# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class RNSAP_CommonDataTypes:

    _name_  = u'RNSAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 1, 1, 3]
    
    _obj_ = [
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProcedureID',
        u'ProtocolIE-ID',
        u'TransactionID',
        u'TriggeringMessage',
        ]
    _type_ = [
        u'Criticality',
        u'Presence',
        u'PrivateIE-ID',
        u'ProcedureCode',
        u'ProcedureID',
        u'ProtocolIE-ID',
        u'TransactionID',
        u'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxPrivateIEs',
        u'maxProtocolExtensions',
        u'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name=u'maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name=u'maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name=u'maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name=u'Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([(u'reject', 0), (u'ignore', 1), (u'notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name=u'Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([(u'optional', 0), (u'conditional', 1), (u'mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name=u'PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name=u'global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        (u'local', _PrivateIE_ID_local),
        (u'global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name=u'ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProcedureID >-----#
    ProcedureID = SEQ(name=u'ProcedureID', mode=MODE_TYPE)
    _ProcedureID_procedureCode = INT(name=u'procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    _ProcedureID_ddMode = ENUM(name=u'ddMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProcedureID_ddMode._cont = ASN1Dict([(u'tdd', 0), (u'fdd', 1), (u'common', 2)])
    _ProcedureID_ddMode._ext = []
    ProcedureID._cont = ASN1Dict([
        (u'procedureCode', _ProcedureID_procedureCode),
        (u'ddMode', _ProcedureID_ddMode),
        ])
    ProcedureID._ext = None
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name=u'ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TransactionID >-----#
    TransactionID = CHOICE(name=u'TransactionID', mode=MODE_TYPE)
    _TransactionID_shortTransActionId = INT(name=u'shortTransActionId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransactionID_shortTransActionId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _TransactionID_longTransActionId = INT(name=u'longTransActionId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransactionID_longTransActionId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    TransactionID._cont = ASN1Dict([
        (u'shortTransActionId', _TransactionID_shortTransActionId),
        (u'longTransActionId', _TransactionID_longTransActionId),
        ])
    TransactionID._ext = None
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name=u'TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([(u'initiating-message', 0), (u'successful-outcome', 1), (u'unsuccessful-outcome', 2), (u'outcome', 3)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        _ProcedureID_procedureCode,
        _ProcedureID_ddMode,
        ProcedureID,
        ProtocolIE_ID,
        _TransactionID_shortTransActionId,
        _TransactionID_longTransActionId,
        TransactionID,
        TriggeringMessage,
    ]

class RNSAP_Constants:

    _name_  = u'RNSAP-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 1, 1, 4]
    
    _obj_ = [
        u'id-commonTransportChannelResourcesInitialisation',
        u'id-commonTransportChannelResourcesRelease',
        u'id-compressedModeCommand',
        u'id-downlinkPowerControl',
        u'id-downlinkPowerTimeslotControl',
        u'id-downlinkSignallingTransfer',
        u'id-errorIndication',
        u'id-dedicatedMeasurementFailure',
        u'id-dedicatedMeasurementInitiation',
        u'id-dedicatedMeasurementReporting',
        u'id-dedicatedMeasurementTermination',
        u'id-paging',
        u'id-physicalChannelReconfiguration',
        u'id-privateMessage',
        u'id-radioLinkAddition',
        u'id-radioLinkCongestion',
        u'id-radioLinkDeletion',
        u'id-radioLinkFailure',
        u'id-radioLinkPreemption',
        u'id-radioLinkRestoration',
        u'id-radioLinkSetup',
        u'id-relocationCommit',
        u'id-synchronisedRadioLinkReconfigurationCancellation',
        u'id-synchronisedRadioLinkReconfigurationCommit',
        u'id-synchronisedRadioLinkReconfigurationPreparation',
        u'id-unSynchronisedRadioLinkReconfiguration',
        u'id-uplinkSignallingTransfer',
        u'id-commonMeasurementFailure',
        u'id-commonMeasurementInitiation',
        u'id-commonMeasurementReporting',
        u'id-commonMeasurementTermination',
        u'id-informationExchangeFailure',
        u'id-informationExchangeInitiation',
        u'id-informationReporting',
        u'id-informationExchangeTermination',
        u'id-reset',
        u'id-radioLinkActivation',
        u'id-gERANuplinkSignallingTransfer',
        u'id-radioLinkParameterUpdate',
        u'id-uEMeasurementFailure',
        u'id-uEMeasurementInitiation',
        u'id-uEMeasurementReporting',
        u'id-uEMeasurementTermination',
        u'id-iurDeactivateTrace',
        u'id-iurInvokeTrace',
        u'id-mBMSAttach',
        u'id-mBMSDetach',
        u'id-directInformationTransfer',
        u'id-enhancedRelocation',
        u'id-enhancedRelocationCancel',
        u'id-enhancedRelocationSignallingTransfer',
        u'id-enhancedRelocationRelease',
        u'id-mBSFNMCCHInformation',
        u'id-secondaryULFrequencyReporting',
        u'id-secondaryULFrequencyUpdate',
        u'id-informationTransferControl',
        u'id-enhancedRelocationResourceAllocation',
        u'id-enhancedRelocationResourceRelease',
        u'maxCellSIB11OrSIB12',
        u'maxCellSIB11ter-ext',
        u'maxCellSIB11ter-1',
        u'maxCellsMeas',
        u'maxRateMatching',
        u'maxNoOfDSCHs',
        u'maxNoOfDSCHsLCR',
        u'maxNoOfRB',
        u'maxNoOfUSCHs',
        u'maxNoOfUSCHsLCR',
        u'maxNrOfTFCs',
        u'maxNrOfTFs',
        u'maxNrOfCCTrCHs',
        u'maxNrOfCCTrCHsLCR',
        u'maxNrOfDCHs',
        u'maxNrOfDL-Codes',
        u'maxNrOfDPCHs',
        u'maxNrOfDPCHsPerRL-1',
        u'maxNrOfDPCHsLCR',
        u'maxNrOfDPCHsLCRPerRL-1',
        u'maxNrOfDPCHs768',
        u'maxNrOfDPCHs768PerRL-1',
        u'maxNrOfErrors',
        u'maxNrOfMACcshSDU-Length',
        u'maxNrOfMBMSServices',
        u'maxNrOfActiveMBMSServices',
        u'maxNrOfPoints',
        u'maxNrOfRLs',
        u'maxNrOfRLSets',
        u'maxNrOfRLSets-1',
        u'maxNrOfRLs-1',
        u'maxNrOfRLs-2',
        u'maxNrOfUEs',
        u'maxNrOfULTs',
        u'maxNrOfULTsLCR',
        u'maxNrOfDLTs',
        u'maxNrOfDLTsLCR',
        u'maxRNCinURA-1',
        u'maxTTI-Count',
        u'maxCTFC',
        u'maxNrOfNeighbouringRNCs',
        u'maxNrOfFDDNeighboursPerRNC',
        u'maxNrOfGSMNeighboursPerRNC',
        u'maxNrOfTDDNeighboursPerRNC',
        u'maxNrOfFACHs',
        u'maxNrOfLCRTDDNeighboursPerRNC',
        u'maxIBSEG',
        u'maxNrOfSCCPCHs',
        u'maxNrOfSCCPCHs768',
        u'maxTGPS',
        u'maxNrOfTS',
        u'maxNrOfLevels',
        u'maxNrOfTsLCR',
        u'maxNoSat',
        u'maxNoGPSTypes',
        u'maxNrOfMeasNCell',
        u'maxNrOfMeasNCell-1',
        u'maxResetContext',
        u'maxResetContextGroup',
        u'maxNrOfHARQProc',
        u'maxNrOfHSSCCHCodes',
        u'maxNrOfHSSICHs',
        u'maxNrOfHSSICHs-1',
        u'maxNrOfMACdFlows',
        u'maxNrOfMACdFlows-1',
        u'maxNrOfMACdPDUSize',
        u'maxNrOfPDUIndexes',
        u'maxNrOfPDUIndexes-1',
        u'maxNrOfPrioQueues',
        u'maxNrOfPrioQueues-1',
        u'maxNrOfSNAs',
        u'maxNrOfSatAlmanac-maxNoSat',
        u'maxNrOfGERANSI',
        u'maxNrOfInterfaces',
        u'maxNrofSigSeqERGHICH-1',
        u'maxNrOfCells',
        u'maxNrOfAddFreq',
        u'maxNrOfCellsPerFreq',
        u'maxNrOfEDCHMACdFlows-1',
        u'maxNrOfEDCH-HARQ-PO-QUANTSTEPs',
        u'maxNrOfEDPCCH-PO-QUANTSTEPs',
        u'maxNrOfEDCHHARQProcesses2msEDCH',
        u'maxNrOfBits-MACe-PDU-non-scheduled',
        u'maxNrOfRefETFCIs',
        u'maxNrOfRefETFCI-PO-QUANTSTEPs',
        u'maxNrOfEDCHMACdFlows',
        u'maxNoOfLogicalChannels',
        u'maxNrOfRefBetas',
        u'maxNrOfEAGCHCodes',
        u'maxNrOfHS-DSCHTBSs',
        u'maxNrOfHS-DSCHTBSs-HS-SCCHless',
        u'maxHS-PDSCHCodeNrComp-1',
        u'maxNrOfEHICHCodes',
        u'maxGANSSSat',
        u'maxNoGANSS',
        u'maxSgnType',
        u'maxNrOfBroadcastPLMNs',
        u'maxHSDPAFrequency',
        u'maxHSDPAFrequency-1',
        u'maxFrequencyinCell',
        u'maxFrequencyinCell-1',
        u'maxGANSSSatAlmanac',
        u'maxGANSSClockMod',
        u'maxNrOfEDCHRLs',
        u'maxEARFCN',
        u'maxEARFCN-Extended',
        u'maxNrOfEUTRANeighboursPerRNC',
        u'maxNrOfMCCHMessages',
        u'maxNrOfMBMSL3',
        u'maxNrOfEDCHMACdFlowsLCR',
        u'maxNrOfEDCHMACdFlowsLCR-1',
        u'maxNrOfPreconfiguredNeighbours',
        u'maxNrOfHSDSCH-1',
        u'maxNrOfHSDSCH',
        u'maxGANSS-1',
        u'maxlengthMBMSconcatservlists',
        u'maxNoOfTBSs-Mapping-HS-DSCH-SPS',
        u'maxNoOfTBSs-Mapping-HS-DSCH-SPS-1',
        u'maxNoOfHS-DSCH-TBSsLCR',
        u'maxNoOfRepetition-Period-LCR',
        u'maxNoOfRepetitionPeriod-SPS-LCR-1',
        u'maxNoOf-HS-SICH-SPS',
        u'maxNoOf-HS-SICH-SPS-1',
        u'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH',
        u'maxNrOfEDCH-1',
        u'maxNrOfDCHMeasurementOccasionPatternSequence',
        u'maxNrOfULCarriersLCR-1',
        u'maxNrOfCellIds',
        u'maxNrOfRAIs',
        u'maxNrOfLAIs',
        u'maxNrOfExtendedNeighbouringRNCs',
        u'maxNoOfGsmCell',
        u'maxNrOfANRCells',
        u'maxFreqBandsTDD',
        u'maxSCPICHCell',
        u'maxSCPICHCell-1',
        u'maxNoOfCommonRGCells',
        u'maxIGPInfo',
        u'maxNrofConcatenatedDCH',
        u'maxMultipleFrequencyBands',
        u'maxMultipleFrequencyBandsEUTRA',
        u'id-AllowedQueuingTime',
        u'id-Allowed-Rate-Information',
        u'id-AntennaColocationIndicator',
        u'id-BindingID',
        u'id-C-ID',
        u'id-C-RNTI',
        u'id-Cell-Capacity-Class-Value',
        u'id-CFN',
        u'id-CN-CS-DomainIdentifier',
        u'id-CN-PS-DomainIdentifier',
        u'id-Cause',
        u'id-CoverageIndicator',
        u'id-CriticalityDiagnostics',
        u'id-ContextInfoItem-Reset',
        u'id-ContextGroupInfoItem-Reset',
        u'id-D-RNTI',
        u'id-D-RNTI-ReleaseIndication',
        u'id-DCHs-to-Add-FDD',
        u'id-DCHs-to-Add-TDD',
        u'id-DCH-DeleteList-RL-ReconfPrepFDD',
        u'id-DCH-DeleteList-RL-ReconfPrepTDD',
        u'id-DCH-DeleteList-RL-ReconfRqstFDD',
        u'id-DCH-DeleteList-RL-ReconfRqstTDD',
        u'id-DCH-FDD-Information',
        u'id-DCH-TDD-Information',
        u'id-FDD-DCHs-to-Modify',
        u'id-TDD-DCHs-to-Modify',
        u'id-DCH-InformationResponse',
        u'id-DCH-Rate-InformationItem-RL-CongestInd',
        u'id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD',
        u'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD',
        u'id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD',
        u'id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'id-DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'id-FDD-DL-CodeInformation',
        u'id-DL-DPCH-Information-RL-ReconfPrepFDD',
        u'id-DL-DPCH-Information-RL-SetupRqstFDD',
        u'id-DL-DPCH-Information-RL-ReconfRqstFDD',
        u'id-DL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'id-DL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'id-DL-DPCH-InformationItem-RL-SetupRspTDD',
        u'id-DL-DPCH-TimingAdjustment',
        u'id-DLReferencePower',
        u'id-DLReferencePowerList-DL-PC-Rqst',
        u'id-DL-ReferencePowerInformation-DL-PC-Rqst',
        u'id-DPC-Mode',
        u'id-DRXCycleLengthCoefficient',
        u'id-DedicatedMeasurementObjectType-DM-Fail-Ind',
        u'id-DedicatedMeasurementObjectType-DM-Fail',
        u'id-DedicatedMeasurementObjectType-DM-Rprt',
        u'id-DedicatedMeasurementObjectType-DM-Rqst',
        u'id-DedicatedMeasurementObjectType-DM-Rsp',
        u'id-DedicatedMeasurementType',
        u'id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD',
        u'id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD',
        u'id-Guaranteed-Rate-Information',
        u'id-IMSI',
        u'id-HCS-Prio',
        u'id-L3-Information',
        u'id-AdjustmentPeriod',
        u'id-MaxAdjustmentStep',
        u'id-MeasurementFilterCoefficient',
        u'id-MessageStructure',
        u'id-MeasurementID',
        u'id-Neighbouring-GSM-CellInformation',
        u'id-Neighbouring-UMTS-CellInformationItem',
        u'id-NRT-Load-Information-Value',
        u'id-NRT-Load-Information-Value-IncrDecrThres',
        u'id-PagingArea-PagingRqst',
        u'id-FACH-FlowControlInformation',
        u'id-PartialReportingIndicator',
        u'id-Permanent-NAS-UE-Identity',
        u'id-PowerAdjustmentType',
        u'id-RANAP-RelocationInformation',
        u'id-RL-Information-PhyChReconfRqstFDD',
        u'id-RL-Information-PhyChReconfRqstTDD',
        u'id-RL-Information-RL-AdditionRqstFDD',
        u'id-RL-Information-RL-AdditionRqstTDD',
        u'id-RL-Information-RL-DeletionRqst',
        u'id-RL-Information-RL-FailureInd',
        u'id-RL-Information-RL-ReconfPrepFDD',
        u'id-RL-Information-RL-RestoreInd',
        u'id-RL-Information-RL-SetupRqstFDD',
        u'id-RL-Information-RL-SetupRqstTDD',
        u'id-RL-InformationItem-RL-CongestInd',
        u'id-RL-InformationItem-DM-Rprt',
        u'id-RL-InformationItem-DM-Rqst',
        u'id-RL-InformationItem-DM-Rsp',
        u'id-RL-InformationItem-RL-PreemptRequiredInd',
        u'id-RL-InformationItem-RL-SetupRqstFDD',
        u'id-RL-InformationList-RL-CongestInd',
        u'id-RL-InformationList-RL-AdditionRqstFDD',
        u'id-RL-InformationList-RL-DeletionRqst',
        u'id-RL-InformationList-RL-PreemptRequiredInd',
        u'id-RL-InformationList-RL-ReconfPrepFDD',
        u'id-RL-InformationResponse-RL-AdditionRspTDD',
        u'id-RL-InformationResponse-RL-ReconfReadyTDD',
        u'id-RL-InformationResponse-RL-SetupRspTDD',
        u'id-RL-InformationResponseItem-RL-AdditionRspFDD',
        u'id-RL-InformationResponseItem-RL-ReconfReadyFDD',
        u'id-RL-InformationResponseItem-RL-ReconfRspFDD',
        u'id-RL-InformationResponseItem-RL-SetupRspFDD',
        u'id-RL-InformationResponseList-RL-AdditionRspFDD',
        u'id-RL-InformationResponseList-RL-ReconfReadyFDD',
        u'id-RL-InformationResponseList-RL-ReconfRspFDD',
        u'id-RL-InformationResponse-RL-ReconfRspTDD',
        u'id-RL-InformationResponseList-RL-SetupRspFDD',
        u'id-RL-ReconfigurationFailure-RL-ReconfFail',
        u'id-RL-Set-InformationItem-DM-Rprt',
        u'id-RL-Set-InformationItem-DM-Rqst',
        u'id-RL-Set-InformationItem-DM-Rsp',
        u'id-RL-Set-Information-RL-FailureInd',
        u'id-RL-Set-Information-RL-RestoreInd',
        u'id-RL-Set-Successful-InformationItem-DM-Fail',
        u'id-RL-Set-Unsuccessful-InformationItem-DM-Fail',
        u'id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'id-RL-Successful-InformationItem-DM-Fail',
        u'id-RL-Unsuccessful-InformationItem-DM-Fail',
        u'id-RL-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'id-ReportCharacteristics',
        u'id-Reporting-Object-RL-FailureInd',
        u'id-Reporing-Object-RL-RestoreInd',
        u'id-RT-Load-Value',
        u'id-RT-Load-Value-IncrDecrThres',
        u'id-S-RNTI',
        u'id-ResetIndicator',
        u'id-RNC-ID',
        u'id-SAI',
        u'id-SRNC-ID',
        u'id-SuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'id-SuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'id-TransportBearerID',
        u'id-TransportBearerRequestIndicator',
        u'id-TransportLayerAddress',
        u'id-TypeOfError',
        u'id-UC-ID',
        u'id-UL-CCTrCH-AddInformation-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'id-UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'id-UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD',
        u'id-UL-CCTrCH-InformationListIE-RL-ReconfReadyTDD',
        u'id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD',
        u'id-UL-DPCH-Information-RL-ReconfPrepFDD',
        u'id-UL-DPCH-Information-RL-ReconfRqstFDD',
        u'id-UL-DPCH-Information-RL-SetupRqstFDD',
        u'id-UL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'id-UL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'id-UL-DPCH-InformationItem-RL-SetupRspTDD',
        u'id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-UL-SIRTarget',
        u'id-URA-Information',
        u'id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'id-UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'id-UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD',
        u'id-Active-Pattern-Sequence-Information',
        u'id-AdjustmentRatio',
        u'id-CauseLevel-RL-AdditionFailureFDD',
        u'id-CauseLevel-RL-AdditionFailureTDD',
        u'id-CauseLevel-RL-ReconfFailure',
        u'id-CauseLevel-RL-SetupFailureFDD',
        u'id-CauseLevel-RL-SetupFailureTDD',
        u'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'id-DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'id-DSCHs-to-Add-TDD',
        u'id-Unused-ProtocolIE-ID-216',
        u'id-DSCH-DeleteList-RL-ReconfPrepTDD',
        u'id-Unused-ProtocolIE-ID-218',
        u'id-Unused-ProtocolIE-ID-219',
        u'id-DSCH-InformationListIE-RL-AdditionRspTDD',
        u'id-DSCH-InformationListIEs-RL-SetupRspTDD',
        u'id-DSCH-TDD-Information',
        u'id-Unused-ProtocolIE-ID-223',
        u'id-Unused-ProtocolIE-ID-226',
        u'id-DSCH-ModifyList-RL-ReconfPrepTDD',
        u'id-Unused-ProtocolIE-ID-228',
        u'id-Unused-ProtocolIE-ID-324',
        u'id-Unused-ProtocolIE-ID-229',
        u'id-DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'id-Unused-ProtocolIE-ID-29',
        u'id-Unused-ProtocolIE-ID-225',
        u'id-GA-Cell',
        u'id-GA-CellAdditionalShapes',
        u'id-Unused-ProtocolIE-ID-246',
        u'id-Transmission-Gap-Pattern-Sequence-Information',
        u'id-UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'id-UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'id-UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD',
        u'id-USCHs-to-Add',
        u'id-USCH-DeleteList-RL-ReconfPrepTDD',
        u'id-USCH-InformationListIE-RL-AdditionRspTDD',
        u'id-USCH-InformationListIEs-RL-SetupRspTDD',
        u'id-USCH-Information',
        u'id-USCH-ModifyList-RL-ReconfPrepTDD',
        u'id-USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'id-DL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'id-UL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'id-ClosedLoopMode1-SupportIndicator',
        u'id-Unused-ProtocolIE-ID-277',
        u'id-STTD-SupportIndicator',
        u'id-CFNReportingIndicator',
        u'id-CNOriginatedPage-PagingRqst',
        u'id-InnerLoopDLPCStatus',
        u'id-PropagationDelay',
        u'id-RxTimingDeviationForTA',
        u'id-timeSlot-ISCP',
        u'id-CCTrCH-InformationItem-RL-FailureInd',
        u'id-CCTrCH-InformationItem-RL-RestoreInd',
        u'id-CommonMeasurementAccuracy',
        u'id-CommonMeasurementObjectType-CM-Rprt',
        u'id-CommonMeasurementObjectType-CM-Rqst',
        u'id-CommonMeasurementObjectType-CM-Rsp',
        u'id-CommonMeasurementType',
        u'id-CongestionCause',
        u'id-SFN',
        u'id-SFNReportingIndicator',
        u'id-InformationExchangeID',
        u'id-InformationExchangeObjectType-InfEx-Rprt',
        u'id-InformationExchangeObjectType-InfEx-Rqst',
        u'id-InformationExchangeObjectType-InfEx-Rsp',
        u'id-InformationReportCharacteristics',
        u'id-InformationType',
        u'id-neighbouring-LCR-TDD-CellInformation',
        u'id-DL-Timeslot-ISCP-LCR-Information-RL-SetupRqstTDD',
        u'id-RL-LCR-InformationResponse-RL-SetupRspTDD',
        u'id-UL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD',
        u'id-UL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'id-DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD',
        u'id-DL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'id-DSCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'id-USCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'id-DL-Timeslot-ISCP-LCR-Information-RL-AdditionRqstTDD',
        u'id-RL-LCR-InformationResponse-RL-AdditionRspTDD',
        u'id-UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'id-UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'id-DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'id-DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'id-DSCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'id-USCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-UL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'id-DL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-DL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'id-UL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD',
        u'id-DL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD',
        u'id-timeSlot-ISCP-LCR-List-DL-PC-Rqst-TDD',
        u'id-TSTD-Support-Indicator-RL-SetupRqstTDD',
        u'id-RestrictionStateIndicator',
        u'id-Load-Value',
        u'id-Load-Value-IncrDecrThres',
        u'id-OnModification',
        u'id-Received-Total-Wideband-Power-Value',
        u'id-Received-Total-Wideband-Power-Value-IncrDecrThres',
        u'id-SFNSFNMeasurementThresholdInformation',
        u'id-Transmitted-Carrier-Power-Value',
        u'id-Transmitted-Carrier-Power-Value-IncrDecrThres',
        u'id-TUTRANGPSMeasurementThresholdInformation',
        u'id-UL-Timeslot-ISCP-Value',
        u'id-UL-Timeslot-ISCP-Value-IncrDecrThres',
        u'id-Rx-Timing-Deviation-Value-LCR',
        u'id-DPC-Mode-Change-SupportIndicator',
        u'id-Unused-ProtocolIE-ID-247',
        u'id-Unused-ProtocolIE-ID-295',
        u'id-PrimaryCCPCH-RSCP-RL-ReconfPrepTDD',
        u'id-DL-TimeSlot-ISCP-Info-RL-ReconfPrepTDD',
        u'id-DL-Timeslot-ISCP-LCR-Information-RL-ReconfPrepTDD',
        u'id-DSCH-RNTI',
        u'id-DL-PowerBalancing-Information',
        u'id-DL-PowerBalancing-ActivationIndicator',
        u'id-DL-PowerBalancing-UpdatedIndicator',
        u'id-DL-ReferencePowerInformation',
        u'id-Enhanced-PrimaryCPICH-EcNo',
        u'id-IPDL-TDD-ParametersLCR',
        u'id-CellCapabilityContainer-FDD',
        u'id-CellCapabilityContainer-TDD',
        u'id-CellCapabilityContainer-TDD-LCR',
        u'id-RL-Specific-DCH-Info',
        u'id-RL-ReconfigurationRequestFDD-RL-InformationList',
        u'id-RL-ReconfigurationRequestFDD-RL-Information-IEs',
        u'id-RL-ReconfigurationRequestTDD-RL-Information',
        u'id-CommonTransportChannelResourcesInitialisationNotRequired',
        u'id-DelayedActivation',
        u'id-DelayedActivationList-RL-ActivationCmdFDD',
        u'id-DelayedActivationInformation-RL-ActivationCmdFDD',
        u'id-DelayedActivationList-RL-ActivationCmdTDD',
        u'id-DelayedActivationInformation-RL-ActivationCmdTDD',
        u'id-neighbouringTDDCellMeasurementInformationLCR',
        u'id-UL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD',
        u'id-UL-SIR-Target-CCTrCH-LCR-InformationItem-RL-SetupRspTDD',
        u'id-PrimCCPCH-RSCP-DL-PC-RqstTDD',
        u'id-HSDSCH-FDD-Information',
        u'id-HSDSCH-FDD-Information-Response',
        u'id-HSDSCH-FDD-Update-Information',
        u'id-HSDSCH-Information-to-Modify',
        u'id-HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'id-HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'id-HSDSCH-RNTI',
        u'id-HSDSCH-TDD-Information',
        u'id-HSDSCH-TDD-Information-Response',
        u'id-HSDSCH-TDD-Update-Information',
        u'id-HSPDSCH-RL-ID',
        u'id-HSDSCH-MACdFlows-to-Add',
        u'id-HSDSCH-MACdFlows-to-Delete',
        u'id-Angle-Of-Arrival-Value-LCR',
        u'id-TrafficClass',
        u'id-Unused-ProtocolIE-ID-248',
        u'id-Unused-ProtocolIE-ID-253',
        u'id-PDSCH-RL-ID',
        u'id-TimeSlot-RL-SetupRspTDD',
        u'id-GERAN-Cell-Capability',
        u'id-GERAN-Classmark',
        u'id-DSCH-InitialWindowSize',
        u'id-UL-Synchronisation-Parameters-LCR',
        u'id-SNA-Information',
        u'id-MAChs-ResetIndicator',
        u'id-TDD-DL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD',
        u'id-TDD-UL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD',
        u'id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD',
        u'id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'id-UL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'id-DL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD',
        u'id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD',
        u'id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD',
        u'id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD',
        u'id-UL-TimingAdvanceCtrl-LCR',
        u'id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'id-HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD',
        u'id-HS-SICH-Reception-Quality',
        u'id-HS-SICH-Reception-Quality-Measurement-Value',
        u'id-HSSICH-Info-DM-Rprt',
        u'id-HSSICH-Info-DM-Rqst',
        u'id-HSSICH-Info-DM',
        u'id-CCTrCH-Maximum-DL-Power-RL-SetupRspTDD',
        u'id-CCTrCH-Minimum-DL-Power-RL-SetupRspTDD',
        u'id-CCTrCH-Maximum-DL-Power-RL-AdditionRspTDD',
        u'id-CCTrCH-Minimum-DL-Power-RL-AdditionRspTDD',
        u'id-CCTrCH-Maximum-DL-Power-RL-ReconfReadyTDD',
        u'id-CCTrCH-Minimum-DL-Power-RL-ReconfReadyTDD',
        u'id-Maximum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'id-Minimum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'id-DL-CCTrCH-InformationList-RL-ReconfRspTDD',
        u'id-DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD',
        u'id-Maximum-DL-Power-TimeslotLCR-InformationItem',
        u'id-Minimum-DL-Power-TimeslotLCR-InformationItem',
        u'id-TDD-Support-8PSK',
        u'id-TDD-maxNrDLPhysicalchannels',
        u'id-ExtendedGSMCellIndividualOffset',
        u'id-RL-ParameterUpdateIndicationFDD-RL-InformationList',
        u'id-Primary-CPICH-Usage-For-Channel-Estimation',
        u'id-Secondary-CPICH-Information',
        u'id-Secondary-CPICH-Information-Change',
        u'id-Unused-ProtocolIE-ID-522',
        u'id-Unused-ProtocolIE-ID-523',
        u'id-RL-ParameterUpdateIndicationFDD-RL-Information-Item',
        u'id-Phase-Reference-Update-Indicator',
        u'id-Unidirectional-DCH-Indicator',
        u'id-RL-Information-RL-ReconfPrepTDD',
        u'id-Multiple-RL-InformationResponse-RL-ReconfReadyTDD',
        u'id-RL-ReconfigurationResponseTDD-RL-Information',
        u'id-Satellite-Almanac-Information-ExtItem',
        u'id-HSDSCH-Information-to-Modify-Unsynchronised',
        u'id-TnlQos',
        u'id-RTLoadValue',
        u'id-NRTLoadInformationValue',
        u'id-CellPortionID',
        u'id-UpPTSInterferenceValue',
        u'id-PrimaryCCPCH-RSCP-Delta',
        u'id-UEMeasurementType',
        u'id-UEMeasurementTimeslotInfoHCR',
        u'id-UEMeasurementTimeslotInfoLCR',
        u'id-UEMeasurementReportCharacteristics',
        u'id-UEMeasurementParameterModAllow',
        u'id-UEMeasurementValueInformation',
        u'id-InterfacesToTraceItem',
        u'id-ListOfInterfacesToTrace',
        u'id-TraceDepth',
        u'id-TraceRecordingSessionReference',
        u'id-TraceReference',
        u'id-UEIdentity',
        u'id-NACC-Related-Data',
        u'id-GSM-Cell-InfEx-Rqst',
        u'id-MeasurementRecoveryBehavior',
        u'id-MeasurementRecoveryReportingIndicator',
        u'id-MeasurementRecoverySupportIndicator',
        u'id-DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        u'id-F-DPCH-Information-RL-ReconfPrepFDD',
        u'id-F-DPCH-Information-RL-SetupRqstFDD',
        u'id-MBMS-Bearer-Service-List',
        u'id-MBMS-Bearer-Service-List-InfEx-Rsp',
        u'id-Active-MBMS-Bearer-ServiceFDD',
        u'id-Active-MBMS-Bearer-ServiceTDD',
        u'id-Old-URA-ID',
        u'id-UE-State',
        u'id-URA-ID',
        u'id-HARQ-Preamble-Mode',
        u'id-SynchronisationIndicator',
        u'id-UL-DPDCHIndicatorEDCH',
        u'id-EDPCH-Information',
        u'id-RL-Specific-EDCH-Information',
        u'id-EDCH-RL-Indication',
        u'id-EDCH-FDD-Information',
        u'id-EDCH-RLSet-Id',
        u'id-Serving-EDCHRL-Id',
        u'id-EDCH-FDD-DL-ControlChannelInformation',
        u'id-EDCH-FDD-InformationResponse',
        u'id-EDCH-MACdFlows-To-Add',
        u'id-EDCH-FDD-Information-To-Modify',
        u'id-EDCH-MACdFlows-To-Delete',
        u'id-EDPCH-Information-RLReconfRequest-FDD',
        u'id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd',
        u'id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd',
        u'id-MBMS-Bearer-Service-Full-Address',
        u'id-Initial-DL-DPCH-TimingAdjustment',
        u'id-Initial-DL-DPCH-TimingAdjustment-Allowed',
        u'id-User-Plane-Congestion-Fields-Inclusion',
        u'id-HARQ-Preamble-Mode-Activation-Indicator',
        u'id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        u'id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        u'id-ProvidedInformation',
        u'id-Active-MBMS-Bearer-ServiceFDD-PFL',
        u'id-Active-MBMS-Bearer-ServiceTDD-PFL',
        u'id-FrequencyBandIndicator',
        u'id-Serving-cell-change-CFN',
        u'id-HS-DSCH-serving-cell-change-information',
        u'id-HS-DSCH-serving-cell-change-informationResponse',
        u'id-E-DCH-Serving-cell-change-informationResponse',
        u'id-secondary-LCR-CCPCH-Info-TDD',
        u'id-E-DCH-FDD-Update-Information',
        u'id-Inter-Frequency-Cell-List',
        u'id-Inter-Frequency-Cell-Information',
        u'id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        u'id-TDD-Support-PLCCH',
        u'id-PLCCH-Information-UL-TimeslotLCR-Info',
        u'id-PLCCH-Information-PhyChReconfRqstTDD',
        u'id-TDD768-maxNrDLPhysicalchannelsTS',
        u'id-RL-InformationResponse-RL-AdditionRspTDD768',
        u'id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD768',
        u'id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD768',
        u'id-UL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'id-DL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768',
        u'id-UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768',
        u'id-DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'id-secondary-CCPCH-Info-RL-ReconfReadyTDD768',
        u'id-hSSCCH-TDD-Specific-InfoList-Response768',
        u'id-hSPDSCH-TDD-Specific-InfoList-Response768',
        u'id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'id-UL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'id-DL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'id-CellCapabilityContainer-TDD768',
        u'id-multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp',
        u'id-neighbouringTDDCellMeasurementInformation768',
        u'id-UEMeasurementTimeslotInfo768',
        u'id-Rx-Timing-Deviation-Value-768',
        u'id-UEMeasurementValueTransmittedPowerList768',
        u'id-UEMeasurementValueTimeslotISCPList768',
        u'id-RL-InformationResponse-RL-SetupRspTDD768',
        u'id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD768',
        u'id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD768',
        u'id-UL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'id-DL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'id-TDD768-minimumSpreadingFactor-UL',
        u'id-TDD768-minimumSpreadingFactor-DL',
        u'id-TDD768-maxNrDLPhysicalchannels',
        u'id-DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD',
        u'id-DPCH-ID768-DM-Rsp',
        u'id-DPCH-ID768-DM-Rqst',
        u'id-DPCH-ID768-DM-Rprt',
        u'id-EDPCH-Information-RLAdditionReq-FDD',
        u'id-HSDSCH-Configured-Indicator',
        u'id-RxTimingDeviationForTAext',
        u'id-RxTimingDeviationForTA768',
        u'id-Rx-Timing-Deviation-Value-ext',
        u'id-E-DCH-PowerOffset-for-SchedulingInfo',
        u'id-TrCH-SrcStatisticsDescr',
        u'id-E-DCH-Information',
        u'id-E-DCH-Serving-RL-ID',
        u'id-E-DCH-Information-Reconfig',
        u'id-E-DCH-Information-Response',
        u'id-E-DCH-768-Information',
        u'id-E-DCH-768-Information-Reconfig',
        u'id-E-DCH-768-Information-Response',
        u'id-ExtendedPropagationDelay',
        u'id-Extended-Round-Trip-Time-Value',
        u'id-AlternativeFormatReportingIndicator',
        u'id-DCH-Indicator-For-E-DCH-HSDPA-Operation',
        u'id-E-RGCH-E-HICH-ChannelisationCodeValidityIndicator',
        u'id-E-DCH-Minimum-Set-E-TFCIValidityIndicator',
        u'id-Fast-Reconfiguration-Mode',
        u'id-Fast-Reconfiguration-Permission',
        u'id-Continuous-Packet-Connectivity-DTX-DRX-Information',
        u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information',
        u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response',
        u'id-CPC-Information',
        u'id-MIMO-InformationResponse',
        u'id-E-DCH-LCR-Information',
        u'id-E-DCH-LCR-Information-Reconfig',
        u'id-E-DCH-LCR-Information-Response',
        u'id-HS-PDSCH-Code-Change-Grant',
        u'id-HS-PDSCH-Code-Change-Indicator',
        u'id-Extended-SRNC-ID',
        u'id-Extended-RNC-ID',
        u'id-SixtyfourQAM-DL-SupportIndicator',
        u'id-Enhanced-FACH-Support-Indicator',
        u'id-Enhanced-FACH-Information-ResponseFDD',
        u'id-HSDSCH-MACdPDUSizeFormat',
        u'id-MaximumMACdPDU-SizeExtended',
        u'id-F-DPCH-SlotFormat',
        u'id-F-DPCH-SlotFormatSupportRequest',
        u'id-eDCH-MACdFlow-Retransmission-Timer-LCR',
        u'id-Max-UE-DTX-Cycle',
        u'id-GANSS-Common-Data',
        u'id-GANSS-Information',
        u'id-GANSS-Generic-Data',
        u'id-TUTRANGANSSMeasurementThresholdInformation',
        u'id-TUTRANGANSSMeasurementValueInformation',
        u'id-Ext-Reference-E-TFCI-PO',
        u'id-Ext-Max-Bits-MACe-PDU-non-scheduled',
        u'id-HARQ-MemoryPartitioningInfoExtForMIMO',
        u'id-MIMO-ActivationIndicator',
        u'id-MIMO-Mode-Indicator',
        u'id-MIMO-N-M-Ratio',
        u'id-TransportBearerNotSetupIndicator',
        u'id-TransportBearerNotRequestedIndicator',
        u'id-PowerControlGAP',
        u'id-UARFCNforNt',
        u'id-LCRTDD-uplink-Physical-Channel-Capability',
        u'id-number-Of-Supported-Carriers',
        u'id-HSSICH-SIRTarget',
        u'id-HSSICH-TPC-StepSize',
        u'id-tSN-Length',
        u'id-HS-SICH-ID-Extension',
        u'id-HSSICH-Info-DM-Rqst-Extension',
        u'id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        u'id-multicarrier-number',
        u'id-UPPCHPositionLCR',
        u'id-UpPCH-InformationList-LCRTDD',
        u'id-UpPCH-InformationItem-LCRTDD',
        u'id-Multiple-PLMN-List',
        u'id-UE-Capabilities-Info',
        u'id-FrameOffset',
        u'id-ChipOffset',
        u'id-Enhanced-PCH-Capability',
        u'id-SixteenQAM-UL-Operation-Indicator',
        u'id-E-TFCI-Boost-Information',
        u'id-SixtyfourQAM-UsageAllowedIndicator',
        u'id-SixtyfourQAM-DL-UsageIndicator',
        u'id-Default-Serving-Grant-in-DTX-Cycle2',
        u'id-E-DPDCH-PowerInterpolation',
        u'id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'id-E-DCH-MACdPDUSizeFormat',
        u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Deactivate-Indicator',
        u'id-E-DCH-DL-Control-Channel-Change-Information',
        u'id-E-DCH-DL-Control-Channel-Grant-Information',
        u'id-MaximumNumber-Of-Retransmission-For-SchedulingInfo-LCRTDD',
        u'id-E-DCH-RetransmissionTimer-For-SchedulingInfo-LCRTDD',
        u'id-E-PUCH-PowerControlGAP',
        u'id-HSDSCH-TBSizeTableIndicator',
        u'id-UE-with-enhanced-HS-SCCH-support-indicator',
        u'id-DGANSS-Corrections-Req',
        u'id-E-AGCH-Table-Choice',
        u'id-RANAP-EnhancedRelocationInformationRequest',
        u'id-RANAP-EnhancedRelocationInformationResponse',
        u'id-Common-EDCH-MAC-d-Flow-Specific-InformationFDD',
        u'id-Common-EDCH-Support-Indicator',
        u'id-E-RNTI',
        u'id-Released-CN-Domain',
        u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst',
        u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp',
        u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt',
        u'id-MBMS-Cell-InfEx-Rqst',
        u'id-MBMS-Cell-InfEx-Rsp',
        u'id-MBMS-Cell-InfEx-Rprt',
        u'id-Counting-Information',
        u'id-Transmission-Mode-Information',
        u'id-MBMS-Neighbouring-Cell-Information',
        u'id-MBMS-RLC-Sequence-Number-Information',
        u'id-RLC-Sequence-Number',
        u'id-Neighbouring-E-UTRA-CellInformation',
        u'id-MBSFN-Cluster-Identity',
        u'id-MCCH-Configuration-Info',
        u'id-MCCH-Message-List',
        u'id-MBSFN-Scheduling-Transmission-Time-Interval-Info-List',
        u'id-GANSS-Time-ID',
        u'id-GANSS-AddIonoModelReq',
        u'id-GANSS-EarthOrientParaReq',
        u'id-GANSS-AddNavigationModelsReq',
        u'id-GANSS-AddUTCModelsReq',
        u'id-GANSS-AuxInfoReq',
        u'id-GANSS-SBAS-ID',
        u'id-GANSS-ID',
        u'id-GANSS-Additional-Ionospheric-Model',
        u'id-GANSS-Earth-Orientation-Parameters',
        u'id-GANSS-Additional-Time-Models',
        u'id-GANSS-Additional-Navigation-Models',
        u'id-GANSS-Additional-UTC-Models',
        u'id-GANSS-Auxiliary-Information',
        u'id-MinimumReducedE-DPDCH-GainFactor',
        u'id-Enhanced-FACH-Information-ResponseLCR',
        u'id-Common-EDCH-MAC-d-Flow-Specific-InformationLCR',
        u'id-HSDSCH-PreconfigurationSetup',
        u'id-HSDSCH-PreconfigurationInfo',
        u'id-NoOfTargetCellHS-SCCH-Order',
        u'id-EnhancedHSServingCC-Abort',
        u'id-Additional-HS-Cell-Information-RL-Setup',
        u'id-Additional-HS-Cell-Information-Response',
        u'id-Additional-HS-Cell-Information-RL-Addition',
        u'id-Additional-HS-Cell-Change-Information-Response',
        u'id-Additional-HS-Cell-Information-RL-Reconf-Prep',
        u'id-Additional-HS-Cell-Information-RL-Reconf-Req',
        u'id-Additional-HS-Cell-RL-Reconf-Response',
        u'id-Additional-HS-Cell-Information-RL-Param-Upd',
        u'id-Secondary-Serving-Cell-List',
        u'id-MultiCarrier-HSDSCH-Physical-Layer-Category',
        u'id-IdleIntervalInformation',
        u'id-NeedforIdleInterval',
        u'id-IdleIntervalConfigurationIndicator',
        u'id-ContinuousPacketConnectivity-DRX-InformationLCR',
        u'id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        u'id-E-AGCH-UE-Inactivity-Monitor-Threshold',
        u'id-CPC-InformationLCR',
        u'id-E-DCH-Semi-PersistentScheduling-Information-LCR',
        u'id-HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        u'id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'id-MIMO-SFMode-For-HSPDSCHDualStream',
        u'id-MIMO-SFMode-Supported-For-HSPDSCHDualStream',
        u'id-MIMO-ReferenceSignal-InformationListLCR',
        u'id-GANSS-alm-keplerianNAVAlmanac',
        u'id-GANSS-alm-keplerianReducedAlmanac',
        u'id-GANSS-alm-keplerianMidiAlmanac',
        u'id-GANSS-alm-keplerianGLONASS',
        u'id-GANSS-alm-ecefSBASAlmanac',
        u'id-DL-RLC-PDU-Size-Format',
        u'id-MACes-Maximum-Bitrate-LCR',
        u'id-Single-Stream-MIMO-ActivationIndicator',
        u'id-Single-Stream-MIMO-Mode-Indicator',
        u'id-Dual-Band-Secondary-Serving-Cell-List',
        u'id-UE-AggregateMaximumBitRate',
        u'id-power-offset-for-S-CPICH-for-MIMO',
        u'id-power-offset-for-S-CPICH-for-MIMO-Request-Indicator',
        u'id-UE-SupportIndicatorExtension',
        u'id-ActivationInformation',
        u'id-CellPortionLCRID',
        u'id-Additional-EDCH-Cell-Information-RL-Setup-Req',
        u'id-Additional-EDCH-Cell-Information-Response',
        u'id-Additional-EDCH-Cell-Information-RL-Add-Req',
        u'id-Additional-EDCH-Cell-Information-Response-RLAdd',
        u'id-Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        u'id-Additional-EDCH-Cell-Information-RL-Reconf-Req',
        u'id-Additional-EDCH-Cell-Information-RL-Param-Upd',
        u'id-Additional-EDCH-Preconfiguration-Information',
        u'id-MulticellEDCH-Information',
        u'id-Additional-EDCH-Cell-Information-ResponseRLReconf',
        u'id-EDCH-Indicator',
        u'id-DiversityMode',
        u'id-TransmitDiversityIndicator',
        u'id-NonCellSpecificTxDiversity',
        u'id-CellCapabilityContainerExtension-FDD',
        u'id-HSDSCH-Physical-Layer-Category',
        u'id-E-RNTI-For-FACH',
        u'id-H-RNTI-For-FACH',
        u'id-RNTI-Allocation-Indicator',
        u'id-UE-AggregateMaximumBitRate-Enforcement-Indicator',
        u'id-DCH-MeasurementOccasion-Information',
        u'id-DCH-MeasurementType-Indicator',
        u'id-Out-of-Sychronization-Window',
        u'id-MulticellEDCH-RL-SpecificInformation',
        u'id-DGNSS-ValidityPeriod',
        u'id-TS0-HS-PDSCH-Indication-LCR',
        u'id-UE-TS0-CapabilityLCR',
        u'id-Non-Serving-RL-Preconfig-Info',
        u'id-Non-Serving-RL-Preconfig-Setup',
        u'id-Non-Serving-RL-Preconfig-Removal',
        u'id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        u'id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        u'id-CellListValidityIndicator',
        u'id-completeAlmanacProvided',
        u'id-ganss-Delta-T',
        u'id-OrdinalNumberOfFrequency',
        u'id-Multicell-EDCH-Restriction',
        u'id-CellCapabilityContainerExtension-TDD-LCR',
        u'id-Multi-Carrier-EDCH-Setup',
        u'id-Multi-Carrier-EDCH-Reconfigure',
        u'id-Multi-Carrier-EDCH-Response',
        u'id-SNPL-Carrier-Group-Indicator',
        u'id-MU-MIMO-InformationLCR',
        u'id-MU-MIMO-Indicator',
        u'id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        u'id-Usefulness-Of-Battery-Optimization',
        u'id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'id-Measurement-Power-Offset',
        u'id-MDT-Configuration',
        u'id-Neighbouring-UMTS-CellInformation-Ext',
        u'id-Neighbouring-UMTS-CellInformationExtensionItem',
        u'id-Control-Type-InformationTransferControlReq',
        u'id-UMTS-Cells-Info',
        u'id-ANRReportIndication',
        u'id-ANR-Cell-InfEx-Rqst',
        u'id-ANR-Cell-InfEx-Rsp',
        u'id-ANR-Cell-Information',
        u'id-Trace-Collection-Entity-IP-Address',
        u'id-Affected-HSDSCH-Serving-Cell-List',
        u'id-UL-CLTD-Information',
        u'id-UL-CLTD-Information-Reconf',
        u'id-UL-CLTD-State-Update-Information',
        u'id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        u'id-CPC-RecoveryReport',
        u'id-FTPICH-Information',
        u'id-FTPICH-Information-Reconf',
        u'id-UE-RF-Band-CapabilityLCR',
        u'id-Extended-S-RNTI',
        u'id-ExtendedAffectedUEInformationForMBMS',
        u'id-Extended-S-RNTI-Group',
        u'id-FTPICH-Information-Response',
        u'id-FTPICH-Reconfiguration-Information',
        u'id-MIMO-withfourtransmitantennas-ActivationIndicator',
        u'id-MIMO-withfourtransmitantennas-ModeIndicator',
        u'id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas',
        u'id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas-Request-Indicator',
        u'id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        u'id-DualStream-MIMO-withfourtransmitantennas-ModeIndicator',
        u'id-Additional-Associated-Secondary-CPICH',
        u'id-UE-transmission-power-headroom',
        u'id-Multiflow-Information',
        u'id-Multiflow-Reconfiguration',
        u'id-Multiflow-OrdinalNumberOfFrequency',
        u'id-UL-MIMO-Information',
        u'id-UL-MIMO-Reconfiguration',
        u'id-UL-MIMO-DL-Control-Channel-Information',
        u'id-SixtyfourQAM-UL-Operation-Indicator',
        u'id-Common-E-RGCH-Cell-InfEx-Rqst',
        u'id-Common-E-RGCH-Cell-InfEx-Rsp',
        u'id-Common-E-RGCH-Cell-InfEx-Rprt',
        u'id-Common-E-RGCH-Cell-Information',
        u'id-PCI',
        u'id-TAC',
        u'id-PLMN-List',
        u'id-PrecoderWeightSetRestriction',
        u'id-EARFCN-FDD-Extended',
        u'id-EARFCN-TDD-Extended',
        u'id-Non-rectangular-resource-allocation-indicator',
        u'id-Non-rectangular-resource-timeslot-set',
        u'id-UE-Support-of-non-rectangular-resource-allocation',
        u'id-DBDS-CorrectionsReq',
        u'id-DBDS-Corrections',
        u'id-BDS-IonosphericGridModelReq',
        u'id-BDS-Ionospheric-Grid-Model',
        u'id-GANSS-alm-keplerianBDSAlmanac',
        u'id-Assisting-RepetitionFactors',
        u'id-E-DCH-Decoupling-Indication',
        u'id-UE-Measurement-Forwarding',
        u'id-UPH-Filtering-Measurement-Forwarding-Request',
        u'id-TTI-Update-Indicator',
        u'id-CQI-Feedback-Cycle2-k',
        u'id-CQI-Cycle-Switch-Timer',
        u'id-UE-DRX-Cycle2',
        u'id-Inactivity-Threshold-for-UE-DRX-Cycle2',
        u'id-DTX-Information2',
        u'id-DCH-ENH-Information',
        u'id-DCH-ENH-Information-Reconf',
        u'id-Gainfactors-10ms-mode',
        u'id-Radio-Links-without-DPCH-FDPCH-Indication',
        u'id-UL-DPCCH2-Information',
        u'id-UL-DPCCH2-Information-Reconf',
        u'id-ImplicitGrantHandling',
        u'id-MinimumTEBSthreshold',
        u'id-MultipleFrequencyBandsIndicatorList-EUTRA',
        u'id-MultipleFrequencyBandsIndicatorList',
        u'id-ActivationDelay',
        u'id-Fast-TTI-switching-Mode-synchronized',
        u'id-Fast-TTI-switching-Mode-unsynchronized',
        u'id-Fast-TTI-switching-Mode-Supported',
        u'id-GANSS-BDSclockModel',
        u'id-GANSS-NavModel-BDSKeplerianSet',
        u'id-GANSS-UTCmodelSet4',
        u'id-Inter-Frequency-Cell-Information-SIB11ter',
        u'id-Improved-Synchronized-Indicator',
        u'id-Downlink-TPC-enhancements-Information',
        u'id-Downlink-TPC-enhancements-Reconf',
        u'id-TPC-slot-position',
        u'id-DL-TBS',
        u'id-Selected-PLMN-Identity',
        u'id-Dual-Cell-EDCH-Enhancements-Information',
        u'id-SpeechVersion',
        u'id-SourceID',
        u'id-TargetID',
        u'id-ClassmarkInformation2',
        u'id-ClassmarkInformation3',
        u'id-GSM-Cell-CM-Rqst',
        u'id-Extension-CommonMeasurementObjectType-CM-Rprt',
        u'id-Extension-CommonMeasurementObjectType-CM-Rqst',
        u'id-Extension-CommonMeasurementObjectType-CM-Rsp',
        u'id-Extension-FailureIndicationMeasurementList',
        u'id-Extension-FailureMeasurementList',
        u'id-Extension-TerminationMeasurementList',
        u'id-GsmCellList-CM-Rprt',
        u'id-GsmCellList-CM-Rqst',
        u'id-GsmCellList-CM-Rsp',
        u'id-LoadValue',
        u'id-EventH',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-commonTransportChannelResourcesInitialisation',
        u'id-commonTransportChannelResourcesRelease',
        u'id-compressedModeCommand',
        u'id-downlinkPowerControl',
        u'id-downlinkPowerTimeslotControl',
        u'id-downlinkSignallingTransfer',
        u'id-errorIndication',
        u'id-dedicatedMeasurementFailure',
        u'id-dedicatedMeasurementInitiation',
        u'id-dedicatedMeasurementReporting',
        u'id-dedicatedMeasurementTermination',
        u'id-paging',
        u'id-physicalChannelReconfiguration',
        u'id-privateMessage',
        u'id-radioLinkAddition',
        u'id-radioLinkCongestion',
        u'id-radioLinkDeletion',
        u'id-radioLinkFailure',
        u'id-radioLinkPreemption',
        u'id-radioLinkRestoration',
        u'id-radioLinkSetup',
        u'id-relocationCommit',
        u'id-synchronisedRadioLinkReconfigurationCancellation',
        u'id-synchronisedRadioLinkReconfigurationCommit',
        u'id-synchronisedRadioLinkReconfigurationPreparation',
        u'id-unSynchronisedRadioLinkReconfiguration',
        u'id-uplinkSignallingTransfer',
        u'id-commonMeasurementFailure',
        u'id-commonMeasurementInitiation',
        u'id-commonMeasurementReporting',
        u'id-commonMeasurementTermination',
        u'id-informationExchangeFailure',
        u'id-informationExchangeInitiation',
        u'id-informationReporting',
        u'id-informationExchangeTermination',
        u'id-reset',
        u'id-radioLinkActivation',
        u'id-gERANuplinkSignallingTransfer',
        u'id-radioLinkParameterUpdate',
        u'id-uEMeasurementFailure',
        u'id-uEMeasurementInitiation',
        u'id-uEMeasurementReporting',
        u'id-uEMeasurementTermination',
        u'id-iurDeactivateTrace',
        u'id-iurInvokeTrace',
        u'id-mBMSAttach',
        u'id-mBMSDetach',
        u'id-directInformationTransfer',
        u'id-enhancedRelocation',
        u'id-enhancedRelocationCancel',
        u'id-enhancedRelocationSignallingTransfer',
        u'id-enhancedRelocationRelease',
        u'id-mBSFNMCCHInformation',
        u'id-secondaryULFrequencyReporting',
        u'id-secondaryULFrequencyUpdate',
        u'id-informationTransferControl',
        u'id-enhancedRelocationResourceAllocation',
        u'id-enhancedRelocationResourceRelease',
        u'maxCellSIB11OrSIB12',
        u'maxCellSIB11ter-ext',
        u'maxCellSIB11ter-1',
        u'maxCellsMeas',
        u'maxRateMatching',
        u'maxNoOfDSCHs',
        u'maxNoOfDSCHsLCR',
        u'maxNoOfRB',
        u'maxNoOfUSCHs',
        u'maxNoOfUSCHsLCR',
        u'maxNrOfTFCs',
        u'maxNrOfTFs',
        u'maxNrOfCCTrCHs',
        u'maxNrOfCCTrCHsLCR',
        u'maxNrOfDCHs',
        u'maxNrOfDL-Codes',
        u'maxNrOfDPCHs',
        u'maxNrOfDPCHsPerRL-1',
        u'maxNrOfDPCHsLCR',
        u'maxNrOfDPCHsLCRPerRL-1',
        u'maxNrOfDPCHs768',
        u'maxNrOfDPCHs768PerRL-1',
        u'maxNrOfErrors',
        u'maxNrOfMACcshSDU-Length',
        u'maxNrOfMBMSServices',
        u'maxNrOfActiveMBMSServices',
        u'maxNrOfPoints',
        u'maxNrOfRLs',
        u'maxNrOfRLSets',
        u'maxNrOfRLSets-1',
        u'maxNrOfRLs-1',
        u'maxNrOfRLs-2',
        u'maxNrOfUEs',
        u'maxNrOfULTs',
        u'maxNrOfULTsLCR',
        u'maxNrOfDLTs',
        u'maxNrOfDLTsLCR',
        u'maxRNCinURA-1',
        u'maxTTI-Count',
        u'maxCTFC',
        u'maxNrOfNeighbouringRNCs',
        u'maxNrOfFDDNeighboursPerRNC',
        u'maxNrOfGSMNeighboursPerRNC',
        u'maxNrOfTDDNeighboursPerRNC',
        u'maxNrOfFACHs',
        u'maxNrOfLCRTDDNeighboursPerRNC',
        u'maxIBSEG',
        u'maxNrOfSCCPCHs',
        u'maxNrOfSCCPCHs768',
        u'maxTGPS',
        u'maxNrOfTS',
        u'maxNrOfLevels',
        u'maxNrOfTsLCR',
        u'maxNoSat',
        u'maxNoGPSTypes',
        u'maxNrOfMeasNCell',
        u'maxNrOfMeasNCell-1',
        u'maxResetContext',
        u'maxResetContextGroup',
        u'maxNrOfHARQProc',
        u'maxNrOfHSSCCHCodes',
        u'maxNrOfHSSICHs',
        u'maxNrOfHSSICHs-1',
        u'maxNrOfMACdFlows',
        u'maxNrOfMACdFlows-1',
        u'maxNrOfMACdPDUSize',
        u'maxNrOfPDUIndexes',
        u'maxNrOfPDUIndexes-1',
        u'maxNrOfPrioQueues',
        u'maxNrOfPrioQueues-1',
        u'maxNrOfSNAs',
        u'maxNrOfSatAlmanac-maxNoSat',
        u'maxNrOfGERANSI',
        u'maxNrOfInterfaces',
        u'maxNrofSigSeqERGHICH-1',
        u'maxNrOfCells',
        u'maxNrOfAddFreq',
        u'maxNrOfCellsPerFreq',
        u'maxNrOfEDCHMACdFlows-1',
        u'maxNrOfEDCH-HARQ-PO-QUANTSTEPs',
        u'maxNrOfEDPCCH-PO-QUANTSTEPs',
        u'maxNrOfEDCHHARQProcesses2msEDCH',
        u'maxNrOfBits-MACe-PDU-non-scheduled',
        u'maxNrOfRefETFCIs',
        u'maxNrOfRefETFCI-PO-QUANTSTEPs',
        u'maxNrOfEDCHMACdFlows',
        u'maxNoOfLogicalChannels',
        u'maxNrOfRefBetas',
        u'maxNrOfEAGCHCodes',
        u'maxNrOfHS-DSCHTBSs',
        u'maxNrOfHS-DSCHTBSs-HS-SCCHless',
        u'maxHS-PDSCHCodeNrComp-1',
        u'maxNrOfEHICHCodes',
        u'maxGANSSSat',
        u'maxNoGANSS',
        u'maxSgnType',
        u'maxNrOfBroadcastPLMNs',
        u'maxHSDPAFrequency',
        u'maxHSDPAFrequency-1',
        u'maxFrequencyinCell',
        u'maxFrequencyinCell-1',
        u'maxGANSSSatAlmanac',
        u'maxGANSSClockMod',
        u'maxNrOfEDCHRLs',
        u'maxEARFCN',
        u'maxEARFCN-Extended',
        u'maxNrOfEUTRANeighboursPerRNC',
        u'maxNrOfMCCHMessages',
        u'maxNrOfMBMSL3',
        u'maxNrOfEDCHMACdFlowsLCR',
        u'maxNrOfEDCHMACdFlowsLCR-1',
        u'maxNrOfPreconfiguredNeighbours',
        u'maxNrOfHSDSCH-1',
        u'maxNrOfHSDSCH',
        u'maxGANSS-1',
        u'maxlengthMBMSconcatservlists',
        u'maxNoOfTBSs-Mapping-HS-DSCH-SPS',
        u'maxNoOfTBSs-Mapping-HS-DSCH-SPS-1',
        u'maxNoOfHS-DSCH-TBSsLCR',
        u'maxNoOfRepetition-Period-LCR',
        u'maxNoOfRepetitionPeriod-SPS-LCR-1',
        u'maxNoOf-HS-SICH-SPS',
        u'maxNoOf-HS-SICH-SPS-1',
        u'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH',
        u'maxNrOfEDCH-1',
        u'maxNrOfDCHMeasurementOccasionPatternSequence',
        u'maxNrOfULCarriersLCR-1',
        u'maxNrOfCellIds',
        u'maxNrOfRAIs',
        u'maxNrOfLAIs',
        u'maxNrOfExtendedNeighbouringRNCs',
        u'maxNoOfGsmCell',
        u'maxNrOfANRCells',
        u'maxFreqBandsTDD',
        u'maxSCPICHCell',
        u'maxSCPICHCell-1',
        u'maxNoOfCommonRGCells',
        u'maxIGPInfo',
        u'maxNrofConcatenatedDCH',
        u'maxMultipleFrequencyBands',
        u'maxMultipleFrequencyBandsEUTRA',
        u'id-AllowedQueuingTime',
        u'id-Allowed-Rate-Information',
        u'id-AntennaColocationIndicator',
        u'id-BindingID',
        u'id-C-ID',
        u'id-C-RNTI',
        u'id-Cell-Capacity-Class-Value',
        u'id-CFN',
        u'id-CN-CS-DomainIdentifier',
        u'id-CN-PS-DomainIdentifier',
        u'id-Cause',
        u'id-CoverageIndicator',
        u'id-CriticalityDiagnostics',
        u'id-ContextInfoItem-Reset',
        u'id-ContextGroupInfoItem-Reset',
        u'id-D-RNTI',
        u'id-D-RNTI-ReleaseIndication',
        u'id-DCHs-to-Add-FDD',
        u'id-DCHs-to-Add-TDD',
        u'id-DCH-DeleteList-RL-ReconfPrepFDD',
        u'id-DCH-DeleteList-RL-ReconfPrepTDD',
        u'id-DCH-DeleteList-RL-ReconfRqstFDD',
        u'id-DCH-DeleteList-RL-ReconfRqstTDD',
        u'id-DCH-FDD-Information',
        u'id-DCH-TDD-Information',
        u'id-FDD-DCHs-to-Modify',
        u'id-TDD-DCHs-to-Modify',
        u'id-DCH-InformationResponse',
        u'id-DCH-Rate-InformationItem-RL-CongestInd',
        u'id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD',
        u'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD',
        u'id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD',
        u'id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'id-DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'id-FDD-DL-CodeInformation',
        u'id-DL-DPCH-Information-RL-ReconfPrepFDD',
        u'id-DL-DPCH-Information-RL-SetupRqstFDD',
        u'id-DL-DPCH-Information-RL-ReconfRqstFDD',
        u'id-DL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'id-DL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'id-DL-DPCH-InformationItem-RL-SetupRspTDD',
        u'id-DL-DPCH-TimingAdjustment',
        u'id-DLReferencePower',
        u'id-DLReferencePowerList-DL-PC-Rqst',
        u'id-DL-ReferencePowerInformation-DL-PC-Rqst',
        u'id-DPC-Mode',
        u'id-DRXCycleLengthCoefficient',
        u'id-DedicatedMeasurementObjectType-DM-Fail-Ind',
        u'id-DedicatedMeasurementObjectType-DM-Fail',
        u'id-DedicatedMeasurementObjectType-DM-Rprt',
        u'id-DedicatedMeasurementObjectType-DM-Rqst',
        u'id-DedicatedMeasurementObjectType-DM-Rsp',
        u'id-DedicatedMeasurementType',
        u'id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD',
        u'id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD',
        u'id-Guaranteed-Rate-Information',
        u'id-IMSI',
        u'id-HCS-Prio',
        u'id-L3-Information',
        u'id-AdjustmentPeriod',
        u'id-MaxAdjustmentStep',
        u'id-MeasurementFilterCoefficient',
        u'id-MessageStructure',
        u'id-MeasurementID',
        u'id-Neighbouring-GSM-CellInformation',
        u'id-Neighbouring-UMTS-CellInformationItem',
        u'id-NRT-Load-Information-Value',
        u'id-NRT-Load-Information-Value-IncrDecrThres',
        u'id-PagingArea-PagingRqst',
        u'id-FACH-FlowControlInformation',
        u'id-PartialReportingIndicator',
        u'id-Permanent-NAS-UE-Identity',
        u'id-PowerAdjustmentType',
        u'id-RANAP-RelocationInformation',
        u'id-RL-Information-PhyChReconfRqstFDD',
        u'id-RL-Information-PhyChReconfRqstTDD',
        u'id-RL-Information-RL-AdditionRqstFDD',
        u'id-RL-Information-RL-AdditionRqstTDD',
        u'id-RL-Information-RL-DeletionRqst',
        u'id-RL-Information-RL-FailureInd',
        u'id-RL-Information-RL-ReconfPrepFDD',
        u'id-RL-Information-RL-RestoreInd',
        u'id-RL-Information-RL-SetupRqstFDD',
        u'id-RL-Information-RL-SetupRqstTDD',
        u'id-RL-InformationItem-RL-CongestInd',
        u'id-RL-InformationItem-DM-Rprt',
        u'id-RL-InformationItem-DM-Rqst',
        u'id-RL-InformationItem-DM-Rsp',
        u'id-RL-InformationItem-RL-PreemptRequiredInd',
        u'id-RL-InformationItem-RL-SetupRqstFDD',
        u'id-RL-InformationList-RL-CongestInd',
        u'id-RL-InformationList-RL-AdditionRqstFDD',
        u'id-RL-InformationList-RL-DeletionRqst',
        u'id-RL-InformationList-RL-PreemptRequiredInd',
        u'id-RL-InformationList-RL-ReconfPrepFDD',
        u'id-RL-InformationResponse-RL-AdditionRspTDD',
        u'id-RL-InformationResponse-RL-ReconfReadyTDD',
        u'id-RL-InformationResponse-RL-SetupRspTDD',
        u'id-RL-InformationResponseItem-RL-AdditionRspFDD',
        u'id-RL-InformationResponseItem-RL-ReconfReadyFDD',
        u'id-RL-InformationResponseItem-RL-ReconfRspFDD',
        u'id-RL-InformationResponseItem-RL-SetupRspFDD',
        u'id-RL-InformationResponseList-RL-AdditionRspFDD',
        u'id-RL-InformationResponseList-RL-ReconfReadyFDD',
        u'id-RL-InformationResponseList-RL-ReconfRspFDD',
        u'id-RL-InformationResponse-RL-ReconfRspTDD',
        u'id-RL-InformationResponseList-RL-SetupRspFDD',
        u'id-RL-ReconfigurationFailure-RL-ReconfFail',
        u'id-RL-Set-InformationItem-DM-Rprt',
        u'id-RL-Set-InformationItem-DM-Rqst',
        u'id-RL-Set-InformationItem-DM-Rsp',
        u'id-RL-Set-Information-RL-FailureInd',
        u'id-RL-Set-Information-RL-RestoreInd',
        u'id-RL-Set-Successful-InformationItem-DM-Fail',
        u'id-RL-Set-Unsuccessful-InformationItem-DM-Fail',
        u'id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'id-RL-Successful-InformationItem-DM-Fail',
        u'id-RL-Unsuccessful-InformationItem-DM-Fail',
        u'id-RL-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'id-ReportCharacteristics',
        u'id-Reporting-Object-RL-FailureInd',
        u'id-Reporing-Object-RL-RestoreInd',
        u'id-RT-Load-Value',
        u'id-RT-Load-Value-IncrDecrThres',
        u'id-S-RNTI',
        u'id-ResetIndicator',
        u'id-RNC-ID',
        u'id-SAI',
        u'id-SRNC-ID',
        u'id-SuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'id-SuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'id-TransportBearerID',
        u'id-TransportBearerRequestIndicator',
        u'id-TransportLayerAddress',
        u'id-TypeOfError',
        u'id-UC-ID',
        u'id-UL-CCTrCH-AddInformation-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'id-UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'id-UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD',
        u'id-UL-CCTrCH-InformationListIE-RL-ReconfReadyTDD',
        u'id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD',
        u'id-UL-DPCH-Information-RL-ReconfPrepFDD',
        u'id-UL-DPCH-Information-RL-ReconfRqstFDD',
        u'id-UL-DPCH-Information-RL-SetupRqstFDD',
        u'id-UL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'id-UL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'id-UL-DPCH-InformationItem-RL-SetupRspTDD',
        u'id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-UL-SIRTarget',
        u'id-URA-Information',
        u'id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'id-UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'id-UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD',
        u'id-Active-Pattern-Sequence-Information',
        u'id-AdjustmentRatio',
        u'id-CauseLevel-RL-AdditionFailureFDD',
        u'id-CauseLevel-RL-AdditionFailureTDD',
        u'id-CauseLevel-RL-ReconfFailure',
        u'id-CauseLevel-RL-SetupFailureFDD',
        u'id-CauseLevel-RL-SetupFailureTDD',
        u'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'id-DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'id-DSCHs-to-Add-TDD',
        u'id-Unused-ProtocolIE-ID-216',
        u'id-DSCH-DeleteList-RL-ReconfPrepTDD',
        u'id-Unused-ProtocolIE-ID-218',
        u'id-Unused-ProtocolIE-ID-219',
        u'id-DSCH-InformationListIE-RL-AdditionRspTDD',
        u'id-DSCH-InformationListIEs-RL-SetupRspTDD',
        u'id-DSCH-TDD-Information',
        u'id-Unused-ProtocolIE-ID-223',
        u'id-Unused-ProtocolIE-ID-226',
        u'id-DSCH-ModifyList-RL-ReconfPrepTDD',
        u'id-Unused-ProtocolIE-ID-228',
        u'id-Unused-ProtocolIE-ID-324',
        u'id-Unused-ProtocolIE-ID-229',
        u'id-DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'id-Unused-ProtocolIE-ID-29',
        u'id-Unused-ProtocolIE-ID-225',
        u'id-GA-Cell',
        u'id-GA-CellAdditionalShapes',
        u'id-Unused-ProtocolIE-ID-246',
        u'id-Transmission-Gap-Pattern-Sequence-Information',
        u'id-UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'id-UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'id-UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD',
        u'id-USCHs-to-Add',
        u'id-USCH-DeleteList-RL-ReconfPrepTDD',
        u'id-USCH-InformationListIE-RL-AdditionRspTDD',
        u'id-USCH-InformationListIEs-RL-SetupRspTDD',
        u'id-USCH-Information',
        u'id-USCH-ModifyList-RL-ReconfPrepTDD',
        u'id-USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'id-DL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'id-UL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'id-ClosedLoopMode1-SupportIndicator',
        u'id-Unused-ProtocolIE-ID-277',
        u'id-STTD-SupportIndicator',
        u'id-CFNReportingIndicator',
        u'id-CNOriginatedPage-PagingRqst',
        u'id-InnerLoopDLPCStatus',
        u'id-PropagationDelay',
        u'id-RxTimingDeviationForTA',
        u'id-timeSlot-ISCP',
        u'id-CCTrCH-InformationItem-RL-FailureInd',
        u'id-CCTrCH-InformationItem-RL-RestoreInd',
        u'id-CommonMeasurementAccuracy',
        u'id-CommonMeasurementObjectType-CM-Rprt',
        u'id-CommonMeasurementObjectType-CM-Rqst',
        u'id-CommonMeasurementObjectType-CM-Rsp',
        u'id-CommonMeasurementType',
        u'id-CongestionCause',
        u'id-SFN',
        u'id-SFNReportingIndicator',
        u'id-InformationExchangeID',
        u'id-InformationExchangeObjectType-InfEx-Rprt',
        u'id-InformationExchangeObjectType-InfEx-Rqst',
        u'id-InformationExchangeObjectType-InfEx-Rsp',
        u'id-InformationReportCharacteristics',
        u'id-InformationType',
        u'id-neighbouring-LCR-TDD-CellInformation',
        u'id-DL-Timeslot-ISCP-LCR-Information-RL-SetupRqstTDD',
        u'id-RL-LCR-InformationResponse-RL-SetupRspTDD',
        u'id-UL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD',
        u'id-UL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'id-DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD',
        u'id-DL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'id-DSCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'id-USCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'id-DL-Timeslot-ISCP-LCR-Information-RL-AdditionRqstTDD',
        u'id-RL-LCR-InformationResponse-RL-AdditionRspTDD',
        u'id-UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'id-UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'id-DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'id-DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'id-DSCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'id-USCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-UL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'id-DL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD',
        u'id-DL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'id-UL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD',
        u'id-DL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD',
        u'id-timeSlot-ISCP-LCR-List-DL-PC-Rqst-TDD',
        u'id-TSTD-Support-Indicator-RL-SetupRqstTDD',
        u'id-RestrictionStateIndicator',
        u'id-Load-Value',
        u'id-Load-Value-IncrDecrThres',
        u'id-OnModification',
        u'id-Received-Total-Wideband-Power-Value',
        u'id-Received-Total-Wideband-Power-Value-IncrDecrThres',
        u'id-SFNSFNMeasurementThresholdInformation',
        u'id-Transmitted-Carrier-Power-Value',
        u'id-Transmitted-Carrier-Power-Value-IncrDecrThres',
        u'id-TUTRANGPSMeasurementThresholdInformation',
        u'id-UL-Timeslot-ISCP-Value',
        u'id-UL-Timeslot-ISCP-Value-IncrDecrThres',
        u'id-Rx-Timing-Deviation-Value-LCR',
        u'id-DPC-Mode-Change-SupportIndicator',
        u'id-Unused-ProtocolIE-ID-247',
        u'id-Unused-ProtocolIE-ID-295',
        u'id-PrimaryCCPCH-RSCP-RL-ReconfPrepTDD',
        u'id-DL-TimeSlot-ISCP-Info-RL-ReconfPrepTDD',
        u'id-DL-Timeslot-ISCP-LCR-Information-RL-ReconfPrepTDD',
        u'id-DSCH-RNTI',
        u'id-DL-PowerBalancing-Information',
        u'id-DL-PowerBalancing-ActivationIndicator',
        u'id-DL-PowerBalancing-UpdatedIndicator',
        u'id-DL-ReferencePowerInformation',
        u'id-Enhanced-PrimaryCPICH-EcNo',
        u'id-IPDL-TDD-ParametersLCR',
        u'id-CellCapabilityContainer-FDD',
        u'id-CellCapabilityContainer-TDD',
        u'id-CellCapabilityContainer-TDD-LCR',
        u'id-RL-Specific-DCH-Info',
        u'id-RL-ReconfigurationRequestFDD-RL-InformationList',
        u'id-RL-ReconfigurationRequestFDD-RL-Information-IEs',
        u'id-RL-ReconfigurationRequestTDD-RL-Information',
        u'id-CommonTransportChannelResourcesInitialisationNotRequired',
        u'id-DelayedActivation',
        u'id-DelayedActivationList-RL-ActivationCmdFDD',
        u'id-DelayedActivationInformation-RL-ActivationCmdFDD',
        u'id-DelayedActivationList-RL-ActivationCmdTDD',
        u'id-DelayedActivationInformation-RL-ActivationCmdTDD',
        u'id-neighbouringTDDCellMeasurementInformationLCR',
        u'id-UL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD',
        u'id-UL-SIR-Target-CCTrCH-LCR-InformationItem-RL-SetupRspTDD',
        u'id-PrimCCPCH-RSCP-DL-PC-RqstTDD',
        u'id-HSDSCH-FDD-Information',
        u'id-HSDSCH-FDD-Information-Response',
        u'id-HSDSCH-FDD-Update-Information',
        u'id-HSDSCH-Information-to-Modify',
        u'id-HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'id-HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'id-HSDSCH-RNTI',
        u'id-HSDSCH-TDD-Information',
        u'id-HSDSCH-TDD-Information-Response',
        u'id-HSDSCH-TDD-Update-Information',
        u'id-HSPDSCH-RL-ID',
        u'id-HSDSCH-MACdFlows-to-Add',
        u'id-HSDSCH-MACdFlows-to-Delete',
        u'id-Angle-Of-Arrival-Value-LCR',
        u'id-TrafficClass',
        u'id-Unused-ProtocolIE-ID-248',
        u'id-Unused-ProtocolIE-ID-253',
        u'id-PDSCH-RL-ID',
        u'id-TimeSlot-RL-SetupRspTDD',
        u'id-GERAN-Cell-Capability',
        u'id-GERAN-Classmark',
        u'id-DSCH-InitialWindowSize',
        u'id-UL-Synchronisation-Parameters-LCR',
        u'id-SNA-Information',
        u'id-MAChs-ResetIndicator',
        u'id-TDD-DL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD',
        u'id-TDD-UL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD',
        u'id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD',
        u'id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'id-UL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'id-DL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD',
        u'id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD',
        u'id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD',
        u'id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD',
        u'id-UL-TimingAdvanceCtrl-LCR',
        u'id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'id-HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD',
        u'id-HS-SICH-Reception-Quality',
        u'id-HS-SICH-Reception-Quality-Measurement-Value',
        u'id-HSSICH-Info-DM-Rprt',
        u'id-HSSICH-Info-DM-Rqst',
        u'id-HSSICH-Info-DM',
        u'id-CCTrCH-Maximum-DL-Power-RL-SetupRspTDD',
        u'id-CCTrCH-Minimum-DL-Power-RL-SetupRspTDD',
        u'id-CCTrCH-Maximum-DL-Power-RL-AdditionRspTDD',
        u'id-CCTrCH-Minimum-DL-Power-RL-AdditionRspTDD',
        u'id-CCTrCH-Maximum-DL-Power-RL-ReconfReadyTDD',
        u'id-CCTrCH-Minimum-DL-Power-RL-ReconfReadyTDD',
        u'id-Maximum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'id-Minimum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'id-DL-CCTrCH-InformationList-RL-ReconfRspTDD',
        u'id-DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD',
        u'id-Maximum-DL-Power-TimeslotLCR-InformationItem',
        u'id-Minimum-DL-Power-TimeslotLCR-InformationItem',
        u'id-TDD-Support-8PSK',
        u'id-TDD-maxNrDLPhysicalchannels',
        u'id-ExtendedGSMCellIndividualOffset',
        u'id-RL-ParameterUpdateIndicationFDD-RL-InformationList',
        u'id-Primary-CPICH-Usage-For-Channel-Estimation',
        u'id-Secondary-CPICH-Information',
        u'id-Secondary-CPICH-Information-Change',
        u'id-Unused-ProtocolIE-ID-522',
        u'id-Unused-ProtocolIE-ID-523',
        u'id-RL-ParameterUpdateIndicationFDD-RL-Information-Item',
        u'id-Phase-Reference-Update-Indicator',
        u'id-Unidirectional-DCH-Indicator',
        u'id-RL-Information-RL-ReconfPrepTDD',
        u'id-Multiple-RL-InformationResponse-RL-ReconfReadyTDD',
        u'id-RL-ReconfigurationResponseTDD-RL-Information',
        u'id-Satellite-Almanac-Information-ExtItem',
        u'id-HSDSCH-Information-to-Modify-Unsynchronised',
        u'id-TnlQos',
        u'id-RTLoadValue',
        u'id-NRTLoadInformationValue',
        u'id-CellPortionID',
        u'id-UpPTSInterferenceValue',
        u'id-PrimaryCCPCH-RSCP-Delta',
        u'id-UEMeasurementType',
        u'id-UEMeasurementTimeslotInfoHCR',
        u'id-UEMeasurementTimeslotInfoLCR',
        u'id-UEMeasurementReportCharacteristics',
        u'id-UEMeasurementParameterModAllow',
        u'id-UEMeasurementValueInformation',
        u'id-InterfacesToTraceItem',
        u'id-ListOfInterfacesToTrace',
        u'id-TraceDepth',
        u'id-TraceRecordingSessionReference',
        u'id-TraceReference',
        u'id-UEIdentity',
        u'id-NACC-Related-Data',
        u'id-GSM-Cell-InfEx-Rqst',
        u'id-MeasurementRecoveryBehavior',
        u'id-MeasurementRecoveryReportingIndicator',
        u'id-MeasurementRecoverySupportIndicator',
        u'id-DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        u'id-F-DPCH-Information-RL-ReconfPrepFDD',
        u'id-F-DPCH-Information-RL-SetupRqstFDD',
        u'id-MBMS-Bearer-Service-List',
        u'id-MBMS-Bearer-Service-List-InfEx-Rsp',
        u'id-Active-MBMS-Bearer-ServiceFDD',
        u'id-Active-MBMS-Bearer-ServiceTDD',
        u'id-Old-URA-ID',
        u'id-UE-State',
        u'id-URA-ID',
        u'id-HARQ-Preamble-Mode',
        u'id-SynchronisationIndicator',
        u'id-UL-DPDCHIndicatorEDCH',
        u'id-EDPCH-Information',
        u'id-RL-Specific-EDCH-Information',
        u'id-EDCH-RL-Indication',
        u'id-EDCH-FDD-Information',
        u'id-EDCH-RLSet-Id',
        u'id-Serving-EDCHRL-Id',
        u'id-EDCH-FDD-DL-ControlChannelInformation',
        u'id-EDCH-FDD-InformationResponse',
        u'id-EDCH-MACdFlows-To-Add',
        u'id-EDCH-FDD-Information-To-Modify',
        u'id-EDCH-MACdFlows-To-Delete',
        u'id-EDPCH-Information-RLReconfRequest-FDD',
        u'id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd',
        u'id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd',
        u'id-MBMS-Bearer-Service-Full-Address',
        u'id-Initial-DL-DPCH-TimingAdjustment',
        u'id-Initial-DL-DPCH-TimingAdjustment-Allowed',
        u'id-User-Plane-Congestion-Fields-Inclusion',
        u'id-HARQ-Preamble-Mode-Activation-Indicator',
        u'id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        u'id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        u'id-ProvidedInformation',
        u'id-Active-MBMS-Bearer-ServiceFDD-PFL',
        u'id-Active-MBMS-Bearer-ServiceTDD-PFL',
        u'id-FrequencyBandIndicator',
        u'id-Serving-cell-change-CFN',
        u'id-HS-DSCH-serving-cell-change-information',
        u'id-HS-DSCH-serving-cell-change-informationResponse',
        u'id-E-DCH-Serving-cell-change-informationResponse',
        u'id-secondary-LCR-CCPCH-Info-TDD',
        u'id-E-DCH-FDD-Update-Information',
        u'id-Inter-Frequency-Cell-List',
        u'id-Inter-Frequency-Cell-Information',
        u'id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        u'id-TDD-Support-PLCCH',
        u'id-PLCCH-Information-UL-TimeslotLCR-Info',
        u'id-PLCCH-Information-PhyChReconfRqstTDD',
        u'id-TDD768-maxNrDLPhysicalchannelsTS',
        u'id-RL-InformationResponse-RL-AdditionRspTDD768',
        u'id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD768',
        u'id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD768',
        u'id-UL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'id-DL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768',
        u'id-UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768',
        u'id-DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'id-secondary-CCPCH-Info-RL-ReconfReadyTDD768',
        u'id-hSSCCH-TDD-Specific-InfoList-Response768',
        u'id-hSPDSCH-TDD-Specific-InfoList-Response768',
        u'id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'id-UL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'id-DL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'id-CellCapabilityContainer-TDD768',
        u'id-multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp',
        u'id-neighbouringTDDCellMeasurementInformation768',
        u'id-UEMeasurementTimeslotInfo768',
        u'id-Rx-Timing-Deviation-Value-768',
        u'id-UEMeasurementValueTransmittedPowerList768',
        u'id-UEMeasurementValueTimeslotISCPList768',
        u'id-RL-InformationResponse-RL-SetupRspTDD768',
        u'id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD768',
        u'id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD768',
        u'id-UL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'id-DL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'id-TDD768-minimumSpreadingFactor-UL',
        u'id-TDD768-minimumSpreadingFactor-DL',
        u'id-TDD768-maxNrDLPhysicalchannels',
        u'id-DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD',
        u'id-DPCH-ID768-DM-Rsp',
        u'id-DPCH-ID768-DM-Rqst',
        u'id-DPCH-ID768-DM-Rprt',
        u'id-EDPCH-Information-RLAdditionReq-FDD',
        u'id-HSDSCH-Configured-Indicator',
        u'id-RxTimingDeviationForTAext',
        u'id-RxTimingDeviationForTA768',
        u'id-Rx-Timing-Deviation-Value-ext',
        u'id-E-DCH-PowerOffset-for-SchedulingInfo',
        u'id-TrCH-SrcStatisticsDescr',
        u'id-E-DCH-Information',
        u'id-E-DCH-Serving-RL-ID',
        u'id-E-DCH-Information-Reconfig',
        u'id-E-DCH-Information-Response',
        u'id-E-DCH-768-Information',
        u'id-E-DCH-768-Information-Reconfig',
        u'id-E-DCH-768-Information-Response',
        u'id-ExtendedPropagationDelay',
        u'id-Extended-Round-Trip-Time-Value',
        u'id-AlternativeFormatReportingIndicator',
        u'id-DCH-Indicator-For-E-DCH-HSDPA-Operation',
        u'id-E-RGCH-E-HICH-ChannelisationCodeValidityIndicator',
        u'id-E-DCH-Minimum-Set-E-TFCIValidityIndicator',
        u'id-Fast-Reconfiguration-Mode',
        u'id-Fast-Reconfiguration-Permission',
        u'id-Continuous-Packet-Connectivity-DTX-DRX-Information',
        u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information',
        u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response',
        u'id-CPC-Information',
        u'id-MIMO-InformationResponse',
        u'id-E-DCH-LCR-Information',
        u'id-E-DCH-LCR-Information-Reconfig',
        u'id-E-DCH-LCR-Information-Response',
        u'id-HS-PDSCH-Code-Change-Grant',
        u'id-HS-PDSCH-Code-Change-Indicator',
        u'id-Extended-SRNC-ID',
        u'id-Extended-RNC-ID',
        u'id-SixtyfourQAM-DL-SupportIndicator',
        u'id-Enhanced-FACH-Support-Indicator',
        u'id-Enhanced-FACH-Information-ResponseFDD',
        u'id-HSDSCH-MACdPDUSizeFormat',
        u'id-MaximumMACdPDU-SizeExtended',
        u'id-F-DPCH-SlotFormat',
        u'id-F-DPCH-SlotFormatSupportRequest',
        u'id-eDCH-MACdFlow-Retransmission-Timer-LCR',
        u'id-Max-UE-DTX-Cycle',
        u'id-GANSS-Common-Data',
        u'id-GANSS-Information',
        u'id-GANSS-Generic-Data',
        u'id-TUTRANGANSSMeasurementThresholdInformation',
        u'id-TUTRANGANSSMeasurementValueInformation',
        u'id-Ext-Reference-E-TFCI-PO',
        u'id-Ext-Max-Bits-MACe-PDU-non-scheduled',
        u'id-HARQ-MemoryPartitioningInfoExtForMIMO',
        u'id-MIMO-ActivationIndicator',
        u'id-MIMO-Mode-Indicator',
        u'id-MIMO-N-M-Ratio',
        u'id-TransportBearerNotSetupIndicator',
        u'id-TransportBearerNotRequestedIndicator',
        u'id-PowerControlGAP',
        u'id-UARFCNforNt',
        u'id-LCRTDD-uplink-Physical-Channel-Capability',
        u'id-number-Of-Supported-Carriers',
        u'id-HSSICH-SIRTarget',
        u'id-HSSICH-TPC-StepSize',
        u'id-tSN-Length',
        u'id-HS-SICH-ID-Extension',
        u'id-HSSICH-Info-DM-Rqst-Extension',
        u'id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        u'id-multicarrier-number',
        u'id-UPPCHPositionLCR',
        u'id-UpPCH-InformationList-LCRTDD',
        u'id-UpPCH-InformationItem-LCRTDD',
        u'id-Multiple-PLMN-List',
        u'id-UE-Capabilities-Info',
        u'id-FrameOffset',
        u'id-ChipOffset',
        u'id-Enhanced-PCH-Capability',
        u'id-SixteenQAM-UL-Operation-Indicator',
        u'id-E-TFCI-Boost-Information',
        u'id-SixtyfourQAM-UsageAllowedIndicator',
        u'id-SixtyfourQAM-DL-UsageIndicator',
        u'id-Default-Serving-Grant-in-DTX-Cycle2',
        u'id-E-DPDCH-PowerInterpolation',
        u'id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'id-E-DCH-MACdPDUSizeFormat',
        u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Deactivate-Indicator',
        u'id-E-DCH-DL-Control-Channel-Change-Information',
        u'id-E-DCH-DL-Control-Channel-Grant-Information',
        u'id-MaximumNumber-Of-Retransmission-For-SchedulingInfo-LCRTDD',
        u'id-E-DCH-RetransmissionTimer-For-SchedulingInfo-LCRTDD',
        u'id-E-PUCH-PowerControlGAP',
        u'id-HSDSCH-TBSizeTableIndicator',
        u'id-UE-with-enhanced-HS-SCCH-support-indicator',
        u'id-DGANSS-Corrections-Req',
        u'id-E-AGCH-Table-Choice',
        u'id-RANAP-EnhancedRelocationInformationRequest',
        u'id-RANAP-EnhancedRelocationInformationResponse',
        u'id-Common-EDCH-MAC-d-Flow-Specific-InformationFDD',
        u'id-Common-EDCH-Support-Indicator',
        u'id-E-RNTI',
        u'id-Released-CN-Domain',
        u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst',
        u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp',
        u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt',
        u'id-MBMS-Cell-InfEx-Rqst',
        u'id-MBMS-Cell-InfEx-Rsp',
        u'id-MBMS-Cell-InfEx-Rprt',
        u'id-Counting-Information',
        u'id-Transmission-Mode-Information',
        u'id-MBMS-Neighbouring-Cell-Information',
        u'id-MBMS-RLC-Sequence-Number-Information',
        u'id-RLC-Sequence-Number',
        u'id-Neighbouring-E-UTRA-CellInformation',
        u'id-MBSFN-Cluster-Identity',
        u'id-MCCH-Configuration-Info',
        u'id-MCCH-Message-List',
        u'id-MBSFN-Scheduling-Transmission-Time-Interval-Info-List',
        u'id-GANSS-Time-ID',
        u'id-GANSS-AddIonoModelReq',
        u'id-GANSS-EarthOrientParaReq',
        u'id-GANSS-AddNavigationModelsReq',
        u'id-GANSS-AddUTCModelsReq',
        u'id-GANSS-AuxInfoReq',
        u'id-GANSS-SBAS-ID',
        u'id-GANSS-ID',
        u'id-GANSS-Additional-Ionospheric-Model',
        u'id-GANSS-Earth-Orientation-Parameters',
        u'id-GANSS-Additional-Time-Models',
        u'id-GANSS-Additional-Navigation-Models',
        u'id-GANSS-Additional-UTC-Models',
        u'id-GANSS-Auxiliary-Information',
        u'id-MinimumReducedE-DPDCH-GainFactor',
        u'id-Enhanced-FACH-Information-ResponseLCR',
        u'id-Common-EDCH-MAC-d-Flow-Specific-InformationLCR',
        u'id-HSDSCH-PreconfigurationSetup',
        u'id-HSDSCH-PreconfigurationInfo',
        u'id-NoOfTargetCellHS-SCCH-Order',
        u'id-EnhancedHSServingCC-Abort',
        u'id-Additional-HS-Cell-Information-RL-Setup',
        u'id-Additional-HS-Cell-Information-Response',
        u'id-Additional-HS-Cell-Information-RL-Addition',
        u'id-Additional-HS-Cell-Change-Information-Response',
        u'id-Additional-HS-Cell-Information-RL-Reconf-Prep',
        u'id-Additional-HS-Cell-Information-RL-Reconf-Req',
        u'id-Additional-HS-Cell-RL-Reconf-Response',
        u'id-Additional-HS-Cell-Information-RL-Param-Upd',
        u'id-Secondary-Serving-Cell-List',
        u'id-MultiCarrier-HSDSCH-Physical-Layer-Category',
        u'id-IdleIntervalInformation',
        u'id-NeedforIdleInterval',
        u'id-IdleIntervalConfigurationIndicator',
        u'id-ContinuousPacketConnectivity-DRX-InformationLCR',
        u'id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        u'id-E-AGCH-UE-Inactivity-Monitor-Threshold',
        u'id-CPC-InformationLCR',
        u'id-E-DCH-Semi-PersistentScheduling-Information-LCR',
        u'id-HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        u'id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'id-MIMO-SFMode-For-HSPDSCHDualStream',
        u'id-MIMO-SFMode-Supported-For-HSPDSCHDualStream',
        u'id-MIMO-ReferenceSignal-InformationListLCR',
        u'id-GANSS-alm-keplerianNAVAlmanac',
        u'id-GANSS-alm-keplerianReducedAlmanac',
        u'id-GANSS-alm-keplerianMidiAlmanac',
        u'id-GANSS-alm-keplerianGLONASS',
        u'id-GANSS-alm-ecefSBASAlmanac',
        u'id-DL-RLC-PDU-Size-Format',
        u'id-MACes-Maximum-Bitrate-LCR',
        u'id-Single-Stream-MIMO-ActivationIndicator',
        u'id-Single-Stream-MIMO-Mode-Indicator',
        u'id-Dual-Band-Secondary-Serving-Cell-List',
        u'id-UE-AggregateMaximumBitRate',
        u'id-power-offset-for-S-CPICH-for-MIMO',
        u'id-power-offset-for-S-CPICH-for-MIMO-Request-Indicator',
        u'id-UE-SupportIndicatorExtension',
        u'id-ActivationInformation',
        u'id-CellPortionLCRID',
        u'id-Additional-EDCH-Cell-Information-RL-Setup-Req',
        u'id-Additional-EDCH-Cell-Information-Response',
        u'id-Additional-EDCH-Cell-Information-RL-Add-Req',
        u'id-Additional-EDCH-Cell-Information-Response-RLAdd',
        u'id-Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        u'id-Additional-EDCH-Cell-Information-RL-Reconf-Req',
        u'id-Additional-EDCH-Cell-Information-RL-Param-Upd',
        u'id-Additional-EDCH-Preconfiguration-Information',
        u'id-MulticellEDCH-Information',
        u'id-Additional-EDCH-Cell-Information-ResponseRLReconf',
        u'id-EDCH-Indicator',
        u'id-DiversityMode',
        u'id-TransmitDiversityIndicator',
        u'id-NonCellSpecificTxDiversity',
        u'id-CellCapabilityContainerExtension-FDD',
        u'id-HSDSCH-Physical-Layer-Category',
        u'id-E-RNTI-For-FACH',
        u'id-H-RNTI-For-FACH',
        u'id-RNTI-Allocation-Indicator',
        u'id-UE-AggregateMaximumBitRate-Enforcement-Indicator',
        u'id-DCH-MeasurementOccasion-Information',
        u'id-DCH-MeasurementType-Indicator',
        u'id-Out-of-Sychronization-Window',
        u'id-MulticellEDCH-RL-SpecificInformation',
        u'id-DGNSS-ValidityPeriod',
        u'id-TS0-HS-PDSCH-Indication-LCR',
        u'id-UE-TS0-CapabilityLCR',
        u'id-Non-Serving-RL-Preconfig-Info',
        u'id-Non-Serving-RL-Preconfig-Setup',
        u'id-Non-Serving-RL-Preconfig-Removal',
        u'id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        u'id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        u'id-CellListValidityIndicator',
        u'id-completeAlmanacProvided',
        u'id-ganss-Delta-T',
        u'id-OrdinalNumberOfFrequency',
        u'id-Multicell-EDCH-Restriction',
        u'id-CellCapabilityContainerExtension-TDD-LCR',
        u'id-Multi-Carrier-EDCH-Setup',
        u'id-Multi-Carrier-EDCH-Reconfigure',
        u'id-Multi-Carrier-EDCH-Response',
        u'id-SNPL-Carrier-Group-Indicator',
        u'id-MU-MIMO-InformationLCR',
        u'id-MU-MIMO-Indicator',
        u'id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        u'id-Usefulness-Of-Battery-Optimization',
        u'id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'id-Measurement-Power-Offset',
        u'id-MDT-Configuration',
        u'id-Neighbouring-UMTS-CellInformation-Ext',
        u'id-Neighbouring-UMTS-CellInformationExtensionItem',
        u'id-Control-Type-InformationTransferControlReq',
        u'id-UMTS-Cells-Info',
        u'id-ANRReportIndication',
        u'id-ANR-Cell-InfEx-Rqst',
        u'id-ANR-Cell-InfEx-Rsp',
        u'id-ANR-Cell-Information',
        u'id-Trace-Collection-Entity-IP-Address',
        u'id-Affected-HSDSCH-Serving-Cell-List',
        u'id-UL-CLTD-Information',
        u'id-UL-CLTD-Information-Reconf',
        u'id-UL-CLTD-State-Update-Information',
        u'id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        u'id-CPC-RecoveryReport',
        u'id-FTPICH-Information',
        u'id-FTPICH-Information-Reconf',
        u'id-UE-RF-Band-CapabilityLCR',
        u'id-Extended-S-RNTI',
        u'id-ExtendedAffectedUEInformationForMBMS',
        u'id-Extended-S-RNTI-Group',
        u'id-FTPICH-Information-Response',
        u'id-FTPICH-Reconfiguration-Information',
        u'id-MIMO-withfourtransmitantennas-ActivationIndicator',
        u'id-MIMO-withfourtransmitantennas-ModeIndicator',
        u'id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas',
        u'id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas-Request-Indicator',
        u'id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        u'id-DualStream-MIMO-withfourtransmitantennas-ModeIndicator',
        u'id-Additional-Associated-Secondary-CPICH',
        u'id-UE-transmission-power-headroom',
        u'id-Multiflow-Information',
        u'id-Multiflow-Reconfiguration',
        u'id-Multiflow-OrdinalNumberOfFrequency',
        u'id-UL-MIMO-Information',
        u'id-UL-MIMO-Reconfiguration',
        u'id-UL-MIMO-DL-Control-Channel-Information',
        u'id-SixtyfourQAM-UL-Operation-Indicator',
        u'id-Common-E-RGCH-Cell-InfEx-Rqst',
        u'id-Common-E-RGCH-Cell-InfEx-Rsp',
        u'id-Common-E-RGCH-Cell-InfEx-Rprt',
        u'id-Common-E-RGCH-Cell-Information',
        u'id-PCI',
        u'id-TAC',
        u'id-PLMN-List',
        u'id-PrecoderWeightSetRestriction',
        u'id-EARFCN-FDD-Extended',
        u'id-EARFCN-TDD-Extended',
        u'id-Non-rectangular-resource-allocation-indicator',
        u'id-Non-rectangular-resource-timeslot-set',
        u'id-UE-Support-of-non-rectangular-resource-allocation',
        u'id-DBDS-CorrectionsReq',
        u'id-DBDS-Corrections',
        u'id-BDS-IonosphericGridModelReq',
        u'id-BDS-Ionospheric-Grid-Model',
        u'id-GANSS-alm-keplerianBDSAlmanac',
        u'id-Assisting-RepetitionFactors',
        u'id-E-DCH-Decoupling-Indication',
        u'id-UE-Measurement-Forwarding',
        u'id-UPH-Filtering-Measurement-Forwarding-Request',
        u'id-TTI-Update-Indicator',
        u'id-CQI-Feedback-Cycle2-k',
        u'id-CQI-Cycle-Switch-Timer',
        u'id-UE-DRX-Cycle2',
        u'id-Inactivity-Threshold-for-UE-DRX-Cycle2',
        u'id-DTX-Information2',
        u'id-DCH-ENH-Information',
        u'id-DCH-ENH-Information-Reconf',
        u'id-Gainfactors-10ms-mode',
        u'id-Radio-Links-without-DPCH-FDPCH-Indication',
        u'id-UL-DPCCH2-Information',
        u'id-UL-DPCCH2-Information-Reconf',
        u'id-ImplicitGrantHandling',
        u'id-MinimumTEBSthreshold',
        u'id-MultipleFrequencyBandsIndicatorList-EUTRA',
        u'id-MultipleFrequencyBandsIndicatorList',
        u'id-ActivationDelay',
        u'id-Fast-TTI-switching-Mode-synchronized',
        u'id-Fast-TTI-switching-Mode-unsynchronized',
        u'id-Fast-TTI-switching-Mode-Supported',
        u'id-GANSS-BDSclockModel',
        u'id-GANSS-NavModel-BDSKeplerianSet',
        u'id-GANSS-UTCmodelSet4',
        u'id-Inter-Frequency-Cell-Information-SIB11ter',
        u'id-Improved-Synchronized-Indicator',
        u'id-Downlink-TPC-enhancements-Information',
        u'id-Downlink-TPC-enhancements-Reconf',
        u'id-TPC-slot-position',
        u'id-DL-TBS',
        u'id-Selected-PLMN-Identity',
        u'id-Dual-Cell-EDCH-Enhancements-Information',
        u'id-SpeechVersion',
        u'id-SourceID',
        u'id-TargetID',
        u'id-ClassmarkInformation2',
        u'id-ClassmarkInformation3',
        u'id-GSM-Cell-CM-Rqst',
        u'id-Extension-CommonMeasurementObjectType-CM-Rprt',
        u'id-Extension-CommonMeasurementObjectType-CM-Rqst',
        u'id-Extension-CommonMeasurementObjectType-CM-Rsp',
        u'id-Extension-FailureIndicationMeasurementList',
        u'id-Extension-FailureMeasurementList',
        u'id-Extension-TerminationMeasurementList',
        u'id-GsmCellList-CM-Rprt',
        u'id-GsmCellList-CM-Rqst',
        u'id-GsmCellList-CM-Rsp',
        u'id-LoadValue',
        u'id-EventH',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-commonTransportChannelResourcesInitialisation >-----#
    id_commonTransportChannelResourcesInitialisation = INT(name=u'id-commonTransportChannelResourcesInitialisation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_commonTransportChannelResourcesInitialisation._val = 0
    
    #-----< id-commonTransportChannelResourcesRelease >-----#
    id_commonTransportChannelResourcesRelease = INT(name=u'id-commonTransportChannelResourcesRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_commonTransportChannelResourcesRelease._val = 1
    
    #-----< id-compressedModeCommand >-----#
    id_compressedModeCommand = INT(name=u'id-compressedModeCommand', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_compressedModeCommand._val = 2
    
    #-----< id-downlinkPowerControl >-----#
    id_downlinkPowerControl = INT(name=u'id-downlinkPowerControl', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkPowerControl._val = 3
    
    #-----< id-downlinkPowerTimeslotControl >-----#
    id_downlinkPowerTimeslotControl = INT(name=u'id-downlinkPowerTimeslotControl', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkPowerTimeslotControl._val = 4
    
    #-----< id-downlinkSignallingTransfer >-----#
    id_downlinkSignallingTransfer = INT(name=u'id-downlinkSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_downlinkSignallingTransfer._val = 5
    
    #-----< id-errorIndication >-----#
    id_errorIndication = INT(name=u'id-errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_errorIndication._val = 6
    
    #-----< id-dedicatedMeasurementFailure >-----#
    id_dedicatedMeasurementFailure = INT(name=u'id-dedicatedMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementFailure._val = 7
    
    #-----< id-dedicatedMeasurementInitiation >-----#
    id_dedicatedMeasurementInitiation = INT(name=u'id-dedicatedMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementInitiation._val = 8
    
    #-----< id-dedicatedMeasurementReporting >-----#
    id_dedicatedMeasurementReporting = INT(name=u'id-dedicatedMeasurementReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementReporting._val = 9
    
    #-----< id-dedicatedMeasurementTermination >-----#
    id_dedicatedMeasurementTermination = INT(name=u'id-dedicatedMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_dedicatedMeasurementTermination._val = 10
    
    #-----< id-paging >-----#
    id_paging = INT(name=u'id-paging', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_paging._val = 11
    
    #-----< id-physicalChannelReconfiguration >-----#
    id_physicalChannelReconfiguration = INT(name=u'id-physicalChannelReconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_physicalChannelReconfiguration._val = 12
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name=u'id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 13
    
    #-----< id-radioLinkAddition >-----#
    id_radioLinkAddition = INT(name=u'id-radioLinkAddition', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkAddition._val = 14
    
    #-----< id-radioLinkCongestion >-----#
    id_radioLinkCongestion = INT(name=u'id-radioLinkCongestion', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkCongestion._val = 34
    
    #-----< id-radioLinkDeletion >-----#
    id_radioLinkDeletion = INT(name=u'id-radioLinkDeletion', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkDeletion._val = 15
    
    #-----< id-radioLinkFailure >-----#
    id_radioLinkFailure = INT(name=u'id-radioLinkFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkFailure._val = 16
    
    #-----< id-radioLinkPreemption >-----#
    id_radioLinkPreemption = INT(name=u'id-radioLinkPreemption', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkPreemption._val = 17
    
    #-----< id-radioLinkRestoration >-----#
    id_radioLinkRestoration = INT(name=u'id-radioLinkRestoration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkRestoration._val = 18
    
    #-----< id-radioLinkSetup >-----#
    id_radioLinkSetup = INT(name=u'id-radioLinkSetup', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkSetup._val = 19
    
    #-----< id-relocationCommit >-----#
    id_relocationCommit = INT(name=u'id-relocationCommit', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_relocationCommit._val = 20
    
    #-----< id-synchronisedRadioLinkReconfigurationCancellation >-----#
    id_synchronisedRadioLinkReconfigurationCancellation = INT(name=u'id-synchronisedRadioLinkReconfigurationCancellation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_synchronisedRadioLinkReconfigurationCancellation._val = 21
    
    #-----< id-synchronisedRadioLinkReconfigurationCommit >-----#
    id_synchronisedRadioLinkReconfigurationCommit = INT(name=u'id-synchronisedRadioLinkReconfigurationCommit', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_synchronisedRadioLinkReconfigurationCommit._val = 22
    
    #-----< id-synchronisedRadioLinkReconfigurationPreparation >-----#
    id_synchronisedRadioLinkReconfigurationPreparation = INT(name=u'id-synchronisedRadioLinkReconfigurationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_synchronisedRadioLinkReconfigurationPreparation._val = 23
    
    #-----< id-unSynchronisedRadioLinkReconfiguration >-----#
    id_unSynchronisedRadioLinkReconfiguration = INT(name=u'id-unSynchronisedRadioLinkReconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_unSynchronisedRadioLinkReconfiguration._val = 24
    
    #-----< id-uplinkSignallingTransfer >-----#
    id_uplinkSignallingTransfer = INT(name=u'id-uplinkSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_uplinkSignallingTransfer._val = 25
    
    #-----< id-commonMeasurementFailure >-----#
    id_commonMeasurementFailure = INT(name=u'id-commonMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementFailure._val = 26
    
    #-----< id-commonMeasurementInitiation >-----#
    id_commonMeasurementInitiation = INT(name=u'id-commonMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementInitiation._val = 27
    
    #-----< id-commonMeasurementReporting >-----#
    id_commonMeasurementReporting = INT(name=u'id-commonMeasurementReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementReporting._val = 28
    
    #-----< id-commonMeasurementTermination >-----#
    id_commonMeasurementTermination = INT(name=u'id-commonMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_commonMeasurementTermination._val = 29
    
    #-----< id-informationExchangeFailure >-----#
    id_informationExchangeFailure = INT(name=u'id-informationExchangeFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_informationExchangeFailure._val = 30
    
    #-----< id-informationExchangeInitiation >-----#
    id_informationExchangeInitiation = INT(name=u'id-informationExchangeInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_informationExchangeInitiation._val = 31
    
    #-----< id-informationReporting >-----#
    id_informationReporting = INT(name=u'id-informationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_informationReporting._val = 32
    
    #-----< id-informationExchangeTermination >-----#
    id_informationExchangeTermination = INT(name=u'id-informationExchangeTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_informationExchangeTermination._val = 33
    
    #-----< id-reset >-----#
    id_reset = INT(name=u'id-reset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_reset._val = 35
    
    #-----< id-radioLinkActivation >-----#
    id_radioLinkActivation = INT(name=u'id-radioLinkActivation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkActivation._val = 36
    
    #-----< id-gERANuplinkSignallingTransfer >-----#
    id_gERANuplinkSignallingTransfer = INT(name=u'id-gERANuplinkSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_gERANuplinkSignallingTransfer._val = 37
    
    #-----< id-radioLinkParameterUpdate >-----#
    id_radioLinkParameterUpdate = INT(name=u'id-radioLinkParameterUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_radioLinkParameterUpdate._val = 38
    
    #-----< id-uEMeasurementFailure >-----#
    id_uEMeasurementFailure = INT(name=u'id-uEMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_uEMeasurementFailure._val = 39
    
    #-----< id-uEMeasurementInitiation >-----#
    id_uEMeasurementInitiation = INT(name=u'id-uEMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_uEMeasurementInitiation._val = 40
    
    #-----< id-uEMeasurementReporting >-----#
    id_uEMeasurementReporting = INT(name=u'id-uEMeasurementReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_uEMeasurementReporting._val = 41
    
    #-----< id-uEMeasurementTermination >-----#
    id_uEMeasurementTermination = INT(name=u'id-uEMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_uEMeasurementTermination._val = 42
    
    #-----< id-iurDeactivateTrace >-----#
    id_iurDeactivateTrace = INT(name=u'id-iurDeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_iurDeactivateTrace._val = 43
    
    #-----< id-iurInvokeTrace >-----#
    id_iurInvokeTrace = INT(name=u'id-iurInvokeTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_iurInvokeTrace._val = 44
    
    #-----< id-mBMSAttach >-----#
    id_mBMSAttach = INT(name=u'id-mBMSAttach', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_mBMSAttach._val = 45
    
    #-----< id-mBMSDetach >-----#
    id_mBMSDetach = INT(name=u'id-mBMSDetach', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_mBMSDetach._val = 46
    
    #-----< id-directInformationTransfer >-----#
    id_directInformationTransfer = INT(name=u'id-directInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_directInformationTransfer._val = 48
    
    #-----< id-enhancedRelocation >-----#
    id_enhancedRelocation = INT(name=u'id-enhancedRelocation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_enhancedRelocation._val = 49
    
    #-----< id-enhancedRelocationCancel >-----#
    id_enhancedRelocationCancel = INT(name=u'id-enhancedRelocationCancel', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_enhancedRelocationCancel._val = 50
    
    #-----< id-enhancedRelocationSignallingTransfer >-----#
    id_enhancedRelocationSignallingTransfer = INT(name=u'id-enhancedRelocationSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_enhancedRelocationSignallingTransfer._val = 51
    
    #-----< id-enhancedRelocationRelease >-----#
    id_enhancedRelocationRelease = INT(name=u'id-enhancedRelocationRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_enhancedRelocationRelease._val = 52
    
    #-----< id-mBSFNMCCHInformation >-----#
    id_mBSFNMCCHInformation = INT(name=u'id-mBSFNMCCHInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_mBSFNMCCHInformation._val = 53
    
    #-----< id-secondaryULFrequencyReporting >-----#
    id_secondaryULFrequencyReporting = INT(name=u'id-secondaryULFrequencyReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_secondaryULFrequencyReporting._val = 54
    
    #-----< id-secondaryULFrequencyUpdate >-----#
    id_secondaryULFrequencyUpdate = INT(name=u'id-secondaryULFrequencyUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_secondaryULFrequencyUpdate._val = 55
    
    #-----< id-informationTransferControl >-----#
    id_informationTransferControl = INT(name=u'id-informationTransferControl', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_informationTransferControl._val = 56
    
    #-----< id-enhancedRelocationResourceAllocation >-----#
    id_enhancedRelocationResourceAllocation = INT(name=u'id-enhancedRelocationResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_enhancedRelocationResourceAllocation._val = 60
    
    #-----< id-enhancedRelocationResourceRelease >-----#
    id_enhancedRelocationResourceRelease = INT(name=u'id-enhancedRelocationResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureCode')))
    id_enhancedRelocationResourceRelease._val = 61
    
    #-----< maxCellSIB11OrSIB12 >-----#
    maxCellSIB11OrSIB12 = INT(name=u'maxCellSIB11OrSIB12', mode=MODE_VALUE)
    maxCellSIB11OrSIB12._val = 32
    
    #-----< maxCellSIB11ter-ext >-----#
    maxCellSIB11ter_ext = INT(name=u'maxCellSIB11ter-ext', mode=MODE_VALUE)
    maxCellSIB11ter_ext._val = 48
    
    #-----< maxCellSIB11ter-1 >-----#
    maxCellSIB11ter_1 = INT(name=u'maxCellSIB11ter-1', mode=MODE_VALUE)
    maxCellSIB11ter_1._val = 79
    
    #-----< maxCellsMeas >-----#
    maxCellsMeas = INT(name=u'maxCellsMeas', mode=MODE_VALUE)
    maxCellsMeas._val = 8
    
    #-----< maxRateMatching >-----#
    maxRateMatching = INT(name=u'maxRateMatching', mode=MODE_VALUE)
    maxRateMatching._val = 256
    
    #-----< maxNoOfDSCHs >-----#
    maxNoOfDSCHs = INT(name=u'maxNoOfDSCHs', mode=MODE_VALUE)
    maxNoOfDSCHs._val = 10
    
    #-----< maxNoOfDSCHsLCR >-----#
    maxNoOfDSCHsLCR = INT(name=u'maxNoOfDSCHsLCR', mode=MODE_VALUE)
    maxNoOfDSCHsLCR._val = 10
    
    #-----< maxNoOfRB >-----#
    maxNoOfRB = INT(name=u'maxNoOfRB', mode=MODE_VALUE)
    maxNoOfRB._val = 32
    
    #-----< maxNoOfUSCHs >-----#
    maxNoOfUSCHs = INT(name=u'maxNoOfUSCHs', mode=MODE_VALUE)
    maxNoOfUSCHs._val = 10
    
    #-----< maxNoOfUSCHsLCR >-----#
    maxNoOfUSCHsLCR = INT(name=u'maxNoOfUSCHsLCR', mode=MODE_VALUE)
    maxNoOfUSCHsLCR._val = 10
    
    #-----< maxNrOfTFCs >-----#
    maxNrOfTFCs = INT(name=u'maxNrOfTFCs', mode=MODE_VALUE)
    maxNrOfTFCs._val = 1024
    
    #-----< maxNrOfTFs >-----#
    maxNrOfTFs = INT(name=u'maxNrOfTFs', mode=MODE_VALUE)
    maxNrOfTFs._val = 32
    
    #-----< maxNrOfCCTrCHs >-----#
    maxNrOfCCTrCHs = INT(name=u'maxNrOfCCTrCHs', mode=MODE_VALUE)
    maxNrOfCCTrCHs._val = 16
    
    #-----< maxNrOfCCTrCHsLCR >-----#
    maxNrOfCCTrCHsLCR = INT(name=u'maxNrOfCCTrCHsLCR', mode=MODE_VALUE)
    maxNrOfCCTrCHsLCR._val = 16
    
    #-----< maxNrOfDCHs >-----#
    maxNrOfDCHs = INT(name=u'maxNrOfDCHs', mode=MODE_VALUE)
    maxNrOfDCHs._val = 128
    
    #-----< maxNrOfDL-Codes >-----#
    maxNrOfDL_Codes = INT(name=u'maxNrOfDL-Codes', mode=MODE_VALUE)
    maxNrOfDL_Codes._val = 8
    
    #-----< maxNrOfDPCHs >-----#
    maxNrOfDPCHs = INT(name=u'maxNrOfDPCHs', mode=MODE_VALUE)
    maxNrOfDPCHs._val = 240
    
    #-----< maxNrOfDPCHsPerRL-1 >-----#
    maxNrOfDPCHsPerRL_1 = INT(name=u'maxNrOfDPCHsPerRL-1', mode=MODE_VALUE)
    maxNrOfDPCHsPerRL_1._val = 239
    
    #-----< maxNrOfDPCHsLCR >-----#
    maxNrOfDPCHsLCR = INT(name=u'maxNrOfDPCHsLCR', mode=MODE_VALUE)
    maxNrOfDPCHsLCR._val = 240
    
    #-----< maxNrOfDPCHsLCRPerRL-1 >-----#
    maxNrOfDPCHsLCRPerRL_1 = INT(name=u'maxNrOfDPCHsLCRPerRL-1', mode=MODE_VALUE)
    maxNrOfDPCHsLCRPerRL_1._val = 95
    
    #-----< maxNrOfDPCHs768 >-----#
    maxNrOfDPCHs768 = INT(name=u'maxNrOfDPCHs768', mode=MODE_VALUE)
    maxNrOfDPCHs768._val = 480
    
    #-----< maxNrOfDPCHs768PerRL-1 >-----#
    maxNrOfDPCHs768PerRL_1 = INT(name=u'maxNrOfDPCHs768PerRL-1', mode=MODE_VALUE)
    maxNrOfDPCHs768PerRL_1._val = 479
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name=u'maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxNrOfMACcshSDU-Length >-----#
    maxNrOfMACcshSDU_Length = INT(name=u'maxNrOfMACcshSDU-Length', mode=MODE_VALUE)
    maxNrOfMACcshSDU_Length._val = 16
    
    #-----< maxNrOfMBMSServices >-----#
    maxNrOfMBMSServices = INT(name=u'maxNrOfMBMSServices', mode=MODE_VALUE)
    maxNrOfMBMSServices._val = 128
    
    #-----< maxNrOfActiveMBMSServices >-----#
    maxNrOfActiveMBMSServices = INT(name=u'maxNrOfActiveMBMSServices', mode=MODE_VALUE)
    maxNrOfActiveMBMSServices._val = 256
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name=u'maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< maxNrOfRLs >-----#
    maxNrOfRLs = INT(name=u'maxNrOfRLs', mode=MODE_VALUE)
    maxNrOfRLs._val = 16
    
    #-----< maxNrOfRLSets >-----#
    maxNrOfRLSets = INT(name=u'maxNrOfRLSets', mode=MODE_VALUE)
    maxNrOfRLSets._val = 16
    
    #-----< maxNrOfRLSets-1 >-----#
    maxNrOfRLSets_1 = INT(name=u'maxNrOfRLSets-1', mode=MODE_VALUE)
    maxNrOfRLSets_1._val = 15
    
    #-----< maxNrOfRLs-1 >-----#
    maxNrOfRLs_1 = INT(name=u'maxNrOfRLs-1', mode=MODE_VALUE)
    maxNrOfRLs_1._val = 15
    
    #-----< maxNrOfRLs-2 >-----#
    maxNrOfRLs_2 = INT(name=u'maxNrOfRLs-2', mode=MODE_VALUE)
    maxNrOfRLs_2._val = 14
    
    #-----< maxNrOfUEs >-----#
    maxNrOfUEs = INT(name=u'maxNrOfUEs', mode=MODE_VALUE)
    maxNrOfUEs._val = 4096
    
    #-----< maxNrOfULTs >-----#
    maxNrOfULTs = INT(name=u'maxNrOfULTs', mode=MODE_VALUE)
    maxNrOfULTs._val = 15
    
    #-----< maxNrOfULTsLCR >-----#
    maxNrOfULTsLCR = INT(name=u'maxNrOfULTsLCR', mode=MODE_VALUE)
    maxNrOfULTsLCR._val = 6
    
    #-----< maxNrOfDLTs >-----#
    maxNrOfDLTs = INT(name=u'maxNrOfDLTs', mode=MODE_VALUE)
    maxNrOfDLTs._val = 15
    
    #-----< maxNrOfDLTsLCR >-----#
    maxNrOfDLTsLCR = INT(name=u'maxNrOfDLTsLCR', mode=MODE_VALUE)
    maxNrOfDLTsLCR._val = 6
    
    #-----< maxRNCinURA-1 >-----#
    maxRNCinURA_1 = INT(name=u'maxRNCinURA-1', mode=MODE_VALUE)
    maxRNCinURA_1._val = 15
    
    #-----< maxTTI-Count >-----#
    maxTTI_Count = INT(name=u'maxTTI-Count', mode=MODE_VALUE)
    maxTTI_Count._val = 4
    
    #-----< maxCTFC >-----#
    maxCTFC = INT(name=u'maxCTFC', mode=MODE_VALUE)
    maxCTFC._val = 16777215
    
    #-----< maxNrOfNeighbouringRNCs >-----#
    maxNrOfNeighbouringRNCs = INT(name=u'maxNrOfNeighbouringRNCs', mode=MODE_VALUE)
    maxNrOfNeighbouringRNCs._val = 10
    
    #-----< maxNrOfFDDNeighboursPerRNC >-----#
    maxNrOfFDDNeighboursPerRNC = INT(name=u'maxNrOfFDDNeighboursPerRNC', mode=MODE_VALUE)
    maxNrOfFDDNeighboursPerRNC._val = 256
    
    #-----< maxNrOfGSMNeighboursPerRNC >-----#
    maxNrOfGSMNeighboursPerRNC = INT(name=u'maxNrOfGSMNeighboursPerRNC', mode=MODE_VALUE)
    maxNrOfGSMNeighboursPerRNC._val = 256
    
    #-----< maxNrOfTDDNeighboursPerRNC >-----#
    maxNrOfTDDNeighboursPerRNC = INT(name=u'maxNrOfTDDNeighboursPerRNC', mode=MODE_VALUE)
    maxNrOfTDDNeighboursPerRNC._val = 256
    
    #-----< maxNrOfFACHs >-----#
    maxNrOfFACHs = INT(name=u'maxNrOfFACHs', mode=MODE_VALUE)
    maxNrOfFACHs._val = 8
    
    #-----< maxNrOfLCRTDDNeighboursPerRNC >-----#
    maxNrOfLCRTDDNeighboursPerRNC = INT(name=u'maxNrOfLCRTDDNeighboursPerRNC', mode=MODE_VALUE)
    maxNrOfLCRTDDNeighboursPerRNC._val = 256
    
    #-----< maxIBSEG >-----#
    maxIBSEG = INT(name=u'maxIBSEG', mode=MODE_VALUE)
    maxIBSEG._val = 16
    
    #-----< maxNrOfSCCPCHs >-----#
    maxNrOfSCCPCHs = INT(name=u'maxNrOfSCCPCHs', mode=MODE_VALUE)
    maxNrOfSCCPCHs._val = 8
    
    #-----< maxNrOfSCCPCHs768 >-----#
    maxNrOfSCCPCHs768 = INT(name=u'maxNrOfSCCPCHs768', mode=MODE_VALUE)
    maxNrOfSCCPCHs768._val = 16
    
    #-----< maxTGPS >-----#
    maxTGPS = INT(name=u'maxTGPS', mode=MODE_VALUE)
    maxTGPS._val = 6
    
    #-----< maxNrOfTS >-----#
    maxNrOfTS = INT(name=u'maxNrOfTS', mode=MODE_VALUE)
    maxNrOfTS._val = 15
    
    #-----< maxNrOfLevels >-----#
    maxNrOfLevels = INT(name=u'maxNrOfLevels', mode=MODE_VALUE)
    maxNrOfLevels._val = 256
    
    #-----< maxNrOfTsLCR >-----#
    maxNrOfTsLCR = INT(name=u'maxNrOfTsLCR', mode=MODE_VALUE)
    maxNrOfTsLCR._val = 6
    
    #-----< maxNoSat >-----#
    maxNoSat = INT(name=u'maxNoSat', mode=MODE_VALUE)
    maxNoSat._val = 16
    
    #-----< maxNoGPSTypes >-----#
    maxNoGPSTypes = INT(name=u'maxNoGPSTypes', mode=MODE_VALUE)
    maxNoGPSTypes._val = 8
    
    #-----< maxNrOfMeasNCell >-----#
    maxNrOfMeasNCell = INT(name=u'maxNrOfMeasNCell', mode=MODE_VALUE)
    maxNrOfMeasNCell._val = 96
    
    #-----< maxNrOfMeasNCell-1 >-----#
    maxNrOfMeasNCell_1 = INT(name=u'maxNrOfMeasNCell-1', mode=MODE_VALUE)
    maxNrOfMeasNCell_1._val = 95
    
    #-----< maxResetContext >-----#
    maxResetContext = INT(name=u'maxResetContext', mode=MODE_VALUE)
    maxResetContext._val = 250
    
    #-----< maxResetContextGroup >-----#
    maxResetContextGroup = INT(name=u'maxResetContextGroup', mode=MODE_VALUE)
    maxResetContextGroup._val = 32
    
    #-----< maxNrOfHARQProc >-----#
    maxNrOfHARQProc = INT(name=u'maxNrOfHARQProc', mode=MODE_VALUE)
    maxNrOfHARQProc._val = 8
    
    #-----< maxNrOfHSSCCHCodes >-----#
    maxNrOfHSSCCHCodes = INT(name=u'maxNrOfHSSCCHCodes', mode=MODE_VALUE)
    maxNrOfHSSCCHCodes._val = 4
    
    #-----< maxNrOfHSSICHs >-----#
    maxNrOfHSSICHs = INT(name=u'maxNrOfHSSICHs', mode=MODE_VALUE)
    maxNrOfHSSICHs._val = 4
    
    #-----< maxNrOfHSSICHs-1 >-----#
    maxNrOfHSSICHs_1 = INT(name=u'maxNrOfHSSICHs-1', mode=MODE_VALUE)
    maxNrOfHSSICHs_1._val = 3
    
    #-----< maxNrOfMACdFlows >-----#
    maxNrOfMACdFlows = INT(name=u'maxNrOfMACdFlows', mode=MODE_VALUE)
    maxNrOfMACdFlows._val = 8
    
    #-----< maxNrOfMACdFlows-1 >-----#
    maxNrOfMACdFlows_1 = INT(name=u'maxNrOfMACdFlows-1', mode=MODE_VALUE)
    maxNrOfMACdFlows_1._val = 7
    
    #-----< maxNrOfMACdPDUSize >-----#
    maxNrOfMACdPDUSize = INT(name=u'maxNrOfMACdPDUSize', mode=MODE_VALUE)
    maxNrOfMACdPDUSize._val = 32
    
    #-----< maxNrOfPDUIndexes >-----#
    maxNrOfPDUIndexes = INT(name=u'maxNrOfPDUIndexes', mode=MODE_VALUE)
    maxNrOfPDUIndexes._val = 8
    
    #-----< maxNrOfPDUIndexes-1 >-----#
    maxNrOfPDUIndexes_1 = INT(name=u'maxNrOfPDUIndexes-1', mode=MODE_VALUE)
    maxNrOfPDUIndexes_1._val = 7
    
    #-----< maxNrOfPrioQueues >-----#
    maxNrOfPrioQueues = INT(name=u'maxNrOfPrioQueues', mode=MODE_VALUE)
    maxNrOfPrioQueues._val = 8
    
    #-----< maxNrOfPrioQueues-1 >-----#
    maxNrOfPrioQueues_1 = INT(name=u'maxNrOfPrioQueues-1', mode=MODE_VALUE)
    maxNrOfPrioQueues_1._val = 7
    
    #-----< maxNrOfSNAs >-----#
    maxNrOfSNAs = INT(name=u'maxNrOfSNAs', mode=MODE_VALUE)
    maxNrOfSNAs._val = 65536
    
    #-----< maxNrOfSatAlmanac-maxNoSat >-----#
    maxNrOfSatAlmanac_maxNoSat = INT(name=u'maxNrOfSatAlmanac-maxNoSat', mode=MODE_VALUE)
    maxNrOfSatAlmanac_maxNoSat._val = 16
    
    #-----< maxNrOfGERANSI >-----#
    maxNrOfGERANSI = INT(name=u'maxNrOfGERANSI', mode=MODE_VALUE)
    maxNrOfGERANSI._val = 8
    
    #-----< maxNrOfInterfaces >-----#
    maxNrOfInterfaces = INT(name=u'maxNrOfInterfaces', mode=MODE_VALUE)
    maxNrOfInterfaces._val = 16
    
    #-----< maxNrofSigSeqERGHICH-1 >-----#
    maxNrofSigSeqERGHICH_1 = INT(name=u'maxNrofSigSeqERGHICH-1', mode=MODE_VALUE)
    maxNrofSigSeqERGHICH_1._val = 39
    
    #-----< maxNrOfCells >-----#
    maxNrOfCells = INT(name=u'maxNrOfCells', mode=MODE_VALUE)
    maxNrOfCells._val = 65536
    
    #-----< maxNrOfAddFreq >-----#
    maxNrOfAddFreq = INT(name=u'maxNrOfAddFreq', mode=MODE_VALUE)
    maxNrOfAddFreq._val = 8
    
    #-----< maxNrOfCellsPerFreq >-----#
    maxNrOfCellsPerFreq = INT(name=u'maxNrOfCellsPerFreq', mode=MODE_VALUE)
    maxNrOfCellsPerFreq._val = 65536
    
    #-----< maxNrOfEDCHMACdFlows-1 >-----#
    maxNrOfEDCHMACdFlows_1 = INT(name=u'maxNrOfEDCHMACdFlows-1', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlows_1._val = 7
    
    #-----< maxNrOfEDCH-HARQ-PO-QUANTSTEPs >-----#
    maxNrOfEDCH_HARQ_PO_QUANTSTEPs = INT(name=u'maxNrOfEDCH-HARQ-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfEDCH_HARQ_PO_QUANTSTEPs._val = 6
    
    #-----< maxNrOfEDPCCH-PO-QUANTSTEPs >-----#
    maxNrOfEDPCCH_PO_QUANTSTEPs = INT(name=u'maxNrOfEDPCCH-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfEDPCCH_PO_QUANTSTEPs._val = 8
    
    #-----< maxNrOfEDCHHARQProcesses2msEDCH >-----#
    maxNrOfEDCHHARQProcesses2msEDCH = INT(name=u'maxNrOfEDCHHARQProcesses2msEDCH', mode=MODE_VALUE)
    maxNrOfEDCHHARQProcesses2msEDCH._val = 8
    
    #-----< maxNrOfBits-MACe-PDU-non-scheduled >-----#
    maxNrOfBits_MACe_PDU_non_scheduled = INT(name=u'maxNrOfBits-MACe-PDU-non-scheduled', mode=MODE_VALUE)
    maxNrOfBits_MACe_PDU_non_scheduled._val = 19982
    
    #-----< maxNrOfRefETFCIs >-----#
    maxNrOfRefETFCIs = INT(name=u'maxNrOfRefETFCIs', mode=MODE_VALUE)
    maxNrOfRefETFCIs._val = 8
    
    #-----< maxNrOfRefETFCI-PO-QUANTSTEPs >-----#
    maxNrOfRefETFCI_PO_QUANTSTEPs = INT(name=u'maxNrOfRefETFCI-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfRefETFCI_PO_QUANTSTEPs._val = 29
    
    #-----< maxNrOfEDCHMACdFlows >-----#
    maxNrOfEDCHMACdFlows = INT(name=u'maxNrOfEDCHMACdFlows', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlows._val = 8
    
    #-----< maxNoOfLogicalChannels >-----#
    maxNoOfLogicalChannels = INT(name=u'maxNoOfLogicalChannels', mode=MODE_VALUE)
    maxNoOfLogicalChannels._val = 16
    
    #-----< maxNrOfRefBetas >-----#
    maxNrOfRefBetas = INT(name=u'maxNrOfRefBetas', mode=MODE_VALUE)
    maxNrOfRefBetas._val = 8
    
    #-----< maxNrOfEAGCHCodes >-----#
    maxNrOfEAGCHCodes = INT(name=u'maxNrOfEAGCHCodes', mode=MODE_VALUE)
    maxNrOfEAGCHCodes._val = 4
    
    #-----< maxNrOfHS-DSCHTBSs >-----#
    maxNrOfHS_DSCHTBSs = INT(name=u'maxNrOfHS-DSCHTBSs', mode=MODE_VALUE)
    maxNrOfHS_DSCHTBSs._val = 90
    
    #-----< maxNrOfHS-DSCHTBSs-HS-SCCHless >-----#
    maxNrOfHS_DSCHTBSs_HS_SCCHless = INT(name=u'maxNrOfHS-DSCHTBSs-HS-SCCHless', mode=MODE_VALUE)
    maxNrOfHS_DSCHTBSs_HS_SCCHless._val = 4
    
    #-----< maxHS-PDSCHCodeNrComp-1 >-----#
    maxHS_PDSCHCodeNrComp_1 = INT(name=u'maxHS-PDSCHCodeNrComp-1', mode=MODE_VALUE)
    maxHS_PDSCHCodeNrComp_1._val = 15
    
    #-----< maxNrOfEHICHCodes >-----#
    maxNrOfEHICHCodes = INT(name=u'maxNrOfEHICHCodes', mode=MODE_VALUE)
    maxNrOfEHICHCodes._val = 4
    
    #-----< maxGANSSSat >-----#
    maxGANSSSat = INT(name=u'maxGANSSSat', mode=MODE_VALUE)
    maxGANSSSat._val = 64
    
    #-----< maxNoGANSS >-----#
    maxNoGANSS = INT(name=u'maxNoGANSS', mode=MODE_VALUE)
    maxNoGANSS._val = 8
    
    #-----< maxSgnType >-----#
    maxSgnType = INT(name=u'maxSgnType', mode=MODE_VALUE)
    maxSgnType._val = 8
    
    #-----< maxNrOfBroadcastPLMNs >-----#
    maxNrOfBroadcastPLMNs = INT(name=u'maxNrOfBroadcastPLMNs', mode=MODE_VALUE)
    maxNrOfBroadcastPLMNs._val = 5
    
    #-----< maxHSDPAFrequency >-----#
    maxHSDPAFrequency = INT(name=u'maxHSDPAFrequency', mode=MODE_VALUE)
    maxHSDPAFrequency._val = 8
    
    #-----< maxHSDPAFrequency-1 >-----#
    maxHSDPAFrequency_1 = INT(name=u'maxHSDPAFrequency-1', mode=MODE_VALUE)
    maxHSDPAFrequency_1._val = 7
    
    #-----< maxFrequencyinCell >-----#
    maxFrequencyinCell = INT(name=u'maxFrequencyinCell', mode=MODE_VALUE)
    maxFrequencyinCell._val = 12
    
    #-----< maxFrequencyinCell-1 >-----#
    maxFrequencyinCell_1 = INT(name=u'maxFrequencyinCell-1', mode=MODE_VALUE)
    maxFrequencyinCell_1._val = 11
    
    #-----< maxGANSSSatAlmanac >-----#
    maxGANSSSatAlmanac = INT(name=u'maxGANSSSatAlmanac', mode=MODE_VALUE)
    maxGANSSSatAlmanac._val = 36
    
    #-----< maxGANSSClockMod >-----#
    maxGANSSClockMod = INT(name=u'maxGANSSClockMod', mode=MODE_VALUE)
    maxGANSSClockMod._val = 4
    
    #-----< maxNrOfEDCHRLs >-----#
    maxNrOfEDCHRLs = INT(name=u'maxNrOfEDCHRLs', mode=MODE_VALUE)
    maxNrOfEDCHRLs._val = 4
    
    #-----< maxEARFCN >-----#
    maxEARFCN = INT(name=u'maxEARFCN', mode=MODE_VALUE)
    maxEARFCN._val = 65535
    
    #-----< maxEARFCN-Extended >-----#
    maxEARFCN_Extended = INT(name=u'maxEARFCN-Extended', mode=MODE_VALUE)
    maxEARFCN_Extended._val = 262143
    
    #-----< maxNrOfEUTRANeighboursPerRNC >-----#
    maxNrOfEUTRANeighboursPerRNC = INT(name=u'maxNrOfEUTRANeighboursPerRNC', mode=MODE_VALUE)
    maxNrOfEUTRANeighboursPerRNC._val = 256
    
    #-----< maxNrOfMCCHMessages >-----#
    maxNrOfMCCHMessages = INT(name=u'maxNrOfMCCHMessages', mode=MODE_VALUE)
    maxNrOfMCCHMessages._val = 5
    
    #-----< maxNrOfMBMSL3 >-----#
    maxNrOfMBMSL3 = INT(name=u'maxNrOfMBMSL3', mode=MODE_VALUE)
    maxNrOfMBMSL3._val = 64
    
    #-----< maxNrOfEDCHMACdFlowsLCR >-----#
    maxNrOfEDCHMACdFlowsLCR = INT(name=u'maxNrOfEDCHMACdFlowsLCR', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlowsLCR._val = 256
    
    #-----< maxNrOfEDCHMACdFlowsLCR-1 >-----#
    maxNrOfEDCHMACdFlowsLCR_1 = INT(name=u'maxNrOfEDCHMACdFlowsLCR-1', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlowsLCR_1._val = 255
    
    #-----< maxNrOfPreconfiguredNeighbours >-----#
    maxNrOfPreconfiguredNeighbours = INT(name=u'maxNrOfPreconfiguredNeighbours', mode=MODE_VALUE)
    maxNrOfPreconfiguredNeighbours._val = 256
    
    #-----< maxNrOfHSDSCH-1 >-----#
    maxNrOfHSDSCH_1 = INT(name=u'maxNrOfHSDSCH-1', mode=MODE_VALUE)
    maxNrOfHSDSCH_1._val = 32
    
    #-----< maxNrOfHSDSCH >-----#
    maxNrOfHSDSCH = INT(name=u'maxNrOfHSDSCH', mode=MODE_VALUE)
    maxNrOfHSDSCH._val = 33
    
    #-----< maxGANSS-1 >-----#
    maxGANSS_1 = INT(name=u'maxGANSS-1', mode=MODE_VALUE)
    maxGANSS_1._val = 7
    
    #-----< maxlengthMBMSconcatservlists >-----#
    maxlengthMBMSconcatservlists = INT(name=u'maxlengthMBMSconcatservlists', mode=MODE_VALUE)
    maxlengthMBMSconcatservlists._val = 96
    
    #-----< maxNoOfTBSs-Mapping-HS-DSCH-SPS >-----#
    maxNoOfTBSs_Mapping_HS_DSCH_SPS = INT(name=u'maxNoOfTBSs-Mapping-HS-DSCH-SPS', mode=MODE_VALUE)
    maxNoOfTBSs_Mapping_HS_DSCH_SPS._val = 4
    
    #-----< maxNoOfTBSs-Mapping-HS-DSCH-SPS-1 >-----#
    maxNoOfTBSs_Mapping_HS_DSCH_SPS_1 = INT(name=u'maxNoOfTBSs-Mapping-HS-DSCH-SPS-1', mode=MODE_VALUE)
    maxNoOfTBSs_Mapping_HS_DSCH_SPS_1._val = 3
    
    #-----< maxNoOfHS-DSCH-TBSsLCR >-----#
    maxNoOfHS_DSCH_TBSsLCR = INT(name=u'maxNoOfHS-DSCH-TBSsLCR', mode=MODE_VALUE)
    maxNoOfHS_DSCH_TBSsLCR._val = 64
    
    #-----< maxNoOfRepetition-Period-LCR >-----#
    maxNoOfRepetition_Period_LCR = INT(name=u'maxNoOfRepetition-Period-LCR', mode=MODE_VALUE)
    maxNoOfRepetition_Period_LCR._val = 4
    
    #-----< maxNoOfRepetitionPeriod-SPS-LCR-1 >-----#
    maxNoOfRepetitionPeriod_SPS_LCR_1 = INT(name=u'maxNoOfRepetitionPeriod-SPS-LCR-1', mode=MODE_VALUE)
    maxNoOfRepetitionPeriod_SPS_LCR_1._val = 3
    
    #-----< maxNoOf-HS-SICH-SPS >-----#
    maxNoOf_HS_SICH_SPS = INT(name=u'maxNoOf-HS-SICH-SPS', mode=MODE_VALUE)
    maxNoOf_HS_SICH_SPS._val = 4
    
    #-----< maxNoOf-HS-SICH-SPS-1 >-----#
    maxNoOf_HS_SICH_SPS_1 = INT(name=u'maxNoOf-HS-SICH-SPS-1', mode=MODE_VALUE)
    maxNoOf_HS_SICH_SPS_1._val = 3
    
    #-----< maxNoOfNon-HS-SCCH-Assosiated-HS-SICH >-----#
    maxNoOfNon_HS_SCCH_Assosiated_HS_SICH = INT(name=u'maxNoOfNon-HS-SCCH-Assosiated-HS-SICH', mode=MODE_VALUE)
    maxNoOfNon_HS_SCCH_Assosiated_HS_SICH._val = 4
    
    #-----< maxNrOfEDCH-1 >-----#
    maxNrOfEDCH_1 = INT(name=u'maxNrOfEDCH-1', mode=MODE_VALUE)
    maxNrOfEDCH_1._val = 32
    
    #-----< maxNrOfDCHMeasurementOccasionPatternSequence >-----#
    maxNrOfDCHMeasurementOccasionPatternSequence = INT(name=u'maxNrOfDCHMeasurementOccasionPatternSequence', mode=MODE_VALUE)
    maxNrOfDCHMeasurementOccasionPatternSequence._val = 6
    
    #-----< maxNrOfULCarriersLCR-1 >-----#
    maxNrOfULCarriersLCR_1 = INT(name=u'maxNrOfULCarriersLCR-1', mode=MODE_VALUE)
    maxNrOfULCarriersLCR_1._val = 5
    
    #-----< maxNrOfCellIds >-----#
    maxNrOfCellIds = INT(name=u'maxNrOfCellIds', mode=MODE_VALUE)
    maxNrOfCellIds._val = 32
    
    #-----< maxNrOfRAIs >-----#
    maxNrOfRAIs = INT(name=u'maxNrOfRAIs', mode=MODE_VALUE)
    maxNrOfRAIs._val = 8
    
    #-----< maxNrOfLAIs >-----#
    maxNrOfLAIs = INT(name=u'maxNrOfLAIs', mode=MODE_VALUE)
    maxNrOfLAIs._val = 8
    
    #-----< maxNrOfExtendedNeighbouringRNCs >-----#
    maxNrOfExtendedNeighbouringRNCs = INT(name=u'maxNrOfExtendedNeighbouringRNCs', mode=MODE_VALUE)
    maxNrOfExtendedNeighbouringRNCs._val = 64
    
    #-----< maxNoOfGsmCell >-----#
    maxNoOfGsmCell = INT(name=u'maxNoOfGsmCell', mode=MODE_VALUE)
    maxNoOfGsmCell._val = 128
    
    #-----< maxNrOfANRCells >-----#
    maxNrOfANRCells = INT(name=u'maxNrOfANRCells', mode=MODE_VALUE)
    maxNrOfANRCells._val = 256
    
    #-----< maxFreqBandsTDD >-----#
    maxFreqBandsTDD = INT(name=u'maxFreqBandsTDD', mode=MODE_VALUE)
    maxFreqBandsTDD._val = 16
    
    #-----< maxSCPICHCell >-----#
    maxSCPICHCell = INT(name=u'maxSCPICHCell', mode=MODE_VALUE)
    maxSCPICHCell._val = 32
    
    #-----< maxSCPICHCell-1 >-----#
    maxSCPICHCell_1 = INT(name=u'maxSCPICHCell-1', mode=MODE_VALUE)
    maxSCPICHCell_1._val = 31
    
    #-----< maxNoOfCommonRGCells >-----#
    maxNoOfCommonRGCells = INT(name=u'maxNoOfCommonRGCells', mode=MODE_VALUE)
    maxNoOfCommonRGCells._val = 256
    
    #-----< maxIGPInfo >-----#
    maxIGPInfo = INT(name=u'maxIGPInfo', mode=MODE_VALUE)
    maxIGPInfo._val = 320
    
    #-----< maxNrofConcatenatedDCH >-----#
    maxNrofConcatenatedDCH = INT(name=u'maxNrofConcatenatedDCH', mode=MODE_VALUE)
    maxNrofConcatenatedDCH._val = 3
    
    #-----< maxMultipleFrequencyBands >-----#
    maxMultipleFrequencyBands = INT(name=u'maxMultipleFrequencyBands', mode=MODE_VALUE)
    maxMultipleFrequencyBands._val = 8
    
    #-----< maxMultipleFrequencyBandsEUTRA >-----#
    maxMultipleFrequencyBandsEUTRA = INT(name=u'maxMultipleFrequencyBandsEUTRA', mode=MODE_VALUE)
    maxMultipleFrequencyBandsEUTRA._val = 8
    
    #-----< id-AllowedQueuingTime >-----#
    id_AllowedQueuingTime = INT(name=u'id-AllowedQueuingTime', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AllowedQueuingTime._val = 4
    
    #-----< id-Allowed-Rate-Information >-----#
    id_Allowed_Rate_Information = INT(name=u'id-Allowed-Rate-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Allowed_Rate_Information._val = 42
    
    #-----< id-AntennaColocationIndicator >-----#
    id_AntennaColocationIndicator = INT(name=u'id-AntennaColocationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AntennaColocationIndicator._val = 309
    
    #-----< id-BindingID >-----#
    id_BindingID = INT(name=u'id-BindingID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BindingID._val = 5
    
    #-----< id-C-ID >-----#
    id_C_ID = INT(name=u'id-C-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_C_ID._val = 6
    
    #-----< id-C-RNTI >-----#
    id_C_RNTI = INT(name=u'id-C-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_C_RNTI._val = 7
    
    #-----< id-Cell-Capacity-Class-Value >-----#
    id_Cell_Capacity_Class_Value = INT(name=u'id-Cell-Capacity-Class-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cell_Capacity_Class_Value._val = 303
    
    #-----< id-CFN >-----#
    id_CFN = INT(name=u'id-CFN', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CFN._val = 8
    
    #-----< id-CN-CS-DomainIdentifier >-----#
    id_CN_CS_DomainIdentifier = INT(name=u'id-CN-CS-DomainIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CN_CS_DomainIdentifier._val = 9
    
    #-----< id-CN-PS-DomainIdentifier >-----#
    id_CN_PS_DomainIdentifier = INT(name=u'id-CN-PS-DomainIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CN_PS_DomainIdentifier._val = 10
    
    #-----< id-Cause >-----#
    id_Cause = INT(name=u'id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 11
    
    #-----< id-CoverageIndicator >-----#
    id_CoverageIndicator = INT(name=u'id-CoverageIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CoverageIndicator._val = 310
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name=u'id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 20
    
    #-----< id-ContextInfoItem-Reset >-----#
    id_ContextInfoItem_Reset = INT(name=u'id-ContextInfoItem-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContextInfoItem_Reset._val = 211
    
    #-----< id-ContextGroupInfoItem-Reset >-----#
    id_ContextGroupInfoItem_Reset = INT(name=u'id-ContextGroupInfoItem-Reset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContextGroupInfoItem_Reset._val = 515
    
    #-----< id-D-RNTI >-----#
    id_D_RNTI = INT(name=u'id-D-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_D_RNTI._val = 21
    
    #-----< id-D-RNTI-ReleaseIndication >-----#
    id_D_RNTI_ReleaseIndication = INT(name=u'id-D-RNTI-ReleaseIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_D_RNTI_ReleaseIndication._val = 22
    
    #-----< id-DCHs-to-Add-FDD >-----#
    id_DCHs_to_Add_FDD = INT(name=u'id-DCHs-to-Add-FDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCHs_to_Add_FDD._val = 26
    
    #-----< id-DCHs-to-Add-TDD >-----#
    id_DCHs_to_Add_TDD = INT(name=u'id-DCHs-to-Add-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCHs_to_Add_TDD._val = 27
    
    #-----< id-DCH-DeleteList-RL-ReconfPrepFDD >-----#
    id_DCH_DeleteList_RL_ReconfPrepFDD = INT(name=u'id-DCH-DeleteList-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfPrepFDD._val = 30
    
    #-----< id-DCH-DeleteList-RL-ReconfPrepTDD >-----#
    id_DCH_DeleteList_RL_ReconfPrepTDD = INT(name=u'id-DCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfPrepTDD._val = 31
    
    #-----< id-DCH-DeleteList-RL-ReconfRqstFDD >-----#
    id_DCH_DeleteList_RL_ReconfRqstFDD = INT(name=u'id-DCH-DeleteList-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfRqstFDD._val = 32
    
    #-----< id-DCH-DeleteList-RL-ReconfRqstTDD >-----#
    id_DCH_DeleteList_RL_ReconfRqstTDD = INT(name=u'id-DCH-DeleteList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_DeleteList_RL_ReconfRqstTDD._val = 33
    
    #-----< id-DCH-FDD-Information >-----#
    id_DCH_FDD_Information = INT(name=u'id-DCH-FDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_FDD_Information._val = 34
    
    #-----< id-DCH-TDD-Information >-----#
    id_DCH_TDD_Information = INT(name=u'id-DCH-TDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_TDD_Information._val = 35
    
    #-----< id-FDD-DCHs-to-Modify >-----#
    id_FDD_DCHs_to_Modify = INT(name=u'id-FDD-DCHs-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FDD_DCHs_to_Modify._val = 39
    
    #-----< id-TDD-DCHs-to-Modify >-----#
    id_TDD_DCHs_to_Modify = INT(name=u'id-TDD-DCHs-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_DCHs_to_Modify._val = 40
    
    #-----< id-DCH-InformationResponse >-----#
    id_DCH_InformationResponse = INT(name=u'id-DCH-InformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_InformationResponse._val = 43
    
    #-----< id-DCH-Rate-InformationItem-RL-CongestInd >-----#
    id_DCH_Rate_InformationItem_RL_CongestInd = INT(name=u'id-DCH-Rate-InformationItem-RL-CongestInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_Rate_InformationItem_RL_CongestInd._val = 38
    
    #-----< id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD = INT(name=u'id-DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._val = 44
    
    #-----< id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD >-----#
    id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD = INT(name=u'id-DL-CCTrCH-InformationListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD._val = 45
    
    #-----< id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = INT(name=u'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._val = 46
    
    #-----< id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD = INT(name=u'id-DL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD._val = 47
    
    #-----< id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = INT(name=u'id-DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD._val = 48
    
    #-----< id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD >-----#
    id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD = INT(name=u'id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD._val = 49
    
    #-----< id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD >-----#
    id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD = INT(name=u'id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD._val = 50
    
    #-----< id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = INT(name=u'id-DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._val = 51
    
    #-----< id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = INT(name=u'id-DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._val = 52
    
    #-----< id-DL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    id_DL_CCTrCH_InformationList_RL_SetupRqstTDD = INT(name=u'id-DL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationList_RL_SetupRqstTDD._val = 53
    
    #-----< id-FDD-DL-CodeInformation >-----#
    id_FDD_DL_CodeInformation = INT(name=u'id-FDD-DL-CodeInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FDD_DL_CodeInformation._val = 54
    
    #-----< id-DL-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_DL_DPCH_Information_RL_ReconfPrepFDD = INT(name=u'id-DL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Information_RL_ReconfPrepFDD._val = 59
    
    #-----< id-DL-DPCH-Information-RL-SetupRqstFDD >-----#
    id_DL_DPCH_Information_RL_SetupRqstFDD = INT(name=u'id-DL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Information_RL_SetupRqstFDD._val = 60
    
    #-----< id-DL-DPCH-Information-RL-ReconfRqstFDD >-----#
    id_DL_DPCH_Information_RL_ReconfRqstFDD = INT(name=u'id-DL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Information_RL_ReconfRqstFDD._val = 61
    
    #-----< id-DL-DPCH-InformationItem-PhyChReconfRqstTDD >-----#
    id_DL_DPCH_InformationItem_PhyChReconfRqstTDD = INT(name=u'id-DL-DPCH-InformationItem-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_PhyChReconfRqstTDD._val = 62
    
    #-----< id-DL-DPCH-InformationItem-RL-AdditionRspTDD >-----#
    id_DL_DPCH_InformationItem_RL_AdditionRspTDD = INT(name=u'id-DL-DPCH-InformationItem-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_RL_AdditionRspTDD._val = 63
    
    #-----< id-DL-DPCH-InformationItem-RL-SetupRspTDD >-----#
    id_DL_DPCH_InformationItem_RL_SetupRspTDD = INT(name=u'id-DL-DPCH-InformationItem-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_RL_SetupRspTDD._val = 64
    
    #-----< id-DL-DPCH-TimingAdjustment >-----#
    id_DL_DPCH_TimingAdjustment = INT(name=u'id-DL-DPCH-TimingAdjustment', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_TimingAdjustment._val = 278
    
    #-----< id-DLReferencePower >-----#
    id_DLReferencePower = INT(name=u'id-DLReferencePower', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLReferencePower._val = 67
    
    #-----< id-DLReferencePowerList-DL-PC-Rqst >-----#
    id_DLReferencePowerList_DL_PC_Rqst = INT(name=u'id-DLReferencePowerList-DL-PC-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DLReferencePowerList_DL_PC_Rqst._val = 68
    
    #-----< id-DL-ReferencePowerInformation-DL-PC-Rqst >-----#
    id_DL_ReferencePowerInformation_DL_PC_Rqst = INT(name=u'id-DL-ReferencePowerInformation-DL-PC-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_ReferencePowerInformation_DL_PC_Rqst._val = 69
    
    #-----< id-DPC-Mode >-----#
    id_DPC_Mode = INT(name=u'id-DPC-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPC_Mode._val = 12
    
    #-----< id-DRXCycleLengthCoefficient >-----#
    id_DRXCycleLengthCoefficient = INT(name=u'id-DRXCycleLengthCoefficient', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DRXCycleLengthCoefficient._val = 70
    
    #-----< id-DedicatedMeasurementObjectType-DM-Fail-Ind >-----#
    id_DedicatedMeasurementObjectType_DM_Fail_Ind = INT(name=u'id-DedicatedMeasurementObjectType-DM-Fail-Ind', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Fail_Ind._val = 470
    
    #-----< id-DedicatedMeasurementObjectType-DM-Fail >-----#
    id_DedicatedMeasurementObjectType_DM_Fail = INT(name=u'id-DedicatedMeasurementObjectType-DM-Fail', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Fail._val = 471
    
    #-----< id-DedicatedMeasurementObjectType-DM-Rprt >-----#
    id_DedicatedMeasurementObjectType_DM_Rprt = INT(name=u'id-DedicatedMeasurementObjectType-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Rprt._val = 71
    
    #-----< id-DedicatedMeasurementObjectType-DM-Rqst >-----#
    id_DedicatedMeasurementObjectType_DM_Rqst = INT(name=u'id-DedicatedMeasurementObjectType-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Rqst._val = 72
    
    #-----< id-DedicatedMeasurementObjectType-DM-Rsp >-----#
    id_DedicatedMeasurementObjectType_DM_Rsp = INT(name=u'id-DedicatedMeasurementObjectType-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementObjectType_DM_Rsp._val = 73
    
    #-----< id-DedicatedMeasurementType >-----#
    id_DedicatedMeasurementType = INT(name=u'id-DedicatedMeasurementType', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DedicatedMeasurementType._val = 74
    
    #-----< id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD >-----#
    id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD = INT(name=u'id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD._val = 82
    
    #-----< id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD >-----#
    id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD = INT(name=u'id-FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD._val = 83
    
    #-----< id-Guaranteed-Rate-Information >-----#
    id_Guaranteed_Rate_Information = INT(name=u'id-Guaranteed-Rate-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Guaranteed_Rate_Information._val = 41
    
    #-----< id-IMSI >-----#
    id_IMSI = INT(name=u'id-IMSI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSI._val = 84
    
    #-----< id-HCS-Prio >-----#
    id_HCS_Prio = INT(name=u'id-HCS-Prio', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HCS_Prio._val = 311
    
    #-----< id-L3-Information >-----#
    id_L3_Information = INT(name=u'id-L3-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_L3_Information._val = 85
    
    #-----< id-AdjustmentPeriod >-----#
    id_AdjustmentPeriod = INT(name=u'id-AdjustmentPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdjustmentPeriod._val = 90
    
    #-----< id-MaxAdjustmentStep >-----#
    id_MaxAdjustmentStep = INT(name=u'id-MaxAdjustmentStep', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaxAdjustmentStep._val = 91
    
    #-----< id-MeasurementFilterCoefficient >-----#
    id_MeasurementFilterCoefficient = INT(name=u'id-MeasurementFilterCoefficient', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementFilterCoefficient._val = 92
    
    #-----< id-MessageStructure >-----#
    id_MessageStructure = INT(name=u'id-MessageStructure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MessageStructure._val = 57
    
    #-----< id-MeasurementID >-----#
    id_MeasurementID = INT(name=u'id-MeasurementID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementID._val = 93
    
    #-----< id-Neighbouring-GSM-CellInformation >-----#
    id_Neighbouring_GSM_CellInformation = INT(name=u'id-Neighbouring-GSM-CellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbouring_GSM_CellInformation._val = 13
    
    #-----< id-Neighbouring-UMTS-CellInformationItem >-----#
    id_Neighbouring_UMTS_CellInformationItem = INT(name=u'id-Neighbouring-UMTS-CellInformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbouring_UMTS_CellInformationItem._val = 95
    
    #-----< id-NRT-Load-Information-Value >-----#
    id_NRT_Load_Information_Value = INT(name=u'id-NRT-Load-Information-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRT_Load_Information_Value._val = 305
    
    #-----< id-NRT-Load-Information-Value-IncrDecrThres >-----#
    id_NRT_Load_Information_Value_IncrDecrThres = INT(name=u'id-NRT-Load-Information-Value-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRT_Load_Information_Value_IncrDecrThres._val = 306
    
    #-----< id-PagingArea-PagingRqst >-----#
    id_PagingArea_PagingRqst = INT(name=u'id-PagingArea-PagingRqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PagingArea_PagingRqst._val = 102
    
    #-----< id-FACH-FlowControlInformation >-----#
    id_FACH_FlowControlInformation = INT(name=u'id-FACH-FlowControlInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FACH_FlowControlInformation._val = 103
    
    #-----< id-PartialReportingIndicator >-----#
    id_PartialReportingIndicator = INT(name=u'id-PartialReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PartialReportingIndicator._val = 472
    
    #-----< id-Permanent-NAS-UE-Identity >-----#
    id_Permanent_NAS_UE_Identity = INT(name=u'id-Permanent-NAS-UE-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Permanent_NAS_UE_Identity._val = 17
    
    #-----< id-PowerAdjustmentType >-----#
    id_PowerAdjustmentType = INT(name=u'id-PowerAdjustmentType', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PowerAdjustmentType._val = 107
    
    #-----< id-RANAP-RelocationInformation >-----#
    id_RANAP_RelocationInformation = INT(name=u'id-RANAP-RelocationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANAP_RelocationInformation._val = 109
    
    #-----< id-RL-Information-PhyChReconfRqstFDD >-----#
    id_RL_Information_PhyChReconfRqstFDD = INT(name=u'id-RL-Information-PhyChReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_PhyChReconfRqstFDD._val = 110
    
    #-----< id-RL-Information-PhyChReconfRqstTDD >-----#
    id_RL_Information_PhyChReconfRqstTDD = INT(name=u'id-RL-Information-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_PhyChReconfRqstTDD._val = 111
    
    #-----< id-RL-Information-RL-AdditionRqstFDD >-----#
    id_RL_Information_RL_AdditionRqstFDD = INT(name=u'id-RL-Information-RL-AdditionRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_AdditionRqstFDD._val = 112
    
    #-----< id-RL-Information-RL-AdditionRqstTDD >-----#
    id_RL_Information_RL_AdditionRqstTDD = INT(name=u'id-RL-Information-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_AdditionRqstTDD._val = 113
    
    #-----< id-RL-Information-RL-DeletionRqst >-----#
    id_RL_Information_RL_DeletionRqst = INT(name=u'id-RL-Information-RL-DeletionRqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_DeletionRqst._val = 114
    
    #-----< id-RL-Information-RL-FailureInd >-----#
    id_RL_Information_RL_FailureInd = INT(name=u'id-RL-Information-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_FailureInd._val = 115
    
    #-----< id-RL-Information-RL-ReconfPrepFDD >-----#
    id_RL_Information_RL_ReconfPrepFDD = INT(name=u'id-RL-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_ReconfPrepFDD._val = 116
    
    #-----< id-RL-Information-RL-RestoreInd >-----#
    id_RL_Information_RL_RestoreInd = INT(name=u'id-RL-Information-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_RestoreInd._val = 117
    
    #-----< id-RL-Information-RL-SetupRqstFDD >-----#
    id_RL_Information_RL_SetupRqstFDD = INT(name=u'id-RL-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_SetupRqstFDD._val = 118
    
    #-----< id-RL-Information-RL-SetupRqstTDD >-----#
    id_RL_Information_RL_SetupRqstTDD = INT(name=u'id-RL-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_SetupRqstTDD._val = 119
    
    #-----< id-RL-InformationItem-RL-CongestInd >-----#
    id_RL_InformationItem_RL_CongestInd = INT(name=u'id-RL-InformationItem-RL-CongestInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_CongestInd._val = 55
    
    #-----< id-RL-InformationItem-DM-Rprt >-----#
    id_RL_InformationItem_DM_Rprt = INT(name=u'id-RL-InformationItem-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_DM_Rprt._val = 120
    
    #-----< id-RL-InformationItem-DM-Rqst >-----#
    id_RL_InformationItem_DM_Rqst = INT(name=u'id-RL-InformationItem-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_DM_Rqst._val = 121
    
    #-----< id-RL-InformationItem-DM-Rsp >-----#
    id_RL_InformationItem_DM_Rsp = INT(name=u'id-RL-InformationItem-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_DM_Rsp._val = 122
    
    #-----< id-RL-InformationItem-RL-PreemptRequiredInd >-----#
    id_RL_InformationItem_RL_PreemptRequiredInd = INT(name=u'id-RL-InformationItem-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_PreemptRequiredInd._val = 2
    
    #-----< id-RL-InformationItem-RL-SetupRqstFDD >-----#
    id_RL_InformationItem_RL_SetupRqstFDD = INT(name=u'id-RL-InformationItem-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationItem_RL_SetupRqstFDD._val = 123
    
    #-----< id-RL-InformationList-RL-CongestInd >-----#
    id_RL_InformationList_RL_CongestInd = INT(name=u'id-RL-InformationList-RL-CongestInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_CongestInd._val = 56
    
    #-----< id-RL-InformationList-RL-AdditionRqstFDD >-----#
    id_RL_InformationList_RL_AdditionRqstFDD = INT(name=u'id-RL-InformationList-RL-AdditionRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_AdditionRqstFDD._val = 124
    
    #-----< id-RL-InformationList-RL-DeletionRqst >-----#
    id_RL_InformationList_RL_DeletionRqst = INT(name=u'id-RL-InformationList-RL-DeletionRqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_DeletionRqst._val = 125
    
    #-----< id-RL-InformationList-RL-PreemptRequiredInd >-----#
    id_RL_InformationList_RL_PreemptRequiredInd = INT(name=u'id-RL-InformationList-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_PreemptRequiredInd._val = 1
    
    #-----< id-RL-InformationList-RL-ReconfPrepFDD >-----#
    id_RL_InformationList_RL_ReconfPrepFDD = INT(name=u'id-RL-InformationList-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationList_RL_ReconfPrepFDD._val = 126
    
    #-----< id-RL-InformationResponse-RL-AdditionRspTDD >-----#
    id_RL_InformationResponse_RL_AdditionRspTDD = INT(name=u'id-RL-InformationResponse-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_AdditionRspTDD._val = 127
    
    #-----< id-RL-InformationResponse-RL-ReconfReadyTDD >-----#
    id_RL_InformationResponse_RL_ReconfReadyTDD = INT(name=u'id-RL-InformationResponse-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_ReconfReadyTDD._val = 128
    
    #-----< id-RL-InformationResponse-RL-SetupRspTDD >-----#
    id_RL_InformationResponse_RL_SetupRspTDD = INT(name=u'id-RL-InformationResponse-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_SetupRspTDD._val = 129
    
    #-----< id-RL-InformationResponseItem-RL-AdditionRspFDD >-----#
    id_RL_InformationResponseItem_RL_AdditionRspFDD = INT(name=u'id-RL-InformationResponseItem-RL-AdditionRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_AdditionRspFDD._val = 130
    
    #-----< id-RL-InformationResponseItem-RL-ReconfReadyFDD >-----#
    id_RL_InformationResponseItem_RL_ReconfReadyFDD = INT(name=u'id-RL-InformationResponseItem-RL-ReconfReadyFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_ReconfReadyFDD._val = 131
    
    #-----< id-RL-InformationResponseItem-RL-ReconfRspFDD >-----#
    id_RL_InformationResponseItem_RL_ReconfRspFDD = INT(name=u'id-RL-InformationResponseItem-RL-ReconfRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_ReconfRspFDD._val = 132
    
    #-----< id-RL-InformationResponseItem-RL-SetupRspFDD >-----#
    id_RL_InformationResponseItem_RL_SetupRspFDD = INT(name=u'id-RL-InformationResponseItem-RL-SetupRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseItem_RL_SetupRspFDD._val = 133
    
    #-----< id-RL-InformationResponseList-RL-AdditionRspFDD >-----#
    id_RL_InformationResponseList_RL_AdditionRspFDD = INT(name=u'id-RL-InformationResponseList-RL-AdditionRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_AdditionRspFDD._val = 134
    
    #-----< id-RL-InformationResponseList-RL-ReconfReadyFDD >-----#
    id_RL_InformationResponseList_RL_ReconfReadyFDD = INT(name=u'id-RL-InformationResponseList-RL-ReconfReadyFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_ReconfReadyFDD._val = 135
    
    #-----< id-RL-InformationResponseList-RL-ReconfRspFDD >-----#
    id_RL_InformationResponseList_RL_ReconfRspFDD = INT(name=u'id-RL-InformationResponseList-RL-ReconfRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_ReconfRspFDD._val = 136
    
    #-----< id-RL-InformationResponse-RL-ReconfRspTDD >-----#
    id_RL_InformationResponse_RL_ReconfRspTDD = INT(name=u'id-RL-InformationResponse-RL-ReconfRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_ReconfRspTDD._val = 28
    
    #-----< id-RL-InformationResponseList-RL-SetupRspFDD >-----#
    id_RL_InformationResponseList_RL_SetupRspFDD = INT(name=u'id-RL-InformationResponseList-RL-SetupRspFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponseList_RL_SetupRspFDD._val = 137
    
    #-----< id-RL-ReconfigurationFailure-RL-ReconfFail >-----#
    id_RL_ReconfigurationFailure_RL_ReconfFail = INT(name=u'id-RL-ReconfigurationFailure-RL-ReconfFail', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ReconfigurationFailure_RL_ReconfFail._val = 141
    
    #-----< id-RL-Set-InformationItem-DM-Rprt >-----#
    id_RL_Set_InformationItem_DM_Rprt = INT(name=u'id-RL-Set-InformationItem-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_DM_Rprt._val = 143
    
    #-----< id-RL-Set-InformationItem-DM-Rqst >-----#
    id_RL_Set_InformationItem_DM_Rqst = INT(name=u'id-RL-Set-InformationItem-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_DM_Rqst._val = 144
    
    #-----< id-RL-Set-InformationItem-DM-Rsp >-----#
    id_RL_Set_InformationItem_DM_Rsp = INT(name=u'id-RL-Set-InformationItem-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_InformationItem_DM_Rsp._val = 145
    
    #-----< id-RL-Set-Information-RL-FailureInd >-----#
    id_RL_Set_Information_RL_FailureInd = INT(name=u'id-RL-Set-Information-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_Information_RL_FailureInd._val = 146
    
    #-----< id-RL-Set-Information-RL-RestoreInd >-----#
    id_RL_Set_Information_RL_RestoreInd = INT(name=u'id-RL-Set-Information-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_Information_RL_RestoreInd._val = 147
    
    #-----< id-RL-Set-Successful-InformationItem-DM-Fail >-----#
    id_RL_Set_Successful_InformationItem_DM_Fail = INT(name=u'id-RL-Set-Successful-InformationItem-DM-Fail', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_Successful_InformationItem_DM_Fail._val = 473
    
    #-----< id-RL-Set-Unsuccessful-InformationItem-DM-Fail >-----#
    id_RL_Set_Unsuccessful_InformationItem_DM_Fail = INT(name=u'id-RL-Set-Unsuccessful-InformationItem-DM-Fail', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_Unsuccessful_InformationItem_DM_Fail._val = 474
    
    #-----< id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind >-----#
    id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind = INT(name=u'id-RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind._val = 475
    
    #-----< id-RL-Successful-InformationItem-DM-Fail >-----#
    id_RL_Successful_InformationItem_DM_Fail = INT(name=u'id-RL-Successful-InformationItem-DM-Fail', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Successful_InformationItem_DM_Fail._val = 476
    
    #-----< id-RL-Unsuccessful-InformationItem-DM-Fail >-----#
    id_RL_Unsuccessful_InformationItem_DM_Fail = INT(name=u'id-RL-Unsuccessful-InformationItem-DM-Fail', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Unsuccessful_InformationItem_DM_Fail._val = 477
    
    #-----< id-RL-Unsuccessful-InformationItem-DM-Fail-Ind >-----#
    id_RL_Unsuccessful_InformationItem_DM_Fail_Ind = INT(name=u'id-RL-Unsuccessful-InformationItem-DM-Fail-Ind', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Unsuccessful_InformationItem_DM_Fail_Ind._val = 478
    
    #-----< id-ReportCharacteristics >-----#
    id_ReportCharacteristics = INT(name=u'id-ReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ReportCharacteristics._val = 152
    
    #-----< id-Reporting-Object-RL-FailureInd >-----#
    id_Reporting_Object_RL_FailureInd = INT(name=u'id-Reporting-Object-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reporting_Object_RL_FailureInd._val = 153
    
    #-----< id-Reporing-Object-RL-RestoreInd >-----#
    id_Reporing_Object_RL_RestoreInd = INT(name=u'id-Reporing-Object-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Reporing_Object_RL_RestoreInd._val = 154
    
    #-----< id-RT-Load-Value >-----#
    id_RT_Load_Value = INT(name=u'id-RT-Load-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RT_Load_Value._val = 307
    
    #-----< id-RT-Load-Value-IncrDecrThres >-----#
    id_RT_Load_Value_IncrDecrThres = INT(name=u'id-RT-Load-Value-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RT_Load_Value_IncrDecrThres._val = 308
    
    #-----< id-S-RNTI >-----#
    id_S_RNTI = INT(name=u'id-S-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_S_RNTI._val = 155
    
    #-----< id-ResetIndicator >-----#
    id_ResetIndicator = INT(name=u'id-ResetIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResetIndicator._val = 244
    
    #-----< id-RNC-ID >-----#
    id_RNC_ID = INT(name=u'id-RNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RNC_ID._val = 245
    
    #-----< id-SAI >-----#
    id_SAI = INT(name=u'id-SAI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SAI._val = 156
    
    #-----< id-SRNC-ID >-----#
    id_SRNC_ID = INT(name=u'id-SRNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SRNC_ID._val = 157
    
    #-----< id-SuccessfulRL-InformationResponse-RL-AdditionFailureFDD >-----#
    id_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD = INT(name=u'id-SuccessfulRL-InformationResponse-RL-AdditionFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD._val = 159
    
    #-----< id-SuccessfulRL-InformationResponse-RL-SetupFailureFDD >-----#
    id_SuccessfulRL_InformationResponse_RL_SetupFailureFDD = INT(name=u'id-SuccessfulRL-InformationResponse-RL-SetupFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SuccessfulRL_InformationResponse_RL_SetupFailureFDD._val = 160
    
    #-----< id-TransportBearerID >-----#
    id_TransportBearerID = INT(name=u'id-TransportBearerID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerID._val = 163
    
    #-----< id-TransportBearerRequestIndicator >-----#
    id_TransportBearerRequestIndicator = INT(name=u'id-TransportBearerRequestIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerRequestIndicator._val = 164
    
    #-----< id-TransportLayerAddress >-----#
    id_TransportLayerAddress = INT(name=u'id-TransportLayerAddress', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportLayerAddress._val = 165
    
    #-----< id-TypeOfError >-----#
    id_TypeOfError = INT(name=u'id-TypeOfError', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TypeOfError._val = 140
    
    #-----< id-UC-ID >-----#
    id_UC_ID = INT(name=u'id-UC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UC_ID._val = 166
    
    #-----< id-UL-CCTrCH-AddInformation-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD = INT(name=u'id-UL-CCTrCH-AddInformation-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD._val = 167
    
    #-----< id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = INT(name=u'id-UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._val = 169
    
    #-----< id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    id_UL_CCTrCH_InformationItem_RL_SetupRqstTDD = INT(name=u'id-UL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationItem_RL_SetupRqstTDD._val = 171
    
    #-----< id-UL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    id_UL_CCTrCH_InformationList_RL_SetupRqstTDD = INT(name=u'id-UL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationList_RL_SetupRqstTDD._val = 172
    
    #-----< id-UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = INT(name=u'id-UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD._val = 173
    
    #-----< id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD >-----#
    id_UL_CCTrCH_InformationListIE_RL_AdditionRspTDD = INT(name=u'id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationListIE_RL_AdditionRspTDD._val = 174
    
    #-----< id-UL-CCTrCH-InformationListIE-RL-ReconfReadyTDD >-----#
    id_UL_CCTrCH_InformationListIE_RL_ReconfReadyTDD = INT(name=u'id-UL-CCTrCH-InformationListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationListIE_RL_ReconfReadyTDD._val = 175
    
    #-----< id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD >-----#
    id_UL_CCTrCH_InformationListIE_RL_SetupRspTDD = INT(name=u'id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationListIE_RL_SetupRspTDD._val = 176
    
    #-----< id-UL-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_UL_DPCH_Information_RL_ReconfPrepFDD = INT(name=u'id-UL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_Information_RL_ReconfPrepFDD._val = 177
    
    #-----< id-UL-DPCH-Information-RL-ReconfRqstFDD >-----#
    id_UL_DPCH_Information_RL_ReconfRqstFDD = INT(name=u'id-UL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_Information_RL_ReconfRqstFDD._val = 178
    
    #-----< id-UL-DPCH-Information-RL-SetupRqstFDD >-----#
    id_UL_DPCH_Information_RL_SetupRqstFDD = INT(name=u'id-UL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_Information_RL_SetupRqstFDD._val = 179
    
    #-----< id-UL-DPCH-InformationItem-PhyChReconfRqstTDD >-----#
    id_UL_DPCH_InformationItem_PhyChReconfRqstTDD = INT(name=u'id-UL-DPCH-InformationItem-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_PhyChReconfRqstTDD._val = 180
    
    #-----< id-UL-DPCH-InformationItem-RL-AdditionRspTDD >-----#
    id_UL_DPCH_InformationItem_RL_AdditionRspTDD = INT(name=u'id-UL-DPCH-InformationItem-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_RL_AdditionRspTDD._val = 181
    
    #-----< id-UL-DPCH-InformationItem-RL-SetupRspTDD >-----#
    id_UL_DPCH_InformationItem_RL_SetupRspTDD = INT(name=u'id-UL-DPCH-InformationItem-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_RL_SetupRspTDD._val = 182
    
    #-----< id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD >-----#
    id_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD = INT(name=u'id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD._val = 183
    
    #-----< id-UL-SIRTarget >-----#
    id_UL_SIRTarget = INT(name=u'id-UL-SIRTarget', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_SIRTarget._val = 184
    
    #-----< id-URA-Information >-----#
    id_URA_Information = INT(name=u'id-URA-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_URA_Information._val = 185
    
    #-----< id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD >-----#
    id_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD = INT(name=u'id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD._val = 188
    
    #-----< id-UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD >-----#
    id_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD = INT(name=u'id-UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD._val = 189
    
    #-----< id-UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD >-----#
    id_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD = INT(name=u'id-UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD._val = 190
    
    #-----< id-Active-Pattern-Sequence-Information >-----#
    id_Active_Pattern_Sequence_Information = INT(name=u'id-Active-Pattern-Sequence-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Active_Pattern_Sequence_Information._val = 193
    
    #-----< id-AdjustmentRatio >-----#
    id_AdjustmentRatio = INT(name=u'id-AdjustmentRatio', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdjustmentRatio._val = 194
    
    #-----< id-CauseLevel-RL-AdditionFailureFDD >-----#
    id_CauseLevel_RL_AdditionFailureFDD = INT(name=u'id-CauseLevel-RL-AdditionFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_AdditionFailureFDD._val = 197
    
    #-----< id-CauseLevel-RL-AdditionFailureTDD >-----#
    id_CauseLevel_RL_AdditionFailureTDD = INT(name=u'id-CauseLevel-RL-AdditionFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_AdditionFailureTDD._val = 198
    
    #-----< id-CauseLevel-RL-ReconfFailure >-----#
    id_CauseLevel_RL_ReconfFailure = INT(name=u'id-CauseLevel-RL-ReconfFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_ReconfFailure._val = 199
    
    #-----< id-CauseLevel-RL-SetupFailureFDD >-----#
    id_CauseLevel_RL_SetupFailureFDD = INT(name=u'id-CauseLevel-RL-SetupFailureFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_SetupFailureFDD._val = 200
    
    #-----< id-CauseLevel-RL-SetupFailureTDD >-----#
    id_CauseLevel_RL_SetupFailureTDD = INT(name=u'id-CauseLevel-RL-SetupFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CauseLevel_RL_SetupFailureTDD._val = 201
    
    #-----< id-DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD = INT(name=u'id-DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._val = 205
    
    #-----< id-DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD = INT(name=u'id-DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._val = 206
    
    #-----< id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = INT(name=u'id-DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._val = 207
    
    #-----< id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = INT(name=u'id-DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._val = 208
    
    #-----< id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    id_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = INT(name=u'id-DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._val = 209
    
    #-----< id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    id_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = INT(name=u'id-DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._val = 210
    
    #-----< id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD >-----#
    id_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD = INT(name=u'id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD._val = 212
    
    #-----< id-DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD >-----#
    id_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD = INT(name=u'id-DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD._val = 213
    
    #-----< id-DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD >-----#
    id_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD = INT(name=u'id-DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD._val = 214
    
    #-----< id-DSCHs-to-Add-TDD >-----#
    id_DSCHs_to_Add_TDD = INT(name=u'id-DSCHs-to-Add-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCHs_to_Add_TDD._val = 215
    
    #-----< id-Unused-ProtocolIE-ID-216 >-----#
    id_Unused_ProtocolIE_ID_216 = INT(name=u'id-Unused-ProtocolIE-ID-216', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_216._val = 216
    
    #-----< id-DSCH-DeleteList-RL-ReconfPrepTDD >-----#
    id_DSCH_DeleteList_RL_ReconfPrepTDD = INT(name=u'id-DSCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_DeleteList_RL_ReconfPrepTDD._val = 217
    
    #-----< id-Unused-ProtocolIE-ID-218 >-----#
    id_Unused_ProtocolIE_ID_218 = INT(name=u'id-Unused-ProtocolIE-ID-218', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_218._val = 218
    
    #-----< id-Unused-ProtocolIE-ID-219 >-----#
    id_Unused_ProtocolIE_ID_219 = INT(name=u'id-Unused-ProtocolIE-ID-219', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_219._val = 219
    
    #-----< id-DSCH-InformationListIE-RL-AdditionRspTDD >-----#
    id_DSCH_InformationListIE_RL_AdditionRspTDD = INT(name=u'id-DSCH-InformationListIE-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_InformationListIE_RL_AdditionRspTDD._val = 220
    
    #-----< id-DSCH-InformationListIEs-RL-SetupRspTDD >-----#
    id_DSCH_InformationListIEs_RL_SetupRspTDD = INT(name=u'id-DSCH-InformationListIEs-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_InformationListIEs_RL_SetupRspTDD._val = 221
    
    #-----< id-DSCH-TDD-Information >-----#
    id_DSCH_TDD_Information = INT(name=u'id-DSCH-TDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_TDD_Information._val = 222
    
    #-----< id-Unused-ProtocolIE-ID-223 >-----#
    id_Unused_ProtocolIE_ID_223 = INT(name=u'id-Unused-ProtocolIE-ID-223', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_223._val = 223
    
    #-----< id-Unused-ProtocolIE-ID-226 >-----#
    id_Unused_ProtocolIE_ID_226 = INT(name=u'id-Unused-ProtocolIE-ID-226', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_226._val = 226
    
    #-----< id-DSCH-ModifyList-RL-ReconfPrepTDD >-----#
    id_DSCH_ModifyList_RL_ReconfPrepTDD = INT(name=u'id-DSCH-ModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_ModifyList_RL_ReconfPrepTDD._val = 227
    
    #-----< id-Unused-ProtocolIE-ID-228 >-----#
    id_Unused_ProtocolIE_ID_228 = INT(name=u'id-Unused-ProtocolIE-ID-228', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_228._val = 228
    
    #-----< id-Unused-ProtocolIE-ID-324 >-----#
    id_Unused_ProtocolIE_ID_324 = INT(name=u'id-Unused-ProtocolIE-ID-324', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_324._val = 324
    
    #-----< id-Unused-ProtocolIE-ID-229 >-----#
    id_Unused_ProtocolIE_ID_229 = INT(name=u'id-Unused-ProtocolIE-ID-229', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_229._val = 229
    
    #-----< id-DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD >-----#
    id_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD = INT(name=u'id-DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD._val = 230
    
    #-----< id-Unused-ProtocolIE-ID-29 >-----#
    id_Unused_ProtocolIE_ID_29 = INT(name=u'id-Unused-ProtocolIE-ID-29', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_29._val = 29
    
    #-----< id-Unused-ProtocolIE-ID-225 >-----#
    id_Unused_ProtocolIE_ID_225 = INT(name=u'id-Unused-ProtocolIE-ID-225', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_225._val = 225
    
    #-----< id-GA-Cell >-----#
    id_GA_Cell = INT(name=u'id-GA-Cell', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GA_Cell._val = 232
    
    #-----< id-GA-CellAdditionalShapes >-----#
    id_GA_CellAdditionalShapes = INT(name=u'id-GA-CellAdditionalShapes', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GA_CellAdditionalShapes._val = 3
    
    #-----< id-Unused-ProtocolIE-ID-246 >-----#
    id_Unused_ProtocolIE_ID_246 = INT(name=u'id-Unused-ProtocolIE-ID-246', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_246._val = 246
    
    #-----< id-Transmission-Gap-Pattern-Sequence-Information >-----#
    id_Transmission_Gap_Pattern_Sequence_Information = INT(name=u'id-Transmission-Gap-Pattern-Sequence-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmission_Gap_Pattern_Sequence_Information._val = 255
    
    #-----< id-UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD = INT(name=u'id-UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD._val = 256
    
    #-----< id-UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD = INT(name=u'id-UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD._val = 257
    
    #-----< id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = INT(name=u'id-UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._val = 258
    
    #-----< id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = INT(name=u'id-UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._val = 259
    
    #-----< id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    id_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = INT(name=u'id-UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._val = 260
    
    #-----< id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = INT(name=u'id-UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._val = 261
    
    #-----< id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = INT(name=u'id-UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._val = 262
    
    #-----< id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = INT(name=u'id-UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._val = 263
    
    #-----< id-UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD >-----#
    id_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD = INT(name=u'id-UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD._val = 264
    
    #-----< id-UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD >-----#
    id_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD = INT(name=u'id-UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD._val = 265
    
    #-----< id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD >-----#
    id_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD = INT(name=u'id-UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD._val = 266
    
    #-----< id-USCHs-to-Add >-----#
    id_USCHs_to_Add = INT(name=u'id-USCHs-to-Add', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCHs_to_Add._val = 267
    
    #-----< id-USCH-DeleteList-RL-ReconfPrepTDD >-----#
    id_USCH_DeleteList_RL_ReconfPrepTDD = INT(name=u'id-USCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_DeleteList_RL_ReconfPrepTDD._val = 268
    
    #-----< id-USCH-InformationListIE-RL-AdditionRspTDD >-----#
    id_USCH_InformationListIE_RL_AdditionRspTDD = INT(name=u'id-USCH-InformationListIE-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_InformationListIE_RL_AdditionRspTDD._val = 269
    
    #-----< id-USCH-InformationListIEs-RL-SetupRspTDD >-----#
    id_USCH_InformationListIEs_RL_SetupRspTDD = INT(name=u'id-USCH-InformationListIEs-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_InformationListIEs_RL_SetupRspTDD._val = 270
    
    #-----< id-USCH-Information >-----#
    id_USCH_Information = INT(name=u'id-USCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_Information._val = 271
    
    #-----< id-USCH-ModifyList-RL-ReconfPrepTDD >-----#
    id_USCH_ModifyList_RL_ReconfPrepTDD = INT(name=u'id-USCH-ModifyList-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_ModifyList_RL_ReconfPrepTDD._val = 272
    
    #-----< id-USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD >-----#
    id_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD = INT(name=u'id-USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD._val = 273
    
    #-----< id-DL-Physical-Channel-Information-RL-SetupRqstTDD >-----#
    id_DL_Physical_Channel_Information_RL_SetupRqstTDD = INT(name=u'id-DL-Physical-Channel-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Physical_Channel_Information_RL_SetupRqstTDD._val = 274
    
    #-----< id-UL-Physical-Channel-Information-RL-SetupRqstTDD >-----#
    id_UL_Physical_Channel_Information_RL_SetupRqstTDD = INT(name=u'id-UL-Physical-Channel-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Physical_Channel_Information_RL_SetupRqstTDD._val = 275
    
    #-----< id-ClosedLoopMode1-SupportIndicator >-----#
    id_ClosedLoopMode1_SupportIndicator = INT(name=u'id-ClosedLoopMode1-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ClosedLoopMode1_SupportIndicator._val = 276
    
    #-----< id-Unused-ProtocolIE-ID-277 >-----#
    id_Unused_ProtocolIE_ID_277 = INT(name=u'id-Unused-ProtocolIE-ID-277', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_277._val = 277
    
    #-----< id-STTD-SupportIndicator >-----#
    id_STTD_SupportIndicator = INT(name=u'id-STTD-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_STTD_SupportIndicator._val = 279
    
    #-----< id-CFNReportingIndicator >-----#
    id_CFNReportingIndicator = INT(name=u'id-CFNReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CFNReportingIndicator._val = 14
    
    #-----< id-CNOriginatedPage-PagingRqst >-----#
    id_CNOriginatedPage_PagingRqst = INT(name=u'id-CNOriginatedPage-PagingRqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CNOriginatedPage_PagingRqst._val = 23
    
    #-----< id-InnerLoopDLPCStatus >-----#
    id_InnerLoopDLPCStatus = INT(name=u'id-InnerLoopDLPCStatus', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InnerLoopDLPCStatus._val = 24
    
    #-----< id-PropagationDelay >-----#
    id_PropagationDelay = INT(name=u'id-PropagationDelay', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PropagationDelay._val = 25
    
    #-----< id-RxTimingDeviationForTA >-----#
    id_RxTimingDeviationForTA = INT(name=u'id-RxTimingDeviationForTA', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RxTimingDeviationForTA._val = 36
    
    #-----< id-timeSlot-ISCP >-----#
    id_timeSlot_ISCP = INT(name=u'id-timeSlot-ISCP', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_timeSlot_ISCP._val = 37
    
    #-----< id-CCTrCH-InformationItem-RL-FailureInd >-----#
    id_CCTrCH_InformationItem_RL_FailureInd = INT(name=u'id-CCTrCH-InformationItem-RL-FailureInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_InformationItem_RL_FailureInd._val = 15
    
    #-----< id-CCTrCH-InformationItem-RL-RestoreInd >-----#
    id_CCTrCH_InformationItem_RL_RestoreInd = INT(name=u'id-CCTrCH-InformationItem-RL-RestoreInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_InformationItem_RL_RestoreInd._val = 16
    
    #-----< id-CommonMeasurementAccuracy >-----#
    id_CommonMeasurementAccuracy = INT(name=u'id-CommonMeasurementAccuracy', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementAccuracy._val = 280
    
    #-----< id-CommonMeasurementObjectType-CM-Rprt >-----#
    id_CommonMeasurementObjectType_CM_Rprt = INT(name=u'id-CommonMeasurementObjectType-CM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementObjectType_CM_Rprt._val = 281
    
    #-----< id-CommonMeasurementObjectType-CM-Rqst >-----#
    id_CommonMeasurementObjectType_CM_Rqst = INT(name=u'id-CommonMeasurementObjectType-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementObjectType_CM_Rqst._val = 282
    
    #-----< id-CommonMeasurementObjectType-CM-Rsp >-----#
    id_CommonMeasurementObjectType_CM_Rsp = INT(name=u'id-CommonMeasurementObjectType-CM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementObjectType_CM_Rsp._val = 283
    
    #-----< id-CommonMeasurementType >-----#
    id_CommonMeasurementType = INT(name=u'id-CommonMeasurementType', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonMeasurementType._val = 284
    
    #-----< id-CongestionCause >-----#
    id_CongestionCause = INT(name=u'id-CongestionCause', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CongestionCause._val = 18
    
    #-----< id-SFN >-----#
    id_SFN = INT(name=u'id-SFN', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFN._val = 285
    
    #-----< id-SFNReportingIndicator >-----#
    id_SFNReportingIndicator = INT(name=u'id-SFNReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNReportingIndicator._val = 286
    
    #-----< id-InformationExchangeID >-----#
    id_InformationExchangeID = INT(name=u'id-InformationExchangeID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeID._val = 287
    
    #-----< id-InformationExchangeObjectType-InfEx-Rprt >-----#
    id_InformationExchangeObjectType_InfEx_Rprt = INT(name=u'id-InformationExchangeObjectType-InfEx-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rprt._val = 288
    
    #-----< id-InformationExchangeObjectType-InfEx-Rqst >-----#
    id_InformationExchangeObjectType_InfEx_Rqst = INT(name=u'id-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rqst._val = 289
    
    #-----< id-InformationExchangeObjectType-InfEx-Rsp >-----#
    id_InformationExchangeObjectType_InfEx_Rsp = INT(name=u'id-InformationExchangeObjectType-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rsp._val = 290
    
    #-----< id-InformationReportCharacteristics >-----#
    id_InformationReportCharacteristics = INT(name=u'id-InformationReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationReportCharacteristics._val = 291
    
    #-----< id-InformationType >-----#
    id_InformationType = INT(name=u'id-InformationType', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationType._val = 292
    
    #-----< id-neighbouring-LCR-TDD-CellInformation >-----#
    id_neighbouring_LCR_TDD_CellInformation = INT(name=u'id-neighbouring-LCR-TDD-CellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_neighbouring_LCR_TDD_CellInformation._val = 58
    
    #-----< id-DL-Timeslot-ISCP-LCR-Information-RL-SetupRqstTDD >-----#
    id_DL_Timeslot_ISCP_LCR_Information_RL_SetupRqstTDD = INT(name=u'id-DL-Timeslot-ISCP-LCR-Information-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_ISCP_LCR_Information_RL_SetupRqstTDD._val = 65
    
    #-----< id-RL-LCR-InformationResponse-RL-SetupRspTDD >-----#
    id_RL_LCR_InformationResponse_RL_SetupRspTDD = INT(name=u'id-RL-LCR-InformationResponse-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_LCR_InformationResponse_RL_SetupRspTDD._val = 66
    
    #-----< id-UL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD >-----#
    id_UL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD = INT(name=u'id-UL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD._val = 75
    
    #-----< id-UL-DPCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    id_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD = INT(name=u'id-UL-DPCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD._val = 76
    
    #-----< id-DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD >-----#
    id_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD = INT(name=u'id-DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD._val = 77
    
    #-----< id-DL-DPCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    id_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD = INT(name=u'id-DL-DPCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD._val = 78
    
    #-----< id-DSCH-LCR-InformationListIEs-RL-SetupRspTDD >-----#
    id_DSCH_LCR_InformationListIEs_RL_SetupRspTDD = INT(name=u'id-DSCH-LCR-InformationListIEs-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_LCR_InformationListIEs_RL_SetupRspTDD._val = 79
    
    #-----< id-USCH-LCR-InformationListIEs-RL-SetupRspTDD >-----#
    id_USCH_LCR_InformationListIEs_RL_SetupRspTDD = INT(name=u'id-USCH-LCR-InformationListIEs-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_LCR_InformationListIEs_RL_SetupRspTDD._val = 80
    
    #-----< id-DL-Timeslot-ISCP-LCR-Information-RL-AdditionRqstTDD >-----#
    id_DL_Timeslot_ISCP_LCR_Information_RL_AdditionRqstTDD = INT(name=u'id-DL-Timeslot-ISCP-LCR-Information-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_ISCP_LCR_Information_RL_AdditionRqstTDD._val = 81
    
    #-----< id-RL-LCR-InformationResponse-RL-AdditionRspTDD >-----#
    id_RL_LCR_InformationResponse_RL_AdditionRspTDD = INT(name=u'id-RL-LCR-InformationResponse-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_LCR_InformationResponse_RL_AdditionRspTDD._val = 86
    
    #-----< id-UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD >-----#
    id_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD = INT(name=u'id-UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD._val = 87
    
    #-----< id-UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    id_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD = INT(name=u'id-UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD._val = 88
    
    #-----< id-DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD >-----#
    id_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD = INT(name=u'id-DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD._val = 89
    
    #-----< id-DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    id_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD = INT(name=u'id-DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD._val = 94
    
    #-----< id-DSCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    id_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD = INT(name=u'id-DSCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD._val = 96
    
    #-----< id-USCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    id_USCH_LCR_InformationListIEs_RL_AdditionRspTDD = INT(name=u'id-USCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_USCH_LCR_InformationListIEs_RL_AdditionRspTDD._val = 97
    
    #-----< id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD >-----#
    id_UL_DPCH_LCR_InformationAddListIE_RL_ReconfReadyTDD = INT(name=u'id-UL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_LCR_InformationAddListIE_RL_ReconfReadyTDD._val = 98
    
    #-----< id-UL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD >-----#
    id_UL_Timeslot_LCR_InformationModifyList_RL_ReconfReadyTDD = INT(name=u'id-UL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot_LCR_InformationModifyList_RL_ReconfReadyTDD._val = 100
    
    #-----< id-DL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD >-----#
    id_DL_DPCH_LCR_InformationAddListIE_RL_ReconfReadyTDD = INT(name=u'id-DL-DPCH-LCR-InformationAddListIE-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_LCR_InformationAddListIE_RL_ReconfReadyTDD._val = 101
    
    #-----< id-DL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD >-----#
    id_DL_Timeslot_LCR_InformationModifyList_RL_ReconfReadyTDD = INT(name=u'id-DL-Timeslot-LCR-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_LCR_InformationModifyList_RL_ReconfReadyTDD._val = 104
    
    #-----< id-UL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD >-----#
    id_UL_Timeslot_LCR_InformationList_PhyChReconfRqstTDD = INT(name=u'id-UL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot_LCR_InformationList_PhyChReconfRqstTDD._val = 105
    
    #-----< id-DL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD >-----#
    id_DL_Timeslot_LCR_InformationList_PhyChReconfRqstTDD = INT(name=u'id-DL-Timeslot-LCR-InformationList-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_LCR_InformationList_PhyChReconfRqstTDD._val = 106
    
    #-----< id-timeSlot-ISCP-LCR-List-DL-PC-Rqst-TDD >-----#
    id_timeSlot_ISCP_LCR_List_DL_PC_Rqst_TDD = INT(name=u'id-timeSlot-ISCP-LCR-List-DL-PC-Rqst-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_timeSlot_ISCP_LCR_List_DL_PC_Rqst_TDD._val = 138
    
    #-----< id-TSTD-Support-Indicator-RL-SetupRqstTDD >-----#
    id_TSTD_Support_Indicator_RL_SetupRqstTDD = INT(name=u'id-TSTD-Support-Indicator-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TSTD_Support_Indicator_RL_SetupRqstTDD._val = 139
    
    #-----< id-RestrictionStateIndicator >-----#
    id_RestrictionStateIndicator = INT(name=u'id-RestrictionStateIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RestrictionStateIndicator._val = 142
    
    #-----< id-Load-Value >-----#
    id_Load_Value = INT(name=u'id-Load-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Load_Value._val = 233
    
    #-----< id-Load-Value-IncrDecrThres >-----#
    id_Load_Value_IncrDecrThres = INT(name=u'id-Load-Value-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Load_Value_IncrDecrThres._val = 234
    
    #-----< id-OnModification >-----#
    id_OnModification = INT(name=u'id-OnModification', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OnModification._val = 235
    
    #-----< id-Received-Total-Wideband-Power-Value >-----#
    id_Received_Total_Wideband_Power_Value = INT(name=u'id-Received-Total-Wideband-Power-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_Total_Wideband_Power_Value._val = 236
    
    #-----< id-Received-Total-Wideband-Power-Value-IncrDecrThres >-----#
    id_Received_Total_Wideband_Power_Value_IncrDecrThres = INT(name=u'id-Received-Total-Wideband-Power-Value-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Received_Total_Wideband_Power_Value_IncrDecrThres._val = 237
    
    #-----< id-SFNSFNMeasurementThresholdInformation >-----#
    id_SFNSFNMeasurementThresholdInformation = INT(name=u'id-SFNSFNMeasurementThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SFNSFNMeasurementThresholdInformation._val = 238
    
    #-----< id-Transmitted-Carrier-Power-Value >-----#
    id_Transmitted_Carrier_Power_Value = INT(name=u'id-Transmitted-Carrier-Power-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmitted_Carrier_Power_Value._val = 239
    
    #-----< id-Transmitted-Carrier-Power-Value-IncrDecrThres >-----#
    id_Transmitted_Carrier_Power_Value_IncrDecrThres = INT(name=u'id-Transmitted-Carrier-Power-Value-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmitted_Carrier_Power_Value_IncrDecrThres._val = 240
    
    #-----< id-TUTRANGPSMeasurementThresholdInformation >-----#
    id_TUTRANGPSMeasurementThresholdInformation = INT(name=u'id-TUTRANGPSMeasurementThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGPSMeasurementThresholdInformation._val = 241
    
    #-----< id-UL-Timeslot-ISCP-Value >-----#
    id_UL_Timeslot_ISCP_Value = INT(name=u'id-UL-Timeslot-ISCP-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot_ISCP_Value._val = 242
    
    #-----< id-UL-Timeslot-ISCP-Value-IncrDecrThres >-----#
    id_UL_Timeslot_ISCP_Value_IncrDecrThres = INT(name=u'id-UL-Timeslot-ISCP-Value-IncrDecrThres', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot_ISCP_Value_IncrDecrThres._val = 243
    
    #-----< id-Rx-Timing-Deviation-Value-LCR >-----#
    id_Rx_Timing_Deviation_Value_LCR = INT(name=u'id-Rx-Timing-Deviation-Value-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Rx_Timing_Deviation_Value_LCR._val = 293
    
    #-----< id-DPC-Mode-Change-SupportIndicator >-----#
    id_DPC_Mode_Change_SupportIndicator = INT(name=u'id-DPC-Mode-Change-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPC_Mode_Change_SupportIndicator._val = 19
    
    #-----< id-Unused-ProtocolIE-ID-247 >-----#
    id_Unused_ProtocolIE_ID_247 = INT(name=u'id-Unused-ProtocolIE-ID-247', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_247._val = 247
    
    #-----< id-Unused-ProtocolIE-ID-295 >-----#
    id_Unused_ProtocolIE_ID_295 = INT(name=u'id-Unused-ProtocolIE-ID-295', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_295._val = 295
    
    #-----< id-PrimaryCCPCH-RSCP-RL-ReconfPrepTDD >-----#
    id_PrimaryCCPCH_RSCP_RL_ReconfPrepTDD = INT(name=u'id-PrimaryCCPCH-RSCP-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCCPCH_RSCP_RL_ReconfPrepTDD._val = 202
    
    #-----< id-DL-TimeSlot-ISCP-Info-RL-ReconfPrepTDD >-----#
    id_DL_TimeSlot_ISCP_Info_RL_ReconfPrepTDD = INT(name=u'id-DL-TimeSlot-ISCP-Info-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_TimeSlot_ISCP_Info_RL_ReconfPrepTDD._val = 203
    
    #-----< id-DL-Timeslot-ISCP-LCR-Information-RL-ReconfPrepTDD >-----#
    id_DL_Timeslot_ISCP_LCR_Information_RL_ReconfPrepTDD = INT(name=u'id-DL-Timeslot-ISCP-LCR-Information-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_ISCP_LCR_Information_RL_ReconfPrepTDD._val = 204
    
    #-----< id-DSCH-RNTI >-----#
    id_DSCH_RNTI = INT(name=u'id-DSCH-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_RNTI._val = 249
    
    #-----< id-DL-PowerBalancing-Information >-----#
    id_DL_PowerBalancing_Information = INT(name=u'id-DL-PowerBalancing-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_PowerBalancing_Information._val = 296
    
    #-----< id-DL-PowerBalancing-ActivationIndicator >-----#
    id_DL_PowerBalancing_ActivationIndicator = INT(name=u'id-DL-PowerBalancing-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_PowerBalancing_ActivationIndicator._val = 297
    
    #-----< id-DL-PowerBalancing-UpdatedIndicator >-----#
    id_DL_PowerBalancing_UpdatedIndicator = INT(name=u'id-DL-PowerBalancing-UpdatedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_PowerBalancing_UpdatedIndicator._val = 298
    
    #-----< id-DL-ReferencePowerInformation >-----#
    id_DL_ReferencePowerInformation = INT(name=u'id-DL-ReferencePowerInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_ReferencePowerInformation._val = 299
    
    #-----< id-Enhanced-PrimaryCPICH-EcNo >-----#
    id_Enhanced_PrimaryCPICH_EcNo = INT(name=u'id-Enhanced-PrimaryCPICH-EcNo', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_PrimaryCPICH_EcNo._val = 224
    
    #-----< id-IPDL-TDD-ParametersLCR >-----#
    id_IPDL_TDD_ParametersLCR = INT(name=u'id-IPDL-TDD-ParametersLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IPDL_TDD_ParametersLCR._val = 252
    
    #-----< id-CellCapabilityContainer-FDD >-----#
    id_CellCapabilityContainer_FDD = INT(name=u'id-CellCapabilityContainer-FDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellCapabilityContainer_FDD._val = 300
    
    #-----< id-CellCapabilityContainer-TDD >-----#
    id_CellCapabilityContainer_TDD = INT(name=u'id-CellCapabilityContainer-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellCapabilityContainer_TDD._val = 301
    
    #-----< id-CellCapabilityContainer-TDD-LCR >-----#
    id_CellCapabilityContainer_TDD_LCR = INT(name=u'id-CellCapabilityContainer-TDD-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellCapabilityContainer_TDD_LCR._val = 302
    
    #-----< id-RL-Specific-DCH-Info >-----#
    id_RL_Specific_DCH_Info = INT(name=u'id-RL-Specific-DCH-Info', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Specific_DCH_Info._val = 317
    
    #-----< id-RL-ReconfigurationRequestFDD-RL-InformationList >-----#
    id_RL_ReconfigurationRequestFDD_RL_InformationList = INT(name=u'id-RL-ReconfigurationRequestFDD-RL-InformationList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ReconfigurationRequestFDD_RL_InformationList._val = 318
    
    #-----< id-RL-ReconfigurationRequestFDD-RL-Information-IEs >-----#
    id_RL_ReconfigurationRequestFDD_RL_Information_IEs = INT(name=u'id-RL-ReconfigurationRequestFDD-RL-Information-IEs', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ReconfigurationRequestFDD_RL_Information_IEs._val = 319
    
    #-----< id-RL-ReconfigurationRequestTDD-RL-Information >-----#
    id_RL_ReconfigurationRequestTDD_RL_Information = INT(name=u'id-RL-ReconfigurationRequestTDD-RL-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ReconfigurationRequestTDD_RL_Information._val = 321
    
    #-----< id-CommonTransportChannelResourcesInitialisationNotRequired >-----#
    id_CommonTransportChannelResourcesInitialisationNotRequired = INT(name=u'id-CommonTransportChannelResourcesInitialisationNotRequired', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CommonTransportChannelResourcesInitialisationNotRequired._val = 250
    
    #-----< id-DelayedActivation >-----#
    id_DelayedActivation = INT(name=u'id-DelayedActivation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivation._val = 312
    
    #-----< id-DelayedActivationList-RL-ActivationCmdFDD >-----#
    id_DelayedActivationList_RL_ActivationCmdFDD = INT(name=u'id-DelayedActivationList-RL-ActivationCmdFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationList_RL_ActivationCmdFDD._val = 313
    
    #-----< id-DelayedActivationInformation-RL-ActivationCmdFDD >-----#
    id_DelayedActivationInformation_RL_ActivationCmdFDD = INT(name=u'id-DelayedActivationInformation-RL-ActivationCmdFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationInformation_RL_ActivationCmdFDD._val = 314
    
    #-----< id-DelayedActivationList-RL-ActivationCmdTDD >-----#
    id_DelayedActivationList_RL_ActivationCmdTDD = INT(name=u'id-DelayedActivationList-RL-ActivationCmdTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationList_RL_ActivationCmdTDD._val = 315
    
    #-----< id-DelayedActivationInformation-RL-ActivationCmdTDD >-----#
    id_DelayedActivationInformation_RL_ActivationCmdTDD = INT(name=u'id-DelayedActivationInformation-RL-ActivationCmdTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DelayedActivationInformation_RL_ActivationCmdTDD._val = 316
    
    #-----< id-neighbouringTDDCellMeasurementInformationLCR >-----#
    id_neighbouringTDDCellMeasurementInformationLCR = INT(name=u'id-neighbouringTDDCellMeasurementInformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_neighbouringTDDCellMeasurementInformationLCR._val = 251
    
    #-----< id-UL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD >-----#
    id_UL_SIR_Target_CCTrCH_InformationItem_RL_SetupRspTDD = INT(name=u'id-UL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_SIR_Target_CCTrCH_InformationItem_RL_SetupRspTDD._val = 150
    
    #-----< id-UL-SIR-Target-CCTrCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    id_UL_SIR_Target_CCTrCH_LCR_InformationItem_RL_SetupRspTDD = INT(name=u'id-UL-SIR-Target-CCTrCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_SIR_Target_CCTrCH_LCR_InformationItem_RL_SetupRspTDD._val = 151
    
    #-----< id-PrimCCPCH-RSCP-DL-PC-RqstTDD >-----#
    id_PrimCCPCH_RSCP_DL_PC_RqstTDD = INT(name=u'id-PrimCCPCH-RSCP-DL-PC-RqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimCCPCH_RSCP_DL_PC_RqstTDD._val = 451
    
    #-----< id-HSDSCH-FDD-Information >-----#
    id_HSDSCH_FDD_Information = INT(name=u'id-HSDSCH-FDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_FDD_Information._val = 452
    
    #-----< id-HSDSCH-FDD-Information-Response >-----#
    id_HSDSCH_FDD_Information_Response = INT(name=u'id-HSDSCH-FDD-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_FDD_Information_Response._val = 453
    
    #-----< id-HSDSCH-FDD-Update-Information >-----#
    id_HSDSCH_FDD_Update_Information = INT(name=u'id-HSDSCH-FDD-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_FDD_Update_Information._val = 466
    
    #-----< id-HSDSCH-Information-to-Modify >-----#
    id_HSDSCH_Information_to_Modify = INT(name=u'id-HSDSCH-Information-to-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Information_to_Modify._val = 456
    
    #-----< id-HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd >-----#
    id_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd = INT(name=u'id-HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd._val = 516
    
    #-----< id-HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd >-----#
    id_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd = INT(name=u'id-HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd._val = 517
    
    #-----< id-HSDSCH-RNTI >-----#
    id_HSDSCH_RNTI = INT(name=u'id-HSDSCH-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_RNTI._val = 457
    
    #-----< id-HSDSCH-TDD-Information >-----#
    id_HSDSCH_TDD_Information = INT(name=u'id-HSDSCH-TDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TDD_Information._val = 458
    
    #-----< id-HSDSCH-TDD-Information-Response >-----#
    id_HSDSCH_TDD_Information_Response = INT(name=u'id-HSDSCH-TDD-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TDD_Information_Response._val = 459
    
    #-----< id-HSDSCH-TDD-Update-Information >-----#
    id_HSDSCH_TDD_Update_Information = INT(name=u'id-HSDSCH-TDD-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TDD_Update_Information._val = 467
    
    #-----< id-HSPDSCH-RL-ID >-----#
    id_HSPDSCH_RL_ID = INT(name=u'id-HSPDSCH-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSPDSCH_RL_ID._val = 463
    
    #-----< id-HSDSCH-MACdFlows-to-Add >-----#
    id_HSDSCH_MACdFlows_to_Add = INT(name=u'id-HSDSCH-MACdFlows-to-Add', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdFlows_to_Add._val = 531
    
    #-----< id-HSDSCH-MACdFlows-to-Delete >-----#
    id_HSDSCH_MACdFlows_to_Delete = INT(name=u'id-HSDSCH-MACdFlows-to-Delete', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdFlows_to_Delete._val = 532
    
    #-----< id-Angle-Of-Arrival-Value-LCR >-----#
    id_Angle_Of_Arrival_Value_LCR = INT(name=u'id-Angle-Of-Arrival-Value-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Angle_Of_Arrival_Value_LCR._val = 148
    
    #-----< id-TrafficClass >-----#
    id_TrafficClass = INT(name=u'id-TrafficClass', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TrafficClass._val = 158
    
    #-----< id-Unused-ProtocolIE-ID-248 >-----#
    id_Unused_ProtocolIE_ID_248 = INT(name=u'id-Unused-ProtocolIE-ID-248', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_248._val = 248
    
    #-----< id-Unused-ProtocolIE-ID-253 >-----#
    id_Unused_ProtocolIE_ID_253 = INT(name=u'id-Unused-ProtocolIE-ID-253', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_253._val = 253
    
    #-----< id-PDSCH-RL-ID >-----#
    id_PDSCH_RL_ID = INT(name=u'id-PDSCH-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PDSCH_RL_ID._val = 323
    
    #-----< id-TimeSlot-RL-SetupRspTDD >-----#
    id_TimeSlot_RL_SetupRspTDD = INT(name=u'id-TimeSlot-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TimeSlot_RL_SetupRspTDD._val = 325
    
    #-----< id-GERAN-Cell-Capability >-----#
    id_GERAN_Cell_Capability = INT(name=u'id-GERAN-Cell-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GERAN_Cell_Capability._val = 468
    
    #-----< id-GERAN-Classmark >-----#
    id_GERAN_Classmark = INT(name=u'id-GERAN-Classmark', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GERAN_Classmark._val = 469
    
    #-----< id-DSCH-InitialWindowSize >-----#
    id_DSCH_InitialWindowSize = INT(name=u'id-DSCH-InitialWindowSize', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DSCH_InitialWindowSize._val = 480
    
    #-----< id-UL-Synchronisation-Parameters-LCR >-----#
    id_UL_Synchronisation_Parameters_LCR = INT(name=u'id-UL-Synchronisation-Parameters-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Synchronisation_Parameters_LCR._val = 464
    
    #-----< id-SNA-Information >-----#
    id_SNA_Information = INT(name=u'id-SNA-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SNA_Information._val = 479
    
    #-----< id-MAChs-ResetIndicator >-----#
    id_MAChs_ResetIndicator = INT(name=u'id-MAChs-ResetIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MAChs_ResetIndicator._val = 465
    
    #-----< id-TDD-DL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD >-----#
    id_TDD_DL_DPCH_TimeSlotFormatModifyItem_LCR_RL_ReconfReadyTDD = INT(name=u'id-TDD-DL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_DL_DPCH_TimeSlotFormatModifyItem_LCR_RL_ReconfReadyTDD._val = 481
    
    #-----< id-TDD-UL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD >-----#
    id_TDD_UL_DPCH_TimeSlotFormatModifyItem_LCR_RL_ReconfReadyTDD = INT(name=u'id-TDD-UL-DPCH-TimeSlotFormatModifyItem-LCR-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_UL_DPCH_TimeSlotFormatModifyItem_LCR_RL_ReconfReadyTDD._val = 482
    
    #-----< id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD >-----#
    id_TDD_TPC_UplinkStepSize_LCR_RL_SetupRqstTDD = INT(name=u'id-TDD-TPC-UplinkStepSize-LCR-RL-SetupRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_LCR_RL_SetupRqstTDD._val = 483
    
    #-----< id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    id_UL_CCTrCH_InformationList_RL_AdditionRqstTDD = INT(name=u'id-UL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationList_RL_AdditionRqstTDD._val = 484
    
    #-----< id-UL-CCTrCH-InformationItem-RL-AdditionRqstTDD >-----#
    id_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD = INT(name=u'id-UL-CCTrCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD._val = 485
    
    #-----< id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    id_DL_CCTrCH_InformationList_RL_AdditionRqstTDD = INT(name=u'id-DL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationList_RL_AdditionRqstTDD._val = 486
    
    #-----< id-DL-CCTrCH-InformationItem-RL-AdditionRqstTDD >-----#
    id_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD = INT(name=u'id-DL-CCTrCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD._val = 487
    
    #-----< id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_UplinkStepSize_InformationAdd_LCR_RL_ReconfPrepTDD = INT(name=u'id-TDD-TPC-UplinkStepSize-InformationAdd-LCR-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_InformationAdd_LCR_RL_ReconfPrepTDD._val = 488
    
    #-----< id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_UplinkStepSize_InformationModify_LCR_RL_ReconfPrepTDD = INT(name=u'id-TDD-TPC-UplinkStepSize-InformationModify-LCR-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_UplinkStepSize_InformationModify_LCR_RL_ReconfPrepTDD._val = 489
    
    #-----< id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_DownlinkStepSize_InformationAdd_RL_ReconfPrepTDD = INT(name=u'id-TDD-TPC-DownlinkStepSize-InformationAdd-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_DownlinkStepSize_InformationAdd_RL_ReconfPrepTDD._val = 490
    
    #-----< id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD >-----#
    id_TDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD = INT(name=u'id-TDD-TPC-DownlinkStepSize-InformationModify-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD._val = 491
    
    #-----< id-UL-TimingAdvanceCtrl-LCR >-----#
    id_UL_TimingAdvanceCtrl_LCR = INT(name=u'id-UL-TimingAdvanceCtrl-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_TimingAdvanceCtrl_LCR._val = 492
    
    #-----< id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD >-----#
    id_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD = INT(name=u'id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD._val = 493
    
    #-----< id-HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD >-----#
    id_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD = INT(name=u'id-HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD._val = 494
    
    #-----< id-HS-SICH-Reception-Quality >-----#
    id_HS_SICH_Reception_Quality = INT(name=u'id-HS-SICH-Reception-Quality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SICH_Reception_Quality._val = 495
    
    #-----< id-HS-SICH-Reception-Quality-Measurement-Value >-----#
    id_HS_SICH_Reception_Quality_Measurement_Value = INT(name=u'id-HS-SICH-Reception-Quality-Measurement-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SICH_Reception_Quality_Measurement_Value._val = 496
    
    #-----< id-HSSICH-Info-DM-Rprt >-----#
    id_HSSICH_Info_DM_Rprt = INT(name=u'id-HSSICH-Info-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM_Rprt._val = 497
    
    #-----< id-HSSICH-Info-DM-Rqst >-----#
    id_HSSICH_Info_DM_Rqst = INT(name=u'id-HSSICH-Info-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM_Rqst._val = 498
    
    #-----< id-HSSICH-Info-DM >-----#
    id_HSSICH_Info_DM = INT(name=u'id-HSSICH-Info-DM', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM._val = 499
    
    #-----< id-CCTrCH-Maximum-DL-Power-RL-SetupRspTDD >-----#
    id_CCTrCH_Maximum_DL_Power_RL_SetupRspTDD = INT(name=u'id-CCTrCH-Maximum-DL-Power-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_RL_SetupRspTDD._val = 500
    
    #-----< id-CCTrCH-Minimum-DL-Power-RL-SetupRspTDD >-----#
    id_CCTrCH_Minimum_DL_Power_RL_SetupRspTDD = INT(name=u'id-CCTrCH-Minimum-DL-Power-RL-SetupRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_RL_SetupRspTDD._val = 501
    
    #-----< id-CCTrCH-Maximum-DL-Power-RL-AdditionRspTDD >-----#
    id_CCTrCH_Maximum_DL_Power_RL_AdditionRspTDD = INT(name=u'id-CCTrCH-Maximum-DL-Power-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_RL_AdditionRspTDD._val = 502
    
    #-----< id-CCTrCH-Minimum-DL-Power-RL-AdditionRspTDD >-----#
    id_CCTrCH_Minimum_DL_Power_RL_AdditionRspTDD = INT(name=u'id-CCTrCH-Minimum-DL-Power-RL-AdditionRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_RL_AdditionRspTDD._val = 503
    
    #-----< id-CCTrCH-Maximum-DL-Power-RL-ReconfReadyTDD >-----#
    id_CCTrCH_Maximum_DL_Power_RL_ReconfReadyTDD = INT(name=u'id-CCTrCH-Maximum-DL-Power-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Maximum_DL_Power_RL_ReconfReadyTDD._val = 504
    
    #-----< id-CCTrCH-Minimum-DL-Power-RL-ReconfReadyTDD >-----#
    id_CCTrCH_Minimum_DL_Power_RL_ReconfReadyTDD = INT(name=u'id-CCTrCH-Minimum-DL-Power-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CCTrCH_Minimum_DL_Power_RL_ReconfReadyTDD._val = 505
    
    #-----< id-Maximum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD >-----#
    id_Maximum_DL_Power_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD = INT(name=u'id-Maximum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_DL_Power_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD._val = 506
    
    #-----< id-Minimum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD >-----#
    id_Minimum_DL_Power_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD = INT(name=u'id-Minimum-DL-Power-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Minimum_DL_Power_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD._val = 507
    
    #-----< id-DL-CCTrCH-InformationList-RL-ReconfRspTDD >-----#
    id_DL_CCTrCH_InformationList_RL_ReconfRspTDD = INT(name=u'id-DL-CCTrCH-InformationList-RL-ReconfRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationList_RL_ReconfRspTDD._val = 508
    
    #-----< id-DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD >-----#
    id_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD = INT(name=u'id-DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD._val = 509
    
    #-----< id-Maximum-DL-Power-TimeslotLCR-InformationItem >-----#
    id_Maximum_DL_Power_TimeslotLCR_InformationItem = INT(name=u'id-Maximum-DL-Power-TimeslotLCR-InformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Maximum_DL_Power_TimeslotLCR_InformationItem._val = 510
    
    #-----< id-Minimum-DL-Power-TimeslotLCR-InformationItem >-----#
    id_Minimum_DL_Power_TimeslotLCR_InformationItem = INT(name=u'id-Minimum-DL-Power-TimeslotLCR-InformationItem', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Minimum_DL_Power_TimeslotLCR_InformationItem._val = 511
    
    #-----< id-TDD-Support-8PSK >-----#
    id_TDD_Support_8PSK = INT(name=u'id-TDD-Support-8PSK', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_Support_8PSK._val = 512
    
    #-----< id-TDD-maxNrDLPhysicalchannels >-----#
    id_TDD_maxNrDLPhysicalchannels = INT(name=u'id-TDD-maxNrDLPhysicalchannels', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_maxNrDLPhysicalchannels._val = 513
    
    #-----< id-ExtendedGSMCellIndividualOffset >-----#
    id_ExtendedGSMCellIndividualOffset = INT(name=u'id-ExtendedGSMCellIndividualOffset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedGSMCellIndividualOffset._val = 514
    
    #-----< id-RL-ParameterUpdateIndicationFDD-RL-InformationList >-----#
    id_RL_ParameterUpdateIndicationFDD_RL_InformationList = INT(name=u'id-RL-ParameterUpdateIndicationFDD-RL-InformationList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ParameterUpdateIndicationFDD_RL_InformationList._val = 518
    
    #-----< id-Primary-CPICH-Usage-For-Channel-Estimation >-----#
    id_Primary_CPICH_Usage_For_Channel_Estimation = INT(name=u'id-Primary-CPICH-Usage-For-Channel-Estimation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Primary_CPICH_Usage_For_Channel_Estimation._val = 519
    
    #-----< id-Secondary-CPICH-Information >-----#
    id_Secondary_CPICH_Information = INT(name=u'id-Secondary-CPICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CPICH_Information._val = 520
    
    #-----< id-Secondary-CPICH-Information-Change >-----#
    id_Secondary_CPICH_Information_Change = INT(name=u'id-Secondary-CPICH-Information-Change', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_CPICH_Information_Change._val = 521
    
    #-----< id-Unused-ProtocolIE-ID-522 >-----#
    id_Unused_ProtocolIE_ID_522 = INT(name=u'id-Unused-ProtocolIE-ID-522', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_522._val = 522
    
    #-----< id-Unused-ProtocolIE-ID-523 >-----#
    id_Unused_ProtocolIE_ID_523 = INT(name=u'id-Unused-ProtocolIE-ID-523', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unused_ProtocolIE_ID_523._val = 523
    
    #-----< id-RL-ParameterUpdateIndicationFDD-RL-Information-Item >-----#
    id_RL_ParameterUpdateIndicationFDD_RL_Information_Item = INT(name=u'id-RL-ParameterUpdateIndicationFDD-RL-Information-Item', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ParameterUpdateIndicationFDD_RL_Information_Item._val = 524
    
    #-----< id-Phase-Reference-Update-Indicator >-----#
    id_Phase_Reference_Update_Indicator = INT(name=u'id-Phase-Reference-Update-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Phase_Reference_Update_Indicator._val = 525
    
    #-----< id-Unidirectional-DCH-Indicator >-----#
    id_Unidirectional_DCH_Indicator = INT(name=u'id-Unidirectional-DCH-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Unidirectional_DCH_Indicator._val = 526
    
    #-----< id-RL-Information-RL-ReconfPrepTDD >-----#
    id_RL_Information_RL_ReconfPrepTDD = INT(name=u'id-RL-Information-RL-ReconfPrepTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Information_RL_ReconfPrepTDD._val = 527
    
    #-----< id-Multiple-RL-InformationResponse-RL-ReconfReadyTDD >-----#
    id_Multiple_RL_InformationResponse_RL_ReconfReadyTDD = INT(name=u'id-Multiple-RL-InformationResponse-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiple_RL_InformationResponse_RL_ReconfReadyTDD._val = 528
    
    #-----< id-RL-ReconfigurationResponseTDD-RL-Information >-----#
    id_RL_ReconfigurationResponseTDD_RL_Information = INT(name=u'id-RL-ReconfigurationResponseTDD-RL-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_ReconfigurationResponseTDD_RL_Information._val = 529
    
    #-----< id-Satellite-Almanac-Information-ExtItem >-----#
    id_Satellite_Almanac_Information_ExtItem = INT(name=u'id-Satellite-Almanac-Information-ExtItem', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Satellite_Almanac_Information_ExtItem._val = 530
    
    #-----< id-HSDSCH-Information-to-Modify-Unsynchronised >-----#
    id_HSDSCH_Information_to_Modify_Unsynchronised = INT(name=u'id-HSDSCH-Information-to-Modify-Unsynchronised', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Information_to_Modify_Unsynchronised._val = 533
    
    #-----< id-TnlQos >-----#
    id_TnlQos = INT(name=u'id-TnlQos', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TnlQos._val = 534
    
    #-----< id-RTLoadValue >-----#
    id_RTLoadValue = INT(name=u'id-RTLoadValue', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RTLoadValue._val = 535
    
    #-----< id-NRTLoadInformationValue >-----#
    id_NRTLoadInformationValue = INT(name=u'id-NRTLoadInformationValue', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NRTLoadInformationValue._val = 536
    
    #-----< id-CellPortionID >-----#
    id_CellPortionID = INT(name=u'id-CellPortionID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortionID._val = 537
    
    #-----< id-UpPTSInterferenceValue >-----#
    id_UpPTSInterferenceValue = INT(name=u'id-UpPTSInterferenceValue', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpPTSInterferenceValue._val = 538
    
    #-----< id-PrimaryCCPCH-RSCP-Delta >-----#
    id_PrimaryCCPCH_RSCP_Delta = INT(name=u'id-PrimaryCCPCH-RSCP-Delta', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrimaryCCPCH_RSCP_Delta._val = 539
    
    #-----< id-UEMeasurementType >-----#
    id_UEMeasurementType = INT(name=u'id-UEMeasurementType', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementType._val = 540
    
    #-----< id-UEMeasurementTimeslotInfoHCR >-----#
    id_UEMeasurementTimeslotInfoHCR = INT(name=u'id-UEMeasurementTimeslotInfoHCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementTimeslotInfoHCR._val = 541
    
    #-----< id-UEMeasurementTimeslotInfoLCR >-----#
    id_UEMeasurementTimeslotInfoLCR = INT(name=u'id-UEMeasurementTimeslotInfoLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementTimeslotInfoLCR._val = 542
    
    #-----< id-UEMeasurementReportCharacteristics >-----#
    id_UEMeasurementReportCharacteristics = INT(name=u'id-UEMeasurementReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementReportCharacteristics._val = 543
    
    #-----< id-UEMeasurementParameterModAllow >-----#
    id_UEMeasurementParameterModAllow = INT(name=u'id-UEMeasurementParameterModAllow', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementParameterModAllow._val = 544
    
    #-----< id-UEMeasurementValueInformation >-----#
    id_UEMeasurementValueInformation = INT(name=u'id-UEMeasurementValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementValueInformation._val = 545
    
    #-----< id-InterfacesToTraceItem >-----#
    id_InterfacesToTraceItem = INT(name=u'id-InterfacesToTraceItem', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InterfacesToTraceItem._val = 546
    
    #-----< id-ListOfInterfacesToTrace >-----#
    id_ListOfInterfacesToTrace = INT(name=u'id-ListOfInterfacesToTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ListOfInterfacesToTrace._val = 547
    
    #-----< id-TraceDepth >-----#
    id_TraceDepth = INT(name=u'id-TraceDepth', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceDepth._val = 548
    
    #-----< id-TraceRecordingSessionReference >-----#
    id_TraceRecordingSessionReference = INT(name=u'id-TraceRecordingSessionReference', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceRecordingSessionReference._val = 549
    
    #-----< id-TraceReference >-----#
    id_TraceReference = INT(name=u'id-TraceReference', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TraceReference._val = 550
    
    #-----< id-UEIdentity >-----#
    id_UEIdentity = INT(name=u'id-UEIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEIdentity._val = 551
    
    #-----< id-NACC-Related-Data >-----#
    id_NACC_Related_Data = INT(name=u'id-NACC-Related-Data', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NACC_Related_Data._val = 552
    
    #-----< id-GSM-Cell-InfEx-Rqst >-----#
    id_GSM_Cell_InfEx_Rqst = INT(name=u'id-GSM-Cell-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GSM_Cell_InfEx_Rqst._val = 553
    
    #-----< id-MeasurementRecoveryBehavior >-----#
    id_MeasurementRecoveryBehavior = INT(name=u'id-MeasurementRecoveryBehavior', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementRecoveryBehavior._val = 554
    
    #-----< id-MeasurementRecoveryReportingIndicator >-----#
    id_MeasurementRecoveryReportingIndicator = INT(name=u'id-MeasurementRecoveryReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementRecoveryReportingIndicator._val = 555
    
    #-----< id-MeasurementRecoverySupportIndicator >-----#
    id_MeasurementRecoverySupportIndicator = INT(name=u'id-MeasurementRecoverySupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementRecoverySupportIndicator._val = 556
    
    #-----< id-DL-DPCH-Power-Information-RL-ReconfPrepFDD >-----#
    id_DL_DPCH_Power_Information_RL_ReconfPrepFDD = INT(name=u'id-DL-DPCH-Power-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_Power_Information_RL_ReconfPrepFDD._val = 557
    
    #-----< id-F-DPCH-Information-RL-ReconfPrepFDD >-----#
    id_F_DPCH_Information_RL_ReconfPrepFDD = INT(name=u'id-F-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_Information_RL_ReconfPrepFDD._val = 558
    
    #-----< id-F-DPCH-Information-RL-SetupRqstFDD >-----#
    id_F_DPCH_Information_RL_SetupRqstFDD = INT(name=u'id-F-DPCH-Information-RL-SetupRqstFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_Information_RL_SetupRqstFDD._val = 559
    
    #-----< id-MBMS-Bearer-Service-List >-----#
    id_MBMS_Bearer_Service_List = INT(name=u'id-MBMS-Bearer-Service-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Bearer_Service_List._val = 560
    
    #-----< id-MBMS-Bearer-Service-List-InfEx-Rsp >-----#
    id_MBMS_Bearer_Service_List_InfEx_Rsp = INT(name=u'id-MBMS-Bearer-Service-List-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Bearer_Service_List_InfEx_Rsp._val = 561
    
    #-----< id-Active-MBMS-Bearer-ServiceFDD >-----#
    id_Active_MBMS_Bearer_ServiceFDD = INT(name=u'id-Active-MBMS-Bearer-ServiceFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Active_MBMS_Bearer_ServiceFDD._val = 562
    
    #-----< id-Active-MBMS-Bearer-ServiceTDD >-----#
    id_Active_MBMS_Bearer_ServiceTDD = INT(name=u'id-Active-MBMS-Bearer-ServiceTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Active_MBMS_Bearer_ServiceTDD._val = 563
    
    #-----< id-Old-URA-ID >-----#
    id_Old_URA_ID = INT(name=u'id-Old-URA-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Old_URA_ID._val = 564
    
    #-----< id-UE-State >-----#
    id_UE_State = INT(name=u'id-UE-State', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_State._val = 568
    
    #-----< id-URA-ID >-----#
    id_URA_ID = INT(name=u'id-URA-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_URA_ID._val = 569
    
    #-----< id-HARQ-Preamble-Mode >-----#
    id_HARQ_Preamble_Mode = INT(name=u'id-HARQ-Preamble-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HARQ_Preamble_Mode._val = 571
    
    #-----< id-SynchronisationIndicator >-----#
    id_SynchronisationIndicator = INT(name=u'id-SynchronisationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SynchronisationIndicator._val = 572
    
    #-----< id-UL-DPDCHIndicatorEDCH >-----#
    id_UL_DPDCHIndicatorEDCH = INT(name=u'id-UL-DPDCHIndicatorEDCH', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPDCHIndicatorEDCH._val = 573
    
    #-----< id-EDPCH-Information >-----#
    id_EDPCH_Information = INT(name=u'id-EDPCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDPCH_Information._val = 574
    
    #-----< id-RL-Specific-EDCH-Information >-----#
    id_RL_Specific_EDCH_Information = INT(name=u'id-RL-Specific-EDCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_Specific_EDCH_Information._val = 575
    
    #-----< id-EDCH-RL-Indication >-----#
    id_EDCH_RL_Indication = INT(name=u'id-EDCH-RL-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_RL_Indication._val = 576
    
    #-----< id-EDCH-FDD-Information >-----#
    id_EDCH_FDD_Information = INT(name=u'id-EDCH-FDD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_FDD_Information._val = 577
    
    #-----< id-EDCH-RLSet-Id >-----#
    id_EDCH_RLSet_Id = INT(name=u'id-EDCH-RLSet-Id', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_RLSet_Id._val = 578
    
    #-----< id-Serving-EDCHRL-Id >-----#
    id_Serving_EDCHRL_Id = INT(name=u'id-Serving-EDCHRL-Id', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_EDCHRL_Id._val = 579
    
    #-----< id-EDCH-FDD-DL-ControlChannelInformation >-----#
    id_EDCH_FDD_DL_ControlChannelInformation = INT(name=u'id-EDCH-FDD-DL-ControlChannelInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_FDD_DL_ControlChannelInformation._val = 580
    
    #-----< id-EDCH-FDD-InformationResponse >-----#
    id_EDCH_FDD_InformationResponse = INT(name=u'id-EDCH-FDD-InformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_FDD_InformationResponse._val = 581
    
    #-----< id-EDCH-MACdFlows-To-Add >-----#
    id_EDCH_MACdFlows_To_Add = INT(name=u'id-EDCH-MACdFlows-To-Add', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_MACdFlows_To_Add._val = 582
    
    #-----< id-EDCH-FDD-Information-To-Modify >-----#
    id_EDCH_FDD_Information_To_Modify = INT(name=u'id-EDCH-FDD-Information-To-Modify', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_FDD_Information_To_Modify._val = 583
    
    #-----< id-EDCH-MACdFlows-To-Delete >-----#
    id_EDCH_MACdFlows_To_Delete = INT(name=u'id-EDCH-MACdFlows-To-Delete', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_MACdFlows_To_Delete._val = 584
    
    #-----< id-EDPCH-Information-RLReconfRequest-FDD >-----#
    id_EDPCH_Information_RLReconfRequest_FDD = INT(name=u'id-EDPCH-Information-RLReconfRequest-FDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDPCH_Information_RLReconfRequest_FDD._val = 585
    
    #-----< id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd >-----#
    id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd = INT(name=u'id-EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd._val = 586
    
    #-----< id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd >-----#
    id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd = INT(name=u'id-EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd._val = 587
    
    #-----< id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd >-----#
    id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd = INT(name=u'id-EDCH-MacdFlowSpecificInformationList-RL-CongestInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd._val = 588
    
    #-----< id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd >-----#
    id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd = INT(name=u'id-EDCH-MacdFlowSpecificInformationItem-RL-CongestInd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd._val = 589
    
    #-----< id-MBMS-Bearer-Service-Full-Address >-----#
    id_MBMS_Bearer_Service_Full_Address = INT(name=u'id-MBMS-Bearer-Service-Full-Address', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Bearer_Service_Full_Address._val = 590
    
    #-----< id-Initial-DL-DPCH-TimingAdjustment >-----#
    id_Initial_DL_DPCH_TimingAdjustment = INT(name=u'id-Initial-DL-DPCH-TimingAdjustment', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Initial_DL_DPCH_TimingAdjustment._val = 591
    
    #-----< id-Initial-DL-DPCH-TimingAdjustment-Allowed >-----#
    id_Initial_DL_DPCH_TimingAdjustment_Allowed = INT(name=u'id-Initial-DL-DPCH-TimingAdjustment-Allowed', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Initial_DL_DPCH_TimingAdjustment_Allowed._val = 592
    
    #-----< id-User-Plane-Congestion-Fields-Inclusion >-----#
    id_User_Plane_Congestion_Fields_Inclusion = INT(name=u'id-User-Plane-Congestion-Fields-Inclusion', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_User_Plane_Congestion_Fields_Inclusion._val = 593
    
    #-----< id-HARQ-Preamble-Mode-Activation-Indicator >-----#
    id_HARQ_Preamble_Mode_Activation_Indicator = INT(name=u'id-HARQ-Preamble-Mode-Activation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HARQ_Preamble_Mode_Activation_Indicator._val = 594
    
    #-----< id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp >-----#
    id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp = INT(name=u'id-multiple-DedicatedMeasurementValueList-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp._val = 595
    
    #-----< id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp >-----#
    id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp = INT(name=u'id-multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp._val = 596
    
    #-----< id-ProvidedInformation >-----#
    id_ProvidedInformation = INT(name=u'id-ProvidedInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ProvidedInformation._val = 597
    
    #-----< id-Active-MBMS-Bearer-ServiceFDD-PFL >-----#
    id_Active_MBMS_Bearer_ServiceFDD_PFL = INT(name=u'id-Active-MBMS-Bearer-ServiceFDD-PFL', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Active_MBMS_Bearer_ServiceFDD_PFL._val = 598
    
    #-----< id-Active-MBMS-Bearer-ServiceTDD-PFL >-----#
    id_Active_MBMS_Bearer_ServiceTDD_PFL = INT(name=u'id-Active-MBMS-Bearer-ServiceTDD-PFL', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Active_MBMS_Bearer_ServiceTDD_PFL._val = 599
    
    #-----< id-FrequencyBandIndicator >-----#
    id_FrequencyBandIndicator = INT(name=u'id-FrequencyBandIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FrequencyBandIndicator._val = 600
    
    #-----< id-Serving-cell-change-CFN >-----#
    id_Serving_cell_change_CFN = INT(name=u'id-Serving-cell-change-CFN', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Serving_cell_change_CFN._val = 601
    
    #-----< id-HS-DSCH-serving-cell-change-information >-----#
    id_HS_DSCH_serving_cell_change_information = INT(name=u'id-HS-DSCH-serving-cell-change-information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_serving_cell_change_information._val = 602
    
    #-----< id-HS-DSCH-serving-cell-change-informationResponse >-----#
    id_HS_DSCH_serving_cell_change_informationResponse = INT(name=u'id-HS-DSCH-serving-cell-change-informationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_serving_cell_change_informationResponse._val = 603
    
    #-----< id-E-DCH-Serving-cell-change-informationResponse >-----#
    id_E_DCH_Serving_cell_change_informationResponse = INT(name=u'id-E-DCH-Serving-cell-change-informationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Serving_cell_change_informationResponse._val = 604
    
    #-----< id-secondary-LCR-CCPCH-Info-TDD >-----#
    id_secondary_LCR_CCPCH_Info_TDD = INT(name=u'id-secondary-LCR-CCPCH-Info-TDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_secondary_LCR_CCPCH_Info_TDD._val = 605
    
    #-----< id-E-DCH-FDD-Update-Information >-----#
    id_E_DCH_FDD_Update_Information = INT(name=u'id-E-DCH-FDD-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_FDD_Update_Information._val = 606
    
    #-----< id-Inter-Frequency-Cell-List >-----#
    id_Inter_Frequency_Cell_List = INT(name=u'id-Inter-Frequency-Cell-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_Frequency_Cell_List._val = 607
    
    #-----< id-Inter-Frequency-Cell-Information >-----#
    id_Inter_Frequency_Cell_Information = INT(name=u'id-Inter-Frequency-Cell-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_Frequency_Cell_Information._val = 608
    
    #-----< id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp >-----#
    id_multiple_HSSICHMeasurementValueList_TDD_DM_Rsp = INT(name=u'id-multiple-HSSICHMeasurementValueList-TDD-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_HSSICHMeasurementValueList_TDD_DM_Rsp._val = 609
    
    #-----< id-TDD-Support-PLCCH >-----#
    id_TDD_Support_PLCCH = INT(name=u'id-TDD-Support-PLCCH', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD_Support_PLCCH._val = 610
    
    #-----< id-PLCCH-Information-UL-TimeslotLCR-Info >-----#
    id_PLCCH_Information_UL_TimeslotLCR_Info = INT(name=u'id-PLCCH-Information-UL-TimeslotLCR-Info', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Information_UL_TimeslotLCR_Info._val = 611
    
    #-----< id-PLCCH-Information-PhyChReconfRqstTDD >-----#
    id_PLCCH_Information_PhyChReconfRqstTDD = INT(name=u'id-PLCCH-Information-PhyChReconfRqstTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLCCH_Information_PhyChReconfRqstTDD._val = 612
    
    #-----< id-TDD768-maxNrDLPhysicalchannelsTS >-----#
    id_TDD768_maxNrDLPhysicalchannelsTS = INT(name=u'id-TDD768-maxNrDLPhysicalchannelsTS', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD768_maxNrDLPhysicalchannelsTS._val = 613
    
    #-----< id-RL-InformationResponse-RL-AdditionRspTDD768 >-----#
    id_RL_InformationResponse_RL_AdditionRspTDD768 = INT(name=u'id-RL-InformationResponse-RL-AdditionRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_AdditionRspTDD768._val = 614
    
    #-----< id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD768 >-----#
    id_UL_CCTrCH_InformationListIE_RL_AdditionRspTDD768 = INT(name=u'id-UL-CCTrCH-InformationListIE-RL-AdditionRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationListIE_RL_AdditionRspTDD768._val = 615
    
    #-----< id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD768 >-----#
    id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD768 = INT(name=u'id-DL-CCTrCH-InformationListIE-RL-AdditionRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD768._val = 616
    
    #-----< id-UL-DPCH-InformationItem-RL-AdditionRspTDD768 >-----#
    id_UL_DPCH_InformationItem_RL_AdditionRspTDD768 = INT(name=u'id-UL-DPCH-InformationItem-RL-AdditionRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_RL_AdditionRspTDD768._val = 617
    
    #-----< id-DL-DPCH-InformationItem-RL-AdditionRspTDD768 >-----#
    id_DL_DPCH_InformationItem_RL_AdditionRspTDD768 = INT(name=u'id-DL-DPCH-InformationItem-RL-AdditionRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_RL_AdditionRspTDD768._val = 618
    
    #-----< id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768 >-----#
    id_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD768 = INT(name=u'id-UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD768._val = 619
    
    #-----< id-UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768 >-----#
    id_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768 = INT(name=u'id-UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768._val = 620
    
    #-----< id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768 >-----#
    id_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD768 = INT(name=u'id-DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD768._val = 621
    
    #-----< id-DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768 >-----#
    id_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768 = INT(name=u'id-DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768._val = 622
    
    #-----< id-secondary-CCPCH-Info-RL-ReconfReadyTDD768 >-----#
    id_secondary_CCPCH_Info_RL_ReconfReadyTDD768 = INT(name=u'id-secondary-CCPCH-Info-RL-ReconfReadyTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_secondary_CCPCH_Info_RL_ReconfReadyTDD768._val = 623
    
    #-----< id-hSSCCH-TDD-Specific-InfoList-Response768 >-----#
    id_hSSCCH_TDD_Specific_InfoList_Response768 = INT(name=u'id-hSSCCH-TDD-Specific-InfoList-Response768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_hSSCCH_TDD_Specific_InfoList_Response768._val = 624
    
    #-----< id-hSPDSCH-TDD-Specific-InfoList-Response768 >-----#
    id_hSPDSCH_TDD_Specific_InfoList_Response768 = INT(name=u'id-hSPDSCH-TDD-Specific-InfoList-Response768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_hSPDSCH_TDD_Specific_InfoList_Response768._val = 625
    
    #-----< id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768 >-----#
    id_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768 = INT(name=u'id-HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768._val = 626
    
    #-----< id-UL-Timeslot-InformationList-PhyChReconfRqstTDD768 >-----#
    id_UL_Timeslot_InformationList_PhyChReconfRqstTDD768 = INT(name=u'id-UL-Timeslot-InformationList-PhyChReconfRqstTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_Timeslot_InformationList_PhyChReconfRqstTDD768._val = 627
    
    #-----< id-DL-Timeslot-InformationList-PhyChReconfRqstTDD768 >-----#
    id_DL_Timeslot_InformationList_PhyChReconfRqstTDD768 = INT(name=u'id-DL-Timeslot-InformationList-PhyChReconfRqstTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_Timeslot_InformationList_PhyChReconfRqstTDD768._val = 628
    
    #-----< id-CellCapabilityContainer-TDD768 >-----#
    id_CellCapabilityContainer_TDD768 = INT(name=u'id-CellCapabilityContainer-TDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellCapabilityContainer_TDD768._val = 629
    
    #-----< id-multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp >-----#
    id_multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp = INT(name=u'id-multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp._val = 630
    
    #-----< id-neighbouringTDDCellMeasurementInformation768 >-----#
    id_neighbouringTDDCellMeasurementInformation768 = INT(name=u'id-neighbouringTDDCellMeasurementInformation768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_neighbouringTDDCellMeasurementInformation768._val = 631
    
    #-----< id-UEMeasurementTimeslotInfo768 >-----#
    id_UEMeasurementTimeslotInfo768 = INT(name=u'id-UEMeasurementTimeslotInfo768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementTimeslotInfo768._val = 632
    
    #-----< id-Rx-Timing-Deviation-Value-768 >-----#
    id_Rx_Timing_Deviation_Value_768 = INT(name=u'id-Rx-Timing-Deviation-Value-768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Rx_Timing_Deviation_Value_768._val = 633
    
    #-----< id-UEMeasurementValueTransmittedPowerList768 >-----#
    id_UEMeasurementValueTransmittedPowerList768 = INT(name=u'id-UEMeasurementValueTransmittedPowerList768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementValueTransmittedPowerList768._val = 634
    
    #-----< id-UEMeasurementValueTimeslotISCPList768 >-----#
    id_UEMeasurementValueTimeslotISCPList768 = INT(name=u'id-UEMeasurementValueTimeslotISCPList768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UEMeasurementValueTimeslotISCPList768._val = 635
    
    #-----< id-RL-InformationResponse-RL-SetupRspTDD768 >-----#
    id_RL_InformationResponse_RL_SetupRspTDD768 = INT(name=u'id-RL-InformationResponse-RL-SetupRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RL_InformationResponse_RL_SetupRspTDD768._val = 636
    
    #-----< id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD768 >-----#
    id_UL_CCTrCH_InformationListIE_RL_SetupRspTDD768 = INT(name=u'id-UL-CCTrCH-InformationListIE-RL-SetupRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CCTrCH_InformationListIE_RL_SetupRspTDD768._val = 637
    
    #-----< id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD768 >-----#
    id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD768 = INT(name=u'id-DL-CCTrCH-InformationListIE-RL-SetupRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD768._val = 638
    
    #-----< id-UL-DPCH-InformationItem-RL-SetupRspTDD768 >-----#
    id_UL_DPCH_InformationItem_RL_SetupRspTDD768 = INT(name=u'id-UL-DPCH-InformationItem-RL-SetupRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCH_InformationItem_RL_SetupRspTDD768._val = 639
    
    #-----< id-DL-DPCH-InformationItem-RL-SetupRspTDD768 >-----#
    id_DL_DPCH_InformationItem_RL_SetupRspTDD768 = INT(name=u'id-DL-DPCH-InformationItem-RL-SetupRspTDD768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationItem_RL_SetupRspTDD768._val = 640
    
    #-----< id-TDD768-minimumSpreadingFactor-UL >-----#
    id_TDD768_minimumSpreadingFactor_UL = INT(name=u'id-TDD768-minimumSpreadingFactor-UL', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD768_minimumSpreadingFactor_UL._val = 641
    
    #-----< id-TDD768-minimumSpreadingFactor-DL >-----#
    id_TDD768_minimumSpreadingFactor_DL = INT(name=u'id-TDD768-minimumSpreadingFactor-DL', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD768_minimumSpreadingFactor_DL._val = 642
    
    #-----< id-TDD768-maxNrDLPhysicalchannels >-----#
    id_TDD768_maxNrDLPhysicalchannels = INT(name=u'id-TDD768-maxNrDLPhysicalchannels', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TDD768_maxNrDLPhysicalchannels._val = 643
    
    #-----< id-DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD >-----#
    id_DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD = INT(name=u'id-DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD._val = 644
    
    #-----< id-DPCH-ID768-DM-Rsp >-----#
    id_DPCH_ID768_DM_Rsp = INT(name=u'id-DPCH-ID768-DM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCH_ID768_DM_Rsp._val = 645
    
    #-----< id-DPCH-ID768-DM-Rqst >-----#
    id_DPCH_ID768_DM_Rqst = INT(name=u'id-DPCH-ID768-DM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCH_ID768_DM_Rqst._val = 646
    
    #-----< id-DPCH-ID768-DM-Rprt >-----#
    id_DPCH_ID768_DM_Rprt = INT(name=u'id-DPCH-ID768-DM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DPCH_ID768_DM_Rprt._val = 647
    
    #-----< id-EDPCH-Information-RLAdditionReq-FDD >-----#
    id_EDPCH_Information_RLAdditionReq_FDD = INT(name=u'id-EDPCH-Information-RLAdditionReq-FDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDPCH_Information_RLAdditionReq_FDD._val = 648
    
    #-----< id-HSDSCH-Configured-Indicator >-----#
    id_HSDSCH_Configured_Indicator = INT(name=u'id-HSDSCH-Configured-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Configured_Indicator._val = 649
    
    #-----< id-RxTimingDeviationForTAext >-----#
    id_RxTimingDeviationForTAext = INT(name=u'id-RxTimingDeviationForTAext', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RxTimingDeviationForTAext._val = 650
    
    #-----< id-RxTimingDeviationForTA768 >-----#
    id_RxTimingDeviationForTA768 = INT(name=u'id-RxTimingDeviationForTA768', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RxTimingDeviationForTA768._val = 651
    
    #-----< id-Rx-Timing-Deviation-Value-ext >-----#
    id_Rx_Timing_Deviation_Value_ext = INT(name=u'id-Rx-Timing-Deviation-Value-ext', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Rx_Timing_Deviation_Value_ext._val = 652
    
    #-----< id-E-DCH-PowerOffset-for-SchedulingInfo >-----#
    id_E_DCH_PowerOffset_for_SchedulingInfo = INT(name=u'id-E-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_PowerOffset_for_SchedulingInfo._val = 653
    
    #-----< id-TrCH-SrcStatisticsDescr >-----#
    id_TrCH_SrcStatisticsDescr = INT(name=u'id-TrCH-SrcStatisticsDescr', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TrCH_SrcStatisticsDescr._val = 654
    
    #-----< id-E-DCH-Information >-----#
    id_E_DCH_Information = INT(name=u'id-E-DCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Information._val = 655
    
    #-----< id-E-DCH-Serving-RL-ID >-----#
    id_E_DCH_Serving_RL_ID = INT(name=u'id-E-DCH-Serving-RL-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Serving_RL_ID._val = 656
    
    #-----< id-E-DCH-Information-Reconfig >-----#
    id_E_DCH_Information_Reconfig = INT(name=u'id-E-DCH-Information-Reconfig', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Information_Reconfig._val = 657
    
    #-----< id-E-DCH-Information-Response >-----#
    id_E_DCH_Information_Response = INT(name=u'id-E-DCH-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Information_Response._val = 658
    
    #-----< id-E-DCH-768-Information >-----#
    id_E_DCH_768_Information = INT(name=u'id-E-DCH-768-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_768_Information._val = 659
    
    #-----< id-E-DCH-768-Information-Reconfig >-----#
    id_E_DCH_768_Information_Reconfig = INT(name=u'id-E-DCH-768-Information-Reconfig', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_768_Information_Reconfig._val = 660
    
    #-----< id-E-DCH-768-Information-Response >-----#
    id_E_DCH_768_Information_Response = INT(name=u'id-E-DCH-768-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_768_Information_Response._val = 661
    
    #-----< id-ExtendedPropagationDelay >-----#
    id_ExtendedPropagationDelay = INT(name=u'id-ExtendedPropagationDelay', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedPropagationDelay._val = 662
    
    #-----< id-Extended-Round-Trip-Time-Value >-----#
    id_Extended_Round_Trip_Time_Value = INT(name=u'id-Extended-Round-Trip-Time-Value', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_Round_Trip_Time_Value._val = 663
    
    #-----< id-AlternativeFormatReportingIndicator >-----#
    id_AlternativeFormatReportingIndicator = INT(name=u'id-AlternativeFormatReportingIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AlternativeFormatReportingIndicator._val = 664
    
    #-----< id-DCH-Indicator-For-E-DCH-HSDPA-Operation >-----#
    id_DCH_Indicator_For_E_DCH_HSDPA_Operation = INT(name=u'id-DCH-Indicator-For-E-DCH-HSDPA-Operation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_Indicator_For_E_DCH_HSDPA_Operation._val = 665
    
    #-----< id-E-RGCH-E-HICH-ChannelisationCodeValidityIndicator >-----#
    id_E_RGCH_E_HICH_ChannelisationCodeValidityIndicator = INT(name=u'id-E-RGCH-E-HICH-ChannelisationCodeValidityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RGCH_E_HICH_ChannelisationCodeValidityIndicator._val = 666
    
    #-----< id-E-DCH-Minimum-Set-E-TFCIValidityIndicator >-----#
    id_E_DCH_Minimum_Set_E_TFCIValidityIndicator = INT(name=u'id-E-DCH-Minimum-Set-E-TFCIValidityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Minimum_Set_E_TFCIValidityIndicator._val = 667
    
    #-----< id-Fast-Reconfiguration-Mode >-----#
    id_Fast_Reconfiguration_Mode = INT(name=u'id-Fast-Reconfiguration-Mode', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_Reconfiguration_Mode._val = 668
    
    #-----< id-Fast-Reconfiguration-Permission >-----#
    id_Fast_Reconfiguration_Permission = INT(name=u'id-Fast-Reconfiguration-Permission', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_Reconfiguration_Permission._val = 669
    
    #-----< id-Continuous-Packet-Connectivity-DTX-DRX-Information >-----#
    id_Continuous_Packet_Connectivity_DTX_DRX_Information = INT(name=u'id-Continuous-Packet-Connectivity-DTX-DRX-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Continuous_Packet_Connectivity_DTX_DRX_Information._val = 670
    
    #-----< id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information >-----#
    id_Continuous_Packet_Connectivity_HS_SCCH_Less_Information = INT(name=u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Continuous_Packet_Connectivity_HS_SCCH_Less_Information._val = 671
    
    #-----< id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response >-----#
    id_Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response = INT(name=u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response._val = 672
    
    #-----< id-CPC-Information >-----#
    id_CPC_Information = INT(name=u'id-CPC-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPC_Information._val = 673
    
    #-----< id-MIMO-InformationResponse >-----#
    id_MIMO_InformationResponse = INT(name=u'id-MIMO-InformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_InformationResponse._val = 675
    
    #-----< id-E-DCH-LCR-Information >-----#
    id_E_DCH_LCR_Information = INT(name=u'id-E-DCH-LCR-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_LCR_Information._val = 677
    
    #-----< id-E-DCH-LCR-Information-Reconfig >-----#
    id_E_DCH_LCR_Information_Reconfig = INT(name=u'id-E-DCH-LCR-Information-Reconfig', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_LCR_Information_Reconfig._val = 678
    
    #-----< id-E-DCH-LCR-Information-Response >-----#
    id_E_DCH_LCR_Information_Response = INT(name=u'id-E-DCH-LCR-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_LCR_Information_Response._val = 679
    
    #-----< id-HS-PDSCH-Code-Change-Grant >-----#
    id_HS_PDSCH_Code_Change_Grant = INT(name=u'id-HS-PDSCH-Code-Change-Grant', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_Code_Change_Grant._val = 680
    
    #-----< id-HS-PDSCH-Code-Change-Indicator >-----#
    id_HS_PDSCH_Code_Change_Indicator = INT(name=u'id-HS-PDSCH-Code-Change-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_PDSCH_Code_Change_Indicator._val = 681
    
    #-----< id-Extended-SRNC-ID >-----#
    id_Extended_SRNC_ID = INT(name=u'id-Extended-SRNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_SRNC_ID._val = 682
    
    #-----< id-Extended-RNC-ID >-----#
    id_Extended_RNC_ID = INT(name=u'id-Extended-RNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_RNC_ID._val = 683
    
    #-----< id-SixtyfourQAM-DL-SupportIndicator >-----#
    id_SixtyfourQAM_DL_SupportIndicator = INT(name=u'id-SixtyfourQAM-DL-SupportIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_DL_SupportIndicator._val = 684
    
    #-----< id-Enhanced-FACH-Support-Indicator >-----#
    id_Enhanced_FACH_Support_Indicator = INT(name=u'id-Enhanced-FACH-Support-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_FACH_Support_Indicator._val = 685
    
    #-----< id-Enhanced-FACH-Information-ResponseFDD >-----#
    id_Enhanced_FACH_Information_ResponseFDD = INT(name=u'id-Enhanced-FACH-Information-ResponseFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_FACH_Information_ResponseFDD._val = 686
    
    #-----< id-HSDSCH-MACdPDUSizeFormat >-----#
    id_HSDSCH_MACdPDUSizeFormat = INT(name=u'id-HSDSCH-MACdPDUSizeFormat', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_MACdPDUSizeFormat._val = 690
    
    #-----< id-MaximumMACdPDU-SizeExtended >-----#
    id_MaximumMACdPDU_SizeExtended = INT(name=u'id-MaximumMACdPDU-SizeExtended', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumMACdPDU_SizeExtended._val = 691
    
    #-----< id-F-DPCH-SlotFormat >-----#
    id_F_DPCH_SlotFormat = INT(name=u'id-F-DPCH-SlotFormat', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_SlotFormat._val = 692
    
    #-----< id-F-DPCH-SlotFormatSupportRequest >-----#
    id_F_DPCH_SlotFormatSupportRequest = INT(name=u'id-F-DPCH-SlotFormatSupportRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_F_DPCH_SlotFormatSupportRequest._val = 693
    
    #-----< id-eDCH-MACdFlow-Retransmission-Timer-LCR >-----#
    id_eDCH_MACdFlow_Retransmission_Timer_LCR = INT(name=u'id-eDCH-MACdFlow-Retransmission-Timer-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_eDCH_MACdFlow_Retransmission_Timer_LCR._val = 694
    
    #-----< id-Max-UE-DTX-Cycle >-----#
    id_Max_UE_DTX_Cycle = INT(name=u'id-Max-UE-DTX-Cycle', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Max_UE_DTX_Cycle._val = 695
    
    #-----< id-GANSS-Common-Data >-----#
    id_GANSS_Common_Data = INT(name=u'id-GANSS-Common-Data', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Common_Data._val = 699
    
    #-----< id-GANSS-Information >-----#
    id_GANSS_Information = INT(name=u'id-GANSS-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Information._val = 700
    
    #-----< id-GANSS-Generic-Data >-----#
    id_GANSS_Generic_Data = INT(name=u'id-GANSS-Generic-Data', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Generic_Data._val = 701
    
    #-----< id-TUTRANGANSSMeasurementThresholdInformation >-----#
    id_TUTRANGANSSMeasurementThresholdInformation = INT(name=u'id-TUTRANGANSSMeasurementThresholdInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGANSSMeasurementThresholdInformation._val = 702
    
    #-----< id-TUTRANGANSSMeasurementValueInformation >-----#
    id_TUTRANGANSSMeasurementValueInformation = INT(name=u'id-TUTRANGANSSMeasurementValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGANSSMeasurementValueInformation._val = 703
    
    #-----< id-Ext-Reference-E-TFCI-PO >-----#
    id_Ext_Reference_E_TFCI_PO = INT(name=u'id-Ext-Reference-E-TFCI-PO', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ext_Reference_E_TFCI_PO._val = 705
    
    #-----< id-Ext-Max-Bits-MACe-PDU-non-scheduled >-----#
    id_Ext_Max_Bits_MACe_PDU_non_scheduled = INT(name=u'id-Ext-Max-Bits-MACe-PDU-non-scheduled', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Ext_Max_Bits_MACe_PDU_non_scheduled._val = 706
    
    #-----< id-HARQ-MemoryPartitioningInfoExtForMIMO >-----#
    id_HARQ_MemoryPartitioningInfoExtForMIMO = INT(name=u'id-HARQ-MemoryPartitioningInfoExtForMIMO', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HARQ_MemoryPartitioningInfoExtForMIMO._val = 707
    
    #-----< id-MIMO-ActivationIndicator >-----#
    id_MIMO_ActivationIndicator = INT(name=u'id-MIMO-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_ActivationIndicator._val = 708
    
    #-----< id-MIMO-Mode-Indicator >-----#
    id_MIMO_Mode_Indicator = INT(name=u'id-MIMO-Mode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_Mode_Indicator._val = 709
    
    #-----< id-MIMO-N-M-Ratio >-----#
    id_MIMO_N_M_Ratio = INT(name=u'id-MIMO-N-M-Ratio', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_N_M_Ratio._val = 710
    
    #-----< id-TransportBearerNotSetupIndicator >-----#
    id_TransportBearerNotSetupIndicator = INT(name=u'id-TransportBearerNotSetupIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerNotSetupIndicator._val = 711
    
    #-----< id-TransportBearerNotRequestedIndicator >-----#
    id_TransportBearerNotRequestedIndicator = INT(name=u'id-TransportBearerNotRequestedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransportBearerNotRequestedIndicator._val = 712
    
    #-----< id-PowerControlGAP >-----#
    id_PowerControlGAP = INT(name=u'id-PowerControlGAP', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PowerControlGAP._val = 713
    
    #-----< id-UARFCNforNt >-----#
    id_UARFCNforNt = INT(name=u'id-UARFCNforNt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UARFCNforNt._val = 714
    
    #-----< id-LCRTDD-uplink-Physical-Channel-Capability >-----#
    id_LCRTDD_uplink_Physical_Channel_Capability = INT(name=u'id-LCRTDD-uplink-Physical-Channel-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LCRTDD_uplink_Physical_Channel_Capability._val = 715
    
    #-----< id-number-Of-Supported-Carriers >-----#
    id_number_Of_Supported_Carriers = INT(name=u'id-number-Of-Supported-Carriers', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_number_Of_Supported_Carriers._val = 716
    
    #-----< id-HSSICH-SIRTarget >-----#
    id_HSSICH_SIRTarget = INT(name=u'id-HSSICH-SIRTarget', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_SIRTarget._val = 717
    
    #-----< id-HSSICH-TPC-StepSize >-----#
    id_HSSICH_TPC_StepSize = INT(name=u'id-HSSICH-TPC-StepSize', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_TPC_StepSize._val = 718
    
    #-----< id-tSN-Length >-----#
    id_tSN_Length = INT(name=u'id-tSN-Length', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_tSN_Length._val = 719
    
    #-----< id-HS-SICH-ID-Extension >-----#
    id_HS_SICH_ID_Extension = INT(name=u'id-HS-SICH-ID-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SICH_ID_Extension._val = 720
    
    #-----< id-HSSICH-Info-DM-Rqst-Extension >-----#
    id_HSSICH_Info_DM_Rqst_Extension = INT(name=u'id-HSSICH-Info-DM-Rqst-Extension', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSSICH_Info_DM_Rqst_Extension._val = 721
    
    #-----< id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR >-----#
    id_multipleFreq_HSPDSCH_InformationList_ResponseTDDLCR = INT(name=u'id-multipleFreq-HSPDSCH-InformationList-ResponseTDDLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multipleFreq_HSPDSCH_InformationList_ResponseTDDLCR._val = 722
    
    #-----< id-multicarrier-number >-----#
    id_multicarrier_number = INT(name=u'id-multicarrier-number', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_multicarrier_number._val = 723
    
    #-----< id-UPPCHPositionLCR >-----#
    id_UPPCHPositionLCR = INT(name=u'id-UPPCHPositionLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPPCHPositionLCR._val = 724
    
    #-----< id-UpPCH-InformationList-LCRTDD >-----#
    id_UpPCH_InformationList_LCRTDD = INT(name=u'id-UpPCH-InformationList-LCRTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpPCH_InformationList_LCRTDD._val = 725
    
    #-----< id-UpPCH-InformationItem-LCRTDD >-----#
    id_UpPCH_InformationItem_LCRTDD = INT(name=u'id-UpPCH-InformationItem-LCRTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UpPCH_InformationItem_LCRTDD._val = 726
    
    #-----< id-Multiple-PLMN-List >-----#
    id_Multiple_PLMN_List = INT(name=u'id-Multiple-PLMN-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiple_PLMN_List._val = 727
    
    #-----< id-UE-Capabilities-Info >-----#
    id_UE_Capabilities_Info = INT(name=u'id-UE-Capabilities-Info', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Capabilities_Info._val = 728
    
    #-----< id-FrameOffset >-----#
    id_FrameOffset = INT(name=u'id-FrameOffset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FrameOffset._val = 729
    
    #-----< id-ChipOffset >-----#
    id_ChipOffset = INT(name=u'id-ChipOffset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ChipOffset._val = 730
    
    #-----< id-Enhanced-PCH-Capability >-----#
    id_Enhanced_PCH_Capability = INT(name=u'id-Enhanced-PCH-Capability', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_PCH_Capability._val = 731
    
    #-----< id-SixteenQAM-UL-Operation-Indicator >-----#
    id_SixteenQAM_UL_Operation_Indicator = INT(name=u'id-SixteenQAM-UL-Operation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixteenQAM_UL_Operation_Indicator._val = 732
    
    #-----< id-E-TFCI-Boost-Information >-----#
    id_E_TFCI_Boost_Information = INT(name=u'id-E-TFCI-Boost-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_TFCI_Boost_Information._val = 733
    
    #-----< id-SixtyfourQAM-UsageAllowedIndicator >-----#
    id_SixtyfourQAM_UsageAllowedIndicator = INT(name=u'id-SixtyfourQAM-UsageAllowedIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_UsageAllowedIndicator._val = 734
    
    #-----< id-SixtyfourQAM-DL-UsageIndicator >-----#
    id_SixtyfourQAM_DL_UsageIndicator = INT(name=u'id-SixtyfourQAM-DL-UsageIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_DL_UsageIndicator._val = 735
    
    #-----< id-Default-Serving-Grant-in-DTX-Cycle2 >-----#
    id_Default_Serving_Grant_in_DTX_Cycle2 = INT(name=u'id-Default-Serving-Grant-in-DTX-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Default_Serving_Grant_in_DTX_Cycle2._val = 736
    
    #-----< id-E-DPDCH-PowerInterpolation >-----#
    id_E_DPDCH_PowerInterpolation = INT(name=u'id-E-DPDCH-PowerInterpolation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DPDCH_PowerInterpolation._val = 737
    
    #-----< id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    id_Extended_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name=u'id-Extended-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_E_DCH_LCRTDD_PhysicalLayerCategory._val = 738
    
    #-----< id-E-DCH-MACdPDUSizeFormat >-----#
    id_E_DCH_MACdPDUSizeFormat = INT(name=u'id-E-DCH-MACdPDUSizeFormat', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_MACdPDUSizeFormat._val = 739
    
    #-----< id-Continuous-Packet-Connectivity-HS-SCCH-Less-Deactivate-Indicator >-----#
    id_Continuous_Packet_Connectivity_HS_SCCH_Less_Deactivate_Indicator = INT(name=u'id-Continuous-Packet-Connectivity-HS-SCCH-Less-Deactivate-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Continuous_Packet_Connectivity_HS_SCCH_Less_Deactivate_Indicator._val = 740
    
    #-----< id-E-DCH-DL-Control-Channel-Change-Information >-----#
    id_E_DCH_DL_Control_Channel_Change_Information = INT(name=u'id-E-DCH-DL-Control-Channel-Change-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_DL_Control_Channel_Change_Information._val = 741
    
    #-----< id-E-DCH-DL-Control-Channel-Grant-Information >-----#
    id_E_DCH_DL_Control_Channel_Grant_Information = INT(name=u'id-E-DCH-DL-Control-Channel-Grant-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_DL_Control_Channel_Grant_Information._val = 742
    
    #-----< id-MaximumNumber-Of-Retransmission-For-SchedulingInfo-LCRTDD >-----#
    id_MaximumNumber_Of_Retransmission_For_SchedulingInfo_LCRTDD = INT(name=u'id-MaximumNumber-Of-Retransmission-For-SchedulingInfo-LCRTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MaximumNumber_Of_Retransmission_For_SchedulingInfo_LCRTDD._val = 743
    
    #-----< id-E-DCH-RetransmissionTimer-For-SchedulingInfo-LCRTDD >-----#
    id_E_DCH_RetransmissionTimer_For_SchedulingInfo_LCRTDD = INT(name=u'id-E-DCH-RetransmissionTimer-For-SchedulingInfo-LCRTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_RetransmissionTimer_For_SchedulingInfo_LCRTDD._val = 744
    
    #-----< id-E-PUCH-PowerControlGAP >-----#
    id_E_PUCH_PowerControlGAP = INT(name=u'id-E-PUCH-PowerControlGAP', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_PUCH_PowerControlGAP._val = 745
    
    #-----< id-HSDSCH-TBSizeTableIndicator >-----#
    id_HSDSCH_TBSizeTableIndicator = INT(name=u'id-HSDSCH-TBSizeTableIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_TBSizeTableIndicator._val = 746
    
    #-----< id-UE-with-enhanced-HS-SCCH-support-indicator >-----#
    id_UE_with_enhanced_HS_SCCH_support_indicator = INT(name=u'id-UE-with-enhanced-HS-SCCH-support-indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_with_enhanced_HS_SCCH_support_indicator._val = 747
    
    #-----< id-DGANSS-Corrections-Req >-----#
    id_DGANSS_Corrections_Req = INT(name=u'id-DGANSS-Corrections-Req', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DGANSS_Corrections_Req._val = 748
    
    #-----< id-E-AGCH-Table-Choice >-----#
    id_E_AGCH_Table_Choice = INT(name=u'id-E-AGCH-Table-Choice', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_Table_Choice._val = 749
    
    #-----< id-RANAP-EnhancedRelocationInformationRequest >-----#
    id_RANAP_EnhancedRelocationInformationRequest = INT(name=u'id-RANAP-EnhancedRelocationInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANAP_EnhancedRelocationInformationRequest._val = 750
    
    #-----< id-RANAP-EnhancedRelocationInformationResponse >-----#
    id_RANAP_EnhancedRelocationInformationResponse = INT(name=u'id-RANAP-EnhancedRelocationInformationResponse', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RANAP_EnhancedRelocationInformationResponse._val = 751
    
    #-----< id-Common-EDCH-MAC-d-Flow-Specific-InformationFDD >-----#
    id_Common_EDCH_MAC_d_Flow_Specific_InformationFDD = INT(name=u'id-Common-EDCH-MAC-d-Flow-Specific-InformationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_MAC_d_Flow_Specific_InformationFDD._val = 752
    
    #-----< id-Common-EDCH-Support-Indicator >-----#
    id_Common_EDCH_Support_Indicator = INT(name=u'id-Common-EDCH-Support-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_Support_Indicator._val = 753
    
    #-----< id-E-RNTI >-----#
    id_E_RNTI = INT(name=u'id-E-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI._val = 754
    
    #-----< id-Released-CN-Domain >-----#
    id_Released_CN_Domain = INT(name=u'id-Released-CN-Domain', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Released_CN_Domain._val = 755
    
    #-----< id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst >-----#
    id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst = INT(name=u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst._val = 756
    
    #-----< id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp >-----#
    id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp = INT(name=u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp._val = 757
    
    #-----< id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt >-----#
    id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt = INT(name=u'id-MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt._val = 758
    
    #-----< id-MBMS-Cell-InfEx-Rqst >-----#
    id_MBMS_Cell_InfEx_Rqst = INT(name=u'id-MBMS-Cell-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Cell_InfEx_Rqst._val = 759
    
    #-----< id-MBMS-Cell-InfEx-Rsp >-----#
    id_MBMS_Cell_InfEx_Rsp = INT(name=u'id-MBMS-Cell-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Cell_InfEx_Rsp._val = 760
    
    #-----< id-MBMS-Cell-InfEx-Rprt >-----#
    id_MBMS_Cell_InfEx_Rprt = INT(name=u'id-MBMS-Cell-InfEx-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Cell_InfEx_Rprt._val = 761
    
    #-----< id-Counting-Information >-----#
    id_Counting_Information = INT(name=u'id-Counting-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Counting_Information._val = 762
    
    #-----< id-Transmission-Mode-Information >-----#
    id_Transmission_Mode_Information = INT(name=u'id-Transmission-Mode-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Transmission_Mode_Information._val = 763
    
    #-----< id-MBMS-Neighbouring-Cell-Information >-----#
    id_MBMS_Neighbouring_Cell_Information = INT(name=u'id-MBMS-Neighbouring-Cell-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_Neighbouring_Cell_Information._val = 764
    
    #-----< id-MBMS-RLC-Sequence-Number-Information >-----#
    id_MBMS_RLC_Sequence_Number_Information = INT(name=u'id-MBMS-RLC-Sequence-Number-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBMS_RLC_Sequence_Number_Information._val = 765
    
    #-----< id-RLC-Sequence-Number >-----#
    id_RLC_Sequence_Number = INT(name=u'id-RLC-Sequence-Number', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RLC_Sequence_Number._val = 766
    
    #-----< id-Neighbouring-E-UTRA-CellInformation >-----#
    id_Neighbouring_E_UTRA_CellInformation = INT(name=u'id-Neighbouring-E-UTRA-CellInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbouring_E_UTRA_CellInformation._val = 767
    
    #-----< id-MBSFN-Cluster-Identity >-----#
    id_MBSFN_Cluster_Identity = INT(name=u'id-MBSFN-Cluster-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Cluster_Identity._val = 769
    
    #-----< id-MCCH-Configuration-Info >-----#
    id_MCCH_Configuration_Info = INT(name=u'id-MCCH-Configuration-Info', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCCH_Configuration_Info._val = 770
    
    #-----< id-MCCH-Message-List >-----#
    id_MCCH_Message_List = INT(name=u'id-MCCH-Message-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MCCH_Message_List._val = 771
    
    #-----< id-MBSFN-Scheduling-Transmission-Time-Interval-Info-List >-----#
    id_MBSFN_Scheduling_Transmission_Time_Interval_Info_List = INT(name=u'id-MBSFN-Scheduling-Transmission-Time-Interval-Info-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MBSFN_Scheduling_Transmission_Time_Interval_Info_List._val = 772
    
    #-----< id-GANSS-Time-ID >-----#
    id_GANSS_Time_ID = INT(name=u'id-GANSS-Time-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Time_ID._val = 773
    
    #-----< id-GANSS-AddIonoModelReq >-----#
    id_GANSS_AddIonoModelReq = INT(name=u'id-GANSS-AddIonoModelReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddIonoModelReq._val = 774
    
    #-----< id-GANSS-EarthOrientParaReq >-----#
    id_GANSS_EarthOrientParaReq = INT(name=u'id-GANSS-EarthOrientParaReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_EarthOrientParaReq._val = 775
    
    #-----< id-GANSS-AddNavigationModelsReq >-----#
    id_GANSS_AddNavigationModelsReq = INT(name=u'id-GANSS-AddNavigationModelsReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddNavigationModelsReq._val = 776
    
    #-----< id-GANSS-AddUTCModelsReq >-----#
    id_GANSS_AddUTCModelsReq = INT(name=u'id-GANSS-AddUTCModelsReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddUTCModelsReq._val = 777
    
    #-----< id-GANSS-AuxInfoReq >-----#
    id_GANSS_AuxInfoReq = INT(name=u'id-GANSS-AuxInfoReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AuxInfoReq._val = 778
    
    #-----< id-GANSS-SBAS-ID >-----#
    id_GANSS_SBAS_ID = INT(name=u'id-GANSS-SBAS-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_SBAS_ID._val = 779
    
    #-----< id-GANSS-ID >-----#
    id_GANSS_ID = INT(name=u'id-GANSS-ID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_ID._val = 780
    
    #-----< id-GANSS-Additional-Ionospheric-Model >-----#
    id_GANSS_Additional_Ionospheric_Model = INT(name=u'id-GANSS-Additional-Ionospheric-Model', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Ionospheric_Model._val = 781
    
    #-----< id-GANSS-Earth-Orientation-Parameters >-----#
    id_GANSS_Earth_Orientation_Parameters = INT(name=u'id-GANSS-Earth-Orientation-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Earth_Orientation_Parameters._val = 782
    
    #-----< id-GANSS-Additional-Time-Models >-----#
    id_GANSS_Additional_Time_Models = INT(name=u'id-GANSS-Additional-Time-Models', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Time_Models._val = 783
    
    #-----< id-GANSS-Additional-Navigation-Models >-----#
    id_GANSS_Additional_Navigation_Models = INT(name=u'id-GANSS-Additional-Navigation-Models', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Navigation_Models._val = 784
    
    #-----< id-GANSS-Additional-UTC-Models >-----#
    id_GANSS_Additional_UTC_Models = INT(name=u'id-GANSS-Additional-UTC-Models', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_UTC_Models._val = 785
    
    #-----< id-GANSS-Auxiliary-Information >-----#
    id_GANSS_Auxiliary_Information = INT(name=u'id-GANSS-Auxiliary-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Auxiliary_Information._val = 786
    
    #-----< id-MinimumReducedE-DPDCH-GainFactor >-----#
    id_MinimumReducedE_DPDCH_GainFactor = INT(name=u'id-MinimumReducedE-DPDCH-GainFactor', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MinimumReducedE_DPDCH_GainFactor._val = 787
    
    #-----< id-Enhanced-FACH-Information-ResponseLCR >-----#
    id_Enhanced_FACH_Information_ResponseLCR = INT(name=u'id-Enhanced-FACH-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Enhanced_FACH_Information_ResponseLCR._val = 788
    
    #-----< id-Common-EDCH-MAC-d-Flow-Specific-InformationLCR >-----#
    id_Common_EDCH_MAC_d_Flow_Specific_InformationLCR = INT(name=u'id-Common-EDCH-MAC-d-Flow-Specific-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_EDCH_MAC_d_Flow_Specific_InformationLCR._val = 789
    
    #-----< id-HSDSCH-PreconfigurationSetup >-----#
    id_HSDSCH_PreconfigurationSetup = INT(name=u'id-HSDSCH-PreconfigurationSetup', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_PreconfigurationSetup._val = 790
    
    #-----< id-HSDSCH-PreconfigurationInfo >-----#
    id_HSDSCH_PreconfigurationInfo = INT(name=u'id-HSDSCH-PreconfigurationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_PreconfigurationInfo._val = 791
    
    #-----< id-NoOfTargetCellHS-SCCH-Order >-----#
    id_NoOfTargetCellHS_SCCH_Order = INT(name=u'id-NoOfTargetCellHS-SCCH-Order', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NoOfTargetCellHS_SCCH_Order._val = 792
    
    #-----< id-EnhancedHSServingCC-Abort >-----#
    id_EnhancedHSServingCC_Abort = INT(name=u'id-EnhancedHSServingCC-Abort', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EnhancedHSServingCC_Abort._val = 793
    
    #-----< id-Additional-HS-Cell-Information-RL-Setup >-----#
    id_Additional_HS_Cell_Information_RL_Setup = INT(name=u'id-Additional-HS-Cell-Information-RL-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Setup._val = 794
    
    #-----< id-Additional-HS-Cell-Information-Response >-----#
    id_Additional_HS_Cell_Information_Response = INT(name=u'id-Additional-HS-Cell-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_Response._val = 795
    
    #-----< id-Additional-HS-Cell-Information-RL-Addition >-----#
    id_Additional_HS_Cell_Information_RL_Addition = INT(name=u'id-Additional-HS-Cell-Information-RL-Addition', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Addition._val = 796
    
    #-----< id-Additional-HS-Cell-Change-Information-Response >-----#
    id_Additional_HS_Cell_Change_Information_Response = INT(name=u'id-Additional-HS-Cell-Change-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Change_Information_Response._val = 797
    
    #-----< id-Additional-HS-Cell-Information-RL-Reconf-Prep >-----#
    id_Additional_HS_Cell_Information_RL_Reconf_Prep = INT(name=u'id-Additional-HS-Cell-Information-RL-Reconf-Prep', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Reconf_Prep._val = 798
    
    #-----< id-Additional-HS-Cell-Information-RL-Reconf-Req >-----#
    id_Additional_HS_Cell_Information_RL_Reconf_Req = INT(name=u'id-Additional-HS-Cell-Information-RL-Reconf-Req', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Reconf_Req._val = 799
    
    #-----< id-Additional-HS-Cell-RL-Reconf-Response >-----#
    id_Additional_HS_Cell_RL_Reconf_Response = INT(name=u'id-Additional-HS-Cell-RL-Reconf-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_RL_Reconf_Response._val = 800
    
    #-----< id-Additional-HS-Cell-Information-RL-Param-Upd >-----#
    id_Additional_HS_Cell_Information_RL_Param_Upd = INT(name=u'id-Additional-HS-Cell-Information-RL-Param-Upd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_HS_Cell_Information_RL_Param_Upd._val = 801
    
    #-----< id-Secondary-Serving-Cell-List >-----#
    id_Secondary_Serving_Cell_List = INT(name=u'id-Secondary-Serving-Cell-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Secondary_Serving_Cell_List._val = 802
    
    #-----< id-MultiCarrier-HSDSCH-Physical-Layer-Category >-----#
    id_MultiCarrier_HSDSCH_Physical_Layer_Category = INT(name=u'id-MultiCarrier-HSDSCH-Physical-Layer-Category', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultiCarrier_HSDSCH_Physical_Layer_Category._val = 803
    
    #-----< id-IdleIntervalInformation >-----#
    id_IdleIntervalInformation = INT(name=u'id-IdleIntervalInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IdleIntervalInformation._val = 804
    
    #-----< id-NeedforIdleInterval >-----#
    id_NeedforIdleInterval = INT(name=u'id-NeedforIdleInterval', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NeedforIdleInterval._val = 805
    
    #-----< id-IdleIntervalConfigurationIndicator >-----#
    id_IdleIntervalConfigurationIndicator = INT(name=u'id-IdleIntervalConfigurationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IdleIntervalConfigurationIndicator._val = 806
    
    #-----< id-ContinuousPacketConnectivity-DRX-InformationLCR >-----#
    id_ContinuousPacketConnectivity_DRX_InformationLCR = INT(name=u'id-ContinuousPacketConnectivity-DRX-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivity_DRX_InformationLCR._val = 807
    
    #-----< id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR >-----#
    id_ContinuousPacketConnectivity_DRX_Information_ResponseLCR = INT(name=u'id-ContinuousPacketConnectivity-DRX-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ContinuousPacketConnectivity_DRX_Information_ResponseLCR._val = 808
    
    #-----< id-E-AGCH-UE-Inactivity-Monitor-Threshold >-----#
    id_E_AGCH_UE_Inactivity_Monitor_Threshold = INT(name=u'id-E-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_AGCH_UE_Inactivity_Monitor_Threshold._val = 809
    
    #-----< id-CPC-InformationLCR >-----#
    id_CPC_InformationLCR = INT(name=u'id-CPC-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPC_InformationLCR._val = 810
    
    #-----< id-E-DCH-Semi-PersistentScheduling-Information-LCR >-----#
    id_E_DCH_Semi_PersistentScheduling_Information_LCR = INT(name=u'id-E-DCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Semi_PersistentScheduling_Information_LCR._val = 811
    
    #-----< id-HS-DSCH-Semi-PersistentScheduling-Information-LCR >-----#
    id_HS_DSCH_Semi_PersistentScheduling_Information_LCR = INT(name=u'id-HS-DSCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_Semi_PersistentScheduling_Information_LCR._val = 812
    
    #-----< id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    id_HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR = INT(name=u'id-HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR._val = 813
    
    #-----< id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    id_E_DCH_Semi_PersistentScheduling_Information_ResponseLCR = INT(name=u'id-E-DCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Semi_PersistentScheduling_Information_ResponseLCR._val = 814
    
    #-----< id-MIMO-SFMode-For-HSPDSCHDualStream >-----#
    id_MIMO_SFMode_For_HSPDSCHDualStream = INT(name=u'id-MIMO-SFMode-For-HSPDSCHDualStream', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_SFMode_For_HSPDSCHDualStream._val = 815
    
    #-----< id-MIMO-SFMode-Supported-For-HSPDSCHDualStream >-----#
    id_MIMO_SFMode_Supported_For_HSPDSCHDualStream = INT(name=u'id-MIMO-SFMode-Supported-For-HSPDSCHDualStream', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_SFMode_Supported_For_HSPDSCHDualStream._val = 816
    
    #-----< id-MIMO-ReferenceSignal-InformationListLCR >-----#
    id_MIMO_ReferenceSignal_InformationListLCR = INT(name=u'id-MIMO-ReferenceSignal-InformationListLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_ReferenceSignal_InformationListLCR._val = 817
    
    #-----< id-GANSS-alm-keplerianNAVAlmanac >-----#
    id_GANSS_alm_keplerianNAVAlmanac = INT(name=u'id-GANSS-alm-keplerianNAVAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianNAVAlmanac._val = 818
    
    #-----< id-GANSS-alm-keplerianReducedAlmanac >-----#
    id_GANSS_alm_keplerianReducedAlmanac = INT(name=u'id-GANSS-alm-keplerianReducedAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianReducedAlmanac._val = 819
    
    #-----< id-GANSS-alm-keplerianMidiAlmanac >-----#
    id_GANSS_alm_keplerianMidiAlmanac = INT(name=u'id-GANSS-alm-keplerianMidiAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianMidiAlmanac._val = 820
    
    #-----< id-GANSS-alm-keplerianGLONASS >-----#
    id_GANSS_alm_keplerianGLONASS = INT(name=u'id-GANSS-alm-keplerianGLONASS', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianGLONASS._val = 821
    
    #-----< id-GANSS-alm-ecefSBASAlmanac >-----#
    id_GANSS_alm_ecefSBASAlmanac = INT(name=u'id-GANSS-alm-ecefSBASAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_ecefSBASAlmanac._val = 822
    
    #-----< id-DL-RLC-PDU-Size-Format >-----#
    id_DL_RLC_PDU_Size_Format = INT(name=u'id-DL-RLC-PDU-Size-Format', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_RLC_PDU_Size_Format._val = 823
    
    #-----< id-MACes-Maximum-Bitrate-LCR >-----#
    id_MACes_Maximum_Bitrate_LCR = INT(name=u'id-MACes-Maximum-Bitrate-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MACes_Maximum_Bitrate_LCR._val = 824
    
    #-----< id-Single-Stream-MIMO-ActivationIndicator >-----#
    id_Single_Stream_MIMO_ActivationIndicator = INT(name=u'id-Single-Stream-MIMO-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Single_Stream_MIMO_ActivationIndicator._val = 825
    
    #-----< id-Single-Stream-MIMO-Mode-Indicator >-----#
    id_Single_Stream_MIMO_Mode_Indicator = INT(name=u'id-Single-Stream-MIMO-Mode-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Single_Stream_MIMO_Mode_Indicator._val = 826
    
    #-----< id-Dual-Band-Secondary-Serving-Cell-List >-----#
    id_Dual_Band_Secondary_Serving_Cell_List = INT(name=u'id-Dual-Band-Secondary-Serving-Cell-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dual_Band_Secondary_Serving_Cell_List._val = 827
    
    #-----< id-UE-AggregateMaximumBitRate >-----#
    id_UE_AggregateMaximumBitRate = INT(name=u'id-UE-AggregateMaximumBitRate', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_AggregateMaximumBitRate._val = 828
    
    #-----< id-power-offset-for-S-CPICH-for-MIMO >-----#
    id_power_offset_for_S_CPICH_for_MIMO = INT(name=u'id-power-offset-for-S-CPICH-for-MIMO', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_power_offset_for_S_CPICH_for_MIMO._val = 829
    
    #-----< id-power-offset-for-S-CPICH-for-MIMO-Request-Indicator >-----#
    id_power_offset_for_S_CPICH_for_MIMO_Request_Indicator = INT(name=u'id-power-offset-for-S-CPICH-for-MIMO-Request-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_power_offset_for_S_CPICH_for_MIMO_Request_Indicator._val = 830
    
    #-----< id-UE-SupportIndicatorExtension >-----#
    id_UE_SupportIndicatorExtension = INT(name=u'id-UE-SupportIndicatorExtension', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_SupportIndicatorExtension._val = 831
    
    #-----< id-ActivationInformation >-----#
    id_ActivationInformation = INT(name=u'id-ActivationInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationInformation._val = 835
    
    #-----< id-CellPortionLCRID >-----#
    id_CellPortionLCRID = INT(name=u'id-CellPortionLCRID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellPortionLCRID._val = 836
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Setup-Req >-----#
    id_Additional_EDCH_Cell_Information_RL_Setup_Req = INT(name=u'id-Additional-EDCH-Cell-Information-RL-Setup-Req', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Setup_Req._val = 837
    
    #-----< id-Additional-EDCH-Cell-Information-Response >-----#
    id_Additional_EDCH_Cell_Information_Response = INT(name=u'id-Additional-EDCH-Cell-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_Response._val = 838
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Add-Req >-----#
    id_Additional_EDCH_Cell_Information_RL_Add_Req = INT(name=u'id-Additional-EDCH-Cell-Information-RL-Add-Req', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Add_Req._val = 839
    
    #-----< id-Additional-EDCH-Cell-Information-Response-RLAdd >-----#
    id_Additional_EDCH_Cell_Information_Response_RLAdd = INT(name=u'id-Additional-EDCH-Cell-Information-Response-RLAdd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_Response_RLAdd._val = 840
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Reconf-Prep >-----#
    id_Additional_EDCH_Cell_Information_RL_Reconf_Prep = INT(name=u'id-Additional-EDCH-Cell-Information-RL-Reconf-Prep', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Reconf_Prep._val = 841
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Reconf-Req >-----#
    id_Additional_EDCH_Cell_Information_RL_Reconf_Req = INT(name=u'id-Additional-EDCH-Cell-Information-RL-Reconf-Req', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Reconf_Req._val = 842
    
    #-----< id-Additional-EDCH-Cell-Information-RL-Param-Upd >-----#
    id_Additional_EDCH_Cell_Information_RL_Param_Upd = INT(name=u'id-Additional-EDCH-Cell-Information-RL-Param-Upd', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_RL_Param_Upd._val = 843
    
    #-----< id-Additional-EDCH-Preconfiguration-Information >-----#
    id_Additional_EDCH_Preconfiguration_Information = INT(name=u'id-Additional-EDCH-Preconfiguration-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Preconfiguration_Information._val = 844
    
    #-----< id-MulticellEDCH-Information >-----#
    id_MulticellEDCH_Information = INT(name=u'id-MulticellEDCH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticellEDCH_Information._val = 845
    
    #-----< id-Additional-EDCH-Cell-Information-ResponseRLReconf >-----#
    id_Additional_EDCH_Cell_Information_ResponseRLReconf = INT(name=u'id-Additional-EDCH-Cell-Information-ResponseRLReconf', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_EDCH_Cell_Information_ResponseRLReconf._val = 854
    
    #-----< id-EDCH-Indicator >-----#
    id_EDCH_Indicator = INT(name=u'id-EDCH-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EDCH_Indicator._val = 855
    
    #-----< id-DiversityMode >-----#
    id_DiversityMode = INT(name=u'id-DiversityMode', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DiversityMode._val = 856
    
    #-----< id-TransmitDiversityIndicator >-----#
    id_TransmitDiversityIndicator = INT(name=u'id-TransmitDiversityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransmitDiversityIndicator._val = 857
    
    #-----< id-NonCellSpecificTxDiversity >-----#
    id_NonCellSpecificTxDiversity = INT(name=u'id-NonCellSpecificTxDiversity', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NonCellSpecificTxDiversity._val = 858
    
    #-----< id-CellCapabilityContainerExtension-FDD >-----#
    id_CellCapabilityContainerExtension_FDD = INT(name=u'id-CellCapabilityContainerExtension-FDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellCapabilityContainerExtension_FDD._val = 859
    
    #-----< id-HSDSCH-Physical-Layer-Category >-----#
    id_HSDSCH_Physical_Layer_Category = INT(name=u'id-HSDSCH-Physical-Layer-Category', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HSDSCH_Physical_Layer_Category._val = 860
    
    #-----< id-E-RNTI-For-FACH >-----#
    id_E_RNTI_For_FACH = INT(name=u'id-E-RNTI-For-FACH', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_RNTI_For_FACH._val = 861
    
    #-----< id-H-RNTI-For-FACH >-----#
    id_H_RNTI_For_FACH = INT(name=u'id-H-RNTI-For-FACH', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_H_RNTI_For_FACH._val = 862
    
    #-----< id-RNTI-Allocation-Indicator >-----#
    id_RNTI_Allocation_Indicator = INT(name=u'id-RNTI-Allocation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RNTI_Allocation_Indicator._val = 863
    
    #-----< id-UE-AggregateMaximumBitRate-Enforcement-Indicator >-----#
    id_UE_AggregateMaximumBitRate_Enforcement_Indicator = INT(name=u'id-UE-AggregateMaximumBitRate-Enforcement-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_AggregateMaximumBitRate_Enforcement_Indicator._val = 864
    
    #-----< id-DCH-MeasurementOccasion-Information >-----#
    id_DCH_MeasurementOccasion_Information = INT(name=u'id-DCH-MeasurementOccasion-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_MeasurementOccasion_Information._val = 865
    
    #-----< id-DCH-MeasurementType-Indicator >-----#
    id_DCH_MeasurementType_Indicator = INT(name=u'id-DCH-MeasurementType-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_MeasurementType_Indicator._val = 866
    
    #-----< id-Out-of-Sychronization-Window >-----#
    id_Out_of_Sychronization_Window = INT(name=u'id-Out-of-Sychronization-Window', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Out_of_Sychronization_Window._val = 867
    
    #-----< id-MulticellEDCH-RL-SpecificInformation >-----#
    id_MulticellEDCH_RL_SpecificInformation = INT(name=u'id-MulticellEDCH-RL-SpecificInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MulticellEDCH_RL_SpecificInformation._val = 868
    
    #-----< id-DGNSS-ValidityPeriod >-----#
    id_DGNSS_ValidityPeriod = INT(name=u'id-DGNSS-ValidityPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DGNSS_ValidityPeriod._val = 869
    
    #-----< id-TS0-HS-PDSCH-Indication-LCR >-----#
    id_TS0_HS_PDSCH_Indication_LCR = INT(name=u'id-TS0-HS-PDSCH-Indication-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TS0_HS_PDSCH_Indication_LCR._val = 870
    
    #-----< id-UE-TS0-CapabilityLCR >-----#
    id_UE_TS0_CapabilityLCR = INT(name=u'id-UE-TS0-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_TS0_CapabilityLCR._val = 871
    
    #-----< id-Non-Serving-RL-Preconfig-Info >-----#
    id_Non_Serving_RL_Preconfig_Info = INT(name=u'id-Non-Serving-RL-Preconfig-Info', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_Serving_RL_Preconfig_Info._val = 872
    
    #-----< id-Non-Serving-RL-Preconfig-Setup >-----#
    id_Non_Serving_RL_Preconfig_Setup = INT(name=u'id-Non-Serving-RL-Preconfig-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_Serving_RL_Preconfig_Setup._val = 873
    
    #-----< id-Non-Serving-RL-Preconfig-Removal >-----#
    id_Non_Serving_RL_Preconfig_Removal = INT(name=u'id-Non-Serving-RL-Preconfig-Removal', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_Serving_RL_Preconfig_Removal._val = 874
    
    #-----< id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup >-----#
    id_Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup = INT(name=u'id-Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup._val = 875
    
    #-----< id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList >-----#
    id_Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList = INT(name=u'id-Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList._val = 876
    
    #-----< id-CellListValidityIndicator >-----#
    id_CellListValidityIndicator = INT(name=u'id-CellListValidityIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellListValidityIndicator._val = 877
    
    #-----< id-completeAlmanacProvided >-----#
    id_completeAlmanacProvided = INT(name=u'id-completeAlmanacProvided', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_completeAlmanacProvided._val = 878
    
    #-----< id-ganss-Delta-T >-----#
    id_ganss_Delta_T = INT(name=u'id-ganss-Delta-T', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganss_Delta_T._val = 879
    
    #-----< id-OrdinalNumberOfFrequency >-----#
    id_OrdinalNumberOfFrequency = INT(name=u'id-OrdinalNumberOfFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OrdinalNumberOfFrequency._val = 880
    
    #-----< id-Multicell-EDCH-Restriction >-----#
    id_Multicell_EDCH_Restriction = INT(name=u'id-Multicell-EDCH-Restriction', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multicell_EDCH_Restriction._val = 882
    
    #-----< id-CellCapabilityContainerExtension-TDD-LCR >-----#
    id_CellCapabilityContainerExtension_TDD_LCR = INT(name=u'id-CellCapabilityContainerExtension-TDD-LCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellCapabilityContainerExtension_TDD_LCR._val = 883
    
    #-----< id-Multi-Carrier-EDCH-Setup >-----#
    id_Multi_Carrier_EDCH_Setup = INT(name=u'id-Multi-Carrier-EDCH-Setup', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_EDCH_Setup._val = 884
    
    #-----< id-Multi-Carrier-EDCH-Reconfigure >-----#
    id_Multi_Carrier_EDCH_Reconfigure = INT(name=u'id-Multi-Carrier-EDCH-Reconfigure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_EDCH_Reconfigure._val = 885
    
    #-----< id-Multi-Carrier-EDCH-Response >-----#
    id_Multi_Carrier_EDCH_Response = INT(name=u'id-Multi-Carrier-EDCH-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_EDCH_Response._val = 886
    
    #-----< id-SNPL-Carrier-Group-Indicator >-----#
    id_SNPL_Carrier_Group_Indicator = INT(name=u'id-SNPL-Carrier-Group-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SNPL_Carrier_Group_Indicator._val = 887
    
    #-----< id-MU-MIMO-InformationLCR >-----#
    id_MU_MIMO_InformationLCR = INT(name=u'id-MU-MIMO-InformationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MU_MIMO_InformationLCR._val = 888
    
    #-----< id-MU-MIMO-Indicator >-----#
    id_MU_MIMO_Indicator = INT(name=u'id-MU-MIMO-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MU_MIMO_Indicator._val = 889
    
    #-----< id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext >-----#
    id_HS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext = INT(name=u'id-HS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext._val = 890
    
    #-----< id-Usefulness-Of-Battery-Optimization >-----#
    id_Usefulness_Of_Battery_Optimization = INT(name=u'id-Usefulness-Of-Battery-Optimization', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Usefulness_Of_Battery_Optimization._val = 891
    
    #-----< id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    id_Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name=u'id-Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory._val = 892
    
    #-----< id-Measurement-Power-Offset >-----#
    id_Measurement_Power_Offset = INT(name=u'id-Measurement-Power-Offset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Measurement_Power_Offset._val = 893
    
    #-----< id-MDT-Configuration >-----#
    id_MDT_Configuration = INT(name=u'id-MDT-Configuration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MDT_Configuration._val = 894
    
    #-----< id-Neighbouring-UMTS-CellInformation-Ext >-----#
    id_Neighbouring_UMTS_CellInformation_Ext = INT(name=u'id-Neighbouring-UMTS-CellInformation-Ext', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbouring_UMTS_CellInformation_Ext._val = 895
    
    #-----< id-Neighbouring-UMTS-CellInformationExtensionItem >-----#
    id_Neighbouring_UMTS_CellInformationExtensionItem = INT(name=u'id-Neighbouring-UMTS-CellInformationExtensionItem', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Neighbouring_UMTS_CellInformationExtensionItem._val = 896
    
    #-----< id-Control-Type-InformationTransferControlReq >-----#
    id_Control_Type_InformationTransferControlReq = INT(name=u'id-Control-Type-InformationTransferControlReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Control_Type_InformationTransferControlReq._val = 897
    
    #-----< id-UMTS-Cells-Info >-----#
    id_UMTS_Cells_Info = INT(name=u'id-UMTS-Cells-Info', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UMTS_Cells_Info._val = 898
    
    #-----< id-ANRReportIndication >-----#
    id_ANRReportIndication = INT(name=u'id-ANRReportIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ANRReportIndication._val = 899
    
    #-----< id-ANR-Cell-InfEx-Rqst >-----#
    id_ANR_Cell_InfEx_Rqst = INT(name=u'id-ANR-Cell-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ANR_Cell_InfEx_Rqst._val = 900
    
    #-----< id-ANR-Cell-InfEx-Rsp >-----#
    id_ANR_Cell_InfEx_Rsp = INT(name=u'id-ANR-Cell-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ANR_Cell_InfEx_Rsp._val = 901
    
    #-----< id-ANR-Cell-Information >-----#
    id_ANR_Cell_Information = INT(name=u'id-ANR-Cell-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ANR_Cell_Information._val = 902
    
    #-----< id-Trace-Collection-Entity-IP-Address >-----#
    id_Trace_Collection_Entity_IP_Address = INT(name=u'id-Trace-Collection-Entity-IP-Address', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Trace_Collection_Entity_IP_Address._val = 904
    
    #-----< id-Affected-HSDSCH-Serving-Cell-List >-----#
    id_Affected_HSDSCH_Serving_Cell_List = INT(name=u'id-Affected-HSDSCH-Serving-Cell-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Affected_HSDSCH_Serving_Cell_List._val = 905
    
    #-----< id-UL-CLTD-Information >-----#
    id_UL_CLTD_Information = INT(name=u'id-UL-CLTD-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CLTD_Information._val = 906
    
    #-----< id-UL-CLTD-Information-Reconf >-----#
    id_UL_CLTD_Information_Reconf = INT(name=u'id-UL-CLTD-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CLTD_Information_Reconf._val = 907
    
    #-----< id-UL-CLTD-State-Update-Information >-----#
    id_UL_CLTD_State_Update_Information = INT(name=u'id-UL-CLTD-State-Update-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_CLTD_State_Update_Information._val = 908
    
    #-----< id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order >-----#
    id_Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order = INT(name=u'id-Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order._val = 909
    
    #-----< id-CPC-RecoveryReport >-----#
    id_CPC_RecoveryReport = INT(name=u'id-CPC-RecoveryReport', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CPC_RecoveryReport._val = 910
    
    #-----< id-FTPICH-Information >-----#
    id_FTPICH_Information = INT(name=u'id-FTPICH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FTPICH_Information._val = 911
    
    #-----< id-FTPICH-Information-Reconf >-----#
    id_FTPICH_Information_Reconf = INT(name=u'id-FTPICH-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FTPICH_Information_Reconf._val = 912
    
    #-----< id-UE-RF-Band-CapabilityLCR >-----#
    id_UE_RF_Band_CapabilityLCR = INT(name=u'id-UE-RF-Band-CapabilityLCR', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_RF_Band_CapabilityLCR._val = 913
    
    #-----< id-Extended-S-RNTI >-----#
    id_Extended_S_RNTI = INT(name=u'id-Extended-S-RNTI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_S_RNTI._val = 914
    
    #-----< id-ExtendedAffectedUEInformationForMBMS >-----#
    id_ExtendedAffectedUEInformationForMBMS = INT(name=u'id-ExtendedAffectedUEInformationForMBMS', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedAffectedUEInformationForMBMS._val = 915
    
    #-----< id-Extended-S-RNTI-Group >-----#
    id_Extended_S_RNTI_Group = INT(name=u'id-Extended-S-RNTI-Group', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_S_RNTI_Group._val = 916
    
    #-----< id-FTPICH-Information-Response >-----#
    id_FTPICH_Information_Response = INT(name=u'id-FTPICH-Information-Response', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FTPICH_Information_Response._val = 917
    
    #-----< id-FTPICH-Reconfiguration-Information >-----#
    id_FTPICH_Reconfiguration_Information = INT(name=u'id-FTPICH-Reconfiguration-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_FTPICH_Reconfiguration_Information._val = 918
    
    #-----< id-MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    id_MIMO_withfourtransmitantennas_ActivationIndicator = INT(name=u'id-MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_withfourtransmitantennas_ActivationIndicator._val = 919
    
    #-----< id-MIMO-withfourtransmitantennas-ModeIndicator >-----#
    id_MIMO_withfourtransmitantennas_ModeIndicator = INT(name=u'id-MIMO-withfourtransmitantennas-ModeIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MIMO_withfourtransmitantennas_ModeIndicator._val = 920
    
    #-----< id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas >-----#
    id_power_offset_for_S_CPICH_for_MIMO_withfourtransmitantennas = INT(name=u'id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_power_offset_for_S_CPICH_for_MIMO_withfourtransmitantennas._val = 921
    
    #-----< id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas-Request-Indicator >-----#
    id_power_offset_for_S_CPICH_for_MIMO_withfourtransmitantennas_Request_Indicator = INT(name=u'id-power-offset-for-S-CPICH-for-MIMO-withfourtransmitantennas-Request-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_power_offset_for_S_CPICH_for_MIMO_withfourtransmitantennas_Request_Indicator._val = 922
    
    #-----< id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    id_DualStream_MIMO_withfourtransmitantennas_ActivationIndicator = INT(name=u'id-DualStream-MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DualStream_MIMO_withfourtransmitantennas_ActivationIndicator._val = 923
    
    #-----< id-DualStream-MIMO-withfourtransmitantennas-ModeIndicator >-----#
    id_DualStream_MIMO_withfourtransmitantennas_ModeIndicator = INT(name=u'id-DualStream-MIMO-withfourtransmitantennas-ModeIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DualStream_MIMO_withfourtransmitantennas_ModeIndicator._val = 924
    
    #-----< id-Additional-Associated-Secondary-CPICH >-----#
    id_Additional_Associated_Secondary_CPICH = INT(name=u'id-Additional-Associated-Secondary-CPICH', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_Associated_Secondary_CPICH._val = 925
    
    #-----< id-UE-transmission-power-headroom >-----#
    id_UE_transmission_power_headroom = INT(name=u'id-UE-transmission-power-headroom', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_transmission_power_headroom._val = 926
    
    #-----< id-Multiflow-Information >-----#
    id_Multiflow_Information = INT(name=u'id-Multiflow-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiflow_Information._val = 927
    
    #-----< id-Multiflow-Reconfiguration >-----#
    id_Multiflow_Reconfiguration = INT(name=u'id-Multiflow-Reconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiflow_Reconfiguration._val = 928
    
    #-----< id-Multiflow-OrdinalNumberOfFrequency >-----#
    id_Multiflow_OrdinalNumberOfFrequency = INT(name=u'id-Multiflow-OrdinalNumberOfFrequency', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Multiflow_OrdinalNumberOfFrequency._val = 929
    
    #-----< id-UL-MIMO-Information >-----#
    id_UL_MIMO_Information = INT(name=u'id-UL-MIMO-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_MIMO_Information._val = 930
    
    #-----< id-UL-MIMO-Reconfiguration >-----#
    id_UL_MIMO_Reconfiguration = INT(name=u'id-UL-MIMO-Reconfiguration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_MIMO_Reconfiguration._val = 931
    
    #-----< id-UL-MIMO-DL-Control-Channel-Information >-----#
    id_UL_MIMO_DL_Control_Channel_Information = INT(name=u'id-UL-MIMO-DL-Control-Channel-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_MIMO_DL_Control_Channel_Information._val = 932
    
    #-----< id-SixtyfourQAM-UL-Operation-Indicator >-----#
    id_SixtyfourQAM_UL_Operation_Indicator = INT(name=u'id-SixtyfourQAM-UL-Operation-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SixtyfourQAM_UL_Operation_Indicator._val = 933
    
    #-----< id-Common-E-RGCH-Cell-InfEx-Rqst >-----#
    id_Common_E_RGCH_Cell_InfEx_Rqst = INT(name=u'id-Common-E-RGCH-Cell-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_RGCH_Cell_InfEx_Rqst._val = 935
    
    #-----< id-Common-E-RGCH-Cell-InfEx-Rsp >-----#
    id_Common_E_RGCH_Cell_InfEx_Rsp = INT(name=u'id-Common-E-RGCH-Cell-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_RGCH_Cell_InfEx_Rsp._val = 936
    
    #-----< id-Common-E-RGCH-Cell-InfEx-Rprt >-----#
    id_Common_E_RGCH_Cell_InfEx_Rprt = INT(name=u'id-Common-E-RGCH-Cell-InfEx-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_RGCH_Cell_InfEx_Rprt._val = 937
    
    #-----< id-Common-E-RGCH-Cell-Information >-----#
    id_Common_E_RGCH_Cell_Information = INT(name=u'id-Common-E-RGCH-Cell-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Common_E_RGCH_Cell_Information._val = 938
    
    #-----< id-PCI >-----#
    id_PCI = INT(name=u'id-PCI', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PCI._val = 939
    
    #-----< id-TAC >-----#
    id_TAC = INT(name=u'id-TAC', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TAC._val = 940
    
    #-----< id-PLMN-List >-----#
    id_PLMN_List = INT(name=u'id-PLMN-List', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PLMN_List._val = 941
    
    #-----< id-PrecoderWeightSetRestriction >-----#
    id_PrecoderWeightSetRestriction = INT(name=u'id-PrecoderWeightSetRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PrecoderWeightSetRestriction._val = 942
    
    #-----< id-EARFCN-FDD-Extended >-----#
    id_EARFCN_FDD_Extended = INT(name=u'id-EARFCN-FDD-Extended', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EARFCN_FDD_Extended._val = 943
    
    #-----< id-EARFCN-TDD-Extended >-----#
    id_EARFCN_TDD_Extended = INT(name=u'id-EARFCN-TDD-Extended', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EARFCN_TDD_Extended._val = 944
    
    #-----< id-Non-rectangular-resource-allocation-indicator >-----#
    id_Non_rectangular_resource_allocation_indicator = INT(name=u'id-Non-rectangular-resource-allocation-indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_rectangular_resource_allocation_indicator._val = 945
    
    #-----< id-Non-rectangular-resource-timeslot-set >-----#
    id_Non_rectangular_resource_timeslot_set = INT(name=u'id-Non-rectangular-resource-timeslot-set', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Non_rectangular_resource_timeslot_set._val = 946
    
    #-----< id-UE-Support-of-non-rectangular-resource-allocation >-----#
    id_UE_Support_of_non_rectangular_resource_allocation = INT(name=u'id-UE-Support-of-non-rectangular-resource-allocation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Support_of_non_rectangular_resource_allocation._val = 947
    
    #-----< id-DBDS-CorrectionsReq >-----#
    id_DBDS_CorrectionsReq = INT(name=u'id-DBDS-CorrectionsReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DBDS_CorrectionsReq._val = 948
    
    #-----< id-DBDS-Corrections >-----#
    id_DBDS_Corrections = INT(name=u'id-DBDS-Corrections', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DBDS_Corrections._val = 949
    
    #-----< id-BDS-IonosphericGridModelReq >-----#
    id_BDS_IonosphericGridModelReq = INT(name=u'id-BDS-IonosphericGridModelReq', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BDS_IonosphericGridModelReq._val = 950
    
    #-----< id-BDS-Ionospheric-Grid-Model >-----#
    id_BDS_Ionospheric_Grid_Model = INT(name=u'id-BDS-Ionospheric-Grid-Model', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BDS_Ionospheric_Grid_Model._val = 951
    
    #-----< id-GANSS-alm-keplerianBDSAlmanac >-----#
    id_GANSS_alm_keplerianBDSAlmanac = INT(name=u'id-GANSS-alm-keplerianBDSAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianBDSAlmanac._val = 952
    
    #-----< id-Assisting-RepetitionFactors >-----#
    id_Assisting_RepetitionFactors = INT(name=u'id-Assisting-RepetitionFactors', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Assisting_RepetitionFactors._val = 953
    
    #-----< id-E-DCH-Decoupling-Indication >-----#
    id_E_DCH_Decoupling_Indication = INT(name=u'id-E-DCH-Decoupling-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_E_DCH_Decoupling_Indication._val = 954
    
    #-----< id-UE-Measurement-Forwarding >-----#
    id_UE_Measurement_Forwarding = INT(name=u'id-UE-Measurement-Forwarding', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_Measurement_Forwarding._val = 955
    
    #-----< id-UPH-Filtering-Measurement-Forwarding-Request >-----#
    id_UPH_Filtering_Measurement_Forwarding_Request = INT(name=u'id-UPH-Filtering-Measurement-Forwarding-Request', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UPH_Filtering_Measurement_Forwarding_Request._val = 956
    
    #-----< id-TTI-Update-Indicator >-----#
    id_TTI_Update_Indicator = INT(name=u'id-TTI-Update-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TTI_Update_Indicator._val = 957
    
    #-----< id-CQI-Feedback-Cycle2-k >-----#
    id_CQI_Feedback_Cycle2_k = INT(name=u'id-CQI-Feedback-Cycle2-k', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CQI_Feedback_Cycle2_k._val = 958
    
    #-----< id-CQI-Cycle-Switch-Timer >-----#
    id_CQI_Cycle_Switch_Timer = INT(name=u'id-CQI-Cycle-Switch-Timer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CQI_Cycle_Switch_Timer._val = 959
    
    #-----< id-UE-DRX-Cycle2 >-----#
    id_UE_DRX_Cycle2 = INT(name=u'id-UE-DRX-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_DRX_Cycle2._val = 960
    
    #-----< id-Inactivity-Threshold-for-UE-DRX-Cycle2 >-----#
    id_Inactivity_Threshold_for_UE_DRX_Cycle2 = INT(name=u'id-Inactivity-Threshold-for-UE-DRX-Cycle2', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inactivity_Threshold_for_UE_DRX_Cycle2._val = 961
    
    #-----< id-DTX-Information2 >-----#
    id_DTX_Information2 = INT(name=u'id-DTX-Information2', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DTX_Information2._val = 962
    
    #-----< id-DCH-ENH-Information >-----#
    id_DCH_ENH_Information = INT(name=u'id-DCH-ENH-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_ENH_Information._val = 964
    
    #-----< id-DCH-ENH-Information-Reconf >-----#
    id_DCH_ENH_Information_Reconf = INT(name=u'id-DCH-ENH-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DCH_ENH_Information_Reconf._val = 965
    
    #-----< id-Gainfactors-10ms-mode >-----#
    id_Gainfactors_10ms_mode = INT(name=u'id-Gainfactors-10ms-mode', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Gainfactors_10ms_mode._val = 966
    
    #-----< id-Radio-Links-without-DPCH-FDPCH-Indication >-----#
    id_Radio_Links_without_DPCH_FDPCH_Indication = INT(name=u'id-Radio-Links-without-DPCH-FDPCH-Indication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Radio_Links_without_DPCH_FDPCH_Indication._val = 967
    
    #-----< id-UL-DPCCH2-Information >-----#
    id_UL_DPCCH2_Information = INT(name=u'id-UL-DPCCH2-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCCH2_Information._val = 968
    
    #-----< id-UL-DPCCH2-Information-Reconf >-----#
    id_UL_DPCCH2_Information_Reconf = INT(name=u'id-UL-DPCCH2-Information-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UL_DPCCH2_Information_Reconf._val = 969
    
    #-----< id-ImplicitGrantHandling >-----#
    id_ImplicitGrantHandling = INT(name=u'id-ImplicitGrantHandling', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ImplicitGrantHandling._val = 970
    
    #-----< id-MinimumTEBSthreshold >-----#
    id_MinimumTEBSthreshold = INT(name=u'id-MinimumTEBSthreshold', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MinimumTEBSthreshold._val = 971
    
    #-----< id-MultipleFrequencyBandsIndicatorList-EUTRA >-----#
    id_MultipleFrequencyBandsIndicatorList_EUTRA = INT(name=u'id-MultipleFrequencyBandsIndicatorList-EUTRA', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFrequencyBandsIndicatorList_EUTRA._val = 972
    
    #-----< id-MultipleFrequencyBandsIndicatorList >-----#
    id_MultipleFrequencyBandsIndicatorList = INT(name=u'id-MultipleFrequencyBandsIndicatorList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MultipleFrequencyBandsIndicatorList._val = 973
    
    #-----< id-ActivationDelay >-----#
    id_ActivationDelay = INT(name=u'id-ActivationDelay', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ActivationDelay._val = 974
    
    #-----< id-Fast-TTI-switching-Mode-synchronized >-----#
    id_Fast_TTI_switching_Mode_synchronized = INT(name=u'id-Fast-TTI-switching-Mode-synchronized', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_TTI_switching_Mode_synchronized._val = 975
    
    #-----< id-Fast-TTI-switching-Mode-unsynchronized >-----#
    id_Fast_TTI_switching_Mode_unsynchronized = INT(name=u'id-Fast-TTI-switching-Mode-unsynchronized', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_TTI_switching_Mode_unsynchronized._val = 976
    
    #-----< id-Fast-TTI-switching-Mode-Supported >-----#
    id_Fast_TTI_switching_Mode_Supported = INT(name=u'id-Fast-TTI-switching-Mode-Supported', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Fast_TTI_switching_Mode_Supported._val = 977
    
    #-----< id-GANSS-BDSclockModel >-----#
    id_GANSS_BDSclockModel = INT(name=u'id-GANSS-BDSclockModel', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_BDSclockModel._val = 978
    
    #-----< id-GANSS-NavModel-BDSKeplerianSet >-----#
    id_GANSS_NavModel_BDSKeplerianSet = INT(name=u'id-GANSS-NavModel-BDSKeplerianSet', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_NavModel_BDSKeplerianSet._val = 979
    
    #-----< id-GANSS-UTCmodelSet4 >-----#
    id_GANSS_UTCmodelSet4 = INT(name=u'id-GANSS-UTCmodelSet4', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_UTCmodelSet4._val = 980
    
    #-----< id-Inter-Frequency-Cell-Information-SIB11ter >-----#
    id_Inter_Frequency_Cell_Information_SIB11ter = INT(name=u'id-Inter-Frequency-Cell-Information-SIB11ter', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Inter_Frequency_Cell_Information_SIB11ter._val = 981
    
    #-----< id-Improved-Synchronized-Indicator >-----#
    id_Improved_Synchronized_Indicator = INT(name=u'id-Improved-Synchronized-Indicator', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Improved_Synchronized_Indicator._val = 982
    
    #-----< id-Downlink-TPC-enhancements-Information >-----#
    id_Downlink_TPC_enhancements_Information = INT(name=u'id-Downlink-TPC-enhancements-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Downlink_TPC_enhancements_Information._val = 983
    
    #-----< id-Downlink-TPC-enhancements-Reconf >-----#
    id_Downlink_TPC_enhancements_Reconf = INT(name=u'id-Downlink-TPC-enhancements-Reconf', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Downlink_TPC_enhancements_Reconf._val = 984
    
    #-----< id-TPC-slot-position >-----#
    id_TPC_slot_position = INT(name=u'id-TPC-slot-position', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TPC_slot_position._val = 985
    
    #-----< id-DL-TBS >-----#
    id_DL_TBS = INT(name=u'id-DL-TBS', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DL_TBS._val = 986
    
    #-----< id-Selected-PLMN-Identity >-----#
    id_Selected_PLMN_Identity = INT(name=u'id-Selected-PLMN-Identity', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Selected_PLMN_Identity._val = 987
    
    #-----< id-Dual-Cell-EDCH-Enhancements-Information >-----#
    id_Dual_Cell_EDCH_Enhancements_Information = INT(name=u'id-Dual-Cell-EDCH-Enhancements-Information', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Dual_Cell_EDCH_Enhancements_Information._val = 988
    
    #-----< id-SpeechVersion >-----#
    id_SpeechVersion = INT(name=u'id-SpeechVersion', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SpeechVersion._val = 2048
    
    #-----< id-SourceID >-----#
    id_SourceID = INT(name=u'id-SourceID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_SourceID._val = 2049
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name=u'id-TargetID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TargetID._val = 2050
    
    #-----< id-ClassmarkInformation2 >-----#
    id_ClassmarkInformation2 = INT(name=u'id-ClassmarkInformation2', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ClassmarkInformation2._val = 2051
    
    #-----< id-ClassmarkInformation3 >-----#
    id_ClassmarkInformation3 = INT(name=u'id-ClassmarkInformation3', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ClassmarkInformation3._val = 2052
    
    #-----< id-GSM-Cell-CM-Rqst >-----#
    id_GSM_Cell_CM_Rqst = INT(name=u'id-GSM-Cell-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GSM_Cell_CM_Rqst._val = 2053
    
    #-----< id-Extension-CommonMeasurementObjectType-CM-Rprt >-----#
    id_Extension_CommonMeasurementObjectType_CM_Rprt = INT(name=u'id-Extension-CommonMeasurementObjectType-CM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extension_CommonMeasurementObjectType_CM_Rprt._val = 2054
    
    #-----< id-Extension-CommonMeasurementObjectType-CM-Rqst >-----#
    id_Extension_CommonMeasurementObjectType_CM_Rqst = INT(name=u'id-Extension-CommonMeasurementObjectType-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extension_CommonMeasurementObjectType_CM_Rqst._val = 2055
    
    #-----< id-Extension-CommonMeasurementObjectType-CM-Rsp >-----#
    id_Extension_CommonMeasurementObjectType_CM_Rsp = INT(name=u'id-Extension-CommonMeasurementObjectType-CM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extension_CommonMeasurementObjectType_CM_Rsp._val = 2056
    
    #-----< id-Extension-FailureIndicationMeasurementList >-----#
    id_Extension_FailureIndicationMeasurementList = INT(name=u'id-Extension-FailureIndicationMeasurementList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extension_FailureIndicationMeasurementList._val = 2057
    
    #-----< id-Extension-FailureMeasurementList >-----#
    id_Extension_FailureMeasurementList = INT(name=u'id-Extension-FailureMeasurementList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extension_FailureMeasurementList._val = 2058
    
    #-----< id-Extension-TerminationMeasurementList >-----#
    id_Extension_TerminationMeasurementList = INT(name=u'id-Extension-TerminationMeasurementList', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extension_TerminationMeasurementList._val = 2059
    
    #-----< id-GsmCellList-CM-Rprt >-----#
    id_GsmCellList_CM_Rprt = INT(name=u'id-GsmCellList-CM-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GsmCellList_CM_Rprt._val = 2060
    
    #-----< id-GsmCellList-CM-Rqst >-----#
    id_GsmCellList_CM_Rqst = INT(name=u'id-GsmCellList-CM-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GsmCellList_CM_Rqst._val = 2061
    
    #-----< id-GsmCellList-CM-Rsp >-----#
    id_GsmCellList_CM_Rsp = INT(name=u'id-GsmCellList-CM-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GsmCellList_CM_Rsp._val = 2062
    
    #-----< id-LoadValue >-----#
    id_LoadValue = INT(name=u'id-LoadValue', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_LoadValue._val = 2063
    
    #-----< id-EventH >-----#
    id_EventH = INT(name=u'id-EventH', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EventH._val = 2064
    
    _all_ = [
        id_commonTransportChannelResourcesInitialisation,
        id_commonTransportChannelResourcesRelease,
        id_compressedModeCommand,
        id_downlinkPowerControl,
        id_downlinkPowerTimeslotControl,
        id_downlinkSignallingTransfer,
        id_errorIndication,
        id_dedicatedMeasurementFailure,
        id_dedicatedMeasurementInitiation,
        id_dedicatedMeasurementReporting,
        id_dedicatedMeasurementTermination,
        id_paging,
        id_physicalChannelReconfiguration,
        id_privateMessage,
        id_radioLinkAddition,
        id_radioLinkCongestion,
        id_radioLinkDeletion,
        id_radioLinkFailure,
        id_radioLinkPreemption,
        id_radioLinkRestoration,
        id_radioLinkSetup,
        id_relocationCommit,
        id_synchronisedRadioLinkReconfigurationCancellation,
        id_synchronisedRadioLinkReconfigurationCommit,
        id_synchronisedRadioLinkReconfigurationPreparation,
        id_unSynchronisedRadioLinkReconfiguration,
        id_uplinkSignallingTransfer,
        id_commonMeasurementFailure,
        id_commonMeasurementInitiation,
        id_commonMeasurementReporting,
        id_commonMeasurementTermination,
        id_informationExchangeFailure,
        id_informationExchangeInitiation,
        id_informationReporting,
        id_informationExchangeTermination,
        id_reset,
        id_radioLinkActivation,
        id_gERANuplinkSignallingTransfer,
        id_radioLinkParameterUpdate,
        id_uEMeasurementFailure,
        id_uEMeasurementInitiation,
        id_uEMeasurementReporting,
        id_uEMeasurementTermination,
        id_iurDeactivateTrace,
        id_iurInvokeTrace,
        id_mBMSAttach,
        id_mBMSDetach,
        id_directInformationTransfer,
        id_enhancedRelocation,
        id_enhancedRelocationCancel,
        id_enhancedRelocationSignallingTransfer,
        id_enhancedRelocationRelease,
        id_mBSFNMCCHInformation,
        id_secondaryULFrequencyReporting,
        id_secondaryULFrequencyUpdate,
        id_informationTransferControl,
        id_enhancedRelocationResourceAllocation,
        id_enhancedRelocationResourceRelease,
        maxCellSIB11OrSIB12,
        maxCellSIB11ter_ext,
        maxCellSIB11ter_1,
        maxCellsMeas,
        maxRateMatching,
        maxNoOfDSCHs,
        maxNoOfDSCHsLCR,
        maxNoOfRB,
        maxNoOfUSCHs,
        maxNoOfUSCHsLCR,
        maxNrOfTFCs,
        maxNrOfTFs,
        maxNrOfCCTrCHs,
        maxNrOfCCTrCHsLCR,
        maxNrOfDCHs,
        maxNrOfDL_Codes,
        maxNrOfDPCHs,
        maxNrOfDPCHsPerRL_1,
        maxNrOfDPCHsLCR,
        maxNrOfDPCHsLCRPerRL_1,
        maxNrOfDPCHs768,
        maxNrOfDPCHs768PerRL_1,
        maxNrOfErrors,
        maxNrOfMACcshSDU_Length,
        maxNrOfMBMSServices,
        maxNrOfActiveMBMSServices,
        maxNrOfPoints,
        maxNrOfRLs,
        maxNrOfRLSets,
        maxNrOfRLSets_1,
        maxNrOfRLs_1,
        maxNrOfRLs_2,
        maxNrOfUEs,
        maxNrOfULTs,
        maxNrOfULTsLCR,
        maxNrOfDLTs,
        maxNrOfDLTsLCR,
        maxRNCinURA_1,
        maxTTI_Count,
        maxCTFC,
        maxNrOfNeighbouringRNCs,
        maxNrOfFDDNeighboursPerRNC,
        maxNrOfGSMNeighboursPerRNC,
        maxNrOfTDDNeighboursPerRNC,
        maxNrOfFACHs,
        maxNrOfLCRTDDNeighboursPerRNC,
        maxIBSEG,
        maxNrOfSCCPCHs,
        maxNrOfSCCPCHs768,
        maxTGPS,
        maxNrOfTS,
        maxNrOfLevels,
        maxNrOfTsLCR,
        maxNoSat,
        maxNoGPSTypes,
        maxNrOfMeasNCell,
        maxNrOfMeasNCell_1,
        maxResetContext,
        maxResetContextGroup,
        maxNrOfHARQProc,
        maxNrOfHSSCCHCodes,
        maxNrOfHSSICHs,
        maxNrOfHSSICHs_1,
        maxNrOfMACdFlows,
        maxNrOfMACdFlows_1,
        maxNrOfMACdPDUSize,
        maxNrOfPDUIndexes,
        maxNrOfPDUIndexes_1,
        maxNrOfPrioQueues,
        maxNrOfPrioQueues_1,
        maxNrOfSNAs,
        maxNrOfSatAlmanac_maxNoSat,
        maxNrOfGERANSI,
        maxNrOfInterfaces,
        maxNrofSigSeqERGHICH_1,
        maxNrOfCells,
        maxNrOfAddFreq,
        maxNrOfCellsPerFreq,
        maxNrOfEDCHMACdFlows_1,
        maxNrOfEDCH_HARQ_PO_QUANTSTEPs,
        maxNrOfEDPCCH_PO_QUANTSTEPs,
        maxNrOfEDCHHARQProcesses2msEDCH,
        maxNrOfBits_MACe_PDU_non_scheduled,
        maxNrOfRefETFCIs,
        maxNrOfRefETFCI_PO_QUANTSTEPs,
        maxNrOfEDCHMACdFlows,
        maxNoOfLogicalChannels,
        maxNrOfRefBetas,
        maxNrOfEAGCHCodes,
        maxNrOfHS_DSCHTBSs,
        maxNrOfHS_DSCHTBSs_HS_SCCHless,
        maxHS_PDSCHCodeNrComp_1,
        maxNrOfEHICHCodes,
        maxGANSSSat,
        maxNoGANSS,
        maxSgnType,
        maxNrOfBroadcastPLMNs,
        maxHSDPAFrequency,
        maxHSDPAFrequency_1,
        maxFrequencyinCell,
        maxFrequencyinCell_1,
        maxGANSSSatAlmanac,
        maxGANSSClockMod,
        maxNrOfEDCHRLs,
        maxEARFCN,
        maxEARFCN_Extended,
        maxNrOfEUTRANeighboursPerRNC,
        maxNrOfMCCHMessages,
        maxNrOfMBMSL3,
        maxNrOfEDCHMACdFlowsLCR,
        maxNrOfEDCHMACdFlowsLCR_1,
        maxNrOfPreconfiguredNeighbours,
        maxNrOfHSDSCH_1,
        maxNrOfHSDSCH,
        maxGANSS_1,
        maxlengthMBMSconcatservlists,
        maxNoOfTBSs_Mapping_HS_DSCH_SPS,
        maxNoOfTBSs_Mapping_HS_DSCH_SPS_1,
        maxNoOfHS_DSCH_TBSsLCR,
        maxNoOfRepetition_Period_LCR,
        maxNoOfRepetitionPeriod_SPS_LCR_1,
        maxNoOf_HS_SICH_SPS,
        maxNoOf_HS_SICH_SPS_1,
        maxNoOfNon_HS_SCCH_Assosiated_HS_SICH,
        maxNrOfEDCH_1,
        maxNrOfDCHMeasurementOccasionPatternSequence,
        maxNrOfULCarriersLCR_1,
        maxNrOfCellIds,
        maxNrOfRAIs,
        maxNrOfLAIs,
        maxNrOfExtendedNeighbouringRNCs,
        maxNoOfGsmCell,
        maxNrOfANRCells,
        maxFreqBandsTDD,
        maxSCPICHCell,
        maxSCPICHCell_1,
        maxNoOfCommonRGCells,
        maxIGPInfo,
        maxNrofConcatenatedDCH,
        maxMultipleFrequencyBands,
        maxMultipleFrequencyBandsEUTRA,
        id_AllowedQueuingTime,
        id_Allowed_Rate_Information,
        id_AntennaColocationIndicator,
        id_BindingID,
        id_C_ID,
        id_C_RNTI,
        id_Cell_Capacity_Class_Value,
        id_CFN,
        id_CN_CS_DomainIdentifier,
        id_CN_PS_DomainIdentifier,
        id_Cause,
        id_CoverageIndicator,
        id_CriticalityDiagnostics,
        id_ContextInfoItem_Reset,
        id_ContextGroupInfoItem_Reset,
        id_D_RNTI,
        id_D_RNTI_ReleaseIndication,
        id_DCHs_to_Add_FDD,
        id_DCHs_to_Add_TDD,
        id_DCH_DeleteList_RL_ReconfPrepFDD,
        id_DCH_DeleteList_RL_ReconfPrepTDD,
        id_DCH_DeleteList_RL_ReconfRqstFDD,
        id_DCH_DeleteList_RL_ReconfRqstTDD,
        id_DCH_FDD_Information,
        id_DCH_TDD_Information,
        id_FDD_DCHs_to_Modify,
        id_TDD_DCHs_to_Modify,
        id_DCH_InformationResponse,
        id_DCH_Rate_InformationItem_RL_CongestInd,
        id_DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationListIE_RL_ReconfReadyTDD,
        id_DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        id_DL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        id_DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
        id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD,
        id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD,
        id_DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        id_DL_CCTrCH_InformationList_RL_SetupRqstTDD,
        id_FDD_DL_CodeInformation,
        id_DL_DPCH_Information_RL_ReconfPrepFDD,
        id_DL_DPCH_Information_RL_SetupRqstFDD,
        id_DL_DPCH_Information_RL_ReconfRqstFDD,
        id_DL_DPCH_InformationItem_PhyChReconfRqstTDD,
        id_DL_DPCH_InformationItem_RL_AdditionRspTDD,
        id_DL_DPCH_InformationItem_RL_SetupRspTDD,
        id_DL_DPCH_TimingAdjustment,
        id_DLReferencePower,
        id_DLReferencePowerList_DL_PC_Rqst,
        id_DL_ReferencePowerInformation_DL_PC_Rqst,
        id_DPC_Mode,
        id_DRXCycleLengthCoefficient,
        id_DedicatedMeasurementObjectType_DM_Fail_Ind,
        id_DedicatedMeasurementObjectType_DM_Fail,
        id_DedicatedMeasurementObjectType_DM_Rprt,
        id_DedicatedMeasurementObjectType_DM_Rqst,
        id_DedicatedMeasurementObjectType_DM_Rsp,
        id_DedicatedMeasurementType,
        id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD,
        id_FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD,
        id_Guaranteed_Rate_Information,
        id_IMSI,
        id_HCS_Prio,
        id_L3_Information,
        id_AdjustmentPeriod,
        id_MaxAdjustmentStep,
        id_MeasurementFilterCoefficient,
        id_MessageStructure,
        id_MeasurementID,
        id_Neighbouring_GSM_CellInformation,
        id_Neighbouring_UMTS_CellInformationItem,
        id_NRT_Load_Information_Value,
        id_NRT_Load_Information_Value_IncrDecrThres,
        id_PagingArea_PagingRqst,
        id_FACH_FlowControlInformation,
        id_PartialReportingIndicator,
        id_Permanent_NAS_UE_Identity,
        id_PowerAdjustmentType,
        id_RANAP_RelocationInformation,
        id_RL_Information_PhyChReconfRqstFDD,
        id_RL_Information_PhyChReconfRqstTDD,
        id_RL_Information_RL_AdditionRqstFDD,
        id_RL_Information_RL_AdditionRqstTDD,
        id_RL_Information_RL_DeletionRqst,
        id_RL_Information_RL_FailureInd,
        id_RL_Information_RL_ReconfPrepFDD,
        id_RL_Information_RL_RestoreInd,
        id_RL_Information_RL_SetupRqstFDD,
        id_RL_Information_RL_SetupRqstTDD,
        id_RL_InformationItem_RL_CongestInd,
        id_RL_InformationItem_DM_Rprt,
        id_RL_InformationItem_DM_Rqst,
        id_RL_InformationItem_DM_Rsp,
        id_RL_InformationItem_RL_PreemptRequiredInd,
        id_RL_InformationItem_RL_SetupRqstFDD,
        id_RL_InformationList_RL_CongestInd,
        id_RL_InformationList_RL_AdditionRqstFDD,
        id_RL_InformationList_RL_DeletionRqst,
        id_RL_InformationList_RL_PreemptRequiredInd,
        id_RL_InformationList_RL_ReconfPrepFDD,
        id_RL_InformationResponse_RL_AdditionRspTDD,
        id_RL_InformationResponse_RL_ReconfReadyTDD,
        id_RL_InformationResponse_RL_SetupRspTDD,
        id_RL_InformationResponseItem_RL_AdditionRspFDD,
        id_RL_InformationResponseItem_RL_ReconfReadyFDD,
        id_RL_InformationResponseItem_RL_ReconfRspFDD,
        id_RL_InformationResponseItem_RL_SetupRspFDD,
        id_RL_InformationResponseList_RL_AdditionRspFDD,
        id_RL_InformationResponseList_RL_ReconfReadyFDD,
        id_RL_InformationResponseList_RL_ReconfRspFDD,
        id_RL_InformationResponse_RL_ReconfRspTDD,
        id_RL_InformationResponseList_RL_SetupRspFDD,
        id_RL_ReconfigurationFailure_RL_ReconfFail,
        id_RL_Set_InformationItem_DM_Rprt,
        id_RL_Set_InformationItem_DM_Rqst,
        id_RL_Set_InformationItem_DM_Rsp,
        id_RL_Set_Information_RL_FailureInd,
        id_RL_Set_Information_RL_RestoreInd,
        id_RL_Set_Successful_InformationItem_DM_Fail,
        id_RL_Set_Unsuccessful_InformationItem_DM_Fail,
        id_RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind,
        id_RL_Successful_InformationItem_DM_Fail,
        id_RL_Unsuccessful_InformationItem_DM_Fail,
        id_RL_Unsuccessful_InformationItem_DM_Fail_Ind,
        id_ReportCharacteristics,
        id_Reporting_Object_RL_FailureInd,
        id_Reporing_Object_RL_RestoreInd,
        id_RT_Load_Value,
        id_RT_Load_Value_IncrDecrThres,
        id_S_RNTI,
        id_ResetIndicator,
        id_RNC_ID,
        id_SAI,
        id_SRNC_ID,
        id_SuccessfulRL_InformationResponse_RL_AdditionFailureFDD,
        id_SuccessfulRL_InformationResponse_RL_SetupFailureFDD,
        id_TransportBearerID,
        id_TransportBearerRequestIndicator,
        id_TransportLayerAddress,
        id_TypeOfError,
        id_UC_ID,
        id_UL_CCTrCH_AddInformation_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        id_UL_CCTrCH_InformationList_RL_SetupRqstTDD,
        id_UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
        id_UL_CCTrCH_InformationListIE_RL_AdditionRspTDD,
        id_UL_CCTrCH_InformationListIE_RL_ReconfReadyTDD,
        id_UL_CCTrCH_InformationListIE_RL_SetupRspTDD,
        id_UL_DPCH_Information_RL_ReconfPrepFDD,
        id_UL_DPCH_Information_RL_ReconfRqstFDD,
        id_UL_DPCH_Information_RL_SetupRqstFDD,
        id_UL_DPCH_InformationItem_PhyChReconfRqstTDD,
        id_UL_DPCH_InformationItem_RL_AdditionRspTDD,
        id_UL_DPCH_InformationItem_RL_SetupRspTDD,
        id_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD,
        id_UL_SIRTarget,
        id_URA_Information,
        id_UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD,
        id_UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD,
        id_UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD,
        id_Active_Pattern_Sequence_Information,
        id_AdjustmentRatio,
        id_CauseLevel_RL_AdditionFailureFDD,
        id_CauseLevel_RL_AdditionFailureTDD,
        id_CauseLevel_RL_ReconfFailure,
        id_CauseLevel_RL_SetupFailureFDD,
        id_CauseLevel_RL_SetupFailureTDD,
        id_DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        id_DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        id_DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        id_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD,
        id_DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD,
        id_DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD,
        id_DSCHs_to_Add_TDD,
        id_Unused_ProtocolIE_ID_216,
        id_DSCH_DeleteList_RL_ReconfPrepTDD,
        id_Unused_ProtocolIE_ID_218,
        id_Unused_ProtocolIE_ID_219,
        id_DSCH_InformationListIE_RL_AdditionRspTDD,
        id_DSCH_InformationListIEs_RL_SetupRspTDD,
        id_DSCH_TDD_Information,
        id_Unused_ProtocolIE_ID_223,
        id_Unused_ProtocolIE_ID_226,
        id_DSCH_ModifyList_RL_ReconfPrepTDD,
        id_Unused_ProtocolIE_ID_228,
        id_Unused_ProtocolIE_ID_324,
        id_Unused_ProtocolIE_ID_229,
        id_DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD,
        id_Unused_ProtocolIE_ID_29,
        id_Unused_ProtocolIE_ID_225,
        id_GA_Cell,
        id_GA_CellAdditionalShapes,
        id_Unused_ProtocolIE_ID_246,
        id_Transmission_Gap_Pattern_Sequence_Information,
        id_UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD,
        id_UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        id_UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        id_UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        id_UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        id_UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        id_UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD,
        id_UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD,
        id_UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD,
        id_USCHs_to_Add,
        id_USCH_DeleteList_RL_ReconfPrepTDD,
        id_USCH_InformationListIE_RL_AdditionRspTDD,
        id_USCH_InformationListIEs_RL_SetupRspTDD,
        id_USCH_Information,
        id_USCH_ModifyList_RL_ReconfPrepTDD,
        id_USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD,
        id_DL_Physical_Channel_Information_RL_SetupRqstTDD,
        id_UL_Physical_Channel_Information_RL_SetupRqstTDD,
        id_ClosedLoopMode1_SupportIndicator,
        id_Unused_ProtocolIE_ID_277,
        id_STTD_SupportIndicator,
        id_CFNReportingIndicator,
        id_CNOriginatedPage_PagingRqst,
        id_InnerLoopDLPCStatus,
        id_PropagationDelay,
        id_RxTimingDeviationForTA,
        id_timeSlot_ISCP,
        id_CCTrCH_InformationItem_RL_FailureInd,
        id_CCTrCH_InformationItem_RL_RestoreInd,
        id_CommonMeasurementAccuracy,
        id_CommonMeasurementObjectType_CM_Rprt,
        id_CommonMeasurementObjectType_CM_Rqst,
        id_CommonMeasurementObjectType_CM_Rsp,
        id_CommonMeasurementType,
        id_CongestionCause,
        id_SFN,
        id_SFNReportingIndicator,
        id_InformationExchangeID,
        id_InformationExchangeObjectType_InfEx_Rprt,
        id_InformationExchangeObjectType_InfEx_Rqst,
        id_InformationExchangeObjectType_InfEx_Rsp,
        id_InformationReportCharacteristics,
        id_InformationType,
        id_neighbouring_LCR_TDD_CellInformation,
        id_DL_Timeslot_ISCP_LCR_Information_RL_SetupRqstTDD,
        id_RL_LCR_InformationResponse_RL_SetupRspTDD,
        id_UL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD,
        id_UL_DPCH_LCR_InformationItem_RL_SetupRspTDD,
        id_DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD,
        id_DL_DPCH_LCR_InformationItem_RL_SetupRspTDD,
        id_DSCH_LCR_InformationListIEs_RL_SetupRspTDD,
        id_USCH_LCR_InformationListIEs_RL_SetupRspTDD,
        id_DL_Timeslot_ISCP_LCR_Information_RL_AdditionRqstTDD,
        id_RL_LCR_InformationResponse_RL_AdditionRspTDD,
        id_UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD,
        id_UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD,
        id_DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD,
        id_DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD,
        id_DSCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        id_USCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        id_UL_DPCH_LCR_InformationAddListIE_RL_ReconfReadyTDD,
        id_UL_Timeslot_LCR_InformationModifyList_RL_ReconfReadyTDD,
        id_DL_DPCH_LCR_InformationAddListIE_RL_ReconfReadyTDD,
        id_DL_Timeslot_LCR_InformationModifyList_RL_ReconfReadyTDD,
        id_UL_Timeslot_LCR_InformationList_PhyChReconfRqstTDD,
        id_DL_Timeslot_LCR_InformationList_PhyChReconfRqstTDD,
        id_timeSlot_ISCP_LCR_List_DL_PC_Rqst_TDD,
        id_TSTD_Support_Indicator_RL_SetupRqstTDD,
        id_RestrictionStateIndicator,
        id_Load_Value,
        id_Load_Value_IncrDecrThres,
        id_OnModification,
        id_Received_Total_Wideband_Power_Value,
        id_Received_Total_Wideband_Power_Value_IncrDecrThres,
        id_SFNSFNMeasurementThresholdInformation,
        id_Transmitted_Carrier_Power_Value,
        id_Transmitted_Carrier_Power_Value_IncrDecrThres,
        id_TUTRANGPSMeasurementThresholdInformation,
        id_UL_Timeslot_ISCP_Value,
        id_UL_Timeslot_ISCP_Value_IncrDecrThres,
        id_Rx_Timing_Deviation_Value_LCR,
        id_DPC_Mode_Change_SupportIndicator,
        id_Unused_ProtocolIE_ID_247,
        id_Unused_ProtocolIE_ID_295,
        id_PrimaryCCPCH_RSCP_RL_ReconfPrepTDD,
        id_DL_TimeSlot_ISCP_Info_RL_ReconfPrepTDD,
        id_DL_Timeslot_ISCP_LCR_Information_RL_ReconfPrepTDD,
        id_DSCH_RNTI,
        id_DL_PowerBalancing_Information,
        id_DL_PowerBalancing_ActivationIndicator,
        id_DL_PowerBalancing_UpdatedIndicator,
        id_DL_ReferencePowerInformation,
        id_Enhanced_PrimaryCPICH_EcNo,
        id_IPDL_TDD_ParametersLCR,
        id_CellCapabilityContainer_FDD,
        id_CellCapabilityContainer_TDD,
        id_CellCapabilityContainer_TDD_LCR,
        id_RL_Specific_DCH_Info,
        id_RL_ReconfigurationRequestFDD_RL_InformationList,
        id_RL_ReconfigurationRequestFDD_RL_Information_IEs,
        id_RL_ReconfigurationRequestTDD_RL_Information,
        id_CommonTransportChannelResourcesInitialisationNotRequired,
        id_DelayedActivation,
        id_DelayedActivationList_RL_ActivationCmdFDD,
        id_DelayedActivationInformation_RL_ActivationCmdFDD,
        id_DelayedActivationList_RL_ActivationCmdTDD,
        id_DelayedActivationInformation_RL_ActivationCmdTDD,
        id_neighbouringTDDCellMeasurementInformationLCR,
        id_UL_SIR_Target_CCTrCH_InformationItem_RL_SetupRspTDD,
        id_UL_SIR_Target_CCTrCH_LCR_InformationItem_RL_SetupRspTDD,
        id_PrimCCPCH_RSCP_DL_PC_RqstTDD,
        id_HSDSCH_FDD_Information,
        id_HSDSCH_FDD_Information_Response,
        id_HSDSCH_FDD_Update_Information,
        id_HSDSCH_Information_to_Modify,
        id_HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd,
        id_HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
        id_HSDSCH_RNTI,
        id_HSDSCH_TDD_Information,
        id_HSDSCH_TDD_Information_Response,
        id_HSDSCH_TDD_Update_Information,
        id_HSPDSCH_RL_ID,
        id_HSDSCH_MACdFlows_to_Add,
        id_HSDSCH_MACdFlows_to_Delete,
        id_Angle_Of_Arrival_Value_LCR,
        id_TrafficClass,
        id_Unused_ProtocolIE_ID_248,
        id_Unused_ProtocolIE_ID_253,
        id_PDSCH_RL_ID,
        id_TimeSlot_RL_SetupRspTDD,
        id_GERAN_Cell_Capability,
        id_GERAN_Classmark,
        id_DSCH_InitialWindowSize,
        id_UL_Synchronisation_Parameters_LCR,
        id_SNA_Information,
        id_MAChs_ResetIndicator,
        id_TDD_DL_DPCH_TimeSlotFormatModifyItem_LCR_RL_ReconfReadyTDD,
        id_TDD_UL_DPCH_TimeSlotFormatModifyItem_LCR_RL_ReconfReadyTDD,
        id_TDD_TPC_UplinkStepSize_LCR_RL_SetupRqstTDD,
        id_UL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        id_UL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
        id_DL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        id_DL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
        id_TDD_TPC_UplinkStepSize_InformationAdd_LCR_RL_ReconfPrepTDD,
        id_TDD_TPC_UplinkStepSize_InformationModify_LCR_RL_ReconfPrepTDD,
        id_TDD_TPC_DownlinkStepSize_InformationAdd_RL_ReconfPrepTDD,
        id_TDD_TPC_DownlinkStepSize_InformationModify_RL_ReconfPrepTDD,
        id_UL_TimingAdvanceCtrl_LCR,
        id_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD,
        id_HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD,
        id_HS_SICH_Reception_Quality,
        id_HS_SICH_Reception_Quality_Measurement_Value,
        id_HSSICH_Info_DM_Rprt,
        id_HSSICH_Info_DM_Rqst,
        id_HSSICH_Info_DM,
        id_CCTrCH_Maximum_DL_Power_RL_SetupRspTDD,
        id_CCTrCH_Minimum_DL_Power_RL_SetupRspTDD,
        id_CCTrCH_Maximum_DL_Power_RL_AdditionRspTDD,
        id_CCTrCH_Minimum_DL_Power_RL_AdditionRspTDD,
        id_CCTrCH_Maximum_DL_Power_RL_ReconfReadyTDD,
        id_CCTrCH_Minimum_DL_Power_RL_ReconfReadyTDD,
        id_Maximum_DL_Power_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD,
        id_Minimum_DL_Power_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD,
        id_DL_CCTrCH_InformationList_RL_ReconfRspTDD,
        id_DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD,
        id_Maximum_DL_Power_TimeslotLCR_InformationItem,
        id_Minimum_DL_Power_TimeslotLCR_InformationItem,
        id_TDD_Support_8PSK,
        id_TDD_maxNrDLPhysicalchannels,
        id_ExtendedGSMCellIndividualOffset,
        id_RL_ParameterUpdateIndicationFDD_RL_InformationList,
        id_Primary_CPICH_Usage_For_Channel_Estimation,
        id_Secondary_CPICH_Information,
        id_Secondary_CPICH_Information_Change,
        id_Unused_ProtocolIE_ID_522,
        id_Unused_ProtocolIE_ID_523,
        id_RL_ParameterUpdateIndicationFDD_RL_Information_Item,
        id_Phase_Reference_Update_Indicator,
        id_Unidirectional_DCH_Indicator,
        id_RL_Information_RL_ReconfPrepTDD,
        id_Multiple_RL_InformationResponse_RL_ReconfReadyTDD,
        id_RL_ReconfigurationResponseTDD_RL_Information,
        id_Satellite_Almanac_Information_ExtItem,
        id_HSDSCH_Information_to_Modify_Unsynchronised,
        id_TnlQos,
        id_RTLoadValue,
        id_NRTLoadInformationValue,
        id_CellPortionID,
        id_UpPTSInterferenceValue,
        id_PrimaryCCPCH_RSCP_Delta,
        id_UEMeasurementType,
        id_UEMeasurementTimeslotInfoHCR,
        id_UEMeasurementTimeslotInfoLCR,
        id_UEMeasurementReportCharacteristics,
        id_UEMeasurementParameterModAllow,
        id_UEMeasurementValueInformation,
        id_InterfacesToTraceItem,
        id_ListOfInterfacesToTrace,
        id_TraceDepth,
        id_TraceRecordingSessionReference,
        id_TraceReference,
        id_UEIdentity,
        id_NACC_Related_Data,
        id_GSM_Cell_InfEx_Rqst,
        id_MeasurementRecoveryBehavior,
        id_MeasurementRecoveryReportingIndicator,
        id_MeasurementRecoverySupportIndicator,
        id_DL_DPCH_Power_Information_RL_ReconfPrepFDD,
        id_F_DPCH_Information_RL_ReconfPrepFDD,
        id_F_DPCH_Information_RL_SetupRqstFDD,
        id_MBMS_Bearer_Service_List,
        id_MBMS_Bearer_Service_List_InfEx_Rsp,
        id_Active_MBMS_Bearer_ServiceFDD,
        id_Active_MBMS_Bearer_ServiceTDD,
        id_Old_URA_ID,
        id_UE_State,
        id_URA_ID,
        id_HARQ_Preamble_Mode,
        id_SynchronisationIndicator,
        id_UL_DPDCHIndicatorEDCH,
        id_EDPCH_Information,
        id_RL_Specific_EDCH_Information,
        id_EDCH_RL_Indication,
        id_EDCH_FDD_Information,
        id_EDCH_RLSet_Id,
        id_Serving_EDCHRL_Id,
        id_EDCH_FDD_DL_ControlChannelInformation,
        id_EDCH_FDD_InformationResponse,
        id_EDCH_MACdFlows_To_Add,
        id_EDCH_FDD_Information_To_Modify,
        id_EDCH_MACdFlows_To_Delete,
        id_EDPCH_Information_RLReconfRequest_FDD,
        id_EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd,
        id_EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
        id_EDCH_MacdFlowSpecificInformationList_RL_CongestInd,
        id_EDCH_MacdFlowSpecificInformationItem_RL_CongestInd,
        id_MBMS_Bearer_Service_Full_Address,
        id_Initial_DL_DPCH_TimingAdjustment,
        id_Initial_DL_DPCH_TimingAdjustment_Allowed,
        id_User_Plane_Congestion_Fields_Inclusion,
        id_HARQ_Preamble_Mode_Activation_Indicator,
        id_multiple_DedicatedMeasurementValueList_TDD_DM_Rsp,
        id_multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp,
        id_ProvidedInformation,
        id_Active_MBMS_Bearer_ServiceFDD_PFL,
        id_Active_MBMS_Bearer_ServiceTDD_PFL,
        id_FrequencyBandIndicator,
        id_Serving_cell_change_CFN,
        id_HS_DSCH_serving_cell_change_information,
        id_HS_DSCH_serving_cell_change_informationResponse,
        id_E_DCH_Serving_cell_change_informationResponse,
        id_secondary_LCR_CCPCH_Info_TDD,
        id_E_DCH_FDD_Update_Information,
        id_Inter_Frequency_Cell_List,
        id_Inter_Frequency_Cell_Information,
        id_multiple_HSSICHMeasurementValueList_TDD_DM_Rsp,
        id_TDD_Support_PLCCH,
        id_PLCCH_Information_UL_TimeslotLCR_Info,
        id_PLCCH_Information_PhyChReconfRqstTDD,
        id_TDD768_maxNrDLPhysicalchannelsTS,
        id_RL_InformationResponse_RL_AdditionRspTDD768,
        id_UL_CCTrCH_InformationListIE_RL_AdditionRspTDD768,
        id_DL_CCTrCH_InformationListIE_RL_AdditionRspTDD768,
        id_UL_DPCH_InformationItem_RL_AdditionRspTDD768,
        id_DL_DPCH_InformationItem_RL_AdditionRspTDD768,
        id_UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD768,
        id_UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768,
        id_DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD768,
        id_DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768,
        id_secondary_CCPCH_Info_RL_ReconfReadyTDD768,
        id_hSSCCH_TDD_Specific_InfoList_Response768,
        id_hSPDSCH_TDD_Specific_InfoList_Response768,
        id_HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768,
        id_UL_Timeslot_InformationList_PhyChReconfRqstTDD768,
        id_DL_Timeslot_InformationList_PhyChReconfRqstTDD768,
        id_CellCapabilityContainer_TDD768,
        id_multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp,
        id_neighbouringTDDCellMeasurementInformation768,
        id_UEMeasurementTimeslotInfo768,
        id_Rx_Timing_Deviation_Value_768,
        id_UEMeasurementValueTransmittedPowerList768,
        id_UEMeasurementValueTimeslotISCPList768,
        id_RL_InformationResponse_RL_SetupRspTDD768,
        id_UL_CCTrCH_InformationListIE_RL_SetupRspTDD768,
        id_DL_CCTrCH_InformationListIE_RL_SetupRspTDD768,
        id_UL_DPCH_InformationItem_RL_SetupRspTDD768,
        id_DL_DPCH_InformationItem_RL_SetupRspTDD768,
        id_TDD768_minimumSpreadingFactor_UL,
        id_TDD768_minimumSpreadingFactor_DL,
        id_TDD768_maxNrDLPhysicalchannels,
        id_DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD,
        id_DPCH_ID768_DM_Rsp,
        id_DPCH_ID768_DM_Rqst,
        id_DPCH_ID768_DM_Rprt,
        id_EDPCH_Information_RLAdditionReq_FDD,
        id_HSDSCH_Configured_Indicator,
        id_RxTimingDeviationForTAext,
        id_RxTimingDeviationForTA768,
        id_Rx_Timing_Deviation_Value_ext,
        id_E_DCH_PowerOffset_for_SchedulingInfo,
        id_TrCH_SrcStatisticsDescr,
        id_E_DCH_Information,
        id_E_DCH_Serving_RL_ID,
        id_E_DCH_Information_Reconfig,
        id_E_DCH_Information_Response,
        id_E_DCH_768_Information,
        id_E_DCH_768_Information_Reconfig,
        id_E_DCH_768_Information_Response,
        id_ExtendedPropagationDelay,
        id_Extended_Round_Trip_Time_Value,
        id_AlternativeFormatReportingIndicator,
        id_DCH_Indicator_For_E_DCH_HSDPA_Operation,
        id_E_RGCH_E_HICH_ChannelisationCodeValidityIndicator,
        id_E_DCH_Minimum_Set_E_TFCIValidityIndicator,
        id_Fast_Reconfiguration_Mode,
        id_Fast_Reconfiguration_Permission,
        id_Continuous_Packet_Connectivity_DTX_DRX_Information,
        id_Continuous_Packet_Connectivity_HS_SCCH_Less_Information,
        id_Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response,
        id_CPC_Information,
        id_MIMO_InformationResponse,
        id_E_DCH_LCR_Information,
        id_E_DCH_LCR_Information_Reconfig,
        id_E_DCH_LCR_Information_Response,
        id_HS_PDSCH_Code_Change_Grant,
        id_HS_PDSCH_Code_Change_Indicator,
        id_Extended_SRNC_ID,
        id_Extended_RNC_ID,
        id_SixtyfourQAM_DL_SupportIndicator,
        id_Enhanced_FACH_Support_Indicator,
        id_Enhanced_FACH_Information_ResponseFDD,
        id_HSDSCH_MACdPDUSizeFormat,
        id_MaximumMACdPDU_SizeExtended,
        id_F_DPCH_SlotFormat,
        id_F_DPCH_SlotFormatSupportRequest,
        id_eDCH_MACdFlow_Retransmission_Timer_LCR,
        id_Max_UE_DTX_Cycle,
        id_GANSS_Common_Data,
        id_GANSS_Information,
        id_GANSS_Generic_Data,
        id_TUTRANGANSSMeasurementThresholdInformation,
        id_TUTRANGANSSMeasurementValueInformation,
        id_Ext_Reference_E_TFCI_PO,
        id_Ext_Max_Bits_MACe_PDU_non_scheduled,
        id_HARQ_MemoryPartitioningInfoExtForMIMO,
        id_MIMO_ActivationIndicator,
        id_MIMO_Mode_Indicator,
        id_MIMO_N_M_Ratio,
        id_TransportBearerNotSetupIndicator,
        id_TransportBearerNotRequestedIndicator,
        id_PowerControlGAP,
        id_UARFCNforNt,
        id_LCRTDD_uplink_Physical_Channel_Capability,
        id_number_Of_Supported_Carriers,
        id_HSSICH_SIRTarget,
        id_HSSICH_TPC_StepSize,
        id_tSN_Length,
        id_HS_SICH_ID_Extension,
        id_HSSICH_Info_DM_Rqst_Extension,
        id_multipleFreq_HSPDSCH_InformationList_ResponseTDDLCR,
        id_multicarrier_number,
        id_UPPCHPositionLCR,
        id_UpPCH_InformationList_LCRTDD,
        id_UpPCH_InformationItem_LCRTDD,
        id_Multiple_PLMN_List,
        id_UE_Capabilities_Info,
        id_FrameOffset,
        id_ChipOffset,
        id_Enhanced_PCH_Capability,
        id_SixteenQAM_UL_Operation_Indicator,
        id_E_TFCI_Boost_Information,
        id_SixtyfourQAM_UsageAllowedIndicator,
        id_SixtyfourQAM_DL_UsageIndicator,
        id_Default_Serving_Grant_in_DTX_Cycle2,
        id_E_DPDCH_PowerInterpolation,
        id_Extended_E_DCH_LCRTDD_PhysicalLayerCategory,
        id_E_DCH_MACdPDUSizeFormat,
        id_Continuous_Packet_Connectivity_HS_SCCH_Less_Deactivate_Indicator,
        id_E_DCH_DL_Control_Channel_Change_Information,
        id_E_DCH_DL_Control_Channel_Grant_Information,
        id_MaximumNumber_Of_Retransmission_For_SchedulingInfo_LCRTDD,
        id_E_DCH_RetransmissionTimer_For_SchedulingInfo_LCRTDD,
        id_E_PUCH_PowerControlGAP,
        id_HSDSCH_TBSizeTableIndicator,
        id_UE_with_enhanced_HS_SCCH_support_indicator,
        id_DGANSS_Corrections_Req,
        id_E_AGCH_Table_Choice,
        id_RANAP_EnhancedRelocationInformationRequest,
        id_RANAP_EnhancedRelocationInformationResponse,
        id_Common_EDCH_MAC_d_Flow_Specific_InformationFDD,
        id_Common_EDCH_Support_Indicator,
        id_E_RNTI,
        id_Released_CN_Domain,
        id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst,
        id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp,
        id_MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt,
        id_MBMS_Cell_InfEx_Rqst,
        id_MBMS_Cell_InfEx_Rsp,
        id_MBMS_Cell_InfEx_Rprt,
        id_Counting_Information,
        id_Transmission_Mode_Information,
        id_MBMS_Neighbouring_Cell_Information,
        id_MBMS_RLC_Sequence_Number_Information,
        id_RLC_Sequence_Number,
        id_Neighbouring_E_UTRA_CellInformation,
        id_MBSFN_Cluster_Identity,
        id_MCCH_Configuration_Info,
        id_MCCH_Message_List,
        id_MBSFN_Scheduling_Transmission_Time_Interval_Info_List,
        id_GANSS_Time_ID,
        id_GANSS_AddIonoModelReq,
        id_GANSS_EarthOrientParaReq,
        id_GANSS_AddNavigationModelsReq,
        id_GANSS_AddUTCModelsReq,
        id_GANSS_AuxInfoReq,
        id_GANSS_SBAS_ID,
        id_GANSS_ID,
        id_GANSS_Additional_Ionospheric_Model,
        id_GANSS_Earth_Orientation_Parameters,
        id_GANSS_Additional_Time_Models,
        id_GANSS_Additional_Navigation_Models,
        id_GANSS_Additional_UTC_Models,
        id_GANSS_Auxiliary_Information,
        id_MinimumReducedE_DPDCH_GainFactor,
        id_Enhanced_FACH_Information_ResponseLCR,
        id_Common_EDCH_MAC_d_Flow_Specific_InformationLCR,
        id_HSDSCH_PreconfigurationSetup,
        id_HSDSCH_PreconfigurationInfo,
        id_NoOfTargetCellHS_SCCH_Order,
        id_EnhancedHSServingCC_Abort,
        id_Additional_HS_Cell_Information_RL_Setup,
        id_Additional_HS_Cell_Information_Response,
        id_Additional_HS_Cell_Information_RL_Addition,
        id_Additional_HS_Cell_Change_Information_Response,
        id_Additional_HS_Cell_Information_RL_Reconf_Prep,
        id_Additional_HS_Cell_Information_RL_Reconf_Req,
        id_Additional_HS_Cell_RL_Reconf_Response,
        id_Additional_HS_Cell_Information_RL_Param_Upd,
        id_Secondary_Serving_Cell_List,
        id_MultiCarrier_HSDSCH_Physical_Layer_Category,
        id_IdleIntervalInformation,
        id_NeedforIdleInterval,
        id_IdleIntervalConfigurationIndicator,
        id_ContinuousPacketConnectivity_DRX_InformationLCR,
        id_ContinuousPacketConnectivity_DRX_Information_ResponseLCR,
        id_E_AGCH_UE_Inactivity_Monitor_Threshold,
        id_CPC_InformationLCR,
        id_E_DCH_Semi_PersistentScheduling_Information_LCR,
        id_HS_DSCH_Semi_PersistentScheduling_Information_LCR,
        id_HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR,
        id_E_DCH_Semi_PersistentScheduling_Information_ResponseLCR,
        id_MIMO_SFMode_For_HSPDSCHDualStream,
        id_MIMO_SFMode_Supported_For_HSPDSCHDualStream,
        id_MIMO_ReferenceSignal_InformationListLCR,
        id_GANSS_alm_keplerianNAVAlmanac,
        id_GANSS_alm_keplerianReducedAlmanac,
        id_GANSS_alm_keplerianMidiAlmanac,
        id_GANSS_alm_keplerianGLONASS,
        id_GANSS_alm_ecefSBASAlmanac,
        id_DL_RLC_PDU_Size_Format,
        id_MACes_Maximum_Bitrate_LCR,
        id_Single_Stream_MIMO_ActivationIndicator,
        id_Single_Stream_MIMO_Mode_Indicator,
        id_Dual_Band_Secondary_Serving_Cell_List,
        id_UE_AggregateMaximumBitRate,
        id_power_offset_for_S_CPICH_for_MIMO,
        id_power_offset_for_S_CPICH_for_MIMO_Request_Indicator,
        id_UE_SupportIndicatorExtension,
        id_ActivationInformation,
        id_CellPortionLCRID,
        id_Additional_EDCH_Cell_Information_RL_Setup_Req,
        id_Additional_EDCH_Cell_Information_Response,
        id_Additional_EDCH_Cell_Information_RL_Add_Req,
        id_Additional_EDCH_Cell_Information_Response_RLAdd,
        id_Additional_EDCH_Cell_Information_RL_Reconf_Prep,
        id_Additional_EDCH_Cell_Information_RL_Reconf_Req,
        id_Additional_EDCH_Cell_Information_RL_Param_Upd,
        id_Additional_EDCH_Preconfiguration_Information,
        id_MulticellEDCH_Information,
        id_Additional_EDCH_Cell_Information_ResponseRLReconf,
        id_EDCH_Indicator,
        id_DiversityMode,
        id_TransmitDiversityIndicator,
        id_NonCellSpecificTxDiversity,
        id_CellCapabilityContainerExtension_FDD,
        id_HSDSCH_Physical_Layer_Category,
        id_E_RNTI_For_FACH,
        id_H_RNTI_For_FACH,
        id_RNTI_Allocation_Indicator,
        id_UE_AggregateMaximumBitRate_Enforcement_Indicator,
        id_DCH_MeasurementOccasion_Information,
        id_DCH_MeasurementType_Indicator,
        id_Out_of_Sychronization_Window,
        id_MulticellEDCH_RL_SpecificInformation,
        id_DGNSS_ValidityPeriod,
        id_TS0_HS_PDSCH_Indication_LCR,
        id_UE_TS0_CapabilityLCR,
        id_Non_Serving_RL_Preconfig_Info,
        id_Non_Serving_RL_Preconfig_Setup,
        id_Non_Serving_RL_Preconfig_Removal,
        id_Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup,
        id_Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList,
        id_CellListValidityIndicator,
        id_completeAlmanacProvided,
        id_ganss_Delta_T,
        id_OrdinalNumberOfFrequency,
        id_Multicell_EDCH_Restriction,
        id_CellCapabilityContainerExtension_TDD_LCR,
        id_Multi_Carrier_EDCH_Setup,
        id_Multi_Carrier_EDCH_Reconfigure,
        id_Multi_Carrier_EDCH_Response,
        id_SNPL_Carrier_Group_Indicator,
        id_MU_MIMO_InformationLCR,
        id_MU_MIMO_Indicator,
        id_HS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext,
        id_Usefulness_Of_Battery_Optimization,
        id_Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory,
        id_Measurement_Power_Offset,
        id_MDT_Configuration,
        id_Neighbouring_UMTS_CellInformation_Ext,
        id_Neighbouring_UMTS_CellInformationExtensionItem,
        id_Control_Type_InformationTransferControlReq,
        id_UMTS_Cells_Info,
        id_ANRReportIndication,
        id_ANR_Cell_InfEx_Rqst,
        id_ANR_Cell_InfEx_Rsp,
        id_ANR_Cell_Information,
        id_Trace_Collection_Entity_IP_Address,
        id_Affected_HSDSCH_Serving_Cell_List,
        id_UL_CLTD_Information,
        id_UL_CLTD_Information_Reconf,
        id_UL_CLTD_State_Update_Information,
        id_Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order,
        id_CPC_RecoveryReport,
        id_FTPICH_Information,
        id_FTPICH_Information_Reconf,
        id_UE_RF_Band_CapabilityLCR,
        id_Extended_S_RNTI,
        id_ExtendedAffectedUEInformationForMBMS,
        id_Extended_S_RNTI_Group,
        id_FTPICH_Information_Response,
        id_FTPICH_Reconfiguration_Information,
        id_MIMO_withfourtransmitantennas_ActivationIndicator,
        id_MIMO_withfourtransmitantennas_ModeIndicator,
        id_power_offset_for_S_CPICH_for_MIMO_withfourtransmitantennas,
        id_power_offset_for_S_CPICH_for_MIMO_withfourtransmitantennas_Request_Indicator,
        id_DualStream_MIMO_withfourtransmitantennas_ActivationIndicator,
        id_DualStream_MIMO_withfourtransmitantennas_ModeIndicator,
        id_Additional_Associated_Secondary_CPICH,
        id_UE_transmission_power_headroom,
        id_Multiflow_Information,
        id_Multiflow_Reconfiguration,
        id_Multiflow_OrdinalNumberOfFrequency,
        id_UL_MIMO_Information,
        id_UL_MIMO_Reconfiguration,
        id_UL_MIMO_DL_Control_Channel_Information,
        id_SixtyfourQAM_UL_Operation_Indicator,
        id_Common_E_RGCH_Cell_InfEx_Rqst,
        id_Common_E_RGCH_Cell_InfEx_Rsp,
        id_Common_E_RGCH_Cell_InfEx_Rprt,
        id_Common_E_RGCH_Cell_Information,
        id_PCI,
        id_TAC,
        id_PLMN_List,
        id_PrecoderWeightSetRestriction,
        id_EARFCN_FDD_Extended,
        id_EARFCN_TDD_Extended,
        id_Non_rectangular_resource_allocation_indicator,
        id_Non_rectangular_resource_timeslot_set,
        id_UE_Support_of_non_rectangular_resource_allocation,
        id_DBDS_CorrectionsReq,
        id_DBDS_Corrections,
        id_BDS_IonosphericGridModelReq,
        id_BDS_Ionospheric_Grid_Model,
        id_GANSS_alm_keplerianBDSAlmanac,
        id_Assisting_RepetitionFactors,
        id_E_DCH_Decoupling_Indication,
        id_UE_Measurement_Forwarding,
        id_UPH_Filtering_Measurement_Forwarding_Request,
        id_TTI_Update_Indicator,
        id_CQI_Feedback_Cycle2_k,
        id_CQI_Cycle_Switch_Timer,
        id_UE_DRX_Cycle2,
        id_Inactivity_Threshold_for_UE_DRX_Cycle2,
        id_DTX_Information2,
        id_DCH_ENH_Information,
        id_DCH_ENH_Information_Reconf,
        id_Gainfactors_10ms_mode,
        id_Radio_Links_without_DPCH_FDPCH_Indication,
        id_UL_DPCCH2_Information,
        id_UL_DPCCH2_Information_Reconf,
        id_ImplicitGrantHandling,
        id_MinimumTEBSthreshold,
        id_MultipleFrequencyBandsIndicatorList_EUTRA,
        id_MultipleFrequencyBandsIndicatorList,
        id_ActivationDelay,
        id_Fast_TTI_switching_Mode_synchronized,
        id_Fast_TTI_switching_Mode_unsynchronized,
        id_Fast_TTI_switching_Mode_Supported,
        id_GANSS_BDSclockModel,
        id_GANSS_NavModel_BDSKeplerianSet,
        id_GANSS_UTCmodelSet4,
        id_Inter_Frequency_Cell_Information_SIB11ter,
        id_Improved_Synchronized_Indicator,
        id_Downlink_TPC_enhancements_Information,
        id_Downlink_TPC_enhancements_Reconf,
        id_TPC_slot_position,
        id_DL_TBS,
        id_Selected_PLMN_Identity,
        id_Dual_Cell_EDCH_Enhancements_Information,
        id_SpeechVersion,
        id_SourceID,
        id_TargetID,
        id_ClassmarkInformation2,
        id_ClassmarkInformation3,
        id_GSM_Cell_CM_Rqst,
        id_Extension_CommonMeasurementObjectType_CM_Rprt,
        id_Extension_CommonMeasurementObjectType_CM_Rqst,
        id_Extension_CommonMeasurementObjectType_CM_Rsp,
        id_Extension_FailureIndicationMeasurementList,
        id_Extension_FailureMeasurementList,
        id_Extension_TerminationMeasurementList,
        id_GsmCellList_CM_Rprt,
        id_GsmCellList_CM_Rqst,
        id_GsmCellList_CM_Rsp,
        id_LoadValue,
        id_EventH,
    ]

class RNSAP_Containers:

    _name_  = u'RNSAP-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 1, 1, 5]
    
    _obj_ = [
        u'RNSAP-PROTOCOL-IES',
        u'RNSAP-PROTOCOL-IES-PAIR',
        u'RNSAP-PROTOCOL-EXTENSION',
        u'RNSAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _type_ = [
        u'RNSAP-PROTOCOL-IES',
        u'RNSAP-PROTOCOL-IES-PAIR',
        u'RNSAP-PROTOCOL-EXTENSION',
        u'RNSAP-PRIVATE-IES',
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'RNSAP-PROTOCOL-IES',
        u'RNSAP-PROTOCOL-IES-PAIR',
        u'RNSAP-PROTOCOL-EXTENSION',
        u'RNSAP-PRIVATE-IES',
        ]
    _param_ = [
        u'ProtocolIE-Container',
        u'ProtocolIE-Single-Container',
        u'ProtocolIE-Field',
        u'ProtocolIE-ContainerPair',
        u'ProtocolIE-FieldPair',
        u'ProtocolIE-ContainerList',
        u'ProtocolIE-ContainerPairList',
        u'ProtocolExtensionContainer',
        u'ProtocolExtensionField',
        u'PrivateIE-Container',
        u'PrivateIE-Field',
        ]
    
    #-----< RNSAP-PROTOCOL-IES >-----#
    RNSAP_PROTOCOL_IES = CLASS(name=u'RNSAP-PROTOCOL-IES', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_IES_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RNSAP_PROTOCOL_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')))
    _RNSAP_PROTOCOL_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Presence')))
    RNSAP_PROTOCOL_IES._cont = ASN1Dict([
        (u'id', _RNSAP_PROTOCOL_IES_id),
        (u'criticality', _RNSAP_PROTOCOL_IES_criticality),
        (u'Value', _RNSAP_PROTOCOL_IES_Value),
        (u'presence', _RNSAP_PROTOCOL_IES_presence),
        ])
    
    #-----< RNSAP-PROTOCOL-IES-PAIR >-----#
    RNSAP_PROTOCOL_IES_PAIR = CLASS(name=u'RNSAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_IES_PAIR_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RNSAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name=u'firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')))
    _RNSAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name=u'FirstValue', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name=u'secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')))
    _RNSAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name=u'SecondValue', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_IES_PAIR_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Presence')))
    RNSAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        (u'id', _RNSAP_PROTOCOL_IES_PAIR_id),
        (u'firstCriticality', _RNSAP_PROTOCOL_IES_PAIR_firstCriticality),
        (u'FirstValue', _RNSAP_PROTOCOL_IES_PAIR_FirstValue),
        (u'secondCriticality', _RNSAP_PROTOCOL_IES_PAIR_secondCriticality),
        (u'SecondValue', _RNSAP_PROTOCOL_IES_PAIR_SecondValue),
        (u'presence', _RNSAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< RNSAP-PROTOCOL-EXTENSION >-----#
    RNSAP_PROTOCOL_EXTENSION = CLASS(name=u'RNSAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_EXTENSION_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RNSAP_PROTOCOL_EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')))
    _RNSAP_PROTOCOL_EXTENSION_Extension = OPEN(name=u'Extension', mode=MODE_TYPE)
    _RNSAP_PROTOCOL_EXTENSION_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Presence')))
    RNSAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        (u'id', _RNSAP_PROTOCOL_EXTENSION_id),
        (u'criticality', _RNSAP_PROTOCOL_EXTENSION_criticality),
        (u'Extension', _RNSAP_PROTOCOL_EXTENSION_Extension),
        (u'presence', _RNSAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< RNSAP-PRIVATE-IES >-----#
    RNSAP_PRIVATE_IES = CLASS(name=u'RNSAP-PRIVATE-IES', mode=MODE_TYPE)
    _RNSAP_PRIVATE_IES_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'PrivateIE-ID')))
    _RNSAP_PRIVATE_IES_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')))
    _RNSAP_PRIVATE_IES_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    _RNSAP_PRIVATE_IES_presence = ENUM(name=u'presence', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Presence')))
    RNSAP_PRIVATE_IES._cont = ASN1Dict([
        (u'id', _RNSAP_PRIVATE_IES_id),
        (u'criticality', _RNSAP_PRIVATE_IES_criticality),
        (u'Value', _RNSAP_PRIVATE_IES_Value),
        (u'presence', _RNSAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name=u'ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name=u'ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name=u'ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name=u'ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name=u'ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name=u'ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name=u'ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name=u'ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name=u'ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name=u'PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name=u'PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _RNSAP_PROTOCOL_IES_id,
        _RNSAP_PROTOCOL_IES_criticality,
        _RNSAP_PROTOCOL_IES_Value,
        _RNSAP_PROTOCOL_IES_presence,
        RNSAP_PROTOCOL_IES,
        _RNSAP_PROTOCOL_IES_PAIR_id,
        _RNSAP_PROTOCOL_IES_PAIR_firstCriticality,
        _RNSAP_PROTOCOL_IES_PAIR_FirstValue,
        _RNSAP_PROTOCOL_IES_PAIR_secondCriticality,
        _RNSAP_PROTOCOL_IES_PAIR_SecondValue,
        _RNSAP_PROTOCOL_IES_PAIR_presence,
        RNSAP_PROTOCOL_IES_PAIR,
        _RNSAP_PROTOCOL_EXTENSION_id,
        _RNSAP_PROTOCOL_EXTENSION_criticality,
        _RNSAP_PROTOCOL_EXTENSION_Extension,
        _RNSAP_PROTOCOL_EXTENSION_presence,
        RNSAP_PROTOCOL_EXTENSION,
        _RNSAP_PRIVATE_IES_id,
        _RNSAP_PRIVATE_IES_criticality,
        _RNSAP_PRIVATE_IES_Value,
        _RNSAP_PRIVATE_IES_presence,
        RNSAP_PRIVATE_IES,
    ]

class RNSAP_IEs:

    _name_  = u'RNSAP-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 1, 1, 2]
    
    _obj_ = [
        u'AccessPointName',
        u'AckNack-RepetitionFactor',
        u'Ack-Power-Offset',
        u'ActivationDelay',
        u'Activate-Info',
        u'Activate-Info-ExtIEs',
        u'ActivationInformation',
        u'ActivationInformationItem',
        u'ActivationInformationItem-ExtIEs',
        u'Active-MBMS-Bearer-Service-ListFDD',
        u'Active-MBMS-Bearer-Service-ListFDD-PFL',
        u'Active-MBMS-Bearer-Service-ListTDD',
        u'Active-MBMS-Bearer-Service-ListTDD-PFL',
        u'Active-Pattern-Sequence-Information',
        u'Active-Pattern-Sequence-Information-ExtIEs',
        u'Additional-EDCH-Cell-Information-Response-RLAddList',
        u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs',
        u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs-ExtIEs',
        u'Additional-EDCH-Setup-Info',
        u'Additional-EDCH-Setup-Info-ExtIEs',
        u'ANRReportIndication',
        u'ANRReportIndication-ExtIEs',
        u'Additional-EDCH-Cell-Information-Setup',
        u'Additional-EDCH-FDD-Setup-Cell-Information',
        u'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Setup',
        u'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs',
        u'Additional-EDCH-F-DPCH-Information',
        u'Additional-EDCH-F-DPCH-Information-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-List',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-To-Add-List',
        u'Additional-EDCH-Cell-Information-To-Add-ItemIEs',
        u'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Addition',
        u'Additional-EDCH-UL-DPCH-Information-Addition-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Add-List',
        u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-List',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Information',
        u'Additional-EDCH-FDD-Information-ExtIEs',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-List',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs',
        u'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs',
        u'Additional-EDCH-Cell-Information-Response-List',
        u'Additional-EDCH-FDD-Information-Response-ItemIEs',
        u'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-Response-RLReconf-List',
        u'Additional-EDCH-FDD-Information-Response-RLReconf-Items',
        u'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs',
        u'Additional-EDCH-Cell-Information-ConfigurationChange-List',
        u'Additional-EDCH-ConfigurationChange-Info-ItemIEs',
        u'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Modify',
        u'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs',
        u'Additional-EDCH-Cell-Information-Removal-List',
        u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs',
        u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs',
        u'RL-on-Secondary-UL-Frequency',
        u'Additional-EDCH-FDD-Update-Information',
        u'Additional-EDCH-FDD-Update-Information-ExtIEs',
        u'Additional-EDCH-DL-Control-Channel-Change-Information-List',
        u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs',
        u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs',
        u'AdditionalPreferredFrequency',
        u'AdditionalPreferredFrequencyItem',
        u'AdditionalPreferredFrequencyItem-ExtIEs',
        u'AdjustmentPeriod',
        u'AffectedUEInformationForMBMS',
        u'AllocationRetentionPriority',
        u'AllocationRetentionPriority-ExtIEs',
        u'Allowed-Rate-Information',
        u'Allowed-Rate-Information-ExtIEs',
        u'Allowed-Rate',
        u'AllowedQueuingTime',
        u'AlphaValue',
        u'AlternativeFormatReportingIndicator',
        u'Angle-Of-Arrival-Value-LCR',
        u'Angle-Of-Arrival-Value-LCR-ExtIEs',
        u'ANR-Cell-Information',
        u'ANR-Cell-Information-ExtIEs',
        u'ANR-FDD-CellInformation',
        u'ANR-FDD-CellInformation-ExtIEs',
        u'ANR-TDD-CellInformation',
        u'ANR-TDD-CellInformation-ExtIEs',
        u'ANR-LCR-TDD-CellInformation',
        u'ANR-LCR-TDD-CellInformation-ExtIEs',
        u'ANR-Multiple-PLMN-List',
        u'ANR-Multiple-PLMN-List-ExtIEs',
        u'AOA-LCR',
        u'AOA-LCR-Accuracy-Class',
        u'AntennaColocationIndicator',
        u'BadSatellites',
        u'BadSatelliteInformation-ExtIEs',
        u'BadSatellites-ExtIEs',
        u'Band-Indicator',
        u'BCC',
        u'BCCH-ARFCN',
        u'BDS-IGPInfoList',
        u'BDS-IGPInfo',
        u'BDS-IGPInfo-ExtIEs',
        u'BDS-IonosphericGridModelReq',
        u'BDS-Ionospheric-Grid-Model',
        u'BDS-Ionospheric-Grid-Model-ExtIEs',
        u'BetaCD',
        u'BindingID',
        u'BLER',
        u'BSIC',
        u'BundlingModeIndicator',
        u'BurstModeParameters',
        u'BurstModeParameters-ExtIEs',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CellBased',
        u'CellBased-ExtIEs',
        u'CellIdList',
        u'Cell-Id',
        u'CellCapabilityContainer-FDD',
        u'CellCapabilityContainerExtension-FDD',
        u'CellCapabilityContainer-TDD',
        u'CellCapabilityContainer-TDD-LCR',
        u'CellCapabilityContainerExtension-TDD-LCR',
        u'CellCapabilityContainer-TDD768',
        u'C-ID',
        u'CCTrCH-ID',
        u'Cell-Capacity-Class-Value',
        u'CellIndividualOffset',
        u'CellListValidityIndicator',
        u'CellParameterID',
        u'CellPortionID',
        u'CellPortionLCRID',
        u'CFN',
        u'CGI',
        u'LAI-ExtIEs',
        u'CGI-ExtIEs',
        u'ChannelCodingType',
        u'ChipOffset',
        u'CI',
        u'ClassmarkInformation2',
        u'ClassmarkInformation3',
        u'ClosedLoopMode1-SupportIndicator',
        u'Closedlooptimingadjustmentmode',
        u'CodingRate',
        u'CommonMeasurementAccuracy',
        u'CommonMeasurementType',
        u'CommonMeasurementValue',
        u'CommonMeasurementValueInformation',
        u'CommonMeasurementAvailable',
        u'CommonMeasurementAvailableItem-ExtIEs',
        u'CongestionCause',
        u'CommonTransportChannelResourcesInitialisationNotRequired',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDD',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem-ExtIEs',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationLCR',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR-ExtIEs',
        u'Common-E-DCH-LogicalChannelInformation',
        u'Common-E-DCH-LogicalChannelInformationItem',
        u'Common-E-DCH-LogicalChannelInformationItem-ExtIEs',
        u'Common-EDCH-Support-Indicator',
        u'Common-E-RGCH-Cell-Information',
        u'Common-E-RGCH-Cell-Info',
        u'Common-E-RGCH-De-Activation',
        u'CompleteAlmanacProvided',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-ExtIEs',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify-ExtIEs',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem-ExtIEs',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response-ExtIEs',
        u'CorrespondingCells',
        u'CoverageIndicator',
        u'CPC-Information',
        u'CPC-Information-ExtIEs',
        u'CPC-RecoveryReport',
        u'Continuous-Packet-Connectivity-HS-SCCH-less-Deactivate-Indicator',
        u'Counting-Information',
        u'Counting-Information-List',
        u'Counting-Information-List-ExtIEs',
        u'Counting-Result',
        u'CRC-Size',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'CN-CS-DomainIdentifier',
        u'CN-CS-DomainIdentifier-ExtIEs',
        u'CN-PS-DomainIdentifier',
        u'CN-PS-DomainIdentifier-ExtIEs',
        u'CNDomainType',
        u'CQI-DTX-Timer',
        u'CQI-Cycle-Switch-Timer',
        u'ControlGAP',
        u'CQI-Feedback-Cycle',
        u'CQI-Feedback-Cycle2',
        u'CQI-Power-Offset',
        u'CQI-RepetitionFactor',
        u'C-RNTI',
        u'CodeRate',
        u'CodeRate-short',
        u'CPC-InformationLCR',
        u'CPC-InformationLCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-InformationLCR',
        u'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR',
        u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs',
        u'Controlled-Object-Scope',
        u'Controlled-Object-Scope-ExtIEs',
        u'DATA-ID',
        u'DBDS-CorrectionsReq',
        u'DBDS-CorrectionsReq-ExtIEs',
        u'DBDS-Corrections',
        u'DBDS-CorrectionsItem-ExtIEs',
        u'DBDS-Info',
        u'DBDS-InfoItem-ExtIEs',
        u'DBDS-SignalInfoList',
        u'DBDS-SignalInfo',
        u'DBDS-SignalInfoItem-ExtIEs',
        u'DBDS-InfoList',
        u'DCH-ENH-Information',
        u'DCH-ENH-Information-ExtIEs',
        u'DCH-ENH-Information-to-Modify',
        u'DCH-ENH-Information-to-Modify-ExtIEs',
        u'DL-FET-Mode',
        u'DCH-ENH-Concat',
        u'DCH-ENH-Information-Reconf',
        u'DCH-ENH-Information-Reconf-ExtIEs',
        u'DCH-ENH-Information-Removal',
        u'DCH-FDD-Information',
        u'DCH-FDD-InformationItem',
        u'DCH-FDD-InformationItem-ExtIEs',
        u'DCH-MeasurementOccasion-Information',
        u'DchMeasurementOccasionInformation-Item',
        u'DCH-MeasurementOccasion-Information-ExtIEs',
        u'Measurement-Occasion-Pattern-Sequence-parameters',
        u'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs',
        u'DCH-MeasurementType-Indicator',
        u'DCH-Specific-FDD-InformationList',
        u'DCH-Specific-FDD-Item',
        u'DCH-FDD-SpecificItem-ExtIEs',
        u'DCH-Indicator-For-E-DCH-HSDPA-Operation',
        u'DCH-ID',
        u'DCH-InformationResponse',
        u'DCH-InformationResponseItem',
        u'DCH-InformationResponseItem-ExtIEs',
        u'DCH-TDD-Information',
        u'DCH-TDD-InformationItem',
        u'DCH-TDD-InformationItem-ExtIEs',
        u'DCH-Specific-TDD-InformationList',
        u'DCH-Specific-TDD-Item',
        u'DCH-Specific-TDD-Item-ExtIEs',
        u'DecimationFactor',
        u'DedicatedMeasurementType',
        u'DedicatedMeasurementValue',
        u'DedicatedMeasurementValueInformation',
        u'DedicatedMeasurementAvailable',
        u'DedicatedMeasurementAvailableItem-ExtIEs',
        u'DedicatedMeasurementnotAvailable',
        u'DelayedActivation',
        u'DelayedActivationUpdate',
        u'Deactivate-Info',
        u'Deactivate-Info-ExtIEs',
        u'DeltaSIR',
        u'DGANSSCorrections',
        u'DGANSSCorrections-ExtIEs',
        u'DGANSS-Corrections-Req',
        u'DGANSS-Corrections-Req-ExtIEs',
        u'DGANSS-InformationItem-ExtIEs',
        u'DGANSS-SignalInformationItem-ExtIEs',
        u'DGANSSThreshold',
        u'DGNSS-ValidityPeriod',
        u'DGNSS-ValidityPeriod-ExtIEs',
        u'DGPSCorrections',
        u'DGPSCorrections-ExtIEs',
        u'DGPSThreshold',
        u'DGPSThreshold-ExtIEs',
        u'DiscardTimer',
        u'DiversityControlField',
        u'DiversityMode',
        u'DL-TBS',
        u'DL-TBS-ExtIEs',
        u'DL-TBS-Value',
        u'DL-DPCH-SlotFormat',
        u'DL-DPCH-TimingAdjustment',
        u'DL-Power',
        u'DL-PowerBalancing-Information',
        u'DL-PowerBalancing-Information-ExtIEs',
        u'DL-ReferencePowerInformationList',
        u'DL-ReferencePowerInformationItem',
        u'DL-ReferencePowerInformationItem-ExtIEs',
        u'DL-PowerBalancing-ActivationIndicator',
        u'DL-PowerBalancing-UpdatedIndicator',
        u'DL-ReferencePowerInformation',
        u'DL-ReferencePowerInformation-ExtIEs',
        u'D-RNTI',
        u'D-RNTI-ReleaseIndication',
        u'DL-ScramblingCode',
        u'DL-FrameType',
        u'DL-Timeslot-Information',
        u'DL-Timeslot-InformationItem',
        u'DL-Timeslot-InformationItem-ExtIEs',
        u'DL-TimeslotLCR-Information',
        u'DL-TimeslotLCR-InformationItem',
        u'DL-TimeslotLCR-InformationItem-ExtIEs',
        u'DL-Timeslot-Information768',
        u'DL-Timeslot-InformationItem768',
        u'DL-Timeslot-InformationItem768-ExtIEs',
        u'DL-TimeSlot-ISCP-Info',
        u'DL-TimeSlot-ISCP-InfoItem',
        u'DL-TimeSlot-ISCP-InfoItem-ExtIEs',
        u'DL-TimeSlot-ISCP-LCR-Information',
        u'DL-TimeSlot-ISCP-LCR-InfoItem',
        u'DL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        u'DL-TimeslotISCP',
        u'Downlink-Compressed-Mode-Method',
        u'Downlink-TPC-enhancements-Information',
        u'Downlink-TPC-enhancements-Information-ExtIEs',
        u'Downlink-TPC-enhancements-Reconf',
        u'Downlink-TPC-enhancements-Reconf-ExtIEs',
        u'Downlink-TPC-enhancements-Information-Removal',
        u'DPC-Mode',
        u'DPC-Mode-Change-SupportIndicator',
        u'DPCH-ID',
        u'DPCH-ID768',
        u'DPCHConstantValue',
        u'DRACControl',
        u'DRXCycleLengthCoefficient',
        u'DRX-Information',
        u'DRX-Information-ExtIEs',
        u'DRX-Information-to-Modify-LCR',
        u'DRX-Information-to-Modify-Items-LCR',
        u'DRX-Information-to-Modify-Items-LCR-ExtIEs',
        u'DRX-Information-to-Modify',
        u'DRX-Information-to-Modify-Items',
        u'DRX-Information-to-Modify-Items-ExtIEs',
        u'DSCH-RNTI',
        u'DSCH-FlowControlInformation',
        u'DSCH-FlowControlItem',
        u'DSCH-FlowControlItem-ExtIEs',
        u'DSCH-ID',
        u'DSCH-InitialWindowSize',
        u'DSCH-TDD-Information',
        u'DSCH-TDD-InformationItem',
        u'DSCH-TDD-InformationItem-ExtIEs',
        u'DsField',
        u'DTX-Cycle-2ms-Items',
        u'DTX-Cycle-2ms-Items-ExtIEs',
        u'DTX-Cycle-2ms-to-Modify-Items',
        u'DTX-Cycle-2ms-to-Modify-Items-ExtIEs',
        u'DTX-Cycle-10ms-Items',
        u'DTX-Cycle-10ms-Items-ExtIEs',
        u'DTX-Cycle-10ms-to-Modify-Items',
        u'DTX-Cycle-10ms-to-Modify-Items-ExtIEs',
        u'DTX-Information',
        u'DTX-Information-ExtIEs',
        u'DTX-Information2',
        u'DTX-Information2-ExtIEs',
        u'DTX-Information-to-Modify',
        u'DTX-Information-to-Modify-Items',
        u'DTX-Information-to-Modify-Items-ExtIEs',
        u'Dual-Cell-EDCH-Enhancements-Information',
        u'Dual-Cell-EDCH-Enhancements-Information-ExtIEs',
        u'EARFCN',
        u'EARFCN-Extended',
        u'EARFCN-Information',
        u'Extension-EARFCN-Information',
        u'Extension-EARFCN-InformationIE',
        u'EARFCN-FDD',
        u'EARFCN-FDD-Extended',
        u'E-AGCH-DRX-Information-ResponseLCR',
        u'E-AGCH-DRX-Parameters-Response',
        u'E-AGCH-DRX-Parameters-Response-ExtIEs',
        u'E-AGCH-DRX-Information-LCR',
        u'E-AGCH-DRX-Parameters',
        u'E-AGCH-DRX-Parameters-ExtIEs',
        u'E-AGCH-Table-Choice',
        u'E-AGCH-UE-Inactivity-Monitor-Threshold',
        u'ECGI',
        u'ECGI-ExtIEs',
        u'EDCH-Additional-RL-Specific-Information-Response-List',
        u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs',
        u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-List',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs-ExtIEs',
        u'EDCH-DDI-Value',
        u'E-DCH-Decoupling-Indication',
        u'EDCH-FDD-DL-ControlChannelInformation',
        u'EDCH-FDD-DL-ControlChannelInformation-ExtIEs',
        u'E-RGCH-E-HICH-ChannelisationCodeValidityIndicator',
        u'EDCH-FDD-Information',
        u'EDCH-FDD-Information-ExtIEs',
        u'EDCH-FDD-InformationResponse',
        u'EDCH-FDD-InformationResponse-ExtIEs',
        u'EDCH-MACdFlow-Specific-InformationResponse',
        u'EDCH-MACdFlow-Specific-InformationResponseItem',
        u'EDCH-MACdFlow-Specific-InformationResponseItem-ExtIEs',
        u'EDCH-FDD-Information-To-Modify',
        u'EDCH-FDD-Information-To-Modify-ExtIEs',
        u'E-DCH-FDD-Update-Information',
        u'E-DCH-FDD-Update-Information-ExtIEs',
        u'E-DCH-MACdFlow-Specific-UpdateInformation',
        u'E-DCH-MACdFlow-Specific-UpdateInformation-Item',
        u'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs',
        u'E-DCH-DL-Control-Channel-Change-Information',
        u'E-DCH-DL-Control-Channel-Change-Information-Item',
        u'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs',
        u'E-DCH-DL-Control-Channel-Grant-Information',
        u'E-DCH-DL-Control-Channel-Grant-Information-Item',
        u'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs',
        u'E-DCH-Grant-Type-Information',
        u'E-DCH-HARQ-PO-FDD',
        u'E-DCH-LogicalChannelInformation',
        u'E-DCH-LogicalChannelInformationItem',
        u'E-DCH-LogicalChannelInformationItem-ExtIEs',
        u'E-DCH-Maximum-Bitrate',
        u'E-DCH-PowerOffset-for-SchedulingInfo',
        u'E-DCH-Processing-Overload-Level',
        u'E-DCH-Reference-Power-Offset',
        u'E-DCH-MACdPDU-SizeList',
        u'E-DCH-MACdPDU-SizeListItem',
        u'E-DCH-MACdPDU-SizeListItem-ExtIEs',
        u'E-DCH-MACdPDUSizeFormat',
        u'E-DCH-LogicalChannelToModify',
        u'E-DCH-LogicalChannelToModifyItem',
        u'E-DCH-LogicalChannelToModifyItem-ExtIEs',
        u'E-DCH-MACdPDU-SizeToModifyList',
        u'E-DCH-LogicalChannelToDelete',
        u'E-DCH-LogicalChannelToDeleteItem',
        u'E-DCH-LogicalChannelToDeleteItem-ExtIEs',
        u'EDCH-MACdFlow-ID',
        u'EDCH-MACdFlow-ID-LCR',
        u'EDCH-MACdFlows-Information',
        u'E-DCH-MACdFlow-Multiplexing-List',
        u'EDCH-MACdFlow-Information-ExtIEs',
        u'EDCH-MACdFlow-Specific-InfoList',
        u'EDCH-MACdFlow-Specific-InfoItem',
        u'EDCH-MACdFlow-Specific-InfoItem-ExtIEs',
        u'EDCH-MACdFlow-Specific-InfoToModifyList',
        u'EDCH-MACdFlow-Specific-InfoToModifyItem',
        u'EDCH-MACdFlow-Specific-InfoToModifyItem-ExtIEs',
        u'EDCH-MACdFlows-To-Delete',
        u'EDCH-MACdFlows-To-Delete-Item',
        u'EDCH-MACdFlows-To-Delete-Item-ExtIEs',
        u'EDCH-Reference-E-TFCI-Information',
        u'EDCH-Reference-E-TFCI-Information-Item',
        u'EDCH-Reference-E-TFCI-Information-Item-ExtIEs',
        u'EDCH-Reference-E-TFCI-PO',
        u'EDCH-RL-Indication',
        u'E-DCH-Non-Scheduled-Transmission-Grant-Items',
        u'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs',
        u'E-DCH-TFCI-Table-Index',
        u'E-DCH-Serving-cell-change-informationResponse',
        u'E-DCH-serving-cell-change-informationResponse-ExtIEs',
        u'E-DCH-serving-cell-change-choice',
        u'E-DCH-serving-cell-change-successful',
        u'E-DCH-serving-cell-change-successful-ExtIEs',
        u'E-DCH-RL-InformationList-Rsp',
        u'E-DCH-RL-InformationList-Rsp-Item',
        u'E-DCH-RL-InformationList-Rsp-Item-ExtIEs',
        u'E-DCH-serving-cell-change-unsuccessful',
        u'E-DCH-serving-cell-change-unsuccessful-ExtIEs',
        u'E-DCH-TTI-Length',
        u'E-DCH-TTI-Length-to-Modify',
        u'EDPCH-Information-FDD',
        u'EDPCH-Information-FDD-ExtIEs',
        u'EDPCH-Information-RLReconfPrepare-FDD',
        u'EDPCH-Information-RLReconfPrepare-FDD-ExtIEs',
        u'EDPCH-Information-RLReconfRequest-FDD',
        u'EDPCH-Information-RLReconfRequest-FDD-ExtIEs',
        u'E-DPCCH-PO',
        u'Extended-E-DPCCH-PO',
        u'E-DPDCH-PowerInterpolation',
        u'E-Primary-Secondary-Grant-Selector',
        u'EHICH-SignatureSequence',
        u'E-RGCH-Release-Indicator',
        u'ERGCH-SignatureSequence',
        u'E-Serving-Grant-Value',
        u'E-RGCH-2-IndexStepThreshold',
        u'E-RGCH-3-IndexStepThreshold',
        u'EDCH-Serving-RL',
        u'EDCH-Serving-RL-in-this-DRNS',
        u'EDCH-Serving-RL-in-this-DRNS-ExtIEs',
        u'Enhanced-FACH-Information-ResponseFDD',
        u'Enhanced-FACH-Information-ResponseFDD-ExtIEs',
        u'Enhanced-FACH-Information-ResponseLCR',
        u'Enhanced-FACH-Information-ResponseLCR-ExtIEs',
        u'Enhanced-FACH-Support-Indicator',
        u'EnhancedHSServingCC-Abort',
        u'Enhanced-PCH-Capability',
        u'E-RNTI',
        u'E-ROCH-PowerOffset',
        u'E-TFCI',
        u'E-TFCI-BetaEC-Boost',
        u'E-TFCI-Boost-Information',
        u'E-TFCI-Boost-Information-ExtIEs',
        u'E-TFCS-Information',
        u'E-TFCS-Information-ExtIEs',
        u'E-DCH-Minimum-Set-E-TFCIValidityIndicator',
        u'E-TTI',
        u'E-AGCH-PowerOffset',
        u'E-RGCH-PowerOffset',
        u'E-HICH-PowerOffset',
        u'Enhanced-PrimaryCPICH-EcNo',
        u'EventA',
        u'EventA-ExtIEs',
        u'EventB',
        u'EventB-ExtIEs',
        u'EventC',
        u'EventC-ExtIEs',
        u'EventD',
        u'EventD-ExtIEs',
        u'EventE',
        u'EventE-ExtIEs',
        u'EventF',
        u'EventF-ExtIEs',
        u'EventH',
        u'EventH-ExtIEs',
        u'Event1F-Parameters',
        u'Event1I-Parameters',
        u'ExtendedGSMCellIndividualOffset',
        u'E-DCH-Information',
        u'E-DCH-Information-ExtIEs',
        u'E-PUCH-Information',
        u'E-PUCH-Information-ExtIEs',
        u'E-TFCS-Information-TDD',
        u'E-TFCS-Information-TDD-ExtIEs',
        u'E-DCH-QPSK-RefBetaInfo',
        u'E-DCH-sixteenQAM-RefBetaInfo',
        u'E-DCH-RefBeta-Item',
        u'E-DCH-MACdFlows-Information-TDD',
        u'E-DCH-MACdFlow-InfoTDDItem',
        u'E-DCH-MACdFlow-InfoTDDItem-ExtIEs',
        u'E-DCH-MACdFlow-Retransmission-Timer-LCR',
        u'E-DCH-HARQ-PO-TDD',
        u'E-DCH-Grant-TypeTDD',
        u'E-DCH-TimeslotResource',
        u'E-DCH-PowerResource',
        u'TddE-PUCH-Offset',
        u'E-DCH-TDD-Information',
        u'E-DCH-TDD-Information-ExtIEs',
        u'E-DCH-TDD-Maximum-Bitrate',
        u'E-DCH-Information-Reconfig',
        u'E-DCH-Information-Reconfig-ExtIEs',
        u'E-DCH-TDD-Information-to-Modify',
        u'E-DCH-TDD-Information-to-Modify-ExtIEs',
        u'E-DCH-TDD-Information-to-Modify-List',
        u'E-DCH-MACdFlow-ModifyTDDItem',
        u'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs',
        u'E-DCH-Information-Response',
        u'E-DCH-Information-Response-ExtIEs',
        u'E-DCH-TDD-MACdFlow-Specific-InformationResp',
        u'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item',
        u'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs',
        u'E-AGCH-Specific-InformationRespListTDD',
        u'E-AGCH-Specific-InformationResp-ItemTDD',
        u'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs',
        u'E-HICH-InformationResp',
        u'E-HICH-InformationResp-ExtIEs',
        u'E-HICH-TimeOffset',
        u'E-DCH-Non-Scheduled-Grant-Info',
        u'E-DCH-Non-Scheduled-Grant-Info-ExtIEs',
        u'E-DCH-768-Information',
        u'E-DCH-768-Information-ExtIEs',
        u'E-DCH-TDD-Information768',
        u'E-DCH-TDD-Information768-ExtIEs',
        u'E-DCH-TDD-Maximum-Bitrate768',
        u'E-DCH-768-Information-Reconfig',
        u'E-DCH-768-Information-Reconfig-ExtIEs',
        u'E-DCH-768-Information-Response',
        u'E-DCH-768-Information-Response-ExtIEs',
        u'E-AGCH-Specific-InformationRespList768TDD',
        u'E-AGCH-Specific-InformationResp-Item768TDD',
        u'E-AGCH-Specific-InformationResp-Item768TDD-ExtIEs',
        u'E-HICH-InformationResp768',
        u'E-HICH-InformationResp768-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info768',
        u'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs',
        u'E-DCH-LCR-Information',
        u'E-DCH-Information-LCR-ExtIEs',
        u'E-PUCH-LCR-Information',
        u'E-PUCH-Information-LCR-ExtIEs',
        u'E-PUCH-PRXdesBase',
        u'E-DCH-LCR-TDD-Information',
        u'E-DCH-LCR-TDD-Information-ExtIEs',
        u'E-DCH-Physical-Layer-Category-LCR',
        u'Execution-Type',
        u'Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'Extension-CommonMeasurementValue',
        u'Extension-CommonMeasurementValueIE',
        u'Extension-DedicatedMeasurementValue',
        u'Extension-DedicatedMeasurementValueIE',
        u'E-DCH-LCR-Information-Reconfig',
        u'E-DCH-Information-Reconfig-LCR-ExtIEs',
        u'E-DCH-LCR-Information-Response',
        u'E-DCH-Information-Response-LCR-ExtIEs',
        u'E-AGCH-Specific-InformationRespList-LCR-TDD',
        u'E-AGCH-Specific-InformationResp-Item-LCR-TDD',
        u'E-AGCH-Specific-InformationResp-ItemTDD-LCR-ExtIEs',
        u'E-HICH-Specific-InformationResp-LCR',
        u'E-HICH-Specific-InformationResp-LCR-ExtIEs',
        u'E-HICH-Scheduled-InformationRespList-LCR-TDD',
        u'E-HICH-Scheduled-InformationResp-Item-LCR-TDD',
        u'E-HICH-Scheduled-InformationResp-LCR-ExtIEs',
        u'E-HICH-EI',
        u'E-HICH-InformationResp-LCR',
        u'E-HICH-InformationResp-LCR-ExtIEs',
        u'E-HICH-TimeOffset-LCR',
        u'E-DCH-SubframeNumber-LCR',
        u'E-DCH-TimeslotResource-LCR',
        u'E-DCH-Non-Scheduled-Grant-Info-LCR',
        u'E-DCH-Non-Scheduled-Grant-Info-LCR-ExtIEs',
        u'Enabling-Delay',
        u'Ext-Reference-E-TFCI-PO',
        u'ExtendedPropagationDelay',
        u'Extended-RNC-ID',
        u'Extended-RNTI',
        u'Extended-Round-Trip-Time-Value',
        u'Extended-S-RNTI-Group',
        u'ExtendedAffectedUEInformationForMBMS',
        u'Ext-Max-Bits-MACe-PDU-non-scheduled',
        u'E-DCH-Semi-PersistentScheduling-Information-LCR',
        u'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        u'E-DCH-SPS-Indicator',
        u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        u'E-DCH-SPS-HICH-Information',
        u'E-DCH-SPS-HICH-Information-ExtIEs',
        u'E-HICH-Configuration',
        u'E-HICH-InformationResp-ExplicitConfiguration-LCR',
        u'E-HICH-InformationResp-ExplicitConfiguration-LCR-ExtIEs',
        u'FACH-FlowControlInformation',
        u'FACH-FlowControlInformationItem',
        u'FACH-FlowControlInformationItem-ExtIEs',
        u'FACH-InitialWindowSize',
        u'FACH-InformationList',
        u'FACH-InformationItem',
        u'FACH-InformationItem-ExtIEs',
        u'Fast-Reconfiguration-Mode',
        u'Fast-Reconfiguration-Permission',
        u'Fast-TTI-switching-Mode-synchronized',
        u'Fast-TTI-switching-Mode-unsynchronized',
        u'Fast-TTI-switching-Mode-Supported',
        u'FDD-DCHs-to-Modify',
        u'FDD-DCHs-to-ModifyItem',
        u'FDD-DCHs-to-ModifyItem-ExtIEs',
        u'FDD-DCHs-to-ModifySpecificInformationList',
        u'FDD-DCHs-to-ModifySpecificItem',
        u'FDD-DCHs-to-ModifySpecificItem-ExtIEs',
        u'FDD-DL-ChannelisationCodeNumber',
        u'FDD-DL-CodeInformation',
        u'FDD-DL-CodeInformationItem',
        u'FDD-DL-CodeInformationItem-ExtIEs',
        u'FDD-TPC-DownlinkStepSize',
        u'SchedulingPriorityIndicator',
        u'F-DPCH-Info',
        u'F-DPCH-Info-ExtIEs',
        u'F-DPCH-Info-To-Modify',
        u'F-DPCH-Info-To-Modify-ExtIEs',
        u'F-DPCH-SlotFormat',
        u'F-DPCH-SlotFormatSupportRequest',
        u'FirstRLS-Indicator',
        u'FNReportingIndicator',
        u'FPACH-Information',
        u'FTPICH-Information',
        u'FTPICH-Information-ExtIEs',
        u'FTPICH-SlotFormat',
        u'FTPICH-Offset',
        u'FTPICH-Information-Removal',
        u'FTPICH-Information-To-Modify',
        u'FTPICH-Information-To-Modify-ExtIEs',
        u'FTPICH-Information-Reconf',
        u'FTPICH-Information-Reconf-ExtIEs',
        u'FTPICH-Reconfiguration-Information',
        u'FTPICH-Reconfiguration-Information-ExtIEs',
        u'FTPICH-Information-Response',
        u'FTPICH-Information-Response-ExtIEs',
        u'FrameHandlingPriority',
        u'FrameOffset',
        u'FrequencyBandIndicator',
        u'GapLength',
        u'GapDuration',
        u'GA-Cell',
        u'GA-Cell-ExtIEs',
        u'GA-CellAdditionalShapes',
        u'GA-AltitudeAndDirection',
        u'GA-EllipsoidArc',
        u'GA-EllipsoidArc-ExtIEs',
        u'Gainfactors-10ms-mode',
        u'SignalledGainFactors10ms-ExtIEs',
        u'GANSS-AddClockModels',
        u'Extension-GANSS-AddClockModels',
        u'Extension-GANSS-AddClockModels-IE',
        u'GANSS-AddIonoModelReq',
        u'GANSS-AddNavigationModelsReq',
        u'GANSS-AddOrbitModels',
        u'Extension-GANSS-AddOrbitModels',
        u'Extension-GANSS-AddOrbitModels-IE',
        u'GANSS-AddUTCModelsReq',
        u'GANSS-Additional-Ionospheric-Model',
        u'GANSS-Additional-Ionospheric-Model-ExtIEs',
        u'GANSS-Additional-Navigation-Models',
        u'GANSS-Additional-Navigation-Models-ExtIEs',
        u'GANSS-Additional-Time-Models',
        u'GANSS-Additional-UTC-Models',
        u'Extension-GANSS-Additional-UTC-Models',
        u'Extension-GANSS-Additional-UTC-Models-IE',
        u'GANSS-Almanac',
        u'GANSS-KeplerianParametersAlm-ExtIEs',
        u'Extension-GANSS-AlmanacModel',
        u'Extension-GANSS-AlmanacModel-IE',
        u'GANSS-alm-keplerianNAVAlmanac',
        u'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        u'GANSS-alm-KEPLERIANBDSALMANAC',
        u'GANSS-alm-KEPLERIANBDSALMANAC-ExtIEs',
        u'GANSS-alm-keplerianReducedAlmanac',
        u'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        u'GANSS-alm-keplerianMidiAlmanac',
        u'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        u'GANSS-alm-keplerianGLONASS',
        u'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        u'GANSS-alm-ecefSBASAlmanac',
        u'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        u'GANSS-Almanac-ExtIEs',
        u'GANSS-Auxiliary-Information',
        u'GANSS-AuxInfoGANSS-ID1',
        u'GANSS-AuxInfoGANSS-ID1-element-ExtIEs',
        u'GANSS-AuxInfoGANSS-ID3',
        u'GANSS-AuxInfoGANSS-ID3-element-ExtIEs',
        u'GANSS-AuxInfoReq',
        u'GANSS-BDSclockModel',
        u'GANSS-BDSclockModelItem-ExtIEs',
        u'GANSS-Clock-Model',
        u'GANSS-ClockModelItem-ExtIEs',
        u'GANSS-CNAVclockModel',
        u'GANSS-CNAVclockModel-ExtIEs',
        u'GANSS-Common-Data',
        u'GANSS-Common-Data-ExtIEs',
        u'GANSS-CommonDataInfoReq',
        u'GANSS-CommonDataInfoReq-ExtIEs',
        u'GANSS-Data-Bit-Assistance',
        u'GANSS-Data-Bit-Assistance-ExtIEs',
        u'GANSS-DataBitAssistanceList',
        u'GANSS-DataBitAssistanceItem',
        u'GANSS-DataBitAssistanceItem-ExtIEs',
        u'GANSS-DataBitAssistanceSgnList',
        u'GANSS-DataBitAssistanceSgnItem',
        u'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ReqItem',
        u'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ReqList',
        u'GANSS-Data-Bit-Assistance-ReqList-ExtIEs',
        u'GANSS-Delta-T',
        u'GANSS-DeltaUT1',
        u'GANSS-DeltaUT1-ExtIEs',
        u'GANSS-Earth-Orientation-Parameters',
        u'GANSS-Earth-Orientation-Parameters-ExtIEs',
        u'GANSS-EarthOrientParaReq',
        u'GANSS-GenericDataInfoReqList',
        u'GANSS-GenericDataInfoReqItem',
        u'GANSS-GenericDataInfoReqItem-ExtIEs',
        u'GANSS-Generic-Data',
        u'GANSS-Generic-DataItem',
        u'GANSS-Generic-DataItem-ExtIEs',
        u'GANSS-GLONASSclockModel',
        u'GANSS-GLONASSclockModel-ExtIEs',
        u'GANSS-ID',
        u'GANSS-Information',
        u'GANSS-Information-ExtIEs',
        u'GANSS-Ionospheric-Model',
        u'GANSS-Ionospheric-Model-ExtIEs',
        u'GANSS-IonosphereRegionalStormFlags',
        u'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        u'GANSS-NAVclockModel',
        u'GANSS-NAVclockModel-ExtIEs',
        u'GANSS-Navigation-Model-And-Time-Recovery',
        u'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs',
        u'GANSS-NavModel-BDSKeplerianSet',
        u'GANSS-NavModel-BDSKeplerianSet-ExtIEs',
        u'GANSS-NavModel-CNAVKeplerianSet',
        u'GANSS-NavModel-CNAVKeplerianSet-ExtIEs',
        u'GANSS-NavModel-GLONASSecef',
        u'GANSS-NavModel-GLONASSecef-ExtIEs',
        u'GANSS-NavModel-NAVKeplerianSet',
        u'GANSS-NavModel-NAVKeplerianSet-ExtIEs',
        u'GANSS-NavModel-SBASecef',
        u'GANSS-NavModel-SBASecef-ExtIEs',
        u'GANSS-Orbit-Model',
        u'GANSS-KeplerianParametersOrb-ExtIEs',
        u'GANSS-Real-Time-Integrity',
        u'GANSS-RealTimeInformationItem-ExtIEs',
        u'GANSS-RX-Pos',
        u'GANSS-RX-Pos-ExtIEs',
        u'GANSS-SatelliteInformationKP',
        u'GANSS-SatelliteInformationKPItem-ExtIEs',
        u'Ganss-Sat-Info-AddNavList',
        u'Ganss-Sat-Info-AddNavList-ExtIEs',
        u'GANSS-SAT-Info-Almanac-BDSkpList',
        u'GANSS-SAT-Info-Almanac-BDS',
        u'GANSS-SAT-Info-Almanac-BDS-ExtIEs',
        u'GANSS-SAT-Info-Almanac-GLOkpList',
        u'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-MIDIkpList',
        u'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-NAVkpList',
        u'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-REDkpList',
        u'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-SBASecefList',
        u'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        u'GANSS-Sat-Info-Nav',
        u'GANSS-Sat-Info-Nav-ExtIEs',
        u'GANSS-SBAS-ID',
        u'GANSS-SBASclockModel',
        u'GANSS-SBASclockModel-ExtIEs',
        u'GANSS-Signal-ID',
        u'GANSS-StatusHealth',
        u'GANSS-Time-ID',
        u'GANSS-Time-Model',
        u'GANSS-Time-Model-ExtIEs',
        u'GANSS-Transmission-Time',
        u'GANSS-Transmission-Time-ExtIEs',
        u'GANSS-UTC-Model',
        u'GANSS-UTC-Model-ExtIEs',
        u'GANSS-UTCmodelSet1',
        u'GANSS-UTCmodelSet1-ExtIEs',
        u'GANSS-UTCmodelSet2',
        u'GANSS-UTCmodelSet2-ExtIEs',
        u'GANSS-UTCmodelSet3',
        u'GANSS-UTCmodelSet3-ExtIEs',
        u'GANSS-UTCmodelSet4',
        u'GANSS-UTCmodelSet4-ExtIEs',
        u'GA-PointWithAltitude',
        u'GA-PointWithAltitude-ExtIEs',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        u'GA-PointWithUnCertaintyEllipse',
        u'GA-PointWithUnCertaintyEllipse-ExtIEs',
        u'GA-UncertaintyEllipse',
        u'GA-PointWithUnCertainty',
        u'GA-PointWithUnCertainty-ExtIEs',
        u'GA-AccessPointPosition',
        u'GA-AccessPoint-ExtIEs',
        u'GeographicalCoordinate',
        u'GeographicalCoordinate-ExtIEs',
        u'GERAN-Cell-Capability',
        u'GERAN-Classmark',
        u'GERAN-SI-Type',
        u'GERAN-SystemInfo',
        u'GERAN-SystemInfo-ExtIEs',
        u'GenericTrafficCategory',
        u'GPS-Almanac',
        u'Satellite-Almanac-Information-ExtIEs',
        u'GPS-Almanac-ExtIEs',
        u'Satellite-Almanac-Information-ExtItem',
        u'Satellite-Almanac-Information-ExtItemIEs',
        u'GPSInformation',
        u'GPSInformation-ExtIEs',
        u'GPS-Ionospheric-Model',
        u'GPS-Ionospheric-Model-ExtIEs',
        u'GPS-NavigationModel-and-TimeRecovery',
        u'GPS-NavigationModel-and-TimeRecoveryItem-ExtIEs',
        u'GPS-RealTime-Integrity',
        u'GPS-RX-POS',
        u'GPS-RX-POS-ExtIEs',
        u'GPS-Status-Health',
        u'GPSTOW',
        u'GPS-UTC-Model',
        u'GPS-UTC-Model-ExtIEs',
        u'Guaranteed-Rate-Information',
        u'Guaranteed-Rate-Information-ExtIEs',
        u'Guaranteed-Rate',
        u'HARQ-Info-for-E-DCH',
        u'HARQ-MemoryPartitioning',
        u'HARQ-MemoryPartitioning-Implicit',
        u'HARQ-MemoryPartitioning-Implicit-ExtIEs',
        u'HARQ-MemoryPartitioning-Explicit',
        u'HARQ-MemoryPartitioning-Explicit-ExtIEs',
        u'HARQ-MemoryPartitioningList',
        u'HARQ-MemoryPartitioningInfoExtForMIMO',
        u'HARQ-MemoryPartitioningItem',
        u'HARQ-MemoryPartitioningItem-ExtIEs',
        u'HARQ-Preamble-Mode',
        u'HARQ-Process-Allocation-2ms-EDCH',
        u'HARQ-Preamble-Mode-Activation-Indicator',
        u'HCS-Prio',
        u'HS-DSCH-Cell-List',
        u'HS-DSCH-Cell',
        u'HS-DSCH-Cell-ExtIEs',
        u'HSDSCH-Configured-Indicator',
        u'HSDSCH-FDD-Information',
        u'HSDSCH-FDD-Information-ExtIEs',
        u'HSDSCH-FDD-Information-Response',
        u'HSDSCH-FDD-Information-Response-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information',
        u'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-Response',
        u'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Information-To-Modify',
        u'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised',
        u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Update-Information',
        u'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response',
        u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs',
        u'HS-DSCH-Secondary-Serving-cell-change-choice',
        u'HS-Secondary-Serving-cell-change-successful',
        u'HS-Secondary-Serving-cell-change-successful-ExtIEs',
        u'HS-Secondary-Serving-cell-change-unsuccessful',
        u'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Remove',
        u'HSDSCH-Information-to-Modify',
        u'HSDSCH-Information-to-Modify-ExtIEs',
        u'HSDSCH-Information-to-Modify-Unsynchronised',
        u'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs',
        u'HSDSCH-MACdFlow-ID',
        u'HSDSCH-MACdFlow-Specific-InfoList',
        u'HSDSCH-MACdPDUSizeFormat',
        u'HSDSCH-MACdFlow-Specific-InfoItem',
        u'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoList-Response',
        u'HSDSCH-MACdFlow-Specific-InfoItem-Response',
        u'HSDSCH-MACdFlow-Specific-InfoItem-Response-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoList-to-Modify',
        u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify',
        u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        u'HSDSCH-MACdFlows-Information',
        u'HSDSCH-MACdFlows-Information-ExtIEs',
        u'HSDSCH-MACdFlows-to-Delete',
        u'HSDSCH-MACdFlows-to-Delete-Item',
        u'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs',
        u'HSDSCH-Initial-Capacity-Allocation',
        u'HSDSCH-Initial-Capacity-AllocationItem',
        u'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs',
        u'HSDSCH-InitialWindowSize',
        u'HSDSCH-PreconfigurationInfo',
        u'HSDSCH-PreconfigurationInfo-ExtIEs',
        u'Additional-EDCH-Preconfiguration-Information',
        u'Additional-EDCH-Preconfiguration-Information-ItemIEs',
        u'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs',
        u'HSDSCH-PreconfigurationSetup',
        u'HSDSCHPreconfigurationSetup-ExtIEs',
        u'HS-SCCH-PreconfiguredCodes',
        u'HS-SCCH-PreconfiguredCodesItem',
        u'HS-SCCH-PreconfiguredCodesItem-ExtIEs',
        u'HS-SCCH-CodeNumber',
        u'HSDSCH-RNTI',
        u'HS-DSCH-serving-cell-change-information',
        u'HS-DSCH-serving-cell-change-information-ExtIEs',
        u'HS-DSCH-serving-cell-change-informationResponse',
        u'HS-DSCH-serving-cell-change-informationResponse-ExtIEs',
        u'HS-DSCH-serving-cell-change-choice',
        u'HSDSCH-TBSizeTableIndicator',
        u'HS-serving-cell-change-successful',
        u'HS-serving-cell-change-successful-ExtIEs',
        u'HS-serving-cell-change-unsuccessful',
        u'HS-serving-cell-change-unsuccessful-ExtIEs',
        u'HSPDSCH-First-Code-Index',
        u'HSPDSCH-Second-Code-Index',
        u'HSPDSCH-Second-Code-Support',
        u'HSDSCH-TDD-Information',
        u'HSDSCH-TDD-Information-ExtIEs',
        u'HSDSCH-TDD-Information-Response',
        u'HSDSCH-TDD-Information-Response-ExtIEs',
        u'Multicarrier-Number',
        u'HSPDSCH-TDD-Specific-InfoList-Response',
        u'HSPDSCH-TDD-Specific-InfoItem-Response',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoList-Response-LCR',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoList-Response768',
        u'HSPDSCH-TDD-Specific-InfoItem-Response768',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-768-ExtIEs',
        u'HS-SCCH-DRX-Information-LCR',
        u'HS-SCCH-DRX-Information-LCR-ExtIEs',
        u'HS-SCCH-DRX-Information-ResponseLCR',
        u'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs',
        u'HSSCCH-FDD-Specific-InfoList-Response',
        u'HSSCCH-FDD-Specific-InfoItem-Response',
        u'HSSCCH-FDD-Specific-InfoItem-Response-ExtIEs',
        u'HSSCCH-PowerOffset',
        u'HSSCCH-TDD-Specific-InfoList-Response',
        u'HSSCCH-TDD-Specific-InfoItem-Response',
        u'HSSCCH-TDD-Specific-InfoItem-Response-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoList-Response-LCR',
        u'HSSCCH-TDD-Specific-InfoItem-Response-LCR',
        u'HSSCCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoList-Response768',
        u'HSSCCH-TDD-Specific-InfoItem-Response768',
        u'HSSCCH-TDD-Specific-InfoItem-Response768-ExtIEs',
        u'HSSICH-Info',
        u'HSSICH-Info-ExtIEs',
        u'HSSICH-InfoLCR',
        u'HSSICH-Info-LCR-ExtIEs',
        u'HSSICH-Info768',
        u'HSSICH-Info-768-ExtIEs',
        u'HS-SICH-Reception-Quality-Value',
        u'HS-SICH-Reception-Quality-Value-ExtIEs',
        u'HS-SICH-failed',
        u'HS-SICH-missed',
        u'HS-SICH-total',
        u'HS-SICH-Reception-Quality-Measurement-Value',
        u'HS-SICH-ID',
        u'HS-SICH-ID-Extension',
        u'HSSCCH-CodeChangeIndicator',
        u'HSSCCH-Code-Change-Grant',
        u'HS-PDSCH-Code-Change-Indicator',
        u'HS-PDSCH-Code-Change-Grant',
        u'HSDSCH-FDD-Update-Information',
        u'HSDSCH-FDD-Update-Information-ExtIEs',
        u'HSDSCH-TDD-Update-Information',
        u'HSDSCH-TDD-Update-Information-ExtIEs',
        u'MIMO-ReferenceSignal-InformationListLCR',
        u'HSSICH-ReferenceSignal-InformationLCR',
        u'HSSICH-ReferenceSignal-InformationLCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        u'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        u'HSDSCH-Physical-Layer-Category',
        u'Transport-Block-Size-List-LCR',
        u'Transport-Block-Size-Item-LCR',
        u'Transport-Block-Size-Item-LCR-ExtIEs',
        u'Transport-Block-Size-maping-Index-LCR',
        u'Transport-Block-Size-Index-LCR',
        u'TS0-HS-PDSCH-Indication-LCR',
        u'Repetition-Period-List-LCR',
        u'Repetition-Period-Item-LCR',
        u'Repetition-Period-Item-LCR-ExtIEs',
        u'RepetitionPeriodIndex',
        u'SPS-Reservation-Indicator',
        u'HS-DSCH-SPS-Operation-Indicator',
        u'LogicalChannellevel',
        u'PriorityQueuelevel',
        u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        u'HS-SICH-InformationList-for-HS-DSCH-SPS',
        u'HS-SICH-InformationItem-for-HS-DSCH-SPS',
        u'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs',
        u'HS-SICH-Mapping-Index',
        u'HS-SICH-Type',
        u'HS-SCCH-Associated-HS-SICH',
        u'Non-HS-SCCH-Associated-HS-SICH',
        u'Non-HS-SCCH-Aassociated-HS-SICH-ID',
        u'Initial-HS-PDSCH-SPS-Resource',
        u'Initial-HS-PDSCH-SPS-Resource-ExtIEs',
        u'HS-DSCH-TimeslotResourceLCR',
        u'ModulationSPS-LCR',
        u'Number-of-Processes-for-HS-DSCH-SPS',
        u'IMEI',
        u'IMEISV',
        u'IMSI',
        u'Implicit-Grant-Handling',
        u'Improved-Synchronized-Indicator',
        u'Inactivity-Threshold-for-UE-DRX-Cycle-LCR',
        u'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        u'Inactivity-Threshold-for-UE-DTX-Cycle2',
        u'Inactivity-Threshold-for-UE-DRX-Cycle',
        u'Inactivity-Threshold-for-UE-Grant-Monitoring',
        u'InformationAvailable',
        u'InformationAvailable-ExtIEs',
        u'InformationExchangeID',
        u'InformationNotAvailable',
        u'InformationReportCharacteristics',
        u'InformationReportPeriodicity',
        u'InformationThreshold',
        u'InformationType',
        u'InformationType-ExtIEs',
        u'Initial-E-DCH-SPS-resource',
        u'Initial-E-DCH-SPS-resource-ExtIEs',
        u'Initial-DL-DPCH-TimingAdjustment-Allowed',
        u'InnerLoopDLPCStatus',
        u'IPDLParameters',
        u'Extension-IPDLParameters',
        u'Extension-IPDLParametersIE',
        u'Inter-Frequency-Cell-List',
        u'Inter-Frequency-Cell',
        u'Inter-Frequency-Cell-ExtIEs',
        u'Inter-Frequency-Cell-Information',
        u'Inter-Frequency-Cell-Information-ExtIEs',
        u'Inter-Frequency-Cell-Information-SIB11',
        u'Inter-Frequency-Cell-Information-SIB12',
        u'Inter-Frequency-Cell-Information-SIB11ter',
        u'Inter-Frequency-Cells-Information-SIB11-Per-Indication',
        u'Inter-Frequency-Cells-Information-SIB11-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB12-Per-Indication',
        u'Inter-Frequency-Cells-Information-SIB12-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication',
        u'Inter-Frequency-Cell-SIB11ter-List',
        u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cell-SIB11ter',
        u'InterFrequencyCellID-Ext',
        u'Inter-Frequency-Cell-SIB11ter-ExtIEs',
        u'Inter-Frequency-Cell-Indication',
        u'Inter-Frequency-Cell-SIB11-or-SIB12-List',
        u'Inter-Frequency-Cell-SIB11-or-SIB12',
        u'InterFrequencyCellID',
        u'InterStream-Interference-Compensation',
        u'IPDL-FDD-Parameters',
        u'IPDL-FDD-Parameters-ExtIEs',
        u'IPDL-TDD-Parameters',
        u'IPDL-TDD-Parameters-ExtIEs',
        u'IPDL-TDD-ParametersLCR',
        u'IPDL-TDD-ParametersLCR-ExtIEs',
        u'IPLength',
        u'IPMulticastAddress',
        u'IPOffset',
        u'IP-P-CCPCH',
        u'IPSlot',
        u'IPSpacingFDD',
        u'IPSpacingTDD',
        u'IPStart',
        u'IPSub',
        u'IdleIntervalInformation',
        u'LABased',
        u'LABased-ExtIEs',
        u'LAI-List',
        u'LAC',
        u'LAI',
        u'LimitedPowerIncrease',
        u'List-Of-PLMNs',
        u'L3-Information',
        u'Load-Value-IncrDecrThres',
        u'Load-Value',
        u'LoadValue',
        u'LCRTDD-Uplink-Physical-Channel-Capability',
        u'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs',
        u'LogicalChannelID',
        u'M1Report',
        u'M2Report',
        u'MDT-Activation',
        u'MDTAreaScope',
        u'MDT-Configuration',
        u'MDT-Configuration-ExtIEs',
        u'MDT-Report-Parameters',
        u'MeasurementQuantity',
        u'MaxNrOfUL-DPCHs',
        u'MAC-c-sh-SDU-Length',
        u'MAC-c-sh-SDU-LengthList',
        u'MAC-DTX-Cycle-2ms',
        u'MAC-DTX-Cycle-10ms',
        u'MAC-ehs-Reset-Timer',
        u'MAC-Inactivity-Threshold',
        u'MACdPDU-Size',
        u'MAC-PDU-SizeExtended',
        u'MACdPDU-Size-IndexList',
        u'MACdPDU-Size-IndexItem',
        u'MACdPDU-Size-IndexItem-ExtIEs',
        u'MACdPDU-Size-IndexList-to-Modify',
        u'MACdPDU-Size-IndexItem-to-Modify',
        u'MACdPDU-Size-IndexItem-to-Modify-ExtIEs',
        u'MACes-Guaranteed-Bitrate',
        u'MACes-Maximum-Bitrate-LCR',
        u'MACeReset-Indicator',
        u'MAChsGuaranteedBitRate',
        u'MAChsReorderingBufferSize-for-RLC-UM',
        u'MAC-hsWindowSize',
        u'MAChsResetScheme',
        u'MaximumAllowedULTxPower',
        u'Max-Bits-MACe-PDU-non-scheduled',
        u'MaxNrDLPhysicalchannels',
        u'MaxNrDLPhysicalchannels768',
        u'MaxNrDLPhysicalchannelsTS',
        u'MaxNrDLPhysicalchannelsTS768',
        u'MaxNr-Retransmissions-EDCH',
        u'MaxNrTimeslots',
        u'MaxNrULPhysicalchannels',
        u'Max-Set-E-DPDCHs',
        u'Max-UE-DTX-Cycle',
        u'MBMS-Bearer-Service-Full-Address',
        u'MBMS-Bearer-Service-Full-Address-ExtIEs',
        u'MBMS-Bearer-Service-List',
        u'MBMS-Bearer-ServiceItemFDD',
        u'MBMS-Bearer-ServiceItemFDD-ExtIEs',
        u'MBMS-Bearer-ServiceItemFDD-PFL',
        u'MBMS-Bearer-ServiceItemFDD-PFL-ExtIEs',
        u'MBMS-Bearer-ServiceItemTDD',
        u'MBMS-Bearer-ServiceItemTDD-ExtIEs',
        u'MBMS-Bearer-ServiceItemTDD-PFL',
        u'MBMS-Bearer-ServiceItemTDD-PFL-ExtIEs',
        u'MBMSChannelTypeInfo',
        u'MBMSChannelTypeInfo-ExtIEs',
        u'MBMSChannelTypeCellList',
        u'MBMSChannelTypeCellList-ExtIEs',
        u'MBMSPreferredFreqLayerInfo',
        u'MBMSPreferredFreqLayerInfo-ExtIEs',
        u'MBMS-Neighbouring-Cell-Information',
        u'MBMS-Neighbouring-Cell-Information-ExtIEs',
        u'MBMS-ConcatenatedServiceList',
        u'MBMS-RLC-Sequence-Number-Information',
        u'MBMS-RLC-Sequence-Number-Information-List',
        u'MBMS-RLC-Sequence-Number-Information-List-ExtIEs',
        u'MBMS-Bearer-Service-List-RLC',
        u'MBMS-Bearer-Service-List-RLCinfo',
        u'MBMS-Bearer-Service-List-RLCinfo-ExtIEs',
        u'MBSFN-Cluster-Identity',
        u'MCCH-Message-List',
        u'MCCH-Configuration-Info',
        u'MCCH-Configuration-Info-ExtIEs',
        u'Secondary-CCPCH-System-Information-MBMS',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Info-List',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Item',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Item-ExtIEs',
        u'MbsfnSchedulingTransmissionTimeInterval',
        u'MeasurementFilterCoefficient',
        u'MeasurementID',
        u'Measurement-Power-Offset',
        u'MinimumSpreadingFactor',
        u'MinimumSpreadingFactor768',
        u'Minimum-TEBS-threshold',
        u'MultipleURAsIndicator',
        u'MaxAdjustmentStep',
        u'MeasurementChangeTime',
        u'MeasurementHysteresisTime',
        u'MeasurementIncreaseDecreaseThreshold',
        u'Extension-MeasurementIncreaseDecreaseThreshold',
        u'Extension-MeasurementIncreaseDecreaseThresholdIE',
        u'MeasurementRecoveryBehavior',
        u'MeasurementRecoveryReportingIndicator',
        u'MeasurementRecoverySupportIndicator',
        u'MeasurementThreshold',
        u'MessageStructure',
        u'MessageStructure-ExtIEs',
        u'Extension-MeasurementThreshold',
        u'Extension-MeasurementThresholdIE',
        u'MidambleConfigurationBurstType1And3',
        u'MidambleConfigurationBurstType2',
        u'MidambleConfigurationLCR',
        u'MidambleShiftAndBurstType',
        u'MidambleShiftLong',
        u'MidambleShiftShort',
        u'MidambleShiftLCR',
        u'MidambleAllocationMode',
        u'MidambleShiftLCR-ExtIEs',
        u'MidambleShiftAndBurstType768',
        u'MidambleConfigurationBurstType2-768',
        u'MidambleShiftShort768',
        u'MIMO-ActivationIndicator',
        u'MIMO-InformationResponse',
        u'MIMO-InformationResponse-ExtIEs',
        u'MIMO-Mode-Indicator',
        u'MIMO-N-M-Ratio',
        u'MIMO-PilotConfiguration',
        u'MIMO-S-CPICH-Channelisation-Code',
        u'MIMO-withfourtransmitantennas-ActivationIndicator',
        u'MIMO-withfourtransmitantennas-ModeIndicator',
        u'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        u'DualStream-MIMO-withfourtransmitantennas-ModeIndicator',
        u'Additional-Associated-Secondary-CPICH',
        u'Additional-Secondary-CPICH',
        u'Additional-Secondary-CPICH-Item-ExtIEs',
        u'MinUL-ChannelisationCodeLength',
        u'MinimumReducedE-DPDCH-GainFactor',
        u'ModifyPriorityQueue',
        u'Modulation',
        u'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'Multicell-EDCH-Transport-Bearer-Mode',
        u'MulticellEDCH-Information',
        u'MulticellEDCH-InformationItem',
        u'MulticellEDCH-InformationItemIEs',
        u'MulticellEDCH-InformationItemIEs-ExtIEs',
        u'MulticellEDCH-RL-SpecificInformation',
        u'MulticellEDCH-RL-SpecificInformationItem',
        u'MulticellEDCH-RL-SpecificInformationItemIEs',
        u'MulticellEDCH-RL-SpecificInformationItemIEs-ExtIEs',
        u'Multicell-EDCH-Restriction',
        u'Multiple-PLMN-List',
        u'Multiple-PLMN-List-ExtIEs',
        u'MultiplexingPosition',
        u'MAChs-ResetIndicator',
        u'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR',
        u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs',
        u'MIMO-SFMode-For-HSPDSCHDualStream',
        u'Multi-Carrier-EDCH-Info',
        u'Multi-Carrier-EDCH-Info-ExtIEs',
        u'Multicarrier-EDCH-Transport-Bearer-Mode',
        u'Multi-Carrier-EDCH-Information',
        u'Multi-Carrier-EDCH-LCR-InformationItem',
        u'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs',
        u'SNPL-Carrier-Group-Indicator',
        u'Multi-Carrier-EDCH-MACdFlows-Information-TDD',
        u'Multi-Carrier-EDCH-MACdFlows-Specific-Info',
        u'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs',
        u'Multi-Carrier-EDCH-Reconfigure',
        u'Multi-Carrier-EDCH-Reconfigure-ExtIEs',
        u'Continue-Setup-Change-Multi-Carrier-EDCH',
        u'Multi-Carrier-EDCH-Change-Info',
        u'Multi-Carrier-EDCH-Change-Info-ExtIEs',
        u'Multi-Carrier-EDCH-Information-Removal-List',
        u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs',
        u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs',
        u'Multi-Carrier-EDCH-Information-Response',
        u'Multi-Carrier-EDCH-LCR-Information-ResponseItem',
        u'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs',
        u'Multiflow-Reconfiguration',
        u'Multiflow-Information',
        u'Multiflow-Information-ExtIEs',
        u'Multiflow-Information-To-Modify',
        u'Multiflow-Information-To-Modify-ExtIEs',
        u'Multiflow-RepetitionFactors',
        u'Multiflow-RepetitionFactors-ExtIEs',
        u'Multiflow-Stop',
        u'Multiflow-Mode',
        u'Multiflow-MIMO',
        u'Multiflow-Timing',
        u'Multiflow-OrdinalNumberOfFrequency',
        u'MU-MIMO-InformationLCR',
        u'MU-MIMO-Operation',
        u'MU-MIMO-Usage-Indicator',
        u'Standalone-Midamble-Channel-Information',
        u'Standalone-Midamble-Configuration',
        u'Standalone-MidambleShift',
        u'Standalone-Midamble-RepetitionPeriod',
        u'Standalone-Midamble-Offset',
        u'ReferenceBeta',
        u'Standalone-Midamble-Channel-Information-ExtIEs',
        u'Mode1-Ind',
        u'MU-MIMO-InformationLCR-ExtIEs',
        u'MU-MIMO-Indicator',
        u'MU-MIMO-Indicator-ExtIEs',
        u'NACC-Related-Data',
        u'NACC-Related-Data-ExtIEs',
        u'Nack-Power-Offset',
        u'NCC',
        u'Neighbouring-UMTS-CellInformation',
        u'Neighbouring-UMTS-CellInformation-Ext',
        u'Neighbouring-UMTS-CellInformationExtensionItemIE',
        u'Neighbouring-UMTS-CellInformationExtensionItem',
        u'Neighbouring-UMTS-CellInformationExtensionItem-ExtIEs',
        u'Neighbouring-UMTS-CellInformationItemIE',
        u'Neighbouring-UMTS-CellInformationItem',
        u'Neighbouring-UMTS-CellInformationItem-ExtIEs',
        u'Neighbouring-FDD-CellInformation',
        u'Neighbouring-FDD-CellInformationItem',
        u'Neighbouring-FDD-CellInformationItem-ExtIEs',
        u'MultipleFrequencyBandsIndicatorList',
        u'NeighbouringFDDCellMeasurementInformation',
        u'NeighbouringFDDCellMeasurementInformationItem-ExtIEs',
        u'Neighbouring-GSM-CellInformation',
        u'Neighbouring-GSM-CellInformationIE',
        u'Neighbouring-GSM-CellInformationIEs',
        u'Neighbouring-GSM-CellInformationItem',
        u'Neighbouring-GSM-CellInformationItem-ExtIEs',
        u'Neighbouring-TDD-CellInformation',
        u'Neighbouring-TDD-CellInformationItem',
        u'Neighbouring-TDD-CellInformationItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformation',
        u'NeighbouringTDDCellMeasurementInformationItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationLCR',
        u'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformation768',
        u'NeighbouringTDDCellMeasurementInformationItem768-ExtIEs',
        u'Neighbouring-LCR-TDD-CellInformation',
        u'Neighbouring-LCR-TDD-CellInformationItem',
        u'Neighbouring-LCR-TDD-CellInformationItem-ExtIEs',
        u'Neighbouring-E-UTRA-CellInformation',
        u'Neighbouring-E-UTRA-CellInformationItem',
        u'Neighbouring-E-UTRA-CellInformationItem-ExtIEs',
        u'MultipleFrequencyBandsIndicatorList-EUTRA',
        u'RadioFrequencyBandEUTRA',
        u'NonCellSpecificTxDiversity',
        u'Non-rectangular-resource-allocation-indicator',
        u'Non-rectangular-resource-timeslot-set',
        u'NotProvidedCellList',
        u'NrOfDLchannelisationcodes',
        u'NrOfTransportBlocks',
        u'NRT-Load-Information-Value-IncrDecrThres',
        u'NRT-Load-Information-Value',
        u'NRTLoadInformationValue',
        u'N-E-UCCH',
        u'N-E-UCCH-LCR',
        u'Number-Of-Supported-Carriers',
        u'NumHS-SCCH-Codes',
        u'NoOfTargetCellHS-SCCH-Order',
        u'Non-Serving-RL-Preconfig-Setup',
        u'Non-Serving-RL-Preconfig-Setup-ExtIEs',
        u'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        u'New-non-serving-RL-setup-selection',
        u'Non-Serving-RL-Preconfig-Info',
        u'Non-Serving-RL-Preconfig-Info-ExtIEs',
        u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs',
        u'NeedforIdleInterval',
        u'OnModification',
        u'OnModification-ExtIEs',
        u'OnModificationInformation',
        u'OnModificationInformation-ExtIEs',
        u'OrdinalNumberOfFrequency',
        u'Out-of-Sychronization-Window',
        u'PagingCause',
        u'PagingRecordType',
        u'PartialReportingIndicator',
        u'Pattern-Sequence-Identifier',
        u'PayloadCRC-PresenceIndicator',
        u'PCCPCH-Power',
        u'PCH-InformationList',
        u'PCH-InformationItem',
        u'PCH-InformationItem-ExtIEs',
        u'PC-Preamble',
        u'PCI',
        u'Periodic',
        u'Periodic-ExtIEs',
        u'PeriodicInformation',
        u'PeriodicInformation-ExtIEs',
        u'Permanent-NAS-UE-Identity',
        u'Phase-Reference-Update-Indicator',
        u'PLCCHsequenceNumber',
        u'PLMN-Identity',
        u'PLMN-List',
        u'PowerAdjustmentType',
        u'PowerOffset',
        u'PowerOffsetForSecondaryCPICHforMIMO',
        u'PowerOffsetForSecondaryCPICHforMIMORequestIndicator',
        u'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas',
        u'Associated-Secondary-CPICH',
        u'Associated-Secondary-CPICH-Item-ExtIEs',
        u'CommonPhysicalChannelID',
        u'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator',
        u'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas',
        u'PRC',
        u'PRCDeviation',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'Precoder-Weight-Set-Restriction',
        u'PredictedSFNSFNDeviationLimit',
        u'PredictedTUTRANGPSDeviationLimit',
        u'PreferredFrequencyLayerInfo',
        u'PreferredFrequencyLayerInfo-ExtIEs',
        u'PrimaryCPICH-Power',
        u'PrimaryCPICH-EcNo',
        u'Primary-CPICH-Usage-For-Channel-Estimation',
        u'PrimaryCCPCH-RSCP',
        u'PrimaryCCPCH-RSCP-Delta',
        u'PrimaryScramblingCode',
        u'PriorityLevel',
        u'PriorityQueue-Id',
        u'PriorityQueue-InfoList',
        u'PriorityQueue-InfoItem',
        u'PriorityQueue-InfoItem-ExtIEs',
        u'PriorityQueue-InfoList-EnhancedFACH-PCH',
        u'PriorityQueue-InfoItem-EnhancedFACH-PCH',
        u'PriorityQueue-InfoItem-EnhancedFACH-PCH-ExtIEs',
        u'PriorityQueue-InfoList-to-Modify',
        u'PriorityQueue-InfoItem-to-Add',
        u'PriorityQueue-InfoItem-to-Add-ExtIEs',
        u'PriorityQueue-InfoItem-to-Modify',
        u'PriorityQueue-InfoItem-to-Modify-ExtIEs',
        u'PriorityQueue-InfoList-to-Modify-Unsynchronised',
        u'PriorityQueue-InfoItem-to-Modify-Unsynchronised',
        u'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs',
        u'PropagationDelay',
        u'ProvidedInformation',
        u'ProvideInformation-ExtIEs',
        u'UpPCH-InformationList-LCRTDD',
        u'UpPCH-InformationItemIE-LCRTDD',
        u'UpPCH-InformationItem-LCRTDD',
        u'UpPCH-InformationItem-LCRTDD-ExtIEs',
        u'PunctureLimit',
        u'PTMCellList',
        u'PTPCellList',
        u'QE-Selector',
        u'Process-Memory-Size',
        u'RABased',
        u'RABased-ExtIEs',
        u'Radio-Links-without-DPCH-FDPCH-Indication',
        u'Radio-Links-without-DPCH-FDPCH-Information',
        u'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs',
        u'RAI-List',
        u'ReportInterval',
        u'ReportAmount',
        u'RAC',
        u'RAI',
        u'RANAP-EnhancedRelocationInformationRequest',
        u'RANAP-EnhancedRelocationInformationResponse',
        u'RANAP-RelocationInformation',
        u'Range-Correction-Rate',
        u'RateMatchingAttribute',
        u'RB-Identity',
        u'RB-Info',
        u'Received-Total-Wideband-Power-Value',
        u'Received-Total-Wideband-Power-Value-IncrDecrThres',
        u'Reference-E-TFCI-Information',
        u'Reference-E-TFCI-Information-Item',
        u'Reference-E-TFCI-Information-Item-ExtIEs',
        u'Reference-E-TFCI-PO',
        u'RefTFCNumber',
        u'Released-CN-Domain',
        u'RepetitionLength',
        u'RepetitionPeriod',
        u'RepetitionNumber0',
        u'RepetitionNumber1',
        u'ReportCharacteristics',
        u'Extension-ReportCharacteristics',
        u'Extension-ReportCharacteristicsIE',
        u'ReportPeriodicity',
        u'RequestedDataValue',
        u'RequestedDataValue-ExtIEs',
        u'RequestedDataValueInformation',
        u'RestrictionStateIndicator',
        u'RL-ID',
        u'RL-Set-ID',
        u'RL-Specific-DCH-Info',
        u'RL-Specific-DCH-Info-Item',
        u'RL-Specific-DCH-Info-Item-ExtIEs',
        u'RL-Specific-EDCH-Information',
        u'RL-Specific-EDCH-Information-Item-ExtIEs',
        u'RL-Specific-EDCH-Info',
        u'RL-Specific-EDCH-InfoItem',
        u'RL-Specific-EDCH-Info-Item-ExtIEs',
        u'RLC-Mode',
        u'DL-RLC-PDU-Size-Format',
        u'RLC-Sequence-Number',
        u'RNC-ID',
        u'RNTI-Allocation-Indicator',
        u'Round-Trip-Time-IncrDecrThres',
        u'Round-Trip-Time-Value',
        u'RSCP-Value',
        u'RSCP-Value-IncrDecrThres',
        u'Received-total-wide-band-power',
        u'RT-Load-Value-IncrDecrThres',
        u'RT-Load-Value',
        u'RTLoadValue',
        u'RxTimingDeviationForTA',
        u'RxTimingDeviationForTAext',
        u'RxTimingDeviationForTA768',
        u'Rx-Timing-Deviation-Value',
        u'Rx-Timing-Deviation-Value-ext',
        u'Rx-Timing-Deviation-Value-LCR',
        u'Rx-Timing-Deviation-Value-768',
        u'RefBeta',
        u'SAC',
        u'SAI',
        u'SAI-ExtIEs',
        u'Same-As-Scheduled-E-HICH',
        u'SAT-ID',
        u'Satellite-DGPSCorrections-Information-ExtIEs',
        u'SCH-TimeSlot',
        u'ScaledAdjustmentRatio',
        u'SchedulingInformation',
        u'SCTD-Indicator',
        u'SDPCCH-PowerOffsetInformation',
        u'SecondaryServingCells',
        u'SecondaryServingCellsItem',
        u'SecondaryServingCellsItem-ExtIEs',
        u'Secondary-CCPCH-Info-TDD',
        u'Secondary-CCPCH-Info-TDD-ExtIEs',
        u'Secondary-CPICH-Information',
        u'Secondary-CPICH-Information-ExtIEs',
        u'Secondary-CPICH-Information-Change',
        u'Secondary-LCR-CCPCH-Info-TDD',
        u'Secondary-LCR-CCPCH-Info-TDD-ExtIEs',
        u'Secondary-CCPCH-Info-TDD768',
        u'Secondary-CCPCH-Info-TDD768-ExtIEs',
        u'Secondary-CCPCH-TDD-InformationList',
        u'Secondary-CCPCH-TDD-InformationItem',
        u'Secondary-CCPCH-TDD-InformationItem-ExtIEs',
        u'Secondary-LCR-CCPCH-TDD-InformationList',
        u'Secondary-LCR-CCPCH-TDD-InformationItem',
        u'Secondary-LCR-CCPCH-TDD-InformationItem-ExtIEs',
        u'Secondary-CCPCH-TDD-InformationList768',
        u'Secondary-CCPCH-TDD-InformationItem768',
        u'Secondary-CCPCH-TDD-InformationItem768-ExtIEs',
        u'Secondary-CCPCH-TDD-Code-Information',
        u'Secondary-CCPCH-TDD-Code-InformationItem',
        u'Secondary-CCPCH-TDD-Code-InformationItem-ExtIEs',
        u'Secondary-LCR-CCPCH-TDD-Code-Information',
        u'Secondary-LCR-CCPCH-TDD-Code-InformationItem',
        u'Secondary-LCR-CCPCH-TDD-Code-InformationItem-ExtIEs',
        u'Secondary-CCPCH-TDD-Code-Information768',
        u'Secondary-CCPCH-TDD-Code-InformationItem768',
        u'Secondary-CCPCH-TDD-Code-InformationItem768-ExtIEs',
        u'Secondary-Serving-Cell-List',
        u'Secondary-Serving-Cell-List-ExtIEs',
        u'Possible-Secondary-Serving-Cell-List',
        u'Possible-Secondary-Serving-Cell',
        u'Possible-Secondary-Serving-Cell-ExtIEs',
        u'SecondInterleavingMode',
        u'Secondary-UL-Frequency-Activation-State',
        u'S-E-DPCCH-PowerOffset',
        u'Seed',
        u'Service-ID',
        u'S-E-ROCH-Release-Indicator',
        u'SetsOfHS-SCCH-Codes',
        u'SetsOfHS-SCCH-CodesItem',
        u'SetsOfHS-SCCH-CodesItem-ExtIEs',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2',
        u'SFN',
        u'SFNSFN-FDD',
        u'SFNSFN-TDD',
        u'SFNSFN-TDD768',
        u'GA-AccessPointPositionwithOptionalAltitude',
        u'GA-AccessPointPositionwithOptionalAltitude-ExtIEs',
        u'SFNSFNChangeLimit',
        u'SFNSFNDriftRate',
        u'SFNSFNDriftRateQuality',
        u'SFNSFNMeasurementThresholdInformation',
        u'SFNSFNMeasurementThresholdInformation-ExtIEs',
        u'SFNSFNMeasurementValueInformation',
        u'SFNSFNMeasurementValueInformationItem-ExtIEs',
        u'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        u'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        u'SFNSFNQuality',
        u'SFNSFNTimeStampInformation',
        u'SFNSFNTimeStamp-TDD',
        u'SFNSFNTimeStamp-ExtIEs',
        u'SFNSFNValue',
        u'SID',
        u'Single-Stream-MIMO-ActivationIndicator',
        u'Single-Stream-MIMO-Mode-Indicator',
        u'SIR-Error-Value',
        u'SIR-Error-Value-IncrDecrThres',
        u'SIR-Value',
        u'SIR-Value-IncrDecrThres',
        u'SixteenQAM-UL-Operation-Indicator',
        u'SixtyfourQAM-UL-Operation-Indicator',
        u'SixtyfourQAM-UsageAllowedIndicator',
        u'SixtyfourQAM-DL-SupportIndicator',
        u'SixtyfourQAM-DL-UsageIndicator',
        u'SignatureSequenceGroupIndex',
        u'SNA-Information',
        u'SNA-Information-ExtIEs',
        u'ListOfSNAs',
        u'SNACode',
        u'SourceID',
        u'SpecialBurstScheduling',
        u'SpeechVersion',
        u'S-RNTI',
        u'S-RNTI-Group',
        u'SRB-Delay',
        u'SSDT-SupportIndicator',
        u'Standalone-Midamble-Channel-Indicator',
        u'Status-Flag',
        u'STTD-SupportIndicator',
        u'Support-8PSK',
        u'Support-PLCCH',
        u'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        u'SyncCase',
        u'SynchronisationConfiguration',
        u'SynchronisationConfiguration-ExtIEs',
        u'SYNC-UL-ProcParameters',
        u'T1',
        u'TAC',
        u'TargetID',
        u'TDD-AckNack-Power-Offset',
        u'TDD-ChannelisationCode',
        u'TDD-ChannelisationCode768',
        u'TDD-ChannelisationCodeLCR',
        u'TDD-DCHs-to-Modify',
        u'TDD-DCHs-to-ModifyItem',
        u'TDD-DCHs-to-ModifyItem-ExtIEs',
        u'TDD-DCHs-to-ModifySpecificInformationList',
        u'TDD-DCHs-to-ModifySpecificItem',
        u'TDD-DCHs-to-ModifySpecificItem-ExtIEs',
        u'TDD-DL-Code-Information',
        u'TDD-DL-Code-InformationItem',
        u'TDD-DL-Code-InformationItem-ExtIEs',
        u'TDD-DL-Code-LCR-Information',
        u'TDD-DL-Code-LCR-InformationItem',
        u'TDD-DL-Code-LCR-InformationItem-ExtIEs',
        u'TDD-DL-Code-Information768',
        u'TDD-DL-Code-InformationItem768',
        u'TDD-DL-Code-InformationItem768-ExtIEs',
        u'TDD-DL-DPCH-TimeSlotFormat-LCR',
        u'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        u'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        u'TDD-DPCHOffset',
        u'TDD-PhysicalChannelOffset',
        u'TDD-TPC-DownlinkStepSize',
        u'TDD-TPC-UplinkStepSize-LCR',
        u'TDD-UL-Code-Information',
        u'TDD-UL-Code-InformationItem',
        u'TDD-UL-Code-InformationItem-ExtIEs',
        u'TDD-UL-Code-LCR-Information',
        u'TDD-UL-Code-LCR-InformationItem',
        u'TDD-UL-Code-LCR-InformationItem-ExtIEs',
        u'TDD-UL-Code-Information768',
        u'TDD-UL-Code-InformationItem768',
        u'TDD-UL-Code-InformationItem768-ExtIEs',
        u'TDD-UL-DPCH-TimeSlotFormat-LCR',
        u'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        u'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        u'TFCI-Coding',
        u'TFCI-Presence',
        u'TFCI-SignallingMode',
        u'TGD',
        u'TGPRC',
        u'TGPSID',
        u'TGSN',
        u'TimeSlot',
        u'TimeSlotLCR',
        u'Time-Stamp',
        u'TimingAdvanceApplied',
        u'SynchronisationIndicator',
        u'TMGI',
        u'TMGI-ExtIEs',
        u'TnlQos',
        u'ToAWE',
        u'ToAWS',
        u'TraceDepth',
        u'TraceRecordingSessionReference',
        u'TraceReference',
        u'TrafficClass',
        u'Transmission-Gap-Pattern-Sequence-Information',
        u'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        u'Transmission-Gap-Pattern-Sequence-ScramblingCode-Information',
        u'Transmission-Gap-Pattern-Sequence-Status-List',
        u'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        u'Affected-HSDSCH-Serving-Cell-List',
        u'TransmissionMode',
        u'Transmission-Mode-Information',
        u'Transmission-Mode-Information-List',
        u'Transmission-Mode-Information-List-ExtIEs',
        u'TransmissionTimeIntervalDynamic',
        u'TransmissionTimeIntervalSemiStatic',
        u'TransmitDiversityIndicator',
        u'Transmitted-Carrier-Power-Value',
        u'Transmitted-Carrier-Power-Value-IncrDecrThres',
        u'Transport-Block-Size-Index',
        u'TUTRANGANSS',
        u'TUTRANGANSSAccuracyClass',
        u'TUTRANGANSSMeasurementThresholdInformation',
        u'TUTRANGANSSMeasurementThresholdInformation-ExtIEs',
        u'TUTRANGANSSMeasurementValueInformation',
        u'TUTRANGANSSMeasurementValueInformation-ExtIEs',
        u'TUTRANGPS',
        u'TUTRANGPSChangeLimit',
        u'TUTRANGPSDriftRate',
        u'TUTRANGPSDriftRateQuality',
        u'TUTRANGPSAccuracyClass',
        u'TUTRANGPSMeasurementThresholdInformation',
        u'TUTRANGPSMeasurementThresholdInformation-ExtIEs',
        u'TUTRANGPSMeasurementValueInformation',
        u'TUTRANGPSMeasurementValueInformationItem-ExtIEs',
        u'TUTRANGPSQuality',
        u'TransportBearerID',
        u'TransportBearerRequestIndicator',
        u'TransportBearerNotRequestedIndicator',
        u'TransportBearerNotSetupIndicator',
        u'TransportBlockSize',
        u'TransportFormatCombination-Beta',
        u'SignalledGainFactors-ExtIEs',
        u'TFCS',
        u'TFCS-ExtIEs',
        u'TFCS-TFCSList',
        u'TFCS-TFCSList-ExtIEs',
        u'TFCS-CTFC',
        u'TPC-slot-position',
        u'TPC-slot-position-ExtIEs',
        u'TransportFormatSet',
        u'TransportFormatSet-ExtIEs',
        u'TransportFormatSet-DynamicPartList',
        u'TransportFormatSet-DynamicPartList-ExtIEs',
        u'TransportFormatSet-ModeDP',
        u'TDD-TransportFormatSet-ModeDP',
        u'TDD-TransportFormatSet-ModeDP-ExtIEs',
        u'TransmissionTimeIntervalInformation',
        u'TransmissionTimeIntervalInformation-ExtIEs',
        u'Transmitted-Code-Power-Value',
        u'Transmitted-Code-Power-Value-IncrDecrThres',
        u'TransportFormatManagement',
        u'TransportFormatSet-Semi-staticPart',
        u'TransportFormatSet-Semi-staticPart-ExtIEs',
        u'TransportFormatSet-ModeSSP',
        u'TransportLayerAddress',
        u'TrCH-SrcStatisticsDescr',
        u'TSN-Length',
        u'TSTD-Indicator',
        u'TSTD-Support-Indicator',
        u'TTI-Update-Indicator',
        u'TTI-Update-Ind',
        u'TxDiversityIndicator',
        u'TypeOfError',
        u'UARFCN',
        u'UDRE',
        u'UDREGrowthRate',
        u'UDREValidityTime',
        u'UE-AggregateMaximumBitRate',
        u'UE-AggregateMaximumBitRateDownlink',
        u'UE-AggregateMaximumBitRateUplink',
        u'UE-AggregateMaximumBitRate-Enforcement-Indicator',
        u'UE-Capabilities-Info',
        u'UE-Capabilities-Info-ExtIEs',
        u'UE-Support-of-non-rectangular-resource-allocation',
        u'UE-TS0-CapabilityLCR',
        u'UE-RF-Band-CapabilityLCR',
        u'Radio-Frequency-BandItem',
        u'Radio-Frequency-Band',
        u'Radio-Frequency-BandItem-ExtIEs',
        u'LCRTDD-HSDSCH-Physical-Layer-Category',
        u'UE-DPCCH-burst1',
        u'UE-DPCCH-burst2',
        u'UE-DRX-Cycle-LCR',
        u'UE-DRX-Offset-LCR',
        u'UE-DRX-Cycle',
        u'UE-DRX-Grant-Monitoring',
        u'UE-DTX-Cycle1-2ms',
        u'UE-DTX-Cycle1-10ms',
        u'UE-DTX-Cycle2-2ms',
        u'UE-DTX-Cycle2-ext-2ms',
        u'UE-DTX-Cycle2-10ms',
        u'UE-DTX-DRX-Offset',
        u'UE-DTX-Long-Preamble',
        u'UEIdentity',
        u'UEMeasurementHysteresisTime',
        u'UEMeasurementParameterModAllow',
        u'UEMeasurementReportCharacteristics',
        u'UEMeasurementReportCharacteristicsEvent1h',
        u'UEMeasurementReportCharacteristicsEvent1h-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent1i',
        u'UEMeasurementReportCharacteristicsEvent1i-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6a',
        u'UEMeasurementReportCharacteristicsEvent6a-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6b',
        u'UEMeasurementReportCharacteristicsEvent6b-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6c',
        u'UEMeasurementReportCharacteristicsEvent6c-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6d',
        u'UEMeasurementReportCharacteristicsEvent6d-ExtIEs',
        u'UEMeasurementReportCharacteristicsPeriodic',
        u'UEMeasurementReportCharacteristicsPeriodicAmountofReporting',
        u'UEMeasurementReportCharacteristicsPeriodicReportingInterval',
        u'UEMeasurementReportCharacteristicsPeriodic-ExtIEs',
        u'UEMeasurementReportCharacteristics-Extension',
        u'UEMeasurementReportCharacteristics-ExtensionIE',
        u'UEMeasurementThreshold',
        u'UEMeasurementThresholdDLTimeslotISCP',
        u'UEMeasurementThresholdUETransmitPower',
        u'UEMeasurementThreshold-Extension',
        u'UEMeasurementThreshold-ExtensionIE',
        u'UEMeasurementTimeslotInfoHCR',
        u'UEMeasurementTimeslotInfoHCR-IEs',
        u'UEMeasurementTimeslotInfoHCRBurstType',
        u'UEMeasurementTimeslotInfoHCR-IEs-ExtIEs',
        u'UEMeasurementTimeslotInfoLCR',
        u'UEMeasurementTimeslotInfoLCR-IEs',
        u'UEMeasurementTimeslotInfoLCR-IEs-ExtIEs',
        u'UEMeasurementTimeslotInfo768',
        u'UEMeasurementTimeslotInfo768-IEs',
        u'UEMeasurementTimeslotInfo768BurstType',
        u'UEMeasurementTimeslotInfo768-IEs-ExtIEs',
        u'UEMeasurementTimeToTrigger',
        u'UEMeasurementType',
        u'UEMeasurementValue',
        u'UE-MeasurementValue-UE-Transmitted-Power',
        u'UE-MeasurementValue-UE-Transmitted-Power-ExtIEs',
        u'UEMeasurementValueTransmittedPowerListHCR',
        u'UEMeasurementValueTransmittedPowerListHCR-IEs',
        u'UEMeasurementValueTransmittedPowerListHCR-IEs-ExtIEs',
        u'UEMeasurementValueTransmittedPowerListLCR',
        u'UEMeasurementValueTransmittedPowerListLCR-IEs',
        u'UEMeasurementValueTransmittedPowerListLCR-IEs-ExtIEs',
        u'UEMeasurementValueTransmittedPowerList768',
        u'UEMeasurementValueTransmittedPowerList768-IEs',
        u'UEMeasurementValueTransmittedPowerList768-IEs-ExtIEs',
        u'UE-MeasurementValue-Primary-CCPCH-RSCP',
        u'UE-MeasurementValue-Primary-CCPCH-RSCP-ExtIEs',
        u'UE-MeasurementValue-DL-Timeslot-ISCP',
        u'UE-MeasurementValue-DL-Timeslot-ISCP-ExtIEs',
        u'UEMeasurementValueTimeslotISCPListHCR',
        u'UEMeasurementValueTimeslotISCPListHCR-IEs',
        u'UEMeasurementValueTimeslotISCPListHCR-IEs-ExtIEs',
        u'UEMeasurementValueTimeslotISCPListLCR',
        u'UEMeasurementValueTimeslotISCPListLCR-IEs',
        u'UEMeasurementValueTimeslotISCPListLCR-IEs-ExtIEs',
        u'UEMeasurementValueTimeslotISCPList768',
        u'UEMeasurementValueTimeslotISCPList768-IEs',
        u'UEMeasurementValueTimeslotISCPList768-IEs-ExtIEs',
        u'UEMeasurementValue-Extension',
        u'UEMeasurementValue-ExtensionIE',
        u'UEMeasurementValueInformation',
        u'UEMeasurementValueInformationAvailable',
        u'UEMeasurementValueInformationAvailableItem-ExtIEs',
        u'UEMeasurementValueInformationnotAvailable',
        u'UE-Measurement-Value',
        u'Extension-UE-Measurement-Value',
        u'Extension-UE-Measurement-ValueIE',
        u'UPHFiltering-Value',
        u'UPH-Filtering-Measurement-Forwarding-Request',
        u'UE-SupportIndicatorExtension',
        u'UE-State',
        u'UE-transmission-power-headroom-Value',
        u'Cell-Fach-Pch-State',
        u'Cell-Fach-Pch-State-ExtIEs',
        u'Ura-Pch-State',
        u'Ura-Pch-State-ExtIEs',
        u'UL-Delta-T2TP',
        u'UL-DL-mode',
        u'UL-DPDCHIndicatorEDCH',
        u'UL-Timeslot-Information',
        u'UL-Timeslot-InformationItem',
        u'UL-Timeslot-InformationItem-ExtIEs',
        u'UL-TimeslotLCR-Information',
        u'UL-TimeslotLCR-InformationItem',
        u'UL-TimeslotLCR-InformationItem-ExtIEs',
        u'PLCCHinformation',
        u'PLCCHinformation-ExtIEs',
        u'UL-Timeslot-Information768',
        u'UL-Timeslot-InformationItem768',
        u'UL-Timeslot-InformationItem768-ExtIEs',
        u'UL-TimeSlot-ISCP-Info',
        u'UL-TimeSlot-ISCP-InfoItem',
        u'UL-TimeSlot-ISCP-InfoItem-ExtIEs',
        u'UL-TimeSlot-ISCP-LCR-Info',
        u'UL-TimeSlot-ISCP-LCR-InfoItem',
        u'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        u'UL-Timeslot-ISCP-Value',
        u'UL-Timeslot-ISCP-Value-IncrDecrThres',
        u'UL-TimingAdvanceCtrl-LCR',
        u'Uplink-Compressed-Mode-Method',
        u'UL-SIR',
        u'UC-ID',
        u'UC-ID-ExtIEs',
        u'UL-DPCCH-SlotFormat',
        u'UL-FP-Mode',
        u'UL-PhysCH-SF-Variation',
        u'UL-ScramblingCode',
        u'UL-ScramblingCode-ExtIEs',
        u'UL-ScramblingCodeLength',
        u'UL-ScramblingCodeNumber',
        u'UL-Synchronisation-Parameters-LCR',
        u'UL-Synchronisation-Parameters-LCR-ExtIEs',
        u'UL-Synchronisation-StepSize',
        u'UL-Synchronisation-Frequency',
        u'UL-TimeslotISCP',
        u'UPPCHPositionLCR',
        u'UpPTSInterferenceValue',
        u'Unidirectional-DCH-Indicator',
        u'URA-ID',
        u'URA-Information',
        u'URA-Information-ExtIEs',
        u'RNCsWithCellsInTheAccessedURA-List',
        u'RNCsWithCellsInTheAccessedURA-Item',
        u'RNCsWithCellsInTheAccessedURA-Item-ExtIEs',
        u'USCH-ID',
        u'USCH-Information',
        u'USCH-InformationItem',
        u'USCH-InformationItem-ExtIEs',
        u'Usefulness-Of-Battery-Optimization',
        u'User-Plane-Congestion-Fields-Inclusion',
        u'Uu-ActivationState',
        u'UMTS-Cells-Info-List',
        u'UMTS-Cells-Info-IEs',
        u'UMTS-Cell-Info',
        u'UMTS-Cell-Info-ExtIEs',
        u'UL-CLTD-Information',
        u'UL-CLTD-Info-ExtIEs',
        u'UL-CLTD-Information-Reconf',
        u'UL-CLTD-Information-Reconf-ExtIEs',
        u'UL-CLTD-Information-To-Modify',
        u'UL-CLTD-Information-To-Modify-ExtIEs',
        u'UL-CLTD-Information-Removal',
        u'UL-CLTD-State-Update-Information',
        u'UL-DPCCH2-Information',
        u'UL-DPCCH2-Information-ExtIEs',
        u'UL-DPCCH2-Information-Reconf',
        u'UL-DPCCH2-Information-Reconf-ExtIEs',
        u'UL-DPCCH2-Information-Removal',
        u'UL-DPCCH2-Information-To-Modify',
        u'UL-DPCCH2-Information-To-Modify-ExtIEs',
        u'UL-CLTD-Activation-Information',
        u'UL-MIMO-Information',
        u'UL-MIMO-Information-ExtIEs',
        u'UL-MIMO-Information-To-Modify',
        u'UL-MIMO-Information-To-Modify-ExtIEs',
        u'UL-MIMO-Reconfiguration',
        u'UL-MIMO-Removal',
        u'UL-MIMO-DL-Control-Channel-Information',
        u'UL-MIMO-DL-Control-Channel-Information-ExtIEs',
        ]
    _type_ = [
        u'AccessPointName',
        u'AckNack-RepetitionFactor',
        u'Ack-Power-Offset',
        u'ActivationDelay',
        u'Activate-Info',
        u'ActivationInformation',
        u'ActivationInformationItem',
        u'Active-MBMS-Bearer-Service-ListFDD',
        u'Active-MBMS-Bearer-Service-ListFDD-PFL',
        u'Active-MBMS-Bearer-Service-ListTDD',
        u'Active-MBMS-Bearer-Service-ListTDD-PFL',
        u'Active-Pattern-Sequence-Information',
        u'Additional-EDCH-Cell-Information-Response-RLAddList',
        u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs',
        u'Additional-EDCH-Setup-Info',
        u'ANRReportIndication',
        u'Additional-EDCH-Cell-Information-Setup',
        u'Additional-EDCH-FDD-Setup-Cell-Information',
        u'Additional-EDCH-UL-DPCH-Information-Setup',
        u'Additional-EDCH-F-DPCH-Information',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-List',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs',
        u'Additional-EDCH-Cell-Information-To-Add-List',
        u'Additional-EDCH-Cell-Information-To-Add-ItemIEs',
        u'Additional-EDCH-UL-DPCH-Information-Addition',
        u'Additional-EDCH-RL-Specific-Information-To-Add-List',
        u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-List',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs',
        u'Additional-EDCH-FDD-Information',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-List',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info',
        u'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response',
        u'Additional-EDCH-Cell-Information-Response-List',
        u'Additional-EDCH-FDD-Information-Response-ItemIEs',
        u'Additional-EDCH-Cell-Information-Response-RLReconf-List',
        u'Additional-EDCH-FDD-Information-Response-RLReconf-Items',
        u'Additional-EDCH-Cell-Information-ConfigurationChange-List',
        u'Additional-EDCH-ConfigurationChange-Info-ItemIEs',
        u'Additional-EDCH-UL-DPCH-Information-Modify',
        u'Additional-EDCH-Cell-Information-Removal-List',
        u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs',
        u'RL-on-Secondary-UL-Frequency',
        u'Additional-EDCH-FDD-Update-Information',
        u'Additional-EDCH-DL-Control-Channel-Change-Information-List',
        u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs',
        u'AdditionalPreferredFrequency',
        u'AdditionalPreferredFrequencyItem',
        u'AdjustmentPeriod',
        u'AffectedUEInformationForMBMS',
        u'AllocationRetentionPriority',
        u'Allowed-Rate-Information',
        u'Allowed-Rate',
        u'AllowedQueuingTime',
        u'AlphaValue',
        u'AlternativeFormatReportingIndicator',
        u'Angle-Of-Arrival-Value-LCR',
        u'ANR-Cell-Information',
        u'ANR-FDD-CellInformation',
        u'ANR-TDD-CellInformation',
        u'ANR-LCR-TDD-CellInformation',
        u'ANR-Multiple-PLMN-List',
        u'AOA-LCR',
        u'AOA-LCR-Accuracy-Class',
        u'AntennaColocationIndicator',
        u'BadSatellites',
        u'Band-Indicator',
        u'BCC',
        u'BCCH-ARFCN',
        u'BDS-IGPInfoList',
        u'BDS-IGPInfo',
        u'BDS-IonosphericGridModelReq',
        u'BDS-Ionospheric-Grid-Model',
        u'BetaCD',
        u'BindingID',
        u'BLER',
        u'BSIC',
        u'BundlingModeIndicator',
        u'BurstModeParameters',
        u'Cause',
        u'CauseMisc',
        u'CauseProtocol',
        u'CauseRadioNetwork',
        u'CauseTransport',
        u'CellBased',
        u'CellIdList',
        u'Cell-Id',
        u'CellCapabilityContainer-FDD',
        u'CellCapabilityContainerExtension-FDD',
        u'CellCapabilityContainer-TDD',
        u'CellCapabilityContainer-TDD-LCR',
        u'CellCapabilityContainerExtension-TDD-LCR',
        u'CellCapabilityContainer-TDD768',
        u'C-ID',
        u'CCTrCH-ID',
        u'Cell-Capacity-Class-Value',
        u'CellIndividualOffset',
        u'CellListValidityIndicator',
        u'CellParameterID',
        u'CellPortionID',
        u'CellPortionLCRID',
        u'CFN',
        u'CGI',
        u'ChannelCodingType',
        u'ChipOffset',
        u'CI',
        u'ClassmarkInformation2',
        u'ClassmarkInformation3',
        u'ClosedLoopMode1-SupportIndicator',
        u'Closedlooptimingadjustmentmode',
        u'CodingRate',
        u'CommonMeasurementAccuracy',
        u'CommonMeasurementType',
        u'CommonMeasurementValue',
        u'CommonMeasurementValueInformation',
        u'CommonMeasurementAvailable',
        u'CongestionCause',
        u'CommonTransportChannelResourcesInitialisationNotRequired',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDD',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationLCR',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR',
        u'Common-E-DCH-LogicalChannelInformation',
        u'Common-E-DCH-LogicalChannelInformationItem',
        u'Common-EDCH-Support-Indicator',
        u'Common-E-RGCH-Cell-Information',
        u'Common-E-RGCH-Cell-Info',
        u'Common-E-RGCH-De-Activation',
        u'CompleteAlmanacProvided',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response',
        u'CorrespondingCells',
        u'CoverageIndicator',
        u'CPC-Information',
        u'CPC-RecoveryReport',
        u'Continuous-Packet-Connectivity-HS-SCCH-less-Deactivate-Indicator',
        u'Counting-Information',
        u'Counting-Information-List',
        u'Counting-Result',
        u'CRC-Size',
        u'CriticalityDiagnostics',
        u'CriticalityDiagnostics-IE-List',
        u'CN-CS-DomainIdentifier',
        u'CN-PS-DomainIdentifier',
        u'CNDomainType',
        u'CQI-DTX-Timer',
        u'CQI-Cycle-Switch-Timer',
        u'ControlGAP',
        u'CQI-Feedback-Cycle',
        u'CQI-Feedback-Cycle2',
        u'CQI-Power-Offset',
        u'CQI-RepetitionFactor',
        u'C-RNTI',
        u'CodeRate',
        u'CodeRate-short',
        u'CPC-InformationLCR',
        u'ContinuousPacketConnectivity-DRX-InformationLCR',
        u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR',
        u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR',
        u'Controlled-Object-Scope',
        u'DATA-ID',
        u'DBDS-CorrectionsReq',
        u'DBDS-Corrections',
        u'DBDS-Info',
        u'DBDS-SignalInfoList',
        u'DBDS-SignalInfo',
        u'DBDS-InfoList',
        u'DCH-ENH-Information',
        u'DCH-ENH-Information-to-Modify',
        u'DL-FET-Mode',
        u'DCH-ENH-Concat',
        u'DCH-ENH-Information-Reconf',
        u'DCH-ENH-Information-Removal',
        u'DCH-FDD-Information',
        u'DCH-FDD-InformationItem',
        u'DCH-MeasurementOccasion-Information',
        u'DchMeasurementOccasionInformation-Item',
        u'Measurement-Occasion-Pattern-Sequence-parameters',
        u'DCH-MeasurementType-Indicator',
        u'DCH-Specific-FDD-InformationList',
        u'DCH-Specific-FDD-Item',
        u'DCH-Indicator-For-E-DCH-HSDPA-Operation',
        u'DCH-ID',
        u'DCH-InformationResponse',
        u'DCH-InformationResponseItem',
        u'DCH-TDD-Information',
        u'DCH-TDD-InformationItem',
        u'DCH-Specific-TDD-InformationList',
        u'DCH-Specific-TDD-Item',
        u'DecimationFactor',
        u'DedicatedMeasurementType',
        u'DedicatedMeasurementValue',
        u'DedicatedMeasurementValueInformation',
        u'DedicatedMeasurementAvailable',
        u'DedicatedMeasurementnotAvailable',
        u'DelayedActivation',
        u'DelayedActivationUpdate',
        u'Deactivate-Info',
        u'DeltaSIR',
        u'DGANSSCorrections',
        u'DGANSS-Corrections-Req',
        u'DGANSSThreshold',
        u'DGNSS-ValidityPeriod',
        u'DGPSCorrections',
        u'DGPSThreshold',
        u'DiscardTimer',
        u'DiversityControlField',
        u'DiversityMode',
        u'DL-TBS',
        u'DL-TBS-Value',
        u'DL-DPCH-SlotFormat',
        u'DL-DPCH-TimingAdjustment',
        u'DL-Power',
        u'DL-PowerBalancing-Information',
        u'DL-ReferencePowerInformationList',
        u'DL-ReferencePowerInformationItem',
        u'DL-PowerBalancing-ActivationIndicator',
        u'DL-PowerBalancing-UpdatedIndicator',
        u'DL-ReferencePowerInformation',
        u'D-RNTI',
        u'D-RNTI-ReleaseIndication',
        u'DL-ScramblingCode',
        u'DL-FrameType',
        u'DL-Timeslot-Information',
        u'DL-Timeslot-InformationItem',
        u'DL-TimeslotLCR-Information',
        u'DL-TimeslotLCR-InformationItem',
        u'DL-Timeslot-Information768',
        u'DL-Timeslot-InformationItem768',
        u'DL-TimeSlot-ISCP-Info',
        u'DL-TimeSlot-ISCP-InfoItem',
        u'DL-TimeSlot-ISCP-LCR-Information',
        u'DL-TimeSlot-ISCP-LCR-InfoItem',
        u'DL-TimeslotISCP',
        u'Downlink-Compressed-Mode-Method',
        u'Downlink-TPC-enhancements-Information',
        u'Downlink-TPC-enhancements-Reconf',
        u'Downlink-TPC-enhancements-Information-Removal',
        u'DPC-Mode',
        u'DPC-Mode-Change-SupportIndicator',
        u'DPCH-ID',
        u'DPCH-ID768',
        u'DPCHConstantValue',
        u'DRACControl',
        u'DRXCycleLengthCoefficient',
        u'DRX-Information',
        u'DRX-Information-to-Modify-LCR',
        u'DRX-Information-to-Modify-Items-LCR',
        u'DRX-Information-to-Modify',
        u'DRX-Information-to-Modify-Items',
        u'DSCH-RNTI',
        u'DSCH-FlowControlInformation',
        u'DSCH-FlowControlItem',
        u'DSCH-ID',
        u'DSCH-InitialWindowSize',
        u'DSCH-TDD-Information',
        u'DSCH-TDD-InformationItem',
        u'DsField',
        u'DTX-Cycle-2ms-Items',
        u'DTX-Cycle-2ms-to-Modify-Items',
        u'DTX-Cycle-10ms-Items',
        u'DTX-Cycle-10ms-to-Modify-Items',
        u'DTX-Information',
        u'DTX-Information2',
        u'DTX-Information-to-Modify',
        u'DTX-Information-to-Modify-Items',
        u'Dual-Cell-EDCH-Enhancements-Information',
        u'EARFCN',
        u'EARFCN-Extended',
        u'EARFCN-Information',
        u'Extension-EARFCN-Information',
        u'EARFCN-FDD',
        u'EARFCN-FDD-Extended',
        u'E-AGCH-DRX-Information-ResponseLCR',
        u'E-AGCH-DRX-Parameters-Response',
        u'E-AGCH-DRX-Information-LCR',
        u'E-AGCH-DRX-Parameters',
        u'E-AGCH-Table-Choice',
        u'E-AGCH-UE-Inactivity-Monitor-Threshold',
        u'ECGI',
        u'EDCH-Additional-RL-Specific-Information-Response-List',
        u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-List',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs',
        u'EDCH-DDI-Value',
        u'E-DCH-Decoupling-Indication',
        u'EDCH-FDD-DL-ControlChannelInformation',
        u'E-RGCH-E-HICH-ChannelisationCodeValidityIndicator',
        u'EDCH-FDD-Information',
        u'EDCH-FDD-InformationResponse',
        u'EDCH-MACdFlow-Specific-InformationResponse',
        u'EDCH-MACdFlow-Specific-InformationResponseItem',
        u'EDCH-FDD-Information-To-Modify',
        u'E-DCH-FDD-Update-Information',
        u'E-DCH-MACdFlow-Specific-UpdateInformation',
        u'E-DCH-MACdFlow-Specific-UpdateInformation-Item',
        u'E-DCH-DL-Control-Channel-Change-Information',
        u'E-DCH-DL-Control-Channel-Change-Information-Item',
        u'E-DCH-DL-Control-Channel-Grant-Information',
        u'E-DCH-DL-Control-Channel-Grant-Information-Item',
        u'E-DCH-Grant-Type-Information',
        u'E-DCH-HARQ-PO-FDD',
        u'E-DCH-LogicalChannelInformation',
        u'E-DCH-LogicalChannelInformationItem',
        u'E-DCH-Maximum-Bitrate',
        u'E-DCH-PowerOffset-for-SchedulingInfo',
        u'E-DCH-Processing-Overload-Level',
        u'E-DCH-Reference-Power-Offset',
        u'E-DCH-MACdPDU-SizeList',
        u'E-DCH-MACdPDU-SizeListItem',
        u'E-DCH-MACdPDUSizeFormat',
        u'E-DCH-LogicalChannelToModify',
        u'E-DCH-LogicalChannelToModifyItem',
        u'E-DCH-MACdPDU-SizeToModifyList',
        u'E-DCH-LogicalChannelToDelete',
        u'E-DCH-LogicalChannelToDeleteItem',
        u'EDCH-MACdFlow-ID',
        u'EDCH-MACdFlow-ID-LCR',
        u'EDCH-MACdFlows-Information',
        u'E-DCH-MACdFlow-Multiplexing-List',
        u'EDCH-MACdFlow-Specific-InfoList',
        u'EDCH-MACdFlow-Specific-InfoItem',
        u'EDCH-MACdFlow-Specific-InfoToModifyList',
        u'EDCH-MACdFlow-Specific-InfoToModifyItem',
        u'EDCH-MACdFlows-To-Delete',
        u'EDCH-MACdFlows-To-Delete-Item',
        u'EDCH-Reference-E-TFCI-Information',
        u'EDCH-Reference-E-TFCI-Information-Item',
        u'EDCH-Reference-E-TFCI-PO',
        u'EDCH-RL-Indication',
        u'E-DCH-Non-Scheduled-Transmission-Grant-Items',
        u'E-DCH-TFCI-Table-Index',
        u'E-DCH-Serving-cell-change-informationResponse',
        u'E-DCH-serving-cell-change-choice',
        u'E-DCH-serving-cell-change-successful',
        u'E-DCH-RL-InformationList-Rsp',
        u'E-DCH-RL-InformationList-Rsp-Item',
        u'E-DCH-serving-cell-change-unsuccessful',
        u'E-DCH-TTI-Length',
        u'E-DCH-TTI-Length-to-Modify',
        u'EDPCH-Information-FDD',
        u'EDPCH-Information-RLReconfPrepare-FDD',
        u'EDPCH-Information-RLReconfRequest-FDD',
        u'E-DPCCH-PO',
        u'Extended-E-DPCCH-PO',
        u'E-DPDCH-PowerInterpolation',
        u'E-Primary-Secondary-Grant-Selector',
        u'EHICH-SignatureSequence',
        u'E-RGCH-Release-Indicator',
        u'ERGCH-SignatureSequence',
        u'E-Serving-Grant-Value',
        u'E-RGCH-2-IndexStepThreshold',
        u'E-RGCH-3-IndexStepThreshold',
        u'EDCH-Serving-RL',
        u'EDCH-Serving-RL-in-this-DRNS',
        u'Enhanced-FACH-Information-ResponseFDD',
        u'Enhanced-FACH-Information-ResponseLCR',
        u'Enhanced-FACH-Support-Indicator',
        u'EnhancedHSServingCC-Abort',
        u'Enhanced-PCH-Capability',
        u'E-RNTI',
        u'E-ROCH-PowerOffset',
        u'E-TFCI',
        u'E-TFCI-BetaEC-Boost',
        u'E-TFCI-Boost-Information',
        u'E-TFCS-Information',
        u'E-DCH-Minimum-Set-E-TFCIValidityIndicator',
        u'E-TTI',
        u'E-AGCH-PowerOffset',
        u'E-RGCH-PowerOffset',
        u'E-HICH-PowerOffset',
        u'Enhanced-PrimaryCPICH-EcNo',
        u'EventA',
        u'EventB',
        u'EventC',
        u'EventD',
        u'EventE',
        u'EventF',
        u'EventH',
        u'Event1F-Parameters',
        u'Event1I-Parameters',
        u'ExtendedGSMCellIndividualOffset',
        u'E-DCH-Information',
        u'E-PUCH-Information',
        u'E-TFCS-Information-TDD',
        u'E-DCH-QPSK-RefBetaInfo',
        u'E-DCH-sixteenQAM-RefBetaInfo',
        u'E-DCH-RefBeta-Item',
        u'E-DCH-MACdFlows-Information-TDD',
        u'E-DCH-MACdFlow-InfoTDDItem',
        u'E-DCH-MACdFlow-Retransmission-Timer-LCR',
        u'E-DCH-HARQ-PO-TDD',
        u'E-DCH-Grant-TypeTDD',
        u'E-DCH-TimeslotResource',
        u'E-DCH-PowerResource',
        u'TddE-PUCH-Offset',
        u'E-DCH-TDD-Information',
        u'E-DCH-TDD-Maximum-Bitrate',
        u'E-DCH-Information-Reconfig',
        u'E-DCH-TDD-Information-to-Modify',
        u'E-DCH-TDD-Information-to-Modify-List',
        u'E-DCH-MACdFlow-ModifyTDDItem',
        u'E-DCH-Information-Response',
        u'E-DCH-TDD-MACdFlow-Specific-InformationResp',
        u'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item',
        u'E-AGCH-Specific-InformationRespListTDD',
        u'E-AGCH-Specific-InformationResp-ItemTDD',
        u'E-HICH-InformationResp',
        u'E-HICH-TimeOffset',
        u'E-DCH-Non-Scheduled-Grant-Info',
        u'E-DCH-768-Information',
        u'E-DCH-TDD-Information768',
        u'E-DCH-TDD-Maximum-Bitrate768',
        u'E-DCH-768-Information-Reconfig',
        u'E-DCH-768-Information-Response',
        u'E-AGCH-Specific-InformationRespList768TDD',
        u'E-AGCH-Specific-InformationResp-Item768TDD',
        u'E-HICH-InformationResp768',
        u'E-DCH-Non-Scheduled-Grant-Info768',
        u'E-DCH-LCR-Information',
        u'E-PUCH-LCR-Information',
        u'E-PUCH-PRXdesBase',
        u'E-DCH-LCR-TDD-Information',
        u'E-DCH-Physical-Layer-Category-LCR',
        u'Execution-Type',
        u'Extended-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'Extension-CommonMeasurementValue',
        u'Extension-DedicatedMeasurementValue',
        u'E-DCH-LCR-Information-Reconfig',
        u'E-DCH-LCR-Information-Response',
        u'E-AGCH-Specific-InformationRespList-LCR-TDD',
        u'E-AGCH-Specific-InformationResp-Item-LCR-TDD',
        u'E-HICH-Specific-InformationResp-LCR',
        u'E-HICH-Scheduled-InformationRespList-LCR-TDD',
        u'E-HICH-Scheduled-InformationResp-Item-LCR-TDD',
        u'E-HICH-EI',
        u'E-HICH-InformationResp-LCR',
        u'E-HICH-TimeOffset-LCR',
        u'E-DCH-SubframeNumber-LCR',
        u'E-DCH-TimeslotResource-LCR',
        u'E-DCH-Non-Scheduled-Grant-Info-LCR',
        u'Enabling-Delay',
        u'Ext-Reference-E-TFCI-PO',
        u'ExtendedPropagationDelay',
        u'Extended-RNC-ID',
        u'Extended-RNTI',
        u'Extended-Round-Trip-Time-Value',
        u'Extended-S-RNTI-Group',
        u'ExtendedAffectedUEInformationForMBMS',
        u'Ext-Max-Bits-MACe-PDU-non-scheduled',
        u'E-DCH-Semi-PersistentScheduling-Information-LCR',
        u'E-DCH-SPS-Indicator',
        u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'E-DCH-SPS-HICH-Information',
        u'E-HICH-Configuration',
        u'E-HICH-InformationResp-ExplicitConfiguration-LCR',
        u'FACH-FlowControlInformation',
        u'FACH-FlowControlInformationItem',
        u'FACH-InitialWindowSize',
        u'FACH-InformationList',
        u'FACH-InformationItem',
        u'Fast-Reconfiguration-Mode',
        u'Fast-Reconfiguration-Permission',
        u'Fast-TTI-switching-Mode-synchronized',
        u'Fast-TTI-switching-Mode-unsynchronized',
        u'Fast-TTI-switching-Mode-Supported',
        u'FDD-DCHs-to-Modify',
        u'FDD-DCHs-to-ModifyItem',
        u'FDD-DCHs-to-ModifySpecificInformationList',
        u'FDD-DCHs-to-ModifySpecificItem',
        u'FDD-DL-ChannelisationCodeNumber',
        u'FDD-DL-CodeInformation',
        u'FDD-DL-CodeInformationItem',
        u'FDD-TPC-DownlinkStepSize',
        u'SchedulingPriorityIndicator',
        u'F-DPCH-Info',
        u'F-DPCH-Info-To-Modify',
        u'F-DPCH-SlotFormat',
        u'F-DPCH-SlotFormatSupportRequest',
        u'FirstRLS-Indicator',
        u'FNReportingIndicator',
        u'FPACH-Information',
        u'FTPICH-Information',
        u'FTPICH-SlotFormat',
        u'FTPICH-Offset',
        u'FTPICH-Information-Removal',
        u'FTPICH-Information-To-Modify',
        u'FTPICH-Information-Reconf',
        u'FTPICH-Reconfiguration-Information',
        u'FTPICH-Information-Response',
        u'FrameHandlingPriority',
        u'FrameOffset',
        u'FrequencyBandIndicator',
        u'GapLength',
        u'GapDuration',
        u'GA-Cell',
        u'GA-CellAdditionalShapes',
        u'GA-AltitudeAndDirection',
        u'GA-EllipsoidArc',
        u'Gainfactors-10ms-mode',
        u'GANSS-AddClockModels',
        u'Extension-GANSS-AddClockModels',
        u'GANSS-AddIonoModelReq',
        u'GANSS-AddNavigationModelsReq',
        u'GANSS-AddOrbitModels',
        u'Extension-GANSS-AddOrbitModels',
        u'GANSS-AddUTCModelsReq',
        u'GANSS-Additional-Ionospheric-Model',
        u'GANSS-Additional-Navigation-Models',
        u'GANSS-Additional-Time-Models',
        u'GANSS-Additional-UTC-Models',
        u'Extension-GANSS-Additional-UTC-Models',
        u'GANSS-Almanac',
        u'Extension-GANSS-AlmanacModel',
        u'GANSS-alm-keplerianNAVAlmanac',
        u'GANSS-alm-KEPLERIANBDSALMANAC',
        u'GANSS-alm-keplerianReducedAlmanac',
        u'GANSS-alm-keplerianMidiAlmanac',
        u'GANSS-alm-keplerianGLONASS',
        u'GANSS-alm-ecefSBASAlmanac',
        u'GANSS-Auxiliary-Information',
        u'GANSS-AuxInfoGANSS-ID1',
        u'GANSS-AuxInfoGANSS-ID3',
        u'GANSS-AuxInfoReq',
        u'GANSS-BDSclockModel',
        u'GANSS-Clock-Model',
        u'GANSS-CNAVclockModel',
        u'GANSS-Common-Data',
        u'GANSS-CommonDataInfoReq',
        u'GANSS-Data-Bit-Assistance',
        u'GANSS-DataBitAssistanceList',
        u'GANSS-DataBitAssistanceItem',
        u'GANSS-DataBitAssistanceSgnList',
        u'GANSS-DataBitAssistanceSgnItem',
        u'GANSS-Data-Bit-Assistance-ReqItem',
        u'GANSS-Data-Bit-Assistance-ReqList',
        u'GANSS-Delta-T',
        u'GANSS-DeltaUT1',
        u'GANSS-Earth-Orientation-Parameters',
        u'GANSS-EarthOrientParaReq',
        u'GANSS-GenericDataInfoReqList',
        u'GANSS-GenericDataInfoReqItem',
        u'GANSS-Generic-Data',
        u'GANSS-Generic-DataItem',
        u'GANSS-GLONASSclockModel',
        u'GANSS-ID',
        u'GANSS-Information',
        u'GANSS-Ionospheric-Model',
        u'GANSS-IonosphereRegionalStormFlags',
        u'GANSS-NAVclockModel',
        u'GANSS-Navigation-Model-And-Time-Recovery',
        u'GANSS-NavModel-BDSKeplerianSet',
        u'GANSS-NavModel-CNAVKeplerianSet',
        u'GANSS-NavModel-GLONASSecef',
        u'GANSS-NavModel-NAVKeplerianSet',
        u'GANSS-NavModel-SBASecef',
        u'GANSS-Orbit-Model',
        u'GANSS-Real-Time-Integrity',
        u'GANSS-RX-Pos',
        u'GANSS-SatelliteInformationKP',
        u'Ganss-Sat-Info-AddNavList',
        u'GANSS-SAT-Info-Almanac-BDSkpList',
        u'GANSS-SAT-Info-Almanac-BDS',
        u'GANSS-SAT-Info-Almanac-GLOkpList',
        u'GANSS-SAT-Info-Almanac-MIDIkpList',
        u'GANSS-SAT-Info-Almanac-NAVkpList',
        u'GANSS-SAT-Info-Almanac-REDkpList',
        u'GANSS-SAT-Info-Almanac-SBASecefList',
        u'GANSS-Sat-Info-Nav',
        u'GANSS-SBAS-ID',
        u'GANSS-SBASclockModel',
        u'GANSS-Signal-ID',
        u'GANSS-StatusHealth',
        u'GANSS-Time-ID',
        u'GANSS-Time-Model',
        u'GANSS-Transmission-Time',
        u'GANSS-UTC-Model',
        u'GANSS-UTCmodelSet1',
        u'GANSS-UTCmodelSet2',
        u'GANSS-UTCmodelSet3',
        u'GANSS-UTCmodelSet4',
        u'GA-PointWithAltitude',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        u'GA-PointWithUnCertaintyEllipse',
        u'GA-UncertaintyEllipse',
        u'GA-PointWithUnCertainty',
        u'GA-AccessPointPosition',
        u'GeographicalCoordinate',
        u'GERAN-Cell-Capability',
        u'GERAN-Classmark',
        u'GERAN-SI-Type',
        u'GERAN-SystemInfo',
        u'GenericTrafficCategory',
        u'GPS-Almanac',
        u'Satellite-Almanac-Information-ExtItem',
        u'GPSInformation',
        u'GPS-Ionospheric-Model',
        u'GPS-NavigationModel-and-TimeRecovery',
        u'GPS-RealTime-Integrity',
        u'GPS-RX-POS',
        u'GPS-Status-Health',
        u'GPSTOW',
        u'GPS-UTC-Model',
        u'Guaranteed-Rate-Information',
        u'Guaranteed-Rate',
        u'HARQ-Info-for-E-DCH',
        u'HARQ-MemoryPartitioning',
        u'HARQ-MemoryPartitioning-Implicit',
        u'HARQ-MemoryPartitioning-Explicit',
        u'HARQ-MemoryPartitioningList',
        u'HARQ-MemoryPartitioningInfoExtForMIMO',
        u'HARQ-MemoryPartitioningItem',
        u'HARQ-Preamble-Mode',
        u'HARQ-Process-Allocation-2ms-EDCH',
        u'HARQ-Preamble-Mode-Activation-Indicator',
        u'HCS-Prio',
        u'HS-DSCH-Cell-List',
        u'HS-DSCH-Cell',
        u'HSDSCH-Configured-Indicator',
        u'HSDSCH-FDD-Information',
        u'HSDSCH-FDD-Information-Response',
        u'HS-DSCH-FDD-Secondary-Serving-Information',
        u'HS-DSCH-FDD-Secondary-Serving-Information-Response',
        u'HS-DSCH-Secondary-Serving-Information-To-Modify',
        u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised',
        u'HS-DSCH-FDD-Secondary-Serving-Update-Information',
        u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response',
        u'HS-DSCH-Secondary-Serving-cell-change-choice',
        u'HS-Secondary-Serving-cell-change-successful',
        u'HS-Secondary-Serving-cell-change-unsuccessful',
        u'HS-DSCH-Secondary-Serving-Remove',
        u'HSDSCH-Information-to-Modify',
        u'HSDSCH-Information-to-Modify-Unsynchronised',
        u'HSDSCH-MACdFlow-ID',
        u'HSDSCH-MACdFlow-Specific-InfoList',
        u'HSDSCH-MACdPDUSizeFormat',
        u'HSDSCH-MACdFlow-Specific-InfoItem',
        u'HSDSCH-MACdFlow-Specific-InfoList-Response',
        u'HSDSCH-MACdFlow-Specific-InfoItem-Response',
        u'HSDSCH-MACdFlow-Specific-InfoList-to-Modify',
        u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify',
        u'HSDSCH-MACdFlows-Information',
        u'HSDSCH-MACdFlows-to-Delete',
        u'HSDSCH-MACdFlows-to-Delete-Item',
        u'HSDSCH-Initial-Capacity-Allocation',
        u'HSDSCH-Initial-Capacity-AllocationItem',
        u'HSDSCH-InitialWindowSize',
        u'HSDSCH-PreconfigurationInfo',
        u'Additional-EDCH-Preconfiguration-Information',
        u'Additional-EDCH-Preconfiguration-Information-ItemIEs',
        u'HSDSCH-PreconfigurationSetup',
        u'HS-SCCH-PreconfiguredCodes',
        u'HS-SCCH-PreconfiguredCodesItem',
        u'HS-SCCH-CodeNumber',
        u'HSDSCH-RNTI',
        u'HS-DSCH-serving-cell-change-information',
        u'HS-DSCH-serving-cell-change-informationResponse',
        u'HS-DSCH-serving-cell-change-choice',
        u'HSDSCH-TBSizeTableIndicator',
        u'HS-serving-cell-change-successful',
        u'HS-serving-cell-change-unsuccessful',
        u'HSPDSCH-First-Code-Index',
        u'HSPDSCH-Second-Code-Index',
        u'HSPDSCH-Second-Code-Support',
        u'HSDSCH-TDD-Information',
        u'HSDSCH-TDD-Information-Response',
        u'Multicarrier-Number',
        u'HSPDSCH-TDD-Specific-InfoList-Response',
        u'HSPDSCH-TDD-Specific-InfoItem-Response',
        u'HSPDSCH-TDD-Specific-InfoList-Response-LCR',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR',
        u'HSPDSCH-TDD-Specific-InfoList-Response768',
        u'HSPDSCH-TDD-Specific-InfoItem-Response768',
        u'HS-SCCH-DRX-Information-LCR',
        u'HS-SCCH-DRX-Information-ResponseLCR',
        u'HSSCCH-FDD-Specific-InfoList-Response',
        u'HSSCCH-FDD-Specific-InfoItem-Response',
        u'HSSCCH-PowerOffset',
        u'HSSCCH-TDD-Specific-InfoList-Response',
        u'HSSCCH-TDD-Specific-InfoItem-Response',
        u'HSSCCH-TDD-Specific-InfoList-Response-LCR',
        u'HSSCCH-TDD-Specific-InfoItem-Response-LCR',
        u'HSSCCH-TDD-Specific-InfoList-Response768',
        u'HSSCCH-TDD-Specific-InfoItem-Response768',
        u'HSSICH-Info',
        u'HSSICH-InfoLCR',
        u'HSSICH-Info768',
        u'HS-SICH-Reception-Quality-Value',
        u'HS-SICH-failed',
        u'HS-SICH-missed',
        u'HS-SICH-total',
        u'HS-SICH-Reception-Quality-Measurement-Value',
        u'HS-SICH-ID',
        u'HS-SICH-ID-Extension',
        u'HSSCCH-CodeChangeIndicator',
        u'HSSCCH-Code-Change-Grant',
        u'HS-PDSCH-Code-Change-Indicator',
        u'HS-PDSCH-Code-Change-Grant',
        u'HSDSCH-FDD-Update-Information',
        u'HSDSCH-TDD-Update-Information',
        u'MIMO-ReferenceSignal-InformationListLCR',
        u'HSSICH-ReferenceSignal-InformationLCR',
        u'HS-DSCH-Semi-PersistentScheduling-Information-LCR',
        u'HSDSCH-Physical-Layer-Category',
        u'Transport-Block-Size-List-LCR',
        u'Transport-Block-Size-Item-LCR',
        u'Transport-Block-Size-maping-Index-LCR',
        u'Transport-Block-Size-Index-LCR',
        u'TS0-HS-PDSCH-Indication-LCR',
        u'Repetition-Period-List-LCR',
        u'Repetition-Period-Item-LCR',
        u'RepetitionPeriodIndex',
        u'SPS-Reservation-Indicator',
        u'HS-DSCH-SPS-Operation-Indicator',
        u'LogicalChannellevel',
        u'PriorityQueuelevel',
        u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR',
        u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR',
        u'HS-SICH-InformationList-for-HS-DSCH-SPS',
        u'HS-SICH-InformationItem-for-HS-DSCH-SPS',
        u'HS-SICH-Mapping-Index',
        u'HS-SICH-Type',
        u'HS-SCCH-Associated-HS-SICH',
        u'Non-HS-SCCH-Associated-HS-SICH',
        u'Non-HS-SCCH-Aassociated-HS-SICH-ID',
        u'Initial-HS-PDSCH-SPS-Resource',
        u'HS-DSCH-TimeslotResourceLCR',
        u'ModulationSPS-LCR',
        u'Number-of-Processes-for-HS-DSCH-SPS',
        u'IMEI',
        u'IMEISV',
        u'IMSI',
        u'Implicit-Grant-Handling',
        u'Improved-Synchronized-Indicator',
        u'Inactivity-Threshold-for-UE-DRX-Cycle-LCR',
        u'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext',
        u'Inactivity-Threshold-for-UE-DTX-Cycle2',
        u'Inactivity-Threshold-for-UE-DRX-Cycle',
        u'Inactivity-Threshold-for-UE-Grant-Monitoring',
        u'InformationAvailable',
        u'InformationExchangeID',
        u'InformationNotAvailable',
        u'InformationReportCharacteristics',
        u'InformationReportPeriodicity',
        u'InformationThreshold',
        u'InformationType',
        u'Initial-E-DCH-SPS-resource',
        u'Initial-DL-DPCH-TimingAdjustment-Allowed',
        u'InnerLoopDLPCStatus',
        u'IPDLParameters',
        u'Extension-IPDLParameters',
        u'Inter-Frequency-Cell-List',
        u'Inter-Frequency-Cell',
        u'Inter-Frequency-Cell-Information',
        u'Inter-Frequency-Cell-Information-SIB11',
        u'Inter-Frequency-Cell-Information-SIB12',
        u'Inter-Frequency-Cell-Information-SIB11ter',
        u'Inter-Frequency-Cells-Information-SIB11-Per-Indication',
        u'Inter-Frequency-Cells-Information-SIB12-Per-Indication',
        u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication',
        u'Inter-Frequency-Cell-SIB11ter-List',
        u'Inter-Frequency-Cell-SIB11ter',
        u'InterFrequencyCellID-Ext',
        u'Inter-Frequency-Cell-Indication',
        u'Inter-Frequency-Cell-SIB11-or-SIB12-List',
        u'Inter-Frequency-Cell-SIB11-or-SIB12',
        u'InterFrequencyCellID',
        u'InterStream-Interference-Compensation',
        u'IPDL-FDD-Parameters',
        u'IPDL-TDD-Parameters',
        u'IPDL-TDD-ParametersLCR',
        u'IPLength',
        u'IPMulticastAddress',
        u'IPOffset',
        u'IP-P-CCPCH',
        u'IPSlot',
        u'IPSpacingFDD',
        u'IPSpacingTDD',
        u'IPStart',
        u'IPSub',
        u'IdleIntervalInformation',
        u'LABased',
        u'LAI-List',
        u'LAC',
        u'LAI',
        u'LimitedPowerIncrease',
        u'List-Of-PLMNs',
        u'L3-Information',
        u'Load-Value-IncrDecrThres',
        u'Load-Value',
        u'LoadValue',
        u'LCRTDD-Uplink-Physical-Channel-Capability',
        u'LogicalChannelID',
        u'M1Report',
        u'M2Report',
        u'MDT-Activation',
        u'MDTAreaScope',
        u'MDT-Configuration',
        u'MDT-Report-Parameters',
        u'MeasurementQuantity',
        u'MaxNrOfUL-DPCHs',
        u'MAC-c-sh-SDU-Length',
        u'MAC-c-sh-SDU-LengthList',
        u'MAC-DTX-Cycle-2ms',
        u'MAC-DTX-Cycle-10ms',
        u'MAC-ehs-Reset-Timer',
        u'MAC-Inactivity-Threshold',
        u'MACdPDU-Size',
        u'MAC-PDU-SizeExtended',
        u'MACdPDU-Size-IndexList',
        u'MACdPDU-Size-IndexItem',
        u'MACdPDU-Size-IndexList-to-Modify',
        u'MACdPDU-Size-IndexItem-to-Modify',
        u'MACes-Guaranteed-Bitrate',
        u'MACes-Maximum-Bitrate-LCR',
        u'MACeReset-Indicator',
        u'MAChsGuaranteedBitRate',
        u'MAChsReorderingBufferSize-for-RLC-UM',
        u'MAC-hsWindowSize',
        u'MAChsResetScheme',
        u'MaximumAllowedULTxPower',
        u'Max-Bits-MACe-PDU-non-scheduled',
        u'MaxNrDLPhysicalchannels',
        u'MaxNrDLPhysicalchannels768',
        u'MaxNrDLPhysicalchannelsTS',
        u'MaxNrDLPhysicalchannelsTS768',
        u'MaxNr-Retransmissions-EDCH',
        u'MaxNrTimeslots',
        u'MaxNrULPhysicalchannels',
        u'Max-Set-E-DPDCHs',
        u'Max-UE-DTX-Cycle',
        u'MBMS-Bearer-Service-Full-Address',
        u'MBMS-Bearer-Service-List',
        u'MBMS-Bearer-ServiceItemFDD',
        u'MBMS-Bearer-ServiceItemFDD-PFL',
        u'MBMS-Bearer-ServiceItemTDD',
        u'MBMS-Bearer-ServiceItemTDD-PFL',
        u'MBMSChannelTypeInfo',
        u'MBMSChannelTypeCellList',
        u'MBMSPreferredFreqLayerInfo',
        u'MBMS-Neighbouring-Cell-Information',
        u'MBMS-ConcatenatedServiceList',
        u'MBMS-RLC-Sequence-Number-Information',
        u'MBMS-RLC-Sequence-Number-Information-List',
        u'MBMS-Bearer-Service-List-RLC',
        u'MBMS-Bearer-Service-List-RLCinfo',
        u'MBSFN-Cluster-Identity',
        u'MCCH-Message-List',
        u'MCCH-Configuration-Info',
        u'Secondary-CCPCH-System-Information-MBMS',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Info-List',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Item',
        u'MbsfnSchedulingTransmissionTimeInterval',
        u'MeasurementFilterCoefficient',
        u'MeasurementID',
        u'Measurement-Power-Offset',
        u'MinimumSpreadingFactor',
        u'MinimumSpreadingFactor768',
        u'Minimum-TEBS-threshold',
        u'MultipleURAsIndicator',
        u'MaxAdjustmentStep',
        u'MeasurementChangeTime',
        u'MeasurementHysteresisTime',
        u'MeasurementIncreaseDecreaseThreshold',
        u'Extension-MeasurementIncreaseDecreaseThreshold',
        u'MeasurementRecoveryBehavior',
        u'MeasurementRecoveryReportingIndicator',
        u'MeasurementRecoverySupportIndicator',
        u'MeasurementThreshold',
        u'MessageStructure',
        u'Extension-MeasurementThreshold',
        u'MidambleConfigurationBurstType1And3',
        u'MidambleConfigurationBurstType2',
        u'MidambleConfigurationLCR',
        u'MidambleShiftAndBurstType',
        u'MidambleShiftLong',
        u'MidambleShiftShort',
        u'MidambleShiftLCR',
        u'MidambleAllocationMode',
        u'MidambleShiftAndBurstType768',
        u'MidambleConfigurationBurstType2-768',
        u'MidambleShiftShort768',
        u'MIMO-ActivationIndicator',
        u'MIMO-InformationResponse',
        u'MIMO-Mode-Indicator',
        u'MIMO-N-M-Ratio',
        u'MIMO-PilotConfiguration',
        u'MIMO-S-CPICH-Channelisation-Code',
        u'MIMO-withfourtransmitantennas-ActivationIndicator',
        u'MIMO-withfourtransmitantennas-ModeIndicator',
        u'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator',
        u'DualStream-MIMO-withfourtransmitantennas-ModeIndicator',
        u'Additional-Associated-Secondary-CPICH',
        u'Additional-Secondary-CPICH',
        u'MinUL-ChannelisationCodeLength',
        u'MinimumReducedE-DPDCH-GainFactor',
        u'ModifyPriorityQueue',
        u'Modulation',
        u'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory',
        u'Multicell-EDCH-Transport-Bearer-Mode',
        u'MulticellEDCH-Information',
        u'MulticellEDCH-InformationItemIEs',
        u'MulticellEDCH-RL-SpecificInformation',
        u'MulticellEDCH-RL-SpecificInformationItemIEs',
        u'Multicell-EDCH-Restriction',
        u'Multiple-PLMN-List',
        u'MultiplexingPosition',
        u'MAChs-ResetIndicator',
        u'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR',
        u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR',
        u'MIMO-SFMode-For-HSPDSCHDualStream',
        u'Multi-Carrier-EDCH-Info',
        u'Multicarrier-EDCH-Transport-Bearer-Mode',
        u'Multi-Carrier-EDCH-Information',
        u'Multi-Carrier-EDCH-LCR-InformationItem',
        u'SNPL-Carrier-Group-Indicator',
        u'Multi-Carrier-EDCH-MACdFlows-Information-TDD',
        u'Multi-Carrier-EDCH-MACdFlows-Specific-Info',
        u'Multi-Carrier-EDCH-Reconfigure',
        u'Continue-Setup-Change-Multi-Carrier-EDCH',
        u'Multi-Carrier-EDCH-Change-Info',
        u'Multi-Carrier-EDCH-Information-Removal-List',
        u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs',
        u'Multi-Carrier-EDCH-Information-Response',
        u'Multi-Carrier-EDCH-LCR-Information-ResponseItem',
        u'Multiflow-Reconfiguration',
        u'Multiflow-Information',
        u'Multiflow-Information-To-Modify',
        u'Multiflow-RepetitionFactors',
        u'Multiflow-Stop',
        u'Multiflow-Mode',
        u'Multiflow-MIMO',
        u'Multiflow-Timing',
        u'Multiflow-OrdinalNumberOfFrequency',
        u'MU-MIMO-InformationLCR',
        u'MU-MIMO-Operation',
        u'MU-MIMO-Usage-Indicator',
        u'Standalone-Midamble-Channel-Information',
        u'Standalone-Midamble-Configuration',
        u'Standalone-MidambleShift',
        u'Standalone-Midamble-RepetitionPeriod',
        u'Standalone-Midamble-Offset',
        u'ReferenceBeta',
        u'Mode1-Ind',
        u'MU-MIMO-Indicator',
        u'NACC-Related-Data',
        u'Nack-Power-Offset',
        u'NCC',
        u'Neighbouring-UMTS-CellInformation',
        u'Neighbouring-UMTS-CellInformation-Ext',
        u'Neighbouring-UMTS-CellInformationExtensionItem',
        u'Neighbouring-UMTS-CellInformationItem',
        u'Neighbouring-FDD-CellInformation',
        u'Neighbouring-FDD-CellInformationItem',
        u'MultipleFrequencyBandsIndicatorList',
        u'NeighbouringFDDCellMeasurementInformation',
        u'Neighbouring-GSM-CellInformation',
        u'Neighbouring-GSM-CellInformationIEs',
        u'Neighbouring-GSM-CellInformationItem',
        u'Neighbouring-TDD-CellInformation',
        u'Neighbouring-TDD-CellInformationItem',
        u'NeighbouringTDDCellMeasurementInformation',
        u'NeighbouringTDDCellMeasurementInformationLCR',
        u'NeighbouringTDDCellMeasurementInformation768',
        u'Neighbouring-LCR-TDD-CellInformation',
        u'Neighbouring-LCR-TDD-CellInformationItem',
        u'Neighbouring-E-UTRA-CellInformation',
        u'Neighbouring-E-UTRA-CellInformationItem',
        u'MultipleFrequencyBandsIndicatorList-EUTRA',
        u'RadioFrequencyBandEUTRA',
        u'NonCellSpecificTxDiversity',
        u'Non-rectangular-resource-allocation-indicator',
        u'Non-rectangular-resource-timeslot-set',
        u'NotProvidedCellList',
        u'NrOfDLchannelisationcodes',
        u'NrOfTransportBlocks',
        u'NRT-Load-Information-Value-IncrDecrThres',
        u'NRT-Load-Information-Value',
        u'NRTLoadInformationValue',
        u'N-E-UCCH',
        u'N-E-UCCH-LCR',
        u'Number-Of-Supported-Carriers',
        u'NumHS-SCCH-Codes',
        u'NoOfTargetCellHS-SCCH-Order',
        u'Non-Serving-RL-Preconfig-Setup',
        u'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup',
        u'New-non-serving-RL-setup-selection',
        u'Non-Serving-RL-Preconfig-Info',
        u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList',
        u'NeedforIdleInterval',
        u'OnModification',
        u'OnModificationInformation',
        u'OrdinalNumberOfFrequency',
        u'Out-of-Sychronization-Window',
        u'PagingCause',
        u'PagingRecordType',
        u'PartialReportingIndicator',
        u'Pattern-Sequence-Identifier',
        u'PayloadCRC-PresenceIndicator',
        u'PCCPCH-Power',
        u'PCH-InformationList',
        u'PCH-InformationItem',
        u'PC-Preamble',
        u'PCI',
        u'Periodic',
        u'PeriodicInformation',
        u'Permanent-NAS-UE-Identity',
        u'Phase-Reference-Update-Indicator',
        u'PLCCHsequenceNumber',
        u'PLMN-Identity',
        u'PLMN-List',
        u'PowerAdjustmentType',
        u'PowerOffset',
        u'PowerOffsetForSecondaryCPICHforMIMO',
        u'PowerOffsetForSecondaryCPICHforMIMORequestIndicator',
        u'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas',
        u'Associated-Secondary-CPICH',
        u'CommonPhysicalChannelID',
        u'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator',
        u'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas',
        u'PRC',
        u'PRCDeviation',
        u'Pre-emptionCapability',
        u'Pre-emptionVulnerability',
        u'Precoder-Weight-Set-Restriction',
        u'PredictedSFNSFNDeviationLimit',
        u'PredictedTUTRANGPSDeviationLimit',
        u'PreferredFrequencyLayerInfo',
        u'PrimaryCPICH-Power',
        u'PrimaryCPICH-EcNo',
        u'Primary-CPICH-Usage-For-Channel-Estimation',
        u'PrimaryCCPCH-RSCP',
        u'PrimaryCCPCH-RSCP-Delta',
        u'PrimaryScramblingCode',
        u'PriorityLevel',
        u'PriorityQueue-Id',
        u'PriorityQueue-InfoList',
        u'PriorityQueue-InfoItem',
        u'PriorityQueue-InfoList-EnhancedFACH-PCH',
        u'PriorityQueue-InfoItem-EnhancedFACH-PCH',
        u'PriorityQueue-InfoList-to-Modify',
        u'PriorityQueue-InfoItem-to-Add',
        u'PriorityQueue-InfoItem-to-Modify',
        u'PriorityQueue-InfoList-to-Modify-Unsynchronised',
        u'PriorityQueue-InfoItem-to-Modify-Unsynchronised',
        u'PropagationDelay',
        u'ProvidedInformation',
        u'UpPCH-InformationList-LCRTDD',
        u'UpPCH-InformationItem-LCRTDD',
        u'PunctureLimit',
        u'PTMCellList',
        u'PTPCellList',
        u'QE-Selector',
        u'Process-Memory-Size',
        u'RABased',
        u'Radio-Links-without-DPCH-FDPCH-Indication',
        u'Radio-Links-without-DPCH-FDPCH-Information',
        u'RAI-List',
        u'ReportInterval',
        u'ReportAmount',
        u'RAC',
        u'RAI',
        u'RANAP-EnhancedRelocationInformationRequest',
        u'RANAP-EnhancedRelocationInformationResponse',
        u'RANAP-RelocationInformation',
        u'Range-Correction-Rate',
        u'RateMatchingAttribute',
        u'RB-Identity',
        u'RB-Info',
        u'Received-Total-Wideband-Power-Value',
        u'Received-Total-Wideband-Power-Value-IncrDecrThres',
        u'Reference-E-TFCI-Information',
        u'Reference-E-TFCI-Information-Item',
        u'Reference-E-TFCI-PO',
        u'RefTFCNumber',
        u'Released-CN-Domain',
        u'RepetitionLength',
        u'RepetitionPeriod',
        u'RepetitionNumber0',
        u'RepetitionNumber1',
        u'ReportCharacteristics',
        u'Extension-ReportCharacteristics',
        u'ReportPeriodicity',
        u'RequestedDataValue',
        u'RequestedDataValueInformation',
        u'RestrictionStateIndicator',
        u'RL-ID',
        u'RL-Set-ID',
        u'RL-Specific-DCH-Info',
        u'RL-Specific-DCH-Info-Item',
        u'RL-Specific-EDCH-Information',
        u'RL-Specific-EDCH-Info',
        u'RL-Specific-EDCH-InfoItem',
        u'RLC-Mode',
        u'DL-RLC-PDU-Size-Format',
        u'RLC-Sequence-Number',
        u'RNC-ID',
        u'RNTI-Allocation-Indicator',
        u'Round-Trip-Time-IncrDecrThres',
        u'Round-Trip-Time-Value',
        u'RSCP-Value',
        u'RSCP-Value-IncrDecrThres',
        u'Received-total-wide-band-power',
        u'RT-Load-Value-IncrDecrThres',
        u'RT-Load-Value',
        u'RTLoadValue',
        u'RxTimingDeviationForTA',
        u'RxTimingDeviationForTAext',
        u'RxTimingDeviationForTA768',
        u'Rx-Timing-Deviation-Value',
        u'Rx-Timing-Deviation-Value-ext',
        u'Rx-Timing-Deviation-Value-LCR',
        u'Rx-Timing-Deviation-Value-768',
        u'RefBeta',
        u'SAC',
        u'SAI',
        u'Same-As-Scheduled-E-HICH',
        u'SAT-ID',
        u'SCH-TimeSlot',
        u'ScaledAdjustmentRatio',
        u'SchedulingInformation',
        u'SCTD-Indicator',
        u'SDPCCH-PowerOffsetInformation',
        u'SecondaryServingCells',
        u'SecondaryServingCellsItem',
        u'Secondary-CCPCH-Info-TDD',
        u'Secondary-CPICH-Information',
        u'Secondary-CPICH-Information-Change',
        u'Secondary-LCR-CCPCH-Info-TDD',
        u'Secondary-CCPCH-Info-TDD768',
        u'Secondary-CCPCH-TDD-InformationList',
        u'Secondary-CCPCH-TDD-InformationItem',
        u'Secondary-LCR-CCPCH-TDD-InformationList',
        u'Secondary-LCR-CCPCH-TDD-InformationItem',
        u'Secondary-CCPCH-TDD-InformationList768',
        u'Secondary-CCPCH-TDD-InformationItem768',
        u'Secondary-CCPCH-TDD-Code-Information',
        u'Secondary-CCPCH-TDD-Code-InformationItem',
        u'Secondary-LCR-CCPCH-TDD-Code-Information',
        u'Secondary-LCR-CCPCH-TDD-Code-InformationItem',
        u'Secondary-CCPCH-TDD-Code-Information768',
        u'Secondary-CCPCH-TDD-Code-InformationItem768',
        u'Secondary-Serving-Cell-List',
        u'Possible-Secondary-Serving-Cell-List',
        u'Possible-Secondary-Serving-Cell',
        u'SecondInterleavingMode',
        u'Secondary-UL-Frequency-Activation-State',
        u'S-E-DPCCH-PowerOffset',
        u'Seed',
        u'Service-ID',
        u'S-E-ROCH-Release-Indicator',
        u'SetsOfHS-SCCH-Codes',
        u'SetsOfHS-SCCH-CodesItem',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH',
        u'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2',
        u'SFN',
        u'SFNSFN-FDD',
        u'SFNSFN-TDD',
        u'SFNSFN-TDD768',
        u'GA-AccessPointPositionwithOptionalAltitude',
        u'SFNSFNChangeLimit',
        u'SFNSFNDriftRate',
        u'SFNSFNDriftRateQuality',
        u'SFNSFNMeasurementThresholdInformation',
        u'SFNSFNMeasurementValueInformation',
        u'SFNSFNQuality',
        u'SFNSFNTimeStampInformation',
        u'SFNSFNTimeStamp-TDD',
        u'SFNSFNValue',
        u'SID',
        u'Single-Stream-MIMO-ActivationIndicator',
        u'Single-Stream-MIMO-Mode-Indicator',
        u'SIR-Error-Value',
        u'SIR-Error-Value-IncrDecrThres',
        u'SIR-Value',
        u'SIR-Value-IncrDecrThres',
        u'SixteenQAM-UL-Operation-Indicator',
        u'SixtyfourQAM-UL-Operation-Indicator',
        u'SixtyfourQAM-UsageAllowedIndicator',
        u'SixtyfourQAM-DL-SupportIndicator',
        u'SixtyfourQAM-DL-UsageIndicator',
        u'SignatureSequenceGroupIndex',
        u'SNA-Information',
        u'ListOfSNAs',
        u'SNACode',
        u'SourceID',
        u'SpecialBurstScheduling',
        u'SpeechVersion',
        u'S-RNTI',
        u'S-RNTI-Group',
        u'SRB-Delay',
        u'SSDT-SupportIndicator',
        u'Standalone-Midamble-Channel-Indicator',
        u'Status-Flag',
        u'STTD-SupportIndicator',
        u'Support-8PSK',
        u'Support-PLCCH',
        u'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order',
        u'SyncCase',
        u'SynchronisationConfiguration',
        u'SYNC-UL-ProcParameters',
        u'T1',
        u'TAC',
        u'TargetID',
        u'TDD-AckNack-Power-Offset',
        u'TDD-ChannelisationCode',
        u'TDD-ChannelisationCode768',
        u'TDD-ChannelisationCodeLCR',
        u'TDD-DCHs-to-Modify',
        u'TDD-DCHs-to-ModifyItem',
        u'TDD-DCHs-to-ModifySpecificInformationList',
        u'TDD-DCHs-to-ModifySpecificItem',
        u'TDD-DL-Code-Information',
        u'TDD-DL-Code-InformationItem',
        u'TDD-DL-Code-LCR-Information',
        u'TDD-DL-Code-LCR-InformationItem',
        u'TDD-DL-Code-Information768',
        u'TDD-DL-Code-InformationItem768',
        u'TDD-DL-DPCH-TimeSlotFormat-LCR',
        u'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        u'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR',
        u'TDD-DPCHOffset',
        u'TDD-PhysicalChannelOffset',
        u'TDD-TPC-DownlinkStepSize',
        u'TDD-TPC-UplinkStepSize-LCR',
        u'TDD-UL-Code-Information',
        u'TDD-UL-Code-InformationItem',
        u'TDD-UL-Code-LCR-Information',
        u'TDD-UL-Code-LCR-InformationItem',
        u'TDD-UL-Code-Information768',
        u'TDD-UL-Code-InformationItem768',
        u'TDD-UL-DPCH-TimeSlotFormat-LCR',
        u'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        u'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR',
        u'TFCI-Coding',
        u'TFCI-Presence',
        u'TFCI-SignallingMode',
        u'TGD',
        u'TGPRC',
        u'TGPSID',
        u'TGSN',
        u'TimeSlot',
        u'TimeSlotLCR',
        u'Time-Stamp',
        u'TimingAdvanceApplied',
        u'SynchronisationIndicator',
        u'TMGI',
        u'TnlQos',
        u'ToAWE',
        u'ToAWS',
        u'TraceDepth',
        u'TraceRecordingSessionReference',
        u'TraceReference',
        u'TrafficClass',
        u'Transmission-Gap-Pattern-Sequence-Information',
        u'Transmission-Gap-Pattern-Sequence-ScramblingCode-Information',
        u'Transmission-Gap-Pattern-Sequence-Status-List',
        u'Affected-HSDSCH-Serving-Cell-List',
        u'TransmissionMode',
        u'Transmission-Mode-Information',
        u'Transmission-Mode-Information-List',
        u'TransmissionTimeIntervalDynamic',
        u'TransmissionTimeIntervalSemiStatic',
        u'TransmitDiversityIndicator',
        u'Transmitted-Carrier-Power-Value',
        u'Transmitted-Carrier-Power-Value-IncrDecrThres',
        u'Transport-Block-Size-Index',
        u'TUTRANGANSS',
        u'TUTRANGANSSAccuracyClass',
        u'TUTRANGANSSMeasurementThresholdInformation',
        u'TUTRANGANSSMeasurementValueInformation',
        u'TUTRANGPS',
        u'TUTRANGPSChangeLimit',
        u'TUTRANGPSDriftRate',
        u'TUTRANGPSDriftRateQuality',
        u'TUTRANGPSAccuracyClass',
        u'TUTRANGPSMeasurementThresholdInformation',
        u'TUTRANGPSMeasurementValueInformation',
        u'TUTRANGPSQuality',
        u'TransportBearerID',
        u'TransportBearerRequestIndicator',
        u'TransportBearerNotRequestedIndicator',
        u'TransportBearerNotSetupIndicator',
        u'TransportBlockSize',
        u'TransportFormatCombination-Beta',
        u'TFCS',
        u'TFCS-TFCSList',
        u'TFCS-CTFC',
        u'TPC-slot-position',
        u'TransportFormatSet',
        u'TransportFormatSet-DynamicPartList',
        u'TransportFormatSet-ModeDP',
        u'TDD-TransportFormatSet-ModeDP',
        u'TransmissionTimeIntervalInformation',
        u'Transmitted-Code-Power-Value',
        u'Transmitted-Code-Power-Value-IncrDecrThres',
        u'TransportFormatManagement',
        u'TransportFormatSet-Semi-staticPart',
        u'TransportFormatSet-ModeSSP',
        u'TransportLayerAddress',
        u'TrCH-SrcStatisticsDescr',
        u'TSN-Length',
        u'TSTD-Indicator',
        u'TSTD-Support-Indicator',
        u'TTI-Update-Indicator',
        u'TTI-Update-Ind',
        u'TxDiversityIndicator',
        u'TypeOfError',
        u'UARFCN',
        u'UDRE',
        u'UDREGrowthRate',
        u'UDREValidityTime',
        u'UE-AggregateMaximumBitRate',
        u'UE-AggregateMaximumBitRateDownlink',
        u'UE-AggregateMaximumBitRateUplink',
        u'UE-AggregateMaximumBitRate-Enforcement-Indicator',
        u'UE-Capabilities-Info',
        u'UE-Support-of-non-rectangular-resource-allocation',
        u'UE-TS0-CapabilityLCR',
        u'UE-RF-Band-CapabilityLCR',
        u'Radio-Frequency-BandItem',
        u'Radio-Frequency-Band',
        u'LCRTDD-HSDSCH-Physical-Layer-Category',
        u'UE-DPCCH-burst1',
        u'UE-DPCCH-burst2',
        u'UE-DRX-Cycle-LCR',
        u'UE-DRX-Offset-LCR',
        u'UE-DRX-Cycle',
        u'UE-DRX-Grant-Monitoring',
        u'UE-DTX-Cycle1-2ms',
        u'UE-DTX-Cycle1-10ms',
        u'UE-DTX-Cycle2-2ms',
        u'UE-DTX-Cycle2-ext-2ms',
        u'UE-DTX-Cycle2-10ms',
        u'UE-DTX-DRX-Offset',
        u'UE-DTX-Long-Preamble',
        u'UEIdentity',
        u'UEMeasurementHysteresisTime',
        u'UEMeasurementParameterModAllow',
        u'UEMeasurementReportCharacteristics',
        u'UEMeasurementReportCharacteristicsEvent1h',
        u'UEMeasurementReportCharacteristicsEvent1i',
        u'UEMeasurementReportCharacteristicsEvent6a',
        u'UEMeasurementReportCharacteristicsEvent6b',
        u'UEMeasurementReportCharacteristicsEvent6c',
        u'UEMeasurementReportCharacteristicsEvent6d',
        u'UEMeasurementReportCharacteristicsPeriodic',
        u'UEMeasurementReportCharacteristicsPeriodicAmountofReporting',
        u'UEMeasurementReportCharacteristicsPeriodicReportingInterval',
        u'UEMeasurementReportCharacteristics-Extension',
        u'UEMeasurementThreshold',
        u'UEMeasurementThresholdDLTimeslotISCP',
        u'UEMeasurementThresholdUETransmitPower',
        u'UEMeasurementThreshold-Extension',
        u'UEMeasurementTimeslotInfoHCR',
        u'UEMeasurementTimeslotInfoHCR-IEs',
        u'UEMeasurementTimeslotInfoHCRBurstType',
        u'UEMeasurementTimeslotInfoLCR',
        u'UEMeasurementTimeslotInfoLCR-IEs',
        u'UEMeasurementTimeslotInfo768',
        u'UEMeasurementTimeslotInfo768-IEs',
        u'UEMeasurementTimeslotInfo768BurstType',
        u'UEMeasurementTimeToTrigger',
        u'UEMeasurementType',
        u'UEMeasurementValue',
        u'UE-MeasurementValue-UE-Transmitted-Power',
        u'UEMeasurementValueTransmittedPowerListHCR',
        u'UEMeasurementValueTransmittedPowerListHCR-IEs',
        u'UEMeasurementValueTransmittedPowerListLCR',
        u'UEMeasurementValueTransmittedPowerListLCR-IEs',
        u'UEMeasurementValueTransmittedPowerList768',
        u'UEMeasurementValueTransmittedPowerList768-IEs',
        u'UE-MeasurementValue-Primary-CCPCH-RSCP',
        u'UE-MeasurementValue-DL-Timeslot-ISCP',
        u'UEMeasurementValueTimeslotISCPListHCR',
        u'UEMeasurementValueTimeslotISCPListHCR-IEs',
        u'UEMeasurementValueTimeslotISCPListLCR',
        u'UEMeasurementValueTimeslotISCPListLCR-IEs',
        u'UEMeasurementValueTimeslotISCPList768',
        u'UEMeasurementValueTimeslotISCPList768-IEs',
        u'UEMeasurementValue-Extension',
        u'UEMeasurementValueInformation',
        u'UEMeasurementValueInformationAvailable',
        u'UEMeasurementValueInformationnotAvailable',
        u'UE-Measurement-Value',
        u'Extension-UE-Measurement-Value',
        u'UPHFiltering-Value',
        u'UPH-Filtering-Measurement-Forwarding-Request',
        u'UE-SupportIndicatorExtension',
        u'UE-State',
        u'UE-transmission-power-headroom-Value',
        u'Cell-Fach-Pch-State',
        u'Ura-Pch-State',
        u'UL-Delta-T2TP',
        u'UL-DL-mode',
        u'UL-DPDCHIndicatorEDCH',
        u'UL-Timeslot-Information',
        u'UL-Timeslot-InformationItem',
        u'UL-TimeslotLCR-Information',
        u'UL-TimeslotLCR-InformationItem',
        u'PLCCHinformation',
        u'UL-Timeslot-Information768',
        u'UL-Timeslot-InformationItem768',
        u'UL-TimeSlot-ISCP-Info',
        u'UL-TimeSlot-ISCP-InfoItem',
        u'UL-TimeSlot-ISCP-LCR-Info',
        u'UL-TimeSlot-ISCP-LCR-InfoItem',
        u'UL-Timeslot-ISCP-Value',
        u'UL-Timeslot-ISCP-Value-IncrDecrThres',
        u'UL-TimingAdvanceCtrl-LCR',
        u'Uplink-Compressed-Mode-Method',
        u'UL-SIR',
        u'UC-ID',
        u'UL-DPCCH-SlotFormat',
        u'UL-FP-Mode',
        u'UL-PhysCH-SF-Variation',
        u'UL-ScramblingCode',
        u'UL-ScramblingCodeLength',
        u'UL-ScramblingCodeNumber',
        u'UL-Synchronisation-Parameters-LCR',
        u'UL-Synchronisation-StepSize',
        u'UL-Synchronisation-Frequency',
        u'UL-TimeslotISCP',
        u'UPPCHPositionLCR',
        u'UpPTSInterferenceValue',
        u'Unidirectional-DCH-Indicator',
        u'URA-ID',
        u'URA-Information',
        u'RNCsWithCellsInTheAccessedURA-List',
        u'RNCsWithCellsInTheAccessedURA-Item',
        u'USCH-ID',
        u'USCH-Information',
        u'USCH-InformationItem',
        u'Usefulness-Of-Battery-Optimization',
        u'User-Plane-Congestion-Fields-Inclusion',
        u'Uu-ActivationState',
        u'UMTS-Cells-Info-List',
        u'UMTS-Cell-Info',
        u'UL-CLTD-Information',
        u'UL-CLTD-Information-Reconf',
        u'UL-CLTD-Information-To-Modify',
        u'UL-CLTD-Information-Removal',
        u'UL-CLTD-State-Update-Information',
        u'UL-DPCCH2-Information',
        u'UL-DPCCH2-Information-Reconf',
        u'UL-DPCCH2-Information-Removal',
        u'UL-DPCCH2-Information-To-Modify',
        u'UL-CLTD-Activation-Information',
        u'UL-MIMO-Information',
        u'UL-MIMO-Information-To-Modify',
        u'UL-MIMO-Reconfiguration',
        u'UL-MIMO-Removal',
        u'UL-MIMO-DL-Control-Channel-Information',
        ]
    _set_ = [
        u'Activate-Info-ExtIEs',
        u'ActivationInformationItem-ExtIEs',
        u'Active-Pattern-Sequence-Information-ExtIEs',
        u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs-ExtIEs',
        u'Additional-EDCH-Setup-Info-ExtIEs',
        u'ANRReportIndication-ExtIEs',
        u'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs',
        u'Additional-EDCH-F-DPCH-Information-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Addition-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Information-ExtIEs',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs',
        u'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs',
        u'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs',
        u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Update-Information-ExtIEs',
        u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs',
        u'AdditionalPreferredFrequencyItem-ExtIEs',
        u'AllocationRetentionPriority-ExtIEs',
        u'Allowed-Rate-Information-ExtIEs',
        u'Angle-Of-Arrival-Value-LCR-ExtIEs',
        u'ANR-Cell-Information-ExtIEs',
        u'ANR-FDD-CellInformation-ExtIEs',
        u'ANR-TDD-CellInformation-ExtIEs',
        u'ANR-LCR-TDD-CellInformation-ExtIEs',
        u'ANR-Multiple-PLMN-List-ExtIEs',
        u'BadSatelliteInformation-ExtIEs',
        u'BadSatellites-ExtIEs',
        u'BDS-IGPInfo-ExtIEs',
        u'BDS-Ionospheric-Grid-Model-ExtIEs',
        u'BurstModeParameters-ExtIEs',
        u'CellBased-ExtIEs',
        u'LAI-ExtIEs',
        u'CGI-ExtIEs',
        u'CommonMeasurementAvailableItem-ExtIEs',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem-ExtIEs',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR-ExtIEs',
        u'Common-E-DCH-LogicalChannelInformationItem-ExtIEs',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-ExtIEs',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify-ExtIEs',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem-ExtIEs',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response-ExtIEs',
        u'CPC-Information-ExtIEs',
        u'Counting-Information-List-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'CN-CS-DomainIdentifier-ExtIEs',
        u'CN-PS-DomainIdentifier-ExtIEs',
        u'CPC-InformationLCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs',
        u'Controlled-Object-Scope-ExtIEs',
        u'DBDS-CorrectionsReq-ExtIEs',
        u'DBDS-CorrectionsItem-ExtIEs',
        u'DBDS-InfoItem-ExtIEs',
        u'DBDS-SignalInfoItem-ExtIEs',
        u'DCH-ENH-Information-ExtIEs',
        u'DCH-ENH-Information-to-Modify-ExtIEs',
        u'DCH-ENH-Information-Reconf-ExtIEs',
        u'DCH-FDD-InformationItem-ExtIEs',
        u'DCH-MeasurementOccasion-Information-ExtIEs',
        u'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs',
        u'DCH-FDD-SpecificItem-ExtIEs',
        u'DCH-InformationResponseItem-ExtIEs',
        u'DCH-TDD-InformationItem-ExtIEs',
        u'DCH-Specific-TDD-Item-ExtIEs',
        u'DedicatedMeasurementAvailableItem-ExtIEs',
        u'Deactivate-Info-ExtIEs',
        u'DGANSSCorrections-ExtIEs',
        u'DGANSS-Corrections-Req-ExtIEs',
        u'DGANSS-InformationItem-ExtIEs',
        u'DGANSS-SignalInformationItem-ExtIEs',
        u'DGNSS-ValidityPeriod-ExtIEs',
        u'DGPSCorrections-ExtIEs',
        u'DGPSThreshold-ExtIEs',
        u'DL-TBS-ExtIEs',
        u'DL-PowerBalancing-Information-ExtIEs',
        u'DL-ReferencePowerInformationItem-ExtIEs',
        u'DL-ReferencePowerInformation-ExtIEs',
        u'DL-Timeslot-InformationItem-ExtIEs',
        u'DL-TimeslotLCR-InformationItem-ExtIEs',
        u'DL-Timeslot-InformationItem768-ExtIEs',
        u'DL-TimeSlot-ISCP-InfoItem-ExtIEs',
        u'DL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        u'Downlink-TPC-enhancements-Information-ExtIEs',
        u'Downlink-TPC-enhancements-Reconf-ExtIEs',
        u'DRX-Information-ExtIEs',
        u'DRX-Information-to-Modify-Items-LCR-ExtIEs',
        u'DRX-Information-to-Modify-Items-ExtIEs',
        u'DSCH-FlowControlItem-ExtIEs',
        u'DSCH-TDD-InformationItem-ExtIEs',
        u'DTX-Cycle-2ms-Items-ExtIEs',
        u'DTX-Cycle-2ms-to-Modify-Items-ExtIEs',
        u'DTX-Cycle-10ms-Items-ExtIEs',
        u'DTX-Cycle-10ms-to-Modify-Items-ExtIEs',
        u'DTX-Information-ExtIEs',
        u'DTX-Information2-ExtIEs',
        u'DTX-Information-to-Modify-Items-ExtIEs',
        u'Dual-Cell-EDCH-Enhancements-Information-ExtIEs',
        u'Extension-EARFCN-InformationIE',
        u'E-AGCH-DRX-Parameters-Response-ExtIEs',
        u'E-AGCH-DRX-Parameters-ExtIEs',
        u'ECGI-ExtIEs',
        u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs-ExtIEs',
        u'EDCH-FDD-DL-ControlChannelInformation-ExtIEs',
        u'EDCH-FDD-Information-ExtIEs',
        u'EDCH-FDD-InformationResponse-ExtIEs',
        u'EDCH-MACdFlow-Specific-InformationResponseItem-ExtIEs',
        u'EDCH-FDD-Information-To-Modify-ExtIEs',
        u'E-DCH-FDD-Update-Information-ExtIEs',
        u'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs',
        u'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs',
        u'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs',
        u'E-DCH-LogicalChannelInformationItem-ExtIEs',
        u'E-DCH-MACdPDU-SizeListItem-ExtIEs',
        u'E-DCH-LogicalChannelToModifyItem-ExtIEs',
        u'E-DCH-LogicalChannelToDeleteItem-ExtIEs',
        u'EDCH-MACdFlow-Information-ExtIEs',
        u'EDCH-MACdFlow-Specific-InfoItem-ExtIEs',
        u'EDCH-MACdFlow-Specific-InfoToModifyItem-ExtIEs',
        u'EDCH-MACdFlows-To-Delete-Item-ExtIEs',
        u'EDCH-Reference-E-TFCI-Information-Item-ExtIEs',
        u'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs',
        u'E-DCH-serving-cell-change-informationResponse-ExtIEs',
        u'E-DCH-serving-cell-change-successful-ExtIEs',
        u'E-DCH-RL-InformationList-Rsp-Item-ExtIEs',
        u'E-DCH-serving-cell-change-unsuccessful-ExtIEs',
        u'EDPCH-Information-FDD-ExtIEs',
        u'EDPCH-Information-RLReconfPrepare-FDD-ExtIEs',
        u'EDPCH-Information-RLReconfRequest-FDD-ExtIEs',
        u'EDCH-Serving-RL-in-this-DRNS-ExtIEs',
        u'Enhanced-FACH-Information-ResponseFDD-ExtIEs',
        u'Enhanced-FACH-Information-ResponseLCR-ExtIEs',
        u'E-TFCI-Boost-Information-ExtIEs',
        u'E-TFCS-Information-ExtIEs',
        u'EventA-ExtIEs',
        u'EventB-ExtIEs',
        u'EventC-ExtIEs',
        u'EventD-ExtIEs',
        u'EventE-ExtIEs',
        u'EventF-ExtIEs',
        u'EventH-ExtIEs',
        u'E-DCH-Information-ExtIEs',
        u'E-PUCH-Information-ExtIEs',
        u'E-TFCS-Information-TDD-ExtIEs',
        u'E-DCH-MACdFlow-InfoTDDItem-ExtIEs',
        u'E-DCH-TDD-Information-ExtIEs',
        u'E-DCH-Information-Reconfig-ExtIEs',
        u'E-DCH-TDD-Information-to-Modify-ExtIEs',
        u'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs',
        u'E-DCH-Information-Response-ExtIEs',
        u'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs',
        u'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs',
        u'E-HICH-InformationResp-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info-ExtIEs',
        u'E-DCH-768-Information-ExtIEs',
        u'E-DCH-TDD-Information768-ExtIEs',
        u'E-DCH-768-Information-Reconfig-ExtIEs',
        u'E-DCH-768-Information-Response-ExtIEs',
        u'E-AGCH-Specific-InformationResp-Item768TDD-ExtIEs',
        u'E-HICH-InformationResp768-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs',
        u'E-DCH-Information-LCR-ExtIEs',
        u'E-PUCH-Information-LCR-ExtIEs',
        u'E-DCH-LCR-TDD-Information-ExtIEs',
        u'Extension-CommonMeasurementValueIE',
        u'Extension-DedicatedMeasurementValueIE',
        u'E-DCH-Information-Reconfig-LCR-ExtIEs',
        u'E-DCH-Information-Response-LCR-ExtIEs',
        u'E-AGCH-Specific-InformationResp-ItemTDD-LCR-ExtIEs',
        u'E-HICH-Specific-InformationResp-LCR-ExtIEs',
        u'E-HICH-Scheduled-InformationResp-LCR-ExtIEs',
        u'E-HICH-InformationResp-LCR-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        u'E-DCH-SPS-HICH-Information-ExtIEs',
        u'E-HICH-InformationResp-ExplicitConfiguration-LCR-ExtIEs',
        u'FACH-FlowControlInformationItem-ExtIEs',
        u'FACH-InformationItem-ExtIEs',
        u'FDD-DCHs-to-ModifyItem-ExtIEs',
        u'FDD-DCHs-to-ModifySpecificItem-ExtIEs',
        u'FDD-DL-CodeInformationItem-ExtIEs',
        u'F-DPCH-Info-ExtIEs',
        u'F-DPCH-Info-To-Modify-ExtIEs',
        u'FTPICH-Information-ExtIEs',
        u'FTPICH-Information-To-Modify-ExtIEs',
        u'FTPICH-Information-Reconf-ExtIEs',
        u'FTPICH-Reconfiguration-Information-ExtIEs',
        u'FTPICH-Information-Response-ExtIEs',
        u'GA-Cell-ExtIEs',
        u'GA-EllipsoidArc-ExtIEs',
        u'SignalledGainFactors10ms-ExtIEs',
        u'Extension-GANSS-AddClockModels-IE',
        u'Extension-GANSS-AddOrbitModels-IE',
        u'GANSS-Additional-Ionospheric-Model-ExtIEs',
        u'GANSS-Additional-Navigation-Models-ExtIEs',
        u'Extension-GANSS-Additional-UTC-Models-IE',
        u'GANSS-KeplerianParametersAlm-ExtIEs',
        u'Extension-GANSS-AlmanacModel-IE',
        u'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        u'GANSS-alm-KEPLERIANBDSALMANAC-ExtIEs',
        u'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        u'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        u'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        u'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        u'GANSS-Almanac-ExtIEs',
        u'GANSS-AuxInfoGANSS-ID1-element-ExtIEs',
        u'GANSS-AuxInfoGANSS-ID3-element-ExtIEs',
        u'GANSS-BDSclockModelItem-ExtIEs',
        u'GANSS-ClockModelItem-ExtIEs',
        u'GANSS-CNAVclockModel-ExtIEs',
        u'GANSS-Common-Data-ExtIEs',
        u'GANSS-CommonDataInfoReq-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ExtIEs',
        u'GANSS-DataBitAssistanceItem-ExtIEs',
        u'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ReqList-ExtIEs',
        u'GANSS-DeltaUT1-ExtIEs',
        u'GANSS-Earth-Orientation-Parameters-ExtIEs',
        u'GANSS-GenericDataInfoReqItem-ExtIEs',
        u'GANSS-Generic-DataItem-ExtIEs',
        u'GANSS-GLONASSclockModel-ExtIEs',
        u'GANSS-Information-ExtIEs',
        u'GANSS-Ionospheric-Model-ExtIEs',
        u'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        u'GANSS-NAVclockModel-ExtIEs',
        u'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs',
        u'GANSS-NavModel-BDSKeplerianSet-ExtIEs',
        u'GANSS-NavModel-CNAVKeplerianSet-ExtIEs',
        u'GANSS-NavModel-GLONASSecef-ExtIEs',
        u'GANSS-NavModel-NAVKeplerianSet-ExtIEs',
        u'GANSS-NavModel-SBASecef-ExtIEs',
        u'GANSS-KeplerianParametersOrb-ExtIEs',
        u'GANSS-RealTimeInformationItem-ExtIEs',
        u'GANSS-RX-Pos-ExtIEs',
        u'GANSS-SatelliteInformationKPItem-ExtIEs',
        u'Ganss-Sat-Info-AddNavList-ExtIEs',
        u'GANSS-SAT-Info-Almanac-BDS-ExtIEs',
        u'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        u'GANSS-Sat-Info-Nav-ExtIEs',
        u'GANSS-SBASclockModel-ExtIEs',
        u'GANSS-Time-Model-ExtIEs',
        u'GANSS-Transmission-Time-ExtIEs',
        u'GANSS-UTC-Model-ExtIEs',
        u'GANSS-UTCmodelSet1-ExtIEs',
        u'GANSS-UTCmodelSet2-ExtIEs',
        u'GANSS-UTCmodelSet3-ExtIEs',
        u'GANSS-UTCmodelSet4-ExtIEs',
        u'GA-PointWithAltitude-ExtIEs',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        u'GA-PointWithUnCertaintyEllipse-ExtIEs',
        u'GA-PointWithUnCertainty-ExtIEs',
        u'GA-AccessPoint-ExtIEs',
        u'GeographicalCoordinate-ExtIEs',
        u'GERAN-SystemInfo-ExtIEs',
        u'Satellite-Almanac-Information-ExtIEs',
        u'GPS-Almanac-ExtIEs',
        u'Satellite-Almanac-Information-ExtItemIEs',
        u'GPSInformation-ExtIEs',
        u'GPS-Ionospheric-Model-ExtIEs',
        u'GPS-NavigationModel-and-TimeRecoveryItem-ExtIEs',
        u'GPS-RX-POS-ExtIEs',
        u'GPS-UTC-Model-ExtIEs',
        u'Guaranteed-Rate-Information-ExtIEs',
        u'HARQ-MemoryPartitioning-Implicit-ExtIEs',
        u'HARQ-MemoryPartitioning-Explicit-ExtIEs',
        u'HARQ-MemoryPartitioningItem-ExtIEs',
        u'HS-DSCH-Cell-ExtIEs',
        u'HSDSCH-FDD-Information-ExtIEs',
        u'HSDSCH-FDD-Information-Response-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs',
        u'HS-Secondary-Serving-cell-change-successful-ExtIEs',
        u'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs',
        u'HSDSCH-Information-to-Modify-ExtIEs',
        u'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoItem-Response-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        u'HSDSCH-MACdFlows-Information-ExtIEs',
        u'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs',
        u'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs',
        u'HSDSCH-PreconfigurationInfo-ExtIEs',
        u'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs',
        u'HSDSCHPreconfigurationSetup-ExtIEs',
        u'HS-SCCH-PreconfiguredCodesItem-ExtIEs',
        u'HS-DSCH-serving-cell-change-information-ExtIEs',
        u'HS-DSCH-serving-cell-change-informationResponse-ExtIEs',
        u'HS-serving-cell-change-successful-ExtIEs',
        u'HS-serving-cell-change-unsuccessful-ExtIEs',
        u'HSDSCH-TDD-Information-ExtIEs',
        u'HSDSCH-TDD-Information-Response-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-768-ExtIEs',
        u'HS-SCCH-DRX-Information-LCR-ExtIEs',
        u'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs',
        u'HSSCCH-FDD-Specific-InfoItem-Response-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoItem-Response-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoItem-Response768-ExtIEs',
        u'HSSICH-Info-ExtIEs',
        u'HSSICH-Info-LCR-ExtIEs',
        u'HSSICH-Info-768-ExtIEs',
        u'HS-SICH-Reception-Quality-Value-ExtIEs',
        u'HSDSCH-FDD-Update-Information-ExtIEs',
        u'HSDSCH-TDD-Update-Information-ExtIEs',
        u'HSSICH-ReferenceSignal-InformationLCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        u'Transport-Block-Size-Item-LCR-ExtIEs',
        u'Repetition-Period-Item-LCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        u'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs',
        u'Initial-HS-PDSCH-SPS-Resource-ExtIEs',
        u'InformationAvailable-ExtIEs',
        u'InformationType-ExtIEs',
        u'Initial-E-DCH-SPS-resource-ExtIEs',
        u'Extension-IPDLParametersIE',
        u'Inter-Frequency-Cell-ExtIEs',
        u'Inter-Frequency-Cell-Information-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB11-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB12-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cell-SIB11ter-ExtIEs',
        u'IPDL-FDD-Parameters-ExtIEs',
        u'IPDL-TDD-Parameters-ExtIEs',
        u'IPDL-TDD-ParametersLCR-ExtIEs',
        u'LABased-ExtIEs',
        u'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MACdPDU-Size-IndexItem-ExtIEs',
        u'MACdPDU-Size-IndexItem-to-Modify-ExtIEs',
        u'MBMS-Bearer-Service-Full-Address-ExtIEs',
        u'MBMS-Bearer-ServiceItemFDD-ExtIEs',
        u'MBMS-Bearer-ServiceItemFDD-PFL-ExtIEs',
        u'MBMS-Bearer-ServiceItemTDD-ExtIEs',
        u'MBMS-Bearer-ServiceItemTDD-PFL-ExtIEs',
        u'MBMSChannelTypeInfo-ExtIEs',
        u'MBMSChannelTypeCellList-ExtIEs',
        u'MBMSPreferredFreqLayerInfo-ExtIEs',
        u'MBMS-Neighbouring-Cell-Information-ExtIEs',
        u'MBMS-RLC-Sequence-Number-Information-List-ExtIEs',
        u'MBMS-Bearer-Service-List-RLCinfo-ExtIEs',
        u'MCCH-Configuration-Info-ExtIEs',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Item-ExtIEs',
        u'Extension-MeasurementIncreaseDecreaseThresholdIE',
        u'MessageStructure-ExtIEs',
        u'Extension-MeasurementThresholdIE',
        u'MidambleShiftLCR-ExtIEs',
        u'MIMO-InformationResponse-ExtIEs',
        u'Additional-Secondary-CPICH-Item-ExtIEs',
        u'MulticellEDCH-InformationItem',
        u'MulticellEDCH-InformationItemIEs-ExtIEs',
        u'MulticellEDCH-RL-SpecificInformationItem',
        u'MulticellEDCH-RL-SpecificInformationItemIEs-ExtIEs',
        u'Multiple-PLMN-List-ExtIEs',
        u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs',
        u'Multi-Carrier-EDCH-Info-ExtIEs',
        u'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs',
        u'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs',
        u'Multi-Carrier-EDCH-Reconfigure-ExtIEs',
        u'Multi-Carrier-EDCH-Change-Info-ExtIEs',
        u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs',
        u'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs',
        u'Multiflow-Information-ExtIEs',
        u'Multiflow-Information-To-Modify-ExtIEs',
        u'Multiflow-RepetitionFactors-ExtIEs',
        u'Standalone-Midamble-Channel-Information-ExtIEs',
        u'MU-MIMO-InformationLCR-ExtIEs',
        u'MU-MIMO-Indicator-ExtIEs',
        u'NACC-Related-Data-ExtIEs',
        u'Neighbouring-UMTS-CellInformationExtensionItemIE',
        u'Neighbouring-UMTS-CellInformationExtensionItem-ExtIEs',
        u'Neighbouring-UMTS-CellInformationItemIE',
        u'Neighbouring-UMTS-CellInformationItem-ExtIEs',
        u'Neighbouring-FDD-CellInformationItem-ExtIEs',
        u'NeighbouringFDDCellMeasurementInformationItem-ExtIEs',
        u'Neighbouring-GSM-CellInformationIE',
        u'Neighbouring-GSM-CellInformationItem-ExtIEs',
        u'Neighbouring-TDD-CellInformationItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationItem768-ExtIEs',
        u'Neighbouring-LCR-TDD-CellInformationItem-ExtIEs',
        u'Neighbouring-E-UTRA-CellInformationItem-ExtIEs',
        u'Non-Serving-RL-Preconfig-Setup-ExtIEs',
        u'Non-Serving-RL-Preconfig-Info-ExtIEs',
        u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs',
        u'OnModification-ExtIEs',
        u'OnModificationInformation-ExtIEs',
        u'PCH-InformationItem-ExtIEs',
        u'Periodic-ExtIEs',
        u'PeriodicInformation-ExtIEs',
        u'Associated-Secondary-CPICH-Item-ExtIEs',
        u'PreferredFrequencyLayerInfo-ExtIEs',
        u'PriorityQueue-InfoItem-ExtIEs',
        u'PriorityQueue-InfoItem-EnhancedFACH-PCH-ExtIEs',
        u'PriorityQueue-InfoItem-to-Add-ExtIEs',
        u'PriorityQueue-InfoItem-to-Modify-ExtIEs',
        u'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs',
        u'ProvideInformation-ExtIEs',
        u'UpPCH-InformationItemIE-LCRTDD',
        u'UpPCH-InformationItem-LCRTDD-ExtIEs',
        u'RABased-ExtIEs',
        u'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs',
        u'Reference-E-TFCI-Information-Item-ExtIEs',
        u'Extension-ReportCharacteristicsIE',
        u'RequestedDataValue-ExtIEs',
        u'RL-Specific-DCH-Info-Item-ExtIEs',
        u'RL-Specific-EDCH-Information-Item-ExtIEs',
        u'RL-Specific-EDCH-Info-Item-ExtIEs',
        u'SAI-ExtIEs',
        u'Satellite-DGPSCorrections-Information-ExtIEs',
        u'SecondaryServingCellsItem-ExtIEs',
        u'Secondary-CCPCH-Info-TDD-ExtIEs',
        u'Secondary-CPICH-Information-ExtIEs',
        u'Secondary-LCR-CCPCH-Info-TDD-ExtIEs',
        u'Secondary-CCPCH-Info-TDD768-ExtIEs',
        u'Secondary-CCPCH-TDD-InformationItem-ExtIEs',
        u'Secondary-LCR-CCPCH-TDD-InformationItem-ExtIEs',
        u'Secondary-CCPCH-TDD-InformationItem768-ExtIEs',
        u'Secondary-CCPCH-TDD-Code-InformationItem-ExtIEs',
        u'Secondary-LCR-CCPCH-TDD-Code-InformationItem-ExtIEs',
        u'Secondary-CCPCH-TDD-Code-InformationItem768-ExtIEs',
        u'Secondary-Serving-Cell-List-ExtIEs',
        u'Possible-Secondary-Serving-Cell-ExtIEs',
        u'SetsOfHS-SCCH-CodesItem-ExtIEs',
        u'GA-AccessPointPositionwithOptionalAltitude-ExtIEs',
        u'SFNSFNMeasurementThresholdInformation-ExtIEs',
        u'SFNSFNMeasurementValueInformationItem-ExtIEs',
        u'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        u'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        u'SFNSFNTimeStamp-ExtIEs',
        u'SNA-Information-ExtIEs',
        u'SynchronisationConfiguration-ExtIEs',
        u'TDD-DCHs-to-ModifyItem-ExtIEs',
        u'TDD-DCHs-to-ModifySpecificItem-ExtIEs',
        u'TDD-DL-Code-InformationItem-ExtIEs',
        u'TDD-DL-Code-LCR-InformationItem-ExtIEs',
        u'TDD-DL-Code-InformationItem768-ExtIEs',
        u'TDD-UL-Code-InformationItem-ExtIEs',
        u'TDD-UL-Code-LCR-InformationItem-ExtIEs',
        u'TDD-UL-Code-InformationItem768-ExtIEs',
        u'TMGI-ExtIEs',
        u'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        u'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        u'Transmission-Mode-Information-List-ExtIEs',
        u'TUTRANGANSSMeasurementThresholdInformation-ExtIEs',
        u'TUTRANGANSSMeasurementValueInformation-ExtIEs',
        u'TUTRANGPSMeasurementThresholdInformation-ExtIEs',
        u'TUTRANGPSMeasurementValueInformationItem-ExtIEs',
        u'SignalledGainFactors-ExtIEs',
        u'TFCS-ExtIEs',
        u'TFCS-TFCSList-ExtIEs',
        u'TPC-slot-position-ExtIEs',
        u'TransportFormatSet-ExtIEs',
        u'TransportFormatSet-DynamicPartList-ExtIEs',
        u'TDD-TransportFormatSet-ModeDP-ExtIEs',
        u'TransmissionTimeIntervalInformation-ExtIEs',
        u'TransportFormatSet-Semi-staticPart-ExtIEs',
        u'UE-Capabilities-Info-ExtIEs',
        u'Radio-Frequency-BandItem-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent1h-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent1i-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6a-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6b-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6c-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6d-ExtIEs',
        u'UEMeasurementReportCharacteristicsPeriodic-ExtIEs',
        u'UEMeasurementReportCharacteristics-ExtensionIE',
        u'UEMeasurementThreshold-ExtensionIE',
        u'UEMeasurementTimeslotInfoHCR-IEs-ExtIEs',
        u'UEMeasurementTimeslotInfoLCR-IEs-ExtIEs',
        u'UEMeasurementTimeslotInfo768-IEs-ExtIEs',
        u'UE-MeasurementValue-UE-Transmitted-Power-ExtIEs',
        u'UEMeasurementValueTransmittedPowerListHCR-IEs-ExtIEs',
        u'UEMeasurementValueTransmittedPowerListLCR-IEs-ExtIEs',
        u'UEMeasurementValueTransmittedPowerList768-IEs-ExtIEs',
        u'UE-MeasurementValue-Primary-CCPCH-RSCP-ExtIEs',
        u'UE-MeasurementValue-DL-Timeslot-ISCP-ExtIEs',
        u'UEMeasurementValueTimeslotISCPListHCR-IEs-ExtIEs',
        u'UEMeasurementValueTimeslotISCPListLCR-IEs-ExtIEs',
        u'UEMeasurementValueTimeslotISCPList768-IEs-ExtIEs',
        u'UEMeasurementValue-ExtensionIE',
        u'UEMeasurementValueInformationAvailableItem-ExtIEs',
        u'Extension-UE-Measurement-ValueIE',
        u'Cell-Fach-Pch-State-ExtIEs',
        u'Ura-Pch-State-ExtIEs',
        u'UL-Timeslot-InformationItem-ExtIEs',
        u'UL-TimeslotLCR-InformationItem-ExtIEs',
        u'PLCCHinformation-ExtIEs',
        u'UL-Timeslot-InformationItem768-ExtIEs',
        u'UL-TimeSlot-ISCP-InfoItem-ExtIEs',
        u'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        u'UC-ID-ExtIEs',
        u'UL-ScramblingCode-ExtIEs',
        u'UL-Synchronisation-Parameters-LCR-ExtIEs',
        u'URA-Information-ExtIEs',
        u'RNCsWithCellsInTheAccessedURA-Item-ExtIEs',
        u'USCH-InformationItem-ExtIEs',
        u'UMTS-Cells-Info-IEs',
        u'UMTS-Cell-Info-ExtIEs',
        u'UL-CLTD-Info-ExtIEs',
        u'UL-CLTD-Information-Reconf-ExtIEs',
        u'UL-CLTD-Information-To-Modify-ExtIEs',
        u'UL-DPCCH2-Information-ExtIEs',
        u'UL-DPCCH2-Information-Reconf-ExtIEs',
        u'UL-DPCCH2-Information-To-Modify-ExtIEs',
        u'UL-MIMO-Information-ExtIEs',
        u'UL-MIMO-Information-To-Modify-ExtIEs',
        u'UL-MIMO-DL-Control-Channel-Information-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'Activate-Info-ExtIEs',
        u'ActivationInformationItem-ExtIEs',
        u'Active-Pattern-Sequence-Information-ExtIEs',
        u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs-ExtIEs',
        u'Additional-EDCH-Setup-Info-ExtIEs',
        u'ANRReportIndication-ExtIEs',
        u'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs',
        u'Additional-EDCH-F-DPCH-Information-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Addition-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs-ExtIEs',
        u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Information-ExtIEs',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs',
        u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs',
        u'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs',
        u'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs',
        u'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs',
        u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs',
        u'Additional-EDCH-FDD-Update-Information-ExtIEs',
        u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs',
        u'AdditionalPreferredFrequencyItem-ExtIEs',
        u'AllocationRetentionPriority-ExtIEs',
        u'Allowed-Rate-Information-ExtIEs',
        u'Angle-Of-Arrival-Value-LCR-ExtIEs',
        u'ANR-Cell-Information-ExtIEs',
        u'ANR-FDD-CellInformation-ExtIEs',
        u'ANR-TDD-CellInformation-ExtIEs',
        u'ANR-LCR-TDD-CellInformation-ExtIEs',
        u'ANR-Multiple-PLMN-List-ExtIEs',
        u'BadSatelliteInformation-ExtIEs',
        u'BadSatellites-ExtIEs',
        u'BDS-IGPInfo-ExtIEs',
        u'BDS-Ionospheric-Grid-Model-ExtIEs',
        u'BurstModeParameters-ExtIEs',
        u'CellBased-ExtIEs',
        u'LAI-ExtIEs',
        u'CGI-ExtIEs',
        u'CommonMeasurementAvailableItem-ExtIEs',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem-ExtIEs',
        u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR-ExtIEs',
        u'Common-E-DCH-LogicalChannelInformationItem-ExtIEs',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-ExtIEs',
        u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify-ExtIEs',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem-ExtIEs',
        u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response-ExtIEs',
        u'CPC-Information-ExtIEs',
        u'Counting-Information-List-ExtIEs',
        u'CriticalityDiagnostics-ExtIEs',
        u'CriticalityDiagnostics-IE-List-ExtIEs',
        u'CN-CS-DomainIdentifier-ExtIEs',
        u'CN-PS-DomainIdentifier-ExtIEs',
        u'CPC-InformationLCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs',
        u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs',
        u'Controlled-Object-Scope-ExtIEs',
        u'DBDS-CorrectionsReq-ExtIEs',
        u'DBDS-CorrectionsItem-ExtIEs',
        u'DBDS-InfoItem-ExtIEs',
        u'DBDS-SignalInfoItem-ExtIEs',
        u'DCH-ENH-Information-ExtIEs',
        u'DCH-ENH-Information-to-Modify-ExtIEs',
        u'DCH-ENH-Information-Reconf-ExtIEs',
        u'DCH-FDD-InformationItem-ExtIEs',
        u'DCH-MeasurementOccasion-Information-ExtIEs',
        u'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs',
        u'DCH-FDD-SpecificItem-ExtIEs',
        u'DCH-InformationResponseItem-ExtIEs',
        u'DCH-TDD-InformationItem-ExtIEs',
        u'DCH-Specific-TDD-Item-ExtIEs',
        u'DedicatedMeasurementAvailableItem-ExtIEs',
        u'Deactivate-Info-ExtIEs',
        u'DGANSSCorrections-ExtIEs',
        u'DGANSS-Corrections-Req-ExtIEs',
        u'DGANSS-InformationItem-ExtIEs',
        u'DGANSS-SignalInformationItem-ExtIEs',
        u'DGNSS-ValidityPeriod-ExtIEs',
        u'DGPSCorrections-ExtIEs',
        u'DGPSThreshold-ExtIEs',
        u'DL-TBS-ExtIEs',
        u'DL-PowerBalancing-Information-ExtIEs',
        u'DL-ReferencePowerInformationItem-ExtIEs',
        u'DL-ReferencePowerInformation-ExtIEs',
        u'DL-Timeslot-InformationItem-ExtIEs',
        u'DL-TimeslotLCR-InformationItem-ExtIEs',
        u'DL-Timeslot-InformationItem768-ExtIEs',
        u'DL-TimeSlot-ISCP-InfoItem-ExtIEs',
        u'DL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        u'Downlink-TPC-enhancements-Information-ExtIEs',
        u'Downlink-TPC-enhancements-Reconf-ExtIEs',
        u'DRX-Information-ExtIEs',
        u'DRX-Information-to-Modify-Items-LCR-ExtIEs',
        u'DRX-Information-to-Modify-Items-ExtIEs',
        u'DSCH-FlowControlItem-ExtIEs',
        u'DSCH-TDD-InformationItem-ExtIEs',
        u'DTX-Cycle-2ms-Items-ExtIEs',
        u'DTX-Cycle-2ms-to-Modify-Items-ExtIEs',
        u'DTX-Cycle-10ms-Items-ExtIEs',
        u'DTX-Cycle-10ms-to-Modify-Items-ExtIEs',
        u'DTX-Information-ExtIEs',
        u'DTX-Information2-ExtIEs',
        u'DTX-Information-to-Modify-Items-ExtIEs',
        u'Dual-Cell-EDCH-Enhancements-Information-ExtIEs',
        u'Extension-EARFCN-InformationIE',
        u'E-AGCH-DRX-Parameters-Response-ExtIEs',
        u'E-AGCH-DRX-Parameters-ExtIEs',
        u'ECGI-ExtIEs',
        u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs',
        u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs-ExtIEs',
        u'EDCH-FDD-DL-ControlChannelInformation-ExtIEs',
        u'EDCH-FDD-Information-ExtIEs',
        u'EDCH-FDD-InformationResponse-ExtIEs',
        u'EDCH-MACdFlow-Specific-InformationResponseItem-ExtIEs',
        u'EDCH-FDD-Information-To-Modify-ExtIEs',
        u'E-DCH-FDD-Update-Information-ExtIEs',
        u'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs',
        u'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs',
        u'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs',
        u'E-DCH-LogicalChannelInformationItem-ExtIEs',
        u'E-DCH-MACdPDU-SizeListItem-ExtIEs',
        u'E-DCH-LogicalChannelToModifyItem-ExtIEs',
        u'E-DCH-LogicalChannelToDeleteItem-ExtIEs',
        u'EDCH-MACdFlow-Information-ExtIEs',
        u'EDCH-MACdFlow-Specific-InfoItem-ExtIEs',
        u'EDCH-MACdFlow-Specific-InfoToModifyItem-ExtIEs',
        u'EDCH-MACdFlows-To-Delete-Item-ExtIEs',
        u'EDCH-Reference-E-TFCI-Information-Item-ExtIEs',
        u'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs',
        u'E-DCH-serving-cell-change-informationResponse-ExtIEs',
        u'E-DCH-serving-cell-change-successful-ExtIEs',
        u'E-DCH-RL-InformationList-Rsp-Item-ExtIEs',
        u'E-DCH-serving-cell-change-unsuccessful-ExtIEs',
        u'EDPCH-Information-FDD-ExtIEs',
        u'EDPCH-Information-RLReconfPrepare-FDD-ExtIEs',
        u'EDPCH-Information-RLReconfRequest-FDD-ExtIEs',
        u'EDCH-Serving-RL-in-this-DRNS-ExtIEs',
        u'Enhanced-FACH-Information-ResponseFDD-ExtIEs',
        u'Enhanced-FACH-Information-ResponseLCR-ExtIEs',
        u'E-TFCI-Boost-Information-ExtIEs',
        u'E-TFCS-Information-ExtIEs',
        u'EventA-ExtIEs',
        u'EventB-ExtIEs',
        u'EventC-ExtIEs',
        u'EventD-ExtIEs',
        u'EventE-ExtIEs',
        u'EventF-ExtIEs',
        u'EventH-ExtIEs',
        u'E-DCH-Information-ExtIEs',
        u'E-PUCH-Information-ExtIEs',
        u'E-TFCS-Information-TDD-ExtIEs',
        u'E-DCH-MACdFlow-InfoTDDItem-ExtIEs',
        u'E-DCH-TDD-Information-ExtIEs',
        u'E-DCH-Information-Reconfig-ExtIEs',
        u'E-DCH-TDD-Information-to-Modify-ExtIEs',
        u'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs',
        u'E-DCH-Information-Response-ExtIEs',
        u'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs',
        u'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs',
        u'E-HICH-InformationResp-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info-ExtIEs',
        u'E-DCH-768-Information-ExtIEs',
        u'E-DCH-TDD-Information768-ExtIEs',
        u'E-DCH-768-Information-Reconfig-ExtIEs',
        u'E-DCH-768-Information-Response-ExtIEs',
        u'E-AGCH-Specific-InformationResp-Item768TDD-ExtIEs',
        u'E-HICH-InformationResp768-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs',
        u'E-DCH-Information-LCR-ExtIEs',
        u'E-PUCH-Information-LCR-ExtIEs',
        u'E-DCH-LCR-TDD-Information-ExtIEs',
        u'Extension-CommonMeasurementValueIE',
        u'Extension-DedicatedMeasurementValueIE',
        u'E-DCH-Information-Reconfig-LCR-ExtIEs',
        u'E-DCH-Information-Response-LCR-ExtIEs',
        u'E-AGCH-Specific-InformationResp-ItemTDD-LCR-ExtIEs',
        u'E-HICH-Specific-InformationResp-LCR-ExtIEs',
        u'E-HICH-Scheduled-InformationResp-LCR-ExtIEs',
        u'E-HICH-InformationResp-LCR-ExtIEs',
        u'E-DCH-Non-Scheduled-Grant-Info-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        u'E-DCH-SPS-HICH-Information-ExtIEs',
        u'E-HICH-InformationResp-ExplicitConfiguration-LCR-ExtIEs',
        u'FACH-FlowControlInformationItem-ExtIEs',
        u'FACH-InformationItem-ExtIEs',
        u'FDD-DCHs-to-ModifyItem-ExtIEs',
        u'FDD-DCHs-to-ModifySpecificItem-ExtIEs',
        u'FDD-DL-CodeInformationItem-ExtIEs',
        u'F-DPCH-Info-ExtIEs',
        u'F-DPCH-Info-To-Modify-ExtIEs',
        u'FTPICH-Information-ExtIEs',
        u'FTPICH-Information-To-Modify-ExtIEs',
        u'FTPICH-Information-Reconf-ExtIEs',
        u'FTPICH-Reconfiguration-Information-ExtIEs',
        u'FTPICH-Information-Response-ExtIEs',
        u'GA-Cell-ExtIEs',
        u'GA-EllipsoidArc-ExtIEs',
        u'SignalledGainFactors10ms-ExtIEs',
        u'Extension-GANSS-AddClockModels-IE',
        u'Extension-GANSS-AddOrbitModels-IE',
        u'GANSS-Additional-Ionospheric-Model-ExtIEs',
        u'GANSS-Additional-Navigation-Models-ExtIEs',
        u'Extension-GANSS-Additional-UTC-Models-IE',
        u'GANSS-KeplerianParametersAlm-ExtIEs',
        u'Extension-GANSS-AlmanacModel-IE',
        u'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        u'GANSS-alm-KEPLERIANBDSALMANAC-ExtIEs',
        u'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        u'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        u'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        u'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        u'GANSS-Almanac-ExtIEs',
        u'GANSS-AuxInfoGANSS-ID1-element-ExtIEs',
        u'GANSS-AuxInfoGANSS-ID3-element-ExtIEs',
        u'GANSS-BDSclockModelItem-ExtIEs',
        u'GANSS-ClockModelItem-ExtIEs',
        u'GANSS-CNAVclockModel-ExtIEs',
        u'GANSS-Common-Data-ExtIEs',
        u'GANSS-CommonDataInfoReq-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ExtIEs',
        u'GANSS-DataBitAssistanceItem-ExtIEs',
        u'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs',
        u'GANSS-Data-Bit-Assistance-ReqList-ExtIEs',
        u'GANSS-DeltaUT1-ExtIEs',
        u'GANSS-Earth-Orientation-Parameters-ExtIEs',
        u'GANSS-GenericDataInfoReqItem-ExtIEs',
        u'GANSS-Generic-DataItem-ExtIEs',
        u'GANSS-GLONASSclockModel-ExtIEs',
        u'GANSS-Information-ExtIEs',
        u'GANSS-Ionospheric-Model-ExtIEs',
        u'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        u'GANSS-NAVclockModel-ExtIEs',
        u'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs',
        u'GANSS-NavModel-BDSKeplerianSet-ExtIEs',
        u'GANSS-NavModel-CNAVKeplerianSet-ExtIEs',
        u'GANSS-NavModel-GLONASSecef-ExtIEs',
        u'GANSS-NavModel-NAVKeplerianSet-ExtIEs',
        u'GANSS-NavModel-SBASecef-ExtIEs',
        u'GANSS-KeplerianParametersOrb-ExtIEs',
        u'GANSS-RealTimeInformationItem-ExtIEs',
        u'GANSS-RX-Pos-ExtIEs',
        u'GANSS-SatelliteInformationKPItem-ExtIEs',
        u'Ganss-Sat-Info-AddNavList-ExtIEs',
        u'GANSS-SAT-Info-Almanac-BDS-ExtIEs',
        u'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        u'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        u'GANSS-Sat-Info-Nav-ExtIEs',
        u'GANSS-SBASclockModel-ExtIEs',
        u'GANSS-Time-Model-ExtIEs',
        u'GANSS-Transmission-Time-ExtIEs',
        u'GANSS-UTC-Model-ExtIEs',
        u'GANSS-UTCmodelSet1-ExtIEs',
        u'GANSS-UTCmodelSet2-ExtIEs',
        u'GANSS-UTCmodelSet3-ExtIEs',
        u'GANSS-UTCmodelSet4-ExtIEs',
        u'GA-PointWithAltitude-ExtIEs',
        u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        u'GA-PointWithUnCertaintyEllipse-ExtIEs',
        u'GA-PointWithUnCertainty-ExtIEs',
        u'GA-AccessPoint-ExtIEs',
        u'GeographicalCoordinate-ExtIEs',
        u'GERAN-SystemInfo-ExtIEs',
        u'Satellite-Almanac-Information-ExtIEs',
        u'GPS-Almanac-ExtIEs',
        u'Satellite-Almanac-Information-ExtItemIEs',
        u'GPSInformation-ExtIEs',
        u'GPS-Ionospheric-Model-ExtIEs',
        u'GPS-NavigationModel-and-TimeRecoveryItem-ExtIEs',
        u'GPS-RX-POS-ExtIEs',
        u'GPS-UTC-Model-ExtIEs',
        u'Guaranteed-Rate-Information-ExtIEs',
        u'HARQ-MemoryPartitioning-Implicit-ExtIEs',
        u'HARQ-MemoryPartitioning-Explicit-ExtIEs',
        u'HARQ-MemoryPartitioningItem-ExtIEs',
        u'HS-DSCH-Cell-ExtIEs',
        u'HSDSCH-FDD-Information-ExtIEs',
        u'HSDSCH-FDD-Information-Response-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs',
        u'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs',
        u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs',
        u'HS-Secondary-Serving-cell-change-successful-ExtIEs',
        u'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs',
        u'HSDSCH-Information-to-Modify-ExtIEs',
        u'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoItem-Response-ExtIEs',
        u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs',
        u'HSDSCH-MACdFlows-Information-ExtIEs',
        u'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs',
        u'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs',
        u'HSDSCH-PreconfigurationInfo-ExtIEs',
        u'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs',
        u'HSDSCHPreconfigurationSetup-ExtIEs',
        u'HS-SCCH-PreconfiguredCodesItem-ExtIEs',
        u'HS-DSCH-serving-cell-change-information-ExtIEs',
        u'HS-DSCH-serving-cell-change-informationResponse-ExtIEs',
        u'HS-serving-cell-change-successful-ExtIEs',
        u'HS-serving-cell-change-unsuccessful-ExtIEs',
        u'HSDSCH-TDD-Information-ExtIEs',
        u'HSDSCH-TDD-Information-Response-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs',
        u'HSPDSCH-TDD-Specific-InfoItem-Response-768-ExtIEs',
        u'HS-SCCH-DRX-Information-LCR-ExtIEs',
        u'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs',
        u'HSSCCH-FDD-Specific-InfoItem-Response-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoItem-Response-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs',
        u'HSSCCH-TDD-Specific-InfoItem-Response768-ExtIEs',
        u'HSSICH-Info-ExtIEs',
        u'HSSICH-Info-LCR-ExtIEs',
        u'HSSICH-Info-768-ExtIEs',
        u'HS-SICH-Reception-Quality-Value-ExtIEs',
        u'HSDSCH-FDD-Update-Information-ExtIEs',
        u'HSDSCH-TDD-Update-Information-ExtIEs',
        u'HSSICH-ReferenceSignal-InformationLCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs',
        u'Transport-Block-Size-Item-LCR-ExtIEs',
        u'Repetition-Period-Item-LCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs',
        u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs',
        u'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs',
        u'Initial-HS-PDSCH-SPS-Resource-ExtIEs',
        u'InformationAvailable-ExtIEs',
        u'InformationType-ExtIEs',
        u'Initial-E-DCH-SPS-resource-ExtIEs',
        u'Extension-IPDLParametersIE',
        u'Inter-Frequency-Cell-ExtIEs',
        u'Inter-Frequency-Cell-Information-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB11-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB12-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication-ExtIEs',
        u'Inter-Frequency-Cell-SIB11ter-ExtIEs',
        u'IPDL-FDD-Parameters-ExtIEs',
        u'IPDL-TDD-Parameters-ExtIEs',
        u'IPDL-TDD-ParametersLCR-ExtIEs',
        u'LABased-ExtIEs',
        u'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs',
        u'MDT-Configuration-ExtIEs',
        u'MACdPDU-Size-IndexItem-ExtIEs',
        u'MACdPDU-Size-IndexItem-to-Modify-ExtIEs',
        u'MBMS-Bearer-Service-Full-Address-ExtIEs',
        u'MBMS-Bearer-ServiceItemFDD-ExtIEs',
        u'MBMS-Bearer-ServiceItemFDD-PFL-ExtIEs',
        u'MBMS-Bearer-ServiceItemTDD-ExtIEs',
        u'MBMS-Bearer-ServiceItemTDD-PFL-ExtIEs',
        u'MBMSChannelTypeInfo-ExtIEs',
        u'MBMSChannelTypeCellList-ExtIEs',
        u'MBMSPreferredFreqLayerInfo-ExtIEs',
        u'MBMS-Neighbouring-Cell-Information-ExtIEs',
        u'MBMS-RLC-Sequence-Number-Information-List-ExtIEs',
        u'MBMS-Bearer-Service-List-RLCinfo-ExtIEs',
        u'MCCH-Configuration-Info-ExtIEs',
        u'MBSFN-Scheduling-Transmission-Time-Interval-Item-ExtIEs',
        u'Extension-MeasurementIncreaseDecreaseThresholdIE',
        u'MessageStructure-ExtIEs',
        u'Extension-MeasurementThresholdIE',
        u'MidambleShiftLCR-ExtIEs',
        u'MIMO-InformationResponse-ExtIEs',
        u'Additional-Secondary-CPICH-Item-ExtIEs',
        u'MulticellEDCH-InformationItem',
        u'MulticellEDCH-InformationItemIEs-ExtIEs',
        u'MulticellEDCH-RL-SpecificInformationItem',
        u'MulticellEDCH-RL-SpecificInformationItemIEs-ExtIEs',
        u'Multiple-PLMN-List-ExtIEs',
        u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs',
        u'Multi-Carrier-EDCH-Info-ExtIEs',
        u'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs',
        u'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs',
        u'Multi-Carrier-EDCH-Reconfigure-ExtIEs',
        u'Multi-Carrier-EDCH-Change-Info-ExtIEs',
        u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs',
        u'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs',
        u'Multiflow-Information-ExtIEs',
        u'Multiflow-Information-To-Modify-ExtIEs',
        u'Multiflow-RepetitionFactors-ExtIEs',
        u'Standalone-Midamble-Channel-Information-ExtIEs',
        u'MU-MIMO-InformationLCR-ExtIEs',
        u'MU-MIMO-Indicator-ExtIEs',
        u'NACC-Related-Data-ExtIEs',
        u'Neighbouring-UMTS-CellInformationExtensionItemIE',
        u'Neighbouring-UMTS-CellInformationExtensionItem-ExtIEs',
        u'Neighbouring-UMTS-CellInformationItemIE',
        u'Neighbouring-UMTS-CellInformationItem-ExtIEs',
        u'Neighbouring-FDD-CellInformationItem-ExtIEs',
        u'NeighbouringFDDCellMeasurementInformationItem-ExtIEs',
        u'Neighbouring-GSM-CellInformationIE',
        u'Neighbouring-GSM-CellInformationItem-ExtIEs',
        u'Neighbouring-TDD-CellInformationItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs',
        u'NeighbouringTDDCellMeasurementInformationItem768-ExtIEs',
        u'Neighbouring-LCR-TDD-CellInformationItem-ExtIEs',
        u'Neighbouring-E-UTRA-CellInformationItem-ExtIEs',
        u'Non-Serving-RL-Preconfig-Setup-ExtIEs',
        u'Non-Serving-RL-Preconfig-Info-ExtIEs',
        u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs',
        u'OnModification-ExtIEs',
        u'OnModificationInformation-ExtIEs',
        u'PCH-InformationItem-ExtIEs',
        u'Periodic-ExtIEs',
        u'PeriodicInformation-ExtIEs',
        u'Associated-Secondary-CPICH-Item-ExtIEs',
        u'PreferredFrequencyLayerInfo-ExtIEs',
        u'PriorityQueue-InfoItem-ExtIEs',
        u'PriorityQueue-InfoItem-EnhancedFACH-PCH-ExtIEs',
        u'PriorityQueue-InfoItem-to-Add-ExtIEs',
        u'PriorityQueue-InfoItem-to-Modify-ExtIEs',
        u'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs',
        u'ProvideInformation-ExtIEs',
        u'UpPCH-InformationItemIE-LCRTDD',
        u'UpPCH-InformationItem-LCRTDD-ExtIEs',
        u'RABased-ExtIEs',
        u'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs',
        u'Reference-E-TFCI-Information-Item-ExtIEs',
        u'Extension-ReportCharacteristicsIE',
        u'RequestedDataValue-ExtIEs',
        u'RL-Specific-DCH-Info-Item-ExtIEs',
        u'RL-Specific-EDCH-Information-Item-ExtIEs',
        u'RL-Specific-EDCH-Info-Item-ExtIEs',
        u'SAI-ExtIEs',
        u'Satellite-DGPSCorrections-Information-ExtIEs',
        u'SecondaryServingCellsItem-ExtIEs',
        u'Secondary-CCPCH-Info-TDD-ExtIEs',
        u'Secondary-CPICH-Information-ExtIEs',
        u'Secondary-LCR-CCPCH-Info-TDD-ExtIEs',
        u'Secondary-CCPCH-Info-TDD768-ExtIEs',
        u'Secondary-CCPCH-TDD-InformationItem-ExtIEs',
        u'Secondary-LCR-CCPCH-TDD-InformationItem-ExtIEs',
        u'Secondary-CCPCH-TDD-InformationItem768-ExtIEs',
        u'Secondary-CCPCH-TDD-Code-InformationItem-ExtIEs',
        u'Secondary-LCR-CCPCH-TDD-Code-InformationItem-ExtIEs',
        u'Secondary-CCPCH-TDD-Code-InformationItem768-ExtIEs',
        u'Secondary-Serving-Cell-List-ExtIEs',
        u'Possible-Secondary-Serving-Cell-ExtIEs',
        u'SetsOfHS-SCCH-CodesItem-ExtIEs',
        u'GA-AccessPointPositionwithOptionalAltitude-ExtIEs',
        u'SFNSFNMeasurementThresholdInformation-ExtIEs',
        u'SFNSFNMeasurementValueInformationItem-ExtIEs',
        u'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        u'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs',
        u'SFNSFNTimeStamp-ExtIEs',
        u'SNA-Information-ExtIEs',
        u'SynchronisationConfiguration-ExtIEs',
        u'TDD-DCHs-to-ModifyItem-ExtIEs',
        u'TDD-DCHs-to-ModifySpecificItem-ExtIEs',
        u'TDD-DL-Code-InformationItem-ExtIEs',
        u'TDD-DL-Code-LCR-InformationItem-ExtIEs',
        u'TDD-DL-Code-InformationItem768-ExtIEs',
        u'TDD-UL-Code-InformationItem-ExtIEs',
        u'TDD-UL-Code-LCR-InformationItem-ExtIEs',
        u'TDD-UL-Code-InformationItem768-ExtIEs',
        u'TMGI-ExtIEs',
        u'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        u'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        u'Transmission-Mode-Information-List-ExtIEs',
        u'TUTRANGANSSMeasurementThresholdInformation-ExtIEs',
        u'TUTRANGANSSMeasurementValueInformation-ExtIEs',
        u'TUTRANGPSMeasurementThresholdInformation-ExtIEs',
        u'TUTRANGPSMeasurementValueInformationItem-ExtIEs',
        u'SignalledGainFactors-ExtIEs',
        u'TFCS-ExtIEs',
        u'TFCS-TFCSList-ExtIEs',
        u'TPC-slot-position-ExtIEs',
        u'TransportFormatSet-ExtIEs',
        u'TransportFormatSet-DynamicPartList-ExtIEs',
        u'TDD-TransportFormatSet-ModeDP-ExtIEs',
        u'TransmissionTimeIntervalInformation-ExtIEs',
        u'TransportFormatSet-Semi-staticPart-ExtIEs',
        u'UE-Capabilities-Info-ExtIEs',
        u'Radio-Frequency-BandItem-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent1h-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent1i-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6a-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6b-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6c-ExtIEs',
        u'UEMeasurementReportCharacteristicsEvent6d-ExtIEs',
        u'UEMeasurementReportCharacteristicsPeriodic-ExtIEs',
        u'UEMeasurementReportCharacteristics-ExtensionIE',
        u'UEMeasurementThreshold-ExtensionIE',
        u'UEMeasurementTimeslotInfoHCR-IEs-ExtIEs',
        u'UEMeasurementTimeslotInfoLCR-IEs-ExtIEs',
        u'UEMeasurementTimeslotInfo768-IEs-ExtIEs',
        u'UE-MeasurementValue-UE-Transmitted-Power-ExtIEs',
        u'UEMeasurementValueTransmittedPowerListHCR-IEs-ExtIEs',
        u'UEMeasurementValueTransmittedPowerListLCR-IEs-ExtIEs',
        u'UEMeasurementValueTransmittedPowerList768-IEs-ExtIEs',
        u'UE-MeasurementValue-Primary-CCPCH-RSCP-ExtIEs',
        u'UE-MeasurementValue-DL-Timeslot-ISCP-ExtIEs',
        u'UEMeasurementValueTimeslotISCPListHCR-IEs-ExtIEs',
        u'UEMeasurementValueTimeslotISCPListLCR-IEs-ExtIEs',
        u'UEMeasurementValueTimeslotISCPList768-IEs-ExtIEs',
        u'UEMeasurementValue-ExtensionIE',
        u'UEMeasurementValueInformationAvailableItem-ExtIEs',
        u'Extension-UE-Measurement-ValueIE',
        u'Cell-Fach-Pch-State-ExtIEs',
        u'Ura-Pch-State-ExtIEs',
        u'UL-Timeslot-InformationItem-ExtIEs',
        u'UL-TimeslotLCR-InformationItem-ExtIEs',
        u'PLCCHinformation-ExtIEs',
        u'UL-Timeslot-InformationItem768-ExtIEs',
        u'UL-TimeSlot-ISCP-InfoItem-ExtIEs',
        u'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs',
        u'UC-ID-ExtIEs',
        u'UL-ScramblingCode-ExtIEs',
        u'UL-Synchronisation-Parameters-LCR-ExtIEs',
        u'URA-Information-ExtIEs',
        u'RNCsWithCellsInTheAccessedURA-Item-ExtIEs',
        u'USCH-InformationItem-ExtIEs',
        u'UMTS-Cells-Info-IEs',
        u'UMTS-Cell-Info-ExtIEs',
        u'UL-CLTD-Info-ExtIEs',
        u'UL-CLTD-Information-Reconf-ExtIEs',
        u'UL-CLTD-Information-To-Modify-ExtIEs',
        u'UL-DPCCH2-Information-ExtIEs',
        u'UL-DPCCH2-Information-Reconf-ExtIEs',
        u'UL-DPCCH2-Information-To-Modify-ExtIEs',
        u'UL-MIMO-Information-ExtIEs',
        u'UL-MIMO-Information-To-Modify-ExtIEs',
        u'UL-MIMO-DL-Control-Channel-Information-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AccessPointName >-----#
    AccessPointName = OCT_STR(name=u'AccessPointName', mode=MODE_TYPE)
    AccessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< AckNack-RepetitionFactor >-----#
    AckNack_RepetitionFactor = INT(name=u'AckNack-RepetitionFactor', mode=MODE_TYPE)
    AckNack_RepetitionFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< Ack-Power-Offset >-----#
    Ack_Power_Offset = INT(name=u'Ack-Power-Offset', mode=MODE_TYPE)
    Ack_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[ASN1RangeInt(lb=9, ub=10)])
    
    #-----< ActivationDelay >-----#
    ActivationDelay = ENUM(name=u'ActivationDelay', mode=MODE_TYPE)
    ActivationDelay._cont = ASN1Dict([(u'v0', 0), (u'v1', 1), (u'v2', 2), (u'v3', 3), (u'v4', 4), (u'v5', 5)])
    ActivationDelay._ext = []
    
    #-----< Activate-Info >-----#
    Activate_Info = SEQ(name=u'Activate-Info', mode=MODE_TYPE)
    _Activate_Info_activation_type = CHOICE(name=u'activation-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Execution-Type')))
    _Activate_Info_initial_dl_tx_power = INT(name=u'initial-dl-tx-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _Activate_Info_firstRLS_Indicator = ENUM(name=u'firstRLS-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FirstRLS-Indicator')), opt=True)
    _Activate_Info_propagation_delay = INT(name=u'propagation-delay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PropagationDelay')), opt=True)
    _Activate_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Activate_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Activate_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Activate_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Activate_Info_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')))
    ____Activate_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 662), (u'criticality', u'ignore'), (u'Extension', _____Activate_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Activate_Info_iE_Extensions__item__id._const_tab = ____Activate_Info_iE_Extensions__item__id_tab
    ___Activate_Info_iE_Extensions__item__id._const_tab_at = None
    ___Activate_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Activate_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Activate_Info_iE_Extensions__item__criticality._const_tab = ____Activate_Info_iE_Extensions__item__id_tab
    ___Activate_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Activate_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Activate_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Activate_Info_iE_Extensions__item__extensionValue._const_tab = ____Activate_Info_iE_Extensions__item__id_tab
    ___Activate_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Activate_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Activate_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Activate_Info_iE_Extensions__item__id),
        (u'criticality', ___Activate_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Activate_Info_iE_Extensions__item__extensionValue),
        ])
    __Activate_Info_iE_Extensions__item_._ext = None
    _Activate_Info_iE_Extensions._cont = __Activate_Info_iE_Extensions__item_
    _Activate_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Activate_Info._cont = ASN1Dict([
        (u'activation-type', _Activate_Info_activation_type),
        (u'initial-dl-tx-power', _Activate_Info_initial_dl_tx_power),
        (u'firstRLS-Indicator', _Activate_Info_firstRLS_Indicator),
        (u'propagation-delay', _Activate_Info_propagation_delay),
        (u'iE-Extensions', _Activate_Info_iE_Extensions),
        ])
    Activate_Info._ext = []
    
    #-----< Activate-Info-ExtIEs >-----#
    Activate_Info_ExtIEs = CLASS(name=u'Activate-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Activate_Info_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')))
    Activate_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 662), (u'criticality', u'ignore'), (u'Extension', _Activate_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ActivationInformation >-----#
    ActivationInformation = SEQ_OF(name=u'ActivationInformation', mode=MODE_TYPE)
    _ActivationInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationInformationItem')))
    ActivationInformation._cont = _ActivationInformation__item_
    ActivationInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ActivationInformationItem >-----#
    ActivationInformationItem = SEQ(name=u'ActivationInformationItem', mode=MODE_TYPE)
    _ActivationInformationItem_uU_ActivationState = ENUM(name=u'uU-ActivationState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Uu-ActivationState')))
    _ActivationInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ActivationInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ActivationInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ActivationInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ActivationInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivationInformationItem_iE_Extensions__item__id._const_tab = ____ActivationInformationItem_iE_Extensions__item__id_tab
    ___ActivationInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___ActivationInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___ActivationInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ActivationInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ActivationInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivationInformationItem_iE_Extensions__item__criticality._const_tab = ____ActivationInformationItem_iE_Extensions__item__criticality_tab
    ___ActivationInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ActivationInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ActivationInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ActivationInformationItem_iE_Extensions__item__extensionValue._const_tab = ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab
    ___ActivationInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ActivationInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ActivationInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ActivationInformationItem_iE_Extensions__item__id),
        (u'criticality', ___ActivationInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___ActivationInformationItem_iE_Extensions__item__extensionValue),
        ])
    __ActivationInformationItem_iE_Extensions__item_._ext = None
    _ActivationInformationItem_iE_Extensions._cont = __ActivationInformationItem_iE_Extensions__item_
    _ActivationInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ActivationInformationItem._cont = ASN1Dict([
        (u'uU-ActivationState', _ActivationInformationItem_uU_ActivationState),
        (u'iE-Extensions', _ActivationInformationItem_iE_Extensions),
        ])
    ActivationInformationItem._ext = []
    
    #-----< ActivationInformationItem-ExtIEs >-----#
    ActivationInformationItem_ExtIEs = CLASS(name=u'ActivationInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ActivationInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Active-MBMS-Bearer-Service-ListFDD >-----#
    Active_MBMS_Bearer_Service_ListFDD = SEQ_OF(name=u'Active-MBMS-Bearer-Service-ListFDD', mode=MODE_TYPE)
    _Active_MBMS_Bearer_Service_ListFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-ServiceItemFDD')))
    Active_MBMS_Bearer_Service_ListFDD._cont = _Active_MBMS_Bearer_Service_ListFDD__item_
    Active_MBMS_Bearer_Service_ListFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Active-MBMS-Bearer-Service-ListFDD-PFL >-----#
    Active_MBMS_Bearer_Service_ListFDD_PFL = SEQ_OF(name=u'Active-MBMS-Bearer-Service-ListFDD-PFL', mode=MODE_TYPE)
    _Active_MBMS_Bearer_Service_ListFDD_PFL__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-ServiceItemFDD-PFL')))
    Active_MBMS_Bearer_Service_ListFDD_PFL._cont = _Active_MBMS_Bearer_Service_ListFDD_PFL__item_
    Active_MBMS_Bearer_Service_ListFDD_PFL._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Active-MBMS-Bearer-Service-ListTDD >-----#
    Active_MBMS_Bearer_Service_ListTDD = SEQ_OF(name=u'Active-MBMS-Bearer-Service-ListTDD', mode=MODE_TYPE)
    _Active_MBMS_Bearer_Service_ListTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-ServiceItemTDD')))
    Active_MBMS_Bearer_Service_ListTDD._cont = _Active_MBMS_Bearer_Service_ListTDD__item_
    Active_MBMS_Bearer_Service_ListTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Active-MBMS-Bearer-Service-ListTDD-PFL >-----#
    Active_MBMS_Bearer_Service_ListTDD_PFL = SEQ_OF(name=u'Active-MBMS-Bearer-Service-ListTDD-PFL', mode=MODE_TYPE)
    _Active_MBMS_Bearer_Service_ListTDD_PFL__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-ServiceItemTDD-PFL')))
    Active_MBMS_Bearer_Service_ListTDD_PFL._cont = _Active_MBMS_Bearer_Service_ListTDD_PFL__item_
    Active_MBMS_Bearer_Service_ListTDD_PFL._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Active-Pattern-Sequence-Information >-----#
    Active_Pattern_Sequence_Information = SEQ(name=u'Active-Pattern-Sequence-Information', mode=MODE_TYPE)
    _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN = INT(name=u'cMConfigurationChangeCFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status = SEQ_OF(name=u'transmission-Gap-Pattern-Sequence-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Status-List')), opt=True)
    _Active_Pattern_Sequence_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Active_Pattern_Sequence_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab_at = None
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Active_Pattern_Sequence_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Active_Pattern_Sequence_Information_iE_Extensions__item__id),
        (u'criticality', ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue),
        ])
    __Active_Pattern_Sequence_Information_iE_Extensions__item_._ext = None
    _Active_Pattern_Sequence_Information_iE_Extensions._cont = __Active_Pattern_Sequence_Information_iE_Extensions__item_
    _Active_Pattern_Sequence_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Active_Pattern_Sequence_Information._cont = ASN1Dict([
        (u'cMConfigurationChangeCFN', _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN),
        (u'transmission-Gap-Pattern-Sequence-Status', _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status),
        (u'iE-Extensions', _Active_Pattern_Sequence_Information_iE_Extensions),
        ])
    Active_Pattern_Sequence_Information._ext = []
    
    #-----< Active-Pattern-Sequence-Information-ExtIEs >-----#
    Active_Pattern_Sequence_Information_ExtIEs = CLASS(name=u'Active-Pattern-Sequence-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Active_Pattern_Sequence_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-RLAddList >-----#
    Additional_EDCH_Cell_Information_Response_RLAddList = SEQ_OF(name=u'Additional-EDCH-Cell-Information-Response-RLAddList', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_RLAddList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs')))
    Additional_EDCH_Cell_Information_Response_RLAddList._cont = _Additional_EDCH_Cell_Information_Response_RLAddList__item_
    Additional_EDCH_Cell_Information_Response_RLAddList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs >-----#
    Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs = SEQ(name=u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_additional_EDCH_FDD_Information_Response = SEQ(name=u'additional-EDCH-FDD-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Information-Response-ItemIEs')), opt=True)
    _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_additional_EDCH_Serving_Cell_Change_Information_Response_RLAdd = SEQ(name=u'additional-EDCH-Serving-Cell-Change-Information-Response-RLAdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Serving-cell-change-informationResponse')), opt=True)
    _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs._cont = ASN1Dict([
        (u'additional-EDCH-FDD-Information-Response', _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_additional_EDCH_FDD_Information_Response),
        (u'additional-EDCH-Serving-Cell-Change-Information-Response-RLAdd', _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_additional_EDCH_Serving_Cell_Change_Information_Response_RLAdd),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-Cell-Information-Response-RLAdd-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Setup-Info >-----#
    Additional_EDCH_Setup_Info = SEQ(name=u'Additional-EDCH-Setup-Info', mode=MODE_TYPE)
    _Additional_EDCH_Setup_Info_multicell_EDCH_Transport_Bearer_Mode = ENUM(name=u'multicell-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multicell-EDCH-Transport-Bearer-Mode')))
    _Additional_EDCH_Setup_Info_additional_EDCH_Cell_Information_Setup = SEQ_OF(name=u'additional-EDCH-Cell-Information-Setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Setup')))
    _Additional_EDCH_Setup_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Setup_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Setup_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Setup_Info_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Setup_Info_iE_Extensions__item_._ext = None
    _Additional_EDCH_Setup_Info_iE_Extensions._cont = __Additional_EDCH_Setup_Info_iE_Extensions__item_
    _Additional_EDCH_Setup_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Setup_Info._cont = ASN1Dict([
        (u'multicell-EDCH-Transport-Bearer-Mode', _Additional_EDCH_Setup_Info_multicell_EDCH_Transport_Bearer_Mode),
        (u'additional-EDCH-Cell-Information-Setup', _Additional_EDCH_Setup_Info_additional_EDCH_Cell_Information_Setup),
        (u'iE-Extensions', _Additional_EDCH_Setup_Info_iE_Extensions),
        ])
    Additional_EDCH_Setup_Info._ext = []
    
    #-----< Additional-EDCH-Setup-Info-ExtIEs >-----#
    Additional_EDCH_Setup_Info_ExtIEs = CLASS(name=u'Additional-EDCH-Setup-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Setup_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANRReportIndication >-----#
    ANRReportIndication = SEQ(name=u'ANRReportIndication', mode=MODE_TYPE)
    _ANRReportIndication_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _ANRReportIndication_l3_Information = BIT_STR(name=u'l3-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _ANRReportIndication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANRReportIndication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANRReportIndication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANRReportIndication_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANRReportIndication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANRReportIndication_iE_Extensions__item__id._const_tab = ____ANRReportIndication_iE_Extensions__item__id_tab
    ___ANRReportIndication_iE_Extensions__item__id._const_tab_at = None
    ___ANRReportIndication_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANRReportIndication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANRReportIndication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANRReportIndication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANRReportIndication_iE_Extensions__item__criticality._const_tab = ____ANRReportIndication_iE_Extensions__item__criticality_tab
    ___ANRReportIndication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANRReportIndication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANRReportIndication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANRReportIndication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANRReportIndication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANRReportIndication_iE_Extensions__item__extensionValue._const_tab = ____ANRReportIndication_iE_Extensions__item__extensionValue_tab
    ___ANRReportIndication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANRReportIndication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANRReportIndication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANRReportIndication_iE_Extensions__item__id),
        (u'criticality', ___ANRReportIndication_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANRReportIndication_iE_Extensions__item__extensionValue),
        ])
    __ANRReportIndication_iE_Extensions__item_._ext = None
    _ANRReportIndication_iE_Extensions._cont = __ANRReportIndication_iE_Extensions__item_
    _ANRReportIndication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANRReportIndication._cont = ASN1Dict([
        (u'pLMN-Identity', _ANRReportIndication_pLMN_Identity),
        (u'l3-Information', _ANRReportIndication_l3_Information),
        (u'iE-Extensions', _ANRReportIndication_iE_Extensions),
        ])
    ANRReportIndication._ext = []
    
    #-----< ANRReportIndication-ExtIEs >-----#
    ANRReportIndication_ExtIEs = CLASS(name=u'ANRReportIndication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANRReportIndication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Setup >-----#
    Additional_EDCH_Cell_Information_Setup = SEQ_OF(name=u'Additional-EDCH-Cell-Information-Setup', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Setup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Setup-Cell-Information')))
    Additional_EDCH_Cell_Information_Setup._cont = _Additional_EDCH_Cell_Information_Setup__item_
    Additional_EDCH_Cell_Information_Setup._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-FDD-Setup-Cell-Information >-----#
    Additional_EDCH_FDD_Setup_Cell_Information = SEQ(name=u'Additional-EDCH-FDD-Setup-Cell-Information', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_UL_DPCH_Information_Setup = SEQ(name=u'additional-EDCH-UL-DPCH-Information-Setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-UL-DPCH-Information-Setup')))
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_RL_Specific_Information_To_Setup = SEQ_OF(name=u'additional-EDCH-RL-Specific-Information-To-Setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Setup-List')))
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_FDD_Information = SEQ(name=u'additional-EDCH-FDD-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Information')), opt=True)
    _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_F_DPCH_Information_Setup = SEQ(name=u'additional-EDCH-F-DPCH-Information-Setup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-F-DPCH-Information')))
    _Additional_EDCH_FDD_Setup_Cell_Information_multicellEDCH_Information = SEQ(name=u'multicellEDCH-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-Information')), opt=True)
    _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions._cont = __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_
    _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Setup_Cell_Information._cont = ASN1Dict([
        (u'additional-EDCH-UL-DPCH-Information-Setup', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_UL_DPCH_Information_Setup),
        (u'additional-EDCH-RL-Specific-Information-To-Setup', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_RL_Specific_Information_To_Setup),
        (u'additional-EDCH-FDD-Information', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_FDD_Information),
        (u'additional-EDCH-F-DPCH-Information-Setup', _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_F_DPCH_Information_Setup),
        (u'multicellEDCH-Information', _Additional_EDCH_FDD_Setup_Cell_Information_multicellEDCH_Information),
        (u'iE-Extensions', _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions),
        ])
    Additional_EDCH_FDD_Setup_Cell_Information._ext = []
    
    #-----< Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Setup_Cell_Information_ExtIEs = CLASS(name=u'Additional-EDCH-FDD-Setup-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Setup_Cell_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-UL-DPCH-Information-Setup >-----#
    Additional_EDCH_UL_DPCH_Information_Setup = SEQ(name=u'Additional-EDCH-UL-DPCH-Information-Setup', mode=MODE_TYPE)
    _Additional_EDCH_UL_DPCH_Information_Setup_ul_ScramblingCode = SEQ(name=u'ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-ScramblingCode')))
    _Additional_EDCH_UL_DPCH_Information_Setup_ul_SIR_Target = INT(name=u'ul-SIR-Target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id._const_tab = ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_._ext = None
    _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions._cont = __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_
    _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_UL_DPCH_Information_Setup._cont = ASN1Dict([
        (u'ul-ScramblingCode', _Additional_EDCH_UL_DPCH_Information_Setup_ul_ScramblingCode),
        (u'ul-SIR-Target', _Additional_EDCH_UL_DPCH_Information_Setup_ul_SIR_Target),
        (u'iE-Extensions', _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions),
        ])
    Additional_EDCH_UL_DPCH_Information_Setup._ext = []
    
    #-----< Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs >-----#
    Additional_EDCH_UL_DPCH_Information_Setup_ExtIEs = CLASS(name=u'Additional-EDCH-UL-DPCH-Information-Setup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_UL_DPCH_Information_Setup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-F-DPCH-Information >-----#
    Additional_EDCH_F_DPCH_Information = SEQ(name=u'Additional-EDCH-F-DPCH-Information', mode=MODE_TYPE)
    _Additional_EDCH_F_DPCH_Information_fdd_TPC_DownlinkStepSize = ENUM(name=u'fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _Additional_EDCH_F_DPCH_Information_limitedPowerIncrease = ENUM(name=u'limitedPowerIncrease', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LimitedPowerIncrease')))
    _Additional_EDCH_F_DPCH_Information_innerLoopDLPCStatus = ENUM(name=u'innerLoopDLPCStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _Additional_EDCH_F_DPCH_Information_f_DPCH_SlotFormatSupportRequest = NULL(name=u'f-DPCH-SlotFormatSupportRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormatSupportRequest')), opt=True)
    _Additional_EDCH_F_DPCH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_F_DPCH_Information_iE_Extensions._cont = __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_
    _Additional_EDCH_F_DPCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_F_DPCH_Information._cont = ASN1Dict([
        (u'fdd-TPC-DownlinkStepSize', _Additional_EDCH_F_DPCH_Information_fdd_TPC_DownlinkStepSize),
        (u'limitedPowerIncrease', _Additional_EDCH_F_DPCH_Information_limitedPowerIncrease),
        (u'innerLoopDLPCStatus', _Additional_EDCH_F_DPCH_Information_innerLoopDLPCStatus),
        (u'f-DPCH-SlotFormatSupportRequest', _Additional_EDCH_F_DPCH_Information_f_DPCH_SlotFormatSupportRequest),
        (u'iE-Extensions', _Additional_EDCH_F_DPCH_Information_iE_Extensions),
        ])
    Additional_EDCH_F_DPCH_Information._ext = []
    
    #-----< Additional-EDCH-F-DPCH-Information-ExtIEs >-----#
    Additional_EDCH_F_DPCH_Information_ExtIEs = CLASS(name=u'Additional-EDCH-F-DPCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_F_DPCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Setup-List >-----#
    Additional_EDCH_RL_Specific_Information_To_Setup_List = SEQ_OF(name=u'Additional-EDCH-RL-Specific-Information-To-Setup-List', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs')))
    Additional_EDCH_RL_Specific_Information_To_Setup_List._cont = _Additional_EDCH_RL_Specific_Information_To_Setup_List__item_
    Additional_EDCH_RL_Specific_Information_To_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs = SEQ(name=u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_eDCH_Additional_RL_ID = INT(name=u'eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_firstRLS_indicator = ENUM(name=u'firstRLS-indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FirstRLS-Indicator')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_propagationDelay = INT(name=u'propagationDelay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PropagationDelay')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_initialDL_transmissionPower = INT(name=u'initialDL-transmissionPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_primaryCPICH_EcNo = INT(name=u'primaryCPICH-EcNo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-EcNo')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_AGCH_PowerOffset = INT(name=u'e-AGCH-PowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_RGCH_PowerOffset = INT(name=u'e-RGCH-PowerOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_HICH_PowerOffset = INT(name=u'e-HICH-PowerOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List = SEQ_OF(name=u'additional-EDCH-MAC-d-Flows-Specific-Info-List', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info-List')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_multicellEDCH_RL_SpecificInformation = SEQ(name=u'multicellEDCH-RL-SpecificInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-RL-SpecificInformation')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions._cont = __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-ID', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_eDCH_Additional_RL_ID),
        (u'c-ID', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_c_ID),
        (u'firstRLS-indicator', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_firstRLS_indicator),
        (u'propagationDelay', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_propagationDelay),
        (u'initialDL-transmissionPower', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_initialDL_transmissionPower),
        (u'primaryCPICH-EcNo', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_primaryCPICH_EcNo),
        (u'e-AGCH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_AGCH_PowerOffset),
        (u'e-RGCH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_RGCH_PowerOffset),
        (u'e-HICH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_HICH_PowerOffset),
        (u'additional-EDCH-MAC-d-Flows-Specific-Info-List', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List),
        (u'multicellEDCH-RL-SpecificInformation', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_multicellEDCH_RL_SpecificInformation),
        (u'iE-Extensions', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs._ext = []
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-RL-Specific-Information-To-Setup-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-To-Add-List >-----#
    Additional_EDCH_Cell_Information_To_Add_List = SEQ_OF(name=u'Additional-EDCH-Cell-Information-To-Add-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-To-Add-ItemIEs')))
    Additional_EDCH_Cell_Information_To_Add_List._cont = _Additional_EDCH_Cell_Information_To_Add_List__item_
    Additional_EDCH_Cell_Information_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-To-Add-ItemIEs >-----#
    Additional_EDCH_Cell_Information_To_Add_ItemIEs = SEQ(name=u'Additional-EDCH-Cell-Information-To-Add-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_UL_DPCH_Information_Setup = SEQ(name=u'additional-EDCH-UL-DPCH-Information-Setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-UL-DPCH-Information-Addition')))
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add_List = SEQ_OF(name=u'additional-EDCH-RL-Specific-Information-To-Add-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Add-List')))
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_FDD_Information = SEQ(name=u'additional-EDCH-FDD-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Information')), opt=True)
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_multicellEDCH_Information = SEQ(name=u'multicellEDCH-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-Information')), opt=True)
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_To_Add_ItemIEs._cont = ASN1Dict([
        (u'additional-EDCH-UL-DPCH-Information-Setup', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_UL_DPCH_Information_Setup),
        (u'additional-EDCH-RL-Specific-Information-To-Add-List', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add_List),
        (u'additional-EDCH-FDD-Information', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_FDD_Information),
        (u'multicellEDCH-Information', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_multicellEDCH_Information),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_To_Add_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_To_Add_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-Cell-Information-To-Add-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_To_Add_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-UL-DPCH-Information-Addition >-----#
    Additional_EDCH_UL_DPCH_Information_Addition = SEQ(name=u'Additional-EDCH-UL-DPCH-Information-Addition', mode=MODE_TYPE)
    _Additional_EDCH_UL_DPCH_Information_Addition_ul_SIR_Target = INT(name=u'ul-SIR-Target', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id._const_tab = ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id_tab
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item_._ext = None
    _Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions._cont = __Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item_
    _Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_UL_DPCH_Information_Addition._cont = ASN1Dict([
        (u'ul-SIR-Target', _Additional_EDCH_UL_DPCH_Information_Addition_ul_SIR_Target),
        (u'iE-Extensions', _Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions),
        ])
    Additional_EDCH_UL_DPCH_Information_Addition._ext = []
    
    #-----< Additional-EDCH-UL-DPCH-Information-Addition-ExtIEs >-----#
    Additional_EDCH_UL_DPCH_Information_Addition_ExtIEs = CLASS(name=u'Additional-EDCH-UL-DPCH-Information-Addition-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_UL_DPCH_Information_Addition_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Add-List >-----#
    Additional_EDCH_RL_Specific_Information_To_Add_List = SEQ_OF(name=u'Additional-EDCH-RL-Specific-Information-To-Add-List', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Add_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs')))
    Additional_EDCH_RL_Specific_Information_To_Add_List._cont = _Additional_EDCH_RL_Specific_Information_To_Add_List__item_
    Additional_EDCH_RL_Specific_Information_To_Add_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs = SEQ(name=u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_eDCH_Additional_RL_ID = INT(name=u'eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_primaryCPICH_EcNo = INT(name=u'primaryCPICH-EcNo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-EcNo')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_AGCH_PowerOffset = INT(name=u'e-AGCH-PowerOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_RGCH_PowerOffset = INT(name=u'e-RGCH-PowerOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_HICH_PowerOffset = INT(name=u'e-HICH-PowerOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List = SEQ_OF(name=u'additional-EDCH-MAC-d-Flows-Specific-Info-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info-List')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_multicellEDCH_RL_SpecificInformation = SEQ(name=u'multicellEDCH-RL-SpecificInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-RL-SpecificInformation')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    ____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions._cont = __Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-ID', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_eDCH_Additional_RL_ID),
        (u'c-ID', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_c_ID),
        (u'primaryCPICH-EcNo', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_primaryCPICH_EcNo),
        (u'e-AGCH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_AGCH_PowerOffset),
        (u'e-RGCH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_RGCH_PowerOffset),
        (u'e-HICH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_HICH_PowerOffset),
        (u'additional-EDCH-MAC-d-Flows-Specific-Info-List', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List),
        (u'multicellEDCH-RL-SpecificInformation', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_multicellEDCH_RL_SpecificInformation),
        (u'iE-Extensions', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs._ext = []
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs-ExtIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-RL-Specific-Information-To-Add-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Modify-List >-----#
    Additional_EDCH_RL_Specific_Information_To_Modify_List = SEQ_OF(name=u'Additional-EDCH-RL-Specific-Information-To-Modify-List', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs')))
    Additional_EDCH_RL_Specific_Information_To_Modify_List._cont = _Additional_EDCH_RL_Specific_Information_To_Modify_List__item_
    Additional_EDCH_RL_Specific_Information_To_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs = SEQ(name=u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_eDCH_Additional_RL_ID = INT(name=u'eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_AGCH_PowerOffset = INT(name=u'e-AGCH-PowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_RGCH_PowerOffset = INT(name=u'e-RGCH-PowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_HICH_PowerOffset = INT(name=u'e-HICH-PowerOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-PowerOffset')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List = SEQ_OF(name=u'additional-EDCH-MAC-d-Flows-Specific-Info-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info-List')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_multicellEDCH_RL_SpecificInformation = SEQ(name=u'multicellEDCH-RL-SpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-RL-SpecificInformation')), opt=True)
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions._cont = __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-ID', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_eDCH_Additional_RL_ID),
        (u'e-AGCH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_AGCH_PowerOffset),
        (u'e-RGCH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_RGCH_PowerOffset),
        (u'e-HICH-PowerOffset', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_HICH_PowerOffset),
        (u'additional-EDCH-MAC-d-Flows-Specific-Info-List', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List),
        (u'multicellEDCH-RL-SpecificInformation', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_multicellEDCH_RL_SpecificInformation),
        (u'iE-Extensions', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs._ext = []
    
    #-----< Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs >-----#
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-RL-Specific-Information-To-Modify-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-FDD-Information >-----#
    Additional_EDCH_FDD_Information = SEQ(name=u'Additional-EDCH-FDD-Information', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _Additional_EDCH_FDD_Information_e_DCH_Maximum_Bitrate = INT(name=u'e-DCH-Maximum-Bitrate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Maximum-Bitrate')), opt=True)
    _Additional_EDCH_FDD_Information_e_DCH_Processing_Overload_Level = INT(name=u'e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _Additional_EDCH_FDD_Information_e_DCH_Min_Set_E_TFCI = INT(name=u'e-DCH-Min-Set-E-TFCI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI')), opt=True)
    _Additional_EDCH_FDD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Information2')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Implicit-Grant-Handling')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Minimum-TEBS-threshold')))
    _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Dual-Cell-EDCH-Enhancements-Information')))
    ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 962), (u'criticality', u'ignore'), (u'Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 970), (u'criticality', u'ignore'), (u'Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 971), (u'criticality', u'ignore'), (u'Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 988), (u'criticality', u'reject'), (u'Extension', _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_FDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_FDD_Information_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Information_iE_Extensions._cont = __Additional_EDCH_FDD_Information_iE_Extensions__item_
    _Additional_EDCH_FDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Information._cont = ASN1Dict([
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _Additional_EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'e-DCH-Maximum-Bitrate', _Additional_EDCH_FDD_Information_e_DCH_Maximum_Bitrate),
        (u'e-DCH-Processing-Overload-Level', _Additional_EDCH_FDD_Information_e_DCH_Processing_Overload_Level),
        (u'e-DCH-Min-Set-E-TFCI', _Additional_EDCH_FDD_Information_e_DCH_Min_Set_E_TFCI),
        (u'iE-Extensions', _Additional_EDCH_FDD_Information_iE_Extensions),
        ])
    Additional_EDCH_FDD_Information._ext = []
    
    #-----< Additional-EDCH-FDD-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Information_ExtIEs = CLASS(name=u'Additional-EDCH-FDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Information2')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Implicit-Grant-Handling')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Minimum-TEBS-threshold')))
    _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Dual-Cell-EDCH-Enhancements-Information')))
    Additional_EDCH_FDD_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 962), (u'criticality', u'ignore'), (u'Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 970), (u'criticality', u'ignore'), (u'Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 971), (u'criticality', u'ignore'), (u'Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 988), (u'criticality', u'reject'), (u'Extension', _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-List >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_List = SEQ_OF(name=u'Additional-EDCH-MAC-d-Flows-Specific-Info-List', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info')))
    Additional_EDCH_MAC_d_Flows_Specific_Info_List._cont = _Additional_EDCH_MAC_d_Flows_Specific_Info_List__item_
    Additional_EDCH_MAC_d_Flows_Specific_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info = SEQ(name=u'Additional-EDCH-MAC-d-Flows-Specific-Info', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_e_DCH_MACdFlow_ID = INT(name=u'e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _Additional_EDCH_MAC_d_Flows_Specific_Info_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_._ext = None
    _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions._cont = __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_
    _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_MAC_d_Flows_Specific_Info._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-ID', _Additional_EDCH_MAC_d_Flows_Specific_Info_e_DCH_MACdFlow_ID),
        (u'bindingID', _Additional_EDCH_MAC_d_Flows_Specific_Info_bindingID),
        (u'transportLayerAddress', _Additional_EDCH_MAC_d_Flows_Specific_Info_transportLayerAddress),
        (u'iE-Extensions', _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions),
        ])
    Additional_EDCH_MAC_d_Flows_Specific_Info._ext = []
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_ExtIEs = CLASS(name=u'Additional-EDCH-MAC-d-Flows-Specific-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_MAC_d_Flows_Specific_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List >-----#
    Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List = SEQ_OF(name=u'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flows-Specific-Info-Response')))
    Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List._cont = _Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List__item_
    Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-Response >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response = SEQ(name=u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response', mode=MODE_TYPE)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_e_DCH_MACdFlow_ID = INT(name=u'e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_._ext = None
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions._cont = __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_
    _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-ID', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_e_DCH_MACdFlow_ID),
        (u'bindingID', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_bindingID),
        (u'transportLayerAddress', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_transportLayerAddress),
        (u'iE-Extensions', _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions),
        ])
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response._ext = []
    
    #-----< Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs >-----#
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response_ExtIEs = CLASS(name=u'Additional-EDCH-MAC-d-Flows-Specific-Info-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_MAC_d_Flows_Specific_Info_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-List >-----#
    Additional_EDCH_Cell_Information_Response_List = SEQ_OF(name=u'Additional-EDCH-Cell-Information-Response-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Information-Response-ItemIEs')))
    Additional_EDCH_Cell_Information_Response_List._cont = _Additional_EDCH_Cell_Information_Response_List__item_
    Additional_EDCH_Cell_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-FDD-Information-Response-ItemIEs >-----#
    Additional_EDCH_FDD_Information_Response_ItemIEs = SEQ(name=u'Additional-EDCH-FDD-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_RL_Specific_Information_Response = SEQ_OF(name=u'eDCH-Additional-RL-Specific-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Additional-RL-Specific-Information-Response-List')))
    _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Information_Response_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-Specific-Information-Response', _Additional_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_RL_Specific_Information_Response),
        (u'iE-Extensions', _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_FDD_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_EDCH_FDD_Information_Response_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-FDD-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Response-RLReconf-List >-----#
    Additional_EDCH_Cell_Information_Response_RLReconf_List = SEQ_OF(name=u'Additional-EDCH-Cell-Information-Response-RLReconf-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Response_RLReconf_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Information-Response-RLReconf-Items')))
    Additional_EDCH_Cell_Information_Response_RLReconf_List._cont = _Additional_EDCH_Cell_Information_Response_RLReconf_List__item_
    Additional_EDCH_Cell_Information_Response_RLReconf_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-FDD-Information-Response-RLReconf-Items >-----#
    Additional_EDCH_FDD_Information_Response_RLReconf_Items = SEQ(name=u'Additional-EDCH-FDD-Information-Response-RLReconf-Items', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_eDCH_Additional_RL_Specific_Information_Response = SEQ_OF(name=u'eDCH-Additional-RL-Specific-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Additional-RL-Specific-Information-Response-List')), opt=True)
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_eDCH_Additional_RL_Specific_Modified_Information_Response = SEQ_OF(name=u'eDCH-Additional-RL-Specific-Modified-Information-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Additional-RL-Specific-Modified-Information-Response-List')), opt=True)
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions._cont = __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_
    _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Information_Response_RLReconf_Items._cont = ASN1Dict([
        (u'eDCH-Additional-RL-Specific-Information-Response', _Additional_EDCH_FDD_Information_Response_RLReconf_Items_eDCH_Additional_RL_Specific_Information_Response),
        (u'eDCH-Additional-RL-Specific-Modified-Information-Response', _Additional_EDCH_FDD_Information_Response_RLReconf_Items_eDCH_Additional_RL_Specific_Modified_Information_Response),
        (u'iE-Extensions', _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions),
        ])
    Additional_EDCH_FDD_Information_Response_RLReconf_Items._ext = []
    
    #-----< Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs >-----#
    Additional_EDCH_FDD_Information_Response_RLReconf_Items_ExtIEs = CLASS(name=u'Additional-EDCH-FDD-Information-Response-RLReconf-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Information_Response_RLReconf_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-ConfigurationChange-List >-----#
    Additional_EDCH_Cell_Information_ConfigurationChange_List = SEQ_OF(name=u'Additional-EDCH-Cell-Information-ConfigurationChange-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_ConfigurationChange_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-ConfigurationChange-Info-ItemIEs')))
    Additional_EDCH_Cell_Information_ConfigurationChange_List._cont = _Additional_EDCH_Cell_Information_ConfigurationChange_List__item_
    Additional_EDCH_Cell_Information_ConfigurationChange_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-ConfigurationChange-Info-ItemIEs >-----#
    Additional_EDCH_ConfigurationChange_Info_ItemIEs = SEQ(name=u'Additional-EDCH-ConfigurationChange-Info-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_UL_DPCH_Information_Modify = SEQ(name=u'additional-EDCH-UL-DPCH-Information-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-UL-DPCH-Information-Modify')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add = SEQ_OF(name=u'additional-EDCH-RL-Specific-Information-To-Add', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Add-List')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Modify = SEQ_OF(name=u'additional-EDCH-RL-Specific-Information-To-Modify', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-RL-Specific-Information-To-Modify-List')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_FDD_Information_To_Modify = SEQ(name=u'additional-EDCH-FDD-Information-To-Modify', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Information')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_F_DPCH_Information_Modify = SEQ(name=u'additional-EDCH-F-DPCH-Information-Modify', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-F-DPCH-Information')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_multicellEDCH_Information = SEQ(name=u'multicellEDCH-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-Information')), opt=True)
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions._cont = __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_ConfigurationChange_Info_ItemIEs._cont = ASN1Dict([
        (u'additional-EDCH-UL-DPCH-Information-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_UL_DPCH_Information_Modify),
        (u'additional-EDCH-RL-Specific-Information-To-Add', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add),
        (u'additional-EDCH-RL-Specific-Information-To-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Modify),
        (u'additional-EDCH-FDD-Information-To-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_FDD_Information_To_Modify),
        (u'additional-EDCH-F-DPCH-Information-Modify', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_F_DPCH_Information_Modify),
        (u'multicellEDCH-Information', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_multicellEDCH_Information),
        (u'iE-Extensions', _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_ConfigurationChange_Info_ItemIEs._ext = []
    
    #-----< Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs >-----#
    Additional_EDCH_ConfigurationChange_Info_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-ConfigurationChange-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_ConfigurationChange_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-UL-DPCH-Information-Modify >-----#
    Additional_EDCH_UL_DPCH_Information_Modify = SEQ(name=u'Additional-EDCH-UL-DPCH-Information-Modify', mode=MODE_TYPE)
    _Additional_EDCH_UL_DPCH_Information_Modify_ul_ScramblingCode = SEQ(name=u'ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-ScramblingCode')), opt=True)
    _Additional_EDCH_UL_DPCH_Information_Modify_ul_SIR_Target = INT(name=u'ul-SIR-Target', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id._const_tab = ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_._ext = None
    _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions._cont = __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_
    _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_UL_DPCH_Information_Modify._cont = ASN1Dict([
        (u'ul-ScramblingCode', _Additional_EDCH_UL_DPCH_Information_Modify_ul_ScramblingCode),
        (u'ul-SIR-Target', _Additional_EDCH_UL_DPCH_Information_Modify_ul_SIR_Target),
        (u'iE-Extensions', _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions),
        ])
    Additional_EDCH_UL_DPCH_Information_Modify._ext = []
    
    #-----< Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs >-----#
    Additional_EDCH_UL_DPCH_Information_Modify_ExtIEs = CLASS(name=u'Additional-EDCH-UL-DPCH-Information-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_UL_DPCH_Information_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-Removal-List >-----#
    Additional_EDCH_Cell_Information_Removal_List = SEQ_OF(name=u'Additional-EDCH-Cell-Information-Removal-List', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Removal_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs')))
    Additional_EDCH_Cell_Information_Removal_List._cont = _Additional_EDCH_Cell_Information_Removal_List__item_
    Additional_EDCH_Cell_Information_Removal_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-Removal-Info-ItemIEs >-----#
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs = SEQ(name=u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_rL_on_Secondary_UL_Frequency = ENUM(name=u'rL-on-Secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-on-Secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs._cont = ASN1Dict([
        (u'rL-on-Secondary-UL-Frequency', _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_rL_on_Secondary_UL_Frequency),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-Cell-Information-Removal-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-on-Secondary-UL-Frequency >-----#
    RL_on_Secondary_UL_Frequency = ENUM(name=u'RL-on-Secondary-UL-Frequency', mode=MODE_TYPE)
    RL_on_Secondary_UL_Frequency._cont = ASN1Dict([(u'remove', 0)])
    RL_on_Secondary_UL_Frequency._ext = []
    
    #-----< Additional-EDCH-FDD-Update-Information >-----#
    Additional_EDCH_FDD_Update_Information = SEQ(name=u'Additional-EDCH-FDD-Update-Information', mode=MODE_TYPE)
    _Additional_EDCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _Additional_EDCH_FDD_Update_Information_additional_EDCH_DL_Control_Channel_Change_Information = SEQ_OF(name=u'additional-EDCH-DL-Control-Channel-Change-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-DL-Control-Channel-Change-Information-List')), opt=True)
    _Additional_EDCH_FDD_Update_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id._const_tab = ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_._ext = None
    _Additional_EDCH_FDD_Update_Information_iE_Extensions._cont = __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_
    _Additional_EDCH_FDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_FDD_Update_Information._cont = ASN1Dict([
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _Additional_EDCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'additional-EDCH-DL-Control-Channel-Change-Information', _Additional_EDCH_FDD_Update_Information_additional_EDCH_DL_Control_Channel_Change_Information),
        (u'iE-Extensions', _Additional_EDCH_FDD_Update_Information_iE_Extensions),
        ])
    Additional_EDCH_FDD_Update_Information._ext = []
    
    #-----< Additional-EDCH-FDD-Update-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Update_Information_ExtIEs = CLASS(name=u'Additional-EDCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-DL-Control-Channel-Change-Information-List >-----#
    Additional_EDCH_DL_Control_Channel_Change_Information_List = SEQ_OF(name=u'Additional-EDCH-DL-Control-Channel-Change-Information-List', mode=MODE_TYPE)
    _Additional_EDCH_DL_Control_Channel_Change_Information_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs')))
    Additional_EDCH_DL_Control_Channel_Change_Information_List._cont = _Additional_EDCH_DL_Control_Channel_Change_Information_List__item_
    Additional_EDCH_DL_Control_Channel_Change_Information_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs >-----#
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs = SEQ(name=u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_eDCH_Additional_RL_ID = INT(name=u'eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions._cont = __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-ID', _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_eDCH_Additional_RL_ID),
        (u'iE-Extensions', _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs._ext = []
    
    #-----< Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs >-----#
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-DL-Control-Channel-Change-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalPreferredFrequency >-----#
    AdditionalPreferredFrequency = SEQ_OF(name=u'AdditionalPreferredFrequency', mode=MODE_TYPE)
    _AdditionalPreferredFrequency__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AdditionalPreferredFrequencyItem')))
    AdditionalPreferredFrequency._cont = _AdditionalPreferredFrequency__item_
    AdditionalPreferredFrequency._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AdditionalPreferredFrequencyItem >-----#
    AdditionalPreferredFrequencyItem = SEQ(name=u'AdditionalPreferredFrequencyItem', mode=MODE_TYPE)
    _AdditionalPreferredFrequencyItem_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _AdditionalPreferredFrequencyItem_correspondingCells = SEQ_OF(name=u'correspondingCells', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CorrespondingCells')))
    _AdditionalPreferredFrequencyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalPreferredFrequencyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AdditionalPreferredFrequencyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____AdditionalPreferredFrequencyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__id._const_tab = ____AdditionalPreferredFrequencyItem_iE_Extensions__item__id_tab
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality._const_tab = ____AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality_tab
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue._const_tab = ____AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue_tab
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AdditionalPreferredFrequencyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AdditionalPreferredFrequencyItem_iE_Extensions__item__id),
        (u'criticality', ___AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue),
        ])
    __AdditionalPreferredFrequencyItem_iE_Extensions__item_._ext = None
    _AdditionalPreferredFrequencyItem_iE_Extensions._cont = __AdditionalPreferredFrequencyItem_iE_Extensions__item_
    _AdditionalPreferredFrequencyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalPreferredFrequencyItem._cont = ASN1Dict([
        (u'dL-UARFCN', _AdditionalPreferredFrequencyItem_dL_UARFCN),
        (u'correspondingCells', _AdditionalPreferredFrequencyItem_correspondingCells),
        (u'iE-Extensions', _AdditionalPreferredFrequencyItem_iE_Extensions),
        ])
    AdditionalPreferredFrequencyItem._ext = []
    
    #-----< AdditionalPreferredFrequencyItem-ExtIEs >-----#
    AdditionalPreferredFrequencyItem_ExtIEs = CLASS(name=u'AdditionalPreferredFrequencyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    AdditionalPreferredFrequencyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdjustmentPeriod >-----#
    AdjustmentPeriod = INT(name=u'AdjustmentPeriod', mode=MODE_TYPE)
    AdjustmentPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AffectedUEInformationForMBMS >-----#
    AffectedUEInformationForMBMS = SEQ_OF(name=u'AffectedUEInformationForMBMS', mode=MODE_TYPE)
    _AffectedUEInformationForMBMS__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    AffectedUEInformationForMBMS._cont = _AffectedUEInformationForMBMS__item_
    AffectedUEInformationForMBMS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4096)], ev=None, er=[])
    
    #-----< AllocationRetentionPriority >-----#
    AllocationRetentionPriority = SEQ(name=u'AllocationRetentionPriority', mode=MODE_TYPE)
    _AllocationRetentionPriority_priorityLevel = INT(name=u'priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityLevel')))
    _AllocationRetentionPriority_pre_emptionCapability = ENUM(name=u'pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Pre-emptionCapability')))
    _AllocationRetentionPriority_pre_emptionVulnerability = ENUM(name=u'pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationRetentionPriority_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___AllocationRetentionPriority_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____AllocationRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____AllocationRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationRetentionPriority_iE_Extensions__item__id._const_tab_id = u'id'
    ___AllocationRetentionPriority_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___AllocationRetentionPriority_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___AllocationRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __AllocationRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___AllocationRetentionPriority_iE_Extensions__item__id),
        (u'criticality', ___AllocationRetentionPriority_iE_Extensions__item__criticality),
        (u'extensionValue', ___AllocationRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationRetentionPriority_iE_Extensions._cont = __AllocationRetentionPriority_iE_Extensions__item_
    _AllocationRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationRetentionPriority._cont = ASN1Dict([
        (u'priorityLevel', _AllocationRetentionPriority_priorityLevel),
        (u'pre-emptionCapability', _AllocationRetentionPriority_pre_emptionCapability),
        (u'pre-emptionVulnerability', _AllocationRetentionPriority_pre_emptionVulnerability),
        (u'iE-Extensions', _AllocationRetentionPriority_iE_Extensions),
        ])
    AllocationRetentionPriority._ext = []
    
    #-----< AllocationRetentionPriority-ExtIEs >-----#
    AllocationRetentionPriority_ExtIEs = CLASS(name=u'AllocationRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    AllocationRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Allowed-Rate-Information >-----#
    Allowed_Rate_Information = SEQ(name=u'Allowed-Rate-Information', mode=MODE_TYPE)
    _Allowed_Rate_Information_allowed_UL_Rate = INT(name=u'allowed-UL-Rate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Allowed-Rate')), opt=True)
    _Allowed_Rate_Information_allowed_DL_Rate = INT(name=u'allowed-DL-Rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Allowed-Rate')), opt=True)
    _Allowed_Rate_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Allowed_Rate_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Allowed_Rate_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Allowed_Rate_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Allowed_Rate_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_Rate_Information_iE_Extensions__item__id._const_tab = ____Allowed_Rate_Information_iE_Extensions__item__id_tab
    ___Allowed_Rate_Information_iE_Extensions__item__id._const_tab_at = None
    ___Allowed_Rate_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Allowed_Rate_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Allowed_Rate_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Allowed_Rate_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_Rate_Information_iE_Extensions__item__criticality._const_tab = ____Allowed_Rate_Information_iE_Extensions__item__criticality_tab
    ___Allowed_Rate_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Allowed_Rate_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Allowed_Rate_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Allowed_Rate_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Allowed_Rate_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Allowed_Rate_Information_iE_Extensions__item__extensionValue._const_tab = ____Allowed_Rate_Information_iE_Extensions__item__extensionValue_tab
    ___Allowed_Rate_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Allowed_Rate_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Allowed_Rate_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Allowed_Rate_Information_iE_Extensions__item__id),
        (u'criticality', ___Allowed_Rate_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Allowed_Rate_Information_iE_Extensions__item__extensionValue),
        ])
    __Allowed_Rate_Information_iE_Extensions__item_._ext = None
    _Allowed_Rate_Information_iE_Extensions._cont = __Allowed_Rate_Information_iE_Extensions__item_
    _Allowed_Rate_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Allowed_Rate_Information._cont = ASN1Dict([
        (u'allowed-UL-Rate', _Allowed_Rate_Information_allowed_UL_Rate),
        (u'allowed-DL-Rate', _Allowed_Rate_Information_allowed_DL_Rate),
        (u'iE-Extensions', _Allowed_Rate_Information_iE_Extensions),
        ])
    Allowed_Rate_Information._ext = []
    
    #-----< Allowed-Rate-Information-ExtIEs >-----#
    Allowed_Rate_Information_ExtIEs = CLASS(name=u'Allowed-Rate-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Allowed_Rate_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Allowed-Rate >-----#
    Allowed_Rate = INT(name=u'Allowed-Rate', mode=MODE_TYPE)
    Allowed_Rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AllowedQueuingTime >-----#
    AllowedQueuingTime = INT(name=u'AllowedQueuingTime', mode=MODE_TYPE)
    AllowedQueuingTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=None, er=[])
    
    #-----< AlphaValue >-----#
    AlphaValue = INT(name=u'AlphaValue', mode=MODE_TYPE)
    AlphaValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< AlternativeFormatReportingIndicator >-----#
    AlternativeFormatReportingIndicator = ENUM(name=u'AlternativeFormatReportingIndicator', mode=MODE_TYPE)
    AlternativeFormatReportingIndicator._cont = ASN1Dict([(u'alternativeFormatAllowed', 0)])
    AlternativeFormatReportingIndicator._ext = []
    
    #-----< Angle-Of-Arrival-Value-LCR >-----#
    Angle_Of_Arrival_Value_LCR = SEQ(name=u'Angle-Of-Arrival-Value-LCR', mode=MODE_TYPE)
    _Angle_Of_Arrival_Value_LCR_aOA_LCR = INT(name=u'aOA-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AOA-LCR')))
    _Angle_Of_Arrival_Value_LCR_aOA_LCR_Accuracy_Class = ENUM(name=u'aOA-LCR-Accuracy-Class', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AOA-LCR-Accuracy-Class')))
    _Angle_Of_Arrival_Value_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id._const_tab = ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id._const_tab_at = None
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality._const_tab = ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue._const_tab = ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id),
        (u'criticality', ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue),
        ])
    __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_._ext = None
    _Angle_Of_Arrival_Value_LCR_iE_Extensions._cont = __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_
    _Angle_Of_Arrival_Value_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Angle_Of_Arrival_Value_LCR._cont = ASN1Dict([
        (u'aOA-LCR', _Angle_Of_Arrival_Value_LCR_aOA_LCR),
        (u'aOA-LCR-Accuracy-Class', _Angle_Of_Arrival_Value_LCR_aOA_LCR_Accuracy_Class),
        (u'iE-Extensions', _Angle_Of_Arrival_Value_LCR_iE_Extensions),
        ])
    Angle_Of_Arrival_Value_LCR._ext = []
    
    #-----< Angle-Of-Arrival-Value-LCR-ExtIEs >-----#
    Angle_Of_Arrival_Value_LCR_ExtIEs = CLASS(name=u'Angle-Of-Arrival-Value-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Angle_Of_Arrival_Value_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANR-Cell-Information >-----#
    ANR_Cell_Information = SEQ(name=u'ANR-Cell-Information', mode=MODE_TYPE)
    _ANR_Cell_Information_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _ANR_Cell_Information_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAC')), opt=True)
    _ANR_Cell_Information_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RAC')), opt=True)
    _ANR_Cell_Information_aNR_FDD_CellInformation = SEQ(name=u'aNR-FDD-CellInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ANR-FDD-CellInformation')), opt=True)
    _ANR_Cell_Information_aNR_TDD_CellInformation = SEQ(name=u'aNR-TDD-CellInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ANR-TDD-CellInformation')), opt=True)
    _ANR_Cell_Information_aNR_LCR_TDD_CellInformation = SEQ(name=u'aNR-LCR-TDD-CellInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ANR-LCR-TDD-CellInformation')), opt=True)
    _ANR_Cell_Information_extended_RNC_ID = INT(name=u'extended-RNC-ID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')), opt=True)
    _ANR_Cell_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANR_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANR_Cell_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANR_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Cell_Information_iE_Extensions__item__id._const_tab = ____ANR_Cell_Information_iE_Extensions__item__id_tab
    ___ANR_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___ANR_Cell_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANR_Cell_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANR_Cell_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Cell_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Cell_Information_iE_Extensions__item__criticality._const_tab = ____ANR_Cell_Information_iE_Extensions__item__criticality_tab
    ___ANR_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANR_Cell_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANR_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANR_Cell_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Cell_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____ANR_Cell_Information_iE_Extensions__item__extensionValue_tab
    ___ANR_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANR_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANR_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANR_Cell_Information_iE_Extensions__item__id),
        (u'criticality', ___ANR_Cell_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANR_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __ANR_Cell_Information_iE_Extensions__item_._ext = None
    _ANR_Cell_Information_iE_Extensions._cont = __ANR_Cell_Information_iE_Extensions__item_
    _ANR_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANR_Cell_Information._cont = ASN1Dict([
        (u'rNC-ID', _ANR_Cell_Information_rNC_ID),
        (u'lAC', _ANR_Cell_Information_lAC),
        (u'rAC', _ANR_Cell_Information_rAC),
        (u'aNR-FDD-CellInformation', _ANR_Cell_Information_aNR_FDD_CellInformation),
        (u'aNR-TDD-CellInformation', _ANR_Cell_Information_aNR_TDD_CellInformation),
        (u'aNR-LCR-TDD-CellInformation', _ANR_Cell_Information_aNR_LCR_TDD_CellInformation),
        (u'extended-RNC-ID', _ANR_Cell_Information_extended_RNC_ID),
        (u'iE-Extensions', _ANR_Cell_Information_iE_Extensions),
        ])
    ANR_Cell_Information._ext = []
    
    #-----< ANR-Cell-Information-ExtIEs >-----#
    ANR_Cell_Information_ExtIEs = CLASS(name=u'ANR-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANR_Cell_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANR-FDD-CellInformation >-----#
    ANR_FDD_CellInformation = SEQ(name=u'ANR-FDD-CellInformation', mode=MODE_TYPE)
    _ANR_FDD_CellInformation_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')), opt=True)
    _ANR_FDD_CellInformation_txDiversityIndicator = ENUM(name=u'txDiversityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TxDiversityIndicator')))
    _ANR_FDD_CellInformation_sTTD_SupportIndicator = ENUM(name=u'sTTD-SupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'STTD-SupportIndicator')), opt=True)
    _ANR_FDD_CellInformation_closedLoopMode1_SupportIndicator = ENUM(name=u'closedLoopMode1-SupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ClosedLoopMode1-SupportIndicator')), opt=True)
    _ANR_FDD_CellInformation_restrictionStateIndicator = ENUM(name=u'restrictionStateIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')), opt=True)
    _ANR_FDD_CellInformation_dpc_ModeChangeSupportIndicator = ENUM(name=u'dpc-ModeChangeSupportIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode-Change-SupportIndicator')), opt=True)
    _ANR_FDD_CellInformation_cellCapabilityContainerFDD = BIT_STR(name=u'cellCapabilityContainerFDD', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-FDD')), opt=True)
    _ANR_FDD_CellInformation_sNA_Information = SEQ(name=u'sNA-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')), opt=True)
    _ANR_FDD_CellInformation_frequencyBandIndicator = ENUM(name=u'frequencyBandIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrequencyBandIndicator')), opt=True)
    _ANR_FDD_CellInformation_max_UE_DTX_Cycle = ENUM(name=u'max-UE-DTX-Cycle', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')), opt=True)
    _ANR_FDD_CellInformation_aNR_Multiple_PLMN_List = SEQ(name=u'aNR-Multiple-PLMN-List', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ANR-Multiple-PLMN-List')), opt=True)
    _ANR_FDD_CellInformation_secondaryServingCellList = SEQ(name=u'secondaryServingCellList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')), opt=True)
    _ANR_FDD_CellInformation_dualBandSecondaryServingCellList = SEQ(name=u'dualBandSecondaryServingCellList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')), opt=True)
    _ANR_FDD_CellInformation_cellCapabilityContainerExtensionFDD = BIT_STR(name=u'cellCapabilityContainerExtensionFDD', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-FDD')), opt=True)
    _ANR_FDD_CellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANR_FDD_CellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANR_FDD_CellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANR_FDD_CellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_FDD_CellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_FDD_CellInformation_iE_Extensions__item__id._const_tab = ____ANR_FDD_CellInformation_iE_Extensions__item__id_tab
    ___ANR_FDD_CellInformation_iE_Extensions__item__id._const_tab_at = None
    ___ANR_FDD_CellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANR_FDD_CellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANR_FDD_CellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_FDD_CellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_FDD_CellInformation_iE_Extensions__item__criticality._const_tab = ____ANR_FDD_CellInformation_iE_Extensions__item__criticality_tab
    ___ANR_FDD_CellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANR_FDD_CellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANR_FDD_CellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANR_FDD_CellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_FDD_CellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_FDD_CellInformation_iE_Extensions__item__extensionValue._const_tab = ____ANR_FDD_CellInformation_iE_Extensions__item__extensionValue_tab
    ___ANR_FDD_CellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANR_FDD_CellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANR_FDD_CellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANR_FDD_CellInformation_iE_Extensions__item__id),
        (u'criticality', ___ANR_FDD_CellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANR_FDD_CellInformation_iE_Extensions__item__extensionValue),
        ])
    __ANR_FDD_CellInformation_iE_Extensions__item_._ext = None
    _ANR_FDD_CellInformation_iE_Extensions._cont = __ANR_FDD_CellInformation_iE_Extensions__item_
    _ANR_FDD_CellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANR_FDD_CellInformation._cont = ASN1Dict([
        (u'primaryCPICH-Power', _ANR_FDD_CellInformation_primaryCPICH_Power),
        (u'txDiversityIndicator', _ANR_FDD_CellInformation_txDiversityIndicator),
        (u'sTTD-SupportIndicator', _ANR_FDD_CellInformation_sTTD_SupportIndicator),
        (u'closedLoopMode1-SupportIndicator', _ANR_FDD_CellInformation_closedLoopMode1_SupportIndicator),
        (u'restrictionStateIndicator', _ANR_FDD_CellInformation_restrictionStateIndicator),
        (u'dpc-ModeChangeSupportIndicator', _ANR_FDD_CellInformation_dpc_ModeChangeSupportIndicator),
        (u'cellCapabilityContainerFDD', _ANR_FDD_CellInformation_cellCapabilityContainerFDD),
        (u'sNA-Information', _ANR_FDD_CellInformation_sNA_Information),
        (u'frequencyBandIndicator', _ANR_FDD_CellInformation_frequencyBandIndicator),
        (u'max-UE-DTX-Cycle', _ANR_FDD_CellInformation_max_UE_DTX_Cycle),
        (u'aNR-Multiple-PLMN-List', _ANR_FDD_CellInformation_aNR_Multiple_PLMN_List),
        (u'secondaryServingCellList', _ANR_FDD_CellInformation_secondaryServingCellList),
        (u'dualBandSecondaryServingCellList', _ANR_FDD_CellInformation_dualBandSecondaryServingCellList),
        (u'cellCapabilityContainerExtensionFDD', _ANR_FDD_CellInformation_cellCapabilityContainerExtensionFDD),
        (u'iE-Extensions', _ANR_FDD_CellInformation_iE_Extensions),
        ])
    ANR_FDD_CellInformation._ext = []
    
    #-----< ANR-FDD-CellInformation-ExtIEs >-----#
    ANR_FDD_CellInformation_ExtIEs = CLASS(name=u'ANR-FDD-CellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANR_FDD_CellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANR-TDD-CellInformation >-----#
    ANR_TDD_CellInformation = SEQ(name=u'ANR-TDD-CellInformation', mode=MODE_TYPE)
    _ANR_TDD_CellInformation_syncCase = INT(name=u'syncCase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SyncCase')))
    _ANR_TDD_CellInformation_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')), opt=True)
    _ANR_TDD_CellInformation_sCH_TimeSlot = INT(name=u'sCH-TimeSlot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCH-TimeSlot')), opt=True)
    _ANR_TDD_CellInformation_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')))
    _ANR_TDD_CellInformation_dPCHConstantValue = INT(name=u'dPCHConstantValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCHConstantValue')), opt=True)
    _ANR_TDD_CellInformation_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')), opt=True)
    _ANR_TDD_CellInformation_restrictionStateIndicator = ENUM(name=u'restrictionStateIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')), opt=True)
    _ANR_TDD_CellInformation_cellCapabilityContainerTDD = BIT_STR(name=u'cellCapabilityContainerTDD', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD')), opt=True)
    _ANR_TDD_CellInformation_cellCapabilityContainerTDD768 = BIT_STR(name=u'cellCapabilityContainerTDD768', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD768')), opt=True)
    _ANR_TDD_CellInformation_sNA_Information = SEQ(name=u'sNA-Information', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')), opt=True)
    _ANR_TDD_CellInformation_aNR_Multiple_PLMN_List = SEQ(name=u'aNR-Multiple-PLMN-List', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ANR-Multiple-PLMN-List')), opt=True)
    _ANR_TDD_CellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANR_TDD_CellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANR_TDD_CellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANR_TDD_CellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_TDD_CellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_TDD_CellInformation_iE_Extensions__item__id._const_tab = ____ANR_TDD_CellInformation_iE_Extensions__item__id_tab
    ___ANR_TDD_CellInformation_iE_Extensions__item__id._const_tab_at = None
    ___ANR_TDD_CellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANR_TDD_CellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANR_TDD_CellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_TDD_CellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_TDD_CellInformation_iE_Extensions__item__criticality._const_tab = ____ANR_TDD_CellInformation_iE_Extensions__item__criticality_tab
    ___ANR_TDD_CellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANR_TDD_CellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANR_TDD_CellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_TDD_CellInformation_iE_Extensions__item__extensionValue._const_tab = ____ANR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab
    ___ANR_TDD_CellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANR_TDD_CellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANR_TDD_CellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANR_TDD_CellInformation_iE_Extensions__item__id),
        (u'criticality', ___ANR_TDD_CellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANR_TDD_CellInformation_iE_Extensions__item__extensionValue),
        ])
    __ANR_TDD_CellInformation_iE_Extensions__item_._ext = None
    _ANR_TDD_CellInformation_iE_Extensions._cont = __ANR_TDD_CellInformation_iE_Extensions__item_
    _ANR_TDD_CellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANR_TDD_CellInformation._cont = ASN1Dict([
        (u'syncCase', _ANR_TDD_CellInformation_syncCase),
        (u'timeSlot', _ANR_TDD_CellInformation_timeSlot),
        (u'sCH-TimeSlot', _ANR_TDD_CellInformation_sCH_TimeSlot),
        (u'sCTD-Indicator', _ANR_TDD_CellInformation_sCTD_Indicator),
        (u'dPCHConstantValue', _ANR_TDD_CellInformation_dPCHConstantValue),
        (u'pCCPCH-Power', _ANR_TDD_CellInformation_pCCPCH_Power),
        (u'restrictionStateIndicator', _ANR_TDD_CellInformation_restrictionStateIndicator),
        (u'cellCapabilityContainerTDD', _ANR_TDD_CellInformation_cellCapabilityContainerTDD),
        (u'cellCapabilityContainerTDD768', _ANR_TDD_CellInformation_cellCapabilityContainerTDD768),
        (u'sNA-Information', _ANR_TDD_CellInformation_sNA_Information),
        (u'aNR-Multiple-PLMN-List', _ANR_TDD_CellInformation_aNR_Multiple_PLMN_List),
        (u'iE-Extensions', _ANR_TDD_CellInformation_iE_Extensions),
        ])
    ANR_TDD_CellInformation._ext = []
    
    #-----< ANR-TDD-CellInformation-ExtIEs >-----#
    ANR_TDD_CellInformation_ExtIEs = CLASS(name=u'ANR-TDD-CellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANR_TDD_CellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANR-LCR-TDD-CellInformation >-----#
    ANR_LCR_TDD_CellInformation = SEQ(name=u'ANR-LCR-TDD-CellInformation', mode=MODE_TYPE)
    _ANR_LCR_TDD_CellInformation_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')))
    _ANR_LCR_TDD_CellInformation_dPCHConstantValue = INT(name=u'dPCHConstantValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCHConstantValue')), opt=True)
    _ANR_LCR_TDD_CellInformation_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')), opt=True)
    _ANR_LCR_TDD_CellInformation_restrictionStateIndicator = ENUM(name=u'restrictionStateIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')), opt=True)
    _ANR_LCR_TDD_CellInformation_cellCapabilityContainerTDD_LCR = BIT_STR(name=u'cellCapabilityContainerTDD-LCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD-LCR')), opt=True)
    _ANR_LCR_TDD_CellInformation_sNA_Information = SEQ(name=u'sNA-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')), opt=True)
    _ANR_LCR_TDD_CellInformation_aNR_Multiple_PLMN_List = SEQ(name=u'aNR-Multiple-PLMN-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ANR-Multiple-PLMN-List')), opt=True)
    _ANR_LCR_TDD_CellInformation_cellCapabilityContainerExternsionTDD_LCR = BIT_STR(name=u'cellCapabilityContainerExternsionTDD-LCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-TDD-LCR')), opt=True)
    _ANR_LCR_TDD_CellInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANR_LCR_TDD_CellInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__id._const_tab = ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__id_tab
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__id._const_tab_at = None
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality._const_tab = ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality_tab
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue._const_tab = ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANR_LCR_TDD_CellInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__id),
        (u'criticality', ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue),
        ])
    __ANR_LCR_TDD_CellInformation_iE_Extensions__item_._ext = None
    _ANR_LCR_TDD_CellInformation_iE_Extensions._cont = __ANR_LCR_TDD_CellInformation_iE_Extensions__item_
    _ANR_LCR_TDD_CellInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANR_LCR_TDD_CellInformation._cont = ASN1Dict([
        (u'sCTD-Indicator', _ANR_LCR_TDD_CellInformation_sCTD_Indicator),
        (u'dPCHConstantValue', _ANR_LCR_TDD_CellInformation_dPCHConstantValue),
        (u'pCCPCH-Power', _ANR_LCR_TDD_CellInformation_pCCPCH_Power),
        (u'restrictionStateIndicator', _ANR_LCR_TDD_CellInformation_restrictionStateIndicator),
        (u'cellCapabilityContainerTDD-LCR', _ANR_LCR_TDD_CellInformation_cellCapabilityContainerTDD_LCR),
        (u'sNA-Information', _ANR_LCR_TDD_CellInformation_sNA_Information),
        (u'aNR-Multiple-PLMN-List', _ANR_LCR_TDD_CellInformation_aNR_Multiple_PLMN_List),
        (u'cellCapabilityContainerExternsionTDD-LCR', _ANR_LCR_TDD_CellInformation_cellCapabilityContainerExternsionTDD_LCR),
        (u'iE-Extensions', _ANR_LCR_TDD_CellInformation_iE_Extensions),
        ])
    ANR_LCR_TDD_CellInformation._ext = []
    
    #-----< ANR-LCR-TDD-CellInformation-ExtIEs >-----#
    ANR_LCR_TDD_CellInformation_ExtIEs = CLASS(name=u'ANR-LCR-TDD-CellInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANR_LCR_TDD_CellInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANR-Multiple-PLMN-List >-----#
    ANR_Multiple_PLMN_List = SEQ(name=u'ANR-Multiple-PLMN-List', mode=MODE_TYPE)
    _ANR_Multiple_PLMN_List_list_Of_PLMNs = SEQ_OF(name=u'list-Of-PLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'List-Of-PLMNs')), opt=True)
    _ANR_Multiple_PLMN_List_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANR_Multiple_PLMN_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANR_Multiple_PLMN_List_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Multiple_PLMN_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__id._const_tab = ____ANR_Multiple_PLMN_List_iE_Extensions__item__id_tab
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__id._const_tab_at = None
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANR_Multiple_PLMN_List_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Multiple_PLMN_List_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__criticality._const_tab = ____ANR_Multiple_PLMN_List_iE_Extensions__item__criticality_tab
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue._const_tab = ____ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANR_Multiple_PLMN_List_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANR_Multiple_PLMN_List_iE_Extensions__item__id),
        (u'criticality', ___ANR_Multiple_PLMN_List_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue),
        ])
    __ANR_Multiple_PLMN_List_iE_Extensions__item_._ext = None
    _ANR_Multiple_PLMN_List_iE_Extensions._cont = __ANR_Multiple_PLMN_List_iE_Extensions__item_
    _ANR_Multiple_PLMN_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANR_Multiple_PLMN_List._cont = ASN1Dict([
        (u'list-Of-PLMNs', _ANR_Multiple_PLMN_List_list_Of_PLMNs),
        (u'iE-Extensions', _ANR_Multiple_PLMN_List_iE_Extensions),
        ])
    ANR_Multiple_PLMN_List._ext = []
    
    #-----< ANR-Multiple-PLMN-List-ExtIEs >-----#
    ANR_Multiple_PLMN_List_ExtIEs = CLASS(name=u'ANR-Multiple-PLMN-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANR_Multiple_PLMN_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AOA-LCR >-----#
    AOA_LCR = INT(name=u'AOA-LCR', mode=MODE_TYPE)
    AOA_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=719)], ev=None, er=[])
    
    #-----< AOA-LCR-Accuracy-Class >-----#
    AOA_LCR_Accuracy_Class = ENUM(name=u'AOA-LCR-Accuracy-Class', mode=MODE_TYPE)
    AOA_LCR_Accuracy_Class._cont = ASN1Dict([(u'a', 0), (u'b', 1), (u'c', 2), (u'd', 3), (u'e', 4), (u'f', 5), (u'g', 6), (u'h', 7)])
    AOA_LCR_Accuracy_Class._ext = []
    
    #-----< AntennaColocationIndicator >-----#
    AntennaColocationIndicator = ENUM(name=u'AntennaColocationIndicator', mode=MODE_TYPE)
    AntennaColocationIndicator._cont = ASN1Dict([(u'co-located', 0)])
    AntennaColocationIndicator._ext = []
    
    #-----< BadSatellites >-----#
    BadSatellites = SEQ(name=u'BadSatellites', mode=MODE_TYPE)
    _BadSatellites_badSatelliteInformation = SEQ_OF(name=u'badSatelliteInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __BadSatellites_badSatelliteInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___BadSatellites_badSatelliteInformation__item__badSAT_ID = INT(name=u'badSAT-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAT-ID')))
    ___BadSatellites_badSatelliteInformation__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____BadSatellites_badSatelliteInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id._const_tab = ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id_tab
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id._const_tab_at = None
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id._const_tab_id = u'id'
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality._const_tab = ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality_tab
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue._const_tab = ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue_tab
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____BadSatellites_badSatelliteInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id),
        (u'criticality', _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality),
        (u'extensionValue', _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue),
        ])
    ____BadSatellites_badSatelliteInformation__item__iE_Extensions__item_._ext = None
    ___BadSatellites_badSatelliteInformation__item__iE_Extensions._cont = ____BadSatellites_badSatelliteInformation__item__iE_Extensions__item_
    ___BadSatellites_badSatelliteInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __BadSatellites_badSatelliteInformation__item_._cont = ASN1Dict([
        (u'badSAT-ID', ___BadSatellites_badSatelliteInformation__item__badSAT_ID),
        (u'iE-Extensions', ___BadSatellites_badSatelliteInformation__item__iE_Extensions),
        ])
    __BadSatellites_badSatelliteInformation__item_._ext = []
    _BadSatellites_badSatelliteInformation._cont = __BadSatellites_badSatelliteInformation__item_
    _BadSatellites_badSatelliteInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _BadSatellites_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BadSatellites_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___BadSatellites_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BadSatellites_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BadSatellites_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BadSatellites_iE_Extensions__item__id._const_tab = ____BadSatellites_iE_Extensions__item__id_tab
    ___BadSatellites_iE_Extensions__item__id._const_tab_at = None
    ___BadSatellites_iE_Extensions__item__id._const_tab_id = u'id'
    ___BadSatellites_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BadSatellites_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BadSatellites_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BadSatellites_iE_Extensions__item__criticality._const_tab = ____BadSatellites_iE_Extensions__item__criticality_tab
    ___BadSatellites_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BadSatellites_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BadSatellites_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BadSatellites_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BadSatellites_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BadSatellites_iE_Extensions__item__extensionValue._const_tab = ____BadSatellites_iE_Extensions__item__extensionValue_tab
    ___BadSatellites_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BadSatellites_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BadSatellites_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BadSatellites_iE_Extensions__item__id),
        (u'criticality', ___BadSatellites_iE_Extensions__item__criticality),
        (u'extensionValue', ___BadSatellites_iE_Extensions__item__extensionValue),
        ])
    __BadSatellites_iE_Extensions__item_._ext = None
    _BadSatellites_iE_Extensions._cont = __BadSatellites_iE_Extensions__item_
    _BadSatellites_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BadSatellites._cont = ASN1Dict([
        (u'badSatelliteInformation', _BadSatellites_badSatelliteInformation),
        (u'iE-Extensions', _BadSatellites_iE_Extensions),
        ])
    BadSatellites._ext = []
    
    #-----< BadSatelliteInformation-ExtIEs >-----#
    BadSatelliteInformation_ExtIEs = CLASS(name=u'BadSatelliteInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    BadSatelliteInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BadSatellites-ExtIEs >-----#
    BadSatellites_ExtIEs = CLASS(name=u'BadSatellites-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    BadSatellites_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Band-Indicator >-----#
    Band_Indicator = ENUM(name=u'Band-Indicator', mode=MODE_TYPE)
    Band_Indicator._cont = ASN1Dict([(u'dcs1800Band', 0), (u'pcs1900Band', 1)])
    Band_Indicator._ext = []
    
    #-----< BCC >-----#
    BCC = BIT_STR(name=u'BCC', mode=MODE_TYPE)
    BCC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< BCCH-ARFCN >-----#
    BCCH_ARFCN = INT(name=u'BCCH-ARFCN', mode=MODE_TYPE)
    BCCH_ARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< BDS-IGPInfoList >-----#
    BDS_IGPInfoList = SEQ_OF(name=u'BDS-IGPInfoList', mode=MODE_TYPE)
    _BDS_IGPInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BDS-IGPInfo')))
    BDS_IGPInfoList._cont = _BDS_IGPInfoList__item_
    BDS_IGPInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    
    #-----< BDS-IGPInfo >-----#
    BDS_IGPInfo = SEQ(name=u'BDS-IGPInfo', mode=MODE_TYPE)
    _BDS_IGPInfo_bds_IGPNumber = INT(name=u'bds-IGPNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_IGPInfo_bds_IGPNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    _BDS_IGPInfo_bds_VerticalDelay = BIT_STR(name=u'bds-VerticalDelay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_IGPInfo_bds_VerticalDelay._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _BDS_IGPInfo_bds_GIVEI = BIT_STR(name=u'bds-GIVEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_IGPInfo_bds_GIVEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _BDS_IGPInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BDS_IGPInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___BDS_IGPInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BDS_IGPInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BDS_IGPInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_IGPInfo_iE_Extensions__item__id._const_tab = ____BDS_IGPInfo_iE_Extensions__item__id_tab
    ___BDS_IGPInfo_iE_Extensions__item__id._const_tab_at = None
    ___BDS_IGPInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___BDS_IGPInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BDS_IGPInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BDS_IGPInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_IGPInfo_iE_Extensions__item__criticality._const_tab = ____BDS_IGPInfo_iE_Extensions__item__criticality_tab
    ___BDS_IGPInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BDS_IGPInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BDS_IGPInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BDS_IGPInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BDS_IGPInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_IGPInfo_iE_Extensions__item__extensionValue._const_tab = ____BDS_IGPInfo_iE_Extensions__item__extensionValue_tab
    ___BDS_IGPInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BDS_IGPInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BDS_IGPInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BDS_IGPInfo_iE_Extensions__item__id),
        (u'criticality', ___BDS_IGPInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___BDS_IGPInfo_iE_Extensions__item__extensionValue),
        ])
    __BDS_IGPInfo_iE_Extensions__item_._ext = None
    _BDS_IGPInfo_iE_Extensions._cont = __BDS_IGPInfo_iE_Extensions__item_
    _BDS_IGPInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BDS_IGPInfo._cont = ASN1Dict([
        (u'bds-IGPNumber', _BDS_IGPInfo_bds_IGPNumber),
        (u'bds-VerticalDelay', _BDS_IGPInfo_bds_VerticalDelay),
        (u'bds-GIVEI', _BDS_IGPInfo_bds_GIVEI),
        (u'iE-Extensions', _BDS_IGPInfo_iE_Extensions),
        ])
    BDS_IGPInfo._ext = []
    
    #-----< BDS-IGPInfo-ExtIEs >-----#
    BDS_IGPInfo_ExtIEs = CLASS(name=u'BDS-IGPInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    BDS_IGPInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BDS-IonosphericGridModelReq >-----#
    BDS_IonosphericGridModelReq = ENUM(name=u'BDS-IonosphericGridModelReq', mode=MODE_TYPE)
    BDS_IonosphericGridModelReq._cont = ASN1Dict([(u'requested', 0)])
    BDS_IonosphericGridModelReq._ext = []
    
    #-----< BDS-Ionospheric-Grid-Model >-----#
    BDS_Ionospheric_Grid_Model = SEQ(name=u'BDS-Ionospheric-Grid-Model', mode=MODE_TYPE)
    _BDS_Ionospheric_Grid_Model_bDS_RefTime = INT(name=u'bDS-RefTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDS_Ionospheric_Grid_Model_bDS_RefTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _BDS_Ionospheric_Grid_Model_bds_IGPInfoList = SEQ_OF(name=u'bds-IGPInfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BDS-IGPInfoList')))
    _BDS_Ionospheric_Grid_Model_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BDS_Ionospheric_Grid_Model_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__id._const_tab = ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__id_tab
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__id._const_tab_at = None
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__id._const_tab_id = u'id'
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality._const_tab = ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality_tab
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue._const_tab = ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue_tab
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BDS_Ionospheric_Grid_Model_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__id),
        (u'criticality', ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality),
        (u'extensionValue', ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue),
        ])
    __BDS_Ionospheric_Grid_Model_iE_Extensions__item_._ext = None
    _BDS_Ionospheric_Grid_Model_iE_Extensions._cont = __BDS_Ionospheric_Grid_Model_iE_Extensions__item_
    _BDS_Ionospheric_Grid_Model_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BDS_Ionospheric_Grid_Model._cont = ASN1Dict([
        (u'bDS-RefTime', _BDS_Ionospheric_Grid_Model_bDS_RefTime),
        (u'bds-IGPInfoList', _BDS_Ionospheric_Grid_Model_bds_IGPInfoList),
        (u'iE-Extensions', _BDS_Ionospheric_Grid_Model_iE_Extensions),
        ])
    BDS_Ionospheric_Grid_Model._ext = []
    
    #-----< BDS-Ionospheric-Grid-Model-ExtIEs >-----#
    BDS_Ionospheric_Grid_Model_ExtIEs = CLASS(name=u'BDS-Ionospheric-Grid-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    BDS_Ionospheric_Grid_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BetaCD >-----#
    BetaCD = INT(name=u'BetaCD', mode=MODE_TYPE)
    BetaCD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< BindingID >-----#
    BindingID = OCT_STR(name=u'BindingID', mode=MODE_TYPE)
    BindingID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< BLER >-----#
    BLER = INT(name=u'BLER', mode=MODE_TYPE)
    BLER._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-63, ub=0)], ev=None, er=[])
    
    #-----< BSIC >-----#
    BSIC = SEQ(name=u'BSIC', mode=MODE_TYPE)
    _BSIC_nCC = BIT_STR(name=u'nCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NCC')))
    _BSIC_bCC = BIT_STR(name=u'bCC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BCC')))
    BSIC._cont = ASN1Dict([
        (u'nCC', _BSIC_nCC),
        (u'bCC', _BSIC_bCC),
        ])
    BSIC._ext = None
    
    #-----< BundlingModeIndicator >-----#
    BundlingModeIndicator = ENUM(name=u'BundlingModeIndicator', mode=MODE_TYPE)
    BundlingModeIndicator._cont = ASN1Dict([(u'bundling', 0), (u'no-bundling', 1)])
    BundlingModeIndicator._ext = None
    
    #-----< BurstModeParameters >-----#
    BurstModeParameters = SEQ(name=u'BurstModeParameters', mode=MODE_TYPE)
    _BurstModeParameters_burstStart = INT(name=u'burstStart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParameters_burstStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _BurstModeParameters_burstLength = INT(name=u'burstLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParameters_burstLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=25)], ev=None, er=[])
    _BurstModeParameters_burstFreq = INT(name=u'burstFreq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParameters_burstFreq._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _BurstModeParameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BurstModeParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___BurstModeParameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____BurstModeParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BurstModeParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BurstModeParameters_iE_Extensions__item__id._const_tab = ____BurstModeParameters_iE_Extensions__item__id_tab
    ___BurstModeParameters_iE_Extensions__item__id._const_tab_at = None
    ___BurstModeParameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___BurstModeParameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____BurstModeParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BurstModeParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BurstModeParameters_iE_Extensions__item__criticality._const_tab = ____BurstModeParameters_iE_Extensions__item__criticality_tab
    ___BurstModeParameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___BurstModeParameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___BurstModeParameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____BurstModeParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____BurstModeParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BurstModeParameters_iE_Extensions__item__extensionValue._const_tab = ____BurstModeParameters_iE_Extensions__item__extensionValue_tab
    ___BurstModeParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___BurstModeParameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __BurstModeParameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___BurstModeParameters_iE_Extensions__item__id),
        (u'criticality', ___BurstModeParameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___BurstModeParameters_iE_Extensions__item__extensionValue),
        ])
    __BurstModeParameters_iE_Extensions__item_._ext = None
    _BurstModeParameters_iE_Extensions._cont = __BurstModeParameters_iE_Extensions__item_
    _BurstModeParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BurstModeParameters._cont = ASN1Dict([
        (u'burstStart', _BurstModeParameters_burstStart),
        (u'burstLength', _BurstModeParameters_burstLength),
        (u'burstFreq', _BurstModeParameters_burstFreq),
        (u'iE-Extensions', _BurstModeParameters_iE_Extensions),
        ])
    BurstModeParameters._ext = []
    
    #-----< BurstModeParameters-ExtIEs >-----#
    BurstModeParameters_ExtIEs = CLASS(name=u'BurstModeParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    BurstModeParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name=u'Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name=u'radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name=u'transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name=u'protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name=u'misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        (u'radioNetwork', _Cause_radioNetwork),
        (u'transport', _Cause_transport),
        (u'protocol', _Cause_protocol),
        (u'misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name=u'CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([(u'control-processing-overload', 0), (u'hardware-failure', 1), (u'om-intervention', 2), (u'not-enough-user-plane-processing-resources', 3), (u'unspecified', 4)])
    CauseMisc._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name=u'CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([(u'transfer-syntax-error', 0), (u'abstract-syntax-error-reject', 1), (u'abstract-syntax-error-ignore-and-notify', 2), (u'message-not-compatible-with-receiver-state', 3), (u'semantic-error', 4), (u'unspecified', 5), (u'abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name=u'CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([(u'unknown-C-ID', 0), (u'cell-not-available', 1), (u'power-level-not-supported', 2), (u'ul-scrambling-code-already-in-use', 3), (u'dl-radio-resources-not-available', 4), (u'ul-radio-resources-not-available', 5), (u'measurement-not-supported-for-the-object', 6), (u'combining-resources-not-available', 7), (u'combining-not-supported', 8), (u'reconfiguration-not-allowed', 9), (u'requested-configuration-not-supported', 10), (u'synchronisation-failure', 11), (u'requested-tx-diversity-mode-not-supported', 12), (u'measurement-temporaily-not-available', 13), (u'unspecified', 14), (u'invalid-CM-settings', 15), (u'reconfiguration-CFN-not-elapsed', 16), (u'number-of-DL-codes-not-supported', 17), (u'dedicated-transport-channel-type-not-supported', 18), (u'dl-shared-channel-type-not-supported', 19), (u'ul-shared-channel-type-not-supported', 20), (u'common-transport-channel-type-not-supported', 21), (u'ul-spreading-factor-not-supported', 22), (u'dl-spreading-factor-not-supported', 23), (u'cm-not-supported', 24), (u'transaction-not-supported-by-destination-node-b', 25), (u'rl-already-activated-or-alocated', 26), (u'number-of-UL-codes-not-supported', 27), (u'cell-reserved-for-operator-use', 28), (u'dpc-mode-change-not-supported', 29), (u'information-temporarily-not-available', 30), (u'information-provision-not-supported-for-the-object', 31), (u'power-balancing-status-not-compatible', 32), (u'delayed-activation-not-supported', 33), (u'rl-timing-adjustment-not-supported', 34), (u'unknown-RNTI', 35), (u'measurement-repetition-rate-not-compatible', 36), (u'ue-not-capable-of-support', 37), (u'f-dpch-not-supported', 38), (u'e-dch-not-supported', 39), (u'continuous-packet-connectivity-dtx-drx-operation-not-supported', 40), (u'continuous-packet-connectivity-hs-scch-less-operation-not-supported', 41), (u'mimo-not-supported', 42), (u'e-dch-tti2ms-not-supported', 43), (u'continuous-packet-connectivity-DTX-DRX-operation-not-available', 44), (u'continuous-packet-connectivity-UE-DTX-Cycle-not-available', 45), (u'mimo-not-available', 46), (u'sixteenQAM-UL-not-Supported', 47), (u'hSDSCH-MACdPDU-SizeFormatNotSupported', 48), (u'f-dpch-slot-format-operation-not-supported', 49), (u'e-DCH-MACdPDU-SizeFormat-not-available', 50), (u'e-DPCCH-Power-Boosting-not-supported', 51), (u'trelocprep-expiry', 52), (u'directed-retry', 53), (u'no-Iu-CS-UP-relocation', 54), (u'reduce-load-in-serving-cell', 55), (u'relocation-cancelled', 56), (u'relocation-desirable-for-radio-reasons', 57), (u'resource-optimisation-relocation', 58), (u'time-critical-relocation', 59), (u'traffic-load-in-the-target-cell-higher-than-in-the-source-cell', 60), (u'sixtyfourQAM-DL-and-MIMO-Combined-not-available', 61), (u'multi-Cell-operation-not-available', 62), (u'multi-Cell-operation-not-supported', 63), (u'semi-Persistent-scheduling-not-supported', 64), (u'continuous-Packet-Connectivity-DRX-not-supported', 65), (u'continuous-Packet-Connectivity-DRX-not-available', 66), (u'enhanced-relocation-not-supported', 67), (u'relocation-not-supported-due-to-PUESBINE-feature', 68), (u'relocation-failure-in-target-RNC', 69), (u'relocation-target-not-allowed', 70), (u'requested-ciphering-and-or-integrity-protection-algorithms-not-supported', 71), (u'sixtyfourQAM-DL-and-MIMO-Combined-not-supported', 72), (u'tx-diversity-for-mimo-on-DL-control-channels-not-available', 73), (u'single-Stream-MIMO-not-supported', 74), (u'single-Stream-MIMO-not-available', 75), (u'multi-Cell-operation-with-MIMO-not-supported', 76), (u'multi-Cell-operation-with-MIMO-not-available', 77), (u'multi-Cell-EDCH-operation-not-supported', 78), (u'multi-Cell-EDCH-operation-not-available', 79), (u'multi-Cell-operation-with-Single-Stream-MIMO-not-supported', 80), (u'multi-Cell-operation-with-Single-Stream-MIMO-not-available', 81), (u'cellSpecificTxDiversityHandlingForMultiCellOperationNotAvailable', 82), (u'cellSpecificTxDiversityHandlingForMultiCellOperationNotSupported', 83), (u'frequencySpecificCompressedModeNotAvailable', 84), (u'uL-CLTD-Operation-not-available', 85), (u'uL-CLTD-Operation-not-supported', 86), (u'mimo-withfourtransmitantennas-not-supported', 87), (u'mimo-withfourtransmitantennas-not-available', 88), (u'dualstream-mimo-withfourtransmitantennas-not-supported', 89), (u'dualstream-mimo-withfourtransmitantennas-not-available', 90), (u'multiflow-operation-not-supported', 91), (u'multiflow-operation-not-available', 92), (u'ul-SixtyfourQAM-not-available', 93), (u'ul-SixtyfourQAM-not-supported', 94), (u'ul-MIMO-Operation-not-available', 95), (u'uL-MIMO-Operation-not-supported', 96), (u'ul-MIMO-SixteenQAM-Operation-not-available', 97), (u'uL-MIMO-SixteenQAM-Operation-not-supported', 98), (u'ul-MIMO-SixtyfourQAM-Operation-not-available', 99), (u'uL-MIMO-SixtyfourQAM-Operation-not-supported', 100), (u'e-DCH-Decoupling-operation-not-available', 101), (u'e-DCH-Decoupling-operation-not-supported', 102), (u'basic-dch-enh-not-available', 103), (u'basic-dch-enh-not-supported', 104), (u'full-dch-enh-not-available', 105), (u'full-dch-enh-not-supported', 106), (u'radio-Links-without-DPCH-FDPCH-Indication-operation-not-available', 107), (u'radio-Links-without-DPCH-FDPCH-Indication-operation-not-supported', 108), (u'uL-DPCCH2-operation-not-available', 109), (u'uL-DPCCH2-operation-not-supported', 110), (u'downlink-TPC-enhancements-operation-not-available', 111), (u'downlink-TPC-enhancements-operation-not-supported', 112), (u'dual-Cell-EDCH-enhancements-with-10ms-and-10ms-TTI-operation-not-available', 113), (u'dual-Cell-EDCH-enhancements-with-10ms-and-10ms-TTI-operation-not-supported', 114), (u'dual-Cell-EDCH-enhancements-with-different-TTI-operation-not-available', 115), (u'dual-Cell-EDCH-enhancements-with-different-TTI-operation-not-supported', 116)])
    CauseRadioNetwork._ext = [u'number-of-UL-codes-not-supported', u'cell-reserved-for-operator-use', u'dpc-mode-change-not-supported', u'information-temporarily-not-available', u'information-provision-not-supported-for-the-object', u'power-balancing-status-not-compatible', u'delayed-activation-not-supported', u'rl-timing-adjustment-not-supported', u'unknown-RNTI', u'measurement-repetition-rate-not-compatible', u'ue-not-capable-of-support', u'f-dpch-not-supported', u'e-dch-not-supported', u'continuous-packet-connectivity-dtx-drx-operation-not-supported', u'continuous-packet-connectivity-hs-scch-less-operation-not-supported', u'mimo-not-supported', u'e-dch-tti2ms-not-supported', u'continuous-packet-connectivity-DTX-DRX-operation-not-available', u'continuous-packet-connectivity-UE-DTX-Cycle-not-available', u'mimo-not-available', u'sixteenQAM-UL-not-Supported', u'hSDSCH-MACdPDU-SizeFormatNotSupported', u'f-dpch-slot-format-operation-not-supported', u'e-DCH-MACdPDU-SizeFormat-not-available', u'e-DPCCH-Power-Boosting-not-supported', u'trelocprep-expiry', u'directed-retry', u'no-Iu-CS-UP-relocation', u'reduce-load-in-serving-cell', u'relocation-cancelled', u'relocation-desirable-for-radio-reasons', u'resource-optimisation-relocation', u'time-critical-relocation', u'traffic-load-in-the-target-cell-higher-than-in-the-source-cell', u'sixtyfourQAM-DL-and-MIMO-Combined-not-available', u'multi-Cell-operation-not-available', u'multi-Cell-operation-not-supported', u'semi-Persistent-scheduling-not-supported', u'continuous-Packet-Connectivity-DRX-not-supported', u'continuous-Packet-Connectivity-DRX-not-available', u'enhanced-relocation-not-supported', u'relocation-not-supported-due-to-PUESBINE-feature', u'relocation-failure-in-target-RNC', u'relocation-target-not-allowed', u'requested-ciphering-and-or-integrity-protection-algorithms-not-supported', u'sixtyfourQAM-DL-and-MIMO-Combined-not-supported', u'tx-diversity-for-mimo-on-DL-control-channels-not-available', u'single-Stream-MIMO-not-supported', u'single-Stream-MIMO-not-available', u'multi-Cell-operation-with-MIMO-not-supported', u'multi-Cell-operation-with-MIMO-not-available', u'multi-Cell-EDCH-operation-not-supported', u'multi-Cell-EDCH-operation-not-available', u'multi-Cell-operation-with-Single-Stream-MIMO-not-supported', u'multi-Cell-operation-with-Single-Stream-MIMO-not-available', u'cellSpecificTxDiversityHandlingForMultiCellOperationNotAvailable', u'cellSpecificTxDiversityHandlingForMultiCellOperationNotSupported', u'frequencySpecificCompressedModeNotAvailable', u'uL-CLTD-Operation-not-available', u'uL-CLTD-Operation-not-supported', u'mimo-withfourtransmitantennas-not-supported', u'mimo-withfourtransmitantennas-not-available', u'dualstream-mimo-withfourtransmitantennas-not-supported', u'dualstream-mimo-withfourtransmitantennas-not-available', u'multiflow-operation-not-supported', u'multiflow-operation-not-available', u'ul-SixtyfourQAM-not-available', u'ul-SixtyfourQAM-not-supported', u'ul-MIMO-Operation-not-available', u'uL-MIMO-Operation-not-supported', u'ul-MIMO-SixteenQAM-Operation-not-available', u'uL-MIMO-SixteenQAM-Operation-not-supported', u'ul-MIMO-SixtyfourQAM-Operation-not-available', u'uL-MIMO-SixtyfourQAM-Operation-not-supported', u'e-DCH-Decoupling-operation-not-available', u'e-DCH-Decoupling-operation-not-supported', u'basic-dch-enh-not-available', u'basic-dch-enh-not-supported', u'full-dch-enh-not-available', u'full-dch-enh-not-supported', u'radio-Links-without-DPCH-FDPCH-Indication-operation-not-available', u'radio-Links-without-DPCH-FDPCH-Indication-operation-not-supported', u'uL-DPCCH2-operation-not-available', u'uL-DPCCH2-operation-not-supported', u'downlink-TPC-enhancements-operation-not-available', u'downlink-TPC-enhancements-operation-not-supported', u'dual-Cell-EDCH-enhancements-with-10ms-and-10ms-TTI-operation-not-available', u'dual-Cell-EDCH-enhancements-with-10ms-and-10ms-TTI-operation-not-supported', u'dual-Cell-EDCH-enhancements-with-different-TTI-operation-not-available', u'dual-Cell-EDCH-enhancements-with-different-TTI-operation-not-supported']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name=u'CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([(u'transport-resource-unavailable', 0), (u'unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CellBased >-----#
    CellBased = SEQ(name=u'CellBased', mode=MODE_TYPE)
    _CellBased_cellIdList = SEQ_OF(name=u'cellIdList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellIdList')))
    _CellBased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CellBased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CellBased_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__id._const_tab = ____CellBased_iE_Extensions__item__id_tab
    ___CellBased_iE_Extensions__item__id._const_tab_at = None
    ___CellBased_iE_Extensions__item__id._const_tab_id = u'id'
    ___CellBased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CellBased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__criticality._const_tab = ____CellBased_iE_Extensions__item__criticality_tab
    ___CellBased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CellBased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CellBased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CellBased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__extensionValue._const_tab = ____CellBased_iE_Extensions__item__extensionValue_tab
    ___CellBased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CellBased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CellBased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CellBased_iE_Extensions__item__id),
        (u'criticality', ___CellBased_iE_Extensions__item__criticality),
        (u'extensionValue', ___CellBased_iE_Extensions__item__extensionValue),
        ])
    __CellBased_iE_Extensions__item_._ext = None
    _CellBased_iE_Extensions._cont = __CellBased_iE_Extensions__item_
    _CellBased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBased._cont = ASN1Dict([
        (u'cellIdList', _CellBased_cellIdList),
        (u'iE-Extensions', _CellBased_iE_Extensions),
        ])
    CellBased._ext = []
    
    #-----< CellBased-ExtIEs >-----#
    CellBased_ExtIEs = CLASS(name=u'CellBased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellBased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdList >-----#
    CellIdList = SEQ_OF(name=u'CellIdList', mode=MODE_TYPE)
    _CellIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Id')))
    CellIdList._cont = _CellIdList__item_
    CellIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cell-Id >-----#
    Cell_Id = INT(name=u'Cell-Id', mode=MODE_TYPE)
    Cell_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    
    #-----< CellCapabilityContainer-FDD >-----#
    CellCapabilityContainer_FDD = BIT_STR(name=u'CellCapabilityContainer-FDD', mode=MODE_TYPE)
    CellCapabilityContainer_FDD._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< CellCapabilityContainerExtension-FDD >-----#
    CellCapabilityContainerExtension_FDD = BIT_STR(name=u'CellCapabilityContainerExtension-FDD', mode=MODE_TYPE)
    CellCapabilityContainerExtension_FDD._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< CellCapabilityContainer-TDD >-----#
    CellCapabilityContainer_TDD = BIT_STR(name=u'CellCapabilityContainer-TDD', mode=MODE_TYPE)
    CellCapabilityContainer_TDD._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< CellCapabilityContainer-TDD-LCR >-----#
    CellCapabilityContainer_TDD_LCR = BIT_STR(name=u'CellCapabilityContainer-TDD-LCR', mode=MODE_TYPE)
    CellCapabilityContainer_TDD_LCR._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< CellCapabilityContainerExtension-TDD-LCR >-----#
    CellCapabilityContainerExtension_TDD_LCR = BIT_STR(name=u'CellCapabilityContainerExtension-TDD-LCR', mode=MODE_TYPE)
    CellCapabilityContainerExtension_TDD_LCR._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< CellCapabilityContainer-TDD768 >-----#
    CellCapabilityContainer_TDD768 = BIT_STR(name=u'CellCapabilityContainer-TDD768', mode=MODE_TYPE)
    CellCapabilityContainer_TDD768._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< C-ID >-----#
    C_ID = INT(name=u'C-ID', mode=MODE_TYPE)
    C_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< CCTrCH-ID >-----#
    CCTrCH_ID = INT(name=u'CCTrCH-ID', mode=MODE_TYPE)
    CCTrCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Cell-Capacity-Class-Value >-----#
    Cell_Capacity_Class_Value = SEQ(name=u'Cell-Capacity-Class-Value', mode=MODE_TYPE)
    _Cell_Capacity_Class_Value_uplinkCellCapacityClassValue = INT(name=u'uplinkCellCapacityClassValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Cell_Capacity_Class_Value_uplinkCellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    _Cell_Capacity_Class_Value_downlinkCellCapacityClassValue = INT(name=u'downlinkCellCapacityClassValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Cell_Capacity_Class_Value_downlinkCellCapacityClassValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    Cell_Capacity_Class_Value._cont = ASN1Dict([
        (u'uplinkCellCapacityClassValue', _Cell_Capacity_Class_Value_uplinkCellCapacityClassValue),
        (u'downlinkCellCapacityClassValue', _Cell_Capacity_Class_Value_downlinkCellCapacityClassValue),
        ])
    Cell_Capacity_Class_Value._ext = None
    
    #-----< CellIndividualOffset >-----#
    CellIndividualOffset = INT(name=u'CellIndividualOffset', mode=MODE_TYPE)
    CellIndividualOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20, ub=20)], ev=None, er=[])
    
    #-----< CellListValidityIndicator >-----#
    CellListValidityIndicator = ENUM(name=u'CellListValidityIndicator', mode=MODE_TYPE)
    CellListValidityIndicator._cont = ASN1Dict([(u'ignoreSecondaryServingCellList', 0), (u'ignoreDualBandSecondaryServingCellList', 1), (u'ignoreBoth', 2)])
    CellListValidityIndicator._ext = None
    
    #-----< CellParameterID >-----#
    CellParameterID = INT(name=u'CellParameterID', mode=MODE_TYPE)
    CellParameterID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< CellPortionID >-----#
    CellPortionID = INT(name=u'CellPortionID', mode=MODE_TYPE)
    CellPortionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=[], er=[])
    
    #-----< CellPortionLCRID >-----#
    CellPortionLCRID = INT(name=u'CellPortionLCRID', mode=MODE_TYPE)
    CellPortionLCRID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< CFN >-----#
    CFN = INT(name=u'CFN', mode=MODE_TYPE)
    CFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< CGI >-----#
    CGI = SEQ(name=u'CGI', mode=MODE_TYPE)
    _CGI_lAI = SEQ(name=u'lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAI')))
    _CGI_cI = OCT_STR(name=u'cI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CI')))
    _CGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__id._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__id._const_tab_at = None
    ___CGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___CGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__criticality._const_tab = ____CGI_iE_Extensions__item__criticality_tab
    ___CGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__extensionValue._const_tab = ____CGI_iE_Extensions__item__extensionValue_tab
    ___CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CGI_iE_Extensions__item__id),
        (u'criticality', ___CGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___CGI_iE_Extensions__item__extensionValue),
        ])
    __CGI_iE_Extensions__item_._ext = None
    _CGI_iE_Extensions._cont = __CGI_iE_Extensions__item_
    _CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI._cont = ASN1Dict([
        (u'lAI', _CGI_lAI),
        (u'cI', _CGI_cI),
        (u'iE-Extensions', _CGI_iE_Extensions),
        ])
    CGI._ext = None
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name=u'LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI-ExtIEs >-----#
    CGI_ExtIEs = CLASS(name=u'CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ChannelCodingType >-----#
    ChannelCodingType = ENUM(name=u'ChannelCodingType', mode=MODE_TYPE)
    ChannelCodingType._cont = ASN1Dict([(u'no-codingTDD', 0), (u'convolutional-coding', 1), (u'turbo-coding', 2)])
    ChannelCodingType._ext = []
    
    #-----< ChipOffset >-----#
    ChipOffset = INT(name=u'ChipOffset', mode=MODE_TYPE)
    ChipOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38399)], ev=None, er=[])
    
    #-----< CI >-----#
    CI = OCT_STR(name=u'CI', mode=MODE_TYPE)
    CI._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ClassmarkInformation2 >-----#
    ClassmarkInformation2 = OCT_STR(name=u'ClassmarkInformation2', mode=MODE_TYPE)
    
    #-----< ClassmarkInformation3 >-----#
    ClassmarkInformation3 = OCT_STR(name=u'ClassmarkInformation3', mode=MODE_TYPE)
    
    #-----< ClosedLoopMode1-SupportIndicator >-----#
    ClosedLoopMode1_SupportIndicator = ENUM(name=u'ClosedLoopMode1-SupportIndicator', mode=MODE_TYPE)
    ClosedLoopMode1_SupportIndicator._cont = ASN1Dict([(u'closedLoop-Mode1-Supported', 0), (u'closedLoop-Mode1-not-Supported', 1)])
    ClosedLoopMode1_SupportIndicator._ext = None
    
    #-----< Closedlooptimingadjustmentmode >-----#
    Closedlooptimingadjustmentmode = ENUM(name=u'Closedlooptimingadjustmentmode', mode=MODE_TYPE)
    Closedlooptimingadjustmentmode._cont = ASN1Dict([(u'adj-1-slot', 0), (u'adj-2-slot', 1)])
    Closedlooptimingadjustmentmode._ext = []
    
    #-----< CodingRate >-----#
    CodingRate = ENUM(name=u'CodingRate', mode=MODE_TYPE)
    CodingRate._cont = ASN1Dict([(u'half', 0), (u'third', 1)])
    CodingRate._ext = []
    
    #-----< CommonMeasurementAccuracy >-----#
    CommonMeasurementAccuracy = CHOICE(name=u'CommonMeasurementAccuracy', mode=MODE_TYPE)
    _CommonMeasurementAccuracy_tUTRANGPSMeasurementAccuracyClass = ENUM(name=u'tUTRANGPSMeasurementAccuracyClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSAccuracyClass')))
    _CommonMeasurementAccuracy_tUTRANGANSSMeasurementAccuracyClass = ENUM(name=u'tUTRANGANSSMeasurementAccuracyClass', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGANSSAccuracyClass')))
    CommonMeasurementAccuracy._cont = ASN1Dict([
        (u'tUTRANGPSMeasurementAccuracyClass', _CommonMeasurementAccuracy_tUTRANGPSMeasurementAccuracyClass),
        (u'tUTRANGANSSMeasurementAccuracyClass', _CommonMeasurementAccuracy_tUTRANGANSSMeasurementAccuracyClass),
        ])
    CommonMeasurementAccuracy._ext = [u'tUTRANGANSSMeasurementAccuracyClass']
    
    #-----< CommonMeasurementType >-----#
    CommonMeasurementType = ENUM(name=u'CommonMeasurementType', mode=MODE_TYPE)
    CommonMeasurementType._cont = ASN1Dict([(u'uTRAN-GPS-timing-of-cell-frames-for-UE-Positioning', 0), (u'sFN-SFN-observerd-time-difference', 1), (u'load', 2), (u'transmitted-carrier-power', 3), (u'received-total-wide-band-power', 4), (u'uplink-timeslot-iscp', 5), (u'rT-load', 6), (u'nRT-load-Information', 7), (u'upPTSInterference', 8), (u'uTRAN-GANSS-timing-of-cell-frames-for-UE-Positioning', 9)])
    CommonMeasurementType._ext = [u'rT-load', u'nRT-load-Information', u'upPTSInterference', u'uTRAN-GANSS-timing-of-cell-frames-for-UE-Positioning']
    
    #-----< CommonMeasurementValue >-----#
    CommonMeasurementValue = CHOICE(name=u'CommonMeasurementValue', mode=MODE_TYPE)
    _CommonMeasurementValue_tUTRANGPSMeasurementValueInformation = SEQ(name=u'tUTRANGPSMeasurementValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSMeasurementValueInformation')))
    _CommonMeasurementValue_sFNSFNMeasurementValueInformation = SEQ(name=u'sFNSFNMeasurementValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNMeasurementValueInformation')))
    _CommonMeasurementValue_loadValue = SEQ(name=u'loadValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LoadValue')))
    _CommonMeasurementValue_transmittedCarrierPowerValue = INT(name=u'transmittedCarrierPowerValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementValue_transmittedCarrierPowerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _CommonMeasurementValue_receivedTotalWideBandPowerValue = INT(name=u'receivedTotalWideBandPowerValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CommonMeasurementValue_receivedTotalWideBandPowerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    _CommonMeasurementValue_uplinkTimeslotISCPValue = INT(name=u'uplinkTimeslotISCPValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotISCP')))
    _CommonMeasurementValue_extension_CommonMeasurementValue = SEQ(name=u'extension-CommonMeasurementValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-CommonMeasurementValue')))
    CommonMeasurementValue._cont = ASN1Dict([
        (u'tUTRANGPSMeasurementValueInformation', _CommonMeasurementValue_tUTRANGPSMeasurementValueInformation),
        (u'sFNSFNMeasurementValueInformation', _CommonMeasurementValue_sFNSFNMeasurementValueInformation),
        (u'loadValue', _CommonMeasurementValue_loadValue),
        (u'transmittedCarrierPowerValue', _CommonMeasurementValue_transmittedCarrierPowerValue),
        (u'receivedTotalWideBandPowerValue', _CommonMeasurementValue_receivedTotalWideBandPowerValue),
        (u'uplinkTimeslotISCPValue', _CommonMeasurementValue_uplinkTimeslotISCPValue),
        (u'extension-CommonMeasurementValue', _CommonMeasurementValue_extension_CommonMeasurementValue),
        ])
    CommonMeasurementValue._ext = [u'extension-CommonMeasurementValue']
    
    #-----< CommonMeasurementValueInformation >-----#
    CommonMeasurementValueInformation = CHOICE(name=u'CommonMeasurementValueInformation', mode=MODE_TYPE)
    _CommonMeasurementValueInformation_measurementAvailable = SEQ(name=u'measurementAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementAvailable')))
    _CommonMeasurementValueInformation_measurementnotAvailable = NULL(name=u'measurementnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CommonMeasurementValueInformation._cont = ASN1Dict([
        (u'measurementAvailable', _CommonMeasurementValueInformation_measurementAvailable),
        (u'measurementnotAvailable', _CommonMeasurementValueInformation_measurementnotAvailable),
        ])
    CommonMeasurementValueInformation._ext = None
    
    #-----< CommonMeasurementAvailable >-----#
    CommonMeasurementAvailable = SEQ(name=u'CommonMeasurementAvailable', mode=MODE_TYPE)
    _CommonMeasurementAvailable_commonMeasurementValue = CHOICE(name=u'commonMeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementValue')))
    _CommonMeasurementAvailable_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementAvailable_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementAvailable_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementAvailable_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementAvailable_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementAvailable_iE_Extensions__item__id._const_tab = ____CommonMeasurementAvailable_iE_Extensions__item__id_tab
    ___CommonMeasurementAvailable_iE_Extensions__item__id._const_tab_at = None
    ___CommonMeasurementAvailable_iE_Extensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementAvailable_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CommonMeasurementAvailable_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementAvailable_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementAvailable_iE_Extensions__item__criticality._const_tab = ____CommonMeasurementAvailable_iE_Extensions__item__criticality_tab
    ___CommonMeasurementAvailable_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementAvailable_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementAvailable_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CommonMeasurementAvailable_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CommonMeasurementAvailable_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonMeasurementAvailable_iE_Extensions__item__extensionValue._const_tab = ____CommonMeasurementAvailable_iE_Extensions__item__extensionValue_tab
    ___CommonMeasurementAvailable_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementAvailable_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementAvailable_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementAvailable_iE_Extensions__item__id),
        (u'criticality', ___CommonMeasurementAvailable_iE_Extensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementAvailable_iE_Extensions__item__extensionValue),
        ])
    __CommonMeasurementAvailable_iE_Extensions__item_._ext = None
    _CommonMeasurementAvailable_iE_Extensions._cont = __CommonMeasurementAvailable_iE_Extensions__item_
    _CommonMeasurementAvailable_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementAvailable._cont = ASN1Dict([
        (u'commonMeasurementValue', _CommonMeasurementAvailable_commonMeasurementValue),
        (u'iE-Extensions', _CommonMeasurementAvailable_iE_Extensions),
        ])
    CommonMeasurementAvailable._ext = []
    
    #-----< CommonMeasurementAvailableItem-ExtIEs >-----#
    CommonMeasurementAvailableItem_ExtIEs = CLASS(name=u'CommonMeasurementAvailableItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CommonMeasurementAvailableItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CongestionCause >-----#
    CongestionCause = ENUM(name=u'CongestionCause', mode=MODE_TYPE)
    CongestionCause._cont = ASN1Dict([(u'uTRAN-dynamic-resources', 0), (u'uTRAN-semistatic-resources', 1)])
    CongestionCause._ext = []
    
    #-----< CommonTransportChannelResourcesInitialisationNotRequired >-----#
    CommonTransportChannelResourcesInitialisationNotRequired = ENUM(name=u'CommonTransportChannelResourcesInitialisationNotRequired', mode=MODE_TYPE)
    CommonTransportChannelResourcesInitialisationNotRequired._cont = ASN1Dict([(u'not-Required', 0)])
    CommonTransportChannelResourcesInitialisationNotRequired._ext = None
    
    #-----< Common-EDCH-MAC-d-Flow-Specific-InformationFDD >-----#
    Common_EDCH_MAC_d_Flow_Specific_InformationFDD = SEQ_OF(name=u'Common-EDCH-MAC-d-Flow-Specific-InformationFDD', mode=MODE_TYPE)
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem')))
    Common_EDCH_MAC_d_Flow_Specific_InformationFDD._cont = _Common_EDCH_MAC_d_Flow_Specific_InformationFDD__item_
    Common_EDCH_MAC_d_Flow_Specific_InformationFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem >-----#
    Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem = SEQ(name=u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem', mode=MODE_TYPE)
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_common_EDCH_MACdFlow_ID = INT(name=u'common-EDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_maximum_Number_of_Retransmissions_For_E_DCH = INT(name=u'maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_eDCH_HARQ_PO_FDD = INT(name=u'eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-HARQ-PO-FDD')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_common_E_DCHLogicalChannelInformation = SEQ_OF(name=u'common-E-DCHLogicalChannelInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-DCH-LogicalChannelInformation')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id._const_tab = ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id_tab
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality._const_tab = ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality_tab
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue._const_tab = ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue_tab
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id),
        (u'criticality', ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue),
        ])
    __Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item_._ext = None
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions._cont = __Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item_
    _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem._cont = ASN1Dict([
        (u'common-EDCH-MACdFlow-ID', _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_common_EDCH_MACdFlow_ID),
        (u'maximum-Number-of-Retransmissions-For-E-DCH', _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_maximum_Number_of_Retransmissions_For_E_DCH),
        (u'eDCH-HARQ-PO-FDD', _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_eDCH_HARQ_PO_FDD),
        (u'eDCH-MACdFlow-Multiplexing-List', _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_eDCH_MACdFlow_Multiplexing_List),
        (u'common-E-DCHLogicalChannelInformation', _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_common_E_DCHLogicalChannelInformation),
        (u'iE-Extensions', _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions),
        ])
    Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem._ext = []
    
    #-----< Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem-ExtIEs >-----#
    Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_ExtIEs = CLASS(name=u'Common-EDCH-MAC-d-Flow-Specific-InformationFDDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-EDCH-MAC-d-Flow-Specific-InformationLCR >-----#
    Common_EDCH_MAC_d_Flow_Specific_InformationLCR = SEQ_OF(name=u'Common-EDCH-MAC-d-Flow-Specific-InformationLCR', mode=MODE_TYPE)
    _Common_EDCH_MAC_d_Flow_Specific_InformationLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR')))
    Common_EDCH_MAC_d_Flow_Specific_InformationLCR._cont = _Common_EDCH_MAC_d_Flow_Specific_InformationLCR__item_
    Common_EDCH_MAC_d_Flow_Specific_InformationLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR >-----#
    Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR = SEQ(name=u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR', mode=MODE_TYPE)
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_common_EDCH_MACdFlow_ID_LCR = INT(name=u'common-EDCH-MACdFlow-ID-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID-LCR')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_maximum_Number_of_Retransmissions_For_E_DCH = INT(name=u'maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_eDCH_HARQ_PO_TDD = INT(name=u'eDCH-HARQ-PO-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-HARQ-PO-TDD')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_common_E_DCHLogicalChannelInformation = SEQ_OF(name=u'common-E-DCHLogicalChannelInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-DCH-LogicalChannelInformation')))
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id._const_tab = ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id_tab
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id._const_tab_at = None
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality._const_tab = ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality_tab
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue._const_tab = ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue_tab
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id),
        (u'criticality', ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue),
        ])
    __Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item_._ext = None
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions._cont = __Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item_
    _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR._cont = ASN1Dict([
        (u'common-EDCH-MACdFlow-ID-LCR', _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_common_EDCH_MACdFlow_ID_LCR),
        (u'maximum-Number-of-Retransmissions-For-E-DCH', _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_maximum_Number_of_Retransmissions_For_E_DCH),
        (u'eDCH-HARQ-PO-TDD', _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_eDCH_HARQ_PO_TDD),
        (u'eDCH-MACdFlow-Multiplexing-List', _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_eDCH_MACdFlow_Multiplexing_List),
        (u'common-E-DCHLogicalChannelInformation', _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_common_E_DCHLogicalChannelInformation),
        (u'iE-Extensions', _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions),
        ])
    Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR._ext = []
    
    #-----< Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR-ExtIEs >-----#
    Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_ExtIEs = CLASS(name=u'Common-EDCH-MAC-d-Flow-Specific-InformationItemLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-DCH-LogicalChannelInformation >-----#
    Common_E_DCH_LogicalChannelInformation = SEQ_OF(name=u'Common-E-DCH-LogicalChannelInformation', mode=MODE_TYPE)
    _Common_E_DCH_LogicalChannelInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-DCH-LogicalChannelInformationItem')))
    Common_E_DCH_LogicalChannelInformation._cont = _Common_E_DCH_LogicalChannelInformation__item_
    Common_E_DCH_LogicalChannelInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Common-E-DCH-LogicalChannelInformationItem >-----#
    Common_E_DCH_LogicalChannelInformationItem = SEQ(name=u'Common-E-DCH-LogicalChannelInformationItem', mode=MODE_TYPE)
    _Common_E_DCH_LogicalChannelInformationItem_logicalChannelId = INT(name=u'logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LogicalChannelID')))
    _Common_E_DCH_LogicalChannelInformationItem_maximumMACdPDU_SizeExtended = INT(name=u'maximumMACdPDU-SizeExtended', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _Common_E_DCH_LogicalChannelInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab = ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab = ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality_tab
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue_tab
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item_._ext = None
    _Common_E_DCH_LogicalChannelInformationItem_iE_Extensions._cont = __Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item_
    _Common_E_DCH_LogicalChannelInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_DCH_LogicalChannelInformationItem._cont = ASN1Dict([
        (u'logicalChannelId', _Common_E_DCH_LogicalChannelInformationItem_logicalChannelId),
        (u'maximumMACdPDU-SizeExtended', _Common_E_DCH_LogicalChannelInformationItem_maximumMACdPDU_SizeExtended),
        (u'iE-Extensions', _Common_E_DCH_LogicalChannelInformationItem_iE_Extensions),
        ])
    Common_E_DCH_LogicalChannelInformationItem._ext = []
    
    #-----< Common-E-DCH-LogicalChannelInformationItem-ExtIEs >-----#
    Common_E_DCH_LogicalChannelInformationItem_ExtIEs = CLASS(name=u'Common-E-DCH-LogicalChannelInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Common_E_DCH_LogicalChannelInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-EDCH-Support-Indicator >-----#
    Common_EDCH_Support_Indicator = NULL(name=u'Common-EDCH-Support-Indicator', mode=MODE_TYPE)
    
    #-----< Common-E-RGCH-Cell-Information >-----#
    Common_E_RGCH_Cell_Information = CHOICE(name=u'Common-E-RGCH-Cell-Information', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_Information_deActivation = NULL(name=u'deActivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-RGCH-De-Activation')))
    _Common_E_RGCH_Cell_Information_common_E_RGCH_Cell_Info = SEQ(name=u'common-E-RGCH-Cell-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-RGCH-Cell-Info')))
    Common_E_RGCH_Cell_Information._cont = ASN1Dict([
        (u'deActivation', _Common_E_RGCH_Cell_Information_deActivation),
        (u'common-E-RGCH-Cell-Info', _Common_E_RGCH_Cell_Information_common_E_RGCH_Cell_Info),
        ])
    Common_E_RGCH_Cell_Information._ext = []
    
    #-----< Common-E-RGCH-Cell-Info >-----#
    Common_E_RGCH_Cell_Info = SEQ(name=u'Common-E-RGCH-Cell-Info', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_Info_eRGCH_ChannelisationCode = INT(name=u'eRGCH-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Common_E_RGCH_Cell_Info_eRGCH_SignatureSequence = INT(name=u'eRGCH-SignatureSequence', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ERGCH-SignatureSequence')))
    _Common_E_RGCH_Cell_Info_serving_Grant_Value = INT(name=u'serving-Grant-Value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-Serving-Grant-Value')), opt=True)
    Common_E_RGCH_Cell_Info._cont = ASN1Dict([
        (u'eRGCH-ChannelisationCode', _Common_E_RGCH_Cell_Info_eRGCH_ChannelisationCode),
        (u'eRGCH-SignatureSequence', _Common_E_RGCH_Cell_Info_eRGCH_SignatureSequence),
        (u'serving-Grant-Value', _Common_E_RGCH_Cell_Info_serving_Grant_Value),
        ])
    Common_E_RGCH_Cell_Info._ext = []
    
    #-----< Common-E-RGCH-De-Activation >-----#
    Common_E_RGCH_De_Activation = NULL(name=u'Common-E-RGCH-De-Activation', mode=MODE_TYPE)
    
    #-----< CompleteAlmanacProvided >-----#
    CompleteAlmanacProvided = BOOL(name=u'CompleteAlmanacProvided', mode=MODE_TYPE)
    
    #-----< Continuous-Packet-Connectivity-DTX-DRX-Information >-----#
    Continuous_Packet_Connectivity_DTX_DRX_Information = SEQ(name=u'Continuous-Packet-Connectivity-DTX-DRX-Information', mode=MODE_TYPE)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_uE_DTX_DRX_Offset = INT(name=u'uE-DTX-DRX-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-DRX-Offset')))
    _Continuous_Packet_Connectivity_DTX_DRX_Information_enabling_Delay = ENUM(name=u'enabling-Delay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Enabling-Delay')))
    _Continuous_Packet_Connectivity_DTX_DRX_Information_dTX_Information = SEQ(name=u'dTX-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Information')))
    _Continuous_Packet_Connectivity_DTX_DRX_Information_dRX_Information = SEQ(name=u'dRX-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DRX-Information')), opt=True)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id._const_tab = ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id_tab
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id._const_tab_at = None
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality._const_tab = ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality_tab
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue._const_tab = ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue_tab
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id),
        (u'criticality', ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue),
        ])
    __Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item_._ext = None
    _Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions._cont = __Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item_
    _Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Continuous_Packet_Connectivity_DTX_DRX_Information._cont = ASN1Dict([
        (u'uE-DTX-DRX-Offset', _Continuous_Packet_Connectivity_DTX_DRX_Information_uE_DTX_DRX_Offset),
        (u'enabling-Delay', _Continuous_Packet_Connectivity_DTX_DRX_Information_enabling_Delay),
        (u'dTX-Information', _Continuous_Packet_Connectivity_DTX_DRX_Information_dTX_Information),
        (u'dRX-Information', _Continuous_Packet_Connectivity_DTX_DRX_Information_dRX_Information),
        (u'iE-Extensions', _Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions),
        ])
    Continuous_Packet_Connectivity_DTX_DRX_Information._ext = []
    
    #-----< Continuous-Packet-Connectivity-DTX-DRX-Information-ExtIEs >-----#
    Continuous_Packet_Connectivity_DTX_DRX_Information_ExtIEs = CLASS(name=u'Continuous-Packet-Connectivity-DTX-DRX-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Continuous_Packet_Connectivity_DTX_DRX_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify >-----#
    Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify = SEQ(name=u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify', mode=MODE_TYPE)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_uE_DTX_DRX_Offset = INT(name=u'uE-DTX-DRX-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-DRX-Offset')), opt=True)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_enabling_Delay = ENUM(name=u'enabling-Delay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Enabling-Delay')), opt=True)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_dTX_Information_to_Modify = CHOICE(name=u'dTX-Information-to-Modify', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Information-to-Modify')), opt=True)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_dRX_Information_to_Modify = CHOICE(name=u'dRX-Information-to-Modify', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DRX-Information-to-Modify')), opt=True)
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id._const_tab = ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item_._ext = None
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions._cont = __Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item_
    _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify._cont = ASN1Dict([
        (u'uE-DTX-DRX-Offset', _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_uE_DTX_DRX_Offset),
        (u'enabling-Delay', _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_enabling_Delay),
        (u'dTX-Information-to-Modify', _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_dTX_Information_to_Modify),
        (u'dRX-Information-to-Modify', _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_dRX_Information_to_Modify),
        (u'iE-Extensions', _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions),
        ])
    Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify._ext = []
    
    #-----< Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify-ExtIEs >-----#
    Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_ExtIEs = CLASS(name=u'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Continuous-Packet-Connectivity-HS-SCCH-Less-Information >-----#
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information = SEQ_OF(name=u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information', mode=MODE_TYPE)
    _Continuous_Packet_Connectivity_HS_SCCH_Less_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem')))
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information._cont = _Continuous_Packet_Connectivity_HS_SCCH_Less_Information__item_
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem >-----#
    Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem = SEQ(name=u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem', mode=MODE_TYPE)
    _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_transport_Block_Size_Index = INT(name=u'transport-Block-Size-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-Index')))
    _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_hSPDSCH_Second_Code_Support = BOOL(name=u'hSPDSCH-Second-Code-Support', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-Second-Code-Support')))
    _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id._const_tab = ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id_tab
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality._const_tab = ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality_tab
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item_._ext = None
    _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions._cont = __Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item_
    _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem._cont = ASN1Dict([
        (u'transport-Block-Size-Index', _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_transport_Block_Size_Index),
        (u'hSPDSCH-Second-Code-Support', _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_hSPDSCH_Second_Code_Support),
        (u'iE-Extensions', _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions),
        ])
    Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem._ext = []
    
    #-----< Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem-ExtIEs >-----#
    Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_ExtIEs = CLASS(name=u'Continuous-Packet-Connectivity-HS-SCCH-Less-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response >-----#
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response = SEQ(name=u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response', mode=MODE_TYPE)
    _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_hSPDSCH_First_Code_Index = INT(name=u'hSPDSCH-First-Code-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-First-Code-Index')))
    _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_hSPDSCH_Second_Code_Index = INT(name=u'hSPDSCH-Second-Code-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-Second-Code-Index')), opt=True)
    _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id._const_tab = ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id_tab
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality._const_tab = ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality_tab
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue_tab
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item_._ext = None
    _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions._cont = __Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item_
    _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response._cont = ASN1Dict([
        (u'hSPDSCH-First-Code-Index', _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_hSPDSCH_First_Code_Index),
        (u'hSPDSCH-Second-Code-Index', _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_hSPDSCH_Second_Code_Index),
        (u'iE-Extensions', _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions),
        ])
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response._ext = []
    
    #-----< Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response-ExtIEs >-----#
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_ExtIEs = CLASS(name=u'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CorrespondingCells >-----#
    CorrespondingCells = SEQ_OF(name=u'CorrespondingCells', mode=MODE_TYPE)
    _CorrespondingCells__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    CorrespondingCells._cont = _CorrespondingCells__item_
    CorrespondingCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< CoverageIndicator >-----#
    CoverageIndicator = ENUM(name=u'CoverageIndicator', mode=MODE_TYPE)
    CoverageIndicator._cont = ASN1Dict([(u'overlap', 0), (u'covers', 1), (u'containedIn', 2)])
    CoverageIndicator._ext = []
    
    #-----< CPC-Information >-----#
    CPC_Information = SEQ(name=u'CPC-Information', mode=MODE_TYPE)
    _CPC_Information_continuous_Packet_Connectivity_DTX_DRX_Information = SEQ(name=u'continuous-Packet-Connectivity-DTX-DRX-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-DTX-DRX-Information')), opt=True)
    _CPC_Information_continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify = SEQ(name=u'continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify')), opt=True)
    _CPC_Information_continuous_Packet_Connectivity_HS_SCCH_Less_Information = SEQ_OF(name=u'continuous-Packet-Connectivity-HS-SCCH-Less-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information')), opt=True)
    _CPC_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CPC_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CPC_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CPC_Information_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-less-Deactivate-Indicator')))
    ____CPC_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 740), (u'criticality', u'reject'), (u'Extension', _____CPC_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CPC_Information_iE_Extensions__item__id._const_tab = ____CPC_Information_iE_Extensions__item__id_tab
    ___CPC_Information_iE_Extensions__item__id._const_tab_at = None
    ___CPC_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___CPC_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CPC_Information_iE_Extensions__item__criticality._const_tab = ____CPC_Information_iE_Extensions__item__id_tab
    ___CPC_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CPC_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CPC_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CPC_Information_iE_Extensions__item__extensionValue._const_tab = ____CPC_Information_iE_Extensions__item__id_tab
    ___CPC_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CPC_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CPC_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CPC_Information_iE_Extensions__item__id),
        (u'criticality', ___CPC_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___CPC_Information_iE_Extensions__item__extensionValue),
        ])
    __CPC_Information_iE_Extensions__item_._ext = None
    _CPC_Information_iE_Extensions._cont = __CPC_Information_iE_Extensions__item_
    _CPC_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_Information._cont = ASN1Dict([
        (u'continuous-Packet-Connectivity-DTX-DRX-Information', _CPC_Information_continuous_Packet_Connectivity_DTX_DRX_Information),
        (u'continuous-Packet-Connectivity-DTX-DRX-Information-to-Modify', _CPC_Information_continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify),
        (u'continuous-Packet-Connectivity-HS-SCCH-Less-Information', _CPC_Information_continuous_Packet_Connectivity_HS_SCCH_Less_Information),
        (u'iE-Extensions', _CPC_Information_iE_Extensions),
        ])
    CPC_Information._ext = []
    
    #-----< CPC-Information-ExtIEs >-----#
    CPC_Information_ExtIEs = CLASS(name=u'CPC-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CPC_Information_ExtIEs_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-less-Deactivate-Indicator')))
    CPC_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 740), (u'criticality', u'reject'), (u'Extension', _CPC_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CPC-RecoveryReport >-----#
    CPC_RecoveryReport = ENUM(name=u'CPC-RecoveryReport', mode=MODE_TYPE)
    CPC_RecoveryReport._cont = ASN1Dict([(u'initiated', 0)])
    CPC_RecoveryReport._ext = []
    
    #-----< Continuous-Packet-Connectivity-HS-SCCH-less-Deactivate-Indicator >-----#
    Continuous_Packet_Connectivity_HS_SCCH_less_Deactivate_Indicator = NULL(name=u'Continuous-Packet-Connectivity-HS-SCCH-less-Deactivate-Indicator', mode=MODE_TYPE)
    
    #-----< Counting-Information >-----#
    Counting_Information = SEQ_OF(name=u'Counting-Information', mode=MODE_TYPE)
    _Counting_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Counting-Information-List')))
    Counting_Information._cont = _Counting_Information__item_
    Counting_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Counting-Information-List >-----#
    Counting_Information_List = SEQ(name=u'Counting-Information-List', mode=MODE_TYPE)
    _Counting_Information_List_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Counting_Information_List_counting_Result = INT(name=u'counting-Result', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Counting-Result')))
    _Counting_Information_List_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Counting_Information_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Counting_Information_List_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Counting_Information_List_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Counting_Information_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Counting_Information_List_iE_Extensions__item__id._const_tab = ____Counting_Information_List_iE_Extensions__item__id_tab
    ___Counting_Information_List_iE_Extensions__item__id._const_tab_at = None
    ___Counting_Information_List_iE_Extensions__item__id._const_tab_id = u'id'
    ___Counting_Information_List_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Counting_Information_List_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Counting_Information_List_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Counting_Information_List_iE_Extensions__item__criticality._const_tab = ____Counting_Information_List_iE_Extensions__item__criticality_tab
    ___Counting_Information_List_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Counting_Information_List_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Counting_Information_List_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Counting_Information_List_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Counting_Information_List_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Counting_Information_List_iE_Extensions__item__extensionValue._const_tab = ____Counting_Information_List_iE_Extensions__item__extensionValue_tab
    ___Counting_Information_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Counting_Information_List_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Counting_Information_List_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Counting_Information_List_iE_Extensions__item__id),
        (u'criticality', ___Counting_Information_List_iE_Extensions__item__criticality),
        (u'extensionValue', ___Counting_Information_List_iE_Extensions__item__extensionValue),
        ])
    __Counting_Information_List_iE_Extensions__item_._ext = None
    _Counting_Information_List_iE_Extensions._cont = __Counting_Information_List_iE_Extensions__item_
    _Counting_Information_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Counting_Information_List._cont = ASN1Dict([
        (u'c-ID', _Counting_Information_List_c_ID),
        (u'counting-Result', _Counting_Information_List_counting_Result),
        (u'iE-Extensions', _Counting_Information_List_iE_Extensions),
        ])
    Counting_Information_List._ext = []
    
    #-----< Counting-Information-List-ExtIEs >-----#
    Counting_Information_List_ExtIEs = CLASS(name=u'Counting-Information-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Counting_Information_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Counting-Result >-----#
    Counting_Result = INT(name=u'Counting-Result', mode=MODE_TYPE)
    Counting_Result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< CRC-Size >-----#
    CRC_Size = ENUM(name=u'CRC-Size', mode=MODE_TYPE)
    CRC_Size._cont = ASN1Dict([(u'v0', 0), (u'v8', 1), (u'v12', 2), (u'v16', 3), (u'v24', 4)])
    CRC_Size._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name=u'CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureID = SEQ(name=u'procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureID')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name=u'triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name=u'procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_transactionID = CHOICE(name=u'transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'TransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name=u'iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = u'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        (u'criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        (u'extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        (u'procedureID', _CriticalityDiagnostics_procedureID),
        (u'triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        (u'procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        (u'transactionID', _CriticalityDiagnostics_transactionID),
        (u'iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        (u'iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name=u'CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name=u'CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name=u'iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__repetitionNumber = INT(name=u'repetitionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionNumber0')), opt=True)
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MessageStructure')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TypeOfError')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'ignore'), (u'Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 140), (u'criticality', u'ignore'), (u'Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        (u'criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        (u'iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        (u'iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        (u'repetitionNumber', __CriticalityDiagnostics_IE_List__item__repetitionNumber),
        (u'iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name=u'CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MessageStructure')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TypeOfError')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 57), (u'criticality', u'ignore'), (u'Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 140), (u'criticality', u'ignore'), (u'Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CN-CS-DomainIdentifier >-----#
    CN_CS_DomainIdentifier = SEQ(name=u'CN-CS-DomainIdentifier', mode=MODE_TYPE)
    _CN_CS_DomainIdentifier_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _CN_CS_DomainIdentifier_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAC')))
    _CN_CS_DomainIdentifier_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CN_CS_DomainIdentifier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CN_CS_DomainIdentifier_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CN_CS_DomainIdentifier_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CN_CS_DomainIdentifier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_CS_DomainIdentifier_iE_Extensions__item__id._const_tab = ____CN_CS_DomainIdentifier_iE_Extensions__item__id_tab
    ___CN_CS_DomainIdentifier_iE_Extensions__item__id._const_tab_at = None
    ___CN_CS_DomainIdentifier_iE_Extensions__item__id._const_tab_id = u'id'
    ___CN_CS_DomainIdentifier_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CN_CS_DomainIdentifier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CN_CS_DomainIdentifier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_CS_DomainIdentifier_iE_Extensions__item__criticality._const_tab = ____CN_CS_DomainIdentifier_iE_Extensions__item__criticality_tab
    ___CN_CS_DomainIdentifier_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CN_CS_DomainIdentifier_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue._const_tab = ____CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue_tab
    ___CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CN_CS_DomainIdentifier_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CN_CS_DomainIdentifier_iE_Extensions__item__id),
        (u'criticality', ___CN_CS_DomainIdentifier_iE_Extensions__item__criticality),
        (u'extensionValue', ___CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue),
        ])
    __CN_CS_DomainIdentifier_iE_Extensions__item_._ext = None
    _CN_CS_DomainIdentifier_iE_Extensions._cont = __CN_CS_DomainIdentifier_iE_Extensions__item_
    _CN_CS_DomainIdentifier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CN_CS_DomainIdentifier._cont = ASN1Dict([
        (u'pLMN-Identity', _CN_CS_DomainIdentifier_pLMN_Identity),
        (u'lAC', _CN_CS_DomainIdentifier_lAC),
        (u'iE-Extensions', _CN_CS_DomainIdentifier_iE_Extensions),
        ])
    CN_CS_DomainIdentifier._ext = None
    
    #-----< CN-CS-DomainIdentifier-ExtIEs >-----#
    CN_CS_DomainIdentifier_ExtIEs = CLASS(name=u'CN-CS-DomainIdentifier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CN_CS_DomainIdentifier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CN-PS-DomainIdentifier >-----#
    CN_PS_DomainIdentifier = SEQ(name=u'CN-PS-DomainIdentifier', mode=MODE_TYPE)
    _CN_PS_DomainIdentifier_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _CN_PS_DomainIdentifier_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAC')))
    _CN_PS_DomainIdentifier_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RAC')))
    _CN_PS_DomainIdentifier_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CN_PS_DomainIdentifier_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CN_PS_DomainIdentifier_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CN_PS_DomainIdentifier_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CN_PS_DomainIdentifier_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_PS_DomainIdentifier_iE_Extensions__item__id._const_tab = ____CN_PS_DomainIdentifier_iE_Extensions__item__id_tab
    ___CN_PS_DomainIdentifier_iE_Extensions__item__id._const_tab_at = None
    ___CN_PS_DomainIdentifier_iE_Extensions__item__id._const_tab_id = u'id'
    ___CN_PS_DomainIdentifier_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CN_PS_DomainIdentifier_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CN_PS_DomainIdentifier_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_PS_DomainIdentifier_iE_Extensions__item__criticality._const_tab = ____CN_PS_DomainIdentifier_iE_Extensions__item__criticality_tab
    ___CN_PS_DomainIdentifier_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CN_PS_DomainIdentifier_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue._const_tab = ____CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue_tab
    ___CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CN_PS_DomainIdentifier_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CN_PS_DomainIdentifier_iE_Extensions__item__id),
        (u'criticality', ___CN_PS_DomainIdentifier_iE_Extensions__item__criticality),
        (u'extensionValue', ___CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue),
        ])
    __CN_PS_DomainIdentifier_iE_Extensions__item_._ext = None
    _CN_PS_DomainIdentifier_iE_Extensions._cont = __CN_PS_DomainIdentifier_iE_Extensions__item_
    _CN_PS_DomainIdentifier_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CN_PS_DomainIdentifier._cont = ASN1Dict([
        (u'pLMN-Identity', _CN_PS_DomainIdentifier_pLMN_Identity),
        (u'lAC', _CN_PS_DomainIdentifier_lAC),
        (u'rAC', _CN_PS_DomainIdentifier_rAC),
        (u'iE-Extensions', _CN_PS_DomainIdentifier_iE_Extensions),
        ])
    CN_PS_DomainIdentifier._ext = None
    
    #-----< CN-PS-DomainIdentifier-ExtIEs >-----#
    CN_PS_DomainIdentifier_ExtIEs = CLASS(name=u'CN-PS-DomainIdentifier-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CN_PS_DomainIdentifier_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNDomainType >-----#
    CNDomainType = ENUM(name=u'CNDomainType', mode=MODE_TYPE)
    CNDomainType._cont = ASN1Dict([(u'cs-domain', 0), (u'ps-domain', 1), (u'i-care', 2)])
    CNDomainType._ext = []
    
    #-----< CQI-DTX-Timer >-----#
    CQI_DTX_Timer = ENUM(name=u'CQI-DTX-Timer', mode=MODE_TYPE)
    CQI_DTX_Timer._cont = ASN1Dict([(u'v0', 0), (u'v1', 1), (u'v2', 2), (u'v4', 3), (u'v8', 4), (u'v16', 5), (u'v32', 6), (u'v64', 7), (u'v128', 8), (u'v256', 9), (u'v512', 10), (u'infinity', 11)])
    CQI_DTX_Timer._ext = None
    
    #-----< CQI-Cycle-Switch-Timer >-----#
    CQI_Cycle_Switch_Timer = ENUM(name=u'CQI-Cycle-Switch-Timer', mode=MODE_TYPE)
    CQI_Cycle_Switch_Timer._cont = ASN1Dict([(u'v4', 0), (u'v8', 1), (u'v16', 2), (u'v32', 3), (u'v64', 4), (u'v128', 5), (u'v256', 6), (u'v512', 7), (u'infinity', 8)])
    CQI_Cycle_Switch_Timer._ext = None
    
    #-----< ControlGAP >-----#
    ControlGAP = INT(name=u'ControlGAP', mode=MODE_TYPE)
    ControlGAP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< CQI-Feedback-Cycle >-----#
    CQI_Feedback_Cycle = ENUM(name=u'CQI-Feedback-Cycle', mode=MODE_TYPE)
    CQI_Feedback_Cycle._cont = ASN1Dict([(u'v0', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v10', 4), (u'v20', 5), (u'v40', 6), (u'v80', 7), (u'v160', 8), (u'v16', 9), (u'v32', 10), (u'v64', 11)])
    CQI_Feedback_Cycle._ext = [u'v16', u'v32', u'v64']
    
    #-----< CQI-Feedback-Cycle2 >-----#
    CQI_Feedback_Cycle2 = ENUM(name=u'CQI-Feedback-Cycle2', mode=MODE_TYPE)
    CQI_Feedback_Cycle2._cont = ASN1Dict([(u'v0', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v16', 4), (u'v10', 5), (u'v20', 6), (u'v32', 7), (u'v40', 8), (u'v64', 9), (u'v80', 10), (u'v160', 11)])
    CQI_Feedback_Cycle2._ext = []
    
    #-----< CQI-Power-Offset >-----#
    CQI_Power_Offset = INT(name=u'CQI-Power-Offset', mode=MODE_TYPE)
    CQI_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[ASN1RangeInt(lb=9, ub=10)])
    
    #-----< CQI-RepetitionFactor >-----#
    CQI_RepetitionFactor = INT(name=u'CQI-RepetitionFactor', mode=MODE_TYPE)
    CQI_RepetitionFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< C-RNTI >-----#
    C_RNTI = INT(name=u'C-RNTI', mode=MODE_TYPE)
    C_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< CodeRate >-----#
    CodeRate = INT(name=u'CodeRate', mode=MODE_TYPE)
    CodeRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< CodeRate-short >-----#
    CodeRate_short = INT(name=u'CodeRate-short', mode=MODE_TYPE)
    CodeRate_short._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CPC-InformationLCR >-----#
    CPC_InformationLCR = SEQ(name=u'CPC-InformationLCR', mode=MODE_TYPE)
    _CPC_InformationLCR_continuousPacketConnectivity_DRX_InformationLCR = SEQ(name=u'continuousPacketConnectivity-DRX-InformationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')), opt=True)
    _CPC_InformationLCR_continuousPacketConnectivity_DRX_Information_to_Modify_LCR = SEQ(name=u'continuousPacketConnectivity-DRX-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR')), opt=True)
    _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_LCR = SEQ(name=u'hS-DSCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')), opt=True)
    _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name=u'hS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR')), opt=True)
    _CPC_InformationLCR_hS_DSCH_SPS_Deactivate_Indicator_LCR = NULL(name=u'hS-DSCH-SPS-Deactivate-Indicator-LCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_LCR = SEQ(name=u'e-DCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')), opt=True)
    _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name=u'e-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR')), opt=True)
    _CPC_InformationLCR_e_DCH_SPS_Deactivate_Indicator_LCR = NULL(name=u'e-DCH-SPS-Deactivate-Indicator-LCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPC_InformationLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CPC_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CPC_InformationLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CPC_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CPC_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_InformationLCR_iE_Extensions__item__id._const_tab = ____CPC_InformationLCR_iE_Extensions__item__id_tab
    ___CPC_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___CPC_InformationLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___CPC_InformationLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CPC_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CPC_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_InformationLCR_iE_Extensions__item__criticality._const_tab = ____CPC_InformationLCR_iE_Extensions__item__criticality_tab
    ___CPC_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CPC_InformationLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CPC_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CPC_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CPC_InformationLCR_iE_Extensions__item__id),
        (u'criticality', ___CPC_InformationLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___CPC_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __CPC_InformationLCR_iE_Extensions__item_._ext = None
    _CPC_InformationLCR_iE_Extensions._cont = __CPC_InformationLCR_iE_Extensions__item_
    _CPC_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CPC_InformationLCR._cont = ASN1Dict([
        (u'continuousPacketConnectivity-DRX-InformationLCR', _CPC_InformationLCR_continuousPacketConnectivity_DRX_InformationLCR),
        (u'continuousPacketConnectivity-DRX-Information-to-Modify-LCR', _CPC_InformationLCR_continuousPacketConnectivity_DRX_Information_to_Modify_LCR),
        (u'hS-DSCH-Semi-PersistentScheduling-Information-LCR', _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_LCR),
        (u'hS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR', _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR),
        (u'hS-DSCH-SPS-Deactivate-Indicator-LCR', _CPC_InformationLCR_hS_DSCH_SPS_Deactivate_Indicator_LCR),
        (u'e-DCH-Semi-PersistentScheduling-Information-LCR', _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_LCR),
        (u'e-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR', _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR),
        (u'e-DCH-SPS-Deactivate-Indicator-LCR', _CPC_InformationLCR_e_DCH_SPS_Deactivate_Indicator_LCR),
        (u'iE-Extensions', _CPC_InformationLCR_iE_Extensions),
        ])
    CPC_InformationLCR._ext = []
    
    #-----< CPC-InformationLCR-ExtIEs >-----#
    CPC_InformationLCR_ExtIEs = CLASS(name=u'CPC-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CPC_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivity-DRX-InformationLCR >-----#
    ContinuousPacketConnectivity_DRX_InformationLCR = SEQ(name=u'ContinuousPacketConnectivity-DRX-InformationLCR', mode=MODE_TYPE)
    _ContinuousPacketConnectivity_DRX_InformationLCR_enabling_Delay = ENUM(name=u'enabling-Delay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Enabling-Delay')))
    _ContinuousPacketConnectivity_DRX_InformationLCR_hS_SCCH_DRX_Information_LCR = SEQ(name=u'hS-SCCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-DRX-Information-LCR')))
    _ContinuousPacketConnectivity_DRX_InformationLCR_e_AGCH_DRX_Information_LCR = CHOICE(name=u'e-AGCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-DRX-Information-LCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id),
        (u'criticality', ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions._cont = __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_
    _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivity_DRX_InformationLCR._cont = ASN1Dict([
        (u'enabling-Delay', _ContinuousPacketConnectivity_DRX_InformationLCR_enabling_Delay),
        (u'hS-SCCH-DRX-Information-LCR', _ContinuousPacketConnectivity_DRX_InformationLCR_hS_SCCH_DRX_Information_LCR),
        (u'e-AGCH-DRX-Information-LCR', _ContinuousPacketConnectivity_DRX_InformationLCR_e_AGCH_DRX_Information_LCR),
        (u'iE-Extensions', _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions),
        ])
    ContinuousPacketConnectivity_DRX_InformationLCR._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs >-----#
    ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs = CLASS(name=u'ContinuousPacketConnectivity-DRX-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR >-----#
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR = SEQ(name=u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR', mode=MODE_TYPE)
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_enabling_Delay = ENUM(name=u'enabling-Delay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Enabling-Delay')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_dRX_Information_to_Modify_LCR = CHOICE(name=u'dRX-Information-to-Modify-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DRX-Information-to-Modify-LCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id),
        (u'criticality', ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions._cont = __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_
    _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR._cont = ASN1Dict([
        (u'enabling-Delay', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_enabling_Delay),
        (u'dRX-Information-to-Modify-LCR', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_dRX_Information_to_Modify_LCR),
        (u'iE-Extensions', _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions),
        ])
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs >-----#
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs = CLASS(name=u'ContinuousPacketConnectivity-DRX-Information-to-Modify-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContinuousPacketConnectivity-DRX-Information-ResponseLCR >-----#
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR = SEQ(name=u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR', mode=MODE_TYPE)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_enabling_Delay = ENUM(name=u'enabling-Delay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Enabling-Delay')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_hS_SCCH_DRX_Information_ResponseLCR = SEQ(name=u'hS-SCCH-DRX-Information-ResponseLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-DRX-Information-ResponseLCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_e_AGCH_DRX_Information_ResponseLCR = CHOICE(name=u'e-AGCH-DRX-Information-ResponseLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-DRX-Information-ResponseLCR')), opt=True)
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality_tab
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id),
        (u'criticality', ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions._cont = __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_
    _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR._cont = ASN1Dict([
        (u'enabling-Delay', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_enabling_Delay),
        (u'hS-SCCH-DRX-Information-ResponseLCR', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_hS_SCCH_DRX_Information_ResponseLCR),
        (u'e-AGCH-DRX-Information-ResponseLCR', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_e_AGCH_DRX_Information_ResponseLCR),
        (u'iE-Extensions', _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions),
        ])
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR._ext = []
    
    #-----< ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs >-----#
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs = CLASS(name=u'ContinuousPacketConnectivity-DRX-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Controlled-Object-Scope >-----#
    Controlled_Object_Scope = SEQ(name=u'Controlled-Object-Scope', mode=MODE_TYPE)
    _Controlled_Object_Scope_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _Controlled_Object_Scope_extended_RNC_ID = INT(name=u'extended-RNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')), opt=True)
    _Controlled_Object_Scope_multiple_PLMN_List = SEQ(name=u'multiple-PLMN-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')), opt=True)
    _Controlled_Object_Scope_umts_cell_Info = SEQ_OF(name=u'umts-cell-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UMTS-Cells-Info-List')), opt=True)
    _Controlled_Object_Scope_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Controlled_Object_Scope_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Controlled_Object_Scope_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Controlled_Object_Scope_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Controlled_Object_Scope_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Controlled_Object_Scope_iE_Extensions__item__id._const_tab = ____Controlled_Object_Scope_iE_Extensions__item__id_tab
    ___Controlled_Object_Scope_iE_Extensions__item__id._const_tab_at = None
    ___Controlled_Object_Scope_iE_Extensions__item__id._const_tab_id = u'id'
    ___Controlled_Object_Scope_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Controlled_Object_Scope_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Controlled_Object_Scope_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Controlled_Object_Scope_iE_Extensions__item__criticality._const_tab = ____Controlled_Object_Scope_iE_Extensions__item__criticality_tab
    ___Controlled_Object_Scope_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Controlled_Object_Scope_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Controlled_Object_Scope_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Controlled_Object_Scope_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Controlled_Object_Scope_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Controlled_Object_Scope_iE_Extensions__item__extensionValue._const_tab = ____Controlled_Object_Scope_iE_Extensions__item__extensionValue_tab
    ___Controlled_Object_Scope_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Controlled_Object_Scope_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Controlled_Object_Scope_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Controlled_Object_Scope_iE_Extensions__item__id),
        (u'criticality', ___Controlled_Object_Scope_iE_Extensions__item__criticality),
        (u'extensionValue', ___Controlled_Object_Scope_iE_Extensions__item__extensionValue),
        ])
    __Controlled_Object_Scope_iE_Extensions__item_._ext = None
    _Controlled_Object_Scope_iE_Extensions._cont = __Controlled_Object_Scope_iE_Extensions__item_
    _Controlled_Object_Scope_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Controlled_Object_Scope._cont = ASN1Dict([
        (u'rNC-ID', _Controlled_Object_Scope_rNC_ID),
        (u'extended-RNC-ID', _Controlled_Object_Scope_extended_RNC_ID),
        (u'multiple-PLMN-List', _Controlled_Object_Scope_multiple_PLMN_List),
        (u'umts-cell-Info', _Controlled_Object_Scope_umts_cell_Info),
        (u'iE-Extensions', _Controlled_Object_Scope_iE_Extensions),
        ])
    Controlled_Object_Scope._ext = []
    
    #-----< Controlled-Object-Scope-ExtIEs >-----#
    Controlled_Object_Scope_ExtIEs = CLASS(name=u'Controlled-Object-Scope-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Controlled_Object_Scope_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DATA-ID >-----#
    DATA_ID = INT(name=u'DATA-ID', mode=MODE_TYPE)
    DATA_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< DBDS-CorrectionsReq >-----#
    DBDS_CorrectionsReq = SEQ(name=u'DBDS-CorrectionsReq', mode=MODE_TYPE)
    _DBDS_CorrectionsReq_dGANSS_Signal_ID = BIT_STR(name=u'dGANSS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_CorrectionsReq_dGANSS_Signal_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DBDS_CorrectionsReq_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_CorrectionsReq_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_CorrectionsReq_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_CorrectionsReq_ie_Extensions__item__id._const_tab = ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab
    ___DBDS_CorrectionsReq_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_CorrectionsReq_ie_Extensions__item__id._const_tab_id = u'id'
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality._const_tab = ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DBDS_CorrectionsReq_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue._const_tab = ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DBDS_CorrectionsReq_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DBDS_CorrectionsReq_ie_Extensions__item__id),
        (u'criticality', ___DBDS_CorrectionsReq_ie_Extensions__item__criticality),
        (u'extensionValue', ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue),
        ])
    __DBDS_CorrectionsReq_ie_Extensions__item_._ext = None
    _DBDS_CorrectionsReq_ie_Extensions._cont = __DBDS_CorrectionsReq_ie_Extensions__item_
    _DBDS_CorrectionsReq_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_CorrectionsReq._cont = ASN1Dict([
        (u'dGANSS-Signal-ID', _DBDS_CorrectionsReq_dGANSS_Signal_ID),
        (u'ie-Extensions', _DBDS_CorrectionsReq_ie_Extensions),
        ])
    DBDS_CorrectionsReq._ext = []
    
    #-----< DBDS-CorrectionsReq-ExtIEs >-----#
    DBDS_CorrectionsReq_ExtIEs = CLASS(name=u'DBDS-CorrectionsReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DBDS_CorrectionsReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-Corrections >-----#
    DBDS_Corrections = SEQ(name=u'DBDS-Corrections', mode=MODE_TYPE)
    _DBDS_Corrections_bDS_RefTime = INT(name=u'bDS-RefTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_Corrections_bDS_RefTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _DBDS_Corrections_dBDS_InfoList = SEQ_OF(name=u'dBDS-InfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-InfoList')))
    _DBDS_Corrections_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_Corrections_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_Corrections_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DBDS_Corrections_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_iE_Extensions__item__id._const_tab = ____DBDS_Corrections_iE_Extensions__item__id_tab
    ___DBDS_Corrections_iE_Extensions__item__id._const_tab_at = None
    ___DBDS_Corrections_iE_Extensions__item__id._const_tab_id = u'id'
    ___DBDS_Corrections_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DBDS_Corrections_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_iE_Extensions__item__criticality._const_tab = ____DBDS_Corrections_iE_Extensions__item__criticality_tab
    ___DBDS_Corrections_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DBDS_Corrections_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DBDS_Corrections_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_iE_Extensions__item__extensionValue._const_tab = ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab
    ___DBDS_Corrections_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DBDS_Corrections_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DBDS_Corrections_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DBDS_Corrections_iE_Extensions__item__id),
        (u'criticality', ___DBDS_Corrections_iE_Extensions__item__criticality),
        (u'extensionValue', ___DBDS_Corrections_iE_Extensions__item__extensionValue),
        ])
    __DBDS_Corrections_iE_Extensions__item_._ext = None
    _DBDS_Corrections_iE_Extensions._cont = __DBDS_Corrections_iE_Extensions__item_
    _DBDS_Corrections_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_Corrections._cont = ASN1Dict([
        (u'bDS-RefTime', _DBDS_Corrections_bDS_RefTime),
        (u'dBDS-InfoList', _DBDS_Corrections_dBDS_InfoList),
        (u'iE-Extensions', _DBDS_Corrections_iE_Extensions),
        ])
    DBDS_Corrections._ext = []
    
    #-----< DBDS-CorrectionsItem-ExtIEs >-----#
    DBDS_CorrectionsItem_ExtIEs = CLASS(name=u'DBDS-CorrectionsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DBDS_CorrectionsItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-Info >-----#
    DBDS_Info = SEQ(name=u'DBDS-Info', mode=MODE_TYPE)
    _DBDS_Info_dBDS_SignalID = INT(name=u'dBDS-SignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Signal-ID')), opt=True)
    _DBDS_Info_dBDS_SignalInfoList = SEQ_OF(name=u'dBDS-SignalInfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-SignalInfoList')))
    _DBDS_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DBDS_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Info_iE_Extensions__item__id._const_tab = ____DBDS_Info_iE_Extensions__item__id_tab
    ___DBDS_Info_iE_Extensions__item__id._const_tab_at = None
    ___DBDS_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___DBDS_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DBDS_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Info_iE_Extensions__item__criticality._const_tab = ____DBDS_Info_iE_Extensions__item__criticality_tab
    ___DBDS_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DBDS_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DBDS_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DBDS_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Info_iE_Extensions__item__extensionValue._const_tab = ____DBDS_Info_iE_Extensions__item__extensionValue_tab
    ___DBDS_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DBDS_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DBDS_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DBDS_Info_iE_Extensions__item__id),
        (u'criticality', ___DBDS_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___DBDS_Info_iE_Extensions__item__extensionValue),
        ])
    __DBDS_Info_iE_Extensions__item_._ext = None
    _DBDS_Info_iE_Extensions._cont = __DBDS_Info_iE_Extensions__item_
    _DBDS_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_Info._cont = ASN1Dict([
        (u'dBDS-SignalID', _DBDS_Info_dBDS_SignalID),
        (u'dBDS-SignalInfoList', _DBDS_Info_dBDS_SignalInfoList),
        (u'iE-Extensions', _DBDS_Info_iE_Extensions),
        ])
    DBDS_Info._ext = []
    
    #-----< DBDS-InfoItem-ExtIEs >-----#
    DBDS_InfoItem_ExtIEs = CLASS(name=u'DBDS-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DBDS_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-SignalInfoList >-----#
    DBDS_SignalInfoList = SEQ_OF(name=u'DBDS-SignalInfoList', mode=MODE_TYPE)
    _DBDS_SignalInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-SignalInfo')))
    DBDS_SignalInfoList._cont = _DBDS_SignalInfoList__item_
    DBDS_SignalInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DBDS-SignalInfo >-----#
    DBDS_SignalInfo = SEQ(name=u'DBDS-SignalInfo', mode=MODE_TYPE)
    _DBDS_SignalInfo_svID = INT(name=u'svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _DBDS_SignalInfo_bds_UDREI = INT(name=u'bds-UDREI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_bds_UDREI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _DBDS_SignalInfo_bds_RURAI = INT(name=u'bds-RURAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_bds_RURAI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _DBDS_SignalInfo_bds_ECC_DeltaT = BIT_STR(name=u'bds-ECC-DeltaT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_SignalInfo_bds_ECC_DeltaT._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _DBDS_SignalInfo_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_SignalInfo_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_SignalInfo_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DBDS_SignalInfo_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_SignalInfo_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_SignalInfo_ie_Extensions__item__id._const_tab = ____DBDS_SignalInfo_ie_Extensions__item__id_tab
    ___DBDS_SignalInfo_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_SignalInfo_ie_Extensions__item__id._const_tab_id = u'id'
    ___DBDS_SignalInfo_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_SignalInfo_ie_Extensions__item__criticality._const_tab = ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab
    ___DBDS_SignalInfo_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DBDS_SignalInfo_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue._const_tab = ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DBDS_SignalInfo_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DBDS_SignalInfo_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DBDS_SignalInfo_ie_Extensions__item__id),
        (u'criticality', ___DBDS_SignalInfo_ie_Extensions__item__criticality),
        (u'extensionValue', ___DBDS_SignalInfo_ie_Extensions__item__extensionValue),
        ])
    __DBDS_SignalInfo_ie_Extensions__item_._ext = None
    _DBDS_SignalInfo_ie_Extensions._cont = __DBDS_SignalInfo_ie_Extensions__item_
    _DBDS_SignalInfo_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_SignalInfo._cont = ASN1Dict([
        (u'svID', _DBDS_SignalInfo_svID),
        (u'bds-UDREI', _DBDS_SignalInfo_bds_UDREI),
        (u'bds-RURAI', _DBDS_SignalInfo_bds_RURAI),
        (u'bds-ECC-DeltaT', _DBDS_SignalInfo_bds_ECC_DeltaT),
        (u'ie-Extensions', _DBDS_SignalInfo_ie_Extensions),
        ])
    DBDS_SignalInfo._ext = []
    
    #-----< DBDS-SignalInfoItem-ExtIEs >-----#
    DBDS_SignalInfoItem_ExtIEs = CLASS(name=u'DBDS-SignalInfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DBDS_SignalInfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-InfoList >-----#
    DBDS_InfoList = SEQ_OF(name=u'DBDS-InfoList', mode=MODE_TYPE)
    _DBDS_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-Info')))
    DBDS_InfoList._cont = _DBDS_InfoList__item_
    DBDS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DCH-ENH-Information >-----#
    DCH_ENH_Information = SEQ(name=u'DCH-ENH-Information', mode=MODE_TYPE)
    _DCH_ENH_Information_pO2_SRB = INT(name=u'pO2-SRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _DCH_ENH_Information_dl_FET_Mode = ENUM(name=u'dl-FET-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-FET-Mode')))
    _DCH_ENH_Information_dCH_ENH_Concat = SEQ_OF(name=u'dCH-ENH-Concat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Concat')), opt=True)
    _DCH_ENH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ENH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ENH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_ENH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_iE_Extensions__item__id._const_tab = ____DCH_ENH_Information_iE_Extensions__item__id_tab
    ___DCH_ENH_Information_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ENH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_ENH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_ENH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_iE_Extensions__item__criticality._const_tab = ____DCH_ENH_Information_iE_Extensions__item__criticality_tab
    ___DCH_ENH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_ENH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue._const_tab = ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_ENH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_ENH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_ENH_Information_iE_Extensions__item__id),
        (u'criticality', ___DCH_ENH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_ENH_Information_iE_Extensions__item__extensionValue),
        ])
    __DCH_ENH_Information_iE_Extensions__item_._ext = None
    _DCH_ENH_Information_iE_Extensions._cont = __DCH_ENH_Information_iE_Extensions__item_
    _DCH_ENH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ENH_Information._cont = ASN1Dict([
        (u'pO2-SRB', _DCH_ENH_Information_pO2_SRB),
        (u'dl-FET-Mode', _DCH_ENH_Information_dl_FET_Mode),
        (u'dCH-ENH-Concat', _DCH_ENH_Information_dCH_ENH_Concat),
        (u'iE-Extensions', _DCH_ENH_Information_iE_Extensions),
        ])
    DCH_ENH_Information._ext = []
    
    #-----< DCH-ENH-Information-ExtIEs >-----#
    DCH_ENH_Information_ExtIEs = CLASS(name=u'DCH-ENH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_ENH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-ENH-Information-to-Modify >-----#
    DCH_ENH_Information_to_Modify = SEQ(name=u'DCH-ENH-Information-to-Modify', mode=MODE_TYPE)
    _DCH_ENH_Information_to_Modify_pO_SRB = INT(name=u'pO-SRB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')), opt=True)
    _DCH_ENH_Information_to_Modify_dl_FET_Mode = ENUM(name=u'dl-FET-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-FET-Mode')), opt=True)
    _DCH_ENH_Information_to_Modify_dCH_ENH_Concat = SEQ_OF(name=u'dCH-ENH-Concat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Concat')), opt=True)
    _DCH_ENH_Information_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ENH_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id._const_tab = ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_ENH_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __DCH_ENH_Information_to_Modify_iE_Extensions__item_._ext = None
    _DCH_ENH_Information_to_Modify_iE_Extensions._cont = __DCH_ENH_Information_to_Modify_iE_Extensions__item_
    _DCH_ENH_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ENH_Information_to_Modify._cont = ASN1Dict([
        (u'pO-SRB', _DCH_ENH_Information_to_Modify_pO_SRB),
        (u'dl-FET-Mode', _DCH_ENH_Information_to_Modify_dl_FET_Mode),
        (u'dCH-ENH-Concat', _DCH_ENH_Information_to_Modify_dCH_ENH_Concat),
        (u'iE-Extensions', _DCH_ENH_Information_to_Modify_iE_Extensions),
        ])
    DCH_ENH_Information_to_Modify._ext = []
    
    #-----< DCH-ENH-Information-to-Modify-ExtIEs >-----#
    DCH_ENH_Information_to_Modify_ExtIEs = CLASS(name=u'DCH-ENH-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_ENH_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-FET-Mode >-----#
    DL_FET_Mode = ENUM(name=u'DL-FET-Mode', mode=MODE_TYPE)
    DL_FET_Mode._cont = ASN1Dict([(u'basic', 0), (u'full', 1)])
    DL_FET_Mode._ext = []
    
    #-----< DCH-ENH-Concat >-----#
    DCH_ENH_Concat = SEQ_OF(name=u'DCH-ENH-Concat', mode=MODE_TYPE)
    _DCH_ENH_Concat__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    DCH_ENH_Concat._cont = _DCH_ENH_Concat__item_
    DCH_ENH_Concat._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< DCH-ENH-Information-Reconf >-----#
    DCH_ENH_Information_Reconf = SEQ(name=u'DCH-ENH-Information-Reconf', mode=MODE_TYPE)
    _DCH_ENH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH')))
    _DCH_ENH_Information_Reconf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_ENH_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id._const_tab = ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_ENH_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_ENH_Information_Reconf_iE_Extensions__item__id),
        (u'criticality', ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __DCH_ENH_Information_Reconf_iE_Extensions__item_._ext = None
    _DCH_ENH_Information_Reconf_iE_Extensions._cont = __DCH_ENH_Information_Reconf_iE_Extensions__item_
    _DCH_ENH_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_ENH_Information_Reconf._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH', _DCH_ENH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH),
        (u'iE-Extensions', _DCH_ENH_Information_Reconf_iE_Extensions),
        ])
    DCH_ENH_Information_Reconf._ext = []
    
    #-----< DCH-ENH-Information-Reconf-ExtIEs >-----#
    DCH_ENH_Information_Reconf_ExtIEs = CLASS(name=u'DCH-ENH-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_ENH_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-ENH-Information-Removal >-----#
    DCH_ENH_Information_Removal = ENUM(name=u'DCH-ENH-Information-Removal', mode=MODE_TYPE)
    DCH_ENH_Information_Removal._cont = ASN1Dict([(u'remove', 0)])
    DCH_ENH_Information_Removal._ext = []
    
    #-----< DCH-FDD-Information >-----#
    DCH_FDD_Information = SEQ_OF(name=u'DCH-FDD-Information', mode=MODE_TYPE)
    _DCH_FDD_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-InformationItem')))
    DCH_FDD_Information._cont = _DCH_FDD_Information__item_
    DCH_FDD_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-FDD-InformationItem >-----#
    DCH_FDD_InformationItem = SEQ(name=u'DCH-FDD-InformationItem', mode=MODE_TYPE)
    _DCH_FDD_InformationItem_payloadCRC_PresenceIndicator = ENUM(name=u'payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _DCH_FDD_InformationItem_ul_FP_Mode = ENUM(name=u'ul-FP-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-FP-Mode')))
    _DCH_FDD_InformationItem_toAWS = INT(name=u'toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWS')))
    _DCH_FDD_InformationItem_toAWE = INT(name=u'toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWE')))
    _DCH_FDD_InformationItem_dCH_SpecificInformationList = SEQ_OF(name=u'dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Specific-FDD-InformationList')))
    _DCH_FDD_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_FDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_FDD_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DCH_FDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____DCH_FDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DCH_FDD_InformationItem_iE_Extensions__item__id._const_tab = ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_FDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DCH_FDD_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_FDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_FDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_FDD_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___DCH_FDD_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DCH_FDD_InformationItem_iE_Extensions__item_._ext = None
    _DCH_FDD_InformationItem_iE_Extensions._cont = __DCH_FDD_InformationItem_iE_Extensions__item_
    _DCH_FDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_FDD_InformationItem._cont = ASN1Dict([
        (u'payloadCRC-PresenceIndicator', _DCH_FDD_InformationItem_payloadCRC_PresenceIndicator),
        (u'ul-FP-Mode', _DCH_FDD_InformationItem_ul_FP_Mode),
        (u'toAWS', _DCH_FDD_InformationItem_toAWS),
        (u'toAWE', _DCH_FDD_InformationItem_toAWE),
        (u'dCH-SpecificInformationList', _DCH_FDD_InformationItem_dCH_SpecificInformationList),
        (u'iE-Extensions', _DCH_FDD_InformationItem_iE_Extensions),
        ])
    DCH_FDD_InformationItem._ext = []
    
    #-----< DCH-FDD-InformationItem-ExtIEs >-----#
    DCH_FDD_InformationItem_ExtIEs = CLASS(name=u'DCH-FDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DCH_FDD_InformationItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    DCH_FDD_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _DCH_FDD_InformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-MeasurementOccasion-Information >-----#
    DCH_MeasurementOccasion_Information = SEQ_OF(name=u'DCH-MeasurementOccasion-Information', mode=MODE_TYPE)
    _DCH_MeasurementOccasion_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DchMeasurementOccasionInformation-Item')))
    DCH_MeasurementOccasion_Information._cont = _DCH_MeasurementOccasion_Information__item_
    DCH_MeasurementOccasion_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DchMeasurementOccasionInformation-Item >-----#
    DchMeasurementOccasionInformation_Item = SEQ(name=u'DchMeasurementOccasionInformation-Item', mode=MODE_TYPE)
    _DchMeasurementOccasionInformation_Item_pattern_Sequence_Identifier = INT(name=u'pattern-Sequence-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Pattern-Sequence-Identifier')))
    _DchMeasurementOccasionInformation_Item_status_Flag = ENUM(name=u'status-Flag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Status-Flag')))
    _DchMeasurementOccasionInformation_Item_measurement_Occasion_Pattern_Sequence_parameters = SEQ(name=u'measurement-Occasion-Pattern-Sequence-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Measurement-Occasion-Pattern-Sequence-parameters')), opt=True)
    _DchMeasurementOccasionInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DchMeasurementOccasionInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id._const_tab = ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality._const_tab = ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DchMeasurementOccasionInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __DchMeasurementOccasionInformation_Item_iE_Extensions__item_._ext = None
    _DchMeasurementOccasionInformation_Item_iE_Extensions._cont = __DchMeasurementOccasionInformation_Item_iE_Extensions__item_
    _DchMeasurementOccasionInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DchMeasurementOccasionInformation_Item._cont = ASN1Dict([
        (u'pattern-Sequence-Identifier', _DchMeasurementOccasionInformation_Item_pattern_Sequence_Identifier),
        (u'status-Flag', _DchMeasurementOccasionInformation_Item_status_Flag),
        (u'measurement-Occasion-Pattern-Sequence-parameters', _DchMeasurementOccasionInformation_Item_measurement_Occasion_Pattern_Sequence_parameters),
        (u'iE-Extensions', _DchMeasurementOccasionInformation_Item_iE_Extensions),
        ])
    DchMeasurementOccasionInformation_Item._ext = []
    
    #-----< DCH-MeasurementOccasion-Information-ExtIEs >-----#
    DCH_MeasurementOccasion_Information_ExtIEs = CLASS(name=u'DCH-MeasurementOccasion-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_MeasurementOccasion_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Measurement-Occasion-Pattern-Sequence-parameters >-----#
    Measurement_Occasion_Pattern_Sequence_parameters = SEQ(name=u'Measurement-Occasion-Pattern-Sequence-parameters', mode=MODE_TYPE)
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k = INT(name=u'measurement-Occasion-Pattern-Sequence-parameters-k', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset = INT(name=u'measurement-Occasion-Pattern-Sequence-parameters-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length = INT(name=u'measurement-Occasion-Pattern-Sequence-parameters-M-Length', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap = BIT_STR(name=u'measurement-Occasion-Pattern-Sequence-parameters-Timeslot-Bitmap', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id._const_tab = ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id._const_tab_at = None
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality._const_tab = ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue._const_tab = ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id),
        (u'criticality', ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue),
        ])
    __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_._ext = None
    _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions._cont = __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_
    _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Measurement_Occasion_Pattern_Sequence_parameters._cont = ASN1Dict([
        (u'measurement-Occasion-Pattern-Sequence-parameters-k', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k),
        (u'measurement-Occasion-Pattern-Sequence-parameters-offset', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset),
        (u'measurement-Occasion-Pattern-Sequence-parameters-M-Length', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length),
        (u'measurement-Occasion-Pattern-Sequence-parameters-Timeslot-Bitmap', _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap),
        (u'iE-Extensions', _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions),
        ])
    Measurement_Occasion_Pattern_Sequence_parameters._ext = []
    
    #-----< Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs >-----#
    Measurement_Occasion_Pattern_Sequence_parameters_ExtIEs = CLASS(name=u'Measurement-Occasion-Pattern-Sequence-parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Measurement_Occasion_Pattern_Sequence_parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-MeasurementType-Indicator >-----#
    DCH_MeasurementType_Indicator = BIT_STR(name=u'DCH-MeasurementType-Indicator', mode=MODE_TYPE)
    DCH_MeasurementType_Indicator._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< DCH-Specific-FDD-InformationList >-----#
    DCH_Specific_FDD_InformationList = SEQ_OF(name=u'DCH-Specific-FDD-InformationList', mode=MODE_TYPE)
    _DCH_Specific_FDD_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Specific-FDD-Item')))
    DCH_Specific_FDD_InformationList._cont = _DCH_Specific_FDD_InformationList__item_
    DCH_Specific_FDD_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-Specific-FDD-Item >-----#
    DCH_Specific_FDD_Item = SEQ(name=u'DCH-Specific-FDD-Item', mode=MODE_TYPE)
    _DCH_Specific_FDD_Item_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_Specific_FDD_Item_trCH_SrcStatisticsDescr = ENUM(name=u'trCH-SrcStatisticsDescr', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    _DCH_Specific_FDD_Item_ul_transportFormatSet = SEQ(name=u'ul-transportFormatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_FDD_Item_dl_transportFormatSet = SEQ(name=u'dl-transportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_FDD_Item_ul_BLER = INT(name=u'ul-BLER', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')))
    _DCH_Specific_FDD_Item_dl_BLER = INT(name=u'dl-BLER', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')))
    _DCH_Specific_FDD_Item_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')))
    _DCH_Specific_FDD_Item_frameHandlingPriority = INT(name=u'frameHandlingPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameHandlingPriority')))
    _DCH_Specific_FDD_Item_qE_Selector = ENUM(name=u'qE-Selector', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'QE-Selector')))
    _DCH_Specific_FDD_Item_dRACControl = ENUM(name=u'dRACControl', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DRACControl')))
    _DCH_Specific_FDD_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Specific_FDD_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Unidirectional-DCH-Indicator')))
    ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'mandatory')]), dict([(u'id', 526), (u'criticality', u'reject'), (u'Extension', _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id._const_tab = ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Specific_FDD_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality._const_tab = ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue._const_tab = ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_Specific_FDD_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_Specific_FDD_Item_iE_Extensions__item__id),
        (u'criticality', ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue),
        ])
    __DCH_Specific_FDD_Item_iE_Extensions__item_._ext = None
    _DCH_Specific_FDD_Item_iE_Extensions._cont = __DCH_Specific_FDD_Item_iE_Extensions__item_
    _DCH_Specific_FDD_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Specific_FDD_Item._cont = ASN1Dict([
        (u'dCH-ID', _DCH_Specific_FDD_Item_dCH_ID),
        (u'trCH-SrcStatisticsDescr', _DCH_Specific_FDD_Item_trCH_SrcStatisticsDescr),
        (u'ul-transportFormatSet', _DCH_Specific_FDD_Item_ul_transportFormatSet),
        (u'dl-transportFormatSet', _DCH_Specific_FDD_Item_dl_transportFormatSet),
        (u'ul-BLER', _DCH_Specific_FDD_Item_ul_BLER),
        (u'dl-BLER', _DCH_Specific_FDD_Item_dl_BLER),
        (u'allocationRetentionPriority', _DCH_Specific_FDD_Item_allocationRetentionPriority),
        (u'frameHandlingPriority', _DCH_Specific_FDD_Item_frameHandlingPriority),
        (u'qE-Selector', _DCH_Specific_FDD_Item_qE_Selector),
        (u'dRACControl', _DCH_Specific_FDD_Item_dRACControl),
        (u'iE-Extensions', _DCH_Specific_FDD_Item_iE_Extensions),
        ])
    DCH_Specific_FDD_Item._ext = []
    
    #-----< DCH-FDD-SpecificItem-ExtIEs >-----#
    DCH_FDD_SpecificItem_ExtIEs = CLASS(name=u'DCH-FDD-SpecificItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DCH_FDD_SpecificItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _DCH_FDD_SpecificItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _DCH_FDD_SpecificItem_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Unidirectional-DCH-Indicator')))
    DCH_FDD_SpecificItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _DCH_FDD_SpecificItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _DCH_FDD_SpecificItem_ExtIEs_val_Extension_1), (u'presence', u'mandatory')]), dict([(u'id', 526), (u'criticality', u'reject'), (u'Extension', _DCH_FDD_SpecificItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-Indicator-For-E-DCH-HSDPA-Operation >-----#
    DCH_Indicator_For_E_DCH_HSDPA_Operation = ENUM(name=u'DCH-Indicator-For-E-DCH-HSDPA-Operation', mode=MODE_TYPE)
    DCH_Indicator_For_E_DCH_HSDPA_Operation._cont = ASN1Dict([(u'dch-not-present', 0)])
    DCH_Indicator_For_E_DCH_HSDPA_Operation._ext = None
    
    #-----< DCH-ID >-----#
    DCH_ID = INT(name=u'DCH-ID', mode=MODE_TYPE)
    DCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DCH-InformationResponse >-----#
    DCH_InformationResponse = SEQ_OF(name=u'DCH-InformationResponse', mode=MODE_TYPE)
    _DCH_InformationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponseItem')))
    DCH_InformationResponse._cont = _DCH_InformationResponse__item_
    DCH_InformationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-InformationResponseItem >-----#
    DCH_InformationResponseItem = SEQ(name=u'DCH-InformationResponseItem', mode=MODE_TYPE)
    _DCH_InformationResponseItem_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_InformationResponseItem_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _DCH_InformationResponseItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _DCH_InformationResponseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_InformationResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_InformationResponseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_InformationResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Allowed-Rate-Information')))
    _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotSetupIndicator')))
    ____DCH_InformationResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 42), (u'criticality', u'ignore'), (u'Extension', _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 711), (u'criticality', u'ignore'), (u'Extension', _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DCH_InformationResponseItem_iE_Extensions__item__id._const_tab = ____DCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DCH_InformationResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___DCH_InformationResponseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab = ____DCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_InformationResponseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab = ____DCH_InformationResponseItem_iE_Extensions__item__id_tab
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_InformationResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_InformationResponseItem_iE_Extensions__item__id),
        (u'criticality', ___DCH_InformationResponseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue),
        ])
    __DCH_InformationResponseItem_iE_Extensions__item_._ext = None
    _DCH_InformationResponseItem_iE_Extensions._cont = __DCH_InformationResponseItem_iE_Extensions__item_
    _DCH_InformationResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_InformationResponseItem._cont = ASN1Dict([
        (u'dCH-ID', _DCH_InformationResponseItem_dCH_ID),
        (u'bindingID', _DCH_InformationResponseItem_bindingID),
        (u'transportLayerAddress', _DCH_InformationResponseItem_transportLayerAddress),
        (u'iE-Extensions', _DCH_InformationResponseItem_iE_Extensions),
        ])
    DCH_InformationResponseItem._ext = []
    
    #-----< DCH-InformationResponseItem-ExtIEs >-----#
    DCH_InformationResponseItem_ExtIEs = CLASS(name=u'DCH-InformationResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DCH_InformationResponseItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Allowed-Rate-Information')))
    _DCH_InformationResponseItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotSetupIndicator')))
    DCH_InformationResponseItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 42), (u'criticality', u'ignore'), (u'Extension', _DCH_InformationResponseItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 711), (u'criticality', u'ignore'), (u'Extension', _DCH_InformationResponseItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-TDD-Information >-----#
    DCH_TDD_Information = SEQ_OF(name=u'DCH-TDD-Information', mode=MODE_TYPE)
    _DCH_TDD_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-InformationItem')))
    DCH_TDD_Information._cont = _DCH_TDD_Information__item_
    DCH_TDD_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-TDD-InformationItem >-----#
    DCH_TDD_InformationItem = SEQ(name=u'DCH-TDD-InformationItem', mode=MODE_TYPE)
    _DCH_TDD_InformationItem_payloadCRC_PresenceIndicator = ENUM(name=u'payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _DCH_TDD_InformationItem_ul_FP_Mode = ENUM(name=u'ul-FP-Mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-FP-Mode')))
    _DCH_TDD_InformationItem_toAWS = INT(name=u'toAWS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWS')))
    _DCH_TDD_InformationItem_toAWE = INT(name=u'toAWE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWE')))
    _DCH_TDD_InformationItem_dCH_SpecificInformationList = SEQ_OF(name=u'dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Specific-TDD-InformationList')))
    _DCH_TDD_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_TDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_TDD_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____DCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DCH_TDD_InformationItem_iE_Extensions__item__id._const_tab = ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_TDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_TDD_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___DCH_TDD_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DCH_TDD_InformationItem_iE_Extensions__item_._ext = None
    _DCH_TDD_InformationItem_iE_Extensions._cont = __DCH_TDD_InformationItem_iE_Extensions__item_
    _DCH_TDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_TDD_InformationItem._cont = ASN1Dict([
        (u'payloadCRC-PresenceIndicator', _DCH_TDD_InformationItem_payloadCRC_PresenceIndicator),
        (u'ul-FP-Mode', _DCH_TDD_InformationItem_ul_FP_Mode),
        (u'toAWS', _DCH_TDD_InformationItem_toAWS),
        (u'toAWE', _DCH_TDD_InformationItem_toAWE),
        (u'dCH-SpecificInformationList', _DCH_TDD_InformationItem_dCH_SpecificInformationList),
        (u'iE-Extensions', _DCH_TDD_InformationItem_iE_Extensions),
        ])
    DCH_TDD_InformationItem._ext = []
    
    #-----< DCH-TDD-InformationItem-ExtIEs >-----#
    DCH_TDD_InformationItem_ExtIEs = CLASS(name=u'DCH-TDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DCH_TDD_InformationItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    DCH_TDD_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _DCH_TDD_InformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-Specific-TDD-InformationList >-----#
    DCH_Specific_TDD_InformationList = SEQ_OF(name=u'DCH-Specific-TDD-InformationList', mode=MODE_TYPE)
    _DCH_Specific_TDD_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Specific-TDD-Item')))
    DCH_Specific_TDD_InformationList._cont = _DCH_Specific_TDD_InformationList__item_
    DCH_Specific_TDD_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-Specific-TDD-Item >-----#
    DCH_Specific_TDD_Item = SEQ(name=u'DCH-Specific-TDD-Item', mode=MODE_TYPE)
    _DCH_Specific_TDD_Item_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_Specific_TDD_Item_ul_cCTrCH_ID = INT(name=u'ul-cCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DCH_Specific_TDD_Item_dl_cCTrCH_ID = INT(name=u'dl-cCTrCH-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DCH_Specific_TDD_Item_trCH_SrcStatisticsDescr = ENUM(name=u'trCH-SrcStatisticsDescr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    _DCH_Specific_TDD_Item_ul_transportFormatSet = SEQ(name=u'ul-transportFormatSet', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_TDD_Item_dl_transportFormatSet = SEQ(name=u'dl-transportFormatSet', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _DCH_Specific_TDD_Item_ul_BLER = INT(name=u'ul-BLER', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')))
    _DCH_Specific_TDD_Item_dl_BLER = INT(name=u'dl-BLER', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')))
    _DCH_Specific_TDD_Item_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')))
    _DCH_Specific_TDD_Item_frameHandlingPriority = INT(name=u'frameHandlingPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameHandlingPriority')))
    _DCH_Specific_TDD_Item_qE_Selector = ENUM(name=u'qE-Selector', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'QE-Selector')), opt=True)
    _DCH_Specific_TDD_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Specific_TDD_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Unidirectional-DCH-Indicator')))
    ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'mandatory')]), dict([(u'id', 526), (u'criticality', u'reject'), (u'Extension', _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id._const_tab = ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Specific_TDD_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality._const_tab = ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue._const_tab = ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_Specific_TDD_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_Specific_TDD_Item_iE_Extensions__item__id),
        (u'criticality', ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue),
        ])
    __DCH_Specific_TDD_Item_iE_Extensions__item_._ext = None
    _DCH_Specific_TDD_Item_iE_Extensions._cont = __DCH_Specific_TDD_Item_iE_Extensions__item_
    _DCH_Specific_TDD_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Specific_TDD_Item._cont = ASN1Dict([
        (u'dCH-ID', _DCH_Specific_TDD_Item_dCH_ID),
        (u'ul-cCTrCH-ID', _DCH_Specific_TDD_Item_ul_cCTrCH_ID),
        (u'dl-cCTrCH-ID', _DCH_Specific_TDD_Item_dl_cCTrCH_ID),
        (u'trCH-SrcStatisticsDescr', _DCH_Specific_TDD_Item_trCH_SrcStatisticsDescr),
        (u'ul-transportFormatSet', _DCH_Specific_TDD_Item_ul_transportFormatSet),
        (u'dl-transportFormatSet', _DCH_Specific_TDD_Item_dl_transportFormatSet),
        (u'ul-BLER', _DCH_Specific_TDD_Item_ul_BLER),
        (u'dl-BLER', _DCH_Specific_TDD_Item_dl_BLER),
        (u'allocationRetentionPriority', _DCH_Specific_TDD_Item_allocationRetentionPriority),
        (u'frameHandlingPriority', _DCH_Specific_TDD_Item_frameHandlingPriority),
        (u'qE-Selector', _DCH_Specific_TDD_Item_qE_Selector),
        (u'iE-Extensions', _DCH_Specific_TDD_Item_iE_Extensions),
        ])
    DCH_Specific_TDD_Item._ext = []
    
    #-----< DCH-Specific-TDD-Item-ExtIEs >-----#
    DCH_Specific_TDD_Item_ExtIEs = CLASS(name=u'DCH-Specific-TDD-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DCH_Specific_TDD_Item_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _DCH_Specific_TDD_Item_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _DCH_Specific_TDD_Item_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Unidirectional-DCH-Indicator')))
    DCH_Specific_TDD_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _DCH_Specific_TDD_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _DCH_Specific_TDD_Item_ExtIEs_val_Extension_1), (u'presence', u'mandatory')]), dict([(u'id', 526), (u'criticality', u'reject'), (u'Extension', _DCH_Specific_TDD_Item_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DecimationFactor >-----#
    DecimationFactor = ENUM(name=u'DecimationFactor', mode=MODE_TYPE)
    DecimationFactor._cont = ASN1Dict([(u'slots3', 0), (u'slots5', 1)])
    DecimationFactor._ext = None
    
    #-----< DedicatedMeasurementType >-----#
    DedicatedMeasurementType = ENUM(name=u'DedicatedMeasurementType', mode=MODE_TYPE)
    DedicatedMeasurementType._cont = ASN1Dict([(u'sir', 0), (u'sir-error', 1), (u'transmitted-code-power', 2), (u'rSCP', 3), (u'rx-timing-deviation', 4), (u'round-trip-time', 5), (u'rx-timing-deviation-LCR', 6), (u'angle-Of-Arrival-LCR', 7), (u'hs-sich-quality', 8), (u'rx-timing-deviation-768', 9), (u'rx-timing-deviation-ext', 10), (u'ue-transmission-power-headroom', 11), (u'dl-TBS', 12)])
    DedicatedMeasurementType._ext = [u'rx-timing-deviation-LCR', u'angle-Of-Arrival-LCR', u'hs-sich-quality', u'rx-timing-deviation-768', u'rx-timing-deviation-ext', u'ue-transmission-power-headroom', u'dl-TBS']
    
    #-----< DedicatedMeasurementValue >-----#
    DedicatedMeasurementValue = CHOICE(name=u'DedicatedMeasurementValue', mode=MODE_TYPE)
    _DedicatedMeasurementValue_sIR_Value = INT(name=u'sIR-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SIR-Value')))
    _DedicatedMeasurementValue_sIR_ErrorValue = INT(name=u'sIR-ErrorValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SIR-Error-Value')))
    _DedicatedMeasurementValue_transmittedCodePowerValue = INT(name=u'transmittedCodePowerValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Code-Power-Value')))
    _DedicatedMeasurementValue_rSCP = INT(name=u'rSCP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RSCP-Value')))
    _DedicatedMeasurementValue_rxTimingDeviationValue = INT(name=u'rxTimingDeviationValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value')))
    _DedicatedMeasurementValue_roundTripTime = INT(name=u'roundTripTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Round-Trip-Time-Value')))
    _DedicatedMeasurementValue_extension_DedicatedMeasurementValue = SEQ(name=u'extension-DedicatedMeasurementValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-DedicatedMeasurementValue')))
    DedicatedMeasurementValue._cont = ASN1Dict([
        (u'sIR-Value', _DedicatedMeasurementValue_sIR_Value),
        (u'sIR-ErrorValue', _DedicatedMeasurementValue_sIR_ErrorValue),
        (u'transmittedCodePowerValue', _DedicatedMeasurementValue_transmittedCodePowerValue),
        (u'rSCP', _DedicatedMeasurementValue_rSCP),
        (u'rxTimingDeviationValue', _DedicatedMeasurementValue_rxTimingDeviationValue),
        (u'roundTripTime', _DedicatedMeasurementValue_roundTripTime),
        (u'extension-DedicatedMeasurementValue', _DedicatedMeasurementValue_extension_DedicatedMeasurementValue),
        ])
    DedicatedMeasurementValue._ext = [u'extension-DedicatedMeasurementValue']
    
    #-----< DedicatedMeasurementValueInformation >-----#
    DedicatedMeasurementValueInformation = CHOICE(name=u'DedicatedMeasurementValueInformation', mode=MODE_TYPE)
    _DedicatedMeasurementValueInformation_measurementAvailable = SEQ(name=u'measurementAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementAvailable')))
    _DedicatedMeasurementValueInformation_measurementnotAvailable = NULL(name=u'measurementnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementnotAvailable')))
    DedicatedMeasurementValueInformation._cont = ASN1Dict([
        (u'measurementAvailable', _DedicatedMeasurementValueInformation_measurementAvailable),
        (u'measurementnotAvailable', _DedicatedMeasurementValueInformation_measurementnotAvailable),
        ])
    DedicatedMeasurementValueInformation._ext = None
    
    #-----< DedicatedMeasurementAvailable >-----#
    DedicatedMeasurementAvailable = SEQ(name=u'DedicatedMeasurementAvailable', mode=MODE_TYPE)
    _DedicatedMeasurementAvailable_dedicatedmeasurementValue = CHOICE(name=u'dedicatedmeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _DedicatedMeasurementAvailable_cFN = INT(name=u'cFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')), opt=True)
    _DedicatedMeasurementAvailable_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementAvailable_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id._const_tab = ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id._const_tab_at = None
    ___DedicatedMeasurementAvailable_ie_Extensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality._const_tab = ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab = ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementAvailable_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementAvailable_ie_Extensions__item__id),
        (u'criticality', ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue),
        ])
    __DedicatedMeasurementAvailable_ie_Extensions__item_._ext = None
    _DedicatedMeasurementAvailable_ie_Extensions._cont = __DedicatedMeasurementAvailable_ie_Extensions__item_
    _DedicatedMeasurementAvailable_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementAvailable._cont = ASN1Dict([
        (u'dedicatedmeasurementValue', _DedicatedMeasurementAvailable_dedicatedmeasurementValue),
        (u'cFN', _DedicatedMeasurementAvailable_cFN),
        (u'ie-Extensions', _DedicatedMeasurementAvailable_ie_Extensions),
        ])
    DedicatedMeasurementAvailable._ext = []
    
    #-----< DedicatedMeasurementAvailableItem-ExtIEs >-----#
    DedicatedMeasurementAvailableItem_ExtIEs = CLASS(name=u'DedicatedMeasurementAvailableItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DedicatedMeasurementAvailableItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementnotAvailable >-----#
    DedicatedMeasurementnotAvailable = NULL(name=u'DedicatedMeasurementnotAvailable', mode=MODE_TYPE)
    
    #-----< DelayedActivation >-----#
    DelayedActivation = CHOICE(name=u'DelayedActivation', mode=MODE_TYPE)
    _DelayedActivation_cfn = INT(name=u'cfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _DelayedActivation_separate_indication = NULL(name=u'separate-indication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DelayedActivation._cont = ASN1Dict([
        (u'cfn', _DelayedActivation_cfn),
        (u'separate-indication', _DelayedActivation_separate_indication),
        ])
    DelayedActivation._ext = None
    
    #-----< DelayedActivationUpdate >-----#
    DelayedActivationUpdate = CHOICE(name=u'DelayedActivationUpdate', mode=MODE_TYPE)
    _DelayedActivationUpdate_activate = SEQ(name=u'activate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Activate-Info')))
    _DelayedActivationUpdate_deactivate = SEQ(name=u'deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Deactivate-Info')))
    DelayedActivationUpdate._cont = ASN1Dict([
        (u'activate', _DelayedActivationUpdate_activate),
        (u'deactivate', _DelayedActivationUpdate_deactivate),
        ])
    DelayedActivationUpdate._ext = None
    
    #-----< Deactivate-Info >-----#
    Deactivate_Info = SEQ(name=u'Deactivate-Info', mode=MODE_TYPE)
    _Deactivate_Info_deactivation_type = CHOICE(name=u'deactivation-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Execution-Type')))
    _Deactivate_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Deactivate_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Deactivate_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Deactivate_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Deactivate_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Deactivate_Info_iE_Extensions__item__id._const_tab = ____Deactivate_Info_iE_Extensions__item__id_tab
    ___Deactivate_Info_iE_Extensions__item__id._const_tab_at = None
    ___Deactivate_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Deactivate_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Deactivate_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Deactivate_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Deactivate_Info_iE_Extensions__item__criticality._const_tab = ____Deactivate_Info_iE_Extensions__item__criticality_tab
    ___Deactivate_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Deactivate_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Deactivate_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Deactivate_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Deactivate_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Deactivate_Info_iE_Extensions__item__extensionValue._const_tab = ____Deactivate_Info_iE_Extensions__item__extensionValue_tab
    ___Deactivate_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Deactivate_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Deactivate_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Deactivate_Info_iE_Extensions__item__id),
        (u'criticality', ___Deactivate_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Deactivate_Info_iE_Extensions__item__extensionValue),
        ])
    __Deactivate_Info_iE_Extensions__item_._ext = None
    _Deactivate_Info_iE_Extensions._cont = __Deactivate_Info_iE_Extensions__item_
    _Deactivate_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Deactivate_Info._cont = ASN1Dict([
        (u'deactivation-type', _Deactivate_Info_deactivation_type),
        (u'iE-Extensions', _Deactivate_Info_iE_Extensions),
        ])
    Deactivate_Info._ext = []
    
    #-----< Deactivate-Info-ExtIEs >-----#
    Deactivate_Info_ExtIEs = CLASS(name=u'Deactivate-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Deactivate_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DeltaSIR >-----#
    DeltaSIR = INT(name=u'DeltaSIR', mode=MODE_TYPE)
    DeltaSIR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=None, er=[])
    
    #-----< DGANSSCorrections >-----#
    DGANSSCorrections = SEQ(name=u'DGANSSCorrections', mode=MODE_TYPE)
    _DGANSSCorrections_dGANSS_ReferenceTime = INT(name=u'dGANSS-ReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSSCorrections_dGANSS_ReferenceTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _DGANSSCorrections_dGANSS_Information = SEQ_OF(name=u'dGANSS-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DGANSSCorrections_dGANSS_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___DGANSSCorrections_dGANSS_Information__item__gANSS_SignalId = INT(name=u'gANSS-SignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Signal-ID')), opt=True)
    ___DGANSSCorrections_dGANSS_Information__item__gANSS_StatusHealth = ENUM(name=u'gANSS-StatusHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-StatusHealth')))
    ___DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation = SEQ_OF(name=u'dGANSS-SignalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__satId = INT(name=u'satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__gANSS_iod = BIT_STR(name=u'gANSS-iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__gANSS_iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__udre = ENUM(name=u'udre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UDRE')))
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_prc = INT(name=u'ganss-prc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_prc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_rrc = INT(name=u'ganss-rrc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_rrc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DGNSS-ValidityPeriod')))
    ________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 869), (u'criticality', u'ignore'), (u'Extension', _________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id._const_tab = ________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id._const_tab_at = None
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id._const_tab_id = u'id'
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__criticality._const_tab = ________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__extensionValue._const_tab = ________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id),
        (u'criticality', _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__criticality),
        (u'extensionValue', _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__extensionValue),
        ])
    ______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item_._ext = None
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions._cont = ______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item_
    _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item_._cont = ASN1Dict([
        (u'satId', _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__satId),
        (u'gANSS-iod', _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__gANSS_iod),
        (u'udre', _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__udre),
        (u'ganss-prc', _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_prc),
        (u'ganss-rrc', _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_rrc),
        (u'ie-Extensions', _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions),
        ])
    ____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item_._ext = []
    ___DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation._cont = ____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item_
    ___DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___DGANSSCorrections_dGANSS_Information__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id._const_tab = ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id_tab
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id._const_tab_at = None
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id._const_tab_id = u'id'
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality._const_tab = ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality_tab
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue._const_tab = ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue_tab
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id),
        (u'criticality', _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality),
        (u'extensionValue', _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue),
        ])
    ____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item_._ext = None
    ___DGANSSCorrections_dGANSS_Information__item__ie_Extensions._cont = ____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item_
    ___DGANSSCorrections_dGANSS_Information__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __DGANSSCorrections_dGANSS_Information__item_._cont = ASN1Dict([
        (u'gANSS-SignalId', ___DGANSSCorrections_dGANSS_Information__item__gANSS_SignalId),
        (u'gANSS-StatusHealth', ___DGANSSCorrections_dGANSS_Information__item__gANSS_StatusHealth),
        (u'dGANSS-SignalInformation', ___DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation),
        (u'ie-Extensions', ___DGANSSCorrections_dGANSS_Information__item__ie_Extensions),
        ])
    __DGANSSCorrections_dGANSS_Information__item_._ext = []
    _DGANSSCorrections_dGANSS_Information._cont = __DGANSSCorrections_dGANSS_Information__item_
    _DGANSSCorrections_dGANSS_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _DGANSSCorrections_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSSCorrections_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DGANSSCorrections_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DGANSSCorrections_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGANSSCorrections_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSCorrections_ie_Extensions__item__id._const_tab = ____DGANSSCorrections_ie_Extensions__item__id_tab
    ___DGANSSCorrections_ie_Extensions__item__id._const_tab_at = None
    ___DGANSSCorrections_ie_Extensions__item__id._const_tab_id = u'id'
    ___DGANSSCorrections_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DGANSSCorrections_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGANSSCorrections_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSCorrections_ie_Extensions__item__criticality._const_tab = ____DGANSSCorrections_ie_Extensions__item__criticality_tab
    ___DGANSSCorrections_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DGANSSCorrections_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DGANSSCorrections_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSSCorrections_ie_Extensions__item__extensionValue._const_tab = ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab
    ___DGANSSCorrections_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DGANSSCorrections_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DGANSSCorrections_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DGANSSCorrections_ie_Extensions__item__id),
        (u'criticality', ___DGANSSCorrections_ie_Extensions__item__criticality),
        (u'extensionValue', ___DGANSSCorrections_ie_Extensions__item__extensionValue),
        ])
    __DGANSSCorrections_ie_Extensions__item_._ext = None
    _DGANSSCorrections_ie_Extensions._cont = __DGANSSCorrections_ie_Extensions__item_
    _DGANSSCorrections_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSSCorrections._cont = ASN1Dict([
        (u'dGANSS-ReferenceTime', _DGANSSCorrections_dGANSS_ReferenceTime),
        (u'dGANSS-Information', _DGANSSCorrections_dGANSS_Information),
        (u'ie-Extensions', _DGANSSCorrections_ie_Extensions),
        ])
    DGANSSCorrections._ext = []
    
    #-----< DGANSSCorrections-ExtIEs >-----#
    DGANSSCorrections_ExtIEs = CLASS(name=u'DGANSSCorrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DGANSSCorrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Corrections-Req >-----#
    DGANSS_Corrections_Req = SEQ(name=u'DGANSS-Corrections-Req', mode=MODE_TYPE)
    _DGANSS_Corrections_Req_dGANSS_Signal_ID = BIT_STR(name=u'dGANSS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_Corrections_Req_dGANSS_Signal_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DGANSS_Corrections_Req_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_Corrections_Req_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_Corrections_Req_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DGANSS_Corrections_Req_ie_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-ID')))
    ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 780), (u'criticality', u'ignore'), (u'Extension', _____DGANSS_Corrections_Req_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DGANSS_Corrections_Req_ie_Extensions__item__id._const_tab = ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_Req_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_Corrections_Req_ie_Extensions__item__id._const_tab_id = u'id'
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality._const_tab = ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DGANSS_Corrections_Req_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DGANSS_Corrections_Req_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DGANSS_Corrections_Req_ie_Extensions__item__id),
        (u'criticality', ___DGANSS_Corrections_Req_ie_Extensions__item__criticality),
        (u'extensionValue', ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_Corrections_Req_ie_Extensions__item_._ext = None
    _DGANSS_Corrections_Req_ie_Extensions._cont = __DGANSS_Corrections_Req_ie_Extensions__item_
    _DGANSS_Corrections_Req_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_Corrections_Req._cont = ASN1Dict([
        (u'dGANSS-Signal-ID', _DGANSS_Corrections_Req_dGANSS_Signal_ID),
        (u'ie-Extensions', _DGANSS_Corrections_Req_ie_Extensions),
        ])
    DGANSS_Corrections_Req._ext = []
    
    #-----< DGANSS-Corrections-Req-ExtIEs >-----#
    DGANSS_Corrections_Req_ExtIEs = CLASS(name=u'DGANSS-Corrections-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DGANSS_Corrections_Req_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-ID')))
    DGANSS_Corrections_Req_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 780), (u'criticality', u'ignore'), (u'Extension', _DGANSS_Corrections_Req_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DGANSS-InformationItem-ExtIEs >-----#
    DGANSS_InformationItem_ExtIEs = CLASS(name=u'DGANSS-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DGANSS_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-SignalInformationItem-ExtIEs >-----#
    DGANSS_SignalInformationItem_ExtIEs = CLASS(name=u'DGANSS-SignalInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DGNSS-ValidityPeriod')))
    DGANSS_SignalInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 869), (u'criticality', u'ignore'), (u'Extension', _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DGANSSThreshold >-----#
    DGANSSThreshold = SEQ(name=u'DGANSSThreshold', mode=MODE_TYPE)
    _DGANSSThreshold_pRCDeviation = ENUM(name=u'pRCDeviation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PRCDeviation')))
    DGANSSThreshold._cont = ASN1Dict([
        (u'pRCDeviation', _DGANSSThreshold_pRCDeviation),
        ])
    DGANSSThreshold._ext = []
    
    #-----< DGNSS-ValidityPeriod >-----#
    DGNSS_ValidityPeriod = SEQ(name=u'DGNSS-ValidityPeriod', mode=MODE_TYPE)
    _DGNSS_ValidityPeriod_udreGrowthRate = ENUM(name=u'udreGrowthRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UDREGrowthRate')))
    _DGNSS_ValidityPeriod_udreValidityTime = ENUM(name=u'udreValidityTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UDREValidityTime')))
    _DGNSS_ValidityPeriod_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGNSS_ValidityPeriod_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab_at = None
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab_id = u'id'
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DGNSS_ValidityPeriod_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DGNSS_ValidityPeriod_iE_Extensions__item__id),
        (u'criticality', ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality),
        (u'extensionValue', ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue),
        ])
    __DGNSS_ValidityPeriod_iE_Extensions__item_._ext = None
    _DGNSS_ValidityPeriod_iE_Extensions._cont = __DGNSS_ValidityPeriod_iE_Extensions__item_
    _DGNSS_ValidityPeriod_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGNSS_ValidityPeriod._cont = ASN1Dict([
        (u'udreGrowthRate', _DGNSS_ValidityPeriod_udreGrowthRate),
        (u'udreValidityTime', _DGNSS_ValidityPeriod_udreValidityTime),
        (u'iE-Extensions', _DGNSS_ValidityPeriod_iE_Extensions),
        ])
    DGNSS_ValidityPeriod._ext = []
    
    #-----< DGNSS-ValidityPeriod-ExtIEs >-----#
    DGNSS_ValidityPeriod_ExtIEs = CLASS(name=u'DGNSS-ValidityPeriod-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DGNSS_ValidityPeriod_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGPSCorrections >-----#
    DGPSCorrections = SEQ(name=u'DGPSCorrections', mode=MODE_TYPE)
    _DGPSCorrections_gPSTOW = INT(name=u'gPSTOW', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPSTOW')))
    _DGPSCorrections_gPS_Status_Health = ENUM(name=u'gPS-Status-Health', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-Status-Health')))
    _DGPSCorrections_satellite_DGPSCorrections_Information = SEQ_OF(name=u'satellite-DGPSCorrections-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DGPSCorrections_satellite_DGPSCorrections_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__sAT_ID = INT(name=u'sAT-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAT-ID')))
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iode_dgps = BIT_STR(name=u'iode-dgps', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iode_dgps._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__uDRE = ENUM(name=u'uDRE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UDRE')))
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__pRC = INT(name=u'pRC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PRC')))
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__range_Correction_Rate = INT(name=u'range-Correction-Rate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Range-Correction-Rate')))
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DGNSS-ValidityPeriod')))
    ______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 869), (u'criticality', u'ignore'), (u'Extension', _______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id._const_tab = ______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id._const_tab_at = None
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id._const_tab_id = u'id'
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__criticality._const_tab = ______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__extensionValue._const_tab = ______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id),
        (u'criticality', _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__criticality),
        (u'extensionValue', _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__extensionValue),
        ])
    ____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item_._ext = None
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions._cont = ____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item_
    ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __DGPSCorrections_satellite_DGPSCorrections_Information__item_._cont = ASN1Dict([
        (u'sAT-ID', ___DGPSCorrections_satellite_DGPSCorrections_Information__item__sAT_ID),
        (u'iode-dgps', ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iode_dgps),
        (u'uDRE', ___DGPSCorrections_satellite_DGPSCorrections_Information__item__uDRE),
        (u'pRC', ___DGPSCorrections_satellite_DGPSCorrections_Information__item__pRC),
        (u'range-Correction-Rate', ___DGPSCorrections_satellite_DGPSCorrections_Information__item__range_Correction_Rate),
        (u'iE-Extensions', ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions),
        ])
    __DGPSCorrections_satellite_DGPSCorrections_Information__item_._ext = []
    _DGPSCorrections_satellite_DGPSCorrections_Information._cont = __DGPSCorrections_satellite_DGPSCorrections_Information__item_
    _DGPSCorrections_satellite_DGPSCorrections_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _DGPSCorrections_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGPSCorrections_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DGPSCorrections_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DGPSCorrections_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_iE_Extensions__item__id._const_tab = ____DGPSCorrections_iE_Extensions__item__id_tab
    ___DGPSCorrections_iE_Extensions__item__id._const_tab_at = None
    ___DGPSCorrections_iE_Extensions__item__id._const_tab_id = u'id'
    ___DGPSCorrections_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DGPSCorrections_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_iE_Extensions__item__criticality._const_tab = ____DGPSCorrections_iE_Extensions__item__criticality_tab
    ___DGPSCorrections_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DGPSCorrections_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DGPSCorrections_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DGPSCorrections_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_iE_Extensions__item__extensionValue._const_tab = ____DGPSCorrections_iE_Extensions__item__extensionValue_tab
    ___DGPSCorrections_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DGPSCorrections_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DGPSCorrections_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DGPSCorrections_iE_Extensions__item__id),
        (u'criticality', ___DGPSCorrections_iE_Extensions__item__criticality),
        (u'extensionValue', ___DGPSCorrections_iE_Extensions__item__extensionValue),
        ])
    __DGPSCorrections_iE_Extensions__item_._ext = None
    _DGPSCorrections_iE_Extensions._cont = __DGPSCorrections_iE_Extensions__item_
    _DGPSCorrections_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGPSCorrections._cont = ASN1Dict([
        (u'gPSTOW', _DGPSCorrections_gPSTOW),
        (u'gPS-Status-Health', _DGPSCorrections_gPS_Status_Health),
        (u'satellite-DGPSCorrections-Information', _DGPSCorrections_satellite_DGPSCorrections_Information),
        (u'iE-Extensions', _DGPSCorrections_iE_Extensions),
        ])
    DGPSCorrections._ext = []
    
    #-----< DGPSCorrections-ExtIEs >-----#
    DGPSCorrections_ExtIEs = CLASS(name=u'DGPSCorrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DGPSCorrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGPSThreshold >-----#
    DGPSThreshold = SEQ(name=u'DGPSThreshold', mode=MODE_TYPE)
    _DGPSThreshold_pRCDeviation = ENUM(name=u'pRCDeviation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PRCDeviation')))
    _DGPSThreshold_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGPSThreshold_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DGPSThreshold_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DGPSThreshold_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGPSThreshold_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSThreshold_iE_Extensions__item__id._const_tab = ____DGPSThreshold_iE_Extensions__item__id_tab
    ___DGPSThreshold_iE_Extensions__item__id._const_tab_at = None
    ___DGPSThreshold_iE_Extensions__item__id._const_tab_id = u'id'
    ___DGPSThreshold_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DGPSThreshold_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGPSThreshold_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSThreshold_iE_Extensions__item__criticality._const_tab = ____DGPSThreshold_iE_Extensions__item__criticality_tab
    ___DGPSThreshold_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DGPSThreshold_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DGPSThreshold_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DGPSThreshold_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DGPSThreshold_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSThreshold_iE_Extensions__item__extensionValue._const_tab = ____DGPSThreshold_iE_Extensions__item__extensionValue_tab
    ___DGPSThreshold_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DGPSThreshold_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DGPSThreshold_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DGPSThreshold_iE_Extensions__item__id),
        (u'criticality', ___DGPSThreshold_iE_Extensions__item__criticality),
        (u'extensionValue', ___DGPSThreshold_iE_Extensions__item__extensionValue),
        ])
    __DGPSThreshold_iE_Extensions__item_._ext = None
    _DGPSThreshold_iE_Extensions._cont = __DGPSThreshold_iE_Extensions__item_
    _DGPSThreshold_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGPSThreshold._cont = ASN1Dict([
        (u'pRCDeviation', _DGPSThreshold_pRCDeviation),
        (u'iE-Extensions', _DGPSThreshold_iE_Extensions),
        ])
    DGPSThreshold._ext = []
    
    #-----< DGPSThreshold-ExtIEs >-----#
    DGPSThreshold_ExtIEs = CLASS(name=u'DGPSThreshold-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DGPSThreshold_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DiscardTimer >-----#
    DiscardTimer = ENUM(name=u'DiscardTimer', mode=MODE_TYPE)
    DiscardTimer._cont = ASN1Dict([(u'v20', 0), (u'v40', 1), (u'v60', 2), (u'v80', 3), (u'v100', 4), (u'v120', 5), (u'v140', 6), (u'v160', 7), (u'v180', 8), (u'v200', 9), (u'v250', 10), (u'v300', 11), (u'v400', 12), (u'v500', 13), (u'v750', 14), (u'v1000', 15), (u'v1250', 16), (u'v1500', 17), (u'v1750', 18), (u'v2000', 19), (u'v2500', 20), (u'v3000', 21), (u'v3500', 22), (u'v4000', 23), (u'v4500', 24), (u'v5000', 25), (u'v7500', 26)])
    DiscardTimer._ext = []
    
    #-----< DiversityControlField >-----#
    DiversityControlField = ENUM(name=u'DiversityControlField', mode=MODE_TYPE)
    DiversityControlField._cont = ASN1Dict([(u'may', 0), (u'must', 1), (u'must-not', 2)])
    DiversityControlField._ext = None
    
    #-----< DiversityMode >-----#
    DiversityMode = ENUM(name=u'DiversityMode', mode=MODE_TYPE)
    DiversityMode._cont = ASN1Dict([(u'none', 0), (u'sTTD', 1), (u'closedLoopMode1', 2), (u'not-used-closedLoopMode2', 3)])
    DiversityMode._ext = []
    
    #-----< DL-TBS >-----#
    DL_TBS = SEQ(name=u'DL-TBS', mode=MODE_TYPE)
    _DL_TBS_hs_DSCH_Cell_List = SEQ_OF(name=u'hs-DSCH-Cell-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Cell-List')))
    _DL_TBS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TBS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_TBS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_TBS_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TBS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TBS_iE_Extensions__item__id._const_tab = ____DL_TBS_iE_Extensions__item__id_tab
    ___DL_TBS_iE_Extensions__item__id._const_tab_at = None
    ___DL_TBS_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_TBS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_TBS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TBS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TBS_iE_Extensions__item__criticality._const_tab = ____DL_TBS_iE_Extensions__item__criticality_tab
    ___DL_TBS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_TBS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_TBS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_TBS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TBS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TBS_iE_Extensions__item__extensionValue._const_tab = ____DL_TBS_iE_Extensions__item__extensionValue_tab
    ___DL_TBS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_TBS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_TBS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_TBS_iE_Extensions__item__id),
        (u'criticality', ___DL_TBS_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_TBS_iE_Extensions__item__extensionValue),
        ])
    __DL_TBS_iE_Extensions__item_._ext = None
    _DL_TBS_iE_Extensions._cont = __DL_TBS_iE_Extensions__item_
    _DL_TBS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TBS._cont = ASN1Dict([
        (u'hs-DSCH-Cell-List', _DL_TBS_hs_DSCH_Cell_List),
        (u'iE-Extensions', _DL_TBS_iE_Extensions),
        ])
    DL_TBS._ext = []
    
    #-----< DL-TBS-ExtIEs >-----#
    DL_TBS_ExtIEs = CLASS(name=u'DL-TBS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_TBS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TBS-Value >-----#
    DL_TBS_Value = INT(name=u'DL-TBS-Value', mode=MODE_TYPE)
    DL_TBS_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=160000)], ev=None, er=[])
    
    #-----< DL-DPCH-SlotFormat >-----#
    DL_DPCH_SlotFormat = INT(name=u'DL-DPCH-SlotFormat', mode=MODE_TYPE)
    DL_DPCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=[], er=[ASN1RangeInt(lb=17, ub=18)])
    
    #-----< DL-DPCH-TimingAdjustment >-----#
    DL_DPCH_TimingAdjustment = ENUM(name=u'DL-DPCH-TimingAdjustment', mode=MODE_TYPE)
    DL_DPCH_TimingAdjustment._cont = ASN1Dict([(u'timing-advance', 0), (u'timing-delay', 1)])
    DL_DPCH_TimingAdjustment._ext = None
    
    #-----< DL-Power >-----#
    DL_Power = INT(name=u'DL-Power', mode=MODE_TYPE)
    DL_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-350, ub=150)], ev=None, er=[])
    
    #-----< DL-PowerBalancing-Information >-----#
    DL_PowerBalancing_Information = SEQ(name=u'DL-PowerBalancing-Information', mode=MODE_TYPE)
    _DL_PowerBalancing_Information_powerAdjustmentType = ENUM(name=u'powerAdjustmentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerAdjustmentType')))
    _DL_PowerBalancing_Information_dLReferencePower = INT(name=u'dLReferencePower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_PowerBalancing_Information_dLReferencePowerList = SEQ_OF(name=u'dLReferencePowerList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ReferencePowerInformationList')), opt=True)
    _DL_PowerBalancing_Information_maxAdjustmentStep = INT(name=u'maxAdjustmentStep', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxAdjustmentStep')), opt=True)
    _DL_PowerBalancing_Information_adjustmentPeriod = INT(name=u'adjustmentPeriod', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AdjustmentPeriod')), opt=True)
    _DL_PowerBalancing_Information_adjustmentRatio = INT(name=u'adjustmentRatio', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ScaledAdjustmentRatio')), opt=True)
    _DL_PowerBalancing_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PowerBalancing_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_PowerBalancing_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerBalancing_Information_iE_Extensions__item__id._const_tab = ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab
    ___DL_PowerBalancing_Information_iE_Extensions__item__id._const_tab_at = None
    ___DL_PowerBalancing_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality._const_tab = ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PowerBalancing_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue._const_tab = ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_PowerBalancing_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_PowerBalancing_Information_iE_Extensions__item__id),
        (u'criticality', ___DL_PowerBalancing_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue),
        ])
    __DL_PowerBalancing_Information_iE_Extensions__item_._ext = None
    _DL_PowerBalancing_Information_iE_Extensions._cont = __DL_PowerBalancing_Information_iE_Extensions__item_
    _DL_PowerBalancing_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PowerBalancing_Information._cont = ASN1Dict([
        (u'powerAdjustmentType', _DL_PowerBalancing_Information_powerAdjustmentType),
        (u'dLReferencePower', _DL_PowerBalancing_Information_dLReferencePower),
        (u'dLReferencePowerList', _DL_PowerBalancing_Information_dLReferencePowerList),
        (u'maxAdjustmentStep', _DL_PowerBalancing_Information_maxAdjustmentStep),
        (u'adjustmentPeriod', _DL_PowerBalancing_Information_adjustmentPeriod),
        (u'adjustmentRatio', _DL_PowerBalancing_Information_adjustmentRatio),
        (u'iE-Extensions', _DL_PowerBalancing_Information_iE_Extensions),
        ])
    DL_PowerBalancing_Information._ext = []
    
    #-----< DL-PowerBalancing-Information-ExtIEs >-----#
    DL_PowerBalancing_Information_ExtIEs = CLASS(name=u'DL-PowerBalancing-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_PowerBalancing_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-ReferencePowerInformationList >-----#
    DL_ReferencePowerInformationList = SEQ_OF(name=u'DL-ReferencePowerInformationList', mode=MODE_TYPE)
    _DL_ReferencePowerInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-ReferencePowerInformationItem')))
    DL_ReferencePowerInformationList._cont = _DL_ReferencePowerInformationList__item_
    DL_ReferencePowerInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-ReferencePowerInformationItem >-----#
    DL_ReferencePowerInformationItem = SEQ(name=u'DL-ReferencePowerInformationItem', mode=MODE_TYPE)
    _DL_ReferencePowerInformationItem_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _DL_ReferencePowerInformationItem_dl_Reference_Power = INT(name=u'dl-Reference-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_ReferencePowerInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_ReferencePowerInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id._const_tab = ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality._const_tab = ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_ReferencePowerInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_ReferencePowerInformationItem_iE_Extensions__item__id),
        (u'criticality', ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_ReferencePowerInformationItem_iE_Extensions__item_._ext = None
    _DL_ReferencePowerInformationItem_iE_Extensions._cont = __DL_ReferencePowerInformationItem_iE_Extensions__item_
    _DL_ReferencePowerInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_ReferencePowerInformationItem._cont = ASN1Dict([
        (u'rL-ID', _DL_ReferencePowerInformationItem_rL_ID),
        (u'dl-Reference-Power', _DL_ReferencePowerInformationItem_dl_Reference_Power),
        (u'iE-Extensions', _DL_ReferencePowerInformationItem_iE_Extensions),
        ])
    DL_ReferencePowerInformationItem._ext = []
    
    #-----< DL-ReferencePowerInformationItem-ExtIEs >-----#
    DL_ReferencePowerInformationItem_ExtIEs = CLASS(name=u'DL-ReferencePowerInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_ReferencePowerInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerBalancing-ActivationIndicator >-----#
    DL_PowerBalancing_ActivationIndicator = ENUM(name=u'DL-PowerBalancing-ActivationIndicator', mode=MODE_TYPE)
    DL_PowerBalancing_ActivationIndicator._cont = ASN1Dict([(u'dL-PowerBalancing-Activated', 0)])
    DL_PowerBalancing_ActivationIndicator._ext = None
    
    #-----< DL-PowerBalancing-UpdatedIndicator >-----#
    DL_PowerBalancing_UpdatedIndicator = ENUM(name=u'DL-PowerBalancing-UpdatedIndicator', mode=MODE_TYPE)
    DL_PowerBalancing_UpdatedIndicator._cont = ASN1Dict([(u'dL-PowerBalancing-Updated', 0)])
    DL_PowerBalancing_UpdatedIndicator._ext = None
    
    #-----< DL-ReferencePowerInformation >-----#
    DL_ReferencePowerInformation = SEQ(name=u'DL-ReferencePowerInformation', mode=MODE_TYPE)
    _DL_ReferencePowerInformation_common_DL_ReferencePowerInformation = INT(name=u'common-DL-ReferencePowerInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_ReferencePowerInformation_individual_DL_ReferencePowerInformation = SEQ_OF(name=u'individual-DL-ReferencePowerInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ReferencePowerInformationList')), opt=True)
    _DL_ReferencePowerInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_ReferencePowerInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_ReferencePowerInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_ReferencePowerInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformation_iE_Extensions__item__id._const_tab = ____DL_ReferencePowerInformation_iE_Extensions__item__id_tab
    ___DL_ReferencePowerInformation_iE_Extensions__item__id._const_tab_at = None
    ___DL_ReferencePowerInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_ReferencePowerInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_ReferencePowerInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformation_iE_Extensions__item__criticality._const_tab = ____DL_ReferencePowerInformation_iE_Extensions__item__criticality_tab
    ___DL_ReferencePowerInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_ReferencePowerInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_ReferencePowerInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_ReferencePowerInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformation_iE_Extensions__item__extensionValue._const_tab = ____DL_ReferencePowerInformation_iE_Extensions__item__extensionValue_tab
    ___DL_ReferencePowerInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_ReferencePowerInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_ReferencePowerInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_ReferencePowerInformation_iE_Extensions__item__id),
        (u'criticality', ___DL_ReferencePowerInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_ReferencePowerInformation_iE_Extensions__item__extensionValue),
        ])
    __DL_ReferencePowerInformation_iE_Extensions__item_._ext = None
    _DL_ReferencePowerInformation_iE_Extensions._cont = __DL_ReferencePowerInformation_iE_Extensions__item_
    _DL_ReferencePowerInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_ReferencePowerInformation._cont = ASN1Dict([
        (u'common-DL-ReferencePowerInformation', _DL_ReferencePowerInformation_common_DL_ReferencePowerInformation),
        (u'individual-DL-ReferencePowerInformation', _DL_ReferencePowerInformation_individual_DL_ReferencePowerInformation),
        (u'iE-Extensions', _DL_ReferencePowerInformation_iE_Extensions),
        ])
    DL_ReferencePowerInformation._ext = []
    
    #-----< DL-ReferencePowerInformation-ExtIEs >-----#
    DL_ReferencePowerInformation_ExtIEs = CLASS(name=u'DL-ReferencePowerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_ReferencePowerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< D-RNTI >-----#
    D_RNTI = INT(name=u'D-RNTI', mode=MODE_TYPE)
    D_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< D-RNTI-ReleaseIndication >-----#
    D_RNTI_ReleaseIndication = ENUM(name=u'D-RNTI-ReleaseIndication', mode=MODE_TYPE)
    D_RNTI_ReleaseIndication._cont = ASN1Dict([(u'release-D-RNTI', 0), (u'not-release-D-RNTI', 1)])
    D_RNTI_ReleaseIndication._ext = None
    
    #-----< DL-ScramblingCode >-----#
    DL_ScramblingCode = INT(name=u'DL-ScramblingCode', mode=MODE_TYPE)
    DL_ScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< DL-FrameType >-----#
    DL_FrameType = ENUM(name=u'DL-FrameType', mode=MODE_TYPE)
    DL_FrameType._cont = ASN1Dict([(u'typeA', 0), (u'typeB', 1)])
    DL_FrameType._ext = []
    
    #-----< DL-Timeslot-Information >-----#
    DL_Timeslot_Information = SEQ_OF(name=u'DL-Timeslot-Information', mode=MODE_TYPE)
    _DL_Timeslot_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-InformationItem')))
    DL_Timeslot_Information._cont = _DL_Timeslot_Information__item_
    DL_Timeslot_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationItem >-----#
    DL_Timeslot_InformationItem = SEQ(name=u'DL-Timeslot-InformationItem', mode=MODE_TYPE)
    _DL_Timeslot_InformationItem_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationItem_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _DL_Timeslot_InformationItem_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot_InformationItem_dL_Code_Information = SEQ_OF(name=u'dL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-Information')))
    _DL_Timeslot_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationItem_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationItem_iE_Extensions._cont = __DL_Timeslot_InformationItem_iE_Extensions__item_
    _DL_Timeslot_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationItem._cont = ASN1Dict([
        (u'timeSlot', _DL_Timeslot_InformationItem_timeSlot),
        (u'midambleShiftAndBurstType', _DL_Timeslot_InformationItem_midambleShiftAndBurstType),
        (u'tFCI-Presence', _DL_Timeslot_InformationItem_tFCI_Presence),
        (u'dL-Code-Information', _DL_Timeslot_InformationItem_dL_Code_Information),
        (u'iE-Extensions', _DL_Timeslot_InformationItem_iE_Extensions),
        ])
    DL_Timeslot_InformationItem._ext = []
    
    #-----< DL-Timeslot-InformationItem-ExtIEs >-----#
    DL_Timeslot_InformationItem_ExtIEs = CLASS(name=u'DL-Timeslot-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotLCR-Information >-----#
    DL_TimeslotLCR_Information = SEQ_OF(name=u'DL-TimeslotLCR-Information', mode=MODE_TYPE)
    _DL_TimeslotLCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotLCR-InformationItem')))
    DL_TimeslotLCR_Information._cont = _DL_TimeslotLCR_Information__item_
    DL_TimeslotLCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-TimeslotLCR-InformationItem >-----#
    DL_TimeslotLCR_InformationItem = SEQ(name=u'DL-TimeslotLCR-InformationItem', mode=MODE_TYPE)
    _DL_TimeslotLCR_InformationItem_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _DL_TimeslotLCR_InformationItem_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _DL_TimeslotLCR_InformationItem_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _DL_TimeslotLCR_InformationItem_dL_Code_LCR_Information = SEQ_OF(name=u'dL-Code-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-LCR-Information')))
    _DL_TimeslotLCR_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeslotLCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 510), (u'criticality', u'ignore'), (u'Extension', _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 511), (u'criticality', u'ignore'), (u'Extension', _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab = ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_TimeslotLCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeslotLCR_InformationItem_iE_Extensions__item_._ext = None
    _DL_TimeslotLCR_InformationItem_iE_Extensions._cont = __DL_TimeslotLCR_InformationItem_iE_Extensions__item_
    _DL_TimeslotLCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeslotLCR_InformationItem._cont = ASN1Dict([
        (u'timeSlotLCR', _DL_TimeslotLCR_InformationItem_timeSlotLCR),
        (u'midambleShiftLCR', _DL_TimeslotLCR_InformationItem_midambleShiftLCR),
        (u'tFCI-Presence', _DL_TimeslotLCR_InformationItem_tFCI_Presence),
        (u'dL-Code-LCR-Information', _DL_TimeslotLCR_InformationItem_dL_Code_LCR_Information),
        (u'iE-Extensions', _DL_TimeslotLCR_InformationItem_iE_Extensions),
        ])
    DL_TimeslotLCR_InformationItem._ext = []
    
    #-----< DL-TimeslotLCR-InformationItem-ExtIEs >-----#
    DL_TimeslotLCR_InformationItem_ExtIEs = CLASS(name=u'DL-TimeslotLCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    DL_TimeslotLCR_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 510), (u'criticality', u'ignore'), (u'Extension', _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 511), (u'criticality', u'ignore'), (u'Extension', _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-Information768 >-----#
    DL_Timeslot_Information768 = SEQ_OF(name=u'DL-Timeslot-Information768', mode=MODE_TYPE)
    _DL_Timeslot_Information768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-InformationItem768')))
    DL_Timeslot_Information768._cont = _DL_Timeslot_Information768__item_
    DL_Timeslot_Information768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationItem768 >-----#
    DL_Timeslot_InformationItem768 = SEQ(name=u'DL-Timeslot-InformationItem768', mode=MODE_TYPE)
    _DL_Timeslot_InformationItem768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationItem768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _DL_Timeslot_InformationItem768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _DL_Timeslot_InformationItem768_dL_Code_Information768 = SEQ_OF(name=u'dL-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-Information768')))
    _DL_Timeslot_InformationItem768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationItem768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_InformationItem768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationItem768_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_InformationItem768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_InformationItem768_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_InformationItem768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationItem768_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationItem768_iE_Extensions._cont = __DL_Timeslot_InformationItem768_iE_Extensions__item_
    _DL_Timeslot_InformationItem768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationItem768._cont = ASN1Dict([
        (u'timeSlot', _DL_Timeslot_InformationItem768_timeSlot),
        (u'midambleShiftAndBurstType768', _DL_Timeslot_InformationItem768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _DL_Timeslot_InformationItem768_tFCI_Presence),
        (u'dL-Code-Information768', _DL_Timeslot_InformationItem768_dL_Code_Information768),
        (u'iE-Extensions', _DL_Timeslot_InformationItem768_iE_Extensions),
        ])
    DL_Timeslot_InformationItem768._ext = []
    
    #-----< DL-Timeslot-InformationItem768-ExtIEs >-----#
    DL_Timeslot_InformationItem768_ExtIEs = CLASS(name=u'DL-Timeslot-InformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TimeSlot-ISCP-Info >-----#
    DL_TimeSlot_ISCP_Info = SEQ_OF(name=u'DL-TimeSlot-ISCP-Info', mode=MODE_TYPE)
    _DL_TimeSlot_ISCP_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-InfoItem')))
    DL_TimeSlot_ISCP_Info._cont = _DL_TimeSlot_ISCP_Info__item_
    DL_TimeSlot_ISCP_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-TimeSlot-ISCP-InfoItem >-----#
    DL_TimeSlot_ISCP_InfoItem = SEQ(name=u'DL-TimeSlot-ISCP-InfoItem', mode=MODE_TYPE)
    _DL_TimeSlot_ISCP_InfoItem_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_TimeSlot_ISCP_InfoItem_dL_TimeslotISCP = INT(name=u'dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotISCP')))
    _DL_TimeSlot_ISCP_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab = ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab = ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_._ext = None
    _DL_TimeSlot_ISCP_InfoItem_iE_Extensions._cont = __DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_
    _DL_TimeSlot_ISCP_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeSlot_ISCP_InfoItem._cont = ASN1Dict([
        (u'timeSlot', _DL_TimeSlot_ISCP_InfoItem_timeSlot),
        (u'dL-TimeslotISCP', _DL_TimeSlot_ISCP_InfoItem_dL_TimeslotISCP),
        (u'iE-Extensions', _DL_TimeSlot_ISCP_InfoItem_iE_Extensions),
        ])
    DL_TimeSlot_ISCP_InfoItem._ext = []
    
    #-----< DL-TimeSlot-ISCP-InfoItem-ExtIEs >-----#
    DL_TimeSlot_ISCP_InfoItem_ExtIEs = CLASS(name=u'DL-TimeSlot-ISCP-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_TimeSlot_ISCP_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TimeSlot-ISCP-LCR-Information >-----#
    DL_TimeSlot_ISCP_LCR_Information = SEQ_OF(name=u'DL-TimeSlot-ISCP-LCR-Information', mode=MODE_TYPE)
    _DL_TimeSlot_ISCP_LCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-InfoItem')))
    DL_TimeSlot_ISCP_LCR_Information._cont = _DL_TimeSlot_ISCP_LCR_Information__item_
    DL_TimeSlot_ISCP_LCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-TimeSlot-ISCP-LCR-InfoItem >-----#
    DL_TimeSlot_ISCP_LCR_InfoItem = SEQ(name=u'DL-TimeSlot-ISCP-LCR-InfoItem', mode=MODE_TYPE)
    _DL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _DL_TimeSlot_ISCP_LCR_InfoItem_dL_TimeslotISCP = INT(name=u'dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotISCP')))
    _DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab = ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab = ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_._ext = None
    _DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions._cont = __DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_
    _DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeSlot_ISCP_LCR_InfoItem._cont = ASN1Dict([
        (u'timeSlotLCR', _DL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR),
        (u'dL-TimeslotISCP', _DL_TimeSlot_ISCP_LCR_InfoItem_dL_TimeslotISCP),
        (u'iE-Extensions', _DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions),
        ])
    DL_TimeSlot_ISCP_LCR_InfoItem._ext = []
    
    #-----< DL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs >-----#
    DL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs = CLASS(name=u'DL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotISCP >-----#
    DL_TimeslotISCP = INT(name=u'DL-TimeslotISCP', mode=MODE_TYPE)
    DL_TimeslotISCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=91)], ev=None, er=[])
    
    #-----< Downlink-Compressed-Mode-Method >-----#
    Downlink_Compressed_Mode_Method = ENUM(name=u'Downlink-Compressed-Mode-Method', mode=MODE_TYPE)
    Downlink_Compressed_Mode_Method._cont = ASN1Dict([(u'not-Used-puncturing', 0), (u'sFdiv2', 1), (u'higher-layer-scheduling', 2)])
    Downlink_Compressed_Mode_Method._ext = []
    
    #-----< Downlink-TPC-enhancements-Information >-----#
    Downlink_TPC_enhancements_Information = SEQ(name=u'Downlink-TPC-enhancements-Information', mode=MODE_TYPE)
    _Downlink_TPC_enhancements_Information_decimationFactorforPrimaryFrequency = ENUM(name=u'decimationFactorforPrimaryFrequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DecimationFactor')), opt=True)
    _Downlink_TPC_enhancements_Information_decimationFactorforSecFrequency = ENUM(name=u'decimationFactorforSecFrequency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DecimationFactor')), opt=True)
    _Downlink_TPC_enhancements_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Downlink_TPC_enhancements_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id._const_tab = ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id._const_tab_at = None
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality._const_tab = ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue._const_tab = ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Downlink_TPC_enhancements_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id),
        (u'criticality', ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue),
        ])
    __Downlink_TPC_enhancements_Information_iE_Extensions__item_._ext = None
    _Downlink_TPC_enhancements_Information_iE_Extensions._cont = __Downlink_TPC_enhancements_Information_iE_Extensions__item_
    _Downlink_TPC_enhancements_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Downlink_TPC_enhancements_Information._cont = ASN1Dict([
        (u'decimationFactorforPrimaryFrequency', _Downlink_TPC_enhancements_Information_decimationFactorforPrimaryFrequency),
        (u'decimationFactorforSecFrequency', _Downlink_TPC_enhancements_Information_decimationFactorforSecFrequency),
        (u'iE-Extensions', _Downlink_TPC_enhancements_Information_iE_Extensions),
        ])
    Downlink_TPC_enhancements_Information._ext = []
    
    #-----< Downlink-TPC-enhancements-Information-ExtIEs >-----#
    Downlink_TPC_enhancements_Information_ExtIEs = CLASS(name=u'Downlink-TPC-enhancements-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Downlink_TPC_enhancements_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Downlink-TPC-enhancements-Reconf >-----#
    Downlink_TPC_enhancements_Reconf = SEQ(name=u'Downlink-TPC-enhancements-Reconf', mode=MODE_TYPE)
    _Downlink_TPC_enhancements_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements')))
    _Downlink_TPC_enhancements_Reconf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id._const_tab = ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id._const_tab_id = u'id'
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality._const_tab = ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue._const_tab = ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id),
        (u'criticality', ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality),
        (u'extensionValue', ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue),
        ])
    __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_._ext = None
    _Downlink_TPC_enhancements_Reconf_iE_Extensions._cont = __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_
    _Downlink_TPC_enhancements_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Downlink_TPC_enhancements_Reconf._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements', _Downlink_TPC_enhancements_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements),
        (u'iE-Extensions', _Downlink_TPC_enhancements_Reconf_iE_Extensions),
        ])
    Downlink_TPC_enhancements_Reconf._ext = []
    
    #-----< Downlink-TPC-enhancements-Reconf-ExtIEs >-----#
    Downlink_TPC_enhancements_Reconf_ExtIEs = CLASS(name=u'Downlink-TPC-enhancements-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Downlink_TPC_enhancements_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Downlink-TPC-enhancements-Information-Removal >-----#
    Downlink_TPC_enhancements_Information_Removal = ENUM(name=u'Downlink-TPC-enhancements-Information-Removal', mode=MODE_TYPE)
    Downlink_TPC_enhancements_Information_Removal._cont = ASN1Dict([(u'remove', 0)])
    Downlink_TPC_enhancements_Information_Removal._ext = []
    
    #-----< DPC-Mode >-----#
    DPC_Mode = ENUM(name=u'DPC-Mode', mode=MODE_TYPE)
    DPC_Mode._cont = ASN1Dict([(u'mode0', 0), (u'mode1', 1)])
    DPC_Mode._ext = []
    
    #-----< DPC-Mode-Change-SupportIndicator >-----#
    DPC_Mode_Change_SupportIndicator = ENUM(name=u'DPC-Mode-Change-SupportIndicator', mode=MODE_TYPE)
    DPC_Mode_Change_SupportIndicator._cont = ASN1Dict([(u'dPC-ModeChangeSupported', 0)])
    DPC_Mode_Change_SupportIndicator._ext = None
    
    #-----< DPCH-ID >-----#
    DPCH_ID = INT(name=u'DPCH-ID', mode=MODE_TYPE)
    DPCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=239)], ev=None, er=[])
    
    #-----< DPCH-ID768 >-----#
    DPCH_ID768 = INT(name=u'DPCH-ID768', mode=MODE_TYPE)
    DPCH_ID768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=479)], ev=None, er=[])
    
    #-----< DPCHConstantValue >-----#
    DPCHConstantValue = INT(name=u'DPCHConstantValue', mode=MODE_TYPE)
    DPCHConstantValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-10, ub=10)], ev=None, er=[])
    
    #-----< DRACControl >-----#
    DRACControl = ENUM(name=u'DRACControl', mode=MODE_TYPE)
    DRACControl._cont = ASN1Dict([(u'not-Used-requested', 0), (u'not-requested', 1)])
    DRACControl._ext = None
    
    #-----< DRXCycleLengthCoefficient >-----#
    DRXCycleLengthCoefficient = INT(name=u'DRXCycleLengthCoefficient', mode=MODE_TYPE)
    DRXCycleLengthCoefficient._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=9)], ev=None, er=[])
    
    #-----< DRX-Information >-----#
    DRX_Information = SEQ(name=u'DRX-Information', mode=MODE_TYPE)
    _DRX_Information_uE_DRX_Cycle = ENUM(name=u'uE-DRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle')))
    _DRX_Information_inactivity_Threshold_for_UE_DRX_Cycle = ENUM(name=u'inactivity-Threshold-for-UE-DRX-Cycle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    _DRX_Information_inactivity_Threshold_for_UE_Grant_Monitoring = ENUM(name=u'inactivity-Threshold-for-UE-Grant-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-Grant-Monitoring')))
    _DRX_Information_uE_DRX_Grant_Monitoring = BOOL(name=u'uE-DRX-Grant-Monitoring', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Grant-Monitoring')))
    _DRX_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRX_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DRX_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRX_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle')))
    _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    ____DRX_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 960), (u'criticality', u'ignore'), (u'Extension', _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 961), (u'criticality', u'ignore'), (u'Extension', _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRX_Information_iE_Extensions__item__id._const_tab = ____DRX_Information_iE_Extensions__item__id_tab
    ___DRX_Information_iE_Extensions__item__id._const_tab_at = None
    ___DRX_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRX_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRX_Information_iE_Extensions__item__criticality._const_tab = ____DRX_Information_iE_Extensions__item__id_tab
    ___DRX_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRX_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRX_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRX_Information_iE_Extensions__item__extensionValue._const_tab = ____DRX_Information_iE_Extensions__item__id_tab
    ___DRX_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRX_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRX_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRX_Information_iE_Extensions__item__id),
        (u'criticality', ___DRX_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRX_Information_iE_Extensions__item__extensionValue),
        ])
    __DRX_Information_iE_Extensions__item_._ext = None
    _DRX_Information_iE_Extensions._cont = __DRX_Information_iE_Extensions__item_
    _DRX_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRX_Information._cont = ASN1Dict([
        (u'uE-DRX-Cycle', _DRX_Information_uE_DRX_Cycle),
        (u'inactivity-Threshold-for-UE-DRX-Cycle', _DRX_Information_inactivity_Threshold_for_UE_DRX_Cycle),
        (u'inactivity-Threshold-for-UE-Grant-Monitoring', _DRX_Information_inactivity_Threshold_for_UE_Grant_Monitoring),
        (u'uE-DRX-Grant-Monitoring', _DRX_Information_uE_DRX_Grant_Monitoring),
        (u'iE-Extensions', _DRX_Information_iE_Extensions),
        ])
    DRX_Information._ext = []
    
    #-----< DRX-Information-ExtIEs >-----#
    DRX_Information_ExtIEs = CLASS(name=u'DRX-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DRX_Information_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle')))
    _DRX_Information_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    DRX_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 960), (u'criticality', u'ignore'), (u'Extension', _DRX_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 961), (u'criticality', u'ignore'), (u'Extension', _DRX_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DRX-Information-to-Modify-LCR >-----#
    DRX_Information_to_Modify_LCR = CHOICE(name=u'DRX-Information-to-Modify-LCR', mode=MODE_TYPE)
    _DRX_Information_to_Modify_LCR_modify = SEQ(name=u'modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DRX-Information-to-Modify-Items-LCR')))
    _DRX_Information_to_Modify_LCR_deactivate = NULL(name=u'deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DRX_Information_to_Modify_LCR._cont = ASN1Dict([
        (u'modify', _DRX_Information_to_Modify_LCR_modify),
        (u'deactivate', _DRX_Information_to_Modify_LCR_deactivate),
        ])
    DRX_Information_to_Modify_LCR._ext = []
    
    #-----< DRX-Information-to-Modify-Items-LCR >-----#
    DRX_Information_to_Modify_Items_LCR = SEQ(name=u'DRX-Information-to-Modify-Items-LCR', mode=MODE_TYPE)
    _DRX_Information_to_Modify_Items_LCR_hS_SCCH_DRX_Information_LCR = SEQ(name=u'hS-SCCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-DRX-Information-LCR')), opt=True)
    _DRX_Information_to_Modify_Items_LCR_e_AGCH_DRX_Information_LCR = CHOICE(name=u'e-AGCH-DRX-Information-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-DRX-Information-LCR')), opt=True)
    _DRX_Information_to_Modify_Items_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id._const_tab = ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id._const_tab_at = None
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality._const_tab = ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue._const_tab = ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id),
        (u'criticality', ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue),
        ])
    __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_._ext = None
    _DRX_Information_to_Modify_Items_LCR_iE_Extensions._cont = __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_
    _DRX_Information_to_Modify_Items_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRX_Information_to_Modify_Items_LCR._cont = ASN1Dict([
        (u'hS-SCCH-DRX-Information-LCR', _DRX_Information_to_Modify_Items_LCR_hS_SCCH_DRX_Information_LCR),
        (u'e-AGCH-DRX-Information-LCR', _DRX_Information_to_Modify_Items_LCR_e_AGCH_DRX_Information_LCR),
        (u'iE-Extensions', _DRX_Information_to_Modify_Items_LCR_iE_Extensions),
        ])
    DRX_Information_to_Modify_Items_LCR._ext = []
    
    #-----< DRX-Information-to-Modify-Items-LCR-ExtIEs >-----#
    DRX_Information_to_Modify_Items_LCR_ExtIEs = CLASS(name=u'DRX-Information-to-Modify-Items-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DRX_Information_to_Modify_Items_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DRX-Information-to-Modify >-----#
    DRX_Information_to_Modify = CHOICE(name=u'DRX-Information-to-Modify', mode=MODE_TYPE)
    _DRX_Information_to_Modify_modify = SEQ(name=u'modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DRX-Information-to-Modify-Items')))
    _DRX_Information_to_Modify_deactivate = NULL(name=u'deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DRX_Information_to_Modify._cont = ASN1Dict([
        (u'modify', _DRX_Information_to_Modify_modify),
        (u'deactivate', _DRX_Information_to_Modify_deactivate),
        ])
    DRX_Information_to_Modify._ext = []
    
    #-----< DRX-Information-to-Modify-Items >-----#
    DRX_Information_to_Modify_Items = SEQ(name=u'DRX-Information-to-Modify-Items', mode=MODE_TYPE)
    _DRX_Information_to_Modify_Items_uE_DRX_Cycle = ENUM(name=u'uE-DRX-Cycle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle')), opt=True)
    _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DRX_Cycle = ENUM(name=u'inactivity-Threshold-for-UE-DRX-Cycle', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')), opt=True)
    _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_Grant_Monitoring = ENUM(name=u'inactivity-Threshold-for-UE-Grant-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-Grant-Monitoring')), opt=True)
    _DRX_Information_to_Modify_Items_uE_DRX_Grant_Monitoring = BOOL(name=u'uE-DRX-Grant-Monitoring', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Grant-Monitoring')), opt=True)
    _DRX_Information_to_Modify_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DRX_Information_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle')))
    _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 960), (u'criticality', u'ignore'), (u'Extension', _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 961), (u'criticality', u'ignore'), (u'Extension', _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DRX_Information_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DRX_Information_to_Modify_Items_iE_Extensions__item__id),
        (u'criticality', ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DRX_Information_to_Modify_Items_iE_Extensions__item_._ext = None
    _DRX_Information_to_Modify_Items_iE_Extensions._cont = __DRX_Information_to_Modify_Items_iE_Extensions__item_
    _DRX_Information_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DRX_Information_to_Modify_Items._cont = ASN1Dict([
        (u'uE-DRX-Cycle', _DRX_Information_to_Modify_Items_uE_DRX_Cycle),
        (u'inactivity-Threshold-for-UE-DRX-Cycle', _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DRX_Cycle),
        (u'inactivity-Threshold-for-UE-Grant-Monitoring', _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_Grant_Monitoring),
        (u'uE-DRX-Grant-Monitoring', _DRX_Information_to_Modify_Items_uE_DRX_Grant_Monitoring),
        (u'iE-Extensions', _DRX_Information_to_Modify_Items_iE_Extensions),
        ])
    DRX_Information_to_Modify_Items._ext = []
    
    #-----< DRX-Information-to-Modify-Items-ExtIEs >-----#
    DRX_Information_to_Modify_Items_ExtIEs = CLASS(name=u'DRX-Information-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle')))
    _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle')))
    DRX_Information_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 960), (u'criticality', u'ignore'), (u'Extension', _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 961), (u'criticality', u'ignore'), (u'Extension', _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DSCH-RNTI >-----#
    DSCH_RNTI = INT(name=u'DSCH-RNTI', mode=MODE_TYPE)
    DSCH_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< DSCH-FlowControlInformation >-----#
    DSCH_FlowControlInformation = SEQ_OF(name=u'DSCH-FlowControlInformation', mode=MODE_TYPE)
    _DSCH_FlowControlInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-FlowControlItem')))
    DSCH_FlowControlInformation._cont = _DSCH_FlowControlInformation__item_
    DSCH_FlowControlInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DSCH-FlowControlItem >-----#
    DSCH_FlowControlItem = SEQ(name=u'DSCH-FlowControlItem', mode=MODE_TYPE)
    _DSCH_FlowControlItem_dSCH_SchedulingPriority = INT(name=u'dSCH-SchedulingPriority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _DSCH_FlowControlItem_mAC_c_sh_SDU_Lengths = SEQ_OF(name=u'mAC-c-sh-SDU-Lengths', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-c-sh-SDU-LengthList')))
    _DSCH_FlowControlItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_FlowControlItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_FlowControlItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCH_FlowControlItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DSCH_FlowControlItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-InitialWindowSize')))
    ____DSCH_FlowControlItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 480), (u'criticality', u'ignore'), (u'Extension', _____DSCH_FlowControlItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DSCH_FlowControlItem_iE_Extensions__item__id._const_tab = ____DSCH_FlowControlItem_iE_Extensions__item__id_tab
    ___DSCH_FlowControlItem_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_FlowControlItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCH_FlowControlItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DSCH_FlowControlItem_iE_Extensions__item__criticality._const_tab = ____DSCH_FlowControlItem_iE_Extensions__item__id_tab
    ___DSCH_FlowControlItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCH_FlowControlItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCH_FlowControlItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DSCH_FlowControlItem_iE_Extensions__item__extensionValue._const_tab = ____DSCH_FlowControlItem_iE_Extensions__item__id_tab
    ___DSCH_FlowControlItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCH_FlowControlItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCH_FlowControlItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCH_FlowControlItem_iE_Extensions__item__id),
        (u'criticality', ___DSCH_FlowControlItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCH_FlowControlItem_iE_Extensions__item__extensionValue),
        ])
    __DSCH_FlowControlItem_iE_Extensions__item_._ext = None
    _DSCH_FlowControlItem_iE_Extensions._cont = __DSCH_FlowControlItem_iE_Extensions__item_
    _DSCH_FlowControlItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_FlowControlItem._cont = ASN1Dict([
        (u'dSCH-SchedulingPriority', _DSCH_FlowControlItem_dSCH_SchedulingPriority),
        (u'mAC-c-sh-SDU-Lengths', _DSCH_FlowControlItem_mAC_c_sh_SDU_Lengths),
        (u'iE-Extensions', _DSCH_FlowControlItem_iE_Extensions),
        ])
    DSCH_FlowControlItem._ext = []
    
    #-----< DSCH-FlowControlItem-ExtIEs >-----#
    DSCH_FlowControlItem_ExtIEs = CLASS(name=u'DSCH-FlowControlItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DSCH_FlowControlItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-InitialWindowSize')))
    DSCH_FlowControlItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 480), (u'criticality', u'ignore'), (u'Extension', _DSCH_FlowControlItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DSCH-ID >-----#
    DSCH_ID = INT(name=u'DSCH-ID', mode=MODE_TYPE)
    DSCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DSCH-InitialWindowSize >-----#
    DSCH_InitialWindowSize = INT(name=u'DSCH-InitialWindowSize', mode=MODE_TYPE)
    DSCH_InitialWindowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< DSCH-TDD-Information >-----#
    DSCH_TDD_Information = SEQ_OF(name=u'DSCH-TDD-Information', mode=MODE_TYPE)
    _DSCH_TDD_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-TDD-InformationItem')))
    DSCH_TDD_Information._cont = _DSCH_TDD_Information__item_
    DSCH_TDD_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< DSCH-TDD-InformationItem >-----#
    DSCH_TDD_InformationItem = SEQ(name=u'DSCH-TDD-InformationItem', mode=MODE_TYPE)
    _DSCH_TDD_InformationItem_dSCH_ID = INT(name=u'dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCH_TDD_InformationItem_dl_ccTrCHID = INT(name=u'dl-ccTrCHID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DSCH_TDD_InformationItem_trChSourceStatisticsDescriptor = ENUM(name=u'trChSourceStatisticsDescriptor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    _DSCH_TDD_InformationItem_transportFormatSet = SEQ(name=u'transportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _DSCH_TDD_InformationItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')))
    _DSCH_TDD_InformationItem_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _DSCH_TDD_InformationItem_bLER = INT(name=u'bLER', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')))
    _DSCH_TDD_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_TDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id._const_tab = ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCH_TDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCH_TDD_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __DSCH_TDD_InformationItem_iE_Extensions__item_._ext = None
    _DSCH_TDD_InformationItem_iE_Extensions._cont = __DSCH_TDD_InformationItem_iE_Extensions__item_
    _DSCH_TDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_TDD_InformationItem._cont = ASN1Dict([
        (u'dSCH-ID', _DSCH_TDD_InformationItem_dSCH_ID),
        (u'dl-ccTrCHID', _DSCH_TDD_InformationItem_dl_ccTrCHID),
        (u'trChSourceStatisticsDescriptor', _DSCH_TDD_InformationItem_trChSourceStatisticsDescriptor),
        (u'transportFormatSet', _DSCH_TDD_InformationItem_transportFormatSet),
        (u'allocationRetentionPriority', _DSCH_TDD_InformationItem_allocationRetentionPriority),
        (u'schedulingPriorityIndicator', _DSCH_TDD_InformationItem_schedulingPriorityIndicator),
        (u'bLER', _DSCH_TDD_InformationItem_bLER),
        (u'iE-Extensions', _DSCH_TDD_InformationItem_iE_Extensions),
        ])
    DSCH_TDD_InformationItem._ext = []
    
    #-----< DSCH-TDD-InformationItem-ExtIEs >-----#
    DSCH_TDD_InformationItem_ExtIEs = CLASS(name=u'DSCH-TDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _DSCH_TDD_InformationItem_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    DSCH_TDD_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _DSCH_TDD_InformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DsField >-----#
    DsField = BIT_STR(name=u'DsField', mode=MODE_TYPE)
    DsField._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< DTX-Cycle-2ms-Items >-----#
    DTX_Cycle_2ms_Items = SEQ(name=u'DTX-Cycle-2ms-Items', mode=MODE_TYPE)
    _DTX_Cycle_2ms_Items_uE_DTX_Cycle1_2ms = ENUM(name=u'uE-DTX-Cycle1-2ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle1-2ms')))
    _DTX_Cycle_2ms_Items_uE_DTX_Cycle2_2ms = ENUM(name=u'uE-DTX-Cycle2-2ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle2-2ms')))
    _DTX_Cycle_2ms_Items_mAC_DTX_Cycle_2ms = ENUM(name=u'mAC-DTX-Cycle-2ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-DTX-Cycle-2ms')))
    _DTX_Cycle_2ms_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_2ms_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Cycle_2ms_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Cycle_2ms_Items_iE_Extensions__item__id),
        (u'criticality', ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_2ms_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_2ms_Items_iE_Extensions._cont = __DTX_Cycle_2ms_Items_iE_Extensions__item_
    _DTX_Cycle_2ms_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_2ms_Items._cont = ASN1Dict([
        (u'uE-DTX-Cycle1-2ms', _DTX_Cycle_2ms_Items_uE_DTX_Cycle1_2ms),
        (u'uE-DTX-Cycle2-2ms', _DTX_Cycle_2ms_Items_uE_DTX_Cycle2_2ms),
        (u'mAC-DTX-Cycle-2ms', _DTX_Cycle_2ms_Items_mAC_DTX_Cycle_2ms),
        (u'iE-Extensions', _DTX_Cycle_2ms_Items_iE_Extensions),
        ])
    DTX_Cycle_2ms_Items._ext = []
    
    #-----< DTX-Cycle-2ms-Items-ExtIEs >-----#
    DTX_Cycle_2ms_Items_ExtIEs = CLASS(name=u'DTX-Cycle-2ms-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_2ms_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Cycle-2ms-to-Modify-Items >-----#
    DTX_Cycle_2ms_to_Modify_Items = SEQ(name=u'DTX-Cycle-2ms-to-Modify-Items', mode=MODE_TYPE)
    _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle1_2ms = ENUM(name=u'uE-DTX-Cycle1-2ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle1-2ms')), opt=True)
    _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle2_2ms = ENUM(name=u'uE-DTX-Cycle2-2ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle2-2ms')), opt=True)
    _DTX_Cycle_2ms_to_Modify_Items_mAC_DTX_Cycle_2ms = ENUM(name=u'mAC-DTX-Cycle-2ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-DTX-Cycle-2ms')), opt=True)
    _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id),
        (u'criticality', ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions._cont = __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_
    _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_2ms_to_Modify_Items._cont = ASN1Dict([
        (u'uE-DTX-Cycle1-2ms', _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle1_2ms),
        (u'uE-DTX-Cycle2-2ms', _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle2_2ms),
        (u'mAC-DTX-Cycle-2ms', _DTX_Cycle_2ms_to_Modify_Items_mAC_DTX_Cycle_2ms),
        (u'iE-Extensions', _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions),
        ])
    DTX_Cycle_2ms_to_Modify_Items._ext = []
    
    #-----< DTX-Cycle-2ms-to-Modify-Items-ExtIEs >-----#
    DTX_Cycle_2ms_to_Modify_Items_ExtIEs = CLASS(name=u'DTX-Cycle-2ms-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_2ms_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Cycle-10ms-Items >-----#
    DTX_Cycle_10ms_Items = SEQ(name=u'DTX-Cycle-10ms-Items', mode=MODE_TYPE)
    _DTX_Cycle_10ms_Items_uE_DTX_Cycle1_10ms = ENUM(name=u'uE-DTX-Cycle1-10ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle1-10ms')))
    _DTX_Cycle_10ms_Items_uE_DTX_Cycle2_10ms = ENUM(name=u'uE-DTX-Cycle2-10ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle2-10ms')))
    _DTX_Cycle_10ms_Items_mAC_DTX_Cycle_10ms = ENUM(name=u'mAC-DTX-Cycle-10ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-DTX-Cycle-10ms')))
    _DTX_Cycle_10ms_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_10ms_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Cycle_10ms_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Cycle_10ms_Items_iE_Extensions__item__id),
        (u'criticality', ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_10ms_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_10ms_Items_iE_Extensions._cont = __DTX_Cycle_10ms_Items_iE_Extensions__item_
    _DTX_Cycle_10ms_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_10ms_Items._cont = ASN1Dict([
        (u'uE-DTX-Cycle1-10ms', _DTX_Cycle_10ms_Items_uE_DTX_Cycle1_10ms),
        (u'uE-DTX-Cycle2-10ms', _DTX_Cycle_10ms_Items_uE_DTX_Cycle2_10ms),
        (u'mAC-DTX-Cycle-10ms', _DTX_Cycle_10ms_Items_mAC_DTX_Cycle_10ms),
        (u'iE-Extensions', _DTX_Cycle_10ms_Items_iE_Extensions),
        ])
    DTX_Cycle_10ms_Items._ext = []
    
    #-----< DTX-Cycle-10ms-Items-ExtIEs >-----#
    DTX_Cycle_10ms_Items_ExtIEs = CLASS(name=u'DTX-Cycle-10ms-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_10ms_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Cycle-10ms-to-Modify-Items >-----#
    DTX_Cycle_10ms_to_Modify_Items = SEQ(name=u'DTX-Cycle-10ms-to-Modify-Items', mode=MODE_TYPE)
    _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle1_10ms = ENUM(name=u'uE-DTX-Cycle1-10ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle1-10ms')), opt=True)
    _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle2_10ms = ENUM(name=u'uE-DTX-Cycle2-10ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle2-10ms')), opt=True)
    _DTX_Cycle_10ms_to_Modify_Items_mAC_DTX_Cycle_10ms = ENUM(name=u'mAC-DTX-Cycle-10ms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-DTX-Cycle-10ms')), opt=True)
    _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id),
        (u'criticality', ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_._ext = None
    _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions._cont = __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_
    _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Cycle_10ms_to_Modify_Items._cont = ASN1Dict([
        (u'uE-DTX-Cycle1-10ms', _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle1_10ms),
        (u'uE-DTX-Cycle2-10ms', _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle2_10ms),
        (u'mAC-DTX-Cycle-10ms', _DTX_Cycle_10ms_to_Modify_Items_mAC_DTX_Cycle_10ms),
        (u'iE-Extensions', _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions),
        ])
    DTX_Cycle_10ms_to_Modify_Items._ext = []
    
    #-----< DTX-Cycle-10ms-to-Modify-Items-ExtIEs >-----#
    DTX_Cycle_10ms_to_Modify_Items_ExtIEs = CLASS(name=u'DTX-Cycle-10ms-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Cycle_10ms_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Information >-----#
    DTX_Information = SEQ(name=u'DTX-Information', mode=MODE_TYPE)
    _DTX_Information_e_DCH_TTI_Length = CHOICE(name=u'e-DCH-TTI-Length', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TTI-Length')))
    _DTX_Information_inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name=u'inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DTX-Cycle2')))
    _DTX_Information_uE_DTX_Long_Preamble = ENUM(name=u'uE-DTX-Long-Preamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Long-Preamble')))
    _DTX_Information_mAC_Inactivity_Threshold = ENUM(name=u'mAC-Inactivity-Threshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-Inactivity-Threshold')))
    _DTX_Information_cQI_DTX_Timer = ENUM(name=u'cQI-DTX-Timer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-DTX-Timer')))
    _DTX_Information_uE_DPCCH_burst1 = ENUM(name=u'uE-DPCCH-burst1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DPCCH-burst1')))
    _DTX_Information_uE_DPCCH_burst2 = ENUM(name=u'uE-DPCCH-burst2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DPCCH-burst2')))
    _DTX_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_iE_Extensions__item__id._const_tab = ____DTX_Information_iE_Extensions__item__id_tab
    ___DTX_Information_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_iE_Extensions__item__criticality._const_tab = ____DTX_Information_iE_Extensions__item__criticality_tab
    ___DTX_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_iE_Extensions__item__extensionValue._const_tab = ____DTX_Information_iE_Extensions__item__extensionValue_tab
    ___DTX_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Information_iE_Extensions__item__id),
        (u'criticality', ___DTX_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Information_iE_Extensions__item__extensionValue),
        ])
    __DTX_Information_iE_Extensions__item_._ext = None
    _DTX_Information_iE_Extensions._cont = __DTX_Information_iE_Extensions__item_
    _DTX_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Information._cont = ASN1Dict([
        (u'e-DCH-TTI-Length', _DTX_Information_e_DCH_TTI_Length),
        (u'inactivity-Threshold-for-UE-DTX-Cycle2', _DTX_Information_inactivity_Threshold_for_UE_DTX_Cycle2),
        (u'uE-DTX-Long-Preamble', _DTX_Information_uE_DTX_Long_Preamble),
        (u'mAC-Inactivity-Threshold', _DTX_Information_mAC_Inactivity_Threshold),
        (u'cQI-DTX-Timer', _DTX_Information_cQI_DTX_Timer),
        (u'uE-DPCCH-burst1', _DTX_Information_uE_DPCCH_burst1),
        (u'uE-DPCCH-burst2', _DTX_Information_uE_DPCCH_burst2),
        (u'iE-Extensions', _DTX_Information_iE_Extensions),
        ])
    DTX_Information._ext = []
    
    #-----< DTX-Information-ExtIEs >-----#
    DTX_Information_ExtIEs = CLASS(name=u'DTX-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Information2 >-----#
    DTX_Information2 = SEQ(name=u'DTX-Information2', mode=MODE_TYPE)
    _DTX_Information2_uE_DTX_Cycle1 = ENUM(name=u'uE-DTX-Cycle1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle1-2ms')))
    _DTX_Information2_uE_DTX_Cycle2 = ENUM(name=u'uE-DTX-Cycle2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Cycle2-ext-2ms')))
    _DTX_Information2_inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name=u'inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DTX-Cycle2')))
    _DTX_Information2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Information2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Information2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Information2_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information2_iE_Extensions__item__id._const_tab = ____DTX_Information2_iE_Extensions__item__id_tab
    ___DTX_Information2_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Information2_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Information2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Information2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information2_iE_Extensions__item__criticality._const_tab = ____DTX_Information2_iE_Extensions__item__criticality_tab
    ___DTX_Information2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Information2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Information2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Information2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information2_iE_Extensions__item__extensionValue._const_tab = ____DTX_Information2_iE_Extensions__item__extensionValue_tab
    ___DTX_Information2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Information2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Information2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Information2_iE_Extensions__item__id),
        (u'criticality', ___DTX_Information2_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Information2_iE_Extensions__item__extensionValue),
        ])
    __DTX_Information2_iE_Extensions__item_._ext = None
    _DTX_Information2_iE_Extensions._cont = __DTX_Information2_iE_Extensions__item_
    _DTX_Information2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Information2._cont = ASN1Dict([
        (u'uE-DTX-Cycle1', _DTX_Information2_uE_DTX_Cycle1),
        (u'uE-DTX-Cycle2', _DTX_Information2_uE_DTX_Cycle2),
        (u'inactivity-Threshold-for-UE-DTX-Cycle2', _DTX_Information2_inactivity_Threshold_for_UE_DTX_Cycle2),
        (u'iE-Extensions', _DTX_Information2_iE_Extensions),
        ])
    DTX_Information2._ext = []
    
    #-----< DTX-Information2-ExtIEs >-----#
    DTX_Information2_ExtIEs = CLASS(name=u'DTX-Information2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Information2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DTX-Information-to-Modify >-----#
    DTX_Information_to_Modify = CHOICE(name=u'DTX-Information-to-Modify', mode=MODE_TYPE)
    _DTX_Information_to_Modify_modify = SEQ(name=u'modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Information-to-Modify-Items')))
    _DTX_Information_to_Modify_deactivate = NULL(name=u'deactivate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    DTX_Information_to_Modify._cont = ASN1Dict([
        (u'modify', _DTX_Information_to_Modify_modify),
        (u'deactivate', _DTX_Information_to_Modify_deactivate),
        ])
    DTX_Information_to_Modify._ext = []
    
    #-----< DTX-Information-to-Modify-Items >-----#
    DTX_Information_to_Modify_Items = SEQ(name=u'DTX-Information-to-Modify-Items', mode=MODE_TYPE)
    _DTX_Information_to_Modify_Items_e_DCH_TTI_Length_to_Modify = CHOICE(name=u'e-DCH-TTI-Length-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TTI-Length-to-Modify')), opt=True)
    _DTX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name=u'inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DTX-Cycle2')), opt=True)
    _DTX_Information_to_Modify_Items_uE_DTX_Long_Preamble = ENUM(name=u'uE-DTX-Long-Preamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DTX-Long-Preamble')), opt=True)
    _DTX_Information_to_Modify_Items_mAC_Inactivity_Threshold = ENUM(name=u'mAC-Inactivity-Threshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-Inactivity-Threshold')), opt=True)
    _DTX_Information_to_Modify_Items_cQI_DTX_Timer = ENUM(name=u'cQI-DTX-Timer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-DTX-Timer')), opt=True)
    _DTX_Information_to_Modify_Items_uE_DPCCH_burst1 = ENUM(name=u'uE-DPCCH-burst1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DPCCH-burst1')), opt=True)
    _DTX_Information_to_Modify_Items_uE_DPCCH_burst2 = ENUM(name=u'uE-DPCCH-burst2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DPCCH-burst2')), opt=True)
    _DTX_Information_to_Modify_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DTX_Information_to_Modify_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab = ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_at = None
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab = ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab = ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DTX_Information_to_Modify_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DTX_Information_to_Modify_Items_iE_Extensions__item__id),
        (u'criticality', ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue),
        ])
    __DTX_Information_to_Modify_Items_iE_Extensions__item_._ext = None
    _DTX_Information_to_Modify_Items_iE_Extensions._cont = __DTX_Information_to_Modify_Items_iE_Extensions__item_
    _DTX_Information_to_Modify_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DTX_Information_to_Modify_Items._cont = ASN1Dict([
        (u'e-DCH-TTI-Length-to-Modify', _DTX_Information_to_Modify_Items_e_DCH_TTI_Length_to_Modify),
        (u'inactivity-Threshold-for-UE-DTX-Cycle2', _DTX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DTX_Cycle2),
        (u'uE-DTX-Long-Preamble', _DTX_Information_to_Modify_Items_uE_DTX_Long_Preamble),
        (u'mAC-Inactivity-Threshold', _DTX_Information_to_Modify_Items_mAC_Inactivity_Threshold),
        (u'cQI-DTX-Timer', _DTX_Information_to_Modify_Items_cQI_DTX_Timer),
        (u'uE-DPCCH-burst1', _DTX_Information_to_Modify_Items_uE_DPCCH_burst1),
        (u'uE-DPCCH-burst2', _DTX_Information_to_Modify_Items_uE_DPCCH_burst2),
        (u'iE-Extensions', _DTX_Information_to_Modify_Items_iE_Extensions),
        ])
    DTX_Information_to_Modify_Items._ext = []
    
    #-----< DTX-Information-to-Modify-Items-ExtIEs >-----#
    DTX_Information_to_Modify_Items_ExtIEs = CLASS(name=u'DTX-Information-to-Modify-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DTX_Information_to_Modify_Items_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Dual-Cell-EDCH-Enhancements-Information >-----#
    Dual_Cell_EDCH_Enhancements_Information = SEQ(name=u'Dual-Cell-EDCH-Enhancements-Information', mode=MODE_TYPE)
    _Dual_Cell_EDCH_Enhancements_Information_e_TTI = ENUM(name=u'e-TTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TTI')))
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_Reference_E_TFCI_Information = SEQ_OF(name=u'eDCH-Reference-E-TFCI-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Reference-E-TFCI-Information')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Boost_Information = SEQ(name=u'eDCH-E-TFCI-Boost-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI-Boost-Information')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_DPCCH_Power_Offset = INT(name=u'eDCH-E-DPCCH-Power-Offset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DPCCH-PO')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Table_Index = INT(name=u'eDCH-E-TFCI-Table-Index', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TFCI-Table-Index')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_Power_Offset_for_SchedulingInfo = INT(name=u'eDCH-Power-Offset-for-SchedulingInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_eDCH_Max_Set_E_DPDCHs = ENUM(name=u'eDCH-Max-Set-E-DPDCHs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-Set-E-DPDCHs')), opt=True)
    _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id._const_tab = ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id._const_tab_at = None
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality._const_tab = ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue._const_tab = ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id),
        (u'criticality', ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue),
        ])
    __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_._ext = None
    _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions._cont = __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_
    _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Dual_Cell_EDCH_Enhancements_Information._cont = ASN1Dict([
        (u'e-TTI', _Dual_Cell_EDCH_Enhancements_Information_e_TTI),
        (u'eDCH-Reference-E-TFCI-Information', _Dual_Cell_EDCH_Enhancements_Information_eDCH_Reference_E_TFCI_Information),
        (u'eDCH-E-TFCI-Boost-Information', _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Boost_Information),
        (u'eDCH-E-DPCCH-Power-Offset', _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_DPCCH_Power_Offset),
        (u'eDCH-E-TFCI-Table-Index', _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Table_Index),
        (u'eDCH-Power-Offset-for-SchedulingInfo', _Dual_Cell_EDCH_Enhancements_Information_eDCH_Power_Offset_for_SchedulingInfo),
        (u'eDCH-Max-Set-E-DPDCHs', _Dual_Cell_EDCH_Enhancements_Information_eDCH_Max_Set_E_DPDCHs),
        (u'iE-Extensions', _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions),
        ])
    Dual_Cell_EDCH_Enhancements_Information._ext = []
    
    #-----< Dual-Cell-EDCH-Enhancements-Information-ExtIEs >-----#
    Dual_Cell_EDCH_Enhancements_Information_ExtIEs = CLASS(name=u'Dual-Cell-EDCH-Enhancements-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Dual_Cell_EDCH_Enhancements_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EARFCN >-----#
    EARFCN = INT(name=u'EARFCN', mode=MODE_TYPE)
    EARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< EARFCN-Extended >-----#
    EARFCN_Extended = INT(name=u'EARFCN-Extended', mode=MODE_TYPE)
    EARFCN_Extended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=262143)], ev=[], er=[])
    
    #-----< EARFCN-Information >-----#
    EARFCN_Information = CHOICE(name=u'EARFCN-Information', mode=MODE_TYPE)
    _EARFCN_Information_fDD = SEQ(name=u'fDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-FDD')))
    _EARFCN_Information_tDD = INT(name=u'tDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN')))
    _EARFCN_Information_extension_EARFCN_Information = SEQ(name=u'extension-EARFCN-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-EARFCN-Information')))
    EARFCN_Information._cont = ASN1Dict([
        (u'fDD', _EARFCN_Information_fDD),
        (u'tDD', _EARFCN_Information_tDD),
        (u'extension-EARFCN-Information', _EARFCN_Information_extension_EARFCN_Information),
        ])
    EARFCN_Information._ext = [u'extension-EARFCN-Information']
    
    #-----< Extension-EARFCN-Information >-----#
    Extension_EARFCN_Information = SEQ(name=u'Extension-EARFCN-Information', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_EARFCN_Information_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_EARFCN_Information_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_EARFCN_Information_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-FDD-Extended')))
    ___Extension_EARFCN_Information_id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-Extended')))
    __Extension_EARFCN_Information_id_tab._val = ASN1Set(rv=[dict([(u'id', 943), (u'criticality', u'ignore'), (u'Value', ___Extension_EARFCN_Information_id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 944), (u'criticality', u'ignore'), (u'Value', ___Extension_EARFCN_Information_id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _Extension_EARFCN_Information_id._const_tab = __Extension_EARFCN_Information_id_tab
    _Extension_EARFCN_Information_id._const_tab_at = None
    _Extension_EARFCN_Information_id._const_tab_id = u'id'
    _Extension_EARFCN_Information_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_EARFCN_Information_criticality._const_tab = __Extension_EARFCN_Information_id_tab
    _Extension_EARFCN_Information_criticality._const_tab_at = ('..', u'id')
    _Extension_EARFCN_Information_criticality._const_tab_id = u'criticality'
    _Extension_EARFCN_Information_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_EARFCN_Information_value._const_tab = __Extension_EARFCN_Information_id_tab
    _Extension_EARFCN_Information_value._const_tab_at = ('..', u'id')
    _Extension_EARFCN_Information_value._const_tab_id = u'Value'
    Extension_EARFCN_Information._cont = ASN1Dict([
        (u'id', _Extension_EARFCN_Information_id),
        (u'criticality', _Extension_EARFCN_Information_criticality),
        (u'value', _Extension_EARFCN_Information_value),
        ])
    Extension_EARFCN_Information._ext = None
    
    #-----< Extension-EARFCN-InformationIE >-----#
    Extension_EARFCN_InformationIE = CLASS(name=u'Extension-EARFCN-InformationIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_EARFCN_InformationIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-FDD-Extended')))
    _Extension_EARFCN_InformationIE_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-Extended')))
    Extension_EARFCN_InformationIE._val = ASN1Set(rv=[dict([(u'id', 943), (u'criticality', u'ignore'), (u'Value', _Extension_EARFCN_InformationIE_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 944), (u'criticality', u'ignore'), (u'Value', _Extension_EARFCN_InformationIE_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EARFCN-FDD >-----#
    EARFCN_FDD = SEQ(name=u'EARFCN-FDD', mode=MODE_TYPE)
    _EARFCN_FDD_uL_EARFCN = INT(name=u'uL-EARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN')))
    _EARFCN_FDD_dL_EARFCN = INT(name=u'dL-EARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN')))
    EARFCN_FDD._cont = ASN1Dict([
        (u'uL-EARFCN', _EARFCN_FDD_uL_EARFCN),
        (u'dL-EARFCN', _EARFCN_FDD_dL_EARFCN),
        ])
    EARFCN_FDD._ext = None
    
    #-----< EARFCN-FDD-Extended >-----#
    EARFCN_FDD_Extended = SEQ(name=u'EARFCN-FDD-Extended', mode=MODE_TYPE)
    _EARFCN_FDD_Extended_uL_EARFCN = INT(name=u'uL-EARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-Extended')))
    _EARFCN_FDD_Extended_dL_EARFCN = INT(name=u'dL-EARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-Extended')))
    EARFCN_FDD_Extended._cont = ASN1Dict([
        (u'uL-EARFCN', _EARFCN_FDD_Extended_uL_EARFCN),
        (u'dL-EARFCN', _EARFCN_FDD_Extended_dL_EARFCN),
        ])
    EARFCN_FDD_Extended._ext = None
    
    #-----< E-AGCH-DRX-Information-ResponseLCR >-----#
    E_AGCH_DRX_Information_ResponseLCR = CHOICE(name=u'E-AGCH-DRX-Information-ResponseLCR', mode=MODE_TYPE)
    _E_AGCH_DRX_Information_ResponseLCR_sameAsHS_SCCH = NULL(name=u'sameAsHS-SCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_AGCH_DRX_Information_ResponseLCR_e_AGCH_DRX_Parameters_Response = SEQ(name=u'e-AGCH-DRX-Parameters-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-DRX-Parameters-Response')))
    E_AGCH_DRX_Information_ResponseLCR._cont = ASN1Dict([
        (u'sameAsHS-SCCH', _E_AGCH_DRX_Information_ResponseLCR_sameAsHS_SCCH),
        (u'e-AGCH-DRX-Parameters-Response', _E_AGCH_DRX_Information_ResponseLCR_e_AGCH_DRX_Parameters_Response),
        ])
    E_AGCH_DRX_Information_ResponseLCR._ext = []
    
    #-----< E-AGCH-DRX-Parameters-Response >-----#
    E_AGCH_DRX_Parameters_Response = SEQ(name=u'E-AGCH-DRX-Parameters-Response', mode=MODE_TYPE)
    _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Cycle_LCR = ENUM(name=u'e-AGCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle-LCR')), opt=True)
    _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_Inactivity_Monitor_Threshold = ENUM(name=u'e-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')), opt=True)
    _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Offset_LCR = INT(name=u'e-AGCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Offset-LCR')), opt=True)
    _E_AGCH_DRX_Parameters_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id._const_tab = ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality._const_tab = ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id),
        (u'criticality', ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_._ext = None
    _E_AGCH_DRX_Parameters_Response_iE_Extensions._cont = __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_
    _E_AGCH_DRX_Parameters_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_DRX_Parameters_Response._cont = ASN1Dict([
        (u'e-AGCH-UE-DRX-Cycle-LCR', _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Cycle_LCR),
        (u'e-AGCH-UE-Inactivity-Monitor-Threshold', _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_Inactivity_Monitor_Threshold),
        (u'e-AGCH-UE-DRX-Offset-LCR', _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Offset_LCR),
        (u'iE-Extensions', _E_AGCH_DRX_Parameters_Response_iE_Extensions),
        ])
    E_AGCH_DRX_Parameters_Response._ext = []
    
    #-----< E-AGCH-DRX-Parameters-Response-ExtIEs >-----#
    E_AGCH_DRX_Parameters_Response_ExtIEs = CLASS(name=u'E-AGCH-DRX-Parameters-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_AGCH_DRX_Parameters_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-DRX-Information-LCR >-----#
    E_AGCH_DRX_Information_LCR = CHOICE(name=u'E-AGCH-DRX-Information-LCR', mode=MODE_TYPE)
    _E_AGCH_DRX_Information_LCR_sameAsHS_SCCH = NULL(name=u'sameAsHS-SCCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _E_AGCH_DRX_Information_LCR_e_AGCH_DRX_Parameters = SEQ(name=u'e-AGCH-DRX-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-DRX-Parameters')))
    E_AGCH_DRX_Information_LCR._cont = ASN1Dict([
        (u'sameAsHS-SCCH', _E_AGCH_DRX_Information_LCR_sameAsHS_SCCH),
        (u'e-AGCH-DRX-Parameters', _E_AGCH_DRX_Information_LCR_e_AGCH_DRX_Parameters),
        ])
    E_AGCH_DRX_Information_LCR._ext = []
    
    #-----< E-AGCH-DRX-Parameters >-----#
    E_AGCH_DRX_Parameters = SEQ(name=u'E-AGCH-DRX-Parameters', mode=MODE_TYPE)
    _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Cycle_LCR = ENUM(name=u'e-AGCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle-LCR')))
    _E_AGCH_DRX_Parameters_e_AGCH_UE_Inactivity_Monitor_Threshold = ENUM(name=u'e-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')), opt=True)
    _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Offset_LCR = INT(name=u'e-AGCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Offset-LCR')))
    _E_AGCH_DRX_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_DRX_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id._const_tab = ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality._const_tab = ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_AGCH_DRX_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_AGCH_DRX_Parameters_iE_Extensions__item__id),
        (u'criticality', ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_DRX_Parameters_iE_Extensions__item_._ext = None
    _E_AGCH_DRX_Parameters_iE_Extensions._cont = __E_AGCH_DRX_Parameters_iE_Extensions__item_
    _E_AGCH_DRX_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_DRX_Parameters._cont = ASN1Dict([
        (u'e-AGCH-UE-DRX-Cycle-LCR', _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Cycle_LCR),
        (u'e-AGCH-UE-Inactivity-Monitor-Threshold', _E_AGCH_DRX_Parameters_e_AGCH_UE_Inactivity_Monitor_Threshold),
        (u'e-AGCH-UE-DRX-Offset-LCR', _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Offset_LCR),
        (u'iE-Extensions', _E_AGCH_DRX_Parameters_iE_Extensions),
        ])
    E_AGCH_DRX_Parameters._ext = []
    
    #-----< E-AGCH-DRX-Parameters-ExtIEs >-----#
    E_AGCH_DRX_Parameters_ExtIEs = CLASS(name=u'E-AGCH-DRX-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_AGCH_DRX_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Table-Choice >-----#
    E_AGCH_Table_Choice = ENUM(name=u'E-AGCH-Table-Choice', mode=MODE_TYPE)
    E_AGCH_Table_Choice._cont = ASN1Dict([(u'table16B', 0), (u'table16B-1', 1)])
    E_AGCH_Table_Choice._ext = []
    
    #-----< E-AGCH-UE-Inactivity-Monitor-Threshold >-----#
    E_AGCH_UE_Inactivity_Monitor_Threshold = ENUM(name=u'E-AGCH-UE-Inactivity-Monitor-Threshold', mode=MODE_TYPE)
    E_AGCH_UE_Inactivity_Monitor_Threshold._cont = ASN1Dict([(u'v0', 0), (u'v1', 1), (u'v2', 2), (u'v4', 3), (u'v8', 4), (u'v16', 5), (u'v32', 6), (u'v64', 7), (u'v128', 8), (u'v256', 9), (u'v512', 10), (u'infinity', 11)])
    E_AGCH_UE_Inactivity_Monitor_Threshold._ext = []
    
    #-----< ECGI >-----#
    ECGI = SEQ(name=u'ECGI', mode=MODE_TYPE)
    _ECGI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _ECGI_e_UTRAN_Cell_ID = BIT_STR(name=u'e-UTRAN-Cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ECGI_e_UTRAN_Cell_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ECGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ECGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ECGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ECGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__id._const_tab = ____ECGI_iE_Extensions__item__id_tab
    ___ECGI_iE_Extensions__item__id._const_tab_at = None
    ___ECGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___ECGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ECGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__criticality._const_tab = ____ECGI_iE_Extensions__item__criticality_tab
    ___ECGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ECGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ECGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ECGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ECGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ECGI_iE_Extensions__item__extensionValue._const_tab = ____ECGI_iE_Extensions__item__extensionValue_tab
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ECGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ECGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ECGI_iE_Extensions__item__id),
        (u'criticality', ___ECGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___ECGI_iE_Extensions__item__extensionValue),
        ])
    __ECGI_iE_Extensions__item_._ext = None
    _ECGI_iE_Extensions._cont = __ECGI_iE_Extensions__item_
    _ECGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ECGI._cont = ASN1Dict([
        (u'pLMN-Identity', _ECGI_pLMN_Identity),
        (u'e-UTRAN-Cell-ID', _ECGI_e_UTRAN_Cell_ID),
        (u'iE-Extensions', _ECGI_iE_Extensions),
        ])
    ECGI._ext = []
    
    #-----< ECGI-ExtIEs >-----#
    ECGI_ExtIEs = CLASS(name=u'ECGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ECGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Additional-RL-Specific-Information-Response-List >-----#
    EDCH_Additional_RL_Specific_Information_Response_List = SEQ_OF(name=u'EDCH-Additional-RL-Specific-Information-Response-List', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Additional-RL-Specific-Information-Response-ItemIEs')))
    EDCH_Additional_RL_Specific_Information_Response_List._cont = _EDCH_Additional_RL_Specific_Information_Response_List__item_
    EDCH_Additional_RL_Specific_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< EDCH-Additional-RL-Specific-Information-Response-ItemIEs >-----#
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs = SEQ(name=u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_Additional_RL_ID = INT(name=u'eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_received_total_wide_band_power = INT(name=u'received-total-wide-band-power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Received-total-wide-band-power')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_PowerBalancing_ActivationIndicator = ENUM(name=u'dL-PowerBalancing-ActivationIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_RL_Set_ID = INT(name=u'e-DCH-RL-Set-ID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_FDD_DL_ControlChannelInformation = SEQ(name=u'eDCH-FDD-DL-ControlChannelInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dl_CodeInformation = SEQ_OF(name=u'dl-CodeInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response_List = SEQ_OF(name=u'additional-EDCH-MAC-d-Flow-Specific-Information-Response-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maximumDL_power = INT(name=u'maximumDL-power', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_minimumDL_power = INT(name=u'minimumDL-power', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_uL_UARFCN = INT(name=u'uL-UARFCN', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_pC_Preamble = INT(name=u'pC-Preamble', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PC-Preamble')))
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primary_CPICH_Usage_For_Channel_Estimation = ENUM(name=u'primary-CPICH-Usage-For-Channel-Estimation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_secondary_CPICH_Information = SEQ(name=u'secondary-CPICH-Information', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_f_DPCH_SlotFormat = INT(name=u'f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions._cont = __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_
    _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-ID', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_Additional_RL_ID),
        (u'received-total-wide-band-power', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_received_total_wide_band_power),
        (u'dL-PowerBalancing-ActivationIndicator', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_PowerBalancing_ActivationIndicator),
        (u'rL-Set-ID', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_rL_Set_ID),
        (u'e-DCH-RL-Set-ID', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_RL_Set_ID),
        (u'eDCH-FDD-DL-ControlChannelInformation', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_FDD_DL_ControlChannelInformation),
        (u'dl-CodeInformation', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dl_CodeInformation),
        (u'additional-EDCH-MAC-d-Flow-Specific-Information-Response-List', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response_List),
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'maxUL-SIR', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maxUL_SIR),
        (u'minUL-SIR', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_minUL_SIR),
        (u'maximumAllowedULTxPower', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maximumAllowedULTxPower),
        (u'maximumDL-power', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maximumDL_power),
        (u'minimumDL-power', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_minimumDL_power),
        (u'primaryScramblingCode', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primaryScramblingCode),
        (u'uL-UARFCN', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_uL_UARFCN),
        (u'dL-UARFCN', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_UARFCN),
        (u'primaryCPICH-Power', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primaryCPICH_Power),
        (u'pC-Preamble', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_pC_Preamble),
        (u'primary-CPICH-Usage-For-Channel-Estimation', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primary_CPICH_Usage_For_Channel_Estimation),
        (u'secondary-CPICH-Information', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_secondary_CPICH_Information),
        (u'f-DPCH-SlotFormat', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_f_DPCH_SlotFormat),
        (u'iE-Extensions', _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions),
        ])
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs._ext = []
    
    #-----< EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs >-----#
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs_ExtIEs = CLASS(name=u'EDCH-Additional-RL-Specific-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_Additional_RL_Specific_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Additional-RL-Specific-Modified-Information-Response-List >-----#
    EDCH_Additional_RL_Specific_Modified_Information_Response_List = SEQ_OF(name=u'EDCH-Additional-RL-Specific-Modified-Information-Response-List', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs')))
    EDCH_Additional_RL_Specific_Modified_Information_Response_List._cont = _EDCH_Additional_RL_Specific_Modified_Information_Response_List__item_
    EDCH_Additional_RL_Specific_Modified_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs >-----#
    EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs = SEQ(name=u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs', mode=MODE_TYPE)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_eDCH_Additional_RL_ID = INT(name=u'eDCH-Additional-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_dL_PowerBalancing_UpdatedIndicator = ENUM(name=u'dL-PowerBalancing-UpdatedIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_eDCH_FDD_DL_ControlChannelInformation = SEQ(name=u'eDCH-FDD-DL-ControlChannelInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response_List = SEQ_OF(name=u'additional-EDCH-MAC-d-Flow-Specific-Information-Response-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-MAC-d-Flow-Specific-Information-Response-List')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_maximumDL_power = INT(name=u'maximumDL-power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_minimumDL_power = INT(name=u'minimumDL-power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_primary_CPICH_Usage_For_Channel_Estimation = ENUM(name=u'primary-CPICH-Usage-For-Channel-Estimation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_secondary_CPICH_Information_Change = CHOICE(name=u'secondary-CPICH-Information-Change', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information-Change')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_f_DPCH_SlotFormat = INT(name=u'f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions._cont = __EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item_
    _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs._cont = ASN1Dict([
        (u'eDCH-Additional-RL-ID', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_eDCH_Additional_RL_ID),
        (u'dL-PowerBalancing-UpdatedIndicator', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_dL_PowerBalancing_UpdatedIndicator),
        (u'eDCH-FDD-DL-ControlChannelInformation', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_eDCH_FDD_DL_ControlChannelInformation),
        (u'additional-EDCH-MAC-d-Flow-Specific-Information-Response-List', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response_List),
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'maxUL-SIR', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_maxUL_SIR),
        (u'minUL-SIR', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_minUL_SIR),
        (u'maximumDL-power', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_maximumDL_power),
        (u'minimumDL-power', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_minimumDL_power),
        (u'primary-CPICH-Usage-For-Channel-Estimation', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_primary_CPICH_Usage_For_Channel_Estimation),
        (u'secondary-CPICH-Information-Change', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_secondary_CPICH_Information_Change),
        (u'f-DPCH-SlotFormat', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_f_DPCH_SlotFormat),
        (u'iE-Extensions', _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions),
        ])
    EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs._ext = []
    
    #-----< EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs-ExtIEs >-----#
    EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_ExtIEs = CLASS(name=u'EDCH-Additional-RL-Specific-Modified-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-DDI-Value >-----#
    EDCH_DDI_Value = INT(name=u'EDCH-DDI-Value', mode=MODE_TYPE)
    EDCH_DDI_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=62)], ev=None, er=[])
    
    #-----< E-DCH-Decoupling-Indication >-----#
    E_DCH_Decoupling_Indication = ENUM(name=u'E-DCH-Decoupling-Indication', mode=MODE_TYPE)
    E_DCH_Decoupling_Indication._cont = ASN1Dict([(u'serving-E-DCH-cell-only', 0), (u'serving-HS-DSCH-cell-only', 1)])
    E_DCH_Decoupling_Indication._ext = []
    
    #-----< EDCH-FDD-DL-ControlChannelInformation >-----#
    EDCH_FDD_DL_ControlChannelInformation = SEQ(name=u'EDCH-FDD-DL-ControlChannelInformation', mode=MODE_TYPE)
    _EDCH_FDD_DL_ControlChannelInformation_eAGCH_ERGCH_EHICH_FDD_ScramblingCode = INT(name=u'eAGCH-ERGCH-EHICH-FDD-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ScramblingCode')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_eAGCH_ChannelisationCode = INT(name=u'eAGCH-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_primary_e_RNTI = INT(name=u'primary-e-RNTI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_secondary_e_RNTI = INT(name=u'secondary-e-RNTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_eRGCH_EHICH_ChannelisationCode = INT(name=u'eRGCH-EHICH-ChannelisationCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _EDCH_FDD_DL_ControlChannelInformation_eRGCH_SignatureSequence = INT(name=u'eRGCH-SignatureSequence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ERGCH-SignatureSequence')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_eHICH_SignatureSequence = INT(name=u'eHICH-SignatureSequence', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EHICH-SignatureSequence')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_serving_Grant_Value = INT(name=u'serving-Grant-Value', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-Serving-Grant-Value')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_primary_Secondary_Grant_Selector = ENUM(name=u'primary-Secondary-Grant-Selector', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-Primary-Secondary-Grant-Selector')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_e_RGCH_Release_Indicator = ENUM(name=u'e-RGCH-Release-Indicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-Release-Indicator')), opt=True)
    _EDCH_FDD_DL_ControlChannelInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-E-HICH-ChannelisationCodeValidityIndicator')))
    _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-Serving-Grant-Value')))
    _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-DL-Control-Channel-Information')))
    ____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 666), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 736), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 932), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id._const_tab = ____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__criticality._const_tab = ____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__extensionValue._const_tab = ____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id),
        (u'criticality', ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__extensionValue),
        ])
    __EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item_._ext = None
    _EDCH_FDD_DL_ControlChannelInformation_iE_Extensions._cont = __EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item_
    _EDCH_FDD_DL_ControlChannelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_FDD_DL_ControlChannelInformation._cont = ASN1Dict([
        (u'eAGCH-ERGCH-EHICH-FDD-ScramblingCode', _EDCH_FDD_DL_ControlChannelInformation_eAGCH_ERGCH_EHICH_FDD_ScramblingCode),
        (u'eAGCH-ChannelisationCode', _EDCH_FDD_DL_ControlChannelInformation_eAGCH_ChannelisationCode),
        (u'primary-e-RNTI', _EDCH_FDD_DL_ControlChannelInformation_primary_e_RNTI),
        (u'secondary-e-RNTI', _EDCH_FDD_DL_ControlChannelInformation_secondary_e_RNTI),
        (u'eRGCH-EHICH-ChannelisationCode', _EDCH_FDD_DL_ControlChannelInformation_eRGCH_EHICH_ChannelisationCode),
        (u'eRGCH-SignatureSequence', _EDCH_FDD_DL_ControlChannelInformation_eRGCH_SignatureSequence),
        (u'eHICH-SignatureSequence', _EDCH_FDD_DL_ControlChannelInformation_eHICH_SignatureSequence),
        (u'serving-Grant-Value', _EDCH_FDD_DL_ControlChannelInformation_serving_Grant_Value),
        (u'primary-Secondary-Grant-Selector', _EDCH_FDD_DL_ControlChannelInformation_primary_Secondary_Grant_Selector),
        (u'e-RGCH-Release-Indicator', _EDCH_FDD_DL_ControlChannelInformation_e_RGCH_Release_Indicator),
        (u'iE-Extensions', _EDCH_FDD_DL_ControlChannelInformation_iE_Extensions),
        ])
    EDCH_FDD_DL_ControlChannelInformation._ext = []
    
    #-----< EDCH-FDD-DL-ControlChannelInformation-ExtIEs >-----#
    EDCH_FDD_DL_ControlChannelInformation_ExtIEs = CLASS(name=u'EDCH-FDD-DL-ControlChannelInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-E-HICH-ChannelisationCodeValidityIndicator')))
    _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-Serving-Grant-Value')))
    _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-DL-Control-Channel-Information')))
    EDCH_FDD_DL_ControlChannelInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 666), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 736), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 932), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-RGCH-E-HICH-ChannelisationCodeValidityIndicator >-----#
    E_RGCH_E_HICH_ChannelisationCodeValidityIndicator = ENUM(name=u'E-RGCH-E-HICH-ChannelisationCodeValidityIndicator', mode=MODE_TYPE)
    E_RGCH_E_HICH_ChannelisationCodeValidityIndicator._cont = ASN1Dict([(u'e-RGCH-E-HICH-Channelisation-Code-response-not-valid', 0)])
    E_RGCH_E_HICH_ChannelisationCodeValidityIndicator._ext = None
    
    #-----< EDCH-FDD-Information >-----#
    EDCH_FDD_Information = SEQ(name=u'EDCH-FDD-Information', mode=MODE_TYPE)
    _EDCH_FDD_Information_eDCH_MACdFlows_Information = SEQ(name=u'eDCH-MACdFlows-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-Information')))
    _EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _EDCH_FDD_Information_e_DCH_Maximum_Bitrate = INT(name=u'e-DCH-Maximum-Bitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Maximum-Bitrate')), opt=True)
    _EDCH_FDD_Information_e_DCH_Processing_Overload_Level = INT(name=u'e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _EDCH_FDD_Information_e_DCH_Reference_Power_Offset = INT(name=u'e-DCH-Reference-Power-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Reference-Power-Offset')), opt=True)
    _EDCH_FDD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_FDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_FDD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_FDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Table-Choice')))
    _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UPH-Filtering-Measurement-Forwarding-Request')))
    ____EDCH_FDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 653), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 732), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 749), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 933), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 930), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 956), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDCH_FDD_Information_iE_Extensions__item__id._const_tab = ____EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___EDCH_FDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_FDD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_FDD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab = ____EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_FDD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_FDD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab = ____EDCH_FDD_Information_iE_Extensions__item__id_tab
    ___EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_FDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_FDD_Information_iE_Extensions__item__id),
        (u'criticality', ___EDCH_FDD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_FDD_Information_iE_Extensions__item__extensionValue),
        ])
    __EDCH_FDD_Information_iE_Extensions__item_._ext = None
    _EDCH_FDD_Information_iE_Extensions._cont = __EDCH_FDD_Information_iE_Extensions__item_
    _EDCH_FDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_FDD_Information._cont = ASN1Dict([
        (u'eDCH-MACdFlows-Information', _EDCH_FDD_Information_eDCH_MACdFlows_Information),
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'e-DCH-Maximum-Bitrate', _EDCH_FDD_Information_e_DCH_Maximum_Bitrate),
        (u'e-DCH-Processing-Overload-Level', _EDCH_FDD_Information_e_DCH_Processing_Overload_Level),
        (u'e-DCH-Reference-Power-Offset', _EDCH_FDD_Information_e_DCH_Reference_Power_Offset),
        (u'iE-Extensions', _EDCH_FDD_Information_iE_Extensions),
        ])
    EDCH_FDD_Information._ext = []
    
    #-----< EDCH-FDD-Information-ExtIEs >-----#
    EDCH_FDD_Information_ExtIEs = CLASS(name=u'EDCH-FDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDCH_FDD_Information_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _EDCH_FDD_Information_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _EDCH_FDD_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Table-Choice')))
    _EDCH_FDD_Information_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _EDCH_FDD_Information_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _EDCH_FDD_Information_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UPH-Filtering-Measurement-Forwarding-Request')))
    EDCH_FDD_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 653), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 732), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 749), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_Information_ExtIEs_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 933), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 930), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 956), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EDCH-FDD-InformationResponse >-----#
    EDCH_FDD_InformationResponse = SEQ(name=u'EDCH-FDD-InformationResponse', mode=MODE_TYPE)
    _EDCH_FDD_InformationResponse_eDCH_MACdFlow_Specific_InformationResponse = SEQ_OF(name=u'eDCH-MACdFlow-Specific-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-Specific-InformationResponse')))
    _EDCH_FDD_InformationResponse_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _EDCH_FDD_InformationResponse_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_FDD_InformationResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-TTI-switching-Mode-Supported')))
    ____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 977), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__id._const_tab = ____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__criticality._const_tab = ____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__extensionValue._const_tab = ____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_FDD_InformationResponse_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_FDD_InformationResponse_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_FDD_InformationResponse_iE_Extensions__item__id),
        (u'criticality', ___EDCH_FDD_InformationResponse_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_FDD_InformationResponse_iE_Extensions__item__extensionValue),
        ])
    __EDCH_FDD_InformationResponse_iE_Extensions__item_._ext = None
    _EDCH_FDD_InformationResponse_iE_Extensions._cont = __EDCH_FDD_InformationResponse_iE_Extensions__item_
    _EDCH_FDD_InformationResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_FDD_InformationResponse._cont = ASN1Dict([
        (u'eDCH-MACdFlow-Specific-InformationResponse', _EDCH_FDD_InformationResponse_eDCH_MACdFlow_Specific_InformationResponse),
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _EDCH_FDD_InformationResponse_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'iE-Extensions', _EDCH_FDD_InformationResponse_iE_Extensions),
        ])
    EDCH_FDD_InformationResponse._ext = []
    
    #-----< EDCH-FDD-InformationResponse-ExtIEs >-----#
    EDCH_FDD_InformationResponse_ExtIEs = CLASS(name=u'EDCH-FDD-InformationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDCH_FDD_InformationResponse_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-TTI-switching-Mode-Supported')))
    EDCH_FDD_InformationResponse_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 977), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_InformationResponse_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EDCH-MACdFlow-Specific-InformationResponse >-----#
    EDCH_MACdFlow_Specific_InformationResponse = SEQ_OF(name=u'EDCH-MACdFlow-Specific-InformationResponse', mode=MODE_TYPE)
    _EDCH_MACdFlow_Specific_InformationResponse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-Specific-InformationResponseItem')))
    EDCH_MACdFlow_Specific_InformationResponse._cont = _EDCH_MACdFlow_Specific_InformationResponse__item_
    EDCH_MACdFlow_Specific_InformationResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDCH-MACdFlow-Specific-InformationResponseItem >-----#
    EDCH_MACdFlow_Specific_InformationResponseItem = SEQ(name=u'EDCH-MACdFlow-Specific-InformationResponseItem', mode=MODE_TYPE)
    _EDCH_MACdFlow_Specific_InformationResponseItem_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _EDCH_MACdFlow_Specific_InformationResponseItem_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _EDCH_MACdFlow_Specific_InformationResponseItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _EDCH_MACdFlow_Specific_InformationResponseItem_hARQ_Process_Allocation_NonSched_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-NonSched-2ms-EDCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotSetupIndicator')))
    ____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 711), (u'criticality', u'ignore'), (u'Extension', _____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id._const_tab = ____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__criticality._const_tab = ____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item_._ext = None
    _EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions._cont = __EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item_
    _EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MACdFlow_Specific_InformationResponseItem._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _EDCH_MACdFlow_Specific_InformationResponseItem_eDCH_MACdFlow_ID),
        (u'bindingID', _EDCH_MACdFlow_Specific_InformationResponseItem_bindingID),
        (u'transportLayerAddress', _EDCH_MACdFlow_Specific_InformationResponseItem_transportLayerAddress),
        (u'hARQ-Process-Allocation-NonSched-2ms-EDCH', _EDCH_MACdFlow_Specific_InformationResponseItem_hARQ_Process_Allocation_NonSched_2ms_EDCH),
        (u'iE-Extensions', _EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions),
        ])
    EDCH_MACdFlow_Specific_InformationResponseItem._ext = []
    
    #-----< EDCH-MACdFlow-Specific-InformationResponseItem-ExtIEs >-----#
    EDCH_MACdFlow_Specific_InformationResponseItem_ExtIEs = CLASS(name=u'EDCH-MACdFlow-Specific-InformationResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDCH_MACdFlow_Specific_InformationResponseItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotSetupIndicator')))
    EDCH_MACdFlow_Specific_InformationResponseItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 711), (u'criticality', u'ignore'), (u'Extension', _EDCH_MACdFlow_Specific_InformationResponseItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EDCH-FDD-Information-To-Modify >-----#
    EDCH_FDD_Information_To_Modify = SEQ(name=u'EDCH-FDD-Information-To-Modify', mode=MODE_TYPE)
    _EDCH_FDD_Information_To_Modify_eDCH_MACdFlow_Specific_Information = SEQ_OF(name=u'eDCH-MACdFlow-Specific-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-Specific-InfoToModifyList')))
    _EDCH_FDD_Information_To_Modify_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _EDCH_FDD_Information_To_Modify_e_DCH_Maximum_Bitrate = INT(name=u'e-DCH-Maximum-Bitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Maximum-Bitrate')), opt=True)
    _EDCH_FDD_Information_To_Modify_e_DCH_Processing_Overload_Level = INT(name=u'e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _EDCH_FDD_Information_To_Modify_e_DCH_Reference_Power_Offset = INT(name=u'e-DCH-Reference-Power-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Reference-Power-Offset')), opt=True)
    _EDCH_FDD_Information_To_Modify_mACeReset_Indicator = ENUM(name=u'mACeReset-Indicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACeReset-Indicator')), opt=True)
    _EDCH_FDD_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_FDD_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-DL-Control-Channel-Grant-Information')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Table-Choice')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-TTI-switching-Mode-synchronized')))
    _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-TTI-switching-Mode-unsynchronized')))
    ____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 653), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 732), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 739), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 742), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 749), (u'criticality', u'ignore'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'conditional')]), dict([(u'id', 933), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 930), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 975), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 976), (u'criticality', u'reject'), (u'Extension', _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__id._const_tab = ____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_FDD_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __EDCH_FDD_Information_To_Modify_iE_Extensions__item_._ext = None
    _EDCH_FDD_Information_To_Modify_iE_Extensions._cont = __EDCH_FDD_Information_To_Modify_iE_Extensions__item_
    _EDCH_FDD_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_FDD_Information_To_Modify._cont = ASN1Dict([
        (u'eDCH-MACdFlow-Specific-Information', _EDCH_FDD_Information_To_Modify_eDCH_MACdFlow_Specific_Information),
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _EDCH_FDD_Information_To_Modify_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'e-DCH-Maximum-Bitrate', _EDCH_FDD_Information_To_Modify_e_DCH_Maximum_Bitrate),
        (u'e-DCH-Processing-Overload-Level', _EDCH_FDD_Information_To_Modify_e_DCH_Processing_Overload_Level),
        (u'e-DCH-Reference-Power-Offset', _EDCH_FDD_Information_To_Modify_e_DCH_Reference_Power_Offset),
        (u'mACeReset-Indicator', _EDCH_FDD_Information_To_Modify_mACeReset_Indicator),
        (u'iE-Extensions', _EDCH_FDD_Information_To_Modify_iE_Extensions),
        ])
    EDCH_FDD_Information_To_Modify._ext = []
    
    #-----< EDCH-FDD-Information-To-Modify-ExtIEs >-----#
    EDCH_FDD_Information_To_Modify_ExtIEs = CLASS(name=u'EDCH-FDD-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-DL-Control-Channel-Grant-Information')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Table-Choice')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_7 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-TTI-switching-Mode-synchronized')))
    _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_8 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-TTI-switching-Mode-unsynchronized')))
    EDCH_FDD_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 653), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 732), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 739), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 742), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 749), (u'criticality', u'ignore'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_4), (u'presence', u'conditional')]), dict([(u'id', 933), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 930), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 975), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 976), (u'criticality', u'reject'), (u'Extension', _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-FDD-Update-Information >-----#
    E_DCH_FDD_Update_Information = SEQ(name=u'E-DCH-FDD-Update-Information', mode=MODE_TYPE)
    _E_DCH_FDD_Update_Information_e_DCH_MACdFlow_Specific_UpdateInformation = SEQ_OF(name=u'e-DCH-MACdFlow-Specific-UpdateInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Specific-UpdateInformation')), opt=True)
    _E_DCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_FDD_Update_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_FDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-DL-Control-Channel-Change-Information')))
    _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TTI-Update-Indicator')))
    ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 741), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 957), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id._const_tab = ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_FDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_FDD_Update_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_FDD_Update_Information_iE_Extensions__item_._ext = None
    _E_DCH_FDD_Update_Information_iE_Extensions._cont = __E_DCH_FDD_Update_Information_iE_Extensions__item_
    _E_DCH_FDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_FDD_Update_Information._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-Specific-UpdateInformation', _E_DCH_FDD_Update_Information_e_DCH_MACdFlow_Specific_UpdateInformation),
        (u'hARQ-Process-Allocation-Scheduled-2ms-EDCH', _E_DCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH),
        (u'iE-Extensions', _E_DCH_FDD_Update_Information_iE_Extensions),
        ])
    E_DCH_FDD_Update_Information._ext = []
    
    #-----< E-DCH-FDD-Update-Information-ExtIEs >-----#
    E_DCH_FDD_Update_Information_ExtIEs = CLASS(name=u'E-DCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-DL-Control-Channel-Change-Information')))
    _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TTI-Update-Indicator')))
    E_DCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 741), (u'criticality', u'ignore'), (u'Extension', _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 957), (u'criticality', u'ignore'), (u'Extension', _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlow-Specific-UpdateInformation >-----#
    E_DCH_MACdFlow_Specific_UpdateInformation = SEQ_OF(name=u'E-DCH-MACdFlow-Specific-UpdateInformation', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_UpdateInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Specific-UpdateInformation-Item')))
    E_DCH_MACdFlow_Specific_UpdateInformation._cont = _E_DCH_MACdFlow_Specific_UpdateInformation__item_
    E_DCH_MACdFlow_Specific_UpdateInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-Specific-UpdateInformation-Item >-----#
    E_DCH_MACdFlow_Specific_UpdateInformation_Item = SEQ(name=u'E-DCH-MACdFlow-Specific-UpdateInformation-Item', mode=MODE_TYPE)
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_e_DCH_MACdFlow_ID = INT(name=u'e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH = BIT_STR(name=u'hARQ-Process-Allocation-NonSched-2ms-EDCH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions._cont = __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_
    _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_Specific_UpdateInformation_Item._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_Specific_UpdateInformation_Item_e_DCH_MACdFlow_ID),
        (u'hARQ-Process-Allocation-NonSched-2ms-EDCH', _E_DCH_MACdFlow_Specific_UpdateInformation_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH),
        (u'iE-Extensions', _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions),
        ])
    E_DCH_MACdFlow_Specific_UpdateInformation_Item._ext = []
    
    #-----< E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs >-----#
    E_DCH_MACdFlow_Specific_UpdateInformation_Item_ExtIEs = CLASS(name=u'E-DCH-MACdFlow-Specific-UpdateInformation-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdFlow_Specific_UpdateInformation_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-DL-Control-Channel-Change-Information >-----#
    E_DCH_DL_Control_Channel_Change_Information = SEQ_OF(name=u'E-DCH-DL-Control-Channel-Change-Information', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Change_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-DL-Control-Channel-Change-Information-Item')))
    E_DCH_DL_Control_Channel_Change_Information._cont = _E_DCH_DL_Control_Channel_Change_Information__item_
    E_DCH_DL_Control_Channel_Change_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-DCH-DL-Control-Channel-Change-Information-Item >-----#
    E_DCH_DL_Control_Channel_Change_Information_Item = SEQ(name=u'E-DCH-DL-Control-Channel-Change-Information-Item', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Change_Information_Item_e_DCH_RL_ID = INT(name=u'e-DCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id._const_tab = ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_._ext = None
    _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions._cont = __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_
    _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_DL_Control_Channel_Change_Information_Item._cont = ASN1Dict([
        (u'e-DCH-RL-ID', _E_DCH_DL_Control_Channel_Change_Information_Item_e_DCH_RL_ID),
        (u'iE-Extensions', _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions),
        ])
    E_DCH_DL_Control_Channel_Change_Information_Item._ext = []
    
    #-----< E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs >-----#
    E_DCH_DL_Control_Channel_Change_Information_Item_ExtIEs = CLASS(name=u'E-DCH-DL-Control-Channel-Change-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_DL_Control_Channel_Change_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-DL-Control-Channel-Grant-Information >-----#
    E_DCH_DL_Control_Channel_Grant_Information = SEQ_OF(name=u'E-DCH-DL-Control-Channel-Grant-Information', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Grant_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-DL-Control-Channel-Grant-Information-Item')))
    E_DCH_DL_Control_Channel_Grant_Information._cont = _E_DCH_DL_Control_Channel_Grant_Information__item_
    E_DCH_DL_Control_Channel_Grant_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-DCH-DL-Control-Channel-Grant-Information-Item >-----#
    E_DCH_DL_Control_Channel_Grant_Information_Item = SEQ(name=u'E-DCH-DL-Control-Channel-Grant-Information-Item', mode=MODE_TYPE)
    _E_DCH_DL_Control_Channel_Grant_Information_Item_e_DCH_RL_ID = INT(name=u'e-DCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id._const_tab = ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_._ext = None
    _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions._cont = __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_
    _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_DL_Control_Channel_Grant_Information_Item._cont = ASN1Dict([
        (u'e-DCH-RL-ID', _E_DCH_DL_Control_Channel_Grant_Information_Item_e_DCH_RL_ID),
        (u'iE-Extensions', _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions),
        ])
    E_DCH_DL_Control_Channel_Grant_Information_Item._ext = []
    
    #-----< E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs >-----#
    E_DCH_DL_Control_Channel_Grant_Information_Item_ExtIEs = CLASS(name=u'E-DCH-DL-Control-Channel-Grant-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_DL_Control_Channel_Grant_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Grant-Type-Information >-----#
    E_DCH_Grant_Type_Information = CHOICE(name=u'E-DCH-Grant-Type-Information', mode=MODE_TYPE)
    _E_DCH_Grant_Type_Information_e_DCH_Non_Scheduled_Transmission_Grant = SEQ(name=u'e-DCH-Non-Scheduled-Transmission-Grant', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Non-Scheduled-Transmission-Grant-Items')))
    _E_DCH_Grant_Type_Information_e_DCH_Scheduled_Transmission_Grant = NULL(name=u'e-DCH-Scheduled-Transmission-Grant', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    E_DCH_Grant_Type_Information._cont = ASN1Dict([
        (u'e-DCH-Non-Scheduled-Transmission-Grant', _E_DCH_Grant_Type_Information_e_DCH_Non_Scheduled_Transmission_Grant),
        (u'e-DCH-Scheduled-Transmission-Grant', _E_DCH_Grant_Type_Information_e_DCH_Scheduled_Transmission_Grant),
        ])
    E_DCH_Grant_Type_Information._ext = []
    
    #-----< E-DCH-HARQ-PO-FDD >-----#
    E_DCH_HARQ_PO_FDD = INT(name=u'E-DCH-HARQ-PO-FDD', mode=MODE_TYPE)
    E_DCH_HARQ_PO_FDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelInformation >-----#
    E_DCH_LogicalChannelInformation = SEQ_OF(name=u'E-DCH-LogicalChannelInformation', mode=MODE_TYPE)
    _E_DCH_LogicalChannelInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelInformationItem')))
    E_DCH_LogicalChannelInformation._cont = _E_DCH_LogicalChannelInformation__item_
    E_DCH_LogicalChannelInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelInformationItem >-----#
    E_DCH_LogicalChannelInformationItem = SEQ(name=u'E-DCH-LogicalChannelInformationItem', mode=MODE_TYPE)
    _E_DCH_LogicalChannelInformationItem_logicalChannelId = INT(name=u'logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LogicalChannelID')))
    _E_DCH_LogicalChannelInformationItem_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _E_DCH_LogicalChannelInformationItem_schedulingInformation = ENUM(name=u'schedulingInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingInformation')))
    _E_DCH_LogicalChannelInformationItem_mACes_GuaranteedBitRate = INT(name=u'mACes-GuaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACes-Guaranteed-Bitrate')), opt=True)
    _E_DCH_LogicalChannelInformationItem_eDCH_DDI_Value = INT(name=u'eDCH-DDI-Value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-DDI-Value')))
    _E_DCH_LogicalChannelInformationItem_mACd_PDU_Size_List = SEQ_OF(name=u'mACd-PDU-Size-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDU-SizeList')))
    _E_DCH_LogicalChannelInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 824), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 864), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab = ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_._ext = None
    _E_DCH_LogicalChannelInformationItem_iE_Extensions._cont = __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_
    _E_DCH_LogicalChannelInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LogicalChannelInformationItem._cont = ASN1Dict([
        (u'logicalChannelId', _E_DCH_LogicalChannelInformationItem_logicalChannelId),
        (u'schedulingPriorityIndicator', _E_DCH_LogicalChannelInformationItem_schedulingPriorityIndicator),
        (u'schedulingInformation', _E_DCH_LogicalChannelInformationItem_schedulingInformation),
        (u'mACes-GuaranteedBitRate', _E_DCH_LogicalChannelInformationItem_mACes_GuaranteedBitRate),
        (u'eDCH-DDI-Value', _E_DCH_LogicalChannelInformationItem_eDCH_DDI_Value),
        (u'mACd-PDU-Size-List', _E_DCH_LogicalChannelInformationItem_mACd_PDU_Size_List),
        (u'iE-Extensions', _E_DCH_LogicalChannelInformationItem_iE_Extensions),
        ])
    E_DCH_LogicalChannelInformationItem._ext = []
    
    #-----< E-DCH-LogicalChannelInformationItem-ExtIEs >-----#
    E_DCH_LogicalChannelInformationItem_ExtIEs = CLASS(name=u'E-DCH-LogicalChannelInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    E_DCH_LogicalChannelInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 824), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 864), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Maximum-Bitrate >-----#
    E_DCH_Maximum_Bitrate = INT(name=u'E-DCH-Maximum-Bitrate', mode=MODE_TYPE)
    E_DCH_Maximum_Bitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5742)], ev=[], er=[ASN1RangeInt(lb=5743, ub=11498), ASN1RangeInt(lb=11499, ub=34507)])
    
    #-----< E-DCH-PowerOffset-for-SchedulingInfo >-----#
    E_DCH_PowerOffset_for_SchedulingInfo = INT(name=u'E-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE)
    E_DCH_PowerOffset_for_SchedulingInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-Processing-Overload-Level >-----#
    E_DCH_Processing_Overload_Level = INT(name=u'E-DCH-Processing-Overload-Level', mode=MODE_TYPE)
    E_DCH_Processing_Overload_Level._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=[], er=[])
    
    #-----< E-DCH-Reference-Power-Offset >-----#
    E_DCH_Reference_Power_Offset = INT(name=u'E-DCH-Reference-Power-Offset', mode=MODE_TYPE)
    E_DCH_Reference_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-MACdPDU-SizeList >-----#
    E_DCH_MACdPDU_SizeList = SEQ_OF(name=u'E-DCH-MACdPDU-SizeList', mode=MODE_TYPE)
    _E_DCH_MACdPDU_SizeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDU-SizeListItem')))
    E_DCH_MACdPDU_SizeList._cont = _E_DCH_MACdPDU_SizeList__item_
    E_DCH_MACdPDU_SizeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-DCH-MACdPDU-SizeListItem >-----#
    E_DCH_MACdPDU_SizeListItem = SEQ(name=u'E-DCH-MACdPDU-SizeListItem', mode=MODE_TYPE)
    _E_DCH_MACdPDU_SizeListItem_mACdPDU_Size = INT(name=u'mACdPDU-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size')))
    _E_DCH_MACdPDU_SizeListItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdPDU_SizeListItem_iE_Extensions._cont = __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_
    _E_DCH_MACdPDU_SizeListItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdPDU_SizeListItem._cont = ASN1Dict([
        (u'mACdPDU-Size', _E_DCH_MACdPDU_SizeListItem_mACdPDU_Size),
        (u'iE-Extensions', _E_DCH_MACdPDU_SizeListItem_iE_Extensions),
        ])
    E_DCH_MACdPDU_SizeListItem._ext = []
    
    #-----< E-DCH-MACdPDU-SizeListItem-ExtIEs >-----#
    E_DCH_MACdPDU_SizeListItem_ExtIEs = CLASS(name=u'E-DCH-MACdPDU-SizeListItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_MACdPDU_SizeListItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdPDUSizeFormat >-----#
    E_DCH_MACdPDUSizeFormat = ENUM(name=u'E-DCH-MACdPDUSizeFormat', mode=MODE_TYPE)
    E_DCH_MACdPDUSizeFormat._cont = ASN1Dict([(u'fixedMACdPDU-Size', 0), (u'flexibleMACdPDU-Size', 1)])
    E_DCH_MACdPDUSizeFormat._ext = None
    
    #-----< E-DCH-LogicalChannelToModify >-----#
    E_DCH_LogicalChannelToModify = SEQ_OF(name=u'E-DCH-LogicalChannelToModify', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToModify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelToModifyItem')))
    E_DCH_LogicalChannelToModify._cont = _E_DCH_LogicalChannelToModify__item_
    E_DCH_LogicalChannelToModify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelToModifyItem >-----#
    E_DCH_LogicalChannelToModifyItem = SEQ(name=u'E-DCH-LogicalChannelToModifyItem', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToModifyItem_logicalChannelId = INT(name=u'logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LogicalChannelID')))
    _E_DCH_LogicalChannelToModifyItem_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_schedulingInformation = ENUM(name=u'schedulingInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingInformation')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_mACes_GuaranteedBitRate = INT(name=u'mACes-GuaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACes-Guaranteed-Bitrate')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_eDCH_DDI_Value = INT(name=u'eDCH-DDI-Value', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-DDI-Value')), opt=True)
    _E_DCH_LogicalChannelToModifyItem_mACd_PDU_Size_List = SEQ_OF(name=u'mACd-PDU-Size-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDU-SizeToModifyList')))
    _E_DCH_LogicalChannelToModifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 824), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id._const_tab = ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_._ext = None
    _E_DCH_LogicalChannelToModifyItem_iE_Extensions._cont = __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_
    _E_DCH_LogicalChannelToModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LogicalChannelToModifyItem._cont = ASN1Dict([
        (u'logicalChannelId', _E_DCH_LogicalChannelToModifyItem_logicalChannelId),
        (u'schedulingPriorityIndicator', _E_DCH_LogicalChannelToModifyItem_schedulingPriorityIndicator),
        (u'schedulingInformation', _E_DCH_LogicalChannelToModifyItem_schedulingInformation),
        (u'mACes-GuaranteedBitRate', _E_DCH_LogicalChannelToModifyItem_mACes_GuaranteedBitRate),
        (u'eDCH-DDI-Value', _E_DCH_LogicalChannelToModifyItem_eDCH_DDI_Value),
        (u'mACd-PDU-Size-List', _E_DCH_LogicalChannelToModifyItem_mACd_PDU_Size_List),
        (u'iE-Extensions', _E_DCH_LogicalChannelToModifyItem_iE_Extensions),
        ])
    E_DCH_LogicalChannelToModifyItem._ext = []
    
    #-----< E-DCH-LogicalChannelToModifyItem-ExtIEs >-----#
    E_DCH_LogicalChannelToModifyItem_ExtIEs = CLASS(name=u'E-DCH-LogicalChannelToModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MACes-Maximum-Bitrate-LCR')))
    E_DCH_LogicalChannelToModifyItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 824), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdPDU-SizeToModifyList >-----#
    E_DCH_MACdPDU_SizeToModifyList = SEQ_OF(name=u'E-DCH-MACdPDU-SizeToModifyList', mode=MODE_TYPE)
    _E_DCH_MACdPDU_SizeToModifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDU-SizeListItem')))
    E_DCH_MACdPDU_SizeToModifyList._cont = _E_DCH_MACdPDU_SizeToModifyList__item_
    E_DCH_MACdPDU_SizeToModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelToDelete >-----#
    E_DCH_LogicalChannelToDelete = SEQ_OF(name=u'E-DCH-LogicalChannelToDelete', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToDelete__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelToDeleteItem')))
    E_DCH_LogicalChannelToDelete._cont = _E_DCH_LogicalChannelToDelete__item_
    E_DCH_LogicalChannelToDelete._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-LogicalChannelToDeleteItem >-----#
    E_DCH_LogicalChannelToDeleteItem = SEQ(name=u'E-DCH-LogicalChannelToDeleteItem', mode=MODE_TYPE)
    _E_DCH_LogicalChannelToDeleteItem_logicalChannelId = INT(name=u'logicalChannelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LogicalChannelID')))
    _E_DCH_LogicalChannelToDeleteItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id._const_tab = ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_._ext = None
    _E_DCH_LogicalChannelToDeleteItem_iE_Extensions._cont = __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_
    _E_DCH_LogicalChannelToDeleteItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LogicalChannelToDeleteItem._cont = ASN1Dict([
        (u'logicalChannelId', _E_DCH_LogicalChannelToDeleteItem_logicalChannelId),
        (u'iE-Extensions', _E_DCH_LogicalChannelToDeleteItem_iE_Extensions),
        ])
    E_DCH_LogicalChannelToDeleteItem._ext = []
    
    #-----< E-DCH-LogicalChannelToDeleteItem-ExtIEs >-----#
    E_DCH_LogicalChannelToDeleteItem_ExtIEs = CLASS(name=u'E-DCH-LogicalChannelToDeleteItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_LogicalChannelToDeleteItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-MACdFlow-ID >-----#
    EDCH_MACdFlow_ID = INT(name=u'EDCH-MACdFlow-ID', mode=MODE_TYPE)
    EDCH_MACdFlow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< EDCH-MACdFlow-ID-LCR >-----#
    EDCH_MACdFlow_ID_LCR = INT(name=u'EDCH-MACdFlow-ID-LCR', mode=MODE_TYPE)
    EDCH_MACdFlow_ID_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< EDCH-MACdFlows-Information >-----#
    EDCH_MACdFlows_Information = SEQ(name=u'EDCH-MACdFlows-Information', mode=MODE_TYPE)
    _EDCH_MACdFlows_Information_eDCH_MACdFlow_Specific_Information = SEQ_OF(name=u'eDCH-MACdFlow-Specific-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-Specific-InfoList')))
    _EDCH_MACdFlows_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MACdFlows_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MACdFlows_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MACdFlows_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlows_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlows_Information_iE_Extensions__item__id._const_tab = ____EDCH_MACdFlows_Information_iE_Extensions__item__id_tab
    ___EDCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MACdFlows_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_MACdFlows_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlows_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab = ____EDCH_MACdFlows_Information_iE_Extensions__item__criticality_tab
    ___EDCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab
    ___EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MACdFlows_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MACdFlows_Information_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MACdFlows_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MACdFlows_Information_iE_Extensions__item_._ext = None
    _EDCH_MACdFlows_Information_iE_Extensions._cont = __EDCH_MACdFlows_Information_iE_Extensions__item_
    _EDCH_MACdFlows_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MACdFlows_Information._cont = ASN1Dict([
        (u'eDCH-MACdFlow-Specific-Information', _EDCH_MACdFlows_Information_eDCH_MACdFlow_Specific_Information),
        (u'iE-Extensions', _EDCH_MACdFlows_Information_iE_Extensions),
        ])
    EDCH_MACdFlows_Information._ext = []
    
    #-----< E-DCH-MACdFlow-Multiplexing-List >-----#
    E_DCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'E-DCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE)
    E_DCH_MACdFlow_Multiplexing_List._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< EDCH-MACdFlow-Information-ExtIEs >-----#
    EDCH_MACdFlow_Information_ExtIEs = CLASS(name=u'EDCH-MACdFlow-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_MACdFlow_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-MACdFlow-Specific-InfoList >-----#
    EDCH_MACdFlow_Specific_InfoList = SEQ_OF(name=u'EDCH-MACdFlow-Specific-InfoList', mode=MODE_TYPE)
    _EDCH_MACdFlow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-Specific-InfoItem')))
    EDCH_MACdFlow_Specific_InfoList._cont = _EDCH_MACdFlow_Specific_InfoList__item_
    EDCH_MACdFlow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDCH-MACdFlow-Specific-InfoItem >-----#
    EDCH_MACdFlow_Specific_InfoItem = SEQ(name=u'EDCH-MACdFlow-Specific-InfoItem', mode=MODE_TYPE)
    _EDCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _EDCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _EDCH_MACdFlow_Specific_InfoItem_tnlQoS = CHOICE(name=u'tnlQoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')), opt=True)
    _EDCH_MACdFlow_Specific_InfoItem_payloadCRC_PresenceIndicator = ENUM(name=u'payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _EDCH_MACdFlow_Specific_InfoItem_maxNr_Retransmissions_EDCH = INT(name=u'maxNr-Retransmissions-EDCH', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')))
    _EDCH_MACdFlow_Specific_InfoItem_trafficClass = ENUM(name=u'trafficClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _EDCH_MACdFlow_Specific_InfoItem_eDCH_HARQ_PO_FDD = INT(name=u'eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-HARQ-PO-FDD')))
    _EDCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _EDCH_MACdFlow_Specific_InfoItem_eDCH_Grant_Type_Information = CHOICE(name=u'eDCH-Grant-Type-Information', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Grant-Type-Information')), opt=True)
    _EDCH_MACdFlow_Specific_InfoItem_bundlingModeIndicator = ENUM(name=u'bundlingModeIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BundlingModeIndicator')), opt=True)
    _EDCH_MACdFlow_Specific_InfoItem_eDCHLogicalChannelInformation = SEQ_OF(name=u'eDCHLogicalChannelInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelInformation')))
    _EDCH_MACdFlow_Specific_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    ____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 654), (u'criticality', u'ignore'), (u'Extension', _____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab = ____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab = ____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._ext = None
    _EDCH_MACdFlow_Specific_InfoItem_iE_Extensions._cont = __EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_
    _EDCH_MACdFlow_Specific_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MACdFlow_Specific_InfoItem._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _EDCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_ID),
        (u'allocationRetentionPriority', _EDCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority),
        (u'tnlQoS', _EDCH_MACdFlow_Specific_InfoItem_tnlQoS),
        (u'payloadCRC-PresenceIndicator', _EDCH_MACdFlow_Specific_InfoItem_payloadCRC_PresenceIndicator),
        (u'maxNr-Retransmissions-EDCH', _EDCH_MACdFlow_Specific_InfoItem_maxNr_Retransmissions_EDCH),
        (u'trafficClass', _EDCH_MACdFlow_Specific_InfoItem_trafficClass),
        (u'eDCH-HARQ-PO-FDD', _EDCH_MACdFlow_Specific_InfoItem_eDCH_HARQ_PO_FDD),
        (u'eDCH-MACdFlow-Multiplexing-List', _EDCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_Multiplexing_List),
        (u'eDCH-Grant-Type-Information', _EDCH_MACdFlow_Specific_InfoItem_eDCH_Grant_Type_Information),
        (u'bundlingModeIndicator', _EDCH_MACdFlow_Specific_InfoItem_bundlingModeIndicator),
        (u'eDCHLogicalChannelInformation', _EDCH_MACdFlow_Specific_InfoItem_eDCHLogicalChannelInformation),
        (u'iE-Extensions', _EDCH_MACdFlow_Specific_InfoItem_iE_Extensions),
        ])
    EDCH_MACdFlow_Specific_InfoItem._ext = []
    
    #-----< EDCH-MACdFlow-Specific-InfoItem-ExtIEs >-----#
    EDCH_MACdFlow_Specific_InfoItem_ExtIEs = CLASS(name=u'EDCH-MACdFlow-Specific-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    EDCH_MACdFlow_Specific_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 654), (u'criticality', u'ignore'), (u'Extension', _EDCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EDCH-MACdFlow-Specific-InfoToModifyList >-----#
    EDCH_MACdFlow_Specific_InfoToModifyList = SEQ_OF(name=u'EDCH-MACdFlow-Specific-InfoToModifyList', mode=MODE_TYPE)
    _EDCH_MACdFlow_Specific_InfoToModifyList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-Specific-InfoToModifyItem')))
    EDCH_MACdFlow_Specific_InfoToModifyList._cont = _EDCH_MACdFlow_Specific_InfoToModifyList__item_
    EDCH_MACdFlow_Specific_InfoToModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDCH-MACdFlow-Specific-InfoToModifyItem >-----#
    EDCH_MACdFlow_Specific_InfoToModifyItem = SEQ(name=u'EDCH-MACdFlow-Specific-InfoToModifyItem', mode=MODE_TYPE)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _EDCH_MACdFlow_Specific_InfoToModifyItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _EDCH_MACdFlow_Specific_InfoToModifyItem_tnlQoS = CHOICE(name=u'tnlQoS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_maxNr_Retransmissions_EDCH = INT(name=u'maxNr-Retransmissions-EDCH', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_trafficClass = ENUM(name=u'trafficClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_HARQ_PO_FDD = INT(name=u'eDCH-HARQ-PO-FDD', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-HARQ-PO-FDD')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_Grant_Type_Information = CHOICE(name=u'eDCH-Grant-Type-Information', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Grant-Type-Information')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_bundlingModeIndicator = ENUM(name=u'bundlingModeIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BundlingModeIndicator')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToAdd = SEQ_OF(name=u'eDCH-LogicalChannelToAdd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelInformation')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToModify = SEQ_OF(name=u'eDCH-LogicalChannelToModify', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelToModify')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToDelete = SEQ_OF(name=u'eDCH-LogicalChannelToDelete', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelToDelete')), opt=True)
    _EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id._const_tab = ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id_tab
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality._const_tab = ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality_tab
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue_tab
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item_._ext = None
    _EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions._cont = __EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item_
    _EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MACdFlow_Specific_InfoToModifyItem._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_MACdFlow_ID),
        (u'allocationRetentionPriority', _EDCH_MACdFlow_Specific_InfoToModifyItem_allocationRetentionPriority),
        (u'transportBearerRequestIndicator', _EDCH_MACdFlow_Specific_InfoToModifyItem_transportBearerRequestIndicator),
        (u'tnlQoS', _EDCH_MACdFlow_Specific_InfoToModifyItem_tnlQoS),
        (u'maxNr-Retransmissions-EDCH', _EDCH_MACdFlow_Specific_InfoToModifyItem_maxNr_Retransmissions_EDCH),
        (u'trafficClass', _EDCH_MACdFlow_Specific_InfoToModifyItem_trafficClass),
        (u'eDCH-HARQ-PO-FDD', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_HARQ_PO_FDD),
        (u'eDCH-MACdFlow-Multiplexing-List', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_MACdFlow_Multiplexing_List),
        (u'eDCH-Grant-Type-Information', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_Grant_Type_Information),
        (u'bundlingModeIndicator', _EDCH_MACdFlow_Specific_InfoToModifyItem_bundlingModeIndicator),
        (u'eDCH-LogicalChannelToAdd', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToAdd),
        (u'eDCH-LogicalChannelToModify', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToModify),
        (u'eDCH-LogicalChannelToDelete', _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToDelete),
        (u'iE-Extensions', _EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions),
        ])
    EDCH_MACdFlow_Specific_InfoToModifyItem._ext = []
    
    #-----< EDCH-MACdFlow-Specific-InfoToModifyItem-ExtIEs >-----#
    EDCH_MACdFlow_Specific_InfoToModifyItem_ExtIEs = CLASS(name=u'EDCH-MACdFlow-Specific-InfoToModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_MACdFlow_Specific_InfoToModifyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-MACdFlows-To-Delete >-----#
    EDCH_MACdFlows_To_Delete = SEQ_OF(name=u'EDCH-MACdFlows-To-Delete', mode=MODE_TYPE)
    _EDCH_MACdFlows_To_Delete__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete-Item')))
    EDCH_MACdFlows_To_Delete._cont = _EDCH_MACdFlows_To_Delete__item_
    EDCH_MACdFlows_To_Delete._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDCH-MACdFlows-To-Delete-Item >-----#
    EDCH_MACdFlows_To_Delete_Item = SEQ(name=u'EDCH-MACdFlows-To-Delete-Item', mode=MODE_TYPE)
    _EDCH_MACdFlows_To_Delete_Item_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _EDCH_MACdFlows_To_Delete_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id._const_tab = ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id_tab
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality._const_tab = ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality_tab
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue_tab
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item_._ext = None
    _EDCH_MACdFlows_To_Delete_Item_iE_Extensions._cont = __EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item_
    _EDCH_MACdFlows_To_Delete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MACdFlows_To_Delete_Item._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _EDCH_MACdFlows_To_Delete_Item_eDCH_MACdFlow_ID),
        (u'iE-Extensions', _EDCH_MACdFlows_To_Delete_Item_iE_Extensions),
        ])
    EDCH_MACdFlows_To_Delete_Item._ext = []
    
    #-----< EDCH-MACdFlows-To-Delete-Item-ExtIEs >-----#
    EDCH_MACdFlows_To_Delete_Item_ExtIEs = CLASS(name=u'EDCH-MACdFlows-To-Delete-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_MACdFlows_To_Delete_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Reference-E-TFCI-Information >-----#
    EDCH_Reference_E_TFCI_Information = SEQ_OF(name=u'EDCH-Reference-E-TFCI-Information', mode=MODE_TYPE)
    _EDCH_Reference_E_TFCI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Reference-E-TFCI-Information-Item')))
    EDCH_Reference_E_TFCI_Information._cont = _EDCH_Reference_E_TFCI_Information__item_
    EDCH_Reference_E_TFCI_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< EDCH-Reference-E-TFCI-Information-Item >-----#
    EDCH_Reference_E_TFCI_Information_Item = SEQ(name=u'EDCH-Reference-E-TFCI-Information-Item', mode=MODE_TYPE)
    _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI = INT(name=u'eDCH-reference-E-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI')))
    _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI_PO = INT(name=u'eDCH-reference-E-TFCI-PO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Reference-E-TFCI-PO')))
    _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab = ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab = ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id),
        (u'criticality', ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_._ext = None
    _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions._cont = __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_
    _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Reference_E_TFCI_Information_Item._cont = ASN1Dict([
        (u'eDCH-reference-E-TFCI', _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI),
        (u'eDCH-reference-E-TFCI-PO', _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI_PO),
        (u'iE-Extensions', _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions),
        ])
    EDCH_Reference_E_TFCI_Information_Item._ext = []
    
    #-----< EDCH-Reference-E-TFCI-Information-Item-ExtIEs >-----#
    EDCH_Reference_E_TFCI_Information_Item_ExtIEs = CLASS(name=u'EDCH-Reference-E-TFCI-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_Reference_E_TFCI_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-Reference-E-TFCI-PO >-----#
    EDCH_Reference_E_TFCI_PO = INT(name=u'EDCH-Reference-E-TFCI-PO', mode=MODE_TYPE)
    EDCH_Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< EDCH-RL-Indication >-----#
    EDCH_RL_Indication = ENUM(name=u'EDCH-RL-Indication', mode=MODE_TYPE)
    EDCH_RL_Indication._cont = ASN1Dict([(u'eDCH', 0), (u'non-EDCH', 1)])
    EDCH_RL_Indication._ext = None
    
    #-----< E-DCH-Non-Scheduled-Transmission-Grant-Items >-----#
    E_DCH_Non_Scheduled_Transmission_Grant_Items = SEQ(name=u'E-DCH-Non-Scheduled-Transmission-Grant-Items', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_maxBits_MACe_PDU_non_scheduled = INT(name=u'maxBits-MACe-PDU-non-scheduled', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-Bits-MACe-PDU-non-scheduled')))
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_hARQ_Process_Allocation_NonSched_2ms = BIT_STR(name=u'hARQ-Process-Allocation-NonSched-2ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Process-Allocation-2ms-EDCH')), opt=True)
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Ext-Max-Bits-MACe-PDU-non-scheduled')))
    ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 706), (u'criticality', u'reject'), (u'Extension', _____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions._cont = __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Transmission_Grant_Items._cont = ASN1Dict([
        (u'maxBits-MACe-PDU-non-scheduled', _E_DCH_Non_Scheduled_Transmission_Grant_Items_maxBits_MACe_PDU_non_scheduled),
        (u'hARQ-Process-Allocation-NonSched-2ms', _E_DCH_Non_Scheduled_Transmission_Grant_Items_hARQ_Process_Allocation_NonSched_2ms),
        (u'iE-Extensions', _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Transmission_Grant_Items._ext = []
    
    #-----< E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs >-----#
    E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs = CLASS(name=u'E-DCH-Non-Scheduled-Transmission-Grant-Items-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Ext-Max-Bits-MACe-PDU-non-scheduled')))
    E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 706), (u'criticality', u'reject'), (u'Extension', _E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TFCI-Table-Index >-----#
    E_DCH_TFCI_Table_Index = INT(name=u'E-DCH-TFCI-Table-Index', mode=MODE_TYPE)
    E_DCH_TFCI_Table_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=[], er=[ASN1RangeInt(lb=2, ub=7)])
    
    #-----< E-DCH-Serving-cell-change-informationResponse >-----#
    E_DCH_Serving_cell_change_informationResponse = SEQ(name=u'E-DCH-Serving-cell-change-informationResponse', mode=MODE_TYPE)
    _E_DCH_Serving_cell_change_informationResponse_e_DCH_serving_cell_outcome_choice = CHOICE(name=u'e-DCH-serving-cell-outcome-choice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-serving-cell-change-choice')))
    _E_DCH_Serving_cell_change_informationResponse_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id._const_tab = ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id_tab
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality._const_tab = ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item_._ext = None
    _E_DCH_Serving_cell_change_informationResponse_iE_Extensions._cont = __E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item_
    _E_DCH_Serving_cell_change_informationResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Serving_cell_change_informationResponse._cont = ASN1Dict([
        (u'e-DCH-serving-cell-outcome-choice', _E_DCH_Serving_cell_change_informationResponse_e_DCH_serving_cell_outcome_choice),
        (u'iE-Extensions', _E_DCH_Serving_cell_change_informationResponse_iE_Extensions),
        ])
    E_DCH_Serving_cell_change_informationResponse._ext = []
    
    #-----< E-DCH-serving-cell-change-informationResponse-ExtIEs >-----#
    E_DCH_serving_cell_change_informationResponse_ExtIEs = CLASS(name=u'E-DCH-serving-cell-change-informationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_serving_cell_change_informationResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-serving-cell-change-choice >-----#
    E_DCH_serving_cell_change_choice = CHOICE(name=u'E-DCH-serving-cell-change-choice', mode=MODE_TYPE)
    _E_DCH_serving_cell_change_choice_e_DCH_serving_cell_change_successful = SEQ(name=u'e-DCH-serving-cell-change-successful', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-serving-cell-change-successful')))
    _E_DCH_serving_cell_change_choice_e_DCH_serving_cell_change_unsuccessful = SEQ(name=u'e-DCH-serving-cell-change-unsuccessful', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-serving-cell-change-unsuccessful')))
    E_DCH_serving_cell_change_choice._cont = ASN1Dict([
        (u'e-DCH-serving-cell-change-successful', _E_DCH_serving_cell_change_choice_e_DCH_serving_cell_change_successful),
        (u'e-DCH-serving-cell-change-unsuccessful', _E_DCH_serving_cell_change_choice_e_DCH_serving_cell_change_unsuccessful),
        ])
    E_DCH_serving_cell_change_choice._ext = []
    
    #-----< E-DCH-serving-cell-change-successful >-----#
    E_DCH_serving_cell_change_successful = SEQ(name=u'E-DCH-serving-cell-change-successful', mode=MODE_TYPE)
    _E_DCH_serving_cell_change_successful_e_DCH_RL_InformationList_Rsp = SEQ_OF(name=u'e-DCH-RL-InformationList-Rsp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-RL-InformationList-Rsp')))
    _E_DCH_serving_cell_change_successful_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_serving_cell_change_successful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id._const_tab = ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab = ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_serving_cell_change_successful_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_serving_cell_change_successful_iE_Extensions__item_._ext = None
    _E_DCH_serving_cell_change_successful_iE_Extensions._cont = __E_DCH_serving_cell_change_successful_iE_Extensions__item_
    _E_DCH_serving_cell_change_successful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_serving_cell_change_successful._cont = ASN1Dict([
        (u'e-DCH-RL-InformationList-Rsp', _E_DCH_serving_cell_change_successful_e_DCH_RL_InformationList_Rsp),
        (u'iE-Extensions', _E_DCH_serving_cell_change_successful_iE_Extensions),
        ])
    E_DCH_serving_cell_change_successful._ext = []
    
    #-----< E-DCH-serving-cell-change-successful-ExtIEs >-----#
    E_DCH_serving_cell_change_successful_ExtIEs = CLASS(name=u'E-DCH-serving-cell-change-successful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_serving_cell_change_successful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-RL-InformationList-Rsp >-----#
    E_DCH_RL_InformationList_Rsp = SEQ_OF(name=u'E-DCH-RL-InformationList-Rsp', mode=MODE_TYPE)
    _E_DCH_RL_InformationList_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-RL-InformationList-Rsp-Item')))
    E_DCH_RL_InformationList_Rsp._cont = _E_DCH_RL_InformationList_Rsp__item_
    E_DCH_RL_InformationList_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< E-DCH-RL-InformationList-Rsp-Item >-----#
    E_DCH_RL_InformationList_Rsp_Item = SEQ(name=u'E-DCH-RL-InformationList-Rsp-Item', mode=MODE_TYPE)
    _E_DCH_RL_InformationList_Rsp_Item_e_DCH_reconfigured_RL_Id = INT(name=u'e-DCH-reconfigured-RL-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _E_DCH_RL_InformationList_Rsp_Item_e_DCH_FDD_DL_Control_Channel_Info = SEQ(name=u'e-DCH-FDD-DL-Control-Channel-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id._const_tab = ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_._ext = None
    _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions._cont = __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_
    _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_RL_InformationList_Rsp_Item._cont = ASN1Dict([
        (u'e-DCH-reconfigured-RL-Id', _E_DCH_RL_InformationList_Rsp_Item_e_DCH_reconfigured_RL_Id),
        (u'e-DCH-FDD-DL-Control-Channel-Info', _E_DCH_RL_InformationList_Rsp_Item_e_DCH_FDD_DL_Control_Channel_Info),
        (u'iE-Extensions', _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions),
        ])
    E_DCH_RL_InformationList_Rsp_Item._ext = []
    
    #-----< E-DCH-RL-InformationList-Rsp-Item-ExtIEs >-----#
    E_DCH_RL_InformationList_Rsp_Item_ExtIEs = CLASS(name=u'E-DCH-RL-InformationList-Rsp-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_RL_InformationList_Rsp_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-serving-cell-change-unsuccessful >-----#
    E_DCH_serving_cell_change_unsuccessful = SEQ(name=u'E-DCH-serving-cell-change-unsuccessful', mode=MODE_TYPE)
    _E_DCH_serving_cell_change_unsuccessful_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _E_DCH_serving_cell_change_unsuccessful_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab = ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab = ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_._ext = None
    _E_DCH_serving_cell_change_unsuccessful_iE_Extensions._cont = __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_
    _E_DCH_serving_cell_change_unsuccessful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_serving_cell_change_unsuccessful._cont = ASN1Dict([
        (u'cause', _E_DCH_serving_cell_change_unsuccessful_cause),
        (u'iE-Extensions', _E_DCH_serving_cell_change_unsuccessful_iE_Extensions),
        ])
    E_DCH_serving_cell_change_unsuccessful._ext = []
    
    #-----< E-DCH-serving-cell-change-unsuccessful-ExtIEs >-----#
    E_DCH_serving_cell_change_unsuccessful_ExtIEs = CLASS(name=u'E-DCH-serving-cell-change-unsuccessful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_serving_cell_change_unsuccessful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TTI-Length >-----#
    E_DCH_TTI_Length = CHOICE(name=u'E-DCH-TTI-Length', mode=MODE_TYPE)
    _E_DCH_TTI_Length_two_ms = SEQ(name=u'two-ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Cycle-2ms-Items')))
    _E_DCH_TTI_Length_ten_ms = SEQ(name=u'ten-ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Cycle-10ms-Items')))
    E_DCH_TTI_Length._cont = ASN1Dict([
        (u'two-ms', _E_DCH_TTI_Length_two_ms),
        (u'ten-ms', _E_DCH_TTI_Length_ten_ms),
        ])
    E_DCH_TTI_Length._ext = []
    
    #-----< E-DCH-TTI-Length-to-Modify >-----#
    E_DCH_TTI_Length_to_Modify = CHOICE(name=u'E-DCH-TTI-Length-to-Modify', mode=MODE_TYPE)
    _E_DCH_TTI_Length_to_Modify_two_ms = SEQ(name=u'two-ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Cycle-2ms-to-Modify-Items')))
    _E_DCH_TTI_Length_to_Modify_ten_ms = SEQ(name=u'ten-ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DTX-Cycle-10ms-to-Modify-Items')))
    E_DCH_TTI_Length_to_Modify._cont = ASN1Dict([
        (u'two-ms', _E_DCH_TTI_Length_to_Modify_two_ms),
        (u'ten-ms', _E_DCH_TTI_Length_to_Modify_ten_ms),
        ])
    E_DCH_TTI_Length_to_Modify._ext = []
    
    #-----< EDPCH-Information-FDD >-----#
    EDPCH_Information_FDD = SEQ(name=u'EDPCH-Information-FDD', mode=MODE_TYPE)
    _EDPCH_Information_FDD_maxSet_E_DPDCHs = ENUM(name=u'maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-Set-E-DPDCHs')))
    _EDPCH_Information_FDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _EDPCH_Information_FDD_e_TFCS_Information = SEQ(name=u'e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information')))
    _EDPCH_Information_FDD_e_TTI = ENUM(name=u'e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TTI')))
    _EDPCH_Information_FDD_e_DPCCH_PO = INT(name=u'e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DPCCH-PO')))
    _EDPCH_Information_FDD_e_RGCH_2_IndexStepThreshold = INT(name=u'e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-2-IndexStepThreshold')))
    _EDPCH_Information_FDD_e_RGCH_3_IndexStepThreshold = INT(name=u'e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-3-IndexStepThreshold')))
    _EDPCH_Information_FDD_hARQ_Info_for_E_DCH = ENUM(name=u'hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Info-for-E-DCH')))
    _EDPCH_Information_FDD_hSDSCH_Configured_Indicator = ENUM(name=u'hSDSCH-Configured-Indicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Configured-Indicator')))
    _EDPCH_Information_FDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDPCH_Information_FDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDPCH_Information_FDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDPCH_Information_FDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDPCH_Information_FDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____EDPCH_Information_FDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _____EDPCH_Information_FDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDPCH_Information_FDD_iE_Extensions__item__id._const_tab = ____EDPCH_Information_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_FDD_iE_Extensions__item__id._const_tab_at = None
    ___EDPCH_Information_FDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDPCH_Information_FDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDPCH_Information_FDD_iE_Extensions__item__criticality._const_tab = ____EDPCH_Information_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_FDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDPCH_Information_FDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDPCH_Information_FDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDPCH_Information_FDD_iE_Extensions__item__extensionValue._const_tab = ____EDPCH_Information_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_FDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDPCH_Information_FDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDPCH_Information_FDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDPCH_Information_FDD_iE_Extensions__item__id),
        (u'criticality', ___EDPCH_Information_FDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDPCH_Information_FDD_iE_Extensions__item__extensionValue),
        ])
    __EDPCH_Information_FDD_iE_Extensions__item_._ext = None
    _EDPCH_Information_FDD_iE_Extensions._cont = __EDPCH_Information_FDD_iE_Extensions__item_
    _EDPCH_Information_FDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDPCH_Information_FDD._cont = ASN1Dict([
        (u'maxSet-E-DPDCHs', _EDPCH_Information_FDD_maxSet_E_DPDCHs),
        (u'punctureLimit', _EDPCH_Information_FDD_punctureLimit),
        (u'e-TFCS-Information', _EDPCH_Information_FDD_e_TFCS_Information),
        (u'e-TTI', _EDPCH_Information_FDD_e_TTI),
        (u'e-DPCCH-PO', _EDPCH_Information_FDD_e_DPCCH_PO),
        (u'e-RGCH-2-IndexStepThreshold', _EDPCH_Information_FDD_e_RGCH_2_IndexStepThreshold),
        (u'e-RGCH-3-IndexStepThreshold', _EDPCH_Information_FDD_e_RGCH_3_IndexStepThreshold),
        (u'hARQ-Info-for-E-DCH', _EDPCH_Information_FDD_hARQ_Info_for_E_DCH),
        (u'hSDSCH-Configured-Indicator', _EDPCH_Information_FDD_hSDSCH_Configured_Indicator),
        (u'iE-Extensions', _EDPCH_Information_FDD_iE_Extensions),
        ])
    EDPCH_Information_FDD._ext = []
    
    #-----< EDPCH-Information-FDD-ExtIEs >-----#
    EDPCH_Information_FDD_ExtIEs = CLASS(name=u'EDPCH-Information-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDPCH_Information_FDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    EDPCH_Information_FDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _EDPCH_Information_FDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EDPCH-Information-RLReconfPrepare-FDD >-----#
    EDPCH_Information_RLReconfPrepare_FDD = SEQ(name=u'EDPCH-Information-RLReconfPrepare-FDD', mode=MODE_TYPE)
    _EDPCH_Information_RLReconfPrepare_FDD_maxSet_E_DPDCHs = ENUM(name=u'maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-Set-E-DPDCHs')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_e_TFCS_Information = SEQ(name=u'e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_e_TTI = ENUM(name=u'e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TTI')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_e_DPCCH_PO = INT(name=u'e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DPCCH-PO')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_e_RGCH_2_IndexStepThreshold = INT(name=u'e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-2-IndexStepThreshold')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_e_RGCH_3_IndexStepThreshold = INT(name=u'e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-3-IndexStepThreshold')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_hARQ_Info_for_E_DCH = ENUM(name=u'hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Info-for-E-DCH')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_hSDSCH_Configured_Indicator = ENUM(name=u'hSDSCH-Configured-Indicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Configured-Indicator')), opt=True)
    _EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id._const_tab = ____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id._const_tab_at = None
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__criticality._const_tab = ____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__extensionValue._const_tab = ____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id),
        (u'criticality', ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__extensionValue),
        ])
    __EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item_._ext = None
    _EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions._cont = __EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item_
    _EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDPCH_Information_RLReconfPrepare_FDD._cont = ASN1Dict([
        (u'maxSet-E-DPDCHs', _EDPCH_Information_RLReconfPrepare_FDD_maxSet_E_DPDCHs),
        (u'punctureLimit', _EDPCH_Information_RLReconfPrepare_FDD_punctureLimit),
        (u'e-TFCS-Information', _EDPCH_Information_RLReconfPrepare_FDD_e_TFCS_Information),
        (u'e-TTI', _EDPCH_Information_RLReconfPrepare_FDD_e_TTI),
        (u'e-DPCCH-PO', _EDPCH_Information_RLReconfPrepare_FDD_e_DPCCH_PO),
        (u'e-RGCH-2-IndexStepThreshold', _EDPCH_Information_RLReconfPrepare_FDD_e_RGCH_2_IndexStepThreshold),
        (u'e-RGCH-3-IndexStepThreshold', _EDPCH_Information_RLReconfPrepare_FDD_e_RGCH_3_IndexStepThreshold),
        (u'hARQ-Info-for-E-DCH', _EDPCH_Information_RLReconfPrepare_FDD_hARQ_Info_for_E_DCH),
        (u'hSDSCH-Configured-Indicator', _EDPCH_Information_RLReconfPrepare_FDD_hSDSCH_Configured_Indicator),
        (u'iE-Extensions', _EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions),
        ])
    EDPCH_Information_RLReconfPrepare_FDD._ext = []
    
    #-----< EDPCH-Information-RLReconfPrepare-FDD-ExtIEs >-----#
    EDPCH_Information_RLReconfPrepare_FDD_ExtIEs = CLASS(name=u'EDPCH-Information-RLReconfPrepare-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDPCH_Information_RLReconfPrepare_FDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    EDPCH_Information_RLReconfPrepare_FDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _EDPCH_Information_RLReconfPrepare_FDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EDPCH-Information-RLReconfRequest-FDD >-----#
    EDPCH_Information_RLReconfRequest_FDD = SEQ(name=u'EDPCH-Information-RLReconfRequest-FDD', mode=MODE_TYPE)
    _EDPCH_Information_RLReconfRequest_FDD_maxSet_E_DPDCHs = ENUM(name=u'maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-Set-E-DPDCHs')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_e_TFCS_Information = SEQ(name=u'e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_e_TTI = ENUM(name=u'e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TTI')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_e_DPCCH_PO = INT(name=u'e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DPCCH-PO')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_e_RGCH_2_IndexStepThreshold = INT(name=u'e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-2-IndexStepThreshold')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_e_RGCH_3_IndexStepThreshold = INT(name=u'e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-3-IndexStepThreshold')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_hARQ_Info_for_E_DCH = ENUM(name=u'hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Info-for-E-DCH')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_hSDSCH_Configured_Indicator = ENUM(name=u'hSDSCH-Configured-Indicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Configured-Indicator')), opt=True)
    _EDPCH_Information_RLReconfRequest_FDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id._const_tab = ____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id._const_tab_at = None
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__criticality._const_tab = ____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__extensionValue._const_tab = ____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id),
        (u'criticality', ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__extensionValue),
        ])
    __EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item_._ext = None
    _EDPCH_Information_RLReconfRequest_FDD_iE_Extensions._cont = __EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item_
    _EDPCH_Information_RLReconfRequest_FDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDPCH_Information_RLReconfRequest_FDD._cont = ASN1Dict([
        (u'maxSet-E-DPDCHs', _EDPCH_Information_RLReconfRequest_FDD_maxSet_E_DPDCHs),
        (u'punctureLimit', _EDPCH_Information_RLReconfRequest_FDD_punctureLimit),
        (u'e-TFCS-Information', _EDPCH_Information_RLReconfRequest_FDD_e_TFCS_Information),
        (u'e-TTI', _EDPCH_Information_RLReconfRequest_FDD_e_TTI),
        (u'e-DPCCH-PO', _EDPCH_Information_RLReconfRequest_FDD_e_DPCCH_PO),
        (u'e-RGCH-2-IndexStepThreshold', _EDPCH_Information_RLReconfRequest_FDD_e_RGCH_2_IndexStepThreshold),
        (u'e-RGCH-3-IndexStepThreshold', _EDPCH_Information_RLReconfRequest_FDD_e_RGCH_3_IndexStepThreshold),
        (u'hARQ-Info-for-E-DCH', _EDPCH_Information_RLReconfRequest_FDD_hARQ_Info_for_E_DCH),
        (u'hSDSCH-Configured-Indicator', _EDPCH_Information_RLReconfRequest_FDD_hSDSCH_Configured_Indicator),
        (u'iE-Extensions', _EDPCH_Information_RLReconfRequest_FDD_iE_Extensions),
        ])
    EDPCH_Information_RLReconfRequest_FDD._ext = []
    
    #-----< EDPCH-Information-RLReconfRequest-FDD-ExtIEs >-----#
    EDPCH_Information_RLReconfRequest_FDD_ExtIEs = CLASS(name=u'EDPCH-Information-RLReconfRequest-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDPCH_Information_RLReconfRequest_FDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    EDPCH_Information_RLReconfRequest_FDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _EDPCH_Information_RLReconfRequest_FDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DPCCH-PO >-----#
    E_DPCCH_PO = INT(name=u'E-DPCCH-PO', mode=MODE_TYPE)
    E_DPCCH_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< Extended-E-DPCCH-PO >-----#
    Extended_E_DPCCH_PO = INT(name=u'Extended-E-DPCCH-PO', mode=MODE_TYPE)
    Extended_E_DPCCH_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=15)], ev=None, er=[])
    
    #-----< E-DPDCH-PowerInterpolation >-----#
    E_DPDCH_PowerInterpolation = BOOL(name=u'E-DPDCH-PowerInterpolation', mode=MODE_TYPE)
    
    #-----< E-Primary-Secondary-Grant-Selector >-----#
    E_Primary_Secondary_Grant_Selector = ENUM(name=u'E-Primary-Secondary-Grant-Selector', mode=MODE_TYPE)
    E_Primary_Secondary_Grant_Selector._cont = ASN1Dict([(u'primary', 0), (u'secondary', 1)])
    E_Primary_Secondary_Grant_Selector._ext = None
    
    #-----< EHICH-SignatureSequence >-----#
    EHICH_SignatureSequence = INT(name=u'EHICH-SignatureSequence', mode=MODE_TYPE)
    EHICH_SignatureSequence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    
    #-----< E-RGCH-Release-Indicator >-----#
    E_RGCH_Release_Indicator = ENUM(name=u'E-RGCH-Release-Indicator', mode=MODE_TYPE)
    E_RGCH_Release_Indicator._cont = ASN1Dict([(u'e-RGCHreleased', 0)])
    E_RGCH_Release_Indicator._ext = None
    
    #-----< ERGCH-SignatureSequence >-----#
    ERGCH_SignatureSequence = INT(name=u'ERGCH-SignatureSequence', mode=MODE_TYPE)
    ERGCH_SignatureSequence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=39)], ev=None, er=[])
    
    #-----< E-Serving-Grant-Value >-----#
    E_Serving_Grant_Value = INT(name=u'E-Serving-Grant-Value', mode=MODE_TYPE)
    E_Serving_Grant_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38)], ev=None, er=[])
    
    #-----< E-RGCH-2-IndexStepThreshold >-----#
    E_RGCH_2_IndexStepThreshold = INT(name=u'E-RGCH-2-IndexStepThreshold', mode=MODE_TYPE)
    E_RGCH_2_IndexStepThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37)], ev=None, er=[])
    
    #-----< E-RGCH-3-IndexStepThreshold >-----#
    E_RGCH_3_IndexStepThreshold = INT(name=u'E-RGCH-3-IndexStepThreshold', mode=MODE_TYPE)
    E_RGCH_3_IndexStepThreshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37)], ev=None, er=[])
    
    #-----< EDCH-Serving-RL >-----#
    EDCH_Serving_RL = CHOICE(name=u'EDCH-Serving-RL', mode=MODE_TYPE)
    _EDCH_Serving_RL_e_DCH_Serving_RL_in_this_DRNS = SEQ(name=u'e-DCH-Serving-RL-in-this-DRNS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL-in-this-DRNS')))
    _EDCH_Serving_RL_e_DCH_Serving_RL_not_in_this_DRNS = NULL(name=u'e-DCH-Serving-RL-not-in-this-DRNS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    EDCH_Serving_RL._cont = ASN1Dict([
        (u'e-DCH-Serving-RL-in-this-DRNS', _EDCH_Serving_RL_e_DCH_Serving_RL_in_this_DRNS),
        (u'e-DCH-Serving-RL-not-in-this-DRNS', _EDCH_Serving_RL_e_DCH_Serving_RL_not_in_this_DRNS),
        ])
    EDCH_Serving_RL._ext = []
    
    #-----< EDCH-Serving-RL-in-this-DRNS >-----#
    EDCH_Serving_RL_in_this_DRNS = SEQ(name=u'EDCH-Serving-RL-in-this-DRNS', mode=MODE_TYPE)
    _EDCH_Serving_RL_in_this_DRNS_e_DCH_Serving_RL_Id = INT(name=u'e-DCH-Serving-RL-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _EDCH_Serving_RL_in_this_DRNS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id._const_tab = ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id_tab
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality._const_tab = ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality_tab
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue._const_tab = ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue_tab
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id),
        (u'criticality', ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue),
        ])
    __EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item_._ext = None
    _EDCH_Serving_RL_in_this_DRNS_iE_Extensions._cont = __EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item_
    _EDCH_Serving_RL_in_this_DRNS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_Serving_RL_in_this_DRNS._cont = ASN1Dict([
        (u'e-DCH-Serving-RL-Id', _EDCH_Serving_RL_in_this_DRNS_e_DCH_Serving_RL_Id),
        (u'iE-Extensions', _EDCH_Serving_RL_in_this_DRNS_iE_Extensions),
        ])
    EDCH_Serving_RL_in_this_DRNS._ext = []
    
    #-----< EDCH-Serving-RL-in-this-DRNS-ExtIEs >-----#
    EDCH_Serving_RL_in_this_DRNS_ExtIEs = CLASS(name=u'EDCH-Serving-RL-in-this-DRNS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_Serving_RL_in_this_DRNS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enhanced-FACH-Information-ResponseFDD >-----#
    Enhanced_FACH_Information_ResponseFDD = SEQ(name=u'Enhanced-FACH-Information-ResponseFDD', mode=MODE_TYPE)
    _Enhanced_FACH_Information_ResponseFDD_common_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH = SEQ_OF(name=u'common-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-EnhancedFACH-PCH')))
    _Enhanced_FACH_Information_ResponseFDD_dedicated_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH = SEQ_OF(name=u'dedicated-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-EnhancedFACH-PCH')))
    _Enhanced_FACH_Information_ResponseFDD_priorityQueueInfo_EnhancedPCH = SEQ_OF(name=u'priorityQueueInfo-EnhancedPCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-EnhancedFACH-PCH')), opt=True)
    _Enhanced_FACH_Information_ResponseFDD_hSDSCH_Initial_Capacity_Allocation = SEQ_OF(name=u'hSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Initial-Capacity-Allocation')))
    _Enhanced_FACH_Information_ResponseFDD_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')), opt=True)
    _Enhanced_FACH_Information_ResponseFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id._const_tab = ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id_tab
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id._const_tab_at = None
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab = ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality_tab
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab = ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id),
        (u'criticality', ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue),
        ])
    __Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item_._ext = None
    _Enhanced_FACH_Information_ResponseFDD_iE_Extensions._cont = __Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item_
    _Enhanced_FACH_Information_ResponseFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Enhanced_FACH_Information_ResponseFDD._cont = ASN1Dict([
        (u'common-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', _Enhanced_FACH_Information_ResponseFDD_common_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH),
        (u'dedicated-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', _Enhanced_FACH_Information_ResponseFDD_dedicated_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH),
        (u'priorityQueueInfo-EnhancedPCH', _Enhanced_FACH_Information_ResponseFDD_priorityQueueInfo_EnhancedPCH),
        (u'hSDSCH-Initial-Capacity-Allocation', _Enhanced_FACH_Information_ResponseFDD_hSDSCH_Initial_Capacity_Allocation),
        (u'hSDSCH-RNTI', _Enhanced_FACH_Information_ResponseFDD_hSDSCH_RNTI),
        (u'iE-Extensions', _Enhanced_FACH_Information_ResponseFDD_iE_Extensions),
        ])
    Enhanced_FACH_Information_ResponseFDD._ext = []
    
    #-----< Enhanced-FACH-Information-ResponseFDD-ExtIEs >-----#
    Enhanced_FACH_Information_ResponseFDD_ExtIEs = CLASS(name=u'Enhanced-FACH-Information-ResponseFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Enhanced_FACH_Information_ResponseFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enhanced-FACH-Information-ResponseLCR >-----#
    Enhanced_FACH_Information_ResponseLCR = SEQ(name=u'Enhanced-FACH-Information-ResponseLCR', mode=MODE_TYPE)
    _Enhanced_FACH_Information_ResponseLCR_common_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH = SEQ_OF(name=u'common-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-EnhancedFACH-PCH')))
    _Enhanced_FACH_Information_ResponseLCR_dedicated_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH = SEQ_OF(name=u'dedicated-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-EnhancedFACH-PCH')))
    _Enhanced_FACH_Information_ResponseLCR_priorityQueueInfo_EnhancedPCH = SEQ_OF(name=u'priorityQueueInfo-EnhancedPCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-EnhancedFACH-PCH')), opt=True)
    _Enhanced_FACH_Information_ResponseLCR_hSDSCH_Initial_Capacity_Allocation = SEQ_OF(name=u'hSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Initial-Capacity-Allocation')))
    _Enhanced_FACH_Information_ResponseLCR_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')), opt=True)
    _Enhanced_FACH_Information_ResponseLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality_tab
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id),
        (u'criticality', ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _Enhanced_FACH_Information_ResponseLCR_iE_Extensions._cont = __Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item_
    _Enhanced_FACH_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Enhanced_FACH_Information_ResponseLCR._cont = ASN1Dict([
        (u'common-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', _Enhanced_FACH_Information_ResponseLCR_common_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH),
        (u'dedicated-HS-DSCH-RNTI-priorityQueueInfo-EnhancedFACH', _Enhanced_FACH_Information_ResponseLCR_dedicated_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH),
        (u'priorityQueueInfo-EnhancedPCH', _Enhanced_FACH_Information_ResponseLCR_priorityQueueInfo_EnhancedPCH),
        (u'hSDSCH-Initial-Capacity-Allocation', _Enhanced_FACH_Information_ResponseLCR_hSDSCH_Initial_Capacity_Allocation),
        (u'hSDSCH-RNTI', _Enhanced_FACH_Information_ResponseLCR_hSDSCH_RNTI),
        (u'iE-Extensions', _Enhanced_FACH_Information_ResponseLCR_iE_Extensions),
        ])
    Enhanced_FACH_Information_ResponseLCR._ext = []
    
    #-----< Enhanced-FACH-Information-ResponseLCR-ExtIEs >-----#
    Enhanced_FACH_Information_ResponseLCR_ExtIEs = CLASS(name=u'Enhanced-FACH-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Enhanced_FACH_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enhanced-FACH-Support-Indicator >-----#
    Enhanced_FACH_Support_Indicator = NULL(name=u'Enhanced-FACH-Support-Indicator', mode=MODE_TYPE)
    
    #-----< EnhancedHSServingCC-Abort >-----#
    EnhancedHSServingCC_Abort = ENUM(name=u'EnhancedHSServingCC-Abort', mode=MODE_TYPE)
    EnhancedHSServingCC_Abort._cont = ASN1Dict([(u'abortEnhancedHSServingCC', 0)])
    EnhancedHSServingCC_Abort._ext = []
    
    #-----< Enhanced-PCH-Capability >-----#
    Enhanced_PCH_Capability = ENUM(name=u'Enhanced-PCH-Capability', mode=MODE_TYPE)
    Enhanced_PCH_Capability._cont = ASN1Dict([(u'enhanced-pch-capable', 0), (u'enhanced-pch-not-capable', 1)])
    Enhanced_PCH_Capability._ext = None
    
    #-----< E-RNTI >-----#
    E_RNTI = INT(name=u'E-RNTI', mode=MODE_TYPE)
    E_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< E-ROCH-PowerOffset >-----#
    E_ROCH_PowerOffset = INT(name=u'E-ROCH-PowerOffset', mode=MODE_TYPE)
    E_ROCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< E-TFCI >-----#
    E_TFCI = INT(name=u'E-TFCI', mode=MODE_TYPE)
    E_TFCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< E-TFCI-BetaEC-Boost >-----#
    E_TFCI_BetaEC_Boost = INT(name=u'E-TFCI-BetaEC-Boost', mode=MODE_TYPE)
    E_TFCI_BetaEC_Boost._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< E-TFCI-Boost-Information >-----#
    E_TFCI_Boost_Information = SEQ(name=u'E-TFCI-Boost-Information', mode=MODE_TYPE)
    _E_TFCI_Boost_Information_e_TFCI_BetaEC_Boost = INT(name=u'e-TFCI-BetaEC-Boost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI-BetaEC-Boost')))
    _E_TFCI_Boost_Information_uL_Delta_T2TP = INT(name=u'uL-Delta-T2TP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Delta-T2TP')), opt=True)
    _E_TFCI_Boost_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCI_Boost_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCI_Boost_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCI_Boost_Information_iE_Extensions__item__id._const_tab = ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab
    ___E_TFCI_Boost_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCI_Boost_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality._const_tab = ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_TFCI_Boost_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue._const_tab = ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_TFCI_Boost_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_TFCI_Boost_Information_iE_Extensions__item__id),
        (u'criticality', ___E_TFCI_Boost_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue),
        ])
    __E_TFCI_Boost_Information_iE_Extensions__item_._ext = None
    _E_TFCI_Boost_Information_iE_Extensions._cont = __E_TFCI_Boost_Information_iE_Extensions__item_
    _E_TFCI_Boost_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCI_Boost_Information._cont = ASN1Dict([
        (u'e-TFCI-BetaEC-Boost', _E_TFCI_Boost_Information_e_TFCI_BetaEC_Boost),
        (u'uL-Delta-T2TP', _E_TFCI_Boost_Information_uL_Delta_T2TP),
        (u'iE-Extensions', _E_TFCI_Boost_Information_iE_Extensions),
        ])
    E_TFCI_Boost_Information._ext = []
    
    #-----< E-TFCI-Boost-Information-ExtIEs >-----#
    E_TFCI_Boost_Information_ExtIEs = CLASS(name=u'E-TFCI-Boost-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_TFCI_Boost_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-TFCS-Information >-----#
    E_TFCS_Information = SEQ(name=u'E-TFCS-Information', mode=MODE_TYPE)
    _E_TFCS_Information_e_DCH_TFCI_Table_Index = INT(name=u'e-DCH-TFCI-Table-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TFCI-Table-Index')))
    _E_TFCS_Information_e_DCH_Min_Set_E_TFCI = INT(name=u'e-DCH-Min-Set-E-TFCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI')))
    _E_TFCS_Information_reference_E_TFCI_Information = SEQ_OF(name=u'reference-E-TFCI-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Reference-E-TFCI-Information')))
    _E_TFCS_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCS_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCS_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_TFCS_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Minimum-Set-E-TFCIValidityIndicator')))
    _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI-Boost-Information')))
    _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_2 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DPDCH-PowerInterpolation')))
    ____E_TFCS_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 667), (u'criticality', u'reject'), (u'Extension', _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 733), (u'criticality', u'reject'), (u'Extension', _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 737), (u'criticality', u'reject'), (u'Extension', _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_TFCS_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_TFCS_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_TFCS_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_TFCS_Information_iE_Extensions__item__id),
        (u'criticality', ___E_TFCS_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_TFCS_Information_iE_Extensions__item__extensionValue),
        ])
    __E_TFCS_Information_iE_Extensions__item_._ext = None
    _E_TFCS_Information_iE_Extensions._cont = __E_TFCS_Information_iE_Extensions__item_
    _E_TFCS_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCS_Information._cont = ASN1Dict([
        (u'e-DCH-TFCI-Table-Index', _E_TFCS_Information_e_DCH_TFCI_Table_Index),
        (u'e-DCH-Min-Set-E-TFCI', _E_TFCS_Information_e_DCH_Min_Set_E_TFCI),
        (u'reference-E-TFCI-Information', _E_TFCS_Information_reference_E_TFCI_Information),
        (u'iE-Extensions', _E_TFCS_Information_iE_Extensions),
        ])
    E_TFCS_Information._ext = []
    
    #-----< E-TFCS-Information-ExtIEs >-----#
    E_TFCS_Information_ExtIEs = CLASS(name=u'E-TFCS-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_TFCS_Information_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Minimum-Set-E-TFCIValidityIndicator')))
    _E_TFCS_Information_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI-Boost-Information')))
    _E_TFCS_Information_ExtIEs_val_Extension_2 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DPDCH-PowerInterpolation')))
    E_TFCS_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 667), (u'criticality', u'reject'), (u'Extension', _E_TFCS_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 733), (u'criticality', u'reject'), (u'Extension', _E_TFCS_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 737), (u'criticality', u'reject'), (u'Extension', _E_TFCS_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Minimum-Set-E-TFCIValidityIndicator >-----#
    E_DCH_Minimum_Set_E_TFCIValidityIndicator = ENUM(name=u'E-DCH-Minimum-Set-E-TFCIValidityIndicator', mode=MODE_TYPE)
    E_DCH_Minimum_Set_E_TFCIValidityIndicator._cont = ASN1Dict([(u'e-DCH-Minimum-Set-E-TFCI-response-not-valid', 0)])
    E_DCH_Minimum_Set_E_TFCIValidityIndicator._ext = None
    
    #-----< E-TTI >-----#
    E_TTI = ENUM(name=u'E-TTI', mode=MODE_TYPE)
    E_TTI._cont = ASN1Dict([(u'tti10', 0), (u'tti2', 1)])
    E_TTI._ext = None
    
    #-----< E-AGCH-PowerOffset >-----#
    E_AGCH_PowerOffset = INT(name=u'E-AGCH-PowerOffset', mode=MODE_TYPE)
    E_AGCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< E-RGCH-PowerOffset >-----#
    E_RGCH_PowerOffset = INT(name=u'E-RGCH-PowerOffset', mode=MODE_TYPE)
    E_RGCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< E-HICH-PowerOffset >-----#
    E_HICH_PowerOffset = INT(name=u'E-HICH-PowerOffset', mode=MODE_TYPE)
    E_HICH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< Enhanced-PrimaryCPICH-EcNo >-----#
    Enhanced_PrimaryCPICH_EcNo = INT(name=u'Enhanced-PrimaryCPICH-EcNo', mode=MODE_TYPE)
    Enhanced_PrimaryCPICH_EcNo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=49)], ev=None, er=[])
    
    #-----< EventA >-----#
    EventA = SEQ(name=u'EventA', mode=MODE_TYPE)
    _EventA_measurementTreshold = CHOICE(name=u'measurementTreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')))
    _EventA_measurementHysteresisTime = INT(name=u'measurementHysteresisTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementHysteresisTime')), opt=True)
    _EventA_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventA_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventA_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventA_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventA_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventA_iE_Extensions__item__id._const_tab = ____EventA_iE_Extensions__item__id_tab
    ___EventA_iE_Extensions__item__id._const_tab_at = None
    ___EventA_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventA_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventA_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventA_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventA_iE_Extensions__item__criticality._const_tab = ____EventA_iE_Extensions__item__criticality_tab
    ___EventA_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventA_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventA_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventA_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventA_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventA_iE_Extensions__item__extensionValue._const_tab = ____EventA_iE_Extensions__item__extensionValue_tab
    ___EventA_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventA_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventA_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventA_iE_Extensions__item__id),
        (u'criticality', ___EventA_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventA_iE_Extensions__item__extensionValue),
        ])
    __EventA_iE_Extensions__item_._ext = None
    _EventA_iE_Extensions._cont = __EventA_iE_Extensions__item_
    _EventA_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventA._cont = ASN1Dict([
        (u'measurementTreshold', _EventA_measurementTreshold),
        (u'measurementHysteresisTime', _EventA_measurementHysteresisTime),
        (u'iE-Extensions', _EventA_iE_Extensions),
        ])
    EventA._ext = []
    
    #-----< EventA-ExtIEs >-----#
    EventA_ExtIEs = CLASS(name=u'EventA-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventA_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventB >-----#
    EventB = SEQ(name=u'EventB', mode=MODE_TYPE)
    _EventB_measurementTreshold = CHOICE(name=u'measurementTreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')))
    _EventB_measurementHysteresisTime = INT(name=u'measurementHysteresisTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementHysteresisTime')), opt=True)
    _EventB_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventB_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventB_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventB_iE_Extensions__item__id._const_tab = ____EventB_iE_Extensions__item__id_tab
    ___EventB_iE_Extensions__item__id._const_tab_at = None
    ___EventB_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventB_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventB_iE_Extensions__item__criticality._const_tab = ____EventB_iE_Extensions__item__criticality_tab
    ___EventB_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventB_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventB_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventB_iE_Extensions__item__extensionValue._const_tab = ____EventB_iE_Extensions__item__extensionValue_tab
    ___EventB_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventB_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventB_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventB_iE_Extensions__item__id),
        (u'criticality', ___EventB_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventB_iE_Extensions__item__extensionValue),
        ])
    __EventB_iE_Extensions__item_._ext = None
    _EventB_iE_Extensions._cont = __EventB_iE_Extensions__item_
    _EventB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventB._cont = ASN1Dict([
        (u'measurementTreshold', _EventB_measurementTreshold),
        (u'measurementHysteresisTime', _EventB_measurementHysteresisTime),
        (u'iE-Extensions', _EventB_iE_Extensions),
        ])
    EventB._ext = []
    
    #-----< EventB-ExtIEs >-----#
    EventB_ExtIEs = CLASS(name=u'EventB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventC >-----#
    EventC = SEQ(name=u'EventC', mode=MODE_TYPE)
    _EventC_measurementIncreaseDecreaseThreshold = CHOICE(name=u'measurementIncreaseDecreaseThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementIncreaseDecreaseThreshold')))
    _EventC_measurementChangeTime = INT(name=u'measurementChangeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementChangeTime')))
    _EventC_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventC_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventC_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventC_iE_Extensions__item__id._const_tab = ____EventC_iE_Extensions__item__id_tab
    ___EventC_iE_Extensions__item__id._const_tab_at = None
    ___EventC_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventC_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventC_iE_Extensions__item__criticality._const_tab = ____EventC_iE_Extensions__item__criticality_tab
    ___EventC_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventC_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventC_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventC_iE_Extensions__item__extensionValue._const_tab = ____EventC_iE_Extensions__item__extensionValue_tab
    ___EventC_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventC_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventC_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventC_iE_Extensions__item__id),
        (u'criticality', ___EventC_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventC_iE_Extensions__item__extensionValue),
        ])
    __EventC_iE_Extensions__item_._ext = None
    _EventC_iE_Extensions._cont = __EventC_iE_Extensions__item_
    _EventC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventC._cont = ASN1Dict([
        (u'measurementIncreaseDecreaseThreshold', _EventC_measurementIncreaseDecreaseThreshold),
        (u'measurementChangeTime', _EventC_measurementChangeTime),
        (u'iE-Extensions', _EventC_iE_Extensions),
        ])
    EventC._ext = []
    
    #-----< EventC-ExtIEs >-----#
    EventC_ExtIEs = CLASS(name=u'EventC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventD >-----#
    EventD = SEQ(name=u'EventD', mode=MODE_TYPE)
    _EventD_measurementIncreaseDecreaseThreshold = CHOICE(name=u'measurementIncreaseDecreaseThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementIncreaseDecreaseThreshold')))
    _EventD_measurementChangeTime = INT(name=u'measurementChangeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementChangeTime')))
    _EventD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventD_iE_Extensions__item__id._const_tab = ____EventD_iE_Extensions__item__id_tab
    ___EventD_iE_Extensions__item__id._const_tab_at = None
    ___EventD_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventD_iE_Extensions__item__criticality._const_tab = ____EventD_iE_Extensions__item__criticality_tab
    ___EventD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventD_iE_Extensions__item__extensionValue._const_tab = ____EventD_iE_Extensions__item__extensionValue_tab
    ___EventD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventD_iE_Extensions__item__id),
        (u'criticality', ___EventD_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventD_iE_Extensions__item__extensionValue),
        ])
    __EventD_iE_Extensions__item_._ext = None
    _EventD_iE_Extensions._cont = __EventD_iE_Extensions__item_
    _EventD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventD._cont = ASN1Dict([
        (u'measurementIncreaseDecreaseThreshold', _EventD_measurementIncreaseDecreaseThreshold),
        (u'measurementChangeTime', _EventD_measurementChangeTime),
        (u'iE-Extensions', _EventD_iE_Extensions),
        ])
    EventD._ext = []
    
    #-----< EventD-ExtIEs >-----#
    EventD_ExtIEs = CLASS(name=u'EventD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventE >-----#
    EventE = SEQ(name=u'EventE', mode=MODE_TYPE)
    _EventE_measurementThreshold1 = CHOICE(name=u'measurementThreshold1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')))
    _EventE_measurementThreshold2 = CHOICE(name=u'measurementThreshold2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')), opt=True)
    _EventE_measurementHysteresisTime = INT(name=u'measurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementHysteresisTime')), opt=True)
    _EventE_reportPeriodicity = CHOICE(name=u'reportPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReportPeriodicity')), opt=True)
    _EventE_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventE_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventE_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventE_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventE_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventE_iE_Extensions__item__id._const_tab = ____EventE_iE_Extensions__item__id_tab
    ___EventE_iE_Extensions__item__id._const_tab_at = None
    ___EventE_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventE_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventE_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventE_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventE_iE_Extensions__item__criticality._const_tab = ____EventE_iE_Extensions__item__criticality_tab
    ___EventE_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventE_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventE_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventE_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventE_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventE_iE_Extensions__item__extensionValue._const_tab = ____EventE_iE_Extensions__item__extensionValue_tab
    ___EventE_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventE_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventE_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventE_iE_Extensions__item__id),
        (u'criticality', ___EventE_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventE_iE_Extensions__item__extensionValue),
        ])
    __EventE_iE_Extensions__item_._ext = None
    _EventE_iE_Extensions._cont = __EventE_iE_Extensions__item_
    _EventE_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventE._cont = ASN1Dict([
        (u'measurementThreshold1', _EventE_measurementThreshold1),
        (u'measurementThreshold2', _EventE_measurementThreshold2),
        (u'measurementHysteresisTime', _EventE_measurementHysteresisTime),
        (u'reportPeriodicity', _EventE_reportPeriodicity),
        (u'iE-Extensions', _EventE_iE_Extensions),
        ])
    EventE._ext = []
    
    #-----< EventE-ExtIEs >-----#
    EventE_ExtIEs = CLASS(name=u'EventE-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventE_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventF >-----#
    EventF = SEQ(name=u'EventF', mode=MODE_TYPE)
    _EventF_measurementThreshold1 = CHOICE(name=u'measurementThreshold1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')))
    _EventF_measurementThreshold2 = CHOICE(name=u'measurementThreshold2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')), opt=True)
    _EventF_measurementHysteresisTime = INT(name=u'measurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementHysteresisTime')), opt=True)
    _EventF_reportPeriodicity = CHOICE(name=u'reportPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReportPeriodicity')), opt=True)
    _EventF_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventF_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventF_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventF_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventF_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventF_iE_Extensions__item__id._const_tab = ____EventF_iE_Extensions__item__id_tab
    ___EventF_iE_Extensions__item__id._const_tab_at = None
    ___EventF_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventF_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventF_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventF_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventF_iE_Extensions__item__criticality._const_tab = ____EventF_iE_Extensions__item__criticality_tab
    ___EventF_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventF_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventF_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventF_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventF_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventF_iE_Extensions__item__extensionValue._const_tab = ____EventF_iE_Extensions__item__extensionValue_tab
    ___EventF_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventF_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventF_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventF_iE_Extensions__item__id),
        (u'criticality', ___EventF_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventF_iE_Extensions__item__extensionValue),
        ])
    __EventF_iE_Extensions__item_._ext = None
    _EventF_iE_Extensions._cont = __EventF_iE_Extensions__item_
    _EventF_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventF._cont = ASN1Dict([
        (u'measurementThreshold1', _EventF_measurementThreshold1),
        (u'measurementThreshold2', _EventF_measurementThreshold2),
        (u'measurementHysteresisTime', _EventF_measurementHysteresisTime),
        (u'reportPeriodicity', _EventF_reportPeriodicity),
        (u'iE-Extensions', _EventF_iE_Extensions),
        ])
    EventF._ext = []
    
    #-----< EventF-ExtIEs >-----#
    EventF_ExtIEs = CLASS(name=u'EventF-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventF_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventH >-----#
    EventH = SEQ(name=u'EventH', mode=MODE_TYPE)
    _EventH_measurementThreshold1 = CHOICE(name=u'measurementThreshold1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')))
    _EventH_measurementThreshold2 = CHOICE(name=u'measurementThreshold2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')), opt=True)
    _EventH_measurementHysteresisTime = INT(name=u'measurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementHysteresisTime')), opt=True)
    _EventH_reportPeriodicity = CHOICE(name=u'reportPeriodicity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReportPeriodicity')), opt=True)
    _EventH_measurementFluctuationRange = INT(name=u'measurementFluctuationRange', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventH_measurementFluctuationRange._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _EventH_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EventH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EventH_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EventH_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventH_iE_Extensions__item__id._const_tab = ____EventH_iE_Extensions__item__id_tab
    ___EventH_iE_Extensions__item__id._const_tab_at = None
    ___EventH_iE_Extensions__item__id._const_tab_id = u'id'
    ___EventH_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EventH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventH_iE_Extensions__item__criticality._const_tab = ____EventH_iE_Extensions__item__criticality_tab
    ___EventH_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EventH_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EventH_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EventH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EventH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EventH_iE_Extensions__item__extensionValue._const_tab = ____EventH_iE_Extensions__item__extensionValue_tab
    ___EventH_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EventH_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EventH_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EventH_iE_Extensions__item__id),
        (u'criticality', ___EventH_iE_Extensions__item__criticality),
        (u'extensionValue', ___EventH_iE_Extensions__item__extensionValue),
        ])
    __EventH_iE_Extensions__item_._ext = None
    _EventH_iE_Extensions._cont = __EventH_iE_Extensions__item_
    _EventH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EventH._cont = ASN1Dict([
        (u'measurementThreshold1', _EventH_measurementThreshold1),
        (u'measurementThreshold2', _EventH_measurementThreshold2),
        (u'measurementHysteresisTime', _EventH_measurementHysteresisTime),
        (u'reportPeriodicity', _EventH_reportPeriodicity),
        (u'measurementFluctuationRange', _EventH_measurementFluctuationRange),
        (u'iE-Extensions', _EventH_iE_Extensions),
        ])
    EventH._ext = []
    
    #-----< EventH-ExtIEs >-----#
    EventH_ExtIEs = CLASS(name=u'EventH-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EventH_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Event1F-Parameters >-----#
    Event1F_Parameters = SEQ(name=u'Event1F-Parameters', mode=MODE_TYPE)
    _Event1F_Parameters_measurementQuantity = ENUM(name=u'measurementQuantity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementQuantity')))
    _Event1F_Parameters_threshold = INT(name=u'threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Event1F_Parameters_threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    Event1F_Parameters._cont = ASN1Dict([
        (u'measurementQuantity', _Event1F_Parameters_measurementQuantity),
        (u'threshold', _Event1F_Parameters_threshold),
        ])
    Event1F_Parameters._ext = []
    
    #-----< Event1I-Parameters >-----#
    Event1I_Parameters = SEQ(name=u'Event1I-Parameters', mode=MODE_TYPE)
    _Event1I_Parameters_threshold = INT(name=u'threshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Event1I_Parameters_threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    Event1I_Parameters._cont = ASN1Dict([
        (u'threshold', _Event1I_Parameters_threshold),
        ])
    Event1I_Parameters._ext = []
    
    #-----< ExtendedGSMCellIndividualOffset >-----#
    ExtendedGSMCellIndividualOffset = INT(name=u'ExtendedGSMCellIndividualOffset', mode=MODE_TYPE)
    ExtendedGSMCellIndividualOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=-11), ASN1RangeInt(lb=11, ub=50)], ev=None, er=[])
    
    #-----< E-DCH-Information >-----#
    E_DCH_Information = SEQ(name=u'E-DCH-Information', mode=MODE_TYPE)
    _E_DCH_Information_e_PUCH_Information = SEQ(name=u'e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-Information')))
    _E_DCH_Information_e_TFCS_Information_TDD = SEQ(name=u'e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information-TDD')))
    _E_DCH_Information_e_DCH_MACdFlows_Information_TDD = SEQ_OF(name=u'e-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlows-Information-TDD')))
    _E_DCH_Information_e_DCH_TDD_Information = SEQ(name=u'e-DCH-TDD-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information')))
    _E_DCH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_iE_Extensions__item__id._const_tab = ____E_DCH_Information_iE_Extensions__item__id_tab
    ___E_DCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Information_iE_Extensions__item_._ext = None
    _E_DCH_Information_iE_Extensions._cont = __E_DCH_Information_iE_Extensions__item_
    _E_DCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Information._cont = ASN1Dict([
        (u'e-PUCH-Information', _E_DCH_Information_e_PUCH_Information),
        (u'e-TFCS-Information-TDD', _E_DCH_Information_e_TFCS_Information_TDD),
        (u'e-DCH-MACdFlows-Information-TDD', _E_DCH_Information_e_DCH_MACdFlows_Information_TDD),
        (u'e-DCH-TDD-Information', _E_DCH_Information_e_DCH_TDD_Information),
        (u'iE-Extensions', _E_DCH_Information_iE_Extensions),
        ])
    E_DCH_Information._ext = []
    
    #-----< E-DCH-Information-ExtIEs >-----#
    E_DCH_Information_ExtIEs = CLASS(name=u'E-DCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-Information >-----#
    E_PUCH_Information = SEQ(name=u'E-PUCH-Information', mode=MODE_TYPE)
    _E_PUCH_Information_minCR = INT(name=u'minCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CodeRate')))
    _E_PUCH_Information_maxCR = INT(name=u'maxCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CodeRate')))
    _E_PUCH_Information_harqInfo = ENUM(name=u'harqInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Info-for-E-DCH')))
    _E_PUCH_Information_n_E_UCCH = INT(name=u'n-E-UCCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'N-E-UCCH')))
    _E_PUCH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_PUCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_iE_Extensions__item__id._const_tab = ____E_PUCH_Information_iE_Extensions__item__id_tab
    ___E_PUCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_PUCH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_PUCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_iE_Extensions__item__criticality._const_tab = ____E_PUCH_Information_iE_Extensions__item__criticality_tab
    ___E_PUCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_PUCH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_PUCH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_PUCH_Information_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab
    ___E_PUCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_PUCH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_PUCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_PUCH_Information_iE_Extensions__item__id),
        (u'criticality', ___E_PUCH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_PUCH_Information_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_Information_iE_Extensions__item_._ext = None
    _E_PUCH_Information_iE_Extensions._cont = __E_PUCH_Information_iE_Extensions__item_
    _E_PUCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_Information._cont = ASN1Dict([
        (u'minCR', _E_PUCH_Information_minCR),
        (u'maxCR', _E_PUCH_Information_maxCR),
        (u'harqInfo', _E_PUCH_Information_harqInfo),
        (u'n-E-UCCH', _E_PUCH_Information_n_E_UCCH),
        (u'iE-Extensions', _E_PUCH_Information_iE_Extensions),
        ])
    E_PUCH_Information._ext = []
    
    #-----< E-PUCH-Information-ExtIEs >-----#
    E_PUCH_Information_ExtIEs = CLASS(name=u'E-PUCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_PUCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-TFCS-Information-TDD >-----#
    E_TFCS_Information_TDD = SEQ(name=u'E-TFCS-Information-TDD', mode=MODE_TYPE)
    _E_TFCS_Information_TDD_e_DCH_QPSK_RefBetaInfo = SEQ_OF(name=u'e-DCH-QPSK-RefBetaInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-QPSK-RefBetaInfo')))
    _E_TFCS_Information_TDD_e_DCH_sixteenQAM_RefBetaInfo = SEQ_OF(name=u'e-DCH-sixteenQAM-RefBetaInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-sixteenQAM-RefBetaInfo')))
    _E_TFCS_Information_TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCS_Information_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCS_Information_TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_TDD_iE_Extensions__item__id._const_tab = ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab
    ___E_TFCS_Information_TDD_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCS_Information_TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality._const_tab = ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_TFCS_Information_TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue._const_tab = ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_TFCS_Information_TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_TFCS_Information_TDD_iE_Extensions__item__id),
        (u'criticality', ___E_TFCS_Information_TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue),
        ])
    __E_TFCS_Information_TDD_iE_Extensions__item_._ext = None
    _E_TFCS_Information_TDD_iE_Extensions._cont = __E_TFCS_Information_TDD_iE_Extensions__item_
    _E_TFCS_Information_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCS_Information_TDD._cont = ASN1Dict([
        (u'e-DCH-QPSK-RefBetaInfo', _E_TFCS_Information_TDD_e_DCH_QPSK_RefBetaInfo),
        (u'e-DCH-sixteenQAM-RefBetaInfo', _E_TFCS_Information_TDD_e_DCH_sixteenQAM_RefBetaInfo),
        (u'iE-Extensions', _E_TFCS_Information_TDD_iE_Extensions),
        ])
    E_TFCS_Information_TDD._ext = []
    
    #-----< E-TFCS-Information-TDD-ExtIEs >-----#
    E_TFCS_Information_TDD_ExtIEs = CLASS(name=u'E-TFCS-Information-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_TFCS_Information_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-QPSK-RefBetaInfo >-----#
    E_DCH_QPSK_RefBetaInfo = SEQ_OF(name=u'E-DCH-QPSK-RefBetaInfo', mode=MODE_TYPE)
    _E_DCH_QPSK_RefBetaInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-RefBeta-Item')))
    E_DCH_QPSK_RefBetaInfo._cont = _E_DCH_QPSK_RefBetaInfo__item_
    E_DCH_QPSK_RefBetaInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-sixteenQAM-RefBetaInfo >-----#
    E_DCH_sixteenQAM_RefBetaInfo = SEQ_OF(name=u'E-DCH-sixteenQAM-RefBetaInfo', mode=MODE_TYPE)
    _E_DCH_sixteenQAM_RefBetaInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-RefBeta-Item')))
    E_DCH_sixteenQAM_RefBetaInfo._cont = _E_DCH_sixteenQAM_RefBetaInfo__item_
    E_DCH_sixteenQAM_RefBetaInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-RefBeta-Item >-----#
    E_DCH_RefBeta_Item = SEQ(name=u'E-DCH-RefBeta-Item', mode=MODE_TYPE)
    _E_DCH_RefBeta_Item_refCodeRate = INT(name=u'refCodeRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CodeRate-short')))
    _E_DCH_RefBeta_Item_refBeta = INT(name=u'refBeta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RefBeta')))
    E_DCH_RefBeta_Item._cont = ASN1Dict([
        (u'refCodeRate', _E_DCH_RefBeta_Item_refCodeRate),
        (u'refBeta', _E_DCH_RefBeta_Item_refBeta),
        ])
    E_DCH_RefBeta_Item._ext = None
    
    #-----< E-DCH-MACdFlows-Information-TDD >-----#
    E_DCH_MACdFlows_Information_TDD = SEQ_OF(name=u'E-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE)
    _E_DCH_MACdFlows_Information_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-InfoTDDItem')))
    E_DCH_MACdFlows_Information_TDD._cont = _E_DCH_MACdFlows_Information_TDD__item_
    E_DCH_MACdFlows_Information_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-InfoTDDItem >-----#
    E_DCH_MACdFlow_InfoTDDItem = SEQ(name=u'E-DCH-MACdFlow-InfoTDDItem', mode=MODE_TYPE)
    _E_DCH_MACdFlow_InfoTDDItem_e_DCH_MACdFlow_ID = INT(name=u'e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_InfoTDDItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')))
    _E_DCH_MACdFlow_InfoTDDItem_tnlQos = CHOICE(name=u'tnlQos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_payloadCRC_PresenceIndicator = ENUM(name=u'payloadCRC-PresenceIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PayloadCRC-PresenceIndicator')))
    _E_DCH_MACdFlow_InfoTDDItem_maximum_Number_of_Retransmissions_For_E_DCH = INT(name=u'maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_HARQ_PO_TDD = INT(name=u'eDCH-HARQ-PO-TDD', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-HARQ-PO-TDD')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _E_DCH_MACdFlow_InfoTDDItem_eDCH_Grant_TypeTDD = ENUM(name=u'eDCH-Grant-TypeTDD', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Grant-TypeTDD')))
    _E_DCH_MACdFlow_InfoTDDItem_eDCHLogicalChannelInformation = SEQ_OF(name=u'eDCHLogicalChannelInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelInformation')))
    _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer-LCR')))
    _____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 694), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions._cont = __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_
    _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_InfoTDDItem._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_InfoTDDItem_e_DCH_MACdFlow_ID),
        (u'allocationRetentionPriority', _E_DCH_MACdFlow_InfoTDDItem_allocationRetentionPriority),
        (u'tnlQos', _E_DCH_MACdFlow_InfoTDDItem_tnlQos),
        (u'bindingID', _E_DCH_MACdFlow_InfoTDDItem_bindingID),
        (u'transportLayerAddress', _E_DCH_MACdFlow_InfoTDDItem_transportLayerAddress),
        (u'payloadCRC-PresenceIndicator', _E_DCH_MACdFlow_InfoTDDItem_payloadCRC_PresenceIndicator),
        (u'maximum-Number-of-Retransmissions-For-E-DCH', _E_DCH_MACdFlow_InfoTDDItem_maximum_Number_of_Retransmissions_For_E_DCH),
        (u'eDCH-HARQ-PO-TDD', _E_DCH_MACdFlow_InfoTDDItem_eDCH_HARQ_PO_TDD),
        (u'eDCH-MACdFlow-Multiplexing-List', _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Multiplexing_List),
        (u'eDCH-Grant-TypeTDD', _E_DCH_MACdFlow_InfoTDDItem_eDCH_Grant_TypeTDD),
        (u'eDCHLogicalChannelInformation', _E_DCH_MACdFlow_InfoTDDItem_eDCHLogicalChannelInformation),
        (u'iE-Extensions', _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions),
        ])
    E_DCH_MACdFlow_InfoTDDItem._ext = []
    
    #-----< E-DCH-MACdFlow-InfoTDDItem-ExtIEs >-----#
    E_DCH_MACdFlow_InfoTDDItem_ExtIEs = CLASS(name=u'E-DCH-MACdFlow-InfoTDDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_MACdFlow_InfoTDDItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer-LCR')))
    _E_DCH_MACdFlow_InfoTDDItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    E_DCH_MACdFlow_InfoTDDItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 694), (u'criticality', u'ignore'), (u'Extension', _E_DCH_MACdFlow_InfoTDDItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _E_DCH_MACdFlow_InfoTDDItem_ExtIEs_val_Extension_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-MACdFlow-Retransmission-Timer-LCR >-----#
    E_DCH_MACdFlow_Retransmission_Timer_LCR = ENUM(name=u'E-DCH-MACdFlow-Retransmission-Timer-LCR', mode=MODE_TYPE)
    E_DCH_MACdFlow_Retransmission_Timer_LCR._cont = ASN1Dict([(u'ms10', 0), (u'ms15', 1), (u'ms20', 2), (u'ms25', 3), (u'ms30', 4), (u'ms35', 5), (u'ms40', 6), (u'ms45', 7), (u'ms50', 8), (u'ms55', 9), (u'ms60', 10), (u'ms65', 11), (u'ms70', 12), (u'ms75', 13), (u'ms80', 14), (u'ms85', 15), (u'ms90', 16), (u'ms95', 17), (u'ms100', 18), (u'ms110', 19), (u'ms120', 20), (u'ms140', 21), (u'ms160', 22), (u'ms200', 23), (u'ms240', 24), (u'ms280', 25), (u'ms320', 26), (u'ms400', 27), (u'ms480', 28), (u'ms560', 29)])
    E_DCH_MACdFlow_Retransmission_Timer_LCR._ext = []
    
    #-----< E-DCH-HARQ-PO-TDD >-----#
    E_DCH_HARQ_PO_TDD = INT(name=u'E-DCH-HARQ-PO-TDD', mode=MODE_TYPE)
    E_DCH_HARQ_PO_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< E-DCH-Grant-TypeTDD >-----#
    E_DCH_Grant_TypeTDD = ENUM(name=u'E-DCH-Grant-TypeTDD', mode=MODE_TYPE)
    E_DCH_Grant_TypeTDD._cont = ASN1Dict([(u'scheduled', 0), (u'non-scheduled', 1)])
    E_DCH_Grant_TypeTDD._ext = None
    
    #-----< E-DCH-TimeslotResource >-----#
    E_DCH_TimeslotResource = BIT_STR(name=u'E-DCH-TimeslotResource', mode=MODE_TYPE)
    E_DCH_TimeslotResource._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    
    #-----< E-DCH-PowerResource >-----#
    E_DCH_PowerResource = INT(name=u'E-DCH-PowerResource', mode=MODE_TYPE)
    E_DCH_PowerResource._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TddE-PUCH-Offset >-----#
    TddE_PUCH_Offset = INT(name=u'TddE-PUCH-Offset', mode=MODE_TYPE)
    TddE_PUCH_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< E-DCH-TDD-Information >-----#
    E_DCH_TDD_Information = SEQ(name=u'E-DCH-TDD-Information', mode=MODE_TYPE)
    _E_DCH_TDD_Information_e_DCH_TDD_Maximum_Bitrate = INT(name=u'e-DCH-TDD-Maximum-Bitrate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Maximum-Bitrate')), opt=True)
    _E_DCH_TDD_Information_e_DCH_Processing_Overload_Level = INT(name=u'e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo = INT(name=u'e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _E_DCH_TDD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_TDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_TDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_TDD_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_TDD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_Information_iE_Extensions__item_._ext = None
    _E_DCH_TDD_Information_iE_Extensions._cont = __E_DCH_TDD_Information_iE_Extensions__item_
    _E_DCH_TDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_Information._cont = ASN1Dict([
        (u'e-DCH-TDD-Maximum-Bitrate', _E_DCH_TDD_Information_e_DCH_TDD_Maximum_Bitrate),
        (u'e-DCH-Processing-Overload-Level', _E_DCH_TDD_Information_e_DCH_Processing_Overload_Level),
        (u'e-DCH-PowerOffset-for-SchedulingInfo', _E_DCH_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo),
        (u'iE-Extensions', _E_DCH_TDD_Information_iE_Extensions),
        ])
    E_DCH_TDD_Information._ext = []
    
    #-----< E-DCH-TDD-Information-ExtIEs >-----#
    E_DCH_TDD_Information_ExtIEs = CLASS(name=u'E-DCH-TDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Maximum-Bitrate >-----#
    E_DCH_TDD_Maximum_Bitrate = INT(name=u'E-DCH-TDD-Maximum-Bitrate', mode=MODE_TYPE)
    E_DCH_TDD_Maximum_Bitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9201)], ev=[], er=[])
    
    #-----< E-DCH-Information-Reconfig >-----#
    E_DCH_Information_Reconfig = SEQ(name=u'E-DCH-Information-Reconfig', mode=MODE_TYPE)
    _E_DCH_Information_Reconfig_e_PUCH_Information = SEQ(name=u'e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-Information')), opt=True)
    _E_DCH_Information_Reconfig_e_TFCS_Information_TDD = SEQ(name=u'e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Add = SEQ_OF(name=u'e-DCH-MACdFlows-to-Add', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlows-Information-TDD')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Delete = SEQ_OF(name=u'e-DCH-MACdFlows-to-Delete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info = SEQ(name=u'e-DCH-Non-Scheduled-Grant-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_TDD_Information = SEQ(name=u'e-DCH-TDD-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information')), opt=True)
    _E_DCH_Information_Reconfig_e_DCH_TDD_Information_to_Modify = SEQ(name=u'e-DCH-TDD-Information-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information-to-Modify')), opt=True)
    _E_DCH_Information_Reconfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Information_Reconfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id._const_tab = ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Information_Reconfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality._const_tab = ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Information_Reconfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Information_Reconfig_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Information_Reconfig_iE_Extensions__item_._ext = None
    _E_DCH_Information_Reconfig_iE_Extensions._cont = __E_DCH_Information_Reconfig_iE_Extensions__item_
    _E_DCH_Information_Reconfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Information_Reconfig._cont = ASN1Dict([
        (u'e-PUCH-Information', _E_DCH_Information_Reconfig_e_PUCH_Information),
        (u'e-TFCS-Information-TDD', _E_DCH_Information_Reconfig_e_TFCS_Information_TDD),
        (u'e-DCH-MACdFlows-to-Add', _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Add),
        (u'e-DCH-MACdFlows-to-Delete', _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Delete),
        (u'e-DCH-Non-Scheduled-Grant-Info', _E_DCH_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info),
        (u'e-DCH-TDD-Information', _E_DCH_Information_Reconfig_e_DCH_TDD_Information),
        (u'e-DCH-TDD-Information-to-Modify', _E_DCH_Information_Reconfig_e_DCH_TDD_Information_to_Modify),
        (u'iE-Extensions', _E_DCH_Information_Reconfig_iE_Extensions),
        ])
    E_DCH_Information_Reconfig._ext = []
    
    #-----< E-DCH-Information-Reconfig-ExtIEs >-----#
    E_DCH_Information_Reconfig_ExtIEs = CLASS(name=u'E-DCH-Information-Reconfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_Reconfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Information-to-Modify >-----#
    E_DCH_TDD_Information_to_Modify = SEQ(name=u'E-DCH-TDD-Information-to-Modify', mode=MODE_TYPE)
    _E_DCH_TDD_Information_to_Modify_e_DCH_TDD_Information_to_Modify_List = SEQ_OF(name=u'e-DCH-TDD-Information-to-Modify-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information-to-Modify-List')), opt=True)
    _E_DCH_TDD_Information_to_Modify_mACeReset_Indicator = ENUM(name=u'mACeReset-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACeReset-Indicator')), opt=True)
    _E_DCH_TDD_Information_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-TS0-CapabilityLCR')))
    ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 739), (u'criticality', u'reject'), (u'Extension', _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 871), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_._ext = None
    _E_DCH_TDD_Information_to_Modify_iE_Extensions._cont = __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_
    _E_DCH_TDD_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_Information_to_Modify._cont = ASN1Dict([
        (u'e-DCH-TDD-Information-to-Modify-List', _E_DCH_TDD_Information_to_Modify_e_DCH_TDD_Information_to_Modify_List),
        (u'mACeReset-Indicator', _E_DCH_TDD_Information_to_Modify_mACeReset_Indicator),
        (u'iE-Extensions', _E_DCH_TDD_Information_to_Modify_iE_Extensions),
        ])
    E_DCH_TDD_Information_to_Modify._ext = []
    
    #-----< E-DCH-TDD-Information-to-Modify-ExtIEs >-----#
    E_DCH_TDD_Information_to_Modify_ExtIEs = CLASS(name=u'E-DCH-TDD-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdPDUSizeFormat')))
    _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-TS0-CapabilityLCR')))
    E_DCH_TDD_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 739), (u'criticality', u'reject'), (u'Extension', _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 871), (u'criticality', u'ignore'), (u'Extension', _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Information-to-Modify-List >-----#
    E_DCH_TDD_Information_to_Modify_List = SEQ_OF(name=u'E-DCH-TDD-Information-to-Modify-List', mode=MODE_TYPE)
    _E_DCH_TDD_Information_to_Modify_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-ModifyTDDItem')))
    E_DCH_TDD_Information_to_Modify_List._cont = _E_DCH_TDD_Information_to_Modify_List__item_
    E_DCH_TDD_Information_to_Modify_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-MACdFlow-ModifyTDDItem >-----#
    E_DCH_MACdFlow_ModifyTDDItem = SEQ(name=u'E-DCH-MACdFlow-ModifyTDDItem', mode=MODE_TYPE)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_MACdFlow_ID = INT(name=u'e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _E_DCH_MACdFlow_ModifyTDDItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _E_DCH_MACdFlow_ModifyTDDItem_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_tnlQos = CHOICE(name=u'tnlQos', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_maximum_Number_of_Retransmissions_For_E_DCH = INT(name=u'maximum-Number-of-Retransmissions-For-E-DCH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_HARQ_PO_TDD = INT(name=u'eDCH-HARQ-PO-TDD', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-HARQ-PO-TDD')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Multiplexing_List = BIT_STR(name=u'eDCH-MACdFlow-Multiplexing-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Multiplexing-List')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_eDCH_Grant_TypeTDD = ENUM(name=u'eDCH-Grant-TypeTDD', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Grant-TypeTDD')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToAdd = SEQ_OF(name=u'e-DCH-LogicalChannelToAdd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelInformation')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToModify = SEQ_OF(name=u'e-DCH-LogicalChannelToModify', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelToModify')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToDelete = SEQ_OF(name=u'e-DCH-LogicalChannelToDelete', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LogicalChannelToDelete')), opt=True)
    _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer-LCR')))
    _____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 694), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id._const_tab = ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality._const_tab = ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_._ext = None
    _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions._cont = __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_
    _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_MACdFlow_ModifyTDDItem._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-ID', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_MACdFlow_ID),
        (u'allocationRetentionPriority', _E_DCH_MACdFlow_ModifyTDDItem_allocationRetentionPriority),
        (u'transportBearerRequestIndicator', _E_DCH_MACdFlow_ModifyTDDItem_transportBearerRequestIndicator),
        (u'bindingID', _E_DCH_MACdFlow_ModifyTDDItem_bindingID),
        (u'transportLayerAddress', _E_DCH_MACdFlow_ModifyTDDItem_transportLayerAddress),
        (u'tnlQos', _E_DCH_MACdFlow_ModifyTDDItem_tnlQos),
        (u'maximum-Number-of-Retransmissions-For-E-DCH', _E_DCH_MACdFlow_ModifyTDDItem_maximum_Number_of_Retransmissions_For_E_DCH),
        (u'eDCH-HARQ-PO-TDD', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_HARQ_PO_TDD),
        (u'eDCH-MACdFlow-Multiplexing-List', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Multiplexing_List),
        (u'eDCH-Grant-TypeTDD', _E_DCH_MACdFlow_ModifyTDDItem_eDCH_Grant_TypeTDD),
        (u'e-DCH-LogicalChannelToAdd', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToAdd),
        (u'e-DCH-LogicalChannelToModify', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToModify),
        (u'e-DCH-LogicalChannelToDelete', _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToDelete),
        (u'iE-Extensions', _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions),
        ])
    E_DCH_MACdFlow_ModifyTDDItem._ext = []
    
    #-----< E-DCH-MACdFlow-ModifyTDDItem-ExtIEs >-----#
    E_DCH_MACdFlow_ModifyTDDItem_ExtIEs = CLASS(name=u'E-DCH-MACdFlow-ModifyTDDItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_MACdFlow_ModifyTDDItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer-LCR')))
    _E_DCH_MACdFlow_ModifyTDDItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    E_DCH_MACdFlow_ModifyTDDItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 694), (u'criticality', u'ignore'), (u'Extension', _E_DCH_MACdFlow_ModifyTDDItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _E_DCH_MACdFlow_ModifyTDDItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Information-Response >-----#
    E_DCH_Information_Response = SEQ(name=u'E-DCH-Information-Response', mode=MODE_TYPE)
    _E_DCH_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name=u'e-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp')), opt=True)
    _E_DCH_Information_Response_e_AGCH_Specific_Information_ResponseTDD = SEQ_OF(name=u'e-AGCH-Specific-Information-ResponseTDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationRespListTDD')), opt=True)
    _E_DCH_Information_Response_e_HICH_Information_Response = SEQ(name=u'e-HICH-Information-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-InformationResp')), opt=True)
    _E_DCH_Information_Response_e_DCH_Non_Scheduled_Grant_Info = SEQ(name=u'e-DCH-Non-Scheduled-Grant-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info')), opt=True)
    _E_DCH_Information_Response_e_RNTI = INT(name=u'e-RNTI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _E_DCH_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Response_iE_Extensions__item__id._const_tab = ____E_DCH_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Response_iE_Extensions__item__criticality._const_tab = ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab
    ___E_DCH_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Information_Response_iE_Extensions__item_._ext = None
    _E_DCH_Information_Response_iE_Extensions._cont = __E_DCH_Information_Response_iE_Extensions__item_
    _E_DCH_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Information_Response._cont = ASN1Dict([
        (u'e-DCH-TDD-MACdFlow-Specific-InformationResp', _E_DCH_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp),
        (u'e-AGCH-Specific-Information-ResponseTDD', _E_DCH_Information_Response_e_AGCH_Specific_Information_ResponseTDD),
        (u'e-HICH-Information-Response', _E_DCH_Information_Response_e_HICH_Information_Response),
        (u'e-DCH-Non-Scheduled-Grant-Info', _E_DCH_Information_Response_e_DCH_Non_Scheduled_Grant_Info),
        (u'e-RNTI', _E_DCH_Information_Response_e_RNTI),
        (u'iE-Extensions', _E_DCH_Information_Response_iE_Extensions),
        ])
    E_DCH_Information_Response._ext = []
    
    #-----< E-DCH-Information-Response-ExtIEs >-----#
    E_DCH_Information_Response_ExtIEs = CLASS(name=u'E-DCH-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-MACdFlow-Specific-InformationResp >-----#
    E_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name=u'E-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item')))
    E_DCH_TDD_MACdFlow_Specific_InformationResp._cont = _E_DCH_TDD_MACdFlow_Specific_InformationResp__item_
    E_DCH_TDD_MACdFlow_Specific_InformationResp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< E-DCH-TDD-MACdFlow-Specific-InformationResp-Item >-----#
    E_DCH_TDD_MACdFlow_Specific_InformationResp_Item = SEQ(name=u'E-DCH-TDD-MACdFlow-Specific-InformationResp-Item', mode=MODE_TYPE)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_e_DCH_MacdFlow_Id = INT(name=u'e-DCH-MacdFlow-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_._ext = None
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions._cont = __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_
    _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_MACdFlow_Specific_InformationResp_Item._cont = ASN1Dict([
        (u'e-DCH-MacdFlow-Id', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_e_DCH_MacdFlow_Id),
        (u'bindingID', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_bindingID),
        (u'transportLayerAddress', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_transportLayerAddress),
        (u'iE-Extensions', _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions),
        ])
    E_DCH_TDD_MACdFlow_Specific_InformationResp_Item._ext = []
    
    #-----< E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs >-----#
    E_DCH_TDD_MACdFlow_Specific_InformationRespItem_ExtIEs = CLASS(name=u'E-DCH-TDD-MACdFlow-Specific-InformationRespItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_MACdFlow_Specific_InformationRespItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Specific-InformationRespListTDD >-----#
    E_AGCH_Specific_InformationRespListTDD = SEQ_OF(name=u'E-AGCH-Specific-InformationRespListTDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationRespListTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationResp-ItemTDD')))
    E_AGCH_Specific_InformationRespListTDD._cont = _E_AGCH_Specific_InformationRespListTDD__item_
    E_AGCH_Specific_InformationRespListTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-AGCH-Specific-InformationResp-ItemTDD >-----#
    E_AGCH_Specific_InformationResp_ItemTDD = SEQ(name=u'E-AGCH-Specific-InformationResp-ItemTDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationResp_ItemTDD_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _E_AGCH_Specific_InformationResp_ItemTDD_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _E_AGCH_Specific_InformationResp_ItemTDD_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id._const_tab = ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality._const_tab = ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id),
        (u'criticality', ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_._ext = None
    _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions._cont = __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_
    _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_Specific_InformationResp_ItemTDD._cont = ASN1Dict([
        (u'timeslot', _E_AGCH_Specific_InformationResp_ItemTDD_timeslot),
        (u'midambleShiftAndBurstType', _E_AGCH_Specific_InformationResp_ItemTDD_midambleShiftAndBurstType),
        (u'tDD-ChannelisationCode', _E_AGCH_Specific_InformationResp_ItemTDD_tDD_ChannelisationCode),
        (u'iE-Extensions', _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions),
        ])
    E_AGCH_Specific_InformationResp_ItemTDD._ext = []
    
    #-----< E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs >-----#
    E_AGCH_Specific_InformationResp_ItemTDD_ExtIEs = CLASS(name=u'E-AGCH-Specific-InformationResp-ItemTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_AGCH_Specific_InformationResp_ItemTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-InformationResp >-----#
    E_HICH_InformationResp = SEQ(name=u'E-HICH-InformationResp', mode=MODE_TYPE)
    _E_HICH_InformationResp_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _E_HICH_InformationResp_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _E_HICH_InformationResp_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_HICH_InformationResp_e_HICH_TimeOffset = INT(name=u'e-HICH-TimeOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-TimeOffset')))
    _E_HICH_InformationResp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_InformationResp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_InformationResp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_HICH_InformationResp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_iE_Extensions__item__id._const_tab = ____E_HICH_InformationResp_iE_Extensions__item__id_tab
    ___E_HICH_InformationResp_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_InformationResp_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_HICH_InformationResp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_HICH_InformationResp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_iE_Extensions__item__criticality._const_tab = ____E_HICH_InformationResp_iE_Extensions__item__criticality_tab
    ___E_HICH_InformationResp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_HICH_InformationResp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_HICH_InformationResp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_InformationResp_iE_Extensions__item__extensionValue_tab
    ___E_HICH_InformationResp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_HICH_InformationResp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_HICH_InformationResp_iE_Extensions__item__id),
        (u'criticality', ___E_HICH_InformationResp_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_HICH_InformationResp_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_InformationResp_iE_Extensions__item_._ext = None
    _E_HICH_InformationResp_iE_Extensions._cont = __E_HICH_InformationResp_iE_Extensions__item_
    _E_HICH_InformationResp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_InformationResp._cont = ASN1Dict([
        (u'timeslot', _E_HICH_InformationResp_timeslot),
        (u'midambleShiftAndBurstType', _E_HICH_InformationResp_midambleShiftAndBurstType),
        (u'tDD-ChannelisationCode', _E_HICH_InformationResp_tDD_ChannelisationCode),
        (u'e-HICH-TimeOffset', _E_HICH_InformationResp_e_HICH_TimeOffset),
        (u'iE-Extensions', _E_HICH_InformationResp_iE_Extensions),
        ])
    E_HICH_InformationResp._ext = []
    
    #-----< E-HICH-InformationResp-ExtIEs >-----#
    E_HICH_InformationResp_ExtIEs = CLASS(name=u'E-HICH-InformationResp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_HICH_InformationResp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-TimeOffset >-----#
    E_HICH_TimeOffset = INT(name=u'E-HICH-TimeOffset', mode=MODE_TYPE)
    E_HICH_TimeOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=44)], ev=None, er=[])
    
    #-----< E-DCH-Non-Scheduled-Grant-Info >-----#
    E_DCH_Non_Scheduled_Grant_Info = SEQ(name=u'E-DCH-Non-Scheduled-Grant-Info', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Grant_Info_timeslotResource = BIT_STR(name=u'timeslotResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TimeslotResource')))
    _E_DCH_Non_Scheduled_Grant_Info_powerResource = INT(name=u'powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Non_Scheduled_Grant_Info_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _E_DCH_Non_Scheduled_Grant_Info_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _E_DCH_Non_Scheduled_Grant_Info_tddE_PUCH_Offset = INT(name=u'tddE-PUCH-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Non_Scheduled_Grant_Info_tdd_ChannelisationCode = ENUM(name=u'tdd-ChannelisationCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions._cont = __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Grant_Info._cont = ASN1Dict([
        (u'timeslotResource', _E_DCH_Non_Scheduled_Grant_Info_timeslotResource),
        (u'powerResource', _E_DCH_Non_Scheduled_Grant_Info_powerResource),
        (u'repetitionPeriod', _E_DCH_Non_Scheduled_Grant_Info_repetitionPeriod),
        (u'repetitionLength', _E_DCH_Non_Scheduled_Grant_Info_repetitionLength),
        (u'tddE-PUCH-Offset', _E_DCH_Non_Scheduled_Grant_Info_tddE_PUCH_Offset),
        (u'tdd-ChannelisationCode', _E_DCH_Non_Scheduled_Grant_Info_tdd_ChannelisationCode),
        (u'iE-Extensions', _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Grant_Info._ext = []
    
    #-----< E-DCH-Non-Scheduled-Grant-Info-ExtIEs >-----#
    E_DCH_Non_Scheduled_Grant_Info_ExtIEs = CLASS(name=u'E-DCH-Non-Scheduled-Grant-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Non_Scheduled_Grant_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-768-Information >-----#
    E_DCH_768_Information = SEQ(name=u'E-DCH-768-Information', mode=MODE_TYPE)
    _E_DCH_768_Information_e_PUCH_Information = SEQ(name=u'e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-Information')))
    _E_DCH_768_Information_e_TFCS_Information_TDD = SEQ(name=u'e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information-TDD')))
    _E_DCH_768_Information_e_DCH_MACdFlows_Information_TDD = SEQ_OF(name=u'e-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlows-Information-TDD')))
    _E_DCH_768_Information_e_DCH_TDD_Information768 = SEQ(name=u'e-DCH-TDD-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information768')))
    _E_DCH_768_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_768_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_768_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_768_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_iE_Extensions__item__id._const_tab = ____E_DCH_768_Information_iE_Extensions__item__id_tab
    ___E_DCH_768_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_768_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_768_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_768_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_768_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_768_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_768_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_768_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_768_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_768_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_768_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_768_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_768_Information_iE_Extensions__item_._ext = None
    _E_DCH_768_Information_iE_Extensions._cont = __E_DCH_768_Information_iE_Extensions__item_
    _E_DCH_768_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_768_Information._cont = ASN1Dict([
        (u'e-PUCH-Information', _E_DCH_768_Information_e_PUCH_Information),
        (u'e-TFCS-Information-TDD', _E_DCH_768_Information_e_TFCS_Information_TDD),
        (u'e-DCH-MACdFlows-Information-TDD', _E_DCH_768_Information_e_DCH_MACdFlows_Information_TDD),
        (u'e-DCH-TDD-Information768', _E_DCH_768_Information_e_DCH_TDD_Information768),
        (u'iE-Extensions', _E_DCH_768_Information_iE_Extensions),
        ])
    E_DCH_768_Information._ext = []
    
    #-----< E-DCH-768-Information-ExtIEs >-----#
    E_DCH_768_Information_ExtIEs = CLASS(name=u'E-DCH-768-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_768_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Information768 >-----#
    E_DCH_TDD_Information768 = SEQ(name=u'E-DCH-TDD-Information768', mode=MODE_TYPE)
    _E_DCH_TDD_Information768_e_DCH_TDD_Maximum_Bitrate768 = INT(name=u'e-DCH-TDD-Maximum-Bitrate768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Maximum-Bitrate768')), opt=True)
    _E_DCH_TDD_Information768_e_DCH_Processing_Overload_Level = INT(name=u'e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_TDD_Information768_e_DCH_PowerOffset_for_SchedulingInfo = INT(name=u'e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _E_DCH_TDD_Information768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_TDD_Information768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_TDD_Information768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information768_iE_Extensions__item__id._const_tab = ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab
    ___E_DCH_TDD_Information768_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_TDD_Information768_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality._const_tab = ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_Information768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_TDD_Information768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_TDD_Information768_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_TDD_Information768_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_TDD_Information768_iE_Extensions__item_._ext = None
    _E_DCH_TDD_Information768_iE_Extensions._cont = __E_DCH_TDD_Information768_iE_Extensions__item_
    _E_DCH_TDD_Information768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_TDD_Information768._cont = ASN1Dict([
        (u'e-DCH-TDD-Maximum-Bitrate768', _E_DCH_TDD_Information768_e_DCH_TDD_Maximum_Bitrate768),
        (u'e-DCH-Processing-Overload-Level', _E_DCH_TDD_Information768_e_DCH_Processing_Overload_Level),
        (u'e-DCH-PowerOffset-for-SchedulingInfo', _E_DCH_TDD_Information768_e_DCH_PowerOffset_for_SchedulingInfo),
        (u'iE-Extensions', _E_DCH_TDD_Information768_iE_Extensions),
        ])
    E_DCH_TDD_Information768._ext = []
    
    #-----< E-DCH-TDD-Information768-ExtIEs >-----#
    E_DCH_TDD_Information768_ExtIEs = CLASS(name=u'E-DCH-TDD-Information768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_TDD_Information768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TDD-Maximum-Bitrate768 >-----#
    E_DCH_TDD_Maximum_Bitrate768 = INT(name=u'E-DCH-TDD-Maximum-Bitrate768', mode=MODE_TYPE)
    E_DCH_TDD_Maximum_Bitrate768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=17713)], ev=[], er=[])
    
    #-----< E-DCH-768-Information-Reconfig >-----#
    E_DCH_768_Information_Reconfig = SEQ(name=u'E-DCH-768-Information-Reconfig', mode=MODE_TYPE)
    _E_DCH_768_Information_Reconfig_e_PUCH_Information = SEQ(name=u'e-PUCH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-Information')), opt=True)
    _E_DCH_768_Information_Reconfig_e_TFCS_Information_TDD = SEQ(name=u'e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Add = SEQ_OF(name=u'e-DCH-MACdFlows-to-Add', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlows-Information-TDD')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Delete = SEQ_OF(name=u'e-DCH-MACdFlows-to-Delete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info768 = SEQ(name=u'e-DCH-Non-Scheduled-Grant-Info768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info768')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information768 = SEQ(name=u'e-DCH-TDD-Information768', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information768')), opt=True)
    _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information_to_Modify = SEQ(name=u'e-DCH-TDD-Information-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information-to-Modify')), opt=True)
    _E_DCH_768_Information_Reconfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_768_Information_Reconfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id._const_tab = ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality._const_tab = ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_768_Information_Reconfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_768_Information_Reconfig_iE_Extensions__item_._ext = None
    _E_DCH_768_Information_Reconfig_iE_Extensions._cont = __E_DCH_768_Information_Reconfig_iE_Extensions__item_
    _E_DCH_768_Information_Reconfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_768_Information_Reconfig._cont = ASN1Dict([
        (u'e-PUCH-Information', _E_DCH_768_Information_Reconfig_e_PUCH_Information),
        (u'e-TFCS-Information-TDD', _E_DCH_768_Information_Reconfig_e_TFCS_Information_TDD),
        (u'e-DCH-MACdFlows-to-Add', _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Add),
        (u'e-DCH-MACdFlows-to-Delete', _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Delete),
        (u'e-DCH-Non-Scheduled-Grant-Info768', _E_DCH_768_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info768),
        (u'e-DCH-TDD-Information768', _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information768),
        (u'e-DCH-TDD-Information-to-Modify', _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information_to_Modify),
        (u'iE-Extensions', _E_DCH_768_Information_Reconfig_iE_Extensions),
        ])
    E_DCH_768_Information_Reconfig._ext = []
    
    #-----< E-DCH-768-Information-Reconfig-ExtIEs >-----#
    E_DCH_768_Information_Reconfig_ExtIEs = CLASS(name=u'E-DCH-768-Information-Reconfig-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_768_Information_Reconfig_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-768-Information-Response >-----#
    E_DCH_768_Information_Response = SEQ(name=u'E-DCH-768-Information-Response', mode=MODE_TYPE)
    _E_DCH_768_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name=u'e-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp')), opt=True)
    _E_DCH_768_Information_Response_e_AGCH_Specific_Information_Response768TDD = SEQ_OF(name=u'e-AGCH-Specific-Information-Response768TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationRespList768TDD')), opt=True)
    _E_DCH_768_Information_Response_e_HICH_Information_Response768 = SEQ(name=u'e-HICH-Information-Response768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-InformationResp768')), opt=True)
    _E_DCH_768_Information_Response_e_DCH_Non_Scheduled_Grant_Info768 = SEQ(name=u'e-DCH-Non-Scheduled-Grant-Info768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info768')), opt=True)
    _E_DCH_768_Information_Response_e_RNTI = INT(name=u'e-RNTI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _E_DCH_768_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_768_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_768_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_768_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Response_iE_Extensions__item__id._const_tab = ____E_DCH_768_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_768_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_768_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_768_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_768_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Response_iE_Extensions__item__criticality._const_tab = ____E_DCH_768_Information_Response_iE_Extensions__item__criticality_tab
    ___E_DCH_768_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_768_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_768_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_768_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_768_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_768_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_768_Information_Response_iE_Extensions__item__extensionValue_tab
    ___E_DCH_768_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_768_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_768_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_768_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_768_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_768_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_768_Information_Response_iE_Extensions__item_._ext = None
    _E_DCH_768_Information_Response_iE_Extensions._cont = __E_DCH_768_Information_Response_iE_Extensions__item_
    _E_DCH_768_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_768_Information_Response._cont = ASN1Dict([
        (u'e-DCH-TDD-MACdFlow-Specific-InformationResp', _E_DCH_768_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp),
        (u'e-AGCH-Specific-Information-Response768TDD', _E_DCH_768_Information_Response_e_AGCH_Specific_Information_Response768TDD),
        (u'e-HICH-Information-Response768', _E_DCH_768_Information_Response_e_HICH_Information_Response768),
        (u'e-DCH-Non-Scheduled-Grant-Info768', _E_DCH_768_Information_Response_e_DCH_Non_Scheduled_Grant_Info768),
        (u'e-RNTI', _E_DCH_768_Information_Response_e_RNTI),
        (u'iE-Extensions', _E_DCH_768_Information_Response_iE_Extensions),
        ])
    E_DCH_768_Information_Response._ext = []
    
    #-----< E-DCH-768-Information-Response-ExtIEs >-----#
    E_DCH_768_Information_Response_ExtIEs = CLASS(name=u'E-DCH-768-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_768_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Specific-InformationRespList768TDD >-----#
    E_AGCH_Specific_InformationRespList768TDD = SEQ_OF(name=u'E-AGCH-Specific-InformationRespList768TDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationRespList768TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationResp-Item768TDD')))
    E_AGCH_Specific_InformationRespList768TDD._cont = _E_AGCH_Specific_InformationRespList768TDD__item_
    E_AGCH_Specific_InformationRespList768TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-AGCH-Specific-InformationResp-Item768TDD >-----#
    E_AGCH_Specific_InformationResp_Item768TDD = SEQ(name=u'E-AGCH-Specific-InformationResp-Item768TDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationResp_Item768TDD_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _E_AGCH_Specific_InformationResp_Item768TDD_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _E_AGCH_Specific_InformationResp_Item768TDD_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id._const_tab = ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id_tab
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality._const_tab = ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality_tab
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id),
        (u'criticality', ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item_._ext = None
    _E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions._cont = __E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item_
    _E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_Specific_InformationResp_Item768TDD._cont = ASN1Dict([
        (u'timeslot', _E_AGCH_Specific_InformationResp_Item768TDD_timeslot),
        (u'midambleShiftAndBurstType768', _E_AGCH_Specific_InformationResp_Item768TDD_midambleShiftAndBurstType768),
        (u'tDD-ChannelisationCode768', _E_AGCH_Specific_InformationResp_Item768TDD_tDD_ChannelisationCode768),
        (u'iE-Extensions', _E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions),
        ])
    E_AGCH_Specific_InformationResp_Item768TDD._ext = []
    
    #-----< E-AGCH-Specific-InformationResp-Item768TDD-ExtIEs >-----#
    E_AGCH_Specific_InformationResp_Item768TDD_ExtIEs = CLASS(name=u'E-AGCH-Specific-InformationResp-Item768TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_AGCH_Specific_InformationResp_Item768TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-InformationResp768 >-----#
    E_HICH_InformationResp768 = SEQ(name=u'E-HICH-InformationResp768', mode=MODE_TYPE)
    _E_HICH_InformationResp768_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _E_HICH_InformationResp768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _E_HICH_InformationResp768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _E_HICH_InformationResp768_e_HICH_TimeOffset = INT(name=u'e-HICH-TimeOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-TimeOffset')))
    _E_HICH_InformationResp768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_InformationResp768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_InformationResp768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_HICH_InformationResp768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp768_iE_Extensions__item__id._const_tab = ____E_HICH_InformationResp768_iE_Extensions__item__id_tab
    ___E_HICH_InformationResp768_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_InformationResp768_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_HICH_InformationResp768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_HICH_InformationResp768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp768_iE_Extensions__item__criticality._const_tab = ____E_HICH_InformationResp768_iE_Extensions__item__criticality_tab
    ___E_HICH_InformationResp768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_HICH_InformationResp768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_HICH_InformationResp768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp768_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_InformationResp768_iE_Extensions__item__extensionValue_tab
    ___E_HICH_InformationResp768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_HICH_InformationResp768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_HICH_InformationResp768_iE_Extensions__item__id),
        (u'criticality', ___E_HICH_InformationResp768_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_HICH_InformationResp768_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_InformationResp768_iE_Extensions__item_._ext = None
    _E_HICH_InformationResp768_iE_Extensions._cont = __E_HICH_InformationResp768_iE_Extensions__item_
    _E_HICH_InformationResp768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_InformationResp768._cont = ASN1Dict([
        (u'timeslot', _E_HICH_InformationResp768_timeslot),
        (u'midambleShiftAndBurstType768', _E_HICH_InformationResp768_midambleShiftAndBurstType768),
        (u'tDD-ChannelisationCode768', _E_HICH_InformationResp768_tDD_ChannelisationCode768),
        (u'e-HICH-TimeOffset', _E_HICH_InformationResp768_e_HICH_TimeOffset),
        (u'iE-Extensions', _E_HICH_InformationResp768_iE_Extensions),
        ])
    E_HICH_InformationResp768._ext = []
    
    #-----< E-HICH-InformationResp768-ExtIEs >-----#
    E_HICH_InformationResp768_ExtIEs = CLASS(name=u'E-HICH-InformationResp768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_HICH_InformationResp768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Non-Scheduled-Grant-Info768 >-----#
    E_DCH_Non_Scheduled_Grant_Info768 = SEQ(name=u'E-DCH-Non-Scheduled-Grant-Info768', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Grant_Info768_timeslotResource = BIT_STR(name=u'timeslotResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TimeslotResource')))
    _E_DCH_Non_Scheduled_Grant_Info768_powerResource = INT(name=u'powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Non_Scheduled_Grant_Info768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _E_DCH_Non_Scheduled_Grant_Info768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _E_DCH_Non_Scheduled_Grant_Info768_tddE_PUCH_Offset = INT(name=u'tddE-PUCH-Offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Non_Scheduled_Grant_Info768_tdd_ChannelisationCode768 = ENUM(name=u'tdd-ChannelisationCode768', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions._cont = __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Grant_Info768._cont = ASN1Dict([
        (u'timeslotResource', _E_DCH_Non_Scheduled_Grant_Info768_timeslotResource),
        (u'powerResource', _E_DCH_Non_Scheduled_Grant_Info768_powerResource),
        (u'repetitionPeriod', _E_DCH_Non_Scheduled_Grant_Info768_repetitionPeriod),
        (u'repetitionLength', _E_DCH_Non_Scheduled_Grant_Info768_repetitionLength),
        (u'tddE-PUCH-Offset', _E_DCH_Non_Scheduled_Grant_Info768_tddE_PUCH_Offset),
        (u'tdd-ChannelisationCode768', _E_DCH_Non_Scheduled_Grant_Info768_tdd_ChannelisationCode768),
        (u'iE-Extensions', _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Grant_Info768._ext = []
    
    #-----< E-DCH-Non-Scheduled-Grant-Info768-ExtIEs >-----#
    E_DCH_Non_Scheduled_Grant_Info768_ExtIEs = CLASS(name=u'E-DCH-Non-Scheduled-Grant-Info768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Non_Scheduled_Grant_Info768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-LCR-Information >-----#
    E_DCH_LCR_Information = SEQ(name=u'E-DCH-LCR-Information', mode=MODE_TYPE)
    _E_DCH_LCR_Information_e_PUCH_LCR_Information = SEQ(name=u'e-PUCH-LCR-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-LCR-Information')))
    _E_DCH_LCR_Information_e_TFCS_Information_TDD = SEQ(name=u'e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information-TDD')))
    _E_DCH_LCR_Information_e_DCH_MACdFlows_Information_TDD = SEQ_OF(name=u'e-DCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlows-Information-TDD')))
    _E_DCH_LCR_Information_e_DCH_LCR_TDD_Information = SEQ(name=u'e-DCH-LCR-TDD-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-TDD-Information')))
    _E_DCH_LCR_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCR_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCR_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LCR_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_iE_Extensions__item__id._const_tab = ____E_DCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCR_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCR_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LCR_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LCR_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LCR_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCR_Information_iE_Extensions__item_._ext = None
    _E_DCH_LCR_Information_iE_Extensions._cont = __E_DCH_LCR_Information_iE_Extensions__item_
    _E_DCH_LCR_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCR_Information._cont = ASN1Dict([
        (u'e-PUCH-LCR-Information', _E_DCH_LCR_Information_e_PUCH_LCR_Information),
        (u'e-TFCS-Information-TDD', _E_DCH_LCR_Information_e_TFCS_Information_TDD),
        (u'e-DCH-MACdFlows-Information-TDD', _E_DCH_LCR_Information_e_DCH_MACdFlows_Information_TDD),
        (u'e-DCH-LCR-TDD-Information', _E_DCH_LCR_Information_e_DCH_LCR_TDD_Information),
        (u'iE-Extensions', _E_DCH_LCR_Information_iE_Extensions),
        ])
    E_DCH_LCR_Information._ext = []
    
    #-----< E-DCH-Information-LCR-ExtIEs >-----#
    E_DCH_Information_LCR_ExtIEs = CLASS(name=u'E-DCH-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-LCR-Information >-----#
    E_PUCH_LCR_Information = SEQ(name=u'E-PUCH-LCR-Information', mode=MODE_TYPE)
    _E_PUCH_LCR_Information_minCR = INT(name=u'minCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CodeRate')))
    _E_PUCH_LCR_Information_maxCR = INT(name=u'maxCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CodeRate')))
    _E_PUCH_LCR_Information_harqInfo = ENUM(name=u'harqInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Info-for-E-DCH')))
    _E_PUCH_LCR_Information_pRxdesBase = INT(name=u'pRxdesBase', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-PRXdesBase')))
    _E_PUCH_LCR_Information_e_PUCH_TPC_Step_Size = ENUM(name=u'e-PUCH-TPC-Step-Size', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _E_PUCH_LCR_Information_n_E_UCCH_LCR = INT(name=u'n-E-UCCH-LCR', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'N-E-UCCH-LCR')))
    _E_PUCH_LCR_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_PUCH_LCR_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_PUCH_LCR_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_PUCH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 745), (u'criticality', u'ignore'), (u'Extension', _____E_PUCH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_PUCH_LCR_Information_iE_Extensions__item__id._const_tab = ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_PUCH_LCR_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_PUCH_LCR_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality._const_tab = ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_PUCH_LCR_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab = ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_PUCH_LCR_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_PUCH_LCR_Information_iE_Extensions__item__id),
        (u'criticality', ___E_PUCH_LCR_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue),
        ])
    __E_PUCH_LCR_Information_iE_Extensions__item_._ext = None
    _E_PUCH_LCR_Information_iE_Extensions._cont = __E_PUCH_LCR_Information_iE_Extensions__item_
    _E_PUCH_LCR_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_PUCH_LCR_Information._cont = ASN1Dict([
        (u'minCR', _E_PUCH_LCR_Information_minCR),
        (u'maxCR', _E_PUCH_LCR_Information_maxCR),
        (u'harqInfo', _E_PUCH_LCR_Information_harqInfo),
        (u'pRxdesBase', _E_PUCH_LCR_Information_pRxdesBase),
        (u'e-PUCH-TPC-Step-Size', _E_PUCH_LCR_Information_e_PUCH_TPC_Step_Size),
        (u'n-E-UCCH-LCR', _E_PUCH_LCR_Information_n_E_UCCH_LCR),
        (u'iE-Extensions', _E_PUCH_LCR_Information_iE_Extensions),
        ])
    E_PUCH_LCR_Information._ext = []
    
    #-----< E-PUCH-Information-LCR-ExtIEs >-----#
    E_PUCH_Information_LCR_ExtIEs = CLASS(name=u'E-PUCH-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_PUCH_Information_LCR_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    E_PUCH_Information_LCR_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 745), (u'criticality', u'ignore'), (u'Extension', _E_PUCH_Information_LCR_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-PUCH-PRXdesBase >-----#
    E_PUCH_PRXdesBase = INT(name=u'E-PUCH-PRXdesBase', mode=MODE_TYPE)
    E_PUCH_PRXdesBase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-112, ub=-50)], ev=None, er=[])
    
    #-----< E-DCH-LCR-TDD-Information >-----#
    E_DCH_LCR_TDD_Information = SEQ(name=u'E-DCH-LCR-TDD-Information', mode=MODE_TYPE)
    _E_DCH_LCR_TDD_Information_e_DCH_Physical_Layer_Category_LCR = INT(name=u'e-DCH-Physical-Layer-Category-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Physical-Layer-Category-LCR')), opt=True)
    _E_DCH_LCR_TDD_Information_e_DCH_Processing_Overload_Level = INT(name=u'e-DCH-Processing-Overload-Level', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Processing-Overload-Level')), opt=True)
    _E_DCH_LCR_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo = INT(name=u'e-DCH-PowerOffset-for-SchedulingInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerOffset-for-SchedulingInfo')), opt=True)
    _E_DCH_LCR_TDD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCR_TDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer-LCR')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNPL-Carrier-Group-Indicator')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-TS0-CapabilityLCR')))
    ____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 738), (u'criticality', u'reject'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 743), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 744), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 809), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 887), (u'criticality', u'reject'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 892), (u'criticality', u'reject'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 871), (u'criticality', u'ignore'), (u'Extension', _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__id._const_tab = ____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_TDD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LCR_TDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LCR_TDD_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LCR_TDD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LCR_TDD_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCR_TDD_Information_iE_Extensions__item_._ext = None
    _E_DCH_LCR_TDD_Information_iE_Extensions._cont = __E_DCH_LCR_TDD_Information_iE_Extensions__item_
    _E_DCH_LCR_TDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCR_TDD_Information._cont = ASN1Dict([
        (u'e-DCH-Physical-Layer-Category-LCR', _E_DCH_LCR_TDD_Information_e_DCH_Physical_Layer_Category_LCR),
        (u'e-DCH-Processing-Overload-Level', _E_DCH_LCR_TDD_Information_e_DCH_Processing_Overload_Level),
        (u'e-DCH-PowerOffset-for-SchedulingInfo', _E_DCH_LCR_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo),
        (u'iE-Extensions', _E_DCH_LCR_TDD_Information_iE_Extensions),
        ])
    E_DCH_LCR_TDD_Information._ext = []
    
    #-----< E-DCH-LCR-TDD-Information-ExtIEs >-----#
    E_DCH_LCR_TDD_Information_ExtIEs = CLASS(name=u'E-DCH-LCR-TDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNr-Retransmissions-EDCH')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlow-Retransmission-Timer-LCR')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-UE-Inactivity-Monitor-Threshold')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNPL-Carrier-Group-Indicator')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory')))
    _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-TS0-CapabilityLCR')))
    E_DCH_LCR_TDD_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 738), (u'criticality', u'reject'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 743), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 744), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 809), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 887), (u'criticality', u'reject'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 892), (u'criticality', u'reject'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 871), (u'criticality', u'ignore'), (u'Extension', _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Physical-Layer-Category-LCR >-----#
    E_DCH_Physical_Layer_Category_LCR = INT(name=u'E-DCH-Physical-Layer-Category-LCR', mode=MODE_TYPE)
    E_DCH_Physical_Layer_Category_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Execution-Type >-----#
    Execution_Type = CHOICE(name=u'Execution-Type', mode=MODE_TYPE)
    _Execution_Type_synchronised = INT(name=u'synchronised', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _Execution_Type_unsynchronised = NULL(name=u'unsynchronised', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Execution_Type._cont = ASN1Dict([
        (u'synchronised', _Execution_Type_synchronised),
        (u'unsynchronised', _Execution_Type_unsynchronised),
        ])
    Execution_Type._ext = None
    
    #-----< Extended-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    Extended_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name=u'Extended-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_TYPE)
    Extended_E_DCH_LCRTDD_PhysicalLayerCategory._const_val = ASN1Set(rv=[6], rr=[], ev=[], er=[])
    
    #-----< Extension-CommonMeasurementValue >-----#
    Extension_CommonMeasurementValue = SEQ(name=u'Extension-CommonMeasurementValue', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementValue_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_CommonMeasurementValue_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RTLoadValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NRTLoadInformationValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPTSInterferenceValue')))
    ___Extension_CommonMeasurementValue_id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGANSSMeasurementValueInformation')))
    __Extension_CommonMeasurementValue_id_tab._val = ASN1Set(rv=[dict([(u'id', 535), (u'criticality', u'ignore'), (u'Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 536), (u'criticality', u'ignore'), (u'Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 538), (u'criticality', u'reject'), (u'Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 703), (u'criticality', u'reject'), (u'Value', ___Extension_CommonMeasurementValue_id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementValue_id._const_tab = __Extension_CommonMeasurementValue_id_tab
    _Extension_CommonMeasurementValue_id._const_tab_at = None
    _Extension_CommonMeasurementValue_id._const_tab_id = u'id'
    _Extension_CommonMeasurementValue_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_CommonMeasurementValue_criticality._const_tab = __Extension_CommonMeasurementValue_id_tab
    _Extension_CommonMeasurementValue_criticality._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementValue_criticality._const_tab_id = u'criticality'
    _Extension_CommonMeasurementValue_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_CommonMeasurementValue_value._const_tab = __Extension_CommonMeasurementValue_id_tab
    _Extension_CommonMeasurementValue_value._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementValue_value._const_tab_id = u'Value'
    Extension_CommonMeasurementValue._cont = ASN1Dict([
        (u'id', _Extension_CommonMeasurementValue_id),
        (u'criticality', _Extension_CommonMeasurementValue_criticality),
        (u'value', _Extension_CommonMeasurementValue_value),
        ])
    Extension_CommonMeasurementValue._ext = None
    
    #-----< Extension-CommonMeasurementValueIE >-----#
    Extension_CommonMeasurementValueIE = CLASS(name=u'Extension-CommonMeasurementValueIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementValueIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RTLoadValue')))
    _Extension_CommonMeasurementValueIE_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NRTLoadInformationValue')))
    _Extension_CommonMeasurementValueIE_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPTSInterferenceValue')))
    _Extension_CommonMeasurementValueIE_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGANSSMeasurementValueInformation')))
    Extension_CommonMeasurementValueIE._val = ASN1Set(rv=[dict([(u'id', 535), (u'criticality', u'ignore'), (u'Value', _Extension_CommonMeasurementValueIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 536), (u'criticality', u'ignore'), (u'Value', _Extension_CommonMeasurementValueIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 538), (u'criticality', u'reject'), (u'Value', _Extension_CommonMeasurementValueIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 703), (u'criticality', u'reject'), (u'Value', _Extension_CommonMeasurementValueIE_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Extension-DedicatedMeasurementValue >-----#
    Extension_DedicatedMeasurementValue = SEQ(name=u'Extension-DedicatedMeasurementValue', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_DedicatedMeasurementValue_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_DedicatedMeasurementValue_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Angle-Of-Arrival-Value-LCR')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Reception-Quality-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-ext')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-Round-Trip-Time-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-transmission-power-headroom-Value')))
    ___Extension_DedicatedMeasurementValue_id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TBS')))
    __Extension_DedicatedMeasurementValue_id_tab._val = ASN1Set(rv=[dict([(u'id', 293), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 495), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 633), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 652), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 663), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 926), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 986), (u'criticality', u'reject'), (u'Value', ___Extension_DedicatedMeasurementValue_id_tab_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_DedicatedMeasurementValue_id._const_tab = __Extension_DedicatedMeasurementValue_id_tab
    _Extension_DedicatedMeasurementValue_id._const_tab_at = None
    _Extension_DedicatedMeasurementValue_id._const_tab_id = u'id'
    _Extension_DedicatedMeasurementValue_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_DedicatedMeasurementValue_criticality._const_tab = __Extension_DedicatedMeasurementValue_id_tab
    _Extension_DedicatedMeasurementValue_criticality._const_tab_at = ('..', u'id')
    _Extension_DedicatedMeasurementValue_criticality._const_tab_id = u'criticality'
    _Extension_DedicatedMeasurementValue_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_DedicatedMeasurementValue_value._const_tab = __Extension_DedicatedMeasurementValue_id_tab
    _Extension_DedicatedMeasurementValue_value._const_tab_at = ('..', u'id')
    _Extension_DedicatedMeasurementValue_value._const_tab_id = u'Value'
    Extension_DedicatedMeasurementValue._cont = ASN1Dict([
        (u'id', _Extension_DedicatedMeasurementValue_id),
        (u'criticality', _Extension_DedicatedMeasurementValue_criticality),
        (u'value', _Extension_DedicatedMeasurementValue_value),
        ])
    Extension_DedicatedMeasurementValue._ext = None
    
    #-----< Extension-DedicatedMeasurementValueIE >-----#
    Extension_DedicatedMeasurementValueIE = CLASS(name=u'Extension-DedicatedMeasurementValueIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_DedicatedMeasurementValueIE_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    _Extension_DedicatedMeasurementValueIE_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Angle-Of-Arrival-Value-LCR')))
    _Extension_DedicatedMeasurementValueIE_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Reception-Quality-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    _Extension_DedicatedMeasurementValueIE_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-ext')))
    _Extension_DedicatedMeasurementValueIE_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-Round-Trip-Time-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-transmission-power-headroom-Value')))
    _Extension_DedicatedMeasurementValueIE_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TBS')))
    Extension_DedicatedMeasurementValueIE._val = ASN1Set(rv=[dict([(u'id', 293), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 148), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 495), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 633), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 652), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 663), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 926), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 986), (u'criticality', u'reject'), (u'Value', _Extension_DedicatedMeasurementValueIE_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< E-DCH-LCR-Information-Reconfig >-----#
    E_DCH_LCR_Information_Reconfig = SEQ(name=u'E-DCH-LCR-Information-Reconfig', mode=MODE_TYPE)
    _E_DCH_LCR_Information_Reconfig_e_PUCH_LCR_Information = SEQ(name=u'e-PUCH-LCR-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-LCR-Information')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_TFCS_Information_TDD = SEQ(name=u'e-TFCS-Information-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information-TDD')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Add = SEQ_OF(name=u'e-DCH-MACdFlows-to-Add', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-MACdFlows-Information-TDD')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Delete = SEQ_OF(name=u'e-DCH-MACdFlows-to-Delete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_LCR_TDD_Information = SEQ(name=u'e-DCH-LCR-TDD-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-TDD-Information')), opt=True)
    _E_DCH_LCR_Information_Reconfig_e_DCH_TDD_Information_to_Modify = SEQ(name=u'e-DCH-TDD-Information-to-Modify', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-Information-to-Modify')), opt=True)
    _E_DCH_LCR_Information_Reconfig_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id._const_tab = ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_._ext = None
    _E_DCH_LCR_Information_Reconfig_iE_Extensions._cont = __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_
    _E_DCH_LCR_Information_Reconfig_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCR_Information_Reconfig._cont = ASN1Dict([
        (u'e-PUCH-LCR-Information', _E_DCH_LCR_Information_Reconfig_e_PUCH_LCR_Information),
        (u'e-TFCS-Information-TDD', _E_DCH_LCR_Information_Reconfig_e_TFCS_Information_TDD),
        (u'e-DCH-MACdFlows-to-Add', _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Add),
        (u'e-DCH-MACdFlows-to-Delete', _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Delete),
        (u'e-DCH-LCR-TDD-Information', _E_DCH_LCR_Information_Reconfig_e_DCH_LCR_TDD_Information),
        (u'e-DCH-TDD-Information-to-Modify', _E_DCH_LCR_Information_Reconfig_e_DCH_TDD_Information_to_Modify),
        (u'iE-Extensions', _E_DCH_LCR_Information_Reconfig_iE_Extensions),
        ])
    E_DCH_LCR_Information_Reconfig._ext = []
    
    #-----< E-DCH-Information-Reconfig-LCR-ExtIEs >-----#
    E_DCH_Information_Reconfig_LCR_ExtIEs = CLASS(name=u'E-DCH-Information-Reconfig-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_Reconfig_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-LCR-Information-Response >-----#
    E_DCH_LCR_Information_Response = SEQ(name=u'E-DCH-LCR-Information-Response', mode=MODE_TYPE)
    _E_DCH_LCR_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name=u'e-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp')), opt=True)
    _E_DCH_LCR_Information_Response_e_AGCH_Specific_Information_Response_LCR_TDD = SEQ_OF(name=u'e-AGCH-Specific-Information-Response-LCR-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationRespList-LCR-TDD')), opt=True)
    _E_DCH_LCR_Information_Response_e_HICH_Specific_Information_Response_LCR = SEQ(name=u'e-HICH-Specific-Information-Response-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-Specific-InformationResp-LCR')), opt=True)
    _E_DCH_LCR_Information_Response_e_DCH_Non_Scheduled_Grant_Info_LCR = SEQ(name=u'e-DCH-Non-Scheduled-Grant-Info-LCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Non-Scheduled-Grant-Info-LCR')), opt=True)
    _E_DCH_LCR_Information_Response_e_RNTI = INT(name=u'e-RNTI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')), opt=True)
    _E_DCH_LCR_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_LCR_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_LCR_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__id._const_tab = ____E_DCH_LCR_Information_Response_iE_Extensions__item__id_tab
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_LCR_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__criticality._const_tab = ____E_DCH_LCR_Information_Response_iE_Extensions__item__criticality_tab
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue_tab
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_LCR_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_LCR_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_LCR_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_LCR_Information_Response_iE_Extensions__item_._ext = None
    _E_DCH_LCR_Information_Response_iE_Extensions._cont = __E_DCH_LCR_Information_Response_iE_Extensions__item_
    _E_DCH_LCR_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_LCR_Information_Response._cont = ASN1Dict([
        (u'e-DCH-TDD-MACdFlow-Specific-InformationResp', _E_DCH_LCR_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp),
        (u'e-AGCH-Specific-Information-Response-LCR-TDD', _E_DCH_LCR_Information_Response_e_AGCH_Specific_Information_Response_LCR_TDD),
        (u'e-HICH-Specific-Information-Response-LCR', _E_DCH_LCR_Information_Response_e_HICH_Specific_Information_Response_LCR),
        (u'e-DCH-Non-Scheduled-Grant-Info-LCR', _E_DCH_LCR_Information_Response_e_DCH_Non_Scheduled_Grant_Info_LCR),
        (u'e-RNTI', _E_DCH_LCR_Information_Response_e_RNTI),
        (u'iE-Extensions', _E_DCH_LCR_Information_Response_iE_Extensions),
        ])
    E_DCH_LCR_Information_Response._ext = []
    
    #-----< E-DCH-Information-Response-LCR-ExtIEs >-----#
    E_DCH_Information_Response_LCR_ExtIEs = CLASS(name=u'E-DCH-Information-Response-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Information_Response_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-AGCH-Specific-InformationRespList-LCR-TDD >-----#
    E_AGCH_Specific_InformationRespList_LCR_TDD = SEQ_OF(name=u'E-AGCH-Specific-InformationRespList-LCR-TDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationRespList_LCR_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationResp-Item-LCR-TDD')))
    E_AGCH_Specific_InformationRespList_LCR_TDD._cont = _E_AGCH_Specific_InformationRespList_LCR_TDD__item_
    E_AGCH_Specific_InformationRespList_LCR_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-AGCH-Specific-InformationResp-Item-LCR-TDD >-----#
    E_AGCH_Specific_InformationResp_Item_LCR_TDD = SEQ(name=u'E-AGCH-Specific-InformationResp-Item-LCR-TDD', mode=MODE_TYPE)
    _E_AGCH_Specific_InformationResp_Item_LCR_TDD_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _E_AGCH_Specific_InformationResp_Item_LCR_TDD_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _E_AGCH_Specific_InformationResp_Item_LCR_TDD_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id._const_tab = ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id._const_tab_at = None
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality._const_tab = ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue._const_tab = ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id),
        (u'criticality', ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue),
        ])
    __E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item_._ext = None
    _E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions._cont = __E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item_
    _E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_AGCH_Specific_InformationResp_Item_LCR_TDD._cont = ASN1Dict([
        (u'timeSlotLCR', _E_AGCH_Specific_InformationResp_Item_LCR_TDD_timeSlotLCR),
        (u'midambleShiftLCR', _E_AGCH_Specific_InformationResp_Item_LCR_TDD_midambleShiftLCR),
        (u'tDD-ChannelisationCode', _E_AGCH_Specific_InformationResp_Item_LCR_TDD_tDD_ChannelisationCode),
        (u'iE-Extensions', _E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions),
        ])
    E_AGCH_Specific_InformationResp_Item_LCR_TDD._ext = []
    
    #-----< E-AGCH-Specific-InformationResp-ItemTDD-LCR-ExtIEs >-----#
    E_AGCH_Specific_InformationResp_ItemTDD_LCR_ExtIEs = CLASS(name=u'E-AGCH-Specific-InformationResp-ItemTDD-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_AGCH_Specific_InformationResp_ItemTDD_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-Specific-InformationResp-LCR >-----#
    E_HICH_Specific_InformationResp_LCR = SEQ(name=u'E-HICH-Specific-InformationResp-LCR', mode=MODE_TYPE)
    _E_HICH_Specific_InformationResp_LCR_e_HICH_Scheduled_InformationResp_LCR = SEQ_OF(name=u'e-HICH-Scheduled-InformationResp-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-Scheduled-InformationRespList-LCR-TDD')), opt=True)
    _E_HICH_Specific_InformationResp_LCR_e_HICH_non_Scheduled_InformationResp_LCR = SEQ(name=u'e-HICH-non-Scheduled-InformationResp-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-InformationResp-LCR')), opt=True)
    _E_HICH_Specific_InformationResp_LCR_e_HICH_TimeOffset_lcr = INT(name=u'e-HICH-TimeOffset-lcr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-TimeOffset-LCR')))
    _E_HICH_Specific_InformationResp_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_Specific_InformationResp_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id._const_tab = ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id_tab
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality._const_tab = ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality_tab
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue_tab
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_HICH_Specific_InformationResp_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id),
        (u'criticality', ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_Specific_InformationResp_LCR_iE_Extensions__item_._ext = None
    _E_HICH_Specific_InformationResp_LCR_iE_Extensions._cont = __E_HICH_Specific_InformationResp_LCR_iE_Extensions__item_
    _E_HICH_Specific_InformationResp_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_Specific_InformationResp_LCR._cont = ASN1Dict([
        (u'e-HICH-Scheduled-InformationResp-LCR', _E_HICH_Specific_InformationResp_LCR_e_HICH_Scheduled_InformationResp_LCR),
        (u'e-HICH-non-Scheduled-InformationResp-LCR', _E_HICH_Specific_InformationResp_LCR_e_HICH_non_Scheduled_InformationResp_LCR),
        (u'e-HICH-TimeOffset-lcr', _E_HICH_Specific_InformationResp_LCR_e_HICH_TimeOffset_lcr),
        (u'iE-Extensions', _E_HICH_Specific_InformationResp_LCR_iE_Extensions),
        ])
    E_HICH_Specific_InformationResp_LCR._ext = []
    
    #-----< E-HICH-Specific-InformationResp-LCR-ExtIEs >-----#
    E_HICH_Specific_InformationResp_LCR_ExtIEs = CLASS(name=u'E-HICH-Specific-InformationResp-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_HICH_Specific_InformationResp_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-Scheduled-InformationRespList-LCR-TDD >-----#
    E_HICH_Scheduled_InformationRespList_LCR_TDD = SEQ_OF(name=u'E-HICH-Scheduled-InformationRespList-LCR-TDD', mode=MODE_TYPE)
    _E_HICH_Scheduled_InformationRespList_LCR_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-Scheduled-InformationResp-Item-LCR-TDD')))
    E_HICH_Scheduled_InformationRespList_LCR_TDD._cont = _E_HICH_Scheduled_InformationRespList_LCR_TDD__item_
    E_HICH_Scheduled_InformationRespList_LCR_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< E-HICH-Scheduled-InformationResp-Item-LCR-TDD >-----#
    E_HICH_Scheduled_InformationResp_Item_LCR_TDD = SEQ(name=u'E-HICH-Scheduled-InformationResp-Item-LCR-TDD', mode=MODE_TYPE)
    _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_e_HICH_EI = INT(name=u'e-HICH-EI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-EI')))
    _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_e_HICH_Scheduled_InformationResp_LCR = SEQ(name=u'e-HICH-Scheduled-InformationResp-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-InformationResp-LCR')))
    _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id._const_tab = ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality._const_tab = ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id),
        (u'criticality', ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item_._ext = None
    _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions._cont = __E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item_
    _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_Scheduled_InformationResp_Item_LCR_TDD._cont = ASN1Dict([
        (u'e-HICH-EI', _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_e_HICH_EI),
        (u'e-HICH-Scheduled-InformationResp-LCR', _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_e_HICH_Scheduled_InformationResp_LCR),
        (u'iE-Extensions', _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions),
        ])
    E_HICH_Scheduled_InformationResp_Item_LCR_TDD._ext = []
    
    #-----< E-HICH-Scheduled-InformationResp-LCR-ExtIEs >-----#
    E_HICH_Scheduled_InformationResp_LCR_ExtIEs = CLASS(name=u'E-HICH-Scheduled-InformationResp-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_HICH_Scheduled_InformationResp_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-EI >-----#
    E_HICH_EI = INT(name=u'E-HICH-EI', mode=MODE_TYPE)
    E_HICH_EI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< E-HICH-InformationResp-LCR >-----#
    E_HICH_InformationResp_LCR = SEQ(name=u'E-HICH-InformationResp-LCR', mode=MODE_TYPE)
    _E_HICH_InformationResp_LCR_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _E_HICH_InformationResp_LCR_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _E_HICH_InformationResp_LCR_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_HICH_InformationResp_LCR_signatureSequenceGroupIndex = INT(name=u'signatureSequenceGroupIndex', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SignatureSequenceGroupIndex')))
    _E_HICH_InformationResp_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_InformationResp_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_HICH_InformationResp_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__id._const_tab = ____E_HICH_InformationResp_LCR_iE_Extensions__item__id_tab
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_HICH_InformationResp_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__criticality._const_tab = ____E_HICH_InformationResp_LCR_iE_Extensions__item__criticality_tab
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue_tab
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_HICH_InformationResp_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_HICH_InformationResp_LCR_iE_Extensions__item__id),
        (u'criticality', ___E_HICH_InformationResp_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_InformationResp_LCR_iE_Extensions__item_._ext = None
    _E_HICH_InformationResp_LCR_iE_Extensions._cont = __E_HICH_InformationResp_LCR_iE_Extensions__item_
    _E_HICH_InformationResp_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_InformationResp_LCR._cont = ASN1Dict([
        (u'timeSlotLCR', _E_HICH_InformationResp_LCR_timeSlotLCR),
        (u'midambleShiftLCR', _E_HICH_InformationResp_LCR_midambleShiftLCR),
        (u'tDD-ChannelisationCode', _E_HICH_InformationResp_LCR_tDD_ChannelisationCode),
        (u'signatureSequenceGroupIndex', _E_HICH_InformationResp_LCR_signatureSequenceGroupIndex),
        (u'iE-Extensions', _E_HICH_InformationResp_LCR_iE_Extensions),
        ])
    E_HICH_InformationResp_LCR._ext = []
    
    #-----< E-HICH-InformationResp-LCR-ExtIEs >-----#
    E_HICH_InformationResp_LCR_ExtIEs = CLASS(name=u'E-HICH-InformationResp-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_HICH_InformationResp_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-TimeOffset-LCR >-----#
    E_HICH_TimeOffset_LCR = INT(name=u'E-HICH-TimeOffset-LCR', mode=MODE_TYPE)
    E_HICH_TimeOffset_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=15)], ev=None, er=[])
    
    #-----< E-DCH-SubframeNumber-LCR >-----#
    E_DCH_SubframeNumber_LCR = ENUM(name=u'E-DCH-SubframeNumber-LCR', mode=MODE_TYPE)
    E_DCH_SubframeNumber_LCR._cont = ASN1Dict([(u's0', 0), (u's1', 1)])
    E_DCH_SubframeNumber_LCR._ext = None
    
    #-----< E-DCH-TimeslotResource-LCR >-----#
    E_DCH_TimeslotResource_LCR = BIT_STR(name=u'E-DCH-TimeslotResource-LCR', mode=MODE_TYPE)
    E_DCH_TimeslotResource_LCR._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< E-DCH-Non-Scheduled-Grant-Info-LCR >-----#
    E_DCH_Non_Scheduled_Grant_Info_LCR = SEQ(name=u'E-DCH-Non-Scheduled-Grant-Info-LCR', mode=MODE_TYPE)
    _E_DCH_Non_Scheduled_Grant_Info_LCR_timeslotResource_LCR = BIT_STR(name=u'timeslotResource-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TimeslotResource-LCR')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_powerResource = INT(name=u'powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerResource')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_subframenumber = ENUM(name=u'subframenumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-SubframeNumber-LCR')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_tddE_PUCH_Offset = INT(name=u'tddE-PUCH-Offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TddE-PUCH-Offset')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_tdd_ChannelisationCode = ENUM(name=u'tdd-ChannelisationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality_tab
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item_._ext = None
    _E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions._cont = __E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item_
    _E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Non_Scheduled_Grant_Info_LCR._cont = ASN1Dict([
        (u'timeslotResource-LCR', _E_DCH_Non_Scheduled_Grant_Info_LCR_timeslotResource_LCR),
        (u'powerResource', _E_DCH_Non_Scheduled_Grant_Info_LCR_powerResource),
        (u'repetitionPeriod', _E_DCH_Non_Scheduled_Grant_Info_LCR_repetitionPeriod),
        (u'repetitionLength', _E_DCH_Non_Scheduled_Grant_Info_LCR_repetitionLength),
        (u'subframenumber', _E_DCH_Non_Scheduled_Grant_Info_LCR_subframenumber),
        (u'tddE-PUCH-Offset', _E_DCH_Non_Scheduled_Grant_Info_LCR_tddE_PUCH_Offset),
        (u'tdd-ChannelisationCode', _E_DCH_Non_Scheduled_Grant_Info_LCR_tdd_ChannelisationCode),
        (u'iE-Extensions', _E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions),
        ])
    E_DCH_Non_Scheduled_Grant_Info_LCR._ext = []
    
    #-----< E-DCH-Non-Scheduled-Grant-Info-LCR-ExtIEs >-----#
    E_DCH_Non_Scheduled_Grant_Info_LCR_ExtIEs = CLASS(name=u'E-DCH-Non-Scheduled-Grant-Info-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Non_Scheduled_Grant_Info_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Enabling-Delay >-----#
    Enabling_Delay = ENUM(name=u'Enabling-Delay', mode=MODE_TYPE)
    Enabling_Delay._cont = ASN1Dict([(u'v0', 0), (u'v1', 1), (u'v2', 2), (u'v4', 3), (u'v8', 4), (u'v16', 5), (u'v32', 6), (u'v64', 7), (u'v128', 8)])
    Enabling_Delay._ext = None
    
    #-----< Ext-Reference-E-TFCI-PO >-----#
    Ext_Reference_E_TFCI_PO = INT(name=u'Ext-Reference-E-TFCI-PO', mode=MODE_TYPE)
    Ext_Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30, ub=31)], ev=[], er=[])
    
    #-----< ExtendedPropagationDelay >-----#
    ExtendedPropagationDelay = INT(name=u'ExtendedPropagationDelay', mode=MODE_TYPE)
    ExtendedPropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=255, ub=1023)], ev=None, er=[])
    
    #-----< Extended-RNC-ID >-----#
    Extended_RNC_ID = INT(name=u'Extended-RNC-ID', mode=MODE_TYPE)
    Extended_RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< Extended-RNTI >-----#
    Extended_RNTI = INT(name=u'Extended-RNTI', mode=MODE_TYPE)
    Extended_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1048576, ub=4194303)], ev=[], er=[])
    
    #-----< Extended-Round-Trip-Time-Value >-----#
    Extended_Round_Trip_Time_Value = INT(name=u'Extended-Round-Trip-Time-Value', mode=MODE_TYPE)
    Extended_Round_Trip_Time_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32767, ub=103041)], ev=None, er=[])
    
    #-----< Extended-S-RNTI-Group >-----#
    Extended_S_RNTI_Group = SEQ(name=u'Extended-S-RNTI-Group', mode=MODE_TYPE)
    _Extended_S_RNTI_Group_extended_sRNTI = INT(name=u'extended-sRNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    _Extended_S_RNTI_Group_extended_sRNTI_BitMaskIndex = ENUM(name=u'extended-sRNTI-BitMaskIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Extended_S_RNTI_Group_extended_sRNTI_BitMaskIndex._cont = ASN1Dict([(u'b1', 0), (u'b2', 1), (u'b3', 2), (u'b4', 3), (u'b5', 4), (u'b6', 5), (u'b7', 6), (u'b8', 7), (u'b9', 8), (u'b10', 9), (u'b11', 10), (u'b12', 11), (u'b13', 12), (u'b14', 13), (u'b15', 14), (u'b16', 15), (u'b17', 16), (u'b18', 17), (u'b19', 18), (u'b20', 19), (u'b21', 20)])
    _Extended_S_RNTI_Group_extended_sRNTI_BitMaskIndex._ext = []
    Extended_S_RNTI_Group._cont = ASN1Dict([
        (u'extended-sRNTI', _Extended_S_RNTI_Group_extended_sRNTI),
        (u'extended-sRNTI-BitMaskIndex', _Extended_S_RNTI_Group_extended_sRNTI_BitMaskIndex),
        ])
    Extended_S_RNTI_Group._ext = None
    
    #-----< ExtendedAffectedUEInformationForMBMS >-----#
    ExtendedAffectedUEInformationForMBMS = SEQ_OF(name=u'ExtendedAffectedUEInformationForMBMS', mode=MODE_TYPE)
    _ExtendedAffectedUEInformationForMBMS__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ExtendedAffectedUEInformationForMBMS._cont = _ExtendedAffectedUEInformationForMBMS__item_
    ExtendedAffectedUEInformationForMBMS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4096)], ev=None, er=[])
    
    #-----< Ext-Max-Bits-MACe-PDU-non-scheduled >-----#
    Ext_Max_Bits_MACe_PDU_non_scheduled = INT(name=u'Ext-Max-Bits-MACe-PDU-non-scheduled', mode=MODE_TYPE)
    Ext_Max_Bits_MACe_PDU_non_scheduled._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=19983, ub=22978)], ev=[], er=[ASN1RangeInt(lb=22979, ub=34507)])
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-LCR >-----#
    E_DCH_Semi_PersistentScheduling_Information_LCR = SEQ(name=u'E-DCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE)
    _E_DCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR = SEQ_OF(name=u'repetition-Period-List-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Repetition-Period-List-LCR')))
    _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Indicator = BIT_STR(name=u'e-DCH-SPS-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-SPS-Indicator')))
    _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Reservation_Indicator = ENUM(name=u'e-DCH-SPS-Reservation-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SPS-Reservation-Indicator')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._cont = __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_
    _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Semi_PersistentScheduling_Information_LCR._cont = ASN1Dict([
        (u'repetition-Period-List-LCR', _E_DCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR),
        (u'e-DCH-SPS-Indicator', _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Indicator),
        (u'e-DCH-SPS-Reservation-Indicator', _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Reservation_Indicator),
        (u'iE-Extensions', _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions),
        ])
    E_DCH_Semi_PersistentScheduling_Information_LCR._ext = []
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs >-----#
    E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs = CLASS(name=u'E-DCH-Semi-PersistentScheduling-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-SPS-Indicator >-----#
    E_DCH_SPS_Indicator = BIT_STR(name=u'E-DCH-SPS-Indicator', mode=MODE_TYPE)
    E_DCH_SPS_Indicator._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR >-----#
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name=u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR = SEQ_OF(name=u'repetition-Period-List-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Repetition-Period-List-LCR')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Indicator = BIT_STR(name=u'e-DCH-SPS-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-SPS-Indicator')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Reservation_Indicator = ENUM(name=u'e-DCH-SPS-Reservation-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SPS-Reservation-Indicator')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._cont = __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_
    _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR._cont = ASN1Dict([
        (u'repetition-Period-List-LCR', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR),
        (u'e-DCH-SPS-Indicator', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Indicator),
        (u'e-DCH-SPS-Reservation-Indicator', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Reservation_Indicator),
        (u'iE-Extensions', _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions),
        ])
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR._ext = []
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs >-----#
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs = CLASS(name=u'E-DCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR = SEQ(name=u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_TYPE)
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_E_DCH_SPS_resource = SEQ(name=u'initial-E-DCH-SPS-resource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Initial-E-DCH-SPS-resource')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_e_DCH_SPS_HICH_Information = SEQ(name=u'e-DCH-SPS-HICH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-SPS-HICH-Information')), opt=True)
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._cont = __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_
    _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR._cont = ASN1Dict([
        (u'initial-E-DCH-SPS-resource', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_E_DCH_SPS_resource),
        (u'e-DCH-SPS-HICH-Information', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_e_DCH_SPS_HICH_Information),
        (u'iE-Extensions', _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions),
        ])
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR._ext = []
    
    #-----< E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs >-----#
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs = CLASS(name=u'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-SPS-HICH-Information >-----#
    E_DCH_SPS_HICH_Information = SEQ(name=u'E-DCH-SPS-HICH-Information', mode=MODE_TYPE)
    _E_DCH_SPS_HICH_Information_e_HICH_Configuration = CHOICE(name=u'e-HICH-Configuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-Configuration')))
    _E_DCH_SPS_HICH_Information_signatureSequenceGroupIndex = INT(name=u'signatureSequenceGroupIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SignatureSequenceGroupIndex')))
    _E_DCH_SPS_HICH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DCH_SPS_HICH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_DCH_SPS_HICH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_SPS_HICH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__id._const_tab = ____E_DCH_SPS_HICH_Information_iE_Extensions__item__id_tab
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality._const_tab = ____E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality_tab
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue_tab
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_DCH_SPS_HICH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_DCH_SPS_HICH_Information_iE_Extensions__item__id),
        (u'criticality', ___E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DCH_SPS_HICH_Information_iE_Extensions__item_._ext = None
    _E_DCH_SPS_HICH_Information_iE_Extensions._cont = __E_DCH_SPS_HICH_Information_iE_Extensions__item_
    _E_DCH_SPS_HICH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DCH_SPS_HICH_Information._cont = ASN1Dict([
        (u'e-HICH-Configuration', _E_DCH_SPS_HICH_Information_e_HICH_Configuration),
        (u'signatureSequenceGroupIndex', _E_DCH_SPS_HICH_Information_signatureSequenceGroupIndex),
        (u'iE-Extensions', _E_DCH_SPS_HICH_Information_iE_Extensions),
        ])
    E_DCH_SPS_HICH_Information._ext = []
    
    #-----< E-DCH-SPS-HICH-Information-ExtIEs >-----#
    E_DCH_SPS_HICH_Information_ExtIEs = CLASS(name=u'E-DCH-SPS-HICH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_DCH_SPS_HICH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-HICH-Configuration >-----#
    E_HICH_Configuration = CHOICE(name=u'E-HICH-Configuration', mode=MODE_TYPE)
    _E_HICH_Configuration_same_As_Scheduled_E_HICH = SEQ(name=u'same-As-Scheduled-E-HICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Same-As-Scheduled-E-HICH')))
    _E_HICH_Configuration_explicit = SEQ(name=u'explicit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-InformationResp-ExplicitConfiguration-LCR')))
    E_HICH_Configuration._cont = ASN1Dict([
        (u'same-As-Scheduled-E-HICH', _E_HICH_Configuration_same_As_Scheduled_E_HICH),
        (u'explicit', _E_HICH_Configuration_explicit),
        ])
    E_HICH_Configuration._ext = []
    
    #-----< E-HICH-InformationResp-ExplicitConfiguration-LCR >-----#
    E_HICH_InformationResp_ExplicitConfiguration_LCR = SEQ(name=u'E-HICH-InformationResp-ExplicitConfiguration-LCR', mode=MODE_TYPE)
    _E_HICH_InformationResp_ExplicitConfiguration_LCR_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _E_HICH_InformationResp_ExplicitConfiguration_LCR_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _E_HICH_InformationResp_ExplicitConfiguration_LCR_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id._const_tab = ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id_tab
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id._const_tab_at = None
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality._const_tab = ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality_tab
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue._const_tab = ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue_tab
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id),
        (u'criticality', ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue),
        ])
    __E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item_._ext = None
    _E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions._cont = __E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item_
    _E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_HICH_InformationResp_ExplicitConfiguration_LCR._cont = ASN1Dict([
        (u'timeSlotLCR', _E_HICH_InformationResp_ExplicitConfiguration_LCR_timeSlotLCR),
        (u'midambleShiftLCR', _E_HICH_InformationResp_ExplicitConfiguration_LCR_midambleShiftLCR),
        (u'tDD-ChannelisationCode', _E_HICH_InformationResp_ExplicitConfiguration_LCR_tDD_ChannelisationCode),
        (u'iE-Extensions', _E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions),
        ])
    E_HICH_InformationResp_ExplicitConfiguration_LCR._ext = []
    
    #-----< E-HICH-InformationResp-ExplicitConfiguration-LCR-ExtIEs >-----#
    E_HICH_InformationResp_ExplicitConfiguration_LCR_ExtIEs = CLASS(name=u'E-HICH-InformationResp-ExplicitConfiguration-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    E_HICH_InformationResp_ExplicitConfiguration_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-FlowControlInformation >-----#
    FACH_FlowControlInformation = SEQ_OF(name=u'FACH-FlowControlInformation', mode=MODE_TYPE)
    _FACH_FlowControlInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FACH-FlowControlInformationItem')))
    FACH_FlowControlInformation._cont = _FACH_FlowControlInformation__item_
    FACH_FlowControlInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< FACH-FlowControlInformationItem >-----#
    FACH_FlowControlInformationItem = SEQ(name=u'FACH-FlowControlInformationItem', mode=MODE_TYPE)
    _FACH_FlowControlInformationItem_fACH_SchedulingPriority = INT(name=u'fACH-SchedulingPriority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _FACH_FlowControlInformationItem_mAC_c_sh_SDU_Lengths = SEQ_OF(name=u'mAC-c-sh-SDU-Lengths', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-c-sh-SDU-LengthList')))
    _FACH_FlowControlInformationItem_fACH_InitialWindowSize = INT(name=u'fACH-InitialWindowSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FACH-InitialWindowSize')))
    _FACH_FlowControlInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_FlowControlInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FACH_FlowControlInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FACH_FlowControlInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_FlowControlInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_FlowControlInformationItem_iE_Extensions__item__id._const_tab = ____FACH_FlowControlInformationItem_iE_Extensions__item__id_tab
    ___FACH_FlowControlInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___FACH_FlowControlInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___FACH_FlowControlInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FACH_FlowControlInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_FlowControlInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_FlowControlInformationItem_iE_Extensions__item__criticality._const_tab = ____FACH_FlowControlInformationItem_iE_Extensions__item__criticality_tab
    ___FACH_FlowControlInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FACH_FlowControlInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue._const_tab = ____FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue_tab
    ___FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FACH_FlowControlInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FACH_FlowControlInformationItem_iE_Extensions__item__id),
        (u'criticality', ___FACH_FlowControlInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue),
        ])
    __FACH_FlowControlInformationItem_iE_Extensions__item_._ext = None
    _FACH_FlowControlInformationItem_iE_Extensions._cont = __FACH_FlowControlInformationItem_iE_Extensions__item_
    _FACH_FlowControlInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_FlowControlInformationItem._cont = ASN1Dict([
        (u'fACH-SchedulingPriority', _FACH_FlowControlInformationItem_fACH_SchedulingPriority),
        (u'mAC-c-sh-SDU-Lengths', _FACH_FlowControlInformationItem_mAC_c_sh_SDU_Lengths),
        (u'fACH-InitialWindowSize', _FACH_FlowControlInformationItem_fACH_InitialWindowSize),
        (u'iE-Extensions', _FACH_FlowControlInformationItem_iE_Extensions),
        ])
    FACH_FlowControlInformationItem._ext = []
    
    #-----< FACH-FlowControlInformationItem-ExtIEs >-----#
    FACH_FlowControlInformationItem_ExtIEs = CLASS(name=u'FACH-FlowControlInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FACH_FlowControlInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-InitialWindowSize >-----#
    FACH_InitialWindowSize = INT(name=u'FACH-InitialWindowSize', mode=MODE_TYPE)
    FACH_InitialWindowSize._cont = ASN1Dict([(u'unlimited', 255)])
    FACH_InitialWindowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< FACH-InformationList >-----#
    FACH_InformationList = SEQ_OF(name=u'FACH-InformationList', mode=MODE_TYPE)
    _FACH_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FACH-InformationItem')))
    FACH_InformationList._cont = _FACH_InformationList__item_
    FACH_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< FACH-InformationItem >-----#
    FACH_InformationItem = SEQ(name=u'FACH-InformationItem', mode=MODE_TYPE)
    _FACH_InformationItem_transportFormatSet = SEQ(name=u'transportFormatSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _FACH_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FACH_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FACH_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InformationItem_iE_Extensions__item__id._const_tab = ____FACH_InformationItem_iE_Extensions__item__id_tab
    ___FACH_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___FACH_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___FACH_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FACH_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InformationItem_iE_Extensions__item__criticality._const_tab = ____FACH_InformationItem_iE_Extensions__item__criticality_tab
    ___FACH_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FACH_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FACH_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FACH_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____FACH_InformationItem_iE_Extensions__item__extensionValue_tab
    ___FACH_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FACH_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FACH_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FACH_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___FACH_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___FACH_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __FACH_InformationItem_iE_Extensions__item_._ext = None
    _FACH_InformationItem_iE_Extensions._cont = __FACH_InformationItem_iE_Extensions__item_
    _FACH_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_InformationItem._cont = ASN1Dict([
        (u'transportFormatSet', _FACH_InformationItem_transportFormatSet),
        (u'iE-Extensions', _FACH_InformationItem_iE_Extensions),
        ])
    FACH_InformationItem._ext = []
    
    #-----< FACH-InformationItem-ExtIEs >-----#
    FACH_InformationItem_ExtIEs = CLASS(name=u'FACH-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FACH_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Fast-Reconfiguration-Mode >-----#
    Fast_Reconfiguration_Mode = ENUM(name=u'Fast-Reconfiguration-Mode', mode=MODE_TYPE)
    Fast_Reconfiguration_Mode._cont = ASN1Dict([(u'fast', 0)])
    Fast_Reconfiguration_Mode._ext = []
    
    #-----< Fast-Reconfiguration-Permission >-----#
    Fast_Reconfiguration_Permission = ENUM(name=u'Fast-Reconfiguration-Permission', mode=MODE_TYPE)
    Fast_Reconfiguration_Permission._cont = ASN1Dict([(u'allowed', 0)])
    Fast_Reconfiguration_Permission._ext = []
    
    #-----< Fast-TTI-switching-Mode-synchronized >-----#
    Fast_TTI_switching_Mode_synchronized = CHOICE(name=u'Fast-TTI-switching-Mode-synchronized', mode=MODE_TYPE)
    _Fast_TTI_switching_Mode_synchronized_mode1 = NULL(name=u'mode1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Mode1-Ind')))
    _Fast_TTI_switching_Mode_synchronized_mode2 = INT(name=u'mode2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    Fast_TTI_switching_Mode_synchronized._cont = ASN1Dict([
        (u'mode1', _Fast_TTI_switching_Mode_synchronized_mode1),
        (u'mode2', _Fast_TTI_switching_Mode_synchronized_mode2),
        ])
    Fast_TTI_switching_Mode_synchronized._ext = None
    
    #-----< Fast-TTI-switching-Mode-unsynchronized >-----#
    Fast_TTI_switching_Mode_unsynchronized = CHOICE(name=u'Fast-TTI-switching-Mode-unsynchronized', mode=MODE_TYPE)
    _Fast_TTI_switching_Mode_unsynchronized_mode1 = ENUM(name=u'mode1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ActivationDelay')))
    _Fast_TTI_switching_Mode_unsynchronized_mode2 = INT(name=u'mode2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    Fast_TTI_switching_Mode_unsynchronized._cont = ASN1Dict([
        (u'mode1', _Fast_TTI_switching_Mode_unsynchronized_mode1),
        (u'mode2', _Fast_TTI_switching_Mode_unsynchronized_mode2),
        ])
    Fast_TTI_switching_Mode_unsynchronized._ext = None
    
    #-----< Fast-TTI-switching-Mode-Supported >-----#
    Fast_TTI_switching_Mode_Supported = ENUM(name=u'Fast-TTI-switching-Mode-Supported', mode=MODE_TYPE)
    Fast_TTI_switching_Mode_Supported._cont = ASN1Dict([(u'mode1', 0), (u'mode2', 1)])
    Fast_TTI_switching_Mode_Supported._ext = None
    
    #-----< FDD-DCHs-to-Modify >-----#
    FDD_DCHs_to_Modify = SEQ_OF(name=u'FDD-DCHs-to-Modify', mode=MODE_TYPE)
    _FDD_DCHs_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-ModifyItem')))
    FDD_DCHs_to_Modify._cont = _FDD_DCHs_to_Modify__item_
    FDD_DCHs_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< FDD-DCHs-to-ModifyItem >-----#
    FDD_DCHs_to_ModifyItem = SEQ(name=u'FDD-DCHs-to-ModifyItem', mode=MODE_TYPE)
    _FDD_DCHs_to_ModifyItem_ul_FP_Mode = ENUM(name=u'ul-FP-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-FP-Mode')), opt=True)
    _FDD_DCHs_to_ModifyItem_toAWS = INT(name=u'toAWS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWS')), opt=True)
    _FDD_DCHs_to_ModifyItem_toAWE = INT(name=u'toAWE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWE')), opt=True)
    _FDD_DCHs_to_ModifyItem_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _FDD_DCHs_to_ModifyItem_dCH_SpecificInformationList = SEQ_OF(name=u'dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-ModifySpecificInformationList')))
    _FDD_DCHs_to_ModifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_DCHs_to_ModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab = ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab = ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab = ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FDD_DCHs_to_ModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id),
        (u'criticality', ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue),
        ])
    __FDD_DCHs_to_ModifyItem_iE_Extensions__item_._ext = None
    _FDD_DCHs_to_ModifyItem_iE_Extensions._cont = __FDD_DCHs_to_ModifyItem_iE_Extensions__item_
    _FDD_DCHs_to_ModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_DCHs_to_ModifyItem._cont = ASN1Dict([
        (u'ul-FP-Mode', _FDD_DCHs_to_ModifyItem_ul_FP_Mode),
        (u'toAWS', _FDD_DCHs_to_ModifyItem_toAWS),
        (u'toAWE', _FDD_DCHs_to_ModifyItem_toAWE),
        (u'transportBearerRequestIndicator', _FDD_DCHs_to_ModifyItem_transportBearerRequestIndicator),
        (u'dCH-SpecificInformationList', _FDD_DCHs_to_ModifyItem_dCH_SpecificInformationList),
        (u'iE-Extensions', _FDD_DCHs_to_ModifyItem_iE_Extensions),
        ])
    FDD_DCHs_to_ModifyItem._ext = []
    
    #-----< FDD-DCHs-to-ModifyItem-ExtIEs >-----#
    FDD_DCHs_to_ModifyItem_ExtIEs = CLASS(name=u'FDD-DCHs-to-ModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _FDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    FDD_DCHs_to_ModifyItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _FDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< FDD-DCHs-to-ModifySpecificInformationList >-----#
    FDD_DCHs_to_ModifySpecificInformationList = SEQ_OF(name=u'FDD-DCHs-to-ModifySpecificInformationList', mode=MODE_TYPE)
    _FDD_DCHs_to_ModifySpecificInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-ModifySpecificItem')))
    FDD_DCHs_to_ModifySpecificInformationList._cont = _FDD_DCHs_to_ModifySpecificInformationList__item_
    FDD_DCHs_to_ModifySpecificInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< FDD-DCHs-to-ModifySpecificItem >-----#
    FDD_DCHs_to_ModifySpecificItem = SEQ(name=u'FDD-DCHs-to-ModifySpecificItem', mode=MODE_TYPE)
    _FDD_DCHs_to_ModifySpecificItem_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _FDD_DCHs_to_ModifySpecificItem_ul_TransportformatSet = SEQ(name=u'ul-TransportformatSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')), opt=True)
    _FDD_DCHs_to_ModifySpecificItem_dl_TransportformatSet = SEQ(name=u'dl-TransportformatSet', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')), opt=True)
    _FDD_DCHs_to_ModifySpecificItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _FDD_DCHs_to_ModifySpecificItem_frameHandlingPriority = INT(name=u'frameHandlingPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameHandlingPriority')), opt=True)
    _FDD_DCHs_to_ModifySpecificItem_not_Used_dRACControl = NULL(name=u'not-Used-dRACControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FDD_DCHs_to_ModifySpecificItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Unidirectional-DCH-Indicator')))
    ____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 526), (u'criticality', u'reject'), (u'Extension', _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id._const_tab = ____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id._const_tab_at = None
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality._const_tab = ____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue._const_tab = ____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id),
        (u'criticality', ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue),
        ])
    __FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_._ext = None
    _FDD_DCHs_to_ModifySpecificItem_iE_Extensions._cont = __FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_
    _FDD_DCHs_to_ModifySpecificItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_DCHs_to_ModifySpecificItem._cont = ASN1Dict([
        (u'dCH-ID', _FDD_DCHs_to_ModifySpecificItem_dCH_ID),
        (u'ul-TransportformatSet', _FDD_DCHs_to_ModifySpecificItem_ul_TransportformatSet),
        (u'dl-TransportformatSet', _FDD_DCHs_to_ModifySpecificItem_dl_TransportformatSet),
        (u'allocationRetentionPriority', _FDD_DCHs_to_ModifySpecificItem_allocationRetentionPriority),
        (u'frameHandlingPriority', _FDD_DCHs_to_ModifySpecificItem_frameHandlingPriority),
        (u'not-Used-dRACControl', _FDD_DCHs_to_ModifySpecificItem_not_Used_dRACControl),
        (u'iE-Extensions', _FDD_DCHs_to_ModifySpecificItem_iE_Extensions),
        ])
    FDD_DCHs_to_ModifySpecificItem._ext = []
    
    #-----< FDD-DCHs-to-ModifySpecificItem-ExtIEs >-----#
    FDD_DCHs_to_ModifySpecificItem_ExtIEs = CLASS(name=u'FDD-DCHs-to-ModifySpecificItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Unidirectional-DCH-Indicator')))
    FDD_DCHs_to_ModifySpecificItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 526), (u'criticality', u'reject'), (u'Extension', _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< FDD-DL-ChannelisationCodeNumber >-----#
    FDD_DL_ChannelisationCodeNumber = INT(name=u'FDD-DL-ChannelisationCodeNumber', mode=MODE_TYPE)
    FDD_DL_ChannelisationCodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< FDD-DL-CodeInformation >-----#
    FDD_DL_CodeInformation = SEQ_OF(name=u'FDD-DL-CodeInformation', mode=MODE_TYPE)
    _FDD_DL_CodeInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformationItem')))
    FDD_DL_CodeInformation._cont = _FDD_DL_CodeInformation__item_
    FDD_DL_CodeInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< FDD-DL-CodeInformationItem >-----#
    FDD_DL_CodeInformationItem = SEQ(name=u'FDD-DL-CodeInformationItem', mode=MODE_TYPE)
    _FDD_DL_CodeInformationItem_dl_ScramblingCode = INT(name=u'dl-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ScramblingCode')))
    _FDD_DL_CodeInformationItem_fDD_DL_ChannelisationCodeNumber = INT(name=u'fDD-DL-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _FDD_DL_CodeInformationItem_transmission_Gap_Pattern_Sequence_ScramblingCode_Information = ENUM(name=u'transmission-Gap-Pattern-Sequence-ScramblingCode-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-ScramblingCode-Information')), opt=True)
    _FDD_DL_CodeInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FDD_DL_CodeInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id._const_tab = ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality._const_tab = ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue._const_tab = ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FDD_DL_CodeInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FDD_DL_CodeInformationItem_iE_Extensions__item__id),
        (u'criticality', ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue),
        ])
    __FDD_DL_CodeInformationItem_iE_Extensions__item_._ext = None
    _FDD_DL_CodeInformationItem_iE_Extensions._cont = __FDD_DL_CodeInformationItem_iE_Extensions__item_
    _FDD_DL_CodeInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FDD_DL_CodeInformationItem._cont = ASN1Dict([
        (u'dl-ScramblingCode', _FDD_DL_CodeInformationItem_dl_ScramblingCode),
        (u'fDD-DL-ChannelisationCodeNumber', _FDD_DL_CodeInformationItem_fDD_DL_ChannelisationCodeNumber),
        (u'transmission-Gap-Pattern-Sequence-ScramblingCode-Information', _FDD_DL_CodeInformationItem_transmission_Gap_Pattern_Sequence_ScramblingCode_Information),
        (u'iE-Extensions', _FDD_DL_CodeInformationItem_iE_Extensions),
        ])
    FDD_DL_CodeInformationItem._ext = []
    
    #-----< FDD-DL-CodeInformationItem-ExtIEs >-----#
    FDD_DL_CodeInformationItem_ExtIEs = CLASS(name=u'FDD-DL-CodeInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FDD_DL_CodeInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FDD-TPC-DownlinkStepSize >-----#
    FDD_TPC_DownlinkStepSize = ENUM(name=u'FDD-TPC-DownlinkStepSize', mode=MODE_TYPE)
    FDD_TPC_DownlinkStepSize._cont = ASN1Dict([(u'step-size0-5', 0), (u'step-size1', 1), (u'step-size1-5', 2), (u'step-size2', 3)])
    FDD_TPC_DownlinkStepSize._ext = []
    
    #-----< SchedulingPriorityIndicator >-----#
    SchedulingPriorityIndicator = INT(name=u'SchedulingPriorityIndicator', mode=MODE_TYPE)
    SchedulingPriorityIndicator._cont = ASN1Dict([(u'lowest', 0), (u'highest', 15)])
    SchedulingPriorityIndicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< F-DPCH-Info >-----#
    F_DPCH_Info = SEQ(name=u'F-DPCH-Info', mode=MODE_TYPE)
    _F_DPCH_Info_f_DPCH_SlotFormat = INT(name=u'f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _F_DPCH_Info_fdd_dl_ChannelisationCodeNumber = INT(name=u'fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _F_DPCH_Info_extended_E_DPCCH_PO = INT(name=u'extended-E-DPCCH-PO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extended-E-DPCCH-PO')), opt=True)
    _F_DPCH_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____F_DPCH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_iE_Extensions__item__id._const_tab = ____F_DPCH_Info_iE_Extensions__item__id_tab
    ___F_DPCH_Info_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___F_DPCH_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____F_DPCH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Info_iE_Extensions__item__criticality_tab
    ___F_DPCH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___F_DPCH_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___F_DPCH_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab
    ___F_DPCH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___F_DPCH_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __F_DPCH_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___F_DPCH_Info_iE_Extensions__item__id),
        (u'criticality', ___F_DPCH_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___F_DPCH_Info_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Info_iE_Extensions__item_._ext = None
    _F_DPCH_Info_iE_Extensions._cont = __F_DPCH_Info_iE_Extensions__item_
    _F_DPCH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Info._cont = ASN1Dict([
        (u'f-DPCH-SlotFormat', _F_DPCH_Info_f_DPCH_SlotFormat),
        (u'fdd-dl-ChannelisationCodeNumber', _F_DPCH_Info_fdd_dl_ChannelisationCodeNumber),
        (u'extended-E-DPCCH-PO', _F_DPCH_Info_extended_E_DPCCH_PO),
        (u'iE-Extensions', _F_DPCH_Info_iE_Extensions),
        ])
    F_DPCH_Info._ext = []
    
    #-----< F-DPCH-Info-ExtIEs >-----#
    F_DPCH_Info_ExtIEs = CLASS(name=u'F-DPCH-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    F_DPCH_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-Info-To-Modify >-----#
    F_DPCH_Info_To_Modify = SEQ(name=u'F-DPCH-Info-To-Modify', mode=MODE_TYPE)
    _F_DPCH_Info_To_Modify_f_DPCH_SlotFormat = INT(name=u'f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _F_DPCH_Info_To_Modify_fdd_dl_ChannelisationCodeNumber = INT(name=u'fdd-dl-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _F_DPCH_Info_To_Modify_extended_E_DPCCH_PO = INT(name=u'extended-E-DPCCH-PO', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extended-E-DPCCH-PO')), opt=True)
    _F_DPCH_Info_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Info_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id._const_tab = ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __F_DPCH_Info_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___F_DPCH_Info_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Info_To_Modify_iE_Extensions__item_._ext = None
    _F_DPCH_Info_To_Modify_iE_Extensions._cont = __F_DPCH_Info_To_Modify_iE_Extensions__item_
    _F_DPCH_Info_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Info_To_Modify._cont = ASN1Dict([
        (u'f-DPCH-SlotFormat', _F_DPCH_Info_To_Modify_f_DPCH_SlotFormat),
        (u'fdd-dl-ChannelisationCodeNumber', _F_DPCH_Info_To_Modify_fdd_dl_ChannelisationCodeNumber),
        (u'extended-E-DPCCH-PO', _F_DPCH_Info_To_Modify_extended_E_DPCCH_PO),
        (u'iE-Extensions', _F_DPCH_Info_To_Modify_iE_Extensions),
        ])
    F_DPCH_Info_To_Modify._ext = []
    
    #-----< F-DPCH-Info-To-Modify-ExtIEs >-----#
    F_DPCH_Info_To_Modify_ExtIEs = CLASS(name=u'F-DPCH-Info-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    F_DPCH_Info_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-SlotFormat >-----#
    F_DPCH_SlotFormat = INT(name=u'F-DPCH-SlotFormat', mode=MODE_TYPE)
    F_DPCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    
    #-----< F-DPCH-SlotFormatSupportRequest >-----#
    F_DPCH_SlotFormatSupportRequest = NULL(name=u'F-DPCH-SlotFormatSupportRequest', mode=MODE_TYPE)
    
    #-----< FirstRLS-Indicator >-----#
    FirstRLS_Indicator = ENUM(name=u'FirstRLS-Indicator', mode=MODE_TYPE)
    FirstRLS_Indicator._cont = ASN1Dict([(u'first-RLS', 0), (u'not-first-RLS', 1)])
    FirstRLS_Indicator._ext = None
    
    #-----< FNReportingIndicator >-----#
    FNReportingIndicator = ENUM(name=u'FNReportingIndicator', mode=MODE_TYPE)
    FNReportingIndicator._cont = ASN1Dict([(u'fN-reporting-required', 0), (u'fN-reporting-not-required', 1)])
    FNReportingIndicator._ext = None
    
    #-----< FPACH-Information >-----#
    FPACH_Information = SEQ(name=u'FPACH-Information', mode=MODE_TYPE)
    _FPACH_Information_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _FPACH_Information_tDD_ChannelisationCodeLCR = SEQ(name=u'tDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _FPACH_Information_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _FPACH_Information_wT = INT(name=u'wT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _FPACH_Information_wT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    FPACH_Information._cont = ASN1Dict([
        (u'timeSlotLCR', _FPACH_Information_timeSlotLCR),
        (u'tDD-ChannelisationCodeLCR', _FPACH_Information_tDD_ChannelisationCodeLCR),
        (u'midambleShiftLCR', _FPACH_Information_midambleShiftLCR),
        (u'wT', _FPACH_Information_wT),
        ])
    FPACH_Information._ext = []
    
    #-----< FTPICH-Information >-----#
    FTPICH_Information = SEQ(name=u'FTPICH-Information', mode=MODE_TYPE)
    _FTPICH_Information_fTPICH_Offset = INT(name=u'fTPICH-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Offset')))
    _FTPICH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FTPICH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_iE_Extensions__item__id._const_tab = ____FTPICH_Information_iE_Extensions__item__id_tab
    ___FTPICH_Information_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___FTPICH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FTPICH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FTPICH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FTPICH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FTPICH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FTPICH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FTPICH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FTPICH_Information_iE_Extensions__item__id),
        (u'criticality', ___FTPICH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___FTPICH_Information_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_iE_Extensions__item_._ext = None
    _FTPICH_Information_iE_Extensions._cont = __FTPICH_Information_iE_Extensions__item_
    _FTPICH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information._cont = ASN1Dict([
        (u'fTPICH-Offset', _FTPICH_Information_fTPICH_Offset),
        (u'iE-Extensions', _FTPICH_Information_iE_Extensions),
        ])
    FTPICH_Information._ext = []
    
    #-----< FTPICH-Information-ExtIEs >-----#
    FTPICH_Information_ExtIEs = CLASS(name=u'FTPICH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FTPICH-SlotFormat >-----#
    FTPICH_SlotFormat = INT(name=u'FTPICH-SlotFormat', mode=MODE_TYPE)
    FTPICH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=[], er=[])
    
    #-----< FTPICH-Offset >-----#
    FTPICH_Offset = INT(name=u'FTPICH-Offset', mode=MODE_TYPE)
    FTPICH_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=149)], ev=None, er=[])
    
    #-----< FTPICH-Information-Removal >-----#
    FTPICH_Information_Removal = ENUM(name=u'FTPICH-Information-Removal', mode=MODE_TYPE)
    FTPICH_Information_Removal._cont = ASN1Dict([(u'remove', 0)])
    FTPICH_Information_Removal._ext = []
    
    #-----< FTPICH-Information-To-Modify >-----#
    FTPICH_Information_To_Modify = SEQ(name=u'FTPICH-Information-To-Modify', mode=MODE_TYPE)
    _FTPICH_Information_To_Modify_fTPICH_Offset = INT(name=u'fTPICH-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Offset')), opt=True)
    _FTPICH_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id._const_tab = ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FTPICH_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FTPICH_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_To_Modify_iE_Extensions__item_._ext = None
    _FTPICH_Information_To_Modify_iE_Extensions._cont = __FTPICH_Information_To_Modify_iE_Extensions__item_
    _FTPICH_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information_To_Modify._cont = ASN1Dict([
        (u'fTPICH-Offset', _FTPICH_Information_To_Modify_fTPICH_Offset),
        (u'iE-Extensions', _FTPICH_Information_To_Modify_iE_Extensions),
        ])
    FTPICH_Information_To_Modify._ext = []
    
    #-----< FTPICH-Information-To-Modify-ExtIEs >-----#
    FTPICH_Information_To_Modify_ExtIEs = CLASS(name=u'FTPICH-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FTPICH-Information-Reconf >-----#
    FTPICH_Information_Reconf = SEQ(name=u'FTPICH-Information-Reconf', mode=MODE_TYPE)
    _FTPICH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information')))
    _FTPICH_Information_Reconf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_Reconf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Reconf_iE_Extensions__item__id._const_tab = ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab
    ___FTPICH_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_Reconf_iE_Extensions__item__id._const_tab_id = u'id'
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FTPICH_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FTPICH_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FTPICH_Information_Reconf_iE_Extensions__item__id),
        (u'criticality', ___FTPICH_Information_Reconf_iE_Extensions__item__criticality),
        (u'extensionValue', ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_Reconf_iE_Extensions__item_._ext = None
    _FTPICH_Information_Reconf_iE_Extensions._cont = __FTPICH_Information_Reconf_iE_Extensions__item_
    _FTPICH_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information_Reconf._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information', _FTPICH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information),
        (u'iE-Extensions', _FTPICH_Information_Reconf_iE_Extensions),
        ])
    FTPICH_Information_Reconf._ext = []
    
    #-----< FTPICH-Information-Reconf-ExtIEs >-----#
    FTPICH_Information_Reconf_ExtIEs = CLASS(name=u'FTPICH-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FTPICH-Reconfiguration-Information >-----#
    FTPICH_Reconfiguration_Information = SEQ(name=u'FTPICH-Reconfiguration-Information', mode=MODE_TYPE)
    _FTPICH_Reconfiguration_Information_fTPICH_SlotFormat = INT(name=u'fTPICH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-SlotFormat')), opt=True)
    _FTPICH_Reconfiguration_Information_fTPICH_ChannelisationCodenumber = INT(name=u'fTPICH-ChannelisationCodenumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')), opt=True)
    _FTPICH_Reconfiguration_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Reconfiguration_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FTPICH_Reconfiguration_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Reconfiguration_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__id._const_tab = ____FTPICH_Reconfiguration_Information_iE_Extensions__item__id_tab
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality._const_tab = ____FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality_tab
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FTPICH_Reconfiguration_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FTPICH_Reconfiguration_Information_iE_Extensions__item__id),
        (u'criticality', ___FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Reconfiguration_Information_iE_Extensions__item_._ext = None
    _FTPICH_Reconfiguration_Information_iE_Extensions._cont = __FTPICH_Reconfiguration_Information_iE_Extensions__item_
    _FTPICH_Reconfiguration_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Reconfiguration_Information._cont = ASN1Dict([
        (u'fTPICH-SlotFormat', _FTPICH_Reconfiguration_Information_fTPICH_SlotFormat),
        (u'fTPICH-ChannelisationCodenumber', _FTPICH_Reconfiguration_Information_fTPICH_ChannelisationCodenumber),
        (u'iE-Extensions', _FTPICH_Reconfiguration_Information_iE_Extensions),
        ])
    FTPICH_Reconfiguration_Information._ext = []
    
    #-----< FTPICH-Reconfiguration-Information-ExtIEs >-----#
    FTPICH_Reconfiguration_Information_ExtIEs = CLASS(name=u'FTPICH-Reconfiguration-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FTPICH_Reconfiguration_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FTPICH-Information-Response >-----#
    FTPICH_Information_Response = SEQ(name=u'FTPICH-Information-Response', mode=MODE_TYPE)
    _FTPICH_Information_Response_fTPICH_SlotFormat = INT(name=u'fTPICH-SlotFormat', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-SlotFormat')))
    _FTPICH_Information_Response_fTPICH_ChannelisationCodenumber = INT(name=u'fTPICH-ChannelisationCodenumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _FTPICH_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FTPICH_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FTPICH_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FTPICH_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Response_iE_Extensions__item__id._const_tab = ____FTPICH_Information_Response_iE_Extensions__item__id_tab
    ___FTPICH_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___FTPICH_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___FTPICH_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FTPICH_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Response_iE_Extensions__item__criticality._const_tab = ____FTPICH_Information_Response_iE_Extensions__item__criticality_tab
    ___FTPICH_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FTPICH_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FTPICH_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FTPICH_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FTPICH_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FTPICH_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____FTPICH_Information_Response_iE_Extensions__item__extensionValue_tab
    ___FTPICH_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FTPICH_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FTPICH_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FTPICH_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___FTPICH_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___FTPICH_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __FTPICH_Information_Response_iE_Extensions__item_._ext = None
    _FTPICH_Information_Response_iE_Extensions._cont = __FTPICH_Information_Response_iE_Extensions__item_
    _FTPICH_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FTPICH_Information_Response._cont = ASN1Dict([
        (u'fTPICH-SlotFormat', _FTPICH_Information_Response_fTPICH_SlotFormat),
        (u'fTPICH-ChannelisationCodenumber', _FTPICH_Information_Response_fTPICH_ChannelisationCodenumber),
        (u'iE-Extensions', _FTPICH_Information_Response_iE_Extensions),
        ])
    FTPICH_Information_Response._ext = []
    
    #-----< FTPICH-Information-Response-ExtIEs >-----#
    FTPICH_Information_Response_ExtIEs = CLASS(name=u'FTPICH-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FTPICH_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrameHandlingPriority >-----#
    FrameHandlingPriority = INT(name=u'FrameHandlingPriority', mode=MODE_TYPE)
    FrameHandlingPriority._cont = ASN1Dict([(u'lowest', 0), (u'highest', 15)])
    FrameHandlingPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< FrameOffset >-----#
    FrameOffset = INT(name=u'FrameOffset', mode=MODE_TYPE)
    FrameOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< FrequencyBandIndicator >-----#
    FrequencyBandIndicator = ENUM(name=u'FrequencyBandIndicator', mode=MODE_TYPE)
    FrequencyBandIndicator._cont = ASN1Dict([(u'bandI', 0), (u'bandII', 1), (u'bandIII', 2), (u'bandIV', 3), (u'bandV', 4), (u'bandVI', 5), (u'bandVII', 6), (u'bandVIII', 7), (u'bandIX', 8), (u'bandX', 9), (u'bandXI', 10), (u'bandXII', 11), (u'bandXIII', 12), (u'bandXIV', 13), (u'bandXV', 14), (u'bandXVI', 15), (u'bandXVII', 16), (u'bandXVIII', 17), (u'bandXIX', 18), (u'bandXX', 19), (u'bandXXI', 20), (u'bandXXII', 21), (u'reserved23', 22), (u'reserved24', 23), (u'bandXXV', 24), (u'bandXXVI', 25), (u'reserved27', 26), (u'reserved28', 27), (u'reserved29', 28), (u'reserved30', 29), (u'reserved31', 30), (u'bandXXXII', 31)])
    FrequencyBandIndicator._ext = [u'reserved23', u'reserved24', u'bandXXV', u'bandXXVI', u'reserved27', u'reserved28', u'reserved29', u'reserved30', u'reserved31', u'bandXXXII']
    
    #-----< GapLength >-----#
    GapLength = INT(name=u'GapLength', mode=MODE_TYPE)
    GapLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< GapDuration >-----#
    GapDuration = INT(name=u'GapDuration', mode=MODE_TYPE)
    GapDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=144)], ev=[], er=[])
    
    #-----< GA-Cell >-----#
    GA_Cell = SEQ_OF(name=u'GA-Cell', mode=MODE_TYPE)
    _GA_Cell__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Cell__item__cell_GAIgeographicalCoordinate = SEQ(name=u'cell-GAIgeographicalCoordinate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    __GA_Cell__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GA_Cell__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GA_Cell__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GA_Cell__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GA_Cell__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Cell__item__iE_Extensions__item__id._const_tab = _____GA_Cell__item__iE_Extensions__item__id_tab
    ____GA_Cell__item__iE_Extensions__item__id._const_tab_at = None
    ____GA_Cell__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____GA_Cell__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GA_Cell__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GA_Cell__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Cell__item__iE_Extensions__item__criticality._const_tab = _____GA_Cell__item__iE_Extensions__item__criticality_tab
    ____GA_Cell__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GA_Cell__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GA_Cell__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GA_Cell__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GA_Cell__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Cell__item__iE_Extensions__item__extensionValue._const_tab = _____GA_Cell__item__iE_Extensions__item__extensionValue_tab
    ____GA_Cell__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GA_Cell__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GA_Cell__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GA_Cell__item__iE_Extensions__item__id),
        (u'criticality', ____GA_Cell__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____GA_Cell__item__iE_Extensions__item__extensionValue),
        ])
    ___GA_Cell__item__iE_Extensions__item_._ext = None
    __GA_Cell__item__iE_Extensions._cont = ___GA_Cell__item__iE_Extensions__item_
    __GA_Cell__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GA_Cell__item_._cont = ASN1Dict([
        (u'cell-GAIgeographicalCoordinate', __GA_Cell__item__cell_GAIgeographicalCoordinate),
        (u'iE-Extensions', __GA_Cell__item__iE_Extensions),
        ])
    _GA_Cell__item_._ext = []
    GA_Cell._cont = _GA_Cell__item_
    GA_Cell._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< GA-Cell-ExtIEs >-----#
    GA_Cell_ExtIEs = CLASS(name=u'GA-Cell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_Cell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-CellAdditionalShapes >-----#
    GA_CellAdditionalShapes = CHOICE(name=u'GA-CellAdditionalShapes', mode=MODE_TYPE)
    _GA_CellAdditionalShapes_pointWithUncertainty = SEQ(name=u'pointWithUncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-PointWithUnCertainty')))
    _GA_CellAdditionalShapes_pointWithUncertaintyEllipse = SEQ(name=u'pointWithUncertaintyEllipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-PointWithUnCertaintyEllipse')))
    _GA_CellAdditionalShapes_pointWithAltitude = SEQ(name=u'pointWithAltitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-PointWithAltitude')))
    _GA_CellAdditionalShapes_pointWithAltitudeAndUncertaintyEllipsoid = SEQ(name=u'pointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-PointWithAltitudeAndUncertaintyEllipsoid')))
    _GA_CellAdditionalShapes_ellipsoidArc = SEQ(name=u'ellipsoidArc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-EllipsoidArc')))
    GA_CellAdditionalShapes._cont = ASN1Dict([
        (u'pointWithUncertainty', _GA_CellAdditionalShapes_pointWithUncertainty),
        (u'pointWithUncertaintyEllipse', _GA_CellAdditionalShapes_pointWithUncertaintyEllipse),
        (u'pointWithAltitude', _GA_CellAdditionalShapes_pointWithAltitude),
        (u'pointWithAltitudeAndUncertaintyEllipsoid', _GA_CellAdditionalShapes_pointWithAltitudeAndUncertaintyEllipsoid),
        (u'ellipsoidArc', _GA_CellAdditionalShapes_ellipsoidArc),
        ])
    GA_CellAdditionalShapes._ext = []
    
    #-----< GA-AltitudeAndDirection >-----#
    GA_AltitudeAndDirection = SEQ(name=u'GA-AltitudeAndDirection', mode=MODE_TYPE)
    _GA_AltitudeAndDirection_directionOfAltitude = ENUM(name=u'directionOfAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_directionOfAltitude._cont = ASN1Dict([(u'height', 0), (u'depth', 1)])
    _GA_AltitudeAndDirection_directionOfAltitude._ext = None
    _GA_AltitudeAndDirection_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    GA_AltitudeAndDirection._cont = ASN1Dict([
        (u'directionOfAltitude', _GA_AltitudeAndDirection_directionOfAltitude),
        (u'altitude', _GA_AltitudeAndDirection_altitude),
        ])
    GA_AltitudeAndDirection._ext = []
    
    #-----< GA-EllipsoidArc >-----#
    GA_EllipsoidArc = SEQ(name=u'GA-EllipsoidArc', mode=MODE_TYPE)
    _GA_EllipsoidArc_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_EllipsoidArc_innerRadius = INT(name=u'innerRadius', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_innerRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GA_EllipsoidArc_uncertaintyRadius = INT(name=u'uncertaintyRadius', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_uncertaintyRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_offsetAngle = INT(name=u'offsetAngle', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_offsetAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_includedAngle = INT(name=u'includedAngle', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_includedAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_EllipsoidArc_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_EllipsoidArc_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__id_tab
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_at = None
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_EllipsoidArc_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_EllipsoidArc_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_EllipsoidArc_iE_Extensions__item__id),
        (u'criticality', ___GA_EllipsoidArc_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_EllipsoidArc_iE_Extensions__item__extensionValue),
        ])
    __GA_EllipsoidArc_iE_Extensions__item_._ext = None
    _GA_EllipsoidArc_iE_Extensions._cont = __GA_EllipsoidArc_iE_Extensions__item_
    _GA_EllipsoidArc_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_EllipsoidArc._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_EllipsoidArc_geographicalCoordinates),
        (u'innerRadius', _GA_EllipsoidArc_innerRadius),
        (u'uncertaintyRadius', _GA_EllipsoidArc_uncertaintyRadius),
        (u'offsetAngle', _GA_EllipsoidArc_offsetAngle),
        (u'includedAngle', _GA_EllipsoidArc_includedAngle),
        (u'confidence', _GA_EllipsoidArc_confidence),
        (u'iE-Extensions', _GA_EllipsoidArc_iE_Extensions),
        ])
    GA_EllipsoidArc._ext = []
    
    #-----< GA-EllipsoidArc-ExtIEs >-----#
    GA_EllipsoidArc_ExtIEs = CLASS(name=u'GA-EllipsoidArc-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_EllipsoidArc_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Gainfactors-10ms-mode >-----#
    Gainfactors_10ms_mode = CHOICE(name=u'Gainfactors-10ms-mode', mode=MODE_TYPE)
    _Gainfactors_10ms_mode_signalledGainFactors10ms = SEQ(name=u'signalledGainFactors10ms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaC = INT(name=u'gain10ms-betaC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BetaCD')))
    __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaD = INT(name=u'gain10ms-betaD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BetaCD')))
    __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_refTFCNumber = INT(name=u'gain10ms-refTFCNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RefTFCNumber')), opt=True)
    __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id._const_tab = _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id._const_tab_at = None
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id._const_tab_id = u'id'
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality._const_tab = _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue._const_tab = _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id),
        (u'criticality', ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality),
        (u'extensionValue', ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue),
        ])
    ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_._ext = None
    __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions._cont = ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_
    __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Gainfactors_10ms_mode_signalledGainFactors10ms._cont = ASN1Dict([
        (u'gain10ms-betaC', __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaC),
        (u'gain10ms-betaD', __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaD),
        (u'gain10ms-refTFCNumber', __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_refTFCNumber),
        (u'iE-Extensions', __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions),
        ])
    _Gainfactors_10ms_mode_signalledGainFactors10ms._ext = []
    _Gainfactors_10ms_mode_computedGainFactors10ms = INT(name=u'computedGainFactors10ms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RefTFCNumber')))
    Gainfactors_10ms_mode._cont = ASN1Dict([
        (u'signalledGainFactors10ms', _Gainfactors_10ms_mode_signalledGainFactors10ms),
        (u'computedGainFactors10ms', _Gainfactors_10ms_mode_computedGainFactors10ms),
        ])
    Gainfactors_10ms_mode._ext = []
    
    #-----< SignalledGainFactors10ms-ExtIEs >-----#
    SignalledGainFactors10ms_ExtIEs = CLASS(name=u'SignalledGainFactors10ms-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SignalledGainFactors10ms_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AddClockModels >-----#
    GANSS_AddClockModels = CHOICE(name=u'GANSS-AddClockModels', mode=MODE_TYPE)
    _GANSS_AddClockModels_navClockModel = SEQ(name=u'navClockModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NAVclockModel')))
    _GANSS_AddClockModels_cnavClockModel = SEQ(name=u'cnavClockModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-CNAVclockModel')))
    _GANSS_AddClockModels_glonassClockModel = SEQ(name=u'glonassClockModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-GLONASSclockModel')))
    _GANSS_AddClockModels_sbasClockModel = SEQ(name=u'sbasClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SBASclockModel')))
    _GANSS_AddClockModels_extension_GANSS_AddClockModels = SEQ(name=u'extension-GANSS-AddClockModels', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-GANSS-AddClockModels')))
    GANSS_AddClockModels._cont = ASN1Dict([
        (u'navClockModel', _GANSS_AddClockModels_navClockModel),
        (u'cnavClockModel', _GANSS_AddClockModels_cnavClockModel),
        (u'glonassClockModel', _GANSS_AddClockModels_glonassClockModel),
        (u'sbasClockModel', _GANSS_AddClockModels_sbasClockModel),
        (u'extension-GANSS-AddClockModels', _GANSS_AddClockModels_extension_GANSS_AddClockModels),
        ])
    GANSS_AddClockModels._ext = [u'extension-GANSS-AddClockModels']
    
    #-----< Extension-GANSS-AddClockModels >-----#
    Extension_GANSS_AddClockModels = SEQ(name=u'Extension-GANSS-AddClockModels', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_GANSS_AddClockModels_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_GANSS_AddClockModels_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_GANSS_AddClockModels_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-BDSclockModel')))
    __Extension_GANSS_AddClockModels_id_tab._val = ASN1Set(rv=[dict([(u'id', 978), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AddClockModels_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_GANSS_AddClockModels_id._const_tab = __Extension_GANSS_AddClockModels_id_tab
    _Extension_GANSS_AddClockModels_id._const_tab_at = None
    _Extension_GANSS_AddClockModels_id._const_tab_id = u'id'
    _Extension_GANSS_AddClockModels_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_GANSS_AddClockModels_criticality._const_tab = __Extension_GANSS_AddClockModels_id_tab
    _Extension_GANSS_AddClockModels_criticality._const_tab_at = ('..', u'id')
    _Extension_GANSS_AddClockModels_criticality._const_tab_id = u'criticality'
    _Extension_GANSS_AddClockModels_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_GANSS_AddClockModels_value._const_tab = __Extension_GANSS_AddClockModels_id_tab
    _Extension_GANSS_AddClockModels_value._const_tab_at = ('..', u'id')
    _Extension_GANSS_AddClockModels_value._const_tab_id = u'Value'
    Extension_GANSS_AddClockModels._cont = ASN1Dict([
        (u'id', _Extension_GANSS_AddClockModels_id),
        (u'criticality', _Extension_GANSS_AddClockModels_criticality),
        (u'value', _Extension_GANSS_AddClockModels_value),
        ])
    Extension_GANSS_AddClockModels._ext = None
    
    #-----< Extension-GANSS-AddClockModels-IE >-----#
    Extension_GANSS_AddClockModels_IE = CLASS(name=u'Extension-GANSS-AddClockModels-IE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_GANSS_AddClockModels_IE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-BDSclockModel')))
    Extension_GANSS_AddClockModels_IE._val = ASN1Set(rv=[dict([(u'id', 978), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AddClockModels_IE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GANSS-AddIonoModelReq >-----#
    GANSS_AddIonoModelReq = BIT_STR(name=u'GANSS-AddIonoModelReq', mode=MODE_TYPE)
    GANSS_AddIonoModelReq._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< GANSS-AddNavigationModelsReq >-----#
    GANSS_AddNavigationModelsReq = BOOL(name=u'GANSS-AddNavigationModelsReq', mode=MODE_TYPE)
    
    #-----< GANSS-AddOrbitModels >-----#
    GANSS_AddOrbitModels = CHOICE(name=u'GANSS-AddOrbitModels', mode=MODE_TYPE)
    _GANSS_AddOrbitModels_navKeplerianSet = SEQ(name=u'navKeplerianSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NavModel-NAVKeplerianSet')))
    _GANSS_AddOrbitModels_cnavKeplerianSet = SEQ(name=u'cnavKeplerianSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NavModel-CNAVKeplerianSet')))
    _GANSS_AddOrbitModels_glonassECEF = SEQ(name=u'glonassECEF', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NavModel-GLONASSecef')))
    _GANSS_AddOrbitModels_sbasECEF = SEQ(name=u'sbasECEF', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NavModel-SBASecef')))
    _GANSS_AddOrbitModels_extension_GANSS_AddOrbitModels = SEQ(name=u'extension-GANSS-AddOrbitModels', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-GANSS-AddOrbitModels')))
    GANSS_AddOrbitModels._cont = ASN1Dict([
        (u'navKeplerianSet', _GANSS_AddOrbitModels_navKeplerianSet),
        (u'cnavKeplerianSet', _GANSS_AddOrbitModels_cnavKeplerianSet),
        (u'glonassECEF', _GANSS_AddOrbitModels_glonassECEF),
        (u'sbasECEF', _GANSS_AddOrbitModels_sbasECEF),
        (u'extension-GANSS-AddOrbitModels', _GANSS_AddOrbitModels_extension_GANSS_AddOrbitModels),
        ])
    GANSS_AddOrbitModels._ext = [u'extension-GANSS-AddOrbitModels']
    
    #-----< Extension-GANSS-AddOrbitModels >-----#
    Extension_GANSS_AddOrbitModels = SEQ(name=u'Extension-GANSS-AddOrbitModels', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_GANSS_AddOrbitModels_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_GANSS_AddOrbitModels_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_GANSS_AddOrbitModels_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NavModel-BDSKeplerianSet')))
    __Extension_GANSS_AddOrbitModels_id_tab._val = ASN1Set(rv=[dict([(u'id', 979), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AddOrbitModels_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_GANSS_AddOrbitModels_id._const_tab = __Extension_GANSS_AddOrbitModels_id_tab
    _Extension_GANSS_AddOrbitModels_id._const_tab_at = None
    _Extension_GANSS_AddOrbitModels_id._const_tab_id = u'id'
    _Extension_GANSS_AddOrbitModels_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_GANSS_AddOrbitModels_criticality._const_tab = __Extension_GANSS_AddOrbitModels_id_tab
    _Extension_GANSS_AddOrbitModels_criticality._const_tab_at = ('..', u'id')
    _Extension_GANSS_AddOrbitModels_criticality._const_tab_id = u'criticality'
    _Extension_GANSS_AddOrbitModels_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_GANSS_AddOrbitModels_value._const_tab = __Extension_GANSS_AddOrbitModels_id_tab
    _Extension_GANSS_AddOrbitModels_value._const_tab_at = ('..', u'id')
    _Extension_GANSS_AddOrbitModels_value._const_tab_id = u'Value'
    Extension_GANSS_AddOrbitModels._cont = ASN1Dict([
        (u'id', _Extension_GANSS_AddOrbitModels_id),
        (u'criticality', _Extension_GANSS_AddOrbitModels_criticality),
        (u'value', _Extension_GANSS_AddOrbitModels_value),
        ])
    Extension_GANSS_AddOrbitModels._ext = None
    
    #-----< Extension-GANSS-AddOrbitModels-IE >-----#
    Extension_GANSS_AddOrbitModels_IE = CLASS(name=u'Extension-GANSS-AddOrbitModels-IE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_GANSS_AddOrbitModels_IE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-NavModel-BDSKeplerianSet')))
    Extension_GANSS_AddOrbitModels_IE._val = ASN1Set(rv=[dict([(u'id', 979), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AddOrbitModels_IE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GANSS-AddUTCModelsReq >-----#
    GANSS_AddUTCModelsReq = BOOL(name=u'GANSS-AddUTCModelsReq', mode=MODE_TYPE)
    
    #-----< GANSS-Additional-Ionospheric-Model >-----#
    GANSS_Additional_Ionospheric_Model = SEQ(name=u'GANSS-Additional-Ionospheric-Model', mode=MODE_TYPE)
    _GANSS_Additional_Ionospheric_Model_dataID = BIT_STR(name=u'dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Additional_Ionospheric_Model_dataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters = SEQ(name=u'alpha-beta-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-Ionospheric-Model')))
    _GANSS_Additional_Ionospheric_Model_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GANSS_Additional_Ionospheric_Model_ie_Extensions._cont = __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_
    _GANSS_Additional_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Additional_Ionospheric_Model._cont = ASN1Dict([
        (u'dataID', _GANSS_Additional_Ionospheric_Model_dataID),
        (u'alpha-beta-parameters', _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters),
        (u'ie-Extensions', _GANSS_Additional_Ionospheric_Model_ie_Extensions),
        ])
    GANSS_Additional_Ionospheric_Model._ext = []
    
    #-----< GANSS-Additional-Ionospheric-Model-ExtIEs >-----#
    GANSS_Additional_Ionospheric_Model_ExtIEs = CLASS(name=u'GANSS-Additional-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Additional_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Additional-Navigation-Models >-----#
    GANSS_Additional_Navigation_Models = SEQ(name=u'GANSS-Additional-Navigation-Models', mode=MODE_TYPE)
    _GANSS_Additional_Navigation_Models_ganss_Transmission_Time = SEQ(name=u'ganss-Transmission-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Transmission-Time')))
    _GANSS_Additional_Navigation_Models_non_broadcastIndication = ENUM(name=u'non-broadcastIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Additional_Navigation_Models_non_broadcastIndication._cont = ASN1Dict([(u'true', 0)])
    _GANSS_Additional_Navigation_Models_non_broadcastIndication._ext = None
    _GANSS_Additional_Navigation_Models_ganssSatInfoNavList = SEQ_OF(name=u'ganssSatInfoNavList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Ganss-Sat-Info-AddNavList')))
    _GANSS_Additional_Navigation_Models_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_._ext = None
    _GANSS_Additional_Navigation_Models_ie_Extensions._cont = __GANSS_Additional_Navigation_Models_ie_Extensions__item_
    _GANSS_Additional_Navigation_Models_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Additional_Navigation_Models._cont = ASN1Dict([
        (u'ganss-Transmission-Time', _GANSS_Additional_Navigation_Models_ganss_Transmission_Time),
        (u'non-broadcastIndication', _GANSS_Additional_Navigation_Models_non_broadcastIndication),
        (u'ganssSatInfoNavList', _GANSS_Additional_Navigation_Models_ganssSatInfoNavList),
        (u'ie-Extensions', _GANSS_Additional_Navigation_Models_ie_Extensions),
        ])
    GANSS_Additional_Navigation_Models._ext = []
    
    #-----< GANSS-Additional-Navigation-Models-ExtIEs >-----#
    GANSS_Additional_Navigation_Models_ExtIEs = CLASS(name=u'GANSS-Additional-Navigation-Models-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Additional_Navigation_Models_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Additional-Time-Models >-----#
    GANSS_Additional_Time_Models = SEQ_OF(name=u'GANSS-Additional-Time-Models', mode=MODE_TYPE)
    _GANSS_Additional_Time_Models__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Time-Model')))
    GANSS_Additional_Time_Models._cont = _GANSS_Additional_Time_Models__item_
    GANSS_Additional_Time_Models._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< GANSS-Additional-UTC-Models >-----#
    GANSS_Additional_UTC_Models = CHOICE(name=u'GANSS-Additional-UTC-Models', mode=MODE_TYPE)
    _GANSS_Additional_UTC_Models_utcModel1 = SEQ(name=u'utcModel1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-UTCmodelSet1')))
    _GANSS_Additional_UTC_Models_utcModel2 = SEQ(name=u'utcModel2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-UTCmodelSet2')))
    _GANSS_Additional_UTC_Models_utcModel3 = SEQ(name=u'utcModel3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-UTCmodelSet3')))
    _GANSS_Additional_UTC_Models_extension_GANSS_Additional_UTC_Models = SEQ(name=u'extension-GANSS-Additional-UTC-Models', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-GANSS-Additional-UTC-Models')))
    GANSS_Additional_UTC_Models._cont = ASN1Dict([
        (u'utcModel1', _GANSS_Additional_UTC_Models_utcModel1),
        (u'utcModel2', _GANSS_Additional_UTC_Models_utcModel2),
        (u'utcModel3', _GANSS_Additional_UTC_Models_utcModel3),
        (u'extension-GANSS-Additional-UTC-Models', _GANSS_Additional_UTC_Models_extension_GANSS_Additional_UTC_Models),
        ])
    GANSS_Additional_UTC_Models._ext = [u'extension-GANSS-Additional-UTC-Models']
    
    #-----< Extension-GANSS-Additional-UTC-Models >-----#
    Extension_GANSS_Additional_UTC_Models = SEQ(name=u'Extension-GANSS-Additional-UTC-Models', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_GANSS_Additional_UTC_Models_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_GANSS_Additional_UTC_Models_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_GANSS_Additional_UTC_Models_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-UTCmodelSet4')))
    __Extension_GANSS_Additional_UTC_Models_id_tab._val = ASN1Set(rv=[dict([(u'id', 980), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_Additional_UTC_Models_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_GANSS_Additional_UTC_Models_id._const_tab = __Extension_GANSS_Additional_UTC_Models_id_tab
    _Extension_GANSS_Additional_UTC_Models_id._const_tab_at = None
    _Extension_GANSS_Additional_UTC_Models_id._const_tab_id = u'id'
    _Extension_GANSS_Additional_UTC_Models_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_GANSS_Additional_UTC_Models_criticality._const_tab = __Extension_GANSS_Additional_UTC_Models_id_tab
    _Extension_GANSS_Additional_UTC_Models_criticality._const_tab_at = ('..', u'id')
    _Extension_GANSS_Additional_UTC_Models_criticality._const_tab_id = u'criticality'
    _Extension_GANSS_Additional_UTC_Models_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_GANSS_Additional_UTC_Models_value._const_tab = __Extension_GANSS_Additional_UTC_Models_id_tab
    _Extension_GANSS_Additional_UTC_Models_value._const_tab_at = ('..', u'id')
    _Extension_GANSS_Additional_UTC_Models_value._const_tab_id = u'Value'
    Extension_GANSS_Additional_UTC_Models._cont = ASN1Dict([
        (u'id', _Extension_GANSS_Additional_UTC_Models_id),
        (u'criticality', _Extension_GANSS_Additional_UTC_Models_criticality),
        (u'value', _Extension_GANSS_Additional_UTC_Models_value),
        ])
    Extension_GANSS_Additional_UTC_Models._ext = None
    
    #-----< Extension-GANSS-Additional-UTC-Models-IE >-----#
    Extension_GANSS_Additional_UTC_Models_IE = CLASS(name=u'Extension-GANSS-Additional-UTC-Models-IE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_GANSS_Additional_UTC_Models_IE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-UTCmodelSet4')))
    Extension_GANSS_Additional_UTC_Models_IE._val = ASN1Set(rv=[dict([(u'id', 980), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_Additional_UTC_Models_IE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GANSS-Almanac >-----#
    GANSS_Almanac = SEQ(name=u'GANSS-Almanac', mode=MODE_TYPE)
    _GANSS_Almanac_ganss_wk_number = INT(name=u'ganss-wk-number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Almanac_ganss_wk_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_Almanac_gANSS_AlmanacModel = CHOICE(name=u'gANSS-AlmanacModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters = SEQ(name=u'gANSS-keplerianParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_t_oa = INT(name=u't-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_iod_a = INT(name=u'iod-a', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_iod_a._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_gANSS_SatelliteInformationKP = SEQ_OF(name=u'gANSS-SatelliteInformationKP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SatelliteInformationKP')))
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id._const_tab = ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id_tab
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id._const_tab_at = None
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id._const_tab_id = u'id'
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality._const_tab = ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue._const_tab = ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id),
        (u'criticality', _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality),
        (u'extensionValue', _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue),
        ])
    ____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item_._ext = None
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions._cont = ____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item_
    ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters._cont = ASN1Dict([
        (u't-oa', ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_t_oa),
        (u'iod-a', ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_iod_a),
        (u'gANSS-SatelliteInformationKP', ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_gANSS_SatelliteInformationKP),
        (u'ie-Extensions', ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions),
        ])
    __GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters._ext = []
    __GANSS_Almanac_gANSS_AlmanacModel_extension_GANSS_AlmanacModel = SEQ(name=u'extension-GANSS-AlmanacModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-GANSS-AlmanacModel')))
    _GANSS_Almanac_gANSS_AlmanacModel._cont = ASN1Dict([
        (u'gANSS-keplerianParameters', __GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters),
        (u'extension-GANSS-AlmanacModel', __GANSS_Almanac_gANSS_AlmanacModel_extension_GANSS_AlmanacModel),
        ])
    _GANSS_Almanac_gANSS_AlmanacModel._ext = [u'extension-GANSS-AlmanacModel']
    _GANSS_Almanac_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Almanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Almanac_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Almanac_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Almanac_ie_Extensions__item__id_tab_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CompleteAlmanacProvided')))
    ____GANSS_Almanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 878), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Almanac_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Almanac_ie_Extensions__item__id._const_tab = ____GANSS_Almanac_ie_Extensions__item__id_tab
    ___GANSS_Almanac_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Almanac_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Almanac_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GANSS_Almanac_ie_Extensions__item__criticality._const_tab = ____GANSS_Almanac_ie_Extensions__item__id_tab
    ___GANSS_Almanac_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Almanac_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Almanac_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GANSS_Almanac_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Almanac_ie_Extensions__item__id_tab
    ___GANSS_Almanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Almanac_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Almanac_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Almanac_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Almanac_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Almanac_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Almanac_ie_Extensions__item_._ext = None
    _GANSS_Almanac_ie_Extensions._cont = __GANSS_Almanac_ie_Extensions__item_
    _GANSS_Almanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Almanac._cont = ASN1Dict([
        (u'ganss-wk-number', _GANSS_Almanac_ganss_wk_number),
        (u'gANSS-AlmanacModel', _GANSS_Almanac_gANSS_AlmanacModel),
        (u'ie-Extensions', _GANSS_Almanac_ie_Extensions),
        ])
    GANSS_Almanac._ext = []
    
    #-----< GANSS-KeplerianParametersAlm-ExtIEs >-----#
    GANSS_KeplerianParametersAlm_ExtIEs = CLASS(name=u'GANSS-KeplerianParametersAlm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_KeplerianParametersAlm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-GANSS-AlmanacModel >-----#
    Extension_GANSS_AlmanacModel = SEQ(name=u'Extension-GANSS-AlmanacModel', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_GANSS_AlmanacModel_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_GANSS_AlmanacModel_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianNAVAlmanac')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianReducedAlmanac')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianMidiAlmanac')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianGLONASS')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-ecefSBASAlmanac')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-KEPLERIANBDSALMANAC')))
    __Extension_GANSS_AlmanacModel_id_tab._val = ASN1Set(rv=[dict([(u'id', 818), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 819), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 820), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 821), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 822), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 952), (u'criticality', u'ignore'), (u'Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_GANSS_AlmanacModel_id._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_id._const_tab_at = None
    _Extension_GANSS_AlmanacModel_id._const_tab_id = u'id'
    _Extension_GANSS_AlmanacModel_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_GANSS_AlmanacModel_criticality._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_criticality._const_tab_at = ('..', u'id')
    _Extension_GANSS_AlmanacModel_criticality._const_tab_id = u'criticality'
    _Extension_GANSS_AlmanacModel_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_GANSS_AlmanacModel_value._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_value._const_tab_at = ('..', u'id')
    _Extension_GANSS_AlmanacModel_value._const_tab_id = u'Value'
    Extension_GANSS_AlmanacModel._cont = ASN1Dict([
        (u'id', _Extension_GANSS_AlmanacModel_id),
        (u'criticality', _Extension_GANSS_AlmanacModel_criticality),
        (u'value', _Extension_GANSS_AlmanacModel_value),
        ])
    Extension_GANSS_AlmanacModel._ext = None
    
    #-----< Extension-GANSS-AlmanacModel-IE >-----#
    Extension_GANSS_AlmanacModel_IE = CLASS(name=u'Extension-GANSS-AlmanacModel-IE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianNAVAlmanac')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianReducedAlmanac')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianMidiAlmanac')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-keplerianGLONASS')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-ecefSBASAlmanac')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-alm-KEPLERIANBDSALMANAC')))
    Extension_GANSS_AlmanacModel_IE._val = ASN1Set(rv=[dict([(u'id', 818), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AlmanacModel_IE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 819), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AlmanacModel_IE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 820), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AlmanacModel_IE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 821), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AlmanacModel_IE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 822), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AlmanacModel_IE_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 952), (u'criticality', u'ignore'), (u'Value', _Extension_GANSS_AlmanacModel_IE_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GANSS-alm-keplerianNAVAlmanac >-----#
    GANSS_alm_keplerianNAVAlmanac = SEQ(name=u'GANSS-alm-keplerianNAVAlmanac', mode=MODE_TYPE)
    _GANSS_alm_keplerianNAVAlmanac_t_oa = INT(name=u't-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_alm_keplerianNAVAlmanac_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_alm_keplerianNAVAlmanac_sat_info_NAVkpList = SEQ_OF(name=u'sat-info-NAVkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-NAVkpList')))
    _GANSS_alm_keplerianNAVAlmanac_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id._const_tab = ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id_tab
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality._const_tab = ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality_tab
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue._const_tab = ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue_tab
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id),
        (u'criticality', ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue),
        ])
    __GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item_._ext = None
    _GANSS_alm_keplerianNAVAlmanac_ie_Extensions._cont = __GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item_
    _GANSS_alm_keplerianNAVAlmanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_alm_keplerianNAVAlmanac._cont = ASN1Dict([
        (u't-oa', _GANSS_alm_keplerianNAVAlmanac_t_oa),
        (u'sat-info-NAVkpList', _GANSS_alm_keplerianNAVAlmanac_sat_info_NAVkpList),
        (u'ie-Extensions', _GANSS_alm_keplerianNAVAlmanac_ie_Extensions),
        ])
    GANSS_alm_keplerianNAVAlmanac._ext = []
    
    #-----< GANSS-ALM-NAVKeplerianSet-ExtIEs >-----#
    GANSS_ALM_NAVKeplerianSet_ExtIEs = CLASS(name=u'GANSS-ALM-NAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_NAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-alm-KEPLERIANBDSALMANAC >-----#
    GANSS_alm_KEPLERIANBDSALMANAC = SEQ(name=u'GANSS-alm-KEPLERIANBDSALMANAC', mode=MODE_TYPE)
    _GANSS_alm_KEPLERIANBDSALMANAC_sat_info_BDSkpList = SEQ_OF(name=u'sat-info-BDSkpList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-BDSkpList')))
    _GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id._const_tab = ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id_tab
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality._const_tab = ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality_tab
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue._const_tab = ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue_tab
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id),
        (u'criticality', ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue),
        ])
    __GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item_._ext = None
    _GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions._cont = __GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item_
    _GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_alm_KEPLERIANBDSALMANAC._cont = ASN1Dict([
        (u'sat-info-BDSkpList', _GANSS_alm_KEPLERIANBDSALMANAC_sat_info_BDSkpList),
        (u'iE-Extensions', _GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions),
        ])
    GANSS_alm_KEPLERIANBDSALMANAC._ext = []
    
    #-----< GANSS-alm-KEPLERIANBDSALMANAC-ExtIEs >-----#
    GANSS_alm_KEPLERIANBDSALMANAC_ExtIEs = CLASS(name=u'GANSS-alm-KEPLERIANBDSALMANAC-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_alm_KEPLERIANBDSALMANAC_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-alm-keplerianReducedAlmanac >-----#
    GANSS_alm_keplerianReducedAlmanac = SEQ(name=u'GANSS-alm-keplerianReducedAlmanac', mode=MODE_TYPE)
    _GANSS_alm_keplerianReducedAlmanac_t_oa = INT(name=u't-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_alm_keplerianReducedAlmanac_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_alm_keplerianReducedAlmanac_sat_info_REDkpList = SEQ_OF(name=u'sat-info-REDkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-REDkpList')))
    _GANSS_alm_keplerianReducedAlmanac_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id._const_tab = ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id_tab
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality._const_tab = ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality_tab
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue._const_tab = ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue_tab
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id),
        (u'criticality', ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue),
        ])
    __GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item_._ext = None
    _GANSS_alm_keplerianReducedAlmanac_ie_Extensions._cont = __GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item_
    _GANSS_alm_keplerianReducedAlmanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_alm_keplerianReducedAlmanac._cont = ASN1Dict([
        (u't-oa', _GANSS_alm_keplerianReducedAlmanac_t_oa),
        (u'sat-info-REDkpList', _GANSS_alm_keplerianReducedAlmanac_sat_info_REDkpList),
        (u'ie-Extensions', _GANSS_alm_keplerianReducedAlmanac_ie_Extensions),
        ])
    GANSS_alm_keplerianReducedAlmanac._ext = []
    
    #-----< GANSS-ALM-ReducedKeplerianSet-ExtIEs >-----#
    GANSS_ALM_ReducedKeplerianSet_ExtIEs = CLASS(name=u'GANSS-ALM-ReducedKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_ReducedKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-alm-keplerianMidiAlmanac >-----#
    GANSS_alm_keplerianMidiAlmanac = SEQ(name=u'GANSS-alm-keplerianMidiAlmanac', mode=MODE_TYPE)
    _GANSS_alm_keplerianMidiAlmanac_t_oa = INT(name=u't-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_alm_keplerianMidiAlmanac_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_alm_keplerianMidiAlmanac_sat_info_MIDIkpList = SEQ_OF(name=u'sat-info-MIDIkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-MIDIkpList')))
    _GANSS_alm_keplerianMidiAlmanac_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id._const_tab = ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id_tab
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality._const_tab = ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality_tab
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue._const_tab = ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue_tab
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id),
        (u'criticality', ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue),
        ])
    __GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item_._ext = None
    _GANSS_alm_keplerianMidiAlmanac_ie_Extensions._cont = __GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item_
    _GANSS_alm_keplerianMidiAlmanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_alm_keplerianMidiAlmanac._cont = ASN1Dict([
        (u't-oa', _GANSS_alm_keplerianMidiAlmanac_t_oa),
        (u'sat-info-MIDIkpList', _GANSS_alm_keplerianMidiAlmanac_sat_info_MIDIkpList),
        (u'ie-Extensions', _GANSS_alm_keplerianMidiAlmanac_ie_Extensions),
        ])
    GANSS_alm_keplerianMidiAlmanac._ext = []
    
    #-----< GANSS-ALM-MidiAlmanacSet-ExtIEs >-----#
    GANSS_ALM_MidiAlmanacSet_ExtIEs = CLASS(name=u'GANSS-ALM-MidiAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_MidiAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-alm-keplerianGLONASS >-----#
    GANSS_alm_keplerianGLONASS = SEQ(name=u'GANSS-alm-keplerianGLONASS', mode=MODE_TYPE)
    _GANSS_alm_keplerianGLONASS_sat_info_GLOkpList = SEQ_OF(name=u'sat-info-GLOkpList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-GLOkpList')))
    _GANSS_alm_keplerianGLONASS_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_alm_keplerianGLONASS_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__id._const_tab = ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__id_tab
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality._const_tab = ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality_tab
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue._const_tab = ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue_tab
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_alm_keplerianGLONASS_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__id),
        (u'criticality', ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue),
        ])
    __GANSS_alm_keplerianGLONASS_ie_Extensions__item_._ext = None
    _GANSS_alm_keplerianGLONASS_ie_Extensions._cont = __GANSS_alm_keplerianGLONASS_ie_Extensions__item_
    _GANSS_alm_keplerianGLONASS_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_alm_keplerianGLONASS._cont = ASN1Dict([
        (u'sat-info-GLOkpList', _GANSS_alm_keplerianGLONASS_sat_info_GLOkpList),
        (u'ie-Extensions', _GANSS_alm_keplerianGLONASS_ie_Extensions),
        ])
    GANSS_alm_keplerianGLONASS._ext = []
    
    #-----< GANSS-ALM-GlonassAlmanacSet-ExtIEs >-----#
    GANSS_ALM_GlonassAlmanacSet_ExtIEs = CLASS(name=u'GANSS-ALM-GlonassAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_GlonassAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-alm-ecefSBASAlmanac >-----#
    GANSS_alm_ecefSBASAlmanac = SEQ(name=u'GANSS-alm-ecefSBASAlmanac', mode=MODE_TYPE)
    _GANSS_alm_ecefSBASAlmanac_sat_info_SBASecefList = SEQ_OF(name=u'sat-info-SBASecefList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-SBASecefList')))
    _GANSS_alm_ecefSBASAlmanac_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_alm_ecefSBASAlmanac_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id._const_tab = ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id_tab
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality._const_tab = ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality_tab
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue._const_tab = ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue_tab
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_alm_ecefSBASAlmanac_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id),
        (u'criticality', ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue),
        ])
    __GANSS_alm_ecefSBASAlmanac_ie_Extensions__item_._ext = None
    _GANSS_alm_ecefSBASAlmanac_ie_Extensions._cont = __GANSS_alm_ecefSBASAlmanac_ie_Extensions__item_
    _GANSS_alm_ecefSBASAlmanac_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_alm_ecefSBASAlmanac._cont = ASN1Dict([
        (u'sat-info-SBASecefList', _GANSS_alm_ecefSBASAlmanac_sat_info_SBASecefList),
        (u'ie-Extensions', _GANSS_alm_ecefSBASAlmanac_ie_Extensions),
        ])
    GANSS_alm_ecefSBASAlmanac._ext = []
    
    #-----< GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs >-----#
    GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs = CLASS(name=u'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Almanac-ExtIEs >-----#
    GANSS_Almanac_ExtIEs = CLASS(name=u'GANSS-Almanac-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GANSS_Almanac_ExtIEs_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CompleteAlmanacProvided')))
    GANSS_Almanac_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 878), (u'criticality', u'ignore'), (u'Extension', _GANSS_Almanac_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Auxiliary-Information >-----#
    GANSS_Auxiliary_Information = CHOICE(name=u'GANSS-Auxiliary-Information', mode=MODE_TYPE)
    _GANSS_Auxiliary_Information_ganssID1 = SEQ_OF(name=u'ganssID1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AuxInfoGANSS-ID1')))
    _GANSS_Auxiliary_Information_ganssID3 = SEQ_OF(name=u'ganssID3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AuxInfoGANSS-ID3')))
    GANSS_Auxiliary_Information._cont = ASN1Dict([
        (u'ganssID1', _GANSS_Auxiliary_Information_ganssID1),
        (u'ganssID3', _GANSS_Auxiliary_Information_ganssID3),
        ])
    GANSS_Auxiliary_Information._ext = []
    
    #-----< GANSS-AuxInfoGANSS-ID1 >-----#
    GANSS_AuxInfoGANSS_ID1 = SEQ_OF(name=u'GANSS-AuxInfoGANSS-ID1', mode=MODE_TYPE)
    _GANSS_AuxInfoGANSS_ID1__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_AuxInfoGANSS_ID1__item__svID = INT(name=u'svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_AuxInfoGANSS_ID1__item__svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_AuxInfoGANSS_ID1__item__signalsAvailable = BIT_STR(name=u'signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_AuxInfoGANSS_ID1__item__signalsAvailable._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_AuxInfoGANSS_ID1__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id._const_tab = _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id_tab
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality._const_tab = _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality_tab
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item_._ext = None
    __GANSS_AuxInfoGANSS_ID1__item__ie_Extensions._cont = ___GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item_
    __GANSS_AuxInfoGANSS_ID1__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID1__item_._cont = ASN1Dict([
        (u'svID', __GANSS_AuxInfoGANSS_ID1__item__svID),
        (u'signalsAvailable', __GANSS_AuxInfoGANSS_ID1__item__signalsAvailable),
        (u'ie-Extensions', __GANSS_AuxInfoGANSS_ID1__item__ie_Extensions),
        ])
    _GANSS_AuxInfoGANSS_ID1__item_._ext = []
    GANSS_AuxInfoGANSS_ID1._cont = _GANSS_AuxInfoGANSS_ID1__item_
    GANSS_AuxInfoGANSS_ID1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-AuxInfoGANSS-ID1-element-ExtIEs >-----#
    GANSS_AuxInfoGANSS_ID1_element_ExtIEs = CLASS(name=u'GANSS-AuxInfoGANSS-ID1-element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_AuxInfoGANSS_ID1_element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AuxInfoGANSS-ID3 >-----#
    GANSS_AuxInfoGANSS_ID3 = SEQ_OF(name=u'GANSS-AuxInfoGANSS-ID3', mode=MODE_TYPE)
    _GANSS_AuxInfoGANSS_ID3__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_AuxInfoGANSS_ID3__item__svID = INT(name=u'svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_AuxInfoGANSS_ID3__item__svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_AuxInfoGANSS_ID3__item__signalsAvailable = BIT_STR(name=u'signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_AuxInfoGANSS_ID3__item__signalsAvailable._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_AuxInfoGANSS_ID3__item__channelNumber = INT(name=u'channelNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_AuxInfoGANSS_ID3__item__channelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-7, ub=13)], ev=None, er=[])
    __GANSS_AuxInfoGANSS_ID3__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id._const_tab = _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id_tab
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality._const_tab = _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality_tab
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item_._ext = None
    __GANSS_AuxInfoGANSS_ID3__item__ie_Extensions._cont = ___GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item_
    __GANSS_AuxInfoGANSS_ID3__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_AuxInfoGANSS_ID3__item_._cont = ASN1Dict([
        (u'svID', __GANSS_AuxInfoGANSS_ID3__item__svID),
        (u'signalsAvailable', __GANSS_AuxInfoGANSS_ID3__item__signalsAvailable),
        (u'channelNumber', __GANSS_AuxInfoGANSS_ID3__item__channelNumber),
        (u'ie-Extensions', __GANSS_AuxInfoGANSS_ID3__item__ie_Extensions),
        ])
    _GANSS_AuxInfoGANSS_ID3__item_._ext = []
    GANSS_AuxInfoGANSS_ID3._cont = _GANSS_AuxInfoGANSS_ID3__item_
    GANSS_AuxInfoGANSS_ID3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-AuxInfoGANSS-ID3-element-ExtIEs >-----#
    GANSS_AuxInfoGANSS_ID3_element_ExtIEs = CLASS(name=u'GANSS-AuxInfoGANSS-ID3-element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_AuxInfoGANSS_ID3_element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AuxInfoReq >-----#
    GANSS_AuxInfoReq = BOOL(name=u'GANSS-AuxInfoReq', mode=MODE_TYPE)
    
    #-----< GANSS-BDSclockModel >-----#
    GANSS_BDSclockModel = SEQ(name=u'GANSS-BDSclockModel', mode=MODE_TYPE)
    _GANSS_BDSclockModel_bdsToc = BIT_STR(name=u'bdsToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsToc._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsa0 = BIT_STR(name=u'bdsa0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsa0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsa1 = BIT_STR(name=u'bdsa1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsa1._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsa2 = BIT_STR(name=u'bdsa2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsa2._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsTgd1 = BIT_STR(name=u'bdsTgd1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsTgd1._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_bdsAODC = BIT_STR(name=u'bdsAODC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_BDSclockModel_bdsAODC._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_BDSclockModel_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_BDSclockModel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_BDSclockModel_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_BDSclockModel_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_BDSclockModel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_BDSclockModel_iE_Extensions__item__id._const_tab = ____GANSS_BDSclockModel_iE_Extensions__item__id_tab
    ___GANSS_BDSclockModel_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_BDSclockModel_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_BDSclockModel_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_BDSclockModel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_BDSclockModel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_BDSclockModel_iE_Extensions__item__criticality._const_tab = ____GANSS_BDSclockModel_iE_Extensions__item__criticality_tab
    ___GANSS_BDSclockModel_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_BDSclockModel_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_BDSclockModel_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_BDSclockModel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_BDSclockModel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_BDSclockModel_iE_Extensions__item__extensionValue._const_tab = ____GANSS_BDSclockModel_iE_Extensions__item__extensionValue_tab
    ___GANSS_BDSclockModel_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_BDSclockModel_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_BDSclockModel_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_BDSclockModel_iE_Extensions__item__id),
        (u'criticality', ___GANSS_BDSclockModel_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_BDSclockModel_iE_Extensions__item__extensionValue),
        ])
    __GANSS_BDSclockModel_iE_Extensions__item_._ext = None
    _GANSS_BDSclockModel_iE_Extensions._cont = __GANSS_BDSclockModel_iE_Extensions__item_
    _GANSS_BDSclockModel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_BDSclockModel._cont = ASN1Dict([
        (u'bdsToc', _GANSS_BDSclockModel_bdsToc),
        (u'bdsa0', _GANSS_BDSclockModel_bdsa0),
        (u'bdsa1', _GANSS_BDSclockModel_bdsa1),
        (u'bdsa2', _GANSS_BDSclockModel_bdsa2),
        (u'bdsTgd1', _GANSS_BDSclockModel_bdsTgd1),
        (u'bdsAODC', _GANSS_BDSclockModel_bdsAODC),
        (u'iE-Extensions', _GANSS_BDSclockModel_iE_Extensions),
        ])
    GANSS_BDSclockModel._ext = []
    
    #-----< GANSS-BDSclockModelItem-ExtIEs >-----#
    GANSS_BDSclockModelItem_ExtIEs = CLASS(name=u'GANSS-BDSclockModelItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_BDSclockModelItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Clock-Model >-----#
    GANSS_Clock_Model = SEQ_OF(name=u'GANSS-Clock-Model', mode=MODE_TYPE)
    _GANSS_Clock_Model__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_Clock_Model__item__t_oc = BIT_STR(name=u't-oc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Clock_Model__item__t_oc._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    __GANSS_Clock_Model__item__a_i2 = BIT_STR(name=u'a-i2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Clock_Model__item__a_i2._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    __GANSS_Clock_Model__item__a_i1 = BIT_STR(name=u'a-i1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Clock_Model__item__a_i1._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    __GANSS_Clock_Model__item__a_i0 = BIT_STR(name=u'a-i0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Clock_Model__item__a_i0._const_sz = ASN1Set(rv=[31], rr=[], ev=None, er=[])
    __GANSS_Clock_Model__item__t_gd = BIT_STR(name=u't-gd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_Clock_Model__item__t_gd._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GANSS_Clock_Model__item__sisa = BIT_STR(name=u'sisa', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Clock_Model__item__sisa._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_Clock_Model__item__model_id = INT(name=u'model-id', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_Clock_Model__item__model_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=[], er=[])
    __GANSS_Clock_Model__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_Clock_Model__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_Clock_Model__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_Clock_Model__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Clock_Model__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Clock_Model__item__ie_Extensions__item__id._const_tab = _____GANSS_Clock_Model__item__ie_Extensions__item__id_tab
    ____GANSS_Clock_Model__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_Clock_Model__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_Clock_Model__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_Clock_Model__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Clock_Model__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Clock_Model__item__ie_Extensions__item__criticality._const_tab = _____GANSS_Clock_Model__item__ie_Extensions__item__criticality_tab
    ____GANSS_Clock_Model__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_Clock_Model__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_Clock_Model__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_Clock_Model__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_Clock_Model__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_Clock_Model__item__ie_Extensions__item_._ext = None
    __GANSS_Clock_Model__item__ie_Extensions._cont = ___GANSS_Clock_Model__item__ie_Extensions__item_
    __GANSS_Clock_Model__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_Clock_Model__item_._cont = ASN1Dict([
        (u't-oc', __GANSS_Clock_Model__item__t_oc),
        (u'a-i2', __GANSS_Clock_Model__item__a_i2),
        (u'a-i1', __GANSS_Clock_Model__item__a_i1),
        (u'a-i0', __GANSS_Clock_Model__item__a_i0),
        (u't-gd', __GANSS_Clock_Model__item__t_gd),
        (u'sisa', __GANSS_Clock_Model__item__sisa),
        (u'model-id', __GANSS_Clock_Model__item__model_id),
        (u'ie-Extensions', __GANSS_Clock_Model__item__ie_Extensions),
        ])
    _GANSS_Clock_Model__item_._ext = []
    GANSS_Clock_Model._cont = _GANSS_Clock_Model__item_
    GANSS_Clock_Model._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GANSS-ClockModelItem-ExtIEs >-----#
    GANSS_ClockModelItem_ExtIEs = CLASS(name=u'GANSS-ClockModelItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_ClockModelItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-CNAVclockModel >-----#
    GANSS_CNAVclockModel = SEQ(name=u'GANSS-CNAVclockModel', mode=MODE_TYPE)
    _GANSS_CNAVclockModel_cnavToc = BIT_STR(name=u'cnavToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavToc._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavTop = BIT_STR(name=u'cnavTop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavTop._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavURA0 = BIT_STR(name=u'cnavURA0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavURA0._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavURA1 = BIT_STR(name=u'cnavURA1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavURA1._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavURA2 = BIT_STR(name=u'cnavURA2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavURA2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavAf2 = BIT_STR(name=u'cnavAf2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavAf2._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavAf1 = BIT_STR(name=u'cnavAf1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavAf1._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavAf0 = BIT_STR(name=u'cnavAf0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavAf0._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavTgd = BIT_STR(name=u'cnavTgd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_CNAVclockModel_cnavTgd._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl1cp = BIT_STR(name=u'cnavISCl1cp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl1cp._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl1cd = BIT_STR(name=u'cnavISCl1cd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl1cd._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl1ca = BIT_STR(name=u'cnavISCl1ca', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl1ca._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl2c = BIT_STR(name=u'cnavISCl2c', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl2c._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl5i5 = BIT_STR(name=u'cnavISCl5i5', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl5i5._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_cnavISCl5q5 = BIT_STR(name=u'cnavISCl5q5', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CNAVclockModel_cnavISCl5q5._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_CNAVclockModel_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_CNAVclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_CNAVclockModel_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_CNAVclockModel_ie_Extensions__item__id._const_tab = ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab
    ___GANSS_CNAVclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_CNAVclockModel_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_CNAVclockModel_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_CNAVclockModel_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_CNAVclockModel_ie_Extensions__item__id),
        (u'criticality', ___GANSS_CNAVclockModel_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_CNAVclockModel_ie_Extensions__item_._ext = None
    _GANSS_CNAVclockModel_ie_Extensions._cont = __GANSS_CNAVclockModel_ie_Extensions__item_
    _GANSS_CNAVclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_CNAVclockModel._cont = ASN1Dict([
        (u'cnavToc', _GANSS_CNAVclockModel_cnavToc),
        (u'cnavTop', _GANSS_CNAVclockModel_cnavTop),
        (u'cnavURA0', _GANSS_CNAVclockModel_cnavURA0),
        (u'cnavURA1', _GANSS_CNAVclockModel_cnavURA1),
        (u'cnavURA2', _GANSS_CNAVclockModel_cnavURA2),
        (u'cnavAf2', _GANSS_CNAVclockModel_cnavAf2),
        (u'cnavAf1', _GANSS_CNAVclockModel_cnavAf1),
        (u'cnavAf0', _GANSS_CNAVclockModel_cnavAf0),
        (u'cnavTgd', _GANSS_CNAVclockModel_cnavTgd),
        (u'cnavISCl1cp', _GANSS_CNAVclockModel_cnavISCl1cp),
        (u'cnavISCl1cd', _GANSS_CNAVclockModel_cnavISCl1cd),
        (u'cnavISCl1ca', _GANSS_CNAVclockModel_cnavISCl1ca),
        (u'cnavISCl2c', _GANSS_CNAVclockModel_cnavISCl2c),
        (u'cnavISCl5i5', _GANSS_CNAVclockModel_cnavISCl5i5),
        (u'cnavISCl5q5', _GANSS_CNAVclockModel_cnavISCl5q5),
        (u'ie-Extensions', _GANSS_CNAVclockModel_ie_Extensions),
        ])
    GANSS_CNAVclockModel._ext = []
    
    #-----< GANSS-CNAVclockModel-ExtIEs >-----#
    GANSS_CNAVclockModel_ExtIEs = CLASS(name=u'GANSS-CNAVclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_CNAVclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Common-Data >-----#
    GANSS_Common_Data = SEQ(name=u'GANSS-Common-Data', mode=MODE_TYPE)
    _GANSS_Common_Data_ganss_Ionospheric_Model = SEQ(name=u'ganss-Ionospheric-Model', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Ionospheric-Model')), opt=True)
    _GANSS_Common_Data_ganss_Rx_Pos = SEQ(name=u'ganss-Rx-Pos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-RX-Pos')), opt=True)
    _GANSS_Common_Data_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Common_Data_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Common_Data_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Common_Data_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-Ionospheric-Model')))
    _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Earth-Orientation-Parameters')))
    ____GANSS_Common_Data_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 781), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 782), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Common_Data_ie_Extensions__item__id._const_tab = ____GANSS_Common_Data_ie_Extensions__item__id_tab
    ___GANSS_Common_Data_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Common_Data_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Common_Data_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GANSS_Common_Data_ie_Extensions__item__criticality._const_tab = ____GANSS_Common_Data_ie_Extensions__item__id_tab
    ___GANSS_Common_Data_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Common_Data_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Common_Data_ie_Extensions__item__id_tab
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Common_Data_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Common_Data_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Common_Data_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Common_Data_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Common_Data_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Common_Data_ie_Extensions__item_._ext = None
    _GANSS_Common_Data_ie_Extensions._cont = __GANSS_Common_Data_ie_Extensions__item_
    _GANSS_Common_Data_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Common_Data._cont = ASN1Dict([
        (u'ganss-Ionospheric-Model', _GANSS_Common_Data_ganss_Ionospheric_Model),
        (u'ganss-Rx-Pos', _GANSS_Common_Data_ganss_Rx_Pos),
        (u'ie-Extensions', _GANSS_Common_Data_ie_Extensions),
        ])
    GANSS_Common_Data._ext = []
    
    #-----< GANSS-Common-Data-ExtIEs >-----#
    GANSS_Common_Data_ExtIEs = CLASS(name=u'GANSS-Common-Data-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GANSS_Common_Data_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-Ionospheric-Model')))
    _GANSS_Common_Data_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Earth-Orientation-Parameters')))
    GANSS_Common_Data_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 781), (u'criticality', u'ignore'), (u'Extension', _GANSS_Common_Data_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 782), (u'criticality', u'ignore'), (u'Extension', _GANSS_Common_Data_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-CommonDataInfoReq >-----#
    GANSS_CommonDataInfoReq = SEQ(name=u'GANSS-CommonDataInfoReq', mode=MODE_TYPE)
    _GANSS_CommonDataInfoReq_ionospheric_Model = BOOL(name=u'ionospheric-Model', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_CommonDataInfoReq_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_CommonDataInfoReq_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddIonoModelReq')))
    _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_1 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-EarthOrientParaReq')))
    ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 774), (u'criticality', u'ignore'), (u'Extension', _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 775), (u'criticality', u'ignore'), (u'Extension', _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id._const_tab = ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality._const_tab = ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue._const_tab = ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_CommonDataInfoReq_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_CommonDataInfoReq_ie_Extensions__item__id),
        (u'criticality', ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue),
        ])
    __GANSS_CommonDataInfoReq_ie_Extensions__item_._ext = None
    _GANSS_CommonDataInfoReq_ie_Extensions._cont = __GANSS_CommonDataInfoReq_ie_Extensions__item_
    _GANSS_CommonDataInfoReq_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_CommonDataInfoReq._cont = ASN1Dict([
        (u'ionospheric-Model', _GANSS_CommonDataInfoReq_ionospheric_Model),
        (u'ie-Extensions', _GANSS_CommonDataInfoReq_ie_Extensions),
        ])
    GANSS_CommonDataInfoReq._ext = []
    
    #-----< GANSS-CommonDataInfoReq-ExtIEs >-----#
    GANSS_CommonDataInfoReq_ExtIEs = CLASS(name=u'GANSS-CommonDataInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddIonoModelReq')))
    _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_1 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-EarthOrientParaReq')))
    GANSS_CommonDataInfoReq_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 774), (u'criticality', u'ignore'), (u'Extension', _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 775), (u'criticality', u'ignore'), (u'Extension', _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance >-----#
    GANSS_Data_Bit_Assistance = SEQ(name=u'GANSS-Data-Bit-Assistance', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ganssTod = INT(name=u'ganssTod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=[], er=[])
    _GANSS_Data_Bit_Assistance_dataBitAssistancelist = SEQ_OF(name=u'dataBitAssistancelist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-DataBitAssistanceList')))
    _GANSS_Data_Bit_Assistance_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ie_Extensions._cont = __GANSS_Data_Bit_Assistance_ie_Extensions__item_
    _GANSS_Data_Bit_Assistance_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance._cont = ASN1Dict([
        (u'ganssTod', _GANSS_Data_Bit_Assistance_ganssTod),
        (u'dataBitAssistancelist', _GANSS_Data_Bit_Assistance_dataBitAssistancelist),
        (u'ie-Extensions', _GANSS_Data_Bit_Assistance_ie_Extensions),
        ])
    GANSS_Data_Bit_Assistance._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ExtIEs = CLASS(name=u'GANSS-Data-Bit-Assistance-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-DataBitAssistanceList >-----#
    GANSS_DataBitAssistanceList = SEQ_OF(name=u'GANSS-DataBitAssistanceList', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-DataBitAssistanceItem')))
    GANSS_DataBitAssistanceList._cont = _GANSS_DataBitAssistanceList__item_
    GANSS_DataBitAssistanceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-DataBitAssistanceItem >-----#
    GANSS_DataBitAssistanceItem = SEQ(name=u'GANSS-DataBitAssistanceItem', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceItem_satId = INT(name=u'satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DataBitAssistanceItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList = SEQ_OF(name=u'dataBitAssistanceSgnList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-DataBitAssistanceSgnList')))
    _GANSS_DataBitAssistanceItem_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id),
        (u'criticality', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_._ext = None
    _GANSS_DataBitAssistanceItem_ie_Extensions._cont = __GANSS_DataBitAssistanceItem_ie_Extensions__item_
    _GANSS_DataBitAssistanceItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DataBitAssistanceItem._cont = ASN1Dict([
        (u'satId', _GANSS_DataBitAssistanceItem_satId),
        (u'dataBitAssistanceSgnList', _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList),
        (u'ie-Extensions', _GANSS_DataBitAssistanceItem_ie_Extensions),
        ])
    GANSS_DataBitAssistanceItem._ext = []
    
    #-----< GANSS-DataBitAssistanceItem-ExtIEs >-----#
    GANSS_DataBitAssistanceItem_ExtIEs = CLASS(name=u'GANSS-DataBitAssistanceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_DataBitAssistanceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-DataBitAssistanceSgnList >-----#
    GANSS_DataBitAssistanceSgnList = SEQ_OF(name=u'GANSS-DataBitAssistanceSgnList', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceSgnList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-DataBitAssistanceSgnItem')))
    GANSS_DataBitAssistanceSgnList._cont = _GANSS_DataBitAssistanceSgnList__item_
    GANSS_DataBitAssistanceSgnList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-DataBitAssistanceSgnItem >-----#
    GANSS_DataBitAssistanceSgnItem = SEQ(name=u'GANSS-DataBitAssistanceSgnItem', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceSgnItem_ganss_SignalId = INT(name=u'ganss-SignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Signal-ID')))
    _GANSS_DataBitAssistanceSgnItem_ganssDataBits = BIT_STR(name=u'ganssDataBits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DataBitAssistanceSgnItem_ganssDataBits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id),
        (u'criticality', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_._ext = None
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions._cont = __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DataBitAssistanceSgnItem._cont = ASN1Dict([
        (u'ganss-SignalId', _GANSS_DataBitAssistanceSgnItem_ganss_SignalId),
        (u'ganssDataBits', _GANSS_DataBitAssistanceSgnItem_ganssDataBits),
        (u'ie-Extensions', _GANSS_DataBitAssistanceSgnItem_ie_Extensions),
        ])
    GANSS_DataBitAssistanceSgnItem._ext = []
    
    #-----< GANSS-DataBitAssistanceSgnItem-ExtIEs >-----#
    GANSS_DataBitAssistanceSgnItem_ExtIEs = CLASS(name=u'GANSS-DataBitAssistanceSgnItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_DataBitAssistanceSgnItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance-ReqItem >-----#
    GANSS_Data_Bit_Assistance_ReqItem = SEQ(name=u'GANSS-Data-Bit-Assistance-ReqItem', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ReqItem_ganssTod = INT(name=u'ganssTod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ReqItem_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqItem_ganss_Data_Bit_Assistance_ReqList = SEQ(name=u'ganss-Data-Bit-Assistance-ReqList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Data-Bit-Assistance-ReqList')))
    _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id),
        (u'criticality', ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions._cont = __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_
    _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance_ReqItem._cont = ASN1Dict([
        (u'ganssTod', _GANSS_Data_Bit_Assistance_ReqItem_ganssTod),
        (u'ganss-Data-Bit-Assistance-ReqList', _GANSS_Data_Bit_Assistance_ReqItem_ganss_Data_Bit_Assistance_ReqList),
        (u'iE-Extensions', _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions),
        ])
    GANSS_Data_Bit_Assistance_ReqItem._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ReqItem-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ReqItem_ExtIEs = CLASS(name=u'GANSS-Data-Bit-Assistance-ReqItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ReqItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance-ReqList >-----#
    GANSS_Data_Bit_Assistance_ReqList = SEQ(name=u'GANSS-Data-Bit-Assistance-ReqList', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID = BIT_STR(name=u'dGANSS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval = INT(name=u'ganss-DataBitInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo = SEQ_OF(name=u'ganss-SatelliteInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_ = INT(name='_item_', mode=MODE_TYPE)
    __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo._cont = __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_
    _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id),
        (u'criticality', ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions._cont = __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_
    _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance_ReqList._cont = ASN1Dict([
        (u'dGANSS-Signal-ID', _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID),
        (u'ganss-DataBitInterval', _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval),
        (u'ganss-SatelliteInfo', _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo),
        (u'iE-Extensions', _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions),
        ])
    GANSS_Data_Bit_Assistance_ReqList._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ReqList-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ReqList_ExtIEs = CLASS(name=u'GANSS-Data-Bit-Assistance-ReqList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ReqList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Delta-T >-----#
    GANSS_Delta_T = INT(name=u'GANSS-Delta-T', mode=MODE_TYPE)
    GANSS_Delta_T._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< GANSS-DeltaUT1 >-----#
    GANSS_DeltaUT1 = SEQ(name=u'GANSS-DeltaUT1', mode=MODE_TYPE)
    _GANSS_DeltaUT1_b1 = BIT_STR(name=u'b1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DeltaUT1_b1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_DeltaUT1_b2 = BIT_STR(name=u'b2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DeltaUT1_b2._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_DeltaUT1_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DeltaUT1_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DeltaUT1_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_DeltaUT1_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DeltaUT1_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DeltaUT1_ie_Extensions__item__id._const_tab = ____GANSS_DeltaUT1_ie_Extensions__item__id_tab
    ___GANSS_DeltaUT1_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DeltaUT1_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality._const_tab = ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_DeltaUT1_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_DeltaUT1_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_DeltaUT1_ie_Extensions__item__id),
        (u'criticality', ___GANSS_DeltaUT1_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DeltaUT1_ie_Extensions__item_._ext = None
    _GANSS_DeltaUT1_ie_Extensions._cont = __GANSS_DeltaUT1_ie_Extensions__item_
    _GANSS_DeltaUT1_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DeltaUT1._cont = ASN1Dict([
        (u'b1', _GANSS_DeltaUT1_b1),
        (u'b2', _GANSS_DeltaUT1_b2),
        (u'ie-Extensions', _GANSS_DeltaUT1_ie_Extensions),
        ])
    GANSS_DeltaUT1._ext = []
    
    #-----< GANSS-DeltaUT1-ExtIEs >-----#
    GANSS_DeltaUT1_ExtIEs = CLASS(name=u'GANSS-DeltaUT1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_DeltaUT1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Earth-Orientation-Parameters >-----#
    GANSS_Earth_Orientation_Parameters = SEQ(name=u'GANSS-Earth-Orientation-Parameters', mode=MODE_TYPE)
    _GANSS_Earth_Orientation_Parameters_teop = BIT_STR(name=u'teop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_teop._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmX = BIT_STR(name=u'pmX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmX._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmXdot = BIT_STR(name=u'pmXdot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmXdot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmY = BIT_STR(name=u'pmY', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmY._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmYdot = BIT_STR(name=u'pmYdot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmYdot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_deltaUT1 = BIT_STR(name=u'deltaUT1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_deltaUT1._const_sz = ASN1Set(rv=[31], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_deltaUT1dot = BIT_STR(name=u'deltaUT1dot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_deltaUT1dot._const_sz = ASN1Set(rv=[19], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_._ext = None
    _GANSS_Earth_Orientation_Parameters_ie_Extensions._cont = __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_
    _GANSS_Earth_Orientation_Parameters_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Earth_Orientation_Parameters._cont = ASN1Dict([
        (u'teop', _GANSS_Earth_Orientation_Parameters_teop),
        (u'pmX', _GANSS_Earth_Orientation_Parameters_pmX),
        (u'pmXdot', _GANSS_Earth_Orientation_Parameters_pmXdot),
        (u'pmY', _GANSS_Earth_Orientation_Parameters_pmY),
        (u'pmYdot', _GANSS_Earth_Orientation_Parameters_pmYdot),
        (u'deltaUT1', _GANSS_Earth_Orientation_Parameters_deltaUT1),
        (u'deltaUT1dot', _GANSS_Earth_Orientation_Parameters_deltaUT1dot),
        (u'ie-Extensions', _GANSS_Earth_Orientation_Parameters_ie_Extensions),
        ])
    GANSS_Earth_Orientation_Parameters._ext = []
    
    #-----< GANSS-Earth-Orientation-Parameters-ExtIEs >-----#
    GANSS_Earth_Orientation_Parameters_ExtIEs = CLASS(name=u'GANSS-Earth-Orientation-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Earth_Orientation_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-EarthOrientParaReq >-----#
    GANSS_EarthOrientParaReq = BOOL(name=u'GANSS-EarthOrientParaReq', mode=MODE_TYPE)
    
    #-----< GANSS-GenericDataInfoReqList >-----#
    GANSS_GenericDataInfoReqList = SEQ_OF(name=u'GANSS-GenericDataInfoReqList', mode=MODE_TYPE)
    _GANSS_GenericDataInfoReqList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-GenericDataInfoReqItem')))
    GANSS_GenericDataInfoReqList._cont = _GANSS_GenericDataInfoReqList__item_
    GANSS_GenericDataInfoReqList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-GenericDataInfoReqItem >-----#
    GANSS_GenericDataInfoReqItem = SEQ(name=u'GANSS-GenericDataInfoReqItem', mode=MODE_TYPE)
    _GANSS_GenericDataInfoReqItem_ganss_Id = INT(name=u'ganss-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-ID')), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Navigation_Model_And_Time_Recovery = BOOL(name=u'ganss-Navigation-Model-And-Time-Recovery', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS = BIT_STR(name=u'ganss-Time-Model-GNSS-GNSS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GANSS_GenericDataInfoReqItem_ganss_UTC_Model = BOOL(name=u'ganss-UTC-Model', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Almanac = BOOL(name=u'ganss-Almanac', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Real_Time_Integrity = BOOL(name=u'ganss-Real-Time-Integrity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GenericDataInfoReqItem_ganss_Data_Bit_Assistance_Req = SEQ(name=u'ganss-Data-Bit-Assistance-Req', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Data-Bit-Assistance-ReqItem')), opt=True)
    _GANSS_GenericDataInfoReqItem_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_GenericDataInfoReqItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddNavigationModelsReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_1 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddUTCModelsReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_2 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AuxInfoReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SBAS-ID')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-CorrectionsReq')))
    _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BDS-IonosphericGridModelReq')))
    ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 776), (u'criticality', u'ignore'), (u'Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 777), (u'criticality', u'ignore'), (u'Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 778), (u'criticality', u'ignore'), (u'Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 779), (u'criticality', u'ignore'), (u'Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 948), (u'criticality', u'ignore'), (u'Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 950), (u'criticality', u'ignore'), (u'Extension', _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id._const_tab = ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality._const_tab = ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_GenericDataInfoReqItem_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id),
        (u'criticality', ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_GenericDataInfoReqItem_ie_Extensions__item_._ext = None
    _GANSS_GenericDataInfoReqItem_ie_Extensions._cont = __GANSS_GenericDataInfoReqItem_ie_Extensions__item_
    _GANSS_GenericDataInfoReqItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_GenericDataInfoReqItem._cont = ASN1Dict([
        (u'ganss-Id', _GANSS_GenericDataInfoReqItem_ganss_Id),
        (u'ganss-Navigation-Model-And-Time-Recovery', _GANSS_GenericDataInfoReqItem_ganss_Navigation_Model_And_Time_Recovery),
        (u'ganss-Time-Model-GNSS-GNSS', _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS),
        (u'ganss-UTC-Model', _GANSS_GenericDataInfoReqItem_ganss_UTC_Model),
        (u'ganss-Almanac', _GANSS_GenericDataInfoReqItem_ganss_Almanac),
        (u'ganss-Real-Time-Integrity', _GANSS_GenericDataInfoReqItem_ganss_Real_Time_Integrity),
        (u'ganss-Data-Bit-Assistance-Req', _GANSS_GenericDataInfoReqItem_ganss_Data_Bit_Assistance_Req),
        (u'ie-Extensions', _GANSS_GenericDataInfoReqItem_ie_Extensions),
        ])
    GANSS_GenericDataInfoReqItem._ext = []
    
    #-----< GANSS-GenericDataInfoReqItem-ExtIEs >-----#
    GANSS_GenericDataInfoReqItem_ExtIEs = CLASS(name=u'GANSS-GenericDataInfoReqItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddNavigationModelsReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_1 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddUTCModelsReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_2 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AuxInfoReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SBAS-ID')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-CorrectionsReq')))
    _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BDS-IonosphericGridModelReq')))
    GANSS_GenericDataInfoReqItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 776), (u'criticality', u'ignore'), (u'Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 777), (u'criticality', u'ignore'), (u'Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 778), (u'criticality', u'ignore'), (u'Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 779), (u'criticality', u'ignore'), (u'Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 948), (u'criticality', u'ignore'), (u'Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 950), (u'criticality', u'ignore'), (u'Extension', _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Generic-Data >-----#
    GANSS_Generic_Data = SEQ_OF(name=u'GANSS-Generic-Data', mode=MODE_TYPE)
    _GANSS_Generic_Data__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Generic-DataItem')))
    GANSS_Generic_Data._cont = _GANSS_Generic_Data__item_
    GANSS_Generic_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-Generic-DataItem >-----#
    GANSS_Generic_DataItem = SEQ(name=u'GANSS-Generic-DataItem', mode=MODE_TYPE)
    _GANSS_Generic_DataItem_ganss_Id = INT(name=u'ganss-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-ID')), opt=True)
    _GANSS_Generic_DataItem_dganss_Correction = SEQ(name=u'dganss-Correction', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DGANSSCorrections')), opt=True)
    _GANSS_Generic_DataItem_ganss_Navigation_Model_And_Time_Recovery = SEQ(name=u'ganss-Navigation-Model-And-Time-Recovery', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Navigation-Model-And-Time-Recovery')), opt=True)
    _GANSS_Generic_DataItem_ganss_Time_Model = SEQ(name=u'ganss-Time-Model', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Time-Model')), opt=True)
    _GANSS_Generic_DataItem_ganss_UTC_TIME = SEQ(name=u'ganss-UTC-TIME', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-UTC-Model')), opt=True)
    _GANSS_Generic_DataItem_ganss_Almanac = SEQ(name=u'ganss-Almanac', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Almanac')), opt=True)
    _GANSS_Generic_DataItem_ganss_Real_Time_Integrity = SEQ_OF(name=u'ganss-Real-Time-Integrity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Real-Time-Integrity')), opt=True)
    _GANSS_Generic_DataItem_ganss_Data_Bit_Assistance = SEQ(name=u'ganss-Data-Bit-Assistance', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Data-Bit-Assistance')), opt=True)
    _GANSS_Generic_DataItem_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Generic_DataItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Generic_DataItem_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-Time-Models')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-Navigation-Models')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-UTC-Models')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Auxiliary-Information')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SBAS-ID')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-Corrections')))
    _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BDS-Ionospheric-Grid-Model')))
    ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 783), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 784), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 785), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 786), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 779), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 949), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 951), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Generic_DataItem_ie_Extensions__item__id._const_tab = ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab
    ___GANSS_Generic_DataItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Generic_DataItem_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality._const_tab = ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Generic_DataItem_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Generic_DataItem_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Generic_DataItem_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Generic_DataItem_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Generic_DataItem_ie_Extensions__item_._ext = None
    _GANSS_Generic_DataItem_ie_Extensions._cont = __GANSS_Generic_DataItem_ie_Extensions__item_
    _GANSS_Generic_DataItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Generic_DataItem._cont = ASN1Dict([
        (u'ganss-Id', _GANSS_Generic_DataItem_ganss_Id),
        (u'dganss-Correction', _GANSS_Generic_DataItem_dganss_Correction),
        (u'ganss-Navigation-Model-And-Time-Recovery', _GANSS_Generic_DataItem_ganss_Navigation_Model_And_Time_Recovery),
        (u'ganss-Time-Model', _GANSS_Generic_DataItem_ganss_Time_Model),
        (u'ganss-UTC-TIME', _GANSS_Generic_DataItem_ganss_UTC_TIME),
        (u'ganss-Almanac', _GANSS_Generic_DataItem_ganss_Almanac),
        (u'ganss-Real-Time-Integrity', _GANSS_Generic_DataItem_ganss_Real_Time_Integrity),
        (u'ganss-Data-Bit-Assistance', _GANSS_Generic_DataItem_ganss_Data_Bit_Assistance),
        (u'ie-Extensions', _GANSS_Generic_DataItem_ie_Extensions),
        ])
    GANSS_Generic_DataItem._ext = []
    
    #-----< GANSS-Generic-DataItem-ExtIEs >-----#
    GANSS_Generic_DataItem_ExtIEs = CLASS(name=u'GANSS-Generic-DataItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-Time-Models')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-Navigation-Models')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Additional-UTC-Models')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Auxiliary-Information')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SBAS-ID')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DBDS-Corrections')))
    _GANSS_Generic_DataItem_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BDS-Ionospheric-Grid-Model')))
    GANSS_Generic_DataItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 783), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 784), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 785), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 786), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 779), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 949), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 951), (u'criticality', u'ignore'), (u'Extension', _GANSS_Generic_DataItem_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-GLONASSclockModel >-----#
    GANSS_GLONASSclockModel = SEQ(name=u'GANSS-GLONASSclockModel', mode=MODE_TYPE)
    _GANSS_GLONASSclockModel_gloTau = BIT_STR(name=u'gloTau', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_GLONASSclockModel_gloTau._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_GLONASSclockModel_gloGamma = BIT_STR(name=u'gloGamma', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_GLONASSclockModel_gloGamma._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_GLONASSclockModel_gloDeltaTau = BIT_STR(name=u'gloDeltaTau', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_GLONASSclockModel_gloDeltaTau._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_GLONASSclockModel_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_GLONASSclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id._const_tab = ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_GLONASSclockModel_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_GLONASSclockModel_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_GLONASSclockModel_ie_Extensions__item__id),
        (u'criticality', ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_GLONASSclockModel_ie_Extensions__item_._ext = None
    _GANSS_GLONASSclockModel_ie_Extensions._cont = __GANSS_GLONASSclockModel_ie_Extensions__item_
    _GANSS_GLONASSclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_GLONASSclockModel._cont = ASN1Dict([
        (u'gloTau', _GANSS_GLONASSclockModel_gloTau),
        (u'gloGamma', _GANSS_GLONASSclockModel_gloGamma),
        (u'gloDeltaTau', _GANSS_GLONASSclockModel_gloDeltaTau),
        (u'ie-Extensions', _GANSS_GLONASSclockModel_ie_Extensions),
        ])
    GANSS_GLONASSclockModel._ext = []
    
    #-----< GANSS-GLONASSclockModel-ExtIEs >-----#
    GANSS_GLONASSclockModel_ExtIEs = CLASS(name=u'GANSS-GLONASSclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_GLONASSclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ID >-----#
    GANSS_ID = INT(name=u'GANSS-ID', mode=MODE_TYPE)
    GANSS_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< GANSS-Information >-----#
    GANSS_Information = SEQ(name=u'GANSS-Information', mode=MODE_TYPE)
    _GANSS_Information_gANSS_CommonDataInfoReq = SEQ(name=u'gANSS-CommonDataInfoReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-CommonDataInfoReq')), opt=True)
    _GANSS_Information_gANSS_GenericDataInfoReqList = SEQ_OF(name=u'gANSS-GenericDataInfoReqList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-GenericDataInfoReqList')), opt=True)
    _GANSS_Information_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Information_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Information_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Information_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Information_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Information_ie_Extensions__item__id._const_tab = ____GANSS_Information_ie_Extensions__item__id_tab
    ___GANSS_Information_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Information_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Information_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Information_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Information_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Information_ie_Extensions__item__criticality._const_tab = ____GANSS_Information_ie_Extensions__item__criticality_tab
    ___GANSS_Information_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Information_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Information_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Information_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Information_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Information_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Information_ie_Extensions__item__extensionValue_tab
    ___GANSS_Information_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Information_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Information_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Information_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Information_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Information_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Information_ie_Extensions__item_._ext = None
    _GANSS_Information_ie_Extensions._cont = __GANSS_Information_ie_Extensions__item_
    _GANSS_Information_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Information._cont = ASN1Dict([
        (u'gANSS-CommonDataInfoReq', _GANSS_Information_gANSS_CommonDataInfoReq),
        (u'gANSS-GenericDataInfoReqList', _GANSS_Information_gANSS_GenericDataInfoReqList),
        (u'ie-Extensions', _GANSS_Information_ie_Extensions),
        ])
    GANSS_Information._ext = []
    
    #-----< GANSS-Information-ExtIEs >-----#
    GANSS_Information_ExtIEs = CLASS(name=u'GANSS-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Ionospheric-Model >-----#
    GANSS_Ionospheric_Model = SEQ(name=u'GANSS-Ionospheric-Model', mode=MODE_TYPE)
    _GANSS_Ionospheric_Model_alpha_zero_ionos = BIT_STR(name=u'alpha-zero-ionos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_zero_ionos._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_alpha_one_ionos = BIT_STR(name=u'alpha-one-ionos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_one_ionos._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_alpha_two_ionos = BIT_STR(name=u'alpha-two-ionos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_two_ionos._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags = SEQ(name=u'gANSS-IonosphereRegionalStormFlags', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-IonosphereRegionalStormFlags')), opt=True)
    _GANSS_Ionospheric_Model_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Ionospheric_Model_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GANSS_Ionospheric_Model_ie_Extensions._cont = __GANSS_Ionospheric_Model_ie_Extensions__item_
    _GANSS_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Ionospheric_Model._cont = ASN1Dict([
        (u'alpha-zero-ionos', _GANSS_Ionospheric_Model_alpha_zero_ionos),
        (u'alpha-one-ionos', _GANSS_Ionospheric_Model_alpha_one_ionos),
        (u'alpha-two-ionos', _GANSS_Ionospheric_Model_alpha_two_ionos),
        (u'gANSS-IonosphereRegionalStormFlags', _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags),
        (u'ie-Extensions', _GANSS_Ionospheric_Model_ie_Extensions),
        ])
    GANSS_Ionospheric_Model._ext = []
    
    #-----< GANSS-Ionospheric-Model-ExtIEs >-----#
    GANSS_Ionospheric_Model_ExtIEs = CLASS(name=u'GANSS-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-IonosphereRegionalStormFlags >-----#
    GANSS_IonosphereRegionalStormFlags = SEQ(name=u'GANSS-IonosphereRegionalStormFlags', mode=MODE_TYPE)
    _GANSS_IonosphereRegionalStormFlags_storm_flag_one = BOOL(name=u'storm-flag-one', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_two = BOOL(name=u'storm-flag-two', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_three = BOOL(name=u'storm-flag-three', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_four = BOOL(name=u'storm-flag-four', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_five = BOOL(name=u'storm-flag-five', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id),
        (u'criticality', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue),
        ])
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_._ext = None
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions._cont = __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_IonosphereRegionalStormFlags._cont = ASN1Dict([
        (u'storm-flag-one', _GANSS_IonosphereRegionalStormFlags_storm_flag_one),
        (u'storm-flag-two', _GANSS_IonosphereRegionalStormFlags_storm_flag_two),
        (u'storm-flag-three', _GANSS_IonosphereRegionalStormFlags_storm_flag_three),
        (u'storm-flag-four', _GANSS_IonosphereRegionalStormFlags_storm_flag_four),
        (u'storm-flag-five', _GANSS_IonosphereRegionalStormFlags_storm_flag_five),
        (u'ie-Extensions', _GANSS_IonosphereRegionalStormFlags_ie_Extensions),
        ])
    GANSS_IonosphereRegionalStormFlags._ext = []
    
    #-----< GANSS-IonosphereRegionalStormFlags-ExtIEs >-----#
    GANSS_IonosphereRegionalStormFlags_ExtIEs = CLASS(name=u'GANSS-IonosphereRegionalStormFlags-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_IonosphereRegionalStormFlags_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NAVclockModel >-----#
    GANSS_NAVclockModel = SEQ(name=u'GANSS-NAVclockModel', mode=MODE_TYPE)
    _GANSS_NAVclockModel_navToc = BIT_STR(name=u'navToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navToc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navaf2 = BIT_STR(name=u'navaf2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navaf2._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navaf1 = BIT_STR(name=u'navaf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navaf1._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navaf0 = BIT_STR(name=u'navaf0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navaf0._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_navTgd = BIT_STR(name=u'navTgd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NAVclockModel_navTgd._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_NAVclockModel_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NAVclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NAVclockModel_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_NAVclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NAVclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NAVclockModel_ie_Extensions__item__id._const_tab = ____GANSS_NAVclockModel_ie_Extensions__item__id_tab
    ___GANSS_NAVclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NAVclockModel_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_NAVclockModel_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_NAVclockModel_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_NAVclockModel_ie_Extensions__item__id),
        (u'criticality', ___GANSS_NAVclockModel_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NAVclockModel_ie_Extensions__item_._ext = None
    _GANSS_NAVclockModel_ie_Extensions._cont = __GANSS_NAVclockModel_ie_Extensions__item_
    _GANSS_NAVclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NAVclockModel._cont = ASN1Dict([
        (u'navToc', _GANSS_NAVclockModel_navToc),
        (u'navaf2', _GANSS_NAVclockModel_navaf2),
        (u'navaf1', _GANSS_NAVclockModel_navaf1),
        (u'navaf0', _GANSS_NAVclockModel_navaf0),
        (u'navTgd', _GANSS_NAVclockModel_navTgd),
        (u'ie-Extensions', _GANSS_NAVclockModel_ie_Extensions),
        ])
    GANSS_NAVclockModel._ext = []
    
    #-----< GANSS-NAVclockModel-ExtIEs >-----#
    GANSS_NAVclockModel_ExtIEs = CLASS(name=u'GANSS-NAVclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_NAVclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Navigation-Model-And-Time-Recovery >-----#
    GANSS_Navigation_Model_And_Time_Recovery = SEQ(name=u'GANSS-Navigation-Model-And-Time-Recovery', mode=MODE_TYPE)
    _GANSS_Navigation_Model_And_Time_Recovery_ganss_Transmission_Time = SEQ(name=u'ganss-Transmission-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Transmission-Time')))
    _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication = ENUM(name=u'non-broadcastIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication._cont = ASN1Dict([(u'true', 0)])
    _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication._ext = None
    _GANSS_Navigation_Model_And_Time_Recovery_ganssSatInfoNav = SEQ_OF(name=u'ganssSatInfoNav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Sat-Info-Nav')))
    _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id._const_tab = ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality._const_tab = ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_._ext = None
    _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions._cont = __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_
    _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Navigation_Model_And_Time_Recovery._cont = ASN1Dict([
        (u'ganss-Transmission-Time', _GANSS_Navigation_Model_And_Time_Recovery_ganss_Transmission_Time),
        (u'non-broadcastIndication', _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication),
        (u'ganssSatInfoNav', _GANSS_Navigation_Model_And_Time_Recovery_ganssSatInfoNav),
        (u'ie-Extensions', _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions),
        ])
    GANSS_Navigation_Model_And_Time_Recovery._ext = []
    
    #-----< GANSS-Navigation-Model-And-Time-Recovery-ExtIEs >-----#
    GANSS_Navigation_Model_And_Time_Recovery_ExtIEs = CLASS(name=u'GANSS-Navigation-Model-And-Time-Recovery-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Navigation_Model_And_Time_Recovery_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-BDSKeplerianSet >-----#
    GANSS_NavModel_BDSKeplerianSet = SEQ(name=u'GANSS-NavModel-BDSKeplerianSet', mode=MODE_TYPE)
    _GANSS_NavModel_BDSKeplerianSet_bdsURAI = BIT_STR(name=u'bdsURAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsURAI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsToe = BIT_STR(name=u'bdsToe', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsToe._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf = BIT_STR(name=u'bdsAPowerHalf', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsE = BIT_STR(name=u'bdsE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsE._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsW = BIT_STR(name=u'bdsW', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsW._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN = BIT_STR(name=u'bdsDeltaN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsM0 = BIT_STR(name=u'bdsM0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsM0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsOmega0 = BIT_STR(name=u'bdsOmega0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsOmega0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot = BIT_STR(name=u'bdsOmegaDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsI0 = BIT_STR(name=u'bdsI0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsI0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsIDot = BIT_STR(name=u'bdsIDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsIDot._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCuc = BIT_STR(name=u'bdsCuc', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCuc._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCus = BIT_STR(name=u'bdsCus', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCus._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCrc = BIT_STR(name=u'bdsCrc', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCrc._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCrs = BIT_STR(name=u'bdsCrs', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCrs._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCic = BIT_STR(name=u'bdsCic', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCic._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsCis = BIT_STR(name=u'bdsCis', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsCis._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_bdsAODE = BIT_STR(name=u'bdsAODE', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_BDSKeplerianSet_bdsAODE._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_BDSKeplerianSet_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id._const_tab = ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id_tab
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality._const_tab = ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality_tab
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id),
        (u'criticality', ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item_._ext = None
    _GANSS_NavModel_BDSKeplerianSet_iE_Extensions._cont = __GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item_
    _GANSS_NavModel_BDSKeplerianSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_BDSKeplerianSet._cont = ASN1Dict([
        (u'bdsURAI', _GANSS_NavModel_BDSKeplerianSet_bdsURAI),
        (u'bdsToe', _GANSS_NavModel_BDSKeplerianSet_bdsToe),
        (u'bdsAPowerHalf', _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf),
        (u'bdsE', _GANSS_NavModel_BDSKeplerianSet_bdsE),
        (u'bdsW', _GANSS_NavModel_BDSKeplerianSet_bdsW),
        (u'bdsDeltaN', _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN),
        (u'bdsM0', _GANSS_NavModel_BDSKeplerianSet_bdsM0),
        (u'bdsOmega0', _GANSS_NavModel_BDSKeplerianSet_bdsOmega0),
        (u'bdsOmegaDot', _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot),
        (u'bdsI0', _GANSS_NavModel_BDSKeplerianSet_bdsI0),
        (u'bdsIDot', _GANSS_NavModel_BDSKeplerianSet_bdsIDot),
        (u'bdsCuc', _GANSS_NavModel_BDSKeplerianSet_bdsCuc),
        (u'bdsCus', _GANSS_NavModel_BDSKeplerianSet_bdsCus),
        (u'bdsCrc', _GANSS_NavModel_BDSKeplerianSet_bdsCrc),
        (u'bdsCrs', _GANSS_NavModel_BDSKeplerianSet_bdsCrs),
        (u'bdsCic', _GANSS_NavModel_BDSKeplerianSet_bdsCic),
        (u'bdsCis', _GANSS_NavModel_BDSKeplerianSet_bdsCis),
        (u'bdsAODE', _GANSS_NavModel_BDSKeplerianSet_bdsAODE),
        (u'iE-Extensions', _GANSS_NavModel_BDSKeplerianSet_iE_Extensions),
        ])
    GANSS_NavModel_BDSKeplerianSet._ext = []
    
    #-----< GANSS-NavModel-BDSKeplerianSet-ExtIEs >-----#
    GANSS_NavModel_BDSKeplerianSet_ExtIEs = CLASS(name=u'GANSS-NavModel-BDSKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_BDSKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-CNAVKeplerianSet >-----#
    GANSS_NavModel_CNAVKeplerianSet = SEQ(name=u'GANSS-NavModel-CNAVKeplerianSet', mode=MODE_TYPE)
    _GANSS_NavModel_CNAVKeplerianSet_cnavTop = BIT_STR(name=u'cnavTop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavTop._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex = BIT_STR(name=u'cnavURAindex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA = BIT_STR(name=u'cnavDeltaA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavAdot = BIT_STR(name=u'cnavAdot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavAdot._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo = BIT_STR(name=u'cnavDeltaNo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot = BIT_STR(name=u'cnavDeltaNoDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavMo = BIT_STR(name=u'cnavMo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavMo._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavE = BIT_STR(name=u'cnavE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavE._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavOmega = BIT_STR(name=u'cnavOmega', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavOmega._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0 = BIT_STR(name=u'cnavOMEGA0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot = BIT_STR(name=u'cnavDeltaOmegaDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavIo = BIT_STR(name=u'cnavIo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavIo._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot = BIT_STR(name=u'cnavIoDot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCis = BIT_STR(name=u'cnavCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCis._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCic = BIT_STR(name=u'cnavCic', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrs = BIT_STR(name=u'cnavCrs', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrs._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrc = BIT_STR(name=u'cnavCrc', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCrc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCus = BIT_STR(name=u'cnavCus', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCus._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_cnavCuc = BIT_STR(name=u'cnavCuc', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_CNAVKeplerianSet_cnavCuc._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id),
        (u'criticality', ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions._cont = __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_
    _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_CNAVKeplerianSet._cont = ASN1Dict([
        (u'cnavTop', _GANSS_NavModel_CNAVKeplerianSet_cnavTop),
        (u'cnavURAindex', _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex),
        (u'cnavDeltaA', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA),
        (u'cnavAdot', _GANSS_NavModel_CNAVKeplerianSet_cnavAdot),
        (u'cnavDeltaNo', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo),
        (u'cnavDeltaNoDot', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot),
        (u'cnavMo', _GANSS_NavModel_CNAVKeplerianSet_cnavMo),
        (u'cnavE', _GANSS_NavModel_CNAVKeplerianSet_cnavE),
        (u'cnavOmega', _GANSS_NavModel_CNAVKeplerianSet_cnavOmega),
        (u'cnavOMEGA0', _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0),
        (u'cnavDeltaOmegaDot', _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot),
        (u'cnavIo', _GANSS_NavModel_CNAVKeplerianSet_cnavIo),
        (u'cnavIoDot', _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot),
        (u'cnavCis', _GANSS_NavModel_CNAVKeplerianSet_cnavCis),
        (u'cnavCic', _GANSS_NavModel_CNAVKeplerianSet_cnavCic),
        (u'cnavCrs', _GANSS_NavModel_CNAVKeplerianSet_cnavCrs),
        (u'cnavCrc', _GANSS_NavModel_CNAVKeplerianSet_cnavCrc),
        (u'cnavCus', _GANSS_NavModel_CNAVKeplerianSet_cnavCus),
        (u'cnavCuc', _GANSS_NavModel_CNAVKeplerianSet_cnavCuc),
        (u'ie-Extensions', _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions),
        ])
    GANSS_NavModel_CNAVKeplerianSet._ext = []
    
    #-----< GANSS-NavModel-CNAVKeplerianSet-ExtIEs >-----#
    GANSS_NavModel_CNAVKeplerianSet_ExtIEs = CLASS(name=u'GANSS-NavModel-CNAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_CNAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-GLONASSecef >-----#
    GANSS_NavModel_GLONASSecef = SEQ(name=u'GANSS-NavModel-GLONASSecef', mode=MODE_TYPE)
    _GANSS_NavModel_GLONASSecef_gloEn = BIT_STR(name=u'gloEn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloEn._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloP1 = BIT_STR(name=u'gloP1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloP1._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloP2 = BIT_STR(name=u'gloP2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloP2._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloM = BIT_STR(name=u'gloM', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_NavModel_GLONASSecef_gloM._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloX = BIT_STR(name=u'gloX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloX._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloXdot = BIT_STR(name=u'gloXdot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloXdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloXdotdot = BIT_STR(name=u'gloXdotdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloXdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloY = BIT_STR(name=u'gloY', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloY._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloYdot = BIT_STR(name=u'gloYdot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloYdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloYdotdot = BIT_STR(name=u'gloYdotdot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloYdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloZ = BIT_STR(name=u'gloZ', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloZ._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloZdot = BIT_STR(name=u'gloZdot', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloZdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_gloZdotdot = BIT_STR(name=u'gloZdotdot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_GLONASSecef_gloZdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_NavModel_GLONASSecef_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_GLONASSecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_NavModel_GLONASSecef_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id),
        (u'criticality', ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_GLONASSecef_ie_Extensions__item_._ext = None
    _GANSS_NavModel_GLONASSecef_ie_Extensions._cont = __GANSS_NavModel_GLONASSecef_ie_Extensions__item_
    _GANSS_NavModel_GLONASSecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_GLONASSecef._cont = ASN1Dict([
        (u'gloEn', _GANSS_NavModel_GLONASSecef_gloEn),
        (u'gloP1', _GANSS_NavModel_GLONASSecef_gloP1),
        (u'gloP2', _GANSS_NavModel_GLONASSecef_gloP2),
        (u'gloM', _GANSS_NavModel_GLONASSecef_gloM),
        (u'gloX', _GANSS_NavModel_GLONASSecef_gloX),
        (u'gloXdot', _GANSS_NavModel_GLONASSecef_gloXdot),
        (u'gloXdotdot', _GANSS_NavModel_GLONASSecef_gloXdotdot),
        (u'gloY', _GANSS_NavModel_GLONASSecef_gloY),
        (u'gloYdot', _GANSS_NavModel_GLONASSecef_gloYdot),
        (u'gloYdotdot', _GANSS_NavModel_GLONASSecef_gloYdotdot),
        (u'gloZ', _GANSS_NavModel_GLONASSecef_gloZ),
        (u'gloZdot', _GANSS_NavModel_GLONASSecef_gloZdot),
        (u'gloZdotdot', _GANSS_NavModel_GLONASSecef_gloZdotdot),
        (u'ie-Extensions', _GANSS_NavModel_GLONASSecef_ie_Extensions),
        ])
    GANSS_NavModel_GLONASSecef._ext = []
    
    #-----< GANSS-NavModel-GLONASSecef-ExtIEs >-----#
    GANSS_NavModel_GLONASSecef_ExtIEs = CLASS(name=u'GANSS-NavModel-GLONASSecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_GLONASSecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-NAVKeplerianSet >-----#
    GANSS_NavModel_NAVKeplerianSet = SEQ(name=u'GANSS-NavModel-NAVKeplerianSet', mode=MODE_TYPE)
    _GANSS_NavModel_NAVKeplerianSet_navURA = BIT_STR(name=u'navURA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navURA._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navFitFlag = BIT_STR(name=u'navFitFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navFitFlag._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navToe = BIT_STR(name=u'navToe', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navToe._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navOmega = BIT_STR(name=u'navOmega', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navOmega._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navDeltaN = BIT_STR(name=u'navDeltaN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navDeltaN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navM0 = BIT_STR(name=u'navM0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navM0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navOmegaADot = BIT_STR(name=u'navOmegaADot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navOmegaADot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navE = BIT_STR(name=u'navE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navE._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navIDot = BIT_STR(name=u'navIDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navIDot._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf = BIT_STR(name=u'navAPowerHalf', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navI0 = BIT_STR(name=u'navI0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navI0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navOmegaA0 = BIT_STR(name=u'navOmegaA0', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navOmegaA0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCrs = BIT_STR(name=u'navCrs', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCrs._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCis = BIT_STR(name=u'navCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCis._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCus = BIT_STR(name=u'navCus', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCus._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCrc = BIT_STR(name=u'navCrc', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCrc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCic = BIT_STR(name=u'navCic', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_navCuc = BIT_STR(name=u'navCuc', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_NAVKeplerianSet_navCuc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_NavModel_NAVKeplerianSet_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id),
        (u'criticality', ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_NavModel_NAVKeplerianSet_ie_Extensions._cont = __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_
    _GANSS_NavModel_NAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_NAVKeplerianSet._cont = ASN1Dict([
        (u'navURA', _GANSS_NavModel_NAVKeplerianSet_navURA),
        (u'navFitFlag', _GANSS_NavModel_NAVKeplerianSet_navFitFlag),
        (u'navToe', _GANSS_NavModel_NAVKeplerianSet_navToe),
        (u'navOmega', _GANSS_NavModel_NAVKeplerianSet_navOmega),
        (u'navDeltaN', _GANSS_NavModel_NAVKeplerianSet_navDeltaN),
        (u'navM0', _GANSS_NavModel_NAVKeplerianSet_navM0),
        (u'navOmegaADot', _GANSS_NavModel_NAVKeplerianSet_navOmegaADot),
        (u'navE', _GANSS_NavModel_NAVKeplerianSet_navE),
        (u'navIDot', _GANSS_NavModel_NAVKeplerianSet_navIDot),
        (u'navAPowerHalf', _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf),
        (u'navI0', _GANSS_NavModel_NAVKeplerianSet_navI0),
        (u'navOmegaA0', _GANSS_NavModel_NAVKeplerianSet_navOmegaA0),
        (u'navCrs', _GANSS_NavModel_NAVKeplerianSet_navCrs),
        (u'navCis', _GANSS_NavModel_NAVKeplerianSet_navCis),
        (u'navCus', _GANSS_NavModel_NAVKeplerianSet_navCus),
        (u'navCrc', _GANSS_NavModel_NAVKeplerianSet_navCrc),
        (u'navCic', _GANSS_NavModel_NAVKeplerianSet_navCic),
        (u'navCuc', _GANSS_NavModel_NAVKeplerianSet_navCuc),
        (u'ie-Extensions', _GANSS_NavModel_NAVKeplerianSet_ie_Extensions),
        ])
    GANSS_NavModel_NAVKeplerianSet._ext = []
    
    #-----< GANSS-NavModel-NAVKeplerianSet-ExtIEs >-----#
    GANSS_NavModel_NAVKeplerianSet_ExtIEs = CLASS(name=u'GANSS-NavModel-NAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_NAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-NavModel-SBASecef >-----#
    GANSS_NavModel_SBASecef = SEQ(name=u'GANSS-NavModel-SBASecef', mode=MODE_TYPE)
    _GANSS_NavModel_SBASecef_sbasTo = BIT_STR(name=u'sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_NavModel_SBASecef_sbasTo._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasAccuracy = BIT_STR(name=u'sbasAccuracy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasAccuracy._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasXg = BIT_STR(name=u'sbasXg', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasXg._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasYg = BIT_STR(name=u'sbasYg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasYg._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasZg = BIT_STR(name=u'sbasZg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasZg._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasXgDot = BIT_STR(name=u'sbasXgDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasXgDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasYgDot = BIT_STR(name=u'sbasYgDot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasYgDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasZgDot = BIT_STR(name=u'sbasZgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasZgDot._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasXgDotDot = BIT_STR(name=u'sbasXgDotDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasXgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbagYgDotDot = BIT_STR(name=u'sbagYgDotDot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbagYgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_sbasZgDotDot = BIT_STR(name=u'sbasZgDotDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_NavModel_SBASecef_sbasZgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_NavModel_SBASecef_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_NavModel_SBASecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id._const_tab = ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality._const_tab = ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab = ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_NavModel_SBASecef_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_NavModel_SBASecef_ie_Extensions__item__id),
        (u'criticality', ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue),
        ])
    __GANSS_NavModel_SBASecef_ie_Extensions__item_._ext = None
    _GANSS_NavModel_SBASecef_ie_Extensions._cont = __GANSS_NavModel_SBASecef_ie_Extensions__item_
    _GANSS_NavModel_SBASecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_NavModel_SBASecef._cont = ASN1Dict([
        (u'sbasTo', _GANSS_NavModel_SBASecef_sbasTo),
        (u'sbasAccuracy', _GANSS_NavModel_SBASecef_sbasAccuracy),
        (u'sbasXg', _GANSS_NavModel_SBASecef_sbasXg),
        (u'sbasYg', _GANSS_NavModel_SBASecef_sbasYg),
        (u'sbasZg', _GANSS_NavModel_SBASecef_sbasZg),
        (u'sbasXgDot', _GANSS_NavModel_SBASecef_sbasXgDot),
        (u'sbasYgDot', _GANSS_NavModel_SBASecef_sbasYgDot),
        (u'sbasZgDot', _GANSS_NavModel_SBASecef_sbasZgDot),
        (u'sbasXgDotDot', _GANSS_NavModel_SBASecef_sbasXgDotDot),
        (u'sbagYgDotDot', _GANSS_NavModel_SBASecef_sbagYgDotDot),
        (u'sbasZgDotDot', _GANSS_NavModel_SBASecef_sbasZgDotDot),
        (u'ie-Extensions', _GANSS_NavModel_SBASecef_ie_Extensions),
        ])
    GANSS_NavModel_SBASecef._ext = []
    
    #-----< GANSS-NavModel-SBASecef-ExtIEs >-----#
    GANSS_NavModel_SBASecef_ExtIEs = CLASS(name=u'GANSS-NavModel-SBASecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_NavModel_SBASecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Orbit-Model >-----#
    GANSS_Orbit_Model = CHOICE(name=u'GANSS-Orbit-Model', mode=MODE_TYPE)
    _GANSS_Orbit_Model_gANSS_keplerianParameters = SEQ(name=u'gANSS-keplerianParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_toe_nav = BIT_STR(name=u'toe-nav', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_toe_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_omega_nav = BIT_STR(name=u'ganss-omega-nav', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_omega_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_delta_n_nav = BIT_STR(name=u'delta-n-nav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_delta_n_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_m_zero_nav = BIT_STR(name=u'm-zero-nav', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_m_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_omegadot_nav = BIT_STR(name=u'omegadot-nav', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_omegadot_nav._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_e_nav = BIT_STR(name=u'ganss-e-nav', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_e_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_idot_nav = BIT_STR(name=u'idot-nav', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_idot_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_a_sqrt_nav = BIT_STR(name=u'a-sqrt-nav', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_a_sqrt_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_i_zero_nav = BIT_STR(name=u'i-zero-nav', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_i_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_omega_zero_nav = BIT_STR(name=u'omega-zero-nav', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_omega_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rs_nav = BIT_STR(name=u'c-rs-nav', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rs_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_is_nav = BIT_STR(name=u'c-is-nav', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_is_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_us_nav = BIT_STR(name=u'c-us-nav', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_us_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rc_nav = BIT_STR(name=u'c-rc-nav', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_ic_nav = BIT_STR(name=u'c-ic-nav', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_ic_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_uc_nav = BIT_STR(name=u'c-uc-nav', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Orbit_Model_gANSS_keplerianParameters_c_uc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id._const_tab = _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id_tab
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id._const_tab_at = None
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality._const_tab = _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue._const_tab = _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id),
        (u'criticality', ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue),
        ])
    ___GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item_._ext = None
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions._cont = ___GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item_
    __GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_Orbit_Model_gANSS_keplerianParameters._cont = ASN1Dict([
        (u'toe-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_toe_nav),
        (u'ganss-omega-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_omega_nav),
        (u'delta-n-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_delta_n_nav),
        (u'm-zero-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_m_zero_nav),
        (u'omegadot-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_omegadot_nav),
        (u'ganss-e-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_e_nav),
        (u'idot-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_idot_nav),
        (u'a-sqrt-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_a_sqrt_nav),
        (u'i-zero-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_i_zero_nav),
        (u'omega-zero-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_omega_zero_nav),
        (u'c-rs-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rs_nav),
        (u'c-is-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_c_is_nav),
        (u'c-us-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_c_us_nav),
        (u'c-rc-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rc_nav),
        (u'c-ic-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_c_ic_nav),
        (u'c-uc-nav', __GANSS_Orbit_Model_gANSS_keplerianParameters_c_uc_nav),
        (u'ie-Extensions', __GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions),
        ])
    _GANSS_Orbit_Model_gANSS_keplerianParameters._ext = []
    GANSS_Orbit_Model._cont = ASN1Dict([
        (u'gANSS-keplerianParameters', _GANSS_Orbit_Model_gANSS_keplerianParameters),
        ])
    GANSS_Orbit_Model._ext = []
    
    #-----< GANSS-KeplerianParametersOrb-ExtIEs >-----#
    GANSS_KeplerianParametersOrb_ExtIEs = CLASS(name=u'GANSS-KeplerianParametersOrb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_KeplerianParametersOrb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Real-Time-Integrity >-----#
    GANSS_Real_Time_Integrity = SEQ_OF(name=u'GANSS-Real-Time-Integrity', mode=MODE_TYPE)
    _GANSS_Real_Time_Integrity__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_Real_Time_Integrity__item__bad_ganss_satId = INT(name=u'bad-ganss-satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Real_Time_Integrity__item__bad_ganss_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_Real_Time_Integrity__item__bad_ganss_signalId = BIT_STR(name=u'bad-ganss-signalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_Real_Time_Integrity__item__bad_ganss_signalId._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_Real_Time_Integrity__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_Real_Time_Integrity__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id._const_tab = _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id_tab
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality._const_tab = _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality_tab
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_Real_Time_Integrity__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_Real_Time_Integrity__item__ie_Extensions__item_._ext = None
    __GANSS_Real_Time_Integrity__item__ie_Extensions._cont = ___GANSS_Real_Time_Integrity__item__ie_Extensions__item_
    __GANSS_Real_Time_Integrity__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_Real_Time_Integrity__item_._cont = ASN1Dict([
        (u'bad-ganss-satId', __GANSS_Real_Time_Integrity__item__bad_ganss_satId),
        (u'bad-ganss-signalId', __GANSS_Real_Time_Integrity__item__bad_ganss_signalId),
        (u'ie-Extensions', __GANSS_Real_Time_Integrity__item__ie_Extensions),
        ])
    _GANSS_Real_Time_Integrity__item_._ext = []
    GANSS_Real_Time_Integrity._cont = _GANSS_Real_Time_Integrity__item_
    GANSS_Real_Time_Integrity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-RealTimeInformationItem-ExtIEs >-----#
    GANSS_RealTimeInformationItem_ExtIEs = CLASS(name=u'GANSS-RealTimeInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_RealTimeInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-RX-Pos >-----#
    GANSS_RX_Pos = SEQ(name=u'GANSS-RX-Pos', mode=MODE_TYPE)
    _GANSS_RX_Pos_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _GANSS_RX_Pos_latitudeSign._ext = None
    _GANSS_RX_Pos_degreesOfLatitude = INT(name=u'degreesOfLatitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_degreesOfLatitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _GANSS_RX_Pos_degreesOfLongitude = INT(name=u'degreesOfLongitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_degreesOfLongitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _GANSS_RX_Pos_directionOfAltitude = ENUM(name=u'directionOfAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_directionOfAltitude._cont = ASN1Dict([(u'height', 0), (u'depth', 1)])
    _GANSS_RX_Pos_directionOfAltitude._ext = None
    _GANSS_RX_Pos_altitude = INT(name=u'altitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RX_Pos_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _GANSS_RX_Pos_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_RX_Pos_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_RX_Pos_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_RX_Pos_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_RX_Pos_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RX_Pos_ie_Extensions__item__id._const_tab = ____GANSS_RX_Pos_ie_Extensions__item__id_tab
    ___GANSS_RX_Pos_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_RX_Pos_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_RX_Pos_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RX_Pos_ie_Extensions__item__criticality._const_tab = ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab
    ___GANSS_RX_Pos_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_RX_Pos_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue._const_tab = ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_RX_Pos_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_RX_Pos_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_RX_Pos_ie_Extensions__item__id),
        (u'criticality', ___GANSS_RX_Pos_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_RX_Pos_ie_Extensions__item__extensionValue),
        ])
    __GANSS_RX_Pos_ie_Extensions__item_._ext = None
    _GANSS_RX_Pos_ie_Extensions._cont = __GANSS_RX_Pos_ie_Extensions__item_
    _GANSS_RX_Pos_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_RX_Pos._cont = ASN1Dict([
        (u'latitudeSign', _GANSS_RX_Pos_latitudeSign),
        (u'degreesOfLatitude', _GANSS_RX_Pos_degreesOfLatitude),
        (u'degreesOfLongitude', _GANSS_RX_Pos_degreesOfLongitude),
        (u'directionOfAltitude', _GANSS_RX_Pos_directionOfAltitude),
        (u'altitude', _GANSS_RX_Pos_altitude),
        (u'ie-Extensions', _GANSS_RX_Pos_ie_Extensions),
        ])
    GANSS_RX_Pos._ext = []
    
    #-----< GANSS-RX-Pos-ExtIEs >-----#
    GANSS_RX_Pos_ExtIEs = CLASS(name=u'GANSS-RX-Pos-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_RX_Pos_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SatelliteInformationKP >-----#
    GANSS_SatelliteInformationKP = SEQ_OF(name=u'GANSS-SatelliteInformationKP', mode=MODE_TYPE)
    _GANSS_SatelliteInformationKP__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_SatelliteInformationKP__item__satId = INT(name=u'satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_e_alm = BIT_STR(name=u'ganss-e-alm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_e_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_delta_I_alm = BIT_STR(name=u'ganss-delta-I-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_delta_I_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_omegadot_alm = BIT_STR(name=u'ganss-omegadot-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_omegadot_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_svStatusINAV_alm = BIT_STR(name=u'ganss-svStatusINAV-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_svStatusINAV_alm._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_svStatusFNAV_alm = BIT_STR(name=u'ganss-svStatusFNAV-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_SatelliteInformationKP__item__ganss_svStatusFNAV_alm._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_delta_a_sqrt_alm = BIT_STR(name=u'ganss-delta-a-sqrt-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_delta_a_sqrt_alm._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_omegazero_alm = BIT_STR(name=u'ganss-omegazero-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_omegazero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_m_zero_alm = BIT_STR(name=u'ganss-m-zero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_m_zero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_omega_alm = BIT_STR(name=u'ganss-omega-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_omega_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_af_zero_alm = BIT_STR(name=u'ganss-af-zero-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_af_zero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ganss_af_one_alm = BIT_STR(name=u'ganss-af-one-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SatelliteInformationKP__item__ganss_af_one_alm._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    __GANSS_SatelliteInformationKP__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_SatelliteInformationKP__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id._const_tab = _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id_tab
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality._const_tab = _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality_tab
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_SatelliteInformationKP__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_SatelliteInformationKP__item__ie_Extensions__item_._ext = None
    __GANSS_SatelliteInformationKP__item__ie_Extensions._cont = ___GANSS_SatelliteInformationKP__item__ie_Extensions__item_
    __GANSS_SatelliteInformationKP__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_SatelliteInformationKP__item_._cont = ASN1Dict([
        (u'satId', __GANSS_SatelliteInformationKP__item__satId),
        (u'ganss-e-alm', __GANSS_SatelliteInformationKP__item__ganss_e_alm),
        (u'ganss-delta-I-alm', __GANSS_SatelliteInformationKP__item__ganss_delta_I_alm),
        (u'ganss-omegadot-alm', __GANSS_SatelliteInformationKP__item__ganss_omegadot_alm),
        (u'ganss-svStatusINAV-alm', __GANSS_SatelliteInformationKP__item__ganss_svStatusINAV_alm),
        (u'ganss-svStatusFNAV-alm', __GANSS_SatelliteInformationKP__item__ganss_svStatusFNAV_alm),
        (u'ganss-delta-a-sqrt-alm', __GANSS_SatelliteInformationKP__item__ganss_delta_a_sqrt_alm),
        (u'ganss-omegazero-alm', __GANSS_SatelliteInformationKP__item__ganss_omegazero_alm),
        (u'ganss-m-zero-alm', __GANSS_SatelliteInformationKP__item__ganss_m_zero_alm),
        (u'ganss-omega-alm', __GANSS_SatelliteInformationKP__item__ganss_omega_alm),
        (u'ganss-af-zero-alm', __GANSS_SatelliteInformationKP__item__ganss_af_zero_alm),
        (u'ganss-af-one-alm', __GANSS_SatelliteInformationKP__item__ganss_af_one_alm),
        (u'ie-Extensions', __GANSS_SatelliteInformationKP__item__ie_Extensions),
        ])
    _GANSS_SatelliteInformationKP__item_._ext = []
    GANSS_SatelliteInformationKP._cont = _GANSS_SatelliteInformationKP__item_
    GANSS_SatelliteInformationKP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SatelliteInformationKPItem-ExtIEs >-----#
    GANSS_SatelliteInformationKPItem_ExtIEs = CLASS(name=u'GANSS-SatelliteInformationKPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SatelliteInformationKPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-Sat-Info-AddNavList >-----#
    Ganss_Sat_Info_AddNavList = SEQ_OF(name=u'Ganss-Sat-Info-AddNavList', mode=MODE_TYPE)
    _Ganss_Sat_Info_AddNavList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Ganss_Sat_Info_AddNavList__item__satId = INT(name=u'satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__svHealth = BIT_STR(name=u'svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__svHealth._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__iod = BIT_STR(name=u'iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__iod._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels = CHOICE(name=u'ganssAddClockModels', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddClockModels')))
    __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels = CHOICE(name=u'ganssAddOrbitModels', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-AddOrbitModels')))
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab_at = None
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id),
        (u'criticality', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue),
        ])
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_._ext = None
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions._cont = ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Ganss_Sat_Info_AddNavList__item_._cont = ASN1Dict([
        (u'satId', __Ganss_Sat_Info_AddNavList__item__satId),
        (u'svHealth', __Ganss_Sat_Info_AddNavList__item__svHealth),
        (u'iod', __Ganss_Sat_Info_AddNavList__item__iod),
        (u'ganssAddClockModels', __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels),
        (u'ganssAddOrbitModels', __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels),
        (u'ie-Extensions', __Ganss_Sat_Info_AddNavList__item__ie_Extensions),
        ])
    _Ganss_Sat_Info_AddNavList__item_._ext = []
    Ganss_Sat_Info_AddNavList._cont = _Ganss_Sat_Info_AddNavList__item_
    Ganss_Sat_Info_AddNavList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Ganss-Sat-Info-AddNavList-ExtIEs >-----#
    Ganss_Sat_Info_AddNavList_ExtIEs = CLASS(name=u'Ganss-Sat-Info-AddNavList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Ganss_Sat_Info_AddNavList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-BDSkpList >-----#
    GANSS_SAT_Info_Almanac_BDSkpList = SEQ_OF(name=u'GANSS-SAT-Info-Almanac-BDSkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_BDSkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-SAT-Info-Almanac-BDS')))
    GANSS_SAT_Info_Almanac_BDSkpList._cont = _GANSS_SAT_Info_Almanac_BDSkpList__item_
    GANSS_SAT_Info_Almanac_BDSkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-BDS >-----#
    GANSS_SAT_Info_Almanac_BDS = SEQ(name=u'GANSS-SAT-Info-Almanac-BDS', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_BDS_satId = INT(name=u'satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa = BIT_STR(name=u'bdsAlmToa', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA = BIT_STR(name=u'bdsAlmSqrtA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmE = BIT_STR(name=u'bdsAlmE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmE._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmW = BIT_STR(name=u'bdsAlmW', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmW._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0 = BIT_STR(name=u'bdsAlmM0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0 = BIT_STR(name=u'bdsAlmOmega0', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot = BIT_STR(name=u'bdsAlmOmegaDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI = BIT_STR(name=u'bdsAlmDeltaI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0 = BIT_STR(name=u'bdsAlmA0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1 = BIT_STR(name=u'bdsAlmA1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth = BIT_STR(name=u'bdsSvHealth', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_BDS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id),
        (u'criticality', ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_BDS_iE_Extensions._cont = __GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item_
    _GANSS_SAT_Info_Almanac_BDS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_BDS._cont = ASN1Dict([
        (u'satId', _GANSS_SAT_Info_Almanac_BDS_satId),
        (u'bdsAlmToa', _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa),
        (u'bdsAlmSqrtA', _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA),
        (u'bdsAlmE', _GANSS_SAT_Info_Almanac_BDS_bdsAlmE),
        (u'bdsAlmW', _GANSS_SAT_Info_Almanac_BDS_bdsAlmW),
        (u'bdsAlmM0', _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0),
        (u'bdsAlmOmega0', _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0),
        (u'bdsAlmOmegaDot', _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot),
        (u'bdsAlmDeltaI', _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI),
        (u'bdsAlmA0', _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0),
        (u'bdsAlmA1', _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1),
        (u'bdsSvHealth', _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth),
        (u'iE-Extensions', _GANSS_SAT_Info_Almanac_BDS_iE_Extensions),
        ])
    GANSS_SAT_Info_Almanac_BDS._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-BDS-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_BDS_ExtIEs = CLASS(name=u'GANSS-SAT-Info-Almanac-BDS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_BDS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-GLOkpList >-----#
    GANSS_SAT_Info_Almanac_GLOkpList = SEQ_OF(name=u'GANSS-SAT-Info-Almanac-GLOkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_GLOkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmNA = BIT_STR(name=u'gloAlmNA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmNA._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmnA = BIT_STR(name=u'gloAlmnA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmnA._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmHA = BIT_STR(name=u'gloAlmHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmHA._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmLambdaA = BIT_STR(name=u'gloAlmLambdaA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmLambdaA._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTlambdaA = BIT_STR(name=u'gloAlmTlambdaA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTlambdaA._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaIA = BIT_STR(name=u'gloAlmDeltaIA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaIA._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAkmDeltaTA = BIT_STR(name=u'gloAkmDeltaTA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAkmDeltaTA._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaTdotA = BIT_STR(name=u'gloAlmDeltaTdotA', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaTdotA._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmEpsilonA = BIT_STR(name=u'gloAlmEpsilonA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmEpsilonA._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmOmegaA = BIT_STR(name=u'gloAlmOmegaA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmOmegaA._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTauA = BIT_STR(name=u'gloAlmTauA', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTauA._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmCA = BIT_STR(name=u'gloAlmCA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmCA._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmMA = BIT_STR(name=u'gloAlmMA', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmMA._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id._const_tab = _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id_tab
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality._const_tab = _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality_tab
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item_._ext = None
    __GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions._cont = ___GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item_
    __GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkpList__item_._cont = ASN1Dict([
        (u'gloAlmNA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmNA),
        (u'gloAlmnA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmnA),
        (u'gloAlmHA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmHA),
        (u'gloAlmLambdaA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmLambdaA),
        (u'gloAlmTlambdaA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTlambdaA),
        (u'gloAlmDeltaIA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaIA),
        (u'gloAkmDeltaTA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAkmDeltaTA),
        (u'gloAlmDeltaTdotA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaTdotA),
        (u'gloAlmEpsilonA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmEpsilonA),
        (u'gloAlmOmegaA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmOmegaA),
        (u'gloAlmTauA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTauA),
        (u'gloAlmCA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmCA),
        (u'gloAlmMA', __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmMA),
        (u'ie-Extensions', __GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions),
        ])
    _GANSS_SAT_Info_Almanac_GLOkpList__item_._ext = []
    GANSS_SAT_Info_Almanac_GLOkpList._cont = _GANSS_SAT_Info_Almanac_GLOkpList__item_
    GANSS_SAT_Info_Almanac_GLOkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-GLOkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_GLOkp_ExtIEs = CLASS(name=u'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_GLOkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkpList >-----#
    GANSS_SAT_Info_Almanac_MIDIkpList = SEQ_OF(name=u'GANSS-SAT-Info-Almanac-MIDIkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_MIDIkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__svID = INT(name=u'svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmE = BIT_STR(name=u'midiAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmE._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmDeltaI = BIT_STR(name=u'midiAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmDeltaI._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmegaDot = BIT_STR(name=u'midiAlmOmegaDot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmegaDot._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmSqrtA = BIT_STR(name=u'midiAlmSqrtA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmSqrtA._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega0 = BIT_STR(name=u'midiAlmOmega0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega0._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega = BIT_STR(name=u'midiAlmOmega', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmMo = BIT_STR(name=u'midiAlmMo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmMo._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf0 = BIT_STR(name=u'midiAlmaf0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf1 = BIT_STR(name=u'midiAlmaf1', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf1._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL1Health = BIT_STR(name=u'midiAlmL1Health', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL1Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL2Health = BIT_STR(name=u'midiAlmL2Health', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL2Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL5Health = BIT_STR(name=u'midiAlmL5Health', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL5Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id._const_tab = _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id_tab
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality._const_tab = _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality_tab
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item_._ext = None
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions._cont = ___GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item_
    __GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkpList__item_._cont = ASN1Dict([
        (u'svID', __GANSS_SAT_Info_Almanac_MIDIkpList__item__svID),
        (u'midiAlmE', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmE),
        (u'midiAlmDeltaI', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmDeltaI),
        (u'midiAlmOmegaDot', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmegaDot),
        (u'midiAlmSqrtA', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmSqrtA),
        (u'midiAlmOmega0', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega0),
        (u'midiAlmOmega', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega),
        (u'midiAlmMo', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmMo),
        (u'midiAlmaf0', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf0),
        (u'midiAlmaf1', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf1),
        (u'midiAlmL1Health', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL1Health),
        (u'midiAlmL2Health', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL2Health),
        (u'midiAlmL5Health', __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL5Health),
        (u'ie-Extensions', __GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions),
        ])
    _GANSS_SAT_Info_Almanac_MIDIkpList__item_._ext = []
    GANSS_SAT_Info_Almanac_MIDIkpList._cont = _GANSS_SAT_Info_Almanac_MIDIkpList__item_
    GANSS_SAT_Info_Almanac_MIDIkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs = CLASS(name=u'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-NAVkpList >-----#
    GANSS_SAT_Info_Almanac_NAVkpList = SEQ_OF(name=u'GANSS-SAT-Info-Almanac-NAVkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_NAVkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_SAT_Info_Almanac_NAVkpList__item__svID = INT(name=u'svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmE = BIT_STR(name=u'navAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmE._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmDeltaI = BIT_STR(name=u'navAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmDeltaI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGADOT = BIT_STR(name=u'navAlmOMEGADOT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGADOT._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSVHealth = BIT_STR(name=u'navAlmSVHealth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSVHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSqrtA = BIT_STR(name=u'navAlmSqrtA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSqrtA._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGAo = BIT_STR(name=u'navAlmOMEGAo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGAo._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOmega = BIT_STR(name=u'navAlmOmega', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOmega._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmMo = BIT_STR(name=u'navAlmMo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmMo._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf0 = BIT_STR(name=u'navAlmaf0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf1 = BIT_STR(name=u'navAlmaf1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id._const_tab = _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id_tab
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality._const_tab = _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality_tab
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item_._ext = None
    __GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions._cont = ___GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item_
    __GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkpList__item_._cont = ASN1Dict([
        (u'svID', __GANSS_SAT_Info_Almanac_NAVkpList__item__svID),
        (u'navAlmE', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmE),
        (u'navAlmDeltaI', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmDeltaI),
        (u'navAlmOMEGADOT', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGADOT),
        (u'navAlmSVHealth', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSVHealth),
        (u'navAlmSqrtA', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSqrtA),
        (u'navAlmOMEGAo', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGAo),
        (u'navAlmOmega', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOmega),
        (u'navAlmMo', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmMo),
        (u'navAlmaf0', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf0),
        (u'navAlmaf1', __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf1),
        (u'ie-Extensions', __GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions),
        ])
    _GANSS_SAT_Info_Almanac_NAVkpList__item_._ext = []
    GANSS_SAT_Info_Almanac_NAVkpList._cont = _GANSS_SAT_Info_Almanac_NAVkpList__item_
    GANSS_SAT_Info_Almanac_NAVkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-NAVkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_NAVkp_ExtIEs = CLASS(name=u'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_NAVkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-REDkpList >-----#
    GANSS_SAT_Info_Almanac_REDkpList = SEQ_OF(name=u'GANSS-SAT-Info-Almanac-REDkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_REDkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_SAT_Info_Almanac_REDkpList__item__svID = INT(name=u'svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmDeltaA = BIT_STR(name=u'redAlmDeltaA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmDeltaA._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmOmega0 = BIT_STR(name=u'redAlmOmega0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmOmega0._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmPhi0 = BIT_STR(name=u'redAlmPhi0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmPhi0._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL1Health = BIT_STR(name=u'redAlmL1Health', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL1Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL2Health = BIT_STR(name=u'redAlmL2Health', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL2Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL5Health = BIT_STR(name=u'redAlmL5Health', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL5Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id._const_tab = _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id_tab
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality._const_tab = _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality_tab
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item_._ext = None
    __GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions._cont = ___GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item_
    __GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkpList__item_._cont = ASN1Dict([
        (u'svID', __GANSS_SAT_Info_Almanac_REDkpList__item__svID),
        (u'redAlmDeltaA', __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmDeltaA),
        (u'redAlmOmega0', __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmOmega0),
        (u'redAlmPhi0', __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmPhi0),
        (u'redAlmL1Health', __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL1Health),
        (u'redAlmL2Health', __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL2Health),
        (u'redAlmL5Health', __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL5Health),
        (u'ie-Extensions', __GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions),
        ])
    _GANSS_SAT_Info_Almanac_REDkpList__item_._ext = []
    GANSS_SAT_Info_Almanac_REDkpList._cont = _GANSS_SAT_Info_Almanac_REDkpList__item_
    GANSS_SAT_Info_Almanac_REDkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-REDkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_REDkp_ExtIEs = CLASS(name=u'GANSS-SAT-Info-Almanac-REDkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_REDkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-SBASecefList >-----#
    GANSS_SAT_Info_Almanac_SBASecefList = SEQ_OF(name=u'GANSS-SAT-Info-Almanac-SBASecefList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_SBASecefList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmDataID = BIT_STR(name=u'sbasAlmDataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmDataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__svID = INT(name=u'svID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmHealth = BIT_STR(name=u'sbasAlmHealth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXg = BIT_STR(name=u'sbasAlmXg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXg._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYg = BIT_STR(name=u'sbasAlmYg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYg._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZg = BIT_STR(name=u'sbasAlmZg', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZg._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXgdot = BIT_STR(name=u'sbasAlmXgdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXgdot._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYgDot = BIT_STR(name=u'sbasAlmYgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYgDot._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZgDot = BIT_STR(name=u'sbasAlmZgDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZgDot._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmTo = BIT_STR(name=u'sbasAlmTo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmTo._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id._const_tab = _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id_tab
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality._const_tab = _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality_tab
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item_._ext = None
    __GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions._cont = ___GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item_
    __GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecefList__item_._cont = ASN1Dict([
        (u'sbasAlmDataID', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmDataID),
        (u'svID', __GANSS_SAT_Info_Almanac_SBASecefList__item__svID),
        (u'sbasAlmHealth', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmHealth),
        (u'sbasAlmXg', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXg),
        (u'sbasAlmYg', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYg),
        (u'sbasAlmZg', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZg),
        (u'sbasAlmXgdot', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXgdot),
        (u'sbasAlmYgDot', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYgDot),
        (u'sbasAlmZgDot', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZgDot),
        (u'sbasAlmTo', __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmTo),
        (u'ie-Extensions', __GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions),
        ])
    _GANSS_SAT_Info_Almanac_SBASecefList__item_._ext = []
    GANSS_SAT_Info_Almanac_SBASecefList._cont = _GANSS_SAT_Info_Almanac_SBASecefList__item_
    GANSS_SAT_Info_Almanac_SBASecefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-SBASecef-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_SBASecef_ExtIEs = CLASS(name=u'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_SBASecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Sat-Info-Nav >-----#
    GANSS_Sat_Info_Nav = SEQ_OF(name=u'GANSS-Sat-Info-Nav', mode=MODE_TYPE)
    _GANSS_Sat_Info_Nav__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_Sat_Info_Nav__item__satId = INT(name=u'satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__svHealth = BIT_STR(name=u'svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__svHealth._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__iod = BIT_STR(name=u'iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__ganssClockModel = SEQ_OF(name=u'ganssClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Clock-Model')))
    __GANSS_Sat_Info_Nav__item__ganssOrbitModel = CHOICE(name=u'ganssOrbitModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Orbit-Model')))
    __GANSS_Sat_Info_Nav__item__ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab_id = u'id'
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id),
        (u'criticality', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality),
        (u'extensionValue', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_._ext = None
    __GANSS_Sat_Info_Nav__item__ie_Extensions._cont = ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_
    __GANSS_Sat_Info_Nav__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_Sat_Info_Nav__item_._cont = ASN1Dict([
        (u'satId', __GANSS_Sat_Info_Nav__item__satId),
        (u'svHealth', __GANSS_Sat_Info_Nav__item__svHealth),
        (u'iod', __GANSS_Sat_Info_Nav__item__iod),
        (u'ganssClockModel', __GANSS_Sat_Info_Nav__item__ganssClockModel),
        (u'ganssOrbitModel', __GANSS_Sat_Info_Nav__item__ganssOrbitModel),
        (u'ie-Extensions', __GANSS_Sat_Info_Nav__item__ie_Extensions),
        ])
    _GANSS_Sat_Info_Nav__item_._ext = []
    GANSS_Sat_Info_Nav._cont = _GANSS_Sat_Info_Nav__item_
    GANSS_Sat_Info_Nav._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-Sat-Info-Nav-ExtIEs >-----#
    GANSS_Sat_Info_Nav_ExtIEs = CLASS(name=u'GANSS-Sat-Info-Nav-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Sat_Info_Nav_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SBAS-ID >-----#
    GANSS_SBAS_ID = ENUM(name=u'GANSS-SBAS-ID', mode=MODE_TYPE)
    GANSS_SBAS_ID._cont = ASN1Dict([(u'waas', 0), (u'egnos', 1), (u'msas', 2), (u'gagan', 3)])
    GANSS_SBAS_ID._ext = []
    
    #-----< GANSS-SBASclockModel >-----#
    GANSS_SBASclockModel = SEQ(name=u'GANSS-SBASclockModel', mode=MODE_TYPE)
    _GANSS_SBASclockModel_sbasTo = BIT_STR(name=u'sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBASclockModel_sbasTo._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_SBASclockModel_sbasAgfo = BIT_STR(name=u'sbasAgfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBASclockModel_sbasAgfo._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    _GANSS_SBASclockModel_sbasAgf1 = BIT_STR(name=u'sbasAgf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBASclockModel_sbasAgf1._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SBASclockModel_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SBASclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SBASclockModel_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_SBASclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBASclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBASclockModel_ie_Extensions__item__id._const_tab = ____GANSS_SBASclockModel_ie_Extensions__item__id_tab
    ___GANSS_SBASclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SBASclockModel_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality._const_tab = ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_SBASclockModel_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_SBASclockModel_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_SBASclockModel_ie_Extensions__item__id),
        (u'criticality', ___GANSS_SBASclockModel_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SBASclockModel_ie_Extensions__item_._ext = None
    _GANSS_SBASclockModel_ie_Extensions._cont = __GANSS_SBASclockModel_ie_Extensions__item_
    _GANSS_SBASclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SBASclockModel._cont = ASN1Dict([
        (u'sbasTo', _GANSS_SBASclockModel_sbasTo),
        (u'sbasAgfo', _GANSS_SBASclockModel_sbasAgfo),
        (u'sbasAgf1', _GANSS_SBASclockModel_sbasAgf1),
        (u'ie-Extensions', _GANSS_SBASclockModel_ie_Extensions),
        ])
    GANSS_SBASclockModel._ext = []
    
    #-----< GANSS-SBASclockModel-ExtIEs >-----#
    GANSS_SBASclockModel_ExtIEs = CLASS(name=u'GANSS-SBASclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_SBASclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Signal-ID >-----#
    GANSS_Signal_ID = INT(name=u'GANSS-Signal-ID', mode=MODE_TYPE)
    GANSS_Signal_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< GANSS-StatusHealth >-----#
    GANSS_StatusHealth = ENUM(name=u'GANSS-StatusHealth', mode=MODE_TYPE)
    GANSS_StatusHealth._cont = ASN1Dict([(u'udre-scale-1dot0', 0), (u'udre-scale-0dot75', 1), (u'udre-scale-0dot5', 2), (u'udre-scale-0dot3', 3), (u'udre-scale-0dot2', 4), (u'udre-scale-0dot1', 5), (u'no-data', 6), (u'invalid-data', 7)])
    GANSS_StatusHealth._ext = None
    
    #-----< GANSS-Time-ID >-----#
    GANSS_Time_ID = INT(name=u'GANSS-Time-ID', mode=MODE_TYPE)
    GANSS_Time_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< GANSS-Time-Model >-----#
    GANSS_Time_Model = SEQ(name=u'GANSS-Time-Model', mode=MODE_TYPE)
    _GANSS_Time_Model_ganss_time_model_Ref_Time = INT(name=u'ganss-time-model-Ref-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_ganss_time_model_Ref_Time._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37799)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a0 = INT(name=u'ganss-t-a0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_ganss_t_a0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a1 = INT(name=u'ganss-t-a1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_t_a1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a2 = INT(name=u'ganss-t-a2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_t_a2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _GANSS_Time_Model_gnss_to_id = ENUM(name=u'gnss-to-id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_gnss_to_id._cont = ASN1Dict([(u'gps', 0), (u'galileo', 1), (u'qzss', 2), (u'glonass', 3), (u'bds', 4)])
    _GANSS_Time_Model_gnss_to_id._ext = [u'galileo', u'qzss', u'glonass', u'bds']
    _GANSS_Time_Model_ganss_wk_number = INT(name=u'ganss-wk-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_wk_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSS_Time_Model_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Time_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Time_Model_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Time_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Delta-T')))
    ____GANSS_Time_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 879), (u'criticality', u'ignore'), (u'Extension', _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Time_Model_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Time_Model_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Time_Model_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Time_Model_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Time_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Time_Model_ie_Extensions__item_._ext = None
    _GANSS_Time_Model_ie_Extensions._cont = __GANSS_Time_Model_ie_Extensions__item_
    _GANSS_Time_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Time_Model._cont = ASN1Dict([
        (u'ganss-time-model-Ref-Time', _GANSS_Time_Model_ganss_time_model_Ref_Time),
        (u'ganss-t-a0', _GANSS_Time_Model_ganss_t_a0),
        (u'ganss-t-a1', _GANSS_Time_Model_ganss_t_a1),
        (u'ganss-t-a2', _GANSS_Time_Model_ganss_t_a2),
        (u'gnss-to-id', _GANSS_Time_Model_gnss_to_id),
        (u'ganss-wk-number', _GANSS_Time_Model_ganss_wk_number),
        (u'ie-Extensions', _GANSS_Time_Model_ie_Extensions),
        ])
    GANSS_Time_Model._ext = []
    
    #-----< GANSS-Time-Model-ExtIEs >-----#
    GANSS_Time_Model_ExtIEs = CLASS(name=u'GANSS-Time-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GANSS_Time_Model_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Delta-T')))
    GANSS_Time_Model_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 879), (u'criticality', u'ignore'), (u'Extension', _GANSS_Time_Model_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Transmission-Time >-----#
    GANSS_Transmission_Time = SEQ(name=u'GANSS-Transmission-Time', mode=MODE_TYPE)
    _GANSS_Transmission_Time_ganssDay = INT(name=u'ganssDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Transmission_Time_ganssDay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSS_Transmission_Time_ganssTod = INT(name=u'ganssTod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Transmission_Time_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GANSS_Transmission_Time_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Transmission_Time_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Transmission_Time_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_Transmission_Time_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Transmission_Time_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Transmission_Time_ie_Extensions__item__id._const_tab = ____GANSS_Transmission_Time_ie_Extensions__item__id_tab
    ___GANSS_Transmission_Time_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Transmission_Time_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality._const_tab = ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_Transmission_Time_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_Transmission_Time_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_Transmission_Time_ie_Extensions__item__id),
        (u'criticality', ___GANSS_Transmission_Time_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Transmission_Time_ie_Extensions__item_._ext = None
    _GANSS_Transmission_Time_ie_Extensions._cont = __GANSS_Transmission_Time_ie_Extensions__item_
    _GANSS_Transmission_Time_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Transmission_Time._cont = ASN1Dict([
        (u'ganssDay', _GANSS_Transmission_Time_ganssDay),
        (u'ganssTod', _GANSS_Transmission_Time_ganssTod),
        (u'ie-Extensions', _GANSS_Transmission_Time_ie_Extensions),
        ])
    GANSS_Transmission_Time._ext = []
    
    #-----< GANSS-Transmission-Time-ExtIEs >-----#
    GANSS_Transmission_Time_ExtIEs = CLASS(name=u'GANSS-Transmission-Time-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_Transmission_Time_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTC-Model >-----#
    GANSS_UTC_Model = SEQ(name=u'GANSS-UTC-Model', mode=MODE_TYPE)
    _GANSS_UTC_Model_a_one_utc = BIT_STR(name=u'a-one-utc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_a_one_utc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_a_zero_utc = BIT_STR(name=u'a-zero-utc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_a_zero_utc._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_t_ot_utc = BIT_STR(name=u't-ot-utc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_t_ot_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_w_n_t_utc = BIT_STR(name=u'w-n-t-utc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_w_n_t_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_delta_t_ls_utc = BIT_STR(name=u'delta-t-ls-utc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_delta_t_ls_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_w_n_lsf_utc = BIT_STR(name=u'w-n-lsf-utc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_w_n_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_dn_utc = BIT_STR(name=u'dn-utc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_dn_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_delta_t_lsf_utc = BIT_STR(name=u'delta-t-lsf-utc', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_delta_t_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTC_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTC_Model_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_UTC_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__id_tab
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_UTC_Model_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_UTC_Model_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_UTC_Model_ie_Extensions__item__id),
        (u'criticality', ___GANSS_UTC_Model_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_UTC_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTC_Model_ie_Extensions__item_._ext = None
    _GANSS_UTC_Model_ie_Extensions._cont = __GANSS_UTC_Model_ie_Extensions__item_
    _GANSS_UTC_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTC_Model._cont = ASN1Dict([
        (u'a-one-utc', _GANSS_UTC_Model_a_one_utc),
        (u'a-zero-utc', _GANSS_UTC_Model_a_zero_utc),
        (u't-ot-utc', _GANSS_UTC_Model_t_ot_utc),
        (u'w-n-t-utc', _GANSS_UTC_Model_w_n_t_utc),
        (u'delta-t-ls-utc', _GANSS_UTC_Model_delta_t_ls_utc),
        (u'w-n-lsf-utc', _GANSS_UTC_Model_w_n_lsf_utc),
        (u'dn-utc', _GANSS_UTC_Model_dn_utc),
        (u'delta-t-lsf-utc', _GANSS_UTC_Model_delta_t_lsf_utc),
        (u'ie-Extensions', _GANSS_UTC_Model_ie_Extensions),
        ])
    GANSS_UTC_Model._ext = []
    
    #-----< GANSS-UTC-Model-ExtIEs >-----#
    GANSS_UTC_Model_ExtIEs = CLASS(name=u'GANSS-UTC-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_UTC_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet1 >-----#
    GANSS_UTCmodelSet1 = SEQ(name=u'GANSS-UTCmodelSet1', mode=MODE_TYPE)
    _GANSS_UTCmodelSet1_utcA0 = BIT_STR(name=u'utcA0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcA0._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcA1 = BIT_STR(name=u'utcA1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcA1._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcA2 = BIT_STR(name=u'utcA2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcA2._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcDeltaTls = BIT_STR(name=u'utcDeltaTls', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcTot = BIT_STR(name=u'utcTot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcTot._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcWNot = BIT_STR(name=u'utcWNot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcWNot._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcWNlsf = BIT_STR(name=u'utcWNlsf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcDN = BIT_STR(name=u'utcDN', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcDN._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_utcDeltaTlsf = BIT_STR(name=u'utcDeltaTlsf', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet1_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet1_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet1_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet1_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_UTCmodelSet1_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_UTCmodelSet1_ie_Extensions__item__id),
        (u'criticality', ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet1_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet1_ie_Extensions._cont = __GANSS_UTCmodelSet1_ie_Extensions__item_
    _GANSS_UTCmodelSet1_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet1._cont = ASN1Dict([
        (u'utcA0', _GANSS_UTCmodelSet1_utcA0),
        (u'utcA1', _GANSS_UTCmodelSet1_utcA1),
        (u'utcA2', _GANSS_UTCmodelSet1_utcA2),
        (u'utcDeltaTls', _GANSS_UTCmodelSet1_utcDeltaTls),
        (u'utcTot', _GANSS_UTCmodelSet1_utcTot),
        (u'utcWNot', _GANSS_UTCmodelSet1_utcWNot),
        (u'utcWNlsf', _GANSS_UTCmodelSet1_utcWNlsf),
        (u'utcDN', _GANSS_UTCmodelSet1_utcDN),
        (u'utcDeltaTlsf', _GANSS_UTCmodelSet1_utcDeltaTlsf),
        (u'ie-Extensions', _GANSS_UTCmodelSet1_ie_Extensions),
        ])
    GANSS_UTCmodelSet1._ext = []
    
    #-----< GANSS-UTCmodelSet1-ExtIEs >-----#
    GANSS_UTCmodelSet1_ExtIEs = CLASS(name=u'GANSS-UTCmodelSet1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet2 >-----#
    GANSS_UTCmodelSet2 = SEQ(name=u'GANSS-UTCmodelSet2', mode=MODE_TYPE)
    _GANSS_UTCmodelSet2_nA = BIT_STR(name=u'nA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet2_nA._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet2_tauC = BIT_STR(name=u'tauC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet2_tauC._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet2_deltaUT1 = SEQ(name=u'deltaUT1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-DeltaUT1')), opt=True)
    _GANSS_UTCmodelSet2_kp = BIT_STR(name=u'kp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_UTCmodelSet2_kp._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet2_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet2_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet2_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_UTCmodelSet2_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_UTCmodelSet2_ie_Extensions__item__id),
        (u'criticality', ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet2_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet2_ie_Extensions._cont = __GANSS_UTCmodelSet2_ie_Extensions__item_
    _GANSS_UTCmodelSet2_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet2._cont = ASN1Dict([
        (u'nA', _GANSS_UTCmodelSet2_nA),
        (u'tauC', _GANSS_UTCmodelSet2_tauC),
        (u'deltaUT1', _GANSS_UTCmodelSet2_deltaUT1),
        (u'kp', _GANSS_UTCmodelSet2_kp),
        (u'ie-Extensions', _GANSS_UTCmodelSet2_ie_Extensions),
        ])
    GANSS_UTCmodelSet2._ext = []
    
    #-----< GANSS-UTCmodelSet2-ExtIEs >-----#
    GANSS_UTCmodelSet2_ExtIEs = CLASS(name=u'GANSS-UTCmodelSet2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet3 >-----#
    GANSS_UTCmodelSet3 = SEQ(name=u'GANSS-UTCmodelSet3', mode=MODE_TYPE)
    _GANSS_UTCmodelSet3_utcA1wnt = BIT_STR(name=u'utcA1wnt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcA1wnt._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcA0wnt = BIT_STR(name=u'utcA0wnt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcA0wnt._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcTot = BIT_STR(name=u'utcTot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcTot._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcWNt = BIT_STR(name=u'utcWNt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcWNt._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcDeltaTls = BIT_STR(name=u'utcDeltaTls', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcWNlsf = BIT_STR(name=u'utcWNlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcDN = BIT_STR(name=u'utcDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcDN._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcDeltaTlsf = BIT_STR(name=u'utcDeltaTlsf', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_utcStandardID = BIT_STR(name=u'utcStandardID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet3_utcStandardID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet3_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet3_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet3_ie_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_UTCmodelSet3_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_UTCmodelSet3_ie_Extensions__item__id),
        (u'criticality', ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet3_ie_Extensions__item_._ext = None
    _GANSS_UTCmodelSet3_ie_Extensions._cont = __GANSS_UTCmodelSet3_ie_Extensions__item_
    _GANSS_UTCmodelSet3_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet3._cont = ASN1Dict([
        (u'utcA1wnt', _GANSS_UTCmodelSet3_utcA1wnt),
        (u'utcA0wnt', _GANSS_UTCmodelSet3_utcA0wnt),
        (u'utcTot', _GANSS_UTCmodelSet3_utcTot),
        (u'utcWNt', _GANSS_UTCmodelSet3_utcWNt),
        (u'utcDeltaTls', _GANSS_UTCmodelSet3_utcDeltaTls),
        (u'utcWNlsf', _GANSS_UTCmodelSet3_utcWNlsf),
        (u'utcDN', _GANSS_UTCmodelSet3_utcDN),
        (u'utcDeltaTlsf', _GANSS_UTCmodelSet3_utcDeltaTlsf),
        (u'utcStandardID', _GANSS_UTCmodelSet3_utcStandardID),
        (u'ie-Extensions', _GANSS_UTCmodelSet3_ie_Extensions),
        ])
    GANSS_UTCmodelSet3._ext = []
    
    #-----< GANSS-UTCmodelSet3-ExtIEs >-----#
    GANSS_UTCmodelSet3_ExtIEs = CLASS(name=u'GANSS-UTCmodelSet3-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet3_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTCmodelSet4 >-----#
    GANSS_UTCmodelSet4 = SEQ(name=u'GANSS-UTCmodelSet4', mode=MODE_TYPE)
    _GANSS_UTCmodelSet4_utcA0 = BIT_STR(name=u'utcA0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcA0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcA1 = BIT_STR(name=u'utcA1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcA1._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcDeltaTls = BIT_STR(name=u'utcDeltaTls', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcWNlsf = BIT_STR(name=u'utcWNlsf', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcDN = BIT_STR(name=u'utcDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcDN._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_utcDeltaTlsf = BIT_STR(name=u'utcDeltaTlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTCmodelSet4_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTCmodelSet4_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTCmodelSet4_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTCmodelSet4_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GANSS_UTCmodelSet4_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet4_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet4_iE_Extensions__item__id._const_tab = ____GANSS_UTCmodelSet4_iE_Extensions__item__id_tab
    ___GANSS_UTCmodelSet4_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_UTCmodelSet4_iE_Extensions__item__id._const_tab_id = u'id'
    ___GANSS_UTCmodelSet4_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GANSS_UTCmodelSet4_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet4_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet4_iE_Extensions__item__criticality._const_tab = ____GANSS_UTCmodelSet4_iE_Extensions__item__criticality_tab
    ___GANSS_UTCmodelSet4_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet4_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue._const_tab = ____GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue_tab
    ___GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GANSS_UTCmodelSet4_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GANSS_UTCmodelSet4_iE_Extensions__item__id),
        (u'criticality', ___GANSS_UTCmodelSet4_iE_Extensions__item__criticality),
        (u'extensionValue', ___GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue),
        ])
    __GANSS_UTCmodelSet4_iE_Extensions__item_._ext = None
    _GANSS_UTCmodelSet4_iE_Extensions._cont = __GANSS_UTCmodelSet4_iE_Extensions__item_
    _GANSS_UTCmodelSet4_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTCmodelSet4._cont = ASN1Dict([
        (u'utcA0', _GANSS_UTCmodelSet4_utcA0),
        (u'utcA1', _GANSS_UTCmodelSet4_utcA1),
        (u'utcDeltaTls', _GANSS_UTCmodelSet4_utcDeltaTls),
        (u'utcWNlsf', _GANSS_UTCmodelSet4_utcWNlsf),
        (u'utcDN', _GANSS_UTCmodelSet4_utcDN),
        (u'utcDeltaTlsf', _GANSS_UTCmodelSet4_utcDeltaTlsf),
        (u'iE-Extensions', _GANSS_UTCmodelSet4_iE_Extensions),
        ])
    GANSS_UTCmodelSet4._ext = []
    
    #-----< GANSS-UTCmodelSet4-ExtIEs >-----#
    GANSS_UTCmodelSet4_ExtIEs = CLASS(name=u'GANSS-UTCmodelSet4-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GANSS_UTCmodelSet4_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitude >-----#
    GA_PointWithAltitude = SEQ(name=u'GA-PointWithAltitude', mode=MODE_TYPE)
    _GA_PointWithAltitude_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_PointWithAltitude_altitudeAndDirection = SEQ(name=u'altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitude_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitude_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitude_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__id_tab
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithAltitude_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithAltitude_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithAltitude_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithAltitude_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithAltitude_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitude_iE_Extensions__item_._ext = None
    _GA_PointWithAltitude_iE_Extensions._cont = __GA_PointWithAltitude_iE_Extensions__item_
    _GA_PointWithAltitude_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitude._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithAltitude_geographicalCoordinates),
        (u'altitudeAndDirection', _GA_PointWithAltitude_altitudeAndDirection),
        (u'iE-Extensions', _GA_PointWithAltitude_iE_Extensions),
        ])
    GA_PointWithAltitude._ext = []
    
    #-----< GA-PointWithAltitude-ExtIEs >-----#
    GA_PointWithAltitude_ExtIEs = CLASS(name=u'GA-PointWithAltitude-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitude_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid = SEQ(name=u'GA-PointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE)
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection = SEQ(name=u'altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse = SEQ(name=u'uncertaintyEllipse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude = INT(name=u'uncertaintyAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._ext = None
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._cont = __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates),
        (u'altitudeAndDirection', _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection),
        (u'uncertaintyEllipse', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse),
        (u'uncertaintyAltitude', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude),
        (u'confidence', _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence),
        (u'iE-Extensions', _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions),
        ])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._ext = []
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs = CLASS(name=u'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertaintyEllipse >-----#
    GA_PointWithUnCertaintyEllipse = SEQ(name=u'GA-PointWithUnCertaintyEllipse', mode=MODE_TYPE)
    _GA_PointWithUnCertaintyEllipse_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse = SEQ(name=u'uncertaintyEllipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithUnCertaintyEllipse_confidence = INT(name=u'confidence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertaintyEllipse_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithUnCertaintyEllipse_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._cont = __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithUnCertaintyEllipse._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertaintyEllipse_geographicalCoordinates),
        (u'uncertaintyEllipse', _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse),
        (u'confidence', _GA_PointWithUnCertaintyEllipse_confidence),
        (u'iE-Extensions', _GA_PointWithUnCertaintyEllipse_iE_Extensions),
        ])
    GA_PointWithUnCertaintyEllipse._ext = []
    
    #-----< GA-PointWithUnCertaintyEllipse-ExtIEs >-----#
    GA_PointWithUnCertaintyEllipse_ExtIEs = CLASS(name=u'GA-PointWithUnCertaintyEllipse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertaintyEllipse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-UncertaintyEllipse >-----#
    GA_UncertaintyEllipse = SEQ(name=u'GA-UncertaintyEllipse', mode=MODE_TYPE)
    _GA_UncertaintyEllipse_uncertaintySemi_major = INT(name=u'uncertaintySemi-major', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_uncertaintySemi_minor = INT(name=u'uncertaintySemi-minor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_orientationOfMajorAxis = INT(name=u'orientationOfMajorAxis', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    GA_UncertaintyEllipse._cont = ASN1Dict([
        (u'uncertaintySemi-major', _GA_UncertaintyEllipse_uncertaintySemi_major),
        (u'uncertaintySemi-minor', _GA_UncertaintyEllipse_uncertaintySemi_minor),
        (u'orientationOfMajorAxis', _GA_UncertaintyEllipse_orientationOfMajorAxis),
        ])
    GA_UncertaintyEllipse._ext = []
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name=u'GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name=u'geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name=u'uncertaintyCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithUnCertainty_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertainty_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_PointWithUnCertainty_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_PointWithUnCertainty_iE_Extensions__item__id),
        (u'criticality', ___GA_PointWithUnCertainty_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertainty_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertainty_iE_Extensions._cont = __GA_PointWithUnCertainty_iE_Extensions__item_
    _GA_PointWithUnCertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        (u'geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        (u'uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        (u'iE-Extensions', _GA_PointWithUnCertainty_iE_Extensions),
        ])
    GA_PointWithUnCertainty._ext = []
    
    #-----< GA-PointWithUnCertainty-ExtIEs >-----#
    GA_PointWithUnCertainty_ExtIEs = CLASS(name=u'GA-PointWithUnCertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-AccessPointPosition >-----#
    GA_AccessPointPosition = SEQ(name=u'GA-AccessPointPosition', mode=MODE_TYPE)
    _GA_AccessPointPosition_geographicalCoordinate = SEQ(name=u'geographicalCoordinate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_AccessPointPosition_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_AccessPointPosition_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_AccessPointPosition_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_AccessPointPosition_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_AccessPointPosition_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_AccessPointPosition_iE_Extensions__item__id._const_tab = ____GA_AccessPointPosition_iE_Extensions__item__id_tab
    ___GA_AccessPointPosition_iE_Extensions__item__id._const_tab_at = None
    ___GA_AccessPointPosition_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_AccessPointPosition_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_AccessPointPosition_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_AccessPointPosition_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_AccessPointPosition_iE_Extensions__item__criticality._const_tab = ____GA_AccessPointPosition_iE_Extensions__item__criticality_tab
    ___GA_AccessPointPosition_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_AccessPointPosition_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_AccessPointPosition_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_AccessPointPosition_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_AccessPointPosition_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_AccessPointPosition_iE_Extensions__item__extensionValue._const_tab = ____GA_AccessPointPosition_iE_Extensions__item__extensionValue_tab
    ___GA_AccessPointPosition_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_AccessPointPosition_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_AccessPointPosition_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_AccessPointPosition_iE_Extensions__item__id),
        (u'criticality', ___GA_AccessPointPosition_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_AccessPointPosition_iE_Extensions__item__extensionValue),
        ])
    __GA_AccessPointPosition_iE_Extensions__item_._ext = None
    _GA_AccessPointPosition_iE_Extensions._cont = __GA_AccessPointPosition_iE_Extensions__item_
    _GA_AccessPointPosition_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_AccessPointPosition._cont = ASN1Dict([
        (u'geographicalCoordinate', _GA_AccessPointPosition_geographicalCoordinate),
        (u'iE-Extensions', _GA_AccessPointPosition_iE_Extensions),
        ])
    GA_AccessPointPosition._ext = []
    
    #-----< GA-AccessPoint-ExtIEs >-----#
    GA_AccessPoint_ExtIEs = CLASS(name=u'GA-AccessPoint-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_AccessPoint_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GeographicalCoordinate >-----#
    GeographicalCoordinate = SEQ(name=u'GeographicalCoordinate', mode=MODE_TYPE)
    _GeographicalCoordinate_latitudeSign = ENUM(name=u'latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinate_latitudeSign._cont = ASN1Dict([(u'north', 0), (u'south', 1)])
    _GeographicalCoordinate_latitudeSign._ext = None
    _GeographicalCoordinate_latitude = INT(name=u'latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinate_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinate_longitude = INT(name=u'longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinate_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinate_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinate_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinate_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeographicalCoordinate_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinate_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinate_iE_Extensions__item__id._const_tab = ____GeographicalCoordinate_iE_Extensions__item__id_tab
    ___GeographicalCoordinate_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinate_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeographicalCoordinate_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeographicalCoordinate_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinate_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinate_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinate_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinate_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeographicalCoordinate_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeographicalCoordinate_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeographicalCoordinate_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinate_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinate_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinate_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinate_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeographicalCoordinate_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeographicalCoordinate_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeographicalCoordinate_iE_Extensions__item__id),
        (u'criticality', ___GeographicalCoordinate_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeographicalCoordinate_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinate_iE_Extensions__item_._ext = None
    _GeographicalCoordinate_iE_Extensions._cont = __GeographicalCoordinate_iE_Extensions__item_
    _GeographicalCoordinate_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinate._cont = ASN1Dict([
        (u'latitudeSign', _GeographicalCoordinate_latitudeSign),
        (u'latitude', _GeographicalCoordinate_latitude),
        (u'longitude', _GeographicalCoordinate_longitude),
        (u'iE-Extensions', _GeographicalCoordinate_iE_Extensions),
        ])
    GeographicalCoordinate._ext = []
    
    #-----< GeographicalCoordinate-ExtIEs >-----#
    GeographicalCoordinate_ExtIEs = CLASS(name=u'GeographicalCoordinate-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GeographicalCoordinate_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GERAN-Cell-Capability >-----#
    GERAN_Cell_Capability = BIT_STR(name=u'GERAN-Cell-Capability', mode=MODE_TYPE)
    GERAN_Cell_Capability._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name=u'GERAN-Classmark', mode=MODE_TYPE)
    
    #-----< GERAN-SI-Type >-----#
    GERAN_SI_Type = CHOICE(name=u'GERAN-SI-Type', mode=MODE_TYPE)
    _GERAN_SI_Type_sI = SEQ_OF(name=u'sI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-SystemInfo')))
    _GERAN_SI_Type_pSI = SEQ_OF(name=u'pSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-SystemInfo')))
    GERAN_SI_Type._cont = ASN1Dict([
        (u'sI', _GERAN_SI_Type_sI),
        (u'pSI', _GERAN_SI_Type_pSI),
        ])
    GERAN_SI_Type._ext = []
    
    #-----< GERAN-SystemInfo >-----#
    GERAN_SystemInfo = SEQ_OF(name=u'GERAN-SystemInfo', mode=MODE_TYPE)
    _GERAN_SystemInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GERAN_SystemInfo__item__gERAN_SI_block = OCT_STR(name=u'gERAN-SI-block', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GERAN_SystemInfo__item__gERAN_SI_block._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=23)], ev=None, er=[])
    __GERAN_SystemInfo__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GERAN_SystemInfo__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GERAN_SystemInfo__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GERAN_SystemInfo__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GERAN_SystemInfo__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GERAN_SystemInfo__item__iE_Extensions__item__id._const_tab = _____GERAN_SystemInfo__item__iE_Extensions__item__id_tab
    ____GERAN_SystemInfo__item__iE_Extensions__item__id._const_tab_at = None
    ____GERAN_SystemInfo__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____GERAN_SystemInfo__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GERAN_SystemInfo__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GERAN_SystemInfo__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GERAN_SystemInfo__item__iE_Extensions__item__criticality._const_tab = _____GERAN_SystemInfo__item__iE_Extensions__item__criticality_tab
    ____GERAN_SystemInfo__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GERAN_SystemInfo__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue._const_tab = _____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue_tab
    ____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GERAN_SystemInfo__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GERAN_SystemInfo__item__iE_Extensions__item__id),
        (u'criticality', ____GERAN_SystemInfo__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue),
        ])
    ___GERAN_SystemInfo__item__iE_Extensions__item_._ext = None
    __GERAN_SystemInfo__item__iE_Extensions._cont = ___GERAN_SystemInfo__item__iE_Extensions__item_
    __GERAN_SystemInfo__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GERAN_SystemInfo__item_._cont = ASN1Dict([
        (u'gERAN-SI-block', __GERAN_SystemInfo__item__gERAN_SI_block),
        (u'iE-Extensions', __GERAN_SystemInfo__item__iE_Extensions),
        ])
    _GERAN_SystemInfo__item_._ext = []
    GERAN_SystemInfo._cont = _GERAN_SystemInfo__item_
    GERAN_SystemInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GERAN-SystemInfo-ExtIEs >-----#
    GERAN_SystemInfo_ExtIEs = CLASS(name=u'GERAN-SystemInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GERAN_SystemInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GenericTrafficCategory >-----#
    GenericTrafficCategory = BIT_STR(name=u'GenericTrafficCategory', mode=MODE_TYPE)
    GenericTrafficCategory._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GPS-Almanac >-----#
    GPS_Almanac = SEQ(name=u'GPS-Almanac', mode=MODE_TYPE)
    _GPS_Almanac_wna_alm = BIT_STR(name=u'wna-alm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Almanac_wna_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Almanac_satellite_Almanac_Information = SEQ_OF(name=u'satellite-Almanac-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_Almanac_satellite_Almanac_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___GPS_Almanac_satellite_Almanac_Information__item__dATA_ID = INT(name=u'dATA-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DATA-ID')))
    ___GPS_Almanac_satellite_Almanac_Information__item__sAT_ID = INT(name=u'sAT-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAT-ID')))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_e_alm = BIT_STR(name=u'gps-e-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_e_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_toa_alm = BIT_STR(name=u'gps-toa-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_toa_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_delta_I_alm = BIT_STR(name=u'gps-delta-I-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_delta_I_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__omegadot_alm = BIT_STR(name=u'omegadot-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__omegadot_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__svhealth_alm = BIT_STR(name=u'svhealth-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__svhealth_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_a_sqrt_alm = BIT_STR(name=u'gps-a-sqrt-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_a_sqrt_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__omegazero_alm = BIT_STR(name=u'omegazero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__omegazero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__m_zero_alm = BIT_STR(name=u'm-zero-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__m_zero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_omega_alm = BIT_STR(name=u'gps-omega-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_omega_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_zero_alm = BIT_STR(name=u'gps-af-zero-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_zero_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_one_alm = BIT_STR(name=u'gps-af-one-alm', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_one_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    ___GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id._const_tab = ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id_tab
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id._const_tab_at = None
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id._const_tab_id = u'id'
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality._const_tab = ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality_tab
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue._const_tab = ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue_tab
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id),
        (u'criticality', _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality),
        (u'extensionValue', _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue),
        ])
    ____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item_._ext = None
    ___GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions._cont = ____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item_
    ___GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __GPS_Almanac_satellite_Almanac_Information__item_._cont = ASN1Dict([
        (u'dATA-ID', ___GPS_Almanac_satellite_Almanac_Information__item__dATA_ID),
        (u'sAT-ID', ___GPS_Almanac_satellite_Almanac_Information__item__sAT_ID),
        (u'gps-e-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_e_alm),
        (u'gps-toa-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_toa_alm),
        (u'gps-delta-I-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_delta_I_alm),
        (u'omegadot-alm', ___GPS_Almanac_satellite_Almanac_Information__item__omegadot_alm),
        (u'svhealth-alm', ___GPS_Almanac_satellite_Almanac_Information__item__svhealth_alm),
        (u'gps-a-sqrt-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_a_sqrt_alm),
        (u'omegazero-alm', ___GPS_Almanac_satellite_Almanac_Information__item__omegazero_alm),
        (u'm-zero-alm', ___GPS_Almanac_satellite_Almanac_Information__item__m_zero_alm),
        (u'gps-omega-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_omega_alm),
        (u'gps-af-zero-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_zero_alm),
        (u'gps-af-one-alm', ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_one_alm),
        (u'iE-Extensions', ___GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions),
        ])
    __GPS_Almanac_satellite_Almanac_Information__item_._ext = []
    _GPS_Almanac_satellite_Almanac_Information._cont = __GPS_Almanac_satellite_Almanac_Information__item_
    _GPS_Almanac_satellite_Almanac_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _GPS_Almanac_sVGlobalHealth_alm = BIT_STR(name=u'sVGlobalHealth-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPS_Almanac_sVGlobalHealth_alm._const_sz = ASN1Set(rv=[364], rr=[], ev=None, er=[])
    _GPS_Almanac_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_Almanac_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GPS_Almanac_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GPS_Almanac_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPS_Almanac_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Satellite-Almanac-Information-ExtItem')))
    _____GPS_Almanac_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CompleteAlmanacProvided')))
    ____GPS_Almanac_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 530), (u'criticality', u'ignore'), (u'Extension', _____GPS_Almanac_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 878), (u'criticality', u'ignore'), (u'Extension', _____GPS_Almanac_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GPS_Almanac_iE_Extensions__item__id._const_tab = ____GPS_Almanac_iE_Extensions__item__id_tab
    ___GPS_Almanac_iE_Extensions__item__id._const_tab_at = None
    ___GPS_Almanac_iE_Extensions__item__id._const_tab_id = u'id'
    ___GPS_Almanac_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GPS_Almanac_iE_Extensions__item__criticality._const_tab = ____GPS_Almanac_iE_Extensions__item__id_tab
    ___GPS_Almanac_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GPS_Almanac_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GPS_Almanac_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GPS_Almanac_iE_Extensions__item__extensionValue._const_tab = ____GPS_Almanac_iE_Extensions__item__id_tab
    ___GPS_Almanac_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GPS_Almanac_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GPS_Almanac_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GPS_Almanac_iE_Extensions__item__id),
        (u'criticality', ___GPS_Almanac_iE_Extensions__item__criticality),
        (u'extensionValue', ___GPS_Almanac_iE_Extensions__item__extensionValue),
        ])
    __GPS_Almanac_iE_Extensions__item_._ext = None
    _GPS_Almanac_iE_Extensions._cont = __GPS_Almanac_iE_Extensions__item_
    _GPS_Almanac_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_Almanac._cont = ASN1Dict([
        (u'wna-alm', _GPS_Almanac_wna_alm),
        (u'satellite-Almanac-Information', _GPS_Almanac_satellite_Almanac_Information),
        (u'sVGlobalHealth-alm', _GPS_Almanac_sVGlobalHealth_alm),
        (u'iE-Extensions', _GPS_Almanac_iE_Extensions),
        ])
    GPS_Almanac._ext = []
    
    #-----< Satellite-Almanac-Information-ExtIEs >-----#
    Satellite_Almanac_Information_ExtIEs = CLASS(name=u'Satellite-Almanac-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Satellite_Almanac_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-Almanac-ExtIEs >-----#
    GPS_Almanac_ExtIEs = CLASS(name=u'GPS-Almanac-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GPS_Almanac_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Satellite-Almanac-Information-ExtItem')))
    _GPS_Almanac_ExtIEs_val_Extension_1 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CompleteAlmanacProvided')))
    GPS_Almanac_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 530), (u'criticality', u'ignore'), (u'Extension', _GPS_Almanac_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 878), (u'criticality', u'ignore'), (u'Extension', _GPS_Almanac_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Satellite-Almanac-Information-ExtItem >-----#
    Satellite_Almanac_Information_ExtItem = SEQ_OF(name=u'Satellite-Almanac-Information-ExtItem', mode=MODE_TYPE)
    _Satellite_Almanac_Information_ExtItem__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Satellite_Almanac_Information_ExtItem__item__dATA_ID = INT(name=u'dATA-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DATA-ID')))
    __Satellite_Almanac_Information_ExtItem__item__sAT_ID = INT(name=u'sAT-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAT-ID')))
    __Satellite_Almanac_Information_ExtItem__item__gps_e_alm = BIT_STR(name=u'gps-e-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_e_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__gps_toa_alm = BIT_STR(name=u'gps-toa-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_toa_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__gps_delta_I_alm = BIT_STR(name=u'gps-delta-I-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_delta_I_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__omegadot_alm = BIT_STR(name=u'omegadot-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__omegadot_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__svhealth_alm = BIT_STR(name=u'svhealth-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__svhealth_alm._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__gps_a_sqrt_alm = BIT_STR(name=u'gps-a-sqrt-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_a_sqrt_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__omegazero_alm = BIT_STR(name=u'omegazero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__omegazero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__m_zero_alm = BIT_STR(name=u'm-zero-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__m_zero_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__gps_omega_alm = BIT_STR(name=u'gps-omega-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_omega_alm._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__gps_af_zero_alm = BIT_STR(name=u'gps-af-zero-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_af_zero_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__gps_af_one_alm = BIT_STR(name=u'gps-af-one-alm', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Satellite_Almanac_Information_ExtItem__item__gps_af_one_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __Satellite_Almanac_Information_ExtItem__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id._const_tab = _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id_tab
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id._const_tab_at = None
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality._const_tab = _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality_tab
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue._const_tab = _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue_tab
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id),
        (u'criticality', ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue),
        ])
    ___Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item_._ext = None
    __Satellite_Almanac_Information_ExtItem__item__iE_Extensions._cont = ___Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item_
    __Satellite_Almanac_Information_ExtItem__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Satellite_Almanac_Information_ExtItem__item_._cont = ASN1Dict([
        (u'dATA-ID', __Satellite_Almanac_Information_ExtItem__item__dATA_ID),
        (u'sAT-ID', __Satellite_Almanac_Information_ExtItem__item__sAT_ID),
        (u'gps-e-alm', __Satellite_Almanac_Information_ExtItem__item__gps_e_alm),
        (u'gps-toa-alm', __Satellite_Almanac_Information_ExtItem__item__gps_toa_alm),
        (u'gps-delta-I-alm', __Satellite_Almanac_Information_ExtItem__item__gps_delta_I_alm),
        (u'omegadot-alm', __Satellite_Almanac_Information_ExtItem__item__omegadot_alm),
        (u'svhealth-alm', __Satellite_Almanac_Information_ExtItem__item__svhealth_alm),
        (u'gps-a-sqrt-alm', __Satellite_Almanac_Information_ExtItem__item__gps_a_sqrt_alm),
        (u'omegazero-alm', __Satellite_Almanac_Information_ExtItem__item__omegazero_alm),
        (u'm-zero-alm', __Satellite_Almanac_Information_ExtItem__item__m_zero_alm),
        (u'gps-omega-alm', __Satellite_Almanac_Information_ExtItem__item__gps_omega_alm),
        (u'gps-af-zero-alm', __Satellite_Almanac_Information_ExtItem__item__gps_af_zero_alm),
        (u'gps-af-one-alm', __Satellite_Almanac_Information_ExtItem__item__gps_af_one_alm),
        (u'iE-Extensions', __Satellite_Almanac_Information_ExtItem__item__iE_Extensions),
        ])
    _Satellite_Almanac_Information_ExtItem__item_._ext = []
    Satellite_Almanac_Information_ExtItem._cont = _Satellite_Almanac_Information_ExtItem__item_
    Satellite_Almanac_Information_ExtItem._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Satellite-Almanac-Information-ExtItemIEs >-----#
    Satellite_Almanac_Information_ExtItemIEs = CLASS(name=u'Satellite-Almanac-Information-ExtItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Satellite_Almanac_Information_ExtItemIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPSInformation >-----#
    GPSInformation = SEQ_OF(name=u'GPSInformation', mode=MODE_TYPE)
    _GPSInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GPSInformation__item__gPSInformationItem = ENUM(name=u'gPSInformationItem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPSInformation__item__gPSInformationItem._cont = ASN1Dict([(u'gPS-NavigationModel-and-TimeRecovery', 0), (u'gPS-Ionospheric-Model', 1), (u'gPS-UTC-Model', 2), (u'gPS-Almanac', 3), (u'gPS-RealTime-Integrity', 4)])
    __GPSInformation__item__gPSInformationItem._ext = []
    __GPSInformation__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GPSInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GPSInformation__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GPSInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPSInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GPSInformation__item__iE_Extensions__item__id._const_tab = _____GPSInformation__item__iE_Extensions__item__id_tab
    ____GPSInformation__item__iE_Extensions__item__id._const_tab_at = None
    ____GPSInformation__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____GPSInformation__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GPSInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPSInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GPSInformation__item__iE_Extensions__item__criticality._const_tab = _____GPSInformation__item__iE_Extensions__item__criticality_tab
    ____GPSInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GPSInformation__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GPSInformation__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GPSInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPSInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GPSInformation__item__iE_Extensions__item__extensionValue._const_tab = _____GPSInformation__item__iE_Extensions__item__extensionValue_tab
    ____GPSInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GPSInformation__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GPSInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GPSInformation__item__iE_Extensions__item__id),
        (u'criticality', ____GPSInformation__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____GPSInformation__item__iE_Extensions__item__extensionValue),
        ])
    ___GPSInformation__item__iE_Extensions__item_._ext = None
    __GPSInformation__item__iE_Extensions._cont = ___GPSInformation__item__iE_Extensions__item_
    __GPSInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GPSInformation__item_._cont = ASN1Dict([
        (u'gPSInformationItem', __GPSInformation__item__gPSInformationItem),
        (u'iE-Extensions', __GPSInformation__item__iE_Extensions),
        ])
    _GPSInformation__item_._ext = []
    GPSInformation._cont = _GPSInformation__item_
    GPSInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GPSInformation-ExtIEs >-----#
    GPSInformation_ExtIEs = CLASS(name=u'GPSInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GPSInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-Ionospheric-Model >-----#
    GPS_Ionospheric_Model = SEQ(name=u'GPS-Ionospheric-Model', mode=MODE_TYPE)
    _GPS_Ionospheric_Model_alpha_zero_ionos = BIT_STR(name=u'alpha-zero-ionos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_zero_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alpha_one_ionos = BIT_STR(name=u'alpha-one-ionos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_one_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alpha_two_ionos = BIT_STR(name=u'alpha-two-ionos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_two_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alpha_three_ionos = BIT_STR(name=u'alpha-three-ionos', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alpha_three_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_zero_ionos = BIT_STR(name=u'beta-zero-ionos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_zero_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_one_ionos = BIT_STR(name=u'beta-one-ionos', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_one_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_two_ionos = BIT_STR(name=u'beta-two-ionos', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_two_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta_three_ionos = BIT_STR(name=u'beta-three-ionos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta_three_ionos._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_Ionospheric_Model_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GPS_Ionospheric_Model_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_iE_Extensions__item__id._const_tab = ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab
    ___GPS_Ionospheric_Model_iE_Extensions__item__id._const_tab_at = None
    ___GPS_Ionospheric_Model_iE_Extensions__item__id._const_tab_id = u'id'
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality._const_tab = ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue._const_tab = ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GPS_Ionospheric_Model_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GPS_Ionospheric_Model_iE_Extensions__item__id),
        (u'criticality', ___GPS_Ionospheric_Model_iE_Extensions__item__criticality),
        (u'extensionValue', ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue),
        ])
    __GPS_Ionospheric_Model_iE_Extensions__item_._ext = None
    _GPS_Ionospheric_Model_iE_Extensions._cont = __GPS_Ionospheric_Model_iE_Extensions__item_
    _GPS_Ionospheric_Model_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_Ionospheric_Model._cont = ASN1Dict([
        (u'alpha-zero-ionos', _GPS_Ionospheric_Model_alpha_zero_ionos),
        (u'alpha-one-ionos', _GPS_Ionospheric_Model_alpha_one_ionos),
        (u'alpha-two-ionos', _GPS_Ionospheric_Model_alpha_two_ionos),
        (u'alpha-three-ionos', _GPS_Ionospheric_Model_alpha_three_ionos),
        (u'beta-zero-ionos', _GPS_Ionospheric_Model_beta_zero_ionos),
        (u'beta-one-ionos', _GPS_Ionospheric_Model_beta_one_ionos),
        (u'beta-two-ionos', _GPS_Ionospheric_Model_beta_two_ionos),
        (u'beta-three-ionos', _GPS_Ionospheric_Model_beta_three_ionos),
        (u'iE-Extensions', _GPS_Ionospheric_Model_iE_Extensions),
        ])
    GPS_Ionospheric_Model._ext = []
    
    #-----< GPS-Ionospheric-Model-ExtIEs >-----#
    GPS_Ionospheric_Model_ExtIEs = CLASS(name=u'GPS-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GPS_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-NavigationModel-and-TimeRecovery >-----#
    GPS_NavigationModel_and_TimeRecovery = SEQ_OF(name=u'GPS-NavigationModel-and-TimeRecovery', mode=MODE_TYPE)
    _GPS_NavigationModel_and_TimeRecovery__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GPS_NavigationModel_and_TimeRecovery__item__tx_tow_nav = INT(name=u'tx-tow-nav', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__tx_tow_nav._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__sAT_ID = INT(name=u'sAT-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAT-ID')))
    __GPS_NavigationModel_and_TimeRecovery__item__tlm_message_nav = BIT_STR(name=u'tlm-message-nav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__tlm_message_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__tlm_revd_c_nav = BIT_STR(name=u'tlm-revd-c-nav', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__tlm_revd_c_nav._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__ho_word_nav = BIT_STR(name=u'ho-word-nav', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__ho_word_nav._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__w_n_nav = BIT_STR(name=u'w-n-nav', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__w_n_nav._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__ca_or_p_on_l2_nav = BIT_STR(name=u'ca-or-p-on-l2-nav', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__ca_or_p_on_l2_nav._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__user_range_accuracy_index_nav = BIT_STR(name=u'user-range-accuracy-index-nav', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__user_range_accuracy_index_nav._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__sv_health_nav = BIT_STR(name=u'sv-health-nav', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__sv_health_nav._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__iodc_nav = BIT_STR(name=u'iodc-nav', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__iodc_nav._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__l2_p_dataflag_nav = BIT_STR(name=u'l2-p-dataflag-nav', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__l2_p_dataflag_nav._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__sf1_reserved_nav = BIT_STR(name=u'sf1-reserved-nav', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__sf1_reserved_nav._const_sz = ASN1Set(rv=[87], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__t_gd_nav = BIT_STR(name=u't-gd-nav', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__t_gd_nav._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__t_oc_nav = BIT_STR(name=u't-oc-nav', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__t_oc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__a_f_2_nav = BIT_STR(name=u'a-f-2-nav', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__a_f_2_nav._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__a_f_1_nav = BIT_STR(name=u'a-f-1-nav', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__a_f_1_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__a_f_zero_nav = BIT_STR(name=u'a-f-zero-nav', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__a_f_zero_nav._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__c_rs_nav = BIT_STR(name=u'c-rs-nav', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__c_rs_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__delta_n_nav = BIT_STR(name=u'delta-n-nav', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__delta_n_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__m_zero_nav = BIT_STR(name=u'm-zero-nav', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__m_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__c_uc_nav = BIT_STR(name=u'c-uc-nav', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__c_uc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__gps_e_nav = BIT_STR(name=u'gps-e-nav', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__gps_e_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__c_us_nav = BIT_STR(name=u'c-us-nav', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__c_us_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__a_sqrt_nav = BIT_STR(name=u'a-sqrt-nav', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__a_sqrt_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__t_oe_nav = BIT_STR(name=u't-oe-nav', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__t_oe_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__fit_interval_flag_nav = BIT_STR(name=u'fit-interval-flag-nav', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__fit_interval_flag_nav._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__aodo_nav = BIT_STR(name=u'aodo-nav', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__aodo_nav._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__c_ic_nav = BIT_STR(name=u'c-ic-nav', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__c_ic_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__omega_zero_nav = BIT_STR(name=u'omega-zero-nav', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__omega_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__c_is_nav = BIT_STR(name=u'c-is-nav', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__c_is_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__i_zero_nav = BIT_STR(name=u'i-zero-nav', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__i_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__c_rc_nav = BIT_STR(name=u'c-rc-nav', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__c_rc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__gps_omega_nav = BIT_STR(name=u'gps-omega-nav', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__gps_omega_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__omegadot_nav = BIT_STR(name=u'omegadot-nav', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__omegadot_nav._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__idot_nav = BIT_STR(name=u'idot-nav', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__idot_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__spare_zero_fill = BIT_STR(name=u'spare-zero-fill', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GPS_NavigationModel_and_TimeRecovery__item__spare_zero_fill._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    __GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id._const_tab = _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id_tab
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id._const_tab_at = None
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality._const_tab = _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality_tab
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue._const_tab = _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue_tab
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id),
        (u'criticality', ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue),
        ])
    ___GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item_._ext = None
    __GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions._cont = ___GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item_
    __GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GPS_NavigationModel_and_TimeRecovery__item_._cont = ASN1Dict([
        (u'tx-tow-nav', __GPS_NavigationModel_and_TimeRecovery__item__tx_tow_nav),
        (u'sAT-ID', __GPS_NavigationModel_and_TimeRecovery__item__sAT_ID),
        (u'tlm-message-nav', __GPS_NavigationModel_and_TimeRecovery__item__tlm_message_nav),
        (u'tlm-revd-c-nav', __GPS_NavigationModel_and_TimeRecovery__item__tlm_revd_c_nav),
        (u'ho-word-nav', __GPS_NavigationModel_and_TimeRecovery__item__ho_word_nav),
        (u'w-n-nav', __GPS_NavigationModel_and_TimeRecovery__item__w_n_nav),
        (u'ca-or-p-on-l2-nav', __GPS_NavigationModel_and_TimeRecovery__item__ca_or_p_on_l2_nav),
        (u'user-range-accuracy-index-nav', __GPS_NavigationModel_and_TimeRecovery__item__user_range_accuracy_index_nav),
        (u'sv-health-nav', __GPS_NavigationModel_and_TimeRecovery__item__sv_health_nav),
        (u'iodc-nav', __GPS_NavigationModel_and_TimeRecovery__item__iodc_nav),
        (u'l2-p-dataflag-nav', __GPS_NavigationModel_and_TimeRecovery__item__l2_p_dataflag_nav),
        (u'sf1-reserved-nav', __GPS_NavigationModel_and_TimeRecovery__item__sf1_reserved_nav),
        (u't-gd-nav', __GPS_NavigationModel_and_TimeRecovery__item__t_gd_nav),
        (u't-oc-nav', __GPS_NavigationModel_and_TimeRecovery__item__t_oc_nav),
        (u'a-f-2-nav', __GPS_NavigationModel_and_TimeRecovery__item__a_f_2_nav),
        (u'a-f-1-nav', __GPS_NavigationModel_and_TimeRecovery__item__a_f_1_nav),
        (u'a-f-zero-nav', __GPS_NavigationModel_and_TimeRecovery__item__a_f_zero_nav),
        (u'c-rs-nav', __GPS_NavigationModel_and_TimeRecovery__item__c_rs_nav),
        (u'delta-n-nav', __GPS_NavigationModel_and_TimeRecovery__item__delta_n_nav),
        (u'm-zero-nav', __GPS_NavigationModel_and_TimeRecovery__item__m_zero_nav),
        (u'c-uc-nav', __GPS_NavigationModel_and_TimeRecovery__item__c_uc_nav),
        (u'gps-e-nav', __GPS_NavigationModel_and_TimeRecovery__item__gps_e_nav),
        (u'c-us-nav', __GPS_NavigationModel_and_TimeRecovery__item__c_us_nav),
        (u'a-sqrt-nav', __GPS_NavigationModel_and_TimeRecovery__item__a_sqrt_nav),
        (u't-oe-nav', __GPS_NavigationModel_and_TimeRecovery__item__t_oe_nav),
        (u'fit-interval-flag-nav', __GPS_NavigationModel_and_TimeRecovery__item__fit_interval_flag_nav),
        (u'aodo-nav', __GPS_NavigationModel_and_TimeRecovery__item__aodo_nav),
        (u'c-ic-nav', __GPS_NavigationModel_and_TimeRecovery__item__c_ic_nav),
        (u'omega-zero-nav', __GPS_NavigationModel_and_TimeRecovery__item__omega_zero_nav),
        (u'c-is-nav', __GPS_NavigationModel_and_TimeRecovery__item__c_is_nav),
        (u'i-zero-nav', __GPS_NavigationModel_and_TimeRecovery__item__i_zero_nav),
        (u'c-rc-nav', __GPS_NavigationModel_and_TimeRecovery__item__c_rc_nav),
        (u'gps-omega-nav', __GPS_NavigationModel_and_TimeRecovery__item__gps_omega_nav),
        (u'omegadot-nav', __GPS_NavigationModel_and_TimeRecovery__item__omegadot_nav),
        (u'idot-nav', __GPS_NavigationModel_and_TimeRecovery__item__idot_nav),
        (u'spare-zero-fill', __GPS_NavigationModel_and_TimeRecovery__item__spare_zero_fill),
        (u'iE-Extensions', __GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions),
        ])
    _GPS_NavigationModel_and_TimeRecovery__item_._ext = []
    GPS_NavigationModel_and_TimeRecovery._cont = _GPS_NavigationModel_and_TimeRecovery__item_
    GPS_NavigationModel_and_TimeRecovery._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GPS-NavigationModel-and-TimeRecoveryItem-ExtIEs >-----#
    GPS_NavigationModel_and_TimeRecoveryItem_ExtIEs = CLASS(name=u'GPS-NavigationModel-and-TimeRecoveryItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GPS_NavigationModel_and_TimeRecoveryItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-RealTime-Integrity >-----#
    GPS_RealTime_Integrity = CHOICE(name=u'GPS-RealTime-Integrity', mode=MODE_TYPE)
    _GPS_RealTime_Integrity_badSatellites = SEQ(name=u'badSatellites', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BadSatellites')))
    _GPS_RealTime_Integrity_noBadSatellite = NULL(name=u'noBadSatellite', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GPS_RealTime_Integrity._cont = ASN1Dict([
        (u'badSatellites', _GPS_RealTime_Integrity_badSatellites),
        (u'noBadSatellite', _GPS_RealTime_Integrity_noBadSatellite),
        ])
    GPS_RealTime_Integrity._ext = None
    
    #-----< GPS-RX-POS >-----#
    GPS_RX_POS = SEQ(name=u'GPS-RX-POS', mode=MODE_TYPE)
    _GPS_RX_POS_geographicalCoordinate = SEQ(name=u'geographicalCoordinate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GPS_RX_POS_altitudeAndDirection = SEQ(name=u'altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AltitudeAndDirection')))
    _GPS_RX_POS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_RX_POS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GPS_RX_POS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GPS_RX_POS_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_RX_POS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_RX_POS_iE_Extensions__item__id._const_tab = ____GPS_RX_POS_iE_Extensions__item__id_tab
    ___GPS_RX_POS_iE_Extensions__item__id._const_tab_at = None
    ___GPS_RX_POS_iE_Extensions__item__id._const_tab_id = u'id'
    ___GPS_RX_POS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GPS_RX_POS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_RX_POS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_RX_POS_iE_Extensions__item__criticality._const_tab = ____GPS_RX_POS_iE_Extensions__item__criticality_tab
    ___GPS_RX_POS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GPS_RX_POS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GPS_RX_POS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_RX_POS_iE_Extensions__item__extensionValue._const_tab = ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab
    ___GPS_RX_POS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GPS_RX_POS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GPS_RX_POS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GPS_RX_POS_iE_Extensions__item__id),
        (u'criticality', ___GPS_RX_POS_iE_Extensions__item__criticality),
        (u'extensionValue', ___GPS_RX_POS_iE_Extensions__item__extensionValue),
        ])
    __GPS_RX_POS_iE_Extensions__item_._ext = None
    _GPS_RX_POS_iE_Extensions._cont = __GPS_RX_POS_iE_Extensions__item_
    _GPS_RX_POS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_RX_POS._cont = ASN1Dict([
        (u'geographicalCoordinate', _GPS_RX_POS_geographicalCoordinate),
        (u'altitudeAndDirection', _GPS_RX_POS_altitudeAndDirection),
        (u'iE-Extensions', _GPS_RX_POS_iE_Extensions),
        ])
    GPS_RX_POS._ext = []
    
    #-----< GPS-RX-POS-ExtIEs >-----#
    GPS_RX_POS_ExtIEs = CLASS(name=u'GPS-RX-POS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GPS_RX_POS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-Status-Health >-----#
    GPS_Status_Health = ENUM(name=u'GPS-Status-Health', mode=MODE_TYPE)
    GPS_Status_Health._cont = ASN1Dict([(u'udre-1-0', 0), (u'udre-0-75', 1), (u'udre-0-5', 2), (u'udre-0-3', 3), (u'udre-0-1', 4), (u'no-data', 5), (u'invalid-data', 6)])
    GPS_Status_Health._ext = None
    
    #-----< GPSTOW >-----#
    GPSTOW = INT(name=u'GPSTOW', mode=MODE_TYPE)
    GPSTOW._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799)], ev=None, er=[])
    
    #-----< GPS-UTC-Model >-----#
    GPS_UTC_Model = SEQ(name=u'GPS-UTC-Model', mode=MODE_TYPE)
    _GPS_UTC_Model_a_one_utc = BIT_STR(name=u'a-one-utc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_a_one_utc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GPS_UTC_Model_a_zero_utc = BIT_STR(name=u'a-zero-utc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_a_zero_utc._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_UTC_Model_t_ot_utc = BIT_STR(name=u't-ot-utc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_t_ot_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_delta_t_ls_utc = BIT_STR(name=u'delta-t-ls-utc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_delta_t_ls_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_w_n_t_utc = BIT_STR(name=u'w-n-t-utc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_w_n_t_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_w_n_lsf_utc = BIT_STR(name=u'w-n-lsf-utc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_w_n_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_dn_utc = BIT_STR(name=u'dn-utc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_dn_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_delta_t_lsf_utc = BIT_STR(name=u'delta-t-lsf-utc', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_delta_t_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_UTC_Model_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GPS_UTC_Model_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GPS_UTC_Model_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_iE_Extensions__item__id._const_tab = ____GPS_UTC_Model_iE_Extensions__item__id_tab
    ___GPS_UTC_Model_iE_Extensions__item__id._const_tab_at = None
    ___GPS_UTC_Model_iE_Extensions__item__id._const_tab_id = u'id'
    ___GPS_UTC_Model_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GPS_UTC_Model_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_iE_Extensions__item__criticality._const_tab = ____GPS_UTC_Model_iE_Extensions__item__criticality_tab
    ___GPS_UTC_Model_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GPS_UTC_Model_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue._const_tab = ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GPS_UTC_Model_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GPS_UTC_Model_iE_Extensions__item__id),
        (u'criticality', ___GPS_UTC_Model_iE_Extensions__item__criticality),
        (u'extensionValue', ___GPS_UTC_Model_iE_Extensions__item__extensionValue),
        ])
    __GPS_UTC_Model_iE_Extensions__item_._ext = None
    _GPS_UTC_Model_iE_Extensions._cont = __GPS_UTC_Model_iE_Extensions__item_
    _GPS_UTC_Model_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_UTC_Model._cont = ASN1Dict([
        (u'a-one-utc', _GPS_UTC_Model_a_one_utc),
        (u'a-zero-utc', _GPS_UTC_Model_a_zero_utc),
        (u't-ot-utc', _GPS_UTC_Model_t_ot_utc),
        (u'delta-t-ls-utc', _GPS_UTC_Model_delta_t_ls_utc),
        (u'w-n-t-utc', _GPS_UTC_Model_w_n_t_utc),
        (u'w-n-lsf-utc', _GPS_UTC_Model_w_n_lsf_utc),
        (u'dn-utc', _GPS_UTC_Model_dn_utc),
        (u'delta-t-lsf-utc', _GPS_UTC_Model_delta_t_lsf_utc),
        (u'iE-Extensions', _GPS_UTC_Model_iE_Extensions),
        ])
    GPS_UTC_Model._ext = []
    
    #-----< GPS-UTC-Model-ExtIEs >-----#
    GPS_UTC_Model_ExtIEs = CLASS(name=u'GPS-UTC-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GPS_UTC_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Guaranteed-Rate-Information >-----#
    Guaranteed_Rate_Information = SEQ(name=u'Guaranteed-Rate-Information', mode=MODE_TYPE)
    _Guaranteed_Rate_Information_guaranteed_UL_Rate = INT(name=u'guaranteed-UL-Rate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate')), opt=True)
    _Guaranteed_Rate_Information_guaranteed_DL_Rate = INT(name=u'guaranteed-DL-Rate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate')), opt=True)
    _Guaranteed_Rate_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Guaranteed_Rate_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Guaranteed_Rate_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Guaranteed_Rate_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Guaranteed_Rate_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Guaranteed_Rate_Information_iE_Extensions__item__id._const_tab = ____Guaranteed_Rate_Information_iE_Extensions__item__id_tab
    ___Guaranteed_Rate_Information_iE_Extensions__item__id._const_tab_at = None
    ___Guaranteed_Rate_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Guaranteed_Rate_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Guaranteed_Rate_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Guaranteed_Rate_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Guaranteed_Rate_Information_iE_Extensions__item__criticality._const_tab = ____Guaranteed_Rate_Information_iE_Extensions__item__criticality_tab
    ___Guaranteed_Rate_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Guaranteed_Rate_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Guaranteed_Rate_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Guaranteed_Rate_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Guaranteed_Rate_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Guaranteed_Rate_Information_iE_Extensions__item__extensionValue._const_tab = ____Guaranteed_Rate_Information_iE_Extensions__item__extensionValue_tab
    ___Guaranteed_Rate_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Guaranteed_Rate_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Guaranteed_Rate_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Guaranteed_Rate_Information_iE_Extensions__item__id),
        (u'criticality', ___Guaranteed_Rate_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Guaranteed_Rate_Information_iE_Extensions__item__extensionValue),
        ])
    __Guaranteed_Rate_Information_iE_Extensions__item_._ext = None
    _Guaranteed_Rate_Information_iE_Extensions._cont = __Guaranteed_Rate_Information_iE_Extensions__item_
    _Guaranteed_Rate_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Guaranteed_Rate_Information._cont = ASN1Dict([
        (u'guaranteed-UL-Rate', _Guaranteed_Rate_Information_guaranteed_UL_Rate),
        (u'guaranteed-DL-Rate', _Guaranteed_Rate_Information_guaranteed_DL_Rate),
        (u'iE-Extensions', _Guaranteed_Rate_Information_iE_Extensions),
        ])
    Guaranteed_Rate_Information._ext = []
    
    #-----< Guaranteed-Rate-Information-ExtIEs >-----#
    Guaranteed_Rate_Information_ExtIEs = CLASS(name=u'Guaranteed-Rate-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Guaranteed_Rate_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Guaranteed-Rate >-----#
    Guaranteed_Rate = INT(name=u'Guaranteed-Rate', mode=MODE_TYPE)
    Guaranteed_Rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HARQ-Info-for-E-DCH >-----#
    HARQ_Info_for_E_DCH = ENUM(name=u'HARQ-Info-for-E-DCH', mode=MODE_TYPE)
    HARQ_Info_for_E_DCH._cont = ASN1Dict([(u'rv0', 0), (u'rvtable', 1)])
    HARQ_Info_for_E_DCH._ext = None
    
    #-----< HARQ-MemoryPartitioning >-----#
    HARQ_MemoryPartitioning = CHOICE(name=u'HARQ-MemoryPartitioning', mode=MODE_TYPE)
    _HARQ_MemoryPartitioning_implicit = SEQ(name=u'implicit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioning-Implicit')))
    _HARQ_MemoryPartitioning_explicit = SEQ(name=u'explicit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioning-Explicit')))
    HARQ_MemoryPartitioning._cont = ASN1Dict([
        (u'implicit', _HARQ_MemoryPartitioning_implicit),
        (u'explicit', _HARQ_MemoryPartitioning_explicit),
        ])
    HARQ_MemoryPartitioning._ext = []
    
    #-----< HARQ-MemoryPartitioning-Implicit >-----#
    HARQ_MemoryPartitioning_Implicit = SEQ(name=u'HARQ-MemoryPartitioning-Implicit', mode=MODE_TYPE)
    _HARQ_MemoryPartitioning_Implicit_number_of_Processes = INT(name=u'number-of-Processes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HARQ_MemoryPartitioning_Implicit_number_of_Processes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[12, 14, 16], er=[])
    _HARQ_MemoryPartitioning_Implicit_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id._const_tab = ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id._const_tab_at = None
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id._const_tab_id = u'id'
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality._const_tab = ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue._const_tab = ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id),
        (u'criticality', ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality),
        (u'extensionValue', ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue),
        ])
    __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_._ext = None
    _HARQ_MemoryPartitioning_Implicit_iE_Extensions._cont = __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_
    _HARQ_MemoryPartitioning_Implicit_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HARQ_MemoryPartitioning_Implicit._cont = ASN1Dict([
        (u'number-of-Processes', _HARQ_MemoryPartitioning_Implicit_number_of_Processes),
        (u'iE-Extensions', _HARQ_MemoryPartitioning_Implicit_iE_Extensions),
        ])
    HARQ_MemoryPartitioning_Implicit._ext = []
    
    #-----< HARQ-MemoryPartitioning-Implicit-ExtIEs >-----#
    HARQ_MemoryPartitioning_Implicit_ExtIEs = CLASS(name=u'HARQ-MemoryPartitioning-Implicit-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HARQ_MemoryPartitioning_Implicit_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HARQ-MemoryPartitioning-Explicit >-----#
    HARQ_MemoryPartitioning_Explicit = SEQ(name=u'HARQ-MemoryPartitioning-Explicit', mode=MODE_TYPE)
    _HARQ_MemoryPartitioning_Explicit_hARQ_MemoryPartitioningList = SEQ_OF(name=u'hARQ-MemoryPartitioningList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioningList')))
    _HARQ_MemoryPartitioning_Explicit_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioningInfoExtForMIMO')))
    ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 707), (u'criticality', u'ignore'), (u'Extension', _____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id._const_tab = ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id._const_tab_at = None
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id._const_tab_id = u'id'
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality._const_tab = ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue._const_tab = ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id),
        (u'criticality', ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality),
        (u'extensionValue', ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue),
        ])
    __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_._ext = None
    _HARQ_MemoryPartitioning_Explicit_iE_Extensions._cont = __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_
    _HARQ_MemoryPartitioning_Explicit_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HARQ_MemoryPartitioning_Explicit._cont = ASN1Dict([
        (u'hARQ-MemoryPartitioningList', _HARQ_MemoryPartitioning_Explicit_hARQ_MemoryPartitioningList),
        (u'iE-Extensions', _HARQ_MemoryPartitioning_Explicit_iE_Extensions),
        ])
    HARQ_MemoryPartitioning_Explicit._ext = []
    
    #-----< HARQ-MemoryPartitioning-Explicit-ExtIEs >-----#
    HARQ_MemoryPartitioning_Explicit_ExtIEs = CLASS(name=u'HARQ-MemoryPartitioning-Explicit-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HARQ_MemoryPartitioning_Explicit_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioningInfoExtForMIMO')))
    HARQ_MemoryPartitioning_Explicit_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 707), (u'criticality', u'ignore'), (u'Extension', _HARQ_MemoryPartitioning_Explicit_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HARQ-MemoryPartitioningList >-----#
    HARQ_MemoryPartitioningList = SEQ_OF(name=u'HARQ-MemoryPartitioningList', mode=MODE_TYPE)
    _HARQ_MemoryPartitioningList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioningItem')))
    HARQ_MemoryPartitioningList._cont = _HARQ_MemoryPartitioningList__item_
    HARQ_MemoryPartitioningList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HARQ-MemoryPartitioningInfoExtForMIMO >-----#
    HARQ_MemoryPartitioningInfoExtForMIMO = SEQ_OF(name=u'HARQ-MemoryPartitioningInfoExtForMIMO', mode=MODE_TYPE)
    _HARQ_MemoryPartitioningInfoExtForMIMO__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioningItem')))
    HARQ_MemoryPartitioningInfoExtForMIMO._cont = _HARQ_MemoryPartitioningInfoExtForMIMO__item_
    HARQ_MemoryPartitioningInfoExtForMIMO._const_sz = ASN1Set(rv=[4, 6, 8], rr=[], ev=None, er=[])
    
    #-----< HARQ-MemoryPartitioningItem >-----#
    HARQ_MemoryPartitioningItem = SEQ(name=u'HARQ-MemoryPartitioningItem', mode=MODE_TYPE)
    _HARQ_MemoryPartitioningItem_process_Memory_Size = ENUM(name=u'process-Memory-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HARQ_MemoryPartitioningItem_process_Memory_Size._cont = ASN1Dict([(u'hms800', 0), (u'hms1600', 1), (u'hms2400', 2), (u'hms3200', 3), (u'hms4000', 4), (u'hms4800', 5), (u'hms5600', 6), (u'hms6400', 7), (u'hms7200', 8), (u'hms8000', 9), (u'hms8800', 10), (u'hms9600', 11), (u'hms10400', 12), (u'hms11200', 13), (u'hms12000', 14), (u'hms12800', 15), (u'hms13600', 16), (u'hms14400', 17), (u'hms15200', 18), (u'hms16000', 19), (u'hms17600', 20), (u'hms19200', 21), (u'hms20800', 22), (u'hms22400', 23), (u'hms24000', 24), (u'hms25600', 25), (u'hms27200', 26), (u'hms28800', 27), (u'hms30400', 28), (u'hms32000', 29), (u'hms36000', 30), (u'hms40000', 31), (u'hms44000', 32), (u'hms48000', 33), (u'hms52000', 34), (u'hms56000', 35), (u'hms60000', 36), (u'hms64000', 37), (u'hms68000', 38), (u'hms72000', 39), (u'hms76000', 40), (u'hms80000', 41), (u'hms88000', 42), (u'hms96000', 43), (u'hms104000', 44), (u'hms112000', 45), (u'hms120000', 46), (u'hms128000', 47), (u'hms136000', 48), (u'hms144000', 49), (u'hms152000', 50), (u'hms160000', 51), (u'hms176000', 52), (u'hms192000', 53), (u'hms208000', 54), (u'hms224000', 55), (u'hms240000', 56), (u'hms256000', 57), (u'hms272000', 58), (u'hms288000', 59), (u'hms304000', 60)])
    _HARQ_MemoryPartitioningItem_process_Memory_Size._ext = []
    _HARQ_MemoryPartitioningItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HARQ_MemoryPartitioningItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id._const_tab = ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id._const_tab_at = None
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality._const_tab = ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue._const_tab = ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HARQ_MemoryPartitioningItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id),
        (u'criticality', ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue),
        ])
    __HARQ_MemoryPartitioningItem_iE_Extensions__item_._ext = None
    _HARQ_MemoryPartitioningItem_iE_Extensions._cont = __HARQ_MemoryPartitioningItem_iE_Extensions__item_
    _HARQ_MemoryPartitioningItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HARQ_MemoryPartitioningItem._cont = ASN1Dict([
        (u'process-Memory-Size', _HARQ_MemoryPartitioningItem_process_Memory_Size),
        (u'iE-Extensions', _HARQ_MemoryPartitioningItem_iE_Extensions),
        ])
    HARQ_MemoryPartitioningItem._ext = []
    
    #-----< HARQ-MemoryPartitioningItem-ExtIEs >-----#
    HARQ_MemoryPartitioningItem_ExtIEs = CLASS(name=u'HARQ-MemoryPartitioningItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HARQ_MemoryPartitioningItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HARQ-Preamble-Mode >-----#
    HARQ_Preamble_Mode = ENUM(name=u'HARQ-Preamble-Mode', mode=MODE_TYPE)
    HARQ_Preamble_Mode._cont = ASN1Dict([(u'mode0', 0), (u'mode1', 1)])
    HARQ_Preamble_Mode._ext = None
    
    #-----< HARQ-Process-Allocation-2ms-EDCH >-----#
    HARQ_Process_Allocation_2ms_EDCH = BIT_STR(name=u'HARQ-Process-Allocation-2ms-EDCH', mode=MODE_TYPE)
    HARQ_Process_Allocation_2ms_EDCH._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HARQ-Preamble-Mode-Activation-Indicator >-----#
    HARQ_Preamble_Mode_Activation_Indicator = ENUM(name=u'HARQ-Preamble-Mode-Activation-Indicator', mode=MODE_TYPE)
    HARQ_Preamble_Mode_Activation_Indicator._cont = ASN1Dict([(u'harqPreambleModeSupported', 0)])
    HARQ_Preamble_Mode_Activation_Indicator._ext = None
    
    #-----< HCS-Prio >-----#
    HCS_Prio = INT(name=u'HCS-Prio', mode=MODE_TYPE)
    HCS_Prio._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< HS-DSCH-Cell-List >-----#
    HS_DSCH_Cell_List = SEQ_OF(name=u'HS-DSCH-Cell-List', mode=MODE_TYPE)
    _HS_DSCH_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Cell')))
    HS_DSCH_Cell_List._cont = _HS_DSCH_Cell_List__item_
    HS_DSCH_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< HS-DSCH-Cell >-----#
    HS_DSCH_Cell = SEQ(name=u'HS-DSCH-Cell', mode=MODE_TYPE)
    _HS_DSCH_Cell_hs_DSCH_Cell_TBS = INT(name=u'hs-DSCH-Cell-TBS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TBS-Value')))
    _HS_DSCH_Cell_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Cell_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Cell_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_Cell_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Cell_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Cell_iE_Extensions__item__id._const_tab = ____HS_DSCH_Cell_iE_Extensions__item__id_tab
    ___HS_DSCH_Cell_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Cell_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_Cell_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Cell_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Cell_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_Cell_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_Cell_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_Cell_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_Cell_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_Cell_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_Cell_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Cell_iE_Extensions__item_._ext = None
    _HS_DSCH_Cell_iE_Extensions._cont = __HS_DSCH_Cell_iE_Extensions__item_
    _HS_DSCH_Cell_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Cell._cont = ASN1Dict([
        (u'hs-DSCH-Cell-TBS', _HS_DSCH_Cell_hs_DSCH_Cell_TBS),
        (u'iE-Extensions', _HS_DSCH_Cell_iE_Extensions),
        ])
    HS_DSCH_Cell._ext = []
    
    #-----< HS-DSCH-Cell-ExtIEs >-----#
    HS_DSCH_Cell_ExtIEs = CLASS(name=u'HS-DSCH-Cell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Cell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Configured-Indicator >-----#
    HSDSCH_Configured_Indicator = ENUM(name=u'HSDSCH-Configured-Indicator', mode=MODE_TYPE)
    HSDSCH_Configured_Indicator._cont = ASN1Dict([(u'configured-HS-DSCH', 0), (u'no-configured-HS-DSCH', 1)])
    HSDSCH_Configured_Indicator._ext = None
    
    #-----< HSDSCH-FDD-Information >-----#
    HSDSCH_FDD_Information = SEQ(name=u'HSDSCH-FDD-Information', mode=MODE_TYPE)
    _HSDSCH_FDD_Information_hSDSCH_MACdFlows_Information = SEQ(name=u'hSDSCH-MACdFlows-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _HSDSCH_FDD_Information_uE_Capabilities_Info = SEQ(name=u'uE-Capabilities-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-Capabilities-Info')))
    _HSDSCH_FDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name=u'mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')))
    _HSDSCH_FDD_Information_cqiFeedback_CycleK = ENUM(name=u'cqiFeedback-CycleK', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle')))
    _HSDSCH_FDD_Information_cqiRepetitionFactor = INT(name=u'cqiRepetitionFactor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _HSDSCH_FDD_Information_ackNackRepetitionFactor = INT(name=u'ackNackRepetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AckNack-RepetitionFactor')))
    _HSDSCH_FDD_Information_cqiPowerOffset = INT(name=u'cqiPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Power-Offset')))
    _HSDSCH_FDD_Information_ackPowerOffset = INT(name=u'ackPowerOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Ack-Power-Offset')))
    _HSDSCH_FDD_Information_nackPowerOffset = INT(name=u'nackPowerOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Nack-Power-Offset')))
    _HSDSCH_FDD_Information_hsscch_PowerOffset = INT(name=u'hsscch-PowerOffset', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HSDSCH_FDD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_FDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_FDD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE)
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EnhancedHSServingCC-Abort')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_7 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_9 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_10 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_11 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Information')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle2')))
    _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Cycle-Switch-Timer')))
    ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 571), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 708), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 690), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 734), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 747), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 793), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 825), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 927), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 958), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 959), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_FDD_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_FDD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_FDD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_FDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_FDD_Information_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_FDD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_FDD_Information_iE_Extensions__item_._ext = None
    _HSDSCH_FDD_Information_iE_Extensions._cont = __HSDSCH_FDD_Information_iE_Extensions__item_
    _HSDSCH_FDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_FDD_Information._cont = ASN1Dict([
        (u'hSDSCH-MACdFlows-Information', _HSDSCH_FDD_Information_hSDSCH_MACdFlows_Information),
        (u'uE-Capabilities-Info', _HSDSCH_FDD_Information_uE_Capabilities_Info),
        (u'mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_FDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        (u'cqiFeedback-CycleK', _HSDSCH_FDD_Information_cqiFeedback_CycleK),
        (u'cqiRepetitionFactor', _HSDSCH_FDD_Information_cqiRepetitionFactor),
        (u'ackNackRepetitionFactor', _HSDSCH_FDD_Information_ackNackRepetitionFactor),
        (u'cqiPowerOffset', _HSDSCH_FDD_Information_cqiPowerOffset),
        (u'ackPowerOffset', _HSDSCH_FDD_Information_ackPowerOffset),
        (u'nackPowerOffset', _HSDSCH_FDD_Information_nackPowerOffset),
        (u'hsscch-PowerOffset', _HSDSCH_FDD_Information_hsscch_PowerOffset),
        (u'iE-Extensions', _HSDSCH_FDD_Information_iE_Extensions),
        ])
    HSDSCH_FDD_Information._ext = []
    
    #-----< HSDSCH-FDD-Information-ExtIEs >-----#
    HSDSCH_FDD_Information_ExtIEs = CLASS(name=u'HSDSCH-FDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE)
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EnhancedHSServingCC-Abort')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_7 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_9 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_10 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_11 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Information')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_13 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle2')))
    _HSDSCH_FDD_Information_ExtIEs_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Cycle-Switch-Timer')))
    HSDSCH_FDD_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 571), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 708), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 690), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 734), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 747), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 793), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 825), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 927), (u'criticality', u'reject'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 958), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 959), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_ExtIEs_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-FDD-Information-Response >-----#
    HSDSCH_FDD_Information_Response = SEQ(name=u'HSDSCH-FDD-Information-Response', mode=MODE_TYPE)
    _HSDSCH_FDD_Information_Response_hSDSCH_MACdFlow_Specific_InfoList_Response = SEQ_OF(name=u'hSDSCH-MACdFlow-Specific-InfoList-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList-Response')), opt=True)
    _HSDSCH_FDD_Information_Response_hSSCCH_Specific_InfoList_Response = SEQ_OF(name=u'hSSCCH-Specific-InfoList-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-FDD-Specific-InfoList-Response')), opt=True)
    _HSDSCH_FDD_Information_Response_hSPDSCH_and_HSSCCH_ScramblingCode = INT(name=u'hSPDSCH-and-HSSCCH-ScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ScramblingCode')), opt=True)
    _HSDSCH_FDD_Information_Response_measurement_Power_Offset = INT(name=u'measurement-Power-Offset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Measurement-Power-Offset')), opt=True)
    _HSDSCH_FDD_Information_Response_hARQ_MemoryPartitioning = CHOICE(name=u'hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _HSDSCH_FDD_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_FDD_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'User-Plane-Congestion-Fields-Inclusion')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode-Activation-Indicator')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TBSizeTableIndicator')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_8 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 593), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 594), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 675), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 735), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 746), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 909), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id._const_tab = ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab = ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_FDD_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_FDD_Information_Response_iE_Extensions__item_._ext = None
    _HSDSCH_FDD_Information_Response_iE_Extensions._cont = __HSDSCH_FDD_Information_Response_iE_Extensions__item_
    _HSDSCH_FDD_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_FDD_Information_Response._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-Specific-InfoList-Response', _HSDSCH_FDD_Information_Response_hSDSCH_MACdFlow_Specific_InfoList_Response),
        (u'hSSCCH-Specific-InfoList-Response', _HSDSCH_FDD_Information_Response_hSSCCH_Specific_InfoList_Response),
        (u'hSPDSCH-and-HSSCCH-ScramblingCode', _HSDSCH_FDD_Information_Response_hSPDSCH_and_HSSCCH_ScramblingCode),
        (u'measurement-Power-Offset', _HSDSCH_FDD_Information_Response_measurement_Power_Offset),
        (u'hARQ-MemoryPartitioning', _HSDSCH_FDD_Information_Response_hARQ_MemoryPartitioning),
        (u'iE-Extensions', _HSDSCH_FDD_Information_Response_iE_Extensions),
        ])
    HSDSCH_FDD_Information_Response._ext = []
    
    #-----< HSDSCH-FDD-Information-Response-ExtIEs >-----#
    HSDSCH_FDD_Information_Response_ExtIEs = CLASS(name=u'HSDSCH-FDD-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'User-Plane-Congestion-Fields-Inclusion')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode-Activation-Indicator')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TBSizeTableIndicator')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_8 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    HSDSCH_FDD_Information_Response_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 593), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 594), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 675), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 735), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 746), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 909), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information >-----#
    HS_DSCH_FDD_Secondary_Serving_Information = SEQ(name=u'HS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Information_hsscch_PowerOffset = INT(name=u'hsscch-PowerOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_sixtyfourQAM_UsageAllowedIndicator = ENUM(name=u'sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DiversityMode')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_7 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 708), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 825), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 856), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 857), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Information._cont = ASN1Dict([
        (u'hsscch-PowerOffset', _HS_DSCH_FDD_Secondary_Serving_Information_hsscch_PowerOffset),
        (u'sixtyfourQAM-UsageAllowedIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_sixtyfourQAM_UsageAllowedIndicator),
        (u'iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Information._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs = CLASS(name=u'HS-DSCH-FDD-Secondary-Serving-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DiversityMode')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_7 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 708), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 825), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 856), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 857), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-Response >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name=u'HS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSSCCH_Specific_InfoList_Response = SEQ_OF(name=u'hSSCCH-Specific-InfoList-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-FDD-Specific-InfoList-Response')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSPDSCH_and_HSSCCH_ScramblingCode = INT(name=u'hSPDSCH-and-HSSCCH-ScramblingCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ScramblingCode')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_measurement_Power_Offset = INT(name=u'measurement-Power-Offset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Measurement-Power-Offset')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_sixtyfourQAM_DL_UsageIndicator = ENUM(name=u'sixtyfourQAM-DL-UsageIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSDSCH_TBSizeTableIndicator = ENUM(name=u'hSDSCH-TBSizeTableIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TBSizeTableIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 675), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Information_Response._cont = ASN1Dict([
        (u'hSSCCH-Specific-InfoList-Response', _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSSCCH_Specific_InfoList_Response),
        (u'hSPDSCH-and-HSSCCH-ScramblingCode', _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSPDSCH_and_HSSCCH_ScramblingCode),
        (u'measurement-Power-Offset', _HS_DSCH_FDD_Secondary_Serving_Information_Response_measurement_Power_Offset),
        (u'sixtyfourQAM-DL-UsageIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_Response_sixtyfourQAM_DL_UsageIndicator),
        (u'hSDSCH-TBSizeTableIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSDSCH_TBSizeTableIndicator),
        (u'iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Information_Response._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs = CLASS(name=u'HS-DSCH-FDD-Secondary-Serving-Information-Respons-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')))
    _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 675), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-Information-To-Modify >-----#
    HS_DSCH_Secondary_Serving_Information_To_Modify = SEQ(name=u'HS-DSCH-Secondary-Serving-Information-To-Modify', mode=MODE_TYPE)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_hsscch_PowerOffset = INT(name=u'hsscch-PowerOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_hSSCCH_CodeChangeGrant = ENUM(name=u'hSSCCH-CodeChangeGrant', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-Code-Change-Grant')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_sixtyfourQAM_UsageAllowedIndicator = ENUM(name=u'sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DiversityMode')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NonCellSpecificTxDiversity')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_9 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_10 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 856), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 857), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 858), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id._const_tab = ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_._ext = None
    _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions._cont = __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_
    _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Secondary_Serving_Information_To_Modify._cont = ASN1Dict([
        (u'hsscch-PowerOffset', _HS_DSCH_Secondary_Serving_Information_To_Modify_hsscch_PowerOffset),
        (u'hSSCCH-CodeChangeGrant', _HS_DSCH_Secondary_Serving_Information_To_Modify_hSSCCH_CodeChangeGrant),
        (u'sixtyfourQAM-UsageAllowedIndicator', _HS_DSCH_Secondary_Serving_Information_To_Modify_sixtyfourQAM_UsageAllowedIndicator),
        (u'iE-Extensions', _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions),
        ])
    HS_DSCH_Secondary_Serving_Information_To_Modify._ext = []
    
    #-----< HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs >-----#
    HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs = CLASS(name=u'HS-DSCH-Secondary-Serving-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DiversityMode')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NonCellSpecificTxDiversity')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_9 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_10 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 856), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 857), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 858), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised = SEQ(name=u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_hsscch_PowerOffset = INT(name=u'hsscch-PowerOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_sixtyfourQAM_UsageAllowedIndicator = ENUM(name=u'sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised._cont = ASN1Dict([
        (u'hsscch-PowerOffset', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_hsscch_PowerOffset),
        (u'sixtyfourQAM-UsageAllowedIndicator', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_sixtyfourQAM_UsageAllowedIndicator),
        (u'iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs = CLASS(name=u'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Update-Information >-----#
    HS_DSCH_FDD_Secondary_Serving_Update_Information = SEQ(name=u'HS-DSCH-FDD-Secondary-Serving-Update-Information', mode=MODE_TYPE)
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_hsSCCHCodeChangeIndicator = ENUM(name=u'hsSCCHCodeChangeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-CodeChangeIndicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_hS_PDSCH_Code_Change_Indicator = ENUM(name=u'hS-PDSCH-Code-Change-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-PDSCH-Code-Change-Indicator')), opt=True)
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_._ext = None
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions._cont = __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_FDD_Secondary_Serving_Update_Information._cont = ASN1Dict([
        (u'hsSCCHCodeChangeIndicator', _HS_DSCH_FDD_Secondary_Serving_Update_Information_hsSCCHCodeChangeIndicator),
        (u'hS-PDSCH-Code-Change-Indicator', _HS_DSCH_FDD_Secondary_Serving_Update_Information_hS_PDSCH_Code_Change_Indicator),
        (u'iE-Extensions', _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions),
        ])
    HS_DSCH_FDD_Secondary_Serving_Update_Information._ext = []
    
    #-----< HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs >-----#
    HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs = CLASS(name=u'HS-DSCH-FDD-Secondary-Serving-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-Cell-Change-Information-Response >-----#
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response = SEQ(name=u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response', mode=MODE_TYPE)
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_hS_DSCH_Secondary_Serving_cell_choice = CHOICE(name=u'hS-DSCH-Secondary-Serving-cell-choice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Secondary-Serving-cell-change-choice')))
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id._const_tab = ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_._ext = None
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions._cont = __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_
    _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response._cont = ASN1Dict([
        (u'hS-DSCH-Secondary-Serving-cell-choice', _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_hS_DSCH_Secondary_Serving_cell_choice),
        (u'iE-Extensions', _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions),
        ])
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response._ext = []
    
    #-----< HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs >-----#
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_ExtIEs = CLASS(name=u'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-cell-change-choice >-----#
    HS_DSCH_Secondary_Serving_cell_change_choice = CHOICE(name=u'HS-DSCH-Secondary-Serving-cell-change-choice', mode=MODE_TYPE)
    _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_successful = SEQ(name=u'hS-Secondary-Serving-cell-change-successful', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-Secondary-Serving-cell-change-successful')))
    _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_unsuccessful = SEQ(name=u'hS-Secondary-Serving-cell-change-unsuccessful', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-Secondary-Serving-cell-change-unsuccessful')))
    HS_DSCH_Secondary_Serving_cell_change_choice._cont = ASN1Dict([
        (u'hS-Secondary-Serving-cell-change-successful', _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_successful),
        (u'hS-Secondary-Serving-cell-change-unsuccessful', _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_unsuccessful),
        ])
    HS_DSCH_Secondary_Serving_cell_change_choice._ext = []
    
    #-----< HS-Secondary-Serving-cell-change-successful >-----#
    HS_Secondary_Serving_cell_change_successful = SEQ(name=u'HS-Secondary-Serving-cell-change-successful', mode=MODE_TYPE)
    _HS_Secondary_Serving_cell_change_successful_hS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-Response')))
    _HS_Secondary_Serving_cell_change_successful_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _HS_Secondary_Serving_cell_change_successful_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id._const_tab = ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id._const_tab_at = None
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality._const_tab = ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab = ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id),
        (u'criticality', ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue),
        ])
    __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_._ext = None
    _HS_Secondary_Serving_cell_change_successful_iE_Extensions._cont = __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_
    _HS_Secondary_Serving_cell_change_successful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_Secondary_Serving_cell_change_successful._cont = ASN1Dict([
        (u'hS-DSCH-FDD-Secondary-Serving-Information-Response', _HS_Secondary_Serving_cell_change_successful_hS_DSCH_FDD_Secondary_Serving_Information_Response),
        (u'hSDSCH-RNTI', _HS_Secondary_Serving_cell_change_successful_hSDSCH_RNTI),
        (u'iE-Extensions', _HS_Secondary_Serving_cell_change_successful_iE_Extensions),
        ])
    HS_Secondary_Serving_cell_change_successful._ext = []
    
    #-----< HS-Secondary-Serving-cell-change-successful-ExtIEs >-----#
    HS_Secondary_Serving_cell_change_successful_ExtIEs = CLASS(name=u'HS-Secondary-Serving-cell-change-successful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_Secondary_Serving_cell_change_successful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-Secondary-Serving-cell-change-unsuccessful >-----#
    HS_Secondary_Serving_cell_change_unsuccessful = SEQ(name=u'HS-Secondary-Serving-cell-change-unsuccessful', mode=MODE_TYPE)
    _HS_Secondary_Serving_cell_change_unsuccessful_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab = ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_at = None
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab = ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab = ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id),
        (u'criticality', ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue),
        ])
    __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_._ext = None
    _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions._cont = __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_
    _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_Secondary_Serving_cell_change_unsuccessful._cont = ASN1Dict([
        (u'cause', _HS_Secondary_Serving_cell_change_unsuccessful_cause),
        (u'iE-Extensions', _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions),
        ])
    HS_Secondary_Serving_cell_change_unsuccessful._ext = []
    
    #-----< HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs >-----#
    HS_Secondary_Serving_cell_change_unsuccessful_ExtIEs = CLASS(name=u'HS-Secondary-Serving-cell-change-unsuccessful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_Secondary_Serving_cell_change_unsuccessful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Secondary-Serving-Remove >-----#
    HS_DSCH_Secondary_Serving_Remove = NULL(name=u'HS-DSCH-Secondary-Serving-Remove', mode=MODE_TYPE)
    
    #-----< HSDSCH-Information-to-Modify >-----#
    HSDSCH_Information_to_Modify = SEQ(name=u'HSDSCH-Information-to-Modify', mode=MODE_TYPE)
    _HSDSCH_Information_to_Modify_hSDSCH_MACdFlow_Specific_InfoList_to_Modify = SEQ_OF(name=u'hSDSCH-MACdFlow-Specific-InfoList-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList-to-Modify')), opt=True)
    _HSDSCH_Information_to_Modify_priorityQueue_Info_to_Modify = SEQ_OF(name=u'priorityQueue-Info-to-Modify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-to-Modify')), opt=True)
    _HSDSCH_Information_to_Modify_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name=u'mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')), opt=True)
    _HSDSCH_Information_to_Modify_cqiFeedback_CycleK = ENUM(name=u'cqiFeedback-CycleK', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle')), opt=True)
    _HSDSCH_Information_to_Modify_cqiRepetitionFactor = INT(name=u'cqiRepetitionFactor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _HSDSCH_Information_to_Modify_ackNackRepetitionFactor = INT(name=u'ackNackRepetitionFactor', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AckNack-RepetitionFactor')), opt=True)
    _HSDSCH_Information_to_Modify_cqiPowerOffset = INT(name=u'cqiPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_ackPowerOffset = INT(name=u'ackPowerOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Ack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_nackPowerOffset = INT(name=u'nackPowerOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Nack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_hsscch_PowerOffset = INT(name=u'hsscch-PowerOffset', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HSDSCH_Information_to_Modify_hSSCCH_CodeChangeGrant = ENUM(name=u'hSSCCH-CodeChangeGrant', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-Code-Change-Grant')), opt=True)
    _HSDSCH_Information_to_Modify_tDDAckNackPowerOffset = INT(name=u'tDDAckNackPowerOffset', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Information_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-PDSCH-Code-Change-Grant')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Capabilities-Info')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EnhancedHSServingCC-Abort')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_12 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_13 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Reconfiguration')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle2')))
    _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_15 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Cycle-Switch-Timer')))
    ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 571), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 680), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 690), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 734), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 728), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 793), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 928), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 958), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 959), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id._const_tab = ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_Information_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_Information_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Information_to_Modify_iE_Extensions__item_._ext = None
    _HSDSCH_Information_to_Modify_iE_Extensions._cont = __HSDSCH_Information_to_Modify_iE_Extensions__item_
    _HSDSCH_Information_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Information_to_Modify._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-Specific-InfoList-to-Modify', _HSDSCH_Information_to_Modify_hSDSCH_MACdFlow_Specific_InfoList_to_Modify),
        (u'priorityQueue-Info-to-Modify', _HSDSCH_Information_to_Modify_priorityQueue_Info_to_Modify),
        (u'mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_Information_to_Modify_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        (u'cqiFeedback-CycleK', _HSDSCH_Information_to_Modify_cqiFeedback_CycleK),
        (u'cqiRepetitionFactor', _HSDSCH_Information_to_Modify_cqiRepetitionFactor),
        (u'ackNackRepetitionFactor', _HSDSCH_Information_to_Modify_ackNackRepetitionFactor),
        (u'cqiPowerOffset', _HSDSCH_Information_to_Modify_cqiPowerOffset),
        (u'ackPowerOffset', _HSDSCH_Information_to_Modify_ackPowerOffset),
        (u'nackPowerOffset', _HSDSCH_Information_to_Modify_nackPowerOffset),
        (u'hsscch-PowerOffset', _HSDSCH_Information_to_Modify_hsscch_PowerOffset),
        (u'hSSCCH-CodeChangeGrant', _HSDSCH_Information_to_Modify_hSSCCH_CodeChangeGrant),
        (u'tDDAckNackPowerOffset', _HSDSCH_Information_to_Modify_tDDAckNackPowerOffset),
        (u'iE-Extensions', _HSDSCH_Information_to_Modify_iE_Extensions),
        ])
    HSDSCH_Information_to_Modify._ext = []
    
    #-----< HSDSCH-Information-to-Modify-ExtIEs >-----#
    HSDSCH_Information_to_Modify_ExtIEs = CLASS(name=u'HSDSCH-Information-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-PDSCH-Code-Change-Grant')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Capabilities-Info')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EnhancedHSServingCC-Abort')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_7 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_11 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_12 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_13 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Reconfiguration')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle2')))
    _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_15 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Cycle-Switch-Timer')))
    HSDSCH_Information_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 571), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 680), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 690), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 734), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 728), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 793), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 928), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 958), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 959), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Information-to-Modify-Unsynchronised >-----#
    HSDSCH_Information_to_Modify_Unsynchronised = SEQ(name=u'HSDSCH-Information-to-Modify-Unsynchronised', mode=MODE_TYPE)
    _HSDSCH_Information_to_Modify_Unsynchronised_hSDSCH_MACdFlow_Specific_InfoList_to_Modify = SEQ_OF(name=u'hSDSCH-MACdFlow-Specific-InfoList-to-Modify', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList-to-Modify')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_priorityQueueInfotoModifyUnsynchronised = SEQ_OF(name=u'priorityQueueInfotoModifyUnsynchronised', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList-to-Modify-Unsynchronised')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_cqiPowerOffset = INT(name=u'cqiPowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_ackPowerOffset = INT(name=u'ackPowerOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Ack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_nackPowerOffset = INT(name=u'nackPowerOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Nack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_hsscch_PowerOffset = INT(name=u'hsscch-PowerOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-PowerOffset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_tDDAckNackPowerOffset = INT(name=u'tDDAckNackPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EnhancedHSServingCC-Abort')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_9 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_10 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Reconfiguration')))
    ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 571), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 734), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 793), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 928), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab = ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_._ext = None
    _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions._cont = __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_
    _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Information_to_Modify_Unsynchronised._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-Specific-InfoList-to-Modify', _HSDSCH_Information_to_Modify_Unsynchronised_hSDSCH_MACdFlow_Specific_InfoList_to_Modify),
        (u'priorityQueueInfotoModifyUnsynchronised', _HSDSCH_Information_to_Modify_Unsynchronised_priorityQueueInfotoModifyUnsynchronised),
        (u'cqiPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_cqiPowerOffset),
        (u'ackPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_ackPowerOffset),
        (u'nackPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_nackPowerOffset),
        (u'hsscch-PowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_hsscch_PowerOffset),
        (u'tDDAckNackPowerOffset', _HSDSCH_Information_to_Modify_Unsynchronised_tDDAckNackPowerOffset),
        (u'iE-Extensions', _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions),
        ])
    HSDSCH_Information_to_Modify_Unsynchronised._ext = []
    
    #-----< HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs >-----#
    HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs = CLASS(name=u'HSDSCH-Information-to-Modify-Unsynchronised-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EnhancedHSServingCC-Abort')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Single-Stream-MIMO-Mode-Indicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ModeIndicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ModeIndicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_9 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_10 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Reconfiguration')))
    HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 571), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 709), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 734), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 793), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 826), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 920), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 924), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 928), (u'criticality', u'reject'), (u'Extension', _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlow-ID >-----#
    HSDSCH_MACdFlow_ID = INT(name=u'HSDSCH-MACdFlow-ID', mode=MODE_TYPE)
    HSDSCH_MACdFlow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoList >-----#
    HSDSCH_MACdFlow_Specific_InfoList = SEQ_OF(name=u'HSDSCH-MACdFlow-Specific-InfoList', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoItem')))
    HSDSCH_MACdFlow_Specific_InfoList._cont = _HSDSCH_MACdFlow_Specific_InfoList__item_
    HSDSCH_MACdFlow_Specific_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdPDUSizeFormat >-----#
    HSDSCH_MACdPDUSizeFormat = ENUM(name=u'HSDSCH-MACdPDUSizeFormat', mode=MODE_TYPE)
    HSDSCH_MACdPDUSizeFormat._cont = ASN1Dict([(u'indexedMACdPDU-Size', 0), (u'flexibleMACdPDU-Size', 1)])
    HSDSCH_MACdPDUSizeFormat._ext = None
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem >-----#
    HSDSCH_MACdFlow_Specific_InfoItem = SEQ(name=u'HSDSCH-MACdFlow-Specific-InfoItem', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoItem_hSDSCH_MACdFlow_ID = INT(name=u'hSDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')))
    _HSDSCH_MACdFlow_Specific_InfoItem_trafficClass = ENUM(name=u'trafficClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _HSDSCH_MACdFlow_Specific_InfoItem_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 654), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions._cont = __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_
    _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlow_Specific_InfoItem._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-ID', _HSDSCH_MACdFlow_Specific_InfoItem_hSDSCH_MACdFlow_ID),
        (u'allocationRetentionPriority', _HSDSCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority),
        (u'trafficClass', _HSDSCH_MACdFlow_Specific_InfoItem_trafficClass),
        (u'bindingID', _HSDSCH_MACdFlow_Specific_InfoItem_bindingID),
        (u'transportLayerAddress', _HSDSCH_MACdFlow_Specific_InfoItem_transportLayerAddress),
        (u'iE-Extensions', _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions),
        ])
    HSDSCH_MACdFlow_Specific_InfoItem._ext = []
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs = CLASS(name=u'HSDSCH-MACdFlow-Specific-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 654), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoList-Response >-----#
    HSDSCH_MACdFlow_Specific_InfoList_Response = SEQ_OF(name=u'HSDSCH-MACdFlow-Specific-InfoList-Response', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoList_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoItem-Response')))
    HSDSCH_MACdFlow_Specific_InfoList_Response._cont = _HSDSCH_MACdFlow_Specific_InfoList_Response__item_
    HSDSCH_MACdFlow_Specific_InfoList_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-Response >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_Response = SEQ(name=u'HSDSCH-MACdFlow-Specific-InfoItem-Response', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_hSDSCH_MACdFlow_ID = INT(name=u'hSDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_hSDSCH_Initial_Capacity_Allocation = SEQ_OF(name=u'hSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Initial-Capacity-Allocation')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions._cont = __HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item_
    _HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlow_Specific_InfoItem_Response._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-ID', _HSDSCH_MACdFlow_Specific_InfoItem_Response_hSDSCH_MACdFlow_ID),
        (u'bindingID', _HSDSCH_MACdFlow_Specific_InfoItem_Response_bindingID),
        (u'transportLayerAddress', _HSDSCH_MACdFlow_Specific_InfoItem_Response_transportLayerAddress),
        (u'hSDSCH-Initial-Capacity-Allocation', _HSDSCH_MACdFlow_Specific_InfoItem_Response_hSDSCH_Initial_Capacity_Allocation),
        (u'iE-Extensions', _HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions),
        ])
    HSDSCH_MACdFlow_Specific_InfoItem_Response._ext = []
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-Response-ExtIEs >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_Response_ExtIEs = CLASS(name=u'HSDSCH-MACdFlow-Specific-InfoItem-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSDSCH_MACdFlow_Specific_InfoItem_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoList-to-Modify >-----#
    HSDSCH_MACdFlow_Specific_InfoList_to_Modify = SEQ_OF(name=u'HSDSCH-MACdFlow-Specific-InfoList-to-Modify', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoList_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify')))
    HSDSCH_MACdFlow_Specific_InfoList_to_Modify._cont = _HSDSCH_MACdFlow_Specific_InfoList_to_Modify__item_
    HSDSCH_MACdFlow_Specific_InfoList_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-to-Modify >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify = SEQ(name=u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify', mode=MODE_TYPE)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_hSDSCH_MACdFlow_ID = INT(name=u'hSDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_trafficClass = ENUM(name=u'trafficClass', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions._cont = __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-ID', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_hSDSCH_MACdFlow_ID),
        (u'allocationRetentionPriority', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority),
        (u'transportBearerRequestIndicator', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator),
        (u'trafficClass', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_trafficClass),
        (u'bindingID', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_bindingID),
        (u'transportLayerAddress', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportLayerAddress),
        (u'iE-Extensions', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions),
        ])
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify._ext = []
    
    #-----< HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs >-----#
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs = CLASS(name=u'HSDSCH-MACdFlow-Specific-InfoItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlows-Information >-----#
    HSDSCH_MACdFlows_Information = SEQ(name=u'HSDSCH-MACdFlows-Information', mode=MODE_TYPE)
    _HSDSCH_MACdFlows_Information_hSDSCH_MACdFlow_Specific_Info = SEQ_OF(name=u'hSDSCH-MACdFlow-Specific-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList')))
    _HSDSCH_MACdFlows_Information_priorityQueue_Info = SEQ_OF(name=u'priorityQueue-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoList')))
    _HSDSCH_MACdFlows_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlows_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_MACdFlows_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlows_Information_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlows_Information_iE_Extensions._cont = __HSDSCH_MACdFlows_Information_iE_Extensions__item_
    _HSDSCH_MACdFlows_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlows_Information._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-Specific-Info', _HSDSCH_MACdFlows_Information_hSDSCH_MACdFlow_Specific_Info),
        (u'priorityQueue-Info', _HSDSCH_MACdFlows_Information_priorityQueue_Info),
        (u'iE-Extensions', _HSDSCH_MACdFlows_Information_iE_Extensions),
        ])
    HSDSCH_MACdFlows_Information._ext = []
    
    #-----< HSDSCH-MACdFlows-Information-ExtIEs >-----#
    HSDSCH_MACdFlows_Information_ExtIEs = CLASS(name=u'HSDSCH-MACdFlows-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSDSCH_MACdFlows_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-MACdFlows-to-Delete >-----#
    HSDSCH_MACdFlows_to_Delete = SEQ_OF(name=u'HSDSCH-MACdFlows-to-Delete', mode=MODE_TYPE)
    _HSDSCH_MACdFlows_to_Delete__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete-Item')))
    HSDSCH_MACdFlows_to_Delete._cont = _HSDSCH_MACdFlows_to_Delete__item_
    HSDSCH_MACdFlows_to_Delete._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-MACdFlows-to-Delete-Item >-----#
    HSDSCH_MACdFlows_to_Delete_Item = SEQ(name=u'HSDSCH-MACdFlows-to-Delete-Item', mode=MODE_TYPE)
    _HSDSCH_MACdFlows_to_Delete_Item_hsDSCH_MACdFlow_ID = INT(name=u'hsDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id._const_tab = ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality._const_tab = ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_._ext = None
    _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions._cont = __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_
    _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_MACdFlows_to_Delete_Item._cont = ASN1Dict([
        (u'hsDSCH-MACdFlow-ID', _HSDSCH_MACdFlows_to_Delete_Item_hsDSCH_MACdFlow_ID),
        (u'iE-Extensions', _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions),
        ])
    HSDSCH_MACdFlows_to_Delete_Item._ext = []
    
    #-----< HSDSCH-MACdFlows-to-Delete-Item-ExtIEs >-----#
    HSDSCH_MACdFlows_to_Delete_Item_ExtIEs = CLASS(name=u'HSDSCH-MACdFlows-to-Delete-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSDSCH_MACdFlows_to_Delete_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Initial-Capacity-Allocation >-----#
    HSDSCH_Initial_Capacity_Allocation = SEQ_OF(name=u'HSDSCH-Initial-Capacity-Allocation', mode=MODE_TYPE)
    _HSDSCH_Initial_Capacity_Allocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Initial-Capacity-AllocationItem')))
    HSDSCH_Initial_Capacity_Allocation._cont = _HSDSCH_Initial_Capacity_Allocation__item_
    HSDSCH_Initial_Capacity_Allocation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCH-Initial-Capacity-AllocationItem >-----#
    HSDSCH_Initial_Capacity_AllocationItem = SEQ(name=u'HSDSCH-Initial-Capacity-AllocationItem', mode=MODE_TYPE)
    _HSDSCH_Initial_Capacity_AllocationItem_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _HSDSCH_Initial_Capacity_AllocationItem_maximum_MACdPDU_Size = INT(name=u'maximum-MACdPDU-Size', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size')))
    _HSDSCH_Initial_Capacity_AllocationItem_hSDSCH_InitialWindowSize = INT(name=u'hSDSCH-InitialWindowSize', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-InitialWindowSize')))
    _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id._const_tab = ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality._const_tab = ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_._ext = None
    _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions._cont = __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_
    _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_Initial_Capacity_AllocationItem._cont = ASN1Dict([
        (u'schedulingPriorityIndicator', _HSDSCH_Initial_Capacity_AllocationItem_schedulingPriorityIndicator),
        (u'maximum-MACdPDU-Size', _HSDSCH_Initial_Capacity_AllocationItem_maximum_MACdPDU_Size),
        (u'hSDSCH-InitialWindowSize', _HSDSCH_Initial_Capacity_AllocationItem_hSDSCH_InitialWindowSize),
        (u'iE-Extensions', _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions),
        ])
    HSDSCH_Initial_Capacity_AllocationItem._ext = []
    
    #-----< HSDSCH-Initial-Capacity-AllocationItem-ExtIEs >-----#
    HSDSCH_Initial_Capacity_AllocationItem_ExtIEs = CLASS(name=u'HSDSCH-Initial-Capacity-AllocationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_Initial_Capacity_AllocationItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    HSDSCH_Initial_Capacity_AllocationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_Initial_Capacity_AllocationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-InitialWindowSize >-----#
    HSDSCH_InitialWindowSize = INT(name=u'HSDSCH-InitialWindowSize', mode=MODE_TYPE)
    HSDSCH_InitialWindowSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< HSDSCH-PreconfigurationInfo >-----#
    HSDSCH_PreconfigurationInfo = SEQ(name=u'HSDSCH-PreconfigurationInfo', mode=MODE_TYPE)
    _HSDSCH_PreconfigurationInfo_setsOfHS_SCCH_Codes = SEQ_OF(name=u'setsOfHS-SCCH-Codes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SetsOfHS-SCCH-Codes')))
    _HSDSCH_PreconfigurationInfo_hARQ_MemoryPartitioning = CHOICE(name=u'hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioning')))
    _HSDSCH_PreconfigurationInfo_eDCH_FDD_DL_ControlChannelInformation = SEQ(name=u'eDCH-FDD-DL-ControlChannelInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    _HSDSCH_PreconfigurationInfo_hARQ_Preamble_Mode_Activation_Indicator = ENUM(name=u'hARQ-Preamble-Mode-Activation-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode-Activation-Indicator')), opt=True)
    _HSDSCH_PreconfigurationInfo_mIMO_N_M_Ratio = SEQ(name=u'mIMO-N-M-Ratio', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')), opt=True)
    _HSDSCH_PreconfigurationInfo_continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response = SEQ(name=u'continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')), opt=True)
    _HSDSCH_PreconfigurationInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_PreconfigurationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Preconfiguration-Information')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 844), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 909), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id._const_tab = ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality._const_tab = ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_PreconfigurationInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_PreconfigurationInfo_iE_Extensions__item_._ext = None
    _HSDSCH_PreconfigurationInfo_iE_Extensions._cont = __HSDSCH_PreconfigurationInfo_iE_Extensions__item_
    _HSDSCH_PreconfigurationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_PreconfigurationInfo._cont = ASN1Dict([
        (u'setsOfHS-SCCH-Codes', _HSDSCH_PreconfigurationInfo_setsOfHS_SCCH_Codes),
        (u'hARQ-MemoryPartitioning', _HSDSCH_PreconfigurationInfo_hARQ_MemoryPartitioning),
        (u'eDCH-FDD-DL-ControlChannelInformation', _HSDSCH_PreconfigurationInfo_eDCH_FDD_DL_ControlChannelInformation),
        (u'hARQ-Preamble-Mode-Activation-Indicator', _HSDSCH_PreconfigurationInfo_hARQ_Preamble_Mode_Activation_Indicator),
        (u'mIMO-N-M-Ratio', _HSDSCH_PreconfigurationInfo_mIMO_N_M_Ratio),
        (u'continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response', _HSDSCH_PreconfigurationInfo_continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response),
        (u'iE-Extensions', _HSDSCH_PreconfigurationInfo_iE_Extensions),
        ])
    HSDSCH_PreconfigurationInfo._ext = []
    
    #-----< HSDSCH-PreconfigurationInfo-ExtIEs >-----#
    HSDSCH_PreconfigurationInfo_ExtIEs = CLASS(name=u'HSDSCH-PreconfigurationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Preconfiguration-Information')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    HSDSCH_PreconfigurationInfo_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 844), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 909), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Preconfiguration-Information >-----#
    Additional_EDCH_Preconfiguration_Information = SEQ_OF(name=u'Additional-EDCH-Preconfiguration-Information', mode=MODE_TYPE)
    _Additional_EDCH_Preconfiguration_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Preconfiguration-Information-ItemIEs')))
    Additional_EDCH_Preconfiguration_Information._cont = _Additional_EDCH_Preconfiguration_Information__item_
    Additional_EDCH_Preconfiguration_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Preconfiguration-Information-ItemIEs >-----#
    Additional_EDCH_Preconfiguration_Information_ItemIEs = SEQ(name=u'Additional-EDCH-Preconfiguration-Information-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_eDCH_FDD_DL_ControlChannelInformation = SEQ(name=u'eDCH-FDD-DL-ControlChannelInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Preconfiguration_Information_ItemIEs._cont = ASN1Dict([
        (u'eDCH-FDD-DL-ControlChannelInformation', _Additional_EDCH_Preconfiguration_Information_ItemIEs_eDCH_FDD_DL_ControlChannelInformation),
        (u'iE-Extensions', _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Preconfiguration_Information_ItemIEs._ext = []
    
    #-----< Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs >-----#
    Additional_EDCH_Preconfiguration_Information_ItemIEs_ExtIEs = CLASS(name=u'Additional-EDCH-Preconfiguration-Information-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Preconfiguration_Information_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-PreconfigurationSetup >-----#
    HSDSCH_PreconfigurationSetup = SEQ(name=u'HSDSCH-PreconfigurationSetup', mode=MODE_TYPE)
    _HSDSCH_PreconfigurationSetup_mAChsResetScheme = ENUM(name=u'mAChsResetScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsResetScheme')))
    _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category = INT(name=u'hSDSCH-Physical-Layer-Category', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    _HSDSCH_PreconfigurationSetup_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name=u'mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')))
    _HSDSCH_PreconfigurationSetup_secondaryServingCells = SEQ_OF(name=u'secondaryServingCells', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SecondaryServingCells')), opt=True)
    _HSDSCH_PreconfigurationSetup_numPrimaryHS_SCCH_Codes = INT(name=u'numPrimaryHS-SCCH-Codes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NumHS-SCCH-Codes')), opt=True)
    _HSDSCH_PreconfigurationSetup_hARQ_Preamble_Mode = ENUM(name=u'hARQ-Preamble-Mode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Preamble-Mode')), opt=True)
    _HSDSCH_PreconfigurationSetup_mIMO_ActivationIndicator = NULL(name=u'mIMO-ActivationIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')), opt=True)
    _HSDSCH_PreconfigurationSetup_hSDSCH_MACdPDUSizeFormat = ENUM(name=u'hSDSCH-MACdPDUSizeFormat', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')), opt=True)
    _HSDSCH_PreconfigurationSetup_sixtyfourQAM_UsageAllowedIndicator = ENUM(name=u'sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _HSDSCH_PreconfigurationSetup_uE_with_enhanced_HS_SCCH_support_indicator = NULL(name=u'uE-with-enhanced-HS-SCCH-support-indicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HSDSCH_PreconfigurationSetup_continuous_Packet_Connectivity_HS_SCCH_Less_Information = SEQ_OF(name=u'continuous-Packet-Connectivity-HS-SCCH-Less-Information', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information')), opt=True)
    _HSDSCH_PreconfigurationSetup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_PreconfigurationSetup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_3 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 927), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 906), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 930), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 732), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 933), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id._const_tab = ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality._const_tab = ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_PreconfigurationSetup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_PreconfigurationSetup_iE_Extensions__item_._ext = None
    _HSDSCH_PreconfigurationSetup_iE_Extensions._cont = __HSDSCH_PreconfigurationSetup_iE_Extensions__item_
    _HSDSCH_PreconfigurationSetup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_PreconfigurationSetup._cont = ASN1Dict([
        (u'mAChsResetScheme', _HSDSCH_PreconfigurationSetup_mAChsResetScheme),
        (u'hSDSCH-Physical-Layer-Category', _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category),
        (u'mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_PreconfigurationSetup_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        (u'secondaryServingCells', _HSDSCH_PreconfigurationSetup_secondaryServingCells),
        (u'numPrimaryHS-SCCH-Codes', _HSDSCH_PreconfigurationSetup_numPrimaryHS_SCCH_Codes),
        (u'hARQ-Preamble-Mode', _HSDSCH_PreconfigurationSetup_hARQ_Preamble_Mode),
        (u'mIMO-ActivationIndicator', _HSDSCH_PreconfigurationSetup_mIMO_ActivationIndicator),
        (u'hSDSCH-MACdPDUSizeFormat', _HSDSCH_PreconfigurationSetup_hSDSCH_MACdPDUSizeFormat),
        (u'sixtyfourQAM-UsageAllowedIndicator', _HSDSCH_PreconfigurationSetup_sixtyfourQAM_UsageAllowedIndicator),
        (u'uE-with-enhanced-HS-SCCH-support-indicator', _HSDSCH_PreconfigurationSetup_uE_with_enhanced_HS_SCCH_support_indicator),
        (u'continuous-Packet-Connectivity-HS-SCCH-Less-Information', _HSDSCH_PreconfigurationSetup_continuous_Packet_Connectivity_HS_SCCH_Less_Information),
        (u'iE-Extensions', _HSDSCH_PreconfigurationSetup_iE_Extensions),
        ])
    HSDSCH_PreconfigurationSetup._ext = []
    
    #-----< HSDSCHPreconfigurationSetup-ExtIEs >-----#
    HSDSCHPreconfigurationSetup_ExtIEs = CLASS(name=u'HSDSCHPreconfigurationSetup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_0 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-SupportIndicatorExtension')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_3 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixteenQAM-UL-Operation-Indicator')))
    _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UL-Operation-Indicator')))
    HSDSCHPreconfigurationSetup_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 831), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 927), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 906), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 930), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 732), (u'criticality', u'ignore'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 933), (u'criticality', u'reject'), (u'Extension', _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-PreconfiguredCodes >-----#
    HS_SCCH_PreconfiguredCodes = SEQ_OF(name=u'HS-SCCH-PreconfiguredCodes', mode=MODE_TYPE)
    _HS_SCCH_PreconfiguredCodes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-PreconfiguredCodesItem')))
    HS_SCCH_PreconfiguredCodes._cont = _HS_SCCH_PreconfiguredCodes__item_
    HS_SCCH_PreconfiguredCodes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HS-SCCH-PreconfiguredCodesItem >-----#
    HS_SCCH_PreconfiguredCodesItem = SEQ(name=u'HS-SCCH-PreconfiguredCodesItem', mode=MODE_TYPE)
    _HS_SCCH_PreconfiguredCodesItem_hS_SCCH_CodeNumber = INT(name=u'hS-SCCH-CodeNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-CodeNumber')))
    _HS_SCCH_PreconfiguredCodesItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id._const_tab = ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id),
        (u'criticality', ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_._ext = None
    _HS_SCCH_PreconfiguredCodesItem_iE_Extensions._cont = __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_
    _HS_SCCH_PreconfiguredCodesItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_PreconfiguredCodesItem._cont = ASN1Dict([
        (u'hS-SCCH-CodeNumber', _HS_SCCH_PreconfiguredCodesItem_hS_SCCH_CodeNumber),
        (u'iE-Extensions', _HS_SCCH_PreconfiguredCodesItem_iE_Extensions),
        ])
    HS_SCCH_PreconfiguredCodesItem._ext = []
    
    #-----< HS-SCCH-PreconfiguredCodesItem-ExtIEs >-----#
    HS_SCCH_PreconfiguredCodesItem_ExtIEs = CLASS(name=u'HS-SCCH-PreconfiguredCodesItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_SCCH_PreconfiguredCodesItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-CodeNumber >-----#
    HS_SCCH_CodeNumber = INT(name=u'HS-SCCH-CodeNumber', mode=MODE_TYPE)
    HS_SCCH_CodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< HSDSCH-RNTI >-----#
    HSDSCH_RNTI = INT(name=u'HSDSCH-RNTI', mode=MODE_TYPE)
    HSDSCH_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< HS-DSCH-serving-cell-change-information >-----#
    HS_DSCH_serving_cell_change_information = SEQ(name=u'HS-DSCH-serving-cell-change-information', mode=MODE_TYPE)
    _HS_DSCH_serving_cell_change_information_hS_PDSCH_RLID = INT(name=u'hS-PDSCH-RLID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _HS_DSCH_serving_cell_change_information_hSDSCH_FDD_Information = SEQ(name=u'hSDSCH-FDD-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')), opt=True)
    _HS_DSCH_serving_cell_change_information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_serving_cell_change_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information')))
    _____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-DTX-DRX-Information')))
    ____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 671), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 670), (u'criticality', u'reject'), (u'Extension', _____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__id._const_tab = ____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_serving_cell_change_information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_serving_cell_change_information_iE_Extensions__item_._ext = None
    _HS_DSCH_serving_cell_change_information_iE_Extensions._cont = __HS_DSCH_serving_cell_change_information_iE_Extensions__item_
    _HS_DSCH_serving_cell_change_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_serving_cell_change_information._cont = ASN1Dict([
        (u'hS-PDSCH-RLID', _HS_DSCH_serving_cell_change_information_hS_PDSCH_RLID),
        (u'hSDSCH-FDD-Information', _HS_DSCH_serving_cell_change_information_hSDSCH_FDD_Information),
        (u'iE-Extensions', _HS_DSCH_serving_cell_change_information_iE_Extensions),
        ])
    HS_DSCH_serving_cell_change_information._ext = []
    
    #-----< HS-DSCH-serving-cell-change-information-ExtIEs >-----#
    HS_DSCH_serving_cell_change_information_ExtIEs = CLASS(name=u'HS-DSCH-serving-cell-change-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_DSCH_serving_cell_change_information_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information')))
    _HS_DSCH_serving_cell_change_information_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-DTX-DRX-Information')))
    HS_DSCH_serving_cell_change_information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 671), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_serving_cell_change_information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 670), (u'criticality', u'reject'), (u'Extension', _HS_DSCH_serving_cell_change_information_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-serving-cell-change-informationResponse >-----#
    HS_DSCH_serving_cell_change_informationResponse = SEQ(name=u'HS-DSCH-serving-cell-change-informationResponse', mode=MODE_TYPE)
    _HS_DSCH_serving_cell_change_informationResponse_hS_DSCH_serving_cell_choice = CHOICE(name=u'hS-DSCH-serving-cell-choice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-choice')))
    _HS_DSCH_serving_cell_change_informationResponse_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id._const_tab = ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id_tab
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item_._ext = None
    _HS_DSCH_serving_cell_change_informationResponse_iE_Extensions._cont = __HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item_
    _HS_DSCH_serving_cell_change_informationResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_serving_cell_change_informationResponse._cont = ASN1Dict([
        (u'hS-DSCH-serving-cell-choice', _HS_DSCH_serving_cell_change_informationResponse_hS_DSCH_serving_cell_choice),
        (u'iE-Extensions', _HS_DSCH_serving_cell_change_informationResponse_iE_Extensions),
        ])
    HS_DSCH_serving_cell_change_informationResponse._ext = []
    
    #-----< HS-DSCH-serving-cell-change-informationResponse-ExtIEs >-----#
    HS_DSCH_serving_cell_change_informationResponse_ExtIEs = CLASS(name=u'HS-DSCH-serving-cell-change-informationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_DSCH_serving_cell_change_informationResponse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-serving-cell-change-choice >-----#
    HS_DSCH_serving_cell_change_choice = CHOICE(name=u'HS-DSCH-serving-cell-change-choice', mode=MODE_TYPE)
    _HS_DSCH_serving_cell_change_choice_hS_serving_cell_change_successful = SEQ(name=u'hS-serving-cell-change-successful', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-serving-cell-change-successful')))
    _HS_DSCH_serving_cell_change_choice_hS_serving_cell_change_unsuccessful = SEQ(name=u'hS-serving-cell-change-unsuccessful', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-serving-cell-change-unsuccessful')))
    HS_DSCH_serving_cell_change_choice._cont = ASN1Dict([
        (u'hS-serving-cell-change-successful', _HS_DSCH_serving_cell_change_choice_hS_serving_cell_change_successful),
        (u'hS-serving-cell-change-unsuccessful', _HS_DSCH_serving_cell_change_choice_hS_serving_cell_change_unsuccessful),
        ])
    HS_DSCH_serving_cell_change_choice._ext = []
    
    #-----< HSDSCH-TBSizeTableIndicator >-----#
    HSDSCH_TBSizeTableIndicator = ENUM(name=u'HSDSCH-TBSizeTableIndicator', mode=MODE_TYPE)
    HSDSCH_TBSizeTableIndicator._cont = ASN1Dict([(u'octet-aligned', 0)])
    HSDSCH_TBSizeTableIndicator._ext = None
    
    #-----< HS-serving-cell-change-successful >-----#
    HS_serving_cell_change_successful = SEQ(name=u'HS-serving-cell-change-successful', mode=MODE_TYPE)
    _HS_serving_cell_change_successful_hSDSCH_FDD_Information_Response = SEQ(name=u'hSDSCH-FDD-Information-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _HS_serving_cell_change_successful_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _HS_serving_cell_change_successful_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_serving_cell_change_successful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_serving_cell_change_successful_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_serving_cell_change_successful_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _____HS_serving_cell_change_successful_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_successful_iE_Extensions__item__id._const_tab = ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_successful_iE_Extensions__item__id._const_tab_at = None
    ___HS_serving_cell_change_successful_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab = ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_serving_cell_change_successful_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab = ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_serving_cell_change_successful_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_serving_cell_change_successful_iE_Extensions__item__id),
        (u'criticality', ___HS_serving_cell_change_successful_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue),
        ])
    __HS_serving_cell_change_successful_iE_Extensions__item_._ext = None
    _HS_serving_cell_change_successful_iE_Extensions._cont = __HS_serving_cell_change_successful_iE_Extensions__item_
    _HS_serving_cell_change_successful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_serving_cell_change_successful._cont = ASN1Dict([
        (u'hSDSCH-FDD-Information-Response', _HS_serving_cell_change_successful_hSDSCH_FDD_Information_Response),
        (u'hSDSCH-RNTI', _HS_serving_cell_change_successful_hSDSCH_RNTI),
        (u'iE-Extensions', _HS_serving_cell_change_successful_iE_Extensions),
        ])
    HS_serving_cell_change_successful._ext = []
    
    #-----< HS-serving-cell-change-successful-ExtIEs >-----#
    HS_serving_cell_change_successful_ExtIEs = CLASS(name=u'HS-serving-cell-change-successful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_serving_cell_change_successful_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    HS_serving_cell_change_successful_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _HS_serving_cell_change_successful_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-serving-cell-change-unsuccessful >-----#
    HS_serving_cell_change_unsuccessful = SEQ(name=u'HS-serving-cell-change-unsuccessful', mode=MODE_TYPE)
    _HS_serving_cell_change_unsuccessful_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _HS_serving_cell_change_unsuccessful_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_serving_cell_change_unsuccessful_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab = ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_at = None
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab = ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab = ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_serving_cell_change_unsuccessful_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id),
        (u'criticality', ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue),
        ])
    __HS_serving_cell_change_unsuccessful_iE_Extensions__item_._ext = None
    _HS_serving_cell_change_unsuccessful_iE_Extensions._cont = __HS_serving_cell_change_unsuccessful_iE_Extensions__item_
    _HS_serving_cell_change_unsuccessful_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_serving_cell_change_unsuccessful._cont = ASN1Dict([
        (u'cause', _HS_serving_cell_change_unsuccessful_cause),
        (u'iE-Extensions', _HS_serving_cell_change_unsuccessful_iE_Extensions),
        ])
    HS_serving_cell_change_unsuccessful._ext = []
    
    #-----< HS-serving-cell-change-unsuccessful-ExtIEs >-----#
    HS_serving_cell_change_unsuccessful_ExtIEs = CLASS(name=u'HS-serving-cell-change-unsuccessful-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_serving_cell_change_unsuccessful_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-First-Code-Index >-----#
    HSPDSCH_First_Code_Index = INT(name=u'HSPDSCH-First-Code-Index', mode=MODE_TYPE)
    HSPDSCH_First_Code_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-Second-Code-Index >-----#
    HSPDSCH_Second_Code_Index = INT(name=u'HSPDSCH-Second-Code-Index', mode=MODE_TYPE)
    HSPDSCH_Second_Code_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-Second-Code-Support >-----#
    HSPDSCH_Second_Code_Support = BOOL(name=u'HSPDSCH-Second-Code-Support', mode=MODE_TYPE)
    
    #-----< HSDSCH-TDD-Information >-----#
    HSDSCH_TDD_Information = SEQ(name=u'HSDSCH-TDD-Information', mode=MODE_TYPE)
    _HSDSCH_TDD_Information_hSDSCH_MACdFlows_Information = SEQ(name=u'hSDSCH-MACdFlows-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _HSDSCH_TDD_Information_uE_Capabilities_Info = SEQ(name=u'uE-Capabilities-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-Capabilities-Info')))
    _HSDSCH_TDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM = INT(name=u'mAChs-Reordering-Buffer-Size-for-RLC-UM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsReorderingBufferSize-for-RLC-UM')))
    _HSDSCH_TDD_Information_tDD_AckNack_Power_Offset = INT(name=u'tDD-AckNack-Power-Offset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-AckNack-Power-Offset')))
    _HSDSCH_TDD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_TDD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_TDD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TSN-Length')))
    _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 690), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 717), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 718), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 719), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 708), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_TDD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_TDD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_TDD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_TDD_Information_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_TDD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_TDD_Information_iE_Extensions__item_._ext = None
    _HSDSCH_TDD_Information_iE_Extensions._cont = __HSDSCH_TDD_Information_iE_Extensions__item_
    _HSDSCH_TDD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_TDD_Information._cont = ASN1Dict([
        (u'hSDSCH-MACdFlows-Information', _HSDSCH_TDD_Information_hSDSCH_MACdFlows_Information),
        (u'uE-Capabilities-Info', _HSDSCH_TDD_Information_uE_Capabilities_Info),
        (u'mAChs-Reordering-Buffer-Size-for-RLC-UM', _HSDSCH_TDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM),
        (u'tDD-AckNack-Power-Offset', _HSDSCH_TDD_Information_tDD_AckNack_Power_Offset),
        (u'iE-Extensions', _HSDSCH_TDD_Information_iE_Extensions),
        ])
    HSDSCH_TDD_Information._ext = []
    
    #-----< HSDSCH-TDD-Information-ExtIEs >-----#
    HSDSCH_TDD_Information_ExtIEs = CLASS(name=u'HSDSCH-TDD-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdPDUSizeFormat')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TSN-Length')))
    _HSDSCH_TDD_Information_ExtIEs_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    HSDSCH_TDD_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 690), (u'criticality', u'reject'), (u'Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 717), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 718), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 719), (u'criticality', u'reject'), (u'Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 708), (u'criticality', u'reject'), (u'Extension', _HSDSCH_TDD_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-TDD-Information-Response >-----#
    HSDSCH_TDD_Information_Response = SEQ(name=u'HSDSCH-TDD-Information-Response', mode=MODE_TYPE)
    _HSDSCH_TDD_Information_Response_hSDSCH_MACdFlow_Specific_InfoList_Response = SEQ_OF(name=u'hSDSCH-MACdFlow-Specific-InfoList-Response', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-Specific-InfoList-Response')), opt=True)
    _HSDSCH_TDD_Information_Response_hSSCCH_TDD_Specific_InfoList_Response = SEQ_OF(name=u'hSSCCH-TDD-Specific-InfoList-Response', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoList-Response')), opt=True)
    _HSDSCH_TDD_Information_Response_hSSCCH_TDD_Specific_InfoList_Response_LCR = SEQ_OF(name=u'hSSCCH-TDD-Specific-InfoList-Response-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoList-Response-LCR')), opt=True)
    _HSDSCH_TDD_Information_Response_hSPDSCH_TDD_Specific_InfoList_Response = SEQ_OF(name=u'hSPDSCH-TDD-Specific-InfoList-Response', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoList-Response')), opt=True)
    _HSDSCH_TDD_Information_Response_hSPDSCH_TDD_Specific_InfoList_Response_LCR = SEQ_OF(name=u'hSPDSCH-TDD-Specific-InfoList-Response-LCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoList-Response-LCR')), opt=True)
    _HSDSCH_TDD_Information_Response_hARQ_MemoryPartitioning = CHOICE(name=u'hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _HSDSCH_TDD_Information_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_TDD_Information_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'User-Plane-Congestion-Fields-Inclusion')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoList-Response768')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoList-Response768')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multicarrier-Number')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ReferenceSignal-InformationListLCR')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TS0-HS-PDSCH-Indication-LCR')))
    _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Out-of-Sychronization-Window')))
    ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 593), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 624), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 625), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 722), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 723), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 815), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 817), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 870), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 867), (u'criticality', u'reject'), (u'Extension', _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id._const_tab = ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality._const_tab = ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_TDD_Information_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_TDD_Information_Response_iE_Extensions__item_._ext = None
    _HSDSCH_TDD_Information_Response_iE_Extensions._cont = __HSDSCH_TDD_Information_Response_iE_Extensions__item_
    _HSDSCH_TDD_Information_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_TDD_Information_Response._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-Specific-InfoList-Response', _HSDSCH_TDD_Information_Response_hSDSCH_MACdFlow_Specific_InfoList_Response),
        (u'hSSCCH-TDD-Specific-InfoList-Response', _HSDSCH_TDD_Information_Response_hSSCCH_TDD_Specific_InfoList_Response),
        (u'hSSCCH-TDD-Specific-InfoList-Response-LCR', _HSDSCH_TDD_Information_Response_hSSCCH_TDD_Specific_InfoList_Response_LCR),
        (u'hSPDSCH-TDD-Specific-InfoList-Response', _HSDSCH_TDD_Information_Response_hSPDSCH_TDD_Specific_InfoList_Response),
        (u'hSPDSCH-TDD-Specific-InfoList-Response-LCR', _HSDSCH_TDD_Information_Response_hSPDSCH_TDD_Specific_InfoList_Response_LCR),
        (u'hARQ-MemoryPartitioning', _HSDSCH_TDD_Information_Response_hARQ_MemoryPartitioning),
        (u'iE-Extensions', _HSDSCH_TDD_Information_Response_iE_Extensions),
        ])
    HSDSCH_TDD_Information_Response._ext = []
    
    #-----< HSDSCH-TDD-Information-Response-ExtIEs >-----#
    HSDSCH_TDD_Information_Response_ExtIEs = CLASS(name=u'HSDSCH-TDD-Information-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'User-Plane-Congestion-Fields-Inclusion')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoList-Response768')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoList-Response768')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multicarrier-Number')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ReferenceSignal-InformationListLCR')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TS0-HS-PDSCH-Indication-LCR')))
    _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Out-of-Sychronization-Window')))
    HSDSCH_TDD_Information_Response_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 593), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 624), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 625), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 722), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 723), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 815), (u'criticality', u'reject'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 817), (u'criticality', u'reject'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 870), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 867), (u'criticality', u'reject'), (u'Extension', _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multicarrier-Number >-----#
    Multicarrier_Number = INT(name=u'Multicarrier-Number', mode=MODE_TYPE)
    Multicarrier_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSPDSCH-TDD-Specific-InfoList-Response >-----#
    HSPDSCH_TDD_Specific_InfoList_Response = SEQ_OF(name=u'HSPDSCH-TDD-Specific-InfoList-Response', mode=MODE_TYPE)
    _HSPDSCH_TDD_Specific_InfoList_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoItem-Response')))
    HSPDSCH_TDD_Specific_InfoList_Response._cont = _HSPDSCH_TDD_Specific_InfoList_Response__item_
    HSPDSCH_TDD_Specific_InfoList_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-TDD-Specific-InfoItem-Response >-----#
    HSPDSCH_TDD_Specific_InfoItem_Response = SEQ(name=u'HSPDSCH-TDD-Specific-InfoItem-Response', mode=MODE_TYPE)
    _HSPDSCH_TDD_Specific_InfoItem_Response_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSPDSCH_TDD_Specific_InfoItem_Response_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id),
        (u'criticality', ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue),
        ])
    __HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_._ext = None
    _HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions._cont = __HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_
    _HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSPDSCH_TDD_Specific_InfoItem_Response._cont = ASN1Dict([
        (u'timeslot', _HSPDSCH_TDD_Specific_InfoItem_Response_timeslot),
        (u'midambleShiftAndBurstType', _HSPDSCH_TDD_Specific_InfoItem_Response_midambleShiftAndBurstType),
        (u'iE-Extensions', _HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions),
        ])
    HSPDSCH_TDD_Specific_InfoItem_Response._ext = []
    
    #-----< HSPDSCH-TDD-Specific-InfoItem-Response-ExtIEs >-----#
    HSPDSCH_TDD_Specific_InfoItem_Response_ExtIEs = CLASS(name=u'HSPDSCH-TDD-Specific-InfoItem-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSPDSCH_TDD_Specific_InfoItem_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-TDD-Specific-InfoList-Response-LCR >-----#
    HSPDSCH_TDD_Specific_InfoList_Response_LCR = SEQ_OF(name=u'HSPDSCH-TDD-Specific-InfoList-Response-LCR', mode=MODE_TYPE)
    _HSPDSCH_TDD_Specific_InfoList_Response_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoItem-Response-LCR')))
    HSPDSCH_TDD_Specific_InfoList_Response_LCR._cont = _HSPDSCH_TDD_Specific_InfoList_Response_LCR__item_
    HSPDSCH_TDD_Specific_InfoList_Response_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< HSPDSCH-TDD-Specific-InfoItem-Response-LCR >-----#
    HSPDSCH_TDD_Specific_InfoItem_Response_LCR = SEQ(name=u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR', mode=MODE_TYPE)
    _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_timeslotLCR = INT(name=u'timeslotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id),
        (u'criticality', ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue),
        ])
    __HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_._ext = None
    _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions._cont = __HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_
    _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSPDSCH_TDD_Specific_InfoItem_Response_LCR._cont = ASN1Dict([
        (u'timeslotLCR', _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_timeslotLCR),
        (u'midambleShiftLCR', _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_midambleShiftLCR),
        (u'iE-Extensions', _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions),
        ])
    HSPDSCH_TDD_Specific_InfoItem_Response_LCR._ext = []
    
    #-----< HSPDSCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs >-----#
    HSPDSCH_TDD_Specific_InfoItem_Response_LCR_ExtIEs = CLASS(name=u'HSPDSCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSPDSCH_TDD_Specific_InfoItem_Response_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-TDD-Specific-InfoList-Response768 >-----#
    HSPDSCH_TDD_Specific_InfoList_Response768 = SEQ_OF(name=u'HSPDSCH-TDD-Specific-InfoList-Response768', mode=MODE_TYPE)
    _HSPDSCH_TDD_Specific_InfoList_Response768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSPDSCH-TDD-Specific-InfoItem-Response768')))
    HSPDSCH_TDD_Specific_InfoList_Response768._cont = _HSPDSCH_TDD_Specific_InfoList_Response768__item_
    HSPDSCH_TDD_Specific_InfoList_Response768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-TDD-Specific-InfoItem-Response768 >-----#
    HSPDSCH_TDD_Specific_InfoItem_Response768 = SEQ(name=u'HSPDSCH-TDD-Specific-InfoItem-Response768', mode=MODE_TYPE)
    _HSPDSCH_TDD_Specific_InfoItem_Response768_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSPDSCH_TDD_Specific_InfoItem_Response768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id._const_tab_at = None
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue._const_tab = ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id),
        (u'criticality', ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue),
        ])
    __HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_._ext = None
    _HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions._cont = __HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_
    _HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSPDSCH_TDD_Specific_InfoItem_Response768._cont = ASN1Dict([
        (u'timeslot', _HSPDSCH_TDD_Specific_InfoItem_Response768_timeslot),
        (u'midambleShiftAndBurstType768', _HSPDSCH_TDD_Specific_InfoItem_Response768_midambleShiftAndBurstType768),
        (u'iE-Extensions', _HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions),
        ])
    HSPDSCH_TDD_Specific_InfoItem_Response768._ext = []
    
    #-----< HSPDSCH-TDD-Specific-InfoItem-Response-768-ExtIEs >-----#
    HSPDSCH_TDD_Specific_InfoItem_Response_768_ExtIEs = CLASS(name=u'HSPDSCH-TDD-Specific-InfoItem-Response-768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSPDSCH_TDD_Specific_InfoItem_Response_768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-DRX-Information-LCR >-----#
    HS_SCCH_DRX_Information_LCR = SEQ(name=u'HS-SCCH-DRX-Information-LCR', mode=MODE_TYPE)
    _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Cycle_LCR = ENUM(name=u'hS-SCCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle-LCR')))
    _HS_SCCH_DRX_Information_LCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR = ENUM(name=u'hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR')), opt=True)
    _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Offset_LCR = INT(name=u'hS-SCCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Offset-LCR')))
    _HS_SCCH_DRX_Information_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 890), (u'criticality', u'ignore'), (u'Extension', _____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id._const_tab = ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id),
        (u'criticality', ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_._ext = None
    _HS_SCCH_DRX_Information_LCR_iE_Extensions._cont = __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_
    _HS_SCCH_DRX_Information_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_DRX_Information_LCR._cont = ASN1Dict([
        (u'hS-SCCH-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Cycle_LCR),
        (u'hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_LCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR),
        (u'hS-SCCH-UE-DRX-Offset-LCR', _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Offset_LCR),
        (u'iE-Extensions', _HS_SCCH_DRX_Information_LCR_iE_Extensions),
        ])
    HS_SCCH_DRX_Information_LCR._ext = []
    
    #-----< HS-SCCH-DRX-Information-LCR-ExtIEs >-----#
    HS_SCCH_DRX_Information_LCR_ExtIEs = CLASS(name=u'HS-SCCH-DRX-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_SCCH_DRX_Information_LCR_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    HS_SCCH_DRX_Information_LCR_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 890), (u'criticality', u'ignore'), (u'Extension', _HS_SCCH_DRX_Information_LCR_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HS-SCCH-DRX-Information-ResponseLCR >-----#
    HS_SCCH_DRX_Information_ResponseLCR = SEQ(name=u'HS-SCCH-DRX-Information-ResponseLCR', mode=MODE_TYPE)
    _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Cycle_LCR = ENUM(name=u'hS-SCCH-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Cycle-LCR')), opt=True)
    _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR = ENUM(name=u'hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR')), opt=True)
    _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Offset_LCR = INT(name=u'hS-SCCH-UE-DRX-Offset-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-DRX-Offset-LCR')), opt=True)
    _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 890), (u'criticality', u'ignore'), (u'Extension', _____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id),
        (u'criticality', ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions._cont = __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_
    _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SCCH_DRX_Information_ResponseLCR._cont = ASN1Dict([
        (u'hS-SCCH-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Cycle_LCR),
        (u'hS-SCCH-Inactivity-Threshold-for-UE-DRX-Cycle-LCR', _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR),
        (u'hS-SCCH-UE-DRX-Offset-LCR', _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Offset_LCR),
        (u'iE-Extensions', _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions),
        ])
    HS_SCCH_DRX_Information_ResponseLCR._ext = []
    
    #-----< HS-SCCH-DRX-Information-ResponseLCR-ExtIEs >-----#
    HS_SCCH_DRX_Information_ResponseLCR_ExtIEs = CLASS(name=u'HS-SCCH-DRX-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HS_SCCH_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext')))
    HS_SCCH_DRX_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 890), (u'criticality', u'ignore'), (u'Extension', _HS_SCCH_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-FDD-Specific-InfoList-Response >-----#
    HSSCCH_FDD_Specific_InfoList_Response = SEQ_OF(name=u'HSSCCH-FDD-Specific-InfoList-Response', mode=MODE_TYPE)
    _HSSCCH_FDD_Specific_InfoList_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-FDD-Specific-InfoItem-Response')))
    HSSCCH_FDD_Specific_InfoList_Response._cont = _HSSCCH_FDD_Specific_InfoList_Response__item_
    HSSCCH_FDD_Specific_InfoList_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-FDD-Specific-InfoItem-Response >-----#
    HSSCCH_FDD_Specific_InfoItem_Response = SEQ(name=u'HSSCCH-FDD-Specific-InfoItem-Response', mode=MODE_TYPE)
    _HSSCCH_FDD_Specific_InfoItem_Response_code_Number = INT(name=u'code-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HSSCCH_FDD_Specific_InfoItem_Response_code_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab = ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab = ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id),
        (u'criticality', ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item_._ext = None
    _HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions._cont = __HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item_
    _HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_FDD_Specific_InfoItem_Response._cont = ASN1Dict([
        (u'code-Number', _HSSCCH_FDD_Specific_InfoItem_Response_code_Number),
        (u'iE-Extensions', _HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions),
        ])
    HSSCCH_FDD_Specific_InfoItem_Response._ext = []
    
    #-----< HSSCCH-FDD-Specific-InfoItem-Response-ExtIEs >-----#
    HSSCCH_FDD_Specific_InfoItem_Response_ExtIEs = CLASS(name=u'HSSCCH-FDD-Specific-InfoItem-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSCCH_FDD_Specific_InfoItem_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-PowerOffset >-----#
    HSSCCH_PowerOffset = INT(name=u'HSSCCH-PowerOffset', mode=MODE_TYPE)
    HSSCCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< HSSCCH-TDD-Specific-InfoList-Response >-----#
    HSSCCH_TDD_Specific_InfoList_Response = SEQ_OF(name=u'HSSCCH-TDD-Specific-InfoList-Response', mode=MODE_TYPE)
    _HSSCCH_TDD_Specific_InfoList_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoItem-Response')))
    HSSCCH_TDD_Specific_InfoList_Response._cont = _HSSCCH_TDD_Specific_InfoList_Response__item_
    HSSCCH_TDD_Specific_InfoList_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-TDD-Specific-InfoItem-Response >-----#
    HSSCCH_TDD_Specific_InfoItem_Response = SEQ(name=u'HSSCCH-TDD-Specific-InfoItem-Response', mode=MODE_TYPE)
    _HSSCCH_TDD_Specific_InfoItem_Response_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSSCCH_TDD_Specific_InfoItem_Response_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _HSSCCH_TDD_Specific_InfoItem_Response_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _HSSCCH_TDD_Specific_InfoItem_Response_hSSICH_Info = SEQ(name=u'hSSICH-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSICH-Info')))
    _HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id),
        (u'criticality', ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_._ext = None
    _HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions._cont = __HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_
    _HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_TDD_Specific_InfoItem_Response._cont = ASN1Dict([
        (u'timeslot', _HSSCCH_TDD_Specific_InfoItem_Response_timeslot),
        (u'midambleShiftAndBurstType', _HSSCCH_TDD_Specific_InfoItem_Response_midambleShiftAndBurstType),
        (u'tDD-ChannelisationCode', _HSSCCH_TDD_Specific_InfoItem_Response_tDD_ChannelisationCode),
        (u'hSSICH-Info', _HSSCCH_TDD_Specific_InfoItem_Response_hSSICH_Info),
        (u'iE-Extensions', _HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions),
        ])
    HSSCCH_TDD_Specific_InfoItem_Response._ext = []
    
    #-----< HSSCCH-TDD-Specific-InfoItem-Response-ExtIEs >-----#
    HSSCCH_TDD_Specific_InfoItem_Response_ExtIEs = CLASS(name=u'HSSCCH-TDD-Specific-InfoItem-Response-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSCCH_TDD_Specific_InfoItem_Response_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-TDD-Specific-InfoList-Response-LCR >-----#
    HSSCCH_TDD_Specific_InfoList_Response_LCR = SEQ_OF(name=u'HSSCCH-TDD-Specific-InfoList-Response-LCR', mode=MODE_TYPE)
    _HSSCCH_TDD_Specific_InfoList_Response_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoItem-Response-LCR')))
    HSSCCH_TDD_Specific_InfoList_Response_LCR._cont = _HSSCCH_TDD_Specific_InfoList_Response_LCR__item_
    HSSCCH_TDD_Specific_InfoList_Response_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-TDD-Specific-InfoItem-Response-LCR >-----#
    HSSCCH_TDD_Specific_InfoItem_Response_LCR = SEQ(name=u'HSSCCH-TDD-Specific-InfoItem-Response-LCR', mode=MODE_TYPE)
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_timeslotLCR = INT(name=u'timeslotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_first_TDD_ChannelisationCode = ENUM(name=u'first-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_second_TDD_ChannelisationCode = ENUM(name=u'second-TDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_hSSICH_InfoLCR = SEQ(name=u'hSSICH-InfoLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSICH-InfoLCR')))
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id),
        (u'criticality', ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_._ext = None
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions._cont = __HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_
    _HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_TDD_Specific_InfoItem_Response_LCR._cont = ASN1Dict([
        (u'timeslotLCR', _HSSCCH_TDD_Specific_InfoItem_Response_LCR_timeslotLCR),
        (u'midambleShiftLCR', _HSSCCH_TDD_Specific_InfoItem_Response_LCR_midambleShiftLCR),
        (u'first-TDD-ChannelisationCode', _HSSCCH_TDD_Specific_InfoItem_Response_LCR_first_TDD_ChannelisationCode),
        (u'second-TDD-ChannelisationCode', _HSSCCH_TDD_Specific_InfoItem_Response_LCR_second_TDD_ChannelisationCode),
        (u'hSSICH-InfoLCR', _HSSCCH_TDD_Specific_InfoItem_Response_LCR_hSSICH_InfoLCR),
        (u'iE-Extensions', _HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions),
        ])
    HSSCCH_TDD_Specific_InfoItem_Response_LCR._ext = []
    
    #-----< HSSCCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs >-----#
    HSSCCH_TDD_Specific_InfoItem_Response_LCR_ExtIEs = CLASS(name=u'HSSCCH-TDD-Specific-InfoItem-Response-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSCCH_TDD_Specific_InfoItem_Response_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSCCH-TDD-Specific-InfoList-Response768 >-----#
    HSSCCH_TDD_Specific_InfoList_Response768 = SEQ_OF(name=u'HSSCCH-TDD-Specific-InfoList-Response768', mode=MODE_TYPE)
    _HSSCCH_TDD_Specific_InfoList_Response768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoItem-Response768')))
    HSSCCH_TDD_Specific_InfoList_Response768._cont = _HSSCCH_TDD_Specific_InfoList_Response768__item_
    HSSCCH_TDD_Specific_InfoList_Response768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< HSSCCH-TDD-Specific-InfoItem-Response768 >-----#
    HSSCCH_TDD_Specific_InfoItem_Response768 = SEQ(name=u'HSSCCH-TDD-Specific-InfoItem-Response768', mode=MODE_TYPE)
    _HSSCCH_TDD_Specific_InfoItem_Response768_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSSCCH_TDD_Specific_InfoItem_Response768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _HSSCCH_TDD_Specific_InfoItem_Response768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _HSSCCH_TDD_Specific_InfoItem_Response768_hSSICH_Info768 = SEQ(name=u'hSSICH-Info768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSICH-Info768')))
    _HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id._const_tab_at = None
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue._const_tab = ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id),
        (u'criticality', ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue),
        ])
    __HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_._ext = None
    _HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions._cont = __HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_
    _HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSCCH_TDD_Specific_InfoItem_Response768._cont = ASN1Dict([
        (u'timeslot', _HSSCCH_TDD_Specific_InfoItem_Response768_timeslot),
        (u'midambleShiftAndBurstType768', _HSSCCH_TDD_Specific_InfoItem_Response768_midambleShiftAndBurstType768),
        (u'tDD-ChannelisationCode768', _HSSCCH_TDD_Specific_InfoItem_Response768_tDD_ChannelisationCode768),
        (u'hSSICH-Info768', _HSSCCH_TDD_Specific_InfoItem_Response768_hSSICH_Info768),
        (u'iE-Extensions', _HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions),
        ])
    HSSCCH_TDD_Specific_InfoItem_Response768._ext = []
    
    #-----< HSSCCH-TDD-Specific-InfoItem-Response768-ExtIEs >-----#
    HSSCCH_TDD_Specific_InfoItem_Response768_ExtIEs = CLASS(name=u'HSSCCH-TDD-Specific-InfoItem-Response768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSCCH_TDD_Specific_InfoItem_Response768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSICH-Info >-----#
    HSSICH_Info = SEQ(name=u'HSSICH-Info', mode=MODE_TYPE)
    _HSSICH_Info_hsSICH_ID = INT(name=u'hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _HSSICH_Info_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSSICH_Info_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _HSSICH_Info_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _HSSICH_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSICH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info_iE_Extensions__item__id._const_tab = ____HSSICH_Info_iE_Extensions__item__id_tab
    ___HSSICH_Info_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSICH_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSICH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info_iE_Extensions__item__criticality._const_tab = ____HSSICH_Info_iE_Extensions__item__criticality_tab
    ___HSSICH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSICH_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSICH_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSICH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_Info_iE_Extensions__item__extensionValue_tab
    ___HSSICH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSICH_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSICH_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSICH_Info_iE_Extensions__item__id),
        (u'criticality', ___HSSICH_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSICH_Info_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_Info_iE_Extensions__item_._ext = None
    _HSSICH_Info_iE_Extensions._cont = __HSSICH_Info_iE_Extensions__item_
    _HSSICH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_Info._cont = ASN1Dict([
        (u'hsSICH-ID', _HSSICH_Info_hsSICH_ID),
        (u'timeslot', _HSSICH_Info_timeslot),
        (u'midambleShiftAndBurstType', _HSSICH_Info_midambleShiftAndBurstType),
        (u'tDD-ChannelisationCode', _HSSICH_Info_tDD_ChannelisationCode),
        (u'iE-Extensions', _HSSICH_Info_iE_Extensions),
        ])
    HSSICH_Info._ext = []
    
    #-----< HSSICH-Info-ExtIEs >-----#
    HSSICH_Info_ExtIEs = CLASS(name=u'HSSICH-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSICH_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSSICH-InfoLCR >-----#
    HSSICH_InfoLCR = SEQ(name=u'HSSICH-InfoLCR', mode=MODE_TYPE)
    _HSSICH_InfoLCR_hsSICH_ID = INT(name=u'hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _HSSICH_InfoLCR_timeslotLCR = INT(name=u'timeslotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _HSSICH_InfoLCR_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _HSSICH_InfoLCR_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _HSSICH_InfoLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_InfoLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_InfoLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSICH_InfoLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSSICH_InfoLCR_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    ____HSSICH_InfoLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _____HSSICH_InfoLCR_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSSICH_InfoLCR_iE_Extensions__item__id._const_tab = ____HSSICH_InfoLCR_iE_Extensions__item__id_tab
    ___HSSICH_InfoLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_InfoLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality._const_tab = ____HSSICH_InfoLCR_iE_Extensions__item__id_tab
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSICH_InfoLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_InfoLCR_iE_Extensions__item__id_tab
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSICH_InfoLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSICH_InfoLCR_iE_Extensions__item__id),
        (u'criticality', ___HSSICH_InfoLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_InfoLCR_iE_Extensions__item_._ext = None
    _HSSICH_InfoLCR_iE_Extensions._cont = __HSSICH_InfoLCR_iE_Extensions__item_
    _HSSICH_InfoLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_InfoLCR._cont = ASN1Dict([
        (u'hsSICH-ID', _HSSICH_InfoLCR_hsSICH_ID),
        (u'timeslotLCR', _HSSICH_InfoLCR_timeslotLCR),
        (u'midambleShiftLCR', _HSSICH_InfoLCR_midambleShiftLCR),
        (u'tDD-ChannelisationCode', _HSSICH_InfoLCR_tDD_ChannelisationCode),
        (u'iE-Extensions', _HSSICH_InfoLCR_iE_Extensions),
        ])
    HSSICH_InfoLCR._ext = []
    
    #-----< HSSICH-Info-LCR-ExtIEs >-----#
    HSSICH_Info_LCR_ExtIEs = CLASS(name=u'HSSICH-Info-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSSICH_Info_LCR_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    HSSICH_Info_LCR_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _HSSICH_Info_LCR_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSSICH-Info768 >-----#
    HSSICH_Info768 = SEQ(name=u'HSSICH-Info768', mode=MODE_TYPE)
    _HSSICH_Info768_hsSICH_ID = INT(name=u'hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _HSSICH_Info768_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSSICH_Info768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _HSSICH_Info768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _HSSICH_Info768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_Info768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_Info768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSICH_Info768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info768_iE_Extensions__item__id._const_tab = ____HSSICH_Info768_iE_Extensions__item__id_tab
    ___HSSICH_Info768_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_Info768_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSICH_Info768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSICH_Info768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info768_iE_Extensions__item__criticality._const_tab = ____HSSICH_Info768_iE_Extensions__item__criticality_tab
    ___HSSICH_Info768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSICH_Info768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSICH_Info768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_Info768_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab
    ___HSSICH_Info768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSICH_Info768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSICH_Info768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSICH_Info768_iE_Extensions__item__id),
        (u'criticality', ___HSSICH_Info768_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSICH_Info768_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_Info768_iE_Extensions__item_._ext = None
    _HSSICH_Info768_iE_Extensions._cont = __HSSICH_Info768_iE_Extensions__item_
    _HSSICH_Info768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_Info768._cont = ASN1Dict([
        (u'hsSICH-ID', _HSSICH_Info768_hsSICH_ID),
        (u'timeslot', _HSSICH_Info768_timeslot),
        (u'midambleShiftAndBurstType768', _HSSICH_Info768_midambleShiftAndBurstType768),
        (u'tDD-ChannelisationCode768', _HSSICH_Info768_tDD_ChannelisationCode768),
        (u'iE-Extensions', _HSSICH_Info768_iE_Extensions),
        ])
    HSSICH_Info768._ext = []
    
    #-----< HSSICH-Info-768-ExtIEs >-----#
    HSSICH_Info_768_ExtIEs = CLASS(name=u'HSSICH-Info-768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSICH_Info_768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Reception-Quality-Value >-----#
    HS_SICH_Reception_Quality_Value = SEQ(name=u'HS-SICH-Reception-Quality-Value', mode=MODE_TYPE)
    _HS_SICH_Reception_Quality_Value_failed_HS_SICH = INT(name=u'failed-HS-SICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-failed')))
    _HS_SICH_Reception_Quality_Value_missed_HS_SICH = INT(name=u'missed-HS-SICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-missed')))
    _HS_SICH_Reception_Quality_Value_total_HS_SICH = INT(name=u'total-HS-SICH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-total')))
    _HS_SICH_Reception_Quality_Value_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_Reception_Quality_Value_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id._const_tab = ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality._const_tab = ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality_tab
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_SICH_Reception_Quality_Value_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id),
        (u'criticality', ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_Reception_Quality_Value_iE_Extensions__item_._ext = None
    _HS_SICH_Reception_Quality_Value_iE_Extensions._cont = __HS_SICH_Reception_Quality_Value_iE_Extensions__item_
    _HS_SICH_Reception_Quality_Value_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_Reception_Quality_Value._cont = ASN1Dict([
        (u'failed-HS-SICH', _HS_SICH_Reception_Quality_Value_failed_HS_SICH),
        (u'missed-HS-SICH', _HS_SICH_Reception_Quality_Value_missed_HS_SICH),
        (u'total-HS-SICH', _HS_SICH_Reception_Quality_Value_total_HS_SICH),
        (u'iE-Extensions', _HS_SICH_Reception_Quality_Value_iE_Extensions),
        ])
    HS_SICH_Reception_Quality_Value._ext = []
    
    #-----< HS-SICH-Reception-Quality-Value-ExtIEs >-----#
    HS_SICH_Reception_Quality_Value_ExtIEs = CLASS(name=u'HS-SICH-Reception-Quality-Value-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_SICH_Reception_Quality_Value_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-failed >-----#
    HS_SICH_failed = INT(name=u'HS-SICH-failed', mode=MODE_TYPE)
    HS_SICH_failed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-missed >-----#
    HS_SICH_missed = INT(name=u'HS-SICH-missed', mode=MODE_TYPE)
    HS_SICH_missed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-total >-----#
    HS_SICH_total = INT(name=u'HS-SICH-total', mode=MODE_TYPE)
    HS_SICH_total._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-Reception-Quality-Measurement-Value >-----#
    HS_SICH_Reception_Quality_Measurement_Value = INT(name=u'HS-SICH-Reception-Quality-Measurement-Value', mode=MODE_TYPE)
    HS_SICH_Reception_Quality_Measurement_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=20)], ev=None, er=[])
    
    #-----< HS-SICH-ID >-----#
    HS_SICH_ID = INT(name=u'HS-SICH-ID', mode=MODE_TYPE)
    HS_SICH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< HS-SICH-ID-Extension >-----#
    HS_SICH_ID_Extension = INT(name=u'HS-SICH-ID-Extension', mode=MODE_TYPE)
    HS_SICH_ID_Extension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=255)], ev=[], er=[])
    
    #-----< HSSCCH-CodeChangeIndicator >-----#
    HSSCCH_CodeChangeIndicator = ENUM(name=u'HSSCCH-CodeChangeIndicator', mode=MODE_TYPE)
    HSSCCH_CodeChangeIndicator._cont = ASN1Dict([(u'hsSCCHCodeChangeNeeded', 0)])
    HSSCCH_CodeChangeIndicator._ext = None
    
    #-----< HSSCCH-Code-Change-Grant >-----#
    HSSCCH_Code_Change_Grant = ENUM(name=u'HSSCCH-Code-Change-Grant', mode=MODE_TYPE)
    HSSCCH_Code_Change_Grant._cont = ASN1Dict([(u'changeGranted', 0)])
    HSSCCH_Code_Change_Grant._ext = None
    
    #-----< HS-PDSCH-Code-Change-Indicator >-----#
    HS_PDSCH_Code_Change_Indicator = ENUM(name=u'HS-PDSCH-Code-Change-Indicator', mode=MODE_TYPE)
    HS_PDSCH_Code_Change_Indicator._cont = ASN1Dict([(u'hsPDSCHCodeChangeNeeded', 0)])
    HS_PDSCH_Code_Change_Indicator._ext = None
    
    #-----< HS-PDSCH-Code-Change-Grant >-----#
    HS_PDSCH_Code_Change_Grant = ENUM(name=u'HS-PDSCH-Code-Change-Grant', mode=MODE_TYPE)
    HS_PDSCH_Code_Change_Grant._cont = ASN1Dict([(u'changeGranted', 0)])
    HS_PDSCH_Code_Change_Grant._ext = None
    
    #-----< HSDSCH-FDD-Update-Information >-----#
    HSDSCH_FDD_Update_Information = SEQ(name=u'HSDSCH-FDD-Update-Information', mode=MODE_TYPE)
    _HSDSCH_FDD_Update_Information_hsSCCHCodeChangeIndicator = ENUM(name=u'hsSCCHCodeChangeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-CodeChangeIndicator')), opt=True)
    _HSDSCH_FDD_Update_Information_cqiFeedback_CycleK = ENUM(name=u'cqiFeedback-CycleK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle')), opt=True)
    _HSDSCH_FDD_Update_Information_cqiRepetitionFactor = INT(name=u'cqiRepetitionFactor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _HSDSCH_FDD_Update_Information_ackNackRepetitionFactor = INT(name=u'ackNackRepetitionFactor', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AckNack-RepetitionFactor')), opt=True)
    _HSDSCH_FDD_Update_Information_cqiPowerOffset = INT(name=u'cqiPowerOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Power-Offset')), opt=True)
    _HSDSCH_FDD_Update_Information_ackPowerOffset = INT(name=u'ackPowerOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Ack-Power-Offset')), opt=True)
    _HSDSCH_FDD_Update_Information_nackPowerOffset = INT(name=u'nackPowerOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Nack-Power-Offset')), opt=True)
    _HSDSCH_FDD_Update_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_FDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-PDSCH-Code-Change-Indicator')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle2')))
    _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Cycle-Switch-Timer')))
    ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 681), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 958), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 959), (u'criticality', u'ignore'), (u'Extension', _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_FDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_FDD_Update_Information_iE_Extensions__item_._ext = None
    _HSDSCH_FDD_Update_Information_iE_Extensions._cont = __HSDSCH_FDD_Update_Information_iE_Extensions__item_
    _HSDSCH_FDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_FDD_Update_Information._cont = ASN1Dict([
        (u'hsSCCHCodeChangeIndicator', _HSDSCH_FDD_Update_Information_hsSCCHCodeChangeIndicator),
        (u'cqiFeedback-CycleK', _HSDSCH_FDD_Update_Information_cqiFeedback_CycleK),
        (u'cqiRepetitionFactor', _HSDSCH_FDD_Update_Information_cqiRepetitionFactor),
        (u'ackNackRepetitionFactor', _HSDSCH_FDD_Update_Information_ackNackRepetitionFactor),
        (u'cqiPowerOffset', _HSDSCH_FDD_Update_Information_cqiPowerOffset),
        (u'ackPowerOffset', _HSDSCH_FDD_Update_Information_ackPowerOffset),
        (u'nackPowerOffset', _HSDSCH_FDD_Update_Information_nackPowerOffset),
        (u'iE-Extensions', _HSDSCH_FDD_Update_Information_iE_Extensions),
        ])
    HSDSCH_FDD_Update_Information._ext = []
    
    #-----< HSDSCH-FDD-Update-Information-ExtIEs >-----#
    HSDSCH_FDD_Update_Information_ExtIEs = CLASS(name=u'HSDSCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-PDSCH-Code-Change-Indicator')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Precoder-Weight-Set-Restriction')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Feedback-Cycle2')))
    _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CQI-Cycle-Switch-Timer')))
    HSDSCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 681), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 942), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 958), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 959), (u'criticality', u'ignore'), (u'Extension', _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-TDD-Update-Information >-----#
    HSDSCH_TDD_Update_Information = SEQ(name=u'HSDSCH-TDD-Update-Information', mode=MODE_TYPE)
    _HSDSCH_TDD_Update_Information_hsSCCHCodeChangeIndicator = ENUM(name=u'hsSCCHCodeChangeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-CodeChangeIndicator')), opt=True)
    _HSDSCH_TDD_Update_Information_tDDAckNackPowerOffset = INT(name=u'tDDAckNackPowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-AckNack-Power-Offset')), opt=True)
    _HSDSCH_TDD_Update_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCH_TDD_Update_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id._const_tab = ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality._const_tab = ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue._const_tab = ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCH_TDD_Update_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id),
        (u'criticality', ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue),
        ])
    __HSDSCH_TDD_Update_Information_iE_Extensions__item_._ext = None
    _HSDSCH_TDD_Update_Information_iE_Extensions._cont = __HSDSCH_TDD_Update_Information_iE_Extensions__item_
    _HSDSCH_TDD_Update_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCH_TDD_Update_Information._cont = ASN1Dict([
        (u'hsSCCHCodeChangeIndicator', _HSDSCH_TDD_Update_Information_hsSCCHCodeChangeIndicator),
        (u'tDDAckNackPowerOffset', _HSDSCH_TDD_Update_Information_tDDAckNackPowerOffset),
        (u'iE-Extensions', _HSDSCH_TDD_Update_Information_iE_Extensions),
        ])
    HSDSCH_TDD_Update_Information._ext = []
    
    #-----< HSDSCH-TDD-Update-Information-ExtIEs >-----#
    HSDSCH_TDD_Update_Information_ExtIEs = CLASS(name=u'HSDSCH-TDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSDSCH_TDD_Update_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MIMO-ReferenceSignal-InformationListLCR >-----#
    MIMO_ReferenceSignal_InformationListLCR = SEQ_OF(name=u'MIMO-ReferenceSignal-InformationListLCR', mode=MODE_TYPE)
    _MIMO_ReferenceSignal_InformationListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSSICH-ReferenceSignal-InformationLCR')))
    MIMO_ReferenceSignal_InformationListLCR._cont = _MIMO_ReferenceSignal_InformationListLCR__item_
    MIMO_ReferenceSignal_InformationListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSICH-ReferenceSignal-InformationLCR >-----#
    HSSICH_ReferenceSignal_InformationLCR = SEQ(name=u'HSSICH-ReferenceSignal-InformationLCR', mode=MODE_TYPE)
    _HSSICH_ReferenceSignal_InformationLCR_midambleConfigurationLCR = ENUM(name=u'midambleConfigurationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationLCR')))
    _HSSICH_ReferenceSignal_InformationLCR_midambleShift = INT(name=u'midambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HSSICH_ReferenceSignal_InformationLCR_midambleShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _HSSICH_ReferenceSignal_InformationLCR_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id._const_tab = ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality._const_tab = ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id),
        (u'criticality', ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_._ext = None
    _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions._cont = __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_
    _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSSICH_ReferenceSignal_InformationLCR._cont = ASN1Dict([
        (u'midambleConfigurationLCR', _HSSICH_ReferenceSignal_InformationLCR_midambleConfigurationLCR),
        (u'midambleShift', _HSSICH_ReferenceSignal_InformationLCR_midambleShift),
        (u'timeSlotLCR', _HSSICH_ReferenceSignal_InformationLCR_timeSlotLCR),
        (u'iE-Extensions', _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions),
        ])
    HSSICH_ReferenceSignal_InformationLCR._ext = []
    
    #-----< HSSICH-ReferenceSignal-InformationLCR-ExtIEs >-----#
    HSSICH_ReferenceSignal_InformationLCR_ExtIEs = CLASS(name=u'HSSICH-ReferenceSignal-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSSICH_ReferenceSignal_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-LCR >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_LCR = SEQ(name=u'HS-DSCH-Semi-PersistentScheduling-Information-LCR', mode=MODE_TYPE)
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_transport_Block_Size_List = SEQ_OF(name=u'transport-Block-Size-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-List-LCR')))
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR = SEQ_OF(name=u'repetition-Period-List-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Repetition-Period-List-LCR')))
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Reservation_Indicator = ENUM(name=u'hS-DSCH-SPS-Reservation-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SPS-Reservation-Indicator')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Operation_Indicator = CHOICE(name=u'hS-DSCH-SPS-Operation-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-SPS-Operation-Indicator')))
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_._ext = None
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._cont = __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_
    _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Semi_PersistentScheduling_Information_LCR._cont = ASN1Dict([
        (u'transport-Block-Size-List', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_transport_Block_Size_List),
        (u'repetition-Period-List-LCR', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR),
        (u'hS-DSCH-SPS-Reservation-Indicator', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Reservation_Indicator),
        (u'hS-DSCH-SPS-Operation-Indicator', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Operation_Indicator),
        (u'iE-Extensions', _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions),
        ])
    HS_DSCH_Semi_PersistentScheduling_Information_LCR._ext = []
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_LCR_ExtIEs = CLASS(name=u'HS-DSCH-Semi-PersistentScheduling-Information-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Semi_PersistentScheduling_Information_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSDSCH-Physical-Layer-Category >-----#
    HSDSCH_Physical_Layer_Category = INT(name=u'HSDSCH-Physical-Layer-Category', mode=MODE_TYPE)
    HSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Transport-Block-Size-List-LCR >-----#
    Transport_Block_Size_List_LCR = SEQ_OF(name=u'Transport-Block-Size-List-LCR', mode=MODE_TYPE)
    _Transport_Block_Size_List_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-Item-LCR')))
    Transport_Block_Size_List_LCR._cont = _Transport_Block_Size_List_LCR__item_
    Transport_Block_Size_List_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Transport-Block-Size-Item-LCR >-----#
    Transport_Block_Size_Item_LCR = SEQ(name=u'Transport-Block-Size-Item-LCR', mode=MODE_TYPE)
    _Transport_Block_Size_Item_LCR_transport_Block_Size_maping_Index_LCR = INT(name=u'transport-Block-Size-maping-Index-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-maping-Index-LCR')))
    _Transport_Block_Size_Item_LCR_transport_Block_Size_Index_LCR = INT(name=u'transport-Block-Size-Index-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-Index-LCR')))
    _Transport_Block_Size_Item_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transport_Block_Size_Item_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id._const_tab = ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id._const_tab_at = None
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality._const_tab = ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue._const_tab = ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Transport_Block_Size_Item_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id),
        (u'criticality', ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue),
        ])
    __Transport_Block_Size_Item_LCR_iE_Extensions__item_._ext = None
    _Transport_Block_Size_Item_LCR_iE_Extensions._cont = __Transport_Block_Size_Item_LCR_iE_Extensions__item_
    _Transport_Block_Size_Item_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transport_Block_Size_Item_LCR._cont = ASN1Dict([
        (u'transport-Block-Size-maping-Index-LCR', _Transport_Block_Size_Item_LCR_transport_Block_Size_maping_Index_LCR),
        (u'transport-Block-Size-Index-LCR', _Transport_Block_Size_Item_LCR_transport_Block_Size_Index_LCR),
        (u'iE-Extensions', _Transport_Block_Size_Item_LCR_iE_Extensions),
        ])
    Transport_Block_Size_Item_LCR._ext = []
    
    #-----< Transport-Block-Size-Item-LCR-ExtIEs >-----#
    Transport_Block_Size_Item_LCR_ExtIEs = CLASS(name=u'Transport-Block-Size-Item-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Transport_Block_Size_Item_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transport-Block-Size-maping-Index-LCR >-----#
    Transport_Block_Size_maping_Index_LCR = INT(name=u'Transport-Block-Size-maping-Index-LCR', mode=MODE_TYPE)
    Transport_Block_Size_maping_Index_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< Transport-Block-Size-Index-LCR >-----#
    Transport_Block_Size_Index_LCR = INT(name=u'Transport-Block-Size-Index-LCR', mode=MODE_TYPE)
    Transport_Block_Size_Index_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< TS0-HS-PDSCH-Indication-LCR >-----#
    TS0_HS_PDSCH_Indication_LCR = NULL(name=u'TS0-HS-PDSCH-Indication-LCR', mode=MODE_TYPE)
    
    #-----< Repetition-Period-List-LCR >-----#
    Repetition_Period_List_LCR = SEQ_OF(name=u'Repetition-Period-List-LCR', mode=MODE_TYPE)
    _Repetition_Period_List_LCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Repetition-Period-Item-LCR')))
    Repetition_Period_List_LCR._cont = _Repetition_Period_List_LCR__item_
    Repetition_Period_List_LCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< Repetition-Period-Item-LCR >-----#
    Repetition_Period_Item_LCR = SEQ(name=u'Repetition-Period-Item-LCR', mode=MODE_TYPE)
    _Repetition_Period_Item_LCR_repetitionPeriodIndex = INT(name=u'repetitionPeriodIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriodIndex')))
    _Repetition_Period_Item_LCR_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _Repetition_Period_Item_LCR_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')), opt=True)
    _Repetition_Period_Item_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Repetition_Period_Item_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id._const_tab = ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id._const_tab_at = None
    ___Repetition_Period_Item_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality._const_tab = ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue._const_tab = ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Repetition_Period_Item_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Repetition_Period_Item_LCR_iE_Extensions__item__id),
        (u'criticality', ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue),
        ])
    __Repetition_Period_Item_LCR_iE_Extensions__item_._ext = None
    _Repetition_Period_Item_LCR_iE_Extensions._cont = __Repetition_Period_Item_LCR_iE_Extensions__item_
    _Repetition_Period_Item_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Repetition_Period_Item_LCR._cont = ASN1Dict([
        (u'repetitionPeriodIndex', _Repetition_Period_Item_LCR_repetitionPeriodIndex),
        (u'repetitionPeriod', _Repetition_Period_Item_LCR_repetitionPeriod),
        (u'repetitionLength', _Repetition_Period_Item_LCR_repetitionLength),
        (u'iE-Extensions', _Repetition_Period_Item_LCR_iE_Extensions),
        ])
    Repetition_Period_Item_LCR._ext = []
    
    #-----< Repetition-Period-Item-LCR-ExtIEs >-----#
    Repetition_Period_Item_LCR_ExtIEs = CLASS(name=u'Repetition-Period-Item-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Repetition_Period_Item_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RepetitionPeriodIndex >-----#
    RepetitionPeriodIndex = INT(name=u'RepetitionPeriodIndex', mode=MODE_TYPE)
    RepetitionPeriodIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< SPS-Reservation-Indicator >-----#
    SPS_Reservation_Indicator = ENUM(name=u'SPS-Reservation-Indicator', mode=MODE_TYPE)
    SPS_Reservation_Indicator._cont = ASN1Dict([(u'reserve', 0)])
    SPS_Reservation_Indicator._ext = None
    
    #-----< HS-DSCH-SPS-Operation-Indicator >-----#
    HS_DSCH_SPS_Operation_Indicator = CHOICE(name=u'HS-DSCH-SPS-Operation-Indicator', mode=MODE_TYPE)
    _HS_DSCH_SPS_Operation_Indicator_logicalChannellevel = BIT_STR(name=u'logicalChannellevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LogicalChannellevel')))
    _HS_DSCH_SPS_Operation_Indicator_priorityQueuelevel = BIT_STR(name=u'priorityQueuelevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueuelevel')))
    HS_DSCH_SPS_Operation_Indicator._cont = ASN1Dict([
        (u'logicalChannellevel', _HS_DSCH_SPS_Operation_Indicator_logicalChannellevel),
        (u'priorityQueuelevel', _HS_DSCH_SPS_Operation_Indicator_priorityQueuelevel),
        ])
    HS_DSCH_SPS_Operation_Indicator._ext = []
    
    #-----< LogicalChannellevel >-----#
    LogicalChannellevel = BIT_STR(name=u'LogicalChannellevel', mode=MODE_TYPE)
    LogicalChannellevel._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PriorityQueuelevel >-----#
    PriorityQueuelevel = BIT_STR(name=u'PriorityQueuelevel', mode=MODE_TYPE)
    PriorityQueuelevel._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR = SEQ(name=u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR', mode=MODE_TYPE)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_transport_Block_Size_List = SEQ_OF(name=u'transport-Block-Size-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-List-LCR')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR = SEQ_OF(name=u'repetition-Period-List-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Repetition-Period-List-LCR')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_hS_DSCH_SPS_Reservation_Indicator = ENUM(name=u'hS-DSCH-SPS-Reservation-Indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SPS-Reservation-Indicator')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_hS_DSCH_SPS_Operation_Indicator = CHOICE(name=u'hS-DSCH-SPS-Operation-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-SPS-Operation-Indicator')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_._ext = None
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._cont = __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_
    _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR._cont = ASN1Dict([
        (u'transport-Block-Size-List', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_transport_Block_Size_List),
        (u'repetition-Period-List-LCR', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR),
        (u'hS-DSCH-SPS-Reservation-Indicator', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_hS_DSCH_SPS_Reservation_Indicator),
        (u'hS-DSCH-SPS-Operation-Indicator', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_hS_DSCH_SPS_Operation_Indicator),
        (u'iE-Extensions', _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions),
        ])
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR._ext = []
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs = CLASS(name=u'HS-DSCH-Semi-PersistentScheduling-Information-to-Modify-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR = SEQ(name=u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR', mode=MODE_TYPE)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_hS_SICH_InformationList_for_HS_DSCH_SPS = SEQ_OF(name=u'hS-SICH-InformationList-for-HS-DSCH-SPS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-InformationList-for-HS-DSCH-SPS')))
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_HS_PDSCH_SPS_Resource = SEQ(name=u'initial-HS-PDSCH-SPS-Resource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Initial-HS-PDSCH-SPS-Resource')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_buffer_Size_for_HS_DSCH_SPS = ENUM(name=u'buffer-Size-for-HS-DSCH-SPS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Process-Memory-Size')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_number_of_Processes_for_HS_DSCH_SPS = INT(name=u'number-of-Processes-for-HS-DSCH-SPS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Number-of-Processes-for-HS-DSCH-SPS')), opt=True)
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_at = None
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab = ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id),
        (u'criticality', ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue),
        ])
    __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_._ext = None
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._cont = __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_
    _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR._cont = ASN1Dict([
        (u'hS-SICH-InformationList-for-HS-DSCH-SPS', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_hS_SICH_InformationList_for_HS_DSCH_SPS),
        (u'initial-HS-PDSCH-SPS-Resource', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_HS_PDSCH_SPS_Resource),
        (u'buffer-Size-for-HS-DSCH-SPS', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_buffer_Size_for_HS_DSCH_SPS),
        (u'number-of-Processes-for-HS-DSCH-SPS', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_number_of_Processes_for_HS_DSCH_SPS),
        (u'iE-Extensions', _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions),
        ])
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR._ext = []
    
    #-----< HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs >-----#
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs = CLASS(name=u'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-InformationList-for-HS-DSCH-SPS >-----#
    HS_SICH_InformationList_for_HS_DSCH_SPS = SEQ_OF(name=u'HS-SICH-InformationList-for-HS-DSCH-SPS', mode=MODE_TYPE)
    _HS_SICH_InformationList_for_HS_DSCH_SPS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-InformationItem-for-HS-DSCH-SPS')))
    HS_SICH_InformationList_for_HS_DSCH_SPS._cont = _HS_SICH_InformationList_for_HS_DSCH_SPS__item_
    HS_SICH_InformationList_for_HS_DSCH_SPS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HS-SICH-InformationItem-for-HS-DSCH-SPS >-----#
    HS_SICH_InformationItem_for_HS_DSCH_SPS = SEQ(name=u'HS-SICH-InformationItem-for-HS-DSCH-SPS', mode=MODE_TYPE)
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Mapping_Index = INT(name=u'hS-SICH-Mapping-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Mapping-Index')), opt=True)
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Type = CHOICE(name=u'hS-SICH-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Type')))
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id._const_tab = ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id._const_tab_at = None
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id._const_tab_id = u'id'
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality._const_tab = ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue._const_tab = ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id),
        (u'criticality', ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality),
        (u'extensionValue', ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue),
        ])
    __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_._ext = None
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions._cont = __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_
    _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HS_SICH_InformationItem_for_HS_DSCH_SPS._cont = ASN1Dict([
        (u'hS-SICH-Mapping-Index', _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Mapping_Index),
        (u'hS-SICH-Type', _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Type),
        (u'iE-Extensions', _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions),
        ])
    HS_SICH_InformationItem_for_HS_DSCH_SPS._ext = []
    
    #-----< HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs >-----#
    HS_SICH_InformationItem_for_HS_DSCH_SPS_ExtIEs = CLASS(name=u'HS-SICH-InformationItem-for-HS-DSCH-SPS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HS_SICH_InformationItem_for_HS_DSCH_SPS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-SICH-Mapping-Index >-----#
    HS_SICH_Mapping_Index = INT(name=u'HS-SICH-Mapping-Index', mode=MODE_TYPE)
    HS_SICH_Mapping_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< HS-SICH-Type >-----#
    HS_SICH_Type = CHOICE(name=u'HS-SICH-Type', mode=MODE_TYPE)
    _HS_SICH_Type_hS_SCCH_Associated_HS_SICH = SEQ(name=u'hS-SCCH-Associated-HS-SICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-Associated-HS-SICH')))
    _HS_SICH_Type_non_HS_SCCH_Associated_HS_SICH = SEQ(name=u'non-HS-SCCH-Associated-HS-SICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Non-HS-SCCH-Associated-HS-SICH')))
    HS_SICH_Type._cont = ASN1Dict([
        (u'hS-SCCH-Associated-HS-SICH', _HS_SICH_Type_hS_SCCH_Associated_HS_SICH),
        (u'non-HS-SCCH-Associated-HS-SICH', _HS_SICH_Type_non_HS_SCCH_Associated_HS_SICH),
        ])
    HS_SICH_Type._ext = []
    
    #-----< HS-SCCH-Associated-HS-SICH >-----#
    HS_SCCH_Associated_HS_SICH = SEQ(name=u'HS-SCCH-Associated-HS-SICH', mode=MODE_TYPE)
    _HS_SCCH_Associated_HS_SICH_hsSICH_ID = INT(name=u'hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _HS_SCCH_Associated_HS_SICH_extended_HS_SICH_ID = INT(name=u'extended-HS-SICH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')), opt=True)
    HS_SCCH_Associated_HS_SICH._cont = ASN1Dict([
        (u'hsSICH-ID', _HS_SCCH_Associated_HS_SICH_hsSICH_ID),
        (u'extended-HS-SICH-ID', _HS_SCCH_Associated_HS_SICH_extended_HS_SICH_ID),
        ])
    HS_SCCH_Associated_HS_SICH._ext = []
    
    #-----< Non-HS-SCCH-Associated-HS-SICH >-----#
    Non_HS_SCCH_Associated_HS_SICH = SEQ(name=u'Non-HS-SCCH-Associated-HS-SICH', mode=MODE_TYPE)
    _Non_HS_SCCH_Associated_HS_SICH_non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name=u'non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Non-HS-SCCH-Aassociated-HS-SICH-ID')))
    Non_HS_SCCH_Associated_HS_SICH._cont = ASN1Dict([
        (u'non-HS-SCCH-Aassociated-HS-SICH-ID', _Non_HS_SCCH_Associated_HS_SICH_non_HS_SCCH_Aassociated_HS_SICH_ID),
        ])
    Non_HS_SCCH_Associated_HS_SICH._ext = []
    
    #-----< Non-HS-SCCH-Aassociated-HS-SICH-ID >-----#
    Non_HS_SCCH_Aassociated_HS_SICH_ID = INT(name=u'Non-HS-SCCH-Aassociated-HS-SICH-ID', mode=MODE_TYPE)
    Non_HS_SCCH_Aassociated_HS_SICH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Initial-HS-PDSCH-SPS-Resource >-----#
    Initial_HS_PDSCH_SPS_Resource = SEQ(name=u'Initial-HS-PDSCH-SPS-Resource', mode=MODE_TYPE)
    _Initial_HS_PDSCH_SPS_Resource_repetitionPeriodIndex = INT(name=u'repetitionPeriodIndex', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriodIndex')))
    _Initial_HS_PDSCH_SPS_Resource_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')), opt=True)
    _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Offset = INT(name=u'hS-PDSCH-Offset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Midamble_Configuation = SEQ(name=u'hS-PDSCH-Midamble-Configuation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _Initial_HS_PDSCH_SPS_Resource_timeslot_Resource_Related_Information = BIT_STR(name=u'timeslot-Resource-Related-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-TimeslotResourceLCR')))
    _Initial_HS_PDSCH_SPS_Resource_startCode = ENUM(name=u'startCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _Initial_HS_PDSCH_SPS_Resource_endCode = ENUM(name=u'endCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _Initial_HS_PDSCH_SPS_Resource_transport_Block_Size_Index = INT(name=u'transport-Block-Size-Index', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transport-Block-Size-Index-LCR')))
    _Initial_HS_PDSCH_SPS_Resource_modulationType = ENUM(name=u'modulationType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ModulationSPS-LCR')))
    _Initial_HS_PDSCH_SPS_Resource_hS_SICH_Mapping_Index = INT(name=u'hS-SICH-Mapping-Index', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Mapping-Index')))
    _Initial_HS_PDSCH_SPS_Resource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id._const_tab = ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id._const_tab_at = None
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id._const_tab_id = u'id'
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality._const_tab = ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality_tab
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue._const_tab = ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue_tab
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id),
        (u'criticality', ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality),
        (u'extensionValue', ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue),
        ])
    __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_._ext = None
    _Initial_HS_PDSCH_SPS_Resource_iE_Extensions._cont = __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_
    _Initial_HS_PDSCH_SPS_Resource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Initial_HS_PDSCH_SPS_Resource._cont = ASN1Dict([
        (u'repetitionPeriodIndex', _Initial_HS_PDSCH_SPS_Resource_repetitionPeriodIndex),
        (u'repetitionLength', _Initial_HS_PDSCH_SPS_Resource_repetitionLength),
        (u'hS-PDSCH-Offset', _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Offset),
        (u'hS-PDSCH-Midamble-Configuation', _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Midamble_Configuation),
        (u'timeslot-Resource-Related-Information', _Initial_HS_PDSCH_SPS_Resource_timeslot_Resource_Related_Information),
        (u'startCode', _Initial_HS_PDSCH_SPS_Resource_startCode),
        (u'endCode', _Initial_HS_PDSCH_SPS_Resource_endCode),
        (u'transport-Block-Size-Index', _Initial_HS_PDSCH_SPS_Resource_transport_Block_Size_Index),
        (u'modulationType', _Initial_HS_PDSCH_SPS_Resource_modulationType),
        (u'hS-SICH-Mapping-Index', _Initial_HS_PDSCH_SPS_Resource_hS_SICH_Mapping_Index),
        (u'iE-Extensions', _Initial_HS_PDSCH_SPS_Resource_iE_Extensions),
        ])
    Initial_HS_PDSCH_SPS_Resource._ext = []
    
    #-----< Initial-HS-PDSCH-SPS-Resource-ExtIEs >-----#
    Initial_HS_PDSCH_SPS_Resource_ExtIEs = CLASS(name=u'Initial-HS-PDSCH-SPS-Resource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Initial_HS_PDSCH_SPS_Resource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HS-DSCH-TimeslotResourceLCR >-----#
    HS_DSCH_TimeslotResourceLCR = BIT_STR(name=u'HS-DSCH-TimeslotResourceLCR', mode=MODE_TYPE)
    HS_DSCH_TimeslotResourceLCR._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< ModulationSPS-LCR >-----#
    ModulationSPS_LCR = ENUM(name=u'ModulationSPS-LCR', mode=MODE_TYPE)
    ModulationSPS_LCR._cont = ASN1Dict([(u'qPSK', 0), (u'sixteenQAM', 1)])
    ModulationSPS_LCR._ext = []
    
    #-----< Number-of-Processes-for-HS-DSCH-SPS >-----#
    Number_of_Processes_for_HS_DSCH_SPS = INT(name=u'Number-of-Processes-for-HS-DSCH-SPS', mode=MODE_TYPE)
    Number_of_Processes_for_HS_DSCH_SPS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name=u'IMEI', mode=MODE_TYPE)
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMEISV >-----#
    IMEISV = OCT_STR(name=u'IMEISV', mode=MODE_TYPE)
    IMEISV._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name=u'IMSI', mode=MODE_TYPE)
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< Implicit-Grant-Handling >-----#
    Implicit_Grant_Handling = ENUM(name=u'Implicit-Grant-Handling', mode=MODE_TYPE)
    Implicit_Grant_Handling._cont = ASN1Dict([(u'true', 0)])
    Implicit_Grant_Handling._ext = None
    
    #-----< Improved-Synchronized-Indicator >-----#
    Improved_Synchronized_Indicator = ENUM(name=u'Improved-Synchronized-Indicator', mode=MODE_TYPE)
    Improved_Synchronized_Indicator._cont = ASN1Dict([(u'true', 0)])
    Improved_Synchronized_Indicator._ext = None
    
    #-----< Inactivity-Threshold-for-UE-DRX-Cycle-LCR >-----#
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR = ENUM(name=u'Inactivity-Threshold-for-UE-DRX-Cycle-LCR', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v16', 4), (u'v32', 5), (u'v64', 6)])
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR._ext = []
    
    #-----< Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext >-----#
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext = ENUM(name=u'Inactivity-Threshold-for-UE-DRX-Cycle-LCR-Ext', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext._cont = ASN1Dict([(u'v128', 0), (u'v256', 1), (u'v512', 2)])
    Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext._ext = []
    
    #-----< Inactivity-Threshold-for-UE-DTX-Cycle2 >-----#
    Inactivity_Threshold_for_UE_DTX_Cycle2 = ENUM(name=u'Inactivity-Threshold-for-UE-DTX-Cycle2', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DTX_Cycle2._cont = ASN1Dict([(u'v1', 0), (u'v4', 1), (u'v8', 2), (u'v16', 3), (u'v32', 4), (u'v64', 5), (u'v128', 6), (u'v256', 7)])
    Inactivity_Threshold_for_UE_DTX_Cycle2._ext = None
    
    #-----< Inactivity-Threshold-for-UE-DRX-Cycle >-----#
    Inactivity_Threshold_for_UE_DRX_Cycle = ENUM(name=u'Inactivity-Threshold-for-UE-DRX-Cycle', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_DRX_Cycle._cont = ASN1Dict([(u'v0', 0), (u'v1', 1), (u'v2', 2), (u'v4', 3), (u'v8', 4), (u'v16', 5), (u'v32', 6), (u'v64', 7), (u'v128', 8), (u'v256', 9), (u'v512', 10)])
    Inactivity_Threshold_for_UE_DRX_Cycle._ext = None
    
    #-----< Inactivity-Threshold-for-UE-Grant-Monitoring >-----#
    Inactivity_Threshold_for_UE_Grant_Monitoring = ENUM(name=u'Inactivity-Threshold-for-UE-Grant-Monitoring', mode=MODE_TYPE)
    Inactivity_Threshold_for_UE_Grant_Monitoring._cont = ASN1Dict([(u'v0', 0), (u'v1', 1), (u'v2', 2), (u'v4', 3), (u'v8', 4), (u'v16', 5), (u'v32', 6), (u'v64', 7), (u'v128', 8), (u'v256', 9)])
    Inactivity_Threshold_for_UE_Grant_Monitoring._ext = None
    
    #-----< InformationAvailable >-----#
    InformationAvailable = SEQ(name=u'InformationAvailable', mode=MODE_TYPE)
    _InformationAvailable_requestedDataValue = SEQ(name=u'requestedDataValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValue')))
    _InformationAvailable_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationAvailable_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationAvailable_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationAvailable_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_iE_Extensions__item__id._const_tab = ____InformationAvailable_iE_Extensions__item__id_tab
    ___InformationAvailable_iE_Extensions__item__id._const_tab_at = None
    ___InformationAvailable_iE_Extensions__item__id._const_tab_id = u'id'
    ___InformationAvailable_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationAvailable_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_iE_Extensions__item__criticality._const_tab = ____InformationAvailable_iE_Extensions__item__criticality_tab
    ___InformationAvailable_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationAvailable_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InformationAvailable_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationAvailable_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_iE_Extensions__item__extensionValue._const_tab = ____InformationAvailable_iE_Extensions__item__extensionValue_tab
    ___InformationAvailable_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationAvailable_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationAvailable_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InformationAvailable_iE_Extensions__item__id),
        (u'criticality', ___InformationAvailable_iE_Extensions__item__criticality),
        (u'extensionValue', ___InformationAvailable_iE_Extensions__item__extensionValue),
        ])
    __InformationAvailable_iE_Extensions__item_._ext = None
    _InformationAvailable_iE_Extensions._cont = __InformationAvailable_iE_Extensions__item_
    _InformationAvailable_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationAvailable._cont = ASN1Dict([
        (u'requestedDataValue', _InformationAvailable_requestedDataValue),
        (u'iE-Extensions', _InformationAvailable_iE_Extensions),
        ])
    InformationAvailable._ext = []
    
    #-----< InformationAvailable-ExtIEs >-----#
    InformationAvailable_ExtIEs = CLASS(name=u'InformationAvailable-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationAvailable_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeID >-----#
    InformationExchangeID = INT(name=u'InformationExchangeID', mode=MODE_TYPE)
    InformationExchangeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationNotAvailable >-----#
    InformationNotAvailable = NULL(name=u'InformationNotAvailable', mode=MODE_TYPE)
    
    #-----< InformationReportCharacteristics >-----#
    InformationReportCharacteristics = CHOICE(name=u'InformationReportCharacteristics', mode=MODE_TYPE)
    _InformationReportCharacteristics_onDemand = NULL(name=u'onDemand', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationReportCharacteristics_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PeriodicInformation')))
    _InformationReportCharacteristics_onModification = SEQ(name=u'onModification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'OnModificationInformation')))
    InformationReportCharacteristics._cont = ASN1Dict([
        (u'onDemand', _InformationReportCharacteristics_onDemand),
        (u'periodic', _InformationReportCharacteristics_periodic),
        (u'onModification', _InformationReportCharacteristics_onModification),
        ])
    InformationReportCharacteristics._ext = []
    
    #-----< InformationReportPeriodicity >-----#
    InformationReportPeriodicity = CHOICE(name=u'InformationReportPeriodicity', mode=MODE_TYPE)
    _InformationReportPeriodicity_min = INT(name=u'min', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationReportPeriodicity_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    _InformationReportPeriodicity_hour = INT(name=u'hour', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationReportPeriodicity_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=[], er=[])
    InformationReportPeriodicity._cont = ASN1Dict([
        (u'min', _InformationReportPeriodicity_min),
        (u'hour', _InformationReportPeriodicity_hour),
        ])
    InformationReportPeriodicity._ext = []
    
    #-----< InformationThreshold >-----#
    InformationThreshold = CHOICE(name=u'InformationThreshold', mode=MODE_TYPE)
    _InformationThreshold_dGPSThreshold = SEQ(name=u'dGPSThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DGPSThreshold')))
    _InformationThreshold_dGANSSThreshold = SEQ(name=u'dGANSSThreshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DGANSSThreshold')))
    InformationThreshold._cont = ASN1Dict([
        (u'dGPSThreshold', _InformationThreshold_dGPSThreshold),
        (u'dGANSSThreshold', _InformationThreshold_dGANSSThreshold),
        ])
    InformationThreshold._ext = [u'dGANSSThreshold']
    
    #-----< InformationType >-----#
    InformationType = SEQ(name=u'InformationType', mode=MODE_TYPE)
    _InformationType_informationTypeItem = ENUM(name=u'informationTypeItem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationType_informationTypeItem._cont = ASN1Dict([(u'gA-AccessPointPositionwithAltitude', 0), (u'gA-AccessPointPosition', 1), (u'iPDLParameters', 2), (u'gPSInformation', 3), (u'dGPSCorrections', 4), (u'gPS-RX-POS', 5), (u'sFNSFN-GA-AccessPointPosition', 6), (u'cell-Capacity-Class', 7), (u'nACC-Related-Data', 8), (u'mBMSBearerServiceFullAddress', 9), (u'interFrequencyCellInformation', 10), (u'gANSSInformation', 11), (u'dGANSSCorrections', 12), (u'gANSS-RX-Pos', 13), (u'mBMS-Counting-Information', 14), (u'mBMS-Transmission-Mode', 15), (u'mBMS-Neighbouring-Cell-Information', 16), (u'mBMS-RLC-Sequence-Number', 17), (u'aNR-Cell-Information', 18), (u'cOmmonERGCH-Cell-Information', 19)])
    _InformationType_informationTypeItem._ext = [u'cell-Capacity-Class', u'nACC-Related-Data', u'mBMSBearerServiceFullAddress', u'interFrequencyCellInformation', u'gANSSInformation', u'dGANSSCorrections', u'gANSS-RX-Pos', u'mBMS-Counting-Information', u'mBMS-Transmission-Mode', u'mBMS-Neighbouring-Cell-Information', u'mBMS-RLC-Sequence-Number', u'aNR-Cell-Information', u'cOmmonERGCH-Cell-Information']
    _InformationType_gPSInformation = SEQ_OF(name=u'gPSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPSInformation')), opt=True)
    _InformationType_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationType_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationType_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____InformationType_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Information')))
    _____InformationType_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DGANSS-Corrections-Req')))
    _____InformationType_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-RLC-Sequence-Number-Information')))
    ____InformationType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 700), (u'criticality', u'ignore'), (u'Extension', _____InformationType_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 748), (u'criticality', u'ignore'), (u'Extension', _____InformationType_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'conditional')]), dict([(u'id', 765), (u'criticality', u'ignore'), (u'Extension', _____InformationType_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___InformationType_iE_Extensions__item__id._const_tab = ____InformationType_iE_Extensions__item__id_tab
    ___InformationType_iE_Extensions__item__id._const_tab_at = None
    ___InformationType_iE_Extensions__item__id._const_tab_id = u'id'
    ___InformationType_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___InformationType_iE_Extensions__item__criticality._const_tab = ____InformationType_iE_Extensions__item__id_tab
    ___InformationType_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationType_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InformationType_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___InformationType_iE_Extensions__item__extensionValue._const_tab = ____InformationType_iE_Extensions__item__id_tab
    ___InformationType_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationType_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationType_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InformationType_iE_Extensions__item__id),
        (u'criticality', ___InformationType_iE_Extensions__item__criticality),
        (u'extensionValue', ___InformationType_iE_Extensions__item__extensionValue),
        ])
    __InformationType_iE_Extensions__item_._ext = None
    _InformationType_iE_Extensions._cont = __InformationType_iE_Extensions__item_
    _InformationType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationType._cont = ASN1Dict([
        (u'informationTypeItem', _InformationType_informationTypeItem),
        (u'gPSInformation', _InformationType_gPSInformation),
        (u'iE-Extensions', _InformationType_iE_Extensions),
        ])
    InformationType._ext = []
    
    #-----< InformationType-ExtIEs >-----#
    InformationType_ExtIEs = CLASS(name=u'InformationType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _InformationType_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Information')))
    _InformationType_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DGANSS-Corrections-Req')))
    _InformationType_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-RLC-Sequence-Number-Information')))
    InformationType_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 700), (u'criticality', u'ignore'), (u'Extension', _InformationType_ExtIEs_val_Extension_0), (u'presence', u'conditional')]), dict([(u'id', 748), (u'criticality', u'ignore'), (u'Extension', _InformationType_ExtIEs_val_Extension_1), (u'presence', u'conditional')]), dict([(u'id', 765), (u'criticality', u'ignore'), (u'Extension', _InformationType_ExtIEs_val_Extension_2), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< Initial-E-DCH-SPS-resource >-----#
    Initial_E_DCH_SPS_resource = SEQ(name=u'Initial-E-DCH-SPS-resource', mode=MODE_TYPE)
    _Initial_E_DCH_SPS_resource_timeslot_Resource_Related_Information = BIT_STR(name=u'timeslot-Resource-Related-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TimeslotResource-LCR')))
    _Initial_E_DCH_SPS_resource_powerResource = INT(name=u'powerResource', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-PowerResource')))
    _Initial_E_DCH_SPS_resource_repetitionPeriodIndex = INT(name=u'repetitionPeriodIndex', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriodIndex')))
    _Initial_E_DCH_SPS_resource_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _Initial_E_DCH_SPS_resource_subframeNumber = ENUM(name=u'subframeNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Initial_E_DCH_SPS_resource_subframeNumber._cont = ASN1Dict([(u'v0', 0), (u'v1', 1)])
    _Initial_E_DCH_SPS_resource_subframeNumber._ext = None
    _Initial_E_DCH_SPS_resource_tddE_PUCH_Offset = INT(name=u'tddE-PUCH-Offset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TddE-PUCH-Offset')))
    _Initial_E_DCH_SPS_resource_tdd_ChannelisationCode = ENUM(name=u'tdd-ChannelisationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _Initial_E_DCH_SPS_resource_n_E_UCCHLCR = INT(name=u'n-E-UCCHLCR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'N-E-UCCH-LCR')))
    _Initial_E_DCH_SPS_resource_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Initial_E_DCH_SPS_resource_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Initial_E_DCH_SPS_resource_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Initial_E_DCH_SPS_resource_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__id._const_tab = ____Initial_E_DCH_SPS_resource_iE_Extensions__item__id_tab
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__id._const_tab_at = None
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__id._const_tab_id = u'id'
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality._const_tab = ____Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality_tab
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue._const_tab = ____Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue_tab
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Initial_E_DCH_SPS_resource_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Initial_E_DCH_SPS_resource_iE_Extensions__item__id),
        (u'criticality', ___Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality),
        (u'extensionValue', ___Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue),
        ])
    __Initial_E_DCH_SPS_resource_iE_Extensions__item_._ext = None
    _Initial_E_DCH_SPS_resource_iE_Extensions._cont = __Initial_E_DCH_SPS_resource_iE_Extensions__item_
    _Initial_E_DCH_SPS_resource_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Initial_E_DCH_SPS_resource._cont = ASN1Dict([
        (u'timeslot-Resource-Related-Information', _Initial_E_DCH_SPS_resource_timeslot_Resource_Related_Information),
        (u'powerResource', _Initial_E_DCH_SPS_resource_powerResource),
        (u'repetitionPeriodIndex', _Initial_E_DCH_SPS_resource_repetitionPeriodIndex),
        (u'repetitionLength', _Initial_E_DCH_SPS_resource_repetitionLength),
        (u'subframeNumber', _Initial_E_DCH_SPS_resource_subframeNumber),
        (u'tddE-PUCH-Offset', _Initial_E_DCH_SPS_resource_tddE_PUCH_Offset),
        (u'tdd-ChannelisationCode', _Initial_E_DCH_SPS_resource_tdd_ChannelisationCode),
        (u'n-E-UCCHLCR', _Initial_E_DCH_SPS_resource_n_E_UCCHLCR),
        (u'iE-Extensions', _Initial_E_DCH_SPS_resource_iE_Extensions),
        ])
    Initial_E_DCH_SPS_resource._ext = []
    
    #-----< Initial-E-DCH-SPS-resource-ExtIEs >-----#
    Initial_E_DCH_SPS_resource_ExtIEs = CLASS(name=u'Initial-E-DCH-SPS-resource-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Initial_E_DCH_SPS_resource_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Initial-DL-DPCH-TimingAdjustment-Allowed >-----#
    Initial_DL_DPCH_TimingAdjustment_Allowed = ENUM(name=u'Initial-DL-DPCH-TimingAdjustment-Allowed', mode=MODE_TYPE)
    Initial_DL_DPCH_TimingAdjustment_Allowed._cont = ASN1Dict([(u'initial-DL-DPCH-TimingAdjustment-Allowed', 0)])
    Initial_DL_DPCH_TimingAdjustment_Allowed._ext = None
    
    #-----< InnerLoopDLPCStatus >-----#
    InnerLoopDLPCStatus = ENUM(name=u'InnerLoopDLPCStatus', mode=MODE_TYPE)
    InnerLoopDLPCStatus._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    InnerLoopDLPCStatus._ext = None
    
    #-----< IPDLParameters >-----#
    IPDLParameters = CHOICE(name=u'IPDLParameters', mode=MODE_TYPE)
    _IPDLParameters_iPDL_FDD_Parameters = SEQ(name=u'iPDL-FDD-Parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPDL-FDD-Parameters')))
    _IPDLParameters_iPDL_TDD_Parameters = SEQ(name=u'iPDL-TDD-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPDL-TDD-Parameters')))
    _IPDLParameters_extension_IPDLParameters = SEQ(name=u'extension-IPDLParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-IPDLParameters')))
    IPDLParameters._cont = ASN1Dict([
        (u'iPDL-FDD-Parameters', _IPDLParameters_iPDL_FDD_Parameters),
        (u'iPDL-TDD-Parameters', _IPDLParameters_iPDL_TDD_Parameters),
        (u'extension-IPDLParameters', _IPDLParameters_extension_IPDLParameters),
        ])
    IPDLParameters._ext = [u'extension-IPDLParameters']
    
    #-----< Extension-IPDLParameters >-----#
    Extension_IPDLParameters = SEQ(name=u'Extension-IPDLParameters', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_IPDLParameters_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_IPDLParameters_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_IPDLParameters_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IPDL-TDD-ParametersLCR')))
    __Extension_IPDLParameters_id_tab._val = ASN1Set(rv=[dict([(u'id', 252), (u'criticality', u'reject'), (u'Value', ___Extension_IPDLParameters_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_IPDLParameters_id._const_tab = __Extension_IPDLParameters_id_tab
    _Extension_IPDLParameters_id._const_tab_at = None
    _Extension_IPDLParameters_id._const_tab_id = u'id'
    _Extension_IPDLParameters_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_IPDLParameters_criticality._const_tab = __Extension_IPDLParameters_id_tab
    _Extension_IPDLParameters_criticality._const_tab_at = ('..', u'id')
    _Extension_IPDLParameters_criticality._const_tab_id = u'criticality'
    _Extension_IPDLParameters_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_IPDLParameters_value._const_tab = __Extension_IPDLParameters_id_tab
    _Extension_IPDLParameters_value._const_tab_at = ('..', u'id')
    _Extension_IPDLParameters_value._const_tab_id = u'Value'
    Extension_IPDLParameters._cont = ASN1Dict([
        (u'id', _Extension_IPDLParameters_id),
        (u'criticality', _Extension_IPDLParameters_criticality),
        (u'value', _Extension_IPDLParameters_value),
        ])
    Extension_IPDLParameters._ext = None
    
    #-----< Extension-IPDLParametersIE >-----#
    Extension_IPDLParametersIE = CLASS(name=u'Extension-IPDLParametersIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_IPDLParametersIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IPDL-TDD-ParametersLCR')))
    Extension_IPDLParametersIE._val = ASN1Set(rv=[dict([(u'id', 252), (u'criticality', u'reject'), (u'Value', _Extension_IPDLParametersIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cell-List >-----#
    Inter_Frequency_Cell_List = SEQ_OF(name=u'Inter-Frequency-Cell-List', mode=MODE_TYPE)
    _Inter_Frequency_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell')))
    Inter_Frequency_Cell_List._cont = _Inter_Frequency_Cell_List__item_
    Inter_Frequency_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cell >-----#
    Inter_Frequency_Cell = SEQ(name=u'Inter-Frequency-Cell', mode=MODE_TYPE)
    _Inter_Frequency_Cell_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Inter_Frequency_Cell_uL_UARFCN = INT(name=u'uL-UARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _Inter_Frequency_Cell_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')))
    _Inter_Frequency_Cell_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cell_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cell_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cell_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cell_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cell_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cell_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cell_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Inter_Frequency_Cell_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cell_iE_Extensions__item__criticality_tab
    ___Inter_Frequency_Cell_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cell_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Inter_Frequency_Cell_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cell_iE_Extensions__item__extensionValue_tab
    ___Inter_Frequency_Cell_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cell_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cell_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cell_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cell_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cell_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cell_iE_Extensions._cont = __Inter_Frequency_Cell_iE_Extensions__item_
    _Inter_Frequency_Cell_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cell._cont = ASN1Dict([
        (u'dL-UARFCN', _Inter_Frequency_Cell_dL_UARFCN),
        (u'uL-UARFCN', _Inter_Frequency_Cell_uL_UARFCN),
        (u'primaryScramblingCode', _Inter_Frequency_Cell_primaryScramblingCode),
        (u'iE-Extensions', _Inter_Frequency_Cell_iE_Extensions),
        ])
    Inter_Frequency_Cell._ext = []
    
    #-----< Inter-Frequency-Cell-ExtIEs >-----#
    Inter_Frequency_Cell_ExtIEs = CLASS(name=u'Inter-Frequency-Cell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Inter_Frequency_Cell_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cell-Information >-----#
    Inter_Frequency_Cell_Information = SEQ(name=u'Inter-Frequency-Cell-Information', mode=MODE_TYPE)
    _Inter_Frequency_Cell_Information_inter_Frequency_Cell_Information_SIB11 = SEQ_OF(name=u'inter-Frequency-Cell-Information-SIB11', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Information-SIB11')))
    _Inter_Frequency_Cell_Information_inter_Frequency_Cell_Information_SIB12 = SEQ_OF(name=u'inter-Frequency-Cell-Information-SIB12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Information-SIB12')))
    _Inter_Frequency_Cell_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Information-SIB11ter')))
    ____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 981), (u'criticality', u'ignore'), (u'Extension', _____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cell_Information_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cell_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cell_Information_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cell_Information_iE_Extensions._cont = __Inter_Frequency_Cell_Information_iE_Extensions__item_
    _Inter_Frequency_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cell_Information._cont = ASN1Dict([
        (u'inter-Frequency-Cell-Information-SIB11', _Inter_Frequency_Cell_Information_inter_Frequency_Cell_Information_SIB11),
        (u'inter-Frequency-Cell-Information-SIB12', _Inter_Frequency_Cell_Information_inter_Frequency_Cell_Information_SIB12),
        (u'iE-Extensions', _Inter_Frequency_Cell_Information_iE_Extensions),
        ])
    Inter_Frequency_Cell_Information._ext = []
    
    #-----< Inter-Frequency-Cell-Information-ExtIEs >-----#
    Inter_Frequency_Cell_Information_ExtIEs = CLASS(name=u'Inter-Frequency-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Inter_Frequency_Cell_Information_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Information-SIB11ter')))
    Inter_Frequency_Cell_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 981), (u'criticality', u'ignore'), (u'Extension', _Inter_Frequency_Cell_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cell-Information-SIB11 >-----#
    Inter_Frequency_Cell_Information_SIB11 = SEQ_OF(name=u'Inter-Frequency-Cell-Information-SIB11', mode=MODE_TYPE)
    _Inter_Frequency_Cell_Information_SIB11__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cells-Information-SIB11-Per-Indication')))
    Inter_Frequency_Cell_Information_SIB11._cont = _Inter_Frequency_Cell_Information_SIB11__item_
    Inter_Frequency_Cell_Information_SIB11._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cell-Information-SIB12 >-----#
    Inter_Frequency_Cell_Information_SIB12 = SEQ_OF(name=u'Inter-Frequency-Cell-Information-SIB12', mode=MODE_TYPE)
    _Inter_Frequency_Cell_Information_SIB12__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cells-Information-SIB12-Per-Indication')))
    Inter_Frequency_Cell_Information_SIB12._cont = _Inter_Frequency_Cell_Information_SIB12__item_
    Inter_Frequency_Cell_Information_SIB12._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cell-Information-SIB11ter >-----#
    Inter_Frequency_Cell_Information_SIB11ter = SEQ_OF(name=u'Inter-Frequency-Cell-Information-SIB11ter', mode=MODE_TYPE)
    _Inter_Frequency_Cell_Information_SIB11ter__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication')))
    Inter_Frequency_Cell_Information_SIB11ter._cont = _Inter_Frequency_Cell_Information_SIB11ter__item_
    Inter_Frequency_Cell_Information_SIB11ter._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cells-Information-SIB11-Per-Indication >-----#
    Inter_Frequency_Cells_Information_SIB11_Per_Indication = SEQ(name=u'Inter-Frequency-Cells-Information-SIB11-Per-Indication', mode=MODE_TYPE)
    _Inter_Frequency_Cells_Information_SIB11_Per_Indication_inter_Frequency_Cell_Indication_SIB11 = INT(name=u'inter-Frequency-Cell-Indication-SIB11', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Indication')))
    _Inter_Frequency_Cells_Information_SIB11_Per_Indication_inter_Frequency_Cell_List_SIB11 = SEQ_OF(name=u'inter-Frequency-Cell-List-SIB11', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-SIB11-or-SIB12-List')))
    _Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality_tab
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue_tab
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions._cont = __Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item_
    _Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cells_Information_SIB11_Per_Indication._cont = ASN1Dict([
        (u'inter-Frequency-Cell-Indication-SIB11', _Inter_Frequency_Cells_Information_SIB11_Per_Indication_inter_Frequency_Cell_Indication_SIB11),
        (u'inter-Frequency-Cell-List-SIB11', _Inter_Frequency_Cells_Information_SIB11_Per_Indication_inter_Frequency_Cell_List_SIB11),
        (u'iE-Extensions', _Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions),
        ])
    Inter_Frequency_Cells_Information_SIB11_Per_Indication._ext = []
    
    #-----< Inter-Frequency-Cells-Information-SIB11-Per-Indication-ExtIEs >-----#
    Inter_Frequency_Cells_Information_SIB11_Per_Indication_ExtIEs = CLASS(name=u'Inter-Frequency-Cells-Information-SIB11-Per-Indication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Inter_Frequency_Cells_Information_SIB11_Per_Indication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cells-Information-SIB12-Per-Indication >-----#
    Inter_Frequency_Cells_Information_SIB12_Per_Indication = SEQ(name=u'Inter-Frequency-Cells-Information-SIB12-Per-Indication', mode=MODE_TYPE)
    _Inter_Frequency_Cells_Information_SIB12_Per_Indication_inter_Frequency_Cell_Indication_SIB12 = INT(name=u'inter-Frequency-Cell-Indication-SIB12', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Indication')))
    _Inter_Frequency_Cells_Information_SIB12_Per_Indication_inter_Frequency_Cell_List_SIB12 = SEQ_OF(name=u'inter-Frequency-Cell-List-SIB12', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-SIB11-or-SIB12-List')))
    _Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality_tab
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue_tab
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions._cont = __Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item_
    _Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cells_Information_SIB12_Per_Indication._cont = ASN1Dict([
        (u'inter-Frequency-Cell-Indication-SIB12', _Inter_Frequency_Cells_Information_SIB12_Per_Indication_inter_Frequency_Cell_Indication_SIB12),
        (u'inter-Frequency-Cell-List-SIB12', _Inter_Frequency_Cells_Information_SIB12_Per_Indication_inter_Frequency_Cell_List_SIB12),
        (u'iE-Extensions', _Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions),
        ])
    Inter_Frequency_Cells_Information_SIB12_Per_Indication._ext = []
    
    #-----< Inter-Frequency-Cells-Information-SIB12-Per-Indication-ExtIEs >-----#
    Inter_Frequency_Cells_Information_SIB12_Per_Indication_ExtIEs = CLASS(name=u'Inter-Frequency-Cells-Information-SIB12-Per-Indication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Inter_Frequency_Cells_Information_SIB12_Per_Indication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cells-Information-SIB11ter-Per-Indication >-----#
    Inter_Frequency_Cells_Information_SIB11ter_Per_Indication = SEQ(name=u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication', mode=MODE_TYPE)
    _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_inter_Frequency_Cell_Indication_SIB11ter = INT(name=u'inter-Frequency-Cell-Indication-SIB11ter', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Indication')))
    _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_inter_Frequency_Cell_List_SIB11ter = SEQ_OF(name=u'inter-Frequency-Cell-List-SIB11ter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-SIB11ter-List')))
    _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality_tab
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue_tab
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions._cont = __Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item_
    _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cells_Information_SIB11ter_Per_Indication._cont = ASN1Dict([
        (u'inter-Frequency-Cell-Indication-SIB11ter', _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_inter_Frequency_Cell_Indication_SIB11ter),
        (u'inter-Frequency-Cell-List-SIB11ter', _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_inter_Frequency_Cell_List_SIB11ter),
        (u'iE-Extensions', _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions),
        ])
    Inter_Frequency_Cells_Information_SIB11ter_Per_Indication._ext = []
    
    #-----< Inter-Frequency-Cell-SIB11ter-List >-----#
    Inter_Frequency_Cell_SIB11ter_List = SEQ_OF(name=u'Inter-Frequency-Cell-SIB11ter-List', mode=MODE_TYPE)
    _Inter_Frequency_Cell_SIB11ter_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-SIB11ter')))
    Inter_Frequency_Cell_SIB11ter_List._cont = _Inter_Frequency_Cell_SIB11ter_List__item_
    Inter_Frequency_Cell_SIB11ter_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=48)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cells-Information-SIB11ter-Per-Indication-ExtIEs >-----#
    Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_ExtIEs = CLASS(name=u'Inter-Frequency-Cells-Information-SIB11ter-Per-Indication-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cell-SIB11ter >-----#
    Inter_Frequency_Cell_SIB11ter = SEQ(name=u'Inter-Frequency-Cell-SIB11ter', mode=MODE_TYPE)
    _Inter_Frequency_Cell_SIB11ter_interFrequencyCellID = INT(name=u'interFrequencyCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InterFrequencyCellID-Ext')))
    _Inter_Frequency_Cell_SIB11ter_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Inter_Frequency_Cell_SIB11ter_uL_UARFCN = INT(name=u'uL-UARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _Inter_Frequency_Cell_SIB11ter_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')))
    _Inter_Frequency_Cell_SIB11ter_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cell_SIB11ter_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality_tab
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue_tab
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cell_SIB11ter_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cell_SIB11ter_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cell_SIB11ter_iE_Extensions._cont = __Inter_Frequency_Cell_SIB11ter_iE_Extensions__item_
    _Inter_Frequency_Cell_SIB11ter_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cell_SIB11ter._cont = ASN1Dict([
        (u'interFrequencyCellID', _Inter_Frequency_Cell_SIB11ter_interFrequencyCellID),
        (u'dL-UARFCN', _Inter_Frequency_Cell_SIB11ter_dL_UARFCN),
        (u'uL-UARFCN', _Inter_Frequency_Cell_SIB11ter_uL_UARFCN),
        (u'primaryScramblingCode', _Inter_Frequency_Cell_SIB11ter_primaryScramblingCode),
        (u'iE-Extensions', _Inter_Frequency_Cell_SIB11ter_iE_Extensions),
        ])
    Inter_Frequency_Cell_SIB11ter._ext = []
    
    #-----< InterFrequencyCellID-Ext >-----#
    InterFrequencyCellID_Ext = INT(name=u'InterFrequencyCellID-Ext', mode=MODE_TYPE)
    InterFrequencyCellID_Ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=79)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cell-SIB11ter-ExtIEs >-----#
    Inter_Frequency_Cell_SIB11ter_ExtIEs = CLASS(name=u'Inter-Frequency-Cell-SIB11ter-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Inter_Frequency_Cell_SIB11ter_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Inter-Frequency-Cell-Indication >-----#
    Inter_Frequency_Cell_Indication = INT(name=u'Inter-Frequency-Cell-Indication', mode=MODE_TYPE)
    Inter_Frequency_Cell_Indication._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cell-SIB11-or-SIB12-List >-----#
    Inter_Frequency_Cell_SIB11_or_SIB12_List = SEQ_OF(name=u'Inter-Frequency-Cell-SIB11-or-SIB12-List', mode=MODE_TYPE)
    _Inter_Frequency_Cell_SIB11_or_SIB12_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-SIB11-or-SIB12')))
    Inter_Frequency_Cell_SIB11_or_SIB12_List._cont = _Inter_Frequency_Cell_SIB11_or_SIB12_List__item_
    Inter_Frequency_Cell_SIB11_or_SIB12_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< Inter-Frequency-Cell-SIB11-or-SIB12 >-----#
    Inter_Frequency_Cell_SIB11_or_SIB12 = SEQ(name=u'Inter-Frequency-Cell-SIB11-or-SIB12', mode=MODE_TYPE)
    _Inter_Frequency_Cell_SIB11_or_SIB12_interFrequencyCellID = INT(name=u'interFrequencyCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InterFrequencyCellID')))
    _Inter_Frequency_Cell_SIB11_or_SIB12_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Inter_Frequency_Cell_SIB11_or_SIB12_uL_UARFCN = INT(name=u'uL-UARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _Inter_Frequency_Cell_SIB11_or_SIB12_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')))
    _Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id._const_tab = ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id_tab
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id._const_tab_at = None
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id._const_tab_id = u'id'
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality._const_tab = ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality_tab
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue._const_tab = ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue_tab
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id),
        (u'criticality', ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality),
        (u'extensionValue', ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue),
        ])
    __Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item_._ext = None
    _Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions._cont = __Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item_
    _Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Inter_Frequency_Cell_SIB11_or_SIB12._cont = ASN1Dict([
        (u'interFrequencyCellID', _Inter_Frequency_Cell_SIB11_or_SIB12_interFrequencyCellID),
        (u'dL-UARFCN', _Inter_Frequency_Cell_SIB11_or_SIB12_dL_UARFCN),
        (u'uL-UARFCN', _Inter_Frequency_Cell_SIB11_or_SIB12_uL_UARFCN),
        (u'primaryScramblingCode', _Inter_Frequency_Cell_SIB11_or_SIB12_primaryScramblingCode),
        (u'iE-Extensions', _Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions),
        ])
    Inter_Frequency_Cell_SIB11_or_SIB12._ext = []
    
    #-----< InterFrequencyCellID >-----#
    InterFrequencyCellID = INT(name=u'InterFrequencyCellID', mode=MODE_TYPE)
    InterFrequencyCellID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< InterStream-Interference-Compensation >-----#
    InterStream_Interference_Compensation = INT(name=u'InterStream-Interference-Compensation', mode=MODE_TYPE)
    InterStream_Interference_Compensation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=[], er=[])
    
    #-----< IPDL-FDD-Parameters >-----#
    IPDL_FDD_Parameters = SEQ(name=u'IPDL-FDD-Parameters', mode=MODE_TYPE)
    _IPDL_FDD_Parameters_iPSpacingFDD = ENUM(name=u'iPSpacingFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPSpacingFDD')))
    _IPDL_FDD_Parameters_iPLength = ENUM(name=u'iPLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPLength')))
    _IPDL_FDD_Parameters_iPOffset = INT(name=u'iPOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPOffset')))
    _IPDL_FDD_Parameters_seed = INT(name=u'seed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Seed')))
    _IPDL_FDD_Parameters_burstModeParameters = SEQ(name=u'burstModeParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BurstModeParameters')), opt=True)
    _IPDL_FDD_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDL_FDD_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___IPDL_FDD_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_FDD_Parameters_iE_Extensions__item__id._const_tab = ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab
    ___IPDL_FDD_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___IPDL_FDD_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality._const_tab = ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IPDL_FDD_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue._const_tab = ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IPDL_FDD_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IPDL_FDD_Parameters_iE_Extensions__item__id),
        (u'criticality', ___IPDL_FDD_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue),
        ])
    __IPDL_FDD_Parameters_iE_Extensions__item_._ext = None
    _IPDL_FDD_Parameters_iE_Extensions._cont = __IPDL_FDD_Parameters_iE_Extensions__item_
    _IPDL_FDD_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDL_FDD_Parameters._cont = ASN1Dict([
        (u'iPSpacingFDD', _IPDL_FDD_Parameters_iPSpacingFDD),
        (u'iPLength', _IPDL_FDD_Parameters_iPLength),
        (u'iPOffset', _IPDL_FDD_Parameters_iPOffset),
        (u'seed', _IPDL_FDD_Parameters_seed),
        (u'burstModeParameters', _IPDL_FDD_Parameters_burstModeParameters),
        (u'iE-Extensions', _IPDL_FDD_Parameters_iE_Extensions),
        ])
    IPDL_FDD_Parameters._ext = []
    
    #-----< IPDL-FDD-Parameters-ExtIEs >-----#
    IPDL_FDD_Parameters_ExtIEs = CLASS(name=u'IPDL-FDD-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    IPDL_FDD_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDL-TDD-Parameters >-----#
    IPDL_TDD_Parameters = SEQ(name=u'IPDL-TDD-Parameters', mode=MODE_TYPE)
    _IPDL_TDD_Parameters_iPSpacingTDD = ENUM(name=u'iPSpacingTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPSpacingTDD')))
    _IPDL_TDD_Parameters_iPStart = INT(name=u'iPStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPStart')))
    _IPDL_TDD_Parameters_iPSlot = INT(name=u'iPSlot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPSlot')))
    _IPDL_TDD_Parameters_iP_P_CCPCH = ENUM(name=u'iP-P-CCPCH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IP-P-CCPCH')))
    _IPDL_TDD_Parameters_burstModeParameters = SEQ(name=u'burstModeParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BurstModeParameters')), opt=True)
    _IPDL_TDD_Parameters_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDL_TDD_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___IPDL_TDD_Parameters_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_iE_Extensions__item__id._const_tab = ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab
    ___IPDL_TDD_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___IPDL_TDD_Parameters_iE_Extensions__item__id._const_tab_id = u'id'
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality._const_tab = ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IPDL_TDD_Parameters_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue._const_tab = ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IPDL_TDD_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IPDL_TDD_Parameters_iE_Extensions__item__id),
        (u'criticality', ___IPDL_TDD_Parameters_iE_Extensions__item__criticality),
        (u'extensionValue', ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue),
        ])
    __IPDL_TDD_Parameters_iE_Extensions__item_._ext = None
    _IPDL_TDD_Parameters_iE_Extensions._cont = __IPDL_TDD_Parameters_iE_Extensions__item_
    _IPDL_TDD_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDL_TDD_Parameters._cont = ASN1Dict([
        (u'iPSpacingTDD', _IPDL_TDD_Parameters_iPSpacingTDD),
        (u'iPStart', _IPDL_TDD_Parameters_iPStart),
        (u'iPSlot', _IPDL_TDD_Parameters_iPSlot),
        (u'iP-P-CCPCH', _IPDL_TDD_Parameters_iP_P_CCPCH),
        (u'burstModeParameters', _IPDL_TDD_Parameters_burstModeParameters),
        (u'iE-Extensions', _IPDL_TDD_Parameters_iE_Extensions),
        ])
    IPDL_TDD_Parameters._ext = []
    
    #-----< IPDL-TDD-Parameters-ExtIEs >-----#
    IPDL_TDD_Parameters_ExtIEs = CLASS(name=u'IPDL-TDD-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    IPDL_TDD_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPDL-TDD-ParametersLCR >-----#
    IPDL_TDD_ParametersLCR = SEQ(name=u'IPDL-TDD-ParametersLCR', mode=MODE_TYPE)
    _IPDL_TDD_ParametersLCR_iPSpacingTDD = ENUM(name=u'iPSpacingTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPSpacingTDD')))
    _IPDL_TDD_ParametersLCR_iPStart = INT(name=u'iPStart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPStart')))
    _IPDL_TDD_ParametersLCR_iPSub = ENUM(name=u'iPSub', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPSub')))
    _IPDL_TDD_ParametersLCR_burstModeParameters = SEQ(name=u'burstModeParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BurstModeParameters')), opt=True)
    _IPDL_TDD_ParametersLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IPDL_TDD_ParametersLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IPDL_TDD_ParametersLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_ParametersLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__id._const_tab = ____IPDL_TDD_ParametersLCR_iE_Extensions__item__id_tab
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__id._const_tab_at = None
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality._const_tab = ____IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality_tab
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue._const_tab = ____IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue_tab
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __IPDL_TDD_ParametersLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___IPDL_TDD_ParametersLCR_iE_Extensions__item__id),
        (u'criticality', ___IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue),
        ])
    __IPDL_TDD_ParametersLCR_iE_Extensions__item_._ext = None
    _IPDL_TDD_ParametersLCR_iE_Extensions._cont = __IPDL_TDD_ParametersLCR_iE_Extensions__item_
    _IPDL_TDD_ParametersLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IPDL_TDD_ParametersLCR._cont = ASN1Dict([
        (u'iPSpacingTDD', _IPDL_TDD_ParametersLCR_iPSpacingTDD),
        (u'iPStart', _IPDL_TDD_ParametersLCR_iPStart),
        (u'iPSub', _IPDL_TDD_ParametersLCR_iPSub),
        (u'burstModeParameters', _IPDL_TDD_ParametersLCR_burstModeParameters),
        (u'iE-Extensions', _IPDL_TDD_ParametersLCR_iE_Extensions),
        ])
    IPDL_TDD_ParametersLCR._ext = []
    
    #-----< IPDL-TDD-ParametersLCR-ExtIEs >-----#
    IPDL_TDD_ParametersLCR_ExtIEs = CLASS(name=u'IPDL-TDD-ParametersLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    IPDL_TDD_ParametersLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPLength >-----#
    IPLength = ENUM(name=u'IPLength', mode=MODE_TYPE)
    IPLength._cont = ASN1Dict([(u'ipl5', 0), (u'ipl10', 1)])
    IPLength._ext = []
    
    #-----< IPMulticastAddress >-----#
    IPMulticastAddress = OCT_STR(name=u'IPMulticastAddress', mode=MODE_TYPE)
    IPMulticastAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< IPOffset >-----#
    IPOffset = INT(name=u'IPOffset', mode=MODE_TYPE)
    IPOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    
    #-----< IP-P-CCPCH >-----#
    IP_P_CCPCH = ENUM(name=u'IP-P-CCPCH', mode=MODE_TYPE)
    IP_P_CCPCH._cont = ASN1Dict([(u'switchOff-1-Frame', 0), (u'switchOff-2-Frames', 1)])
    IP_P_CCPCH._ext = None
    
    #-----< IPSlot >-----#
    IPSlot = INT(name=u'IPSlot', mode=MODE_TYPE)
    IPSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< IPSpacingFDD >-----#
    IPSpacingFDD = ENUM(name=u'IPSpacingFDD', mode=MODE_TYPE)
    IPSpacingFDD._cont = ASN1Dict([(u'ipsF5', 0), (u'ipsF7', 1), (u'ipsF10', 2), (u'ipsF15', 3), (u'ipsF20', 4), (u'ipsF30', 5), (u'ipsF40', 6), (u'ipsF50', 7)])
    IPSpacingFDD._ext = []
    
    #-----< IPSpacingTDD >-----#
    IPSpacingTDD = ENUM(name=u'IPSpacingTDD', mode=MODE_TYPE)
    IPSpacingTDD._cont = ASN1Dict([(u'ipsT30', 0), (u'ipsT40', 1), (u'ipsT50', 2), (u'ipsT70', 3), (u'ipsT100', 4)])
    IPSpacingTDD._ext = []
    
    #-----< IPStart >-----#
    IPStart = INT(name=u'IPStart', mode=MODE_TYPE)
    IPStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< IPSub >-----#
    IPSub = ENUM(name=u'IPSub', mode=MODE_TYPE)
    IPSub._cont = ASN1Dict([(u'first', 0), (u'second', 1), (u'both', 2)])
    IPSub._ext = None
    
    #-----< IdleIntervalInformation >-----#
    IdleIntervalInformation = SEQ(name=u'IdleIntervalInformation', mode=MODE_TYPE)
    _IdleIntervalInformation_idleIntervalInfo_k = INT(name=u'idleIntervalInfo-k', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IdleIntervalInformation_idleIntervalInfo_k._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    _IdleIntervalInformation_idleIntervalInfo_offset = INT(name=u'idleIntervalInfo-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IdleIntervalInformation_idleIntervalInfo_offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    IdleIntervalInformation._cont = ASN1Dict([
        (u'idleIntervalInfo-k', _IdleIntervalInformation_idleIntervalInfo_k),
        (u'idleIntervalInfo-offset', _IdleIntervalInformation_idleIntervalInfo_offset),
        ])
    IdleIntervalInformation._ext = []
    
    #-----< LABased >-----#
    LABased = SEQ(name=u'LABased', mode=MODE_TYPE)
    _LABased_laiList = SEQ_OF(name=u'laiList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAI-List')))
    _LABased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LABased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___LABased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LABased_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__id._const_tab = ____LABased_iE_Extensions__item__id_tab
    ___LABased_iE_Extensions__item__id._const_tab_at = None
    ___LABased_iE_Extensions__item__id._const_tab_id = u'id'
    ___LABased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LABased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__criticality._const_tab = ____LABased_iE_Extensions__item__criticality_tab
    ___LABased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LABased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LABased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LABased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__extensionValue._const_tab = ____LABased_iE_Extensions__item__extensionValue_tab
    ___LABased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LABased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LABased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LABased_iE_Extensions__item__id),
        (u'criticality', ___LABased_iE_Extensions__item__criticality),
        (u'extensionValue', ___LABased_iE_Extensions__item__extensionValue),
        ])
    __LABased_iE_Extensions__item_._ext = None
    _LABased_iE_Extensions._cont = __LABased_iE_Extensions__item_
    _LABased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LABased._cont = ASN1Dict([
        (u'laiList', _LABased_laiList),
        (u'iE-Extensions', _LABased_iE_Extensions),
        ])
    LABased._ext = []
    
    #-----< LABased-ExtIEs >-----#
    LABased_ExtIEs = CLASS(name=u'LABased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    LABased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAI-List >-----#
    LAI_List = SEQ_OF(name=u'LAI-List', mode=MODE_TYPE)
    _LAI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LAI')))
    LAI_List._cont = _LAI_List__item_
    LAI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name=u'LAI', mode=MODE_TYPE)
    _LAI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _LAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LAI_iE_Extensions__item__id),
        (u'criticality', ___LAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        (u'pLMN-Identity', _LAI_pLMN_Identity),
        (u'lAC', _LAI_lAC),
        (u'iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = []
    
    #-----< LimitedPowerIncrease >-----#
    LimitedPowerIncrease = ENUM(name=u'LimitedPowerIncrease', mode=MODE_TYPE)
    LimitedPowerIncrease._cont = ASN1Dict([(u'used', 0), (u'not-used', 1)])
    LimitedPowerIncrease._ext = None
    
    #-----< List-Of-PLMNs >-----#
    List_Of_PLMNs = SEQ_OF(name=u'List-Of-PLMNs', mode=MODE_TYPE)
    _List_Of_PLMNs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    List_Of_PLMNs._cont = _List_Of_PLMNs__item_
    List_Of_PLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< L3-Information >-----#
    L3_Information = BIT_STR(name=u'L3-Information', mode=MODE_TYPE)
    
    #-----< Load-Value-IncrDecrThres >-----#
    Load_Value_IncrDecrThres = INT(name=u'Load-Value-IncrDecrThres', mode=MODE_TYPE)
    Load_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Load-Value >-----#
    Load_Value = INT(name=u'Load-Value', mode=MODE_TYPE)
    Load_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< LoadValue >-----#
    LoadValue = SEQ(name=u'LoadValue', mode=MODE_TYPE)
    _LoadValue_uplinkLoadValue = INT(name=u'uplinkLoadValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LoadValue_uplinkLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _LoadValue_downlinkLoadValue = INT(name=u'downlinkLoadValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LoadValue_downlinkLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    LoadValue._cont = ASN1Dict([
        (u'uplinkLoadValue', _LoadValue_uplinkLoadValue),
        (u'downlinkLoadValue', _LoadValue_downlinkLoadValue),
        ])
    LoadValue._ext = None
    
    #-----< LCRTDD-Uplink-Physical-Channel-Capability >-----#
    LCRTDD_Uplink_Physical_Channel_Capability = SEQ(name=u'LCRTDD-Uplink-Physical-Channel-Capability', mode=MODE_TYPE)
    _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame = INT(name=u'maxTimeslotsPerSubFrame', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot = ENUM(name=u'maxPhysChPerTimeslot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot._cont = ASN1Dict([(u'ts1', 0), (u'ts2', 1), (u'ts3', 2), (u'ts4', 3)])
    _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot._ext = []
    _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id._const_tab = ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id._const_tab_at = None
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id._const_tab_id = u'id'
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality._const_tab = ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue._const_tab = ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id),
        (u'criticality', ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality),
        (u'extensionValue', ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue),
        ])
    __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_._ext = None
    _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions._cont = __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_
    _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LCRTDD_Uplink_Physical_Channel_Capability._cont = ASN1Dict([
        (u'maxTimeslotsPerSubFrame', _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame),
        (u'maxPhysChPerTimeslot', _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot),
        (u'iE-Extensions', _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions),
        ])
    LCRTDD_Uplink_Physical_Channel_Capability._ext = []
    
    #-----< LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs >-----#
    LCRTDD_Uplink_Physical_Channel_Capability_ExtIEs = CLASS(name=u'LCRTDD-Uplink-Physical-Channel-Capability-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    LCRTDD_Uplink_Physical_Channel_Capability_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LogicalChannelID >-----#
    LogicalChannelID = INT(name=u'LogicalChannelID', mode=MODE_TYPE)
    LogicalChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< M1Report >-----#
    M1Report = CHOICE(name=u'M1Report', mode=MODE_TYPE)
    _M1Report_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MDT-Report-Parameters')))
    _M1Report_event1F = SEQ(name=u'event1F', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Event1F-Parameters')))
    M1Report._cont = ASN1Dict([
        (u'periodic', _M1Report_periodic),
        (u'event1F', _M1Report_event1F),
        ])
    M1Report._ext = []
    
    #-----< M2Report >-----#
    M2Report = CHOICE(name=u'M2Report', mode=MODE_TYPE)
    _M2Report_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MDT-Report-Parameters')))
    _M2Report_event1I = SEQ(name=u'event1I', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Event1I-Parameters')))
    M2Report._cont = ASN1Dict([
        (u'periodic', _M2Report_periodic),
        (u'event1I', _M2Report_event1I),
        ])
    M2Report._ext = []
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name=u'MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([(u'mdt-only', 0), (u'mdt-and-trace', 1)])
    MDT_Activation._ext = []
    
    #-----< MDTAreaScope >-----#
    MDTAreaScope = CHOICE(name=u'MDTAreaScope', mode=MODE_TYPE)
    _MDTAreaScope_cellbased = SEQ(name=u'cellbased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellBased')))
    _MDTAreaScope_labased = SEQ(name=u'labased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LABased')))
    _MDTAreaScope_rabased = SEQ(name=u'rabased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RABased')))
    _MDTAreaScope_plmn_area_based = NULL(name=u'plmn-area-based', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MDTAreaScope._cont = ASN1Dict([
        (u'cellbased', _MDTAreaScope_cellbased),
        (u'labased', _MDTAreaScope_labased),
        (u'rabased', _MDTAreaScope_rabased),
        (u'plmn-area-based', _MDTAreaScope_plmn_area_based),
        ])
    MDTAreaScope._ext = []
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdtActivation = ENUM(name=u'mdtActivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_mdtAreaScope = CHOICE(name=u'mdtAreaScope', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MDTAreaScope')))
    _MDT_Configuration_m1report = CHOICE(name=u'm1report', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'M1Report')), opt=True)
    _MDT_Configuration_m2report = CHOICE(name=u'm2report', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'M2Report')), opt=True)
    _MDT_Configuration_m3report = NULL(name=u'm3report', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MDT_Configuration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = u'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__criticality_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MDT_Configuration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__extensionValue_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MDT_Configuration_iE_Extensions__item__id),
        (u'criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        (u'extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        (u'mdtActivation', _MDT_Configuration_mdtActivation),
        (u'mdtAreaScope', _MDT_Configuration_mdtAreaScope),
        (u'm1report', _MDT_Configuration_m1report),
        (u'm2report', _MDT_Configuration_m2report),
        (u'm3report', _MDT_Configuration_m3report),
        (u'iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name=u'MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MDT-Report-Parameters >-----#
    MDT_Report_Parameters = SEQ(name=u'MDT-Report-Parameters', mode=MODE_TYPE)
    _MDT_Report_Parameters_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReportInterval')))
    _MDT_Report_Parameters_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReportAmount')))
    MDT_Report_Parameters._cont = ASN1Dict([
        (u'reportInterval', _MDT_Report_Parameters_reportInterval),
        (u'reportAmount', _MDT_Report_Parameters_reportAmount),
        ])
    MDT_Report_Parameters._ext = []
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = ENUM(name=u'MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._cont = ASN1Dict([(u'cpichEcNo', 0), (u'cpichRSCP', 1), (u'pathloss', 2)])
    MeasurementQuantity._ext = []
    
    #-----< MaxNrOfUL-DPCHs >-----#
    MaxNrOfUL_DPCHs = INT(name=u'MaxNrOfUL-DPCHs', mode=MODE_TYPE)
    MaxNrOfUL_DPCHs._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< MAC-c-sh-SDU-Length >-----#
    MAC_c_sh_SDU_Length = INT(name=u'MAC-c-sh-SDU-Length', mode=MODE_TYPE)
    MAC_c_sh_SDU_Length._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=None, er=[])
    
    #-----< MAC-c-sh-SDU-LengthList >-----#
    MAC_c_sh_SDU_LengthList = SEQ_OF(name=u'MAC-c-sh-SDU-LengthList', mode=MODE_TYPE)
    _MAC_c_sh_SDU_LengthList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-c-sh-SDU-Length')))
    MAC_c_sh_SDU_LengthList._cont = _MAC_c_sh_SDU_LengthList__item_
    MAC_c_sh_SDU_LengthList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MAC-DTX-Cycle-2ms >-----#
    MAC_DTX_Cycle_2ms = ENUM(name=u'MAC-DTX-Cycle-2ms', mode=MODE_TYPE)
    MAC_DTX_Cycle_2ms._cont = ASN1Dict([(u'v1', 0), (u'v4', 1), (u'v5', 2), (u'v8', 3), (u'v10', 4), (u'v16', 5), (u'v20', 6)])
    MAC_DTX_Cycle_2ms._ext = None
    
    #-----< MAC-DTX-Cycle-10ms >-----#
    MAC_DTX_Cycle_10ms = ENUM(name=u'MAC-DTX-Cycle-10ms', mode=MODE_TYPE)
    MAC_DTX_Cycle_10ms._cont = ASN1Dict([(u'v5', 0), (u'v10', 1), (u'v20', 2)])
    MAC_DTX_Cycle_10ms._ext = None
    
    #-----< MAC-ehs-Reset-Timer >-----#
    MAC_ehs_Reset_Timer = ENUM(name=u'MAC-ehs-Reset-Timer', mode=MODE_TYPE)
    MAC_ehs_Reset_Timer._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v3', 2), (u'v4', 3)])
    MAC_ehs_Reset_Timer._ext = []
    
    #-----< MAC-Inactivity-Threshold >-----#
    MAC_Inactivity_Threshold = ENUM(name=u'MAC-Inactivity-Threshold', mode=MODE_TYPE)
    MAC_Inactivity_Threshold._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v16', 4), (u'v32', 5), (u'v64', 6), (u'v128', 7), (u'v256', 8), (u'v512', 9), (u'infinity', 10)])
    MAC_Inactivity_Threshold._ext = None
    
    #-----< MACdPDU-Size >-----#
    MACdPDU_Size = INT(name=u'MACdPDU-Size', mode=MODE_TYPE)
    MACdPDU_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5000)], ev=[], er=[])
    
    #-----< MAC-PDU-SizeExtended >-----#
    MAC_PDU_SizeExtended = INT(name=u'MAC-PDU-SizeExtended', mode=MODE_TYPE)
    MAC_PDU_SizeExtended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1504)], ev=[1505], er=[])
    
    #-----< MACdPDU-Size-IndexList >-----#
    MACdPDU_Size_IndexList = SEQ_OF(name=u'MACdPDU-Size-IndexList', mode=MODE_TYPE)
    _MACdPDU_Size_IndexList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size-IndexItem')))
    MACdPDU_Size_IndexList._cont = _MACdPDU_Size_IndexList__item_
    MACdPDU_Size_IndexList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MACdPDU-Size-IndexItem >-----#
    MACdPDU_Size_IndexItem = SEQ(name=u'MACdPDU-Size-IndexItem', mode=MODE_TYPE)
    _MACdPDU_Size_IndexItem_sID = INT(name=u'sID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SID')))
    _MACdPDU_Size_IndexItem_mACdPDU_Size = INT(name=u'mACdPDU-Size', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size')))
    _MACdPDU_Size_IndexItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MACdPDU_Size_IndexItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id._const_tab = ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id._const_tab_at = None
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality._const_tab = ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue._const_tab = ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MACdPDU_Size_IndexItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MACdPDU_Size_IndexItem_iE_Extensions__item__id),
        (u'criticality', ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue),
        ])
    __MACdPDU_Size_IndexItem_iE_Extensions__item_._ext = None
    _MACdPDU_Size_IndexItem_iE_Extensions._cont = __MACdPDU_Size_IndexItem_iE_Extensions__item_
    _MACdPDU_Size_IndexItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MACdPDU_Size_IndexItem._cont = ASN1Dict([
        (u'sID', _MACdPDU_Size_IndexItem_sID),
        (u'mACdPDU-Size', _MACdPDU_Size_IndexItem_mACdPDU_Size),
        (u'iE-Extensions', _MACdPDU_Size_IndexItem_iE_Extensions),
        ])
    MACdPDU_Size_IndexItem._ext = []
    
    #-----< MACdPDU-Size-IndexItem-ExtIEs >-----#
    MACdPDU_Size_IndexItem_ExtIEs = CLASS(name=u'MACdPDU-Size-IndexItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MACdPDU_Size_IndexItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MACdPDU-Size-IndexList-to-Modify >-----#
    MACdPDU_Size_IndexList_to_Modify = SEQ_OF(name=u'MACdPDU-Size-IndexList-to-Modify', mode=MODE_TYPE)
    _MACdPDU_Size_IndexList_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size-IndexItem-to-Modify')))
    MACdPDU_Size_IndexList_to_Modify._cont = _MACdPDU_Size_IndexList_to_Modify__item_
    MACdPDU_Size_IndexList_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MACdPDU-Size-IndexItem-to-Modify >-----#
    MACdPDU_Size_IndexItem_to_Modify = SEQ(name=u'MACdPDU-Size-IndexItem-to-Modify', mode=MODE_TYPE)
    _MACdPDU_Size_IndexItem_to_Modify_sID = INT(name=u'sID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SID')))
    _MACdPDU_Size_IndexItem_to_Modify_mACdPDU_Size = INT(name=u'mACdPDU-Size', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size')))
    _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id._const_tab = ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_._ext = None
    _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions._cont = __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_
    _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MACdPDU_Size_IndexItem_to_Modify._cont = ASN1Dict([
        (u'sID', _MACdPDU_Size_IndexItem_to_Modify_sID),
        (u'mACdPDU-Size', _MACdPDU_Size_IndexItem_to_Modify_mACdPDU_Size),
        (u'iE-Extensions', _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions),
        ])
    MACdPDU_Size_IndexItem_to_Modify._ext = []
    
    #-----< MACdPDU-Size-IndexItem-to-Modify-ExtIEs >-----#
    MACdPDU_Size_IndexItem_to_Modify_ExtIEs = CLASS(name=u'MACdPDU-Size-IndexItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MACdPDU_Size_IndexItem_to_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MACes-Guaranteed-Bitrate >-----#
    MACes_Guaranteed_Bitrate = INT(name=u'MACes-Guaranteed-Bitrate', mode=MODE_TYPE)
    MACes_Guaranteed_Bitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[ASN1RangeInt(lb=16777216, ub=256000000)])
    
    #-----< MACes-Maximum-Bitrate-LCR >-----#
    MACes_Maximum_Bitrate_LCR = INT(name=u'MACes-Maximum-Bitrate-LCR', mode=MODE_TYPE)
    MACes_Maximum_Bitrate_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256000000)], ev=[], er=[])
    
    #-----< MACeReset-Indicator >-----#
    MACeReset_Indicator = ENUM(name=u'MACeReset-Indicator', mode=MODE_TYPE)
    MACeReset_Indicator._cont = ASN1Dict([(u'mACeReset', 0)])
    MACeReset_Indicator._ext = None
    
    #-----< MAChsGuaranteedBitRate >-----#
    MAChsGuaranteedBitRate = INT(name=u'MAChsGuaranteedBitRate', mode=MODE_TYPE)
    MAChsGuaranteedBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=[], er=[ASN1RangeInt(lb=16777216, ub=1000000000)])
    
    #-----< MAChsReorderingBufferSize-for-RLC-UM >-----#
    MAChsReorderingBufferSize_for_RLC_UM = INT(name=u'MAChsReorderingBufferSize-for-RLC-UM', mode=MODE_TYPE)
    MAChsReorderingBufferSize_for_RLC_UM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=300)], ev=[], er=[])
    
    #-----< MAC-hsWindowSize >-----#
    MAC_hsWindowSize = ENUM(name=u'MAC-hsWindowSize', mode=MODE_TYPE)
    MAC_hsWindowSize._cont = ASN1Dict([(u'v4', 0), (u'v6', 1), (u'v8', 2), (u'v12', 3), (u'v16', 4), (u'v24', 5), (u'v32', 6), (u'v64', 7), (u'v128', 8), (u'v256', 9)])
    MAC_hsWindowSize._ext = [u'v64', u'v128', u'v256']
    
    #-----< MAChsResetScheme >-----#
    MAChsResetScheme = ENUM(name=u'MAChsResetScheme', mode=MODE_TYPE)
    MAChsResetScheme._cont = ASN1Dict([(u'always', 0), (u'interNodeB-change', 1)])
    MAChsResetScheme._ext = None
    
    #-----< MaximumAllowedULTxPower >-----#
    MaximumAllowedULTxPower = INT(name=u'MaximumAllowedULTxPower', mode=MODE_TYPE)
    MaximumAllowedULTxPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=33)], ev=None, er=[])
    
    #-----< Max-Bits-MACe-PDU-non-scheduled >-----#
    Max_Bits_MACe_PDU_non_scheduled = INT(name=u'Max-Bits-MACe-PDU-non-scheduled', mode=MODE_TYPE)
    Max_Bits_MACe_PDU_non_scheduled._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=19982)], ev=None, er=[])
    
    #-----< MaxNrDLPhysicalchannels >-----#
    MaxNrDLPhysicalchannels = INT(name=u'MaxNrDLPhysicalchannels', mode=MODE_TYPE)
    MaxNrDLPhysicalchannels._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=224)], ev=None, er=[])
    
    #-----< MaxNrDLPhysicalchannels768 >-----#
    MaxNrDLPhysicalchannels768 = INT(name=u'MaxNrDLPhysicalchannels768', mode=MODE_TYPE)
    MaxNrDLPhysicalchannels768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=448)], ev=None, er=[])
    
    #-----< MaxNrDLPhysicalchannelsTS >-----#
    MaxNrDLPhysicalchannelsTS = INT(name=u'MaxNrDLPhysicalchannelsTS', mode=MODE_TYPE)
    MaxNrDLPhysicalchannelsTS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MaxNrDLPhysicalchannelsTS768 >-----#
    MaxNrDLPhysicalchannelsTS768 = INT(name=u'MaxNrDLPhysicalchannelsTS768', mode=MODE_TYPE)
    MaxNrDLPhysicalchannelsTS768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< MaxNr-Retransmissions-EDCH >-----#
    MaxNr_Retransmissions_EDCH = INT(name=u'MaxNr-Retransmissions-EDCH', mode=MODE_TYPE)
    MaxNr_Retransmissions_EDCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< MaxNrTimeslots >-----#
    MaxNrTimeslots = INT(name=u'MaxNrTimeslots', mode=MODE_TYPE)
    MaxNrTimeslots._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< MaxNrULPhysicalchannels >-----#
    MaxNrULPhysicalchannels = INT(name=u'MaxNrULPhysicalchannels', mode=MODE_TYPE)
    MaxNrULPhysicalchannels._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Max-Set-E-DPDCHs >-----#
    Max_Set_E_DPDCHs = ENUM(name=u'Max-Set-E-DPDCHs', mode=MODE_TYPE)
    Max_Set_E_DPDCHs._cont = ASN1Dict([(u'vN256', 0), (u'vN128', 1), (u'vN64', 2), (u'vN32', 3), (u'vN16', 4), (u'vN8', 5), (u'vN4', 6), (u'v2xN4', 7), (u'v2xN2', 8), (u'v2xN2plus2xN4', 9), (u'v2xM2plus2xM4', 10)])
    Max_Set_E_DPDCHs._ext = [u'v2xM2plus2xM4']
    
    #-----< Max-UE-DTX-Cycle >-----#
    Max_UE_DTX_Cycle = ENUM(name=u'Max-UE-DTX-Cycle', mode=MODE_TYPE)
    Max_UE_DTX_Cycle._cont = ASN1Dict([(u'v5', 0), (u'v10', 1), (u'v20', 2), (u'v40', 3), (u'v64', 4), (u'v80', 5), (u'v128', 6), (u'v160', 7), (u'v256', 8), (u'v320', 9), (u'v512', 10), (u'v640', 11), (u'v1024', 12), (u'v1280', 13)])
    Max_UE_DTX_Cycle._ext = [u'v256', u'v320', u'v512', u'v640', u'v1024', u'v1280']
    
    #-----< MBMS-Bearer-Service-Full-Address >-----#
    MBMS_Bearer_Service_Full_Address = SEQ(name=u'MBMS-Bearer-Service-Full-Address', mode=MODE_TYPE)
    _MBMS_Bearer_Service_Full_Address_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AccessPointName')))
    _MBMS_Bearer_Service_Full_Address_iPMulticastAddress = OCT_STR(name=u'iPMulticastAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPMulticastAddress')))
    _MBMS_Bearer_Service_Full_Address_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_Service_Full_Address_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id_tab
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_Service_Full_Address_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_Service_Full_Address_iE_Extensions__item_._ext = None
    _MBMS_Bearer_Service_Full_Address_iE_Extensions._cont = __MBMS_Bearer_Service_Full_Address_iE_Extensions__item_
    _MBMS_Bearer_Service_Full_Address_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_Service_Full_Address._cont = ASN1Dict([
        (u'accessPointName', _MBMS_Bearer_Service_Full_Address_accessPointName),
        (u'iPMulticastAddress', _MBMS_Bearer_Service_Full_Address_iPMulticastAddress),
        (u'iE-Extensions', _MBMS_Bearer_Service_Full_Address_iE_Extensions),
        ])
    MBMS_Bearer_Service_Full_Address._ext = []
    
    #-----< MBMS-Bearer-Service-Full-Address-ExtIEs >-----#
    MBMS_Bearer_Service_Full_Address_ExtIEs = CLASS(name=u'MBMS-Bearer-Service-Full-Address-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_Service_Full_Address_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-List >-----#
    MBMS_Bearer_Service_List = SEQ_OF(name=u'MBMS-Bearer-Service-List', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    MBMS_Bearer_Service_List._cont = _MBMS_Bearer_Service_List__item_
    MBMS_Bearer_Service_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MBMS-Bearer-ServiceItemFDD >-----#
    MBMS_Bearer_ServiceItemFDD = SEQ(name=u'MBMS-Bearer-ServiceItemFDD', mode=MODE_TYPE)
    _MBMS_Bearer_ServiceItemFDD_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_ServiceItemFDD_transmissionMode = ENUM(name=u'transmissionMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionMode')))
    _MBMS_Bearer_ServiceItemFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_ServiceItemFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id_tab
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_ServiceItemFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_ServiceItemFDD_iE_Extensions__item_._ext = None
    _MBMS_Bearer_ServiceItemFDD_iE_Extensions._cont = __MBMS_Bearer_ServiceItemFDD_iE_Extensions__item_
    _MBMS_Bearer_ServiceItemFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_ServiceItemFDD._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_ServiceItemFDD_tmgi),
        (u'transmissionMode', _MBMS_Bearer_ServiceItemFDD_transmissionMode),
        (u'iE-Extensions', _MBMS_Bearer_ServiceItemFDD_iE_Extensions),
        ])
    MBMS_Bearer_ServiceItemFDD._ext = []
    
    #-----< MBMS-Bearer-ServiceItemFDD-ExtIEs >-----#
    MBMS_Bearer_ServiceItemFDD_ExtIEs = CLASS(name=u'MBMS-Bearer-ServiceItemFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_ServiceItemFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-ServiceItemFDD-PFL >-----#
    MBMS_Bearer_ServiceItemFDD_PFL = SEQ(name=u'MBMS-Bearer-ServiceItemFDD-PFL', mode=MODE_TYPE)
    _MBMS_Bearer_ServiceItemFDD_PFL_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_ServiceItemFDD_PFL_transmissionMode = ENUM(name=u'transmissionMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionMode')), opt=True)
    _MBMS_Bearer_ServiceItemFDD_PFL_preferredFrequencyLayer = INT(name=u'preferredFrequencyLayer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id_tab
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item_._ext = None
    _MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions._cont = __MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item_
    _MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_ServiceItemFDD_PFL._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_ServiceItemFDD_PFL_tmgi),
        (u'transmissionMode', _MBMS_Bearer_ServiceItemFDD_PFL_transmissionMode),
        (u'preferredFrequencyLayer', _MBMS_Bearer_ServiceItemFDD_PFL_preferredFrequencyLayer),
        (u'iE-Extensions', _MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions),
        ])
    MBMS_Bearer_ServiceItemFDD_PFL._ext = []
    
    #-----< MBMS-Bearer-ServiceItemFDD-PFL-ExtIEs >-----#
    MBMS_Bearer_ServiceItemFDD_PFL_ExtIEs = CLASS(name=u'MBMS-Bearer-ServiceItemFDD-PFL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_ServiceItemFDD_PFL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-ServiceItemTDD >-----#
    MBMS_Bearer_ServiceItemTDD = SEQ(name=u'MBMS-Bearer-ServiceItemTDD', mode=MODE_TYPE)
    _MBMS_Bearer_ServiceItemTDD_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_ServiceItemTDD_transmissionMode = ENUM(name=u'transmissionMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionMode')))
    _MBMS_Bearer_ServiceItemTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_ServiceItemTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id_tab
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_ServiceItemTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_ServiceItemTDD_iE_Extensions__item_._ext = None
    _MBMS_Bearer_ServiceItemTDD_iE_Extensions._cont = __MBMS_Bearer_ServiceItemTDD_iE_Extensions__item_
    _MBMS_Bearer_ServiceItemTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_ServiceItemTDD._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_ServiceItemTDD_tmgi),
        (u'transmissionMode', _MBMS_Bearer_ServiceItemTDD_transmissionMode),
        (u'iE-Extensions', _MBMS_Bearer_ServiceItemTDD_iE_Extensions),
        ])
    MBMS_Bearer_ServiceItemTDD._ext = []
    
    #-----< MBMS-Bearer-ServiceItemTDD-ExtIEs >-----#
    MBMS_Bearer_ServiceItemTDD_ExtIEs = CLASS(name=u'MBMS-Bearer-ServiceItemTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_ServiceItemTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-ServiceItemTDD-PFL >-----#
    MBMS_Bearer_ServiceItemTDD_PFL = SEQ(name=u'MBMS-Bearer-ServiceItemTDD-PFL', mode=MODE_TYPE)
    _MBMS_Bearer_ServiceItemTDD_PFL_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_ServiceItemTDD_PFL_transmissionMode = ENUM(name=u'transmissionMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionMode')), opt=True)
    _MBMS_Bearer_ServiceItemTDD_PFL_preferredFrequencyLayer = INT(name=u'preferredFrequencyLayer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id_tab
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item_._ext = None
    _MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions._cont = __MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item_
    _MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_ServiceItemTDD_PFL._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_ServiceItemTDD_PFL_tmgi),
        (u'transmissionMode', _MBMS_Bearer_ServiceItemTDD_PFL_transmissionMode),
        (u'preferredFrequencyLayer', _MBMS_Bearer_ServiceItemTDD_PFL_preferredFrequencyLayer),
        (u'iE-Extensions', _MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions),
        ])
    MBMS_Bearer_ServiceItemTDD_PFL._ext = []
    
    #-----< MBMS-Bearer-ServiceItemTDD-PFL-ExtIEs >-----#
    MBMS_Bearer_ServiceItemTDD_PFL_ExtIEs = CLASS(name=u'MBMS-Bearer-ServiceItemTDD-PFL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_ServiceItemTDD_PFL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSChannelTypeInfo >-----#
    MBMSChannelTypeInfo = SEQ(name=u'MBMSChannelTypeInfo', mode=MODE_TYPE)
    _MBMSChannelTypeInfo_tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMSChannelTypeInfo_pTM_Cell_List = SEQ_OF(name=u'pTM-Cell-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PTMCellList')), opt=True)
    _MBMSChannelTypeInfo_pTP_Cell_List = SEQ_OF(name=u'pTP-Cell-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PTPCellList')), opt=True)
    _MBMSChannelTypeInfo_not_Provided_Cell_List = SEQ_OF(name=u'not-Provided-Cell-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NotProvidedCellList')), opt=True)
    _MBMSChannelTypeInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSChannelTypeInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMSChannelTypeInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSChannelTypeInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSChannelTypeInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSChannelTypeInfo_iE_Extensions__item__id._const_tab = ____MBMSChannelTypeInfo_iE_Extensions__item__id_tab
    ___MBMSChannelTypeInfo_iE_Extensions__item__id._const_tab_at = None
    ___MBMSChannelTypeInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMSChannelTypeInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSChannelTypeInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSChannelTypeInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSChannelTypeInfo_iE_Extensions__item__criticality._const_tab = ____MBMSChannelTypeInfo_iE_Extensions__item__criticality_tab
    ___MBMSChannelTypeInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSChannelTypeInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSChannelTypeInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSChannelTypeInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSChannelTypeInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSChannelTypeInfo_iE_Extensions__item__extensionValue._const_tab = ____MBMSChannelTypeInfo_iE_Extensions__item__extensionValue_tab
    ___MBMSChannelTypeInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSChannelTypeInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSChannelTypeInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSChannelTypeInfo_iE_Extensions__item__id),
        (u'criticality', ___MBMSChannelTypeInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMSChannelTypeInfo_iE_Extensions__item__extensionValue),
        ])
    __MBMSChannelTypeInfo_iE_Extensions__item_._ext = None
    _MBMSChannelTypeInfo_iE_Extensions._cont = __MBMSChannelTypeInfo_iE_Extensions__item_
    _MBMSChannelTypeInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSChannelTypeInfo._cont = ASN1Dict([
        (u'tMGI', _MBMSChannelTypeInfo_tMGI),
        (u'pTM-Cell-List', _MBMSChannelTypeInfo_pTM_Cell_List),
        (u'pTP-Cell-List', _MBMSChannelTypeInfo_pTP_Cell_List),
        (u'not-Provided-Cell-List', _MBMSChannelTypeInfo_not_Provided_Cell_List),
        (u'iE-Extensions', _MBMSChannelTypeInfo_iE_Extensions),
        ])
    MBMSChannelTypeInfo._ext = []
    
    #-----< MBMSChannelTypeInfo-ExtIEs >-----#
    MBMSChannelTypeInfo_ExtIEs = CLASS(name=u'MBMSChannelTypeInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMSChannelTypeInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSChannelTypeCellList >-----#
    MBMSChannelTypeCellList = SEQ(name=u'MBMSChannelTypeCellList', mode=MODE_TYPE)
    _MBMSChannelTypeCellList_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMSChannelTypeCellList_affectedUEInformationForMBMS = SEQ_OF(name=u'affectedUEInformationForMBMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AffectedUEInformationForMBMS')), opt=True)
    _MBMSChannelTypeCellList_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSChannelTypeCellList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMSChannelTypeCellList_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSChannelTypeCellList_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____MBMSChannelTypeCellList_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedAffectedUEInformationForMBMS')))
    ____MBMSChannelTypeCellList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 915), (u'criticality', u'ignore'), (u'Extension', _____MBMSChannelTypeCellList_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSChannelTypeCellList_iE_Extensions__item__id._const_tab = ____MBMSChannelTypeCellList_iE_Extensions__item__id_tab
    ___MBMSChannelTypeCellList_iE_Extensions__item__id._const_tab_at = None
    ___MBMSChannelTypeCellList_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMSChannelTypeCellList_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MBMSChannelTypeCellList_iE_Extensions__item__criticality._const_tab = ____MBMSChannelTypeCellList_iE_Extensions__item__id_tab
    ___MBMSChannelTypeCellList_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSChannelTypeCellList_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSChannelTypeCellList_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MBMSChannelTypeCellList_iE_Extensions__item__extensionValue._const_tab = ____MBMSChannelTypeCellList_iE_Extensions__item__id_tab
    ___MBMSChannelTypeCellList_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSChannelTypeCellList_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSChannelTypeCellList_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSChannelTypeCellList_iE_Extensions__item__id),
        (u'criticality', ___MBMSChannelTypeCellList_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMSChannelTypeCellList_iE_Extensions__item__extensionValue),
        ])
    __MBMSChannelTypeCellList_iE_Extensions__item_._ext = None
    _MBMSChannelTypeCellList_iE_Extensions._cont = __MBMSChannelTypeCellList_iE_Extensions__item_
    _MBMSChannelTypeCellList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSChannelTypeCellList._cont = ASN1Dict([
        (u'c-ID', _MBMSChannelTypeCellList_c_ID),
        (u'affectedUEInformationForMBMS', _MBMSChannelTypeCellList_affectedUEInformationForMBMS),
        (u'iE-Extensions', _MBMSChannelTypeCellList_iE_Extensions),
        ])
    MBMSChannelTypeCellList._ext = []
    
    #-----< MBMSChannelTypeCellList-ExtIEs >-----#
    MBMSChannelTypeCellList_ExtIEs = CLASS(name=u'MBMSChannelTypeCellList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _MBMSChannelTypeCellList_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedAffectedUEInformationForMBMS')))
    MBMSChannelTypeCellList_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 915), (u'criticality', u'ignore'), (u'Extension', _MBMSChannelTypeCellList_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSPreferredFreqLayerInfo >-----#
    MBMSPreferredFreqLayerInfo = SEQ(name=u'MBMSPreferredFreqLayerInfo', mode=MODE_TYPE)
    _MBMSPreferredFreqLayerInfo_tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMSPreferredFreqLayerInfo_preferredFrequencyLayerInfo = SEQ(name=u'preferredFrequencyLayerInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PreferredFrequencyLayerInfo')))
    _MBMSPreferredFreqLayerInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSPreferredFreqLayerInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__id._const_tab = ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__id_tab
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__id._const_tab_at = None
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality._const_tab = ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality_tab
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue._const_tab = ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue_tab
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSPreferredFreqLayerInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__id),
        (u'criticality', ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue),
        ])
    __MBMSPreferredFreqLayerInfo_iE_Extensions__item_._ext = None
    _MBMSPreferredFreqLayerInfo_iE_Extensions._cont = __MBMSPreferredFreqLayerInfo_iE_Extensions__item_
    _MBMSPreferredFreqLayerInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSPreferredFreqLayerInfo._cont = ASN1Dict([
        (u'tMGI', _MBMSPreferredFreqLayerInfo_tMGI),
        (u'preferredFrequencyLayerInfo', _MBMSPreferredFreqLayerInfo_preferredFrequencyLayerInfo),
        (u'iE-Extensions', _MBMSPreferredFreqLayerInfo_iE_Extensions),
        ])
    MBMSPreferredFreqLayerInfo._ext = []
    
    #-----< MBMSPreferredFreqLayerInfo-ExtIEs >-----#
    MBMSPreferredFreqLayerInfo_ExtIEs = CLASS(name=u'MBMSPreferredFreqLayerInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMSPreferredFreqLayerInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Neighbouring-Cell-Information >-----#
    MBMS_Neighbouring_Cell_Information = SEQ(name=u'MBMS-Neighbouring-Cell-Information', mode=MODE_TYPE)
    _MBMS_Neighbouring_Cell_Information_mBMS_ConcatenatedServiceList = SEQ_OF(name=u'mBMS-ConcatenatedServiceList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-ConcatenatedServiceList')))
    _MBMS_Neighbouring_Cell_Information_l3_Information_1 = BIT_STR(name=u'l3-Information-1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')), opt=True)
    _MBMS_Neighbouring_Cell_Information_l3_Information_2 = BIT_STR(name=u'l3-Information-2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')), opt=True)
    _MBMS_Neighbouring_Cell_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Neighbouring_Cell_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id._const_tab = ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id_tab
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality._const_tab = ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality_tab
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue_tab
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Neighbouring_Cell_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Neighbouring_Cell_Information_iE_Extensions__item_._ext = None
    _MBMS_Neighbouring_Cell_Information_iE_Extensions._cont = __MBMS_Neighbouring_Cell_Information_iE_Extensions__item_
    _MBMS_Neighbouring_Cell_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Neighbouring_Cell_Information._cont = ASN1Dict([
        (u'mBMS-ConcatenatedServiceList', _MBMS_Neighbouring_Cell_Information_mBMS_ConcatenatedServiceList),
        (u'l3-Information-1', _MBMS_Neighbouring_Cell_Information_l3_Information_1),
        (u'l3-Information-2', _MBMS_Neighbouring_Cell_Information_l3_Information_2),
        (u'iE-Extensions', _MBMS_Neighbouring_Cell_Information_iE_Extensions),
        ])
    MBMS_Neighbouring_Cell_Information._ext = []
    
    #-----< MBMS-Neighbouring-Cell-Information-ExtIEs >-----#
    MBMS_Neighbouring_Cell_Information_ExtIEs = CLASS(name=u'MBMS-Neighbouring-Cell-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Neighbouring_Cell_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-ConcatenatedServiceList >-----#
    MBMS_ConcatenatedServiceList = SEQ_OF(name=u'MBMS-ConcatenatedServiceList', mode=MODE_TYPE)
    _MBMS_ConcatenatedServiceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    MBMS_ConcatenatedServiceList._cont = _MBMS_ConcatenatedServiceList__item_
    MBMS_ConcatenatedServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=96)], ev=None, er=[])
    
    #-----< MBMS-RLC-Sequence-Number-Information >-----#
    MBMS_RLC_Sequence_Number_Information = SEQ_OF(name=u'MBMS-RLC-Sequence-Number-Information', mode=MODE_TYPE)
    _MBMS_RLC_Sequence_Number_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-RLC-Sequence-Number-Information-List')))
    MBMS_RLC_Sequence_Number_Information._cont = _MBMS_RLC_Sequence_Number_Information__item_
    MBMS_RLC_Sequence_Number_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< MBMS-RLC-Sequence-Number-Information-List >-----#
    MBMS_RLC_Sequence_Number_Information_List = SEQ(name=u'MBMS-RLC-Sequence-Number-Information-List', mode=MODE_TYPE)
    _MBMS_RLC_Sequence_Number_Information_List_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMS_RLC_Sequence_Number_Information_List_mBMS_Bearer_Service_List_RLC = SEQ_OF(name=u'mBMS-Bearer-Service-List-RLC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List-RLC')))
    _MBMS_RLC_Sequence_Number_Information_List_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id._const_tab = ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id_tab
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality._const_tab = ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality_tab
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue._const_tab = ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue_tab
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id),
        (u'criticality', ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue),
        ])
    __MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item_._ext = None
    _MBMS_RLC_Sequence_Number_Information_List_iE_Extensions._cont = __MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item_
    _MBMS_RLC_Sequence_Number_Information_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_RLC_Sequence_Number_Information_List._cont = ASN1Dict([
        (u'c-ID', _MBMS_RLC_Sequence_Number_Information_List_c_ID),
        (u'mBMS-Bearer-Service-List-RLC', _MBMS_RLC_Sequence_Number_Information_List_mBMS_Bearer_Service_List_RLC),
        (u'iE-Extensions', _MBMS_RLC_Sequence_Number_Information_List_iE_Extensions),
        ])
    MBMS_RLC_Sequence_Number_Information_List._ext = []
    
    #-----< MBMS-RLC-Sequence-Number-Information-List-ExtIEs >-----#
    MBMS_RLC_Sequence_Number_Information_List_ExtIEs = CLASS(name=u'MBMS-RLC-Sequence-Number-Information-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_RLC_Sequence_Number_Information_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-List-RLC >-----#
    MBMS_Bearer_Service_List_RLC = SEQ_OF(name=u'MBMS-Bearer-Service-List-RLC', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List_RLC__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List-RLCinfo')))
    MBMS_Bearer_Service_List_RLC._cont = _MBMS_Bearer_Service_List_RLC__item_
    MBMS_Bearer_Service_List_RLC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MBMS-Bearer-Service-List-RLCinfo >-----#
    MBMS_Bearer_Service_List_RLCinfo = SEQ(name=u'MBMS-Bearer-Service-List-RLCinfo', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List_RLCinfo_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_Service_List_RLCinfo_time_Stamp = INT(name=u'time-Stamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Time-Stamp')))
    _MBMS_Bearer_Service_List_RLCinfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id_tab
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item_._ext = None
    _MBMS_Bearer_Service_List_RLCinfo_iE_Extensions._cont = __MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item_
    _MBMS_Bearer_Service_List_RLCinfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_Service_List_RLCinfo._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_Service_List_RLCinfo_tmgi),
        (u'time-Stamp', _MBMS_Bearer_Service_List_RLCinfo_time_Stamp),
        (u'iE-Extensions', _MBMS_Bearer_Service_List_RLCinfo_iE_Extensions),
        ])
    MBMS_Bearer_Service_List_RLCinfo._ext = []
    
    #-----< MBMS-Bearer-Service-List-RLCinfo-ExtIEs >-----#
    MBMS_Bearer_Service_List_RLCinfo_ExtIEs = CLASS(name=u'MBMS-Bearer-Service-List-RLCinfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_Service_List_RLCinfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSFN-Cluster-Identity >-----#
    MBSFN_Cluster_Identity = INT(name=u'MBSFN-Cluster-Identity', mode=MODE_TYPE)
    MBSFN_Cluster_Identity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< MCCH-Message-List >-----#
    MCCH_Message_List = SEQ_OF(name=u'MCCH-Message-List', mode=MODE_TYPE)
    _MCCH_Message_List__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    MCCH_Message_List._cont = _MCCH_Message_List__item_
    MCCH_Message_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< MCCH-Configuration-Info >-----#
    MCCH_Configuration_Info = SEQ(name=u'MCCH-Configuration-Info', mode=MODE_TYPE)
    _MCCH_Configuration_Info_secondaryCCPCHSystemInformationMBMS = BIT_STR(name=u'secondaryCCPCHSystemInformationMBMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-System-Information-MBMS')))
    _MCCH_Configuration_Info_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MCCH_Configuration_Info_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MCCH_Configuration_Info_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MCCH_Configuration_Info_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MCCH_Configuration_Info_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCCH_Configuration_Info_ie_Extensions__item__id._const_tab = ____MCCH_Configuration_Info_ie_Extensions__item__id_tab
    ___MCCH_Configuration_Info_ie_Extensions__item__id._const_tab_at = None
    ___MCCH_Configuration_Info_ie_Extensions__item__id._const_tab_id = u'id'
    ___MCCH_Configuration_Info_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MCCH_Configuration_Info_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MCCH_Configuration_Info_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCCH_Configuration_Info_ie_Extensions__item__criticality._const_tab = ____MCCH_Configuration_Info_ie_Extensions__item__criticality_tab
    ___MCCH_Configuration_Info_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MCCH_Configuration_Info_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MCCH_Configuration_Info_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MCCH_Configuration_Info_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MCCH_Configuration_Info_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MCCH_Configuration_Info_ie_Extensions__item__extensionValue._const_tab = ____MCCH_Configuration_Info_ie_Extensions__item__extensionValue_tab
    ___MCCH_Configuration_Info_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MCCH_Configuration_Info_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MCCH_Configuration_Info_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MCCH_Configuration_Info_ie_Extensions__item__id),
        (u'criticality', ___MCCH_Configuration_Info_ie_Extensions__item__criticality),
        (u'extensionValue', ___MCCH_Configuration_Info_ie_Extensions__item__extensionValue),
        ])
    __MCCH_Configuration_Info_ie_Extensions__item_._ext = None
    _MCCH_Configuration_Info_ie_Extensions._cont = __MCCH_Configuration_Info_ie_Extensions__item_
    _MCCH_Configuration_Info_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MCCH_Configuration_Info._cont = ASN1Dict([
        (u'secondaryCCPCHSystemInformationMBMS', _MCCH_Configuration_Info_secondaryCCPCHSystemInformationMBMS),
        (u'ie-Extensions', _MCCH_Configuration_Info_ie_Extensions),
        ])
    MCCH_Configuration_Info._ext = []
    
    #-----< MCCH-Configuration-Info-ExtIEs >-----#
    MCCH_Configuration_Info_ExtIEs = CLASS(name=u'MCCH-Configuration-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MCCH_Configuration_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-System-Information-MBMS >-----#
    Secondary_CCPCH_System_Information_MBMS = BIT_STR(name=u'Secondary-CCPCH-System-Information-MBMS', mode=MODE_TYPE)
    
    #-----< MBSFN-Scheduling-Transmission-Time-Interval-Info-List >-----#
    MBSFN_Scheduling_Transmission_Time_Interval_Info_List = SEQ_OF(name=u'MBSFN-Scheduling-Transmission-Time-Interval-Info-List', mode=MODE_TYPE)
    _MBSFN_Scheduling_Transmission_Time_Interval_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBSFN-Scheduling-Transmission-Time-Interval-Item')))
    MBSFN_Scheduling_Transmission_Time_Interval_Info_List._cont = _MBSFN_Scheduling_Transmission_Time_Interval_Info_List__item_
    MBSFN_Scheduling_Transmission_Time_Interval_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBSFN-Scheduling-Transmission-Time-Interval-Item >-----#
    MBSFN_Scheduling_Transmission_Time_Interval_Item = SEQ(name=u'MBSFN-Scheduling-Transmission-Time-Interval-Item', mode=MODE_TYPE)
    _MBSFN_Scheduling_Transmission_Time_Interval_Item_tMGI = SEQ(name=u'tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBSFN_Scheduling_Transmission_Time_Interval_Item_mbsfnSchedulingTransmissionTimeInterval = ENUM(name=u'mbsfnSchedulingTransmissionTimeInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MbsfnSchedulingTransmissionTimeInterval')))
    _MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id._const_tab = ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id_tab
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id._const_tab_at = None
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id._const_tab_id = u'id'
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality._const_tab = ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality_tab
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue._const_tab = ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue_tab
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id),
        (u'criticality', ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality),
        (u'extensionValue', ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue),
        ])
    __MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item_._ext = None
    _MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions._cont = __MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item_
    _MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSFN_Scheduling_Transmission_Time_Interval_Item._cont = ASN1Dict([
        (u'tMGI', _MBSFN_Scheduling_Transmission_Time_Interval_Item_tMGI),
        (u'mbsfnSchedulingTransmissionTimeInterval', _MBSFN_Scheduling_Transmission_Time_Interval_Item_mbsfnSchedulingTransmissionTimeInterval),
        (u'ie-Extensions', _MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions),
        ])
    MBSFN_Scheduling_Transmission_Time_Interval_Item._ext = []
    
    #-----< MBSFN-Scheduling-Transmission-Time-Interval-Item-ExtIEs >-----#
    MBSFN_Scheduling_Transmission_Time_Interval_Item_ExtIEs = CLASS(name=u'MBSFN-Scheduling-Transmission-Time-Interval-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBSFN_Scheduling_Transmission_Time_Interval_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MbsfnSchedulingTransmissionTimeInterval >-----#
    MbsfnSchedulingTransmissionTimeInterval = ENUM(name=u'MbsfnSchedulingTransmissionTimeInterval', mode=MODE_TYPE)
    MbsfnSchedulingTransmissionTimeInterval._cont = ASN1Dict([(u'tti4', 0), (u'tti8', 1), (u'tti16', 2), (u'tti32', 3), (u'tti64', 4), (u'tti128', 5), (u'tti256', 6)])
    MbsfnSchedulingTransmissionTimeInterval._ext = None
    
    #-----< MeasurementFilterCoefficient >-----#
    MeasurementFilterCoefficient = ENUM(name=u'MeasurementFilterCoefficient', mode=MODE_TYPE)
    MeasurementFilterCoefficient._cont = ASN1Dict([(u'k0', 0), (u'k1', 1), (u'k2', 2), (u'k3', 3), (u'k4', 4), (u'k5', 5), (u'k6', 6), (u'k7', 7), (u'k8', 8), (u'k9', 9), (u'k11', 10), (u'k13', 11), (u'k15', 12), (u'k17', 13), (u'k19', 14)])
    MeasurementFilterCoefficient._ext = []
    
    #-----< MeasurementID >-----#
    MeasurementID = INT(name=u'MeasurementID', mode=MODE_TYPE)
    MeasurementID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< Measurement-Power-Offset >-----#
    Measurement_Power_Offset = INT(name=u'Measurement-Power-Offset', mode=MODE_TYPE)
    Measurement_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=26)], ev=None, er=[])
    
    #-----< MinimumSpreadingFactor >-----#
    MinimumSpreadingFactor = INT(name=u'MinimumSpreadingFactor', mode=MODE_TYPE)
    MinimumSpreadingFactor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MinimumSpreadingFactor768 >-----#
    MinimumSpreadingFactor768 = INT(name=u'MinimumSpreadingFactor768', mode=MODE_TYPE)
    MinimumSpreadingFactor768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Minimum-TEBS-threshold >-----#
    Minimum_TEBS_threshold = ENUM(name=u'Minimum-TEBS-threshold', mode=MODE_TYPE)
    Minimum_TEBS_threshold._cont = ASN1Dict([(u'v2', 0), (u'v4', 1), (u'v8', 2), (u'v16', 3), (u'v32', 4), (u'v64', 5), (u'v128', 6), (u'v256', 7), (u'v512', 8), (u'v1024', 9), (u'v2048', 10), (u'v4096', 11), (u'v8192', 12), (u'v16384', 13), (u'v32768', 14), (u'v65536', 15), (u'v131072', 16), (u'v262144', 17), (u'v524288', 18), (u'v1048576', 19)])
    Minimum_TEBS_threshold._ext = []
    
    #-----< MultipleURAsIndicator >-----#
    MultipleURAsIndicator = ENUM(name=u'MultipleURAsIndicator', mode=MODE_TYPE)
    MultipleURAsIndicator._cont = ASN1Dict([(u'multiple-URAs-exist', 0), (u'single-URA-exists', 1)])
    MultipleURAsIndicator._ext = None
    
    #-----< MaxAdjustmentStep >-----#
    MaxAdjustmentStep = INT(name=u'MaxAdjustmentStep', mode=MODE_TYPE)
    MaxAdjustmentStep._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< MeasurementChangeTime >-----#
    MeasurementChangeTime = INT(name=u'MeasurementChangeTime', mode=MODE_TYPE)
    MeasurementChangeTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6000)], ev=[], er=[])
    
    #-----< MeasurementHysteresisTime >-----#
    MeasurementHysteresisTime = INT(name=u'MeasurementHysteresisTime', mode=MODE_TYPE)
    MeasurementHysteresisTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6000)], ev=[], er=[])
    
    #-----< MeasurementIncreaseDecreaseThreshold >-----#
    MeasurementIncreaseDecreaseThreshold = CHOICE(name=u'MeasurementIncreaseDecreaseThreshold', mode=MODE_TYPE)
    _MeasurementIncreaseDecreaseThreshold_sir = INT(name=u'sir', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SIR-Value-IncrDecrThres')))
    _MeasurementIncreaseDecreaseThreshold_sir_error = INT(name=u'sir-error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SIR-Error-Value-IncrDecrThres')))
    _MeasurementIncreaseDecreaseThreshold_transmitted_code_power = INT(name=u'transmitted-code-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Code-Power-Value-IncrDecrThres')))
    _MeasurementIncreaseDecreaseThreshold_rscp = INT(name=u'rscp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RSCP-Value-IncrDecrThres')))
    _MeasurementIncreaseDecreaseThreshold_round_trip_time = INT(name=u'round-trip-time', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Round-Trip-Time-IncrDecrThres')))
    _MeasurementIncreaseDecreaseThreshold_extension_MeasurementIncreaseDecreaseThreshold = SEQ(name=u'extension-MeasurementIncreaseDecreaseThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-MeasurementIncreaseDecreaseThreshold')))
    MeasurementIncreaseDecreaseThreshold._cont = ASN1Dict([
        (u'sir', _MeasurementIncreaseDecreaseThreshold_sir),
        (u'sir-error', _MeasurementIncreaseDecreaseThreshold_sir_error),
        (u'transmitted-code-power', _MeasurementIncreaseDecreaseThreshold_transmitted_code_power),
        (u'rscp', _MeasurementIncreaseDecreaseThreshold_rscp),
        (u'round-trip-time', _MeasurementIncreaseDecreaseThreshold_round_trip_time),
        (u'extension-MeasurementIncreaseDecreaseThreshold', _MeasurementIncreaseDecreaseThreshold_extension_MeasurementIncreaseDecreaseThreshold),
        ])
    MeasurementIncreaseDecreaseThreshold._ext = [u'extension-MeasurementIncreaseDecreaseThreshold']
    
    #-----< Extension-MeasurementIncreaseDecreaseThreshold >-----#
    Extension_MeasurementIncreaseDecreaseThreshold = SEQ(name=u'Extension-MeasurementIncreaseDecreaseThreshold', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_MeasurementIncreaseDecreaseThreshold_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_MeasurementIncreaseDecreaseThreshold_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Load-Value-IncrDecrThres')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Carrier-Power-Value-IncrDecrThres')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Received-Total-Wideband-Power-Value-IncrDecrThres')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-ISCP-Value-IncrDecrThres')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RT-Load-Value-IncrDecrThres')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NRT-Load-Information-Value-IncrDecrThres')))
    ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPTSInterferenceValue')))
    __Extension_MeasurementIncreaseDecreaseThreshold_id_tab._val = ASN1Set(rv=[dict([(u'id', 234), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 240), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 237), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 308), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 306), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 538), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_6), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_MeasurementIncreaseDecreaseThreshold_id._const_tab = __Extension_MeasurementIncreaseDecreaseThreshold_id_tab
    _Extension_MeasurementIncreaseDecreaseThreshold_id._const_tab_at = None
    _Extension_MeasurementIncreaseDecreaseThreshold_id._const_tab_id = u'id'
    _Extension_MeasurementIncreaseDecreaseThreshold_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_MeasurementIncreaseDecreaseThreshold_criticality._const_tab = __Extension_MeasurementIncreaseDecreaseThreshold_id_tab
    _Extension_MeasurementIncreaseDecreaseThreshold_criticality._const_tab_at = ('..', u'id')
    _Extension_MeasurementIncreaseDecreaseThreshold_criticality._const_tab_id = u'criticality'
    _Extension_MeasurementIncreaseDecreaseThreshold_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_MeasurementIncreaseDecreaseThreshold_value._const_tab = __Extension_MeasurementIncreaseDecreaseThreshold_id_tab
    _Extension_MeasurementIncreaseDecreaseThreshold_value._const_tab_at = ('..', u'id')
    _Extension_MeasurementIncreaseDecreaseThreshold_value._const_tab_id = u'Value'
    Extension_MeasurementIncreaseDecreaseThreshold._cont = ASN1Dict([
        (u'id', _Extension_MeasurementIncreaseDecreaseThreshold_id),
        (u'criticality', _Extension_MeasurementIncreaseDecreaseThreshold_criticality),
        (u'value', _Extension_MeasurementIncreaseDecreaseThreshold_value),
        ])
    Extension_MeasurementIncreaseDecreaseThreshold._ext = None
    
    #-----< Extension-MeasurementIncreaseDecreaseThresholdIE >-----#
    Extension_MeasurementIncreaseDecreaseThresholdIE = CLASS(name=u'Extension-MeasurementIncreaseDecreaseThresholdIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Load-Value-IncrDecrThres')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Carrier-Power-Value-IncrDecrThres')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Received-Total-Wideband-Power-Value-IncrDecrThres')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-ISCP-Value-IncrDecrThres')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RT-Load-Value-IncrDecrThres')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NRT-Load-Information-Value-IncrDecrThres')))
    _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPTSInterferenceValue')))
    Extension_MeasurementIncreaseDecreaseThresholdIE._val = ASN1Set(rv=[dict([(u'id', 234), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 240), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 237), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 243), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 308), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 306), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 538), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_6), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MeasurementRecoveryBehavior >-----#
    MeasurementRecoveryBehavior = NULL(name=u'MeasurementRecoveryBehavior', mode=MODE_TYPE)
    
    #-----< MeasurementRecoveryReportingIndicator >-----#
    MeasurementRecoveryReportingIndicator = NULL(name=u'MeasurementRecoveryReportingIndicator', mode=MODE_TYPE)
    
    #-----< MeasurementRecoverySupportIndicator >-----#
    MeasurementRecoverySupportIndicator = NULL(name=u'MeasurementRecoverySupportIndicator', mode=MODE_TYPE)
    
    #-----< MeasurementThreshold >-----#
    MeasurementThreshold = CHOICE(name=u'MeasurementThreshold', mode=MODE_TYPE)
    _MeasurementThreshold_sir = INT(name=u'sir', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SIR-Value')))
    _MeasurementThreshold_sir_error = INT(name=u'sir-error', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SIR-Error-Value')))
    _MeasurementThreshold_transmitted_code_power = INT(name=u'transmitted-code-power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Code-Power-Value')))
    _MeasurementThreshold_rscp = INT(name=u'rscp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RSCP-Value')))
    _MeasurementThreshold_rx_timing_deviation = INT(name=u'rx-timing-deviation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value')))
    _MeasurementThreshold_round_trip_time = INT(name=u'round-trip-time', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Round-Trip-Time-Value')))
    _MeasurementThreshold_extension_MeasurementThreshold = SEQ(name=u'extension-MeasurementThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-MeasurementThreshold')))
    MeasurementThreshold._cont = ASN1Dict([
        (u'sir', _MeasurementThreshold_sir),
        (u'sir-error', _MeasurementThreshold_sir_error),
        (u'transmitted-code-power', _MeasurementThreshold_transmitted_code_power),
        (u'rscp', _MeasurementThreshold_rscp),
        (u'rx-timing-deviation', _MeasurementThreshold_rx_timing_deviation),
        (u'round-trip-time', _MeasurementThreshold_round_trip_time),
        (u'extension-MeasurementThreshold', _MeasurementThreshold_extension_MeasurementThreshold),
        ])
    MeasurementThreshold._ext = [u'extension-MeasurementThreshold']
    
    #-----< MessageStructure >-----#
    MessageStructure = SEQ_OF(name=u'MessageStructure', mode=MODE_TYPE)
    _MessageStructure__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MessageStructure__item__iE_ID = INT(name=u'iE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProtocolIE-ID')))
    __MessageStructure__item__repetitionNumber = INT(name=u'repetitionNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionNumber1')), opt=True)
    __MessageStructure__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___MessageStructure__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____MessageStructure__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____MessageStructure__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__id._const_tab = _____MessageStructure__item__iE_Extensions__item__id_tab
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_at = None
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____MessageStructure__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab = _____MessageStructure__item__iE_Extensions__item__criticality_tab
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____MessageStructure__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab = _____MessageStructure__item__iE_Extensions__item__extensionValue_tab
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___MessageStructure__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____MessageStructure__item__iE_Extensions__item__id),
        (u'criticality', ____MessageStructure__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____MessageStructure__item__iE_Extensions__item__extensionValue),
        ])
    ___MessageStructure__item__iE_Extensions__item_._ext = None
    __MessageStructure__item__iE_Extensions._cont = ___MessageStructure__item__iE_Extensions__item_
    __MessageStructure__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _MessageStructure__item_._cont = ASN1Dict([
        (u'iE-ID', __MessageStructure__item__iE_ID),
        (u'repetitionNumber', __MessageStructure__item__repetitionNumber),
        (u'iE-Extensions', __MessageStructure__item__iE_Extensions),
        ])
    _MessageStructure__item_._ext = []
    MessageStructure._cont = _MessageStructure__item_
    MessageStructure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MessageStructure-ExtIEs >-----#
    MessageStructure_ExtIEs = CLASS(name=u'MessageStructure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MessageStructure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-MeasurementThreshold >-----#
    Extension_MeasurementThreshold = SEQ(name=u'Extension-MeasurementThreshold', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_MeasurementThreshold_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_MeasurementThreshold_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSMeasurementThresholdInformation')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNMeasurementThresholdInformation')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Load-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Carrier-Power-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Received-Total-Wideband-Power-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-ISCP-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RT-Load-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NRT-Load-Information-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Reception-Quality-Measurement-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_10 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPTSInterferenceValue')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_12 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-ext')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_13 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-Round-Trip-Time-Value')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGANSSMeasurementThresholdInformation')))
    ___Extension_MeasurementThreshold_id_tab_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-transmission-power-headroom-Value')))
    __Extension_MeasurementThreshold_id_tab._val = ASN1Set(rv=[dict([(u'id', 241), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 238), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 239), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 236), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 242), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 307), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 305), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 293), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_8), (u'presence', u'mandatory')]), dict([(u'id', 496), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 538), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_10), (u'presence', u'mandatory')]), dict([(u'id', 633), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_11), (u'presence', u'mandatory')]), dict([(u'id', 652), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_12), (u'presence', u'mandatory')]), dict([(u'id', 663), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_13), (u'presence', u'mandatory')]), dict([(u'id', 702), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_14), (u'presence', u'mandatory')]), dict([(u'id', 926), (u'criticality', u'reject'), (u'Value', ___Extension_MeasurementThreshold_id_tab_val_Value_15), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_MeasurementThreshold_id._const_tab = __Extension_MeasurementThreshold_id_tab
    _Extension_MeasurementThreshold_id._const_tab_at = None
    _Extension_MeasurementThreshold_id._const_tab_id = u'id'
    _Extension_MeasurementThreshold_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_MeasurementThreshold_criticality._const_tab = __Extension_MeasurementThreshold_id_tab
    _Extension_MeasurementThreshold_criticality._const_tab_at = ('..', u'id')
    _Extension_MeasurementThreshold_criticality._const_tab_id = u'criticality'
    _Extension_MeasurementThreshold_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_MeasurementThreshold_value._const_tab = __Extension_MeasurementThreshold_id_tab
    _Extension_MeasurementThreshold_value._const_tab_at = ('..', u'id')
    _Extension_MeasurementThreshold_value._const_tab_id = u'Value'
    Extension_MeasurementThreshold._cont = ASN1Dict([
        (u'id', _Extension_MeasurementThreshold_id),
        (u'criticality', _Extension_MeasurementThreshold_criticality),
        (u'value', _Extension_MeasurementThreshold_value),
        ])
    Extension_MeasurementThreshold._ext = None
    
    #-----< Extension-MeasurementThresholdIE >-----#
    Extension_MeasurementThresholdIE = CLASS(name=u'Extension-MeasurementThresholdIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_MeasurementThresholdIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSMeasurementThresholdInformation')))
    _Extension_MeasurementThresholdIE_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNMeasurementThresholdInformation')))
    _Extension_MeasurementThresholdIE_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Load-Value')))
    _Extension_MeasurementThresholdIE_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmitted-Carrier-Power-Value')))
    _Extension_MeasurementThresholdIE_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Received-Total-Wideband-Power-Value')))
    _Extension_MeasurementThresholdIE_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-ISCP-Value')))
    _Extension_MeasurementThresholdIE_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RT-Load-Value')))
    _Extension_MeasurementThresholdIE_val_Value_7 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NRT-Load-Information-Value')))
    _Extension_MeasurementThresholdIE_val_Value_8 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-LCR')))
    _Extension_MeasurementThresholdIE_val_Value_9 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-Reception-Quality-Measurement-Value')))
    _Extension_MeasurementThresholdIE_val_Value_10 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPTSInterferenceValue')))
    _Extension_MeasurementThresholdIE_val_Value_11 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-768')))
    _Extension_MeasurementThresholdIE_val_Value_12 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Rx-Timing-Deviation-Value-ext')))
    _Extension_MeasurementThresholdIE_val_Value_13 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-Round-Trip-Time-Value')))
    _Extension_MeasurementThresholdIE_val_Value_14 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGANSSMeasurementThresholdInformation')))
    _Extension_MeasurementThresholdIE_val_Value_15 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-transmission-power-headroom-Value')))
    Extension_MeasurementThresholdIE._val = ASN1Set(rv=[dict([(u'id', 241), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 238), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 233), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 239), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 236), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 242), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 307), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 305), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 293), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_8), (u'presence', u'mandatory')]), dict([(u'id', 496), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 538), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_10), (u'presence', u'mandatory')]), dict([(u'id', 633), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_11), (u'presence', u'mandatory')]), dict([(u'id', 652), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_12), (u'presence', u'mandatory')]), dict([(u'id', 663), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_13), (u'presence', u'mandatory')]), dict([(u'id', 702), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_14), (u'presence', u'mandatory')]), dict([(u'id', 926), (u'criticality', u'reject'), (u'Value', _Extension_MeasurementThresholdIE_val_Value_15), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MidambleConfigurationBurstType1And3 >-----#
    MidambleConfigurationBurstType1And3 = ENUM(name=u'MidambleConfigurationBurstType1And3', mode=MODE_TYPE)
    MidambleConfigurationBurstType1And3._cont = ASN1Dict([(u'v4', 0), (u'v8', 1), (u'v16', 2)])
    MidambleConfigurationBurstType1And3._ext = None
    
    #-----< MidambleConfigurationBurstType2 >-----#
    MidambleConfigurationBurstType2 = ENUM(name=u'MidambleConfigurationBurstType2', mode=MODE_TYPE)
    MidambleConfigurationBurstType2._cont = ASN1Dict([(u'v3', 0), (u'v6', 1)])
    MidambleConfigurationBurstType2._ext = None
    
    #-----< MidambleConfigurationLCR >-----#
    MidambleConfigurationLCR = ENUM(name=u'MidambleConfigurationLCR', mode=MODE_TYPE)
    MidambleConfigurationLCR._cont = ASN1Dict([(u'v2', 0), (u'v4', 1), (u'v6', 2), (u'v8', 3), (u'v10', 4), (u'v12', 5), (u'v14', 6), (u'v16', 7)])
    MidambleConfigurationLCR._ext = []
    
    #-----< MidambleShiftAndBurstType >-----#
    MidambleShiftAndBurstType = CHOICE(name=u'MidambleShiftAndBurstType', mode=MODE_TYPE)
    _MidambleShiftAndBurstType_type1 = SEQ(name=u'type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3 = ENUM(name=u'midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType_type1_midambleAllocationMode = CHOICE(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble = NULL(name=u'defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble = NULL(name=u'commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble = INT(name=u'ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType_type1_midambleAllocationMode._cont = ASN1Dict([
        (u'defaultMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble),
        (u'commonMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble),
        (u'ueSpecificMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type1_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type1._cont = ASN1Dict([
        (u'midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3),
        (u'midambleAllocationMode', __MidambleShiftAndBurstType_type1_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type1._ext = []
    _MidambleShiftAndBurstType_type2 = SEQ(name=u'type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2 = ENUM(name=u'midambleConfigurationBurstType2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationBurstType2')))
    __MidambleShiftAndBurstType_type2_midambleAllocationMode = CHOICE(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble = NULL(name=u'defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble = NULL(name=u'commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble = INT(name=u'ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftShort')))
    __MidambleShiftAndBurstType_type2_midambleAllocationMode._cont = ASN1Dict([
        (u'defaultMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble),
        (u'commonMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble),
        (u'ueSpecificMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type2_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type2._cont = ASN1Dict([
        (u'midambleConfigurationBurstType2', __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2),
        (u'midambleAllocationMode', __MidambleShiftAndBurstType_type2_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type2._ext = []
    _MidambleShiftAndBurstType_type3 = SEQ(name=u'type3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3 = ENUM(name=u'midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType_type3_midambleAllocationMode = CHOICE(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble = NULL(name=u'defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble = INT(name=u'ueSpecificMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType_type3_midambleAllocationMode._cont = ASN1Dict([
        (u'defaultMidamble', ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble),
        (u'ueSpecificMidamble', ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type3_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type3._cont = ASN1Dict([
        (u'midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3),
        (u'midambleAllocationMode', __MidambleShiftAndBurstType_type3_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type3._ext = []
    MidambleShiftAndBurstType._cont = ASN1Dict([
        (u'type1', _MidambleShiftAndBurstType_type1),
        (u'type2', _MidambleShiftAndBurstType_type2),
        (u'type3', _MidambleShiftAndBurstType_type3),
        ])
    MidambleShiftAndBurstType._ext = []
    
    #-----< MidambleShiftLong >-----#
    MidambleShiftLong = INT(name=u'MidambleShiftLong', mode=MODE_TYPE)
    MidambleShiftLong._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< MidambleShiftShort >-----#
    MidambleShiftShort = INT(name=u'MidambleShiftShort', mode=MODE_TYPE)
    MidambleShiftShort._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< MidambleShiftLCR >-----#
    MidambleShiftLCR = SEQ(name=u'MidambleShiftLCR', mode=MODE_TYPE)
    _MidambleShiftLCR_midambleAllocationMode = ENUM(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleAllocationMode')))
    _MidambleShiftLCR_midambleShift = INT(name=u'midambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLong')), opt=True)
    _MidambleShiftLCR_midambleConfigurationLCR = ENUM(name=u'midambleConfigurationLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationLCR')))
    _MidambleShiftLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MidambleShiftLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MidambleShiftLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MidambleShiftLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MidambleShiftLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MidambleShiftLCR_iE_Extensions__item__id._const_tab = ____MidambleShiftLCR_iE_Extensions__item__id_tab
    ___MidambleShiftLCR_iE_Extensions__item__id._const_tab_at = None
    ___MidambleShiftLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___MidambleShiftLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MidambleShiftLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MidambleShiftLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MidambleShiftLCR_iE_Extensions__item__criticality._const_tab = ____MidambleShiftLCR_iE_Extensions__item__criticality_tab
    ___MidambleShiftLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MidambleShiftLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue._const_tab = ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MidambleShiftLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MidambleShiftLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MidambleShiftLCR_iE_Extensions__item__id),
        (u'criticality', ___MidambleShiftLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___MidambleShiftLCR_iE_Extensions__item__extensionValue),
        ])
    __MidambleShiftLCR_iE_Extensions__item_._ext = None
    _MidambleShiftLCR_iE_Extensions._cont = __MidambleShiftLCR_iE_Extensions__item_
    _MidambleShiftLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MidambleShiftLCR._cont = ASN1Dict([
        (u'midambleAllocationMode', _MidambleShiftLCR_midambleAllocationMode),
        (u'midambleShift', _MidambleShiftLCR_midambleShift),
        (u'midambleConfigurationLCR', _MidambleShiftLCR_midambleConfigurationLCR),
        (u'iE-Extensions', _MidambleShiftLCR_iE_Extensions),
        ])
    MidambleShiftLCR._ext = []
    
    #-----< MidambleAllocationMode >-----#
    MidambleAllocationMode = ENUM(name=u'MidambleAllocationMode', mode=MODE_TYPE)
    MidambleAllocationMode._cont = ASN1Dict([(u'defaultMidamble', 0), (u'commonMidamble', 1), (u'uESpecificMidamble', 2)])
    MidambleAllocationMode._ext = []
    
    #-----< MidambleShiftLCR-ExtIEs >-----#
    MidambleShiftLCR_ExtIEs = CLASS(name=u'MidambleShiftLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MidambleShiftLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MidambleShiftAndBurstType768 >-----#
    MidambleShiftAndBurstType768 = CHOICE(name=u'MidambleShiftAndBurstType768', mode=MODE_TYPE)
    _MidambleShiftAndBurstType768_type1 = SEQ(name=u'type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType768_type1_midambleConfigurationBurstType1And3 = ENUM(name=u'midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType768_type1_midambleAllocationMode = CHOICE(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_defaultMidamble = NULL(name=u'defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_commonMidamble = NULL(name=u'commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_ueSpecificMidamble = INT(name=u'ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType768_type1_midambleAllocationMode._cont = ASN1Dict([
        (u'defaultMidamble', ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_defaultMidamble),
        (u'commonMidamble', ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_commonMidamble),
        (u'ueSpecificMidamble', ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType768_type1_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType768_type1._cont = ASN1Dict([
        (u'midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType768_type1_midambleConfigurationBurstType1And3),
        (u'midambleAllocationMode', __MidambleShiftAndBurstType768_type1_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType768_type1._ext = []
    _MidambleShiftAndBurstType768_type2 = SEQ(name=u'type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType768_type2_midambleConfigurationBurstType2_768 = ENUM(name=u'midambleConfigurationBurstType2-768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationBurstType2-768')))
    __MidambleShiftAndBurstType768_type2_midambleAllocationMode = CHOICE(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_defaultMidamble = NULL(name=u'defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_commonMidamble = NULL(name=u'commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_ueSpecificMidamble = INT(name=u'ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftShort768')))
    __MidambleShiftAndBurstType768_type2_midambleAllocationMode._cont = ASN1Dict([
        (u'defaultMidamble', ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_defaultMidamble),
        (u'commonMidamble', ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_commonMidamble),
        (u'ueSpecificMidamble', ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType768_type2_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType768_type2._cont = ASN1Dict([
        (u'midambleConfigurationBurstType2-768', __MidambleShiftAndBurstType768_type2_midambleConfigurationBurstType2_768),
        (u'midambleAllocationMode', __MidambleShiftAndBurstType768_type2_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType768_type2._ext = []
    _MidambleShiftAndBurstType768_type3 = SEQ(name=u'type3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType768_type3_midambleConfigurationBurstType1And3 = ENUM(name=u'midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType768_type3_midambleAllocationMode = CHOICE(name=u'midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_defaultMidamble = NULL(name=u'defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_ueSpecificMidamble = INT(name=u'ueSpecificMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType768_type3_midambleAllocationMode._cont = ASN1Dict([
        (u'defaultMidamble', ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_defaultMidamble),
        (u'ueSpecificMidamble', ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType768_type3_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType768_type3._cont = ASN1Dict([
        (u'midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType768_type3_midambleConfigurationBurstType1And3),
        (u'midambleAllocationMode', __MidambleShiftAndBurstType768_type3_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType768_type3._ext = []
    MidambleShiftAndBurstType768._cont = ASN1Dict([
        (u'type1', _MidambleShiftAndBurstType768_type1),
        (u'type2', _MidambleShiftAndBurstType768_type2),
        (u'type3', _MidambleShiftAndBurstType768_type3),
        ])
    MidambleShiftAndBurstType768._ext = []
    
    #-----< MidambleConfigurationBurstType2-768 >-----#
    MidambleConfigurationBurstType2_768 = ENUM(name=u'MidambleConfigurationBurstType2-768', mode=MODE_TYPE)
    MidambleConfigurationBurstType2_768._cont = ASN1Dict([(u'v4', 0), (u'v8', 1)])
    MidambleConfigurationBurstType2_768._ext = None
    
    #-----< MidambleShiftShort768 >-----#
    MidambleShiftShort768 = INT(name=u'MidambleShiftShort768', mode=MODE_TYPE)
    MidambleShiftShort768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< MIMO-ActivationIndicator >-----#
    MIMO_ActivationIndicator = NULL(name=u'MIMO-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< MIMO-InformationResponse >-----#
    MIMO_InformationResponse = SEQ(name=u'MIMO-InformationResponse', mode=MODE_TYPE)
    _MIMO_InformationResponse_mIMO_PilotConfiguration = CHOICE(name=u'mIMO-PilotConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-PilotConfiguration')))
    _MIMO_InformationResponse_mIMO_N_M_Ratio = ENUM(name=u'mIMO-N-M-Ratio', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-N-M-Ratio')))
    _MIMO_InformationResponse_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MIMO_InformationResponse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MIMO_InformationResponse_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MIMO_InformationResponse_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____MIMO_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-Associated-Secondary-CPICH')))
    ____MIMO_InformationResponse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 925), (u'criticality', u'reject'), (u'Extension', _____MIMO_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MIMO_InformationResponse_iE_Extensions__item__id._const_tab = ____MIMO_InformationResponse_iE_Extensions__item__id_tab
    ___MIMO_InformationResponse_iE_Extensions__item__id._const_tab_at = None
    ___MIMO_InformationResponse_iE_Extensions__item__id._const_tab_id = u'id'
    ___MIMO_InformationResponse_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___MIMO_InformationResponse_iE_Extensions__item__criticality._const_tab = ____MIMO_InformationResponse_iE_Extensions__item__id_tab
    ___MIMO_InformationResponse_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MIMO_InformationResponse_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MIMO_InformationResponse_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___MIMO_InformationResponse_iE_Extensions__item__extensionValue._const_tab = ____MIMO_InformationResponse_iE_Extensions__item__id_tab
    ___MIMO_InformationResponse_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MIMO_InformationResponse_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MIMO_InformationResponse_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MIMO_InformationResponse_iE_Extensions__item__id),
        (u'criticality', ___MIMO_InformationResponse_iE_Extensions__item__criticality),
        (u'extensionValue', ___MIMO_InformationResponse_iE_Extensions__item__extensionValue),
        ])
    __MIMO_InformationResponse_iE_Extensions__item_._ext = None
    _MIMO_InformationResponse_iE_Extensions._cont = __MIMO_InformationResponse_iE_Extensions__item_
    _MIMO_InformationResponse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MIMO_InformationResponse._cont = ASN1Dict([
        (u'mIMO-PilotConfiguration', _MIMO_InformationResponse_mIMO_PilotConfiguration),
        (u'mIMO-N-M-Ratio', _MIMO_InformationResponse_mIMO_N_M_Ratio),
        (u'iE-Extensions', _MIMO_InformationResponse_iE_Extensions),
        ])
    MIMO_InformationResponse._ext = []
    
    #-----< MIMO-InformationResponse-ExtIEs >-----#
    MIMO_InformationResponse_ExtIEs = CLASS(name=u'MIMO-InformationResponse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _MIMO_InformationResponse_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-Associated-Secondary-CPICH')))
    MIMO_InformationResponse_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 925), (u'criticality', u'reject'), (u'Extension', _MIMO_InformationResponse_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MIMO-Mode-Indicator >-----#
    MIMO_Mode_Indicator = ENUM(name=u'MIMO-Mode-Indicator', mode=MODE_TYPE)
    MIMO_Mode_Indicator._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    MIMO_Mode_Indicator._ext = None
    
    #-----< MIMO-N-M-Ratio >-----#
    MIMO_N_M_Ratio = ENUM(name=u'MIMO-N-M-Ratio', mode=MODE_TYPE)
    MIMO_N_M_Ratio._cont = ASN1Dict([(u'v1-2', 0), (u'v2-3', 1), (u'v3-4', 2), (u'v4-5', 3), (u'v5-6', 4), (u'v6-7', 5), (u'v7-8', 6), (u'v8-9', 7), (u'v9-10', 8), (u'v1-1', 9)])
    MIMO_N_M_Ratio._ext = []
    
    #-----< MIMO-PilotConfiguration >-----#
    MIMO_PilotConfiguration = CHOICE(name=u'MIMO-PilotConfiguration', mode=MODE_TYPE)
    _MIMO_PilotConfiguration_primary_and_secondary_CPICH = INT(name=u'primary-and-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-S-CPICH-Channelisation-Code')))
    _MIMO_PilotConfiguration_normal_and_diversity_primary_CPICH = NULL(name=u'normal-and-diversity-primary-CPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MIMO_PilotConfiguration._cont = ASN1Dict([
        (u'primary-and-secondary-CPICH', _MIMO_PilotConfiguration_primary_and_secondary_CPICH),
        (u'normal-and-diversity-primary-CPICH', _MIMO_PilotConfiguration_normal_and_diversity_primary_CPICH),
        ])
    MIMO_PilotConfiguration._ext = []
    
    #-----< MIMO-S-CPICH-Channelisation-Code >-----#
    MIMO_S_CPICH_Channelisation_Code = INT(name=u'MIMO-S-CPICH-Channelisation-Code', mode=MODE_TYPE)
    MIMO_S_CPICH_Channelisation_Code._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    MIMO_withfourtransmitantennas_ActivationIndicator = NULL(name=u'MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< MIMO-withfourtransmitantennas-ModeIndicator >-----#
    MIMO_withfourtransmitantennas_ModeIndicator = ENUM(name=u'MIMO-withfourtransmitantennas-ModeIndicator', mode=MODE_TYPE)
    MIMO_withfourtransmitantennas_ModeIndicator._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    MIMO_withfourtransmitantennas_ModeIndicator._ext = None
    
    #-----< DualStream-MIMO-withfourtransmitantennas-ActivationIndicator >-----#
    DualStream_MIMO_withfourtransmitantennas_ActivationIndicator = NULL(name=u'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< DualStream-MIMO-withfourtransmitantennas-ModeIndicator >-----#
    DualStream_MIMO_withfourtransmitantennas_ModeIndicator = ENUM(name=u'DualStream-MIMO-withfourtransmitantennas-ModeIndicator', mode=MODE_TYPE)
    DualStream_MIMO_withfourtransmitantennas_ModeIndicator._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    DualStream_MIMO_withfourtransmitantennas_ModeIndicator._ext = None
    
    #-----< Additional-Associated-Secondary-CPICH >-----#
    Additional_Associated_Secondary_CPICH = SEQ_OF(name=u'Additional-Associated-Secondary-CPICH', mode=MODE_TYPE)
    _Additional_Associated_Secondary_CPICH__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-Secondary-CPICH')))
    Additional_Associated_Secondary_CPICH._cont = _Additional_Associated_Secondary_CPICH__item_
    Additional_Associated_Secondary_CPICH._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=None, er=[])
    
    #-----< Additional-Secondary-CPICH >-----#
    Additional_Secondary_CPICH = SEQ(name=u'Additional-Secondary-CPICH', mode=MODE_TYPE)
    _Additional_Secondary_CPICH_additional_secondary_CPICH = INT(name=u'additional-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-S-CPICH-Channelisation-Code')))
    _Additional_Secondary_CPICH_additional_D_CPICH = INT(name=u'additional-D-CPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-S-CPICH-Channelisation-Code')), opt=True)
    _Additional_Secondary_CPICH_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_Secondary_CPICH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_Secondary_CPICH_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_Secondary_CPICH_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_Secondary_CPICH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Secondary_CPICH_iE_Extensions__item__id._const_tab = ____Additional_Secondary_CPICH_iE_Extensions__item__id_tab
    ___Additional_Secondary_CPICH_iE_Extensions__item__id._const_tab_at = None
    ___Additional_Secondary_CPICH_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_Secondary_CPICH_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_Secondary_CPICH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_Secondary_CPICH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Secondary_CPICH_iE_Extensions__item__criticality._const_tab = ____Additional_Secondary_CPICH_iE_Extensions__item__criticality_tab
    ___Additional_Secondary_CPICH_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_Secondary_CPICH_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_Secondary_CPICH_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_Secondary_CPICH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_Secondary_CPICH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_Secondary_CPICH_iE_Extensions__item__extensionValue._const_tab = ____Additional_Secondary_CPICH_iE_Extensions__item__extensionValue_tab
    ___Additional_Secondary_CPICH_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_Secondary_CPICH_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_Secondary_CPICH_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_Secondary_CPICH_iE_Extensions__item__id),
        (u'criticality', ___Additional_Secondary_CPICH_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_Secondary_CPICH_iE_Extensions__item__extensionValue),
        ])
    __Additional_Secondary_CPICH_iE_Extensions__item_._ext = None
    _Additional_Secondary_CPICH_iE_Extensions._cont = __Additional_Secondary_CPICH_iE_Extensions__item_
    _Additional_Secondary_CPICH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_Secondary_CPICH._cont = ASN1Dict([
        (u'additional-secondary-CPICH', _Additional_Secondary_CPICH_additional_secondary_CPICH),
        (u'additional-D-CPICH', _Additional_Secondary_CPICH_additional_D_CPICH),
        (u'iE-Extensions', _Additional_Secondary_CPICH_iE_Extensions),
        ])
    Additional_Secondary_CPICH._ext = []
    
    #-----< Additional-Secondary-CPICH-Item-ExtIEs >-----#
    Additional_Secondary_CPICH_Item_ExtIEs = CLASS(name=u'Additional-Secondary-CPICH-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_Secondary_CPICH_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MinUL-ChannelisationCodeLength >-----#
    MinUL_ChannelisationCodeLength = ENUM(name=u'MinUL-ChannelisationCodeLength', mode=MODE_TYPE)
    MinUL_ChannelisationCodeLength._cont = ASN1Dict([(u'v4', 0), (u'v8', 1), (u'v16', 2), (u'v32', 3), (u'v64', 4), (u'v128', 5), (u'v256', 6)])
    MinUL_ChannelisationCodeLength._ext = None
    
    #-----< MinimumReducedE-DPDCH-GainFactor >-----#
    MinimumReducedE_DPDCH_GainFactor = ENUM(name=u'MinimumReducedE-DPDCH-GainFactor', mode=MODE_TYPE)
    MinimumReducedE_DPDCH_GainFactor._cont = ASN1Dict([(u'm8-15', 0), (u'm11-15', 1), (u'm15-15', 2), (u'm21-15', 3), (u'm30-15', 4), (u'm42-15', 5), (u'm60-15', 6), (u'm84-15', 7)])
    MinimumReducedE_DPDCH_GainFactor._ext = []
    
    #-----< ModifyPriorityQueue >-----#
    ModifyPriorityQueue = CHOICE(name=u'ModifyPriorityQueue', mode=MODE_TYPE)
    _ModifyPriorityQueue_addPriorityQueue = SEQ(name=u'addPriorityQueue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoItem-to-Add')))
    _ModifyPriorityQueue_modifyPriorityQueue = SEQ(name=u'modifyPriorityQueue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoItem-to-Modify')))
    _ModifyPriorityQueue_deletePriorityQueue = INT(name=u'deletePriorityQueue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-Id')))
    ModifyPriorityQueue._cont = ASN1Dict([
        (u'addPriorityQueue', _ModifyPriorityQueue_addPriorityQueue),
        (u'modifyPriorityQueue', _ModifyPriorityQueue_modifyPriorityQueue),
        (u'deletePriorityQueue', _ModifyPriorityQueue_deletePriorityQueue),
        ])
    ModifyPriorityQueue._ext = []
    
    #-----< Modulation >-----#
    Modulation = ENUM(name=u'Modulation', mode=MODE_TYPE)
    Modulation._cont = ASN1Dict([(u'qPSK', 0), (u'eightPSK', 1)])
    Modulation._ext = []
    
    #-----< Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory >-----#
    Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory = INT(name=u'Multi-Carrier-E-DCH-LCRTDD-PhysicalLayerCategory', mode=MODE_TYPE)
    Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=[], er=[])
    
    #-----< Multicell-EDCH-Transport-Bearer-Mode >-----#
    Multicell_EDCH_Transport_Bearer_Mode = ENUM(name=u'Multicell-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE)
    Multicell_EDCH_Transport_Bearer_Mode._cont = ASN1Dict([(u'separate-Iur-Transport-Bearer-Mode', 0), (u'uL-Flow-Multiplexing-Mode', 1)])
    Multicell_EDCH_Transport_Bearer_Mode._ext = None
    
    #-----< MulticellEDCH-Information >-----#
    MulticellEDCH_Information = SEQ(name=u'MulticellEDCH-Information', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _MulticellEDCH_Information_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __MulticellEDCH_Information_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___MulticellEDCH_Information_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-InformationItemIEs')))
    __MulticellEDCH_Information_id_tab._val = ASN1Set(rv=[dict([(u'id', 845), (u'criticality', u'ignore'), (u'Value', ___MulticellEDCH_Information_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _MulticellEDCH_Information_id._const_tab = __MulticellEDCH_Information_id_tab
    _MulticellEDCH_Information_id._const_tab_at = None
    _MulticellEDCH_Information_id._const_tab_id = u'id'
    _MulticellEDCH_Information_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _MulticellEDCH_Information_criticality._const_tab = __MulticellEDCH_Information_id_tab
    _MulticellEDCH_Information_criticality._const_tab_at = ('..', u'id')
    _MulticellEDCH_Information_criticality._const_tab_id = u'criticality'
    _MulticellEDCH_Information_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _MulticellEDCH_Information_value._const_tab = __MulticellEDCH_Information_id_tab
    _MulticellEDCH_Information_value._const_tab_at = ('..', u'id')
    _MulticellEDCH_Information_value._const_tab_id = u'Value'
    MulticellEDCH_Information._cont = ASN1Dict([
        (u'id', _MulticellEDCH_Information_id),
        (u'criticality', _MulticellEDCH_Information_criticality),
        (u'value', _MulticellEDCH_Information_value),
        ])
    MulticellEDCH_Information._ext = None
    
    #-----< MulticellEDCH-InformationItem >-----#
    MulticellEDCH_InformationItem = CLASS(name=u'MulticellEDCH-InformationItem', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _MulticellEDCH_InformationItem_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-InformationItemIEs')))
    MulticellEDCH_InformationItem._val = ASN1Set(rv=[dict([(u'id', 845), (u'criticality', u'ignore'), (u'Value', _MulticellEDCH_InformationItem_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MulticellEDCH-InformationItemIEs >-----#
    MulticellEDCH_InformationItemIEs = SEQ(name=u'MulticellEDCH-InformationItemIEs', mode=MODE_TYPE)
    _MulticellEDCH_InformationItemIEs_dL_PowerBalancing_Information = SEQ(name=u'dL-PowerBalancing-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-Information')), opt=True)
    _MulticellEDCH_InformationItemIEs_minimumReducedE_DPDCH_GainFactor = ENUM(name=u'minimumReducedE-DPDCH-GainFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')), opt=True)
    _MulticellEDCH_InformationItemIEs_secondary_UL_Frequency_Activation_State = ENUM(name=u'secondary-UL-Frequency-Activation-State', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-UL-Frequency-Activation-State')), opt=True)
    _MulticellEDCH_InformationItemIEs_f_DPCH_SlotFormat = INT(name=u'f-DPCH-SlotFormat', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')), opt=True)
    _MulticellEDCH_InformationItemIEs_common_DL_ReferencePowerInformation = INT(name=u'common-DL-ReferencePowerInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _MulticellEDCH_InformationItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticellEDCH_InformationItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__id._const_tab = ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__id_tab
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality._const_tab = ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality_tab
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab = ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MulticellEDCH_InformationItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__id),
        (u'criticality', ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue),
        ])
    __MulticellEDCH_InformationItemIEs_iE_Extensions__item_._ext = None
    _MulticellEDCH_InformationItemIEs_iE_Extensions._cont = __MulticellEDCH_InformationItemIEs_iE_Extensions__item_
    _MulticellEDCH_InformationItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticellEDCH_InformationItemIEs._cont = ASN1Dict([
        (u'dL-PowerBalancing-Information', _MulticellEDCH_InformationItemIEs_dL_PowerBalancing_Information),
        (u'minimumReducedE-DPDCH-GainFactor', _MulticellEDCH_InformationItemIEs_minimumReducedE_DPDCH_GainFactor),
        (u'secondary-UL-Frequency-Activation-State', _MulticellEDCH_InformationItemIEs_secondary_UL_Frequency_Activation_State),
        (u'f-DPCH-SlotFormat', _MulticellEDCH_InformationItemIEs_f_DPCH_SlotFormat),
        (u'common-DL-ReferencePowerInformation', _MulticellEDCH_InformationItemIEs_common_DL_ReferencePowerInformation),
        (u'iE-Extensions', _MulticellEDCH_InformationItemIEs_iE_Extensions),
        ])
    MulticellEDCH_InformationItemIEs._ext = []
    
    #-----< MulticellEDCH-InformationItemIEs-ExtIEs >-----#
    MulticellEDCH_InformationItemIEs_ExtIEs = CLASS(name=u'MulticellEDCH-InformationItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MulticellEDCH_InformationItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MulticellEDCH-RL-SpecificInformation >-----#
    MulticellEDCH_RL_SpecificInformation = SEQ(name=u'MulticellEDCH-RL-SpecificInformation', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _MulticellEDCH_RL_SpecificInformation_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __MulticellEDCH_RL_SpecificInformation_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___MulticellEDCH_RL_SpecificInformation_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-RL-SpecificInformationItemIEs')))
    __MulticellEDCH_RL_SpecificInformation_id_tab._val = ASN1Set(rv=[dict([(u'id', 868), (u'criticality', u'ignore'), (u'Value', ___MulticellEDCH_RL_SpecificInformation_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _MulticellEDCH_RL_SpecificInformation_id._const_tab = __MulticellEDCH_RL_SpecificInformation_id_tab
    _MulticellEDCH_RL_SpecificInformation_id._const_tab_at = None
    _MulticellEDCH_RL_SpecificInformation_id._const_tab_id = u'id'
    _MulticellEDCH_RL_SpecificInformation_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _MulticellEDCH_RL_SpecificInformation_criticality._const_tab = __MulticellEDCH_RL_SpecificInformation_id_tab
    _MulticellEDCH_RL_SpecificInformation_criticality._const_tab_at = ('..', u'id')
    _MulticellEDCH_RL_SpecificInformation_criticality._const_tab_id = u'criticality'
    _MulticellEDCH_RL_SpecificInformation_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _MulticellEDCH_RL_SpecificInformation_value._const_tab = __MulticellEDCH_RL_SpecificInformation_id_tab
    _MulticellEDCH_RL_SpecificInformation_value._const_tab_at = ('..', u'id')
    _MulticellEDCH_RL_SpecificInformation_value._const_tab_id = u'Value'
    MulticellEDCH_RL_SpecificInformation._cont = ASN1Dict([
        (u'id', _MulticellEDCH_RL_SpecificInformation_id),
        (u'criticality', _MulticellEDCH_RL_SpecificInformation_criticality),
        (u'value', _MulticellEDCH_RL_SpecificInformation_value),
        ])
    MulticellEDCH_RL_SpecificInformation._ext = None
    
    #-----< MulticellEDCH-RL-SpecificInformationItem >-----#
    MulticellEDCH_RL_SpecificInformationItem = CLASS(name=u'MulticellEDCH-RL-SpecificInformationItem', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _MulticellEDCH_RL_SpecificInformationItem_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MulticellEDCH-RL-SpecificInformationItemIEs')))
    MulticellEDCH_RL_SpecificInformationItem._val = ASN1Set(rv=[dict([(u'id', 868), (u'criticality', u'ignore'), (u'Value', _MulticellEDCH_RL_SpecificInformationItem_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MulticellEDCH-RL-SpecificInformationItemIEs >-----#
    MulticellEDCH_RL_SpecificInformationItemIEs = SEQ(name=u'MulticellEDCH-RL-SpecificInformationItemIEs', mode=MODE_TYPE)
    _MulticellEDCH_RL_SpecificInformationItemIEs_extendedPropagationDelay = INT(name=u'extendedPropagationDelay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')), opt=True)
    _MulticellEDCH_RL_SpecificInformationItemIEs_enhanced_PrimaryCPICH_EcNo = INT(name=u'enhanced-PrimaryCPICH-EcNo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PrimaryCPICH-EcNo')), opt=True)
    _MulticellEDCH_RL_SpecificInformationItemIEs_dl_Reference_Power = INT(name=u'dl-Reference-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _MulticellEDCH_RL_SpecificInformationItemIEs_phase_Reference_Update_Indicator = ENUM(name=u'phase-Reference-Update-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Phase-Reference-Update-Indicator')), opt=True)
    _MulticellEDCH_RL_SpecificInformationItemIEs_additional_e_DCH_DL_Control_Channel_Grant = NULL(name=u'additional-e-DCH-DL-Control-Channel-Grant', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id._const_tab = ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id_tab
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality._const_tab = ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality_tab
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue._const_tab = ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue_tab
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id),
        (u'criticality', ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue),
        ])
    __MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item_._ext = None
    _MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions._cont = __MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item_
    _MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MulticellEDCH_RL_SpecificInformationItemIEs._cont = ASN1Dict([
        (u'extendedPropagationDelay', _MulticellEDCH_RL_SpecificInformationItemIEs_extendedPropagationDelay),
        (u'enhanced-PrimaryCPICH-EcNo', _MulticellEDCH_RL_SpecificInformationItemIEs_enhanced_PrimaryCPICH_EcNo),
        (u'dl-Reference-Power', _MulticellEDCH_RL_SpecificInformationItemIEs_dl_Reference_Power),
        (u'phase-Reference-Update-Indicator', _MulticellEDCH_RL_SpecificInformationItemIEs_phase_Reference_Update_Indicator),
        (u'additional-e-DCH-DL-Control-Channel-Grant', _MulticellEDCH_RL_SpecificInformationItemIEs_additional_e_DCH_DL_Control_Channel_Grant),
        (u'iE-Extensions', _MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions),
        ])
    MulticellEDCH_RL_SpecificInformationItemIEs._ext = []
    
    #-----< MulticellEDCH-RL-SpecificInformationItemIEs-ExtIEs >-----#
    MulticellEDCH_RL_SpecificInformationItemIEs_ExtIEs = CLASS(name=u'MulticellEDCH-RL-SpecificInformationItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MulticellEDCH_RL_SpecificInformationItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicell-EDCH-Restriction >-----#
    Multicell_EDCH_Restriction = BOOL(name=u'Multicell-EDCH-Restriction', mode=MODE_TYPE)
    
    #-----< Multiple-PLMN-List >-----#
    Multiple_PLMN_List = SEQ(name=u'Multiple-PLMN-List', mode=MODE_TYPE)
    _Multiple_PLMN_List_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _Multiple_PLMN_List_list_Of_PLMNs = SEQ_OF(name=u'list-Of-PLMNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'List-Of-PLMNs')), opt=True)
    _Multiple_PLMN_List_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_PLMN_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_PLMN_List_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiple_PLMN_List_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_PLMN_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PLMN_List_iE_Extensions__item__id._const_tab = ____Multiple_PLMN_List_iE_Extensions__item__id_tab
    ___Multiple_PLMN_List_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_PLMN_List_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiple_PLMN_List_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multiple_PLMN_List_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_PLMN_List_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PLMN_List_iE_Extensions__item__criticality._const_tab = ____Multiple_PLMN_List_iE_Extensions__item__criticality_tab
    ___Multiple_PLMN_List_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiple_PLMN_List_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiple_PLMN_List_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_PLMN_List_iE_Extensions__item__extensionValue._const_tab = ____Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab
    ___Multiple_PLMN_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiple_PLMN_List_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiple_PLMN_List_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiple_PLMN_List_iE_Extensions__item__id),
        (u'criticality', ___Multiple_PLMN_List_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiple_PLMN_List_iE_Extensions__item__extensionValue),
        ])
    __Multiple_PLMN_List_iE_Extensions__item_._ext = None
    _Multiple_PLMN_List_iE_Extensions._cont = __Multiple_PLMN_List_iE_Extensions__item_
    _Multiple_PLMN_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_PLMN_List._cont = ASN1Dict([
        (u'pLMN-Identity', _Multiple_PLMN_List_pLMN_Identity),
        (u'list-Of-PLMNs', _Multiple_PLMN_List_list_Of_PLMNs),
        (u'iE-Extensions', _Multiple_PLMN_List_iE_Extensions),
        ])
    Multiple_PLMN_List._ext = []
    
    #-----< Multiple-PLMN-List-ExtIEs >-----#
    Multiple_PLMN_List_ExtIEs = CLASS(name=u'Multiple-PLMN-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multiple_PLMN_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MultiplexingPosition >-----#
    MultiplexingPosition = ENUM(name=u'MultiplexingPosition', mode=MODE_TYPE)
    MultiplexingPosition._cont = ASN1Dict([(u'fixed', 0), (u'flexible', 1)])
    MultiplexingPosition._ext = None
    
    #-----< MAChs-ResetIndicator >-----#
    MAChs_ResetIndicator = ENUM(name=u'MAChs-ResetIndicator', mode=MODE_TYPE)
    MAChs_ResetIndicator._cont = ASN1Dict([(u'mAChs-NotReset', 0)])
    MAChs_ResetIndicator._ext = None
    
    #-----< MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR >-----#
    MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR = SEQ_OF(name=u'MultipleFreq-HSPDSCH-InformationList-ResponseTDDLCR', mode=MODE_TYPE)
    _MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR')))
    MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR._cont = _MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR__item_
    MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR >-----#
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR = SEQ(name=u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR', mode=MODE_TYPE)
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hSSCCH_TDD_Specific_InfoList_Response_LCR = SEQ_OF(name=u'hSSCCH-TDD-Specific-InfoList-Response-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSSCCH-TDD-Specific-InfoList-Response-LCR')), opt=True)
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hARQ_MemoryPartitioning = CHOICE(name=u'hARQ-MemoryPartitioning', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-MemoryPartitioning')), opt=True)
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_uARFCN = INT(name=u'uARFCN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id._const_tab = ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id._const_tab_at = None
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality._const_tab = ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue._const_tab = ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id),
        (u'criticality', ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue),
        ])
    __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_._ext = None
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions._cont = __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_
    _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR._cont = ASN1Dict([
        (u'hSSCCH-TDD-Specific-InfoList-Response-LCR', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hSSCCH_TDD_Specific_InfoList_Response_LCR),
        (u'hARQ-MemoryPartitioning', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hARQ_MemoryPartitioning),
        (u'uARFCN', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_uARFCN),
        (u'iE-Extensions', _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions),
        ])
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR._ext = []
    
    #-----< MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs >-----#
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_ExtIEs = CLASS(name=u'MultipleFreq-HSPDSCH-InformationItem-ResponseTDDLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MIMO-SFMode-For-HSPDSCHDualStream >-----#
    MIMO_SFMode_For_HSPDSCHDualStream = ENUM(name=u'MIMO-SFMode-For-HSPDSCHDualStream', mode=MODE_TYPE)
    MIMO_SFMode_For_HSPDSCHDualStream._cont = ASN1Dict([(u'sF1', 0), (u'sF1SF16', 1)])
    MIMO_SFMode_For_HSPDSCHDualStream._ext = None
    
    #-----< Multi-Carrier-EDCH-Info >-----#
    Multi_Carrier_EDCH_Info = SEQ(name=u'Multi-Carrier-EDCH-Info', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Info_multicarrier_EDCH_Transport_Bearer_Mode = ENUM(name=u'multicarrier-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multicarrier-EDCH-Transport-Bearer-Mode')))
    _Multi_Carrier_EDCH_Info_multi_carrier_EDCH_Information = SEQ_OF(name=u'multi-carrier-EDCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information')))
    _Multi_Carrier_EDCH_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Info_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Info_iE_Extensions._cont = __Multi_Carrier_EDCH_Info_iE_Extensions__item_
    _Multi_Carrier_EDCH_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Info._cont = ASN1Dict([
        (u'multicarrier-EDCH-Transport-Bearer-Mode', _Multi_Carrier_EDCH_Info_multicarrier_EDCH_Transport_Bearer_Mode),
        (u'multi-carrier-EDCH-Information', _Multi_Carrier_EDCH_Info_multi_carrier_EDCH_Information),
        (u'iE-Extensions', _Multi_Carrier_EDCH_Info_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Info._ext = []
    
    #-----< Multi-Carrier-EDCH-Info-ExtIEs >-----#
    Multi_Carrier_EDCH_Info_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multicarrier-EDCH-Transport-Bearer-Mode >-----#
    Multicarrier_EDCH_Transport_Bearer_Mode = ENUM(name=u'Multicarrier-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE)
    Multicarrier_EDCH_Transport_Bearer_Mode._cont = ASN1Dict([(u'separate-Iur-Transport-Bearer-Mode', 0), (u'shared-Iur-Transport-Bearer-Mode', 1)])
    Multicarrier_EDCH_Transport_Bearer_Mode._ext = None
    
    #-----< Multi-Carrier-EDCH-Information >-----#
    Multi_Carrier_EDCH_Information = SEQ_OF(name=u'Multi-Carrier-EDCH-Information', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-LCR-InformationItem')))
    Multi_Carrier_EDCH_Information._cont = _Multi_Carrier_EDCH_Information__item_
    Multi_Carrier_EDCH_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-LCR-InformationItem >-----#
    Multi_Carrier_EDCH_LCR_InformationItem = SEQ(name=u'Multi-Carrier-EDCH-LCR-InformationItem', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_LCR_InformationItem_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Multi_Carrier_EDCH_LCR_InformationItem_sNPL_carrier_group_indicator = INT(name=u'sNPL-carrier-group-indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SNPL-Carrier-Group-Indicator')), opt=True)
    _Multi_Carrier_EDCH_LCR_InformationItem_pRxdesBase = INT(name=u'pRxdesBase', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-PUCH-PRXdesBase')))
    _Multi_Carrier_EDCH_LCR_InformationItem_multi_Carrier_EDCH_MACdFlows_Information_TDD = SEQ_OF(name=u'multi-Carrier-EDCH-MACdFlows-Information-TDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-MACdFlows-Information-TDD')), opt=True)
    _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions._cont = __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_
    _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_LCR_InformationItem._cont = ASN1Dict([
        (u'uARFCNforNt', _Multi_Carrier_EDCH_LCR_InformationItem_uARFCNforNt),
        (u'sNPL-carrier-group-indicator', _Multi_Carrier_EDCH_LCR_InformationItem_sNPL_carrier_group_indicator),
        (u'pRxdesBase', _Multi_Carrier_EDCH_LCR_InformationItem_pRxdesBase),
        (u'multi-Carrier-EDCH-MACdFlows-Information-TDD', _Multi_Carrier_EDCH_LCR_InformationItem_multi_Carrier_EDCH_MACdFlows_Information_TDD),
        (u'iE-Extensions', _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions),
        ])
    Multi_Carrier_EDCH_LCR_InformationItem._ext = []
    
    #-----< Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs >-----#
    Multi_Carrier_EDCH_LCR_InformationItem_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-LCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_LCR_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNPL-Carrier-Group-Indicator >-----#
    SNPL_Carrier_Group_Indicator = INT(name=u'SNPL-Carrier-Group-Indicator', mode=MODE_TYPE)
    SNPL_Carrier_Group_Indicator._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-MACdFlows-Information-TDD >-----#
    Multi_Carrier_EDCH_MACdFlows_Information_TDD = SEQ_OF(name=u'Multi-Carrier-EDCH-MACdFlows-Information-TDD', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_MACdFlows_Information_TDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-MACdFlows-Specific-Info')))
    Multi_Carrier_EDCH_MACdFlows_Information_TDD._cont = _Multi_Carrier_EDCH_MACdFlows_Information_TDD__item_
    Multi_Carrier_EDCH_MACdFlows_Information_TDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-MACdFlows-Specific-Info >-----#
    Multi_Carrier_EDCH_MACdFlows_Specific_Info = SEQ(name=u'Multi-Carrier-EDCH-MACdFlows-Specific-Info', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_e_DCH_MACdFlow_ID = INT(name=u'e-DCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions._cont = __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_
    _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_MACdFlows_Specific_Info._cont = ASN1Dict([
        (u'e-DCH-MACdFlow-ID', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_e_DCH_MACdFlow_ID),
        (u'bindingID', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_bindingID),
        (u'transportLayerAddress', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_transportLayerAddress),
        (u'iE-Extensions', _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions),
        ])
    Multi_Carrier_EDCH_MACdFlows_Specific_Info._ext = []
    
    #-----< Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs >-----#
    Multi_Carrier_EDCH_MACdFlows_Specific_Info_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-MACdFlows-Specific-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_MACdFlows_Specific_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Reconfigure >-----#
    Multi_Carrier_EDCH_Reconfigure = SEQ(name=u'Multi-Carrier-EDCH-Reconfigure', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Reconfigure_continue_setup_change_Of_Multi_Carrier_EDCH = CHOICE(name=u'continue-setup-change-Of-Multi-Carrier-EDCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Continue-Setup-Change-Multi-Carrier-EDCH')))
    _Multi_Carrier_EDCH_Reconfigure_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Reconfigure_iE_Extensions._cont = __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_
    _Multi_Carrier_EDCH_Reconfigure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Reconfigure._cont = ASN1Dict([
        (u'continue-setup-change-Of-Multi-Carrier-EDCH', _Multi_Carrier_EDCH_Reconfigure_continue_setup_change_Of_Multi_Carrier_EDCH),
        (u'iE-Extensions', _Multi_Carrier_EDCH_Reconfigure_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Reconfigure._ext = []
    
    #-----< Multi-Carrier-EDCH-Reconfigure-ExtIEs >-----#
    Multi_Carrier_EDCH_Reconfigure_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-Reconfigure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Reconfigure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Continue-Setup-Change-Multi-Carrier-EDCH >-----#
    Continue_Setup_Change_Multi_Carrier_EDCH = CHOICE(name=u'Continue-Setup-Change-Multi-Carrier-EDCH', mode=MODE_TYPE)
    _Continue_Setup_Change_Multi_Carrier_EDCH_continue_ = NULL(name=u'continue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Continue_Setup_Change_Multi_Carrier_EDCH_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _Continue_Setup_Change_Multi_Carrier_EDCH_change = SEQ(name=u'change', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Change-Info')))
    Continue_Setup_Change_Multi_Carrier_EDCH._cont = ASN1Dict([
        (u'continue', _Continue_Setup_Change_Multi_Carrier_EDCH_continue_),
        (u'setup', _Continue_Setup_Change_Multi_Carrier_EDCH_setup),
        (u'change', _Continue_Setup_Change_Multi_Carrier_EDCH_change),
        ])
    Continue_Setup_Change_Multi_Carrier_EDCH._ext = []
    
    #-----< Multi-Carrier-EDCH-Change-Info >-----#
    Multi_Carrier_EDCH_Change_Info = SEQ(name=u'Multi-Carrier-EDCH-Change-Info', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Change_Info_multicarrier_EDCH_Transport_Bearer_Mode = ENUM(name=u'multicarrier-EDCH-Transport-Bearer-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multicarrier-EDCH-Transport-Bearer-Mode')), opt=True)
    _Multi_Carrier_EDCH_Change_Info_multi_carrier_EDCH_Information = SEQ_OF(name=u'multi-carrier-EDCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information')), opt=True)
    _Multi_Carrier_EDCH_Change_Info_multi_Carrier_EDCH_Information_Removal_List = SEQ_OF(name=u'multi-Carrier-EDCH-Information-Removal-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Removal-List')), opt=True)
    _Multi_Carrier_EDCH_Change_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Change_Info_iE_Extensions._cont = __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_
    _Multi_Carrier_EDCH_Change_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Change_Info._cont = ASN1Dict([
        (u'multicarrier-EDCH-Transport-Bearer-Mode', _Multi_Carrier_EDCH_Change_Info_multicarrier_EDCH_Transport_Bearer_Mode),
        (u'multi-carrier-EDCH-Information', _Multi_Carrier_EDCH_Change_Info_multi_carrier_EDCH_Information),
        (u'multi-Carrier-EDCH-Information-Removal-List', _Multi_Carrier_EDCH_Change_Info_multi_Carrier_EDCH_Information_Removal_List),
        (u'iE-Extensions', _Multi_Carrier_EDCH_Change_Info_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Change_Info._ext = []
    
    #-----< Multi-Carrier-EDCH-Change-Info-ExtIEs >-----#
    Multi_Carrier_EDCH_Change_Info_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-Change-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Change_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Information-Removal-List >-----#
    Multi_Carrier_EDCH_Information_Removal_List = SEQ_OF(name=u'Multi-Carrier-EDCH-Information-Removal-List', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information_Removal_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs')))
    Multi_Carrier_EDCH_Information_Removal_List._cont = _Multi_Carrier_EDCH_Information_Removal_List__item_
    Multi_Carrier_EDCH_Information_Removal_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs >-----#
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs = SEQ(name=u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions._cont = __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_
    _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs._cont = ASN1Dict([
        (u'uARFCNforNt', _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_uARFCNforNt),
        (u'iE-Extensions', _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions),
        ])
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs._ext = []
    
    #-----< Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs >-----#
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-Information-Removal-Info-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multi-Carrier-EDCH-Information-Response >-----#
    Multi_Carrier_EDCH_Information_Response = SEQ_OF(name=u'Multi-Carrier-EDCH-Information-Response', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_Information_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-LCR-Information-ResponseItem')))
    Multi_Carrier_EDCH_Information_Response._cont = _Multi_Carrier_EDCH_Information_Response__item_
    Multi_Carrier_EDCH_Information_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Multi-Carrier-EDCH-LCR-Information-ResponseItem >-----#
    Multi_Carrier_EDCH_LCR_Information_ResponseItem = SEQ(name=u'Multi-Carrier-EDCH-LCR-Information-ResponseItem', mode=MODE_TYPE)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_DCH_TDD_MACdFlow_Specific_InformationResp = SEQ_OF(name=u'e-DCH-TDD-MACdFlow-Specific-InformationResp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-TDD-MACdFlow-Specific-InformationResp')), opt=True)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_AGCH_Specific_Information_Response_LCR_TDD = SEQ_OF(name=u'e-AGCH-Specific-Information-Response-LCR-TDD', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-Specific-InformationRespList-LCR-TDD')), opt=True)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_HICH_Scheduled_InformationResp_LCR = SEQ_OF(name=u'e-HICH-Scheduled-InformationResp-LCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-Scheduled-InformationRespList-LCR-TDD')), opt=True)
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id._const_tab = ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id._const_tab_at = None
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality._const_tab = ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue._const_tab = ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id),
        (u'criticality', ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue),
        ])
    __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_._ext = None
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions._cont = __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_
    _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multi_Carrier_EDCH_LCR_Information_ResponseItem._cont = ASN1Dict([
        (u'uARFCNforNt', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_uARFCNforNt),
        (u'e-DCH-TDD-MACdFlow-Specific-InformationResp', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_DCH_TDD_MACdFlow_Specific_InformationResp),
        (u'e-AGCH-Specific-Information-Response-LCR-TDD', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_AGCH_Specific_Information_Response_LCR_TDD),
        (u'e-HICH-Scheduled-InformationResp-LCR', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_HICH_Scheduled_InformationResp_LCR),
        (u'iE-Extensions', _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions),
        ])
    Multi_Carrier_EDCH_LCR_Information_ResponseItem._ext = []
    
    #-----< Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs >-----#
    Multi_Carrier_EDCH_LCR_Information_ResponseItem_ExtIEs = CLASS(name=u'Multi-Carrier-EDCH-LCR-Information-ResponseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multi_Carrier_EDCH_LCR_Information_ResponseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiflow-Reconfiguration >-----#
    Multiflow_Reconfiguration = CHOICE(name=u'Multiflow-Reconfiguration', mode=MODE_TYPE)
    _Multiflow_Reconfiguration_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Information')))
    _Multiflow_Reconfiguration_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Information-To-Modify')))
    _Multiflow_Reconfiguration_stop = ENUM(name=u'stop', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Stop')))
    Multiflow_Reconfiguration._cont = ASN1Dict([
        (u'setup', _Multiflow_Reconfiguration_setup),
        (u'configurationChange', _Multiflow_Reconfiguration_configurationChange),
        (u'stop', _Multiflow_Reconfiguration_stop),
        ])
    Multiflow_Reconfiguration._ext = []
    
    #-----< Multiflow-Information >-----#
    Multiflow_Information = SEQ(name=u'Multiflow-Information', mode=MODE_TYPE)
    _Multiflow_Information_total_Number_of_HS_DSCH_Cells = INT(name=u'total-Number-of-HS-DSCH-Cells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Multiflow_Information_total_Number_of_HS_DSCH_Cells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=[], er=[])
    _Multiflow_Information_mode = ENUM(name=u'mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Mode')))
    _Multiflow_Information_mimo = ENUM(name=u'mimo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-MIMO')))
    _Multiflow_Information_timing = CHOICE(name=u'timing', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Timing')), opt=True)
    _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB = INT(name=u'max-Number-of-HS-SCCH-Sets-per-NodeB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _Multiflow_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiflow_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiflow_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiflow_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Multiflow_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-RepetitionFactors')))
    ____Multiflow_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 953), (u'criticality', u'ignore'), (u'Extension', _____Multiflow_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Multiflow_Information_iE_Extensions__item__id._const_tab = ____Multiflow_Information_iE_Extensions__item__id_tab
    ___Multiflow_Information_iE_Extensions__item__id._const_tab_at = None
    ___Multiflow_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiflow_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Multiflow_Information_iE_Extensions__item__criticality._const_tab = ____Multiflow_Information_iE_Extensions__item__id_tab
    ___Multiflow_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiflow_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiflow_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Multiflow_Information_iE_Extensions__item__extensionValue._const_tab = ____Multiflow_Information_iE_Extensions__item__id_tab
    ___Multiflow_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiflow_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiflow_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiflow_Information_iE_Extensions__item__id),
        (u'criticality', ___Multiflow_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiflow_Information_iE_Extensions__item__extensionValue),
        ])
    __Multiflow_Information_iE_Extensions__item_._ext = None
    _Multiflow_Information_iE_Extensions._cont = __Multiflow_Information_iE_Extensions__item_
    _Multiflow_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiflow_Information._cont = ASN1Dict([
        (u'total-Number-of-HS-DSCH-Cells', _Multiflow_Information_total_Number_of_HS_DSCH_Cells),
        (u'mode', _Multiflow_Information_mode),
        (u'mimo', _Multiflow_Information_mimo),
        (u'timing', _Multiflow_Information_timing),
        (u'max-Number-of-HS-SCCH-Sets-per-NodeB', _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB),
        (u'iE-Extensions', _Multiflow_Information_iE_Extensions),
        ])
    Multiflow_Information._ext = []
    
    #-----< Multiflow-Information-ExtIEs >-----#
    Multiflow_Information_ExtIEs = CLASS(name=u'Multiflow-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Multiflow_Information_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-RepetitionFactors')))
    Multiflow_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 953), (u'criticality', u'ignore'), (u'Extension', _Multiflow_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiflow-Information-To-Modify >-----#
    Multiflow_Information_To_Modify = SEQ(name=u'Multiflow-Information-To-Modify', mode=MODE_TYPE)
    _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells = INT(name=u'total-Number-of-HS-DSCH-Cells', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=[], er=[])
    _Multiflow_Information_To_Modify_mode = ENUM(name=u'mode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Mode')), opt=True)
    _Multiflow_Information_To_Modify_mimo = ENUM(name=u'mimo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-MIMO')), opt=True)
    _Multiflow_Information_To_Modify_timing = CHOICE(name=u'timing', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-Timing')), opt=True)
    _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB = INT(name=u'max-Number-of-HS-SCCH-Sets-per-NodeB', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=[], er=[])
    _Multiflow_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiflow_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-RepetitionFactors')))
    ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 953), (u'criticality', u'ignore'), (u'Extension', _____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id._const_tab = ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___Multiflow_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiflow_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiflow_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __Multiflow_Information_To_Modify_iE_Extensions__item_._ext = None
    _Multiflow_Information_To_Modify_iE_Extensions._cont = __Multiflow_Information_To_Modify_iE_Extensions__item_
    _Multiflow_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiflow_Information_To_Modify._cont = ASN1Dict([
        (u'total-Number-of-HS-DSCH-Cells', _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells),
        (u'mode', _Multiflow_Information_To_Modify_mode),
        (u'mimo', _Multiflow_Information_To_Modify_mimo),
        (u'timing', _Multiflow_Information_To_Modify_timing),
        (u'max-Number-of-HS-SCCH-Sets-per-NodeB', _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB),
        (u'iE-Extensions', _Multiflow_Information_To_Modify_iE_Extensions),
        ])
    Multiflow_Information_To_Modify._ext = []
    
    #-----< Multiflow-Information-To-Modify-ExtIEs >-----#
    Multiflow_Information_To_Modify_ExtIEs = CLASS(name=u'Multiflow-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Multiflow_Information_To_Modify_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-RepetitionFactors')))
    Multiflow_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 953), (u'criticality', u'ignore'), (u'Extension', _Multiflow_Information_To_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiflow-RepetitionFactors >-----#
    Multiflow_RepetitionFactors = SEQ(name=u'Multiflow-RepetitionFactors', mode=MODE_TYPE)
    _Multiflow_RepetitionFactors_assisting_CQI_RepetitionFactor = INT(name=u'assisting-CQI-RepetitionFactor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CQI-RepetitionFactor')), opt=True)
    _Multiflow_RepetitionFactors_assisting_AckNack_RepetitionFactor = INT(name=u'assisting-AckNack-RepetitionFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AckNack-RepetitionFactor')), opt=True)
    _Multiflow_RepetitionFactors_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiflow_RepetitionFactors_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id._const_tab = ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id._const_tab_at = None
    ___Multiflow_RepetitionFactors_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality._const_tab = ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue._const_tab = ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiflow_RepetitionFactors_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiflow_RepetitionFactors_iE_Extensions__item__id),
        (u'criticality', ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue),
        ])
    __Multiflow_RepetitionFactors_iE_Extensions__item_._ext = None
    _Multiflow_RepetitionFactors_iE_Extensions._cont = __Multiflow_RepetitionFactors_iE_Extensions__item_
    _Multiflow_RepetitionFactors_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiflow_RepetitionFactors._cont = ASN1Dict([
        (u'assisting-CQI-RepetitionFactor', _Multiflow_RepetitionFactors_assisting_CQI_RepetitionFactor),
        (u'assisting-AckNack-RepetitionFactor', _Multiflow_RepetitionFactors_assisting_AckNack_RepetitionFactor),
        (u'iE-Extensions', _Multiflow_RepetitionFactors_iE_Extensions),
        ])
    Multiflow_RepetitionFactors._ext = []
    
    #-----< Multiflow-RepetitionFactors-ExtIEs >-----#
    Multiflow_RepetitionFactors_ExtIEs = CLASS(name=u'Multiflow-RepetitionFactors-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multiflow_RepetitionFactors_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiflow-Stop >-----#
    Multiflow_Stop = ENUM(name=u'Multiflow-Stop', mode=MODE_TYPE)
    Multiflow_Stop._cont = ASN1Dict([(u'stop', 0)])
    Multiflow_Stop._ext = []
    
    #-----< Multiflow-Mode >-----#
    Multiflow_Mode = ENUM(name=u'Multiflow-Mode', mode=MODE_TYPE)
    Multiflow_Mode._cont = ASN1Dict([(u'primary', 0), (u'assisting', 1)])
    Multiflow_Mode._ext = []
    
    #-----< Multiflow-MIMO >-----#
    Multiflow_MIMO = ENUM(name=u'Multiflow-MIMO', mode=MODE_TYPE)
    Multiflow_MIMO._cont = ASN1Dict([(u'on', 0), (u'off', 1)])
    Multiflow_MIMO._ext = []
    
    #-----< Multiflow-Timing >-----#
    Multiflow_Timing = CHOICE(name=u'Multiflow-Timing', mode=MODE_TYPE)
    _Multiflow_Timing_time_Reference = NULL(name=u'time-Reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Multiflow_Timing_non_Time_Reference = INT(name=u'non-Time-Reference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Multiflow_Timing_non_Time_Reference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=30)], ev=[], er=[])
    Multiflow_Timing._cont = ASN1Dict([
        (u'time-Reference', _Multiflow_Timing_time_Reference),
        (u'non-Time-Reference', _Multiflow_Timing_non_Time_Reference),
        ])
    Multiflow_Timing._ext = []
    
    #-----< Multiflow-OrdinalNumberOfFrequency >-----#
    Multiflow_OrdinalNumberOfFrequency = INT(name=u'Multiflow-OrdinalNumberOfFrequency', mode=MODE_TYPE)
    Multiflow_OrdinalNumberOfFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< MU-MIMO-InformationLCR >-----#
    MU_MIMO_InformationLCR = SEQ(name=u'MU-MIMO-InformationLCR', mode=MODE_TYPE)
    _MU_MIMO_InformationLCR_mU_MIMO_Operation = ENUM(name=u'mU-MIMO-Operation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Operation')))
    _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information = SEQ(name=u'standalone-Midamble-Channel-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Standalone-Midamble-Channel-Information')), opt=True)
    _MU_MIMO_InformationLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MU_MIMO_InformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id._const_tab = ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___MU_MIMO_InformationLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality._const_tab = ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue._const_tab = ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MU_MIMO_InformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MU_MIMO_InformationLCR_iE_Extensions__item__id),
        (u'criticality', ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue),
        ])
    __MU_MIMO_InformationLCR_iE_Extensions__item_._ext = None
    _MU_MIMO_InformationLCR_iE_Extensions._cont = __MU_MIMO_InformationLCR_iE_Extensions__item_
    _MU_MIMO_InformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MU_MIMO_InformationLCR._cont = ASN1Dict([
        (u'mU-MIMO-Operation', _MU_MIMO_InformationLCR_mU_MIMO_Operation),
        (u'standalone-Midamble-Channel-Information', _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information),
        (u'iE-Extensions', _MU_MIMO_InformationLCR_iE_Extensions),
        ])
    MU_MIMO_InformationLCR._ext = []
    
    #-----< MU-MIMO-Operation >-----#
    MU_MIMO_Operation = ENUM(name=u'MU-MIMO-Operation', mode=MODE_TYPE)
    MU_MIMO_Operation._cont = ASN1Dict([(u'mU-MIMO-Used', 0), (u'mU-MIMO-Not-Used', 1)])
    MU_MIMO_Operation._ext = []
    
    #-----< MU-MIMO-Usage-Indicator >-----#
    MU_MIMO_Usage_Indicator = ENUM(name=u'MU-MIMO-Usage-Indicator', mode=MODE_TYPE)
    MU_MIMO_Usage_Indicator._cont = ASN1Dict([(u'ul-Only', 0), (u'dl-Only', 1), (u'ul-and-dl', 2)])
    MU_MIMO_Usage_Indicator._ext = None
    
    #-----< Standalone-Midamble-Channel-Information >-----#
    Standalone_Midamble_Channel_Information = SEQ(name=u'Standalone-Midamble-Channel-Information', mode=MODE_TYPE)
    _Standalone_Midamble_Channel_Information_standalone_Midamble_Configuration = ENUM(name=u'standalone-Midamble-Configuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Standalone-Midamble-Configuration')))
    _Standalone_Midamble_Channel_Information_standalone_MidambleShift = INT(name=u'standalone-MidambleShift', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Standalone-MidambleShift')))
    _Standalone_Midamble_Channel_Information_timeslotLCR = INT(name=u'timeslotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _Standalone_Midamble_Channel_Information_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Standalone-Midamble-RepetitionPeriod')))
    _Standalone_Midamble_Channel_Information_offset = INT(name=u'offset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Standalone-Midamble-Offset')))
    _Standalone_Midamble_Channel_Information_referenceBeta = INT(name=u'referenceBeta', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReferenceBeta')), opt=True)
    _Standalone_Midamble_Channel_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Standalone_Midamble_Channel_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id._const_tab = ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id._const_tab_at = None
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality._const_tab = ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue._const_tab = ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Standalone_Midamble_Channel_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id),
        (u'criticality', ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue),
        ])
    __Standalone_Midamble_Channel_Information_iE_Extensions__item_._ext = None
    _Standalone_Midamble_Channel_Information_iE_Extensions._cont = __Standalone_Midamble_Channel_Information_iE_Extensions__item_
    _Standalone_Midamble_Channel_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Standalone_Midamble_Channel_Information._cont = ASN1Dict([
        (u'standalone-Midamble-Configuration', _Standalone_Midamble_Channel_Information_standalone_Midamble_Configuration),
        (u'standalone-MidambleShift', _Standalone_Midamble_Channel_Information_standalone_MidambleShift),
        (u'timeslotLCR', _Standalone_Midamble_Channel_Information_timeslotLCR),
        (u'repetitionPeriod', _Standalone_Midamble_Channel_Information_repetitionPeriod),
        (u'offset', _Standalone_Midamble_Channel_Information_offset),
        (u'referenceBeta', _Standalone_Midamble_Channel_Information_referenceBeta),
        (u'iE-Extensions', _Standalone_Midamble_Channel_Information_iE_Extensions),
        ])
    Standalone_Midamble_Channel_Information._ext = []
    
    #-----< Standalone-Midamble-Configuration >-----#
    Standalone_Midamble_Configuration = ENUM(name=u'Standalone-Midamble-Configuration', mode=MODE_TYPE)
    Standalone_Midamble_Configuration._cont = ASN1Dict([(u'v2', 0), (u'v4', 1), (u'v6', 2), (u'v8', 3), (u'v10', 4), (u'v12', 5), (u'v14', 6), (u'v16', 7)])
    Standalone_Midamble_Configuration._ext = []
    
    #-----< Standalone-MidambleShift >-----#
    Standalone_MidambleShift = INT(name=u'Standalone-MidambleShift', mode=MODE_TYPE)
    Standalone_MidambleShift._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Standalone-Midamble-RepetitionPeriod >-----#
    Standalone_Midamble_RepetitionPeriod = ENUM(name=u'Standalone-Midamble-RepetitionPeriod', mode=MODE_TYPE)
    Standalone_Midamble_RepetitionPeriod._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v16', 4), (u'v32', 5), (u'v64', 6)])
    Standalone_Midamble_RepetitionPeriod._ext = []
    
    #-----< Standalone-Midamble-Offset >-----#
    Standalone_Midamble_Offset = INT(name=u'Standalone-Midamble-Offset', mode=MODE_TYPE)
    Standalone_Midamble_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< ReferenceBeta >-----#
    ReferenceBeta = INT(name=u'ReferenceBeta', mode=MODE_TYPE)
    ReferenceBeta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-15, ub=16)], ev=None, er=[])
    
    #-----< Standalone-Midamble-Channel-Information-ExtIEs >-----#
    Standalone_Midamble_Channel_Information_ExtIEs = CLASS(name=u'Standalone-Midamble-Channel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Standalone_Midamble_Channel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Mode1-Ind >-----#
    Mode1_Ind = NULL(name=u'Mode1-Ind', mode=MODE_TYPE)
    
    #-----< MU-MIMO-InformationLCR-ExtIEs >-----#
    MU_MIMO_InformationLCR_ExtIEs = CLASS(name=u'MU-MIMO-InformationLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MU_MIMO_InformationLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MU-MIMO-Indicator >-----#
    MU_MIMO_Indicator = SEQ(name=u'MU-MIMO-Indicator', mode=MODE_TYPE)
    _MU_MIMO_Indicator_mU_MIMO_Usage_Indicator = ENUM(name=u'mU-MIMO-Usage-Indicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Usage-Indicator')))
    _MU_MIMO_Indicator_standalone_Midamble_Channel_Indicator = ENUM(name=u'standalone-Midamble-Channel-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Standalone-Midamble-Channel-Indicator')))
    _MU_MIMO_Indicator_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MU_MIMO_Indicator_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MU_MIMO_Indicator_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MU_MIMO_Indicator_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Indicator_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Indicator_iE_Extensions__item__id._const_tab = ____MU_MIMO_Indicator_iE_Extensions__item__id_tab
    ___MU_MIMO_Indicator_iE_Extensions__item__id._const_tab_at = None
    ___MU_MIMO_Indicator_iE_Extensions__item__id._const_tab_id = u'id'
    ___MU_MIMO_Indicator_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MU_MIMO_Indicator_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Indicator_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Indicator_iE_Extensions__item__criticality._const_tab = ____MU_MIMO_Indicator_iE_Extensions__item__criticality_tab
    ___MU_MIMO_Indicator_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MU_MIMO_Indicator_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MU_MIMO_Indicator_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MU_MIMO_Indicator_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MU_MIMO_Indicator_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MU_MIMO_Indicator_iE_Extensions__item__extensionValue._const_tab = ____MU_MIMO_Indicator_iE_Extensions__item__extensionValue_tab
    ___MU_MIMO_Indicator_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MU_MIMO_Indicator_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MU_MIMO_Indicator_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MU_MIMO_Indicator_iE_Extensions__item__id),
        (u'criticality', ___MU_MIMO_Indicator_iE_Extensions__item__criticality),
        (u'extensionValue', ___MU_MIMO_Indicator_iE_Extensions__item__extensionValue),
        ])
    __MU_MIMO_Indicator_iE_Extensions__item_._ext = None
    _MU_MIMO_Indicator_iE_Extensions._cont = __MU_MIMO_Indicator_iE_Extensions__item_
    _MU_MIMO_Indicator_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MU_MIMO_Indicator._cont = ASN1Dict([
        (u'mU-MIMO-Usage-Indicator', _MU_MIMO_Indicator_mU_MIMO_Usage_Indicator),
        (u'standalone-Midamble-Channel-Indicator', _MU_MIMO_Indicator_standalone_Midamble_Channel_Indicator),
        (u'iE-Extensions', _MU_MIMO_Indicator_iE_Extensions),
        ])
    MU_MIMO_Indicator._ext = []
    
    #-----< MU-MIMO-Indicator-ExtIEs >-----#
    MU_MIMO_Indicator_ExtIEs = CLASS(name=u'MU-MIMO-Indicator-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MU_MIMO_Indicator_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NACC-Related-Data >-----#
    NACC_Related_Data = SEQ(name=u'NACC-Related-Data', mode=MODE_TYPE)
    _NACC_Related_Data_gERAN_SI_Type = CHOICE(name=u'gERAN-SI-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-SI-Type')))
    _NACC_Related_Data_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NACC_Related_Data_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NACC_Related_Data_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NACC_Related_Data_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NACC_Related_Data_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NACC_Related_Data_iE_Extensions__item__id._const_tab = ____NACC_Related_Data_iE_Extensions__item__id_tab
    ___NACC_Related_Data_iE_Extensions__item__id._const_tab_at = None
    ___NACC_Related_Data_iE_Extensions__item__id._const_tab_id = u'id'
    ___NACC_Related_Data_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NACC_Related_Data_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NACC_Related_Data_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NACC_Related_Data_iE_Extensions__item__criticality._const_tab = ____NACC_Related_Data_iE_Extensions__item__criticality_tab
    ___NACC_Related_Data_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NACC_Related_Data_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NACC_Related_Data_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NACC_Related_Data_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NACC_Related_Data_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NACC_Related_Data_iE_Extensions__item__extensionValue._const_tab = ____NACC_Related_Data_iE_Extensions__item__extensionValue_tab
    ___NACC_Related_Data_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NACC_Related_Data_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NACC_Related_Data_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NACC_Related_Data_iE_Extensions__item__id),
        (u'criticality', ___NACC_Related_Data_iE_Extensions__item__criticality),
        (u'extensionValue', ___NACC_Related_Data_iE_Extensions__item__extensionValue),
        ])
    __NACC_Related_Data_iE_Extensions__item_._ext = None
    _NACC_Related_Data_iE_Extensions._cont = __NACC_Related_Data_iE_Extensions__item_
    _NACC_Related_Data_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NACC_Related_Data._cont = ASN1Dict([
        (u'gERAN-SI-Type', _NACC_Related_Data_gERAN_SI_Type),
        (u'iE-Extensions', _NACC_Related_Data_iE_Extensions),
        ])
    NACC_Related_Data._ext = []
    
    #-----< NACC-Related-Data-ExtIEs >-----#
    NACC_Related_Data_ExtIEs = CLASS(name=u'NACC-Related-Data-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    NACC_Related_Data_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Nack-Power-Offset >-----#
    Nack_Power_Offset = INT(name=u'Nack-Power-Offset', mode=MODE_TYPE)
    Nack_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=[], er=[ASN1RangeInt(lb=9, ub=10)])
    
    #-----< NCC >-----#
    NCC = BIT_STR(name=u'NCC', mode=MODE_TYPE)
    NCC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Neighbouring-UMTS-CellInformation >-----#
    Neighbouring_UMTS_CellInformation = SEQ_OF(name=u'Neighbouring-UMTS-CellInformation', mode=MODE_TYPE)
    _Neighbouring_UMTS_CellInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __Neighbouring_UMTS_CellInformation__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___Neighbouring_UMTS_CellInformation__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____Neighbouring_UMTS_CellInformation__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformationItem')))
    ___Neighbouring_UMTS_CellInformation__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', ____Neighbouring_UMTS_CellInformation__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Neighbouring_UMTS_CellInformation__item__id._const_tab = ___Neighbouring_UMTS_CellInformation__item__id_tab
    __Neighbouring_UMTS_CellInformation__item__id._const_tab_at = None
    __Neighbouring_UMTS_CellInformation__item__id._const_tab_id = u'id'
    __Neighbouring_UMTS_CellInformation__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __Neighbouring_UMTS_CellInformation__item__criticality._const_tab = ___Neighbouring_UMTS_CellInformation__item__id_tab
    __Neighbouring_UMTS_CellInformation__item__criticality._const_tab_at = ('..', u'id')
    __Neighbouring_UMTS_CellInformation__item__criticality._const_tab_id = u'criticality'
    __Neighbouring_UMTS_CellInformation__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __Neighbouring_UMTS_CellInformation__item__value._const_tab = ___Neighbouring_UMTS_CellInformation__item__id_tab
    __Neighbouring_UMTS_CellInformation__item__value._const_tab_at = ('..', u'id')
    __Neighbouring_UMTS_CellInformation__item__value._const_tab_id = u'Value'
    _Neighbouring_UMTS_CellInformation__item_._cont = ASN1Dict([
        (u'id', __Neighbouring_UMTS_CellInformation__item__id),
        (u'criticality', __Neighbouring_UMTS_CellInformation__item__criticality),
        (u'value', __Neighbouring_UMTS_CellInformation__item__value),
        ])
    _Neighbouring_UMTS_CellInformation__item_._ext = None
    Neighbouring_UMTS_CellInformation._cont = _Neighbouring_UMTS_CellInformation__item_
    Neighbouring_UMTS_CellInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< Neighbouring-UMTS-CellInformation-Ext >-----#
    Neighbouring_UMTS_CellInformation_Ext = SEQ_OF(name=u'Neighbouring-UMTS-CellInformation-Ext', mode=MODE_TYPE)
    _Neighbouring_UMTS_CellInformation_Ext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __Neighbouring_UMTS_CellInformation_Ext__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___Neighbouring_UMTS_CellInformation_Ext__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____Neighbouring_UMTS_CellInformation_Ext__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformationExtensionItem')))
    ___Neighbouring_UMTS_CellInformation_Ext__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 896), (u'criticality', u'ignore'), (u'Value', ____Neighbouring_UMTS_CellInformation_Ext__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __Neighbouring_UMTS_CellInformation_Ext__item__id._const_tab = ___Neighbouring_UMTS_CellInformation_Ext__item__id_tab
    __Neighbouring_UMTS_CellInformation_Ext__item__id._const_tab_at = None
    __Neighbouring_UMTS_CellInformation_Ext__item__id._const_tab_id = u'id'
    __Neighbouring_UMTS_CellInformation_Ext__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __Neighbouring_UMTS_CellInformation_Ext__item__criticality._const_tab = ___Neighbouring_UMTS_CellInformation_Ext__item__id_tab
    __Neighbouring_UMTS_CellInformation_Ext__item__criticality._const_tab_at = ('..', u'id')
    __Neighbouring_UMTS_CellInformation_Ext__item__criticality._const_tab_id = u'criticality'
    __Neighbouring_UMTS_CellInformation_Ext__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __Neighbouring_UMTS_CellInformation_Ext__item__value._const_tab = ___Neighbouring_UMTS_CellInformation_Ext__item__id_tab
    __Neighbouring_UMTS_CellInformation_Ext__item__value._const_tab_at = ('..', u'id')
    __Neighbouring_UMTS_CellInformation_Ext__item__value._const_tab_id = u'Value'
    _Neighbouring_UMTS_CellInformation_Ext__item_._cont = ASN1Dict([
        (u'id', __Neighbouring_UMTS_CellInformation_Ext__item__id),
        (u'criticality', __Neighbouring_UMTS_CellInformation_Ext__item__criticality),
        (u'value', __Neighbouring_UMTS_CellInformation_Ext__item__value),
        ])
    _Neighbouring_UMTS_CellInformation_Ext__item_._ext = None
    Neighbouring_UMTS_CellInformation_Ext._cont = _Neighbouring_UMTS_CellInformation_Ext__item_
    Neighbouring_UMTS_CellInformation_Ext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Neighbouring-UMTS-CellInformationExtensionItemIE >-----#
    Neighbouring_UMTS_CellInformationExtensionItemIE = CLASS(name=u'Neighbouring-UMTS-CellInformationExtensionItemIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Neighbouring_UMTS_CellInformationExtensionItemIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformationExtensionItem')))
    Neighbouring_UMTS_CellInformationExtensionItemIE._val = ASN1Set(rv=[dict([(u'id', 896), (u'criticality', u'ignore'), (u'Value', _Neighbouring_UMTS_CellInformationExtensionItemIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Neighbouring-UMTS-CellInformationExtensionItem >-----#
    Neighbouring_UMTS_CellInformationExtensionItem = SEQ(name=u'Neighbouring-UMTS-CellInformationExtensionItem', mode=MODE_TYPE)
    _Neighbouring_UMTS_CellInformationExtensionItem_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _Neighbouring_UMTS_CellInformationExtensionItem_cN_PS_DomainIdentifier = SEQ(name=u'cN-PS-DomainIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')), opt=True)
    _Neighbouring_UMTS_CellInformationExtensionItem_cN_CS_DomainIdentifier = SEQ(name=u'cN-CS-DomainIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')), opt=True)
    _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_FDD_CellInformation = SEQ_OF(name=u'neighbouring-FDD-CellInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-FDD-CellInformation')), opt=True)
    _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_TDD_CellInformation = SEQ_OF(name=u'neighbouring-TDD-CellInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-TDD-CellInformation')), opt=True)
    _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_LCR_TDD_CellInformation = SEQ_OF(name=u'neighbouring-LCR-TDD-CellInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-LCR-TDD-CellInformation')), opt=True)
    _Neighbouring_UMTS_CellInformationExtensionItem_extended_RNC_ID = INT(name=u'extended-RNC-ID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')), opt=True)
    _Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id._const_tab = ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id_tab
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality_tab
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue_tab
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item_._ext = None
    _Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions._cont = __Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item_
    _Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_UMTS_CellInformationExtensionItem._cont = ASN1Dict([
        (u'rNC-ID', _Neighbouring_UMTS_CellInformationExtensionItem_rNC_ID),
        (u'cN-PS-DomainIdentifier', _Neighbouring_UMTS_CellInformationExtensionItem_cN_PS_DomainIdentifier),
        (u'cN-CS-DomainIdentifier', _Neighbouring_UMTS_CellInformationExtensionItem_cN_CS_DomainIdentifier),
        (u'neighbouring-FDD-CellInformation', _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_FDD_CellInformation),
        (u'neighbouring-TDD-CellInformation', _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_TDD_CellInformation),
        (u'neighbouring-LCR-TDD-CellInformation', _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_LCR_TDD_CellInformation),
        (u'extended-RNC-ID', _Neighbouring_UMTS_CellInformationExtensionItem_extended_RNC_ID),
        (u'iE-Extensions', _Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions),
        ])
    Neighbouring_UMTS_CellInformationExtensionItem._ext = []
    
    #-----< Neighbouring-UMTS-CellInformationExtensionItem-ExtIEs >-----#
    Neighbouring_UMTS_CellInformationExtensionItem_ExtIEs = CLASS(name=u'Neighbouring-UMTS-CellInformationExtensionItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Neighbouring_UMTS_CellInformationExtensionItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Neighbouring-UMTS-CellInformationItemIE >-----#
    Neighbouring_UMTS_CellInformationItemIE = CLASS(name=u'Neighbouring-UMTS-CellInformationItemIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Neighbouring_UMTS_CellInformationItemIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformationItem')))
    Neighbouring_UMTS_CellInformationItemIE._val = ASN1Set(rv=[dict([(u'id', 95), (u'criticality', u'ignore'), (u'Value', _Neighbouring_UMTS_CellInformationItemIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Neighbouring-UMTS-CellInformationItem >-----#
    Neighbouring_UMTS_CellInformationItem = SEQ(name=u'Neighbouring-UMTS-CellInformationItem', mode=MODE_TYPE)
    _Neighbouring_UMTS_CellInformationItem_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _Neighbouring_UMTS_CellInformationItem_cN_PS_DomainIdentifier = SEQ(name=u'cN-PS-DomainIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')), opt=True)
    _Neighbouring_UMTS_CellInformationItem_cN_CS_DomainIdentifier = SEQ(name=u'cN-CS-DomainIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')), opt=True)
    _Neighbouring_UMTS_CellInformationItem_neighbouring_FDD_CellInformation = SEQ_OF(name=u'neighbouring-FDD-CellInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-FDD-CellInformation')), opt=True)
    _Neighbouring_UMTS_CellInformationItem_neighbouring_TDD_CellInformation = SEQ_OF(name=u'neighbouring-TDD-CellInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-TDD-CellInformation')), opt=True)
    _Neighbouring_UMTS_CellInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_UMTS_CellInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-LCR-TDD-CellInformation')))
    _____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id._const_tab = ____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_UMTS_CellInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_UMTS_CellInformationItem_iE_Extensions__item_._ext = None
    _Neighbouring_UMTS_CellInformationItem_iE_Extensions._cont = __Neighbouring_UMTS_CellInformationItem_iE_Extensions__item_
    _Neighbouring_UMTS_CellInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_UMTS_CellInformationItem._cont = ASN1Dict([
        (u'rNC-ID', _Neighbouring_UMTS_CellInformationItem_rNC_ID),
        (u'cN-PS-DomainIdentifier', _Neighbouring_UMTS_CellInformationItem_cN_PS_DomainIdentifier),
        (u'cN-CS-DomainIdentifier', _Neighbouring_UMTS_CellInformationItem_cN_CS_DomainIdentifier),
        (u'neighbouring-FDD-CellInformation', _Neighbouring_UMTS_CellInformationItem_neighbouring_FDD_CellInformation),
        (u'neighbouring-TDD-CellInformation', _Neighbouring_UMTS_CellInformationItem_neighbouring_TDD_CellInformation),
        (u'iE-Extensions', _Neighbouring_UMTS_CellInformationItem_iE_Extensions),
        ])
    Neighbouring_UMTS_CellInformationItem._ext = []
    
    #-----< Neighbouring-UMTS-CellInformationItem-ExtIEs >-----#
    Neighbouring_UMTS_CellInformationItem_ExtIEs = CLASS(name=u'Neighbouring-UMTS-CellInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Neighbouring_UMTS_CellInformationItem_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-LCR-TDD-CellInformation')))
    _Neighbouring_UMTS_CellInformationItem_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    Neighbouring_UMTS_CellInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 58), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_UMTS_CellInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _Neighbouring_UMTS_CellInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Neighbouring-FDD-CellInformation >-----#
    Neighbouring_FDD_CellInformation = SEQ_OF(name=u'Neighbouring-FDD-CellInformation', mode=MODE_TYPE)
    _Neighbouring_FDD_CellInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-FDD-CellInformationItem')))
    Neighbouring_FDD_CellInformation._cont = _Neighbouring_FDD_CellInformation__item_
    Neighbouring_FDD_CellInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Neighbouring-FDD-CellInformationItem >-----#
    Neighbouring_FDD_CellInformationItem = SEQ(name=u'Neighbouring-FDD-CellInformationItem', mode=MODE_TYPE)
    _Neighbouring_FDD_CellInformationItem_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Neighbouring_FDD_CellInformationItem_uARFCNforNu = INT(name=u'uARFCNforNu', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Neighbouring_FDD_CellInformationItem_uARFCNforNd = INT(name=u'uARFCNforNd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Neighbouring_FDD_CellInformationItem_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')), opt=True)
    _Neighbouring_FDD_CellInformationItem_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')))
    _Neighbouring_FDD_CellInformationItem_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')), opt=True)
    _Neighbouring_FDD_CellInformationItem_cellIndividualOffset = INT(name=u'cellIndividualOffset', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellIndividualOffset')), opt=True)
    _Neighbouring_FDD_CellInformationItem_txDiversityIndicator = ENUM(name=u'txDiversityIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TxDiversityIndicator')))
    _Neighbouring_FDD_CellInformationItem_sTTD_SupportIndicator = ENUM(name=u'sTTD-SupportIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'STTD-SupportIndicator')), opt=True)
    _Neighbouring_FDD_CellInformationItem_closedLoopMode1_SupportIndicator = ENUM(name=u'closedLoopMode1-SupportIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ClosedLoopMode1-SupportIndicator')), opt=True)
    _Neighbouring_FDD_CellInformationItem_not_used_closedLoopMode2_SupportIndicator = NULL(name=u'not-used-closedLoopMode2-SupportIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Neighbouring_FDD_CellInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_FDD_CellInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode-Change-SupportIndicator')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-FDD')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FrequencyBandIndicator')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_12 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-FDD')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_13 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellListValidityIndicator')))
    _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFrequencyBandsIndicatorList')))
    ____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 142), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 600), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'conditional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 802), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 827), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 859), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 877), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 973), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id._const_tab = ____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_FDD_CellInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_FDD_CellInformationItem_iE_Extensions__item_._ext = None
    _Neighbouring_FDD_CellInformationItem_iE_Extensions._cont = __Neighbouring_FDD_CellInformationItem_iE_Extensions__item_
    _Neighbouring_FDD_CellInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_FDD_CellInformationItem._cont = ASN1Dict([
        (u'c-ID', _Neighbouring_FDD_CellInformationItem_c_ID),
        (u'uARFCNforNu', _Neighbouring_FDD_CellInformationItem_uARFCNforNu),
        (u'uARFCNforNd', _Neighbouring_FDD_CellInformationItem_uARFCNforNd),
        (u'frameOffset', _Neighbouring_FDD_CellInformationItem_frameOffset),
        (u'primaryScramblingCode', _Neighbouring_FDD_CellInformationItem_primaryScramblingCode),
        (u'primaryCPICH-Power', _Neighbouring_FDD_CellInformationItem_primaryCPICH_Power),
        (u'cellIndividualOffset', _Neighbouring_FDD_CellInformationItem_cellIndividualOffset),
        (u'txDiversityIndicator', _Neighbouring_FDD_CellInformationItem_txDiversityIndicator),
        (u'sTTD-SupportIndicator', _Neighbouring_FDD_CellInformationItem_sTTD_SupportIndicator),
        (u'closedLoopMode1-SupportIndicator', _Neighbouring_FDD_CellInformationItem_closedLoopMode1_SupportIndicator),
        (u'not-used-closedLoopMode2-SupportIndicator', _Neighbouring_FDD_CellInformationItem_not_used_closedLoopMode2_SupportIndicator),
        (u'iE-Extensions', _Neighbouring_FDD_CellInformationItem_iE_Extensions),
        ])
    Neighbouring_FDD_CellInformationItem._ext = []
    
    #-----< Neighbouring-FDD-CellInformationItem-ExtIEs >-----#
    Neighbouring_FDD_CellInformationItem_ExtIEs = CLASS(name=u'Neighbouring-FDD-CellInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode-Change-SupportIndicator')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_5 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-FDD')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FrequencyBandIndicator')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_12 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-FDD')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_13 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellListValidityIndicator')))
    _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFrequencyBandsIndicatorList')))
    Neighbouring_FDD_CellInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 142), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 600), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_8), (u'presence', u'conditional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 802), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 827), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 859), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 877), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 973), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MultipleFrequencyBandsIndicatorList >-----#
    MultipleFrequencyBandsIndicatorList = SEQ_OF(name=u'MultipleFrequencyBandsIndicatorList', mode=MODE_TYPE)
    _MultipleFrequencyBandsIndicatorList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FrequencyBandIndicator')))
    MultipleFrequencyBandsIndicatorList._cont = _MultipleFrequencyBandsIndicatorList__item_
    MultipleFrequencyBandsIndicatorList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< NeighbouringFDDCellMeasurementInformation >-----#
    NeighbouringFDDCellMeasurementInformation = SEQ(name=u'NeighbouringFDDCellMeasurementInformation', mode=MODE_TYPE)
    _NeighbouringFDDCellMeasurementInformation_uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _NeighbouringFDDCellMeasurementInformation_uARFCN = INT(name=u'uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _NeighbouringFDDCellMeasurementInformation_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')))
    _NeighbouringFDDCellMeasurementInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id._const_tab = ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab = ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id),
        (u'criticality', ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_._ext = None
    _NeighbouringFDDCellMeasurementInformation_iE_Extensions._cont = __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_
    _NeighbouringFDDCellMeasurementInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringFDDCellMeasurementInformation._cont = ASN1Dict([
        (u'uC-ID', _NeighbouringFDDCellMeasurementInformation_uC_ID),
        (u'uARFCN', _NeighbouringFDDCellMeasurementInformation_uARFCN),
        (u'primaryScramblingCode', _NeighbouringFDDCellMeasurementInformation_primaryScramblingCode),
        (u'iE-Extensions', _NeighbouringFDDCellMeasurementInformation_iE_Extensions),
        ])
    NeighbouringFDDCellMeasurementInformation._ext = []
    
    #-----< NeighbouringFDDCellMeasurementInformationItem-ExtIEs >-----#
    NeighbouringFDDCellMeasurementInformationItem_ExtIEs = CLASS(name=u'NeighbouringFDDCellMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    NeighbouringFDDCellMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Neighbouring-GSM-CellInformation >-----#
    Neighbouring_GSM_CellInformation = SEQ(name=u'Neighbouring-GSM-CellInformation', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Neighbouring_GSM_CellInformation_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Neighbouring_GSM_CellInformation_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Neighbouring_GSM_CellInformation_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformationIEs')))
    __Neighbouring_GSM_CellInformation_id_tab._val = ASN1Set(rv=[dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', ___Neighbouring_GSM_CellInformation_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Neighbouring_GSM_CellInformation_id._const_tab = __Neighbouring_GSM_CellInformation_id_tab
    _Neighbouring_GSM_CellInformation_id._const_tab_at = None
    _Neighbouring_GSM_CellInformation_id._const_tab_id = u'id'
    _Neighbouring_GSM_CellInformation_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Neighbouring_GSM_CellInformation_criticality._const_tab = __Neighbouring_GSM_CellInformation_id_tab
    _Neighbouring_GSM_CellInformation_criticality._const_tab_at = ('..', u'id')
    _Neighbouring_GSM_CellInformation_criticality._const_tab_id = u'criticality'
    _Neighbouring_GSM_CellInformation_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Neighbouring_GSM_CellInformation_value._const_tab = __Neighbouring_GSM_CellInformation_id_tab
    _Neighbouring_GSM_CellInformation_value._const_tab_at = ('..', u'id')
    _Neighbouring_GSM_CellInformation_value._const_tab_id = u'Value'
    Neighbouring_GSM_CellInformation._cont = ASN1Dict([
        (u'id', _Neighbouring_GSM_CellInformation_id),
        (u'criticality', _Neighbouring_GSM_CellInformation_criticality),
        (u'value', _Neighbouring_GSM_CellInformation_value),
        ])
    Neighbouring_GSM_CellInformation._ext = None
    
    #-----< Neighbouring-GSM-CellInformationIE >-----#
    Neighbouring_GSM_CellInformationIE = CLASS(name=u'Neighbouring-GSM-CellInformationIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Neighbouring_GSM_CellInformationIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformationIEs')))
    Neighbouring_GSM_CellInformationIE._val = ASN1Set(rv=[dict([(u'id', 13), (u'criticality', u'ignore'), (u'Value', _Neighbouring_GSM_CellInformationIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Neighbouring-GSM-CellInformationIEs >-----#
    Neighbouring_GSM_CellInformationIEs = SEQ_OF(name=u'Neighbouring-GSM-CellInformationIEs', mode=MODE_TYPE)
    _Neighbouring_GSM_CellInformationIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformationItem')))
    Neighbouring_GSM_CellInformationIEs._cont = _Neighbouring_GSM_CellInformationIEs__item_
    Neighbouring_GSM_CellInformationIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Neighbouring-GSM-CellInformationItem >-----#
    Neighbouring_GSM_CellInformationItem = SEQ(name=u'Neighbouring-GSM-CellInformationItem', mode=MODE_TYPE)
    _Neighbouring_GSM_CellInformationItem_cGI = SEQ(name=u'cGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CGI')))
    _Neighbouring_GSM_CellInformationItem_cellIndividualOffset = INT(name=u'cellIndividualOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellIndividualOffset')), opt=True)
    _Neighbouring_GSM_CellInformationItem_bSIC = SEQ(name=u'bSIC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BSIC')))
    _Neighbouring_GSM_CellInformationItem_band_Indicator = ENUM(name=u'band-Indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Band-Indicator')))
    _Neighbouring_GSM_CellInformationItem_bCCH_ARFCN = INT(name=u'bCCH-ARFCN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BCCH-ARFCN')))
    _Neighbouring_GSM_CellInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_GSM_CellInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-Cell-Capability')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-Classmark')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedGSMCellIndividualOffset')))
    _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-List')))
    ____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 468), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 469), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 514), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 941), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id._const_tab = ____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_GSM_CellInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_GSM_CellInformationItem_iE_Extensions__item_._ext = None
    _Neighbouring_GSM_CellInformationItem_iE_Extensions._cont = __Neighbouring_GSM_CellInformationItem_iE_Extensions__item_
    _Neighbouring_GSM_CellInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_GSM_CellInformationItem._cont = ASN1Dict([
        (u'cGI', _Neighbouring_GSM_CellInformationItem_cGI),
        (u'cellIndividualOffset', _Neighbouring_GSM_CellInformationItem_cellIndividualOffset),
        (u'bSIC', _Neighbouring_GSM_CellInformationItem_bSIC),
        (u'band-Indicator', _Neighbouring_GSM_CellInformationItem_band_Indicator),
        (u'bCCH-ARFCN', _Neighbouring_GSM_CellInformationItem_bCCH_ARFCN),
        (u'iE-Extensions', _Neighbouring_GSM_CellInformationItem_iE_Extensions),
        ])
    Neighbouring_GSM_CellInformationItem._ext = []
    
    #-----< Neighbouring-GSM-CellInformationItem-ExtIEs >-----#
    Neighbouring_GSM_CellInformationItem_ExtIEs = CLASS(name=u'Neighbouring-GSM-CellInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-Cell-Capability')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_5 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GERAN-Classmark')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedGSMCellIndividualOffset')))
    _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-List')))
    Neighbouring_GSM_CellInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 468), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 469), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 514), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 941), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Neighbouring-TDD-CellInformation >-----#
    Neighbouring_TDD_CellInformation = SEQ_OF(name=u'Neighbouring-TDD-CellInformation', mode=MODE_TYPE)
    _Neighbouring_TDD_CellInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-TDD-CellInformationItem')))
    Neighbouring_TDD_CellInformation._cont = _Neighbouring_TDD_CellInformation__item_
    Neighbouring_TDD_CellInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Neighbouring-TDD-CellInformationItem >-----#
    Neighbouring_TDD_CellInformationItem = SEQ(name=u'Neighbouring-TDD-CellInformationItem', mode=MODE_TYPE)
    _Neighbouring_TDD_CellInformationItem_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Neighbouring_TDD_CellInformationItem_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Neighbouring_TDD_CellInformationItem_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')), opt=True)
    _Neighbouring_TDD_CellInformationItem_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')))
    _Neighbouring_TDD_CellInformationItem_syncCase = INT(name=u'syncCase', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SyncCase')))
    _Neighbouring_TDD_CellInformationItem_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')), opt=True)
    _Neighbouring_TDD_CellInformationItem_sCH_TimeSlot = INT(name=u'sCH-TimeSlot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCH-TimeSlot')), opt=True)
    _Neighbouring_TDD_CellInformationItem_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')))
    _Neighbouring_TDD_CellInformationItem_cellIndividualOffset = INT(name=u'cellIndividualOffset', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellIndividualOffset')), opt=True)
    _Neighbouring_TDD_CellInformationItem_dPCHConstantValue = INT(name=u'dPCHConstantValue', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCHConstantValue')), opt=True)
    _Neighbouring_TDD_CellInformationItem_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')), opt=True)
    _Neighbouring_TDD_CellInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_TDD_CellInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD768')))
    _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    ____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 142), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 629), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id._const_tab = ____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_TDD_CellInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_TDD_CellInformationItem_iE_Extensions__item_._ext = None
    _Neighbouring_TDD_CellInformationItem_iE_Extensions._cont = __Neighbouring_TDD_CellInformationItem_iE_Extensions__item_
    _Neighbouring_TDD_CellInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_TDD_CellInformationItem._cont = ASN1Dict([
        (u'c-ID', _Neighbouring_TDD_CellInformationItem_c_ID),
        (u'uARFCNforNt', _Neighbouring_TDD_CellInformationItem_uARFCNforNt),
        (u'frameOffset', _Neighbouring_TDD_CellInformationItem_frameOffset),
        (u'cellParameterID', _Neighbouring_TDD_CellInformationItem_cellParameterID),
        (u'syncCase', _Neighbouring_TDD_CellInformationItem_syncCase),
        (u'timeSlot', _Neighbouring_TDD_CellInformationItem_timeSlot),
        (u'sCH-TimeSlot', _Neighbouring_TDD_CellInformationItem_sCH_TimeSlot),
        (u'sCTD-Indicator', _Neighbouring_TDD_CellInformationItem_sCTD_Indicator),
        (u'cellIndividualOffset', _Neighbouring_TDD_CellInformationItem_cellIndividualOffset),
        (u'dPCHConstantValue', _Neighbouring_TDD_CellInformationItem_dPCHConstantValue),
        (u'pCCPCH-Power', _Neighbouring_TDD_CellInformationItem_pCCPCH_Power),
        (u'iE-Extensions', _Neighbouring_TDD_CellInformationItem_iE_Extensions),
        ])
    Neighbouring_TDD_CellInformationItem._ext = []
    
    #-----< Neighbouring-TDD-CellInformationItem-ExtIEs >-----#
    Neighbouring_TDD_CellInformationItem_ExtIEs = CLASS(name=u'Neighbouring-TDD-CellInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_4 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD768')))
    _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    Neighbouring_TDD_CellInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 142), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 629), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NeighbouringTDDCellMeasurementInformation >-----#
    NeighbouringTDDCellMeasurementInformation = SEQ(name=u'NeighbouringTDDCellMeasurementInformation', mode=MODE_TYPE)
    _NeighbouringTDDCellMeasurementInformation_uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _NeighbouringTDDCellMeasurementInformation_uARFCN = INT(name=u'uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _NeighbouringTDDCellMeasurementInformation_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')))
    _NeighbouringTDDCellMeasurementInformation_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')), opt=True)
    _NeighbouringTDDCellMeasurementInformation_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _NeighbouringTDDCellMeasurementInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id._const_tab = ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab = ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id),
        (u'criticality', ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_._ext = None
    _NeighbouringTDDCellMeasurementInformation_iE_Extensions._cont = __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_
    _NeighbouringTDDCellMeasurementInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringTDDCellMeasurementInformation._cont = ASN1Dict([
        (u'uC-ID', _NeighbouringTDDCellMeasurementInformation_uC_ID),
        (u'uARFCN', _NeighbouringTDDCellMeasurementInformation_uARFCN),
        (u'cellParameterID', _NeighbouringTDDCellMeasurementInformation_cellParameterID),
        (u'timeSlot', _NeighbouringTDDCellMeasurementInformation_timeSlot),
        (u'midambleShiftAndBurstType', _NeighbouringTDDCellMeasurementInformation_midambleShiftAndBurstType),
        (u'iE-Extensions', _NeighbouringTDDCellMeasurementInformation_iE_Extensions),
        ])
    NeighbouringTDDCellMeasurementInformation._ext = []
    
    #-----< NeighbouringTDDCellMeasurementInformationItem-ExtIEs >-----#
    NeighbouringTDDCellMeasurementInformationItem_ExtIEs = CLASS(name=u'NeighbouringTDDCellMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    NeighbouringTDDCellMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeighbouringTDDCellMeasurementInformationLCR >-----#
    NeighbouringTDDCellMeasurementInformationLCR = SEQ(name=u'NeighbouringTDDCellMeasurementInformationLCR', mode=MODE_TYPE)
    _NeighbouringTDDCellMeasurementInformationLCR_uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _NeighbouringTDDCellMeasurementInformationLCR_uARFCN = INT(name=u'uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _NeighbouringTDDCellMeasurementInformationLCR_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')))
    _NeighbouringTDDCellMeasurementInformationLCR_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')), opt=True)
    _NeighbouringTDDCellMeasurementInformationLCR_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')), opt=True)
    _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id._const_tab = ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality._const_tab = ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id),
        (u'criticality', ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_._ext = None
    _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions._cont = __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_
    _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringTDDCellMeasurementInformationLCR._cont = ASN1Dict([
        (u'uC-ID', _NeighbouringTDDCellMeasurementInformationLCR_uC_ID),
        (u'uARFCN', _NeighbouringTDDCellMeasurementInformationLCR_uARFCN),
        (u'cellParameterID', _NeighbouringTDDCellMeasurementInformationLCR_cellParameterID),
        (u'timeSlotLCR', _NeighbouringTDDCellMeasurementInformationLCR_timeSlotLCR),
        (u'midambleShiftLCR', _NeighbouringTDDCellMeasurementInformationLCR_midambleShiftLCR),
        (u'iE-Extensions', _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions),
        ])
    NeighbouringTDDCellMeasurementInformationLCR._ext = []
    
    #-----< NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs >-----#
    NeighbouringTDDCellMeasurementInformationLCRItem_ExtIEs = CLASS(name=u'NeighbouringTDDCellMeasurementInformationLCRItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    NeighbouringTDDCellMeasurementInformationLCRItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeighbouringTDDCellMeasurementInformation768 >-----#
    NeighbouringTDDCellMeasurementInformation768 = SEQ(name=u'NeighbouringTDDCellMeasurementInformation768', mode=MODE_TYPE)
    _NeighbouringTDDCellMeasurementInformation768_uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _NeighbouringTDDCellMeasurementInformation768_uARFCN = INT(name=u'uARFCN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _NeighbouringTDDCellMeasurementInformation768_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')))
    _NeighbouringTDDCellMeasurementInformation768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')), opt=True)
    _NeighbouringTDDCellMeasurementInformation768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _NeighbouringTDDCellMeasurementInformation768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id._const_tab = ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id._const_tab_at = None
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id._const_tab_id = u'id'
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality._const_tab = ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue._const_tab = ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id),
        (u'criticality', ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality),
        (u'extensionValue', ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue),
        ])
    __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_._ext = None
    _NeighbouringTDDCellMeasurementInformation768_iE_Extensions._cont = __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_
    _NeighbouringTDDCellMeasurementInformation768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NeighbouringTDDCellMeasurementInformation768._cont = ASN1Dict([
        (u'uC-ID', _NeighbouringTDDCellMeasurementInformation768_uC_ID),
        (u'uARFCN', _NeighbouringTDDCellMeasurementInformation768_uARFCN),
        (u'cellParameterID', _NeighbouringTDDCellMeasurementInformation768_cellParameterID),
        (u'timeSlot', _NeighbouringTDDCellMeasurementInformation768_timeSlot),
        (u'midambleShiftAndBurstType768', _NeighbouringTDDCellMeasurementInformation768_midambleShiftAndBurstType768),
        (u'iE-Extensions', _NeighbouringTDDCellMeasurementInformation768_iE_Extensions),
        ])
    NeighbouringTDDCellMeasurementInformation768._ext = []
    
    #-----< NeighbouringTDDCellMeasurementInformationItem768-ExtIEs >-----#
    NeighbouringTDDCellMeasurementInformationItem768_ExtIEs = CLASS(name=u'NeighbouringTDDCellMeasurementInformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    NeighbouringTDDCellMeasurementInformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Neighbouring-LCR-TDD-CellInformation >-----#
    Neighbouring_LCR_TDD_CellInformation = SEQ_OF(name=u'Neighbouring-LCR-TDD-CellInformation', mode=MODE_TYPE)
    _Neighbouring_LCR_TDD_CellInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-LCR-TDD-CellInformationItem')))
    Neighbouring_LCR_TDD_CellInformation._cont = _Neighbouring_LCR_TDD_CellInformation__item_
    Neighbouring_LCR_TDD_CellInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Neighbouring-LCR-TDD-CellInformationItem >-----#
    Neighbouring_LCR_TDD_CellInformationItem = SEQ(name=u'Neighbouring-LCR-TDD-CellInformationItem', mode=MODE_TYPE)
    _Neighbouring_LCR_TDD_CellInformationItem_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Neighbouring_LCR_TDD_CellInformationItem_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _Neighbouring_LCR_TDD_CellInformationItem_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')), opt=True)
    _Neighbouring_LCR_TDD_CellInformationItem_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')))
    _Neighbouring_LCR_TDD_CellInformationItem_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')))
    _Neighbouring_LCR_TDD_CellInformationItem_cellIndividualOffset = INT(name=u'cellIndividualOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellIndividualOffset')), opt=True)
    _Neighbouring_LCR_TDD_CellInformationItem_dPCHConstantValue = INT(name=u'dPCHConstantValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCHConstantValue')), opt=True)
    _Neighbouring_LCR_TDD_CellInformationItem_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')), opt=True)
    _Neighbouring_LCR_TDD_CellInformationItem_restrictionStateIndicator = ENUM(name=u'restrictionStateIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RestrictionStateIndicator')), opt=True)
    _Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD-LCR')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-TDD-LCR')))
    ____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 883), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id._const_tab = ____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item_._ext = None
    _Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions._cont = __Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item_
    _Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_LCR_TDD_CellInformationItem._cont = ASN1Dict([
        (u'c-ID', _Neighbouring_LCR_TDD_CellInformationItem_c_ID),
        (u'uARFCNforNt', _Neighbouring_LCR_TDD_CellInformationItem_uARFCNforNt),
        (u'frameOffset', _Neighbouring_LCR_TDD_CellInformationItem_frameOffset),
        (u'cellParameterID', _Neighbouring_LCR_TDD_CellInformationItem_cellParameterID),
        (u'sCTD-Indicator', _Neighbouring_LCR_TDD_CellInformationItem_sCTD_Indicator),
        (u'cellIndividualOffset', _Neighbouring_LCR_TDD_CellInformationItem_cellIndividualOffset),
        (u'dPCHConstantValue', _Neighbouring_LCR_TDD_CellInformationItem_dPCHConstantValue),
        (u'pCCPCH-Power', _Neighbouring_LCR_TDD_CellInformationItem_pCCPCH_Power),
        (u'restrictionStateIndicator', _Neighbouring_LCR_TDD_CellInformationItem_restrictionStateIndicator),
        (u'iE-Extensions', _Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions),
        ])
    Neighbouring_LCR_TDD_CellInformationItem._ext = []
    
    #-----< Neighbouring-LCR-TDD-CellInformationItem-ExtIEs >-----#
    Neighbouring_LCR_TDD_CellInformationItem_ExtIEs = CLASS(name=u'Neighbouring-LCR-TDD-CellInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CoverageIndicator')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AntennaColocationIndicator')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD-LCR')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-TDD-LCR')))
    Neighbouring_LCR_TDD_CellInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 310), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 309), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 883), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Neighbouring-E-UTRA-CellInformation >-----#
    Neighbouring_E_UTRA_CellInformation = SEQ_OF(name=u'Neighbouring-E-UTRA-CellInformation', mode=MODE_TYPE)
    _Neighbouring_E_UTRA_CellInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformationItem')))
    Neighbouring_E_UTRA_CellInformation._cont = _Neighbouring_E_UTRA_CellInformation__item_
    Neighbouring_E_UTRA_CellInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Neighbouring-E-UTRA-CellInformationItem >-----#
    Neighbouring_E_UTRA_CellInformationItem = SEQ(name=u'Neighbouring-E-UTRA-CellInformationItem', mode=MODE_TYPE)
    _Neighbouring_E_UTRA_CellInformationItem_eCGI = SEQ(name=u'eCGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ECGI')))
    _Neighbouring_E_UTRA_CellInformationItem_eARFCN_Information = CHOICE(name=u'eARFCN-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EARFCN-Information')))
    _Neighbouring_E_UTRA_CellInformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PCI')))
    _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TAC')))
    _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-List')))
    _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFrequencyBandsIndicatorList-EUTRA')))
    ____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 939), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 940), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 941), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 972), (u'criticality', u'ignore'), (u'Extension', _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id._const_tab = ____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__criticality._const_tab = ____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__extensionValue._const_tab = ____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id),
        (u'criticality', ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__extensionValue),
        ])
    __Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item_._ext = None
    _Neighbouring_E_UTRA_CellInformationItem_iE_Extensions._cont = __Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item_
    _Neighbouring_E_UTRA_CellInformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Neighbouring_E_UTRA_CellInformationItem._cont = ASN1Dict([
        (u'eCGI', _Neighbouring_E_UTRA_CellInformationItem_eCGI),
        (u'eARFCN-Information', _Neighbouring_E_UTRA_CellInformationItem_eARFCN_Information),
        (u'iE-Extensions', _Neighbouring_E_UTRA_CellInformationItem_iE_Extensions),
        ])
    Neighbouring_E_UTRA_CellInformationItem._ext = []
    
    #-----< Neighbouring-E-UTRA-CellInformationItem-ExtIEs >-----#
    Neighbouring_E_UTRA_CellInformationItem_ExtIEs = CLASS(name=u'Neighbouring-E-UTRA-CellInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PCI')))
    _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TAC')))
    _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-List')))
    _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MultipleFrequencyBandsIndicatorList-EUTRA')))
    Neighbouring_E_UTRA_CellInformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 939), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 940), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 941), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 972), (u'criticality', u'ignore'), (u'Extension', _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MultipleFrequencyBandsIndicatorList-EUTRA >-----#
    MultipleFrequencyBandsIndicatorList_EUTRA = SEQ_OF(name=u'MultipleFrequencyBandsIndicatorList-EUTRA', mode=MODE_TYPE)
    _MultipleFrequencyBandsIndicatorList_EUTRA__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RadioFrequencyBandEUTRA')))
    MultipleFrequencyBandsIndicatorList_EUTRA._cont = _MultipleFrequencyBandsIndicatorList_EUTRA__item_
    MultipleFrequencyBandsIndicatorList_EUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< RadioFrequencyBandEUTRA >-----#
    RadioFrequencyBandEUTRA = INT(name=u'RadioFrequencyBandEUTRA', mode=MODE_TYPE)
    RadioFrequencyBandEUTRA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< NonCellSpecificTxDiversity >-----#
    NonCellSpecificTxDiversity = ENUM(name=u'NonCellSpecificTxDiversity', mode=MODE_TYPE)
    NonCellSpecificTxDiversity._cont = ASN1Dict([(u'txDiversity', 0)])
    NonCellSpecificTxDiversity._ext = []
    
    #-----< Non-rectangular-resource-allocation-indicator >-----#
    Non_rectangular_resource_allocation_indicator = ENUM(name=u'Non-rectangular-resource-allocation-indicator', mode=MODE_TYPE)
    Non_rectangular_resource_allocation_indicator._cont = ASN1Dict([(u'activate', 0)])
    Non_rectangular_resource_allocation_indicator._ext = None
    
    #-----< Non-rectangular-resource-timeslot-set >-----#
    Non_rectangular_resource_timeslot_set = BIT_STR(name=u'Non-rectangular-resource-timeslot-set', mode=MODE_TYPE)
    Non_rectangular_resource_timeslot_set._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< NotProvidedCellList >-----#
    NotProvidedCellList = SEQ_OF(name=u'NotProvidedCellList', mode=MODE_TYPE)
    _NotProvidedCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMSChannelTypeCellList')))
    NotProvidedCellList._cont = _NotProvidedCellList__item_
    NotProvidedCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< NrOfDLchannelisationcodes >-----#
    NrOfDLchannelisationcodes = INT(name=u'NrOfDLchannelisationcodes', mode=MODE_TYPE)
    NrOfDLchannelisationcodes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< NrOfTransportBlocks >-----#
    NrOfTransportBlocks = INT(name=u'NrOfTransportBlocks', mode=MODE_TYPE)
    NrOfTransportBlocks._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< NRT-Load-Information-Value-IncrDecrThres >-----#
    NRT_Load_Information_Value_IncrDecrThres = INT(name=u'NRT-Load-Information-Value-IncrDecrThres', mode=MODE_TYPE)
    NRT_Load_Information_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< NRT-Load-Information-Value >-----#
    NRT_Load_Information_Value = INT(name=u'NRT-Load-Information-Value', mode=MODE_TYPE)
    NRT_Load_Information_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< NRTLoadInformationValue >-----#
    NRTLoadInformationValue = SEQ(name=u'NRTLoadInformationValue', mode=MODE_TYPE)
    _NRTLoadInformationValue_uplinkNRTLoadInformationValue = INT(name=u'uplinkNRTLoadInformationValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRTLoadInformationValue_uplinkNRTLoadInformationValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _NRTLoadInformationValue_downlinkNRTLoadInformationValue = INT(name=u'downlinkNRTLoadInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NRTLoadInformationValue_downlinkNRTLoadInformationValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    NRTLoadInformationValue._cont = ASN1Dict([
        (u'uplinkNRTLoadInformationValue', _NRTLoadInformationValue_uplinkNRTLoadInformationValue),
        (u'downlinkNRTLoadInformationValue', _NRTLoadInformationValue_downlinkNRTLoadInformationValue),
        ])
    NRTLoadInformationValue._ext = None
    
    #-----< N-E-UCCH >-----#
    N_E_UCCH = INT(name=u'N-E-UCCH', mode=MODE_TYPE)
    N_E_UCCH._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< N-E-UCCH-LCR >-----#
    N_E_UCCH_LCR = INT(name=u'N-E-UCCH-LCR', mode=MODE_TYPE)
    N_E_UCCH_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Number-Of-Supported-Carriers >-----#
    Number_Of_Supported_Carriers = ENUM(name=u'Number-Of-Supported-Carriers', mode=MODE_TYPE)
    Number_Of_Supported_Carriers._cont = ASN1Dict([(u'one-one-carrier', 0), (u'one-three-carrier', 1), (u'three-three-carrier', 2), (u'one-six-carrier', 3), (u'three-six-carrier', 4), (u'six-six-carrier', 5), (u'one-two-carrier-discontiguous', 6), (u'two-two-carrier-discontiguous', 7), (u'one-two-carrier-contiguous', 8), (u'two-two-carrier-contiguous', 9)])
    Number_Of_Supported_Carriers._ext = [u'one-two-carrier-discontiguous', u'two-two-carrier-discontiguous', u'one-two-carrier-contiguous', u'two-two-carrier-contiguous']
    
    #-----< NumHS-SCCH-Codes >-----#
    NumHS_SCCH_Codes = INT(name=u'NumHS-SCCH-Codes', mode=MODE_TYPE)
    NumHS_SCCH_Codes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< NoOfTargetCellHS-SCCH-Order >-----#
    NoOfTargetCellHS_SCCH_Order = INT(name=u'NoOfTargetCellHS-SCCH-Order', mode=MODE_TYPE)
    NoOfTargetCellHS_SCCH_Order._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< Non-Serving-RL-Preconfig-Setup >-----#
    Non_Serving_RL_Preconfig_Setup = SEQ(name=u'Non-Serving-RL-Preconfig-Setup', mode=MODE_TYPE)
    _Non_Serving_RL_Preconfig_Setup_new_non_serving_RL_selection = CHOICE(name=u'new-non-serving-RL-selection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'New-non-serving-RL-setup-selection')))
    _Non_Serving_RL_Preconfig_Setup_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup')))
    _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 875), (u'criticality', u'ignore'), (u'Extension', _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id._const_tab = ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id._const_tab_at = None
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id._const_tab_id = u'id'
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality._const_tab = ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue._const_tab = ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id),
        (u'criticality', ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality),
        (u'extensionValue', ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue),
        ])
    __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_._ext = None
    _Non_Serving_RL_Preconfig_Setup_iE_Extensions._cont = __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_
    _Non_Serving_RL_Preconfig_Setup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Serving_RL_Preconfig_Setup._cont = ASN1Dict([
        (u'new-non-serving-RL-selection', _Non_Serving_RL_Preconfig_Setup_new_non_serving_RL_selection),
        (u'iE-Extensions', _Non_Serving_RL_Preconfig_Setup_iE_Extensions),
        ])
    Non_Serving_RL_Preconfig_Setup._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Setup-ExtIEs >-----#
    Non_Serving_RL_Preconfig_Setup_ExtIEs = CLASS(name=u'Non-Serving-RL-Preconfig-Setup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup')))
    _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    Non_Serving_RL_Preconfig_Setup_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 875), (u'criticality', u'ignore'), (u'Extension', _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup >-----#
    Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup = NULL(name=u'Additional-E-DCH-Non-Serving-RL-Preconfiguration-Setup', mode=MODE_TYPE)
    
    #-----< New-non-serving-RL-setup-selection >-----#
    New_non_serving_RL_setup_selection = CHOICE(name=u'New-non-serving-RL-setup-selection', mode=MODE_TYPE)
    _New_non_serving_RL_setup_selection_new_Serving_RL_in_DRNS = NULL(name=u'new-Serving-RL-in-DRNS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _New_non_serving_RL_setup_selection_new_Serving_RL_Not_in_DRNS = NULL(name=u'new-Serving-RL-Not-in-DRNS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _New_non_serving_RL_setup_selection_new_Serving_RL_in_or_Not_in_DRNS = NULL(name=u'new-Serving-RL-in-or-Not-in-DRNS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    New_non_serving_RL_setup_selection._cont = ASN1Dict([
        (u'new-Serving-RL-in-DRNS', _New_non_serving_RL_setup_selection_new_Serving_RL_in_DRNS),
        (u'new-Serving-RL-Not-in-DRNS', _New_non_serving_RL_setup_selection_new_Serving_RL_Not_in_DRNS),
        (u'new-Serving-RL-in-or-Not-in-DRNS', _New_non_serving_RL_setup_selection_new_Serving_RL_in_or_Not_in_DRNS),
        ])
    New_non_serving_RL_setup_selection._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Info >-----#
    Non_Serving_RL_Preconfig_Info = SEQ(name=u'Non-Serving-RL-Preconfig-Info', mode=MODE_TYPE)
    _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_A = SEQ(name=u'new-non-serving-RL-E-DCH-FDD-DL-ControlChannelInformation-A', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_B = SEQ(name=u'new-non-serving-RL-E-DCH-FDD-DL-ControlChannelInformation-B', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_C = SEQ(name=u'new-non-serving-RL-E-DCH-FDD-DL-ControlChannelInformation-C', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    _Non_Serving_RL_Preconfig_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList')))
    _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 876), (u'criticality', u'ignore'), (u'Extension', _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id._const_tab = ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id._const_tab_at = None
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality._const_tab = ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue._const_tab = ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id),
        (u'criticality', ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue),
        ])
    __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_._ext = None
    _Non_Serving_RL_Preconfig_Info_iE_Extensions._cont = __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_
    _Non_Serving_RL_Preconfig_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Non_Serving_RL_Preconfig_Info._cont = ASN1Dict([
        (u'new-non-serving-RL-E-DCH-FDD-DL-ControlChannelInformation-A', _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_A),
        (u'new-non-serving-RL-E-DCH-FDD-DL-ControlChannelInformation-B', _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_B),
        (u'new-non-serving-RL-E-DCH-FDD-DL-ControlChannelInformation-C', _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_C),
        (u'iE-Extensions', _Non_Serving_RL_Preconfig_Info_iE_Extensions),
        ])
    Non_Serving_RL_Preconfig_Info._ext = []
    
    #-----< Non-Serving-RL-Preconfig-Info-ExtIEs >-----#
    Non_Serving_RL_Preconfig_Info_ExtIEs = CLASS(name=u'Non-Serving-RL-Preconfig-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList')))
    _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    Non_Serving_RL_Preconfig_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 876), (u'criticality', u'ignore'), (u'Extension', _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList >-----#
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList = SEQ_OF(name=u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList', mode=MODE_TYPE)
    _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A = SEQ(name=u'new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-A', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B = SEQ(name=u'new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-B', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C = SEQ(name=u'new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-C', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')), opt=True)
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id._const_tab = _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id._const_tab_at = None
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality._const_tab = _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue._const_tab = _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id),
        (u'criticality', ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue),
        ])
    ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_._ext = None
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions._cont = ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_
    __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_._cont = ASN1Dict([
        (u'new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-A', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A),
        (u'new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-B', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B),
        (u'new-non-serving-RL-E-DCH-FDD-DL-Control-Channel-Information-C', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C),
        (u'iE-Extensions', __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions),
        ])
    _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_._ext = []
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList._cont = _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs >-----#
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList_ExtIEs = CLASS(name=u'Additional-E-DCH-New-non-serving-RL-E-DCH-FDD-DL-Control-Channel-InfoList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NeedforIdleInterval >-----#
    NeedforIdleInterval = ENUM(name=u'NeedforIdleInterval', mode=MODE_TYPE)
    NeedforIdleInterval._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    NeedforIdleInterval._ext = None
    
    #-----< OnModification >-----#
    OnModification = SEQ(name=u'OnModification', mode=MODE_TYPE)
    _OnModification_measurementThreshold = CHOICE(name=u'measurementThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementThreshold')))
    _OnModification_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OnModification_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___OnModification_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____OnModification_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____OnModification_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnModification_iE_Extensions__item__id._const_tab = ____OnModification_iE_Extensions__item__id_tab
    ___OnModification_iE_Extensions__item__id._const_tab_at = None
    ___OnModification_iE_Extensions__item__id._const_tab_id = u'id'
    ___OnModification_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____OnModification_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____OnModification_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnModification_iE_Extensions__item__criticality._const_tab = ____OnModification_iE_Extensions__item__criticality_tab
    ___OnModification_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___OnModification_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___OnModification_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____OnModification_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____OnModification_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnModification_iE_Extensions__item__extensionValue._const_tab = ____OnModification_iE_Extensions__item__extensionValue_tab
    ___OnModification_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___OnModification_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __OnModification_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___OnModification_iE_Extensions__item__id),
        (u'criticality', ___OnModification_iE_Extensions__item__criticality),
        (u'extensionValue', ___OnModification_iE_Extensions__item__extensionValue),
        ])
    __OnModification_iE_Extensions__item_._ext = None
    _OnModification_iE_Extensions._cont = __OnModification_iE_Extensions__item_
    _OnModification_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OnModification._cont = ASN1Dict([
        (u'measurementThreshold', _OnModification_measurementThreshold),
        (u'iE-Extensions', _OnModification_iE_Extensions),
        ])
    OnModification._ext = []
    
    #-----< OnModification-ExtIEs >-----#
    OnModification_ExtIEs = CLASS(name=u'OnModification-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    OnModification_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OnModificationInformation >-----#
    OnModificationInformation = SEQ(name=u'OnModificationInformation', mode=MODE_TYPE)
    _OnModificationInformation_informationThreshold = CHOICE(name=u'informationThreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InformationThreshold')), opt=True)
    _OnModificationInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OnModificationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___OnModificationInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____OnModificationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____OnModificationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnModificationInformation_iE_Extensions__item__id._const_tab = ____OnModificationInformation_iE_Extensions__item__id_tab
    ___OnModificationInformation_iE_Extensions__item__id._const_tab_at = None
    ___OnModificationInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___OnModificationInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____OnModificationInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____OnModificationInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnModificationInformation_iE_Extensions__item__criticality._const_tab = ____OnModificationInformation_iE_Extensions__item__criticality_tab
    ___OnModificationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___OnModificationInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___OnModificationInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____OnModificationInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____OnModificationInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OnModificationInformation_iE_Extensions__item__extensionValue._const_tab = ____OnModificationInformation_iE_Extensions__item__extensionValue_tab
    ___OnModificationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___OnModificationInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __OnModificationInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___OnModificationInformation_iE_Extensions__item__id),
        (u'criticality', ___OnModificationInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___OnModificationInformation_iE_Extensions__item__extensionValue),
        ])
    __OnModificationInformation_iE_Extensions__item_._ext = None
    _OnModificationInformation_iE_Extensions._cont = __OnModificationInformation_iE_Extensions__item_
    _OnModificationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OnModificationInformation._cont = ASN1Dict([
        (u'informationThreshold', _OnModificationInformation_informationThreshold),
        (u'iE-Extensions', _OnModificationInformation_iE_Extensions),
        ])
    OnModificationInformation._ext = []
    
    #-----< OnModificationInformation-ExtIEs >-----#
    OnModificationInformation_ExtIEs = CLASS(name=u'OnModificationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    OnModificationInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OrdinalNumberOfFrequency >-----#
    OrdinalNumberOfFrequency = INT(name=u'OrdinalNumberOfFrequency', mode=MODE_TYPE)
    OrdinalNumberOfFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=[], er=[])
    
    #-----< Out-of-Sychronization-Window >-----#
    Out_of_Sychronization_Window = ENUM(name=u'Out-of-Sychronization-Window', mode=MODE_TYPE)
    Out_of_Sychronization_Window._cont = ASN1Dict([(u'ms40', 0), (u'ms80', 1), (u'ms160', 2), (u'ms320', 3), (u'ms640', 4)])
    Out_of_Sychronization_Window._ext = []
    
    #-----< PagingCause >-----#
    PagingCause = ENUM(name=u'PagingCause', mode=MODE_TYPE)
    PagingCause._cont = ASN1Dict([(u'terminating-conversational-call', 0), (u'terminating-streaming-call', 1), (u'terminating-interactive-call', 2), (u'terminating-background-call', 3), (u'terminating-low-priority-signalling', 4), (u'terminating-high-priority-signalling', 5), (u'terminating-cause-unknown', 6)])
    PagingCause._ext = [u'terminating-high-priority-signalling', u'terminating-cause-unknown']
    
    #-----< PagingRecordType >-----#
    PagingRecordType = ENUM(name=u'PagingRecordType', mode=MODE_TYPE)
    PagingRecordType._cont = ASN1Dict([(u'imsi-gsm-map', 0), (u'tmsi-gsm-map', 1), (u'p-tmsi-gsm-map', 2), (u'imsi-ds-41', 3), (u'tmsi-ds-41', 4)])
    PagingRecordType._ext = []
    
    #-----< PartialReportingIndicator >-----#
    PartialReportingIndicator = ENUM(name=u'PartialReportingIndicator', mode=MODE_TYPE)
    PartialReportingIndicator._cont = ASN1Dict([(u'partial-reporting-allowed', 0)])
    PartialReportingIndicator._ext = None
    
    #-----< Pattern-Sequence-Identifier >-----#
    Pattern_Sequence_Identifier = INT(name=u'Pattern-Sequence-Identifier', mode=MODE_TYPE)
    Pattern_Sequence_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< PayloadCRC-PresenceIndicator >-----#
    PayloadCRC_PresenceIndicator = ENUM(name=u'PayloadCRC-PresenceIndicator', mode=MODE_TYPE)
    PayloadCRC_PresenceIndicator._cont = ASN1Dict([(u'crc-included', 0), (u'crc-not-included', 1)])
    PayloadCRC_PresenceIndicator._ext = None
    
    #-----< PCCPCH-Power >-----#
    PCCPCH_Power = INT(name=u'PCCPCH-Power', mode=MODE_TYPE)
    PCCPCH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-150, ub=400)], ev=[], er=[])
    
    #-----< PCH-InformationList >-----#
    PCH_InformationList = SEQ_OF(name=u'PCH-InformationList', mode=MODE_TYPE)
    _PCH_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PCH-InformationItem')))
    PCH_InformationList._cont = _PCH_InformationList__item_
    PCH_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    
    #-----< PCH-InformationItem >-----#
    PCH_InformationItem = SEQ(name=u'PCH-InformationItem', mode=MODE_TYPE)
    _PCH_InformationItem_transportFormatSet = SEQ(name=u'transportFormatSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _PCH_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PCH_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PCH_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PCH_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PCH_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCH_InformationItem_iE_Extensions__item__id._const_tab = ____PCH_InformationItem_iE_Extensions__item__id_tab
    ___PCH_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___PCH_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PCH_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PCH_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PCH_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCH_InformationItem_iE_Extensions__item__criticality._const_tab = ____PCH_InformationItem_iE_Extensions__item__criticality_tab
    ___PCH_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PCH_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PCH_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PCH_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PCH_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PCH_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____PCH_InformationItem_iE_Extensions__item__extensionValue_tab
    ___PCH_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PCH_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PCH_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PCH_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___PCH_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PCH_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __PCH_InformationItem_iE_Extensions__item_._ext = None
    _PCH_InformationItem_iE_Extensions._cont = __PCH_InformationItem_iE_Extensions__item_
    _PCH_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PCH_InformationItem._cont = ASN1Dict([
        (u'transportFormatSet', _PCH_InformationItem_transportFormatSet),
        (u'iE-Extensions', _PCH_InformationItem_iE_Extensions),
        ])
    PCH_InformationItem._ext = []
    
    #-----< PCH-InformationItem-ExtIEs >-----#
    PCH_InformationItem_ExtIEs = CLASS(name=u'PCH-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PCH_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PC-Preamble >-----#
    PC_Preamble = INT(name=u'PC-Preamble', mode=MODE_TYPE)
    PC_Preamble._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< PCI >-----#
    PCI = INT(name=u'PCI', mode=MODE_TYPE)
    PCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=[], er=[])
    
    #-----< Periodic >-----#
    Periodic = SEQ(name=u'Periodic', mode=MODE_TYPE)
    _Periodic_reportPeriodicity = CHOICE(name=u'reportPeriodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ReportPeriodicity')))
    _Periodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Periodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Periodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Periodic_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Periodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Periodic_iE_Extensions__item__id._const_tab = ____Periodic_iE_Extensions__item__id_tab
    ___Periodic_iE_Extensions__item__id._const_tab_at = None
    ___Periodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___Periodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Periodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Periodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Periodic_iE_Extensions__item__criticality._const_tab = ____Periodic_iE_Extensions__item__criticality_tab
    ___Periodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Periodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Periodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Periodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Periodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Periodic_iE_Extensions__item__extensionValue._const_tab = ____Periodic_iE_Extensions__item__extensionValue_tab
    ___Periodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Periodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Periodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Periodic_iE_Extensions__item__id),
        (u'criticality', ___Periodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___Periodic_iE_Extensions__item__extensionValue),
        ])
    __Periodic_iE_Extensions__item_._ext = None
    _Periodic_iE_Extensions._cont = __Periodic_iE_Extensions__item_
    _Periodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Periodic._cont = ASN1Dict([
        (u'reportPeriodicity', _Periodic_reportPeriodicity),
        (u'iE-Extensions', _Periodic_iE_Extensions),
        ])
    Periodic._ext = []
    
    #-----< Periodic-ExtIEs >-----#
    Periodic_ExtIEs = CLASS(name=u'Periodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Periodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PeriodicInformation >-----#
    PeriodicInformation = SEQ(name=u'PeriodicInformation', mode=MODE_TYPE)
    _PeriodicInformation_informationReportPeriodicity = CHOICE(name=u'informationReportPeriodicity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InformationReportPeriodicity')))
    _PeriodicInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PeriodicInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PeriodicInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PeriodicInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicInformation_iE_Extensions__item__id._const_tab = ____PeriodicInformation_iE_Extensions__item__id_tab
    ___PeriodicInformation_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PeriodicInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PeriodicInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PeriodicInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicInformation_iE_Extensions__item__criticality._const_tab = ____PeriodicInformation_iE_Extensions__item__criticality_tab
    ___PeriodicInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PeriodicInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PeriodicInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PeriodicInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PeriodicInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicInformation_iE_Extensions__item__extensionValue._const_tab = ____PeriodicInformation_iE_Extensions__item__extensionValue_tab
    ___PeriodicInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PeriodicInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PeriodicInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PeriodicInformation_iE_Extensions__item__id),
        (u'criticality', ___PeriodicInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PeriodicInformation_iE_Extensions__item__extensionValue),
        ])
    __PeriodicInformation_iE_Extensions__item_._ext = None
    _PeriodicInformation_iE_Extensions._cont = __PeriodicInformation_iE_Extensions__item_
    _PeriodicInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicInformation._cont = ASN1Dict([
        (u'informationReportPeriodicity', _PeriodicInformation_informationReportPeriodicity),
        (u'iE-Extensions', _PeriodicInformation_iE_Extensions),
        ])
    PeriodicInformation._ext = []
    
    #-----< PeriodicInformation-ExtIEs >-----#
    PeriodicInformation_ExtIEs = CLASS(name=u'PeriodicInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PeriodicInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Permanent-NAS-UE-Identity >-----#
    Permanent_NAS_UE_Identity = CHOICE(name=u'Permanent-NAS-UE-Identity', mode=MODE_TYPE)
    _Permanent_NAS_UE_Identity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IMSI')))
    Permanent_NAS_UE_Identity._cont = ASN1Dict([
        (u'imsi', _Permanent_NAS_UE_Identity_imsi),
        ])
    Permanent_NAS_UE_Identity._ext = []
    
    #-----< Phase-Reference-Update-Indicator >-----#
    Phase_Reference_Update_Indicator = ENUM(name=u'Phase-Reference-Update-Indicator', mode=MODE_TYPE)
    Phase_Reference_Update_Indicator._cont = ASN1Dict([(u'phase-reference-needs-to-be-changed', 0)])
    Phase_Reference_Update_Indicator._ext = None
    
    #-----< PLCCHsequenceNumber >-----#
    PLCCHsequenceNumber = INT(name=u'PLCCHsequenceNumber', mode=MODE_TYPE)
    PLCCHsequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name=u'PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PLMN-List >-----#
    PLMN_List = SEQ_OF(name=u'PLMN-List', mode=MODE_TYPE)
    _PLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    PLMN_List._cont = _PLMN_List__item_
    PLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< PowerAdjustmentType >-----#
    PowerAdjustmentType = ENUM(name=u'PowerAdjustmentType', mode=MODE_TYPE)
    PowerAdjustmentType._cont = ASN1Dict([(u'none', 0), (u'common', 1), (u'individual', 2)])
    PowerAdjustmentType._ext = None
    
    #-----< PowerOffset >-----#
    PowerOffset = INT(name=u'PowerOffset', mode=MODE_TYPE)
    PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=None, er=[])
    
    #-----< PowerOffsetForSecondaryCPICHforMIMO >-----#
    PowerOffsetForSecondaryCPICHforMIMO = INT(name=u'PowerOffsetForSecondaryCPICHforMIMO', mode=MODE_TYPE)
    PowerOffsetForSecondaryCPICHforMIMO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-6, ub=0)], ev=None, er=[])
    
    #-----< PowerOffsetForSecondaryCPICHforMIMORequestIndicator >-----#
    PowerOffsetForSecondaryCPICHforMIMORequestIndicator = NULL(name=u'PowerOffsetForSecondaryCPICHforMIMORequestIndicator', mode=MODE_TYPE)
    
    #-----< PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas >-----#
    PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas = SEQ_OF(name=u'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas', mode=MODE_TYPE)
    _PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Associated-Secondary-CPICH')))
    PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas._cont = _PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas__item_
    PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Associated-Secondary-CPICH >-----#
    Associated_Secondary_CPICH = SEQ(name=u'Associated-Secondary-CPICH', mode=MODE_TYPE)
    _Associated_Secondary_CPICH_associated_secondary_CPICH_channelId = INT(name=u'associated-secondary-CPICH-channelId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonPhysicalChannelID')))
    _Associated_Secondary_CPICH_associated_secondary_CPICH = INT(name=u'associated-secondary-CPICH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas')), opt=True)
    _Associated_Secondary_CPICH_associated_D_CPICH_channelId = INT(name=u'associated-D-CPICH-channelId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonPhysicalChannelID')), opt=True)
    _Associated_Secondary_CPICH_associated_D_CPICH = INT(name=u'associated-D-CPICH', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas')), opt=True)
    _Associated_Secondary_CPICH_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Associated_Secondary_CPICH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Associated_Secondary_CPICH_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Associated_Secondary_CPICH_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Associated_Secondary_CPICH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_Secondary_CPICH_iE_Extensions__item__id._const_tab = ____Associated_Secondary_CPICH_iE_Extensions__item__id_tab
    ___Associated_Secondary_CPICH_iE_Extensions__item__id._const_tab_at = None
    ___Associated_Secondary_CPICH_iE_Extensions__item__id._const_tab_id = u'id'
    ___Associated_Secondary_CPICH_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Associated_Secondary_CPICH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Associated_Secondary_CPICH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_Secondary_CPICH_iE_Extensions__item__criticality._const_tab = ____Associated_Secondary_CPICH_iE_Extensions__item__criticality_tab
    ___Associated_Secondary_CPICH_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Associated_Secondary_CPICH_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Associated_Secondary_CPICH_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Associated_Secondary_CPICH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Associated_Secondary_CPICH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Associated_Secondary_CPICH_iE_Extensions__item__extensionValue._const_tab = ____Associated_Secondary_CPICH_iE_Extensions__item__extensionValue_tab
    ___Associated_Secondary_CPICH_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Associated_Secondary_CPICH_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Associated_Secondary_CPICH_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Associated_Secondary_CPICH_iE_Extensions__item__id),
        (u'criticality', ___Associated_Secondary_CPICH_iE_Extensions__item__criticality),
        (u'extensionValue', ___Associated_Secondary_CPICH_iE_Extensions__item__extensionValue),
        ])
    __Associated_Secondary_CPICH_iE_Extensions__item_._ext = None
    _Associated_Secondary_CPICH_iE_Extensions._cont = __Associated_Secondary_CPICH_iE_Extensions__item_
    _Associated_Secondary_CPICH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Associated_Secondary_CPICH._cont = ASN1Dict([
        (u'associated-secondary-CPICH-channelId', _Associated_Secondary_CPICH_associated_secondary_CPICH_channelId),
        (u'associated-secondary-CPICH', _Associated_Secondary_CPICH_associated_secondary_CPICH),
        (u'associated-D-CPICH-channelId', _Associated_Secondary_CPICH_associated_D_CPICH_channelId),
        (u'associated-D-CPICH', _Associated_Secondary_CPICH_associated_D_CPICH),
        (u'iE-Extensions', _Associated_Secondary_CPICH_iE_Extensions),
        ])
    Associated_Secondary_CPICH._ext = []
    
    #-----< Associated-Secondary-CPICH-Item-ExtIEs >-----#
    Associated_Secondary_CPICH_Item_ExtIEs = CLASS(name=u'Associated-Secondary-CPICH-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Associated_Secondary_CPICH_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonPhysicalChannelID >-----#
    CommonPhysicalChannelID = INT(name=u'CommonPhysicalChannelID', mode=MODE_TYPE)
    CommonPhysicalChannelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator >-----#
    PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator = NULL(name=u'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator', mode=MODE_TYPE)
    
    #-----< PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas >-----#
    PowerOffsetForSCPICH_DCPICHforMIMOwithfourtransmitantennas = INT(name=u'PowerOffsetForSCPICH-DCPICHforMIMOwithfourtransmitantennas', mode=MODE_TYPE)
    PowerOffsetForSCPICH_DCPICHforMIMOwithfourtransmitantennas._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=0)], ev=None, er=[])
    
    #-----< PRC >-----#
    PRC = INT(name=u'PRC', mode=MODE_TYPE)
    PRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    
    #-----< PRCDeviation >-----#
    PRCDeviation = ENUM(name=u'PRCDeviation', mode=MODE_TYPE)
    PRCDeviation._cont = ASN1Dict([(u'prcd1', 0), (u'prcd2', 1), (u'prcd5', 2), (u'prcd10', 3)])
    PRCDeviation._ext = []
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name=u'Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([(u'shall-not-trigger-pre-emption', 0), (u'may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name=u'Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([(u'not-pre-emptable', 0), (u'pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< Precoder-Weight-Set-Restriction >-----#
    Precoder_Weight_Set_Restriction = BIT_STR(name=u'Precoder-Weight-Set-Restriction', mode=MODE_TYPE)
    Precoder_Weight_Set_Restriction._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< PredictedSFNSFNDeviationLimit >-----#
    PredictedSFNSFNDeviationLimit = INT(name=u'PredictedSFNSFNDeviationLimit', mode=MODE_TYPE)
    PredictedSFNSFNDeviationLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PredictedTUTRANGPSDeviationLimit >-----#
    PredictedTUTRANGPSDeviationLimit = INT(name=u'PredictedTUTRANGPSDeviationLimit', mode=MODE_TYPE)
    PredictedTUTRANGPSDeviationLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< PreferredFrequencyLayerInfo >-----#
    PreferredFrequencyLayerInfo = SEQ(name=u'PreferredFrequencyLayerInfo', mode=MODE_TYPE)
    _PreferredFrequencyLayerInfo_defaultPreferredFrequency = INT(name=u'defaultPreferredFrequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _PreferredFrequencyLayerInfo_additionalPreferredFrequency = SEQ_OF(name=u'additionalPreferredFrequency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AdditionalPreferredFrequency')), opt=True)
    _PreferredFrequencyLayerInfo_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PreferredFrequencyLayerInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PreferredFrequencyLayerInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PreferredFrequencyLayerInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__id._const_tab = ____PreferredFrequencyLayerInfo_iE_Extensions__item__id_tab
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__id._const_tab_at = None
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__id._const_tab_id = u'id'
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PreferredFrequencyLayerInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PreferredFrequencyLayerInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__criticality._const_tab = ____PreferredFrequencyLayerInfo_iE_Extensions__item__criticality_tab
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue._const_tab = ____PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue_tab
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PreferredFrequencyLayerInfo_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PreferredFrequencyLayerInfo_iE_Extensions__item__id),
        (u'criticality', ___PreferredFrequencyLayerInfo_iE_Extensions__item__criticality),
        (u'extensionValue', ___PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue),
        ])
    __PreferredFrequencyLayerInfo_iE_Extensions__item_._ext = None
    _PreferredFrequencyLayerInfo_iE_Extensions._cont = __PreferredFrequencyLayerInfo_iE_Extensions__item_
    _PreferredFrequencyLayerInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PreferredFrequencyLayerInfo._cont = ASN1Dict([
        (u'defaultPreferredFrequency', _PreferredFrequencyLayerInfo_defaultPreferredFrequency),
        (u'additionalPreferredFrequency', _PreferredFrequencyLayerInfo_additionalPreferredFrequency),
        (u'iE-Extensions', _PreferredFrequencyLayerInfo_iE_Extensions),
        ])
    PreferredFrequencyLayerInfo._ext = []
    
    #-----< PreferredFrequencyLayerInfo-ExtIEs >-----#
    PreferredFrequencyLayerInfo_ExtIEs = CLASS(name=u'PreferredFrequencyLayerInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PreferredFrequencyLayerInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrimaryCPICH-Power >-----#
    PrimaryCPICH_Power = INT(name=u'PrimaryCPICH-Power', mode=MODE_TYPE)
    PrimaryCPICH_Power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=500)], ev=None, er=[])
    
    #-----< PrimaryCPICH-EcNo >-----#
    PrimaryCPICH_EcNo = INT(name=u'PrimaryCPICH-EcNo', mode=MODE_TYPE)
    PrimaryCPICH_EcNo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-30, ub=30)], ev=None, er=[])
    
    #-----< Primary-CPICH-Usage-For-Channel-Estimation >-----#
    Primary_CPICH_Usage_For_Channel_Estimation = ENUM(name=u'Primary-CPICH-Usage-For-Channel-Estimation', mode=MODE_TYPE)
    Primary_CPICH_Usage_For_Channel_Estimation._cont = ASN1Dict([(u'primary-CPICH-may-be-used', 0), (u'primary-CPICH-shall-not-be-used', 1)])
    Primary_CPICH_Usage_For_Channel_Estimation._ext = None
    
    #-----< PrimaryCCPCH-RSCP >-----#
    PrimaryCCPCH_RSCP = INT(name=u'PrimaryCCPCH-RSCP', mode=MODE_TYPE)
    PrimaryCCPCH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=91)], ev=None, er=[])
    
    #-----< PrimaryCCPCH-RSCP-Delta >-----#
    PrimaryCCPCH_RSCP_Delta = INT(name=u'PrimaryCCPCH-RSCP-Delta', mode=MODE_TYPE)
    PrimaryCCPCH_RSCP_Delta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-5, ub=-1)], ev=[], er=[])
    
    #-----< PrimaryScramblingCode >-----#
    PrimaryScramblingCode = INT(name=u'PrimaryScramblingCode', mode=MODE_TYPE)
    PrimaryScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name=u'PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< PriorityQueue-Id >-----#
    PriorityQueue_Id = INT(name=u'PriorityQueue-Id', mode=MODE_TYPE)
    PriorityQueue_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoList >-----#
    PriorityQueue_InfoList = SEQ_OF(name=u'PriorityQueue-InfoList', mode=MODE_TYPE)
    _PriorityQueue_InfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoItem')))
    PriorityQueue_InfoList._cont = _PriorityQueue_InfoList__item_
    PriorityQueue_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem >-----#
    PriorityQueue_InfoItem = SEQ(name=u'PriorityQueue-InfoItem', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_priorityQueue_Id = INT(name=u'priorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_associatedHSDSCH_MACdFlow = INT(name=u'associatedHSDSCH-MACdFlow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _PriorityQueue_InfoItem_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _PriorityQueue_InfoItem_t1 = ENUM(name=u't1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'T1')))
    _PriorityQueue_InfoItem_discardTimer = ENUM(name=u'discardTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_mAC_hsWindowSize = ENUM(name=u'mAC-hsWindowSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-hsWindowSize')))
    _PriorityQueue_InfoItem_mAChsGuaranteedBitRate = INT(name=u'mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_mACdPDU_Size_Index = SEQ_OF(name=u'mACdPDU-Size-Index', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size-IndexList')))
    _PriorityQueue_InfoItem_rLC_Mode = ENUM(name=u'rLC-Mode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RLC-Mode')))
    _PriorityQueue_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-RLC-PDU-Size-Format')))
    _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 823), (u'criticality', u'ignore'), (u'Extension', _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 864), (u'criticality', u'ignore'), (u'Extension', _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PriorityQueue_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PriorityQueue_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___PriorityQueue_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_iE_Extensions._cont = __PriorityQueue_InfoItem_iE_Extensions__item_
    _PriorityQueue_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem._cont = ASN1Dict([
        (u'priorityQueue-Id', _PriorityQueue_InfoItem_priorityQueue_Id),
        (u'associatedHSDSCH-MACdFlow', _PriorityQueue_InfoItem_associatedHSDSCH_MACdFlow),
        (u'schedulingPriorityIndicator', _PriorityQueue_InfoItem_schedulingPriorityIndicator),
        (u't1', _PriorityQueue_InfoItem_t1),
        (u'discardTimer', _PriorityQueue_InfoItem_discardTimer),
        (u'mAC-hsWindowSize', _PriorityQueue_InfoItem_mAC_hsWindowSize),
        (u'mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_mAChsGuaranteedBitRate),
        (u'mACdPDU-Size-Index', _PriorityQueue_InfoItem_mACdPDU_Size_Index),
        (u'rLC-Mode', _PriorityQueue_InfoItem_rLC_Mode),
        (u'iE-Extensions', _PriorityQueue_InfoItem_iE_Extensions),
        ])
    PriorityQueue_InfoItem._ext = []
    
    #-----< PriorityQueue-InfoItem-ExtIEs >-----#
    PriorityQueue_InfoItem_ExtIEs = CLASS(name=u'PriorityQueue-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _PriorityQueue_InfoItem_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-RLC-PDU-Size-Format')))
    _PriorityQueue_InfoItem_ExtIEs_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate-Enforcement-Indicator')))
    PriorityQueue_InfoItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _PriorityQueue_InfoItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 823), (u'criticality', u'ignore'), (u'Extension', _PriorityQueue_InfoItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 864), (u'criticality', u'ignore'), (u'Extension', _PriorityQueue_InfoItem_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoList-EnhancedFACH-PCH >-----#
    PriorityQueue_InfoList_EnhancedFACH_PCH = SEQ_OF(name=u'PriorityQueue-InfoList-EnhancedFACH-PCH', mode=MODE_TYPE)
    _PriorityQueue_InfoList_EnhancedFACH_PCH__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoItem-EnhancedFACH-PCH')))
    PriorityQueue_InfoList_EnhancedFACH_PCH._cont = _PriorityQueue_InfoList_EnhancedFACH_PCH__item_
    PriorityQueue_InfoList_EnhancedFACH_PCH._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem-EnhancedFACH-PCH >-----#
    PriorityQueue_InfoItem_EnhancedFACH_PCH = SEQ(name=u'PriorityQueue-InfoItem-EnhancedFACH-PCH', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_priorityQueue_Id = INT(name=u'priorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_t1 = ENUM(name=u't1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'T1')))
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_mAC_ehs_Reset_Timer = ENUM(name=u'mAC-ehs-Reset-Timer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-ehs-Reset-Timer')))
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_discardTimer = ENUM(name=u'discardTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_mAC_hsWindowSize = ENUM(name=u'mAC-hsWindowSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-hsWindowSize')))
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_maximum_MACdPDU_Size = INT(name=u'maximum-MACdPDU-Size', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id._const_tab_id = u'id'
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality_tab
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue_tab
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id),
        (u'criticality', ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality),
        (u'extensionValue', ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions._cont = __PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item_
    _PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_EnhancedFACH_PCH._cont = ASN1Dict([
        (u'priorityQueue-Id', _PriorityQueue_InfoItem_EnhancedFACH_PCH_priorityQueue_Id),
        (u'schedulingPriorityIndicator', _PriorityQueue_InfoItem_EnhancedFACH_PCH_schedulingPriorityIndicator),
        (u't1', _PriorityQueue_InfoItem_EnhancedFACH_PCH_t1),
        (u'mAC-ehs-Reset-Timer', _PriorityQueue_InfoItem_EnhancedFACH_PCH_mAC_ehs_Reset_Timer),
        (u'discardTimer', _PriorityQueue_InfoItem_EnhancedFACH_PCH_discardTimer),
        (u'mAC-hsWindowSize', _PriorityQueue_InfoItem_EnhancedFACH_PCH_mAC_hsWindowSize),
        (u'maximum-MACdPDU-Size', _PriorityQueue_InfoItem_EnhancedFACH_PCH_maximum_MACdPDU_Size),
        (u'iE-Extensions', _PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions),
        ])
    PriorityQueue_InfoItem_EnhancedFACH_PCH._ext = []
    
    #-----< PriorityQueue-InfoItem-EnhancedFACH-PCH-ExtIEs >-----#
    PriorityQueue_InfoItem_EnhancedFACH_PCH_ExtIEs = CLASS(name=u'PriorityQueue-InfoItem-EnhancedFACH-PCH-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PriorityQueue_InfoItem_EnhancedFACH_PCH_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoList-to-Modify >-----#
    PriorityQueue_InfoList_to_Modify = SEQ_OF(name=u'PriorityQueue-InfoList-to-Modify', mode=MODE_TYPE)
    _PriorityQueue_InfoList_to_Modify__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ModifyPriorityQueue')))
    PriorityQueue_InfoList_to_Modify._cont = _PriorityQueue_InfoList_to_Modify__item_
    PriorityQueue_InfoList_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem-to-Add >-----#
    PriorityQueue_InfoItem_to_Add = SEQ(name=u'PriorityQueue-InfoItem-to-Add', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_to_Add_priorityQueue_Id = INT(name=u'priorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_to_Add_associatedHSDSCH_MACdFlow = INT(name=u'associatedHSDSCH-MACdFlow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _PriorityQueue_InfoItem_to_Add_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _PriorityQueue_InfoItem_to_Add_t1 = ENUM(name=u't1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'T1')))
    _PriorityQueue_InfoItem_to_Add_discardTimer = ENUM(name=u'discardTimer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_to_Add_mAC_hsWindowSize = ENUM(name=u'mAC-hsWindowSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-hsWindowSize')))
    _PriorityQueue_InfoItem_to_Add_mAChsGuaranteedBitRate = INT(name=u'mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_to_Add_mACdPDU_Size_Index = SEQ_OF(name=u'mACdPDU-Size-Index', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size-IndexList')))
    _PriorityQueue_InfoItem_to_Add_rLC_Mode = ENUM(name=u'rLC-Mode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RLC-Mode')))
    _PriorityQueue_InfoItem_to_Add_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-RLC-PDU-Size-Format')))
    ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 823), (u'criticality', u'ignore'), (u'Extension', _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id._const_tab_id = u'id'
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id),
        (u'criticality', ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality),
        (u'extensionValue', ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_to_Add_iE_Extensions._cont = __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_
    _PriorityQueue_InfoItem_to_Add_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_to_Add._cont = ASN1Dict([
        (u'priorityQueue-Id', _PriorityQueue_InfoItem_to_Add_priorityQueue_Id),
        (u'associatedHSDSCH-MACdFlow', _PriorityQueue_InfoItem_to_Add_associatedHSDSCH_MACdFlow),
        (u'schedulingPriorityIndicator', _PriorityQueue_InfoItem_to_Add_schedulingPriorityIndicator),
        (u't1', _PriorityQueue_InfoItem_to_Add_t1),
        (u'discardTimer', _PriorityQueue_InfoItem_to_Add_discardTimer),
        (u'mAC-hsWindowSize', _PriorityQueue_InfoItem_to_Add_mAC_hsWindowSize),
        (u'mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_to_Add_mAChsGuaranteedBitRate),
        (u'mACdPDU-Size-Index', _PriorityQueue_InfoItem_to_Add_mACdPDU_Size_Index),
        (u'rLC-Mode', _PriorityQueue_InfoItem_to_Add_rLC_Mode),
        (u'iE-Extensions', _PriorityQueue_InfoItem_to_Add_iE_Extensions),
        ])
    PriorityQueue_InfoItem_to_Add._ext = []
    
    #-----< PriorityQueue-InfoItem-to-Add-ExtIEs >-----#
    PriorityQueue_InfoItem_to_Add_ExtIEs = CLASS(name=u'PriorityQueue-InfoItem-to-Add-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-RLC-PDU-Size-Format')))
    PriorityQueue_InfoItem_to_Add_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 823), (u'criticality', u'ignore'), (u'Extension', _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoItem-to-Modify >-----#
    PriorityQueue_InfoItem_to_Modify = SEQ(name=u'PriorityQueue-InfoItem-to-Modify', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_to_Modify_priorityQueue_Id = INT(name=u'priorityQueue-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_to_Modify_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_t1 = ENUM(name=u't1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'T1')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_discardTimer = ENUM(name=u'discardTimer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_mAC_hsWindowSize = ENUM(name=u'mAC-hsWindowSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAC-hsWindowSize')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_mAChsGuaranteedBitRate = INT(name=u'mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_mACdPDU_Size_Index_to_Modify = SEQ_OF(name=u'mACdPDU-Size-Index-to-Modify', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MACdPDU-Size-IndexList-to-Modify')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-RLC-PDU-Size-Format')))
    ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 823), (u'criticality', u'ignore'), (u'Extension', _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id),
        (u'criticality', ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_to_Modify_iE_Extensions._cont = __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_
    _PriorityQueue_InfoItem_to_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_to_Modify._cont = ASN1Dict([
        (u'priorityQueue-Id', _PriorityQueue_InfoItem_to_Modify_priorityQueue_Id),
        (u'schedulingPriorityIndicator', _PriorityQueue_InfoItem_to_Modify_schedulingPriorityIndicator),
        (u't1', _PriorityQueue_InfoItem_to_Modify_t1),
        (u'discardTimer', _PriorityQueue_InfoItem_to_Modify_discardTimer),
        (u'mAC-hsWindowSize', _PriorityQueue_InfoItem_to_Modify_mAC_hsWindowSize),
        (u'mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_to_Modify_mAChsGuaranteedBitRate),
        (u'mACdPDU-Size-Index-to-Modify', _PriorityQueue_InfoItem_to_Modify_mACdPDU_Size_Index_to_Modify),
        (u'iE-Extensions', _PriorityQueue_InfoItem_to_Modify_iE_Extensions),
        ])
    PriorityQueue_InfoItem_to_Modify._ext = []
    
    #-----< PriorityQueue-InfoItem-to-Modify-ExtIEs >-----#
    PriorityQueue_InfoItem_to_Modify_ExtIEs = CLASS(name=u'PriorityQueue-InfoItem-to-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAC-PDU-SizeExtended')))
    _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-RLC-PDU-Size-Format')))
    PriorityQueue_InfoItem_to_Modify_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 691), (u'criticality', u'reject'), (u'Extension', _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 823), (u'criticality', u'ignore'), (u'Extension', _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PriorityQueue-InfoList-to-Modify-Unsynchronised >-----#
    PriorityQueue_InfoList_to_Modify_Unsynchronised = SEQ_OF(name=u'PriorityQueue-InfoList-to-Modify-Unsynchronised', mode=MODE_TYPE)
    _PriorityQueue_InfoList_to_Modify_Unsynchronised__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-InfoItem-to-Modify-Unsynchronised')))
    PriorityQueue_InfoList_to_Modify_Unsynchronised._cont = _PriorityQueue_InfoList_to_Modify_Unsynchronised__item_
    PriorityQueue_InfoList_to_Modify_Unsynchronised._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< PriorityQueue-InfoItem-to-Modify-Unsynchronised >-----#
    PriorityQueue_InfoItem_to_Modify_Unsynchronised = SEQ(name=u'PriorityQueue-InfoItem-to-Modify-Unsynchronised', mode=MODE_TYPE)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_priorityQueueId = INT(name=u'priorityQueueId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PriorityQueue-Id')))
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_discardTimer = ENUM(name=u'discardTimer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiscardTimer')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_mAChsGuaranteedBitRate = INT(name=u'mAChsGuaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MAChsGuaranteedBitRate')), opt=True)
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab = ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_at = None
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id._const_tab_id = u'id'
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab = ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab = ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id),
        (u'criticality', ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality),
        (u'extensionValue', ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue),
        ])
    __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_._ext = None
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions._cont = __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_
    _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PriorityQueue_InfoItem_to_Modify_Unsynchronised._cont = ASN1Dict([
        (u'priorityQueueId', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_priorityQueueId),
        (u'schedulingPriorityIndicator', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_schedulingPriorityIndicator),
        (u'discardTimer', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_discardTimer),
        (u'mAChsGuaranteedBitRate', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_mAChsGuaranteedBitRate),
        (u'iE-Extensions', _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions),
        ])
    PriorityQueue_InfoItem_to_Modify_Unsynchronised._ext = []
    
    #-----< PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs >-----#
    PriorityQueue_InfoItem_to_Modify_Unsynchronised_ExtIEs = CLASS(name=u'PriorityQueue-InfoItem-to-Modify-Unsynchronised-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PriorityQueue_InfoItem_to_Modify_Unsynchronised_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PropagationDelay >-----#
    PropagationDelay = INT(name=u'PropagationDelay', mode=MODE_TYPE)
    PropagationDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProvidedInformation >-----#
    ProvidedInformation = SEQ(name=u'ProvidedInformation', mode=MODE_TYPE)
    _ProvidedInformation_mBMSChannelTypeInfo = SEQ(name=u'mBMSChannelTypeInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MBMSChannelTypeInfo')), opt=True)
    _ProvidedInformation_mBMSPreferredFreqLayerInfo = SEQ(name=u'mBMSPreferredFreqLayerInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MBMSPreferredFreqLayerInfo')), opt=True)
    _ProvidedInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ProvidedInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ProvidedInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ProvidedInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____ProvidedInformation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPCH-InformationList-LCRTDD')))
    _____ProvidedInformation_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ANRReportIndication')))
    ____ProvidedInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 725), (u'criticality', u'ignore'), (u'Extension', _____ProvidedInformation_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 899), (u'criticality', u'ignore'), (u'Extension', _____ProvidedInformation_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ProvidedInformation_iE_Extensions__item__id._const_tab = ____ProvidedInformation_iE_Extensions__item__id_tab
    ___ProvidedInformation_iE_Extensions__item__id._const_tab_at = None
    ___ProvidedInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___ProvidedInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ProvidedInformation_iE_Extensions__item__criticality._const_tab = ____ProvidedInformation_iE_Extensions__item__id_tab
    ___ProvidedInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ProvidedInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ProvidedInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ProvidedInformation_iE_Extensions__item__extensionValue._const_tab = ____ProvidedInformation_iE_Extensions__item__id_tab
    ___ProvidedInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ProvidedInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ProvidedInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ProvidedInformation_iE_Extensions__item__id),
        (u'criticality', ___ProvidedInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___ProvidedInformation_iE_Extensions__item__extensionValue),
        ])
    __ProvidedInformation_iE_Extensions__item_._ext = None
    _ProvidedInformation_iE_Extensions._cont = __ProvidedInformation_iE_Extensions__item_
    _ProvidedInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ProvidedInformation._cont = ASN1Dict([
        (u'mBMSChannelTypeInfo', _ProvidedInformation_mBMSChannelTypeInfo),
        (u'mBMSPreferredFreqLayerInfo', _ProvidedInformation_mBMSPreferredFreqLayerInfo),
        (u'iE-Extensions', _ProvidedInformation_iE_Extensions),
        ])
    ProvidedInformation._ext = []
    
    #-----< ProvideInformation-ExtIEs >-----#
    ProvideInformation_ExtIEs = CLASS(name=u'ProvideInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _ProvideInformation_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPCH-InformationList-LCRTDD')))
    _ProvideInformation_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ANRReportIndication')))
    ProvideInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 725), (u'criticality', u'ignore'), (u'Extension', _ProvideInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 899), (u'criticality', u'ignore'), (u'Extension', _ProvideInformation_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UpPCH-InformationList-LCRTDD >-----#
    UpPCH_InformationList_LCRTDD = SEQ_OF(name=u'UpPCH-InformationList-LCRTDD', mode=MODE_TYPE)
    _UpPCH_InformationList_LCRTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UpPCH_InformationList_LCRTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UpPCH_InformationList_LCRTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UpPCH_InformationList_LCRTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPCH-InformationItem-LCRTDD')))
    ___UpPCH_InformationList_LCRTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 726), (u'criticality', u'ignore'), (u'Value', ____UpPCH_InformationList_LCRTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UpPCH_InformationList_LCRTDD__item__id._const_tab = ___UpPCH_InformationList_LCRTDD__item__id_tab
    __UpPCH_InformationList_LCRTDD__item__id._const_tab_at = None
    __UpPCH_InformationList_LCRTDD__item__id._const_tab_id = u'id'
    __UpPCH_InformationList_LCRTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UpPCH_InformationList_LCRTDD__item__criticality._const_tab = ___UpPCH_InformationList_LCRTDD__item__id_tab
    __UpPCH_InformationList_LCRTDD__item__criticality._const_tab_at = ('..', u'id')
    __UpPCH_InformationList_LCRTDD__item__criticality._const_tab_id = u'criticality'
    __UpPCH_InformationList_LCRTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UpPCH_InformationList_LCRTDD__item__value._const_tab = ___UpPCH_InformationList_LCRTDD__item__id_tab
    __UpPCH_InformationList_LCRTDD__item__value._const_tab_at = ('..', u'id')
    __UpPCH_InformationList_LCRTDD__item__value._const_tab_id = u'Value'
    _UpPCH_InformationList_LCRTDD__item_._cont = ASN1Dict([
        (u'id', __UpPCH_InformationList_LCRTDD__item__id),
        (u'criticality', __UpPCH_InformationList_LCRTDD__item__criticality),
        (u'value', __UpPCH_InformationList_LCRTDD__item__value),
        ])
    _UpPCH_InformationList_LCRTDD__item_._ext = None
    UpPCH_InformationList_LCRTDD._cont = _UpPCH_InformationList_LCRTDD__item_
    UpPCH_InformationList_LCRTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=12)], ev=None, er=[])
    
    #-----< UpPCH-InformationItemIE-LCRTDD >-----#
    UpPCH_InformationItemIE_LCRTDD = CLASS(name=u'UpPCH-InformationItemIE-LCRTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UpPCH_InformationItemIE_LCRTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UpPCH-InformationItem-LCRTDD')))
    UpPCH_InformationItemIE_LCRTDD._val = ASN1Set(rv=[dict([(u'id', 726), (u'criticality', u'ignore'), (u'Value', _UpPCH_InformationItemIE_LCRTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UpPCH-InformationItem-LCRTDD >-----#
    UpPCH_InformationItem_LCRTDD = SEQ(name=u'UpPCH-InformationItem-LCRTDD', mode=MODE_TYPE)
    _UpPCH_InformationItem_LCRTDD_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _UpPCH_InformationItem_LCRTDD_uPPCHPositionLCR = INT(name=u'uPPCHPositionLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UPPCHPositionLCR')), opt=True)
    _UpPCH_InformationItem_LCRTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UpPCH_InformationItem_LCRTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id._const_tab = ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id_tab
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id._const_tab_at = None
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality._const_tab = ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality_tab
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue._const_tab = ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue_tab
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UpPCH_InformationItem_LCRTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id),
        (u'criticality', ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue),
        ])
    __UpPCH_InformationItem_LCRTDD_iE_Extensions__item_._ext = None
    _UpPCH_InformationItem_LCRTDD_iE_Extensions._cont = __UpPCH_InformationItem_LCRTDD_iE_Extensions__item_
    _UpPCH_InformationItem_LCRTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UpPCH_InformationItem_LCRTDD._cont = ASN1Dict([
        (u'uARFCNforNt', _UpPCH_InformationItem_LCRTDD_uARFCNforNt),
        (u'uPPCHPositionLCR', _UpPCH_InformationItem_LCRTDD_uPPCHPositionLCR),
        (u'iE-Extensions', _UpPCH_InformationItem_LCRTDD_iE_Extensions),
        ])
    UpPCH_InformationItem_LCRTDD._ext = []
    
    #-----< UpPCH-InformationItem-LCRTDD-ExtIEs >-----#
    UpPCH_InformationItem_LCRTDD_ExtIEs = CLASS(name=u'UpPCH-InformationItem-LCRTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UpPCH_InformationItem_LCRTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PunctureLimit >-----#
    PunctureLimit = INT(name=u'PunctureLimit', mode=MODE_TYPE)
    PunctureLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< PTMCellList >-----#
    PTMCellList = SEQ_OF(name=u'PTMCellList', mode=MODE_TYPE)
    _PTMCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMSChannelTypeCellList')))
    PTMCellList._cont = _PTMCellList__item_
    PTMCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< PTPCellList >-----#
    PTPCellList = SEQ_OF(name=u'PTPCellList', mode=MODE_TYPE)
    _PTPCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMSChannelTypeCellList')))
    PTPCellList._cont = _PTPCellList__item_
    PTPCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< QE-Selector >-----#
    QE_Selector = ENUM(name=u'QE-Selector', mode=MODE_TYPE)
    QE_Selector._cont = ASN1Dict([(u'selected', 0), (u'non-selected', 1)])
    QE_Selector._ext = None
    
    #-----< Process-Memory-Size >-----#
    Process_Memory_Size = ENUM(name=u'Process-Memory-Size', mode=MODE_TYPE)
    Process_Memory_Size._cont = ASN1Dict([(u'hms800', 0), (u'hms1600', 1), (u'hms2400', 2), (u'hms3200', 3), (u'hms4000', 4), (u'hms4800', 5), (u'hms5600', 6), (u'hms6400', 7), (u'hms7200', 8), (u'hms8000', 9), (u'hms8800', 10), (u'hms9600', 11), (u'hms10400', 12), (u'hms11200', 13), (u'hms12000', 14), (u'hms12800', 15), (u'hms13600', 16), (u'hms14400', 17), (u'hms15200', 18), (u'hms16000', 19), (u'hms17600', 20), (u'hms19200', 21), (u'hms20800', 22), (u'hms22400', 23), (u'hms24000', 24), (u'hms25600', 25), (u'hms27200', 26), (u'hms28800', 27), (u'hms30400', 28), (u'hms32000', 29), (u'hms36000', 30), (u'hms40000', 31), (u'hms44000', 32), (u'hms48000', 33), (u'hms52000', 34), (u'hms56000', 35), (u'hms60000', 36), (u'hms64000', 37), (u'hms68000', 38), (u'hms72000', 39), (u'hms76000', 40), (u'hms80000', 41), (u'hms88000', 42), (u'hms96000', 43), (u'hms104000', 44), (u'hms112000', 45), (u'hms120000', 46), (u'hms128000', 47), (u'hms136000', 48), (u'hms144000', 49), (u'hms152000', 50), (u'hms160000', 51), (u'hms176000', 52), (u'hms192000', 53), (u'hms208000', 54), (u'hms224000', 55), (u'hms240000', 56), (u'hms256000', 57), (u'hms272000', 58), (u'hms288000', 59), (u'hms304000', 60)])
    Process_Memory_Size._ext = []
    
    #-----< RABased >-----#
    RABased = SEQ(name=u'RABased', mode=MODE_TYPE)
    _RABased_raiList = SEQ_OF(name=u'raiList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RAI-List')))
    _RABased_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RABased_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RABased_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__id._const_tab = ____RABased_iE_Extensions__item__id_tab
    ___RABased_iE_Extensions__item__id._const_tab_at = None
    ___RABased_iE_Extensions__item__id._const_tab_id = u'id'
    ___RABased_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RABased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__criticality._const_tab = ____RABased_iE_Extensions__item__criticality_tab
    ___RABased_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RABased_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RABased_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RABased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__extensionValue._const_tab = ____RABased_iE_Extensions__item__extensionValue_tab
    ___RABased_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RABased_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RABased_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RABased_iE_Extensions__item__id),
        (u'criticality', ___RABased_iE_Extensions__item__criticality),
        (u'extensionValue', ___RABased_iE_Extensions__item__extensionValue),
        ])
    __RABased_iE_Extensions__item_._ext = None
    _RABased_iE_Extensions._cont = __RABased_iE_Extensions__item_
    _RABased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABased._cont = ASN1Dict([
        (u'raiList', _RABased_raiList),
        (u'iE-Extensions', _RABased_iE_Extensions),
        ])
    RABased._ext = []
    
    #-----< RABased-ExtIEs >-----#
    RABased_ExtIEs = CLASS(name=u'RABased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RABased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Radio-Links-without-DPCH-FDPCH-Indication >-----#
    Radio_Links_without_DPCH_FDPCH_Indication = SEQ_OF(name=u'Radio-Links-without-DPCH-FDPCH-Indication', mode=MODE_TYPE)
    _Radio_Links_without_DPCH_FDPCH_Indication__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Information')))
    Radio_Links_without_DPCH_FDPCH_Indication._cont = _Radio_Links_without_DPCH_FDPCH_Indication__item_
    Radio_Links_without_DPCH_FDPCH_Indication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Radio-Links-without-DPCH-FDPCH-Information >-----#
    Radio_Links_without_DPCH_FDPCH_Information = SEQ(name=u'Radio-Links-without-DPCH-FDPCH-Information', mode=MODE_TYPE)
    _Radio_Links_without_DPCH_FDPCH_Information_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator = ENUM(name=u'radio-Links-without-DPCH-FDPCH-Operation-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator._cont = ASN1Dict([(u'true', 0)])
    _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator._ext = None
    _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id._const_tab = ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality._const_tab = ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue._const_tab = ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id),
        (u'criticality', ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue),
        ])
    __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_._ext = None
    _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions._cont = __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_
    _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Radio_Links_without_DPCH_FDPCH_Information._cont = ASN1Dict([
        (u'rL-ID', _Radio_Links_without_DPCH_FDPCH_Information_rL_ID),
        (u'radio-Links-without-DPCH-FDPCH-Operation-Indicator', _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator),
        (u'iE-Extensions', _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions),
        ])
    Radio_Links_without_DPCH_FDPCH_Information._ext = []
    
    #-----< Radio-Links-without-DPCH-FDPCH-Information-ExtIEs >-----#
    Radio_Links_without_DPCH_FDPCH_Information_ExtIEs = CLASS(name=u'Radio-Links-without-DPCH-FDPCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Radio_Links_without_DPCH_FDPCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAI-List >-----#
    RAI_List = SEQ_OF(name=u'RAI-List', mode=MODE_TYPE)
    _RAI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RAI')))
    RAI_List._cont = _RAI_List__item_
    RAI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name=u'ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([(u'ms250', 0), (u'ms500', 1), (u'ms1000', 2), (u'ms2000', 3), (u'ms3000', 4), (u'ms4000', 5), (u'ms6000', 6), (u'ms12000', 7), (u'ms16000', 8), (u'ms20000', 9), (u'ms24000', 10), (u'ms32000', 11), (u'ms64000', 12)])
    ReportInterval._ext = []
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name=u'ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([(u'n1', 0), (u'n2', 1), (u'n4', 2), (u'n8', 3), (u'n16', 4), (u'n32', 5), (u'n64', 6), (u'infinity', 7)])
    ReportAmount._ext = []
    
    #-----< RAC >-----#
    RAC = OCT_STR(name=u'RAC', mode=MODE_TYPE)
    RAC._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RAI >-----#
    RAI = SEQ(name=u'RAI', mode=MODE_TYPE)
    _RAI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _RAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAC')))
    _RAI_rAC = OCT_STR(name=u'rAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RAC')))
    RAI._cont = ASN1Dict([
        (u'pLMN-Identity', _RAI_pLMN_Identity),
        (u'lAC', _RAI_lAC),
        (u'rAC', _RAI_rAC),
        ])
    RAI._ext = None
    
    #-----< RANAP-EnhancedRelocationInformationRequest >-----#
    RANAP_EnhancedRelocationInformationRequest = BIT_STR(name=u'RANAP-EnhancedRelocationInformationRequest', mode=MODE_TYPE)
    
    #-----< RANAP-EnhancedRelocationInformationResponse >-----#
    RANAP_EnhancedRelocationInformationResponse = BIT_STR(name=u'RANAP-EnhancedRelocationInformationResponse', mode=MODE_TYPE)
    
    #-----< RANAP-RelocationInformation >-----#
    RANAP_RelocationInformation = BIT_STR(name=u'RANAP-RelocationInformation', mode=MODE_TYPE)
    
    #-----< Range-Correction-Rate >-----#
    Range_Correction_Rate = INT(name=u'Range-Correction-Rate', mode=MODE_TYPE)
    Range_Correction_Rate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    
    #-----< RateMatchingAttribute >-----#
    RateMatchingAttribute = INT(name=u'RateMatchingAttribute', mode=MODE_TYPE)
    RateMatchingAttribute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RB-Identity >-----#
    RB_Identity = INT(name=u'RB-Identity', mode=MODE_TYPE)
    RB_Identity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< RB-Info >-----#
    RB_Info = SEQ_OF(name=u'RB-Info', mode=MODE_TYPE)
    _RB_Info__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RB-Identity')))
    RB_Info._cont = _RB_Info__item_
    RB_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Received-Total-Wideband-Power-Value >-----#
    Received_Total_Wideband_Power_Value = INT(name=u'Received-Total-Wideband-Power-Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Received-total-wide-band-power')))
    
    #-----< Received-Total-Wideband-Power-Value-IncrDecrThres >-----#
    Received_Total_Wideband_Power_Value_IncrDecrThres = INT(name=u'Received-Total-Wideband-Power-Value-IncrDecrThres', mode=MODE_TYPE)
    Received_Total_Wideband_Power_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=620)], ev=None, er=[])
    
    #-----< Reference-E-TFCI-Information >-----#
    Reference_E_TFCI_Information = SEQ_OF(name=u'Reference-E-TFCI-Information', mode=MODE_TYPE)
    _Reference_E_TFCI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Reference-E-TFCI-Information-Item')))
    Reference_E_TFCI_Information._cont = _Reference_E_TFCI_Information__item_
    Reference_E_TFCI_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Reference-E-TFCI-Information-Item >-----#
    Reference_E_TFCI_Information_Item = SEQ(name=u'Reference-E-TFCI-Information-Item', mode=MODE_TYPE)
    _Reference_E_TFCI_Information_Item_reference_E_TFCI = INT(name=u'reference-E-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCI')))
    _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO = INT(name=u'reference-E-TFCI-PO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Reference-E-TFCI-PO')))
    _Reference_E_TFCI_Information_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Ext-Reference-E-TFCI-PO')))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 705), (u'criticality', u'reject'), (u'Extension', _____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id),
        (u'criticality', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_._ext = None
    _Reference_E_TFCI_Information_Item_iE_Extensions._cont = __Reference_E_TFCI_Information_Item_iE_Extensions__item_
    _Reference_E_TFCI_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Reference_E_TFCI_Information_Item._cont = ASN1Dict([
        (u'reference-E-TFCI', _Reference_E_TFCI_Information_Item_reference_E_TFCI),
        (u'reference-E-TFCI-PO', _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO),
        (u'iE-Extensions', _Reference_E_TFCI_Information_Item_iE_Extensions),
        ])
    Reference_E_TFCI_Information_Item._ext = []
    
    #-----< Reference-E-TFCI-Information-Item-ExtIEs >-----#
    Reference_E_TFCI_Information_Item_ExtIEs = CLASS(name=u'Reference-E-TFCI-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Reference_E_TFCI_Information_Item_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Ext-Reference-E-TFCI-PO')))
    Reference_E_TFCI_Information_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 705), (u'criticality', u'reject'), (u'Extension', _Reference_E_TFCI_Information_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Reference-E-TFCI-PO >-----#
    Reference_E_TFCI_PO = INT(name=u'Reference-E-TFCI-PO', mode=MODE_TYPE)
    Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=29)], ev=None, er=[])
    
    #-----< RefTFCNumber >-----#
    RefTFCNumber = INT(name=u'RefTFCNumber', mode=MODE_TYPE)
    RefTFCNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Released-CN-Domain >-----#
    Released_CN_Domain = CHOICE(name=u'Released-CN-Domain', mode=MODE_TYPE)
    _Released_CN_Domain_pSDomain = NULL(name=u'pSDomain', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Released_CN_Domain_cSDomain = NULL(name=u'cSDomain', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Released_CN_Domain_pS_CSDomain = NULL(name=u'pS-CSDomain', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Released_CN_Domain._cont = ASN1Dict([
        (u'pSDomain', _Released_CN_Domain_pSDomain),
        (u'cSDomain', _Released_CN_Domain_cSDomain),
        (u'pS-CSDomain', _Released_CN_Domain_pS_CSDomain),
        ])
    Released_CN_Domain._ext = []
    
    #-----< RepetitionLength >-----#
    RepetitionLength = INT(name=u'RepetitionLength', mode=MODE_TYPE)
    RepetitionLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = ENUM(name=u'RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v16', 4), (u'v32', 5), (u'v64', 6)])
    RepetitionPeriod._ext = None
    
    #-----< RepetitionNumber0 >-----#
    RepetitionNumber0 = INT(name=u'RepetitionNumber0', mode=MODE_TYPE)
    RepetitionNumber0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RepetitionNumber1 >-----#
    RepetitionNumber1 = INT(name=u'RepetitionNumber1', mode=MODE_TYPE)
    RepetitionNumber1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ReportCharacteristics >-----#
    ReportCharacteristics = CHOICE(name=u'ReportCharacteristics', mode=MODE_TYPE)
    _ReportCharacteristics_onDemand = NULL(name=u'onDemand', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportCharacteristics_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Periodic')))
    _ReportCharacteristics_eventA = SEQ(name=u'eventA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EventA')))
    _ReportCharacteristics_eventB = SEQ(name=u'eventB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EventB')))
    _ReportCharacteristics_eventC = SEQ(name=u'eventC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EventC')))
    _ReportCharacteristics_eventD = SEQ(name=u'eventD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EventD')))
    _ReportCharacteristics_eventE = SEQ(name=u'eventE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EventE')))
    _ReportCharacteristics_eventF = SEQ(name=u'eventF', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EventF')))
    _ReportCharacteristics_extension_ReportCharacteristics = SEQ(name=u'extension-ReportCharacteristics', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-ReportCharacteristics')))
    ReportCharacteristics._cont = ASN1Dict([
        (u'onDemand', _ReportCharacteristics_onDemand),
        (u'periodic', _ReportCharacteristics_periodic),
        (u'eventA', _ReportCharacteristics_eventA),
        (u'eventB', _ReportCharacteristics_eventB),
        (u'eventC', _ReportCharacteristics_eventC),
        (u'eventD', _ReportCharacteristics_eventD),
        (u'eventE', _ReportCharacteristics_eventE),
        (u'eventF', _ReportCharacteristics_eventF),
        (u'extension-ReportCharacteristics', _ReportCharacteristics_extension_ReportCharacteristics),
        ])
    ReportCharacteristics._ext = [u'extension-ReportCharacteristics']
    
    #-----< Extension-ReportCharacteristics >-----#
    Extension_ReportCharacteristics = SEQ(name=u'Extension-ReportCharacteristics', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_ReportCharacteristics_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_ReportCharacteristics_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_ReportCharacteristics_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OnModification')))
    ___Extension_ReportCharacteristics_id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EventH')))
    __Extension_ReportCharacteristics_id_tab._val = ASN1Set(rv=[dict([(u'id', 235), (u'criticality', u'reject'), (u'Value', ___Extension_ReportCharacteristics_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 2064), (u'criticality', u'reject'), (u'Value', ___Extension_ReportCharacteristics_id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_ReportCharacteristics_id._const_tab = __Extension_ReportCharacteristics_id_tab
    _Extension_ReportCharacteristics_id._const_tab_at = None
    _Extension_ReportCharacteristics_id._const_tab_id = u'id'
    _Extension_ReportCharacteristics_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_ReportCharacteristics_criticality._const_tab = __Extension_ReportCharacteristics_id_tab
    _Extension_ReportCharacteristics_criticality._const_tab_at = ('..', u'id')
    _Extension_ReportCharacteristics_criticality._const_tab_id = u'criticality'
    _Extension_ReportCharacteristics_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_ReportCharacteristics_value._const_tab = __Extension_ReportCharacteristics_id_tab
    _Extension_ReportCharacteristics_value._const_tab_at = ('..', u'id')
    _Extension_ReportCharacteristics_value._const_tab_id = u'Value'
    Extension_ReportCharacteristics._cont = ASN1Dict([
        (u'id', _Extension_ReportCharacteristics_id),
        (u'criticality', _Extension_ReportCharacteristics_criticality),
        (u'value', _Extension_ReportCharacteristics_value),
        ])
    Extension_ReportCharacteristics._ext = None
    
    #-----< Extension-ReportCharacteristicsIE >-----#
    Extension_ReportCharacteristicsIE = CLASS(name=u'Extension-ReportCharacteristicsIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_ReportCharacteristicsIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OnModification')))
    _Extension_ReportCharacteristicsIE_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EventH')))
    Extension_ReportCharacteristicsIE._val = ASN1Set(rv=[dict([(u'id', 235), (u'criticality', u'reject'), (u'Value', _Extension_ReportCharacteristicsIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 2064), (u'criticality', u'reject'), (u'Value', _Extension_ReportCharacteristicsIE_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< ReportPeriodicity >-----#
    ReportPeriodicity = CHOICE(name=u'ReportPeriodicity', mode=MODE_TYPE)
    _ReportPeriodicity_ten_msec = INT(name=u'ten-msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportPeriodicity_ten_msec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6000)], ev=[], er=[])
    _ReportPeriodicity_min = INT(name=u'min', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportPeriodicity_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    ReportPeriodicity._cont = ASN1Dict([
        (u'ten-msec', _ReportPeriodicity_ten_msec),
        (u'min', _ReportPeriodicity_min),
        ])
    ReportPeriodicity._ext = []
    
    #-----< RequestedDataValue >-----#
    RequestedDataValue = SEQ(name=u'RequestedDataValue', mode=MODE_TYPE)
    _RequestedDataValue_gA_AccessPointPositionwithAltitude = SEQ(name=u'gA-AccessPointPositionwithAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPositionwithOptionalAltitude')), opt=True)
    _RequestedDataValue_iPDLParameters = CHOICE(name=u'iPDLParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IPDLParameters')), opt=True)
    _RequestedDataValue_dGPSCorrections = SEQ(name=u'dGPSCorrections', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DGPSCorrections')), opt=True)
    _RequestedDataValue_gPS_NavigationModel_and_TimeRecovery = SEQ_OF(name=u'gPS-NavigationModel-and-TimeRecovery', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-NavigationModel-and-TimeRecovery')), opt=True)
    _RequestedDataValue_gPS_Ionospheric_Model = SEQ(name=u'gPS-Ionospheric-Model', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-Ionospheric-Model')), opt=True)
    _RequestedDataValue_gPS_UTC_Model = SEQ(name=u'gPS-UTC-Model', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-UTC-Model')), opt=True)
    _RequestedDataValue_gPS_Almanac = SEQ(name=u'gPS-Almanac', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-Almanac')), opt=True)
    _RequestedDataValue_gPS_RealTime_Integrity = CHOICE(name=u'gPS-RealTime-Integrity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-RealTime-Integrity')), opt=True)
    _RequestedDataValue_gPS_RX_POS = SEQ(name=u'gPS-RX-POS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GPS-RX-POS')), opt=True)
    _RequestedDataValue_sFNSFN_GA_AccessPointPosition = SEQ(name=u'sFNSFN-GA-AccessPointPosition', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPositionwithOptionalAltitude')), opt=True)
    _RequestedDataValue_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDataValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RequestedDataValue_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RequestedDataValue_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Capacity-Class-Value')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NACC-Related-Data')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-Full-Address')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Information')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Common-Data')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Generic-Data')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Counting-Information')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Mode-Information')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Neighbouring-Cell-Information')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RLC-Sequence-Number')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ANR-Cell-Information')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_11 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-RGCH-Cell-Information')))
    ____RequestedDataValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 303), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 552), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 590), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 608), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 699), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 701), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 762), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 763), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 764), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 766), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 902), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 938), (u'criticality', u'ignore'), (u'Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RequestedDataValue_iE_Extensions__item__id._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDataValue_iE_Extensions__item__id._const_tab_id = u'id'
    ___RequestedDataValue_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RequestedDataValue_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RequestedDataValue_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RequestedDataValue_iE_Extensions__item__id),
        (u'criticality', ___RequestedDataValue_iE_Extensions__item__criticality),
        (u'extensionValue', ___RequestedDataValue_iE_Extensions__item__extensionValue),
        ])
    __RequestedDataValue_iE_Extensions__item_._ext = None
    _RequestedDataValue_iE_Extensions._cont = __RequestedDataValue_iE_Extensions__item_
    _RequestedDataValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDataValue._cont = ASN1Dict([
        (u'gA-AccessPointPositionwithAltitude', _RequestedDataValue_gA_AccessPointPositionwithAltitude),
        (u'iPDLParameters', _RequestedDataValue_iPDLParameters),
        (u'dGPSCorrections', _RequestedDataValue_dGPSCorrections),
        (u'gPS-NavigationModel-and-TimeRecovery', _RequestedDataValue_gPS_NavigationModel_and_TimeRecovery),
        (u'gPS-Ionospheric-Model', _RequestedDataValue_gPS_Ionospheric_Model),
        (u'gPS-UTC-Model', _RequestedDataValue_gPS_UTC_Model),
        (u'gPS-Almanac', _RequestedDataValue_gPS_Almanac),
        (u'gPS-RealTime-Integrity', _RequestedDataValue_gPS_RealTime_Integrity),
        (u'gPS-RX-POS', _RequestedDataValue_gPS_RX_POS),
        (u'sFNSFN-GA-AccessPointPosition', _RequestedDataValue_sFNSFN_GA_AccessPointPosition),
        (u'iE-Extensions', _RequestedDataValue_iE_Extensions),
        ])
    RequestedDataValue._ext = []
    
    #-----< RequestedDataValue-ExtIEs >-----#
    RequestedDataValue_ExtIEs = CLASS(name=u'RequestedDataValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RequestedDataValue_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Capacity-Class-Value')))
    _RequestedDataValue_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NACC-Related-Data')))
    _RequestedDataValue_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-Full-Address')))
    _RequestedDataValue_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-Information')))
    _RequestedDataValue_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Common-Data')))
    _RequestedDataValue_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Generic-Data')))
    _RequestedDataValue_ExtIEs_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Counting-Information')))
    _RequestedDataValue_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Mode-Information')))
    _RequestedDataValue_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Neighbouring-Cell-Information')))
    _RequestedDataValue_ExtIEs_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RLC-Sequence-Number')))
    _RequestedDataValue_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ANR-Cell-Information')))
    _RequestedDataValue_ExtIEs_val_Extension_11 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-E-RGCH-Cell-Information')))
    RequestedDataValue_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 303), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 552), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 590), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 608), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 699), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 701), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 762), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 763), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 764), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 766), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 902), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 938), (u'criticality', u'ignore'), (u'Extension', _RequestedDataValue_ExtIEs_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestedDataValueInformation >-----#
    RequestedDataValueInformation = CHOICE(name=u'RequestedDataValueInformation', mode=MODE_TYPE)
    _RequestedDataValueInformation_informationAvailable = SEQ(name=u'informationAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InformationAvailable')))
    _RequestedDataValueInformation_informationNotAvailable = NULL(name=u'informationNotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InformationNotAvailable')))
    RequestedDataValueInformation._cont = ASN1Dict([
        (u'informationAvailable', _RequestedDataValueInformation_informationAvailable),
        (u'informationNotAvailable', _RequestedDataValueInformation_informationNotAvailable),
        ])
    RequestedDataValueInformation._ext = None
    
    #-----< RestrictionStateIndicator >-----#
    RestrictionStateIndicator = ENUM(name=u'RestrictionStateIndicator', mode=MODE_TYPE)
    RestrictionStateIndicator._cont = ASN1Dict([(u'cellNotResevedForOperatorUse', 0), (u'cellResevedForOperatorUse', 1)])
    RestrictionStateIndicator._ext = []
    
    #-----< RL-ID >-----#
    RL_ID = INT(name=u'RL-ID', mode=MODE_TYPE)
    RL_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< RL-Set-ID >-----#
    RL_Set_ID = INT(name=u'RL-Set-ID', mode=MODE_TYPE)
    RL_Set_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< RL-Specific-DCH-Info >-----#
    RL_Specific_DCH_Info = SEQ_OF(name=u'RL-Specific-DCH-Info', mode=MODE_TYPE)
    _RL_Specific_DCH_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info-Item')))
    RL_Specific_DCH_Info._cont = _RL_Specific_DCH_Info__item_
    RL_Specific_DCH_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< RL-Specific-DCH-Info-Item >-----#
    RL_Specific_DCH_Info_Item = SEQ(name=u'RL-Specific-DCH-Info-Item', mode=MODE_TYPE)
    _RL_Specific_DCH_Info_Item_dCH_id = INT(name=u'dCH-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _RL_Specific_DCH_Info_Item_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _RL_Specific_DCH_Info_Item_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _RL_Specific_DCH_Info_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Specific_DCH_Info_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotRequestedIndicator')))
    ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 712), (u'criticality', u'ignore'), (u'Extension', _____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id._const_tab = ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id._const_tab_at = None
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality._const_tab = ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue._const_tab = ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Specific_DCH_Info_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id),
        (u'criticality', ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue),
        ])
    __RL_Specific_DCH_Info_Item_iE_Extensions__item_._ext = None
    _RL_Specific_DCH_Info_Item_iE_Extensions._cont = __RL_Specific_DCH_Info_Item_iE_Extensions__item_
    _RL_Specific_DCH_Info_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Specific_DCH_Info_Item._cont = ASN1Dict([
        (u'dCH-id', _RL_Specific_DCH_Info_Item_dCH_id),
        (u'bindingID', _RL_Specific_DCH_Info_Item_bindingID),
        (u'transportLayerAddress', _RL_Specific_DCH_Info_Item_transportLayerAddress),
        (u'iE-Extensions', _RL_Specific_DCH_Info_Item_iE_Extensions),
        ])
    RL_Specific_DCH_Info_Item._ext = []
    
    #-----< RL-Specific-DCH-Info-Item-ExtIEs >-----#
    RL_Specific_DCH_Info_Item_ExtIEs = CLASS(name=u'RL-Specific-DCH-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Specific_DCH_Info_Item_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotRequestedIndicator')))
    RL_Specific_DCH_Info_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 712), (u'criticality', u'ignore'), (u'Extension', _RL_Specific_DCH_Info_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-Specific-EDCH-Information >-----#
    RL_Specific_EDCH_Information = SEQ(name=u'RL-Specific-EDCH-Information', mode=MODE_TYPE)
    _RL_Specific_EDCH_Information_rL_Specific_EDCH_Info = SEQ_OF(name=u'rL-Specific-EDCH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Info')))
    _RL_Specific_EDCH_Information_e_AGCH_PowerOffset = INT(name=u'e-AGCH-PowerOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-AGCH-PowerOffset')), opt=True)
    _RL_Specific_EDCH_Information_e_RGCH_PowerOffset = INT(name=u'e-RGCH-PowerOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-PowerOffset')), opt=True)
    _RL_Specific_EDCH_Information_e_HICH_PowerOffset = INT(name=u'e-HICH-PowerOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-PowerOffset')), opt=True)
    _RL_Specific_EDCH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Specific_EDCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Specific_EDCH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Specific_EDCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_EDCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_EDCH_Information_iE_Extensions__item__id._const_tab = ____RL_Specific_EDCH_Information_iE_Extensions__item__id_tab
    ___RL_Specific_EDCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___RL_Specific_EDCH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Specific_EDCH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Specific_EDCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_EDCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_EDCH_Information_iE_Extensions__item__criticality._const_tab = ____RL_Specific_EDCH_Information_iE_Extensions__item__criticality_tab
    ___RL_Specific_EDCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Specific_EDCH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue._const_tab = ____RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue_tab
    ___RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Specific_EDCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Specific_EDCH_Information_iE_Extensions__item__id),
        (u'criticality', ___RL_Specific_EDCH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue),
        ])
    __RL_Specific_EDCH_Information_iE_Extensions__item_._ext = None
    _RL_Specific_EDCH_Information_iE_Extensions._cont = __RL_Specific_EDCH_Information_iE_Extensions__item_
    _RL_Specific_EDCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Specific_EDCH_Information._cont = ASN1Dict([
        (u'rL-Specific-EDCH-Info', _RL_Specific_EDCH_Information_rL_Specific_EDCH_Info),
        (u'e-AGCH-PowerOffset', _RL_Specific_EDCH_Information_e_AGCH_PowerOffset),
        (u'e-RGCH-PowerOffset', _RL_Specific_EDCH_Information_e_RGCH_PowerOffset),
        (u'e-HICH-PowerOffset', _RL_Specific_EDCH_Information_e_HICH_PowerOffset),
        (u'iE-Extensions', _RL_Specific_EDCH_Information_iE_Extensions),
        ])
    RL_Specific_EDCH_Information._ext = []
    
    #-----< RL-Specific-EDCH-Information-Item-ExtIEs >-----#
    RL_Specific_EDCH_Information_Item_ExtIEs = CLASS(name=u'RL-Specific-EDCH-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Specific_EDCH_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Specific-EDCH-Info >-----#
    RL_Specific_EDCH_Info = SEQ_OF(name=u'RL-Specific-EDCH-Info', mode=MODE_TYPE)
    _RL_Specific_EDCH_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-InfoItem')))
    RL_Specific_EDCH_Info._cont = _RL_Specific_EDCH_Info__item_
    RL_Specific_EDCH_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< RL-Specific-EDCH-InfoItem >-----#
    RL_Specific_EDCH_InfoItem = SEQ(name=u'RL-Specific-EDCH-InfoItem', mode=MODE_TYPE)
    _RL_Specific_EDCH_InfoItem_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _RL_Specific_EDCH_InfoItem_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _RL_Specific_EDCH_InfoItem_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _RL_Specific_EDCH_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Specific_EDCH_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotRequestedIndicator')))
    ____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 712), (u'criticality', u'ignore'), (u'Extension', _____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__id._const_tab = ____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__criticality._const_tab = ____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Specific_EDCH_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __RL_Specific_EDCH_InfoItem_iE_Extensions__item_._ext = None
    _RL_Specific_EDCH_InfoItem_iE_Extensions._cont = __RL_Specific_EDCH_InfoItem_iE_Extensions__item_
    _RL_Specific_EDCH_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Specific_EDCH_InfoItem._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _RL_Specific_EDCH_InfoItem_eDCH_MACdFlow_ID),
        (u'bindingID', _RL_Specific_EDCH_InfoItem_bindingID),
        (u'transportLayerAddress', _RL_Specific_EDCH_InfoItem_transportLayerAddress),
        (u'iE-Extensions', _RL_Specific_EDCH_InfoItem_iE_Extensions),
        ])
    RL_Specific_EDCH_InfoItem._ext = []
    
    #-----< RL-Specific-EDCH-Info-Item-ExtIEs >-----#
    RL_Specific_EDCH_Info_Item_ExtIEs = CLASS(name=u'RL-Specific-EDCH-Info-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Specific_EDCH_Info_Item_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerNotRequestedIndicator')))
    RL_Specific_EDCH_Info_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 712), (u'criticality', u'ignore'), (u'Extension', _RL_Specific_EDCH_Info_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RLC-Mode >-----#
    RLC_Mode = ENUM(name=u'RLC-Mode', mode=MODE_TYPE)
    RLC_Mode._cont = ASN1Dict([(u'rLC-AM', 0), (u'rLC-UM', 1)])
    RLC_Mode._ext = []
    
    #-----< DL-RLC-PDU-Size-Format >-----#
    DL_RLC_PDU_Size_Format = ENUM(name=u'DL-RLC-PDU-Size-Format', mode=MODE_TYPE)
    DL_RLC_PDU_Size_Format._cont = ASN1Dict([(u'fixed-RLC-PDU-Size', 0), (u'flexible-RLC-PDU-Size', 1)])
    DL_RLC_PDU_Size_Format._ext = []
    
    #-----< RLC-Sequence-Number >-----#
    RLC_Sequence_Number = INT(name=u'RLC-Sequence-Number', mode=MODE_TYPE)
    RLC_Sequence_Number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name=u'RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RNTI-Allocation-Indicator >-----#
    RNTI_Allocation_Indicator = ENUM(name=u'RNTI-Allocation-Indicator', mode=MODE_TYPE)
    RNTI_Allocation_Indicator._cont = ASN1Dict([(u'true', 0)])
    RNTI_Allocation_Indicator._ext = None
    
    #-----< Round-Trip-Time-IncrDecrThres >-----#
    Round_Trip_Time_IncrDecrThres = INT(name=u'Round-Trip-Time-IncrDecrThres', mode=MODE_TYPE)
    Round_Trip_Time_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    
    #-----< Round-Trip-Time-Value >-----#
    Round_Trip_Time_Value = INT(name=u'Round-Trip-Time-Value', mode=MODE_TYPE)
    Round_Trip_Time_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< RSCP-Value >-----#
    RSCP_Value = INT(name=u'RSCP-Value', mode=MODE_TYPE)
    RSCP_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< RSCP-Value-IncrDecrThres >-----#
    RSCP_Value_IncrDecrThres = INT(name=u'RSCP-Value-IncrDecrThres', mode=MODE_TYPE)
    RSCP_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< Received-total-wide-band-power >-----#
    Received_total_wide_band_power = INT(name=u'Received-total-wide-band-power', mode=MODE_TYPE)
    Received_total_wide_band_power._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=621)], ev=None, er=[])
    
    #-----< RT-Load-Value-IncrDecrThres >-----#
    RT_Load_Value_IncrDecrThres = INT(name=u'RT-Load-Value-IncrDecrThres', mode=MODE_TYPE)
    RT_Load_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< RT-Load-Value >-----#
    RT_Load_Value = INT(name=u'RT-Load-Value', mode=MODE_TYPE)
    RT_Load_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< RTLoadValue >-----#
    RTLoadValue = SEQ(name=u'RTLoadValue', mode=MODE_TYPE)
    _RTLoadValue_uplinkRTLoadValue = INT(name=u'uplinkRTLoadValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTLoadValue_uplinkRTLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _RTLoadValue_downlinkRTLoadValue = INT(name=u'downlinkRTLoadValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTLoadValue_downlinkRTLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    RTLoadValue._cont = ASN1Dict([
        (u'uplinkRTLoadValue', _RTLoadValue_uplinkRTLoadValue),
        (u'downlinkRTLoadValue', _RTLoadValue_downlinkRTLoadValue),
        ])
    RTLoadValue._ext = None
    
    #-----< RxTimingDeviationForTA >-----#
    RxTimingDeviationForTA = INT(name=u'RxTimingDeviationForTA', mode=MODE_TYPE)
    RxTimingDeviationForTA._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< RxTimingDeviationForTAext >-----#
    RxTimingDeviationForTAext = INT(name=u'RxTimingDeviationForTAext', mode=MODE_TYPE)
    RxTimingDeviationForTAext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< RxTimingDeviationForTA768 >-----#
    RxTimingDeviationForTA768 = INT(name=u'RxTimingDeviationForTA768', mode=MODE_TYPE)
    RxTimingDeviationForTA768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value >-----#
    Rx_Timing_Deviation_Value = INT(name=u'Rx-Timing-Deviation-Value', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value-ext >-----#
    Rx_Timing_Deviation_Value_ext = INT(name=u'Rx-Timing-Deviation-Value-ext', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value_ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value-LCR >-----#
    Rx_Timing_Deviation_Value_LCR = INT(name=u'Rx-Timing-Deviation-Value-LCR', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< Rx-Timing-Deviation-Value-768 >-----#
    Rx_Timing_Deviation_Value_768 = INT(name=u'Rx-Timing-Deviation-Value-768', mode=MODE_TYPE)
    Rx_Timing_Deviation_Value_768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< RefBeta >-----#
    RefBeta = INT(name=u'RefBeta', mode=MODE_TYPE)
    RefBeta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-15, ub=16)], ev=None, er=[])
    
    #-----< SAC >-----#
    SAC = OCT_STR(name=u'SAC', mode=MODE_TYPE)
    SAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< SAI >-----#
    SAI = SEQ(name=u'SAI', mode=MODE_TYPE)
    _SAI_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _SAI_lAC = OCT_STR(name=u'lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LAC')))
    _SAI_sAC = OCT_STR(name=u'sAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAC')))
    _SAI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SAI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__id._const_tab = ____SAI_iE_Extensions__item__id_tab
    ___SAI_iE_Extensions__item__id._const_tab_at = None
    ___SAI_iE_Extensions__item__id._const_tab_id = u'id'
    ___SAI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__criticality._const_tab = ____SAI_iE_Extensions__item__criticality_tab
    ___SAI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SAI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SAI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__extensionValue._const_tab = ____SAI_iE_Extensions__item__extensionValue_tab
    ___SAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SAI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SAI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SAI_iE_Extensions__item__id),
        (u'criticality', ___SAI_iE_Extensions__item__criticality),
        (u'extensionValue', ___SAI_iE_Extensions__item__extensionValue),
        ])
    __SAI_iE_Extensions__item_._ext = None
    _SAI_iE_Extensions._cont = __SAI_iE_Extensions__item_
    _SAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAI._cont = ASN1Dict([
        (u'pLMN-Identity', _SAI_pLMN_Identity),
        (u'lAC', _SAI_lAC),
        (u'sAC', _SAI_sAC),
        (u'iE-Extensions', _SAI_iE_Extensions),
        ])
    SAI._ext = None
    
    #-----< SAI-ExtIEs >-----#
    SAI_ExtIEs = CLASS(name=u'SAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Same-As-Scheduled-E-HICH >-----#
    Same_As_Scheduled_E_HICH = SEQ(name=u'Same-As-Scheduled-E-HICH', mode=MODE_TYPE)
    _Same_As_Scheduled_E_HICH_e_HICH_EI = INT(name=u'e-HICH-EI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-HICH-EI')))
    Same_As_Scheduled_E_HICH._cont = ASN1Dict([
        (u'e-HICH-EI', _Same_As_Scheduled_E_HICH_e_HICH_EI),
        ])
    Same_As_Scheduled_E_HICH._ext = []
    
    #-----< SAT-ID >-----#
    SAT_ID = INT(name=u'SAT-ID', mode=MODE_TYPE)
    SAT_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< Satellite-DGPSCorrections-Information-ExtIEs >-----#
    Satellite_DGPSCorrections_Information_ExtIEs = CLASS(name=u'Satellite-DGPSCorrections-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Satellite_DGPSCorrections_Information_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DGNSS-ValidityPeriod')))
    Satellite_DGPSCorrections_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 869), (u'criticality', u'ignore'), (u'Extension', _Satellite_DGPSCorrections_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SCH-TimeSlot >-----#
    SCH_TimeSlot = INT(name=u'SCH-TimeSlot', mode=MODE_TYPE)
    SCH_TimeSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< ScaledAdjustmentRatio >-----#
    ScaledAdjustmentRatio = INT(name=u'ScaledAdjustmentRatio', mode=MODE_TYPE)
    ScaledAdjustmentRatio._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< SchedulingInformation >-----#
    SchedulingInformation = ENUM(name=u'SchedulingInformation', mode=MODE_TYPE)
    SchedulingInformation._cont = ASN1Dict([(u'included', 0), (u'not-included', 1)])
    SchedulingInformation._ext = None
    
    #-----< SCTD-Indicator >-----#
    SCTD_Indicator = ENUM(name=u'SCTD-Indicator', mode=MODE_TYPE)
    SCTD_Indicator._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    SCTD_Indicator._ext = None
    
    #-----< SDPCCH-PowerOffsetInformation >-----#
    SDPCCH_PowerOffsetInformation = INT(name=u'SDPCCH-PowerOffsetInformation', mode=MODE_TYPE)
    SDPCCH_PowerOffsetInformation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=[], er=[])
    
    #-----< SecondaryServingCells >-----#
    SecondaryServingCells = SEQ_OF(name=u'SecondaryServingCells', mode=MODE_TYPE)
    _SecondaryServingCells__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SecondaryServingCellsItem')))
    SecondaryServingCells._cont = _SecondaryServingCells__item_
    SecondaryServingCells._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SecondaryServingCellsItem >-----#
    SecondaryServingCellsItem = SEQ(name=u'SecondaryServingCellsItem', mode=MODE_TYPE)
    _SecondaryServingCellsItem_secondaryC_ID = INT(name=u'secondaryC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _SecondaryServingCellsItem_numSecondaryHS_SCCH_Codes = INT(name=u'numSecondaryHS-SCCH-Codes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NumHS-SCCH-Codes')), opt=True)
    _SecondaryServingCellsItem_sixtyfourQAM_UsageAllowedIndicator = ENUM(name=u'sixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-UsageAllowedIndicator')), opt=True)
    _SecondaryServingCellsItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryServingCellsItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryServingCellsItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecondaryServingCellsItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE)
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    ____SecondaryServingCellsItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 708), (u'criticality', u'ignore'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 855), (u'criticality', u'ignore'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'ignore'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'ignore'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SecondaryServingCellsItem_iE_Extensions__item__id._const_tab = ____SecondaryServingCellsItem_iE_Extensions__item__id_tab
    ___SecondaryServingCellsItem_iE_Extensions__item__id._const_tab_at = None
    ___SecondaryServingCellsItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality._const_tab = ____SecondaryServingCellsItem_iE_Extensions__item__id_tab
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryServingCellsItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue._const_tab = ____SecondaryServingCellsItem_iE_Extensions__item__id_tab
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SecondaryServingCellsItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SecondaryServingCellsItem_iE_Extensions__item__id),
        (u'criticality', ___SecondaryServingCellsItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue),
        ])
    __SecondaryServingCellsItem_iE_Extensions__item_._ext = None
    _SecondaryServingCellsItem_iE_Extensions._cont = __SecondaryServingCellsItem_iE_Extensions__item_
    _SecondaryServingCellsItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryServingCellsItem._cont = ASN1Dict([
        (u'secondaryC-ID', _SecondaryServingCellsItem_secondaryC_ID),
        (u'numSecondaryHS-SCCH-Codes', _SecondaryServingCellsItem_numSecondaryHS_SCCH_Codes),
        (u'sixtyfourQAM-UsageAllowedIndicator', _SecondaryServingCellsItem_sixtyfourQAM_UsageAllowedIndicator),
        (u'iE-Extensions', _SecondaryServingCellsItem_iE_Extensions),
        ])
    SecondaryServingCellsItem._ext = []
    
    #-----< SecondaryServingCellsItem-ExtIEs >-----#
    SecondaryServingCellsItem_ExtIEs = CLASS(name=u'SecondaryServingCellsItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-ActivationIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE)
    _SecondaryServingCellsItem_ExtIEs_val_Extension_2 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMORequestIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'OrdinalNumberOfFrequency')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_4 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-withfourtransmitantennas-ActivationIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DualStream-MIMO-withfourtransmitantennas-ActivationIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator')))
    _SecondaryServingCellsItem_ExtIEs_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiflow-OrdinalNumberOfFrequency')))
    SecondaryServingCellsItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 708), (u'criticality', u'ignore'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 855), (u'criticality', u'ignore'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 830), (u'criticality', u'ignore'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 880), (u'criticality', u'reject'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 919), (u'criticality', u'ignore'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 923), (u'criticality', u'ignore'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 922), (u'criticality', u'ignore'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 929), (u'criticality', u'reject'), (u'Extension', _SecondaryServingCellsItem_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-Info-TDD >-----#
    Secondary_CCPCH_Info_TDD = SEQ(name=u'Secondary-CCPCH-Info-TDD', mode=MODE_TYPE)
    _Secondary_CCPCH_Info_TDD_dl_TFCS = SEQ(name=u'dl-TFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _Secondary_CCPCH_Info_TDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _Secondary_CCPCH_Info_TDD_secondary_CCPCH_TDD_InformationList = SEQ_OF(name=u'secondary-CCPCH-TDD-InformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-InformationList')))
    _Secondary_CCPCH_Info_TDD_fACH_InformationList = SEQ_OF(name=u'fACH-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FACH-InformationList')))
    _Secondary_CCPCH_Info_TDD_pCH_InformationList = SEQ_OF(name=u'pCH-InformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCH-InformationList')))
    _Secondary_CCPCH_Info_TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_Info_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CCPCH_Info_TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_Info_TDD_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_Info_TDD_iE_Extensions._cont = __Secondary_CCPCH_Info_TDD_iE_Extensions__item_
    _Secondary_CCPCH_Info_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_Info_TDD._cont = ASN1Dict([
        (u'dl-TFCS', _Secondary_CCPCH_Info_TDD_dl_TFCS),
        (u'tFCI-Coding', _Secondary_CCPCH_Info_TDD_tFCI_Coding),
        (u'secondary-CCPCH-TDD-InformationList', _Secondary_CCPCH_Info_TDD_secondary_CCPCH_TDD_InformationList),
        (u'fACH-InformationList', _Secondary_CCPCH_Info_TDD_fACH_InformationList),
        (u'pCH-InformationList', _Secondary_CCPCH_Info_TDD_pCH_InformationList),
        (u'iE-Extensions', _Secondary_CCPCH_Info_TDD_iE_Extensions),
        ])
    Secondary_CCPCH_Info_TDD._ext = []
    
    #-----< Secondary-CCPCH-Info-TDD-ExtIEs >-----#
    Secondary_CCPCH_Info_TDD_ExtIEs = CLASS(name=u'Secondary-CCPCH-Info-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_Info_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CPICH-Information >-----#
    Secondary_CPICH_Information = SEQ(name=u'Secondary-CPICH-Information', mode=MODE_TYPE)
    _Secondary_CPICH_Information_dl_ScramblingCode = INT(name=u'dl-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ScramblingCode')))
    _Secondary_CPICH_Information_fDD_DL_ChannelisationCodeNumber = INT(name=u'fDD-DL-ChannelisationCodeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _Secondary_CPICH_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CPICH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CPICH_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CPICH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CPICH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CPICH_Information_iE_Extensions__item__id._const_tab = ____Secondary_CPICH_Information_iE_Extensions__item__id_tab
    ___Secondary_CPICH_Information_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CPICH_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CPICH_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CPICH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CPICH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CPICH_Information_iE_Extensions__item__criticality._const_tab = ____Secondary_CPICH_Information_iE_Extensions__item__criticality_tab
    ___Secondary_CPICH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CPICH_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CPICH_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CPICH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CPICH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CPICH_Information_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CPICH_Information_iE_Extensions__item__extensionValue_tab
    ___Secondary_CPICH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CPICH_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CPICH_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CPICH_Information_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CPICH_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CPICH_Information_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CPICH_Information_iE_Extensions__item_._ext = None
    _Secondary_CPICH_Information_iE_Extensions._cont = __Secondary_CPICH_Information_iE_Extensions__item_
    _Secondary_CPICH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CPICH_Information._cont = ASN1Dict([
        (u'dl-ScramblingCode', _Secondary_CPICH_Information_dl_ScramblingCode),
        (u'fDD-DL-ChannelisationCodeNumber', _Secondary_CPICH_Information_fDD_DL_ChannelisationCodeNumber),
        (u'iE-Extensions', _Secondary_CPICH_Information_iE_Extensions),
        ])
    Secondary_CPICH_Information._ext = []
    
    #-----< Secondary-CPICH-Information-ExtIEs >-----#
    Secondary_CPICH_Information_ExtIEs = CLASS(name=u'Secondary-CPICH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CPICH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CPICH-Information-Change >-----#
    Secondary_CPICH_Information_Change = CHOICE(name=u'Secondary-CPICH-Information-Change', mode=MODE_TYPE)
    _Secondary_CPICH_Information_Change_new_secondary_CPICH = SEQ(name=u'new-secondary-CPICH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information')))
    _Secondary_CPICH_Information_Change_secondary_CPICH_shall_not_be_used = NULL(name=u'secondary-CPICH-shall-not-be-used', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Secondary_CPICH_Information_Change._cont = ASN1Dict([
        (u'new-secondary-CPICH', _Secondary_CPICH_Information_Change_new_secondary_CPICH),
        (u'secondary-CPICH-shall-not-be-used', _Secondary_CPICH_Information_Change_secondary_CPICH_shall_not_be_used),
        ])
    Secondary_CPICH_Information_Change._ext = []
    
    #-----< Secondary-LCR-CCPCH-Info-TDD >-----#
    Secondary_LCR_CCPCH_Info_TDD = SEQ(name=u'Secondary-LCR-CCPCH-Info-TDD', mode=MODE_TYPE)
    _Secondary_LCR_CCPCH_Info_TDD_dl_TFCS = SEQ(name=u'dl-TFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _Secondary_LCR_CCPCH_Info_TDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _Secondary_LCR_CCPCH_Info_TDD_secondary_LCR_CCPCH_TDD_InformationList = SEQ_OF(name=u'secondary-LCR-CCPCH-TDD-InformationList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-TDD-InformationList')))
    _Secondary_LCR_CCPCH_Info_TDD_fACH_InformationList = SEQ_OF(name=u'fACH-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FACH-InformationList')))
    _Secondary_LCR_CCPCH_Info_TDD_pCH_InformationList = SEQ_OF(name=u'pCH-InformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCH-InformationList')))
    _Secondary_LCR_CCPCH_Info_TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id._const_tab = ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id_tab
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality._const_tab = ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue._const_tab = ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id),
        (u'criticality', ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue),
        ])
    __Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item_._ext = None
    _Secondary_LCR_CCPCH_Info_TDD_iE_Extensions._cont = __Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item_
    _Secondary_LCR_CCPCH_Info_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_LCR_CCPCH_Info_TDD._cont = ASN1Dict([
        (u'dl-TFCS', _Secondary_LCR_CCPCH_Info_TDD_dl_TFCS),
        (u'tFCI-Coding', _Secondary_LCR_CCPCH_Info_TDD_tFCI_Coding),
        (u'secondary-LCR-CCPCH-TDD-InformationList', _Secondary_LCR_CCPCH_Info_TDD_secondary_LCR_CCPCH_TDD_InformationList),
        (u'fACH-InformationList', _Secondary_LCR_CCPCH_Info_TDD_fACH_InformationList),
        (u'pCH-InformationList', _Secondary_LCR_CCPCH_Info_TDD_pCH_InformationList),
        (u'iE-Extensions', _Secondary_LCR_CCPCH_Info_TDD_iE_Extensions),
        ])
    Secondary_LCR_CCPCH_Info_TDD._ext = []
    
    #-----< Secondary-LCR-CCPCH-Info-TDD-ExtIEs >-----#
    Secondary_LCR_CCPCH_Info_TDD_ExtIEs = CLASS(name=u'Secondary-LCR-CCPCH-Info-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_LCR_CCPCH_Info_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-Info-TDD768 >-----#
    Secondary_CCPCH_Info_TDD768 = SEQ(name=u'Secondary-CCPCH-Info-TDD768', mode=MODE_TYPE)
    _Secondary_CCPCH_Info_TDD768_dl_TFCS = SEQ(name=u'dl-TFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _Secondary_CCPCH_Info_TDD768_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _Secondary_CCPCH_Info_TDD768_secondary_CCPCH_TDD_InformationList768 = SEQ_OF(name=u'secondary-CCPCH-TDD-InformationList768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-InformationList768')))
    _Secondary_CCPCH_Info_TDD768_fACH_InformationList = SEQ_OF(name=u'fACH-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FACH-InformationList')))
    _Secondary_CCPCH_Info_TDD768_pCH_InformationList = SEQ_OF(name=u'pCH-InformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCH-InformationList')))
    _Secondary_CCPCH_Info_TDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_Info_TDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CCPCH_Info_TDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_Info_TDD768_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_Info_TDD768_iE_Extensions._cont = __Secondary_CCPCH_Info_TDD768_iE_Extensions__item_
    _Secondary_CCPCH_Info_TDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_Info_TDD768._cont = ASN1Dict([
        (u'dl-TFCS', _Secondary_CCPCH_Info_TDD768_dl_TFCS),
        (u'tFCI-Coding', _Secondary_CCPCH_Info_TDD768_tFCI_Coding),
        (u'secondary-CCPCH-TDD-InformationList768', _Secondary_CCPCH_Info_TDD768_secondary_CCPCH_TDD_InformationList768),
        (u'fACH-InformationList', _Secondary_CCPCH_Info_TDD768_fACH_InformationList),
        (u'pCH-InformationList', _Secondary_CCPCH_Info_TDD768_pCH_InformationList),
        (u'iE-Extensions', _Secondary_CCPCH_Info_TDD768_iE_Extensions),
        ])
    Secondary_CCPCH_Info_TDD768._ext = []
    
    #-----< Secondary-CCPCH-Info-TDD768-ExtIEs >-----#
    Secondary_CCPCH_Info_TDD768_ExtIEs = CLASS(name=u'Secondary-CCPCH-Info-TDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_Info_TDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-TDD-InformationList >-----#
    Secondary_CCPCH_TDD_InformationList = SEQ_OF(name=u'Secondary-CCPCH-TDD-InformationList', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-InformationItem')))
    Secondary_CCPCH_TDD_InformationList._cont = _Secondary_CCPCH_TDD_InformationList__item_
    Secondary_CCPCH_TDD_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-TDD-InformationItem >-----#
    Secondary_CCPCH_TDD_InformationItem = SEQ(name=u'Secondary-CCPCH-TDD-InformationItem', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_InformationItem_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _Secondary_CCPCH_TDD_InformationItem_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _Secondary_CCPCH_TDD_InformationItem_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _Secondary_CCPCH_TDD_InformationItem_secondary_CCPCH_TDD_Code_Information = SEQ_OF(name=u'secondary-CCPCH-TDD-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-Code-Information')))
    _Secondary_CCPCH_TDD_InformationItem_tDD_PhysicalChannelOffset = INT(name=u'tDD-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Secondary_CCPCH_TDD_InformationItem_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _Secondary_CCPCH_TDD_InformationItem_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _Secondary_CCPCH_TDD_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_TDD_InformationItem_iE_Extensions._cont = __Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item_
    _Secondary_CCPCH_TDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_TDD_InformationItem._cont = ASN1Dict([
        (u'timeSlot', _Secondary_CCPCH_TDD_InformationItem_timeSlot),
        (u'midambleShiftAndBurstType', _Secondary_CCPCH_TDD_InformationItem_midambleShiftAndBurstType),
        (u'tFCI-Presence', _Secondary_CCPCH_TDD_InformationItem_tFCI_Presence),
        (u'secondary-CCPCH-TDD-Code-Information', _Secondary_CCPCH_TDD_InformationItem_secondary_CCPCH_TDD_Code_Information),
        (u'tDD-PhysicalChannelOffset', _Secondary_CCPCH_TDD_InformationItem_tDD_PhysicalChannelOffset),
        (u'repetitionLength', _Secondary_CCPCH_TDD_InformationItem_repetitionLength),
        (u'repetitionPeriod', _Secondary_CCPCH_TDD_InformationItem_repetitionPeriod),
        (u'iE-Extensions', _Secondary_CCPCH_TDD_InformationItem_iE_Extensions),
        ])
    Secondary_CCPCH_TDD_InformationItem._ext = []
    
    #-----< Secondary-CCPCH-TDD-InformationItem-ExtIEs >-----#
    Secondary_CCPCH_TDD_InformationItem_ExtIEs = CLASS(name=u'Secondary-CCPCH-TDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_TDD_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-LCR-CCPCH-TDD-InformationList >-----#
    Secondary_LCR_CCPCH_TDD_InformationList = SEQ_OF(name=u'Secondary-LCR-CCPCH-TDD-InformationList', mode=MODE_TYPE)
    _Secondary_LCR_CCPCH_TDD_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-TDD-InformationItem')))
    Secondary_LCR_CCPCH_TDD_InformationList._cont = _Secondary_LCR_CCPCH_TDD_InformationList__item_
    Secondary_LCR_CCPCH_TDD_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< Secondary-LCR-CCPCH-TDD-InformationItem >-----#
    Secondary_LCR_CCPCH_TDD_InformationItem = SEQ(name=u'Secondary-LCR-CCPCH-TDD-InformationItem', mode=MODE_TYPE)
    _Secondary_LCR_CCPCH_TDD_InformationItem_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_secondary_LCR_CCPCH_TDD_Code_Information = SEQ_OF(name=u'secondary-LCR-CCPCH-TDD-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-TDD-Code-Information')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_tDD_PhysicalChannelOffset = INT(name=u'tDD-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id._const_tab = ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab = ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item_._ext = None
    _Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions._cont = __Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item_
    _Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_LCR_CCPCH_TDD_InformationItem._cont = ASN1Dict([
        (u'timeSlotLCR', _Secondary_LCR_CCPCH_TDD_InformationItem_timeSlotLCR),
        (u'midambleShiftLCR', _Secondary_LCR_CCPCH_TDD_InformationItem_midambleShiftLCR),
        (u'tFCI-Presence', _Secondary_LCR_CCPCH_TDD_InformationItem_tFCI_Presence),
        (u'secondary-LCR-CCPCH-TDD-Code-Information', _Secondary_LCR_CCPCH_TDD_InformationItem_secondary_LCR_CCPCH_TDD_Code_Information),
        (u'tDD-PhysicalChannelOffset', _Secondary_LCR_CCPCH_TDD_InformationItem_tDD_PhysicalChannelOffset),
        (u'repetitionLength', _Secondary_LCR_CCPCH_TDD_InformationItem_repetitionLength),
        (u'repetitionPeriod', _Secondary_LCR_CCPCH_TDD_InformationItem_repetitionPeriod),
        (u'iE-Extensions', _Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions),
        ])
    Secondary_LCR_CCPCH_TDD_InformationItem._ext = []
    
    #-----< Secondary-LCR-CCPCH-TDD-InformationItem-ExtIEs >-----#
    Secondary_LCR_CCPCH_TDD_InformationItem_ExtIEs = CLASS(name=u'Secondary-LCR-CCPCH-TDD-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_LCR_CCPCH_TDD_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-TDD-InformationList768 >-----#
    Secondary_CCPCH_TDD_InformationList768 = SEQ_OF(name=u'Secondary-CCPCH-TDD-InformationList768', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_InformationList768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-InformationItem768')))
    Secondary_CCPCH_TDD_InformationList768._cont = _Secondary_CCPCH_TDD_InformationList768__item_
    Secondary_CCPCH_TDD_InformationList768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-TDD-InformationItem768 >-----#
    Secondary_CCPCH_TDD_InformationItem768 = SEQ(name=u'Secondary-CCPCH-TDD-InformationItem768', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_InformationItem768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _Secondary_CCPCH_TDD_InformationItem768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _Secondary_CCPCH_TDD_InformationItem768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _Secondary_CCPCH_TDD_InformationItem768_secondary_CCPCH_TDD_Code_Information768 = SEQ_OF(name=u'secondary-CCPCH-TDD-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-Code-Information768')))
    _Secondary_CCPCH_TDD_InformationItem768_tDD_PhysicalChannelOffset = INT(name=u'tDD-PhysicalChannelOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-PhysicalChannelOffset')))
    _Secondary_CCPCH_TDD_InformationItem768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _Secondary_CCPCH_TDD_InformationItem768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _Secondary_CCPCH_TDD_InformationItem768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_TDD_InformationItem768_iE_Extensions._cont = __Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item_
    _Secondary_CCPCH_TDD_InformationItem768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_TDD_InformationItem768._cont = ASN1Dict([
        (u'timeSlot', _Secondary_CCPCH_TDD_InformationItem768_timeSlot),
        (u'midambleShiftAndBurstType768', _Secondary_CCPCH_TDD_InformationItem768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _Secondary_CCPCH_TDD_InformationItem768_tFCI_Presence),
        (u'secondary-CCPCH-TDD-Code-Information768', _Secondary_CCPCH_TDD_InformationItem768_secondary_CCPCH_TDD_Code_Information768),
        (u'tDD-PhysicalChannelOffset', _Secondary_CCPCH_TDD_InformationItem768_tDD_PhysicalChannelOffset),
        (u'repetitionLength', _Secondary_CCPCH_TDD_InformationItem768_repetitionLength),
        (u'repetitionPeriod', _Secondary_CCPCH_TDD_InformationItem768_repetitionPeriod),
        (u'iE-Extensions', _Secondary_CCPCH_TDD_InformationItem768_iE_Extensions),
        ])
    Secondary_CCPCH_TDD_InformationItem768._ext = []
    
    #-----< Secondary-CCPCH-TDD-InformationItem768-ExtIEs >-----#
    Secondary_CCPCH_TDD_InformationItem768_ExtIEs = CLASS(name=u'Secondary-CCPCH-TDD-InformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_TDD_InformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-TDD-Code-Information >-----#
    Secondary_CCPCH_TDD_Code_Information = SEQ_OF(name=u'Secondary-CCPCH-TDD-Code-Information', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-Code-InformationItem')))
    Secondary_CCPCH_TDD_Code_Information._cont = _Secondary_CCPCH_TDD_Code_Information__item_
    Secondary_CCPCH_TDD_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-TDD-Code-InformationItem >-----#
    Secondary_CCPCH_TDD_Code_InformationItem = SEQ(name=u'Secondary-CCPCH-TDD-Code-InformationItem', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_Code_InformationItem_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions._cont = __Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_
    _Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_TDD_Code_InformationItem._cont = ASN1Dict([
        (u'tDD-ChannelisationCode', _Secondary_CCPCH_TDD_Code_InformationItem_tDD_ChannelisationCode),
        (u'iE-Extensions', _Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions),
        ])
    Secondary_CCPCH_TDD_Code_InformationItem._ext = []
    
    #-----< Secondary-CCPCH-TDD-Code-InformationItem-ExtIEs >-----#
    Secondary_CCPCH_TDD_Code_InformationItem_ExtIEs = CLASS(name=u'Secondary-CCPCH-TDD-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_TDD_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-LCR-CCPCH-TDD-Code-Information >-----#
    Secondary_LCR_CCPCH_TDD_Code_Information = SEQ_OF(name=u'Secondary-LCR-CCPCH-TDD-Code-Information', mode=MODE_TYPE)
    _Secondary_LCR_CCPCH_TDD_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-TDD-Code-InformationItem')))
    Secondary_LCR_CCPCH_TDD_Code_Information._cont = _Secondary_LCR_CCPCH_TDD_Code_Information__item_
    Secondary_LCR_CCPCH_TDD_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Secondary-LCR-CCPCH-TDD-Code-InformationItem >-----#
    Secondary_LCR_CCPCH_TDD_Code_InformationItem = SEQ(name=u'Secondary-LCR-CCPCH-TDD-Code-InformationItem', mode=MODE_TYPE)
    _Secondary_LCR_CCPCH_TDD_Code_InformationItem_tDD_ChannelisationCodeLCR = SEQ(name=u'tDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _Secondary_LCR_CCPCH_TDD_Code_InformationItem_s_CCPCH_TimeSlotFormat_LCR = CHOICE(name=u's-CCPCH-TimeSlotFormat-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    _Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id._const_tab = ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_._ext = None
    _Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions._cont = __Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_
    _Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_LCR_CCPCH_TDD_Code_InformationItem._cont = ASN1Dict([
        (u'tDD-ChannelisationCodeLCR', _Secondary_LCR_CCPCH_TDD_Code_InformationItem_tDD_ChannelisationCodeLCR),
        (u's-CCPCH-TimeSlotFormat-LCR', _Secondary_LCR_CCPCH_TDD_Code_InformationItem_s_CCPCH_TimeSlotFormat_LCR),
        (u'iE-Extensions', _Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions),
        ])
    Secondary_LCR_CCPCH_TDD_Code_InformationItem._ext = []
    
    #-----< Secondary-LCR-CCPCH-TDD-Code-InformationItem-ExtIEs >-----#
    Secondary_LCR_CCPCH_TDD_Code_InformationItem_ExtIEs = CLASS(name=u'Secondary-LCR-CCPCH-TDD-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_LCR_CCPCH_TDD_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-CCPCH-TDD-Code-Information768 >-----#
    Secondary_CCPCH_TDD_Code_Information768 = SEQ_OF(name=u'Secondary-CCPCH-TDD-Code-Information768', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_Code_Information768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-TDD-Code-InformationItem768')))
    Secondary_CCPCH_TDD_Code_Information768._cont = _Secondary_CCPCH_TDD_Code_Information768__item_
    Secondary_CCPCH_TDD_Code_Information768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Secondary-CCPCH-TDD-Code-InformationItem768 >-----#
    Secondary_CCPCH_TDD_Code_InformationItem768 = SEQ(name=u'Secondary-CCPCH-TDD-Code-InformationItem768', mode=MODE_TYPE)
    _Secondary_CCPCH_TDD_Code_InformationItem768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id._const_tab = ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id_tab
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality._const_tab = ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality_tab
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab = ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue_tab
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id),
        (u'criticality', ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue),
        ])
    __Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item_._ext = None
    _Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions._cont = __Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item_
    _Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_CCPCH_TDD_Code_InformationItem768._cont = ASN1Dict([
        (u'tDD-ChannelisationCode768', _Secondary_CCPCH_TDD_Code_InformationItem768_tDD_ChannelisationCode768),
        (u'iE-Extensions', _Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions),
        ])
    Secondary_CCPCH_TDD_Code_InformationItem768._ext = []
    
    #-----< Secondary-CCPCH-TDD-Code-InformationItem768-ExtIEs >-----#
    Secondary_CCPCH_TDD_Code_InformationItem768_ExtIEs = CLASS(name=u'Secondary-CCPCH-TDD-Code-InformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Secondary_CCPCH_TDD_Code_InformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Secondary-Serving-Cell-List >-----#
    Secondary_Serving_Cell_List = SEQ(name=u'Secondary-Serving-Cell-List', mode=MODE_TYPE)
    _Secondary_Serving_Cell_List_possible_Secondary_Serving_Cell_List = SEQ_OF(name=u'possible-Secondary-Serving-Cell-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Possible-Secondary-Serving-Cell-List')))
    _Secondary_Serving_Cell_List_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Secondary_Serving_Cell_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Secondary_Serving_Cell_List_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multicell-EDCH-Restriction')))
    ____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 882), (u'criticality', u'ignore'), (u'Extension', _____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Secondary_Serving_Cell_List_iE_Extensions__item__id._const_tab = ____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab
    ___Secondary_Serving_Cell_List_iE_Extensions__item__id._const_tab_at = None
    ___Secondary_Serving_Cell_List_iE_Extensions__item__id._const_tab_id = u'id'
    ___Secondary_Serving_Cell_List_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Secondary_Serving_Cell_List_iE_Extensions__item__criticality._const_tab = ____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab
    ___Secondary_Serving_Cell_List_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Secondary_Serving_Cell_List_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Secondary_Serving_Cell_List_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Secondary_Serving_Cell_List_iE_Extensions__item__extensionValue._const_tab = ____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab
    ___Secondary_Serving_Cell_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Secondary_Serving_Cell_List_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Secondary_Serving_Cell_List_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Secondary_Serving_Cell_List_iE_Extensions__item__id),
        (u'criticality', ___Secondary_Serving_Cell_List_iE_Extensions__item__criticality),
        (u'extensionValue', ___Secondary_Serving_Cell_List_iE_Extensions__item__extensionValue),
        ])
    __Secondary_Serving_Cell_List_iE_Extensions__item_._ext = None
    _Secondary_Serving_Cell_List_iE_Extensions._cont = __Secondary_Serving_Cell_List_iE_Extensions__item_
    _Secondary_Serving_Cell_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Secondary_Serving_Cell_List._cont = ASN1Dict([
        (u'possible-Secondary-Serving-Cell-List', _Secondary_Serving_Cell_List_possible_Secondary_Serving_Cell_List),
        (u'iE-Extensions', _Secondary_Serving_Cell_List_iE_Extensions),
        ])
    Secondary_Serving_Cell_List._ext = []
    
    #-----< Secondary-Serving-Cell-List-ExtIEs >-----#
    Secondary_Serving_Cell_List_ExtIEs = CLASS(name=u'Secondary-Serving-Cell-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Secondary_Serving_Cell_List_ExtIEs_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multicell-EDCH-Restriction')))
    Secondary_Serving_Cell_List_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 882), (u'criticality', u'ignore'), (u'Extension', _Secondary_Serving_Cell_List_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Possible-Secondary-Serving-Cell-List >-----#
    Possible_Secondary_Serving_Cell_List = SEQ_OF(name=u'Possible-Secondary-Serving-Cell-List', mode=MODE_TYPE)
    _Possible_Secondary_Serving_Cell_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Possible-Secondary-Serving-Cell')))
    Possible_Secondary_Serving_Cell_List._cont = _Possible_Secondary_Serving_Cell_List__item_
    Possible_Secondary_Serving_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Possible-Secondary-Serving-Cell >-----#
    Possible_Secondary_Serving_Cell = SEQ(name=u'Possible-Secondary-Serving-Cell', mode=MODE_TYPE)
    _Possible_Secondary_Serving_Cell_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Possible_Secondary_Serving_Cell_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Possible_Secondary_Serving_Cell_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multicell-EDCH-Restriction')))
    ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 882), (u'criticality', u'ignore'), (u'Extension', _____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id._const_tab = ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id._const_tab_at = None
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id._const_tab_id = u'id'
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality._const_tab = ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue._const_tab = ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Possible_Secondary_Serving_Cell_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id),
        (u'criticality', ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality),
        (u'extensionValue', ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue),
        ])
    __Possible_Secondary_Serving_Cell_iE_Extensions__item_._ext = None
    _Possible_Secondary_Serving_Cell_iE_Extensions._cont = __Possible_Secondary_Serving_Cell_iE_Extensions__item_
    _Possible_Secondary_Serving_Cell_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Possible_Secondary_Serving_Cell._cont = ASN1Dict([
        (u'c-ID', _Possible_Secondary_Serving_Cell_c_ID),
        (u'iE-Extensions', _Possible_Secondary_Serving_Cell_iE_Extensions),
        ])
    Possible_Secondary_Serving_Cell._ext = []
    
    #-----< Possible-Secondary-Serving-Cell-ExtIEs >-----#
    Possible_Secondary_Serving_Cell_ExtIEs = CLASS(name=u'Possible-Secondary-Serving-Cell-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Possible_Secondary_Serving_Cell_ExtIEs_val_Extension_0 = BOOL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multicell-EDCH-Restriction')))
    Possible_Secondary_Serving_Cell_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 882), (u'criticality', u'ignore'), (u'Extension', _Possible_Secondary_Serving_Cell_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecondInterleavingMode >-----#
    SecondInterleavingMode = ENUM(name=u'SecondInterleavingMode', mode=MODE_TYPE)
    SecondInterleavingMode._cont = ASN1Dict([(u'frame-related', 0), (u'timeslot-related', 1)])
    SecondInterleavingMode._ext = []
    
    #-----< Secondary-UL-Frequency-Activation-State >-----#
    Secondary_UL_Frequency_Activation_State = ENUM(name=u'Secondary-UL-Frequency-Activation-State', mode=MODE_TYPE)
    Secondary_UL_Frequency_Activation_State._cont = ASN1Dict([(u'activated', 0), (u'deactivated', 1)])
    Secondary_UL_Frequency_Activation_State._ext = []
    
    #-----< S-E-DPCCH-PowerOffset >-----#
    S_E_DPCCH_PowerOffset = INT(name=u'S-E-DPCCH-PowerOffset', mode=MODE_TYPE)
    S_E_DPCCH_PowerOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=17)], ev=[], er=[])
    
    #-----< Seed >-----#
    Seed = INT(name=u'Seed', mode=MODE_TYPE)
    Seed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< Service-ID >-----#
    Service_ID = OCT_STR(name=u'Service-ID', mode=MODE_TYPE)
    Service_ID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< S-E-ROCH-Release-Indicator >-----#
    S_E_ROCH_Release_Indicator = ENUM(name=u'S-E-ROCH-Release-Indicator', mode=MODE_TYPE)
    S_E_ROCH_Release_Indicator._cont = ASN1Dict([(u's-E-ROCHreleased', 0)])
    S_E_ROCH_Release_Indicator._ext = None
    
    #-----< SetsOfHS-SCCH-Codes >-----#
    SetsOfHS_SCCH_Codes = SEQ_OF(name=u'SetsOfHS-SCCH-Codes', mode=MODE_TYPE)
    _SetsOfHS_SCCH_Codes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SetsOfHS-SCCH-CodesItem')))
    SetsOfHS_SCCH_Codes._cont = _SetsOfHS_SCCH_Codes__item_
    SetsOfHS_SCCH_Codes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=33)], ev=None, er=[])
    
    #-----< SetsOfHS-SCCH-CodesItem >-----#
    SetsOfHS_SCCH_CodesItem = SEQ(name=u'SetsOfHS-SCCH-CodesItem', mode=MODE_TYPE)
    _SetsOfHS_SCCH_CodesItem_hS_SCCH_PreconfiguredCodes = SEQ_OF(name=u'hS-SCCH-PreconfiguredCodes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SCCH-PreconfiguredCodes')))
    _SetsOfHS_SCCH_CodesItem_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _SetsOfHS_SCCH_CodesItem_hSPDSCH_and_HSSCCH_ScramblingCode = INT(name=u'hSPDSCH-and-HSSCCH-ScramblingCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-ScramblingCode')))
    _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_SupportIndicator = ENUM(name=u'sixtyfourQAM-DL-SupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')), opt=True)
    _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_UsageIndicator = ENUM(name=u'sixtyfourQAM-DL-UsageIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-UsageIndicator')), opt=True)
    _SetsOfHS_SCCH_CodesItem_hSDSCH_TBSizeTableIndicator = ENUM(name=u'hSDSCH-TBSizeTableIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TBSizeTableIndicator')), opt=True)
    _SetsOfHS_SCCH_CodesItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')))
    _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Measurement-Power-Offset')))
    _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 675), (u'criticality', u'ignore'), (u'Extension', _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 893), (u'criticality', u'ignore'), (u'Extension', _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id._const_tab = ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id._const_tab_at = None
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality._const_tab = ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue._const_tab = ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id),
        (u'criticality', ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue),
        ])
    __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_._ext = None
    _SetsOfHS_SCCH_CodesItem_iE_Extensions._cont = __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_
    _SetsOfHS_SCCH_CodesItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SetsOfHS_SCCH_CodesItem._cont = ASN1Dict([
        (u'hS-SCCH-PreconfiguredCodes', _SetsOfHS_SCCH_CodesItem_hS_SCCH_PreconfiguredCodes),
        (u'hSDSCH-RNTI', _SetsOfHS_SCCH_CodesItem_hSDSCH_RNTI),
        (u'hSPDSCH-and-HSSCCH-ScramblingCode', _SetsOfHS_SCCH_CodesItem_hSPDSCH_and_HSSCCH_ScramblingCode),
        (u'sixtyfourQAM-DL-SupportIndicator', _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_SupportIndicator),
        (u'sixtyfourQAM-DL-UsageIndicator', _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_UsageIndicator),
        (u'hSDSCH-TBSizeTableIndicator', _SetsOfHS_SCCH_CodesItem_hSDSCH_TBSizeTableIndicator),
        (u'iE-Extensions', _SetsOfHS_SCCH_CodesItem_iE_Extensions),
        ])
    SetsOfHS_SCCH_CodesItem._ext = []
    
    #-----< SetsOfHS-SCCH-CodesItem-ExtIEs >-----#
    SetsOfHS_SCCH_CodesItem_ExtIEs = CLASS(name=u'SetsOfHS-SCCH-CodesItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-InformationResponse')))
    _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMO')))
    _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Measurement-Power-Offset')))
    _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas')))
    SetsOfHS_SCCH_CodesItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 675), (u'criticality', u'ignore'), (u'Extension', _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 829), (u'criticality', u'ignore'), (u'Extension', _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 893), (u'criticality', u'ignore'), (u'Extension', _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 921), (u'criticality', u'ignore'), (u'Extension', _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name=u'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Setup-Info')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_configurationChange = SEQ_OF(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-ConfigurationChange-List')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_removal = SEQ_OF(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Removal-List')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency._cont = ASN1Dict([
        (u'setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_setup),
        (u'configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_configurationChange),
        (u'removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements = CHOICE(name=u'Setup-Or-ConfigurationChange-Or-Removal-Of-Downlink-TPC-enhancements', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_removal = ENUM(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements._cont = ASN1Dict([
        (u'setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_setup),
        (u'configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_configurationChange),
        (u'removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD = CHOICE(name=u'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information-To-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_removal = ENUM(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD._cont = ASN1Dict([
        (u'setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_setup),
        (u'configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_configurationChange),
        (u'removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information = CHOICE(name=u'Setup-Or-ConfigurationChange-Or-Removal-Of-FTPICH-Information', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-To-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_removal = ENUM(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information._cont = ASN1Dict([
        (u'setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_setup),
        (u'configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_configurationChange),
        (u'removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH = CHOICE(name=u'Setup-Or-ConfigurationChange-Or-Removal-Of-DCH-ENH', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information-to-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_removal = ENUM(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH._cont = ASN1Dict([
        (u'setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_setup),
        (u'configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_configurationChange),
        (u'removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH._ext = []
    
    #-----< Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2 >-----#
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2 = CHOICE(name=u'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2', mode=MODE_TYPE)
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information-To-Modify')))
    _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_removal = ENUM(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information-Removal')))
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2._cont = ASN1Dict([
        (u'setup', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_setup),
        (u'configurationChange', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_configurationChange),
        (u'removal', _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_removal),
        ])
    Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2._ext = []
    
    #-----< SFN >-----#
    SFN = INT(name=u'SFN', mode=MODE_TYPE)
    SFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< SFNSFN-FDD >-----#
    SFNSFN_FDD = INT(name=u'SFNSFN-FDD', mode=MODE_TYPE)
    SFNSFN_FDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=614399)], ev=None, er=[])
    
    #-----< SFNSFN-TDD >-----#
    SFNSFN_TDD = INT(name=u'SFNSFN-TDD', mode=MODE_TYPE)
    SFNSFN_TDD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40961)], ev=None, er=[])
    
    #-----< SFNSFN-TDD768 >-----#
    SFNSFN_TDD768 = INT(name=u'SFNSFN-TDD768', mode=MODE_TYPE)
    SFNSFN_TDD768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=81923)], ev=None, er=[])
    
    #-----< GA-AccessPointPositionwithOptionalAltitude >-----#
    GA_AccessPointPositionwithOptionalAltitude = SEQ(name=u'GA-AccessPointPositionwithOptionalAltitude', mode=MODE_TYPE)
    _GA_AccessPointPositionwithOptionalAltitude_geographicalCoordinate = SEQ(name=u'geographicalCoordinate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GeographicalCoordinate')))
    _GA_AccessPointPositionwithOptionalAltitude_altitudeAndDirection = SEQ(name=u'altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AltitudeAndDirection')), opt=True)
    _GA_AccessPointPositionwithOptionalAltitude_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id._const_tab = ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id_tab
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id._const_tab_at = None
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id._const_tab_id = u'id'
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality._const_tab = ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality_tab
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue._const_tab = ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue_tab
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id),
        (u'criticality', ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality),
        (u'extensionValue', ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue),
        ])
    __GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item_._ext = None
    _GA_AccessPointPositionwithOptionalAltitude_iE_Extensions._cont = __GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item_
    _GA_AccessPointPositionwithOptionalAltitude_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_AccessPointPositionwithOptionalAltitude._cont = ASN1Dict([
        (u'geographicalCoordinate', _GA_AccessPointPositionwithOptionalAltitude_geographicalCoordinate),
        (u'altitudeAndDirection', _GA_AccessPointPositionwithOptionalAltitude_altitudeAndDirection),
        (u'iE-Extensions', _GA_AccessPointPositionwithOptionalAltitude_iE_Extensions),
        ])
    GA_AccessPointPositionwithOptionalAltitude._ext = []
    
    #-----< GA-AccessPointPositionwithOptionalAltitude-ExtIEs >-----#
    GA_AccessPointPositionwithOptionalAltitude_ExtIEs = CLASS(name=u'GA-AccessPointPositionwithOptionalAltitude-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GA_AccessPointPositionwithOptionalAltitude_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNChangeLimit >-----#
    SFNSFNChangeLimit = INT(name=u'SFNSFNChangeLimit', mode=MODE_TYPE)
    SFNSFNChangeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SFNSFNDriftRate >-----#
    SFNSFNDriftRate = INT(name=u'SFNSFNDriftRate', mode=MODE_TYPE)
    SFNSFNDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=100)], ev=None, er=[])
    
    #-----< SFNSFNDriftRateQuality >-----#
    SFNSFNDriftRateQuality = INT(name=u'SFNSFNDriftRateQuality', mode=MODE_TYPE)
    SFNSFNDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< SFNSFNMeasurementThresholdInformation >-----#
    SFNSFNMeasurementThresholdInformation = SEQ(name=u'SFNSFNMeasurementThresholdInformation', mode=MODE_TYPE)
    _SFNSFNMeasurementThresholdInformation_sFNSFNChangeLimit = INT(name=u'sFNSFNChangeLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNChangeLimit')), opt=True)
    _SFNSFNMeasurementThresholdInformation_predictedSFNSFNDeviationLimit = INT(name=u'predictedSFNSFNDeviationLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PredictedSFNSFNDeviationLimit')), opt=True)
    _SFNSFNMeasurementThresholdInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id._const_tab = ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab = ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id),
        (u'criticality', ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_._ext = None
    _SFNSFNMeasurementThresholdInformation_iE_Extensions._cont = __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_
    _SFNSFNMeasurementThresholdInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNMeasurementThresholdInformation._cont = ASN1Dict([
        (u'sFNSFNChangeLimit', _SFNSFNMeasurementThresholdInformation_sFNSFNChangeLimit),
        (u'predictedSFNSFNDeviationLimit', _SFNSFNMeasurementThresholdInformation_predictedSFNSFNDeviationLimit),
        (u'iE-Extensions', _SFNSFNMeasurementThresholdInformation_iE_Extensions),
        ])
    SFNSFNMeasurementThresholdInformation._ext = []
    
    #-----< SFNSFNMeasurementThresholdInformation-ExtIEs >-----#
    SFNSFNMeasurementThresholdInformation_ExtIEs = CLASS(name=u'SFNSFNMeasurementThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SFNSFNMeasurementThresholdInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNMeasurementValueInformation >-----#
    SFNSFNMeasurementValueInformation = SEQ(name=u'SFNSFNMeasurementValueInformation', mode=MODE_TYPE)
    _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = SEQ_OF(name=u'successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNValue = CHOICE(name=u'sFNSFNValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNValue')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNQuality = INT(name=u'sFNSFNQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNQuality')), opt=True)
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRate = INT(name=u'sFNSFNDriftRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNDriftRate')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRateQuality = INT(name=u'sFNSFNDriftRateQuality', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNDriftRateQuality')), opt=True)
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNTimeStampInformation = CHOICE(name=u'sFNSFNTimeStampInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNTimeStampInformation')))
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab = ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_at = None
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_id = u'id'
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab = ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab = ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id),
        (u'criticality', _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality),
        (u'extensionValue', _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue),
        ])
    ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._ext = None
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._cont = ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_
    ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._cont = ASN1Dict([
        (u'uC-ID', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_ID),
        (u'sFNSFNValue', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNValue),
        (u'sFNSFNQuality', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNQuality),
        (u'sFNSFNDriftRate', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRate),
        (u'sFNSFNDriftRateQuality', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRateQuality),
        (u'sFNSFNTimeStampInformation', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNTimeStampInformation),
        (u'iE-Extensions', ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions),
        ])
    __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._ext = []
    _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._cont = __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_
    _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=96)], ev=None, er=[])
    _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation = SEQ_OF(name=u'unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab = ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_at = None
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id._const_tab_id = u'id'
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab = ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab = ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id),
        (u'criticality', _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality),
        (u'extensionValue', _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue),
        ])
    ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_._ext = None
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._cont = ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_
    ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._cont = ASN1Dict([
        (u'uC-ID', ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_ID),
        (u'iE-Extensions', ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions),
        ])
    __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_._ext = []
    _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._cont = __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_
    _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=95)], ev=None, er=[])
    _SFNSFNMeasurementValueInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNMeasurementValueInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id._const_tab = ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality._const_tab = ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SFNSFNMeasurementValueInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id),
        (u'criticality', ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNMeasurementValueInformation_iE_Extensions__item_._ext = None
    _SFNSFNMeasurementValueInformation_iE_Extensions._cont = __SFNSFNMeasurementValueInformation_iE_Extensions__item_
    _SFNSFNMeasurementValueInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNMeasurementValueInformation._cont = ASN1Dict([
        (u'successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation),
        (u'unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation', _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation),
        (u'iE-Extensions', _SFNSFNMeasurementValueInformation_iE_Extensions),
        ])
    SFNSFNMeasurementValueInformation._ext = []
    
    #-----< SFNSFNMeasurementValueInformationItem-ExtIEs >-----#
    SFNSFNMeasurementValueInformationItem_ExtIEs = CLASS(name=u'SFNSFNMeasurementValueInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SFNSFNMeasurementValueInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs >-----#
    SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs = CLASS(name=u'SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs >-----#
    UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs = CLASS(name=u'UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNQuality >-----#
    SFNSFNQuality = INT(name=u'SFNSFNQuality', mode=MODE_TYPE)
    SFNSFNQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SFNSFNTimeStampInformation >-----#
    SFNSFNTimeStampInformation = CHOICE(name=u'SFNSFNTimeStampInformation', mode=MODE_TYPE)
    _SFNSFNTimeStampInformation_sFNSFNTimeStamp_FDD = INT(name=u'sFNSFNTimeStamp-FDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    _SFNSFNTimeStampInformation_sFNSFNTimeStamp_TDD = SEQ(name=u'sFNSFNTimeStamp-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFNTimeStamp-TDD')))
    SFNSFNTimeStampInformation._cont = ASN1Dict([
        (u'sFNSFNTimeStamp-FDD', _SFNSFNTimeStampInformation_sFNSFNTimeStamp_FDD),
        (u'sFNSFNTimeStamp-TDD', _SFNSFNTimeStampInformation_sFNSFNTimeStamp_TDD),
        ])
    SFNSFNTimeStampInformation._ext = []
    
    #-----< SFNSFNTimeStamp-TDD >-----#
    SFNSFNTimeStamp_TDD = SEQ(name=u'SFNSFNTimeStamp-TDD', mode=MODE_TYPE)
    _SFNSFNTimeStamp_TDD_sFN = INT(name=u'sFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    _SFNSFNTimeStamp_TDD_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _SFNSFNTimeStamp_TDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNTimeStamp_TDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id._const_tab = ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality._const_tab = ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SFNSFNTimeStamp_TDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id),
        (u'criticality', ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNTimeStamp_TDD_iE_Extensions__item_._ext = None
    _SFNSFNTimeStamp_TDD_iE_Extensions._cont = __SFNSFNTimeStamp_TDD_iE_Extensions__item_
    _SFNSFNTimeStamp_TDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNTimeStamp_TDD._cont = ASN1Dict([
        (u'sFN', _SFNSFNTimeStamp_TDD_sFN),
        (u'timeSlot', _SFNSFNTimeStamp_TDD_timeSlot),
        (u'iE-Extensions', _SFNSFNTimeStamp_TDD_iE_Extensions),
        ])
    SFNSFNTimeStamp_TDD._ext = []
    
    #-----< SFNSFNTimeStamp-ExtIEs >-----#
    SFNSFNTimeStamp_ExtIEs = CLASS(name=u'SFNSFNTimeStamp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SFNSFNTimeStamp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNValue >-----#
    SFNSFNValue = CHOICE(name=u'SFNSFNValue', mode=MODE_TYPE)
    _SFNSFNValue_sFNSFN_FDD = INT(name=u'sFNSFN-FDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFN-FDD')))
    _SFNSFNValue_sFNSFN_TDD = INT(name=u'sFNSFN-TDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFN-TDD')))
    _SFNSFNValue_sFNSFN_TDD768 = INT(name=u'sFNSFN-TDD768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SFNSFN-TDD768')))
    SFNSFNValue._cont = ASN1Dict([
        (u'sFNSFN-FDD', _SFNSFNValue_sFNSFN_FDD),
        (u'sFNSFN-TDD', _SFNSFNValue_sFNSFN_TDD),
        (u'sFNSFN-TDD768', _SFNSFNValue_sFNSFN_TDD768),
        ])
    SFNSFNValue._ext = [u'sFNSFN-TDD768']
    
    #-----< SID >-----#
    SID = INT(name=u'SID', mode=MODE_TYPE)
    SID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< Single-Stream-MIMO-ActivationIndicator >-----#
    Single_Stream_MIMO_ActivationIndicator = NULL(name=u'Single-Stream-MIMO-ActivationIndicator', mode=MODE_TYPE)
    
    #-----< Single-Stream-MIMO-Mode-Indicator >-----#
    Single_Stream_MIMO_Mode_Indicator = ENUM(name=u'Single-Stream-MIMO-Mode-Indicator', mode=MODE_TYPE)
    Single_Stream_MIMO_Mode_Indicator._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    Single_Stream_MIMO_Mode_Indicator._ext = None
    
    #-----< SIR-Error-Value >-----#
    SIR_Error_Value = INT(name=u'SIR-Error-Value', mode=MODE_TYPE)
    SIR_Error_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=125)], ev=None, er=[])
    
    #-----< SIR-Error-Value-IncrDecrThres >-----#
    SIR_Error_Value_IncrDecrThres = INT(name=u'SIR-Error-Value-IncrDecrThres', mode=MODE_TYPE)
    SIR_Error_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=124)], ev=None, er=[])
    
    #-----< SIR-Value >-----#
    SIR_Value = INT(name=u'SIR-Value', mode=MODE_TYPE)
    SIR_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< SIR-Value-IncrDecrThres >-----#
    SIR_Value_IncrDecrThres = INT(name=u'SIR-Value-IncrDecrThres', mode=MODE_TYPE)
    SIR_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=62)], ev=None, er=[])
    
    #-----< SixteenQAM-UL-Operation-Indicator >-----#
    SixteenQAM_UL_Operation_Indicator = ENUM(name=u'SixteenQAM-UL-Operation-Indicator', mode=MODE_TYPE)
    SixteenQAM_UL_Operation_Indicator._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    SixteenQAM_UL_Operation_Indicator._ext = None
    
    #-----< SixtyfourQAM-UL-Operation-Indicator >-----#
    SixtyfourQAM_UL_Operation_Indicator = ENUM(name=u'SixtyfourQAM-UL-Operation-Indicator', mode=MODE_TYPE)
    SixtyfourQAM_UL_Operation_Indicator._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    SixtyfourQAM_UL_Operation_Indicator._ext = None
    
    #-----< SixtyfourQAM-UsageAllowedIndicator >-----#
    SixtyfourQAM_UsageAllowedIndicator = ENUM(name=u'SixtyfourQAM-UsageAllowedIndicator', mode=MODE_TYPE)
    SixtyfourQAM_UsageAllowedIndicator._cont = ASN1Dict([(u'allowed', 0), (u'not-allowed', 1)])
    SixtyfourQAM_UsageAllowedIndicator._ext = None
    
    #-----< SixtyfourQAM-DL-SupportIndicator >-----#
    SixtyfourQAM_DL_SupportIndicator = ENUM(name=u'SixtyfourQAM-DL-SupportIndicator', mode=MODE_TYPE)
    SixtyfourQAM_DL_SupportIndicator._cont = ASN1Dict([(u'sixtyfourQAM-DL-supported', 0), (u'sixtyfourQAM-DL-not-supported', 1)])
    SixtyfourQAM_DL_SupportIndicator._ext = None
    
    #-----< SixtyfourQAM-DL-UsageIndicator >-----#
    SixtyfourQAM_DL_UsageIndicator = ENUM(name=u'SixtyfourQAM-DL-UsageIndicator', mode=MODE_TYPE)
    SixtyfourQAM_DL_UsageIndicator._cont = ASN1Dict([(u'sixtyfourQAM-DL-used', 0), (u'sixtyfourQAM-DL-not-used', 1)])
    SixtyfourQAM_DL_UsageIndicator._ext = None
    
    #-----< SignatureSequenceGroupIndex >-----#
    SignatureSequenceGroupIndex = INT(name=u'SignatureSequenceGroupIndex', mode=MODE_TYPE)
    SignatureSequenceGroupIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    
    #-----< SNA-Information >-----#
    SNA_Information = SEQ(name=u'SNA-Information', mode=MODE_TYPE)
    _SNA_Information_pLMN_Identity = OCT_STR(name=u'pLMN-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _SNA_Information_listOfSNAs = SEQ_OF(name=u'listOfSNAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ListOfSNAs')), opt=True)
    _SNA_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNA_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SNA_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SNA_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SNA_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Information_iE_Extensions__item__id._const_tab = ____SNA_Information_iE_Extensions__item__id_tab
    ___SNA_Information_iE_Extensions__item__id._const_tab_at = None
    ___SNA_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___SNA_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SNA_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SNA_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Information_iE_Extensions__item__criticality._const_tab = ____SNA_Information_iE_Extensions__item__criticality_tab
    ___SNA_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SNA_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SNA_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SNA_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SNA_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Information_iE_Extensions__item__extensionValue._const_tab = ____SNA_Information_iE_Extensions__item__extensionValue_tab
    ___SNA_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SNA_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SNA_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SNA_Information_iE_Extensions__item__id),
        (u'criticality', ___SNA_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___SNA_Information_iE_Extensions__item__extensionValue),
        ])
    __SNA_Information_iE_Extensions__item_._ext = None
    _SNA_Information_iE_Extensions._cont = __SNA_Information_iE_Extensions__item_
    _SNA_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNA_Information._cont = ASN1Dict([
        (u'pLMN-Identity', _SNA_Information_pLMN_Identity),
        (u'listOfSNAs', _SNA_Information_listOfSNAs),
        (u'iE-Extensions', _SNA_Information_iE_Extensions),
        ])
    SNA_Information._ext = []
    
    #-----< SNA-Information-ExtIEs >-----#
    SNA_Information_ExtIEs = CLASS(name=u'SNA-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SNA_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ListOfSNAs >-----#
    ListOfSNAs = SEQ_OF(name=u'ListOfSNAs', mode=MODE_TYPE)
    _ListOfSNAs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNACode')))
    ListOfSNAs._cont = _ListOfSNAs__item_
    ListOfSNAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< SNACode >-----#
    SNACode = INT(name=u'SNACode', mode=MODE_TYPE)
    SNACode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< SourceID >-----#
    SourceID = SEQ(name=u'SourceID', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    
    #-----< SpecialBurstScheduling >-----#
    SpecialBurstScheduling = INT(name=u'SpecialBurstScheduling', mode=MODE_TYPE)
    SpecialBurstScheduling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SpeechVersion >-----#
    SpeechVersion = BIT_STR(name=u'SpeechVersion', mode=MODE_TYPE)
    SpeechVersion._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< S-RNTI >-----#
    S_RNTI = INT(name=u'S-RNTI', mode=MODE_TYPE)
    S_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< S-RNTI-Group >-----#
    S_RNTI_Group = SEQ(name=u'S-RNTI-Group', mode=MODE_TYPE)
    _S_RNTI_Group_sRNTI = INT(name=u'sRNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _S_RNTI_Group_sRNTI_BitMaskIndex = ENUM(name=u'sRNTI-BitMaskIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _S_RNTI_Group_sRNTI_BitMaskIndex._cont = ASN1Dict([(u'b1', 0), (u'b2', 1), (u'b3', 2), (u'b4', 3), (u'b5', 4), (u'b6', 5), (u'b7', 6), (u'b8', 7), (u'b9', 8), (u'b10', 9), (u'b11', 10), (u'b12', 11), (u'b13', 12), (u'b14', 13), (u'b15', 14), (u'b16', 15), (u'b17', 16), (u'b18', 17), (u'b19', 18)])
    _S_RNTI_Group_sRNTI_BitMaskIndex._ext = []
    S_RNTI_Group._cont = ASN1Dict([
        (u'sRNTI', _S_RNTI_Group_sRNTI),
        (u'sRNTI-BitMaskIndex', _S_RNTI_Group_sRNTI_BitMaskIndex),
        ])
    S_RNTI_Group._ext = None
    
    #-----< SRB-Delay >-----#
    SRB_Delay = INT(name=u'SRB-Delay', mode=MODE_TYPE)
    SRB_Delay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=[], er=[])
    
    #-----< SSDT-SupportIndicator >-----#
    SSDT_SupportIndicator = ENUM(name=u'SSDT-SupportIndicator', mode=MODE_TYPE)
    SSDT_SupportIndicator._cont = ASN1Dict([(u'not-Used-sSDT-supported', 0), (u'sSDT-not-supported', 1)])
    SSDT_SupportIndicator._ext = None
    
    #-----< Standalone-Midamble-Channel-Indicator >-----#
    Standalone_Midamble_Channel_Indicator = ENUM(name=u'Standalone-Midamble-Channel-Indicator', mode=MODE_TYPE)
    Standalone_Midamble_Channel_Indicator._cont = ASN1Dict([(u'used', 0), (u'not-used', 1)])
    Standalone_Midamble_Channel_Indicator._ext = None
    
    #-----< Status-Flag >-----#
    Status_Flag = ENUM(name=u'Status-Flag', mode=MODE_TYPE)
    Status_Flag._cont = ASN1Dict([(u'activate', 0), (u'deactivate', 1)])
    Status_Flag._ext = None
    
    #-----< STTD-SupportIndicator >-----#
    STTD_SupportIndicator = ENUM(name=u'STTD-SupportIndicator', mode=MODE_TYPE)
    STTD_SupportIndicator._cont = ASN1Dict([(u'sTTD-Supported', 0), (u'sTTD-not-Supported', 1)])
    STTD_SupportIndicator._ext = None
    
    #-----< Support-8PSK >-----#
    Support_8PSK = ENUM(name=u'Support-8PSK', mode=MODE_TYPE)
    Support_8PSK._cont = ASN1Dict([(u'v8PSK-Supported', 0)])
    Support_8PSK._ext = None
    
    #-----< Support-PLCCH >-----#
    Support_PLCCH = ENUM(name=u'Support-PLCCH', mode=MODE_TYPE)
    Support_PLCCH._cont = ASN1Dict([(u'vPLCCH-Supported', 0)])
    Support_PLCCH._ext = None
    
    #-----< Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order >-----#
    Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order = ENUM(name=u'Support-of-Dynamic-DTXDRX-Related-HS-SCCH-Order', mode=MODE_TYPE)
    Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order._cont = ASN1Dict([(u'supported', 0), (u'not-supported', 1)])
    Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order._ext = None
    
    #-----< SyncCase >-----#
    SyncCase = INT(name=u'SyncCase', mode=MODE_TYPE)
    SyncCase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=[], er=[])
    
    #-----< SynchronisationConfiguration >-----#
    SynchronisationConfiguration = SEQ(name=u'SynchronisationConfiguration', mode=MODE_TYPE)
    _SynchronisationConfiguration_n_INSYNC_IND = INT(name=u'n-INSYNC-IND', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SynchronisationConfiguration_n_INSYNC_IND._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _SynchronisationConfiguration_n_OUTSYNC_IND = INT(name=u'n-OUTSYNC-IND', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SynchronisationConfiguration_n_OUTSYNC_IND._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _SynchronisationConfiguration_t_RLFAILURE = INT(name=u't-RLFAILURE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SynchronisationConfiguration_t_RLFAILURE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _SynchronisationConfiguration_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SynchronisationConfiguration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SynchronisationConfiguration_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SynchronisationConfiguration_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SynchronisationConfiguration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationConfiguration_iE_Extensions__item__id._const_tab = ____SynchronisationConfiguration_iE_Extensions__item__id_tab
    ___SynchronisationConfiguration_iE_Extensions__item__id._const_tab_at = None
    ___SynchronisationConfiguration_iE_Extensions__item__id._const_tab_id = u'id'
    ___SynchronisationConfiguration_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SynchronisationConfiguration_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SynchronisationConfiguration_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationConfiguration_iE_Extensions__item__criticality._const_tab = ____SynchronisationConfiguration_iE_Extensions__item__criticality_tab
    ___SynchronisationConfiguration_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SynchronisationConfiguration_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SynchronisationConfiguration_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SynchronisationConfiguration_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SynchronisationConfiguration_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SynchronisationConfiguration_iE_Extensions__item__extensionValue._const_tab = ____SynchronisationConfiguration_iE_Extensions__item__extensionValue_tab
    ___SynchronisationConfiguration_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SynchronisationConfiguration_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SynchronisationConfiguration_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SynchronisationConfiguration_iE_Extensions__item__id),
        (u'criticality', ___SynchronisationConfiguration_iE_Extensions__item__criticality),
        (u'extensionValue', ___SynchronisationConfiguration_iE_Extensions__item__extensionValue),
        ])
    __SynchronisationConfiguration_iE_Extensions__item_._ext = None
    _SynchronisationConfiguration_iE_Extensions._cont = __SynchronisationConfiguration_iE_Extensions__item_
    _SynchronisationConfiguration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SynchronisationConfiguration._cont = ASN1Dict([
        (u'n-INSYNC-IND', _SynchronisationConfiguration_n_INSYNC_IND),
        (u'n-OUTSYNC-IND', _SynchronisationConfiguration_n_OUTSYNC_IND),
        (u't-RLFAILURE', _SynchronisationConfiguration_t_RLFAILURE),
        (u'iE-Extensions', _SynchronisationConfiguration_iE_Extensions),
        ])
    SynchronisationConfiguration._ext = []
    
    #-----< SynchronisationConfiguration-ExtIEs >-----#
    SynchronisationConfiguration_ExtIEs = CLASS(name=u'SynchronisationConfiguration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SynchronisationConfiguration_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SYNC-UL-ProcParameters >-----#
    SYNC_UL_ProcParameters = SEQ(name=u'SYNC-UL-ProcParameters', mode=MODE_TYPE)
    _SYNC_UL_ProcParameters_maxSYNC_UL_transmissions = ENUM(name=u'maxSYNC-UL-transmissions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SYNC_UL_ProcParameters_maxSYNC_UL_transmissions._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3)])
    _SYNC_UL_ProcParameters_maxSYNC_UL_transmissions._ext = []
    _SYNC_UL_ProcParameters_powerRampStep = INT(name=u'powerRampStep', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SYNC_UL_ProcParameters_powerRampStep._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[])
    SYNC_UL_ProcParameters._cont = ASN1Dict([
        (u'maxSYNC-UL-transmissions', _SYNC_UL_ProcParameters_maxSYNC_UL_transmissions),
        (u'powerRampStep', _SYNC_UL_ProcParameters_powerRampStep),
        ])
    SYNC_UL_ProcParameters._ext = []
    
    #-----< T1 >-----#
    T1 = ENUM(name=u'T1', mode=MODE_TYPE)
    T1._cont = ASN1Dict([(u'v10', 0), (u'v20', 1), (u'v30', 2), (u'v40', 3), (u'v50', 4), (u'v60', 5), (u'v70', 6), (u'v80', 7), (u'v90', 8), (u'v100', 9), (u'v120', 10), (u'v140', 11), (u'v160', 12), (u'v200', 13), (u'v300', 14), (u'v400', 15)])
    T1._ext = []
    
    #-----< TAC >-----#
    TAC = OCT_STR(name=u'TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TargetID >-----#
    TargetID = SEQ(name=u'TargetID', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CGI')))
    
    #-----< TDD-AckNack-Power-Offset >-----#
    TDD_AckNack_Power_Offset = INT(name=u'TDD-AckNack-Power-Offset', mode=MODE_TYPE)
    TDD_AckNack_Power_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-7, ub=8)], ev=[], er=[])
    
    #-----< TDD-ChannelisationCode >-----#
    TDD_ChannelisationCode = ENUM(name=u'TDD-ChannelisationCode', mode=MODE_TYPE)
    TDD_ChannelisationCode._cont = ASN1Dict([(u'chCode1div1', 0), (u'chCode2div1', 1), (u'chCode2div2', 2), (u'chCode4div1', 3), (u'chCode4div2', 4), (u'chCode4div3', 5), (u'chCode4div4', 6), (u'chCode8div1', 7), (u'chCode8div2', 8), (u'chCode8div3', 9), (u'chCode8div4', 10), (u'chCode8div5', 11), (u'chCode8div6', 12), (u'chCode8div7', 13), (u'chCode8div8', 14), (u'chCode16div1', 15), (u'chCode16div2', 16), (u'chCode16div3', 17), (u'chCode16div4', 18), (u'chCode16div5', 19), (u'chCode16div6', 20), (u'chCode16div7', 21), (u'chCode16div8', 22), (u'chCode16div9', 23), (u'chCode16div10', 24), (u'chCode16div11', 25), (u'chCode16div12', 26), (u'chCode16div13', 27), (u'chCode16div14', 28), (u'chCode16div15', 29), (u'chCode16div16', 30)])
    TDD_ChannelisationCode._ext = []
    
    #-----< TDD-ChannelisationCode768 >-----#
    TDD_ChannelisationCode768 = ENUM(name=u'TDD-ChannelisationCode768', mode=MODE_TYPE)
    TDD_ChannelisationCode768._cont = ASN1Dict([(u'chCode1div1', 0), (u'chCode2div1', 1), (u'chCode2div2', 2), (u'chCode4div1', 3), (u'chCode4div2', 4), (u'chCode4div3', 5), (u'chCode4div4', 6), (u'chCode8div1', 7), (u'chCode8div2', 8), (u'chCode8div3', 9), (u'chCode8div4', 10), (u'chCode8div5', 11), (u'chCode8div6', 12), (u'chCode8div7', 13), (u'chCode8div8', 14), (u'chCode16div1', 15), (u'chCode16div2', 16), (u'chCode16div3', 17), (u'chCode16div4', 18), (u'chCode16div5', 19), (u'chCode16div6', 20), (u'chCode16div7', 21), (u'chCode16div8', 22), (u'chCode16div9', 23), (u'chCode16div10', 24), (u'chCode16div11', 25), (u'chCode16div12', 26), (u'chCode16div13', 27), (u'chCode16div14', 28), (u'chCode16div15', 29), (u'chCode16div16', 30), (u'chCode32div1', 31), (u'chCode32div2', 32), (u'chCode32div3', 33), (u'chCode32div4', 34), (u'chCode32div5', 35), (u'chCode32div6', 36), (u'chCode32div7', 37), (u'chCode32div8', 38), (u'chCode32div9', 39), (u'chCode32div10', 40), (u'chCode32div11', 41), (u'chCode32div12', 42), (u'chCode32div13', 43), (u'chCode32div14', 44), (u'chCode32div15', 45), (u'chCode32div16', 46), (u'chCode32div17', 47), (u'chCode32div18', 48), (u'chCode32div19', 49), (u'chCode32div20', 50), (u'chCode32div21', 51), (u'chCode32div22', 52), (u'chCode32div23', 53), (u'chCode32div24', 54), (u'chCode32div25', 55), (u'chCode32div26', 56), (u'chCode32div27', 57), (u'chCode32div28', 58), (u'chCode32div29', 59), (u'chCode32div30', 60), (u'chCode32div31', 61), (u'chCode32div32', 62)])
    TDD_ChannelisationCode768._ext = []
    
    #-----< TDD-ChannelisationCodeLCR >-----#
    TDD_ChannelisationCodeLCR = SEQ(name=u'TDD-ChannelisationCodeLCR', mode=MODE_TYPE)
    _TDD_ChannelisationCodeLCR_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_ChannelisationCodeLCR_modulation = ENUM(name=u'modulation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Modulation')))
    TDD_ChannelisationCodeLCR._cont = ASN1Dict([
        (u'tDD-ChannelisationCode', _TDD_ChannelisationCodeLCR_tDD_ChannelisationCode),
        (u'modulation', _TDD_ChannelisationCodeLCR_modulation),
        ])
    TDD_ChannelisationCodeLCR._ext = []
    
    #-----< TDD-DCHs-to-Modify >-----#
    TDD_DCHs_to_Modify = SEQ_OF(name=u'TDD-DCHs-to-Modify', mode=MODE_TYPE)
    _TDD_DCHs_to_Modify__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-ModifyItem')))
    TDD_DCHs_to_Modify._cont = _TDD_DCHs_to_Modify__item_
    TDD_DCHs_to_Modify._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< TDD-DCHs-to-ModifyItem >-----#
    TDD_DCHs_to_ModifyItem = SEQ(name=u'TDD-DCHs-to-ModifyItem', mode=MODE_TYPE)
    _TDD_DCHs_to_ModifyItem_ul_FP_Mode = ENUM(name=u'ul-FP-Mode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-FP-Mode')), opt=True)
    _TDD_DCHs_to_ModifyItem_toAWS = INT(name=u'toAWS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWS')), opt=True)
    _TDD_DCHs_to_ModifyItem_toAWE = INT(name=u'toAWE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ToAWE')), opt=True)
    _TDD_DCHs_to_ModifyItem_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _TDD_DCHs_to_ModifyItem_dCH_SpecificInformationList = SEQ_OF(name=u'dCH-SpecificInformationList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-ModifySpecificInformationList')))
    _TDD_DCHs_to_ModifyItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DCHs_to_ModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab = ____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab = ____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DCHs_to_ModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__id),
        (u'criticality', ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DCHs_to_ModifyItem_iE_Extensions__item_._ext = None
    _TDD_DCHs_to_ModifyItem_iE_Extensions._cont = __TDD_DCHs_to_ModifyItem_iE_Extensions__item_
    _TDD_DCHs_to_ModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DCHs_to_ModifyItem._cont = ASN1Dict([
        (u'ul-FP-Mode', _TDD_DCHs_to_ModifyItem_ul_FP_Mode),
        (u'toAWS', _TDD_DCHs_to_ModifyItem_toAWS),
        (u'toAWE', _TDD_DCHs_to_ModifyItem_toAWE),
        (u'transportBearerRequestIndicator', _TDD_DCHs_to_ModifyItem_transportBearerRequestIndicator),
        (u'dCH-SpecificInformationList', _TDD_DCHs_to_ModifyItem_dCH_SpecificInformationList),
        (u'iE-Extensions', _TDD_DCHs_to_ModifyItem_iE_Extensions),
        ])
    TDD_DCHs_to_ModifyItem._ext = []
    
    #-----< TDD-DCHs-to-ModifyItem-ExtIEs >-----#
    TDD_DCHs_to_ModifyItem_ExtIEs = CLASS(name=u'TDD-DCHs-to-ModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    TDD_DCHs_to_ModifyItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _TDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-DCHs-to-ModifySpecificInformationList >-----#
    TDD_DCHs_to_ModifySpecificInformationList = SEQ_OF(name=u'TDD-DCHs-to-ModifySpecificInformationList', mode=MODE_TYPE)
    _TDD_DCHs_to_ModifySpecificInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-ModifySpecificItem')))
    TDD_DCHs_to_ModifySpecificInformationList._cont = _TDD_DCHs_to_ModifySpecificInformationList__item_
    TDD_DCHs_to_ModifySpecificInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< TDD-DCHs-to-ModifySpecificItem >-----#
    TDD_DCHs_to_ModifySpecificItem = SEQ(name=u'TDD-DCHs-to-ModifySpecificItem', mode=MODE_TYPE)
    _TDD_DCHs_to_ModifySpecificItem_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _TDD_DCHs_to_ModifySpecificItem_ul_CCTrCH_ID = INT(name=u'ul-CCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')), opt=True)
    _TDD_DCHs_to_ModifySpecificItem_dl_CCTrCH_ID = INT(name=u'dl-CCTrCH-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')), opt=True)
    _TDD_DCHs_to_ModifySpecificItem_ul_TransportformatSet = SEQ(name=u'ul-TransportformatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')), opt=True)
    _TDD_DCHs_to_ModifySpecificItem_dl_TransportformatSet = SEQ(name=u'dl-TransportformatSet', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')), opt=True)
    _TDD_DCHs_to_ModifySpecificItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _TDD_DCHs_to_ModifySpecificItem_frameHandlingPriority = INT(name=u'frameHandlingPriority', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameHandlingPriority')), opt=True)
    _TDD_DCHs_to_ModifySpecificItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    ____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id._const_tab = ____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality._const_tab = ____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id),
        (u'criticality', ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_._ext = None
    _TDD_DCHs_to_ModifySpecificItem_iE_Extensions._cont = __TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_
    _TDD_DCHs_to_ModifySpecificItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DCHs_to_ModifySpecificItem._cont = ASN1Dict([
        (u'dCH-ID', _TDD_DCHs_to_ModifySpecificItem_dCH_ID),
        (u'ul-CCTrCH-ID', _TDD_DCHs_to_ModifySpecificItem_ul_CCTrCH_ID),
        (u'dl-CCTrCH-ID', _TDD_DCHs_to_ModifySpecificItem_dl_CCTrCH_ID),
        (u'ul-TransportformatSet', _TDD_DCHs_to_ModifySpecificItem_ul_TransportformatSet),
        (u'dl-TransportformatSet', _TDD_DCHs_to_ModifySpecificItem_dl_TransportformatSet),
        (u'allocationRetentionPriority', _TDD_DCHs_to_ModifySpecificItem_allocationRetentionPriority),
        (u'frameHandlingPriority', _TDD_DCHs_to_ModifySpecificItem_frameHandlingPriority),
        (u'iE-Extensions', _TDD_DCHs_to_ModifySpecificItem_iE_Extensions),
        ])
    TDD_DCHs_to_ModifySpecificItem._ext = []
    
    #-----< TDD-DCHs-to-ModifySpecificItem-ExtIEs >-----#
    TDD_DCHs_to_ModifySpecificItem_ExtIEs = CLASS(name=u'TDD-DCHs-to-ModifySpecificItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Guaranteed-Rate-Information')))
    _TDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    TDD_DCHs_to_ModifySpecificItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 41), (u'criticality', u'ignore'), (u'Extension', _TDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _TDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-Information >-----#
    TDD_DL_Code_Information = SEQ_OF(name=u'TDD-DL-Code-Information', mode=MODE_TYPE)
    _TDD_DL_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-InformationItem')))
    TDD_DL_Code_Information._cont = _TDD_DL_Code_Information__item_
    TDD_DL_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-DL-Code-InformationItem >-----#
    TDD_DL_Code_InformationItem = SEQ(name=u'TDD-DL-Code-InformationItem', mode=MODE_TYPE)
    _TDD_DL_Code_InformationItem_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_InformationItem_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_DL_Code_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DL_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DL_Code_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_InformationItem_iE_Extensions__item_._ext = None
    _TDD_DL_Code_InformationItem_iE_Extensions._cont = __TDD_DL_Code_InformationItem_iE_Extensions__item_
    _TDD_DL_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_InformationItem._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_DL_Code_InformationItem_dPCH_ID),
        (u'tDD-ChannelisationCode', _TDD_DL_Code_InformationItem_tDD_ChannelisationCode),
        (u'iE-Extensions', _TDD_DL_Code_InformationItem_iE_Extensions),
        ])
    TDD_DL_Code_InformationItem._ext = []
    
    #-----< TDD-DL-Code-InformationItem-ExtIEs >-----#
    TDD_DL_Code_InformationItem_ExtIEs = CLASS(name=u'TDD-DL-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-LCR-Information >-----#
    TDD_DL_Code_LCR_Information = SEQ_OF(name=u'TDD-DL-Code-LCR-Information', mode=MODE_TYPE)
    _TDD_DL_Code_LCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-LCR-InformationItem')))
    TDD_DL_Code_LCR_Information._cont = _TDD_DL_Code_LCR_Information__item_
    TDD_DL_Code_LCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-DL-Code-LCR-InformationItem >-----#
    TDD_DL_Code_LCR_InformationItem = SEQ(name=u'TDD-DL-Code-LCR-InformationItem', mode=MODE_TYPE)
    _TDD_DL_Code_LCR_InformationItem_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR = SEQ(name=u'tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _TDD_DL_Code_LCR_InformationItem_tdd_DL_DPCH_TimeSlotFormat_LCR = CHOICE(name=u'tdd-DL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    _TDD_DL_Code_LCR_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_._ext = None
    _TDD_DL_Code_LCR_InformationItem_iE_Extensions._cont = __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_
    _TDD_DL_Code_LCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_LCR_InformationItem._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_DL_Code_LCR_InformationItem_dPCH_ID),
        (u'tdd-ChannelisationCodeLCR', _TDD_DL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR),
        (u'tdd-DL-DPCH-TimeSlotFormat-LCR', _TDD_DL_Code_LCR_InformationItem_tdd_DL_DPCH_TimeSlotFormat_LCR),
        (u'iE-Extensions', _TDD_DL_Code_LCR_InformationItem_iE_Extensions),
        ])
    TDD_DL_Code_LCR_InformationItem._ext = []
    
    #-----< TDD-DL-Code-LCR-InformationItem-ExtIEs >-----#
    TDD_DL_Code_LCR_InformationItem_ExtIEs = CLASS(name=u'TDD-DL-Code-LCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_LCR_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-Information768 >-----#
    TDD_DL_Code_Information768 = SEQ_OF(name=u'TDD-DL-Code-Information768', mode=MODE_TYPE)
    _TDD_DL_Code_Information768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-InformationItem768')))
    TDD_DL_Code_Information768._cont = _TDD_DL_Code_Information768__item_
    TDD_DL_Code_Information768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< TDD-DL-Code-InformationItem768 >-----#
    TDD_DL_Code_InformationItem768 = SEQ(name=u'TDD-DL-Code-InformationItem768', mode=MODE_TYPE)
    _TDD_DL_Code_InformationItem768_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_InformationItem768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _TDD_DL_Code_InformationItem768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_InformationItem768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DL_Code_InformationItem768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_InformationItem768_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DL_Code_InformationItem768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DL_Code_InformationItem768_iE_Extensions__item__id),
        (u'criticality', ___TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_InformationItem768_iE_Extensions__item_._ext = None
    _TDD_DL_Code_InformationItem768_iE_Extensions._cont = __TDD_DL_Code_InformationItem768_iE_Extensions__item_
    _TDD_DL_Code_InformationItem768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_InformationItem768._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_DL_Code_InformationItem768_dPCH_ID),
        (u'tDD-ChannelisationCode768', _TDD_DL_Code_InformationItem768_tDD_ChannelisationCode768),
        (u'iE-Extensions', _TDD_DL_Code_InformationItem768_iE_Extensions),
        ])
    TDD_DL_Code_InformationItem768._ext = []
    
    #-----< TDD-DL-Code-InformationItem768-ExtIEs >-----#
    TDD_DL_Code_InformationItem768_ExtIEs = CLASS(name=u'TDD-DL-Code-InformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_InformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-DPCH-TimeSlotFormat-LCR >-----#
    TDD_DL_DPCH_TimeSlotFormat_LCR = CHOICE(name=u'TDD-DL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE)
    _TDD_DL_DPCH_TimeSlotFormat_LCR_qPSK = INT(name=u'qPSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR')))
    _TDD_DL_DPCH_TimeSlotFormat_LCR_eightPSK = INT(name=u'eightPSK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR')))
    TDD_DL_DPCH_TimeSlotFormat_LCR._cont = ASN1Dict([
        (u'qPSK', _TDD_DL_DPCH_TimeSlotFormat_LCR_qPSK),
        (u'eightPSK', _TDD_DL_DPCH_TimeSlotFormat_LCR_eightPSK),
        ])
    TDD_DL_DPCH_TimeSlotFormat_LCR._ext = []
    
    #-----< QPSK-DL-DPCH-TimeSlotFormatTDD-LCR >-----#
    QPSK_DL_DPCH_TimeSlotFormatTDD_LCR = INT(name=u'QPSK-DL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    QPSK_DL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=[], er=[])
    
    #-----< EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR >-----#
    EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR = INT(name=u'EightPSK-DL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=[], er=[])
    
    #-----< TDD-DPCHOffset >-----#
    TDD_DPCHOffset = CHOICE(name=u'TDD-DPCHOffset', mode=MODE_TYPE)
    _TDD_DPCHOffset_initialOffset = INT(name=u'initialOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_DPCHOffset_initialOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TDD_DPCHOffset_noinitialOffset = INT(name=u'noinitialOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_DPCHOffset_noinitialOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    TDD_DPCHOffset._cont = ASN1Dict([
        (u'initialOffset', _TDD_DPCHOffset_initialOffset),
        (u'noinitialOffset', _TDD_DPCHOffset_noinitialOffset),
        ])
    TDD_DPCHOffset._ext = None
    
    #-----< TDD-PhysicalChannelOffset >-----#
    TDD_PhysicalChannelOffset = INT(name=u'TDD-PhysicalChannelOffset', mode=MODE_TYPE)
    TDD_PhysicalChannelOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< TDD-TPC-DownlinkStepSize >-----#
    TDD_TPC_DownlinkStepSize = ENUM(name=u'TDD-TPC-DownlinkStepSize', mode=MODE_TYPE)
    TDD_TPC_DownlinkStepSize._cont = ASN1Dict([(u'step-size1', 0), (u'step-size2', 1), (u'step-size3', 2)])
    TDD_TPC_DownlinkStepSize._ext = []
    
    #-----< TDD-TPC-UplinkStepSize-LCR >-----#
    TDD_TPC_UplinkStepSize_LCR = ENUM(name=u'TDD-TPC-UplinkStepSize-LCR', mode=MODE_TYPE)
    TDD_TPC_UplinkStepSize_LCR._cont = ASN1Dict([(u'step-size1', 0), (u'step-size2', 1), (u'step-size3', 2)])
    TDD_TPC_UplinkStepSize_LCR._ext = []
    
    #-----< TDD-UL-Code-Information >-----#
    TDD_UL_Code_Information = SEQ_OF(name=u'TDD-UL-Code-Information', mode=MODE_TYPE)
    _TDD_UL_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-InformationItem')))
    TDD_UL_Code_Information._cont = _TDD_UL_Code_Information__item_
    TDD_UL_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-InformationItem >-----#
    TDD_UL_Code_InformationItem = SEQ(name=u'TDD-UL-Code-InformationItem', mode=MODE_TYPE)
    _TDD_UL_Code_InformationItem_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_InformationItem_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_UL_Code_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_UL_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_UL_Code_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_InformationItem_iE_Extensions__item_._ext = None
    _TDD_UL_Code_InformationItem_iE_Extensions._cont = __TDD_UL_Code_InformationItem_iE_Extensions__item_
    _TDD_UL_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_InformationItem._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_UL_Code_InformationItem_dPCH_ID),
        (u'tDD-ChannelisationCode', _TDD_UL_Code_InformationItem_tDD_ChannelisationCode),
        (u'iE-Extensions', _TDD_UL_Code_InformationItem_iE_Extensions),
        ])
    TDD_UL_Code_InformationItem._ext = []
    
    #-----< TDD-UL-Code-InformationItem-ExtIEs >-----#
    TDD_UL_Code_InformationItem_ExtIEs = CLASS(name=u'TDD-UL-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-LCR-Information >-----#
    TDD_UL_Code_LCR_Information = SEQ_OF(name=u'TDD-UL-Code-LCR-Information', mode=MODE_TYPE)
    _TDD_UL_Code_LCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-LCR-InformationItem')))
    TDD_UL_Code_LCR_Information._cont = _TDD_UL_Code_LCR_Information__item_
    TDD_UL_Code_LCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-LCR-InformationItem >-----#
    TDD_UL_Code_LCR_InformationItem = SEQ(name=u'TDD-UL-Code-LCR-InformationItem', mode=MODE_TYPE)
    _TDD_UL_Code_LCR_InformationItem_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR = SEQ(name=u'tdd-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCodeLCR')))
    _TDD_UL_Code_LCR_InformationItem_tdd_UL_DPCH_TimeSlotFormat_LCR = CHOICE(name=u'tdd-UL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    _TDD_UL_Code_LCR_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_._ext = None
    _TDD_UL_Code_LCR_InformationItem_iE_Extensions._cont = __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_
    _TDD_UL_Code_LCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_LCR_InformationItem._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_UL_Code_LCR_InformationItem_dPCH_ID),
        (u'tdd-ChannelisationCodeLCR', _TDD_UL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR),
        (u'tdd-UL-DPCH-TimeSlotFormat-LCR', _TDD_UL_Code_LCR_InformationItem_tdd_UL_DPCH_TimeSlotFormat_LCR),
        (u'iE-Extensions', _TDD_UL_Code_LCR_InformationItem_iE_Extensions),
        ])
    TDD_UL_Code_LCR_InformationItem._ext = []
    
    #-----< TDD-UL-Code-LCR-InformationItem-ExtIEs >-----#
    TDD_UL_Code_LCR_InformationItem_ExtIEs = CLASS(name=u'TDD-UL-Code-LCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_LCR_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-Information768 >-----#
    TDD_UL_Code_Information768 = SEQ_OF(name=u'TDD-UL-Code-Information768', mode=MODE_TYPE)
    _TDD_UL_Code_Information768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-InformationItem768')))
    TDD_UL_Code_Information768._cont = _TDD_UL_Code_Information768__item_
    TDD_UL_Code_Information768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< TDD-UL-Code-InformationItem768 >-----#
    TDD_UL_Code_InformationItem768 = SEQ(name=u'TDD-UL-Code-InformationItem768', mode=MODE_TYPE)
    _TDD_UL_Code_InformationItem768_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_InformationItem768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')))
    _TDD_UL_Code_InformationItem768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_InformationItem768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_UL_Code_InformationItem768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_InformationItem768_iE_Extensions__item__id_tab
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_UL_Code_InformationItem768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_UL_Code_InformationItem768_iE_Extensions__item__id),
        (u'criticality', ___TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_InformationItem768_iE_Extensions__item_._ext = None
    _TDD_UL_Code_InformationItem768_iE_Extensions._cont = __TDD_UL_Code_InformationItem768_iE_Extensions__item_
    _TDD_UL_Code_InformationItem768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_InformationItem768._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_UL_Code_InformationItem768_dPCH_ID),
        (u'tDD-ChannelisationCode768', _TDD_UL_Code_InformationItem768_tDD_ChannelisationCode768),
        (u'iE-Extensions', _TDD_UL_Code_InformationItem768_iE_Extensions),
        ])
    TDD_UL_Code_InformationItem768._ext = []
    
    #-----< TDD-UL-Code-InformationItem768-ExtIEs >-----#
    TDD_UL_Code_InformationItem768_ExtIEs = CLASS(name=u'TDD-UL-Code-InformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_InformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-DPCH-TimeSlotFormat-LCR >-----#
    TDD_UL_DPCH_TimeSlotFormat_LCR = CHOICE(name=u'TDD-UL-DPCH-TimeSlotFormat-LCR', mode=MODE_TYPE)
    _TDD_UL_DPCH_TimeSlotFormat_LCR_qPSK = INT(name=u'qPSK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR')))
    _TDD_UL_DPCH_TimeSlotFormat_LCR_eightPSK = INT(name=u'eightPSK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR')))
    TDD_UL_DPCH_TimeSlotFormat_LCR._cont = ASN1Dict([
        (u'qPSK', _TDD_UL_DPCH_TimeSlotFormat_LCR_qPSK),
        (u'eightPSK', _TDD_UL_DPCH_TimeSlotFormat_LCR_eightPSK),
        ])
    TDD_UL_DPCH_TimeSlotFormat_LCR._ext = []
    
    #-----< QPSK-UL-DPCH-TimeSlotFormatTDD-LCR >-----#
    QPSK_UL_DPCH_TimeSlotFormatTDD_LCR = INT(name=u'QPSK-UL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    QPSK_UL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=69)], ev=[], er=[])
    
    #-----< EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR >-----#
    EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR = INT(name=u'EightPSK-UL-DPCH-TimeSlotFormatTDD-LCR', mode=MODE_TYPE)
    EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=24)], ev=[], er=[])
    
    #-----< TFCI-Coding >-----#
    TFCI_Coding = ENUM(name=u'TFCI-Coding', mode=MODE_TYPE)
    TFCI_Coding._cont = ASN1Dict([(u'v4', 0), (u'v8', 1), (u'v16', 2), (u'v32', 3)])
    TFCI_Coding._ext = []
    
    #-----< TFCI-Presence >-----#
    TFCI_Presence = ENUM(name=u'TFCI-Presence', mode=MODE_TYPE)
    TFCI_Presence._cont = ASN1Dict([(u'present', 0), (u'not-present', 1)])
    TFCI_Presence._ext = None
    
    #-----< TFCI-SignallingMode >-----#
    TFCI_SignallingMode = ENUM(name=u'TFCI-SignallingMode', mode=MODE_TYPE)
    TFCI_SignallingMode._cont = ASN1Dict([(u'normal', 0), (u'not-Used-split', 1)])
    TFCI_SignallingMode._ext = None
    
    #-----< TGD >-----#
    TGD = INT(name=u'TGD', mode=MODE_TYPE)
    TGD._const_val = ASN1Set(rv=[0], rr=[ASN1RangeInt(lb=15, ub=269)], ev=None, er=[])
    
    #-----< TGPRC >-----#
    TGPRC = INT(name=u'TGPRC', mode=MODE_TYPE)
    TGPRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< TGPSID >-----#
    TGPSID = INT(name=u'TGPSID', mode=MODE_TYPE)
    TGPSID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< TGSN >-----#
    TGSN = INT(name=u'TGSN', mode=MODE_TYPE)
    TGSN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< TimeSlot >-----#
    TimeSlot = INT(name=u'TimeSlot', mode=MODE_TYPE)
    TimeSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< TimeSlotLCR >-----#
    TimeSlotLCR = INT(name=u'TimeSlotLCR', mode=MODE_TYPE)
    TimeSlotLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< Time-Stamp >-----#
    Time_Stamp = INT(name=u'Time-Stamp', mode=MODE_TYPE)
    Time_Stamp._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9999)], ev=None, er=[])
    
    #-----< TimingAdvanceApplied >-----#
    TimingAdvanceApplied = ENUM(name=u'TimingAdvanceApplied', mode=MODE_TYPE)
    TimingAdvanceApplied._cont = ASN1Dict([(u'yes', 0), (u'no', 1)])
    TimingAdvanceApplied._ext = None
    
    #-----< SynchronisationIndicator >-----#
    SynchronisationIndicator = ENUM(name=u'SynchronisationIndicator', mode=MODE_TYPE)
    SynchronisationIndicator._cont = ASN1Dict([(u'timingMaintainedSynchronisation', 0)])
    SynchronisationIndicator._ext = []
    
    #-----< TMGI >-----#
    TMGI = SEQ(name=u'TMGI', mode=MODE_TYPE)
    _TMGI_plmn_id = OCT_STR(name=u'plmn-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _TMGI_service_id = OCT_STR(name=u'service-id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Service-ID')))
    _TMGI_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TMGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TMGI_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TMGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__id._const_tab = ____TMGI_iE_Extensions__item__id_tab
    ___TMGI_iE_Extensions__item__id._const_tab_at = None
    ___TMGI_iE_Extensions__item__id._const_tab_id = u'id'
    ___TMGI_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TMGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__criticality._const_tab = ____TMGI_iE_Extensions__item__criticality_tab
    ___TMGI_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TMGI_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TMGI_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TMGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__extensionValue._const_tab = ____TMGI_iE_Extensions__item__extensionValue_tab
    ___TMGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TMGI_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TMGI_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TMGI_iE_Extensions__item__id),
        (u'criticality', ___TMGI_iE_Extensions__item__criticality),
        (u'extensionValue', ___TMGI_iE_Extensions__item__extensionValue),
        ])
    __TMGI_iE_Extensions__item_._ext = None
    _TMGI_iE_Extensions._cont = __TMGI_iE_Extensions__item_
    _TMGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TMGI._cont = ASN1Dict([
        (u'plmn-id', _TMGI_plmn_id),
        (u'service-id', _TMGI_service_id),
        (u'iE-Extensions', _TMGI_iE_Extensions),
        ])
    TMGI._ext = []
    
    #-----< TMGI-ExtIEs >-----#
    TMGI_ExtIEs = CLASS(name=u'TMGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TMGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TnlQos >-----#
    TnlQos = CHOICE(name=u'TnlQos', mode=MODE_TYPE)
    _TnlQos_dsField = BIT_STR(name=u'dsField', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DsField')))
    _TnlQos_genericTrafficCategory = BIT_STR(name=u'genericTrafficCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GenericTrafficCategory')))
    TnlQos._cont = ASN1Dict([
        (u'dsField', _TnlQos_dsField),
        (u'genericTrafficCategory', _TnlQos_genericTrafficCategory),
        ])
    TnlQos._ext = []
    
    #-----< ToAWE >-----#
    ToAWE = INT(name=u'ToAWE', mode=MODE_TYPE)
    ToAWE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2559)], ev=None, er=[])
    
    #-----< ToAWS >-----#
    ToAWS = INT(name=u'ToAWS', mode=MODE_TYPE)
    ToAWS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1279)], ev=None, er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = INT(name=u'TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name=u'TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< TrafficClass >-----#
    TrafficClass = ENUM(name=u'TrafficClass', mode=MODE_TYPE)
    TrafficClass._cont = ASN1Dict([(u'conversational', 0), (u'streaming', 1), (u'interactive', 2), (u'background', 3)])
    TrafficClass._ext = []
    
    #-----< Transmission-Gap-Pattern-Sequence-Information >-----#
    Transmission_Gap_Pattern_Sequence_Information = SEQ_OF(name=u'Transmission-Gap-Pattern-Sequence-Information', mode=MODE_TYPE)
    _Transmission_Gap_Pattern_Sequence_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID = INT(name=u'tGPSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TGPSID')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGSN = INT(name=u'tGSN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TGSN')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGL1 = INT(name=u'tGL1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GapLength')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGL2 = INT(name=u'tGL2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GapLength')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__tGD = INT(name=u'tGD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TGD')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1 = INT(name=u'tGPL1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GapDuration')))
    __Transmission_Gap_Pattern_Sequence_Information__item__not_to_be_used_1 = INT(name=u'not-to-be-used-1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GapDuration')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__uL_DL_mode = ENUM(name=u'uL-DL-mode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-DL-mode')))
    __Transmission_Gap_Pattern_Sequence_Information__item__downlink_Compressed_Mode_Method = ENUM(name=u'downlink-Compressed-Mode-Method', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-Compressed-Mode-Method')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method = ENUM(name=u'uplink-Compressed-Mode-Method', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Uplink-Compressed-Mode-Method')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__dL_FrameType = ENUM(name=u'dL-FrameType', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-FrameType')))
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR1 = INT(name=u'delta-SIR1', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DeltaSIR')))
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after1 = INT(name=u'delta-SIR-after1', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DeltaSIR')))
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR2 = INT(name=u'delta-SIR2', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DeltaSIR')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after2 = INT(name=u'delta-SIR-after2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DeltaSIR')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab_at = None
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id),
        (u'criticality', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue),
        ])
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_._ext = None
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions._cont = ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transmission_Gap_Pattern_Sequence_Information__item_._cont = ASN1Dict([
        (u'tGPSID', __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID),
        (u'tGSN', __Transmission_Gap_Pattern_Sequence_Information__item__tGSN),
        (u'tGL1', __Transmission_Gap_Pattern_Sequence_Information__item__tGL1),
        (u'tGL2', __Transmission_Gap_Pattern_Sequence_Information__item__tGL2),
        (u'tGD', __Transmission_Gap_Pattern_Sequence_Information__item__tGD),
        (u'tGPL1', __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1),
        (u'not-to-be-used-1', __Transmission_Gap_Pattern_Sequence_Information__item__not_to_be_used_1),
        (u'uL-DL-mode', __Transmission_Gap_Pattern_Sequence_Information__item__uL_DL_mode),
        (u'downlink-Compressed-Mode-Method', __Transmission_Gap_Pattern_Sequence_Information__item__downlink_Compressed_Mode_Method),
        (u'uplink-Compressed-Mode-Method', __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method),
        (u'dL-FrameType', __Transmission_Gap_Pattern_Sequence_Information__item__dL_FrameType),
        (u'delta-SIR1', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR1),
        (u'delta-SIR-after1', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after1),
        (u'delta-SIR2', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR2),
        (u'delta-SIR-after2', __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after2),
        (u'iE-Extensions', __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions),
        ])
    _Transmission_Gap_Pattern_Sequence_Information__item_._ext = []
    Transmission_Gap_Pattern_Sequence_Information._cont = _Transmission_Gap_Pattern_Sequence_Information__item_
    Transmission_Gap_Pattern_Sequence_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Information-ExtIEs >-----#
    Transmission_Gap_Pattern_Sequence_Information_ExtIEs = CLASS(name=u'Transmission-Gap-Pattern-Sequence-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Transmission_Gap_Pattern_Sequence_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-ScramblingCode-Information >-----#
    Transmission_Gap_Pattern_Sequence_ScramblingCode_Information = ENUM(name=u'Transmission-Gap-Pattern-Sequence-ScramblingCode-Information', mode=MODE_TYPE)
    Transmission_Gap_Pattern_Sequence_ScramblingCode_Information._cont = ASN1Dict([(u'code-change', 0), (u'nocode-change', 1)])
    Transmission_Gap_Pattern_Sequence_ScramblingCode_Information._ext = None
    
    #-----< Transmission-Gap-Pattern-Sequence-Status-List >-----#
    Transmission_Gap_Pattern_Sequence_Status_List = SEQ_OF(name=u'Transmission-Gap-Pattern-Sequence-Status-List', mode=MODE_TYPE)
    _Transmission_Gap_Pattern_Sequence_Status_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID = INT(name=u'tGPSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TGPSID')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC = INT(name=u'tGPRC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TGPRC')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN = INT(name=u'tGCFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Affected-HSDSCH-Serving-Cell-List')))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 905), (u'criticality', u'reject'), (u'Extension', ______Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab_at = None
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id),
        (u'criticality', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue),
        ])
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_._ext = None
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions._cont = ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transmission_Gap_Pattern_Sequence_Status_List__item_._cont = ASN1Dict([
        (u'tGPSID', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID),
        (u'tGPRC', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC),
        (u'tGCFN', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN),
        (u'iE-Extensions', __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions),
        ])
    _Transmission_Gap_Pattern_Sequence_Status_List__item_._ext = []
    Transmission_Gap_Pattern_Sequence_Status_List._cont = _Transmission_Gap_Pattern_Sequence_Status_List__item_
    Transmission_Gap_Pattern_Sequence_Status_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs >-----#
    Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs = CLASS(name=u'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Affected-HSDSCH-Serving-Cell-List')))
    Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 905), (u'criticality', u'reject'), (u'Extension', _Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Affected-HSDSCH-Serving-Cell-List >-----#
    Affected_HSDSCH_Serving_Cell_List = SEQ_OF(name=u'Affected-HSDSCH-Serving-Cell-List', mode=MODE_TYPE)
    _Affected_HSDSCH_Serving_Cell_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    Affected_HSDSCH_Serving_Cell_List._cont = _Affected_HSDSCH_Serving_Cell_List__item_
    Affected_HSDSCH_Serving_Cell_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=33)], ev=None, er=[])
    
    #-----< TransmissionMode >-----#
    TransmissionMode = ENUM(name=u'TransmissionMode', mode=MODE_TYPE)
    TransmissionMode._cont = ASN1Dict([(u'p-t-p', 0), (u'p-t-m', 1), (u'not-provided', 2)])
    TransmissionMode._ext = []
    
    #-----< Transmission-Mode-Information >-----#
    Transmission_Mode_Information = SEQ_OF(name=u'Transmission-Mode-Information', mode=MODE_TYPE)
    _Transmission_Mode_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Mode-Information-List')))
    Transmission_Mode_Information._cont = _Transmission_Mode_Information__item_
    Transmission_Mode_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=[], er=[])
    
    #-----< Transmission-Mode-Information-List >-----#
    Transmission_Mode_Information_List = SEQ(name=u'Transmission-Mode-Information-List', mode=MODE_TYPE)
    _Transmission_Mode_Information_List_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Transmission_Mode_Information_List_transmissionMode = ENUM(name=u'transmissionMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionMode')))
    _Transmission_Mode_Information_List_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Transmission_Mode_Information_List_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Transmission_Mode_Information_List_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Transmission_Mode_Information_List_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Transmission_Mode_Information_List_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Mode_Information_List_iE_Extensions__item__id._const_tab = ____Transmission_Mode_Information_List_iE_Extensions__item__id_tab
    ___Transmission_Mode_Information_List_iE_Extensions__item__id._const_tab_at = None
    ___Transmission_Mode_Information_List_iE_Extensions__item__id._const_tab_id = u'id'
    ___Transmission_Mode_Information_List_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Transmission_Mode_Information_List_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Transmission_Mode_Information_List_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Mode_Information_List_iE_Extensions__item__criticality._const_tab = ____Transmission_Mode_Information_List_iE_Extensions__item__criticality_tab
    ___Transmission_Mode_Information_List_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Transmission_Mode_Information_List_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Transmission_Mode_Information_List_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Transmission_Mode_Information_List_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Transmission_Mode_Information_List_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Transmission_Mode_Information_List_iE_Extensions__item__extensionValue._const_tab = ____Transmission_Mode_Information_List_iE_Extensions__item__extensionValue_tab
    ___Transmission_Mode_Information_List_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Transmission_Mode_Information_List_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Transmission_Mode_Information_List_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Transmission_Mode_Information_List_iE_Extensions__item__id),
        (u'criticality', ___Transmission_Mode_Information_List_iE_Extensions__item__criticality),
        (u'extensionValue', ___Transmission_Mode_Information_List_iE_Extensions__item__extensionValue),
        ])
    __Transmission_Mode_Information_List_iE_Extensions__item_._ext = None
    _Transmission_Mode_Information_List_iE_Extensions._cont = __Transmission_Mode_Information_List_iE_Extensions__item_
    _Transmission_Mode_Information_List_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Transmission_Mode_Information_List._cont = ASN1Dict([
        (u'c-ID', _Transmission_Mode_Information_List_c_ID),
        (u'transmissionMode', _Transmission_Mode_Information_List_transmissionMode),
        (u'iE-Extensions', _Transmission_Mode_Information_List_iE_Extensions),
        ])
    Transmission_Mode_Information_List._ext = []
    
    #-----< Transmission-Mode-Information-List-ExtIEs >-----#
    Transmission_Mode_Information_List_ExtIEs = CLASS(name=u'Transmission-Mode-Information-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Transmission_Mode_Information_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionTimeIntervalDynamic >-----#
    TransmissionTimeIntervalDynamic = ENUM(name=u'TransmissionTimeIntervalDynamic', mode=MODE_TYPE)
    TransmissionTimeIntervalDynamic._cont = ASN1Dict([(u'msec-10', 0), (u'msec-20', 1), (u'msec-40', 2), (u'msec-80', 3)])
    TransmissionTimeIntervalDynamic._ext = []
    
    #-----< TransmissionTimeIntervalSemiStatic >-----#
    TransmissionTimeIntervalSemiStatic = ENUM(name=u'TransmissionTimeIntervalSemiStatic', mode=MODE_TYPE)
    TransmissionTimeIntervalSemiStatic._cont = ASN1Dict([(u'msec-10', 0), (u'msec-20', 1), (u'msec-40', 2), (u'msec-80', 3), (u'dynamic', 4)])
    TransmissionTimeIntervalSemiStatic._ext = []
    
    #-----< TransmitDiversityIndicator >-----#
    TransmitDiversityIndicator = ENUM(name=u'TransmitDiversityIndicator', mode=MODE_TYPE)
    TransmitDiversityIndicator._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    TransmitDiversityIndicator._ext = None
    
    #-----< Transmitted-Carrier-Power-Value >-----#
    Transmitted_Carrier_Power_Value = INT(name=u'Transmitted-Carrier-Power-Value', mode=MODE_TYPE)
    Transmitted_Carrier_Power_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Transmitted-Carrier-Power-Value-IncrDecrThres >-----#
    Transmitted_Carrier_Power_Value_IncrDecrThres = INT(name=u'Transmitted-Carrier-Power-Value-IncrDecrThres', mode=MODE_TYPE)
    Transmitted_Carrier_Power_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< Transport-Block-Size-Index >-----#
    Transport_Block_Size_Index = INT(name=u'Transport-Block-Size-Index', mode=MODE_TYPE)
    Transport_Block_Size_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=90)], ev=None, er=[])
    
    #-----< TUTRANGANSS >-----#
    TUTRANGANSS = SEQ(name=u'TUTRANGANSS', mode=MODE_TYPE)
    _TUTRANGANSS_mS = INT(name=u'mS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSS_mS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _TUTRANGANSS_lS = INT(name=u'lS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSS_lS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    TUTRANGANSS._cont = ASN1Dict([
        (u'mS', _TUTRANGANSS_mS),
        (u'lS', _TUTRANGANSS_lS),
        ])
    TUTRANGANSS._ext = None
    
    #-----< TUTRANGANSSAccuracyClass >-----#
    TUTRANGANSSAccuracyClass = ENUM(name=u'TUTRANGANSSAccuracyClass', mode=MODE_TYPE)
    TUTRANGANSSAccuracyClass._cont = ASN1Dict([(u'ganssAccuracy-class-A', 0), (u'ganssAccuracy-class-B', 1), (u'ganssAccuracy-class-C', 2)])
    TUTRANGANSSAccuracyClass._ext = []
    
    #-----< TUTRANGANSSMeasurementThresholdInformation >-----#
    TUTRANGANSSMeasurementThresholdInformation = SEQ(name=u'TUTRANGANSSMeasurementThresholdInformation', mode=MODE_TYPE)
    _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit = INT(name=u'tUTRANGANSSChangeLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit = INT(name=u'predictedTUTRANGANSSDeviationLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id._const_tab = ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id._const_tab_at = None
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id._const_tab_id = u'id'
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality._const_tab = ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue._const_tab = ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id),
        (u'criticality', ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality),
        (u'extensionValue', ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue),
        ])
    __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_._ext = None
    _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions._cont = __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_
    _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGANSSMeasurementThresholdInformation._cont = ASN1Dict([
        (u'tUTRANGANSSChangeLimit', _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit),
        (u'predictedTUTRANGANSSDeviationLimit', _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit),
        (u'ie-Extensions', _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions),
        ])
    TUTRANGANSSMeasurementThresholdInformation._ext = []
    
    #-----< TUTRANGANSSMeasurementThresholdInformation-ExtIEs >-----#
    TUTRANGANSSMeasurementThresholdInformation_ExtIEs = CLASS(name=u'TUTRANGANSSMeasurementThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TUTRANGANSSMeasurementThresholdInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGANSSMeasurementValueInformation >-----#
    TUTRANGANSSMeasurementValueInformation = SEQ(name=u'TUTRANGANSSMeasurementValueInformation', mode=MODE_TYPE)
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSS = SEQ(name=u'tUTRANGANSS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGANSS')))
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality = INT(name=u'tUTRANGANSSQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate = INT(name=u'tUTRANGANSSDriftRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=50)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality = INT(name=u'tUTRANGANSSDriftRateQuality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=50)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInformation_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Time-ID')))
    ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 773), (u'criticality', u'ignore'), (u'Extension', _____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id._const_tab = ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id._const_tab_at = None
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id._const_tab_id = u'id'
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality._const_tab = ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue._const_tab = ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id),
        (u'criticality', ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality),
        (u'extensionValue', ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue),
        ])
    __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_._ext = None
    _TUTRANGANSSMeasurementValueInformation_ie_Extensions._cont = __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_
    _TUTRANGANSSMeasurementValueInformation_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGANSSMeasurementValueInformation._cont = ASN1Dict([
        (u'tUTRANGANSS', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSS),
        (u'tUTRANGANSSQuality', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality),
        (u'tUTRANGANSSDriftRate', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate),
        (u'tUTRANGANSSDriftRateQuality', _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality),
        (u'ie-Extensions', _TUTRANGANSSMeasurementValueInformation_ie_Extensions),
        ])
    TUTRANGANSSMeasurementValueInformation._ext = []
    
    #-----< TUTRANGANSSMeasurementValueInformation-ExtIEs >-----#
    TUTRANGANSSMeasurementValueInformation_ExtIEs = CLASS(name=u'TUTRANGANSSMeasurementValueInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TUTRANGANSSMeasurementValueInformation_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Time-ID')))
    TUTRANGANSSMeasurementValueInformation_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 773), (u'criticality', u'ignore'), (u'Extension', _TUTRANGANSSMeasurementValueInformation_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TUTRANGPS >-----#
    TUTRANGPS = SEQ(name=u'TUTRANGPS', mode=MODE_TYPE)
    _TUTRANGPS_ms_part = INT(name=u'ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGPS_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _TUTRANGPS_ls_part = INT(name=u'ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGPS_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    TUTRANGPS._cont = ASN1Dict([
        (u'ms-part', _TUTRANGPS_ms_part),
        (u'ls-part', _TUTRANGPS_ls_part),
        ])
    TUTRANGPS._ext = None
    
    #-----< TUTRANGPSChangeLimit >-----#
    TUTRANGPSChangeLimit = INT(name=u'TUTRANGPSChangeLimit', mode=MODE_TYPE)
    TUTRANGPSChangeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TUTRANGPSDriftRate >-----#
    TUTRANGPSDriftRate = INT(name=u'TUTRANGPSDriftRate', mode=MODE_TYPE)
    TUTRANGPSDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=50)], ev=None, er=[])
    
    #-----< TUTRANGPSDriftRateQuality >-----#
    TUTRANGPSDriftRateQuality = INT(name=u'TUTRANGPSDriftRateQuality', mode=MODE_TYPE)
    TUTRANGPSDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=50)], ev=None, er=[])
    
    #-----< TUTRANGPSAccuracyClass >-----#
    TUTRANGPSAccuracyClass = ENUM(name=u'TUTRANGPSAccuracyClass', mode=MODE_TYPE)
    TUTRANGPSAccuracyClass._cont = ASN1Dict([(u'accuracy-class-A', 0), (u'accuracy-class-B', 1), (u'accuracy-class-C', 2)])
    TUTRANGPSAccuracyClass._ext = []
    
    #-----< TUTRANGPSMeasurementThresholdInformation >-----#
    TUTRANGPSMeasurementThresholdInformation = SEQ(name=u'TUTRANGPSMeasurementThresholdInformation', mode=MODE_TYPE)
    _TUTRANGPSMeasurementThresholdInformation_tUTRANGPSChangeLimit = INT(name=u'tUTRANGPSChangeLimit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSChangeLimit')), opt=True)
    _TUTRANGPSMeasurementThresholdInformation_predictedTUTRANGPSDeviationLimit = INT(name=u'predictedTUTRANGPSDeviationLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PredictedTUTRANGPSDeviationLimit')), opt=True)
    _TUTRANGPSMeasurementThresholdInformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id._const_tab = ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_at = None
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab = ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab = ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id),
        (u'criticality', ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue),
        ])
    __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_._ext = None
    _TUTRANGPSMeasurementThresholdInformation_iE_Extensions._cont = __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_
    _TUTRANGPSMeasurementThresholdInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGPSMeasurementThresholdInformation._cont = ASN1Dict([
        (u'tUTRANGPSChangeLimit', _TUTRANGPSMeasurementThresholdInformation_tUTRANGPSChangeLimit),
        (u'predictedTUTRANGPSDeviationLimit', _TUTRANGPSMeasurementThresholdInformation_predictedTUTRANGPSDeviationLimit),
        (u'iE-Extensions', _TUTRANGPSMeasurementThresholdInformation_iE_Extensions),
        ])
    TUTRANGPSMeasurementThresholdInformation._ext = []
    
    #-----< TUTRANGPSMeasurementThresholdInformation-ExtIEs >-----#
    TUTRANGPSMeasurementThresholdInformation_ExtIEs = CLASS(name=u'TUTRANGPSMeasurementThresholdInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TUTRANGPSMeasurementThresholdInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGPSMeasurementValueInformation >-----#
    TUTRANGPSMeasurementValueInformation = SEQ(name=u'TUTRANGPSMeasurementValueInformation', mode=MODE_TYPE)
    _TUTRANGPSMeasurementValueInformation_tUTRANGPS = SEQ(name=u'tUTRANGPS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPS')))
    _TUTRANGPSMeasurementValueInformation_tUTRANGPSQuality = INT(name=u'tUTRANGPSQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSQuality')), opt=True)
    _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRate = INT(name=u'tUTRANGPSDriftRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSDriftRate')))
    _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRateQuality = INT(name=u'tUTRANGPSDriftRateQuality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TUTRANGPSDriftRateQuality')), opt=True)
    _TUTRANGPSMeasurementValueInformation_iEe_Extensions = SEQ_OF(name=u'iEe-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGPSMeasurementValueInformation_iEe_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id._const_tab = ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id_tab
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id._const_tab_at = None
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id._const_tab_id = u'id'
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality._const_tab = ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality_tab
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue._const_tab = ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue_tab
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TUTRANGPSMeasurementValueInformation_iEe_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id),
        (u'criticality', ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality),
        (u'extensionValue', ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue),
        ])
    __TUTRANGPSMeasurementValueInformation_iEe_Extensions__item_._ext = None
    _TUTRANGPSMeasurementValueInformation_iEe_Extensions._cont = __TUTRANGPSMeasurementValueInformation_iEe_Extensions__item_
    _TUTRANGPSMeasurementValueInformation_iEe_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGPSMeasurementValueInformation._cont = ASN1Dict([
        (u'tUTRANGPS', _TUTRANGPSMeasurementValueInformation_tUTRANGPS),
        (u'tUTRANGPSQuality', _TUTRANGPSMeasurementValueInformation_tUTRANGPSQuality),
        (u'tUTRANGPSDriftRate', _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRate),
        (u'tUTRANGPSDriftRateQuality', _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRateQuality),
        (u'iEe-Extensions', _TUTRANGPSMeasurementValueInformation_iEe_Extensions),
        ])
    TUTRANGPSMeasurementValueInformation._ext = []
    
    #-----< TUTRANGPSMeasurementValueInformationItem-ExtIEs >-----#
    TUTRANGPSMeasurementValueInformationItem_ExtIEs = CLASS(name=u'TUTRANGPSMeasurementValueInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TUTRANGPSMeasurementValueInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGPSQuality >-----#
    TUTRANGPSQuality = INT(name=u'TUTRANGPSQuality', mode=MODE_TYPE)
    TUTRANGPSQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TransportBearerID >-----#
    TransportBearerID = INT(name=u'TransportBearerID', mode=MODE_TYPE)
    TransportBearerID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< TransportBearerRequestIndicator >-----#
    TransportBearerRequestIndicator = ENUM(name=u'TransportBearerRequestIndicator', mode=MODE_TYPE)
    TransportBearerRequestIndicator._cont = ASN1Dict([(u'bearer-requested', 0), (u'bearer-not-requested', 1)])
    TransportBearerRequestIndicator._ext = []
    
    #-----< TransportBearerNotRequestedIndicator >-----#
    TransportBearerNotRequestedIndicator = ENUM(name=u'TransportBearerNotRequestedIndicator', mode=MODE_TYPE)
    TransportBearerNotRequestedIndicator._cont = ASN1Dict([(u'transport-bearer-shall-not-be-established', 0), (u'transport-bearer-may-not-be-established', 1)])
    TransportBearerNotRequestedIndicator._ext = None
    
    #-----< TransportBearerNotSetupIndicator >-----#
    TransportBearerNotSetupIndicator = ENUM(name=u'TransportBearerNotSetupIndicator', mode=MODE_TYPE)
    TransportBearerNotSetupIndicator._cont = ASN1Dict([(u'transport-bearer-not-setup', 0)])
    TransportBearerNotSetupIndicator._ext = None
    
    #-----< TransportBlockSize >-----#
    TransportBlockSize = INT(name=u'TransportBlockSize', mode=MODE_TYPE)
    TransportBlockSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5000)], ev=None, er=[])
    
    #-----< TransportFormatCombination-Beta >-----#
    TransportFormatCombination_Beta = CHOICE(name=u'TransportFormatCombination-Beta', mode=MODE_TYPE)
    _TransportFormatCombination_Beta_signalledGainFactors = SEQ(name=u'signalledGainFactors', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransportFormatCombination_Beta_signalledGainFactors_betaC = INT(name=u'betaC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BetaCD')))
    __TransportFormatCombination_Beta_signalledGainFactors_betaD = INT(name=u'betaD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BetaCD')))
    __TransportFormatCombination_Beta_signalledGainFactors_refTFCNumber = INT(name=u'refTFCNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RefTFCNumber')), opt=True)
    __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id._const_tab = _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id._const_tab_at = None
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id._const_tab_id = u'id'
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality._const_tab = _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue._const_tab = _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id),
        (u'criticality', ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality),
        (u'extensionValue', ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue),
        ])
    ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_._ext = None
    __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions._cont = ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_
    __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransportFormatCombination_Beta_signalledGainFactors._cont = ASN1Dict([
        (u'betaC', __TransportFormatCombination_Beta_signalledGainFactors_betaC),
        (u'betaD', __TransportFormatCombination_Beta_signalledGainFactors_betaD),
        (u'refTFCNumber', __TransportFormatCombination_Beta_signalledGainFactors_refTFCNumber),
        (u'iE-Extensions', __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions),
        ])
    _TransportFormatCombination_Beta_signalledGainFactors._ext = []
    _TransportFormatCombination_Beta_refTFCNumber = INT(name=u'refTFCNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RefTFCNumber')))
    TransportFormatCombination_Beta._cont = ASN1Dict([
        (u'signalledGainFactors', _TransportFormatCombination_Beta_signalledGainFactors),
        (u'refTFCNumber', _TransportFormatCombination_Beta_refTFCNumber),
        ])
    TransportFormatCombination_Beta._ext = []
    
    #-----< SignalledGainFactors-ExtIEs >-----#
    SignalledGainFactors_ExtIEs = CLASS(name=u'SignalledGainFactors-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SignalledGainFactors_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TFCS >-----#
    TFCS = SEQ(name=u'TFCS', mode=MODE_TYPE)
    _TFCS_tFCSvalues = CHOICE(name=u'tFCSvalues', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TFCS_tFCSvalues_no_Split_in_TFCI = SEQ_OF(name=u'no-Split-in-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS-TFCSList')))
    __TFCS_tFCSvalues_not_Used_split_in_TFCI = NULL(name=u'not-Used-split-in-TFCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_tFCSvalues._cont = ASN1Dict([
        (u'no-Split-in-TFCI', __TFCS_tFCSvalues_no_Split_in_TFCI),
        (u'not-Used-split-in-TFCI', __TFCS_tFCSvalues_not_Used_split_in_TFCI),
        ])
    _TFCS_tFCSvalues._ext = []
    _TFCS_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TFCS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TFCS_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TFCS_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TFCS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCS_iE_Extensions__item__id._const_tab = ____TFCS_iE_Extensions__item__id_tab
    ___TFCS_iE_Extensions__item__id._const_tab_at = None
    ___TFCS_iE_Extensions__item__id._const_tab_id = u'id'
    ___TFCS_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TFCS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TFCS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCS_iE_Extensions__item__criticality._const_tab = ____TFCS_iE_Extensions__item__criticality_tab
    ___TFCS_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TFCS_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TFCS_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TFCS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TFCS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TFCS_iE_Extensions__item__extensionValue._const_tab = ____TFCS_iE_Extensions__item__extensionValue_tab
    ___TFCS_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TFCS_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TFCS_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TFCS_iE_Extensions__item__id),
        (u'criticality', ___TFCS_iE_Extensions__item__criticality),
        (u'extensionValue', ___TFCS_iE_Extensions__item__extensionValue),
        ])
    __TFCS_iE_Extensions__item_._ext = None
    _TFCS_iE_Extensions._cont = __TFCS_iE_Extensions__item_
    _TFCS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TFCS._cont = ASN1Dict([
        (u'tFCSvalues', _TFCS_tFCSvalues),
        (u'iE-Extensions', _TFCS_iE_Extensions),
        ])
    TFCS._ext = []
    
    #-----< TFCS-ExtIEs >-----#
    TFCS_ExtIEs = CLASS(name=u'TFCS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TFCS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TFCS-TFCSList >-----#
    TFCS_TFCSList = SEQ_OF(name=u'TFCS-TFCSList', mode=MODE_TYPE)
    _TFCS_TFCSList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TFCS_TFCSList__item__cTFC = CHOICE(name=u'cTFC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS-CTFC')))
    __TFCS_TFCSList__item__tFC_Beta = CHOICE(name=u'tFC-Beta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatCombination-Beta')), opt=True)
    __TFCS_TFCSList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TFCS_TFCSList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____TFCS_TFCSList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____TFCS_TFCSList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ______TFCS_TFCSList__item__iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Gainfactors-10ms-mode')))
    _____TFCS_TFCSList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 966), (u'criticality', u'reject'), (u'Extension', ______TFCS_TFCSList__item__iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ____TFCS_TFCSList__item__iE_Extensions__item__id._const_tab = _____TFCS_TFCSList__item__iE_Extensions__item__id_tab
    ____TFCS_TFCSList__item__iE_Extensions__item__id._const_tab_at = None
    ____TFCS_TFCSList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality._const_tab = _____TFCS_TFCSList__item__iE_Extensions__item__id_tab
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____TFCS_TFCSList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue._const_tab = _____TFCS_TFCSList__item__iE_Extensions__item__id_tab
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___TFCS_TFCSList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____TFCS_TFCSList__item__iE_Extensions__item__id),
        (u'criticality', ____TFCS_TFCSList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue),
        ])
    ___TFCS_TFCSList__item__iE_Extensions__item_._ext = None
    __TFCS_TFCSList__item__iE_Extensions._cont = ___TFCS_TFCSList__item__iE_Extensions__item_
    __TFCS_TFCSList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TFCS_TFCSList__item_._cont = ASN1Dict([
        (u'cTFC', __TFCS_TFCSList__item__cTFC),
        (u'tFC-Beta', __TFCS_TFCSList__item__tFC_Beta),
        (u'iE-Extensions', __TFCS_TFCSList__item__iE_Extensions),
        ])
    _TFCS_TFCSList__item_._ext = []
    TFCS_TFCSList._cont = _TFCS_TFCSList__item_
    TFCS_TFCSList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< TFCS-TFCSList-ExtIEs >-----#
    TFCS_TFCSList_ExtIEs = CLASS(name=u'TFCS-TFCSList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TFCS_TFCSList_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Gainfactors-10ms-mode')))
    TFCS_TFCSList_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 966), (u'criticality', u'reject'), (u'Extension', _TFCS_TFCSList_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< TFCS-CTFC >-----#
    TFCS_CTFC = CHOICE(name=u'TFCS-CTFC', mode=MODE_TYPE)
    _TFCS_CTFC_ctfc2bit = INT(name=u'ctfc2bit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc2bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _TFCS_CTFC_ctfc4bit = INT(name=u'ctfc4bit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc4bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _TFCS_CTFC_ctfc6bit = INT(name=u'ctfc6bit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc6bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _TFCS_CTFC_ctfc8bit = INT(name=u'ctfc8bit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc8bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TFCS_CTFC_ctfc12bit = INT(name=u'ctfc12bit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc12bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _TFCS_CTFC_ctfc16bit = INT(name=u'ctfc16bit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfc16bit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _TFCS_CTFC_ctfcmaxbit = INT(name=u'ctfcmaxbit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TFCS_CTFC_ctfcmaxbit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    TFCS_CTFC._cont = ASN1Dict([
        (u'ctfc2bit', _TFCS_CTFC_ctfc2bit),
        (u'ctfc4bit', _TFCS_CTFC_ctfc4bit),
        (u'ctfc6bit', _TFCS_CTFC_ctfc6bit),
        (u'ctfc8bit', _TFCS_CTFC_ctfc8bit),
        (u'ctfc12bit', _TFCS_CTFC_ctfc12bit),
        (u'ctfc16bit', _TFCS_CTFC_ctfc16bit),
        (u'ctfcmaxbit', _TFCS_CTFC_ctfcmaxbit),
        ])
    TFCS_CTFC._ext = None
    
    #-----< TPC-slot-position >-----#
    TPC_slot_position = SEQ(name=u'TPC-slot-position', mode=MODE_TYPE)
    _TPC_slot_position_slot_position = INT(name=u'slot-position', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TPC_slot_position_slot_position._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    _TPC_slot_position_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TPC_slot_position_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TPC_slot_position_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TPC_slot_position_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TPC_slot_position_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TPC_slot_position_iE_Extensions__item__id._const_tab = ____TPC_slot_position_iE_Extensions__item__id_tab
    ___TPC_slot_position_iE_Extensions__item__id._const_tab_at = None
    ___TPC_slot_position_iE_Extensions__item__id._const_tab_id = u'id'
    ___TPC_slot_position_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TPC_slot_position_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TPC_slot_position_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TPC_slot_position_iE_Extensions__item__criticality._const_tab = ____TPC_slot_position_iE_Extensions__item__criticality_tab
    ___TPC_slot_position_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TPC_slot_position_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TPC_slot_position_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TPC_slot_position_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TPC_slot_position_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TPC_slot_position_iE_Extensions__item__extensionValue._const_tab = ____TPC_slot_position_iE_Extensions__item__extensionValue_tab
    ___TPC_slot_position_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TPC_slot_position_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TPC_slot_position_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TPC_slot_position_iE_Extensions__item__id),
        (u'criticality', ___TPC_slot_position_iE_Extensions__item__criticality),
        (u'extensionValue', ___TPC_slot_position_iE_Extensions__item__extensionValue),
        ])
    __TPC_slot_position_iE_Extensions__item_._ext = None
    _TPC_slot_position_iE_Extensions._cont = __TPC_slot_position_iE_Extensions__item_
    _TPC_slot_position_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TPC_slot_position._cont = ASN1Dict([
        (u'slot-position', _TPC_slot_position_slot_position),
        (u'iE-Extensions', _TPC_slot_position_iE_Extensions),
        ])
    TPC_slot_position._ext = []
    
    #-----< TPC-slot-position-ExtIEs >-----#
    TPC_slot_position_ExtIEs = CLASS(name=u'TPC-slot-position-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TPC_slot_position_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet >-----#
    TransportFormatSet = SEQ(name=u'TransportFormatSet', mode=MODE_TYPE)
    _TransportFormatSet_dynamicParts = SEQ_OF(name=u'dynamicParts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet-DynamicPartList')))
    _TransportFormatSet_semi_staticPart = SEQ(name=u'semi-staticPart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet-Semi-staticPart')))
    _TransportFormatSet_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportFormatSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TransportFormatSet_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TransportFormatSet_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__id._const_tab = ____TransportFormatSet_iE_Extensions__item__id_tab
    ___TransportFormatSet_iE_Extensions__item__id._const_tab_at = None
    ___TransportFormatSet_iE_Extensions__item__id._const_tab_id = u'id'
    ___TransportFormatSet_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TransportFormatSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab = ____TransportFormatSet_iE_Extensions__item__criticality_tab
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TransportFormatSet_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TransportFormatSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab = ____TransportFormatSet_iE_Extensions__item__extensionValue_tab
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TransportFormatSet_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TransportFormatSet_iE_Extensions__item__id),
        (u'criticality', ___TransportFormatSet_iE_Extensions__item__criticality),
        (u'extensionValue', ___TransportFormatSet_iE_Extensions__item__extensionValue),
        ])
    __TransportFormatSet_iE_Extensions__item_._ext = None
    _TransportFormatSet_iE_Extensions._cont = __TransportFormatSet_iE_Extensions__item_
    _TransportFormatSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportFormatSet._cont = ASN1Dict([
        (u'dynamicParts', _TransportFormatSet_dynamicParts),
        (u'semi-staticPart', _TransportFormatSet_semi_staticPart),
        (u'iE-Extensions', _TransportFormatSet_iE_Extensions),
        ])
    TransportFormatSet._ext = []
    
    #-----< TransportFormatSet-ExtIEs >-----#
    TransportFormatSet_ExtIEs = CLASS(name=u'TransportFormatSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-DynamicPartList >-----#
    TransportFormatSet_DynamicPartList = SEQ_OF(name=u'TransportFormatSet-DynamicPartList', mode=MODE_TYPE)
    _TransportFormatSet_DynamicPartList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TransportFormatSet_DynamicPartList__item__nrOfTransportBlocks = INT(name=u'nrOfTransportBlocks', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NrOfTransportBlocks')))
    __TransportFormatSet_DynamicPartList__item__transportBlockSize = INT(name=u'transportBlockSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBlockSize')), opt=True)
    __TransportFormatSet_DynamicPartList__item__mode = CHOICE(name=u'mode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet-ModeDP')))
    __TransportFormatSet_DynamicPartList__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab_at = None
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id),
        (u'criticality', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue),
        ])
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_._ext = None
    __TransportFormatSet_DynamicPartList__item__iE_Extensions._cont = ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_
    __TransportFormatSet_DynamicPartList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransportFormatSet_DynamicPartList__item_._cont = ASN1Dict([
        (u'nrOfTransportBlocks', __TransportFormatSet_DynamicPartList__item__nrOfTransportBlocks),
        (u'transportBlockSize', __TransportFormatSet_DynamicPartList__item__transportBlockSize),
        (u'mode', __TransportFormatSet_DynamicPartList__item__mode),
        (u'iE-Extensions', __TransportFormatSet_DynamicPartList__item__iE_Extensions),
        ])
    _TransportFormatSet_DynamicPartList__item_._ext = []
    TransportFormatSet_DynamicPartList._cont = _TransportFormatSet_DynamicPartList__item_
    TransportFormatSet_DynamicPartList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TransportFormatSet-DynamicPartList-ExtIEs >-----#
    TransportFormatSet_DynamicPartList_ExtIEs = CLASS(name=u'TransportFormatSet-DynamicPartList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_DynamicPartList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-ModeDP >-----#
    TransportFormatSet_ModeDP = CHOICE(name=u'TransportFormatSet-ModeDP', mode=MODE_TYPE)
    _TransportFormatSet_ModeDP_tdd = SEQ(name=u'tdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TransportFormatSet-ModeDP')))
    _TransportFormatSet_ModeDP_notApplicable = NULL(name=u'notApplicable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TransportFormatSet_ModeDP._cont = ASN1Dict([
        (u'tdd', _TransportFormatSet_ModeDP_tdd),
        (u'notApplicable', _TransportFormatSet_ModeDP_notApplicable),
        ])
    TransportFormatSet_ModeDP._ext = []
    
    #-----< TDD-TransportFormatSet-ModeDP >-----#
    TDD_TransportFormatSet_ModeDP = SEQ(name=u'TDD-TransportFormatSet-ModeDP', mode=MODE_TYPE)
    _TDD_TransportFormatSet_ModeDP_transmissionTimeIntervalInformation = SEQ_OF(name=u'transmissionTimeIntervalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionTimeIntervalInformation')), opt=True)
    _TDD_TransportFormatSet_ModeDP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id._const_tab = ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id._const_tab_at = None
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality._const_tab = ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue._const_tab = ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id),
        (u'criticality', ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue),
        ])
    __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_._ext = None
    _TDD_TransportFormatSet_ModeDP_iE_Extensions._cont = __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_
    _TDD_TransportFormatSet_ModeDP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_TransportFormatSet_ModeDP._cont = ASN1Dict([
        (u'transmissionTimeIntervalInformation', _TDD_TransportFormatSet_ModeDP_transmissionTimeIntervalInformation),
        (u'iE-Extensions', _TDD_TransportFormatSet_ModeDP_iE_Extensions),
        ])
    TDD_TransportFormatSet_ModeDP._ext = []
    
    #-----< TDD-TransportFormatSet-ModeDP-ExtIEs >-----#
    TDD_TransportFormatSet_ModeDP_ExtIEs = CLASS(name=u'TDD-TransportFormatSet-ModeDP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_TransportFormatSet_ModeDP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionTimeIntervalInformation >-----#
    TransmissionTimeIntervalInformation = SEQ_OF(name=u'TransmissionTimeIntervalInformation', mode=MODE_TYPE)
    _TransmissionTimeIntervalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TransmissionTimeIntervalInformation__item__transmissionTimeInterval = ENUM(name=u'transmissionTimeInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionTimeIntervalDynamic')))
    __TransmissionTimeIntervalInformation__item__iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id._const_tab = _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id._const_tab_at = None
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id._const_tab_id = u'id'
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality._const_tab = _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue._const_tab = _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id),
        (u'criticality', ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality),
        (u'extensionValue', ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue),
        ])
    ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_._ext = None
    __TransmissionTimeIntervalInformation__item__iE_Extensions._cont = ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_
    __TransmissionTimeIntervalInformation__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransmissionTimeIntervalInformation__item_._cont = ASN1Dict([
        (u'transmissionTimeInterval', __TransmissionTimeIntervalInformation__item__transmissionTimeInterval),
        (u'iE-Extensions', __TransmissionTimeIntervalInformation__item__iE_Extensions),
        ])
    _TransmissionTimeIntervalInformation__item_._ext = []
    TransmissionTimeIntervalInformation._cont = _TransmissionTimeIntervalInformation__item_
    TransmissionTimeIntervalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TransmissionTimeIntervalInformation-ExtIEs >-----#
    TransmissionTimeIntervalInformation_ExtIEs = CLASS(name=u'TransmissionTimeIntervalInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TransmissionTimeIntervalInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmitted-Code-Power-Value >-----#
    Transmitted_Code_Power_Value = INT(name=u'Transmitted-Code-Power-Value', mode=MODE_TYPE)
    Transmitted_Code_Power_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Transmitted-Code-Power-Value-IncrDecrThres >-----#
    Transmitted_Code_Power_Value_IncrDecrThres = INT(name=u'Transmitted-Code-Power-Value-IncrDecrThres', mode=MODE_TYPE)
    Transmitted_Code_Power_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=112)], ev=[], er=[])
    
    #-----< TransportFormatManagement >-----#
    TransportFormatManagement = ENUM(name=u'TransportFormatManagement', mode=MODE_TYPE)
    TransportFormatManagement._cont = ASN1Dict([(u'cell-based', 0), (u'ue-based', 1)])
    TransportFormatManagement._ext = []
    
    #-----< TransportFormatSet-Semi-staticPart >-----#
    TransportFormatSet_Semi_staticPart = SEQ(name=u'TransportFormatSet-Semi-staticPart', mode=MODE_TYPE)
    _TransportFormatSet_Semi_staticPart_transmissionTime = ENUM(name=u'transmissionTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmissionTimeIntervalSemiStatic')))
    _TransportFormatSet_Semi_staticPart_channelCoding = ENUM(name=u'channelCoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ChannelCodingType')))
    _TransportFormatSet_Semi_staticPart_codingRate = ENUM(name=u'codingRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CodingRate')), opt=True)
    _TransportFormatSet_Semi_staticPart_rateMatcingAttribute = INT(name=u'rateMatcingAttribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RateMatchingAttribute')))
    _TransportFormatSet_Semi_staticPart_cRC_Size = ENUM(name=u'cRC-Size', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CRC-Size')))
    _TransportFormatSet_Semi_staticPart_mode = CHOICE(name=u'mode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet-ModeSSP')))
    _TransportFormatSet_Semi_staticPart_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab_at = None
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab_id = u'id'
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id),
        (u'criticality', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality),
        (u'extensionValue', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue),
        ])
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_._ext = None
    _TransportFormatSet_Semi_staticPart_iE_Extensions._cont = __TransportFormatSet_Semi_staticPart_iE_Extensions__item_
    _TransportFormatSet_Semi_staticPart_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportFormatSet_Semi_staticPart._cont = ASN1Dict([
        (u'transmissionTime', _TransportFormatSet_Semi_staticPart_transmissionTime),
        (u'channelCoding', _TransportFormatSet_Semi_staticPart_channelCoding),
        (u'codingRate', _TransportFormatSet_Semi_staticPart_codingRate),
        (u'rateMatcingAttribute', _TransportFormatSet_Semi_staticPart_rateMatcingAttribute),
        (u'cRC-Size', _TransportFormatSet_Semi_staticPart_cRC_Size),
        (u'mode', _TransportFormatSet_Semi_staticPart_mode),
        (u'iE-Extensions', _TransportFormatSet_Semi_staticPart_iE_Extensions),
        ])
    TransportFormatSet_Semi_staticPart._ext = []
    
    #-----< TransportFormatSet-Semi-staticPart-ExtIEs >-----#
    TransportFormatSet_Semi_staticPart_ExtIEs = CLASS(name=u'TransportFormatSet-Semi-staticPart-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_Semi_staticPart_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-ModeSSP >-----#
    TransportFormatSet_ModeSSP = CHOICE(name=u'TransportFormatSet-ModeSSP', mode=MODE_TYPE)
    _TransportFormatSet_ModeSSP_tdd = ENUM(name=u'tdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SecondInterleavingMode')))
    _TransportFormatSet_ModeSSP_notApplicable = NULL(name=u'notApplicable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TransportFormatSet_ModeSSP._cont = ASN1Dict([
        (u'tdd', _TransportFormatSet_ModeSSP_tdd),
        (u'notApplicable', _TransportFormatSet_ModeSSP_notApplicable),
        ])
    TransportFormatSet_ModeSSP._ext = []
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name=u'TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TrCH-SrcStatisticsDescr >-----#
    TrCH_SrcStatisticsDescr = ENUM(name=u'TrCH-SrcStatisticsDescr', mode=MODE_TYPE)
    TrCH_SrcStatisticsDescr._cont = ASN1Dict([(u'speech', 0), (u'rRC', 1), (u'unknown', 2)])
    TrCH_SrcStatisticsDescr._ext = []
    
    #-----< TSN-Length >-----#
    TSN_Length = ENUM(name=u'TSN-Length', mode=MODE_TYPE)
    TSN_Length._cont = ASN1Dict([(u'tsn-6bits', 0), (u'tsn-9bits', 1)])
    TSN_Length._ext = None
    
    #-----< TSTD-Indicator >-----#
    TSTD_Indicator = ENUM(name=u'TSTD-Indicator', mode=MODE_TYPE)
    TSTD_Indicator._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    TSTD_Indicator._ext = None
    
    #-----< TSTD-Support-Indicator >-----#
    TSTD_Support_Indicator = ENUM(name=u'TSTD-Support-Indicator', mode=MODE_TYPE)
    TSTD_Support_Indicator._cont = ASN1Dict([(u'tSTD-supported', 0), (u'tSTD-not-supported', 1)])
    TSTD_Support_Indicator._ext = None
    
    #-----< TTI-Update-Indicator >-----#
    TTI_Update_Indicator = CHOICE(name=u'TTI-Update-Indicator', mode=MODE_TYPE)
    _TTI_Update_Indicator_tTI_Update_CFN = INT(name=u'tTI-Update-CFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _TTI_Update_Indicator_tTI_Update_Ind = NULL(name=u'tTI-Update-Ind', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TTI-Update-Ind')))
    TTI_Update_Indicator._cont = ASN1Dict([
        (u'tTI-Update-CFN', _TTI_Update_Indicator_tTI_Update_CFN),
        (u'tTI-Update-Ind', _TTI_Update_Indicator_tTI_Update_Ind),
        ])
    TTI_Update_Indicator._ext = None
    
    #-----< TTI-Update-Ind >-----#
    TTI_Update_Ind = NULL(name=u'TTI-Update-Ind', mode=MODE_TYPE)
    
    #-----< TxDiversityIndicator >-----#
    TxDiversityIndicator = ENUM(name=u'TxDiversityIndicator', mode=MODE_TYPE)
    TxDiversityIndicator._cont = ASN1Dict([(u'true', 0), (u'false', 1)])
    TxDiversityIndicator._ext = None
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name=u'TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([(u'not-understood', 0), (u'missing', 1)])
    TypeOfError._ext = []
    
    #-----< UARFCN >-----#
    UARFCN = INT(name=u'UARFCN', mode=MODE_TYPE)
    UARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=[], er=[])
    
    #-----< UDRE >-----#
    UDRE = ENUM(name=u'UDRE', mode=MODE_TYPE)
    UDRE._cont = ASN1Dict([(u'lessThan1', 0), (u'between1-and-4', 1), (u'between4-and-8', 2), (u'over8', 3)])
    UDRE._ext = []
    
    #-----< UDREGrowthRate >-----#
    UDREGrowthRate = ENUM(name=u'UDREGrowthRate', mode=MODE_TYPE)
    UDREGrowthRate._cont = ASN1Dict([(u'growth-1-point-5', 0), (u'growth-2', 1), (u'growth-4', 2), (u'growth-6', 3), (u'growth-8', 4), (u'growth-10', 5), (u'growth-12', 6), (u'growth-16', 7)])
    UDREGrowthRate._ext = None
    
    #-----< UDREValidityTime >-----#
    UDREValidityTime = ENUM(name=u'UDREValidityTime', mode=MODE_TYPE)
    UDREValidityTime._cont = ASN1Dict([(u'val-20sec', 0), (u'val-40sec', 1), (u'val-80sec', 2), (u'val-160sec', 3), (u'val-320sec', 4), (u'val-640sec', 5), (u'val-1280sec', 6), (u'val-2560sec', 7)])
    UDREValidityTime._ext = None
    
    #-----< UE-AggregateMaximumBitRate >-----#
    UE_AggregateMaximumBitRate = SEQ(name=u'UE-AggregateMaximumBitRate', mode=MODE_TYPE)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink = INT(name=u'uE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRateDownlink')), opt=True)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink = INT(name=u'uE-AggregateMaximumBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRateUplink')), opt=True)
    UE_AggregateMaximumBitRate._cont = ASN1Dict([
        (u'uE-AggregateMaximumBitRateDownlink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink),
        (u'uE-AggregateMaximumBitRateUplink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink),
        ])
    UE_AggregateMaximumBitRate._ext = []
    
    #-----< UE-AggregateMaximumBitRateDownlink >-----#
    UE_AggregateMaximumBitRateDownlink = INT(name=u'UE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateDownlink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-AggregateMaximumBitRateUplink >-----#
    UE_AggregateMaximumBitRateUplink = INT(name=u'UE-AggregateMaximumBitRateUplink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateUplink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-AggregateMaximumBitRate-Enforcement-Indicator >-----#
    UE_AggregateMaximumBitRate_Enforcement_Indicator = NULL(name=u'UE-AggregateMaximumBitRate-Enforcement-Indicator', mode=MODE_TYPE)
    
    #-----< UE-Capabilities-Info >-----#
    UE_Capabilities_Info = SEQ(name=u'UE-Capabilities-Info', mode=MODE_TYPE)
    _UE_Capabilities_Info_hSDSCH_Physical_Layer_Category = INT(name=u'hSDSCH-Physical-Layer-Category', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_Capabilities_Info_hSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=[], er=[])
    _UE_Capabilities_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Capabilities_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UE_Capabilities_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_Capabilities_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LCRTDD-Uplink-Physical-Channel-Capability')))
    _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Number-Of-Supported-Carriers')))
    _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LCRTDD-HSDSCH-Physical-Layer-Category')))
    _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-TS0-CapabilityLCR')))
    _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-RF-Band-CapabilityLCR')))
    ____UE_Capabilities_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 715), (u'criticality', u'ignore'), (u'Extension', _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 716), (u'criticality', u'reject'), (u'Extension', _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 816), (u'criticality', u'ignore'), (u'Extension', _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 803), (u'criticality', u'ignore'), (u'Extension', _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 871), (u'criticality', u'ignore'), (u'Extension', _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 913), (u'criticality', u'ignore'), (u'Extension', _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___UE_Capabilities_Info_iE_Extensions__item__id._const_tab = ____UE_Capabilities_Info_iE_Extensions__item__id_tab
    ___UE_Capabilities_Info_iE_Extensions__item__id._const_tab_at = None
    ___UE_Capabilities_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_Capabilities_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_Capabilities_Info_iE_Extensions__item__criticality._const_tab = ____UE_Capabilities_Info_iE_Extensions__item__id_tab
    ___UE_Capabilities_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_Capabilities_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_Capabilities_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_Capabilities_Info_iE_Extensions__item__extensionValue._const_tab = ____UE_Capabilities_Info_iE_Extensions__item__id_tab
    ___UE_Capabilities_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_Capabilities_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_Capabilities_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_Capabilities_Info_iE_Extensions__item__id),
        (u'criticality', ___UE_Capabilities_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_Capabilities_Info_iE_Extensions__item__extensionValue),
        ])
    __UE_Capabilities_Info_iE_Extensions__item_._ext = None
    _UE_Capabilities_Info_iE_Extensions._cont = __UE_Capabilities_Info_iE_Extensions__item_
    _UE_Capabilities_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Capabilities_Info._cont = ASN1Dict([
        (u'hSDSCH-Physical-Layer-Category', _UE_Capabilities_Info_hSDSCH_Physical_Layer_Category),
        (u'iE-Extensions', _UE_Capabilities_Info_iE_Extensions),
        ])
    UE_Capabilities_Info._ext = []
    
    #-----< UE-Capabilities-Info-ExtIEs >-----#
    UE_Capabilities_Info_ExtIEs = CLASS(name=u'UE-Capabilities-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UE_Capabilities_Info_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LCRTDD-Uplink-Physical-Channel-Capability')))
    _UE_Capabilities_Info_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Number-Of-Supported-Carriers')))
    _UE_Capabilities_Info_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MIMO-SFMode-For-HSPDSCHDualStream')))
    _UE_Capabilities_Info_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LCRTDD-HSDSCH-Physical-Layer-Category')))
    _UE_Capabilities_Info_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-TS0-CapabilityLCR')))
    _UE_Capabilities_Info_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-RF-Band-CapabilityLCR')))
    UE_Capabilities_Info_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 715), (u'criticality', u'ignore'), (u'Extension', _UE_Capabilities_Info_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 716), (u'criticality', u'reject'), (u'Extension', _UE_Capabilities_Info_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 816), (u'criticality', u'ignore'), (u'Extension', _UE_Capabilities_Info_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 803), (u'criticality', u'ignore'), (u'Extension', _UE_Capabilities_Info_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 871), (u'criticality', u'ignore'), (u'Extension', _UE_Capabilities_Info_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 913), (u'criticality', u'ignore'), (u'Extension', _UE_Capabilities_Info_ExtIEs_val_Extension_5), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< UE-Support-of-non-rectangular-resource-allocation >-----#
    UE_Support_of_non_rectangular_resource_allocation = ENUM(name=u'UE-Support-of-non-rectangular-resource-allocation', mode=MODE_TYPE)
    UE_Support_of_non_rectangular_resource_allocation._cont = ASN1Dict([(u'support', 0)])
    UE_Support_of_non_rectangular_resource_allocation._ext = None
    
    #-----< UE-TS0-CapabilityLCR >-----#
    UE_TS0_CapabilityLCR = ENUM(name=u'UE-TS0-CapabilityLCR', mode=MODE_TYPE)
    UE_TS0_CapabilityLCR._cont = ASN1Dict([(u'tS0-Capable', 0), (u'tS0-Not-Capable', 1)])
    UE_TS0_CapabilityLCR._ext = None
    
    #-----< UE-RF-Band-CapabilityLCR >-----#
    UE_RF_Band_CapabilityLCR = SEQ_OF(name=u'UE-RF-Band-CapabilityLCR', mode=MODE_TYPE)
    _UE_RF_Band_CapabilityLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Frequency-BandItem')))
    UE_RF_Band_CapabilityLCR._cont = _UE_RF_Band_CapabilityLCR__item_
    UE_RF_Band_CapabilityLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Radio-Frequency-BandItem >-----#
    Radio_Frequency_BandItem = SEQ(name=u'Radio-Frequency-BandItem', mode=MODE_TYPE)
    _Radio_Frequency_BandItem_radio_Frequency_Band = ENUM(name=u'radio-Frequency-Band', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Frequency-Band')))
    _Radio_Frequency_BandItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Radio_Frequency_BandItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Radio_Frequency_BandItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Frequency_BandItem_iE_Extensions__item__id._const_tab = ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab
    ___Radio_Frequency_BandItem_iE_Extensions__item__id._const_tab_at = None
    ___Radio_Frequency_BandItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality._const_tab = ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Radio_Frequency_BandItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue._const_tab = ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Radio_Frequency_BandItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Radio_Frequency_BandItem_iE_Extensions__item__id),
        (u'criticality', ___Radio_Frequency_BandItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue),
        ])
    __Radio_Frequency_BandItem_iE_Extensions__item_._ext = None
    _Radio_Frequency_BandItem_iE_Extensions._cont = __Radio_Frequency_BandItem_iE_Extensions__item_
    _Radio_Frequency_BandItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Radio_Frequency_BandItem._cont = ASN1Dict([
        (u'radio-Frequency-Band', _Radio_Frequency_BandItem_radio_Frequency_Band),
        (u'iE-Extensions', _Radio_Frequency_BandItem_iE_Extensions),
        ])
    Radio_Frequency_BandItem._ext = []
    
    #-----< Radio-Frequency-Band >-----#
    Radio_Frequency_Band = ENUM(name=u'Radio-Frequency-Band', mode=MODE_TYPE)
    Radio_Frequency_Band._cont = ASN1Dict([(u'a', 0), (u'b', 1), (u'c', 2), (u'd', 3), (u'e', 4), (u'f', 5), (u'g', 6), (u'h', 7), (u'i', 8), (u'j', 9), (u'k', 10), (u'l', 11), (u'm', 12), (u'n', 13), (u'o', 14), (u'p', 15)])
    Radio_Frequency_Band._ext = []
    
    #-----< Radio-Frequency-BandItem-ExtIEs >-----#
    Radio_Frequency_BandItem_ExtIEs = CLASS(name=u'Radio-Frequency-BandItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Radio_Frequency_BandItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LCRTDD-HSDSCH-Physical-Layer-Category >-----#
    LCRTDD_HSDSCH_Physical_Layer_Category = INT(name=u'LCRTDD-HSDSCH-Physical-Layer-Category', mode=MODE_TYPE)
    LCRTDD_HSDSCH_Physical_Layer_Category._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< UE-DPCCH-burst1 >-----#
    UE_DPCCH_burst1 = ENUM(name=u'UE-DPCCH-burst1', mode=MODE_TYPE)
    UE_DPCCH_burst1._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v5', 2)])
    UE_DPCCH_burst1._ext = None
    
    #-----< UE-DPCCH-burst2 >-----#
    UE_DPCCH_burst2 = ENUM(name=u'UE-DPCCH-burst2', mode=MODE_TYPE)
    UE_DPCCH_burst2._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v5', 2)])
    UE_DPCCH_burst2._ext = None
    
    #-----< UE-DRX-Cycle-LCR >-----#
    UE_DRX_Cycle_LCR = ENUM(name=u'UE-DRX-Cycle-LCR', mode=MODE_TYPE)
    UE_DRX_Cycle_LCR._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v4', 2), (u'v8', 3), (u'v16', 4), (u'v32', 5), (u'v64', 6)])
    UE_DRX_Cycle_LCR._ext = []
    
    #-----< UE-DRX-Offset-LCR >-----#
    UE_DRX_Offset_LCR = INT(name=u'UE-DRX-Offset-LCR', mode=MODE_TYPE)
    UE_DRX_Offset_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< UE-DRX-Cycle >-----#
    UE_DRX_Cycle = ENUM(name=u'UE-DRX-Cycle', mode=MODE_TYPE)
    UE_DRX_Cycle._cont = ASN1Dict([(u'v4', 0), (u'v5', 1), (u'v8', 2), (u'v10', 3), (u'v16', 4), (u'v20', 5)])
    UE_DRX_Cycle._ext = None
    
    #-----< UE-DRX-Grant-Monitoring >-----#
    UE_DRX_Grant_Monitoring = BOOL(name=u'UE-DRX-Grant-Monitoring', mode=MODE_TYPE)
    
    #-----< UE-DTX-Cycle1-2ms >-----#
    UE_DTX_Cycle1_2ms = ENUM(name=u'UE-DTX-Cycle1-2ms', mode=MODE_TYPE)
    UE_DTX_Cycle1_2ms._cont = ASN1Dict([(u'v1', 0), (u'v4', 1), (u'v5', 2), (u'v8', 3), (u'v10', 4), (u'v16', 5), (u'v20', 6)])
    UE_DTX_Cycle1_2ms._ext = None
    
    #-----< UE-DTX-Cycle1-10ms >-----#
    UE_DTX_Cycle1_10ms = ENUM(name=u'UE-DTX-Cycle1-10ms', mode=MODE_TYPE)
    UE_DTX_Cycle1_10ms._cont = ASN1Dict([(u'v1', 0), (u'v5', 1), (u'v10', 2), (u'v20', 3)])
    UE_DTX_Cycle1_10ms._ext = None
    
    #-----< UE-DTX-Cycle2-2ms >-----#
    UE_DTX_Cycle2_2ms = ENUM(name=u'UE-DTX-Cycle2-2ms', mode=MODE_TYPE)
    UE_DTX_Cycle2_2ms._cont = ASN1Dict([(u'v4', 0), (u'v5', 1), (u'v8', 2), (u'v10', 3), (u'v16', 4), (u'v20', 5), (u'v32', 6), (u'v40', 7), (u'v64', 8), (u'v80', 9), (u'v128', 10), (u'v160', 11)])
    UE_DTX_Cycle2_2ms._ext = None
    
    #-----< UE-DTX-Cycle2-ext-2ms >-----#
    UE_DTX_Cycle2_ext_2ms = ENUM(name=u'UE-DTX-Cycle2-ext-2ms', mode=MODE_TYPE)
    UE_DTX_Cycle2_ext_2ms._cont = ASN1Dict([(u'v4', 0), (u'v5', 1), (u'v8', 2), (u'v10', 3), (u'v16', 4), (u'v20', 5), (u'v32', 6), (u'v40', 7), (u'v64', 8), (u'v80', 9), (u'v128', 10), (u'v160', 11), (u'v256', 12), (u'v320', 13), (u'v512', 14), (u'v640', 15), (u'v1024', 16), (u'v1280', 17)])
    UE_DTX_Cycle2_ext_2ms._ext = None
    
    #-----< UE-DTX-Cycle2-10ms >-----#
    UE_DTX_Cycle2_10ms = ENUM(name=u'UE-DTX-Cycle2-10ms', mode=MODE_TYPE)
    UE_DTX_Cycle2_10ms._cont = ASN1Dict([(u'v5', 0), (u'v10', 1), (u'v20', 2), (u'v40', 3), (u'v80', 4), (u'v160', 5)])
    UE_DTX_Cycle2_10ms._ext = None
    
    #-----< UE-DTX-DRX-Offset >-----#
    UE_DTX_DRX_Offset = INT(name=u'UE-DTX-DRX-Offset', mode=MODE_TYPE)
    UE_DTX_DRX_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=159)], ev=None, er=[])
    
    #-----< UE-DTX-Long-Preamble >-----#
    UE_DTX_Long_Preamble = ENUM(name=u'UE-DTX-Long-Preamble', mode=MODE_TYPE)
    UE_DTX_Long_Preamble._cont = ASN1Dict([(u'v2', 0), (u'v4', 1), (u'v15', 2)])
    UE_DTX_Long_Preamble._ext = None
    
    #-----< UEIdentity >-----#
    UEIdentity = CHOICE(name=u'UEIdentity', mode=MODE_TYPE)
    _UEIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IMSI')))
    _UEIdentity_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IMEI')))
    _UEIdentity_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'IMEISV')))
    UEIdentity._cont = ASN1Dict([
        (u'imsi', _UEIdentity_imsi),
        (u'imei', _UEIdentity_imei),
        (u'imeisv', _UEIdentity_imeisv),
        ])
    UEIdentity._ext = []
    
    #-----< UEMeasurementHysteresisTime >-----#
    UEMeasurementHysteresisTime = INT(name=u'UEMeasurementHysteresisTime', mode=MODE_TYPE)
    UEMeasurementHysteresisTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementParameterModAllow >-----#
    UEMeasurementParameterModAllow = ENUM(name=u'UEMeasurementParameterModAllow', mode=MODE_TYPE)
    UEMeasurementParameterModAllow._cont = ASN1Dict([(u'parameterModificationAllowed', 0)])
    UEMeasurementParameterModAllow._ext = []
    
    #-----< UEMeasurementReportCharacteristics >-----#
    UEMeasurementReportCharacteristics = CHOICE(name=u'UEMeasurementReportCharacteristics', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristics_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsPeriodic')))
    _UEMeasurementReportCharacteristics_event1h = SEQ(name=u'event1h', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsEvent1h')))
    _UEMeasurementReportCharacteristics_event1i = SEQ(name=u'event1i', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsEvent1i')))
    _UEMeasurementReportCharacteristics_event6a = SEQ(name=u'event6a', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsEvent6a')))
    _UEMeasurementReportCharacteristics_event6b = SEQ(name=u'event6b', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsEvent6b')))
    _UEMeasurementReportCharacteristics_event6c = SEQ(name=u'event6c', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsEvent6c')))
    _UEMeasurementReportCharacteristics_event6d = SEQ(name=u'event6d', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsEvent6d')))
    _UEMeasurementReportCharacteristics_extension_ReportCharacteristics = SEQ(name=u'extension-ReportCharacteristics', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristics-Extension')))
    UEMeasurementReportCharacteristics._cont = ASN1Dict([
        (u'periodic', _UEMeasurementReportCharacteristics_periodic),
        (u'event1h', _UEMeasurementReportCharacteristics_event1h),
        (u'event1i', _UEMeasurementReportCharacteristics_event1i),
        (u'event6a', _UEMeasurementReportCharacteristics_event6a),
        (u'event6b', _UEMeasurementReportCharacteristics_event6b),
        (u'event6c', _UEMeasurementReportCharacteristics_event6c),
        (u'event6d', _UEMeasurementReportCharacteristics_event6d),
        (u'extension-ReportCharacteristics', _UEMeasurementReportCharacteristics_extension_ReportCharacteristics),
        ])
    UEMeasurementReportCharacteristics._ext = [u'extension-ReportCharacteristics']
    
    #-----< UEMeasurementReportCharacteristicsEvent1h >-----#
    UEMeasurementReportCharacteristicsEvent1h = SEQ(name=u'UEMeasurementReportCharacteristicsEvent1h', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementTreshold = CHOICE(name=u'uEMeasurementTreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThreshold')))
    _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementTimeToTrigger = ENUM(name=u'uEMeasurementTimeToTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeToTrigger')))
    _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementHysteresisTime = INT(name=u'uEMeasurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementHysteresisTime')))
    _UEMeasurementReportCharacteristicsEvent1h_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsEvent1h_iE_Extensions._cont = __UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsEvent1h_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsEvent1h._cont = ASN1Dict([
        (u'uEMeasurementTreshold', _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementTreshold),
        (u'uEMeasurementTimeToTrigger', _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementTimeToTrigger),
        (u'uEMeasurementHysteresisTime', _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementHysteresisTime),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsEvent1h_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsEvent1h._ext = []
    
    #-----< UEMeasurementReportCharacteristicsEvent1h-ExtIEs >-----#
    UEMeasurementReportCharacteristicsEvent1h_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsEvent1h-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsEvent1h_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristicsEvent1i >-----#
    UEMeasurementReportCharacteristicsEvent1i = SEQ(name=u'UEMeasurementReportCharacteristicsEvent1i', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementTreshold = CHOICE(name=u'uEMeasurementTreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThreshold')))
    _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementTimeToTrigger = ENUM(name=u'uEMeasurementTimeToTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeToTrigger')))
    _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementHysteresisTime = INT(name=u'uEMeasurementHysteresisTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementHysteresisTime')))
    _UEMeasurementReportCharacteristicsEvent1i_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsEvent1i_iE_Extensions._cont = __UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsEvent1i_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsEvent1i._cont = ASN1Dict([
        (u'uEMeasurementTreshold', _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementTreshold),
        (u'uEMeasurementTimeToTrigger', _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementTimeToTrigger),
        (u'uEMeasurementHysteresisTime', _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementHysteresisTime),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsEvent1i_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsEvent1i._ext = []
    
    #-----< UEMeasurementReportCharacteristicsEvent1i-ExtIEs >-----#
    UEMeasurementReportCharacteristicsEvent1i_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsEvent1i-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsEvent1i_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristicsEvent6a >-----#
    UEMeasurementReportCharacteristicsEvent6a = SEQ(name=u'UEMeasurementReportCharacteristicsEvent6a', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsEvent6a_uEMeasurementTreshold = CHOICE(name=u'uEMeasurementTreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThreshold')))
    _UEMeasurementReportCharacteristicsEvent6a_uEMeasurementTimeToTrigger = ENUM(name=u'uEMeasurementTimeToTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeToTrigger')))
    _UEMeasurementReportCharacteristicsEvent6a_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsEvent6a_iE_Extensions._cont = __UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsEvent6a_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsEvent6a._cont = ASN1Dict([
        (u'uEMeasurementTreshold', _UEMeasurementReportCharacteristicsEvent6a_uEMeasurementTreshold),
        (u'uEMeasurementTimeToTrigger', _UEMeasurementReportCharacteristicsEvent6a_uEMeasurementTimeToTrigger),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsEvent6a_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsEvent6a._ext = []
    
    #-----< UEMeasurementReportCharacteristicsEvent6a-ExtIEs >-----#
    UEMeasurementReportCharacteristicsEvent6a_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsEvent6a-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsEvent6a_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristicsEvent6b >-----#
    UEMeasurementReportCharacteristicsEvent6b = SEQ(name=u'UEMeasurementReportCharacteristicsEvent6b', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsEvent6b_uEMeasurementTreshold = CHOICE(name=u'uEMeasurementTreshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThreshold')))
    _UEMeasurementReportCharacteristicsEvent6b_uEMeasurementTimeToTrigger = ENUM(name=u'uEMeasurementTimeToTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeToTrigger')))
    _UEMeasurementReportCharacteristicsEvent6b_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsEvent6b_iE_Extensions._cont = __UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsEvent6b_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsEvent6b._cont = ASN1Dict([
        (u'uEMeasurementTreshold', _UEMeasurementReportCharacteristicsEvent6b_uEMeasurementTreshold),
        (u'uEMeasurementTimeToTrigger', _UEMeasurementReportCharacteristicsEvent6b_uEMeasurementTimeToTrigger),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsEvent6b_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsEvent6b._ext = []
    
    #-----< UEMeasurementReportCharacteristicsEvent6b-ExtIEs >-----#
    UEMeasurementReportCharacteristicsEvent6b_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsEvent6b-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsEvent6b_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristicsEvent6c >-----#
    UEMeasurementReportCharacteristicsEvent6c = SEQ(name=u'UEMeasurementReportCharacteristicsEvent6c', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsEvent6c_uEMeasurementTimeToTrigger = ENUM(name=u'uEMeasurementTimeToTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeToTrigger')))
    _UEMeasurementReportCharacteristicsEvent6c_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsEvent6c_iE_Extensions._cont = __UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsEvent6c_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsEvent6c._cont = ASN1Dict([
        (u'uEMeasurementTimeToTrigger', _UEMeasurementReportCharacteristicsEvent6c_uEMeasurementTimeToTrigger),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsEvent6c_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsEvent6c._ext = []
    
    #-----< UEMeasurementReportCharacteristicsEvent6c-ExtIEs >-----#
    UEMeasurementReportCharacteristicsEvent6c_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsEvent6c-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsEvent6c_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristicsEvent6d >-----#
    UEMeasurementReportCharacteristicsEvent6d = SEQ(name=u'UEMeasurementReportCharacteristicsEvent6d', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsEvent6d_uEMeasurementTimeToTrigger = ENUM(name=u'uEMeasurementTimeToTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeToTrigger')))
    _UEMeasurementReportCharacteristicsEvent6d_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsEvent6d_iE_Extensions._cont = __UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsEvent6d_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsEvent6d._cont = ASN1Dict([
        (u'uEMeasurementTimeToTrigger', _UEMeasurementReportCharacteristicsEvent6d_uEMeasurementTimeToTrigger),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsEvent6d_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsEvent6d._ext = []
    
    #-----< UEMeasurementReportCharacteristicsEvent6d-ExtIEs >-----#
    UEMeasurementReportCharacteristicsEvent6d_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsEvent6d-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsEvent6d_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristicsPeriodic >-----#
    UEMeasurementReportCharacteristicsPeriodic = SEQ(name=u'UEMeasurementReportCharacteristicsPeriodic', mode=MODE_TYPE)
    _UEMeasurementReportCharacteristicsPeriodic_amountofReporting = ENUM(name=u'amountofReporting', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsPeriodicAmountofReporting')))
    _UEMeasurementReportCharacteristicsPeriodic_reportingInterval = ENUM(name=u'reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristicsPeriodicReportingInterval')))
    _UEMeasurementReportCharacteristicsPeriodic_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id._const_tab = ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id_tab
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality._const_tab = ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality_tab
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item_._ext = None
    _UEMeasurementReportCharacteristicsPeriodic_iE_Extensions._cont = __UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item_
    _UEMeasurementReportCharacteristicsPeriodic_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReportCharacteristicsPeriodic._cont = ASN1Dict([
        (u'amountofReporting', _UEMeasurementReportCharacteristicsPeriodic_amountofReporting),
        (u'reportingInterval', _UEMeasurementReportCharacteristicsPeriodic_reportingInterval),
        (u'iE-Extensions', _UEMeasurementReportCharacteristicsPeriodic_iE_Extensions),
        ])
    UEMeasurementReportCharacteristicsPeriodic._ext = []
    
    #-----< UEMeasurementReportCharacteristicsPeriodicAmountofReporting >-----#
    UEMeasurementReportCharacteristicsPeriodicAmountofReporting = ENUM(name=u'UEMeasurementReportCharacteristicsPeriodicAmountofReporting', mode=MODE_TYPE)
    UEMeasurementReportCharacteristicsPeriodicAmountofReporting._cont = ASN1Dict([(u'r1', 0), (u'r2', 1), (u'r4', 2), (u'r8', 3), (u'r16', 4), (u'r32', 5), (u'r64', 6), (u'rInfinity', 7)])
    UEMeasurementReportCharacteristicsPeriodicAmountofReporting._ext = None
    
    #-----< UEMeasurementReportCharacteristicsPeriodicReportingInterval >-----#
    UEMeasurementReportCharacteristicsPeriodicReportingInterval = ENUM(name=u'UEMeasurementReportCharacteristicsPeriodicReportingInterval', mode=MODE_TYPE)
    UEMeasurementReportCharacteristicsPeriodicReportingInterval._cont = ASN1Dict([(u'r250', 0), (u'r500', 1), (u'r1000', 2), (u'r2000', 3), (u'r3000', 4), (u'r4000', 5), (u'r6000', 6), (u'r8000', 7), (u'r12000', 8), (u'r16000', 9), (u'r20000', 10), (u'r24000', 11), (u'r28000', 12), (u'r32000', 13), (u'r64000', 14)])
    UEMeasurementReportCharacteristicsPeriodicReportingInterval._ext = None
    
    #-----< UEMeasurementReportCharacteristicsPeriodic-ExtIEs >-----#
    UEMeasurementReportCharacteristicsPeriodic_ExtIEs = CLASS(name=u'UEMeasurementReportCharacteristicsPeriodic-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReportCharacteristicsPeriodic_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReportCharacteristics-Extension >-----#
    UEMeasurementReportCharacteristics_Extension = SEQ(name=u'UEMeasurementReportCharacteristics-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UEMeasurementReportCharacteristics_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UEMeasurementReportCharacteristics_Extension_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementReportCharacteristics_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementReportCharacteristics_Extension_id._const_tab = __UEMeasurementReportCharacteristics_Extension_id_tab
    _UEMeasurementReportCharacteristics_Extension_id._const_tab_at = None
    _UEMeasurementReportCharacteristics_Extension_id._const_tab_id = u'id'
    _UEMeasurementReportCharacteristics_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UEMeasurementReportCharacteristics_Extension_criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementReportCharacteristics_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementReportCharacteristics_Extension_criticality._const_tab = __UEMeasurementReportCharacteristics_Extension_criticality_tab
    _UEMeasurementReportCharacteristics_Extension_criticality._const_tab_at = ('..', u'id')
    _UEMeasurementReportCharacteristics_Extension_criticality._const_tab_id = u'criticality'
    _UEMeasurementReportCharacteristics_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UEMeasurementReportCharacteristics_Extension_value_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementReportCharacteristics_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementReportCharacteristics_Extension_value._const_tab = __UEMeasurementReportCharacteristics_Extension_value_tab
    _UEMeasurementReportCharacteristics_Extension_value._const_tab_at = ('..', u'id')
    _UEMeasurementReportCharacteristics_Extension_value._const_tab_id = u'Value'
    UEMeasurementReportCharacteristics_Extension._cont = ASN1Dict([
        (u'id', _UEMeasurementReportCharacteristics_Extension_id),
        (u'criticality', _UEMeasurementReportCharacteristics_Extension_criticality),
        (u'value', _UEMeasurementReportCharacteristics_Extension_value),
        ])
    UEMeasurementReportCharacteristics_Extension._ext = None
    
    #-----< UEMeasurementReportCharacteristics-ExtensionIE >-----#
    UEMeasurementReportCharacteristics_ExtensionIE = CLASS(name=u'UEMeasurementReportCharacteristics-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    UEMeasurementReportCharacteristics_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementThreshold >-----#
    UEMeasurementThreshold = CHOICE(name=u'UEMeasurementThreshold', mode=MODE_TYPE)
    _UEMeasurementThreshold_timeslotISCP = INT(name=u'timeslotISCP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThresholdDLTimeslotISCP')))
    _UEMeasurementThreshold_uETransmitPower = INT(name=u'uETransmitPower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThresholdUETransmitPower')))
    _UEMeasurementThreshold_extension_UEMeasurementThreshold = SEQ(name=u'extension-UEMeasurementThreshold', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementThreshold-Extension')))
    UEMeasurementThreshold._cont = ASN1Dict([
        (u'timeslotISCP', _UEMeasurementThreshold_timeslotISCP),
        (u'uETransmitPower', _UEMeasurementThreshold_uETransmitPower),
        (u'extension-UEMeasurementThreshold', _UEMeasurementThreshold_extension_UEMeasurementThreshold),
        ])
    UEMeasurementThreshold._ext = [u'extension-UEMeasurementThreshold']
    
    #-----< UEMeasurementThresholdDLTimeslotISCP >-----#
    UEMeasurementThresholdDLTimeslotISCP = INT(name=u'UEMeasurementThresholdDLTimeslotISCP', mode=MODE_TYPE)
    UEMeasurementThresholdDLTimeslotISCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-115, ub=-25)], ev=None, er=[])
    
    #-----< UEMeasurementThresholdUETransmitPower >-----#
    UEMeasurementThresholdUETransmitPower = INT(name=u'UEMeasurementThresholdUETransmitPower', mode=MODE_TYPE)
    UEMeasurementThresholdUETransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=33)], ev=None, er=[])
    
    #-----< UEMeasurementThreshold-Extension >-----#
    UEMeasurementThreshold_Extension = SEQ(name=u'UEMeasurementThreshold-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UEMeasurementThreshold_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UEMeasurementThreshold_Extension_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementThreshold_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementThreshold_Extension_id._const_tab = __UEMeasurementThreshold_Extension_id_tab
    _UEMeasurementThreshold_Extension_id._const_tab_at = None
    _UEMeasurementThreshold_Extension_id._const_tab_id = u'id'
    _UEMeasurementThreshold_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UEMeasurementThreshold_Extension_criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementThreshold_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementThreshold_Extension_criticality._const_tab = __UEMeasurementThreshold_Extension_criticality_tab
    _UEMeasurementThreshold_Extension_criticality._const_tab_at = ('..', u'id')
    _UEMeasurementThreshold_Extension_criticality._const_tab_id = u'criticality'
    _UEMeasurementThreshold_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UEMeasurementThreshold_Extension_value_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementThreshold_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementThreshold_Extension_value._const_tab = __UEMeasurementThreshold_Extension_value_tab
    _UEMeasurementThreshold_Extension_value._const_tab_at = ('..', u'id')
    _UEMeasurementThreshold_Extension_value._const_tab_id = u'Value'
    UEMeasurementThreshold_Extension._cont = ASN1Dict([
        (u'id', _UEMeasurementThreshold_Extension_id),
        (u'criticality', _UEMeasurementThreshold_Extension_criticality),
        (u'value', _UEMeasurementThreshold_Extension_value),
        ])
    UEMeasurementThreshold_Extension._ext = None
    
    #-----< UEMeasurementThreshold-ExtensionIE >-----#
    UEMeasurementThreshold_ExtensionIE = CLASS(name=u'UEMeasurementThreshold-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    UEMeasurementThreshold_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementTimeslotInfoHCR >-----#
    UEMeasurementTimeslotInfoHCR = SEQ_OF(name=u'UEMeasurementTimeslotInfoHCR', mode=MODE_TYPE)
    _UEMeasurementTimeslotInfoHCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoHCR-IEs')))
    UEMeasurementTimeslotInfoHCR._cont = _UEMeasurementTimeslotInfoHCR__item_
    UEMeasurementTimeslotInfoHCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementTimeslotInfoHCR-IEs >-----#
    UEMeasurementTimeslotInfoHCR_IEs = SEQ(name=u'UEMeasurementTimeslotInfoHCR-IEs', mode=MODE_TYPE)
    _UEMeasurementTimeslotInfoHCR_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UEMeasurementTimeslotInfoHCR_IEs_burstType = ENUM(name=u'burstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoHCRBurstType')))
    _UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions._cont = __UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item_
    _UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementTimeslotInfoHCR_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementTimeslotInfoHCR_IEs_timeSlot),
        (u'burstType', _UEMeasurementTimeslotInfoHCR_IEs_burstType),
        (u'iE-Extensions', _UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions),
        ])
    UEMeasurementTimeslotInfoHCR_IEs._ext = []
    
    #-----< UEMeasurementTimeslotInfoHCRBurstType >-----#
    UEMeasurementTimeslotInfoHCRBurstType = ENUM(name=u'UEMeasurementTimeslotInfoHCRBurstType', mode=MODE_TYPE)
    UEMeasurementTimeslotInfoHCRBurstType._cont = ASN1Dict([(u'type1', 0), (u'type2', 1), (u'type3', 2)])
    UEMeasurementTimeslotInfoHCRBurstType._ext = []
    
    #-----< UEMeasurementTimeslotInfoHCR-IEs-ExtIEs >-----#
    UEMeasurementTimeslotInfoHCR_IEs_ExtIEs = CLASS(name=u'UEMeasurementTimeslotInfoHCR-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementTimeslotInfoHCR_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementTimeslotInfoLCR >-----#
    UEMeasurementTimeslotInfoLCR = SEQ_OF(name=u'UEMeasurementTimeslotInfoLCR', mode=MODE_TYPE)
    _UEMeasurementTimeslotInfoLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoLCR-IEs')))
    UEMeasurementTimeslotInfoLCR._cont = _UEMeasurementTimeslotInfoLCR__item_
    UEMeasurementTimeslotInfoLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UEMeasurementTimeslotInfoLCR-IEs >-----#
    UEMeasurementTimeslotInfoLCR_IEs = SEQ(name=u'UEMeasurementTimeslotInfoLCR-IEs', mode=MODE_TYPE)
    _UEMeasurementTimeslotInfoLCR_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions._cont = __UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item_
    _UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementTimeslotInfoLCR_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementTimeslotInfoLCR_IEs_timeSlot),
        (u'iE-Extensions', _UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions),
        ])
    UEMeasurementTimeslotInfoLCR_IEs._ext = []
    
    #-----< UEMeasurementTimeslotInfoLCR-IEs-ExtIEs >-----#
    UEMeasurementTimeslotInfoLCR_IEs_ExtIEs = CLASS(name=u'UEMeasurementTimeslotInfoLCR-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementTimeslotInfoLCR_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementTimeslotInfo768 >-----#
    UEMeasurementTimeslotInfo768 = SEQ_OF(name=u'UEMeasurementTimeslotInfo768', mode=MODE_TYPE)
    _UEMeasurementTimeslotInfo768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfo768-IEs')))
    UEMeasurementTimeslotInfo768._cont = _UEMeasurementTimeslotInfo768__item_
    UEMeasurementTimeslotInfo768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementTimeslotInfo768-IEs >-----#
    UEMeasurementTimeslotInfo768_IEs = SEQ(name=u'UEMeasurementTimeslotInfo768-IEs', mode=MODE_TYPE)
    _UEMeasurementTimeslotInfo768_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UEMeasurementTimeslotInfo768_IEs_burstType = ENUM(name=u'burstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfo768BurstType')))
    _UEMeasurementTimeslotInfo768_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementTimeslotInfo768_IEs_iE_Extensions._cont = __UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item_
    _UEMeasurementTimeslotInfo768_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementTimeslotInfo768_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementTimeslotInfo768_IEs_timeSlot),
        (u'burstType', _UEMeasurementTimeslotInfo768_IEs_burstType),
        (u'iE-Extensions', _UEMeasurementTimeslotInfo768_IEs_iE_Extensions),
        ])
    UEMeasurementTimeslotInfo768_IEs._ext = []
    
    #-----< UEMeasurementTimeslotInfo768BurstType >-----#
    UEMeasurementTimeslotInfo768BurstType = ENUM(name=u'UEMeasurementTimeslotInfo768BurstType', mode=MODE_TYPE)
    UEMeasurementTimeslotInfo768BurstType._cont = ASN1Dict([(u'type1', 0), (u'type2', 1), (u'type3', 2)])
    UEMeasurementTimeslotInfo768BurstType._ext = []
    
    #-----< UEMeasurementTimeslotInfo768-IEs-ExtIEs >-----#
    UEMeasurementTimeslotInfo768_IEs_ExtIEs = CLASS(name=u'UEMeasurementTimeslotInfo768-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementTimeslotInfo768_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementTimeToTrigger >-----#
    UEMeasurementTimeToTrigger = ENUM(name=u'UEMeasurementTimeToTrigger', mode=MODE_TYPE)
    UEMeasurementTimeToTrigger._cont = ASN1Dict([(u'r0', 0), (u'r10', 1), (u'r20', 2), (u'r40', 3), (u'r60', 4), (u'r80', 5), (u'r100', 6), (u'r120', 7), (u'r160', 8), (u'r200', 9), (u'r240', 10), (u'r320', 11), (u'r640', 12), (u'r1280', 13), (u'r2560', 14), (u'r5000', 15)])
    UEMeasurementTimeToTrigger._ext = None
    
    #-----< UEMeasurementType >-----#
    UEMeasurementType = ENUM(name=u'UEMeasurementType', mode=MODE_TYPE)
    UEMeasurementType._cont = ASN1Dict([(u'primary-CCPCH-RSCP', 0), (u'dL-Timeslot-ISCP', 1), (u'uE-Transmitted-power', 2)])
    UEMeasurementType._ext = []
    
    #-----< UEMeasurementValue >-----#
    UEMeasurementValue = CHOICE(name=u'UEMeasurementValue', mode=MODE_TYPE)
    _UEMeasurementValue_uE_Transmitted_Power = SEQ(name=u'uE-Transmitted-Power', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-MeasurementValue-UE-Transmitted-Power')))
    _UEMeasurementValue_primary_CCPCH_RSCP = SEQ(name=u'primary-CCPCH-RSCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-MeasurementValue-Primary-CCPCH-RSCP')))
    _UEMeasurementValue_dL_Timeslot_ISCP = SEQ(name=u'dL-Timeslot-ISCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-MeasurementValue-DL-Timeslot-ISCP')))
    _UEMeasurementValue_extension_UEMeasurementValue = SEQ(name=u'extension-UEMeasurementValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValue-Extension')))
    UEMeasurementValue._cont = ASN1Dict([
        (u'uE-Transmitted-Power', _UEMeasurementValue_uE_Transmitted_Power),
        (u'primary-CCPCH-RSCP', _UEMeasurementValue_primary_CCPCH_RSCP),
        (u'dL-Timeslot-ISCP', _UEMeasurementValue_dL_Timeslot_ISCP),
        (u'extension-UEMeasurementValue', _UEMeasurementValue_extension_UEMeasurementValue),
        ])
    UEMeasurementValue._ext = [u'extension-UEMeasurementValue']
    
    #-----< UE-MeasurementValue-UE-Transmitted-Power >-----#
    UE_MeasurementValue_UE_Transmitted_Power = SEQ(name=u'UE-MeasurementValue-UE-Transmitted-Power', mode=MODE_TYPE)
    _UE_MeasurementValue_UE_Transmitted_Power_uEMeasurementTransmittedPowerListHCR = SEQ_OF(name=u'uEMeasurementTransmittedPowerListHCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerListHCR')), opt=True)
    _UE_MeasurementValue_UE_Transmitted_Power_uEMeasurementTransmittedPowerListLCR = SEQ_OF(name=u'uEMeasurementTransmittedPowerListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerListLCR')), opt=True)
    _UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerList768')))
    ____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 634), (u'criticality', u'ignore'), (u'Extension', _____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id._const_tab = ____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id._const_tab_at = None
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__criticality._const_tab = ____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__extensionValue._const_tab = ____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id),
        (u'criticality', ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__extensionValue),
        ])
    __UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item_._ext = None
    _UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions._cont = __UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item_
    _UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MeasurementValue_UE_Transmitted_Power._cont = ASN1Dict([
        (u'uEMeasurementTransmittedPowerListHCR', _UE_MeasurementValue_UE_Transmitted_Power_uEMeasurementTransmittedPowerListHCR),
        (u'uEMeasurementTransmittedPowerListLCR', _UE_MeasurementValue_UE_Transmitted_Power_uEMeasurementTransmittedPowerListLCR),
        (u'iE-Extensions', _UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions),
        ])
    UE_MeasurementValue_UE_Transmitted_Power._ext = []
    
    #-----< UE-MeasurementValue-UE-Transmitted-Power-ExtIEs >-----#
    UE_MeasurementValue_UE_Transmitted_Power_ExtIEs = CLASS(name=u'UE-MeasurementValue-UE-Transmitted-Power-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UE_MeasurementValue_UE_Transmitted_Power_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerList768')))
    UE_MeasurementValue_UE_Transmitted_Power_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 634), (u'criticality', u'ignore'), (u'Extension', _UE_MeasurementValue_UE_Transmitted_Power_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueTransmittedPowerListHCR >-----#
    UEMeasurementValueTransmittedPowerListHCR = SEQ_OF(name=u'UEMeasurementValueTransmittedPowerListHCR', mode=MODE_TYPE)
    _UEMeasurementValueTransmittedPowerListHCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerListHCR-IEs')))
    UEMeasurementValueTransmittedPowerListHCR._cont = _UEMeasurementValueTransmittedPowerListHCR__item_
    UEMeasurementValueTransmittedPowerListHCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementValueTransmittedPowerListHCR-IEs >-----#
    UEMeasurementValueTransmittedPowerListHCR_IEs = SEQ(name=u'UEMeasurementValueTransmittedPowerListHCR-IEs', mode=MODE_TYPE)
    _UEMeasurementValueTransmittedPowerListHCR_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UEMeasurementValueTransmittedPowerListHCR_IEs_uETransmitPower = INT(name=u'uETransmitPower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEMeasurementValueTransmittedPowerListHCR_IEs_uETransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=104)], ev=None, er=[])
    _UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions._cont = __UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item_
    _UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueTransmittedPowerListHCR_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementValueTransmittedPowerListHCR_IEs_timeSlot),
        (u'uETransmitPower', _UEMeasurementValueTransmittedPowerListHCR_IEs_uETransmitPower),
        (u'iE-Extensions', _UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions),
        ])
    UEMeasurementValueTransmittedPowerListHCR_IEs._ext = []
    
    #-----< UEMeasurementValueTransmittedPowerListHCR-IEs-ExtIEs >-----#
    UEMeasurementValueTransmittedPowerListHCR_IEs_ExtIEs = CLASS(name=u'UEMeasurementValueTransmittedPowerListHCR-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueTransmittedPowerListHCR_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueTransmittedPowerListLCR >-----#
    UEMeasurementValueTransmittedPowerListLCR = SEQ_OF(name=u'UEMeasurementValueTransmittedPowerListLCR', mode=MODE_TYPE)
    _UEMeasurementValueTransmittedPowerListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerListLCR-IEs')))
    UEMeasurementValueTransmittedPowerListLCR._cont = _UEMeasurementValueTransmittedPowerListLCR__item_
    UEMeasurementValueTransmittedPowerListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UEMeasurementValueTransmittedPowerListLCR-IEs >-----#
    UEMeasurementValueTransmittedPowerListLCR_IEs = SEQ(name=u'UEMeasurementValueTransmittedPowerListLCR-IEs', mode=MODE_TYPE)
    _UEMeasurementValueTransmittedPowerListLCR_IEs_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UEMeasurementValueTransmittedPowerListLCR_IEs_uETransmitPower = INT(name=u'uETransmitPower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEMeasurementValueTransmittedPowerListLCR_IEs_uETransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=104)], ev=None, er=[])
    _UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions._cont = __UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item_
    _UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueTransmittedPowerListLCR_IEs._cont = ASN1Dict([
        (u'timeSlotLCR', _UEMeasurementValueTransmittedPowerListLCR_IEs_timeSlotLCR),
        (u'uETransmitPower', _UEMeasurementValueTransmittedPowerListLCR_IEs_uETransmitPower),
        (u'iE-Extensions', _UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions),
        ])
    UEMeasurementValueTransmittedPowerListLCR_IEs._ext = []
    
    #-----< UEMeasurementValueTransmittedPowerListLCR-IEs-ExtIEs >-----#
    UEMeasurementValueTransmittedPowerListLCR_IEs_ExtIEs = CLASS(name=u'UEMeasurementValueTransmittedPowerListLCR-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueTransmittedPowerListLCR_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueTransmittedPowerList768 >-----#
    UEMeasurementValueTransmittedPowerList768 = SEQ_OF(name=u'UEMeasurementValueTransmittedPowerList768', mode=MODE_TYPE)
    _UEMeasurementValueTransmittedPowerList768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTransmittedPowerList768-IEs')))
    UEMeasurementValueTransmittedPowerList768._cont = _UEMeasurementValueTransmittedPowerList768__item_
    UEMeasurementValueTransmittedPowerList768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementValueTransmittedPowerList768-IEs >-----#
    UEMeasurementValueTransmittedPowerList768_IEs = SEQ(name=u'UEMeasurementValueTransmittedPowerList768-IEs', mode=MODE_TYPE)
    _UEMeasurementValueTransmittedPowerList768_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UEMeasurementValueTransmittedPowerList768_IEs_uETransmitPower = INT(name=u'uETransmitPower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UEMeasurementValueTransmittedPowerList768_IEs_uETransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=104)], ev=None, er=[])
    _UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions._cont = __UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item_
    _UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueTransmittedPowerList768_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementValueTransmittedPowerList768_IEs_timeSlot),
        (u'uETransmitPower', _UEMeasurementValueTransmittedPowerList768_IEs_uETransmitPower),
        (u'iE-Extensions', _UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions),
        ])
    UEMeasurementValueTransmittedPowerList768_IEs._ext = []
    
    #-----< UEMeasurementValueTransmittedPowerList768-IEs-ExtIEs >-----#
    UEMeasurementValueTransmittedPowerList768_IEs_ExtIEs = CLASS(name=u'UEMeasurementValueTransmittedPowerList768-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueTransmittedPowerList768_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MeasurementValue-Primary-CCPCH-RSCP >-----#
    UE_MeasurementValue_Primary_CCPCH_RSCP = SEQ(name=u'UE-MeasurementValue-Primary-CCPCH-RSCP', mode=MODE_TYPE)
    _UE_MeasurementValue_Primary_CCPCH_RSCP_primaryCCPCH_RSCP = INT(name=u'primaryCCPCH-RSCP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')), opt=True)
    _UE_MeasurementValue_Primary_CCPCH_RSCP_primaryCCPCH_RSCP_Delta = INT(name=u'primaryCCPCH-RSCP-Delta', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')), opt=True)
    _UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id._const_tab = ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id._const_tab_at = None
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality._const_tab = ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality_tab
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue._const_tab = ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue_tab
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id),
        (u'criticality', ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue),
        ])
    __UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item_._ext = None
    _UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions._cont = __UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item_
    _UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MeasurementValue_Primary_CCPCH_RSCP._cont = ASN1Dict([
        (u'primaryCCPCH-RSCP', _UE_MeasurementValue_Primary_CCPCH_RSCP_primaryCCPCH_RSCP),
        (u'primaryCCPCH-RSCP-Delta', _UE_MeasurementValue_Primary_CCPCH_RSCP_primaryCCPCH_RSCP_Delta),
        (u'iE-Extensions', _UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions),
        ])
    UE_MeasurementValue_Primary_CCPCH_RSCP._ext = []
    
    #-----< UE-MeasurementValue-Primary-CCPCH-RSCP-ExtIEs >-----#
    UE_MeasurementValue_Primary_CCPCH_RSCP_ExtIEs = CLASS(name=u'UE-MeasurementValue-Primary-CCPCH-RSCP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UE_MeasurementValue_Primary_CCPCH_RSCP_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-MeasurementValue-DL-Timeslot-ISCP >-----#
    UE_MeasurementValue_DL_Timeslot_ISCP = SEQ(name=u'UE-MeasurementValue-DL-Timeslot-ISCP', mode=MODE_TYPE)
    _UE_MeasurementValue_DL_Timeslot_ISCP_uEMeasurementTimeslotISCPListHCR = SEQ_OF(name=u'uEMeasurementTimeslotISCPListHCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPListHCR')), opt=True)
    _UE_MeasurementValue_DL_Timeslot_ISCP_uEMeasurementTimeslotISCPListLCR = SEQ_OF(name=u'uEMeasurementTimeslotISCPListLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPListLCR')), opt=True)
    _UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPList768')))
    ____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 635), (u'criticality', u'ignore'), (u'Extension', _____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id._const_tab = ____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id._const_tab_at = None
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__criticality._const_tab = ____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__extensionValue._const_tab = ____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id),
        (u'criticality', ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__extensionValue),
        ])
    __UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item_._ext = None
    _UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions._cont = __UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item_
    _UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_MeasurementValue_DL_Timeslot_ISCP._cont = ASN1Dict([
        (u'uEMeasurementTimeslotISCPListHCR', _UE_MeasurementValue_DL_Timeslot_ISCP_uEMeasurementTimeslotISCPListHCR),
        (u'uEMeasurementTimeslotISCPListLCR', _UE_MeasurementValue_DL_Timeslot_ISCP_uEMeasurementTimeslotISCPListLCR),
        (u'iE-Extensions', _UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions),
        ])
    UE_MeasurementValue_DL_Timeslot_ISCP._ext = []
    
    #-----< UE-MeasurementValue-DL-Timeslot-ISCP-ExtIEs >-----#
    UE_MeasurementValue_DL_Timeslot_ISCP_ExtIEs = CLASS(name=u'UE-MeasurementValue-DL-Timeslot-ISCP-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UE_MeasurementValue_DL_Timeslot_ISCP_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPList768')))
    UE_MeasurementValue_DL_Timeslot_ISCP_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 635), (u'criticality', u'ignore'), (u'Extension', _UE_MeasurementValue_DL_Timeslot_ISCP_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueTimeslotISCPListHCR >-----#
    UEMeasurementValueTimeslotISCPListHCR = SEQ_OF(name=u'UEMeasurementValueTimeslotISCPListHCR', mode=MODE_TYPE)
    _UEMeasurementValueTimeslotISCPListHCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPListHCR-IEs')))
    UEMeasurementValueTimeslotISCPListHCR._cont = _UEMeasurementValueTimeslotISCPListHCR__item_
    UEMeasurementValueTimeslotISCPListHCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementValueTimeslotISCPListHCR-IEs >-----#
    UEMeasurementValueTimeslotISCPListHCR_IEs = SEQ(name=u'UEMeasurementValueTimeslotISCPListHCR-IEs', mode=MODE_TYPE)
    _UEMeasurementValueTimeslotISCPListHCR_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UEMeasurementValueTimeslotISCPListHCR_IEs_dL_TimeslotISCP = INT(name=u'dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotISCP')))
    _UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions._cont = __UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item_
    _UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueTimeslotISCPListHCR_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementValueTimeslotISCPListHCR_IEs_timeSlot),
        (u'dL-TimeslotISCP', _UEMeasurementValueTimeslotISCPListHCR_IEs_dL_TimeslotISCP),
        (u'iE-Extensions', _UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions),
        ])
    UEMeasurementValueTimeslotISCPListHCR_IEs._ext = []
    
    #-----< UEMeasurementValueTimeslotISCPListHCR-IEs-ExtIEs >-----#
    UEMeasurementValueTimeslotISCPListHCR_IEs_ExtIEs = CLASS(name=u'UEMeasurementValueTimeslotISCPListHCR-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueTimeslotISCPListHCR_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueTimeslotISCPListLCR >-----#
    UEMeasurementValueTimeslotISCPListLCR = SEQ_OF(name=u'UEMeasurementValueTimeslotISCPListLCR', mode=MODE_TYPE)
    _UEMeasurementValueTimeslotISCPListLCR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPListLCR-IEs')))
    UEMeasurementValueTimeslotISCPListLCR._cont = _UEMeasurementValueTimeslotISCPListLCR__item_
    UEMeasurementValueTimeslotISCPListLCR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UEMeasurementValueTimeslotISCPListLCR-IEs >-----#
    UEMeasurementValueTimeslotISCPListLCR_IEs = SEQ(name=u'UEMeasurementValueTimeslotISCPListLCR-IEs', mode=MODE_TYPE)
    _UEMeasurementValueTimeslotISCPListLCR_IEs_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UEMeasurementValueTimeslotISCPListLCR_IEs_dL_TimeslotISCP = INT(name=u'dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotISCP')))
    _UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions._cont = __UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item_
    _UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueTimeslotISCPListLCR_IEs._cont = ASN1Dict([
        (u'timeSlotLCR', _UEMeasurementValueTimeslotISCPListLCR_IEs_timeSlotLCR),
        (u'dL-TimeslotISCP', _UEMeasurementValueTimeslotISCPListLCR_IEs_dL_TimeslotISCP),
        (u'iE-Extensions', _UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions),
        ])
    UEMeasurementValueTimeslotISCPListLCR_IEs._ext = []
    
    #-----< UEMeasurementValueTimeslotISCPListLCR-IEs-ExtIEs >-----#
    UEMeasurementValueTimeslotISCPListLCR_IEs_ExtIEs = CLASS(name=u'UEMeasurementValueTimeslotISCPListLCR-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueTimeslotISCPListLCR_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueTimeslotISCPList768 >-----#
    UEMeasurementValueTimeslotISCPList768 = SEQ_OF(name=u'UEMeasurementValueTimeslotISCPList768', mode=MODE_TYPE)
    _UEMeasurementValueTimeslotISCPList768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueTimeslotISCPList768-IEs')))
    UEMeasurementValueTimeslotISCPList768._cont = _UEMeasurementValueTimeslotISCPList768__item_
    UEMeasurementValueTimeslotISCPList768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UEMeasurementValueTimeslotISCPList768-IEs >-----#
    UEMeasurementValueTimeslotISCPList768_IEs = SEQ(name=u'UEMeasurementValueTimeslotISCPList768-IEs', mode=MODE_TYPE)
    _UEMeasurementValueTimeslotISCPList768_IEs_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UEMeasurementValueTimeslotISCPList768_IEs_dL_TimeslotISCP = INT(name=u'dL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotISCP')))
    _UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id._const_tab = ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id_tab
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality._const_tab = ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality_tab
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue_tab
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item_._ext = None
    _UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions._cont = __UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item_
    _UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueTimeslotISCPList768_IEs._cont = ASN1Dict([
        (u'timeSlot', _UEMeasurementValueTimeslotISCPList768_IEs_timeSlot),
        (u'dL-TimeslotISCP', _UEMeasurementValueTimeslotISCPList768_IEs_dL_TimeslotISCP),
        (u'iE-Extensions', _UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions),
        ])
    UEMeasurementValueTimeslotISCPList768_IEs._ext = []
    
    #-----< UEMeasurementValueTimeslotISCPList768-IEs-ExtIEs >-----#
    UEMeasurementValueTimeslotISCPList768_IEs_ExtIEs = CLASS(name=u'UEMeasurementValueTimeslotISCPList768-IEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueTimeslotISCPList768_IEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValue-Extension >-----#
    UEMeasurementValue_Extension = SEQ(name=u'UEMeasurementValue-Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UEMeasurementValue_Extension_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UEMeasurementValue_Extension_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementValue_Extension_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementValue_Extension_id._const_tab = __UEMeasurementValue_Extension_id_tab
    _UEMeasurementValue_Extension_id._const_tab_at = None
    _UEMeasurementValue_Extension_id._const_tab_id = u'id'
    _UEMeasurementValue_Extension_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UEMeasurementValue_Extension_criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementValue_Extension_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementValue_Extension_criticality._const_tab = __UEMeasurementValue_Extension_criticality_tab
    _UEMeasurementValue_Extension_criticality._const_tab_at = ('..', u'id')
    _UEMeasurementValue_Extension_criticality._const_tab_id = u'criticality'
    _UEMeasurementValue_Extension_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UEMeasurementValue_Extension_value_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __UEMeasurementValue_Extension_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _UEMeasurementValue_Extension_value._const_tab = __UEMeasurementValue_Extension_value_tab
    _UEMeasurementValue_Extension_value._const_tab_at = ('..', u'id')
    _UEMeasurementValue_Extension_value._const_tab_id = u'Value'
    UEMeasurementValue_Extension._cont = ASN1Dict([
        (u'id', _UEMeasurementValue_Extension_id),
        (u'criticality', _UEMeasurementValue_Extension_criticality),
        (u'value', _UEMeasurementValue_Extension_value),
        ])
    UEMeasurementValue_Extension._ext = None
    
    #-----< UEMeasurementValue-ExtensionIE >-----#
    UEMeasurementValue_ExtensionIE = CLASS(name=u'UEMeasurementValue-ExtensionIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    UEMeasurementValue_ExtensionIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueInformation >-----#
    UEMeasurementValueInformation = CHOICE(name=u'UEMeasurementValueInformation', mode=MODE_TYPE)
    _UEMeasurementValueInformation_measurementAvailable = SEQ(name=u'measurementAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueInformationAvailable')))
    _UEMeasurementValueInformation_measurementnotAvailable = NULL(name=u'measurementnotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueInformationnotAvailable')))
    UEMeasurementValueInformation._cont = ASN1Dict([
        (u'measurementAvailable', _UEMeasurementValueInformation_measurementAvailable),
        (u'measurementnotAvailable', _UEMeasurementValueInformation_measurementnotAvailable),
        ])
    UEMeasurementValueInformation._ext = None
    
    #-----< UEMeasurementValueInformationAvailable >-----#
    UEMeasurementValueInformationAvailable = SEQ(name=u'UEMeasurementValueInformationAvailable', mode=MODE_TYPE)
    _UEMeasurementValueInformationAvailable_uEmeasurementValue = CHOICE(name=u'uEmeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValue')))
    _UEMeasurementValueInformationAvailable_ie_Extensions = SEQ_OF(name=u'ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementValueInformationAvailable_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementValueInformationAvailable_ie_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueInformationAvailable_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__id._const_tab = ____UEMeasurementValueInformationAvailable_ie_Extensions__item__id_tab
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__id._const_tab_at = None
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__id._const_tab_id = u'id'
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality._const_tab = ____UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality_tab
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue._const_tab = ____UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue_tab
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementValueInformationAvailable_ie_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementValueInformationAvailable_ie_Extensions__item__id),
        (u'criticality', ___UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality),
        (u'extensionValue', ___UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue),
        ])
    __UEMeasurementValueInformationAvailable_ie_Extensions__item_._ext = None
    _UEMeasurementValueInformationAvailable_ie_Extensions._cont = __UEMeasurementValueInformationAvailable_ie_Extensions__item_
    _UEMeasurementValueInformationAvailable_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementValueInformationAvailable._cont = ASN1Dict([
        (u'uEmeasurementValue', _UEMeasurementValueInformationAvailable_uEmeasurementValue),
        (u'ie-Extensions', _UEMeasurementValueInformationAvailable_ie_Extensions),
        ])
    UEMeasurementValueInformationAvailable._ext = []
    
    #-----< UEMeasurementValueInformationAvailableItem-ExtIEs >-----#
    UEMeasurementValueInformationAvailableItem_ExtIEs = CLASS(name=u'UEMeasurementValueInformationAvailableItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementValueInformationAvailableItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementValueInformationnotAvailable >-----#
    UEMeasurementValueInformationnotAvailable = NULL(name=u'UEMeasurementValueInformationnotAvailable', mode=MODE_TYPE)
    
    #-----< UE-Measurement-Value >-----#
    UE_Measurement_Value = CHOICE(name=u'UE-Measurement-Value', mode=MODE_TYPE)
    _UE_Measurement_Value_uPHFiltering_Value = INT(name=u'uPHFiltering-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UPHFiltering-Value')))
    _UE_Measurement_Value_extension_UE_Measurement_Value = SEQ(name=u'extension-UE-Measurement-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Extension-UE-Measurement-Value')))
    UE_Measurement_Value._cont = ASN1Dict([
        (u'uPHFiltering-Value', _UE_Measurement_Value_uPHFiltering_Value),
        (u'extension-UE-Measurement-Value', _UE_Measurement_Value_extension_UE_Measurement_Value),
        ])
    UE_Measurement_Value._ext = None
    
    #-----< Extension-UE-Measurement-Value >-----#
    Extension_UE_Measurement_Value = SEQ(name=u'Extension-UE-Measurement-Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_UE_Measurement_Value_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_UE_Measurement_Value_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __Extension_UE_Measurement_Value_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_UE_Measurement_Value_id._const_tab = __Extension_UE_Measurement_Value_id_tab
    _Extension_UE_Measurement_Value_id._const_tab_at = None
    _Extension_UE_Measurement_Value_id._const_tab_id = u'id'
    _Extension_UE_Measurement_Value_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __Extension_UE_Measurement_Value_criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __Extension_UE_Measurement_Value_criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_UE_Measurement_Value_criticality._const_tab = __Extension_UE_Measurement_Value_criticality_tab
    _Extension_UE_Measurement_Value_criticality._const_tab_at = ('..', u'id')
    _Extension_UE_Measurement_Value_criticality._const_tab_id = u'criticality'
    _Extension_UE_Measurement_Value_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __Extension_UE_Measurement_Value_value_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    __Extension_UE_Measurement_Value_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_UE_Measurement_Value_value._const_tab = __Extension_UE_Measurement_Value_value_tab
    _Extension_UE_Measurement_Value_value._const_tab_at = ('..', u'id')
    _Extension_UE_Measurement_Value_value._const_tab_id = u'Value'
    Extension_UE_Measurement_Value._cont = ASN1Dict([
        (u'id', _Extension_UE_Measurement_Value_id),
        (u'criticality', _Extension_UE_Measurement_Value_criticality),
        (u'value', _Extension_UE_Measurement_Value_value),
        ])
    Extension_UE_Measurement_Value._ext = None
    
    #-----< Extension-UE-Measurement-ValueIE >-----#
    Extension_UE_Measurement_ValueIE = CLASS(name=u'Extension-UE-Measurement-ValueIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    Extension_UE_Measurement_ValueIE._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UPHFiltering-Value >-----#
    UPHFiltering_Value = INT(name=u'UPHFiltering-Value', mode=MODE_TYPE)
    UPHFiltering_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< UPH-Filtering-Measurement-Forwarding-Request >-----#
    UPH_Filtering_Measurement_Forwarding_Request = ENUM(name=u'UPH-Filtering-Measurement-Forwarding-Request', mode=MODE_TYPE)
    UPH_Filtering_Measurement_Forwarding_Request._cont = ASN1Dict([(u'requested', 0), (u'notRequested', 1)])
    UPH_Filtering_Measurement_Forwarding_Request._ext = None
    
    #-----< UE-SupportIndicatorExtension >-----#
    UE_SupportIndicatorExtension = BIT_STR(name=u'UE-SupportIndicatorExtension', mode=MODE_TYPE)
    UE_SupportIndicatorExtension._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< UE-State >-----#
    UE_State = CHOICE(name=u'UE-State', mode=MODE_TYPE)
    _UE_State_cell_fach_pch = SEQ(name=u'cell-fach-pch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Fach-Pch-State')))
    _UE_State_ura_pch = SEQ(name=u'ura-pch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Ura-Pch-State')))
    UE_State._cont = ASN1Dict([
        (u'cell-fach-pch', _UE_State_cell_fach_pch),
        (u'ura-pch', _UE_State_ura_pch),
        ])
    UE_State._ext = []
    
    #-----< UE-transmission-power-headroom-Value >-----#
    UE_transmission_power_headroom_Value = INT(name=u'UE-transmission-power-headroom-Value', mode=MODE_TYPE)
    UE_transmission_power_headroom_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< Cell-Fach-Pch-State >-----#
    Cell_Fach_Pch_State = SEQ(name=u'Cell-Fach-Pch-State', mode=MODE_TYPE)
    _Cell_Fach_Pch_State_d_RNTI = INT(name=u'd-RNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _Cell_Fach_Pch_State_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Fach_Pch_State_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Fach_Pch_State_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_Fach_Pch_State_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_Fach_Pch_State_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Fach_Pch_State_iE_Extensions__item__id._const_tab = ____Cell_Fach_Pch_State_iE_Extensions__item__id_tab
    ___Cell_Fach_Pch_State_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Fach_Pch_State_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_Fach_Pch_State_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_Fach_Pch_State_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_Fach_Pch_State_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Fach_Pch_State_iE_Extensions__item__criticality._const_tab = ____Cell_Fach_Pch_State_iE_Extensions__item__criticality_tab
    ___Cell_Fach_Pch_State_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_Fach_Pch_State_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_Fach_Pch_State_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_Fach_Pch_State_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_Fach_Pch_State_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Fach_Pch_State_iE_Extensions__item__extensionValue._const_tab = ____Cell_Fach_Pch_State_iE_Extensions__item__extensionValue_tab
    ___Cell_Fach_Pch_State_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_Fach_Pch_State_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_Fach_Pch_State_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_Fach_Pch_State_iE_Extensions__item__id),
        (u'criticality', ___Cell_Fach_Pch_State_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_Fach_Pch_State_iE_Extensions__item__extensionValue),
        ])
    __Cell_Fach_Pch_State_iE_Extensions__item_._ext = None
    _Cell_Fach_Pch_State_iE_Extensions._cont = __Cell_Fach_Pch_State_iE_Extensions__item_
    _Cell_Fach_Pch_State_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Fach_Pch_State._cont = ASN1Dict([
        (u'd-RNTI', _Cell_Fach_Pch_State_d_RNTI),
        (u'iE-Extensions', _Cell_Fach_Pch_State_iE_Extensions),
        ])
    Cell_Fach_Pch_State._ext = []
    
    #-----< Cell-Fach-Pch-State-ExtIEs >-----#
    Cell_Fach_Pch_State_ExtIEs = CLASS(name=u'Cell-Fach-Pch-State-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Cell_Fach_Pch_State_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ura-Pch-State >-----#
    Ura_Pch_State = SEQ(name=u'Ura-Pch-State', mode=MODE_TYPE)
    _Ura_Pch_State_srnc_id = INT(name=u'srnc-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _Ura_Pch_State_ura_id = INT(name=u'ura-id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _Ura_Pch_State_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ura_Pch_State_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Ura_Pch_State_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Ura_Pch_State_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Ura_Pch_State_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____Ura_Pch_State_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _____Ura_Pch_State_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Ura_Pch_State_iE_Extensions__item__id._const_tab = ____Ura_Pch_State_iE_Extensions__item__id_tab
    ___Ura_Pch_State_iE_Extensions__item__id._const_tab_at = None
    ___Ura_Pch_State_iE_Extensions__item__id._const_tab_id = u'id'
    ___Ura_Pch_State_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Ura_Pch_State_iE_Extensions__item__criticality._const_tab = ____Ura_Pch_State_iE_Extensions__item__id_tab
    ___Ura_Pch_State_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Ura_Pch_State_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Ura_Pch_State_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Ura_Pch_State_iE_Extensions__item__extensionValue._const_tab = ____Ura_Pch_State_iE_Extensions__item__id_tab
    ___Ura_Pch_State_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Ura_Pch_State_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Ura_Pch_State_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Ura_Pch_State_iE_Extensions__item__id),
        (u'criticality', ___Ura_Pch_State_iE_Extensions__item__criticality),
        (u'extensionValue', ___Ura_Pch_State_iE_Extensions__item__extensionValue),
        ])
    __Ura_Pch_State_iE_Extensions__item_._ext = None
    _Ura_Pch_State_iE_Extensions._cont = __Ura_Pch_State_iE_Extensions__item_
    _Ura_Pch_State_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ura_Pch_State._cont = ASN1Dict([
        (u'srnc-id', _Ura_Pch_State_srnc_id),
        (u'ura-id', _Ura_Pch_State_ura_id),
        (u'iE-Extensions', _Ura_Pch_State_iE_Extensions),
        ])
    Ura_Pch_State._ext = []
    
    #-----< Ura-Pch-State-ExtIEs >-----#
    Ura_Pch_State_ExtIEs = CLASS(name=u'Ura-Pch-State-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Ura_Pch_State_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    Ura_Pch_State_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _Ura_Pch_State_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-Delta-T2TP >-----#
    UL_Delta_T2TP = INT(name=u'UL-Delta-T2TP', mode=MODE_TYPE)
    UL_Delta_T2TP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=6)], ev=[], er=[])
    
    #-----< UL-DL-mode >-----#
    UL_DL_mode = ENUM(name=u'UL-DL-mode', mode=MODE_TYPE)
    UL_DL_mode._cont = ASN1Dict([(u'ul-only', 0), (u'dl-only', 1), (u'both-ul-and-dl', 2)])
    UL_DL_mode._ext = None
    
    #-----< UL-DPDCHIndicatorEDCH >-----#
    UL_DPDCHIndicatorEDCH = ENUM(name=u'UL-DPDCHIndicatorEDCH', mode=MODE_TYPE)
    UL_DPDCHIndicatorEDCH._cont = ASN1Dict([(u'uL-DPDCH-present', 0), (u'uL-DPDCH-not-present', 1)])
    UL_DPDCHIndicatorEDCH._ext = None
    
    #-----< UL-Timeslot-Information >-----#
    UL_Timeslot_Information = SEQ_OF(name=u'UL-Timeslot-Information', mode=MODE_TYPE)
    _UL_Timeslot_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-InformationItem')))
    UL_Timeslot_Information._cont = _UL_Timeslot_Information__item_
    UL_Timeslot_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationItem >-----#
    UL_Timeslot_InformationItem = SEQ(name=u'UL-Timeslot-InformationItem', mode=MODE_TYPE)
    _UL_Timeslot_InformationItem_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationItem_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _UL_Timeslot_InformationItem_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot_InformationItem_uL_Code_Information = SEQ_OF(name=u'uL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-Information')))
    _UL_Timeslot_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Timeslot_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Timeslot_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationItem_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationItem_iE_Extensions._cont = __UL_Timeslot_InformationItem_iE_Extensions__item_
    _UL_Timeslot_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationItem._cont = ASN1Dict([
        (u'timeSlot', _UL_Timeslot_InformationItem_timeSlot),
        (u'midambleShiftAndBurstType', _UL_Timeslot_InformationItem_midambleShiftAndBurstType),
        (u'tFCI-Presence', _UL_Timeslot_InformationItem_tFCI_Presence),
        (u'uL-Code-Information', _UL_Timeslot_InformationItem_uL_Code_Information),
        (u'iE-Extensions', _UL_Timeslot_InformationItem_iE_Extensions),
        ])
    UL_Timeslot_InformationItem._ext = []
    
    #-----< UL-Timeslot-InformationItem-ExtIEs >-----#
    UL_Timeslot_InformationItem_ExtIEs = CLASS(name=u'UL-Timeslot-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotLCR-Information >-----#
    UL_TimeslotLCR_Information = SEQ_OF(name=u'UL-TimeslotLCR-Information', mode=MODE_TYPE)
    _UL_TimeslotLCR_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotLCR-InformationItem')))
    UL_TimeslotLCR_Information._cont = _UL_TimeslotLCR_Information__item_
    UL_TimeslotLCR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-TimeslotLCR-InformationItem >-----#
    UL_TimeslotLCR_InformationItem = SEQ(name=u'UL-TimeslotLCR-InformationItem', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationItem_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UL_TimeslotLCR_InformationItem_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _UL_TimeslotLCR_InformationItem_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _UL_TimeslotLCR_InformationItem_uL_Code_LCR_InformationList = SEQ_OF(name=u'uL-Code-LCR-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-LCR-Information')))
    _UL_TimeslotLCR_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeslotLCR_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLCCHinformation')))
    ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 611), (u'criticality', u'ignore'), (u'Extension', _____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab = ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab = ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_TimeslotLCR_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeslotLCR_InformationItem_iE_Extensions__item_._ext = None
    _UL_TimeslotLCR_InformationItem_iE_Extensions._cont = __UL_TimeslotLCR_InformationItem_iE_Extensions__item_
    _UL_TimeslotLCR_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeslotLCR_InformationItem._cont = ASN1Dict([
        (u'timeSlotLCR', _UL_TimeslotLCR_InformationItem_timeSlotLCR),
        (u'midambleShiftLCR', _UL_TimeslotLCR_InformationItem_midambleShiftLCR),
        (u'tFCI-Presence', _UL_TimeslotLCR_InformationItem_tFCI_Presence),
        (u'uL-Code-LCR-InformationList', _UL_TimeslotLCR_InformationItem_uL_Code_LCR_InformationList),
        (u'iE-Extensions', _UL_TimeslotLCR_InformationItem_iE_Extensions),
        ])
    UL_TimeslotLCR_InformationItem._ext = []
    
    #-----< UL-TimeslotLCR-InformationItem-ExtIEs >-----#
    UL_TimeslotLCR_InformationItem_ExtIEs = CLASS(name=u'UL-TimeslotLCR-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLCCHinformation')))
    UL_TimeslotLCR_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 611), (u'criticality', u'ignore'), (u'Extension', _UL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PLCCHinformation >-----#
    PLCCHinformation = SEQ(name=u'PLCCHinformation', mode=MODE_TYPE)
    _PLCCHinformation_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')))
    _PLCCHinformation_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _PLCCHinformation_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _PLCCHinformation_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PLCCHsequenceNumber')))
    _PLCCHinformation_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLCCHinformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PLCCHinformation_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PLCCHinformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PLCCHinformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCHinformation_iE_Extensions__item__id._const_tab = ____PLCCHinformation_iE_Extensions__item__id_tab
    ___PLCCHinformation_iE_Extensions__item__id._const_tab_at = None
    ___PLCCHinformation_iE_Extensions__item__id._const_tab_id = u'id'
    ___PLCCHinformation_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PLCCHinformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PLCCHinformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCHinformation_iE_Extensions__item__criticality._const_tab = ____PLCCHinformation_iE_Extensions__item__criticality_tab
    ___PLCCHinformation_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PLCCHinformation_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PLCCHinformation_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PLCCHinformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PLCCHinformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLCCHinformation_iE_Extensions__item__extensionValue._const_tab = ____PLCCHinformation_iE_Extensions__item__extensionValue_tab
    ___PLCCHinformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PLCCHinformation_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PLCCHinformation_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PLCCHinformation_iE_Extensions__item__id),
        (u'criticality', ___PLCCHinformation_iE_Extensions__item__criticality),
        (u'extensionValue', ___PLCCHinformation_iE_Extensions__item__extensionValue),
        ])
    __PLCCHinformation_iE_Extensions__item_._ext = None
    _PLCCHinformation_iE_Extensions._cont = __PLCCHinformation_iE_Extensions__item_
    _PLCCHinformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLCCHinformation._cont = ASN1Dict([
        (u'tDD-ChannelisationCode', _PLCCHinformation_tDD_ChannelisationCode),
        (u'timeSlotLCR', _PLCCHinformation_timeSlotLCR),
        (u'midambleShiftLCR', _PLCCHinformation_midambleShiftLCR),
        (u'sequenceNumber', _PLCCHinformation_sequenceNumber),
        (u'iE-Extensions', _PLCCHinformation_iE_Extensions),
        ])
    PLCCHinformation._ext = []
    
    #-----< PLCCHinformation-ExtIEs >-----#
    PLCCHinformation_ExtIEs = CLASS(name=u'PLCCHinformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PLCCHinformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-Information768 >-----#
    UL_Timeslot_Information768 = SEQ_OF(name=u'UL-Timeslot-Information768', mode=MODE_TYPE)
    _UL_Timeslot_Information768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-InformationItem768')))
    UL_Timeslot_Information768._cont = _UL_Timeslot_Information768__item_
    UL_Timeslot_Information768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationItem768 >-----#
    UL_Timeslot_InformationItem768 = SEQ(name=u'UL-Timeslot-InformationItem768', mode=MODE_TYPE)
    _UL_Timeslot_InformationItem768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationItem768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _UL_Timeslot_InformationItem768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')))
    _UL_Timeslot_InformationItem768_uL_Code_Information768 = SEQ_OF(name=u'uL-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-Information768')))
    _UL_Timeslot_InformationItem768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationItem768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Timeslot_InformationItem768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationItem768_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Timeslot_InformationItem768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Timeslot_InformationItem768_iE_Extensions__item__id),
        (u'criticality', ___UL_Timeslot_InformationItem768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationItem768_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationItem768_iE_Extensions._cont = __UL_Timeslot_InformationItem768_iE_Extensions__item_
    _UL_Timeslot_InformationItem768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationItem768._cont = ASN1Dict([
        (u'timeSlot', _UL_Timeslot_InformationItem768_timeSlot),
        (u'midambleShiftAndBurstType768', _UL_Timeslot_InformationItem768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _UL_Timeslot_InformationItem768_tFCI_Presence),
        (u'uL-Code-Information768', _UL_Timeslot_InformationItem768_uL_Code_Information768),
        (u'iE-Extensions', _UL_Timeslot_InformationItem768_iE_Extensions),
        ])
    UL_Timeslot_InformationItem768._ext = []
    
    #-----< UL-Timeslot-InformationItem768-ExtIEs >-----#
    UL_Timeslot_InformationItem768_ExtIEs = CLASS(name=u'UL-Timeslot-InformationItem768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationItem768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeSlot-ISCP-Info >-----#
    UL_TimeSlot_ISCP_Info = SEQ_OF(name=u'UL-TimeSlot-ISCP-Info', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-InfoItem')))
    UL_TimeSlot_ISCP_Info._cont = _UL_TimeSlot_ISCP_Info__item_
    UL_TimeSlot_ISCP_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-TimeSlot-ISCP-InfoItem >-----#
    UL_TimeSlot_ISCP_InfoItem = SEQ(name=u'UL-TimeSlot-ISCP-InfoItem', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_InfoItem_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_TimeSlot_ISCP_InfoItem_uL_TimeslotISCP = INT(name=u'uL-TimeslotISCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotISCP')))
    _UL_TimeSlot_ISCP_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab = ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab = ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_._ext = None
    _UL_TimeSlot_ISCP_InfoItem_iE_Extensions._cont = __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_
    _UL_TimeSlot_ISCP_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeSlot_ISCP_InfoItem._cont = ASN1Dict([
        (u'timeSlot', _UL_TimeSlot_ISCP_InfoItem_timeSlot),
        (u'uL-TimeslotISCP', _UL_TimeSlot_ISCP_InfoItem_uL_TimeslotISCP),
        (u'iE-Extensions', _UL_TimeSlot_ISCP_InfoItem_iE_Extensions),
        ])
    UL_TimeSlot_ISCP_InfoItem._ext = []
    
    #-----< UL-TimeSlot-ISCP-InfoItem-ExtIEs >-----#
    UL_TimeSlot_ISCP_InfoItem_ExtIEs = CLASS(name=u'UL-TimeSlot-ISCP-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_TimeSlot_ISCP_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TimeSlot-ISCP-LCR-Info >-----#
    UL_TimeSlot_ISCP_LCR_Info = SEQ_OF(name=u'UL-TimeSlot-ISCP-LCR-Info', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_LCR_Info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-LCR-InfoItem')))
    UL_TimeSlot_ISCP_LCR_Info._cont = _UL_TimeSlot_ISCP_LCR_Info__item_
    UL_TimeSlot_ISCP_LCR_Info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-TimeSlot-ISCP-LCR-InfoItem >-----#
    UL_TimeSlot_ISCP_LCR_InfoItem = SEQ(name=u'UL-TimeSlot-ISCP-LCR-InfoItem', mode=MODE_TYPE)
    _UL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UL_TimeSlot_ISCP_LCR_InfoItem_iSCP = INT(name=u'iSCP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-ISCP-Value')))
    _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab = ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab = ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id),
        (u'criticality', ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_._ext = None
    _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions._cont = __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_
    _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeSlot_ISCP_LCR_InfoItem._cont = ASN1Dict([
        (u'timeSlotLCR', _UL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR),
        (u'iSCP', _UL_TimeSlot_ISCP_LCR_InfoItem_iSCP),
        (u'iE-Extensions', _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions),
        ])
    UL_TimeSlot_ISCP_LCR_InfoItem._ext = []
    
    #-----< UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs >-----#
    UL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs = CLASS(name=u'UL-TimeSlot-ISCP-LCR-InfoItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-ISCP-Value >-----#
    UL_Timeslot_ISCP_Value = INT(name=u'UL-Timeslot-ISCP-Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotISCP')))
    
    #-----< UL-Timeslot-ISCP-Value-IncrDecrThres >-----#
    UL_Timeslot_ISCP_Value_IncrDecrThres = INT(name=u'UL-Timeslot-ISCP-Value-IncrDecrThres', mode=MODE_TYPE)
    UL_Timeslot_ISCP_Value_IncrDecrThres._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=126)], ev=None, er=[])
    
    #-----< UL-TimingAdvanceCtrl-LCR >-----#
    UL_TimingAdvanceCtrl_LCR = SEQ(name=u'UL-TimingAdvanceCtrl-LCR', mode=MODE_TYPE)
    _UL_TimingAdvanceCtrl_LCR_sync_UL_codes_bitmap = BIT_STR(name=u'sync-UL-codes-bitmap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_TimingAdvanceCtrl_LCR_sync_UL_codes_bitmap._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UL_TimingAdvanceCtrl_LCR_fPACH_info = SEQ(name=u'fPACH-info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FPACH-Information')))
    _UL_TimingAdvanceCtrl_LCR_prxUpPCHdes = INT(name=u'prxUpPCHdes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_TimingAdvanceCtrl_LCR_prxUpPCHdes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-58)], ev=[], er=[])
    _UL_TimingAdvanceCtrl_LCR_syncUL_procParameter = SEQ(name=u'syncUL-procParameter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SYNC-UL-ProcParameters')))
    _UL_TimingAdvanceCtrl_LCR_mMax = INT(name=u'mMax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_TimingAdvanceCtrl_LCR_mMax._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    UL_TimingAdvanceCtrl_LCR._cont = ASN1Dict([
        (u'sync-UL-codes-bitmap', _UL_TimingAdvanceCtrl_LCR_sync_UL_codes_bitmap),
        (u'fPACH-info', _UL_TimingAdvanceCtrl_LCR_fPACH_info),
        (u'prxUpPCHdes', _UL_TimingAdvanceCtrl_LCR_prxUpPCHdes),
        (u'syncUL-procParameter', _UL_TimingAdvanceCtrl_LCR_syncUL_procParameter),
        (u'mMax', _UL_TimingAdvanceCtrl_LCR_mMax),
        ])
    UL_TimingAdvanceCtrl_LCR._ext = []
    
    #-----< Uplink-Compressed-Mode-Method >-----#
    Uplink_Compressed_Mode_Method = ENUM(name=u'Uplink-Compressed-Mode-Method', mode=MODE_TYPE)
    Uplink_Compressed_Mode_Method._cont = ASN1Dict([(u'sFdiv2', 0), (u'higher-layer-scheduling', 1)])
    Uplink_Compressed_Mode_Method._ext = []
    
    #-----< UL-SIR >-----#
    UL_SIR = INT(name=u'UL-SIR', mode=MODE_TYPE)
    UL_SIR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-82, ub=173)], ev=None, er=[])
    
    #-----< UC-ID >-----#
    UC_ID = SEQ(name=u'UC-ID', mode=MODE_TYPE)
    _UC_ID_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _UC_ID_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _UC_ID_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UC_ID_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UC_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____UC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _____UC_ID_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UC_ID_iE_Extensions__item__id._const_tab = ____UC_ID_iE_Extensions__item__id_tab
    ___UC_ID_iE_Extensions__item__id._const_tab_at = None
    ___UC_ID_iE_Extensions__item__id._const_tab_id = u'id'
    ___UC_ID_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UC_ID_iE_Extensions__item__criticality._const_tab = ____UC_ID_iE_Extensions__item__id_tab
    ___UC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UC_ID_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UC_ID_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UC_ID_iE_Extensions__item__extensionValue._const_tab = ____UC_ID_iE_Extensions__item__id_tab
    ___UC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UC_ID_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UC_ID_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UC_ID_iE_Extensions__item__id),
        (u'criticality', ___UC_ID_iE_Extensions__item__criticality),
        (u'extensionValue', ___UC_ID_iE_Extensions__item__extensionValue),
        ])
    __UC_ID_iE_Extensions__item_._ext = None
    _UC_ID_iE_Extensions._cont = __UC_ID_iE_Extensions__item_
    _UC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UC_ID._cont = ASN1Dict([
        (u'rNC-ID', _UC_ID_rNC_ID),
        (u'c-ID', _UC_ID_c_ID),
        (u'iE-Extensions', _UC_ID_iE_Extensions),
        ])
    UC_ID._ext = []
    
    #-----< UC-ID-ExtIEs >-----#
    UC_ID_ExtIEs = CLASS(name=u'UC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UC_ID_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    UC_ID_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _UC_ID_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCCH-SlotFormat >-----#
    UL_DPCCH_SlotFormat = INT(name=u'UL-DPCCH-SlotFormat', mode=MODE_TYPE)
    UL_DPCCH_SlotFormat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=[], er=[])
    
    #-----< UL-FP-Mode >-----#
    UL_FP_Mode = ENUM(name=u'UL-FP-Mode', mode=MODE_TYPE)
    UL_FP_Mode._cont = ASN1Dict([(u'normal', 0), (u'silent', 1)])
    UL_FP_Mode._ext = []
    
    #-----< UL-PhysCH-SF-Variation >-----#
    UL_PhysCH_SF_Variation = ENUM(name=u'UL-PhysCH-SF-Variation', mode=MODE_TYPE)
    UL_PhysCH_SF_Variation._cont = ASN1Dict([(u'sf-variation-supported', 0), (u'sf-variation-not-supported', 1)])
    UL_PhysCH_SF_Variation._ext = None
    
    #-----< UL-ScramblingCode >-----#
    UL_ScramblingCode = SEQ(name=u'UL-ScramblingCode', mode=MODE_TYPE)
    _UL_ScramblingCode_ul_ScramblingCodeNumber = INT(name=u'ul-ScramblingCodeNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-ScramblingCodeNumber')))
    _UL_ScramblingCode_ul_ScramblingCodeLength = ENUM(name=u'ul-ScramblingCodeLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-ScramblingCodeLength')))
    _UL_ScramblingCode_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_ScramblingCode_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_ScramblingCode_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_ScramblingCode_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_ScramblingCode_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_ScramblingCode_iE_Extensions__item__id._const_tab = ____UL_ScramblingCode_iE_Extensions__item__id_tab
    ___UL_ScramblingCode_iE_Extensions__item__id._const_tab_at = None
    ___UL_ScramblingCode_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_ScramblingCode_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_ScramblingCode_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_ScramblingCode_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_ScramblingCode_iE_Extensions__item__criticality._const_tab = ____UL_ScramblingCode_iE_Extensions__item__criticality_tab
    ___UL_ScramblingCode_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_ScramblingCode_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue._const_tab = ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_ScramblingCode_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_ScramblingCode_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_ScramblingCode_iE_Extensions__item__id),
        (u'criticality', ___UL_ScramblingCode_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_ScramblingCode_iE_Extensions__item__extensionValue),
        ])
    __UL_ScramblingCode_iE_Extensions__item_._ext = None
    _UL_ScramblingCode_iE_Extensions._cont = __UL_ScramblingCode_iE_Extensions__item_
    _UL_ScramblingCode_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_ScramblingCode._cont = ASN1Dict([
        (u'ul-ScramblingCodeNumber', _UL_ScramblingCode_ul_ScramblingCodeNumber),
        (u'ul-ScramblingCodeLength', _UL_ScramblingCode_ul_ScramblingCodeLength),
        (u'iE-Extensions', _UL_ScramblingCode_iE_Extensions),
        ])
    UL_ScramblingCode._ext = None
    
    #-----< UL-ScramblingCode-ExtIEs >-----#
    UL_ScramblingCode_ExtIEs = CLASS(name=u'UL-ScramblingCode-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_ScramblingCode_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-ScramblingCodeLength >-----#
    UL_ScramblingCodeLength = ENUM(name=u'UL-ScramblingCodeLength', mode=MODE_TYPE)
    UL_ScramblingCodeLength._cont = ASN1Dict([(u'short', 0), (u'long', 1)])
    UL_ScramblingCodeLength._ext = None
    
    #-----< UL-ScramblingCodeNumber >-----#
    UL_ScramblingCodeNumber = INT(name=u'UL-ScramblingCodeNumber', mode=MODE_TYPE)
    UL_ScramblingCodeNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< UL-Synchronisation-Parameters-LCR >-----#
    UL_Synchronisation_Parameters_LCR = SEQ(name=u'UL-Synchronisation-Parameters-LCR', mode=MODE_TYPE)
    _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_StepSize = INT(name=u'uL-Synchronisation-StepSize', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-StepSize')))
    _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_Frequency = INT(name=u'uL-Synchronisation-Frequency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Frequency')))
    _UL_Synchronisation_Parameters_LCR_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id._const_tab = ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id._const_tab_at = None
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality._const_tab = ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab = ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id),
        (u'criticality', ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue),
        ])
    __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_._ext = None
    _UL_Synchronisation_Parameters_LCR_iE_Extensions._cont = __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_
    _UL_Synchronisation_Parameters_LCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Synchronisation_Parameters_LCR._cont = ASN1Dict([
        (u'uL-Synchronisation-StepSize', _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_StepSize),
        (u'uL-Synchronisation-Frequency', _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_Frequency),
        (u'iE-Extensions', _UL_Synchronisation_Parameters_LCR_iE_Extensions),
        ])
    UL_Synchronisation_Parameters_LCR._ext = []
    
    #-----< UL-Synchronisation-Parameters-LCR-ExtIEs >-----#
    UL_Synchronisation_Parameters_LCR_ExtIEs = CLASS(name=u'UL-Synchronisation-Parameters-LCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Synchronisation_Parameters_LCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Synchronisation-StepSize >-----#
    UL_Synchronisation_StepSize = INT(name=u'UL-Synchronisation-StepSize', mode=MODE_TYPE)
    UL_Synchronisation_StepSize._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UL-Synchronisation-Frequency >-----#
    UL_Synchronisation_Frequency = INT(name=u'UL-Synchronisation-Frequency', mode=MODE_TYPE)
    UL_Synchronisation_Frequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< UL-TimeslotISCP >-----#
    UL_TimeslotISCP = INT(name=u'UL-TimeslotISCP', mode=MODE_TYPE)
    UL_TimeslotISCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< UPPCHPositionLCR >-----#
    UPPCHPositionLCR = INT(name=u'UPPCHPositionLCR', mode=MODE_TYPE)
    UPPCHPositionLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< UpPTSInterferenceValue >-----#
    UpPTSInterferenceValue = INT(name=u'UpPTSInterferenceValue', mode=MODE_TYPE)
    UpPTSInterferenceValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< Unidirectional-DCH-Indicator >-----#
    Unidirectional_DCH_Indicator = ENUM(name=u'Unidirectional-DCH-Indicator', mode=MODE_TYPE)
    Unidirectional_DCH_Indicator._cont = ASN1Dict([(u'downlink-DCH-only', 0), (u'uplink-DCH-only', 1)])
    Unidirectional_DCH_Indicator._ext = None
    
    #-----< URA-ID >-----#
    URA_ID = INT(name=u'URA-ID', mode=MODE_TYPE)
    URA_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< URA-Information >-----#
    URA_Information = SEQ(name=u'URA-Information', mode=MODE_TYPE)
    _URA_Information_uRA_ID = INT(name=u'uRA-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _URA_Information_multipleURAsIndicator = ENUM(name=u'multipleURAsIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MultipleURAsIndicator')))
    _URA_Information_rNCsWithCellsInTheAccessedURA_List = SEQ_OF(name=u'rNCsWithCellsInTheAccessedURA-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNCsWithCellsInTheAccessedURA-List')), opt=True)
    _URA_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __URA_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___URA_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____URA_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____URA_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___URA_Information_iE_Extensions__item__id._const_tab = ____URA_Information_iE_Extensions__item__id_tab
    ___URA_Information_iE_Extensions__item__id._const_tab_at = None
    ___URA_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___URA_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____URA_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____URA_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___URA_Information_iE_Extensions__item__criticality._const_tab = ____URA_Information_iE_Extensions__item__criticality_tab
    ___URA_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___URA_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___URA_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____URA_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____URA_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___URA_Information_iE_Extensions__item__extensionValue._const_tab = ____URA_Information_iE_Extensions__item__extensionValue_tab
    ___URA_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___URA_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __URA_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___URA_Information_iE_Extensions__item__id),
        (u'criticality', ___URA_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___URA_Information_iE_Extensions__item__extensionValue),
        ])
    __URA_Information_iE_Extensions__item_._ext = None
    _URA_Information_iE_Extensions._cont = __URA_Information_iE_Extensions__item_
    _URA_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    URA_Information._cont = ASN1Dict([
        (u'uRA-ID', _URA_Information_uRA_ID),
        (u'multipleURAsIndicator', _URA_Information_multipleURAsIndicator),
        (u'rNCsWithCellsInTheAccessedURA-List', _URA_Information_rNCsWithCellsInTheAccessedURA_List),
        (u'iE-Extensions', _URA_Information_iE_Extensions),
        ])
    URA_Information._ext = []
    
    #-----< URA-Information-ExtIEs >-----#
    URA_Information_ExtIEs = CLASS(name=u'URA-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    URA_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RNCsWithCellsInTheAccessedURA-List >-----#
    RNCsWithCellsInTheAccessedURA_List = SEQ_OF(name=u'RNCsWithCellsInTheAccessedURA-List', mode=MODE_TYPE)
    _RNCsWithCellsInTheAccessedURA_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNCsWithCellsInTheAccessedURA-Item')))
    RNCsWithCellsInTheAccessedURA_List._cont = _RNCsWithCellsInTheAccessedURA_List__item_
    RNCsWithCellsInTheAccessedURA_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RNCsWithCellsInTheAccessedURA-Item >-----#
    RNCsWithCellsInTheAccessedURA_Item = SEQ(name=u'RNCsWithCellsInTheAccessedURA-Item', mode=MODE_TYPE)
    _RNCsWithCellsInTheAccessedURA_Item_rNC_ID = INT(name=u'rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _RNCsWithCellsInTheAccessedURA_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id._const_tab = ____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id._const_tab_at = None
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__criticality._const_tab = ____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__extensionValue._const_tab = ____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id),
        (u'criticality', ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__extensionValue),
        ])
    __RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item_._ext = None
    _RNCsWithCellsInTheAccessedURA_Item_iE_Extensions._cont = __RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item_
    _RNCsWithCellsInTheAccessedURA_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNCsWithCellsInTheAccessedURA_Item._cont = ASN1Dict([
        (u'rNC-ID', _RNCsWithCellsInTheAccessedURA_Item_rNC_ID),
        (u'iE-Extensions', _RNCsWithCellsInTheAccessedURA_Item_iE_Extensions),
        ])
    RNCsWithCellsInTheAccessedURA_Item._ext = []
    
    #-----< RNCsWithCellsInTheAccessedURA-Item-ExtIEs >-----#
    RNCsWithCellsInTheAccessedURA_Item_ExtIEs = CLASS(name=u'RNCsWithCellsInTheAccessedURA-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RNCsWithCellsInTheAccessedURA_Item_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    RNCsWithCellsInTheAccessedURA_Item_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _RNCsWithCellsInTheAccessedURA_Item_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< USCH-ID >-----#
    USCH_ID = INT(name=u'USCH-ID', mode=MODE_TYPE)
    USCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< USCH-Information >-----#
    USCH_Information = SEQ_OF(name=u'USCH-Information', mode=MODE_TYPE)
    _USCH_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'USCH-InformationItem')))
    USCH_Information._cont = _USCH_Information__item_
    USCH_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< USCH-InformationItem >-----#
    USCH_InformationItem = SEQ(name=u'USCH-InformationItem', mode=MODE_TYPE)
    _USCH_InformationItem_uSCH_ID = INT(name=u'uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCH_InformationItem_ul_CCTrCH_ID = INT(name=u'ul-CCTrCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _USCH_InformationItem_trChSourceStatisticsDescriptor = ENUM(name=u'trChSourceStatisticsDescriptor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')))
    _USCH_InformationItem_transportFormatSet = SEQ(name=u'transportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')))
    _USCH_InformationItem_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')))
    _USCH_InformationItem_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')))
    _USCH_InformationItem_rb_Info = SEQ_OF(name=u'rb-Info', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RB-Info')))
    _USCH_InformationItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCH_InformationItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCH_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____USCH_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___USCH_InformationItem_iE_Extensions__item__id._const_tab = ____USCH_InformationItem_iE_Extensions__item__id_tab
    ___USCH_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___USCH_InformationItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCH_InformationItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___USCH_InformationItem_iE_Extensions__item__criticality._const_tab = ____USCH_InformationItem_iE_Extensions__item__id_tab
    ___USCH_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCH_InformationItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCH_InformationItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___USCH_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____USCH_InformationItem_iE_Extensions__item__id_tab
    ___USCH_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCH_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCH_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCH_InformationItem_iE_Extensions__item__id),
        (u'criticality', ___USCH_InformationItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCH_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __USCH_InformationItem_iE_Extensions__item_._ext = None
    _USCH_InformationItem_iE_Extensions._cont = __USCH_InformationItem_iE_Extensions__item_
    _USCH_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_InformationItem._cont = ASN1Dict([
        (u'uSCH-ID', _USCH_InformationItem_uSCH_ID),
        (u'ul-CCTrCH-ID', _USCH_InformationItem_ul_CCTrCH_ID),
        (u'trChSourceStatisticsDescriptor', _USCH_InformationItem_trChSourceStatisticsDescriptor),
        (u'transportFormatSet', _USCH_InformationItem_transportFormatSet),
        (u'allocationRetentionPriority', _USCH_InformationItem_allocationRetentionPriority),
        (u'schedulingPriorityIndicator', _USCH_InformationItem_schedulingPriorityIndicator),
        (u'rb-Info', _USCH_InformationItem_rb_Info),
        (u'iE-Extensions', _USCH_InformationItem_iE_Extensions),
        ])
    USCH_InformationItem._ext = []
    
    #-----< USCH-InformationItem-ExtIEs >-----#
    USCH_InformationItem_ExtIEs = CLASS(name=u'USCH-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _USCH_InformationItem_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _USCH_InformationItem_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _USCH_InformationItem_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _USCH_InformationItem_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    USCH_InformationItem_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _USCH_InformationItem_ExtIEs_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _USCH_InformationItem_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _USCH_InformationItem_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _USCH_InformationItem_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Usefulness-Of-Battery-Optimization >-----#
    Usefulness_Of_Battery_Optimization = ENUM(name=u'Usefulness-Of-Battery-Optimization', mode=MODE_TYPE)
    Usefulness_Of_Battery_Optimization._cont = ASN1Dict([(u'can-benefit', 0), (u'cannot-benefit', 1)])
    Usefulness_Of_Battery_Optimization._ext = None
    
    #-----< User-Plane-Congestion-Fields-Inclusion >-----#
    User_Plane_Congestion_Fields_Inclusion = ENUM(name=u'User-Plane-Congestion-Fields-Inclusion', mode=MODE_TYPE)
    User_Plane_Congestion_Fields_Inclusion._cont = ASN1Dict([(u'shall-be-included', 0)])
    User_Plane_Congestion_Fields_Inclusion._ext = None
    
    #-----< Uu-ActivationState >-----#
    Uu_ActivationState = ENUM(name=u'Uu-ActivationState', mode=MODE_TYPE)
    Uu_ActivationState._cont = ASN1Dict([(u'activated', 0), (u'de-activated', 1), (u'changeRequest', 2)])
    Uu_ActivationState._ext = [u'changeRequest']
    
    #-----< UMTS-Cells-Info-List >-----#
    UMTS_Cells_Info_List = SEQ_OF(name=u'UMTS-Cells-Info-List', mode=MODE_TYPE)
    _UMTS_Cells_Info_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UMTS_Cells_Info_List__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UMTS_Cells_Info_List__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UMTS_Cells_Info_List__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UMTS-Cell-Info')))
    ___UMTS_Cells_Info_List__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 898), (u'criticality', u'ignore'), (u'Value', ____UMTS_Cells_Info_List__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __UMTS_Cells_Info_List__item__id._const_tab = ___UMTS_Cells_Info_List__item__id_tab
    __UMTS_Cells_Info_List__item__id._const_tab_at = None
    __UMTS_Cells_Info_List__item__id._const_tab_id = u'id'
    __UMTS_Cells_Info_List__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UMTS_Cells_Info_List__item__criticality._const_tab = ___UMTS_Cells_Info_List__item__id_tab
    __UMTS_Cells_Info_List__item__criticality._const_tab_at = ('..', u'id')
    __UMTS_Cells_Info_List__item__criticality._const_tab_id = u'criticality'
    __UMTS_Cells_Info_List__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UMTS_Cells_Info_List__item__value._const_tab = ___UMTS_Cells_Info_List__item__id_tab
    __UMTS_Cells_Info_List__item__value._const_tab_at = ('..', u'id')
    __UMTS_Cells_Info_List__item__value._const_tab_id = u'Value'
    _UMTS_Cells_Info_List__item_._cont = ASN1Dict([
        (u'id', __UMTS_Cells_Info_List__item__id),
        (u'criticality', __UMTS_Cells_Info_List__item__criticality),
        (u'value', __UMTS_Cells_Info_List__item__value),
        ])
    _UMTS_Cells_Info_List__item_._ext = None
    UMTS_Cells_Info_List._cont = _UMTS_Cells_Info_List__item_
    UMTS_Cells_Info_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65536)], ev=None, er=[])
    
    #-----< UMTS-Cells-Info-IEs >-----#
    UMTS_Cells_Info_IEs = CLASS(name=u'UMTS-Cells-Info-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UMTS_Cells_Info_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UMTS-Cell-Info')))
    UMTS_Cells_Info_IEs._val = ASN1Set(rv=[dict([(u'id', 898), (u'criticality', u'ignore'), (u'Value', _UMTS_Cells_Info_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< UMTS-Cell-Info >-----#
    UMTS_Cell_Info = SEQ(name=u'UMTS-Cell-Info', mode=MODE_TYPE)
    _UMTS_Cell_Info_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _UMTS_Cell_Info_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UMTS_Cell_Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UMTS_Cell_Info_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UMTS_Cell_Info_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UMTS_Cell_Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UMTS_Cell_Info_iE_Extensions__item__id._const_tab = ____UMTS_Cell_Info_iE_Extensions__item__id_tab
    ___UMTS_Cell_Info_iE_Extensions__item__id._const_tab_at = None
    ___UMTS_Cell_Info_iE_Extensions__item__id._const_tab_id = u'id'
    ___UMTS_Cell_Info_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UMTS_Cell_Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UMTS_Cell_Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UMTS_Cell_Info_iE_Extensions__item__criticality._const_tab = ____UMTS_Cell_Info_iE_Extensions__item__criticality_tab
    ___UMTS_Cell_Info_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UMTS_Cell_Info_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UMTS_Cell_Info_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UMTS_Cell_Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UMTS_Cell_Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UMTS_Cell_Info_iE_Extensions__item__extensionValue._const_tab = ____UMTS_Cell_Info_iE_Extensions__item__extensionValue_tab
    ___UMTS_Cell_Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UMTS_Cell_Info_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UMTS_Cell_Info_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UMTS_Cell_Info_iE_Extensions__item__id),
        (u'criticality', ___UMTS_Cell_Info_iE_Extensions__item__criticality),
        (u'extensionValue', ___UMTS_Cell_Info_iE_Extensions__item__extensionValue),
        ])
    __UMTS_Cell_Info_iE_Extensions__item_._ext = None
    _UMTS_Cell_Info_iE_Extensions._cont = __UMTS_Cell_Info_iE_Extensions__item_
    _UMTS_Cell_Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UMTS_Cell_Info._cont = ASN1Dict([
        (u'c-ID', _UMTS_Cell_Info_c_ID),
        (u'iE-Extensions', _UMTS_Cell_Info_iE_Extensions),
        ])
    UMTS_Cell_Info._ext = []
    
    #-----< UMTS-Cell-Info-ExtIEs >-----#
    UMTS_Cell_Info_ExtIEs = CLASS(name=u'UMTS-Cell-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UMTS_Cell_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information >-----#
    UL_CLTD_Information = SEQ(name=u'UL-CLTD-Information', mode=MODE_TYPE)
    _UL_CLTD_Information_sDPCCH_PowerOffsetInformation = INT(name=u'sDPCCH-PowerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SDPCCH-PowerOffsetInformation')))
    _UL_CLTD_Information_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')), opt=True)
    _UL_CLTD_Information_uL_CLTD_Activation_Information = ENUM(name=u'uL-CLTD-Activation-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Activation-Information')), opt=True)
    _UL_CLTD_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CLTD_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CLTD_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CLTD_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_iE_Extensions__item__id._const_tab = ____UL_CLTD_Information_iE_Extensions__item__id_tab
    ___UL_CLTD_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_CLTD_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CLTD_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CLTD_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_iE_Extensions__item__criticality._const_tab = ____UL_CLTD_Information_iE_Extensions__item__criticality_tab
    ___UL_CLTD_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CLTD_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CLTD_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CLTD_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CLTD_Information_iE_Extensions__item__id),
        (u'criticality', ___UL_CLTD_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CLTD_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_CLTD_Information_iE_Extensions__item_._ext = None
    _UL_CLTD_Information_iE_Extensions._cont = __UL_CLTD_Information_iE_Extensions__item_
    _UL_CLTD_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CLTD_Information._cont = ASN1Dict([
        (u'sDPCCH-PowerOffsetInformation', _UL_CLTD_Information_sDPCCH_PowerOffsetInformation),
        (u'c-ID', _UL_CLTD_Information_c_ID),
        (u'uL-CLTD-Activation-Information', _UL_CLTD_Information_uL_CLTD_Activation_Information),
        (u'iE-Extensions', _UL_CLTD_Information_iE_Extensions),
        ])
    UL_CLTD_Information._ext = []
    
    #-----< UL-CLTD-Info-ExtIEs >-----#
    UL_CLTD_Info_ExtIEs = CLASS(name=u'UL-CLTD-Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CLTD_Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information-Reconf >-----#
    UL_CLTD_Information_Reconf = SEQ(name=u'UL-CLTD-Information-Reconf', mode=MODE_TYPE)
    _UL_CLTD_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD')))
    _UL_CLTD_Information_Reconf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CLTD_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id._const_tab = ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CLTD_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CLTD_Information_Reconf_iE_Extensions__item__id),
        (u'criticality', ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __UL_CLTD_Information_Reconf_iE_Extensions__item_._ext = None
    _UL_CLTD_Information_Reconf_iE_Extensions._cont = __UL_CLTD_Information_Reconf_iE_Extensions__item_
    _UL_CLTD_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CLTD_Information_Reconf._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-UL-CLTD', _UL_CLTD_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD),
        (u'iE-Extensions', _UL_CLTD_Information_Reconf_iE_Extensions),
        ])
    UL_CLTD_Information_Reconf._ext = []
    
    #-----< UL-CLTD-Information-Reconf-ExtIEs >-----#
    UL_CLTD_Information_Reconf_ExtIEs = CLASS(name=u'UL-CLTD-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CLTD_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information-To-Modify >-----#
    UL_CLTD_Information_To_Modify = SEQ(name=u'UL-CLTD-Information-To-Modify', mode=MODE_TYPE)
    _UL_CLTD_Information_To_Modify_sDPCCH_PowerOffsetInformation = INT(name=u'sDPCCH-PowerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SDPCCH-PowerOffsetInformation')), opt=True)
    _UL_CLTD_Information_To_Modify_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')), opt=True)
    _UL_CLTD_Information_To_Modify_uL_CLTD_Activation_Information = ENUM(name=u'uL-CLTD-Activation-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Activation-Information')), opt=True)
    _UL_CLTD_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CLTD_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id._const_tab = ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CLTD_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __UL_CLTD_Information_To_Modify_iE_Extensions__item_._ext = None
    _UL_CLTD_Information_To_Modify_iE_Extensions._cont = __UL_CLTD_Information_To_Modify_iE_Extensions__item_
    _UL_CLTD_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CLTD_Information_To_Modify._cont = ASN1Dict([
        (u'sDPCCH-PowerOffsetInformation', _UL_CLTD_Information_To_Modify_sDPCCH_PowerOffsetInformation),
        (u'c-ID', _UL_CLTD_Information_To_Modify_c_ID),
        (u'uL-CLTD-Activation-Information', _UL_CLTD_Information_To_Modify_uL_CLTD_Activation_Information),
        (u'iE-Extensions', _UL_CLTD_Information_To_Modify_iE_Extensions),
        ])
    UL_CLTD_Information_To_Modify._ext = []
    
    #-----< UL-CLTD-Information-To-Modify-ExtIEs >-----#
    UL_CLTD_Information_To_Modify_ExtIEs = CLASS(name=u'UL-CLTD-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CLTD_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Information-Removal >-----#
    UL_CLTD_Information_Removal = ENUM(name=u'UL-CLTD-Information-Removal', mode=MODE_TYPE)
    UL_CLTD_Information_Removal._cont = ASN1Dict([(u'remove', 0)])
    UL_CLTD_Information_Removal._ext = []
    
    #-----< UL-CLTD-State-Update-Information >-----#
    UL_CLTD_State_Update_Information = ENUM(name=u'UL-CLTD-State-Update-Information', mode=MODE_TYPE)
    UL_CLTD_State_Update_Information._cont = ASN1Dict([(u'activate', 0), (u'de-activate', 1)])
    UL_CLTD_State_Update_Information._ext = []
    
    #-----< UL-DPCCH2-Information >-----#
    UL_DPCCH2_Information = SEQ(name=u'UL-DPCCH2-Information', mode=MODE_TYPE)
    _UL_DPCCH2_Information_f_DPCH_Info = SEQ(name=u'f-DPCH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-Info')))
    _UL_DPCCH2_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCCH2_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCCH2_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCCH2_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_iE_Extensions__item__id._const_tab = ____UL_DPCCH2_Information_iE_Extensions__item__id_tab
    ___UL_DPCCH2_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCCH2_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality._const_tab = ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCCH2_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCCH2_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCCH2_Information_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCCH2_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCCH2_Information_iE_Extensions__item_._ext = None
    _UL_DPCCH2_Information_iE_Extensions._cont = __UL_DPCCH2_Information_iE_Extensions__item_
    _UL_DPCCH2_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCCH2_Information._cont = ASN1Dict([
        (u'f-DPCH-Info', _UL_DPCCH2_Information_f_DPCH_Info),
        (u'iE-Extensions', _UL_DPCCH2_Information_iE_Extensions),
        ])
    UL_DPCCH2_Information._ext = []
    
    #-----< UL-DPCCH2-Information-ExtIEs >-----#
    UL_DPCCH2_Information_ExtIEs = CLASS(name=u'UL-DPCCH2-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCCH2_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCCH2-Information-Reconf >-----#
    UL_DPCCH2_Information_Reconf = SEQ(name=u'UL-DPCCH2-Information-Reconf', mode=MODE_TYPE)
    _UL_DPCCH2_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2 = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2')))
    _UL_DPCCH2_Information_Reconf_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCCH2_Information_Reconf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id._const_tab = ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality._const_tab = ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCCH2_Information_Reconf_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCCH2_Information_Reconf_iE_Extensions__item_._ext = None
    _UL_DPCCH2_Information_Reconf_iE_Extensions._cont = __UL_DPCCH2_Information_Reconf_iE_Extensions__item_
    _UL_DPCCH2_Information_Reconf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCCH2_Information_Reconf._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-UL-DPCCH2', _UL_DPCCH2_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2),
        (u'iE-Extensions', _UL_DPCCH2_Information_Reconf_iE_Extensions),
        ])
    UL_DPCCH2_Information_Reconf._ext = []
    
    #-----< UL-DPCCH2-Information-Reconf-ExtIEs >-----#
    UL_DPCCH2_Information_Reconf_ExtIEs = CLASS(name=u'UL-DPCCH2-Information-Reconf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCCH2_Information_Reconf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCCH2-Information-Removal >-----#
    UL_DPCCH2_Information_Removal = ENUM(name=u'UL-DPCCH2-Information-Removal', mode=MODE_TYPE)
    UL_DPCCH2_Information_Removal._cont = ASN1Dict([(u'remove', 0)])
    UL_DPCCH2_Information_Removal._ext = []
    
    #-----< UL-DPCCH2-Information-To-Modify >-----#
    UL_DPCCH2_Information_To_Modify = SEQ(name=u'UL-DPCCH2-Information-To-Modify', mode=MODE_TYPE)
    _UL_DPCCH2_Information_To_Modify_f_DPCH_Info = SEQ(name=u'f-DPCH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-Info-To-Modify')), opt=True)
    _UL_DPCCH2_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id._const_tab = ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_._ext = None
    _UL_DPCCH2_Information_To_Modify_iE_Extensions._cont = __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_
    _UL_DPCCH2_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCCH2_Information_To_Modify._cont = ASN1Dict([
        (u'f-DPCH-Info', _UL_DPCCH2_Information_To_Modify_f_DPCH_Info),
        (u'iE-Extensions', _UL_DPCCH2_Information_To_Modify_iE_Extensions),
        ])
    UL_DPCCH2_Information_To_Modify._ext = []
    
    #-----< UL-DPCCH2-Information-To-Modify-ExtIEs >-----#
    UL_DPCCH2_Information_To_Modify_ExtIEs = CLASS(name=u'UL-DPCCH2-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCCH2_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-CLTD-Activation-Information >-----#
    UL_CLTD_Activation_Information = ENUM(name=u'UL-CLTD-Activation-Information', mode=MODE_TYPE)
    UL_CLTD_Activation_Information._cont = ASN1Dict([(u'activated', 0), (u'de-activated', 1)])
    UL_CLTD_Activation_Information._ext = []
    
    #-----< UL-MIMO-Information >-----#
    UL_MIMO_Information = SEQ(name=u'UL-MIMO-Information', mode=MODE_TYPE)
    _UL_MIMO_Information_e_roch_power_offset = INT(name=u'e-roch-power-offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-ROCH-PowerOffset')), opt=True)
    _UL_MIMO_Information_s_e_dpcch_power_offset = INT(name=u's-e-dpcch-power-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'S-E-DPCCH-PowerOffset')))
    _UL_MIMO_Information_interstream_compensation = INT(name=u'interstream-compensation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InterStream-Interference-Compensation')))
    _UL_MIMO_Information_minimum_E_TFCI_rank2 = INT(name=u'minimum-E-TFCI-rank2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_MIMO_Information_minimum_E_TFCI_rank2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UL_MIMO_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_MIMO_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_MIMO_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_MIMO_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_iE_Extensions__item__id._const_tab = ____UL_MIMO_Information_iE_Extensions__item__id_tab
    ___UL_MIMO_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_MIMO_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_MIMO_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_MIMO_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_iE_Extensions__item__criticality._const_tab = ____UL_MIMO_Information_iE_Extensions__item__criticality_tab
    ___UL_MIMO_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_MIMO_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_MIMO_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_MIMO_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_MIMO_Information_iE_Extensions__item__id),
        (u'criticality', ___UL_MIMO_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_MIMO_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_MIMO_Information_iE_Extensions__item_._ext = None
    _UL_MIMO_Information_iE_Extensions._cont = __UL_MIMO_Information_iE_Extensions__item_
    _UL_MIMO_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_MIMO_Information._cont = ASN1Dict([
        (u'e-roch-power-offset', _UL_MIMO_Information_e_roch_power_offset),
        (u's-e-dpcch-power-offset', _UL_MIMO_Information_s_e_dpcch_power_offset),
        (u'interstream-compensation', _UL_MIMO_Information_interstream_compensation),
        (u'minimum-E-TFCI-rank2', _UL_MIMO_Information_minimum_E_TFCI_rank2),
        (u'iE-Extensions', _UL_MIMO_Information_iE_Extensions),
        ])
    UL_MIMO_Information._ext = []
    
    #-----< UL-MIMO-Information-ExtIEs >-----#
    UL_MIMO_Information_ExtIEs = CLASS(name=u'UL-MIMO-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_MIMO_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-MIMO-Information-To-Modify >-----#
    UL_MIMO_Information_To_Modify = SEQ(name=u'UL-MIMO-Information-To-Modify', mode=MODE_TYPE)
    _UL_MIMO_Information_To_Modify_e_roch_power_offset = INT(name=u'e-roch-power-offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-ROCH-PowerOffset')), opt=True)
    _UL_MIMO_Information_To_Modify_s_e_dpcch_power_offset = INT(name=u's-e-dpcch-power-offset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'S-E-DPCCH-PowerOffset')), opt=True)
    _UL_MIMO_Information_To_Modify_interstream_compensation = INT(name=u'interstream-compensation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InterStream-Interference-Compensation')), opt=True)
    _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2 = INT(name=u'minimum-E-TFCI-rank2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UL_MIMO_Information_To_Modify_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_MIMO_Information_To_Modify_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab = ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab_at = None
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab = ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab = ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_MIMO_Information_To_Modify_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id),
        (u'criticality', ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue),
        ])
    __UL_MIMO_Information_To_Modify_iE_Extensions__item_._ext = None
    _UL_MIMO_Information_To_Modify_iE_Extensions._cont = __UL_MIMO_Information_To_Modify_iE_Extensions__item_
    _UL_MIMO_Information_To_Modify_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_MIMO_Information_To_Modify._cont = ASN1Dict([
        (u'e-roch-power-offset', _UL_MIMO_Information_To_Modify_e_roch_power_offset),
        (u's-e-dpcch-power-offset', _UL_MIMO_Information_To_Modify_s_e_dpcch_power_offset),
        (u'interstream-compensation', _UL_MIMO_Information_To_Modify_interstream_compensation),
        (u'minimum-E-TFCI-rank2', _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2),
        (u'iE-Extensions', _UL_MIMO_Information_To_Modify_iE_Extensions),
        ])
    UL_MIMO_Information_To_Modify._ext = []
    
    #-----< UL-MIMO-Information-To-Modify-ExtIEs >-----#
    UL_MIMO_Information_To_Modify_ExtIEs = CLASS(name=u'UL-MIMO-Information-To-Modify-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_MIMO_Information_To_Modify_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-MIMO-Reconfiguration >-----#
    UL_MIMO_Reconfiguration = CHOICE(name=u'UL-MIMO-Reconfiguration', mode=MODE_TYPE)
    _UL_MIMO_Reconfiguration_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information')))
    _UL_MIMO_Reconfiguration_configurationChange = SEQ(name=u'configurationChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Information-To-Modify')))
    _UL_MIMO_Reconfiguration_removal = ENUM(name=u'removal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-MIMO-Removal')))
    UL_MIMO_Reconfiguration._cont = ASN1Dict([
        (u'setup', _UL_MIMO_Reconfiguration_setup),
        (u'configurationChange', _UL_MIMO_Reconfiguration_configurationChange),
        (u'removal', _UL_MIMO_Reconfiguration_removal),
        ])
    UL_MIMO_Reconfiguration._ext = None
    
    #-----< UL-MIMO-Removal >-----#
    UL_MIMO_Removal = ENUM(name=u'UL-MIMO-Removal', mode=MODE_TYPE)
    UL_MIMO_Removal._cont = ASN1Dict([(u'remove', 0)])
    UL_MIMO_Removal._ext = []
    
    #-----< UL-MIMO-DL-Control-Channel-Information >-----#
    UL_MIMO_DL_Control_Channel_Information = SEQ(name=u'UL-MIMO-DL-Control-Channel-Information', mode=MODE_TYPE)
    _UL_MIMO_DL_Control_Channel_Information_e_roch_channelization_code = INT(name=u'e-roch-channelization-code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-ChannelisationCodeNumber')))
    _UL_MIMO_DL_Control_Channel_Information_s_e_rnti = INT(name=u's-e-rnti', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _UL_MIMO_DL_Control_Channel_Information_s_signature_sequence = INT(name=u's-signature-sequence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ERGCH-SignatureSequence')))
    _UL_MIMO_DL_Control_Channel_Information_s_e_roch_release_indicator = ENUM(name=u's-e-roch-release-indicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'S-E-ROCH-Release-Indicator')), opt=True)
    _UL_MIMO_DL_Control_Channel_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab = ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab_at = None
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab = ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab = ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id),
        (u'criticality', ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue),
        ])
    __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_._ext = None
    _UL_MIMO_DL_Control_Channel_Information_iE_Extensions._cont = __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_
    _UL_MIMO_DL_Control_Channel_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_MIMO_DL_Control_Channel_Information._cont = ASN1Dict([
        (u'e-roch-channelization-code', _UL_MIMO_DL_Control_Channel_Information_e_roch_channelization_code),
        (u's-e-rnti', _UL_MIMO_DL_Control_Channel_Information_s_e_rnti),
        (u's-signature-sequence', _UL_MIMO_DL_Control_Channel_Information_s_signature_sequence),
        (u's-e-roch-release-indicator', _UL_MIMO_DL_Control_Channel_Information_s_e_roch_release_indicator),
        (u'iE-Extensions', _UL_MIMO_DL_Control_Channel_Information_iE_Extensions),
        ])
    UL_MIMO_DL_Control_Channel_Information._ext = []
    
    #-----< UL-MIMO-DL-Control-Channel-Information-ExtIEs >-----#
    UL_MIMO_DL_Control_Channel_Information_ExtIEs = CLASS(name=u'UL-MIMO-DL-Control-Channel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_MIMO_DL_Control_Channel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        AccessPointName,
        AckNack_RepetitionFactor,
        Ack_Power_Offset,
        ActivationDelay,
        _Activate_Info_activation_type,
        _Activate_Info_initial_dl_tx_power,
        _Activate_Info_firstRLS_Indicator,
        _Activate_Info_propagation_delay,
        ____Activate_Info_iE_Extensions__item__id_tab,
        _____Activate_Info_iE_Extensions__item__id_tab_val_Extension_0,
        ___Activate_Info_iE_Extensions__item__id,
        ___Activate_Info_iE_Extensions__item__criticality,
        ___Activate_Info_iE_Extensions__item__extensionValue,
        __Activate_Info_iE_Extensions__item_,
        _Activate_Info_iE_Extensions,
        Activate_Info,
        Activate_Info_ExtIEs,
        _Activate_Info_ExtIEs_val_Extension_0,
        _ActivationInformation__item_,
        ActivationInformation,
        _ActivationInformationItem_uU_ActivationState,
        ____ActivationInformationItem_iE_Extensions__item__id_tab,
        ___ActivationInformationItem_iE_Extensions__item__id,
        ____ActivationInformationItem_iE_Extensions__item__criticality_tab,
        ___ActivationInformationItem_iE_Extensions__item__criticality,
        ____ActivationInformationItem_iE_Extensions__item__extensionValue_tab,
        ___ActivationInformationItem_iE_Extensions__item__extensionValue,
        __ActivationInformationItem_iE_Extensions__item_,
        _ActivationInformationItem_iE_Extensions,
        ActivationInformationItem,
        ActivationInformationItem_ExtIEs,
        _Active_MBMS_Bearer_Service_ListFDD__item_,
        Active_MBMS_Bearer_Service_ListFDD,
        _Active_MBMS_Bearer_Service_ListFDD_PFL__item_,
        Active_MBMS_Bearer_Service_ListFDD_PFL,
        _Active_MBMS_Bearer_Service_ListTDD__item_,
        Active_MBMS_Bearer_Service_ListTDD,
        _Active_MBMS_Bearer_Service_ListTDD_PFL__item_,
        Active_MBMS_Bearer_Service_ListTDD_PFL,
        _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN,
        _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__id,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue,
        __Active_Pattern_Sequence_Information_iE_Extensions__item_,
        _Active_Pattern_Sequence_Information_iE_Extensions,
        Active_Pattern_Sequence_Information,
        Active_Pattern_Sequence_Information_ExtIEs,
        _Additional_EDCH_Cell_Information_Response_RLAddList__item_,
        Additional_EDCH_Cell_Information_Response_RLAddList,
        _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_additional_EDCH_FDD_Information_Response,
        _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_additional_EDCH_Serving_Cell_Change_Information_Response_RLAdd,
        ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs,
        Additional_EDCH_Cell_Information_Response_RLAdd_ItemIEs_ExtIEs,
        _Additional_EDCH_Setup_Info_multicell_EDCH_Transport_Bearer_Mode,
        _Additional_EDCH_Setup_Info_additional_EDCH_Cell_Information_Setup,
        ____Additional_EDCH_Setup_Info_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Setup_Info_iE_Extensions__item__id,
        ____Additional_EDCH_Setup_Info_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Setup_Info_iE_Extensions__item__criticality,
        ____Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Setup_Info_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Setup_Info_iE_Extensions__item_,
        _Additional_EDCH_Setup_Info_iE_Extensions,
        Additional_EDCH_Setup_Info,
        Additional_EDCH_Setup_Info_ExtIEs,
        _ANRReportIndication_pLMN_Identity,
        _ANRReportIndication_l3_Information,
        ____ANRReportIndication_iE_Extensions__item__id_tab,
        ___ANRReportIndication_iE_Extensions__item__id,
        ____ANRReportIndication_iE_Extensions__item__criticality_tab,
        ___ANRReportIndication_iE_Extensions__item__criticality,
        ____ANRReportIndication_iE_Extensions__item__extensionValue_tab,
        ___ANRReportIndication_iE_Extensions__item__extensionValue,
        __ANRReportIndication_iE_Extensions__item_,
        _ANRReportIndication_iE_Extensions,
        ANRReportIndication,
        ANRReportIndication_ExtIEs,
        _Additional_EDCH_Cell_Information_Setup__item_,
        Additional_EDCH_Cell_Information_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_UL_DPCH_Information_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_RL_Specific_Information_To_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_FDD_Information,
        _Additional_EDCH_FDD_Setup_Cell_Information_additional_EDCH_F_DPCH_Information_Setup,
        _Additional_EDCH_FDD_Setup_Cell_Information_multicellEDCH_Information,
        ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions__item_,
        _Additional_EDCH_FDD_Setup_Cell_Information_iE_Extensions,
        Additional_EDCH_FDD_Setup_Cell_Information,
        Additional_EDCH_FDD_Setup_Cell_Information_ExtIEs,
        _Additional_EDCH_UL_DPCH_Information_Setup_ul_ScramblingCode,
        _Additional_EDCH_UL_DPCH_Information_Setup_ul_SIR_Target,
        ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id_tab,
        ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__id,
        ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__criticality,
        ____Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item__extensionValue,
        __Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions__item_,
        _Additional_EDCH_UL_DPCH_Information_Setup_iE_Extensions,
        Additional_EDCH_UL_DPCH_Information_Setup,
        Additional_EDCH_UL_DPCH_Information_Setup_ExtIEs,
        _Additional_EDCH_F_DPCH_Information_fdd_TPC_DownlinkStepSize,
        _Additional_EDCH_F_DPCH_Information_limitedPowerIncrease,
        _Additional_EDCH_F_DPCH_Information_innerLoopDLPCStatus,
        _Additional_EDCH_F_DPCH_Information_f_DPCH_SlotFormatSupportRequest,
        ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id_tab,
        ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__id,
        ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__criticality,
        ____Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_F_DPCH_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_F_DPCH_Information_iE_Extensions__item_,
        _Additional_EDCH_F_DPCH_Information_iE_Extensions,
        Additional_EDCH_F_DPCH_Information,
        Additional_EDCH_F_DPCH_Information_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Setup_List__item_,
        Additional_EDCH_RL_Specific_Information_To_Setup_List,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_eDCH_Additional_RL_ID,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_c_ID,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_firstRLS_indicator,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_propagationDelay,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_initialDL_transmissionPower,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_primaryCPICH_EcNo,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_AGCH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_RGCH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_e_HICH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_multicellEDCH_RL_SpecificInformation,
        ____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab,
        _____Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__id,
        ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__criticality,
        ___Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_iE_Extensions,
        Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs,
        Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Setup_ItemIEs_ExtIEs_val_Extension_0,
        _Additional_EDCH_Cell_Information_To_Add_List__item_,
        Additional_EDCH_Cell_Information_To_Add_List,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_UL_DPCH_Information_Setup,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add_List,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_additional_EDCH_FDD_Information,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_multicellEDCH_Information,
        ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_To_Add_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_To_Add_ItemIEs,
        Additional_EDCH_Cell_Information_To_Add_ItemIEs_ExtIEs,
        _Additional_EDCH_UL_DPCH_Information_Addition_ul_SIR_Target,
        ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id_tab,
        ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__id,
        ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__criticality,
        ____Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item__extensionValue,
        __Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions__item_,
        _Additional_EDCH_UL_DPCH_Information_Addition_iE_Extensions,
        Additional_EDCH_UL_DPCH_Information_Addition,
        Additional_EDCH_UL_DPCH_Information_Addition_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Add_List__item_,
        Additional_EDCH_RL_Specific_Information_To_Add_List,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_eDCH_Additional_RL_ID,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_c_ID,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_primaryCPICH_EcNo,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_AGCH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_RGCH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_e_HICH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_multicellEDCH_RL_SpecificInformation,
        ____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab,
        _____Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__id,
        ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__criticality,
        ___Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_iE_Extensions,
        Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs,
        Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Add_ItemIEs_ExtIEs_val_Extension_0,
        _Additional_EDCH_RL_Specific_Information_To_Modify_List__item_,
        Additional_EDCH_RL_Specific_Information_To_Modify_List,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_eDCH_Additional_RL_ID,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_AGCH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_RGCH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_e_HICH_PowerOffset,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_additional_EDCH_MAC_d_Flows_Specific_Info_List,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_multicellEDCH_RL_SpecificInformation,
        ____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab,
        _____Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__id,
        ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__criticality,
        ___Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_iE_Extensions,
        Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs,
        Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs,
        _Additional_EDCH_RL_Specific_Information_To_Modify_ItemIEs_ExtIEs_val_Extension_0,
        _Additional_EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _Additional_EDCH_FDD_Information_e_DCH_Maximum_Bitrate,
        _Additional_EDCH_FDD_Information_e_DCH_Processing_Overload_Level,
        _Additional_EDCH_FDD_Information_e_DCH_Min_Set_E_TFCI,
        ____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____Additional_EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        ___Additional_EDCH_FDD_Information_iE_Extensions__item__id,
        ___Additional_EDCH_FDD_Information_iE_Extensions__item__criticality,
        ___Additional_EDCH_FDD_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Information_iE_Extensions__item_,
        _Additional_EDCH_FDD_Information_iE_Extensions,
        Additional_EDCH_FDD_Information,
        Additional_EDCH_FDD_Information_ExtIEs,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_0,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_1,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_2,
        _Additional_EDCH_FDD_Information_ExtIEs_val_Extension_3,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_List__item_,
        Additional_EDCH_MAC_d_Flows_Specific_Info_List,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_e_DCH_MACdFlow_ID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_bindingID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_transportLayerAddress,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__id,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__criticality,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item__extensionValue,
        __Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions__item_,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_iE_Extensions,
        Additional_EDCH_MAC_d_Flows_Specific_Info,
        Additional_EDCH_MAC_d_Flows_Specific_Info_ExtIEs,
        _Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List__item_,
        Additional_EDCH_MAC_d_Flow_Specific_Information_Response_List,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_e_DCH_MACdFlow_ID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_bindingID,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_transportLayerAddress,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__id,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__criticality,
        ____Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item__extensionValue,
        __Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions__item_,
        _Additional_EDCH_MAC_d_Flows_Specific_Info_Response_iE_Extensions,
        Additional_EDCH_MAC_d_Flows_Specific_Info_Response,
        Additional_EDCH_MAC_d_Flows_Specific_Info_Response_ExtIEs,
        _Additional_EDCH_Cell_Information_Response_List__item_,
        Additional_EDCH_Cell_Information_Response_List,
        _Additional_EDCH_FDD_Information_Response_ItemIEs_eDCH_Additional_RL_Specific_Information_Response,
        ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_FDD_Information_Response_ItemIEs_iE_Extensions,
        Additional_EDCH_FDD_Information_Response_ItemIEs,
        Additional_EDCH_FDD_Information_Response_ItemIEs_ExtIEs,
        _Additional_EDCH_Cell_Information_Response_RLReconf_List__item_,
        Additional_EDCH_Cell_Information_Response_RLReconf_List,
        _Additional_EDCH_FDD_Information_Response_RLReconf_Items_eDCH_Additional_RL_Specific_Information_Response,
        _Additional_EDCH_FDD_Information_Response_RLReconf_Items_eDCH_Additional_RL_Specific_Modified_Information_Response,
        ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions__item_,
        _Additional_EDCH_FDD_Information_Response_RLReconf_Items_iE_Extensions,
        Additional_EDCH_FDD_Information_Response_RLReconf_Items,
        Additional_EDCH_FDD_Information_Response_RLReconf_Items_ExtIEs,
        _Additional_EDCH_Cell_Information_ConfigurationChange_List__item_,
        Additional_EDCH_Cell_Information_ConfigurationChange_List,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_UL_DPCH_Information_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Add,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_RL_Specific_Information_To_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_FDD_Information_To_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_additional_EDCH_F_DPCH_Information_Modify,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_multicellEDCH_Information,
        ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_ConfigurationChange_Info_ItemIEs_iE_Extensions,
        Additional_EDCH_ConfigurationChange_Info_ItemIEs,
        Additional_EDCH_ConfigurationChange_Info_ItemIEs_ExtIEs,
        _Additional_EDCH_UL_DPCH_Information_Modify_ul_ScramblingCode,
        _Additional_EDCH_UL_DPCH_Information_Modify_ul_SIR_Target,
        ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id_tab,
        ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__id,
        ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__criticality,
        ____Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item__extensionValue,
        __Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions__item_,
        _Additional_EDCH_UL_DPCH_Information_Modify_iE_Extensions,
        Additional_EDCH_UL_DPCH_Information_Modify,
        Additional_EDCH_UL_DPCH_Information_Modify_ExtIEs,
        _Additional_EDCH_Cell_Information_Removal_List__item_,
        Additional_EDCH_Cell_Information_Removal_List,
        _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_rL_on_Secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_Removal_Info_ItemIEs,
        Additional_EDCH_Cell_Information_Removal_Info_ItemIEs_ExtIEs,
        RL_on_Secondary_UL_Frequency,
        _Additional_EDCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _Additional_EDCH_FDD_Update_Information_additional_EDCH_DL_Control_Channel_Change_Information,
        ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id_tab,
        ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__id,
        ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__criticality,
        ____Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_FDD_Update_Information_iE_Extensions__item__extensionValue,
        __Additional_EDCH_FDD_Update_Information_iE_Extensions__item_,
        _Additional_EDCH_FDD_Update_Information_iE_Extensions,
        Additional_EDCH_FDD_Update_Information,
        Additional_EDCH_FDD_Update_Information_ExtIEs,
        _Additional_EDCH_DL_Control_Channel_Change_Information_List__item_,
        Additional_EDCH_DL_Control_Channel_Change_Information_List,
        _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_eDCH_Additional_RL_ID,
        ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_iE_Extensions,
        Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs,
        Additional_EDCH_DL_Control_Channel_Change_Info_ItemIEs_ExtIEs,
        _AdditionalPreferredFrequency__item_,
        AdditionalPreferredFrequency,
        _AdditionalPreferredFrequencyItem_dL_UARFCN,
        _AdditionalPreferredFrequencyItem_correspondingCells,
        ____AdditionalPreferredFrequencyItem_iE_Extensions__item__id_tab,
        ___AdditionalPreferredFrequencyItem_iE_Extensions__item__id,
        ____AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality_tab,
        ___AdditionalPreferredFrequencyItem_iE_Extensions__item__criticality,
        ____AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue_tab,
        ___AdditionalPreferredFrequencyItem_iE_Extensions__item__extensionValue,
        __AdditionalPreferredFrequencyItem_iE_Extensions__item_,
        _AdditionalPreferredFrequencyItem_iE_Extensions,
        AdditionalPreferredFrequencyItem,
        AdditionalPreferredFrequencyItem_ExtIEs,
        AdjustmentPeriod,
        _AffectedUEInformationForMBMS__item_,
        AffectedUEInformationForMBMS,
        _AllocationRetentionPriority_priorityLevel,
        _AllocationRetentionPriority_pre_emptionCapability,
        _AllocationRetentionPriority_pre_emptionVulnerability,
        ____AllocationRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationRetentionPriority_iE_Extensions__item__id,
        ____AllocationRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationRetentionPriority_iE_Extensions__item_,
        _AllocationRetentionPriority_iE_Extensions,
        AllocationRetentionPriority,
        AllocationRetentionPriority_ExtIEs,
        _Allowed_Rate_Information_allowed_UL_Rate,
        _Allowed_Rate_Information_allowed_DL_Rate,
        ____Allowed_Rate_Information_iE_Extensions__item__id_tab,
        ___Allowed_Rate_Information_iE_Extensions__item__id,
        ____Allowed_Rate_Information_iE_Extensions__item__criticality_tab,
        ___Allowed_Rate_Information_iE_Extensions__item__criticality,
        ____Allowed_Rate_Information_iE_Extensions__item__extensionValue_tab,
        ___Allowed_Rate_Information_iE_Extensions__item__extensionValue,
        __Allowed_Rate_Information_iE_Extensions__item_,
        _Allowed_Rate_Information_iE_Extensions,
        Allowed_Rate_Information,
        Allowed_Rate_Information_ExtIEs,
        Allowed_Rate,
        AllowedQueuingTime,
        AlphaValue,
        AlternativeFormatReportingIndicator,
        _Angle_Of_Arrival_Value_LCR_aOA_LCR,
        _Angle_Of_Arrival_Value_LCR_aOA_LCR_Accuracy_Class,
        ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id_tab,
        ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__id,
        ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality_tab,
        ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__criticality,
        ____Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue_tab,
        ___Angle_Of_Arrival_Value_LCR_iE_Extensions__item__extensionValue,
        __Angle_Of_Arrival_Value_LCR_iE_Extensions__item_,
        _Angle_Of_Arrival_Value_LCR_iE_Extensions,
        Angle_Of_Arrival_Value_LCR,
        Angle_Of_Arrival_Value_LCR_ExtIEs,
        _ANR_Cell_Information_rNC_ID,
        _ANR_Cell_Information_lAC,
        _ANR_Cell_Information_rAC,
        _ANR_Cell_Information_aNR_FDD_CellInformation,
        _ANR_Cell_Information_aNR_TDD_CellInformation,
        _ANR_Cell_Information_aNR_LCR_TDD_CellInformation,
        _ANR_Cell_Information_extended_RNC_ID,
        ____ANR_Cell_Information_iE_Extensions__item__id_tab,
        ___ANR_Cell_Information_iE_Extensions__item__id,
        ____ANR_Cell_Information_iE_Extensions__item__criticality_tab,
        ___ANR_Cell_Information_iE_Extensions__item__criticality,
        ____ANR_Cell_Information_iE_Extensions__item__extensionValue_tab,
        ___ANR_Cell_Information_iE_Extensions__item__extensionValue,
        __ANR_Cell_Information_iE_Extensions__item_,
        _ANR_Cell_Information_iE_Extensions,
        ANR_Cell_Information,
        ANR_Cell_Information_ExtIEs,
        _ANR_FDD_CellInformation_primaryCPICH_Power,
        _ANR_FDD_CellInformation_txDiversityIndicator,
        _ANR_FDD_CellInformation_sTTD_SupportIndicator,
        _ANR_FDD_CellInformation_closedLoopMode1_SupportIndicator,
        _ANR_FDD_CellInformation_restrictionStateIndicator,
        _ANR_FDD_CellInformation_dpc_ModeChangeSupportIndicator,
        _ANR_FDD_CellInformation_cellCapabilityContainerFDD,
        _ANR_FDD_CellInformation_sNA_Information,
        _ANR_FDD_CellInformation_frequencyBandIndicator,
        _ANR_FDD_CellInformation_max_UE_DTX_Cycle,
        _ANR_FDD_CellInformation_aNR_Multiple_PLMN_List,
        _ANR_FDD_CellInformation_secondaryServingCellList,
        _ANR_FDD_CellInformation_dualBandSecondaryServingCellList,
        _ANR_FDD_CellInformation_cellCapabilityContainerExtensionFDD,
        ____ANR_FDD_CellInformation_iE_Extensions__item__id_tab,
        ___ANR_FDD_CellInformation_iE_Extensions__item__id,
        ____ANR_FDD_CellInformation_iE_Extensions__item__criticality_tab,
        ___ANR_FDD_CellInformation_iE_Extensions__item__criticality,
        ____ANR_FDD_CellInformation_iE_Extensions__item__extensionValue_tab,
        ___ANR_FDD_CellInformation_iE_Extensions__item__extensionValue,
        __ANR_FDD_CellInformation_iE_Extensions__item_,
        _ANR_FDD_CellInformation_iE_Extensions,
        ANR_FDD_CellInformation,
        ANR_FDD_CellInformation_ExtIEs,
        _ANR_TDD_CellInformation_syncCase,
        _ANR_TDD_CellInformation_timeSlot,
        _ANR_TDD_CellInformation_sCH_TimeSlot,
        _ANR_TDD_CellInformation_sCTD_Indicator,
        _ANR_TDD_CellInformation_dPCHConstantValue,
        _ANR_TDD_CellInformation_pCCPCH_Power,
        _ANR_TDD_CellInformation_restrictionStateIndicator,
        _ANR_TDD_CellInformation_cellCapabilityContainerTDD,
        _ANR_TDD_CellInformation_cellCapabilityContainerTDD768,
        _ANR_TDD_CellInformation_sNA_Information,
        _ANR_TDD_CellInformation_aNR_Multiple_PLMN_List,
        ____ANR_TDD_CellInformation_iE_Extensions__item__id_tab,
        ___ANR_TDD_CellInformation_iE_Extensions__item__id,
        ____ANR_TDD_CellInformation_iE_Extensions__item__criticality_tab,
        ___ANR_TDD_CellInformation_iE_Extensions__item__criticality,
        ____ANR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab,
        ___ANR_TDD_CellInformation_iE_Extensions__item__extensionValue,
        __ANR_TDD_CellInformation_iE_Extensions__item_,
        _ANR_TDD_CellInformation_iE_Extensions,
        ANR_TDD_CellInformation,
        ANR_TDD_CellInformation_ExtIEs,
        _ANR_LCR_TDD_CellInformation_sCTD_Indicator,
        _ANR_LCR_TDD_CellInformation_dPCHConstantValue,
        _ANR_LCR_TDD_CellInformation_pCCPCH_Power,
        _ANR_LCR_TDD_CellInformation_restrictionStateIndicator,
        _ANR_LCR_TDD_CellInformation_cellCapabilityContainerTDD_LCR,
        _ANR_LCR_TDD_CellInformation_sNA_Information,
        _ANR_LCR_TDD_CellInformation_aNR_Multiple_PLMN_List,
        _ANR_LCR_TDD_CellInformation_cellCapabilityContainerExternsionTDD_LCR,
        ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__id_tab,
        ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__id,
        ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality_tab,
        ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__criticality,
        ____ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue_tab,
        ___ANR_LCR_TDD_CellInformation_iE_Extensions__item__extensionValue,
        __ANR_LCR_TDD_CellInformation_iE_Extensions__item_,
        _ANR_LCR_TDD_CellInformation_iE_Extensions,
        ANR_LCR_TDD_CellInformation,
        ANR_LCR_TDD_CellInformation_ExtIEs,
        _ANR_Multiple_PLMN_List_list_Of_PLMNs,
        ____ANR_Multiple_PLMN_List_iE_Extensions__item__id_tab,
        ___ANR_Multiple_PLMN_List_iE_Extensions__item__id,
        ____ANR_Multiple_PLMN_List_iE_Extensions__item__criticality_tab,
        ___ANR_Multiple_PLMN_List_iE_Extensions__item__criticality,
        ____ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab,
        ___ANR_Multiple_PLMN_List_iE_Extensions__item__extensionValue,
        __ANR_Multiple_PLMN_List_iE_Extensions__item_,
        _ANR_Multiple_PLMN_List_iE_Extensions,
        ANR_Multiple_PLMN_List,
        ANR_Multiple_PLMN_List_ExtIEs,
        AOA_LCR,
        AOA_LCR_Accuracy_Class,
        AntennaColocationIndicator,
        ___BadSatellites_badSatelliteInformation__item__badSAT_ID,
        ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id_tab,
        _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__id,
        ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality_tab,
        _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__criticality,
        ______BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue_tab,
        _____BadSatellites_badSatelliteInformation__item__iE_Extensions__item__extensionValue,
        ____BadSatellites_badSatelliteInformation__item__iE_Extensions__item_,
        ___BadSatellites_badSatelliteInformation__item__iE_Extensions,
        __BadSatellites_badSatelliteInformation__item_,
        _BadSatellites_badSatelliteInformation,
        ____BadSatellites_iE_Extensions__item__id_tab,
        ___BadSatellites_iE_Extensions__item__id,
        ____BadSatellites_iE_Extensions__item__criticality_tab,
        ___BadSatellites_iE_Extensions__item__criticality,
        ____BadSatellites_iE_Extensions__item__extensionValue_tab,
        ___BadSatellites_iE_Extensions__item__extensionValue,
        __BadSatellites_iE_Extensions__item_,
        _BadSatellites_iE_Extensions,
        BadSatellites,
        BadSatelliteInformation_ExtIEs,
        BadSatellites_ExtIEs,
        Band_Indicator,
        BCC,
        BCCH_ARFCN,
        _BDS_IGPInfoList__item_,
        BDS_IGPInfoList,
        _BDS_IGPInfo_bds_IGPNumber,
        _BDS_IGPInfo_bds_VerticalDelay,
        _BDS_IGPInfo_bds_GIVEI,
        ____BDS_IGPInfo_iE_Extensions__item__id_tab,
        ___BDS_IGPInfo_iE_Extensions__item__id,
        ____BDS_IGPInfo_iE_Extensions__item__criticality_tab,
        ___BDS_IGPInfo_iE_Extensions__item__criticality,
        ____BDS_IGPInfo_iE_Extensions__item__extensionValue_tab,
        ___BDS_IGPInfo_iE_Extensions__item__extensionValue,
        __BDS_IGPInfo_iE_Extensions__item_,
        _BDS_IGPInfo_iE_Extensions,
        BDS_IGPInfo,
        BDS_IGPInfo_ExtIEs,
        BDS_IonosphericGridModelReq,
        _BDS_Ionospheric_Grid_Model_bDS_RefTime,
        _BDS_Ionospheric_Grid_Model_bds_IGPInfoList,
        ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__id_tab,
        ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__id,
        ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality_tab,
        ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__criticality,
        ____BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue_tab,
        ___BDS_Ionospheric_Grid_Model_iE_Extensions__item__extensionValue,
        __BDS_Ionospheric_Grid_Model_iE_Extensions__item_,
        _BDS_Ionospheric_Grid_Model_iE_Extensions,
        BDS_Ionospheric_Grid_Model,
        BDS_Ionospheric_Grid_Model_ExtIEs,
        BetaCD,
        BindingID,
        BLER,
        _BSIC_nCC,
        _BSIC_bCC,
        BSIC,
        BundlingModeIndicator,
        _BurstModeParameters_burstStart,
        _BurstModeParameters_burstLength,
        _BurstModeParameters_burstFreq,
        ____BurstModeParameters_iE_Extensions__item__id_tab,
        ___BurstModeParameters_iE_Extensions__item__id,
        ____BurstModeParameters_iE_Extensions__item__criticality_tab,
        ___BurstModeParameters_iE_Extensions__item__criticality,
        ____BurstModeParameters_iE_Extensions__item__extensionValue_tab,
        ___BurstModeParameters_iE_Extensions__item__extensionValue,
        __BurstModeParameters_iE_Extensions__item_,
        _BurstModeParameters_iE_Extensions,
        BurstModeParameters,
        BurstModeParameters_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseMisc,
        CauseProtocol,
        CauseRadioNetwork,
        CauseTransport,
        _CellBased_cellIdList,
        ____CellBased_iE_Extensions__item__id_tab,
        ___CellBased_iE_Extensions__item__id,
        ____CellBased_iE_Extensions__item__criticality_tab,
        ___CellBased_iE_Extensions__item__criticality,
        ____CellBased_iE_Extensions__item__extensionValue_tab,
        ___CellBased_iE_Extensions__item__extensionValue,
        __CellBased_iE_Extensions__item_,
        _CellBased_iE_Extensions,
        CellBased,
        CellBased_ExtIEs,
        _CellIdList__item_,
        CellIdList,
        Cell_Id,
        CellCapabilityContainer_FDD,
        CellCapabilityContainerExtension_FDD,
        CellCapabilityContainer_TDD,
        CellCapabilityContainer_TDD_LCR,
        CellCapabilityContainerExtension_TDD_LCR,
        CellCapabilityContainer_TDD768,
        C_ID,
        CCTrCH_ID,
        _Cell_Capacity_Class_Value_uplinkCellCapacityClassValue,
        _Cell_Capacity_Class_Value_downlinkCellCapacityClassValue,
        Cell_Capacity_Class_Value,
        CellIndividualOffset,
        CellListValidityIndicator,
        CellParameterID,
        CellPortionID,
        CellPortionLCRID,
        CFN,
        _CGI_lAI,
        _CGI_cI,
        ____CGI_iE_Extensions__item__id_tab,
        ___CGI_iE_Extensions__item__id,
        ____CGI_iE_Extensions__item__criticality_tab,
        ___CGI_iE_Extensions__item__criticality,
        ____CGI_iE_Extensions__item__extensionValue_tab,
        ___CGI_iE_Extensions__item__extensionValue,
        __CGI_iE_Extensions__item_,
        _CGI_iE_Extensions,
        CGI,
        LAI_ExtIEs,
        CGI_ExtIEs,
        ChannelCodingType,
        ChipOffset,
        CI,
        ClassmarkInformation2,
        ClassmarkInformation3,
        ClosedLoopMode1_SupportIndicator,
        Closedlooptimingadjustmentmode,
        CodingRate,
        _CommonMeasurementAccuracy_tUTRANGPSMeasurementAccuracyClass,
        _CommonMeasurementAccuracy_tUTRANGANSSMeasurementAccuracyClass,
        CommonMeasurementAccuracy,
        CommonMeasurementType,
        _CommonMeasurementValue_tUTRANGPSMeasurementValueInformation,
        _CommonMeasurementValue_sFNSFNMeasurementValueInformation,
        _CommonMeasurementValue_loadValue,
        _CommonMeasurementValue_transmittedCarrierPowerValue,
        _CommonMeasurementValue_receivedTotalWideBandPowerValue,
        _CommonMeasurementValue_uplinkTimeslotISCPValue,
        _CommonMeasurementValue_extension_CommonMeasurementValue,
        CommonMeasurementValue,
        _CommonMeasurementValueInformation_measurementAvailable,
        _CommonMeasurementValueInformation_measurementnotAvailable,
        CommonMeasurementValueInformation,
        _CommonMeasurementAvailable_commonMeasurementValue,
        ____CommonMeasurementAvailable_iE_Extensions__item__id_tab,
        ___CommonMeasurementAvailable_iE_Extensions__item__id,
        ____CommonMeasurementAvailable_iE_Extensions__item__criticality_tab,
        ___CommonMeasurementAvailable_iE_Extensions__item__criticality,
        ____CommonMeasurementAvailable_iE_Extensions__item__extensionValue_tab,
        ___CommonMeasurementAvailable_iE_Extensions__item__extensionValue,
        __CommonMeasurementAvailable_iE_Extensions__item_,
        _CommonMeasurementAvailable_iE_Extensions,
        CommonMeasurementAvailable,
        CommonMeasurementAvailableItem_ExtIEs,
        CongestionCause,
        CommonTransportChannelResourcesInitialisationNotRequired,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDD__item_,
        Common_EDCH_MAC_d_Flow_Specific_InformationFDD,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_common_EDCH_MACdFlow_ID,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_maximum_Number_of_Retransmissions_For_E_DCH,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_eDCH_HARQ_PO_FDD,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_eDCH_MACdFlow_Multiplexing_List,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_common_E_DCHLogicalChannelInformation,
        ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id_tab,
        ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__id,
        ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality_tab,
        ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__criticality,
        ____Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue_tab,
        ___Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item__extensionValue,
        __Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions__item_,
        _Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_iE_Extensions,
        Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem,
        Common_EDCH_MAC_d_Flow_Specific_InformationFDDItem_ExtIEs,
        _Common_EDCH_MAC_d_Flow_Specific_InformationLCR__item_,
        Common_EDCH_MAC_d_Flow_Specific_InformationLCR,
        _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_common_EDCH_MACdFlow_ID_LCR,
        _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_maximum_Number_of_Retransmissions_For_E_DCH,
        _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_eDCH_HARQ_PO_TDD,
        _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_eDCH_MACdFlow_Multiplexing_List,
        _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_common_E_DCHLogicalChannelInformation,
        ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id_tab,
        ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__id,
        ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality_tab,
        ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__criticality,
        ____Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue_tab,
        ___Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item__extensionValue,
        __Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions__item_,
        _Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_iE_Extensions,
        Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR,
        Common_EDCH_MAC_d_Flow_Specific_InformationItemLCR_ExtIEs,
        _Common_E_DCH_LogicalChannelInformation__item_,
        Common_E_DCH_LogicalChannelInformation,
        _Common_E_DCH_LogicalChannelInformationItem_logicalChannelId,
        _Common_E_DCH_LogicalChannelInformationItem_maximumMACdPDU_SizeExtended,
        ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab,
        ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id,
        ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality_tab,
        ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality,
        ____Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue_tab,
        ___Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue,
        __Common_E_DCH_LogicalChannelInformationItem_iE_Extensions__item_,
        _Common_E_DCH_LogicalChannelInformationItem_iE_Extensions,
        Common_E_DCH_LogicalChannelInformationItem,
        Common_E_DCH_LogicalChannelInformationItem_ExtIEs,
        Common_EDCH_Support_Indicator,
        _Common_E_RGCH_Cell_Information_deActivation,
        _Common_E_RGCH_Cell_Information_common_E_RGCH_Cell_Info,
        Common_E_RGCH_Cell_Information,
        _Common_E_RGCH_Cell_Info_eRGCH_ChannelisationCode,
        _Common_E_RGCH_Cell_Info_eRGCH_SignatureSequence,
        _Common_E_RGCH_Cell_Info_serving_Grant_Value,
        Common_E_RGCH_Cell_Info,
        Common_E_RGCH_De_Activation,
        CompleteAlmanacProvided,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_uE_DTX_DRX_Offset,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_enabling_Delay,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_dTX_Information,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_dRX_Information,
        ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id_tab,
        ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__id,
        ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality_tab,
        ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__criticality,
        ____Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue_tab,
        ___Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item__extensionValue,
        __Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions__item_,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_iE_Extensions,
        Continuous_Packet_Connectivity_DTX_DRX_Information,
        Continuous_Packet_Connectivity_DTX_DRX_Information_ExtIEs,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_uE_DTX_DRX_Offset,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_enabling_Delay,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_dTX_Information_to_Modify,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_dRX_Information_to_Modify,
        ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id_tab,
        ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__id,
        ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality_tab,
        ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__criticality,
        ____Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item__extensionValue,
        __Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions__item_,
        _Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_iE_Extensions,
        Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify,
        Continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify_ExtIEs,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_Information__item_,
        Continuous_Packet_Connectivity_HS_SCCH_Less_Information,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_transport_Block_Size_Index,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_hSPDSCH_Second_Code_Support,
        ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id_tab,
        ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__id,
        ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality_tab,
        ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__criticality,
        ____Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item__extensionValue,
        __Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions__item_,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_iE_Extensions,
        Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem,
        Continuous_Packet_Connectivity_HS_SCCH_Less_InformationItem_ExtIEs,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_hSPDSCH_First_Code_Index,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_hSPDSCH_Second_Code_Index,
        ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id_tab,
        ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__id,
        ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality_tab,
        ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__criticality,
        ____Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item__extensionValue,
        __Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions__item_,
        _Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_iE_Extensions,
        Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response,
        Continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response_ExtIEs,
        _CorrespondingCells__item_,
        CorrespondingCells,
        CoverageIndicator,
        _CPC_Information_continuous_Packet_Connectivity_DTX_DRX_Information,
        _CPC_Information_continuous_Packet_Connectivity_DTX_DRX_Information_to_Modify,
        _CPC_Information_continuous_Packet_Connectivity_HS_SCCH_Less_Information,
        ____CPC_Information_iE_Extensions__item__id_tab,
        _____CPC_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___CPC_Information_iE_Extensions__item__id,
        ___CPC_Information_iE_Extensions__item__criticality,
        ___CPC_Information_iE_Extensions__item__extensionValue,
        __CPC_Information_iE_Extensions__item_,
        _CPC_Information_iE_Extensions,
        CPC_Information,
        CPC_Information_ExtIEs,
        _CPC_Information_ExtIEs_val_Extension_0,
        CPC_RecoveryReport,
        Continuous_Packet_Connectivity_HS_SCCH_less_Deactivate_Indicator,
        _Counting_Information__item_,
        Counting_Information,
        _Counting_Information_List_c_ID,
        _Counting_Information_List_counting_Result,
        ____Counting_Information_List_iE_Extensions__item__id_tab,
        ___Counting_Information_List_iE_Extensions__item__id,
        ____Counting_Information_List_iE_Extensions__item__criticality_tab,
        ___Counting_Information_List_iE_Extensions__item__criticality,
        ____Counting_Information_List_iE_Extensions__item__extensionValue_tab,
        ___Counting_Information_List_iE_Extensions__item__extensionValue,
        __Counting_Information_List_iE_Extensions__item_,
        _Counting_Information_List_iE_Extensions,
        Counting_Information_List,
        Counting_Information_List_ExtIEs,
        Counting_Result,
        CRC_Size,
        _CriticalityDiagnostics_procedureID,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_transactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__repetitionNumber,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1,
        _CN_CS_DomainIdentifier_pLMN_Identity,
        _CN_CS_DomainIdentifier_lAC,
        ____CN_CS_DomainIdentifier_iE_Extensions__item__id_tab,
        ___CN_CS_DomainIdentifier_iE_Extensions__item__id,
        ____CN_CS_DomainIdentifier_iE_Extensions__item__criticality_tab,
        ___CN_CS_DomainIdentifier_iE_Extensions__item__criticality,
        ____CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue_tab,
        ___CN_CS_DomainIdentifier_iE_Extensions__item__extensionValue,
        __CN_CS_DomainIdentifier_iE_Extensions__item_,
        _CN_CS_DomainIdentifier_iE_Extensions,
        CN_CS_DomainIdentifier,
        CN_CS_DomainIdentifier_ExtIEs,
        _CN_PS_DomainIdentifier_pLMN_Identity,
        _CN_PS_DomainIdentifier_lAC,
        _CN_PS_DomainIdentifier_rAC,
        ____CN_PS_DomainIdentifier_iE_Extensions__item__id_tab,
        ___CN_PS_DomainIdentifier_iE_Extensions__item__id,
        ____CN_PS_DomainIdentifier_iE_Extensions__item__criticality_tab,
        ___CN_PS_DomainIdentifier_iE_Extensions__item__criticality,
        ____CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue_tab,
        ___CN_PS_DomainIdentifier_iE_Extensions__item__extensionValue,
        __CN_PS_DomainIdentifier_iE_Extensions__item_,
        _CN_PS_DomainIdentifier_iE_Extensions,
        CN_PS_DomainIdentifier,
        CN_PS_DomainIdentifier_ExtIEs,
        CNDomainType,
        CQI_DTX_Timer,
        CQI_Cycle_Switch_Timer,
        ControlGAP,
        CQI_Feedback_Cycle,
        CQI_Feedback_Cycle2,
        CQI_Power_Offset,
        CQI_RepetitionFactor,
        C_RNTI,
        CodeRate,
        CodeRate_short,
        _CPC_InformationLCR_continuousPacketConnectivity_DRX_InformationLCR,
        _CPC_InformationLCR_continuousPacketConnectivity_DRX_Information_to_Modify_LCR,
        _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_LCR,
        _CPC_InformationLCR_hS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        _CPC_InformationLCR_hS_DSCH_SPS_Deactivate_Indicator_LCR,
        _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_LCR,
        _CPC_InformationLCR_e_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        _CPC_InformationLCR_e_DCH_SPS_Deactivate_Indicator_LCR,
        ____CPC_InformationLCR_iE_Extensions__item__id_tab,
        ___CPC_InformationLCR_iE_Extensions__item__id,
        ____CPC_InformationLCR_iE_Extensions__item__criticality_tab,
        ___CPC_InformationLCR_iE_Extensions__item__criticality,
        ____CPC_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___CPC_InformationLCR_iE_Extensions__item__extensionValue,
        __CPC_InformationLCR_iE_Extensions__item_,
        _CPC_InformationLCR_iE_Extensions,
        CPC_InformationLCR,
        CPC_InformationLCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_InformationLCR_enabling_Delay,
        _ContinuousPacketConnectivity_DRX_InformationLCR_hS_SCCH_DRX_Information_LCR,
        _ContinuousPacketConnectivity_DRX_InformationLCR_e_AGCH_DRX_Information_LCR,
        ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__id,
        ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions__item_,
        _ContinuousPacketConnectivity_DRX_InformationLCR_iE_Extensions,
        ContinuousPacketConnectivity_DRX_InformationLCR,
        ContinuousPacketConnectivity_DRX_InformationLCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_enabling_Delay,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_dRX_Information_to_Modify_LCR,
        ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__id,
        ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions__item_,
        _ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_iE_Extensions,
        ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR,
        ContinuousPacketConnectivity_DRX_Information_to_Modify_LCR_ExtIEs,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_enabling_Delay,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_hS_SCCH_DRX_Information_ResponseLCR,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_e_AGCH_DRX_Information_ResponseLCR,
        ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab,
        ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__id,
        ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__criticality,
        ____ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions__item_,
        _ContinuousPacketConnectivity_DRX_Information_ResponseLCR_iE_Extensions,
        ContinuousPacketConnectivity_DRX_Information_ResponseLCR,
        ContinuousPacketConnectivity_DRX_Information_ResponseLCR_ExtIEs,
        _Controlled_Object_Scope_rNC_ID,
        _Controlled_Object_Scope_extended_RNC_ID,
        _Controlled_Object_Scope_multiple_PLMN_List,
        _Controlled_Object_Scope_umts_cell_Info,
        ____Controlled_Object_Scope_iE_Extensions__item__id_tab,
        ___Controlled_Object_Scope_iE_Extensions__item__id,
        ____Controlled_Object_Scope_iE_Extensions__item__criticality_tab,
        ___Controlled_Object_Scope_iE_Extensions__item__criticality,
        ____Controlled_Object_Scope_iE_Extensions__item__extensionValue_tab,
        ___Controlled_Object_Scope_iE_Extensions__item__extensionValue,
        __Controlled_Object_Scope_iE_Extensions__item_,
        _Controlled_Object_Scope_iE_Extensions,
        Controlled_Object_Scope,
        Controlled_Object_Scope_ExtIEs,
        DATA_ID,
        _DBDS_CorrectionsReq_dGANSS_Signal_ID,
        ____DBDS_CorrectionsReq_ie_Extensions__item__id_tab,
        ___DBDS_CorrectionsReq_ie_Extensions__item__id,
        ____DBDS_CorrectionsReq_ie_Extensions__item__criticality_tab,
        ___DBDS_CorrectionsReq_ie_Extensions__item__criticality,
        ____DBDS_CorrectionsReq_ie_Extensions__item__extensionValue_tab,
        ___DBDS_CorrectionsReq_ie_Extensions__item__extensionValue,
        __DBDS_CorrectionsReq_ie_Extensions__item_,
        _DBDS_CorrectionsReq_ie_Extensions,
        DBDS_CorrectionsReq,
        DBDS_CorrectionsReq_ExtIEs,
        _DBDS_Corrections_bDS_RefTime,
        _DBDS_Corrections_dBDS_InfoList,
        ____DBDS_Corrections_iE_Extensions__item__id_tab,
        ___DBDS_Corrections_iE_Extensions__item__id,
        ____DBDS_Corrections_iE_Extensions__item__criticality_tab,
        ___DBDS_Corrections_iE_Extensions__item__criticality,
        ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab,
        ___DBDS_Corrections_iE_Extensions__item__extensionValue,
        __DBDS_Corrections_iE_Extensions__item_,
        _DBDS_Corrections_iE_Extensions,
        DBDS_Corrections,
        DBDS_CorrectionsItem_ExtIEs,
        _DBDS_Info_dBDS_SignalID,
        _DBDS_Info_dBDS_SignalInfoList,
        ____DBDS_Info_iE_Extensions__item__id_tab,
        ___DBDS_Info_iE_Extensions__item__id,
        ____DBDS_Info_iE_Extensions__item__criticality_tab,
        ___DBDS_Info_iE_Extensions__item__criticality,
        ____DBDS_Info_iE_Extensions__item__extensionValue_tab,
        ___DBDS_Info_iE_Extensions__item__extensionValue,
        __DBDS_Info_iE_Extensions__item_,
        _DBDS_Info_iE_Extensions,
        DBDS_Info,
        DBDS_InfoItem_ExtIEs,
        _DBDS_SignalInfoList__item_,
        DBDS_SignalInfoList,
        _DBDS_SignalInfo_svID,
        _DBDS_SignalInfo_bds_UDREI,
        _DBDS_SignalInfo_bds_RURAI,
        _DBDS_SignalInfo_bds_ECC_DeltaT,
        ____DBDS_SignalInfo_ie_Extensions__item__id_tab,
        ___DBDS_SignalInfo_ie_Extensions__item__id,
        ____DBDS_SignalInfo_ie_Extensions__item__criticality_tab,
        ___DBDS_SignalInfo_ie_Extensions__item__criticality,
        ____DBDS_SignalInfo_ie_Extensions__item__extensionValue_tab,
        ___DBDS_SignalInfo_ie_Extensions__item__extensionValue,
        __DBDS_SignalInfo_ie_Extensions__item_,
        _DBDS_SignalInfo_ie_Extensions,
        DBDS_SignalInfo,
        DBDS_SignalInfoItem_ExtIEs,
        _DBDS_InfoList__item_,
        DBDS_InfoList,
        _DCH_ENH_Information_pO2_SRB,
        _DCH_ENH_Information_dl_FET_Mode,
        _DCH_ENH_Information_dCH_ENH_Concat,
        ____DCH_ENH_Information_iE_Extensions__item__id_tab,
        ___DCH_ENH_Information_iE_Extensions__item__id,
        ____DCH_ENH_Information_iE_Extensions__item__criticality_tab,
        ___DCH_ENH_Information_iE_Extensions__item__criticality,
        ____DCH_ENH_Information_iE_Extensions__item__extensionValue_tab,
        ___DCH_ENH_Information_iE_Extensions__item__extensionValue,
        __DCH_ENH_Information_iE_Extensions__item_,
        _DCH_ENH_Information_iE_Extensions,
        DCH_ENH_Information,
        DCH_ENH_Information_ExtIEs,
        _DCH_ENH_Information_to_Modify_pO_SRB,
        _DCH_ENH_Information_to_Modify_dl_FET_Mode,
        _DCH_ENH_Information_to_Modify_dCH_ENH_Concat,
        ____DCH_ENH_Information_to_Modify_iE_Extensions__item__id_tab,
        ___DCH_ENH_Information_to_Modify_iE_Extensions__item__id,
        ____DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality_tab,
        ___DCH_ENH_Information_to_Modify_iE_Extensions__item__criticality,
        ____DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___DCH_ENH_Information_to_Modify_iE_Extensions__item__extensionValue,
        __DCH_ENH_Information_to_Modify_iE_Extensions__item_,
        _DCH_ENH_Information_to_Modify_iE_Extensions,
        DCH_ENH_Information_to_Modify,
        DCH_ENH_Information_to_Modify_ExtIEs,
        DL_FET_Mode,
        _DCH_ENH_Concat__item_,
        DCH_ENH_Concat,
        _DCH_ENH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH,
        ____DCH_ENH_Information_Reconf_iE_Extensions__item__id_tab,
        ___DCH_ENH_Information_Reconf_iE_Extensions__item__id,
        ____DCH_ENH_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___DCH_ENH_Information_Reconf_iE_Extensions__item__criticality,
        ____DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___DCH_ENH_Information_Reconf_iE_Extensions__item__extensionValue,
        __DCH_ENH_Information_Reconf_iE_Extensions__item_,
        _DCH_ENH_Information_Reconf_iE_Extensions,
        DCH_ENH_Information_Reconf,
        DCH_ENH_Information_Reconf_ExtIEs,
        DCH_ENH_Information_Removal,
        _DCH_FDD_Information__item_,
        DCH_FDD_Information,
        _DCH_FDD_InformationItem_payloadCRC_PresenceIndicator,
        _DCH_FDD_InformationItem_ul_FP_Mode,
        _DCH_FDD_InformationItem_toAWS,
        _DCH_FDD_InformationItem_toAWE,
        _DCH_FDD_InformationItem_dCH_SpecificInformationList,
        ____DCH_FDD_InformationItem_iE_Extensions__item__id_tab,
        _____DCH_FDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_FDD_InformationItem_iE_Extensions__item__id,
        ___DCH_FDD_InformationItem_iE_Extensions__item__criticality,
        ___DCH_FDD_InformationItem_iE_Extensions__item__extensionValue,
        __DCH_FDD_InformationItem_iE_Extensions__item_,
        _DCH_FDD_InformationItem_iE_Extensions,
        DCH_FDD_InformationItem,
        DCH_FDD_InformationItem_ExtIEs,
        _DCH_FDD_InformationItem_ExtIEs_val_Extension_0,
        _DCH_MeasurementOccasion_Information__item_,
        DCH_MeasurementOccasion_Information,
        _DchMeasurementOccasionInformation_Item_pattern_Sequence_Identifier,
        _DchMeasurementOccasionInformation_Item_status_Flag,
        _DchMeasurementOccasionInformation_Item_measurement_Occasion_Pattern_Sequence_parameters,
        ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__id_tab,
        ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__id,
        ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality_tab,
        ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__criticality,
        ____DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___DchMeasurementOccasionInformation_Item_iE_Extensions__item__extensionValue,
        __DchMeasurementOccasionInformation_Item_iE_Extensions__item_,
        _DchMeasurementOccasionInformation_Item_iE_Extensions,
        DchMeasurementOccasionInformation_Item,
        DCH_MeasurementOccasion_Information_ExtIEs,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_k,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_offset,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_M_Length,
        _Measurement_Occasion_Pattern_Sequence_parameters_measurement_Occasion_Pattern_Sequence_parameters_Timeslot_Bitmap,
        ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id_tab,
        ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__id,
        ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality_tab,
        ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__criticality,
        ____Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue_tab,
        ___Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item__extensionValue,
        __Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions__item_,
        _Measurement_Occasion_Pattern_Sequence_parameters_iE_Extensions,
        Measurement_Occasion_Pattern_Sequence_parameters,
        Measurement_Occasion_Pattern_Sequence_parameters_ExtIEs,
        DCH_MeasurementType_Indicator,
        _DCH_Specific_FDD_InformationList__item_,
        DCH_Specific_FDD_InformationList,
        _DCH_Specific_FDD_Item_dCH_ID,
        _DCH_Specific_FDD_Item_trCH_SrcStatisticsDescr,
        _DCH_Specific_FDD_Item_ul_transportFormatSet,
        _DCH_Specific_FDD_Item_dl_transportFormatSet,
        _DCH_Specific_FDD_Item_ul_BLER,
        _DCH_Specific_FDD_Item_dl_BLER,
        _DCH_Specific_FDD_Item_allocationRetentionPriority,
        _DCH_Specific_FDD_Item_frameHandlingPriority,
        _DCH_Specific_FDD_Item_qE_Selector,
        _DCH_Specific_FDD_Item_dRACControl,
        ____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab,
        _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DCH_Specific_FDD_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___DCH_Specific_FDD_Item_iE_Extensions__item__id,
        ___DCH_Specific_FDD_Item_iE_Extensions__item__criticality,
        ___DCH_Specific_FDD_Item_iE_Extensions__item__extensionValue,
        __DCH_Specific_FDD_Item_iE_Extensions__item_,
        _DCH_Specific_FDD_Item_iE_Extensions,
        DCH_Specific_FDD_Item,
        DCH_FDD_SpecificItem_ExtIEs,
        _DCH_FDD_SpecificItem_ExtIEs_val_Extension_0,
        _DCH_FDD_SpecificItem_ExtIEs_val_Extension_1,
        _DCH_FDD_SpecificItem_ExtIEs_val_Extension_2,
        DCH_Indicator_For_E_DCH_HSDPA_Operation,
        DCH_ID,
        _DCH_InformationResponse__item_,
        DCH_InformationResponse,
        _DCH_InformationResponseItem_dCH_ID,
        _DCH_InformationResponseItem_bindingID,
        _DCH_InformationResponseItem_transportLayerAddress,
        ____DCH_InformationResponseItem_iE_Extensions__item__id_tab,
        _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____DCH_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___DCH_InformationResponseItem_iE_Extensions__item__id,
        ___DCH_InformationResponseItem_iE_Extensions__item__criticality,
        ___DCH_InformationResponseItem_iE_Extensions__item__extensionValue,
        __DCH_InformationResponseItem_iE_Extensions__item_,
        _DCH_InformationResponseItem_iE_Extensions,
        DCH_InformationResponseItem,
        DCH_InformationResponseItem_ExtIEs,
        _DCH_InformationResponseItem_ExtIEs_val_Extension_0,
        _DCH_InformationResponseItem_ExtIEs_val_Extension_1,
        _DCH_TDD_Information__item_,
        DCH_TDD_Information,
        _DCH_TDD_InformationItem_payloadCRC_PresenceIndicator,
        _DCH_TDD_InformationItem_ul_FP_Mode,
        _DCH_TDD_InformationItem_toAWS,
        _DCH_TDD_InformationItem_toAWE,
        _DCH_TDD_InformationItem_dCH_SpecificInformationList,
        ____DCH_TDD_InformationItem_iE_Extensions__item__id_tab,
        _____DCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DCH_TDD_InformationItem_iE_Extensions__item__id,
        ___DCH_TDD_InformationItem_iE_Extensions__item__criticality,
        ___DCH_TDD_InformationItem_iE_Extensions__item__extensionValue,
        __DCH_TDD_InformationItem_iE_Extensions__item_,
        _DCH_TDD_InformationItem_iE_Extensions,
        DCH_TDD_InformationItem,
        DCH_TDD_InformationItem_ExtIEs,
        _DCH_TDD_InformationItem_ExtIEs_val_Extension_0,
        _DCH_Specific_TDD_InformationList__item_,
        DCH_Specific_TDD_InformationList,
        _DCH_Specific_TDD_Item_dCH_ID,
        _DCH_Specific_TDD_Item_ul_cCTrCH_ID,
        _DCH_Specific_TDD_Item_dl_cCTrCH_ID,
        _DCH_Specific_TDD_Item_trCH_SrcStatisticsDescr,
        _DCH_Specific_TDD_Item_ul_transportFormatSet,
        _DCH_Specific_TDD_Item_dl_transportFormatSet,
        _DCH_Specific_TDD_Item_ul_BLER,
        _DCH_Specific_TDD_Item_dl_BLER,
        _DCH_Specific_TDD_Item_allocationRetentionPriority,
        _DCH_Specific_TDD_Item_frameHandlingPriority,
        _DCH_Specific_TDD_Item_qE_Selector,
        ____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab,
        _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_1,
        _____DCH_Specific_TDD_Item_iE_Extensions__item__id_tab_val_Extension_2,
        ___DCH_Specific_TDD_Item_iE_Extensions__item__id,
        ___DCH_Specific_TDD_Item_iE_Extensions__item__criticality,
        ___DCH_Specific_TDD_Item_iE_Extensions__item__extensionValue,
        __DCH_Specific_TDD_Item_iE_Extensions__item_,
        _DCH_Specific_TDD_Item_iE_Extensions,
        DCH_Specific_TDD_Item,
        DCH_Specific_TDD_Item_ExtIEs,
        _DCH_Specific_TDD_Item_ExtIEs_val_Extension_0,
        _DCH_Specific_TDD_Item_ExtIEs_val_Extension_1,
        _DCH_Specific_TDD_Item_ExtIEs_val_Extension_2,
        DecimationFactor,
        DedicatedMeasurementType,
        _DedicatedMeasurementValue_sIR_Value,
        _DedicatedMeasurementValue_sIR_ErrorValue,
        _DedicatedMeasurementValue_transmittedCodePowerValue,
        _DedicatedMeasurementValue_rSCP,
        _DedicatedMeasurementValue_rxTimingDeviationValue,
        _DedicatedMeasurementValue_roundTripTime,
        _DedicatedMeasurementValue_extension_DedicatedMeasurementValue,
        DedicatedMeasurementValue,
        _DedicatedMeasurementValueInformation_measurementAvailable,
        _DedicatedMeasurementValueInformation_measurementnotAvailable,
        DedicatedMeasurementValueInformation,
        _DedicatedMeasurementAvailable_dedicatedmeasurementValue,
        _DedicatedMeasurementAvailable_cFN,
        ____DedicatedMeasurementAvailable_ie_Extensions__item__id_tab,
        ___DedicatedMeasurementAvailable_ie_Extensions__item__id,
        ____DedicatedMeasurementAvailable_ie_Extensions__item__criticality_tab,
        ___DedicatedMeasurementAvailable_ie_Extensions__item__criticality,
        ____DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue_tab,
        ___DedicatedMeasurementAvailable_ie_Extensions__item__extensionValue,
        __DedicatedMeasurementAvailable_ie_Extensions__item_,
        _DedicatedMeasurementAvailable_ie_Extensions,
        DedicatedMeasurementAvailable,
        DedicatedMeasurementAvailableItem_ExtIEs,
        DedicatedMeasurementnotAvailable,
        _DelayedActivation_cfn,
        _DelayedActivation_separate_indication,
        DelayedActivation,
        _DelayedActivationUpdate_activate,
        _DelayedActivationUpdate_deactivate,
        DelayedActivationUpdate,
        _Deactivate_Info_deactivation_type,
        ____Deactivate_Info_iE_Extensions__item__id_tab,
        ___Deactivate_Info_iE_Extensions__item__id,
        ____Deactivate_Info_iE_Extensions__item__criticality_tab,
        ___Deactivate_Info_iE_Extensions__item__criticality,
        ____Deactivate_Info_iE_Extensions__item__extensionValue_tab,
        ___Deactivate_Info_iE_Extensions__item__extensionValue,
        __Deactivate_Info_iE_Extensions__item_,
        _Deactivate_Info_iE_Extensions,
        Deactivate_Info,
        Deactivate_Info_ExtIEs,
        DeltaSIR,
        _DGANSSCorrections_dGANSS_ReferenceTime,
        ___DGANSSCorrections_dGANSS_Information__item__gANSS_SignalId,
        ___DGANSSCorrections_dGANSS_Information__item__gANSS_StatusHealth,
        _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__satId,
        _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__gANSS_iod,
        _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__udre,
        _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_prc,
        _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ganss_rrc,
        ________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab,
        _________DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id_tab_val_Extension_0,
        _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__id,
        _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__criticality,
        _______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item__extensionValue,
        ______DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions__item_,
        _____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item__ie_Extensions,
        ____DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation__item_,
        ___DGANSSCorrections_dGANSS_Information__item__dGANSS_SignalInformation,
        ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id_tab,
        _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__id,
        ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality_tab,
        _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__criticality,
        ______DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue_tab,
        _____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item__extensionValue,
        ____DGANSSCorrections_dGANSS_Information__item__ie_Extensions__item_,
        ___DGANSSCorrections_dGANSS_Information__item__ie_Extensions,
        __DGANSSCorrections_dGANSS_Information__item_,
        _DGANSSCorrections_dGANSS_Information,
        ____DGANSSCorrections_ie_Extensions__item__id_tab,
        ___DGANSSCorrections_ie_Extensions__item__id,
        ____DGANSSCorrections_ie_Extensions__item__criticality_tab,
        ___DGANSSCorrections_ie_Extensions__item__criticality,
        ____DGANSSCorrections_ie_Extensions__item__extensionValue_tab,
        ___DGANSSCorrections_ie_Extensions__item__extensionValue,
        __DGANSSCorrections_ie_Extensions__item_,
        _DGANSSCorrections_ie_Extensions,
        DGANSSCorrections,
        DGANSSCorrections_ExtIEs,
        _DGANSS_Corrections_Req_dGANSS_Signal_ID,
        ____DGANSS_Corrections_Req_ie_Extensions__item__id_tab,
        _____DGANSS_Corrections_Req_ie_Extensions__item__id_tab_val_Extension_0,
        ___DGANSS_Corrections_Req_ie_Extensions__item__id,
        ___DGANSS_Corrections_Req_ie_Extensions__item__criticality,
        ___DGANSS_Corrections_Req_ie_Extensions__item__extensionValue,
        __DGANSS_Corrections_Req_ie_Extensions__item_,
        _DGANSS_Corrections_Req_ie_Extensions,
        DGANSS_Corrections_Req,
        DGANSS_Corrections_Req_ExtIEs,
        _DGANSS_Corrections_Req_ExtIEs_val_Extension_0,
        DGANSS_InformationItem_ExtIEs,
        DGANSS_SignalInformationItem_ExtIEs,
        _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0,
        _DGANSSThreshold_pRCDeviation,
        DGANSSThreshold,
        _DGNSS_ValidityPeriod_udreGrowthRate,
        _DGNSS_ValidityPeriod_udreValidityTime,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__id,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue,
        __DGNSS_ValidityPeriod_iE_Extensions__item_,
        _DGNSS_ValidityPeriod_iE_Extensions,
        DGNSS_ValidityPeriod,
        DGNSS_ValidityPeriod_ExtIEs,
        _DGPSCorrections_gPSTOW,
        _DGPSCorrections_gPS_Status_Health,
        ___DGPSCorrections_satellite_DGPSCorrections_Information__item__sAT_ID,
        ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iode_dgps,
        ___DGPSCorrections_satellite_DGPSCorrections_Information__item__uDRE,
        ___DGPSCorrections_satellite_DGPSCorrections_Information__item__pRC,
        ___DGPSCorrections_satellite_DGPSCorrections_Information__item__range_Correction_Rate,
        ______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab,
        _______DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id_tab_val_Extension_0,
        _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__id,
        _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__criticality,
        _____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item__extensionValue,
        ____DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions__item_,
        ___DGPSCorrections_satellite_DGPSCorrections_Information__item__iE_Extensions,
        __DGPSCorrections_satellite_DGPSCorrections_Information__item_,
        _DGPSCorrections_satellite_DGPSCorrections_Information,
        ____DGPSCorrections_iE_Extensions__item__id_tab,
        ___DGPSCorrections_iE_Extensions__item__id,
        ____DGPSCorrections_iE_Extensions__item__criticality_tab,
        ___DGPSCorrections_iE_Extensions__item__criticality,
        ____DGPSCorrections_iE_Extensions__item__extensionValue_tab,
        ___DGPSCorrections_iE_Extensions__item__extensionValue,
        __DGPSCorrections_iE_Extensions__item_,
        _DGPSCorrections_iE_Extensions,
        DGPSCorrections,
        DGPSCorrections_ExtIEs,
        _DGPSThreshold_pRCDeviation,
        ____DGPSThreshold_iE_Extensions__item__id_tab,
        ___DGPSThreshold_iE_Extensions__item__id,
        ____DGPSThreshold_iE_Extensions__item__criticality_tab,
        ___DGPSThreshold_iE_Extensions__item__criticality,
        ____DGPSThreshold_iE_Extensions__item__extensionValue_tab,
        ___DGPSThreshold_iE_Extensions__item__extensionValue,
        __DGPSThreshold_iE_Extensions__item_,
        _DGPSThreshold_iE_Extensions,
        DGPSThreshold,
        DGPSThreshold_ExtIEs,
        DiscardTimer,
        DiversityControlField,
        DiversityMode,
        _DL_TBS_hs_DSCH_Cell_List,
        ____DL_TBS_iE_Extensions__item__id_tab,
        ___DL_TBS_iE_Extensions__item__id,
        ____DL_TBS_iE_Extensions__item__criticality_tab,
        ___DL_TBS_iE_Extensions__item__criticality,
        ____DL_TBS_iE_Extensions__item__extensionValue_tab,
        ___DL_TBS_iE_Extensions__item__extensionValue,
        __DL_TBS_iE_Extensions__item_,
        _DL_TBS_iE_Extensions,
        DL_TBS,
        DL_TBS_ExtIEs,
        DL_TBS_Value,
        DL_DPCH_SlotFormat,
        DL_DPCH_TimingAdjustment,
        DL_Power,
        _DL_PowerBalancing_Information_powerAdjustmentType,
        _DL_PowerBalancing_Information_dLReferencePower,
        _DL_PowerBalancing_Information_dLReferencePowerList,
        _DL_PowerBalancing_Information_maxAdjustmentStep,
        _DL_PowerBalancing_Information_adjustmentPeriod,
        _DL_PowerBalancing_Information_adjustmentRatio,
        ____DL_PowerBalancing_Information_iE_Extensions__item__id_tab,
        ___DL_PowerBalancing_Information_iE_Extensions__item__id,
        ____DL_PowerBalancing_Information_iE_Extensions__item__criticality_tab,
        ___DL_PowerBalancing_Information_iE_Extensions__item__criticality,
        ____DL_PowerBalancing_Information_iE_Extensions__item__extensionValue_tab,
        ___DL_PowerBalancing_Information_iE_Extensions__item__extensionValue,
        __DL_PowerBalancing_Information_iE_Extensions__item_,
        _DL_PowerBalancing_Information_iE_Extensions,
        DL_PowerBalancing_Information,
        DL_PowerBalancing_Information_ExtIEs,
        _DL_ReferencePowerInformationList__item_,
        DL_ReferencePowerInformationList,
        _DL_ReferencePowerInformationItem_rL_ID,
        _DL_ReferencePowerInformationItem_dl_Reference_Power,
        ____DL_ReferencePowerInformationItem_iE_Extensions__item__id_tab,
        ___DL_ReferencePowerInformationItem_iE_Extensions__item__id,
        ____DL_ReferencePowerInformationItem_iE_Extensions__item__criticality_tab,
        ___DL_ReferencePowerInformationItem_iE_Extensions__item__criticality,
        ____DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue_tab,
        ___DL_ReferencePowerInformationItem_iE_Extensions__item__extensionValue,
        __DL_ReferencePowerInformationItem_iE_Extensions__item_,
        _DL_ReferencePowerInformationItem_iE_Extensions,
        DL_ReferencePowerInformationItem,
        DL_ReferencePowerInformationItem_ExtIEs,
        DL_PowerBalancing_ActivationIndicator,
        DL_PowerBalancing_UpdatedIndicator,
        _DL_ReferencePowerInformation_common_DL_ReferencePowerInformation,
        _DL_ReferencePowerInformation_individual_DL_ReferencePowerInformation,
        ____DL_ReferencePowerInformation_iE_Extensions__item__id_tab,
        ___DL_ReferencePowerInformation_iE_Extensions__item__id,
        ____DL_ReferencePowerInformation_iE_Extensions__item__criticality_tab,
        ___DL_ReferencePowerInformation_iE_Extensions__item__criticality,
        ____DL_ReferencePowerInformation_iE_Extensions__item__extensionValue_tab,
        ___DL_ReferencePowerInformation_iE_Extensions__item__extensionValue,
        __DL_ReferencePowerInformation_iE_Extensions__item_,
        _DL_ReferencePowerInformation_iE_Extensions,
        DL_ReferencePowerInformation,
        DL_ReferencePowerInformation_ExtIEs,
        D_RNTI,
        D_RNTI_ReleaseIndication,
        DL_ScramblingCode,
        DL_FrameType,
        _DL_Timeslot_Information__item_,
        DL_Timeslot_Information,
        _DL_Timeslot_InformationItem_timeSlot,
        _DL_Timeslot_InformationItem_midambleShiftAndBurstType,
        _DL_Timeslot_InformationItem_tFCI_Presence,
        _DL_Timeslot_InformationItem_dL_Code_Information,
        ____DL_Timeslot_InformationItem_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationItem_iE_Extensions__item__id,
        ____DL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationItem_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationItem_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationItem_iE_Extensions__item_,
        _DL_Timeslot_InformationItem_iE_Extensions,
        DL_Timeslot_InformationItem,
        DL_Timeslot_InformationItem_ExtIEs,
        _DL_TimeslotLCR_Information__item_,
        DL_TimeslotLCR_Information,
        _DL_TimeslotLCR_InformationItem_timeSlotLCR,
        _DL_TimeslotLCR_InformationItem_midambleShiftLCR,
        _DL_TimeslotLCR_InformationItem_tFCI_Presence,
        _DL_TimeslotLCR_InformationItem_dL_Code_LCR_Information,
        ____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab,
        _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__id,
        ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality,
        ___DL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue,
        __DL_TimeslotLCR_InformationItem_iE_Extensions__item_,
        _DL_TimeslotLCR_InformationItem_iE_Extensions,
        DL_TimeslotLCR_InformationItem,
        DL_TimeslotLCR_InformationItem_ExtIEs,
        _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0,
        _DL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_1,
        _DL_Timeslot_Information768__item_,
        DL_Timeslot_Information768,
        _DL_Timeslot_InformationItem768_timeSlot,
        _DL_Timeslot_InformationItem768_midambleShiftAndBurstType768,
        _DL_Timeslot_InformationItem768_tFCI_Presence,
        _DL_Timeslot_InformationItem768_dL_Code_Information768,
        ____DL_Timeslot_InformationItem768_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationItem768_iE_Extensions__item__id,
        ____DL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationItem768_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationItem768_iE_Extensions__item_,
        _DL_Timeslot_InformationItem768_iE_Extensions,
        DL_Timeslot_InformationItem768,
        DL_Timeslot_InformationItem768_ExtIEs,
        _DL_TimeSlot_ISCP_Info__item_,
        DL_TimeSlot_ISCP_Info,
        _DL_TimeSlot_ISCP_InfoItem_timeSlot,
        _DL_TimeSlot_ISCP_InfoItem_dL_TimeslotISCP,
        ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab,
        ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id,
        ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab,
        ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality,
        ____DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue,
        __DL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_,
        _DL_TimeSlot_ISCP_InfoItem_iE_Extensions,
        DL_TimeSlot_ISCP_InfoItem,
        DL_TimeSlot_ISCP_InfoItem_ExtIEs,
        _DL_TimeSlot_ISCP_LCR_Information__item_,
        DL_TimeSlot_ISCP_LCR_Information,
        _DL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR,
        _DL_TimeSlot_ISCP_LCR_InfoItem_dL_TimeslotISCP,
        ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab,
        ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id,
        ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab,
        ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality,
        ____DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue,
        __DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_,
        _DL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions,
        DL_TimeSlot_ISCP_LCR_InfoItem,
        DL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs,
        DL_TimeslotISCP,
        Downlink_Compressed_Mode_Method,
        _Downlink_TPC_enhancements_Information_decimationFactorforPrimaryFrequency,
        _Downlink_TPC_enhancements_Information_decimationFactorforSecFrequency,
        ____Downlink_TPC_enhancements_Information_iE_Extensions__item__id_tab,
        ___Downlink_TPC_enhancements_Information_iE_Extensions__item__id,
        ____Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality_tab,
        ___Downlink_TPC_enhancements_Information_iE_Extensions__item__criticality,
        ____Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue_tab,
        ___Downlink_TPC_enhancements_Information_iE_Extensions__item__extensionValue,
        __Downlink_TPC_enhancements_Information_iE_Extensions__item_,
        _Downlink_TPC_enhancements_Information_iE_Extensions,
        Downlink_TPC_enhancements_Information,
        Downlink_TPC_enhancements_Information_ExtIEs,
        _Downlink_TPC_enhancements_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements,
        ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id_tab,
        ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__id,
        ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality_tab,
        ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__criticality,
        ____Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue_tab,
        ___Downlink_TPC_enhancements_Reconf_iE_Extensions__item__extensionValue,
        __Downlink_TPC_enhancements_Reconf_iE_Extensions__item_,
        _Downlink_TPC_enhancements_Reconf_iE_Extensions,
        Downlink_TPC_enhancements_Reconf,
        Downlink_TPC_enhancements_Reconf_ExtIEs,
        Downlink_TPC_enhancements_Information_Removal,
        DPC_Mode,
        DPC_Mode_Change_SupportIndicator,
        DPCH_ID,
        DPCH_ID768,
        DPCHConstantValue,
        DRACControl,
        DRXCycleLengthCoefficient,
        _DRX_Information_uE_DRX_Cycle,
        _DRX_Information_inactivity_Threshold_for_UE_DRX_Cycle,
        _DRX_Information_inactivity_Threshold_for_UE_Grant_Monitoring,
        _DRX_Information_uE_DRX_Grant_Monitoring,
        ____DRX_Information_iE_Extensions__item__id_tab,
        _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRX_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRX_Information_iE_Extensions__item__id,
        ___DRX_Information_iE_Extensions__item__criticality,
        ___DRX_Information_iE_Extensions__item__extensionValue,
        __DRX_Information_iE_Extensions__item_,
        _DRX_Information_iE_Extensions,
        DRX_Information,
        DRX_Information_ExtIEs,
        _DRX_Information_ExtIEs_val_Extension_0,
        _DRX_Information_ExtIEs_val_Extension_1,
        _DRX_Information_to_Modify_LCR_modify,
        _DRX_Information_to_Modify_LCR_deactivate,
        DRX_Information_to_Modify_LCR,
        _DRX_Information_to_Modify_Items_LCR_hS_SCCH_DRX_Information_LCR,
        _DRX_Information_to_Modify_Items_LCR_e_AGCH_DRX_Information_LCR,
        ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id_tab,
        ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__id,
        ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality_tab,
        ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__criticality,
        ____DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue_tab,
        ___DRX_Information_to_Modify_Items_LCR_iE_Extensions__item__extensionValue,
        __DRX_Information_to_Modify_Items_LCR_iE_Extensions__item_,
        _DRX_Information_to_Modify_Items_LCR_iE_Extensions,
        DRX_Information_to_Modify_Items_LCR,
        DRX_Information_to_Modify_Items_LCR_ExtIEs,
        _DRX_Information_to_Modify_modify,
        _DRX_Information_to_Modify_deactivate,
        DRX_Information_to_Modify,
        _DRX_Information_to_Modify_Items_uE_DRX_Cycle,
        _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DRX_Cycle,
        _DRX_Information_to_Modify_Items_inactivity_Threshold_for_UE_Grant_Monitoring,
        _DRX_Information_to_Modify_Items_uE_DRX_Grant_Monitoring,
        ____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab,
        _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_0,
        _____DRX_Information_to_Modify_Items_iE_Extensions__item__id_tab_val_Extension_1,
        ___DRX_Information_to_Modify_Items_iE_Extensions__item__id,
        ___DRX_Information_to_Modify_Items_iE_Extensions__item__criticality,
        ___DRX_Information_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DRX_Information_to_Modify_Items_iE_Extensions__item_,
        _DRX_Information_to_Modify_Items_iE_Extensions,
        DRX_Information_to_Modify_Items,
        DRX_Information_to_Modify_Items_ExtIEs,
        _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_0,
        _DRX_Information_to_Modify_Items_ExtIEs_val_Extension_1,
        DSCH_RNTI,
        _DSCH_FlowControlInformation__item_,
        DSCH_FlowControlInformation,
        _DSCH_FlowControlItem_dSCH_SchedulingPriority,
        _DSCH_FlowControlItem_mAC_c_sh_SDU_Lengths,
        ____DSCH_FlowControlItem_iE_Extensions__item__id_tab,
        _____DSCH_FlowControlItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___DSCH_FlowControlItem_iE_Extensions__item__id,
        ___DSCH_FlowControlItem_iE_Extensions__item__criticality,
        ___DSCH_FlowControlItem_iE_Extensions__item__extensionValue,
        __DSCH_FlowControlItem_iE_Extensions__item_,
        _DSCH_FlowControlItem_iE_Extensions,
        DSCH_FlowControlItem,
        DSCH_FlowControlItem_ExtIEs,
        _DSCH_FlowControlItem_ExtIEs_val_Extension_0,
        DSCH_ID,
        DSCH_InitialWindowSize,
        _DSCH_TDD_Information__item_,
        DSCH_TDD_Information,
        _DSCH_TDD_InformationItem_dSCH_ID,
        _DSCH_TDD_InformationItem_dl_ccTrCHID,
        _DSCH_TDD_InformationItem_trChSourceStatisticsDescriptor,
        _DSCH_TDD_InformationItem_transportFormatSet,
        _DSCH_TDD_InformationItem_allocationRetentionPriority,
        _DSCH_TDD_InformationItem_schedulingPriorityIndicator,
        _DSCH_TDD_InformationItem_bLER,
        ____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____DSCH_TDD_InformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        ___DSCH_TDD_InformationItem_iE_Extensions__item__id,
        ___DSCH_TDD_InformationItem_iE_Extensions__item__criticality,
        ___DSCH_TDD_InformationItem_iE_Extensions__item__extensionValue,
        __DSCH_TDD_InformationItem_iE_Extensions__item_,
        _DSCH_TDD_InformationItem_iE_Extensions,
        DSCH_TDD_InformationItem,
        DSCH_TDD_InformationItem_ExtIEs,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_0,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_1,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_2,
        _DSCH_TDD_InformationItem_ExtIEs_val_Extension_3,
        DsField,
        _DTX_Cycle_2ms_Items_uE_DTX_Cycle1_2ms,
        _DTX_Cycle_2ms_Items_uE_DTX_Cycle2_2ms,
        _DTX_Cycle_2ms_Items_mAC_DTX_Cycle_2ms,
        ____DTX_Cycle_2ms_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_2ms_Items_iE_Extensions__item__id,
        ____DTX_Cycle_2ms_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_2ms_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_2ms_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_2ms_Items_iE_Extensions__item_,
        _DTX_Cycle_2ms_Items_iE_Extensions,
        DTX_Cycle_2ms_Items,
        DTX_Cycle_2ms_Items_ExtIEs,
        _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle1_2ms,
        _DTX_Cycle_2ms_to_Modify_Items_uE_DTX_Cycle2_2ms,
        _DTX_Cycle_2ms_to_Modify_Items_mAC_DTX_Cycle_2ms,
        ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__id,
        ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_2ms_to_Modify_Items_iE_Extensions__item_,
        _DTX_Cycle_2ms_to_Modify_Items_iE_Extensions,
        DTX_Cycle_2ms_to_Modify_Items,
        DTX_Cycle_2ms_to_Modify_Items_ExtIEs,
        _DTX_Cycle_10ms_Items_uE_DTX_Cycle1_10ms,
        _DTX_Cycle_10ms_Items_uE_DTX_Cycle2_10ms,
        _DTX_Cycle_10ms_Items_mAC_DTX_Cycle_10ms,
        ____DTX_Cycle_10ms_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_10ms_Items_iE_Extensions__item__id,
        ____DTX_Cycle_10ms_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_10ms_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_10ms_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_10ms_Items_iE_Extensions__item_,
        _DTX_Cycle_10ms_Items_iE_Extensions,
        DTX_Cycle_10ms_Items,
        DTX_Cycle_10ms_Items_ExtIEs,
        _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle1_10ms,
        _DTX_Cycle_10ms_to_Modify_Items_uE_DTX_Cycle2_10ms,
        _DTX_Cycle_10ms_to_Modify_Items_mAC_DTX_Cycle_10ms,
        ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id_tab,
        ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__id,
        ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__criticality,
        ____DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DTX_Cycle_10ms_to_Modify_Items_iE_Extensions__item_,
        _DTX_Cycle_10ms_to_Modify_Items_iE_Extensions,
        DTX_Cycle_10ms_to_Modify_Items,
        DTX_Cycle_10ms_to_Modify_Items_ExtIEs,
        _DTX_Information_e_DCH_TTI_Length,
        _DTX_Information_inactivity_Threshold_for_UE_DTX_Cycle2,
        _DTX_Information_uE_DTX_Long_Preamble,
        _DTX_Information_mAC_Inactivity_Threshold,
        _DTX_Information_cQI_DTX_Timer,
        _DTX_Information_uE_DPCCH_burst1,
        _DTX_Information_uE_DPCCH_burst2,
        ____DTX_Information_iE_Extensions__item__id_tab,
        ___DTX_Information_iE_Extensions__item__id,
        ____DTX_Information_iE_Extensions__item__criticality_tab,
        ___DTX_Information_iE_Extensions__item__criticality,
        ____DTX_Information_iE_Extensions__item__extensionValue_tab,
        ___DTX_Information_iE_Extensions__item__extensionValue,
        __DTX_Information_iE_Extensions__item_,
        _DTX_Information_iE_Extensions,
        DTX_Information,
        DTX_Information_ExtIEs,
        _DTX_Information2_uE_DTX_Cycle1,
        _DTX_Information2_uE_DTX_Cycle2,
        _DTX_Information2_inactivity_Threshold_for_UE_DTX_Cycle2,
        ____DTX_Information2_iE_Extensions__item__id_tab,
        ___DTX_Information2_iE_Extensions__item__id,
        ____DTX_Information2_iE_Extensions__item__criticality_tab,
        ___DTX_Information2_iE_Extensions__item__criticality,
        ____DTX_Information2_iE_Extensions__item__extensionValue_tab,
        ___DTX_Information2_iE_Extensions__item__extensionValue,
        __DTX_Information2_iE_Extensions__item_,
        _DTX_Information2_iE_Extensions,
        DTX_Information2,
        DTX_Information2_ExtIEs,
        _DTX_Information_to_Modify_modify,
        _DTX_Information_to_Modify_deactivate,
        DTX_Information_to_Modify,
        _DTX_Information_to_Modify_Items_e_DCH_TTI_Length_to_Modify,
        _DTX_Information_to_Modify_Items_inactivity_Threshold_for_UE_DTX_Cycle2,
        _DTX_Information_to_Modify_Items_uE_DTX_Long_Preamble,
        _DTX_Information_to_Modify_Items_mAC_Inactivity_Threshold,
        _DTX_Information_to_Modify_Items_cQI_DTX_Timer,
        _DTX_Information_to_Modify_Items_uE_DPCCH_burst1,
        _DTX_Information_to_Modify_Items_uE_DPCCH_burst2,
        ____DTX_Information_to_Modify_Items_iE_Extensions__item__id_tab,
        ___DTX_Information_to_Modify_Items_iE_Extensions__item__id,
        ____DTX_Information_to_Modify_Items_iE_Extensions__item__criticality_tab,
        ___DTX_Information_to_Modify_Items_iE_Extensions__item__criticality,
        ____DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue_tab,
        ___DTX_Information_to_Modify_Items_iE_Extensions__item__extensionValue,
        __DTX_Information_to_Modify_Items_iE_Extensions__item_,
        _DTX_Information_to_Modify_Items_iE_Extensions,
        DTX_Information_to_Modify_Items,
        DTX_Information_to_Modify_Items_ExtIEs,
        _Dual_Cell_EDCH_Enhancements_Information_e_TTI,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_Reference_E_TFCI_Information,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Boost_Information,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_DPCCH_Power_Offset,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_E_TFCI_Table_Index,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_Power_Offset_for_SchedulingInfo,
        _Dual_Cell_EDCH_Enhancements_Information_eDCH_Max_Set_E_DPDCHs,
        ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id_tab,
        ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__id,
        ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality_tab,
        ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__criticality,
        ____Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue_tab,
        ___Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item__extensionValue,
        __Dual_Cell_EDCH_Enhancements_Information_iE_Extensions__item_,
        _Dual_Cell_EDCH_Enhancements_Information_iE_Extensions,
        Dual_Cell_EDCH_Enhancements_Information,
        Dual_Cell_EDCH_Enhancements_Information_ExtIEs,
        EARFCN,
        EARFCN_Extended,
        _EARFCN_Information_fDD,
        _EARFCN_Information_tDD,
        _EARFCN_Information_extension_EARFCN_Information,
        EARFCN_Information,
        __Extension_EARFCN_Information_id_tab,
        ___Extension_EARFCN_Information_id_tab_val_Value_0,
        ___Extension_EARFCN_Information_id_tab_val_Value_1,
        _Extension_EARFCN_Information_id,
        _Extension_EARFCN_Information_criticality,
        _Extension_EARFCN_Information_value,
        Extension_EARFCN_Information,
        Extension_EARFCN_InformationIE,
        _Extension_EARFCN_InformationIE_val_Value_0,
        _Extension_EARFCN_InformationIE_val_Value_1,
        _EARFCN_FDD_uL_EARFCN,
        _EARFCN_FDD_dL_EARFCN,
        EARFCN_FDD,
        _EARFCN_FDD_Extended_uL_EARFCN,
        _EARFCN_FDD_Extended_dL_EARFCN,
        EARFCN_FDD_Extended,
        _E_AGCH_DRX_Information_ResponseLCR_sameAsHS_SCCH,
        _E_AGCH_DRX_Information_ResponseLCR_e_AGCH_DRX_Parameters_Response,
        E_AGCH_DRX_Information_ResponseLCR,
        _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Cycle_LCR,
        _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_Inactivity_Monitor_Threshold,
        _E_AGCH_DRX_Parameters_Response_e_AGCH_UE_DRX_Offset_LCR,
        ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id_tab,
        ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__id,
        ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality_tab,
        ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__criticality,
        ____E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_DRX_Parameters_Response_iE_Extensions__item__extensionValue,
        __E_AGCH_DRX_Parameters_Response_iE_Extensions__item_,
        _E_AGCH_DRX_Parameters_Response_iE_Extensions,
        E_AGCH_DRX_Parameters_Response,
        E_AGCH_DRX_Parameters_Response_ExtIEs,
        _E_AGCH_DRX_Information_LCR_sameAsHS_SCCH,
        _E_AGCH_DRX_Information_LCR_e_AGCH_DRX_Parameters,
        E_AGCH_DRX_Information_LCR,
        _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Cycle_LCR,
        _E_AGCH_DRX_Parameters_e_AGCH_UE_Inactivity_Monitor_Threshold,
        _E_AGCH_DRX_Parameters_e_AGCH_UE_DRX_Offset_LCR,
        ____E_AGCH_DRX_Parameters_iE_Extensions__item__id_tab,
        ___E_AGCH_DRX_Parameters_iE_Extensions__item__id,
        ____E_AGCH_DRX_Parameters_iE_Extensions__item__criticality_tab,
        ___E_AGCH_DRX_Parameters_iE_Extensions__item__criticality,
        ____E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_DRX_Parameters_iE_Extensions__item__extensionValue,
        __E_AGCH_DRX_Parameters_iE_Extensions__item_,
        _E_AGCH_DRX_Parameters_iE_Extensions,
        E_AGCH_DRX_Parameters,
        E_AGCH_DRX_Parameters_ExtIEs,
        E_AGCH_Table_Choice,
        E_AGCH_UE_Inactivity_Monitor_Threshold,
        _ECGI_pLMN_Identity,
        _ECGI_e_UTRAN_Cell_ID,
        ____ECGI_iE_Extensions__item__id_tab,
        ___ECGI_iE_Extensions__item__id,
        ____ECGI_iE_Extensions__item__criticality_tab,
        ___ECGI_iE_Extensions__item__criticality,
        ____ECGI_iE_Extensions__item__extensionValue_tab,
        ___ECGI_iE_Extensions__item__extensionValue,
        __ECGI_iE_Extensions__item_,
        _ECGI_iE_Extensions,
        ECGI,
        ECGI_ExtIEs,
        _EDCH_Additional_RL_Specific_Information_Response_List__item_,
        EDCH_Additional_RL_Specific_Information_Response_List,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_Additional_RL_ID,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_received_total_wide_band_power,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_PowerBalancing_ActivationIndicator,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_rL_Set_ID,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_e_DCH_RL_Set_ID,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_eDCH_FDD_DL_ControlChannelInformation,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dl_CodeInformation,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response_List,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maxUL_SIR,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_minUL_SIR,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maximumAllowedULTxPower,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_maximumDL_power,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_minimumDL_power,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primaryScramblingCode,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_uL_UARFCN,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_dL_UARFCN,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primaryCPICH_Power,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_pC_Preamble,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_primary_CPICH_Usage_For_Channel_Estimation,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_secondary_CPICH_Information,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_f_DPCH_SlotFormat,
        ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions__item_,
        _EDCH_Additional_RL_Specific_Information_Response_ItemIEs_iE_Extensions,
        EDCH_Additional_RL_Specific_Information_Response_ItemIEs,
        EDCH_Additional_RL_Specific_Information_Response_ItemIEs_ExtIEs,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_List__item_,
        EDCH_Additional_RL_Specific_Modified_Information_Response_List,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_eDCH_Additional_RL_ID,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_dL_PowerBalancing_UpdatedIndicator,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_eDCH_FDD_DL_ControlChannelInformation,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_additional_EDCH_MAC_d_Flow_Specific_Information_Response_List,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_maxUL_SIR,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_minUL_SIR,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_maximumDL_power,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_minimumDL_power,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_primary_CPICH_Usage_For_Channel_Estimation,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_secondary_CPICH_Information_Change,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_f_DPCH_SlotFormat,
        ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions__item_,
        _EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_iE_Extensions,
        EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs,
        EDCH_Additional_RL_Specific_Modified_Information_Response_ItemIEs_ExtIEs,
        EDCH_DDI_Value,
        E_DCH_Decoupling_Indication,
        _EDCH_FDD_DL_ControlChannelInformation_eAGCH_ERGCH_EHICH_FDD_ScramblingCode,
        _EDCH_FDD_DL_ControlChannelInformation_eAGCH_ChannelisationCode,
        _EDCH_FDD_DL_ControlChannelInformation_primary_e_RNTI,
        _EDCH_FDD_DL_ControlChannelInformation_secondary_e_RNTI,
        _EDCH_FDD_DL_ControlChannelInformation_eRGCH_EHICH_ChannelisationCode,
        _EDCH_FDD_DL_ControlChannelInformation_eRGCH_SignatureSequence,
        _EDCH_FDD_DL_ControlChannelInformation_eHICH_SignatureSequence,
        _EDCH_FDD_DL_ControlChannelInformation_serving_Grant_Value,
        _EDCH_FDD_DL_ControlChannelInformation_primary_Secondary_Grant_Selector,
        _EDCH_FDD_DL_ControlChannelInformation_e_RGCH_Release_Indicator,
        ____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab,
        _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id_tab_val_Extension_2,
        ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__id,
        ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__criticality,
        ___EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item__extensionValue,
        __EDCH_FDD_DL_ControlChannelInformation_iE_Extensions__item_,
        _EDCH_FDD_DL_ControlChannelInformation_iE_Extensions,
        EDCH_FDD_DL_ControlChannelInformation,
        EDCH_FDD_DL_ControlChannelInformation_ExtIEs,
        _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_0,
        _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_1,
        _EDCH_FDD_DL_ControlChannelInformation_ExtIEs_val_Extension_2,
        E_RGCH_E_HICH_ChannelisationCodeValidityIndicator,
        _EDCH_FDD_Information_eDCH_MACdFlows_Information,
        _EDCH_FDD_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _EDCH_FDD_Information_e_DCH_Maximum_Bitrate,
        _EDCH_FDD_Information_e_DCH_Processing_Overload_Level,
        _EDCH_FDD_Information_e_DCH_Reference_Power_Offset,
        ____EDCH_FDD_Information_iE_Extensions__item__id_tab,
        _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____EDCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5,
        ___EDCH_FDD_Information_iE_Extensions__item__id,
        ___EDCH_FDD_Information_iE_Extensions__item__criticality,
        ___EDCH_FDD_Information_iE_Extensions__item__extensionValue,
        __EDCH_FDD_Information_iE_Extensions__item_,
        _EDCH_FDD_Information_iE_Extensions,
        EDCH_FDD_Information,
        EDCH_FDD_Information_ExtIEs,
        _EDCH_FDD_Information_ExtIEs_val_Extension_0,
        _EDCH_FDD_Information_ExtIEs_val_Extension_1,
        _EDCH_FDD_Information_ExtIEs_val_Extension_2,
        _EDCH_FDD_Information_ExtIEs_val_Extension_3,
        _EDCH_FDD_Information_ExtIEs_val_Extension_4,
        _EDCH_FDD_Information_ExtIEs_val_Extension_5,
        _EDCH_FDD_InformationResponse_eDCH_MACdFlow_Specific_InformationResponse,
        _EDCH_FDD_InformationResponse_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        ____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab,
        _____EDCH_FDD_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDCH_FDD_InformationResponse_iE_Extensions__item__id,
        ___EDCH_FDD_InformationResponse_iE_Extensions__item__criticality,
        ___EDCH_FDD_InformationResponse_iE_Extensions__item__extensionValue,
        __EDCH_FDD_InformationResponse_iE_Extensions__item_,
        _EDCH_FDD_InformationResponse_iE_Extensions,
        EDCH_FDD_InformationResponse,
        EDCH_FDD_InformationResponse_ExtIEs,
        _EDCH_FDD_InformationResponse_ExtIEs_val_Extension_0,
        _EDCH_MACdFlow_Specific_InformationResponse__item_,
        EDCH_MACdFlow_Specific_InformationResponse,
        _EDCH_MACdFlow_Specific_InformationResponseItem_eDCH_MACdFlow_ID,
        _EDCH_MACdFlow_Specific_InformationResponseItem_bindingID,
        _EDCH_MACdFlow_Specific_InformationResponseItem_transportLayerAddress,
        _EDCH_MACdFlow_Specific_InformationResponseItem_hARQ_Process_Allocation_NonSched_2ms_EDCH,
        ____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab,
        _____EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__id,
        ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__criticality,
        ___EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item__extensionValue,
        __EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions__item_,
        _EDCH_MACdFlow_Specific_InformationResponseItem_iE_Extensions,
        EDCH_MACdFlow_Specific_InformationResponseItem,
        EDCH_MACdFlow_Specific_InformationResponseItem_ExtIEs,
        _EDCH_MACdFlow_Specific_InformationResponseItem_ExtIEs_val_Extension_0,
        _EDCH_FDD_Information_To_Modify_eDCH_MACdFlow_Specific_Information,
        _EDCH_FDD_Information_To_Modify_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        _EDCH_FDD_Information_To_Modify_e_DCH_Maximum_Bitrate,
        _EDCH_FDD_Information_To_Modify_e_DCH_Processing_Overload_Level,
        _EDCH_FDD_Information_To_Modify_e_DCH_Reference_Power_Offset,
        _EDCH_FDD_Information_To_Modify_mACeReset_Indicator,
        ____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7,
        _____EDCH_FDD_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8,
        ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__id,
        ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__criticality,
        ___EDCH_FDD_Information_To_Modify_iE_Extensions__item__extensionValue,
        __EDCH_FDD_Information_To_Modify_iE_Extensions__item_,
        _EDCH_FDD_Information_To_Modify_iE_Extensions,
        EDCH_FDD_Information_To_Modify,
        EDCH_FDD_Information_To_Modify_ExtIEs,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_0,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_1,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_2,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_3,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_4,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_5,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_6,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_7,
        _EDCH_FDD_Information_To_Modify_ExtIEs_val_Extension_8,
        _E_DCH_FDD_Update_Information_e_DCH_MACdFlow_Specific_UpdateInformation,
        _E_DCH_FDD_Update_Information_hARQ_Process_Allocation_Scheduled_2ms_EDCH,
        ____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab,
        _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_FDD_Update_Information_iE_Extensions__item__id,
        ___E_DCH_FDD_Update_Information_iE_Extensions__item__criticality,
        ___E_DCH_FDD_Update_Information_iE_Extensions__item__extensionValue,
        __E_DCH_FDD_Update_Information_iE_Extensions__item_,
        _E_DCH_FDD_Update_Information_iE_Extensions,
        E_DCH_FDD_Update_Information,
        E_DCH_FDD_Update_Information_ExtIEs,
        _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_0,
        _E_DCH_FDD_Update_Information_ExtIEs_val_Extension_1,
        _E_DCH_MACdFlow_Specific_UpdateInformation__item_,
        E_DCH_MACdFlow_Specific_UpdateInformation,
        _E_DCH_MACdFlow_Specific_UpdateInformation_Item_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_Specific_UpdateInformation_Item_hARQ_Process_Allocation_NonSched_2ms_EDCH,
        ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id_tab,
        ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__id,
        ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__criticality,
        ____E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions__item_,
        _E_DCH_MACdFlow_Specific_UpdateInformation_Item_iE_Extensions,
        E_DCH_MACdFlow_Specific_UpdateInformation_Item,
        E_DCH_MACdFlow_Specific_UpdateInformation_Item_ExtIEs,
        _E_DCH_DL_Control_Channel_Change_Information__item_,
        E_DCH_DL_Control_Channel_Change_Information,
        _E_DCH_DL_Control_Channel_Change_Information_Item_e_DCH_RL_ID,
        ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id_tab,
        ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__id,
        ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__criticality,
        ____E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item__extensionValue,
        __E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions__item_,
        _E_DCH_DL_Control_Channel_Change_Information_Item_iE_Extensions,
        E_DCH_DL_Control_Channel_Change_Information_Item,
        E_DCH_DL_Control_Channel_Change_Information_Item_ExtIEs,
        _E_DCH_DL_Control_Channel_Grant_Information__item_,
        E_DCH_DL_Control_Channel_Grant_Information,
        _E_DCH_DL_Control_Channel_Grant_Information_Item_e_DCH_RL_ID,
        ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id_tab,
        ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__id,
        ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__criticality,
        ____E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item__extensionValue,
        __E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions__item_,
        _E_DCH_DL_Control_Channel_Grant_Information_Item_iE_Extensions,
        E_DCH_DL_Control_Channel_Grant_Information_Item,
        E_DCH_DL_Control_Channel_Grant_Information_Item_ExtIEs,
        _E_DCH_Grant_Type_Information_e_DCH_Non_Scheduled_Transmission_Grant,
        _E_DCH_Grant_Type_Information_e_DCH_Scheduled_Transmission_Grant,
        E_DCH_Grant_Type_Information,
        E_DCH_HARQ_PO_FDD,
        _E_DCH_LogicalChannelInformation__item_,
        E_DCH_LogicalChannelInformation,
        _E_DCH_LogicalChannelInformationItem_logicalChannelId,
        _E_DCH_LogicalChannelInformationItem_schedulingPriorityIndicator,
        _E_DCH_LogicalChannelInformationItem_schedulingInformation,
        _E_DCH_LogicalChannelInformationItem_mACes_GuaranteedBitRate,
        _E_DCH_LogicalChannelInformationItem_eDCH_DDI_Value,
        _E_DCH_LogicalChannelInformationItem_mACd_PDU_Size_List,
        ____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab,
        _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__id,
        ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__criticality,
        ___E_DCH_LogicalChannelInformationItem_iE_Extensions__item__extensionValue,
        __E_DCH_LogicalChannelInformationItem_iE_Extensions__item_,
        _E_DCH_LogicalChannelInformationItem_iE_Extensions,
        E_DCH_LogicalChannelInformationItem,
        E_DCH_LogicalChannelInformationItem_ExtIEs,
        _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_0,
        _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_1,
        _E_DCH_LogicalChannelInformationItem_ExtIEs_val_Extension_2,
        E_DCH_Maximum_Bitrate,
        E_DCH_PowerOffset_for_SchedulingInfo,
        E_DCH_Processing_Overload_Level,
        E_DCH_Reference_Power_Offset,
        _E_DCH_MACdPDU_SizeList__item_,
        E_DCH_MACdPDU_SizeList,
        _E_DCH_MACdPDU_SizeListItem_mACdPDU_Size,
        ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id_tab,
        ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__id,
        ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality_tab,
        ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__criticality,
        ____E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_MACdPDU_SizeListItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdPDU_SizeListItem_iE_Extensions__item_,
        _E_DCH_MACdPDU_SizeListItem_iE_Extensions,
        E_DCH_MACdPDU_SizeListItem,
        E_DCH_MACdPDU_SizeListItem_ExtIEs,
        E_DCH_MACdPDUSizeFormat,
        _E_DCH_LogicalChannelToModify__item_,
        E_DCH_LogicalChannelToModify,
        _E_DCH_LogicalChannelToModifyItem_logicalChannelId,
        _E_DCH_LogicalChannelToModifyItem_schedulingPriorityIndicator,
        _E_DCH_LogicalChannelToModifyItem_schedulingInformation,
        _E_DCH_LogicalChannelToModifyItem_mACes_GuaranteedBitRate,
        _E_DCH_LogicalChannelToModifyItem_eDCH_DDI_Value,
        _E_DCH_LogicalChannelToModifyItem_mACd_PDU_Size_List,
        ____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab,
        _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__id,
        ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__criticality,
        ___E_DCH_LogicalChannelToModifyItem_iE_Extensions__item__extensionValue,
        __E_DCH_LogicalChannelToModifyItem_iE_Extensions__item_,
        _E_DCH_LogicalChannelToModifyItem_iE_Extensions,
        E_DCH_LogicalChannelToModifyItem,
        E_DCH_LogicalChannelToModifyItem_ExtIEs,
        _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_0,
        _E_DCH_LogicalChannelToModifyItem_ExtIEs_val_Extension_1,
        _E_DCH_MACdPDU_SizeToModifyList__item_,
        E_DCH_MACdPDU_SizeToModifyList,
        _E_DCH_LogicalChannelToDelete__item_,
        E_DCH_LogicalChannelToDelete,
        _E_DCH_LogicalChannelToDeleteItem_logicalChannelId,
        ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id_tab,
        ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__id,
        ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality_tab,
        ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__criticality,
        ____E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item__extensionValue,
        __E_DCH_LogicalChannelToDeleteItem_iE_Extensions__item_,
        _E_DCH_LogicalChannelToDeleteItem_iE_Extensions,
        E_DCH_LogicalChannelToDeleteItem,
        E_DCH_LogicalChannelToDeleteItem_ExtIEs,
        EDCH_MACdFlow_ID,
        EDCH_MACdFlow_ID_LCR,
        _EDCH_MACdFlows_Information_eDCH_MACdFlow_Specific_Information,
        ____EDCH_MACdFlows_Information_iE_Extensions__item__id_tab,
        ___EDCH_MACdFlows_Information_iE_Extensions__item__id,
        ____EDCH_MACdFlows_Information_iE_Extensions__item__criticality_tab,
        ___EDCH_MACdFlows_Information_iE_Extensions__item__criticality,
        ____EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab,
        ___EDCH_MACdFlows_Information_iE_Extensions__item__extensionValue,
        __EDCH_MACdFlows_Information_iE_Extensions__item_,
        _EDCH_MACdFlows_Information_iE_Extensions,
        EDCH_MACdFlows_Information,
        E_DCH_MACdFlow_Multiplexing_List,
        EDCH_MACdFlow_Information_ExtIEs,
        _EDCH_MACdFlow_Specific_InfoList__item_,
        EDCH_MACdFlow_Specific_InfoList,
        _EDCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_ID,
        _EDCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority,
        _EDCH_MACdFlow_Specific_InfoItem_tnlQoS,
        _EDCH_MACdFlow_Specific_InfoItem_payloadCRC_PresenceIndicator,
        _EDCH_MACdFlow_Specific_InfoItem_maxNr_Retransmissions_EDCH,
        _EDCH_MACdFlow_Specific_InfoItem_trafficClass,
        _EDCH_MACdFlow_Specific_InfoItem_eDCH_HARQ_PO_FDD,
        _EDCH_MACdFlow_Specific_InfoItem_eDCH_MACdFlow_Multiplexing_List,
        _EDCH_MACdFlow_Specific_InfoItem_eDCH_Grant_Type_Information,
        _EDCH_MACdFlow_Specific_InfoItem_bundlingModeIndicator,
        _EDCH_MACdFlow_Specific_InfoItem_eDCHLogicalChannelInformation,
        ____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab,
        _____EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id,
        ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality,
        ___EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue,
        __EDCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_,
        _EDCH_MACdFlow_Specific_InfoItem_iE_Extensions,
        EDCH_MACdFlow_Specific_InfoItem,
        EDCH_MACdFlow_Specific_InfoItem_ExtIEs,
        _EDCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0,
        _EDCH_MACdFlow_Specific_InfoToModifyList__item_,
        EDCH_MACdFlow_Specific_InfoToModifyList,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_MACdFlow_ID,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_allocationRetentionPriority,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_transportBearerRequestIndicator,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_tnlQoS,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_maxNr_Retransmissions_EDCH,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_trafficClass,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_HARQ_PO_FDD,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_MACdFlow_Multiplexing_List,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_Grant_Type_Information,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_bundlingModeIndicator,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToAdd,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToModify,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_eDCH_LogicalChannelToDelete,
        ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id_tab,
        ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__id,
        ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality_tab,
        ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__criticality,
        ____EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue_tab,
        ___EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item__extensionValue,
        __EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions__item_,
        _EDCH_MACdFlow_Specific_InfoToModifyItem_iE_Extensions,
        EDCH_MACdFlow_Specific_InfoToModifyItem,
        EDCH_MACdFlow_Specific_InfoToModifyItem_ExtIEs,
        _EDCH_MACdFlows_To_Delete__item_,
        EDCH_MACdFlows_To_Delete,
        _EDCH_MACdFlows_To_Delete_Item_eDCH_MACdFlow_ID,
        ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id_tab,
        ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__id,
        ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality_tab,
        ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__criticality,
        ____EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue_tab,
        ___EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item__extensionValue,
        __EDCH_MACdFlows_To_Delete_Item_iE_Extensions__item_,
        _EDCH_MACdFlows_To_Delete_Item_iE_Extensions,
        EDCH_MACdFlows_To_Delete_Item,
        EDCH_MACdFlows_To_Delete_Item_ExtIEs,
        _EDCH_Reference_E_TFCI_Information__item_,
        EDCH_Reference_E_TFCI_Information,
        _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI,
        _EDCH_Reference_E_TFCI_Information_Item_eDCH_reference_E_TFCI_PO,
        ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab,
        ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__id,
        ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab,
        ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality,
        ____EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue,
        __EDCH_Reference_E_TFCI_Information_Item_iE_Extensions__item_,
        _EDCH_Reference_E_TFCI_Information_Item_iE_Extensions,
        EDCH_Reference_E_TFCI_Information_Item,
        EDCH_Reference_E_TFCI_Information_Item_ExtIEs,
        EDCH_Reference_E_TFCI_PO,
        EDCH_RL_Indication,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_maxBits_MACe_PDU_non_scheduled,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_hARQ_Process_Allocation_NonSched_2ms,
        ____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab,
        _____E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__id,
        ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__criticality,
        ___E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_iE_Extensions,
        E_DCH_Non_Scheduled_Transmission_Grant_Items,
        E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs,
        _E_DCH_Non_Scheduled_Transmission_Grant_Items_ExtIEs_val_Extension_0,
        E_DCH_TFCI_Table_Index,
        _E_DCH_Serving_cell_change_informationResponse_e_DCH_serving_cell_outcome_choice,
        ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id_tab,
        ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__id,
        ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab,
        ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__criticality,
        ____E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item__extensionValue,
        __E_DCH_Serving_cell_change_informationResponse_iE_Extensions__item_,
        _E_DCH_Serving_cell_change_informationResponse_iE_Extensions,
        E_DCH_Serving_cell_change_informationResponse,
        E_DCH_serving_cell_change_informationResponse_ExtIEs,
        _E_DCH_serving_cell_change_choice_e_DCH_serving_cell_change_successful,
        _E_DCH_serving_cell_change_choice_e_DCH_serving_cell_change_unsuccessful,
        E_DCH_serving_cell_change_choice,
        _E_DCH_serving_cell_change_successful_e_DCH_RL_InformationList_Rsp,
        ____E_DCH_serving_cell_change_successful_iE_Extensions__item__id_tab,
        ___E_DCH_serving_cell_change_successful_iE_Extensions__item__id,
        ____E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality_tab,
        ___E_DCH_serving_cell_change_successful_iE_Extensions__item__criticality,
        ____E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_serving_cell_change_successful_iE_Extensions__item__extensionValue,
        __E_DCH_serving_cell_change_successful_iE_Extensions__item_,
        _E_DCH_serving_cell_change_successful_iE_Extensions,
        E_DCH_serving_cell_change_successful,
        E_DCH_serving_cell_change_successful_ExtIEs,
        _E_DCH_RL_InformationList_Rsp__item_,
        E_DCH_RL_InformationList_Rsp,
        _E_DCH_RL_InformationList_Rsp_Item_e_DCH_reconfigured_RL_Id,
        _E_DCH_RL_InformationList_Rsp_Item_e_DCH_FDD_DL_Control_Channel_Info,
        ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id_tab,
        ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__id,
        ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__criticality,
        ____E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item__extensionValue,
        __E_DCH_RL_InformationList_Rsp_Item_iE_Extensions__item_,
        _E_DCH_RL_InformationList_Rsp_Item_iE_Extensions,
        E_DCH_RL_InformationList_Rsp_Item,
        E_DCH_RL_InformationList_Rsp_Item_ExtIEs,
        _E_DCH_serving_cell_change_unsuccessful_cause,
        ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab,
        ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__id,
        ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab,
        ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__criticality,
        ____E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue,
        __E_DCH_serving_cell_change_unsuccessful_iE_Extensions__item_,
        _E_DCH_serving_cell_change_unsuccessful_iE_Extensions,
        E_DCH_serving_cell_change_unsuccessful,
        E_DCH_serving_cell_change_unsuccessful_ExtIEs,
        _E_DCH_TTI_Length_two_ms,
        _E_DCH_TTI_Length_ten_ms,
        E_DCH_TTI_Length,
        _E_DCH_TTI_Length_to_Modify_two_ms,
        _E_DCH_TTI_Length_to_Modify_ten_ms,
        E_DCH_TTI_Length_to_Modify,
        _EDPCH_Information_FDD_maxSet_E_DPDCHs,
        _EDPCH_Information_FDD_punctureLimit,
        _EDPCH_Information_FDD_e_TFCS_Information,
        _EDPCH_Information_FDD_e_TTI,
        _EDPCH_Information_FDD_e_DPCCH_PO,
        _EDPCH_Information_FDD_e_RGCH_2_IndexStepThreshold,
        _EDPCH_Information_FDD_e_RGCH_3_IndexStepThreshold,
        _EDPCH_Information_FDD_hARQ_Info_for_E_DCH,
        _EDPCH_Information_FDD_hSDSCH_Configured_Indicator,
        ____EDPCH_Information_FDD_iE_Extensions__item__id_tab,
        _____EDPCH_Information_FDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDPCH_Information_FDD_iE_Extensions__item__id,
        ___EDPCH_Information_FDD_iE_Extensions__item__criticality,
        ___EDPCH_Information_FDD_iE_Extensions__item__extensionValue,
        __EDPCH_Information_FDD_iE_Extensions__item_,
        _EDPCH_Information_FDD_iE_Extensions,
        EDPCH_Information_FDD,
        EDPCH_Information_FDD_ExtIEs,
        _EDPCH_Information_FDD_ExtIEs_val_Extension_0,
        _EDPCH_Information_RLReconfPrepare_FDD_maxSet_E_DPDCHs,
        _EDPCH_Information_RLReconfPrepare_FDD_punctureLimit,
        _EDPCH_Information_RLReconfPrepare_FDD_e_TFCS_Information,
        _EDPCH_Information_RLReconfPrepare_FDD_e_TTI,
        _EDPCH_Information_RLReconfPrepare_FDD_e_DPCCH_PO,
        _EDPCH_Information_RLReconfPrepare_FDD_e_RGCH_2_IndexStepThreshold,
        _EDPCH_Information_RLReconfPrepare_FDD_e_RGCH_3_IndexStepThreshold,
        _EDPCH_Information_RLReconfPrepare_FDD_hARQ_Info_for_E_DCH,
        _EDPCH_Information_RLReconfPrepare_FDD_hSDSCH_Configured_Indicator,
        ____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab,
        _____EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__id,
        ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__criticality,
        ___EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item__extensionValue,
        __EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions__item_,
        _EDPCH_Information_RLReconfPrepare_FDD_iE_Extensions,
        EDPCH_Information_RLReconfPrepare_FDD,
        EDPCH_Information_RLReconfPrepare_FDD_ExtIEs,
        _EDPCH_Information_RLReconfPrepare_FDD_ExtIEs_val_Extension_0,
        _EDPCH_Information_RLReconfRequest_FDD_maxSet_E_DPDCHs,
        _EDPCH_Information_RLReconfRequest_FDD_punctureLimit,
        _EDPCH_Information_RLReconfRequest_FDD_e_TFCS_Information,
        _EDPCH_Information_RLReconfRequest_FDD_e_TTI,
        _EDPCH_Information_RLReconfRequest_FDD_e_DPCCH_PO,
        _EDPCH_Information_RLReconfRequest_FDD_e_RGCH_2_IndexStepThreshold,
        _EDPCH_Information_RLReconfRequest_FDD_e_RGCH_3_IndexStepThreshold,
        _EDPCH_Information_RLReconfRequest_FDD_hARQ_Info_for_E_DCH,
        _EDPCH_Information_RLReconfRequest_FDD_hSDSCH_Configured_Indicator,
        ____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab,
        _____EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__id,
        ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__criticality,
        ___EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item__extensionValue,
        __EDPCH_Information_RLReconfRequest_FDD_iE_Extensions__item_,
        _EDPCH_Information_RLReconfRequest_FDD_iE_Extensions,
        EDPCH_Information_RLReconfRequest_FDD,
        EDPCH_Information_RLReconfRequest_FDD_ExtIEs,
        _EDPCH_Information_RLReconfRequest_FDD_ExtIEs_val_Extension_0,
        E_DPCCH_PO,
        Extended_E_DPCCH_PO,
        E_DPDCH_PowerInterpolation,
        E_Primary_Secondary_Grant_Selector,
        EHICH_SignatureSequence,
        E_RGCH_Release_Indicator,
        ERGCH_SignatureSequence,
        E_Serving_Grant_Value,
        E_RGCH_2_IndexStepThreshold,
        E_RGCH_3_IndexStepThreshold,
        _EDCH_Serving_RL_e_DCH_Serving_RL_in_this_DRNS,
        _EDCH_Serving_RL_e_DCH_Serving_RL_not_in_this_DRNS,
        EDCH_Serving_RL,
        _EDCH_Serving_RL_in_this_DRNS_e_DCH_Serving_RL_Id,
        ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id_tab,
        ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__id,
        ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality_tab,
        ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__criticality,
        ____EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue_tab,
        ___EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item__extensionValue,
        __EDCH_Serving_RL_in_this_DRNS_iE_Extensions__item_,
        _EDCH_Serving_RL_in_this_DRNS_iE_Extensions,
        EDCH_Serving_RL_in_this_DRNS,
        EDCH_Serving_RL_in_this_DRNS_ExtIEs,
        _Enhanced_FACH_Information_ResponseFDD_common_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH,
        _Enhanced_FACH_Information_ResponseFDD_dedicated_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH,
        _Enhanced_FACH_Information_ResponseFDD_priorityQueueInfo_EnhancedPCH,
        _Enhanced_FACH_Information_ResponseFDD_hSDSCH_Initial_Capacity_Allocation,
        _Enhanced_FACH_Information_ResponseFDD_hSDSCH_RNTI,
        ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id_tab,
        ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__id,
        ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality_tab,
        ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__criticality,
        ____Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue_tab,
        ___Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item__extensionValue,
        __Enhanced_FACH_Information_ResponseFDD_iE_Extensions__item_,
        _Enhanced_FACH_Information_ResponseFDD_iE_Extensions,
        Enhanced_FACH_Information_ResponseFDD,
        Enhanced_FACH_Information_ResponseFDD_ExtIEs,
        _Enhanced_FACH_Information_ResponseLCR_common_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH,
        _Enhanced_FACH_Information_ResponseLCR_dedicated_HS_DSCH_RNTI_priorityQueueInfo_EnhancedFACH,
        _Enhanced_FACH_Information_ResponseLCR_priorityQueueInfo_EnhancedPCH,
        _Enhanced_FACH_Information_ResponseLCR_hSDSCH_Initial_Capacity_Allocation,
        _Enhanced_FACH_Information_ResponseLCR_hSDSCH_RNTI,
        ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id_tab,
        ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__id,
        ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__criticality,
        ____Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __Enhanced_FACH_Information_ResponseLCR_iE_Extensions__item_,
        _Enhanced_FACH_Information_ResponseLCR_iE_Extensions,
        Enhanced_FACH_Information_ResponseLCR,
        Enhanced_FACH_Information_ResponseLCR_ExtIEs,
        Enhanced_FACH_Support_Indicator,
        EnhancedHSServingCC_Abort,
        Enhanced_PCH_Capability,
        E_RNTI,
        E_ROCH_PowerOffset,
        E_TFCI,
        E_TFCI_BetaEC_Boost,
        _E_TFCI_Boost_Information_e_TFCI_BetaEC_Boost,
        _E_TFCI_Boost_Information_uL_Delta_T2TP,
        ____E_TFCI_Boost_Information_iE_Extensions__item__id_tab,
        ___E_TFCI_Boost_Information_iE_Extensions__item__id,
        ____E_TFCI_Boost_Information_iE_Extensions__item__criticality_tab,
        ___E_TFCI_Boost_Information_iE_Extensions__item__criticality,
        ____E_TFCI_Boost_Information_iE_Extensions__item__extensionValue_tab,
        ___E_TFCI_Boost_Information_iE_Extensions__item__extensionValue,
        __E_TFCI_Boost_Information_iE_Extensions__item_,
        _E_TFCI_Boost_Information_iE_Extensions,
        E_TFCI_Boost_Information,
        E_TFCI_Boost_Information_ExtIEs,
        _E_TFCS_Information_e_DCH_TFCI_Table_Index,
        _E_TFCS_Information_e_DCH_Min_Set_E_TFCI,
        _E_TFCS_Information_reference_E_TFCI_Information,
        ____E_TFCS_Information_iE_Extensions__item__id_tab,
        _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_TFCS_Information_iE_Extensions__item__id_tab_val_Extension_2,
        ___E_TFCS_Information_iE_Extensions__item__id,
        ___E_TFCS_Information_iE_Extensions__item__criticality,
        ___E_TFCS_Information_iE_Extensions__item__extensionValue,
        __E_TFCS_Information_iE_Extensions__item_,
        _E_TFCS_Information_iE_Extensions,
        E_TFCS_Information,
        E_TFCS_Information_ExtIEs,
        _E_TFCS_Information_ExtIEs_val_Extension_0,
        _E_TFCS_Information_ExtIEs_val_Extension_1,
        _E_TFCS_Information_ExtIEs_val_Extension_2,
        E_DCH_Minimum_Set_E_TFCIValidityIndicator,
        E_TTI,
        E_AGCH_PowerOffset,
        E_RGCH_PowerOffset,
        E_HICH_PowerOffset,
        Enhanced_PrimaryCPICH_EcNo,
        _EventA_measurementTreshold,
        _EventA_measurementHysteresisTime,
        ____EventA_iE_Extensions__item__id_tab,
        ___EventA_iE_Extensions__item__id,
        ____EventA_iE_Extensions__item__criticality_tab,
        ___EventA_iE_Extensions__item__criticality,
        ____EventA_iE_Extensions__item__extensionValue_tab,
        ___EventA_iE_Extensions__item__extensionValue,
        __EventA_iE_Extensions__item_,
        _EventA_iE_Extensions,
        EventA,
        EventA_ExtIEs,
        _EventB_measurementTreshold,
        _EventB_measurementHysteresisTime,
        ____EventB_iE_Extensions__item__id_tab,
        ___EventB_iE_Extensions__item__id,
        ____EventB_iE_Extensions__item__criticality_tab,
        ___EventB_iE_Extensions__item__criticality,
        ____EventB_iE_Extensions__item__extensionValue_tab,
        ___EventB_iE_Extensions__item__extensionValue,
        __EventB_iE_Extensions__item_,
        _EventB_iE_Extensions,
        EventB,
        EventB_ExtIEs,
        _EventC_measurementIncreaseDecreaseThreshold,
        _EventC_measurementChangeTime,
        ____EventC_iE_Extensions__item__id_tab,
        ___EventC_iE_Extensions__item__id,
        ____EventC_iE_Extensions__item__criticality_tab,
        ___EventC_iE_Extensions__item__criticality,
        ____EventC_iE_Extensions__item__extensionValue_tab,
        ___EventC_iE_Extensions__item__extensionValue,
        __EventC_iE_Extensions__item_,
        _EventC_iE_Extensions,
        EventC,
        EventC_ExtIEs,
        _EventD_measurementIncreaseDecreaseThreshold,
        _EventD_measurementChangeTime,
        ____EventD_iE_Extensions__item__id_tab,
        ___EventD_iE_Extensions__item__id,
        ____EventD_iE_Extensions__item__criticality_tab,
        ___EventD_iE_Extensions__item__criticality,
        ____EventD_iE_Extensions__item__extensionValue_tab,
        ___EventD_iE_Extensions__item__extensionValue,
        __EventD_iE_Extensions__item_,
        _EventD_iE_Extensions,
        EventD,
        EventD_ExtIEs,
        _EventE_measurementThreshold1,
        _EventE_measurementThreshold2,
        _EventE_measurementHysteresisTime,
        _EventE_reportPeriodicity,
        ____EventE_iE_Extensions__item__id_tab,
        ___EventE_iE_Extensions__item__id,
        ____EventE_iE_Extensions__item__criticality_tab,
        ___EventE_iE_Extensions__item__criticality,
        ____EventE_iE_Extensions__item__extensionValue_tab,
        ___EventE_iE_Extensions__item__extensionValue,
        __EventE_iE_Extensions__item_,
        _EventE_iE_Extensions,
        EventE,
        EventE_ExtIEs,
        _EventF_measurementThreshold1,
        _EventF_measurementThreshold2,
        _EventF_measurementHysteresisTime,
        _EventF_reportPeriodicity,
        ____EventF_iE_Extensions__item__id_tab,
        ___EventF_iE_Extensions__item__id,
        ____EventF_iE_Extensions__item__criticality_tab,
        ___EventF_iE_Extensions__item__criticality,
        ____EventF_iE_Extensions__item__extensionValue_tab,
        ___EventF_iE_Extensions__item__extensionValue,
        __EventF_iE_Extensions__item_,
        _EventF_iE_Extensions,
        EventF,
        EventF_ExtIEs,
        _EventH_measurementThreshold1,
        _EventH_measurementThreshold2,
        _EventH_measurementHysteresisTime,
        _EventH_reportPeriodicity,
        _EventH_measurementFluctuationRange,
        ____EventH_iE_Extensions__item__id_tab,
        ___EventH_iE_Extensions__item__id,
        ____EventH_iE_Extensions__item__criticality_tab,
        ___EventH_iE_Extensions__item__criticality,
        ____EventH_iE_Extensions__item__extensionValue_tab,
        ___EventH_iE_Extensions__item__extensionValue,
        __EventH_iE_Extensions__item_,
        _EventH_iE_Extensions,
        EventH,
        EventH_ExtIEs,
        _Event1F_Parameters_measurementQuantity,
        _Event1F_Parameters_threshold,
        Event1F_Parameters,
        _Event1I_Parameters_threshold,
        Event1I_Parameters,
        ExtendedGSMCellIndividualOffset,
        _E_DCH_Information_e_PUCH_Information,
        _E_DCH_Information_e_TFCS_Information_TDD,
        _E_DCH_Information_e_DCH_MACdFlows_Information_TDD,
        _E_DCH_Information_e_DCH_TDD_Information,
        ____E_DCH_Information_iE_Extensions__item__id_tab,
        ___E_DCH_Information_iE_Extensions__item__id,
        ____E_DCH_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_Information_iE_Extensions__item__criticality,
        ____E_DCH_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Information_iE_Extensions__item__extensionValue,
        __E_DCH_Information_iE_Extensions__item_,
        _E_DCH_Information_iE_Extensions,
        E_DCH_Information,
        E_DCH_Information_ExtIEs,
        _E_PUCH_Information_minCR,
        _E_PUCH_Information_maxCR,
        _E_PUCH_Information_harqInfo,
        _E_PUCH_Information_n_E_UCCH,
        ____E_PUCH_Information_iE_Extensions__item__id_tab,
        ___E_PUCH_Information_iE_Extensions__item__id,
        ____E_PUCH_Information_iE_Extensions__item__criticality_tab,
        ___E_PUCH_Information_iE_Extensions__item__criticality,
        ____E_PUCH_Information_iE_Extensions__item__extensionValue_tab,
        ___E_PUCH_Information_iE_Extensions__item__extensionValue,
        __E_PUCH_Information_iE_Extensions__item_,
        _E_PUCH_Information_iE_Extensions,
        E_PUCH_Information,
        E_PUCH_Information_ExtIEs,
        _E_TFCS_Information_TDD_e_DCH_QPSK_RefBetaInfo,
        _E_TFCS_Information_TDD_e_DCH_sixteenQAM_RefBetaInfo,
        ____E_TFCS_Information_TDD_iE_Extensions__item__id_tab,
        ___E_TFCS_Information_TDD_iE_Extensions__item__id,
        ____E_TFCS_Information_TDD_iE_Extensions__item__criticality_tab,
        ___E_TFCS_Information_TDD_iE_Extensions__item__criticality,
        ____E_TFCS_Information_TDD_iE_Extensions__item__extensionValue_tab,
        ___E_TFCS_Information_TDD_iE_Extensions__item__extensionValue,
        __E_TFCS_Information_TDD_iE_Extensions__item_,
        _E_TFCS_Information_TDD_iE_Extensions,
        E_TFCS_Information_TDD,
        E_TFCS_Information_TDD_ExtIEs,
        _E_DCH_QPSK_RefBetaInfo__item_,
        E_DCH_QPSK_RefBetaInfo,
        _E_DCH_sixteenQAM_RefBetaInfo__item_,
        E_DCH_sixteenQAM_RefBetaInfo,
        _E_DCH_RefBeta_Item_refCodeRate,
        _E_DCH_RefBeta_Item_refBeta,
        E_DCH_RefBeta_Item,
        _E_DCH_MACdFlows_Information_TDD__item_,
        E_DCH_MACdFlows_Information_TDD,
        _E_DCH_MACdFlow_InfoTDDItem_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_InfoTDDItem_allocationRetentionPriority,
        _E_DCH_MACdFlow_InfoTDDItem_tnlQos,
        _E_DCH_MACdFlow_InfoTDDItem_bindingID,
        _E_DCH_MACdFlow_InfoTDDItem_transportLayerAddress,
        _E_DCH_MACdFlow_InfoTDDItem_payloadCRC_PresenceIndicator,
        _E_DCH_MACdFlow_InfoTDDItem_maximum_Number_of_Retransmissions_For_E_DCH,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_HARQ_PO_TDD,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_InfoTDDItem_eDCH_Grant_TypeTDD,
        _E_DCH_MACdFlow_InfoTDDItem_eDCHLogicalChannelInformation,
        ____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab,
        _____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__id,
        ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__criticality,
        ___E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_InfoTDDItem_iE_Extensions__item_,
        _E_DCH_MACdFlow_InfoTDDItem_iE_Extensions,
        E_DCH_MACdFlow_InfoTDDItem,
        E_DCH_MACdFlow_InfoTDDItem_ExtIEs,
        _E_DCH_MACdFlow_InfoTDDItem_ExtIEs_val_Extension_0,
        _E_DCH_MACdFlow_InfoTDDItem_ExtIEs_val_Extension_1,
        E_DCH_MACdFlow_Retransmission_Timer_LCR,
        E_DCH_HARQ_PO_TDD,
        E_DCH_Grant_TypeTDD,
        E_DCH_TimeslotResource,
        E_DCH_PowerResource,
        TddE_PUCH_Offset,
        _E_DCH_TDD_Information_e_DCH_TDD_Maximum_Bitrate,
        _E_DCH_TDD_Information_e_DCH_Processing_Overload_Level,
        _E_DCH_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo,
        ____E_DCH_TDD_Information_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_Information_iE_Extensions__item__id,
        ____E_DCH_TDD_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_Information_iE_Extensions__item__criticality,
        ____E_DCH_TDD_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_Information_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_Information_iE_Extensions__item_,
        _E_DCH_TDD_Information_iE_Extensions,
        E_DCH_TDD_Information,
        E_DCH_TDD_Information_ExtIEs,
        E_DCH_TDD_Maximum_Bitrate,
        _E_DCH_Information_Reconfig_e_PUCH_Information,
        _E_DCH_Information_Reconfig_e_TFCS_Information_TDD,
        _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Add,
        _E_DCH_Information_Reconfig_e_DCH_MACdFlows_to_Delete,
        _E_DCH_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info,
        _E_DCH_Information_Reconfig_e_DCH_TDD_Information,
        _E_DCH_Information_Reconfig_e_DCH_TDD_Information_to_Modify,
        ____E_DCH_Information_Reconfig_iE_Extensions__item__id_tab,
        ___E_DCH_Information_Reconfig_iE_Extensions__item__id,
        ____E_DCH_Information_Reconfig_iE_Extensions__item__criticality_tab,
        ___E_DCH_Information_Reconfig_iE_Extensions__item__criticality,
        ____E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Information_Reconfig_iE_Extensions__item__extensionValue,
        __E_DCH_Information_Reconfig_iE_Extensions__item_,
        _E_DCH_Information_Reconfig_iE_Extensions,
        E_DCH_Information_Reconfig,
        E_DCH_Information_Reconfig_ExtIEs,
        _E_DCH_TDD_Information_to_Modify_e_DCH_TDD_Information_to_Modify_List,
        _E_DCH_TDD_Information_to_Modify_mACeReset_Indicator,
        ____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab,
        _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__id,
        ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__criticality,
        ___E_DCH_TDD_Information_to_Modify_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_Information_to_Modify_iE_Extensions__item_,
        _E_DCH_TDD_Information_to_Modify_iE_Extensions,
        E_DCH_TDD_Information_to_Modify,
        E_DCH_TDD_Information_to_Modify_ExtIEs,
        _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_0,
        _E_DCH_TDD_Information_to_Modify_ExtIEs_val_Extension_1,
        _E_DCH_TDD_Information_to_Modify_List__item_,
        E_DCH_TDD_Information_to_Modify_List,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_MACdFlow_ID,
        _E_DCH_MACdFlow_ModifyTDDItem_allocationRetentionPriority,
        _E_DCH_MACdFlow_ModifyTDDItem_transportBearerRequestIndicator,
        _E_DCH_MACdFlow_ModifyTDDItem_bindingID,
        _E_DCH_MACdFlow_ModifyTDDItem_transportLayerAddress,
        _E_DCH_MACdFlow_ModifyTDDItem_tnlQos,
        _E_DCH_MACdFlow_ModifyTDDItem_maximum_Number_of_Retransmissions_For_E_DCH,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_HARQ_PO_TDD,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_MACdFlow_Multiplexing_List,
        _E_DCH_MACdFlow_ModifyTDDItem_eDCH_Grant_TypeTDD,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToAdd,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToModify,
        _E_DCH_MACdFlow_ModifyTDDItem_e_DCH_LogicalChannelToDelete,
        ____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab,
        _____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__id,
        ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__criticality,
        ___E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item__extensionValue,
        __E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions__item_,
        _E_DCH_MACdFlow_ModifyTDDItem_iE_Extensions,
        E_DCH_MACdFlow_ModifyTDDItem,
        E_DCH_MACdFlow_ModifyTDDItem_ExtIEs,
        _E_DCH_MACdFlow_ModifyTDDItem_ExtIEs_val_Extension_0,
        _E_DCH_MACdFlow_ModifyTDDItem_ExtIEs_val_Extension_1,
        _E_DCH_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp,
        _E_DCH_Information_Response_e_AGCH_Specific_Information_ResponseTDD,
        _E_DCH_Information_Response_e_HICH_Information_Response,
        _E_DCH_Information_Response_e_DCH_Non_Scheduled_Grant_Info,
        _E_DCH_Information_Response_e_RNTI,
        ____E_DCH_Information_Response_iE_Extensions__item__id_tab,
        ___E_DCH_Information_Response_iE_Extensions__item__id,
        ____E_DCH_Information_Response_iE_Extensions__item__criticality_tab,
        ___E_DCH_Information_Response_iE_Extensions__item__criticality,
        ____E_DCH_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Information_Response_iE_Extensions__item__extensionValue,
        __E_DCH_Information_Response_iE_Extensions__item_,
        _E_DCH_Information_Response_iE_Extensions,
        E_DCH_Information_Response,
        E_DCH_Information_Response_ExtIEs,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp__item_,
        E_DCH_TDD_MACdFlow_Specific_InformationResp,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_e_DCH_MacdFlow_Id,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_bindingID,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_transportLayerAddress,
        ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__id,
        ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__criticality,
        ____E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions__item_,
        _E_DCH_TDD_MACdFlow_Specific_InformationResp_Item_iE_Extensions,
        E_DCH_TDD_MACdFlow_Specific_InformationResp_Item,
        E_DCH_TDD_MACdFlow_Specific_InformationRespItem_ExtIEs,
        _E_AGCH_Specific_InformationRespListTDD__item_,
        E_AGCH_Specific_InformationRespListTDD,
        _E_AGCH_Specific_InformationResp_ItemTDD_timeslot,
        _E_AGCH_Specific_InformationResp_ItemTDD_midambleShiftAndBurstType,
        _E_AGCH_Specific_InformationResp_ItemTDD_tDD_ChannelisationCode,
        ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id_tab,
        ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__id,
        ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality_tab,
        ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__criticality,
        ____E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item__extensionValue,
        __E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions__item_,
        _E_AGCH_Specific_InformationResp_ItemTDD_iE_Extensions,
        E_AGCH_Specific_InformationResp_ItemTDD,
        E_AGCH_Specific_InformationResp_ItemTDD_ExtIEs,
        _E_HICH_InformationResp_timeslot,
        _E_HICH_InformationResp_midambleShiftAndBurstType,
        _E_HICH_InformationResp_tDD_ChannelisationCode,
        _E_HICH_InformationResp_e_HICH_TimeOffset,
        ____E_HICH_InformationResp_iE_Extensions__item__id_tab,
        ___E_HICH_InformationResp_iE_Extensions__item__id,
        ____E_HICH_InformationResp_iE_Extensions__item__criticality_tab,
        ___E_HICH_InformationResp_iE_Extensions__item__criticality,
        ____E_HICH_InformationResp_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_InformationResp_iE_Extensions__item__extensionValue,
        __E_HICH_InformationResp_iE_Extensions__item_,
        _E_HICH_InformationResp_iE_Extensions,
        E_HICH_InformationResp,
        E_HICH_InformationResp_ExtIEs,
        E_HICH_TimeOffset,
        _E_DCH_Non_Scheduled_Grant_Info_timeslotResource,
        _E_DCH_Non_Scheduled_Grant_Info_powerResource,
        _E_DCH_Non_Scheduled_Grant_Info_repetitionPeriod,
        _E_DCH_Non_Scheduled_Grant_Info_repetitionLength,
        _E_DCH_Non_Scheduled_Grant_Info_tddE_PUCH_Offset,
        _E_DCH_Non_Scheduled_Grant_Info_tdd_ChannelisationCode,
        ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__id,
        ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__criticality,
        ____E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Grant_Info_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Grant_Info_iE_Extensions,
        E_DCH_Non_Scheduled_Grant_Info,
        E_DCH_Non_Scheduled_Grant_Info_ExtIEs,
        _E_DCH_768_Information_e_PUCH_Information,
        _E_DCH_768_Information_e_TFCS_Information_TDD,
        _E_DCH_768_Information_e_DCH_MACdFlows_Information_TDD,
        _E_DCH_768_Information_e_DCH_TDD_Information768,
        ____E_DCH_768_Information_iE_Extensions__item__id_tab,
        ___E_DCH_768_Information_iE_Extensions__item__id,
        ____E_DCH_768_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_768_Information_iE_Extensions__item__criticality,
        ____E_DCH_768_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_768_Information_iE_Extensions__item__extensionValue,
        __E_DCH_768_Information_iE_Extensions__item_,
        _E_DCH_768_Information_iE_Extensions,
        E_DCH_768_Information,
        E_DCH_768_Information_ExtIEs,
        _E_DCH_TDD_Information768_e_DCH_TDD_Maximum_Bitrate768,
        _E_DCH_TDD_Information768_e_DCH_Processing_Overload_Level,
        _E_DCH_TDD_Information768_e_DCH_PowerOffset_for_SchedulingInfo,
        ____E_DCH_TDD_Information768_iE_Extensions__item__id_tab,
        ___E_DCH_TDD_Information768_iE_Extensions__item__id,
        ____E_DCH_TDD_Information768_iE_Extensions__item__criticality_tab,
        ___E_DCH_TDD_Information768_iE_Extensions__item__criticality,
        ____E_DCH_TDD_Information768_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_TDD_Information768_iE_Extensions__item__extensionValue,
        __E_DCH_TDD_Information768_iE_Extensions__item_,
        _E_DCH_TDD_Information768_iE_Extensions,
        E_DCH_TDD_Information768,
        E_DCH_TDD_Information768_ExtIEs,
        E_DCH_TDD_Maximum_Bitrate768,
        _E_DCH_768_Information_Reconfig_e_PUCH_Information,
        _E_DCH_768_Information_Reconfig_e_TFCS_Information_TDD,
        _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Add,
        _E_DCH_768_Information_Reconfig_e_DCH_MACdFlows_to_Delete,
        _E_DCH_768_Information_Reconfig_e_DCH_Non_Scheduled_Grant_Info768,
        _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information768,
        _E_DCH_768_Information_Reconfig_e_DCH_TDD_Information_to_Modify,
        ____E_DCH_768_Information_Reconfig_iE_Extensions__item__id_tab,
        ___E_DCH_768_Information_Reconfig_iE_Extensions__item__id,
        ____E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality_tab,
        ___E_DCH_768_Information_Reconfig_iE_Extensions__item__criticality,
        ____E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_768_Information_Reconfig_iE_Extensions__item__extensionValue,
        __E_DCH_768_Information_Reconfig_iE_Extensions__item_,
        _E_DCH_768_Information_Reconfig_iE_Extensions,
        E_DCH_768_Information_Reconfig,
        E_DCH_768_Information_Reconfig_ExtIEs,
        _E_DCH_768_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp,
        _E_DCH_768_Information_Response_e_AGCH_Specific_Information_Response768TDD,
        _E_DCH_768_Information_Response_e_HICH_Information_Response768,
        _E_DCH_768_Information_Response_e_DCH_Non_Scheduled_Grant_Info768,
        _E_DCH_768_Information_Response_e_RNTI,
        ____E_DCH_768_Information_Response_iE_Extensions__item__id_tab,
        ___E_DCH_768_Information_Response_iE_Extensions__item__id,
        ____E_DCH_768_Information_Response_iE_Extensions__item__criticality_tab,
        ___E_DCH_768_Information_Response_iE_Extensions__item__criticality,
        ____E_DCH_768_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_768_Information_Response_iE_Extensions__item__extensionValue,
        __E_DCH_768_Information_Response_iE_Extensions__item_,
        _E_DCH_768_Information_Response_iE_Extensions,
        E_DCH_768_Information_Response,
        E_DCH_768_Information_Response_ExtIEs,
        _E_AGCH_Specific_InformationRespList768TDD__item_,
        E_AGCH_Specific_InformationRespList768TDD,
        _E_AGCH_Specific_InformationResp_Item768TDD_timeslot,
        _E_AGCH_Specific_InformationResp_Item768TDD_midambleShiftAndBurstType768,
        _E_AGCH_Specific_InformationResp_Item768TDD_tDD_ChannelisationCode768,
        ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id_tab,
        ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__id,
        ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality_tab,
        ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__criticality,
        ____E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item__extensionValue,
        __E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions__item_,
        _E_AGCH_Specific_InformationResp_Item768TDD_iE_Extensions,
        E_AGCH_Specific_InformationResp_Item768TDD,
        E_AGCH_Specific_InformationResp_Item768TDD_ExtIEs,
        _E_HICH_InformationResp768_timeslot,
        _E_HICH_InformationResp768_midambleShiftAndBurstType768,
        _E_HICH_InformationResp768_tDD_ChannelisationCode768,
        _E_HICH_InformationResp768_e_HICH_TimeOffset,
        ____E_HICH_InformationResp768_iE_Extensions__item__id_tab,
        ___E_HICH_InformationResp768_iE_Extensions__item__id,
        ____E_HICH_InformationResp768_iE_Extensions__item__criticality_tab,
        ___E_HICH_InformationResp768_iE_Extensions__item__criticality,
        ____E_HICH_InformationResp768_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_InformationResp768_iE_Extensions__item__extensionValue,
        __E_HICH_InformationResp768_iE_Extensions__item_,
        _E_HICH_InformationResp768_iE_Extensions,
        E_HICH_InformationResp768,
        E_HICH_InformationResp768_ExtIEs,
        _E_DCH_Non_Scheduled_Grant_Info768_timeslotResource,
        _E_DCH_Non_Scheduled_Grant_Info768_powerResource,
        _E_DCH_Non_Scheduled_Grant_Info768_repetitionPeriod,
        _E_DCH_Non_Scheduled_Grant_Info768_repetitionLength,
        _E_DCH_Non_Scheduled_Grant_Info768_tddE_PUCH_Offset,
        _E_DCH_Non_Scheduled_Grant_Info768_tdd_ChannelisationCode768,
        ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id_tab,
        ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__id,
        ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality_tab,
        ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__criticality,
        ____E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Grant_Info768_iE_Extensions,
        E_DCH_Non_Scheduled_Grant_Info768,
        E_DCH_Non_Scheduled_Grant_Info768_ExtIEs,
        _E_DCH_LCR_Information_e_PUCH_LCR_Information,
        _E_DCH_LCR_Information_e_TFCS_Information_TDD,
        _E_DCH_LCR_Information_e_DCH_MACdFlows_Information_TDD,
        _E_DCH_LCR_Information_e_DCH_LCR_TDD_Information,
        ____E_DCH_LCR_Information_iE_Extensions__item__id_tab,
        ___E_DCH_LCR_Information_iE_Extensions__item__id,
        ____E_DCH_LCR_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_LCR_Information_iE_Extensions__item__criticality,
        ____E_DCH_LCR_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LCR_Information_iE_Extensions__item__extensionValue,
        __E_DCH_LCR_Information_iE_Extensions__item_,
        _E_DCH_LCR_Information_iE_Extensions,
        E_DCH_LCR_Information,
        E_DCH_Information_LCR_ExtIEs,
        _E_PUCH_LCR_Information_minCR,
        _E_PUCH_LCR_Information_maxCR,
        _E_PUCH_LCR_Information_harqInfo,
        _E_PUCH_LCR_Information_pRxdesBase,
        _E_PUCH_LCR_Information_e_PUCH_TPC_Step_Size,
        _E_PUCH_LCR_Information_n_E_UCCH_LCR,
        ____E_PUCH_LCR_Information_iE_Extensions__item__id_tab,
        _____E_PUCH_LCR_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___E_PUCH_LCR_Information_iE_Extensions__item__id,
        ___E_PUCH_LCR_Information_iE_Extensions__item__criticality,
        ___E_PUCH_LCR_Information_iE_Extensions__item__extensionValue,
        __E_PUCH_LCR_Information_iE_Extensions__item_,
        _E_PUCH_LCR_Information_iE_Extensions,
        E_PUCH_LCR_Information,
        E_PUCH_Information_LCR_ExtIEs,
        _E_PUCH_Information_LCR_ExtIEs_val_Extension_0,
        E_PUCH_PRXdesBase,
        _E_DCH_LCR_TDD_Information_e_DCH_Physical_Layer_Category_LCR,
        _E_DCH_LCR_TDD_Information_e_DCH_Processing_Overload_Level,
        _E_DCH_LCR_TDD_Information_e_DCH_PowerOffset_for_SchedulingInfo,
        ____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____E_DCH_LCR_TDD_Information_iE_Extensions__item__id_tab_val_Extension_6,
        ___E_DCH_LCR_TDD_Information_iE_Extensions__item__id,
        ___E_DCH_LCR_TDD_Information_iE_Extensions__item__criticality,
        ___E_DCH_LCR_TDD_Information_iE_Extensions__item__extensionValue,
        __E_DCH_LCR_TDD_Information_iE_Extensions__item_,
        _E_DCH_LCR_TDD_Information_iE_Extensions,
        E_DCH_LCR_TDD_Information,
        E_DCH_LCR_TDD_Information_ExtIEs,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_0,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_1,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_2,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_3,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_4,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_5,
        _E_DCH_LCR_TDD_Information_ExtIEs_val_Extension_6,
        E_DCH_Physical_Layer_Category_LCR,
        _Execution_Type_synchronised,
        _Execution_Type_unsynchronised,
        Execution_Type,
        Extended_E_DCH_LCRTDD_PhysicalLayerCategory,
        __Extension_CommonMeasurementValue_id_tab,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_0,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_1,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_2,
        ___Extension_CommonMeasurementValue_id_tab_val_Value_3,
        _Extension_CommonMeasurementValue_id,
        _Extension_CommonMeasurementValue_criticality,
        _Extension_CommonMeasurementValue_value,
        Extension_CommonMeasurementValue,
        Extension_CommonMeasurementValueIE,
        _Extension_CommonMeasurementValueIE_val_Value_0,
        _Extension_CommonMeasurementValueIE_val_Value_1,
        _Extension_CommonMeasurementValueIE_val_Value_2,
        _Extension_CommonMeasurementValueIE_val_Value_3,
        __Extension_DedicatedMeasurementValue_id_tab,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_0,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_1,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_2,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_3,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_4,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_5,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_6,
        ___Extension_DedicatedMeasurementValue_id_tab_val_Value_7,
        _Extension_DedicatedMeasurementValue_id,
        _Extension_DedicatedMeasurementValue_criticality,
        _Extension_DedicatedMeasurementValue_value,
        Extension_DedicatedMeasurementValue,
        Extension_DedicatedMeasurementValueIE,
        _Extension_DedicatedMeasurementValueIE_val_Value_0,
        _Extension_DedicatedMeasurementValueIE_val_Value_1,
        _Extension_DedicatedMeasurementValueIE_val_Value_2,
        _Extension_DedicatedMeasurementValueIE_val_Value_3,
        _Extension_DedicatedMeasurementValueIE_val_Value_4,
        _Extension_DedicatedMeasurementValueIE_val_Value_5,
        _Extension_DedicatedMeasurementValueIE_val_Value_6,
        _Extension_DedicatedMeasurementValueIE_val_Value_7,
        _E_DCH_LCR_Information_Reconfig_e_PUCH_LCR_Information,
        _E_DCH_LCR_Information_Reconfig_e_TFCS_Information_TDD,
        _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Add,
        _E_DCH_LCR_Information_Reconfig_e_DCH_MACdFlows_to_Delete,
        _E_DCH_LCR_Information_Reconfig_e_DCH_LCR_TDD_Information,
        _E_DCH_LCR_Information_Reconfig_e_DCH_TDD_Information_to_Modify,
        ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id_tab,
        ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__id,
        ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality_tab,
        ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__criticality,
        ____E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LCR_Information_Reconfig_iE_Extensions__item__extensionValue,
        __E_DCH_LCR_Information_Reconfig_iE_Extensions__item_,
        _E_DCH_LCR_Information_Reconfig_iE_Extensions,
        E_DCH_LCR_Information_Reconfig,
        E_DCH_Information_Reconfig_LCR_ExtIEs,
        _E_DCH_LCR_Information_Response_e_DCH_TDD_MACdFlow_Specific_InformationResp,
        _E_DCH_LCR_Information_Response_e_AGCH_Specific_Information_Response_LCR_TDD,
        _E_DCH_LCR_Information_Response_e_HICH_Specific_Information_Response_LCR,
        _E_DCH_LCR_Information_Response_e_DCH_Non_Scheduled_Grant_Info_LCR,
        _E_DCH_LCR_Information_Response_e_RNTI,
        ____E_DCH_LCR_Information_Response_iE_Extensions__item__id_tab,
        ___E_DCH_LCR_Information_Response_iE_Extensions__item__id,
        ____E_DCH_LCR_Information_Response_iE_Extensions__item__criticality_tab,
        ___E_DCH_LCR_Information_Response_iE_Extensions__item__criticality,
        ____E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_LCR_Information_Response_iE_Extensions__item__extensionValue,
        __E_DCH_LCR_Information_Response_iE_Extensions__item_,
        _E_DCH_LCR_Information_Response_iE_Extensions,
        E_DCH_LCR_Information_Response,
        E_DCH_Information_Response_LCR_ExtIEs,
        _E_AGCH_Specific_InformationRespList_LCR_TDD__item_,
        E_AGCH_Specific_InformationRespList_LCR_TDD,
        _E_AGCH_Specific_InformationResp_Item_LCR_TDD_timeSlotLCR,
        _E_AGCH_Specific_InformationResp_Item_LCR_TDD_midambleShiftLCR,
        _E_AGCH_Specific_InformationResp_Item_LCR_TDD_tDD_ChannelisationCode,
        ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab,
        ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__id,
        ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab,
        ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality,
        ____E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab,
        ___E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue,
        __E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions__item_,
        _E_AGCH_Specific_InformationResp_Item_LCR_TDD_iE_Extensions,
        E_AGCH_Specific_InformationResp_Item_LCR_TDD,
        E_AGCH_Specific_InformationResp_ItemTDD_LCR_ExtIEs,
        _E_HICH_Specific_InformationResp_LCR_e_HICH_Scheduled_InformationResp_LCR,
        _E_HICH_Specific_InformationResp_LCR_e_HICH_non_Scheduled_InformationResp_LCR,
        _E_HICH_Specific_InformationResp_LCR_e_HICH_TimeOffset_lcr,
        ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id_tab,
        ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__id,
        ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality_tab,
        ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__criticality,
        ____E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_Specific_InformationResp_LCR_iE_Extensions__item__extensionValue,
        __E_HICH_Specific_InformationResp_LCR_iE_Extensions__item_,
        _E_HICH_Specific_InformationResp_LCR_iE_Extensions,
        E_HICH_Specific_InformationResp_LCR,
        E_HICH_Specific_InformationResp_LCR_ExtIEs,
        _E_HICH_Scheduled_InformationRespList_LCR_TDD__item_,
        E_HICH_Scheduled_InformationRespList_LCR_TDD,
        _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_e_HICH_EI,
        _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_e_HICH_Scheduled_InformationResp_LCR,
        ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id_tab,
        ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__id,
        ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality_tab,
        ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__criticality,
        ____E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item__extensionValue,
        __E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions__item_,
        _E_HICH_Scheduled_InformationResp_Item_LCR_TDD_iE_Extensions,
        E_HICH_Scheduled_InformationResp_Item_LCR_TDD,
        E_HICH_Scheduled_InformationResp_LCR_ExtIEs,
        E_HICH_EI,
        _E_HICH_InformationResp_LCR_timeSlotLCR,
        _E_HICH_InformationResp_LCR_midambleShiftLCR,
        _E_HICH_InformationResp_LCR_tDD_ChannelisationCode,
        _E_HICH_InformationResp_LCR_signatureSequenceGroupIndex,
        ____E_HICH_InformationResp_LCR_iE_Extensions__item__id_tab,
        ___E_HICH_InformationResp_LCR_iE_Extensions__item__id,
        ____E_HICH_InformationResp_LCR_iE_Extensions__item__criticality_tab,
        ___E_HICH_InformationResp_LCR_iE_Extensions__item__criticality,
        ____E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_InformationResp_LCR_iE_Extensions__item__extensionValue,
        __E_HICH_InformationResp_LCR_iE_Extensions__item_,
        _E_HICH_InformationResp_LCR_iE_Extensions,
        E_HICH_InformationResp_LCR,
        E_HICH_InformationResp_LCR_ExtIEs,
        E_HICH_TimeOffset_LCR,
        E_DCH_SubframeNumber_LCR,
        E_DCH_TimeslotResource_LCR,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_timeslotResource_LCR,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_powerResource,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_repetitionPeriod,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_repetitionLength,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_subframenumber,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_tddE_PUCH_Offset,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_tdd_ChannelisationCode,
        ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__id,
        ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__criticality,
        ____E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item__extensionValue,
        __E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions__item_,
        _E_DCH_Non_Scheduled_Grant_Info_LCR_iE_Extensions,
        E_DCH_Non_Scheduled_Grant_Info_LCR,
        E_DCH_Non_Scheduled_Grant_Info_LCR_ExtIEs,
        Enabling_Delay,
        Ext_Reference_E_TFCI_PO,
        ExtendedPropagationDelay,
        Extended_RNC_ID,
        Extended_RNTI,
        Extended_Round_Trip_Time_Value,
        _Extended_S_RNTI_Group_extended_sRNTI,
        _Extended_S_RNTI_Group_extended_sRNTI_BitMaskIndex,
        Extended_S_RNTI_Group,
        _ExtendedAffectedUEInformationForMBMS__item_,
        ExtendedAffectedUEInformationForMBMS,
        Ext_Max_Bits_MACe_PDU_non_scheduled,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Indicator,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_e_DCH_SPS_Reservation_Indicator,
        ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id,
        ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality,
        ____E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue,
        __E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_,
        _E_DCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions,
        E_DCH_Semi_PersistentScheduling_Information_LCR,
        E_DCH_Semi_PersistentScheduling_Information_LCR_ExtIEs,
        E_DCH_SPS_Indicator,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Indicator,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_e_DCH_SPS_Reservation_Indicator,
        ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id,
        ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality,
        ____E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue,
        __E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_,
        _E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions,
        E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        E_DCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_E_DCH_SPS_resource,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_e_DCH_SPS_HICH_Information,
        ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id,
        ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality,
        ____E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_,
        _E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions,
        E_DCH_Semi_PersistentScheduling_Information_ResponseLCR,
        E_DCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs,
        _E_DCH_SPS_HICH_Information_e_HICH_Configuration,
        _E_DCH_SPS_HICH_Information_signatureSequenceGroupIndex,
        ____E_DCH_SPS_HICH_Information_iE_Extensions__item__id_tab,
        ___E_DCH_SPS_HICH_Information_iE_Extensions__item__id,
        ____E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality_tab,
        ___E_DCH_SPS_HICH_Information_iE_Extensions__item__criticality,
        ____E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DCH_SPS_HICH_Information_iE_Extensions__item__extensionValue,
        __E_DCH_SPS_HICH_Information_iE_Extensions__item_,
        _E_DCH_SPS_HICH_Information_iE_Extensions,
        E_DCH_SPS_HICH_Information,
        E_DCH_SPS_HICH_Information_ExtIEs,
        _E_HICH_Configuration_same_As_Scheduled_E_HICH,
        _E_HICH_Configuration_explicit,
        E_HICH_Configuration,
        _E_HICH_InformationResp_ExplicitConfiguration_LCR_timeSlotLCR,
        _E_HICH_InformationResp_ExplicitConfiguration_LCR_midambleShiftLCR,
        _E_HICH_InformationResp_ExplicitConfiguration_LCR_tDD_ChannelisationCode,
        ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id_tab,
        ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__id,
        ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality_tab,
        ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__criticality,
        ____E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue_tab,
        ___E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item__extensionValue,
        __E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions__item_,
        _E_HICH_InformationResp_ExplicitConfiguration_LCR_iE_Extensions,
        E_HICH_InformationResp_ExplicitConfiguration_LCR,
        E_HICH_InformationResp_ExplicitConfiguration_LCR_ExtIEs,
        _FACH_FlowControlInformation__item_,
        FACH_FlowControlInformation,
        _FACH_FlowControlInformationItem_fACH_SchedulingPriority,
        _FACH_FlowControlInformationItem_mAC_c_sh_SDU_Lengths,
        _FACH_FlowControlInformationItem_fACH_InitialWindowSize,
        ____FACH_FlowControlInformationItem_iE_Extensions__item__id_tab,
        ___FACH_FlowControlInformationItem_iE_Extensions__item__id,
        ____FACH_FlowControlInformationItem_iE_Extensions__item__criticality_tab,
        ___FACH_FlowControlInformationItem_iE_Extensions__item__criticality,
        ____FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue_tab,
        ___FACH_FlowControlInformationItem_iE_Extensions__item__extensionValue,
        __FACH_FlowControlInformationItem_iE_Extensions__item_,
        _FACH_FlowControlInformationItem_iE_Extensions,
        FACH_FlowControlInformationItem,
        FACH_FlowControlInformationItem_ExtIEs,
        FACH_InitialWindowSize,
        _FACH_InformationList__item_,
        FACH_InformationList,
        _FACH_InformationItem_transportFormatSet,
        ____FACH_InformationItem_iE_Extensions__item__id_tab,
        ___FACH_InformationItem_iE_Extensions__item__id,
        ____FACH_InformationItem_iE_Extensions__item__criticality_tab,
        ___FACH_InformationItem_iE_Extensions__item__criticality,
        ____FACH_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___FACH_InformationItem_iE_Extensions__item__extensionValue,
        __FACH_InformationItem_iE_Extensions__item_,
        _FACH_InformationItem_iE_Extensions,
        FACH_InformationItem,
        FACH_InformationItem_ExtIEs,
        Fast_Reconfiguration_Mode,
        Fast_Reconfiguration_Permission,
        _Fast_TTI_switching_Mode_synchronized_mode1,
        _Fast_TTI_switching_Mode_synchronized_mode2,
        Fast_TTI_switching_Mode_synchronized,
        _Fast_TTI_switching_Mode_unsynchronized_mode1,
        _Fast_TTI_switching_Mode_unsynchronized_mode2,
        Fast_TTI_switching_Mode_unsynchronized,
        Fast_TTI_switching_Mode_Supported,
        _FDD_DCHs_to_Modify__item_,
        FDD_DCHs_to_Modify,
        _FDD_DCHs_to_ModifyItem_ul_FP_Mode,
        _FDD_DCHs_to_ModifyItem_toAWS,
        _FDD_DCHs_to_ModifyItem_toAWE,
        _FDD_DCHs_to_ModifyItem_transportBearerRequestIndicator,
        _FDD_DCHs_to_ModifyItem_dCH_SpecificInformationList,
        ____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab,
        _____FDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__id,
        ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality,
        ___FDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue,
        __FDD_DCHs_to_ModifyItem_iE_Extensions__item_,
        _FDD_DCHs_to_ModifyItem_iE_Extensions,
        FDD_DCHs_to_ModifyItem,
        FDD_DCHs_to_ModifyItem_ExtIEs,
        _FDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0,
        _FDD_DCHs_to_ModifySpecificInformationList__item_,
        FDD_DCHs_to_ModifySpecificInformationList,
        _FDD_DCHs_to_ModifySpecificItem_dCH_ID,
        _FDD_DCHs_to_ModifySpecificItem_ul_TransportformatSet,
        _FDD_DCHs_to_ModifySpecificItem_dl_TransportformatSet,
        _FDD_DCHs_to_ModifySpecificItem_allocationRetentionPriority,
        _FDD_DCHs_to_ModifySpecificItem_frameHandlingPriority,
        _FDD_DCHs_to_ModifySpecificItem_not_Used_dRACControl,
        ____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab,
        _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id,
        ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality,
        ___FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue,
        __FDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_,
        _FDD_DCHs_to_ModifySpecificItem_iE_Extensions,
        FDD_DCHs_to_ModifySpecificItem,
        FDD_DCHs_to_ModifySpecificItem_ExtIEs,
        _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_0,
        _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_1,
        _FDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_2,
        FDD_DL_ChannelisationCodeNumber,
        _FDD_DL_CodeInformation__item_,
        FDD_DL_CodeInformation,
        _FDD_DL_CodeInformationItem_dl_ScramblingCode,
        _FDD_DL_CodeInformationItem_fDD_DL_ChannelisationCodeNumber,
        _FDD_DL_CodeInformationItem_transmission_Gap_Pattern_Sequence_ScramblingCode_Information,
        ____FDD_DL_CodeInformationItem_iE_Extensions__item__id_tab,
        ___FDD_DL_CodeInformationItem_iE_Extensions__item__id,
        ____FDD_DL_CodeInformationItem_iE_Extensions__item__criticality_tab,
        ___FDD_DL_CodeInformationItem_iE_Extensions__item__criticality,
        ____FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue_tab,
        ___FDD_DL_CodeInformationItem_iE_Extensions__item__extensionValue,
        __FDD_DL_CodeInformationItem_iE_Extensions__item_,
        _FDD_DL_CodeInformationItem_iE_Extensions,
        FDD_DL_CodeInformationItem,
        FDD_DL_CodeInformationItem_ExtIEs,
        FDD_TPC_DownlinkStepSize,
        SchedulingPriorityIndicator,
        _F_DPCH_Info_f_DPCH_SlotFormat,
        _F_DPCH_Info_fdd_dl_ChannelisationCodeNumber,
        _F_DPCH_Info_extended_E_DPCCH_PO,
        ____F_DPCH_Info_iE_Extensions__item__id_tab,
        ___F_DPCH_Info_iE_Extensions__item__id,
        ____F_DPCH_Info_iE_Extensions__item__criticality_tab,
        ___F_DPCH_Info_iE_Extensions__item__criticality,
        ____F_DPCH_Info_iE_Extensions__item__extensionValue_tab,
        ___F_DPCH_Info_iE_Extensions__item__extensionValue,
        __F_DPCH_Info_iE_Extensions__item_,
        _F_DPCH_Info_iE_Extensions,
        F_DPCH_Info,
        F_DPCH_Info_ExtIEs,
        _F_DPCH_Info_To_Modify_f_DPCH_SlotFormat,
        _F_DPCH_Info_To_Modify_fdd_dl_ChannelisationCodeNumber,
        _F_DPCH_Info_To_Modify_extended_E_DPCCH_PO,
        ____F_DPCH_Info_To_Modify_iE_Extensions__item__id_tab,
        ___F_DPCH_Info_To_Modify_iE_Extensions__item__id,
        ____F_DPCH_Info_To_Modify_iE_Extensions__item__criticality_tab,
        ___F_DPCH_Info_To_Modify_iE_Extensions__item__criticality,
        ____F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___F_DPCH_Info_To_Modify_iE_Extensions__item__extensionValue,
        __F_DPCH_Info_To_Modify_iE_Extensions__item_,
        _F_DPCH_Info_To_Modify_iE_Extensions,
        F_DPCH_Info_To_Modify,
        F_DPCH_Info_To_Modify_ExtIEs,
        F_DPCH_SlotFormat,
        F_DPCH_SlotFormatSupportRequest,
        FirstRLS_Indicator,
        FNReportingIndicator,
        _FPACH_Information_timeSlotLCR,
        _FPACH_Information_tDD_ChannelisationCodeLCR,
        _FPACH_Information_midambleShiftLCR,
        _FPACH_Information_wT,
        FPACH_Information,
        _FTPICH_Information_fTPICH_Offset,
        ____FTPICH_Information_iE_Extensions__item__id_tab,
        ___FTPICH_Information_iE_Extensions__item__id,
        ____FTPICH_Information_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_iE_Extensions__item__criticality,
        ____FTPICH_Information_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_iE_Extensions__item__extensionValue,
        __FTPICH_Information_iE_Extensions__item_,
        _FTPICH_Information_iE_Extensions,
        FTPICH_Information,
        FTPICH_Information_ExtIEs,
        FTPICH_SlotFormat,
        FTPICH_Offset,
        FTPICH_Information_Removal,
        _FTPICH_Information_To_Modify_fTPICH_Offset,
        ____FTPICH_Information_To_Modify_iE_Extensions__item__id_tab,
        ___FTPICH_Information_To_Modify_iE_Extensions__item__id,
        ____FTPICH_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_To_Modify_iE_Extensions__item__criticality,
        ____FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_To_Modify_iE_Extensions__item__extensionValue,
        __FTPICH_Information_To_Modify_iE_Extensions__item_,
        _FTPICH_Information_To_Modify_iE_Extensions,
        FTPICH_Information_To_Modify,
        FTPICH_Information_To_Modify_ExtIEs,
        _FTPICH_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information,
        ____FTPICH_Information_Reconf_iE_Extensions__item__id_tab,
        ___FTPICH_Information_Reconf_iE_Extensions__item__id,
        ____FTPICH_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_Reconf_iE_Extensions__item__criticality,
        ____FTPICH_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_Reconf_iE_Extensions__item__extensionValue,
        __FTPICH_Information_Reconf_iE_Extensions__item_,
        _FTPICH_Information_Reconf_iE_Extensions,
        FTPICH_Information_Reconf,
        FTPICH_Information_Reconf_ExtIEs,
        _FTPICH_Reconfiguration_Information_fTPICH_SlotFormat,
        _FTPICH_Reconfiguration_Information_fTPICH_ChannelisationCodenumber,
        ____FTPICH_Reconfiguration_Information_iE_Extensions__item__id_tab,
        ___FTPICH_Reconfiguration_Information_iE_Extensions__item__id,
        ____FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality_tab,
        ___FTPICH_Reconfiguration_Information_iE_Extensions__item__criticality,
        ____FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Reconfiguration_Information_iE_Extensions__item__extensionValue,
        __FTPICH_Reconfiguration_Information_iE_Extensions__item_,
        _FTPICH_Reconfiguration_Information_iE_Extensions,
        FTPICH_Reconfiguration_Information,
        FTPICH_Reconfiguration_Information_ExtIEs,
        _FTPICH_Information_Response_fTPICH_SlotFormat,
        _FTPICH_Information_Response_fTPICH_ChannelisationCodenumber,
        ____FTPICH_Information_Response_iE_Extensions__item__id_tab,
        ___FTPICH_Information_Response_iE_Extensions__item__id,
        ____FTPICH_Information_Response_iE_Extensions__item__criticality_tab,
        ___FTPICH_Information_Response_iE_Extensions__item__criticality,
        ____FTPICH_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___FTPICH_Information_Response_iE_Extensions__item__extensionValue,
        __FTPICH_Information_Response_iE_Extensions__item_,
        _FTPICH_Information_Response_iE_Extensions,
        FTPICH_Information_Response,
        FTPICH_Information_Response_ExtIEs,
        FrameHandlingPriority,
        FrameOffset,
        FrequencyBandIndicator,
        GapLength,
        GapDuration,
        __GA_Cell__item__cell_GAIgeographicalCoordinate,
        _____GA_Cell__item__iE_Extensions__item__id_tab,
        ____GA_Cell__item__iE_Extensions__item__id,
        _____GA_Cell__item__iE_Extensions__item__criticality_tab,
        ____GA_Cell__item__iE_Extensions__item__criticality,
        _____GA_Cell__item__iE_Extensions__item__extensionValue_tab,
        ____GA_Cell__item__iE_Extensions__item__extensionValue,
        ___GA_Cell__item__iE_Extensions__item_,
        __GA_Cell__item__iE_Extensions,
        _GA_Cell__item_,
        GA_Cell,
        GA_Cell_ExtIEs,
        _GA_CellAdditionalShapes_pointWithUncertainty,
        _GA_CellAdditionalShapes_pointWithUncertaintyEllipse,
        _GA_CellAdditionalShapes_pointWithAltitude,
        _GA_CellAdditionalShapes_pointWithAltitudeAndUncertaintyEllipsoid,
        _GA_CellAdditionalShapes_ellipsoidArc,
        GA_CellAdditionalShapes,
        _GA_AltitudeAndDirection_directionOfAltitude,
        _GA_AltitudeAndDirection_altitude,
        GA_AltitudeAndDirection,
        _GA_EllipsoidArc_geographicalCoordinates,
        _GA_EllipsoidArc_innerRadius,
        _GA_EllipsoidArc_uncertaintyRadius,
        _GA_EllipsoidArc_offsetAngle,
        _GA_EllipsoidArc_includedAngle,
        _GA_EllipsoidArc_confidence,
        ____GA_EllipsoidArc_iE_Extensions__item__id_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__id,
        ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__criticality,
        ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__extensionValue,
        __GA_EllipsoidArc_iE_Extensions__item_,
        _GA_EllipsoidArc_iE_Extensions,
        GA_EllipsoidArc,
        GA_EllipsoidArc_ExtIEs,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaC,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_betaD,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_gain10ms_refTFCNumber,
        _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id_tab,
        ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__id,
        _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality_tab,
        ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__criticality,
        _____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue_tab,
        ____Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item__extensionValue,
        ___Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions__item_,
        __Gainfactors_10ms_mode_signalledGainFactors10ms_iE_Extensions,
        _Gainfactors_10ms_mode_signalledGainFactors10ms,
        _Gainfactors_10ms_mode_computedGainFactors10ms,
        Gainfactors_10ms_mode,
        SignalledGainFactors10ms_ExtIEs,
        _GANSS_AddClockModels_navClockModel,
        _GANSS_AddClockModels_cnavClockModel,
        _GANSS_AddClockModels_glonassClockModel,
        _GANSS_AddClockModels_sbasClockModel,
        _GANSS_AddClockModels_extension_GANSS_AddClockModels,
        GANSS_AddClockModels,
        __Extension_GANSS_AddClockModels_id_tab,
        ___Extension_GANSS_AddClockModels_id_tab_val_Value_0,
        _Extension_GANSS_AddClockModels_id,
        _Extension_GANSS_AddClockModels_criticality,
        _Extension_GANSS_AddClockModels_value,
        Extension_GANSS_AddClockModels,
        Extension_GANSS_AddClockModels_IE,
        _Extension_GANSS_AddClockModels_IE_val_Value_0,
        GANSS_AddIonoModelReq,
        GANSS_AddNavigationModelsReq,
        _GANSS_AddOrbitModels_navKeplerianSet,
        _GANSS_AddOrbitModels_cnavKeplerianSet,
        _GANSS_AddOrbitModels_glonassECEF,
        _GANSS_AddOrbitModels_sbasECEF,
        _GANSS_AddOrbitModels_extension_GANSS_AddOrbitModels,
        GANSS_AddOrbitModels,
        __Extension_GANSS_AddOrbitModels_id_tab,
        ___Extension_GANSS_AddOrbitModels_id_tab_val_Value_0,
        _Extension_GANSS_AddOrbitModels_id,
        _Extension_GANSS_AddOrbitModels_criticality,
        _Extension_GANSS_AddOrbitModels_value,
        Extension_GANSS_AddOrbitModels,
        Extension_GANSS_AddOrbitModels_IE,
        _Extension_GANSS_AddOrbitModels_IE_val_Value_0,
        GANSS_AddUTCModelsReq,
        _GANSS_Additional_Ionospheric_Model_dataID,
        _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_,
        _GANSS_Additional_Ionospheric_Model_ie_Extensions,
        GANSS_Additional_Ionospheric_Model,
        GANSS_Additional_Ionospheric_Model_ExtIEs,
        _GANSS_Additional_Navigation_Models_ganss_Transmission_Time,
        _GANSS_Additional_Navigation_Models_non_broadcastIndication,
        _GANSS_Additional_Navigation_Models_ganssSatInfoNavList,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue,
        __GANSS_Additional_Navigation_Models_ie_Extensions__item_,
        _GANSS_Additional_Navigation_Models_ie_Extensions,
        GANSS_Additional_Navigation_Models,
        GANSS_Additional_Navigation_Models_ExtIEs,
        _GANSS_Additional_Time_Models__item_,
        GANSS_Additional_Time_Models,
        _GANSS_Additional_UTC_Models_utcModel1,
        _GANSS_Additional_UTC_Models_utcModel2,
        _GANSS_Additional_UTC_Models_utcModel3,
        _GANSS_Additional_UTC_Models_extension_GANSS_Additional_UTC_Models,
        GANSS_Additional_UTC_Models,
        __Extension_GANSS_Additional_UTC_Models_id_tab,
        ___Extension_GANSS_Additional_UTC_Models_id_tab_val_Value_0,
        _Extension_GANSS_Additional_UTC_Models_id,
        _Extension_GANSS_Additional_UTC_Models_criticality,
        _Extension_GANSS_Additional_UTC_Models_value,
        Extension_GANSS_Additional_UTC_Models,
        Extension_GANSS_Additional_UTC_Models_IE,
        _Extension_GANSS_Additional_UTC_Models_IE_val_Value_0,
        _GANSS_Almanac_ganss_wk_number,
        ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_t_oa,
        ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_iod_a,
        ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_gANSS_SatelliteInformationKP,
        ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id_tab,
        _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__id,
        ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab,
        _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__criticality,
        ______GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab,
        _____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item__extensionValue,
        ____GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions__item_,
        ___GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters_ie_Extensions,
        __GANSS_Almanac_gANSS_AlmanacModel_gANSS_keplerianParameters,
        __GANSS_Almanac_gANSS_AlmanacModel_extension_GANSS_AlmanacModel,
        _GANSS_Almanac_gANSS_AlmanacModel,
        ____GANSS_Almanac_ie_Extensions__item__id_tab,
        _____GANSS_Almanac_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_Almanac_ie_Extensions__item__id,
        ___GANSS_Almanac_ie_Extensions__item__criticality,
        ___GANSS_Almanac_ie_Extensions__item__extensionValue,
        __GANSS_Almanac_ie_Extensions__item_,
        _GANSS_Almanac_ie_Extensions,
        GANSS_Almanac,
        GANSS_KeplerianParametersAlm_ExtIEs,
        __Extension_GANSS_AlmanacModel_id_tab,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5,
        _Extension_GANSS_AlmanacModel_id,
        _Extension_GANSS_AlmanacModel_criticality,
        _Extension_GANSS_AlmanacModel_value,
        Extension_GANSS_AlmanacModel,
        Extension_GANSS_AlmanacModel_IE,
        _Extension_GANSS_AlmanacModel_IE_val_Value_0,
        _Extension_GANSS_AlmanacModel_IE_val_Value_1,
        _Extension_GANSS_AlmanacModel_IE_val_Value_2,
        _Extension_GANSS_AlmanacModel_IE_val_Value_3,
        _Extension_GANSS_AlmanacModel_IE_val_Value_4,
        _Extension_GANSS_AlmanacModel_IE_val_Value_5,
        _GANSS_alm_keplerianNAVAlmanac_t_oa,
        _GANSS_alm_keplerianNAVAlmanac_sat_info_NAVkpList,
        ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id_tab,
        ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__id,
        ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality_tab,
        ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__criticality,
        ____GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue_tab,
        ___GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item__extensionValue,
        __GANSS_alm_keplerianNAVAlmanac_ie_Extensions__item_,
        _GANSS_alm_keplerianNAVAlmanac_ie_Extensions,
        GANSS_alm_keplerianNAVAlmanac,
        GANSS_ALM_NAVKeplerianSet_ExtIEs,
        _GANSS_alm_KEPLERIANBDSALMANAC_sat_info_BDSkpList,
        ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id_tab,
        ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__id,
        ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality_tab,
        ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__criticality,
        ____GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue_tab,
        ___GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item__extensionValue,
        __GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions__item_,
        _GANSS_alm_KEPLERIANBDSALMANAC_iE_Extensions,
        GANSS_alm_KEPLERIANBDSALMANAC,
        GANSS_alm_KEPLERIANBDSALMANAC_ExtIEs,
        _GANSS_alm_keplerianReducedAlmanac_t_oa,
        _GANSS_alm_keplerianReducedAlmanac_sat_info_REDkpList,
        ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id_tab,
        ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__id,
        ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality_tab,
        ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__criticality,
        ____GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue_tab,
        ___GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item__extensionValue,
        __GANSS_alm_keplerianReducedAlmanac_ie_Extensions__item_,
        _GANSS_alm_keplerianReducedAlmanac_ie_Extensions,
        GANSS_alm_keplerianReducedAlmanac,
        GANSS_ALM_ReducedKeplerianSet_ExtIEs,
        _GANSS_alm_keplerianMidiAlmanac_t_oa,
        _GANSS_alm_keplerianMidiAlmanac_sat_info_MIDIkpList,
        ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id_tab,
        ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__id,
        ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality_tab,
        ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__criticality,
        ____GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue_tab,
        ___GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item__extensionValue,
        __GANSS_alm_keplerianMidiAlmanac_ie_Extensions__item_,
        _GANSS_alm_keplerianMidiAlmanac_ie_Extensions,
        GANSS_alm_keplerianMidiAlmanac,
        GANSS_ALM_MidiAlmanacSet_ExtIEs,
        _GANSS_alm_keplerianGLONASS_sat_info_GLOkpList,
        ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__id_tab,
        ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__id,
        ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality_tab,
        ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__criticality,
        ____GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue_tab,
        ___GANSS_alm_keplerianGLONASS_ie_Extensions__item__extensionValue,
        __GANSS_alm_keplerianGLONASS_ie_Extensions__item_,
        _GANSS_alm_keplerianGLONASS_ie_Extensions,
        GANSS_alm_keplerianGLONASS,
        GANSS_ALM_GlonassAlmanacSet_ExtIEs,
        _GANSS_alm_ecefSBASAlmanac_sat_info_SBASecefList,
        ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id_tab,
        ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__id,
        ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality_tab,
        ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__criticality,
        ____GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue_tab,
        ___GANSS_alm_ecefSBASAlmanac_ie_Extensions__item__extensionValue,
        __GANSS_alm_ecefSBASAlmanac_ie_Extensions__item_,
        _GANSS_alm_ecefSBASAlmanac_ie_Extensions,
        GANSS_alm_ecefSBASAlmanac,
        GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs,
        GANSS_Almanac_ExtIEs,
        _GANSS_Almanac_ExtIEs_val_Extension_0,
        _GANSS_Auxiliary_Information_ganssID1,
        _GANSS_Auxiliary_Information_ganssID3,
        GANSS_Auxiliary_Information,
        __GANSS_AuxInfoGANSS_ID1__item__svID,
        __GANSS_AuxInfoGANSS_ID1__item__signalsAvailable,
        _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id_tab,
        ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__id,
        _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality_tab,
        ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__criticality,
        _____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item__extensionValue,
        ___GANSS_AuxInfoGANSS_ID1__item__ie_Extensions__item_,
        __GANSS_AuxInfoGANSS_ID1__item__ie_Extensions,
        _GANSS_AuxInfoGANSS_ID1__item_,
        GANSS_AuxInfoGANSS_ID1,
        GANSS_AuxInfoGANSS_ID1_element_ExtIEs,
        __GANSS_AuxInfoGANSS_ID3__item__svID,
        __GANSS_AuxInfoGANSS_ID3__item__signalsAvailable,
        __GANSS_AuxInfoGANSS_ID3__item__channelNumber,
        _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id_tab,
        ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__id,
        _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality_tab,
        ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__criticality,
        _____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item__extensionValue,
        ___GANSS_AuxInfoGANSS_ID3__item__ie_Extensions__item_,
        __GANSS_AuxInfoGANSS_ID3__item__ie_Extensions,
        _GANSS_AuxInfoGANSS_ID3__item_,
        GANSS_AuxInfoGANSS_ID3,
        GANSS_AuxInfoGANSS_ID3_element_ExtIEs,
        GANSS_AuxInfoReq,
        _GANSS_BDSclockModel_bdsToc,
        _GANSS_BDSclockModel_bdsa0,
        _GANSS_BDSclockModel_bdsa1,
        _GANSS_BDSclockModel_bdsa2,
        _GANSS_BDSclockModel_bdsTgd1,
        _GANSS_BDSclockModel_bdsAODC,
        ____GANSS_BDSclockModel_iE_Extensions__item__id_tab,
        ___GANSS_BDSclockModel_iE_Extensions__item__id,
        ____GANSS_BDSclockModel_iE_Extensions__item__criticality_tab,
        ___GANSS_BDSclockModel_iE_Extensions__item__criticality,
        ____GANSS_BDSclockModel_iE_Extensions__item__extensionValue_tab,
        ___GANSS_BDSclockModel_iE_Extensions__item__extensionValue,
        __GANSS_BDSclockModel_iE_Extensions__item_,
        _GANSS_BDSclockModel_iE_Extensions,
        GANSS_BDSclockModel,
        GANSS_BDSclockModelItem_ExtIEs,
        __GANSS_Clock_Model__item__t_oc,
        __GANSS_Clock_Model__item__a_i2,
        __GANSS_Clock_Model__item__a_i1,
        __GANSS_Clock_Model__item__a_i0,
        __GANSS_Clock_Model__item__t_gd,
        __GANSS_Clock_Model__item__sisa,
        __GANSS_Clock_Model__item__model_id,
        _____GANSS_Clock_Model__item__ie_Extensions__item__id_tab,
        ____GANSS_Clock_Model__item__ie_Extensions__item__id,
        _____GANSS_Clock_Model__item__ie_Extensions__item__criticality_tab,
        ____GANSS_Clock_Model__item__ie_Extensions__item__criticality,
        _____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_Clock_Model__item__ie_Extensions__item__extensionValue,
        ___GANSS_Clock_Model__item__ie_Extensions__item_,
        __GANSS_Clock_Model__item__ie_Extensions,
        _GANSS_Clock_Model__item_,
        GANSS_Clock_Model,
        GANSS_ClockModelItem_ExtIEs,
        _GANSS_CNAVclockModel_cnavToc,
        _GANSS_CNAVclockModel_cnavTop,
        _GANSS_CNAVclockModel_cnavURA0,
        _GANSS_CNAVclockModel_cnavURA1,
        _GANSS_CNAVclockModel_cnavURA2,
        _GANSS_CNAVclockModel_cnavAf2,
        _GANSS_CNAVclockModel_cnavAf1,
        _GANSS_CNAVclockModel_cnavAf0,
        _GANSS_CNAVclockModel_cnavTgd,
        _GANSS_CNAVclockModel_cnavISCl1cp,
        _GANSS_CNAVclockModel_cnavISCl1cd,
        _GANSS_CNAVclockModel_cnavISCl1ca,
        _GANSS_CNAVclockModel_cnavISCl2c,
        _GANSS_CNAVclockModel_cnavISCl5i5,
        _GANSS_CNAVclockModel_cnavISCl5q5,
        ____GANSS_CNAVclockModel_ie_Extensions__item__id_tab,
        ___GANSS_CNAVclockModel_ie_Extensions__item__id,
        ____GANSS_CNAVclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_CNAVclockModel_ie_Extensions__item__criticality,
        ____GANSS_CNAVclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_CNAVclockModel_ie_Extensions__item__extensionValue,
        __GANSS_CNAVclockModel_ie_Extensions__item_,
        _GANSS_CNAVclockModel_ie_Extensions,
        GANSS_CNAVclockModel,
        GANSS_CNAVclockModel_ExtIEs,
        _GANSS_Common_Data_ganss_Ionospheric_Model,
        _GANSS_Common_Data_ganss_Rx_Pos,
        ____GANSS_Common_Data_ie_Extensions__item__id_tab,
        _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_Common_Data_ie_Extensions__item__id_tab_val_Extension_1,
        ___GANSS_Common_Data_ie_Extensions__item__id,
        ___GANSS_Common_Data_ie_Extensions__item__criticality,
        ___GANSS_Common_Data_ie_Extensions__item__extensionValue,
        __GANSS_Common_Data_ie_Extensions__item_,
        _GANSS_Common_Data_ie_Extensions,
        GANSS_Common_Data,
        GANSS_Common_Data_ExtIEs,
        _GANSS_Common_Data_ExtIEs_val_Extension_0,
        _GANSS_Common_Data_ExtIEs_val_Extension_1,
        _GANSS_CommonDataInfoReq_ionospheric_Model,
        ____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab,
        _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_CommonDataInfoReq_ie_Extensions__item__id_tab_val_Extension_1,
        ___GANSS_CommonDataInfoReq_ie_Extensions__item__id,
        ___GANSS_CommonDataInfoReq_ie_Extensions__item__criticality,
        ___GANSS_CommonDataInfoReq_ie_Extensions__item__extensionValue,
        __GANSS_CommonDataInfoReq_ie_Extensions__item_,
        _GANSS_CommonDataInfoReq_ie_Extensions,
        GANSS_CommonDataInfoReq,
        GANSS_CommonDataInfoReq_ExtIEs,
        _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_0,
        _GANSS_CommonDataInfoReq_ExtIEs_val_Extension_1,
        _GANSS_Data_Bit_Assistance_ganssTod,
        _GANSS_Data_Bit_Assistance_dataBitAssistancelist,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ie_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ie_Extensions,
        GANSS_Data_Bit_Assistance,
        GANSS_Data_Bit_Assistance_ExtIEs,
        _GANSS_DataBitAssistanceList__item_,
        GANSS_DataBitAssistanceList,
        _GANSS_DataBitAssistanceItem_satId,
        _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue,
        __GANSS_DataBitAssistanceItem_ie_Extensions__item_,
        _GANSS_DataBitAssistanceItem_ie_Extensions,
        GANSS_DataBitAssistanceItem,
        GANSS_DataBitAssistanceItem_ExtIEs,
        _GANSS_DataBitAssistanceSgnList__item_,
        GANSS_DataBitAssistanceSgnList,
        _GANSS_DataBitAssistanceSgnItem_ganss_SignalId,
        _GANSS_DataBitAssistanceSgnItem_ganssDataBits,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue,
        __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_,
        _GANSS_DataBitAssistanceSgnItem_ie_Extensions,
        GANSS_DataBitAssistanceSgnItem,
        GANSS_DataBitAssistanceSgnItem_ExtIEs,
        _GANSS_Data_Bit_Assistance_ReqItem_ganssTod,
        _GANSS_Data_Bit_Assistance_ReqItem_ganss_Data_Bit_Assistance_ReqList,
        ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ReqItem_iE_Extensions,
        GANSS_Data_Bit_Assistance_ReqItem,
        GANSS_Data_Bit_Assistance_ReqItem_ExtIEs,
        _GANSS_Data_Bit_Assistance_ReqList_dGANSS_Signal_ID,
        _GANSS_Data_Bit_Assistance_ReqList_ganss_DataBitInterval,
        __GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo__item_,
        _GANSS_Data_Bit_Assistance_ReqList_ganss_SatelliteInfo,
        ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ReqList_iE_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ReqList_iE_Extensions,
        GANSS_Data_Bit_Assistance_ReqList,
        GANSS_Data_Bit_Assistance_ReqList_ExtIEs,
        GANSS_Delta_T,
        _GANSS_DeltaUT1_b1,
        _GANSS_DeltaUT1_b2,
        ____GANSS_DeltaUT1_ie_Extensions__item__id_tab,
        ___GANSS_DeltaUT1_ie_Extensions__item__id,
        ____GANSS_DeltaUT1_ie_Extensions__item__criticality_tab,
        ___GANSS_DeltaUT1_ie_Extensions__item__criticality,
        ____GANSS_DeltaUT1_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DeltaUT1_ie_Extensions__item__extensionValue,
        __GANSS_DeltaUT1_ie_Extensions__item_,
        _GANSS_DeltaUT1_ie_Extensions,
        GANSS_DeltaUT1,
        GANSS_DeltaUT1_ExtIEs,
        _GANSS_Earth_Orientation_Parameters_teop,
        _GANSS_Earth_Orientation_Parameters_pmX,
        _GANSS_Earth_Orientation_Parameters_pmXdot,
        _GANSS_Earth_Orientation_Parameters_pmY,
        _GANSS_Earth_Orientation_Parameters_pmYdot,
        _GANSS_Earth_Orientation_Parameters_deltaUT1,
        _GANSS_Earth_Orientation_Parameters_deltaUT1dot,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue,
        __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_,
        _GANSS_Earth_Orientation_Parameters_ie_Extensions,
        GANSS_Earth_Orientation_Parameters,
        GANSS_Earth_Orientation_Parameters_ExtIEs,
        GANSS_EarthOrientParaReq,
        _GANSS_GenericDataInfoReqList__item_,
        GANSS_GenericDataInfoReqList,
        _GANSS_GenericDataInfoReqItem_ganss_Id,
        _GANSS_GenericDataInfoReqItem_ganss_Navigation_Model_And_Time_Recovery,
        _GANSS_GenericDataInfoReqItem_ganss_Time_Model_GNSS_GNSS,
        _GANSS_GenericDataInfoReqItem_ganss_UTC_Model,
        _GANSS_GenericDataInfoReqItem_ganss_Almanac,
        _GANSS_GenericDataInfoReqItem_ganss_Real_Time_Integrity,
        _GANSS_GenericDataInfoReqItem_ganss_Data_Bit_Assistance_Req,
        ____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_1,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_2,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_3,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_4,
        _____GANSS_GenericDataInfoReqItem_ie_Extensions__item__id_tab_val_Extension_5,
        ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__id,
        ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__criticality,
        ___GANSS_GenericDataInfoReqItem_ie_Extensions__item__extensionValue,
        __GANSS_GenericDataInfoReqItem_ie_Extensions__item_,
        _GANSS_GenericDataInfoReqItem_ie_Extensions,
        GANSS_GenericDataInfoReqItem,
        GANSS_GenericDataInfoReqItem_ExtIEs,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_0,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_1,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_2,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_3,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_4,
        _GANSS_GenericDataInfoReqItem_ExtIEs_val_Extension_5,
        _GANSS_Generic_Data__item_,
        GANSS_Generic_Data,
        _GANSS_Generic_DataItem_ganss_Id,
        _GANSS_Generic_DataItem_dganss_Correction,
        _GANSS_Generic_DataItem_ganss_Navigation_Model_And_Time_Recovery,
        _GANSS_Generic_DataItem_ganss_Time_Model,
        _GANSS_Generic_DataItem_ganss_UTC_TIME,
        _GANSS_Generic_DataItem_ganss_Almanac,
        _GANSS_Generic_DataItem_ganss_Real_Time_Integrity,
        _GANSS_Generic_DataItem_ganss_Data_Bit_Assistance,
        ____GANSS_Generic_DataItem_ie_Extensions__item__id_tab,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_1,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_2,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_3,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_4,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_5,
        _____GANSS_Generic_DataItem_ie_Extensions__item__id_tab_val_Extension_6,
        ___GANSS_Generic_DataItem_ie_Extensions__item__id,
        ___GANSS_Generic_DataItem_ie_Extensions__item__criticality,
        ___GANSS_Generic_DataItem_ie_Extensions__item__extensionValue,
        __GANSS_Generic_DataItem_ie_Extensions__item_,
        _GANSS_Generic_DataItem_ie_Extensions,
        GANSS_Generic_DataItem,
        GANSS_Generic_DataItem_ExtIEs,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_0,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_1,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_2,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_3,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_4,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_5,
        _GANSS_Generic_DataItem_ExtIEs_val_Extension_6,
        _GANSS_GLONASSclockModel_gloTau,
        _GANSS_GLONASSclockModel_gloGamma,
        _GANSS_GLONASSclockModel_gloDeltaTau,
        ____GANSS_GLONASSclockModel_ie_Extensions__item__id_tab,
        ___GANSS_GLONASSclockModel_ie_Extensions__item__id,
        ____GANSS_GLONASSclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_GLONASSclockModel_ie_Extensions__item__criticality,
        ____GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_GLONASSclockModel_ie_Extensions__item__extensionValue,
        __GANSS_GLONASSclockModel_ie_Extensions__item_,
        _GANSS_GLONASSclockModel_ie_Extensions,
        GANSS_GLONASSclockModel,
        GANSS_GLONASSclockModel_ExtIEs,
        GANSS_ID,
        _GANSS_Information_gANSS_CommonDataInfoReq,
        _GANSS_Information_gANSS_GenericDataInfoReqList,
        ____GANSS_Information_ie_Extensions__item__id_tab,
        ___GANSS_Information_ie_Extensions__item__id,
        ____GANSS_Information_ie_Extensions__item__criticality_tab,
        ___GANSS_Information_ie_Extensions__item__criticality,
        ____GANSS_Information_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Information_ie_Extensions__item__extensionValue,
        __GANSS_Information_ie_Extensions__item_,
        _GANSS_Information_ie_Extensions,
        GANSS_Information,
        GANSS_Information_ExtIEs,
        _GANSS_Ionospheric_Model_alpha_zero_ionos,
        _GANSS_Ionospheric_Model_alpha_one_ionos,
        _GANSS_Ionospheric_Model_alpha_two_ionos,
        _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__id,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GANSS_Ionospheric_Model_ie_Extensions__item_,
        _GANSS_Ionospheric_Model_ie_Extensions,
        GANSS_Ionospheric_Model,
        GANSS_Ionospheric_Model_ExtIEs,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_one,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_two,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_three,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_four,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_five,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue,
        __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_,
        _GANSS_IonosphereRegionalStormFlags_ie_Extensions,
        GANSS_IonosphereRegionalStormFlags,
        GANSS_IonosphereRegionalStormFlags_ExtIEs,
        _GANSS_NAVclockModel_navToc,
        _GANSS_NAVclockModel_navaf2,
        _GANSS_NAVclockModel_navaf1,
        _GANSS_NAVclockModel_navaf0,
        _GANSS_NAVclockModel_navTgd,
        ____GANSS_NAVclockModel_ie_Extensions__item__id_tab,
        ___GANSS_NAVclockModel_ie_Extensions__item__id,
        ____GANSS_NAVclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_NAVclockModel_ie_Extensions__item__criticality,
        ____GANSS_NAVclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NAVclockModel_ie_Extensions__item__extensionValue,
        __GANSS_NAVclockModel_ie_Extensions__item_,
        _GANSS_NAVclockModel_ie_Extensions,
        GANSS_NAVclockModel,
        GANSS_NAVclockModel_ExtIEs,
        _GANSS_Navigation_Model_And_Time_Recovery_ganss_Transmission_Time,
        _GANSS_Navigation_Model_And_Time_Recovery_non_broadcastIndication,
        _GANSS_Navigation_Model_And_Time_Recovery_ganssSatInfoNav,
        ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id_tab,
        ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__id,
        ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality_tab,
        ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__criticality,
        ____GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item__extensionValue,
        __GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions__item_,
        _GANSS_Navigation_Model_And_Time_Recovery_ie_Extensions,
        GANSS_Navigation_Model_And_Time_Recovery,
        GANSS_Navigation_Model_And_Time_Recovery_ExtIEs,
        _GANSS_NavModel_BDSKeplerianSet_bdsURAI,
        _GANSS_NavModel_BDSKeplerianSet_bdsToe,
        _GANSS_NavModel_BDSKeplerianSet_bdsAPowerHalf,
        _GANSS_NavModel_BDSKeplerianSet_bdsE,
        _GANSS_NavModel_BDSKeplerianSet_bdsW,
        _GANSS_NavModel_BDSKeplerianSet_bdsDeltaN,
        _GANSS_NavModel_BDSKeplerianSet_bdsM0,
        _GANSS_NavModel_BDSKeplerianSet_bdsOmega0,
        _GANSS_NavModel_BDSKeplerianSet_bdsOmegaDot,
        _GANSS_NavModel_BDSKeplerianSet_bdsI0,
        _GANSS_NavModel_BDSKeplerianSet_bdsIDot,
        _GANSS_NavModel_BDSKeplerianSet_bdsCuc,
        _GANSS_NavModel_BDSKeplerianSet_bdsCus,
        _GANSS_NavModel_BDSKeplerianSet_bdsCrc,
        _GANSS_NavModel_BDSKeplerianSet_bdsCrs,
        _GANSS_NavModel_BDSKeplerianSet_bdsCic,
        _GANSS_NavModel_BDSKeplerianSet_bdsCis,
        _GANSS_NavModel_BDSKeplerianSet_bdsAODE,
        ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id_tab,
        ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__id,
        ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality_tab,
        ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__criticality,
        ____GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item__extensionValue,
        __GANSS_NavModel_BDSKeplerianSet_iE_Extensions__item_,
        _GANSS_NavModel_BDSKeplerianSet_iE_Extensions,
        GANSS_NavModel_BDSKeplerianSet,
        GANSS_NavModel_BDSKeplerianSet_ExtIEs,
        _GANSS_NavModel_CNAVKeplerianSet_cnavTop,
        _GANSS_NavModel_CNAVKeplerianSet_cnavURAindex,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaA,
        _GANSS_NavModel_CNAVKeplerianSet_cnavAdot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNo,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaNoDot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavMo,
        _GANSS_NavModel_CNAVKeplerianSet_cnavE,
        _GANSS_NavModel_CNAVKeplerianSet_cnavOmega,
        _GANSS_NavModel_CNAVKeplerianSet_cnavOMEGA0,
        _GANSS_NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavIo,
        _GANSS_NavModel_CNAVKeplerianSet_cnavIoDot,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCis,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCic,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCrs,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCrc,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCus,
        _GANSS_NavModel_CNAVKeplerianSet_cnavCuc,
        ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__id,
        ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_CNAVKeplerianSet_ie_Extensions__item_,
        _GANSS_NavModel_CNAVKeplerianSet_ie_Extensions,
        GANSS_NavModel_CNAVKeplerianSet,
        GANSS_NavModel_CNAVKeplerianSet_ExtIEs,
        _GANSS_NavModel_GLONASSecef_gloEn,
        _GANSS_NavModel_GLONASSecef_gloP1,
        _GANSS_NavModel_GLONASSecef_gloP2,
        _GANSS_NavModel_GLONASSecef_gloM,
        _GANSS_NavModel_GLONASSecef_gloX,
        _GANSS_NavModel_GLONASSecef_gloXdot,
        _GANSS_NavModel_GLONASSecef_gloXdotdot,
        _GANSS_NavModel_GLONASSecef_gloY,
        _GANSS_NavModel_GLONASSecef_gloYdot,
        _GANSS_NavModel_GLONASSecef_gloYdotdot,
        _GANSS_NavModel_GLONASSecef_gloZ,
        _GANSS_NavModel_GLONASSecef_gloZdot,
        _GANSS_NavModel_GLONASSecef_gloZdotdot,
        ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__id,
        ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__criticality,
        ____GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_GLONASSecef_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_GLONASSecef_ie_Extensions__item_,
        _GANSS_NavModel_GLONASSecef_ie_Extensions,
        GANSS_NavModel_GLONASSecef,
        GANSS_NavModel_GLONASSecef_ExtIEs,
        _GANSS_NavModel_NAVKeplerianSet_navURA,
        _GANSS_NavModel_NAVKeplerianSet_navFitFlag,
        _GANSS_NavModel_NAVKeplerianSet_navToe,
        _GANSS_NavModel_NAVKeplerianSet_navOmega,
        _GANSS_NavModel_NAVKeplerianSet_navDeltaN,
        _GANSS_NavModel_NAVKeplerianSet_navM0,
        _GANSS_NavModel_NAVKeplerianSet_navOmegaADot,
        _GANSS_NavModel_NAVKeplerianSet_navE,
        _GANSS_NavModel_NAVKeplerianSet_navIDot,
        _GANSS_NavModel_NAVKeplerianSet_navAPowerHalf,
        _GANSS_NavModel_NAVKeplerianSet_navI0,
        _GANSS_NavModel_NAVKeplerianSet_navOmegaA0,
        _GANSS_NavModel_NAVKeplerianSet_navCrs,
        _GANSS_NavModel_NAVKeplerianSet_navCis,
        _GANSS_NavModel_NAVKeplerianSet_navCus,
        _GANSS_NavModel_NAVKeplerianSet_navCrc,
        _GANSS_NavModel_NAVKeplerianSet_navCic,
        _GANSS_NavModel_NAVKeplerianSet_navCuc,
        ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__id,
        ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_NAVKeplerianSet_ie_Extensions__item_,
        _GANSS_NavModel_NAVKeplerianSet_ie_Extensions,
        GANSS_NavModel_NAVKeplerianSet,
        GANSS_NavModel_NAVKeplerianSet_ExtIEs,
        _GANSS_NavModel_SBASecef_sbasTo,
        _GANSS_NavModel_SBASecef_sbasAccuracy,
        _GANSS_NavModel_SBASecef_sbasXg,
        _GANSS_NavModel_SBASecef_sbasYg,
        _GANSS_NavModel_SBASecef_sbasZg,
        _GANSS_NavModel_SBASecef_sbasXgDot,
        _GANSS_NavModel_SBASecef_sbasYgDot,
        _GANSS_NavModel_SBASecef_sbasZgDot,
        _GANSS_NavModel_SBASecef_sbasXgDotDot,
        _GANSS_NavModel_SBASecef_sbagYgDotDot,
        _GANSS_NavModel_SBASecef_sbasZgDotDot,
        ____GANSS_NavModel_SBASecef_ie_Extensions__item__id_tab,
        ___GANSS_NavModel_SBASecef_ie_Extensions__item__id,
        ____GANSS_NavModel_SBASecef_ie_Extensions__item__criticality_tab,
        ___GANSS_NavModel_SBASecef_ie_Extensions__item__criticality,
        ____GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue_tab,
        ___GANSS_NavModel_SBASecef_ie_Extensions__item__extensionValue,
        __GANSS_NavModel_SBASecef_ie_Extensions__item_,
        _GANSS_NavModel_SBASecef_ie_Extensions,
        GANSS_NavModel_SBASecef,
        GANSS_NavModel_SBASecef_ExtIEs,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_toe_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_omega_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_delta_n_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_m_zero_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_omegadot_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_ganss_e_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_idot_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_a_sqrt_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_i_zero_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_omega_zero_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rs_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_c_is_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_c_us_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_c_rc_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_c_ic_nav,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_c_uc_nav,
        _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id_tab,
        ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__id,
        _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality_tab,
        ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__criticality,
        _____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue_tab,
        ____GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item__extensionValue,
        ___GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions__item_,
        __GANSS_Orbit_Model_gANSS_keplerianParameters_ie_Extensions,
        _GANSS_Orbit_Model_gANSS_keplerianParameters,
        GANSS_Orbit_Model,
        GANSS_KeplerianParametersOrb_ExtIEs,
        __GANSS_Real_Time_Integrity__item__bad_ganss_satId,
        __GANSS_Real_Time_Integrity__item__bad_ganss_signalId,
        _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id_tab,
        ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__id,
        _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality_tab,
        ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__criticality,
        _____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_Real_Time_Integrity__item__ie_Extensions__item__extensionValue,
        ___GANSS_Real_Time_Integrity__item__ie_Extensions__item_,
        __GANSS_Real_Time_Integrity__item__ie_Extensions,
        _GANSS_Real_Time_Integrity__item_,
        GANSS_Real_Time_Integrity,
        GANSS_RealTimeInformationItem_ExtIEs,
        _GANSS_RX_Pos_latitudeSign,
        _GANSS_RX_Pos_degreesOfLatitude,
        _GANSS_RX_Pos_degreesOfLongitude,
        _GANSS_RX_Pos_directionOfAltitude,
        _GANSS_RX_Pos_altitude,
        ____GANSS_RX_Pos_ie_Extensions__item__id_tab,
        ___GANSS_RX_Pos_ie_Extensions__item__id,
        ____GANSS_RX_Pos_ie_Extensions__item__criticality_tab,
        ___GANSS_RX_Pos_ie_Extensions__item__criticality,
        ____GANSS_RX_Pos_ie_Extensions__item__extensionValue_tab,
        ___GANSS_RX_Pos_ie_Extensions__item__extensionValue,
        __GANSS_RX_Pos_ie_Extensions__item_,
        _GANSS_RX_Pos_ie_Extensions,
        GANSS_RX_Pos,
        GANSS_RX_Pos_ExtIEs,
        __GANSS_SatelliteInformationKP__item__satId,
        __GANSS_SatelliteInformationKP__item__ganss_e_alm,
        __GANSS_SatelliteInformationKP__item__ganss_delta_I_alm,
        __GANSS_SatelliteInformationKP__item__ganss_omegadot_alm,
        __GANSS_SatelliteInformationKP__item__ganss_svStatusINAV_alm,
        __GANSS_SatelliteInformationKP__item__ganss_svStatusFNAV_alm,
        __GANSS_SatelliteInformationKP__item__ganss_delta_a_sqrt_alm,
        __GANSS_SatelliteInformationKP__item__ganss_omegazero_alm,
        __GANSS_SatelliteInformationKP__item__ganss_m_zero_alm,
        __GANSS_SatelliteInformationKP__item__ganss_omega_alm,
        __GANSS_SatelliteInformationKP__item__ganss_af_zero_alm,
        __GANSS_SatelliteInformationKP__item__ganss_af_one_alm,
        _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id_tab,
        ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__id,
        _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality_tab,
        ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__criticality,
        _____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_SatelliteInformationKP__item__ie_Extensions__item__extensionValue,
        ___GANSS_SatelliteInformationKP__item__ie_Extensions__item_,
        __GANSS_SatelliteInformationKP__item__ie_Extensions,
        _GANSS_SatelliteInformationKP__item_,
        GANSS_SatelliteInformationKP,
        GANSS_SatelliteInformationKPItem_ExtIEs,
        __Ganss_Sat_Info_AddNavList__item__satId,
        __Ganss_Sat_Info_AddNavList__item__svHealth,
        __Ganss_Sat_Info_AddNavList__item__iod,
        __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels,
        __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue,
        ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_,
        __Ganss_Sat_Info_AddNavList__item__ie_Extensions,
        _Ganss_Sat_Info_AddNavList__item_,
        Ganss_Sat_Info_AddNavList,
        Ganss_Sat_Info_AddNavList_ExtIEs,
        _GANSS_SAT_Info_Almanac_BDSkpList__item_,
        GANSS_SAT_Info_Almanac_BDSkpList,
        _GANSS_SAT_Info_Almanac_BDS_satId,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmToa,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmSqrtA,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmE,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmW,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmM0,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmega0,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmOmegaDot,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmDeltaI,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmA0,
        _GANSS_SAT_Info_Almanac_BDS_bdsAlmA1,
        _GANSS_SAT_Info_Almanac_BDS_bdsSvHealth,
        ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_BDS_iE_Extensions__item_,
        _GANSS_SAT_Info_Almanac_BDS_iE_Extensions,
        GANSS_SAT_Info_Almanac_BDS,
        GANSS_SAT_Info_Almanac_BDS_ExtIEs,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmNA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmnA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmHA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmLambdaA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTlambdaA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaIA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAkmDeltaTA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmDeltaTdotA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmEpsilonA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmOmegaA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmTauA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmCA,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__gloAlmMA,
        _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id_tab,
        ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__id,
        _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality_tab,
        ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__criticality,
        _____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item__extensionValue,
        ___GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions__item_,
        __GANSS_SAT_Info_Almanac_GLOkpList__item__ie_Extensions,
        _GANSS_SAT_Info_Almanac_GLOkpList__item_,
        GANSS_SAT_Info_Almanac_GLOkpList,
        GANSS_SAT_Info_Almanac_GLOkp_ExtIEs,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__svID,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmE,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmDeltaI,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmegaDot,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmSqrtA,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega0,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmOmega,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmMo,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf0,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmaf1,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL1Health,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL2Health,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__midiAlmL5Health,
        _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id_tab,
        ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__id,
        _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality_tab,
        ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__criticality,
        _____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item__extensionValue,
        ___GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions__item_,
        __GANSS_SAT_Info_Almanac_MIDIkpList__item__ie_Extensions,
        _GANSS_SAT_Info_Almanac_MIDIkpList__item_,
        GANSS_SAT_Info_Almanac_MIDIkpList,
        GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__svID,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmE,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmDeltaI,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGADOT,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSVHealth,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmSqrtA,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOMEGAo,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmOmega,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmMo,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf0,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__navAlmaf1,
        _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id_tab,
        ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__id,
        _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality_tab,
        ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__criticality,
        _____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item__extensionValue,
        ___GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions__item_,
        __GANSS_SAT_Info_Almanac_NAVkpList__item__ie_Extensions,
        _GANSS_SAT_Info_Almanac_NAVkpList__item_,
        GANSS_SAT_Info_Almanac_NAVkpList,
        GANSS_SAT_Info_Almanac_NAVkp_ExtIEs,
        __GANSS_SAT_Info_Almanac_REDkpList__item__svID,
        __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmDeltaA,
        __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmOmega0,
        __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmPhi0,
        __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL1Health,
        __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL2Health,
        __GANSS_SAT_Info_Almanac_REDkpList__item__redAlmL5Health,
        _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id_tab,
        ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__id,
        _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality_tab,
        ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__criticality,
        _____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item__extensionValue,
        ___GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions__item_,
        __GANSS_SAT_Info_Almanac_REDkpList__item__ie_Extensions,
        _GANSS_SAT_Info_Almanac_REDkpList__item_,
        GANSS_SAT_Info_Almanac_REDkpList,
        GANSS_SAT_Info_Almanac_REDkp_ExtIEs,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmDataID,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__svID,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmHealth,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXg,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYg,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZg,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmXgdot,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmYgDot,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmZgDot,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__sbasAlmTo,
        _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id_tab,
        ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__id,
        _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality_tab,
        ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__criticality,
        _____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item__extensionValue,
        ___GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions__item_,
        __GANSS_SAT_Info_Almanac_SBASecefList__item__ie_Extensions,
        _GANSS_SAT_Info_Almanac_SBASecefList__item_,
        GANSS_SAT_Info_Almanac_SBASecefList,
        GANSS_SAT_Info_Almanac_SBASecef_ExtIEs,
        __GANSS_Sat_Info_Nav__item__satId,
        __GANSS_Sat_Info_Nav__item__svHealth,
        __GANSS_Sat_Info_Nav__item__iod,
        __GANSS_Sat_Info_Nav__item__ganssClockModel,
        __GANSS_Sat_Info_Nav__item__ganssOrbitModel,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue,
        ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_,
        __GANSS_Sat_Info_Nav__item__ie_Extensions,
        _GANSS_Sat_Info_Nav__item_,
        GANSS_Sat_Info_Nav,
        GANSS_Sat_Info_Nav_ExtIEs,
        GANSS_SBAS_ID,
        _GANSS_SBASclockModel_sbasTo,
        _GANSS_SBASclockModel_sbasAgfo,
        _GANSS_SBASclockModel_sbasAgf1,
        ____GANSS_SBASclockModel_ie_Extensions__item__id_tab,
        ___GANSS_SBASclockModel_ie_Extensions__item__id,
        ____GANSS_SBASclockModel_ie_Extensions__item__criticality_tab,
        ___GANSS_SBASclockModel_ie_Extensions__item__criticality,
        ____GANSS_SBASclockModel_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SBASclockModel_ie_Extensions__item__extensionValue,
        __GANSS_SBASclockModel_ie_Extensions__item_,
        _GANSS_SBASclockModel_ie_Extensions,
        GANSS_SBASclockModel,
        GANSS_SBASclockModel_ExtIEs,
        GANSS_Signal_ID,
        GANSS_StatusHealth,
        GANSS_Time_ID,
        _GANSS_Time_Model_ganss_time_model_Ref_Time,
        _GANSS_Time_Model_ganss_t_a0,
        _GANSS_Time_Model_ganss_t_a1,
        _GANSS_Time_Model_ganss_t_a2,
        _GANSS_Time_Model_gnss_to_id,
        _GANSS_Time_Model_ganss_wk_number,
        ____GANSS_Time_Model_ie_Extensions__item__id_tab,
        _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_Time_Model_ie_Extensions__item__id,
        ___GANSS_Time_Model_ie_Extensions__item__criticality,
        ___GANSS_Time_Model_ie_Extensions__item__extensionValue,
        __GANSS_Time_Model_ie_Extensions__item_,
        _GANSS_Time_Model_ie_Extensions,
        GANSS_Time_Model,
        GANSS_Time_Model_ExtIEs,
        _GANSS_Time_Model_ExtIEs_val_Extension_0,
        _GANSS_Transmission_Time_ganssDay,
        _GANSS_Transmission_Time_ganssTod,
        ____GANSS_Transmission_Time_ie_Extensions__item__id_tab,
        ___GANSS_Transmission_Time_ie_Extensions__item__id,
        ____GANSS_Transmission_Time_ie_Extensions__item__criticality_tab,
        ___GANSS_Transmission_Time_ie_Extensions__item__criticality,
        ____GANSS_Transmission_Time_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Transmission_Time_ie_Extensions__item__extensionValue,
        __GANSS_Transmission_Time_ie_Extensions__item_,
        _GANSS_Transmission_Time_ie_Extensions,
        GANSS_Transmission_Time,
        GANSS_Transmission_Time_ExtIEs,
        _GANSS_UTC_Model_a_one_utc,
        _GANSS_UTC_Model_a_zero_utc,
        _GANSS_UTC_Model_t_ot_utc,
        _GANSS_UTC_Model_w_n_t_utc,
        _GANSS_UTC_Model_delta_t_ls_utc,
        _GANSS_UTC_Model_w_n_lsf_utc,
        _GANSS_UTC_Model_dn_utc,
        _GANSS_UTC_Model_delta_t_lsf_utc,
        ____GANSS_UTC_Model_ie_Extensions__item__id_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__id,
        ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__criticality,
        ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__extensionValue,
        __GANSS_UTC_Model_ie_Extensions__item_,
        _GANSS_UTC_Model_ie_Extensions,
        GANSS_UTC_Model,
        GANSS_UTC_Model_ExtIEs,
        _GANSS_UTCmodelSet1_utcA0,
        _GANSS_UTCmodelSet1_utcA1,
        _GANSS_UTCmodelSet1_utcA2,
        _GANSS_UTCmodelSet1_utcDeltaTls,
        _GANSS_UTCmodelSet1_utcTot,
        _GANSS_UTCmodelSet1_utcWNot,
        _GANSS_UTCmodelSet1_utcWNlsf,
        _GANSS_UTCmodelSet1_utcDN,
        _GANSS_UTCmodelSet1_utcDeltaTlsf,
        ____GANSS_UTCmodelSet1_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet1_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet1_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet1_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet1_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet1_ie_Extensions__item_,
        _GANSS_UTCmodelSet1_ie_Extensions,
        GANSS_UTCmodelSet1,
        GANSS_UTCmodelSet1_ExtIEs,
        _GANSS_UTCmodelSet2_nA,
        _GANSS_UTCmodelSet2_tauC,
        _GANSS_UTCmodelSet2_deltaUT1,
        _GANSS_UTCmodelSet2_kp,
        ____GANSS_UTCmodelSet2_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet2_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet2_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet2_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet2_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet2_ie_Extensions__item_,
        _GANSS_UTCmodelSet2_ie_Extensions,
        GANSS_UTCmodelSet2,
        GANSS_UTCmodelSet2_ExtIEs,
        _GANSS_UTCmodelSet3_utcA1wnt,
        _GANSS_UTCmodelSet3_utcA0wnt,
        _GANSS_UTCmodelSet3_utcTot,
        _GANSS_UTCmodelSet3_utcWNt,
        _GANSS_UTCmodelSet3_utcDeltaTls,
        _GANSS_UTCmodelSet3_utcWNlsf,
        _GANSS_UTCmodelSet3_utcDN,
        _GANSS_UTCmodelSet3_utcDeltaTlsf,
        _GANSS_UTCmodelSet3_utcStandardID,
        ____GANSS_UTCmodelSet3_ie_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet3_ie_Extensions__item__id,
        ____GANSS_UTCmodelSet3_ie_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet3_ie_Extensions__item__criticality,
        ____GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet3_ie_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet3_ie_Extensions__item_,
        _GANSS_UTCmodelSet3_ie_Extensions,
        GANSS_UTCmodelSet3,
        GANSS_UTCmodelSet3_ExtIEs,
        _GANSS_UTCmodelSet4_utcA0,
        _GANSS_UTCmodelSet4_utcA1,
        _GANSS_UTCmodelSet4_utcDeltaTls,
        _GANSS_UTCmodelSet4_utcWNlsf,
        _GANSS_UTCmodelSet4_utcDN,
        _GANSS_UTCmodelSet4_utcDeltaTlsf,
        ____GANSS_UTCmodelSet4_iE_Extensions__item__id_tab,
        ___GANSS_UTCmodelSet4_iE_Extensions__item__id,
        ____GANSS_UTCmodelSet4_iE_Extensions__item__criticality_tab,
        ___GANSS_UTCmodelSet4_iE_Extensions__item__criticality,
        ____GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue_tab,
        ___GANSS_UTCmodelSet4_iE_Extensions__item__extensionValue,
        __GANSS_UTCmodelSet4_iE_Extensions__item_,
        _GANSS_UTCmodelSet4_iE_Extensions,
        GANSS_UTCmodelSet4,
        GANSS_UTCmodelSet4_ExtIEs,
        _GA_PointWithAltitude_geographicalCoordinates,
        _GA_PointWithAltitude_altitudeAndDirection,
        ____GA_PointWithAltitude_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__id,
        ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__criticality,
        ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitude_iE_Extensions__item_,
        _GA_PointWithAltitude_iE_Extensions,
        GA_PointWithAltitude,
        GA_PointWithAltitude_ExtIEs,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions,
        GA_PointWithAltitudeAndUncertaintyEllipsoid,
        GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs,
        _GA_PointWithUnCertaintyEllipse_geographicalCoordinates,
        _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse,
        _GA_PointWithUnCertaintyEllipse_confidence,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_,
        _GA_PointWithUnCertaintyEllipse_iE_Extensions,
        GA_PointWithUnCertaintyEllipse,
        GA_PointWithUnCertaintyEllipse_ExtIEs,
        _GA_UncertaintyEllipse_uncertaintySemi_major,
        _GA_UncertaintyEllipse_uncertaintySemi_minor,
        _GA_UncertaintyEllipse_orientationOfMajorAxis,
        GA_UncertaintyEllipse,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        _GA_PointWithUnCertainty_uncertaintyCode,
        ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__id,
        ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertainty_iE_Extensions__item_,
        _GA_PointWithUnCertainty_iE_Extensions,
        GA_PointWithUnCertainty,
        GA_PointWithUnCertainty_ExtIEs,
        _GA_AccessPointPosition_geographicalCoordinate,
        ____GA_AccessPointPosition_iE_Extensions__item__id_tab,
        ___GA_AccessPointPosition_iE_Extensions__item__id,
        ____GA_AccessPointPosition_iE_Extensions__item__criticality_tab,
        ___GA_AccessPointPosition_iE_Extensions__item__criticality,
        ____GA_AccessPointPosition_iE_Extensions__item__extensionValue_tab,
        ___GA_AccessPointPosition_iE_Extensions__item__extensionValue,
        __GA_AccessPointPosition_iE_Extensions__item_,
        _GA_AccessPointPosition_iE_Extensions,
        GA_AccessPointPosition,
        GA_AccessPoint_ExtIEs,
        _GeographicalCoordinate_latitudeSign,
        _GeographicalCoordinate_latitude,
        _GeographicalCoordinate_longitude,
        ____GeographicalCoordinate_iE_Extensions__item__id_tab,
        ___GeographicalCoordinate_iE_Extensions__item__id,
        ____GeographicalCoordinate_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinate_iE_Extensions__item__criticality,
        ____GeographicalCoordinate_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinate_iE_Extensions__item__extensionValue,
        __GeographicalCoordinate_iE_Extensions__item_,
        _GeographicalCoordinate_iE_Extensions,
        GeographicalCoordinate,
        GeographicalCoordinate_ExtIEs,
        GERAN_Cell_Capability,
        GERAN_Classmark,
        _GERAN_SI_Type_sI,
        _GERAN_SI_Type_pSI,
        GERAN_SI_Type,
        __GERAN_SystemInfo__item__gERAN_SI_block,
        _____GERAN_SystemInfo__item__iE_Extensions__item__id_tab,
        ____GERAN_SystemInfo__item__iE_Extensions__item__id,
        _____GERAN_SystemInfo__item__iE_Extensions__item__criticality_tab,
        ____GERAN_SystemInfo__item__iE_Extensions__item__criticality,
        _____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue_tab,
        ____GERAN_SystemInfo__item__iE_Extensions__item__extensionValue,
        ___GERAN_SystemInfo__item__iE_Extensions__item_,
        __GERAN_SystemInfo__item__iE_Extensions,
        _GERAN_SystemInfo__item_,
        GERAN_SystemInfo,
        GERAN_SystemInfo_ExtIEs,
        GenericTrafficCategory,
        _GPS_Almanac_wna_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__dATA_ID,
        ___GPS_Almanac_satellite_Almanac_Information__item__sAT_ID,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_e_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_toa_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_delta_I_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__omegadot_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__svhealth_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_a_sqrt_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__omegazero_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__m_zero_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_omega_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_zero_alm,
        ___GPS_Almanac_satellite_Almanac_Information__item__gps_af_one_alm,
        ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id_tab,
        _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__id,
        ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality_tab,
        _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__criticality,
        ______GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue_tab,
        _____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item__extensionValue,
        ____GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions__item_,
        ___GPS_Almanac_satellite_Almanac_Information__item__iE_Extensions,
        __GPS_Almanac_satellite_Almanac_Information__item_,
        _GPS_Almanac_satellite_Almanac_Information,
        _GPS_Almanac_sVGlobalHealth_alm,
        ____GPS_Almanac_iE_Extensions__item__id_tab,
        _____GPS_Almanac_iE_Extensions__item__id_tab_val_Extension_0,
        _____GPS_Almanac_iE_Extensions__item__id_tab_val_Extension_1,
        ___GPS_Almanac_iE_Extensions__item__id,
        ___GPS_Almanac_iE_Extensions__item__criticality,
        ___GPS_Almanac_iE_Extensions__item__extensionValue,
        __GPS_Almanac_iE_Extensions__item_,
        _GPS_Almanac_iE_Extensions,
        GPS_Almanac,
        Satellite_Almanac_Information_ExtIEs,
        GPS_Almanac_ExtIEs,
        _GPS_Almanac_ExtIEs_val_Extension_0,
        _GPS_Almanac_ExtIEs_val_Extension_1,
        __Satellite_Almanac_Information_ExtItem__item__dATA_ID,
        __Satellite_Almanac_Information_ExtItem__item__sAT_ID,
        __Satellite_Almanac_Information_ExtItem__item__gps_e_alm,
        __Satellite_Almanac_Information_ExtItem__item__gps_toa_alm,
        __Satellite_Almanac_Information_ExtItem__item__gps_delta_I_alm,
        __Satellite_Almanac_Information_ExtItem__item__omegadot_alm,
        __Satellite_Almanac_Information_ExtItem__item__svhealth_alm,
        __Satellite_Almanac_Information_ExtItem__item__gps_a_sqrt_alm,
        __Satellite_Almanac_Information_ExtItem__item__omegazero_alm,
        __Satellite_Almanac_Information_ExtItem__item__m_zero_alm,
        __Satellite_Almanac_Information_ExtItem__item__gps_omega_alm,
        __Satellite_Almanac_Information_ExtItem__item__gps_af_zero_alm,
        __Satellite_Almanac_Information_ExtItem__item__gps_af_one_alm,
        _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id_tab,
        ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__id,
        _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality_tab,
        ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__criticality,
        _____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue_tab,
        ____Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item__extensionValue,
        ___Satellite_Almanac_Information_ExtItem__item__iE_Extensions__item_,
        __Satellite_Almanac_Information_ExtItem__item__iE_Extensions,
        _Satellite_Almanac_Information_ExtItem__item_,
        Satellite_Almanac_Information_ExtItem,
        Satellite_Almanac_Information_ExtItemIEs,
        __GPSInformation__item__gPSInformationItem,
        _____GPSInformation__item__iE_Extensions__item__id_tab,
        ____GPSInformation__item__iE_Extensions__item__id,
        _____GPSInformation__item__iE_Extensions__item__criticality_tab,
        ____GPSInformation__item__iE_Extensions__item__criticality,
        _____GPSInformation__item__iE_Extensions__item__extensionValue_tab,
        ____GPSInformation__item__iE_Extensions__item__extensionValue,
        ___GPSInformation__item__iE_Extensions__item_,
        __GPSInformation__item__iE_Extensions,
        _GPSInformation__item_,
        GPSInformation,
        GPSInformation_ExtIEs,
        _GPS_Ionospheric_Model_alpha_zero_ionos,
        _GPS_Ionospheric_Model_alpha_one_ionos,
        _GPS_Ionospheric_Model_alpha_two_ionos,
        _GPS_Ionospheric_Model_alpha_three_ionos,
        _GPS_Ionospheric_Model_beta_zero_ionos,
        _GPS_Ionospheric_Model_beta_one_ionos,
        _GPS_Ionospheric_Model_beta_two_ionos,
        _GPS_Ionospheric_Model_beta_three_ionos,
        ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab,
        ___GPS_Ionospheric_Model_iE_Extensions__item__id,
        ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab,
        ___GPS_Ionospheric_Model_iE_Extensions__item__criticality,
        ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab,
        ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue,
        __GPS_Ionospheric_Model_iE_Extensions__item_,
        _GPS_Ionospheric_Model_iE_Extensions,
        GPS_Ionospheric_Model,
        GPS_Ionospheric_Model_ExtIEs,
        __GPS_NavigationModel_and_TimeRecovery__item__tx_tow_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__sAT_ID,
        __GPS_NavigationModel_and_TimeRecovery__item__tlm_message_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__tlm_revd_c_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__ho_word_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__w_n_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__ca_or_p_on_l2_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__user_range_accuracy_index_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__sv_health_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__iodc_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__l2_p_dataflag_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__sf1_reserved_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__t_gd_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__t_oc_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__a_f_2_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__a_f_1_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__a_f_zero_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__c_rs_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__delta_n_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__m_zero_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__c_uc_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__gps_e_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__c_us_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__a_sqrt_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__t_oe_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__fit_interval_flag_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__aodo_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__c_ic_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__omega_zero_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__c_is_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__i_zero_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__c_rc_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__gps_omega_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__omegadot_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__idot_nav,
        __GPS_NavigationModel_and_TimeRecovery__item__spare_zero_fill,
        _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id_tab,
        ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__id,
        _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality_tab,
        ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__criticality,
        _____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue_tab,
        ____GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item__extensionValue,
        ___GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions__item_,
        __GPS_NavigationModel_and_TimeRecovery__item__iE_Extensions,
        _GPS_NavigationModel_and_TimeRecovery__item_,
        GPS_NavigationModel_and_TimeRecovery,
        GPS_NavigationModel_and_TimeRecoveryItem_ExtIEs,
        _GPS_RealTime_Integrity_badSatellites,
        _GPS_RealTime_Integrity_noBadSatellite,
        GPS_RealTime_Integrity,
        _GPS_RX_POS_geographicalCoordinate,
        _GPS_RX_POS_altitudeAndDirection,
        ____GPS_RX_POS_iE_Extensions__item__id_tab,
        ___GPS_RX_POS_iE_Extensions__item__id,
        ____GPS_RX_POS_iE_Extensions__item__criticality_tab,
        ___GPS_RX_POS_iE_Extensions__item__criticality,
        ____GPS_RX_POS_iE_Extensions__item__extensionValue_tab,
        ___GPS_RX_POS_iE_Extensions__item__extensionValue,
        __GPS_RX_POS_iE_Extensions__item_,
        _GPS_RX_POS_iE_Extensions,
        GPS_RX_POS,
        GPS_RX_POS_ExtIEs,
        GPS_Status_Health,
        GPSTOW,
        _GPS_UTC_Model_a_one_utc,
        _GPS_UTC_Model_a_zero_utc,
        _GPS_UTC_Model_t_ot_utc,
        _GPS_UTC_Model_delta_t_ls_utc,
        _GPS_UTC_Model_w_n_t_utc,
        _GPS_UTC_Model_w_n_lsf_utc,
        _GPS_UTC_Model_dn_utc,
        _GPS_UTC_Model_delta_t_lsf_utc,
        ____GPS_UTC_Model_iE_Extensions__item__id_tab,
        ___GPS_UTC_Model_iE_Extensions__item__id,
        ____GPS_UTC_Model_iE_Extensions__item__criticality_tab,
        ___GPS_UTC_Model_iE_Extensions__item__criticality,
        ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab,
        ___GPS_UTC_Model_iE_Extensions__item__extensionValue,
        __GPS_UTC_Model_iE_Extensions__item_,
        _GPS_UTC_Model_iE_Extensions,
        GPS_UTC_Model,
        GPS_UTC_Model_ExtIEs,
        _Guaranteed_Rate_Information_guaranteed_UL_Rate,
        _Guaranteed_Rate_Information_guaranteed_DL_Rate,
        ____Guaranteed_Rate_Information_iE_Extensions__item__id_tab,
        ___Guaranteed_Rate_Information_iE_Extensions__item__id,
        ____Guaranteed_Rate_Information_iE_Extensions__item__criticality_tab,
        ___Guaranteed_Rate_Information_iE_Extensions__item__criticality,
        ____Guaranteed_Rate_Information_iE_Extensions__item__extensionValue_tab,
        ___Guaranteed_Rate_Information_iE_Extensions__item__extensionValue,
        __Guaranteed_Rate_Information_iE_Extensions__item_,
        _Guaranteed_Rate_Information_iE_Extensions,
        Guaranteed_Rate_Information,
        Guaranteed_Rate_Information_ExtIEs,
        Guaranteed_Rate,
        HARQ_Info_for_E_DCH,
        _HARQ_MemoryPartitioning_implicit,
        _HARQ_MemoryPartitioning_explicit,
        HARQ_MemoryPartitioning,
        _HARQ_MemoryPartitioning_Implicit_number_of_Processes,
        ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id_tab,
        ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__id,
        ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality_tab,
        ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__criticality,
        ____HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue_tab,
        ___HARQ_MemoryPartitioning_Implicit_iE_Extensions__item__extensionValue,
        __HARQ_MemoryPartitioning_Implicit_iE_Extensions__item_,
        _HARQ_MemoryPartitioning_Implicit_iE_Extensions,
        HARQ_MemoryPartitioning_Implicit,
        HARQ_MemoryPartitioning_Implicit_ExtIEs,
        _HARQ_MemoryPartitioning_Explicit_hARQ_MemoryPartitioningList,
        ____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab,
        _____HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id_tab_val_Extension_0,
        ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__id,
        ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__criticality,
        ___HARQ_MemoryPartitioning_Explicit_iE_Extensions__item__extensionValue,
        __HARQ_MemoryPartitioning_Explicit_iE_Extensions__item_,
        _HARQ_MemoryPartitioning_Explicit_iE_Extensions,
        HARQ_MemoryPartitioning_Explicit,
        HARQ_MemoryPartitioning_Explicit_ExtIEs,
        _HARQ_MemoryPartitioning_Explicit_ExtIEs_val_Extension_0,
        _HARQ_MemoryPartitioningList__item_,
        HARQ_MemoryPartitioningList,
        _HARQ_MemoryPartitioningInfoExtForMIMO__item_,
        HARQ_MemoryPartitioningInfoExtForMIMO,
        _HARQ_MemoryPartitioningItem_process_Memory_Size,
        ____HARQ_MemoryPartitioningItem_iE_Extensions__item__id_tab,
        ___HARQ_MemoryPartitioningItem_iE_Extensions__item__id,
        ____HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality_tab,
        ___HARQ_MemoryPartitioningItem_iE_Extensions__item__criticality,
        ____HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue_tab,
        ___HARQ_MemoryPartitioningItem_iE_Extensions__item__extensionValue,
        __HARQ_MemoryPartitioningItem_iE_Extensions__item_,
        _HARQ_MemoryPartitioningItem_iE_Extensions,
        HARQ_MemoryPartitioningItem,
        HARQ_MemoryPartitioningItem_ExtIEs,
        HARQ_Preamble_Mode,
        HARQ_Process_Allocation_2ms_EDCH,
        HARQ_Preamble_Mode_Activation_Indicator,
        HCS_Prio,
        _HS_DSCH_Cell_List__item_,
        HS_DSCH_Cell_List,
        _HS_DSCH_Cell_hs_DSCH_Cell_TBS,
        ____HS_DSCH_Cell_iE_Extensions__item__id_tab,
        ___HS_DSCH_Cell_iE_Extensions__item__id,
        ____HS_DSCH_Cell_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Cell_iE_Extensions__item__criticality,
        ____HS_DSCH_Cell_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Cell_iE_Extensions__item__extensionValue,
        __HS_DSCH_Cell_iE_Extensions__item_,
        _HS_DSCH_Cell_iE_Extensions,
        HS_DSCH_Cell,
        HS_DSCH_Cell_ExtIEs,
        HSDSCH_Configured_Indicator,
        _HSDSCH_FDD_Information_hSDSCH_MACdFlows_Information,
        _HSDSCH_FDD_Information_uE_Capabilities_Info,
        _HSDSCH_FDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_FDD_Information_cqiFeedback_CycleK,
        _HSDSCH_FDD_Information_cqiRepetitionFactor,
        _HSDSCH_FDD_Information_ackNackRepetitionFactor,
        _HSDSCH_FDD_Information_cqiPowerOffset,
        _HSDSCH_FDD_Information_ackPowerOffset,
        _HSDSCH_FDD_Information_nackPowerOffset,
        _HSDSCH_FDD_Information_hsscch_PowerOffset,
        ____HSDSCH_FDD_Information_iE_Extensions__item__id_tab,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_10,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_11,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_12,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_13,
        _____HSDSCH_FDD_Information_iE_Extensions__item__id_tab_val_Extension_14,
        ___HSDSCH_FDD_Information_iE_Extensions__item__id,
        ___HSDSCH_FDD_Information_iE_Extensions__item__criticality,
        ___HSDSCH_FDD_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_FDD_Information_iE_Extensions__item_,
        _HSDSCH_FDD_Information_iE_Extensions,
        HSDSCH_FDD_Information,
        HSDSCH_FDD_Information_ExtIEs,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_0,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_1,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_2,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_3,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_4,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_5,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_6,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_7,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_8,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_9,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_10,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_11,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_12,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_13,
        _HSDSCH_FDD_Information_ExtIEs_val_Extension_14,
        _HSDSCH_FDD_Information_Response_hSDSCH_MACdFlow_Specific_InfoList_Response,
        _HSDSCH_FDD_Information_Response_hSSCCH_Specific_InfoList_Response,
        _HSDSCH_FDD_Information_Response_hSPDSCH_and_HSSCCH_ScramblingCode,
        _HSDSCH_FDD_Information_Response_measurement_Power_Offset,
        _HSDSCH_FDD_Information_Response_hARQ_MemoryPartitioning,
        ____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_FDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_8,
        ___HSDSCH_FDD_Information_Response_iE_Extensions__item__id,
        ___HSDSCH_FDD_Information_Response_iE_Extensions__item__criticality,
        ___HSDSCH_FDD_Information_Response_iE_Extensions__item__extensionValue,
        __HSDSCH_FDD_Information_Response_iE_Extensions__item_,
        _HSDSCH_FDD_Information_Response_iE_Extensions,
        HSDSCH_FDD_Information_Response,
        HSDSCH_FDD_Information_Response_ExtIEs,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_0,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_1,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_2,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_3,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_4,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_5,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_6,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_7,
        _HSDSCH_FDD_Information_Response_ExtIEs_val_Extension_8,
        _HS_DSCH_FDD_Secondary_Serving_Information_hsscch_PowerOffset,
        _HS_DSCH_FDD_Secondary_Serving_Information_sixtyfourQAM_UsageAllowedIndicator,
        ____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_4,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_5,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_6,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_7,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_8,
        _____HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id_tab_val_Extension_9,
        ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Information_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Information,
        HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_0,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_1,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_2,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_3,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_4,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_5,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_6,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_7,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_8,
        _HS_DSCH_FDD_Secondary_Serving_Information_ExtIEs_val_Extension_9,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSSCCH_Specific_InfoList_Response,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSPDSCH_and_HSSCCH_ScramblingCode,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_measurement_Power_Offset,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_sixtyfourQAM_DL_UsageIndicator,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_hSDSCH_TBSizeTableIndicator,
        ____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id_tab_val_Extension_3,
        ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Information_Response_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Information_Response,
        HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_0,
        _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_1,
        _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_2,
        _HS_DSCH_FDD_Secondary_Serving_Information_Respons_ExtIEs_val_Extension_3,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_hsscch_PowerOffset,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_hSSCCH_CodeChangeGrant,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_sixtyfourQAM_UsageAllowedIndicator,
        ____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_3,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_4,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_5,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_6,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_7,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_8,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_9,
        _____HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_10,
        ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__id,
        ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__criticality,
        ___HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item__extensionValue,
        __HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions__item_,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_iE_Extensions,
        HS_DSCH_Secondary_Serving_Information_To_Modify,
        HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_0,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_1,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_2,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_3,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_4,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_5,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_6,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_7,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_8,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_9,
        _HS_DSCH_Secondary_Serving_Information_To_Modify_ExtIEs_val_Extension_10,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_hsscch_PowerOffset,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_sixtyfourQAM_UsageAllowedIndicator,
        ____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6,
        _____HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7,
        ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised,
        HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_0,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_1,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_2,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_3,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_4,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_5,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_6,
        _HS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised_ExtIEs_val_Extension_7,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_hsSCCHCodeChangeIndicator,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_hS_PDSCH_Code_Change_Indicator,
        ____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab,
        _____HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__id,
        ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__criticality,
        ___HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item__extensionValue,
        __HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions__item_,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_iE_Extensions,
        HS_DSCH_FDD_Secondary_Serving_Update_Information,
        HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs,
        _HS_DSCH_FDD_Secondary_Serving_Update_Information_ExtIEs_val_Extension_0,
        _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_hS_DSCH_Secondary_Serving_cell_choice,
        ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id_tab,
        ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__id,
        ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__criticality,
        ____HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item__extensionValue,
        __HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions__item_,
        _HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_iE_Extensions,
        HS_DSCH_Secondary_Serving_Cell_Change_Information_Response,
        HS_DSCH_Secondary_Serving_Cell_Change_Information_Response_ExtIEs,
        _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_successful,
        _HS_DSCH_Secondary_Serving_cell_change_choice_hS_Secondary_Serving_cell_change_unsuccessful,
        HS_DSCH_Secondary_Serving_cell_change_choice,
        _HS_Secondary_Serving_cell_change_successful_hS_DSCH_FDD_Secondary_Serving_Information_Response,
        _HS_Secondary_Serving_cell_change_successful_hSDSCH_RNTI,
        ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id_tab,
        ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__id,
        ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality_tab,
        ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__criticality,
        ____HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue_tab,
        ___HS_Secondary_Serving_cell_change_successful_iE_Extensions__item__extensionValue,
        __HS_Secondary_Serving_cell_change_successful_iE_Extensions__item_,
        _HS_Secondary_Serving_cell_change_successful_iE_Extensions,
        HS_Secondary_Serving_cell_change_successful,
        HS_Secondary_Serving_cell_change_successful_ExtIEs,
        _HS_Secondary_Serving_cell_change_unsuccessful_cause,
        ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id_tab,
        ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__id,
        ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab,
        ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__criticality,
        ____HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab,
        ___HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue,
        __HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions__item_,
        _HS_Secondary_Serving_cell_change_unsuccessful_iE_Extensions,
        HS_Secondary_Serving_cell_change_unsuccessful,
        HS_Secondary_Serving_cell_change_unsuccessful_ExtIEs,
        HS_DSCH_Secondary_Serving_Remove,
        _HSDSCH_Information_to_Modify_hSDSCH_MACdFlow_Specific_InfoList_to_Modify,
        _HSDSCH_Information_to_Modify_priorityQueue_Info_to_Modify,
        _HSDSCH_Information_to_Modify_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_Information_to_Modify_cqiFeedback_CycleK,
        _HSDSCH_Information_to_Modify_cqiRepetitionFactor,
        _HSDSCH_Information_to_Modify_ackNackRepetitionFactor,
        _HSDSCH_Information_to_Modify_cqiPowerOffset,
        _HSDSCH_Information_to_Modify_ackPowerOffset,
        _HSDSCH_Information_to_Modify_nackPowerOffset,
        _HSDSCH_Information_to_Modify_hsscch_PowerOffset,
        _HSDSCH_Information_to_Modify_hSSCCH_CodeChangeGrant,
        _HSDSCH_Information_to_Modify_tDDAckNackPowerOffset,
        ____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_10,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_11,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_12,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_13,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_14,
        _____HSDSCH_Information_to_Modify_iE_Extensions__item__id_tab_val_Extension_15,
        ___HSDSCH_Information_to_Modify_iE_Extensions__item__id,
        ___HSDSCH_Information_to_Modify_iE_Extensions__item__criticality,
        ___HSDSCH_Information_to_Modify_iE_Extensions__item__extensionValue,
        __HSDSCH_Information_to_Modify_iE_Extensions__item_,
        _HSDSCH_Information_to_Modify_iE_Extensions,
        HSDSCH_Information_to_Modify,
        HSDSCH_Information_to_Modify_ExtIEs,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_0,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_1,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_2,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_3,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_4,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_5,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_6,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_7,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_8,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_9,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_10,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_11,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_12,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_13,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_14,
        _HSDSCH_Information_to_Modify_ExtIEs_val_Extension_15,
        _HSDSCH_Information_to_Modify_Unsynchronised_hSDSCH_MACdFlow_Specific_InfoList_to_Modify,
        _HSDSCH_Information_to_Modify_Unsynchronised_priorityQueueInfotoModifyUnsynchronised,
        _HSDSCH_Information_to_Modify_Unsynchronised_cqiPowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_ackPowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_nackPowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_hsscch_PowerOffset,
        _HSDSCH_Information_to_Modify_Unsynchronised_tDDAckNackPowerOffset,
        ____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id_tab_val_Extension_10,
        ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__id,
        ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__criticality,
        ___HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue,
        __HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions__item_,
        _HSDSCH_Information_to_Modify_Unsynchronised_iE_Extensions,
        HSDSCH_Information_to_Modify_Unsynchronised,
        HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_0,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_1,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_2,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_3,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_4,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_5,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_6,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_7,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_8,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_9,
        _HSDSCH_Information_to_Modify_Unsynchronised_ExtIEs_val_Extension_10,
        HSDSCH_MACdFlow_ID,
        _HSDSCH_MACdFlow_Specific_InfoList__item_,
        HSDSCH_MACdFlow_Specific_InfoList,
        HSDSCH_MACdPDUSizeFormat,
        _HSDSCH_MACdFlow_Specific_InfoItem_hSDSCH_MACdFlow_ID,
        _HSDSCH_MACdFlow_Specific_InfoItem_allocationRetentionPriority,
        _HSDSCH_MACdFlow_Specific_InfoItem_trafficClass,
        _HSDSCH_MACdFlow_Specific_InfoItem_bindingID,
        _HSDSCH_MACdFlow_Specific_InfoItem_transportLayerAddress,
        ____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab,
        _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__id,
        ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__criticality,
        ___HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions__item_,
        _HSDSCH_MACdFlow_Specific_InfoItem_iE_Extensions,
        HSDSCH_MACdFlow_Specific_InfoItem,
        HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs,
        _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_0,
        _HSDSCH_MACdFlow_Specific_InfoItem_ExtIEs_val_Extension_1,
        _HSDSCH_MACdFlow_Specific_InfoList_Response__item_,
        HSDSCH_MACdFlow_Specific_InfoList_Response,
        _HSDSCH_MACdFlow_Specific_InfoItem_Response_hSDSCH_MACdFlow_ID,
        _HSDSCH_MACdFlow_Specific_InfoItem_Response_bindingID,
        _HSDSCH_MACdFlow_Specific_InfoItem_Response_transportLayerAddress,
        _HSDSCH_MACdFlow_Specific_InfoItem_Response_hSDSCH_Initial_Capacity_Allocation,
        ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id_tab,
        ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__id,
        ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab,
        ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__criticality,
        ____HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions__item_,
        _HSDSCH_MACdFlow_Specific_InfoItem_Response_iE_Extensions,
        HSDSCH_MACdFlow_Specific_InfoItem_Response,
        HSDSCH_MACdFlow_Specific_InfoItem_Response_ExtIEs,
        _HSDSCH_MACdFlow_Specific_InfoList_to_Modify__item_,
        HSDSCH_MACdFlow_Specific_InfoList_to_Modify,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_hSDSCH_MACdFlow_ID,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_allocationRetentionPriority,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportBearerRequestIndicator,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_trafficClass,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_bindingID,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_transportLayerAddress,
        ____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab,
        _____HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__id,
        ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__criticality,
        ___HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions__item_,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_iE_Extensions,
        HSDSCH_MACdFlow_Specific_InfoItem_to_Modify,
        HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs,
        _HSDSCH_MACdFlow_Specific_InfoItem_to_Modify_ExtIEs_val_Extension_0,
        _HSDSCH_MACdFlows_Information_hSDSCH_MACdFlow_Specific_Info,
        _HSDSCH_MACdFlows_Information_priorityQueue_Info,
        ____HSDSCH_MACdFlows_Information_iE_Extensions__item__id_tab,
        ___HSDSCH_MACdFlows_Information_iE_Extensions__item__id,
        ____HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality_tab,
        ___HSDSCH_MACdFlows_Information_iE_Extensions__item__criticality,
        ____HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_MACdFlows_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlows_Information_iE_Extensions__item_,
        _HSDSCH_MACdFlows_Information_iE_Extensions,
        HSDSCH_MACdFlows_Information,
        HSDSCH_MACdFlows_Information_ExtIEs,
        _HSDSCH_MACdFlows_to_Delete__item_,
        HSDSCH_MACdFlows_to_Delete,
        _HSDSCH_MACdFlows_to_Delete_Item_hsDSCH_MACdFlow_ID,
        ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id_tab,
        ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__id,
        ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality_tab,
        ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__criticality,
        ____HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item__extensionValue,
        __HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions__item_,
        _HSDSCH_MACdFlows_to_Delete_Item_iE_Extensions,
        HSDSCH_MACdFlows_to_Delete_Item,
        HSDSCH_MACdFlows_to_Delete_Item_ExtIEs,
        _HSDSCH_Initial_Capacity_Allocation__item_,
        HSDSCH_Initial_Capacity_Allocation,
        _HSDSCH_Initial_Capacity_AllocationItem_schedulingPriorityIndicator,
        _HSDSCH_Initial_Capacity_AllocationItem_maximum_MACdPDU_Size,
        _HSDSCH_Initial_Capacity_AllocationItem_hSDSCH_InitialWindowSize,
        ____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab,
        _____HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__id,
        ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__criticality,
        ___HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item__extensionValue,
        __HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions__item_,
        _HSDSCH_Initial_Capacity_AllocationItem_iE_Extensions,
        HSDSCH_Initial_Capacity_AllocationItem,
        HSDSCH_Initial_Capacity_AllocationItem_ExtIEs,
        _HSDSCH_Initial_Capacity_AllocationItem_ExtIEs_val_Extension_0,
        HSDSCH_InitialWindowSize,
        _HSDSCH_PreconfigurationInfo_setsOfHS_SCCH_Codes,
        _HSDSCH_PreconfigurationInfo_hARQ_MemoryPartitioning,
        _HSDSCH_PreconfigurationInfo_eDCH_FDD_DL_ControlChannelInformation,
        _HSDSCH_PreconfigurationInfo_hARQ_Preamble_Mode_Activation_Indicator,
        _HSDSCH_PreconfigurationInfo_mIMO_N_M_Ratio,
        _HSDSCH_PreconfigurationInfo_continuous_Packet_Connectivity_HS_SCCH_Less_Information_Response,
        ____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_PreconfigurationInfo_iE_Extensions__item__id_tab_val_Extension_4,
        ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__id,
        ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__criticality,
        ___HSDSCH_PreconfigurationInfo_iE_Extensions__item__extensionValue,
        __HSDSCH_PreconfigurationInfo_iE_Extensions__item_,
        _HSDSCH_PreconfigurationInfo_iE_Extensions,
        HSDSCH_PreconfigurationInfo,
        HSDSCH_PreconfigurationInfo_ExtIEs,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_0,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_1,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_2,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_3,
        _HSDSCH_PreconfigurationInfo_ExtIEs_val_Extension_4,
        _Additional_EDCH_Preconfiguration_Information__item_,
        Additional_EDCH_Preconfiguration_Information,
        _Additional_EDCH_Preconfiguration_Information_ItemIEs_eDCH_FDD_DL_ControlChannelInformation,
        ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Preconfiguration_Information_ItemIEs_iE_Extensions,
        Additional_EDCH_Preconfiguration_Information_ItemIEs,
        Additional_EDCH_Preconfiguration_Information_ItemIEs_ExtIEs,
        _HSDSCH_PreconfigurationSetup_mAChsResetScheme,
        _HSDSCH_PreconfigurationSetup_hSDSCH_Physical_Layer_Category,
        _HSDSCH_PreconfigurationSetup_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_PreconfigurationSetup_secondaryServingCells,
        _HSDSCH_PreconfigurationSetup_numPrimaryHS_SCCH_Codes,
        _HSDSCH_PreconfigurationSetup_hARQ_Preamble_Mode,
        _HSDSCH_PreconfigurationSetup_mIMO_ActivationIndicator,
        _HSDSCH_PreconfigurationSetup_hSDSCH_MACdPDUSizeFormat,
        _HSDSCH_PreconfigurationSetup_sixtyfourQAM_UsageAllowedIndicator,
        _HSDSCH_PreconfigurationSetup_uE_with_enhanced_HS_SCCH_support_indicator,
        _HSDSCH_PreconfigurationSetup_continuous_Packet_Connectivity_HS_SCCH_Less_Information,
        ____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_9,
        _____HSDSCH_PreconfigurationSetup_iE_Extensions__item__id_tab_val_Extension_10,
        ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__id,
        ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__criticality,
        ___HSDSCH_PreconfigurationSetup_iE_Extensions__item__extensionValue,
        __HSDSCH_PreconfigurationSetup_iE_Extensions__item_,
        _HSDSCH_PreconfigurationSetup_iE_Extensions,
        HSDSCH_PreconfigurationSetup,
        HSDSCHPreconfigurationSetup_ExtIEs,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_0,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_1,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_2,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_3,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_4,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_5,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_6,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_7,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_8,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_9,
        _HSDSCHPreconfigurationSetup_ExtIEs_val_Extension_10,
        _HS_SCCH_PreconfiguredCodes__item_,
        HS_SCCH_PreconfiguredCodes,
        _HS_SCCH_PreconfiguredCodesItem_hS_SCCH_CodeNumber,
        ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id_tab,
        ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__id,
        ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality_tab,
        ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__criticality,
        ____HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue_tab,
        ___HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item__extensionValue,
        __HS_SCCH_PreconfiguredCodesItem_iE_Extensions__item_,
        _HS_SCCH_PreconfiguredCodesItem_iE_Extensions,
        HS_SCCH_PreconfiguredCodesItem,
        HS_SCCH_PreconfiguredCodesItem_ExtIEs,
        HS_SCCH_CodeNumber,
        HSDSCH_RNTI,
        _HS_DSCH_serving_cell_change_information_hS_PDSCH_RLID,
        _HS_DSCH_serving_cell_change_information_hSDSCH_FDD_Information,
        ____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab,
        _____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HS_DSCH_serving_cell_change_information_iE_Extensions__item__id_tab_val_Extension_1,
        ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__id,
        ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__criticality,
        ___HS_DSCH_serving_cell_change_information_iE_Extensions__item__extensionValue,
        __HS_DSCH_serving_cell_change_information_iE_Extensions__item_,
        _HS_DSCH_serving_cell_change_information_iE_Extensions,
        HS_DSCH_serving_cell_change_information,
        HS_DSCH_serving_cell_change_information_ExtIEs,
        _HS_DSCH_serving_cell_change_information_ExtIEs_val_Extension_0,
        _HS_DSCH_serving_cell_change_information_ExtIEs_val_Extension_1,
        _HS_DSCH_serving_cell_change_informationResponse_hS_DSCH_serving_cell_choice,
        ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id_tab,
        ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__id,
        ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__criticality,
        ____HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item__extensionValue,
        __HS_DSCH_serving_cell_change_informationResponse_iE_Extensions__item_,
        _HS_DSCH_serving_cell_change_informationResponse_iE_Extensions,
        HS_DSCH_serving_cell_change_informationResponse,
        HS_DSCH_serving_cell_change_informationResponse_ExtIEs,
        _HS_DSCH_serving_cell_change_choice_hS_serving_cell_change_successful,
        _HS_DSCH_serving_cell_change_choice_hS_serving_cell_change_unsuccessful,
        HS_DSCH_serving_cell_change_choice,
        HSDSCH_TBSizeTableIndicator,
        _HS_serving_cell_change_successful_hSDSCH_FDD_Information_Response,
        _HS_serving_cell_change_successful_hSDSCH_RNTI,
        ____HS_serving_cell_change_successful_iE_Extensions__item__id_tab,
        _____HS_serving_cell_change_successful_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_serving_cell_change_successful_iE_Extensions__item__id,
        ___HS_serving_cell_change_successful_iE_Extensions__item__criticality,
        ___HS_serving_cell_change_successful_iE_Extensions__item__extensionValue,
        __HS_serving_cell_change_successful_iE_Extensions__item_,
        _HS_serving_cell_change_successful_iE_Extensions,
        HS_serving_cell_change_successful,
        HS_serving_cell_change_successful_ExtIEs,
        _HS_serving_cell_change_successful_ExtIEs_val_Extension_0,
        _HS_serving_cell_change_unsuccessful_cause,
        ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__id_tab,
        ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__id,
        ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality_tab,
        ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__criticality,
        ____HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue_tab,
        ___HS_serving_cell_change_unsuccessful_iE_Extensions__item__extensionValue,
        __HS_serving_cell_change_unsuccessful_iE_Extensions__item_,
        _HS_serving_cell_change_unsuccessful_iE_Extensions,
        HS_serving_cell_change_unsuccessful,
        HS_serving_cell_change_unsuccessful_ExtIEs,
        HSPDSCH_First_Code_Index,
        HSPDSCH_Second_Code_Index,
        HSPDSCH_Second_Code_Support,
        _HSDSCH_TDD_Information_hSDSCH_MACdFlows_Information,
        _HSDSCH_TDD_Information_uE_Capabilities_Info,
        _HSDSCH_TDD_Information_mAChs_Reordering_Buffer_Size_for_RLC_UM,
        _HSDSCH_TDD_Information_tDD_AckNack_Power_Offset,
        ____HSDSCH_TDD_Information_iE_Extensions__item__id_tab,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_TDD_Information_iE_Extensions__item__id_tab_val_Extension_4,
        ___HSDSCH_TDD_Information_iE_Extensions__item__id,
        ___HSDSCH_TDD_Information_iE_Extensions__item__criticality,
        ___HSDSCH_TDD_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_TDD_Information_iE_Extensions__item_,
        _HSDSCH_TDD_Information_iE_Extensions,
        HSDSCH_TDD_Information,
        HSDSCH_TDD_Information_ExtIEs,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_0,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_1,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_2,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_3,
        _HSDSCH_TDD_Information_ExtIEs_val_Extension_4,
        _HSDSCH_TDD_Information_Response_hSDSCH_MACdFlow_Specific_InfoList_Response,
        _HSDSCH_TDD_Information_Response_hSSCCH_TDD_Specific_InfoList_Response,
        _HSDSCH_TDD_Information_Response_hSSCCH_TDD_Specific_InfoList_Response_LCR,
        _HSDSCH_TDD_Information_Response_hSPDSCH_TDD_Specific_InfoList_Response,
        _HSDSCH_TDD_Information_Response_hSPDSCH_TDD_Specific_InfoList_Response_LCR,
        _HSDSCH_TDD_Information_Response_hARQ_MemoryPartitioning,
        ____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_3,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_4,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_5,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_6,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_7,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_8,
        _____HSDSCH_TDD_Information_Response_iE_Extensions__item__id_tab_val_Extension_9,
        ___HSDSCH_TDD_Information_Response_iE_Extensions__item__id,
        ___HSDSCH_TDD_Information_Response_iE_Extensions__item__criticality,
        ___HSDSCH_TDD_Information_Response_iE_Extensions__item__extensionValue,
        __HSDSCH_TDD_Information_Response_iE_Extensions__item_,
        _HSDSCH_TDD_Information_Response_iE_Extensions,
        HSDSCH_TDD_Information_Response,
        HSDSCH_TDD_Information_Response_ExtIEs,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_0,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_1,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_2,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_3,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_4,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_5,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_6,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_7,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_8,
        _HSDSCH_TDD_Information_Response_ExtIEs_val_Extension_9,
        Multicarrier_Number,
        _HSPDSCH_TDD_Specific_InfoList_Response__item_,
        HSPDSCH_TDD_Specific_InfoList_Response,
        _HSPDSCH_TDD_Specific_InfoItem_Response_timeslot,
        _HSPDSCH_TDD_Specific_InfoItem_Response_midambleShiftAndBurstType,
        ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id,
        ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality,
        ____HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue,
        __HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_,
        _HSPDSCH_TDD_Specific_InfoItem_Response_iE_Extensions,
        HSPDSCH_TDD_Specific_InfoItem_Response,
        HSPDSCH_TDD_Specific_InfoItem_Response_ExtIEs,
        _HSPDSCH_TDD_Specific_InfoList_Response_LCR__item_,
        HSPDSCH_TDD_Specific_InfoList_Response_LCR,
        _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_timeslotLCR,
        _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_midambleShiftLCR,
        ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id,
        ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality,
        ____HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue,
        __HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_,
        _HSPDSCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions,
        HSPDSCH_TDD_Specific_InfoItem_Response_LCR,
        HSPDSCH_TDD_Specific_InfoItem_Response_LCR_ExtIEs,
        _HSPDSCH_TDD_Specific_InfoList_Response768__item_,
        HSPDSCH_TDD_Specific_InfoList_Response768,
        _HSPDSCH_TDD_Specific_InfoItem_Response768_timeslot,
        _HSPDSCH_TDD_Specific_InfoItem_Response768_midambleShiftAndBurstType768,
        ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id,
        ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality,
        ____HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab,
        ___HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue,
        __HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_,
        _HSPDSCH_TDD_Specific_InfoItem_Response768_iE_Extensions,
        HSPDSCH_TDD_Specific_InfoItem_Response768,
        HSPDSCH_TDD_Specific_InfoItem_Response_768_ExtIEs,
        _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_LCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_LCR_hS_SCCH_UE_DRX_Offset_LCR,
        ____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab,
        _____HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__id,
        ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__criticality,
        ___HS_SCCH_DRX_Information_LCR_iE_Extensions__item__extensionValue,
        __HS_SCCH_DRX_Information_LCR_iE_Extensions__item_,
        _HS_SCCH_DRX_Information_LCR_iE_Extensions,
        HS_SCCH_DRX_Information_LCR,
        HS_SCCH_DRX_Information_LCR_ExtIEs,
        _HS_SCCH_DRX_Information_LCR_ExtIEs_val_Extension_0,
        _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_Inactivity_Threshold_for_UE_DRX_Cycle_LCR,
        _HS_SCCH_DRX_Information_ResponseLCR_hS_SCCH_UE_DRX_Offset_LCR,
        ____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab,
        _____HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__id,
        ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__criticality,
        ___HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions__item_,
        _HS_SCCH_DRX_Information_ResponseLCR_iE_Extensions,
        HS_SCCH_DRX_Information_ResponseLCR,
        HS_SCCH_DRX_Information_ResponseLCR_ExtIEs,
        _HS_SCCH_DRX_Information_ResponseLCR_ExtIEs_val_Extension_0,
        _HSSCCH_FDD_Specific_InfoList_Response__item_,
        HSSCCH_FDD_Specific_InfoList_Response,
        _HSSCCH_FDD_Specific_InfoItem_Response_code_Number,
        ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab,
        ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__id,
        ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab,
        ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__criticality,
        ____HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue,
        __HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions__item_,
        _HSSCCH_FDD_Specific_InfoItem_Response_iE_Extensions,
        HSSCCH_FDD_Specific_InfoItem_Response,
        HSSCCH_FDD_Specific_InfoItem_Response_ExtIEs,
        HSSCCH_PowerOffset,
        _HSSCCH_TDD_Specific_InfoList_Response__item_,
        HSSCCH_TDD_Specific_InfoList_Response,
        _HSSCCH_TDD_Specific_InfoItem_Response_timeslot,
        _HSSCCH_TDD_Specific_InfoItem_Response_midambleShiftAndBurstType,
        _HSSCCH_TDD_Specific_InfoItem_Response_tDD_ChannelisationCode,
        _HSSCCH_TDD_Specific_InfoItem_Response_hSSICH_Info,
        ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__id,
        ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__criticality,
        ____HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item__extensionValue,
        __HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions__item_,
        _HSSCCH_TDD_Specific_InfoItem_Response_iE_Extensions,
        HSSCCH_TDD_Specific_InfoItem_Response,
        HSSCCH_TDD_Specific_InfoItem_Response_ExtIEs,
        _HSSCCH_TDD_Specific_InfoList_Response_LCR__item_,
        HSSCCH_TDD_Specific_InfoList_Response_LCR,
        _HSSCCH_TDD_Specific_InfoItem_Response_LCR_timeslotLCR,
        _HSSCCH_TDD_Specific_InfoItem_Response_LCR_midambleShiftLCR,
        _HSSCCH_TDD_Specific_InfoItem_Response_LCR_first_TDD_ChannelisationCode,
        _HSSCCH_TDD_Specific_InfoItem_Response_LCR_second_TDD_ChannelisationCode,
        _HSSCCH_TDD_Specific_InfoItem_Response_LCR_hSSICH_InfoLCR,
        ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__id,
        ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__criticality,
        ____HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item__extensionValue,
        __HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions__item_,
        _HSSCCH_TDD_Specific_InfoItem_Response_LCR_iE_Extensions,
        HSSCCH_TDD_Specific_InfoItem_Response_LCR,
        HSSCCH_TDD_Specific_InfoItem_Response_LCR_ExtIEs,
        _HSSCCH_TDD_Specific_InfoList_Response768__item_,
        HSSCCH_TDD_Specific_InfoList_Response768,
        _HSSCCH_TDD_Specific_InfoItem_Response768_timeslot,
        _HSSCCH_TDD_Specific_InfoItem_Response768_midambleShiftAndBurstType768,
        _HSSCCH_TDD_Specific_InfoItem_Response768_tDD_ChannelisationCode768,
        _HSSCCH_TDD_Specific_InfoItem_Response768_hSSICH_Info768,
        ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__id,
        ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__criticality,
        ____HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue_tab,
        ___HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item__extensionValue,
        __HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions__item_,
        _HSSCCH_TDD_Specific_InfoItem_Response768_iE_Extensions,
        HSSCCH_TDD_Specific_InfoItem_Response768,
        HSSCCH_TDD_Specific_InfoItem_Response768_ExtIEs,
        _HSSICH_Info_hsSICH_ID,
        _HSSICH_Info_timeslot,
        _HSSICH_Info_midambleShiftAndBurstType,
        _HSSICH_Info_tDD_ChannelisationCode,
        ____HSSICH_Info_iE_Extensions__item__id_tab,
        ___HSSICH_Info_iE_Extensions__item__id,
        ____HSSICH_Info_iE_Extensions__item__criticality_tab,
        ___HSSICH_Info_iE_Extensions__item__criticality,
        ____HSSICH_Info_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_Info_iE_Extensions__item__extensionValue,
        __HSSICH_Info_iE_Extensions__item_,
        _HSSICH_Info_iE_Extensions,
        HSSICH_Info,
        HSSICH_Info_ExtIEs,
        _HSSICH_InfoLCR_hsSICH_ID,
        _HSSICH_InfoLCR_timeslotLCR,
        _HSSICH_InfoLCR_midambleShiftLCR,
        _HSSICH_InfoLCR_tDD_ChannelisationCode,
        ____HSSICH_InfoLCR_iE_Extensions__item__id_tab,
        _____HSSICH_InfoLCR_iE_Extensions__item__id_tab_val_Extension_0,
        ___HSSICH_InfoLCR_iE_Extensions__item__id,
        ___HSSICH_InfoLCR_iE_Extensions__item__criticality,
        ___HSSICH_InfoLCR_iE_Extensions__item__extensionValue,
        __HSSICH_InfoLCR_iE_Extensions__item_,
        _HSSICH_InfoLCR_iE_Extensions,
        HSSICH_InfoLCR,
        HSSICH_Info_LCR_ExtIEs,
        _HSSICH_Info_LCR_ExtIEs_val_Extension_0,
        _HSSICH_Info768_hsSICH_ID,
        _HSSICH_Info768_timeslot,
        _HSSICH_Info768_midambleShiftAndBurstType768,
        _HSSICH_Info768_tDD_ChannelisationCode768,
        ____HSSICH_Info768_iE_Extensions__item__id_tab,
        ___HSSICH_Info768_iE_Extensions__item__id,
        ____HSSICH_Info768_iE_Extensions__item__criticality_tab,
        ___HSSICH_Info768_iE_Extensions__item__criticality,
        ____HSSICH_Info768_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_Info768_iE_Extensions__item__extensionValue,
        __HSSICH_Info768_iE_Extensions__item_,
        _HSSICH_Info768_iE_Extensions,
        HSSICH_Info768,
        HSSICH_Info_768_ExtIEs,
        _HS_SICH_Reception_Quality_Value_failed_HS_SICH,
        _HS_SICH_Reception_Quality_Value_missed_HS_SICH,
        _HS_SICH_Reception_Quality_Value_total_HS_SICH,
        ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__id_tab,
        ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__id,
        ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality_tab,
        ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__criticality,
        ____HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_Reception_Quality_Value_iE_Extensions__item__extensionValue,
        __HS_SICH_Reception_Quality_Value_iE_Extensions__item_,
        _HS_SICH_Reception_Quality_Value_iE_Extensions,
        HS_SICH_Reception_Quality_Value,
        HS_SICH_Reception_Quality_Value_ExtIEs,
        HS_SICH_failed,
        HS_SICH_missed,
        HS_SICH_total,
        HS_SICH_Reception_Quality_Measurement_Value,
        HS_SICH_ID,
        HS_SICH_ID_Extension,
        HSSCCH_CodeChangeIndicator,
        HSSCCH_Code_Change_Grant,
        HS_PDSCH_Code_Change_Indicator,
        HS_PDSCH_Code_Change_Grant,
        _HSDSCH_FDD_Update_Information_hsSCCHCodeChangeIndicator,
        _HSDSCH_FDD_Update_Information_cqiFeedback_CycleK,
        _HSDSCH_FDD_Update_Information_cqiRepetitionFactor,
        _HSDSCH_FDD_Update_Information_ackNackRepetitionFactor,
        _HSDSCH_FDD_Update_Information_cqiPowerOffset,
        _HSDSCH_FDD_Update_Information_ackPowerOffset,
        _HSDSCH_FDD_Update_Information_nackPowerOffset,
        ____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_1,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_2,
        _____HSDSCH_FDD_Update_Information_iE_Extensions__item__id_tab_val_Extension_3,
        ___HSDSCH_FDD_Update_Information_iE_Extensions__item__id,
        ___HSDSCH_FDD_Update_Information_iE_Extensions__item__criticality,
        ___HSDSCH_FDD_Update_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_FDD_Update_Information_iE_Extensions__item_,
        _HSDSCH_FDD_Update_Information_iE_Extensions,
        HSDSCH_FDD_Update_Information,
        HSDSCH_FDD_Update_Information_ExtIEs,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_0,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_1,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_2,
        _HSDSCH_FDD_Update_Information_ExtIEs_val_Extension_3,
        _HSDSCH_TDD_Update_Information_hsSCCHCodeChangeIndicator,
        _HSDSCH_TDD_Update_Information_tDDAckNackPowerOffset,
        ____HSDSCH_TDD_Update_Information_iE_Extensions__item__id_tab,
        ___HSDSCH_TDD_Update_Information_iE_Extensions__item__id,
        ____HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality_tab,
        ___HSDSCH_TDD_Update_Information_iE_Extensions__item__criticality,
        ____HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue_tab,
        ___HSDSCH_TDD_Update_Information_iE_Extensions__item__extensionValue,
        __HSDSCH_TDD_Update_Information_iE_Extensions__item_,
        _HSDSCH_TDD_Update_Information_iE_Extensions,
        HSDSCH_TDD_Update_Information,
        HSDSCH_TDD_Update_Information_ExtIEs,
        _MIMO_ReferenceSignal_InformationListLCR__item_,
        MIMO_ReferenceSignal_InformationListLCR,
        _HSSICH_ReferenceSignal_InformationLCR_midambleConfigurationLCR,
        _HSSICH_ReferenceSignal_InformationLCR_midambleShift,
        _HSSICH_ReferenceSignal_InformationLCR_timeSlotLCR,
        ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id_tab,
        ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__id,
        ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality_tab,
        ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__criticality,
        ____HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item__extensionValue,
        __HSSICH_ReferenceSignal_InformationLCR_iE_Extensions__item_,
        _HSSICH_ReferenceSignal_InformationLCR_iE_Extensions,
        HSSICH_ReferenceSignal_InformationLCR,
        HSSICH_ReferenceSignal_InformationLCR_ExtIEs,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_transport_Block_Size_List,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_repetition_Period_List_LCR,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Reservation_Indicator,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_hS_DSCH_SPS_Operation_Indicator,
        ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__id,
        ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__criticality,
        ____HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item__extensionValue,
        __HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions__item_,
        _HS_DSCH_Semi_PersistentScheduling_Information_LCR_iE_Extensions,
        HS_DSCH_Semi_PersistentScheduling_Information_LCR,
        HS_DSCH_Semi_PersistentScheduling_Information_LCR_ExtIEs,
        HSDSCH_Physical_Layer_Category,
        _Transport_Block_Size_List_LCR__item_,
        Transport_Block_Size_List_LCR,
        _Transport_Block_Size_Item_LCR_transport_Block_Size_maping_Index_LCR,
        _Transport_Block_Size_Item_LCR_transport_Block_Size_Index_LCR,
        ____Transport_Block_Size_Item_LCR_iE_Extensions__item__id_tab,
        ___Transport_Block_Size_Item_LCR_iE_Extensions__item__id,
        ____Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality_tab,
        ___Transport_Block_Size_Item_LCR_iE_Extensions__item__criticality,
        ____Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue_tab,
        ___Transport_Block_Size_Item_LCR_iE_Extensions__item__extensionValue,
        __Transport_Block_Size_Item_LCR_iE_Extensions__item_,
        _Transport_Block_Size_Item_LCR_iE_Extensions,
        Transport_Block_Size_Item_LCR,
        Transport_Block_Size_Item_LCR_ExtIEs,
        Transport_Block_Size_maping_Index_LCR,
        Transport_Block_Size_Index_LCR,
        TS0_HS_PDSCH_Indication_LCR,
        _Repetition_Period_List_LCR__item_,
        Repetition_Period_List_LCR,
        _Repetition_Period_Item_LCR_repetitionPeriodIndex,
        _Repetition_Period_Item_LCR_repetitionPeriod,
        _Repetition_Period_Item_LCR_repetitionLength,
        ____Repetition_Period_Item_LCR_iE_Extensions__item__id_tab,
        ___Repetition_Period_Item_LCR_iE_Extensions__item__id,
        ____Repetition_Period_Item_LCR_iE_Extensions__item__criticality_tab,
        ___Repetition_Period_Item_LCR_iE_Extensions__item__criticality,
        ____Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue_tab,
        ___Repetition_Period_Item_LCR_iE_Extensions__item__extensionValue,
        __Repetition_Period_Item_LCR_iE_Extensions__item_,
        _Repetition_Period_Item_LCR_iE_Extensions,
        Repetition_Period_Item_LCR,
        Repetition_Period_Item_LCR_ExtIEs,
        RepetitionPeriodIndex,
        SPS_Reservation_Indicator,
        _HS_DSCH_SPS_Operation_Indicator_logicalChannellevel,
        _HS_DSCH_SPS_Operation_Indicator_priorityQueuelevel,
        HS_DSCH_SPS_Operation_Indicator,
        LogicalChannellevel,
        PriorityQueuelevel,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_transport_Block_Size_List,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_repetition_Period_List_LCR,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_hS_DSCH_SPS_Reservation_Indicator,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_hS_DSCH_SPS_Operation_Indicator,
        ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__id,
        ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__criticality,
        ____HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item__extensionValue,
        __HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions__item_,
        _HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_iE_Extensions,
        HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR,
        HS_DSCH_Semi_PersistentScheduling_Information_to_Modify_LCR_ExtIEs,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_hS_SICH_InformationList_for_HS_DSCH_SPS,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_initial_HS_PDSCH_SPS_Resource,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_buffer_Size_for_HS_DSCH_SPS,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_number_of_Processes_for_HS_DSCH_SPS,
        ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__id,
        ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__criticality,
        ____HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue_tab,
        ___HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item__extensionValue,
        __HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions__item_,
        _HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_iE_Extensions,
        HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR,
        HS_DSCH_Semi_PersistentScheduling_Information_ResponseLCR_ExtIEs,
        _HS_SICH_InformationList_for_HS_DSCH_SPS__item_,
        HS_SICH_InformationList_for_HS_DSCH_SPS,
        _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Mapping_Index,
        _HS_SICH_InformationItem_for_HS_DSCH_SPS_hS_SICH_Type,
        ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id_tab,
        ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__id,
        ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality_tab,
        ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__criticality,
        ____HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue_tab,
        ___HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item__extensionValue,
        __HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions__item_,
        _HS_SICH_InformationItem_for_HS_DSCH_SPS_iE_Extensions,
        HS_SICH_InformationItem_for_HS_DSCH_SPS,
        HS_SICH_InformationItem_for_HS_DSCH_SPS_ExtIEs,
        HS_SICH_Mapping_Index,
        _HS_SICH_Type_hS_SCCH_Associated_HS_SICH,
        _HS_SICH_Type_non_HS_SCCH_Associated_HS_SICH,
        HS_SICH_Type,
        _HS_SCCH_Associated_HS_SICH_hsSICH_ID,
        _HS_SCCH_Associated_HS_SICH_extended_HS_SICH_ID,
        HS_SCCH_Associated_HS_SICH,
        _Non_HS_SCCH_Associated_HS_SICH_non_HS_SCCH_Aassociated_HS_SICH_ID,
        Non_HS_SCCH_Associated_HS_SICH,
        Non_HS_SCCH_Aassociated_HS_SICH_ID,
        _Initial_HS_PDSCH_SPS_Resource_repetitionPeriodIndex,
        _Initial_HS_PDSCH_SPS_Resource_repetitionLength,
        _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Offset,
        _Initial_HS_PDSCH_SPS_Resource_hS_PDSCH_Midamble_Configuation,
        _Initial_HS_PDSCH_SPS_Resource_timeslot_Resource_Related_Information,
        _Initial_HS_PDSCH_SPS_Resource_startCode,
        _Initial_HS_PDSCH_SPS_Resource_endCode,
        _Initial_HS_PDSCH_SPS_Resource_transport_Block_Size_Index,
        _Initial_HS_PDSCH_SPS_Resource_modulationType,
        _Initial_HS_PDSCH_SPS_Resource_hS_SICH_Mapping_Index,
        ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id_tab,
        ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__id,
        ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality_tab,
        ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__criticality,
        ____Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue_tab,
        ___Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item__extensionValue,
        __Initial_HS_PDSCH_SPS_Resource_iE_Extensions__item_,
        _Initial_HS_PDSCH_SPS_Resource_iE_Extensions,
        Initial_HS_PDSCH_SPS_Resource,
        Initial_HS_PDSCH_SPS_Resource_ExtIEs,
        HS_DSCH_TimeslotResourceLCR,
        ModulationSPS_LCR,
        Number_of_Processes_for_HS_DSCH_SPS,
        IMEI,
        IMEISV,
        IMSI,
        Implicit_Grant_Handling,
        Improved_Synchronized_Indicator,
        Inactivity_Threshold_for_UE_DRX_Cycle_LCR,
        Inactivity_Threshold_for_UE_DRX_Cycle_LCR_Ext,
        Inactivity_Threshold_for_UE_DTX_Cycle2,
        Inactivity_Threshold_for_UE_DRX_Cycle,
        Inactivity_Threshold_for_UE_Grant_Monitoring,
        _InformationAvailable_requestedDataValue,
        ____InformationAvailable_iE_Extensions__item__id_tab,
        ___InformationAvailable_iE_Extensions__item__id,
        ____InformationAvailable_iE_Extensions__item__criticality_tab,
        ___InformationAvailable_iE_Extensions__item__criticality,
        ____InformationAvailable_iE_Extensions__item__extensionValue_tab,
        ___InformationAvailable_iE_Extensions__item__extensionValue,
        __InformationAvailable_iE_Extensions__item_,
        _InformationAvailable_iE_Extensions,
        InformationAvailable,
        InformationAvailable_ExtIEs,
        InformationExchangeID,
        InformationNotAvailable,
        _InformationReportCharacteristics_onDemand,
        _InformationReportCharacteristics_periodic,
        _InformationReportCharacteristics_onModification,
        InformationReportCharacteristics,
        _InformationReportPeriodicity_min,
        _InformationReportPeriodicity_hour,
        InformationReportPeriodicity,
        _InformationThreshold_dGPSThreshold,
        _InformationThreshold_dGANSSThreshold,
        InformationThreshold,
        _InformationType_informationTypeItem,
        _InformationType_gPSInformation,
        ____InformationType_iE_Extensions__item__id_tab,
        _____InformationType_iE_Extensions__item__id_tab_val_Extension_0,
        _____InformationType_iE_Extensions__item__id_tab_val_Extension_1,
        _____InformationType_iE_Extensions__item__id_tab_val_Extension_2,
        ___InformationType_iE_Extensions__item__id,
        ___InformationType_iE_Extensions__item__criticality,
        ___InformationType_iE_Extensions__item__extensionValue,
        __InformationType_iE_Extensions__item_,
        _InformationType_iE_Extensions,
        InformationType,
        InformationType_ExtIEs,
        _InformationType_ExtIEs_val_Extension_0,
        _InformationType_ExtIEs_val_Extension_1,
        _InformationType_ExtIEs_val_Extension_2,
        _Initial_E_DCH_SPS_resource_timeslot_Resource_Related_Information,
        _Initial_E_DCH_SPS_resource_powerResource,
        _Initial_E_DCH_SPS_resource_repetitionPeriodIndex,
        _Initial_E_DCH_SPS_resource_repetitionLength,
        _Initial_E_DCH_SPS_resource_subframeNumber,
        _Initial_E_DCH_SPS_resource_tddE_PUCH_Offset,
        _Initial_E_DCH_SPS_resource_tdd_ChannelisationCode,
        _Initial_E_DCH_SPS_resource_n_E_UCCHLCR,
        ____Initial_E_DCH_SPS_resource_iE_Extensions__item__id_tab,
        ___Initial_E_DCH_SPS_resource_iE_Extensions__item__id,
        ____Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality_tab,
        ___Initial_E_DCH_SPS_resource_iE_Extensions__item__criticality,
        ____Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue_tab,
        ___Initial_E_DCH_SPS_resource_iE_Extensions__item__extensionValue,
        __Initial_E_DCH_SPS_resource_iE_Extensions__item_,
        _Initial_E_DCH_SPS_resource_iE_Extensions,
        Initial_E_DCH_SPS_resource,
        Initial_E_DCH_SPS_resource_ExtIEs,
        Initial_DL_DPCH_TimingAdjustment_Allowed,
        InnerLoopDLPCStatus,
        _IPDLParameters_iPDL_FDD_Parameters,
        _IPDLParameters_iPDL_TDD_Parameters,
        _IPDLParameters_extension_IPDLParameters,
        IPDLParameters,
        __Extension_IPDLParameters_id_tab,
        ___Extension_IPDLParameters_id_tab_val_Value_0,
        _Extension_IPDLParameters_id,
        _Extension_IPDLParameters_criticality,
        _Extension_IPDLParameters_value,
        Extension_IPDLParameters,
        Extension_IPDLParametersIE,
        _Extension_IPDLParametersIE_val_Value_0,
        _Inter_Frequency_Cell_List__item_,
        Inter_Frequency_Cell_List,
        _Inter_Frequency_Cell_dL_UARFCN,
        _Inter_Frequency_Cell_uL_UARFCN,
        _Inter_Frequency_Cell_primaryScramblingCode,
        ____Inter_Frequency_Cell_iE_Extensions__item__id_tab,
        ___Inter_Frequency_Cell_iE_Extensions__item__id,
        ____Inter_Frequency_Cell_iE_Extensions__item__criticality_tab,
        ___Inter_Frequency_Cell_iE_Extensions__item__criticality,
        ____Inter_Frequency_Cell_iE_Extensions__item__extensionValue_tab,
        ___Inter_Frequency_Cell_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cell_iE_Extensions__item_,
        _Inter_Frequency_Cell_iE_Extensions,
        Inter_Frequency_Cell,
        Inter_Frequency_Cell_ExtIEs,
        _Inter_Frequency_Cell_Information_inter_Frequency_Cell_Information_SIB11,
        _Inter_Frequency_Cell_Information_inter_Frequency_Cell_Information_SIB12,
        ____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab,
        _____Inter_Frequency_Cell_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___Inter_Frequency_Cell_Information_iE_Extensions__item__id,
        ___Inter_Frequency_Cell_Information_iE_Extensions__item__criticality,
        ___Inter_Frequency_Cell_Information_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cell_Information_iE_Extensions__item_,
        _Inter_Frequency_Cell_Information_iE_Extensions,
        Inter_Frequency_Cell_Information,
        Inter_Frequency_Cell_Information_ExtIEs,
        _Inter_Frequency_Cell_Information_ExtIEs_val_Extension_0,
        _Inter_Frequency_Cell_Information_SIB11__item_,
        Inter_Frequency_Cell_Information_SIB11,
        _Inter_Frequency_Cell_Information_SIB12__item_,
        Inter_Frequency_Cell_Information_SIB12,
        _Inter_Frequency_Cell_Information_SIB11ter__item_,
        Inter_Frequency_Cell_Information_SIB11ter,
        _Inter_Frequency_Cells_Information_SIB11_Per_Indication_inter_Frequency_Cell_Indication_SIB11,
        _Inter_Frequency_Cells_Information_SIB11_Per_Indication_inter_Frequency_Cell_List_SIB11,
        ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id_tab,
        ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__id,
        ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality_tab,
        ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__criticality,
        ____Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue_tab,
        ___Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions__item_,
        _Inter_Frequency_Cells_Information_SIB11_Per_Indication_iE_Extensions,
        Inter_Frequency_Cells_Information_SIB11_Per_Indication,
        Inter_Frequency_Cells_Information_SIB11_Per_Indication_ExtIEs,
        _Inter_Frequency_Cells_Information_SIB12_Per_Indication_inter_Frequency_Cell_Indication_SIB12,
        _Inter_Frequency_Cells_Information_SIB12_Per_Indication_inter_Frequency_Cell_List_SIB12,
        ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id_tab,
        ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__id,
        ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality_tab,
        ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__criticality,
        ____Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue_tab,
        ___Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions__item_,
        _Inter_Frequency_Cells_Information_SIB12_Per_Indication_iE_Extensions,
        Inter_Frequency_Cells_Information_SIB12_Per_Indication,
        Inter_Frequency_Cells_Information_SIB12_Per_Indication_ExtIEs,
        _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_inter_Frequency_Cell_Indication_SIB11ter,
        _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_inter_Frequency_Cell_List_SIB11ter,
        ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id_tab,
        ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__id,
        ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality_tab,
        ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__criticality,
        ____Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue_tab,
        ___Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions__item_,
        _Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_iE_Extensions,
        Inter_Frequency_Cells_Information_SIB11ter_Per_Indication,
        _Inter_Frequency_Cell_SIB11ter_List__item_,
        Inter_Frequency_Cell_SIB11ter_List,
        Inter_Frequency_Cells_Information_SIB11ter_Per_Indication_ExtIEs,
        _Inter_Frequency_Cell_SIB11ter_interFrequencyCellID,
        _Inter_Frequency_Cell_SIB11ter_dL_UARFCN,
        _Inter_Frequency_Cell_SIB11ter_uL_UARFCN,
        _Inter_Frequency_Cell_SIB11ter_primaryScramblingCode,
        ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id_tab,
        ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__id,
        ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality_tab,
        ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__criticality,
        ____Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue_tab,
        ___Inter_Frequency_Cell_SIB11ter_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cell_SIB11ter_iE_Extensions__item_,
        _Inter_Frequency_Cell_SIB11ter_iE_Extensions,
        Inter_Frequency_Cell_SIB11ter,
        InterFrequencyCellID_Ext,
        Inter_Frequency_Cell_SIB11ter_ExtIEs,
        Inter_Frequency_Cell_Indication,
        _Inter_Frequency_Cell_SIB11_or_SIB12_List__item_,
        Inter_Frequency_Cell_SIB11_or_SIB12_List,
        _Inter_Frequency_Cell_SIB11_or_SIB12_interFrequencyCellID,
        _Inter_Frequency_Cell_SIB11_or_SIB12_dL_UARFCN,
        _Inter_Frequency_Cell_SIB11_or_SIB12_uL_UARFCN,
        _Inter_Frequency_Cell_SIB11_or_SIB12_primaryScramblingCode,
        ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id_tab,
        ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__id,
        ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality_tab,
        ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__criticality,
        ____Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue_tab,
        ___Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item__extensionValue,
        __Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions__item_,
        _Inter_Frequency_Cell_SIB11_or_SIB12_iE_Extensions,
        Inter_Frequency_Cell_SIB11_or_SIB12,
        InterFrequencyCellID,
        InterStream_Interference_Compensation,
        _IPDL_FDD_Parameters_iPSpacingFDD,
        _IPDL_FDD_Parameters_iPLength,
        _IPDL_FDD_Parameters_iPOffset,
        _IPDL_FDD_Parameters_seed,
        _IPDL_FDD_Parameters_burstModeParameters,
        ____IPDL_FDD_Parameters_iE_Extensions__item__id_tab,
        ___IPDL_FDD_Parameters_iE_Extensions__item__id,
        ____IPDL_FDD_Parameters_iE_Extensions__item__criticality_tab,
        ___IPDL_FDD_Parameters_iE_Extensions__item__criticality,
        ____IPDL_FDD_Parameters_iE_Extensions__item__extensionValue_tab,
        ___IPDL_FDD_Parameters_iE_Extensions__item__extensionValue,
        __IPDL_FDD_Parameters_iE_Extensions__item_,
        _IPDL_FDD_Parameters_iE_Extensions,
        IPDL_FDD_Parameters,
        IPDL_FDD_Parameters_ExtIEs,
        _IPDL_TDD_Parameters_iPSpacingTDD,
        _IPDL_TDD_Parameters_iPStart,
        _IPDL_TDD_Parameters_iPSlot,
        _IPDL_TDD_Parameters_iP_P_CCPCH,
        _IPDL_TDD_Parameters_burstModeParameters,
        ____IPDL_TDD_Parameters_iE_Extensions__item__id_tab,
        ___IPDL_TDD_Parameters_iE_Extensions__item__id,
        ____IPDL_TDD_Parameters_iE_Extensions__item__criticality_tab,
        ___IPDL_TDD_Parameters_iE_Extensions__item__criticality,
        ____IPDL_TDD_Parameters_iE_Extensions__item__extensionValue_tab,
        ___IPDL_TDD_Parameters_iE_Extensions__item__extensionValue,
        __IPDL_TDD_Parameters_iE_Extensions__item_,
        _IPDL_TDD_Parameters_iE_Extensions,
        IPDL_TDD_Parameters,
        IPDL_TDD_Parameters_ExtIEs,
        _IPDL_TDD_ParametersLCR_iPSpacingTDD,
        _IPDL_TDD_ParametersLCR_iPStart,
        _IPDL_TDD_ParametersLCR_iPSub,
        _IPDL_TDD_ParametersLCR_burstModeParameters,
        ____IPDL_TDD_ParametersLCR_iE_Extensions__item__id_tab,
        ___IPDL_TDD_ParametersLCR_iE_Extensions__item__id,
        ____IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality_tab,
        ___IPDL_TDD_ParametersLCR_iE_Extensions__item__criticality,
        ____IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue_tab,
        ___IPDL_TDD_ParametersLCR_iE_Extensions__item__extensionValue,
        __IPDL_TDD_ParametersLCR_iE_Extensions__item_,
        _IPDL_TDD_ParametersLCR_iE_Extensions,
        IPDL_TDD_ParametersLCR,
        IPDL_TDD_ParametersLCR_ExtIEs,
        IPLength,
        IPMulticastAddress,
        IPOffset,
        IP_P_CCPCH,
        IPSlot,
        IPSpacingFDD,
        IPSpacingTDD,
        IPStart,
        IPSub,
        _IdleIntervalInformation_idleIntervalInfo_k,
        _IdleIntervalInformation_idleIntervalInfo_offset,
        IdleIntervalInformation,
        _LABased_laiList,
        ____LABased_iE_Extensions__item__id_tab,
        ___LABased_iE_Extensions__item__id,
        ____LABased_iE_Extensions__item__criticality_tab,
        ___LABased_iE_Extensions__item__criticality,
        ____LABased_iE_Extensions__item__extensionValue_tab,
        ___LABased_iE_Extensions__item__extensionValue,
        __LABased_iE_Extensions__item_,
        _LABased_iE_Extensions,
        LABased,
        LABased_ExtIEs,
        _LAI_List__item_,
        LAI_List,
        LAC,
        _LAI_pLMN_Identity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LimitedPowerIncrease,
        _List_Of_PLMNs__item_,
        List_Of_PLMNs,
        L3_Information,
        Load_Value_IncrDecrThres,
        Load_Value,
        _LoadValue_uplinkLoadValue,
        _LoadValue_downlinkLoadValue,
        LoadValue,
        _LCRTDD_Uplink_Physical_Channel_Capability_maxTimeslotsPerSubFrame,
        _LCRTDD_Uplink_Physical_Channel_Capability_maxPhysChPerTimeslot,
        ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id_tab,
        ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__id,
        ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality_tab,
        ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__criticality,
        ____LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue_tab,
        ___LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item__extensionValue,
        __LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions__item_,
        _LCRTDD_Uplink_Physical_Channel_Capability_iE_Extensions,
        LCRTDD_Uplink_Physical_Channel_Capability,
        LCRTDD_Uplink_Physical_Channel_Capability_ExtIEs,
        LogicalChannelID,
        _M1Report_periodic,
        _M1Report_event1F,
        M1Report,
        _M2Report_periodic,
        _M2Report_event1I,
        M2Report,
        MDT_Activation,
        _MDTAreaScope_cellbased,
        _MDTAreaScope_labased,
        _MDTAreaScope_rabased,
        _MDTAreaScope_plmn_area_based,
        MDTAreaScope,
        _MDT_Configuration_mdtActivation,
        _MDT_Configuration_mdtAreaScope,
        _MDT_Configuration_m1report,
        _MDT_Configuration_m2report,
        _MDT_Configuration_m3report,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        ___MDT_Configuration_iE_Extensions__item__id,
        ____MDT_Configuration_iE_Extensions__item__criticality_tab,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ____MDT_Configuration_iE_Extensions__item__extensionValue_tab,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Report_Parameters_reportInterval,
        _MDT_Report_Parameters_reportAmount,
        MDT_Report_Parameters,
        MeasurementQuantity,
        MaxNrOfUL_DPCHs,
        MAC_c_sh_SDU_Length,
        _MAC_c_sh_SDU_LengthList__item_,
        MAC_c_sh_SDU_LengthList,
        MAC_DTX_Cycle_2ms,
        MAC_DTX_Cycle_10ms,
        MAC_ehs_Reset_Timer,
        MAC_Inactivity_Threshold,
        MACdPDU_Size,
        MAC_PDU_SizeExtended,
        _MACdPDU_Size_IndexList__item_,
        MACdPDU_Size_IndexList,
        _MACdPDU_Size_IndexItem_sID,
        _MACdPDU_Size_IndexItem_mACdPDU_Size,
        ____MACdPDU_Size_IndexItem_iE_Extensions__item__id_tab,
        ___MACdPDU_Size_IndexItem_iE_Extensions__item__id,
        ____MACdPDU_Size_IndexItem_iE_Extensions__item__criticality_tab,
        ___MACdPDU_Size_IndexItem_iE_Extensions__item__criticality,
        ____MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue_tab,
        ___MACdPDU_Size_IndexItem_iE_Extensions__item__extensionValue,
        __MACdPDU_Size_IndexItem_iE_Extensions__item_,
        _MACdPDU_Size_IndexItem_iE_Extensions,
        MACdPDU_Size_IndexItem,
        MACdPDU_Size_IndexItem_ExtIEs,
        _MACdPDU_Size_IndexList_to_Modify__item_,
        MACdPDU_Size_IndexList_to_Modify,
        _MACdPDU_Size_IndexItem_to_Modify_sID,
        _MACdPDU_Size_IndexItem_to_Modify_mACdPDU_Size,
        ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id_tab,
        ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__id,
        ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality_tab,
        ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__criticality,
        ____MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue_tab,
        ___MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item__extensionValue,
        __MACdPDU_Size_IndexItem_to_Modify_iE_Extensions__item_,
        _MACdPDU_Size_IndexItem_to_Modify_iE_Extensions,
        MACdPDU_Size_IndexItem_to_Modify,
        MACdPDU_Size_IndexItem_to_Modify_ExtIEs,
        MACes_Guaranteed_Bitrate,
        MACes_Maximum_Bitrate_LCR,
        MACeReset_Indicator,
        MAChsGuaranteedBitRate,
        MAChsReorderingBufferSize_for_RLC_UM,
        MAC_hsWindowSize,
        MAChsResetScheme,
        MaximumAllowedULTxPower,
        Max_Bits_MACe_PDU_non_scheduled,
        MaxNrDLPhysicalchannels,
        MaxNrDLPhysicalchannels768,
        MaxNrDLPhysicalchannelsTS,
        MaxNrDLPhysicalchannelsTS768,
        MaxNr_Retransmissions_EDCH,
        MaxNrTimeslots,
        MaxNrULPhysicalchannels,
        Max_Set_E_DPDCHs,
        Max_UE_DTX_Cycle,
        _MBMS_Bearer_Service_Full_Address_accessPointName,
        _MBMS_Bearer_Service_Full_Address_iPMulticastAddress,
        ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__id,
        ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__criticality,
        ____MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_Service_Full_Address_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_Service_Full_Address_iE_Extensions__item_,
        _MBMS_Bearer_Service_Full_Address_iE_Extensions,
        MBMS_Bearer_Service_Full_Address,
        MBMS_Bearer_Service_Full_Address_ExtIEs,
        _MBMS_Bearer_Service_List__item_,
        MBMS_Bearer_Service_List,
        _MBMS_Bearer_ServiceItemFDD_tmgi,
        _MBMS_Bearer_ServiceItemFDD_transmissionMode,
        ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__id,
        ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__criticality,
        ____MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_ServiceItemFDD_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_ServiceItemFDD_iE_Extensions__item_,
        _MBMS_Bearer_ServiceItemFDD_iE_Extensions,
        MBMS_Bearer_ServiceItemFDD,
        MBMS_Bearer_ServiceItemFDD_ExtIEs,
        _MBMS_Bearer_ServiceItemFDD_PFL_tmgi,
        _MBMS_Bearer_ServiceItemFDD_PFL_transmissionMode,
        _MBMS_Bearer_ServiceItemFDD_PFL_preferredFrequencyLayer,
        ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__id,
        ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__criticality,
        ____MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions__item_,
        _MBMS_Bearer_ServiceItemFDD_PFL_iE_Extensions,
        MBMS_Bearer_ServiceItemFDD_PFL,
        MBMS_Bearer_ServiceItemFDD_PFL_ExtIEs,
        _MBMS_Bearer_ServiceItemTDD_tmgi,
        _MBMS_Bearer_ServiceItemTDD_transmissionMode,
        ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__id,
        ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__criticality,
        ____MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_ServiceItemTDD_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_ServiceItemTDD_iE_Extensions__item_,
        _MBMS_Bearer_ServiceItemTDD_iE_Extensions,
        MBMS_Bearer_ServiceItemTDD,
        MBMS_Bearer_ServiceItemTDD_ExtIEs,
        _MBMS_Bearer_ServiceItemTDD_PFL_tmgi,
        _MBMS_Bearer_ServiceItemTDD_PFL_transmissionMode,
        _MBMS_Bearer_ServiceItemTDD_PFL_preferredFrequencyLayer,
        ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__id,
        ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__criticality,
        ____MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions__item_,
        _MBMS_Bearer_ServiceItemTDD_PFL_iE_Extensions,
        MBMS_Bearer_ServiceItemTDD_PFL,
        MBMS_Bearer_ServiceItemTDD_PFL_ExtIEs,
        _MBMSChannelTypeInfo_tMGI,
        _MBMSChannelTypeInfo_pTM_Cell_List,
        _MBMSChannelTypeInfo_pTP_Cell_List,
        _MBMSChannelTypeInfo_not_Provided_Cell_List,
        ____MBMSChannelTypeInfo_iE_Extensions__item__id_tab,
        ___MBMSChannelTypeInfo_iE_Extensions__item__id,
        ____MBMSChannelTypeInfo_iE_Extensions__item__criticality_tab,
        ___MBMSChannelTypeInfo_iE_Extensions__item__criticality,
        ____MBMSChannelTypeInfo_iE_Extensions__item__extensionValue_tab,
        ___MBMSChannelTypeInfo_iE_Extensions__item__extensionValue,
        __MBMSChannelTypeInfo_iE_Extensions__item_,
        _MBMSChannelTypeInfo_iE_Extensions,
        MBMSChannelTypeInfo,
        MBMSChannelTypeInfo_ExtIEs,
        _MBMSChannelTypeCellList_c_ID,
        _MBMSChannelTypeCellList_affectedUEInformationForMBMS,
        ____MBMSChannelTypeCellList_iE_Extensions__item__id_tab,
        _____MBMSChannelTypeCellList_iE_Extensions__item__id_tab_val_Extension_0,
        ___MBMSChannelTypeCellList_iE_Extensions__item__id,
        ___MBMSChannelTypeCellList_iE_Extensions__item__criticality,
        ___MBMSChannelTypeCellList_iE_Extensions__item__extensionValue,
        __MBMSChannelTypeCellList_iE_Extensions__item_,
        _MBMSChannelTypeCellList_iE_Extensions,
        MBMSChannelTypeCellList,
        MBMSChannelTypeCellList_ExtIEs,
        _MBMSChannelTypeCellList_ExtIEs_val_Extension_0,
        _MBMSPreferredFreqLayerInfo_tMGI,
        _MBMSPreferredFreqLayerInfo_preferredFrequencyLayerInfo,
        ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__id_tab,
        ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__id,
        ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality_tab,
        ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__criticality,
        ____MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue_tab,
        ___MBMSPreferredFreqLayerInfo_iE_Extensions__item__extensionValue,
        __MBMSPreferredFreqLayerInfo_iE_Extensions__item_,
        _MBMSPreferredFreqLayerInfo_iE_Extensions,
        MBMSPreferredFreqLayerInfo,
        MBMSPreferredFreqLayerInfo_ExtIEs,
        _MBMS_Neighbouring_Cell_Information_mBMS_ConcatenatedServiceList,
        _MBMS_Neighbouring_Cell_Information_l3_Information_1,
        _MBMS_Neighbouring_Cell_Information_l3_Information_2,
        ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id_tab,
        ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__id,
        ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality_tab,
        ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__criticality,
        ____MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Neighbouring_Cell_Information_iE_Extensions__item__extensionValue,
        __MBMS_Neighbouring_Cell_Information_iE_Extensions__item_,
        _MBMS_Neighbouring_Cell_Information_iE_Extensions,
        MBMS_Neighbouring_Cell_Information,
        MBMS_Neighbouring_Cell_Information_ExtIEs,
        _MBMS_ConcatenatedServiceList__item_,
        MBMS_ConcatenatedServiceList,
        _MBMS_RLC_Sequence_Number_Information__item_,
        MBMS_RLC_Sequence_Number_Information,
        _MBMS_RLC_Sequence_Number_Information_List_c_ID,
        _MBMS_RLC_Sequence_Number_Information_List_mBMS_Bearer_Service_List_RLC,
        ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id_tab,
        ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__id,
        ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality_tab,
        ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__criticality,
        ____MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue_tab,
        ___MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item__extensionValue,
        __MBMS_RLC_Sequence_Number_Information_List_iE_Extensions__item_,
        _MBMS_RLC_Sequence_Number_Information_List_iE_Extensions,
        MBMS_RLC_Sequence_Number_Information_List,
        MBMS_RLC_Sequence_Number_Information_List_ExtIEs,
        _MBMS_Bearer_Service_List_RLC__item_,
        MBMS_Bearer_Service_List_RLC,
        _MBMS_Bearer_Service_List_RLCinfo_tmgi,
        _MBMS_Bearer_Service_List_RLCinfo_time_Stamp,
        ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__id,
        ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__criticality,
        ____MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_Service_List_RLCinfo_iE_Extensions__item_,
        _MBMS_Bearer_Service_List_RLCinfo_iE_Extensions,
        MBMS_Bearer_Service_List_RLCinfo,
        MBMS_Bearer_Service_List_RLCinfo_ExtIEs,
        MBSFN_Cluster_Identity,
        _MCCH_Message_List__item_,
        MCCH_Message_List,
        _MCCH_Configuration_Info_secondaryCCPCHSystemInformationMBMS,
        ____MCCH_Configuration_Info_ie_Extensions__item__id_tab,
        ___MCCH_Configuration_Info_ie_Extensions__item__id,
        ____MCCH_Configuration_Info_ie_Extensions__item__criticality_tab,
        ___MCCH_Configuration_Info_ie_Extensions__item__criticality,
        ____MCCH_Configuration_Info_ie_Extensions__item__extensionValue_tab,
        ___MCCH_Configuration_Info_ie_Extensions__item__extensionValue,
        __MCCH_Configuration_Info_ie_Extensions__item_,
        _MCCH_Configuration_Info_ie_Extensions,
        MCCH_Configuration_Info,
        MCCH_Configuration_Info_ExtIEs,
        Secondary_CCPCH_System_Information_MBMS,
        _MBSFN_Scheduling_Transmission_Time_Interval_Info_List__item_,
        MBSFN_Scheduling_Transmission_Time_Interval_Info_List,
        _MBSFN_Scheduling_Transmission_Time_Interval_Item_tMGI,
        _MBSFN_Scheduling_Transmission_Time_Interval_Item_mbsfnSchedulingTransmissionTimeInterval,
        ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id_tab,
        ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__id,
        ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality_tab,
        ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__criticality,
        ____MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue_tab,
        ___MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item__extensionValue,
        __MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions__item_,
        _MBSFN_Scheduling_Transmission_Time_Interval_Item_ie_Extensions,
        MBSFN_Scheduling_Transmission_Time_Interval_Item,
        MBSFN_Scheduling_Transmission_Time_Interval_Item_ExtIEs,
        MbsfnSchedulingTransmissionTimeInterval,
        MeasurementFilterCoefficient,
        MeasurementID,
        Measurement_Power_Offset,
        MinimumSpreadingFactor,
        MinimumSpreadingFactor768,
        Minimum_TEBS_threshold,
        MultipleURAsIndicator,
        MaxAdjustmentStep,
        MeasurementChangeTime,
        MeasurementHysteresisTime,
        _MeasurementIncreaseDecreaseThreshold_sir,
        _MeasurementIncreaseDecreaseThreshold_sir_error,
        _MeasurementIncreaseDecreaseThreshold_transmitted_code_power,
        _MeasurementIncreaseDecreaseThreshold_rscp,
        _MeasurementIncreaseDecreaseThreshold_round_trip_time,
        _MeasurementIncreaseDecreaseThreshold_extension_MeasurementIncreaseDecreaseThreshold,
        MeasurementIncreaseDecreaseThreshold,
        __Extension_MeasurementIncreaseDecreaseThreshold_id_tab,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_0,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_1,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_2,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_3,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_4,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_5,
        ___Extension_MeasurementIncreaseDecreaseThreshold_id_tab_val_Value_6,
        _Extension_MeasurementIncreaseDecreaseThreshold_id,
        _Extension_MeasurementIncreaseDecreaseThreshold_criticality,
        _Extension_MeasurementIncreaseDecreaseThreshold_value,
        Extension_MeasurementIncreaseDecreaseThreshold,
        Extension_MeasurementIncreaseDecreaseThresholdIE,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_0,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_1,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_2,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_3,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_4,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_5,
        _Extension_MeasurementIncreaseDecreaseThresholdIE_val_Value_6,
        MeasurementRecoveryBehavior,
        MeasurementRecoveryReportingIndicator,
        MeasurementRecoverySupportIndicator,
        _MeasurementThreshold_sir,
        _MeasurementThreshold_sir_error,
        _MeasurementThreshold_transmitted_code_power,
        _MeasurementThreshold_rscp,
        _MeasurementThreshold_rx_timing_deviation,
        _MeasurementThreshold_round_trip_time,
        _MeasurementThreshold_extension_MeasurementThreshold,
        MeasurementThreshold,
        __MessageStructure__item__iE_ID,
        __MessageStructure__item__repetitionNumber,
        _____MessageStructure__item__iE_Extensions__item__id_tab,
        ____MessageStructure__item__iE_Extensions__item__id,
        _____MessageStructure__item__iE_Extensions__item__criticality_tab,
        ____MessageStructure__item__iE_Extensions__item__criticality,
        _____MessageStructure__item__iE_Extensions__item__extensionValue_tab,
        ____MessageStructure__item__iE_Extensions__item__extensionValue,
        ___MessageStructure__item__iE_Extensions__item_,
        __MessageStructure__item__iE_Extensions,
        _MessageStructure__item_,
        MessageStructure,
        MessageStructure_ExtIEs,
        __Extension_MeasurementThreshold_id_tab,
        ___Extension_MeasurementThreshold_id_tab_val_Value_0,
        ___Extension_MeasurementThreshold_id_tab_val_Value_1,
        ___Extension_MeasurementThreshold_id_tab_val_Value_2,
        ___Extension_MeasurementThreshold_id_tab_val_Value_3,
        ___Extension_MeasurementThreshold_id_tab_val_Value_4,
        ___Extension_MeasurementThreshold_id_tab_val_Value_5,
        ___Extension_MeasurementThreshold_id_tab_val_Value_6,
        ___Extension_MeasurementThreshold_id_tab_val_Value_7,
        ___Extension_MeasurementThreshold_id_tab_val_Value_8,
        ___Extension_MeasurementThreshold_id_tab_val_Value_9,
        ___Extension_MeasurementThreshold_id_tab_val_Value_10,
        ___Extension_MeasurementThreshold_id_tab_val_Value_11,
        ___Extension_MeasurementThreshold_id_tab_val_Value_12,
        ___Extension_MeasurementThreshold_id_tab_val_Value_13,
        ___Extension_MeasurementThreshold_id_tab_val_Value_14,
        ___Extension_MeasurementThreshold_id_tab_val_Value_15,
        _Extension_MeasurementThreshold_id,
        _Extension_MeasurementThreshold_criticality,
        _Extension_MeasurementThreshold_value,
        Extension_MeasurementThreshold,
        Extension_MeasurementThresholdIE,
        _Extension_MeasurementThresholdIE_val_Value_0,
        _Extension_MeasurementThresholdIE_val_Value_1,
        _Extension_MeasurementThresholdIE_val_Value_2,
        _Extension_MeasurementThresholdIE_val_Value_3,
        _Extension_MeasurementThresholdIE_val_Value_4,
        _Extension_MeasurementThresholdIE_val_Value_5,
        _Extension_MeasurementThresholdIE_val_Value_6,
        _Extension_MeasurementThresholdIE_val_Value_7,
        _Extension_MeasurementThresholdIE_val_Value_8,
        _Extension_MeasurementThresholdIE_val_Value_9,
        _Extension_MeasurementThresholdIE_val_Value_10,
        _Extension_MeasurementThresholdIE_val_Value_11,
        _Extension_MeasurementThresholdIE_val_Value_12,
        _Extension_MeasurementThresholdIE_val_Value_13,
        _Extension_MeasurementThresholdIE_val_Value_14,
        _Extension_MeasurementThresholdIE_val_Value_15,
        MidambleConfigurationBurstType1And3,
        MidambleConfigurationBurstType2,
        MidambleConfigurationLCR,
        __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type1_midambleAllocationMode,
        _MidambleShiftAndBurstType_type1,
        __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type2_midambleAllocationMode,
        _MidambleShiftAndBurstType_type2,
        __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type3_midambleAllocationMode,
        _MidambleShiftAndBurstType_type3,
        MidambleShiftAndBurstType,
        MidambleShiftLong,
        MidambleShiftShort,
        _MidambleShiftLCR_midambleAllocationMode,
        _MidambleShiftLCR_midambleShift,
        _MidambleShiftLCR_midambleConfigurationLCR,
        ____MidambleShiftLCR_iE_Extensions__item__id_tab,
        ___MidambleShiftLCR_iE_Extensions__item__id,
        ____MidambleShiftLCR_iE_Extensions__item__criticality_tab,
        ___MidambleShiftLCR_iE_Extensions__item__criticality,
        ____MidambleShiftLCR_iE_Extensions__item__extensionValue_tab,
        ___MidambleShiftLCR_iE_Extensions__item__extensionValue,
        __MidambleShiftLCR_iE_Extensions__item_,
        _MidambleShiftLCR_iE_Extensions,
        MidambleShiftLCR,
        MidambleAllocationMode,
        MidambleShiftLCR_ExtIEs,
        __MidambleShiftAndBurstType768_type1_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType768_type1_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType768_type1_midambleAllocationMode,
        _MidambleShiftAndBurstType768_type1,
        __MidambleShiftAndBurstType768_type2_midambleConfigurationBurstType2_768,
        ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType768_type2_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType768_type2_midambleAllocationMode,
        _MidambleShiftAndBurstType768_type2,
        __MidambleShiftAndBurstType768_type3_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType768_type3_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType768_type3_midambleAllocationMode,
        _MidambleShiftAndBurstType768_type3,
        MidambleShiftAndBurstType768,
        MidambleConfigurationBurstType2_768,
        MidambleShiftShort768,
        MIMO_ActivationIndicator,
        _MIMO_InformationResponse_mIMO_PilotConfiguration,
        _MIMO_InformationResponse_mIMO_N_M_Ratio,
        ____MIMO_InformationResponse_iE_Extensions__item__id_tab,
        _____MIMO_InformationResponse_iE_Extensions__item__id_tab_val_Extension_0,
        ___MIMO_InformationResponse_iE_Extensions__item__id,
        ___MIMO_InformationResponse_iE_Extensions__item__criticality,
        ___MIMO_InformationResponse_iE_Extensions__item__extensionValue,
        __MIMO_InformationResponse_iE_Extensions__item_,
        _MIMO_InformationResponse_iE_Extensions,
        MIMO_InformationResponse,
        MIMO_InformationResponse_ExtIEs,
        _MIMO_InformationResponse_ExtIEs_val_Extension_0,
        MIMO_Mode_Indicator,
        MIMO_N_M_Ratio,
        _MIMO_PilotConfiguration_primary_and_secondary_CPICH,
        _MIMO_PilotConfiguration_normal_and_diversity_primary_CPICH,
        MIMO_PilotConfiguration,
        MIMO_S_CPICH_Channelisation_Code,
        MIMO_withfourtransmitantennas_ActivationIndicator,
        MIMO_withfourtransmitantennas_ModeIndicator,
        DualStream_MIMO_withfourtransmitantennas_ActivationIndicator,
        DualStream_MIMO_withfourtransmitantennas_ModeIndicator,
        _Additional_Associated_Secondary_CPICH__item_,
        Additional_Associated_Secondary_CPICH,
        _Additional_Secondary_CPICH_additional_secondary_CPICH,
        _Additional_Secondary_CPICH_additional_D_CPICH,
        ____Additional_Secondary_CPICH_iE_Extensions__item__id_tab,
        ___Additional_Secondary_CPICH_iE_Extensions__item__id,
        ____Additional_Secondary_CPICH_iE_Extensions__item__criticality_tab,
        ___Additional_Secondary_CPICH_iE_Extensions__item__criticality,
        ____Additional_Secondary_CPICH_iE_Extensions__item__extensionValue_tab,
        ___Additional_Secondary_CPICH_iE_Extensions__item__extensionValue,
        __Additional_Secondary_CPICH_iE_Extensions__item_,
        _Additional_Secondary_CPICH_iE_Extensions,
        Additional_Secondary_CPICH,
        Additional_Secondary_CPICH_Item_ExtIEs,
        MinUL_ChannelisationCodeLength,
        MinimumReducedE_DPDCH_GainFactor,
        _ModifyPriorityQueue_addPriorityQueue,
        _ModifyPriorityQueue_modifyPriorityQueue,
        _ModifyPriorityQueue_deletePriorityQueue,
        ModifyPriorityQueue,
        Modulation,
        Multi_Carrier_E_DCH_LCRTDD_PhysicalLayerCategory,
        Multicell_EDCH_Transport_Bearer_Mode,
        __MulticellEDCH_Information_id_tab,
        ___MulticellEDCH_Information_id_tab_val_Value_0,
        _MulticellEDCH_Information_id,
        _MulticellEDCH_Information_criticality,
        _MulticellEDCH_Information_value,
        MulticellEDCH_Information,
        MulticellEDCH_InformationItem,
        _MulticellEDCH_InformationItem_val_Value_0,
        _MulticellEDCH_InformationItemIEs_dL_PowerBalancing_Information,
        _MulticellEDCH_InformationItemIEs_minimumReducedE_DPDCH_GainFactor,
        _MulticellEDCH_InformationItemIEs_secondary_UL_Frequency_Activation_State,
        _MulticellEDCH_InformationItemIEs_f_DPCH_SlotFormat,
        _MulticellEDCH_InformationItemIEs_common_DL_ReferencePowerInformation,
        ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__id_tab,
        ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__id,
        ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality_tab,
        ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__criticality,
        ____MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue_tab,
        ___MulticellEDCH_InformationItemIEs_iE_Extensions__item__extensionValue,
        __MulticellEDCH_InformationItemIEs_iE_Extensions__item_,
        _MulticellEDCH_InformationItemIEs_iE_Extensions,
        MulticellEDCH_InformationItemIEs,
        MulticellEDCH_InformationItemIEs_ExtIEs,
        __MulticellEDCH_RL_SpecificInformation_id_tab,
        ___MulticellEDCH_RL_SpecificInformation_id_tab_val_Value_0,
        _MulticellEDCH_RL_SpecificInformation_id,
        _MulticellEDCH_RL_SpecificInformation_criticality,
        _MulticellEDCH_RL_SpecificInformation_value,
        MulticellEDCH_RL_SpecificInformation,
        MulticellEDCH_RL_SpecificInformationItem,
        _MulticellEDCH_RL_SpecificInformationItem_val_Value_0,
        _MulticellEDCH_RL_SpecificInformationItemIEs_extendedPropagationDelay,
        _MulticellEDCH_RL_SpecificInformationItemIEs_enhanced_PrimaryCPICH_EcNo,
        _MulticellEDCH_RL_SpecificInformationItemIEs_dl_Reference_Power,
        _MulticellEDCH_RL_SpecificInformationItemIEs_phase_Reference_Update_Indicator,
        _MulticellEDCH_RL_SpecificInformationItemIEs_additional_e_DCH_DL_Control_Channel_Grant,
        ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id_tab,
        ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__id,
        ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality_tab,
        ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__criticality,
        ____MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue_tab,
        ___MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item__extensionValue,
        __MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions__item_,
        _MulticellEDCH_RL_SpecificInformationItemIEs_iE_Extensions,
        MulticellEDCH_RL_SpecificInformationItemIEs,
        MulticellEDCH_RL_SpecificInformationItemIEs_ExtIEs,
        Multicell_EDCH_Restriction,
        _Multiple_PLMN_List_pLMN_Identity,
        _Multiple_PLMN_List_list_Of_PLMNs,
        ____Multiple_PLMN_List_iE_Extensions__item__id_tab,
        ___Multiple_PLMN_List_iE_Extensions__item__id,
        ____Multiple_PLMN_List_iE_Extensions__item__criticality_tab,
        ___Multiple_PLMN_List_iE_Extensions__item__criticality,
        ____Multiple_PLMN_List_iE_Extensions__item__extensionValue_tab,
        ___Multiple_PLMN_List_iE_Extensions__item__extensionValue,
        __Multiple_PLMN_List_iE_Extensions__item_,
        _Multiple_PLMN_List_iE_Extensions,
        Multiple_PLMN_List,
        Multiple_PLMN_List_ExtIEs,
        MultiplexingPosition,
        MAChs_ResetIndicator,
        _MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR__item_,
        MultipleFreq_HSPDSCH_InformationList_ResponseTDDLCR,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hSSCCH_TDD_Specific_InfoList_Response_LCR,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_hARQ_MemoryPartitioning,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_uARFCN,
        ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id_tab,
        ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__id,
        ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality_tab,
        ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__criticality,
        ____MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue_tab,
        ___MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item__extensionValue,
        __MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions__item_,
        _MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_iE_Extensions,
        MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR,
        MultipleFreq_HSPDSCH_InformationItem_ResponseTDDLCR_ExtIEs,
        MIMO_SFMode_For_HSPDSCHDualStream,
        _Multi_Carrier_EDCH_Info_multicarrier_EDCH_Transport_Bearer_Mode,
        _Multi_Carrier_EDCH_Info_multi_carrier_EDCH_Information,
        ____Multi_Carrier_EDCH_Info_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Info_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Info_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Info_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Info_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Info_iE_Extensions,
        Multi_Carrier_EDCH_Info,
        Multi_Carrier_EDCH_Info_ExtIEs,
        Multicarrier_EDCH_Transport_Bearer_Mode,
        _Multi_Carrier_EDCH_Information__item_,
        Multi_Carrier_EDCH_Information,
        _Multi_Carrier_EDCH_LCR_InformationItem_uARFCNforNt,
        _Multi_Carrier_EDCH_LCR_InformationItem_sNPL_carrier_group_indicator,
        _Multi_Carrier_EDCH_LCR_InformationItem_pRxdesBase,
        _Multi_Carrier_EDCH_LCR_InformationItem_multi_Carrier_EDCH_MACdFlows_Information_TDD,
        ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions__item_,
        _Multi_Carrier_EDCH_LCR_InformationItem_iE_Extensions,
        Multi_Carrier_EDCH_LCR_InformationItem,
        Multi_Carrier_EDCH_LCR_InformationItem_ExtIEs,
        SNPL_Carrier_Group_Indicator,
        _Multi_Carrier_EDCH_MACdFlows_Information_TDD__item_,
        Multi_Carrier_EDCH_MACdFlows_Information_TDD,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_e_DCH_MACdFlow_ID,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_bindingID,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_transportLayerAddress,
        ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions__item_,
        _Multi_Carrier_EDCH_MACdFlows_Specific_Info_iE_Extensions,
        Multi_Carrier_EDCH_MACdFlows_Specific_Info,
        Multi_Carrier_EDCH_MACdFlows_Specific_Info_ExtIEs,
        _Multi_Carrier_EDCH_Reconfigure_continue_setup_change_Of_Multi_Carrier_EDCH,
        ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Reconfigure_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Reconfigure_iE_Extensions,
        Multi_Carrier_EDCH_Reconfigure,
        Multi_Carrier_EDCH_Reconfigure_ExtIEs,
        _Continue_Setup_Change_Multi_Carrier_EDCH_continue_,
        _Continue_Setup_Change_Multi_Carrier_EDCH_setup,
        _Continue_Setup_Change_Multi_Carrier_EDCH_change,
        Continue_Setup_Change_Multi_Carrier_EDCH,
        _Multi_Carrier_EDCH_Change_Info_multicarrier_EDCH_Transport_Bearer_Mode,
        _Multi_Carrier_EDCH_Change_Info_multi_carrier_EDCH_Information,
        _Multi_Carrier_EDCH_Change_Info_multi_Carrier_EDCH_Information_Removal_List,
        ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Change_Info_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Change_Info_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Change_Info_iE_Extensions,
        Multi_Carrier_EDCH_Change_Info,
        Multi_Carrier_EDCH_Change_Info_ExtIEs,
        _Multi_Carrier_EDCH_Information_Removal_List__item_,
        Multi_Carrier_EDCH_Information_Removal_List,
        _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_uARFCNforNt,
        ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions__item_,
        _Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_iE_Extensions,
        Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs,
        Multi_Carrier_EDCH_Information_Removal_Info_ItemIEs_ExtIEs,
        _Multi_Carrier_EDCH_Information_Response__item_,
        Multi_Carrier_EDCH_Information_Response,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_uARFCNforNt,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_DCH_TDD_MACdFlow_Specific_InformationResp,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_AGCH_Specific_Information_Response_LCR_TDD,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_e_HICH_Scheduled_InformationResp_LCR,
        ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id_tab,
        ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__id,
        ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality_tab,
        ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__criticality,
        ____Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue_tab,
        ___Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item__extensionValue,
        __Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions__item_,
        _Multi_Carrier_EDCH_LCR_Information_ResponseItem_iE_Extensions,
        Multi_Carrier_EDCH_LCR_Information_ResponseItem,
        Multi_Carrier_EDCH_LCR_Information_ResponseItem_ExtIEs,
        _Multiflow_Reconfiguration_setup,
        _Multiflow_Reconfiguration_configurationChange,
        _Multiflow_Reconfiguration_stop,
        Multiflow_Reconfiguration,
        _Multiflow_Information_total_Number_of_HS_DSCH_Cells,
        _Multiflow_Information_mode,
        _Multiflow_Information_mimo,
        _Multiflow_Information_timing,
        _Multiflow_Information_max_Number_of_HS_SCCH_Sets_per_NodeB,
        ____Multiflow_Information_iE_Extensions__item__id_tab,
        _____Multiflow_Information_iE_Extensions__item__id_tab_val_Extension_0,
        ___Multiflow_Information_iE_Extensions__item__id,
        ___Multiflow_Information_iE_Extensions__item__criticality,
        ___Multiflow_Information_iE_Extensions__item__extensionValue,
        __Multiflow_Information_iE_Extensions__item_,
        _Multiflow_Information_iE_Extensions,
        Multiflow_Information,
        Multiflow_Information_ExtIEs,
        _Multiflow_Information_ExtIEs_val_Extension_0,
        _Multiflow_Information_To_Modify_total_Number_of_HS_DSCH_Cells,
        _Multiflow_Information_To_Modify_mode,
        _Multiflow_Information_To_Modify_mimo,
        _Multiflow_Information_To_Modify_timing,
        _Multiflow_Information_To_Modify_max_Number_of_HS_SCCH_Sets_per_NodeB,
        ____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab,
        _____Multiflow_Information_To_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        ___Multiflow_Information_To_Modify_iE_Extensions__item__id,
        ___Multiflow_Information_To_Modify_iE_Extensions__item__criticality,
        ___Multiflow_Information_To_Modify_iE_Extensions__item__extensionValue,
        __Multiflow_Information_To_Modify_iE_Extensions__item_,
        _Multiflow_Information_To_Modify_iE_Extensions,
        Multiflow_Information_To_Modify,
        Multiflow_Information_To_Modify_ExtIEs,
        _Multiflow_Information_To_Modify_ExtIEs_val_Extension_0,
        _Multiflow_RepetitionFactors_assisting_CQI_RepetitionFactor,
        _Multiflow_RepetitionFactors_assisting_AckNack_RepetitionFactor,
        ____Multiflow_RepetitionFactors_iE_Extensions__item__id_tab,
        ___Multiflow_RepetitionFactors_iE_Extensions__item__id,
        ____Multiflow_RepetitionFactors_iE_Extensions__item__criticality_tab,
        ___Multiflow_RepetitionFactors_iE_Extensions__item__criticality,
        ____Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue_tab,
        ___Multiflow_RepetitionFactors_iE_Extensions__item__extensionValue,
        __Multiflow_RepetitionFactors_iE_Extensions__item_,
        _Multiflow_RepetitionFactors_iE_Extensions,
        Multiflow_RepetitionFactors,
        Multiflow_RepetitionFactors_ExtIEs,
        Multiflow_Stop,
        Multiflow_Mode,
        Multiflow_MIMO,
        _Multiflow_Timing_time_Reference,
        _Multiflow_Timing_non_Time_Reference,
        Multiflow_Timing,
        Multiflow_OrdinalNumberOfFrequency,
        _MU_MIMO_InformationLCR_mU_MIMO_Operation,
        _MU_MIMO_InformationLCR_standalone_Midamble_Channel_Information,
        ____MU_MIMO_InformationLCR_iE_Extensions__item__id_tab,
        ___MU_MIMO_InformationLCR_iE_Extensions__item__id,
        ____MU_MIMO_InformationLCR_iE_Extensions__item__criticality_tab,
        ___MU_MIMO_InformationLCR_iE_Extensions__item__criticality,
        ____MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue_tab,
        ___MU_MIMO_InformationLCR_iE_Extensions__item__extensionValue,
        __MU_MIMO_InformationLCR_iE_Extensions__item_,
        _MU_MIMO_InformationLCR_iE_Extensions,
        MU_MIMO_InformationLCR,
        MU_MIMO_Operation,
        MU_MIMO_Usage_Indicator,
        _Standalone_Midamble_Channel_Information_standalone_Midamble_Configuration,
        _Standalone_Midamble_Channel_Information_standalone_MidambleShift,
        _Standalone_Midamble_Channel_Information_timeslotLCR,
        _Standalone_Midamble_Channel_Information_repetitionPeriod,
        _Standalone_Midamble_Channel_Information_offset,
        _Standalone_Midamble_Channel_Information_referenceBeta,
        ____Standalone_Midamble_Channel_Information_iE_Extensions__item__id_tab,
        ___Standalone_Midamble_Channel_Information_iE_Extensions__item__id,
        ____Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality_tab,
        ___Standalone_Midamble_Channel_Information_iE_Extensions__item__criticality,
        ____Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue_tab,
        ___Standalone_Midamble_Channel_Information_iE_Extensions__item__extensionValue,
        __Standalone_Midamble_Channel_Information_iE_Extensions__item_,
        _Standalone_Midamble_Channel_Information_iE_Extensions,
        Standalone_Midamble_Channel_Information,
        Standalone_Midamble_Configuration,
        Standalone_MidambleShift,
        Standalone_Midamble_RepetitionPeriod,
        Standalone_Midamble_Offset,
        ReferenceBeta,
        Standalone_Midamble_Channel_Information_ExtIEs,
        Mode1_Ind,
        MU_MIMO_InformationLCR_ExtIEs,
        _MU_MIMO_Indicator_mU_MIMO_Usage_Indicator,
        _MU_MIMO_Indicator_standalone_Midamble_Channel_Indicator,
        ____MU_MIMO_Indicator_iE_Extensions__item__id_tab,
        ___MU_MIMO_Indicator_iE_Extensions__item__id,
        ____MU_MIMO_Indicator_iE_Extensions__item__criticality_tab,
        ___MU_MIMO_Indicator_iE_Extensions__item__criticality,
        ____MU_MIMO_Indicator_iE_Extensions__item__extensionValue_tab,
        ___MU_MIMO_Indicator_iE_Extensions__item__extensionValue,
        __MU_MIMO_Indicator_iE_Extensions__item_,
        _MU_MIMO_Indicator_iE_Extensions,
        MU_MIMO_Indicator,
        MU_MIMO_Indicator_ExtIEs,
        _NACC_Related_Data_gERAN_SI_Type,
        ____NACC_Related_Data_iE_Extensions__item__id_tab,
        ___NACC_Related_Data_iE_Extensions__item__id,
        ____NACC_Related_Data_iE_Extensions__item__criticality_tab,
        ___NACC_Related_Data_iE_Extensions__item__criticality,
        ____NACC_Related_Data_iE_Extensions__item__extensionValue_tab,
        ___NACC_Related_Data_iE_Extensions__item__extensionValue,
        __NACC_Related_Data_iE_Extensions__item_,
        _NACC_Related_Data_iE_Extensions,
        NACC_Related_Data,
        NACC_Related_Data_ExtIEs,
        Nack_Power_Offset,
        NCC,
        ___Neighbouring_UMTS_CellInformation__item__id_tab,
        ____Neighbouring_UMTS_CellInformation__item__id_tab_val_Value_0,
        __Neighbouring_UMTS_CellInformation__item__id,
        __Neighbouring_UMTS_CellInformation__item__criticality,
        __Neighbouring_UMTS_CellInformation__item__value,
        _Neighbouring_UMTS_CellInformation__item_,
        Neighbouring_UMTS_CellInformation,
        ___Neighbouring_UMTS_CellInformation_Ext__item__id_tab,
        ____Neighbouring_UMTS_CellInformation_Ext__item__id_tab_val_Value_0,
        __Neighbouring_UMTS_CellInformation_Ext__item__id,
        __Neighbouring_UMTS_CellInformation_Ext__item__criticality,
        __Neighbouring_UMTS_CellInformation_Ext__item__value,
        _Neighbouring_UMTS_CellInformation_Ext__item_,
        Neighbouring_UMTS_CellInformation_Ext,
        Neighbouring_UMTS_CellInformationExtensionItemIE,
        _Neighbouring_UMTS_CellInformationExtensionItemIE_val_Value_0,
        _Neighbouring_UMTS_CellInformationExtensionItem_rNC_ID,
        _Neighbouring_UMTS_CellInformationExtensionItem_cN_PS_DomainIdentifier,
        _Neighbouring_UMTS_CellInformationExtensionItem_cN_CS_DomainIdentifier,
        _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_FDD_CellInformation,
        _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_TDD_CellInformation,
        _Neighbouring_UMTS_CellInformationExtensionItem_neighbouring_LCR_TDD_CellInformation,
        _Neighbouring_UMTS_CellInformationExtensionItem_extended_RNC_ID,
        ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id_tab,
        ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__id,
        ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality_tab,
        ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__criticality,
        ____Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue_tab,
        ___Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item__extensionValue,
        __Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions__item_,
        _Neighbouring_UMTS_CellInformationExtensionItem_iE_Extensions,
        Neighbouring_UMTS_CellInformationExtensionItem,
        Neighbouring_UMTS_CellInformationExtensionItem_ExtIEs,
        Neighbouring_UMTS_CellInformationItemIE,
        _Neighbouring_UMTS_CellInformationItemIE_val_Value_0,
        _Neighbouring_UMTS_CellInformationItem_rNC_ID,
        _Neighbouring_UMTS_CellInformationItem_cN_PS_DomainIdentifier,
        _Neighbouring_UMTS_CellInformationItem_cN_CS_DomainIdentifier,
        _Neighbouring_UMTS_CellInformationItem_neighbouring_FDD_CellInformation,
        _Neighbouring_UMTS_CellInformationItem_neighbouring_TDD_CellInformation,
        ____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab,
        _____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__id,
        ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__criticality,
        ___Neighbouring_UMTS_CellInformationItem_iE_Extensions__item__extensionValue,
        __Neighbouring_UMTS_CellInformationItem_iE_Extensions__item_,
        _Neighbouring_UMTS_CellInformationItem_iE_Extensions,
        Neighbouring_UMTS_CellInformationItem,
        Neighbouring_UMTS_CellInformationItem_ExtIEs,
        _Neighbouring_UMTS_CellInformationItem_ExtIEs_val_Extension_0,
        _Neighbouring_UMTS_CellInformationItem_ExtIEs_val_Extension_1,
        _Neighbouring_FDD_CellInformation__item_,
        Neighbouring_FDD_CellInformation,
        _Neighbouring_FDD_CellInformationItem_c_ID,
        _Neighbouring_FDD_CellInformationItem_uARFCNforNu,
        _Neighbouring_FDD_CellInformationItem_uARFCNforNd,
        _Neighbouring_FDD_CellInformationItem_frameOffset,
        _Neighbouring_FDD_CellInformationItem_primaryScramblingCode,
        _Neighbouring_FDD_CellInformationItem_primaryCPICH_Power,
        _Neighbouring_FDD_CellInformationItem_cellIndividualOffset,
        _Neighbouring_FDD_CellInformationItem_txDiversityIndicator,
        _Neighbouring_FDD_CellInformationItem_sTTD_SupportIndicator,
        _Neighbouring_FDD_CellInformationItem_closedLoopMode1_SupportIndicator,
        _Neighbouring_FDD_CellInformationItem_not_used_closedLoopMode2_SupportIndicator,
        ____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_8,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_9,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_10,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_11,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_12,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_13,
        _____Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_14,
        ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__id,
        ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__criticality,
        ___Neighbouring_FDD_CellInformationItem_iE_Extensions__item__extensionValue,
        __Neighbouring_FDD_CellInformationItem_iE_Extensions__item_,
        _Neighbouring_FDD_CellInformationItem_iE_Extensions,
        Neighbouring_FDD_CellInformationItem,
        Neighbouring_FDD_CellInformationItem_ExtIEs,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_0,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_1,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_2,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_3,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_4,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_5,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_6,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_7,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_8,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_9,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_10,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_11,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_12,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_13,
        _Neighbouring_FDD_CellInformationItem_ExtIEs_val_Extension_14,
        _MultipleFrequencyBandsIndicatorList__item_,
        MultipleFrequencyBandsIndicatorList,
        _NeighbouringFDDCellMeasurementInformation_uC_ID,
        _NeighbouringFDDCellMeasurementInformation_uARFCN,
        _NeighbouringFDDCellMeasurementInformation_primaryScramblingCode,
        ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id_tab,
        ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__id,
        ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality_tab,
        ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__criticality,
        ____NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringFDDCellMeasurementInformation_iE_Extensions__item__extensionValue,
        __NeighbouringFDDCellMeasurementInformation_iE_Extensions__item_,
        _NeighbouringFDDCellMeasurementInformation_iE_Extensions,
        NeighbouringFDDCellMeasurementInformation,
        NeighbouringFDDCellMeasurementInformationItem_ExtIEs,
        __Neighbouring_GSM_CellInformation_id_tab,
        ___Neighbouring_GSM_CellInformation_id_tab_val_Value_0,
        _Neighbouring_GSM_CellInformation_id,
        _Neighbouring_GSM_CellInformation_criticality,
        _Neighbouring_GSM_CellInformation_value,
        Neighbouring_GSM_CellInformation,
        Neighbouring_GSM_CellInformationIE,
        _Neighbouring_GSM_CellInformationIE_val_Value_0,
        _Neighbouring_GSM_CellInformationIEs__item_,
        Neighbouring_GSM_CellInformationIEs,
        _Neighbouring_GSM_CellInformationItem_cGI,
        _Neighbouring_GSM_CellInformationItem_cellIndividualOffset,
        _Neighbouring_GSM_CellInformationItem_bSIC,
        _Neighbouring_GSM_CellInformationItem_band_Indicator,
        _Neighbouring_GSM_CellInformationItem_bCCH_ARFCN,
        ____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6,
        _____Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7,
        ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__id,
        ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__criticality,
        ___Neighbouring_GSM_CellInformationItem_iE_Extensions__item__extensionValue,
        __Neighbouring_GSM_CellInformationItem_iE_Extensions__item_,
        _Neighbouring_GSM_CellInformationItem_iE_Extensions,
        Neighbouring_GSM_CellInformationItem,
        Neighbouring_GSM_CellInformationItem_ExtIEs,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_0,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_1,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_2,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_3,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_4,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_5,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_6,
        _Neighbouring_GSM_CellInformationItem_ExtIEs_val_Extension_7,
        _Neighbouring_TDD_CellInformation__item_,
        Neighbouring_TDD_CellInformation,
        _Neighbouring_TDD_CellInformationItem_c_ID,
        _Neighbouring_TDD_CellInformationItem_uARFCNforNt,
        _Neighbouring_TDD_CellInformationItem_frameOffset,
        _Neighbouring_TDD_CellInformationItem_cellParameterID,
        _Neighbouring_TDD_CellInformationItem_syncCase,
        _Neighbouring_TDD_CellInformationItem_timeSlot,
        _Neighbouring_TDD_CellInformationItem_sCH_TimeSlot,
        _Neighbouring_TDD_CellInformationItem_sCTD_Indicator,
        _Neighbouring_TDD_CellInformationItem_cellIndividualOffset,
        _Neighbouring_TDD_CellInformationItem_dPCHConstantValue,
        _Neighbouring_TDD_CellInformationItem_pCCPCH_Power,
        ____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6,
        _____Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_7,
        ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__id,
        ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__criticality,
        ___Neighbouring_TDD_CellInformationItem_iE_Extensions__item__extensionValue,
        __Neighbouring_TDD_CellInformationItem_iE_Extensions__item_,
        _Neighbouring_TDD_CellInformationItem_iE_Extensions,
        Neighbouring_TDD_CellInformationItem,
        Neighbouring_TDD_CellInformationItem_ExtIEs,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_0,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_1,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_2,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_3,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_4,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_5,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_6,
        _Neighbouring_TDD_CellInformationItem_ExtIEs_val_Extension_7,
        _NeighbouringTDDCellMeasurementInformation_uC_ID,
        _NeighbouringTDDCellMeasurementInformation_uARFCN,
        _NeighbouringTDDCellMeasurementInformation_cellParameterID,
        _NeighbouringTDDCellMeasurementInformation_timeSlot,
        _NeighbouringTDDCellMeasurementInformation_midambleShiftAndBurstType,
        ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id_tab,
        ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__id,
        ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality_tab,
        ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__criticality,
        ____NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringTDDCellMeasurementInformation_iE_Extensions__item__extensionValue,
        __NeighbouringTDDCellMeasurementInformation_iE_Extensions__item_,
        _NeighbouringTDDCellMeasurementInformation_iE_Extensions,
        NeighbouringTDDCellMeasurementInformation,
        NeighbouringTDDCellMeasurementInformationItem_ExtIEs,
        _NeighbouringTDDCellMeasurementInformationLCR_uC_ID,
        _NeighbouringTDDCellMeasurementInformationLCR_uARFCN,
        _NeighbouringTDDCellMeasurementInformationLCR_cellParameterID,
        _NeighbouringTDDCellMeasurementInformationLCR_timeSlotLCR,
        _NeighbouringTDDCellMeasurementInformationLCR_midambleShiftLCR,
        ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id_tab,
        ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__id,
        ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality_tab,
        ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__criticality,
        ____NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item__extensionValue,
        __NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions__item_,
        _NeighbouringTDDCellMeasurementInformationLCR_iE_Extensions,
        NeighbouringTDDCellMeasurementInformationLCR,
        NeighbouringTDDCellMeasurementInformationLCRItem_ExtIEs,
        _NeighbouringTDDCellMeasurementInformation768_uC_ID,
        _NeighbouringTDDCellMeasurementInformation768_uARFCN,
        _NeighbouringTDDCellMeasurementInformation768_cellParameterID,
        _NeighbouringTDDCellMeasurementInformation768_timeSlot,
        _NeighbouringTDDCellMeasurementInformation768_midambleShiftAndBurstType768,
        ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id_tab,
        ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__id,
        ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality_tab,
        ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__criticality,
        ____NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue_tab,
        ___NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item__extensionValue,
        __NeighbouringTDDCellMeasurementInformation768_iE_Extensions__item_,
        _NeighbouringTDDCellMeasurementInformation768_iE_Extensions,
        NeighbouringTDDCellMeasurementInformation768,
        NeighbouringTDDCellMeasurementInformationItem768_ExtIEs,
        _Neighbouring_LCR_TDD_CellInformation__item_,
        Neighbouring_LCR_TDD_CellInformation,
        _Neighbouring_LCR_TDD_CellInformationItem_c_ID,
        _Neighbouring_LCR_TDD_CellInformationItem_uARFCNforNt,
        _Neighbouring_LCR_TDD_CellInformationItem_frameOffset,
        _Neighbouring_LCR_TDD_CellInformationItem_cellParameterID,
        _Neighbouring_LCR_TDD_CellInformationItem_sCTD_Indicator,
        _Neighbouring_LCR_TDD_CellInformationItem_cellIndividualOffset,
        _Neighbouring_LCR_TDD_CellInformationItem_dPCHConstantValue,
        _Neighbouring_LCR_TDD_CellInformationItem_pCCPCH_Power,
        _Neighbouring_LCR_TDD_CellInformationItem_restrictionStateIndicator,
        ____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_4,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_5,
        _____Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_6,
        ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__id,
        ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__criticality,
        ___Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item__extensionValue,
        __Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions__item_,
        _Neighbouring_LCR_TDD_CellInformationItem_iE_Extensions,
        Neighbouring_LCR_TDD_CellInformationItem,
        Neighbouring_LCR_TDD_CellInformationItem_ExtIEs,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_0,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_1,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_2,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_3,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_4,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_5,
        _Neighbouring_LCR_TDD_CellInformationItem_ExtIEs_val_Extension_6,
        _Neighbouring_E_UTRA_CellInformation__item_,
        Neighbouring_E_UTRA_CellInformation,
        _Neighbouring_E_UTRA_CellInformationItem_eCGI,
        _Neighbouring_E_UTRA_CellInformationItem_eARFCN_Information,
        ____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab,
        _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__id,
        ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__criticality,
        ___Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item__extensionValue,
        __Neighbouring_E_UTRA_CellInformationItem_iE_Extensions__item_,
        _Neighbouring_E_UTRA_CellInformationItem_iE_Extensions,
        Neighbouring_E_UTRA_CellInformationItem,
        Neighbouring_E_UTRA_CellInformationItem_ExtIEs,
        _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_0,
        _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_1,
        _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_2,
        _Neighbouring_E_UTRA_CellInformationItem_ExtIEs_val_Extension_3,
        _MultipleFrequencyBandsIndicatorList_EUTRA__item_,
        MultipleFrequencyBandsIndicatorList_EUTRA,
        RadioFrequencyBandEUTRA,
        NonCellSpecificTxDiversity,
        Non_rectangular_resource_allocation_indicator,
        Non_rectangular_resource_timeslot_set,
        _NotProvidedCellList__item_,
        NotProvidedCellList,
        NrOfDLchannelisationcodes,
        NrOfTransportBlocks,
        NRT_Load_Information_Value_IncrDecrThres,
        NRT_Load_Information_Value,
        _NRTLoadInformationValue_uplinkNRTLoadInformationValue,
        _NRTLoadInformationValue_downlinkNRTLoadInformationValue,
        NRTLoadInformationValue,
        N_E_UCCH,
        N_E_UCCH_LCR,
        Number_Of_Supported_Carriers,
        NumHS_SCCH_Codes,
        NoOfTargetCellHS_SCCH_Order,
        _Non_Serving_RL_Preconfig_Setup_new_non_serving_RL_selection,
        ____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab,
        _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_0,
        _____Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id_tab_val_Extension_1,
        ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__id,
        ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__criticality,
        ___Non_Serving_RL_Preconfig_Setup_iE_Extensions__item__extensionValue,
        __Non_Serving_RL_Preconfig_Setup_iE_Extensions__item_,
        _Non_Serving_RL_Preconfig_Setup_iE_Extensions,
        Non_Serving_RL_Preconfig_Setup,
        Non_Serving_RL_Preconfig_Setup_ExtIEs,
        _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_0,
        _Non_Serving_RL_Preconfig_Setup_ExtIEs_val_Extension_1,
        Additional_E_DCH_Non_Serving_RL_Preconfiguration_Setup,
        _New_non_serving_RL_setup_selection_new_Serving_RL_in_DRNS,
        _New_non_serving_RL_setup_selection_new_Serving_RL_Not_in_DRNS,
        _New_non_serving_RL_setup_selection_new_Serving_RL_in_or_Not_in_DRNS,
        New_non_serving_RL_setup_selection,
        _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_A,
        _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_B,
        _Non_Serving_RL_Preconfig_Info_new_non_serving_RL_E_DCH_FDD_DL_ControlChannelInformation_C,
        ____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab,
        _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id_tab_val_Extension_1,
        ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__id,
        ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__criticality,
        ___Non_Serving_RL_Preconfig_Info_iE_Extensions__item__extensionValue,
        __Non_Serving_RL_Preconfig_Info_iE_Extensions__item_,
        _Non_Serving_RL_Preconfig_Info_iE_Extensions,
        Non_Serving_RL_Preconfig_Info,
        Non_Serving_RL_Preconfig_Info_ExtIEs,
        _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_0,
        _Non_Serving_RL_Preconfig_Info_ExtIEs_val_Extension_1,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_A,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_B,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__new_non_serving_RL_E_DCH_FDD_DL_Control_Channel_Information_C,
        _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id_tab,
        ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__id,
        _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality_tab,
        ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__criticality,
        _____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue_tab,
        ____Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item__extensionValue,
        ___Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions__item_,
        __Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item__iE_Extensions,
        _Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList__item_,
        Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList,
        Additional_E_DCH_New_non_serving_RL_E_DCH_FDD_DL_Control_Channel_InfoList_ExtIEs,
        NeedforIdleInterval,
        _OnModification_measurementThreshold,
        ____OnModification_iE_Extensions__item__id_tab,
        ___OnModification_iE_Extensions__item__id,
        ____OnModification_iE_Extensions__item__criticality_tab,
        ___OnModification_iE_Extensions__item__criticality,
        ____OnModification_iE_Extensions__item__extensionValue_tab,
        ___OnModification_iE_Extensions__item__extensionValue,
        __OnModification_iE_Extensions__item_,
        _OnModification_iE_Extensions,
        OnModification,
        OnModification_ExtIEs,
        _OnModificationInformation_informationThreshold,
        ____OnModificationInformation_iE_Extensions__item__id_tab,
        ___OnModificationInformation_iE_Extensions__item__id,
        ____OnModificationInformation_iE_Extensions__item__criticality_tab,
        ___OnModificationInformation_iE_Extensions__item__criticality,
        ____OnModificationInformation_iE_Extensions__item__extensionValue_tab,
        ___OnModificationInformation_iE_Extensions__item__extensionValue,
        __OnModificationInformation_iE_Extensions__item_,
        _OnModificationInformation_iE_Extensions,
        OnModificationInformation,
        OnModificationInformation_ExtIEs,
        OrdinalNumberOfFrequency,
        Out_of_Sychronization_Window,
        PagingCause,
        PagingRecordType,
        PartialReportingIndicator,
        Pattern_Sequence_Identifier,
        PayloadCRC_PresenceIndicator,
        PCCPCH_Power,
        _PCH_InformationList__item_,
        PCH_InformationList,
        _PCH_InformationItem_transportFormatSet,
        ____PCH_InformationItem_iE_Extensions__item__id_tab,
        ___PCH_InformationItem_iE_Extensions__item__id,
        ____PCH_InformationItem_iE_Extensions__item__criticality_tab,
        ___PCH_InformationItem_iE_Extensions__item__criticality,
        ____PCH_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___PCH_InformationItem_iE_Extensions__item__extensionValue,
        __PCH_InformationItem_iE_Extensions__item_,
        _PCH_InformationItem_iE_Extensions,
        PCH_InformationItem,
        PCH_InformationItem_ExtIEs,
        PC_Preamble,
        PCI,
        _Periodic_reportPeriodicity,
        ____Periodic_iE_Extensions__item__id_tab,
        ___Periodic_iE_Extensions__item__id,
        ____Periodic_iE_Extensions__item__criticality_tab,
        ___Periodic_iE_Extensions__item__criticality,
        ____Periodic_iE_Extensions__item__extensionValue_tab,
        ___Periodic_iE_Extensions__item__extensionValue,
        __Periodic_iE_Extensions__item_,
        _Periodic_iE_Extensions,
        Periodic,
        Periodic_ExtIEs,
        _PeriodicInformation_informationReportPeriodicity,
        ____PeriodicInformation_iE_Extensions__item__id_tab,
        ___PeriodicInformation_iE_Extensions__item__id,
        ____PeriodicInformation_iE_Extensions__item__criticality_tab,
        ___PeriodicInformation_iE_Extensions__item__criticality,
        ____PeriodicInformation_iE_Extensions__item__extensionValue_tab,
        ___PeriodicInformation_iE_Extensions__item__extensionValue,
        __PeriodicInformation_iE_Extensions__item_,
        _PeriodicInformation_iE_Extensions,
        PeriodicInformation,
        PeriodicInformation_ExtIEs,
        _Permanent_NAS_UE_Identity_imsi,
        Permanent_NAS_UE_Identity,
        Phase_Reference_Update_Indicator,
        PLCCHsequenceNumber,
        PLMN_Identity,
        _PLMN_List__item_,
        PLMN_List,
        PowerAdjustmentType,
        PowerOffset,
        PowerOffsetForSecondaryCPICHforMIMO,
        PowerOffsetForSecondaryCPICHforMIMORequestIndicator,
        _PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas__item_,
        PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennas,
        _Associated_Secondary_CPICH_associated_secondary_CPICH_channelId,
        _Associated_Secondary_CPICH_associated_secondary_CPICH,
        _Associated_Secondary_CPICH_associated_D_CPICH_channelId,
        _Associated_Secondary_CPICH_associated_D_CPICH,
        ____Associated_Secondary_CPICH_iE_Extensions__item__id_tab,
        ___Associated_Secondary_CPICH_iE_Extensions__item__id,
        ____Associated_Secondary_CPICH_iE_Extensions__item__criticality_tab,
        ___Associated_Secondary_CPICH_iE_Extensions__item__criticality,
        ____Associated_Secondary_CPICH_iE_Extensions__item__extensionValue_tab,
        ___Associated_Secondary_CPICH_iE_Extensions__item__extensionValue,
        __Associated_Secondary_CPICH_iE_Extensions__item_,
        _Associated_Secondary_CPICH_iE_Extensions,
        Associated_Secondary_CPICH,
        Associated_Secondary_CPICH_Item_ExtIEs,
        CommonPhysicalChannelID,
        PowerOffsetForSecondaryCPICHforMIMOwithfourtransmitantennasRequestIndicator,
        PowerOffsetForSCPICH_DCPICHforMIMOwithfourtransmitantennas,
        PRC,
        PRCDeviation,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        Precoder_Weight_Set_Restriction,
        PredictedSFNSFNDeviationLimit,
        PredictedTUTRANGPSDeviationLimit,
        _PreferredFrequencyLayerInfo_defaultPreferredFrequency,
        _PreferredFrequencyLayerInfo_additionalPreferredFrequency,
        ____PreferredFrequencyLayerInfo_iE_Extensions__item__id_tab,
        ___PreferredFrequencyLayerInfo_iE_Extensions__item__id,
        ____PreferredFrequencyLayerInfo_iE_Extensions__item__criticality_tab,
        ___PreferredFrequencyLayerInfo_iE_Extensions__item__criticality,
        ____PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue_tab,
        ___PreferredFrequencyLayerInfo_iE_Extensions__item__extensionValue,
        __PreferredFrequencyLayerInfo_iE_Extensions__item_,
        _PreferredFrequencyLayerInfo_iE_Extensions,
        PreferredFrequencyLayerInfo,
        PreferredFrequencyLayerInfo_ExtIEs,
        PrimaryCPICH_Power,
        PrimaryCPICH_EcNo,
        Primary_CPICH_Usage_For_Channel_Estimation,
        PrimaryCCPCH_RSCP,
        PrimaryCCPCH_RSCP_Delta,
        PrimaryScramblingCode,
        PriorityLevel,
        PriorityQueue_Id,
        _PriorityQueue_InfoList__item_,
        PriorityQueue_InfoList,
        _PriorityQueue_InfoItem_priorityQueue_Id,
        _PriorityQueue_InfoItem_associatedHSDSCH_MACdFlow,
        _PriorityQueue_InfoItem_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_t1,
        _PriorityQueue_InfoItem_discardTimer,
        _PriorityQueue_InfoItem_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_mAChsGuaranteedBitRate,
        _PriorityQueue_InfoItem_mACdPDU_Size_Index,
        _PriorityQueue_InfoItem_rLC_Mode,
        ____PriorityQueue_InfoItem_iE_Extensions__item__id_tab,
        _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____PriorityQueue_InfoItem_iE_Extensions__item__id_tab_val_Extension_2,
        ___PriorityQueue_InfoItem_iE_Extensions__item__id,
        ___PriorityQueue_InfoItem_iE_Extensions__item__criticality,
        ___PriorityQueue_InfoItem_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_iE_Extensions__item_,
        _PriorityQueue_InfoItem_iE_Extensions,
        PriorityQueue_InfoItem,
        PriorityQueue_InfoItem_ExtIEs,
        _PriorityQueue_InfoItem_ExtIEs_val_Extension_0,
        _PriorityQueue_InfoItem_ExtIEs_val_Extension_1,
        _PriorityQueue_InfoItem_ExtIEs_val_Extension_2,
        _PriorityQueue_InfoList_EnhancedFACH_PCH__item_,
        PriorityQueue_InfoList_EnhancedFACH_PCH,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_priorityQueue_Id,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_t1,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_mAC_ehs_Reset_Timer,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_discardTimer,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_maximum_MACdPDU_Size,
        ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id_tab,
        ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__id,
        ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality_tab,
        ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__criticality,
        ____PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue_tab,
        ___PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions__item_,
        _PriorityQueue_InfoItem_EnhancedFACH_PCH_iE_Extensions,
        PriorityQueue_InfoItem_EnhancedFACH_PCH,
        PriorityQueue_InfoItem_EnhancedFACH_PCH_ExtIEs,
        _PriorityQueue_InfoList_to_Modify__item_,
        PriorityQueue_InfoList_to_Modify,
        _PriorityQueue_InfoItem_to_Add_priorityQueue_Id,
        _PriorityQueue_InfoItem_to_Add_associatedHSDSCH_MACdFlow,
        _PriorityQueue_InfoItem_to_Add_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_to_Add_t1,
        _PriorityQueue_InfoItem_to_Add_discardTimer,
        _PriorityQueue_InfoItem_to_Add_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_to_Add_mAChsGuaranteedBitRate,
        _PriorityQueue_InfoItem_to_Add_mACdPDU_Size_Index,
        _PriorityQueue_InfoItem_to_Add_rLC_Mode,
        ____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab,
        _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_0,
        _____PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id_tab_val_Extension_1,
        ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__id,
        ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__criticality,
        ___PriorityQueue_InfoItem_to_Add_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_to_Add_iE_Extensions__item_,
        _PriorityQueue_InfoItem_to_Add_iE_Extensions,
        PriorityQueue_InfoItem_to_Add,
        PriorityQueue_InfoItem_to_Add_ExtIEs,
        _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_0,
        _PriorityQueue_InfoItem_to_Add_ExtIEs_val_Extension_1,
        _PriorityQueue_InfoItem_to_Modify_priorityQueue_Id,
        _PriorityQueue_InfoItem_to_Modify_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_to_Modify_t1,
        _PriorityQueue_InfoItem_to_Modify_discardTimer,
        _PriorityQueue_InfoItem_to_Modify_mAC_hsWindowSize,
        _PriorityQueue_InfoItem_to_Modify_mAChsGuaranteedBitRate,
        _PriorityQueue_InfoItem_to_Modify_mACdPDU_Size_Index_to_Modify,
        ____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab,
        _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_0,
        _____PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id_tab_val_Extension_1,
        ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__id,
        ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__criticality,
        ___PriorityQueue_InfoItem_to_Modify_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_to_Modify_iE_Extensions__item_,
        _PriorityQueue_InfoItem_to_Modify_iE_Extensions,
        PriorityQueue_InfoItem_to_Modify,
        PriorityQueue_InfoItem_to_Modify_ExtIEs,
        _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_0,
        _PriorityQueue_InfoItem_to_Modify_ExtIEs_val_Extension_1,
        _PriorityQueue_InfoList_to_Modify_Unsynchronised__item_,
        PriorityQueue_InfoList_to_Modify_Unsynchronised,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_priorityQueueId,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_schedulingPriorityIndicator,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_discardTimer,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_mAChsGuaranteedBitRate,
        ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id_tab,
        ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__id,
        ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality_tab,
        ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__criticality,
        ____PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue_tab,
        ___PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item__extensionValue,
        __PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions__item_,
        _PriorityQueue_InfoItem_to_Modify_Unsynchronised_iE_Extensions,
        PriorityQueue_InfoItem_to_Modify_Unsynchronised,
        PriorityQueue_InfoItem_to_Modify_Unsynchronised_ExtIEs,
        PropagationDelay,
        _ProvidedInformation_mBMSChannelTypeInfo,
        _ProvidedInformation_mBMSPreferredFreqLayerInfo,
        ____ProvidedInformation_iE_Extensions__item__id_tab,
        _____ProvidedInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____ProvidedInformation_iE_Extensions__item__id_tab_val_Extension_1,
        ___ProvidedInformation_iE_Extensions__item__id,
        ___ProvidedInformation_iE_Extensions__item__criticality,
        ___ProvidedInformation_iE_Extensions__item__extensionValue,
        __ProvidedInformation_iE_Extensions__item_,
        _ProvidedInformation_iE_Extensions,
        ProvidedInformation,
        ProvideInformation_ExtIEs,
        _ProvideInformation_ExtIEs_val_Extension_0,
        _ProvideInformation_ExtIEs_val_Extension_1,
        ___UpPCH_InformationList_LCRTDD__item__id_tab,
        ____UpPCH_InformationList_LCRTDD__item__id_tab_val_Value_0,
        __UpPCH_InformationList_LCRTDD__item__id,
        __UpPCH_InformationList_LCRTDD__item__criticality,
        __UpPCH_InformationList_LCRTDD__item__value,
        _UpPCH_InformationList_LCRTDD__item_,
        UpPCH_InformationList_LCRTDD,
        UpPCH_InformationItemIE_LCRTDD,
        _UpPCH_InformationItemIE_LCRTDD_val_Value_0,
        _UpPCH_InformationItem_LCRTDD_uARFCNforNt,
        _UpPCH_InformationItem_LCRTDD_uPPCHPositionLCR,
        ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id_tab,
        ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__id,
        ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality_tab,
        ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__criticality,
        ____UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue_tab,
        ___UpPCH_InformationItem_LCRTDD_iE_Extensions__item__extensionValue,
        __UpPCH_InformationItem_LCRTDD_iE_Extensions__item_,
        _UpPCH_InformationItem_LCRTDD_iE_Extensions,
        UpPCH_InformationItem_LCRTDD,
        UpPCH_InformationItem_LCRTDD_ExtIEs,
        PunctureLimit,
        _PTMCellList__item_,
        PTMCellList,
        _PTPCellList__item_,
        PTPCellList,
        QE_Selector,
        Process_Memory_Size,
        _RABased_raiList,
        ____RABased_iE_Extensions__item__id_tab,
        ___RABased_iE_Extensions__item__id,
        ____RABased_iE_Extensions__item__criticality_tab,
        ___RABased_iE_Extensions__item__criticality,
        ____RABased_iE_Extensions__item__extensionValue_tab,
        ___RABased_iE_Extensions__item__extensionValue,
        __RABased_iE_Extensions__item_,
        _RABased_iE_Extensions,
        RABased,
        RABased_ExtIEs,
        _Radio_Links_without_DPCH_FDPCH_Indication__item_,
        Radio_Links_without_DPCH_FDPCH_Indication,
        _Radio_Links_without_DPCH_FDPCH_Information_rL_ID,
        _Radio_Links_without_DPCH_FDPCH_Information_radio_Links_without_DPCH_FDPCH_Operation_Indicator,
        ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id_tab,
        ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__id,
        ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality_tab,
        ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__criticality,
        ____Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue_tab,
        ___Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item__extensionValue,
        __Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions__item_,
        _Radio_Links_without_DPCH_FDPCH_Information_iE_Extensions,
        Radio_Links_without_DPCH_FDPCH_Information,
        Radio_Links_without_DPCH_FDPCH_Information_ExtIEs,
        _RAI_List__item_,
        RAI_List,
        ReportInterval,
        ReportAmount,
        RAC,
        _RAI_pLMN_Identity,
        _RAI_lAC,
        _RAI_rAC,
        RAI,
        RANAP_EnhancedRelocationInformationRequest,
        RANAP_EnhancedRelocationInformationResponse,
        RANAP_RelocationInformation,
        Range_Correction_Rate,
        RateMatchingAttribute,
        RB_Identity,
        _RB_Info__item_,
        RB_Info,
        Received_Total_Wideband_Power_Value,
        Received_Total_Wideband_Power_Value_IncrDecrThres,
        _Reference_E_TFCI_Information__item_,
        Reference_E_TFCI_Information,
        _Reference_E_TFCI_Information_Item_reference_E_TFCI,
        _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO,
        ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab,
        _____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue,
        __Reference_E_TFCI_Information_Item_iE_Extensions__item_,
        _Reference_E_TFCI_Information_Item_iE_Extensions,
        Reference_E_TFCI_Information_Item,
        Reference_E_TFCI_Information_Item_ExtIEs,
        _Reference_E_TFCI_Information_Item_ExtIEs_val_Extension_0,
        Reference_E_TFCI_PO,
        RefTFCNumber,
        _Released_CN_Domain_pSDomain,
        _Released_CN_Domain_cSDomain,
        _Released_CN_Domain_pS_CSDomain,
        Released_CN_Domain,
        RepetitionLength,
        RepetitionPeriod,
        RepetitionNumber0,
        RepetitionNumber1,
        _ReportCharacteristics_onDemand,
        _ReportCharacteristics_periodic,
        _ReportCharacteristics_eventA,
        _ReportCharacteristics_eventB,
        _ReportCharacteristics_eventC,
        _ReportCharacteristics_eventD,
        _ReportCharacteristics_eventE,
        _ReportCharacteristics_eventF,
        _ReportCharacteristics_extension_ReportCharacteristics,
        ReportCharacteristics,
        __Extension_ReportCharacteristics_id_tab,
        ___Extension_ReportCharacteristics_id_tab_val_Value_0,
        ___Extension_ReportCharacteristics_id_tab_val_Value_1,
        _Extension_ReportCharacteristics_id,
        _Extension_ReportCharacteristics_criticality,
        _Extension_ReportCharacteristics_value,
        Extension_ReportCharacteristics,
        Extension_ReportCharacteristicsIE,
        _Extension_ReportCharacteristicsIE_val_Value_0,
        _Extension_ReportCharacteristicsIE_val_Value_1,
        _ReportPeriodicity_ten_msec,
        _ReportPeriodicity_min,
        ReportPeriodicity,
        _RequestedDataValue_gA_AccessPointPositionwithAltitude,
        _RequestedDataValue_iPDLParameters,
        _RequestedDataValue_dGPSCorrections,
        _RequestedDataValue_gPS_NavigationModel_and_TimeRecovery,
        _RequestedDataValue_gPS_Ionospheric_Model,
        _RequestedDataValue_gPS_UTC_Model,
        _RequestedDataValue_gPS_Almanac,
        _RequestedDataValue_gPS_RealTime_Integrity,
        _RequestedDataValue_gPS_RX_POS,
        _RequestedDataValue_sFNSFN_GA_AccessPointPosition,
        ____RequestedDataValue_iE_Extensions__item__id_tab,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_2,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_3,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_4,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_5,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_6,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_7,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_8,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_9,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_10,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_11,
        ___RequestedDataValue_iE_Extensions__item__id,
        ___RequestedDataValue_iE_Extensions__item__criticality,
        ___RequestedDataValue_iE_Extensions__item__extensionValue,
        __RequestedDataValue_iE_Extensions__item_,
        _RequestedDataValue_iE_Extensions,
        RequestedDataValue,
        RequestedDataValue_ExtIEs,
        _RequestedDataValue_ExtIEs_val_Extension_0,
        _RequestedDataValue_ExtIEs_val_Extension_1,
        _RequestedDataValue_ExtIEs_val_Extension_2,
        _RequestedDataValue_ExtIEs_val_Extension_3,
        _RequestedDataValue_ExtIEs_val_Extension_4,
        _RequestedDataValue_ExtIEs_val_Extension_5,
        _RequestedDataValue_ExtIEs_val_Extension_6,
        _RequestedDataValue_ExtIEs_val_Extension_7,
        _RequestedDataValue_ExtIEs_val_Extension_8,
        _RequestedDataValue_ExtIEs_val_Extension_9,
        _RequestedDataValue_ExtIEs_val_Extension_10,
        _RequestedDataValue_ExtIEs_val_Extension_11,
        _RequestedDataValueInformation_informationAvailable,
        _RequestedDataValueInformation_informationNotAvailable,
        RequestedDataValueInformation,
        RestrictionStateIndicator,
        RL_ID,
        RL_Set_ID,
        _RL_Specific_DCH_Info__item_,
        RL_Specific_DCH_Info,
        _RL_Specific_DCH_Info_Item_dCH_id,
        _RL_Specific_DCH_Info_Item_bindingID,
        _RL_Specific_DCH_Info_Item_transportLayerAddress,
        ____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab,
        _____RL_Specific_DCH_Info_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___RL_Specific_DCH_Info_Item_iE_Extensions__item__id,
        ___RL_Specific_DCH_Info_Item_iE_Extensions__item__criticality,
        ___RL_Specific_DCH_Info_Item_iE_Extensions__item__extensionValue,
        __RL_Specific_DCH_Info_Item_iE_Extensions__item_,
        _RL_Specific_DCH_Info_Item_iE_Extensions,
        RL_Specific_DCH_Info_Item,
        RL_Specific_DCH_Info_Item_ExtIEs,
        _RL_Specific_DCH_Info_Item_ExtIEs_val_Extension_0,
        _RL_Specific_EDCH_Information_rL_Specific_EDCH_Info,
        _RL_Specific_EDCH_Information_e_AGCH_PowerOffset,
        _RL_Specific_EDCH_Information_e_RGCH_PowerOffset,
        _RL_Specific_EDCH_Information_e_HICH_PowerOffset,
        ____RL_Specific_EDCH_Information_iE_Extensions__item__id_tab,
        ___RL_Specific_EDCH_Information_iE_Extensions__item__id,
        ____RL_Specific_EDCH_Information_iE_Extensions__item__criticality_tab,
        ___RL_Specific_EDCH_Information_iE_Extensions__item__criticality,
        ____RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue_tab,
        ___RL_Specific_EDCH_Information_iE_Extensions__item__extensionValue,
        __RL_Specific_EDCH_Information_iE_Extensions__item_,
        _RL_Specific_EDCH_Information_iE_Extensions,
        RL_Specific_EDCH_Information,
        RL_Specific_EDCH_Information_Item_ExtIEs,
        _RL_Specific_EDCH_Info__item_,
        RL_Specific_EDCH_Info,
        _RL_Specific_EDCH_InfoItem_eDCH_MACdFlow_ID,
        _RL_Specific_EDCH_InfoItem_bindingID,
        _RL_Specific_EDCH_InfoItem_transportLayerAddress,
        ____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab,
        _____RL_Specific_EDCH_InfoItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__id,
        ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__criticality,
        ___RL_Specific_EDCH_InfoItem_iE_Extensions__item__extensionValue,
        __RL_Specific_EDCH_InfoItem_iE_Extensions__item_,
        _RL_Specific_EDCH_InfoItem_iE_Extensions,
        RL_Specific_EDCH_InfoItem,
        RL_Specific_EDCH_Info_Item_ExtIEs,
        _RL_Specific_EDCH_Info_Item_ExtIEs_val_Extension_0,
        RLC_Mode,
        DL_RLC_PDU_Size_Format,
        RLC_Sequence_Number,
        RNC_ID,
        RNTI_Allocation_Indicator,
        Round_Trip_Time_IncrDecrThres,
        Round_Trip_Time_Value,
        RSCP_Value,
        RSCP_Value_IncrDecrThres,
        Received_total_wide_band_power,
        RT_Load_Value_IncrDecrThres,
        RT_Load_Value,
        _RTLoadValue_uplinkRTLoadValue,
        _RTLoadValue_downlinkRTLoadValue,
        RTLoadValue,
        RxTimingDeviationForTA,
        RxTimingDeviationForTAext,
        RxTimingDeviationForTA768,
        Rx_Timing_Deviation_Value,
        Rx_Timing_Deviation_Value_ext,
        Rx_Timing_Deviation_Value_LCR,
        Rx_Timing_Deviation_Value_768,
        RefBeta,
        SAC,
        _SAI_pLMN_Identity,
        _SAI_lAC,
        _SAI_sAC,
        ____SAI_iE_Extensions__item__id_tab,
        ___SAI_iE_Extensions__item__id,
        ____SAI_iE_Extensions__item__criticality_tab,
        ___SAI_iE_Extensions__item__criticality,
        ____SAI_iE_Extensions__item__extensionValue_tab,
        ___SAI_iE_Extensions__item__extensionValue,
        __SAI_iE_Extensions__item_,
        _SAI_iE_Extensions,
        SAI,
        SAI_ExtIEs,
        _Same_As_Scheduled_E_HICH_e_HICH_EI,
        Same_As_Scheduled_E_HICH,
        SAT_ID,
        Satellite_DGPSCorrections_Information_ExtIEs,
        _Satellite_DGPSCorrections_Information_ExtIEs_val_Extension_0,
        SCH_TimeSlot,
        ScaledAdjustmentRatio,
        SchedulingInformation,
        SCTD_Indicator,
        SDPCCH_PowerOffsetInformation,
        _SecondaryServingCells__item_,
        SecondaryServingCells,
        _SecondaryServingCellsItem_secondaryC_ID,
        _SecondaryServingCellsItem_numSecondaryHS_SCCH_Codes,
        _SecondaryServingCellsItem_sixtyfourQAM_UsageAllowedIndicator,
        ____SecondaryServingCellsItem_iE_Extensions__item__id_tab,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_3,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_4,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_5,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_6,
        _____SecondaryServingCellsItem_iE_Extensions__item__id_tab_val_Extension_7,
        ___SecondaryServingCellsItem_iE_Extensions__item__id,
        ___SecondaryServingCellsItem_iE_Extensions__item__criticality,
        ___SecondaryServingCellsItem_iE_Extensions__item__extensionValue,
        __SecondaryServingCellsItem_iE_Extensions__item_,
        _SecondaryServingCellsItem_iE_Extensions,
        SecondaryServingCellsItem,
        SecondaryServingCellsItem_ExtIEs,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_0,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_1,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_2,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_3,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_4,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_5,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_6,
        _SecondaryServingCellsItem_ExtIEs_val_Extension_7,
        _Secondary_CCPCH_Info_TDD_dl_TFCS,
        _Secondary_CCPCH_Info_TDD_tFCI_Coding,
        _Secondary_CCPCH_Info_TDD_secondary_CCPCH_TDD_InformationList,
        _Secondary_CCPCH_Info_TDD_fACH_InformationList,
        _Secondary_CCPCH_Info_TDD_pCH_InformationList,
        ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__id,
        ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_Info_TDD_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_Info_TDD_iE_Extensions__item_,
        _Secondary_CCPCH_Info_TDD_iE_Extensions,
        Secondary_CCPCH_Info_TDD,
        Secondary_CCPCH_Info_TDD_ExtIEs,
        _Secondary_CPICH_Information_dl_ScramblingCode,
        _Secondary_CPICH_Information_fDD_DL_ChannelisationCodeNumber,
        ____Secondary_CPICH_Information_iE_Extensions__item__id_tab,
        ___Secondary_CPICH_Information_iE_Extensions__item__id,
        ____Secondary_CPICH_Information_iE_Extensions__item__criticality_tab,
        ___Secondary_CPICH_Information_iE_Extensions__item__criticality,
        ____Secondary_CPICH_Information_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CPICH_Information_iE_Extensions__item__extensionValue,
        __Secondary_CPICH_Information_iE_Extensions__item_,
        _Secondary_CPICH_Information_iE_Extensions,
        Secondary_CPICH_Information,
        Secondary_CPICH_Information_ExtIEs,
        _Secondary_CPICH_Information_Change_new_secondary_CPICH,
        _Secondary_CPICH_Information_Change_secondary_CPICH_shall_not_be_used,
        Secondary_CPICH_Information_Change,
        _Secondary_LCR_CCPCH_Info_TDD_dl_TFCS,
        _Secondary_LCR_CCPCH_Info_TDD_tFCI_Coding,
        _Secondary_LCR_CCPCH_Info_TDD_secondary_LCR_CCPCH_TDD_InformationList,
        _Secondary_LCR_CCPCH_Info_TDD_fACH_InformationList,
        _Secondary_LCR_CCPCH_Info_TDD_pCH_InformationList,
        ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id_tab,
        ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__id,
        ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality_tab,
        ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__criticality,
        ____Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue_tab,
        ___Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item__extensionValue,
        __Secondary_LCR_CCPCH_Info_TDD_iE_Extensions__item_,
        _Secondary_LCR_CCPCH_Info_TDD_iE_Extensions,
        Secondary_LCR_CCPCH_Info_TDD,
        Secondary_LCR_CCPCH_Info_TDD_ExtIEs,
        _Secondary_CCPCH_Info_TDD768_dl_TFCS,
        _Secondary_CCPCH_Info_TDD768_tFCI_Coding,
        _Secondary_CCPCH_Info_TDD768_secondary_CCPCH_TDD_InformationList768,
        _Secondary_CCPCH_Info_TDD768_fACH_InformationList,
        _Secondary_CCPCH_Info_TDD768_pCH_InformationList,
        ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__id,
        ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_Info_TDD768_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_Info_TDD768_iE_Extensions__item_,
        _Secondary_CCPCH_Info_TDD768_iE_Extensions,
        Secondary_CCPCH_Info_TDD768,
        Secondary_CCPCH_Info_TDD768_ExtIEs,
        _Secondary_CCPCH_TDD_InformationList__item_,
        Secondary_CCPCH_TDD_InformationList,
        _Secondary_CCPCH_TDD_InformationItem_timeSlot,
        _Secondary_CCPCH_TDD_InformationItem_midambleShiftAndBurstType,
        _Secondary_CCPCH_TDD_InformationItem_tFCI_Presence,
        _Secondary_CCPCH_TDD_InformationItem_secondary_CCPCH_TDD_Code_Information,
        _Secondary_CCPCH_TDD_InformationItem_tDD_PhysicalChannelOffset,
        _Secondary_CCPCH_TDD_InformationItem_repetitionLength,
        _Secondary_CCPCH_TDD_InformationItem_repetitionPeriod,
        ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__id,
        ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_TDD_InformationItem_iE_Extensions__item_,
        _Secondary_CCPCH_TDD_InformationItem_iE_Extensions,
        Secondary_CCPCH_TDD_InformationItem,
        Secondary_CCPCH_TDD_InformationItem_ExtIEs,
        _Secondary_LCR_CCPCH_TDD_InformationList__item_,
        Secondary_LCR_CCPCH_TDD_InformationList,
        _Secondary_LCR_CCPCH_TDD_InformationItem_timeSlotLCR,
        _Secondary_LCR_CCPCH_TDD_InformationItem_midambleShiftLCR,
        _Secondary_LCR_CCPCH_TDD_InformationItem_tFCI_Presence,
        _Secondary_LCR_CCPCH_TDD_InformationItem_secondary_LCR_CCPCH_TDD_Code_Information,
        _Secondary_LCR_CCPCH_TDD_InformationItem_tDD_PhysicalChannelOffset,
        _Secondary_LCR_CCPCH_TDD_InformationItem_repetitionLength,
        _Secondary_LCR_CCPCH_TDD_InformationItem_repetitionPeriod,
        ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id_tab,
        ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__id,
        ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality_tab,
        ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__criticality,
        ____Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item__extensionValue,
        __Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions__item_,
        _Secondary_LCR_CCPCH_TDD_InformationItem_iE_Extensions,
        Secondary_LCR_CCPCH_TDD_InformationItem,
        Secondary_LCR_CCPCH_TDD_InformationItem_ExtIEs,
        _Secondary_CCPCH_TDD_InformationList768__item_,
        Secondary_CCPCH_TDD_InformationList768,
        _Secondary_CCPCH_TDD_InformationItem768_timeSlot,
        _Secondary_CCPCH_TDD_InformationItem768_midambleShiftAndBurstType768,
        _Secondary_CCPCH_TDD_InformationItem768_tFCI_Presence,
        _Secondary_CCPCH_TDD_InformationItem768_secondary_CCPCH_TDD_Code_Information768,
        _Secondary_CCPCH_TDD_InformationItem768_tDD_PhysicalChannelOffset,
        _Secondary_CCPCH_TDD_InformationItem768_repetitionLength,
        _Secondary_CCPCH_TDD_InformationItem768_repetitionPeriod,
        ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__id,
        ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_TDD_InformationItem768_iE_Extensions__item_,
        _Secondary_CCPCH_TDD_InformationItem768_iE_Extensions,
        Secondary_CCPCH_TDD_InformationItem768,
        Secondary_CCPCH_TDD_InformationItem768_ExtIEs,
        _Secondary_CCPCH_TDD_Code_Information__item_,
        Secondary_CCPCH_TDD_Code_Information,
        _Secondary_CCPCH_TDD_Code_InformationItem_tDD_ChannelisationCode,
        ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id,
        ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_,
        _Secondary_CCPCH_TDD_Code_InformationItem_iE_Extensions,
        Secondary_CCPCH_TDD_Code_InformationItem,
        Secondary_CCPCH_TDD_Code_InformationItem_ExtIEs,
        _Secondary_LCR_CCPCH_TDD_Code_Information__item_,
        Secondary_LCR_CCPCH_TDD_Code_Information,
        _Secondary_LCR_CCPCH_TDD_Code_InformationItem_tDD_ChannelisationCodeLCR,
        _Secondary_LCR_CCPCH_TDD_Code_InformationItem_s_CCPCH_TimeSlotFormat_LCR,
        ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id_tab,
        ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__id,
        ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__criticality,
        ____Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item__extensionValue,
        __Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions__item_,
        _Secondary_LCR_CCPCH_TDD_Code_InformationItem_iE_Extensions,
        Secondary_LCR_CCPCH_TDD_Code_InformationItem,
        Secondary_LCR_CCPCH_TDD_Code_InformationItem_ExtIEs,
        _Secondary_CCPCH_TDD_Code_Information768__item_,
        Secondary_CCPCH_TDD_Code_Information768,
        _Secondary_CCPCH_TDD_Code_InformationItem768_tDD_ChannelisationCode768,
        ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id_tab,
        ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__id,
        ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality_tab,
        ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__criticality,
        ____Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue_tab,
        ___Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item__extensionValue,
        __Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions__item_,
        _Secondary_CCPCH_TDD_Code_InformationItem768_iE_Extensions,
        Secondary_CCPCH_TDD_Code_InformationItem768,
        Secondary_CCPCH_TDD_Code_InformationItem768_ExtIEs,
        _Secondary_Serving_Cell_List_possible_Secondary_Serving_Cell_List,
        ____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab,
        _____Secondary_Serving_Cell_List_iE_Extensions__item__id_tab_val_Extension_0,
        ___Secondary_Serving_Cell_List_iE_Extensions__item__id,
        ___Secondary_Serving_Cell_List_iE_Extensions__item__criticality,
        ___Secondary_Serving_Cell_List_iE_Extensions__item__extensionValue,
        __Secondary_Serving_Cell_List_iE_Extensions__item_,
        _Secondary_Serving_Cell_List_iE_Extensions,
        Secondary_Serving_Cell_List,
        Secondary_Serving_Cell_List_ExtIEs,
        _Secondary_Serving_Cell_List_ExtIEs_val_Extension_0,
        _Possible_Secondary_Serving_Cell_List__item_,
        Possible_Secondary_Serving_Cell_List,
        _Possible_Secondary_Serving_Cell_c_ID,
        ____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab,
        _____Possible_Secondary_Serving_Cell_iE_Extensions__item__id_tab_val_Extension_0,
        ___Possible_Secondary_Serving_Cell_iE_Extensions__item__id,
        ___Possible_Secondary_Serving_Cell_iE_Extensions__item__criticality,
        ___Possible_Secondary_Serving_Cell_iE_Extensions__item__extensionValue,
        __Possible_Secondary_Serving_Cell_iE_Extensions__item_,
        _Possible_Secondary_Serving_Cell_iE_Extensions,
        Possible_Secondary_Serving_Cell,
        Possible_Secondary_Serving_Cell_ExtIEs,
        _Possible_Secondary_Serving_Cell_ExtIEs_val_Extension_0,
        SecondInterleavingMode,
        Secondary_UL_Frequency_Activation_State,
        S_E_DPCCH_PowerOffset,
        Seed,
        Service_ID,
        S_E_ROCH_Release_Indicator,
        _SetsOfHS_SCCH_Codes__item_,
        SetsOfHS_SCCH_Codes,
        _SetsOfHS_SCCH_CodesItem_hS_SCCH_PreconfiguredCodes,
        _SetsOfHS_SCCH_CodesItem_hSDSCH_RNTI,
        _SetsOfHS_SCCH_CodesItem_hSPDSCH_and_HSSCCH_ScramblingCode,
        _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_SupportIndicator,
        _SetsOfHS_SCCH_CodesItem_sixtyfourQAM_DL_UsageIndicator,
        _SetsOfHS_SCCH_CodesItem_hSDSCH_TBSizeTableIndicator,
        ____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab,
        _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id_tab_val_Extension_3,
        ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__id,
        ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__criticality,
        ___SetsOfHS_SCCH_CodesItem_iE_Extensions__item__extensionValue,
        __SetsOfHS_SCCH_CodesItem_iE_Extensions__item_,
        _SetsOfHS_SCCH_CodesItem_iE_Extensions,
        SetsOfHS_SCCH_CodesItem,
        SetsOfHS_SCCH_CodesItem_ExtIEs,
        _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_0,
        _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_1,
        _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_2,
        _SetsOfHS_SCCH_CodesItem_ExtIEs_val_Extension_3,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_Downlink_TPC_enhancements,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_FTPICH_Information,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_DCH_ENH,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_setup,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_configurationChange,
        _Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2_removal,
        Setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2,
        SFN,
        SFNSFN_FDD,
        SFNSFN_TDD,
        SFNSFN_TDD768,
        _GA_AccessPointPositionwithOptionalAltitude_geographicalCoordinate,
        _GA_AccessPointPositionwithOptionalAltitude_altitudeAndDirection,
        ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id_tab,
        ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__id,
        ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality_tab,
        ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__criticality,
        ____GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue_tab,
        ___GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item__extensionValue,
        __GA_AccessPointPositionwithOptionalAltitude_iE_Extensions__item_,
        _GA_AccessPointPositionwithOptionalAltitude_iE_Extensions,
        GA_AccessPointPositionwithOptionalAltitude,
        GA_AccessPointPositionwithOptionalAltitude_ExtIEs,
        SFNSFNChangeLimit,
        SFNSFNDriftRate,
        SFNSFNDriftRateQuality,
        _SFNSFNMeasurementThresholdInformation_sFNSFNChangeLimit,
        _SFNSFNMeasurementThresholdInformation_predictedSFNSFNDeviationLimit,
        ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id_tab,
        ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__id,
        ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality_tab,
        ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__criticality,
        ____SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNMeasurementThresholdInformation_iE_Extensions__item__extensionValue,
        __SFNSFNMeasurementThresholdInformation_iE_Extensions__item_,
        _SFNSFNMeasurementThresholdInformation_iE_Extensions,
        SFNSFNMeasurementThresholdInformation,
        SFNSFNMeasurementThresholdInformation_ExtIEs,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_ID,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNValue,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNQuality,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRate,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNDriftRateQuality,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__sFNSFNTimeStampInformation,
        ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab,
        _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id,
        ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab,
        _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality,
        ______SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab,
        _____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue,
        ____SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_,
        ___SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions,
        __SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_,
        _SFNSFNMeasurementValueInformation_successfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
        ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__uC_ID,
        ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id_tab,
        _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__id,
        ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality_tab,
        _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__criticality,
        ______SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue_tab,
        _____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item__extensionValue,
        ____SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions__item_,
        ___SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item__iE_Extensions,
        __SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation__item_,
        _SFNSFNMeasurementValueInformation_unsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformation,
        ____SFNSFNMeasurementValueInformation_iE_Extensions__item__id_tab,
        ___SFNSFNMeasurementValueInformation_iE_Extensions__item__id,
        ____SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality_tab,
        ___SFNSFNMeasurementValueInformation_iE_Extensions__item__criticality,
        ____SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNMeasurementValueInformation_iE_Extensions__item__extensionValue,
        __SFNSFNMeasurementValueInformation_iE_Extensions__item_,
        _SFNSFNMeasurementValueInformation_iE_Extensions,
        SFNSFNMeasurementValueInformation,
        SFNSFNMeasurementValueInformationItem_ExtIEs,
        SuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs,
        UnsuccessfullNeighbouringCellSFNSFNObservedTimeDifferenceMeasurementInformationItem_ExtIEs,
        SFNSFNQuality,
        _SFNSFNTimeStampInformation_sFNSFNTimeStamp_FDD,
        _SFNSFNTimeStampInformation_sFNSFNTimeStamp_TDD,
        SFNSFNTimeStampInformation,
        _SFNSFNTimeStamp_TDD_sFN,
        _SFNSFNTimeStamp_TDD_timeSlot,
        ____SFNSFNTimeStamp_TDD_iE_Extensions__item__id_tab,
        ___SFNSFNTimeStamp_TDD_iE_Extensions__item__id,
        ____SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality_tab,
        ___SFNSFNTimeStamp_TDD_iE_Extensions__item__criticality,
        ____SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNTimeStamp_TDD_iE_Extensions__item__extensionValue,
        __SFNSFNTimeStamp_TDD_iE_Extensions__item_,
        _SFNSFNTimeStamp_TDD_iE_Extensions,
        SFNSFNTimeStamp_TDD,
        SFNSFNTimeStamp_ExtIEs,
        _SFNSFNValue_sFNSFN_FDD,
        _SFNSFNValue_sFNSFN_TDD,
        _SFNSFNValue_sFNSFN_TDD768,
        SFNSFNValue,
        SID,
        Single_Stream_MIMO_ActivationIndicator,
        Single_Stream_MIMO_Mode_Indicator,
        SIR_Error_Value,
        SIR_Error_Value_IncrDecrThres,
        SIR_Value,
        SIR_Value_IncrDecrThres,
        SixteenQAM_UL_Operation_Indicator,
        SixtyfourQAM_UL_Operation_Indicator,
        SixtyfourQAM_UsageAllowedIndicator,
        SixtyfourQAM_DL_SupportIndicator,
        SixtyfourQAM_DL_UsageIndicator,
        SignatureSequenceGroupIndex,
        _SNA_Information_pLMN_Identity,
        _SNA_Information_listOfSNAs,
        ____SNA_Information_iE_Extensions__item__id_tab,
        ___SNA_Information_iE_Extensions__item__id,
        ____SNA_Information_iE_Extensions__item__criticality_tab,
        ___SNA_Information_iE_Extensions__item__criticality,
        ____SNA_Information_iE_Extensions__item__extensionValue_tab,
        ___SNA_Information_iE_Extensions__item__extensionValue,
        __SNA_Information_iE_Extensions__item_,
        _SNA_Information_iE_Extensions,
        SNA_Information,
        SNA_Information_ExtIEs,
        _ListOfSNAs__item_,
        ListOfSNAs,
        SNACode,
        SourceID,
        SpecialBurstScheduling,
        SpeechVersion,
        S_RNTI,
        _S_RNTI_Group_sRNTI,
        _S_RNTI_Group_sRNTI_BitMaskIndex,
        S_RNTI_Group,
        SRB_Delay,
        SSDT_SupportIndicator,
        Standalone_Midamble_Channel_Indicator,
        Status_Flag,
        STTD_SupportIndicator,
        Support_8PSK,
        Support_PLCCH,
        Support_of_Dynamic_DTXDRX_Related_HS_SCCH_Order,
        SyncCase,
        _SynchronisationConfiguration_n_INSYNC_IND,
        _SynchronisationConfiguration_n_OUTSYNC_IND,
        _SynchronisationConfiguration_t_RLFAILURE,
        ____SynchronisationConfiguration_iE_Extensions__item__id_tab,
        ___SynchronisationConfiguration_iE_Extensions__item__id,
        ____SynchronisationConfiguration_iE_Extensions__item__criticality_tab,
        ___SynchronisationConfiguration_iE_Extensions__item__criticality,
        ____SynchronisationConfiguration_iE_Extensions__item__extensionValue_tab,
        ___SynchronisationConfiguration_iE_Extensions__item__extensionValue,
        __SynchronisationConfiguration_iE_Extensions__item_,
        _SynchronisationConfiguration_iE_Extensions,
        SynchronisationConfiguration,
        SynchronisationConfiguration_ExtIEs,
        _SYNC_UL_ProcParameters_maxSYNC_UL_transmissions,
        _SYNC_UL_ProcParameters_powerRampStep,
        SYNC_UL_ProcParameters,
        T1,
        TAC,
        TargetID,
        TDD_AckNack_Power_Offset,
        TDD_ChannelisationCode,
        TDD_ChannelisationCode768,
        _TDD_ChannelisationCodeLCR_tDD_ChannelisationCode,
        _TDD_ChannelisationCodeLCR_modulation,
        TDD_ChannelisationCodeLCR,
        _TDD_DCHs_to_Modify__item_,
        TDD_DCHs_to_Modify,
        _TDD_DCHs_to_ModifyItem_ul_FP_Mode,
        _TDD_DCHs_to_ModifyItem_toAWS,
        _TDD_DCHs_to_ModifyItem_toAWE,
        _TDD_DCHs_to_ModifyItem_transportBearerRequestIndicator,
        _TDD_DCHs_to_ModifyItem_dCH_SpecificInformationList,
        ____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab,
        _____TDD_DCHs_to_ModifyItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__id,
        ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__criticality,
        ___TDD_DCHs_to_ModifyItem_iE_Extensions__item__extensionValue,
        __TDD_DCHs_to_ModifyItem_iE_Extensions__item_,
        _TDD_DCHs_to_ModifyItem_iE_Extensions,
        TDD_DCHs_to_ModifyItem,
        TDD_DCHs_to_ModifyItem_ExtIEs,
        _TDD_DCHs_to_ModifyItem_ExtIEs_val_Extension_0,
        _TDD_DCHs_to_ModifySpecificInformationList__item_,
        TDD_DCHs_to_ModifySpecificInformationList,
        _TDD_DCHs_to_ModifySpecificItem_dCH_ID,
        _TDD_DCHs_to_ModifySpecificItem_ul_CCTrCH_ID,
        _TDD_DCHs_to_ModifySpecificItem_dl_CCTrCH_ID,
        _TDD_DCHs_to_ModifySpecificItem_ul_TransportformatSet,
        _TDD_DCHs_to_ModifySpecificItem_dl_TransportformatSet,
        _TDD_DCHs_to_ModifySpecificItem_allocationRetentionPriority,
        _TDD_DCHs_to_ModifySpecificItem_frameHandlingPriority,
        ____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab,
        _____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__id,
        ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__criticality,
        ___TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item__extensionValue,
        __TDD_DCHs_to_ModifySpecificItem_iE_Extensions__item_,
        _TDD_DCHs_to_ModifySpecificItem_iE_Extensions,
        TDD_DCHs_to_ModifySpecificItem,
        TDD_DCHs_to_ModifySpecificItem_ExtIEs,
        _TDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_0,
        _TDD_DCHs_to_ModifySpecificItem_ExtIEs_val_Extension_1,
        _TDD_DL_Code_Information__item_,
        TDD_DL_Code_Information,
        _TDD_DL_Code_InformationItem_dPCH_ID,
        _TDD_DL_Code_InformationItem_tDD_ChannelisationCode,
        ____TDD_DL_Code_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_InformationItem_iE_Extensions__item__id,
        ____TDD_DL_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_InformationItem_iE_Extensions__item__criticality,
        ____TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_InformationItem_iE_Extensions__item_,
        _TDD_DL_Code_InformationItem_iE_Extensions,
        TDD_DL_Code_InformationItem,
        TDD_DL_Code_InformationItem_ExtIEs,
        _TDD_DL_Code_LCR_Information__item_,
        TDD_DL_Code_LCR_Information,
        _TDD_DL_Code_LCR_InformationItem_dPCH_ID,
        _TDD_DL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR,
        _TDD_DL_Code_LCR_InformationItem_tdd_DL_DPCH_TimeSlotFormat_LCR,
        ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__id,
        ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__criticality,
        ____TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_LCR_InformationItem_iE_Extensions__item_,
        _TDD_DL_Code_LCR_InformationItem_iE_Extensions,
        TDD_DL_Code_LCR_InformationItem,
        TDD_DL_Code_LCR_InformationItem_ExtIEs,
        _TDD_DL_Code_Information768__item_,
        TDD_DL_Code_Information768,
        _TDD_DL_Code_InformationItem768_dPCH_ID,
        _TDD_DL_Code_InformationItem768_tDD_ChannelisationCode768,
        ____TDD_DL_Code_InformationItem768_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_InformationItem768_iE_Extensions__item__id,
        ____TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_InformationItem768_iE_Extensions__item__criticality,
        ____TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_InformationItem768_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_InformationItem768_iE_Extensions__item_,
        _TDD_DL_Code_InformationItem768_iE_Extensions,
        TDD_DL_Code_InformationItem768,
        TDD_DL_Code_InformationItem768_ExtIEs,
        _TDD_DL_DPCH_TimeSlotFormat_LCR_qPSK,
        _TDD_DL_DPCH_TimeSlotFormat_LCR_eightPSK,
        TDD_DL_DPCH_TimeSlotFormat_LCR,
        QPSK_DL_DPCH_TimeSlotFormatTDD_LCR,
        EightPSK_DL_DPCH_TimeSlotFormatTDD_LCR,
        _TDD_DPCHOffset_initialOffset,
        _TDD_DPCHOffset_noinitialOffset,
        TDD_DPCHOffset,
        TDD_PhysicalChannelOffset,
        TDD_TPC_DownlinkStepSize,
        TDD_TPC_UplinkStepSize_LCR,
        _TDD_UL_Code_Information__item_,
        TDD_UL_Code_Information,
        _TDD_UL_Code_InformationItem_dPCH_ID,
        _TDD_UL_Code_InformationItem_tDD_ChannelisationCode,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__id,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_InformationItem_iE_Extensions__item_,
        _TDD_UL_Code_InformationItem_iE_Extensions,
        TDD_UL_Code_InformationItem,
        TDD_UL_Code_InformationItem_ExtIEs,
        _TDD_UL_Code_LCR_Information__item_,
        TDD_UL_Code_LCR_Information,
        _TDD_UL_Code_LCR_InformationItem_dPCH_ID,
        _TDD_UL_Code_LCR_InformationItem_tdd_ChannelisationCodeLCR,
        _TDD_UL_Code_LCR_InformationItem_tdd_UL_DPCH_TimeSlotFormat_LCR,
        ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__id,
        ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__criticality,
        ____TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_LCR_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_LCR_InformationItem_iE_Extensions__item_,
        _TDD_UL_Code_LCR_InformationItem_iE_Extensions,
        TDD_UL_Code_LCR_InformationItem,
        TDD_UL_Code_LCR_InformationItem_ExtIEs,
        _TDD_UL_Code_Information768__item_,
        TDD_UL_Code_Information768,
        _TDD_UL_Code_InformationItem768_dPCH_ID,
        _TDD_UL_Code_InformationItem768_tDD_ChannelisationCode768,
        ____TDD_UL_Code_InformationItem768_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_InformationItem768_iE_Extensions__item__id,
        ____TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_InformationItem768_iE_Extensions__item__criticality,
        ____TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_InformationItem768_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_InformationItem768_iE_Extensions__item_,
        _TDD_UL_Code_InformationItem768_iE_Extensions,
        TDD_UL_Code_InformationItem768,
        TDD_UL_Code_InformationItem768_ExtIEs,
        _TDD_UL_DPCH_TimeSlotFormat_LCR_qPSK,
        _TDD_UL_DPCH_TimeSlotFormat_LCR_eightPSK,
        TDD_UL_DPCH_TimeSlotFormat_LCR,
        QPSK_UL_DPCH_TimeSlotFormatTDD_LCR,
        EightPSK_UL_DPCH_TimeSlotFormatTDD_LCR,
        TFCI_Coding,
        TFCI_Presence,
        TFCI_SignallingMode,
        TGD,
        TGPRC,
        TGPSID,
        TGSN,
        TimeSlot,
        TimeSlotLCR,
        Time_Stamp,
        TimingAdvanceApplied,
        SynchronisationIndicator,
        _TMGI_plmn_id,
        _TMGI_service_id,
        ____TMGI_iE_Extensions__item__id_tab,
        ___TMGI_iE_Extensions__item__id,
        ____TMGI_iE_Extensions__item__criticality_tab,
        ___TMGI_iE_Extensions__item__criticality,
        ____TMGI_iE_Extensions__item__extensionValue_tab,
        ___TMGI_iE_Extensions__item__extensionValue,
        __TMGI_iE_Extensions__item_,
        _TMGI_iE_Extensions,
        TMGI,
        TMGI_ExtIEs,
        _TnlQos_dsField,
        _TnlQos_genericTrafficCategory,
        TnlQos,
        ToAWE,
        ToAWS,
        TraceDepth,
        TraceRecordingSessionReference,
        TraceReference,
        TrafficClass,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGSN,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGL1,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGL2,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGD,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1,
        __Transmission_Gap_Pattern_Sequence_Information__item__not_to_be_used_1,
        __Transmission_Gap_Pattern_Sequence_Information__item__uL_DL_mode,
        __Transmission_Gap_Pattern_Sequence_Information__item__downlink_Compressed_Mode_Method,
        __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method,
        __Transmission_Gap_Pattern_Sequence_Information__item__dL_FrameType,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR1,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after1,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR2,
        __Transmission_Gap_Pattern_Sequence_Information__item__delta_SIR_after2,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue,
        ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_,
        __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions,
        _Transmission_Gap_Pattern_Sequence_Information__item_,
        Transmission_Gap_Pattern_Sequence_Information,
        Transmission_Gap_Pattern_Sequence_Information_ExtIEs,
        Transmission_Gap_Pattern_Sequence_ScramblingCode_Information,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN,
        _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab,
        ______Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue,
        ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions,
        _Transmission_Gap_Pattern_Sequence_Status_List__item_,
        Transmission_Gap_Pattern_Sequence_Status_List,
        Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs,
        _Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs_val_Extension_0,
        _Affected_HSDSCH_Serving_Cell_List__item_,
        Affected_HSDSCH_Serving_Cell_List,
        TransmissionMode,
        _Transmission_Mode_Information__item_,
        Transmission_Mode_Information,
        _Transmission_Mode_Information_List_c_ID,
        _Transmission_Mode_Information_List_transmissionMode,
        ____Transmission_Mode_Information_List_iE_Extensions__item__id_tab,
        ___Transmission_Mode_Information_List_iE_Extensions__item__id,
        ____Transmission_Mode_Information_List_iE_Extensions__item__criticality_tab,
        ___Transmission_Mode_Information_List_iE_Extensions__item__criticality,
        ____Transmission_Mode_Information_List_iE_Extensions__item__extensionValue_tab,
        ___Transmission_Mode_Information_List_iE_Extensions__item__extensionValue,
        __Transmission_Mode_Information_List_iE_Extensions__item_,
        _Transmission_Mode_Information_List_iE_Extensions,
        Transmission_Mode_Information_List,
        Transmission_Mode_Information_List_ExtIEs,
        TransmissionTimeIntervalDynamic,
        TransmissionTimeIntervalSemiStatic,
        TransmitDiversityIndicator,
        Transmitted_Carrier_Power_Value,
        Transmitted_Carrier_Power_Value_IncrDecrThres,
        Transport_Block_Size_Index,
        _TUTRANGANSS_mS,
        _TUTRANGANSS_lS,
        TUTRANGANSS,
        TUTRANGANSSAccuracyClass,
        _TUTRANGANSSMeasurementThresholdInformation_tUTRANGANSSChangeLimit,
        _TUTRANGANSSMeasurementThresholdInformation_predictedTUTRANGANSSDeviationLimit,
        ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id_tab,
        ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__id,
        ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality_tab,
        ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__criticality,
        ____TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue_tab,
        ___TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item__extensionValue,
        __TUTRANGANSSMeasurementThresholdInformation_ie_Extensions__item_,
        _TUTRANGANSSMeasurementThresholdInformation_ie_Extensions,
        TUTRANGANSSMeasurementThresholdInformation,
        TUTRANGANSSMeasurementThresholdInformation_ExtIEs,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSS,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSQuality,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRate,
        _TUTRANGANSSMeasurementValueInformation_tUTRANGANSSDriftRateQuality,
        ____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab,
        _____TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id_tab_val_Extension_0,
        ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__id,
        ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__criticality,
        ___TUTRANGANSSMeasurementValueInformation_ie_Extensions__item__extensionValue,
        __TUTRANGANSSMeasurementValueInformation_ie_Extensions__item_,
        _TUTRANGANSSMeasurementValueInformation_ie_Extensions,
        TUTRANGANSSMeasurementValueInformation,
        TUTRANGANSSMeasurementValueInformation_ExtIEs,
        _TUTRANGANSSMeasurementValueInformation_ExtIEs_val_Extension_0,
        _TUTRANGPS_ms_part,
        _TUTRANGPS_ls_part,
        TUTRANGPS,
        TUTRANGPSChangeLimit,
        TUTRANGPSDriftRate,
        TUTRANGPSDriftRateQuality,
        TUTRANGPSAccuracyClass,
        _TUTRANGPSMeasurementThresholdInformation_tUTRANGPSChangeLimit,
        _TUTRANGPSMeasurementThresholdInformation_predictedTUTRANGPSDeviationLimit,
        ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id_tab,
        ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__id,
        ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality_tab,
        ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__criticality,
        ____TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue_tab,
        ___TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item__extensionValue,
        __TUTRANGPSMeasurementThresholdInformation_iE_Extensions__item_,
        _TUTRANGPSMeasurementThresholdInformation_iE_Extensions,
        TUTRANGPSMeasurementThresholdInformation,
        TUTRANGPSMeasurementThresholdInformation_ExtIEs,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPS,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPSQuality,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRate,
        _TUTRANGPSMeasurementValueInformation_tUTRANGPSDriftRateQuality,
        ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id_tab,
        ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__id,
        ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality_tab,
        ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__criticality,
        ____TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue_tab,
        ___TUTRANGPSMeasurementValueInformation_iEe_Extensions__item__extensionValue,
        __TUTRANGPSMeasurementValueInformation_iEe_Extensions__item_,
        _TUTRANGPSMeasurementValueInformation_iEe_Extensions,
        TUTRANGPSMeasurementValueInformation,
        TUTRANGPSMeasurementValueInformationItem_ExtIEs,
        TUTRANGPSQuality,
        TransportBearerID,
        TransportBearerRequestIndicator,
        TransportBearerNotRequestedIndicator,
        TransportBearerNotSetupIndicator,
        TransportBlockSize,
        __TransportFormatCombination_Beta_signalledGainFactors_betaC,
        __TransportFormatCombination_Beta_signalledGainFactors_betaD,
        __TransportFormatCombination_Beta_signalledGainFactors_refTFCNumber,
        _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id_tab,
        ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__id,
        _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality_tab,
        ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__criticality,
        _____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue_tab,
        ____TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item__extensionValue,
        ___TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions__item_,
        __TransportFormatCombination_Beta_signalledGainFactors_iE_Extensions,
        _TransportFormatCombination_Beta_signalledGainFactors,
        _TransportFormatCombination_Beta_refTFCNumber,
        TransportFormatCombination_Beta,
        SignalledGainFactors_ExtIEs,
        __TFCS_tFCSvalues_no_Split_in_TFCI,
        __TFCS_tFCSvalues_not_Used_split_in_TFCI,
        _TFCS_tFCSvalues,
        ____TFCS_iE_Extensions__item__id_tab,
        ___TFCS_iE_Extensions__item__id,
        ____TFCS_iE_Extensions__item__criticality_tab,
        ___TFCS_iE_Extensions__item__criticality,
        ____TFCS_iE_Extensions__item__extensionValue_tab,
        ___TFCS_iE_Extensions__item__extensionValue,
        __TFCS_iE_Extensions__item_,
        _TFCS_iE_Extensions,
        TFCS,
        TFCS_ExtIEs,
        __TFCS_TFCSList__item__cTFC,
        __TFCS_TFCSList__item__tFC_Beta,
        _____TFCS_TFCSList__item__iE_Extensions__item__id_tab,
        ______TFCS_TFCSList__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____TFCS_TFCSList__item__iE_Extensions__item__id,
        ____TFCS_TFCSList__item__iE_Extensions__item__criticality,
        ____TFCS_TFCSList__item__iE_Extensions__item__extensionValue,
        ___TFCS_TFCSList__item__iE_Extensions__item_,
        __TFCS_TFCSList__item__iE_Extensions,
        _TFCS_TFCSList__item_,
        TFCS_TFCSList,
        TFCS_TFCSList_ExtIEs,
        _TFCS_TFCSList_ExtIEs_val_Extension_0,
        _TFCS_CTFC_ctfc2bit,
        _TFCS_CTFC_ctfc4bit,
        _TFCS_CTFC_ctfc6bit,
        _TFCS_CTFC_ctfc8bit,
        _TFCS_CTFC_ctfc12bit,
        _TFCS_CTFC_ctfc16bit,
        _TFCS_CTFC_ctfcmaxbit,
        TFCS_CTFC,
        _TPC_slot_position_slot_position,
        ____TPC_slot_position_iE_Extensions__item__id_tab,
        ___TPC_slot_position_iE_Extensions__item__id,
        ____TPC_slot_position_iE_Extensions__item__criticality_tab,
        ___TPC_slot_position_iE_Extensions__item__criticality,
        ____TPC_slot_position_iE_Extensions__item__extensionValue_tab,
        ___TPC_slot_position_iE_Extensions__item__extensionValue,
        __TPC_slot_position_iE_Extensions__item_,
        _TPC_slot_position_iE_Extensions,
        TPC_slot_position,
        TPC_slot_position_ExtIEs,
        _TransportFormatSet_dynamicParts,
        _TransportFormatSet_semi_staticPart,
        ____TransportFormatSet_iE_Extensions__item__id_tab,
        ___TransportFormatSet_iE_Extensions__item__id,
        ____TransportFormatSet_iE_Extensions__item__criticality_tab,
        ___TransportFormatSet_iE_Extensions__item__criticality,
        ____TransportFormatSet_iE_Extensions__item__extensionValue_tab,
        ___TransportFormatSet_iE_Extensions__item__extensionValue,
        __TransportFormatSet_iE_Extensions__item_,
        _TransportFormatSet_iE_Extensions,
        TransportFormatSet,
        TransportFormatSet_ExtIEs,
        __TransportFormatSet_DynamicPartList__item__nrOfTransportBlocks,
        __TransportFormatSet_DynamicPartList__item__transportBlockSize,
        __TransportFormatSet_DynamicPartList__item__mode,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue,
        ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_,
        __TransportFormatSet_DynamicPartList__item__iE_Extensions,
        _TransportFormatSet_DynamicPartList__item_,
        TransportFormatSet_DynamicPartList,
        TransportFormatSet_DynamicPartList_ExtIEs,
        _TransportFormatSet_ModeDP_tdd,
        _TransportFormatSet_ModeDP_notApplicable,
        TransportFormatSet_ModeDP,
        _TDD_TransportFormatSet_ModeDP_transmissionTimeIntervalInformation,
        ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id_tab,
        ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__id,
        ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality_tab,
        ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__criticality,
        ____TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue_tab,
        ___TDD_TransportFormatSet_ModeDP_iE_Extensions__item__extensionValue,
        __TDD_TransportFormatSet_ModeDP_iE_Extensions__item_,
        _TDD_TransportFormatSet_ModeDP_iE_Extensions,
        TDD_TransportFormatSet_ModeDP,
        TDD_TransportFormatSet_ModeDP_ExtIEs,
        __TransmissionTimeIntervalInformation__item__transmissionTimeInterval,
        _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id_tab,
        ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__id,
        _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality_tab,
        ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__criticality,
        _____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue_tab,
        ____TransmissionTimeIntervalInformation__item__iE_Extensions__item__extensionValue,
        ___TransmissionTimeIntervalInformation__item__iE_Extensions__item_,
        __TransmissionTimeIntervalInformation__item__iE_Extensions,
        _TransmissionTimeIntervalInformation__item_,
        TransmissionTimeIntervalInformation,
        TransmissionTimeIntervalInformation_ExtIEs,
        Transmitted_Code_Power_Value,
        Transmitted_Code_Power_Value_IncrDecrThres,
        TransportFormatManagement,
        _TransportFormatSet_Semi_staticPart_transmissionTime,
        _TransportFormatSet_Semi_staticPart_channelCoding,
        _TransportFormatSet_Semi_staticPart_codingRate,
        _TransportFormatSet_Semi_staticPart_rateMatcingAttribute,
        _TransportFormatSet_Semi_staticPart_cRC_Size,
        _TransportFormatSet_Semi_staticPart_mode,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue,
        __TransportFormatSet_Semi_staticPart_iE_Extensions__item_,
        _TransportFormatSet_Semi_staticPart_iE_Extensions,
        TransportFormatSet_Semi_staticPart,
        TransportFormatSet_Semi_staticPart_ExtIEs,
        _TransportFormatSet_ModeSSP_tdd,
        _TransportFormatSet_ModeSSP_notApplicable,
        TransportFormatSet_ModeSSP,
        TransportLayerAddress,
        TrCH_SrcStatisticsDescr,
        TSN_Length,
        TSTD_Indicator,
        TSTD_Support_Indicator,
        _TTI_Update_Indicator_tTI_Update_CFN,
        _TTI_Update_Indicator_tTI_Update_Ind,
        TTI_Update_Indicator,
        TTI_Update_Ind,
        TxDiversityIndicator,
        TypeOfError,
        UARFCN,
        UDRE,
        UDREGrowthRate,
        UDREValidityTime,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink,
        UE_AggregateMaximumBitRate,
        UE_AggregateMaximumBitRateDownlink,
        UE_AggregateMaximumBitRateUplink,
        UE_AggregateMaximumBitRate_Enforcement_Indicator,
        _UE_Capabilities_Info_hSDSCH_Physical_Layer_Category,
        ____UE_Capabilities_Info_iE_Extensions__item__id_tab,
        _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_1,
        _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_2,
        _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_3,
        _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_4,
        _____UE_Capabilities_Info_iE_Extensions__item__id_tab_val_Extension_5,
        ___UE_Capabilities_Info_iE_Extensions__item__id,
        ___UE_Capabilities_Info_iE_Extensions__item__criticality,
        ___UE_Capabilities_Info_iE_Extensions__item__extensionValue,
        __UE_Capabilities_Info_iE_Extensions__item_,
        _UE_Capabilities_Info_iE_Extensions,
        UE_Capabilities_Info,
        UE_Capabilities_Info_ExtIEs,
        _UE_Capabilities_Info_ExtIEs_val_Extension_0,
        _UE_Capabilities_Info_ExtIEs_val_Extension_1,
        _UE_Capabilities_Info_ExtIEs_val_Extension_2,
        _UE_Capabilities_Info_ExtIEs_val_Extension_3,
        _UE_Capabilities_Info_ExtIEs_val_Extension_4,
        _UE_Capabilities_Info_ExtIEs_val_Extension_5,
        UE_Support_of_non_rectangular_resource_allocation,
        UE_TS0_CapabilityLCR,
        _UE_RF_Band_CapabilityLCR__item_,
        UE_RF_Band_CapabilityLCR,
        _Radio_Frequency_BandItem_radio_Frequency_Band,
        ____Radio_Frequency_BandItem_iE_Extensions__item__id_tab,
        ___Radio_Frequency_BandItem_iE_Extensions__item__id,
        ____Radio_Frequency_BandItem_iE_Extensions__item__criticality_tab,
        ___Radio_Frequency_BandItem_iE_Extensions__item__criticality,
        ____Radio_Frequency_BandItem_iE_Extensions__item__extensionValue_tab,
        ___Radio_Frequency_BandItem_iE_Extensions__item__extensionValue,
        __Radio_Frequency_BandItem_iE_Extensions__item_,
        _Radio_Frequency_BandItem_iE_Extensions,
        Radio_Frequency_BandItem,
        Radio_Frequency_Band,
        Radio_Frequency_BandItem_ExtIEs,
        LCRTDD_HSDSCH_Physical_Layer_Category,
        UE_DPCCH_burst1,
        UE_DPCCH_burst2,
        UE_DRX_Cycle_LCR,
        UE_DRX_Offset_LCR,
        UE_DRX_Cycle,
        UE_DRX_Grant_Monitoring,
        UE_DTX_Cycle1_2ms,
        UE_DTX_Cycle1_10ms,
        UE_DTX_Cycle2_2ms,
        UE_DTX_Cycle2_ext_2ms,
        UE_DTX_Cycle2_10ms,
        UE_DTX_DRX_Offset,
        UE_DTX_Long_Preamble,
        _UEIdentity_imsi,
        _UEIdentity_imei,
        _UEIdentity_imeisv,
        UEIdentity,
        UEMeasurementHysteresisTime,
        UEMeasurementParameterModAllow,
        _UEMeasurementReportCharacteristics_periodic,
        _UEMeasurementReportCharacteristics_event1h,
        _UEMeasurementReportCharacteristics_event1i,
        _UEMeasurementReportCharacteristics_event6a,
        _UEMeasurementReportCharacteristics_event6b,
        _UEMeasurementReportCharacteristics_event6c,
        _UEMeasurementReportCharacteristics_event6d,
        _UEMeasurementReportCharacteristics_extension_ReportCharacteristics,
        UEMeasurementReportCharacteristics,
        _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementTreshold,
        _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementTimeToTrigger,
        _UEMeasurementReportCharacteristicsEvent1h_uEMeasurementHysteresisTime,
        ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsEvent1h_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsEvent1h_iE_Extensions,
        UEMeasurementReportCharacteristicsEvent1h,
        UEMeasurementReportCharacteristicsEvent1h_ExtIEs,
        _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementTreshold,
        _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementTimeToTrigger,
        _UEMeasurementReportCharacteristicsEvent1i_uEMeasurementHysteresisTime,
        ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsEvent1i_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsEvent1i_iE_Extensions,
        UEMeasurementReportCharacteristicsEvent1i,
        UEMeasurementReportCharacteristicsEvent1i_ExtIEs,
        _UEMeasurementReportCharacteristicsEvent6a_uEMeasurementTreshold,
        _UEMeasurementReportCharacteristicsEvent6a_uEMeasurementTimeToTrigger,
        ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsEvent6a_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsEvent6a_iE_Extensions,
        UEMeasurementReportCharacteristicsEvent6a,
        UEMeasurementReportCharacteristicsEvent6a_ExtIEs,
        _UEMeasurementReportCharacteristicsEvent6b_uEMeasurementTreshold,
        _UEMeasurementReportCharacteristicsEvent6b_uEMeasurementTimeToTrigger,
        ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsEvent6b_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsEvent6b_iE_Extensions,
        UEMeasurementReportCharacteristicsEvent6b,
        UEMeasurementReportCharacteristicsEvent6b_ExtIEs,
        _UEMeasurementReportCharacteristicsEvent6c_uEMeasurementTimeToTrigger,
        ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsEvent6c_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsEvent6c_iE_Extensions,
        UEMeasurementReportCharacteristicsEvent6c,
        UEMeasurementReportCharacteristicsEvent6c_ExtIEs,
        _UEMeasurementReportCharacteristicsEvent6d_uEMeasurementTimeToTrigger,
        ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsEvent6d_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsEvent6d_iE_Extensions,
        UEMeasurementReportCharacteristicsEvent6d,
        UEMeasurementReportCharacteristicsEvent6d_ExtIEs,
        _UEMeasurementReportCharacteristicsPeriodic_amountofReporting,
        _UEMeasurementReportCharacteristicsPeriodic_reportingInterval,
        ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id_tab,
        ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__id,
        ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality_tab,
        ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__criticality,
        ____UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item__extensionValue,
        __UEMeasurementReportCharacteristicsPeriodic_iE_Extensions__item_,
        _UEMeasurementReportCharacteristicsPeriodic_iE_Extensions,
        UEMeasurementReportCharacteristicsPeriodic,
        UEMeasurementReportCharacteristicsPeriodicAmountofReporting,
        UEMeasurementReportCharacteristicsPeriodicReportingInterval,
        UEMeasurementReportCharacteristicsPeriodic_ExtIEs,
        __UEMeasurementReportCharacteristics_Extension_id_tab,
        _UEMeasurementReportCharacteristics_Extension_id,
        __UEMeasurementReportCharacteristics_Extension_criticality_tab,
        _UEMeasurementReportCharacteristics_Extension_criticality,
        __UEMeasurementReportCharacteristics_Extension_value_tab,
        _UEMeasurementReportCharacteristics_Extension_value,
        UEMeasurementReportCharacteristics_Extension,
        UEMeasurementReportCharacteristics_ExtensionIE,
        _UEMeasurementThreshold_timeslotISCP,
        _UEMeasurementThreshold_uETransmitPower,
        _UEMeasurementThreshold_extension_UEMeasurementThreshold,
        UEMeasurementThreshold,
        UEMeasurementThresholdDLTimeslotISCP,
        UEMeasurementThresholdUETransmitPower,
        __UEMeasurementThreshold_Extension_id_tab,
        _UEMeasurementThreshold_Extension_id,
        __UEMeasurementThreshold_Extension_criticality_tab,
        _UEMeasurementThreshold_Extension_criticality,
        __UEMeasurementThreshold_Extension_value_tab,
        _UEMeasurementThreshold_Extension_value,
        UEMeasurementThreshold_Extension,
        UEMeasurementThreshold_ExtensionIE,
        _UEMeasurementTimeslotInfoHCR__item_,
        UEMeasurementTimeslotInfoHCR,
        _UEMeasurementTimeslotInfoHCR_IEs_timeSlot,
        _UEMeasurementTimeslotInfoHCR_IEs_burstType,
        ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__id,
        ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions__item_,
        _UEMeasurementTimeslotInfoHCR_IEs_iE_Extensions,
        UEMeasurementTimeslotInfoHCR_IEs,
        UEMeasurementTimeslotInfoHCRBurstType,
        UEMeasurementTimeslotInfoHCR_IEs_ExtIEs,
        _UEMeasurementTimeslotInfoLCR__item_,
        UEMeasurementTimeslotInfoLCR,
        _UEMeasurementTimeslotInfoLCR_IEs_timeSlot,
        ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__id,
        ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions__item_,
        _UEMeasurementTimeslotInfoLCR_IEs_iE_Extensions,
        UEMeasurementTimeslotInfoLCR_IEs,
        UEMeasurementTimeslotInfoLCR_IEs_ExtIEs,
        _UEMeasurementTimeslotInfo768__item_,
        UEMeasurementTimeslotInfo768,
        _UEMeasurementTimeslotInfo768_IEs_timeSlot,
        _UEMeasurementTimeslotInfo768_IEs_burstType,
        ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__id,
        ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementTimeslotInfo768_IEs_iE_Extensions__item_,
        _UEMeasurementTimeslotInfo768_IEs_iE_Extensions,
        UEMeasurementTimeslotInfo768_IEs,
        UEMeasurementTimeslotInfo768BurstType,
        UEMeasurementTimeslotInfo768_IEs_ExtIEs,
        UEMeasurementTimeToTrigger,
        UEMeasurementType,
        _UEMeasurementValue_uE_Transmitted_Power,
        _UEMeasurementValue_primary_CCPCH_RSCP,
        _UEMeasurementValue_dL_Timeslot_ISCP,
        _UEMeasurementValue_extension_UEMeasurementValue,
        UEMeasurementValue,
        _UE_MeasurementValue_UE_Transmitted_Power_uEMeasurementTransmittedPowerListHCR,
        _UE_MeasurementValue_UE_Transmitted_Power_uEMeasurementTransmittedPowerListLCR,
        ____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab,
        _____UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id_tab_val_Extension_0,
        ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__id,
        ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__criticality,
        ___UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item__extensionValue,
        __UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions__item_,
        _UE_MeasurementValue_UE_Transmitted_Power_iE_Extensions,
        UE_MeasurementValue_UE_Transmitted_Power,
        UE_MeasurementValue_UE_Transmitted_Power_ExtIEs,
        _UE_MeasurementValue_UE_Transmitted_Power_ExtIEs_val_Extension_0,
        _UEMeasurementValueTransmittedPowerListHCR__item_,
        UEMeasurementValueTransmittedPowerListHCR,
        _UEMeasurementValueTransmittedPowerListHCR_IEs_timeSlot,
        _UEMeasurementValueTransmittedPowerListHCR_IEs_uETransmitPower,
        ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__id,
        ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions__item_,
        _UEMeasurementValueTransmittedPowerListHCR_IEs_iE_Extensions,
        UEMeasurementValueTransmittedPowerListHCR_IEs,
        UEMeasurementValueTransmittedPowerListHCR_IEs_ExtIEs,
        _UEMeasurementValueTransmittedPowerListLCR__item_,
        UEMeasurementValueTransmittedPowerListLCR,
        _UEMeasurementValueTransmittedPowerListLCR_IEs_timeSlotLCR,
        _UEMeasurementValueTransmittedPowerListLCR_IEs_uETransmitPower,
        ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__id,
        ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions__item_,
        _UEMeasurementValueTransmittedPowerListLCR_IEs_iE_Extensions,
        UEMeasurementValueTransmittedPowerListLCR_IEs,
        UEMeasurementValueTransmittedPowerListLCR_IEs_ExtIEs,
        _UEMeasurementValueTransmittedPowerList768__item_,
        UEMeasurementValueTransmittedPowerList768,
        _UEMeasurementValueTransmittedPowerList768_IEs_timeSlot,
        _UEMeasurementValueTransmittedPowerList768_IEs_uETransmitPower,
        ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__id,
        ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions__item_,
        _UEMeasurementValueTransmittedPowerList768_IEs_iE_Extensions,
        UEMeasurementValueTransmittedPowerList768_IEs,
        UEMeasurementValueTransmittedPowerList768_IEs_ExtIEs,
        _UE_MeasurementValue_Primary_CCPCH_RSCP_primaryCCPCH_RSCP,
        _UE_MeasurementValue_Primary_CCPCH_RSCP_primaryCCPCH_RSCP_Delta,
        ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id_tab,
        ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__id,
        ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality_tab,
        ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__criticality,
        ____UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue_tab,
        ___UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item__extensionValue,
        __UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions__item_,
        _UE_MeasurementValue_Primary_CCPCH_RSCP_iE_Extensions,
        UE_MeasurementValue_Primary_CCPCH_RSCP,
        UE_MeasurementValue_Primary_CCPCH_RSCP_ExtIEs,
        _UE_MeasurementValue_DL_Timeslot_ISCP_uEMeasurementTimeslotISCPListHCR,
        _UE_MeasurementValue_DL_Timeslot_ISCP_uEMeasurementTimeslotISCPListLCR,
        ____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab,
        _____UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id_tab_val_Extension_0,
        ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__id,
        ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__criticality,
        ___UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item__extensionValue,
        __UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions__item_,
        _UE_MeasurementValue_DL_Timeslot_ISCP_iE_Extensions,
        UE_MeasurementValue_DL_Timeslot_ISCP,
        UE_MeasurementValue_DL_Timeslot_ISCP_ExtIEs,
        _UE_MeasurementValue_DL_Timeslot_ISCP_ExtIEs_val_Extension_0,
        _UEMeasurementValueTimeslotISCPListHCR__item_,
        UEMeasurementValueTimeslotISCPListHCR,
        _UEMeasurementValueTimeslotISCPListHCR_IEs_timeSlot,
        _UEMeasurementValueTimeslotISCPListHCR_IEs_dL_TimeslotISCP,
        ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__id,
        ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions__item_,
        _UEMeasurementValueTimeslotISCPListHCR_IEs_iE_Extensions,
        UEMeasurementValueTimeslotISCPListHCR_IEs,
        UEMeasurementValueTimeslotISCPListHCR_IEs_ExtIEs,
        _UEMeasurementValueTimeslotISCPListLCR__item_,
        UEMeasurementValueTimeslotISCPListLCR,
        _UEMeasurementValueTimeslotISCPListLCR_IEs_timeSlotLCR,
        _UEMeasurementValueTimeslotISCPListLCR_IEs_dL_TimeslotISCP,
        ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__id,
        ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions__item_,
        _UEMeasurementValueTimeslotISCPListLCR_IEs_iE_Extensions,
        UEMeasurementValueTimeslotISCPListLCR_IEs,
        UEMeasurementValueTimeslotISCPListLCR_IEs_ExtIEs,
        _UEMeasurementValueTimeslotISCPList768__item_,
        UEMeasurementValueTimeslotISCPList768,
        _UEMeasurementValueTimeslotISCPList768_IEs_timeSlot,
        _UEMeasurementValueTimeslotISCPList768_IEs_dL_TimeslotISCP,
        ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id_tab,
        ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__id,
        ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality_tab,
        ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__criticality,
        ____UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item__extensionValue,
        __UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions__item_,
        _UEMeasurementValueTimeslotISCPList768_IEs_iE_Extensions,
        UEMeasurementValueTimeslotISCPList768_IEs,
        UEMeasurementValueTimeslotISCPList768_IEs_ExtIEs,
        __UEMeasurementValue_Extension_id_tab,
        _UEMeasurementValue_Extension_id,
        __UEMeasurementValue_Extension_criticality_tab,
        _UEMeasurementValue_Extension_criticality,
        __UEMeasurementValue_Extension_value_tab,
        _UEMeasurementValue_Extension_value,
        UEMeasurementValue_Extension,
        UEMeasurementValue_ExtensionIE,
        _UEMeasurementValueInformation_measurementAvailable,
        _UEMeasurementValueInformation_measurementnotAvailable,
        UEMeasurementValueInformation,
        _UEMeasurementValueInformationAvailable_uEmeasurementValue,
        ____UEMeasurementValueInformationAvailable_ie_Extensions__item__id_tab,
        ___UEMeasurementValueInformationAvailable_ie_Extensions__item__id,
        ____UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality_tab,
        ___UEMeasurementValueInformationAvailable_ie_Extensions__item__criticality,
        ____UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue_tab,
        ___UEMeasurementValueInformationAvailable_ie_Extensions__item__extensionValue,
        __UEMeasurementValueInformationAvailable_ie_Extensions__item_,
        _UEMeasurementValueInformationAvailable_ie_Extensions,
        UEMeasurementValueInformationAvailable,
        UEMeasurementValueInformationAvailableItem_ExtIEs,
        UEMeasurementValueInformationnotAvailable,
        _UE_Measurement_Value_uPHFiltering_Value,
        _UE_Measurement_Value_extension_UE_Measurement_Value,
        UE_Measurement_Value,
        __Extension_UE_Measurement_Value_id_tab,
        _Extension_UE_Measurement_Value_id,
        __Extension_UE_Measurement_Value_criticality_tab,
        _Extension_UE_Measurement_Value_criticality,
        __Extension_UE_Measurement_Value_value_tab,
        _Extension_UE_Measurement_Value_value,
        Extension_UE_Measurement_Value,
        Extension_UE_Measurement_ValueIE,
        UPHFiltering_Value,
        UPH_Filtering_Measurement_Forwarding_Request,
        UE_SupportIndicatorExtension,
        _UE_State_cell_fach_pch,
        _UE_State_ura_pch,
        UE_State,
        UE_transmission_power_headroom_Value,
        _Cell_Fach_Pch_State_d_RNTI,
        ____Cell_Fach_Pch_State_iE_Extensions__item__id_tab,
        ___Cell_Fach_Pch_State_iE_Extensions__item__id,
        ____Cell_Fach_Pch_State_iE_Extensions__item__criticality_tab,
        ___Cell_Fach_Pch_State_iE_Extensions__item__criticality,
        ____Cell_Fach_Pch_State_iE_Extensions__item__extensionValue_tab,
        ___Cell_Fach_Pch_State_iE_Extensions__item__extensionValue,
        __Cell_Fach_Pch_State_iE_Extensions__item_,
        _Cell_Fach_Pch_State_iE_Extensions,
        Cell_Fach_Pch_State,
        Cell_Fach_Pch_State_ExtIEs,
        _Ura_Pch_State_srnc_id,
        _Ura_Pch_State_ura_id,
        ____Ura_Pch_State_iE_Extensions__item__id_tab,
        _____Ura_Pch_State_iE_Extensions__item__id_tab_val_Extension_0,
        ___Ura_Pch_State_iE_Extensions__item__id,
        ___Ura_Pch_State_iE_Extensions__item__criticality,
        ___Ura_Pch_State_iE_Extensions__item__extensionValue,
        __Ura_Pch_State_iE_Extensions__item_,
        _Ura_Pch_State_iE_Extensions,
        Ura_Pch_State,
        Ura_Pch_State_ExtIEs,
        _Ura_Pch_State_ExtIEs_val_Extension_0,
        UL_Delta_T2TP,
        UL_DL_mode,
        UL_DPDCHIndicatorEDCH,
        _UL_Timeslot_Information__item_,
        UL_Timeslot_Information,
        _UL_Timeslot_InformationItem_timeSlot,
        _UL_Timeslot_InformationItem_midambleShiftAndBurstType,
        _UL_Timeslot_InformationItem_tFCI_Presence,
        _UL_Timeslot_InformationItem_uL_Code_Information,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__id,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationItem_iE_Extensions__item_,
        _UL_Timeslot_InformationItem_iE_Extensions,
        UL_Timeslot_InformationItem,
        UL_Timeslot_InformationItem_ExtIEs,
        _UL_TimeslotLCR_Information__item_,
        UL_TimeslotLCR_Information,
        _UL_TimeslotLCR_InformationItem_timeSlotLCR,
        _UL_TimeslotLCR_InformationItem_midambleShiftLCR,
        _UL_TimeslotLCR_InformationItem_tFCI_Presence,
        _UL_TimeslotLCR_InformationItem_uL_Code_LCR_InformationList,
        ____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab,
        _____UL_TimeslotLCR_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__id,
        ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__criticality,
        ___UL_TimeslotLCR_InformationItem_iE_Extensions__item__extensionValue,
        __UL_TimeslotLCR_InformationItem_iE_Extensions__item_,
        _UL_TimeslotLCR_InformationItem_iE_Extensions,
        UL_TimeslotLCR_InformationItem,
        UL_TimeslotLCR_InformationItem_ExtIEs,
        _UL_TimeslotLCR_InformationItem_ExtIEs_val_Extension_0,
        _PLCCHinformation_tDD_ChannelisationCode,
        _PLCCHinformation_timeSlotLCR,
        _PLCCHinformation_midambleShiftLCR,
        _PLCCHinformation_sequenceNumber,
        ____PLCCHinformation_iE_Extensions__item__id_tab,
        ___PLCCHinformation_iE_Extensions__item__id,
        ____PLCCHinformation_iE_Extensions__item__criticality_tab,
        ___PLCCHinformation_iE_Extensions__item__criticality,
        ____PLCCHinformation_iE_Extensions__item__extensionValue_tab,
        ___PLCCHinformation_iE_Extensions__item__extensionValue,
        __PLCCHinformation_iE_Extensions__item_,
        _PLCCHinformation_iE_Extensions,
        PLCCHinformation,
        PLCCHinformation_ExtIEs,
        _UL_Timeslot_Information768__item_,
        UL_Timeslot_Information768,
        _UL_Timeslot_InformationItem768_timeSlot,
        _UL_Timeslot_InformationItem768_midambleShiftAndBurstType768,
        _UL_Timeslot_InformationItem768_tFCI_Presence,
        _UL_Timeslot_InformationItem768_uL_Code_Information768,
        ____UL_Timeslot_InformationItem768_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationItem768_iE_Extensions__item__id,
        ____UL_Timeslot_InformationItem768_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationItem768_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationItem768_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationItem768_iE_Extensions__item_,
        _UL_Timeslot_InformationItem768_iE_Extensions,
        UL_Timeslot_InformationItem768,
        UL_Timeslot_InformationItem768_ExtIEs,
        _UL_TimeSlot_ISCP_Info__item_,
        UL_TimeSlot_ISCP_Info,
        _UL_TimeSlot_ISCP_InfoItem_timeSlot,
        _UL_TimeSlot_ISCP_InfoItem_uL_TimeslotISCP,
        ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id_tab,
        ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__id,
        ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality_tab,
        ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__criticality,
        ____UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item__extensionValue,
        __UL_TimeSlot_ISCP_InfoItem_iE_Extensions__item_,
        _UL_TimeSlot_ISCP_InfoItem_iE_Extensions,
        UL_TimeSlot_ISCP_InfoItem,
        UL_TimeSlot_ISCP_InfoItem_ExtIEs,
        _UL_TimeSlot_ISCP_LCR_Info__item_,
        UL_TimeSlot_ISCP_LCR_Info,
        _UL_TimeSlot_ISCP_LCR_InfoItem_timeSlotLCR,
        _UL_TimeSlot_ISCP_LCR_InfoItem_iSCP,
        ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id_tab,
        ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__id,
        ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality_tab,
        ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__criticality,
        ____UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue_tab,
        ___UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item__extensionValue,
        __UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions__item_,
        _UL_TimeSlot_ISCP_LCR_InfoItem_iE_Extensions,
        UL_TimeSlot_ISCP_LCR_InfoItem,
        UL_TimeSlot_ISCP_LCR_InfoItem_ExtIEs,
        UL_Timeslot_ISCP_Value,
        UL_Timeslot_ISCP_Value_IncrDecrThres,
        _UL_TimingAdvanceCtrl_LCR_sync_UL_codes_bitmap,
        _UL_TimingAdvanceCtrl_LCR_fPACH_info,
        _UL_TimingAdvanceCtrl_LCR_prxUpPCHdes,
        _UL_TimingAdvanceCtrl_LCR_syncUL_procParameter,
        _UL_TimingAdvanceCtrl_LCR_mMax,
        UL_TimingAdvanceCtrl_LCR,
        Uplink_Compressed_Mode_Method,
        UL_SIR,
        _UC_ID_rNC_ID,
        _UC_ID_c_ID,
        ____UC_ID_iE_Extensions__item__id_tab,
        _____UC_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___UC_ID_iE_Extensions__item__id,
        ___UC_ID_iE_Extensions__item__criticality,
        ___UC_ID_iE_Extensions__item__extensionValue,
        __UC_ID_iE_Extensions__item_,
        _UC_ID_iE_Extensions,
        UC_ID,
        UC_ID_ExtIEs,
        _UC_ID_ExtIEs_val_Extension_0,
        UL_DPCCH_SlotFormat,
        UL_FP_Mode,
        UL_PhysCH_SF_Variation,
        _UL_ScramblingCode_ul_ScramblingCodeNumber,
        _UL_ScramblingCode_ul_ScramblingCodeLength,
        ____UL_ScramblingCode_iE_Extensions__item__id_tab,
        ___UL_ScramblingCode_iE_Extensions__item__id,
        ____UL_ScramblingCode_iE_Extensions__item__criticality_tab,
        ___UL_ScramblingCode_iE_Extensions__item__criticality,
        ____UL_ScramblingCode_iE_Extensions__item__extensionValue_tab,
        ___UL_ScramblingCode_iE_Extensions__item__extensionValue,
        __UL_ScramblingCode_iE_Extensions__item_,
        _UL_ScramblingCode_iE_Extensions,
        UL_ScramblingCode,
        UL_ScramblingCode_ExtIEs,
        UL_ScramblingCodeLength,
        UL_ScramblingCodeNumber,
        _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_StepSize,
        _UL_Synchronisation_Parameters_LCR_uL_Synchronisation_Frequency,
        ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id_tab,
        ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__id,
        ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality_tab,
        ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__criticality,
        ____UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue_tab,
        ___UL_Synchronisation_Parameters_LCR_iE_Extensions__item__extensionValue,
        __UL_Synchronisation_Parameters_LCR_iE_Extensions__item_,
        _UL_Synchronisation_Parameters_LCR_iE_Extensions,
        UL_Synchronisation_Parameters_LCR,
        UL_Synchronisation_Parameters_LCR_ExtIEs,
        UL_Synchronisation_StepSize,
        UL_Synchronisation_Frequency,
        UL_TimeslotISCP,
        UPPCHPositionLCR,
        UpPTSInterferenceValue,
        Unidirectional_DCH_Indicator,
        URA_ID,
        _URA_Information_uRA_ID,
        _URA_Information_multipleURAsIndicator,
        _URA_Information_rNCsWithCellsInTheAccessedURA_List,
        ____URA_Information_iE_Extensions__item__id_tab,
        ___URA_Information_iE_Extensions__item__id,
        ____URA_Information_iE_Extensions__item__criticality_tab,
        ___URA_Information_iE_Extensions__item__criticality,
        ____URA_Information_iE_Extensions__item__extensionValue_tab,
        ___URA_Information_iE_Extensions__item__extensionValue,
        __URA_Information_iE_Extensions__item_,
        _URA_Information_iE_Extensions,
        URA_Information,
        URA_Information_ExtIEs,
        _RNCsWithCellsInTheAccessedURA_List__item_,
        RNCsWithCellsInTheAccessedURA_List,
        _RNCsWithCellsInTheAccessedURA_Item_rNC_ID,
        ____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab,
        _____RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id_tab_val_Extension_0,
        ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__id,
        ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__criticality,
        ___RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item__extensionValue,
        __RNCsWithCellsInTheAccessedURA_Item_iE_Extensions__item_,
        _RNCsWithCellsInTheAccessedURA_Item_iE_Extensions,
        RNCsWithCellsInTheAccessedURA_Item,
        RNCsWithCellsInTheAccessedURA_Item_ExtIEs,
        _RNCsWithCellsInTheAccessedURA_Item_ExtIEs_val_Extension_0,
        USCH_ID,
        _USCH_Information__item_,
        USCH_Information,
        _USCH_InformationItem_uSCH_ID,
        _USCH_InformationItem_ul_CCTrCH_ID,
        _USCH_InformationItem_trChSourceStatisticsDescriptor,
        _USCH_InformationItem_transportFormatSet,
        _USCH_InformationItem_allocationRetentionPriority,
        _USCH_InformationItem_schedulingPriorityIndicator,
        _USCH_InformationItem_rb_Info,
        ____USCH_InformationItem_iE_Extensions__item__id_tab,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_1,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_2,
        _____USCH_InformationItem_iE_Extensions__item__id_tab_val_Extension_3,
        ___USCH_InformationItem_iE_Extensions__item__id,
        ___USCH_InformationItem_iE_Extensions__item__criticality,
        ___USCH_InformationItem_iE_Extensions__item__extensionValue,
        __USCH_InformationItem_iE_Extensions__item_,
        _USCH_InformationItem_iE_Extensions,
        USCH_InformationItem,
        USCH_InformationItem_ExtIEs,
        _USCH_InformationItem_ExtIEs_val_Extension_0,
        _USCH_InformationItem_ExtIEs_val_Extension_1,
        _USCH_InformationItem_ExtIEs_val_Extension_2,
        _USCH_InformationItem_ExtIEs_val_Extension_3,
        Usefulness_Of_Battery_Optimization,
        User_Plane_Congestion_Fields_Inclusion,
        Uu_ActivationState,
        ___UMTS_Cells_Info_List__item__id_tab,
        ____UMTS_Cells_Info_List__item__id_tab_val_Value_0,
        __UMTS_Cells_Info_List__item__id,
        __UMTS_Cells_Info_List__item__criticality,
        __UMTS_Cells_Info_List__item__value,
        _UMTS_Cells_Info_List__item_,
        UMTS_Cells_Info_List,
        UMTS_Cells_Info_IEs,
        _UMTS_Cells_Info_IEs_val_Value_0,
        _UMTS_Cell_Info_c_ID,
        ____UMTS_Cell_Info_iE_Extensions__item__id_tab,
        ___UMTS_Cell_Info_iE_Extensions__item__id,
        ____UMTS_Cell_Info_iE_Extensions__item__criticality_tab,
        ___UMTS_Cell_Info_iE_Extensions__item__criticality,
        ____UMTS_Cell_Info_iE_Extensions__item__extensionValue_tab,
        ___UMTS_Cell_Info_iE_Extensions__item__extensionValue,
        __UMTS_Cell_Info_iE_Extensions__item_,
        _UMTS_Cell_Info_iE_Extensions,
        UMTS_Cell_Info,
        UMTS_Cell_Info_ExtIEs,
        _UL_CLTD_Information_sDPCCH_PowerOffsetInformation,
        _UL_CLTD_Information_c_ID,
        _UL_CLTD_Information_uL_CLTD_Activation_Information,
        ____UL_CLTD_Information_iE_Extensions__item__id_tab,
        ___UL_CLTD_Information_iE_Extensions__item__id,
        ____UL_CLTD_Information_iE_Extensions__item__criticality_tab,
        ___UL_CLTD_Information_iE_Extensions__item__criticality,
        ____UL_CLTD_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_CLTD_Information_iE_Extensions__item__extensionValue,
        __UL_CLTD_Information_iE_Extensions__item_,
        _UL_CLTD_Information_iE_Extensions,
        UL_CLTD_Information,
        UL_CLTD_Info_ExtIEs,
        _UL_CLTD_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_CLTD,
        ____UL_CLTD_Information_Reconf_iE_Extensions__item__id_tab,
        ___UL_CLTD_Information_Reconf_iE_Extensions__item__id,
        ____UL_CLTD_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___UL_CLTD_Information_Reconf_iE_Extensions__item__criticality,
        ____UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___UL_CLTD_Information_Reconf_iE_Extensions__item__extensionValue,
        __UL_CLTD_Information_Reconf_iE_Extensions__item_,
        _UL_CLTD_Information_Reconf_iE_Extensions,
        UL_CLTD_Information_Reconf,
        UL_CLTD_Information_Reconf_ExtIEs,
        _UL_CLTD_Information_To_Modify_sDPCCH_PowerOffsetInformation,
        _UL_CLTD_Information_To_Modify_c_ID,
        _UL_CLTD_Information_To_Modify_uL_CLTD_Activation_Information,
        ____UL_CLTD_Information_To_Modify_iE_Extensions__item__id_tab,
        ___UL_CLTD_Information_To_Modify_iE_Extensions__item__id,
        ____UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___UL_CLTD_Information_To_Modify_iE_Extensions__item__criticality,
        ____UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___UL_CLTD_Information_To_Modify_iE_Extensions__item__extensionValue,
        __UL_CLTD_Information_To_Modify_iE_Extensions__item_,
        _UL_CLTD_Information_To_Modify_iE_Extensions,
        UL_CLTD_Information_To_Modify,
        UL_CLTD_Information_To_Modify_ExtIEs,
        UL_CLTD_Information_Removal,
        UL_CLTD_State_Update_Information,
        _UL_DPCCH2_Information_f_DPCH_Info,
        ____UL_DPCCH2_Information_iE_Extensions__item__id_tab,
        ___UL_DPCCH2_Information_iE_Extensions__item__id,
        ____UL_DPCCH2_Information_iE_Extensions__item__criticality_tab,
        ___UL_DPCCH2_Information_iE_Extensions__item__criticality,
        ____UL_DPCCH2_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCCH2_Information_iE_Extensions__item__extensionValue,
        __UL_DPCCH2_Information_iE_Extensions__item_,
        _UL_DPCCH2_Information_iE_Extensions,
        UL_DPCCH2_Information,
        UL_DPCCH2_Information_ExtIEs,
        _UL_DPCCH2_Information_Reconf_setup_Or_ConfigurationChange_Or_Removal_Of_UL_DPCCH2,
        ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__id_tab,
        ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__id,
        ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality_tab,
        ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__criticality,
        ____UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCCH2_Information_Reconf_iE_Extensions__item__extensionValue,
        __UL_DPCCH2_Information_Reconf_iE_Extensions__item_,
        _UL_DPCCH2_Information_Reconf_iE_Extensions,
        UL_DPCCH2_Information_Reconf,
        UL_DPCCH2_Information_Reconf_ExtIEs,
        UL_DPCCH2_Information_Removal,
        _UL_DPCCH2_Information_To_Modify_f_DPCH_Info,
        ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id_tab,
        ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__id,
        ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__criticality,
        ____UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCCH2_Information_To_Modify_iE_Extensions__item__extensionValue,
        __UL_DPCCH2_Information_To_Modify_iE_Extensions__item_,
        _UL_DPCCH2_Information_To_Modify_iE_Extensions,
        UL_DPCCH2_Information_To_Modify,
        UL_DPCCH2_Information_To_Modify_ExtIEs,
        UL_CLTD_Activation_Information,
        _UL_MIMO_Information_e_roch_power_offset,
        _UL_MIMO_Information_s_e_dpcch_power_offset,
        _UL_MIMO_Information_interstream_compensation,
        _UL_MIMO_Information_minimum_E_TFCI_rank2,
        ____UL_MIMO_Information_iE_Extensions__item__id_tab,
        ___UL_MIMO_Information_iE_Extensions__item__id,
        ____UL_MIMO_Information_iE_Extensions__item__criticality_tab,
        ___UL_MIMO_Information_iE_Extensions__item__criticality,
        ____UL_MIMO_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_MIMO_Information_iE_Extensions__item__extensionValue,
        __UL_MIMO_Information_iE_Extensions__item_,
        _UL_MIMO_Information_iE_Extensions,
        UL_MIMO_Information,
        UL_MIMO_Information_ExtIEs,
        _UL_MIMO_Information_To_Modify_e_roch_power_offset,
        _UL_MIMO_Information_To_Modify_s_e_dpcch_power_offset,
        _UL_MIMO_Information_To_Modify_interstream_compensation,
        _UL_MIMO_Information_To_Modify_minimum_E_TFCI_rank2,
        ____UL_MIMO_Information_To_Modify_iE_Extensions__item__id_tab,
        ___UL_MIMO_Information_To_Modify_iE_Extensions__item__id,
        ____UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality_tab,
        ___UL_MIMO_Information_To_Modify_iE_Extensions__item__criticality,
        ____UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue_tab,
        ___UL_MIMO_Information_To_Modify_iE_Extensions__item__extensionValue,
        __UL_MIMO_Information_To_Modify_iE_Extensions__item_,
        _UL_MIMO_Information_To_Modify_iE_Extensions,
        UL_MIMO_Information_To_Modify,
        UL_MIMO_Information_To_Modify_ExtIEs,
        _UL_MIMO_Reconfiguration_setup,
        _UL_MIMO_Reconfiguration_configurationChange,
        _UL_MIMO_Reconfiguration_removal,
        UL_MIMO_Reconfiguration,
        UL_MIMO_Removal,
        _UL_MIMO_DL_Control_Channel_Information_e_roch_channelization_code,
        _UL_MIMO_DL_Control_Channel_Information_s_e_rnti,
        _UL_MIMO_DL_Control_Channel_Information_s_signature_sequence,
        _UL_MIMO_DL_Control_Channel_Information_s_e_roch_release_indicator,
        ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id_tab,
        ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__id,
        ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality_tab,
        ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__criticality,
        ____UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue_tab,
        ___UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item__extensionValue,
        __UL_MIMO_DL_Control_Channel_Information_iE_Extensions__item_,
        _UL_MIMO_DL_Control_Channel_Information_iE_Extensions,
        UL_MIMO_DL_Control_Channel_Information,
        UL_MIMO_DL_Control_Channel_Information_ExtIEs,
    ]

class RNSAP_PDU_Contents:

    _name_  = u'RNSAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 1, 1, 1]
    
    _obj_ = [
        u'RadioLinkSetupRequestFDD',
        u'RadioLinkSetupRequestFDD-IEs',
        u'UL-DPCH-Information-RL-SetupRqstFDD',
        u'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'DL-DPCH-Information-RL-SetupRqstFDD',
        u'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'PowerOffsetInformation-RL-SetupRqstFDD',
        u'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs',
        u'RL-InformationList-RL-SetupRqstFDD',
        u'RL-InformationItemIEs-RL-SetupRqstFDD',
        u'RL-InformationItem-RL-SetupRqstFDD',
        u'RL-InformationItem-RL-SetupRqstFDD-ExtIEs',
        u'RadioLinkSetupRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Setup-List',
        u'Additional-HS-Cell-Information-RL-Setup-ItemIEs',
        u'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs',
        u'F-DPCH-Information-RL-SetupRqstFDD',
        u'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD',
        u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs',
        u'RadioLinkSetupRequestTDD',
        u'RadioLinkSetupRequestTDD-IEs',
        u'UL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'UL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'DL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'DL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'CCTrCH-TPCList-RL-SetupRqstTDD',
        u'CCTrCH-TPCItem-RL-SetupRqstTDD',
        u'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs',
        u'RL-Information-RL-SetupRqstTDD',
        u'RL-Information-RL-SetupRqstTDD-ExtIEs',
        u'RadioLinkSetupRequestTDD-Extensions',
        u'RadioLinkSetupResponseFDD',
        u'RadioLinkSetupResponseFDD-IEs',
        u'RL-InformationResponseList-RL-SetupRspFDD',
        u'RL-InformationResponseItemIEs-RL-SetupRspFDD',
        u'RL-InformationResponseItem-RL-SetupRspFDD',
        u'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs',
        u'DiversityIndication-RL-SetupRspFDD',
        u'Combining-RL-SetupRspFDD',
        u'CombiningItem-RL-SetupRspFDD-ExtIEs',
        u'NonCombiningOrFirstRL-RL-SetupRspFDD',
        u'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs',
        u'RadioLinkSetupResponseFDD-Extensions',
        u'Additional-HS-Cell-Information-Response-List',
        u'Additional-HS-Cell-Information-Response-ItemIEs',
        u'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs',
        u'RadioLinkSetupResponseTDD',
        u'RadioLinkSetupResponseTDD-IEs',
        u'RL-InformationResponse-RL-SetupRspTDD',
        u'RL-InformationResponse-RL-SetupRspTDD-ExtIEs',
        u'UL-CCTrCHInformationList-RL-SetupRspTDD',
        u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'UL-CCTrCHInformationListIE-RL-SetupRspTDD',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'UL-DPCH-InformationList-RL-SetupRspTDD',
        u'UL-DPCH-InformationListIEs-RL-SetupRspTDD',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-CCTrCHInformationList-RL-SetupRspTDD',
        u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'DL-CCTrCHInformationListIE-RL-SetupRspTDD',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-DPCH-InformationList-RL-SetupRspTDD',
        u'DL-DPCH-InformationListIEs-RL-SetupRspTDD',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DCH-InformationResponseList-RL-SetupRspTDD',
        u'DCH-InformationResponseListIEs-RL-SetupRspTDD',
        u'DSCH-InformationResponse-RL-SetupRspTDD',
        u'DSCH-InformationList-RL-SetupRspTDD',
        u'DSCH-InformationListIEs-RL-SetupRspTDD',
        u'DSCHInformationItem-RL-SetupRspTDD',
        u'DSCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'USCH-InformationResponse-RL-SetupRspTDD',
        u'USCH-InformationList-RL-SetupRspTDD',
        u'USCH-InformationListIEs-RL-SetupRspTDD',
        u'USCHInformationItem-RL-SetupRspTDD',
        u'USCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'RadioLinkSetupResponseTDD-Extensions',
        u'RL-LCR-InformationResponse-RL-SetupRspTDD',
        u'RL-LCR-InformationResponseList-RL-SetupRspTDD-ExtIEs',
        u'UL-LCR-CCTrCHInformationList-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationList-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-LCR-CCTrCHInformationList-RL-SetupRspTDD',
        u'DL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationList-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DSCH-LCR-InformationResponse-RL-SetupRspTDD',
        u'DSCH-LCR-InformationList-RL-SetupRspTDD',
        u'DSCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'DSCH-LCR-InformationItem-RL-SetupRspTDD',
        u'DSCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'USCH-LCR-InformationResponse-RL-SetupRspTDD',
        u'USCH-LCR-InformationList-RL-SetupRspTDD',
        u'USCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'USCH-LCR-InformationItem-RL-SetupRspTDD',
        u'USCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'RL-InformationResponse-RL-SetupRspTDD768',
        u'RL-InformationResponse-RL-SetupRspTDD768-ExtIEs',
        u'UL-CCTrCHInformationList-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationListIE-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs',
        u'UL-DPCH-InformationList-RL-SetupRspTDD768',
        u'UL-DPCH-InformationListIEs-RL-SetupRspTDD768',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs',
        u'DL-CCTrCHInformationList-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationListIE-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs',
        u'DL-DPCH-InformationList-RL-SetupRspTDD768',
        u'DL-DPCH-InformationListIEs-RL-SetupRspTDD768',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs',
        u'RadioLinkSetupFailureFDD',
        u'RadioLinkSetupFailureFDD-IEs',
        u'CauseLevel-RL-SetupFailureFDD',
        u'GeneralCauseList-RL-SetupFailureFDD',
        u'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs',
        u'RLSpecificCauseList-RL-SetupFailureFDD',
        u'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs',
        u'UnsuccessfulRL-InformationResponseList-RL-SetupFailureFDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs',
        u'SuccessfulRL-InformationResponseList-RL-SetupFailureFDD',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs',
        u'DiversityIndication-RL-SetupFailureFDD',
        u'Combining-RL-SetupFailureFDD',
        u'CombiningItem-RL-SetupFailureFDD-ExtIEs',
        u'NonCombiningOrFirstRL-RL-SetupFailureFDD',
        u'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs',
        u'RadioLinkSetupFailureFDD-Extensions',
        u'RadioLinkSetupFailureTDD',
        u'RadioLinkSetupFailureTDD-IEs',
        u'CauseLevel-RL-SetupFailureTDD',
        u'GeneralCauseList-RL-SetupFailureTDD',
        u'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs',
        u'RLSpecificCauseList-RL-SetupFailureTDD',
        u'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs',
        u'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD',
        u'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD-ExtIEs',
        u'RadioLinkSetupFailureTDD-Extensions',
        u'RadioLinkAdditionRequestFDD',
        u'RadioLinkAdditionRequestFDD-IEs',
        u'RL-InformationList-RL-AdditionRqstFDD',
        u'RL-Information-RL-AdditionRqstFDD-IEs',
        u'RL-Information-RL-AdditionRqstFDD',
        u'RL-Information-RL-AdditionRqstFDD-ExtIEs',
        u'RadioLinkAdditionRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Addition-List',
        u'Additional-HS-Cell-Information-RL-Addition-ItemIEs',
        u'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Add-Req',
        u'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs',
        u'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency',
        u'EDPCH-Information-RLAdditionReq-FDD',
        u'EDPCH-Information-RLAdditionReq-FDD-ExtIEs',
        u'RadioLinkAdditionRequestTDD',
        u'RadioLinkAdditionRequestTDD-IEs',
        u'RL-Information-RL-AdditionRqstTDD',
        u'RL-Information-RL-AdditionRqstTDD-ExtIEs',
        u'RadioLinkAdditionRequestTDD-Extensions',
        u'UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        u'RadioLinkAdditionResponseFDD',
        u'RadioLinkAdditionResponseFDD-IEs',
        u'RL-InformationResponseList-RL-AdditionRspFDD',
        u'RL-InformationResponseItemIEs-RL-AdditionRspFDD',
        u'RL-InformationResponseItem-RL-AdditionRspFDD',
        u'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs',
        u'DL-CodeInformationList-RL-AdditionRspFDD',
        u'DL-CodeInformationListIEs-RL-AdditionRspFDD',
        u'DiversityIndication-RL-AdditionRspFDD',
        u'Combining-RL-AdditionRspFDD',
        u'CombiningItem-RL-AdditionRspFDD-ExtIEs',
        u'NonCombining-RL-AdditionRspFDD',
        u'NonCombiningItem-RL-AdditionRspFDD-ExtIEs',
        u'RadioLinkAdditionResponseFDD-Extensions',
        u'Additional-HS-Cell-Change-Information-Response-List',
        u'Additional-HS-Cell-Change-Information-Response-ItemIEs',
        u'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs',
        u'RadioLinkAdditionResponseTDD',
        u'RadioLinkAdditionResponseTDD-IEs',
        u'RL-InformationResponse-RL-AdditionRspTDD',
        u'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs',
        u'UL-CCTrCHInformationList-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationListIE-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'UL-DPCH-InformationList-RL-AdditionRspTDD',
        u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-CCTrCHInformationList-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationListIE-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-DPCH-InformationList-RL-AdditionRspTDD',
        u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DCH-Information-RL-AdditionRspTDD',
        u'DCH-Information-RL-AdditionRspTDD-ExtIEs',
        u'DiversityIndication-RL-AdditionRspTDD',
        u'Combining-RL-AdditionRspTDD',
        u'CombiningItem-RL-AdditionRspTDD-ExtIEs',
        u'NonCombining-RL-AdditionRspTDD',
        u'NonCombiningItem-RL-AdditionRspTDD-ExtIEs',
        u'DSCH-InformationResponse-RL-AdditionRspTDD',
        u'DSCH-InformationListIEs-RL-AdditionRspTDD',
        u'DSCH-InformationListIE-RL-AdditionRspTDD',
        u'DSCHInformationItem-RL-AdditionRspTDD',
        u'DSCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DiversityIndication-RL-AdditionRspTDD2',
        u'DiversityIndication-RL-AdditionRspTDD2-ExtIEs',
        u'USCH-InformationResponse-RL-AdditionRspTDD',
        u'USCH-InformationListIEs-RL-AdditionRspTDD',
        u'USCH-InformationListIE-RL-AdditionRspTDD',
        u'USCHInformationItem-RL-AdditionRspTDD',
        u'USCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'RadioLinkAdditionResponseTDD-Extensions',
        u'RL-LCR-InformationResponse-RL-AdditionRspTDD',
        u'RL-LCR-InformationResponseList-RL-AdditionRspTDD-ExtIEs',
        u'UL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationList-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DCH-InformationResponseList-RL-AdditionRspTDD',
        u'DCH-InformationResponseListIEs-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationResponse-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'USCH-LCR-InformationResponse-RL-AdditionRspTDD',
        u'USCH-LCR-InformationList-RL-AdditionRspTDD',
        u'USCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'USCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'USCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'RL-InformationResponse-RL-AdditionRspTDD768',
        u'RL-InformationResponse-RL-AdditionRspTDD768-ExtIEs',
        u'UL-CCTrCHInformationList-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationListIE-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'UL-DPCH-InformationList-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'DL-CCTrCHInformationList-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationListIE-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'DL-DPCH-InformationList-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'RadioLinkAdditionFailureFDD',
        u'RadioLinkAdditionFailureFDD-IEs',
        u'CauseLevel-RL-AdditionFailureFDD',
        u'GeneralCauseList-RL-AdditionFailureFDD',
        u'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs',
        u'RLSpecificCauseList-RL-AdditionFailureFDD',
        u'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs',
        u'UnsuccessfulRL-InformationResponseList-RL-AdditionFailureFDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs',
        u'SuccessfulRL-InformationResponseList-RL-AdditionFailureFDD',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs',
        u'DL-CodeInformationList-RL-AdditionFailureFDD',
        u'DL-CodeInformationListIEs-RL-AdditionFailureFDD',
        u'DiversityIndication-RL-AdditionFailureFDD',
        u'Combining-RL-AdditionFailureFDD',
        u'CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        u'NonCombining-RL-AdditionFailureFDD',
        u'NonCombiningItem-RL-AdditionFailureFDD-ExtIEs',
        u'RadioLinkAdditionFailureFDD-Extensions',
        u'RadioLinkAdditionFailureTDD',
        u'RadioLinkAdditionFailureTDD-IEs',
        u'CauseLevel-RL-AdditionFailureTDD',
        u'GeneralCauseList-RL-AdditionFailureTDD',
        u'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs',
        u'RLSpecificCauseList-RL-AdditionFailureTDD',
        u'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs',
        u'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD',
        u'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD-ExtIEs',
        u'RadioLinkAdditionFailureTDD-Extensions',
        u'RadioLinkDeletionRequest',
        u'RadioLinkDeletionRequest-IEs',
        u'RL-InformationList-RL-DeletionRqst',
        u'RL-Information-RL-DeletionRqst-IEs',
        u'RL-Information-RL-DeletionRqst',
        u'RL-Information-RL-DeletionRqst-ExtIEs',
        u'RadioLinkDeletionRequest-Extensions',
        u'RadioLinkDeletionResponse',
        u'RadioLinkDeletionResponse-IEs',
        u'RadioLinkDeletionResponse-Extensions',
        u'RadioLinkReconfigurationPrepareFDD',
        u'RadioLinkReconfigurationPrepareFDD-IEs',
        u'UL-DPCH-Information-RL-ReconfPrepFDD',
        u'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'DL-DPCH-Information-RL-ReconfPrepFDD',
        u'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        u'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs',
        u'PowerOffsetInformation-RL-ReconfPrepFDD',
        u'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs',
        u'DCH-DeleteList-RL-ReconfPrepFDD',
        u'DCH-DeleteItem-RL-ReconfPrepFDD',
        u'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs',
        u'RL-InformationList-RL-ReconfPrepFDD',
        u'RL-Information-RL-ReconfPrepFDD-IEs',
        u'RL-Information-RL-ReconfPrepFDD',
        u'RL-Information-RL-ReconfPrepFDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs',
        u'F-DPCH-Information-RL-ReconfPrepFDD',
        u'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD',
        u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareTDD',
        u'RadioLinkReconfigurationPrepareTDD-IEs',
        u'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-ExtIEs',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-ExtIEs',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'DL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        u'CCTrCH-TPCAddList-RL-ReconfPrepTDD',
        u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD',
        u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'DL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'CCTrCH-TPCModifyList-RL-ReconfPrepTDD',
        u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD',
        u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'DL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'DCH-DeleteList-RL-ReconfPrepTDD',
        u'DCH-DeleteItem-RL-ReconfPrepTDD',
        u'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'DSCH-ModifyList-RL-ReconfPrepTDD',
        u'DSCH-ModifyItem-RL-ReconfPrepTDD',
        u'DSCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'DSCH-DeleteList-RL-ReconfPrepTDD',
        u'DSCH-DeleteItem-RL-ReconfPrepTDD',
        u'DSCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'USCH-ModifyList-RL-ReconfPrepTDD',
        u'USCH-ModifyItem-RL-ReconfPrepTDD',
        u'USCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'USCH-DeleteList-RL-ReconfPrepTDD',
        u'USCH-DeleteItem-RL-ReconfPrepTDD',
        u'USCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareTDD-Extensions',
        u'RL-Information-RL-ReconfPrepTDD',
        u'RL-InformationIE-RL-ReconfPrepTDD',
        u'RL-InformationIE-RL-ReconfPrepTDD-ExtIEs',
        u'RadioLinkReconfigurationReadyFDD',
        u'RadioLinkReconfigurationReadyFDD-IEs',
        u'RL-InformationResponseList-RL-ReconfReadyFDD',
        u'RL-InformationResponse-RL-ReconfReadyFDD-IEs',
        u'RL-InformationResponseItem-RL-ReconfReadyFDD',
        u'RL-InformationResponseItem-RL-ReconfReadyFDD-ExtIEs',
        u'DL-CodeInformationList-RL-ReconfReadyFDD',
        u'DL-CodeInformationListIEs-RL-ReconfReadyFDD',
        u'DCH-InformationResponseList-RL-ReconfReadyFDD',
        u'DCH-InformationResponseListIEs-RL-ReconfReadyFDD',
        u'RadioLinkReconfigurationReadyFDD-Extensions',
        u'Additional-HS-Cell-RL-Reconf-Response',
        u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs',
        u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs-ExtIEs',
        u'RadioLinkReconfigurationReadyTDD',
        u'RadioLinkReconfigurationReadyTDD-IEs',
        u'RL-InformationResponse-RL-ReconfReadyTDD',
        u'RL-InformationResponse-RL-ReconfReadyTDD-ExtIEs',
        u'UL-CCTrCH-InformationList-RL-ReconfReadyTDD',
        u'UL-CCTrCHInformationListIEs-RL-ReconfReadyTDD',
        u'UL-CCTrCHInformationListIE-RL-ReconfReadyTDD',
        u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD',
        u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD',
        u'UL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-InformationAddList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-InformationAddList-RL-ReconfReadyTDD768',
        u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs',
        u'UL-DPCH-InformationModifyList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD',
        u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-UL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD768',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs',
        u'DL-CCTrCH-InformationList-RL-ReconfReadyTDD',
        u'DL-CCTrCHInformationListIEs-RL-ReconfReadyTDD',
        u'DL-CCTrCHInformationListIE-RL-ReconfReadyTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD',
        u'DL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationAddList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationAddList-RL-ReconfReadyTDD768',
        u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs',
        u'DL-DPCH-InformationModifyList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD',
        u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-DL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD768',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteItem768-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD-ExtIEs',
        u'DCH-InformationResponseList-RL-ReconfReadyTDD',
        u'DCH-InformationResponseListIEs-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModified-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs',
        u'USCHToBeAddedOrModified-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs',
        u'RadioLinkReconfigurationReadyTDD-Extensions',
        u'Multiple-RL-InformationResponse-RL-ReconfReadyTDD',
        u'RadioLinkReconfigurationCommit',
        u'RadioLinkReconfigurationCommit-IEs',
        u'RadioLinkReconfigurationCommit-Extensions',
        u'RadioLinkReconfigurationFailure',
        u'RadioLinkReconfigurationFailure-IEs',
        u'CauseLevel-RL-ReconfFailure',
        u'GeneralCauseList-RL-ReconfFailure',
        u'GeneralCauseItem-RL-ReconfFailure-ExtIEs',
        u'RLSpecificCauseList-RL-ReconfFailure',
        u'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs',
        u'RL-ReconfigurationFailureList-RL-ReconfFailure',
        u'RL-ReconfigurationFailure-RL-ReconfFailure-IEs',
        u'RL-ReconfigurationFailure-RL-ReconfFail',
        u'RL-ReconfigurationFailure-RL-ReconfFailure-ExtIEs',
        u'RadioLinkReconfigurationFailure-Extensions',
        u'RadioLinkReconfigurationCancel',
        u'RadioLinkReconfigurationCancel-IEs',
        u'RadioLinkReconfigurationCancel-Extensions',
        u'RadioLinkReconfigurationRequestFDD',
        u'RadioLinkReconfigurationRequestFDD-IEs',
        u'UL-DPCH-Information-RL-ReconfRqstFDD',
        u'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        u'DL-DPCH-Information-RL-ReconfRqstFDD',
        u'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        u'DCH-DeleteList-RL-ReconfRqstFDD',
        u'DCH-DeleteItem-RL-ReconfRqstFDD',
        u'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs',
        u'RadioLinkReconfigurationRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Reconf-Req',
        u'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs',
        u'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Req',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs',
        u'RL-ReconfigurationRequestFDD-RL-InformationList',
        u'RL-ReconfigurationRequestFDD-RL-Information-ListItem',
        u'RL-ReconfigurationRequestFDD-RL-Information-IEs',
        u'RL-ReconfigurationRequestFDD-RL-Information-ExtIEs',
        u'RadioLinkReconfigurationRequestTDD',
        u'RadioLinkReconfigurationRequestTDD-IEs',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs',
        u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs',
        u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'DCH-DeleteList-RL-ReconfRqstTDD',
        u'DCH-DeleteItem-RL-ReconfRqstTDD',
        u'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'RadioLinkReconfigurationRequestTDD-Extensions',
        u'Multiple-RL-ReconfigurationRequestTDD-RL-Information',
        u'RL-ReconfigurationRequestTDD-RL-Information',
        u'RL-ReconfigurationRequestTDD-RL-Information-ExtIEs',
        u'RadioLinkReconfigurationResponseFDD',
        u'RadioLinkReconfigurationResponseFDD-IEs',
        u'RL-InformationResponseList-RL-ReconfRspFDD',
        u'RL-InformationResponse-RL-ReconfRspFDD-IEs',
        u'RL-InformationResponseItem-RL-ReconfRspFDD',
        u'RL-InformationResponseItem-RL-ReconfRspFDD-ExtIEs',
        u'DCH-InformationResponseList-RL-ReconfRspFDD',
        u'DCH-InformationResponseListIEs-RL-ReconfRspFDD',
        u'DL-CodeInformationList-RL-ReconfRspFDD',
        u'DL-CodeInformationListIEs-RL-ReconfRspFDD',
        u'RadioLinkReconfigurationResponseFDD-Extensions',
        u'RadioLinkReconfigurationResponseTDD',
        u'RadioLinkReconfigurationResponseTDD-IEs',
        u'RL-InformationResponse-RL-ReconfRspTDD',
        u'RL-InformationResponse-RL-ReconfRspTDD-ExtIEs',
        u'DL-CCTrCH-InformationList-RL-ReconfRspTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD-ExtIEs',
        u'DL-DPCH-InformationModifyList-LCR-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyListIEs-LCR-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD-ExtIEs',
        u'DL-Timeslot-LCR-InformationModifyList-RL-ReconfRspTDD',
        u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD',
        u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD-ExtIEs',
        u'DCH-InformationResponseList-RL-ReconfRspTDD',
        u'DCH-InformationResponseListIEs-RL-ReconfRspTDD',
        u'RadioLinkReconfigurationResponseTDD-Extensions',
        u'Multiple-RL-InformationResponse-RL-ReconfRspTDD',
        u'RadioLinkFailureIndication',
        u'RadioLinkFailureIndication-IEs',
        u'Reporting-Object-RL-FailureInd',
        u'RL-RL-FailureInd',
        u'RLItem-RL-FailureInd-ExtIEs',
        u'RL-InformationList-RL-FailureInd',
        u'RL-Information-RL-FailureInd-IEs',
        u'RL-Information-RL-FailureInd',
        u'RL-Information-RL-FailureInd-ExtIEs',
        u'RL-Set-RL-FailureInd',
        u'RL-SetItem-RL-FailureInd-ExtIEs',
        u'RL-Set-InformationList-RL-FailureInd',
        u'RL-Set-Information-RL-FailureInd-IEs',
        u'RL-Set-Information-RL-FailureInd',
        u'RL-Set-Information-RL-FailureInd-ExtIEs',
        u'RadioLinkFailureIndication-Extensions',
        u'CCTrCH-RL-FailureInd',
        u'CCTrCHItem-RL-FailureInd-ExtIEs',
        u'CCTrCH-InformationList-RL-FailureInd',
        u'CCTrCH-InformationItemIE-RL-FailureInd',
        u'CCTrCH-InformationItem-RL-FailureInd',
        u'CCTrCH-InformationItem-RL-FailureInd-ExtIEs',
        u'RadioLinkPreemptionRequiredIndication',
        u'RadioLinkPreemptionRequiredIndication-IEs',
        u'RL-InformationList-RL-PreemptRequiredInd',
        u'RL-InformationItemIEs-RL-PreemptRequiredInd',
        u'RL-InformationItem-RL-PreemptRequiredInd',
        u'RL-Information-RL-PreemptRequiredInd-ExtIEs',
        u'RadioLinkPreemptionRequiredIndication-Extensions',
        u'HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs',
        u'EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs',
        u'RadioLinkRestoreIndication',
        u'RadioLinkRestoreIndication-IEs',
        u'Reporting-Object-RL-RestoreInd',
        u'RL-RL-RestoreInd',
        u'RLItem-RL-RestoreInd-ExtIEs',
        u'RL-InformationList-RL-RestoreInd',
        u'RL-Information-RL-RestoreInd-IEs',
        u'RL-Information-RL-RestoreInd',
        u'RL-Information-RL-RestoreInd-ExtIEs',
        u'RL-Set-RL-RestoreInd',
        u'RL-SetItem-RL-RestoreInd-ExtIEs',
        u'RL-Set-InformationList-RL-RestoreInd',
        u'RL-Set-Information-RL-RestoreInd-IEs',
        u'RL-Set-Information-RL-RestoreInd',
        u'RL-Set-Information-RL-RestoreInd-ExtIEs',
        u'RadioLinkRestoreIndication-Extensions',
        u'CCTrCH-RL-RestoreInd',
        u'CCTrCHItem-RL-RestoreInd-ExtIEs',
        u'CCTrCH-InformationList-RL-RestoreInd',
        u'CCTrCH-InformationItemIE-RL-RestoreInd',
        u'CCTrCH-InformationItem-RL-RestoreInd',
        u'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs',
        u'DL-PowerControlRequest',
        u'DL-PowerControlRequest-IEs',
        u'DL-ReferencePowerInformationList-DL-PC-Rqst',
        u'DL-ReferencePowerInformation-DL-PC-Rqst-IEs',
        u'DL-ReferencePowerInformation-DL-PC-Rqst',
        u'DL-ReferencePowerInformation-DL-PC-Rqst-ExtIEs',
        u'DL-PowerControlRequest-Extensions',
        u'DL-PowerTimeslotControlRequest',
        u'DL-PowerTimeslotControlRequest-IEs',
        u'DL-PowerTimeslotControlRequest-Extensions',
        u'PhysicalChannelReconfigurationRequestFDD',
        u'PhysicalChannelReconfigurationRequestFDD-IEs',
        u'RL-Information-PhyChReconfRqstFDD',
        u'RL-Information-PhyChReconfRqstFDD-ExtIEs',
        u'DL-CodeInformationList-PhyChReconfRqstFDD',
        u'DL-CodeInformationListIEs-PhyChReconfRqstFDD',
        u'PhysicalChannelReconfigurationRequestFDD-Extensions',
        u'PhysicalChannelReconfigurationRequestTDD',
        u'PhysicalChannelReconfigurationRequestTDD-IEs',
        u'RL-Information-PhyChReconfRqstTDD',
        u'RL-Information-PhyChReconfRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationList-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-DPCH-InformationList-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationListIEs-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD',
        u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD',
        u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'DL-CCTrCH-InformationList-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-DPCH-InformationList-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationListIEs-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD',
        u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD',
        u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD-ExtIEs',
        u'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'PhysicalChannelReconfigurationRequestTDD-Extensions',
        u'PhysicalChannelReconfigurationCommand',
        u'PhysicalChannelReconfigurationCommand-IEs',
        u'PhysicalChannelReconfigurationCommand-Extensions',
        u'PhysicalChannelReconfigurationFailure',
        u'PhysicalChannelReconfigurationFailure-IEs',
        u'PhysicalChannelReconfigurationFailure-Extensions',
        u'RadioLinkCongestionIndication',
        u'RadioLinkCongestionIndication-IEs',
        u'RL-InformationList-RL-CongestInd',
        u'RL-InformationItemIEs-RL-CongestInd',
        u'RL-InformationItem-RL-CongestInd',
        u'DCH-Rate-Information-RL-CongestInd',
        u'DCH-Rate-InformationItemIEs-RL-CongestInd',
        u'DCH-Rate-InformationItem-RL-CongestInd',
        u'DCH-Rate-InformationItem-RL-CongestInd-ExtIEs',
        u'RL-Information-RL-CongestInd-ExtIEs',
        u'RadioLinkCongestionIndication-Extensions',
        u'EDCH-MacdFlowSpecificInformationList-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformationItemIEs-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformationItem-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformation-RL-CongestInd-ExtIEs',
        u'UplinkSignallingTransferIndicationFDD',
        u'UplinkSignallingTransferIndicationFDD-IEs',
        u'UplinkSignallingTransferIndicationFDD-Extensions',
        u'UplinkSignallingTransferIndicationTDD',
        u'UplinkSignallingTransferIndicationTDD-IEs',
        u'UplinkSignallingTransferIndicationTDD-Extensions',
        u'DownlinkSignallingTransferRequest',
        u'DownlinkSignallingTransferRequest-IEs',
        u'DownlinkSignallingTransferRequest-Extensions',
        u'RelocationCommit',
        u'RelocationCommit-IEs',
        u'RelocationCommit-Extensions',
        u'PagingRequest',
        u'PagingRequest-IEs',
        u'PagingArea-PagingRqst',
        u'URA-PagingRqst',
        u'URAItem-PagingRqst-ExtIEs',
        u'Cell-PagingRqst',
        u'CellItem-PagingRqst-ExtIEs',
        u'CNOriginatedPage-PagingRqst',
        u'CNOriginatedPage-PagingRqst-ExtIEs',
        u'PagingRequest-Extensions',
        u'DedicatedMeasurementInitiationRequest',
        u'DedicatedMeasurementInitiationRequest-IEs',
        u'DedicatedMeasurementObjectType-DM-Rqst',
        u'RL-DM-Rqst',
        u'RLItem-DM-Rqst-ExtIEs',
        u'RL-InformationList-DM-Rqst',
        u'RL-Information-DM-Rqst-IEs',
        u'RL-InformationItem-DM-Rqst',
        u'RL-InformationItem-DM-Rqst-ExtIEs',
        u'HSSICH-Info-DM-Rqst',
        u'HSSICH-Info-DM-Rqst-Extension',
        u'RL-Set-DM-Rqst',
        u'RL-SetItem-DM-Rqst-ExtIEs',
        u'RL-Set-InformationList-DM-Rqst',
        u'RL-Set-Information-DM-Rqst-IEs',
        u'RL-Set-InformationItem-DM-Rqst',
        u'RL-Set-InformationItem-DM-Rqst-ExtIEs',
        u'All-RL-DM-Rqst',
        u'All-RL-Set-DM-Rqst',
        u'DedicatedMeasurementInitiationRequest-Extensions',
        u'DedicatedMeasurementInitiationResponse',
        u'DedicatedMeasurementInitiationResponse-IEs',
        u'DedicatedMeasurementObjectType-DM-Rsp',
        u'RL-DM-Rsp',
        u'RLItem-DM-Rsp-ExtIEs',
        u'RL-Set-DM-Rsp',
        u'RL-SetItem-DM-Rsp-ExtIEs',
        u'RL-InformationList-DM-Rsp',
        u'RL-Information-DM-Rsp-IEs',
        u'RL-InformationItem-DM-Rsp',
        u'RL-InformationItem-DM-Rsp-ExtIEs',
        u'RL-Set-InformationList-DM-Rsp',
        u'RL-Set-Information-DM-Rsp-IEs',
        u'RL-Set-InformationItem-DM-Rsp',
        u'RL-Set-InformationItem-DM-Rspns-ExtIEs',
        u'DedicatedMeasurementInitiationResponse-Extensions',
        u'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        u'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs',
        u'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp',
        u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        u'Multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp-ExtIEs',
        u'DedicatedMeasurementInitiationFailure',
        u'DedicatedMeasurementInitiationFailure-IEs',
        u'DedicatedMeasurementInitiationFailure-Extensions',
        u'DedicatedMeasurementObjectType-DM-Fail',
        u'RL-DM-Fail',
        u'RLItem-DM-Fail-ExtIEs',
        u'RL-Set-DM-Fail',
        u'RL-SetItem-DM-Fail-ExtIEs',
        u'RL-Unsuccessful-InformationRespList-DM-Fail',
        u'RL-Unsuccessful-InformationResp-DM-Fail-IEs',
        u'RL-Unsuccessful-InformationItem-DM-Fail',
        u'RL-Unsuccessful-InformationItem-DM-Fail-ExtIEs',
        u'RL-Successful-InformationRespList-DM-Fail',
        u'RL-Successful-InformationResp-DM-Fail-IEs',
        u'RL-Successful-InformationItem-DM-Fail',
        u'RL-Successful-InformationItem-DM-Fail-ExtIEs',
        u'RL-Set-Unsuccessful-InformationRespList-DM-Fail',
        u'RL-Set-Unsuccessful-InformationResp-DM-Fail-IEs',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail',
        u'RL-Set-Unsuccessful-InformationItem-DM-Failns-ExtIEs',
        u'RL-Set-Successful-InformationRespList-DM-Fail',
        u'RL-Set-Successful-InformationResp-DM-Fail-IEs',
        u'RL-Set-Successful-InformationItem-DM-Fail',
        u'RL-Set-Successful-InformationItem-DM-Failns-ExtIEs',
        u'DedicatedMeasurementReport',
        u'DedicatedMeasurementReport-IEs',
        u'DedicatedMeasurementObjectType-DM-Rprt',
        u'RL-DM-Rprt',
        u'RLItem-DM-Rprt-ExtIEs',
        u'RL-Set-DM-Rprt',
        u'RL-SetItem-DM-Rprt-ExtIEs',
        u'RL-InformationList-DM-Rprt',
        u'RL-Information-DM-Rprt-IEs',
        u'RL-InformationItem-DM-Rprt',
        u'RL-InformationItem-DM-Rprt-ExtIEs',
        u'RL-Set-InformationList-DM-Rprt',
        u'RL-Set-Information-DM-Rprt-IEs',
        u'RL-Set-InformationItem-DM-Rprt',
        u'RL-Set-InformationItem-DM-Rprt-ExtIEs',
        u'DedicatedMeasurementReport-Extensions',
        u'DedicatedMeasurementTerminationRequest',
        u'DedicatedMeasurementTerminationRequest-IEs',
        u'DedicatedMeasurementTerminationRequest-Extensions',
        u'DedicatedMeasurementFailureIndication',
        u'DedicatedMeasurementFailureIndication-IEs',
        u'DedicatedMeasurementFailureIndication-Extensions',
        u'DedicatedMeasurementObjectType-DM-Fail-Ind',
        u'RL-DM-Fail-Ind',
        u'RLItem-DM-Fail-Ind-ExtIEs',
        u'RL-Set-DM-Fail-Ind',
        u'RL-SetItem-DM-Fail-Ind-ExtIEs',
        u'RL-Unsuccessful-InformationRespList-DM-Fail-Ind',
        u'RL-Unsuccessful-InformationResp-DM-Fail-Ind-IEs',
        u'RL-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'RL-Unsuccessful-InformationItem-DM-Fail-Ind-ExtIEs',
        u'RL-Set-Unsuccessful-InformationRespList-DM-Fail-Ind',
        u'RL-Set-Unsuccessful-InformationResp-DM-Fail-Ind-IEs',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Indns-ExtIEs',
        u'CommonTransportChannelResourcesReleaseRequest',
        u'CommonTransportChannelResourcesReleaseRequest-IEs',
        u'CommonTransportChannelResourcesReleaseRequest-Extensions',
        u'CommonTransportChannelResourcesRequest',
        u'CommonTransportChannelResourcesRequest-IEs',
        u'CommonTransportChannelResourcesRequest-Extensions',
        u'CommonTransportChannelResourcesResponseFDD',
        u'CommonTransportChannelResourcesResponseFDD-IEs',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD-ExtIEs',
        u'FACH-FlowControlInformation-CTCH-ResourceRspFDD',
        u'FACH-FlowControlInformationIEs-CTCH-ResourceRspFDD',
        u'CommonTransportChannelResourcesResponseFDD-Extensions',
        u'CommonTransportChannelResourcesResponseTDD',
        u'CommonTransportChannelResourcesResponseTDD-IEs',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD-ExtIEs',
        u'FACH-FlowControlInformation-CTCH-ResourceRspTDD',
        u'FACH-FlowControlInformationIEs-CTCH-ResourceRspTDD',
        u'CommonTransportChannelResourcesResponseTDD-Extensions',
        u'CommonTransportChannelResourcesFailure',
        u'CommonTransportChannelResourcesFailure-IEs',
        u'CommonTransportChannelResourcesFailure-Extensions',
        u'CompressedModeCommand',
        u'CompressedModeCommand-IEs',
        u'CompressedModeCommand-Extensions',
        u'ErrorIndication',
        u'ErrorIndication-IEs',
        u'ErrorIndication-Extensions',
        u'CommonMeasurementInitiationRequest',
        u'CommonMeasurementInitiationRequest-IEs',
        u'CommonMeasurementInitiationRequest-Extensions',
        u'CommonMeasurementObjectType-CM-Rqst',
        u'Cell-CM-Rqst',
        u'NeighbouringCellMeasurementInfo',
        u'Extension-neighbouringCellMeasurementInformation',
        u'Extension-neighbouringCellMeasurementInformationIE',
        u'Extension-neighbouringCellMeasurementInformation768',
        u'Extension-neighbouringCellMeasurementInformation768IE',
        u'CellItem-CM-Rqst-ExtIEs',
        u'Additional-CommonMeasurementObjectType-CM-Rqst',
        u'Additional-CommonMeasurementObjectType-CM-RqstIE',
        u'GSM-Cell-CM-Rqst',
        u'GSMCell-CM-Rqst-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-Rqst',
        u'Extension-CommonMeasurementObjectType-CM-RqstIE',
        u'GsmCellList-CM-Rqst',
        u'GsmCellItem-CM-Rqst',
        u'GsmCellItem-CM-Rqst-ExtIEs',
        u'CommonMeasurementInitiationResponse',
        u'CommonMeasurementInitiationResponse-IEs',
        u'CommonMeasurementInitiationResponse-Extensions',
        u'CommonMeasurementObjectType-CM-Rsp',
        u'Cell-CM-Rsp',
        u'CellItem-CM-Rsp-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-Rsp',
        u'Extension-CommonMeasurementObjectType-CM-RspIE',
        u'GsmCellList-CM-Rsp',
        u'GsmCellItem-CM-Rsp',
        u'GsmCellItem-CM-Rsp-ExtIEs',
        u'CommonMeasurementInitiationFailure',
        u'CommonMeasurementInitiationFailure-IEs',
        u'CommonMeasurementInitiationFailure-Extensions',
        u'Extension-FailureMeasurementList',
        u'Extension-FailureMeasurementItem',
        u'Extension-FailureMeasurementItem-ExtIEs',
        u'CommonMeasurementReport',
        u'CommonMeasurementReport-IEs',
        u'CommonMeasurementReport-Extensions',
        u'CommonMeasurementObjectType-CM-Rprt',
        u'Cell-CM-Rprt',
        u'CellItem-CM-Rprt-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-Rprt',
        u'Extension-CommonMeasurementObjectType-CM-RprtIE',
        u'GsmCellList-CM-Rprt',
        u'GsmCellItem-CM-Rprt',
        u'GsmCellItem-CM-Rprt-ExtIEs',
        u'CommonMeasurementTerminationRequest',
        u'CommonMeasurementTerminationRequest-IEs',
        u'CommonMeasurementTerminationRequest-Extensions',
        u'Extension-TerminationMeasurementList',
        u'Extension-TerminationMeasurementItem',
        u'Extension-TerminationMeasurementItem-ExtIEs',
        u'CommonMeasurementFailureIndication',
        u'CommonMeasurementFailureIndication-IEs',
        u'CommonMeasurementFailureIndication-Extensions',
        u'Extension-FailureIndicationMeasurementList',
        u'Extension-FailureIndicationMeasurementItem',
        u'Extension-FailureIndicationMeasurementItem-ExtIEs',
        u'InformationExchangeInitiationRequest',
        u'InformationExchangeInitiationRequest-IEs',
        u'InformationExchangeInitiationRequest-Extensions',
        u'InformationExchangeObjectType-InfEx-Rqst',
        u'Cell-InfEx-Rqst',
        u'CellItem-InfEx-Rqst-ExtIEs',
        u'Extension-InformationExchangeObjectType-InfEx-Rqst',
        u'Extension-InformationExchangeObjectType-InfEx-RqstIE',
        u'GSM-Cell-InfEx-Rqst',
        u'GSMCellItem-InfEx-Rqst-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst-ExtIEs',
        u'MBMS-Bearer-Service-List-InfEx-Rqst',
        u'MBMS-Cell-InfEx-Rqst',
        u'ANR-Cell-InfEx-Rqst',
        u'Common-E-RGCH-Cell-InfEx-Rqst',
        u'InformationExchangeInitiationResponse',
        u'InformationExchangeInitiationResponse-IEs',
        u'InformationExchangeInitiationResponse-Extensions',
        u'InformationExchangeObjectType-InfEx-Rsp',
        u'Cell-InfEx-Rsp',
        u'CellItem-InfEx-Rsp-ExtIEs',
        u'Extension-InformationExchangeObjectType-InfEx-Rsp',
        u'Extension-InformationExchangeObjectType-InfEx-RspIE',
        u'MBMS-Bearer-Service-List-InfEx-Rsp',
        u'MBMS-Bearer-ServiceItemIEs-InfEx-Rsp',
        u'MBMS-Bearer-ServiceItem-InfEx-Rsp-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp-ExtIEs',
        u'MBMS-Cell-InfEx-Rsp',
        u'MBMS-Cell-Item-InfEx-Rsp',
        u'MBMS-Cell-Item-InfEx-Rsp-ExtIEs',
        u'ANR-Cell-InfEx-Rsp',
        u'ANR-Cell-ItemIEs-InfEx-Rsp',
        u'ANR-Cell-ItemIEs-InfEx-Rsp-ExtIEs',
        u'Common-E-RGCH-Cell-InfEx-Rsp',
        u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp',
        u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp-ExtIEs',
        u'InformationExchangeInitiationFailure',
        u'InformationExchangeInitiationFailure-IEs',
        u'InformationExchangeInitiationFailure-Extensions',
        u'InformationReport',
        u'InformationReport-IEs',
        u'InformationReport-Extensions',
        u'InformationExchangeObjectType-InfEx-Rprt',
        u'Extension-InformationExchangeObjectType-InfEx-Rprt',
        u'Extension-InformationExchangeObjectType-InfEx-RprtIE',
        u'Cell-InfEx-Rprt',
        u'CellItem-InfEx-Rprt-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt-ExtIEs',
        u'MBMS-Bearer-Service-List-InfEx-Rprt',
        u'MBMS-Bearer-Service-List-Item-InfEx-Rprt',
        u'MBMS-Bearer-Service-List-Item-InfEx-Rprt-ExtIEs',
        u'MBMS-Cell-InfEx-Rprt',
        u'MBMS-Cell-Item-InfEx-Rprt',
        u'MBMS-Cell-Item-InfEx-Rprt-ExtIEs',
        u'Common-E-RGCH-Cell-InfEx-Rprt',
        u'Common-E-RGCH-Cell-Item-InfEx-Rprt',
        u'Common-E-RGCH-Cell-Item-InfEx-Rprt-ExtIEs',
        u'InformationExchangeTerminationRequest',
        u'InformationExchangeTerminationRequest-IEs',
        u'InformationExchangeTerminationRequest-Extensions',
        u'InformationExchangeFailureIndication',
        u'InformationExchangeFailureIndication-IEs',
        u'InformationExchangeFailureIndication-Extensions',
        u'ResetRequest',
        u'ResetRequest-IEs',
        u'ResetRequest-Extensions',
        u'ResetIndicator',
        u'ContextList-Reset',
        u'ContextItem-Reset-ExtIEs',
        u'ContextInfoList-Reset',
        u'ContextInfoItemIE-Reset',
        u'ContextInfoItem-Reset',
        u'ContextInfoItem-Reset-ExtIEs',
        u'ContextType-Reset',
        u'Extension-ContextType-Reset',
        u'Extension-ContextType-ResetIE',
        u'ContextGroupList-Reset',
        u'ContextGroupItem-Reset-ExtIEs',
        u'ContextGroupInfoList-Reset',
        u'ContextGroupInfoItemIE-Reset',
        u'ContextGroupInfoItem-Reset',
        u'ContextGroupInfoItem-Reset-ExtIEs',
        u'ResetResponse',
        u'ResetResponse-IEs',
        u'ResetResponse-Extensions',
        u'RadioLinkActivationCommandFDD',
        u'RadioLinkActivationCommandFDD-IEs',
        u'RadioLinkActivationCommandFDD-Extensions',
        u'DelayedActivationInformationList-RL-ActivationCmdFDD',
        u'DelayedActivationInformation-RL-ActivationCmdFDD-IEs',
        u'DelayedActivationInformation-RL-ActivationCmdFDD',
        u'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs',
        u'RadioLinkActivationCommandTDD',
        u'RadioLinkActivationCommandTDD-IEs',
        u'RadioLinkActivationCommandTDD-Extensions',
        u'DelayedActivationInformationList-RL-ActivationCmdTDD',
        u'DelayedActivationInformation-RL-ActivationCmdTDD-IEs',
        u'DelayedActivationInformation-RL-ActivationCmdTDD',
        u'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs',
        u'GERANUplinkSignallingTransferIndication',
        u'GERANUplinkSignallingTransferIndication-IEs',
        u'GERANUplinkSignallingTransferIndication-Extensions',
        u'RadioLinkParameterUpdateIndicationFDD',
        u'RadioLinkParameterUpdateIndicationFDD-IEs',
        u'RL-ParameterUpdateIndicationFDD-RL-InformationList',
        u'RL-ParameterUpdateIndicationFDD-RL-InformationList-IEs',
        u'RL-ParameterUpdateIndicationFDD-RL-Information-Item',
        u'RL-ParameterUpdateIndicationFDD-RL-Information-ExtIEs',
        u'RadioLinkParameterUpdateIndicationFDD-Extensions',
        u'UE-Measurement-Forwarding',
        u'UE-Measurement-Forwarding-ExtIEs',
        u'Additional-HS-Cell-Information-RL-Param-Upd',
        u'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs',
        u'Additional-HS-Cell-Information-RL-Setup-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Param-Upd',
        u'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs',
        u'Additional-EDCH-FDD-Update-Information-ExtIEs',
        u'RadioLinkParameterUpdateIndicationTDD',
        u'RadioLinkParameterUpdateIndicationTDD-IEs',
        u'RadioLinkParameterUpdateIndicationTDD-Extensions',
        u'UEMeasurementInitiationRequest',
        u'UEMeasurementInitiationRequest-IEs',
        u'UEMeasurementInitiationRequest-Extensions',
        u'UEMeasurementInitiationResponse',
        u'UEMeasurementInitiationResponse-IEs',
        u'UEMeasurementInitiationResponse-Extensions',
        u'UEMeasurementInitiationFailure',
        u'UEMeasurementInitiationFailure-IEs',
        u'UEMeasurementInitiationFailure-Extensions',
        u'UEMeasurementReport',
        u'UEMeasurementReport-IEs',
        u'UEMeasurementReport-Extensions',
        u'UEMeasurementTerminationRequest',
        u'UEMeasurementTerminationRequest-IEs',
        u'UEMeasurementTerminationRequest-Extensions',
        u'UEMeasurementFailureIndication',
        u'UEMeasurementFailureIndication-IEs',
        u'UEMeasurementFailureIndication-Extensions',
        u'IurInvokeTrace',
        u'IurInvokeTrace-IEs',
        u'ListOfInterfacesToTrace',
        u'InterfacesToBeTracedItemIE',
        u'InterfacesToTraceItem',
        u'InterfacesToTraceItem-ExtIEs',
        u'IurInvokeTrace-Extensions',
        u'IurDeactivateTrace',
        u'IurDeactivateTrace-IEs',
        u'IurDeactivateTrace-Extensions',
        u'MBMSAttachCommand',
        u'MBMSAttachCommand-IEs',
        u'MBMSAttachCommand-Extensions',
        u'MBMSDetachCommand',
        u'MBMSDetachCommand-IEs',
        u'MBMSDetachCommand-Extensions',
        u'DirectInformationTransfer',
        u'DirectInformationTransfer-IEs',
        u'DirectInformationTransfer-Extensions',
        u'EnhancedRelocationRequest',
        u'EnhancedRelocationRequest-IEs',
        u'EnhancedRelocationRequest-Extensions',
        u'EnhancedRelocationResponse',
        u'EnhancedRelocationResponse-IEs',
        u'EnhancedRelocationResponse-Extensions',
        u'EnhancedRelocationFailure',
        u'EnhancedRelocationFailure-IEs',
        u'EnhancedRelocationFailure-Extensions',
        u'EnhancedRelocationCancel',
        u'EnhancedRelocationCancel-IEs',
        u'EnhancedRelocationCancel-Extensions',
        u'EnhancedRelocationSignallingTransfer',
        u'EnhancedRelocationSignallingTransfer-IEs',
        u'EnhancedRelocationSignallingTransfer-Extensions',
        u'EnhancedRelocationRelease',
        u'EnhancedRelocationRelease-IEs',
        u'EnhancedRelocationRelease-Extensions',
        u'MBSFNMCCHInformation',
        u'MBSFNMCCHInformation-IEs',
        u'MBSFNMCCHInformation-Extensions',
        u'SecondaryULFrequencyReport',
        u'SecondaryULFrequencyReport-IEs',
        u'SecondaryULFrequencyReport-Extensions',
        u'SecondaryULFrequencyUpdateIndication',
        u'SecondaryULFrequencyUpdateIndication-IEs',
        u'SecondaryULFrequencyUpdateIndication-Extensions',
        u'EnhancedRelocationResourceRequest',
        u'EnhancedRelocationResourceRequest-IEs',
        u'EnhancedRelocationResourceRequest-Extensions',
        u'EnhancedRelocationResourceResponse',
        u'EnhancedRelocationResourceResponse-IEs',
        u'EnhancedRelocationResourceResponse-Extensions',
        u'EnhancedRelocationResourceFailure',
        u'EnhancedRelocationResourceFailure-IEs',
        u'EnhancedRelocationResourceFailure-Extensions',
        u'EnhancedRelocationResourceReleaseCommand',
        u'EnhancedRelocationResourceReleaseCommand-IEs',
        u'EnhancedRelocationResourceReleaseCommand-Extensions',
        u'EnhancedRelocationResourceReleaseComplete',
        u'EnhancedRelocationResourceReleaseComplete-IEs',
        u'EnhancedRelocationResourceReleaseComplete-Extensions',
        u'PrivateMessage',
        u'PrivateMessage-IEs',
        u'InformationTransferControlRequest',
        u'InformationTransferControlRequest-IEs',
        u'InformationTransferControlRequest-Extensions',
        u'Control-Type-InformationTransferControlReq',
        u'Suspension-Control-Type',
        u'Suspension-Control-Type-ExtIEs',
        u'Resume-Control-Type',
        u'Resume-Control-Type-ExtIEs',
        ]
    _type_ = [
        u'RadioLinkSetupRequestFDD',
        u'UL-DPCH-Information-RL-SetupRqstFDD',
        u'DL-DPCH-Information-RL-SetupRqstFDD',
        u'PowerOffsetInformation-RL-SetupRqstFDD',
        u'RL-InformationList-RL-SetupRqstFDD',
        u'RL-InformationItem-RL-SetupRqstFDD',
        u'Additional-HS-Cell-Information-RL-Setup-List',
        u'Additional-HS-Cell-Information-RL-Setup-ItemIEs',
        u'F-DPCH-Information-RL-SetupRqstFDD',
        u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD',
        u'RadioLinkSetupRequestTDD',
        u'UL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'DL-Physical-Channel-Information-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationList-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD',
        u'CCTrCH-TPCList-RL-SetupRqstTDD',
        u'CCTrCH-TPCItem-RL-SetupRqstTDD',
        u'RL-Information-RL-SetupRqstTDD',
        u'RadioLinkSetupResponseFDD',
        u'RL-InformationResponseList-RL-SetupRspFDD',
        u'RL-InformationResponseItem-RL-SetupRspFDD',
        u'DiversityIndication-RL-SetupRspFDD',
        u'Combining-RL-SetupRspFDD',
        u'NonCombiningOrFirstRL-RL-SetupRspFDD',
        u'Additional-HS-Cell-Information-Response-List',
        u'Additional-HS-Cell-Information-Response-ItemIEs',
        u'RadioLinkSetupResponseTDD',
        u'RL-InformationResponse-RL-SetupRspTDD',
        u'UL-CCTrCHInformationList-RL-SetupRspTDD',
        u'UL-CCTrCHInformationListIE-RL-SetupRspTDD',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD',
        u'UL-DPCH-InformationList-RL-SetupRspTDD',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD',
        u'DL-CCTrCHInformationList-RL-SetupRspTDD',
        u'DL-CCTrCHInformationListIE-RL-SetupRspTDD',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD',
        u'DL-DPCH-InformationList-RL-SetupRspTDD',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD',
        u'DCH-InformationResponseList-RL-SetupRspTDD',
        u'DSCH-InformationResponse-RL-SetupRspTDD',
        u'DSCH-InformationListIEs-RL-SetupRspTDD',
        u'DSCHInformationItem-RL-SetupRspTDD',
        u'USCH-InformationResponse-RL-SetupRspTDD',
        u'USCH-InformationListIEs-RL-SetupRspTDD',
        u'USCHInformationItem-RL-SetupRspTDD',
        u'RL-LCR-InformationResponse-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationList-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationList-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'DL-LCR-CCTrCHInformationList-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationList-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD',
        u'DSCH-LCR-InformationResponse-RL-SetupRspTDD',
        u'DSCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'DSCH-LCR-InformationItem-RL-SetupRspTDD',
        u'USCH-LCR-InformationResponse-RL-SetupRspTDD',
        u'USCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'USCH-LCR-InformationItem-RL-SetupRspTDD',
        u'RL-InformationResponse-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationList-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationListIE-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD768',
        u'UL-DPCH-InformationList-RL-SetupRspTDD768',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationList-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationListIE-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD768',
        u'DL-DPCH-InformationList-RL-SetupRspTDD768',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD768',
        u'RadioLinkSetupFailureFDD',
        u'CauseLevel-RL-SetupFailureFDD',
        u'GeneralCauseList-RL-SetupFailureFDD',
        u'RLSpecificCauseList-RL-SetupFailureFDD',
        u'UnsuccessfulRL-InformationResponseList-RL-SetupFailureFDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'SuccessfulRL-InformationResponseList-RL-SetupFailureFDD',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD',
        u'DiversityIndication-RL-SetupFailureFDD',
        u'Combining-RL-SetupFailureFDD',
        u'NonCombiningOrFirstRL-RL-SetupFailureFDD',
        u'RadioLinkSetupFailureTDD',
        u'CauseLevel-RL-SetupFailureTDD',
        u'GeneralCauseList-RL-SetupFailureTDD',
        u'RLSpecificCauseList-RL-SetupFailureTDD',
        u'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD',
        u'RadioLinkAdditionRequestFDD',
        u'RL-InformationList-RL-AdditionRqstFDD',
        u'RL-Information-RL-AdditionRqstFDD',
        u'Additional-HS-Cell-Information-RL-Addition-List',
        u'Additional-HS-Cell-Information-RL-Addition-ItemIEs',
        u'Additional-EDCH-Cell-Information-RL-Add-Req',
        u'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency',
        u'EDPCH-Information-RLAdditionReq-FDD',
        u'RadioLinkAdditionRequestTDD',
        u'RL-Information-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationList-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD',
        u'RadioLinkAdditionResponseFDD',
        u'RL-InformationResponseList-RL-AdditionRspFDD',
        u'RL-InformationResponseItem-RL-AdditionRspFDD',
        u'DL-CodeInformationList-RL-AdditionRspFDD',
        u'DiversityIndication-RL-AdditionRspFDD',
        u'Combining-RL-AdditionRspFDD',
        u'NonCombining-RL-AdditionRspFDD',
        u'Additional-HS-Cell-Change-Information-Response-List',
        u'Additional-HS-Cell-Change-Information-Response-ItemIEs',
        u'RadioLinkAdditionResponseTDD',
        u'RL-InformationResponse-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationList-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationListIE-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD',
        u'UL-DPCH-InformationList-RL-AdditionRspTDD',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationList-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationListIE-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD',
        u'DL-DPCH-InformationList-RL-AdditionRspTDD',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD',
        u'DCH-Information-RL-AdditionRspTDD',
        u'DiversityIndication-RL-AdditionRspTDD',
        u'Combining-RL-AdditionRspTDD',
        u'NonCombining-RL-AdditionRspTDD',
        u'DSCH-InformationResponse-RL-AdditionRspTDD',
        u'DSCH-InformationListIE-RL-AdditionRspTDD',
        u'DSCHInformationItem-RL-AdditionRspTDD',
        u'DiversityIndication-RL-AdditionRspTDD2',
        u'USCH-InformationResponse-RL-AdditionRspTDD',
        u'USCH-InformationListIE-RL-AdditionRspTDD',
        u'USCHInformationItem-RL-AdditionRspTDD',
        u'RL-LCR-InformationResponse-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationList-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'DCH-InformationResponseList-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationResponse-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'USCH-LCR-InformationResponse-RL-AdditionRspTDD',
        u'USCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'USCH-LCR-InformationItem-RL-AdditionRspTDD',
        u'RL-InformationResponse-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationList-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationListIE-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationList-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationList-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationListIE-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationList-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD768',
        u'RadioLinkAdditionFailureFDD',
        u'CauseLevel-RL-AdditionFailureFDD',
        u'GeneralCauseList-RL-AdditionFailureFDD',
        u'RLSpecificCauseList-RL-AdditionFailureFDD',
        u'UnsuccessfulRL-InformationResponseList-RL-AdditionFailureFDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'SuccessfulRL-InformationResponseList-RL-AdditionFailureFDD',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD',
        u'DL-CodeInformationList-RL-AdditionFailureFDD',
        u'DiversityIndication-RL-AdditionFailureFDD',
        u'Combining-RL-AdditionFailureFDD',
        u'NonCombining-RL-AdditionFailureFDD',
        u'RadioLinkAdditionFailureTDD',
        u'CauseLevel-RL-AdditionFailureTDD',
        u'GeneralCauseList-RL-AdditionFailureTDD',
        u'RLSpecificCauseList-RL-AdditionFailureTDD',
        u'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD',
        u'RadioLinkDeletionRequest',
        u'RL-InformationList-RL-DeletionRqst',
        u'RL-Information-RL-DeletionRqst',
        u'RadioLinkDeletionResponse',
        u'RadioLinkReconfigurationPrepareFDD',
        u'UL-DPCH-Information-RL-ReconfPrepFDD',
        u'DL-DPCH-Information-RL-ReconfPrepFDD',
        u'DL-DPCH-Power-Information-RL-ReconfPrepFDD',
        u'PowerOffsetInformation-RL-ReconfPrepFDD',
        u'DCH-DeleteList-RL-ReconfPrepFDD',
        u'DCH-DeleteItem-RL-ReconfPrepFDD',
        u'RL-InformationList-RL-ReconfPrepFDD',
        u'RL-Information-RL-ReconfPrepFDD',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Prep',
        u'F-DPCH-Information-RL-ReconfPrepFDD',
        u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD',
        u'RadioLinkReconfigurationPrepareTDD',
        u'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD',
        u'CCTrCH-TPCAddList-RL-ReconfPrepTDD',
        u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD',
        u'CCTrCH-TPCModifyList-RL-ReconfPrepTDD',
        u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD',
        u'DCH-DeleteList-RL-ReconfPrepTDD',
        u'DCH-DeleteItem-RL-ReconfPrepTDD',
        u'DSCH-ModifyList-RL-ReconfPrepTDD',
        u'DSCH-ModifyItem-RL-ReconfPrepTDD',
        u'DSCH-DeleteList-RL-ReconfPrepTDD',
        u'DSCH-DeleteItem-RL-ReconfPrepTDD',
        u'USCH-ModifyList-RL-ReconfPrepTDD',
        u'USCH-ModifyItem-RL-ReconfPrepTDD',
        u'USCH-DeleteList-RL-ReconfPrepTDD',
        u'USCH-DeleteItem-RL-ReconfPrepTDD',
        u'RL-Information-RL-ReconfPrepTDD',
        u'RL-InformationIE-RL-ReconfPrepTDD',
        u'RadioLinkReconfigurationReadyFDD',
        u'RL-InformationResponseList-RL-ReconfReadyFDD',
        u'RL-InformationResponseItem-RL-ReconfReadyFDD',
        u'DL-CodeInformationList-RL-ReconfReadyFDD',
        u'DCH-InformationResponseList-RL-ReconfReadyFDD',
        u'Additional-HS-Cell-RL-Reconf-Response',
        u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs',
        u'RadioLinkReconfigurationReadyTDD',
        u'RL-InformationResponse-RL-ReconfReadyTDD',
        u'UL-CCTrCH-InformationList-RL-ReconfReadyTDD',
        u'UL-CCTrCHInformationListIE-RL-ReconfReadyTDD',
        u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD',
        u'UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddList-RL-ReconfReadyTDD768',
        u'UL-DPCH-InformationModifyList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD',
        u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-UL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD',
        u'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768',
        u'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD768',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768',
        u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD',
        u'DL-CCTrCH-InformationList-RL-ReconfReadyTDD',
        u'DL-CCTrCHInformationListIE-RL-ReconfReadyTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD',
        u'DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddList-RL-ReconfReadyTDD768',
        u'DL-DPCH-InformationModifyList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD',
        u'DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD',
        u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-DL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD',
        u'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD',
        u'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD',
        u'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768',
        u'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD768',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768',
        u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteItem768-RL-ReconfReadyTDD',
        u'DCH-InformationResponseList-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModified-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModified-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD',
        u'Multiple-RL-InformationResponse-RL-ReconfReadyTDD',
        u'RadioLinkReconfigurationCommit',
        u'RadioLinkReconfigurationFailure',
        u'CauseLevel-RL-ReconfFailure',
        u'GeneralCauseList-RL-ReconfFailure',
        u'RLSpecificCauseList-RL-ReconfFailure',
        u'RL-ReconfigurationFailureList-RL-ReconfFailure',
        u'RL-ReconfigurationFailure-RL-ReconfFail',
        u'RadioLinkReconfigurationCancel',
        u'RadioLinkReconfigurationRequestFDD',
        u'UL-DPCH-Information-RL-ReconfRqstFDD',
        u'DL-DPCH-Information-RL-ReconfRqstFDD',
        u'DCH-DeleteList-RL-ReconfRqstFDD',
        u'DCH-DeleteItem-RL-ReconfRqstFDD',
        u'Additional-HS-Cell-Information-RL-Reconf-Req',
        u'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Req',
        u'RL-ReconfigurationRequestFDD-RL-InformationList',
        u'RL-ReconfigurationRequestFDD-RL-Information-IEs',
        u'RadioLinkReconfigurationRequestTDD',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD',
        u'DCH-DeleteList-RL-ReconfRqstTDD',
        u'DCH-DeleteItem-RL-ReconfRqstTDD',
        u'Multiple-RL-ReconfigurationRequestTDD-RL-Information',
        u'RL-ReconfigurationRequestTDD-RL-Information',
        u'RadioLinkReconfigurationResponseFDD',
        u'RL-InformationResponseList-RL-ReconfRspFDD',
        u'RL-InformationResponseItem-RL-ReconfRspFDD',
        u'DCH-InformationResponseList-RL-ReconfRspFDD',
        u'DL-CodeInformationList-RL-ReconfRspFDD',
        u'RadioLinkReconfigurationResponseTDD',
        u'RL-InformationResponse-RL-ReconfRspTDD',
        u'DL-CCTrCH-InformationList-RL-ReconfRspTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyList-LCR-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD',
        u'DL-Timeslot-LCR-InformationModifyList-RL-ReconfRspTDD',
        u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD',
        u'DCH-InformationResponseList-RL-ReconfRspTDD',
        u'Multiple-RL-InformationResponse-RL-ReconfRspTDD',
        u'RadioLinkFailureIndication',
        u'Reporting-Object-RL-FailureInd',
        u'RL-RL-FailureInd',
        u'RL-InformationList-RL-FailureInd',
        u'RL-Information-RL-FailureInd',
        u'RL-Set-RL-FailureInd',
        u'RL-Set-InformationList-RL-FailureInd',
        u'RL-Set-Information-RL-FailureInd',
        u'CCTrCH-RL-FailureInd',
        u'CCTrCH-InformationList-RL-FailureInd',
        u'CCTrCH-InformationItem-RL-FailureInd',
        u'RadioLinkPreemptionRequiredIndication',
        u'RL-InformationList-RL-PreemptRequiredInd',
        u'RL-InformationItem-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd',
        u'RadioLinkRestoreIndication',
        u'Reporting-Object-RL-RestoreInd',
        u'RL-RL-RestoreInd',
        u'RL-InformationList-RL-RestoreInd',
        u'RL-Information-RL-RestoreInd',
        u'RL-Set-RL-RestoreInd',
        u'RL-Set-InformationList-RL-RestoreInd',
        u'RL-Set-Information-RL-RestoreInd',
        u'CCTrCH-RL-RestoreInd',
        u'CCTrCH-InformationList-RL-RestoreInd',
        u'CCTrCH-InformationItem-RL-RestoreInd',
        u'DL-PowerControlRequest',
        u'DL-ReferencePowerInformationList-DL-PC-Rqst',
        u'DL-ReferencePowerInformation-DL-PC-Rqst',
        u'DL-PowerTimeslotControlRequest',
        u'PhysicalChannelReconfigurationRequestFDD',
        u'RL-Information-PhyChReconfRqstFDD',
        u'DL-CodeInformationList-PhyChReconfRqstFDD',
        u'PhysicalChannelReconfigurationRequestTDD',
        u'RL-Information-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationList-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationList-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD',
        u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD',
        u'UL-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD',
        u'UL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768',
        u'DL-CCTrCH-InformationList-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationList-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationItem-PhyChReconfRqstTDD',
        u'DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD',
        u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD',
        u'DL-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD',
        u'DL-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768',
        u'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD',
        u'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768',
        u'PhysicalChannelReconfigurationCommand',
        u'PhysicalChannelReconfigurationFailure',
        u'RadioLinkCongestionIndication',
        u'RL-InformationList-RL-CongestInd',
        u'RL-InformationItem-RL-CongestInd',
        u'DCH-Rate-Information-RL-CongestInd',
        u'DCH-Rate-InformationItem-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformationList-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformationItem-RL-CongestInd',
        u'UplinkSignallingTransferIndicationFDD',
        u'UplinkSignallingTransferIndicationTDD',
        u'DownlinkSignallingTransferRequest',
        u'RelocationCommit',
        u'PagingRequest',
        u'PagingArea-PagingRqst',
        u'URA-PagingRqst',
        u'Cell-PagingRqst',
        u'CNOriginatedPage-PagingRqst',
        u'DedicatedMeasurementInitiationRequest',
        u'DedicatedMeasurementObjectType-DM-Rqst',
        u'RL-DM-Rqst',
        u'RL-InformationList-DM-Rqst',
        u'RL-InformationItem-DM-Rqst',
        u'HSSICH-Info-DM-Rqst',
        u'HSSICH-Info-DM-Rqst-Extension',
        u'RL-Set-DM-Rqst',
        u'RL-Set-InformationList-DM-Rqst',
        u'RL-Set-InformationItem-DM-Rqst',
        u'All-RL-DM-Rqst',
        u'All-RL-Set-DM-Rqst',
        u'DedicatedMeasurementInitiationResponse',
        u'DedicatedMeasurementObjectType-DM-Rsp',
        u'RL-DM-Rsp',
        u'RL-Set-DM-Rsp',
        u'RL-InformationList-DM-Rsp',
        u'RL-InformationItem-DM-Rsp',
        u'RL-Set-InformationList-DM-Rsp',
        u'RL-Set-InformationItem-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp',
        u'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp',
        u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp',
        u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp',
        u'DedicatedMeasurementInitiationFailure',
        u'DedicatedMeasurementObjectType-DM-Fail',
        u'RL-DM-Fail',
        u'RL-Set-DM-Fail',
        u'RL-Unsuccessful-InformationRespList-DM-Fail',
        u'RL-Unsuccessful-InformationItem-DM-Fail',
        u'RL-Successful-InformationRespList-DM-Fail',
        u'RL-Successful-InformationItem-DM-Fail',
        u'RL-Set-Unsuccessful-InformationRespList-DM-Fail',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail',
        u'RL-Set-Successful-InformationRespList-DM-Fail',
        u'RL-Set-Successful-InformationItem-DM-Fail',
        u'DedicatedMeasurementReport',
        u'DedicatedMeasurementObjectType-DM-Rprt',
        u'RL-DM-Rprt',
        u'RL-Set-DM-Rprt',
        u'RL-InformationList-DM-Rprt',
        u'RL-InformationItem-DM-Rprt',
        u'RL-Set-InformationList-DM-Rprt',
        u'RL-Set-InformationItem-DM-Rprt',
        u'DedicatedMeasurementTerminationRequest',
        u'DedicatedMeasurementFailureIndication',
        u'DedicatedMeasurementObjectType-DM-Fail-Ind',
        u'RL-DM-Fail-Ind',
        u'RL-Set-DM-Fail-Ind',
        u'RL-Unsuccessful-InformationRespList-DM-Fail-Ind',
        u'RL-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'RL-Set-Unsuccessful-InformationRespList-DM-Fail-Ind',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind',
        u'CommonTransportChannelResourcesReleaseRequest',
        u'CommonTransportChannelResourcesRequest',
        u'CommonTransportChannelResourcesResponseFDD',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD',
        u'FACH-FlowControlInformation-CTCH-ResourceRspFDD',
        u'CommonTransportChannelResourcesResponseTDD',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD',
        u'FACH-FlowControlInformation-CTCH-ResourceRspTDD',
        u'CommonTransportChannelResourcesFailure',
        u'CompressedModeCommand',
        u'ErrorIndication',
        u'CommonMeasurementInitiationRequest',
        u'CommonMeasurementObjectType-CM-Rqst',
        u'Cell-CM-Rqst',
        u'NeighbouringCellMeasurementInfo',
        u'Extension-neighbouringCellMeasurementInformation',
        u'Extension-neighbouringCellMeasurementInformation768',
        u'Additional-CommonMeasurementObjectType-CM-Rqst',
        u'GSM-Cell-CM-Rqst',
        u'Extension-CommonMeasurementObjectType-CM-Rqst',
        u'GsmCellList-CM-Rqst',
        u'GsmCellItem-CM-Rqst',
        u'CommonMeasurementInitiationResponse',
        u'CommonMeasurementObjectType-CM-Rsp',
        u'Cell-CM-Rsp',
        u'Extension-CommonMeasurementObjectType-CM-Rsp',
        u'GsmCellList-CM-Rsp',
        u'GsmCellItem-CM-Rsp',
        u'CommonMeasurementInitiationFailure',
        u'Extension-FailureMeasurementList',
        u'Extension-FailureMeasurementItem',
        u'CommonMeasurementReport',
        u'CommonMeasurementObjectType-CM-Rprt',
        u'Cell-CM-Rprt',
        u'Extension-CommonMeasurementObjectType-CM-Rprt',
        u'GsmCellList-CM-Rprt',
        u'GsmCellItem-CM-Rprt',
        u'CommonMeasurementTerminationRequest',
        u'Extension-TerminationMeasurementList',
        u'Extension-TerminationMeasurementItem',
        u'CommonMeasurementFailureIndication',
        u'Extension-FailureIndicationMeasurementList',
        u'Extension-FailureIndicationMeasurementItem',
        u'InformationExchangeInitiationRequest',
        u'InformationExchangeObjectType-InfEx-Rqst',
        u'Cell-InfEx-Rqst',
        u'Extension-InformationExchangeObjectType-InfEx-Rqst',
        u'GSM-Cell-InfEx-Rqst',
        u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst',
        u'MBMS-Bearer-Service-List-InfEx-Rqst',
        u'MBMS-Cell-InfEx-Rqst',
        u'ANR-Cell-InfEx-Rqst',
        u'Common-E-RGCH-Cell-InfEx-Rqst',
        u'InformationExchangeInitiationResponse',
        u'InformationExchangeObjectType-InfEx-Rsp',
        u'Cell-InfEx-Rsp',
        u'Extension-InformationExchangeObjectType-InfEx-Rsp',
        u'MBMS-Bearer-Service-List-InfEx-Rsp',
        u'MBMS-Bearer-ServiceItemIEs-InfEx-Rsp',
        u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp',
        u'MBMS-Cell-InfEx-Rsp',
        u'MBMS-Cell-Item-InfEx-Rsp',
        u'ANR-Cell-InfEx-Rsp',
        u'ANR-Cell-ItemIEs-InfEx-Rsp',
        u'Common-E-RGCH-Cell-InfEx-Rsp',
        u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp',
        u'InformationExchangeInitiationFailure',
        u'InformationReport',
        u'InformationExchangeObjectType-InfEx-Rprt',
        u'Extension-InformationExchangeObjectType-InfEx-Rprt',
        u'Cell-InfEx-Rprt',
        u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt',
        u'MBMS-Bearer-Service-List-InfEx-Rprt',
        u'MBMS-Bearer-Service-List-Item-InfEx-Rprt',
        u'MBMS-Cell-InfEx-Rprt',
        u'MBMS-Cell-Item-InfEx-Rprt',
        u'Common-E-RGCH-Cell-InfEx-Rprt',
        u'Common-E-RGCH-Cell-Item-InfEx-Rprt',
        u'InformationExchangeTerminationRequest',
        u'InformationExchangeFailureIndication',
        u'ResetRequest',
        u'ResetIndicator',
        u'ContextList-Reset',
        u'ContextInfoList-Reset',
        u'ContextInfoItem-Reset',
        u'ContextType-Reset',
        u'Extension-ContextType-Reset',
        u'ContextGroupList-Reset',
        u'ContextGroupInfoList-Reset',
        u'ContextGroupInfoItem-Reset',
        u'ResetResponse',
        u'RadioLinkActivationCommandFDD',
        u'DelayedActivationInformationList-RL-ActivationCmdFDD',
        u'DelayedActivationInformation-RL-ActivationCmdFDD',
        u'RadioLinkActivationCommandTDD',
        u'DelayedActivationInformationList-RL-ActivationCmdTDD',
        u'DelayedActivationInformation-RL-ActivationCmdTDD',
        u'GERANUplinkSignallingTransferIndication',
        u'RadioLinkParameterUpdateIndicationFDD',
        u'RL-ParameterUpdateIndicationFDD-RL-InformationList',
        u'RL-ParameterUpdateIndicationFDD-RL-Information-Item',
        u'UE-Measurement-Forwarding',
        u'Additional-HS-Cell-Information-RL-Param-Upd',
        u'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs',
        u'Additional-EDCH-Cell-Information-RL-Param-Upd',
        u'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs',
        u'RadioLinkParameterUpdateIndicationTDD',
        u'UEMeasurementInitiationRequest',
        u'UEMeasurementInitiationResponse',
        u'UEMeasurementInitiationFailure',
        u'UEMeasurementReport',
        u'UEMeasurementTerminationRequest',
        u'UEMeasurementFailureIndication',
        u'IurInvokeTrace',
        u'ListOfInterfacesToTrace',
        u'InterfacesToTraceItem',
        u'IurDeactivateTrace',
        u'MBMSAttachCommand',
        u'MBMSDetachCommand',
        u'DirectInformationTransfer',
        u'EnhancedRelocationRequest',
        u'EnhancedRelocationResponse',
        u'EnhancedRelocationFailure',
        u'EnhancedRelocationCancel',
        u'EnhancedRelocationSignallingTransfer',
        u'EnhancedRelocationRelease',
        u'MBSFNMCCHInformation',
        u'SecondaryULFrequencyReport',
        u'SecondaryULFrequencyUpdateIndication',
        u'EnhancedRelocationResourceRequest',
        u'EnhancedRelocationResourceResponse',
        u'EnhancedRelocationResourceFailure',
        u'EnhancedRelocationResourceReleaseCommand',
        u'EnhancedRelocationResourceReleaseComplete',
        u'PrivateMessage',
        u'InformationTransferControlRequest',
        u'Control-Type-InformationTransferControlReq',
        u'Suspension-Control-Type',
        u'Resume-Control-Type',
        ]
    _set_ = [
        u'RadioLinkSetupRequestFDD-IEs',
        u'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs',
        u'RL-InformationItemIEs-RL-SetupRqstFDD',
        u'RL-InformationItem-RL-SetupRqstFDD-ExtIEs',
        u'RadioLinkSetupRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs',
        u'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs',
        u'RadioLinkSetupRequestTDD-IEs',
        u'UL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'DL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs',
        u'RL-Information-RL-SetupRqstTDD-ExtIEs',
        u'RadioLinkSetupRequestTDD-Extensions',
        u'RadioLinkSetupResponseFDD-IEs',
        u'RL-InformationResponseItemIEs-RL-SetupRspFDD',
        u'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs',
        u'CombiningItem-RL-SetupRspFDD-ExtIEs',
        u'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs',
        u'RadioLinkSetupResponseFDD-Extensions',
        u'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs',
        u'RadioLinkSetupResponseTDD-IEs',
        u'RL-InformationResponse-RL-SetupRspTDD-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-SetupRspTDD',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-SetupRspTDD',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-SetupRspTDD',
        u'DSCH-InformationList-RL-SetupRspTDD',
        u'DSCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'USCH-InformationList-RL-SetupRspTDD',
        u'USCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'RadioLinkSetupResponseTDD-Extensions',
        u'RL-LCR-InformationResponseList-RL-SetupRspTDD-ExtIEs',
        u'UL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DSCH-LCR-InformationList-RL-SetupRspTDD',
        u'DSCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'USCH-LCR-InformationList-RL-SetupRspTDD',
        u'USCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'RL-InformationResponse-RL-SetupRspTDD768-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-SetupRspTDD768',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-SetupRspTDD768',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs',
        u'RadioLinkSetupFailureFDD-IEs',
        u'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs',
        u'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs',
        u'CombiningItem-RL-SetupFailureFDD-ExtIEs',
        u'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs',
        u'RadioLinkSetupFailureFDD-Extensions',
        u'RadioLinkSetupFailureTDD-IEs',
        u'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs',
        u'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs',
        u'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD-ExtIEs',
        u'RadioLinkSetupFailureTDD-Extensions',
        u'RadioLinkAdditionRequestFDD-IEs',
        u'RL-Information-RL-AdditionRqstFDD-IEs',
        u'RL-Information-RL-AdditionRqstFDD-ExtIEs',
        u'RadioLinkAdditionRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs',
        u'EDPCH-Information-RLAdditionReq-FDD-ExtIEs',
        u'RadioLinkAdditionRequestTDD-IEs',
        u'RL-Information-RL-AdditionRqstTDD-ExtIEs',
        u'RadioLinkAdditionRequestTDD-Extensions',
        u'UL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        u'RadioLinkAdditionResponseFDD-IEs',
        u'RL-InformationResponseItemIEs-RL-AdditionRspFDD',
        u'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs',
        u'DL-CodeInformationListIEs-RL-AdditionRspFDD',
        u'CombiningItem-RL-AdditionRspFDD-ExtIEs',
        u'NonCombiningItem-RL-AdditionRspFDD-ExtIEs',
        u'RadioLinkAdditionResponseFDD-Extensions',
        u'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs',
        u'RadioLinkAdditionResponseTDD-IEs',
        u'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DCH-Information-RL-AdditionRspTDD-ExtIEs',
        u'CombiningItem-RL-AdditionRspTDD-ExtIEs',
        u'NonCombiningItem-RL-AdditionRspTDD-ExtIEs',
        u'DSCH-InformationListIEs-RL-AdditionRspTDD',
        u'DSCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DiversityIndication-RL-AdditionRspTDD2-ExtIEs',
        u'USCH-InformationListIEs-RL-AdditionRspTDD',
        u'USCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'RadioLinkAdditionResponseTDD-Extensions',
        u'RL-LCR-InformationResponseList-RL-AdditionRspTDD-ExtIEs',
        u'UL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'USCH-LCR-InformationList-RL-AdditionRspTDD',
        u'USCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'RL-InformationResponse-RL-AdditionRspTDD768-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'RadioLinkAdditionFailureFDD-IEs',
        u'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs',
        u'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs',
        u'DL-CodeInformationListIEs-RL-AdditionFailureFDD',
        u'CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        u'NonCombiningItem-RL-AdditionFailureFDD-ExtIEs',
        u'RadioLinkAdditionFailureFDD-Extensions',
        u'RadioLinkAdditionFailureTDD-IEs',
        u'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs',
        u'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs',
        u'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD-ExtIEs',
        u'RadioLinkAdditionFailureTDD-Extensions',
        u'RadioLinkDeletionRequest-IEs',
        u'RL-Information-RL-DeletionRqst-IEs',
        u'RL-Information-RL-DeletionRqst-ExtIEs',
        u'RadioLinkDeletionRequest-Extensions',
        u'RadioLinkDeletionResponse-IEs',
        u'RadioLinkDeletionResponse-Extensions',
        u'RadioLinkReconfigurationPrepareFDD-IEs',
        u'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs',
        u'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs',
        u'RL-Information-RL-ReconfPrepFDD-IEs',
        u'RL-Information-RL-ReconfPrepFDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs',
        u'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareTDD-IEs',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-ExtIEs',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-ExtIEs',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'DSCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'DSCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'USCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'USCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareTDD-Extensions',
        u'RL-InformationIE-RL-ReconfPrepTDD-ExtIEs',
        u'RadioLinkReconfigurationReadyFDD-IEs',
        u'RL-InformationResponse-RL-ReconfReadyFDD-IEs',
        u'RL-InformationResponseItem-RL-ReconfReadyFDD-ExtIEs',
        u'DL-CodeInformationListIEs-RL-ReconfReadyFDD',
        u'DCH-InformationResponseListIEs-RL-ReconfReadyFDD',
        u'RadioLinkReconfigurationReadyFDD-Extensions',
        u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs-ExtIEs',
        u'RadioLinkReconfigurationReadyTDD-IEs',
        u'RL-InformationResponse-RL-ReconfReadyTDD-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-ReconfReadyTDD',
        u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs',
        u'UL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'UL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-ReconfReadyTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs',
        u'DL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'DL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs',
        u'USCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs',
        u'RadioLinkReconfigurationReadyTDD-Extensions',
        u'RadioLinkReconfigurationCommit-IEs',
        u'RadioLinkReconfigurationCommit-Extensions',
        u'RadioLinkReconfigurationFailure-IEs',
        u'GeneralCauseItem-RL-ReconfFailure-ExtIEs',
        u'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs',
        u'RL-ReconfigurationFailure-RL-ReconfFailure-IEs',
        u'RL-ReconfigurationFailure-RL-ReconfFailure-ExtIEs',
        u'RadioLinkReconfigurationFailure-Extensions',
        u'RadioLinkReconfigurationCancel-IEs',
        u'RadioLinkReconfigurationCancel-Extensions',
        u'RadioLinkReconfigurationRequestFDD-IEs',
        u'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        u'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs',
        u'RadioLinkReconfigurationRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs',
        u'RL-ReconfigurationRequestFDD-RL-Information-ListItem',
        u'RL-ReconfigurationRequestFDD-RL-Information-ExtIEs',
        u'RadioLinkReconfigurationRequestTDD-IEs',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs',
        u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs',
        u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'RadioLinkReconfigurationRequestTDD-Extensions',
        u'RL-ReconfigurationRequestTDD-RL-Information-ExtIEs',
        u'RadioLinkReconfigurationResponseFDD-IEs',
        u'RL-InformationResponse-RL-ReconfRspFDD-IEs',
        u'RL-InformationResponseItem-RL-ReconfRspFDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-ReconfRspFDD',
        u'DL-CodeInformationListIEs-RL-ReconfRspFDD',
        u'RadioLinkReconfigurationResponseFDD-Extensions',
        u'RadioLinkReconfigurationResponseTDD-IEs',
        u'RL-InformationResponse-RL-ReconfRspTDD-ExtIEs',
        u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD-ExtIEs',
        u'DL-DPCH-InformationModifyListIEs-LCR-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD-ExtIEs',
        u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-ReconfRspTDD',
        u'RadioLinkReconfigurationResponseTDD-Extensions',
        u'RadioLinkFailureIndication-IEs',
        u'RLItem-RL-FailureInd-ExtIEs',
        u'RL-Information-RL-FailureInd-IEs',
        u'RL-Information-RL-FailureInd-ExtIEs',
        u'RL-SetItem-RL-FailureInd-ExtIEs',
        u'RL-Set-Information-RL-FailureInd-IEs',
        u'RL-Set-Information-RL-FailureInd-ExtIEs',
        u'RadioLinkFailureIndication-Extensions',
        u'CCTrCHItem-RL-FailureInd-ExtIEs',
        u'CCTrCH-InformationItemIE-RL-FailureInd',
        u'CCTrCH-InformationItem-RL-FailureInd-ExtIEs',
        u'RadioLinkPreemptionRequiredIndication-IEs',
        u'RL-InformationItemIEs-RL-PreemptRequiredInd',
        u'RL-Information-RL-PreemptRequiredInd-ExtIEs',
        u'RadioLinkPreemptionRequiredIndication-Extensions',
        u'HSDSCHMacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs',
        u'EDCH-MacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs',
        u'RadioLinkRestoreIndication-IEs',
        u'RLItem-RL-RestoreInd-ExtIEs',
        u'RL-Information-RL-RestoreInd-IEs',
        u'RL-Information-RL-RestoreInd-ExtIEs',
        u'RL-SetItem-RL-RestoreInd-ExtIEs',
        u'RL-Set-Information-RL-RestoreInd-IEs',
        u'RL-Set-Information-RL-RestoreInd-ExtIEs',
        u'RadioLinkRestoreIndication-Extensions',
        u'CCTrCHItem-RL-RestoreInd-ExtIEs',
        u'CCTrCH-InformationItemIE-RL-RestoreInd',
        u'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs',
        u'DL-PowerControlRequest-IEs',
        u'DL-ReferencePowerInformation-DL-PC-Rqst-IEs',
        u'DL-ReferencePowerInformation-DL-PC-Rqst-ExtIEs',
        u'DL-PowerControlRequest-Extensions',
        u'DL-PowerTimeslotControlRequest-IEs',
        u'DL-PowerTimeslotControlRequest-Extensions',
        u'PhysicalChannelReconfigurationRequestFDD-IEs',
        u'RL-Information-PhyChReconfRqstFDD-ExtIEs',
        u'DL-CodeInformationListIEs-PhyChReconfRqstFDD',
        u'PhysicalChannelReconfigurationRequestFDD-Extensions',
        u'PhysicalChannelReconfigurationRequestTDD-IEs',
        u'RL-Information-PhyChReconfRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-DPCH-InformationListIEs-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'DL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-DPCH-InformationListIEs-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD-ExtIEs',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'PhysicalChannelReconfigurationRequestTDD-Extensions',
        u'PhysicalChannelReconfigurationCommand-IEs',
        u'PhysicalChannelReconfigurationCommand-Extensions',
        u'PhysicalChannelReconfigurationFailure-IEs',
        u'PhysicalChannelReconfigurationFailure-Extensions',
        u'RadioLinkCongestionIndication-IEs',
        u'RL-InformationItemIEs-RL-CongestInd',
        u'DCH-Rate-InformationItemIEs-RL-CongestInd',
        u'DCH-Rate-InformationItem-RL-CongestInd-ExtIEs',
        u'RL-Information-RL-CongestInd-ExtIEs',
        u'RadioLinkCongestionIndication-Extensions',
        u'EDCH-MacdFlowSpecificInformationItemIEs-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformation-RL-CongestInd-ExtIEs',
        u'UplinkSignallingTransferIndicationFDD-IEs',
        u'UplinkSignallingTransferIndicationFDD-Extensions',
        u'UplinkSignallingTransferIndicationTDD-IEs',
        u'UplinkSignallingTransferIndicationTDD-Extensions',
        u'DownlinkSignallingTransferRequest-IEs',
        u'DownlinkSignallingTransferRequest-Extensions',
        u'RelocationCommit-IEs',
        u'RelocationCommit-Extensions',
        u'PagingRequest-IEs',
        u'URAItem-PagingRqst-ExtIEs',
        u'CellItem-PagingRqst-ExtIEs',
        u'CNOriginatedPage-PagingRqst-ExtIEs',
        u'PagingRequest-Extensions',
        u'DedicatedMeasurementInitiationRequest-IEs',
        u'RLItem-DM-Rqst-ExtIEs',
        u'RL-Information-DM-Rqst-IEs',
        u'RL-InformationItem-DM-Rqst-ExtIEs',
        u'RL-SetItem-DM-Rqst-ExtIEs',
        u'RL-Set-Information-DM-Rqst-IEs',
        u'RL-Set-InformationItem-DM-Rqst-ExtIEs',
        u'DedicatedMeasurementInitiationRequest-Extensions',
        u'DedicatedMeasurementInitiationResponse-IEs',
        u'RLItem-DM-Rsp-ExtIEs',
        u'RL-SetItem-DM-Rsp-ExtIEs',
        u'RL-Information-DM-Rsp-IEs',
        u'RL-InformationItem-DM-Rsp-ExtIEs',
        u'RL-Set-Information-DM-Rsp-IEs',
        u'RL-Set-InformationItem-DM-Rspns-ExtIEs',
        u'DedicatedMeasurementInitiationResponse-Extensions',
        u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs',
        u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp-ExtIEs',
        u'DedicatedMeasurementInitiationFailure-IEs',
        u'DedicatedMeasurementInitiationFailure-Extensions',
        u'RLItem-DM-Fail-ExtIEs',
        u'RL-SetItem-DM-Fail-ExtIEs',
        u'RL-Unsuccessful-InformationResp-DM-Fail-IEs',
        u'RL-Unsuccessful-InformationItem-DM-Fail-ExtIEs',
        u'RL-Successful-InformationResp-DM-Fail-IEs',
        u'RL-Successful-InformationItem-DM-Fail-ExtIEs',
        u'RL-Set-Unsuccessful-InformationResp-DM-Fail-IEs',
        u'RL-Set-Unsuccessful-InformationItem-DM-Failns-ExtIEs',
        u'RL-Set-Successful-InformationResp-DM-Fail-IEs',
        u'RL-Set-Successful-InformationItem-DM-Failns-ExtIEs',
        u'DedicatedMeasurementReport-IEs',
        u'RLItem-DM-Rprt-ExtIEs',
        u'RL-SetItem-DM-Rprt-ExtIEs',
        u'RL-Information-DM-Rprt-IEs',
        u'RL-InformationItem-DM-Rprt-ExtIEs',
        u'RL-Set-Information-DM-Rprt-IEs',
        u'RL-Set-InformationItem-DM-Rprt-ExtIEs',
        u'DedicatedMeasurementReport-Extensions',
        u'DedicatedMeasurementTerminationRequest-IEs',
        u'DedicatedMeasurementTerminationRequest-Extensions',
        u'DedicatedMeasurementFailureIndication-IEs',
        u'DedicatedMeasurementFailureIndication-Extensions',
        u'RLItem-DM-Fail-Ind-ExtIEs',
        u'RL-SetItem-DM-Fail-Ind-ExtIEs',
        u'RL-Unsuccessful-InformationResp-DM-Fail-Ind-IEs',
        u'RL-Unsuccessful-InformationItem-DM-Fail-Ind-ExtIEs',
        u'RL-Set-Unsuccessful-InformationResp-DM-Fail-Ind-IEs',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Indns-ExtIEs',
        u'CommonTransportChannelResourcesReleaseRequest-IEs',
        u'CommonTransportChannelResourcesReleaseRequest-Extensions',
        u'CommonTransportChannelResourcesRequest-IEs',
        u'CommonTransportChannelResourcesRequest-Extensions',
        u'CommonTransportChannelResourcesResponseFDD-IEs',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD-ExtIEs',
        u'FACH-FlowControlInformationIEs-CTCH-ResourceRspFDD',
        u'CommonTransportChannelResourcesResponseFDD-Extensions',
        u'CommonTransportChannelResourcesResponseTDD-IEs',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD-ExtIEs',
        u'FACH-FlowControlInformationIEs-CTCH-ResourceRspTDD',
        u'CommonTransportChannelResourcesResponseTDD-Extensions',
        u'CommonTransportChannelResourcesFailure-IEs',
        u'CommonTransportChannelResourcesFailure-Extensions',
        u'CompressedModeCommand-IEs',
        u'CompressedModeCommand-Extensions',
        u'ErrorIndication-IEs',
        u'ErrorIndication-Extensions',
        u'CommonMeasurementInitiationRequest-IEs',
        u'CommonMeasurementInitiationRequest-Extensions',
        u'Extension-neighbouringCellMeasurementInformationIE',
        u'Extension-neighbouringCellMeasurementInformation768IE',
        u'CellItem-CM-Rqst-ExtIEs',
        u'Additional-CommonMeasurementObjectType-CM-RqstIE',
        u'GSMCell-CM-Rqst-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-RqstIE',
        u'GsmCellItem-CM-Rqst-ExtIEs',
        u'CommonMeasurementInitiationResponse-IEs',
        u'CommonMeasurementInitiationResponse-Extensions',
        u'CellItem-CM-Rsp-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-RspIE',
        u'GsmCellItem-CM-Rsp-ExtIEs',
        u'CommonMeasurementInitiationFailure-IEs',
        u'CommonMeasurementInitiationFailure-Extensions',
        u'Extension-FailureMeasurementItem-ExtIEs',
        u'CommonMeasurementReport-IEs',
        u'CommonMeasurementReport-Extensions',
        u'CellItem-CM-Rprt-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-RprtIE',
        u'GsmCellItem-CM-Rprt-ExtIEs',
        u'CommonMeasurementTerminationRequest-IEs',
        u'CommonMeasurementTerminationRequest-Extensions',
        u'Extension-TerminationMeasurementItem-ExtIEs',
        u'CommonMeasurementFailureIndication-IEs',
        u'CommonMeasurementFailureIndication-Extensions',
        u'Extension-FailureIndicationMeasurementItem-ExtIEs',
        u'InformationExchangeInitiationRequest-IEs',
        u'InformationExchangeInitiationRequest-Extensions',
        u'CellItem-InfEx-Rqst-ExtIEs',
        u'Extension-InformationExchangeObjectType-InfEx-RqstIE',
        u'GSMCellItem-InfEx-Rqst-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst-ExtIEs',
        u'InformationExchangeInitiationResponse-IEs',
        u'InformationExchangeInitiationResponse-Extensions',
        u'CellItem-InfEx-Rsp-ExtIEs',
        u'Extension-InformationExchangeObjectType-InfEx-RspIE',
        u'MBMS-Bearer-ServiceItem-InfEx-Rsp-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp-ExtIEs',
        u'MBMS-Cell-Item-InfEx-Rsp-ExtIEs',
        u'ANR-Cell-ItemIEs-InfEx-Rsp-ExtIEs',
        u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp-ExtIEs',
        u'InformationExchangeInitiationFailure-IEs',
        u'InformationExchangeInitiationFailure-Extensions',
        u'InformationReport-IEs',
        u'InformationReport-Extensions',
        u'Extension-InformationExchangeObjectType-InfEx-RprtIE',
        u'CellItem-InfEx-Rprt-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt-ExtIEs',
        u'MBMS-Bearer-Service-List-Item-InfEx-Rprt-ExtIEs',
        u'MBMS-Cell-Item-InfEx-Rprt-ExtIEs',
        u'Common-E-RGCH-Cell-Item-InfEx-Rprt-ExtIEs',
        u'InformationExchangeTerminationRequest-IEs',
        u'InformationExchangeTerminationRequest-Extensions',
        u'InformationExchangeFailureIndication-IEs',
        u'InformationExchangeFailureIndication-Extensions',
        u'ResetRequest-IEs',
        u'ResetRequest-Extensions',
        u'ContextItem-Reset-ExtIEs',
        u'ContextInfoItemIE-Reset',
        u'ContextInfoItem-Reset-ExtIEs',
        u'Extension-ContextType-ResetIE',
        u'ContextGroupItem-Reset-ExtIEs',
        u'ContextGroupInfoItemIE-Reset',
        u'ContextGroupInfoItem-Reset-ExtIEs',
        u'ResetResponse-IEs',
        u'ResetResponse-Extensions',
        u'RadioLinkActivationCommandFDD-IEs',
        u'RadioLinkActivationCommandFDD-Extensions',
        u'DelayedActivationInformation-RL-ActivationCmdFDD-IEs',
        u'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs',
        u'RadioLinkActivationCommandTDD-IEs',
        u'RadioLinkActivationCommandTDD-Extensions',
        u'DelayedActivationInformation-RL-ActivationCmdTDD-IEs',
        u'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs',
        u'GERANUplinkSignallingTransferIndication-IEs',
        u'GERANUplinkSignallingTransferIndication-Extensions',
        u'RadioLinkParameterUpdateIndicationFDD-IEs',
        u'RL-ParameterUpdateIndicationFDD-RL-InformationList-IEs',
        u'RL-ParameterUpdateIndicationFDD-RL-Information-ExtIEs',
        u'RadioLinkParameterUpdateIndicationFDD-Extensions',
        u'UE-Measurement-Forwarding-ExtIEs',
        u'Additional-HS-Cell-Information-RL-Setup-ExtIEs',
        u'Additional-EDCH-FDD-Update-Information-ExtIEs',
        u'RadioLinkParameterUpdateIndicationTDD-IEs',
        u'RadioLinkParameterUpdateIndicationTDD-Extensions',
        u'UEMeasurementInitiationRequest-IEs',
        u'UEMeasurementInitiationRequest-Extensions',
        u'UEMeasurementInitiationResponse-IEs',
        u'UEMeasurementInitiationResponse-Extensions',
        u'UEMeasurementInitiationFailure-IEs',
        u'UEMeasurementInitiationFailure-Extensions',
        u'UEMeasurementReport-IEs',
        u'UEMeasurementReport-Extensions',
        u'UEMeasurementTerminationRequest-IEs',
        u'UEMeasurementTerminationRequest-Extensions',
        u'UEMeasurementFailureIndication-IEs',
        u'UEMeasurementFailureIndication-Extensions',
        u'IurInvokeTrace-IEs',
        u'InterfacesToBeTracedItemIE',
        u'InterfacesToTraceItem-ExtIEs',
        u'IurInvokeTrace-Extensions',
        u'IurDeactivateTrace-IEs',
        u'IurDeactivateTrace-Extensions',
        u'MBMSAttachCommand-IEs',
        u'MBMSAttachCommand-Extensions',
        u'MBMSDetachCommand-IEs',
        u'MBMSDetachCommand-Extensions',
        u'DirectInformationTransfer-IEs',
        u'DirectInformationTransfer-Extensions',
        u'EnhancedRelocationRequest-IEs',
        u'EnhancedRelocationRequest-Extensions',
        u'EnhancedRelocationResponse-IEs',
        u'EnhancedRelocationResponse-Extensions',
        u'EnhancedRelocationFailure-IEs',
        u'EnhancedRelocationFailure-Extensions',
        u'EnhancedRelocationCancel-IEs',
        u'EnhancedRelocationCancel-Extensions',
        u'EnhancedRelocationSignallingTransfer-IEs',
        u'EnhancedRelocationSignallingTransfer-Extensions',
        u'EnhancedRelocationRelease-IEs',
        u'EnhancedRelocationRelease-Extensions',
        u'MBSFNMCCHInformation-IEs',
        u'MBSFNMCCHInformation-Extensions',
        u'SecondaryULFrequencyReport-IEs',
        u'SecondaryULFrequencyReport-Extensions',
        u'SecondaryULFrequencyUpdateIndication-IEs',
        u'SecondaryULFrequencyUpdateIndication-Extensions',
        u'EnhancedRelocationResourceRequest-IEs',
        u'EnhancedRelocationResourceRequest-Extensions',
        u'EnhancedRelocationResourceResponse-IEs',
        u'EnhancedRelocationResourceResponse-Extensions',
        u'EnhancedRelocationResourceFailure-IEs',
        u'EnhancedRelocationResourceFailure-Extensions',
        u'EnhancedRelocationResourceReleaseCommand-IEs',
        u'EnhancedRelocationResourceReleaseCommand-Extensions',
        u'EnhancedRelocationResourceReleaseComplete-IEs',
        u'EnhancedRelocationResourceReleaseComplete-Extensions',
        u'PrivateMessage-IEs',
        u'InformationTransferControlRequest-IEs',
        u'InformationTransferControlRequest-Extensions',
        u'Suspension-Control-Type-ExtIEs',
        u'Resume-Control-Type-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        u'RadioLinkSetupRequestFDD-IEs',
        u'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs',
        u'RL-InformationItemIEs-RL-SetupRqstFDD',
        u'RL-InformationItem-RL-SetupRqstFDD-ExtIEs',
        u'RadioLinkSetupRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs',
        u'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs',
        u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs',
        u'RadioLinkSetupRequestTDD-IEs',
        u'UL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'DL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs',
        u'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs',
        u'RL-Information-RL-SetupRqstTDD-ExtIEs',
        u'RadioLinkSetupRequestTDD-Extensions',
        u'RadioLinkSetupResponseFDD-IEs',
        u'RL-InformationResponseItemIEs-RL-SetupRspFDD',
        u'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs',
        u'CombiningItem-RL-SetupRspFDD-ExtIEs',
        u'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs',
        u'RadioLinkSetupResponseFDD-Extensions',
        u'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs',
        u'RadioLinkSetupResponseTDD-IEs',
        u'RL-InformationResponse-RL-SetupRspTDD-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-SetupRspTDD',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-SetupRspTDD',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-SetupRspTDD',
        u'DSCH-InformationList-RL-SetupRspTDD',
        u'DSCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'USCH-InformationList-RL-SetupRspTDD',
        u'USCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'RadioLinkSetupResponseTDD-Extensions',
        u'RL-LCR-InformationResponseList-RL-SetupRspTDD-ExtIEs',
        u'UL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'DSCH-LCR-InformationList-RL-SetupRspTDD',
        u'DSCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'USCH-LCR-InformationList-RL-SetupRspTDD',
        u'USCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs',
        u'RL-InformationResponse-RL-SetupRspTDD768-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD768',
        u'UL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-SetupRspTDD768',
        u'UL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD768',
        u'DL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-SetupRspTDD768',
        u'DL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs',
        u'RadioLinkSetupFailureFDD-IEs',
        u'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs',
        u'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs',
        u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs',
        u'CombiningItem-RL-SetupFailureFDD-ExtIEs',
        u'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs',
        u'RadioLinkSetupFailureFDD-Extensions',
        u'RadioLinkSetupFailureTDD-IEs',
        u'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs',
        u'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs',
        u'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD-ExtIEs',
        u'RadioLinkSetupFailureTDD-Extensions',
        u'RadioLinkAdditionRequestFDD-IEs',
        u'RL-Information-RL-AdditionRqstFDD-IEs',
        u'RL-Information-RL-AdditionRqstFDD-ExtIEs',
        u'RadioLinkAdditionRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs',
        u'EDPCH-Information-RLAdditionReq-FDD-ExtIEs',
        u'RadioLinkAdditionRequestTDD-IEs',
        u'RL-Information-RL-AdditionRqstTDD-ExtIEs',
        u'RadioLinkAdditionRequestTDD-Extensions',
        u'UL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD',
        u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD',
        u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs',
        u'RadioLinkAdditionResponseFDD-IEs',
        u'RL-InformationResponseItemIEs-RL-AdditionRspFDD',
        u'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs',
        u'DL-CodeInformationListIEs-RL-AdditionRspFDD',
        u'CombiningItem-RL-AdditionRspFDD-ExtIEs',
        u'NonCombiningItem-RL-AdditionRspFDD-ExtIEs',
        u'RadioLinkAdditionResponseFDD-Extensions',
        u'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs',
        u'RadioLinkAdditionResponseTDD-IEs',
        u'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DCH-Information-RL-AdditionRspTDD-ExtIEs',
        u'CombiningItem-RL-AdditionRspTDD-ExtIEs',
        u'NonCombiningItem-RL-AdditionRspTDD-ExtIEs',
        u'DSCH-InformationListIEs-RL-AdditionRspTDD',
        u'DSCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DiversityIndication-RL-AdditionRspTDD2-ExtIEs',
        u'USCH-InformationListIEs-RL-AdditionRspTDD',
        u'USCHInformationItem-RL-AdditionRspTDD-ExtIEs',
        u'RadioLinkAdditionResponseTDD-Extensions',
        u'RL-LCR-InformationResponseList-RL-AdditionRspTDD-ExtIEs',
        u'UL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD',
        u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationList-RL-AdditionRspTDD',
        u'DSCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'USCH-LCR-InformationList-RL-AdditionRspTDD',
        u'USCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs',
        u'RL-InformationResponse-RL-AdditionRspTDD768-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD768',
        u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD768',
        u'UL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD768',
        u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD768',
        u'DL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs',
        u'RadioLinkAdditionFailureFDD-IEs',
        u'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs',
        u'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs',
        u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs',
        u'DL-CodeInformationListIEs-RL-AdditionFailureFDD',
        u'CombiningItem-RL-AdditionFailureFDD-ExtIEs',
        u'NonCombiningItem-RL-AdditionFailureFDD-ExtIEs',
        u'RadioLinkAdditionFailureFDD-Extensions',
        u'RadioLinkAdditionFailureTDD-IEs',
        u'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs',
        u'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs',
        u'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD',
        u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD-ExtIEs',
        u'RadioLinkAdditionFailureTDD-Extensions',
        u'RadioLinkDeletionRequest-IEs',
        u'RL-Information-RL-DeletionRqst-IEs',
        u'RL-Information-RL-DeletionRqst-ExtIEs',
        u'RadioLinkDeletionRequest-Extensions',
        u'RadioLinkDeletionResponse-IEs',
        u'RadioLinkDeletionResponse-Extensions',
        u'RadioLinkReconfigurationPrepareFDD-IEs',
        u'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs',
        u'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs',
        u'RL-Information-RL-ReconfPrepFDD-IEs',
        u'RL-Information-RL-ReconfPrepFDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs',
        u'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs',
        u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareTDD-IEs',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-ExtIEs',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-ExtIEs',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs',
        u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs',
        u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'DL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'DSCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'DSCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'USCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs',
        u'USCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs',
        u'RadioLinkReconfigurationPrepareTDD-Extensions',
        u'RL-InformationIE-RL-ReconfPrepTDD-ExtIEs',
        u'RadioLinkReconfigurationReadyFDD-IEs',
        u'RL-InformationResponse-RL-ReconfReadyFDD-IEs',
        u'RL-InformationResponseItem-RL-ReconfReadyFDD-ExtIEs',
        u'DL-CodeInformationListIEs-RL-ReconfReadyFDD',
        u'DCH-InformationResponseListIEs-RL-ReconfReadyFDD',
        u'RadioLinkReconfigurationReadyFDD-Extensions',
        u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs-ExtIEs',
        u'RadioLinkReconfigurationReadyTDD-IEs',
        u'RL-InformationResponse-RL-ReconfReadyTDD-ExtIEs',
        u'UL-CCTrCHInformationListIEs-RL-ReconfReadyTDD',
        u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs',
        u'UL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'UL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD',
        u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs',
        u'DL-CCTrCHInformationListIEs-RL-ReconfReadyTDD',
        u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs',
        u'DL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs',
        u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs',
        u'DL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD',
        u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs',
        u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD',
        u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs',
        u'USCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD',
        u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs',
        u'RadioLinkReconfigurationReadyTDD-Extensions',
        u'RadioLinkReconfigurationCommit-IEs',
        u'RadioLinkReconfigurationCommit-Extensions',
        u'RadioLinkReconfigurationFailure-IEs',
        u'GeneralCauseItem-RL-ReconfFailure-ExtIEs',
        u'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs',
        u'RL-ReconfigurationFailure-RL-ReconfFailure-IEs',
        u'RL-ReconfigurationFailure-RL-ReconfFailure-ExtIEs',
        u'RadioLinkReconfigurationFailure-Extensions',
        u'RadioLinkReconfigurationCancel-IEs',
        u'RadioLinkReconfigurationCancel-Extensions',
        u'RadioLinkReconfigurationRequestFDD-IEs',
        u'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        u'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs',
        u'RadioLinkReconfigurationRequestFDD-Extensions',
        u'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs',
        u'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs',
        u'RL-ReconfigurationRequestFDD-RL-Information-ListItem',
        u'RL-ReconfigurationRequestFDD-RL-Information-ExtIEs',
        u'RadioLinkReconfigurationRequestTDD-IEs',
        u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs',
        u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs',
        u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs',
        u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs',
        u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs',
        u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs',
        u'RadioLinkReconfigurationRequestTDD-Extensions',
        u'RL-ReconfigurationRequestTDD-RL-Information-ExtIEs',
        u'RadioLinkReconfigurationResponseFDD-IEs',
        u'RL-InformationResponse-RL-ReconfRspFDD-IEs',
        u'RL-InformationResponseItem-RL-ReconfRspFDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-ReconfRspFDD',
        u'DL-CodeInformationListIEs-RL-ReconfRspFDD',
        u'RadioLinkReconfigurationResponseFDD-Extensions',
        u'RadioLinkReconfigurationResponseTDD-IEs',
        u'RL-InformationResponse-RL-ReconfRspTDD-ExtIEs',
        u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD-ExtIEs',
        u'DL-DPCH-InformationModifyListIEs-LCR-RL-ReconfRspTDD',
        u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD-ExtIEs',
        u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD-ExtIEs',
        u'DCH-InformationResponseListIEs-RL-ReconfRspTDD',
        u'RadioLinkReconfigurationResponseTDD-Extensions',
        u'RadioLinkFailureIndication-IEs',
        u'RLItem-RL-FailureInd-ExtIEs',
        u'RL-Information-RL-FailureInd-IEs',
        u'RL-Information-RL-FailureInd-ExtIEs',
        u'RL-SetItem-RL-FailureInd-ExtIEs',
        u'RL-Set-Information-RL-FailureInd-IEs',
        u'RL-Set-Information-RL-FailureInd-ExtIEs',
        u'RadioLinkFailureIndication-Extensions',
        u'CCTrCHItem-RL-FailureInd-ExtIEs',
        u'CCTrCH-InformationItemIE-RL-FailureInd',
        u'CCTrCH-InformationItem-RL-FailureInd-ExtIEs',
        u'RadioLinkPreemptionRequiredIndication-IEs',
        u'RL-InformationItemIEs-RL-PreemptRequiredInd',
        u'RL-Information-RL-PreemptRequiredInd-ExtIEs',
        u'RadioLinkPreemptionRequiredIndication-Extensions',
        u'HSDSCHMacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd',
        u'HSDSCHMacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs',
        u'EDCH-MacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd',
        u'EDCH-MacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs',
        u'RadioLinkRestoreIndication-IEs',
        u'RLItem-RL-RestoreInd-ExtIEs',
        u'RL-Information-RL-RestoreInd-IEs',
        u'RL-Information-RL-RestoreInd-ExtIEs',
        u'RL-SetItem-RL-RestoreInd-ExtIEs',
        u'RL-Set-Information-RL-RestoreInd-IEs',
        u'RL-Set-Information-RL-RestoreInd-ExtIEs',
        u'RadioLinkRestoreIndication-Extensions',
        u'CCTrCHItem-RL-RestoreInd-ExtIEs',
        u'CCTrCH-InformationItemIE-RL-RestoreInd',
        u'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs',
        u'DL-PowerControlRequest-IEs',
        u'DL-ReferencePowerInformation-DL-PC-Rqst-IEs',
        u'DL-ReferencePowerInformation-DL-PC-Rqst-ExtIEs',
        u'DL-PowerControlRequest-Extensions',
        u'DL-PowerTimeslotControlRequest-IEs',
        u'DL-PowerTimeslotControlRequest-Extensions',
        u'PhysicalChannelReconfigurationRequestFDD-IEs',
        u'RL-Information-PhyChReconfRqstFDD-ExtIEs',
        u'DL-CodeInformationListIEs-PhyChReconfRqstFDD',
        u'PhysicalChannelReconfigurationRequestFDD-Extensions',
        u'PhysicalChannelReconfigurationRequestTDD-IEs',
        u'RL-Information-PhyChReconfRqstTDD-ExtIEs',
        u'UL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD',
        u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-DPCH-InformationListIEs-PhyChReconfRqstTDD',
        u'UL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'DL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD',
        u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-DPCH-InformationListIEs-PhyChReconfRqstTDD',
        u'DL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs',
        u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD-ExtIEs',
        u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs',
        u'PhysicalChannelReconfigurationRequestTDD-Extensions',
        u'PhysicalChannelReconfigurationCommand-IEs',
        u'PhysicalChannelReconfigurationCommand-Extensions',
        u'PhysicalChannelReconfigurationFailure-IEs',
        u'PhysicalChannelReconfigurationFailure-Extensions',
        u'RadioLinkCongestionIndication-IEs',
        u'RL-InformationItemIEs-RL-CongestInd',
        u'DCH-Rate-InformationItemIEs-RL-CongestInd',
        u'DCH-Rate-InformationItem-RL-CongestInd-ExtIEs',
        u'RL-Information-RL-CongestInd-ExtIEs',
        u'RadioLinkCongestionIndication-Extensions',
        u'EDCH-MacdFlowSpecificInformationItemIEs-RL-CongestInd',
        u'EDCH-MacdFlowSpecificInformation-RL-CongestInd-ExtIEs',
        u'UplinkSignallingTransferIndicationFDD-IEs',
        u'UplinkSignallingTransferIndicationFDD-Extensions',
        u'UplinkSignallingTransferIndicationTDD-IEs',
        u'UplinkSignallingTransferIndicationTDD-Extensions',
        u'DownlinkSignallingTransferRequest-IEs',
        u'DownlinkSignallingTransferRequest-Extensions',
        u'RelocationCommit-IEs',
        u'RelocationCommit-Extensions',
        u'PagingRequest-IEs',
        u'URAItem-PagingRqst-ExtIEs',
        u'CellItem-PagingRqst-ExtIEs',
        u'CNOriginatedPage-PagingRqst-ExtIEs',
        u'PagingRequest-Extensions',
        u'DedicatedMeasurementInitiationRequest-IEs',
        u'RLItem-DM-Rqst-ExtIEs',
        u'RL-Information-DM-Rqst-IEs',
        u'RL-InformationItem-DM-Rqst-ExtIEs',
        u'RL-SetItem-DM-Rqst-ExtIEs',
        u'RL-Set-Information-DM-Rqst-IEs',
        u'RL-Set-InformationItem-DM-Rqst-ExtIEs',
        u'DedicatedMeasurementInitiationRequest-Extensions',
        u'DedicatedMeasurementInitiationResponse-IEs',
        u'RLItem-DM-Rsp-ExtIEs',
        u'RL-SetItem-DM-Rsp-ExtIEs',
        u'RL-Information-DM-Rsp-IEs',
        u'RL-InformationItem-DM-Rsp-ExtIEs',
        u'RL-Set-Information-DM-Rsp-IEs',
        u'RL-Set-InformationItem-DM-Rspns-ExtIEs',
        u'DedicatedMeasurementInitiationResponse-Extensions',
        u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs',
        u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs',
        u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp-ExtIEs',
        u'DedicatedMeasurementInitiationFailure-IEs',
        u'DedicatedMeasurementInitiationFailure-Extensions',
        u'RLItem-DM-Fail-ExtIEs',
        u'RL-SetItem-DM-Fail-ExtIEs',
        u'RL-Unsuccessful-InformationResp-DM-Fail-IEs',
        u'RL-Unsuccessful-InformationItem-DM-Fail-ExtIEs',
        u'RL-Successful-InformationResp-DM-Fail-IEs',
        u'RL-Successful-InformationItem-DM-Fail-ExtIEs',
        u'RL-Set-Unsuccessful-InformationResp-DM-Fail-IEs',
        u'RL-Set-Unsuccessful-InformationItem-DM-Failns-ExtIEs',
        u'RL-Set-Successful-InformationResp-DM-Fail-IEs',
        u'RL-Set-Successful-InformationItem-DM-Failns-ExtIEs',
        u'DedicatedMeasurementReport-IEs',
        u'RLItem-DM-Rprt-ExtIEs',
        u'RL-SetItem-DM-Rprt-ExtIEs',
        u'RL-Information-DM-Rprt-IEs',
        u'RL-InformationItem-DM-Rprt-ExtIEs',
        u'RL-Set-Information-DM-Rprt-IEs',
        u'RL-Set-InformationItem-DM-Rprt-ExtIEs',
        u'DedicatedMeasurementReport-Extensions',
        u'DedicatedMeasurementTerminationRequest-IEs',
        u'DedicatedMeasurementTerminationRequest-Extensions',
        u'DedicatedMeasurementFailureIndication-IEs',
        u'DedicatedMeasurementFailureIndication-Extensions',
        u'RLItem-DM-Fail-Ind-ExtIEs',
        u'RL-SetItem-DM-Fail-Ind-ExtIEs',
        u'RL-Unsuccessful-InformationResp-DM-Fail-Ind-IEs',
        u'RL-Unsuccessful-InformationItem-DM-Fail-Ind-ExtIEs',
        u'RL-Set-Unsuccessful-InformationResp-DM-Fail-Ind-IEs',
        u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Indns-ExtIEs',
        u'CommonTransportChannelResourcesReleaseRequest-IEs',
        u'CommonTransportChannelResourcesReleaseRequest-Extensions',
        u'CommonTransportChannelResourcesRequest-IEs',
        u'CommonTransportChannelResourcesRequest-Extensions',
        u'CommonTransportChannelResourcesResponseFDD-IEs',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD-ExtIEs',
        u'FACH-FlowControlInformationIEs-CTCH-ResourceRspFDD',
        u'CommonTransportChannelResourcesResponseFDD-Extensions',
        u'CommonTransportChannelResourcesResponseTDD-IEs',
        u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD-ExtIEs',
        u'FACH-FlowControlInformationIEs-CTCH-ResourceRspTDD',
        u'CommonTransportChannelResourcesResponseTDD-Extensions',
        u'CommonTransportChannelResourcesFailure-IEs',
        u'CommonTransportChannelResourcesFailure-Extensions',
        u'CompressedModeCommand-IEs',
        u'CompressedModeCommand-Extensions',
        u'ErrorIndication-IEs',
        u'ErrorIndication-Extensions',
        u'CommonMeasurementInitiationRequest-IEs',
        u'CommonMeasurementInitiationRequest-Extensions',
        u'Extension-neighbouringCellMeasurementInformationIE',
        u'Extension-neighbouringCellMeasurementInformation768IE',
        u'CellItem-CM-Rqst-ExtIEs',
        u'Additional-CommonMeasurementObjectType-CM-RqstIE',
        u'GSMCell-CM-Rqst-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-RqstIE',
        u'GsmCellItem-CM-Rqst-ExtIEs',
        u'CommonMeasurementInitiationResponse-IEs',
        u'CommonMeasurementInitiationResponse-Extensions',
        u'CellItem-CM-Rsp-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-RspIE',
        u'GsmCellItem-CM-Rsp-ExtIEs',
        u'CommonMeasurementInitiationFailure-IEs',
        u'CommonMeasurementInitiationFailure-Extensions',
        u'Extension-FailureMeasurementItem-ExtIEs',
        u'CommonMeasurementReport-IEs',
        u'CommonMeasurementReport-Extensions',
        u'CellItem-CM-Rprt-ExtIEs',
        u'Extension-CommonMeasurementObjectType-CM-RprtIE',
        u'GsmCellItem-CM-Rprt-ExtIEs',
        u'CommonMeasurementTerminationRequest-IEs',
        u'CommonMeasurementTerminationRequest-Extensions',
        u'Extension-TerminationMeasurementItem-ExtIEs',
        u'CommonMeasurementFailureIndication-IEs',
        u'CommonMeasurementFailureIndication-Extensions',
        u'Extension-FailureIndicationMeasurementItem-ExtIEs',
        u'InformationExchangeInitiationRequest-IEs',
        u'InformationExchangeInitiationRequest-Extensions',
        u'CellItem-InfEx-Rqst-ExtIEs',
        u'Extension-InformationExchangeObjectType-InfEx-RqstIE',
        u'GSMCellItem-InfEx-Rqst-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst-ExtIEs',
        u'InformationExchangeInitiationResponse-IEs',
        u'InformationExchangeInitiationResponse-Extensions',
        u'CellItem-InfEx-Rsp-ExtIEs',
        u'Extension-InformationExchangeObjectType-InfEx-RspIE',
        u'MBMS-Bearer-ServiceItem-InfEx-Rsp-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp-ExtIEs',
        u'MBMS-Cell-Item-InfEx-Rsp-ExtIEs',
        u'ANR-Cell-ItemIEs-InfEx-Rsp-ExtIEs',
        u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp-ExtIEs',
        u'InformationExchangeInitiationFailure-IEs',
        u'InformationExchangeInitiationFailure-Extensions',
        u'InformationReport-IEs',
        u'InformationReport-Extensions',
        u'Extension-InformationExchangeObjectType-InfEx-RprtIE',
        u'CellItem-InfEx-Rprt-ExtIEs',
        u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt-ExtIEs',
        u'MBMS-Bearer-Service-List-Item-InfEx-Rprt-ExtIEs',
        u'MBMS-Cell-Item-InfEx-Rprt-ExtIEs',
        u'Common-E-RGCH-Cell-Item-InfEx-Rprt-ExtIEs',
        u'InformationExchangeTerminationRequest-IEs',
        u'InformationExchangeTerminationRequest-Extensions',
        u'InformationExchangeFailureIndication-IEs',
        u'InformationExchangeFailureIndication-Extensions',
        u'ResetRequest-IEs',
        u'ResetRequest-Extensions',
        u'ContextItem-Reset-ExtIEs',
        u'ContextInfoItemIE-Reset',
        u'ContextInfoItem-Reset-ExtIEs',
        u'Extension-ContextType-ResetIE',
        u'ContextGroupItem-Reset-ExtIEs',
        u'ContextGroupInfoItemIE-Reset',
        u'ContextGroupInfoItem-Reset-ExtIEs',
        u'ResetResponse-IEs',
        u'ResetResponse-Extensions',
        u'RadioLinkActivationCommandFDD-IEs',
        u'RadioLinkActivationCommandFDD-Extensions',
        u'DelayedActivationInformation-RL-ActivationCmdFDD-IEs',
        u'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs',
        u'RadioLinkActivationCommandTDD-IEs',
        u'RadioLinkActivationCommandTDD-Extensions',
        u'DelayedActivationInformation-RL-ActivationCmdTDD-IEs',
        u'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs',
        u'GERANUplinkSignallingTransferIndication-IEs',
        u'GERANUplinkSignallingTransferIndication-Extensions',
        u'RadioLinkParameterUpdateIndicationFDD-IEs',
        u'RL-ParameterUpdateIndicationFDD-RL-InformationList-IEs',
        u'RL-ParameterUpdateIndicationFDD-RL-Information-ExtIEs',
        u'RadioLinkParameterUpdateIndicationFDD-Extensions',
        u'UE-Measurement-Forwarding-ExtIEs',
        u'Additional-HS-Cell-Information-RL-Setup-ExtIEs',
        u'Additional-EDCH-FDD-Update-Information-ExtIEs',
        u'RadioLinkParameterUpdateIndicationTDD-IEs',
        u'RadioLinkParameterUpdateIndicationTDD-Extensions',
        u'UEMeasurementInitiationRequest-IEs',
        u'UEMeasurementInitiationRequest-Extensions',
        u'UEMeasurementInitiationResponse-IEs',
        u'UEMeasurementInitiationResponse-Extensions',
        u'UEMeasurementInitiationFailure-IEs',
        u'UEMeasurementInitiationFailure-Extensions',
        u'UEMeasurementReport-IEs',
        u'UEMeasurementReport-Extensions',
        u'UEMeasurementTerminationRequest-IEs',
        u'UEMeasurementTerminationRequest-Extensions',
        u'UEMeasurementFailureIndication-IEs',
        u'UEMeasurementFailureIndication-Extensions',
        u'IurInvokeTrace-IEs',
        u'InterfacesToBeTracedItemIE',
        u'InterfacesToTraceItem-ExtIEs',
        u'IurInvokeTrace-Extensions',
        u'IurDeactivateTrace-IEs',
        u'IurDeactivateTrace-Extensions',
        u'MBMSAttachCommand-IEs',
        u'MBMSAttachCommand-Extensions',
        u'MBMSDetachCommand-IEs',
        u'MBMSDetachCommand-Extensions',
        u'DirectInformationTransfer-IEs',
        u'DirectInformationTransfer-Extensions',
        u'EnhancedRelocationRequest-IEs',
        u'EnhancedRelocationRequest-Extensions',
        u'EnhancedRelocationResponse-IEs',
        u'EnhancedRelocationResponse-Extensions',
        u'EnhancedRelocationFailure-IEs',
        u'EnhancedRelocationFailure-Extensions',
        u'EnhancedRelocationCancel-IEs',
        u'EnhancedRelocationCancel-Extensions',
        u'EnhancedRelocationSignallingTransfer-IEs',
        u'EnhancedRelocationSignallingTransfer-Extensions',
        u'EnhancedRelocationRelease-IEs',
        u'EnhancedRelocationRelease-Extensions',
        u'MBSFNMCCHInformation-IEs',
        u'MBSFNMCCHInformation-Extensions',
        u'SecondaryULFrequencyReport-IEs',
        u'SecondaryULFrequencyReport-Extensions',
        u'SecondaryULFrequencyUpdateIndication-IEs',
        u'SecondaryULFrequencyUpdateIndication-Extensions',
        u'EnhancedRelocationResourceRequest-IEs',
        u'EnhancedRelocationResourceRequest-Extensions',
        u'EnhancedRelocationResourceResponse-IEs',
        u'EnhancedRelocationResourceResponse-Extensions',
        u'EnhancedRelocationResourceFailure-IEs',
        u'EnhancedRelocationResourceFailure-Extensions',
        u'EnhancedRelocationResourceReleaseCommand-IEs',
        u'EnhancedRelocationResourceReleaseCommand-Extensions',
        u'EnhancedRelocationResourceReleaseComplete-IEs',
        u'EnhancedRelocationResourceReleaseComplete-Extensions',
        u'PrivateMessage-IEs',
        u'InformationTransferControlRequest-IEs',
        u'InformationTransferControlRequest-Extensions',
        u'Suspension-Control-Type-ExtIEs',
        u'Resume-Control-Type-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< RadioLinkSetupRequestFDD >-----#
    RadioLinkSetupRequestFDD = SEQ(name=u'RadioLinkSetupRequestFDD', mode=MODE_TYPE)
    _RadioLinkSetupRequestFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-Information')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 60), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 118), (u'criticality', u'notify'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 255), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupRequestFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkSetupRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupRequestFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkSetupRequestFDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupRequestFDD_protocolIEs__item_._ext = None
    _RadioLinkSetupRequestFDD_protocolIEs._cont = __RadioLinkSetupRequestFDD_protocolIEs__item_
    _RadioLinkSetupRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupRequestFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDPCH-Information-FDD')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'F-DPCH-Information-RL-SetupRqstFDD')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Indicator-For-E-DCH-HSDPA-Operation')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-DTX-DRX-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Setup-List')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Setup-Info')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Usefulness-Of-Battery-Optimization')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_19 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_20 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_21 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_22 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_23 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_24 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_25 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_26 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information')))
    ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 452), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'conditional')]), dict([(u'id', 560), (u'criticality', u'notify'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 574), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'conditional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 559), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 592), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 665), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 601), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 670), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 671), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 794), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 837), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 891), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 906), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 964), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_22), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_23), (u'presence', u'optional')]), dict([(u'id', 968), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_24), (u'presence', u'optional')]), dict([(u'id', 987), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_25), (u'presence', u'optional')]), dict([(u'id', 983), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_26), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkSetupRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupRequestFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupRequestFDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupRequestFDD_protocolExtensions._cont = __RadioLinkSetupRequestFDD_protocolExtensions__item_
    _RadioLinkSetupRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupRequestFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkSetupRequestFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkSetupRequestFDD_protocolExtensions),
        ])
    RadioLinkSetupRequestFDD._ext = []
    
    #-----< RadioLinkSetupRequestFDD-IEs >-----#
    RadioLinkSetupRequestFDD_IEs = CLASS(name=u'RadioLinkSetupRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-Information')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    _RadioLinkSetupRequestFDD_IEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    RadioLinkSetupRequestFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 179), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 60), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 34), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 118), (u'criticality', u'notify'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 255), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 193), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestFDD_IEs_val_Value_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-SetupRqstFDD >-----#
    UL_DPCH_Information_RL_SetupRqstFDD = SEQ(name=u'UL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_ScramblingCode = SEQ(name=u'ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-ScramblingCode')))
    _UL_DPCH_Information_RL_SetupRqstFDD_minUL_ChannelisationCodeLength = ENUM(name=u'minUL-ChannelisationCodeLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MinUL-ChannelisationCodeLength')))
    _UL_DPCH_Information_RL_SetupRqstFDD_maxNrOfUL_DPCHs = INT(name=u'maxNrOfUL-DPCHs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrOfUL-DPCHs')), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit = INT(name=u'ul-PunctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_TFCS = SEQ(name=u'ul-TFCS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_DPCCH_SlotFormat = INT(name=u'ul-DPCCH-SlotFormat', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH-SlotFormat')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ul_SIRTarget = INT(name=u'ul-SIRTarget', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_diversityMode = ENUM(name=u'diversityMode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiversityMode')))
    _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_sSDT_CellIdLength = NULL(name=u'not-Used-sSDT-CellIdLength', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_s_FieldLength = NULL(name=u'not-Used-s-FieldLength', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode')))
    _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPDCHIndicatorEDCH')))
    ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'reject'), (u'Extension', _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 573), (u'criticality', u'reject'), (u'Extension', _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        (u'ul-ScramblingCode', _UL_DPCH_Information_RL_SetupRqstFDD_ul_ScramblingCode),
        (u'minUL-ChannelisationCodeLength', _UL_DPCH_Information_RL_SetupRqstFDD_minUL_ChannelisationCodeLength),
        (u'maxNrOfUL-DPCHs', _UL_DPCH_Information_RL_SetupRqstFDD_maxNrOfUL_DPCHs),
        (u'ul-PunctureLimit', _UL_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit),
        (u'ul-TFCS', _UL_DPCH_Information_RL_SetupRqstFDD_ul_TFCS),
        (u'ul-DPCCH-SlotFormat', _UL_DPCH_Information_RL_SetupRqstFDD_ul_DPCCH_SlotFormat),
        (u'ul-SIRTarget', _UL_DPCH_Information_RL_SetupRqstFDD_ul_SIRTarget),
        (u'diversityMode', _UL_DPCH_Information_RL_SetupRqstFDD_diversityMode),
        (u'not-Used-sSDT-CellIdLength', _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_sSDT_CellIdLength),
        (u'not-Used-s-FieldLength', _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_s_FieldLength),
        (u'iE-Extensions', _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    UL_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name=u'UL-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode')))
    _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPDCHIndicatorEDCH')))
    UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'reject'), (u'Extension', _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 573), (u'criticality', u'reject'), (u'Extension', _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-SetupRqstFDD >-----#
    DL_DPCH_Information_RL_SetupRqstFDD = SEQ(name=u'DL-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _DL_DPCH_Information_RL_SetupRqstFDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _DL_DPCH_Information_RL_SetupRqstFDD_dl_DPCH_SlotFormat = INT(name=u'dl-DPCH-SlotFormat', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-SlotFormat')))
    _DL_DPCH_Information_RL_SetupRqstFDD_nrOfDLchannelisationcodes = INT(name=u'nrOfDLchannelisationcodes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NrOfDLchannelisationcodes')))
    _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_SignallingMode = ENUM(name=u'tFCI-SignallingMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-SignallingMode')))
    _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_DPCH_Information_RL_SetupRqstFDD_multiplexingPosition = ENUM(name=u'multiplexingPosition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MultiplexingPosition')))
    _DL_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation = SEQ(name=u'powerOffsetInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PowerOffsetInformation-RL-SetupRqstFDD')))
    _DL_DPCH_Information_RL_SetupRqstFDD_fdd_dl_TPC_DownlinkStepSize = ENUM(name=u'fdd-dl-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _DL_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease = ENUM(name=u'limitedPowerIncrease', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LimitedPowerIncrease')))
    _DL_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus = ENUM(name=u'innerLoopDLPCStatus', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        (u'tFCS', _DL_DPCH_Information_RL_SetupRqstFDD_tFCS),
        (u'dl-DPCH-SlotFormat', _DL_DPCH_Information_RL_SetupRqstFDD_dl_DPCH_SlotFormat),
        (u'nrOfDLchannelisationcodes', _DL_DPCH_Information_RL_SetupRqstFDD_nrOfDLchannelisationcodes),
        (u'tFCI-SignallingMode', _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_SignallingMode),
        (u'tFCI-Presence', _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_Presence),
        (u'multiplexingPosition', _DL_DPCH_Information_RL_SetupRqstFDD_multiplexingPosition),
        (u'powerOffsetInformation', _DL_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation),
        (u'fdd-dl-TPC-DownlinkStepSize', _DL_DPCH_Information_RL_SetupRqstFDD_fdd_dl_TPC_DownlinkStepSize),
        (u'limitedPowerIncrease', _DL_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease),
        (u'innerLoopDLPCStatus', _DL_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus),
        (u'iE-Extensions', _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    DL_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    DL_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name=u'DL-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-RL-SetupRqstFDD >-----#
    PowerOffsetInformation_RL_SetupRqstFDD = SEQ(name=u'PowerOffsetInformation-RL-SetupRqstFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_RL_SetupRqstFDD_po1_ForTFCI_Bits = INT(name=u'po1-ForTFCI-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_SetupRqstFDD_po2_ForTPC_Bits = INT(name=u'po2-ForTPC-Bits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_SetupRqstFDD_po3_ForPilotBits = INT(name=u'po3-ForPilotBits', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions._cont = __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_
    _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_RL_SetupRqstFDD._cont = ASN1Dict([
        (u'po1-ForTFCI-Bits', _PowerOffsetInformation_RL_SetupRqstFDD_po1_ForTFCI_Bits),
        (u'po2-ForTPC-Bits', _PowerOffsetInformation_RL_SetupRqstFDD_po2_ForTPC_Bits),
        (u'po3-ForPilotBits', _PowerOffsetInformation_RL_SetupRqstFDD_po3_ForPilotBits),
        (u'iE-Extensions', _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions),
        ])
    PowerOffsetInformation_RL_SetupRqstFDD._ext = []
    
    #-----< PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs >-----#
    PowerOffsetInformation_RL_SetupRqstFDD_ExtIEs = CLASS(name=u'PowerOffsetInformation-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-SetupRqstFDD >-----#
    RL_InformationList_RL_SetupRqstFDD = SEQ_OF(name=u'RL-InformationList-RL-SetupRqstFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_SetupRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_SetupRqstFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_SetupRqstFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_SetupRqstFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-RL-SetupRqstFDD')))
    ___RL_InformationList_RL_SetupRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 123), (u'criticality', u'notify'), (u'Value', ____RL_InformationList_RL_SetupRqstFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_SetupRqstFDD__item__id._const_tab = ___RL_InformationList_RL_SetupRqstFDD__item__id_tab
    __RL_InformationList_RL_SetupRqstFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_SetupRqstFDD__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_SetupRqstFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_SetupRqstFDD__item__criticality._const_tab = ___RL_InformationList_RL_SetupRqstFDD__item__id_tab
    __RL_InformationList_RL_SetupRqstFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_SetupRqstFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_SetupRqstFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_SetupRqstFDD__item__value._const_tab = ___RL_InformationList_RL_SetupRqstFDD__item__id_tab
    __RL_InformationList_RL_SetupRqstFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_SetupRqstFDD__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_SetupRqstFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_SetupRqstFDD__item__id),
        (u'criticality', __RL_InformationList_RL_SetupRqstFDD__item__criticality),
        (u'value', __RL_InformationList_RL_SetupRqstFDD__item__value),
        ])
    _RL_InformationList_RL_SetupRqstFDD__item_._ext = None
    RL_InformationList_RL_SetupRqstFDD._cont = _RL_InformationList_RL_SetupRqstFDD__item_
    RL_InformationList_RL_SetupRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIEs-RL-SetupRqstFDD >-----#
    RL_InformationItemIEs_RL_SetupRqstFDD = CLASS(name=u'RL-InformationItemIEs-RL-SetupRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationItemIEs_RL_SetupRqstFDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-RL-SetupRqstFDD')))
    RL_InformationItemIEs_RL_SetupRqstFDD._val = ASN1Set(rv=[dict([(u'id', 123), (u'criticality', u'notify'), (u'Value', _RL_InformationItemIEs_RL_SetupRqstFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-SetupRqstFDD >-----#
    RL_InformationItem_RL_SetupRqstFDD = SEQ(name=u'RL-InformationItem-RL-SetupRqstFDD', mode=MODE_TYPE)
    _RL_InformationItem_RL_SetupRqstFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_SetupRqstFDD_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _RL_InformationItem_RL_SetupRqstFDD_firstRLS_indicator = ENUM(name=u'firstRLS-indicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FirstRLS-Indicator')))
    _RL_InformationItem_RL_SetupRqstFDD_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')))
    _RL_InformationItem_RL_SetupRqstFDD_chipOffset = INT(name=u'chipOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ChipOffset')))
    _RL_InformationItem_RL_SetupRqstFDD_propagationDelay = INT(name=u'propagationDelay', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PropagationDelay')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_diversityControlField = ENUM(name=u'diversityControlField', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiversityControlField')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_dl_InitialTX_Power = INT(name=u'dl-InitialTX-Power', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_primaryCPICH_EcNo = INT(name=u'primaryCPICH-EcNo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-EcNo')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_not_Used_sSDT_CellID = NULL(name=u'not-Used-sSDT-CellID', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_transmitDiversityIndicator = ENUM(name=u'transmitDiversityIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')), opt=True)
    _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PrimaryCPICH-EcNo')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionID')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationIndicator')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 224), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 537), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 662), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 572), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions._cont = __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_
    _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_SetupRqstFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationItem_RL_SetupRqstFDD_rL_ID),
        (u'c-ID', _RL_InformationItem_RL_SetupRqstFDD_c_ID),
        (u'firstRLS-indicator', _RL_InformationItem_RL_SetupRqstFDD_firstRLS_indicator),
        (u'frameOffset', _RL_InformationItem_RL_SetupRqstFDD_frameOffset),
        (u'chipOffset', _RL_InformationItem_RL_SetupRqstFDD_chipOffset),
        (u'propagationDelay', _RL_InformationItem_RL_SetupRqstFDD_propagationDelay),
        (u'diversityControlField', _RL_InformationItem_RL_SetupRqstFDD_diversityControlField),
        (u'dl-InitialTX-Power', _RL_InformationItem_RL_SetupRqstFDD_dl_InitialTX_Power),
        (u'primaryCPICH-EcNo', _RL_InformationItem_RL_SetupRqstFDD_primaryCPICH_EcNo),
        (u'not-Used-sSDT-CellID', _RL_InformationItem_RL_SetupRqstFDD_not_Used_sSDT_CellID),
        (u'transmitDiversityIndicator', _RL_InformationItem_RL_SetupRqstFDD_transmitDiversityIndicator),
        (u'iE-Extensions', _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions),
        ])
    RL_InformationItem_RL_SetupRqstFDD._ext = []
    
    #-----< RL-InformationItem-RL-SetupRqstFDD-ExtIEs >-----#
    RL_InformationItem_RL_SetupRqstFDD_ExtIEs = CLASS(name=u'RL-InformationItem-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PrimaryCPICH-EcNo')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionID')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_7 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationIndicator')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    RL_InformationItem_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 224), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 537), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 662), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 572), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestFDD-Extensions >-----#
    RadioLinkSetupRequestFDD_Extensions = CLASS(name=u'RadioLinkSetupRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDPCH-Information-FDD')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_7 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'F-DPCH-Information-RL-SetupRqstFDD')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_9 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_10 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Indicator-For-E-DCH-HSDPA-Operation')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-DTX-DRX-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_13 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Setup-List')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Setup-Info')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Usefulness-Of-Battery-Optimization')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_19 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_20 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_21 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_22 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_23 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_24 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_25 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLMN-Identity')))
    _RadioLinkSetupRequestFDD_Extensions_val_Extension_26 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information')))
    RadioLinkSetupRequestFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 296), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 452), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_3), (u'presence', u'conditional')]), dict([(u'id', 560), (u'criticality', u'notify'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 574), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_6), (u'presence', u'conditional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 559), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 592), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 665), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 601), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 670), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 671), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 794), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 837), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 891), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 906), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 964), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_22), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_23), (u'presence', u'optional')]), dict([(u'id', 968), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_24), (u'presence', u'optional')]), dict([(u'id', 987), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_25), (u'presence', u'optional')]), dict([(u'id', 983), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestFDD_Extensions_val_Extension_26), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Setup-List >-----#
    Additional_HS_Cell_Information_RL_Setup_List = SEQ_OF(name=u'Additional-HS-Cell-Information-RL-Setup-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Setup_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Setup-ItemIEs')))
    Additional_HS_Cell_Information_RL_Setup_List._cont = _Additional_HS_Cell_Information_RL_Setup_List__item_
    Additional_HS_Cell_Information_RL_Setup_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Setup-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Setup_ItemIEs = SEQ(name=u'Additional-HS-Cell-Information-RL-Setup-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')))
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Setup_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hSPDSCH_RL_ID),
        (u'c-ID', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_c_ID),
        (u'hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        (u'iE-Extensions', _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Setup_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Setup_ItemIEs_ExtIEs = CLASS(name=u'Additional-HS-Cell-Information-RL-Setup-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Setup_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-Information-RL-SetupRqstFDD >-----#
    F_DPCH_Information_RL_SetupRqstFDD = SEQ(name=u'F-DPCH-Information-RL-SetupRqstFDD', mode=MODE_TYPE)
    _F_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation = SEQ(name=u'powerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD')))
    _F_DPCH_Information_RL_SetupRqstFDD_fdd_dl_TPC_DownlinkStepSize = ENUM(name=u'fdd-dl-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _F_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease = ENUM(name=u'limitedPowerIncrease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LimitedPowerIncrease')))
    _F_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus = ENUM(name=u'innerLoopDLPCStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormatSupportRequest')))
    _____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 693), (u'criticality', u'reject'), (u'Extension', _____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._cont = __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_
    _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Information_RL_SetupRqstFDD._cont = ASN1Dict([
        (u'powerOffsetInformation', _F_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation),
        (u'fdd-dl-TPC-DownlinkStepSize', _F_DPCH_Information_RL_SetupRqstFDD_fdd_dl_TPC_DownlinkStepSize),
        (u'limitedPowerIncrease', _F_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease),
        (u'innerLoopDLPCStatus', _F_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus),
        (u'iE-Extensions', _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions),
        ])
    F_DPCH_Information_RL_SetupRqstFDD._ext = []
    
    #-----< F-DPCH-Information-RL-SetupRqstFDD-ExtIEs >-----#
    F_DPCH_Information_RL_SetupRqstFDD_ExtIEs = CLASS(name=u'F-DPCH-Information-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _F_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormatSupportRequest')))
    _F_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    F_DPCH_Information_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 693), (u'criticality', u'reject'), (u'Extension', _F_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _F_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD >-----#
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD = SEQ(name=u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_po2_ForTPC_Bits = INT(name=u'po2-ForTPC-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions._cont = __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_
    _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD._cont = ASN1Dict([
        (u'po2-ForTPC-Bits', _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_po2_ForTPC_Bits),
        (u'iE-Extensions', _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions),
        ])
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD._ext = []
    
    #-----< PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs >-----#
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_ExtIEs = CLASS(name=u'PowerOffsetInformation-F-DPCH-RL-SetupRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestTDD >-----#
    RadioLinkSetupRequestTDD = SEQ(name=u'RadioLinkSetupRequestTDD', mode=MODE_TYPE)
    _RadioLinkSetupRequestTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Physical-Channel-Information-RL-SetupRqstTDD')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Physical-Channel-Information-RL-SetupRqstTDD')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-Information')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-TDD-Information')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'USCH-Information')))
    _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-SetupRqstTDD')))
    ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 274), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'notify'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 53), (u'criticality', u'notify'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupRequestTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkSetupRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupRequestTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkSetupRequestTDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupRequestTDD_protocolIEs__item_._ext = None
    _RadioLinkSetupRequestTDD_protocolIEs._cont = __RadioLinkSetupRequestTDD_protocolIEs__item_
    _RadioLinkSetupRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupRequestTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNTI-Allocation-Indicator')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_17 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 323), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 560), (u'criticality', u'notify'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 655), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 659), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 677), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 807), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 812), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 811), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 863), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 884), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkSetupRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupRequestTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupRequestTDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupRequestTDD_protocolExtensions._cont = __RadioLinkSetupRequestTDD_protocolExtensions__item_
    _RadioLinkSetupRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupRequestTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkSetupRequestTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkSetupRequestTDD_protocolExtensions),
        ])
    RadioLinkSetupRequestTDD._ext = []
    
    #-----< RadioLinkSetupRequestTDD-IEs >-----#
    RadioLinkSetupRequestTDD_IEs = CLASS(name=u'RadioLinkSetupRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Physical-Channel-Information-RL-SetupRqstTDD')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_4 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Physical-Channel-Information-RL-SetupRqstTDD')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-SetupRqstTDD')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-Information')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-TDD-Information')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'USCH-Information')))
    _RadioLinkSetupRequestTDD_IEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-SetupRqstTDD')))
    RadioLinkSetupRequestTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 275), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 274), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 172), (u'criticality', u'notify'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 53), (u'criticality', u'notify'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 35), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 222), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 271), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 119), (u'criticality', u'reject'), (u'Value', _RadioLinkSetupRequestTDD_IEs_val_Value_11), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UL-Physical-Channel-Information-RL-SetupRqstTDD >-----#
    UL_Physical_Channel_Information_RL_SetupRqstTDD = SEQ(name=u'UL-Physical-Channel-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrTimeslots_UL = INT(name=u'maxNrTimeslots-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrTimeslots')))
    _UL_Physical_Channel_Information_RL_SetupRqstTDD_minimumSpreadingFactor_UL = INT(name=u'minimumSpreadingFactor-UL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MinimumSpreadingFactor')))
    _UL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrULPhysicalchannels = INT(name=u'maxNrULPhysicalchannels', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrULPhysicalchannels')))
    _UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-8PSK')))
    _____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumSpreadingFactor768')))
    ____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 512), (u'criticality', u'ignore'), (u'Extension', _____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 641), (u'criticality', u'ignore'), (u'Extension', _____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions._cont = __UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Physical_Channel_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        (u'maxNrTimeslots-UL', _UL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrTimeslots_UL),
        (u'minimumSpreadingFactor-UL', _UL_Physical_Channel_Information_RL_SetupRqstTDD_minimumSpreadingFactor_UL),
        (u'maxNrULPhysicalchannels', _UL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrULPhysicalchannels),
        (u'iE-Extensions', _UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    UL_Physical_Channel_Information_RL_SetupRqstTDD._ext = []
    
    #-----< UL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name=u'UL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-8PSK')))
    _UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumSpreadingFactor768')))
    UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 512), (u'criticality', u'ignore'), (u'Extension', _UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 641), (u'criticality', u'ignore'), (u'Extension', _UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Physical-Channel-Information-RL-SetupRqstTDD >-----#
    DL_Physical_Channel_Information_RL_SetupRqstTDD = SEQ(name=u'DL-Physical-Channel-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrTimeslots_DL = INT(name=u'maxNrTimeslots-DL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrTimeslots')))
    _DL_Physical_Channel_Information_RL_SetupRqstTDD_minimumSpreadingFactor_DL = INT(name=u'minimumSpreadingFactor-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MinimumSpreadingFactor')))
    _DL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrDLPhysicalchannels = INT(name=u'maxNrDLPhysicalchannels', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannels')))
    _DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannelsTS')))
    _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-8PSK')))
    _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-PLCCH')))
    _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumSpreadingFactor768')))
    _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannels768')))
    _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannelsTS768')))
    ____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 513), (u'criticality', u'ignore'), (u'Extension', _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 512), (u'criticality', u'ignore'), (u'Extension', _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 610), (u'criticality', u'ignore'), (u'Extension', _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 642), (u'criticality', u'ignore'), (u'Extension', _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 643), (u'criticality', u'ignore'), (u'Extension', _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 613), (u'criticality', u'ignore'), (u'Extension', _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions._cont = __DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Physical_Channel_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        (u'maxNrTimeslots-DL', _DL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrTimeslots_DL),
        (u'minimumSpreadingFactor-DL', _DL_Physical_Channel_Information_RL_SetupRqstTDD_minimumSpreadingFactor_DL),
        (u'maxNrDLPhysicalchannels', _DL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrDLPhysicalchannels),
        (u'iE-Extensions', _DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    DL_Physical_Channel_Information_RL_SetupRqstTDD._ext = []
    
    #-----< DL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name=u'DL-Physical-Channel-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannelsTS')))
    _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-8PSK')))
    _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Support-PLCCH')))
    _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumSpreadingFactor768')))
    _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannels768')))
    _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrDLPhysicalchannelsTS768')))
    DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 513), (u'criticality', u'ignore'), (u'Extension', _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 512), (u'criticality', u'ignore'), (u'Extension', _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 610), (u'criticality', u'ignore'), (u'Extension', _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 642), (u'criticality', u'ignore'), (u'Extension', _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 643), (u'criticality', u'ignore'), (u'Extension', _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 613), (u'criticality', u'ignore'), (u'Extension', _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    UL_CCTrCH_InformationList_RL_SetupRqstTDD = SEQ_OF(name=u'UL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._ext = None
    UL_CCTrCH_InformationList_RL_SetupRqstTDD._cont = _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_
    UL_CCTrCH_InformationList_RL_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD >-----#
    UL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD = CLASS(name=u'UL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    UL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD._val = ASN1Set(rv=[dict([(u'id', 171), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD = SEQ(name=u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ul_TFCS = SEQ(name=u'ul-TFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ul_PunctureLimit = INT(name=u'ul-PunctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 483), (u'criticality', u'reject'), (u'Extension', _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID),
        (u'ul-TFCS', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ul_TFCS),
        (u'tFCI-Coding', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding),
        (u'ul-PunctureLimit', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ul_PunctureLimit),
        (u'iE-Extensions', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 483), (u'criticality', u'reject'), (u'Extension', _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-RL-SetupRqstTDD >-----#
    DL_CCTrCH_InformationList_RL_SetupRqstTDD = SEQ_OF(name=u'DL-CCTrCH-InformationList-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_._ext = None
    DL_CCTrCH_InformationList_RL_SetupRqstTDD._cont = _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_
    DL_CCTrCH_InformationList_RL_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD >-----#
    DL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD = CLASS(name=u'DL-CCTrCH-InformationItemIEs-RL-SetupRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-SetupRqstTDD')))
    DL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD._val = ASN1Set(rv=[dict([(u'id', 47), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItem-RL-SetupRqstTDD >-----#
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD = SEQ(name=u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dl_TFCS = SEQ(name=u'dl-TFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dl_PunctureLimit = INT(name=u'dl-PunctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tdd_TPC_DownlinkStepSize = ENUM(name=u'tdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_TPCList = SEQ_OF(name=u'cCTrCH-TPCList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-TPCList-RL-SetupRqstTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID),
        (u'dl-TFCS', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dl_TFCS),
        (u'tFCI-Coding', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding),
        (u'dl-PunctureLimit', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dl_PunctureLimit),
        (u'tdd-TPC-DownlinkStepSize', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tdd_TPC_DownlinkStepSize),
        (u'cCTrCH-TPCList', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_TPCList),
        (u'iE-Extensions', _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-TPCList-RL-SetupRqstTDD >-----#
    CCTrCH_TPCList_RL_SetupRqstTDD = SEQ_OF(name=u'CCTrCH-TPCList-RL-SetupRqstTDD', mode=MODE_TYPE)
    _CCTrCH_TPCList_RL_SetupRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-TPCItem-RL-SetupRqstTDD')))
    CCTrCH_TPCList_RL_SetupRqstTDD._cont = _CCTrCH_TPCList_RL_SetupRqstTDD__item_
    CCTrCH_TPCList_RL_SetupRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-TPCItem-RL-SetupRqstTDD >-----#
    CCTrCH_TPCItem_RL_SetupRqstTDD = SEQ(name=u'CCTrCH-TPCItem-RL-SetupRqstTDD', mode=MODE_TYPE)
    _CCTrCH_TPCItem_RL_SetupRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions._cont = __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_
    _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_TPCItem_RL_SetupRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _CCTrCH_TPCItem_RL_SetupRqstTDD_cCTrCH_ID),
        (u'iE-Extensions', _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions),
        ])
    CCTrCH_TPCItem_RL_SetupRqstTDD._ext = []
    
    #-----< CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs >-----#
    CCTrCH_TPCItem_RL_SetupRqstTDD_ExtIEs = CLASS(name=u'CCTrCH-TPCItem-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCH_TPCItem_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Information-RL-SetupRqstTDD >-----#
    RL_Information_RL_SetupRqstTDD = SEQ(name=u'RL-Information-RL-SetupRqstTDD', mode=MODE_TYPE)
    _RL_Information_RL_SetupRqstTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_SetupRqstTDD_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _RL_Information_RL_SetupRqstTDD_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')))
    _RL_Information_RL_SetupRqstTDD_specialBurstScheduling = INT(name=u'specialBurstScheduling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SpecialBurstScheduling')))
    _RL_Information_RL_SetupRqstTDD_primaryCCPCH_RSCP = INT(name=u'primaryCCPCH-RSCP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')), opt=True)
    _RL_Information_RL_SetupRqstTDD_dL_TimeSlot_ISCP = SEQ_OF(name=u'dL-TimeSlot-ISCP', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-Info')), opt=True)
    _RL_Information_RL_SetupRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TSTD-Support-Indicator')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE)
    _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionLCRID')))
    ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 139), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 464), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 806), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 836), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_SetupRqstTDD_iE_Extensions._cont = __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_
    _RL_Information_RL_SetupRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_SetupRqstTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_SetupRqstTDD_rL_ID),
        (u'c-ID', _RL_Information_RL_SetupRqstTDD_c_ID),
        (u'frameOffset', _RL_Information_RL_SetupRqstTDD_frameOffset),
        (u'specialBurstScheduling', _RL_Information_RL_SetupRqstTDD_specialBurstScheduling),
        (u'primaryCCPCH-RSCP', _RL_Information_RL_SetupRqstTDD_primaryCCPCH_RSCP),
        (u'dL-TimeSlot-ISCP', _RL_Information_RL_SetupRqstTDD_dL_TimeSlot_ISCP),
        (u'iE-Extensions', _RL_Information_RL_SetupRqstTDD_iE_Extensions),
        ])
    RL_Information_RL_SetupRqstTDD._ext = []
    
    #-----< RL-Information-RL-SetupRqstTDD-ExtIEs >-----#
    RL_Information_RL_SetupRqstTDD_ExtIEs = CLASS(name=u'RL-Information-RL-SetupRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TSTD-Support-Indicator')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE)
    _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionLCRID')))
    RL_Information_RL_SetupRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 65), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 139), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 464), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 806), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 836), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupRequestTDD-Extensions >-----#
    RadioLinkSetupRequestTDD_Extensions = CLASS(name=u'RadioLinkSetupRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_13 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNTI-Allocation-Indicator')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_14 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_17 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    _RadioLinkSetupRequestTDD_Extensions_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkSetupRequestTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 323), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 560), (u'criticality', u'notify'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 655), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 659), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 677), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 807), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 812), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 811), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 863), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 884), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupRequestTDD_Extensions_val_Extension_18), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseFDD >-----#
    RadioLinkSetupResponseFDD = SEQ(name=u'RadioLinkSetupResponseFDD', mode=MODE_TYPE)
    _RadioLinkSetupResponseFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupResponseFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-SetupRspFDD')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupResponseFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkSetupResponseFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupResponseFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkSetupResponseFDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupResponseFDD_protocolIEs__item_._ext = None
    _RadioLinkSetupResponseFDD_protocolIEs._cont = __RadioLinkSetupResponseFDD_protocolIEs__item_
    _RadioLinkSetupResponseFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupResponseFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupResponseFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 795), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 838), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkSetupResponseFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupResponseFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupResponseFDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupResponseFDD_protocolExtensions._cont = __RadioLinkSetupResponseFDD_protocolExtensions__item_
    _RadioLinkSetupResponseFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupResponseFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkSetupResponseFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkSetupResponseFDD_protocolExtensions),
        ])
    RadioLinkSetupResponseFDD._ext = []
    
    #-----< RadioLinkSetupResponseFDD-IEs >-----#
    RadioLinkSetupResponseFDD_IEs = CLASS(name=u'RadioLinkSetupResponseFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-SetupRspFDD')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RadioLinkSetupResponseFDD_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupResponseFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseFDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseFDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 137), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseFDD_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseFDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseFDD_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-SetupRspFDD >-----#
    RL_InformationResponseList_RL_SetupRspFDD = SEQ_OF(name=u'RL-InformationResponseList-RL-SetupRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_SetupRspFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_SetupRspFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_SetupRspFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-SetupRspFDD')))
    ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', ____RL_InformationResponseList_RL_SetupRspFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_SetupRspFDD__item__id._const_tab = ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab
    __RL_InformationResponseList_RL_SetupRspFDD__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_SetupRspFDD__item__id._const_tab_id = u'id'
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality._const_tab = ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_SetupRspFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationResponseList_RL_SetupRspFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationResponseList_RL_SetupRspFDD__item__value._const_tab = ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab
    __RL_InformationResponseList_RL_SetupRspFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_SetupRspFDD__item__value._const_tab_id = u'Value'
    _RL_InformationResponseList_RL_SetupRspFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationResponseList_RL_SetupRspFDD__item__id),
        (u'criticality', __RL_InformationResponseList_RL_SetupRspFDD__item__criticality),
        (u'value', __RL_InformationResponseList_RL_SetupRspFDD__item__value),
        ])
    _RL_InformationResponseList_RL_SetupRspFDD__item_._ext = None
    RL_InformationResponseList_RL_SetupRspFDD._cont = _RL_InformationResponseList_RL_SetupRspFDD__item_
    RL_InformationResponseList_RL_SetupRspFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationResponseItemIEs-RL-SetupRspFDD >-----#
    RL_InformationResponseItemIEs_RL_SetupRspFDD = CLASS(name=u'RL-InformationResponseItemIEs-RL-SetupRspFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationResponseItemIEs_RL_SetupRspFDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-SetupRspFDD')))
    RL_InformationResponseItemIEs_RL_SetupRspFDD._val = ASN1Set(rv=[dict([(u'id', 133), (u'criticality', u'ignore'), (u'Value', _RL_InformationResponseItemIEs_RL_SetupRspFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-SetupRspFDD >-----#
    RL_InformationResponseItem_RL_SetupRspFDD = SEQ(name=u'RL-InformationResponseItem-RL-SetupRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_SetupRspFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_SetupRspFDD_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_SetupRspFDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_InformationResponseItem_RL_SetupRspFDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_received_total_wide_band_power = INT(name=u'received-total-wide-band-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Received-total-wide-band-power')))
    _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_secondary_CCPCH_Info = NULL(name=u'not-Used-secondary-CCPCH-Info', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_dl_CodeInformation = SEQ_OF(name=u'dl-CodeInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    _RL_InformationResponseItem_RL_SetupRspFDD_diversityIndication = CHOICE(name=u'diversityIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-SetupRspFDD')))
    _RL_InformationResponseItem_RL_SetupRspFDD_sSDT_SupportIndicator = ENUM(name=u'sSDT-SupportIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SSDT-SupportIndicator')))
    _RL_InformationResponseItem_RL_SetupRspFDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponseItem_RL_SetupRspFDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponseItem_RL_SetupRspFDD_closedlooptimingadjustmentmode = ENUM(name=u'closedlooptimingadjustmentmode', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Closedlooptimingadjustmentmode')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_InformationResponseItem_RL_SetupRspFDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponseItem_RL_SetupRspFDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponseItem_RL_SetupRspFDD_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_uL_UARFCN = INT(name=u'uL-UARFCN', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')))
    _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_dSCHInformationResponse = NULL(name=u'not-Used-dSCHInformationResponse', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_InformationResponseItem_RL_SetupRspFDD_pC_Preamble = INT(name=u'pC-Preamble', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PC-Preamble')))
    _RL_InformationResponseItem_RL_SetupRspFDD_sRB_Delay = INT(name=u'sRB-Delay', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SRB-Delay')))
    _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_10 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ChipOffset')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_12 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 519), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 520), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 729), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 730), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_16), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions._cont = __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_
    _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_SetupRspFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponseItem_RL_SetupRspFDD_rL_ID),
        (u'rL-Set-ID', _RL_InformationResponseItem_RL_SetupRspFDD_rL_Set_ID),
        (u'uRA-Information', _RL_InformationResponseItem_RL_SetupRspFDD_uRA_Information),
        (u'sAI', _RL_InformationResponseItem_RL_SetupRspFDD_sAI),
        (u'gA-Cell', _RL_InformationResponseItem_RL_SetupRspFDD_gA_Cell),
        (u'gA-AccessPointPosition', _RL_InformationResponseItem_RL_SetupRspFDD_gA_AccessPointPosition),
        (u'received-total-wide-band-power', _RL_InformationResponseItem_RL_SetupRspFDD_received_total_wide_band_power),
        (u'not-Used-secondary-CCPCH-Info', _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_secondary_CCPCH_Info),
        (u'dl-CodeInformation', _RL_InformationResponseItem_RL_SetupRspFDD_dl_CodeInformation),
        (u'diversityIndication', _RL_InformationResponseItem_RL_SetupRspFDD_diversityIndication),
        (u'sSDT-SupportIndicator', _RL_InformationResponseItem_RL_SetupRspFDD_sSDT_SupportIndicator),
        (u'maxUL-SIR', _RL_InformationResponseItem_RL_SetupRspFDD_maxUL_SIR),
        (u'minUL-SIR', _RL_InformationResponseItem_RL_SetupRspFDD_minUL_SIR),
        (u'closedlooptimingadjustmentmode', _RL_InformationResponseItem_RL_SetupRspFDD_closedlooptimingadjustmentmode),
        (u'maximumAllowedULTxPower', _RL_InformationResponseItem_RL_SetupRspFDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_InformationResponseItem_RL_SetupRspFDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponseItem_RL_SetupRspFDD_minimumDLTxPower),
        (u'primaryScramblingCode', _RL_InformationResponseItem_RL_SetupRspFDD_primaryScramblingCode),
        (u'uL-UARFCN', _RL_InformationResponseItem_RL_SetupRspFDD_uL_UARFCN),
        (u'dL-UARFCN', _RL_InformationResponseItem_RL_SetupRspFDD_dL_UARFCN),
        (u'primaryCPICH-Power', _RL_InformationResponseItem_RL_SetupRspFDD_primaryCPICH_Power),
        (u'not-Used-dSCHInformationResponse', _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_dSCHInformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_InformationResponseItem_RL_SetupRspFDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_InformationResponseItem_RL_SetupRspFDD_neighbouring_GSM_CellInformation),
        (u'pC-Preamble', _RL_InformationResponseItem_RL_SetupRspFDD_pC_Preamble),
        (u'sRB-Delay', _RL_InformationResponseItem_RL_SetupRspFDD_sRB_Delay),
        (u'iE-Extensions', _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_SetupRspFDD._ext = []
    
    #-----< RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs >-----#
    RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs = CLASS(name=u'RL-InformationResponseItem-RL-SetupRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_10 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ChipOffset')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_12 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 519), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 520), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 729), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 730), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_16), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-SetupRspFDD >-----#
    DiversityIndication_RL_SetupRspFDD = CHOICE(name=u'DiversityIndication-RL-SetupRspFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_SetupRspFDD_combining = SEQ(name=u'combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Combining-RL-SetupRspFDD')))
    _DiversityIndication_RL_SetupRspFDD_nonCombiningOrFirstRL = SEQ(name=u'nonCombiningOrFirstRL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'NonCombiningOrFirstRL-RL-SetupRspFDD')))
    DiversityIndication_RL_SetupRspFDD._cont = ASN1Dict([
        (u'combining', _DiversityIndication_RL_SetupRspFDD_combining),
        (u'nonCombiningOrFirstRL', _DiversityIndication_RL_SetupRspFDD_nonCombiningOrFirstRL),
        ])
    DiversityIndication_RL_SetupRspFDD._ext = None
    
    #-----< Combining-RL-SetupRspFDD >-----#
    Combining_RL_SetupRspFDD = SEQ(name=u'Combining-RL-SetupRspFDD', mode=MODE_TYPE)
    _Combining_RL_SetupRspFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Combining_RL_SetupRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_SetupRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Combining_RL_SetupRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Combining_RL_SetupRspFDD_iE_Extensions__item__id),
        (u'criticality', ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_SetupRspFDD_iE_Extensions__item_._ext = None
    _Combining_RL_SetupRspFDD_iE_Extensions._cont = __Combining_RL_SetupRspFDD_iE_Extensions__item_
    _Combining_RL_SetupRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_SetupRspFDD._cont = ASN1Dict([
        (u'rL-ID', _Combining_RL_SetupRspFDD_rL_ID),
        (u'iE-Extensions', _Combining_RL_SetupRspFDD_iE_Extensions),
        ])
    Combining_RL_SetupRspFDD._ext = []
    
    #-----< CombiningItem-RL-SetupRspFDD-ExtIEs >-----#
    CombiningItem_RL_SetupRspFDD_ExtIEs = CLASS(name=u'CombiningItem-RL-SetupRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_SetupRspFDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _CombiningItem_RL_SetupRspFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    CombiningItem_RL_SetupRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_SetupRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_SetupRspFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonCombiningOrFirstRL-RL-SetupRspFDD >-----#
    NonCombiningOrFirstRL_RL_SetupRspFDD = SEQ(name=u'NonCombiningOrFirstRL-RL-SetupRspFDD', mode=MODE_TYPE)
    _NonCombiningOrFirstRL_RL_SetupRspFDD_dCH_InformationResponse = SEQ_OF(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id._const_tab = ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab = ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id),
        (u'criticality', ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_._ext = None
    _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions._cont = __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_
    _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombiningOrFirstRL_RL_SetupRspFDD._cont = ASN1Dict([
        (u'dCH-InformationResponse', _NonCombiningOrFirstRL_RL_SetupRspFDD_dCH_InformationResponse),
        (u'iE-Extensions', _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions),
        ])
    NonCombiningOrFirstRL_RL_SetupRspFDD._ext = []
    
    #-----< NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs >-----#
    NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs = CLASS(name=u'NonCombiningOrFirstRLItem-RL-SetupRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseFDD-Extensions >-----#
    RadioLinkSetupResponseFDD_Extensions = CLASS(name=u'RadioLinkSetupResponseFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RadioLinkSetupResponseFDD_Extensions_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    RadioLinkSetupResponseFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 795), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 838), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseFDD_Extensions_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-Response-List >-----#
    Additional_HS_Cell_Information_Response_List = SEQ_OF(name=u'Additional-HS-Cell-Information-Response-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-ItemIEs')))
    Additional_HS_Cell_Information_Response_List._cont = _Additional_HS_Cell_Information_Response_List__item_
    Additional_HS_Cell_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-Response-ItemIEs >-----#
    Additional_HS_Cell_Information_Response_ItemIEs = SEQ(name=u'Additional-HS-Cell-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_Response_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_Response_ItemIEs_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _Additional_HS_Cell_Information_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-Response')))
    _Additional_HS_Cell_Information_Response_ItemIEs_sixtyfourQAM_DL_SupportIndicator = ENUM(name=u'sixtyfourQAM-DL-SupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')), opt=True)
    _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_Response_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Information_Response_ItemIEs_hSPDSCH_RL_ID),
        (u'hSDSCH-RNTI', _Additional_HS_Cell_Information_Response_ItemIEs_hSDSCH_RNTI),
        (u'hS-DSCH-FDD-Secondary-Serving-Information-Response', _Additional_HS_Cell_Information_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response),
        (u'sixtyfourQAM-DL-SupportIndicator', _Additional_HS_Cell_Information_Response_ItemIEs_sixtyfourQAM_DL_SupportIndicator),
        (u'iE-Extensions', _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_Response_ItemIEs_ExtIEs = CLASS(name=u'Additional-HS-Cell-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseTDD >-----#
    RadioLinkSetupResponseTDD = SEQ(name=u'RadioLinkSetupResponseTDD', mode=MODE_TYPE)
    _RadioLinkSetupResponseTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-SetupRspTDD')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupResponseTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkSetupResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupResponseTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkSetupResponseTDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupResponseTDD_protocolIEs__item_._ext = None
    _RadioLinkSetupResponseTDD_protocolIEs._cont = __RadioLinkSetupResponseTDD_protocolIEs__item_
    _RadioLinkSetupResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupResponseTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-LCR-InformationResponse-RL-SetupRspTDD')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-RNTI')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD-PFL')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-SetupRspTDD768')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_12 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_17 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_18 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 599), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 636), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 861), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 862), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkSetupResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupResponseTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupResponseTDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupResponseTDD_protocolExtensions._cont = __RadioLinkSetupResponseTDD_protocolExtensions__item_
    _RadioLinkSetupResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupResponseTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkSetupResponseTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkSetupResponseTDD_protocolExtensions),
        ])
    RadioLinkSetupResponseTDD._ext = []
    
    #-----< RadioLinkSetupResponseTDD-IEs >-----#
    RadioLinkSetupResponseTDD_IEs = CLASS(name=u'RadioLinkSetupResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-SetupRspTDD')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RadioLinkSetupResponseTDD_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupResponseTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseTDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseTDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseTDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 129), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseTDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseTDD_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupResponseTDD_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-SetupRspTDD >-----#
    RL_InformationResponse_RL_SetupRspTDD = SEQ(name=u'RL-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_RL_SetupRspTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_SetupRspTDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_InformationResponse_RL_SetupRspTDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_ul_TimeSlot_ISCP_Info = SEQ_OF(name=u'ul-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-Info')))
    _RL_InformationResponse_RL_SetupRspTDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_SetupRspTDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_SetupRspTDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_InformationResponse_RL_SetupRspTDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_SetupRspTDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_SetupRspTDD_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_syncCase = INT(name=u'syncCase', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SyncCase')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_sCH_TimeSlot = INT(name=u'sCH-TimeSlot', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCH-TimeSlot')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')))
    _RL_InformationResponse_RL_SetupRspTDD_timingAdvanceApplied = ENUM(name=u'timingAdvanceApplied', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimingAdvanceApplied')))
    _RL_InformationResponse_RL_SetupRspTDD_alphaValue = INT(name=u'alphaValue', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AlphaValue')))
    _RL_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation = ENUM(name=u'ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_RL_SetupRspTDD_synchronisationConfiguration = SEQ(name=u'synchronisationConfiguration', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationConfiguration')))
    _RL_InformationResponse_RL_SetupRspTDD_secondary_CCPCH_Info_TDD = SEQ(name=u'secondary-CCPCH-Info-TDD', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_ul_CCTrCHInformation = SEQ(name=u'ul-CCTrCHInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_dl_CCTrCHInformation = SEQ(name=u'dl-CCTrCHInformation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_dCH_InformationResponse = SEQ(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_dsch_InformationResponse = SEQ(name=u'dsch-InformationResponse', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationResponse-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_usch_InformationResponse = SEQ(name=u'usch-InformationResponse', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationResponse-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 325), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions._cont = __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_
    _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponse_RL_SetupRspTDD_rL_ID),
        (u'uRA-Information', _RL_InformationResponse_RL_SetupRspTDD_uRA_Information),
        (u'sAI', _RL_InformationResponse_RL_SetupRspTDD_sAI),
        (u'gA-Cell', _RL_InformationResponse_RL_SetupRspTDD_gA_Cell),
        (u'gA-AccessPointPosition', _RL_InformationResponse_RL_SetupRspTDD_gA_AccessPointPosition),
        (u'ul-TimeSlot-ISCP-Info', _RL_InformationResponse_RL_SetupRspTDD_ul_TimeSlot_ISCP_Info),
        (u'maxUL-SIR', _RL_InformationResponse_RL_SetupRspTDD_maxUL_SIR),
        (u'minUL-SIR', _RL_InformationResponse_RL_SetupRspTDD_minUL_SIR),
        (u'maximumAllowedULTxPower', _RL_InformationResponse_RL_SetupRspTDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_InformationResponse_RL_SetupRspTDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponse_RL_SetupRspTDD_minimumDLTxPower),
        (u'uARFCNforNt', _RL_InformationResponse_RL_SetupRspTDD_uARFCNforNt),
        (u'cellParameterID', _RL_InformationResponse_RL_SetupRspTDD_cellParameterID),
        (u'syncCase', _RL_InformationResponse_RL_SetupRspTDD_syncCase),
        (u'sCH-TimeSlot', _RL_InformationResponse_RL_SetupRspTDD_sCH_TimeSlot),
        (u'sCTD-Indicator', _RL_InformationResponse_RL_SetupRspTDD_sCTD_Indicator),
        (u'pCCPCH-Power', _RL_InformationResponse_RL_SetupRspTDD_pCCPCH_Power),
        (u'timingAdvanceApplied', _RL_InformationResponse_RL_SetupRspTDD_timingAdvanceApplied),
        (u'alphaValue', _RL_InformationResponse_RL_SetupRspTDD_alphaValue),
        (u'ul-PhysCH-SF-Variation', _RL_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation),
        (u'synchronisationConfiguration', _RL_InformationResponse_RL_SetupRspTDD_synchronisationConfiguration),
        (u'secondary-CCPCH-Info-TDD', _RL_InformationResponse_RL_SetupRspTDD_secondary_CCPCH_Info_TDD),
        (u'ul-CCTrCHInformation', _RL_InformationResponse_RL_SetupRspTDD_ul_CCTrCHInformation),
        (u'dl-CCTrCHInformation', _RL_InformationResponse_RL_SetupRspTDD_dl_CCTrCHInformation),
        (u'dCH-InformationResponse', _RL_InformationResponse_RL_SetupRspTDD_dCH_InformationResponse),
        (u'dsch-InformationResponse', _RL_InformationResponse_RL_SetupRspTDD_dsch_InformationResponse),
        (u'usch-InformationResponse', _RL_InformationResponse_RL_SetupRspTDD_usch_InformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_InformationResponse_RL_SetupRspTDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_InformationResponse_RL_SetupRspTDD_neighbouring_GSM_CellInformation),
        (u'iE-Extensions', _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_RL_SetupRspTDD._ext = []
    
    #-----< RL-InformationResponse-RL-SetupRspTDD-ExtIEs >-----#
    RL_InformationResponse_RL_SetupRspTDD_ExtIEs = CLASS(name=u'RL-InformationResponse-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    RL_InformationResponse_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 325), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_2), (u'presence', u'conditional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCHInformationList-RL-SetupRspTDD >-----#
    UL_CCTrCHInformationList_RL_SetupRspTDD = SEQ(name=u'UL-CCTrCHInformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCHInformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-SetupRspTDD')))
    __UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', ___UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab = __UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _UL_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_at = None
    _UL_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _UL_CCTrCHInformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab = __UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _UL_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _UL_CCTrCHInformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab = __UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _UL_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    UL_CCTrCHInformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _UL_CCTrCHInformationList_RL_SetupRspTDD_id),
        (u'criticality', _UL_CCTrCHInformationList_RL_SetupRspTDD_criticality),
        (u'value', _UL_CCTrCHInformationList_RL_SetupRspTDD_value),
        ])
    UL_CCTrCHInformationList_RL_SetupRspTDD._ext = None
    
    #-----< UL-CCTrCHInformationListIEs-RL-SetupRspTDD >-----#
    UL_CCTrCHInformationListIEs_RL_SetupRspTDD = CLASS(name=u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-SetupRspTDD')))
    UL_CCTrCHInformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 176), (u'criticality', u'ignore'), (u'Value', _UL_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationListIE-RL-SetupRspTDD >-----#
    UL_CCTrCHInformationListIE_RL_SetupRspTDD = SEQ_OF(name=u'UL-CCTrCHInformationListIE-RL-SetupRspTDD', mode=MODE_TYPE)
    _UL_CCTrCHInformationListIE_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationItem-RL-SetupRspTDD')))
    UL_CCTrCHInformationListIE_RL_SetupRspTDD._cont = _UL_CCTrCHInformationListIE_RL_SetupRspTDD__item_
    UL_CCTrCHInformationListIE_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationItem-RL-SetupRspTDD >-----#
    UL_CCTrCHInformationItem_RL_SetupRspTDD = SEQ(name=u'UL-CCTrCHInformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _UL_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCHInformationItem_RL_SetupRspTDD_ul_DPCH_Information = SEQ(name=u'ul-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationList-RL-SetupRspTDD')), opt=True)
    _UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 150), (u'criticality', u'ignore'), (u'Extension', _____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions._cont = __UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCHInformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID),
        (u'ul-DPCH-Information', _UL_CCTrCHInformationItem_RL_SetupRspTDD_ul_DPCH_Information),
        (u'iE-Extensions', _UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    UL_CCTrCHInformationItem_RL_SetupRspTDD._ext = []
    
    #-----< UL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs >-----#
    UL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'UL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    UL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 150), (u'criticality', u'ignore'), (u'Extension', _UL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationList-RL-SetupRspTDD >-----#
    UL_DPCH_InformationList_RL_SetupRspTDD = SEQ(name=u'UL-DPCH-InformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-SetupRspTDD')))
    __UL_DPCH_InformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationList_RL_SetupRspTDD_id._const_tab = __UL_DPCH_InformationList_RL_SetupRspTDD_id_tab
    _UL_DPCH_InformationList_RL_SetupRspTDD_id._const_tab_at = None
    _UL_DPCH_InformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _UL_DPCH_InformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationList_RL_SetupRspTDD_criticality._const_tab = __UL_DPCH_InformationList_RL_SetupRspTDD_id_tab
    _UL_DPCH_InformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationList_RL_SetupRspTDD_value._const_tab = __UL_DPCH_InformationList_RL_SetupRspTDD_id_tab
    _UL_DPCH_InformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    UL_DPCH_InformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationList_RL_SetupRspTDD_id),
        (u'criticality', _UL_DPCH_InformationList_RL_SetupRspTDD_criticality),
        (u'value', _UL_DPCH_InformationList_RL_SetupRspTDD_value),
        ])
    UL_DPCH_InformationList_RL_SetupRspTDD._ext = None
    
    #-----< UL-DPCH-InformationListIEs-RL-SetupRspTDD >-----#
    UL_DPCH_InformationListIEs_RL_SetupRspTDD = CLASS(name=u'UL-DPCH-InformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-SetupRspTDD')))
    UL_DPCH_InformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 182), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-RL-SetupRspTDD >-----#
    UL_DPCH_InformationItem_RL_SetupRspTDD = SEQ(name=u'UL-DPCH-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_RL_SetupRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD_uL_Timeslot_Information = SEQ_OF(name=u'uL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationItem_RL_SetupRspTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationItem_RL_SetupRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset),
        (u'uL-Timeslot-Information', _UL_DPCH_InformationItem_RL_SetupRspTDD_uL_Timeslot_Information),
        (u'iE-Extensions', _UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'UL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCHInformationList-RL-SetupRspTDD >-----#
    DL_CCTrCHInformationList_RL_SetupRspTDD = SEQ(name=u'DL-CCTrCHInformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCHInformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-SetupRspTDD')))
    __DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', ___DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab = __DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _DL_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_at = None
    _DL_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DL_CCTrCHInformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab = __DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _DL_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DL_CCTrCHInformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab = __DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _DL_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DL_CCTrCHInformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DL_CCTrCHInformationList_RL_SetupRspTDD_id),
        (u'criticality', _DL_CCTrCHInformationList_RL_SetupRspTDD_criticality),
        (u'value', _DL_CCTrCHInformationList_RL_SetupRspTDD_value),
        ])
    DL_CCTrCHInformationList_RL_SetupRspTDD._ext = None
    
    #-----< DL-CCTrCHInformationListIEs-RL-SetupRspTDD >-----#
    DL_CCTrCHInformationListIEs_RL_SetupRspTDD = CLASS(name=u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-SetupRspTDD')))
    DL_CCTrCHInformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 50), (u'criticality', u'ignore'), (u'Value', _DL_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationListIE-RL-SetupRspTDD >-----#
    DL_CCTrCHInformationListIE_RL_SetupRspTDD = SEQ_OF(name=u'DL-CCTrCHInformationListIE-RL-SetupRspTDD', mode=MODE_TYPE)
    _DL_CCTrCHInformationListIE_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationItem-RL-SetupRspTDD')))
    DL_CCTrCHInformationListIE_RL_SetupRspTDD._cont = _DL_CCTrCHInformationListIE_RL_SetupRspTDD__item_
    DL_CCTrCHInformationListIE_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationItem-RL-SetupRspTDD >-----#
    DL_CCTrCHInformationItem_RL_SetupRspTDD = SEQ(name=u'DL-CCTrCHInformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_dl_DPCH_Information = SEQ(name=u'dl-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationList-RL-SetupRspTDD')), opt=True)
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 500), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 501), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions._cont = __DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCHInformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID),
        (u'dl-DPCH-Information', _DL_CCTrCHInformationItem_RL_SetupRspTDD_dl_DPCH_Information),
        (u'iE-Extensions', _DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    DL_CCTrCHInformationItem_RL_SetupRspTDD._ext = []
    
    #-----< DL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs >-----#
    DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'DL-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 500), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 501), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationList-RL-SetupRspTDD >-----#
    DL_DPCH_InformationList_RL_SetupRspTDD = SEQ(name=u'DL-DPCH-InformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-SetupRspTDD')))
    __DL_DPCH_InformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationList_RL_SetupRspTDD_id._const_tab = __DL_DPCH_InformationList_RL_SetupRspTDD_id_tab
    _DL_DPCH_InformationList_RL_SetupRspTDD_id._const_tab_at = None
    _DL_DPCH_InformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationList_RL_SetupRspTDD_criticality._const_tab = __DL_DPCH_InformationList_RL_SetupRspTDD_id_tab
    _DL_DPCH_InformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationList_RL_SetupRspTDD_value._const_tab = __DL_DPCH_InformationList_RL_SetupRspTDD_id_tab
    _DL_DPCH_InformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationList_RL_SetupRspTDD_id),
        (u'criticality', _DL_DPCH_InformationList_RL_SetupRspTDD_criticality),
        (u'value', _DL_DPCH_InformationList_RL_SetupRspTDD_value),
        ])
    DL_DPCH_InformationList_RL_SetupRspTDD._ext = None
    
    #-----< DL-DPCH-InformationListIEs-RL-SetupRspTDD >-----#
    DL_DPCH_InformationListIEs_RL_SetupRspTDD = CLASS(name=u'DL-DPCH-InformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-SetupRspTDD')))
    DL_DPCH_InformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 64), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-RL-SetupRspTDD >-----#
    DL_DPCH_InformationItem_RL_SetupRspTDD = SEQ(name=u'DL-DPCH-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_RL_SetupRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD_dL_Timeslot_Information = SEQ_OF(name=u'dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationItem_RL_SetupRspTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationItem_RL_SetupRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset),
        (u'dL-Timeslot-Information', _DL_DPCH_InformationItem_RL_SetupRspTDD_dL_Timeslot_Information),
        (u'iE-Extensions', _DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-SetupRspTDD >-----#
    DCH_InformationResponseList_RL_SetupRspTDD = SEQ(name=u'DCH-InformationResponseList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DCH_InformationResponseList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ___DCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_SetupRspTDD_id._const_tab = __DCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab = __DCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DCH_InformationResponseList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DCH_InformationResponseList_RL_SetupRspTDD_value._const_tab = __DCH_InformationResponseList_RL_SetupRspTDD_id_tab
    _DCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DCH_InformationResponseList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DCH_InformationResponseList_RL_SetupRspTDD_id),
        (u'criticality', _DCH_InformationResponseList_RL_SetupRspTDD_criticality),
        (u'value', _DCH_InformationResponseList_RL_SetupRspTDD_value),
        ])
    DCH_InformationResponseList_RL_SetupRspTDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-SetupRspTDD >-----#
    DCH_InformationResponseListIEs_RL_SetupRspTDD = CLASS(name=u'DCH-InformationResponseListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _DCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-InformationResponse-RL-SetupRspTDD >-----#
    DSCH_InformationResponse_RL_SetupRspTDD = SEQ(name=u'DSCH-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_InformationResponse_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DSCH_InformationResponse_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DSCH_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationListIEs-RL-SetupRspTDD')))
    __DSCH_InformationResponse_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Value', ___DSCH_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_InformationResponse_RL_SetupRspTDD_id._const_tab = __DSCH_InformationResponse_RL_SetupRspTDD_id_tab
    _DSCH_InformationResponse_RL_SetupRspTDD_id._const_tab_at = None
    _DSCH_InformationResponse_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DSCH_InformationResponse_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DSCH_InformationResponse_RL_SetupRspTDD_criticality._const_tab = __DSCH_InformationResponse_RL_SetupRspTDD_id_tab
    _DSCH_InformationResponse_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DSCH_InformationResponse_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DSCH_InformationResponse_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DSCH_InformationResponse_RL_SetupRspTDD_value._const_tab = __DSCH_InformationResponse_RL_SetupRspTDD_id_tab
    _DSCH_InformationResponse_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DSCH_InformationResponse_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DSCH_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DSCH_InformationResponse_RL_SetupRspTDD_id),
        (u'criticality', _DSCH_InformationResponse_RL_SetupRspTDD_criticality),
        (u'value', _DSCH_InformationResponse_RL_SetupRspTDD_value),
        ])
    DSCH_InformationResponse_RL_SetupRspTDD._ext = None
    
    #-----< DSCH-InformationList-RL-SetupRspTDD >-----#
    DSCH_InformationList_RL_SetupRspTDD = CLASS(name=u'DSCH-InformationList-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DSCH_InformationList_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationListIEs-RL-SetupRspTDD')))
    DSCH_InformationList_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 221), (u'criticality', u'ignore'), (u'Value', _DSCH_InformationList_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-InformationListIEs-RL-SetupRspTDD >-----#
    DSCH_InformationListIEs_RL_SetupRspTDD = SEQ_OF(name=u'DSCH-InformationListIEs-RL-SetupRspTDD', mode=MODE_TYPE)
    _DSCH_InformationListIEs_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCHInformationItem-RL-SetupRspTDD')))
    DSCH_InformationListIEs_RL_SetupRspTDD._cont = _DSCH_InformationListIEs_RL_SetupRspTDD__item_
    DSCH_InformationListIEs_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCHInformationItem-RL-SetupRspTDD >-----#
    DSCHInformationItem_RL_SetupRspTDD = SEQ(name=u'DSCHInformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _DSCHInformationItem_RL_SetupRspTDD_dsch_ID = INT(name=u'dsch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCHInformationItem_RL_SetupRspTDD_dSCH_FlowControlInformation = SEQ_OF(name=u'dSCH-FlowControlInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-FlowControlInformation')))
    _DSCHInformationItem_RL_SetupRspTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _DSCHInformationItem_RL_SetupRspTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _DSCHInformationItem_RL_SetupRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _DSCHInformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _DSCHInformationItem_RL_SetupRspTDD_iE_Extensions._cont = __DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _DSCHInformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCHInformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'dsch-ID', _DSCHInformationItem_RL_SetupRspTDD_dsch_ID),
        (u'dSCH-FlowControlInformation', _DSCHInformationItem_RL_SetupRspTDD_dSCH_FlowControlInformation),
        (u'bindingID', _DSCHInformationItem_RL_SetupRspTDD_bindingID),
        (u'transportLayerAddress', _DSCHInformationItem_RL_SetupRspTDD_transportLayerAddress),
        (u'transportFormatManagement', _DSCHInformationItem_RL_SetupRspTDD_transportFormatManagement),
        (u'iE-Extensions', _DSCHInformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    DSCHInformationItem_RL_SetupRspTDD._ext = []
    
    #-----< DSCHInformationItem-RL-SetupRspTDD-ExtIEs >-----#
    DSCHInformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'DSCHInformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DSCHInformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-InformationResponse-RL-SetupRspTDD >-----#
    USCH_InformationResponse_RL_SetupRspTDD = SEQ(name=u'USCH-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_InformationResponse_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __USCH_InformationResponse_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___USCH_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationListIEs-RL-SetupRspTDD')))
    __USCH_InformationResponse_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 270), (u'criticality', u'ignore'), (u'Value', ___USCH_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _USCH_InformationResponse_RL_SetupRspTDD_id._const_tab = __USCH_InformationResponse_RL_SetupRspTDD_id_tab
    _USCH_InformationResponse_RL_SetupRspTDD_id._const_tab_at = None
    _USCH_InformationResponse_RL_SetupRspTDD_id._const_tab_id = u'id'
    _USCH_InformationResponse_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _USCH_InformationResponse_RL_SetupRspTDD_criticality._const_tab = __USCH_InformationResponse_RL_SetupRspTDD_id_tab
    _USCH_InformationResponse_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _USCH_InformationResponse_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _USCH_InformationResponse_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _USCH_InformationResponse_RL_SetupRspTDD_value._const_tab = __USCH_InformationResponse_RL_SetupRspTDD_id_tab
    _USCH_InformationResponse_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _USCH_InformationResponse_RL_SetupRspTDD_value._const_tab_id = u'Value'
    USCH_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _USCH_InformationResponse_RL_SetupRspTDD_id),
        (u'criticality', _USCH_InformationResponse_RL_SetupRspTDD_criticality),
        (u'value', _USCH_InformationResponse_RL_SetupRspTDD_value),
        ])
    USCH_InformationResponse_RL_SetupRspTDD._ext = None
    
    #-----< USCH-InformationList-RL-SetupRspTDD >-----#
    USCH_InformationList_RL_SetupRspTDD = CLASS(name=u'USCH-InformationList-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _USCH_InformationList_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationListIEs-RL-SetupRspTDD')))
    USCH_InformationList_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 270), (u'criticality', u'ignore'), (u'Value', _USCH_InformationList_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-InformationListIEs-RL-SetupRspTDD >-----#
    USCH_InformationListIEs_RL_SetupRspTDD = SEQ_OF(name=u'USCH-InformationListIEs-RL-SetupRspTDD', mode=MODE_TYPE)
    _USCH_InformationListIEs_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCHInformationItem-RL-SetupRspTDD')))
    USCH_InformationListIEs_RL_SetupRspTDD._cont = _USCH_InformationListIEs_RL_SetupRspTDD__item_
    USCH_InformationListIEs_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCHInformationItem-RL-SetupRspTDD >-----#
    USCHInformationItem_RL_SetupRspTDD = SEQ(name=u'USCHInformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _USCHInformationItem_RL_SetupRspTDD_usch_ID = INT(name=u'usch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCHInformationItem_RL_SetupRspTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _USCHInformationItem_RL_SetupRspTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _USCHInformationItem_RL_SetupRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _USCHInformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _USCHInformationItem_RL_SetupRspTDD_iE_Extensions._cont = __USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _USCHInformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCHInformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'usch-ID', _USCHInformationItem_RL_SetupRspTDD_usch_ID),
        (u'bindingID', _USCHInformationItem_RL_SetupRspTDD_bindingID),
        (u'transportLayerAddress', _USCHInformationItem_RL_SetupRspTDD_transportLayerAddress),
        (u'transportFormatManagement', _USCHInformationItem_RL_SetupRspTDD_transportFormatManagement),
        (u'iE-Extensions', _USCHInformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    USCHInformationItem_RL_SetupRspTDD._ext = []
    
    #-----< USCHInformationItem-RL-SetupRspTDD-ExtIEs >-----#
    USCHInformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'USCHInformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    USCHInformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupResponseTDD-Extensions >-----#
    RadioLinkSetupResponseTDD_Extensions = CLASS(name=u'RadioLinkSetupResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-LCR-InformationResponse-RL-SetupRspTDD')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-RNTI')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD-PFL')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-SetupRspTDD768')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_12 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_17 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkSetupResponseTDD_Extensions_val_Extension_18 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkSetupResponseTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 66), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 599), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 636), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 861), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 862), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _RadioLinkSetupResponseTDD_Extensions_val_Extension_18), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-LCR-InformationResponse-RL-SetupRspTDD >-----#
    RL_LCR_InformationResponse_RL_SetupRspTDD = SEQ(name=u'RL-LCR-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_TimeSlot_ISCP_LCR_Info = SEQ_OF(name=u'ul-TimeSlot-ISCP-LCR-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-LCR-Info')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_alphaValue = INT(name=u'alphaValue', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AlphaValue')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation = ENUM(name=u'ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_synchronisationConfiguration = SEQ(name=u'synchronisationConfiguration', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationConfiguration')))
    _RL_LCR_InformationResponse_RL_SetupRspTDD_secondary_LCR_CCPCH_Info_TDD = SEQ(name=u'secondary-LCR-CCPCH-Info-TDD', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-Info-TDD')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_LCR_CCTrCHInformation = SEQ(name=u'ul-LCR-CCTrCHInformation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-LCR-CCTrCHInformationList-RL-SetupRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_dl_LCR_CCTrCHInformation = SEQ(name=u'dl-LCR-CCTrCHInformation', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-LCR-CCTrCHInformationList-RL-SetupRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_dCH_InformationResponse = SEQ(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_dsch_LCR_InformationResponse = SEQ(name=u'dsch-LCR-InformationResponse', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationResponse-RL-SetupRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_usch_LCR_InformationResponse = SEQ(name=u'usch-LCR-InformationResponse', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationResponse-RL-SetupRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions._cont = __RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_
    _RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_LCR_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_LCR_InformationResponse_RL_SetupRspTDD_rL_ID),
        (u'uRA-Information', _RL_LCR_InformationResponse_RL_SetupRspTDD_uRA_Information),
        (u'sAI', _RL_LCR_InformationResponse_RL_SetupRspTDD_sAI),
        (u'gA-Cell', _RL_LCR_InformationResponse_RL_SetupRspTDD_gA_Cell),
        (u'gA-AccessPointPosition', _RL_LCR_InformationResponse_RL_SetupRspTDD_gA_AccessPointPosition),
        (u'ul-TimeSlot-ISCP-LCR-Info', _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_TimeSlot_ISCP_LCR_Info),
        (u'maxUL-SIR', _RL_LCR_InformationResponse_RL_SetupRspTDD_maxUL_SIR),
        (u'minUL-SIR', _RL_LCR_InformationResponse_RL_SetupRspTDD_minUL_SIR),
        (u'maximumAllowedULTxPower', _RL_LCR_InformationResponse_RL_SetupRspTDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_LCR_InformationResponse_RL_SetupRspTDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_LCR_InformationResponse_RL_SetupRspTDD_minimumDLTxPower),
        (u'uARFCNforNt', _RL_LCR_InformationResponse_RL_SetupRspTDD_uARFCNforNt),
        (u'cellParameterID', _RL_LCR_InformationResponse_RL_SetupRspTDD_cellParameterID),
        (u'sCTD-Indicator', _RL_LCR_InformationResponse_RL_SetupRspTDD_sCTD_Indicator),
        (u'pCCPCH-Power', _RL_LCR_InformationResponse_RL_SetupRspTDD_pCCPCH_Power),
        (u'alphaValue', _RL_LCR_InformationResponse_RL_SetupRspTDD_alphaValue),
        (u'ul-PhysCH-SF-Variation', _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation),
        (u'synchronisationConfiguration', _RL_LCR_InformationResponse_RL_SetupRspTDD_synchronisationConfiguration),
        (u'secondary-LCR-CCPCH-Info-TDD', _RL_LCR_InformationResponse_RL_SetupRspTDD_secondary_LCR_CCPCH_Info_TDD),
        (u'ul-LCR-CCTrCHInformation', _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_LCR_CCTrCHInformation),
        (u'dl-LCR-CCTrCHInformation', _RL_LCR_InformationResponse_RL_SetupRspTDD_dl_LCR_CCTrCHInformation),
        (u'dCH-InformationResponse', _RL_LCR_InformationResponse_RL_SetupRspTDD_dCH_InformationResponse),
        (u'dsch-LCR-InformationResponse', _RL_LCR_InformationResponse_RL_SetupRspTDD_dsch_LCR_InformationResponse),
        (u'usch-LCR-InformationResponse', _RL_LCR_InformationResponse_RL_SetupRspTDD_usch_LCR_InformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_LCR_InformationResponse_RL_SetupRspTDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_LCR_InformationResponse_RL_SetupRspTDD_neighbouring_GSM_CellInformation),
        (u'iE-Extensions', _RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions),
        ])
    RL_LCR_InformationResponse_RL_SetupRspTDD._ext = []
    
    #-----< RL-LCR-InformationResponseList-RL-SetupRspTDD-ExtIEs >-----#
    RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs = CLASS(name=u'RL-LCR-InformationResponseList-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-LCR-CCTrCHInformationList-RL-SetupRspTDD >-----#
    UL_LCR_CCTrCHInformationList_RL_SetupRspTDD = SEQ(name=u'UL-LCR-CCTrCHInformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD')))
    __UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', ___UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab = __UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_at = None
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab = __UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab = __UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    UL_LCR_CCTrCHInformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id),
        (u'criticality', _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality),
        (u'value', _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value),
        ])
    UL_LCR_CCTrCHInformationList_RL_SetupRspTDD._ext = None
    
    #-----< UL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD >-----#
    UL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD = CLASS(name=u'UL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD')))
    UL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 75), (u'criticality', u'ignore'), (u'Value', _UL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD >-----#
    UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD = SEQ_OF(name=u'UL-LCR-CCTrCHInformationListIE-RL-SetupRspTDD', mode=MODE_TYPE)
    _UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD')))
    UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD._cont = _UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD__item_
    UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD >-----#
    UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD = SEQ(name=u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ul_DPCH_LCR_Information = SEQ(name=u'ul-DPCH-LCR-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationList-RL-SetupRspTDD')), opt=True)
    _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    ____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'ignore'), (u'Extension', _____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions._cont = __UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID),
        (u'ul-DPCH-LCR-Information', _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ul_DPCH_LCR_Information),
        (u'iE-Extensions', _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD._ext = []
    
    #-----< UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs >-----#
    UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'UL-LCR-CCTrCHInformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 151), (u'criticality', u'ignore'), (u'Extension', _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-LCR-InformationList-RL-SetupRspTDD >-----#
    UL_DPCH_LCR_InformationList_RL_SetupRspTDD = SEQ(name=u'UL-DPCH-LCR-InformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD')))
    __UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 76), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id._const_tab = __UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id._const_tab_at = None
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality._const_tab = __UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_value._const_tab = __UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    UL_DPCH_LCR_InformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id),
        (u'criticality', _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality),
        (u'value', _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_value),
        ])
    UL_DPCH_LCR_InformationList_RL_SetupRspTDD._ext = None
    
    #-----< UL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD >-----#
    UL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD = CLASS(name=u'UL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD')))
    UL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 76), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    UL_DPCH_LCR_InformationItem_RL_SetupRspTDD = SEQ(name=u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_uL_TimeslotLCR_Information = SEQ_OF(name=u'uL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_LCR_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset),
        (u'uL-TimeslotLCR-Information', _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_uL_TimeslotLCR_Information),
        (u'iE-Extensions', _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    UL_DPCH_LCR_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< UL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'UL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-LCR-CCTrCHInformationList-RL-SetupRspTDD >-----#
    DL_LCR_CCTrCHInformationList_RL_SetupRspTDD = SEQ(name=u'DL-LCR-CCTrCHInformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD')))
    __DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', ___DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab = __DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_at = None
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab = __DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab = __DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DL_LCR_CCTrCHInformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id),
        (u'criticality', _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality),
        (u'value', _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value),
        ])
    DL_LCR_CCTrCHInformationList_RL_SetupRspTDD._ext = None
    
    #-----< DL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD >-----#
    DL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD = CLASS(name=u'DL-LCR-CCTrCHInformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD')))
    DL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 77), (u'criticality', u'ignore'), (u'Value', _DL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD >-----#
    DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD = SEQ_OF(name=u'DL-CCTrCH-LCR-InformationListIE-RL-SetupRspTDD', mode=MODE_TYPE)
    _DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD')))
    DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD._cont = _DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD__item_
    DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD = SEQ(name=u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_dl_DPCH_LCR_Information = SEQ(name=u'dl-DPCH-LCR-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationList-RL-SetupRspTDD')), opt=True)
    _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_cCTrCH_ID),
        (u'dl-DPCH-LCR-Information', _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_dl_DPCH_LCR_Information),
        (u'iE-Extensions', _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-LCR-InformationList-RL-SetupRspTDD >-----#
    DL_DPCH_LCR_InformationList_RL_SetupRspTDD = SEQ(name=u'DL-DPCH-LCR-InformationList-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD')))
    __DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id._const_tab = __DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id._const_tab_at = None
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality._const_tab = __DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_value._const_tab = __DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DL_DPCH_LCR_InformationList_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id),
        (u'criticality', _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality),
        (u'value', _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_value),
        ])
    DL_DPCH_LCR_InformationList_RL_SetupRspTDD._ext = None
    
    #-----< DL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD >-----#
    DL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD = CLASS(name=u'DL-DPCH-LCR-InformationListIEs-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD')))
    DL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 78), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    DL_DPCH_LCR_InformationItem_RL_SetupRspTDD = SEQ(name=u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_dL_Timeslot_LCR_Information = SEQ_OF(name=u'dL-Timeslot-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tSTD_Indicator = ENUM(name=u'tSTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TSTD-Indicator')))
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset),
        (u'dL-Timeslot-LCR-Information', _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_dL_Timeslot_LCR_Information),
        (u'tSTD-Indicator', _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tSTD_Indicator),
        (u'iE-Extensions', _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'DL-DPCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-LCR-InformationResponse-RL-SetupRspTDD >-----#
    DSCH_LCR_InformationResponse_RL_SetupRspTDD = SEQ(name=u'DSCH-LCR-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationListIEs-RL-SetupRspTDD')))
    __DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', ___DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_id._const_tab = __DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_id._const_tab_at = None
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_id._const_tab_id = u'id'
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_criticality._const_tab = __DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_value._const_tab = __DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _DSCH_LCR_InformationResponse_RL_SetupRspTDD_value._const_tab_id = u'Value'
    DSCH_LCR_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _DSCH_LCR_InformationResponse_RL_SetupRspTDD_id),
        (u'criticality', _DSCH_LCR_InformationResponse_RL_SetupRspTDD_criticality),
        (u'value', _DSCH_LCR_InformationResponse_RL_SetupRspTDD_value),
        ])
    DSCH_LCR_InformationResponse_RL_SetupRspTDD._ext = None
    
    #-----< DSCH-LCR-InformationList-RL-SetupRspTDD >-----#
    DSCH_LCR_InformationList_RL_SetupRspTDD = CLASS(name=u'DSCH-LCR-InformationList-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DSCH_LCR_InformationList_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationListIEs-RL-SetupRspTDD')))
    DSCH_LCR_InformationList_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 79), (u'criticality', u'ignore'), (u'Value', _DSCH_LCR_InformationList_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-LCR-InformationListIEs-RL-SetupRspTDD >-----#
    DSCH_LCR_InformationListIEs_RL_SetupRspTDD = SEQ_OF(name=u'DSCH-LCR-InformationListIEs-RL-SetupRspTDD', mode=MODE_TYPE)
    _DSCH_LCR_InformationListIEs_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationItem-RL-SetupRspTDD')))
    DSCH_LCR_InformationListIEs_RL_SetupRspTDD._cont = _DSCH_LCR_InformationListIEs_RL_SetupRspTDD__item_
    DSCH_LCR_InformationListIEs_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    DSCH_LCR_InformationItem_RL_SetupRspTDD = SEQ(name=u'DSCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_dsch_ID = INT(name=u'dsch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_dSCH_FlowControlInformation = SEQ_OF(name=u'dSCH-FlowControlInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-FlowControlInformation')))
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_LCR_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'dsch-ID', _DSCH_LCR_InformationItem_RL_SetupRspTDD_dsch_ID),
        (u'dSCH-FlowControlInformation', _DSCH_LCR_InformationItem_RL_SetupRspTDD_dSCH_FlowControlInformation),
        (u'bindingID', _DSCH_LCR_InformationItem_RL_SetupRspTDD_bindingID),
        (u'transportLayerAddress', _DSCH_LCR_InformationItem_RL_SetupRspTDD_transportLayerAddress),
        (u'transportFormatManagement', _DSCH_LCR_InformationItem_RL_SetupRspTDD_transportFormatManagement),
        (u'iE-Extensions', _DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    DSCH_LCR_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< DSCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    DSCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'DSCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DSCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-LCR-InformationResponse-RL-SetupRspTDD >-----#
    USCH_LCR_InformationResponse_RL_SetupRspTDD = SEQ(name=u'USCH-LCR-InformationResponse-RL-SetupRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationListIEs-RL-SetupRspTDD')))
    __USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', ___USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_id._const_tab = __USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_id._const_tab_at = None
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_id._const_tab_id = u'id'
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_criticality._const_tab = __USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_criticality._const_tab_at = ('..', u'id')
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_criticality._const_tab_id = u'criticality'
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_value._const_tab = __USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_value._const_tab_at = ('..', u'id')
    _USCH_LCR_InformationResponse_RL_SetupRspTDD_value._const_tab_id = u'Value'
    USCH_LCR_InformationResponse_RL_SetupRspTDD._cont = ASN1Dict([
        (u'id', _USCH_LCR_InformationResponse_RL_SetupRspTDD_id),
        (u'criticality', _USCH_LCR_InformationResponse_RL_SetupRspTDD_criticality),
        (u'value', _USCH_LCR_InformationResponse_RL_SetupRspTDD_value),
        ])
    USCH_LCR_InformationResponse_RL_SetupRspTDD._ext = None
    
    #-----< USCH-LCR-InformationList-RL-SetupRspTDD >-----#
    USCH_LCR_InformationList_RL_SetupRspTDD = CLASS(name=u'USCH-LCR-InformationList-RL-SetupRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _USCH_LCR_InformationList_RL_SetupRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationListIEs-RL-SetupRspTDD')))
    USCH_LCR_InformationList_RL_SetupRspTDD._val = ASN1Set(rv=[dict([(u'id', 80), (u'criticality', u'ignore'), (u'Value', _USCH_LCR_InformationList_RL_SetupRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-LCR-InformationListIEs-RL-SetupRspTDD >-----#
    USCH_LCR_InformationListIEs_RL_SetupRspTDD = SEQ_OF(name=u'USCH-LCR-InformationListIEs-RL-SetupRspTDD', mode=MODE_TYPE)
    _USCH_LCR_InformationListIEs_RL_SetupRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationItem-RL-SetupRspTDD')))
    USCH_LCR_InformationListIEs_RL_SetupRspTDD._cont = _USCH_LCR_InformationListIEs_RL_SetupRspTDD__item_
    USCH_LCR_InformationListIEs_RL_SetupRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCH-LCR-InformationItem-RL-SetupRspTDD >-----#
    USCH_LCR_InformationItem_RL_SetupRspTDD = SEQ(name=u'USCH-LCR-InformationItem-RL-SetupRspTDD', mode=MODE_TYPE)
    _USCH_LCR_InformationItem_RL_SetupRspTDD_usch_ID = INT(name=u'usch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCH_LCR_InformationItem_RL_SetupRspTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _USCH_LCR_InformationItem_RL_SetupRspTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _USCH_LCR_InformationItem_RL_SetupRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab = ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab = ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab = ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id),
        (u'criticality', ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue),
        ])
    __USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_._ext = None
    _USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._cont = __USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_
    _USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_LCR_InformationItem_RL_SetupRspTDD._cont = ASN1Dict([
        (u'usch-ID', _USCH_LCR_InformationItem_RL_SetupRspTDD_usch_ID),
        (u'bindingID', _USCH_LCR_InformationItem_RL_SetupRspTDD_bindingID),
        (u'transportLayerAddress', _USCH_LCR_InformationItem_RL_SetupRspTDD_transportLayerAddress),
        (u'transportFormatManagement', _USCH_LCR_InformationItem_RL_SetupRspTDD_transportFormatManagement),
        (u'iE-Extensions', _USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions),
        ])
    USCH_LCR_InformationItem_RL_SetupRspTDD._ext = []
    
    #-----< USCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs >-----#
    USCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs = CLASS(name=u'USCH-LCR-InformationItem-RL-SetupRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    USCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-SetupRspTDD768 >-----#
    RL_InformationResponse_RL_SetupRspTDD768 = SEQ(name=u'RL-InformationResponse-RL-SetupRspTDD768', mode=MODE_TYPE)
    _RL_InformationResponse_RL_SetupRspTDD768_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_SetupRspTDD768_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_InformationResponse_RL_SetupRspTDD768_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_ul_TimeSlot_ISCP_Info = SEQ_OF(name=u'ul-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-Info')))
    _RL_InformationResponse_RL_SetupRspTDD768_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_SetupRspTDD768_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_SetupRspTDD768_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_InformationResponse_RL_SetupRspTDD768_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_SetupRspTDD768_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_SetupRspTDD768_uARFCNforNt = INT(name=u'uARFCNforNt', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_cellParameterID = INT(name=u'cellParameterID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CellParameterID')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_syncCase = INT(name=u'syncCase', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SyncCase')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_sCH_TimeSlot = INT(name=u'sCH-TimeSlot', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCH-TimeSlot')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_sCTD_Indicator = ENUM(name=u'sCTD-Indicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SCTD-Indicator')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')))
    _RL_InformationResponse_RL_SetupRspTDD768_timingAdvanceApplied = ENUM(name=u'timingAdvanceApplied', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimingAdvanceApplied')))
    _RL_InformationResponse_RL_SetupRspTDD768_alphaValue = INT(name=u'alphaValue', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AlphaValue')))
    _RL_InformationResponse_RL_SetupRspTDD768_ul_PhysCH_SF_Variation = ENUM(name=u'ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_RL_SetupRspTDD768_synchronisationConfiguration = SEQ(name=u'synchronisationConfiguration', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationConfiguration')))
    _RL_InformationResponse_RL_SetupRspTDD768_secondary_CCPCH_Info_TDD768 = SEQ(name=u'secondary-CCPCH-Info-TDD768', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD768')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_ul_CCTrCHInformation768 = SEQ(name=u'ul-CCTrCHInformation768', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationList-RL-SetupRspTDD768')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_dl_CCTrCHInformation768 = SEQ(name=u'dl-CCTrCHInformation768', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationList-RL-SetupRspTDD768')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_dCH_InformationResponse = SEQ(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_dsch_InformationResponse = SEQ(name=u'dsch-InformationResponse', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationResponse-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_usch_InformationResponse = SEQ(name=u'usch-InformationResponse', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationResponse-RL-SetupRspTDD')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_gA_CellAdditionalShapes = CHOICE(name=u'gA-CellAdditionalShapes', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_hCS_Prio = INT(name=u'hCS-Prio', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_timeSlot_RL_SetupRspTDD = INT(name=u'timeSlot-RL-SetupRspTDD', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')), opt=True)
    _RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions._cont = __RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item_
    _RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponse_RL_SetupRspTDD768_rL_ID),
        (u'uRA-Information', _RL_InformationResponse_RL_SetupRspTDD768_uRA_Information),
        (u'sAI', _RL_InformationResponse_RL_SetupRspTDD768_sAI),
        (u'gA-Cell', _RL_InformationResponse_RL_SetupRspTDD768_gA_Cell),
        (u'gA-AccessPointPosition', _RL_InformationResponse_RL_SetupRspTDD768_gA_AccessPointPosition),
        (u'ul-TimeSlot-ISCP-Info', _RL_InformationResponse_RL_SetupRspTDD768_ul_TimeSlot_ISCP_Info),
        (u'maxUL-SIR', _RL_InformationResponse_RL_SetupRspTDD768_maxUL_SIR),
        (u'minUL-SIR', _RL_InformationResponse_RL_SetupRspTDD768_minUL_SIR),
        (u'maximumAllowedULTxPower', _RL_InformationResponse_RL_SetupRspTDD768_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_InformationResponse_RL_SetupRspTDD768_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponse_RL_SetupRspTDD768_minimumDLTxPower),
        (u'uARFCNforNt', _RL_InformationResponse_RL_SetupRspTDD768_uARFCNforNt),
        (u'cellParameterID', _RL_InformationResponse_RL_SetupRspTDD768_cellParameterID),
        (u'syncCase', _RL_InformationResponse_RL_SetupRspTDD768_syncCase),
        (u'sCH-TimeSlot', _RL_InformationResponse_RL_SetupRspTDD768_sCH_TimeSlot),
        (u'sCTD-Indicator', _RL_InformationResponse_RL_SetupRspTDD768_sCTD_Indicator),
        (u'pCCPCH-Power', _RL_InformationResponse_RL_SetupRspTDD768_pCCPCH_Power),
        (u'timingAdvanceApplied', _RL_InformationResponse_RL_SetupRspTDD768_timingAdvanceApplied),
        (u'alphaValue', _RL_InformationResponse_RL_SetupRspTDD768_alphaValue),
        (u'ul-PhysCH-SF-Variation', _RL_InformationResponse_RL_SetupRspTDD768_ul_PhysCH_SF_Variation),
        (u'synchronisationConfiguration', _RL_InformationResponse_RL_SetupRspTDD768_synchronisationConfiguration),
        (u'secondary-CCPCH-Info-TDD768', _RL_InformationResponse_RL_SetupRspTDD768_secondary_CCPCH_Info_TDD768),
        (u'ul-CCTrCHInformation768', _RL_InformationResponse_RL_SetupRspTDD768_ul_CCTrCHInformation768),
        (u'dl-CCTrCHInformation768', _RL_InformationResponse_RL_SetupRspTDD768_dl_CCTrCHInformation768),
        (u'dCH-InformationResponse', _RL_InformationResponse_RL_SetupRspTDD768_dCH_InformationResponse),
        (u'dsch-InformationResponse', _RL_InformationResponse_RL_SetupRspTDD768_dsch_InformationResponse),
        (u'usch-InformationResponse', _RL_InformationResponse_RL_SetupRspTDD768_usch_InformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_InformationResponse_RL_SetupRspTDD768_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_InformationResponse_RL_SetupRspTDD768_neighbouring_GSM_CellInformation),
        (u'gA-CellAdditionalShapes', _RL_InformationResponse_RL_SetupRspTDD768_gA_CellAdditionalShapes),
        (u'hCS-Prio', _RL_InformationResponse_RL_SetupRspTDD768_hCS_Prio),
        (u'timeSlot-RL-SetupRspTDD', _RL_InformationResponse_RL_SetupRspTDD768_timeSlot_RL_SetupRspTDD),
        (u'iE-Extensions', _RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions),
        ])
    RL_InformationResponse_RL_SetupRspTDD768._ext = []
    
    #-----< RL-InformationResponse-RL-SetupRspTDD768-ExtIEs >-----#
    RL_InformationResponse_RL_SetupRspTDD768_ExtIEs = CLASS(name=u'RL-InformationResponse-RL-SetupRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponse_RL_SetupRspTDD768_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_InformationResponse_RL_SetupRspTDD768_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    RL_InformationResponse_RL_SetupRspTDD768_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD768_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_SetupRspTDD768_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCHInformationList-RL-SetupRspTDD768 >-----#
    UL_CCTrCHInformationList_RL_SetupRspTDD768 = SEQ(name=u'UL-CCTrCHInformationList-RL-SetupRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-SetupRspTDD768')))
    __UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 637), (u'criticality', u'ignore'), (u'Value', ___UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_id._const_tab = __UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_id._const_tab_at = None
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_id._const_tab_id = u'id'
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_criticality._const_tab = __UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_criticality._const_tab_id = u'criticality'
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_value._const_tab = __UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_value._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_SetupRspTDD768_value._const_tab_id = u'Value'
    UL_CCTrCHInformationList_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'id', _UL_CCTrCHInformationList_RL_SetupRspTDD768_id),
        (u'criticality', _UL_CCTrCHInformationList_RL_SetupRspTDD768_criticality),
        (u'value', _UL_CCTrCHInformationList_RL_SetupRspTDD768_value),
        ])
    UL_CCTrCHInformationList_RL_SetupRspTDD768._ext = None
    
    #-----< UL-CCTrCHInformationListIEs-RL-SetupRspTDD768 >-----#
    UL_CCTrCHInformationListIEs_RL_SetupRspTDD768 = CLASS(name=u'UL-CCTrCHInformationListIEs-RL-SetupRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCHInformationListIEs_RL_SetupRspTDD768_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-SetupRspTDD768')))
    UL_CCTrCHInformationListIEs_RL_SetupRspTDD768._val = ASN1Set(rv=[dict([(u'id', 637), (u'criticality', u'ignore'), (u'Value', _UL_CCTrCHInformationListIEs_RL_SetupRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationListIE-RL-SetupRspTDD768 >-----#
    UL_CCTrCHInformationListIE_RL_SetupRspTDD768 = SEQ_OF(name=u'UL-CCTrCHInformationListIE-RL-SetupRspTDD768', mode=MODE_TYPE)
    _UL_CCTrCHInformationListIE_RL_SetupRspTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationItem-RL-SetupRspTDD768')))
    UL_CCTrCHInformationListIE_RL_SetupRspTDD768._cont = _UL_CCTrCHInformationListIE_RL_SetupRspTDD768__item_
    UL_CCTrCHInformationListIE_RL_SetupRspTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationItem-RL-SetupRspTDD768 >-----#
    UL_CCTrCHInformationItem_RL_SetupRspTDD768 = SEQ(name=u'UL-CCTrCHInformationItem-RL-SetupRspTDD768', mode=MODE_TYPE)
    _UL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCHInformationItem_RL_SetupRspTDD768_ul_DPCH_Information768 = SEQ(name=u'ul-DPCH-Information768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationList-RL-SetupRspTDD768')), opt=True)
    _UL_CCTrCHInformationItem_RL_SetupRspTDD768_uL_SIR_Target_CCTrCH_InformationItem_RL_SetupRspTDD768 = INT(name=u'uL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD768', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab = ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_._ext = None
    _UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions._cont = __UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_
    _UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCHInformationItem_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_ID),
        (u'ul-DPCH-Information768', _UL_CCTrCHInformationItem_RL_SetupRspTDD768_ul_DPCH_Information768),
        (u'uL-SIR-Target-CCTrCH-InformationItem-RL-SetupRspTDD768', _UL_CCTrCHInformationItem_RL_SetupRspTDD768_uL_SIR_Target_CCTrCH_InformationItem_RL_SetupRspTDD768),
        (u'iE-Extensions', _UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions),
        ])
    UL_CCTrCHInformationItem_RL_SetupRspTDD768._ext = []
    
    #-----< UL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs >-----#
    UL_CCTrCHInformationItem_RL_SetupRspTDD768_ExtIEs = CLASS(name=u'UL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCHInformationItem_RL_SetupRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationList-RL-SetupRspTDD768 >-----#
    UL_DPCH_InformationList_RL_SetupRspTDD768 = SEQ(name=u'UL-DPCH-InformationList-RL-SetupRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationList_RL_SetupRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-SetupRspTDD768')))
    __UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 639), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationList_RL_SetupRspTDD768_id._const_tab = __UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab
    _UL_DPCH_InformationList_RL_SetupRspTDD768_id._const_tab_at = None
    _UL_DPCH_InformationList_RL_SetupRspTDD768_id._const_tab_id = u'id'
    _UL_DPCH_InformationList_RL_SetupRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationList_RL_SetupRspTDD768_criticality._const_tab = __UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab
    _UL_DPCH_InformationList_RL_SetupRspTDD768_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_SetupRspTDD768_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationList_RL_SetupRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationList_RL_SetupRspTDD768_value._const_tab = __UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab
    _UL_DPCH_InformationList_RL_SetupRspTDD768_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_SetupRspTDD768_value._const_tab_id = u'Value'
    UL_DPCH_InformationList_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationList_RL_SetupRspTDD768_id),
        (u'criticality', _UL_DPCH_InformationList_RL_SetupRspTDD768_criticality),
        (u'value', _UL_DPCH_InformationList_RL_SetupRspTDD768_value),
        ])
    UL_DPCH_InformationList_RL_SetupRspTDD768._ext = None
    
    #-----< UL-DPCH-InformationListIEs-RL-SetupRspTDD768 >-----#
    UL_DPCH_InformationListIEs_RL_SetupRspTDD768 = CLASS(name=u'UL-DPCH-InformationListIEs-RL-SetupRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationListIEs_RL_SetupRspTDD768_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-SetupRspTDD768')))
    UL_DPCH_InformationListIEs_RL_SetupRspTDD768._val = ASN1Set(rv=[dict([(u'id', 639), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationListIEs_RL_SetupRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-RL-SetupRspTDD768 >-----#
    UL_DPCH_InformationItem_RL_SetupRspTDD768 = SEQ(name=u'UL-DPCH-InformationItem-RL-SetupRspTDD768', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_uL_Timeslot_Information768 = SEQ_OF(name=u'uL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-Information768')))
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions._cont = __UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_
    _UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationItem_RL_SetupRspTDD768_tDD_DPCHOffset),
        (u'uL-Timeslot-Information768', _UL_DPCH_InformationItem_RL_SetupRspTDD768_uL_Timeslot_Information768),
        (u'iE-Extensions', _UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions),
        ])
    UL_DPCH_InformationItem_RL_SetupRspTDD768._ext = []
    
    #-----< UL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs >-----#
    UL_DPCH_InformationItem_RL_SetupRspTDD768_ExtIEs = CLASS(name=u'UL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_RL_SetupRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCHInformationList-RL-SetupRspTDD768 >-----#
    DL_CCTrCHInformationList_RL_SetupRspTDD768 = SEQ(name=u'DL-CCTrCHInformationList-RL-SetupRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-SetupRspTDD768')))
    __DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 638), (u'criticality', u'ignore'), (u'Value', ___DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_id._const_tab = __DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_id._const_tab_at = None
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_id._const_tab_id = u'id'
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_criticality._const_tab = __DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_criticality._const_tab_id = u'criticality'
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_value._const_tab = __DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_value._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_SetupRspTDD768_value._const_tab_id = u'Value'
    DL_CCTrCHInformationList_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'id', _DL_CCTrCHInformationList_RL_SetupRspTDD768_id),
        (u'criticality', _DL_CCTrCHInformationList_RL_SetupRspTDD768_criticality),
        (u'value', _DL_CCTrCHInformationList_RL_SetupRspTDD768_value),
        ])
    DL_CCTrCHInformationList_RL_SetupRspTDD768._ext = None
    
    #-----< DL-CCTrCHInformationListIEs-RL-SetupRspTDD768 >-----#
    DL_CCTrCHInformationListIEs_RL_SetupRspTDD768 = CLASS(name=u'DL-CCTrCHInformationListIEs-RL-SetupRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCHInformationListIEs_RL_SetupRspTDD768_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-SetupRspTDD768')))
    DL_CCTrCHInformationListIEs_RL_SetupRspTDD768._val = ASN1Set(rv=[dict([(u'id', 638), (u'criticality', u'ignore'), (u'Value', _DL_CCTrCHInformationListIEs_RL_SetupRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationListIE-RL-SetupRspTDD768 >-----#
    DL_CCTrCHInformationListIE_RL_SetupRspTDD768 = SEQ_OF(name=u'DL-CCTrCHInformationListIE-RL-SetupRspTDD768', mode=MODE_TYPE)
    _DL_CCTrCHInformationListIE_RL_SetupRspTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationItem-RL-SetupRspTDD768')))
    DL_CCTrCHInformationListIE_RL_SetupRspTDD768._cont = _DL_CCTrCHInformationListIE_RL_SetupRspTDD768__item_
    DL_CCTrCHInformationListIE_RL_SetupRspTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationItem-RL-SetupRspTDD768 >-----#
    DL_CCTrCHInformationItem_RL_SetupRspTDD768 = SEQ(name=u'DL-CCTrCHInformationItem-RL-SetupRspTDD768', mode=MODE_TYPE)
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_dl_DPCH_Information768 = SEQ(name=u'dl-DPCH-Information768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationList-RL-SetupRspTDD768')), opt=True)
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_Maximum_DL_Power = INT(name=u'cCTrCH-Maximum-DL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_Minimum_DL_Power = INT(name=u'cCTrCH-Minimum-DL-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab = ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_._ext = None
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions._cont = __DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_
    _DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCHInformationItem_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_ID),
        (u'dl-DPCH-Information768', _DL_CCTrCHInformationItem_RL_SetupRspTDD768_dl_DPCH_Information768),
        (u'cCTrCH-Maximum-DL-Power', _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_Maximum_DL_Power),
        (u'cCTrCH-Minimum-DL-Power', _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_Minimum_DL_Power),
        (u'iE-Extensions', _DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions),
        ])
    DL_CCTrCHInformationItem_RL_SetupRspTDD768._ext = []
    
    #-----< DL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs >-----#
    DL_CCTrCHInformationItem_RL_SetupRspTDD768_ExtIEs = CLASS(name=u'DL-CCTrCHInformationItem-RL-SetupRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCHInformationItem_RL_SetupRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationList-RL-SetupRspTDD768 >-----#
    DL_DPCH_InformationList_RL_SetupRspTDD768 = SEQ(name=u'DL-DPCH-InformationList-RL-SetupRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationList_RL_SetupRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-SetupRspTDD768')))
    __DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 640), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationList_RL_SetupRspTDD768_id._const_tab = __DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab
    _DL_DPCH_InformationList_RL_SetupRspTDD768_id._const_tab_at = None
    _DL_DPCH_InformationList_RL_SetupRspTDD768_id._const_tab_id = u'id'
    _DL_DPCH_InformationList_RL_SetupRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationList_RL_SetupRspTDD768_criticality._const_tab = __DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab
    _DL_DPCH_InformationList_RL_SetupRspTDD768_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_SetupRspTDD768_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationList_RL_SetupRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationList_RL_SetupRspTDD768_value._const_tab = __DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab
    _DL_DPCH_InformationList_RL_SetupRspTDD768_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_SetupRspTDD768_value._const_tab_id = u'Value'
    DL_DPCH_InformationList_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationList_RL_SetupRspTDD768_id),
        (u'criticality', _DL_DPCH_InformationList_RL_SetupRspTDD768_criticality),
        (u'value', _DL_DPCH_InformationList_RL_SetupRspTDD768_value),
        ])
    DL_DPCH_InformationList_RL_SetupRspTDD768._ext = None
    
    #-----< DL-DPCH-InformationListIEs-RL-SetupRspTDD768 >-----#
    DL_DPCH_InformationListIEs_RL_SetupRspTDD768 = CLASS(name=u'DL-DPCH-InformationListIEs-RL-SetupRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationListIEs_RL_SetupRspTDD768_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-SetupRspTDD768')))
    DL_DPCH_InformationListIEs_RL_SetupRspTDD768._val = ASN1Set(rv=[dict([(u'id', 640), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationListIEs_RL_SetupRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-RL-SetupRspTDD768 >-----#
    DL_DPCH_InformationItem_RL_SetupRspTDD768 = SEQ(name=u'DL-DPCH-InformationItem-RL-SetupRspTDD768', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_dL_Timeslot_Information768 = SEQ_OF(name=u'dL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-Information768')))
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions._cont = __DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_
    _DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_RL_SetupRspTDD768._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationItem_RL_SetupRspTDD768_tDD_DPCHOffset),
        (u'dL-Timeslot-Information768', _DL_DPCH_InformationItem_RL_SetupRspTDD768_dL_Timeslot_Information768),
        (u'iE-Extensions', _DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions),
        ])
    DL_DPCH_InformationItem_RL_SetupRspTDD768._ext = []
    
    #-----< DL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs >-----#
    DL_DPCH_InformationItem_RL_SetupRspTDD768_ExtIEs = CLASS(name=u'DL-DPCH-InformationItem-RL-SetupRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_RL_SetupRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureFDD >-----#
    RadioLinkSetupFailureFDD = SEQ(name=u'RadioLinkSetupFailureFDD', mode=MODE_TYPE)
    _RadioLinkSetupFailureFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupFailureFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-SetupFailureFDD')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 200), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupFailureFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkSetupFailureFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupFailureFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkSetupFailureFDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupFailureFDD_protocolIEs__item_._ext = None
    _RadioLinkSetupFailureFDD_protocolIEs._cont = __RadioLinkSetupFailureFDD_protocolIEs__item_
    _RadioLinkSetupFailureFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupFailureFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupFailureFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkSetupFailureFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupFailureFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupFailureFDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupFailureFDD_protocolExtensions._cont = __RadioLinkSetupFailureFDD_protocolExtensions__item_
    _RadioLinkSetupFailureFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupFailureFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkSetupFailureFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkSetupFailureFDD_protocolExtensions),
        ])
    RadioLinkSetupFailureFDD._ext = []
    
    #-----< RadioLinkSetupFailureFDD-IEs >-----#
    RadioLinkSetupFailureFDD_IEs = CLASS(name=u'RadioLinkSetupFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-SetupFailureFDD')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RadioLinkSetupFailureFDD_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupFailureFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureFDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureFDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 200), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureFDD_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 184), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureFDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureFDD_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-SetupFailureFDD >-----#
    CauseLevel_RL_SetupFailureFDD = CHOICE(name=u'CauseLevel-RL-SetupFailureFDD', mode=MODE_TYPE)
    _CauseLevel_RL_SetupFailureFDD_generalCause = SEQ(name=u'generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GeneralCauseList-RL-SetupFailureFDD')))
    _CauseLevel_RL_SetupFailureFDD_rLSpecificCause = SEQ(name=u'rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RLSpecificCauseList-RL-SetupFailureFDD')))
    CauseLevel_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'generalCause', _CauseLevel_RL_SetupFailureFDD_generalCause),
        (u'rLSpecificCause', _CauseLevel_RL_SetupFailureFDD_rLSpecificCause),
        ])
    CauseLevel_RL_SetupFailureFDD._ext = []
    
    #-----< GeneralCauseList-RL-SetupFailureFDD >-----#
    GeneralCauseList_RL_SetupFailureFDD = SEQ(name=u'GeneralCauseList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_SetupFailureFDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions._cont = __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_
    _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'cause', _GeneralCauseList_RL_SetupFailureFDD_cause),
        (u'iE-Extensions', _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions),
        ])
    GeneralCauseList_RL_SetupFailureFDD._ext = []
    
    #-----< GeneralCauseItem-RL-SetupFailureFDD-ExtIEs >-----#
    GeneralCauseItem_RL_SetupFailureFDD_ExtIEs = CLASS(name=u'GeneralCauseItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-SetupFailureFDD >-----#
    RLSpecificCauseList_RL_SetupFailureFDD = SEQ(name=u'RLSpecificCauseList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_SetupFailureFDD_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD = SEQ_OF(name=u'unsuccessful-RL-InformationRespList-RL-SetupFailureFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponseList-RL-SetupFailureFDD')))
    _RLSpecificCauseList_RL_SetupFailureFDD_successful_RL_InformationRespList_RL_SetupFailureFDD = SEQ_OF(name=u'successful-RL-InformationRespList-RL-SetupFailureFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SuccessfulRL-InformationResponseList-RL-SetupFailureFDD')), opt=True)
    _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 795), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 838), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions._cont = __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'unsuccessful-RL-InformationRespList-RL-SetupFailureFDD', _RLSpecificCauseList_RL_SetupFailureFDD_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD),
        (u'successful-RL-InformationRespList-RL-SetupFailureFDD', _RLSpecificCauseList_RL_SetupFailureFDD_successful_RL_InformationRespList_RL_SetupFailureFDD),
        (u'iE-Extensions', _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_SetupFailureFDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs = CLASS(name=u'RLSpecificCauseItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-List')))
    RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 795), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 838), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UnsuccessfulRL-InformationResponseList-RL-SetupFailureFDD >-----#
    UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD = SEQ_OF(name=u'UnsuccessfulRL-InformationResponseList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD')))
    ___UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', ____UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id._const_tab = ___UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id._const_tab_at = None
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id._const_tab_id = u'id'
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality._const_tab = ___UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality._const_tab_at = ('..', u'id')
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality._const_tab_id = u'criticality'
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value._const_tab = ___UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value._const_tab_at = ('..', u'id')
    __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value._const_tab_id = u'Value'
    _UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_._cont = ASN1Dict([
        (u'id', __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id),
        (u'criticality', __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality),
        (u'value', __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value),
        ])
    _UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_._ext = None
    UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD._cont = _UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_
    UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs >-----#
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs = CLASS(name=u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD')))
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 189), (u'criticality', u'ignore'), (u'Value', _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD >-----#
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD = SEQ(name=u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD', mode=MODE_TYPE)
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions._cont = __UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'rL-ID', _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_ID),
        (u'cause', _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_cause),
        (u'iE-Extensions', _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions),
        ])
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD._ext = []
    
    #-----< UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs >-----#
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs = CLASS(name=u'UnsuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< SuccessfulRL-InformationResponseList-RL-SetupFailureFDD >-----#
    SuccessfulRL_InformationResponseList_RL_SetupFailureFDD = SEQ_OF(name=u'SuccessfulRL-InformationResponseList-RL-SetupFailureFDD', mode=MODE_TYPE)
    _SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SuccessfulRL-InformationResponse-RL-SetupFailureFDD')))
    ___SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 160), (u'criticality', u'ignore'), (u'Value', ____SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id._const_tab = ___SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id._const_tab_at = None
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id._const_tab_id = u'id'
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality._const_tab = ___SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality._const_tab_at = ('..', u'id')
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality._const_tab_id = u'criticality'
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value._const_tab = ___SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value._const_tab_at = ('..', u'id')
    __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value._const_tab_id = u'Value'
    _SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_._cont = ASN1Dict([
        (u'id', __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id),
        (u'criticality', __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality),
        (u'value', __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value),
        ])
    _SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_._ext = None
    SuccessfulRL_InformationResponseList_RL_SetupFailureFDD._cont = _SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_
    SuccessfulRL_InformationResponseList_RL_SetupFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< SuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs >-----#
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs = CLASS(name=u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SuccessfulRL-InformationResponse-RL-SetupFailureFDD')))
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 160), (u'criticality', u'ignore'), (u'Value', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SuccessfulRL-InformationResponse-RL-SetupFailureFDD >-----#
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD = SEQ(name=u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD', mode=MODE_TYPE)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_received_total_wide_band_power = INT(name=u'received-total-wide-band-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Received-total-wide-band-power')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_not_Used_secondary_CCPCH_Info = NULL(name=u'not-Used-secondary-CCPCH-Info', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_dl_CodeInformation = SEQ_OF(name=u'dl-CodeInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_diversityIndication = CHOICE(name=u'diversityIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-SetupFailureFDD')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sSDT_SupportIndicator = ENUM(name=u'sSDT-SupportIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SSDT-SupportIndicator')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_closedlooptimingadjustmentmode = ENUM(name=u'closedlooptimingadjustmentmode', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Closedlooptimingadjustmentmode')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_primaryScramblingCode = INT(name=u'primaryScramblingCode', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryScramblingCode')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_uL_UARFCN = INT(name=u'uL-UARFCN', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_dL_UARFCN = INT(name=u'dL-UARFCN', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD = NULL(name=u'not-Used-dSCH-InformationResponse-RL-SetupFailureFDD', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_pC_Preamble = INT(name=u'pC-Preamble', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PC-Preamble')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sRB_Delay = INT(name=u'sRB-Delay', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SRB-Delay')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_13 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 519), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 520), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_13), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions._cont = __SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'rL-ID', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_ID),
        (u'rL-Set-ID', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_Set_ID),
        (u'uRA-Information', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_uRA_Information),
        (u'sAI', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sAI),
        (u'gA-Cell', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_gA_Cell),
        (u'gA-AccessPointPosition', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_gA_AccessPointPosition),
        (u'received-total-wide-band-power', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_received_total_wide_band_power),
        (u'not-Used-secondary-CCPCH-Info', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_not_Used_secondary_CCPCH_Info),
        (u'dl-CodeInformation', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_dl_CodeInformation),
        (u'diversityIndication', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_diversityIndication),
        (u'sSDT-SupportIndicator', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sSDT_SupportIndicator),
        (u'maxUL-SIR', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maxUL_SIR),
        (u'minUL-SIR', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_minUL_SIR),
        (u'closedlooptimingadjustmentmode', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_closedlooptimingadjustmentmode),
        (u'maximumAllowedULTxPower', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maximumDLTxPower),
        (u'minimumDLTxPower', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_minimumDLTxPower),
        (u'primaryCPICH-Power', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_primaryCPICH_Power),
        (u'primaryScramblingCode', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_primaryScramblingCode),
        (u'uL-UARFCN', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_uL_UARFCN),
        (u'dL-UARFCN', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_dL_UARFCN),
        (u'not-Used-dSCH-InformationResponse-RL-SetupFailureFDD', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD),
        (u'neighbouring-UMTS-CellInformation', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_neighbouring_GSM_CellInformation),
        (u'pC-Preamble', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_pC_Preamble),
        (u'sRB-Delay', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sRB_Delay),
        (u'iE-Extensions', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions),
        ])
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD._ext = []
    
    #-----< SuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs >-----#
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs = CLASS(name=u'SuccessfulRL-InformationResponse-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_8 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_9 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_13 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 519), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 520), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_13), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-SetupFailureFDD >-----#
    DiversityIndication_RL_SetupFailureFDD = CHOICE(name=u'DiversityIndication-RL-SetupFailureFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_SetupFailureFDD_combining = SEQ(name=u'combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Combining-RL-SetupFailureFDD')))
    _DiversityIndication_RL_SetupFailureFDD_nonCombiningOrFirstRL = SEQ(name=u'nonCombiningOrFirstRL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'NonCombiningOrFirstRL-RL-SetupFailureFDD')))
    DiversityIndication_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'combining', _DiversityIndication_RL_SetupFailureFDD_combining),
        (u'nonCombiningOrFirstRL', _DiversityIndication_RL_SetupFailureFDD_nonCombiningOrFirstRL),
        ])
    DiversityIndication_RL_SetupFailureFDD._ext = None
    
    #-----< Combining-RL-SetupFailureFDD >-----#
    Combining_RL_SetupFailureFDD = SEQ(name=u'Combining-RL-SetupFailureFDD', mode=MODE_TYPE)
    _Combining_RL_SetupFailureFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Combining_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Combining_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _Combining_RL_SetupFailureFDD_iE_Extensions._cont = __Combining_RL_SetupFailureFDD_iE_Extensions__item_
    _Combining_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'rL-ID', _Combining_RL_SetupFailureFDD_rL_ID),
        (u'iE-Extensions', _Combining_RL_SetupFailureFDD_iE_Extensions),
        ])
    Combining_RL_SetupFailureFDD._ext = []
    
    #-----< CombiningItem-RL-SetupFailureFDD-ExtIEs >-----#
    CombiningItem_RL_SetupFailureFDD_ExtIEs = CLASS(name=u'CombiningItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _CombiningItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    CombiningItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonCombiningOrFirstRL-RL-SetupFailureFDD >-----#
    NonCombiningOrFirstRL_RL_SetupFailureFDD = SEQ(name=u'NonCombiningOrFirstRL-RL-SetupFailureFDD', mode=MODE_TYPE)
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_dCH_InformationResponse = SEQ_OF(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab = ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab = ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_._ext = None
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions._cont = __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_
    _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombiningOrFirstRL_RL_SetupFailureFDD._cont = ASN1Dict([
        (u'dCH-InformationResponse', _NonCombiningOrFirstRL_RL_SetupFailureFDD_dCH_InformationResponse),
        (u'iE-Extensions', _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions),
        ])
    NonCombiningOrFirstRL_RL_SetupFailureFDD._ext = []
    
    #-----< NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs >-----#
    NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs = CLASS(name=u'NonCombiningOrFirstRLItem-RL-SetupFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureFDD-Extensions >-----#
    RadioLinkSetupFailureFDD_Extensions = CLASS(name=u'RadioLinkSetupFailureFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkSetupFailureFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureTDD >-----#
    RadioLinkSetupFailureTDD = SEQ(name=u'RadioLinkSetupFailureTDD', mode=MODE_TYPE)
    _RadioLinkSetupFailureTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkSetupFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-SetupFailureTDD')))
    _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 201), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id._const_tab = ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkSetupFailureTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value._const_tab = ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkSetupFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupFailureTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkSetupFailureTDD_protocolIEs__item__value),
        ])
    __RadioLinkSetupFailureTDD_protocolIEs__item_._ext = None
    _RadioLinkSetupFailureTDD_protocolIEs._cont = __RadioLinkSetupFailureTDD_protocolIEs__item_
    _RadioLinkSetupFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkSetupFailureTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkSetupFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id._const_tab = ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkSetupFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkSetupFailureTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkSetupFailureTDD_protocolExtensions__item_._ext = None
    _RadioLinkSetupFailureTDD_protocolExtensions._cont = __RadioLinkSetupFailureTDD_protocolExtensions__item_
    _RadioLinkSetupFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkSetupFailureTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkSetupFailureTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkSetupFailureTDD_protocolExtensions),
        ])
    RadioLinkSetupFailureTDD._ext = []
    
    #-----< RadioLinkSetupFailureTDD-IEs >-----#
    RadioLinkSetupFailureTDD_IEs = CLASS(name=u'RadioLinkSetupFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkSetupFailureTDD_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-SetupFailureTDD')))
    _RadioLinkSetupFailureTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkSetupFailureTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 201), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureTDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkSetupFailureTDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-SetupFailureTDD >-----#
    CauseLevel_RL_SetupFailureTDD = CHOICE(name=u'CauseLevel-RL-SetupFailureTDD', mode=MODE_TYPE)
    _CauseLevel_RL_SetupFailureTDD_generalCause = SEQ(name=u'generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GeneralCauseList-RL-SetupFailureTDD')))
    _CauseLevel_RL_SetupFailureTDD_rLSpecificCause = SEQ(name=u'rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RLSpecificCauseList-RL-SetupFailureTDD')))
    CauseLevel_RL_SetupFailureTDD._cont = ASN1Dict([
        (u'generalCause', _CauseLevel_RL_SetupFailureTDD_generalCause),
        (u'rLSpecificCause', _CauseLevel_RL_SetupFailureTDD_rLSpecificCause),
        ])
    CauseLevel_RL_SetupFailureTDD._ext = []
    
    #-----< GeneralCauseList-RL-SetupFailureTDD >-----#
    GeneralCauseList_RL_SetupFailureTDD = SEQ(name=u'GeneralCauseList-RL-SetupFailureTDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_SetupFailureTDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id),
        (u'criticality', ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions._cont = __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_
    _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_SetupFailureTDD._cont = ASN1Dict([
        (u'cause', _GeneralCauseList_RL_SetupFailureTDD_cause),
        (u'iE-Extensions', _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions),
        ])
    GeneralCauseList_RL_SetupFailureTDD._ext = []
    
    #-----< GeneralCauseItem-RL-SetupFailureTDD-ExtIEs >-----#
    GeneralCauseItem_RL_SetupFailureTDD_ExtIEs = CLASS(name=u'GeneralCauseItem-RL-SetupFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_SetupFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-SetupFailureTDD >-----#
    RLSpecificCauseList_RL_SetupFailureTDD = SEQ(name=u'RLSpecificCauseList-RL-SetupFailureTDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_SetupFailureTDD_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD = SEQ(name=u'unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD')))
    _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id),
        (u'criticality', ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions._cont = __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_SetupFailureTDD._cont = ASN1Dict([
        (u'unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD', _RLSpecificCauseList_RL_SetupFailureTDD_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD),
        (u'iE-Extensions', _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_SetupFailureTDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs = CLASS(name=u'RLSpecificCauseItem-RL-SetupFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SixtyfourQAM-DL-SupportIndicator')))
    RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 684), (u'criticality', u'ignore'), (u'Extension', _RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD >-----#
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD = SEQ(name=u'Unsuccessful-RL-InformationRespItem-RL-SetupFailureTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD')))
    __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id._const_tab = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id._const_tab_at = None
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id._const_tab_id = u'id'
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality._const_tab = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality._const_tab_at = ('..', u'id')
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality._const_tab_id = u'criticality'
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value._const_tab = __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value._const_tab_at = ('..', u'id')
    _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value._const_tab_id = u'Value'
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD._cont = ASN1Dict([
        (u'id', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id),
        (u'criticality', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality),
        (u'value', _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value),
        ])
    Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD._ext = None
    
    #-----< Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD >-----#
    Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD = CLASS(name=u'Unsuccessful-RL-InformationRespItemIE-RL-SetupFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD')))
    Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD._val = ASN1Set(rv=[dict([(u'id', 190), (u'criticality', u'ignore'), (u'Value', _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD >-----#
    UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD = SEQ(name=u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD', mode=MODE_TYPE)
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab = ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id_tab
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab = ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id),
        (u'criticality', ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item_._ext = None
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions._cont = __UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item_
    _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD._cont = ASN1Dict([
        (u'rL-ID', _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_rL_ID),
        (u'cause', _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_cause),
        (u'iE-Extensions', _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions),
        ])
    UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD._ext = []
    
    #-----< UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD-ExtIEs >-----#
    UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_ExtIEs = CLASS(name=u'UnsuccessfulRL-InformationResponse-RL-SetupFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkSetupFailureTDD-Extensions >-----#
    RadioLinkSetupFailureTDD_Extensions = CLASS(name=u'RadioLinkSetupFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkSetupFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestFDD >-----#
    RadioLinkAdditionRequestFDD = SEQ(name=u'RadioLinkAdditionRequestFDD', mode=MODE_TYPE)
    _RadioLinkAdditionRequestFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-AdditionRqstFDD')))
    _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Value', _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 124), (u'criticality', u'notify'), (u'Value', _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 193), (u'criticality', u'reject'), (u'Value', _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkAdditionRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionRequestFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkAdditionRequestFDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionRequestFDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionRequestFDD_protocolIEs._cont = __RadioLinkAdditionRequestFDD_protocolIEs__item_
    _RadioLinkAdditionRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionRequestFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDPCH-Information-RLAdditionReq-FDD')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Addition-List')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Add-Req')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information')))
    _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information')))
    ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 592), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 602), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 601), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 574), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 796), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 839), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 906), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 968), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 983), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkAdditionRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionRequestFDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionRequestFDD_protocolExtensions._cont = __RadioLinkAdditionRequestFDD_protocolExtensions__item_
    _RadioLinkAdditionRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionRequestFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkAdditionRequestFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkAdditionRequestFDD_protocolExtensions),
        ])
    RadioLinkAdditionRequestFDD._ext = []
    
    #-----< RadioLinkAdditionRequestFDD-IEs >-----#
    RadioLinkAdditionRequestFDD_IEs = CLASS(name=u'RadioLinkAdditionRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkAdditionRequestFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RadioLinkAdditionRequestFDD_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-AdditionRqstFDD')))
    _RadioLinkAdditionRequestFDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    RadioLinkAdditionRequestFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Value', _RadioLinkAdditionRequestFDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 124), (u'criticality', u'notify'), (u'Value', _RadioLinkAdditionRequestFDD_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 193), (u'criticality', u'reject'), (u'Value', _RadioLinkAdditionRequestFDD_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-AdditionRqstFDD >-----#
    RL_InformationList_RL_AdditionRqstFDD = SEQ_OF(name=u'RL-InformationList-RL-AdditionRqstFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_AdditionRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_AdditionRqstFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_AdditionRqstFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-AdditionRqstFDD')))
    ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 112), (u'criticality', u'notify'), (u'Value', ____RL_InformationList_RL_AdditionRqstFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_AdditionRqstFDD__item__id._const_tab = ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab
    __RL_InformationList_RL_AdditionRqstFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_AdditionRqstFDD__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality._const_tab = ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_AdditionRqstFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_AdditionRqstFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_AdditionRqstFDD__item__value._const_tab = ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab
    __RL_InformationList_RL_AdditionRqstFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_AdditionRqstFDD__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_AdditionRqstFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_AdditionRqstFDD__item__id),
        (u'criticality', __RL_InformationList_RL_AdditionRqstFDD__item__criticality),
        (u'value', __RL_InformationList_RL_AdditionRqstFDD__item__value),
        ])
    _RL_InformationList_RL_AdditionRqstFDD__item_._ext = None
    RL_InformationList_RL_AdditionRqstFDD._cont = _RL_InformationList_RL_AdditionRqstFDD__item_
    RL_InformationList_RL_AdditionRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-Information-RL-AdditionRqstFDD-IEs >-----#
    RL_Information_RL_AdditionRqstFDD_IEs = CLASS(name=u'RL-Information-RL-AdditionRqstFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_RL_AdditionRqstFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-AdditionRqstFDD')))
    RL_Information_RL_AdditionRqstFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 112), (u'criticality', u'notify'), (u'Value', _RL_Information_RL_AdditionRqstFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Information-RL-AdditionRqstFDD >-----#
    RL_Information_RL_AdditionRqstFDD = SEQ(name=u'RL-Information-RL-AdditionRqstFDD', mode=MODE_TYPE)
    _RL_Information_RL_AdditionRqstFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_AdditionRqstFDD_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _RL_Information_RL_AdditionRqstFDD_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')))
    _RL_Information_RL_AdditionRqstFDD_chipOffset = INT(name=u'chipOffset', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'ChipOffset')))
    _RL_Information_RL_AdditionRqstFDD_diversityControlField = ENUM(name=u'diversityControlField', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiversityControlField')))
    _RL_Information_RL_AdditionRqstFDD_primaryCPICH_EcNo = INT(name=u'primaryCPICH-EcNo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-EcNo')), opt=True)
    _RL_Information_RL_AdditionRqstFDD_not_Used_sSDT_CellID = NULL(name=u'not-Used-sSDT-CellID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_Information_RL_AdditionRqstFDD_transmitDiversityIndicator = ENUM(name=u'transmitDiversityIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')), opt=True)
    _RL_Information_RL_AdditionRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_AdditionRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PrimaryCPICH-EcNo')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationIndicator')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    ____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 224), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 572), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_AdditionRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_AdditionRqstFDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_AdditionRqstFDD_iE_Extensions._cont = __RL_Information_RL_AdditionRqstFDD_iE_Extensions__item_
    _RL_Information_RL_AdditionRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_AdditionRqstFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_AdditionRqstFDD_rL_ID),
        (u'c-ID', _RL_Information_RL_AdditionRqstFDD_c_ID),
        (u'frameOffset', _RL_Information_RL_AdditionRqstFDD_frameOffset),
        (u'chipOffset', _RL_Information_RL_AdditionRqstFDD_chipOffset),
        (u'diversityControlField', _RL_Information_RL_AdditionRqstFDD_diversityControlField),
        (u'primaryCPICH-EcNo', _RL_Information_RL_AdditionRqstFDD_primaryCPICH_EcNo),
        (u'not-Used-sSDT-CellID', _RL_Information_RL_AdditionRqstFDD_not_Used_sSDT_CellID),
        (u'transmitDiversityIndicator', _RL_Information_RL_AdditionRqstFDD_transmitDiversityIndicator),
        (u'iE-Extensions', _RL_Information_RL_AdditionRqstFDD_iE_Extensions),
        ])
    RL_Information_RL_AdditionRqstFDD._ext = []
    
    #-----< RL-Information-RL-AdditionRqstFDD-ExtIEs >-----#
    RL_Information_RL_AdditionRqstFDD_ExtIEs = CLASS(name=u'RL-Information-RL-AdditionRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PrimaryCPICH-EcNo')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationIndicator')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information')))
    _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    RL_Information_RL_AdditionRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 224), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 572), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 911), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestFDD-Extensions >-----#
    RadioLinkAdditionRequestFDD_Extensions = CLASS(name=u'RadioLinkAdditionRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_1 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Initial-DL-DPCH-TimingAdjustment-Allowed')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDPCH-Information-RLAdditionReq-FDD')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_8 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Addition-List')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Add-Req')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_12 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_13 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information')))
    _RadioLinkAdditionRequestFDD_Extensions_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Information')))
    RadioLinkAdditionRequestFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 12), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 592), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 602), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 601), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 574), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 796), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 839), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 906), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 968), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 983), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestFDD_Extensions_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Addition-List >-----#
    Additional_HS_Cell_Information_RL_Addition_List = SEQ_OF(name=u'Additional-HS-Cell-Information-RL-Addition-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Addition_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Addition-ItemIEs')))
    Additional_HS_Cell_Information_RL_Addition_List._cont = _Additional_HS_Cell_Information_RL_Addition_List__item_
    Additional_HS_Cell_Information_RL_Addition_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Addition-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Addition_ItemIEs = SEQ(name=u'Additional-HS-Cell-Information-RL-Addition-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')))
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Addition_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hSPDSCH_RL_ID),
        (u'c-ID', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_c_ID),
        (u'hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        (u'iE-Extensions', _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Addition_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Addition_ItemIEs_ExtIEs = CLASS(name=u'Additional-HS-Cell-Information-RL-Addition-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Addition_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Add-Req >-----#
    Additional_EDCH_Cell_Information_RL_Add_Req = SEQ(name=u'Additional-EDCH-Cell-Information-RL-Add-Req', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Add_Req_setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name=u'setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Add_Req._cont = ASN1Dict([
        (u'setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency', _Additional_EDCH_Cell_Information_RL_Add_Req_setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Add_Req._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Add_Req_ExtIEs = CLASS(name=u'Additional-EDCH-Cell-Information-RL-Add-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Add_Req_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency >-----#
    Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name=u'Setup-Or-Addition-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE)
    _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_setup = SEQ(name=u'setup', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Setup-Info')))
    _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_addition = SEQ_OF(name=u'addition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-To-Add-List')))
    Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency._cont = ASN1Dict([
        (u'setup', _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_setup),
        (u'addition', _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_addition),
        ])
    Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency._ext = []
    
    #-----< EDPCH-Information-RLAdditionReq-FDD >-----#
    EDPCH_Information_RLAdditionReq_FDD = SEQ(name=u'EDPCH-Information-RLAdditionReq-FDD', mode=MODE_TYPE)
    _EDPCH_Information_RLAdditionReq_FDD_maxSet_E_DPDCHs = ENUM(name=u'maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Max-Set-E-DPDCHs')))
    _EDPCH_Information_RLAdditionReq_FDD_ul_PunctureLimit = INT(name=u'ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _EDPCH_Information_RLAdditionReq_FDD_e_TFCS_Information = SEQ(name=u'e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TFCS-Information')))
    _EDPCH_Information_RLAdditionReq_FDD_e_TTI = ENUM(name=u'e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-TTI')))
    _EDPCH_Information_RLAdditionReq_FDD_e_DPCCH_PO = INT(name=u'e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-DPCCH-PO')))
    _EDPCH_Information_RLAdditionReq_FDD_e_RGCH_2_IndexStepThreshold = INT(name=u'e-RGCH-2-IndexStepThreshold', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-2-IndexStepThreshold')))
    _EDPCH_Information_RLAdditionReq_FDD_e_RGCH_3_IndexStepThreshold = INT(name=u'e-RGCH-3-IndexStepThreshold', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'E-RGCH-3-IndexStepThreshold')))
    _EDPCH_Information_RLAdditionReq_FDD_hARQ_Info_for_E_DCH = ENUM(name=u'hARQ-Info-for-E-DCH', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HARQ-Info-for-E-DCH')))
    _EDPCH_Information_RLAdditionReq_FDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Configured-Indicator')))
    _____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    ____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 649), (u'criticality', u'reject'), (u'Extension', _____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id._const_tab = ____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id._const_tab_at = None
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__criticality._const_tab = ____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__extensionValue._const_tab = ____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id),
        (u'criticality', ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__extensionValue),
        ])
    __EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item_._ext = None
    _EDPCH_Information_RLAdditionReq_FDD_iE_Extensions._cont = __EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item_
    _EDPCH_Information_RLAdditionReq_FDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDPCH_Information_RLAdditionReq_FDD._cont = ASN1Dict([
        (u'maxSet-E-DPDCHs', _EDPCH_Information_RLAdditionReq_FDD_maxSet_E_DPDCHs),
        (u'ul-PunctureLimit', _EDPCH_Information_RLAdditionReq_FDD_ul_PunctureLimit),
        (u'e-TFCS-Information', _EDPCH_Information_RLAdditionReq_FDD_e_TFCS_Information),
        (u'e-TTI', _EDPCH_Information_RLAdditionReq_FDD_e_TTI),
        (u'e-DPCCH-PO', _EDPCH_Information_RLAdditionReq_FDD_e_DPCCH_PO),
        (u'e-RGCH-2-IndexStepThreshold', _EDPCH_Information_RLAdditionReq_FDD_e_RGCH_2_IndexStepThreshold),
        (u'e-RGCH-3-IndexStepThreshold', _EDPCH_Information_RLAdditionReq_FDD_e_RGCH_3_IndexStepThreshold),
        (u'hARQ-Info-for-E-DCH', _EDPCH_Information_RLAdditionReq_FDD_hARQ_Info_for_E_DCH),
        (u'iE-Extensions', _EDPCH_Information_RLAdditionReq_FDD_iE_Extensions),
        ])
    EDPCH_Information_RLAdditionReq_FDD._ext = []
    
    #-----< EDPCH-Information-RLAdditionReq-FDD-ExtIEs >-----#
    EDPCH_Information_RLAdditionReq_FDD_ExtIEs = CLASS(name=u'EDPCH-Information-RLAdditionReq-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EDPCH_Information_RLAdditionReq_FDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Configured-Indicator')))
    _EDPCH_Information_RLAdditionReq_FDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MinimumReducedE-DPDCH-GainFactor')))
    EDPCH_Information_RLAdditionReq_FDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 649), (u'criticality', u'reject'), (u'Extension', _EDPCH_Information_RLAdditionReq_FDD_ExtIEs_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 787), (u'criticality', u'ignore'), (u'Extension', _EDPCH_Information_RLAdditionReq_FDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestTDD >-----#
    RadioLinkAdditionRequestTDD = SEQ(name=u'RadioLinkAdditionRequestTDD', mode=MODE_TYPE)
    _RadioLinkAdditionRequestTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-AdditionRqstTDD')))
    ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 113), (u'criticality', u'reject'), (u'Value', _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkAdditionRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionRequestTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkAdditionRequestTDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionRequestTDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionRequestTDD_protocolIEs._cont = __RadioLinkAdditionRequestTDD_protocolIEs__item_
    _RadioLinkAdditionRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionRequestTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 484), (u'criticality', u'notify'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 486), (u'criticality', u'notify'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 655), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 659), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 677), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 807), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 812), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 811), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 884), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkAdditionRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionRequestTDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionRequestTDD_protocolExtensions._cont = __RadioLinkAdditionRequestTDD_protocolExtensions__item_
    _RadioLinkAdditionRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionRequestTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkAdditionRequestTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkAdditionRequestTDD_protocolExtensions),
        ])
    RadioLinkAdditionRequestTDD._ext = []
    
    #-----< RadioLinkAdditionRequestTDD-IEs >-----#
    RadioLinkAdditionRequestTDD_IEs = CLASS(name=u'RadioLinkAdditionRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkAdditionRequestTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-AdditionRqstTDD')))
    RadioLinkAdditionRequestTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 113), (u'criticality', u'reject'), (u'Value', _RadioLinkAdditionRequestTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RL-Information-RL-AdditionRqstTDD >-----#
    RL_Information_RL_AdditionRqstTDD = SEQ(name=u'RL-Information-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _RL_Information_RL_AdditionRqstTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_AdditionRqstTDD_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _RL_Information_RL_AdditionRqstTDD_frameOffset = INT(name=u'frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FrameOffset')))
    _RL_Information_RL_AdditionRqstTDD_diversityControlField = ENUM(name=u'diversityControlField', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiversityControlField')))
    _RL_Information_RL_AdditionRqstTDD_primaryCCPCH_RSCP = INT(name=u'primaryCCPCH-RSCP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')), opt=True)
    _RL_Information_RL_AdditionRqstTDD_dL_TimeSlot_ISCP_Info = SEQ_OF(name=u'dL-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-Info')), opt=True)
    _RL_Information_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE)
    ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 81), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 464), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 806), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_AdditionRqstTDD_iE_Extensions._cont = __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_
    _RL_Information_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_AdditionRqstTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_AdditionRqstTDD_rL_ID),
        (u'c-ID', _RL_Information_RL_AdditionRqstTDD_c_ID),
        (u'frameOffset', _RL_Information_RL_AdditionRqstTDD_frameOffset),
        (u'diversityControlField', _RL_Information_RL_AdditionRqstTDD_diversityControlField),
        (u'primaryCCPCH-RSCP', _RL_Information_RL_AdditionRqstTDD_primaryCCPCH_RSCP),
        (u'dL-TimeSlot-ISCP-Info', _RL_Information_RL_AdditionRqstTDD_dL_TimeSlot_ISCP_Info),
        (u'iE-Extensions', _RL_Information_RL_AdditionRqstTDD_iE_Extensions),
        ])
    RL_Information_RL_AdditionRqstTDD._ext = []
    
    #-----< RL-Information-RL-AdditionRqstTDD-ExtIEs >-----#
    RL_Information_RL_AdditionRqstTDD_ExtIEs = CLASS(name=u'RL-Information-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivation')))
    _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE)
    RL_Information_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 81), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 312), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 464), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 806), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionRequestTDD-Extensions >-----#
    RadioLinkAdditionRequestTDD_Extensions = CLASS(name=u'RadioLinkAdditionRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-AdditionRqstTDD')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-InformationLCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-LCR')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_12 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Info')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _RadioLinkAdditionRequestTDD_Extensions_val_Extension_15 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkAdditionRequestTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 484), (u'criticality', u'notify'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 486), (u'criticality', u'notify'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 655), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 659), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 677), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 807), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 812), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 811), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 884), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionRequestTDD_Extensions_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    UL_CCTrCH_InformationList_RL_AdditionRqstTDD = SEQ_OF(name=u'UL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD')))
    ___UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 485), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_._ext = None
    UL_CCTrCH_InformationList_RL_AdditionRqstTDD._cont = _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_
    UL_CCTrCH_InformationList_RL_AdditionRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD >-----#
    UL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD = CLASS(name=u'UL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD')))
    UL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD._val = ASN1Set(rv=[dict([(u'id', 485), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationItem-RL-AdditionRqstTDD >-----#
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD = SEQ(name=u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_uplinkStepSizeLCR = ENUM(name=u'uplinkStepSizeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')), opt=True)
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID),
        (u'uplinkStepSizeLCR', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_uplinkStepSizeLCR),
        (u'iE-Extensions', _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-RL-AdditionRqstTDD >-----#
    DL_CCTrCH_InformationList_RL_AdditionRqstTDD = SEQ_OF(name=u'DL-CCTrCH-InformationList-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD')))
    ___DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 487), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_._ext = None
    DL_CCTrCH_InformationList_RL_AdditionRqstTDD._cont = _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_
    DL_CCTrCH_InformationList_RL_AdditionRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD >-----#
    DL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD = CLASS(name=u'DL-CCTrCH-InformationItemIEs-RL-AdditionRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD')))
    DL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD._val = ASN1Set(rv=[dict([(u'id', 487), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationItem-RL-AdditionRqstTDD >-----#
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD = SEQ(name=u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_downlinkStepSize = ENUM(name=u'downlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-DownlinkStepSize')), opt=True)
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID),
        (u'downlinkStepSize', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_downlinkStepSize),
        (u'iE-Extensions', _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationItem-RL-AdditionRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseFDD >-----#
    RadioLinkAdditionResponseFDD = SEQ(name=u'RadioLinkAdditionResponseFDD', mode=MODE_TYPE)
    _RadioLinkAdditionResponseFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionResponseFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-AdditionRspFDD')))
    _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkAdditionResponseFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionResponseFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkAdditionResponseFDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionResponseFDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionResponseFDD_protocolIEs._cont = __RadioLinkAdditionResponseFDD_protocolIEs__item_
    _RadioLinkAdditionResponseFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionResponseFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionResponseFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-informationResponse')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Serving-cell-change-informationResponse')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLAddList')))
    ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 603), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 604), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 797), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 840), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkAdditionResponseFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionResponseFDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionResponseFDD_protocolExtensions._cont = __RadioLinkAdditionResponseFDD_protocolExtensions__item_
    _RadioLinkAdditionResponseFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionResponseFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkAdditionResponseFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkAdditionResponseFDD_protocolExtensions),
        ])
    RadioLinkAdditionResponseFDD._ext = []
    
    #-----< RadioLinkAdditionResponseFDD-IEs >-----#
    RadioLinkAdditionResponseFDD_IEs = CLASS(name=u'RadioLinkAdditionResponseFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkAdditionResponseFDD_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-AdditionRspFDD')))
    _RadioLinkAdditionResponseFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionResponseFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 134), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionResponseFDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionResponseFDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-AdditionRspFDD >-----#
    RL_InformationResponseList_RL_AdditionRspFDD = SEQ_OF(name=u'RL-InformationResponseList-RL-AdditionRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_AdditionRspFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-AdditionRspFDD')))
    ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', ____RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id._const_tab = ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_AdditionRspFDD__item__id._const_tab_id = u'id'
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality._const_tab = ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value._const_tab = ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_AdditionRspFDD__item__value._const_tab_id = u'Value'
    _RL_InformationResponseList_RL_AdditionRspFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationResponseList_RL_AdditionRspFDD__item__id),
        (u'criticality', __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality),
        (u'value', __RL_InformationResponseList_RL_AdditionRspFDD__item__value),
        ])
    _RL_InformationResponseList_RL_AdditionRspFDD__item_._ext = None
    RL_InformationResponseList_RL_AdditionRspFDD._cont = _RL_InformationResponseList_RL_AdditionRspFDD__item_
    RL_InformationResponseList_RL_AdditionRspFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-InformationResponseItemIEs-RL-AdditionRspFDD >-----#
    RL_InformationResponseItemIEs_RL_AdditionRspFDD = CLASS(name=u'RL-InformationResponseItemIEs-RL-AdditionRspFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationResponseItemIEs_RL_AdditionRspFDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-AdditionRspFDD')))
    RL_InformationResponseItemIEs_RL_AdditionRspFDD._val = ASN1Set(rv=[dict([(u'id', 130), (u'criticality', u'ignore'), (u'Value', _RL_InformationResponseItemIEs_RL_AdditionRspFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-AdditionRspFDD >-----#
    RL_InformationResponseItem_RL_AdditionRspFDD = SEQ(name=u'RL-InformationResponseItem-RL-AdditionRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_AdditionRspFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_received_total_wide_band_power = INT(name=u'received-total-wide-band-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Received-total-wide-band-power')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_not_Used_secondary_CCPCH_Info = NULL(name=u'not-Used-secondary-CCPCH-Info', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_dl_CodeInformation = SEQ(name=u'dl-CodeInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CodeInformationList-RL-AdditionRspFDD')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_diversityIndication = CHOICE(name=u'diversityIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspFDD')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_sSDT_SupportIndicator = ENUM(name=u'sSDT-SupportIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SSDT-SupportIndicator')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_closedlooptimingadjustmentmode = ENUM(name=u'closedlooptimingadjustmentmode', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Closedlooptimingadjustmentmode')), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_InformationResponseItem_RL_AdditionRspFDD_pC_Preamble = INT(name=u'pC-Preamble', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PC-Preamble')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_sRB_Delay = INT(name=u'sRB-Delay', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SRB-Delay')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_12), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions._cont = __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_
    _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_AdditionRspFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponseItem_RL_AdditionRspFDD_rL_ID),
        (u'rL-Set-ID', _RL_InformationResponseItem_RL_AdditionRspFDD_rL_Set_ID),
        (u'uRA-Information', _RL_InformationResponseItem_RL_AdditionRspFDD_uRA_Information),
        (u'sAI', _RL_InformationResponseItem_RL_AdditionRspFDD_sAI),
        (u'gA-Cell', _RL_InformationResponseItem_RL_AdditionRspFDD_gA_Cell),
        (u'gA-AccessPointPosition', _RL_InformationResponseItem_RL_AdditionRspFDD_gA_AccessPointPosition),
        (u'received-total-wide-band-power', _RL_InformationResponseItem_RL_AdditionRspFDD_received_total_wide_band_power),
        (u'not-Used-secondary-CCPCH-Info', _RL_InformationResponseItem_RL_AdditionRspFDD_not_Used_secondary_CCPCH_Info),
        (u'dl-CodeInformation', _RL_InformationResponseItem_RL_AdditionRspFDD_dl_CodeInformation),
        (u'diversityIndication', _RL_InformationResponseItem_RL_AdditionRspFDD_diversityIndication),
        (u'sSDT-SupportIndicator', _RL_InformationResponseItem_RL_AdditionRspFDD_sSDT_SupportIndicator),
        (u'minUL-SIR', _RL_InformationResponseItem_RL_AdditionRspFDD_minUL_SIR),
        (u'maxUL-SIR', _RL_InformationResponseItem_RL_AdditionRspFDD_maxUL_SIR),
        (u'closedlooptimingadjustmentmode', _RL_InformationResponseItem_RL_AdditionRspFDD_closedlooptimingadjustmentmode),
        (u'maximumAllowedULTxPower', _RL_InformationResponseItem_RL_AdditionRspFDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_InformationResponseItem_RL_AdditionRspFDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponseItem_RL_AdditionRspFDD_minimumDLTxPower),
        (u'neighbouring-UMTS-CellInformation', _RL_InformationResponseItem_RL_AdditionRspFDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_InformationResponseItem_RL_AdditionRspFDD_neighbouring_GSM_CellInformation),
        (u'pC-Preamble', _RL_InformationResponseItem_RL_AdditionRspFDD_pC_Preamble),
        (u'sRB-Delay', _RL_InformationResponseItem_RL_AdditionRspFDD_sRB_Delay),
        (u'primaryCPICH-Power', _RL_InformationResponseItem_RL_AdditionRspFDD_primaryCPICH_Power),
        (u'iE-Extensions', _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_AdditionRspFDD._ext = []
    
    #-----< RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs >-----#
    RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs = CLASS(name=u'RL-InformationResponseItem-RL-AdditionRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_8 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_12), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CodeInformationList-RL-AdditionRspFDD >-----#
    DL_CodeInformationList_RL_AdditionRspFDD = SEQ(name=u'DL-CodeInformationList-RL-AdditionRspFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CodeInformationList_RL_AdditionRspFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CodeInformationList_RL_AdditionRspFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CodeInformationList_RL_AdditionRspFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    __DL_CodeInformationList_RL_AdditionRspFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', ___DL_CodeInformationList_RL_AdditionRspFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CodeInformationList_RL_AdditionRspFDD_id._const_tab = __DL_CodeInformationList_RL_AdditionRspFDD_id_tab
    _DL_CodeInformationList_RL_AdditionRspFDD_id._const_tab_at = None
    _DL_CodeInformationList_RL_AdditionRspFDD_id._const_tab_id = u'id'
    _DL_CodeInformationList_RL_AdditionRspFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CodeInformationList_RL_AdditionRspFDD_criticality._const_tab = __DL_CodeInformationList_RL_AdditionRspFDD_id_tab
    _DL_CodeInformationList_RL_AdditionRspFDD_criticality._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_AdditionRspFDD_criticality._const_tab_id = u'criticality'
    _DL_CodeInformationList_RL_AdditionRspFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CodeInformationList_RL_AdditionRspFDD_value._const_tab = __DL_CodeInformationList_RL_AdditionRspFDD_id_tab
    _DL_CodeInformationList_RL_AdditionRspFDD_value._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_AdditionRspFDD_value._const_tab_id = u'Value'
    DL_CodeInformationList_RL_AdditionRspFDD._cont = ASN1Dict([
        (u'id', _DL_CodeInformationList_RL_AdditionRspFDD_id),
        (u'criticality', _DL_CodeInformationList_RL_AdditionRspFDD_criticality),
        (u'value', _DL_CodeInformationList_RL_AdditionRspFDD_value),
        ])
    DL_CodeInformationList_RL_AdditionRspFDD._ext = None
    
    #-----< DL-CodeInformationListIEs-RL-AdditionRspFDD >-----#
    DL_CodeInformationListIEs_RL_AdditionRspFDD = CLASS(name=u'DL-CodeInformationListIEs-RL-AdditionRspFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CodeInformationListIEs_RL_AdditionRspFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    DL_CodeInformationListIEs_RL_AdditionRspFDD._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _DL_CodeInformationListIEs_RL_AdditionRspFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DiversityIndication-RL-AdditionRspFDD >-----#
    DiversityIndication_RL_AdditionRspFDD = CHOICE(name=u'DiversityIndication-RL-AdditionRspFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionRspFDD_combining = SEQ(name=u'combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Combining-RL-AdditionRspFDD')))
    _DiversityIndication_RL_AdditionRspFDD_nonCombining = SEQ(name=u'nonCombining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'NonCombining-RL-AdditionRspFDD')))
    DiversityIndication_RL_AdditionRspFDD._cont = ASN1Dict([
        (u'combining', _DiversityIndication_RL_AdditionRspFDD_combining),
        (u'nonCombining', _DiversityIndication_RL_AdditionRspFDD_nonCombining),
        ])
    DiversityIndication_RL_AdditionRspFDD._ext = None
    
    #-----< Combining-RL-AdditionRspFDD >-----#
    Combining_RL_AdditionRspFDD = SEQ(name=u'Combining-RL-AdditionRspFDD', mode=MODE_TYPE)
    _Combining_RL_AdditionRspFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Combining_RL_AdditionRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_AdditionRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Combining_RL_AdditionRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id),
        (u'criticality', ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_AdditionRspFDD_iE_Extensions__item_._ext = None
    _Combining_RL_AdditionRspFDD_iE_Extensions._cont = __Combining_RL_AdditionRspFDD_iE_Extensions__item_
    _Combining_RL_AdditionRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_AdditionRspFDD._cont = ASN1Dict([
        (u'rL-ID', _Combining_RL_AdditionRspFDD_rL_ID),
        (u'iE-Extensions', _Combining_RL_AdditionRspFDD_iE_Extensions),
        ])
    Combining_RL_AdditionRspFDD._ext = []
    
    #-----< CombiningItem-RL-AdditionRspFDD-ExtIEs >-----#
    CombiningItem_RL_AdditionRspFDD_ExtIEs = CLASS(name=u'CombiningItem-RL-AdditionRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    CombiningItem_RL_AdditionRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonCombining-RL-AdditionRspFDD >-----#
    NonCombining_RL_AdditionRspFDD = SEQ(name=u'NonCombining-RL-AdditionRspFDD', mode=MODE_TYPE)
    _NonCombining_RL_AdditionRspFDD_dCH_InformationResponse = SEQ_OF(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _NonCombining_RL_AdditionRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombining_RL_AdditionRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab = ____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab = ____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonCombining_RL_AdditionRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id),
        (u'criticality', ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombining_RL_AdditionRspFDD_iE_Extensions__item_._ext = None
    _NonCombining_RL_AdditionRspFDD_iE_Extensions._cont = __NonCombining_RL_AdditionRspFDD_iE_Extensions__item_
    _NonCombining_RL_AdditionRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombining_RL_AdditionRspFDD._cont = ASN1Dict([
        (u'dCH-InformationResponse', _NonCombining_RL_AdditionRspFDD_dCH_InformationResponse),
        (u'iE-Extensions', _NonCombining_RL_AdditionRspFDD_iE_Extensions),
        ])
    NonCombining_RL_AdditionRspFDD._ext = []
    
    #-----< NonCombiningItem-RL-AdditionRspFDD-ExtIEs >-----#
    NonCombiningItem_RL_AdditionRspFDD_ExtIEs = CLASS(name=u'NonCombiningItem-RL-AdditionRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _NonCombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    NonCombiningItem_RL_AdditionRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _NonCombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseFDD-Extensions >-----#
    RadioLinkAdditionResponseFDD_Extensions = CLASS(name=u'RadioLinkAdditionResponseFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-informationResponse')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Serving-cell-change-informationResponse')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _RadioLinkAdditionResponseFDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLAddList')))
    RadioLinkAdditionResponseFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 603), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 604), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 797), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 840), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseFDD_Extensions_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Change-Information-Response-List >-----#
    Additional_HS_Cell_Change_Information_Response_List = SEQ_OF(name=u'Additional-HS-Cell-Change-Information-Response-List', mode=MODE_TYPE)
    _Additional_HS_Cell_Change_Information_Response_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-ItemIEs')))
    Additional_HS_Cell_Change_Information_Response_List._cont = _Additional_HS_Cell_Change_Information_Response_List__item_
    Additional_HS_Cell_Change_Information_Response_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Change-Information-Response-ItemIEs >-----#
    Additional_HS_Cell_Change_Information_Response_ItemIEs = SEQ(name=u'Additional-HS-Cell-Change-Information-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_hS_DSCH_Secondary_Serving_Cell_Change_Information_Response = SEQ(name=u'hS-DSCH-Secondary-Serving-Cell-Change-Information-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Secondary-Serving-Cell-Change-Information-Response')))
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Change_Information_Response_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSPDSCH_RL_ID),
        (u'hSDSCH-RNTI', _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSDSCH_RNTI),
        (u'hS-DSCH-Secondary-Serving-Cell-Change-Information-Response', _Additional_HS_Cell_Change_Information_Response_ItemIEs_hS_DSCH_Secondary_Serving_Cell_Change_Information_Response),
        (u'iE-Extensions', _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Change_Information_Response_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Change_Information_Response_ItemIEs_ExtIEs = CLASS(name=u'Additional-HS-Cell-Change-Information-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Change_Information_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseTDD >-----#
    RadioLinkAdditionResponseTDD = SEQ(name=u'RadioLinkAdditionResponseTDD', mode=MODE_TYPE)
    _RadioLinkAdditionResponseTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-AdditionRspTDD')))
    _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkAdditionResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionResponseTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkAdditionResponseTDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionResponseTDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionResponseTDD_protocolIEs._cont = __RadioLinkAdditionResponseTDD_protocolIEs__item_
    _RadioLinkAdditionResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionResponseTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-LCR-InformationResponse-RL-AdditionRspTDD')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD-PFL')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-RNTI')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-AdditionRspTDD768')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_15 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 86), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 599), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 614), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkAdditionResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionResponseTDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionResponseTDD_protocolExtensions._cont = __RadioLinkAdditionResponseTDD_protocolExtensions__item_
    _RadioLinkAdditionResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionResponseTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkAdditionResponseTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkAdditionResponseTDD_protocolExtensions),
        ])
    RadioLinkAdditionResponseTDD._ext = []
    
    #-----< RadioLinkAdditionResponseTDD-IEs >-----#
    RadioLinkAdditionResponseTDD_IEs = CLASS(name=u'RadioLinkAdditionResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkAdditionResponseTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-AdditionRspTDD')))
    _RadioLinkAdditionResponseTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionResponseTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 127), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionResponseTDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionResponseTDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-AdditionRspTDD >-----#
    RL_InformationResponse_RL_AdditionRspTDD = SEQ(name=u'RL-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_RL_AdditionRspTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_AdditionRspTDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_InformationResponse_RL_AdditionRspTDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_ul_TimeSlot_ISCP_Info = SEQ_OF(name=u'ul-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-Info')))
    _RL_InformationResponse_RL_AdditionRspTDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_AdditionRspTDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_AdditionRspTDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_InformationResponse_RL_AdditionRspTDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_AdditionRspTDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_AdditionRspTDD_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')))
    _RL_InformationResponse_RL_AdditionRspTDD_timingAdvanceApplied = ENUM(name=u'timingAdvanceApplied', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimingAdvanceApplied')))
    _RL_InformationResponse_RL_AdditionRspTDD_alphaValue = INT(name=u'alphaValue', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AlphaValue')))
    _RL_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation = ENUM(name=u'ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_RL_AdditionRspTDD_synchronisationConfiguration = SEQ(name=u'synchronisationConfiguration', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationConfiguration')))
    _RL_InformationResponse_RL_AdditionRspTDD_secondary_CCPCH_Info_TDD = SEQ(name=u'secondary-CCPCH-Info-TDD', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_ul_CCTrCHInformation = SEQ(name=u'ul-CCTrCHInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationList-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_dl_CCTrCHInformation = SEQ(name=u'dl-CCTrCHInformation', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationList-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_dCH_Information = SEQ(name=u'dCH-Information', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-Information-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_dSCH_InformationResponse = SEQ(name=u'dSCH-InformationResponse', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationResponse-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_uSCH_InformationResponse = SEQ(name=u'uSCH-InformationResponse', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationResponse-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions._cont = __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_
    _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponse_RL_AdditionRspTDD_rL_ID),
        (u'uRA-Information', _RL_InformationResponse_RL_AdditionRspTDD_uRA_Information),
        (u'sAI', _RL_InformationResponse_RL_AdditionRspTDD_sAI),
        (u'gA-Cell', _RL_InformationResponse_RL_AdditionRspTDD_gA_Cell),
        (u'gA-AccessPointPosition', _RL_InformationResponse_RL_AdditionRspTDD_gA_AccessPointPosition),
        (u'ul-TimeSlot-ISCP-Info', _RL_InformationResponse_RL_AdditionRspTDD_ul_TimeSlot_ISCP_Info),
        (u'minUL-SIR', _RL_InformationResponse_RL_AdditionRspTDD_minUL_SIR),
        (u'maxUL-SIR', _RL_InformationResponse_RL_AdditionRspTDD_maxUL_SIR),
        (u'maximumAllowedULTxPower', _RL_InformationResponse_RL_AdditionRspTDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_InformationResponse_RL_AdditionRspTDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponse_RL_AdditionRspTDD_minimumDLTxPower),
        (u'pCCPCH-Power', _RL_InformationResponse_RL_AdditionRspTDD_pCCPCH_Power),
        (u'timingAdvanceApplied', _RL_InformationResponse_RL_AdditionRspTDD_timingAdvanceApplied),
        (u'alphaValue', _RL_InformationResponse_RL_AdditionRspTDD_alphaValue),
        (u'ul-PhysCH-SF-Variation', _RL_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation),
        (u'synchronisationConfiguration', _RL_InformationResponse_RL_AdditionRspTDD_synchronisationConfiguration),
        (u'secondary-CCPCH-Info-TDD', _RL_InformationResponse_RL_AdditionRspTDD_secondary_CCPCH_Info_TDD),
        (u'ul-CCTrCHInformation', _RL_InformationResponse_RL_AdditionRspTDD_ul_CCTrCHInformation),
        (u'dl-CCTrCHInformation', _RL_InformationResponse_RL_AdditionRspTDD_dl_CCTrCHInformation),
        (u'dCH-Information', _RL_InformationResponse_RL_AdditionRspTDD_dCH_Information),
        (u'dSCH-InformationResponse', _RL_InformationResponse_RL_AdditionRspTDD_dSCH_InformationResponse),
        (u'uSCH-InformationResponse', _RL_InformationResponse_RL_AdditionRspTDD_uSCH_InformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_InformationResponse_RL_AdditionRspTDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_InformationResponse_RL_AdditionRspTDD_neighbouring_GSM_CellInformation),
        (u'iE-Extensions', _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_RL_AdditionRspTDD._ext = []
    
    #-----< RL-InformationResponse-RL-AdditionRspTDD-ExtIEs >-----#
    RL_InformationResponse_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'RL-InformationResponse-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    RL_InformationResponse_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCHInformationList-RL-AdditionRspTDD >-----#
    UL_CCTrCHInformationList_RL_AdditionRspTDD = SEQ(name=u'UL-CCTrCHInformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-AdditionRspTDD')))
    __UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', ___UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_id._const_tab = __UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_criticality._const_tab = __UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_value._const_tab = __UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    UL_CCTrCHInformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _UL_CCTrCHInformationList_RL_AdditionRspTDD_id),
        (u'criticality', _UL_CCTrCHInformationList_RL_AdditionRspTDD_criticality),
        (u'value', _UL_CCTrCHInformationList_RL_AdditionRspTDD_value),
        ])
    UL_CCTrCHInformationList_RL_AdditionRspTDD._ext = None
    
    #-----< UL-CCTrCHInformationListIEs-RL-AdditionRspTDD >-----#
    UL_CCTrCHInformationListIEs_RL_AdditionRspTDD = CLASS(name=u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCHInformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-AdditionRspTDD')))
    UL_CCTrCHInformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 174), (u'criticality', u'ignore'), (u'Value', _UL_CCTrCHInformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationListIE-RL-AdditionRspTDD >-----#
    UL_CCTrCHInformationListIE_RL_AdditionRspTDD = SEQ_OF(name=u'UL-CCTrCHInformationListIE-RL-AdditionRspTDD', mode=MODE_TYPE)
    _UL_CCTrCHInformationListIE_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationItem-RL-AdditionRspTDD')))
    UL_CCTrCHInformationListIE_RL_AdditionRspTDD._cont = _UL_CCTrCHInformationListIE_RL_AdditionRspTDD__item_
    UL_CCTrCHInformationListIE_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationItem-RL-AdditionRspTDD >-----#
    UL_CCTrCHInformationItem_RL_AdditionRspTDD = SEQ(name=u'UL-CCTrCHInformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD_ul_DPCH_Information = SEQ(name=u'ul-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationList-RL-AdditionRspTDD')), opt=True)
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCHInformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCHInformationItem_RL_AdditionRspTDD_cCTrCH_ID),
        (u'ul-DPCH-Information', _UL_CCTrCHInformationItem_RL_AdditionRspTDD_ul_DPCH_Information),
        (u'iE-Extensions', _UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    UL_CCTrCHInformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< UL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    UL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'UL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationList-RL-AdditionRspTDD >-----#
    UL_DPCH_InformationList_RL_AdditionRspTDD = SEQ(name=u'UL-DPCH-InformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-AdditionRspTDD')))
    __UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationList_RL_AdditionRspTDD_id._const_tab = __UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab
    _UL_DPCH_InformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _UL_DPCH_InformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _UL_DPCH_InformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationList_RL_AdditionRspTDD_criticality._const_tab = __UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab
    _UL_DPCH_InformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationList_RL_AdditionRspTDD_value._const_tab = __UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab
    _UL_DPCH_InformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    UL_DPCH_InformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationList_RL_AdditionRspTDD_id),
        (u'criticality', _UL_DPCH_InformationList_RL_AdditionRspTDD_criticality),
        (u'value', _UL_DPCH_InformationList_RL_AdditionRspTDD_value),
        ])
    UL_DPCH_InformationList_RL_AdditionRspTDD._ext = None
    
    #-----< UL-DPCH-InformationListIEs-RL-AdditionRspTDD >-----#
    UL_DPCH_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-AdditionRspTDD')))
    UL_DPCH_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-RL-AdditionRspTDD >-----#
    UL_DPCH_InformationItem_RL_AdditionRspTDD = SEQ(name=u'UL-DPCH-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_uL_Timeslot_Information = SEQ_OF(name=u'uL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset),
        (u'uL-Timeslot-Information', _UL_DPCH_InformationItem_RL_AdditionRspTDD_uL_Timeslot_Information),
        (u'iE-Extensions', _UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'UL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCHInformationList-RL-AdditionRspTDD >-----#
    DL_CCTrCHInformationList_RL_AdditionRspTDD = SEQ(name=u'DL-CCTrCHInformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-AdditionRspTDD')))
    __DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', ___DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_id._const_tab = __DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_criticality._const_tab = __DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_value._const_tab = __DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DL_CCTrCHInformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DL_CCTrCHInformationList_RL_AdditionRspTDD_id),
        (u'criticality', _DL_CCTrCHInformationList_RL_AdditionRspTDD_criticality),
        (u'value', _DL_CCTrCHInformationList_RL_AdditionRspTDD_value),
        ])
    DL_CCTrCHInformationList_RL_AdditionRspTDD._ext = None
    
    #-----< DL-CCTrCHInformationListIEs-RL-AdditionRspTDD >-----#
    DL_CCTrCHInformationListIEs_RL_AdditionRspTDD = CLASS(name=u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCHInformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-AdditionRspTDD')))
    DL_CCTrCHInformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 49), (u'criticality', u'ignore'), (u'Value', _DL_CCTrCHInformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationListIE-RL-AdditionRspTDD >-----#
    DL_CCTrCHInformationListIE_RL_AdditionRspTDD = SEQ_OF(name=u'DL-CCTrCHInformationListIE-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DL_CCTrCHInformationListIE_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationItem-RL-AdditionRspTDD')))
    DL_CCTrCHInformationListIE_RL_AdditionRspTDD._cont = _DL_CCTrCHInformationListIE_RL_AdditionRspTDD__item_
    DL_CCTrCHInformationListIE_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationItem-RL-AdditionRspTDD >-----#
    DL_CCTrCHInformationItem_RL_AdditionRspTDD = SEQ(name=u'DL-CCTrCHInformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_dl_DPCH_Information = SEQ(name=u'dl-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationList-RL-AdditionRspTDD')), opt=True)
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 502), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 503), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCHInformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCHInformationItem_RL_AdditionRspTDD_cCTrCH_ID),
        (u'dl-DPCH-Information', _DL_CCTrCHInformationItem_RL_AdditionRspTDD_dl_DPCH_Information),
        (u'iE-Extensions', _DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    DL_CCTrCHInformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< DL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DL-CCTrCHInformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 502), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 503), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationList-RL-AdditionRspTDD >-----#
    DL_DPCH_InformationList_RL_AdditionRspTDD = SEQ(name=u'DL-DPCH-InformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-AdditionRspTDD')))
    __DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationList_RL_AdditionRspTDD_id._const_tab = __DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab
    _DL_DPCH_InformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _DL_DPCH_InformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationList_RL_AdditionRspTDD_criticality._const_tab = __DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab
    _DL_DPCH_InformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationList_RL_AdditionRspTDD_value._const_tab = __DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab
    _DL_DPCH_InformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationList_RL_AdditionRspTDD_id),
        (u'criticality', _DL_DPCH_InformationList_RL_AdditionRspTDD_criticality),
        (u'value', _DL_DPCH_InformationList_RL_AdditionRspTDD_value),
        ])
    DL_DPCH_InformationList_RL_AdditionRspTDD._ext = None
    
    #-----< DL-DPCH-InformationListIEs-RL-AdditionRspTDD >-----#
    DL_DPCH_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-AdditionRspTDD')))
    DL_DPCH_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 63), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-RL-AdditionRspTDD >-----#
    DL_DPCH_InformationItem_RL_AdditionRspTDD = SEQ(name=u'DL-DPCH-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_dL_Timeslot_Information = SEQ_OF(name=u'dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset),
        (u'dL-Timeslot-Information', _DL_DPCH_InformationItem_RL_AdditionRspTDD_dL_Timeslot_Information),
        (u'iE-Extensions', _DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-Information-RL-AdditionRspTDD >-----#
    DCH_Information_RL_AdditionRspTDD = SEQ(name=u'DCH-Information-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DCH_Information_RL_AdditionRspTDD_diversityIndication = CHOICE(name=u'diversityIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspTDD')))
    _DCH_Information_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DCH_Information_RL_AdditionRspTDD_iE_Extensions._cont = __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_
    _DCH_Information_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Information_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'diversityIndication', _DCH_Information_RL_AdditionRspTDD_diversityIndication),
        (u'iE-Extensions', _DCH_Information_RL_AdditionRspTDD_iE_Extensions),
        ])
    DCH_Information_RL_AdditionRspTDD._ext = []
    
    #-----< DCH-Information-RL-AdditionRspTDD-ExtIEs >-----#
    DCH_Information_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DCH-Information-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_Information_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-AdditionRspTDD >-----#
    DiversityIndication_RL_AdditionRspTDD = CHOICE(name=u'DiversityIndication-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionRspTDD_combining = SEQ(name=u'combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Combining-RL-AdditionRspTDD')))
    _DiversityIndication_RL_AdditionRspTDD_nonCombining = SEQ(name=u'nonCombining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'NonCombining-RL-AdditionRspTDD')))
    DiversityIndication_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'combining', _DiversityIndication_RL_AdditionRspTDD_combining),
        (u'nonCombining', _DiversityIndication_RL_AdditionRspTDD_nonCombining),
        ])
    DiversityIndication_RL_AdditionRspTDD._ext = None
    
    #-----< Combining-RL-AdditionRspTDD >-----#
    Combining_RL_AdditionRspTDD = SEQ(name=u'Combining-RL-AdditionRspTDD', mode=MODE_TYPE)
    _Combining_RL_AdditionRspTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Combining_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Combining_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _Combining_RL_AdditionRspTDD_iE_Extensions._cont = __Combining_RL_AdditionRspTDD_iE_Extensions__item_
    _Combining_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'rL-ID', _Combining_RL_AdditionRspTDD_rL_ID),
        (u'iE-Extensions', _Combining_RL_AdditionRspTDD_iE_Extensions),
        ])
    Combining_RL_AdditionRspTDD._ext = []
    
    #-----< CombiningItem-RL-AdditionRspTDD-ExtIEs >-----#
    CombiningItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'CombiningItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_AdditionRspTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    CombiningItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_AdditionRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonCombining-RL-AdditionRspTDD >-----#
    NonCombining_RL_AdditionRspTDD = SEQ(name=u'NonCombining-RL-AdditionRspTDD', mode=MODE_TYPE)
    _NonCombining_RL_AdditionRspTDD_dCH_InformationResponse = SEQ_OF(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _NonCombining_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombining_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonCombining_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombining_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _NonCombining_RL_AdditionRspTDD_iE_Extensions._cont = __NonCombining_RL_AdditionRspTDD_iE_Extensions__item_
    _NonCombining_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombining_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'dCH-InformationResponse', _NonCombining_RL_AdditionRspTDD_dCH_InformationResponse),
        (u'iE-Extensions', _NonCombining_RL_AdditionRspTDD_iE_Extensions),
        ])
    NonCombining_RL_AdditionRspTDD._ext = []
    
    #-----< NonCombiningItem-RL-AdditionRspTDD-ExtIEs >-----#
    NonCombiningItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'NonCombiningItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    NonCombiningItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-InformationResponse-RL-AdditionRspTDD >-----#
    DSCH_InformationResponse_RL_AdditionRspTDD = SEQ(name=u'DSCH-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_InformationResponse_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DSCH_InformationResponse_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DSCH_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationListIE-RL-AdditionRspTDD')))
    __DSCH_InformationResponse_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 220), (u'criticality', u'ignore'), (u'Value', ___DSCH_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_InformationResponse_RL_AdditionRspTDD_id._const_tab = __DSCH_InformationResponse_RL_AdditionRspTDD_id_tab
    _DSCH_InformationResponse_RL_AdditionRspTDD_id._const_tab_at = None
    _DSCH_InformationResponse_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DSCH_InformationResponse_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DSCH_InformationResponse_RL_AdditionRspTDD_criticality._const_tab = __DSCH_InformationResponse_RL_AdditionRspTDD_id_tab
    _DSCH_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DSCH_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DSCH_InformationResponse_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DSCH_InformationResponse_RL_AdditionRspTDD_value._const_tab = __DSCH_InformationResponse_RL_AdditionRspTDD_id_tab
    _DSCH_InformationResponse_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DSCH_InformationResponse_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DSCH_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DSCH_InformationResponse_RL_AdditionRspTDD_id),
        (u'criticality', _DSCH_InformationResponse_RL_AdditionRspTDD_criticality),
        (u'value', _DSCH_InformationResponse_RL_AdditionRspTDD_value),
        ])
    DSCH_InformationResponse_RL_AdditionRspTDD._ext = None
    
    #-----< DSCH-InformationListIEs-RL-AdditionRspTDD >-----#
    DSCH_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'DSCH-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DSCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationListIE-RL-AdditionRspTDD')))
    DSCH_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 220), (u'criticality', u'ignore'), (u'Value', _DSCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-InformationListIE-RL-AdditionRspTDD >-----#
    DSCH_InformationListIE_RL_AdditionRspTDD = SEQ_OF(name=u'DSCH-InformationListIE-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DSCH_InformationListIE_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCHInformationItem-RL-AdditionRspTDD')))
    DSCH_InformationListIE_RL_AdditionRspTDD._cont = _DSCH_InformationListIE_RL_AdditionRspTDD__item_
    DSCH_InformationListIE_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCHInformationItem-RL-AdditionRspTDD >-----#
    DSCHInformationItem_RL_AdditionRspTDD = SEQ(name=u'DSCHInformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DSCHInformationItem_RL_AdditionRspTDD_dsch_ID = INT(name=u'dsch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCHInformationItem_RL_AdditionRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _DSCHInformationItem_RL_AdditionRspTDD_dSCH_FlowControlInformation = SEQ_OF(name=u'dSCH-FlowControlInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-FlowControlInformation')))
    _DSCHInformationItem_RL_AdditionRspTDD_diversityIndication = SEQ(name=u'diversityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspTDD2')), opt=True)
    _DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCHInformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'dsch-ID', _DSCHInformationItem_RL_AdditionRspTDD_dsch_ID),
        (u'transportFormatManagement', _DSCHInformationItem_RL_AdditionRspTDD_transportFormatManagement),
        (u'dSCH-FlowControlInformation', _DSCHInformationItem_RL_AdditionRspTDD_dSCH_FlowControlInformation),
        (u'diversityIndication', _DSCHInformationItem_RL_AdditionRspTDD_diversityIndication),
        (u'iE-Extensions', _DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    DSCHInformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< DSCHInformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    DSCHInformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DSCHInformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DSCHInformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DiversityIndication-RL-AdditionRspTDD2 >-----#
    DiversityIndication_RL_AdditionRspTDD2 = SEQ(name=u'DiversityIndication-RL-AdditionRspTDD2', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionRspTDD2_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _DiversityIndication_RL_AdditionRspTDD2_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _DiversityIndication_RL_AdditionRspTDD2_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id._const_tab = ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id_tab
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id._const_tab_at = None
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id._const_tab_id = u'id'
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality._const_tab = ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality_tab
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue._const_tab = ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue_tab
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id),
        (u'criticality', ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality),
        (u'extensionValue', ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue),
        ])
    __DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item_._ext = None
    _DiversityIndication_RL_AdditionRspTDD2_iE_Extensions._cont = __DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item_
    _DiversityIndication_RL_AdditionRspTDD2_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DiversityIndication_RL_AdditionRspTDD2._cont = ASN1Dict([
        (u'bindingID', _DiversityIndication_RL_AdditionRspTDD2_bindingID),
        (u'transportLayerAddress', _DiversityIndication_RL_AdditionRspTDD2_transportLayerAddress),
        (u'iE-Extensions', _DiversityIndication_RL_AdditionRspTDD2_iE_Extensions),
        ])
    DiversityIndication_RL_AdditionRspTDD2._ext = []
    
    #-----< DiversityIndication-RL-AdditionRspTDD2-ExtIEs >-----#
    DiversityIndication_RL_AdditionRspTDD2_ExtIEs = CLASS(name=u'DiversityIndication-RL-AdditionRspTDD2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DiversityIndication_RL_AdditionRspTDD2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-InformationResponse-RL-AdditionRspTDD >-----#
    USCH_InformationResponse_RL_AdditionRspTDD = SEQ(name=u'USCH-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_InformationResponse_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __USCH_InformationResponse_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___USCH_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationListIE-RL-AdditionRspTDD')))
    __USCH_InformationResponse_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', ___USCH_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _USCH_InformationResponse_RL_AdditionRspTDD_id._const_tab = __USCH_InformationResponse_RL_AdditionRspTDD_id_tab
    _USCH_InformationResponse_RL_AdditionRspTDD_id._const_tab_at = None
    _USCH_InformationResponse_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _USCH_InformationResponse_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _USCH_InformationResponse_RL_AdditionRspTDD_criticality._const_tab = __USCH_InformationResponse_RL_AdditionRspTDD_id_tab
    _USCH_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _USCH_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _USCH_InformationResponse_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _USCH_InformationResponse_RL_AdditionRspTDD_value._const_tab = __USCH_InformationResponse_RL_AdditionRspTDD_id_tab
    _USCH_InformationResponse_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _USCH_InformationResponse_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    USCH_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _USCH_InformationResponse_RL_AdditionRspTDD_id),
        (u'criticality', _USCH_InformationResponse_RL_AdditionRspTDD_criticality),
        (u'value', _USCH_InformationResponse_RL_AdditionRspTDD_value),
        ])
    USCH_InformationResponse_RL_AdditionRspTDD._ext = None
    
    #-----< USCH-InformationListIEs-RL-AdditionRspTDD >-----#
    USCH_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'USCH-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _USCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationListIE-RL-AdditionRspTDD')))
    USCH_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 269), (u'criticality', u'ignore'), (u'Value', _USCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-InformationListIE-RL-AdditionRspTDD >-----#
    USCH_InformationListIE_RL_AdditionRspTDD = SEQ_OF(name=u'USCH-InformationListIE-RL-AdditionRspTDD', mode=MODE_TYPE)
    _USCH_InformationListIE_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCHInformationItem-RL-AdditionRspTDD')))
    USCH_InformationListIE_RL_AdditionRspTDD._cont = _USCH_InformationListIE_RL_AdditionRspTDD__item_
    USCH_InformationListIE_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCHInformationItem-RL-AdditionRspTDD >-----#
    USCHInformationItem_RL_AdditionRspTDD = SEQ(name=u'USCHInformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _USCHInformationItem_RL_AdditionRspTDD_uSCH_ID = INT(name=u'uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCHInformationItem_RL_AdditionRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _USCHInformationItem_RL_AdditionRspTDD_diversityIndication = SEQ(name=u'diversityIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspTDD2')), opt=True)
    _USCHInformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _USCHInformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _USCHInformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCHInformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'uSCH-ID', _USCHInformationItem_RL_AdditionRspTDD_uSCH_ID),
        (u'transportFormatManagement', _USCHInformationItem_RL_AdditionRspTDD_transportFormatManagement),
        (u'diversityIndication', _USCHInformationItem_RL_AdditionRspTDD_diversityIndication),
        (u'iE-Extensions', _USCHInformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    USCHInformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< USCHInformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    USCHInformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'USCHInformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    USCHInformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionResponseTDD-Extensions >-----#
    RadioLinkAdditionResponseTDD_Extensions = CLASS(name=u'RadioLinkAdditionResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-LCR-InformationResponse-RL-AdditionRspTDD')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD-PFL')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-RNTI')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-AdditionRspTDD768')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_12 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_14 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkAdditionResponseTDD_Extensions_val_Extension_15 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkAdditionResponseTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 86), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 599), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 614), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _RadioLinkAdditionResponseTDD_Extensions_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-LCR-InformationResponse-RL-AdditionRspTDD >-----#
    RL_LCR_InformationResponse_RL_AdditionRspTDD = SEQ(name=u'RL-LCR-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_TimeSlot_ISCP_LCR_Info = SEQ_OF(name=u'ul-TimeSlot-ISCP-LCR-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-LCR-Info')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_alphaValue = INT(name=u'alphaValue', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AlphaValue')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation = ENUM(name=u'ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_synchronisationConfiguration = SEQ(name=u'synchronisationConfiguration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationConfiguration')))
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_secondary_LCR_CCPCH_Info_TDD = SEQ(name=u'secondary-LCR-CCPCH-Info-TDD', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-Info-TDD')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_CCTrCH_LCR_Information = SEQ(name=u'ul-CCTrCH-LCR-Information', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_dl_CCTrCH_LCR_Information = SEQ(name=u'dl-CCTrCH-LCR-Information', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_dCH_InformationResponse = SEQ(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-AdditionRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_dsch_LCR_InformationResponse = SEQ(name=u'dsch-LCR-InformationResponse', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationResponse-RL-AdditionRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_usch_LCR_InformationResponse = SEQ(name=u'usch-LCR-InformationResponse', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationResponse-RL-AdditionRspTDD')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions._cont = __RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_
    _RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_LCR_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_LCR_InformationResponse_RL_AdditionRspTDD_rL_ID),
        (u'uRA-Information', _RL_LCR_InformationResponse_RL_AdditionRspTDD_uRA_Information),
        (u'sAI', _RL_LCR_InformationResponse_RL_AdditionRspTDD_sAI),
        (u'gA-Cell', _RL_LCR_InformationResponse_RL_AdditionRspTDD_gA_Cell),
        (u'gA-AccessPointPosition', _RL_LCR_InformationResponse_RL_AdditionRspTDD_gA_AccessPointPosition),
        (u'ul-TimeSlot-ISCP-LCR-Info', _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_TimeSlot_ISCP_LCR_Info),
        (u'maxUL-SIR', _RL_LCR_InformationResponse_RL_AdditionRspTDD_maxUL_SIR),
        (u'minUL-SIR', _RL_LCR_InformationResponse_RL_AdditionRspTDD_minUL_SIR),
        (u'pCCPCH-Power', _RL_LCR_InformationResponse_RL_AdditionRspTDD_pCCPCH_Power),
        (u'maximumAllowedULTxPower', _RL_LCR_InformationResponse_RL_AdditionRspTDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_LCR_InformationResponse_RL_AdditionRspTDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_LCR_InformationResponse_RL_AdditionRspTDD_minimumDLTxPower),
        (u'alphaValue', _RL_LCR_InformationResponse_RL_AdditionRspTDD_alphaValue),
        (u'ul-PhysCH-SF-Variation', _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation),
        (u'synchronisationConfiguration', _RL_LCR_InformationResponse_RL_AdditionRspTDD_synchronisationConfiguration),
        (u'secondary-LCR-CCPCH-Info-TDD', _RL_LCR_InformationResponse_RL_AdditionRspTDD_secondary_LCR_CCPCH_Info_TDD),
        (u'ul-CCTrCH-LCR-Information', _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_CCTrCH_LCR_Information),
        (u'dl-CCTrCH-LCR-Information', _RL_LCR_InformationResponse_RL_AdditionRspTDD_dl_CCTrCH_LCR_Information),
        (u'dCH-InformationResponse', _RL_LCR_InformationResponse_RL_AdditionRspTDD_dCH_InformationResponse),
        (u'dsch-LCR-InformationResponse', _RL_LCR_InformationResponse_RL_AdditionRspTDD_dsch_LCR_InformationResponse),
        (u'usch-LCR-InformationResponse', _RL_LCR_InformationResponse_RL_AdditionRspTDD_usch_LCR_InformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_LCR_InformationResponse_RL_AdditionRspTDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_LCR_InformationResponse_RL_AdditionRspTDD_neighbouring_GSM_CellInformation),
        (u'iE-Extensions', _RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions),
        ])
    RL_LCR_InformationResponse_RL_AdditionRspTDD._ext = []
    
    #-----< RL-LCR-InformationResponseList-RL-AdditionRspTDD-ExtIEs >-----#
    RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'RL-LCR-InformationResponseList-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD >-----#
    UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD = SEQ(name=u'UL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD')))
    __UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', ___UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab = __UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab = __UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab = __UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id),
        (u'criticality', _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality),
        (u'value', _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value),
        ])
    UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD._ext = None
    
    #-----< UL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    UL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'UL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD')))
    UL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 87), (u'criticality', u'ignore'), (u'Value', _UL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD >-----#
    UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD = SEQ_OF(name=u'UL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD', mode=MODE_TYPE)
    _UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD')))
    UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD._cont = _UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD__item_
    UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD = SEQ(name=u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ul_DPCH_LCR_Information = SEQ(name=u'ul-DPCH-LCR-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationList-RL-AdditionRspTDD')), opt=True)
    _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_cCTrCH_ID),
        (u'ul-DPCH-LCR-Information', _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ul_DPCH_LCR_Information),
        (u'iE-Extensions', _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-LCR-InformationList-RL-AdditionRspTDD >-----#
    UL_DPCH_LCR_InformationList_RL_AdditionRspTDD = SEQ(name=u'UL-DPCH-LCR-InformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD')))
    __UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 88), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab = __UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab = __UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab = __UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    UL_DPCH_LCR_InformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id),
        (u'criticality', _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality),
        (u'value', _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value),
        ])
    UL_DPCH_LCR_InformationList_RL_AdditionRspTDD._ext = None
    
    #-----< UL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    UL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'UL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD')))
    UL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 88), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD = SEQ(name=u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_uL_TimeslotLCR_Information = SEQ_OF(name=u'uL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset),
        (u'uL-TimeslotLCR-Information', _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_uL_TimeslotLCR_Information),
        (u'iE-Extensions', _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'UL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD >-----#
    DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD = SEQ(name=u'DL-CCTrCH-LCR-InformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD')))
    __DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Value', ___DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab = __DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab = __DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab = __DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id),
        (u'criticality', _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality),
        (u'value', _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value),
        ])
    DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD._ext = None
    
    #-----< DL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    DL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'DL-CCTrCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD')))
    DL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 89), (u'criticality', u'ignore'), (u'Value', _DL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD >-----#
    DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD = SEQ_OF(name=u'DL-CCTrCH-LCR-InformationListIE-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD')))
    DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD._cont = _DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD__item_
    DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD = SEQ(name=u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_dl_DPCH_LCR_Information = SEQ(name=u'dl-DPCH-LCR-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationList-RL-AdditionRspTDD')), opt=True)
    _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_cCTrCH_ID),
        (u'dl-DPCH-LCR-Information', _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_dl_DPCH_LCR_Information),
        (u'iE-Extensions', _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-LCR-InformationList-RL-AdditionRspTDD >-----#
    DL_DPCH_LCR_InformationList_RL_AdditionRspTDD = SEQ(name=u'DL-DPCH-LCR-InformationList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD')))
    __DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 94), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab = __DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_at = None
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab = __DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab = __DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DL_DPCH_LCR_InformationList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id),
        (u'criticality', _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality),
        (u'value', _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value),
        ])
    DL_DPCH_LCR_InformationList_RL_AdditionRspTDD._ext = None
    
    #-----< DL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    DL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD = CLASS(name=u'DL-DPCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD')))
    DL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 94), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD = SEQ(name=u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_dL_TimeslotLCR_Information = SEQ_OF(name=u'dL-TimeslotLCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tSTD_Indicator = ENUM(name=u'tSTD-Indicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TSTD-Indicator')))
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset),
        (u'dL-TimeslotLCR-Information', _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_dL_TimeslotLCR_Information),
        (u'tSTD-Indicator', _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tSTD_Indicator),
        (u'iE-Extensions', _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DL-DPCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-AdditionRspTDD >-----#
    DCH_InformationResponseList_RL_AdditionRspTDD = SEQ(name=u'DCH-InformationResponseList-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DCH_InformationResponseList_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ___DCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab = __DCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _DCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DCH_InformationResponseList_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab = __DCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _DCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DCH_InformationResponseList_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab = __DCH_InformationResponseList_RL_AdditionRspTDD_id_tab
    _DCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DCH_InformationResponseList_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DCH_InformationResponseList_RL_AdditionRspTDD_id),
        (u'criticality', _DCH_InformationResponseList_RL_AdditionRspTDD_criticality),
        (u'value', _DCH_InformationResponseList_RL_AdditionRspTDD_value),
        ])
    DCH_InformationResponseList_RL_AdditionRspTDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-AdditionRspTDD >-----#
    DCH_InformationResponseListIEs_RL_AdditionRspTDD = CLASS(name=u'DCH-InformationResponseListIEs-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _DCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-LCR-InformationResponse-RL-AdditionRspTDD >-----#
    DSCH_LCR_InformationResponse_RL_AdditionRspTDD = SEQ(name=u'DSCH-LCR-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationListIEs-RL-AdditionRspTDD')))
    __DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', ___DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id._const_tab = __DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id._const_tab_at = None
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality._const_tab = __DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_value._const_tab = __DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    DSCH_LCR_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id),
        (u'criticality', _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality),
        (u'value', _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_value),
        ])
    DSCH_LCR_InformationResponse_RL_AdditionRspTDD._ext = None
    
    #-----< DSCH-LCR-InformationList-RL-AdditionRspTDD >-----#
    DSCH_LCR_InformationList_RL_AdditionRspTDD = CLASS(name=u'DSCH-LCR-InformationList-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DSCH_LCR_InformationList_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationListIEs-RL-AdditionRspTDD')))
    DSCH_LCR_InformationList_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 96), (u'criticality', u'ignore'), (u'Value', _DSCH_LCR_InformationList_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    DSCH_LCR_InformationListIEs_RL_AdditionRspTDD = SEQ_OF(name=u'DSCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DSCH_LCR_InformationListIEs_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-LCR-InformationItem-RL-AdditionRspTDD')))
    DSCH_LCR_InformationListIEs_RL_AdditionRspTDD._cont = _DSCH_LCR_InformationListIEs_RL_AdditionRspTDD__item_
    DSCH_LCR_InformationListIEs_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    DSCH_LCR_InformationItem_RL_AdditionRspTDD = SEQ(name=u'DSCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_dsch_ID = INT(name=u'dsch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_dSCH_FlowControlInformation = SEQ_OF(name=u'dSCH-FlowControlInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-FlowControlInformation')))
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_LCR_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'dsch-ID', _DSCH_LCR_InformationItem_RL_AdditionRspTDD_dsch_ID),
        (u'dSCH-FlowControlInformation', _DSCH_LCR_InformationItem_RL_AdditionRspTDD_dSCH_FlowControlInformation),
        (u'bindingID', _DSCH_LCR_InformationItem_RL_AdditionRspTDD_bindingID),
        (u'transportLayerAddress', _DSCH_LCR_InformationItem_RL_AdditionRspTDD_transportLayerAddress),
        (u'transportFormatManagement', _DSCH_LCR_InformationItem_RL_AdditionRspTDD_transportFormatManagement),
        (u'iE-Extensions', _DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    DSCH_LCR_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< DSCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    DSCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'DSCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DSCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-LCR-InformationResponse-RL-AdditionRspTDD >-----#
    USCH_LCR_InformationResponse_RL_AdditionRspTDD = SEQ(name=u'USCH-LCR-InformationResponse-RL-AdditionRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationListIEs-RL-AdditionRspTDD')))
    __USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 97), (u'criticality', u'ignore'), (u'Value', ___USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_id._const_tab = __USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_id._const_tab_at = None
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_id._const_tab_id = u'id'
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality._const_tab = __USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_at = ('..', u'id')
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality._const_tab_id = u'criticality'
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_value._const_tab = __USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_value._const_tab_at = ('..', u'id')
    _USCH_LCR_InformationResponse_RL_AdditionRspTDD_value._const_tab_id = u'Value'
    USCH_LCR_InformationResponse_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'id', _USCH_LCR_InformationResponse_RL_AdditionRspTDD_id),
        (u'criticality', _USCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality),
        (u'value', _USCH_LCR_InformationResponse_RL_AdditionRspTDD_value),
        ])
    USCH_LCR_InformationResponse_RL_AdditionRspTDD._ext = None
    
    #-----< USCH-LCR-InformationList-RL-AdditionRspTDD >-----#
    USCH_LCR_InformationList_RL_AdditionRspTDD = CLASS(name=u'USCH-LCR-InformationList-RL-AdditionRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _USCH_LCR_InformationList_RL_AdditionRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationListIEs-RL-AdditionRspTDD')))
    USCH_LCR_InformationList_RL_AdditionRspTDD._val = ASN1Set(rv=[dict([(u'id', 97), (u'criticality', u'ignore'), (u'Value', _USCH_LCR_InformationList_RL_AdditionRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCH-LCR-InformationListIEs-RL-AdditionRspTDD >-----#
    USCH_LCR_InformationListIEs_RL_AdditionRspTDD = SEQ_OF(name=u'USCH-LCR-InformationListIEs-RL-AdditionRspTDD', mode=MODE_TYPE)
    _USCH_LCR_InformationListIEs_RL_AdditionRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-LCR-InformationItem-RL-AdditionRspTDD')))
    USCH_LCR_InformationListIEs_RL_AdditionRspTDD._cont = _USCH_LCR_InformationListIEs_RL_AdditionRspTDD__item_
    USCH_LCR_InformationListIEs_RL_AdditionRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCH-LCR-InformationItem-RL-AdditionRspTDD >-----#
    USCH_LCR_InformationItem_RL_AdditionRspTDD = SEQ(name=u'USCH-LCR-InformationItem-RL-AdditionRspTDD', mode=MODE_TYPE)
    _USCH_LCR_InformationItem_RL_AdditionRspTDD_usch_ID = INT(name=u'usch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCH_LCR_InformationItem_RL_AdditionRspTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _USCH_LCR_InformationItem_RL_AdditionRspTDD_diversityIndication = SEQ(name=u'diversityIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-AdditionRspTDD2')), opt=True)
    _USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab = ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab = ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab = ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id),
        (u'criticality', ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue),
        ])
    __USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_._ext = None
    _USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._cont = __USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_
    _USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_LCR_InformationItem_RL_AdditionRspTDD._cont = ASN1Dict([
        (u'usch-ID', _USCH_LCR_InformationItem_RL_AdditionRspTDD_usch_ID),
        (u'transportFormatManagement', _USCH_LCR_InformationItem_RL_AdditionRspTDD_transportFormatManagement),
        (u'diversityIndication', _USCH_LCR_InformationItem_RL_AdditionRspTDD_diversityIndication),
        (u'iE-Extensions', _USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions),
        ])
    USCH_LCR_InformationItem_RL_AdditionRspTDD._ext = []
    
    #-----< USCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs >-----#
    USCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs = CLASS(name=u'USCH-LCR-InformationItem-RL-AdditionRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    USCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-AdditionRspTDD768 >-----#
    RL_InformationResponse_RL_AdditionRspTDD768 = SEQ(name=u'RL-InformationResponse-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _RL_InformationResponse_RL_AdditionRspTDD768_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_AdditionRspTDD768_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _RL_InformationResponse_RL_AdditionRspTDD768_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_ul_TimeSlot_ISCP_Info = SEQ_OF(name=u'ul-TimeSlot-ISCP-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeSlot-ISCP-Info')))
    _RL_InformationResponse_RL_AdditionRspTDD768_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_AdditionRspTDD768_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _RL_InformationResponse_RL_AdditionRspTDD768_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _RL_InformationResponse_RL_AdditionRspTDD768_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_AdditionRspTDD768_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_InformationResponse_RL_AdditionRspTDD768_pCCPCH_Power = INT(name=u'pCCPCH-Power', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PCCPCH-Power')))
    _RL_InformationResponse_RL_AdditionRspTDD768_timingAdvanceApplied = ENUM(name=u'timingAdvanceApplied', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimingAdvanceApplied')))
    _RL_InformationResponse_RL_AdditionRspTDD768_alphaValue = INT(name=u'alphaValue', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AlphaValue')))
    _RL_InformationResponse_RL_AdditionRspTDD768_ul_PhysCH_SF_Variation = ENUM(name=u'ul-PhysCH-SF-Variation', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-PhysCH-SF-Variation')))
    _RL_InformationResponse_RL_AdditionRspTDD768_synchronisationConfiguration = SEQ(name=u'synchronisationConfiguration', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SynchronisationConfiguration')))
    _RL_InformationResponse_RL_AdditionRspTDD768_secondary_CCPCH_Info_TDD768 = SEQ(name=u'secondary-CCPCH-Info-TDD768', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD768')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_ul_CCTrCHInformation768 = SEQ(name=u'ul-CCTrCHInformation768', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationList-RL-AdditionRspTDD768')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_dl_CCTrCHInformation768 = SEQ(name=u'dl-CCTrCHInformation768', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationList-RL-AdditionRspTDD768')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_dCH_Information = SEQ(name=u'dCH-Information', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-Information-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_dSCH_InformationResponse = SEQ(name=u'dSCH-InformationResponse', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-InformationResponse-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_uSCH_InformationResponse = SEQ(name=u'uSCH-InformationResponse', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-InformationResponse-RL-AdditionRspTDD')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_gA_CellAdditionalShapes = CHOICE(name=u'gA-CellAdditionalShapes', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_hCS_Prio = INT(name=u'hCS-Prio', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')), opt=True)
    _RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions._cont = __RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item_
    _RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponse_RL_AdditionRspTDD768_rL_ID),
        (u'uRA-Information', _RL_InformationResponse_RL_AdditionRspTDD768_uRA_Information),
        (u'sAI', _RL_InformationResponse_RL_AdditionRspTDD768_sAI),
        (u'gA-Cell', _RL_InformationResponse_RL_AdditionRspTDD768_gA_Cell),
        (u'gA-AccessPointPosition', _RL_InformationResponse_RL_AdditionRspTDD768_gA_AccessPointPosition),
        (u'ul-TimeSlot-ISCP-Info', _RL_InformationResponse_RL_AdditionRspTDD768_ul_TimeSlot_ISCP_Info),
        (u'minUL-SIR', _RL_InformationResponse_RL_AdditionRspTDD768_minUL_SIR),
        (u'maxUL-SIR', _RL_InformationResponse_RL_AdditionRspTDD768_maxUL_SIR),
        (u'maximumAllowedULTxPower', _RL_InformationResponse_RL_AdditionRspTDD768_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _RL_InformationResponse_RL_AdditionRspTDD768_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponse_RL_AdditionRspTDD768_minimumDLTxPower),
        (u'pCCPCH-Power', _RL_InformationResponse_RL_AdditionRspTDD768_pCCPCH_Power),
        (u'timingAdvanceApplied', _RL_InformationResponse_RL_AdditionRspTDD768_timingAdvanceApplied),
        (u'alphaValue', _RL_InformationResponse_RL_AdditionRspTDD768_alphaValue),
        (u'ul-PhysCH-SF-Variation', _RL_InformationResponse_RL_AdditionRspTDD768_ul_PhysCH_SF_Variation),
        (u'synchronisationConfiguration', _RL_InformationResponse_RL_AdditionRspTDD768_synchronisationConfiguration),
        (u'secondary-CCPCH-Info-TDD768', _RL_InformationResponse_RL_AdditionRspTDD768_secondary_CCPCH_Info_TDD768),
        (u'ul-CCTrCHInformation768', _RL_InformationResponse_RL_AdditionRspTDD768_ul_CCTrCHInformation768),
        (u'dl-CCTrCHInformation768', _RL_InformationResponse_RL_AdditionRspTDD768_dl_CCTrCHInformation768),
        (u'dCH-Information', _RL_InformationResponse_RL_AdditionRspTDD768_dCH_Information),
        (u'dSCH-InformationResponse', _RL_InformationResponse_RL_AdditionRspTDD768_dSCH_InformationResponse),
        (u'uSCH-InformationResponse', _RL_InformationResponse_RL_AdditionRspTDD768_uSCH_InformationResponse),
        (u'neighbouring-UMTS-CellInformation', _RL_InformationResponse_RL_AdditionRspTDD768_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _RL_InformationResponse_RL_AdditionRspTDD768_neighbouring_GSM_CellInformation),
        (u'gA-CellAdditionalShapes', _RL_InformationResponse_RL_AdditionRspTDD768_gA_CellAdditionalShapes),
        (u'hCS-Prio', _RL_InformationResponse_RL_AdditionRspTDD768_hCS_Prio),
        (u'iE-Extensions', _RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions),
        ])
    RL_InformationResponse_RL_AdditionRspTDD768._ext = []
    
    #-----< RL-InformationResponse-RL-AdditionRspTDD768-ExtIEs >-----#
    RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs = CLASS(name=u'RL-InformationResponse-RL-AdditionRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCHInformationList-RL-AdditionRspTDD768 >-----#
    UL_CCTrCHInformationList_RL_AdditionRspTDD768 = SEQ(name=u'UL-CCTrCHInformationList-RL-AdditionRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-AdditionRspTDD768')))
    __UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 615), (u'criticality', u'ignore'), (u'Value', ___UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_id._const_tab = __UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_id._const_tab_at = None
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_id._const_tab_id = u'id'
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality._const_tab = __UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality._const_tab_id = u'criticality'
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_value._const_tab = __UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_value._const_tab_at = ('..', u'id')
    _UL_CCTrCHInformationList_RL_AdditionRspTDD768_value._const_tab_id = u'Value'
    UL_CCTrCHInformationList_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'id', _UL_CCTrCHInformationList_RL_AdditionRspTDD768_id),
        (u'criticality', _UL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality),
        (u'value', _UL_CCTrCHInformationList_RL_AdditionRspTDD768_value),
        ])
    UL_CCTrCHInformationList_RL_AdditionRspTDD768._ext = None
    
    #-----< UL-CCTrCHInformationListIEs-RL-AdditionRspTDD768 >-----#
    UL_CCTrCHInformationListIEs_RL_AdditionRspTDD768 = CLASS(name=u'UL-CCTrCHInformationListIEs-RL-AdditionRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCHInformationListIEs_RL_AdditionRspTDD768_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-AdditionRspTDD768')))
    UL_CCTrCHInformationListIEs_RL_AdditionRspTDD768._val = ASN1Set(rv=[dict([(u'id', 615), (u'criticality', u'ignore'), (u'Value', _UL_CCTrCHInformationListIEs_RL_AdditionRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationListIE-RL-AdditionRspTDD768 >-----#
    UL_CCTrCHInformationListIE_RL_AdditionRspTDD768 = SEQ_OF(name=u'UL-CCTrCHInformationListIE-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _UL_CCTrCHInformationListIE_RL_AdditionRspTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationItem-RL-AdditionRspTDD768')))
    UL_CCTrCHInformationListIE_RL_AdditionRspTDD768._cont = _UL_CCTrCHInformationListIE_RL_AdditionRspTDD768__item_
    UL_CCTrCHInformationListIE_RL_AdditionRspTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationItem-RL-AdditionRspTDD768 >-----#
    UL_CCTrCHInformationItem_RL_AdditionRspTDD768 = SEQ(name=u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_ul_DPCH_Information768 = SEQ(name=u'ul-DPCH-Information768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationList-RL-AdditionRspTDD768')), opt=True)
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab = ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._ext = None
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions._cont = __UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_
    _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCHInformationItem_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_ID),
        (u'ul-DPCH-Information768', _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_ul_DPCH_Information768),
        (u'iE-Extensions', _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions),
        ])
    UL_CCTrCHInformationItem_RL_AdditionRspTDD768._ext = []
    
    #-----< UL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs >-----#
    UL_CCTrCHInformationItem_RL_AdditionRspTDD768_ExtIEs = CLASS(name=u'UL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCHInformationItem_RL_AdditionRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationList-RL-AdditionRspTDD768 >-----#
    UL_DPCH_InformationList_RL_AdditionRspTDD768 = SEQ(name=u'UL-DPCH-InformationList-RL-AdditionRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-AdditionRspTDD768')))
    __UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_id._const_tab = __UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_id._const_tab_at = None
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_id._const_tab_id = u'id'
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_criticality._const_tab = __UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_value._const_tab = __UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_RL_AdditionRspTDD768_value._const_tab_id = u'Value'
    UL_DPCH_InformationList_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationList_RL_AdditionRspTDD768_id),
        (u'criticality', _UL_DPCH_InformationList_RL_AdditionRspTDD768_criticality),
        (u'value', _UL_DPCH_InformationList_RL_AdditionRspTDD768_value),
        ])
    UL_DPCH_InformationList_RL_AdditionRspTDD768._ext = None
    
    #-----< UL-DPCH-InformationListIEs-RL-AdditionRspTDD768 >-----#
    UL_DPCH_InformationListIEs_RL_AdditionRspTDD768 = CLASS(name=u'UL-DPCH-InformationListIEs-RL-AdditionRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationListIEs_RL_AdditionRspTDD768_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-RL-AdditionRspTDD768')))
    UL_DPCH_InformationListIEs_RL_AdditionRspTDD768._val = ASN1Set(rv=[dict([(u'id', 181), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationListIEs_RL_AdditionRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-RL-AdditionRspTDD768 >-----#
    UL_DPCH_InformationItem_RL_AdditionRspTDD768 = SEQ(name=u'UL-DPCH-InformationItem-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_uL_Timeslot_Information768 = SEQ_OF(name=u'uL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-Information768')))
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions._cont = __UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_
    _UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationItem_RL_AdditionRspTDD768_tDD_DPCHOffset),
        (u'uL-Timeslot-Information768', _UL_DPCH_InformationItem_RL_AdditionRspTDD768_uL_Timeslot_Information768),
        (u'iE-Extensions', _UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions),
        ])
    UL_DPCH_InformationItem_RL_AdditionRspTDD768._ext = []
    
    #-----< UL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs >-----#
    UL_DPCH_InformationItem_RL_AdditionRspTDD768_ExtIEs = CLASS(name=u'UL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationItem_RL_AdditionRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCHInformationList-RL-AdditionRspTDD768 >-----#
    DL_CCTrCHInformationList_RL_AdditionRspTDD768 = SEQ(name=u'DL-CCTrCHInformationList-RL-AdditionRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-AdditionRspTDD768')))
    __DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 616), (u'criticality', u'ignore'), (u'Value', ___DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_id._const_tab = __DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_id._const_tab_at = None
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_id._const_tab_id = u'id'
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality._const_tab = __DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality._const_tab_id = u'criticality'
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_value._const_tab = __DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_value._const_tab_at = ('..', u'id')
    _DL_CCTrCHInformationList_RL_AdditionRspTDD768_value._const_tab_id = u'Value'
    DL_CCTrCHInformationList_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'id', _DL_CCTrCHInformationList_RL_AdditionRspTDD768_id),
        (u'criticality', _DL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality),
        (u'value', _DL_CCTrCHInformationList_RL_AdditionRspTDD768_value),
        ])
    DL_CCTrCHInformationList_RL_AdditionRspTDD768._ext = None
    
    #-----< DL-CCTrCHInformationListIEs-RL-AdditionRspTDD768 >-----#
    DL_CCTrCHInformationListIEs_RL_AdditionRspTDD768 = CLASS(name=u'DL-CCTrCHInformationListIEs-RL-AdditionRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCHInformationListIEs_RL_AdditionRspTDD768_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-AdditionRspTDD768')))
    DL_CCTrCHInformationListIEs_RL_AdditionRspTDD768._val = ASN1Set(rv=[dict([(u'id', 616), (u'criticality', u'ignore'), (u'Value', _DL_CCTrCHInformationListIEs_RL_AdditionRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationListIE-RL-AdditionRspTDD768 >-----#
    DL_CCTrCHInformationListIE_RL_AdditionRspTDD768 = SEQ_OF(name=u'DL-CCTrCHInformationListIE-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _DL_CCTrCHInformationListIE_RL_AdditionRspTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationItem-RL-AdditionRspTDD768')))
    DL_CCTrCHInformationListIE_RL_AdditionRspTDD768._cont = _DL_CCTrCHInformationListIE_RL_AdditionRspTDD768__item_
    DL_CCTrCHInformationListIE_RL_AdditionRspTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationItem-RL-AdditionRspTDD768 >-----#
    DL_CCTrCHInformationItem_RL_AdditionRspTDD768 = SEQ(name=u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_dl_DPCH_Information768 = SEQ(name=u'dl-DPCH-Information768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationList-RL-AdditionRspTDD768')), opt=True)
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_Maximum_DL_Power = INT(name=u'cCTrCH-Maximum-DL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_Minimum_DL_Power = INT(name=u'cCTrCH-Minimum-DL-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab = ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._ext = None
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions._cont = __DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_
    _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCHInformationItem_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_ID),
        (u'dl-DPCH-Information768', _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_dl_DPCH_Information768),
        (u'cCTrCH-Maximum-DL-Power', _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_Maximum_DL_Power),
        (u'cCTrCH-Minimum-DL-Power', _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_Minimum_DL_Power),
        (u'iE-Extensions', _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions),
        ])
    DL_CCTrCHInformationItem_RL_AdditionRspTDD768._ext = []
    
    #-----< DL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs >-----#
    DL_CCTrCHInformationItem_RL_AdditionRspTDD768_ExtIEs = CLASS(name=u'DL-CCTrCHInformationItem-RL-AdditionRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCHInformationItem_RL_AdditionRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationList-RL-AdditionRspTDD768 >-----#
    DL_DPCH_InformationList_RL_AdditionRspTDD768 = SEQ(name=u'DL-DPCH-InformationList-RL-AdditionRspTDD768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-AdditionRspTDD768')))
    __DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab._val = ASN1Set(rv=[dict([(u'id', 618), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_id._const_tab = __DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_id._const_tab_at = None
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_id._const_tab_id = u'id'
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_criticality._const_tab = __DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_value._const_tab = __DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_RL_AdditionRspTDD768_value._const_tab_id = u'Value'
    DL_DPCH_InformationList_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationList_RL_AdditionRspTDD768_id),
        (u'criticality', _DL_DPCH_InformationList_RL_AdditionRspTDD768_criticality),
        (u'value', _DL_DPCH_InformationList_RL_AdditionRspTDD768_value),
        ])
    DL_DPCH_InformationList_RL_AdditionRspTDD768._ext = None
    
    #-----< DL-DPCH-InformationListIEs-RL-AdditionRspTDD768 >-----#
    DL_DPCH_InformationListIEs_RL_AdditionRspTDD768 = CLASS(name=u'DL-DPCH-InformationListIEs-RL-AdditionRspTDD768', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationListIEs_RL_AdditionRspTDD768_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-RL-AdditionRspTDD768')))
    DL_DPCH_InformationListIEs_RL_AdditionRspTDD768._val = ASN1Set(rv=[dict([(u'id', 618), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationListIEs_RL_AdditionRspTDD768_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-RL-AdditionRspTDD768 >-----#
    DL_DPCH_InformationItem_RL_AdditionRspTDD768 = SEQ(name=u'DL-DPCH-InformationItem-RL-AdditionRspTDD768', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_dL_Timeslot_Information768 = SEQ_OF(name=u'dL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-Information768')))
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions._cont = __DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_
    _DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_RL_AdditionRspTDD768._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationItem_RL_AdditionRspTDD768_tDD_DPCHOffset),
        (u'dL-Timeslot-Information768', _DL_DPCH_InformationItem_RL_AdditionRspTDD768_dL_Timeslot_Information768),
        (u'iE-Extensions', _DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions),
        ])
    DL_DPCH_InformationItem_RL_AdditionRspTDD768._ext = []
    
    #-----< DL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs >-----#
    DL_DPCH_InformationItem_RL_AdditionRspTDD768_ExtIEs = CLASS(name=u'DL-DPCH-InformationItem-RL-AdditionRspTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationItem_RL_AdditionRspTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureFDD >-----#
    RadioLinkAdditionFailureFDD = SEQ(name=u'RadioLinkAdditionFailureFDD', mode=MODE_TYPE)
    _RadioLinkAdditionFailureFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionFailureFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureFDD')))
    _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkAdditionFailureFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionFailureFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkAdditionFailureFDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionFailureFDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionFailureFDD_protocolIEs._cont = __RadioLinkAdditionFailureFDD_protocolIEs__item_
    _RadioLinkAdditionFailureFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionFailureFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionFailureFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-informationResponse')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Serving-cell-change-informationResponse')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLAddList')))
    ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 603), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 604), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 797), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 840), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkAdditionFailureFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionFailureFDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionFailureFDD_protocolExtensions._cont = __RadioLinkAdditionFailureFDD_protocolExtensions__item_
    _RadioLinkAdditionFailureFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionFailureFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkAdditionFailureFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkAdditionFailureFDD_protocolExtensions),
        ])
    RadioLinkAdditionFailureFDD._ext = []
    
    #-----< RadioLinkAdditionFailureFDD-IEs >-----#
    RadioLinkAdditionFailureFDD_IEs = CLASS(name=u'RadioLinkAdditionFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkAdditionFailureFDD_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureFDD')))
    _RadioLinkAdditionFailureFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionFailureFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 197), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionFailureFDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionFailureFDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-AdditionFailureFDD >-----#
    CauseLevel_RL_AdditionFailureFDD = CHOICE(name=u'CauseLevel-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _CauseLevel_RL_AdditionFailureFDD_generalCause = SEQ(name=u'generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GeneralCauseList-RL-AdditionFailureFDD')))
    _CauseLevel_RL_AdditionFailureFDD_rLSpecificCause = SEQ(name=u'rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RLSpecificCauseList-RL-AdditionFailureFDD')))
    CauseLevel_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'generalCause', _CauseLevel_RL_AdditionFailureFDD_generalCause),
        (u'rLSpecificCause', _CauseLevel_RL_AdditionFailureFDD_rLSpecificCause),
        ])
    CauseLevel_RL_AdditionFailureFDD._ext = []
    
    #-----< GeneralCauseList-RL-AdditionFailureFDD >-----#
    GeneralCauseList_RL_AdditionFailureFDD = SEQ(name=u'GeneralCauseList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_AdditionFailureFDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions._cont = __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_
    _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'cause', _GeneralCauseList_RL_AdditionFailureFDD_cause),
        (u'iE-Extensions', _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions),
        ])
    GeneralCauseList_RL_AdditionFailureFDD._ext = []
    
    #-----< GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs >-----#
    GeneralCauseItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name=u'GeneralCauseItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-AdditionFailureFDD >-----#
    RLSpecificCauseList_RL_AdditionFailureFDD = SEQ(name=u'RLSpecificCauseList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_AdditionFailureFDD_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD = SEQ_OF(name=u'unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponseList-RL-AdditionFailureFDD')))
    _RLSpecificCauseList_RL_AdditionFailureFDD_successful_RL_InformationRespList_RL_AdditionFailureFDD = SEQ_OF(name=u'successful-RL-InformationRespList-RL-AdditionFailureFDD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SuccessfulRL-InformationResponseList-RL-AdditionFailureFDD')), opt=True)
    _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions._cont = __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'unsuccessful-RL-InformationRespList-RL-AdditionFailureFDD', _RLSpecificCauseList_RL_AdditionFailureFDD_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD),
        (u'successful-RL-InformationRespList-RL-AdditionFailureFDD', _RLSpecificCauseList_RL_AdditionFailureFDD_successful_RL_InformationRespList_RL_AdditionFailureFDD),
        (u'iE-Extensions', _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_AdditionFailureFDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name=u'RLSpecificCauseItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UnsuccessfulRL-InformationResponseList-RL-AdditionFailureFDD >-----#
    UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD = SEQ_OF(name=u'UnsuccessfulRL-InformationResponseList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD')))
    ___UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 188), (u'criticality', u'ignore'), (u'Value', ____UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id._const_tab = ___UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id._const_tab_at = None
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id._const_tab_id = u'id'
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality._const_tab = ___UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality._const_tab_at = ('..', u'id')
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality._const_tab_id = u'criticality'
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value._const_tab = ___UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value._const_tab_at = ('..', u'id')
    __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value._const_tab_id = u'Value'
    _UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_._cont = ASN1Dict([
        (u'id', __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id),
        (u'criticality', __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality),
        (u'value', __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value),
        ])
    _UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_._ext = None
    UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD._cont = _UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_
    UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs >-----#
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs = CLASS(name=u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD')))
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 188), (u'criticality', u'ignore'), (u'Value', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD >-----#
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD = SEQ(name=u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions._cont = __UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'rL-ID', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_ID),
        (u'cause', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_cause),
        (u'iE-Extensions', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions),
        ])
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD._ext = []
    
    #-----< UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs >-----#
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs = CLASS(name=u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SuccessfulRL-InformationResponseList-RL-AdditionFailureFDD >-----#
    SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD = SEQ_OF(name=u'SuccessfulRL-InformationResponseList-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD')))
    ___SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', ____SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id._const_tab = ___SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id._const_tab_at = None
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id._const_tab_id = u'id'
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality._const_tab = ___SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality._const_tab_at = ('..', u'id')
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality._const_tab_id = u'criticality'
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value._const_tab = ___SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value._const_tab_at = ('..', u'id')
    __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value._const_tab_id = u'Value'
    _SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_._cont = ASN1Dict([
        (u'id', __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id),
        (u'criticality', __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality),
        (u'value', __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value),
        ])
    _SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_._ext = None
    SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD._cont = _SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_
    SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs >-----#
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs = CLASS(name=u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD')))
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 159), (u'criticality', u'ignore'), (u'Value', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< SuccessfulRL-InformationResponse-RL-AdditionFailureFDD >-----#
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD = SEQ(name=u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_uRA_Information = SEQ(name=u'uRA-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sAI = SEQ(name=u'sAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_gA_Cell = SEQ_OF(name=u'gA-Cell', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_gA_AccessPointPosition = SEQ(name=u'gA-AccessPointPosition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'GA-AccessPointPosition')), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_received_total_wide_band_power = INT(name=u'received-total-wide-band-power', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Received-total-wide-band-power')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_not_Used_secondary_CCPCH_Info = NULL(name=u'not-Used-secondary-CCPCH-Info', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_dl_CodeInformation = SEQ(name=u'dl-CodeInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CodeInformationList-RL-AdditionFailureFDD')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_diversityIndication = CHOICE(name=u'diversityIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DiversityIndication-RL-AdditionFailureFDD')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sSDT_SupportIndicator = ENUM(name=u'sSDT-SupportIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SSDT-SupportIndicator')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_minUL_SIR = INT(name=u'minUL-SIR', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maxUL_SIR = INT(name=u'maxUL-SIR', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_closedlooptimingadjustmentmode = ENUM(name=u'closedlooptimingadjustmentmode', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Closedlooptimingadjustmentmode')), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maximumAllowedULTxPower = INT(name=u'maximumAllowedULTxPower', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaximumAllowedULTxPower')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_neighbouring_UMTS_CellInformation = SEQ_OF(name=u'neighbouring-UMTS-CellInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation')), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_neighbouring_GSM_CellInformation = SEQ(name=u'neighbouring-GSM-CellInformation', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-GSM-CellInformation')), opt=True)
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_primaryCPICH_Power = INT(name=u'primaryCPICH-Power', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCPICH-Power')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_pC_Preamble = INT(name=u'pC-Preamble', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PC-Preamble')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sRB_Delay = INT(name=u'sRB-Delay', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SRB-Delay')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    ____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions._cont = __SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'rL-ID', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_ID),
        (u'rL-Set-ID', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_Set_ID),
        (u'uRA-Information', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_uRA_Information),
        (u'sAI', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sAI),
        (u'gA-Cell', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_gA_Cell),
        (u'gA-AccessPointPosition', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_gA_AccessPointPosition),
        (u'received-total-wide-band-power', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_received_total_wide_band_power),
        (u'not-Used-secondary-CCPCH-Info', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_not_Used_secondary_CCPCH_Info),
        (u'dl-CodeInformation', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_dl_CodeInformation),
        (u'diversityIndication', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_diversityIndication),
        (u'sSDT-SupportIndicator', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sSDT_SupportIndicator),
        (u'minUL-SIR', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_minUL_SIR),
        (u'maxUL-SIR', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maxUL_SIR),
        (u'closedlooptimingadjustmentmode', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_closedlooptimingadjustmentmode),
        (u'maximumAllowedULTxPower', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maximumAllowedULTxPower),
        (u'maximumDLTxPower', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maximumDLTxPower),
        (u'minimumDLTxPower', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_minimumDLTxPower),
        (u'neighbouring-UMTS-CellInformation', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_neighbouring_UMTS_CellInformation),
        (u'neighbouring-GSM-CellInformation', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_neighbouring_GSM_CellInformation),
        (u'primaryCPICH-Power', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_primaryCPICH_Power),
        (u'pC-Preamble', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_pC_Preamble),
        (u'sRB-Delay', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sRB_Delay),
        (u'iE-Extensions', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions),
        ])
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD._ext = []
    
    #-----< SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs >-----#
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs = CLASS(name=u'SuccessfulRL-InformationResponse-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-ActivationIndicator')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HCS-Prio')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD-PFL')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_6 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-E-UTRA-CellInformation')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Neighbouring-UMTS-CellInformation-Ext')))
    SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 297), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 311), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 598), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 591), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 767), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 895), (u'criticality', u'ignore'), (u'Extension', _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_11), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CodeInformationList-RL-AdditionFailureFDD >-----#
    DL_CodeInformationList_RL_AdditionFailureFDD = SEQ(name=u'DL-CodeInformationList-RL-AdditionFailureFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CodeInformationList_RL_AdditionFailureFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CodeInformationList_RL_AdditionFailureFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CodeInformationList_RL_AdditionFailureFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    __DL_CodeInformationList_RL_AdditionFailureFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', ___DL_CodeInformationList_RL_AdditionFailureFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CodeInformationList_RL_AdditionFailureFDD_id._const_tab = __DL_CodeInformationList_RL_AdditionFailureFDD_id_tab
    _DL_CodeInformationList_RL_AdditionFailureFDD_id._const_tab_at = None
    _DL_CodeInformationList_RL_AdditionFailureFDD_id._const_tab_id = u'id'
    _DL_CodeInformationList_RL_AdditionFailureFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CodeInformationList_RL_AdditionFailureFDD_criticality._const_tab = __DL_CodeInformationList_RL_AdditionFailureFDD_id_tab
    _DL_CodeInformationList_RL_AdditionFailureFDD_criticality._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_AdditionFailureFDD_criticality._const_tab_id = u'criticality'
    _DL_CodeInformationList_RL_AdditionFailureFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CodeInformationList_RL_AdditionFailureFDD_value._const_tab = __DL_CodeInformationList_RL_AdditionFailureFDD_id_tab
    _DL_CodeInformationList_RL_AdditionFailureFDD_value._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_AdditionFailureFDD_value._const_tab_id = u'Value'
    DL_CodeInformationList_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'id', _DL_CodeInformationList_RL_AdditionFailureFDD_id),
        (u'criticality', _DL_CodeInformationList_RL_AdditionFailureFDD_criticality),
        (u'value', _DL_CodeInformationList_RL_AdditionFailureFDD_value),
        ])
    DL_CodeInformationList_RL_AdditionFailureFDD._ext = None
    
    #-----< DL-CodeInformationListIEs-RL-AdditionFailureFDD >-----#
    DL_CodeInformationListIEs_RL_AdditionFailureFDD = CLASS(name=u'DL-CodeInformationListIEs-RL-AdditionFailureFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CodeInformationListIEs_RL_AdditionFailureFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    DL_CodeInformationListIEs_RL_AdditionFailureFDD._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _DL_CodeInformationListIEs_RL_AdditionFailureFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DiversityIndication-RL-AdditionFailureFDD >-----#
    DiversityIndication_RL_AdditionFailureFDD = CHOICE(name=u'DiversityIndication-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _DiversityIndication_RL_AdditionFailureFDD_combining = SEQ(name=u'combining', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Combining-RL-AdditionFailureFDD')))
    _DiversityIndication_RL_AdditionFailureFDD_nonCombining = SEQ(name=u'nonCombining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'NonCombining-RL-AdditionFailureFDD')))
    DiversityIndication_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'combining', _DiversityIndication_RL_AdditionFailureFDD_combining),
        (u'nonCombining', _DiversityIndication_RL_AdditionFailureFDD_nonCombining),
        ])
    DiversityIndication_RL_AdditionFailureFDD._ext = None
    
    #-----< Combining-RL-AdditionFailureFDD >-----#
    Combining_RL_AdditionFailureFDD = SEQ(name=u'Combining-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _Combining_RL_AdditionFailureFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Combining_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Combining_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Combining_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __Combining_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _Combining_RL_AdditionFailureFDD_iE_Extensions._cont = __Combining_RL_AdditionFailureFDD_iE_Extensions__item_
    _Combining_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Combining_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'rL-ID', _Combining_RL_AdditionFailureFDD_rL_ID),
        (u'iE-Extensions', _Combining_RL_AdditionFailureFDD_iE_Extensions),
        ])
    Combining_RL_AdditionFailureFDD._ext = []
    
    #-----< CombiningItem-RL-AdditionFailureFDD-ExtIEs >-----#
    CombiningItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name=u'CombiningItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    CombiningItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< NonCombining-RL-AdditionFailureFDD >-----#
    NonCombining_RL_AdditionFailureFDD = SEQ(name=u'NonCombining-RL-AdditionFailureFDD', mode=MODE_TYPE)
    _NonCombining_RL_AdditionFailureFDD_dCH_InformationResponse = SEQ_OF(name=u'dCH-InformationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    _NonCombining_RL_AdditionFailureFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NonCombining_RL_AdditionFailureFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    ____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab = ____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_at = None
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab = ____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab = ____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __NonCombining_RL_AdditionFailureFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id),
        (u'criticality', ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue),
        ])
    __NonCombining_RL_AdditionFailureFDD_iE_Extensions__item_._ext = None
    _NonCombining_RL_AdditionFailureFDD_iE_Extensions._cont = __NonCombining_RL_AdditionFailureFDD_iE_Extensions__item_
    _NonCombining_RL_AdditionFailureFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NonCombining_RL_AdditionFailureFDD._cont = ASN1Dict([
        (u'dCH-InformationResponse', _NonCombining_RL_AdditionFailureFDD_dCH_InformationResponse),
        (u'iE-Extensions', _NonCombining_RL_AdditionFailureFDD_iE_Extensions),
        ])
    NonCombining_RL_AdditionFailureFDD._ext = []
    
    #-----< NonCombiningItem-RL-AdditionFailureFDD-ExtIEs >-----#
    NonCombiningItem_RL_AdditionFailureFDD_ExtIEs = CLASS(name=u'NonCombiningItem-RL-AdditionFailureFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _NonCombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    NonCombiningItem_RL_AdditionFailureFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _NonCombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureFDD-Extensions >-----#
    RadioLinkAdditionFailureFDD_Extensions = CLASS(name=u'RadioLinkAdditionFailureFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-serving-cell-change-informationResponse')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Serving-cell-change-informationResponse')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Change-Information-Response-List')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkAdditionFailureFDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLAddList')))
    RadioLinkAdditionFailureFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 603), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 604), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 797), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 840), (u'criticality', u'ignore'), (u'Extension', _RadioLinkAdditionFailureFDD_Extensions_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureTDD >-----#
    RadioLinkAdditionFailureTDD = SEQ(name=u'RadioLinkAdditionFailureTDD', mode=MODE_TYPE)
    _RadioLinkAdditionFailureTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkAdditionFailureTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureTDD')))
    _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id._const_tab = ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value._const_tab = ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkAdditionFailureTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionFailureTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkAdditionFailureTDD_protocolIEs__item__value),
        ])
    __RadioLinkAdditionFailureTDD_protocolIEs__item_._ext = None
    _RadioLinkAdditionFailureTDD_protocolIEs._cont = __RadioLinkAdditionFailureTDD_protocolIEs__item_
    _RadioLinkAdditionFailureTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkAdditionFailureTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkAdditionFailureTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id._const_tab = ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkAdditionFailureTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkAdditionFailureTDD_protocolExtensions__item_._ext = None
    _RadioLinkAdditionFailureTDD_protocolExtensions._cont = __RadioLinkAdditionFailureTDD_protocolExtensions__item_
    _RadioLinkAdditionFailureTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkAdditionFailureTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkAdditionFailureTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkAdditionFailureTDD_protocolExtensions),
        ])
    RadioLinkAdditionFailureTDD._ext = []
    
    #-----< RadioLinkAdditionFailureTDD-IEs >-----#
    RadioLinkAdditionFailureTDD_IEs = CLASS(name=u'RadioLinkAdditionFailureTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkAdditionFailureTDD_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-AdditionFailureTDD')))
    _RadioLinkAdditionFailureTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkAdditionFailureTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 198), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionFailureTDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkAdditionFailureTDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-AdditionFailureTDD >-----#
    CauseLevel_RL_AdditionFailureTDD = CHOICE(name=u'CauseLevel-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _CauseLevel_RL_AdditionFailureTDD_generalCause = SEQ(name=u'generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GeneralCauseList-RL-AdditionFailureTDD')))
    _CauseLevel_RL_AdditionFailureTDD_rLSpecificCause = SEQ(name=u'rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RLSpecificCauseList-RL-AdditionFailureTDD')))
    CauseLevel_RL_AdditionFailureTDD._cont = ASN1Dict([
        (u'generalCause', _CauseLevel_RL_AdditionFailureTDD_generalCause),
        (u'rLSpecificCause', _CauseLevel_RL_AdditionFailureTDD_rLSpecificCause),
        ])
    CauseLevel_RL_AdditionFailureTDD._ext = []
    
    #-----< GeneralCauseList-RL-AdditionFailureTDD >-----#
    GeneralCauseList_RL_AdditionFailureTDD = SEQ(name=u'GeneralCauseList-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _GeneralCauseList_RL_AdditionFailureTDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id),
        (u'criticality', ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions._cont = __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_
    _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_AdditionFailureTDD._cont = ASN1Dict([
        (u'cause', _GeneralCauseList_RL_AdditionFailureTDD_cause),
        (u'iE-Extensions', _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions),
        ])
    GeneralCauseList_RL_AdditionFailureTDD._ext = []
    
    #-----< GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs >-----#
    GeneralCauseItem_RL_AdditionFailureTDD_ExtIEs = CLASS(name=u'GeneralCauseItem-RL-AdditionFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_AdditionFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-AdditionFailureTDD >-----#
    RLSpecificCauseList_RL_AdditionFailureTDD = SEQ(name=u'RLSpecificCauseList-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_AdditionFailureTDD_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD = SEQ(name=u'unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD')))
    _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id),
        (u'criticality', ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions._cont = __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_
    _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_AdditionFailureTDD._cont = ASN1Dict([
        (u'unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD', _RLSpecificCauseList_RL_AdditionFailureTDD_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD),
        (u'iE-Extensions', _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions),
        ])
    RLSpecificCauseList_RL_AdditionFailureTDD._ext = []
    
    #-----< RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs >-----#
    RLSpecificCauseItem_RL_AdditionFailureTDD_ExtIEs = CLASS(name=u'RLSpecificCauseItem-RL-AdditionFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_AdditionFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD >-----#
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD = SEQ(name=u'Unsuccessful-RL-InformationRespItem-RL-AdditionFailureTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD')))
    __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 266), (u'criticality', u'ignore'), (u'Value', ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id._const_tab = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id._const_tab_at = None
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id._const_tab_id = u'id'
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality._const_tab = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality._const_tab_at = ('..', u'id')
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality._const_tab_id = u'criticality'
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value._const_tab = __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value._const_tab_at = ('..', u'id')
    _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value._const_tab_id = u'Value'
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD._cont = ASN1Dict([
        (u'id', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id),
        (u'criticality', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality),
        (u'value', _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value),
        ])
    Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD._ext = None
    
    #-----< Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD >-----#
    Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD = CLASS(name=u'Unsuccessful-RL-InformationRespItemIE-RL-AdditionFailureTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD')))
    Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD._val = ASN1Set(rv=[dict([(u'id', 266), (u'criticality', u'ignore'), (u'Value', _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD >-----#
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD = SEQ(name=u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD', mode=MODE_TYPE)
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab = ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id_tab
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_at = None
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab = ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab = ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id),
        (u'criticality', ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue),
        ])
    __UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item_._ext = None
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions._cont = __UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item_
    _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD._cont = ASN1Dict([
        (u'rL-ID', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_rL_ID),
        (u'cause', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_cause),
        (u'iE-Extensions', _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions),
        ])
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD._ext = []
    
    #-----< UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD-ExtIEs >-----#
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_ExtIEs = CLASS(name=u'UnsuccessfulRL-InformationResponse-RL-AdditionFailureTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkAdditionFailureTDD-Extensions >-----#
    RadioLinkAdditionFailureTDD_Extensions = CLASS(name=u'RadioLinkAdditionFailureTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkAdditionFailureTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionRequest >-----#
    RadioLinkDeletionRequest = SEQ(name=u'RadioLinkDeletionRequest', mode=MODE_TYPE)
    _RadioLinkDeletionRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkDeletionRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkDeletionRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkDeletionRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-DeletionRqst')))
    ____RadioLinkDeletionRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 125), (u'criticality', u'notify'), (u'Value', _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolIEs__item__id._const_tab = ____RadioLinkDeletionRequest_protocolIEs__item__id_tab
    ___RadioLinkDeletionRequest_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkDeletionRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality._const_tab = ____RadioLinkDeletionRequest_protocolIEs__item__id_tab
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkDeletionRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkDeletionRequest_protocolIEs__item__value._const_tab = ____RadioLinkDeletionRequest_protocolIEs__item__id_tab
    ___RadioLinkDeletionRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkDeletionRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkDeletionRequest_protocolIEs__item__id),
        (u'criticality', ___RadioLinkDeletionRequest_protocolIEs__item__criticality),
        (u'value', ___RadioLinkDeletionRequest_protocolIEs__item__value),
        ])
    __RadioLinkDeletionRequest_protocolIEs__item_._ext = None
    _RadioLinkDeletionRequest_protocolIEs._cont = __RadioLinkDeletionRequest_protocolIEs__item_
    _RadioLinkDeletionRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkDeletionRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkDeletionRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkDeletionRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolExtensions__item__id._const_tab = ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab
    ___RadioLinkDeletionRequest_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkDeletionRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality._const_tab = ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkDeletionRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkDeletionRequest_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkDeletionRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkDeletionRequest_protocolExtensions__item_._ext = None
    _RadioLinkDeletionRequest_protocolExtensions._cont = __RadioLinkDeletionRequest_protocolExtensions__item_
    _RadioLinkDeletionRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkDeletionRequest._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkDeletionRequest_protocolIEs),
        (u'protocolExtensions', _RadioLinkDeletionRequest_protocolExtensions),
        ])
    RadioLinkDeletionRequest._ext = []
    
    #-----< RadioLinkDeletionRequest-IEs >-----#
    RadioLinkDeletionRequest_IEs = CLASS(name=u'RadioLinkDeletionRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkDeletionRequest_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-DeletionRqst')))
    RadioLinkDeletionRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 125), (u'criticality', u'notify'), (u'Value', _RadioLinkDeletionRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-DeletionRqst >-----#
    RL_InformationList_RL_DeletionRqst = SEQ_OF(name=u'RL-InformationList-RL-DeletionRqst', mode=MODE_TYPE)
    _RL_InformationList_RL_DeletionRqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_DeletionRqst__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_DeletionRqst__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_DeletionRqst__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-DeletionRqst')))
    ___RL_InformationList_RL_DeletionRqst__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 114), (u'criticality', u'notify'), (u'Value', ____RL_InformationList_RL_DeletionRqst__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_DeletionRqst__item__id._const_tab = ___RL_InformationList_RL_DeletionRqst__item__id_tab
    __RL_InformationList_RL_DeletionRqst__item__id._const_tab_at = None
    __RL_InformationList_RL_DeletionRqst__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_DeletionRqst__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_DeletionRqst__item__criticality._const_tab = ___RL_InformationList_RL_DeletionRqst__item__id_tab
    __RL_InformationList_RL_DeletionRqst__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_DeletionRqst__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_DeletionRqst__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_DeletionRqst__item__value._const_tab = ___RL_InformationList_RL_DeletionRqst__item__id_tab
    __RL_InformationList_RL_DeletionRqst__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_DeletionRqst__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_DeletionRqst__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_DeletionRqst__item__id),
        (u'criticality', __RL_InformationList_RL_DeletionRqst__item__criticality),
        (u'value', __RL_InformationList_RL_DeletionRqst__item__value),
        ])
    _RL_InformationList_RL_DeletionRqst__item_._ext = None
    RL_InformationList_RL_DeletionRqst._cont = _RL_InformationList_RL_DeletionRqst__item_
    RL_InformationList_RL_DeletionRqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-RL-DeletionRqst-IEs >-----#
    RL_Information_RL_DeletionRqst_IEs = CLASS(name=u'RL-Information-RL-DeletionRqst-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_RL_DeletionRqst_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-DeletionRqst')))
    RL_Information_RL_DeletionRqst_IEs._val = ASN1Set(rv=[dict([(u'id', 114), (u'criticality', u'notify'), (u'Value', _RL_Information_RL_DeletionRqst_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Information-RL-DeletionRqst >-----#
    RL_Information_RL_DeletionRqst = SEQ(name=u'RL-Information-RL-DeletionRqst', mode=MODE_TYPE)
    _RL_Information_RL_DeletionRqst_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_DeletionRqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_DeletionRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_DeletionRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_DeletionRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__id._const_tab = ____RL_Information_RL_DeletionRqst_iE_Extensions__item__id_tab
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality_tab
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_DeletionRqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_DeletionRqst_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_DeletionRqst_iE_Extensions__item_._ext = None
    _RL_Information_RL_DeletionRqst_iE_Extensions._cont = __RL_Information_RL_DeletionRqst_iE_Extensions__item_
    _RL_Information_RL_DeletionRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_DeletionRqst._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_DeletionRqst_rL_ID),
        (u'iE-Extensions', _RL_Information_RL_DeletionRqst_iE_Extensions),
        ])
    RL_Information_RL_DeletionRqst._ext = []
    
    #-----< RL-Information-RL-DeletionRqst-ExtIEs >-----#
    RL_Information_RL_DeletionRqst_ExtIEs = CLASS(name=u'RL-Information-RL-DeletionRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Information_RL_DeletionRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionRequest-Extensions >-----#
    RadioLinkDeletionRequest_Extensions = CLASS(name=u'RadioLinkDeletionRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkDeletionRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionResponse >-----#
    RadioLinkDeletionResponse = SEQ(name=u'RadioLinkDeletionResponse', mode=MODE_TYPE)
    _RadioLinkDeletionResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkDeletionResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkDeletionResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkDeletionResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkDeletionResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolIEs__item__id._const_tab = ____RadioLinkDeletionResponse_protocolIEs__item__id_tab
    ___RadioLinkDeletionResponse_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkDeletionResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality._const_tab = ____RadioLinkDeletionResponse_protocolIEs__item__id_tab
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkDeletionResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkDeletionResponse_protocolIEs__item__value._const_tab = ____RadioLinkDeletionResponse_protocolIEs__item__id_tab
    ___RadioLinkDeletionResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkDeletionResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkDeletionResponse_protocolIEs__item__id),
        (u'criticality', ___RadioLinkDeletionResponse_protocolIEs__item__criticality),
        (u'value', ___RadioLinkDeletionResponse_protocolIEs__item__value),
        ])
    __RadioLinkDeletionResponse_protocolIEs__item_._ext = None
    _RadioLinkDeletionResponse_protocolIEs._cont = __RadioLinkDeletionResponse_protocolIEs__item_
    _RadioLinkDeletionResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkDeletionResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkDeletionResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkDeletionResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolExtensions__item__id._const_tab = ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab
    ___RadioLinkDeletionResponse_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkDeletionResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality._const_tab = ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkDeletionResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkDeletionResponse_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkDeletionResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkDeletionResponse_protocolExtensions__item_._ext = None
    _RadioLinkDeletionResponse_protocolExtensions._cont = __RadioLinkDeletionResponse_protocolExtensions__item_
    _RadioLinkDeletionResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkDeletionResponse._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkDeletionResponse_protocolIEs),
        (u'protocolExtensions', _RadioLinkDeletionResponse_protocolExtensions),
        ])
    RadioLinkDeletionResponse._ext = []
    
    #-----< RadioLinkDeletionResponse-IEs >-----#
    RadioLinkDeletionResponse_IEs = CLASS(name=u'RadioLinkDeletionResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkDeletionResponse_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkDeletionResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkDeletionResponse_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkDeletionResponse-Extensions >-----#
    RadioLinkDeletionResponse_Extensions = CLASS(name=u'RadioLinkDeletionResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkDeletionResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareFDD >-----#
    RadioLinkReconfigurationPrepareFDD = SEQ(name=u'RadioLinkReconfigurationPrepareFDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationPrepareFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 126), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 255), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationPrepareFDD_protocolIEs._cont = __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_
    _RadioLinkReconfigurationPrepareFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationPrepareFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDPCH-Information-RLReconfPrepare-FDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information-To-Modify')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_10 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'F-DPCH-Information-RL-ReconfPrepFDD')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_12 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-Reconfiguration-Mode')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-Information')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Prep')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Prep')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_19 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_22 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_23 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Improved-Synchronized-Indicator')))
    ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 452), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 456), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 574), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 583), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 582), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 584), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 558), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 668), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 673), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 798), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 841), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 907), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 965), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 969), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 984), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_22), (u'presence', u'optional')]), dict([(u'id', 982), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_23), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationPrepareFDD_protocolExtensions._cont = __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_
    _RadioLinkReconfigurationPrepareFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationPrepareFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationPrepareFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationPrepareFDD_protocolExtensions),
        ])
    RadioLinkReconfigurationPrepareFDD._ext = []
    
    #-----< RadioLinkReconfigurationPrepareFDD-IEs >-----#
    RadioLinkReconfigurationPrepareFDD_IEs = CLASS(name=u'RadioLinkReconfigurationPrepareFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-Information')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    RadioLinkReconfigurationPrepareFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 177), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 59), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 30), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 126), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 255), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-ReconfPrepFDD >-----#
    UL_DPCH_Information_RL_ReconfPrepFDD = SEQ(name=u'UL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_ScramblingCode = SEQ(name=u'ul-ScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-ScramblingCode')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_SIRTarget = INT(name=u'ul-SIRTarget', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_minUL_ChannelisationCodeLength = ENUM(name=u'minUL-ChannelisationCodeLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MinUL-ChannelisationCodeLength')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_maxNrOfUL_DPDCHs = INT(name=u'maxNrOfUL-DPDCHs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MaxNrOfUL-DPCHs')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit = INT(name=u'ul-PunctureLimit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_ul_DPCCH_SlotFormat = INT(name=u'ul-DPCCH-SlotFormat', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH-SlotFormat')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_diversityMode = ENUM(name=u'diversityMode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DiversityMode')), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIDLength = NULL(name=u'not-Used-sSDT-CellIDLength', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_s_FieldLength = NULL(name=u'not-Used-s-FieldLength', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPDCHIndicatorEDCH')))
    ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 573), (u'criticality', u'reject'), (u'Extension', _____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'ul-ScramblingCode', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_ScramblingCode),
        (u'ul-SIRTarget', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_SIRTarget),
        (u'minUL-ChannelisationCodeLength', _UL_DPCH_Information_RL_ReconfPrepFDD_minUL_ChannelisationCodeLength),
        (u'maxNrOfUL-DPDCHs', _UL_DPCH_Information_RL_ReconfPrepFDD_maxNrOfUL_DPDCHs),
        (u'ul-PunctureLimit', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit),
        (u'tFCS', _UL_DPCH_Information_RL_ReconfPrepFDD_tFCS),
        (u'ul-DPCCH-SlotFormat', _UL_DPCH_Information_RL_ReconfPrepFDD_ul_DPCCH_SlotFormat),
        (u'diversityMode', _UL_DPCH_Information_RL_ReconfPrepFDD_diversityMode),
        (u'not-Used-sSDT-CellIDLength', _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIDLength),
        (u'not-Used-s-FieldLength', _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_s_FieldLength),
        (u'iE-Extensions', _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    UL_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'UL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPDCHIndicatorEDCH')))
    UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 573), (u'criticality', u'reject'), (u'Extension', _UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-ReconfPrepFDD >-----#
    DL_DPCH_Information_RL_ReconfPrepFDD = SEQ(name=u'DL-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DL_DPCH_Information_RL_ReconfPrepFDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_dl_DPCH_SlotFormat = INT(name=u'dl-DPCH-SlotFormat', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-SlotFormat')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_nrOfDLchannelisationcodes = INT(name=u'nrOfDLchannelisationcodes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NrOfDLchannelisationcodes')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_SignallingMode = ENUM(name=u'tFCI-SignallingMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-SignallingMode')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_multiplexingPosition = ENUM(name=u'multiplexingPosition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MultiplexingPosition')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease = ENUM(name=u'limitedPowerIncrease', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LimitedPowerIncrease')), opt=True)
    _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Power-Information-RL-ReconfPrepFDD')))
    ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 557), (u'criticality', u'reject'), (u'Extension', _____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'tFCS', _DL_DPCH_Information_RL_ReconfPrepFDD_tFCS),
        (u'dl-DPCH-SlotFormat', _DL_DPCH_Information_RL_ReconfPrepFDD_dl_DPCH_SlotFormat),
        (u'nrOfDLchannelisationcodes', _DL_DPCH_Information_RL_ReconfPrepFDD_nrOfDLchannelisationcodes),
        (u'tFCI-SignallingMode', _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_SignallingMode),
        (u'tFCI-Presence', _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_Presence),
        (u'multiplexingPosition', _DL_DPCH_Information_RL_ReconfPrepFDD_multiplexingPosition),
        (u'limitedPowerIncrease', _DL_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease),
        (u'iE-Extensions', _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    DL_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'DL-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Power-Information-RL-ReconfPrepFDD')))
    DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 557), (u'criticality', u'reject'), (u'Extension', _DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Power-Information-RL-ReconfPrepFDD >-----#
    DL_DPCH_Power_Information_RL_ReconfPrepFDD = SEQ(name=u'DL-DPCH-Power-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_powerOffsetInformation = SEQ(name=u'powerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PowerOffsetInformation-RL-ReconfPrepFDD')))
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize = ENUM(name=u'fdd-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus = ENUM(name=u'innerLoopDLPCStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Power_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'powerOffsetInformation', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_powerOffsetInformation),
        (u'fdd-TPC-DownlinkStepSize', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize),
        (u'innerLoopDLPCStatus', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus),
        (u'iE-Extensions', _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    DL_DPCH_Power_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    DL_DPCH_Power_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'DL-DPCH-Power-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_Power_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-RL-ReconfPrepFDD >-----#
    PowerOffsetInformation_RL_ReconfPrepFDD = SEQ(name=u'PowerOffsetInformation-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_RL_ReconfPrepFDD_pO1_ForTFCI_Bits = INT(name=u'pO1-ForTFCI-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_ReconfPrepFDD_pO2_ForTPC_Bits = INT(name=u'pO2-ForTPC-Bits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_ReconfPrepFDD_pO3_ForPilotBits = INT(name=u'pO3-ForPilotBits', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions._cont = __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_
    _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'pO1-ForTFCI-Bits', _PowerOffsetInformation_RL_ReconfPrepFDD_pO1_ForTFCI_Bits),
        (u'pO2-ForTPC-Bits', _PowerOffsetInformation_RL_ReconfPrepFDD_pO2_ForTPC_Bits),
        (u'pO3-ForPilotBits', _PowerOffsetInformation_RL_ReconfPrepFDD_pO3_ForPilotBits),
        (u'iE-Extensions', _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions),
        ])
    PowerOffsetInformation_RL_ReconfPrepFDD._ext = []
    
    #-----< PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs >-----#
    PowerOffsetInformation_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'PowerOffsetInformation-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfPrepFDD >-----#
    DCH_DeleteList_RL_ReconfPrepFDD = SEQ_OF(name=u'DCH-DeleteList-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfPrepFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfPrepFDD')))
    DCH_DeleteList_RL_ReconfPrepFDD._cont = _DCH_DeleteList_RL_ReconfPrepFDD__item_
    DCH_DeleteList_RL_ReconfPrepFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfPrepFDD >-----#
    DCH_DeleteItem_RL_ReconfPrepFDD = SEQ(name=u'DCH-DeleteItem-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfPrepFDD_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'dCH-ID', _DCH_DeleteItem_RL_ReconfPrepFDD_dCH_ID),
        (u'iE-Extensions', _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfPrepFDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'DCH-DeleteItem-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-ReconfPrepFDD >-----#
    RL_InformationList_RL_ReconfPrepFDD = SEQ_OF(name=u'RL-InformationList-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _RL_InformationList_RL_ReconfPrepFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_ReconfPrepFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_ReconfPrepFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-ReconfPrepFDD')))
    ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 116), (u'criticality', u'reject'), (u'Value', ____RL_InformationList_RL_ReconfPrepFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_ReconfPrepFDD__item__id._const_tab = ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab
    __RL_InformationList_RL_ReconfPrepFDD__item__id._const_tab_at = None
    __RL_InformationList_RL_ReconfPrepFDD__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality._const_tab = ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_ReconfPrepFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_ReconfPrepFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_ReconfPrepFDD__item__value._const_tab = ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab
    __RL_InformationList_RL_ReconfPrepFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_ReconfPrepFDD__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_ReconfPrepFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_ReconfPrepFDD__item__id),
        (u'criticality', __RL_InformationList_RL_ReconfPrepFDD__item__criticality),
        (u'value', __RL_InformationList_RL_ReconfPrepFDD__item__value),
        ])
    _RL_InformationList_RL_ReconfPrepFDD__item_._ext = None
    RL_InformationList_RL_ReconfPrepFDD._cont = _RL_InformationList_RL_ReconfPrepFDD__item_
    RL_InformationList_RL_ReconfPrepFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-RL-ReconfPrepFDD-IEs >-----#
    RL_Information_RL_ReconfPrepFDD_IEs = CLASS(name=u'RL-Information-RL-ReconfPrepFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_RL_ReconfPrepFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-ReconfPrepFDD')))
    RL_Information_RL_ReconfPrepFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 116), (u'criticality', u'reject'), (u'Value', _RL_Information_RL_ReconfPrepFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Information-RL-ReconfPrepFDD >-----#
    RL_Information_RL_ReconfPrepFDD = SEQ(name=u'RL-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _RL_Information_RL_ReconfPrepFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_ReconfPrepFDD_not_Used_sSDT_Indication = NULL(name=u'not-Used-sSDT-Indication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIdentity = NULL(name=u'not-Used-sSDT-CellIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_Information_RL_ReconfPrepFDD_transmitDiversityIndicator = ENUM(name=u'transmitDiversityIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransmitDiversityIndicator')), opt=True)
    _RL_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Phase-Reference-Update-Indicator')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Reconf')))
    _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    ____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 525), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 874), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 912), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _RL_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __RL_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _RL_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_ReconfPrepFDD_rL_ID),
        (u'not-Used-sSDT-Indication', _RL_Information_RL_ReconfPrepFDD_not_Used_sSDT_Indication),
        (u'not-Used-sSDT-CellIdentity', _RL_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIdentity),
        (u'transmitDiversityIndicator', _RL_Information_RL_ReconfPrepFDD_transmitDiversityIndicator),
        (u'iE-Extensions', _RL_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    RL_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< RL-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    RL_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'RL-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-DPCH-TimingAdjustment')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Phase-Reference-Update-Indicator')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Reconf')))
    _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TPC-slot-position')))
    RL_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 67), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 317), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 278), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 525), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 874), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 912), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 985), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareFDD-Extensions >-----#
    RadioLinkReconfigurationPrepareFDD_Extensions = CLASS(name=u'RadioLinkReconfigurationPrepareFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDPCH-Information-RLReconfPrepare-FDD')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information-To-Modify')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_9 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_10 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'F-DPCH-Information-RL-ReconfPrepFDD')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_12 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-Reconfiguration-Mode')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-Information')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Prep')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Prep')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_19 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ENH-Information-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_20 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_21 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_22 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_23 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Improved-Synchronized-Indicator')))
    RadioLinkReconfigurationPrepareFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 452), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 456), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 574), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 583), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 582), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 584), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 558), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 668), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 673), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 798), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 841), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 907), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 965), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 969), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 984), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_22), (u'presence', u'optional')]), dict([(u'id', 982), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_23), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Prep >-----#
    Additional_HS_Cell_Information_RL_Reconf_Prep = SEQ_OF(name=u'Additional-HS-Cell-Information-RL-Reconf-Prep', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Prep__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs')))
    Additional_HS_Cell_Information_RL_Reconf_Prep._cont = _Additional_HS_Cell_Information_RL_Reconf_Prep__item_
    Additional_HS_Cell_Information_RL_Reconf_Prep._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs = SEQ(name=u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_Secondary_Serving_Information_To_Modify = SEQ(name=u'hS-DSCH-Secondary-Serving-Information-To-Modify', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Secondary-Serving-Information-To-Modify')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_HS_DSCH_Secondary_Serving_Remove = NULL(name=u'hS-HS-DSCH-Secondary-Serving-Remove', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Secondary-Serving-Remove')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hSPDSCH_RL_ID),
        (u'c-ID', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_c_ID),
        (u'hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        (u'hS-DSCH-Secondary-Serving-Information-To-Modify', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_Secondary_Serving_Information_To_Modify),
        (u'hS-HS-DSCH-Secondary-Serving-Remove', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_HS_DSCH_Secondary_Serving_Remove),
        (u'iE-Extensions', _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_ExtIEs = CLASS(name=u'Additional-HS-Cell-Information-RL-Reconf-Prep-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Prep >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Prep = SEQ(name=u'Additional-EDCH-Cell-Information-RL-Reconf-Prep', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Reconf_Prep._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', _Additional_EDCH_Cell_Information_RL_Reconf_Prep_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Reconf_Prep._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Prep_ExtIEs = CLASS(name=u'Additional-EDCH-Cell-Information-RL-Reconf-Prep-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Reconf_Prep_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< F-DPCH-Information-RL-ReconfPrepFDD >-----#
    F_DPCH_Information_RL_ReconfPrepFDD = SEQ(name=u'F-DPCH-Information-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _F_DPCH_Information_RL_ReconfPrepFDD_powerOffsetInformation = SEQ(name=u'powerOffsetInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD')))
    _F_DPCH_Information_RL_ReconfPrepFDD_fdd_dl_TPC_DownlinkStepSize = ENUM(name=u'fdd-dl-TPC-DownlinkStepSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'FDD-TPC-DownlinkStepSize')))
    _F_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease = ENUM(name=u'limitedPowerIncrease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LimitedPowerIncrease')))
    _F_DPCH_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus = ENUM(name=u'innerLoopDLPCStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormatSupportRequest')))
    _____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 693), (u'criticality', u'reject'), (u'Extension', _____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._cont = __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_
    _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    F_DPCH_Information_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'powerOffsetInformation', _F_DPCH_Information_RL_ReconfPrepFDD_powerOffsetInformation),
        (u'fdd-dl-TPC-DownlinkStepSize', _F_DPCH_Information_RL_ReconfPrepFDD_fdd_dl_TPC_DownlinkStepSize),
        (u'limitedPowerIncrease', _F_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease),
        (u'innerLoopDLPCStatus', _F_DPCH_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus),
        (u'iE-Extensions', _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions),
        ])
    F_DPCH_Information_RL_ReconfPrepFDD._ext = []
    
    #-----< F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs >-----#
    F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'F-DPCH-Information-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormatSupportRequest')))
    _F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 693), (u'criticality', u'reject'), (u'Extension', _F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD >-----#
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD = SEQ(name=u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD', mode=MODE_TYPE)
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_po2_ForTPC_Bits = INT(name=u'po2-ForTPC-Bits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PowerOffset')))
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab = ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_at = None
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab = ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab = ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id),
        (u'criticality', ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue),
        ])
    __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_._ext = None
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions._cont = __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_
    _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD._cont = ASN1Dict([
        (u'po2-ForTPC-Bits', _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_po2_ForTPC_Bits),
        (u'iE-Extensions', _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions),
        ])
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD._ext = []
    
    #-----< PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs >-----#
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_ExtIEs = CLASS(name=u'PowerOffsetInformation-F-DPCH-RL-ReconfPrepFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareTDD >-----#
    RadioLinkReconfigurationPrepareTDD = SEQ(name=u'RadioLinkReconfigurationPrepareTDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationPrepareTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-ModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-TDD-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_12 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-DeleteList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-ModifyList-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'USCH-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-DeleteList-RL-ReconfPrepTDD')))
    ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 169), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 51), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 208), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 272), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 267), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 268), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationPrepareTDD_protocolIEs._cont = __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_
    _RadioLinkReconfigurationPrepareTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationPrepareTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-Info')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-ReconfPrepTDD')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Reconfig')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_16 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeedforIdleInterval')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-InformationLCR')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNTI-Allocation-Indicator')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_19 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_22 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 456), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 323), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 464), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 527), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 657), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 660), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 678), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 805), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 810), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 863), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 885), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_22), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationPrepareTDD_protocolExtensions._cont = __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_
    _RadioLinkReconfigurationPrepareTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationPrepareTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationPrepareTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationPrepareTDD_protocolExtensions),
        ])
    RadioLinkReconfigurationPrepareTDD._ext = []
    
    #-----< RadioLinkReconfigurationPrepareTDD-IEs >-----#
    RadioLinkReconfigurationPrepareTDD_IEs = CLASS(name=u'RadioLinkReconfigurationPrepareTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_8 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-Information')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_9 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_10 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-ModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_11 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-TDD-Information')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_12 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-DeleteList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_13 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-ModifyList-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_14 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'USCH-Information')))
    _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_15 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-DeleteList-RL-ReconfPrepTDD')))
    RadioLinkReconfigurationPrepareTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 169), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 260), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 259), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 51), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 209), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 208), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_7), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 31), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 227), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 215), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 217), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_12), (u'presence', u'optional')]), dict([(u'id', 272), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_13), (u'presence', u'optional')]), dict([(u'id', 267), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_14), (u'presence', u'optional')]), dict([(u'id', 268), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = SEQ_OF(name=u'UL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD')))
    ___UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 167), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id._const_tab = ___UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value._const_tab = ___UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value),
        ])
    _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_._ext = None
    UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._cont = _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_
    UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs >-----#
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs = CLASS(name=u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD')))
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 167), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-AddInformation-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD = SEQ(name=u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    ____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Extension', _____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 488), (u'criticality', u'reject'), (u'Extension', _____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'tFCS', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_tFCS),
        (u'tFCI-Coding', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_tFCI_Coding),
        (u'punctureLimit', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_punctureLimit),
        (u'iE-Extensions', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-AddInformation-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Extension', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 488), (u'criticality', u'reject'), (u'Extension', _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = SEQ_OF(name=u'UL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD')))
    ___UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 257), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value),
        ])
    _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_._ext = None
    UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._cont = _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_
    UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs >-----#
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs = CLASS(name=u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD')))
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 257), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD = SEQ(name=u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')), opt=True)
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')), opt=True)
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    ____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Extension', _____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 489), (u'criticality', u'reject'), (u'Extension', _____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'tFCS', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_tFCS),
        (u'tFCI-Coding', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_tFCI_Coding),
        (u'punctureLimit', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_punctureLimit),
        (u'iE-Extensions', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-UplinkStepSize-LCR')))
    UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Extension', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 489), (u'criticality', u'reject'), (u'Extension', _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = SEQ_OF(name=u'UL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD')))
    ___UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 256), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value),
        ])
    _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_._ext = None
    UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._cont = _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_
    UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs >-----#
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs = CLASS(name=u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD')))
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 256), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD >-----#
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD = SEQ(name=u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions._cont = __UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item_
    _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'iE-Extensions', _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions),
        ])
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD._ext = []
    
    #-----< UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-ExtIEs >-----#
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD = SEQ_OF(name=u'DL-CCTrCH-InformationAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD')))
    ___DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 44), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id._const_tab = ___DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value._const_tab = ___DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value),
        ])
    _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_._ext = None
    DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._cont = _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_
    DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs >-----#
    DL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs = CLASS(name=u'DL-CCTrCH-AddInformation-RL-ReconfPrepTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD')))
    DL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 44), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD = SEQ(name=u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_TPCList = SEQ_OF(name=u'cCTrCH-TPCList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-TPCAddList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 490), (u'criticality', u'reject'), (u'Extension', _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'tFCS', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS),
        (u'tFCI-Coding', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding),
        (u'punctureLimit', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit),
        (u'cCTrCH-TPCList', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_TPCList),
        (u'iE-Extensions', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 490), (u'criticality', u'reject'), (u'Extension', _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-TPCAddList-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCAddList_RL_ReconfPrepTDD = SEQ_OF(name=u'CCTrCH-TPCAddList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCAddList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-TPCAddItem-RL-ReconfPrepTDD')))
    CCTrCH_TPCAddList_RL_ReconfPrepTDD._cont = _CCTrCH_TPCAddList_RL_ReconfPrepTDD__item_
    CCTrCH_TPCAddList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-TPCAddItem-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD = SEQ(name=u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions._cont = __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'iE-Extensions', _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD._ext = []
    
    #-----< CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs >-----#
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'CCTrCH-TPCAddItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCH_TPCAddItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD = SEQ_OF(name=u'DL-CCTrCH-InformationModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD')))
    ___DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 206), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value),
        ])
    _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_._ext = None
    DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._cont = _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_
    DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs >-----#
    DL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs = CLASS(name=u'DL-CCTrCH-ModifyInformation-RL-ReconfPrepTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD')))
    DL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 206), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD = SEQ(name=u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding = ENUM(name=u'tFCI-Coding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Coding')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit = INT(name=u'punctureLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PunctureLimit')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_TPCList = SEQ_OF(name=u'cCTrCH-TPCList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-TPCModifyList-RL-ReconfPrepTDD')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 491), (u'criticality', u'reject'), (u'Extension', _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'tFCS', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS),
        (u'tFCI-Coding', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding),
        (u'punctureLimit', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit),
        (u'cCTrCH-TPCList', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_TPCList),
        (u'iE-Extensions', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-TPC-DownlinkStepSize')))
    DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 491), (u'criticality', u'reject'), (u'Extension', _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-TPCModifyList-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCModifyList_RL_ReconfPrepTDD = SEQ_OF(name=u'CCTrCH-TPCModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD')))
    CCTrCH_TPCModifyList_RL_ReconfPrepTDD._cont = _CCTrCH_TPCModifyList_RL_ReconfPrepTDD__item_
    CCTrCH_TPCModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-TPCModifyItem-RL-ReconfPrepTDD >-----#
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD = SEQ(name=u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'iE-Extensions', _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'CCTrCH-TPCModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD = SEQ_OF(name=u'DL-CCTrCH-InformationDeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD')))
    ___DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 205), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value),
        ])
    _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_._ext = None
    DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._cont = _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_
    DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs >-----#
    DL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs = CLASS(name=u'DL-CCTrCH-DeleteInformation-RL-ReconfPrepTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD')))
    DL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 205), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD = SEQ(name=u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID),
        (u'iE-Extensions', _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationDeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfPrepTDD >-----#
    DCH_DeleteList_RL_ReconfPrepTDD = SEQ_OF(name=u'DCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfPrepTDD')))
    DCH_DeleteList_RL_ReconfPrepTDD._cont = _DCH_DeleteList_RL_ReconfPrepTDD__item_
    DCH_DeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfPrepTDD >-----#
    DCH_DeleteItem_RL_ReconfPrepTDD = SEQ(name=u'DCH-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfPrepTDD_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'dCH-ID', _DCH_DeleteItem_RL_ReconfPrepTDD_dCH_ID),
        (u'iE-Extensions', _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'DCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DSCH-ModifyList-RL-ReconfPrepTDD >-----#
    DSCH_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name=u'DSCH-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-ModifyItem-RL-ReconfPrepTDD')))
    DSCH_ModifyList_RL_ReconfPrepTDD._cont = _DSCH_ModifyList_RL_ReconfPrepTDD__item_
    DSCH_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCH-ModifyItem-RL-ReconfPrepTDD >-----#
    DSCH_ModifyItem_RL_ReconfPrepTDD = SEQ(name=u'DSCH-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_dSCH_ID = INT(name=u'dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCH_ModifyItem_RL_ReconfPrepTDD_dl_ccTrCHID = INT(name=u'dl-ccTrCHID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')), opt=True)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_trChSourceStatisticsDescriptor = ENUM(name=u'trChSourceStatisticsDescriptor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')), opt=True)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_transportFormatSet = SEQ(name=u'transportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')), opt=True)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_bLER = INT(name=u'bLER', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')), opt=True)
    _DSCH_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'dSCH-ID', _DSCH_ModifyItem_RL_ReconfPrepTDD_dSCH_ID),
        (u'dl-ccTrCHID', _DSCH_ModifyItem_RL_ReconfPrepTDD_dl_ccTrCHID),
        (u'trChSourceStatisticsDescriptor', _DSCH_ModifyItem_RL_ReconfPrepTDD_trChSourceStatisticsDescriptor),
        (u'transportFormatSet', _DSCH_ModifyItem_RL_ReconfPrepTDD_transportFormatSet),
        (u'allocationRetentionPriority', _DSCH_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority),
        (u'schedulingPriorityIndicator', _DSCH_ModifyItem_RL_ReconfPrepTDD_schedulingPriorityIndicator),
        (u'bLER', _DSCH_ModifyItem_RL_ReconfPrepTDD_bLER),
        (u'transportBearerRequestIndicator', _DSCH_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator),
        (u'iE-Extensions', _DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DSCH_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DSCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'DSCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DSCH-DeleteList-RL-ReconfPrepTDD >-----#
    DSCH_DeleteList_RL_ReconfPrepTDD = SEQ_OF(name=u'DSCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_DeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCH-DeleteItem-RL-ReconfPrepTDD')))
    DSCH_DeleteList_RL_ReconfPrepTDD._cont = _DSCH_DeleteList_RL_ReconfPrepTDD__item_
    DSCH_DeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCH-DeleteItem-RL-ReconfPrepTDD >-----#
    DSCH_DeleteItem_RL_ReconfPrepTDD = SEQ(name=u'DSCH-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _DSCH_DeleteItem_RL_ReconfPrepTDD_dSCH_ID = INT(name=u'dSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCH_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'dSCH-ID', _DSCH_DeleteItem_RL_ReconfPrepTDD_dSCH_ID),
        (u'iE-Extensions', _DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    DSCH_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< DSCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    DSCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'DSCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DSCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-ModifyList-RL-ReconfPrepTDD >-----#
    USCH_ModifyList_RL_ReconfPrepTDD = SEQ_OF(name=u'USCH-ModifyList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_ModifyList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-ModifyItem-RL-ReconfPrepTDD')))
    USCH_ModifyList_RL_ReconfPrepTDD._cont = _USCH_ModifyList_RL_ReconfPrepTDD__item_
    USCH_ModifyList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCH-ModifyItem-RL-ReconfPrepTDD >-----#
    USCH_ModifyItem_RL_ReconfPrepTDD = SEQ(name=u'USCH-ModifyItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_ModifyItem_RL_ReconfPrepTDD_uSCH_ID = INT(name=u'uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCH_ModifyItem_RL_ReconfPrepTDD_ul_ccTrCHID = INT(name=u'ul-ccTrCHID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_trChSourceStatisticsDescriptor = ENUM(name=u'trChSourceStatisticsDescriptor', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TrCH-SrcStatisticsDescr')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_transportFormatSet = SEQ(name=u'transportFormatSet', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatSet')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority = SEQ(name=u'allocationRetentionPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'AllocationRetentionPriority')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_schedulingPriorityIndicator = INT(name=u'schedulingPriorityIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'SchedulingPriorityIndicator')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_bLER = INT(name=u'bLER', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BLER')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator = ENUM(name=u'transportBearerRequestIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _USCH_ModifyItem_RL_ReconfPrepTDD_rb_Info = SEQ_OF(name=u'rb-Info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RB-Info')), opt=True)
    _USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    ____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._cont = __USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_ModifyItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'uSCH-ID', _USCH_ModifyItem_RL_ReconfPrepTDD_uSCH_ID),
        (u'ul-ccTrCHID', _USCH_ModifyItem_RL_ReconfPrepTDD_ul_ccTrCHID),
        (u'trChSourceStatisticsDescriptor', _USCH_ModifyItem_RL_ReconfPrepTDD_trChSourceStatisticsDescriptor),
        (u'transportFormatSet', _USCH_ModifyItem_RL_ReconfPrepTDD_transportFormatSet),
        (u'allocationRetentionPriority', _USCH_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority),
        (u'schedulingPriorityIndicator', _USCH_ModifyItem_RL_ReconfPrepTDD_schedulingPriorityIndicator),
        (u'bLER', _USCH_ModifyItem_RL_ReconfPrepTDD_bLER),
        (u'transportBearerRequestIndicator', _USCH_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator),
        (u'rb-Info', _USCH_ModifyItem_RL_ReconfPrepTDD_rb_Info),
        (u'iE-Extensions', _USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    USCH_ModifyItem_RL_ReconfPrepTDD._ext = []
    
    #-----< USCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs >-----#
    USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'USCH-ModifyItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TrafficClass')))
    _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 158), (u'criticality', u'ignore'), (u'Extension', _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< USCH-DeleteList-RL-ReconfPrepTDD >-----#
    USCH_DeleteList_RL_ReconfPrepTDD = SEQ_OF(name=u'USCH-DeleteList-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_DeleteList_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCH-DeleteItem-RL-ReconfPrepTDD')))
    USCH_DeleteList_RL_ReconfPrepTDD._cont = _USCH_DeleteList_RL_ReconfPrepTDD__item_
    USCH_DeleteList_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCH-DeleteItem-RL-ReconfPrepTDD >-----#
    USCH_DeleteItem_RL_ReconfPrepTDD = SEQ(name=u'USCH-DeleteItem-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _USCH_DeleteItem_RL_ReconfPrepTDD_uSCH_ID = INT(name=u'uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._cont = __USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_
    _USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCH_DeleteItem_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'uSCH-ID', _USCH_DeleteItem_RL_ReconfPrepTDD_uSCH_ID),
        (u'iE-Extensions', _USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions),
        ])
    USCH_DeleteItem_RL_ReconfPrepTDD._ext = []
    
    #-----< USCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs >-----#
    USCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'USCH-DeleteItem-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    USCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationPrepareTDD-Extensions >-----#
    RadioLinkReconfigurationPrepareTDD_Extensions = CLASS(name=u'RadioLinkReconfigurationPrepareTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-Info')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_10 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-ReconfPrepTDD')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Reconfig')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_16 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeedforIdleInterval')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-InformationLCR')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNTI-Allocation-Indicator')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_19 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_20 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_21 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_22 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkReconfigurationPrepareTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 202), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 203), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 204), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 456), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 323), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 464), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 527), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 657), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 660), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 678), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 805), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 810), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 863), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 885), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_22), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-Information-RL-ReconfPrepTDD >-----#
    RL_Information_RL_ReconfPrepTDD = SEQ_OF(name=u'RL-Information-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _RL_Information_RL_ReconfPrepTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationIE-RL-ReconfPrepTDD')))
    RL_Information_RL_ReconfPrepTDD._cont = _RL_Information_RL_ReconfPrepTDD__item_
    RL_Information_RL_ReconfPrepTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationIE-RL-ReconfPrepTDD >-----#
    RL_InformationIE_RL_ReconfPrepTDD = SEQ(name=u'RL-InformationIE-RL-ReconfPrepTDD', mode=MODE_TYPE)
    _RL_InformationIE_RL_ReconfPrepTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationIE_RL_ReconfPrepTDD_rL_Specific_DCH_Info = SEQ_OF(name=u'rL-Specific-DCH-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')), opt=True)
    _RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab = ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item_._ext = None
    _RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions._cont = __RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item_
    _RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationIE_RL_ReconfPrepTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationIE_RL_ReconfPrepTDD_rL_ID),
        (u'rL-Specific-DCH-Info', _RL_InformationIE_RL_ReconfPrepTDD_rL_Specific_DCH_Info),
        (u'iE-Extensions', _RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions),
        ])
    RL_InformationIE_RL_ReconfPrepTDD._ext = []
    
    #-----< RL-InformationIE-RL-ReconfPrepTDD-ExtIEs >-----#
    RL_InformationIE_RL_ReconfPrepTDD_ExtIEs = CLASS(name=u'RL-InformationIE-RL-ReconfPrepTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_InformationIE_RL_ReconfPrepTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationReadyFDD >-----#
    RadioLinkReconfigurationReadyFDD = SEQ(name=u'RadioLinkReconfigurationReadyFDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationReadyFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationReadyFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfReadyFDD')))
    _____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationReadyFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationReadyFDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationReadyFDD_protocolIEs._cont = __RadioLinkReconfigurationReadyFDD_protocolIEs__item_
    _RadioLinkReconfigurationReadyFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationReadyFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationReadyFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-Reconfiguration-Permission')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-RL-Reconf-Response')))
    _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    ____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 669), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 800), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 854), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationReadyFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationReadyFDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationReadyFDD_protocolExtensions._cont = __RadioLinkReconfigurationReadyFDD_protocolExtensions__item_
    _RadioLinkReconfigurationReadyFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationReadyFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationReadyFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationReadyFDD_protocolExtensions),
        ])
    RadioLinkReconfigurationReadyFDD._ext = []
    
    #-----< RadioLinkReconfigurationReadyFDD-IEs >-----#
    RadioLinkReconfigurationReadyFDD_IEs = CLASS(name=u'RadioLinkReconfigurationReadyFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationReadyFDD_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfReadyFDD')))
    _RadioLinkReconfigurationReadyFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationReadyFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 135), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationReadyFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationReadyFDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-ReconfReadyFDD >-----#
    RL_InformationResponseList_RL_ReconfReadyFDD = SEQ_OF(name=u'RL-InformationResponseList-RL-ReconfReadyFDD', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_ReconfReadyFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfReadyFDD')))
    ___RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', ____RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__id._const_tab = ___RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__id._const_tab_id = u'id'
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__criticality._const_tab = ___RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__value._const_tab = ___RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_ReconfReadyFDD__item__value._const_tab_id = u'Value'
    _RL_InformationResponseList_RL_ReconfReadyFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationResponseList_RL_ReconfReadyFDD__item__id),
        (u'criticality', __RL_InformationResponseList_RL_ReconfReadyFDD__item__criticality),
        (u'value', __RL_InformationResponseList_RL_ReconfReadyFDD__item__value),
        ])
    _RL_InformationResponseList_RL_ReconfReadyFDD__item_._ext = None
    RL_InformationResponseList_RL_ReconfReadyFDD._cont = _RL_InformationResponseList_RL_ReconfReadyFDD__item_
    RL_InformationResponseList_RL_ReconfReadyFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationResponse-RL-ReconfReadyFDD-IEs >-----#
    RL_InformationResponse_RL_ReconfReadyFDD_IEs = CLASS(name=u'RL-InformationResponse-RL-ReconfReadyFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationResponse_RL_ReconfReadyFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfReadyFDD')))
    RL_InformationResponse_RL_ReconfReadyFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 131), (u'criticality', u'ignore'), (u'Value', _RL_InformationResponse_RL_ReconfReadyFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-ReconfReadyFDD >-----#
    RL_InformationResponseItem_RL_ReconfReadyFDD = SEQ(name=u'RL-InformationResponseItem-RL-ReconfReadyFDD', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_max_UL_SIR = INT(name=u'max-UL-SIR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_min_UL_SIR = INT(name=u'min-UL-SIR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_not_Used_secondary_CCPCH_Info = NULL(name=u'not-Used-secondary-CCPCH-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_dl_CodeInformationList = SEQ(name=u'dl-CodeInformationList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CodeInformationList-RL-ReconfReadyFDD')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_dCHInformationResponse = SEQ(name=u'dCHInformationResponse', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-ReconfReadyFDD')), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_not_Used_dSCHsToBeAddedOrModified = NULL(name=u'not-Used-dSCHsToBeAddedOrModified', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information-Change')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    ____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 519), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 521), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions._cont = __RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item_
    _RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_ReconfReadyFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponseItem_RL_ReconfReadyFDD_rL_ID),
        (u'max-UL-SIR', _RL_InformationResponseItem_RL_ReconfReadyFDD_max_UL_SIR),
        (u'min-UL-SIR', _RL_InformationResponseItem_RL_ReconfReadyFDD_min_UL_SIR),
        (u'maximumDLTxPower', _RL_InformationResponseItem_RL_ReconfReadyFDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponseItem_RL_ReconfReadyFDD_minimumDLTxPower),
        (u'not-Used-secondary-CCPCH-Info', _RL_InformationResponseItem_RL_ReconfReadyFDD_not_Used_secondary_CCPCH_Info),
        (u'dl-CodeInformationList', _RL_InformationResponseItem_RL_ReconfReadyFDD_dl_CodeInformationList),
        (u'dCHInformationResponse', _RL_InformationResponseItem_RL_ReconfReadyFDD_dCHInformationResponse),
        (u'not-Used-dSCHsToBeAddedOrModified', _RL_InformationResponseItem_RL_ReconfReadyFDD_not_Used_dSCHsToBeAddedOrModified),
        (u'iE-Extensions', _RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_ReconfReadyFDD._ext = []
    
    #-----< RL-InformationResponseItem-RL-ReconfReadyFDD-ExtIEs >-----#
    RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs = CLASS(name=u'RL-InformationResponseItem-RL-ReconfReadyFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Primary-CPICH-Usage-For-Channel-Estimation')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_2 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CPICH-Information-Change')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 519), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 521), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_9), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CodeInformationList-RL-ReconfReadyFDD >-----#
    DL_CodeInformationList_RL_ReconfReadyFDD = SEQ(name=u'DL-CodeInformationList-RL-ReconfReadyFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CodeInformationList_RL_ReconfReadyFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CodeInformationList_RL_ReconfReadyFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CodeInformationList_RL_ReconfReadyFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    __DL_CodeInformationList_RL_ReconfReadyFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', ___DL_CodeInformationList_RL_ReconfReadyFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CodeInformationList_RL_ReconfReadyFDD_id._const_tab = __DL_CodeInformationList_RL_ReconfReadyFDD_id_tab
    _DL_CodeInformationList_RL_ReconfReadyFDD_id._const_tab_at = None
    _DL_CodeInformationList_RL_ReconfReadyFDD_id._const_tab_id = u'id'
    _DL_CodeInformationList_RL_ReconfReadyFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CodeInformationList_RL_ReconfReadyFDD_criticality._const_tab = __DL_CodeInformationList_RL_ReconfReadyFDD_id_tab
    _DL_CodeInformationList_RL_ReconfReadyFDD_criticality._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_ReconfReadyFDD_criticality._const_tab_id = u'criticality'
    _DL_CodeInformationList_RL_ReconfReadyFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CodeInformationList_RL_ReconfReadyFDD_value._const_tab = __DL_CodeInformationList_RL_ReconfReadyFDD_id_tab
    _DL_CodeInformationList_RL_ReconfReadyFDD_value._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_ReconfReadyFDD_value._const_tab_id = u'Value'
    DL_CodeInformationList_RL_ReconfReadyFDD._cont = ASN1Dict([
        (u'id', _DL_CodeInformationList_RL_ReconfReadyFDD_id),
        (u'criticality', _DL_CodeInformationList_RL_ReconfReadyFDD_criticality),
        (u'value', _DL_CodeInformationList_RL_ReconfReadyFDD_value),
        ])
    DL_CodeInformationList_RL_ReconfReadyFDD._ext = None
    
    #-----< DL-CodeInformationListIEs-RL-ReconfReadyFDD >-----#
    DL_CodeInformationListIEs_RL_ReconfReadyFDD = CLASS(name=u'DL-CodeInformationListIEs-RL-ReconfReadyFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CodeInformationListIEs_RL_ReconfReadyFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    DL_CodeInformationListIEs_RL_ReconfReadyFDD._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _DL_CodeInformationListIEs_RL_ReconfReadyFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DCH-InformationResponseList-RL-ReconfReadyFDD >-----#
    DCH_InformationResponseList_RL_ReconfReadyFDD = SEQ(name=u'DCH-InformationResponseList-RL-ReconfReadyFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_ReconfReadyFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ___DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_ReconfReadyFDD_id._const_tab = __DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab
    _DCH_InformationResponseList_RL_ReconfReadyFDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_ReconfReadyFDD_id._const_tab_id = u'id'
    _DCH_InformationResponseList_RL_ReconfReadyFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DCH_InformationResponseList_RL_ReconfReadyFDD_criticality._const_tab = __DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab
    _DCH_InformationResponseList_RL_ReconfReadyFDD_criticality._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfReadyFDD_criticality._const_tab_id = u'criticality'
    _DCH_InformationResponseList_RL_ReconfReadyFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DCH_InformationResponseList_RL_ReconfReadyFDD_value._const_tab = __DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab
    _DCH_InformationResponseList_RL_ReconfReadyFDD_value._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfReadyFDD_value._const_tab_id = u'Value'
    DCH_InformationResponseList_RL_ReconfReadyFDD._cont = ASN1Dict([
        (u'id', _DCH_InformationResponseList_RL_ReconfReadyFDD_id),
        (u'criticality', _DCH_InformationResponseList_RL_ReconfReadyFDD_criticality),
        (u'value', _DCH_InformationResponseList_RL_ReconfReadyFDD_value),
        ])
    DCH_InformationResponseList_RL_ReconfReadyFDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-ReconfReadyFDD >-----#
    DCH_InformationResponseListIEs_RL_ReconfReadyFDD = CLASS(name=u'DCH-InformationResponseListIEs-RL-ReconfReadyFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_ReconfReadyFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_ReconfReadyFDD._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _DCH_InformationResponseListIEs_RL_ReconfReadyFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RadioLinkReconfigurationReadyFDD-Extensions >-----#
    RadioLinkReconfigurationReadyFDD_Extensions = CLASS(name=u'RadioLinkReconfigurationReadyFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-Reconfiguration-Permission')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-RL-Reconf-Response')))
    _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    RadioLinkReconfigurationReadyFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 669), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 800), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 854), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-RL-Reconf-Response >-----#
    Additional_HS_Cell_RL_Reconf_Response = SEQ_OF(name=u'Additional-HS-Cell-RL-Reconf-Response', mode=MODE_TYPE)
    _Additional_HS_Cell_RL_Reconf_Response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-RL-Reconf-Response-ItemIEs')))
    Additional_HS_Cell_RL_Reconf_Response._cont = _Additional_HS_Cell_RL_Reconf_Response__item_
    Additional_HS_Cell_RL_Reconf_Response._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-RL-Reconf-Response-ItemIEs >-----#
    Additional_HS_Cell_RL_Reconf_Response_ItemIEs = SEQ(name=u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hSDSCH_RNTI = INT(name=u'hSDSCH-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information-Response', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-Response')))
    _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_RL_Reconf_Response_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hSPDSCH_RL_ID),
        (u'hSDSCH-RNTI', _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hSDSCH_RNTI),
        (u'hS-DSCH-FDD-Secondary-Serving-Information-Response', _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response),
        (u'iE-Extensions', _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_RL_Reconf_Response_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-RL-Reconf-Response-ItemIEs-ExtIEs >-----#
    Additional_HS_Cell_RL_Reconf_Response_ItemIEs_ExtIEs = CLASS(name=u'Additional-HS-Cell-RL-Reconf-Response-ItemIEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_RL_Reconf_Response_ItemIEs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationReadyTDD >-----#
    RadioLinkReconfigurationReadyTDD = SEQ(name=u'RadioLinkReconfigurationReadyTDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationReadyTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationReadyTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-ReconfReadyTDD')))
    _____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 128), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationReadyTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationReadyTDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationReadyTDD_protocolIEs._cont = __RadioLinkReconfigurationReadyTDD_protocolIEs__item_
    _RadioLinkReconfigurationReadyTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationReadyTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationReadyTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-RNTI')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-RL-InformationResponse-RL-ReconfReadyTDD')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_19 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 528), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 861), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 862), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_19), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationReadyTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationReadyTDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationReadyTDD_protocolExtensions._cont = __RadioLinkReconfigurationReadyTDD_protocolExtensions__item_
    _RadioLinkReconfigurationReadyTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationReadyTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationReadyTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationReadyTDD_protocolExtensions),
        ])
    RadioLinkReconfigurationReadyTDD._ext = []
    
    #-----< RadioLinkReconfigurationReadyTDD-IEs >-----#
    RadioLinkReconfigurationReadyTDD_IEs = CLASS(name=u'RadioLinkReconfigurationReadyTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationReadyTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-ReconfReadyTDD')))
    _RadioLinkReconfigurationReadyTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationReadyTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 128), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationReadyTDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationReadyTDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-ReconfReadyTDD >-----#
    RL_InformationResponse_RL_ReconfReadyTDD = SEQ(name=u'RL-InformationResponse-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _RL_InformationResponse_RL_ReconfReadyTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_ReconfReadyTDD_max_UL_SIR = INT(name=u'max-UL-SIR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_min_UL_SIR = INT(name=u'min-UL-SIR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_secondary_CCPCH_Info_TDD = SEQ(name=u'secondary-CCPCH-Info-TDD', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_ul_CCTrCH_Information = SEQ(name=u'ul-CCTrCH-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationList-RL-ReconfReadyTDD')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_dl_CCTrCH_Information = SEQ(name=u'dl-CCTrCH-Information', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-ReconfReadyTDD')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_dCHInformationResponse = SEQ(name=u'dCHInformationResponse', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-ReconfReadyTDD')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_dSCHsToBeAddedOrModified = SEQ(name=u'dSCHsToBeAddedOrModified', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCHToBeAddedOrModified-RL-ReconfReadyTDD')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_uSCHsToBeAddedOrModified = SEQ(name=u'uSCHsToBeAddedOrModified', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCHToBeAddedOrModified-RL-ReconfReadyTDD')), opt=True)
    _RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-Info-TDD')))
    _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD768')))
    _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    ____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 605), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 623), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions._cont = __RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item_
    _RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponse_RL_ReconfReadyTDD_rL_ID),
        (u'max-UL-SIR', _RL_InformationResponse_RL_ReconfReadyTDD_max_UL_SIR),
        (u'min-UL-SIR', _RL_InformationResponse_RL_ReconfReadyTDD_min_UL_SIR),
        (u'maximumDLTxPower', _RL_InformationResponse_RL_ReconfReadyTDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponse_RL_ReconfReadyTDD_minimumDLTxPower),
        (u'secondary-CCPCH-Info-TDD', _RL_InformationResponse_RL_ReconfReadyTDD_secondary_CCPCH_Info_TDD),
        (u'ul-CCTrCH-Information', _RL_InformationResponse_RL_ReconfReadyTDD_ul_CCTrCH_Information),
        (u'dl-CCTrCH-Information', _RL_InformationResponse_RL_ReconfReadyTDD_dl_CCTrCH_Information),
        (u'dCHInformationResponse', _RL_InformationResponse_RL_ReconfReadyTDD_dCHInformationResponse),
        (u'dSCHsToBeAddedOrModified', _RL_InformationResponse_RL_ReconfReadyTDD_dSCHsToBeAddedOrModified),
        (u'uSCHsToBeAddedOrModified', _RL_InformationResponse_RL_ReconfReadyTDD_uSCHsToBeAddedOrModified),
        (u'iE-Extensions', _RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions),
        ])
    RL_InformationResponse_RL_ReconfReadyTDD._ext = []
    
    #-----< RL-InformationResponse-RL-ReconfReadyTDD-ExtIEs >-----#
    RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'RL-InformationResponse-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-LCR-CCPCH-Info-TDD')))
    _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-CCPCH-Info-TDD768')))
    _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 605), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 623), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationList-RL-ReconfReadyTDD >-----#
    UL_CCTrCH_InformationList_RL_ReconfReadyTDD = SEQ(name=u'UL-CCTrCH-InformationList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-ReconfReadyTDD')))
    __UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', ___UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id._const_tab = __UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id._const_tab_at = None
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality._const_tab = __UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_value._const_tab = __UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    UL_CCTrCH_InformationList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id),
        (u'criticality', _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality),
        (u'value', _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_value),
        ])
    UL_CCTrCH_InformationList_RL_ReconfReadyTDD._ext = None
    
    #-----< UL-CCTrCHInformationListIEs-RL-ReconfReadyTDD >-----#
    UL_CCTrCHInformationListIEs_RL_ReconfReadyTDD = CLASS(name=u'UL-CCTrCHInformationListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCHInformationListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCHInformationListIE-RL-ReconfReadyTDD')))
    UL_CCTrCHInformationListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 175), (u'criticality', u'ignore'), (u'Value', _UL_CCTrCHInformationListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCHInformationListIE-RL-ReconfReadyTDD >-----#
    UL_CCTrCHInformationListIE_RL_ReconfReadyTDD = SEQ_OF(name=u'UL-CCTrCHInformationListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_CCTrCHInformationListIE_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD')))
    UL_CCTrCHInformationListIE_RL_ReconfReadyTDD._cont = _UL_CCTrCHInformationListIE_RL_ReconfReadyTDD__item_
    UL_CCTrCHInformationListIE_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItem-RL-ReconfReadyTDD >-----#
    UL_CCTrCH_InformationItem_RL_ReconfReadyTDD = SEQ(name=u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_AddInformation = SEQ(name=u'ul-DPCH-AddInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationAddList-RL-ReconfReadyTDD')), opt=True)
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_ModifyInformation = SEQ(name=u'ul-DPCH-ModifyInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_DeleteInformation = SEQ(name=u'ul-DPCH-DeleteInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD')), opt=True)
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD')))
    _____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationAddList-RL-ReconfReadyTDD768')))
    ____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 98), (u'criticality', u'ignore'), (u'Extension', _____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 619), (u'criticality', u'ignore'), (u'Extension', _____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_cCTrCH_ID),
        (u'ul-DPCH-AddInformation', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_AddInformation),
        (u'ul-DPCH-ModifyInformation', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_ModifyInformation),
        (u'ul-DPCH-DeleteInformation', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_DeleteInformation),
        (u'iE-Extensions', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationItem_RL_ReconfReadyTDD._ext = []
    
    #-----< UL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD')))
    _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationAddList-RL-ReconfReadyTDD768')))
    UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 98), (u'criticality', u'ignore'), (u'Extension', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 619), (u'criticality', u'ignore'), (u'Extension', _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD >-----#
    UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_uL_TimeslotLCR_Info = SEQ_OF(name=u'uL-TimeslotLCR-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimeslotLCR-Information')))
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_tDD_DPCHOffset),
        (u'uL-TimeslotLCR-Info', _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_uL_TimeslotLCR_Info),
        (u'iE-Extensions', _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD._ext = []
    
    #-----< UL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_DPCH_LCR_InformationAddItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_LCR_InformationAddItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationAddList-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationAddList_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-InformationAddList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD')))
    __UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 183), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id._const_tab = __UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id._const_tab_at = None
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality._const_tab = __UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_value._const_tab = __UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    UL_DPCH_InformationAddList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id),
        (u'criticality', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality),
        (u'value', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_value),
        ])
    UL_DPCH_InformationAddList_RL_ReconfReadyTDD._ext = None
    
    #-----< UL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD = CLASS(name=u'UL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD')))
    UL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 183), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-InformationAddListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_rxTimingDeviationForTA = INT(name=u'rxTimingDeviationForTA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTA')), opt=True)
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_uL_Timeslot_Information = SEQ_OF(name=u'uL-Timeslot-Information', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-Information')))
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTAext')))
    ____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 650), (u'criticality', u'ignore'), (u'Extension', _____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_tDD_DPCHOffset),
        (u'rxTimingDeviationForTA', _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_rxTimingDeviationForTA),
        (u'uL-Timeslot-Information', _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_uL_Timeslot_Information),
        (u'iE-Extensions', _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD._ext = []
    
    #-----< UL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTAext')))
    UL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 650), (u'criticality', u'ignore'), (u'Extension', _UL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationAddList-RL-ReconfReadyTDD768 >-----#
    UL_DPCH_InformationAddList_RL_ReconfReadyTDD768 = SEQ(name=u'UL-DPCH-InformationAddList-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_rxTimingDeviationForTA768 = INT(name=u'rxTimingDeviationForTA768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTA768')), opt=True)
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_uL_Timeslot_Information768 = SEQ_OF(name=u'uL-Timeslot-Information768', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-Timeslot-Information768')))
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions._cont = __UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_
    _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationAddList_RL_ReconfReadyTDD768._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_tDD_DPCHOffset),
        (u'rxTimingDeviationForTA768', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_rxTimingDeviationForTA768),
        (u'uL-Timeslot-Information768', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_uL_Timeslot_Information768),
        (u'iE-Extensions', _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions),
        ])
    UL_DPCH_InformationAddList_RL_ReconfReadyTDD768._ext = []
    
    #-----< UL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs >-----#
    UL_DPCH_InformationAddItem_RL_ReconfReadyTDD768_ExtIEs = CLASS(name=u'UL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationAddItem_RL_ReconfReadyTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationModifyList-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationModifyList_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD')))
    __UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 265), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id._const_tab = __UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id._const_tab_at = None
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality._const_tab = __UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value._const_tab = __UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    UL_DPCH_InformationModifyList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id),
        (u'criticality', _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality),
        (u'value', _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value),
        ])
    UL_DPCH_InformationModifyList_RL_ReconfReadyTDD._ext = None
    
    #-----< UL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD = CLASS(name=u'UL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD')))
    UL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 265), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')), opt=True)
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')), opt=True)
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')), opt=True)
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'uL-Timeslot-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD')))
    _____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768')))
    ____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 620), (u'criticality', u'ignore'), (u'Extension', _____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_tDD_DPCHOffset),
        (u'uL-Timeslot-InformationModifyList-RL-ReconfReadyTDD', _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD),
        (u'iE-Extensions', _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD._ext = []
    
    #-----< UL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD')))
    _UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768')))
    UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 100), (u'criticality', u'ignore'), (u'Extension', _UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 620), (u'criticality', u'ignore'), (u'Extension', _UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD >-----#
    UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'UL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD')))
    UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD._cont = _UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD__item_
    UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD >-----#
    UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')), opt=True)
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_uL_Code_LCR_Information = SEQ_OF(name=u'tDD-uL-Code-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-UL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'timeSlotLCR', _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_timeSlotLCR),
        (u'midambleShiftLCR', _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftLCR),
        (u'tFCI-Presence', _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence),
        (u'tDD-uL-Code-LCR-Information', _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_uL_Code_LCR_Information),
        (u'iE-Extensions', _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< TDD-UL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD >-----#
    TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'TDD-UL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD')))
    TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD._cont = _TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD__item_
    TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD >-----#
    TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCodeLCR = SEQ(name=u'tDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCodeLCR')), opt=True)
    _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    ____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 482), (u'criticality', u'reject'), (u'Extension', _____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID),
        (u'tDD-ChannelisationCodeLCR', _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCodeLCR),
        (u'iE-Extensions', _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'TDD-UL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-DPCH-TimeSlotFormat-LCR')))
    TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 482), (u'criticality', u'reject'), (u'Extension', _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD >-----#
    UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD')))
    UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD._cont = _UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD__item_
    UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD >-----#
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_uL_Code_Information = SEQ_OF(name=u'uL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'timeSlot', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_timeSlot),
        (u'midambleShiftAndBurstType', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftAndBurstType),
        (u'tFCI-Presence', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence),
        (u'uL-Code-Information', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_uL_Code_Information),
        (u'iE-Extensions', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD >-----#
    TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD')))
    TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD._cont = _TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD__item_
    TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD >-----#
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID),
        (u'tDD-ChannelisationCode', _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCode),
        (u'iE-Extensions', _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768 >-----#
    UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768 = SEQ_OF(name=u'UL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768')))
    UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768._cont = _UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768__item_
    UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768 >-----#
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768 = SEQ(name=u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_uL_Code_Information768 = SEQ_OF(name=u'uL-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD768')), opt=True)
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._cont = __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_
    _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768._cont = ASN1Dict([
        (u'timeSlot', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_timeSlot),
        (u'midambleShiftAndBurstType768', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_tFCI_Presence),
        (u'uL-Code-Information768', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_uL_Code_Information768),
        (u'iE-Extensions', _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions),
        ])
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768._ext = []
    
    #-----< UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs >-----#
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs = CLASS(name=u'UL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD768 >-----#
    TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768 = SEQ_OF(name=u'TDD-UL-Code-InformationModifyList-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768')))
    TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768._cont = _TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768__item_
    TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768 >-----#
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768 = SEQ(name=u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')), opt=True)
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id),
        (u'criticality', ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._ext = None
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._cont = __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_
    _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_dPCH_ID),
        (u'tDD-ChannelisationCode768', _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_tDD_ChannelisationCode768),
        (u'iE-Extensions', _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions),
        ])
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768._ext = []
    
    #-----< TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs >-----#
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs = CLASS(name=u'TDD-UL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD')))
    __UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', ___UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id._const_tab = __UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id._const_tab_at = None
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality._const_tab = __UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value._const_tab = __UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id),
        (u'criticality', _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality),
        (u'value', _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value),
        ])
    UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD._ext = None
    
    #-----< UL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD = CLASS(name=u'UL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD')))
    UL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 264), (u'criticality', u'ignore'), (u'Value', _UL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD = SEQ_OF(name=u'UL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD')))
    UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD._cont = _UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD__item_
    UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=None, er=[])
    
    #-----< UL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD >-----#
    UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD = SEQ(name=u'UL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions._cont = __UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID', _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_dPCH_ID),
        (u'iE-Extensions', _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD._ext = []
    
    #-----< UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs >-----#
    UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'UL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-RL-ReconfReadyTDD >-----#
    DL_CCTrCH_InformationList_RL_ReconfReadyTDD = SEQ(name=u'DL-CCTrCH-InformationList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-ReconfReadyTDD')))
    __DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', ___DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id._const_tab = __DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id._const_tab_at = None
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality._const_tab = __DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_value._const_tab = __DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    DL_CCTrCH_InformationList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id),
        (u'criticality', _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality),
        (u'value', _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_value),
        ])
    DL_CCTrCH_InformationList_RL_ReconfReadyTDD._ext = None
    
    #-----< DL-CCTrCHInformationListIEs-RL-ReconfReadyTDD >-----#
    DL_CCTrCHInformationListIEs_RL_ReconfReadyTDD = CLASS(name=u'DL-CCTrCHInformationListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCHInformationListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCHInformationListIE-RL-ReconfReadyTDD')))
    DL_CCTrCHInformationListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 45), (u'criticality', u'ignore'), (u'Value', _DL_CCTrCHInformationListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCHInformationListIE-RL-ReconfReadyTDD >-----#
    DL_CCTrCHInformationListIE_RL_ReconfReadyTDD = SEQ_OF(name=u'DL-CCTrCHInformationListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_CCTrCHInformationListIE_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD')))
    DL_CCTrCHInformationListIE_RL_ReconfReadyTDD._cont = _DL_CCTrCHInformationListIE_RL_ReconfReadyTDD__item_
    DL_CCTrCHInformationListIE_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItem-RL-ReconfReadyTDD >-----#
    DL_CCTrCH_InformationItem_RL_ReconfReadyTDD = SEQ(name=u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_AddInformation = SEQ(name=u'dl-DPCH-AddInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationAddList-RL-ReconfReadyTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_ModifyInformation = SEQ(name=u'dl-DPCH-ModifyInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_DeleteInformation = SEQ(name=u'dl-DPCH-DeleteInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD')))
    _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationAddList-RL-ReconfReadyTDD768')))
    _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD')))
    ____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 101), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 504), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 505), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 621), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 644), (u'criticality', u'ignore'), (u'Extension', _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_cCTrCH_ID),
        (u'dl-DPCH-AddInformation', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_AddInformation),
        (u'dl-DPCH-ModifyInformation', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_ModifyInformation),
        (u'dl-DPCH-DeleteInformation', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_DeleteInformation),
        (u'iE-Extensions', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD')))
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationAddList-RL-ReconfReadyTDD768')))
    _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD')))
    DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 101), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 504), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 505), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 621), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 644), (u'criticality', u'ignore'), (u'Extension', _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD >-----#
    DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-LCR-InformationAddList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_dL_TimeslotLCR_Info = SEQ_OF(name=u'dL-TimeslotLCR-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeslotLCR-Information')))
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_tDD_DPCHOffset),
        (u'dL-TimeslotLCR-Info', _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_dL_TimeslotLCR_Info),
        (u'iE-Extensions', _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_DPCH_LCR_InformationAddItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-DPCH-LCR-InformationAddItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_LCR_InformationAddItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationAddList-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationAddList_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationAddList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD')))
    __DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id._const_tab = __DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id._const_tab_at = None
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality._const_tab = __DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_value._const_tab = __DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationAddList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id),
        (u'criticality', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality),
        (u'value', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_value),
        ])
    DL_DPCH_InformationAddList_RL_ReconfReadyTDD._ext = None
    
    #-----< DL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD = CLASS(name=u'DL-DPCH-InformationAddListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD')))
    DL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 212), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationAddListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_dL_Timeslot_Information = SEQ_OF(name=u'dL-Timeslot-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-Information')))
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_tDD_DPCHOffset),
        (u'dL-Timeslot-Information', _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_dL_Timeslot_Information),
        (u'iE-Extensions', _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationAddList-RL-ReconfReadyTDD768 >-----#
    DL_DPCH_InformationAddList_RL_ReconfReadyTDD768 = SEQ(name=u'DL-DPCH-InformationAddList-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_dL_Timeslot_Information768 = SEQ_OF(name=u'dL-Timeslot-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Timeslot-Information768')))
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions._cont = __DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_
    _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationAddList_RL_ReconfReadyTDD768._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_tDD_DPCHOffset),
        (u'dL-Timeslot-Information768', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_dL_Timeslot_Information768),
        (u'iE-Extensions', _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions),
        ])
    DL_DPCH_InformationAddList_RL_ReconfReadyTDD768._ext = []
    
    #-----< DL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs >-----#
    DL_DPCH_InformationAddItem_RL_ReconfReadyTDD768_ExtIEs = CLASS(name=u'DL-DPCH-InformationAddItem-RL-ReconfReadyTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationAddItem_RL_ReconfReadyTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationModifyList-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationModifyList_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD')))
    __DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 214), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id._const_tab = __DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id._const_tab_at = None
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality._const_tab = __DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value._const_tab = __DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationModifyList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id),
        (u'criticality', _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality),
        (u'value', _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value),
        ])
    DL_DPCH_InformationModifyList_RL_ReconfReadyTDD._ext = None
    
    #-----< DL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD = CLASS(name=u'DL-DPCH-InformationModifyListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD')))
    DL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 214), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationModifyListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')), opt=True)
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')), opt=True)
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')), opt=True)
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'dL-Timeslot-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD')))
    _____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768')))
    ____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'ignore'), (u'Extension', _____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 622), (u'criticality', u'ignore'), (u'Extension', _____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_tDD_DPCHOffset),
        (u'dL-Timeslot-InformationModifyList-RL-ReconfReadyTDD', _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD),
        (u'iE-Extensions', _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD')))
    _DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768')))
    DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 104), (u'criticality', u'ignore'), (u'Extension', _DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 622), (u'criticality', u'ignore'), (u'Extension', _DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD >-----#
    DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'DL-TimeslotLCR-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD')))
    DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD._cont = _DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD__item_
    DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD >-----#
    DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')), opt=True)
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_dL_Code_LCR_Information = SEQ_OF(name=u'tDD-dL-Code-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-DL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    ____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 506), (u'criticality', u'ignore'), (u'Extension', _____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 507), (u'criticality', u'ignore'), (u'Extension', _____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'timeSlotLCR', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_timeSlotLCR),
        (u'midambleShiftLCR', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftLCR),
        (u'tFCI-Presence', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence),
        (u'tDD-dL-Code-LCR-Information', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_dL_Code_LCR_Information),
        (u'iE-Extensions', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< TDD-DL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD >-----#
    TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'TDD-DL-Code-LCR-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD')))
    TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD._cont = _TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD__item_
    TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD >-----#
    TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCodeLCR = SEQ(name=u'tDD-ChannelisationCodeLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCodeLCR')), opt=True)
    _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    ____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 481), (u'criticality', u'reject'), (u'Extension', _____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID),
        (u'tDD-ChannelisationCodeLCR', _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCodeLCR),
        (u'iE-Extensions', _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'TDD-DL-Code-LCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 481), (u'criticality', u'reject'), (u'Extension', _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-TimeslotLCR-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 506), (u'criticality', u'ignore'), (u'Extension', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 507), (u'criticality', u'ignore'), (u'Extension', _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD >-----#
    DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD')))
    DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD._cont = _DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD__item_
    DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD >-----#
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_dL_Code_Information = SEQ_OF(name=u'dL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD')), opt=True)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'timeSlot', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_timeSlot),
        (u'midambleShiftAndBurstType', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftAndBurstType),
        (u'tFCI-Presence', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence),
        (u'dL-Code-Information', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_dL_Code_Information),
        (u'iE-Extensions', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD >-----#
    TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD = SEQ_OF(name=u'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD')))
    TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD._cont = _TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD__item_
    TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD >-----#
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD = SEQ(name=u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCode = ENUM(name=u'tDD-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode')), opt=True)
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 481), (u'criticality', u'reject'), (u'Extension', _____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._cont = __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID),
        (u'tDD-ChannelisationCode', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCode),
        (u'iE-Extensions', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD._ext = []
    
    #-----< TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs >-----#
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-DPCH-TimeSlotFormat-LCR')))
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 481), (u'criticality', u'reject'), (u'Extension', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768 >-----#
    DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768 = SEQ_OF(name=u'DL-Timeslot-InformationModifyList-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768')))
    DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768._cont = _DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768__item_
    DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768 >-----#
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768 = SEQ(name=u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_dL_Code_Information768 = SEQ_OF(name=u'dL-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD768')), opt=True)
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._cont = __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_
    _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768._cont = ASN1Dict([
        (u'timeSlot', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_timeSlot),
        (u'midambleShiftAndBurstType768', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_tFCI_Presence),
        (u'dL-Code-Information768', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_dL_Code_Information768),
        (u'iE-Extensions', _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions),
        ])
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768._ext = []
    
    #-----< DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs >-----#
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs = CLASS(name=u'DL-Timeslot-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD768 >-----#
    TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768 = SEQ_OF(name=u'TDD-DL-Code-InformationModifyList-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768')))
    TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768._cont = _TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768__item_
    TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=480)], ev=None, er=[])
    
    #-----< TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768 >-----#
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768 = SEQ(name=u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768', mode=MODE_TYPE)
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_dPCH_ID768 = INT(name=u'dPCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_tDD_ChannelisationCode768 = ENUM(name=u'tDD-ChannelisationCode768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-ChannelisationCode768')), opt=True)
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab = ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_at = None
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab = ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab = ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id),
        (u'criticality', ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue),
        ])
    __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_._ext = None
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._cont = __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_
    _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768._cont = ASN1Dict([
        (u'dPCH-ID768', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_dPCH_ID768),
        (u'tDD-ChannelisationCode768', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_tDD_ChannelisationCode768),
        (u'iE-Extensions', _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions),
        ])
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768._ext = []
    
    #-----< TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs >-----#
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs = CLASS(name=u'TDD-DL-Code-InformationModifyItem-RL-ReconfReadyTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD')))
    __DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id._const_tab = __DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id._const_tab_at = None
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality._const_tab = __DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value._const_tab = __DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id),
        (u'criticality', _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality),
        (u'value', _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value),
        ])
    DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD._ext = None
    
    #-----< DL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD = CLASS(name=u'DL-DPCH-InformationDeleteListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD')))
    DL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 213), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD = SEQ_OF(name=u'DL-DPCH-InformationDeleteListIE-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD')))
    DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD._cont = _DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD__item_
    DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=240)], ev=None, er=[])
    
    #-----< DL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationDeleteItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID', _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_dPCH_ID),
        (u'iE-Extensions', _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationDeleteList-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD = SEQ_OF(name=u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationDeleteItem768-RL-ReconfReadyTDD')))
    DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD._cont = _DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD__item_
    DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=480)], ev=None, er=[])
    
    #-----< DL-DPCH-InformationDeleteItem768-RL-ReconfReadyTDD >-----#
    DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD = SEQ(name=u'DL-DPCH-InformationDeleteItem768-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_dPCH_ID768 = INT(name=u'dPCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions._cont = __DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item_
    _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dPCH-ID768', _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_dPCH_ID768),
        (u'iE-Extensions', _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD._ext = []
    
    #-----< DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD-ExtIEs >-----#
    DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationDeleteList768-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-ReconfReadyTDD >-----#
    DCH_InformationResponseList_RL_ReconfReadyTDD = SEQ(name=u'DCH-InformationResponseList-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ___DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_ReconfReadyTDD_id._const_tab = __DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab
    _DCH_InformationResponseList_RL_ReconfReadyTDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _DCH_InformationResponseList_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DCH_InformationResponseList_RL_ReconfReadyTDD_criticality._const_tab = __DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab
    _DCH_InformationResponseList_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _DCH_InformationResponseList_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DCH_InformationResponseList_RL_ReconfReadyTDD_value._const_tab = __DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab
    _DCH_InformationResponseList_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    DCH_InformationResponseList_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _DCH_InformationResponseList_RL_ReconfReadyTDD_id),
        (u'criticality', _DCH_InformationResponseList_RL_ReconfReadyTDD_criticality),
        (u'value', _DCH_InformationResponseList_RL_ReconfReadyTDD_value),
        ])
    DCH_InformationResponseList_RL_ReconfReadyTDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-ReconfReadyTDD >-----#
    DCH_InformationResponseListIEs_RL_ReconfReadyTDD = CLASS(name=u'DCH-InformationResponseListIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _DCH_InformationResponseListIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCHToBeAddedOrModified-RL-ReconfReadyTDD >-----#
    DSCHToBeAddedOrModified_RL_ReconfReadyTDD = SEQ(name=u'DSCHToBeAddedOrModified-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD')))
    __DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 230), (u'criticality', u'ignore'), (u'Value', ___DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id._const_tab = __DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id._const_tab_at = None
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality._const_tab = __DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_value._const_tab = __DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    DSCHToBeAddedOrModified_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id),
        (u'criticality', _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality),
        (u'value', _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_value),
        ])
    DSCHToBeAddedOrModified_RL_ReconfReadyTDD._ext = None
    
    #-----< DSCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD >-----#
    DSCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD = CLASS(name=u'DSCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DSCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD')))
    DSCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 230), (u'criticality', u'ignore'), (u'Value', _DSCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD >-----#
    DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD = SEQ_OF(name=u'DSCHToBeAddedOrModifiedList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD')))
    DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD._cont = _DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD__item_
    DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD >-----#
    DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD = SEQ(name=u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_dsch_ID = INT(name=u'dsch-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-ID')))
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_dSCH_FlowControlInformation = SEQ_OF(name=u'dSCH-FlowControlInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-FlowControlInformation')))
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions._cont = __DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'dsch-ID', _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_dsch_ID),
        (u'transportFormatManagement', _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportFormatManagement),
        (u'dSCH-FlowControlInformation', _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_dSCH_FlowControlInformation),
        (u'bindingID', _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_bindingID),
        (u'transportLayerAddress', _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportLayerAddress),
        (u'iE-Extensions', _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD._ext = []
    
    #-----< DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs >-----#
    DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'DSCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCHToBeAddedOrModified-RL-ReconfReadyTDD >-----#
    USCHToBeAddedOrModified_RL_ReconfReadyTDD = SEQ(name=u'USCHToBeAddedOrModified-RL-ReconfReadyTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD')))
    __USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', ___USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_id._const_tab = __USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_id._const_tab_at = None
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_id._const_tab_id = u'id'
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality._const_tab = __USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality._const_tab_at = ('..', u'id')
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality._const_tab_id = u'criticality'
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_value._const_tab = __USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_value._const_tab_at = ('..', u'id')
    _USCHToBeAddedOrModified_RL_ReconfReadyTDD_value._const_tab_id = u'Value'
    USCHToBeAddedOrModified_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'id', _USCHToBeAddedOrModified_RL_ReconfReadyTDD_id),
        (u'criticality', _USCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality),
        (u'value', _USCHToBeAddedOrModified_RL_ReconfReadyTDD_value),
        ])
    USCHToBeAddedOrModified_RL_ReconfReadyTDD._ext = None
    
    #-----< USCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD >-----#
    USCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD = CLASS(name=u'USCHToBeAddedOrModifiedIEs-RL-ReconfReadyTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _USCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD')))
    USCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD._val = ASN1Set(rv=[dict([(u'id', 273), (u'criticality', u'ignore'), (u'Value', _USCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD >-----#
    USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD = SEQ_OF(name=u'USCHToBeAddedOrModifiedList-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD')))
    USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD._cont = _USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD__item_
    USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD >-----#
    USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD = SEQ(name=u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_uSCH_ID = INT(name=u'uSCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'USCH-ID')))
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportFormatManagement = ENUM(name=u'transportFormatManagement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportFormatManagement')))
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_bindingID = OCT_STR(name=u'bindingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')), opt=True)
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportLayerAddress = BIT_STR(name=u'transportLayerAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')), opt=True)
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab = ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_at = None
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab = ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab = ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id),
        (u'criticality', ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue),
        ])
    __USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_._ext = None
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions._cont = __USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_
    _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD._cont = ASN1Dict([
        (u'uSCH-ID', _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_uSCH_ID),
        (u'transportFormatManagement', _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportFormatManagement),
        (u'bindingID', _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_bindingID),
        (u'transportLayerAddress', _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportLayerAddress),
        (u'iE-Extensions', _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions),
        ])
    USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD._ext = []
    
    #-----< USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs >-----#
    USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_ExtIEs = CLASS(name=u'USCHToBeAddedOrModifiedItem-RL-ReconfReadyTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationReadyTDD-Extensions >-----#
    RadioLinkReconfigurationReadyTDD_Extensions = CLASS(name=u'RadioLinkReconfigurationReadyTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DSCH-RNTI')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-RL-InformationResponse-RL-ReconfReadyTDD')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_12 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_16 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_18 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_19 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkReconfigurationReadyTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 249), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 528), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 861), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 862), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_19), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiple-RL-InformationResponse-RL-ReconfReadyTDD >-----#
    Multiple_RL_InformationResponse_RL_ReconfReadyTDD = SEQ_OF(name=u'Multiple-RL-InformationResponse-RL-ReconfReadyTDD', mode=MODE_TYPE)
    _Multiple_RL_InformationResponse_RL_ReconfReadyTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-ReconfReadyTDD')))
    Multiple_RL_InformationResponse_RL_ReconfReadyTDD._cont = _Multiple_RL_InformationResponse_RL_ReconfReadyTDD__item_
    Multiple_RL_InformationResponse_RL_ReconfReadyTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RadioLinkReconfigurationCommit >-----#
    RadioLinkReconfigurationCommit = SEQ(name=u'RadioLinkReconfigurationCommit', mode=MODE_TYPE)
    _RadioLinkReconfigurationCommit_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationCommit_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCommit_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCommit_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationCommit_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationCommit_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationCommit_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationCommit_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationCommit_protocolIEs._cont = __RadioLinkReconfigurationCommit_protocolIEs__item_
    _RadioLinkReconfigurationCommit_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationCommit_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationCommit_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-Reconfiguration-Mode')))
    _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationDelay')))
    ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 668), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 974), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationCommit_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationCommit_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationCommit_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationCommit_protocolExtensions._cont = __RadioLinkReconfigurationCommit_protocolExtensions__item_
    _RadioLinkReconfigurationCommit_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationCommit._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationCommit_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationCommit_protocolExtensions),
        ])
    RadioLinkReconfigurationCommit._ext = []
    
    #-----< RadioLinkReconfigurationCommit-IEs >-----#
    RadioLinkReconfigurationCommit_IEs = CLASS(name=u'RadioLinkReconfigurationCommit-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationCommit_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _RadioLinkReconfigurationCommit_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    RadioLinkReconfigurationCommit_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationCommit_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 193), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationCommit_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCommit-Extensions >-----#
    RadioLinkReconfigurationCommit_Extensions = CLASS(name=u'RadioLinkReconfigurationCommit-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationCommit_Extensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Fast-Reconfiguration-Mode')))
    _RadioLinkReconfigurationCommit_Extensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationDelay')))
    RadioLinkReconfigurationCommit_Extensions._val = ASN1Set(rv=[dict([(u'id', 668), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationCommit_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 974), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationCommit_Extensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationFailure >-----#
    RadioLinkReconfigurationFailure = SEQ(name=u'RadioLinkReconfigurationFailure', mode=MODE_TYPE)
    _RadioLinkReconfigurationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-ReconfFailure')))
    _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 199), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationFailure_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationFailure_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationFailure_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationFailure_protocolIEs._cont = __RadioLinkReconfigurationFailure_protocolIEs__item_
    _RadioLinkReconfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationFailure_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationFailure_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationFailure_protocolExtensions._cont = __RadioLinkReconfigurationFailure_protocolExtensions__item_
    _RadioLinkReconfigurationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationFailure._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationFailure_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationFailure_protocolExtensions),
        ])
    RadioLinkReconfigurationFailure._ext = []
    
    #-----< RadioLinkReconfigurationFailure-IEs >-----#
    RadioLinkReconfigurationFailure_IEs = CLASS(name=u'RadioLinkReconfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CauseLevel-RL-ReconfFailure')))
    _RadioLinkReconfigurationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 199), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CauseLevel-RL-ReconfFailure >-----#
    CauseLevel_RL_ReconfFailure = CHOICE(name=u'CauseLevel-RL-ReconfFailure', mode=MODE_TYPE)
    _CauseLevel_RL_ReconfFailure_generalCause = SEQ(name=u'generalCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GeneralCauseList-RL-ReconfFailure')))
    _CauseLevel_RL_ReconfFailure_rLSpecificCause = SEQ(name=u'rLSpecificCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RLSpecificCauseList-RL-ReconfFailure')))
    CauseLevel_RL_ReconfFailure._cont = ASN1Dict([
        (u'generalCause', _CauseLevel_RL_ReconfFailure_generalCause),
        (u'rLSpecificCause', _CauseLevel_RL_ReconfFailure_rLSpecificCause),
        ])
    CauseLevel_RL_ReconfFailure._ext = []
    
    #-----< GeneralCauseList-RL-ReconfFailure >-----#
    GeneralCauseList_RL_ReconfFailure = SEQ(name=u'GeneralCauseList-RL-ReconfFailure', mode=MODE_TYPE)
    _GeneralCauseList_RL_ReconfFailure_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _GeneralCauseList_RL_ReconfFailure_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab = ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_at = None
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_id = u'id'
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab = ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab = ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id),
        (u'criticality', ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality),
        (u'extensionValue', ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue),
        ])
    __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_._ext = None
    _GeneralCauseList_RL_ReconfFailure_iE_Extensions._cont = __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_
    _GeneralCauseList_RL_ReconfFailure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeneralCauseList_RL_ReconfFailure._cont = ASN1Dict([
        (u'cause', _GeneralCauseList_RL_ReconfFailure_cause),
        (u'iE-Extensions', _GeneralCauseList_RL_ReconfFailure_iE_Extensions),
        ])
    GeneralCauseList_RL_ReconfFailure._ext = []
    
    #-----< GeneralCauseItem-RL-ReconfFailure-ExtIEs >-----#
    GeneralCauseItem_RL_ReconfFailure_ExtIEs = CLASS(name=u'GeneralCauseItem-RL-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GeneralCauseItem_RL_ReconfFailure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLSpecificCauseList-RL-ReconfFailure >-----#
    RLSpecificCauseList_RL_ReconfFailure = SEQ(name=u'RLSpecificCauseList-RL-ReconfFailure', mode=MODE_TYPE)
    _RLSpecificCauseList_RL_ReconfFailure_rL_ReconfigurationFailureList_RL_ReconfFailure = SEQ_OF(name=u'rL-ReconfigurationFailureList-RL-ReconfFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationFailureList-RL-ReconfFailure')), opt=True)
    _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab = ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_at = None
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id._const_tab_id = u'id'
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab = ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab = ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id),
        (u'criticality', ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality),
        (u'extensionValue', ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue),
        ])
    __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_._ext = None
    _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions._cont = __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_
    _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RLSpecificCauseList_RL_ReconfFailure._cont = ASN1Dict([
        (u'rL-ReconfigurationFailureList-RL-ReconfFailure', _RLSpecificCauseList_RL_ReconfFailure_rL_ReconfigurationFailureList_RL_ReconfFailure),
        (u'iE-Extensions', _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions),
        ])
    RLSpecificCauseList_RL_ReconfFailure._ext = []
    
    #-----< RLSpecificCauseItem-RL-ReconfFailure-ExtIEs >-----#
    RLSpecificCauseItem_RL_ReconfFailure_ExtIEs = CLASS(name=u'RLSpecificCauseItem-RL-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLSpecificCauseItem_RL_ReconfFailure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-ReconfigurationFailureList-RL-ReconfFailure >-----#
    RL_ReconfigurationFailureList_RL_ReconfFailure = SEQ_OF(name=u'RL-ReconfigurationFailureList-RL-ReconfFailure', mode=MODE_TYPE)
    _RL_ReconfigurationFailureList_RL_ReconfFailure__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationFailure-RL-ReconfFail')))
    ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', ____RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id._const_tab = ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id._const_tab_at = None
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id._const_tab_id = u'id'
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality._const_tab = ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality._const_tab_at = ('..', u'id')
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality._const_tab_id = u'criticality'
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value._const_tab = ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value._const_tab_at = ('..', u'id')
    __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value._const_tab_id = u'Value'
    _RL_ReconfigurationFailureList_RL_ReconfFailure__item_._cont = ASN1Dict([
        (u'id', __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id),
        (u'criticality', __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality),
        (u'value', __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value),
        ])
    _RL_ReconfigurationFailureList_RL_ReconfFailure__item_._ext = None
    RL_ReconfigurationFailureList_RL_ReconfFailure._cont = _RL_ReconfigurationFailureList_RL_ReconfFailure__item_
    RL_ReconfigurationFailureList_RL_ReconfFailure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RL-ReconfigurationFailure-RL-ReconfFailure-IEs >-----#
    RL_ReconfigurationFailure_RL_ReconfFailure_IEs = CLASS(name=u'RL-ReconfigurationFailure-RL-ReconfFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_ReconfigurationFailure_RL_ReconfFailure_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationFailure-RL-ReconfFail')))
    RL_ReconfigurationFailure_RL_ReconfFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 141), (u'criticality', u'ignore'), (u'Value', _RL_ReconfigurationFailure_RL_ReconfFailure_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-ReconfigurationFailure-RL-ReconfFail >-----#
    RL_ReconfigurationFailure_RL_ReconfFail = SEQ(name=u'RL-ReconfigurationFailure-RL-ReconfFail', mode=MODE_TYPE)
    _RL_ReconfigurationFailure_RL_ReconfFail_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_ReconfigurationFailure_RL_ReconfFail_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    ____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id._const_tab = ____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id._const_tab_at = None
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__criticality._const_tab = ____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__extensionValue._const_tab = ____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id),
        (u'criticality', ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__extensionValue),
        ])
    __RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item_._ext = None
    _RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions._cont = __RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item_
    _RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_ReconfigurationFailure_RL_ReconfFail._cont = ASN1Dict([
        (u'rL-ID', _RL_ReconfigurationFailure_RL_ReconfFail_rL_ID),
        (u'cause', _RL_ReconfigurationFailure_RL_ReconfFail_cause),
        (u'iE-Extensions', _RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions),
        ])
    RL_ReconfigurationFailure_RL_ReconfFail._ext = []
    
    #-----< RL-ReconfigurationFailure-RL-ReconfFailure-ExtIEs >-----#
    RL_ReconfigurationFailure_RL_ReconfFailure_ExtIEs = CLASS(name=u'RL-ReconfigurationFailure-RL-ReconfFailure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_ReconfigurationFailure_RL_ReconfFailure_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    RL_ReconfigurationFailure_RL_ReconfFailure_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationFailure_RL_ReconfFailure_ExtIEs_val_Extension_0), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationFailure-Extensions >-----#
    RadioLinkReconfigurationFailure_Extensions = CLASS(name=u'RadioLinkReconfigurationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkReconfigurationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCancel >-----#
    RadioLinkReconfigurationCancel = SEQ(name=u'RadioLinkReconfigurationCancel', mode=MODE_TYPE)
    _RadioLinkReconfigurationCancel_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCancel_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationCancel_protocolIEs__item__criticality_tab
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__value_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RadioLinkReconfigurationCancel_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationCancel_protocolIEs__item__value_tab
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCancel_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationCancel_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationCancel_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationCancel_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationCancel_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationCancel_protocolIEs._cont = __RadioLinkReconfigurationCancel_protocolIEs__item_
    _RadioLinkReconfigurationCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationCancel_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationCancel_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationCancel_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationCancel_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationCancel_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationCancel_protocolExtensions._cont = __RadioLinkReconfigurationCancel_protocolExtensions__item_
    _RadioLinkReconfigurationCancel_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationCancel._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationCancel_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationCancel_protocolExtensions),
        ])
    RadioLinkReconfigurationCancel._ext = []
    
    #-----< RadioLinkReconfigurationCancel-IEs >-----#
    RadioLinkReconfigurationCancel_IEs = CLASS(name=u'RadioLinkReconfigurationCancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    RadioLinkReconfigurationCancel_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationCancel-Extensions >-----#
    RadioLinkReconfigurationCancel_Extensions = CLASS(name=u'RadioLinkReconfigurationCancel-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkReconfigurationCancel_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestFDD >-----#
    RadioLinkReconfigurationRequestFDD = SEQ(name=u'RadioLinkReconfigurationRequestFDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationRequestFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstFDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 178), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 255), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationRequestFDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationRequestFDD_protocolIEs._cont = __RadioLinkReconfigurationRequestFDD_protocolIEs__item_
    _RadioLinkReconfigurationRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationRequestFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationRequestFDD-RL-InformationList')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-ReferencePowerInformation')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDPCH-Information-RLReconfRequest-FDD')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information-To-Modify')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-Information')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NoOfTargetCellHS-SCCH-Order')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Req')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Req')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_18 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information-Reconf')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_19 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_20 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_21 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_22 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 318), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 452), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 533), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 585), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 583), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 582), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 584), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 673), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 792), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 799), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 842), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 907), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 969), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 984), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_22), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationRequestFDD_protocolExtensions._cont = __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_
    _RadioLinkReconfigurationRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationRequestFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationRequestFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationRequestFDD_protocolExtensions),
        ])
    RadioLinkReconfigurationRequestFDD._ext = []
    
    #-----< RadioLinkReconfigurationRequestFDD-IEs >-----#
    RadioLinkReconfigurationRequestFDD_IEs = CLASS(name=u'RadioLinkReconfigurationRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-Information-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-Information-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-FDD-Information')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstFDD')))
    _RadioLinkReconfigurationRequestFDD_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    RadioLinkReconfigurationRequestFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 178), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 61), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 39), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 26), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 32), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 255), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestFDD_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-Information-RL-ReconfRqstFDD >-----#
    UL_DPCH_Information_RL_ReconfRqstFDD = SEQ(name=u'UL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _UL_DPCH_Information_RL_ReconfRqstFDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPDCHIndicatorEDCH')))
    ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 573), (u'criticality', u'reject'), (u'Extension', _____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._cont = __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_
    _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_Information_RL_ReconfRqstFDD._cont = ASN1Dict([
        (u'tFCS', _UL_DPCH_Information_RL_ReconfRqstFDD_tFCS),
        (u'iE-Extensions', _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions),
        ])
    UL_DPCH_Information_RL_ReconfRqstFDD._ext = []
    
    #-----< UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs >-----#
    UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs = CLASS(name=u'UL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPDCHIndicatorEDCH')))
    UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 573), (u'criticality', u'reject'), (u'Extension', _UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-Information-RL-ReconfRqstFDD >-----#
    DL_DPCH_Information_RL_ReconfRqstFDD = SEQ(name=u'DL-DPCH-Information-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _DL_DPCH_Information_RL_ReconfRqstFDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _DL_DPCH_Information_RL_ReconfRqstFDD_tFCI_SignallingMode = ENUM(name=u'tFCI-SignallingMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-SignallingMode')), opt=True)
    _DL_DPCH_Information_RL_ReconfRqstFDD_limitedPowerIncrease = ENUM(name=u'limitedPowerIncrease', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'LimitedPowerIncrease')), opt=True)
    _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._cont = __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_
    _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_Information_RL_ReconfRqstFDD._cont = ASN1Dict([
        (u'tFCS', _DL_DPCH_Information_RL_ReconfRqstFDD_tFCS),
        (u'tFCI-SignallingMode', _DL_DPCH_Information_RL_ReconfRqstFDD_tFCI_SignallingMode),
        (u'limitedPowerIncrease', _DL_DPCH_Information_RL_ReconfRqstFDD_limitedPowerIncrease),
        (u'iE-Extensions', _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions),
        ])
    DL_DPCH_Information_RL_ReconfRqstFDD._ext = []
    
    #-----< DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs >-----#
    DL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs = CLASS(name=u'DL-DPCH-Information-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfRqstFDD >-----#
    DCH_DeleteList_RL_ReconfRqstFDD = SEQ_OF(name=u'DCH-DeleteList-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfRqstFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfRqstFDD')))
    DCH_DeleteList_RL_ReconfRqstFDD._cont = _DCH_DeleteList_RL_ReconfRqstFDD__item_
    DCH_DeleteList_RL_ReconfRqstFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfRqstFDD >-----#
    DCH_DeleteItem_RL_ReconfRqstFDD = SEQ(name=u'DCH-DeleteItem-RL-ReconfRqstFDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfRqstFDD_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfRqstFDD._cont = ASN1Dict([
        (u'dCH-ID', _DCH_DeleteItem_RL_ReconfRqstFDD_dCH_ID),
        (u'iE-Extensions', _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfRqstFDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfRqstFDD_ExtIEs = CLASS(name=u'DCH-DeleteItem-RL-ReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestFDD-Extensions >-----#
    RadioLinkReconfigurationRequestFDD_Extensions = CLASS(name=u'RadioLinkReconfigurationRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationRequestFDD-RL-InformationList')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-ReferencePowerInformation')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDPCH-Information-RLReconfRequest-FDD')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-Information-To-Modify')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_11 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlows-To-Delete')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_12 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-Serving-RL')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-Information')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NoOfTargetCellHS-SCCH-Order')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Req')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_17 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Reconf-Req')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_18 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-Information-Reconf')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_19 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Decoupling-Indication')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_20 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Radio-Links-without-DPCH-FDPCH-Indication')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_21 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-DPCCH2-Information-Reconf')))
    _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_22 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    RadioLinkReconfigurationRequestFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 318), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 299), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 452), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 533), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 585), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 577), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 583), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 582), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 584), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 579), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 673), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 792), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 799), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 828), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 842), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 907), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_18), (u'presence', u'optional')]), dict([(u'id', 954), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_19), (u'presence', u'optional')]), dict([(u'id', 967), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_20), (u'presence', u'optional')]), dict([(u'id', 969), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_21), (u'presence', u'optional')]), dict([(u'id', 984), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_22), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Req >-----#
    Additional_HS_Cell_Information_RL_Reconf_Req = SEQ_OF(name=u'Additional-HS-Cell-Information-RL-Reconf-Req', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Req__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs')))
    Additional_HS_Cell_Information_RL_Reconf_Req._cont = _Additional_HS_Cell_Information_RL_Reconf_Req__item_
    Additional_HS_Cell_Information_RL_Reconf_Req._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs = SEQ(name=u'Additional-HS-Cell-Information-RL-Reconf-Req-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_Secondary_Serving_Remove = NULL(name=u'hS-DSCH-Secondary-Serving-Remove', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Secondary-Serving-Remove')), opt=True)
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hSPDSCH_RL_ID),
        (u'c-ID', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_c_ID),
        (u'hS-DSCH-FDD-Secondary-Serving-Information', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information),
        (u'hS-DSCH-FDD-Secondary-Serving-Information-To-Modify-Unsynchronised', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised),
        (u'hS-DSCH-Secondary-Serving-Remove', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_Secondary_Serving_Remove),
        (u'iE-Extensions', _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Reconf_Req_ExtIEs = CLASS(name=u'Additional-HS-Cell-Information-RL-Reconf-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Reconf_Req_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Req >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Req = SEQ(name=u'Additional-EDCH-Cell-Information-RL-Reconf-Req', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency = CHOICE(name=u'setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency')))
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Reconf_Req._cont = ASN1Dict([
        (u'setup-Or-ConfigurationChange-Or-Removal-Of-EDCH-On-secondary-UL-Frequency', _Additional_EDCH_Cell_Information_RL_Reconf_Req_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Reconf_Req._ext = []
    
    #-----< Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs >-----#
    Additional_EDCH_Cell_Information_RL_Reconf_Req_ExtIEs = CLASS(name=u'Additional-EDCH-Cell-Information-RL-Reconf-Req-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_Cell_Information_RL_Reconf_Req_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-ReconfigurationRequestFDD-RL-InformationList >-----#
    RL_ReconfigurationRequestFDD_RL_InformationList = SEQ_OF(name=u'RL-ReconfigurationRequestFDD-RL-InformationList', mode=MODE_TYPE)
    _RL_ReconfigurationRequestFDD_RL_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationRequestFDD-RL-Information-IEs')))
    ___RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 319), (u'criticality', u'ignore'), (u'Value', ____RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__id._const_tab = ___RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__id._const_tab_at = None
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__id._const_tab_id = u'id'
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__criticality._const_tab = ___RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__criticality._const_tab_at = ('..', u'id')
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__criticality._const_tab_id = u'criticality'
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__value._const_tab = ___RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__value._const_tab_at = ('..', u'id')
    __RL_ReconfigurationRequestFDD_RL_InformationList__item__value._const_tab_id = u'Value'
    _RL_ReconfigurationRequestFDD_RL_InformationList__item_._cont = ASN1Dict([
        (u'id', __RL_ReconfigurationRequestFDD_RL_InformationList__item__id),
        (u'criticality', __RL_ReconfigurationRequestFDD_RL_InformationList__item__criticality),
        (u'value', __RL_ReconfigurationRequestFDD_RL_InformationList__item__value),
        ])
    _RL_ReconfigurationRequestFDD_RL_InformationList__item_._ext = None
    RL_ReconfigurationRequestFDD_RL_InformationList._cont = _RL_ReconfigurationRequestFDD_RL_InformationList__item_
    RL_ReconfigurationRequestFDD_RL_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RL-ReconfigurationRequestFDD-RL-Information-ListItem >-----#
    RL_ReconfigurationRequestFDD_RL_Information_ListItem = CLASS(name=u'RL-ReconfigurationRequestFDD-RL-Information-ListItem', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_ReconfigurationRequestFDD_RL_Information_ListItem_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationRequestFDD-RL-Information-IEs')))
    RL_ReconfigurationRequestFDD_RL_Information_ListItem._val = ASN1Set(rv=[dict([(u'id', 319), (u'criticality', u'ignore'), (u'Value', _RL_ReconfigurationRequestFDD_RL_Information_ListItem_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< RL-ReconfigurationRequestFDD-RL-Information-IEs >-----#
    RL_ReconfigurationRequestFDD_RL_Information_IEs = SEQ(name=u'RL-ReconfigurationRequestFDD-RL-Information-IEs', mode=MODE_TYPE)
    _RL_ReconfigurationRequestFDD_RL_Information_IEs_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_ReconfigurationRequestFDD_RL_Information_IEs_rL_Specific_DCH_Info = SEQ_OF(name=u'rL-Specific-DCH-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')), opt=True)
    _RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Reconf')))
    _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    ____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 874), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 912), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 984), (u'criticality', u'reject'), (u'Extension', _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id._const_tab = ____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id._const_tab_at = None
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__criticality._const_tab = ____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__extensionValue._const_tab = ____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id),
        (u'criticality', ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__extensionValue),
        ])
    __RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item_._ext = None
    _RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions._cont = __RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item_
    _RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_ReconfigurationRequestFDD_RL_Information_IEs._cont = ASN1Dict([
        (u'rL-ID', _RL_ReconfigurationRequestFDD_RL_Information_IEs_rL_ID),
        (u'rL-Specific-DCH-Info', _RL_ReconfigurationRequestFDD_RL_Information_IEs_rL_Specific_DCH_Info),
        (u'iE-Extensions', _RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions),
        ])
    RL_ReconfigurationRequestFDD_RL_Information_IEs._ext = []
    
    #-----< RL-ReconfigurationRequestFDD-RL-Information-ExtIEs >-----#
    RL_ReconfigurationRequestFDD_RL_Information_ExtIEs = CLASS(name=u'RL-ReconfigurationRequestFDD-RL-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-EDCH-Information')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-RL-Indication')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationSetup')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Setup')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Reconf')))
    _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Downlink-TPC-enhancements-Reconf')))
    RL_ReconfigurationRequestFDD_RL_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 575), (u'criticality', u'reject'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 576), (u'criticality', u'reject'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 790), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 873), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 874), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 912), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 984), (u'criticality', u'reject'), (u'Extension', _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestTDD >-----#
    RadioLinkReconfigurationRequestTDD = SEQ(name=u'RadioLinkReconfigurationRequestTDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationRequestTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-Modify')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstTDD')))
    ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 52), (u'criticality', u'notify'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'reject'), (u'Value', _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationRequestTDD_protocolIEs._cont = __RadioLinkReconfigurationRequestTDD_protocolIEs__item_
    _RadioLinkReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-RL-ReconfigurationRequestTDD-RL-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Reconfig')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-InformationLCR')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNTI-Allocation-Indicator')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 321), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 533), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 657), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 660), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 678), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 810), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 863), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 885), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationRequestTDD_protocolExtensions._cont = __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_
    _RadioLinkReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationRequestTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationRequestTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationRequestTDD_protocolExtensions),
        ])
    RadioLinkReconfigurationRequestTDD._ext = []
    
    #-----< RadioLinkReconfigurationRequestTDD-IEs >-----#
    RadioLinkReconfigurationRequestTDD_IEs = CLASS(name=u'RadioLinkReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DCHs-to-Modify')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_6 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-TDD-Information')))
    _RadioLinkReconfigurationRequestTDD_IEs_val_Value_7 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteList-RL-ReconfRqstTDD')))
    RadioLinkReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 261), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 263), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 210), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 52), (u'criticality', u'notify'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 40), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 27), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 33), (u'criticality', u'reject'), (u'Value', _RadioLinkReconfigurationRequestTDD_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = SEQ_OF(name=u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._ext = None
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._cont = _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs >-----#
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs = CLASS(name=u'UL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 258), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = SEQ(name=u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Extension', _____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID),
        (u'tFCS', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS),
        (u'iE-Extensions', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')))
    UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 184), (u'criticality', u'reject'), (u'Extension', _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = SEQ_OF(name=u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 262), (u'criticality', u'notify'), (u'Value', ____UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_id = u'id'
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_id = u'criticality'
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab = ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', u'id')
    __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_id = u'Value'
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        (u'id', __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id),
        (u'criticality', __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality),
        (u'value', __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value),
        ])
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._ext = None
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._cont = _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs >-----#
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs = CLASS(name=u'UL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 262), (u'criticality', u'notify'), (u'Value', _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = SEQ(name=u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID),
        (u'iE-Extensions', _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD = SEQ_OF(name=u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 207), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_._ext = None
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._cont = _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs >-----#
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs = CLASS(name=u'DL-CCTrCH-InformationModifyList-RL-ReconfRqstTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD')))
    DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 207), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD = SEQ(name=u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS = SEQ(name=u'tFCS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCS')), opt=True)
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID),
        (u'tFCS', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS),
        (u'iE-Extensions', _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationModifyItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD = SEQ_OF(name=u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 46), (u'criticality', u'notify'), (u'Value', ____DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_at = None
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id._const_tab_id = u'id'
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality._const_tab_id = u'criticality'
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab = ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_at = ('..', u'id')
    __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value._const_tab_id = u'Value'
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._cont = ASN1Dict([
        (u'id', __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id),
        (u'criticality', __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality),
        (u'value', __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value),
        ])
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_._ext = None
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._cont = _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs >-----#
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs = CLASS(name=u'DL-CCTrCH-InformationDeleteList-RL-ReconfRqstTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD')))
    DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 46), (u'criticality', u'notify'), (u'Value', _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD = SEQ(name=u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID),
        (u'iE-Extensions', _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationDeleteItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-DeleteList-RL-ReconfRqstTDD >-----#
    DCH_DeleteList_RL_ReconfRqstTDD = SEQ_OF(name=u'DCH-DeleteList-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DCH_DeleteList_RL_ReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-DeleteItem-RL-ReconfRqstTDD')))
    DCH_DeleteList_RL_ReconfRqstTDD._cont = _DCH_DeleteList_RL_ReconfRqstTDD__item_
    DCH_DeleteList_RL_ReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=128)], ev=None, er=[])
    
    #-----< DCH-DeleteItem-RL-ReconfRqstTDD >-----#
    DCH_DeleteItem_RL_ReconfRqstTDD = SEQ(name=u'DCH-DeleteItem-RL-ReconfRqstTDD', mode=MODE_TYPE)
    _DCH_DeleteItem_RL_ReconfRqstTDD_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_._ext = None
    _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions._cont = __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_
    _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_DeleteItem_RL_ReconfRqstTDD._cont = ASN1Dict([
        (u'dCH-ID', _DCH_DeleteItem_RL_ReconfRqstTDD_dCH_ID),
        (u'iE-Extensions', _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions),
        ])
    DCH_DeleteItem_RL_ReconfRqstTDD._ext = []
    
    #-----< DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs >-----#
    DCH_DeleteItem_RL_ReconfRqstTDD_ExtIEs = CLASS(name=u'DCH-DeleteItem-RL-ReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_DeleteItem_RL_ReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationRequestTDD-Extensions >-----#
    RadioLinkReconfigurationRequestTDD_Extensions = CLASS(name=u'RadioLinkReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-RL-ReconfigurationRequestTDD-RL-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Information-to-Modify-Unsynchronised')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-Information')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlows-to-Delete')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Reconfig')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Reconfig')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Reconfig')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-InformationLCR')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_11 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNTI-Allocation-Indicator')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_12 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementType-Indicator')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_13 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Reconfigure')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-Indicator')))
    _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_15 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-Support-of-non-rectangular-resource-allocation')))
    RadioLinkReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 321), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 458), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 533), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 531), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 532), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 463), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 657), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 656), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 660), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 678), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 810), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 863), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 866), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 885), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 889), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 947), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_15), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiple-RL-ReconfigurationRequestTDD-RL-Information >-----#
    Multiple_RL_ReconfigurationRequestTDD_RL_Information = SEQ_OF(name=u'Multiple-RL-ReconfigurationRequestTDD-RL-Information', mode=MODE_TYPE)
    _Multiple_RL_ReconfigurationRequestTDD_RL_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ReconfigurationRequestTDD-RL-Information')))
    Multiple_RL_ReconfigurationRequestTDD_RL_Information._cont = _Multiple_RL_ReconfigurationRequestTDD_RL_Information__item_
    Multiple_RL_ReconfigurationRequestTDD_RL_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-ReconfigurationRequestTDD-RL-Information >-----#
    RL_ReconfigurationRequestTDD_RL_Information = SEQ(name=u'RL-ReconfigurationRequestTDD-RL-Information', mode=MODE_TYPE)
    _RL_ReconfigurationRequestTDD_RL_Information_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_ReconfigurationRequestTDD_RL_Information_rL_Specific_DCH_Info = SEQ_OF(name=u'rL-Specific-DCH-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Specific-DCH-Info')), opt=True)
    _RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeedforIdleInterval')))
    ____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 464), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 805), (u'criticality', u'ignore'), (u'Extension', _____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id._const_tab = ____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id._const_tab_at = None
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__criticality._const_tab = ____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__extensionValue._const_tab = ____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id),
        (u'criticality', ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__extensionValue),
        ])
    __RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item_._ext = None
    _RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions._cont = __RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item_
    _RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_ReconfigurationRequestTDD_RL_Information._cont = ASN1Dict([
        (u'rL-ID', _RL_ReconfigurationRequestTDD_RL_Information_rL_ID),
        (u'rL-Specific-DCH-Info', _RL_ReconfigurationRequestTDD_RL_Information_rL_Specific_DCH_Info),
        (u'iE-Extensions', _RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions),
        ])
    RL_ReconfigurationRequestTDD_RL_Information._ext = []
    
    #-----< RL-ReconfigurationRequestTDD-RL-Information-ExtIEs >-----#
    RL_ReconfigurationRequestTDD_RL_Information_ExtIEs = CLASS(name=u'RL-ReconfigurationRequestTDD-RL-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_ReconfigurationRequestTDD_RL_Information_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-Synchronisation-Parameters-LCR')))
    _RL_ReconfigurationRequestTDD_RL_Information_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeedforIdleInterval')))
    RL_ReconfigurationRequestTDD_RL_Information_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 464), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationRequestTDD_RL_Information_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 805), (u'criticality', u'ignore'), (u'Extension', _RL_ReconfigurationRequestTDD_RL_Information_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationResponseFDD >-----#
    RadioLinkReconfigurationResponseFDD = SEQ(name=u'RadioLinkReconfigurationResponseFDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationResponseFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationResponseFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfRspFDD')))
    _____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationResponseFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationResponseFDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationResponseFDD_protocolIEs._cont = __RadioLinkReconfigurationResponseFDD_protocolIEs__item_
    _RadioLinkReconfigurationResponseFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationResponseFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationResponseFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    ____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 795), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 854), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationResponseFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationResponseFDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationResponseFDD_protocolExtensions._cont = __RadioLinkReconfigurationResponseFDD_protocolExtensions__item_
    _RadioLinkReconfigurationResponseFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationResponseFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationResponseFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationResponseFDD_protocolExtensions),
        ])
    RadioLinkReconfigurationResponseFDD._ext = []
    
    #-----< RadioLinkReconfigurationResponseFDD-IEs >-----#
    RadioLinkReconfigurationResponseFDD_IEs = CLASS(name=u'RadioLinkReconfigurationResponseFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationResponseFDD_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseList-RL-ReconfRspFDD')))
    _RadioLinkReconfigurationResponseFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationResponseFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 136), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationResponseFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationResponseFDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponseList-RL-ReconfRspFDD >-----#
    RL_InformationResponseList_RL_ReconfRspFDD = SEQ_OF(name=u'RL-InformationResponseList-RL-ReconfRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseList_RL_ReconfRspFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationResponseList_RL_ReconfRspFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfRspFDD')))
    ___RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', ____RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationResponseList_RL_ReconfRspFDD__item__id._const_tab = ___RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab
    __RL_InformationResponseList_RL_ReconfRspFDD__item__id._const_tab_at = None
    __RL_InformationResponseList_RL_ReconfRspFDD__item__id._const_tab_id = u'id'
    __RL_InformationResponseList_RL_ReconfRspFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationResponseList_RL_ReconfRspFDD__item__criticality._const_tab = ___RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab
    __RL_InformationResponseList_RL_ReconfRspFDD__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_ReconfRspFDD__item__criticality._const_tab_id = u'criticality'
    __RL_InformationResponseList_RL_ReconfRspFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationResponseList_RL_ReconfRspFDD__item__value._const_tab = ___RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab
    __RL_InformationResponseList_RL_ReconfRspFDD__item__value._const_tab_at = ('..', u'id')
    __RL_InformationResponseList_RL_ReconfRspFDD__item__value._const_tab_id = u'Value'
    _RL_InformationResponseList_RL_ReconfRspFDD__item_._cont = ASN1Dict([
        (u'id', __RL_InformationResponseList_RL_ReconfRspFDD__item__id),
        (u'criticality', __RL_InformationResponseList_RL_ReconfRspFDD__item__criticality),
        (u'value', __RL_InformationResponseList_RL_ReconfRspFDD__item__value),
        ])
    _RL_InformationResponseList_RL_ReconfRspFDD__item_._ext = None
    RL_InformationResponseList_RL_ReconfRspFDD._cont = _RL_InformationResponseList_RL_ReconfRspFDD__item_
    RL_InformationResponseList_RL_ReconfRspFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationResponse-RL-ReconfRspFDD-IEs >-----#
    RL_InformationResponse_RL_ReconfRspFDD_IEs = CLASS(name=u'RL-InformationResponse-RL-ReconfRspFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationResponse_RL_ReconfRspFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponseItem-RL-ReconfRspFDD')))
    RL_InformationResponse_RL_ReconfRspFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 132), (u'criticality', u'ignore'), (u'Value', _RL_InformationResponse_RL_ReconfRspFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationResponseItem-RL-ReconfRspFDD >-----#
    RL_InformationResponseItem_RL_ReconfRspFDD = SEQ(name=u'RL-InformationResponseItem-RL-ReconfRspFDD', mode=MODE_TYPE)
    _RL_InformationResponseItem_RL_ReconfRspFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_max_UL_SIR = INT(name=u'max-UL-SIR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_min_UL_SIR = INT(name=u'min-UL-SIR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_not_Used_secondary_CCPCH_Info = NULL(name=u'not-Used-secondary-CCPCH-Info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_dCHsInformationResponseList = SEQ(name=u'dCHsInformationResponseList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-ReconfRspFDD')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_dL_CodeInformationList_RL_ReconfResp = SEQ(name=u'dL-CodeInformationList-RL-ReconfResp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CodeInformationList-RL-ReconfRspFDD')), opt=True)
    _RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    ____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item_._ext = None
    _RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions._cont = __RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item_
    _RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponseItem_RL_ReconfRspFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponseItem_RL_ReconfRspFDD_rL_ID),
        (u'max-UL-SIR', _RL_InformationResponseItem_RL_ReconfRspFDD_max_UL_SIR),
        (u'min-UL-SIR', _RL_InformationResponseItem_RL_ReconfRspFDD_min_UL_SIR),
        (u'maximumDLTxPower', _RL_InformationResponseItem_RL_ReconfRspFDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponseItem_RL_ReconfRspFDD_minimumDLTxPower),
        (u'not-Used-secondary-CCPCH-Info', _RL_InformationResponseItem_RL_ReconfRspFDD_not_Used_secondary_CCPCH_Info),
        (u'dCHsInformationResponseList', _RL_InformationResponseItem_RL_ReconfRspFDD_dCHsInformationResponseList),
        (u'dL-CodeInformationList-RL-ReconfResp', _RL_InformationResponseItem_RL_ReconfRspFDD_dL_CodeInformationList_RL_ReconfResp),
        (u'iE-Extensions', _RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions),
        ])
    RL_InformationResponseItem_RL_ReconfRspFDD._ext = []
    
    #-----< RL-InformationResponseItem-RL-ReconfRspFDD-ExtIEs >-----#
    RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs = CLASS(name=u'RL-InformationResponseItem-RL-ReconfRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-PowerBalancing-UpdatedIndicator')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-InformationResponse')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-FDD-DL-ControlChannelInformation')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-PreconfigurationInfo')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-Serving-RL-Preconfig-Info')))
    _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_7 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Information-Response')))
    RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 298), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 581), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 578), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 580), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 791), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 872), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 917), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-ReconfRspFDD >-----#
    DCH_InformationResponseList_RL_ReconfRspFDD = SEQ(name=u'DCH-InformationResponseList-RL-ReconfRspFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_ReconfRspFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DCH_InformationResponseList_RL_ReconfRspFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_ReconfRspFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_ReconfRspFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ___DCH_InformationResponseList_RL_ReconfRspFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_ReconfRspFDD_id._const_tab = __DCH_InformationResponseList_RL_ReconfRspFDD_id_tab
    _DCH_InformationResponseList_RL_ReconfRspFDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_ReconfRspFDD_id._const_tab_id = u'id'
    _DCH_InformationResponseList_RL_ReconfRspFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DCH_InformationResponseList_RL_ReconfRspFDD_criticality._const_tab = __DCH_InformationResponseList_RL_ReconfRspFDD_id_tab
    _DCH_InformationResponseList_RL_ReconfRspFDD_criticality._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfRspFDD_criticality._const_tab_id = u'criticality'
    _DCH_InformationResponseList_RL_ReconfRspFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DCH_InformationResponseList_RL_ReconfRspFDD_value._const_tab = __DCH_InformationResponseList_RL_ReconfRspFDD_id_tab
    _DCH_InformationResponseList_RL_ReconfRspFDD_value._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfRspFDD_value._const_tab_id = u'Value'
    DCH_InformationResponseList_RL_ReconfRspFDD._cont = ASN1Dict([
        (u'id', _DCH_InformationResponseList_RL_ReconfRspFDD_id),
        (u'criticality', _DCH_InformationResponseList_RL_ReconfRspFDD_criticality),
        (u'value', _DCH_InformationResponseList_RL_ReconfRspFDD_value),
        ])
    DCH_InformationResponseList_RL_ReconfRspFDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-ReconfRspFDD >-----#
    DCH_InformationResponseListIEs_RL_ReconfRspFDD = CLASS(name=u'DCH-InformationResponseListIEs-RL-ReconfRspFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_ReconfRspFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_ReconfRspFDD._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _DCH_InformationResponseListIEs_RL_ReconfRspFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CodeInformationList-RL-ReconfRspFDD >-----#
    DL_CodeInformationList_RL_ReconfRspFDD = SEQ(name=u'DL-CodeInformationList-RL-ReconfRspFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CodeInformationList_RL_ReconfRspFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CodeInformationList_RL_ReconfRspFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CodeInformationList_RL_ReconfRspFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    __DL_CodeInformationList_RL_ReconfRspFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', ___DL_CodeInformationList_RL_ReconfRspFDD_id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _DL_CodeInformationList_RL_ReconfRspFDD_id._const_tab = __DL_CodeInformationList_RL_ReconfRspFDD_id_tab
    _DL_CodeInformationList_RL_ReconfRspFDD_id._const_tab_at = None
    _DL_CodeInformationList_RL_ReconfRspFDD_id._const_tab_id = u'id'
    _DL_CodeInformationList_RL_ReconfRspFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CodeInformationList_RL_ReconfRspFDD_criticality._const_tab = __DL_CodeInformationList_RL_ReconfRspFDD_id_tab
    _DL_CodeInformationList_RL_ReconfRspFDD_criticality._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_ReconfRspFDD_criticality._const_tab_id = u'criticality'
    _DL_CodeInformationList_RL_ReconfRspFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CodeInformationList_RL_ReconfRspFDD_value._const_tab = __DL_CodeInformationList_RL_ReconfRspFDD_id_tab
    _DL_CodeInformationList_RL_ReconfRspFDD_value._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_RL_ReconfRspFDD_value._const_tab_id = u'Value'
    DL_CodeInformationList_RL_ReconfRspFDD._cont = ASN1Dict([
        (u'id', _DL_CodeInformationList_RL_ReconfRspFDD_id),
        (u'criticality', _DL_CodeInformationList_RL_ReconfRspFDD_criticality),
        (u'value', _DL_CodeInformationList_RL_ReconfRspFDD_value),
        ])
    DL_CodeInformationList_RL_ReconfRspFDD._ext = None
    
    #-----< DL-CodeInformationListIEs-RL-ReconfRspFDD >-----#
    DL_CodeInformationListIEs_RL_ReconfRspFDD = CLASS(name=u'DL-CodeInformationListIEs-RL-ReconfRspFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CodeInformationListIEs_RL_ReconfRspFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    DL_CodeInformationListIEs_RL_ReconfRspFDD._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'ignore'), (u'Value', _DL_CodeInformationListIEs_RL_ReconfRspFDD_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< RadioLinkReconfigurationResponseFDD-Extensions >-----#
    RadioLinkReconfigurationResponseFDD_Extensions = CLASS(name=u'RadioLinkReconfigurationResponseFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Information-Response')))
    _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_3 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Continuous-Packet-Connectivity-HS-SCCH-Less-Information-Response')))
    _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-Response-List')))
    _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-Cell-Information-Response-RLReconf-List')))
    RadioLinkReconfigurationResponseFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 453), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 672), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 795), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 854), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkReconfigurationResponseTDD >-----#
    RadioLinkReconfigurationResponseTDD = SEQ(name=u'RadioLinkReconfigurationResponseTDD', mode=MODE_TYPE)
    _RadioLinkReconfigurationResponseTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkReconfigurationResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-ReconfRspTDD')))
    _____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__id._const_tab = ____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__value._const_tab = ____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkReconfigurationResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__value),
        ])
    __RadioLinkReconfigurationResponseTDD_protocolIEs__item_._ext = None
    _RadioLinkReconfigurationResponseTDD_protocolIEs._cont = __RadioLinkReconfigurationResponseTDD_protocolIEs__item_
    _RadioLinkReconfigurationResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkReconfigurationResponseTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkReconfigurationResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-RL-InformationResponse-RL-ReconfRspTDD')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_12 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_17 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_18 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    ____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 529), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 861), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 862), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_18), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id._const_tab = ____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkReconfigurationResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkReconfigurationResponseTDD_protocolExtensions__item_._ext = None
    _RadioLinkReconfigurationResponseTDD_protocolExtensions._cont = __RadioLinkReconfigurationResponseTDD_protocolExtensions__item_
    _RadioLinkReconfigurationResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkReconfigurationResponseTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkReconfigurationResponseTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkReconfigurationResponseTDD_protocolExtensions),
        ])
    RadioLinkReconfigurationResponseTDD._ext = []
    
    #-----< RadioLinkReconfigurationResponseTDD-IEs >-----#
    RadioLinkReconfigurationResponseTDD_IEs = CLASS(name=u'RadioLinkReconfigurationResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkReconfigurationResponseTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-ReconfRspTDD')))
    _RadioLinkReconfigurationResponseTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    RadioLinkReconfigurationResponseTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 28), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationResponseTDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _RadioLinkReconfigurationResponseTDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationResponse-RL-ReconfRspTDD >-----#
    RL_InformationResponse_RL_ReconfRspTDD = SEQ(name=u'RL-InformationResponse-RL-ReconfRspTDD', mode=MODE_TYPE)
    _RL_InformationResponse_RL_ReconfRspTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationResponse_RL_ReconfRspTDD_max_UL_SIR = INT(name=u'max-UL-SIR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponse_RL_ReconfRspTDD_min_UL_SIR = INT(name=u'min-UL-SIR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UL-SIR')), opt=True)
    _RL_InformationResponse_RL_ReconfRspTDD_maximumDLTxPower = INT(name=u'maximumDLTxPower', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponse_RL_ReconfRspTDD_minimumDLTxPower = INT(name=u'minimumDLTxPower', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _RL_InformationResponse_RL_ReconfRspTDD_dCHsInformationResponseList = SEQ(name=u'dCHsInformationResponseList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-InformationResponseList-RL-ReconfRspTDD')), opt=True)
    _RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-ReconfRspTDD')))
    _____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    ____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 508), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab = ____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab = ____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item_._ext = None
    _RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions._cont = __RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item_
    _RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationResponse_RL_ReconfRspTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationResponse_RL_ReconfRspTDD_rL_ID),
        (u'max-UL-SIR', _RL_InformationResponse_RL_ReconfRspTDD_max_UL_SIR),
        (u'min-UL-SIR', _RL_InformationResponse_RL_ReconfRspTDD_min_UL_SIR),
        (u'maximumDLTxPower', _RL_InformationResponse_RL_ReconfRspTDD_maximumDLTxPower),
        (u'minimumDLTxPower', _RL_InformationResponse_RL_ReconfRspTDD_minimumDLTxPower),
        (u'dCHsInformationResponseList', _RL_InformationResponse_RL_ReconfRspTDD_dCHsInformationResponseList),
        (u'iE-Extensions', _RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions),
        ])
    RL_InformationResponse_RL_ReconfRspTDD._ext = []
    
    #-----< RL-InformationResponse-RL-ReconfRspTDD-ExtIEs >-----#
    RL_InformationResponse_RL_ReconfRspTDD_ExtIEs = CLASS(name=u'RL-InformationResponse-RL-ReconfRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationResponse_RL_ReconfRspTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-RL-ReconfRspTDD')))
    _RL_InformationResponse_RL_ReconfRspTDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-TimingAdvanceCtrl-LCR')))
    RL_InformationResponse_RL_ReconfRspTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 508), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_ReconfRspTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 492), (u'criticality', u'ignore'), (u'Extension', _RL_InformationResponse_RL_ReconfRspTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-RL-ReconfRspTDD >-----#
    DL_CCTrCH_InformationList_RL_ReconfRspTDD = SEQ_OF(name=u'DL-CCTrCH-InformationList-RL-ReconfRspTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationList_RL_ReconfRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-RL-ReconfRspTDD')))
    DL_CCTrCH_InformationList_RL_ReconfRspTDD._cont = _DL_CCTrCH_InformationList_RL_ReconfRspTDD__item_
    DL_CCTrCH_InformationList_RL_ReconfRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItem-RL-ReconfRspTDD >-----#
    DL_CCTrCH_InformationItem_RL_ReconfRspTDD = SEQ(name=u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_dl_DPCH_ModifyInformation_LCR = SEQ(name=u'dl-DPCH-ModifyInformation-LCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationModifyList-LCR-RL-ReconfRspTDD')), opt=True)
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_Maximum_DL_Power = INT(name=u'cCTrCH-Maximum-DL-Power', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_Minimum_DL_Power = INT(name=u'cCTrCH-Minimum-DL-Power', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_RL_ReconfRspTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_ID),
        (u'dl-DPCH-ModifyInformation-LCR', _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_dl_DPCH_ModifyInformation_LCR),
        (u'cCTrCH-Maximum-DL-Power', _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_Maximum_DL_Power),
        (u'cCTrCH-Minimum-DL-Power', _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_Minimum_DL_Power),
        (u'iE-Extensions', _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_RL_ReconfRspTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-RL-ReconfRspTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_RL_ReconfRspTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationItem-RL-ReconfRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationItem_RL_ReconfRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationModifyList-LCR-RL-ReconfRspTDD >-----#
    DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD = SEQ(name=u'DL-DPCH-InformationModifyList-LCR-RL-ReconfRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD')))
    __DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 509), (u'criticality', u'ignore'), (u'Value', ___DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id._const_tab = __DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id._const_tab_at = None
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_criticality._const_tab = __DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_value._const_tab = __DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id),
        (u'criticality', _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_criticality),
        (u'value', _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_value),
        ])
    DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD._ext = None
    
    #-----< DL-DPCH-InformationModifyListIEs-LCR-RL-ReconfRspTDD >-----#
    DL_DPCH_InformationModifyListIEs_LCR_RL_ReconfRspTDD = CLASS(name=u'DL-DPCH-InformationModifyListIEs-LCR-RL-ReconfRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationModifyListIEs_LCR_RL_ReconfRspTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD')))
    DL_DPCH_InformationModifyListIEs_LCR_RL_ReconfRspTDD._val = ASN1Set(rv=[dict([(u'id', 509), (u'criticality', u'ignore'), (u'Value', _DL_DPCH_InformationModifyListIEs_LCR_RL_ReconfRspTDD_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD >-----#
    DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD = SEQ(name=u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD = SEQ_OF(name=u'dL-Timeslot-LCR-InformationModifyList-RL-ReconfRqstTDD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModifyList-RL-ReconfRspTDD')), opt=True)
    _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions._cont = __DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item_
    _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD._cont = ASN1Dict([
        (u'dL-Timeslot-LCR-InformationModifyList-RL-ReconfRqstTDD', _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD),
        (u'iE-Extensions', _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions),
        ])
    DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD._ext = []
    
    #-----< DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD-ExtIEs >-----#
    DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationModifyItem-LCR-RL-ReconfRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-LCR-InformationModifyList-RL-ReconfRspTDD >-----#
    DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD = SEQ_OF(name=u'DL-Timeslot-LCR-InformationModifyList-RL-ReconfRspTDD', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD')))
    DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD._cont = _DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD__item_
    DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD >-----#
    DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD = SEQ(name=u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD', mode=MODE_TYPE)
    _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_maxPowerLCR = INT(name=u'maxPowerLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_minPowerLCR = INT(name=u'minPowerLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')), opt=True)
    _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions._cont = __DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item_
    _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD._cont = ASN1Dict([
        (u'timeSlotLCR', _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_timeSlotLCR),
        (u'maxPowerLCR', _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_maxPowerLCR),
        (u'minPowerLCR', _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_minPowerLCR),
        (u'iE-Extensions', _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions),
        ])
    DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD._ext = []
    
    #-----< DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD-ExtIEs >-----#
    DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_ExtIEs = CLASS(name=u'DL-Timeslot-LCR-InformationModifyItem-RL-ReconfRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-InformationResponseList-RL-ReconfRspTDD >-----#
    DCH_InformationResponseList_RL_ReconfRspTDD = SEQ(name=u'DCH-InformationResponseList-RL-ReconfRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DCH_InformationResponseList_RL_ReconfRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DCH_InformationResponseList_RL_ReconfRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DCH_InformationResponseList_RL_ReconfRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    __DCH_InformationResponseList_RL_ReconfRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', ___DCH_InformationResponseList_RL_ReconfRspTDD_id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    _DCH_InformationResponseList_RL_ReconfRspTDD_id._const_tab = __DCH_InformationResponseList_RL_ReconfRspTDD_id_tab
    _DCH_InformationResponseList_RL_ReconfRspTDD_id._const_tab_at = None
    _DCH_InformationResponseList_RL_ReconfRspTDD_id._const_tab_id = u'id'
    _DCH_InformationResponseList_RL_ReconfRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DCH_InformationResponseList_RL_ReconfRspTDD_criticality._const_tab = __DCH_InformationResponseList_RL_ReconfRspTDD_id_tab
    _DCH_InformationResponseList_RL_ReconfRspTDD_criticality._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfRspTDD_criticality._const_tab_id = u'criticality'
    _DCH_InformationResponseList_RL_ReconfRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DCH_InformationResponseList_RL_ReconfRspTDD_value._const_tab = __DCH_InformationResponseList_RL_ReconfRspTDD_id_tab
    _DCH_InformationResponseList_RL_ReconfRspTDD_value._const_tab_at = ('..', u'id')
    _DCH_InformationResponseList_RL_ReconfRspTDD_value._const_tab_id = u'Value'
    DCH_InformationResponseList_RL_ReconfRspTDD._cont = ASN1Dict([
        (u'id', _DCH_InformationResponseList_RL_ReconfRspTDD_id),
        (u'criticality', _DCH_InformationResponseList_RL_ReconfRspTDD_criticality),
        (u'value', _DCH_InformationResponseList_RL_ReconfRspTDD_value),
        ])
    DCH_InformationResponseList_RL_ReconfRspTDD._ext = None
    
    #-----< DCH-InformationResponseListIEs-RL-ReconfRspTDD >-----#
    DCH_InformationResponseListIEs_RL_ReconfRspTDD = CLASS(name=u'DCH-InformationResponseListIEs-RL-ReconfRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_InformationResponseListIEs_RL_ReconfRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-InformationResponse')))
    DCH_InformationResponseListIEs_RL_ReconfRspTDD._val = ASN1Set(rv=[dict([(u'id', 43), (u'criticality', u'ignore'), (u'Value', _DCH_InformationResponseListIEs_RL_ReconfRspTDD_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< RadioLinkReconfigurationResponseTDD-Extensions >-----#
    RadioLinkReconfigurationResponseTDD_Extensions = CLASS(name=u'RadioLinkReconfigurationResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Information-Response')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MAChs-ResetIndicator')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-RL-InformationResponse-RL-ReconfRspTDD')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Information-Response')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-768-Information-Response')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_6 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-LCR-Information-Response')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ControlGAP')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_8 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IdleIntervalInformation')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ContinuousPacketConnectivity-DRX-Information-ResponseLCR')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_11 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-Semi-PersistentScheduling-Information-ResponseLCR')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_12 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_13 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_14 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-MeasurementOccasion-Information')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_15 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multi-Carrier-EDCH-Information-Response')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_16 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MU-MIMO-InformationLCR')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_17 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-allocation-indicator')))
    _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_18 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Non-rectangular-resource-timeslot-set')))
    RadioLinkReconfigurationResponseTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 459), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 465), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 529), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 658), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 661), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 679), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 713), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 804), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 808), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 813), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 814), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 861), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 862), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 865), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 886), (u'criticality', u'ignore'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 888), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_16), (u'presence', u'optional')]), dict([(u'id', 945), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_17), (u'presence', u'optional')]), dict([(u'id', 946), (u'criticality', u'reject'), (u'Extension', _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_18), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiple-RL-InformationResponse-RL-ReconfRspTDD >-----#
    Multiple_RL_InformationResponse_RL_ReconfRspTDD = SEQ_OF(name=u'Multiple-RL-InformationResponse-RL-ReconfRspTDD', mode=MODE_TYPE)
    _Multiple_RL_InformationResponse_RL_ReconfRspTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationResponse-RL-ReconfRspTDD')))
    Multiple_RL_InformationResponse_RL_ReconfRspTDD._cont = _Multiple_RL_InformationResponse_RL_ReconfRspTDD__item_
    Multiple_RL_InformationResponse_RL_ReconfRspTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RadioLinkFailureIndication >-----#
    RadioLinkFailureIndication = SEQ(name=u'RadioLinkFailureIndication', mode=MODE_TYPE)
    _RadioLinkFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Reporting-Object-RL-FailureInd')))
    ____RadioLinkFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolIEs__item__id._const_tab = ____RadioLinkFailureIndication_protocolIEs__item__id_tab
    ___RadioLinkFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkFailureIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkFailureIndication_protocolIEs__item__id_tab
    ___RadioLinkFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkFailureIndication_protocolIEs__item__value._const_tab = ____RadioLinkFailureIndication_protocolIEs__item__id_tab
    ___RadioLinkFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkFailureIndication_protocolIEs__item__id),
        (u'criticality', ___RadioLinkFailureIndication_protocolIEs__item__criticality),
        (u'value', ___RadioLinkFailureIndication_protocolIEs__item__value),
        ])
    __RadioLinkFailureIndication_protocolIEs__item_._ext = None
    _RadioLinkFailureIndication_protocolIEs._cont = __RadioLinkFailureIndication_protocolIEs__item_
    _RadioLinkFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkFailureIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkFailureIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolExtensions__item__id._const_tab = ____RadioLinkFailureIndication_protocolExtensions__item__id_tab
    ___RadioLinkFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkFailureIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkFailureIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkFailureIndication_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkFailureIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkFailureIndication_protocolExtensions__item_._ext = None
    _RadioLinkFailureIndication_protocolExtensions._cont = __RadioLinkFailureIndication_protocolExtensions__item_
    _RadioLinkFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkFailureIndication_protocolIEs),
        (u'protocolExtensions', _RadioLinkFailureIndication_protocolExtensions),
        ])
    RadioLinkFailureIndication._ext = []
    
    #-----< RadioLinkFailureIndication-IEs >-----#
    RadioLinkFailureIndication_IEs = CLASS(name=u'RadioLinkFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkFailureIndication_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Reporting-Object-RL-FailureInd')))
    RadioLinkFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 153), (u'criticality', u'ignore'), (u'Value', _RadioLinkFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Reporting-Object-RL-FailureInd >-----#
    Reporting_Object_RL_FailureInd = CHOICE(name=u'Reporting-Object-RL-FailureInd', mode=MODE_TYPE)
    _Reporting_Object_RL_FailureInd_rL = SEQ(name=u'rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-RL-FailureInd')))
    _Reporting_Object_RL_FailureInd_rL_Set = SEQ(name=u'rL-Set', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-RL-FailureInd')))
    _Reporting_Object_RL_FailureInd_cCTrCH = SEQ(name=u'cCTrCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-RL-FailureInd')))
    Reporting_Object_RL_FailureInd._cont = ASN1Dict([
        (u'rL', _Reporting_Object_RL_FailureInd_rL),
        (u'rL-Set', _Reporting_Object_RL_FailureInd_rL_Set),
        (u'cCTrCH', _Reporting_Object_RL_FailureInd_cCTrCH),
        ])
    Reporting_Object_RL_FailureInd._ext = [u'cCTrCH']
    
    #-----< RL-RL-FailureInd >-----#
    RL_RL_FailureInd = SEQ(name=u'RL-RL-FailureInd', mode=MODE_TYPE)
    _RL_RL_FailureInd_rL_InformationList_RL_FailureInd = SEQ_OF(name=u'rL-InformationList-RL-FailureInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-FailureInd')))
    _RL_RL_FailureInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_RL_FailureInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_RL_FailureInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_RL_FailureInd_iE_Extensions__item__id),
        (u'criticality', ___RL_RL_FailureInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_RL_FailureInd_iE_Extensions._cont = __RL_RL_FailureInd_iE_Extensions__item_
    _RL_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_RL_FailureInd._cont = ASN1Dict([
        (u'rL-InformationList-RL-FailureInd', _RL_RL_FailureInd_rL_InformationList_RL_FailureInd),
        (u'iE-Extensions', _RL_RL_FailureInd_iE_Extensions),
        ])
    RL_RL_FailureInd._ext = []
    
    #-----< RLItem-RL-FailureInd-ExtIEs >-----#
    RLItem_RL_FailureInd_ExtIEs = CLASS(name=u'RLItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-FailureInd >-----#
    RL_InformationList_RL_FailureInd = SEQ_OF(name=u'RL-InformationList-RL-FailureInd', mode=MODE_TYPE)
    _RL_InformationList_RL_FailureInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_FailureInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_FailureInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_FailureInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-FailureInd')))
    ___RL_InformationList_RL_FailureInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 115), (u'criticality', u'ignore'), (u'Value', ____RL_InformationList_RL_FailureInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_FailureInd__item__id._const_tab = ___RL_InformationList_RL_FailureInd__item__id_tab
    __RL_InformationList_RL_FailureInd__item__id._const_tab_at = None
    __RL_InformationList_RL_FailureInd__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_FailureInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_FailureInd__item__criticality._const_tab = ___RL_InformationList_RL_FailureInd__item__id_tab
    __RL_InformationList_RL_FailureInd__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_FailureInd__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_FailureInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_FailureInd__item__value._const_tab = ___RL_InformationList_RL_FailureInd__item__id_tab
    __RL_InformationList_RL_FailureInd__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_FailureInd__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_FailureInd__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_FailureInd__item__id),
        (u'criticality', __RL_InformationList_RL_FailureInd__item__criticality),
        (u'value', __RL_InformationList_RL_FailureInd__item__value),
        ])
    _RL_InformationList_RL_FailureInd__item_._ext = None
    RL_InformationList_RL_FailureInd._cont = _RL_InformationList_RL_FailureInd__item_
    RL_InformationList_RL_FailureInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-RL-FailureInd-IEs >-----#
    RL_Information_RL_FailureInd_IEs = CLASS(name=u'RL-Information-RL-FailureInd-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_RL_FailureInd_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-FailureInd')))
    RL_Information_RL_FailureInd_IEs._val = ASN1Set(rv=[dict([(u'id', 115), (u'criticality', u'ignore'), (u'Value', _RL_Information_RL_FailureInd_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Information-RL-FailureInd >-----#
    RL_Information_RL_FailureInd = SEQ(name=u'RL-Information-RL-FailureInd', mode=MODE_TYPE)
    _RL_Information_RL_FailureInd_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_FailureInd_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _RL_Information_RL_FailureInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_FailureInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_Information_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_Information_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_FailureInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Information_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_Information_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_FailureInd_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_FailureInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_Information_RL_FailureInd_iE_Extensions._cont = __RL_Information_RL_FailureInd_iE_Extensions__item_
    _RL_Information_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_FailureInd._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_FailureInd_rL_ID),
        (u'cause', _RL_Information_RL_FailureInd_cause),
        (u'iE-Extensions', _RL_Information_RL_FailureInd_iE_Extensions),
        ])
    RL_Information_RL_FailureInd._ext = []
    
    #-----< RL-Information-RL-FailureInd-ExtIEs >-----#
    RL_Information_RL_FailureInd_ExtIEs = CLASS(name=u'RL-Information-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Information_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-RL-FailureInd >-----#
    RL_Set_RL_FailureInd = SEQ(name=u'RL-Set-RL-FailureInd', mode=MODE_TYPE)
    _RL_Set_RL_FailureInd_rL_Set_InformationList_RL_FailureInd = SEQ_OF(name=u'rL-Set-InformationList-RL-FailureInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationList-RL-FailureInd')))
    _RL_Set_RL_FailureInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_RL_FailureInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_RL_FailureInd_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_Set_RL_FailureInd_iE_Extensions._cont = __RL_Set_RL_FailureInd_iE_Extensions__item_
    _RL_Set_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_RL_FailureInd._cont = ASN1Dict([
        (u'rL-Set-InformationList-RL-FailureInd', _RL_Set_RL_FailureInd_rL_Set_InformationList_RL_FailureInd),
        (u'iE-Extensions', _RL_Set_RL_FailureInd_iE_Extensions),
        ])
    RL_Set_RL_FailureInd._ext = []
    
    #-----< RL-SetItem-RL-FailureInd-ExtIEs >-----#
    RL_SetItem_RL_FailureInd_ExtIEs = CLASS(name=u'RL-SetItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-RL-FailureInd >-----#
    RL_Set_InformationList_RL_FailureInd = SEQ_OF(name=u'RL-Set-InformationList-RL-FailureInd', mode=MODE_TYPE)
    _RL_Set_InformationList_RL_FailureInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_RL_FailureInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_InformationList_RL_FailureInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_RL_FailureInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Information-RL-FailureInd')))
    ___RL_Set_InformationList_RL_FailureInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', ____RL_Set_InformationList_RL_FailureInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_RL_FailureInd__item__id._const_tab = ___RL_Set_InformationList_RL_FailureInd__item__id_tab
    __RL_Set_InformationList_RL_FailureInd__item__id._const_tab_at = None
    __RL_Set_InformationList_RL_FailureInd__item__id._const_tab_id = u'id'
    __RL_Set_InformationList_RL_FailureInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_InformationList_RL_FailureInd__item__criticality._const_tab = ___RL_Set_InformationList_RL_FailureInd__item__id_tab
    __RL_Set_InformationList_RL_FailureInd__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_RL_FailureInd__item__criticality._const_tab_id = u'criticality'
    __RL_Set_InformationList_RL_FailureInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_InformationList_RL_FailureInd__item__value._const_tab = ___RL_Set_InformationList_RL_FailureInd__item__id_tab
    __RL_Set_InformationList_RL_FailureInd__item__value._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_RL_FailureInd__item__value._const_tab_id = u'Value'
    _RL_Set_InformationList_RL_FailureInd__item_._cont = ASN1Dict([
        (u'id', __RL_Set_InformationList_RL_FailureInd__item__id),
        (u'criticality', __RL_Set_InformationList_RL_FailureInd__item__criticality),
        (u'value', __RL_Set_InformationList_RL_FailureInd__item__value),
        ])
    _RL_Set_InformationList_RL_FailureInd__item_._ext = None
    RL_Set_InformationList_RL_FailureInd._cont = _RL_Set_InformationList_RL_FailureInd__item_
    RL_Set_InformationList_RL_FailureInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Information-RL-FailureInd-IEs >-----#
    RL_Set_Information_RL_FailureInd_IEs = CLASS(name=u'RL-Set-Information-RL-FailureInd-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Information_RL_FailureInd_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Information-RL-FailureInd')))
    RL_Set_Information_RL_FailureInd_IEs._val = ASN1Set(rv=[dict([(u'id', 146), (u'criticality', u'ignore'), (u'Value', _RL_Set_Information_RL_FailureInd_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-Information-RL-FailureInd >-----#
    RL_Set_Information_RL_FailureInd = SEQ(name=u'RL-Set-Information-RL-FailureInd', mode=MODE_TYPE)
    _RL_Set_Information_RL_FailureInd_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_Information_RL_FailureInd_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _RL_Set_Information_RL_FailureInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_Information_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__id._const_tab = ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__id_tab
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_Information_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_Information_RL_FailureInd_iE_Extensions__item_._ext = None
    _RL_Set_Information_RL_FailureInd_iE_Extensions._cont = __RL_Set_Information_RL_FailureInd_iE_Extensions__item_
    _RL_Set_Information_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_Information_RL_FailureInd._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_Information_RL_FailureInd_rL_Set_ID),
        (u'cause', _RL_Set_Information_RL_FailureInd_cause),
        (u'iE-Extensions', _RL_Set_Information_RL_FailureInd_iE_Extensions),
        ])
    RL_Set_Information_RL_FailureInd._ext = []
    
    #-----< RL-Set-Information-RL-FailureInd-ExtIEs >-----#
    RL_Set_Information_RL_FailureInd_ExtIEs = CLASS(name=u'RL-Set-Information-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_Information_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkFailureIndication-Extensions >-----#
    RadioLinkFailureIndication_Extensions = CLASS(name=u'RadioLinkFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-RL-FailureInd >-----#
    CCTrCH_RL_FailureInd = SEQ(name=u'CCTrCH-RL-FailureInd', mode=MODE_TYPE)
    _CCTrCH_RL_FailureInd_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _CCTrCH_RL_FailureInd_cCTrCH_InformationList_RL_FailureInd = SEQ_OF(name=u'cCTrCH-InformationList-RL-FailureInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-InformationList-RL-FailureInd')))
    _CCTrCH_RL_FailureInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id._const_tab = ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_RL_FailureInd_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_RL_FailureInd_iE_Extensions__item_._ext = None
    _CCTrCH_RL_FailureInd_iE_Extensions._cont = __CCTrCH_RL_FailureInd_iE_Extensions__item_
    _CCTrCH_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_RL_FailureInd._cont = ASN1Dict([
        (u'rL-ID', _CCTrCH_RL_FailureInd_rL_ID),
        (u'cCTrCH-InformationList-RL-FailureInd', _CCTrCH_RL_FailureInd_cCTrCH_InformationList_RL_FailureInd),
        (u'iE-Extensions', _CCTrCH_RL_FailureInd_iE_Extensions),
        ])
    CCTrCH_RL_FailureInd._ext = []
    
    #-----< CCTrCHItem-RL-FailureInd-ExtIEs >-----#
    CCTrCHItem_RL_FailureInd_ExtIEs = CLASS(name=u'CCTrCHItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCHItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-InformationList-RL-FailureInd >-----#
    CCTrCH_InformationList_RL_FailureInd = SEQ_OF(name=u'CCTrCH-InformationList-RL-FailureInd', mode=MODE_TYPE)
    _CCTrCH_InformationList_RL_FailureInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __CCTrCH_InformationList_RL_FailureInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___CCTrCH_InformationList_RL_FailureInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____CCTrCH_InformationList_RL_FailureInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-InformationItem-RL-FailureInd')))
    ___CCTrCH_InformationList_RL_FailureInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', ____CCTrCH_InformationList_RL_FailureInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CCTrCH_InformationList_RL_FailureInd__item__id._const_tab = ___CCTrCH_InformationList_RL_FailureInd__item__id_tab
    __CCTrCH_InformationList_RL_FailureInd__item__id._const_tab_at = None
    __CCTrCH_InformationList_RL_FailureInd__item__id._const_tab_id = u'id'
    __CCTrCH_InformationList_RL_FailureInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __CCTrCH_InformationList_RL_FailureInd__item__criticality._const_tab = ___CCTrCH_InformationList_RL_FailureInd__item__id_tab
    __CCTrCH_InformationList_RL_FailureInd__item__criticality._const_tab_at = ('..', u'id')
    __CCTrCH_InformationList_RL_FailureInd__item__criticality._const_tab_id = u'criticality'
    __CCTrCH_InformationList_RL_FailureInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __CCTrCH_InformationList_RL_FailureInd__item__value._const_tab = ___CCTrCH_InformationList_RL_FailureInd__item__id_tab
    __CCTrCH_InformationList_RL_FailureInd__item__value._const_tab_at = ('..', u'id')
    __CCTrCH_InformationList_RL_FailureInd__item__value._const_tab_id = u'Value'
    _CCTrCH_InformationList_RL_FailureInd__item_._cont = ASN1Dict([
        (u'id', __CCTrCH_InformationList_RL_FailureInd__item__id),
        (u'criticality', __CCTrCH_InformationList_RL_FailureInd__item__criticality),
        (u'value', __CCTrCH_InformationList_RL_FailureInd__item__value),
        ])
    _CCTrCH_InformationList_RL_FailureInd__item_._ext = None
    CCTrCH_InformationList_RL_FailureInd._cont = _CCTrCH_InformationList_RL_FailureInd__item_
    CCTrCH_InformationList_RL_FailureInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-InformationItemIE-RL-FailureInd >-----#
    CCTrCH_InformationItemIE_RL_FailureInd = CLASS(name=u'CCTrCH-InformationItemIE-RL-FailureInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CCTrCH_InformationItemIE_RL_FailureInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-InformationItem-RL-FailureInd')))
    CCTrCH_InformationItemIE_RL_FailureInd._val = ASN1Set(rv=[dict([(u'id', 15), (u'criticality', u'ignore'), (u'Value', _CCTrCH_InformationItemIE_RL_FailureInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCTrCH-InformationItem-RL-FailureInd >-----#
    CCTrCH_InformationItem_RL_FailureInd = SEQ(name=u'CCTrCH-InformationItem-RL-FailureInd', mode=MODE_TYPE)
    _CCTrCH_InformationItem_RL_FailureInd_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_InformationItem_RL_FailureInd_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab = ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_._ext = None
    _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions._cont = __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_
    _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_InformationItem_RL_FailureInd._cont = ASN1Dict([
        (u'cCTrCH-ID', _CCTrCH_InformationItem_RL_FailureInd_cCTrCH_ID),
        (u'cause', _CCTrCH_InformationItem_RL_FailureInd_cause),
        (u'iE-Extensions', _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions),
        ])
    CCTrCH_InformationItem_RL_FailureInd._ext = []
    
    #-----< CCTrCH-InformationItem-RL-FailureInd-ExtIEs >-----#
    CCTrCH_InformationItem_RL_FailureInd_ExtIEs = CLASS(name=u'CCTrCH-InformationItem-RL-FailureInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCH_InformationItem_RL_FailureInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkPreemptionRequiredIndication >-----#
    RadioLinkPreemptionRequiredIndication = SEQ(name=u'RadioLinkPreemptionRequiredIndication', mode=MODE_TYPE)
    _RadioLinkPreemptionRequiredIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkPreemptionRequiredIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-PreemptRequiredInd')))
    ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkPreemptionRequiredIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id),
        (u'criticality', ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality),
        (u'value', ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value),
        ])
    __RadioLinkPreemptionRequiredIndication_protocolIEs__item_._ext = None
    _RadioLinkPreemptionRequiredIndication_protocolIEs._cont = __RadioLinkPreemptionRequiredIndication_protocolIEs__item_
    _RadioLinkPreemptionRequiredIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkPreemptionRequiredIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd')))
    ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 516), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_._ext = None
    _RadioLinkPreemptionRequiredIndication_protocolExtensions._cont = __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_
    _RadioLinkPreemptionRequiredIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkPreemptionRequiredIndication._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkPreemptionRequiredIndication_protocolIEs),
        (u'protocolExtensions', _RadioLinkPreemptionRequiredIndication_protocolExtensions),
        ])
    RadioLinkPreemptionRequiredIndication._ext = []
    
    #-----< RadioLinkPreemptionRequiredIndication-IEs >-----#
    RadioLinkPreemptionRequiredIndication_IEs = CLASS(name=u'RadioLinkPreemptionRequiredIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkPreemptionRequiredIndication_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-PreemptRequiredInd')))
    RadioLinkPreemptionRequiredIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 1), (u'criticality', u'ignore'), (u'Value', _RadioLinkPreemptionRequiredIndication_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-PreemptRequiredInd >-----#
    RL_InformationList_RL_PreemptRequiredInd = SEQ_OF(name=u'RL-InformationList-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _RL_InformationList_RL_PreemptRequiredInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_PreemptRequiredInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-RL-PreemptRequiredInd')))
    ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', ____RL_InformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_PreemptRequiredInd__item__id._const_tab = ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab
    __RL_InformationList_RL_PreemptRequiredInd__item__id._const_tab_at = None
    __RL_InformationList_RL_PreemptRequiredInd__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality._const_tab = ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_PreemptRequiredInd__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_PreemptRequiredInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_PreemptRequiredInd__item__value._const_tab = ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab
    __RL_InformationList_RL_PreemptRequiredInd__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_PreemptRequiredInd__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_PreemptRequiredInd__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_PreemptRequiredInd__item__id),
        (u'criticality', __RL_InformationList_RL_PreemptRequiredInd__item__criticality),
        (u'value', __RL_InformationList_RL_PreemptRequiredInd__item__value),
        ])
    _RL_InformationList_RL_PreemptRequiredInd__item_._ext = None
    RL_InformationList_RL_PreemptRequiredInd._cont = _RL_InformationList_RL_PreemptRequiredInd__item_
    RL_InformationList_RL_PreemptRequiredInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIEs-RL-PreemptRequiredInd >-----#
    RL_InformationItemIEs_RL_PreemptRequiredInd = CLASS(name=u'RL-InformationItemIEs-RL-PreemptRequiredInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationItemIEs_RL_PreemptRequiredInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-RL-PreemptRequiredInd')))
    RL_InformationItemIEs_RL_PreemptRequiredInd._val = ASN1Set(rv=[dict([(u'id', 2), (u'criticality', u'ignore'), (u'Value', _RL_InformationItemIEs_RL_PreemptRequiredInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-PreemptRequiredInd >-----#
    RL_InformationItem_RL_PreemptRequiredInd = SEQ(name=u'RL-InformationItem-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _RL_InformationItem_RL_PreemptRequiredInd_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd')))
    ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 586), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions._cont = __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_
    _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_PreemptRequiredInd._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationItem_RL_PreemptRequiredInd_rL_ID),
        (u'iE-Extensions', _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions),
        ])
    RL_InformationItem_RL_PreemptRequiredInd._ext = []
    
    #-----< RL-Information-RL-PreemptRequiredInd-ExtIEs >-----#
    RL_Information_RL_PreemptRequiredInd_ExtIEs = CLASS(name=u'RL-Information-RL-PreemptRequiredInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_PreemptRequiredInd_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd')))
    RL_Information_RL_PreemptRequiredInd_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 586), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_PreemptRequiredInd_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkPreemptionRequiredIndication-Extensions >-----#
    RadioLinkPreemptionRequiredIndication_Extensions = CLASS(name=u'RadioLinkPreemptionRequiredIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkPreemptionRequiredIndication_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd')))
    RadioLinkPreemptionRequiredIndication_Extensions._val = ASN1Set(rv=[dict([(u'id', 516), (u'criticality', u'ignore'), (u'Extension', _RadioLinkPreemptionRequiredIndication_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd >-----#
    HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd = SEQ_OF(name=u'HSDSCHMacdFlowSpecificInformationList-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd')))
    ___HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 517), (u'criticality', u'ignore'), (u'Value', ____HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id._const_tab = ___HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id._const_tab_at = None
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id._const_tab_id = u'id'
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality._const_tab = ___HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality._const_tab_at = ('..', u'id')
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality._const_tab_id = u'criticality'
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value._const_tab = ___HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value._const_tab_at = ('..', u'id')
    __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value._const_tab_id = u'Value'
    _HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_._cont = ASN1Dict([
        (u'id', __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id),
        (u'criticality', __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality),
        (u'value', __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value),
        ])
    _HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_._ext = None
    HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd._cont = _HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_
    HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< HSDSCHMacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd >-----#
    HSDSCHMacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd = CLASS(name=u'HSDSCHMacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _HSDSCHMacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd')))
    HSDSCHMacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd._val = ASN1Set(rv=[dict([(u'id', 517), (u'criticality', u'ignore'), (u'Value', _HSDSCHMacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd >-----#
    HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd = SEQ(name=u'HSDSCHMacdFlowSpecificInformationItem-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_hSDSCH_MACdFlow_ID = INT(name=u'hSDSCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-MACdFlow-ID')))
    _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab = ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_at = None
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab = ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab = ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id),
        (u'criticality', ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue),
        ])
    __HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._ext = None
    _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions._cont = __HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_
    _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd._cont = ASN1Dict([
        (u'hSDSCH-MACdFlow-ID', _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_hSDSCH_MACdFlow_ID),
        (u'iE-Extensions', _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions),
        ])
    HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd._ext = []
    
    #-----< HSDSCHMacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs >-----#
    HSDSCHMacdFlowSpecificInformation_RL_PreemptRequiredInd_ExtIEs = CLASS(name=u'HSDSCHMacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSDSCHMacdFlowSpecificInformation_RL_PreemptRequiredInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd >-----#
    EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd = SEQ_OF(name=u'EDCH-MacdFlowSpecificInformationList-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd')))
    ___EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 587), (u'criticality', u'ignore'), (u'Value', ____EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id._const_tab = ___EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id._const_tab_at = None
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id._const_tab_id = u'id'
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality._const_tab = ___EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality._const_tab_at = ('..', u'id')
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality._const_tab_id = u'criticality'
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value._const_tab = ___EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value._const_tab_at = ('..', u'id')
    __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value._const_tab_id = u'Value'
    _EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_._cont = ASN1Dict([
        (u'id', __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id),
        (u'criticality', __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality),
        (u'value', __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value),
        ])
    _EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_._ext = None
    EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd._cont = _EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_
    EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDCH-MacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd >-----#
    EDCH_MacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd = CLASS(name=u'EDCH-MacdFlowSpecificInformationItemIEs-RL-PreemptRequiredInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EDCH_MacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd')))
    EDCH_MacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd._val = ASN1Set(rv=[dict([(u'id', 587), (u'criticality', u'ignore'), (u'Value', _EDCH_MacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd >-----#
    EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd = SEQ(name=u'EDCH-MacdFlowSpecificInformationItem-RL-PreemptRequiredInd', mode=MODE_TYPE)
    _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab = ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab = ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_._ext = None
    _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions._cont = __EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_
    _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_eDCH_MACdFlow_ID),
        (u'iE-Extensions', _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions),
        ])
    EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd._ext = []
    
    #-----< EDCH-MacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs >-----#
    EDCH_MacdFlowSpecificInformation_RL_PreemptRequiredInd_ExtIEs = CLASS(name=u'EDCH-MacdFlowSpecificInformation-RL-PreemptRequiredInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_MacdFlowSpecificInformation_RL_PreemptRequiredInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkRestoreIndication >-----#
    RadioLinkRestoreIndication = SEQ(name=u'RadioLinkRestoreIndication', mode=MODE_TYPE)
    _RadioLinkRestoreIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkRestoreIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkRestoreIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkRestoreIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Reporting-Object-RL-RestoreInd')))
    ____RadioLinkRestoreIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolIEs__item__id._const_tab = ____RadioLinkRestoreIndication_protocolIEs__item__id_tab
    ___RadioLinkRestoreIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkRestoreIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkRestoreIndication_protocolIEs__item__id_tab
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkRestoreIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkRestoreIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkRestoreIndication_protocolIEs__item__value._const_tab = ____RadioLinkRestoreIndication_protocolIEs__item__id_tab
    ___RadioLinkRestoreIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkRestoreIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkRestoreIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkRestoreIndication_protocolIEs__item__id),
        (u'criticality', ___RadioLinkRestoreIndication_protocolIEs__item__criticality),
        (u'value', ___RadioLinkRestoreIndication_protocolIEs__item__value),
        ])
    __RadioLinkRestoreIndication_protocolIEs__item_._ext = None
    _RadioLinkRestoreIndication_protocolIEs._cont = __RadioLinkRestoreIndication_protocolIEs__item_
    _RadioLinkRestoreIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkRestoreIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkRestoreIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkRestoreIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolExtensions__item__id._const_tab = ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab
    ___RadioLinkRestoreIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkRestoreIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkRestoreIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkRestoreIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkRestoreIndication_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkRestoreIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkRestoreIndication_protocolExtensions__item_._ext = None
    _RadioLinkRestoreIndication_protocolExtensions._cont = __RadioLinkRestoreIndication_protocolExtensions__item_
    _RadioLinkRestoreIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkRestoreIndication._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkRestoreIndication_protocolIEs),
        (u'protocolExtensions', _RadioLinkRestoreIndication_protocolExtensions),
        ])
    RadioLinkRestoreIndication._ext = []
    
    #-----< RadioLinkRestoreIndication-IEs >-----#
    RadioLinkRestoreIndication_IEs = CLASS(name=u'RadioLinkRestoreIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkRestoreIndication_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Reporting-Object-RL-RestoreInd')))
    RadioLinkRestoreIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 154), (u'criticality', u'ignore'), (u'Value', _RadioLinkRestoreIndication_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Reporting-Object-RL-RestoreInd >-----#
    Reporting_Object_RL_RestoreInd = CHOICE(name=u'Reporting-Object-RL-RestoreInd', mode=MODE_TYPE)
    _Reporting_Object_RL_RestoreInd_rL = SEQ(name=u'rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-RL-RestoreInd')))
    _Reporting_Object_RL_RestoreInd_rL_Set = SEQ(name=u'rL-Set', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-RL-RestoreInd')))
    _Reporting_Object_RL_RestoreInd_cCTrCH = SEQ(name=u'cCTrCH', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-RL-RestoreInd')))
    Reporting_Object_RL_RestoreInd._cont = ASN1Dict([
        (u'rL', _Reporting_Object_RL_RestoreInd_rL),
        (u'rL-Set', _Reporting_Object_RL_RestoreInd_rL_Set),
        (u'cCTrCH', _Reporting_Object_RL_RestoreInd_cCTrCH),
        ])
    Reporting_Object_RL_RestoreInd._ext = [u'cCTrCH']
    
    #-----< RL-RL-RestoreInd >-----#
    RL_RL_RestoreInd = SEQ(name=u'RL-RL-RestoreInd', mode=MODE_TYPE)
    _RL_RL_RestoreInd_rL_InformationList_RL_RestoreInd = SEQ_OF(name=u'rL-InformationList-RL-RestoreInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-RestoreInd')))
    _RL_RL_RestoreInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_RL_RestoreInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_RL_RestoreInd_iE_Extensions__item__id),
        (u'criticality', ___RL_RL_RestoreInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_RL_RestoreInd_iE_Extensions._cont = __RL_RL_RestoreInd_iE_Extensions__item_
    _RL_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_RL_RestoreInd._cont = ASN1Dict([
        (u'rL-InformationList-RL-RestoreInd', _RL_RL_RestoreInd_rL_InformationList_RL_RestoreInd),
        (u'iE-Extensions', _RL_RL_RestoreInd_iE_Extensions),
        ])
    RL_RL_RestoreInd._ext = []
    
    #-----< RLItem-RL-RestoreInd-ExtIEs >-----#
    RLItem_RL_RestoreInd_ExtIEs = CLASS(name=u'RLItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-RestoreInd >-----#
    RL_InformationList_RL_RestoreInd = SEQ_OF(name=u'RL-InformationList-RL-RestoreInd', mode=MODE_TYPE)
    _RL_InformationList_RL_RestoreInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_RestoreInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_RestoreInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_RestoreInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-RestoreInd')))
    ___RL_InformationList_RL_RestoreInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', ____RL_InformationList_RL_RestoreInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_RestoreInd__item__id._const_tab = ___RL_InformationList_RL_RestoreInd__item__id_tab
    __RL_InformationList_RL_RestoreInd__item__id._const_tab_at = None
    __RL_InformationList_RL_RestoreInd__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_RestoreInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_RestoreInd__item__criticality._const_tab = ___RL_InformationList_RL_RestoreInd__item__id_tab
    __RL_InformationList_RL_RestoreInd__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_RestoreInd__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_RestoreInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_RestoreInd__item__value._const_tab = ___RL_InformationList_RL_RestoreInd__item__id_tab
    __RL_InformationList_RL_RestoreInd__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_RestoreInd__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_RestoreInd__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_RestoreInd__item__id),
        (u'criticality', __RL_InformationList_RL_RestoreInd__item__criticality),
        (u'value', __RL_InformationList_RL_RestoreInd__item__value),
        ])
    _RL_InformationList_RL_RestoreInd__item_._ext = None
    RL_InformationList_RL_RestoreInd._cont = _RL_InformationList_RL_RestoreInd__item_
    RL_InformationList_RL_RestoreInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-RL-RestoreInd-IEs >-----#
    RL_Information_RL_RestoreInd_IEs = CLASS(name=u'RL-Information-RL-RestoreInd-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_RL_RestoreInd_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-RL-RestoreInd')))
    RL_Information_RL_RestoreInd_IEs._val = ASN1Set(rv=[dict([(u'id', 117), (u'criticality', u'ignore'), (u'Value', _RL_Information_RL_RestoreInd_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Information-RL-RestoreInd >-----#
    RL_Information_RL_RestoreInd = SEQ(name=u'RL-Information-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Information_RL_RestoreInd_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_RL_RestoreInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_Information_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_RL_RestoreInd_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_RL_RestoreInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_Information_RL_RestoreInd_iE_Extensions._cont = __RL_Information_RL_RestoreInd_iE_Extensions__item_
    _RL_Information_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_RL_RestoreInd._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_RL_RestoreInd_rL_ID),
        (u'iE-Extensions', _RL_Information_RL_RestoreInd_iE_Extensions),
        ])
    RL_Information_RL_RestoreInd._ext = []
    
    #-----< RL-Information-RL-RestoreInd-ExtIEs >-----#
    RL_Information_RL_RestoreInd_ExtIEs = CLASS(name=u'RL-Information-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Information_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-RL-RestoreInd >-----#
    RL_Set_RL_RestoreInd = SEQ(name=u'RL-Set-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Set_RL_RestoreInd_rL_Set_InformationList_RL_RestoreInd = SEQ_OF(name=u'rL-Set-InformationList-RL-RestoreInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationList-RL-RestoreInd')))
    _RL_Set_RL_RestoreInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_RL_RestoreInd_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_Set_RL_RestoreInd_iE_Extensions._cont = __RL_Set_RL_RestoreInd_iE_Extensions__item_
    _RL_Set_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_RL_RestoreInd._cont = ASN1Dict([
        (u'rL-Set-InformationList-RL-RestoreInd', _RL_Set_RL_RestoreInd_rL_Set_InformationList_RL_RestoreInd),
        (u'iE-Extensions', _RL_Set_RL_RestoreInd_iE_Extensions),
        ])
    RL_Set_RL_RestoreInd._ext = []
    
    #-----< RL-SetItem-RL-RestoreInd-ExtIEs >-----#
    RL_SetItem_RL_RestoreInd_ExtIEs = CLASS(name=u'RL-SetItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-RL-RestoreInd >-----#
    RL_Set_InformationList_RL_RestoreInd = SEQ_OF(name=u'RL-Set-InformationList-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Set_InformationList_RL_RestoreInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_RL_RestoreInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_InformationList_RL_RestoreInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_RL_RestoreInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Information-RL-RestoreInd')))
    ___RL_Set_InformationList_RL_RestoreInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', ____RL_Set_InformationList_RL_RestoreInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_RL_RestoreInd__item__id._const_tab = ___RL_Set_InformationList_RL_RestoreInd__item__id_tab
    __RL_Set_InformationList_RL_RestoreInd__item__id._const_tab_at = None
    __RL_Set_InformationList_RL_RestoreInd__item__id._const_tab_id = u'id'
    __RL_Set_InformationList_RL_RestoreInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_InformationList_RL_RestoreInd__item__criticality._const_tab = ___RL_Set_InformationList_RL_RestoreInd__item__id_tab
    __RL_Set_InformationList_RL_RestoreInd__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_RL_RestoreInd__item__criticality._const_tab_id = u'criticality'
    __RL_Set_InformationList_RL_RestoreInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_InformationList_RL_RestoreInd__item__value._const_tab = ___RL_Set_InformationList_RL_RestoreInd__item__id_tab
    __RL_Set_InformationList_RL_RestoreInd__item__value._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_RL_RestoreInd__item__value._const_tab_id = u'Value'
    _RL_Set_InformationList_RL_RestoreInd__item_._cont = ASN1Dict([
        (u'id', __RL_Set_InformationList_RL_RestoreInd__item__id),
        (u'criticality', __RL_Set_InformationList_RL_RestoreInd__item__criticality),
        (u'value', __RL_Set_InformationList_RL_RestoreInd__item__value),
        ])
    _RL_Set_InformationList_RL_RestoreInd__item_._ext = None
    RL_Set_InformationList_RL_RestoreInd._cont = _RL_Set_InformationList_RL_RestoreInd__item_
    RL_Set_InformationList_RL_RestoreInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Information-RL-RestoreInd-IEs >-----#
    RL_Set_Information_RL_RestoreInd_IEs = CLASS(name=u'RL-Set-Information-RL-RestoreInd-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Information_RL_RestoreInd_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Information-RL-RestoreInd')))
    RL_Set_Information_RL_RestoreInd_IEs._val = ASN1Set(rv=[dict([(u'id', 147), (u'criticality', u'ignore'), (u'Value', _RL_Set_Information_RL_RestoreInd_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-Information-RL-RestoreInd >-----#
    RL_Set_Information_RL_RestoreInd = SEQ(name=u'RL-Set-Information-RL-RestoreInd', mode=MODE_TYPE)
    _RL_Set_Information_RL_RestoreInd_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_Information_RL_RestoreInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_Information_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id_tab
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_Information_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_Information_RL_RestoreInd_iE_Extensions__item_._ext = None
    _RL_Set_Information_RL_RestoreInd_iE_Extensions._cont = __RL_Set_Information_RL_RestoreInd_iE_Extensions__item_
    _RL_Set_Information_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_Information_RL_RestoreInd._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_Information_RL_RestoreInd_rL_Set_ID),
        (u'iE-Extensions', _RL_Set_Information_RL_RestoreInd_iE_Extensions),
        ])
    RL_Set_Information_RL_RestoreInd._ext = []
    
    #-----< RL-Set-Information-RL-RestoreInd-ExtIEs >-----#
    RL_Set_Information_RL_RestoreInd_ExtIEs = CLASS(name=u'RL-Set-Information-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_Information_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkRestoreIndication-Extensions >-----#
    RadioLinkRestoreIndication_Extensions = CLASS(name=u'RadioLinkRestoreIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkRestoreIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-RL-RestoreInd >-----#
    CCTrCH_RL_RestoreInd = SEQ(name=u'CCTrCH-RL-RestoreInd', mode=MODE_TYPE)
    _CCTrCH_RL_RestoreInd_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _CCTrCH_RL_RestoreInd_cCTrCH_InformationList_RL_RestoreInd = SEQ_OF(name=u'cCTrCH-InformationList-RL-RestoreInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-InformationList-RL-RestoreInd')))
    _CCTrCH_RL_RestoreInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_RL_RestoreInd_iE_Extensions__item_._ext = None
    _CCTrCH_RL_RestoreInd_iE_Extensions._cont = __CCTrCH_RL_RestoreInd_iE_Extensions__item_
    _CCTrCH_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_RL_RestoreInd._cont = ASN1Dict([
        (u'rL-ID', _CCTrCH_RL_RestoreInd_rL_ID),
        (u'cCTrCH-InformationList-RL-RestoreInd', _CCTrCH_RL_RestoreInd_cCTrCH_InformationList_RL_RestoreInd),
        (u'iE-Extensions', _CCTrCH_RL_RestoreInd_iE_Extensions),
        ])
    CCTrCH_RL_RestoreInd._ext = []
    
    #-----< CCTrCHItem-RL-RestoreInd-ExtIEs >-----#
    CCTrCHItem_RL_RestoreInd_ExtIEs = CLASS(name=u'CCTrCHItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCHItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CCTrCH-InformationList-RL-RestoreInd >-----#
    CCTrCH_InformationList_RL_RestoreInd = SEQ_OF(name=u'CCTrCH-InformationList-RL-RestoreInd', mode=MODE_TYPE)
    _CCTrCH_InformationList_RL_RestoreInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __CCTrCH_InformationList_RL_RestoreInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____CCTrCH_InformationList_RL_RestoreInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-InformationItem-RL-RestoreInd')))
    ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', ____CCTrCH_InformationList_RL_RestoreInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __CCTrCH_InformationList_RL_RestoreInd__item__id._const_tab = ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab
    __CCTrCH_InformationList_RL_RestoreInd__item__id._const_tab_at = None
    __CCTrCH_InformationList_RL_RestoreInd__item__id._const_tab_id = u'id'
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality._const_tab = ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality._const_tab_at = ('..', u'id')
    __CCTrCH_InformationList_RL_RestoreInd__item__criticality._const_tab_id = u'criticality'
    __CCTrCH_InformationList_RL_RestoreInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __CCTrCH_InformationList_RL_RestoreInd__item__value._const_tab = ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab
    __CCTrCH_InformationList_RL_RestoreInd__item__value._const_tab_at = ('..', u'id')
    __CCTrCH_InformationList_RL_RestoreInd__item__value._const_tab_id = u'Value'
    _CCTrCH_InformationList_RL_RestoreInd__item_._cont = ASN1Dict([
        (u'id', __CCTrCH_InformationList_RL_RestoreInd__item__id),
        (u'criticality', __CCTrCH_InformationList_RL_RestoreInd__item__criticality),
        (u'value', __CCTrCH_InformationList_RL_RestoreInd__item__value),
        ])
    _CCTrCH_InformationList_RL_RestoreInd__item_._ext = None
    CCTrCH_InformationList_RL_RestoreInd._cont = _CCTrCH_InformationList_RL_RestoreInd__item_
    CCTrCH_InformationList_RL_RestoreInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CCTrCH-InformationItemIE-RL-RestoreInd >-----#
    CCTrCH_InformationItemIE_RL_RestoreInd = CLASS(name=u'CCTrCH-InformationItemIE-RL-RestoreInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CCTrCH_InformationItemIE_RL_RestoreInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CCTrCH-InformationItem-RL-RestoreInd')))
    CCTrCH_InformationItemIE_RL_RestoreInd._val = ASN1Set(rv=[dict([(u'id', 16), (u'criticality', u'ignore'), (u'Value', _CCTrCH_InformationItemIE_RL_RestoreInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CCTrCH-InformationItem-RL-RestoreInd >-----#
    CCTrCH_InformationItem_RL_RestoreInd = SEQ(name=u'CCTrCH-InformationItem-RL-RestoreInd', mode=MODE_TYPE)
    _CCTrCH_InformationItem_RL_RestoreInd_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab = ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_at = None
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab = ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab = ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id),
        (u'criticality', ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue),
        ])
    __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_._ext = None
    _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions._cont = __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_
    _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CCTrCH_InformationItem_RL_RestoreInd._cont = ASN1Dict([
        (u'cCTrCH-ID', _CCTrCH_InformationItem_RL_RestoreInd_cCTrCH_ID),
        (u'iE-Extensions', _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions),
        ])
    CCTrCH_InformationItem_RL_RestoreInd._ext = []
    
    #-----< CCTrCH-InformationItem-RL-RestoreInd-ExtIEs >-----#
    CCTrCH_InformationItem_RL_RestoreInd_ExtIEs = CLASS(name=u'CCTrCH-InformationItem-RL-RestoreInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CCTrCH_InformationItem_RL_RestoreInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerControlRequest >-----#
    DL_PowerControlRequest = SEQ(name=u'DL-PowerControlRequest', mode=MODE_TYPE)
    _DL_PowerControlRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DL_PowerControlRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DL_PowerControlRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DL_PowerControlRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerAdjustmentType')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-ReferencePowerInformationList-DL-PC-Rqst')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxAdjustmentStep')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AdjustmentPeriod')))
    _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ScaledAdjustmentRatio')))
    ____DL_PowerControlRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 24), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Value', _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'conditional')])], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolIEs__item__id._const_tab = ____DL_PowerControlRequest_protocolIEs__item__id_tab
    ___DL_PowerControlRequest_protocolIEs__item__id._const_tab_at = None
    ___DL_PowerControlRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___DL_PowerControlRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DL_PowerControlRequest_protocolIEs__item__criticality._const_tab = ____DL_PowerControlRequest_protocolIEs__item__id_tab
    ___DL_PowerControlRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PowerControlRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DL_PowerControlRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DL_PowerControlRequest_protocolIEs__item__value._const_tab = ____DL_PowerControlRequest_protocolIEs__item__id_tab
    ___DL_PowerControlRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DL_PowerControlRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __DL_PowerControlRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DL_PowerControlRequest_protocolIEs__item__id),
        (u'criticality', ___DL_PowerControlRequest_protocolIEs__item__criticality),
        (u'value', ___DL_PowerControlRequest_protocolIEs__item__value),
        ])
    __DL_PowerControlRequest_protocolIEs__item_._ext = None
    _DL_PowerControlRequest_protocolIEs._cont = __DL_PowerControlRequest_protocolIEs__item_
    _DL_PowerControlRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DL_PowerControlRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PowerControlRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_PowerControlRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_PowerControlRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_PowerControlRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolExtensions__item__id._const_tab = ____DL_PowerControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerControlRequest_protocolExtensions__item__id._const_tab_at = None
    ___DL_PowerControlRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___DL_PowerControlRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolExtensions__item__criticality._const_tab = ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab
    ___DL_PowerControlRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PowerControlRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue._const_tab = ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_PowerControlRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_PowerControlRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DL_PowerControlRequest_protocolExtensions__item__id),
        (u'criticality', ___DL_PowerControlRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___DL_PowerControlRequest_protocolExtensions__item__extensionValue),
        ])
    __DL_PowerControlRequest_protocolExtensions__item_._ext = None
    _DL_PowerControlRequest_protocolExtensions._cont = __DL_PowerControlRequest_protocolExtensions__item_
    _DL_PowerControlRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PowerControlRequest._cont = ASN1Dict([
        (u'protocolIEs', _DL_PowerControlRequest_protocolIEs),
        (u'protocolExtensions', _DL_PowerControlRequest_protocolExtensions),
        ])
    DL_PowerControlRequest._ext = []
    
    #-----< DL-PowerControlRequest-IEs >-----#
    DL_PowerControlRequest_IEs = CLASS(name=u'DL-PowerControlRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_PowerControlRequest_IEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PowerAdjustmentType')))
    _DL_PowerControlRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_PowerControlRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InnerLoopDLPCStatus')))
    _DL_PowerControlRequest_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-ReferencePowerInformationList-DL-PC-Rqst')))
    _DL_PowerControlRequest_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MaxAdjustmentStep')))
    _DL_PowerControlRequest_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AdjustmentPeriod')))
    _DL_PowerControlRequest_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ScaledAdjustmentRatio')))
    DL_PowerControlRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 107), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 67), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_1), (u'presence', u'conditional')]), dict([(u'id', 24), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 68), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_3), (u'presence', u'conditional')]), dict([(u'id', 91), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_4), (u'presence', u'conditional')]), dict([(u'id', 90), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_5), (u'presence', u'conditional')]), dict([(u'id', 194), (u'criticality', u'ignore'), (u'Value', _DL_PowerControlRequest_IEs_val_Value_6), (u'presence', u'conditional')])], rr=[], ev=[], er=[])
    
    #-----< DL-ReferencePowerInformationList-DL-PC-Rqst >-----#
    DL_ReferencePowerInformationList_DL_PC_Rqst = SEQ_OF(name=u'DL-ReferencePowerInformationList-DL-PC-Rqst', mode=MODE_TYPE)
    _DL_ReferencePowerInformationList_DL_PC_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-ReferencePowerInformation-DL-PC-Rqst')))
    ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', ____DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id._const_tab = ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id._const_tab_at = None
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id._const_tab_id = u'id'
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality._const_tab = ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality._const_tab_at = ('..', u'id')
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality._const_tab_id = u'criticality'
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value._const_tab = ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value._const_tab_at = ('..', u'id')
    __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value._const_tab_id = u'Value'
    _DL_ReferencePowerInformationList_DL_PC_Rqst__item_._cont = ASN1Dict([
        (u'id', __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id),
        (u'criticality', __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality),
        (u'value', __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value),
        ])
    _DL_ReferencePowerInformationList_DL_PC_Rqst__item_._ext = None
    DL_ReferencePowerInformationList_DL_PC_Rqst._cont = _DL_ReferencePowerInformationList_DL_PC_Rqst__item_
    DL_ReferencePowerInformationList_DL_PC_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-ReferencePowerInformation-DL-PC-Rqst-IEs >-----#
    DL_ReferencePowerInformation_DL_PC_Rqst_IEs = CLASS(name=u'DL-ReferencePowerInformation-DL-PC-Rqst-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_ReferencePowerInformation_DL_PC_Rqst_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-ReferencePowerInformation-DL-PC-Rqst')))
    DL_ReferencePowerInformation_DL_PC_Rqst_IEs._val = ASN1Set(rv=[dict([(u'id', 69), (u'criticality', u'ignore'), (u'Value', _DL_ReferencePowerInformation_DL_PC_Rqst_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-ReferencePowerInformation-DL-PC-Rqst >-----#
    DL_ReferencePowerInformation_DL_PC_Rqst = SEQ(name=u'DL-ReferencePowerInformation-DL-PC-Rqst', mode=MODE_TYPE)
    _DL_ReferencePowerInformation_DL_PC_Rqst_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _DL_ReferencePowerInformation_DL_PC_Rqst_dl_Reference_Power = INT(name=u'dl-Reference-Power', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DL-Power')))
    _DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id._const_tab = ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id_tab
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality._const_tab = ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality_tab
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue._const_tab = ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id),
        (u'criticality', ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue),
        ])
    __DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item_._ext = None
    _DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions._cont = __DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item_
    _DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_ReferencePowerInformation_DL_PC_Rqst._cont = ASN1Dict([
        (u'rL-ID', _DL_ReferencePowerInformation_DL_PC_Rqst_rL_ID),
        (u'dl-Reference-Power', _DL_ReferencePowerInformation_DL_PC_Rqst_dl_Reference_Power),
        (u'iE-Extensions', _DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions),
        ])
    DL_ReferencePowerInformation_DL_PC_Rqst._ext = []
    
    #-----< DL-ReferencePowerInformation-DL-PC-Rqst-ExtIEs >-----#
    DL_ReferencePowerInformation_DL_PC_Rqst_ExtIEs = CLASS(name=u'DL-ReferencePowerInformation-DL-PC-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_ReferencePowerInformation_DL_PC_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerControlRequest-Extensions >-----#
    DL_PowerControlRequest_Extensions = CLASS(name=u'DL-PowerControlRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_PowerControlRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-PowerTimeslotControlRequest >-----#
    DL_PowerTimeslotControlRequest = SEQ(name=u'DL-PowerTimeslotControlRequest', mode=MODE_TYPE)
    _DL_PowerTimeslotControlRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DL_PowerTimeslotControlRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-Info')))
    ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id._const_tab = ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id._const_tab_at = None
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality._const_tab = ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value._const_tab = ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DL_PowerTimeslotControlRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __DL_PowerTimeslotControlRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DL_PowerTimeslotControlRequest_protocolIEs__item__id),
        (u'criticality', ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality),
        (u'value', ___DL_PowerTimeslotControlRequest_protocolIEs__item__value),
        ])
    __DL_PowerTimeslotControlRequest_protocolIEs__item_._ext = None
    _DL_PowerTimeslotControlRequest_protocolIEs._cont = __DL_PowerTimeslotControlRequest_protocolIEs__item_
    _DL_PowerTimeslotControlRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DL_PowerTimeslotControlRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_PowerTimeslotControlRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')))
    _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 138), (u'criticality', u'ignore'), (u'Extension', _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 451), (u'criticality', u'ignore'), (u'Extension', _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id._const_tab = ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id._const_tab_at = None
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality._const_tab = ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue._const_tab = ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_PowerTimeslotControlRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id),
        (u'criticality', ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue),
        ])
    __DL_PowerTimeslotControlRequest_protocolExtensions__item_._ext = None
    _DL_PowerTimeslotControlRequest_protocolExtensions._cont = __DL_PowerTimeslotControlRequest_protocolExtensions__item_
    _DL_PowerTimeslotControlRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_PowerTimeslotControlRequest._cont = ASN1Dict([
        (u'protocolIEs', _DL_PowerTimeslotControlRequest_protocolIEs),
        (u'protocolExtensions', _DL_PowerTimeslotControlRequest_protocolExtensions),
        ])
    DL_PowerTimeslotControlRequest._ext = []
    
    #-----< DL-PowerTimeslotControlRequest-IEs >-----#
    DL_PowerTimeslotControlRequest_IEs = CLASS(name=u'DL-PowerTimeslotControlRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_PowerTimeslotControlRequest_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-Info')))
    DL_PowerTimeslotControlRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 37), (u'criticality', u'ignore'), (u'Value', _DL_PowerTimeslotControlRequest_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-PowerTimeslotControlRequest-Extensions >-----#
    DL_PowerTimeslotControlRequest_Extensions = CLASS(name=u'DL-PowerTimeslotControlRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_PowerTimeslotControlRequest_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DL-TimeSlot-ISCP-LCR-Information')))
    _DL_PowerTimeslotControlRequest_Extensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP')))
    _DL_PowerTimeslotControlRequest_Extensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PrimaryCCPCH-RSCP-Delta')))
    DL_PowerTimeslotControlRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 138), (u'criticality', u'ignore'), (u'Extension', _DL_PowerTimeslotControlRequest_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 451), (u'criticality', u'ignore'), (u'Extension', _DL_PowerTimeslotControlRequest_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 539), (u'criticality', u'ignore'), (u'Extension', _DL_PowerTimeslotControlRequest_Extensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationRequestFDD >-----#
    PhysicalChannelReconfigurationRequestFDD = SEQ(name=u'PhysicalChannelReconfigurationRequestFDD', mode=MODE_TYPE)
    _PhysicalChannelReconfigurationRequestFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __PhysicalChannelReconfigurationRequestFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-PhyChReconfRqstFDD')))
    ____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 110), (u'criticality', u'reject'), (u'Value', _____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab = ____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab = ____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab = ____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __PhysicalChannelReconfigurationRequestFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__criticality),
        (u'value', ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__value),
        ])
    __PhysicalChannelReconfigurationRequestFDD_protocolIEs__item_._ext = None
    _PhysicalChannelReconfigurationRequestFDD_protocolIEs._cont = __PhysicalChannelReconfigurationRequestFDD_protocolIEs__item_
    _PhysicalChannelReconfigurationRequestFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalChannelReconfigurationRequestFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab = ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab = ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab = ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue),
        ])
    __PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item_._ext = None
    _PhysicalChannelReconfigurationRequestFDD_protocolExtensions._cont = __PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item_
    _PhysicalChannelReconfigurationRequestFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalChannelReconfigurationRequestFDD._cont = ASN1Dict([
        (u'protocolIEs', _PhysicalChannelReconfigurationRequestFDD_protocolIEs),
        (u'protocolExtensions', _PhysicalChannelReconfigurationRequestFDD_protocolExtensions),
        ])
    PhysicalChannelReconfigurationRequestFDD._ext = []
    
    #-----< PhysicalChannelReconfigurationRequestFDD-IEs >-----#
    PhysicalChannelReconfigurationRequestFDD_IEs = CLASS(name=u'PhysicalChannelReconfigurationRequestFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _PhysicalChannelReconfigurationRequestFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-PhyChReconfRqstFDD')))
    PhysicalChannelReconfigurationRequestFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 110), (u'criticality', u'reject'), (u'Value', _PhysicalChannelReconfigurationRequestFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RL-Information-PhyChReconfRqstFDD >-----#
    RL_Information_PhyChReconfRqstFDD = SEQ(name=u'RL-Information-PhyChReconfRqstFDD', mode=MODE_TYPE)
    _RL_Information_PhyChReconfRqstFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_PhyChReconfRqstFDD_dl_CodeInformation = SEQ(name=u'dl-CodeInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CodeInformationList-PhyChReconfRqstFDD')))
    _RL_Information_PhyChReconfRqstFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_PhyChReconfRqstFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Reconfiguration-Information')))
    ____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 918), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id._const_tab = ____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_PhyChReconfRqstFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_PhyChReconfRqstFDD_iE_Extensions__item_._ext = None
    _RL_Information_PhyChReconfRqstFDD_iE_Extensions._cont = __RL_Information_PhyChReconfRqstFDD_iE_Extensions__item_
    _RL_Information_PhyChReconfRqstFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_PhyChReconfRqstFDD._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_PhyChReconfRqstFDD_rL_ID),
        (u'dl-CodeInformation', _RL_Information_PhyChReconfRqstFDD_dl_CodeInformation),
        (u'iE-Extensions', _RL_Information_PhyChReconfRqstFDD_iE_Extensions),
        ])
    RL_Information_PhyChReconfRqstFDD._ext = []
    
    #-----< RL-Information-PhyChReconfRqstFDD-ExtIEs >-----#
    RL_Information_PhyChReconfRqstFDD_ExtIEs = CLASS(name=u'RL-Information-PhyChReconfRqstFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_PhyChReconfRqstFDD_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'F-DPCH-SlotFormat')))
    _RL_Information_PhyChReconfRqstFDD_ExtIEs_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FTPICH-Reconfiguration-Information')))
    RL_Information_PhyChReconfRqstFDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 692), (u'criticality', u'ignore'), (u'Extension', _RL_Information_PhyChReconfRqstFDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 918), (u'criticality', u'ignore'), (u'Extension', _RL_Information_PhyChReconfRqstFDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-CodeInformationList-PhyChReconfRqstFDD >-----#
    DL_CodeInformationList_PhyChReconfRqstFDD = SEQ(name=u'DL-CodeInformationList-PhyChReconfRqstFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CodeInformationList_PhyChReconfRqstFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CodeInformationList_PhyChReconfRqstFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CodeInformationList_PhyChReconfRqstFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    __DL_CodeInformationList_PhyChReconfRqstFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'notify'), (u'Value', ___DL_CodeInformationList_PhyChReconfRqstFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CodeInformationList_PhyChReconfRqstFDD_id._const_tab = __DL_CodeInformationList_PhyChReconfRqstFDD_id_tab
    _DL_CodeInformationList_PhyChReconfRqstFDD_id._const_tab_at = None
    _DL_CodeInformationList_PhyChReconfRqstFDD_id._const_tab_id = u'id'
    _DL_CodeInformationList_PhyChReconfRqstFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CodeInformationList_PhyChReconfRqstFDD_criticality._const_tab = __DL_CodeInformationList_PhyChReconfRqstFDD_id_tab
    _DL_CodeInformationList_PhyChReconfRqstFDD_criticality._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_PhyChReconfRqstFDD_criticality._const_tab_id = u'criticality'
    _DL_CodeInformationList_PhyChReconfRqstFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CodeInformationList_PhyChReconfRqstFDD_value._const_tab = __DL_CodeInformationList_PhyChReconfRqstFDD_id_tab
    _DL_CodeInformationList_PhyChReconfRqstFDD_value._const_tab_at = ('..', u'id')
    _DL_CodeInformationList_PhyChReconfRqstFDD_value._const_tab_id = u'Value'
    DL_CodeInformationList_PhyChReconfRqstFDD._cont = ASN1Dict([
        (u'id', _DL_CodeInformationList_PhyChReconfRqstFDD_id),
        (u'criticality', _DL_CodeInformationList_PhyChReconfRqstFDD_criticality),
        (u'value', _DL_CodeInformationList_PhyChReconfRqstFDD_value),
        ])
    DL_CodeInformationList_PhyChReconfRqstFDD._ext = None
    
    #-----< DL-CodeInformationListIEs-PhyChReconfRqstFDD >-----#
    DL_CodeInformationListIEs_PhyChReconfRqstFDD = CLASS(name=u'DL-CodeInformationListIEs-PhyChReconfRqstFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CodeInformationListIEs_PhyChReconfRqstFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FDD-DL-CodeInformation')))
    DL_CodeInformationListIEs_PhyChReconfRqstFDD._val = ASN1Set(rv=[dict([(u'id', 54), (u'criticality', u'notify'), (u'Value', _DL_CodeInformationListIEs_PhyChReconfRqstFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< PhysicalChannelReconfigurationRequestFDD-Extensions >-----#
    PhysicalChannelReconfigurationRequestFDD_Extensions = CLASS(name=u'PhysicalChannelReconfigurationRequestFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PhysicalChannelReconfigurationRequestFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationRequestTDD >-----#
    PhysicalChannelReconfigurationRequestTDD = SEQ(name=u'PhysicalChannelReconfigurationRequestTDD', mode=MODE_TYPE)
    _PhysicalChannelReconfigurationRequestTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __PhysicalChannelReconfigurationRequestTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-PhyChReconfRqstTDD')))
    ____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab = ____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab = ____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab = ____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __PhysicalChannelReconfigurationRequestTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__criticality),
        (u'value', ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__value),
        ])
    __PhysicalChannelReconfigurationRequestTDD_protocolIEs__item_._ext = None
    _PhysicalChannelReconfigurationRequestTDD_protocolIEs._cont = __PhysicalChannelReconfigurationRequestTDD_protocolIEs__item_
    _PhysicalChannelReconfigurationRequestTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalChannelReconfigurationRequestTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab = ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab = ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality_tab
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab = ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue_tab
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue),
        ])
    __PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item_._ext = None
    _PhysicalChannelReconfigurationRequestTDD_protocolExtensions._cont = __PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item_
    _PhysicalChannelReconfigurationRequestTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalChannelReconfigurationRequestTDD._cont = ASN1Dict([
        (u'protocolIEs', _PhysicalChannelReconfigurationRequestTDD_protocolIEs),
        (u'protocolExtensions', _PhysicalChannelReconfigurationRequestTDD_protocolExtensions),
        ])
    PhysicalChannelReconfigurationRequestTDD._ext = []
    
    #-----< PhysicalChannelReconfigurationRequestTDD-IEs >-----#
    PhysicalChannelReconfigurationRequestTDD_IEs = CLASS(name=u'PhysicalChannelReconfigurationRequestTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _PhysicalChannelReconfigurationRequestTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Information-PhyChReconfRqstTDD')))
    PhysicalChannelReconfigurationRequestTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 111), (u'criticality', u'reject'), (u'Value', _PhysicalChannelReconfigurationRequestTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RL-Information-PhyChReconfRqstTDD >-----#
    RL_Information_PhyChReconfRqstTDD = SEQ(name=u'RL-Information-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _RL_Information_PhyChReconfRqstTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Information_PhyChReconfRqstTDD_ul_CCTrCH_Information = SEQ(name=u'ul-CCTrCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationList-PhyChReconfRqstTDD')), opt=True)
    _RL_Information_PhyChReconfRqstTDD_dl_CCTrCH_Information = SEQ(name=u'dl-CCTrCH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationList-PhyChReconfRqstTDD')), opt=True)
    _RL_Information_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Information_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD')))
    _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD')))
    _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768')))
    _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    ____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 493), (u'criticality', u'reject'), (u'Extension', _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 494), (u'criticality', u'reject'), (u'Extension', _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 626), (u'criticality', u'reject'), (u'Extension', _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Information_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __RL_Information_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _RL_Information_PhyChReconfRqstTDD_iE_Extensions._cont = __RL_Information_PhyChReconfRqstTDD_iE_Extensions__item_
    _RL_Information_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Information_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'rL-ID', _RL_Information_PhyChReconfRqstTDD_rL_ID),
        (u'ul-CCTrCH-Information', _RL_Information_PhyChReconfRqstTDD_ul_CCTrCH_Information),
        (u'dl-CCTrCH-Information', _RL_Information_PhyChReconfRqstTDD_dl_CCTrCH_Information),
        (u'iE-Extensions', _RL_Information_PhyChReconfRqstTDD_iE_Extensions),
        ])
    RL_Information_PhyChReconfRqstTDD._ext = []
    
    #-----< RL-Information-PhyChReconfRqstTDD-ExtIEs >-----#
    RL_Information_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'RL-Information-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD')))
    _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD')))
    _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768')))
    _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    RL_Information_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 493), (u'criticality', u'reject'), (u'Extension', _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 494), (u'criticality', u'reject'), (u'Extension', _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 626), (u'criticality', u'reject'), (u'Extension', _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-CCTrCH-InformationList-PhyChReconfRqstTDD >-----#
    UL_CCTrCH_InformationList_PhyChReconfRqstTDD = SEQ(name=u'UL-CCTrCH-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD')))
    __UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 173), (u'criticality', u'reject'), (u'Value', ___UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id._const_tab = __UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id._const_tab_at = None
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id._const_tab_id = u'id'
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab = __UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_at = ('..', u'id')
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_id = u'criticality'
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_value._const_tab = __UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_value._const_tab_at = ('..', u'id')
    _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_value._const_tab_id = u'Value'
    UL_CCTrCH_InformationList_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'id', _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id),
        (u'criticality', _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality),
        (u'value', _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_value),
        ])
    UL_CCTrCH_InformationList_PhyChReconfRqstTDD._ext = None
    
    #-----< UL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD >-----#
    UL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD = CLASS(name=u'UL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD')))
    UL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD._val = ASN1Set(rv=[dict([(u'id', 173), (u'criticality', u'reject'), (u'Value', _UL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD >-----#
    UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = SEQ_OF(name=u'UL-CCTrCH-InformationListIE-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD')))
    UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD._cont = _UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD__item_
    UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< UL-CCTrCH-InformationItem-PhyChReconfRqstTDD >-----#
    UL_CCTrCH_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ul_DPCH_Information = SEQ(name=u'ul-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationList-PhyChReconfRqstTDD')))
    _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_CCTrCH_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_cCTrCH_ID),
        (u'ul-DPCH-Information', _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ul_DPCH_Information),
        (u'iE-Extensions', _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    UL_CCTrCH_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< UL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'UL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCH-InformationList-PhyChReconfRqstTDD >-----#
    UL_DPCH_InformationList_PhyChReconfRqstTDD = SEQ(name=u'UL-DPCH-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-PhyChReconfRqstTDD')))
    __UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'notify'), (u'Value', ___UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_id._const_tab = __UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_id._const_tab_at = None
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_id._const_tab_id = u'id'
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab = __UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_id = u'criticality'
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_value._const_tab = __UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_value._const_tab_at = ('..', u'id')
    _UL_DPCH_InformationList_PhyChReconfRqstTDD_value._const_tab_id = u'Value'
    UL_DPCH_InformationList_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'id', _UL_DPCH_InformationList_PhyChReconfRqstTDD_id),
        (u'criticality', _UL_DPCH_InformationList_PhyChReconfRqstTDD_criticality),
        (u'value', _UL_DPCH_InformationList_PhyChReconfRqstTDD_value),
        ])
    UL_DPCH_InformationList_PhyChReconfRqstTDD._ext = None
    
    #-----< UL-DPCH-InformationListIEs-PhyChReconfRqstTDD >-----#
    UL_DPCH_InformationListIEs_PhyChReconfRqstTDD = CLASS(name=u'UL-DPCH-InformationListIEs-PhyChReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UL_DPCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-DPCH-InformationItem-PhyChReconfRqstTDD')))
    UL_DPCH_InformationListIEs_PhyChReconfRqstTDD._val = ASN1Set(rv=[dict([(u'id', 180), (u'criticality', u'notify'), (u'Value', _UL_DPCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UL-DPCH-InformationItem-PhyChReconfRqstTDD >-----#
    UL_DPCH_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'UL-DPCH-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')), opt=True)
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')), opt=True)
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')), opt=True)
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_uL_Timeslot_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'uL-Timeslot-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationList-PhyChReconfRqstTDD')), opt=True)
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD')))
    _____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationList-PhyChReconfRqstTDD768')))
    ____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 105), (u'criticality', u'reject'), (u'Extension', _____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 627), (u'criticality', u'reject'), (u'Extension', _____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_DPCH_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionPeriod),
        (u'repetitionLength', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionLength),
        (u'tDD-DPCHOffset', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_tDD_DPCHOffset),
        (u'uL-Timeslot-InformationList-PhyChReconfRqstTDD', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_uL_Timeslot_InformationList_PhyChReconfRqstTDD),
        (u'iE-Extensions', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    UL_DPCH_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< UL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'UL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD')))
    _UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationList-PhyChReconfRqstTDD768')))
    UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 105), (u'criticality', u'reject'), (u'Extension', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 627), (u'criticality', u'reject'), (u'Extension', _UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD >-----#
    UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'UL-TimeslotLCR-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD')))
    UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD._cont = _UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD__item_
    UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD >-----#
    UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')), opt=True)
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_uL_Code_LCR_Information = SEQ_OF(name=u'uL-Code-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-LCR-Information')), opt=True)
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLCCHinformation')))
    ____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 612), (u'criticality', u'reject'), (u'Extension', _____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'timeSlotLCR', _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_timeSlotLCR),
        (u'midambleShiftLCR', _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_midambleShiftLCR),
        (u'tFCI-Presence', _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_tFCI_Presence),
        (u'uL-Code-LCR-Information', _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_uL_Code_LCR_Information),
        (u'iE-Extensions', _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'UL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PLCCHinformation')))
    UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 612), (u'criticality', u'reject'), (u'Extension', _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationList-PhyChReconfRqstTDD >-----#
    UL_Timeslot_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'UL-Timeslot-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_Timeslot_InformationList_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationItem-PhyChReconfRqstTDD')))
    UL_Timeslot_InformationList_PhyChReconfRqstTDD._cont = _UL_Timeslot_InformationList_PhyChReconfRqstTDD__item_
    UL_Timeslot_InformationList_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationItem-PhyChReconfRqstTDD >-----#
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_uL_Code_Information = SEQ_OF(name=u'uL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-Information')), opt=True)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'timeSlot', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_timeSlot),
        (u'midambleShiftAndBurstType', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType),
        (u'tFCI-Presence', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_tFCI_Presence),
        (u'uL-Code-Information', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_uL_Code_Information),
        (u'iE-Extensions', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< UL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-Timeslot-InformationList-PhyChReconfRqstTDD768 >-----#
    UL_Timeslot_InformationList_PhyChReconfRqstTDD768 = SEQ_OF(name=u'UL-Timeslot-InformationList-PhyChReconfRqstTDD768', mode=MODE_TYPE)
    _UL_Timeslot_InformationList_PhyChReconfRqstTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768')))
    UL_Timeslot_InformationList_PhyChReconfRqstTDD768._cont = _UL_Timeslot_InformationList_PhyChReconfRqstTDD768__item_
    UL_Timeslot_InformationList_PhyChReconfRqstTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< UL-Timeslot-InformationItem-PhyChReconfRqstTDD768 >-----#
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD768 = SEQ(name=u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768', mode=MODE_TYPE)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_uL_Code_Information768 = SEQ_OF(name=u'uL-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-UL-Code-Information768')), opt=True)
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id),
        (u'criticality', ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions._cont = __UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_
    _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD768._cont = ASN1Dict([
        (u'timeSlot', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeSlot),
        (u'midambleShiftAndBurstType768', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_tFCI_Presence),
        (u'uL-Code-Information768', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_uL_Code_Information768),
        (u'iE-Extensions', _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions),
        ])
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD768._ext = []
    
    #-----< UL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs >-----#
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs = CLASS(name=u'UL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-CCTrCH-InformationList-PhyChReconfRqstTDD >-----#
    DL_CCTrCH_InformationList_PhyChReconfRqstTDD = SEQ(name=u'DL-CCTrCH-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD')))
    __DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', ___DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id._const_tab = __DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id._const_tab_at = None
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id._const_tab_id = u'id'
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab = __DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_at = ('..', u'id')
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_id = u'criticality'
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_value._const_tab = __DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_value._const_tab_at = ('..', u'id')
    _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_value._const_tab_id = u'Value'
    DL_CCTrCH_InformationList_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'id', _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id),
        (u'criticality', _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality),
        (u'value', _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_value),
        ])
    DL_CCTrCH_InformationList_PhyChReconfRqstTDD._ext = None
    
    #-----< DL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD >-----#
    DL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD = CLASS(name=u'DL-CCTrCH-InformationListIEs-PhyChReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD')))
    DL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD._val = ASN1Set(rv=[dict([(u'id', 48), (u'criticality', u'reject'), (u'Value', _DL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD >-----#
    DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD = SEQ_OF(name=u'DL-CCTrCH-InformationListIE-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD')))
    DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD._cont = _DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD__item_
    DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DL-CCTrCH-InformationItem-PhyChReconfRqstTDD >-----#
    DL_CCTrCH_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_cCTrCH_ID = INT(name=u'cCTrCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CCTrCH-ID')))
    _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_dl_DPCH_Information = SEQ(name=u'dl-DPCH-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationList-PhyChReconfRqstTDD')))
    _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_CCTrCH_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'cCTrCH-ID', _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_cCTrCH_ID),
        (u'dl-DPCH-Information', _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_dl_DPCH_Information),
        (u'iE-Extensions', _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    DL_CCTrCH_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< DL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'DL-CCTrCH-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-DPCH-InformationList-PhyChReconfRqstTDD >-----#
    DL_DPCH_InformationList_PhyChReconfRqstTDD = SEQ(name=u'DL-DPCH-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-PhyChReconfRqstTDD')))
    __DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 62), (u'criticality', u'notify'), (u'Value', ___DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_id._const_tab = __DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_id._const_tab_at = None
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_id._const_tab_id = u'id'
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab = __DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_criticality._const_tab_id = u'criticality'
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_value._const_tab = __DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_value._const_tab_at = ('..', u'id')
    _DL_DPCH_InformationList_PhyChReconfRqstTDD_value._const_tab_id = u'Value'
    DL_DPCH_InformationList_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'id', _DL_DPCH_InformationList_PhyChReconfRqstTDD_id),
        (u'criticality', _DL_DPCH_InformationList_PhyChReconfRqstTDD_criticality),
        (u'value', _DL_DPCH_InformationList_PhyChReconfRqstTDD_value),
        ])
    DL_DPCH_InformationList_PhyChReconfRqstTDD._ext = None
    
    #-----< DL-DPCH-InformationListIEs-PhyChReconfRqstTDD >-----#
    DL_DPCH_InformationListIEs_PhyChReconfRqstTDD = CLASS(name=u'DL-DPCH-InformationListIEs-PhyChReconfRqstTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DL_DPCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-DPCH-InformationItem-PhyChReconfRqstTDD')))
    DL_DPCH_InformationListIEs_PhyChReconfRqstTDD._val = ASN1Set(rv=[dict([(u'id', 62), (u'criticality', u'notify'), (u'Value', _DL_DPCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DL-DPCH-InformationItem-PhyChReconfRqstTDD >-----#
    DL_DPCH_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'DL-DPCH-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionPeriod = ENUM(name=u'repetitionPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionPeriod')), opt=True)
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionLength = INT(name=u'repetitionLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RepetitionLength')), opt=True)
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_tDD_DPCHOffset = CHOICE(name=u'tDD-DPCHOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DPCHOffset')), opt=True)
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_dL_Timeslot_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'dL-Timeslot-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationList-PhyChReconfRqstTDD')), opt=True)
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD')))
    _____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationList-PhyChReconfRqstTDD768')))
    ____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 106), (u'criticality', u'reject'), (u'Extension', _____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 628), (u'criticality', u'reject'), (u'Extension', _____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_DPCH_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'repetitionPeriod', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionPeriod),
        (u'repetitionLength', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionLength),
        (u'tDD-DPCHOffset', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_tDD_DPCHOffset),
        (u'dL-Timeslot-InformationList-PhyChReconfRqstTDD', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_dL_Timeslot_InformationList_PhyChReconfRqstTDD),
        (u'iE-Extensions', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    DL_DPCH_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< DL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'DL-DPCH-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD')))
    _DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationList-PhyChReconfRqstTDD768')))
    DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 106), (u'criticality', u'reject'), (u'Extension', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 628), (u'criticality', u'reject'), (u'Extension', _DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD >-----#
    DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'DL-TimeslotLCR-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD')))
    DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD._cont = _DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD__item_
    DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD >-----#
    DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')), opt=True)
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_dL_Code_LCR_Information = SEQ_OF(name=u'dL-Code-LCR-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-LCR-Information')), opt=True)
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'timeSlotLCR', _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_timeSlotLCR),
        (u'midambleShiftLCR', _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_midambleShiftLCR),
        (u'tFCI-Presence', _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_tFCI_Presence),
        (u'dL-Code-LCR-Information', _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_dL_Code_LCR_Information),
        (u'iE-Extensions', _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'DL-TimeslotLCR-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationList-PhyChReconfRqstTDD >-----#
    DL_Timeslot_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'DL-Timeslot-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_Timeslot_InformationList_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationItem-PhyChReconfRqstTDD')))
    DL_Timeslot_InformationList_PhyChReconfRqstTDD._cont = _DL_Timeslot_InformationList_PhyChReconfRqstTDD__item_
    DL_Timeslot_InformationList_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationItem-PhyChReconfRqstTDD >-----#
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')), opt=True)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_dL_Code_Information = SEQ_OF(name=u'dL-Code-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-Information')), opt=True)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'timeSlot', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_timeSlot),
        (u'midambleShiftAndBurstType', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType),
        (u'tFCI-Presence', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_tFCI_Presence),
        (u'dL-Code-Information', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_dL_Code_Information),
        (u'iE-Extensions', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< DL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-Timeslot-InformationList-PhyChReconfRqstTDD768 >-----#
    DL_Timeslot_InformationList_PhyChReconfRqstTDD768 = SEQ_OF(name=u'DL-Timeslot-InformationList-PhyChReconfRqstTDD768', mode=MODE_TYPE)
    _DL_Timeslot_InformationList_PhyChReconfRqstTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768')))
    DL_Timeslot_InformationList_PhyChReconfRqstTDD768._cont = _DL_Timeslot_InformationList_PhyChReconfRqstTDD768__item_
    DL_Timeslot_InformationList_PhyChReconfRqstTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DL-Timeslot-InformationItem-PhyChReconfRqstTDD768 >-----#
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD768 = SEQ(name=u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768', mode=MODE_TYPE)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')), opt=True)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_tFCI_Presence = ENUM(name=u'tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TFCI-Presence')), opt=True)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_dL_Code_Information768 = SEQ_OF(name=u'dL-Code-Information768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TDD-DL-Code-Information768')), opt=True)
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab = ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab_at = None
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab = ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab = ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id),
        (u'criticality', ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue),
        ])
    __DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_._ext = None
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions._cont = __DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_
    _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD768._cont = ASN1Dict([
        (u'timeSlot', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeSlot),
        (u'midambleShiftAndBurstType768', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768),
        (u'tFCI-Presence', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_tFCI_Presence),
        (u'dL-Code-Information768', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_dL_Code_Information768),
        (u'iE-Extensions', _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions),
        ])
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD768._ext = []
    
    #-----< DL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs >-----#
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs = CLASS(name=u'DL-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD >-----#
    HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD = SEQ_OF(name=u'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD')))
    HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD._cont = _HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD__item_
    HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD >-----#
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD = SEQ(name=u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType = CHOICE(name=u'midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType')))
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions._cont = __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'timeslot', _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_timeslot),
        (u'midambleShiftAndBurstType', _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType),
        (u'iE-Extensions', _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions),
        ])
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD._ext = []
    
    #-----< HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs >-----#
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD >-----#
    HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD = SEQ_OF(name=u'HSPDSCH-Timeslot-InformationListLCR-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD')))
    HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD._cont = _HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD__item_
    HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD >-----#
    HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD = SEQ(name=u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD', mode=MODE_TYPE)
    _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_timeslotLCR = INT(name=u'timeslotLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')))
    _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_midambleShiftLCR = SEQ(name=u'midambleShiftLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftLCR')))
    _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab = ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id_tab
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_at = None
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab = ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab = ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id),
        (u'criticality', ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue),
        ])
    __HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item_._ext = None
    _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions._cont = __HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item_
    _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD._cont = ASN1Dict([
        (u'timeslotLCR', _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_timeslotLCR),
        (u'midambleShiftLCR', _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_midambleShiftLCR),
        (u'iE-Extensions', _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions),
        ])
    HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD._ext = []
    
    #-----< HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD-ExtIEs >-----#
    HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_ExtIEs = CLASS(name=u'HSPDSCH-Timeslot-InformationItemLCR-PhyChReconfRqstTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768 >-----#
    HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768 = SEQ_OF(name=u'HSPDSCH-Timeslot-InformationList-PhyChReconfRqstTDD768', mode=MODE_TYPE)
    _HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768')))
    HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768._cont = _HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768__item_
    HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768 >-----#
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768 = SEQ(name=u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768', mode=MODE_TYPE)
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeslot = INT(name=u'timeslot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')))
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768 = CHOICE(name=u'midambleShiftAndBurstType768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MidambleShiftAndBurstType768')))
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab = ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab_at = None
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id._const_tab_id = u'id'
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab = ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab = ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id),
        (u'criticality', ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality),
        (u'extensionValue', ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue),
        ])
    __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_._ext = None
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions._cont = __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_
    _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768._cont = ASN1Dict([
        (u'timeslot', _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeslot),
        (u'midambleShiftAndBurstType768', _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768),
        (u'iE-Extensions', _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions),
        ])
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768._ext = []
    
    #-----< HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs >-----#
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs = CLASS(name=u'HSPDSCH-Timeslot-InformationItem-PhyChReconfRqstTDD768-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationRequestTDD-Extensions >-----#
    PhysicalChannelReconfigurationRequestTDD_Extensions = CLASS(name=u'PhysicalChannelReconfigurationRequestTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PhysicalChannelReconfigurationRequestTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationCommand >-----#
    PhysicalChannelReconfigurationCommand = SEQ(name=u'PhysicalChannelReconfigurationCommand', mode=MODE_TYPE)
    _PhysicalChannelReconfigurationCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __PhysicalChannelReconfigurationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__id._const_tab = ____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__criticality._const_tab = ____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__value._const_tab = ____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __PhysicalChannelReconfigurationCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationCommand_protocolIEs__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationCommand_protocolIEs__item__criticality),
        (u'value', ___PhysicalChannelReconfigurationCommand_protocolIEs__item__value),
        ])
    __PhysicalChannelReconfigurationCommand_protocolIEs__item_._ext = None
    _PhysicalChannelReconfigurationCommand_protocolIEs._cont = __PhysicalChannelReconfigurationCommand_protocolIEs__item_
    _PhysicalChannelReconfigurationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalChannelReconfigurationCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalChannelReconfigurationCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__id._const_tab = ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__id_tab
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality._const_tab = ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality_tab
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue._const_tab = ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue_tab
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __PhysicalChannelReconfigurationCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue),
        ])
    __PhysicalChannelReconfigurationCommand_protocolExtensions__item_._ext = None
    _PhysicalChannelReconfigurationCommand_protocolExtensions._cont = __PhysicalChannelReconfigurationCommand_protocolExtensions__item_
    _PhysicalChannelReconfigurationCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalChannelReconfigurationCommand._cont = ASN1Dict([
        (u'protocolIEs', _PhysicalChannelReconfigurationCommand_protocolIEs),
        (u'protocolExtensions', _PhysicalChannelReconfigurationCommand_protocolExtensions),
        ])
    PhysicalChannelReconfigurationCommand._ext = []
    
    #-----< PhysicalChannelReconfigurationCommand-IEs >-----#
    PhysicalChannelReconfigurationCommand_IEs = CLASS(name=u'PhysicalChannelReconfigurationCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _PhysicalChannelReconfigurationCommand_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _PhysicalChannelReconfigurationCommand_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    PhysicalChannelReconfigurationCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 8), (u'criticality', u'ignore'), (u'Value', _PhysicalChannelReconfigurationCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _PhysicalChannelReconfigurationCommand_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationCommand-Extensions >-----#
    PhysicalChannelReconfigurationCommand_Extensions = CLASS(name=u'PhysicalChannelReconfigurationCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PhysicalChannelReconfigurationCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationFailure >-----#
    PhysicalChannelReconfigurationFailure = SEQ(name=u'PhysicalChannelReconfigurationFailure', mode=MODE_TYPE)
    _PhysicalChannelReconfigurationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __PhysicalChannelReconfigurationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__id._const_tab = ____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab = ____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__value._const_tab = ____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __PhysicalChannelReconfigurationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationFailure_protocolIEs__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationFailure_protocolIEs__item__criticality),
        (u'value', ___PhysicalChannelReconfigurationFailure_protocolIEs__item__value),
        ])
    __PhysicalChannelReconfigurationFailure_protocolIEs__item_._ext = None
    _PhysicalChannelReconfigurationFailure_protocolIEs._cont = __PhysicalChannelReconfigurationFailure_protocolIEs__item_
    _PhysicalChannelReconfigurationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PhysicalChannelReconfigurationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PhysicalChannelReconfigurationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__id._const_tab = ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__id_tab
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__id._const_tab_at = None
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab = ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality_tab
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab = ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __PhysicalChannelReconfigurationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__id),
        (u'criticality', ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue),
        ])
    __PhysicalChannelReconfigurationFailure_protocolExtensions__item_._ext = None
    _PhysicalChannelReconfigurationFailure_protocolExtensions._cont = __PhysicalChannelReconfigurationFailure_protocolExtensions__item_
    _PhysicalChannelReconfigurationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PhysicalChannelReconfigurationFailure._cont = ASN1Dict([
        (u'protocolIEs', _PhysicalChannelReconfigurationFailure_protocolIEs),
        (u'protocolExtensions', _PhysicalChannelReconfigurationFailure_protocolExtensions),
        ])
    PhysicalChannelReconfigurationFailure._ext = []
    
    #-----< PhysicalChannelReconfigurationFailure-IEs >-----#
    PhysicalChannelReconfigurationFailure_IEs = CLASS(name=u'PhysicalChannelReconfigurationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _PhysicalChannelReconfigurationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _PhysicalChannelReconfigurationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    PhysicalChannelReconfigurationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _PhysicalChannelReconfigurationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _PhysicalChannelReconfigurationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PhysicalChannelReconfigurationFailure-Extensions >-----#
    PhysicalChannelReconfigurationFailure_Extensions = CLASS(name=u'PhysicalChannelReconfigurationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    PhysicalChannelReconfigurationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkCongestionIndication >-----#
    RadioLinkCongestionIndication = SEQ(name=u'RadioLinkCongestionIndication', mode=MODE_TYPE)
    _RadioLinkCongestionIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkCongestionIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkCongestionIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkCongestionIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkCongestionIndication_protocolIEs__item__id_tab_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CongestionCause')))
    _____RadioLinkCongestionIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-CongestInd')))
    ____RadioLinkCongestionIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _____RadioLinkCongestionIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _____RadioLinkCongestionIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkCongestionIndication_protocolIEs__item__id._const_tab = ____RadioLinkCongestionIndication_protocolIEs__item__id_tab
    ___RadioLinkCongestionIndication_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkCongestionIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkCongestionIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkCongestionIndication_protocolIEs__item__criticality._const_tab = ____RadioLinkCongestionIndication_protocolIEs__item__id_tab
    ___RadioLinkCongestionIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkCongestionIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkCongestionIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkCongestionIndication_protocolIEs__item__value._const_tab = ____RadioLinkCongestionIndication_protocolIEs__item__id_tab
    ___RadioLinkCongestionIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkCongestionIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkCongestionIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkCongestionIndication_protocolIEs__item__id),
        (u'criticality', ___RadioLinkCongestionIndication_protocolIEs__item__criticality),
        (u'value', ___RadioLinkCongestionIndication_protocolIEs__item__value),
        ])
    __RadioLinkCongestionIndication_protocolIEs__item_._ext = None
    _RadioLinkCongestionIndication_protocolIEs._cont = __RadioLinkCongestionIndication_protocolIEs__item_
    _RadioLinkCongestionIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkCongestionIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkCongestionIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkCongestionIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkCongestionIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkCongestionIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkCongestionIndication_protocolExtensions__item__id._const_tab = ____RadioLinkCongestionIndication_protocolExtensions__item__id_tab
    ___RadioLinkCongestionIndication_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkCongestionIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkCongestionIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkCongestionIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkCongestionIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkCongestionIndication_protocolExtensions__item__criticality._const_tab = ____RadioLinkCongestionIndication_protocolExtensions__item__criticality_tab
    ___RadioLinkCongestionIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkCongestionIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkCongestionIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkCongestionIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkCongestionIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkCongestionIndication_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkCongestionIndication_protocolExtensions__item__extensionValue_tab
    ___RadioLinkCongestionIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkCongestionIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkCongestionIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkCongestionIndication_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkCongestionIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkCongestionIndication_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkCongestionIndication_protocolExtensions__item_._ext = None
    _RadioLinkCongestionIndication_protocolExtensions._cont = __RadioLinkCongestionIndication_protocolExtensions__item_
    _RadioLinkCongestionIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkCongestionIndication._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkCongestionIndication_protocolIEs),
        (u'protocolExtensions', _RadioLinkCongestionIndication_protocolExtensions),
        ])
    RadioLinkCongestionIndication._ext = []
    
    #-----< RadioLinkCongestionIndication-IEs >-----#
    RadioLinkCongestionIndication_IEs = CLASS(name=u'RadioLinkCongestionIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkCongestionIndication_IEs_val_Value_0 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CongestionCause')))
    _RadioLinkCongestionIndication_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-RL-CongestInd')))
    RadioLinkCongestionIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 18), (u'criticality', u'ignore'), (u'Value', _RadioLinkCongestionIndication_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 56), (u'criticality', u'ignore'), (u'Value', _RadioLinkCongestionIndication_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-RL-CongestInd >-----#
    RL_InformationList_RL_CongestInd = SEQ_OF(name=u'RL-InformationList-RL-CongestInd', mode=MODE_TYPE)
    _RL_InformationList_RL_CongestInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_RL_CongestInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_RL_CongestInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_RL_CongestInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-RL-CongestInd')))
    ___RL_InformationList_RL_CongestInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', ____RL_InformationList_RL_CongestInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_RL_CongestInd__item__id._const_tab = ___RL_InformationList_RL_CongestInd__item__id_tab
    __RL_InformationList_RL_CongestInd__item__id._const_tab_at = None
    __RL_InformationList_RL_CongestInd__item__id._const_tab_id = u'id'
    __RL_InformationList_RL_CongestInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_RL_CongestInd__item__criticality._const_tab = ___RL_InformationList_RL_CongestInd__item__id_tab
    __RL_InformationList_RL_CongestInd__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_CongestInd__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_RL_CongestInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_RL_CongestInd__item__value._const_tab = ___RL_InformationList_RL_CongestInd__item__id_tab
    __RL_InformationList_RL_CongestInd__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_RL_CongestInd__item__value._const_tab_id = u'Value'
    _RL_InformationList_RL_CongestInd__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_RL_CongestInd__item__id),
        (u'criticality', __RL_InformationList_RL_CongestInd__item__criticality),
        (u'value', __RL_InformationList_RL_CongestInd__item__value),
        ])
    _RL_InformationList_RL_CongestInd__item_._ext = None
    RL_InformationList_RL_CongestInd._cont = _RL_InformationList_RL_CongestInd__item_
    RL_InformationList_RL_CongestInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-InformationItemIEs-RL-CongestInd >-----#
    RL_InformationItemIEs_RL_CongestInd = CLASS(name=u'RL-InformationItemIEs-RL-CongestInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_InformationItemIEs_RL_CongestInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-RL-CongestInd')))
    RL_InformationItemIEs_RL_CongestInd._val = ASN1Set(rv=[dict([(u'id', 55), (u'criticality', u'ignore'), (u'Value', _RL_InformationItemIEs_RL_CongestInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-RL-CongestInd >-----#
    RL_InformationItem_RL_CongestInd = SEQ(name=u'RL-InformationItem-RL-CongestInd', mode=MODE_TYPE)
    _RL_InformationItem_RL_CongestInd_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationItem_RL_CongestInd_dCH_Rate_Information = SEQ_OF(name=u'dCH-Rate-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-Rate-Information-RL-CongestInd')))
    _RL_InformationItem_RL_CongestInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_RL_CongestInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationList-RL-CongestInd')))
    _____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Indicator-For-E-DCH-HSDPA-Operation')))
    ____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 588), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 665), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab = ____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationItem_RL_CongestInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_RL_CongestInd_iE_Extensions__item_._ext = None
    _RL_InformationItem_RL_CongestInd_iE_Extensions._cont = __RL_InformationItem_RL_CongestInd_iE_Extensions__item_
    _RL_InformationItem_RL_CongestInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_RL_CongestInd._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationItem_RL_CongestInd_rL_ID),
        (u'dCH-Rate-Information', _RL_InformationItem_RL_CongestInd_dCH_Rate_Information),
        (u'iE-Extensions', _RL_InformationItem_RL_CongestInd_iE_Extensions),
        ])
    RL_InformationItem_RL_CongestInd._ext = []
    
    #-----< DCH-Rate-Information-RL-CongestInd >-----#
    DCH_Rate_Information_RL_CongestInd = SEQ_OF(name=u'DCH-Rate-Information-RL-CongestInd', mode=MODE_TYPE)
    _DCH_Rate_Information_RL_CongestInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DCH_Rate_Information_RL_CongestInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DCH_Rate_Information_RL_CongestInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DCH_Rate_Information_RL_CongestInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-Rate-InformationItem-RL-CongestInd')))
    ___DCH_Rate_Information_RL_CongestInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', ____DCH_Rate_Information_RL_CongestInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __DCH_Rate_Information_RL_CongestInd__item__id._const_tab = ___DCH_Rate_Information_RL_CongestInd__item__id_tab
    __DCH_Rate_Information_RL_CongestInd__item__id._const_tab_at = None
    __DCH_Rate_Information_RL_CongestInd__item__id._const_tab_id = u'id'
    __DCH_Rate_Information_RL_CongestInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DCH_Rate_Information_RL_CongestInd__item__criticality._const_tab = ___DCH_Rate_Information_RL_CongestInd__item__id_tab
    __DCH_Rate_Information_RL_CongestInd__item__criticality._const_tab_at = ('..', u'id')
    __DCH_Rate_Information_RL_CongestInd__item__criticality._const_tab_id = u'criticality'
    __DCH_Rate_Information_RL_CongestInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DCH_Rate_Information_RL_CongestInd__item__value._const_tab = ___DCH_Rate_Information_RL_CongestInd__item__id_tab
    __DCH_Rate_Information_RL_CongestInd__item__value._const_tab_at = ('..', u'id')
    __DCH_Rate_Information_RL_CongestInd__item__value._const_tab_id = u'Value'
    _DCH_Rate_Information_RL_CongestInd__item_._cont = ASN1Dict([
        (u'id', __DCH_Rate_Information_RL_CongestInd__item__id),
        (u'criticality', __DCH_Rate_Information_RL_CongestInd__item__criticality),
        (u'value', __DCH_Rate_Information_RL_CongestInd__item__value),
        ])
    _DCH_Rate_Information_RL_CongestInd__item_._ext = None
    DCH_Rate_Information_RL_CongestInd._cont = _DCH_Rate_Information_RL_CongestInd__item_
    DCH_Rate_Information_RL_CongestInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< DCH-Rate-InformationItemIEs-RL-CongestInd >-----#
    DCH_Rate_InformationItemIEs_RL_CongestInd = CLASS(name=u'DCH-Rate-InformationItemIEs-RL-CongestInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DCH_Rate_InformationItemIEs_RL_CongestInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DCH-Rate-InformationItem-RL-CongestInd')))
    DCH_Rate_InformationItemIEs_RL_CongestInd._val = ASN1Set(rv=[dict([(u'id', 38), (u'criticality', u'ignore'), (u'Value', _DCH_Rate_InformationItemIEs_RL_CongestInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< DCH-Rate-InformationItem-RL-CongestInd >-----#
    DCH_Rate_InformationItem_RL_CongestInd = SEQ(name=u'DCH-Rate-InformationItem-RL-CongestInd', mode=MODE_TYPE)
    _DCH_Rate_InformationItem_RL_CongestInd_dCH_ID = INT(name=u'dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DCH-ID')))
    _DCH_Rate_InformationItem_RL_CongestInd_allowed_Rate_Information = SEQ(name=u'allowed-Rate-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Allowed-Rate-Information')), opt=True)
    _DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab = ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab = ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab = ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id),
        (u'criticality', ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue),
        ])
    __DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item_._ext = None
    _DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions._cont = __DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item_
    _DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Rate_InformationItem_RL_CongestInd._cont = ASN1Dict([
        (u'dCH-ID', _DCH_Rate_InformationItem_RL_CongestInd_dCH_ID),
        (u'allowed-Rate-Information', _DCH_Rate_InformationItem_RL_CongestInd_allowed_Rate_Information),
        (u'iE-Extensions', _DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions),
        ])
    DCH_Rate_InformationItem_RL_CongestInd._ext = []
    
    #-----< DCH-Rate-InformationItem-RL-CongestInd-ExtIEs >-----#
    DCH_Rate_InformationItem_RL_CongestInd_ExtIEs = CLASS(name=u'DCH-Rate-InformationItem-RL-CongestInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DCH_Rate_InformationItem_RL_CongestInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Information-RL-CongestInd-ExtIEs >-----#
    RL_Information_RL_CongestInd_ExtIEs = CLASS(name=u'RL-Information-RL-CongestInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Information_RL_CongestInd_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationList-RL-CongestInd')))
    _RL_Information_RL_CongestInd_ExtIEs_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DCH-Indicator-For-E-DCH-HSDPA-Operation')))
    RL_Information_RL_CongestInd_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 588), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_CongestInd_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 665), (u'criticality', u'ignore'), (u'Extension', _RL_Information_RL_CongestInd_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkCongestionIndication-Extensions >-----#
    RadioLinkCongestionIndication_Extensions = CLASS(name=u'RadioLinkCongestionIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkCongestionIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EDCH-MacdFlowSpecificInformationList-RL-CongestInd >-----#
    EDCH_MacdFlowSpecificInformationList_RL_CongestInd = SEQ_OF(name=u'EDCH-MacdFlowSpecificInformationList-RL-CongestInd', mode=MODE_TYPE)
    _EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationItem-RL-CongestInd')))
    ___EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 589), (u'criticality', u'ignore'), (u'Value', ____EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id._const_tab = ___EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id._const_tab_at = None
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id._const_tab_id = u'id'
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__criticality._const_tab = ___EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__criticality._const_tab_at = ('..', u'id')
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__criticality._const_tab_id = u'criticality'
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__value._const_tab = ___EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__value._const_tab_at = ('..', u'id')
    __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__value._const_tab_id = u'Value'
    _EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item_._cont = ASN1Dict([
        (u'id', __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id),
        (u'criticality', __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__criticality),
        (u'value', __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__value),
        ])
    _EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item_._ext = None
    EDCH_MacdFlowSpecificInformationList_RL_CongestInd._cont = _EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item_
    EDCH_MacdFlowSpecificInformationList_RL_CongestInd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDCH-MacdFlowSpecificInformationItemIEs-RL-CongestInd >-----#
    EDCH_MacdFlowSpecificInformationItemIEs_RL_CongestInd = CLASS(name=u'EDCH-MacdFlowSpecificInformationItemIEs-RL-CongestInd', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EDCH_MacdFlowSpecificInformationItemIEs_RL_CongestInd_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EDCH-MacdFlowSpecificInformationItem-RL-CongestInd')))
    EDCH_MacdFlowSpecificInformationItemIEs_RL_CongestInd._val = ASN1Set(rv=[dict([(u'id', 589), (u'criticality', u'ignore'), (u'Value', _EDCH_MacdFlowSpecificInformationItemIEs_RL_CongestInd_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< EDCH-MacdFlowSpecificInformationItem-RL-CongestInd >-----#
    EDCH_MacdFlowSpecificInformationItem_RL_CongestInd = SEQ(name=u'EDCH-MacdFlowSpecificInformationItem-RL-CongestInd', mode=MODE_TYPE)
    _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_eDCH_MACdFlow_ID = INT(name=u'eDCH-MACdFlow-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'EDCH-MACdFlow-ID')))
    _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab = ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id_tab
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab_at = None
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id._const_tab_id = u'id'
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab = ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab = ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id),
        (u'criticality', ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality),
        (u'extensionValue', ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue),
        ])
    __EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item_._ext = None
    _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions._cont = __EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item_
    _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EDCH_MacdFlowSpecificInformationItem_RL_CongestInd._cont = ASN1Dict([
        (u'eDCH-MACdFlow-ID', _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_eDCH_MACdFlow_ID),
        (u'iE-Extensions', _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions),
        ])
    EDCH_MacdFlowSpecificInformationItem_RL_CongestInd._ext = []
    
    #-----< EDCH-MacdFlowSpecificInformation-RL-CongestInd-ExtIEs >-----#
    EDCH_MacdFlowSpecificInformation_RL_CongestInd_ExtIEs = CLASS(name=u'EDCH-MacdFlowSpecificInformation-RL-CongestInd-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EDCH_MacdFlowSpecificInformation_RL_CongestInd_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkSignallingTransferIndicationFDD >-----#
    UplinkSignallingTransferIndicationFDD = SEQ(name=u'UplinkSignallingTransferIndicationFDD', mode=MODE_TYPE)
    _UplinkSignallingTransferIndicationFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UplinkSignallingTransferIndicationFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PropagationDelay')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'STTD-SupportIndicator')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ClosedLoopMode1-SupportIndicator')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    ____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 232), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 276), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_12), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__id._const_tab = ____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__id._const_tab_at = None
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__criticality._const_tab = ____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__value._const_tab = ____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkSignallingTransferIndicationFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__id),
        (u'criticality', ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__criticality),
        (u'value', ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__value),
        ])
    __UplinkSignallingTransferIndicationFDD_protocolIEs__item_._ext = None
    _UplinkSignallingTransferIndicationFDD_protocolIEs._cont = __UplinkSignallingTransferIndicationFDD_protocolIEs__item_
    _UplinkSignallingTransferIndicationFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkSignallingTransferIndicationFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkSignallingTransferIndicationFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode-Change-SupportIndicator')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonTransportChannelResourcesInitialisationNotRequired')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-FDD')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionID')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-List')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_12 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_13 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-FDD')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_16 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 537), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 562), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 607), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 662), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 754), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'conditional')]), dict([(u'id', 859), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 802), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 827), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_16), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id._const_tab = ____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id._const_tab_at = None
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__criticality._const_tab = ____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__extensionValue._const_tab = ____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UplinkSignallingTransferIndicationFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id),
        (u'criticality', ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__extensionValue),
        ])
    __UplinkSignallingTransferIndicationFDD_protocolExtensions__item_._ext = None
    _UplinkSignallingTransferIndicationFDD_protocolExtensions._cont = __UplinkSignallingTransferIndicationFDD_protocolExtensions__item_
    _UplinkSignallingTransferIndicationFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkSignallingTransferIndicationFDD._cont = ASN1Dict([
        (u'protocolIEs', _UplinkSignallingTransferIndicationFDD_protocolIEs),
        (u'protocolExtensions', _UplinkSignallingTransferIndicationFDD_protocolExtensions),
        ])
    UplinkSignallingTransferIndicationFDD._ext = []
    
    #-----< UplinkSignallingTransferIndicationFDD-IEs >-----#
    UplinkSignallingTransferIndicationFDD_IEs = CLASS(name=u'UplinkSignallingTransferIndicationFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PropagationDelay')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'STTD-SupportIndicator')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_8 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ClosedLoopMode1-SupportIndicator')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_9 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_11 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _UplinkSignallingTransferIndicationFDD_IEs_val_Value_12 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    UplinkSignallingTransferIndicationFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 232), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 25), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 279), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 276), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_8), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_9), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_10), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_11), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationFDD_IEs_val_Value_12), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkSignallingTransferIndicationFDD-Extensions >-----#
    UplinkSignallingTransferIndicationFDD_Extensions = CLASS(name=u'UplinkSignallingTransferIndicationFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPC-Mode-Change-SupportIndicator')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonTransportChannelResourcesInitialisationNotRequired')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-FDD')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionID')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_6 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_7 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Inter-Frequency-Cell-List')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ExtendedPropagationDelay')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_9 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_10 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_12 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Max-UE-DTX-Cycle')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_13 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-FDD')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_14 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_15 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Secondary-Serving-Cell-List')))
    _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_16 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    UplinkSignallingTransferIndicationFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 19), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 300), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 537), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 562), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 607), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 662), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 754), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 695), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_12), (u'presence', u'conditional')]), dict([(u'id', 859), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 802), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_14), (u'presence', u'optional')]), dict([(u'id', 827), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_15), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_16), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkSignallingTransferIndicationTDD >-----#
    UplinkSignallingTransferIndicationTDD = SEQ(name=u'UplinkSignallingTransferIndicationTDD', mode=MODE_TYPE)
    _UplinkSignallingTransferIndicationTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UplinkSignallingTransferIndicationTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTA')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    ____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 232), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_10), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__id._const_tab = ____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__id._const_tab_at = None
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__criticality._const_tab = ____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__value._const_tab = ____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __UplinkSignallingTransferIndicationTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__id),
        (u'criticality', ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__criticality),
        (u'value', ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__value),
        ])
    __UplinkSignallingTransferIndicationTDD_protocolIEs__item_._ext = None
    _UplinkSignallingTransferIndicationTDD_protocolIEs._cont = __UplinkSignallingTransferIndicationTDD_protocolIEs__item_
    _UplinkSignallingTransferIndicationTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkSignallingTransferIndicationTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkSignallingTransferIndicationTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonTransportChannelResourcesInitialisationNotRequired')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD-LCR')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD768')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTA768')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTAext')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_10 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_12 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionLCRID')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_13 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-TDD-LCR')))
    _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 563), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 629), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 651), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 650), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 754), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 836), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 883), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id._const_tab = ____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id._const_tab_at = None
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__criticality._const_tab = ____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__extensionValue._const_tab = ____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UplinkSignallingTransferIndicationTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id),
        (u'criticality', ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__extensionValue),
        ])
    __UplinkSignallingTransferIndicationTDD_protocolExtensions__item_._ext = None
    _UplinkSignallingTransferIndicationTDD_protocolExtensions._cont = __UplinkSignallingTransferIndicationTDD_protocolExtensions__item_
    _UplinkSignallingTransferIndicationTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkSignallingTransferIndicationTDD._cont = ASN1Dict([
        (u'protocolIEs', _UplinkSignallingTransferIndicationTDD_protocolIEs),
        (u'protocolExtensions', _UplinkSignallingTransferIndicationTDD_protocolExtensions),
        ])
    UplinkSignallingTransferIndicationTDD._ext = []
    
    #-----< UplinkSignallingTransferIndicationTDD-IEs >-----#
    UplinkSignallingTransferIndicationTDD_IEs = CLASS(name=u'UplinkSignallingTransferIndicationTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-Cell')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_5 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTA')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_7 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_8 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_9 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _UplinkSignallingTransferIndicationTDD_IEs_val_Value_10 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    UplinkSignallingTransferIndicationTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 232), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 36), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_7), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_8), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_9), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _UplinkSignallingTransferIndicationTDD_IEs_val_Value_10), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkSignallingTransferIndicationTDD-Extensions >-----#
    UplinkSignallingTransferIndicationTDD_Extensions = CLASS(name=u'UplinkSignallingTransferIndicationTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GA-CellAdditionalShapes')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonTransportChannelResourcesInitialisationNotRequired')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_3 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD-LCR')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_4 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SNA-Information')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_5 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_6 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainer-TDD768')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTA768')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_8 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RxTimingDeviationForTAext')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_9 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Multiple-PLMN-List')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_10 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-RNTI')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_11 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_12 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellPortionLCRID')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_13 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CellCapabilityContainerExtension-TDD-LCR')))
    _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_14 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    UplinkSignallingTransferIndicationTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 3), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 250), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 301), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 302), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 479), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 563), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 629), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 651), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 650), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_8), (u'presence', u'optional')]), dict([(u'id', 727), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_9), (u'presence', u'optional')]), dict([(u'id', 457), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_10), (u'presence', u'optional')]), dict([(u'id', 754), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_11), (u'presence', u'optional')]), dict([(u'id', 836), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_12), (u'presence', u'optional')]), dict([(u'id', 883), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_13), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_14), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkSignallingTransferRequest >-----#
    DownlinkSignallingTransferRequest = SEQ(name=u'DownlinkSignallingTransferRequest', mode=MODE_TYPE)
    _DownlinkSignallingTransferRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DownlinkSignallingTransferRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DownlinkSignallingTransferRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI-ReleaseIndication')))
    ____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DownlinkSignallingTransferRequest_protocolIEs__item__id._const_tab = ____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab
    ___DownlinkSignallingTransferRequest_protocolIEs__item__id._const_tab_at = None
    ___DownlinkSignallingTransferRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___DownlinkSignallingTransferRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DownlinkSignallingTransferRequest_protocolIEs__item__criticality._const_tab = ____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab
    ___DownlinkSignallingTransferRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkSignallingTransferRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DownlinkSignallingTransferRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DownlinkSignallingTransferRequest_protocolIEs__item__value._const_tab = ____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab
    ___DownlinkSignallingTransferRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DownlinkSignallingTransferRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __DownlinkSignallingTransferRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DownlinkSignallingTransferRequest_protocolIEs__item__id),
        (u'criticality', ___DownlinkSignallingTransferRequest_protocolIEs__item__criticality),
        (u'value', ___DownlinkSignallingTransferRequest_protocolIEs__item__value),
        ])
    __DownlinkSignallingTransferRequest_protocolIEs__item_._ext = None
    _DownlinkSignallingTransferRequest_protocolIEs._cont = __DownlinkSignallingTransferRequest_protocolIEs__item_
    _DownlinkSignallingTransferRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DownlinkSignallingTransferRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DownlinkSignallingTransferRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PCH-Capability')))
    ____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 569), (u'criticality', u'ignore'), (u'Extension', _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 560), (u'criticality', u'ignore'), (u'Extension', _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 564), (u'criticality', u'ignore'), (u'Extension', _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Extension', _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'conditional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 731), (u'criticality', u'ignore'), (u'Extension', _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__id._const_tab = ____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__id._const_tab_at = None
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__criticality._const_tab = ____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__extensionValue._const_tab = ____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DownlinkSignallingTransferRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DownlinkSignallingTransferRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DownlinkSignallingTransferRequest_protocolExtensions__item__id),
        (u'criticality', ___DownlinkSignallingTransferRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___DownlinkSignallingTransferRequest_protocolExtensions__item__extensionValue),
        ])
    __DownlinkSignallingTransferRequest_protocolExtensions__item_._ext = None
    _DownlinkSignallingTransferRequest_protocolExtensions._cont = __DownlinkSignallingTransferRequest_protocolExtensions__item_
    _DownlinkSignallingTransferRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DownlinkSignallingTransferRequest._cont = ASN1Dict([
        (u'protocolIEs', _DownlinkSignallingTransferRequest_protocolIEs),
        (u'protocolExtensions', _DownlinkSignallingTransferRequest_protocolExtensions),
        ])
    DownlinkSignallingTransferRequest._ext = []
    
    #-----< DownlinkSignallingTransferRequest-IEs >-----#
    DownlinkSignallingTransferRequest_IEs = CLASS(name=u'DownlinkSignallingTransferRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DownlinkSignallingTransferRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _DownlinkSignallingTransferRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _DownlinkSignallingTransferRequest_IEs_val_Value_2 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _DownlinkSignallingTransferRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI-ReleaseIndication')))
    DownlinkSignallingTransferRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Value', _DownlinkSignallingTransferRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _DownlinkSignallingTransferRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _DownlinkSignallingTransferRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 22), (u'criticality', u'ignore'), (u'Value', _DownlinkSignallingTransferRequest_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DownlinkSignallingTransferRequest-Extensions >-----#
    DownlinkSignallingTransferRequest_Extensions = CLASS(name=u'DownlinkSignallingTransferRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DownlinkSignallingTransferRequest_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _DownlinkSignallingTransferRequest_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _DownlinkSignallingTransferRequest_Extensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _DownlinkSignallingTransferRequest_Extensions_val_Extension_3 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _DownlinkSignallingTransferRequest_Extensions_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _DownlinkSignallingTransferRequest_Extensions_val_Extension_5 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PCH-Capability')))
    DownlinkSignallingTransferRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 569), (u'criticality', u'ignore'), (u'Extension', _DownlinkSignallingTransferRequest_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 560), (u'criticality', u'ignore'), (u'Extension', _DownlinkSignallingTransferRequest_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 564), (u'criticality', u'ignore'), (u'Extension', _DownlinkSignallingTransferRequest_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Extension', _DownlinkSignallingTransferRequest_Extensions_val_Extension_3), (u'presence', u'conditional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _DownlinkSignallingTransferRequest_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 731), (u'criticality', u'ignore'), (u'Extension', _DownlinkSignallingTransferRequest_Extensions_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCommit >-----#
    RelocationCommit = SEQ(name=u'RelocationCommit', mode=MODE_TYPE)
    _RelocationCommit_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RelocationCommit_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCommit_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RelocationCommit_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RelocationCommit_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____RelocationCommit_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RANAP-RelocationInformation')))
    ____RelocationCommit_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____RelocationCommit_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _____RelocationCommit_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RelocationCommit_protocolIEs__item__id._const_tab = ____RelocationCommit_protocolIEs__item__id_tab
    ___RelocationCommit_protocolIEs__item__id._const_tab_at = None
    ___RelocationCommit_protocolIEs__item__id._const_tab_id = u'id'
    ___RelocationCommit_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RelocationCommit_protocolIEs__item__criticality._const_tab = ____RelocationCommit_protocolIEs__item__id_tab
    ___RelocationCommit_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCommit_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RelocationCommit_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RelocationCommit_protocolIEs__item__value._const_tab = ____RelocationCommit_protocolIEs__item__id_tab
    ___RelocationCommit_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RelocationCommit_protocolIEs__item__value._const_tab_id = u'Value'
    __RelocationCommit_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RelocationCommit_protocolIEs__item__id),
        (u'criticality', ___RelocationCommit_protocolIEs__item__criticality),
        (u'value', ___RelocationCommit_protocolIEs__item__value),
        ])
    __RelocationCommit_protocolIEs__item_._ext = None
    _RelocationCommit_protocolIEs._cont = __RelocationCommit_protocolIEs__item_
    _RelocationCommit_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCommit_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCommit_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCommit_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RelocationCommit_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RelocationCommit_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCommit_protocolExtensions__item__id._const_tab = ____RelocationCommit_protocolExtensions__item__id_tab
    ___RelocationCommit_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCommit_protocolExtensions__item__id._const_tab_id = u'id'
    ___RelocationCommit_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RelocationCommit_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RelocationCommit_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCommit_protocolExtensions__item__criticality._const_tab = ____RelocationCommit_protocolExtensions__item__criticality_tab
    ___RelocationCommit_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RelocationCommit_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RelocationCommit_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RelocationCommit_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RelocationCommit_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCommit_protocolExtensions__item__extensionValue._const_tab = ____RelocationCommit_protocolExtensions__item__extensionValue_tab
    ___RelocationCommit_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RelocationCommit_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RelocationCommit_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RelocationCommit_protocolExtensions__item__id),
        (u'criticality', ___RelocationCommit_protocolExtensions__item__criticality),
        (u'extensionValue', ___RelocationCommit_protocolExtensions__item__extensionValue),
        ])
    __RelocationCommit_protocolExtensions__item_._ext = None
    _RelocationCommit_protocolExtensions._cont = __RelocationCommit_protocolExtensions__item_
    _RelocationCommit_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCommit._cont = ASN1Dict([
        (u'protocolIEs', _RelocationCommit_protocolIEs),
        (u'protocolExtensions', _RelocationCommit_protocolExtensions),
        ])
    RelocationCommit._ext = []
    
    #-----< RelocationCommit-IEs >-----#
    RelocationCommit_IEs = CLASS(name=u'RelocationCommit-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RelocationCommit_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _RelocationCommit_IEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RANAP-RelocationInformation')))
    RelocationCommit_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _RelocationCommit_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 109), (u'criticality', u'ignore'), (u'Value', _RelocationCommit_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCommit-Extensions >-----#
    RelocationCommit_Extensions = CLASS(name=u'RelocationCommit-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RelocationCommit_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingRequest >-----#
    PagingRequest = SEQ(name=u'PagingRequest', mode=MODE_TYPE)
    _PagingRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __PagingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___PagingRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____PagingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____PagingRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingArea-PagingRqst')))
    _____PagingRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____PagingRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____PagingRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IMSI')))
    _____PagingRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DRXCycleLengthCoefficient')))
    _____PagingRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CNOriginatedPage-PagingRqst')))
    ____PagingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 102), (u'criticality', u'ignore'), (u'Value', _____PagingRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _____PagingRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____PagingRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _____PagingRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 70), (u'criticality', u'ignore'), (u'Value', _____PagingRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _____PagingRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PagingRequest_protocolIEs__item__id._const_tab = ____PagingRequest_protocolIEs__item__id_tab
    ___PagingRequest_protocolIEs__item__id._const_tab_at = None
    ___PagingRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___PagingRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___PagingRequest_protocolIEs__item__criticality._const_tab = ____PagingRequest_protocolIEs__item__id_tab
    ___PagingRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PagingRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___PagingRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___PagingRequest_protocolIEs__item__value._const_tab = ____PagingRequest_protocolIEs__item__id_tab
    ___PagingRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___PagingRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __PagingRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___PagingRequest_protocolIEs__item__id),
        (u'criticality', ___PagingRequest_protocolIEs__item__criticality),
        (u'value', ___PagingRequest_protocolIEs__item__value),
        ])
    __PagingRequest_protocolIEs__item_._ext = None
    _PagingRequest_protocolIEs._cont = __PagingRequest_protocolIEs__item_
    _PagingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PagingRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PagingRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___PagingRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____PagingRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PCH-Capability')))
    _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____PagingRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 731), (u'criticality', u'ignore'), (u'Extension', _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___PagingRequest_protocolExtensions__item__id._const_tab = ____PagingRequest_protocolExtensions__item__id_tab
    ___PagingRequest_protocolExtensions__item__id._const_tab_at = None
    ___PagingRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___PagingRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___PagingRequest_protocolExtensions__item__criticality._const_tab = ____PagingRequest_protocolExtensions__item__id_tab
    ___PagingRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___PagingRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___PagingRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___PagingRequest_protocolExtensions__item__extensionValue._const_tab = ____PagingRequest_protocolExtensions__item__id_tab
    ___PagingRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___PagingRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __PagingRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___PagingRequest_protocolExtensions__item__id),
        (u'criticality', ___PagingRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___PagingRequest_protocolExtensions__item__extensionValue),
        ])
    __PagingRequest_protocolExtensions__item_._ext = None
    _PagingRequest_protocolExtensions._cont = __PagingRequest_protocolExtensions__item_
    _PagingRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PagingRequest._cont = ASN1Dict([
        (u'protocolIEs', _PagingRequest_protocolIEs),
        (u'protocolExtensions', _PagingRequest_protocolExtensions),
        ])
    PagingRequest._ext = []
    
    #-----< PagingRequest-IEs >-----#
    PagingRequest_IEs = CLASS(name=u'PagingRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _PagingRequest_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingArea-PagingRqst')))
    _PagingRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _PagingRequest_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _PagingRequest_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IMSI')))
    _PagingRequest_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DRXCycleLengthCoefficient')))
    _PagingRequest_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CNOriginatedPage-PagingRqst')))
    PagingRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 102), (u'criticality', u'ignore'), (u'Value', _PagingRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'ignore'), (u'Value', _PagingRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _PagingRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 84), (u'criticality', u'ignore'), (u'Value', _PagingRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 70), (u'criticality', u'ignore'), (u'Value', _PagingRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 23), (u'criticality', u'ignore'), (u'Value', _PagingRequest_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< PagingArea-PagingRqst >-----#
    PagingArea_PagingRqst = CHOICE(name=u'PagingArea-PagingRqst', mode=MODE_TYPE)
    _PagingArea_PagingRqst_uRA = SEQ(name=u'uRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'URA-PagingRqst')))
    _PagingArea_PagingRqst_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-PagingRqst')))
    PagingArea_PagingRqst._cont = ASN1Dict([
        (u'uRA', _PagingArea_PagingRqst_uRA),
        (u'cell', _PagingArea_PagingRqst_cell),
        ])
    PagingArea_PagingRqst._ext = []
    
    #-----< URA-PagingRqst >-----#
    URA_PagingRqst = SEQ(name=u'URA-PagingRqst', mode=MODE_TYPE)
    _URA_PagingRqst_uRA_ID = INT(name=u'uRA-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'URA-ID')))
    _URA_PagingRqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __URA_PagingRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___URA_PagingRqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____URA_PagingRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____URA_PagingRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___URA_PagingRqst_iE_Extensions__item__id._const_tab = ____URA_PagingRqst_iE_Extensions__item__id_tab
    ___URA_PagingRqst_iE_Extensions__item__id._const_tab_at = None
    ___URA_PagingRqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___URA_PagingRqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____URA_PagingRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____URA_PagingRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___URA_PagingRqst_iE_Extensions__item__criticality._const_tab = ____URA_PagingRqst_iE_Extensions__item__criticality_tab
    ___URA_PagingRqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___URA_PagingRqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___URA_PagingRqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____URA_PagingRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____URA_PagingRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___URA_PagingRqst_iE_Extensions__item__extensionValue._const_tab = ____URA_PagingRqst_iE_Extensions__item__extensionValue_tab
    ___URA_PagingRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___URA_PagingRqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __URA_PagingRqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___URA_PagingRqst_iE_Extensions__item__id),
        (u'criticality', ___URA_PagingRqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___URA_PagingRqst_iE_Extensions__item__extensionValue),
        ])
    __URA_PagingRqst_iE_Extensions__item_._ext = None
    _URA_PagingRqst_iE_Extensions._cont = __URA_PagingRqst_iE_Extensions__item_
    _URA_PagingRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    URA_PagingRqst._cont = ASN1Dict([
        (u'uRA-ID', _URA_PagingRqst_uRA_ID),
        (u'iE-Extensions', _URA_PagingRqst_iE_Extensions),
        ])
    URA_PagingRqst._ext = []
    
    #-----< URAItem-PagingRqst-ExtIEs >-----#
    URAItem_PagingRqst_ExtIEs = CLASS(name=u'URAItem-PagingRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    URAItem_PagingRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cell-PagingRqst >-----#
    Cell_PagingRqst = SEQ(name=u'Cell-PagingRqst', mode=MODE_TYPE)
    _Cell_PagingRqst_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Cell_PagingRqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_PagingRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_PagingRqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_PagingRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_PagingRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_PagingRqst_iE_Extensions__item__id._const_tab = ____Cell_PagingRqst_iE_Extensions__item__id_tab
    ___Cell_PagingRqst_iE_Extensions__item__id._const_tab_at = None
    ___Cell_PagingRqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_PagingRqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_PagingRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_PagingRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_PagingRqst_iE_Extensions__item__criticality._const_tab = ____Cell_PagingRqst_iE_Extensions__item__criticality_tab
    ___Cell_PagingRqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_PagingRqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_PagingRqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_PagingRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_PagingRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_PagingRqst_iE_Extensions__item__extensionValue._const_tab = ____Cell_PagingRqst_iE_Extensions__item__extensionValue_tab
    ___Cell_PagingRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_PagingRqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_PagingRqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_PagingRqst_iE_Extensions__item__id),
        (u'criticality', ___Cell_PagingRqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_PagingRqst_iE_Extensions__item__extensionValue),
        ])
    __Cell_PagingRqst_iE_Extensions__item_._ext = None
    _Cell_PagingRqst_iE_Extensions._cont = __Cell_PagingRqst_iE_Extensions__item_
    _Cell_PagingRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_PagingRqst._cont = ASN1Dict([
        (u'c-ID', _Cell_PagingRqst_c_ID),
        (u'iE-Extensions', _Cell_PagingRqst_iE_Extensions),
        ])
    Cell_PagingRqst._ext = []
    
    #-----< CellItem-PagingRqst-ExtIEs >-----#
    CellItem_PagingRqst_ExtIEs = CLASS(name=u'CellItem-PagingRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellItem_PagingRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNOriginatedPage-PagingRqst >-----#
    CNOriginatedPage_PagingRqst = SEQ(name=u'CNOriginatedPage-PagingRqst', mode=MODE_TYPE)
    _CNOriginatedPage_PagingRqst_pagingCause = ENUM(name=u'pagingCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PagingCause')))
    _CNOriginatedPage_PagingRqst_cNDomainType = ENUM(name=u'cNDomainType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CNDomainType')))
    _CNOriginatedPage_PagingRqst_pagingRecordType = ENUM(name=u'pagingRecordType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'PagingRecordType')))
    _CNOriginatedPage_PagingRqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNOriginatedPage_PagingRqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CNOriginatedPage_PagingRqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CNOriginatedPage_PagingRqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__id._const_tab = ____CNOriginatedPage_PagingRqst_iE_Extensions__item__id_tab
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__id._const_tab_at = None
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality._const_tab = ____CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality_tab
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue._const_tab = ____CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue_tab
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __CNOriginatedPage_PagingRqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___CNOriginatedPage_PagingRqst_iE_Extensions__item__id),
        (u'criticality', ___CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue),
        ])
    __CNOriginatedPage_PagingRqst_iE_Extensions__item_._ext = None
    _CNOriginatedPage_PagingRqst_iE_Extensions._cont = __CNOriginatedPage_PagingRqst_iE_Extensions__item_
    _CNOriginatedPage_PagingRqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNOriginatedPage_PagingRqst._cont = ASN1Dict([
        (u'pagingCause', _CNOriginatedPage_PagingRqst_pagingCause),
        (u'cNDomainType', _CNOriginatedPage_PagingRqst_cNDomainType),
        (u'pagingRecordType', _CNOriginatedPage_PagingRqst_pagingRecordType),
        (u'iE-Extensions', _CNOriginatedPage_PagingRqst_iE_Extensions),
        ])
    CNOriginatedPage_PagingRqst._ext = []
    
    #-----< CNOriginatedPage-PagingRqst-ExtIEs >-----#
    CNOriginatedPage_PagingRqst_ExtIEs = CLASS(name=u'CNOriginatedPage-PagingRqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CNOriginatedPage_PagingRqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PagingRequest-Extensions >-----#
    PagingRequest_Extensions = CLASS(name=u'PagingRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _PagingRequest_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _PagingRequest_Extensions_val_Extension_1 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-PCH-Capability')))
    _PagingRequest_Extensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    PagingRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 682), (u'criticality', u'reject'), (u'Extension', _PagingRequest_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 731), (u'criticality', u'ignore'), (u'Extension', _PagingRequest_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _PagingRequest_Extensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationRequest >-----#
    DedicatedMeasurementInitiationRequest = SEQ(name=u'DedicatedMeasurementInitiationRequest', mode=MODE_TYPE)
    _DedicatedMeasurementInitiationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rqst')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementType')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ReportCharacteristics')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FNReportingIndicator')))
    _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 72), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __DedicatedMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id),
        (u'criticality', ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality),
        (u'value', ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __DedicatedMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _DedicatedMeasurementInitiationRequest_protocolIEs._cont = __DedicatedMeasurementInitiationRequest_protocolIEs__item_
    _DedicatedMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementInitiationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PartialReportingIndicator')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryBehavior')))
    _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AlternativeFormatReportingIndicator')))
    ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 472), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 554), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 664), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id),
        (u'criticality', ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementInitiationRequest_protocolExtensions__item_._ext = None
    _DedicatedMeasurementInitiationRequest_protocolExtensions._cont = __DedicatedMeasurementInitiationRequest_protocolExtensions__item_
    _DedicatedMeasurementInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementInitiationRequest._cont = ASN1Dict([
        (u'protocolIEs', _DedicatedMeasurementInitiationRequest_protocolIEs),
        (u'protocolExtensions', _DedicatedMeasurementInitiationRequest_protocolExtensions),
        ])
    DedicatedMeasurementInitiationRequest._ext = []
    
    #-----< DedicatedMeasurementInitiationRequest-IEs >-----#
    DedicatedMeasurementInitiationRequest_IEs = CLASS(name=u'DedicatedMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rqst')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementType')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ReportCharacteristics')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FNReportingIndicator')))
    _DedicatedMeasurementInitiationRequest_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    DedicatedMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 72), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 74), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 14), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _DedicatedMeasurementInitiationRequest_IEs_val_Value_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Rqst >-----#
    DedicatedMeasurementObjectType_DM_Rqst = CHOICE(name=u'DedicatedMeasurementObjectType-DM-Rqst', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Rqst_rL = SEQ(name=u'rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Rqst')))
    _DedicatedMeasurementObjectType_DM_Rqst_rLS = SEQ(name=u'rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Rqst')))
    _DedicatedMeasurementObjectType_DM_Rqst_allRL = NULL(name=u'allRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'All-RL-DM-Rqst')))
    _DedicatedMeasurementObjectType_DM_Rqst_allRLS = NULL(name=u'allRLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'All-RL-Set-DM-Rqst')))
    DedicatedMeasurementObjectType_DM_Rqst._cont = ASN1Dict([
        (u'rL', _DedicatedMeasurementObjectType_DM_Rqst_rL),
        (u'rLS', _DedicatedMeasurementObjectType_DM_Rqst_rLS),
        (u'allRL', _DedicatedMeasurementObjectType_DM_Rqst_allRL),
        (u'allRLS', _DedicatedMeasurementObjectType_DM_Rqst_allRLS),
        ])
    DedicatedMeasurementObjectType_DM_Rqst._ext = []
    
    #-----< RL-DM-Rqst >-----#
    RL_DM_Rqst = SEQ(name=u'RL-DM-Rqst', mode=MODE_TYPE)
    _RL_DM_Rqst_rL_InformationList_DM_Rqst = SEQ_OF(name=u'rL-InformationList-DM-Rqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-DM-Rqst')))
    _RL_DM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_DM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_DM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_DM_Rqst_iE_Extensions__item__criticality_tab
    ___RL_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_DM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___RL_DM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_DM_Rqst_iE_Extensions._cont = __RL_DM_Rqst_iE_Extensions__item_
    _RL_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Rqst._cont = ASN1Dict([
        (u'rL-InformationList-DM-Rqst', _RL_DM_Rqst_rL_InformationList_DM_Rqst),
        (u'iE-Extensions', _RL_DM_Rqst_iE_Extensions),
        ])
    RL_DM_Rqst._ext = []
    
    #-----< RLItem-DM-Rqst-ExtIEs >-----#
    RLItem_DM_Rqst_ExtIEs = CLASS(name=u'RLItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-DM-Rqst >-----#
    RL_InformationList_DM_Rqst = SEQ_OF(name=u'RL-InformationList-DM-Rqst', mode=MODE_TYPE)
    _RL_InformationList_DM_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_DM_Rqst__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_DM_Rqst__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_DM_Rqst__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-DM-Rqst')))
    ___RL_InformationList_DM_Rqst__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 121), (u'criticality', u'reject'), (u'Value', ____RL_InformationList_DM_Rqst__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_DM_Rqst__item__id._const_tab = ___RL_InformationList_DM_Rqst__item__id_tab
    __RL_InformationList_DM_Rqst__item__id._const_tab_at = None
    __RL_InformationList_DM_Rqst__item__id._const_tab_id = u'id'
    __RL_InformationList_DM_Rqst__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_DM_Rqst__item__criticality._const_tab = ___RL_InformationList_DM_Rqst__item__id_tab
    __RL_InformationList_DM_Rqst__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_DM_Rqst__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_DM_Rqst__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_DM_Rqst__item__value._const_tab = ___RL_InformationList_DM_Rqst__item__id_tab
    __RL_InformationList_DM_Rqst__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_DM_Rqst__item__value._const_tab_id = u'Value'
    _RL_InformationList_DM_Rqst__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_DM_Rqst__item__id),
        (u'criticality', __RL_InformationList_DM_Rqst__item__criticality),
        (u'value', __RL_InformationList_DM_Rqst__item__value),
        ])
    _RL_InformationList_DM_Rqst__item_._ext = None
    RL_InformationList_DM_Rqst._cont = _RL_InformationList_DM_Rqst__item_
    RL_InformationList_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-DM-Rqst-IEs >-----#
    RL_Information_DM_Rqst_IEs = CLASS(name=u'RL-Information-DM-Rqst-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_DM_Rqst_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-DM-Rqst')))
    RL_Information_DM_Rqst_IEs._val = ASN1Set(rv=[dict([(u'id', 121), (u'criticality', u'reject'), (u'Value', _RL_Information_DM_Rqst_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-DM-Rqst >-----#
    RL_InformationItem_DM_Rqst = SEQ(name=u'RL-InformationItem-DM-Rqst', mode=MODE_TYPE)
    _RL_InformationItem_DM_Rqst_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationItem_DM_Rqst_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')), opt=True)
    _RL_InformationItem_DM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSSICH-Info-DM-Rqst')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSSICH-Info-DM-Rqst-Extension')))
    ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 498), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 646), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 721), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationItem_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_InformationItem_DM_Rqst_iE_Extensions._cont = __RL_InformationItem_DM_Rqst_iE_Extensions__item_
    _RL_InformationItem_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_DM_Rqst._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationItem_DM_Rqst_rL_ID),
        (u'dPCH-ID', _RL_InformationItem_DM_Rqst_dPCH_ID),
        (u'iE-Extensions', _RL_InformationItem_DM_Rqst_iE_Extensions),
        ])
    RL_InformationItem_DM_Rqst._ext = []
    
    #-----< RL-InformationItem-DM-Rqst-ExtIEs >-----#
    RL_InformationItem_DM_Rqst_ExtIEs = CLASS(name=u'RL-InformationItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSSICH-Info-DM-Rqst')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'HSSICH-Info-DM-Rqst-Extension')))
    RL_InformationItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 498), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 646), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 721), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< HSSICH-Info-DM-Rqst >-----#
    HSSICH_Info_DM_Rqst = SEQ_OF(name=u'HSSICH-Info-DM-Rqst', mode=MODE_TYPE)
    _HSSICH_Info_DM_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    HSSICH_Info_DM_Rqst._cont = _HSSICH_Info_DM_Rqst__item_
    HSSICH_Info_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< HSSICH-Info-DM-Rqst-Extension >-----#
    HSSICH_Info_DM_Rqst_Extension = SEQ_OF(name=u'HSSICH-Info-DM-Rqst-Extension', mode=MODE_TYPE)
    _HSSICH_Info_DM_Rqst_Extension__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    HSSICH_Info_DM_Rqst_Extension._cont = _HSSICH_Info_DM_Rqst_Extension__item_
    HSSICH_Info_DM_Rqst_Extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< RL-Set-DM-Rqst >-----#
    RL_Set_DM_Rqst = SEQ(name=u'RL-Set-DM-Rqst', mode=MODE_TYPE)
    _RL_Set_DM_Rqst_rL_Set_InformationList_DM_Rqst = SEQ_OF(name=u'rL-Set-InformationList-DM-Rqst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationList-DM-Rqst')))
    _RL_Set_DM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_Set_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_DM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_DM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_Set_DM_Rqst_iE_Extensions._cont = __RL_Set_DM_Rqst_iE_Extensions__item_
    _RL_Set_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Rqst._cont = ASN1Dict([
        (u'rL-Set-InformationList-DM-Rqst', _RL_Set_DM_Rqst_rL_Set_InformationList_DM_Rqst),
        (u'iE-Extensions', _RL_Set_DM_Rqst_iE_Extensions),
        ])
    RL_Set_DM_Rqst._ext = []
    
    #-----< RL-SetItem-DM-Rqst-ExtIEs >-----#
    RL_SetItem_DM_Rqst_ExtIEs = CLASS(name=u'RL-SetItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-DM-Rqst >-----#
    RL_Set_InformationList_DM_Rqst = SEQ_OF(name=u'RL-Set-InformationList-DM-Rqst', mode=MODE_TYPE)
    _RL_Set_InformationList_DM_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_DM_Rqst__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_InformationList_DM_Rqst__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_DM_Rqst__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rqst')))
    ___RL_Set_InformationList_DM_Rqst__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', ____RL_Set_InformationList_DM_Rqst__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_DM_Rqst__item__id._const_tab = ___RL_Set_InformationList_DM_Rqst__item__id_tab
    __RL_Set_InformationList_DM_Rqst__item__id._const_tab_at = None
    __RL_Set_InformationList_DM_Rqst__item__id._const_tab_id = u'id'
    __RL_Set_InformationList_DM_Rqst__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_InformationList_DM_Rqst__item__criticality._const_tab = ___RL_Set_InformationList_DM_Rqst__item__id_tab
    __RL_Set_InformationList_DM_Rqst__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_DM_Rqst__item__criticality._const_tab_id = u'criticality'
    __RL_Set_InformationList_DM_Rqst__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_InformationList_DM_Rqst__item__value._const_tab = ___RL_Set_InformationList_DM_Rqst__item__id_tab
    __RL_Set_InformationList_DM_Rqst__item__value._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_DM_Rqst__item__value._const_tab_id = u'Value'
    _RL_Set_InformationList_DM_Rqst__item_._cont = ASN1Dict([
        (u'id', __RL_Set_InformationList_DM_Rqst__item__id),
        (u'criticality', __RL_Set_InformationList_DM_Rqst__item__criticality),
        (u'value', __RL_Set_InformationList_DM_Rqst__item__value),
        ])
    _RL_Set_InformationList_DM_Rqst__item_._ext = None
    RL_Set_InformationList_DM_Rqst._cont = _RL_Set_InformationList_DM_Rqst__item_
    RL_Set_InformationList_DM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Information-DM-Rqst-IEs >-----#
    RL_Set_Information_DM_Rqst_IEs = CLASS(name=u'RL-Set-Information-DM-Rqst-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Information_DM_Rqst_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rqst')))
    RL_Set_Information_DM_Rqst_IEs._val = ASN1Set(rv=[dict([(u'id', 144), (u'criticality', u'reject'), (u'Value', _RL_Set_Information_DM_Rqst_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-DM-Rqst >-----#
    RL_Set_InformationItem_DM_Rqst = SEQ(name=u'RL-Set-InformationItem-DM-Rqst', mode=MODE_TYPE)
    _RL_Set_InformationItem_DM_Rqst_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_DM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_DM_Rqst_iE_Extensions._cont = __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_
    _RL_Set_InformationItem_DM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_DM_Rqst._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_InformationItem_DM_Rqst_rL_Set_ID),
        (u'iE-Extensions', _RL_Set_InformationItem_DM_Rqst_iE_Extensions),
        ])
    RL_Set_InformationItem_DM_Rqst._ext = []
    
    #-----< RL-Set-InformationItem-DM-Rqst-ExtIEs >-----#
    RL_Set_InformationItem_DM_Rqst_ExtIEs = CLASS(name=u'RL-Set-InformationItem-DM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_DM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< All-RL-DM-Rqst >-----#
    All_RL_DM_Rqst = NULL(name=u'All-RL-DM-Rqst', mode=MODE_TYPE)
    
    #-----< All-RL-Set-DM-Rqst >-----#
    All_RL_Set_DM_Rqst = NULL(name=u'All-RL-Set-DM-Rqst', mode=MODE_TYPE)
    
    #-----< DedicatedMeasurementInitiationRequest-Extensions >-----#
    DedicatedMeasurementInitiationRequest_Extensions = CLASS(name=u'DedicatedMeasurementInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_0 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'PartialReportingIndicator')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_1 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryBehavior')))
    _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_2 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AlternativeFormatReportingIndicator')))
    DedicatedMeasurementInitiationRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 472), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 554), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 664), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationResponse >-----#
    DedicatedMeasurementInitiationResponse = SEQ(name=u'DedicatedMeasurementInitiationResponse', mode=MODE_TYPE)
    _DedicatedMeasurementInitiationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rsp')))
    _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 73), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __DedicatedMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id),
        (u'criticality', ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality),
        (u'value', ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __DedicatedMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _DedicatedMeasurementInitiationResponse_protocolIEs._cont = __DedicatedMeasurementInitiationResponse_protocolIEs__item_
    _DedicatedMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementInitiationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoverySupportIndicator')))
    ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 556), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id),
        (u'criticality', ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementInitiationResponse_protocolExtensions__item_._ext = None
    _DedicatedMeasurementInitiationResponse_protocolExtensions._cont = __DedicatedMeasurementInitiationResponse_protocolExtensions__item_
    _DedicatedMeasurementInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementInitiationResponse._cont = ASN1Dict([
        (u'protocolIEs', _DedicatedMeasurementInitiationResponse_protocolIEs),
        (u'protocolExtensions', _DedicatedMeasurementInitiationResponse_protocolExtensions),
        ])
    DedicatedMeasurementInitiationResponse._ext = []
    
    #-----< DedicatedMeasurementInitiationResponse-IEs >-----#
    DedicatedMeasurementInitiationResponse_IEs = CLASS(name=u'DedicatedMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rsp')))
    _DedicatedMeasurementInitiationResponse_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    DedicatedMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 73), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementInitiationResponse_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Rsp >-----#
    DedicatedMeasurementObjectType_DM_Rsp = CHOICE(name=u'DedicatedMeasurementObjectType-DM-Rsp', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Rsp_rLs = SEQ(name=u'rLs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Rsp')))
    _DedicatedMeasurementObjectType_DM_Rsp_rLS = SEQ(name=u'rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Rsp')))
    _DedicatedMeasurementObjectType_DM_Rsp_allRL = SEQ(name=u'allRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Rsp')))
    _DedicatedMeasurementObjectType_DM_Rsp_allRLS = SEQ(name=u'allRLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Rsp')))
    DedicatedMeasurementObjectType_DM_Rsp._cont = ASN1Dict([
        (u'rLs', _DedicatedMeasurementObjectType_DM_Rsp_rLs),
        (u'rLS', _DedicatedMeasurementObjectType_DM_Rsp_rLS),
        (u'allRL', _DedicatedMeasurementObjectType_DM_Rsp_allRL),
        (u'allRLS', _DedicatedMeasurementObjectType_DM_Rsp_allRLS),
        ])
    DedicatedMeasurementObjectType_DM_Rsp._ext = []
    
    #-----< RL-DM-Rsp >-----#
    RL_DM_Rsp = SEQ(name=u'RL-DM-Rsp', mode=MODE_TYPE)
    _RL_DM_Rsp_rL_InformationList_DM_Rsp = SEQ_OF(name=u'rL-InformationList-DM-Rsp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-DM-Rsp')))
    _RL_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_DM_Rsp_iE_Extensions__item__criticality_tab
    ___RL_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___RL_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_DM_Rsp_iE_Extensions._cont = __RL_DM_Rsp_iE_Extensions__item_
    _RL_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Rsp._cont = ASN1Dict([
        (u'rL-InformationList-DM-Rsp', _RL_DM_Rsp_rL_InformationList_DM_Rsp),
        (u'iE-Extensions', _RL_DM_Rsp_iE_Extensions),
        ])
    RL_DM_Rsp._ext = []
    
    #-----< RLItem-DM-Rsp-ExtIEs >-----#
    RLItem_DM_Rsp_ExtIEs = CLASS(name=u'RLItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-DM-Rsp >-----#
    RL_Set_DM_Rsp = SEQ(name=u'RL-Set-DM-Rsp', mode=MODE_TYPE)
    _RL_Set_DM_Rsp_rL_Set_InformationList_DM_Rsp = SEQ_OF(name=u'rL-Set-InformationList-DM-Rsp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationList-DM-Rsp')))
    _RL_Set_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_Set_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_Set_DM_Rsp_iE_Extensions._cont = __RL_Set_DM_Rsp_iE_Extensions__item_
    _RL_Set_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Rsp._cont = ASN1Dict([
        (u'rL-Set-InformationList-DM-Rsp', _RL_Set_DM_Rsp_rL_Set_InformationList_DM_Rsp),
        (u'iE-Extensions', _RL_Set_DM_Rsp_iE_Extensions),
        ])
    RL_Set_DM_Rsp._ext = []
    
    #-----< RL-SetItem-DM-Rsp-ExtIEs >-----#
    RL_SetItem_DM_Rsp_ExtIEs = CLASS(name=u'RL-SetItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-DM-Rsp >-----#
    RL_InformationList_DM_Rsp = SEQ_OF(name=u'RL-InformationList-DM-Rsp', mode=MODE_TYPE)
    _RL_InformationList_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_DM_Rsp__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_DM_Rsp__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_DM_Rsp__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-DM-Rsp')))
    ___RL_InformationList_DM_Rsp__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', ____RL_InformationList_DM_Rsp__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_DM_Rsp__item__id._const_tab = ___RL_InformationList_DM_Rsp__item__id_tab
    __RL_InformationList_DM_Rsp__item__id._const_tab_at = None
    __RL_InformationList_DM_Rsp__item__id._const_tab_id = u'id'
    __RL_InformationList_DM_Rsp__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_DM_Rsp__item__criticality._const_tab = ___RL_InformationList_DM_Rsp__item__id_tab
    __RL_InformationList_DM_Rsp__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_DM_Rsp__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_DM_Rsp__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_DM_Rsp__item__value._const_tab = ___RL_InformationList_DM_Rsp__item__id_tab
    __RL_InformationList_DM_Rsp__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_DM_Rsp__item__value._const_tab_id = u'Value'
    _RL_InformationList_DM_Rsp__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_DM_Rsp__item__id),
        (u'criticality', __RL_InformationList_DM_Rsp__item__criticality),
        (u'value', __RL_InformationList_DM_Rsp__item__value),
        ])
    _RL_InformationList_DM_Rsp__item_._ext = None
    RL_InformationList_DM_Rsp._cont = _RL_InformationList_DM_Rsp__item_
    RL_InformationList_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-DM-Rsp-IEs >-----#
    RL_Information_DM_Rsp_IEs = CLASS(name=u'RL-Information-DM-Rsp-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_DM_Rsp_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-DM-Rsp')))
    RL_Information_DM_Rsp_IEs._val = ASN1Set(rv=[dict([(u'id', 122), (u'criticality', u'ignore'), (u'Value', _RL_Information_DM_Rsp_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-DM-Rsp >-----#
    RL_InformationItem_DM_Rsp = SEQ(name=u'RL-InformationItem-DM-Rsp', mode=MODE_TYPE)
    _RL_InformationItem_DM_Rsp_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationItem_DM_Rsp_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')), opt=True)
    _RL_InformationItem_DM_Rsp_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _RL_InformationItem_DM_Rsp_cFN = INT(name=u'cFN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')), opt=True)
    _RL_InformationItem_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 499), (u'criticality', u'reject'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 595), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 596), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 609), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 630), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 645), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationItem_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_InformationItem_DM_Rsp_iE_Extensions._cont = __RL_InformationItem_DM_Rsp_iE_Extensions__item_
    _RL_InformationItem_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_DM_Rsp._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationItem_DM_Rsp_rL_ID),
        (u'dPCH-ID', _RL_InformationItem_DM_Rsp_dPCH_ID),
        (u'dedicatedMeasurementValue', _RL_InformationItem_DM_Rsp_dedicatedMeasurementValue),
        (u'cFN', _RL_InformationItem_DM_Rsp_cFN),
        (u'iE-Extensions', _RL_InformationItem_DM_Rsp_iE_Extensions),
        ])
    RL_InformationItem_DM_Rsp._ext = []
    
    #-----< RL-InformationItem-DM-Rsp-ExtIEs >-----#
    RL_InformationItem_DM_Rsp_ExtIEs = CLASS(name=u'RL-InformationItem-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_4 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    RL_InformationItem_DM_Rsp_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 499), (u'criticality', u'reject'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 595), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 596), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 609), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 630), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 645), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-DM-Rsp >-----#
    RL_Set_InformationList_DM_Rsp = SEQ_OF(name=u'RL-Set-InformationList-DM-Rsp', mode=MODE_TYPE)
    _RL_Set_InformationList_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_DM_Rsp__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_InformationList_DM_Rsp__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_DM_Rsp__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rsp')))
    ___RL_Set_InformationList_DM_Rsp__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', ____RL_Set_InformationList_DM_Rsp__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_DM_Rsp__item__id._const_tab = ___RL_Set_InformationList_DM_Rsp__item__id_tab
    __RL_Set_InformationList_DM_Rsp__item__id._const_tab_at = None
    __RL_Set_InformationList_DM_Rsp__item__id._const_tab_id = u'id'
    __RL_Set_InformationList_DM_Rsp__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_InformationList_DM_Rsp__item__criticality._const_tab = ___RL_Set_InformationList_DM_Rsp__item__id_tab
    __RL_Set_InformationList_DM_Rsp__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_DM_Rsp__item__criticality._const_tab_id = u'criticality'
    __RL_Set_InformationList_DM_Rsp__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_InformationList_DM_Rsp__item__value._const_tab = ___RL_Set_InformationList_DM_Rsp__item__id_tab
    __RL_Set_InformationList_DM_Rsp__item__value._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_DM_Rsp__item__value._const_tab_id = u'Value'
    _RL_Set_InformationList_DM_Rsp__item_._cont = ASN1Dict([
        (u'id', __RL_Set_InformationList_DM_Rsp__item__id),
        (u'criticality', __RL_Set_InformationList_DM_Rsp__item__criticality),
        (u'value', __RL_Set_InformationList_DM_Rsp__item__value),
        ])
    _RL_Set_InformationList_DM_Rsp__item_._ext = None
    RL_Set_InformationList_DM_Rsp._cont = _RL_Set_InformationList_DM_Rsp__item_
    RL_Set_InformationList_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Information-DM-Rsp-IEs >-----#
    RL_Set_Information_DM_Rsp_IEs = CLASS(name=u'RL-Set-Information-DM-Rsp-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Information_DM_Rsp_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rsp')))
    RL_Set_Information_DM_Rsp_IEs._val = ASN1Set(rv=[dict([(u'id', 145), (u'criticality', u'ignore'), (u'Value', _RL_Set_Information_DM_Rsp_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-DM-Rsp >-----#
    RL_Set_InformationItem_DM_Rsp = SEQ(name=u'RL-Set-InformationItem-DM-Rsp', mode=MODE_TYPE)
    _RL_Set_InformationItem_DM_Rsp_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_DM_Rsp_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _RL_Set_InformationItem_DM_Rsp_cFN = INT(name=u'cFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')), opt=True)
    _RL_Set_InformationItem_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_DM_Rsp_iE_Extensions._cont = __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_
    _RL_Set_InformationItem_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_DM_Rsp._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_InformationItem_DM_Rsp_rL_Set_ID),
        (u'dedicatedMeasurementValue', _RL_Set_InformationItem_DM_Rsp_dedicatedMeasurementValue),
        (u'cFN', _RL_Set_InformationItem_DM_Rsp_cFN),
        (u'iE-Extensions', _RL_Set_InformationItem_DM_Rsp_iE_Extensions),
        ])
    RL_Set_InformationItem_DM_Rsp._ext = []
    
    #-----< RL-Set-InformationItem-DM-Rspns-ExtIEs >-----#
    RL_Set_InformationItem_DM_Rspns_ExtIEs = CLASS(name=u'RL-Set-InformationItem-DM-Rspns-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_DM_Rspns_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationResponse-Extensions >-----#
    DedicatedMeasurementInitiationResponse_Extensions = CLASS(name=u'DedicatedMeasurementInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementInitiationResponse_Extensions_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoverySupportIndicator')))
    DedicatedMeasurementInitiationResponse_Extensions._val = ASN1Set(rv=[dict([(u'id', 556), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementInitiationResponse_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp = SEQ_OF(name=u'Multiple-DedicatedMeasurementValueList-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp')))
    Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp._cont = _Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp__item_
    Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=239)], ev=None, er=[])
    
    #-----< Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp = SEQ(name=u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp._cont = ASN1Dict([
        (u'dPCH-ID', _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dPCH_ID),
        (u'dedicatedMeasurementValue', _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue),
        (u'iE-Extensions', _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_ExtIEs = CLASS(name=u'Multiple-DedicatedMeasurementValueItem-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp = SEQ_OF(name=u'Multiple-DedicatedMeasurementValueList-LCR-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp')))
    Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp._cont = _Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp__item_
    Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=95)], ev=None, er=[])
    
    #-----< Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp = SEQ(name=u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')))
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp._cont = ASN1Dict([
        (u'dPCH-ID', _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dPCH_ID),
        (u'dedicatedMeasurementValue', _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dedicatedMeasurementValue),
        (u'iE-Extensions', _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_ExtIEs = CLASS(name=u'Multiple-DedicatedMeasurementValueItem-LCR-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp >-----#
    Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp = SEQ_OF(name=u'Multiple-HSSICHMeasurementValueList-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp')))
    Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp._cont = _Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp__item_
    Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp >-----#
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp = SEQ(name=u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp', mode=MODE_TYPE)
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_hsSICH_ID = INT(name=u'hsSICH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._cont = __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp._cont = ASN1Dict([
        (u'hsSICH-ID', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_hsSICH_ID),
        (u'dedicatedMeasurementValue', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue),
        (u'iE-Extensions', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions),
        ])
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp._ext = []
    
    #-----< Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs >-----#
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs = CLASS(name=u'Multiple-HSSICHMeasurementValueItem-TDD-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp = SEQ_OF(name=u'Multiple-DedicatedMeasurementValueList-TDD768-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp')))
    Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp._cont = _Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp__item_
    Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=479)], ev=None, er=[])
    
    #-----< Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp >-----#
    Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp = SEQ(name=u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp', mode=MODE_TYPE)
    _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_dPCH_ID768 = INT(name=u'dPCH-ID768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item_._ext = None
    _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions._cont = __Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item_
    _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp._cont = ASN1Dict([
        (u'dPCH-ID768', _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_dPCH_ID768),
        (u'dedicatedMeasurementValue', _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_dedicatedMeasurementValue),
        (u'iE-Extensions', _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions),
        ])
    Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp._ext = []
    
    #-----< Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp-ExtIEs >-----#
    Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_ExtIEs = CLASS(name=u'Multiple-DedicatedMeasurementValueItem-TDD768-DM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationFailure >-----#
    DedicatedMeasurementInitiationFailure = SEQ(name=u'DedicatedMeasurementInitiationFailure', mode=MODE_TYPE)
    _DedicatedMeasurementInitiationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __DedicatedMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id),
        (u'criticality', ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality),
        (u'value', ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __DedicatedMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _DedicatedMeasurementInitiationFailure_protocolIEs._cont = __DedicatedMeasurementInitiationFailure_protocolIEs__item_
    _DedicatedMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementInitiationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Fail')))
    ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 471), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id),
        (u'criticality', ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementInitiationFailure_protocolExtensions__item_._ext = None
    _DedicatedMeasurementInitiationFailure_protocolExtensions._cont = __DedicatedMeasurementInitiationFailure_protocolExtensions__item_
    _DedicatedMeasurementInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementInitiationFailure._cont = ASN1Dict([
        (u'protocolIEs', _DedicatedMeasurementInitiationFailure_protocolIEs),
        (u'protocolExtensions', _DedicatedMeasurementInitiationFailure_protocolExtensions),
        ])
    DedicatedMeasurementInitiationFailure._ext = []
    
    #-----< DedicatedMeasurementInitiationFailure-IEs >-----#
    DedicatedMeasurementInitiationFailure_IEs = CLASS(name=u'DedicatedMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _DedicatedMeasurementInitiationFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    DedicatedMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementInitiationFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementInitiationFailure-Extensions >-----#
    DedicatedMeasurementInitiationFailure_Extensions = CLASS(name=u'DedicatedMeasurementInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementInitiationFailure_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Fail')))
    DedicatedMeasurementInitiationFailure_Extensions._val = ASN1Set(rv=[dict([(u'id', 471), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementInitiationFailure_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Fail >-----#
    DedicatedMeasurementObjectType_DM_Fail = CHOICE(name=u'DedicatedMeasurementObjectType-DM-Fail', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Fail_rL = SEQ(name=u'rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Fail')))
    _DedicatedMeasurementObjectType_DM_Fail_rLS = SEQ(name=u'rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Fail')))
    _DedicatedMeasurementObjectType_DM_Fail_allRL = SEQ(name=u'allRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Fail')))
    _DedicatedMeasurementObjectType_DM_Fail_allRLS = SEQ(name=u'allRLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Fail')))
    DedicatedMeasurementObjectType_DM_Fail._cont = ASN1Dict([
        (u'rL', _DedicatedMeasurementObjectType_DM_Fail_rL),
        (u'rLS', _DedicatedMeasurementObjectType_DM_Fail_rLS),
        (u'allRL', _DedicatedMeasurementObjectType_DM_Fail_allRL),
        (u'allRLS', _DedicatedMeasurementObjectType_DM_Fail_allRLS),
        ])
    DedicatedMeasurementObjectType_DM_Fail._ext = []
    
    #-----< RL-DM-Fail >-----#
    RL_DM_Fail = SEQ(name=u'RL-DM-Fail', mode=MODE_TYPE)
    _RL_DM_Fail_rL_unsuccessful_InformationRespList_DM_Fail = SEQ_OF(name=u'rL-unsuccessful-InformationRespList-DM-Fail', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Unsuccessful-InformationRespList-DM-Fail')))
    _RL_DM_Fail_rL_successful_InformationRespList_DM_Fail = SEQ_OF(name=u'rL-successful-InformationRespList-DM-Fail', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Successful-InformationRespList-DM-Fail')), opt=True)
    _RL_DM_Fail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Fail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Fail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_DM_Fail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Fail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Fail_iE_Extensions__item__id._const_tab = ____RL_DM_Fail_iE_Extensions__item__id_tab
    ___RL_DM_Fail_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Fail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_DM_Fail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_DM_Fail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Fail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Fail_iE_Extensions__item__criticality._const_tab = ____RL_DM_Fail_iE_Extensions__item__criticality_tab
    ___RL_DM_Fail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_DM_Fail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_DM_Fail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_DM_Fail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Fail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Fail_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Fail_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Fail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_DM_Fail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_DM_Fail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_DM_Fail_iE_Extensions__item__id),
        (u'criticality', ___RL_DM_Fail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_DM_Fail_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Fail_iE_Extensions__item_._ext = None
    _RL_DM_Fail_iE_Extensions._cont = __RL_DM_Fail_iE_Extensions__item_
    _RL_DM_Fail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Fail._cont = ASN1Dict([
        (u'rL-unsuccessful-InformationRespList-DM-Fail', _RL_DM_Fail_rL_unsuccessful_InformationRespList_DM_Fail),
        (u'rL-successful-InformationRespList-DM-Fail', _RL_DM_Fail_rL_successful_InformationRespList_DM_Fail),
        (u'iE-Extensions', _RL_DM_Fail_iE_Extensions),
        ])
    RL_DM_Fail._ext = []
    
    #-----< RLItem-DM-Fail-ExtIEs >-----#
    RLItem_DM_Fail_ExtIEs = CLASS(name=u'RLItem-DM-Fail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Fail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-DM-Fail >-----#
    RL_Set_DM_Fail = SEQ(name=u'RL-Set-DM-Fail', mode=MODE_TYPE)
    _RL_Set_DM_Fail_rL_Set_unsuccessful_InformationRespList_DM_Fail = SEQ_OF(name=u'rL-Set-unsuccessful-InformationRespList-DM-Fail', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Unsuccessful-InformationRespList-DM-Fail')))
    _RL_Set_DM_Fail_rL_Set_successful_InformationRespList_DM_Fail = SEQ_OF(name=u'rL-Set-successful-InformationRespList-DM-Fail', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Successful-InformationRespList-DM-Fail')), opt=True)
    _RL_Set_DM_Fail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Fail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Fail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_DM_Fail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Fail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Fail_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Set_DM_Fail_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Fail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_DM_Fail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_DM_Fail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Fail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Fail_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Fail_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Fail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Fail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_DM_Fail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_DM_Fail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Fail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Fail_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Fail_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Fail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Fail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_DM_Fail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_DM_Fail_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_DM_Fail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_DM_Fail_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Fail_iE_Extensions__item_._ext = None
    _RL_Set_DM_Fail_iE_Extensions._cont = __RL_Set_DM_Fail_iE_Extensions__item_
    _RL_Set_DM_Fail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Fail._cont = ASN1Dict([
        (u'rL-Set-unsuccessful-InformationRespList-DM-Fail', _RL_Set_DM_Fail_rL_Set_unsuccessful_InformationRespList_DM_Fail),
        (u'rL-Set-successful-InformationRespList-DM-Fail', _RL_Set_DM_Fail_rL_Set_successful_InformationRespList_DM_Fail),
        (u'iE-Extensions', _RL_Set_DM_Fail_iE_Extensions),
        ])
    RL_Set_DM_Fail._ext = []
    
    #-----< RL-SetItem-DM-Fail-ExtIEs >-----#
    RL_SetItem_DM_Fail_ExtIEs = CLASS(name=u'RL-SetItem-DM-Fail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Fail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Unsuccessful-InformationRespList-DM-Fail >-----#
    RL_Unsuccessful_InformationRespList_DM_Fail = SEQ_OF(name=u'RL-Unsuccessful-InformationRespList-DM-Fail', mode=MODE_TYPE)
    _RL_Unsuccessful_InformationRespList_DM_Fail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Unsuccessful-InformationItem-DM-Fail')))
    ___RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 477), (u'criticality', u'ignore'), (u'Value', ____RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__id._const_tab = ___RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__id._const_tab_at = None
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__id._const_tab_id = u'id'
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__criticality._const_tab = ___RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__criticality._const_tab_at = ('..', u'id')
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__criticality._const_tab_id = u'criticality'
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__value._const_tab = ___RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__value._const_tab_at = ('..', u'id')
    __RL_Unsuccessful_InformationRespList_DM_Fail__item__value._const_tab_id = u'Value'
    _RL_Unsuccessful_InformationRespList_DM_Fail__item_._cont = ASN1Dict([
        (u'id', __RL_Unsuccessful_InformationRespList_DM_Fail__item__id),
        (u'criticality', __RL_Unsuccessful_InformationRespList_DM_Fail__item__criticality),
        (u'value', __RL_Unsuccessful_InformationRespList_DM_Fail__item__value),
        ])
    _RL_Unsuccessful_InformationRespList_DM_Fail__item_._ext = None
    RL_Unsuccessful_InformationRespList_DM_Fail._cont = _RL_Unsuccessful_InformationRespList_DM_Fail__item_
    RL_Unsuccessful_InformationRespList_DM_Fail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Unsuccessful-InformationResp-DM-Fail-IEs >-----#
    RL_Unsuccessful_InformationResp_DM_Fail_IEs = CLASS(name=u'RL-Unsuccessful-InformationResp-DM-Fail-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Unsuccessful_InformationResp_DM_Fail_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Unsuccessful-InformationItem-DM-Fail')))
    RL_Unsuccessful_InformationResp_DM_Fail_IEs._val = ASN1Set(rv=[dict([(u'id', 477), (u'criticality', u'ignore'), (u'Value', _RL_Unsuccessful_InformationResp_DM_Fail_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Unsuccessful-InformationItem-DM-Fail >-----#
    RL_Unsuccessful_InformationItem_DM_Fail = SEQ(name=u'RL-Unsuccessful-InformationItem-DM-Fail', mode=MODE_TYPE)
    _RL_Unsuccessful_InformationItem_DM_Fail_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Unsuccessful_InformationItem_DM_Fail_individualcause = CHOICE(name=u'individualcause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')), opt=True)
    _RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab = ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_at = None
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab = ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab = ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id),
        (u'criticality', ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue),
        ])
    __RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_._ext = None
    _RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions._cont = __RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_
    _RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Unsuccessful_InformationItem_DM_Fail._cont = ASN1Dict([
        (u'rL-ID', _RL_Unsuccessful_InformationItem_DM_Fail_rL_ID),
        (u'individualcause', _RL_Unsuccessful_InformationItem_DM_Fail_individualcause),
        (u'iE-Extensions', _RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions),
        ])
    RL_Unsuccessful_InformationItem_DM_Fail._ext = []
    
    #-----< RL-Unsuccessful-InformationItem-DM-Fail-ExtIEs >-----#
    RL_Unsuccessful_InformationItem_DM_Fail_ExtIEs = CLASS(name=u'RL-Unsuccessful-InformationItem-DM-Fail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Unsuccessful_InformationItem_DM_Fail_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Successful-InformationRespList-DM-Fail >-----#
    RL_Successful_InformationRespList_DM_Fail = SEQ_OF(name=u'RL-Successful-InformationRespList-DM-Fail', mode=MODE_TYPE)
    _RL_Successful_InformationRespList_DM_Fail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Successful_InformationRespList_DM_Fail__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Successful_InformationRespList_DM_Fail__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Successful_InformationRespList_DM_Fail__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Successful-InformationItem-DM-Fail')))
    ___RL_Successful_InformationRespList_DM_Fail__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 476), (u'criticality', u'ignore'), (u'Value', ____RL_Successful_InformationRespList_DM_Fail__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Successful_InformationRespList_DM_Fail__item__id._const_tab = ___RL_Successful_InformationRespList_DM_Fail__item__id_tab
    __RL_Successful_InformationRespList_DM_Fail__item__id._const_tab_at = None
    __RL_Successful_InformationRespList_DM_Fail__item__id._const_tab_id = u'id'
    __RL_Successful_InformationRespList_DM_Fail__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Successful_InformationRespList_DM_Fail__item__criticality._const_tab = ___RL_Successful_InformationRespList_DM_Fail__item__id_tab
    __RL_Successful_InformationRespList_DM_Fail__item__criticality._const_tab_at = ('..', u'id')
    __RL_Successful_InformationRespList_DM_Fail__item__criticality._const_tab_id = u'criticality'
    __RL_Successful_InformationRespList_DM_Fail__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Successful_InformationRespList_DM_Fail__item__value._const_tab = ___RL_Successful_InformationRespList_DM_Fail__item__id_tab
    __RL_Successful_InformationRespList_DM_Fail__item__value._const_tab_at = ('..', u'id')
    __RL_Successful_InformationRespList_DM_Fail__item__value._const_tab_id = u'Value'
    _RL_Successful_InformationRespList_DM_Fail__item_._cont = ASN1Dict([
        (u'id', __RL_Successful_InformationRespList_DM_Fail__item__id),
        (u'criticality', __RL_Successful_InformationRespList_DM_Fail__item__criticality),
        (u'value', __RL_Successful_InformationRespList_DM_Fail__item__value),
        ])
    _RL_Successful_InformationRespList_DM_Fail__item_._ext = None
    RL_Successful_InformationRespList_DM_Fail._cont = _RL_Successful_InformationRespList_DM_Fail__item_
    RL_Successful_InformationRespList_DM_Fail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-Successful-InformationResp-DM-Fail-IEs >-----#
    RL_Successful_InformationResp_DM_Fail_IEs = CLASS(name=u'RL-Successful-InformationResp-DM-Fail-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Successful_InformationResp_DM_Fail_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Successful-InformationItem-DM-Fail')))
    RL_Successful_InformationResp_DM_Fail_IEs._val = ASN1Set(rv=[dict([(u'id', 476), (u'criticality', u'ignore'), (u'Value', _RL_Successful_InformationResp_DM_Fail_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Successful-InformationItem-DM-Fail >-----#
    RL_Successful_InformationItem_DM_Fail = SEQ(name=u'RL-Successful-InformationItem-DM-Fail', mode=MODE_TYPE)
    _RL_Successful_InformationItem_DM_Fail_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Successful_InformationItem_DM_Fail_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')), opt=True)
    _RL_Successful_InformationItem_DM_Fail_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _RL_Successful_InformationItem_DM_Fail_cFN = INT(name=u'cFN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')), opt=True)
    _RL_Successful_InformationItem_DM_Fail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Successful_InformationItem_DM_Fail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    ____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 499), (u'criticality', u'reject'), (u'Extension', _____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab = ____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_at = None
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab = ____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab = ____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Successful_InformationItem_DM_Fail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id),
        (u'criticality', ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue),
        ])
    __RL_Successful_InformationItem_DM_Fail_iE_Extensions__item_._ext = None
    _RL_Successful_InformationItem_DM_Fail_iE_Extensions._cont = __RL_Successful_InformationItem_DM_Fail_iE_Extensions__item_
    _RL_Successful_InformationItem_DM_Fail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Successful_InformationItem_DM_Fail._cont = ASN1Dict([
        (u'rL-ID', _RL_Successful_InformationItem_DM_Fail_rL_ID),
        (u'dPCH-ID', _RL_Successful_InformationItem_DM_Fail_dPCH_ID),
        (u'dedicatedMeasurementValue', _RL_Successful_InformationItem_DM_Fail_dedicatedMeasurementValue),
        (u'cFN', _RL_Successful_InformationItem_DM_Fail_cFN),
        (u'iE-Extensions', _RL_Successful_InformationItem_DM_Fail_iE_Extensions),
        ])
    RL_Successful_InformationItem_DM_Fail._ext = []
    
    #-----< RL-Successful-InformationItem-DM-Fail-ExtIEs >-----#
    RL_Successful_InformationItem_DM_Fail_ExtIEs = CLASS(name=u'RL-Successful-InformationItem-DM-Fail-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_Successful_InformationItem_DM_Fail_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _RL_Successful_InformationItem_DM_Fail_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    RL_Successful_InformationItem_DM_Fail_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 499), (u'criticality', u'reject'), (u'Extension', _RL_Successful_InformationItem_DM_Fail_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _RL_Successful_InformationItem_DM_Fail_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-Set-Unsuccessful-InformationRespList-DM-Fail >-----#
    RL_Set_Unsuccessful_InformationRespList_DM_Fail = SEQ_OF(name=u'RL-Set-Unsuccessful-InformationRespList-DM-Fail', mode=MODE_TYPE)
    _RL_Set_Unsuccessful_InformationRespList_DM_Fail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Unsuccessful-InformationItem-DM-Fail')))
    ___RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 474), (u'criticality', u'ignore'), (u'Value', ____RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id._const_tab = ___RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id._const_tab_at = None
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id._const_tab_id = u'id'
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__criticality._const_tab = ___RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__criticality._const_tab_id = u'criticality'
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__value._const_tab = ___RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__value._const_tab_at = ('..', u'id')
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__value._const_tab_id = u'Value'
    _RL_Set_Unsuccessful_InformationRespList_DM_Fail__item_._cont = ASN1Dict([
        (u'id', __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id),
        (u'criticality', __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__criticality),
        (u'value', __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__value),
        ])
    _RL_Set_Unsuccessful_InformationRespList_DM_Fail__item_._ext = None
    RL_Set_Unsuccessful_InformationRespList_DM_Fail._cont = _RL_Set_Unsuccessful_InformationRespList_DM_Fail__item_
    RL_Set_Unsuccessful_InformationRespList_DM_Fail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Unsuccessful-InformationResp-DM-Fail-IEs >-----#
    RL_Set_Unsuccessful_InformationResp_DM_Fail_IEs = CLASS(name=u'RL-Set-Unsuccessful-InformationResp-DM-Fail-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Unsuccessful_InformationResp_DM_Fail_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Unsuccessful-InformationItem-DM-Fail')))
    RL_Set_Unsuccessful_InformationResp_DM_Fail_IEs._val = ASN1Set(rv=[dict([(u'id', 474), (u'criticality', u'ignore'), (u'Value', _RL_Set_Unsuccessful_InformationResp_DM_Fail_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-Unsuccessful-InformationItem-DM-Fail >-----#
    RL_Set_Unsuccessful_InformationItem_DM_Fail = SEQ(name=u'RL-Set-Unsuccessful-InformationItem-DM-Fail', mode=MODE_TYPE)
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_individualcause = CHOICE(name=u'individualcause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')), opt=True)
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab = ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab = ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_._ext = None
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions._cont = __RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_Unsuccessful_InformationItem_DM_Fail._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_Unsuccessful_InformationItem_DM_Fail_rL_Set_ID),
        (u'individualcause', _RL_Set_Unsuccessful_InformationItem_DM_Fail_individualcause),
        (u'iE-Extensions', _RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions),
        ])
    RL_Set_Unsuccessful_InformationItem_DM_Fail._ext = []
    
    #-----< RL-Set-Unsuccessful-InformationItem-DM-Failns-ExtIEs >-----#
    RL_Set_Unsuccessful_InformationItem_DM_Failns_ExtIEs = CLASS(name=u'RL-Set-Unsuccessful-InformationItem-DM-Failns-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_Unsuccessful_InformationItem_DM_Failns_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-Successful-InformationRespList-DM-Fail >-----#
    RL_Set_Successful_InformationRespList_DM_Fail = SEQ_OF(name=u'RL-Set-Successful-InformationRespList-DM-Fail', mode=MODE_TYPE)
    _RL_Set_Successful_InformationRespList_DM_Fail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_Successful_InformationRespList_DM_Fail__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Successful-InformationItem-DM-Fail')))
    ___RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 473), (u'criticality', u'ignore'), (u'Value', ____RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_Successful_InformationRespList_DM_Fail__item__id._const_tab = ___RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab
    __RL_Set_Successful_InformationRespList_DM_Fail__item__id._const_tab_at = None
    __RL_Set_Successful_InformationRespList_DM_Fail__item__id._const_tab_id = u'id'
    __RL_Set_Successful_InformationRespList_DM_Fail__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_Successful_InformationRespList_DM_Fail__item__criticality._const_tab = ___RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab
    __RL_Set_Successful_InformationRespList_DM_Fail__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_Successful_InformationRespList_DM_Fail__item__criticality._const_tab_id = u'criticality'
    __RL_Set_Successful_InformationRespList_DM_Fail__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_Successful_InformationRespList_DM_Fail__item__value._const_tab = ___RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab
    __RL_Set_Successful_InformationRespList_DM_Fail__item__value._const_tab_at = ('..', u'id')
    __RL_Set_Successful_InformationRespList_DM_Fail__item__value._const_tab_id = u'Value'
    _RL_Set_Successful_InformationRespList_DM_Fail__item_._cont = ASN1Dict([
        (u'id', __RL_Set_Successful_InformationRespList_DM_Fail__item__id),
        (u'criticality', __RL_Set_Successful_InformationRespList_DM_Fail__item__criticality),
        (u'value', __RL_Set_Successful_InformationRespList_DM_Fail__item__value),
        ])
    _RL_Set_Successful_InformationRespList_DM_Fail__item_._ext = None
    RL_Set_Successful_InformationRespList_DM_Fail._cont = _RL_Set_Successful_InformationRespList_DM_Fail__item_
    RL_Set_Successful_InformationRespList_DM_Fail._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< RL-Set-Successful-InformationResp-DM-Fail-IEs >-----#
    RL_Set_Successful_InformationResp_DM_Fail_IEs = CLASS(name=u'RL-Set-Successful-InformationResp-DM-Fail-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Successful_InformationResp_DM_Fail_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Successful-InformationItem-DM-Fail')))
    RL_Set_Successful_InformationResp_DM_Fail_IEs._val = ASN1Set(rv=[dict([(u'id', 473), (u'criticality', u'ignore'), (u'Value', _RL_Set_Successful_InformationResp_DM_Fail_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-Successful-InformationItem-DM-Fail >-----#
    RL_Set_Successful_InformationItem_DM_Fail = SEQ(name=u'RL-Set-Successful-InformationItem-DM-Fail', mode=MODE_TYPE)
    _RL_Set_Successful_InformationItem_DM_Fail_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_Successful_InformationItem_DM_Fail_dedicatedMeasurementValue = CHOICE(name=u'dedicatedMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValue')))
    _RL_Set_Successful_InformationItem_DM_Fail_cFN = INT(name=u'cFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CFN')), opt=True)
    _RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab = ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab = ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item_._ext = None
    _RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions._cont = __RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item_
    _RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_Successful_InformationItem_DM_Fail._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_Successful_InformationItem_DM_Fail_rL_Set_ID),
        (u'dedicatedMeasurementValue', _RL_Set_Successful_InformationItem_DM_Fail_dedicatedMeasurementValue),
        (u'cFN', _RL_Set_Successful_InformationItem_DM_Fail_cFN),
        (u'iE-Extensions', _RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions),
        ])
    RL_Set_Successful_InformationItem_DM_Fail._ext = []
    
    #-----< RL-Set-Successful-InformationItem-DM-Failns-ExtIEs >-----#
    RL_Set_Successful_InformationItem_DM_Failns_ExtIEs = CLASS(name=u'RL-Set-Successful-InformationItem-DM-Failns-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_Successful_InformationItem_DM_Failns_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementReport >-----#
    DedicatedMeasurementReport = SEQ(name=u'DedicatedMeasurementReport', mode=MODE_TYPE)
    _DedicatedMeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DedicatedMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rprt')))
    ____DedicatedMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementReport_protocolIEs__item__id._const_tab = ____DedicatedMeasurementReport_protocolIEs__item__id_tab
    ___DedicatedMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DedicatedMeasurementReport_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementReport_protocolIEs__item__id_tab
    ___DedicatedMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DedicatedMeasurementReport_protocolIEs__item__value._const_tab = ____DedicatedMeasurementReport_protocolIEs__item__id_tab
    ___DedicatedMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __DedicatedMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementReport_protocolIEs__item__id),
        (u'criticality', ___DedicatedMeasurementReport_protocolIEs__item__criticality),
        (u'value', ___DedicatedMeasurementReport_protocolIEs__item__value),
        ])
    __DedicatedMeasurementReport_protocolIEs__item_._ext = None
    _DedicatedMeasurementReport_protocolIEs._cont = __DedicatedMeasurementReport_protocolIEs__item_
    _DedicatedMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    ____DedicatedMeasurementReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 555), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementReport_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementReport_protocolExtensions__item__id_tab
    ___DedicatedMeasurementReport_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementReport_protocolExtensions__item__id_tab
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementReport_protocolExtensions__item__id_tab
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementReport_protocolExtensions__item__id),
        (u'criticality', ___DedicatedMeasurementReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementReport_protocolExtensions__item_._ext = None
    _DedicatedMeasurementReport_protocolExtensions._cont = __DedicatedMeasurementReport_protocolExtensions__item_
    _DedicatedMeasurementReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _DedicatedMeasurementReport_protocolIEs),
        (u'protocolExtensions', _DedicatedMeasurementReport_protocolExtensions),
        ])
    DedicatedMeasurementReport._ext = []
    
    #-----< DedicatedMeasurementReport-IEs >-----#
    DedicatedMeasurementReport_IEs = CLASS(name=u'DedicatedMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DedicatedMeasurementReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementReport_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Rprt')))
    DedicatedMeasurementReport_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 71), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementReport_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Rprt >-----#
    DedicatedMeasurementObjectType_DM_Rprt = CHOICE(name=u'DedicatedMeasurementObjectType-DM-Rprt', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Rprt_rLs = SEQ(name=u'rLs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Rprt')))
    _DedicatedMeasurementObjectType_DM_Rprt_rLS = SEQ(name=u'rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Rprt')))
    _DedicatedMeasurementObjectType_DM_Rprt_allRL = SEQ(name=u'allRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Rprt')))
    _DedicatedMeasurementObjectType_DM_Rprt_allRLS = SEQ(name=u'allRLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Rprt')))
    DedicatedMeasurementObjectType_DM_Rprt._cont = ASN1Dict([
        (u'rLs', _DedicatedMeasurementObjectType_DM_Rprt_rLs),
        (u'rLS', _DedicatedMeasurementObjectType_DM_Rprt_rLS),
        (u'allRL', _DedicatedMeasurementObjectType_DM_Rprt_allRL),
        (u'allRLS', _DedicatedMeasurementObjectType_DM_Rprt_allRLS),
        ])
    DedicatedMeasurementObjectType_DM_Rprt._ext = []
    
    #-----< RL-DM-Rprt >-----#
    RL_DM_Rprt = SEQ(name=u'RL-DM-Rprt', mode=MODE_TYPE)
    _RL_DM_Rprt_rL_InformationList_DM_Rprt = SEQ_OF(name=u'rL-InformationList-DM-Rprt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationList-DM-Rprt')))
    _RL_DM_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_DM_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_DM_Rprt_iE_Extensions__item__criticality_tab
    ___RL_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_DM_Rprt_iE_Extensions__item__id),
        (u'criticality', ___RL_DM_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_DM_Rprt_iE_Extensions._cont = __RL_DM_Rprt_iE_Extensions__item_
    _RL_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Rprt._cont = ASN1Dict([
        (u'rL-InformationList-DM-Rprt', _RL_DM_Rprt_rL_InformationList_DM_Rprt),
        (u'iE-Extensions', _RL_DM_Rprt_iE_Extensions),
        ])
    RL_DM_Rprt._ext = []
    
    #-----< RLItem-DM-Rprt-ExtIEs >-----#
    RLItem_DM_Rprt_ExtIEs = CLASS(name=u'RLItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-DM-Rprt >-----#
    RL_Set_DM_Rprt = SEQ(name=u'RL-Set-DM-Rprt', mode=MODE_TYPE)
    _RL_Set_DM_Rprt_rL_Set_InformationList_DM_Rprt = SEQ_OF(name=u'rL-Set-InformationList-DM-Rprt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationList-DM-Rprt')))
    _RL_Set_DM_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_Set_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_DM_Rprt_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_DM_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_Set_DM_Rprt_iE_Extensions._cont = __RL_Set_DM_Rprt_iE_Extensions__item_
    _RL_Set_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Rprt._cont = ASN1Dict([
        (u'rL-Set-InformationList-DM-Rprt', _RL_Set_DM_Rprt_rL_Set_InformationList_DM_Rprt),
        (u'iE-Extensions', _RL_Set_DM_Rprt_iE_Extensions),
        ])
    RL_Set_DM_Rprt._ext = []
    
    #-----< RL-SetItem-DM-Rprt-ExtIEs >-----#
    RL_SetItem_DM_Rprt_ExtIEs = CLASS(name=u'RL-SetItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-InformationList-DM-Rprt >-----#
    RL_InformationList_DM_Rprt = SEQ_OF(name=u'RL-InformationList-DM-Rprt', mode=MODE_TYPE)
    _RL_InformationList_DM_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_InformationList_DM_Rprt__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_InformationList_DM_Rprt__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_InformationList_DM_Rprt__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-DM-Rprt')))
    ___RL_InformationList_DM_Rprt__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', ____RL_InformationList_DM_Rprt__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_InformationList_DM_Rprt__item__id._const_tab = ___RL_InformationList_DM_Rprt__item__id_tab
    __RL_InformationList_DM_Rprt__item__id._const_tab_at = None
    __RL_InformationList_DM_Rprt__item__id._const_tab_id = u'id'
    __RL_InformationList_DM_Rprt__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_InformationList_DM_Rprt__item__criticality._const_tab = ___RL_InformationList_DM_Rprt__item__id_tab
    __RL_InformationList_DM_Rprt__item__criticality._const_tab_at = ('..', u'id')
    __RL_InformationList_DM_Rprt__item__criticality._const_tab_id = u'criticality'
    __RL_InformationList_DM_Rprt__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_InformationList_DM_Rprt__item__value._const_tab = ___RL_InformationList_DM_Rprt__item__id_tab
    __RL_InformationList_DM_Rprt__item__value._const_tab_at = ('..', u'id')
    __RL_InformationList_DM_Rprt__item__value._const_tab_id = u'Value'
    _RL_InformationList_DM_Rprt__item_._cont = ASN1Dict([
        (u'id', __RL_InformationList_DM_Rprt__item__id),
        (u'criticality', __RL_InformationList_DM_Rprt__item__criticality),
        (u'value', __RL_InformationList_DM_Rprt__item__value),
        ])
    _RL_InformationList_DM_Rprt__item_._ext = None
    RL_InformationList_DM_Rprt._cont = _RL_InformationList_DM_Rprt__item_
    RL_InformationList_DM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Information-DM-Rprt-IEs >-----#
    RL_Information_DM_Rprt_IEs = CLASS(name=u'RL-Information-DM-Rprt-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Information_DM_Rprt_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-InformationItem-DM-Rprt')))
    RL_Information_DM_Rprt_IEs._val = ASN1Set(rv=[dict([(u'id', 120), (u'criticality', u'ignore'), (u'Value', _RL_Information_DM_Rprt_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-InformationItem-DM-Rprt >-----#
    RL_InformationItem_DM_Rprt = SEQ(name=u'RL-InformationItem-DM-Rprt', mode=MODE_TYPE)
    _RL_InformationItem_DM_Rprt_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_InformationItem_DM_Rprt_dPCH_ID = INT(name=u'dPCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID')), opt=True)
    _RL_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation = CHOICE(name=u'dedicatedMeasurementValueInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValueInformation')))
    _RL_InformationItem_DM_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_InformationItem_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 497), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 647), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_InformationItem_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id),
        (u'criticality', ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_InformationItem_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_InformationItem_DM_Rprt_iE_Extensions._cont = __RL_InformationItem_DM_Rprt_iE_Extensions__item_
    _RL_InformationItem_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_InformationItem_DM_Rprt._cont = ASN1Dict([
        (u'rL-ID', _RL_InformationItem_DM_Rprt_rL_ID),
        (u'dPCH-ID', _RL_InformationItem_DM_Rprt_dPCH_ID),
        (u'dedicatedMeasurementValueInformation', _RL_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation),
        (u'iE-Extensions', _RL_InformationItem_DM_Rprt_iE_Extensions),
        ])
    RL_InformationItem_DM_Rprt._ext = []
    
    #-----< RL-InformationItem-DM-Rprt-ExtIEs >-----#
    RL_InformationItem_DM_Rprt_ExtIEs = CLASS(name=u'RL-InformationItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'DPCH-ID768')))
    _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HS-SICH-ID-Extension')))
    RL_InformationItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 497), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 647), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 720), (u'criticality', u'ignore'), (u'Extension', _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-Set-InformationList-DM-Rprt >-----#
    RL_Set_InformationList_DM_Rprt = SEQ_OF(name=u'RL-Set-InformationList-DM-Rprt', mode=MODE_TYPE)
    _RL_Set_InformationList_DM_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_InformationList_DM_Rprt__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_InformationList_DM_Rprt__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_InformationList_DM_Rprt__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rprt')))
    ___RL_Set_InformationList_DM_Rprt__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 143), (u'criticality', u'ignore'), (u'Value', ____RL_Set_InformationList_DM_Rprt__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_InformationList_DM_Rprt__item__id._const_tab = ___RL_Set_InformationList_DM_Rprt__item__id_tab
    __RL_Set_InformationList_DM_Rprt__item__id._const_tab_at = None
    __RL_Set_InformationList_DM_Rprt__item__id._const_tab_id = u'id'
    __RL_Set_InformationList_DM_Rprt__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_InformationList_DM_Rprt__item__criticality._const_tab = ___RL_Set_InformationList_DM_Rprt__item__id_tab
    __RL_Set_InformationList_DM_Rprt__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_DM_Rprt__item__criticality._const_tab_id = u'criticality'
    __RL_Set_InformationList_DM_Rprt__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_InformationList_DM_Rprt__item__value._const_tab = ___RL_Set_InformationList_DM_Rprt__item__id_tab
    __RL_Set_InformationList_DM_Rprt__item__value._const_tab_at = ('..', u'id')
    __RL_Set_InformationList_DM_Rprt__item__value._const_tab_id = u'Value'
    _RL_Set_InformationList_DM_Rprt__item_._cont = ASN1Dict([
        (u'id', __RL_Set_InformationList_DM_Rprt__item__id),
        (u'criticality', __RL_Set_InformationList_DM_Rprt__item__criticality),
        (u'value', __RL_Set_InformationList_DM_Rprt__item__value),
        ])
    _RL_Set_InformationList_DM_Rprt__item_._ext = None
    RL_Set_InformationList_DM_Rprt._cont = _RL_Set_InformationList_DM_Rprt__item_
    RL_Set_InformationList_DM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Information-DM-Rprt-IEs >-----#
    RL_Set_Information_DM_Rprt_IEs = CLASS(name=u'RL-Set-Information-DM-Rprt-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Information_DM_Rprt_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-InformationItem-DM-Rprt')))
    RL_Set_Information_DM_Rprt_IEs._val = ASN1Set(rv=[dict([(u'id', 143), (u'criticality', u'ignore'), (u'Value', _RL_Set_Information_DM_Rprt_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-InformationItem-DM-Rprt >-----#
    RL_Set_InformationItem_DM_Rprt = SEQ(name=u'RL-Set-InformationItem-DM-Rprt', mode=MODE_TYPE)
    _RL_Set_InformationItem_DM_Rprt_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation = CHOICE(name=u'dedicatedMeasurementValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DedicatedMeasurementValueInformation')))
    _RL_Set_InformationItem_DM_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab = ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab = ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_._ext = None
    _RL_Set_InformationItem_DM_Rprt_iE_Extensions._cont = __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_
    _RL_Set_InformationItem_DM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_InformationItem_DM_Rprt._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_InformationItem_DM_Rprt_rL_Set_ID),
        (u'dedicatedMeasurementValueInformation', _RL_Set_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation),
        (u'iE-Extensions', _RL_Set_InformationItem_DM_Rprt_iE_Extensions),
        ])
    RL_Set_InformationItem_DM_Rprt._ext = []
    
    #-----< RL-Set-InformationItem-DM-Rprt-ExtIEs >-----#
    RL_Set_InformationItem_DM_Rprt_ExtIEs = CLASS(name=u'RL-Set-InformationItem-DM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_InformationItem_DM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementReport-Extensions >-----#
    DedicatedMeasurementReport_Extensions = CLASS(name=u'DedicatedMeasurementReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementReport_Extensions_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    DedicatedMeasurementReport_Extensions._val = ASN1Set(rv=[dict([(u'id', 555), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementReport_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementTerminationRequest >-----#
    DedicatedMeasurementTerminationRequest = SEQ(name=u'DedicatedMeasurementTerminationRequest', mode=MODE_TYPE)
    _DedicatedMeasurementTerminationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id._const_tab = ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value._const_tab = ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __DedicatedMeasurementTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id),
        (u'criticality', ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality),
        (u'value', ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value),
        ])
    __DedicatedMeasurementTerminationRequest_protocolIEs__item_._ext = None
    _DedicatedMeasurementTerminationRequest_protocolIEs._cont = __DedicatedMeasurementTerminationRequest_protocolIEs__item_
    _DedicatedMeasurementTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementTerminationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id),
        (u'criticality', ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementTerminationRequest_protocolExtensions__item_._ext = None
    _DedicatedMeasurementTerminationRequest_protocolExtensions._cont = __DedicatedMeasurementTerminationRequest_protocolExtensions__item_
    _DedicatedMeasurementTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementTerminationRequest._cont = ASN1Dict([
        (u'protocolIEs', _DedicatedMeasurementTerminationRequest_protocolIEs),
        (u'protocolExtensions', _DedicatedMeasurementTerminationRequest_protocolExtensions),
        ])
    DedicatedMeasurementTerminationRequest._ext = []
    
    #-----< DedicatedMeasurementTerminationRequest-IEs >-----#
    DedicatedMeasurementTerminationRequest_IEs = CLASS(name=u'DedicatedMeasurementTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DedicatedMeasurementTerminationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    DedicatedMeasurementTerminationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementTerminationRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementTerminationRequest-Extensions >-----#
    DedicatedMeasurementTerminationRequest_Extensions = CLASS(name=u'DedicatedMeasurementTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DedicatedMeasurementTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementFailureIndication >-----#
    DedicatedMeasurementFailureIndication = SEQ(name=u'DedicatedMeasurementFailureIndication', mode=MODE_TYPE)
    _DedicatedMeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DedicatedMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __DedicatedMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___DedicatedMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __DedicatedMeasurementFailureIndication_protocolIEs__item_._ext = None
    _DedicatedMeasurementFailureIndication_protocolIEs._cont = __DedicatedMeasurementFailureIndication_protocolIEs__item_
    _DedicatedMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DedicatedMeasurementFailureIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DedicatedMeasurementFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Fail-Ind')))
    ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 470), (u'criticality', u'ignore'), (u'Extension', _____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id._const_tab = ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab = ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DedicatedMeasurementFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id),
        (u'criticality', ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __DedicatedMeasurementFailureIndication_protocolExtensions__item_._ext = None
    _DedicatedMeasurementFailureIndication_protocolExtensions._cont = __DedicatedMeasurementFailureIndication_protocolExtensions__item_
    _DedicatedMeasurementFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DedicatedMeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _DedicatedMeasurementFailureIndication_protocolIEs),
        (u'protocolExtensions', _DedicatedMeasurementFailureIndication_protocolExtensions),
        ])
    DedicatedMeasurementFailureIndication._ext = []
    
    #-----< DedicatedMeasurementFailureIndication-IEs >-----#
    DedicatedMeasurementFailureIndication_IEs = CLASS(name=u'DedicatedMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DedicatedMeasurementFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _DedicatedMeasurementFailureIndication_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    DedicatedMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _DedicatedMeasurementFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementFailureIndication-Extensions >-----#
    DedicatedMeasurementFailureIndication_Extensions = CLASS(name=u'DedicatedMeasurementFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DedicatedMeasurementFailureIndication_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementObjectType-DM-Fail-Ind')))
    DedicatedMeasurementFailureIndication_Extensions._val = ASN1Set(rv=[dict([(u'id', 470), (u'criticality', u'ignore'), (u'Extension', _DedicatedMeasurementFailureIndication_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< DedicatedMeasurementObjectType-DM-Fail-Ind >-----#
    DedicatedMeasurementObjectType_DM_Fail_Ind = CHOICE(name=u'DedicatedMeasurementObjectType-DM-Fail-Ind', mode=MODE_TYPE)
    _DedicatedMeasurementObjectType_DM_Fail_Ind_rL = SEQ(name=u'rL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Fail-Ind')))
    _DedicatedMeasurementObjectType_DM_Fail_Ind_rLS = SEQ(name=u'rLS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Fail-Ind')))
    _DedicatedMeasurementObjectType_DM_Fail_Ind_allRL = SEQ(name=u'allRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-DM-Fail-Ind')))
    _DedicatedMeasurementObjectType_DM_Fail_Ind_allRLS = SEQ(name=u'allRLS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-DM-Fail-Ind')))
    DedicatedMeasurementObjectType_DM_Fail_Ind._cont = ASN1Dict([
        (u'rL', _DedicatedMeasurementObjectType_DM_Fail_Ind_rL),
        (u'rLS', _DedicatedMeasurementObjectType_DM_Fail_Ind_rLS),
        (u'allRL', _DedicatedMeasurementObjectType_DM_Fail_Ind_allRL),
        (u'allRLS', _DedicatedMeasurementObjectType_DM_Fail_Ind_allRLS),
        ])
    DedicatedMeasurementObjectType_DM_Fail_Ind._ext = []
    
    #-----< RL-DM-Fail-Ind >-----#
    RL_DM_Fail_Ind = SEQ(name=u'RL-DM-Fail-Ind', mode=MODE_TYPE)
    _RL_DM_Fail_Ind_rL_unsuccessful_InformationRespList_DM_Fail_Ind = SEQ_OF(name=u'rL-unsuccessful-InformationRespList-DM-Fail-Ind', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Unsuccessful-InformationRespList-DM-Fail-Ind')))
    _RL_DM_Fail_Ind_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_DM_Fail_Ind_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_DM_Fail_Ind_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_DM_Fail_Ind_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Fail_Ind_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Fail_Ind_iE_Extensions__item__id._const_tab = ____RL_DM_Fail_Ind_iE_Extensions__item__id_tab
    ___RL_DM_Fail_Ind_iE_Extensions__item__id._const_tab_at = None
    ___RL_DM_Fail_Ind_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_DM_Fail_Ind_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_DM_Fail_Ind_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Fail_Ind_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab = ____RL_DM_Fail_Ind_iE_Extensions__item__criticality_tab
    ___RL_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_DM_Fail_Ind_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab = ____RL_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab
    ___RL_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_DM_Fail_Ind_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_DM_Fail_Ind_iE_Extensions__item__id),
        (u'criticality', ___RL_DM_Fail_Ind_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_DM_Fail_Ind_iE_Extensions__item__extensionValue),
        ])
    __RL_DM_Fail_Ind_iE_Extensions__item_._ext = None
    _RL_DM_Fail_Ind_iE_Extensions._cont = __RL_DM_Fail_Ind_iE_Extensions__item_
    _RL_DM_Fail_Ind_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_DM_Fail_Ind._cont = ASN1Dict([
        (u'rL-unsuccessful-InformationRespList-DM-Fail-Ind', _RL_DM_Fail_Ind_rL_unsuccessful_InformationRespList_DM_Fail_Ind),
        (u'iE-Extensions', _RL_DM_Fail_Ind_iE_Extensions),
        ])
    RL_DM_Fail_Ind._ext = []
    
    #-----< RLItem-DM-Fail-Ind-ExtIEs >-----#
    RLItem_DM_Fail_Ind_ExtIEs = CLASS(name=u'RLItem-DM-Fail-Ind-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RLItem_DM_Fail_Ind_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-DM-Fail-Ind >-----#
    RL_Set_DM_Fail_Ind = SEQ(name=u'RL-Set-DM-Fail-Ind', mode=MODE_TYPE)
    _RL_Set_DM_Fail_Ind_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind = SEQ_OF(name=u'rL-Set-unsuccessful-InformationRespList-DM-Fail-Ind', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Unsuccessful-InformationRespList-DM-Fail-Ind')))
    _RL_Set_DM_Fail_Ind_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_DM_Fail_Ind_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_DM_Fail_Ind_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Fail_Ind_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__id._const_tab = ____RL_Set_DM_Fail_Ind_iE_Extensions__item__id_tab
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab = ____RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality_tab
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_DM_Fail_Ind_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_DM_Fail_Ind_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_DM_Fail_Ind_iE_Extensions__item_._ext = None
    _RL_Set_DM_Fail_Ind_iE_Extensions._cont = __RL_Set_DM_Fail_Ind_iE_Extensions__item_
    _RL_Set_DM_Fail_Ind_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_DM_Fail_Ind._cont = ASN1Dict([
        (u'rL-Set-unsuccessful-InformationRespList-DM-Fail-Ind', _RL_Set_DM_Fail_Ind_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind),
        (u'iE-Extensions', _RL_Set_DM_Fail_Ind_iE_Extensions),
        ])
    RL_Set_DM_Fail_Ind._ext = []
    
    #-----< RL-SetItem-DM-Fail-Ind-ExtIEs >-----#
    RL_SetItem_DM_Fail_Ind_ExtIEs = CLASS(name=u'RL-SetItem-DM-Fail-Ind-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_SetItem_DM_Fail_Ind_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Unsuccessful-InformationRespList-DM-Fail-Ind >-----#
    RL_Unsuccessful_InformationRespList_DM_Fail_Ind = SEQ_OF(name=u'RL-Unsuccessful-InformationRespList-DM-Fail-Ind', mode=MODE_TYPE)
    _RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Unsuccessful-InformationItem-DM-Fail-Ind')))
    ___RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 478), (u'criticality', u'ignore'), (u'Value', ____RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id._const_tab = ___RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id._const_tab_at = None
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id._const_tab_id = u'id'
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality._const_tab = ___RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality._const_tab_at = ('..', u'id')
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality._const_tab_id = u'criticality'
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value._const_tab = ___RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value._const_tab_at = ('..', u'id')
    __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value._const_tab_id = u'Value'
    _RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item_._cont = ASN1Dict([
        (u'id', __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id),
        (u'criticality', __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality),
        (u'value', __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value),
        ])
    _RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item_._ext = None
    RL_Unsuccessful_InformationRespList_DM_Fail_Ind._cont = _RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item_
    RL_Unsuccessful_InformationRespList_DM_Fail_Ind._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Unsuccessful-InformationResp-DM-Fail-Ind-IEs >-----#
    RL_Unsuccessful_InformationResp_DM_Fail_Ind_IEs = CLASS(name=u'RL-Unsuccessful-InformationResp-DM-Fail-Ind-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Unsuccessful_InformationResp_DM_Fail_Ind_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Unsuccessful-InformationItem-DM-Fail-Ind')))
    RL_Unsuccessful_InformationResp_DM_Fail_Ind_IEs._val = ASN1Set(rv=[dict([(u'id', 478), (u'criticality', u'ignore'), (u'Value', _RL_Unsuccessful_InformationResp_DM_Fail_Ind_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Unsuccessful-InformationItem-DM-Fail-Ind >-----#
    RL_Unsuccessful_InformationItem_DM_Fail_Ind = SEQ(name=u'RL-Unsuccessful-InformationItem-DM-Fail-Ind', mode=MODE_TYPE)
    _RL_Unsuccessful_InformationItem_DM_Fail_Ind_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_Unsuccessful_InformationItem_DM_Fail_Ind_individualcause = CHOICE(name=u'individualcause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')), opt=True)
    _RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id._const_tab = ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id._const_tab_at = None
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab = ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab = ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id),
        (u'criticality', ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue),
        ])
    __RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_._ext = None
    _RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions._cont = __RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_
    _RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Unsuccessful_InformationItem_DM_Fail_Ind._cont = ASN1Dict([
        (u'rL-ID', _RL_Unsuccessful_InformationItem_DM_Fail_Ind_rL_ID),
        (u'individualcause', _RL_Unsuccessful_InformationItem_DM_Fail_Ind_individualcause),
        (u'iE-Extensions', _RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions),
        ])
    RL_Unsuccessful_InformationItem_DM_Fail_Ind._ext = []
    
    #-----< RL-Unsuccessful-InformationItem-DM-Fail-Ind-ExtIEs >-----#
    RL_Unsuccessful_InformationItem_DM_Fail_Ind_ExtIEs = CLASS(name=u'RL-Unsuccessful-InformationItem-DM-Fail-Ind-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Unsuccessful_InformationItem_DM_Fail_Ind_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RL-Set-Unsuccessful-InformationRespList-DM-Fail-Ind >-----#
    RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind = SEQ_OF(name=u'RL-Set-Unsuccessful-InformationRespList-DM-Fail-Ind', mode=MODE_TYPE)
    _RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind')))
    ___RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 475), (u'criticality', u'ignore'), (u'Value', ____RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id._const_tab = ___RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id._const_tab_at = None
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id._const_tab_id = u'id'
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality._const_tab = ___RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality._const_tab_at = ('..', u'id')
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality._const_tab_id = u'criticality'
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value._const_tab = ___RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value._const_tab_at = ('..', u'id')
    __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value._const_tab_id = u'Value'
    _RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item_._cont = ASN1Dict([
        (u'id', __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id),
        (u'criticality', __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality),
        (u'value', __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value),
        ])
    _RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item_._ext = None
    RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind._cont = _RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item_
    RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-Set-Unsuccessful-InformationResp-DM-Fail-Ind-IEs >-----#
    RL_Set_Unsuccessful_InformationResp_DM_Fail_Ind_IEs = CLASS(name=u'RL-Set-Unsuccessful-InformationResp-DM-Fail-Ind-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_Set_Unsuccessful_InformationResp_DM_Fail_Ind_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind')))
    RL_Set_Unsuccessful_InformationResp_DM_Fail_Ind_IEs._val = ASN1Set(rv=[dict([(u'id', 475), (u'criticality', u'ignore'), (u'Value', _RL_Set_Unsuccessful_InformationResp_DM_Fail_Ind_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind >-----#
    RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind = SEQ(name=u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Ind', mode=MODE_TYPE)
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_rL_Set_ID = INT(name=u'rL-Set-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-Set-ID')))
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_individualcause = CHOICE(name=u'individualcause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')), opt=True)
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id._const_tab = ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id._const_tab_at = None
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab = ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab = ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id),
        (u'criticality', ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue),
        ])
    __RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_._ext = None
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions._cont = __RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_
    _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind._cont = ASN1Dict([
        (u'rL-Set-ID', _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_rL_Set_ID),
        (u'individualcause', _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_individualcause),
        (u'iE-Extensions', _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions),
        ])
    RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind._ext = []
    
    #-----< RL-Set-Unsuccessful-InformationItem-DM-Fail-Indns-ExtIEs >-----#
    RL_Set_Unsuccessful_InformationItem_DM_Fail_Indns_ExtIEs = CLASS(name=u'RL-Set-Unsuccessful-InformationItem-DM-Fail-Indns-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_Set_Unsuccessful_InformationItem_DM_Fail_Indns_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesReleaseRequest >-----#
    CommonTransportChannelResourcesReleaseRequest = SEQ(name=u'CommonTransportChannelResourcesReleaseRequest', mode=MODE_TYPE)
    _CommonTransportChannelResourcesReleaseRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelResourcesReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    ____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id._const_tab = ____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__value._const_tab = ____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonTransportChannelResourcesReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id),
        (u'criticality', ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__criticality),
        (u'value', ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__value),
        ])
    __CommonTransportChannelResourcesReleaseRequest_protocolIEs__item_._ext = None
    _CommonTransportChannelResourcesReleaseRequest_protocolIEs._cont = __CommonTransportChannelResourcesReleaseRequest_protocolIEs__item_
    _CommonTransportChannelResourcesReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelResourcesReleaseRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id._const_tab = ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality_tab
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id),
        (u'criticality', ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item_._ext = None
    _CommonTransportChannelResourcesReleaseRequest_protocolExtensions._cont = __CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item_
    _CommonTransportChannelResourcesReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelResourcesReleaseRequest._cont = ASN1Dict([
        (u'protocolIEs', _CommonTransportChannelResourcesReleaseRequest_protocolIEs),
        (u'protocolExtensions', _CommonTransportChannelResourcesReleaseRequest_protocolExtensions),
        ])
    CommonTransportChannelResourcesReleaseRequest._ext = []
    
    #-----< CommonTransportChannelResourcesReleaseRequest-IEs >-----#
    CommonTransportChannelResourcesReleaseRequest_IEs = CLASS(name=u'CommonTransportChannelResourcesReleaseRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonTransportChannelResourcesReleaseRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    CommonTransportChannelResourcesReleaseRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesReleaseRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesReleaseRequest-Extensions >-----#
    CommonTransportChannelResourcesReleaseRequest_Extensions = CLASS(name=u'CommonTransportChannelResourcesReleaseRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CommonTransportChannelResourcesReleaseRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesRequest >-----#
    CommonTransportChannelResourcesRequest = SEQ(name=u'CommonTransportChannelResourcesRequest', mode=MODE_TYPE)
    _CommonTransportChannelResourcesRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelResourcesRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerID')))
    ____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Value', _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 163), (u'criticality', u'reject'), (u'Value', _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__id._const_tab = ____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__value._const_tab = ____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonTransportChannelResourcesRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesRequest_protocolIEs__item__id),
        (u'criticality', ___CommonTransportChannelResourcesRequest_protocolIEs__item__criticality),
        (u'value', ___CommonTransportChannelResourcesRequest_protocolIEs__item__value),
        ])
    __CommonTransportChannelResourcesRequest_protocolIEs__item_._ext = None
    _CommonTransportChannelResourcesRequest_protocolIEs._cont = __CommonTransportChannelResourcesRequest_protocolIEs__item_
    _CommonTransportChannelResourcesRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelResourcesRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelResourcesRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-FACH-Support-Indicator')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-Support-Indicator')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Physical-Layer-Category')))
    _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE)
    ____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 560), (u'criticality', u'notify'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 685), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 753), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 860), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 747), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_8), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__id._const_tab = ____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonTransportChannelResourcesRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesRequest_protocolExtensions__item__id),
        (u'criticality', ___CommonTransportChannelResourcesRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonTransportChannelResourcesRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelResourcesRequest_protocolExtensions__item_._ext = None
    _CommonTransportChannelResourcesRequest_protocolExtensions._cont = __CommonTransportChannelResourcesRequest_protocolExtensions__item_
    _CommonTransportChannelResourcesRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelResourcesRequest._cont = ASN1Dict([
        (u'protocolIEs', _CommonTransportChannelResourcesRequest_protocolIEs),
        (u'protocolExtensions', _CommonTransportChannelResourcesRequest_protocolExtensions),
        ])
    CommonTransportChannelResourcesRequest._ext = []
    
    #-----< CommonTransportChannelResourcesRequest-IEs >-----#
    CommonTransportChannelResourcesRequest_IEs = CLASS(name=u'CommonTransportChannelResourcesRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonTransportChannelResourcesRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _CommonTransportChannelResourcesRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _CommonTransportChannelResourcesRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerRequestIndicator')))
    _CommonTransportChannelResourcesRequest_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportBearerID')))
    CommonTransportChannelResourcesRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'reject'), (u'Value', _CommonTransportChannelResourcesRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 6), (u'criticality', u'reject'), (u'Value', _CommonTransportChannelResourcesRequest_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 164), (u'criticality', u'reject'), (u'Value', _CommonTransportChannelResourcesRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 163), (u'criticality', u'reject'), (u'Value', _CommonTransportChannelResourcesRequest_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesRequest-Extensions >-----#
    CommonTransportChannelResourcesRequest_Extensions = CLASS(name=u'CommonTransportChannelResourcesRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_0 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_1 = OCT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_2 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_4 = CHOICE(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TnlQos')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_5 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-FACH-Support-Indicator')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_6 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-Support-Indicator')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_7 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-Physical-Layer-Category')))
    _CommonTransportChannelResourcesRequest_Extensions_val_Extension_8 = NULL(name=u'Extension', mode=MODE_TYPE)
    CommonTransportChannelResourcesRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 17), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 560), (u'criticality', u'notify'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 534), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 685), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 753), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_6), (u'presence', u'optional')]), dict([(u'id', 860), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_7), (u'presence', u'optional')]), dict([(u'id', 747), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesRequest_Extensions_val_Extension_8), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesResponseFDD >-----#
    CommonTransportChannelResourcesResponseFDD = SEQ(name=u'CommonTransportChannelResourcesResponseFDD', mode=MODE_TYPE)
    _CommonTransportChannelResourcesResponseFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelResourcesResponseFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD')))
    _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id._const_tab = ____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__value._const_tab = ____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonTransportChannelResourcesResponseFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id),
        (u'criticality', ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__criticality),
        (u'value', ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__value),
        ])
    __CommonTransportChannelResourcesResponseFDD_protocolIEs__item_._ext = None
    _CommonTransportChannelResourcesResponseFDD_protocolIEs._cont = __CommonTransportChannelResourcesResponseFDD_protocolIEs__item_
    _CommonTransportChannelResourcesResponseFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelResourcesResponseFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelResourcesResponseFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD')))
    _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-FACH-Information-ResponseFDD')))
    _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-MAC-d-Flow-Specific-InformationFDD')))
    _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 562), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 686), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 752), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 754), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id._const_tab = ____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonTransportChannelResourcesResponseFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id),
        (u'criticality', ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelResourcesResponseFDD_protocolExtensions__item_._ext = None
    _CommonTransportChannelResourcesResponseFDD_protocolExtensions._cont = __CommonTransportChannelResourcesResponseFDD_protocolExtensions__item_
    _CommonTransportChannelResourcesResponseFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelResourcesResponseFDD._cont = ASN1Dict([
        (u'protocolIEs', _CommonTransportChannelResourcesResponseFDD_protocolIEs),
        (u'protocolExtensions', _CommonTransportChannelResourcesResponseFDD_protocolExtensions),
        ])
    CommonTransportChannelResourcesResponseFDD._ext = []
    
    #-----< CommonTransportChannelResourcesResponseFDD-IEs >-----#
    CommonTransportChannelResourcesResponseFDD_IEs = CLASS(name=u'CommonTransportChannelResourcesResponseFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD')))
    _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelResourcesResponseFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 82), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD >-----#
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD = SEQ(name=u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD', mode=MODE_TYPE)
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_fACH_FlowControlInformation = SEQ(name=u'fACH-FlowControlInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'FACH-FlowControlInformation-CTCH-ResourceRspFDD')))
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id._const_tab = ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id_tab
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id._const_tab_at = None
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality._const_tab = ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality_tab
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue._const_tab = ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue_tab
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id),
        (u'criticality', ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue),
        ])
    __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item_._ext = None
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions._cont = __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item_
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD._cont = ASN1Dict([
        (u'fACH-FlowControlInformation', _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_fACH_FlowControlInformation),
        (u'iE-Extensions', _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions),
        ])
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD._ext = []
    
    #-----< FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD-ExtIEs >-----#
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_ExtIEs = CLASS(name=u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-FlowControlInformation-CTCH-ResourceRspFDD >-----#
    FACH_FlowControlInformation_CTCH_ResourceRspFDD = SEQ(name=u'FACH-FlowControlInformation-CTCH-ResourceRspFDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FACH-FlowControlInformation')))
    __FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', ___FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_id._const_tab = __FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_id._const_tab_at = None
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_id._const_tab_id = u'id'
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_criticality._const_tab = __FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_criticality._const_tab_at = ('..', u'id')
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_criticality._const_tab_id = u'criticality'
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_value._const_tab = __FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_value._const_tab_at = ('..', u'id')
    _FACH_FlowControlInformation_CTCH_ResourceRspFDD_value._const_tab_id = u'Value'
    FACH_FlowControlInformation_CTCH_ResourceRspFDD._cont = ASN1Dict([
        (u'id', _FACH_FlowControlInformation_CTCH_ResourceRspFDD_id),
        (u'criticality', _FACH_FlowControlInformation_CTCH_ResourceRspFDD_criticality),
        (u'value', _FACH_FlowControlInformation_CTCH_ResourceRspFDD_value),
        ])
    FACH_FlowControlInformation_CTCH_ResourceRspFDD._ext = None
    
    #-----< FACH-FlowControlInformationIEs-CTCH-ResourceRspFDD >-----#
    FACH_FlowControlInformationIEs_CTCH_ResourceRspFDD = CLASS(name=u'FACH-FlowControlInformationIEs-CTCH-ResourceRspFDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _FACH_FlowControlInformationIEs_CTCH_ResourceRspFDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FACH-FlowControlInformation')))
    FACH_FlowControlInformationIEs_CTCH_ResourceRspFDD._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _FACH_FlowControlInformationIEs_CTCH_ResourceRspFDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CommonTransportChannelResourcesResponseFDD-Extensions >-----#
    CommonTransportChannelResourcesResponseFDD_Extensions = CLASS(name=u'CommonTransportChannelResourcesResponseFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListFDD')))
    _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-FACH-Information-ResponseFDD')))
    _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-MAC-d-Flow-Specific-InformationFDD')))
    _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-RNTI')))
    _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_5 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    CommonTransportChannelResourcesResponseFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 562), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 686), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 752), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 754), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesResponseTDD >-----#
    CommonTransportChannelResourcesResponseTDD = SEQ(name=u'CommonTransportChannelResourcesResponseTDD', mode=MODE_TYPE)
    _CommonTransportChannelResourcesResponseTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelResourcesResponseTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD')))
    _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id._const_tab = ____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__value._const_tab = ____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonTransportChannelResourcesResponseTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id),
        (u'criticality', ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__criticality),
        (u'value', ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__value),
        ])
    __CommonTransportChannelResourcesResponseTDD_protocolIEs__item_._ext = None
    _CommonTransportChannelResourcesResponseTDD_protocolIEs._cont = __CommonTransportChannelResourcesResponseTDD_protocolIEs__item_
    _CommonTransportChannelResourcesResponseTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelResourcesResponseTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelResourcesResponseTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD')))
    _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-FACH-Information-ResponseLCR')))
    _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-MAC-d-Flow-Specific-InformationLCR')))
    _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 563), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 788), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 789), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id._const_tab = ____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonTransportChannelResourcesResponseTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id),
        (u'criticality', ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelResourcesResponseTDD_protocolExtensions__item_._ext = None
    _CommonTransportChannelResourcesResponseTDD_protocolExtensions._cont = __CommonTransportChannelResourcesResponseTDD_protocolExtensions__item_
    _CommonTransportChannelResourcesResponseTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelResourcesResponseTDD._cont = ASN1Dict([
        (u'protocolIEs', _CommonTransportChannelResourcesResponseTDD_protocolIEs),
        (u'protocolExtensions', _CommonTransportChannelResourcesResponseTDD_protocolExtensions),
        ])
    CommonTransportChannelResourcesResponseTDD._ext = []
    
    #-----< CommonTransportChannelResourcesResponseTDD-IEs >-----#
    CommonTransportChannelResourcesResponseTDD_IEs = CLASS(name=u'CommonTransportChannelResourcesResponseTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-RNTI')))
    _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD')))
    _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_3 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'BindingID')))
    _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelResourcesResponseTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 7), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 83), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 165), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 5), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_5), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD >-----#
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD = SEQ(name=u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD', mode=MODE_TYPE)
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_fACH_FlowControlInformation = SEQ(name=u'fACH-FlowControlInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'FACH-FlowControlInformation-CTCH-ResourceRspTDD')))
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id._const_tab = ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id_tab
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id._const_tab_at = None
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality._const_tab = ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality_tab
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue._const_tab = ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue_tab
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id),
        (u'criticality', ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue),
        ])
    __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item_._ext = None
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions._cont = __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item_
    _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD._cont = ASN1Dict([
        (u'fACH-FlowControlInformation', _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_fACH_FlowControlInformation),
        (u'iE-Extensions', _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions),
        ])
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD._ext = []
    
    #-----< FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD-ExtIEs >-----#
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_ExtIEs = CLASS(name=u'FACH-InfoForUESelectedS-CCPCH-CTCH-ResourceRspTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FACH-FlowControlInformation-CTCH-ResourceRspTDD >-----#
    FACH_FlowControlInformation_CTCH_ResourceRspTDD = SEQ(name=u'FACH-FlowControlInformation-CTCH-ResourceRspTDD', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FACH-FlowControlInformation')))
    __FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', ___FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_id._const_tab = __FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_id._const_tab_at = None
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_id._const_tab_id = u'id'
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_criticality._const_tab = __FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_criticality._const_tab_at = ('..', u'id')
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_criticality._const_tab_id = u'criticality'
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_value._const_tab = __FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_value._const_tab_at = ('..', u'id')
    _FACH_FlowControlInformation_CTCH_ResourceRspTDD_value._const_tab_id = u'Value'
    FACH_FlowControlInformation_CTCH_ResourceRspTDD._cont = ASN1Dict([
        (u'id', _FACH_FlowControlInformation_CTCH_ResourceRspTDD_id),
        (u'criticality', _FACH_FlowControlInformation_CTCH_ResourceRspTDD_criticality),
        (u'value', _FACH_FlowControlInformation_CTCH_ResourceRspTDD_value),
        ])
    FACH_FlowControlInformation_CTCH_ResourceRspTDD._ext = None
    
    #-----< FACH-FlowControlInformationIEs-CTCH-ResourceRspTDD >-----#
    FACH_FlowControlInformationIEs_CTCH_ResourceRspTDD = CLASS(name=u'FACH-FlowControlInformationIEs-CTCH-ResourceRspTDD', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _FACH_FlowControlInformationIEs_CTCH_ResourceRspTDD_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FACH-FlowControlInformation')))
    FACH_FlowControlInformationIEs_CTCH_ResourceRspTDD._val = ASN1Set(rv=[dict([(u'id', 103), (u'criticality', u'ignore'), (u'Value', _FACH_FlowControlInformationIEs_CTCH_ResourceRspTDD_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< CommonTransportChannelResourcesResponseTDD-Extensions >-----#
    CommonTransportChannelResourcesResponseTDD_Extensions = CLASS(name=u'CommonTransportChannelResourcesResponseTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-MBMS-Bearer-Service-ListTDD')))
    _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Enhanced-FACH-Information-ResponseLCR')))
    _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_3 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Common-EDCH-MAC-d-Flow-Specific-InformationLCR')))
    _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_4 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    CommonTransportChannelResourcesResponseTDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 6), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_0), (u'presence', u'mandatory')]), dict([(u'id', 563), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 788), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 789), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesFailure >-----#
    CommonTransportChannelResourcesFailure = SEQ(name=u'CommonTransportChannelResourcesFailure', mode=MODE_TYPE)
    _CommonTransportChannelResourcesFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonTransportChannelResourcesFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__id._const_tab = ____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__criticality._const_tab = ____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__value._const_tab = ____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonTransportChannelResourcesFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesFailure_protocolIEs__item__id),
        (u'criticality', ___CommonTransportChannelResourcesFailure_protocolIEs__item__criticality),
        (u'value', ___CommonTransportChannelResourcesFailure_protocolIEs__item__value),
        ])
    __CommonTransportChannelResourcesFailure_protocolIEs__item_._ext = None
    _CommonTransportChannelResourcesFailure_protocolIEs._cont = __CommonTransportChannelResourcesFailure_protocolIEs__item_
    _CommonTransportChannelResourcesFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonTransportChannelResourcesFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonTransportChannelResourcesFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__id._const_tab = ____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__id._const_tab_at = None
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__criticality._const_tab = ____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__extensionValue._const_tab = ____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonTransportChannelResourcesFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonTransportChannelResourcesFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonTransportChannelResourcesFailure_protocolExtensions__item__id),
        (u'criticality', ___CommonTransportChannelResourcesFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonTransportChannelResourcesFailure_protocolExtensions__item__extensionValue),
        ])
    __CommonTransportChannelResourcesFailure_protocolExtensions__item_._ext = None
    _CommonTransportChannelResourcesFailure_protocolExtensions._cont = __CommonTransportChannelResourcesFailure_protocolExtensions__item_
    _CommonTransportChannelResourcesFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonTransportChannelResourcesFailure._cont = ASN1Dict([
        (u'protocolIEs', _CommonTransportChannelResourcesFailure_protocolIEs),
        (u'protocolExtensions', _CommonTransportChannelResourcesFailure_protocolExtensions),
        ])
    CommonTransportChannelResourcesFailure._ext = []
    
    #-----< CommonTransportChannelResourcesFailure-IEs >-----#
    CommonTransportChannelResourcesFailure_IEs = CLASS(name=u'CommonTransportChannelResourcesFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonTransportChannelResourcesFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _CommonTransportChannelResourcesFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _CommonTransportChannelResourcesFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    CommonTransportChannelResourcesFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _CommonTransportChannelResourcesFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonTransportChannelResourcesFailure-Extensions >-----#
    CommonTransportChannelResourcesFailure_Extensions = CLASS(name=u'CommonTransportChannelResourcesFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonTransportChannelResourcesFailure_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    CommonTransportChannelResourcesFailure_Extensions._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _CommonTransportChannelResourcesFailure_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CompressedModeCommand >-----#
    CompressedModeCommand = SEQ(name=u'CompressedModeCommand', mode=MODE_TYPE)
    _CompressedModeCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CompressedModeCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CompressedModeCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CompressedModeCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    ____CompressedModeCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 193), (u'criticality', u'ignore'), (u'Value', _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolIEs__item__id._const_tab = ____CompressedModeCommand_protocolIEs__item__id_tab
    ___CompressedModeCommand_protocolIEs__item__id._const_tab_at = None
    ___CompressedModeCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___CompressedModeCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CompressedModeCommand_protocolIEs__item__criticality._const_tab = ____CompressedModeCommand_protocolIEs__item__id_tab
    ___CompressedModeCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CompressedModeCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CompressedModeCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CompressedModeCommand_protocolIEs__item__value._const_tab = ____CompressedModeCommand_protocolIEs__item__id_tab
    ___CompressedModeCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CompressedModeCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __CompressedModeCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CompressedModeCommand_protocolIEs__item__id),
        (u'criticality', ___CompressedModeCommand_protocolIEs__item__criticality),
        (u'value', ___CompressedModeCommand_protocolIEs__item__value),
        ])
    __CompressedModeCommand_protocolIEs__item_._ext = None
    _CompressedModeCommand_protocolIEs._cont = __CompressedModeCommand_protocolIEs__item_
    _CompressedModeCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CompressedModeCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CompressedModeCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CompressedModeCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CompressedModeCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CompressedModeCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolExtensions__item__id._const_tab = ____CompressedModeCommand_protocolExtensions__item__id_tab
    ___CompressedModeCommand_protocolExtensions__item__id._const_tab_at = None
    ___CompressedModeCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___CompressedModeCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____CompressedModeCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CompressedModeCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolExtensions__item__criticality._const_tab = ____CompressedModeCommand_protocolExtensions__item__criticality_tab
    ___CompressedModeCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CompressedModeCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CompressedModeCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompressedModeCommand_protocolExtensions__item__extensionValue._const_tab = ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab
    ___CompressedModeCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CompressedModeCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CompressedModeCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CompressedModeCommand_protocolExtensions__item__id),
        (u'criticality', ___CompressedModeCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___CompressedModeCommand_protocolExtensions__item__extensionValue),
        ])
    __CompressedModeCommand_protocolExtensions__item_._ext = None
    _CompressedModeCommand_protocolExtensions._cont = __CompressedModeCommand_protocolExtensions__item_
    _CompressedModeCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CompressedModeCommand._cont = ASN1Dict([
        (u'protocolIEs', _CompressedModeCommand_protocolIEs),
        (u'protocolExtensions', _CompressedModeCommand_protocolExtensions),
        ])
    CompressedModeCommand._ext = []
    
    #-----< CompressedModeCommand-IEs >-----#
    CompressedModeCommand_IEs = CLASS(name=u'CompressedModeCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CompressedModeCommand_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Active-Pattern-Sequence-Information')))
    CompressedModeCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 193), (u'criticality', u'ignore'), (u'Value', _CompressedModeCommand_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CompressedModeCommand-Extensions >-----#
    CompressedModeCommand_Extensions = CLASS(name=u'CompressedModeCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CompressedModeCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name=u'ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolIEs__item__id),
        (u'criticality', ___ErrorIndication_protocolIEs__item__criticality),
        (u'value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ErrorIndication_protocolExtensions__item__id),
        (u'criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        (u'protocolIEs', _ErrorIndication_protocolIEs),
        (u'protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndication-IEs >-----#
    ErrorIndication_IEs = CLASS(name=u'ErrorIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _ErrorIndication_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _ErrorIndication_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ErrorIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _ErrorIndication_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication-Extensions >-----#
    ErrorIndication_Extensions = CLASS(name=u'ErrorIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _ErrorIndication_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _ErrorIndication_Extensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _ErrorIndication_Extensions_val_Extension_2 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ErrorIndication_Extensions._val = ASN1Set(rv=[dict([(u'id', 155), (u'criticality', u'ignore'), (u'Extension', _ErrorIndication_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Extension', _ErrorIndication_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _ErrorIndication_Extensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationRequest >-----#
    CommonMeasurementInitiationRequest = SEQ(name=u'CommonMeasurementInitiationRequest', mode=MODE_TYPE)
    _CommonMeasurementInitiationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rqst')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementType')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ReportCharacteristics')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FNReportingIndicator')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementAccuracy')))
    ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 282), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 284), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 286), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 285), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementInitiationRequest_protocolIEs__item__id),
        (u'criticality', ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality),
        (u'value', ___CommonMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __CommonMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _CommonMeasurementInitiationRequest_protocolIEs._cont = __CommonMeasurementInitiationRequest_protocolIEs__item_
    _CommonMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementInitiationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryBehavior')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Time-ID')))
    _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rqst')))
    ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 554), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 773), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 2055), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id._const_tab = ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementInitiationRequest_protocolExtensions__item__id),
        (u'criticality', ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementInitiationRequest_protocolExtensions__item_._ext = None
    _CommonMeasurementInitiationRequest_protocolExtensions._cont = __CommonMeasurementInitiationRequest_protocolExtensions__item_
    _CommonMeasurementInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementInitiationRequest._cont = ASN1Dict([
        (u'protocolIEs', _CommonMeasurementInitiationRequest_protocolIEs),
        (u'protocolExtensions', _CommonMeasurementInitiationRequest_protocolExtensions),
        ])
    CommonMeasurementInitiationRequest._ext = []
    
    #-----< CommonMeasurementInitiationRequest-IEs >-----#
    CommonMeasurementInitiationRequest_IEs = CLASS(name=u'CommonMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rqst')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementType')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_3 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ReportCharacteristics')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'FNReportingIndicator')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_6 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    _CommonMeasurementInitiationRequest_IEs_val_Value_7 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementAccuracy')))
    CommonMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 282), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 284), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 152), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 286), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_5), (u'presence', u'mandatory')]), dict([(u'id', 285), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationRequest_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationRequest-Extensions >-----#
    CommonMeasurementInitiationRequest_Extensions = CLASS(name=u'CommonMeasurementInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryBehavior')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'GANSS-Time-ID')))
    _CommonMeasurementInitiationRequest_Extensions_val_Extension_2 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rqst')))
    CommonMeasurementInitiationRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 554), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 773), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 2055), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementInitiationRequest_Extensions_val_Extension_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementObjectType-CM-Rqst >-----#
    CommonMeasurementObjectType_CM_Rqst = CHOICE(name=u'CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE)
    _CommonMeasurementObjectType_CM_Rqst_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-CM-Rqst')))
    _CommonMeasurementObjectType_CM_Rqst_additional_CommonMeasurementObjectType_CM_Rqst = SEQ(name=u'additional-CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-CommonMeasurementObjectType-CM-Rqst')))
    CommonMeasurementObjectType_CM_Rqst._cont = ASN1Dict([
        (u'cell', _CommonMeasurementObjectType_CM_Rqst_cell),
        (u'additional-CommonMeasurementObjectType-CM-Rqst', _CommonMeasurementObjectType_CM_Rqst_additional_CommonMeasurementObjectType_CM_Rqst),
        ])
    CommonMeasurementObjectType_CM_Rqst._ext = [u'additional-CommonMeasurementObjectType-CM-Rqst']
    
    #-----< Cell-CM-Rqst >-----#
    Cell_CM_Rqst = SEQ(name=u'Cell-CM-Rqst', mode=MODE_TYPE)
    _Cell_CM_Rqst_uC_ID = SEQ(name=u'uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _Cell_CM_Rqst_timeSlot = INT(name=u'timeSlot', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlot')), opt=True)
    _Cell_CM_Rqst_timeSlotLCR = INT(name=u'timeSlotLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TimeSlotLCR')), opt=True)
    _Cell_CM_Rqst_neighbouringCellMeasurementInformation = SEQ_OF(name=u'neighbouringCellMeasurementInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'NeighbouringCellMeasurementInfo')), opt=True)
    _Cell_CM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UPPCHPositionLCR')))
    ____Cell_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 724), (u'criticality', u'reject'), (u'Extension', _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___Cell_CM_Rqst_iE_Extensions__item__id._const_tab = ____Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___Cell_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_CM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_CM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___Cell_CM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __Cell_CM_Rqst_iE_Extensions__item_._ext = None
    _Cell_CM_Rqst_iE_Extensions._cont = __Cell_CM_Rqst_iE_Extensions__item_
    _Cell_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CM_Rqst._cont = ASN1Dict([
        (u'uC-ID', _Cell_CM_Rqst_uC_ID),
        (u'timeSlot', _Cell_CM_Rqst_timeSlot),
        (u'timeSlotLCR', _Cell_CM_Rqst_timeSlotLCR),
        (u'neighbouringCellMeasurementInformation', _Cell_CM_Rqst_neighbouringCellMeasurementInformation),
        (u'iE-Extensions', _Cell_CM_Rqst_iE_Extensions),
        ])
    Cell_CM_Rqst._ext = []
    
    #-----< NeighbouringCellMeasurementInfo >-----#
    NeighbouringCellMeasurementInfo = SEQ_OF(name=u'NeighbouringCellMeasurementInfo', mode=MODE_TYPE)
    _NeighbouringCellMeasurementInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __NeighbouringCellMeasurementInfo__item__neighbouringFDDCellMeasurementInformation = SEQ(name=u'neighbouringFDDCellMeasurementInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NeighbouringFDDCellMeasurementInformation')))
    __NeighbouringCellMeasurementInfo__item__neighbouringTDDCellMeasurementInformation = SEQ(name=u'neighbouringTDDCellMeasurementInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'NeighbouringTDDCellMeasurementInformation')))
    __NeighbouringCellMeasurementInfo__item__extension_neighbouringCellMeasurementInformation = SEQ(name=u'extension-neighbouringCellMeasurementInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-neighbouringCellMeasurementInformation')))
    __NeighbouringCellMeasurementInfo__item__extension_neighbouringCellMeasurementInformation768 = SEQ(name=u'extension-neighbouringCellMeasurementInformation768', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-neighbouringCellMeasurementInformation768')))
    _NeighbouringCellMeasurementInfo__item_._cont = ASN1Dict([
        (u'neighbouringFDDCellMeasurementInformation', __NeighbouringCellMeasurementInfo__item__neighbouringFDDCellMeasurementInformation),
        (u'neighbouringTDDCellMeasurementInformation', __NeighbouringCellMeasurementInfo__item__neighbouringTDDCellMeasurementInformation),
        (u'extension-neighbouringCellMeasurementInformation', __NeighbouringCellMeasurementInfo__item__extension_neighbouringCellMeasurementInformation),
        (u'extension-neighbouringCellMeasurementInformation768', __NeighbouringCellMeasurementInfo__item__extension_neighbouringCellMeasurementInformation768),
        ])
    _NeighbouringCellMeasurementInfo__item_._ext = [u'extension-neighbouringCellMeasurementInformation', u'extension-neighbouringCellMeasurementInformation768']
    NeighbouringCellMeasurementInfo._cont = _NeighbouringCellMeasurementInfo__item_
    NeighbouringCellMeasurementInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=96)], ev=None, er=[])
    
    #-----< Extension-neighbouringCellMeasurementInformation >-----#
    Extension_neighbouringCellMeasurementInformation = SEQ(name=u'Extension-neighbouringCellMeasurementInformation', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_neighbouringCellMeasurementInformation_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_neighbouringCellMeasurementInformation_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeighbouringTDDCellMeasurementInformationLCR')))
    __Extension_neighbouringCellMeasurementInformation_id_tab._val = ASN1Set(rv=[dict([(u'id', 251), (u'criticality', u'reject'), (u'Value', ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_neighbouringCellMeasurementInformation_id._const_tab = __Extension_neighbouringCellMeasurementInformation_id_tab
    _Extension_neighbouringCellMeasurementInformation_id._const_tab_at = None
    _Extension_neighbouringCellMeasurementInformation_id._const_tab_id = u'id'
    _Extension_neighbouringCellMeasurementInformation_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_neighbouringCellMeasurementInformation_criticality._const_tab = __Extension_neighbouringCellMeasurementInformation_id_tab
    _Extension_neighbouringCellMeasurementInformation_criticality._const_tab_at = ('..', u'id')
    _Extension_neighbouringCellMeasurementInformation_criticality._const_tab_id = u'criticality'
    _Extension_neighbouringCellMeasurementInformation_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_neighbouringCellMeasurementInformation_value._const_tab = __Extension_neighbouringCellMeasurementInformation_id_tab
    _Extension_neighbouringCellMeasurementInformation_value._const_tab_at = ('..', u'id')
    _Extension_neighbouringCellMeasurementInformation_value._const_tab_id = u'Value'
    Extension_neighbouringCellMeasurementInformation._cont = ASN1Dict([
        (u'id', _Extension_neighbouringCellMeasurementInformation_id),
        (u'criticality', _Extension_neighbouringCellMeasurementInformation_criticality),
        (u'value', _Extension_neighbouringCellMeasurementInformation_value),
        ])
    Extension_neighbouringCellMeasurementInformation._ext = None
    
    #-----< Extension-neighbouringCellMeasurementInformationIE >-----#
    Extension_neighbouringCellMeasurementInformationIE = CLASS(name=u'Extension-neighbouringCellMeasurementInformationIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_neighbouringCellMeasurementInformationIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeighbouringTDDCellMeasurementInformationLCR')))
    Extension_neighbouringCellMeasurementInformationIE._val = ASN1Set(rv=[dict([(u'id', 251), (u'criticality', u'reject'), (u'Value', _Extension_neighbouringCellMeasurementInformationIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Extension-neighbouringCellMeasurementInformation768 >-----#
    Extension_neighbouringCellMeasurementInformation768 = SEQ(name=u'Extension-neighbouringCellMeasurementInformation768', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_neighbouringCellMeasurementInformation768_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_neighbouringCellMeasurementInformation768_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_neighbouringCellMeasurementInformation768_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeighbouringTDDCellMeasurementInformation768')))
    __Extension_neighbouringCellMeasurementInformation768_id_tab._val = ASN1Set(rv=[dict([(u'id', 631), (u'criticality', u'reject'), (u'Value', ___Extension_neighbouringCellMeasurementInformation768_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_neighbouringCellMeasurementInformation768_id._const_tab = __Extension_neighbouringCellMeasurementInformation768_id_tab
    _Extension_neighbouringCellMeasurementInformation768_id._const_tab_at = None
    _Extension_neighbouringCellMeasurementInformation768_id._const_tab_id = u'id'
    _Extension_neighbouringCellMeasurementInformation768_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_neighbouringCellMeasurementInformation768_criticality._const_tab = __Extension_neighbouringCellMeasurementInformation768_id_tab
    _Extension_neighbouringCellMeasurementInformation768_criticality._const_tab_at = ('..', u'id')
    _Extension_neighbouringCellMeasurementInformation768_criticality._const_tab_id = u'criticality'
    _Extension_neighbouringCellMeasurementInformation768_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_neighbouringCellMeasurementInformation768_value._const_tab = __Extension_neighbouringCellMeasurementInformation768_id_tab
    _Extension_neighbouringCellMeasurementInformation768_value._const_tab_at = ('..', u'id')
    _Extension_neighbouringCellMeasurementInformation768_value._const_tab_id = u'Value'
    Extension_neighbouringCellMeasurementInformation768._cont = ASN1Dict([
        (u'id', _Extension_neighbouringCellMeasurementInformation768_id),
        (u'criticality', _Extension_neighbouringCellMeasurementInformation768_criticality),
        (u'value', _Extension_neighbouringCellMeasurementInformation768_value),
        ])
    Extension_neighbouringCellMeasurementInformation768._ext = None
    
    #-----< Extension-neighbouringCellMeasurementInformation768IE >-----#
    Extension_neighbouringCellMeasurementInformation768IE = CLASS(name=u'Extension-neighbouringCellMeasurementInformation768IE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_neighbouringCellMeasurementInformation768IE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'NeighbouringTDDCellMeasurementInformation768')))
    Extension_neighbouringCellMeasurementInformation768IE._val = ASN1Set(rv=[dict([(u'id', 631), (u'criticality', u'reject'), (u'Value', _Extension_neighbouringCellMeasurementInformation768IE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CellItem-CM-Rqst-ExtIEs >-----#
    CellItem_CM_Rqst_ExtIEs = CLASS(name=u'CellItem-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UARFCN')))
    _CellItem_CM_Rqst_ExtIEs_val_Extension_1 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UPPCHPositionLCR')))
    CellItem_CM_Rqst_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 714), (u'criticality', u'ignore'), (u'Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 724), (u'criticality', u'reject'), (u'Extension', _CellItem_CM_Rqst_ExtIEs_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Additional-CommonMeasurementObjectType-CM-Rqst >-----#
    Additional_CommonMeasurementObjectType_CM_Rqst = SEQ(name=u'Additional-CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Additional_CommonMeasurementObjectType_CM_Rqst_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Additional_CommonMeasurementObjectType_CM_Rqst_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Additional_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GSM-Cell-CM-Rqst')))
    __Additional_CommonMeasurementObjectType_CM_Rqst_id_tab._val = ASN1Set(rv=[dict([(u'id', 2053), (u'criticality', u'ignore'), (u'Value', ___Additional_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Additional_CommonMeasurementObjectType_CM_Rqst_id._const_tab = __Additional_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Additional_CommonMeasurementObjectType_CM_Rqst_id._const_tab_at = None
    _Additional_CommonMeasurementObjectType_CM_Rqst_id._const_tab_id = u'id'
    _Additional_CommonMeasurementObjectType_CM_Rqst_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Additional_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab = __Additional_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Additional_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab_at = ('..', u'id')
    _Additional_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab_id = u'criticality'
    _Additional_CommonMeasurementObjectType_CM_Rqst_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Additional_CommonMeasurementObjectType_CM_Rqst_value._const_tab = __Additional_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Additional_CommonMeasurementObjectType_CM_Rqst_value._const_tab_at = ('..', u'id')
    _Additional_CommonMeasurementObjectType_CM_Rqst_value._const_tab_id = u'Value'
    Additional_CommonMeasurementObjectType_CM_Rqst._cont = ASN1Dict([
        (u'id', _Additional_CommonMeasurementObjectType_CM_Rqst_id),
        (u'criticality', _Additional_CommonMeasurementObjectType_CM_Rqst_criticality),
        (u'value', _Additional_CommonMeasurementObjectType_CM_Rqst_value),
        ])
    Additional_CommonMeasurementObjectType_CM_Rqst._ext = None
    
    #-----< Additional-CommonMeasurementObjectType-CM-RqstIE >-----#
    Additional_CommonMeasurementObjectType_CM_RqstIE = CLASS(name=u'Additional-CommonMeasurementObjectType-CM-RqstIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Additional_CommonMeasurementObjectType_CM_RqstIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GSM-Cell-CM-Rqst')))
    Additional_CommonMeasurementObjectType_CM_RqstIE._val = ASN1Set(rv=[dict([(u'id', 2053), (u'criticality', u'ignore'), (u'Value', _Additional_CommonMeasurementObjectType_CM_RqstIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GSM-Cell-CM-Rqst >-----#
    GSM_Cell_CM_Rqst = SEQ(name=u'GSM-Cell-CM-Rqst', mode=MODE_TYPE)
    _GSM_Cell_CM_Rqst_cGI = SEQ(name=u'cGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CGI')))
    _GSM_Cell_CM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GSM_Cell_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GSM_Cell_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GSM_Cell_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__id._const_tab = ____GSM_Cell_CM_Rqst_iE_Extensions__item__id_tab
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GSM_Cell_CM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GSM_Cell_CM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____GSM_Cell_CM_Rqst_iE_Extensions__item__criticality_tab
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue_tab
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GSM_Cell_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GSM_Cell_CM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___GSM_Cell_CM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __GSM_Cell_CM_Rqst_iE_Extensions__item_._ext = None
    _GSM_Cell_CM_Rqst_iE_Extensions._cont = __GSM_Cell_CM_Rqst_iE_Extensions__item_
    _GSM_Cell_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GSM_Cell_CM_Rqst._cont = ASN1Dict([
        (u'cGI', _GSM_Cell_CM_Rqst_cGI),
        (u'iE-Extensions', _GSM_Cell_CM_Rqst_iE_Extensions),
        ])
    GSM_Cell_CM_Rqst._ext = []
    
    #-----< GSMCell-CM-Rqst-ExtIEs >-----#
    GSMCell_CM_Rqst_ExtIEs = CLASS(name=u'GSMCell-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GSMCell_CM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-CommonMeasurementObjectType-CM-Rqst >-----#
    Extension_CommonMeasurementObjectType_CM_Rqst = SEQ(name=u'Extension-CommonMeasurementObjectType-CM-Rqst', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementObjectType_CM_Rqst_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellList-CM-Rqst')))
    __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab._val = ASN1Set(rv=[dict([(u'id', 2061), (u'criticality', u'ignore'), (u'Value', ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementObjectType_CM_Rqst_id._const_tab = __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rqst_id._const_tab_at = None
    _Extension_CommonMeasurementObjectType_CM_Rqst_id._const_tab_id = u'id'
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab = __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementObjectType_CM_Rqst_criticality._const_tab_id = u'criticality'
    _Extension_CommonMeasurementObjectType_CM_Rqst_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_CommonMeasurementObjectType_CM_Rqst_value._const_tab = __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rqst_value._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementObjectType_CM_Rqst_value._const_tab_id = u'Value'
    Extension_CommonMeasurementObjectType_CM_Rqst._cont = ASN1Dict([
        (u'id', _Extension_CommonMeasurementObjectType_CM_Rqst_id),
        (u'criticality', _Extension_CommonMeasurementObjectType_CM_Rqst_criticality),
        (u'value', _Extension_CommonMeasurementObjectType_CM_Rqst_value),
        ])
    Extension_CommonMeasurementObjectType_CM_Rqst._ext = None
    
    #-----< Extension-CommonMeasurementObjectType-CM-RqstIE >-----#
    Extension_CommonMeasurementObjectType_CM_RqstIE = CLASS(name=u'Extension-CommonMeasurementObjectType-CM-RqstIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellList-CM-Rqst')))
    Extension_CommonMeasurementObjectType_CM_RqstIE._val = ASN1Set(rv=[dict([(u'id', 2061), (u'criticality', u'ignore'), (u'Value', _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GsmCellList-CM-Rqst >-----#
    GsmCellList_CM_Rqst = SEQ_OF(name=u'GsmCellList-CM-Rqst', mode=MODE_TYPE)
    _GsmCellList_CM_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellItem-CM-Rqst')))
    GsmCellList_CM_Rqst._cont = _GsmCellList_CM_Rqst__item_
    GsmCellList_CM_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< GsmCellItem-CM-Rqst >-----#
    GsmCellItem_CM_Rqst = SEQ(name=u'GsmCellItem-CM-Rqst', mode=MODE_TYPE)
    _GsmCellItem_CM_Rqst_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _GsmCellItem_CM_Rqst_gsmCell = SEQ(name=u'gsmCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GSM-Cell-CM-Rqst')))
    _GsmCellItem_CM_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GsmCellItem_CM_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GsmCellItem_CM_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__id._const_tab = ____GsmCellItem_CM_Rqst_iE_Extensions__item__id_tab
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GsmCellItem_CM_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__criticality._const_tab = ____GsmCellItem_CM_Rqst_iE_Extensions__item__criticality_tab
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue._const_tab = ____GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue_tab
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GsmCellItem_CM_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GsmCellItem_CM_Rqst_iE_Extensions__item__id),
        (u'criticality', ___GsmCellItem_CM_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue),
        ])
    __GsmCellItem_CM_Rqst_iE_Extensions__item_._ext = None
    _GsmCellItem_CM_Rqst_iE_Extensions._cont = __GsmCellItem_CM_Rqst_iE_Extensions__item_
    _GsmCellItem_CM_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GsmCellItem_CM_Rqst._cont = ASN1Dict([
        (u'measurementID', _GsmCellItem_CM_Rqst_measurementID),
        (u'gsmCell', _GsmCellItem_CM_Rqst_gsmCell),
        (u'iE-Extensions', _GsmCellItem_CM_Rqst_iE_Extensions),
        ])
    GsmCellItem_CM_Rqst._ext = []
    
    #-----< GsmCellItem-CM-Rqst-ExtIEs >-----#
    GsmCellItem_CM_Rqst_ExtIEs = CLASS(name=u'GsmCellItem-CM-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GsmCellItem_CM_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationResponse >-----#
    CommonMeasurementInitiationResponse = SEQ(name=u'CommonMeasurementInitiationResponse', mode=MODE_TYPE)
    _CommonMeasurementInitiationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rsp')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementAccuracy')))
    ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'reject'), (u'Value', _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementInitiationResponse_protocolIEs__item__id),
        (u'criticality', ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality),
        (u'value', ___CommonMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __CommonMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _CommonMeasurementInitiationResponse_protocolIEs._cont = __CommonMeasurementInitiationResponse_protocolIEs__item_
    _CommonMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementInitiationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoverySupportIndicator')))
    _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rsp')))
    ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 556), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 2056), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id._const_tab = ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementInitiationResponse_protocolExtensions__item__id),
        (u'criticality', ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementInitiationResponse_protocolExtensions__item_._ext = None
    _CommonMeasurementInitiationResponse_protocolExtensions._cont = __CommonMeasurementInitiationResponse_protocolExtensions__item_
    _CommonMeasurementInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementInitiationResponse._cont = ASN1Dict([
        (u'protocolIEs', _CommonMeasurementInitiationResponse_protocolIEs),
        (u'protocolExtensions', _CommonMeasurementInitiationResponse_protocolExtensions),
        ])
    CommonMeasurementInitiationResponse._ext = []
    
    #-----< CommonMeasurementInitiationResponse-IEs >-----#
    CommonMeasurementInitiationResponse_IEs = CLASS(name=u'CommonMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rsp')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    _CommonMeasurementInitiationResponse_IEs_val_Value_4 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementAccuracy')))
    CommonMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 283), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationResponse_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationResponse_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 280), (u'criticality', u'reject'), (u'Value', _CommonMeasurementInitiationResponse_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationResponse-Extensions >-----#
    CommonMeasurementInitiationResponse_Extensions = CLASS(name=u'CommonMeasurementInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementInitiationResponse_Extensions_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoverySupportIndicator')))
    _CommonMeasurementInitiationResponse_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rsp')))
    CommonMeasurementInitiationResponse_Extensions._val = ASN1Set(rv=[dict([(u'id', 556), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementInitiationResponse_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 2056), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementInitiationResponse_Extensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementObjectType-CM-Rsp >-----#
    CommonMeasurementObjectType_CM_Rsp = CHOICE(name=u'CommonMeasurementObjectType-CM-Rsp', mode=MODE_TYPE)
    _CommonMeasurementObjectType_CM_Rsp_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-CM-Rsp')))
    CommonMeasurementObjectType_CM_Rsp._cont = ASN1Dict([
        (u'cell', _CommonMeasurementObjectType_CM_Rsp_cell),
        ])
    CommonMeasurementObjectType_CM_Rsp._ext = []
    
    #-----< Cell-CM-Rsp >-----#
    Cell_CM_Rsp = SEQ(name=u'Cell-CM-Rsp', mode=MODE_TYPE)
    _Cell_CM_Rsp_commonMeasurementValue = CHOICE(name=u'commonMeasurementValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementValue')))
    _Cell_CM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_CM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_CM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CM_Rsp_iE_Extensions__item__id._const_tab = ____Cell_CM_Rsp_iE_Extensions__item__id_tab
    ___Cell_CM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_CM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_CM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_CM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CM_Rsp_iE_Extensions__item__criticality._const_tab = ____Cell_CM_Rsp_iE_Extensions__item__criticality_tab
    ___Cell_CM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_CM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_CM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_CM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Cell_CM_Rsp_iE_Extensions__item__extensionValue_tab
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_CM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_CM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Cell_CM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_CM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Cell_CM_Rsp_iE_Extensions__item_._ext = None
    _Cell_CM_Rsp_iE_Extensions._cont = __Cell_CM_Rsp_iE_Extensions__item_
    _Cell_CM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CM_Rsp._cont = ASN1Dict([
        (u'commonMeasurementValue', _Cell_CM_Rsp_commonMeasurementValue),
        (u'iE-Extensions', _Cell_CM_Rsp_iE_Extensions),
        ])
    Cell_CM_Rsp._ext = []
    
    #-----< CellItem-CM-Rsp-ExtIEs >-----#
    CellItem_CM_Rsp_ExtIEs = CLASS(name=u'CellItem-CM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellItem_CM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-CommonMeasurementObjectType-CM-Rsp >-----#
    Extension_CommonMeasurementObjectType_CM_Rsp = SEQ(name=u'Extension-CommonMeasurementObjectType-CM-Rsp', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementObjectType_CM_Rsp_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellList-CM-Rsp')))
    __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab._val = ASN1Set(rv=[dict([(u'id', 2062), (u'criticality', u'ignore'), (u'Value', ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementObjectType_CM_Rsp_id._const_tab = __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rsp_id._const_tab_at = None
    _Extension_CommonMeasurementObjectType_CM_Rsp_id._const_tab_id = u'id'
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality._const_tab = __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementObjectType_CM_Rsp_criticality._const_tab_id = u'criticality'
    _Extension_CommonMeasurementObjectType_CM_Rsp_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_CommonMeasurementObjectType_CM_Rsp_value._const_tab = __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rsp_value._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementObjectType_CM_Rsp_value._const_tab_id = u'Value'
    Extension_CommonMeasurementObjectType_CM_Rsp._cont = ASN1Dict([
        (u'id', _Extension_CommonMeasurementObjectType_CM_Rsp_id),
        (u'criticality', _Extension_CommonMeasurementObjectType_CM_Rsp_criticality),
        (u'value', _Extension_CommonMeasurementObjectType_CM_Rsp_value),
        ])
    Extension_CommonMeasurementObjectType_CM_Rsp._ext = None
    
    #-----< Extension-CommonMeasurementObjectType-CM-RspIE >-----#
    Extension_CommonMeasurementObjectType_CM_RspIE = CLASS(name=u'Extension-CommonMeasurementObjectType-CM-RspIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellList-CM-Rsp')))
    Extension_CommonMeasurementObjectType_CM_RspIE._val = ASN1Set(rv=[dict([(u'id', 2062), (u'criticality', u'ignore'), (u'Value', _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GsmCellList-CM-Rsp >-----#
    GsmCellList_CM_Rsp = SEQ_OF(name=u'GsmCellList-CM-Rsp', mode=MODE_TYPE)
    _GsmCellList_CM_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellItem-CM-Rsp')))
    GsmCellList_CM_Rsp._cont = _GsmCellList_CM_Rsp__item_
    GsmCellList_CM_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< GsmCellItem-CM-Rsp >-----#
    GsmCellItem_CM_Rsp = SEQ(name=u'GsmCellItem-CM-Rsp', mode=MODE_TYPE)
    _GsmCellItem_CM_Rsp_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _GsmCellItem_CM_Rsp_commonMeasurementValue = CHOICE(name=u'commonMeasurementValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementValue')), opt=True)
    _GsmCellItem_CM_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GsmCellItem_CM_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GsmCellItem_CM_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__id._const_tab = ____GsmCellItem_CM_Rsp_iE_Extensions__item__id_tab
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GsmCellItem_CM_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__criticality._const_tab = ____GsmCellItem_CM_Rsp_iE_Extensions__item__criticality_tab
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue._const_tab = ____GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue_tab
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GsmCellItem_CM_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GsmCellItem_CM_Rsp_iE_Extensions__item__id),
        (u'criticality', ___GsmCellItem_CM_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue),
        ])
    __GsmCellItem_CM_Rsp_iE_Extensions__item_._ext = None
    _GsmCellItem_CM_Rsp_iE_Extensions._cont = __GsmCellItem_CM_Rsp_iE_Extensions__item_
    _GsmCellItem_CM_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GsmCellItem_CM_Rsp._cont = ASN1Dict([
        (u'measurementID', _GsmCellItem_CM_Rsp_measurementID),
        (u'commonMeasurementValue', _GsmCellItem_CM_Rsp_commonMeasurementValue),
        (u'iE-Extensions', _GsmCellItem_CM_Rsp_iE_Extensions),
        ])
    GsmCellItem_CM_Rsp._ext = []
    
    #-----< GsmCellItem-CM-Rsp-ExtIEs >-----#
    GsmCellItem_CM_Rsp_ExtIEs = CLASS(name=u'GsmCellItem-CM-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GsmCellItem_CM_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationFailure >-----#
    CommonMeasurementInitiationFailure = SEQ(name=u'CommonMeasurementInitiationFailure', mode=MODE_TYPE)
    _CommonMeasurementInitiationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementInitiationFailure_protocolIEs__item__id),
        (u'criticality', ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality),
        (u'value', ___CommonMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __CommonMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _CommonMeasurementInitiationFailure_protocolIEs._cont = __CommonMeasurementInitiationFailure_protocolIEs__item_
    _CommonMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementInitiationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-FailureMeasurementList')))
    ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2058), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id._const_tab = ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementInitiationFailure_protocolExtensions__item__id),
        (u'criticality', ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementInitiationFailure_protocolExtensions__item_._ext = None
    _CommonMeasurementInitiationFailure_protocolExtensions._cont = __CommonMeasurementInitiationFailure_protocolExtensions__item_
    _CommonMeasurementInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementInitiationFailure._cont = ASN1Dict([
        (u'protocolIEs', _CommonMeasurementInitiationFailure_protocolIEs),
        (u'protocolExtensions', _CommonMeasurementInitiationFailure_protocolExtensions),
        ])
    CommonMeasurementInitiationFailure._ext = []
    
    #-----< CommonMeasurementInitiationFailure-IEs >-----#
    CommonMeasurementInitiationFailure_IEs = CLASS(name=u'CommonMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonMeasurementInitiationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _CommonMeasurementInitiationFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _CommonMeasurementInitiationFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    CommonMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementInitiationFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementInitiationFailure-Extensions >-----#
    CommonMeasurementInitiationFailure_Extensions = CLASS(name=u'CommonMeasurementInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementInitiationFailure_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-FailureMeasurementList')))
    CommonMeasurementInitiationFailure_Extensions._val = ASN1Set(rv=[dict([(u'id', 2058), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementInitiationFailure_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Extension-FailureMeasurementList >-----#
    Extension_FailureMeasurementList = SEQ_OF(name=u'Extension-FailureMeasurementList', mode=MODE_TYPE)
    _Extension_FailureMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-FailureMeasurementItem')))
    Extension_FailureMeasurementList._cont = _Extension_FailureMeasurementList__item_
    Extension_FailureMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< Extension-FailureMeasurementItem >-----#
    Extension_FailureMeasurementItem = SEQ(name=u'Extension-FailureMeasurementItem', mode=MODE_TYPE)
    _Extension_FailureMeasurementItem_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _Extension_FailureMeasurementItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _Extension_FailureMeasurementItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extension_FailureMeasurementItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Extension_FailureMeasurementItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extension_FailureMeasurementItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_FailureMeasurementItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_FailureMeasurementItem_iE_Extensions__item__id._const_tab = ____Extension_FailureMeasurementItem_iE_Extensions__item__id_tab
    ___Extension_FailureMeasurementItem_iE_Extensions__item__id._const_tab_at = None
    ___Extension_FailureMeasurementItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extension_FailureMeasurementItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extension_FailureMeasurementItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_FailureMeasurementItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_FailureMeasurementItem_iE_Extensions__item__criticality._const_tab = ____Extension_FailureMeasurementItem_iE_Extensions__item__criticality_tab
    ___Extension_FailureMeasurementItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extension_FailureMeasurementItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue._const_tab = ____Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue_tab
    ___Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extension_FailureMeasurementItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extension_FailureMeasurementItem_iE_Extensions__item__id),
        (u'criticality', ___Extension_FailureMeasurementItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue),
        ])
    __Extension_FailureMeasurementItem_iE_Extensions__item_._ext = None
    _Extension_FailureMeasurementItem_iE_Extensions._cont = __Extension_FailureMeasurementItem_iE_Extensions__item_
    _Extension_FailureMeasurementItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extension_FailureMeasurementItem._cont = ASN1Dict([
        (u'measurementID', _Extension_FailureMeasurementItem_measurementID),
        (u'cause', _Extension_FailureMeasurementItem_cause),
        (u'iE-Extensions', _Extension_FailureMeasurementItem_iE_Extensions),
        ])
    Extension_FailureMeasurementItem._ext = []
    
    #-----< Extension-FailureMeasurementItem-ExtIEs >-----#
    Extension_FailureMeasurementItem_ExtIEs = CLASS(name=u'Extension-FailureMeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Extension_FailureMeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementReport >-----#
    CommonMeasurementReport = SEQ(name=u'CommonMeasurementReport', mode=MODE_TYPE)
    _CommonMeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rprt')))
    _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    ____CommonMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementReport_protocolIEs__item__id._const_tab = ____CommonMeasurementReport_protocolIEs__item__id_tab
    ___CommonMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonMeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonMeasurementReport_protocolIEs__item__criticality._const_tab = ____CommonMeasurementReport_protocolIEs__item__id_tab
    ___CommonMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonMeasurementReport_protocolIEs__item__value._const_tab = ____CommonMeasurementReport_protocolIEs__item__id_tab
    ___CommonMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonMeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementReport_protocolIEs__item__id),
        (u'criticality', ___CommonMeasurementReport_protocolIEs__item__criticality),
        (u'value', ___CommonMeasurementReport_protocolIEs__item__value),
        ])
    __CommonMeasurementReport_protocolIEs__item_._ext = None
    _CommonMeasurementReport_protocolIEs._cont = __CommonMeasurementReport_protocolIEs__item_
    _CommonMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rprt')))
    ____CommonMeasurementReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 555), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 2054), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementReport_protocolExtensions__item__id._const_tab = ____CommonMeasurementReport_protocolExtensions__item__id_tab
    ___CommonMeasurementReport_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonMeasurementReport_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementReport_protocolExtensions__item__id_tab
    ___CommonMeasurementReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementReport_protocolExtensions__item__id_tab
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementReport_protocolExtensions__item__id),
        (u'criticality', ___CommonMeasurementReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementReport_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementReport_protocolExtensions__item_._ext = None
    _CommonMeasurementReport_protocolExtensions._cont = __CommonMeasurementReport_protocolExtensions__item_
    _CommonMeasurementReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _CommonMeasurementReport_protocolIEs),
        (u'protocolExtensions', _CommonMeasurementReport_protocolExtensions),
        ])
    CommonMeasurementReport._ext = []
    
    #-----< CommonMeasurementReport-IEs >-----#
    CommonMeasurementReport_IEs = CLASS(name=u'CommonMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonMeasurementReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _CommonMeasurementReport_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementObjectType-CM-Rprt')))
    _CommonMeasurementReport_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SFN')))
    CommonMeasurementReport_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 281), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementReport_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 285), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementReport_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementReport-Extensions >-----#
    CommonMeasurementReport_Extensions = CLASS(name=u'CommonMeasurementReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementReport_Extensions_val_Extension_0 = NULL(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementRecoveryReportingIndicator')))
    _CommonMeasurementReport_Extensions_val_Extension_1 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-CommonMeasurementObjectType-CM-Rprt')))
    CommonMeasurementReport_Extensions._val = ASN1Set(rv=[dict([(u'id', 555), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementReport_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 2054), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementReport_Extensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementObjectType-CM-Rprt >-----#
    CommonMeasurementObjectType_CM_Rprt = CHOICE(name=u'CommonMeasurementObjectType-CM-Rprt', mode=MODE_TYPE)
    _CommonMeasurementObjectType_CM_Rprt_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-CM-Rprt')))
    CommonMeasurementObjectType_CM_Rprt._cont = ASN1Dict([
        (u'cell', _CommonMeasurementObjectType_CM_Rprt_cell),
        ])
    CommonMeasurementObjectType_CM_Rprt._ext = []
    
    #-----< Cell-CM-Rprt >-----#
    Cell_CM_Rprt = SEQ(name=u'Cell-CM-Rprt', mode=MODE_TYPE)
    _Cell_CM_Rprt_commonMeasurementValueInformation = CHOICE(name=u'commonMeasurementValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementValueInformation')))
    _Cell_CM_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_CM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_CM_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_CM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_CM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CM_Rprt_iE_Extensions__item__id._const_tab = ____Cell_CM_Rprt_iE_Extensions__item__id_tab
    ___Cell_CM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___Cell_CM_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_CM_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_CM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_CM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CM_Rprt_iE_Extensions__item__criticality._const_tab = ____Cell_CM_Rprt_iE_Extensions__item__criticality_tab
    ___Cell_CM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_CM_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_CM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_CM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____Cell_CM_Rprt_iE_Extensions__item__extensionValue_tab
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_CM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_CM_Rprt_iE_Extensions__item__id),
        (u'criticality', ___Cell_CM_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_CM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __Cell_CM_Rprt_iE_Extensions__item_._ext = None
    _Cell_CM_Rprt_iE_Extensions._cont = __Cell_CM_Rprt_iE_Extensions__item_
    _Cell_CM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_CM_Rprt._cont = ASN1Dict([
        (u'commonMeasurementValueInformation', _Cell_CM_Rprt_commonMeasurementValueInformation),
        (u'iE-Extensions', _Cell_CM_Rprt_iE_Extensions),
        ])
    Cell_CM_Rprt._ext = []
    
    #-----< CellItem-CM-Rprt-ExtIEs >-----#
    CellItem_CM_Rprt_ExtIEs = CLASS(name=u'CellItem-CM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellItem_CM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-CommonMeasurementObjectType-CM-Rprt >-----#
    Extension_CommonMeasurementObjectType_CM_Rprt = SEQ(name=u'Extension-CommonMeasurementObjectType-CM-Rprt', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_CommonMeasurementObjectType_CM_Rprt_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellList-CM-Rprt')))
    __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab._val = ASN1Set(rv=[dict([(u'id', 2060), (u'criticality', u'ignore'), (u'Value', ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_CommonMeasurementObjectType_CM_Rprt_id._const_tab = __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rprt_id._const_tab_at = None
    _Extension_CommonMeasurementObjectType_CM_Rprt_id._const_tab_id = u'id'
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality._const_tab = __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementObjectType_CM_Rprt_criticality._const_tab_id = u'criticality'
    _Extension_CommonMeasurementObjectType_CM_Rprt_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_CommonMeasurementObjectType_CM_Rprt_value._const_tab = __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab
    _Extension_CommonMeasurementObjectType_CM_Rprt_value._const_tab_at = ('..', u'id')
    _Extension_CommonMeasurementObjectType_CM_Rprt_value._const_tab_id = u'Value'
    Extension_CommonMeasurementObjectType_CM_Rprt._cont = ASN1Dict([
        (u'id', _Extension_CommonMeasurementObjectType_CM_Rprt_id),
        (u'criticality', _Extension_CommonMeasurementObjectType_CM_Rprt_criticality),
        (u'value', _Extension_CommonMeasurementObjectType_CM_Rprt_value),
        ])
    Extension_CommonMeasurementObjectType_CM_Rprt._ext = None
    
    #-----< Extension-CommonMeasurementObjectType-CM-RprtIE >-----#
    Extension_CommonMeasurementObjectType_CM_RprtIE = CLASS(name=u'Extension-CommonMeasurementObjectType-CM-RprtIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellList-CM-Rprt')))
    Extension_CommonMeasurementObjectType_CM_RprtIE._val = ASN1Set(rv=[dict([(u'id', 2060), (u'criticality', u'ignore'), (u'Value', _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GsmCellList-CM-Rprt >-----#
    GsmCellList_CM_Rprt = SEQ_OF(name=u'GsmCellList-CM-Rprt', mode=MODE_TYPE)
    _GsmCellList_CM_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GsmCellItem-CM-Rprt')))
    GsmCellList_CM_Rprt._cont = _GsmCellList_CM_Rprt__item_
    GsmCellList_CM_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< GsmCellItem-CM-Rprt >-----#
    GsmCellItem_CM_Rprt = SEQ(name=u'GsmCellItem-CM-Rprt', mode=MODE_TYPE)
    _GsmCellItem_CM_Rprt_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _GsmCellItem_CM_Rprt_commonMeasurementValueInformation = CHOICE(name=u'commonMeasurementValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CommonMeasurementValueInformation')))
    _GsmCellItem_CM_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GsmCellItem_CM_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GsmCellItem_CM_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__id._const_tab = ____GsmCellItem_CM_Rprt_iE_Extensions__item__id_tab
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GsmCellItem_CM_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__criticality._const_tab = ____GsmCellItem_CM_Rprt_iE_Extensions__item__criticality_tab
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue._const_tab = ____GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue_tab
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GsmCellItem_CM_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GsmCellItem_CM_Rprt_iE_Extensions__item__id),
        (u'criticality', ___GsmCellItem_CM_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue),
        ])
    __GsmCellItem_CM_Rprt_iE_Extensions__item_._ext = None
    _GsmCellItem_CM_Rprt_iE_Extensions._cont = __GsmCellItem_CM_Rprt_iE_Extensions__item_
    _GsmCellItem_CM_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GsmCellItem_CM_Rprt._cont = ASN1Dict([
        (u'measurementID', _GsmCellItem_CM_Rprt_measurementID),
        (u'commonMeasurementValueInformation', _GsmCellItem_CM_Rprt_commonMeasurementValueInformation),
        (u'iE-Extensions', _GsmCellItem_CM_Rprt_iE_Extensions),
        ])
    GsmCellItem_CM_Rprt._ext = []
    
    #-----< GsmCellItem-CM-Rprt-ExtIEs >-----#
    GsmCellItem_CM_Rprt_ExtIEs = CLASS(name=u'GsmCellItem-CM-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GsmCellItem_CM_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementTerminationRequest >-----#
    CommonMeasurementTerminationRequest = SEQ(name=u'CommonMeasurementTerminationRequest', mode=MODE_TYPE)
    _CommonMeasurementTerminationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id._const_tab = ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementTerminationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab = ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value._const_tab = ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonMeasurementTerminationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonMeasurementTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementTerminationRequest_protocolIEs__item__id),
        (u'criticality', ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality),
        (u'value', ___CommonMeasurementTerminationRequest_protocolIEs__item__value),
        ])
    __CommonMeasurementTerminationRequest_protocolIEs__item_._ext = None
    _CommonMeasurementTerminationRequest_protocolIEs._cont = __CommonMeasurementTerminationRequest_protocolIEs__item_
    _CommonMeasurementTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementTerminationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-TerminationMeasurementList')))
    ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2059), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id._const_tab = ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementTerminationRequest_protocolExtensions__item__id),
        (u'criticality', ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementTerminationRequest_protocolExtensions__item_._ext = None
    _CommonMeasurementTerminationRequest_protocolExtensions._cont = __CommonMeasurementTerminationRequest_protocolExtensions__item_
    _CommonMeasurementTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementTerminationRequest._cont = ASN1Dict([
        (u'protocolIEs', _CommonMeasurementTerminationRequest_protocolIEs),
        (u'protocolExtensions', _CommonMeasurementTerminationRequest_protocolExtensions),
        ])
    CommonMeasurementTerminationRequest._ext = []
    
    #-----< CommonMeasurementTerminationRequest-IEs >-----#
    CommonMeasurementTerminationRequest_IEs = CLASS(name=u'CommonMeasurementTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonMeasurementTerminationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    CommonMeasurementTerminationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementTerminationRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementTerminationRequest-Extensions >-----#
    CommonMeasurementTerminationRequest_Extensions = CLASS(name=u'CommonMeasurementTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementTerminationRequest_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-TerminationMeasurementList')))
    CommonMeasurementTerminationRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 2059), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementTerminationRequest_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Extension-TerminationMeasurementList >-----#
    Extension_TerminationMeasurementList = SEQ_OF(name=u'Extension-TerminationMeasurementList', mode=MODE_TYPE)
    _Extension_TerminationMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-TerminationMeasurementItem')))
    Extension_TerminationMeasurementList._cont = _Extension_TerminationMeasurementList__item_
    Extension_TerminationMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< Extension-TerminationMeasurementItem >-----#
    Extension_TerminationMeasurementItem = SEQ(name=u'Extension-TerminationMeasurementItem', mode=MODE_TYPE)
    _Extension_TerminationMeasurementItem_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _Extension_TerminationMeasurementItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extension_TerminationMeasurementItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extension_TerminationMeasurementItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_TerminationMeasurementItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__id._const_tab = ____Extension_TerminationMeasurementItem_iE_Extensions__item__id_tab
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__id._const_tab_at = None
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extension_TerminationMeasurementItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_TerminationMeasurementItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__criticality._const_tab = ____Extension_TerminationMeasurementItem_iE_Extensions__item__criticality_tab
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue._const_tab = ____Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue_tab
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extension_TerminationMeasurementItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extension_TerminationMeasurementItem_iE_Extensions__item__id),
        (u'criticality', ___Extension_TerminationMeasurementItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue),
        ])
    __Extension_TerminationMeasurementItem_iE_Extensions__item_._ext = None
    _Extension_TerminationMeasurementItem_iE_Extensions._cont = __Extension_TerminationMeasurementItem_iE_Extensions__item_
    _Extension_TerminationMeasurementItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extension_TerminationMeasurementItem._cont = ASN1Dict([
        (u'measurementID', _Extension_TerminationMeasurementItem_measurementID),
        (u'iE-Extensions', _Extension_TerminationMeasurementItem_iE_Extensions),
        ])
    Extension_TerminationMeasurementItem._ext = []
    
    #-----< Extension-TerminationMeasurementItem-ExtIEs >-----#
    Extension_TerminationMeasurementItem_ExtIEs = CLASS(name=u'Extension-TerminationMeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Extension_TerminationMeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementFailureIndication >-----#
    CommonMeasurementFailureIndication = SEQ(name=u'CommonMeasurementFailureIndication', mode=MODE_TYPE)
    _CommonMeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __CommonMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___CommonMeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___CommonMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab
    ___CommonMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___CommonMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___CommonMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab
    ___CommonMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___CommonMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __CommonMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___CommonMeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___CommonMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __CommonMeasurementFailureIndication_protocolIEs__item_._ext = None
    _CommonMeasurementFailureIndication_protocolIEs._cont = __CommonMeasurementFailureIndication_protocolIEs__item_
    _CommonMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonMeasurementFailureIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonMeasurementFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-FailureIndicationMeasurementList')))
    ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 2057), (u'criticality', u'ignore'), (u'Extension', _____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id._const_tab = ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___CommonMeasurementFailureIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab = ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __CommonMeasurementFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___CommonMeasurementFailureIndication_protocolExtensions__item__id),
        (u'criticality', ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __CommonMeasurementFailureIndication_protocolExtensions__item_._ext = None
    _CommonMeasurementFailureIndication_protocolExtensions._cont = __CommonMeasurementFailureIndication_protocolExtensions__item_
    _CommonMeasurementFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonMeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _CommonMeasurementFailureIndication_protocolIEs),
        (u'protocolExtensions', _CommonMeasurementFailureIndication_protocolExtensions),
        ])
    CommonMeasurementFailureIndication._ext = []
    
    #-----< CommonMeasurementFailureIndication-IEs >-----#
    CommonMeasurementFailureIndication_IEs = CLASS(name=u'CommonMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _CommonMeasurementFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _CommonMeasurementFailureIndication_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    CommonMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _CommonMeasurementFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonMeasurementFailureIndication-Extensions >-----#
    CommonMeasurementFailureIndication_Extensions = CLASS(name=u'CommonMeasurementFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _CommonMeasurementFailureIndication_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-FailureIndicationMeasurementList')))
    CommonMeasurementFailureIndication_Extensions._val = ASN1Set(rv=[dict([(u'id', 2057), (u'criticality', u'ignore'), (u'Extension', _CommonMeasurementFailureIndication_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< Extension-FailureIndicationMeasurementList >-----#
    Extension_FailureIndicationMeasurementList = SEQ_OF(name=u'Extension-FailureIndicationMeasurementList', mode=MODE_TYPE)
    _Extension_FailureIndicationMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-FailureIndicationMeasurementItem')))
    Extension_FailureIndicationMeasurementList._cont = _Extension_FailureIndicationMeasurementList__item_
    Extension_FailureIndicationMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< Extension-FailureIndicationMeasurementItem >-----#
    Extension_FailureIndicationMeasurementItem = SEQ(name=u'Extension-FailureIndicationMeasurementItem', mode=MODE_TYPE)
    _Extension_FailureIndicationMeasurementItem_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _Extension_FailureIndicationMeasurementItem_cause = CHOICE(name=u'cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _Extension_FailureIndicationMeasurementItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Extension_FailureIndicationMeasurementItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id._const_tab = ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id_tab
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id._const_tab_at = None
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality._const_tab = ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality_tab
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue._const_tab = ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue_tab
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Extension_FailureIndicationMeasurementItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id),
        (u'criticality', ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue),
        ])
    __Extension_FailureIndicationMeasurementItem_iE_Extensions__item_._ext = None
    _Extension_FailureIndicationMeasurementItem_iE_Extensions._cont = __Extension_FailureIndicationMeasurementItem_iE_Extensions__item_
    _Extension_FailureIndicationMeasurementItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Extension_FailureIndicationMeasurementItem._cont = ASN1Dict([
        (u'measurementID', _Extension_FailureIndicationMeasurementItem_measurementID),
        (u'cause', _Extension_FailureIndicationMeasurementItem_cause),
        (u'iE-Extensions', _Extension_FailureIndicationMeasurementItem_iE_Extensions),
        ])
    Extension_FailureIndicationMeasurementItem._ext = []
    
    #-----< Extension-FailureIndicationMeasurementItem-ExtIEs >-----#
    Extension_FailureIndicationMeasurementItem_ExtIEs = CLASS(name=u'Extension-FailureIndicationMeasurementItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Extension_FailureIndicationMeasurementItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationRequest >-----#
    InformationExchangeInitiationRequest = SEQ(name=u'InformationExchangeInitiationRequest', mode=MODE_TYPE)
    _InformationExchangeInitiationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rqst')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationType')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationReportCharacteristics')))
    ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 289), (u'criticality', u'reject'), (u'Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 292), (u'criticality', u'reject'), (u'Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 291), (u'criticality', u'reject'), (u'Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeInitiationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationExchangeInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeInitiationRequest_protocolIEs__item__id),
        (u'criticality', ___InformationExchangeInitiationRequest_protocolIEs__item__criticality),
        (u'value', ___InformationExchangeInitiationRequest_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationRequest_protocolIEs__item_._ext = None
    _InformationExchangeInitiationRequest_protocolIEs._cont = __InformationExchangeInitiationRequest_protocolIEs__item_
    _InformationExchangeInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationExchangeInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeInitiationRequest_protocolExtensions__item__id),
        (u'criticality', ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationRequest_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationRequest_protocolExtensions._cont = __InformationExchangeInitiationRequest_protocolExtensions__item_
    _InformationExchangeInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationRequest._cont = ASN1Dict([
        (u'protocolIEs', _InformationExchangeInitiationRequest_protocolIEs),
        (u'protocolExtensions', _InformationExchangeInitiationRequest_protocolExtensions),
        ])
    InformationExchangeInitiationRequest._ext = []
    
    #-----< InformationExchangeInitiationRequest-IEs >-----#
    InformationExchangeInitiationRequest_IEs = CLASS(name=u'InformationExchangeInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationExchangeInitiationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationRequest_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rqst')))
    _InformationExchangeInitiationRequest_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationType')))
    _InformationExchangeInitiationRequest_IEs_val_Value_3 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationReportCharacteristics')))
    InformationExchangeInitiationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'reject'), (u'Value', _InformationExchangeInitiationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 289), (u'criticality', u'reject'), (u'Value', _InformationExchangeInitiationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 292), (u'criticality', u'reject'), (u'Value', _InformationExchangeInitiationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 291), (u'criticality', u'reject'), (u'Value', _InformationExchangeInitiationRequest_IEs_val_Value_3), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationRequest-Extensions >-----#
    InformationExchangeInitiationRequest_Extensions = CLASS(name=u'InformationExchangeInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rqst >-----#
    InformationExchangeObjectType_InfEx_Rqst = CHOICE(name=u'InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rqst_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-InfEx-Rqst')))
    _InformationExchangeObjectType_InfEx_Rqst_extension_InformationExchangeObjectType_InfEx_Rqst = SEQ(name=u'extension-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-InformationExchangeObjectType-InfEx-Rqst')))
    InformationExchangeObjectType_InfEx_Rqst._cont = ASN1Dict([
        (u'cell', _InformationExchangeObjectType_InfEx_Rqst_cell),
        (u'extension-InformationExchangeObjectType-InfEx-Rqst', _InformationExchangeObjectType_InfEx_Rqst_extension_InformationExchangeObjectType_InfEx_Rqst),
        ])
    InformationExchangeObjectType_InfEx_Rqst._ext = [u'extension-InformationExchangeObjectType-InfEx-Rqst']
    
    #-----< Cell-InfEx-Rqst >-----#
    Cell_InfEx_Rqst = SEQ(name=u'Cell-InfEx-Rqst', mode=MODE_TYPE)
    _Cell_InfEx_Rqst_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Cell_InfEx_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InfEx_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InfEx_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab = ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab
    ___Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab = ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab = ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_InfEx_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_InfEx_Rqst_iE_Extensions__item__id),
        (u'criticality', ___Cell_InfEx_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue),
        ])
    __Cell_InfEx_Rqst_iE_Extensions__item_._ext = None
    _Cell_InfEx_Rqst_iE_Extensions._cont = __Cell_InfEx_Rqst_iE_Extensions__item_
    _Cell_InfEx_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InfEx_Rqst._cont = ASN1Dict([
        (u'c-ID', _Cell_InfEx_Rqst_c_ID),
        (u'iE-Extensions', _Cell_InfEx_Rqst_iE_Extensions),
        ])
    Cell_InfEx_Rqst._ext = []
    
    #-----< CellItem-InfEx-Rqst-ExtIEs >-----#
    CellItem_InfEx_Rqst_ExtIEs = CLASS(name=u'CellItem-InfEx-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellItem_InfEx_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-InformationExchangeObjectType-InfEx-Rqst >-----#
    Extension_InformationExchangeObjectType_InfEx_Rqst = SEQ(name=u'Extension-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GSM-Cell-InfEx-Rqst')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-InfEx-Rqst')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ANR-Cell-InfEx-Rqst')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-InfEx-Rqst')))
    __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab._val = ASN1Set(rv=[dict([(u'id', 553), (u'criticality', u'reject'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 560), (u'criticality', u'reject'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 756), (u'criticality', u'reject'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 759), (u'criticality', u'reject'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 900), (u'criticality', u'reject'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 935), (u'criticality', u'reject'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id._const_tab_at = None
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id._const_tab_id = u'id'
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality._const_tab_at = ('..', u'id')
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality._const_tab_id = u'criticality'
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value._const_tab_at = ('..', u'id')
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value._const_tab_id = u'Value'
    Extension_InformationExchangeObjectType_InfEx_Rqst._cont = ASN1Dict([
        (u'id', _Extension_InformationExchangeObjectType_InfEx_Rqst_id),
        (u'criticality', _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality),
        (u'value', _Extension_InformationExchangeObjectType_InfEx_Rqst_value),
        ])
    Extension_InformationExchangeObjectType_InfEx_Rqst._ext = None
    
    #-----< Extension-InformationExchangeObjectType-InfEx-RqstIE >-----#
    Extension_InformationExchangeObjectType_InfEx_RqstIE = CLASS(name=u'Extension-InformationExchangeObjectType-InfEx-RqstIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GSM-Cell-InfEx-Rqst')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-InfEx-Rqst')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ANR-Cell-InfEx-Rqst')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_5 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-InfEx-Rqst')))
    Extension_InformationExchangeObjectType_InfEx_RqstIE._val = ASN1Set(rv=[dict([(u'id', 553), (u'criticality', u'reject'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 560), (u'criticality', u'reject'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 756), (u'criticality', u'reject'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 759), (u'criticality', u'reject'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 900), (u'criticality', u'reject'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 935), (u'criticality', u'reject'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GSM-Cell-InfEx-Rqst >-----#
    GSM_Cell_InfEx_Rqst = SEQ(name=u'GSM-Cell-InfEx-Rqst', mode=MODE_TYPE)
    _GSM_Cell_InfEx_Rqst_cGI = SEQ(name=u'cGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'CGI')))
    _GSM_Cell_InfEx_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GSM_Cell_InfEx_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab = ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__id_tab
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab = ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab = ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __GSM_Cell_InfEx_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__id),
        (u'criticality', ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue),
        ])
    __GSM_Cell_InfEx_Rqst_iE_Extensions__item_._ext = None
    _GSM_Cell_InfEx_Rqst_iE_Extensions._cont = __GSM_Cell_InfEx_Rqst_iE_Extensions__item_
    _GSM_Cell_InfEx_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GSM_Cell_InfEx_Rqst._cont = ASN1Dict([
        (u'cGI', _GSM_Cell_InfEx_Rqst_cGI),
        (u'iE-Extensions', _GSM_Cell_InfEx_Rqst_iE_Extensions),
        ])
    GSM_Cell_InfEx_Rqst._ext = []
    
    #-----< GSMCellItem-InfEx-Rqst-ExtIEs >-----#
    GSMCellItem_InfEx_Rqst_ExtIEs = CLASS(name=u'GSMCellItem-InfEx-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    GSMCellItem_InfEx_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst = SEQ_OF(name=u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rqst', mode=MODE_TYPE)
    _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst')))
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst._cont = _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst__item_
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst = SEQ(name=u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst', mode=MODE_TYPE)
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_mBMS_Bearer_Service_List_InfEx_Rqst = SEQ_OF(name=u'mBMS-Bearer-Service-List-InfEx-Rqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-List-InfEx-Rqst')))
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item_._ext = None
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions._cont = __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item_
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst._cont = ASN1Dict([
        (u'c-ID', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_c_ID),
        (u'mBMS-Bearer-Service-List-InfEx-Rqst', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_mBMS_Bearer_Service_List_InfEx_Rqst),
        (u'iE-Extensions', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions),
        ])
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst._ext = []
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst-ExtIEs >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_ExtIEs = CLASS(name=u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-List-InfEx-Rqst >-----#
    MBMS_Bearer_Service_List_InfEx_Rqst = SEQ_OF(name=u'MBMS-Bearer-Service-List-InfEx-Rqst', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List_InfEx_Rqst__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    MBMS_Bearer_Service_List_InfEx_Rqst._cont = _MBMS_Bearer_Service_List_InfEx_Rqst__item_
    MBMS_Bearer_Service_List_InfEx_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MBMS-Cell-InfEx-Rqst >-----#
    MBMS_Cell_InfEx_Rqst = SEQ_OF(name=u'MBMS-Cell-InfEx-Rqst', mode=MODE_TYPE)
    _MBMS_Cell_InfEx_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    MBMS_Cell_InfEx_Rqst._cont = _MBMS_Cell_InfEx_Rqst__item_
    MBMS_Cell_InfEx_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< ANR-Cell-InfEx-Rqst >-----#
    ANR_Cell_InfEx_Rqst = SEQ_OF(name=u'ANR-Cell-InfEx-Rqst', mode=MODE_TYPE)
    _ANR_Cell_InfEx_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    ANR_Cell_InfEx_Rqst._cont = _ANR_Cell_InfEx_Rqst__item_
    ANR_Cell_InfEx_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-E-RGCH-Cell-InfEx-Rqst >-----#
    Common_E_RGCH_Cell_InfEx_Rqst = SEQ_OF(name=u'Common-E-RGCH-Cell-InfEx-Rqst', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_InfEx_Rqst__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    Common_E_RGCH_Cell_InfEx_Rqst._cont = _Common_E_RGCH_Cell_InfEx_Rqst__item_
    Common_E_RGCH_Cell_InfEx_Rqst._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< InformationExchangeInitiationResponse >-----#
    InformationExchangeInitiationResponse = SEQ(name=u'InformationExchangeInitiationResponse', mode=MODE_TYPE)
    _InformationExchangeInitiationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rsp')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeInitiationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationExchangeInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeInitiationResponse_protocolIEs__item__id),
        (u'criticality', ___InformationExchangeInitiationResponse_protocolIEs__item__criticality),
        (u'value', ___InformationExchangeInitiationResponse_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationResponse_protocolIEs__item_._ext = None
    _InformationExchangeInitiationResponse_protocolIEs._cont = __InformationExchangeInitiationResponse_protocolIEs__item_
    _InformationExchangeInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationExchangeInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeInitiationResponse_protocolExtensions__item__id),
        (u'criticality', ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationResponse_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationResponse_protocolExtensions._cont = __InformationExchangeInitiationResponse_protocolExtensions__item_
    _InformationExchangeInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationResponse._cont = ASN1Dict([
        (u'protocolIEs', _InformationExchangeInitiationResponse_protocolIEs),
        (u'protocolExtensions', _InformationExchangeInitiationResponse_protocolExtensions),
        ])
    InformationExchangeInitiationResponse._ext = []
    
    #-----< InformationExchangeInitiationResponse-IEs >-----#
    InformationExchangeInitiationResponse_IEs = CLASS(name=u'InformationExchangeInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationExchangeInitiationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationResponse_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rsp')))
    _InformationExchangeInitiationResponse_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    InformationExchangeInitiationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _InformationExchangeInitiationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 290), (u'criticality', u'ignore'), (u'Value', _InformationExchangeInitiationResponse_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _InformationExchangeInitiationResponse_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationResponse-Extensions >-----#
    InformationExchangeInitiationResponse_Extensions = CLASS(name=u'InformationExchangeInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rsp >-----#
    InformationExchangeObjectType_InfEx_Rsp = CHOICE(name=u'InformationExchangeObjectType-InfEx-Rsp', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rsp_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-InfEx-Rsp')))
    _InformationExchangeObjectType_InfEx_Rsp_extension_InformationExchangeObjectType_InfEx_Rsp = SEQ(name=u'extension-InformationExchangeObjectType-InfEx-Rsp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-InformationExchangeObjectType-InfEx-Rsp')))
    InformationExchangeObjectType_InfEx_Rsp._cont = ASN1Dict([
        (u'cell', _InformationExchangeObjectType_InfEx_Rsp_cell),
        (u'extension-InformationExchangeObjectType-InfEx-Rsp', _InformationExchangeObjectType_InfEx_Rsp_extension_InformationExchangeObjectType_InfEx_Rsp),
        ])
    InformationExchangeObjectType_InfEx_Rsp._ext = [u'extension-InformationExchangeObjectType-InfEx-Rsp']
    
    #-----< Cell-InfEx-Rsp >-----#
    Cell_InfEx_Rsp = SEQ(name=u'Cell-InfEx-Rsp', mode=MODE_TYPE)
    _Cell_InfEx_Rsp_requestedDataValue = SEQ(name=u'requestedDataValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValue')))
    _Cell_InfEx_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InfEx_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab
    ___Cell_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_InfEx_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Cell_InfEx_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Cell_InfEx_Rsp_iE_Extensions__item_._ext = None
    _Cell_InfEx_Rsp_iE_Extensions._cont = __Cell_InfEx_Rsp_iE_Extensions__item_
    _Cell_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InfEx_Rsp._cont = ASN1Dict([
        (u'requestedDataValue', _Cell_InfEx_Rsp_requestedDataValue),
        (u'iE-Extensions', _Cell_InfEx_Rsp_iE_Extensions),
        ])
    Cell_InfEx_Rsp._ext = []
    
    #-----< CellItem-InfEx-Rsp-ExtIEs >-----#
    CellItem_InfEx_Rsp_ExtIEs = CLASS(name=u'CellItem-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellItem_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-InformationExchangeObjectType-InfEx-Rsp >-----#
    Extension_InformationExchangeObjectType_InfEx_Rsp = SEQ(name=u'Extension-InformationExchangeObjectType-InfEx-Rsp', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_InformationExchangeObjectType_InfEx_Rsp_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-List-InfEx-Rsp')))
    ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp')))
    ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-InfEx-Rsp')))
    ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ANR-Cell-InfEx-Rsp')))
    ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-InfEx-Rsp')))
    __Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab._val = ASN1Set(rv=[dict([(u'id', 561), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 757), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 760), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 901), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 936), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_InformationExchangeObjectType_InfEx_Rsp_id._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rsp_id._const_tab_at = None
    _Extension_InformationExchangeObjectType_InfEx_Rsp_id._const_tab_id = u'id'
    _Extension_InformationExchangeObjectType_InfEx_Rsp_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_InformationExchangeObjectType_InfEx_Rsp_criticality._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rsp_criticality._const_tab_at = ('..', u'id')
    _Extension_InformationExchangeObjectType_InfEx_Rsp_criticality._const_tab_id = u'criticality'
    _Extension_InformationExchangeObjectType_InfEx_Rsp_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_InformationExchangeObjectType_InfEx_Rsp_value._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rsp_value._const_tab_at = ('..', u'id')
    _Extension_InformationExchangeObjectType_InfEx_Rsp_value._const_tab_id = u'Value'
    Extension_InformationExchangeObjectType_InfEx_Rsp._cont = ASN1Dict([
        (u'id', _Extension_InformationExchangeObjectType_InfEx_Rsp_id),
        (u'criticality', _Extension_InformationExchangeObjectType_InfEx_Rsp_criticality),
        (u'value', _Extension_InformationExchangeObjectType_InfEx_Rsp_value),
        ])
    Extension_InformationExchangeObjectType_InfEx_Rsp._ext = None
    
    #-----< Extension-InformationExchangeObjectType-InfEx-RspIE >-----#
    Extension_InformationExchangeObjectType_InfEx_RspIE = CLASS(name=u'Extension-InformationExchangeObjectType-InfEx-RspIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-List-InfEx-Rsp')))
    _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp')))
    _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-InfEx-Rsp')))
    _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ANR-Cell-InfEx-Rsp')))
    _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-InfEx-Rsp')))
    Extension_InformationExchangeObjectType_InfEx_RspIE._val = ASN1Set(rv=[dict([(u'id', 561), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 757), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 760), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 901), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 936), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_4), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< MBMS-Bearer-Service-List-InfEx-Rsp >-----#
    MBMS_Bearer_Service_List_InfEx_Rsp = SEQ_OF(name=u'MBMS-Bearer-Service-List-InfEx-Rsp', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List_InfEx_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-ServiceItemIEs-InfEx-Rsp')))
    MBMS_Bearer_Service_List_InfEx_Rsp._cont = _MBMS_Bearer_Service_List_InfEx_Rsp__item_
    MBMS_Bearer_Service_List_InfEx_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MBMS-Bearer-ServiceItemIEs-InfEx-Rsp >-----#
    MBMS_Bearer_ServiceItemIEs_InfEx_Rsp = SEQ(name=u'MBMS-Bearer-ServiceItemIEs-InfEx-Rsp', mode=MODE_TYPE)
    _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_requestedDataValue = SEQ(name=u'requestedDataValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValue')))
    _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item_._ext = None
    _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions._cont = __MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item_
    _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_ServiceItemIEs_InfEx_Rsp._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_tmgi),
        (u'requestedDataValue', _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_requestedDataValue),
        (u'iE-Extensions', _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions),
        ])
    MBMS_Bearer_ServiceItemIEs_InfEx_Rsp._ext = []
    
    #-----< MBMS-Bearer-ServiceItem-InfEx-Rsp-ExtIEs >-----#
    MBMS_Bearer_ServiceItem_InfEx_Rsp_ExtIEs = CLASS(name=u'MBMS-Bearer-ServiceItem-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_ServiceItem_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp = SEQ_OF(name=u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rsp', mode=MODE_TYPE)
    _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp')))
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp._cont = _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp__item_
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp = SEQ(name=u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp', mode=MODE_TYPE)
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_mBMS_Bearer_Service_List_InfEx_Rsp = SEQ_OF(name=u'mBMS-Bearer-Service-List-InfEx-Rsp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-List-InfEx-Rsp')))
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_._ext = None
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions._cont = __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp._cont = ASN1Dict([
        (u'c-ID', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_c_ID),
        (u'mBMS-Bearer-Service-List-InfEx-Rsp', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_mBMS_Bearer_Service_List_InfEx_Rsp),
        (u'iE-Extensions', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions),
        ])
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp._ext = []
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp-ExtIEs >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_ExtIEs = CLASS(name=u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Cell-InfEx-Rsp >-----#
    MBMS_Cell_InfEx_Rsp = SEQ_OF(name=u'MBMS-Cell-InfEx-Rsp', mode=MODE_TYPE)
    _MBMS_Cell_InfEx_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-Item-InfEx-Rsp')))
    MBMS_Cell_InfEx_Rsp._cont = _MBMS_Cell_InfEx_Rsp__item_
    MBMS_Cell_InfEx_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< MBMS-Cell-Item-InfEx-Rsp >-----#
    MBMS_Cell_Item_InfEx_Rsp = SEQ(name=u'MBMS-Cell-Item-InfEx-Rsp', mode=MODE_TYPE)
    _MBMS_Cell_Item_InfEx_Rsp_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMS_Cell_Item_InfEx_Rsp_requestedDataValue = SEQ(name=u'requestedDataValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValue')))
    _MBMS_Cell_Item_InfEx_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_._ext = None
    _MBMS_Cell_Item_InfEx_Rsp_iE_Extensions._cont = __MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_
    _MBMS_Cell_Item_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Cell_Item_InfEx_Rsp._cont = ASN1Dict([
        (u'c-ID', _MBMS_Cell_Item_InfEx_Rsp_c_ID),
        (u'requestedDataValue', _MBMS_Cell_Item_InfEx_Rsp_requestedDataValue),
        (u'iE-Extensions', _MBMS_Cell_Item_InfEx_Rsp_iE_Extensions),
        ])
    MBMS_Cell_Item_InfEx_Rsp._ext = []
    
    #-----< MBMS-Cell-Item-InfEx-Rsp-ExtIEs >-----#
    MBMS_Cell_Item_InfEx_Rsp_ExtIEs = CLASS(name=u'MBMS-Cell-Item-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Cell_Item_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ANR-Cell-InfEx-Rsp >-----#
    ANR_Cell_InfEx_Rsp = SEQ_OF(name=u'ANR-Cell-InfEx-Rsp', mode=MODE_TYPE)
    _ANR_Cell_InfEx_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ANR-Cell-ItemIEs-InfEx-Rsp')))
    ANR_Cell_InfEx_Rsp._cont = _ANR_Cell_InfEx_Rsp__item_
    ANR_Cell_InfEx_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ANR-Cell-ItemIEs-InfEx-Rsp >-----#
    ANR_Cell_ItemIEs_InfEx_Rsp = SEQ(name=u'ANR-Cell-ItemIEs-InfEx-Rsp', mode=MODE_TYPE)
    _ANR_Cell_ItemIEs_InfEx_Rsp_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _ANR_Cell_ItemIEs_InfEx_Rsp_requestedDataValue = SEQ(name=u'requestedDataValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValue')))
    _ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id),
        (u'criticality', ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_._ext = None
    _ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions._cont = __ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_
    _ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ANR_Cell_ItemIEs_InfEx_Rsp._cont = ASN1Dict([
        (u'c-ID', _ANR_Cell_ItemIEs_InfEx_Rsp_c_ID),
        (u'requestedDataValue', _ANR_Cell_ItemIEs_InfEx_Rsp_requestedDataValue),
        (u'iE-Extensions', _ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions),
        ])
    ANR_Cell_ItemIEs_InfEx_Rsp._ext = []
    
    #-----< ANR-Cell-ItemIEs-InfEx-Rsp-ExtIEs >-----#
    ANR_Cell_ItemIEs_InfEx_Rsp_ExtIEs = CLASS(name=u'ANR-Cell-ItemIEs-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ANR_Cell_ItemIEs_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-RGCH-Cell-InfEx-Rsp >-----#
    Common_E_RGCH_Cell_InfEx_Rsp = SEQ_OF(name=u'Common-E-RGCH-Cell-InfEx-Rsp', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_InfEx_Rsp__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp')))
    Common_E_RGCH_Cell_InfEx_Rsp._cont = _Common_E_RGCH_Cell_InfEx_Rsp__item_
    Common_E_RGCH_Cell_InfEx_Rsp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp >-----#
    Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp = SEQ(name=u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_requestedDataValue = SEQ(name=u'requestedDataValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValue')))
    _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = u'id'
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id),
        (u'criticality', ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality),
        (u'extensionValue', ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_._ext = None
    _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions._cont = __Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_
    _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp._cont = ASN1Dict([
        (u'c-ID', _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_c_ID),
        (u'requestedDataValue', _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_requestedDataValue),
        (u'iE-Extensions', _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions),
        ])
    Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp._ext = []
    
    #-----< Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp-ExtIEs >-----#
    Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_ExtIEs = CLASS(name=u'Common-E-RGCH-Cell-ItemIEs-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationFailure >-----#
    InformationExchangeInitiationFailure = SEQ(name=u'InformationExchangeInitiationFailure', mode=MODE_TYPE)
    _InformationExchangeInitiationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeInitiationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationExchangeInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeInitiationFailure_protocolIEs__item__id),
        (u'criticality', ___InformationExchangeInitiationFailure_protocolIEs__item__criticality),
        (u'value', ___InformationExchangeInitiationFailure_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationFailure_protocolIEs__item_._ext = None
    _InformationExchangeInitiationFailure_protocolIEs._cont = __InformationExchangeInitiationFailure_protocolIEs__item_
    _InformationExchangeInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationExchangeInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeInitiationFailure_protocolExtensions__item__id),
        (u'criticality', ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationFailure_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationFailure_protocolExtensions._cont = __InformationExchangeInitiationFailure_protocolExtensions__item_
    _InformationExchangeInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationFailure._cont = ASN1Dict([
        (u'protocolIEs', _InformationExchangeInitiationFailure_protocolIEs),
        (u'protocolExtensions', _InformationExchangeInitiationFailure_protocolExtensions),
        ])
    InformationExchangeInitiationFailure._ext = []
    
    #-----< InformationExchangeInitiationFailure-IEs >-----#
    InformationExchangeInitiationFailure_IEs = CLASS(name=u'InformationExchangeInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationExchangeInitiationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _InformationExchangeInitiationFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    InformationExchangeInitiationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _InformationExchangeInitiationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _InformationExchangeInitiationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _InformationExchangeInitiationFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationFailure-Extensions >-----#
    InformationExchangeInitiationFailure_Extensions = CLASS(name=u'InformationExchangeInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationReport >-----#
    InformationReport = SEQ(name=u'InformationReport', mode=MODE_TYPE)
    _InformationReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationReport_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _____InformationReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rprt')))
    ____InformationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _____InformationReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _____InformationReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationReport_protocolIEs__item__id._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__id._const_tab_at = None
    ___InformationReport_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationReport_protocolIEs__item__criticality._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationReport_protocolIEs__item__value._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationReport_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationReport_protocolIEs__item__id),
        (u'criticality', ___InformationReport_protocolIEs__item__criticality),
        (u'value', ___InformationReport_protocolIEs__item__value),
        ])
    __InformationReport_protocolIEs__item_._ext = None
    _InformationReport_protocolIEs._cont = __InformationReport_protocolIEs__item_
    _InformationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__id._const_tab = ____InformationReport_protocolExtensions__item__id_tab
    ___InformationReport_protocolExtensions__item__id._const_tab_at = None
    ___InformationReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__criticality._const_tab = ____InformationReport_protocolExtensions__item__criticality_tab
    ___InformationReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab = ____InformationReport_protocolExtensions__item__extensionValue_tab
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationReport_protocolExtensions__item__id),
        (u'criticality', ___InformationReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationReport_protocolExtensions__item__extensionValue),
        ])
    __InformationReport_protocolExtensions__item_._ext = None
    _InformationReport_protocolExtensions._cont = __InformationReport_protocolExtensions__item_
    _InformationReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationReport._cont = ASN1Dict([
        (u'protocolIEs', _InformationReport_protocolIEs),
        (u'protocolExtensions', _InformationReport_protocolExtensions),
        ])
    InformationReport._ext = []
    
    #-----< InformationReport-IEs >-----#
    InformationReport_IEs = CLASS(name=u'InformationReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _InformationReport_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rprt')))
    InformationReport_IEs._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _InformationReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 288), (u'criticality', u'ignore'), (u'Value', _InformationReport_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationReport-Extensions >-----#
    InformationReport_Extensions = CLASS(name=u'InformationReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationReport_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rprt >-----#
    InformationExchangeObjectType_InfEx_Rprt = CHOICE(name=u'InformationExchangeObjectType-InfEx-Rprt', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rprt_cell = SEQ(name=u'cell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Cell-InfEx-Rprt')))
    _InformationExchangeObjectType_InfEx_Rprt_extension_InformationExchangeObjectType_InfEx_Rprt = SEQ(name=u'extension-InformationExchangeObjectType-InfEx-Rprt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-InformationExchangeObjectType-InfEx-Rprt')))
    InformationExchangeObjectType_InfEx_Rprt._cont = ASN1Dict([
        (u'cell', _InformationExchangeObjectType_InfEx_Rprt_cell),
        (u'extension-InformationExchangeObjectType-InfEx-Rprt', _InformationExchangeObjectType_InfEx_Rprt_extension_InformationExchangeObjectType_InfEx_Rprt),
        ])
    InformationExchangeObjectType_InfEx_Rprt._ext = [u'extension-InformationExchangeObjectType-InfEx-Rprt']
    
    #-----< Extension-InformationExchangeObjectType-InfEx-Rprt >-----#
    Extension_InformationExchangeObjectType_InfEx_Rprt = SEQ(name=u'Extension-InformationExchangeObjectType-InfEx-Rprt', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_InformationExchangeObjectType_InfEx_Rprt_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt')))
    ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-InfEx-Rprt')))
    ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-InfEx-Rprt')))
    __Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab._val = ASN1Set(rv=[dict([(u'id', 758), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 761), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 937), (u'criticality', u'ignore'), (u'Value', ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_InformationExchangeObjectType_InfEx_Rprt_id._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rprt_id._const_tab_at = None
    _Extension_InformationExchangeObjectType_InfEx_Rprt_id._const_tab_id = u'id'
    _Extension_InformationExchangeObjectType_InfEx_Rprt_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_InformationExchangeObjectType_InfEx_Rprt_criticality._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rprt_criticality._const_tab_at = ('..', u'id')
    _Extension_InformationExchangeObjectType_InfEx_Rprt_criticality._const_tab_id = u'criticality'
    _Extension_InformationExchangeObjectType_InfEx_Rprt_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_InformationExchangeObjectType_InfEx_Rprt_value._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rprt_value._const_tab_at = ('..', u'id')
    _Extension_InformationExchangeObjectType_InfEx_Rprt_value._const_tab_id = u'Value'
    Extension_InformationExchangeObjectType_InfEx_Rprt._cont = ASN1Dict([
        (u'id', _Extension_InformationExchangeObjectType_InfEx_Rprt_id),
        (u'criticality', _Extension_InformationExchangeObjectType_InfEx_Rprt_criticality),
        (u'value', _Extension_InformationExchangeObjectType_InfEx_Rprt_value),
        ])
    Extension_InformationExchangeObjectType_InfEx_Rprt._ext = None
    
    #-----< Extension-InformationExchangeObjectType-InfEx-RprtIE >-----#
    Extension_InformationExchangeObjectType_InfEx_RprtIE = CLASS(name=u'Extension-InformationExchangeObjectType-InfEx-RprtIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt')))
    _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-InfEx-Rprt')))
    _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_2 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-InfEx-Rprt')))
    Extension_InformationExchangeObjectType_InfEx_RprtIE._val = ASN1Set(rv=[dict([(u'id', 758), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 761), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 937), (u'criticality', u'ignore'), (u'Value', _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_2), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-InfEx-Rprt >-----#
    Cell_InfEx_Rprt = SEQ(name=u'Cell-InfEx-Rprt', mode=MODE_TYPE)
    _Cell_InfEx_Rprt_requestedDataValueInformation = CHOICE(name=u'requestedDataValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValueInformation')))
    _Cell_InfEx_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_InfEx_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Cell_InfEx_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Cell_InfEx_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rprt_iE_Extensions__item__id._const_tab = ____Cell_InfEx_Rprt_iE_Extensions__item__id_tab
    ___Cell_InfEx_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___Cell_InfEx_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___Cell_InfEx_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Cell_InfEx_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rprt_iE_Extensions__item__criticality._const_tab = ____Cell_InfEx_Rprt_iE_Extensions__item__criticality_tab
    ___Cell_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Cell_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Cell_InfEx_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Cell_InfEx_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Cell_InfEx_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab = ____Cell_InfEx_Rprt_iE_Extensions__item__extensionValue_tab
    ___Cell_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Cell_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Cell_InfEx_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Cell_InfEx_Rprt_iE_Extensions__item__id),
        (u'criticality', ___Cell_InfEx_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___Cell_InfEx_Rprt_iE_Extensions__item__extensionValue),
        ])
    __Cell_InfEx_Rprt_iE_Extensions__item_._ext = None
    _Cell_InfEx_Rprt_iE_Extensions._cont = __Cell_InfEx_Rprt_iE_Extensions__item_
    _Cell_InfEx_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_InfEx_Rprt._cont = ASN1Dict([
        (u'requestedDataValueInformation', _Cell_InfEx_Rprt_requestedDataValueInformation),
        (u'iE-Extensions', _Cell_InfEx_Rprt_iE_Extensions),
        ])
    Cell_InfEx_Rprt._ext = []
    
    #-----< CellItem-InfEx-Rprt-ExtIEs >-----#
    CellItem_InfEx_Rprt_ExtIEs = CLASS(name=u'CellItem-InfEx-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    CellItem_InfEx_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt = SEQ_OF(name=u'MBMS-Bearer-Service-in-MBMS-Cell-InfEx-Rprt', mode=MODE_TYPE)
    _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt')))
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt._cont = _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt__item_
    MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt = SEQ(name=u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt', mode=MODE_TYPE)
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_mBMS_Bearer_Service_List_InfEx_Rprt = SEQ_OF(name=u'mBMS-Bearer-Service-List-InfEx-Rprt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-List-InfEx-Rprt')))
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_._ext = None
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions._cont = __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_
    _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt._cont = ASN1Dict([
        (u'c-ID', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_c_ID),
        (u'mBMS-Bearer-Service-List-InfEx-Rprt', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_mBMS_Bearer_Service_List_InfEx_Rprt),
        (u'iE-Extensions', _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions),
        ])
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt._ext = []
    
    #-----< MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt-ExtIEs >-----#
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_ExtIEs = CLASS(name=u'MBMS-Bearer-Service-in-MBMS-Cell-Item-InfEx-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Bearer-Service-List-InfEx-Rprt >-----#
    MBMS_Bearer_Service_List_InfEx_Rprt = SEQ_OF(name=u'MBMS-Bearer-Service-List-InfEx-Rprt', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List_InfEx_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Bearer-Service-List-Item-InfEx-Rprt')))
    MBMS_Bearer_Service_List_InfEx_Rprt._cont = _MBMS_Bearer_Service_List_InfEx_Rprt__item_
    MBMS_Bearer_Service_List_InfEx_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< MBMS-Bearer-Service-List-Item-InfEx-Rprt >-----#
    MBMS_Bearer_Service_List_Item_InfEx_Rprt = SEQ(name=u'MBMS-Bearer-Service-List-Item-InfEx-Rprt', mode=MODE_TYPE)
    _MBMS_Bearer_Service_List_Item_InfEx_Rprt_tmgi = SEQ(name=u'tmgi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'TMGI')))
    _MBMS_Bearer_Service_List_Item_InfEx_Rprt_requestedDataValueInformation = CHOICE(name=u'requestedDataValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValueInformation')))
    _MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab = ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id_tab
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab = ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item_._ext = None
    _MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions._cont = __MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item_
    _MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Bearer_Service_List_Item_InfEx_Rprt._cont = ASN1Dict([
        (u'tmgi', _MBMS_Bearer_Service_List_Item_InfEx_Rprt_tmgi),
        (u'requestedDataValueInformation', _MBMS_Bearer_Service_List_Item_InfEx_Rprt_requestedDataValueInformation),
        (u'iE-Extensions', _MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions),
        ])
    MBMS_Bearer_Service_List_Item_InfEx_Rprt._ext = []
    
    #-----< MBMS-Bearer-Service-List-Item-InfEx-Rprt-ExtIEs >-----#
    MBMS_Bearer_Service_List_Item_InfEx_Rprt_ExtIEs = CLASS(name=u'MBMS-Bearer-Service-List-Item-InfEx-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Bearer_Service_List_Item_InfEx_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMS-Cell-InfEx-Rprt >-----#
    MBMS_Cell_InfEx_Rprt = SEQ_OF(name=u'MBMS-Cell-InfEx-Rprt', mode=MODE_TYPE)
    _MBMS_Cell_InfEx_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMS-Cell-Item-InfEx-Rprt')))
    MBMS_Cell_InfEx_Rprt._cont = _MBMS_Cell_InfEx_Rprt__item_
    MBMS_Cell_InfEx_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< MBMS-Cell-Item-InfEx-Rprt >-----#
    MBMS_Cell_Item_InfEx_Rprt = SEQ(name=u'MBMS-Cell-Item-InfEx-Rprt', mode=MODE_TYPE)
    _MBMS_Cell_Item_InfEx_Rprt_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _MBMS_Cell_Item_InfEx_Rprt_requestedDataValueInformation = CHOICE(name=u'requestedDataValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValueInformation')))
    _MBMS_Cell_Item_InfEx_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab = ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab = ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab = ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id),
        (u'criticality', ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue),
        ])
    __MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_._ext = None
    _MBMS_Cell_Item_InfEx_Rprt_iE_Extensions._cont = __MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_
    _MBMS_Cell_Item_InfEx_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMS_Cell_Item_InfEx_Rprt._cont = ASN1Dict([
        (u'c-ID', _MBMS_Cell_Item_InfEx_Rprt_c_ID),
        (u'requestedDataValueInformation', _MBMS_Cell_Item_InfEx_Rprt_requestedDataValueInformation),
        (u'iE-Extensions', _MBMS_Cell_Item_InfEx_Rprt_iE_Extensions),
        ])
    MBMS_Cell_Item_InfEx_Rprt._ext = []
    
    #-----< MBMS-Cell-Item-InfEx-Rprt-ExtIEs >-----#
    MBMS_Cell_Item_InfEx_Rprt_ExtIEs = CLASS(name=u'MBMS-Cell-Item-InfEx-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMS_Cell_Item_InfEx_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Common-E-RGCH-Cell-InfEx-Rprt >-----#
    Common_E_RGCH_Cell_InfEx_Rprt = SEQ_OF(name=u'Common-E-RGCH-Cell-InfEx-Rprt', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_InfEx_Rprt__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Common-E-RGCH-Cell-Item-InfEx-Rprt')))
    Common_E_RGCH_Cell_InfEx_Rprt._cont = _Common_E_RGCH_Cell_InfEx_Rprt__item_
    Common_E_RGCH_Cell_InfEx_Rprt._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< Common-E-RGCH-Cell-Item-InfEx-Rprt >-----#
    Common_E_RGCH_Cell_Item_InfEx_Rprt = SEQ(name=u'Common-E-RGCH-Cell-Item-InfEx-Rprt', mode=MODE_TYPE)
    _Common_E_RGCH_Cell_Item_InfEx_Rprt_c_ID = INT(name=u'c-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'C-ID')))
    _Common_E_RGCH_Cell_Item_InfEx_Rprt_requestedDataValueInformation = CHOICE(name=u'requestedDataValueInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RequestedDataValueInformation')))
    _Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab = ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id._const_tab_id = u'id'
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab = ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab = ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id),
        (u'criticality', ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality),
        (u'extensionValue', ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue),
        ])
    __Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item_._ext = None
    _Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions._cont = __Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item_
    _Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Common_E_RGCH_Cell_Item_InfEx_Rprt._cont = ASN1Dict([
        (u'c-ID', _Common_E_RGCH_Cell_Item_InfEx_Rprt_c_ID),
        (u'requestedDataValueInformation', _Common_E_RGCH_Cell_Item_InfEx_Rprt_requestedDataValueInformation),
        (u'iE-Extensions', _Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions),
        ])
    Common_E_RGCH_Cell_Item_InfEx_Rprt._ext = []
    
    #-----< Common-E-RGCH-Cell-Item-InfEx-Rprt-ExtIEs >-----#
    Common_E_RGCH_Cell_Item_InfEx_Rprt_ExtIEs = CLASS(name=u'Common-E-RGCH-Cell-Item-InfEx-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Common_E_RGCH_Cell_Item_InfEx_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeTerminationRequest >-----#
    InformationExchangeTerminationRequest = SEQ(name=u'InformationExchangeTerminationRequest', mode=MODE_TYPE)
    _InformationExchangeTerminationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeTerminationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeTerminationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationExchangeTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeTerminationRequest_protocolIEs__item__id),
        (u'criticality', ___InformationExchangeTerminationRequest_protocolIEs__item__criticality),
        (u'value', ___InformationExchangeTerminationRequest_protocolIEs__item__value),
        ])
    __InformationExchangeTerminationRequest_protocolIEs__item_._ext = None
    _InformationExchangeTerminationRequest_protocolIEs._cont = __InformationExchangeTerminationRequest_protocolIEs__item_
    _InformationExchangeTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeTerminationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationExchangeTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeTerminationRequest_protocolExtensions__item__id),
        (u'criticality', ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeTerminationRequest_protocolExtensions__item_._ext = None
    _InformationExchangeTerminationRequest_protocolExtensions._cont = __InformationExchangeTerminationRequest_protocolExtensions__item_
    _InformationExchangeTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeTerminationRequest._cont = ASN1Dict([
        (u'protocolIEs', _InformationExchangeTerminationRequest_protocolIEs),
        (u'protocolExtensions', _InformationExchangeTerminationRequest_protocolExtensions),
        ])
    InformationExchangeTerminationRequest._ext = []
    
    #-----< InformationExchangeTerminationRequest-IEs >-----#
    InformationExchangeTerminationRequest_IEs = CLASS(name=u'InformationExchangeTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationExchangeTerminationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    InformationExchangeTerminationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _InformationExchangeTerminationRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeTerminationRequest-Extensions >-----#
    InformationExchangeTerminationRequest_Extensions = CLASS(name=u'InformationExchangeTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationExchangeTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeFailureIndication >-----#
    InformationExchangeFailureIndication = SEQ(name=u'InformationExchangeFailureIndication', mode=MODE_TYPE)
    _InformationExchangeFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationExchangeFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    ____InformationExchangeFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationExchangeFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeFailureIndication_protocolIEs__item__id),
        (u'criticality', ___InformationExchangeFailureIndication_protocolIEs__item__criticality),
        (u'value', ___InformationExchangeFailureIndication_protocolIEs__item__value),
        ])
    __InformationExchangeFailureIndication_protocolIEs__item_._ext = None
    _InformationExchangeFailureIndication_protocolIEs._cont = __InformationExchangeFailureIndication_protocolIEs__item_
    _InformationExchangeFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeFailureIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeFailureIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationExchangeFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationExchangeFailureIndication_protocolExtensions__item__id),
        (u'criticality', ___InformationExchangeFailureIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeFailureIndication_protocolExtensions__item_._ext = None
    _InformationExchangeFailureIndication_protocolExtensions._cont = __InformationExchangeFailureIndication_protocolExtensions__item_
    _InformationExchangeFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _InformationExchangeFailureIndication_protocolIEs),
        (u'protocolExtensions', _InformationExchangeFailureIndication_protocolExtensions),
        ])
    InformationExchangeFailureIndication._ext = []
    
    #-----< InformationExchangeFailureIndication-IEs >-----#
    InformationExchangeFailureIndication_IEs = CLASS(name=u'InformationExchangeFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationExchangeFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'InformationExchangeID')))
    _InformationExchangeFailureIndication_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    InformationExchangeFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 287), (u'criticality', u'ignore'), (u'Value', _InformationExchangeFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _InformationExchangeFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeFailureIndication-Extensions >-----#
    InformationExchangeFailureIndication_Extensions = CLASS(name=u'InformationExchangeFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationExchangeFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResetRequest >-----#
    ResetRequest = SEQ(name=u'ResetRequest', mode=MODE_TYPE)
    _ResetRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __ResetRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___ResetRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____ResetRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____ResetRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetIndicator')))
    ____ResetRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 245), (u'criticality', u'reject'), (u'Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 244), (u'criticality', u'reject'), (u'Value', _____ResetRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___ResetRequest_protocolIEs__item__id._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__id._const_tab_at = None
    ___ResetRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetRequest_protocolIEs__item__criticality._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___ResetRequest_protocolIEs__item__value._const_tab = ____ResetRequest_protocolIEs__item__id_tab
    ___ResetRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetRequest_protocolIEs__item__id),
        (u'criticality', ___ResetRequest_protocolIEs__item__criticality),
        (u'value', ___ResetRequest_protocolIEs__item__value),
        ])
    __ResetRequest_protocolIEs__item_._ext = None
    _ResetRequest_protocolIEs._cont = __ResetRequest_protocolIEs__item_
    _ResetRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ResetRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____ResetRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____ResetRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _____ResetRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetRequest_protocolExtensions__item__id._const_tab = ____ResetRequest_protocolExtensions__item__id_tab
    ___ResetRequest_protocolExtensions__item__id._const_tab_at = None
    ___ResetRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___ResetRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetRequest_protocolExtensions__item__criticality._const_tab = ____ResetRequest_protocolExtensions__item__id_tab
    ___ResetRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ResetRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetRequest_protocolExtensions__item__extensionValue._const_tab = ____ResetRequest_protocolExtensions__item__id_tab
    ___ResetRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ResetRequest_protocolExtensions__item__id),
        (u'criticality', ___ResetRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___ResetRequest_protocolExtensions__item__extensionValue),
        ])
    __ResetRequest_protocolExtensions__item_._ext = None
    _ResetRequest_protocolExtensions._cont = __ResetRequest_protocolExtensions__item_
    _ResetRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetRequest._cont = ASN1Dict([
        (u'protocolIEs', _ResetRequest_protocolIEs),
        (u'protocolExtensions', _ResetRequest_protocolExtensions),
        ])
    ResetRequest._ext = []
    
    #-----< ResetRequest-IEs >-----#
    ResetRequest_IEs = CLASS(name=u'ResetRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _ResetRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _ResetRequest_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetIndicator')))
    ResetRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 245), (u'criticality', u'reject'), (u'Value', _ResetRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 244), (u'criticality', u'reject'), (u'Value', _ResetRequest_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetRequest-Extensions >-----#
    ResetRequest_Extensions = CLASS(name=u'ResetRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _ResetRequest_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ResetRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _ResetRequest_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetIndicator >-----#
    ResetIndicator = CHOICE(name=u'ResetIndicator', mode=MODE_TYPE)
    _ResetIndicator_context = SEQ(name=u'context', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextList-Reset')))
    _ResetIndicator_all_contexts = NULL(name=u'all-contexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResetIndicator_contextGroup = SEQ(name=u'contextGroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextGroupList-Reset')))
    ResetIndicator._cont = ASN1Dict([
        (u'context', _ResetIndicator_context),
        (u'all-contexts', _ResetIndicator_all_contexts),
        (u'contextGroup', _ResetIndicator_contextGroup),
        ])
    ResetIndicator._ext = [u'contextGroup']
    
    #-----< ContextList-Reset >-----#
    ContextList_Reset = SEQ(name=u'ContextList-Reset', mode=MODE_TYPE)
    _ContextList_Reset_contextInfoList_Reset = SEQ_OF(name=u'contextInfoList-Reset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextInfoList-Reset')))
    _ContextList_Reset_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContextList_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContextList_Reset_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContextList_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextList_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextList_Reset_iE_Extensions__item__id._const_tab = ____ContextList_Reset_iE_Extensions__item__id_tab
    ___ContextList_Reset_iE_Extensions__item__id._const_tab_at = None
    ___ContextList_Reset_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContextList_Reset_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContextList_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextList_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextList_Reset_iE_Extensions__item__criticality._const_tab = ____ContextList_Reset_iE_Extensions__item__criticality_tab
    ___ContextList_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContextList_Reset_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContextList_Reset_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContextList_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextList_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextList_Reset_iE_Extensions__item__extensionValue._const_tab = ____ContextList_Reset_iE_Extensions__item__extensionValue_tab
    ___ContextList_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContextList_Reset_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContextList_Reset_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContextList_Reset_iE_Extensions__item__id),
        (u'criticality', ___ContextList_Reset_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContextList_Reset_iE_Extensions__item__extensionValue),
        ])
    __ContextList_Reset_iE_Extensions__item_._ext = None
    _ContextList_Reset_iE_Extensions._cont = __ContextList_Reset_iE_Extensions__item_
    _ContextList_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContextList_Reset._cont = ASN1Dict([
        (u'contextInfoList-Reset', _ContextList_Reset_contextInfoList_Reset),
        (u'iE-Extensions', _ContextList_Reset_iE_Extensions),
        ])
    ContextList_Reset._ext = []
    
    #-----< ContextItem-Reset-ExtIEs >-----#
    ContextItem_Reset_ExtIEs = CLASS(name=u'ContextItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ContextItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContextInfoList-Reset >-----#
    ContextInfoList_Reset = SEQ_OF(name=u'ContextInfoList-Reset', mode=MODE_TYPE)
    _ContextInfoList_Reset__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __ContextInfoList_Reset__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___ContextInfoList_Reset__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____ContextInfoList_Reset__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextInfoItem-Reset')))
    ___ContextInfoList_Reset__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 211), (u'criticality', u'reject'), (u'Value', ____ContextInfoList_Reset__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __ContextInfoList_Reset__item__id._const_tab = ___ContextInfoList_Reset__item__id_tab
    __ContextInfoList_Reset__item__id._const_tab_at = None
    __ContextInfoList_Reset__item__id._const_tab_id = u'id'
    __ContextInfoList_Reset__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __ContextInfoList_Reset__item__criticality._const_tab = ___ContextInfoList_Reset__item__id_tab
    __ContextInfoList_Reset__item__criticality._const_tab_at = ('..', u'id')
    __ContextInfoList_Reset__item__criticality._const_tab_id = u'criticality'
    __ContextInfoList_Reset__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __ContextInfoList_Reset__item__value._const_tab = ___ContextInfoList_Reset__item__id_tab
    __ContextInfoList_Reset__item__value._const_tab_at = ('..', u'id')
    __ContextInfoList_Reset__item__value._const_tab_id = u'Value'
    _ContextInfoList_Reset__item_._cont = ASN1Dict([
        (u'id', __ContextInfoList_Reset__item__id),
        (u'criticality', __ContextInfoList_Reset__item__criticality),
        (u'value', __ContextInfoList_Reset__item__value),
        ])
    _ContextInfoList_Reset__item_._ext = None
    ContextInfoList_Reset._cont = _ContextInfoList_Reset__item_
    ContextInfoList_Reset._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=250)], ev=None, er=[])
    
    #-----< ContextInfoItemIE-Reset >-----#
    ContextInfoItemIE_Reset = CLASS(name=u'ContextInfoItemIE-Reset', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _ContextInfoItemIE_Reset_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextInfoItem-Reset')))
    ContextInfoItemIE_Reset._val = ASN1Set(rv=[dict([(u'id', 211), (u'criticality', u'reject'), (u'Value', _ContextInfoItemIE_Reset_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< ContextInfoItem-Reset >-----#
    ContextInfoItem_Reset = SEQ(name=u'ContextInfoItem-Reset', mode=MODE_TYPE)
    _ContextInfoItem_Reset_contextType_Reset = CHOICE(name=u'contextType-Reset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextType-Reset')))
    _ContextInfoItem_Reset_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContextInfoItem_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContextInfoItem_Reset_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContextInfoItem_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextInfoItem_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextInfoItem_Reset_iE_Extensions__item__id._const_tab = ____ContextInfoItem_Reset_iE_Extensions__item__id_tab
    ___ContextInfoItem_Reset_iE_Extensions__item__id._const_tab_at = None
    ___ContextInfoItem_Reset_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContextInfoItem_Reset_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContextInfoItem_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextInfoItem_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextInfoItem_Reset_iE_Extensions__item__criticality._const_tab = ____ContextInfoItem_Reset_iE_Extensions__item__criticality_tab
    ___ContextInfoItem_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContextInfoItem_Reset_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContextInfoItem_Reset_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab = ____ContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab
    ___ContextInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContextInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContextInfoItem_Reset_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContextInfoItem_Reset_iE_Extensions__item__id),
        (u'criticality', ___ContextInfoItem_Reset_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContextInfoItem_Reset_iE_Extensions__item__extensionValue),
        ])
    __ContextInfoItem_Reset_iE_Extensions__item_._ext = None
    _ContextInfoItem_Reset_iE_Extensions._cont = __ContextInfoItem_Reset_iE_Extensions__item_
    _ContextInfoItem_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContextInfoItem_Reset._cont = ASN1Dict([
        (u'contextType-Reset', _ContextInfoItem_Reset_contextType_Reset),
        (u'iE-Extensions', _ContextInfoItem_Reset_iE_Extensions),
        ])
    ContextInfoItem_Reset._ext = []
    
    #-----< ContextInfoItem-Reset-ExtIEs >-----#
    ContextInfoItem_Reset_ExtIEs = CLASS(name=u'ContextInfoItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ContextInfoItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContextType-Reset >-----#
    ContextType_Reset = CHOICE(name=u'ContextType-Reset', mode=MODE_TYPE)
    _ContextType_Reset_sRNTI = INT(name=u'sRNTI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _ContextType_Reset_dRNTI = INT(name=u'dRNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _ContextType_Reset_extension_ContextType_Reset = SEQ(name=u'extension-ContextType-Reset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Extension-ContextType-Reset')))
    ContextType_Reset._cont = ASN1Dict([
        (u'sRNTI', _ContextType_Reset_sRNTI),
        (u'dRNTI', _ContextType_Reset_dRNTI),
        (u'extension-ContextType-Reset', _ContextType_Reset_extension_ContextType_Reset),
        ])
    ContextType_Reset._ext = [u'extension-ContextType-Reset']
    
    #-----< Extension-ContextType-Reset >-----#
    Extension_ContextType_Reset = SEQ(name=u'Extension-ContextType-Reset', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_ContextType_Reset_id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    __Extension_ContextType_Reset_id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ___Extension_ContextType_Reset_id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    __Extension_ContextType_Reset_id_tab._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'reject'), (u'Value', ___Extension_ContextType_Reset_id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    _Extension_ContextType_Reset_id._const_tab = __Extension_ContextType_Reset_id_tab
    _Extension_ContextType_Reset_id._const_tab_at = None
    _Extension_ContextType_Reset_id._const_tab_id = u'id'
    _Extension_ContextType_Reset_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    _Extension_ContextType_Reset_criticality._const_tab = __Extension_ContextType_Reset_id_tab
    _Extension_ContextType_Reset_criticality._const_tab_at = ('..', u'id')
    _Extension_ContextType_Reset_criticality._const_tab_id = u'criticality'
    _Extension_ContextType_Reset_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    _Extension_ContextType_Reset_value._const_tab = __Extension_ContextType_Reset_id_tab
    _Extension_ContextType_Reset_value._const_tab_at = ('..', u'id')
    _Extension_ContextType_Reset_value._const_tab_id = u'Value'
    Extension_ContextType_Reset._cont = ASN1Dict([
        (u'id', _Extension_ContextType_Reset_id),
        (u'criticality', _Extension_ContextType_Reset_criticality),
        (u'value', _Extension_ContextType_Reset_value),
        ])
    Extension_ContextType_Reset._ext = None
    
    #-----< Extension-ContextType-ResetIE >-----#
    Extension_ContextType_ResetIE = CLASS(name=u'Extension-ContextType-ResetIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _Extension_ContextType_ResetIE_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    Extension_ContextType_ResetIE._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'reject'), (u'Value', _Extension_ContextType_ResetIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ContextGroupList-Reset >-----#
    ContextGroupList_Reset = SEQ(name=u'ContextGroupList-Reset', mode=MODE_TYPE)
    _ContextGroupList_Reset_contextGroupInfoList_Reset = SEQ_OF(name=u'contextGroupInfoList-Reset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextGroupInfoList-Reset')))
    _ContextGroupList_Reset_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContextGroupList_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContextGroupList_Reset_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContextGroupList_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextGroupList_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextGroupList_Reset_iE_Extensions__item__id._const_tab = ____ContextGroupList_Reset_iE_Extensions__item__id_tab
    ___ContextGroupList_Reset_iE_Extensions__item__id._const_tab_at = None
    ___ContextGroupList_Reset_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContextGroupList_Reset_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____ContextGroupList_Reset_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextGroupList_Reset_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextGroupList_Reset_iE_Extensions__item__criticality._const_tab = ____ContextGroupList_Reset_iE_Extensions__item__criticality_tab
    ___ContextGroupList_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContextGroupList_Reset_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContextGroupList_Reset_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____ContextGroupList_Reset_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____ContextGroupList_Reset_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ContextGroupList_Reset_iE_Extensions__item__extensionValue._const_tab = ____ContextGroupList_Reset_iE_Extensions__item__extensionValue_tab
    ___ContextGroupList_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContextGroupList_Reset_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContextGroupList_Reset_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContextGroupList_Reset_iE_Extensions__item__id),
        (u'criticality', ___ContextGroupList_Reset_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContextGroupList_Reset_iE_Extensions__item__extensionValue),
        ])
    __ContextGroupList_Reset_iE_Extensions__item_._ext = None
    _ContextGroupList_Reset_iE_Extensions._cont = __ContextGroupList_Reset_iE_Extensions__item_
    _ContextGroupList_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContextGroupList_Reset._cont = ASN1Dict([
        (u'contextGroupInfoList-Reset', _ContextGroupList_Reset_contextGroupInfoList_Reset),
        (u'iE-Extensions', _ContextGroupList_Reset_iE_Extensions),
        ])
    ContextGroupList_Reset._ext = []
    
    #-----< ContextGroupItem-Reset-ExtIEs >-----#
    ContextGroupItem_Reset_ExtIEs = CLASS(name=u'ContextGroupItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ContextGroupItem_Reset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ContextGroupInfoList-Reset >-----#
    ContextGroupInfoList_Reset = SEQ_OF(name=u'ContextGroupInfoList-Reset', mode=MODE_TYPE)
    _ContextGroupInfoList_Reset__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __ContextGroupInfoList_Reset__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___ContextGroupInfoList_Reset__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____ContextGroupInfoList_Reset__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextGroupInfoItem-Reset')))
    ___ContextGroupInfoList_Reset__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 515), (u'criticality', u'reject'), (u'Value', ____ContextGroupInfoList_Reset__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __ContextGroupInfoList_Reset__item__id._const_tab = ___ContextGroupInfoList_Reset__item__id_tab
    __ContextGroupInfoList_Reset__item__id._const_tab_at = None
    __ContextGroupInfoList_Reset__item__id._const_tab_id = u'id'
    __ContextGroupInfoList_Reset__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __ContextGroupInfoList_Reset__item__criticality._const_tab = ___ContextGroupInfoList_Reset__item__id_tab
    __ContextGroupInfoList_Reset__item__criticality._const_tab_at = ('..', u'id')
    __ContextGroupInfoList_Reset__item__criticality._const_tab_id = u'criticality'
    __ContextGroupInfoList_Reset__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __ContextGroupInfoList_Reset__item__value._const_tab = ___ContextGroupInfoList_Reset__item__id_tab
    __ContextGroupInfoList_Reset__item__value._const_tab_at = ('..', u'id')
    __ContextGroupInfoList_Reset__item__value._const_tab_id = u'Value'
    _ContextGroupInfoList_Reset__item_._cont = ASN1Dict([
        (u'id', __ContextGroupInfoList_Reset__item__id),
        (u'criticality', __ContextGroupInfoList_Reset__item__criticality),
        (u'value', __ContextGroupInfoList_Reset__item__value),
        ])
    _ContextGroupInfoList_Reset__item_._ext = None
    ContextGroupInfoList_Reset._cont = _ContextGroupInfoList_Reset__item_
    ContextGroupInfoList_Reset._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ContextGroupInfoItemIE-Reset >-----#
    ContextGroupInfoItemIE_Reset = CLASS(name=u'ContextGroupInfoItemIE-Reset', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _ContextGroupInfoItemIE_Reset_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ContextGroupInfoItem-Reset')))
    ContextGroupInfoItemIE_Reset._val = ASN1Set(rv=[dict([(u'id', 515), (u'criticality', u'reject'), (u'Value', _ContextGroupInfoItemIE_Reset_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< ContextGroupInfoItem-Reset >-----#
    ContextGroupInfoItem_Reset = SEQ(name=u'ContextGroupInfoItem-Reset', mode=MODE_TYPE)
    _ContextGroupInfoItem_Reset_s_RNTI_Group = SEQ(name=u's-RNTI-Group', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI-Group')))
    _ContextGroupInfoItem_Reset_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ContextGroupInfoItem_Reset_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-S-RNTI-Group')))
    ____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 916), (u'criticality', u'reject'), (u'Extension', _____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__id._const_tab = ____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__id._const_tab_at = None
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__id._const_tab_id = u'id'
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__criticality._const_tab = ____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab = ____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ContextGroupInfoItem_Reset_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __ContextGroupInfoItem_Reset_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___ContextGroupInfoItem_Reset_iE_Extensions__item__id),
        (u'criticality', ___ContextGroupInfoItem_Reset_iE_Extensions__item__criticality),
        (u'extensionValue', ___ContextGroupInfoItem_Reset_iE_Extensions__item__extensionValue),
        ])
    __ContextGroupInfoItem_Reset_iE_Extensions__item_._ext = None
    _ContextGroupInfoItem_Reset_iE_Extensions._cont = __ContextGroupInfoItem_Reset_iE_Extensions__item_
    _ContextGroupInfoItem_Reset_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ContextGroupInfoItem_Reset._cont = ASN1Dict([
        (u's-RNTI-Group', _ContextGroupInfoItem_Reset_s_RNTI_Group),
        (u'iE-Extensions', _ContextGroupInfoItem_Reset_iE_Extensions),
        ])
    ContextGroupInfoItem_Reset._ext = []
    
    #-----< ContextGroupInfoItem-Reset-ExtIEs >-----#
    ContextGroupInfoItem_Reset_ExtIEs = CLASS(name=u'ContextGroupInfoItem-Reset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _ContextGroupInfoItem_Reset_ExtIEs_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-S-RNTI-Group')))
    ContextGroupInfoItem_Reset_ExtIEs._val = ASN1Set(rv=[dict([(u'id', 916), (u'criticality', u'reject'), (u'Extension', _ContextGroupInfoItem_Reset_ExtIEs_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse >-----#
    ResetResponse = SEQ(name=u'ResetResponse', mode=MODE_TYPE)
    _ResetResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __ResetResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___ResetResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____ResetResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____ResetResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____ResetResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____ResetResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolIEs__item__id._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__id._const_tab_at = None
    ___ResetResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___ResetResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___ResetResponse_protocolIEs__item__criticality._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___ResetResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___ResetResponse_protocolIEs__item__value._const_tab = ____ResetResponse_protocolIEs__item__id_tab
    ___ResetResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __ResetResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___ResetResponse_protocolIEs__item__id),
        (u'criticality', ___ResetResponse_protocolIEs__item__criticality),
        (u'value', ___ResetResponse_protocolIEs__item__value),
        ])
    __ResetResponse_protocolIEs__item_._ext = None
    _ResetResponse_protocolIEs._cont = __ResetResponse_protocolIEs__item_
    _ResetResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___ResetResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____ResetResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____ResetResponse_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____ResetResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _____ResetResponse_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___ResetResponse_protocolExtensions__item__id._const_tab = ____ResetResponse_protocolExtensions__item__id_tab
    ___ResetResponse_protocolExtensions__item__id._const_tab_at = None
    ___ResetResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___ResetResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___ResetResponse_protocolExtensions__item__criticality._const_tab = ____ResetResponse_protocolExtensions__item__id_tab
    ___ResetResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___ResetResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___ResetResponse_protocolExtensions__item__extensionValue._const_tab = ____ResetResponse_protocolExtensions__item__id_tab
    ___ResetResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___ResetResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __ResetResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___ResetResponse_protocolExtensions__item__id),
        (u'criticality', ___ResetResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___ResetResponse_protocolExtensions__item__extensionValue),
        ])
    __ResetResponse_protocolExtensions__item_._ext = None
    _ResetResponse_protocolExtensions._cont = __ResetResponse_protocolExtensions__item_
    _ResetResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResponse._cont = ASN1Dict([
        (u'protocolIEs', _ResetResponse_protocolIEs),
        (u'protocolExtensions', _ResetResponse_protocolExtensions),
        ])
    ResetResponse._ext = []
    
    #-----< ResetResponse-IEs >-----#
    ResetResponse_IEs = CLASS(name=u'ResetResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _ResetResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _ResetResponse_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ResetResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _ResetResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _ResetResponse_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResponse-Extensions >-----#
    ResetResponse_Extensions = CLASS(name=u'ResetResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _ResetResponse_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ResetResponse_Extensions._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _ResetResponse_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandFDD >-----#
    RadioLinkActivationCommandFDD = SEQ(name=u'RadioLinkActivationCommandFDD', mode=MODE_TYPE)
    _RadioLinkActivationCommandFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkActivationCommandFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdFDD')))
    ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 313), (u'criticality', u'ignore'), (u'Value', _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id._const_tab = ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkActivationCommandFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value._const_tab = ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkActivationCommandFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkActivationCommandFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkActivationCommandFDD_protocolIEs__item__value),
        ])
    __RadioLinkActivationCommandFDD_protocolIEs__item_._ext = None
    _RadioLinkActivationCommandFDD_protocolIEs._cont = __RadioLinkActivationCommandFDD_protocolIEs__item_
    _RadioLinkActivationCommandFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkActivationCommandFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkActivationCommandFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id._const_tab = ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkActivationCommandFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkActivationCommandFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkActivationCommandFDD_protocolExtensions__item_._ext = None
    _RadioLinkActivationCommandFDD_protocolExtensions._cont = __RadioLinkActivationCommandFDD_protocolExtensions__item_
    _RadioLinkActivationCommandFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkActivationCommandFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkActivationCommandFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkActivationCommandFDD_protocolExtensions),
        ])
    RadioLinkActivationCommandFDD._ext = []
    
    #-----< RadioLinkActivationCommandFDD-IEs >-----#
    RadioLinkActivationCommandFDD_IEs = CLASS(name=u'RadioLinkActivationCommandFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkActivationCommandFDD_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdFDD')))
    RadioLinkActivationCommandFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 313), (u'criticality', u'ignore'), (u'Value', _RadioLinkActivationCommandFDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandFDD-Extensions >-----#
    RadioLinkActivationCommandFDD_Extensions = CLASS(name=u'RadioLinkActivationCommandFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkActivationCommandFDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DelayedActivationInformationList-RL-ActivationCmdFDD >-----#
    DelayedActivationInformationList_RL_ActivationCmdFDD = SEQ_OF(name=u'DelayedActivationInformationList-RL-ActivationCmdFDD', mode=MODE_TYPE)
    _DelayedActivationInformationList_RL_ActivationCmdFDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdFDD')))
    ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 314), (u'criticality', u'ignore'), (u'Value', ____DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id._const_tab_at = None
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id._const_tab_id = u'id'
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality._const_tab_at = ('..', u'id')
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality._const_tab_id = u'criticality'
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value._const_tab_at = ('..', u'id')
    __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value._const_tab_id = u'Value'
    _DelayedActivationInformationList_RL_ActivationCmdFDD__item_._cont = ASN1Dict([
        (u'id', __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id),
        (u'criticality', __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality),
        (u'value', __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value),
        ])
    _DelayedActivationInformationList_RL_ActivationCmdFDD__item_._ext = None
    DelayedActivationInformationList_RL_ActivationCmdFDD._cont = _DelayedActivationInformationList_RL_ActivationCmdFDD__item_
    DelayedActivationInformationList_RL_ActivationCmdFDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdFDD-IEs >-----#
    DelayedActivationInformation_RL_ActivationCmdFDD_IEs = CLASS(name=u'DelayedActivationInformation-RL-ActivationCmdFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DelayedActivationInformation_RL_ActivationCmdFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdFDD')))
    DelayedActivationInformation_RL_ActivationCmdFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 314), (u'criticality', u'ignore'), (u'Value', _DelayedActivationInformation_RL_ActivationCmdFDD_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdFDD >-----#
    DelayedActivationInformation_RL_ActivationCmdFDD = SEQ(name=u'DelayedActivationInformation-RL-ActivationCmdFDD', mode=MODE_TYPE)
    _DelayedActivationInformation_RL_ActivationCmdFDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _DelayedActivationInformation_RL_ActivationCmdFDD_delayed_activation_update = CHOICE(name=u'delayed-activation-update', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivationUpdate')))
    _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id._const_tab = ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id._const_tab_at = None
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality._const_tab = ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue._const_tab = ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id),
        (u'criticality', ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue),
        ])
    __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_._ext = None
    _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions._cont = __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_
    _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DelayedActivationInformation_RL_ActivationCmdFDD._cont = ASN1Dict([
        (u'rL-ID', _DelayedActivationInformation_RL_ActivationCmdFDD_rL_ID),
        (u'delayed-activation-update', _DelayedActivationInformation_RL_ActivationCmdFDD_delayed_activation_update),
        (u'iE-Extensions', _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions),
        ])
    DelayedActivationInformation_RL_ActivationCmdFDD._ext = []
    
    #-----< DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs >-----#
    DelayedActivationInformation_RL_ActivationCmdFDD_ExtIEs = CLASS(name=u'DelayedActivationInformation-RL-ActivationCmdFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DelayedActivationInformation_RL_ActivationCmdFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandTDD >-----#
    RadioLinkActivationCommandTDD = SEQ(name=u'RadioLinkActivationCommandTDD', mode=MODE_TYPE)
    _RadioLinkActivationCommandTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkActivationCommandTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdTDD')))
    ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 315), (u'criticality', u'ignore'), (u'Value', _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id._const_tab = ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkActivationCommandTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value._const_tab = ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkActivationCommandTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkActivationCommandTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkActivationCommandTDD_protocolIEs__item__value),
        ])
    __RadioLinkActivationCommandTDD_protocolIEs__item_._ext = None
    _RadioLinkActivationCommandTDD_protocolIEs._cont = __RadioLinkActivationCommandTDD_protocolIEs__item_
    _RadioLinkActivationCommandTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkActivationCommandTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkActivationCommandTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id._const_tab = ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkActivationCommandTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkActivationCommandTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkActivationCommandTDD_protocolExtensions__item_._ext = None
    _RadioLinkActivationCommandTDD_protocolExtensions._cont = __RadioLinkActivationCommandTDD_protocolExtensions__item_
    _RadioLinkActivationCommandTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkActivationCommandTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkActivationCommandTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkActivationCommandTDD_protocolExtensions),
        ])
    RadioLinkActivationCommandTDD._ext = []
    
    #-----< RadioLinkActivationCommandTDD-IEs >-----#
    RadioLinkActivationCommandTDD_IEs = CLASS(name=u'RadioLinkActivationCommandTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkActivationCommandTDD_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformationList-RL-ActivationCmdTDD')))
    RadioLinkActivationCommandTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 315), (u'criticality', u'ignore'), (u'Value', _RadioLinkActivationCommandTDD_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkActivationCommandTDD-Extensions >-----#
    RadioLinkActivationCommandTDD_Extensions = CLASS(name=u'RadioLinkActivationCommandTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkActivationCommandTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DelayedActivationInformationList-RL-ActivationCmdTDD >-----#
    DelayedActivationInformationList_RL_ActivationCmdTDD = SEQ_OF(name=u'DelayedActivationInformationList-RL-ActivationCmdTDD', mode=MODE_TYPE)
    _DelayedActivationInformationList_RL_ActivationCmdTDD__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdTDD')))
    ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 316), (u'criticality', u'ignore'), (u'Value', ____DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id._const_tab_at = None
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id._const_tab_id = u'id'
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality._const_tab_at = ('..', u'id')
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality._const_tab_id = u'criticality'
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value._const_tab = ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value._const_tab_at = ('..', u'id')
    __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value._const_tab_id = u'Value'
    _DelayedActivationInformationList_RL_ActivationCmdTDD__item_._cont = ASN1Dict([
        (u'id', __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id),
        (u'criticality', __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality),
        (u'value', __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value),
        ])
    _DelayedActivationInformationList_RL_ActivationCmdTDD__item_._ext = None
    DelayedActivationInformationList_RL_ActivationCmdTDD._cont = _DelayedActivationInformationList_RL_ActivationCmdTDD__item_
    DelayedActivationInformationList_RL_ActivationCmdTDD._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdTDD-IEs >-----#
    DelayedActivationInformation_RL_ActivationCmdTDD_IEs = CLASS(name=u'DelayedActivationInformation-RL-ActivationCmdTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DelayedActivationInformation_RL_ActivationCmdTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DelayedActivationInformation-RL-ActivationCmdTDD')))
    DelayedActivationInformation_RL_ActivationCmdTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 316), (u'criticality', u'ignore'), (u'Value', _DelayedActivationInformation_RL_ActivationCmdTDD_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    
    #-----< DelayedActivationInformation-RL-ActivationCmdTDD >-----#
    DelayedActivationInformation_RL_ActivationCmdTDD = SEQ(name=u'DelayedActivationInformation-RL-ActivationCmdTDD', mode=MODE_TYPE)
    _DelayedActivationInformation_RL_ActivationCmdTDD_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _DelayedActivationInformation_RL_ActivationCmdTDD_delayed_activation_update = CHOICE(name=u'delayed-activation-update', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'DelayedActivationUpdate')))
    _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id._const_tab = ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id._const_tab_at = None
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id._const_tab_id = u'id'
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality._const_tab = ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue._const_tab = ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id),
        (u'criticality', ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality),
        (u'extensionValue', ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue),
        ])
    __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_._ext = None
    _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions._cont = __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_
    _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DelayedActivationInformation_RL_ActivationCmdTDD._cont = ASN1Dict([
        (u'rL-ID', _DelayedActivationInformation_RL_ActivationCmdTDD_rL_ID),
        (u'delayed-activation-update', _DelayedActivationInformation_RL_ActivationCmdTDD_delayed_activation_update),
        (u'iE-Extensions', _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions),
        ])
    DelayedActivationInformation_RL_ActivationCmdTDD._ext = []
    
    #-----< DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs >-----#
    DelayedActivationInformation_RL_ActivationCmdTDD_ExtIEs = CLASS(name=u'DelayedActivationInformation-RL-ActivationCmdTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    DelayedActivationInformation_RL_ActivationCmdTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GERANUplinkSignallingTransferIndication >-----#
    GERANUplinkSignallingTransferIndication = SEQ(name=u'GERANUplinkSignallingTransferIndication', mode=MODE_TYPE)
    _GERANUplinkSignallingTransferIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __GERANUplinkSignallingTransferIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    ____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__id._const_tab = ____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__id._const_tab_at = None
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__criticality._const_tab = ____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__value._const_tab = ____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___GERANUplinkSignallingTransferIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __GERANUplinkSignallingTransferIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___GERANUplinkSignallingTransferIndication_protocolIEs__item__id),
        (u'criticality', ___GERANUplinkSignallingTransferIndication_protocolIEs__item__criticality),
        (u'value', ___GERANUplinkSignallingTransferIndication_protocolIEs__item__value),
        ])
    __GERANUplinkSignallingTransferIndication_protocolIEs__item_._ext = None
    _GERANUplinkSignallingTransferIndication_protocolIEs._cont = __GERANUplinkSignallingTransferIndication_protocolIEs__item_
    _GERANUplinkSignallingTransferIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GERANUplinkSignallingTransferIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERANUplinkSignallingTransferIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__id._const_tab = ____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__id._const_tab_at = None
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__criticality._const_tab = ____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__extensionValue._const_tab = ____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __GERANUplinkSignallingTransferIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__id),
        (u'criticality', ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__extensionValue),
        ])
    __GERANUplinkSignallingTransferIndication_protocolExtensions__item_._ext = None
    _GERANUplinkSignallingTransferIndication_protocolExtensions._cont = __GERANUplinkSignallingTransferIndication_protocolExtensions__item_
    _GERANUplinkSignallingTransferIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERANUplinkSignallingTransferIndication._cont = ASN1Dict([
        (u'protocolIEs', _GERANUplinkSignallingTransferIndication_protocolIEs),
        (u'protocolExtensions', _GERANUplinkSignallingTransferIndication_protocolExtensions),
        ])
    GERANUplinkSignallingTransferIndication._ext = []
    
    #-----< GERANUplinkSignallingTransferIndication-IEs >-----#
    GERANUplinkSignallingTransferIndication_IEs = CLASS(name=u'GERANUplinkSignallingTransferIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UC-ID')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SAI')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_4 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_5 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-PS-DomainIdentifier')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_6 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CN-CS-DomainIdentifier')))
    _GERANUplinkSignallingTransferIndication_IEs_val_Value_7 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'URA-Information')))
    GERANUplinkSignallingTransferIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 166), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 156), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 155), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 10), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 9), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_6), (u'presence', u'optional')]), dict([(u'id', 185), (u'criticality', u'ignore'), (u'Value', _GERANUplinkSignallingTransferIndication_IEs_val_Value_7), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< GERANUplinkSignallingTransferIndication-Extensions >-----#
    GERANUplinkSignallingTransferIndication_Extensions = CLASS(name=u'GERANUplinkSignallingTransferIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _GERANUplinkSignallingTransferIndication_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    GERANUplinkSignallingTransferIndication_Extensions._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'ignore'), (u'Extension', _GERANUplinkSignallingTransferIndication_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationFDD >-----#
    RadioLinkParameterUpdateIndicationFDD = SEQ(name=u'RadioLinkParameterUpdateIndicationFDD', mode=MODE_TYPE)
    _RadioLinkParameterUpdateIndicationFDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Update-Information')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ParameterUpdateIndicationFDD-RL-InformationList')))
    ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 466), (u'criticality', u'ignore'), (u'Value', _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 518), (u'criticality', u'ignore'), (u'Value', _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value),
        ])
    __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_._ext = None
    _RadioLinkParameterUpdateIndicationFDD_protocolIEs._cont = __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_
    _RadioLinkParameterUpdateIndicationFDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkParameterUpdateIndicationFDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-FDD-Update-Information')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Param-Upd')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Param-Upd')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-RecoveryReport')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-State-Update-Information')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UE-Measurement-Forwarding')))
    _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 606), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 801), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 843), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 910), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 908), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 955), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Extension', _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_._ext = None
    _RadioLinkParameterUpdateIndicationFDD_protocolExtensions._cont = __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_
    _RadioLinkParameterUpdateIndicationFDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkParameterUpdateIndicationFDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkParameterUpdateIndicationFDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkParameterUpdateIndicationFDD_protocolExtensions),
        ])
    RadioLinkParameterUpdateIndicationFDD._ext = []
    
    #-----< RadioLinkParameterUpdateIndicationFDD-IEs >-----#
    RadioLinkParameterUpdateIndicationFDD_IEs = CLASS(name=u'RadioLinkParameterUpdateIndicationFDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-FDD-Update-Information')))
    _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ParameterUpdateIndicationFDD-RL-InformationList')))
    RadioLinkParameterUpdateIndicationFDD_IEs._val = ASN1Set(rv=[dict([(u'id', 466), (u'criticality', u'ignore'), (u'Value', _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 518), (u'criticality', u'ignore'), (u'Value', _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RL-ParameterUpdateIndicationFDD-RL-InformationList >-----#
    RL_ParameterUpdateIndicationFDD_RL_InformationList = SEQ_OF(name=u'RL-ParameterUpdateIndicationFDD-RL-InformationList', mode=MODE_TYPE)
    _RL_ParameterUpdateIndicationFDD_RL_InformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ParameterUpdateIndicationFDD-RL-Information-Item')))
    ___RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 524), (u'criticality', u'ignore'), (u'Value', ____RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id._const_tab = ___RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id._const_tab_at = None
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id._const_tab_id = u'id'
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__criticality._const_tab = ___RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__criticality._const_tab_at = ('..', u'id')
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__criticality._const_tab_id = u'criticality'
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__value._const_tab = ___RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__value._const_tab_at = ('..', u'id')
    __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__value._const_tab_id = u'Value'
    _RL_ParameterUpdateIndicationFDD_RL_InformationList__item_._cont = ASN1Dict([
        (u'id', __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id),
        (u'criticality', __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__criticality),
        (u'value', __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__value),
        ])
    _RL_ParameterUpdateIndicationFDD_RL_InformationList__item_._ext = None
    RL_ParameterUpdateIndicationFDD_RL_InformationList._cont = _RL_ParameterUpdateIndicationFDD_RL_InformationList__item_
    RL_ParameterUpdateIndicationFDD_RL_InformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< RL-ParameterUpdateIndicationFDD-RL-InformationList-IEs >-----#
    RL_ParameterUpdateIndicationFDD_RL_InformationList_IEs = CLASS(name=u'RL-ParameterUpdateIndicationFDD-RL-InformationList-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RL_ParameterUpdateIndicationFDD_RL_InformationList_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RL-ParameterUpdateIndicationFDD-RL-Information-Item')))
    RL_ParameterUpdateIndicationFDD_RL_InformationList_IEs._val = ASN1Set(rv=[dict([(u'id', 524), (u'criticality', u'ignore'), (u'Value', _RL_ParameterUpdateIndicationFDD_RL_InformationList_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< RL-ParameterUpdateIndicationFDD-RL-Information-Item >-----#
    RL_ParameterUpdateIndicationFDD_RL_Information_Item = SEQ(name=u'RL-ParameterUpdateIndicationFDD-RL-Information-Item', mode=MODE_TYPE)
    _RL_ParameterUpdateIndicationFDD_RL_Information_Item_rL_ID = INT(name=u'rL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _RL_ParameterUpdateIndicationFDD_RL_Information_Item_phase_Reference_Update_Indicator = ENUM(name=u'phase-Reference-Update-Indicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Phase-Reference-Update-Indicator')), opt=True)
    _RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id._const_tab = ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id_tab
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id._const_tab_id = u'id'
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality._const_tab = ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality_tab
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue_tab
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id),
        (u'criticality', ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality),
        (u'extensionValue', ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item_._ext = None
    _RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions._cont = __RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item_
    _RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RL_ParameterUpdateIndicationFDD_RL_Information_Item._cont = ASN1Dict([
        (u'rL-ID', _RL_ParameterUpdateIndicationFDD_RL_Information_Item_rL_ID),
        (u'phase-Reference-Update-Indicator', _RL_ParameterUpdateIndicationFDD_RL_Information_Item_phase_Reference_Update_Indicator),
        (u'iE-Extensions', _RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions),
        ])
    RL_ParameterUpdateIndicationFDD_RL_Information_Item._ext = []
    
    #-----< RL-ParameterUpdateIndicationFDD-RL-Information-ExtIEs >-----#
    RL_ParameterUpdateIndicationFDD_RL_Information_ExtIEs = CLASS(name=u'RL-ParameterUpdateIndicationFDD-RL-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RL_ParameterUpdateIndicationFDD_RL_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationFDD-Extensions >-----#
    RadioLinkParameterUpdateIndicationFDD_Extensions = CLASS(name=u'RadioLinkParameterUpdateIndicationFDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'E-DCH-FDD-Update-Information')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_1 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Param-Upd')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_2 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Param-Upd')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_3 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CPC-RecoveryReport')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_4 = ENUM(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UL-CLTD-State-Update-Information')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_5 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UE-Measurement-Forwarding')))
    _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_6 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    RadioLinkParameterUpdateIndicationFDD_Extensions._val = ASN1Set(rv=[dict([(u'id', 606), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 801), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_1), (u'presence', u'optional')]), dict([(u'id', 843), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_2), (u'presence', u'optional')]), dict([(u'id', 910), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_3), (u'presence', u'optional')]), dict([(u'id', 908), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_4), (u'presence', u'optional')]), dict([(u'id', 955), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_5), (u'presence', u'optional')]), dict([(u'id', 8), (u'criticality', u'ignore'), (u'Extension', _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_6), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UE-Measurement-Forwarding >-----#
    UE_Measurement_Forwarding = SEQ(name=u'UE-Measurement-Forwarding', mode=MODE_TYPE)
    _UE_Measurement_Forwarding_measurementID = INT(name=u'measurementID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _UE_Measurement_Forwarding_uE_Measurement_Value = CHOICE(name=u'uE-Measurement-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'UE-Measurement-Value')))
    _UE_Measurement_Forwarding_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Measurement_Forwarding_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UE_Measurement_Forwarding_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Measurement_Forwarding_iE_Extensions__item__id._const_tab = ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab
    ___UE_Measurement_Forwarding_iE_Extensions__item__id._const_tab_at = None
    ___UE_Measurement_Forwarding_iE_Extensions__item__id._const_tab_id = u'id'
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality._const_tab = ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___UE_Measurement_Forwarding_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue._const_tab = ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __UE_Measurement_Forwarding_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___UE_Measurement_Forwarding_iE_Extensions__item__id),
        (u'criticality', ___UE_Measurement_Forwarding_iE_Extensions__item__criticality),
        (u'extensionValue', ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue),
        ])
    __UE_Measurement_Forwarding_iE_Extensions__item_._ext = None
    _UE_Measurement_Forwarding_iE_Extensions._cont = __UE_Measurement_Forwarding_iE_Extensions__item_
    _UE_Measurement_Forwarding_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Measurement_Forwarding._cont = ASN1Dict([
        (u'measurementID', _UE_Measurement_Forwarding_measurementID),
        (u'uE-Measurement-Value', _UE_Measurement_Forwarding_uE_Measurement_Value),
        (u'iE-Extensions', _UE_Measurement_Forwarding_iE_Extensions),
        ])
    UE_Measurement_Forwarding._ext = []
    
    #-----< UE-Measurement-Forwarding-ExtIEs >-----#
    UE_Measurement_Forwarding_ExtIEs = CLASS(name=u'UE-Measurement-Forwarding-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UE_Measurement_Forwarding_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Param-Upd >-----#
    Additional_HS_Cell_Information_RL_Param_Upd = SEQ_OF(name=u'Additional-HS-Cell-Information-RL-Param-Upd', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Param_Upd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs')))
    Additional_HS_Cell_Information_RL_Param_Upd._cont = _Additional_HS_Cell_Information_RL_Param_Upd__item_
    Additional_HS_Cell_Information_RL_Param_Upd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs >-----#
    Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs = SEQ(name=u'Additional-HS-Cell-Information-RL-Param-Upd-ItemIEs', mode=MODE_TYPE)
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hSPDSCH_RL_ID = INT(name=u'hSPDSCH-RL-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'RL-ID')))
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Update_Information = SEQ(name=u'hS-DSCH-FDD-Secondary-Serving-Update-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'HS-DSCH-FDD-Secondary-Serving-Update-Information')))
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._cont = __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_
    _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs._cont = ASN1Dict([
        (u'hSPDSCH-RL-ID', _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hSPDSCH_RL_ID),
        (u'hS-DSCH-FDD-Secondary-Serving-Update-Information', _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Update_Information),
        (u'iE-Extensions', _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions),
        ])
    Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs._ext = []
    
    #-----< Additional-HS-Cell-Information-RL-Setup-ExtIEs >-----#
    Additional_HS_Cell_Information_RL_Setup_ExtIEs = CLASS(name=u'Additional-HS-Cell-Information-RL-Setup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_HS_Cell_Information_RL_Setup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Param-Upd >-----#
    Additional_EDCH_Cell_Information_RL_Param_Upd = SEQ_OF(name=u'Additional-EDCH-Cell-Information-RL-Param-Upd', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Param_Upd__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs')))
    Additional_EDCH_Cell_Information_RL_Param_Upd._cont = _Additional_EDCH_Cell_Information_RL_Param_Upd__item_
    Additional_EDCH_Cell_Information_RL_Param_Upd._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs >-----#
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs = SEQ(name=u'Additional-EDCH-Cell-Information-RL-Param-Upd-ItemIEs', mode=MODE_TYPE)
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_additional_EDCH_FDD_Update_Information = SEQ(name=u'additional-EDCH-FDD-Update-Information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Additional-EDCH-FDD-Update-Information')))
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab = ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_at = None
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id._const_tab_id = u'id'
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab = ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab = ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id),
        (u'criticality', ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality),
        (u'extensionValue', ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue),
        ])
    __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_._ext = None
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._cont = __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_
    _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs._cont = ASN1Dict([
        (u'additional-EDCH-FDD-Update-Information', _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_additional_EDCH_FDD_Update_Information),
        (u'iE-Extensions', _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions),
        ])
    Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs._ext = []
    
    #-----< Additional-EDCH-FDD-Update-Information-ExtIEs >-----#
    Additional_EDCH_FDD_Update_Information_ExtIEs = CLASS(name=u'Additional-EDCH-FDD-Update-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Additional_EDCH_FDD_Update_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationTDD >-----#
    RadioLinkParameterUpdateIndicationTDD = SEQ(name=u'RadioLinkParameterUpdateIndicationTDD', mode=MODE_TYPE)
    _RadioLinkParameterUpdateIndicationTDD_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Update-Information')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 467), (u'criticality', u'ignore'), (u'Value', _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id._const_tab_id = u'id'
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value._const_tab_id = u'Value'
    __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id),
        (u'criticality', ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality),
        (u'value', ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value),
        ])
    __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_._ext = None
    _RadioLinkParameterUpdateIndicationTDD_protocolIEs._cont = __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_
    _RadioLinkParameterUpdateIndicationTDD_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RadioLinkParameterUpdateIndicationTDD_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id._const_tab_at = None
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id._const_tab_id = u'id'
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue._const_tab = ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id),
        (u'criticality', ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality),
        (u'extensionValue', ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue),
        ])
    __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_._ext = None
    _RadioLinkParameterUpdateIndicationTDD_protocolExtensions._cont = __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_
    _RadioLinkParameterUpdateIndicationTDD_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RadioLinkParameterUpdateIndicationTDD._cont = ASN1Dict([
        (u'protocolIEs', _RadioLinkParameterUpdateIndicationTDD_protocolIEs),
        (u'protocolExtensions', _RadioLinkParameterUpdateIndicationTDD_protocolExtensions),
        ])
    RadioLinkParameterUpdateIndicationTDD._ext = []
    
    #-----< RadioLinkParameterUpdateIndicationTDD-IEs >-----#
    RadioLinkParameterUpdateIndicationTDD_IEs = CLASS(name=u'RadioLinkParameterUpdateIndicationTDD-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'HSDSCH-TDD-Update-Information')))
    RadioLinkParameterUpdateIndicationTDD_IEs._val = ASN1Set(rv=[dict([(u'id', 467), (u'criticality', u'ignore'), (u'Value', _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< RadioLinkParameterUpdateIndicationTDD-Extensions >-----#
    RadioLinkParameterUpdateIndicationTDD_Extensions = CLASS(name=u'RadioLinkParameterUpdateIndicationTDD-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    RadioLinkParameterUpdateIndicationTDD_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementInitiationRequest >-----#
    UEMeasurementInitiationRequest = SEQ(name=u'UEMeasurementInitiationRequest', mode=MODE_TYPE)
    _UEMeasurementInitiationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UEMeasurementInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UEMeasurementInitiationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UEMeasurementInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementType')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoHCR')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoLCR')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristics')))
    _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementParameterModAllow')))
    ____UEMeasurementInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 540), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 541), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 542), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 543), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 544), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationRequest_protocolIEs__item__id._const_tab = ____UEMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___UEMeasurementInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEMeasurementInitiationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEMeasurementInitiationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UEMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab = ____UEMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___UEMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementInitiationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UEMeasurementInitiationRequest_protocolIEs__item__value._const_tab = ____UEMeasurementInitiationRequest_protocolIEs__item__id_tab
    ___UEMeasurementInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEMeasurementInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementInitiationRequest_protocolIEs__item__id),
        (u'criticality', ___UEMeasurementInitiationRequest_protocolIEs__item__criticality),
        (u'value', ___UEMeasurementInitiationRequest_protocolIEs__item__value),
        ])
    __UEMeasurementInitiationRequest_protocolIEs__item_._ext = None
    _UEMeasurementInitiationRequest_protocolIEs._cont = __UEMeasurementInitiationRequest_protocolIEs__item_
    _UEMeasurementInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEMeasurementInitiationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementInitiationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfo768')))
    ____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 632), (u'criticality', u'reject'), (u'Extension', _____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationRequest_protocolExtensions__item__id._const_tab = ____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___UEMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___UEMeasurementInitiationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___UEMeasurementInitiationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___UEMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab = ____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___UEMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___UEMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab
    ___UEMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementInitiationRequest_protocolExtensions__item__id),
        (u'criticality', ___UEMeasurementInitiationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___UEMeasurementInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __UEMeasurementInitiationRequest_protocolExtensions__item_._ext = None
    _UEMeasurementInitiationRequest_protocolExtensions._cont = __UEMeasurementInitiationRequest_protocolExtensions__item_
    _UEMeasurementInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementInitiationRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEMeasurementInitiationRequest_protocolIEs),
        (u'protocolExtensions', _UEMeasurementInitiationRequest_protocolExtensions),
        ])
    UEMeasurementInitiationRequest._ext = []
    
    #-----< UEMeasurementInitiationRequest-IEs >-----#
    UEMeasurementInitiationRequest_IEs = CLASS(name=u'UEMeasurementInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UEMeasurementInitiationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'AllowedQueuingTime')))
    _UEMeasurementInitiationRequest_IEs_val_Value_1 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _UEMeasurementInitiationRequest_IEs_val_Value_2 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementType')))
    _UEMeasurementInitiationRequest_IEs_val_Value_3 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoHCR')))
    _UEMeasurementInitiationRequest_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfoLCR')))
    _UEMeasurementInitiationRequest_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _UEMeasurementInitiationRequest_IEs_val_Value_6 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristics')))
    _UEMeasurementInitiationRequest_IEs_val_Value_7 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementParameterModAllow')))
    UEMeasurementInitiationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 4), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 93), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 540), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 541), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 542), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_5), (u'presence', u'optional')]), dict([(u'id', 543), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_6), (u'presence', u'mandatory')]), dict([(u'id', 544), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationRequest_IEs_val_Value_7), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementInitiationRequest-Extensions >-----#
    UEMeasurementInitiationRequest_Extensions = CLASS(name=u'UEMeasurementInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _UEMeasurementInitiationRequest_Extensions_val_Extension_0 = SEQ_OF(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementTimeslotInfo768')))
    UEMeasurementInitiationRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 632), (u'criticality', u'reject'), (u'Extension', _UEMeasurementInitiationRequest_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementInitiationResponse >-----#
    UEMeasurementInitiationResponse = SEQ(name=u'UEMeasurementInitiationResponse', mode=MODE_TYPE)
    _UEMeasurementInitiationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UEMeasurementInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UEMeasurementInitiationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UEMeasurementInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristics')))
    _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____UEMeasurementInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 543), (u'criticality', u'reject'), (u'Value', _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationResponse_protocolIEs__item__id._const_tab = ____UEMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___UEMeasurementInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___UEMeasurementInitiationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___UEMeasurementInitiationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UEMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab = ____UEMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___UEMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementInitiationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UEMeasurementInitiationResponse_protocolIEs__item__value._const_tab = ____UEMeasurementInitiationResponse_protocolIEs__item__id_tab
    ___UEMeasurementInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __UEMeasurementInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementInitiationResponse_protocolIEs__item__id),
        (u'criticality', ___UEMeasurementInitiationResponse_protocolIEs__item__criticality),
        (u'value', ___UEMeasurementInitiationResponse_protocolIEs__item__value),
        ])
    __UEMeasurementInitiationResponse_protocolIEs__item_._ext = None
    _UEMeasurementInitiationResponse_protocolIEs._cont = __UEMeasurementInitiationResponse_protocolIEs__item_
    _UEMeasurementInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEMeasurementInitiationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementInitiationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationResponse_protocolExtensions__item__id._const_tab = ____UEMeasurementInitiationResponse_protocolExtensions__item__id_tab
    ___UEMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___UEMeasurementInitiationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___UEMeasurementInitiationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementInitiationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementInitiationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab = ____UEMeasurementInitiationResponse_protocolExtensions__item__criticality_tab
    ___UEMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue_tab
    ___UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementInitiationResponse_protocolExtensions__item__id),
        (u'criticality', ___UEMeasurementInitiationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __UEMeasurementInitiationResponse_protocolExtensions__item_._ext = None
    _UEMeasurementInitiationResponse_protocolExtensions._cont = __UEMeasurementInitiationResponse_protocolExtensions__item_
    _UEMeasurementInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementInitiationResponse._cont = ASN1Dict([
        (u'protocolIEs', _UEMeasurementInitiationResponse_protocolIEs),
        (u'protocolExtensions', _UEMeasurementInitiationResponse_protocolExtensions),
        ])
    UEMeasurementInitiationResponse._ext = []
    
    #-----< UEMeasurementInitiationResponse-IEs >-----#
    UEMeasurementInitiationResponse_IEs = CLASS(name=u'UEMeasurementInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UEMeasurementInitiationResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _UEMeasurementInitiationResponse_IEs_val_Value_1 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementFilterCoefficient')))
    _UEMeasurementInitiationResponse_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementReportCharacteristics')))
    _UEMeasurementInitiationResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    UEMeasurementInitiationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _UEMeasurementInitiationResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 92), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationResponse_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 543), (u'criticality', u'reject'), (u'Value', _UEMeasurementInitiationResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _UEMeasurementInitiationResponse_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementInitiationResponse-Extensions >-----#
    UEMeasurementInitiationResponse_Extensions = CLASS(name=u'UEMeasurementInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementInitiationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementInitiationFailure >-----#
    UEMeasurementInitiationFailure = SEQ(name=u'UEMeasurementInitiationFailure', mode=MODE_TYPE)
    _UEMeasurementInitiationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UEMeasurementInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UEMeasurementInitiationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UEMeasurementInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____UEMeasurementInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationFailure_protocolIEs__item__id._const_tab = ____UEMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___UEMeasurementInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___UEMeasurementInitiationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___UEMeasurementInitiationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UEMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab = ____UEMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___UEMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementInitiationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UEMeasurementInitiationFailure_protocolIEs__item__value._const_tab = ____UEMeasurementInitiationFailure_protocolIEs__item__id_tab
    ___UEMeasurementInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __UEMeasurementInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementInitiationFailure_protocolIEs__item__id),
        (u'criticality', ___UEMeasurementInitiationFailure_protocolIEs__item__criticality),
        (u'value', ___UEMeasurementInitiationFailure_protocolIEs__item__value),
        ])
    __UEMeasurementInitiationFailure_protocolIEs__item_._ext = None
    _UEMeasurementInitiationFailure_protocolIEs._cont = __UEMeasurementInitiationFailure_protocolIEs__item_
    _UEMeasurementInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEMeasurementInitiationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementInitiationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationFailure_protocolExtensions__item__id._const_tab = ____UEMeasurementInitiationFailure_protocolExtensions__item__id_tab
    ___UEMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___UEMeasurementInitiationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___UEMeasurementInitiationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab = ____UEMeasurementInitiationFailure_protocolExtensions__item__criticality_tab
    ___UEMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementInitiationFailure_protocolExtensions__item__id),
        (u'criticality', ___UEMeasurementInitiationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __UEMeasurementInitiationFailure_protocolExtensions__item_._ext = None
    _UEMeasurementInitiationFailure_protocolExtensions._cont = __UEMeasurementInitiationFailure_protocolExtensions__item_
    _UEMeasurementInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementInitiationFailure._cont = ASN1Dict([
        (u'protocolIEs', _UEMeasurementInitiationFailure_protocolIEs),
        (u'protocolExtensions', _UEMeasurementInitiationFailure_protocolExtensions),
        ])
    UEMeasurementInitiationFailure._ext = []
    
    #-----< UEMeasurementInitiationFailure-IEs >-----#
    UEMeasurementInitiationFailure_IEs = CLASS(name=u'UEMeasurementInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UEMeasurementInitiationFailure_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _UEMeasurementInitiationFailure_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _UEMeasurementInitiationFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    UEMeasurementInitiationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _UEMeasurementInitiationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _UEMeasurementInitiationFailure_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _UEMeasurementInitiationFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementInitiationFailure-Extensions >-----#
    UEMeasurementInitiationFailure_Extensions = CLASS(name=u'UEMeasurementInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementInitiationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReport >-----#
    UEMeasurementReport = SEQ(name=u'UEMeasurementReport', mode=MODE_TYPE)
    _UEMeasurementReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UEMeasurementReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UEMeasurementReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UEMeasurementReport_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UEMeasurementReport_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____UEMeasurementReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueInformation')))
    ____UEMeasurementReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 545), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementReport_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEMeasurementReport_protocolIEs__item__id._const_tab = ____UEMeasurementReport_protocolIEs__item__id_tab
    ___UEMeasurementReport_protocolIEs__item__id._const_tab_at = None
    ___UEMeasurementReport_protocolIEs__item__id._const_tab_id = u'id'
    ___UEMeasurementReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UEMeasurementReport_protocolIEs__item__criticality._const_tab = ____UEMeasurementReport_protocolIEs__item__id_tab
    ___UEMeasurementReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UEMeasurementReport_protocolIEs__item__value._const_tab = ____UEMeasurementReport_protocolIEs__item__id_tab
    ___UEMeasurementReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEMeasurementReport_protocolIEs__item__value._const_tab_id = u'Value'
    __UEMeasurementReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReport_protocolIEs__item__id),
        (u'criticality', ___UEMeasurementReport_protocolIEs__item__criticality),
        (u'value', ___UEMeasurementReport_protocolIEs__item__value),
        ])
    __UEMeasurementReport_protocolIEs__item_._ext = None
    _UEMeasurementReport_protocolIEs._cont = __UEMeasurementReport_protocolIEs__item_
    _UEMeasurementReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEMeasurementReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReport_protocolExtensions__item__id._const_tab = ____UEMeasurementReport_protocolExtensions__item__id_tab
    ___UEMeasurementReport_protocolExtensions__item__id._const_tab_at = None
    ___UEMeasurementReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___UEMeasurementReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReport_protocolExtensions__item__criticality._const_tab = ____UEMeasurementReport_protocolExtensions__item__criticality_tab
    ___UEMeasurementReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementReport_protocolExtensions__item__extensionValue._const_tab = ____UEMeasurementReport_protocolExtensions__item__extensionValue_tab
    ___UEMeasurementReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementReport_protocolExtensions__item__id),
        (u'criticality', ___UEMeasurementReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___UEMeasurementReport_protocolExtensions__item__extensionValue),
        ])
    __UEMeasurementReport_protocolExtensions__item_._ext = None
    _UEMeasurementReport_protocolExtensions._cont = __UEMeasurementReport_protocolExtensions__item_
    _UEMeasurementReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementReport._cont = ASN1Dict([
        (u'protocolIEs', _UEMeasurementReport_protocolIEs),
        (u'protocolExtensions', _UEMeasurementReport_protocolExtensions),
        ])
    UEMeasurementReport._ext = []
    
    #-----< UEMeasurementReport-IEs >-----#
    UEMeasurementReport_IEs = CLASS(name=u'UEMeasurementReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UEMeasurementReport_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _UEMeasurementReport_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEMeasurementValueInformation')))
    UEMeasurementReport_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _UEMeasurementReport_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 545), (u'criticality', u'ignore'), (u'Value', _UEMeasurementReport_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementReport-Extensions >-----#
    UEMeasurementReport_Extensions = CLASS(name=u'UEMeasurementReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementReport_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementTerminationRequest >-----#
    UEMeasurementTerminationRequest = SEQ(name=u'UEMeasurementTerminationRequest', mode=MODE_TYPE)
    _UEMeasurementTerminationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UEMeasurementTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UEMeasurementTerminationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UEMeasurementTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UEMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    ____UEMeasurementTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEMeasurementTerminationRequest_protocolIEs__item__id._const_tab = ____UEMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___UEMeasurementTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___UEMeasurementTerminationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___UEMeasurementTerminationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UEMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab = ____UEMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___UEMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementTerminationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementTerminationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UEMeasurementTerminationRequest_protocolIEs__item__value._const_tab = ____UEMeasurementTerminationRequest_protocolIEs__item__id_tab
    ___UEMeasurementTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEMeasurementTerminationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __UEMeasurementTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementTerminationRequest_protocolIEs__item__id),
        (u'criticality', ___UEMeasurementTerminationRequest_protocolIEs__item__criticality),
        (u'value', ___UEMeasurementTerminationRequest_protocolIEs__item__value),
        ])
    __UEMeasurementTerminationRequest_protocolIEs__item_._ext = None
    _UEMeasurementTerminationRequest_protocolIEs._cont = __UEMeasurementTerminationRequest_protocolIEs__item_
    _UEMeasurementTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEMeasurementTerminationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementTerminationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTerminationRequest_protocolExtensions__item__id._const_tab = ____UEMeasurementTerminationRequest_protocolExtensions__item__id_tab
    ___UEMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___UEMeasurementTerminationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___UEMeasurementTerminationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab = ____UEMeasurementTerminationRequest_protocolExtensions__item__criticality_tab
    ___UEMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementTerminationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementTerminationRequest_protocolExtensions__item__id),
        (u'criticality', ___UEMeasurementTerminationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __UEMeasurementTerminationRequest_protocolExtensions__item_._ext = None
    _UEMeasurementTerminationRequest_protocolExtensions._cont = __UEMeasurementTerminationRequest_protocolExtensions__item_
    _UEMeasurementTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementTerminationRequest._cont = ASN1Dict([
        (u'protocolIEs', _UEMeasurementTerminationRequest_protocolIEs),
        (u'protocolExtensions', _UEMeasurementTerminationRequest_protocolExtensions),
        ])
    UEMeasurementTerminationRequest._ext = []
    
    #-----< UEMeasurementTerminationRequest-IEs >-----#
    UEMeasurementTerminationRequest_IEs = CLASS(name=u'UEMeasurementTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UEMeasurementTerminationRequest_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    UEMeasurementTerminationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _UEMeasurementTerminationRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementTerminationRequest-Extensions >-----#
    UEMeasurementTerminationRequest_Extensions = CLASS(name=u'UEMeasurementTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementFailureIndication >-----#
    UEMeasurementFailureIndication = SEQ(name=u'UEMeasurementFailureIndication', mode=MODE_TYPE)
    _UEMeasurementFailureIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __UEMeasurementFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___UEMeasurementFailureIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____UEMeasurementFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____UEMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _____UEMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    ____UEMeasurementFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____UEMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___UEMeasurementFailureIndication_protocolIEs__item__id._const_tab = ____UEMeasurementFailureIndication_protocolIEs__item__id_tab
    ___UEMeasurementFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___UEMeasurementFailureIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___UEMeasurementFailureIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___UEMeasurementFailureIndication_protocolIEs__item__criticality._const_tab = ____UEMeasurementFailureIndication_protocolIEs__item__id_tab
    ___UEMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementFailureIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementFailureIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___UEMeasurementFailureIndication_protocolIEs__item__value._const_tab = ____UEMeasurementFailureIndication_protocolIEs__item__id_tab
    ___UEMeasurementFailureIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___UEMeasurementFailureIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __UEMeasurementFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementFailureIndication_protocolIEs__item__id),
        (u'criticality', ___UEMeasurementFailureIndication_protocolIEs__item__criticality),
        (u'value', ___UEMeasurementFailureIndication_protocolIEs__item__value),
        ])
    __UEMeasurementFailureIndication_protocolIEs__item_._ext = None
    _UEMeasurementFailureIndication_protocolIEs._cont = __UEMeasurementFailureIndication_protocolIEs__item_
    _UEMeasurementFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UEMeasurementFailureIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UEMeasurementFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___UEMeasurementFailureIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____UEMeasurementFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementFailureIndication_protocolExtensions__item__id._const_tab = ____UEMeasurementFailureIndication_protocolExtensions__item__id_tab
    ___UEMeasurementFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___UEMeasurementFailureIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___UEMeasurementFailureIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____UEMeasurementFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab = ____UEMeasurementFailureIndication_protocolExtensions__item__criticality_tab
    ___UEMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___UEMeasurementFailureIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___UEMeasurementFailureIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____UEMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____UEMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UEMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____UEMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab
    ___UEMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___UEMeasurementFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __UEMeasurementFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___UEMeasurementFailureIndication_protocolExtensions__item__id),
        (u'criticality', ___UEMeasurementFailureIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___UEMeasurementFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __UEMeasurementFailureIndication_protocolExtensions__item_._ext = None
    _UEMeasurementFailureIndication_protocolExtensions._cont = __UEMeasurementFailureIndication_protocolExtensions__item_
    _UEMeasurementFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UEMeasurementFailureIndication._cont = ASN1Dict([
        (u'protocolIEs', _UEMeasurementFailureIndication_protocolIEs),
        (u'protocolExtensions', _UEMeasurementFailureIndication_protocolExtensions),
        ])
    UEMeasurementFailureIndication._ext = []
    
    #-----< UEMeasurementFailureIndication-IEs >-----#
    UEMeasurementFailureIndication_IEs = CLASS(name=u'UEMeasurementFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _UEMeasurementFailureIndication_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MeasurementID')))
    _UEMeasurementFailureIndication_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    UEMeasurementFailureIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 93), (u'criticality', u'ignore'), (u'Value', _UEMeasurementFailureIndication_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _UEMeasurementFailureIndication_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UEMeasurementFailureIndication-Extensions >-----#
    UEMeasurementFailureIndication_Extensions = CLASS(name=u'UEMeasurementFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    UEMeasurementFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IurInvokeTrace >-----#
    IurInvokeTrace = SEQ(name=u'IurInvokeTrace', mode=MODE_TYPE)
    _IurInvokeTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __IurInvokeTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___IurInvokeTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____IurInvokeTrace_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceReference')))
    _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEIdentity')))
    _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceRecordingSessionReference')))
    _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ListOfInterfacesToTrace')))
    _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceDepth')))
    ____IurInvokeTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 550), (u'criticality', u'ignore'), (u'Value', _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 551), (u'criticality', u'ignore'), (u'Value', _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 549), (u'criticality', u'ignore'), (u'Value', _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 547), (u'criticality', u'ignore'), (u'Value', _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 548), (u'criticality', u'ignore'), (u'Value', _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___IurInvokeTrace_protocolIEs__item__id._const_tab = ____IurInvokeTrace_protocolIEs__item__id_tab
    ___IurInvokeTrace_protocolIEs__item__id._const_tab_at = None
    ___IurInvokeTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___IurInvokeTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___IurInvokeTrace_protocolIEs__item__criticality._const_tab = ____IurInvokeTrace_protocolIEs__item__id_tab
    ___IurInvokeTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IurInvokeTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IurInvokeTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___IurInvokeTrace_protocolIEs__item__value._const_tab = ____IurInvokeTrace_protocolIEs__item__id_tab
    ___IurInvokeTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IurInvokeTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __IurInvokeTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IurInvokeTrace_protocolIEs__item__id),
        (u'criticality', ___IurInvokeTrace_protocolIEs__item__criticality),
        (u'value', ___IurInvokeTrace_protocolIEs__item__value),
        ])
    __IurInvokeTrace_protocolIEs__item_._ext = None
    _IurInvokeTrace_protocolIEs._cont = __IurInvokeTrace_protocolIEs__item_
    _IurInvokeTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _IurInvokeTrace_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IurInvokeTrace_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___IurInvokeTrace_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IurInvokeTrace_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____IurInvokeTrace_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MDT-Configuration')))
    _____IurInvokeTrace_protocolExtensions__item__id_tab_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    ____IurInvokeTrace_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 894), (u'criticality', u'ignore'), (u'Extension', _____IurInvokeTrace_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 904), (u'criticality', u'ignore'), (u'Extension', _____IurInvokeTrace_protocolExtensions__item__id_tab_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___IurInvokeTrace_protocolExtensions__item__id._const_tab = ____IurInvokeTrace_protocolExtensions__item__id_tab
    ___IurInvokeTrace_protocolExtensions__item__id._const_tab_at = None
    ___IurInvokeTrace_protocolExtensions__item__id._const_tab_id = u'id'
    ___IurInvokeTrace_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___IurInvokeTrace_protocolExtensions__item__criticality._const_tab = ____IurInvokeTrace_protocolExtensions__item__id_tab
    ___IurInvokeTrace_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___IurInvokeTrace_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___IurInvokeTrace_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___IurInvokeTrace_protocolExtensions__item__extensionValue._const_tab = ____IurInvokeTrace_protocolExtensions__item__id_tab
    ___IurInvokeTrace_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IurInvokeTrace_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __IurInvokeTrace_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___IurInvokeTrace_protocolExtensions__item__id),
        (u'criticality', ___IurInvokeTrace_protocolExtensions__item__criticality),
        (u'extensionValue', ___IurInvokeTrace_protocolExtensions__item__extensionValue),
        ])
    __IurInvokeTrace_protocolExtensions__item_._ext = None
    _IurInvokeTrace_protocolExtensions._cont = __IurInvokeTrace_protocolExtensions__item_
    _IurInvokeTrace_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IurInvokeTrace._cont = ASN1Dict([
        (u'protocolIEs', _IurInvokeTrace_protocolIEs),
        (u'protocolExtensions', _IurInvokeTrace_protocolExtensions),
        ])
    IurInvokeTrace._ext = []
    
    #-----< IurInvokeTrace-IEs >-----#
    IurInvokeTrace_IEs = CLASS(name=u'IurInvokeTrace-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _IurInvokeTrace_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _IurInvokeTrace_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceReference')))
    _IurInvokeTrace_IEs_val_Value_2 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UEIdentity')))
    _IurInvokeTrace_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceRecordingSessionReference')))
    _IurInvokeTrace_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ListOfInterfacesToTrace')))
    _IurInvokeTrace_IEs_val_Value_5 = ENUM(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceDepth')))
    IurInvokeTrace_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _IurInvokeTrace_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 550), (u'criticality', u'ignore'), (u'Value', _IurInvokeTrace_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 551), (u'criticality', u'ignore'), (u'Value', _IurInvokeTrace_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 549), (u'criticality', u'ignore'), (u'Value', _IurInvokeTrace_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 547), (u'criticality', u'ignore'), (u'Value', _IurInvokeTrace_IEs_val_Value_4), (u'presence', u'optional')]), dict([(u'id', 548), (u'criticality', u'ignore'), (u'Value', _IurInvokeTrace_IEs_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ListOfInterfacesToTrace >-----#
    ListOfInterfacesToTrace = SEQ_OF(name=u'ListOfInterfacesToTrace', mode=MODE_TYPE)
    _ListOfInterfacesToTrace__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Single-Container')))
    __ListOfInterfacesToTrace__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ___ListOfInterfacesToTrace__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____ListOfInterfacesToTrace__item__id_tab_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InterfacesToTraceItem')))
    ___ListOfInterfacesToTrace__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 546), (u'criticality', u'ignore'), (u'Value', ____ListOfInterfacesToTrace__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    __ListOfInterfacesToTrace__item__id._const_tab = ___ListOfInterfacesToTrace__item__id_tab
    __ListOfInterfacesToTrace__item__id._const_tab_at = None
    __ListOfInterfacesToTrace__item__id._const_tab_id = u'id'
    __ListOfInterfacesToTrace__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    __ListOfInterfacesToTrace__item__criticality._const_tab = ___ListOfInterfacesToTrace__item__id_tab
    __ListOfInterfacesToTrace__item__criticality._const_tab_at = ('..', u'id')
    __ListOfInterfacesToTrace__item__criticality._const_tab_id = u'criticality'
    __ListOfInterfacesToTrace__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    __ListOfInterfacesToTrace__item__value._const_tab = ___ListOfInterfacesToTrace__item__id_tab
    __ListOfInterfacesToTrace__item__value._const_tab_at = ('..', u'id')
    __ListOfInterfacesToTrace__item__value._const_tab_id = u'Value'
    _ListOfInterfacesToTrace__item_._cont = ASN1Dict([
        (u'id', __ListOfInterfacesToTrace__item__id),
        (u'criticality', __ListOfInterfacesToTrace__item__criticality),
        (u'value', __ListOfInterfacesToTrace__item__value),
        ])
    _ListOfInterfacesToTrace__item_._ext = None
    ListOfInterfacesToTrace._cont = _ListOfInterfacesToTrace__item_
    ListOfInterfacesToTrace._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< InterfacesToBeTracedItemIE >-----#
    InterfacesToBeTracedItemIE = CLASS(name=u'InterfacesToBeTracedItemIE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InterfacesToBeTracedItemIE_val_Value_0 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InterfacesToTraceItem')))
    InterfacesToBeTracedItemIE._val = ASN1Set(rv=[dict([(u'id', 546), (u'criticality', u'ignore'), (u'Value', _InterfacesToBeTracedItemIE_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< InterfacesToTraceItem >-----#
    InterfacesToTraceItem = SEQ(name=u'InterfacesToTraceItem', mode=MODE_TYPE)
    _InterfacesToTraceItem_interface = ENUM(name=u'interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterfacesToTraceItem_interface._cont = ASN1Dict([(u'iub', 0), (u'iur', 1)])
    _InterfacesToTraceItem_interface._ext = []
    _InterfacesToTraceItem_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterfacesToTraceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InterfacesToTraceItem_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InterfacesToTraceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__id_tab
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab_at = None
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab_id = u'id'
    ___InterfacesToTraceItem_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __InterfacesToTraceItem_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___InterfacesToTraceItem_iE_Extensions__item__id),
        (u'criticality', ___InterfacesToTraceItem_iE_Extensions__item__criticality),
        (u'extensionValue', ___InterfacesToTraceItem_iE_Extensions__item__extensionValue),
        ])
    __InterfacesToTraceItem_iE_Extensions__item_._ext = None
    _InterfacesToTraceItem_iE_Extensions._cont = __InterfacesToTraceItem_iE_Extensions__item_
    _InterfacesToTraceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterfacesToTraceItem._cont = ASN1Dict([
        (u'interface', _InterfacesToTraceItem_interface),
        (u'iE-Extensions', _InterfacesToTraceItem_iE_Extensions),
        ])
    InterfacesToTraceItem._ext = []
    
    #-----< InterfacesToTraceItem-ExtIEs >-----#
    InterfacesToTraceItem_ExtIEs = CLASS(name=u'InterfacesToTraceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InterfacesToTraceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IurInvokeTrace-Extensions >-----#
    IurInvokeTrace_Extensions = CLASS(name=u'IurInvokeTrace-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _IurInvokeTrace_Extensions_val_Extension_0 = SEQ(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MDT-Configuration')))
    _IurInvokeTrace_Extensions_val_Extension_1 = BIT_STR(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TransportLayerAddress')))
    IurInvokeTrace_Extensions._val = ASN1Set(rv=[dict([(u'id', 894), (u'criticality', u'ignore'), (u'Extension', _IurInvokeTrace_Extensions_val_Extension_0), (u'presence', u'optional')]), dict([(u'id', 904), (u'criticality', u'ignore'), (u'Extension', _IurInvokeTrace_Extensions_val_Extension_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< IurDeactivateTrace >-----#
    IurDeactivateTrace = SEQ(name=u'IurDeactivateTrace', mode=MODE_TYPE)
    _IurDeactivateTrace_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __IurDeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___IurDeactivateTrace_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____IurDeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____IurDeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____IurDeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceReference')))
    ____IurDeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____IurDeactivateTrace_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 550), (u'criticality', u'ignore'), (u'Value', _____IurDeactivateTrace_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___IurDeactivateTrace_protocolIEs__item__id._const_tab = ____IurDeactivateTrace_protocolIEs__item__id_tab
    ___IurDeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___IurDeactivateTrace_protocolIEs__item__id._const_tab_id = u'id'
    ___IurDeactivateTrace_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___IurDeactivateTrace_protocolIEs__item__criticality._const_tab = ____IurDeactivateTrace_protocolIEs__item__id_tab
    ___IurDeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___IurDeactivateTrace_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___IurDeactivateTrace_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___IurDeactivateTrace_protocolIEs__item__value._const_tab = ____IurDeactivateTrace_protocolIEs__item__id_tab
    ___IurDeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___IurDeactivateTrace_protocolIEs__item__value._const_tab_id = u'Value'
    __IurDeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___IurDeactivateTrace_protocolIEs__item__id),
        (u'criticality', ___IurDeactivateTrace_protocolIEs__item__criticality),
        (u'value', ___IurDeactivateTrace_protocolIEs__item__value),
        ])
    __IurDeactivateTrace_protocolIEs__item_._ext = None
    _IurDeactivateTrace_protocolIEs._cont = __IurDeactivateTrace_protocolIEs__item_
    _IurDeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _IurDeactivateTrace_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IurDeactivateTrace_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___IurDeactivateTrace_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____IurDeactivateTrace_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IurDeactivateTrace_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurDeactivateTrace_protocolExtensions__item__id._const_tab = ____IurDeactivateTrace_protocolExtensions__item__id_tab
    ___IurDeactivateTrace_protocolExtensions__item__id._const_tab_at = None
    ___IurDeactivateTrace_protocolExtensions__item__id._const_tab_id = u'id'
    ___IurDeactivateTrace_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____IurDeactivateTrace_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IurDeactivateTrace_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurDeactivateTrace_protocolExtensions__item__criticality._const_tab = ____IurDeactivateTrace_protocolExtensions__item__criticality_tab
    ___IurDeactivateTrace_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___IurDeactivateTrace_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___IurDeactivateTrace_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____IurDeactivateTrace_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____IurDeactivateTrace_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IurDeactivateTrace_protocolExtensions__item__extensionValue._const_tab = ____IurDeactivateTrace_protocolExtensions__item__extensionValue_tab
    ___IurDeactivateTrace_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___IurDeactivateTrace_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __IurDeactivateTrace_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___IurDeactivateTrace_protocolExtensions__item__id),
        (u'criticality', ___IurDeactivateTrace_protocolExtensions__item__criticality),
        (u'extensionValue', ___IurDeactivateTrace_protocolExtensions__item__extensionValue),
        ])
    __IurDeactivateTrace_protocolExtensions__item_._ext = None
    _IurDeactivateTrace_protocolExtensions._cont = __IurDeactivateTrace_protocolExtensions__item_
    _IurDeactivateTrace_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IurDeactivateTrace._cont = ASN1Dict([
        (u'protocolIEs', _IurDeactivateTrace_protocolIEs),
        (u'protocolExtensions', _IurDeactivateTrace_protocolExtensions),
        ])
    IurDeactivateTrace._ext = []
    
    #-----< IurDeactivateTrace-IEs >-----#
    IurDeactivateTrace_IEs = CLASS(name=u'IurDeactivateTrace-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _IurDeactivateTrace_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _IurDeactivateTrace_IEs_val_Value_1 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TraceReference')))
    IurDeactivateTrace_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _IurDeactivateTrace_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 550), (u'criticality', u'ignore'), (u'Value', _IurDeactivateTrace_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< IurDeactivateTrace-Extensions >-----#
    IurDeactivateTrace_Extensions = CLASS(name=u'IurDeactivateTrace-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    IurDeactivateTrace_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSAttachCommand >-----#
    MBMSAttachCommand = SEQ(name=u'MBMSAttachCommand', mode=MODE_TYPE)
    _MBMSAttachCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __MBMSAttachCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___MBMSAttachCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____MBMSAttachCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____MBMSAttachCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _____MBMSAttachCommand_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-State')))
    ____MBMSAttachCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 560), (u'criticality', u'ignore'), (u'Value', _____MBMSAttachCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 568), (u'criticality', u'ignore'), (u'Value', _____MBMSAttachCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSAttachCommand_protocolIEs__item__id._const_tab = ____MBMSAttachCommand_protocolIEs__item__id_tab
    ___MBMSAttachCommand_protocolIEs__item__id._const_tab_at = None
    ___MBMSAttachCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSAttachCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSAttachCommand_protocolIEs__item__criticality._const_tab = ____MBMSAttachCommand_protocolIEs__item__id_tab
    ___MBMSAttachCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSAttachCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSAttachCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSAttachCommand_protocolIEs__item__value._const_tab = ____MBMSAttachCommand_protocolIEs__item__id_tab
    ___MBMSAttachCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSAttachCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSAttachCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSAttachCommand_protocolIEs__item__id),
        (u'criticality', ___MBMSAttachCommand_protocolIEs__item__criticality),
        (u'value', ___MBMSAttachCommand_protocolIEs__item__value),
        ])
    __MBMSAttachCommand_protocolIEs__item_._ext = None
    _MBMSAttachCommand_protocolIEs._cont = __MBMSAttachCommand_protocolIEs__item_
    _MBMSAttachCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSAttachCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSAttachCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMSAttachCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSAttachCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSAttachCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSAttachCommand_protocolExtensions__item__id._const_tab = ____MBMSAttachCommand_protocolExtensions__item__id_tab
    ___MBMSAttachCommand_protocolExtensions__item__id._const_tab_at = None
    ___MBMSAttachCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSAttachCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSAttachCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSAttachCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSAttachCommand_protocolExtensions__item__criticality._const_tab = ____MBMSAttachCommand_protocolExtensions__item__criticality_tab
    ___MBMSAttachCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSAttachCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSAttachCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSAttachCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSAttachCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSAttachCommand_protocolExtensions__item__extensionValue._const_tab = ____MBMSAttachCommand_protocolExtensions__item__extensionValue_tab
    ___MBMSAttachCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSAttachCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSAttachCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSAttachCommand_protocolExtensions__item__id),
        (u'criticality', ___MBMSAttachCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSAttachCommand_protocolExtensions__item__extensionValue),
        ])
    __MBMSAttachCommand_protocolExtensions__item_._ext = None
    _MBMSAttachCommand_protocolExtensions._cont = __MBMSAttachCommand_protocolExtensions__item_
    _MBMSAttachCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSAttachCommand._cont = ASN1Dict([
        (u'protocolIEs', _MBMSAttachCommand_protocolIEs),
        (u'protocolExtensions', _MBMSAttachCommand_protocolExtensions),
        ])
    MBMSAttachCommand._ext = []
    
    #-----< MBMSAttachCommand-IEs >-----#
    MBMSAttachCommand_IEs = CLASS(name=u'MBMSAttachCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _MBMSAttachCommand_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _MBMSAttachCommand_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-State')))
    MBMSAttachCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 560), (u'criticality', u'ignore'), (u'Value', _MBMSAttachCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 568), (u'criticality', u'ignore'), (u'Value', _MBMSAttachCommand_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSAttachCommand-Extensions >-----#
    MBMSAttachCommand_Extensions = CLASS(name=u'MBMSAttachCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMSAttachCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSDetachCommand >-----#
    MBMSDetachCommand = SEQ(name=u'MBMSDetachCommand', mode=MODE_TYPE)
    _MBMSDetachCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __MBMSDetachCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___MBMSDetachCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____MBMSDetachCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____MBMSDetachCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _____MBMSDetachCommand_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-State')))
    ____MBMSDetachCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 560), (u'criticality', u'ignore'), (u'Value', _____MBMSDetachCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 568), (u'criticality', u'ignore'), (u'Value', _____MBMSDetachCommand_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBMSDetachCommand_protocolIEs__item__id._const_tab = ____MBMSDetachCommand_protocolIEs__item__id_tab
    ___MBMSDetachCommand_protocolIEs__item__id._const_tab_at = None
    ___MBMSDetachCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___MBMSDetachCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___MBMSDetachCommand_protocolIEs__item__criticality._const_tab = ____MBMSDetachCommand_protocolIEs__item__id_tab
    ___MBMSDetachCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSDetachCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBMSDetachCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___MBMSDetachCommand_protocolIEs__item__value._const_tab = ____MBMSDetachCommand_protocolIEs__item__id_tab
    ___MBMSDetachCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBMSDetachCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __MBMSDetachCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBMSDetachCommand_protocolIEs__item__id),
        (u'criticality', ___MBMSDetachCommand_protocolIEs__item__criticality),
        (u'value', ___MBMSDetachCommand_protocolIEs__item__value),
        ])
    __MBMSDetachCommand_protocolIEs__item_._ext = None
    _MBMSDetachCommand_protocolIEs._cont = __MBMSDetachCommand_protocolIEs__item_
    _MBMSDetachCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSDetachCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSDetachCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBMSDetachCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBMSDetachCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSDetachCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSDetachCommand_protocolExtensions__item__id._const_tab = ____MBMSDetachCommand_protocolExtensions__item__id_tab
    ___MBMSDetachCommand_protocolExtensions__item__id._const_tab_at = None
    ___MBMSDetachCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBMSDetachCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBMSDetachCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSDetachCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSDetachCommand_protocolExtensions__item__criticality._const_tab = ____MBMSDetachCommand_protocolExtensions__item__criticality_tab
    ___MBMSDetachCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBMSDetachCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBMSDetachCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBMSDetachCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBMSDetachCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSDetachCommand_protocolExtensions__item__extensionValue._const_tab = ____MBMSDetachCommand_protocolExtensions__item__extensionValue_tab
    ___MBMSDetachCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBMSDetachCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBMSDetachCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBMSDetachCommand_protocolExtensions__item__id),
        (u'criticality', ___MBMSDetachCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBMSDetachCommand_protocolExtensions__item__extensionValue),
        ])
    __MBMSDetachCommand_protocolExtensions__item_._ext = None
    _MBMSDetachCommand_protocolExtensions._cont = __MBMSDetachCommand_protocolExtensions__item_
    _MBMSDetachCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSDetachCommand._cont = ASN1Dict([
        (u'protocolIEs', _MBMSDetachCommand_protocolIEs),
        (u'protocolExtensions', _MBMSDetachCommand_protocolExtensions),
        ])
    MBMSDetachCommand._ext = []
    
    #-----< MBMSDetachCommand-IEs >-----#
    MBMSDetachCommand_IEs = CLASS(name=u'MBMSDetachCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _MBMSDetachCommand_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBMS-Bearer-Service-List')))
    _MBMSDetachCommand_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'UE-State')))
    MBMSDetachCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 560), (u'criticality', u'ignore'), (u'Value', _MBMSDetachCommand_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 568), (u'criticality', u'ignore'), (u'Value', _MBMSDetachCommand_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSDetachCommand-Extensions >-----#
    MBMSDetachCommand_Extensions = CLASS(name=u'MBMSDetachCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBMSDetachCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DirectInformationTransfer >-----#
    DirectInformationTransfer = SEQ(name=u'DirectInformationTransfer', mode=MODE_TYPE)
    _DirectInformationTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __DirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___DirectInformationTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____DirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ProvidedInformation')))
    ____DirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 597), (u'criticality', u'ignore'), (u'Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___DirectInformationTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___DirectInformationTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __DirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___DirectInformationTransfer_protocolIEs__item__id),
        (u'criticality', ___DirectInformationTransfer_protocolIEs__item__criticality),
        (u'value', ___DirectInformationTransfer_protocolIEs__item__value),
        ])
    __DirectInformationTransfer_protocolIEs__item_._ext = None
    _DirectInformationTransfer_protocolIEs._cont = __DirectInformationTransfer_protocolIEs__item_
    _DirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectInformationTransfer_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectInformationTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___DirectInformationTransfer_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____DirectInformationTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    ____DirectInformationTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab_id = u'id'
    ___DirectInformationTransfer_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __DirectInformationTransfer_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___DirectInformationTransfer_protocolExtensions__item__id),
        (u'criticality', ___DirectInformationTransfer_protocolExtensions__item__criticality),
        (u'extensionValue', ___DirectInformationTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectInformationTransfer_protocolExtensions__item_._ext = None
    _DirectInformationTransfer_protocolExtensions._cont = __DirectInformationTransfer_protocolExtensions__item_
    _DirectInformationTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectInformationTransfer._cont = ASN1Dict([
        (u'protocolIEs', _DirectInformationTransfer_protocolIEs),
        (u'protocolExtensions', _DirectInformationTransfer_protocolExtensions),
        ])
    DirectInformationTransfer._ext = []
    
    #-----< DirectInformationTransfer-IEs >-----#
    DirectInformationTransfer_IEs = CLASS(name=u'DirectInformationTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _DirectInformationTransfer_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _DirectInformationTransfer_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ProvidedInformation')))
    DirectInformationTransfer_IEs._val = ASN1Set(rv=[dict([(u'id', 245), (u'criticality', u'ignore'), (u'Value', _DirectInformationTransfer_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 597), (u'criticality', u'ignore'), (u'Value', _DirectInformationTransfer_IEs_val_Value_1), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DirectInformationTransfer-Extensions >-----#
    DirectInformationTransfer_Extensions = CLASS(name=u'DirectInformationTransfer-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _DirectInformationTransfer_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    DirectInformationTransfer_Extensions._val = ASN1Set(rv=[dict([(u'id', 683), (u'criticality', u'reject'), (u'Extension', _DirectInformationTransfer_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationRequest >-----#
    EnhancedRelocationRequest = SEQ(name=u'EnhancedRelocationRequest', mode=MODE_TYPE)
    _EnhancedRelocationRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RANAP-EnhancedRelocationInformationRequest')))
    ____EnhancedRelocationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 750), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationRequest_protocolIEs__item__id._const_tab = ____EnhancedRelocationRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationRequest_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationRequest_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationRequest_protocolIEs__item__value._const_tab = ____EnhancedRelocationRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationRequest_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationRequest_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationRequest_protocolIEs__item__value),
        ])
    __EnhancedRelocationRequest_protocolIEs__item_._ext = None
    _EnhancedRelocationRequest_protocolIEs._cont = __EnhancedRelocationRequest_protocolIEs__item_
    _EnhancedRelocationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _____EnhancedRelocationRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    ____EnhancedRelocationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'reject'), (u'Extension', _____EnhancedRelocationRequest_protocolExtensions__item__id_tab_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationRequest_protocolExtensions__item__id._const_tab = ____EnhancedRelocationRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationRequest_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ___EnhancedRelocationRequest_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ___EnhancedRelocationRequest_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationRequest_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationRequest_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationRequest_protocolExtensions__item_._ext = None
    _EnhancedRelocationRequest_protocolExtensions._cont = __EnhancedRelocationRequest_protocolExtensions__item_
    _EnhancedRelocationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationRequest._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationRequest_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationRequest_protocolExtensions),
        ])
    EnhancedRelocationRequest._ext = []
    
    #-----< EnhancedRelocationRequest-IEs >-----#
    EnhancedRelocationRequest_IEs = CLASS(name=u'EnhancedRelocationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationRequest_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _EnhancedRelocationRequest_IEs_val_Value_1 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Permanent-NAS-UE-Identity')))
    _EnhancedRelocationRequest_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RNC-ID')))
    _EnhancedRelocationRequest_IEs_val_Value_3 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNC-ID')))
    _EnhancedRelocationRequest_IEs_val_Value_4 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'S-RNTI')))
    _EnhancedRelocationRequest_IEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RANAP-EnhancedRelocationInformationRequest')))
    EnhancedRelocationRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationRequest_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 17), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 157), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationRequest_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 682), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationRequest_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 155), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 750), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationRequest_IEs_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationRequest-Extensions >-----#
    EnhancedRelocationRequest_Extensions = CLASS(name=u'EnhancedRelocationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    _EnhancedRelocationRequest_Extensions_val_Extension_0 = INT(name=u'Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Extended-RNTI')))
    EnhancedRelocationRequest_Extensions._val = ASN1Set(rv=[dict([(u'id', 914), (u'criticality', u'reject'), (u'Extension', _EnhancedRelocationRequest_Extensions_val_Extension_0), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResponse >-----#
    EnhancedRelocationResponse = SEQ(name=u'EnhancedRelocationResponse', mode=MODE_TYPE)
    _EnhancedRelocationResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RANAP-EnhancedRelocationInformationResponse')))
    ____EnhancedRelocationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 751), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationResponse_protocolIEs__item__id._const_tab = ____EnhancedRelocationResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationResponse_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationResponse_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationResponse_protocolIEs__item__value._const_tab = ____EnhancedRelocationResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResponse_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationResponse_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationResponse_protocolIEs__item__value),
        ])
    __EnhancedRelocationResponse_protocolIEs__item_._ext = None
    _EnhancedRelocationResponse_protocolIEs._cont = __EnhancedRelocationResponse_protocolIEs__item_
    _EnhancedRelocationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResponse_protocolExtensions__item__id._const_tab = ____EnhancedRelocationResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationResponse_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResponse_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationResponse_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResponse_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationResponse_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResponse_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationResponse_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationResponse_protocolExtensions__item_._ext = None
    _EnhancedRelocationResponse_protocolExtensions._cont = __EnhancedRelocationResponse_protocolExtensions__item_
    _EnhancedRelocationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationResponse._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationResponse_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationResponse_protocolExtensions),
        ])
    EnhancedRelocationResponse._ext = []
    
    #-----< EnhancedRelocationResponse-IEs >-----#
    EnhancedRelocationResponse_IEs = CLASS(name=u'EnhancedRelocationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationResponse_IEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'RANAP-EnhancedRelocationInformationResponse')))
    EnhancedRelocationResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 751), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResponse_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResponse-Extensions >-----#
    EnhancedRelocationResponse_Extensions = CLASS(name=u'EnhancedRelocationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationFailure >-----#
    EnhancedRelocationFailure = SEQ(name=u'EnhancedRelocationFailure', mode=MODE_TYPE)
    _EnhancedRelocationFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____EnhancedRelocationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    ____EnhancedRelocationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationFailure_protocolIEs__item__id._const_tab = ____EnhancedRelocationFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationFailure_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationFailure_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationFailure_protocolIEs__item__value._const_tab = ____EnhancedRelocationFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationFailure_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationFailure_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationFailure_protocolIEs__item__value),
        ])
    __EnhancedRelocationFailure_protocolIEs__item_._ext = None
    _EnhancedRelocationFailure_protocolIEs._cont = __EnhancedRelocationFailure_protocolIEs__item_
    _EnhancedRelocationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationFailure_protocolExtensions__item__id._const_tab = ____EnhancedRelocationFailure_protocolExtensions__item__id_tab
    ___EnhancedRelocationFailure_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationFailure_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationFailure_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationFailure_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationFailure_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationFailure_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationFailure_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationFailure_protocolExtensions__item_._ext = None
    _EnhancedRelocationFailure_protocolExtensions._cont = __EnhancedRelocationFailure_protocolExtensions__item_
    _EnhancedRelocationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationFailure._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationFailure_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationFailure_protocolExtensions),
        ])
    EnhancedRelocationFailure._ext = []
    
    #-----< EnhancedRelocationFailure-IEs >-----#
    EnhancedRelocationFailure_IEs = CLASS(name=u'EnhancedRelocationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _EnhancedRelocationFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CriticalityDiagnostics')))
    EnhancedRelocationFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 20), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationFailure_IEs_val_Value_1), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationFailure-Extensions >-----#
    EnhancedRelocationFailure_Extensions = CLASS(name=u'EnhancedRelocationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCancel >-----#
    EnhancedRelocationCancel = SEQ(name=u'EnhancedRelocationCancel', mode=MODE_TYPE)
    _EnhancedRelocationCancel_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCancel_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationCancel_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationCancel_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    ____EnhancedRelocationCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationCancel_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCancel_protocolIEs__item__id._const_tab = ____EnhancedRelocationCancel_protocolIEs__item__id_tab
    ___EnhancedRelocationCancel_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCancel_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCancel_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationCancel_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCancel_protocolIEs__item__id_tab
    ___EnhancedRelocationCancel_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCancel_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCancel_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationCancel_protocolIEs__item__value._const_tab = ____EnhancedRelocationCancel_protocolIEs__item__id_tab
    ___EnhancedRelocationCancel_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCancel_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationCancel_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCancel_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationCancel_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationCancel_protocolIEs__item__value),
        ])
    __EnhancedRelocationCancel_protocolIEs__item_._ext = None
    _EnhancedRelocationCancel_protocolIEs._cont = __EnhancedRelocationCancel_protocolIEs__item_
    _EnhancedRelocationCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCancel_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCancel_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCancel_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationCancel_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCancel_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCancel_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCancel_protocolExtensions__item__id_tab
    ___EnhancedRelocationCancel_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCancel_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationCancel_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationCancel_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCancel_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCancel_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCancel_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationCancel_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCancel_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationCancel_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationCancel_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCancel_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCancel_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCancel_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationCancel_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationCancel_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationCancel_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationCancel_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationCancel_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationCancel_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCancel_protocolExtensions__item_._ext = None
    _EnhancedRelocationCancel_protocolExtensions._cont = __EnhancedRelocationCancel_protocolExtensions__item_
    _EnhancedRelocationCancel_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCancel._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationCancel_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationCancel_protocolExtensions),
        ])
    EnhancedRelocationCancel._ext = []
    
    #-----< EnhancedRelocationCancel-IEs >-----#
    EnhancedRelocationCancel_IEs = CLASS(name=u'EnhancedRelocationCancel-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationCancel_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    EnhancedRelocationCancel_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationCancel_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCancel-Extensions >-----#
    EnhancedRelocationCancel_Extensions = CLASS(name=u'EnhancedRelocationCancel-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationCancel_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationSignallingTransfer >-----#
    EnhancedRelocationSignallingTransfer = SEQ(name=u'EnhancedRelocationSignallingTransfer', mode=MODE_TYPE)
    _EnhancedRelocationSignallingTransfer_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationSignallingTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    ____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__id._const_tab = ____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__value._const_tab = ____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationSignallingTransfer_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationSignallingTransfer_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationSignallingTransfer_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationSignallingTransfer_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationSignallingTransfer_protocolIEs__item__value),
        ])
    __EnhancedRelocationSignallingTransfer_protocolIEs__item_._ext = None
    _EnhancedRelocationSignallingTransfer_protocolIEs._cont = __EnhancedRelocationSignallingTransfer_protocolIEs__item_
    _EnhancedRelocationSignallingTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationSignallingTransfer_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationSignallingTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__id._const_tab = ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__id_tab
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationSignallingTransfer_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationSignallingTransfer_protocolExtensions__item_._ext = None
    _EnhancedRelocationSignallingTransfer_protocolExtensions._cont = __EnhancedRelocationSignallingTransfer_protocolExtensions__item_
    _EnhancedRelocationSignallingTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationSignallingTransfer._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationSignallingTransfer_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationSignallingTransfer_protocolExtensions),
        ])
    EnhancedRelocationSignallingTransfer._ext = []
    
    #-----< EnhancedRelocationSignallingTransfer-IEs >-----#
    EnhancedRelocationSignallingTransfer_IEs = CLASS(name=u'EnhancedRelocationSignallingTransfer-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationSignallingTransfer_IEs_val_Value_0 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    EnhancedRelocationSignallingTransfer_IEs._val = ASN1Set(rv=[dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationSignallingTransfer_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationSignallingTransfer-Extensions >-----#
    EnhancedRelocationSignallingTransfer_Extensions = CLASS(name=u'EnhancedRelocationSignallingTransfer-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationSignallingTransfer_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationRelease >-----#
    EnhancedRelocationRelease = SEQ(name=u'EnhancedRelocationRelease', mode=MODE_TYPE)
    _EnhancedRelocationRelease_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationRelease_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationRelease_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationRelease_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationRelease_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Released-CN-Domain')))
    ____EnhancedRelocationRelease_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 755), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationRelease_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationRelease_protocolIEs__item__id._const_tab = ____EnhancedRelocationRelease_protocolIEs__item__id_tab
    ___EnhancedRelocationRelease_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationRelease_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationRelease_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationRelease_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationRelease_protocolIEs__item__id_tab
    ___EnhancedRelocationRelease_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRelease_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationRelease_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationRelease_protocolIEs__item__value._const_tab = ____EnhancedRelocationRelease_protocolIEs__item__id_tab
    ___EnhancedRelocationRelease_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRelease_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationRelease_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationRelease_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationRelease_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationRelease_protocolIEs__item__value),
        ])
    __EnhancedRelocationRelease_protocolIEs__item_._ext = None
    _EnhancedRelocationRelease_protocolIEs._cont = __EnhancedRelocationRelease_protocolIEs__item_
    _EnhancedRelocationRelease_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationRelease_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationRelease_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationRelease_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationRelease_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationRelease_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationRelease_protocolExtensions__item__id._const_tab = ____EnhancedRelocationRelease_protocolExtensions__item__id_tab
    ___EnhancedRelocationRelease_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationRelease_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationRelease_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationRelease_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationRelease_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationRelease_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationRelease_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationRelease_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRelease_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationRelease_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationRelease_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationRelease_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationRelease_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationRelease_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationRelease_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationRelease_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationRelease_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationRelease_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationRelease_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationRelease_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationRelease_protocolExtensions__item_._ext = None
    _EnhancedRelocationRelease_protocolExtensions._cont = __EnhancedRelocationRelease_protocolExtensions__item_
    _EnhancedRelocationRelease_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationRelease._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationRelease_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationRelease_protocolExtensions),
        ])
    EnhancedRelocationRelease._ext = []
    
    #-----< EnhancedRelocationRelease-IEs >-----#
    EnhancedRelocationRelease_IEs = CLASS(name=u'EnhancedRelocationRelease-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationRelease_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Released-CN-Domain')))
    EnhancedRelocationRelease_IEs._val = ASN1Set(rv=[dict([(u'id', 755), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationRelease_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationRelease-Extensions >-----#
    EnhancedRelocationRelease_Extensions = CLASS(name=u'EnhancedRelocationRelease-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationRelease_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSFNMCCHInformation >-----#
    MBSFNMCCHInformation = SEQ(name=u'MBSFNMCCHInformation', mode=MODE_TYPE)
    _MBSFNMCCHInformation_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __MBSFNMCCHInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___MBSFNMCCHInformation_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____MBSFNMCCHInformation_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBSFN-Cluster-Identity')))
    _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MCCH-Message-List')))
    _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MCCH-Configuration-Info')))
    _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBSFN-Scheduling-Transmission-Time-Interval-Info-List')))
    ____MBSFNMCCHInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 769), (u'criticality', u'ignore'), (u'Value', _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 771), (u'criticality', u'reject'), (u'Value', _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 770), (u'criticality', u'ignore'), (u'Value', _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 772), (u'criticality', u'ignore'), (u'Value', _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___MBSFNMCCHInformation_protocolIEs__item__id._const_tab = ____MBSFNMCCHInformation_protocolIEs__item__id_tab
    ___MBSFNMCCHInformation_protocolIEs__item__id._const_tab_at = None
    ___MBSFNMCCHInformation_protocolIEs__item__id._const_tab_id = u'id'
    ___MBSFNMCCHInformation_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___MBSFNMCCHInformation_protocolIEs__item__criticality._const_tab = ____MBSFNMCCHInformation_protocolIEs__item__id_tab
    ___MBSFNMCCHInformation_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___MBSFNMCCHInformation_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___MBSFNMCCHInformation_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___MBSFNMCCHInformation_protocolIEs__item__value._const_tab = ____MBSFNMCCHInformation_protocolIEs__item__id_tab
    ___MBSFNMCCHInformation_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___MBSFNMCCHInformation_protocolIEs__item__value._const_tab_id = u'Value'
    __MBSFNMCCHInformation_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___MBSFNMCCHInformation_protocolIEs__item__id),
        (u'criticality', ___MBSFNMCCHInformation_protocolIEs__item__criticality),
        (u'value', ___MBSFNMCCHInformation_protocolIEs__item__value),
        ])
    __MBSFNMCCHInformation_protocolIEs__item_._ext = None
    _MBSFNMCCHInformation_protocolIEs._cont = __MBSFNMCCHInformation_protocolIEs__item_
    _MBSFNMCCHInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBSFNMCCHInformation_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSFNMCCHInformation_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___MBSFNMCCHInformation_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____MBSFNMCCHInformation_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBSFNMCCHInformation_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFNMCCHInformation_protocolExtensions__item__id._const_tab = ____MBSFNMCCHInformation_protocolExtensions__item__id_tab
    ___MBSFNMCCHInformation_protocolExtensions__item__id._const_tab_at = None
    ___MBSFNMCCHInformation_protocolExtensions__item__id._const_tab_id = u'id'
    ___MBSFNMCCHInformation_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____MBSFNMCCHInformation_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBSFNMCCHInformation_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFNMCCHInformation_protocolExtensions__item__criticality._const_tab = ____MBSFNMCCHInformation_protocolExtensions__item__criticality_tab
    ___MBSFNMCCHInformation_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___MBSFNMCCHInformation_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___MBSFNMCCHInformation_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____MBSFNMCCHInformation_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____MBSFNMCCHInformation_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSFNMCCHInformation_protocolExtensions__item__extensionValue._const_tab = ____MBSFNMCCHInformation_protocolExtensions__item__extensionValue_tab
    ___MBSFNMCCHInformation_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___MBSFNMCCHInformation_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __MBSFNMCCHInformation_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___MBSFNMCCHInformation_protocolExtensions__item__id),
        (u'criticality', ___MBSFNMCCHInformation_protocolExtensions__item__criticality),
        (u'extensionValue', ___MBSFNMCCHInformation_protocolExtensions__item__extensionValue),
        ])
    __MBSFNMCCHInformation_protocolExtensions__item_._ext = None
    _MBSFNMCCHInformation_protocolExtensions._cont = __MBSFNMCCHInformation_protocolExtensions__item_
    _MBSFNMCCHInformation_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSFNMCCHInformation._cont = ASN1Dict([
        (u'protocolIEs', _MBSFNMCCHInformation_protocolIEs),
        (u'protocolExtensions', _MBSFNMCCHInformation_protocolExtensions),
        ])
    MBSFNMCCHInformation._ext = []
    
    #-----< MBSFNMCCHInformation-IEs >-----#
    MBSFNMCCHInformation_IEs = CLASS(name=u'MBSFNMCCHInformation-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _MBSFNMCCHInformation_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBSFN-Cluster-Identity')))
    _MBSFNMCCHInformation_IEs_val_Value_1 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MCCH-Message-List')))
    _MBSFNMCCHInformation_IEs_val_Value_2 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'CFN')))
    _MBSFNMCCHInformation_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MCCH-Configuration-Info')))
    _MBSFNMCCHInformation_IEs_val_Value_4 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'MBSFN-Scheduling-Transmission-Time-Interval-Info-List')))
    MBSFNMCCHInformation_IEs._val = ASN1Set(rv=[dict([(u'id', 769), (u'criticality', u'ignore'), (u'Value', _MBSFNMCCHInformation_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 771), (u'criticality', u'reject'), (u'Value', _MBSFNMCCHInformation_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 8), (u'criticality', u'reject'), (u'Value', _MBSFNMCCHInformation_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 770), (u'criticality', u'ignore'), (u'Value', _MBSFNMCCHInformation_IEs_val_Value_3), (u'presence', u'optional')]), dict([(u'id', 772), (u'criticality', u'ignore'), (u'Value', _MBSFNMCCHInformation_IEs_val_Value_4), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBSFNMCCHInformation-Extensions >-----#
    MBSFNMCCHInformation_Extensions = CLASS(name=u'MBSFNMCCHInformation-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    MBSFNMCCHInformation_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyReport >-----#
    SecondaryULFrequencyReport = SEQ(name=u'SecondaryULFrequencyReport', mode=MODE_TYPE)
    _SecondaryULFrequencyReport_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __SecondaryULFrequencyReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___SecondaryULFrequencyReport_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____SecondaryULFrequencyReport_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationInformation')))
    ____SecondaryULFrequencyReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 835), (u'criticality', u'ignore'), (u'Value', _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolIEs__item__id._const_tab = ____SecondaryULFrequencyReport_protocolIEs__item__id_tab
    ___SecondaryULFrequencyReport_protocolIEs__item__id._const_tab_at = None
    ___SecondaryULFrequencyReport_protocolIEs__item__id._const_tab_id = u'id'
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality._const_tab = ____SecondaryULFrequencyReport_protocolIEs__item__id_tab
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyReport_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecondaryULFrequencyReport_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___SecondaryULFrequencyReport_protocolIEs__item__value._const_tab = ____SecondaryULFrequencyReport_protocolIEs__item__id_tab
    ___SecondaryULFrequencyReport_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyReport_protocolIEs__item__value._const_tab_id = u'Value'
    __SecondaryULFrequencyReport_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecondaryULFrequencyReport_protocolIEs__item__id),
        (u'criticality', ___SecondaryULFrequencyReport_protocolIEs__item__criticality),
        (u'value', ___SecondaryULFrequencyReport_protocolIEs__item__value),
        ])
    __SecondaryULFrequencyReport_protocolIEs__item_._ext = None
    _SecondaryULFrequencyReport_protocolIEs._cont = __SecondaryULFrequencyReport_protocolIEs__item_
    _SecondaryULFrequencyReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecondaryULFrequencyReport_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryULFrequencyReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryULFrequencyReport_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolExtensions__item__id._const_tab = ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab
    ___SecondaryULFrequencyReport_protocolExtensions__item__id._const_tab_at = None
    ___SecondaryULFrequencyReport_protocolExtensions__item__id._const_tab_id = u'id'
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality._const_tab = ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyReport_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue._const_tab = ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SecondaryULFrequencyReport_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SecondaryULFrequencyReport_protocolExtensions__item__id),
        (u'criticality', ___SecondaryULFrequencyReport_protocolExtensions__item__criticality),
        (u'extensionValue', ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue),
        ])
    __SecondaryULFrequencyReport_protocolExtensions__item_._ext = None
    _SecondaryULFrequencyReport_protocolExtensions._cont = __SecondaryULFrequencyReport_protocolExtensions__item_
    _SecondaryULFrequencyReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryULFrequencyReport._cont = ASN1Dict([
        (u'protocolIEs', _SecondaryULFrequencyReport_protocolIEs),
        (u'protocolExtensions', _SecondaryULFrequencyReport_protocolExtensions),
        ])
    SecondaryULFrequencyReport._ext = []
    
    #-----< SecondaryULFrequencyReport-IEs >-----#
    SecondaryULFrequencyReport_IEs = CLASS(name=u'SecondaryULFrequencyReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _SecondaryULFrequencyReport_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationInformation')))
    SecondaryULFrequencyReport_IEs._val = ASN1Set(rv=[dict([(u'id', 835), (u'criticality', u'ignore'), (u'Value', _SecondaryULFrequencyReport_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyReport-Extensions >-----#
    SecondaryULFrequencyReport_Extensions = CLASS(name=u'SecondaryULFrequencyReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SecondaryULFrequencyReport_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyUpdateIndication >-----#
    SecondaryULFrequencyUpdateIndication = SEQ(name=u'SecondaryULFrequencyUpdateIndication', mode=MODE_TYPE)
    _SecondaryULFrequencyUpdateIndication_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __SecondaryULFrequencyUpdateIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationInformation')))
    ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 835), (u'criticality', u'ignore'), (u'Value', _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id._const_tab_at = None
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id._const_tab_id = u'id'
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value._const_tab_id = u'Value'
    __SecondaryULFrequencyUpdateIndication_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id),
        (u'criticality', ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality),
        (u'value', ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value),
        ])
    __SecondaryULFrequencyUpdateIndication_protocolIEs__item_._ext = None
    _SecondaryULFrequencyUpdateIndication_protocolIEs._cont = __SecondaryULFrequencyUpdateIndication_protocolIEs__item_
    _SecondaryULFrequencyUpdateIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecondaryULFrequencyUpdateIndication_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id._const_tab_at = None
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id._const_tab_id = u'id'
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue._const_tab = ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id),
        (u'criticality', ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality),
        (u'extensionValue', ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue),
        ])
    __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_._ext = None
    _SecondaryULFrequencyUpdateIndication_protocolExtensions._cont = __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_
    _SecondaryULFrequencyUpdateIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecondaryULFrequencyUpdateIndication._cont = ASN1Dict([
        (u'protocolIEs', _SecondaryULFrequencyUpdateIndication_protocolIEs),
        (u'protocolExtensions', _SecondaryULFrequencyUpdateIndication_protocolExtensions),
        ])
    SecondaryULFrequencyUpdateIndication._ext = []
    
    #-----< SecondaryULFrequencyUpdateIndication-IEs >-----#
    SecondaryULFrequencyUpdateIndication_IEs = CLASS(name=u'SecondaryULFrequencyUpdateIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _SecondaryULFrequencyUpdateIndication_IEs_val_Value_0 = SEQ_OF(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ActivationInformation')))
    SecondaryULFrequencyUpdateIndication_IEs._val = ASN1Set(rv=[dict([(u'id', 835), (u'criticality', u'ignore'), (u'Value', _SecondaryULFrequencyUpdateIndication_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecondaryULFrequencyUpdateIndication-Extensions >-----#
    SecondaryULFrequencyUpdateIndication_Extensions = CLASS(name=u'SecondaryULFrequencyUpdateIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    SecondaryULFrequencyUpdateIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceRequest >-----#
    EnhancedRelocationResourceRequest = SEQ(name=u'EnhancedRelocationResourceRequest', mode=MODE_TYPE)
    _EnhancedRelocationResourceRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationResourceRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationResourceRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IMSI')))
    _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SourceID')))
    _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TargetID')))
    _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ClassmarkInformation2')))
    _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ClassmarkInformation3')))
    _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SpeechVersion')))
    ____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 84), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 2049), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2050), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2051), (u'criticality', u'reject'), (u'Value', _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 2052), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 2048), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceRequest_protocolIEs__item__id._const_tab = ____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceRequest_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationResourceRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationResourceRequest_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationResourceRequest_protocolIEs__item__value._const_tab = ____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationResourceRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceRequest_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationResourceRequest_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationResourceRequest_protocolIEs__item__value),
        ])
    __EnhancedRelocationResourceRequest_protocolIEs__item_._ext = None
    _EnhancedRelocationResourceRequest_protocolIEs._cont = __EnhancedRelocationResourceRequest_protocolIEs__item_
    _EnhancedRelocationResourceRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationResourceRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationResourceRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationResourceRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__id._const_tab = ____EnhancedRelocationResourceRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationResourceRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationResourceRequest_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationResourceRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceRequest_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationResourceRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationResourceRequest_protocolExtensions__item_._ext = None
    _EnhancedRelocationResourceRequest_protocolExtensions._cont = __EnhancedRelocationResourceRequest_protocolExtensions__item_
    _EnhancedRelocationResourceRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationResourceRequest._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationResourceRequest_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationResourceRequest_protocolExtensions),
        ])
    EnhancedRelocationResourceRequest._ext = []
    
    #-----< EnhancedRelocationResourceRequest-IEs >-----#
    EnhancedRelocationResourceRequest_IEs = CLASS(name=u'EnhancedRelocationResourceRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationResourceRequest_IEs_val_Value_0 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'IMSI')))
    _EnhancedRelocationResourceRequest_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SourceID')))
    _EnhancedRelocationResourceRequest_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'TargetID')))
    _EnhancedRelocationResourceRequest_IEs_val_Value_3 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ClassmarkInformation2')))
    _EnhancedRelocationResourceRequest_IEs_val_Value_4 = OCT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'ClassmarkInformation3')))
    _EnhancedRelocationResourceRequest_IEs_val_Value_5 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'SpeechVersion')))
    EnhancedRelocationResourceRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 84), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationResourceRequest_IEs_val_Value_0), (u'presence', u'optional')]), dict([(u'id', 2049), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceRequest_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 2050), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationResourceRequest_IEs_val_Value_2), (u'presence', u'mandatory')]), dict([(u'id', 2051), (u'criticality', u'reject'), (u'Value', _EnhancedRelocationResourceRequest_IEs_val_Value_3), (u'presence', u'mandatory')]), dict([(u'id', 2052), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceRequest_IEs_val_Value_4), (u'presence', u'mandatory')]), dict([(u'id', 2048), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceRequest_IEs_val_Value_5), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceRequest-Extensions >-----#
    EnhancedRelocationResourceRequest_Extensions = CLASS(name=u'EnhancedRelocationResourceRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationResourceRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceResponse >-----#
    EnhancedRelocationResourceResponse = SEQ(name=u'EnhancedRelocationResourceResponse', mode=MODE_TYPE)
    _EnhancedRelocationResourceResponse_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationResourceResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationResourceResponse_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Capacity-Class-Value')))
    _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LoadValue')))
    ____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 2063), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_3), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceResponse_protocolIEs__item__id._const_tab = ____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceResponse_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationResourceResponse_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceResponse_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationResourceResponse_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceResponse_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceResponse_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceResponse_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationResourceResponse_protocolIEs__item__value._const_tab = ____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceResponse_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceResponse_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationResourceResponse_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceResponse_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationResourceResponse_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationResourceResponse_protocolIEs__item__value),
        ])
    __EnhancedRelocationResourceResponse_protocolIEs__item_._ext = None
    _EnhancedRelocationResourceResponse_protocolIEs._cont = __EnhancedRelocationResourceResponse_protocolIEs__item_
    _EnhancedRelocationResourceResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationResourceResponse_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationResourceResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationResourceResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__id._const_tab = ____EnhancedRelocationResourceResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationResourceResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationResourceResponse_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationResourceResponse_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceResponse_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationResourceResponse_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationResourceResponse_protocolExtensions__item_._ext = None
    _EnhancedRelocationResourceResponse_protocolExtensions._cont = __EnhancedRelocationResourceResponse_protocolExtensions__item_
    _EnhancedRelocationResourceResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationResourceResponse._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationResourceResponse_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationResourceResponse_protocolExtensions),
        ])
    EnhancedRelocationResourceResponse._ext = []
    
    #-----< EnhancedRelocationResourceResponse-IEs >-----#
    EnhancedRelocationResourceResponse_IEs = CLASS(name=u'EnhancedRelocationResourceResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationResourceResponse_IEs_val_Value_0 = INT(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'D-RNTI')))
    _EnhancedRelocationResourceResponse_IEs_val_Value_1 = BIT_STR(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'L3-Information')))
    _EnhancedRelocationResourceResponse_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Capacity-Class-Value')))
    _EnhancedRelocationResourceResponse_IEs_val_Value_3 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LoadValue')))
    EnhancedRelocationResourceResponse_IEs._val = ASN1Set(rv=[dict([(u'id', 21), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceResponse_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 85), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceResponse_IEs_val_Value_1), (u'presence', u'mandatory')]), dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceResponse_IEs_val_Value_2), (u'presence', u'optional')]), dict([(u'id', 2063), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceResponse_IEs_val_Value_3), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceResponse-Extensions >-----#
    EnhancedRelocationResourceResponse_Extensions = CLASS(name=u'EnhancedRelocationResourceResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationResourceResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceFailure >-----#
    EnhancedRelocationResourceFailure = SEQ(name=u'EnhancedRelocationResourceFailure', mode=MODE_TYPE)
    _EnhancedRelocationResourceFailure_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationResourceFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationResourceFailure_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Capacity-Class-Value')))
    _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LoadValue')))
    ____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 2063), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_2), (u'presence', u'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceFailure_protocolIEs__item__id._const_tab = ____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceFailure_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationResourceFailure_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceFailure_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationResourceFailure_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceFailure_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceFailure_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceFailure_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationResourceFailure_protocolIEs__item__value._const_tab = ____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceFailure_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceFailure_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationResourceFailure_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceFailure_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationResourceFailure_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationResourceFailure_protocolIEs__item__value),
        ])
    __EnhancedRelocationResourceFailure_protocolIEs__item_._ext = None
    _EnhancedRelocationResourceFailure_protocolIEs._cont = __EnhancedRelocationResourceFailure_protocolIEs__item_
    _EnhancedRelocationResourceFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationResourceFailure_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationResourceFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationResourceFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__id._const_tab = ____EnhancedRelocationResourceFailure_protocolExtensions__item__id_tab
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationResourceFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationResourceFailure_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationResourceFailure_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceFailure_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationResourceFailure_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationResourceFailure_protocolExtensions__item_._ext = None
    _EnhancedRelocationResourceFailure_protocolExtensions._cont = __EnhancedRelocationResourceFailure_protocolExtensions__item_
    _EnhancedRelocationResourceFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationResourceFailure._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationResourceFailure_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationResourceFailure_protocolExtensions),
        ])
    EnhancedRelocationResourceFailure._ext = []
    
    #-----< EnhancedRelocationResourceFailure-IEs >-----#
    EnhancedRelocationResourceFailure_IEs = CLASS(name=u'EnhancedRelocationResourceFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationResourceFailure_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    _EnhancedRelocationResourceFailure_IEs_val_Value_1 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cell-Capacity-Class-Value')))
    _EnhancedRelocationResourceFailure_IEs_val_Value_2 = SEQ(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'LoadValue')))
    EnhancedRelocationResourceFailure_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceFailure_IEs_val_Value_0), (u'presence', u'mandatory')]), dict([(u'id', 303), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceFailure_IEs_val_Value_1), (u'presence', u'optional')]), dict([(u'id', 2063), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceFailure_IEs_val_Value_2), (u'presence', u'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceFailure-Extensions >-----#
    EnhancedRelocationResourceFailure_Extensions = CLASS(name=u'EnhancedRelocationResourceFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationResourceFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceReleaseCommand >-----#
    EnhancedRelocationResourceReleaseCommand = SEQ(name=u'EnhancedRelocationResourceReleaseCommand', mode=MODE_TYPE)
    _EnhancedRelocationResourceReleaseCommand_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationResourceReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    ____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id._const_tab = ____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__value._const_tab = ____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationResourceReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__value),
        ])
    __EnhancedRelocationResourceReleaseCommand_protocolIEs__item_._ext = None
    _EnhancedRelocationResourceReleaseCommand_protocolIEs._cont = __EnhancedRelocationResourceReleaseCommand_protocolIEs__item_
    _EnhancedRelocationResourceReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationResourceReleaseCommand_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationResourceReleaseCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id._const_tab = ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id_tab
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationResourceReleaseCommand_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationResourceReleaseCommand_protocolExtensions__item_._ext = None
    _EnhancedRelocationResourceReleaseCommand_protocolExtensions._cont = __EnhancedRelocationResourceReleaseCommand_protocolExtensions__item_
    _EnhancedRelocationResourceReleaseCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationResourceReleaseCommand._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationResourceReleaseCommand_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationResourceReleaseCommand_protocolExtensions),
        ])
    EnhancedRelocationResourceReleaseCommand._ext = []
    
    #-----< EnhancedRelocationResourceReleaseCommand-IEs >-----#
    EnhancedRelocationResourceReleaseCommand_IEs = CLASS(name=u'EnhancedRelocationResourceReleaseCommand-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _EnhancedRelocationResourceReleaseCommand_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-IEs', 'Cause')))
    EnhancedRelocationResourceReleaseCommand_IEs._val = ASN1Set(rv=[dict([(u'id', 11), (u'criticality', u'ignore'), (u'Value', _EnhancedRelocationResourceReleaseCommand_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceReleaseCommand-Extensions >-----#
    EnhancedRelocationResourceReleaseCommand_Extensions = CLASS(name=u'EnhancedRelocationResourceReleaseCommand-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationResourceReleaseCommand_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceReleaseComplete >-----#
    EnhancedRelocationResourceReleaseComplete = SEQ(name=u'EnhancedRelocationResourceReleaseComplete', mode=MODE_TYPE)
    _EnhancedRelocationResourceReleaseComplete_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationResourceReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id._const_tab = ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id_tab
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality_tab
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value._const_tab = ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value_tab
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value._const_tab_id = u'Value'
    __EnhancedRelocationResourceReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id),
        (u'criticality', ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality),
        (u'value', ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value),
        ])
    __EnhancedRelocationResourceReleaseComplete_protocolIEs__item_._ext = None
    _EnhancedRelocationResourceReleaseComplete_protocolIEs._cont = __EnhancedRelocationResourceReleaseComplete_protocolIEs__item_
    _EnhancedRelocationResourceReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationResourceReleaseComplete_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationResourceReleaseComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id._const_tab = ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id_tab
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id._const_tab_id = u'id'
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __EnhancedRelocationResourceReleaseComplete_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id),
        (u'criticality', ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality),
        (u'extensionValue', ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationResourceReleaseComplete_protocolExtensions__item_._ext = None
    _EnhancedRelocationResourceReleaseComplete_protocolExtensions._cont = __EnhancedRelocationResourceReleaseComplete_protocolExtensions__item_
    _EnhancedRelocationResourceReleaseComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationResourceReleaseComplete._cont = ASN1Dict([
        (u'protocolIEs', _EnhancedRelocationResourceReleaseComplete_protocolIEs),
        (u'protocolExtensions', _EnhancedRelocationResourceReleaseComplete_protocolExtensions),
        ])
    EnhancedRelocationResourceReleaseComplete._ext = []
    
    #-----< EnhancedRelocationResourceReleaseComplete-IEs >-----#
    EnhancedRelocationResourceReleaseComplete_IEs = CLASS(name=u'EnhancedRelocationResourceReleaseComplete-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    EnhancedRelocationResourceReleaseComplete_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationResourceReleaseComplete-Extensions >-----#
    EnhancedRelocationResourceReleaseComplete_Extensions = CLASS(name=u'EnhancedRelocationResourceReleaseComplete-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationResourceReleaseComplete_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name=u'PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name=u'privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PRIVATE-IES'), [u'id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_RNSAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = u'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PRIVATE-IES'), [u'criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_RNSAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = u'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PRIVATE-IES'), [u'Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_RNSAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', u'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = u'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        (u'id', ___PrivateMessage_privateIEs__item__id),
        (u'criticality', ___PrivateMessage_privateIEs__item__criticality),
        (u'value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        (u'privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name=u'PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationTransferControlRequest >-----#
    InformationTransferControlRequest = SEQ(name=u'InformationTransferControlRequest', mode=MODE_TYPE)
    _InformationTransferControlRequest_protocolIEs = SEQ_OF(name=u'protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferControlRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferControlRequest_protocolIEs__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'id']))
    ____InformationTransferControlRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _____InformationTransferControlRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Control-Type-InformationTransferControlReq')))
    ____InformationTransferControlRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([(u'id', 897), (u'criticality', u'ignore'), (u'Value', _____InformationTransferControlRequest_protocolIEs__item__id_tab_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=None, er=[])
    ___InformationTransferControlRequest_protocolIEs__item__id._const_tab = ____InformationTransferControlRequest_protocolIEs__item__id_tab
    ___InformationTransferControlRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferControlRequest_protocolIEs__item__id._const_tab_id = u'id'
    ___InformationTransferControlRequest_protocolIEs__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'criticality']))
    ___InformationTransferControlRequest_protocolIEs__item__criticality._const_tab = ____InformationTransferControlRequest_protocolIEs__item__id_tab
    ___InformationTransferControlRequest_protocolIEs__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferControlRequest_protocolIEs__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferControlRequest_protocolIEs__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES'), [u'Value']))
    ___InformationTransferControlRequest_protocolIEs__item__value._const_tab = ____InformationTransferControlRequest_protocolIEs__item__id_tab
    ___InformationTransferControlRequest_protocolIEs__item__value._const_tab_at = ('..', u'id')
    ___InformationTransferControlRequest_protocolIEs__item__value._const_tab_id = u'Value'
    __InformationTransferControlRequest_protocolIEs__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferControlRequest_protocolIEs__item__id),
        (u'criticality', ___InformationTransferControlRequest_protocolIEs__item__criticality),
        (u'value', ___InformationTransferControlRequest_protocolIEs__item__value),
        ])
    __InformationTransferControlRequest_protocolIEs__item_._ext = None
    _InformationTransferControlRequest_protocolIEs._cont = __InformationTransferControlRequest_protocolIEs__item_
    _InformationTransferControlRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferControlRequest_protocolExtensions = SEQ_OF(name=u'protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferControlRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferControlRequest_protocolExtensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____InformationTransferControlRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationTransferControlRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferControlRequest_protocolExtensions__item__id._const_tab = ____InformationTransferControlRequest_protocolExtensions__item__id_tab
    ___InformationTransferControlRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferControlRequest_protocolExtensions__item__id._const_tab_id = u'id'
    ___InformationTransferControlRequest_protocolExtensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____InformationTransferControlRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationTransferControlRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferControlRequest_protocolExtensions__item__criticality._const_tab = ____InformationTransferControlRequest_protocolExtensions__item__criticality_tab
    ___InformationTransferControlRequest_protocolExtensions__item__criticality._const_tab_at = ('..', u'id')
    ___InformationTransferControlRequest_protocolExtensions__item__criticality._const_tab_id = u'criticality'
    ___InformationTransferControlRequest_protocolExtensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____InformationTransferControlRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____InformationTransferControlRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferControlRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferControlRequest_protocolExtensions__item__extensionValue_tab
    ___InformationTransferControlRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___InformationTransferControlRequest_protocolExtensions__item__extensionValue._const_tab_id = u'Extension'
    __InformationTransferControlRequest_protocolExtensions__item_._cont = ASN1Dict([
        (u'id', ___InformationTransferControlRequest_protocolExtensions__item__id),
        (u'criticality', ___InformationTransferControlRequest_protocolExtensions__item__criticality),
        (u'extensionValue', ___InformationTransferControlRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferControlRequest_protocolExtensions__item_._ext = None
    _InformationTransferControlRequest_protocolExtensions._cont = __InformationTransferControlRequest_protocolExtensions__item_
    _InformationTransferControlRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferControlRequest._cont = ASN1Dict([
        (u'protocolIEs', _InformationTransferControlRequest_protocolIEs),
        (u'protocolExtensions', _InformationTransferControlRequest_protocolExtensions),
        ])
    InformationTransferControlRequest._ext = []
    
    #-----< InformationTransferControlRequest-IEs >-----#
    InformationTransferControlRequest_IEs = CLASS(name=u'InformationTransferControlRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-IES')))
    _InformationTransferControlRequest_IEs_val_Value_0 = CHOICE(name=u'Value', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Control-Type-InformationTransferControlReq')))
    InformationTransferControlRequest_IEs._val = ASN1Set(rv=[dict([(u'id', 897), (u'criticality', u'ignore'), (u'Value', _InformationTransferControlRequest_IEs_val_Value_0), (u'presence', u'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferControlRequest-Extensions >-----#
    InformationTransferControlRequest_Extensions = CLASS(name=u'InformationTransferControlRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    InformationTransferControlRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Control-Type-InformationTransferControlReq >-----#
    Control_Type_InformationTransferControlReq = CHOICE(name=u'Control-Type-InformationTransferControlReq', mode=MODE_TYPE)
    _Control_Type_InformationTransferControlReq_suspension = SEQ(name=u'suspension', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Suspension-Control-Type')))
    _Control_Type_InformationTransferControlReq_resume = SEQ(name=u'resume', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Contents', 'Resume-Control-Type')))
    Control_Type_InformationTransferControlReq._cont = ASN1Dict([
        (u'suspension', _Control_Type_InformationTransferControlReq_suspension),
        (u'resume', _Control_Type_InformationTransferControlReq_resume),
        ])
    Control_Type_InformationTransferControlReq._ext = []
    
    #-----< Suspension-Control-Type >-----#
    Suspension_Control_Type = SEQ(name=u'Suspension-Control-Type', mode=MODE_TYPE)
    _Suspension_Control_Type_controlled_Object_Scope = SEQ(name=u'controlled-Object-Scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Controlled-Object-Scope')))
    _Suspension_Control_Type_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')))
    __Suspension_Control_Type_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Suspension_Control_Type_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Suspension_Control_Type_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Suspension_Control_Type_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Suspension_Control_Type_iE_Extensions__item__id._const_tab = ____Suspension_Control_Type_iE_Extensions__item__id_tab
    ___Suspension_Control_Type_iE_Extensions__item__id._const_tab_at = None
    ___Suspension_Control_Type_iE_Extensions__item__id._const_tab_id = u'id'
    ___Suspension_Control_Type_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Suspension_Control_Type_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Suspension_Control_Type_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Suspension_Control_Type_iE_Extensions__item__criticality._const_tab = ____Suspension_Control_Type_iE_Extensions__item__criticality_tab
    ___Suspension_Control_Type_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Suspension_Control_Type_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Suspension_Control_Type_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Suspension_Control_Type_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Suspension_Control_Type_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Suspension_Control_Type_iE_Extensions__item__extensionValue._const_tab = ____Suspension_Control_Type_iE_Extensions__item__extensionValue_tab
    ___Suspension_Control_Type_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Suspension_Control_Type_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Suspension_Control_Type_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Suspension_Control_Type_iE_Extensions__item__id),
        (u'criticality', ___Suspension_Control_Type_iE_Extensions__item__criticality),
        (u'extensionValue', ___Suspension_Control_Type_iE_Extensions__item__extensionValue),
        ])
    __Suspension_Control_Type_iE_Extensions__item_._ext = None
    _Suspension_Control_Type_iE_Extensions._cont = __Suspension_Control_Type_iE_Extensions__item_
    _Suspension_Control_Type_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Suspension_Control_Type._cont = ASN1Dict([
        (u'controlled-Object-Scope', _Suspension_Control_Type_controlled_Object_Scope),
        (u'iE-Extensions', _Suspension_Control_Type_iE_Extensions),
        ])
    Suspension_Control_Type._ext = []
    
    #-----< Suspension-Control-Type-ExtIEs >-----#
    Suspension_Control_Type_ExtIEs = CLASS(name=u'Suspension-Control-Type-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Suspension_Control_Type_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Resume-Control-Type >-----#
    Resume_Control_Type = SEQ(name=u'Resume-Control-Type', mode=MODE_TYPE)
    _Resume_Control_Type_controlled_Object_Scope = SEQ(name=u'controlled-Object-Scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-IEs', 'Controlled-Object-Scope')))
    _Resume_Control_Type_iE_Extensions = SEQ_OF(name=u'iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionContainer')))
    __Resume_Control_Type_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-Containers', 'ProtocolExtensionField')))
    ___Resume_Control_Type_iE_Extensions__item__id = INT(name=u'id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'id']))
    ____Resume_Control_Type_iE_Extensions__item__id_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Resume_Control_Type_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Resume_Control_Type_iE_Extensions__item__id._const_tab = ____Resume_Control_Type_iE_Extensions__item__id_tab
    ___Resume_Control_Type_iE_Extensions__item__id._const_tab_at = None
    ___Resume_Control_Type_iE_Extensions__item__id._const_tab_id = u'id'
    ___Resume_Control_Type_iE_Extensions__item__criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'criticality']))
    ____Resume_Control_Type_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Resume_Control_Type_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Resume_Control_Type_iE_Extensions__item__criticality._const_tab = ____Resume_Control_Type_iE_Extensions__item__criticality_tab
    ___Resume_Control_Type_iE_Extensions__item__criticality._const_tab_at = ('..', u'id')
    ___Resume_Control_Type_iE_Extensions__item__criticality._const_tab_id = u'criticality'
    ___Resume_Control_Type_iE_Extensions__item__extensionValue = OPEN(name=u'extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION'), [u'Extension']))
    ____Resume_Control_Type_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RNSAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    ____Resume_Control_Type_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Resume_Control_Type_iE_Extensions__item__extensionValue._const_tab = ____Resume_Control_Type_iE_Extensions__item__extensionValue_tab
    ___Resume_Control_Type_iE_Extensions__item__extensionValue._const_tab_at = ('..', u'id')
    ___Resume_Control_Type_iE_Extensions__item__extensionValue._const_tab_id = u'Extension'
    __Resume_Control_Type_iE_Extensions__item_._cont = ASN1Dict([
        (u'id', ___Resume_Control_Type_iE_Extensions__item__id),
        (u'criticality', ___Resume_Control_Type_iE_Extensions__item__criticality),
        (u'extensionValue', ___Resume_Control_Type_iE_Extensions__item__extensionValue),
        ])
    __Resume_Control_Type_iE_Extensions__item_._ext = None
    _Resume_Control_Type_iE_Extensions._cont = __Resume_Control_Type_iE_Extensions__item_
    _Resume_Control_Type_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Resume_Control_Type._cont = ASN1Dict([
        (u'controlled-Object-Scope', _Resume_Control_Type_controlled_Object_Scope),
        (u'iE-Extensions', _Resume_Control_Type_iE_Extensions),
        ])
    Resume_Control_Type._ext = []
    
    #-----< Resume-Control-Type-ExtIEs >-----#
    Resume_Control_Type_ExtIEs = CLASS(name=u'Resume-Control-Type-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-Containers', 'RNSAP-PROTOCOL-EXTENSION')))
    Resume_Control_Type_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_7,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_8,
        _____RadioLinkSetupRequestFDD_protocolIEs__item__id_tab_val_Value_9,
        ___RadioLinkSetupRequestFDD_protocolIEs__item__id,
        ___RadioLinkSetupRequestFDD_protocolIEs__item__criticality,
        ___RadioLinkSetupRequestFDD_protocolIEs__item__value,
        __RadioLinkSetupRequestFDD_protocolIEs__item_,
        _RadioLinkSetupRequestFDD_protocolIEs,
        ____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_22,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_23,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_24,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_25,
        _____RadioLinkSetupRequestFDD_protocolExtensions__item__id_tab_val_Extension_26,
        ___RadioLinkSetupRequestFDD_protocolExtensions__item__id,
        ___RadioLinkSetupRequestFDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupRequestFDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupRequestFDD_protocolExtensions__item_,
        _RadioLinkSetupRequestFDD_protocolExtensions,
        RadioLinkSetupRequestFDD,
        RadioLinkSetupRequestFDD_IEs,
        _RadioLinkSetupRequestFDD_IEs_val_Value_0,
        _RadioLinkSetupRequestFDD_IEs_val_Value_1,
        _RadioLinkSetupRequestFDD_IEs_val_Value_2,
        _RadioLinkSetupRequestFDD_IEs_val_Value_3,
        _RadioLinkSetupRequestFDD_IEs_val_Value_4,
        _RadioLinkSetupRequestFDD_IEs_val_Value_5,
        _RadioLinkSetupRequestFDD_IEs_val_Value_6,
        _RadioLinkSetupRequestFDD_IEs_val_Value_7,
        _RadioLinkSetupRequestFDD_IEs_val_Value_8,
        _RadioLinkSetupRequestFDD_IEs_val_Value_9,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_ScramblingCode,
        _UL_DPCH_Information_RL_SetupRqstFDD_minUL_ChannelisationCodeLength,
        _UL_DPCH_Information_RL_SetupRqstFDD_maxNrOfUL_DPCHs,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_PunctureLimit,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_TFCS,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_DPCCH_SlotFormat,
        _UL_DPCH_Information_RL_SetupRqstFDD_ul_SIRTarget,
        _UL_DPCH_Information_RL_SetupRqstFDD_diversityMode,
        _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_sSDT_CellIdLength,
        _UL_DPCH_Information_RL_SetupRqstFDD_not_Used_s_FieldLength,
        ____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ___UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _UL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        UL_DPCH_Information_RL_SetupRqstFDD,
        UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0,
        _UL_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1,
        _DL_DPCH_Information_RL_SetupRqstFDD_tFCS,
        _DL_DPCH_Information_RL_SetupRqstFDD_dl_DPCH_SlotFormat,
        _DL_DPCH_Information_RL_SetupRqstFDD_nrOfDLchannelisationcodes,
        _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_SignallingMode,
        _DL_DPCH_Information_RL_SetupRqstFDD_tFCI_Presence,
        _DL_DPCH_Information_RL_SetupRqstFDD_multiplexingPosition,
        _DL_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation,
        _DL_DPCH_Information_RL_SetupRqstFDD_fdd_dl_TPC_DownlinkStepSize,
        _DL_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease,
        _DL_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus,
        ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _DL_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        DL_DPCH_Information_RL_SetupRqstFDD,
        DL_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _PowerOffsetInformation_RL_SetupRqstFDD_po1_ForTFCI_Bits,
        _PowerOffsetInformation_RL_SetupRqstFDD_po2_ForTPC_Bits,
        _PowerOffsetInformation_RL_SetupRqstFDD_po3_ForPilotBits,
        ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions__item_,
        _PowerOffsetInformation_RL_SetupRqstFDD_iE_Extensions,
        PowerOffsetInformation_RL_SetupRqstFDD,
        PowerOffsetInformation_RL_SetupRqstFDD_ExtIEs,
        ___RL_InformationList_RL_SetupRqstFDD__item__id_tab,
        ____RL_InformationList_RL_SetupRqstFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_SetupRqstFDD__item__id,
        __RL_InformationList_RL_SetupRqstFDD__item__criticality,
        __RL_InformationList_RL_SetupRqstFDD__item__value,
        _RL_InformationList_RL_SetupRqstFDD__item_,
        RL_InformationList_RL_SetupRqstFDD,
        RL_InformationItemIEs_RL_SetupRqstFDD,
        _RL_InformationItemIEs_RL_SetupRqstFDD_val_Value_0,
        _RL_InformationItem_RL_SetupRqstFDD_rL_ID,
        _RL_InformationItem_RL_SetupRqstFDD_c_ID,
        _RL_InformationItem_RL_SetupRqstFDD_firstRLS_indicator,
        _RL_InformationItem_RL_SetupRqstFDD_frameOffset,
        _RL_InformationItem_RL_SetupRqstFDD_chipOffset,
        _RL_InformationItem_RL_SetupRqstFDD_propagationDelay,
        _RL_InformationItem_RL_SetupRqstFDD_diversityControlField,
        _RL_InformationItem_RL_SetupRqstFDD_dl_InitialTX_Power,
        _RL_InformationItem_RL_SetupRqstFDD_primaryCPICH_EcNo,
        _RL_InformationItem_RL_SetupRqstFDD_not_Used_sSDT_CellID,
        _RL_InformationItem_RL_SetupRqstFDD_transmitDiversityIndicator,
        ____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_11,
        ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__id,
        ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_SetupRqstFDD_iE_Extensions__item_,
        _RL_InformationItem_RL_SetupRqstFDD_iE_Extensions,
        RL_InformationItem_RL_SetupRqstFDD,
        RL_InformationItem_RL_SetupRqstFDD_ExtIEs,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_0,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_1,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_2,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_3,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_4,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_5,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_6,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_7,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_8,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_9,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_10,
        _RL_InformationItem_RL_SetupRqstFDD_ExtIEs_val_Extension_11,
        RadioLinkSetupRequestFDD_Extensions,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_0,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_1,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_2,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_3,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_4,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_5,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_6,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_7,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_8,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_9,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_10,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_11,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_12,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_13,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_14,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_15,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_16,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_17,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_18,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_19,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_20,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_21,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_22,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_23,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_24,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_25,
        _RadioLinkSetupRequestFDD_Extensions_val_Extension_26,
        _Additional_HS_Cell_Information_RL_Setup_List__item_,
        Additional_HS_Cell_Information_RL_Setup_List,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Setup_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Setup_ItemIEs,
        Additional_HS_Cell_Information_RL_Setup_ItemIEs_ExtIEs,
        _F_DPCH_Information_RL_SetupRqstFDD_powerOffsetInformation,
        _F_DPCH_Information_RL_SetupRqstFDD_fdd_dl_TPC_DownlinkStepSize,
        _F_DPCH_Information_RL_SetupRqstFDD_limitedPowerIncrease,
        _F_DPCH_Information_RL_SetupRqstFDD_innerLoopDLPCStatus,
        ____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        _____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__id,
        ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ___F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions__item_,
        _F_DPCH_Information_RL_SetupRqstFDD_iE_Extensions,
        F_DPCH_Information_RL_SetupRqstFDD,
        F_DPCH_Information_RL_SetupRqstFDD_ExtIEs,
        _F_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_0,
        _F_DPCH_Information_RL_SetupRqstFDD_ExtIEs_val_Extension_1,
        _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_po2_ForTPC_Bits,
        ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions__item_,
        _PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_iE_Extensions,
        PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD,
        PowerOffsetInformation_F_DPCH_RL_SetupRqstFDD_ExtIEs,
        ____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_7,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_8,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_9,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_10,
        _____RadioLinkSetupRequestTDD_protocolIEs__item__id_tab_val_Value_11,
        ___RadioLinkSetupRequestTDD_protocolIEs__item__id,
        ___RadioLinkSetupRequestTDD_protocolIEs__item__criticality,
        ___RadioLinkSetupRequestTDD_protocolIEs__item__value,
        __RadioLinkSetupRequestTDD_protocolIEs__item_,
        _RadioLinkSetupRequestTDD_protocolIEs,
        ____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkSetupRequestTDD_protocolExtensions__item__id_tab_val_Extension_18,
        ___RadioLinkSetupRequestTDD_protocolExtensions__item__id,
        ___RadioLinkSetupRequestTDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupRequestTDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupRequestTDD_protocolExtensions__item_,
        _RadioLinkSetupRequestTDD_protocolExtensions,
        RadioLinkSetupRequestTDD,
        RadioLinkSetupRequestTDD_IEs,
        _RadioLinkSetupRequestTDD_IEs_val_Value_0,
        _RadioLinkSetupRequestTDD_IEs_val_Value_1,
        _RadioLinkSetupRequestTDD_IEs_val_Value_2,
        _RadioLinkSetupRequestTDD_IEs_val_Value_3,
        _RadioLinkSetupRequestTDD_IEs_val_Value_4,
        _RadioLinkSetupRequestTDD_IEs_val_Value_5,
        _RadioLinkSetupRequestTDD_IEs_val_Value_6,
        _RadioLinkSetupRequestTDD_IEs_val_Value_7,
        _RadioLinkSetupRequestTDD_IEs_val_Value_8,
        _RadioLinkSetupRequestTDD_IEs_val_Value_9,
        _RadioLinkSetupRequestTDD_IEs_val_Value_10,
        _RadioLinkSetupRequestTDD_IEs_val_Value_11,
        _UL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrTimeslots_UL,
        _UL_Physical_Channel_Information_RL_SetupRqstTDD_minimumSpreadingFactor_UL,
        _UL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrULPhysicalchannels,
        ____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _UL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions,
        UL_Physical_Channel_Information_RL_SetupRqstTDD,
        UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        _UL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1,
        _DL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrTimeslots_DL,
        _DL_Physical_Channel_Information_RL_SetupRqstTDD_minimumSpreadingFactor_DL,
        _DL_Physical_Channel_Information_RL_SetupRqstTDD_maxNrDLPhysicalchannels,
        ____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _DL_Physical_Channel_Information_RL_SetupRqstTDD_iE_Extensions,
        DL_Physical_Channel_Information_RL_SetupRqstTDD,
        DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_1,
        _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_2,
        _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_3,
        _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_4,
        _DL_Physical_Channel_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_5,
        ___UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id,
        __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality,
        __UL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value,
        _UL_CCTrCH_InformationList_RL_SetupRqstTDD__item_,
        UL_CCTrCH_InformationList_RL_SetupRqstTDD,
        UL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD,
        _UL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD_val_Value_0,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ul_TFCS,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ul_PunctureLimit,
        ____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _UL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        ___DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__id,
        __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__criticality,
        __DL_CCTrCH_InformationList_RL_SetupRqstTDD__item__value,
        _DL_CCTrCH_InformationList_RL_SetupRqstTDD__item_,
        DL_CCTrCH_InformationList_RL_SetupRqstTDD,
        DL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD,
        _DL_CCTrCH_InformationItemIEs_RL_SetupRqstTDD_val_Value_0,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dl_TFCS,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tFCI_Coding,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_dl_PunctureLimit,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_tdd_TPC_DownlinkStepSize,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_cCTrCH_TPCList,
        ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_RL_SetupRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_RL_SetupRqstTDD,
        DL_CCTrCH_InformationItem_RL_SetupRqstTDD_ExtIEs,
        _CCTrCH_TPCList_RL_SetupRqstTDD__item_,
        CCTrCH_TPCList_RL_SetupRqstTDD,
        _CCTrCH_TPCItem_RL_SetupRqstTDD_cCTrCH_ID,
        ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__id,
        ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality_tab,
        ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ____CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions__item_,
        _CCTrCH_TPCItem_RL_SetupRqstTDD_iE_Extensions,
        CCTrCH_TPCItem_RL_SetupRqstTDD,
        CCTrCH_TPCItem_RL_SetupRqstTDD_ExtIEs,
        _RL_Information_RL_SetupRqstTDD_rL_ID,
        _RL_Information_RL_SetupRqstTDD_c_ID,
        _RL_Information_RL_SetupRqstTDD_frameOffset,
        _RL_Information_RL_SetupRqstTDD_specialBurstScheduling,
        _RL_Information_RL_SetupRqstTDD_primaryCCPCH_RSCP,
        _RL_Information_RL_SetupRqstTDD_dL_TimeSlot_ISCP,
        ____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id_tab_val_Extension_7,
        ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__id,
        ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_SetupRqstTDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_SetupRqstTDD_iE_Extensions__item_,
        _RL_Information_RL_SetupRqstTDD_iE_Extensions,
        RL_Information_RL_SetupRqstTDD,
        RL_Information_RL_SetupRqstTDD_ExtIEs,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_0,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_1,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_2,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_3,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_4,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_5,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_6,
        _RL_Information_RL_SetupRqstTDD_ExtIEs_val_Extension_7,
        RadioLinkSetupRequestTDD_Extensions,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_0,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_1,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_2,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_3,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_4,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_5,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_6,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_7,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_8,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_9,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_10,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_11,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_12,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_13,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_14,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_15,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_16,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_17,
        _RadioLinkSetupRequestTDD_Extensions_val_Extension_18,
        ____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupResponseFDD_protocolIEs__item__id_tab_val_Value_5,
        ___RadioLinkSetupResponseFDD_protocolIEs__item__id,
        ___RadioLinkSetupResponseFDD_protocolIEs__item__criticality,
        ___RadioLinkSetupResponseFDD_protocolIEs__item__value,
        __RadioLinkSetupResponseFDD_protocolIEs__item_,
        _RadioLinkSetupResponseFDD_protocolIEs,
        ____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupResponseFDD_protocolExtensions__item__id_tab_val_Extension_5,
        ___RadioLinkSetupResponseFDD_protocolExtensions__item__id,
        ___RadioLinkSetupResponseFDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupResponseFDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupResponseFDD_protocolExtensions__item_,
        _RadioLinkSetupResponseFDD_protocolExtensions,
        RadioLinkSetupResponseFDD,
        RadioLinkSetupResponseFDD_IEs,
        _RadioLinkSetupResponseFDD_IEs_val_Value_0,
        _RadioLinkSetupResponseFDD_IEs_val_Value_1,
        _RadioLinkSetupResponseFDD_IEs_val_Value_2,
        _RadioLinkSetupResponseFDD_IEs_val_Value_3,
        _RadioLinkSetupResponseFDD_IEs_val_Value_4,
        _RadioLinkSetupResponseFDD_IEs_val_Value_5,
        ___RL_InformationResponseList_RL_SetupRspFDD__item__id_tab,
        ____RL_InformationResponseList_RL_SetupRspFDD__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_SetupRspFDD__item__id,
        __RL_InformationResponseList_RL_SetupRspFDD__item__criticality,
        __RL_InformationResponseList_RL_SetupRspFDD__item__value,
        _RL_InformationResponseList_RL_SetupRspFDD__item_,
        RL_InformationResponseList_RL_SetupRspFDD,
        RL_InformationResponseItemIEs_RL_SetupRspFDD,
        _RL_InformationResponseItemIEs_RL_SetupRspFDD_val_Value_0,
        _RL_InformationResponseItem_RL_SetupRspFDD_rL_ID,
        _RL_InformationResponseItem_RL_SetupRspFDD_rL_Set_ID,
        _RL_InformationResponseItem_RL_SetupRspFDD_uRA_Information,
        _RL_InformationResponseItem_RL_SetupRspFDD_sAI,
        _RL_InformationResponseItem_RL_SetupRspFDD_gA_Cell,
        _RL_InformationResponseItem_RL_SetupRspFDD_gA_AccessPointPosition,
        _RL_InformationResponseItem_RL_SetupRspFDD_received_total_wide_band_power,
        _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_secondary_CCPCH_Info,
        _RL_InformationResponseItem_RL_SetupRspFDD_dl_CodeInformation,
        _RL_InformationResponseItem_RL_SetupRspFDD_diversityIndication,
        _RL_InformationResponseItem_RL_SetupRspFDD_sSDT_SupportIndicator,
        _RL_InformationResponseItem_RL_SetupRspFDD_maxUL_SIR,
        _RL_InformationResponseItem_RL_SetupRspFDD_minUL_SIR,
        _RL_InformationResponseItem_RL_SetupRspFDD_closedlooptimingadjustmentmode,
        _RL_InformationResponseItem_RL_SetupRspFDD_maximumAllowedULTxPower,
        _RL_InformationResponseItem_RL_SetupRspFDD_maximumDLTxPower,
        _RL_InformationResponseItem_RL_SetupRspFDD_minimumDLTxPower,
        _RL_InformationResponseItem_RL_SetupRspFDD_primaryScramblingCode,
        _RL_InformationResponseItem_RL_SetupRspFDD_uL_UARFCN,
        _RL_InformationResponseItem_RL_SetupRspFDD_dL_UARFCN,
        _RL_InformationResponseItem_RL_SetupRspFDD_primaryCPICH_Power,
        _RL_InformationResponseItem_RL_SetupRspFDD_not_Used_dSCHInformationResponse,
        _RL_InformationResponseItem_RL_SetupRspFDD_neighbouring_UMTS_CellInformation,
        _RL_InformationResponseItem_RL_SetupRspFDD_neighbouring_GSM_CellInformation,
        _RL_InformationResponseItem_RL_SetupRspFDD_pC_Preamble,
        _RL_InformationResponseItem_RL_SetupRspFDD_sRB_Delay,
        ____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_11,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_12,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_13,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_14,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_15,
        _____RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_16,
        ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_SetupRspFDD_iE_Extensions,
        RL_InformationResponseItem_RL_SetupRspFDD,
        RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_5,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_6,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_7,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_8,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_9,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_10,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_11,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_12,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_13,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_14,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_15,
        _RL_InformationResponseItem_RL_SetupRspFDD_ExtIEs_val_Extension_16,
        _DiversityIndication_RL_SetupRspFDD_combining,
        _DiversityIndication_RL_SetupRspFDD_nonCombiningOrFirstRL,
        DiversityIndication_RL_SetupRspFDD,
        _Combining_RL_SetupRspFDD_rL_ID,
        ____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab,
        _____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Combining_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Combining_RL_SetupRspFDD_iE_Extensions__item__id,
        ___Combining_RL_SetupRspFDD_iE_Extensions__item__criticality,
        ___Combining_RL_SetupRspFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_SetupRspFDD_iE_Extensions__item_,
        _Combining_RL_SetupRspFDD_iE_Extensions,
        Combining_RL_SetupRspFDD,
        CombiningItem_RL_SetupRspFDD_ExtIEs,
        _CombiningItem_RL_SetupRspFDD_ExtIEs_val_Extension_0,
        _CombiningItem_RL_SetupRspFDD_ExtIEs_val_Extension_1,
        _NonCombiningOrFirstRL_RL_SetupRspFDD_dCH_InformationResponse,
        ____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab,
        _____NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__id,
        ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__criticality,
        ___NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item__extensionValue,
        __NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions__item_,
        _NonCombiningOrFirstRL_RL_SetupRspFDD_iE_Extensions,
        NonCombiningOrFirstRL_RL_SetupRspFDD,
        NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs,
        _NonCombiningOrFirstRLItem_RL_SetupRspFDD_ExtIEs_val_Extension_0,
        RadioLinkSetupResponseFDD_Extensions,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_0,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_1,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_2,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_3,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_4,
        _RadioLinkSetupResponseFDD_Extensions_val_Extension_5,
        _Additional_HS_Cell_Information_Response_List__item_,
        Additional_HS_Cell_Information_Response_List,
        _Additional_HS_Cell_Information_Response_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_Response_ItemIEs_hSDSCH_RNTI,
        _Additional_HS_Cell_Information_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response,
        _Additional_HS_Cell_Information_Response_ItemIEs_sixtyfourQAM_DL_SupportIndicator,
        ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_Response_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_Response_ItemIEs,
        Additional_HS_Cell_Information_Response_ItemIEs_ExtIEs,
        ____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupResponseTDD_protocolIEs__item__id_tab_val_Value_5,
        ___RadioLinkSetupResponseTDD_protocolIEs__item__id,
        ___RadioLinkSetupResponseTDD_protocolIEs__item__criticality,
        ___RadioLinkSetupResponseTDD_protocolIEs__item__value,
        __RadioLinkSetupResponseTDD_protocolIEs__item_,
        _RadioLinkSetupResponseTDD_protocolIEs,
        ____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkSetupResponseTDD_protocolExtensions__item__id_tab_val_Extension_18,
        ___RadioLinkSetupResponseTDD_protocolExtensions__item__id,
        ___RadioLinkSetupResponseTDD_protocolExtensions__item__criticality,
        ___RadioLinkSetupResponseTDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupResponseTDD_protocolExtensions__item_,
        _RadioLinkSetupResponseTDD_protocolExtensions,
        RadioLinkSetupResponseTDD,
        RadioLinkSetupResponseTDD_IEs,
        _RadioLinkSetupResponseTDD_IEs_val_Value_0,
        _RadioLinkSetupResponseTDD_IEs_val_Value_1,
        _RadioLinkSetupResponseTDD_IEs_val_Value_2,
        _RadioLinkSetupResponseTDD_IEs_val_Value_3,
        _RadioLinkSetupResponseTDD_IEs_val_Value_4,
        _RadioLinkSetupResponseTDD_IEs_val_Value_5,
        _RL_InformationResponse_RL_SetupRspTDD_rL_ID,
        _RL_InformationResponse_RL_SetupRspTDD_uRA_Information,
        _RL_InformationResponse_RL_SetupRspTDD_sAI,
        _RL_InformationResponse_RL_SetupRspTDD_gA_Cell,
        _RL_InformationResponse_RL_SetupRspTDD_gA_AccessPointPosition,
        _RL_InformationResponse_RL_SetupRspTDD_ul_TimeSlot_ISCP_Info,
        _RL_InformationResponse_RL_SetupRspTDD_maxUL_SIR,
        _RL_InformationResponse_RL_SetupRspTDD_minUL_SIR,
        _RL_InformationResponse_RL_SetupRspTDD_maximumAllowedULTxPower,
        _RL_InformationResponse_RL_SetupRspTDD_maximumDLTxPower,
        _RL_InformationResponse_RL_SetupRspTDD_minimumDLTxPower,
        _RL_InformationResponse_RL_SetupRspTDD_uARFCNforNt,
        _RL_InformationResponse_RL_SetupRspTDD_cellParameterID,
        _RL_InformationResponse_RL_SetupRspTDD_syncCase,
        _RL_InformationResponse_RL_SetupRspTDD_sCH_TimeSlot,
        _RL_InformationResponse_RL_SetupRspTDD_sCTD_Indicator,
        _RL_InformationResponse_RL_SetupRspTDD_pCCPCH_Power,
        _RL_InformationResponse_RL_SetupRspTDD_timingAdvanceApplied,
        _RL_InformationResponse_RL_SetupRspTDD_alphaValue,
        _RL_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_RL_SetupRspTDD_synchronisationConfiguration,
        _RL_InformationResponse_RL_SetupRspTDD_secondary_CCPCH_Info_TDD,
        _RL_InformationResponse_RL_SetupRspTDD_ul_CCTrCHInformation,
        _RL_InformationResponse_RL_SetupRspTDD_dl_CCTrCHInformation,
        _RL_InformationResponse_RL_SetupRspTDD_dCH_InformationResponse,
        _RL_InformationResponse_RL_SetupRspTDD_dsch_InformationResponse,
        _RL_InformationResponse_RL_SetupRspTDD_usch_InformationResponse,
        _RL_InformationResponse_RL_SetupRspTDD_neighbouring_UMTS_CellInformation,
        _RL_InformationResponse_RL_SetupRspTDD_neighbouring_GSM_CellInformation,
        ____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id,
        ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ___RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_RL_SetupRspTDD_iE_Extensions,
        RL_InformationResponse_RL_SetupRspTDD,
        RL_InformationResponse_RL_SetupRspTDD_ExtIEs,
        _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_0,
        _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_1,
        _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_2,
        _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_3,
        _RL_InformationResponse_RL_SetupRspTDD_ExtIEs_val_Extension_4,
        __UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab,
        ___UL_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _UL_CCTrCHInformationList_RL_SetupRspTDD_id,
        _UL_CCTrCHInformationList_RL_SetupRspTDD_criticality,
        _UL_CCTrCHInformationList_RL_SetupRspTDD_value,
        UL_CCTrCHInformationList_RL_SetupRspTDD,
        UL_CCTrCHInformationListIEs_RL_SetupRspTDD,
        _UL_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0,
        _UL_CCTrCHInformationListIE_RL_SetupRspTDD__item_,
        UL_CCTrCHInformationListIE_RL_SetupRspTDD,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD_ul_DPCH_Information,
        ____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions,
        UL_CCTrCHInformationItem_RL_SetupRspTDD,
        UL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0,
        __UL_DPCH_InformationList_RL_SetupRspTDD_id_tab,
        ___UL_DPCH_InformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationList_RL_SetupRspTDD_id,
        _UL_DPCH_InformationList_RL_SetupRspTDD_criticality,
        _UL_DPCH_InformationList_RL_SetupRspTDD_value,
        UL_DPCH_InformationList_RL_SetupRspTDD,
        UL_DPCH_InformationListIEs_RL_SetupRspTDD,
        _UL_DPCH_InformationListIEs_RL_SetupRspTDD_val_Value_0,
        _UL_DPCH_InformationItem_RL_SetupRspTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_RL_SetupRspTDD_repetitionLength,
        _UL_DPCH_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset,
        _UL_DPCH_InformationItem_RL_SetupRspTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions,
        UL_DPCH_InformationItem_RL_SetupRspTDD,
        UL_DPCH_InformationItem_RL_SetupRspTDD_ExtIEs,
        __DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab,
        ___DL_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DL_CCTrCHInformationList_RL_SetupRspTDD_id,
        _DL_CCTrCHInformationList_RL_SetupRspTDD_criticality,
        _DL_CCTrCHInformationList_RL_SetupRspTDD_value,
        DL_CCTrCHInformationList_RL_SetupRspTDD,
        DL_CCTrCHInformationListIEs_RL_SetupRspTDD,
        _DL_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0,
        _DL_CCTrCHInformationListIE_RL_SetupRspTDD__item_,
        DL_CCTrCHInformationListIE_RL_SetupRspTDD,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD_dl_DPCH_Information,
        ____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions,
        DL_CCTrCHInformationItem_RL_SetupRspTDD,
        DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_1,
        __DL_DPCH_InformationList_RL_SetupRspTDD_id_tab,
        ___DL_DPCH_InformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationList_RL_SetupRspTDD_id,
        _DL_DPCH_InformationList_RL_SetupRspTDD_criticality,
        _DL_DPCH_InformationList_RL_SetupRspTDD_value,
        DL_DPCH_InformationList_RL_SetupRspTDD,
        DL_DPCH_InformationListIEs_RL_SetupRspTDD,
        _DL_DPCH_InformationListIEs_RL_SetupRspTDD_val_Value_0,
        _DL_DPCH_InformationItem_RL_SetupRspTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_RL_SetupRspTDD_repetitionLength,
        _DL_DPCH_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset,
        _DL_DPCH_InformationItem_RL_SetupRspTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_RL_SetupRspTDD_iE_Extensions,
        DL_DPCH_InformationItem_RL_SetupRspTDD,
        DL_DPCH_InformationItem_RL_SetupRspTDD_ExtIEs,
        __DCH_InformationResponseList_RL_SetupRspTDD_id_tab,
        ___DCH_InformationResponseList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_SetupRspTDD_id,
        _DCH_InformationResponseList_RL_SetupRspTDD_criticality,
        _DCH_InformationResponseList_RL_SetupRspTDD_value,
        DCH_InformationResponseList_RL_SetupRspTDD,
        DCH_InformationResponseListIEs_RL_SetupRspTDD,
        _DCH_InformationResponseListIEs_RL_SetupRspTDD_val_Value_0,
        __DSCH_InformationResponse_RL_SetupRspTDD_id_tab,
        ___DSCH_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0,
        _DSCH_InformationResponse_RL_SetupRspTDD_id,
        _DSCH_InformationResponse_RL_SetupRspTDD_criticality,
        _DSCH_InformationResponse_RL_SetupRspTDD_value,
        DSCH_InformationResponse_RL_SetupRspTDD,
        DSCH_InformationList_RL_SetupRspTDD,
        _DSCH_InformationList_RL_SetupRspTDD_val_Value_0,
        _DSCH_InformationListIEs_RL_SetupRspTDD__item_,
        DSCH_InformationListIEs_RL_SetupRspTDD,
        _DSCHInformationItem_RL_SetupRspTDD_dsch_ID,
        _DSCHInformationItem_RL_SetupRspTDD_dSCH_FlowControlInformation,
        _DSCHInformationItem_RL_SetupRspTDD_bindingID,
        _DSCHInformationItem_RL_SetupRspTDD_transportLayerAddress,
        _DSCHInformationItem_RL_SetupRspTDD_transportFormatManagement,
        ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __DSCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _DSCHInformationItem_RL_SetupRspTDD_iE_Extensions,
        DSCHInformationItem_RL_SetupRspTDD,
        DSCHInformationItem_RL_SetupRspTDD_ExtIEs,
        __USCH_InformationResponse_RL_SetupRspTDD_id_tab,
        ___USCH_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0,
        _USCH_InformationResponse_RL_SetupRspTDD_id,
        _USCH_InformationResponse_RL_SetupRspTDD_criticality,
        _USCH_InformationResponse_RL_SetupRspTDD_value,
        USCH_InformationResponse_RL_SetupRspTDD,
        USCH_InformationList_RL_SetupRspTDD,
        _USCH_InformationList_RL_SetupRspTDD_val_Value_0,
        _USCH_InformationListIEs_RL_SetupRspTDD__item_,
        USCH_InformationListIEs_RL_SetupRspTDD,
        _USCHInformationItem_RL_SetupRspTDD_usch_ID,
        _USCHInformationItem_RL_SetupRspTDD_bindingID,
        _USCHInformationItem_RL_SetupRspTDD_transportLayerAddress,
        _USCHInformationItem_RL_SetupRspTDD_transportFormatManagement,
        ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __USCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _USCHInformationItem_RL_SetupRspTDD_iE_Extensions,
        USCHInformationItem_RL_SetupRspTDD,
        USCHInformationItem_RL_SetupRspTDD_ExtIEs,
        RadioLinkSetupResponseTDD_Extensions,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_0,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_1,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_2,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_3,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_4,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_5,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_6,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_7,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_8,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_9,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_10,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_11,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_12,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_13,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_14,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_15,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_16,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_17,
        _RadioLinkSetupResponseTDD_Extensions_val_Extension_18,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_rL_ID,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_uRA_Information,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_sAI,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_gA_Cell,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_gA_AccessPointPosition,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_TimeSlot_ISCP_LCR_Info,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_maxUL_SIR,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_minUL_SIR,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_maximumAllowedULTxPower,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_maximumDLTxPower,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_minimumDLTxPower,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_uARFCNforNt,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_cellParameterID,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_sCTD_Indicator,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_pCCPCH_Power,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_alphaValue,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_PhysCH_SF_Variation,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_synchronisationConfiguration,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_secondary_LCR_CCPCH_Info_TDD,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_ul_LCR_CCTrCHInformation,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_dl_LCR_CCTrCHInformation,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_dCH_InformationResponse,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_dsch_LCR_InformationResponse,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_usch_LCR_InformationResponse,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_neighbouring_UMTS_CellInformation,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_neighbouring_GSM_CellInformation,
        ____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_7,
        ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__id,
        ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ___RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions__item_,
        _RL_LCR_InformationResponse_RL_SetupRspTDD_iE_Extensions,
        RL_LCR_InformationResponse_RL_SetupRspTDD,
        RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_0,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_1,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_2,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_3,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_4,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_5,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_6,
        _RL_LCR_InformationResponseList_RL_SetupRspTDD_ExtIEs_val_Extension_7,
        __UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab,
        ___UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id,
        _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality,
        _UL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value,
        UL_LCR_CCTrCHInformationList_RL_SetupRspTDD,
        UL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD,
        _UL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0,
        _UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD__item_,
        UL_LCR_CCTrCHInformationListIE_RL_SetupRspTDD,
        _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_cCTrCH_ID,
        _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ul_DPCH_LCR_Information,
        ____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        _____UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ___UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_iE_Extensions,
        UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD,
        UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs,
        _UL_LCR_CCTrCHInformationItem_RL_SetupRspTDD_ExtIEs_val_Extension_0,
        __UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab,
        ___UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_id,
        _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality,
        _UL_DPCH_LCR_InformationList_RL_SetupRspTDD_value,
        UL_DPCH_LCR_InformationList_RL_SetupRspTDD,
        UL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD,
        _UL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD_val_Value_0,
        _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionPeriod,
        _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionLength,
        _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset,
        _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_uL_TimeslotLCR_Information,
        ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions,
        UL_DPCH_LCR_InformationItem_RL_SetupRspTDD,
        UL_DPCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs,
        __DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab,
        ___DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_id,
        _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_criticality,
        _DL_LCR_CCTrCHInformationList_RL_SetupRspTDD_value,
        DL_LCR_CCTrCHInformationList_RL_SetupRspTDD,
        DL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD,
        _DL_LCR_CCTrCHInformationListIEs_RL_SetupRspTDD_val_Value_0,
        _DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD__item_,
        DL_CCTrCH_LCR_InformationListIE_RL_SetupRspTDD,
        _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_cCTrCH_ID,
        _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_dl_DPCH_LCR_Information,
        ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions,
        DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD,
        DL_CCTrCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs,
        __DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab,
        ___DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id_tab_val_Value_0,
        _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_id,
        _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_criticality,
        _DL_DPCH_LCR_InformationList_RL_SetupRspTDD_value,
        DL_DPCH_LCR_InformationList_RL_SetupRspTDD,
        DL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD,
        _DL_DPCH_LCR_InformationListIEs_RL_SetupRspTDD_val_Value_0,
        _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionPeriod,
        _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_repetitionLength,
        _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tDD_DPCHOffset,
        _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_dL_Timeslot_LCR_Information,
        _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_tSTD_Indicator,
        ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions,
        DL_DPCH_LCR_InformationItem_RL_SetupRspTDD,
        DL_DPCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs,
        __DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab,
        ___DSCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0,
        _DSCH_LCR_InformationResponse_RL_SetupRspTDD_id,
        _DSCH_LCR_InformationResponse_RL_SetupRspTDD_criticality,
        _DSCH_LCR_InformationResponse_RL_SetupRspTDD_value,
        DSCH_LCR_InformationResponse_RL_SetupRspTDD,
        DSCH_LCR_InformationList_RL_SetupRspTDD,
        _DSCH_LCR_InformationList_RL_SetupRspTDD_val_Value_0,
        _DSCH_LCR_InformationListIEs_RL_SetupRspTDD__item_,
        DSCH_LCR_InformationListIEs_RL_SetupRspTDD,
        _DSCH_LCR_InformationItem_RL_SetupRspTDD_dsch_ID,
        _DSCH_LCR_InformationItem_RL_SetupRspTDD_dSCH_FlowControlInformation,
        _DSCH_LCR_InformationItem_RL_SetupRspTDD_bindingID,
        _DSCH_LCR_InformationItem_RL_SetupRspTDD_transportLayerAddress,
        _DSCH_LCR_InformationItem_RL_SetupRspTDD_transportFormatManagement,
        ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _DSCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions,
        DSCH_LCR_InformationItem_RL_SetupRspTDD,
        DSCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs,
        __USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab,
        ___USCH_LCR_InformationResponse_RL_SetupRspTDD_id_tab_val_Value_0,
        _USCH_LCR_InformationResponse_RL_SetupRspTDD_id,
        _USCH_LCR_InformationResponse_RL_SetupRspTDD_criticality,
        _USCH_LCR_InformationResponse_RL_SetupRspTDD_value,
        USCH_LCR_InformationResponse_RL_SetupRspTDD,
        USCH_LCR_InformationList_RL_SetupRspTDD,
        _USCH_LCR_InformationList_RL_SetupRspTDD_val_Value_0,
        _USCH_LCR_InformationListIEs_RL_SetupRspTDD__item_,
        USCH_LCR_InformationListIEs_RL_SetupRspTDD,
        _USCH_LCR_InformationItem_RL_SetupRspTDD_usch_ID,
        _USCH_LCR_InformationItem_RL_SetupRspTDD_bindingID,
        _USCH_LCR_InformationItem_RL_SetupRspTDD_transportLayerAddress,
        _USCH_LCR_InformationItem_RL_SetupRspTDD_transportFormatManagement,
        ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id_tab,
        ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__id,
        ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality_tab,
        ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__criticality,
        ____USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue_tab,
        ___USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item__extensionValue,
        __USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions__item_,
        _USCH_LCR_InformationItem_RL_SetupRspTDD_iE_Extensions,
        USCH_LCR_InformationItem_RL_SetupRspTDD,
        USCH_LCR_InformationItem_RL_SetupRspTDD_ExtIEs,
        _RL_InformationResponse_RL_SetupRspTDD768_rL_ID,
        _RL_InformationResponse_RL_SetupRspTDD768_uRA_Information,
        _RL_InformationResponse_RL_SetupRspTDD768_sAI,
        _RL_InformationResponse_RL_SetupRspTDD768_gA_Cell,
        _RL_InformationResponse_RL_SetupRspTDD768_gA_AccessPointPosition,
        _RL_InformationResponse_RL_SetupRspTDD768_ul_TimeSlot_ISCP_Info,
        _RL_InformationResponse_RL_SetupRspTDD768_maxUL_SIR,
        _RL_InformationResponse_RL_SetupRspTDD768_minUL_SIR,
        _RL_InformationResponse_RL_SetupRspTDD768_maximumAllowedULTxPower,
        _RL_InformationResponse_RL_SetupRspTDD768_maximumDLTxPower,
        _RL_InformationResponse_RL_SetupRspTDD768_minimumDLTxPower,
        _RL_InformationResponse_RL_SetupRspTDD768_uARFCNforNt,
        _RL_InformationResponse_RL_SetupRspTDD768_cellParameterID,
        _RL_InformationResponse_RL_SetupRspTDD768_syncCase,
        _RL_InformationResponse_RL_SetupRspTDD768_sCH_TimeSlot,
        _RL_InformationResponse_RL_SetupRspTDD768_sCTD_Indicator,
        _RL_InformationResponse_RL_SetupRspTDD768_pCCPCH_Power,
        _RL_InformationResponse_RL_SetupRspTDD768_timingAdvanceApplied,
        _RL_InformationResponse_RL_SetupRspTDD768_alphaValue,
        _RL_InformationResponse_RL_SetupRspTDD768_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_RL_SetupRspTDD768_synchronisationConfiguration,
        _RL_InformationResponse_RL_SetupRspTDD768_secondary_CCPCH_Info_TDD768,
        _RL_InformationResponse_RL_SetupRspTDD768_ul_CCTrCHInformation768,
        _RL_InformationResponse_RL_SetupRspTDD768_dl_CCTrCHInformation768,
        _RL_InformationResponse_RL_SetupRspTDD768_dCH_InformationResponse,
        _RL_InformationResponse_RL_SetupRspTDD768_dsch_InformationResponse,
        _RL_InformationResponse_RL_SetupRspTDD768_usch_InformationResponse,
        _RL_InformationResponse_RL_SetupRspTDD768_neighbouring_UMTS_CellInformation,
        _RL_InformationResponse_RL_SetupRspTDD768_neighbouring_GSM_CellInformation,
        _RL_InformationResponse_RL_SetupRspTDD768_gA_CellAdditionalShapes,
        _RL_InformationResponse_RL_SetupRspTDD768_hCS_Prio,
        _RL_InformationResponse_RL_SetupRspTDD768_timeSlot_RL_SetupRspTDD,
        ____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab,
        _____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__id,
        ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__criticality,
        ___RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions__item_,
        _RL_InformationResponse_RL_SetupRspTDD768_iE_Extensions,
        RL_InformationResponse_RL_SetupRspTDD768,
        RL_InformationResponse_RL_SetupRspTDD768_ExtIEs,
        _RL_InformationResponse_RL_SetupRspTDD768_ExtIEs_val_Extension_0,
        _RL_InformationResponse_RL_SetupRspTDD768_ExtIEs_val_Extension_1,
        __UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab,
        ___UL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab_val_Value_0,
        _UL_CCTrCHInformationList_RL_SetupRspTDD768_id,
        _UL_CCTrCHInformationList_RL_SetupRspTDD768_criticality,
        _UL_CCTrCHInformationList_RL_SetupRspTDD768_value,
        UL_CCTrCHInformationList_RL_SetupRspTDD768,
        UL_CCTrCHInformationListIEs_RL_SetupRspTDD768,
        _UL_CCTrCHInformationListIEs_RL_SetupRspTDD768_val_Value_0,
        _UL_CCTrCHInformationListIE_RL_SetupRspTDD768__item_,
        UL_CCTrCHInformationListIE_RL_SetupRspTDD768,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_ID,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD768_ul_DPCH_Information768,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD768_uL_SIR_Target_CCTrCH_InformationItem_RL_SetupRspTDD768,
        ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab,
        ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id,
        ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality,
        ____UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue,
        __UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_,
        _UL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions,
        UL_CCTrCHInformationItem_RL_SetupRspTDD768,
        UL_CCTrCHInformationItem_RL_SetupRspTDD768_ExtIEs,
        __UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab,
        ___UL_DPCH_InformationList_RL_SetupRspTDD768_id_tab_val_Value_0,
        _UL_DPCH_InformationList_RL_SetupRspTDD768_id,
        _UL_DPCH_InformationList_RL_SetupRspTDD768_criticality,
        _UL_DPCH_InformationList_RL_SetupRspTDD768_value,
        UL_DPCH_InformationList_RL_SetupRspTDD768,
        UL_DPCH_InformationListIEs_RL_SetupRspTDD768,
        _UL_DPCH_InformationListIEs_RL_SetupRspTDD768_val_Value_0,
        _UL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionPeriod,
        _UL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionLength,
        _UL_DPCH_InformationItem_RL_SetupRspTDD768_tDD_DPCHOffset,
        _UL_DPCH_InformationItem_RL_SetupRspTDD768_uL_Timeslot_Information768,
        ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_,
        _UL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions,
        UL_DPCH_InformationItem_RL_SetupRspTDD768,
        UL_DPCH_InformationItem_RL_SetupRspTDD768_ExtIEs,
        __DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab,
        ___DL_CCTrCHInformationList_RL_SetupRspTDD768_id_tab_val_Value_0,
        _DL_CCTrCHInformationList_RL_SetupRspTDD768_id,
        _DL_CCTrCHInformationList_RL_SetupRspTDD768_criticality,
        _DL_CCTrCHInformationList_RL_SetupRspTDD768_value,
        DL_CCTrCHInformationList_RL_SetupRspTDD768,
        DL_CCTrCHInformationListIEs_RL_SetupRspTDD768,
        _DL_CCTrCHInformationListIEs_RL_SetupRspTDD768_val_Value_0,
        _DL_CCTrCHInformationListIE_RL_SetupRspTDD768__item_,
        DL_CCTrCHInformationListIE_RL_SetupRspTDD768,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_ID,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD768_dl_DPCH_Information768,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_Maximum_DL_Power,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD768_cCTrCH_Minimum_DL_Power,
        ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab,
        ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__id,
        ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality,
        ____DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue,
        __DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions__item_,
        _DL_CCTrCHInformationItem_RL_SetupRspTDD768_iE_Extensions,
        DL_CCTrCHInformationItem_RL_SetupRspTDD768,
        DL_CCTrCHInformationItem_RL_SetupRspTDD768_ExtIEs,
        __DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab,
        ___DL_DPCH_InformationList_RL_SetupRspTDD768_id_tab_val_Value_0,
        _DL_DPCH_InformationList_RL_SetupRspTDD768_id,
        _DL_DPCH_InformationList_RL_SetupRspTDD768_criticality,
        _DL_DPCH_InformationList_RL_SetupRspTDD768_value,
        DL_DPCH_InformationList_RL_SetupRspTDD768,
        DL_DPCH_InformationListIEs_RL_SetupRspTDD768,
        _DL_DPCH_InformationListIEs_RL_SetupRspTDD768_val_Value_0,
        _DL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionPeriod,
        _DL_DPCH_InformationItem_RL_SetupRspTDD768_repetitionLength,
        _DL_DPCH_InformationItem_RL_SetupRspTDD768_tDD_DPCHOffset,
        _DL_DPCH_InformationItem_RL_SetupRspTDD768_dL_Timeslot_Information768,
        ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions__item_,
        _DL_DPCH_InformationItem_RL_SetupRspTDD768_iE_Extensions,
        DL_DPCH_InformationItem_RL_SetupRspTDD768,
        DL_DPCH_InformationItem_RL_SetupRspTDD768_ExtIEs,
        ____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkSetupFailureFDD_protocolIEs__item__id_tab_val_Value_5,
        ___RadioLinkSetupFailureFDD_protocolIEs__item__id,
        ___RadioLinkSetupFailureFDD_protocolIEs__item__criticality,
        ___RadioLinkSetupFailureFDD_protocolIEs__item__value,
        __RadioLinkSetupFailureFDD_protocolIEs__item_,
        _RadioLinkSetupFailureFDD_protocolIEs,
        ____RadioLinkSetupFailureFDD_protocolExtensions__item__id_tab,
        ___RadioLinkSetupFailureFDD_protocolExtensions__item__id,
        ____RadioLinkSetupFailureFDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkSetupFailureFDD_protocolExtensions__item__criticality,
        ____RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkSetupFailureFDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupFailureFDD_protocolExtensions__item_,
        _RadioLinkSetupFailureFDD_protocolExtensions,
        RadioLinkSetupFailureFDD,
        RadioLinkSetupFailureFDD_IEs,
        _RadioLinkSetupFailureFDD_IEs_val_Value_0,
        _RadioLinkSetupFailureFDD_IEs_val_Value_1,
        _RadioLinkSetupFailureFDD_IEs_val_Value_2,
        _RadioLinkSetupFailureFDD_IEs_val_Value_3,
        _RadioLinkSetupFailureFDD_IEs_val_Value_4,
        _RadioLinkSetupFailureFDD_IEs_val_Value_5,
        _CauseLevel_RL_SetupFailureFDD_generalCause,
        _CauseLevel_RL_SetupFailureFDD_rLSpecificCause,
        CauseLevel_RL_SetupFailureFDD,
        _GeneralCauseList_RL_SetupFailureFDD_cause,
        ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_SetupFailureFDD_iE_Extensions__item_,
        _GeneralCauseList_RL_SetupFailureFDD_iE_Extensions,
        GeneralCauseList_RL_SetupFailureFDD,
        GeneralCauseItem_RL_SetupFailureFDD_ExtIEs,
        _RLSpecificCauseList_RL_SetupFailureFDD_unsuccessful_RL_InformationRespList_RL_SetupFailureFDD,
        _RLSpecificCauseList_RL_SetupFailureFDD_successful_RL_InformationRespList_RL_SetupFailureFDD,
        ____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_SetupFailureFDD_iE_Extensions,
        RLSpecificCauseList_RL_SetupFailureFDD,
        RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_2,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_3,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_4,
        _RLSpecificCauseItem_RL_SetupFailureFDD_ExtIEs_val_Extension_5,
        ___UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab,
        ____UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab_val_Value_0,
        __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id,
        __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality,
        __UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value,
        _UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_,
        UnsuccessfulRL_InformationResponseList_RL_SetupFailureFDD,
        UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs_val_Value_0,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_ID,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_cause,
        ____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions,
        UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD,
        UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        ___SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab,
        ____SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id_tab_val_Value_0,
        __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__id,
        __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__criticality,
        __SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item__value,
        _SuccessfulRL_InformationResponseList_RL_SetupFailureFDD__item_,
        SuccessfulRL_InformationResponseList_RL_SetupFailureFDD,
        SuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_IEs_val_Value_0,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_ID,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_rL_Set_ID,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_uRA_Information,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sAI,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_gA_Cell,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_gA_AccessPointPosition,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_received_total_wide_band_power,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_not_Used_secondary_CCPCH_Info,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_dl_CodeInformation,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_diversityIndication,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sSDT_SupportIndicator,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maxUL_SIR,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_minUL_SIR,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_closedlooptimingadjustmentmode,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maximumAllowedULTxPower,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_maximumDLTxPower,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_minimumDLTxPower,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_primaryCPICH_Power,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_primaryScramblingCode,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_uL_UARFCN,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_dL_UARFCN,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_not_Used_dSCH_InformationResponse_RL_SetupFailureFDD,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_neighbouring_UMTS_CellInformation,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_neighbouring_GSM_CellInformation,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_pC_Preamble,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_sRB_Delay,
        ____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_11,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_12,
        _____SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_13,
        ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions__item_,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_iE_Extensions,
        SuccessfulRL_InformationResponse_RL_SetupFailureFDD,
        SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_1,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_2,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_3,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_4,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_5,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_6,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_7,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_8,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_9,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_10,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_11,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_12,
        _SuccessfulRL_InformationResponse_RL_SetupFailureFDD_ExtIEs_val_Extension_13,
        _DiversityIndication_RL_SetupFailureFDD_combining,
        _DiversityIndication_RL_SetupFailureFDD_nonCombiningOrFirstRL,
        DiversityIndication_RL_SetupFailureFDD,
        _Combining_RL_SetupFailureFDD_rL_ID,
        ____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Combining_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Combining_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___Combining_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___Combining_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_SetupFailureFDD_iE_Extensions__item_,
        _Combining_RL_SetupFailureFDD_iE_Extensions,
        Combining_RL_SetupFailureFDD,
        CombiningItem_RL_SetupFailureFDD_ExtIEs,
        _CombiningItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        _CombiningItem_RL_SetupFailureFDD_ExtIEs_val_Extension_1,
        _NonCombiningOrFirstRL_RL_SetupFailureFDD_dCH_InformationResponse,
        ____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab,
        _____NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__id,
        ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__criticality,
        ___NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item__extensionValue,
        __NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions__item_,
        _NonCombiningOrFirstRL_RL_SetupFailureFDD_iE_Extensions,
        NonCombiningOrFirstRL_RL_SetupFailureFDD,
        NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs,
        _NonCombiningOrFirstRLItem_RL_SetupFailureFDD_ExtIEs_val_Extension_0,
        RadioLinkSetupFailureFDD_Extensions,
        ____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab,
        _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkSetupFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkSetupFailureTDD_protocolIEs__item__id,
        ___RadioLinkSetupFailureTDD_protocolIEs__item__criticality,
        ___RadioLinkSetupFailureTDD_protocolIEs__item__value,
        __RadioLinkSetupFailureTDD_protocolIEs__item_,
        _RadioLinkSetupFailureTDD_protocolIEs,
        ____RadioLinkSetupFailureTDD_protocolExtensions__item__id_tab,
        ___RadioLinkSetupFailureTDD_protocolExtensions__item__id,
        ____RadioLinkSetupFailureTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkSetupFailureTDD_protocolExtensions__item__criticality,
        ____RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkSetupFailureTDD_protocolExtensions__item__extensionValue,
        __RadioLinkSetupFailureTDD_protocolExtensions__item_,
        _RadioLinkSetupFailureTDD_protocolExtensions,
        RadioLinkSetupFailureTDD,
        RadioLinkSetupFailureTDD_IEs,
        _RadioLinkSetupFailureTDD_IEs_val_Value_0,
        _RadioLinkSetupFailureTDD_IEs_val_Value_1,
        _CauseLevel_RL_SetupFailureTDD_generalCause,
        _CauseLevel_RL_SetupFailureTDD_rLSpecificCause,
        CauseLevel_RL_SetupFailureTDD,
        _GeneralCauseList_RL_SetupFailureTDD_cause,
        ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_SetupFailureTDD_iE_Extensions__item_,
        _GeneralCauseList_RL_SetupFailureTDD_iE_Extensions,
        GeneralCauseList_RL_SetupFailureTDD,
        GeneralCauseItem_RL_SetupFailureTDD_ExtIEs,
        _RLSpecificCauseList_RL_SetupFailureTDD_unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD,
        ____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab,
        _____RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__id,
        ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__criticality,
        ___RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_SetupFailureTDD_iE_Extensions,
        RLSpecificCauseList_RL_SetupFailureTDD,
        RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs,
        _RLSpecificCauseItem_RL_SetupFailureTDD_ExtIEs_val_Extension_0,
        __Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id_tab_val_Value_0,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_id,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_criticality,
        _Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD_value,
        Unsuccessful_RL_InformationRespItem_RL_SetupFailureTDD,
        Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD,
        _Unsuccessful_RL_InformationRespItemIE_RL_SetupFailureTDD_val_Value_0,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_rL_ID,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_cause,
        ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id_tab,
        ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__id,
        ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality_tab,
        ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__criticality,
        ____UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item__extensionValue,
        __UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions__item_,
        _UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_iE_Extensions,
        UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD,
        UnsuccessfulRL_InformationResponse_RL_SetupFailureTDD_ExtIEs,
        RadioLinkSetupFailureTDD_Extensions,
        ____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkAdditionRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        ___RadioLinkAdditionRequestFDD_protocolIEs__item__id,
        ___RadioLinkAdditionRequestFDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionRequestFDD_protocolIEs__item__value,
        __RadioLinkAdditionRequestFDD_protocolIEs__item_,
        _RadioLinkAdditionRequestFDD_protocolIEs,
        ____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkAdditionRequestFDD_protocolExtensions__item__id_tab_val_Extension_15,
        ___RadioLinkAdditionRequestFDD_protocolExtensions__item__id,
        ___RadioLinkAdditionRequestFDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionRequestFDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionRequestFDD_protocolExtensions__item_,
        _RadioLinkAdditionRequestFDD_protocolExtensions,
        RadioLinkAdditionRequestFDD,
        RadioLinkAdditionRequestFDD_IEs,
        _RadioLinkAdditionRequestFDD_IEs_val_Value_0,
        _RadioLinkAdditionRequestFDD_IEs_val_Value_1,
        _RadioLinkAdditionRequestFDD_IEs_val_Value_2,
        ___RL_InformationList_RL_AdditionRqstFDD__item__id_tab,
        ____RL_InformationList_RL_AdditionRqstFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_AdditionRqstFDD__item__id,
        __RL_InformationList_RL_AdditionRqstFDD__item__criticality,
        __RL_InformationList_RL_AdditionRqstFDD__item__value,
        _RL_InformationList_RL_AdditionRqstFDD__item_,
        RL_InformationList_RL_AdditionRqstFDD,
        RL_Information_RL_AdditionRqstFDD_IEs,
        _RL_Information_RL_AdditionRqstFDD_IEs_val_Value_0,
        _RL_Information_RL_AdditionRqstFDD_rL_ID,
        _RL_Information_RL_AdditionRqstFDD_c_ID,
        _RL_Information_RL_AdditionRqstFDD_frameOffset,
        _RL_Information_RL_AdditionRqstFDD_chipOffset,
        _RL_Information_RL_AdditionRqstFDD_diversityControlField,
        _RL_Information_RL_AdditionRqstFDD_primaryCPICH_EcNo,
        _RL_Information_RL_AdditionRqstFDD_not_Used_sSDT_CellID,
        _RL_Information_RL_AdditionRqstFDD_transmitDiversityIndicator,
        ____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id_tab_val_Extension_10,
        ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__id,
        ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_AdditionRqstFDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_AdditionRqstFDD_iE_Extensions__item_,
        _RL_Information_RL_AdditionRqstFDD_iE_Extensions,
        RL_Information_RL_AdditionRqstFDD,
        RL_Information_RL_AdditionRqstFDD_ExtIEs,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_0,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_1,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_2,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_3,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_4,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_5,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_6,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_7,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_8,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_9,
        _RL_Information_RL_AdditionRqstFDD_ExtIEs_val_Extension_10,
        RadioLinkAdditionRequestFDD_Extensions,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_0,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_1,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_2,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_3,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_4,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_5,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_6,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_7,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_8,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_9,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_10,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_11,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_12,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_13,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_14,
        _RadioLinkAdditionRequestFDD_Extensions_val_Extension_15,
        _Additional_HS_Cell_Information_RL_Addition_List__item_,
        Additional_HS_Cell_Information_RL_Addition_List,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Addition_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Addition_ItemIEs,
        Additional_HS_Cell_Information_RL_Addition_ItemIEs_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Add_Req_setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Add_Req_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Add_Req,
        Additional_EDCH_Cell_Information_RL_Add_Req_ExtIEs,
        _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_setup,
        _Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency_addition,
        Setup_Or_Addition_Of_EDCH_On_secondary_UL_Frequency,
        _EDPCH_Information_RLAdditionReq_FDD_maxSet_E_DPDCHs,
        _EDPCH_Information_RLAdditionReq_FDD_ul_PunctureLimit,
        _EDPCH_Information_RLAdditionReq_FDD_e_TFCS_Information,
        _EDPCH_Information_RLAdditionReq_FDD_e_TTI,
        _EDPCH_Information_RLAdditionReq_FDD_e_DPCCH_PO,
        _EDPCH_Information_RLAdditionReq_FDD_e_RGCH_2_IndexStepThreshold,
        _EDPCH_Information_RLAdditionReq_FDD_e_RGCH_3_IndexStepThreshold,
        _EDPCH_Information_RLAdditionReq_FDD_hARQ_Info_for_E_DCH,
        ____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab,
        _____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__id,
        ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__criticality,
        ___EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item__extensionValue,
        __EDPCH_Information_RLAdditionReq_FDD_iE_Extensions__item_,
        _EDPCH_Information_RLAdditionReq_FDD_iE_Extensions,
        EDPCH_Information_RLAdditionReq_FDD,
        EDPCH_Information_RLAdditionReq_FDD_ExtIEs,
        _EDPCH_Information_RLAdditionReq_FDD_ExtIEs_val_Extension_0,
        _EDPCH_Information_RLAdditionReq_FDD_ExtIEs_val_Extension_1,
        ____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkAdditionRequestTDD_protocolIEs__item__id,
        ___RadioLinkAdditionRequestTDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionRequestTDD_protocolIEs__item__value,
        __RadioLinkAdditionRequestTDD_protocolIEs__item_,
        _RadioLinkAdditionRequestTDD_protocolIEs,
        ____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkAdditionRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        ___RadioLinkAdditionRequestTDD_protocolExtensions__item__id,
        ___RadioLinkAdditionRequestTDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionRequestTDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionRequestTDD_protocolExtensions__item_,
        _RadioLinkAdditionRequestTDD_protocolExtensions,
        RadioLinkAdditionRequestTDD,
        RadioLinkAdditionRequestTDD_IEs,
        _RadioLinkAdditionRequestTDD_IEs_val_Value_0,
        _RL_Information_RL_AdditionRqstTDD_rL_ID,
        _RL_Information_RL_AdditionRqstTDD_c_ID,
        _RL_Information_RL_AdditionRqstTDD_frameOffset,
        _RL_Information_RL_AdditionRqstTDD_diversityControlField,
        _RL_Information_RL_AdditionRqstTDD_primaryCCPCH_RSCP,
        _RL_Information_RL_AdditionRqstTDD_dL_TimeSlot_ISCP_Info,
        ____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id_tab_val_Extension_5,
        ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_AdditionRqstTDD_iE_Extensions__item_,
        _RL_Information_RL_AdditionRqstTDD_iE_Extensions,
        RL_Information_RL_AdditionRqstTDD,
        RL_Information_RL_AdditionRqstTDD_ExtIEs,
        _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_0,
        _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_1,
        _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_2,
        _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_3,
        _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_4,
        _RL_Information_RL_AdditionRqstTDD_ExtIEs_val_Extension_5,
        RadioLinkAdditionRequestTDD_Extensions,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_0,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_1,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_2,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_3,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_4,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_5,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_6,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_7,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_8,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_9,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_10,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_11,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_12,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_13,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_14,
        _RadioLinkAdditionRequestTDD_Extensions_val_Extension_15,
        ___UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id,
        __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality,
        __UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value,
        _UL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_,
        UL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        UL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD,
        _UL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD_val_Value_0,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_uplinkStepSizeLCR,
        ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
        UL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs,
        ___DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__id,
        __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__criticality,
        __DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item__value,
        _DL_CCTrCH_InformationList_RL_AdditionRqstTDD__item_,
        DL_CCTrCH_InformationList_RL_AdditionRqstTDD,
        DL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD,
        _DL_CCTrCH_InformationItemIEs_RL_AdditionRqstTDD_val_Value_0,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_downlinkStepSize,
        ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_RL_AdditionRqstTDD,
        DL_CCTrCH_InformationItem_RL_AdditionRqstTDD_ExtIEs,
        ____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionResponseFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkAdditionResponseFDD_protocolIEs__item__id,
        ___RadioLinkAdditionResponseFDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionResponseFDD_protocolIEs__item__value,
        __RadioLinkAdditionResponseFDD_protocolIEs__item_,
        _RadioLinkAdditionResponseFDD_protocolIEs,
        ____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionResponseFDD_protocolExtensions__item__id_tab_val_Extension_4,
        ___RadioLinkAdditionResponseFDD_protocolExtensions__item__id,
        ___RadioLinkAdditionResponseFDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionResponseFDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionResponseFDD_protocolExtensions__item_,
        _RadioLinkAdditionResponseFDD_protocolExtensions,
        RadioLinkAdditionResponseFDD,
        RadioLinkAdditionResponseFDD_IEs,
        _RadioLinkAdditionResponseFDD_IEs_val_Value_0,
        _RadioLinkAdditionResponseFDD_IEs_val_Value_1,
        ___RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab,
        ____RL_InformationResponseList_RL_AdditionRspFDD__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_AdditionRspFDD__item__id,
        __RL_InformationResponseList_RL_AdditionRspFDD__item__criticality,
        __RL_InformationResponseList_RL_AdditionRspFDD__item__value,
        _RL_InformationResponseList_RL_AdditionRspFDD__item_,
        RL_InformationResponseList_RL_AdditionRspFDD,
        RL_InformationResponseItemIEs_RL_AdditionRspFDD,
        _RL_InformationResponseItemIEs_RL_AdditionRspFDD_val_Value_0,
        _RL_InformationResponseItem_RL_AdditionRspFDD_rL_ID,
        _RL_InformationResponseItem_RL_AdditionRspFDD_rL_Set_ID,
        _RL_InformationResponseItem_RL_AdditionRspFDD_uRA_Information,
        _RL_InformationResponseItem_RL_AdditionRspFDD_sAI,
        _RL_InformationResponseItem_RL_AdditionRspFDD_gA_Cell,
        _RL_InformationResponseItem_RL_AdditionRspFDD_gA_AccessPointPosition,
        _RL_InformationResponseItem_RL_AdditionRspFDD_received_total_wide_band_power,
        _RL_InformationResponseItem_RL_AdditionRspFDD_not_Used_secondary_CCPCH_Info,
        _RL_InformationResponseItem_RL_AdditionRspFDD_dl_CodeInformation,
        _RL_InformationResponseItem_RL_AdditionRspFDD_diversityIndication,
        _RL_InformationResponseItem_RL_AdditionRspFDD_sSDT_SupportIndicator,
        _RL_InformationResponseItem_RL_AdditionRspFDD_minUL_SIR,
        _RL_InformationResponseItem_RL_AdditionRspFDD_maxUL_SIR,
        _RL_InformationResponseItem_RL_AdditionRspFDD_closedlooptimingadjustmentmode,
        _RL_InformationResponseItem_RL_AdditionRspFDD_maximumAllowedULTxPower,
        _RL_InformationResponseItem_RL_AdditionRspFDD_maximumDLTxPower,
        _RL_InformationResponseItem_RL_AdditionRspFDD_minimumDLTxPower,
        _RL_InformationResponseItem_RL_AdditionRspFDD_neighbouring_UMTS_CellInformation,
        _RL_InformationResponseItem_RL_AdditionRspFDD_neighbouring_GSM_CellInformation,
        _RL_InformationResponseItem_RL_AdditionRspFDD_pC_Preamble,
        _RL_InformationResponseItem_RL_AdditionRspFDD_sRB_Delay,
        _RL_InformationResponseItem_RL_AdditionRspFDD_primaryCPICH_Power,
        ____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_11,
        _____RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_12,
        ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_AdditionRspFDD_iE_Extensions,
        RL_InformationResponseItem_RL_AdditionRspFDD,
        RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_5,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_6,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_7,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_8,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_9,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_10,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_11,
        _RL_InformationResponseItem_RL_AdditionRspFDD_ExtIEs_val_Extension_12,
        __DL_CodeInformationList_RL_AdditionRspFDD_id_tab,
        ___DL_CodeInformationList_RL_AdditionRspFDD_id_tab_val_Value_0,
        _DL_CodeInformationList_RL_AdditionRspFDD_id,
        _DL_CodeInformationList_RL_AdditionRspFDD_criticality,
        _DL_CodeInformationList_RL_AdditionRspFDD_value,
        DL_CodeInformationList_RL_AdditionRspFDD,
        DL_CodeInformationListIEs_RL_AdditionRspFDD,
        _DL_CodeInformationListIEs_RL_AdditionRspFDD_val_Value_0,
        _DiversityIndication_RL_AdditionRspFDD_combining,
        _DiversityIndication_RL_AdditionRspFDD_nonCombining,
        DiversityIndication_RL_AdditionRspFDD,
        _Combining_RL_AdditionRspFDD_rL_ID,
        ____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab,
        _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Combining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Combining_RL_AdditionRspFDD_iE_Extensions__item__id,
        ___Combining_RL_AdditionRspFDD_iE_Extensions__item__criticality,
        ___Combining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_AdditionRspFDD_iE_Extensions__item_,
        _Combining_RL_AdditionRspFDD_iE_Extensions,
        Combining_RL_AdditionRspFDD,
        CombiningItem_RL_AdditionRspFDD_ExtIEs,
        _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0,
        _CombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_1,
        _NonCombining_RL_AdditionRspFDD_dCH_InformationResponse,
        ____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab,
        _____NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__id,
        ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__criticality,
        ___NonCombining_RL_AdditionRspFDD_iE_Extensions__item__extensionValue,
        __NonCombining_RL_AdditionRspFDD_iE_Extensions__item_,
        _NonCombining_RL_AdditionRspFDD_iE_Extensions,
        NonCombining_RL_AdditionRspFDD,
        NonCombiningItem_RL_AdditionRspFDD_ExtIEs,
        _NonCombiningItem_RL_AdditionRspFDD_ExtIEs_val_Extension_0,
        RadioLinkAdditionResponseFDD_Extensions,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_0,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_1,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_2,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_3,
        _RadioLinkAdditionResponseFDD_Extensions_val_Extension_4,
        _Additional_HS_Cell_Change_Information_Response_List__item_,
        Additional_HS_Cell_Change_Information_Response_List,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_hSDSCH_RNTI,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_hS_DSCH_Secondary_Serving_Cell_Change_Information_Response,
        ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Change_Information_Response_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Change_Information_Response_ItemIEs,
        Additional_HS_Cell_Change_Information_Response_ItemIEs_ExtIEs,
        ____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionResponseTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkAdditionResponseTDD_protocolIEs__item__id,
        ___RadioLinkAdditionResponseTDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionResponseTDD_protocolIEs__item__value,
        __RadioLinkAdditionResponseTDD_protocolIEs__item_,
        _RadioLinkAdditionResponseTDD_protocolIEs,
        ____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkAdditionResponseTDD_protocolExtensions__item__id_tab_val_Extension_15,
        ___RadioLinkAdditionResponseTDD_protocolExtensions__item__id,
        ___RadioLinkAdditionResponseTDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionResponseTDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionResponseTDD_protocolExtensions__item_,
        _RadioLinkAdditionResponseTDD_protocolExtensions,
        RadioLinkAdditionResponseTDD,
        RadioLinkAdditionResponseTDD_IEs,
        _RadioLinkAdditionResponseTDD_IEs_val_Value_0,
        _RadioLinkAdditionResponseTDD_IEs_val_Value_1,
        _RL_InformationResponse_RL_AdditionRspTDD_rL_ID,
        _RL_InformationResponse_RL_AdditionRspTDD_uRA_Information,
        _RL_InformationResponse_RL_AdditionRspTDD_sAI,
        _RL_InformationResponse_RL_AdditionRspTDD_gA_Cell,
        _RL_InformationResponse_RL_AdditionRspTDD_gA_AccessPointPosition,
        _RL_InformationResponse_RL_AdditionRspTDD_ul_TimeSlot_ISCP_Info,
        _RL_InformationResponse_RL_AdditionRspTDD_minUL_SIR,
        _RL_InformationResponse_RL_AdditionRspTDD_maxUL_SIR,
        _RL_InformationResponse_RL_AdditionRspTDD_maximumAllowedULTxPower,
        _RL_InformationResponse_RL_AdditionRspTDD_maximumDLTxPower,
        _RL_InformationResponse_RL_AdditionRspTDD_minimumDLTxPower,
        _RL_InformationResponse_RL_AdditionRspTDD_pCCPCH_Power,
        _RL_InformationResponse_RL_AdditionRspTDD_timingAdvanceApplied,
        _RL_InformationResponse_RL_AdditionRspTDD_alphaValue,
        _RL_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_RL_AdditionRspTDD_synchronisationConfiguration,
        _RL_InformationResponse_RL_AdditionRspTDD_secondary_CCPCH_Info_TDD,
        _RL_InformationResponse_RL_AdditionRspTDD_ul_CCTrCHInformation,
        _RL_InformationResponse_RL_AdditionRspTDD_dl_CCTrCHInformation,
        _RL_InformationResponse_RL_AdditionRspTDD_dCH_Information,
        _RL_InformationResponse_RL_AdditionRspTDD_dSCH_InformationResponse,
        _RL_InformationResponse_RL_AdditionRspTDD_uSCH_InformationResponse,
        _RL_InformationResponse_RL_AdditionRspTDD_neighbouring_UMTS_CellInformation,
        _RL_InformationResponse_RL_AdditionRspTDD_neighbouring_GSM_CellInformation,
        ____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id,
        ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ___RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_RL_AdditionRspTDD_iE_Extensions,
        RL_InformationResponse_RL_AdditionRspTDD,
        RL_InformationResponse_RL_AdditionRspTDD_ExtIEs,
        _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_0,
        _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_1,
        _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_2,
        _RL_InformationResponse_RL_AdditionRspTDD_ExtIEs_val_Extension_3,
        __UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab,
        ___UL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _UL_CCTrCHInformationList_RL_AdditionRspTDD_id,
        _UL_CCTrCHInformationList_RL_AdditionRspTDD_criticality,
        _UL_CCTrCHInformationList_RL_AdditionRspTDD_value,
        UL_CCTrCHInformationList_RL_AdditionRspTDD,
        UL_CCTrCHInformationListIEs_RL_AdditionRspTDD,
        _UL_CCTrCHInformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _UL_CCTrCHInformationListIE_RL_AdditionRspTDD__item_,
        UL_CCTrCHInformationListIE_RL_AdditionRspTDD,
        _UL_CCTrCHInformationItem_RL_AdditionRspTDD_cCTrCH_ID,
        _UL_CCTrCHInformationItem_RL_AdditionRspTDD_ul_DPCH_Information,
        ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _UL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions,
        UL_CCTrCHInformationItem_RL_AdditionRspTDD,
        UL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs,
        __UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab,
        ___UL_DPCH_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationList_RL_AdditionRspTDD_id,
        _UL_DPCH_InformationList_RL_AdditionRspTDD_criticality,
        _UL_DPCH_InformationList_RL_AdditionRspTDD_value,
        UL_DPCH_InformationList_RL_AdditionRspTDD,
        UL_DPCH_InformationListIEs_RL_AdditionRspTDD,
        _UL_DPCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionLength,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        UL_DPCH_InformationItem_RL_AdditionRspTDD,
        UL_DPCH_InformationItem_RL_AdditionRspTDD_ExtIEs,
        __DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab,
        ___DL_CCTrCHInformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DL_CCTrCHInformationList_RL_AdditionRspTDD_id,
        _DL_CCTrCHInformationList_RL_AdditionRspTDD_criticality,
        _DL_CCTrCHInformationList_RL_AdditionRspTDD_value,
        DL_CCTrCHInformationList_RL_AdditionRspTDD,
        DL_CCTrCHInformationListIEs_RL_AdditionRspTDD,
        _DL_CCTrCHInformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _DL_CCTrCHInformationListIE_RL_AdditionRspTDD__item_,
        DL_CCTrCHInformationListIE_RL_AdditionRspTDD,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD_cCTrCH_ID,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD_dl_DPCH_Information,
        ____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD_iE_Extensions,
        DL_CCTrCHInformationItem_RL_AdditionRspTDD,
        DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD_ExtIEs_val_Extension_1,
        __DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab,
        ___DL_DPCH_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationList_RL_AdditionRspTDD_id,
        _DL_DPCH_InformationList_RL_AdditionRspTDD_criticality,
        _DL_DPCH_InformationList_RL_AdditionRspTDD_value,
        DL_DPCH_InformationList_RL_AdditionRspTDD,
        DL_DPCH_InformationListIEs_RL_AdditionRspTDD,
        _DL_DPCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD_repetitionLength,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        DL_DPCH_InformationItem_RL_AdditionRspTDD,
        DL_DPCH_InformationItem_RL_AdditionRspTDD_ExtIEs,
        _DCH_Information_RL_AdditionRspTDD_diversityIndication,
        ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_Information_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DCH_Information_RL_AdditionRspTDD_iE_Extensions__item_,
        _DCH_Information_RL_AdditionRspTDD_iE_Extensions,
        DCH_Information_RL_AdditionRspTDD,
        DCH_Information_RL_AdditionRspTDD_ExtIEs,
        _DiversityIndication_RL_AdditionRspTDD_combining,
        _DiversityIndication_RL_AdditionRspTDD_nonCombining,
        DiversityIndication_RL_AdditionRspTDD,
        _Combining_RL_AdditionRspTDD_rL_ID,
        ____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        _____Combining_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___Combining_RL_AdditionRspTDD_iE_Extensions__item__id,
        ___Combining_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ___Combining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __Combining_RL_AdditionRspTDD_iE_Extensions__item_,
        _Combining_RL_AdditionRspTDD_iE_Extensions,
        Combining_RL_AdditionRspTDD,
        CombiningItem_RL_AdditionRspTDD_ExtIEs,
        _CombiningItem_RL_AdditionRspTDD_ExtIEs_val_Extension_0,
        _NonCombining_RL_AdditionRspTDD_dCH_InformationResponse,
        ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___NonCombining_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __NonCombining_RL_AdditionRspTDD_iE_Extensions__item_,
        _NonCombining_RL_AdditionRspTDD_iE_Extensions,
        NonCombining_RL_AdditionRspTDD,
        NonCombiningItem_RL_AdditionRspTDD_ExtIEs,
        __DSCH_InformationResponse_RL_AdditionRspTDD_id_tab,
        ___DSCH_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DSCH_InformationResponse_RL_AdditionRspTDD_id,
        _DSCH_InformationResponse_RL_AdditionRspTDD_criticality,
        _DSCH_InformationResponse_RL_AdditionRspTDD_value,
        DSCH_InformationResponse_RL_AdditionRspTDD,
        DSCH_InformationListIEs_RL_AdditionRspTDD,
        _DSCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _DSCH_InformationListIE_RL_AdditionRspTDD__item_,
        DSCH_InformationListIE_RL_AdditionRspTDD,
        _DSCHInformationItem_RL_AdditionRspTDD_dsch_ID,
        _DSCHInformationItem_RL_AdditionRspTDD_transportFormatManagement,
        _DSCHInformationItem_RL_AdditionRspTDD_dSCH_FlowControlInformation,
        _DSCHInformationItem_RL_AdditionRspTDD_diversityIndication,
        ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _DSCHInformationItem_RL_AdditionRspTDD_iE_Extensions,
        DSCHInformationItem_RL_AdditionRspTDD,
        DSCHInformationItem_RL_AdditionRspTDD_ExtIEs,
        _DiversityIndication_RL_AdditionRspTDD2_bindingID,
        _DiversityIndication_RL_AdditionRspTDD2_transportLayerAddress,
        ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id_tab,
        ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__id,
        ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality_tab,
        ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__criticality,
        ____DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue_tab,
        ___DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item__extensionValue,
        __DiversityIndication_RL_AdditionRspTDD2_iE_Extensions__item_,
        _DiversityIndication_RL_AdditionRspTDD2_iE_Extensions,
        DiversityIndication_RL_AdditionRspTDD2,
        DiversityIndication_RL_AdditionRspTDD2_ExtIEs,
        __USCH_InformationResponse_RL_AdditionRspTDD_id_tab,
        ___USCH_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0,
        _USCH_InformationResponse_RL_AdditionRspTDD_id,
        _USCH_InformationResponse_RL_AdditionRspTDD_criticality,
        _USCH_InformationResponse_RL_AdditionRspTDD_value,
        USCH_InformationResponse_RL_AdditionRspTDD,
        USCH_InformationListIEs_RL_AdditionRspTDD,
        _USCH_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _USCH_InformationListIE_RL_AdditionRspTDD__item_,
        USCH_InformationListIE_RL_AdditionRspTDD,
        _USCHInformationItem_RL_AdditionRspTDD_uSCH_ID,
        _USCHInformationItem_RL_AdditionRspTDD_transportFormatManagement,
        _USCHInformationItem_RL_AdditionRspTDD_diversityIndication,
        ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __USCHInformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _USCHInformationItem_RL_AdditionRspTDD_iE_Extensions,
        USCHInformationItem_RL_AdditionRspTDD,
        USCHInformationItem_RL_AdditionRspTDD_ExtIEs,
        RadioLinkAdditionResponseTDD_Extensions,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_0,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_1,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_2,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_3,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_4,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_5,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_6,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_7,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_8,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_9,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_10,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_11,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_12,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_13,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_14,
        _RadioLinkAdditionResponseTDD_Extensions_val_Extension_15,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_rL_ID,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_uRA_Information,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_sAI,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_gA_Cell,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_gA_AccessPointPosition,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_TimeSlot_ISCP_LCR_Info,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_maxUL_SIR,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_minUL_SIR,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_pCCPCH_Power,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_maximumAllowedULTxPower,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_maximumDLTxPower,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_minimumDLTxPower,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_alphaValue,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_PhysCH_SF_Variation,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_synchronisationConfiguration,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_secondary_LCR_CCPCH_Info_TDD,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_ul_CCTrCH_LCR_Information,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_dl_CCTrCH_LCR_Information,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_dCH_InformationResponse,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_dsch_LCR_InformationResponse,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_usch_LCR_InformationResponse,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_neighbouring_UMTS_CellInformation,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_neighbouring_GSM_CellInformation,
        ____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id_tab_val_Extension_7,
        ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__id,
        ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ___RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions__item_,
        _RL_LCR_InformationResponse_RL_AdditionRspTDD_iE_Extensions,
        RL_LCR_InformationResponse_RL_AdditionRspTDD,
        RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_0,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_1,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_2,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_3,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_4,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_5,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_6,
        _RL_LCR_InformationResponseList_RL_AdditionRspTDD_ExtIEs_val_Extension_7,
        __UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab,
        ___UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id,
        _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality,
        _UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value,
        UL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD,
        UL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        _UL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD__item_,
        UL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD,
        _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_cCTrCH_ID,
        _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ul_DPCH_LCR_Information,
        ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD,
        UL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs,
        __UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab,
        ___UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id,
        _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality,
        _UL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value,
        UL_DPCH_LCR_InformationList_RL_AdditionRspTDD,
        UL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        _UL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionPeriod,
        _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionLength,
        _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset,
        _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_uL_TimeslotLCR_Information,
        ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD,
        UL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs,
        __DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab,
        ___DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_id,
        _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_criticality,
        _DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD_value,
        DL_CCTrCH_LCR_InformationList_RL_AdditionRspTDD,
        DL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        _DL_CCTrCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD__item_,
        DL_CCTrCH_LCR_InformationListIE_RL_AdditionRspTDD,
        _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_cCTrCH_ID,
        _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_dl_DPCH_LCR_Information,
        ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD,
        DL_CCTrCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs,
        __DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab,
        ___DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_id,
        _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_criticality,
        _DL_DPCH_LCR_InformationList_RL_AdditionRspTDD_value,
        DL_DPCH_LCR_InformationList_RL_AdditionRspTDD,
        DL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        _DL_DPCH_LCR_InformationListIEs_RL_AdditionRspTDD_val_Value_0,
        _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionPeriod,
        _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_repetitionLength,
        _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tDD_DPCHOffset,
        _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_dL_TimeslotLCR_Information,
        _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_tSTD_Indicator,
        ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD,
        DL_DPCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs,
        __DCH_InformationResponseList_RL_AdditionRspTDD_id_tab,
        ___DCH_InformationResponseList_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_AdditionRspTDD_id,
        _DCH_InformationResponseList_RL_AdditionRspTDD_criticality,
        _DCH_InformationResponseList_RL_AdditionRspTDD_value,
        DCH_InformationResponseList_RL_AdditionRspTDD,
        DCH_InformationResponseListIEs_RL_AdditionRspTDD,
        _DCH_InformationResponseListIEs_RL_AdditionRspTDD_val_Value_0,
        __DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab,
        ___DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0,
        _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_id,
        _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality,
        _DSCH_LCR_InformationResponse_RL_AdditionRspTDD_value,
        DSCH_LCR_InformationResponse_RL_AdditionRspTDD,
        DSCH_LCR_InformationList_RL_AdditionRspTDD,
        _DSCH_LCR_InformationList_RL_AdditionRspTDD_val_Value_0,
        _DSCH_LCR_InformationListIEs_RL_AdditionRspTDD__item_,
        DSCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        _DSCH_LCR_InformationItem_RL_AdditionRspTDD_dsch_ID,
        _DSCH_LCR_InformationItem_RL_AdditionRspTDD_dSCH_FlowControlInformation,
        _DSCH_LCR_InformationItem_RL_AdditionRspTDD_bindingID,
        _DSCH_LCR_InformationItem_RL_AdditionRspTDD_transportLayerAddress,
        _DSCH_LCR_InformationItem_RL_AdditionRspTDD_transportFormatManagement,
        ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _DSCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        DSCH_LCR_InformationItem_RL_AdditionRspTDD,
        DSCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs,
        __USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab,
        ___USCH_LCR_InformationResponse_RL_AdditionRspTDD_id_tab_val_Value_0,
        _USCH_LCR_InformationResponse_RL_AdditionRspTDD_id,
        _USCH_LCR_InformationResponse_RL_AdditionRspTDD_criticality,
        _USCH_LCR_InformationResponse_RL_AdditionRspTDD_value,
        USCH_LCR_InformationResponse_RL_AdditionRspTDD,
        USCH_LCR_InformationList_RL_AdditionRspTDD,
        _USCH_LCR_InformationList_RL_AdditionRspTDD_val_Value_0,
        _USCH_LCR_InformationListIEs_RL_AdditionRspTDD__item_,
        USCH_LCR_InformationListIEs_RL_AdditionRspTDD,
        _USCH_LCR_InformationItem_RL_AdditionRspTDD_usch_ID,
        _USCH_LCR_InformationItem_RL_AdditionRspTDD_transportFormatManagement,
        _USCH_LCR_InformationItem_RL_AdditionRspTDD_diversityIndication,
        ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id_tab,
        ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__id,
        ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality_tab,
        ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__criticality,
        ____USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue_tab,
        ___USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item__extensionValue,
        __USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions__item_,
        _USCH_LCR_InformationItem_RL_AdditionRspTDD_iE_Extensions,
        USCH_LCR_InformationItem_RL_AdditionRspTDD,
        USCH_LCR_InformationItem_RL_AdditionRspTDD_ExtIEs,
        _RL_InformationResponse_RL_AdditionRspTDD768_rL_ID,
        _RL_InformationResponse_RL_AdditionRspTDD768_uRA_Information,
        _RL_InformationResponse_RL_AdditionRspTDD768_sAI,
        _RL_InformationResponse_RL_AdditionRspTDD768_gA_Cell,
        _RL_InformationResponse_RL_AdditionRspTDD768_gA_AccessPointPosition,
        _RL_InformationResponse_RL_AdditionRspTDD768_ul_TimeSlot_ISCP_Info,
        _RL_InformationResponse_RL_AdditionRspTDD768_minUL_SIR,
        _RL_InformationResponse_RL_AdditionRspTDD768_maxUL_SIR,
        _RL_InformationResponse_RL_AdditionRspTDD768_maximumAllowedULTxPower,
        _RL_InformationResponse_RL_AdditionRspTDD768_maximumDLTxPower,
        _RL_InformationResponse_RL_AdditionRspTDD768_minimumDLTxPower,
        _RL_InformationResponse_RL_AdditionRspTDD768_pCCPCH_Power,
        _RL_InformationResponse_RL_AdditionRspTDD768_timingAdvanceApplied,
        _RL_InformationResponse_RL_AdditionRspTDD768_alphaValue,
        _RL_InformationResponse_RL_AdditionRspTDD768_ul_PhysCH_SF_Variation,
        _RL_InformationResponse_RL_AdditionRspTDD768_synchronisationConfiguration,
        _RL_InformationResponse_RL_AdditionRspTDD768_secondary_CCPCH_Info_TDD768,
        _RL_InformationResponse_RL_AdditionRspTDD768_ul_CCTrCHInformation768,
        _RL_InformationResponse_RL_AdditionRspTDD768_dl_CCTrCHInformation768,
        _RL_InformationResponse_RL_AdditionRspTDD768_dCH_Information,
        _RL_InformationResponse_RL_AdditionRspTDD768_dSCH_InformationResponse,
        _RL_InformationResponse_RL_AdditionRspTDD768_uSCH_InformationResponse,
        _RL_InformationResponse_RL_AdditionRspTDD768_neighbouring_UMTS_CellInformation,
        _RL_InformationResponse_RL_AdditionRspTDD768_neighbouring_GSM_CellInformation,
        _RL_InformationResponse_RL_AdditionRspTDD768_gA_CellAdditionalShapes,
        _RL_InformationResponse_RL_AdditionRspTDD768_hCS_Prio,
        ____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab,
        _____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__id,
        ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__criticality,
        ___RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions__item_,
        _RL_InformationResponse_RL_AdditionRspTDD768_iE_Extensions,
        RL_InformationResponse_RL_AdditionRspTDD768,
        RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs,
        _RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs_val_Extension_0,
        _RL_InformationResponse_RL_AdditionRspTDD768_ExtIEs_val_Extension_1,
        __UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab,
        ___UL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab_val_Value_0,
        _UL_CCTrCHInformationList_RL_AdditionRspTDD768_id,
        _UL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality,
        _UL_CCTrCHInformationList_RL_AdditionRspTDD768_value,
        UL_CCTrCHInformationList_RL_AdditionRspTDD768,
        UL_CCTrCHInformationListIEs_RL_AdditionRspTDD768,
        _UL_CCTrCHInformationListIEs_RL_AdditionRspTDD768_val_Value_0,
        _UL_CCTrCHInformationListIE_RL_AdditionRspTDD768__item_,
        UL_CCTrCHInformationListIE_RL_AdditionRspTDD768,
        _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_ID,
        _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_ul_DPCH_Information768,
        ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab,
        ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id,
        ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality,
        ____UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue,
        __UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_,
        _UL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions,
        UL_CCTrCHInformationItem_RL_AdditionRspTDD768,
        UL_CCTrCHInformationItem_RL_AdditionRspTDD768_ExtIEs,
        __UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab,
        ___UL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab_val_Value_0,
        _UL_DPCH_InformationList_RL_AdditionRspTDD768_id,
        _UL_DPCH_InformationList_RL_AdditionRspTDD768_criticality,
        _UL_DPCH_InformationList_RL_AdditionRspTDD768_value,
        UL_DPCH_InformationList_RL_AdditionRspTDD768,
        UL_DPCH_InformationListIEs_RL_AdditionRspTDD768,
        _UL_DPCH_InformationListIEs_RL_AdditionRspTDD768_val_Value_0,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionPeriod,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionLength,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD768_tDD_DPCHOffset,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD768_uL_Timeslot_Information768,
        ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id,
        ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_,
        _UL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions,
        UL_DPCH_InformationItem_RL_AdditionRspTDD768,
        UL_DPCH_InformationItem_RL_AdditionRspTDD768_ExtIEs,
        __DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab,
        ___DL_CCTrCHInformationList_RL_AdditionRspTDD768_id_tab_val_Value_0,
        _DL_CCTrCHInformationList_RL_AdditionRspTDD768_id,
        _DL_CCTrCHInformationList_RL_AdditionRspTDD768_criticality,
        _DL_CCTrCHInformationList_RL_AdditionRspTDD768_value,
        DL_CCTrCHInformationList_RL_AdditionRspTDD768,
        DL_CCTrCHInformationListIEs_RL_AdditionRspTDD768,
        _DL_CCTrCHInformationListIEs_RL_AdditionRspTDD768_val_Value_0,
        _DL_CCTrCHInformationListIE_RL_AdditionRspTDD768__item_,
        DL_CCTrCHInformationListIE_RL_AdditionRspTDD768,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_ID,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_dl_DPCH_Information768,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_Maximum_DL_Power,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_cCTrCH_Minimum_DL_Power,
        ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab,
        ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id,
        ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality,
        ____DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue,
        __DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions__item_,
        _DL_CCTrCHInformationItem_RL_AdditionRspTDD768_iE_Extensions,
        DL_CCTrCHInformationItem_RL_AdditionRspTDD768,
        DL_CCTrCHInformationItem_RL_AdditionRspTDD768_ExtIEs,
        __DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab,
        ___DL_DPCH_InformationList_RL_AdditionRspTDD768_id_tab_val_Value_0,
        _DL_DPCH_InformationList_RL_AdditionRspTDD768_id,
        _DL_DPCH_InformationList_RL_AdditionRspTDD768_criticality,
        _DL_DPCH_InformationList_RL_AdditionRspTDD768_value,
        DL_DPCH_InformationList_RL_AdditionRspTDD768,
        DL_DPCH_InformationListIEs_RL_AdditionRspTDD768,
        _DL_DPCH_InformationListIEs_RL_AdditionRspTDD768_val_Value_0,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionPeriod,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD768_repetitionLength,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD768_tDD_DPCHOffset,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD768_dL_Timeslot_Information768,
        ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__id,
        ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions__item_,
        _DL_DPCH_InformationItem_RL_AdditionRspTDD768_iE_Extensions,
        DL_DPCH_InformationItem_RL_AdditionRspTDD768,
        DL_DPCH_InformationItem_RL_AdditionRspTDD768_ExtIEs,
        ____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionFailureFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkAdditionFailureFDD_protocolIEs__item__id,
        ___RadioLinkAdditionFailureFDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionFailureFDD_protocolIEs__item__value,
        __RadioLinkAdditionFailureFDD_protocolIEs__item_,
        _RadioLinkAdditionFailureFDD_protocolIEs,
        ____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkAdditionFailureFDD_protocolExtensions__item__id_tab_val_Extension_4,
        ___RadioLinkAdditionFailureFDD_protocolExtensions__item__id,
        ___RadioLinkAdditionFailureFDD_protocolExtensions__item__criticality,
        ___RadioLinkAdditionFailureFDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionFailureFDD_protocolExtensions__item_,
        _RadioLinkAdditionFailureFDD_protocolExtensions,
        RadioLinkAdditionFailureFDD,
        RadioLinkAdditionFailureFDD_IEs,
        _RadioLinkAdditionFailureFDD_IEs_val_Value_0,
        _RadioLinkAdditionFailureFDD_IEs_val_Value_1,
        _CauseLevel_RL_AdditionFailureFDD_generalCause,
        _CauseLevel_RL_AdditionFailureFDD_rLSpecificCause,
        CauseLevel_RL_AdditionFailureFDD,
        _GeneralCauseList_RL_AdditionFailureFDD_cause,
        ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions__item_,
        _GeneralCauseList_RL_AdditionFailureFDD_iE_Extensions,
        GeneralCauseList_RL_AdditionFailureFDD,
        GeneralCauseItem_RL_AdditionFailureFDD_ExtIEs,
        _RLSpecificCauseList_RL_AdditionFailureFDD_unsuccessful_RL_InformationRespList_RL_AdditionFailureFDD,
        _RLSpecificCauseList_RL_AdditionFailureFDD_successful_RL_InformationRespList_RL_AdditionFailureFDD,
        ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_AdditionFailureFDD_iE_Extensions,
        RLSpecificCauseList_RL_AdditionFailureFDD,
        RLSpecificCauseItem_RL_AdditionFailureFDD_ExtIEs,
        ___UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab,
        ____UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab_val_Value_0,
        __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id,
        __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality,
        __UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value,
        _UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_,
        UnsuccessfulRL_InformationResponseList_RL_AdditionFailureFDD,
        UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs_val_Value_0,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_ID,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_cause,
        ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality_tab,
        ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue_tab,
        ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions,
        UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD,
        UnsuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs,
        ___SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab,
        ____SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id_tab_val_Value_0,
        __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__id,
        __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__criticality,
        __SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item__value,
        _SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD__item_,
        SuccessfulRL_InformationResponseList_RL_AdditionFailureFDD,
        SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_IEs_val_Value_0,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_ID,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_rL_Set_ID,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_uRA_Information,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sAI,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_gA_Cell,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_gA_AccessPointPosition,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_received_total_wide_band_power,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_not_Used_secondary_CCPCH_Info,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_dl_CodeInformation,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_diversityIndication,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sSDT_SupportIndicator,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_minUL_SIR,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maxUL_SIR,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_closedlooptimingadjustmentmode,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maximumAllowedULTxPower,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_maximumDLTxPower,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_minimumDLTxPower,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_neighbouring_UMTS_CellInformation,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_neighbouring_GSM_CellInformation,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_primaryCPICH_Power,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_pC_Preamble,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_sRB_Delay,
        ____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_10,
        _____SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_11,
        ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ___SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions__item_,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_iE_Extensions,
        SuccessfulRL_InformationResponse_RL_AdditionFailureFDD,
        SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_0,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_1,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_2,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_3,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_4,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_5,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_6,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_7,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_8,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_9,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_10,
        _SuccessfulRL_InformationResponse_RL_AdditionFailureFDD_ExtIEs_val_Extension_11,
        __DL_CodeInformationList_RL_AdditionFailureFDD_id_tab,
        ___DL_CodeInformationList_RL_AdditionFailureFDD_id_tab_val_Value_0,
        _DL_CodeInformationList_RL_AdditionFailureFDD_id,
        _DL_CodeInformationList_RL_AdditionFailureFDD_criticality,
        _DL_CodeInformationList_RL_AdditionFailureFDD_value,
        DL_CodeInformationList_RL_AdditionFailureFDD,
        DL_CodeInformationListIEs_RL_AdditionFailureFDD,
        _DL_CodeInformationListIEs_RL_AdditionFailureFDD_val_Value_0,
        _DiversityIndication_RL_AdditionFailureFDD_combining,
        _DiversityIndication_RL_AdditionFailureFDD_nonCombining,
        DiversityIndication_RL_AdditionFailureFDD,
        _Combining_RL_AdditionFailureFDD_rL_ID,
        ____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____Combining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ___Combining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __Combining_RL_AdditionFailureFDD_iE_Extensions__item_,
        _Combining_RL_AdditionFailureFDD_iE_Extensions,
        Combining_RL_AdditionFailureFDD,
        CombiningItem_RL_AdditionFailureFDD_ExtIEs,
        _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0,
        _CombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_1,
        _NonCombining_RL_AdditionFailureFDD_dCH_InformationResponse,
        ____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab,
        _____NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__id,
        ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__criticality,
        ___NonCombining_RL_AdditionFailureFDD_iE_Extensions__item__extensionValue,
        __NonCombining_RL_AdditionFailureFDD_iE_Extensions__item_,
        _NonCombining_RL_AdditionFailureFDD_iE_Extensions,
        NonCombining_RL_AdditionFailureFDD,
        NonCombiningItem_RL_AdditionFailureFDD_ExtIEs,
        _NonCombiningItem_RL_AdditionFailureFDD_ExtIEs_val_Extension_0,
        RadioLinkAdditionFailureFDD_Extensions,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_0,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_1,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_2,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_3,
        _RadioLinkAdditionFailureFDD_Extensions_val_Extension_4,
        ____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab,
        _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkAdditionFailureTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkAdditionFailureTDD_protocolIEs__item__id,
        ___RadioLinkAdditionFailureTDD_protocolIEs__item__criticality,
        ___RadioLinkAdditionFailureTDD_protocolIEs__item__value,
        __RadioLinkAdditionFailureTDD_protocolIEs__item_,
        _RadioLinkAdditionFailureTDD_protocolIEs,
        ____RadioLinkAdditionFailureTDD_protocolExtensions__item__id_tab,
        ___RadioLinkAdditionFailureTDD_protocolExtensions__item__id,
        ____RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkAdditionFailureTDD_protocolExtensions__item__criticality,
        ____RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkAdditionFailureTDD_protocolExtensions__item__extensionValue,
        __RadioLinkAdditionFailureTDD_protocolExtensions__item_,
        _RadioLinkAdditionFailureTDD_protocolExtensions,
        RadioLinkAdditionFailureTDD,
        RadioLinkAdditionFailureTDD_IEs,
        _RadioLinkAdditionFailureTDD_IEs_val_Value_0,
        _RadioLinkAdditionFailureTDD_IEs_val_Value_1,
        _CauseLevel_RL_AdditionFailureTDD_generalCause,
        _CauseLevel_RL_AdditionFailureTDD_rLSpecificCause,
        CauseLevel_RL_AdditionFailureTDD,
        _GeneralCauseList_RL_AdditionFailureTDD_cause,
        ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id,
        ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions__item_,
        _GeneralCauseList_RL_AdditionFailureTDD_iE_Extensions,
        GeneralCauseList_RL_AdditionFailureTDD,
        GeneralCauseItem_RL_AdditionFailureTDD_ExtIEs,
        _RLSpecificCauseList_RL_AdditionFailureTDD_unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD,
        ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions__item_,
        _RLSpecificCauseList_RL_AdditionFailureTDD_iE_Extensions,
        RLSpecificCauseList_RL_AdditionFailureTDD,
        RLSpecificCauseItem_RL_AdditionFailureTDD_ExtIEs,
        __Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab,
        ___Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id_tab_val_Value_0,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_id,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_criticality,
        _Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD_value,
        Unsuccessful_RL_InformationRespItem_RL_AdditionFailureTDD,
        Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD,
        _Unsuccessful_RL_InformationRespItemIE_RL_AdditionFailureTDD_val_Value_0,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_rL_ID,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_cause,
        ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id_tab,
        ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__id,
        ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality_tab,
        ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__criticality,
        ____UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue_tab,
        ___UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item__extensionValue,
        __UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions__item_,
        _UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_iE_Extensions,
        UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD,
        UnsuccessfulRL_InformationResponse_RL_AdditionFailureTDD_ExtIEs,
        RadioLinkAdditionFailureTDD_Extensions,
        ____RadioLinkDeletionRequest_protocolIEs__item__id_tab,
        _____RadioLinkDeletionRequest_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkDeletionRequest_protocolIEs__item__id,
        ___RadioLinkDeletionRequest_protocolIEs__item__criticality,
        ___RadioLinkDeletionRequest_protocolIEs__item__value,
        __RadioLinkDeletionRequest_protocolIEs__item_,
        _RadioLinkDeletionRequest_protocolIEs,
        ____RadioLinkDeletionRequest_protocolExtensions__item__id_tab,
        ___RadioLinkDeletionRequest_protocolExtensions__item__id,
        ____RadioLinkDeletionRequest_protocolExtensions__item__criticality_tab,
        ___RadioLinkDeletionRequest_protocolExtensions__item__criticality,
        ____RadioLinkDeletionRequest_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkDeletionRequest_protocolExtensions__item__extensionValue,
        __RadioLinkDeletionRequest_protocolExtensions__item_,
        _RadioLinkDeletionRequest_protocolExtensions,
        RadioLinkDeletionRequest,
        RadioLinkDeletionRequest_IEs,
        _RadioLinkDeletionRequest_IEs_val_Value_0,
        ___RL_InformationList_RL_DeletionRqst__item__id_tab,
        ____RL_InformationList_RL_DeletionRqst__item__id_tab_val_Value_0,
        __RL_InformationList_RL_DeletionRqst__item__id,
        __RL_InformationList_RL_DeletionRqst__item__criticality,
        __RL_InformationList_RL_DeletionRqst__item__value,
        _RL_InformationList_RL_DeletionRqst__item_,
        RL_InformationList_RL_DeletionRqst,
        RL_Information_RL_DeletionRqst_IEs,
        _RL_Information_RL_DeletionRqst_IEs_val_Value_0,
        _RL_Information_RL_DeletionRqst_rL_ID,
        ____RL_Information_RL_DeletionRqst_iE_Extensions__item__id_tab,
        ___RL_Information_RL_DeletionRqst_iE_Extensions__item__id,
        ____RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality_tab,
        ___RL_Information_RL_DeletionRqst_iE_Extensions__item__criticality,
        ____RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue_tab,
        ___RL_Information_RL_DeletionRqst_iE_Extensions__item__extensionValue,
        __RL_Information_RL_DeletionRqst_iE_Extensions__item_,
        _RL_Information_RL_DeletionRqst_iE_Extensions,
        RL_Information_RL_DeletionRqst,
        RL_Information_RL_DeletionRqst_ExtIEs,
        RadioLinkDeletionRequest_Extensions,
        ____RadioLinkDeletionResponse_protocolIEs__item__id_tab,
        _____RadioLinkDeletionResponse_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkDeletionResponse_protocolIEs__item__id,
        ___RadioLinkDeletionResponse_protocolIEs__item__criticality,
        ___RadioLinkDeletionResponse_protocolIEs__item__value,
        __RadioLinkDeletionResponse_protocolIEs__item_,
        _RadioLinkDeletionResponse_protocolIEs,
        ____RadioLinkDeletionResponse_protocolExtensions__item__id_tab,
        ___RadioLinkDeletionResponse_protocolExtensions__item__id,
        ____RadioLinkDeletionResponse_protocolExtensions__item__criticality_tab,
        ___RadioLinkDeletionResponse_protocolExtensions__item__criticality,
        ____RadioLinkDeletionResponse_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkDeletionResponse_protocolExtensions__item__extensionValue,
        __RadioLinkDeletionResponse_protocolExtensions__item_,
        _RadioLinkDeletionResponse_protocolExtensions,
        RadioLinkDeletionResponse,
        RadioLinkDeletionResponse_IEs,
        _RadioLinkDeletionResponse_IEs_val_Value_0,
        RadioLinkDeletionResponse_Extensions,
        ____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id_tab_val_Value_7,
        ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationPrepareFDD_protocolIEs__item__value,
        __RadioLinkReconfigurationPrepareFDD_protocolIEs__item_,
        _RadioLinkReconfigurationPrepareFDD_protocolIEs,
        ____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_22,
        _____RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id_tab_val_Extension_23,
        ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationPrepareFDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationPrepareFDD_protocolExtensions__item_,
        _RadioLinkReconfigurationPrepareFDD_protocolExtensions,
        RadioLinkReconfigurationPrepareFDD,
        RadioLinkReconfigurationPrepareFDD_IEs,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_0,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_1,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_2,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_3,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_4,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_5,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_6,
        _RadioLinkReconfigurationPrepareFDD_IEs_val_Value_7,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_ScramblingCode,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_SIRTarget,
        _UL_DPCH_Information_RL_ReconfPrepFDD_minUL_ChannelisationCodeLength,
        _UL_DPCH_Information_RL_ReconfPrepFDD_maxNrOfUL_DPDCHs,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_PunctureLimit,
        _UL_DPCH_Information_RL_ReconfPrepFDD_tFCS,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ul_DPCCH_SlotFormat,
        _UL_DPCH_Information_RL_ReconfPrepFDD_diversityMode,
        _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIDLength,
        _UL_DPCH_Information_RL_ReconfPrepFDD_not_Used_s_FieldLength,
        ____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _UL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        UL_DPCH_Information_RL_ReconfPrepFDD,
        UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _UL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _DL_DPCH_Information_RL_ReconfPrepFDD_tFCS,
        _DL_DPCH_Information_RL_ReconfPrepFDD_dl_DPCH_SlotFormat,
        _DL_DPCH_Information_RL_ReconfPrepFDD_nrOfDLchannelisationcodes,
        _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_SignallingMode,
        _DL_DPCH_Information_RL_ReconfPrepFDD_tFCI_Presence,
        _DL_DPCH_Information_RL_ReconfPrepFDD_multiplexingPosition,
        _DL_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease,
        ____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _DL_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        DL_DPCH_Information_RL_ReconfPrepFDD,
        DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _DL_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_powerOffsetInformation,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_fdd_TPC_DownlinkStepSize,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus,
        ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _DL_DPCH_Power_Information_RL_ReconfPrepFDD_iE_Extensions,
        DL_DPCH_Power_Information_RL_ReconfPrepFDD,
        DL_DPCH_Power_Information_RL_ReconfPrepFDD_ExtIEs,
        _PowerOffsetInformation_RL_ReconfPrepFDD_pO1_ForTFCI_Bits,
        _PowerOffsetInformation_RL_ReconfPrepFDD_pO2_ForTPC_Bits,
        _PowerOffsetInformation_RL_ReconfPrepFDD_pO3_ForPilotBits,
        ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions__item_,
        _PowerOffsetInformation_RL_ReconfPrepFDD_iE_Extensions,
        PowerOffsetInformation_RL_ReconfPrepFDD,
        PowerOffsetInformation_RL_ReconfPrepFDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfPrepFDD__item_,
        DCH_DeleteList_RL_ReconfPrepFDD,
        _DCH_DeleteItem_RL_ReconfPrepFDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfPrepFDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfPrepFDD,
        DCH_DeleteItem_RL_ReconfPrepFDD_ExtIEs,
        ___RL_InformationList_RL_ReconfPrepFDD__item__id_tab,
        ____RL_InformationList_RL_ReconfPrepFDD__item__id_tab_val_Value_0,
        __RL_InformationList_RL_ReconfPrepFDD__item__id,
        __RL_InformationList_RL_ReconfPrepFDD__item__criticality,
        __RL_InformationList_RL_ReconfPrepFDD__item__value,
        _RL_InformationList_RL_ReconfPrepFDD__item_,
        RL_InformationList_RL_ReconfPrepFDD,
        RL_Information_RL_ReconfPrepFDD_IEs,
        _RL_Information_RL_ReconfPrepFDD_IEs_val_Value_0,
        _RL_Information_RL_ReconfPrepFDD_rL_ID,
        _RL_Information_RL_ReconfPrepFDD_not_Used_sSDT_Indication,
        _RL_Information_RL_ReconfPrepFDD_not_Used_sSDT_CellIdentity,
        _RL_Information_RL_ReconfPrepFDD_transmitDiversityIndicator,
        ____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_9,
        _____RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_10,
        ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___RL_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __RL_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _RL_Information_RL_ReconfPrepFDD_iE_Extensions,
        RL_Information_RL_ReconfPrepFDD,
        RL_Information_RL_ReconfPrepFDD_ExtIEs,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_1,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_2,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_3,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_4,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_5,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_6,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_7,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_8,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_9,
        _RL_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_10,
        RadioLinkReconfigurationPrepareFDD_Extensions,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_22,
        _RadioLinkReconfigurationPrepareFDD_Extensions_val_Extension_23,
        _Additional_HS_Cell_Information_RL_Reconf_Prep__item_,
        Additional_HS_Cell_Information_RL_Reconf_Prep,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_DSCH_Secondary_Serving_Information_To_Modify,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_hS_HS_DSCH_Secondary_Serving_Remove,
        ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs,
        Additional_HS_Cell_Information_RL_Reconf_Prep_ItemIEs_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Reconf_Prep_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Reconf_Prep_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Reconf_Prep,
        Additional_EDCH_Cell_Information_RL_Reconf_Prep_ExtIEs,
        _F_DPCH_Information_RL_ReconfPrepFDD_powerOffsetInformation,
        _F_DPCH_Information_RL_ReconfPrepFDD_fdd_dl_TPC_DownlinkStepSize,
        _F_DPCH_Information_RL_ReconfPrepFDD_limitedPowerIncrease,
        _F_DPCH_Information_RL_ReconfPrepFDD_innerLoopDLPCStatus,
        ____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        _____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ___F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions__item_,
        _F_DPCH_Information_RL_ReconfPrepFDD_iE_Extensions,
        F_DPCH_Information_RL_ReconfPrepFDD,
        F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs,
        _F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_0,
        _F_DPCH_Information_RL_ReconfPrepFDD_ExtIEs_val_Extension_1,
        _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_po2_ForTPC_Bits,
        ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id_tab,
        ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__id,
        ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality_tab,
        ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__criticality,
        ____PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue_tab,
        ___PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item__extensionValue,
        __PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions__item_,
        _PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_iE_Extensions,
        PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD,
        PowerOffsetInformation_F_DPCH_RL_ReconfPrepFDD_ExtIEs,
        ____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_7,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_8,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_9,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_10,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_11,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_12,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_13,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_14,
        _____RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id_tab_val_Value_15,
        ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationPrepareTDD_protocolIEs__item__value,
        __RadioLinkReconfigurationPrepareTDD_protocolIEs__item_,
        _RadioLinkReconfigurationPrepareTDD_protocolIEs,
        ____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id_tab_val_Extension_22,
        ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationPrepareTDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationPrepareTDD_protocolExtensions__item_,
        _RadioLinkReconfigurationPrepareTDD_protocolExtensions,
        RadioLinkReconfigurationPrepareTDD,
        RadioLinkReconfigurationPrepareTDD_IEs,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_0,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_1,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_2,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_3,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_4,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_5,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_6,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_7,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_8,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_9,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_10,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_11,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_12,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_13,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_14,
        _RadioLinkReconfigurationPrepareTDD_IEs_val_Value_15,
        ___UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab,
        ____UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id,
        __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality,
        __UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value,
        _UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_,
        UL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs_val_Value_0,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_cCTrCH_ID,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_tFCS,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_tFCI_Coding,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_punctureLimit,
        ____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_iE_Extensions,
        UL_CCTrCH_AddInformation_RL_ReconfPrepTDD,
        UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_AddInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        ___UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab,
        ____UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id,
        __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality,
        __UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value,
        _UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_,
        UL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs_val_Value_0,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_cCTrCH_ID,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_tFCS,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_tFCI_Coding,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_punctureLimit,
        ____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_iE_Extensions,
        UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD,
        UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        ___UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab,
        ____UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value,
        _UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_,
        UL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs,
        _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs_val_Value_0,
        _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_cCTrCH_ID,
        ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions__item_,
        _UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_iE_Extensions,
        UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD,
        UL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_ExtIEs,
        ___DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab,
        ____DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__id,
        __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__criticality,
        __DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item__value,
        _DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD__item_,
        DL_CCTrCH_InformationAddList_RL_ReconfPrepTDD,
        DL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs,
        _DL_CCTrCH_AddInformation_RL_ReconfPrepTDD_IEs_val_Value_0,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCS,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_tFCI_Coding,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_punctureLimit,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_cCTrCH_TPCList,
        ____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD,
        DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationAddItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _CCTrCH_TPCAddList_RL_ReconfPrepTDD__item_,
        CCTrCH_TPCAddList_RL_ReconfPrepTDD,
        _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _CCTrCH_TPCAddItem_RL_ReconfPrepTDD_iE_Extensions,
        CCTrCH_TPCAddItem_RL_ReconfPrepTDD,
        CCTrCH_TPCAddItem_RL_ReconfPrepTDD_ExtIEs,
        ___DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab,
        ____DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__id,
        __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__criticality,
        __DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item__value,
        _DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD__item_,
        DL_CCTrCH_InformationModifyList_RL_ReconfPrepTDD,
        DL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs,
        _DL_CCTrCH_ModifyInformation_RL_ReconfPrepTDD_IEs_val_Value_0,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCS,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_tFCI_Coding,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_punctureLimit,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_cCTrCH_TPCList,
        ____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD,
        DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _CCTrCH_TPCModifyList_RL_ReconfPrepTDD__item_,
        CCTrCH_TPCModifyList_RL_ReconfPrepTDD,
        _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        CCTrCH_TPCModifyItem_RL_ReconfPrepTDD,
        CCTrCH_TPCModifyItem_RL_ReconfPrepTDD_ExtIEs,
        ___DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab,
        ____DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__id,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__criticality,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item__value,
        _DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD__item_,
        DL_CCTrCH_InformationDeleteList_RL_ReconfPrepTDD,
        DL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs,
        _DL_CCTrCH_DeleteInformation_RL_ReconfPrepTDD_IEs_val_Value_0,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_cCTrCH_ID,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfPrepTDD__item_,
        DCH_DeleteList_RL_ReconfPrepTDD,
        _DCH_DeleteItem_RL_ReconfPrepTDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfPrepTDD,
        DCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _DSCH_ModifyList_RL_ReconfPrepTDD__item_,
        DSCH_ModifyList_RL_ReconfPrepTDD,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_dSCH_ID,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_dl_ccTrCHID,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_trChSourceStatisticsDescriptor,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_transportFormatSet,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_schedulingPriorityIndicator,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_bLER,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator,
        ____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        DSCH_ModifyItem_RL_ReconfPrepTDD,
        DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _DSCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _DSCH_DeleteList_RL_ReconfPrepTDD__item_,
        DSCH_DeleteList_RL_ReconfPrepTDD,
        _DSCH_DeleteItem_RL_ReconfPrepTDD_dSCH_ID,
        ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _DSCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        DSCH_DeleteItem_RL_ReconfPrepTDD,
        DSCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        _USCH_ModifyList_RL_ReconfPrepTDD__item_,
        USCH_ModifyList_RL_ReconfPrepTDD,
        _USCH_ModifyItem_RL_ReconfPrepTDD_uSCH_ID,
        _USCH_ModifyItem_RL_ReconfPrepTDD_ul_ccTrCHID,
        _USCH_ModifyItem_RL_ReconfPrepTDD_trChSourceStatisticsDescriptor,
        _USCH_ModifyItem_RL_ReconfPrepTDD_transportFormatSet,
        _USCH_ModifyItem_RL_ReconfPrepTDD_allocationRetentionPriority,
        _USCH_ModifyItem_RL_ReconfPrepTDD_schedulingPriorityIndicator,
        _USCH_ModifyItem_RL_ReconfPrepTDD_bLER,
        _USCH_ModifyItem_RL_ReconfPrepTDD_transportBearerRequestIndicator,
        _USCH_ModifyItem_RL_ReconfPrepTDD_rb_Info,
        ____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ___USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _USCH_ModifyItem_RL_ReconfPrepTDD_iE_Extensions,
        USCH_ModifyItem_RL_ReconfPrepTDD,
        USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs,
        _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_0,
        _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_1,
        _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_2,
        _USCH_ModifyItem_RL_ReconfPrepTDD_ExtIEs_val_Extension_3,
        _USCH_DeleteList_RL_ReconfPrepTDD__item_,
        USCH_DeleteList_RL_ReconfPrepTDD,
        _USCH_DeleteItem_RL_ReconfPrepTDD_uSCH_ID,
        ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions__item_,
        _USCH_DeleteItem_RL_ReconfPrepTDD_iE_Extensions,
        USCH_DeleteItem_RL_ReconfPrepTDD,
        USCH_DeleteItem_RL_ReconfPrepTDD_ExtIEs,
        RadioLinkReconfigurationPrepareTDD_Extensions,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationPrepareTDD_Extensions_val_Extension_22,
        _RL_Information_RL_ReconfPrepTDD__item_,
        RL_Information_RL_ReconfPrepTDD,
        _RL_InformationIE_RL_ReconfPrepTDD_rL_ID,
        _RL_InformationIE_RL_ReconfPrepTDD_rL_Specific_DCH_Info,
        ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id_tab,
        ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__id,
        ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality_tab,
        ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__criticality,
        ____RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue_tab,
        ___RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item__extensionValue,
        __RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions__item_,
        _RL_InformationIE_RL_ReconfPrepTDD_iE_Extensions,
        RL_InformationIE_RL_ReconfPrepTDD,
        RL_InformationIE_RL_ReconfPrepTDD_ExtIEs,
        ____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationReadyFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationReadyFDD_protocolIEs__item__value,
        __RadioLinkReconfigurationReadyFDD_protocolIEs__item_,
        _RadioLinkReconfigurationReadyFDD_protocolIEs,
        ____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id_tab_val_Extension_6,
        ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationReadyFDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationReadyFDD_protocolExtensions__item_,
        _RadioLinkReconfigurationReadyFDD_protocolExtensions,
        RadioLinkReconfigurationReadyFDD,
        RadioLinkReconfigurationReadyFDD_IEs,
        _RadioLinkReconfigurationReadyFDD_IEs_val_Value_0,
        _RadioLinkReconfigurationReadyFDD_IEs_val_Value_1,
        ___RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab,
        ____RL_InformationResponseList_RL_ReconfReadyFDD__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_ReconfReadyFDD__item__id,
        __RL_InformationResponseList_RL_ReconfReadyFDD__item__criticality,
        __RL_InformationResponseList_RL_ReconfReadyFDD__item__value,
        _RL_InformationResponseList_RL_ReconfReadyFDD__item_,
        RL_InformationResponseList_RL_ReconfReadyFDD,
        RL_InformationResponse_RL_ReconfReadyFDD_IEs,
        _RL_InformationResponse_RL_ReconfReadyFDD_IEs_val_Value_0,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_rL_ID,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_max_UL_SIR,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_min_UL_SIR,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_maximumDLTxPower,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_minimumDLTxPower,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_not_Used_secondary_CCPCH_Info,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_dl_CodeInformationList,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_dCHInformationResponse,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_not_Used_dSCHsToBeAddedOrModified,
        ____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_7,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_8,
        _____RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id_tab_val_Extension_9,
        ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_iE_Extensions,
        RL_InformationResponseItem_RL_ReconfReadyFDD,
        RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_5,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_6,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_7,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_8,
        _RL_InformationResponseItem_RL_ReconfReadyFDD_ExtIEs_val_Extension_9,
        __DL_CodeInformationList_RL_ReconfReadyFDD_id_tab,
        ___DL_CodeInformationList_RL_ReconfReadyFDD_id_tab_val_Value_0,
        _DL_CodeInformationList_RL_ReconfReadyFDD_id,
        _DL_CodeInformationList_RL_ReconfReadyFDD_criticality,
        _DL_CodeInformationList_RL_ReconfReadyFDD_value,
        DL_CodeInformationList_RL_ReconfReadyFDD,
        DL_CodeInformationListIEs_RL_ReconfReadyFDD,
        _DL_CodeInformationListIEs_RL_ReconfReadyFDD_val_Value_0,
        __DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab,
        ___DCH_InformationResponseList_RL_ReconfReadyFDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_ReconfReadyFDD_id,
        _DCH_InformationResponseList_RL_ReconfReadyFDD_criticality,
        _DCH_InformationResponseList_RL_ReconfReadyFDD_value,
        DCH_InformationResponseList_RL_ReconfReadyFDD,
        DCH_InformationResponseListIEs_RL_ReconfReadyFDD,
        _DCH_InformationResponseListIEs_RL_ReconfReadyFDD_val_Value_0,
        RadioLinkReconfigurationReadyFDD_Extensions,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationReadyFDD_Extensions_val_Extension_6,
        _Additional_HS_Cell_RL_Reconf_Response__item_,
        Additional_HS_Cell_RL_Reconf_Response,
        _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hSDSCH_RNTI,
        _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_Response,
        ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_RL_Reconf_Response_ItemIEs_iE_Extensions,
        Additional_HS_Cell_RL_Reconf_Response_ItemIEs,
        Additional_HS_Cell_RL_Reconf_Response_ItemIEs_ExtIEs,
        ____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationReadyTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationReadyTDD_protocolIEs__item__value,
        __RadioLinkReconfigurationReadyTDD_protocolIEs__item_,
        _RadioLinkReconfigurationReadyTDD_protocolIEs,
        ____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id_tab_val_Extension_19,
        ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationReadyTDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationReadyTDD_protocolExtensions__item_,
        _RadioLinkReconfigurationReadyTDD_protocolExtensions,
        RadioLinkReconfigurationReadyTDD,
        RadioLinkReconfigurationReadyTDD_IEs,
        _RadioLinkReconfigurationReadyTDD_IEs_val_Value_0,
        _RadioLinkReconfigurationReadyTDD_IEs_val_Value_1,
        _RL_InformationResponse_RL_ReconfReadyTDD_rL_ID,
        _RL_InformationResponse_RL_ReconfReadyTDD_max_UL_SIR,
        _RL_InformationResponse_RL_ReconfReadyTDD_min_UL_SIR,
        _RL_InformationResponse_RL_ReconfReadyTDD_maximumDLTxPower,
        _RL_InformationResponse_RL_ReconfReadyTDD_minimumDLTxPower,
        _RL_InformationResponse_RL_ReconfReadyTDD_secondary_CCPCH_Info_TDD,
        _RL_InformationResponse_RL_ReconfReadyTDD_ul_CCTrCH_Information,
        _RL_InformationResponse_RL_ReconfReadyTDD_dl_CCTrCH_Information,
        _RL_InformationResponse_RL_ReconfReadyTDD_dCHInformationResponse,
        _RL_InformationResponse_RL_ReconfReadyTDD_dSCHsToBeAddedOrModified,
        _RL_InformationResponse_RL_ReconfReadyTDD_uSCHsToBeAddedOrModified,
        ____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions__item_,
        _RL_InformationResponse_RL_ReconfReadyTDD_iE_Extensions,
        RL_InformationResponse_RL_ReconfReadyTDD,
        RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs,
        _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_1,
        _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_2,
        _RL_InformationResponse_RL_ReconfReadyTDD_ExtIEs_val_Extension_3,
        __UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab,
        ___UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_id,
        _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality,
        _UL_CCTrCH_InformationList_RL_ReconfReadyTDD_value,
        UL_CCTrCH_InformationList_RL_ReconfReadyTDD,
        UL_CCTrCHInformationListIEs_RL_ReconfReadyTDD,
        _UL_CCTrCHInformationListIEs_RL_ReconfReadyTDD_val_Value_0,
        _UL_CCTrCHInformationListIE_RL_ReconfReadyTDD__item_,
        UL_CCTrCHInformationListIE_RL_ReconfReadyTDD,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_AddInformation,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_ModifyInformation,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ul_DPCH_DeleteInformation,
        ____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions,
        UL_CCTrCH_InformationItem_RL_ReconfReadyTDD,
        UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _UL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionPeriod,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionLength,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_tDD_DPCHOffset,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_uL_TimeslotLCR_Info,
        ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions,
        UL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD,
        UL_DPCH_LCR_InformationAddItem_RL_ReconfReadyTDD_ExtIEs,
        __UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab,
        ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_id,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD_value,
        UL_DPCH_InformationAddList_RL_ReconfReadyTDD,
        UL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD,
        _UL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD_val_Value_0,
        _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionPeriod,
        _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionLength,
        _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_tDD_DPCHOffset,
        _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_rxTimingDeviationForTA,
        _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_uL_Timeslot_Information,
        ____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions,
        UL_DPCH_InformationAddListIE_RL_ReconfReadyTDD,
        UL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs,
        _UL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionPeriod,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionLength,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_tDD_DPCHOffset,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_rxTimingDeviationForTA768,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_uL_Timeslot_Information768,
        ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id,
        ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_,
        _UL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions,
        UL_DPCH_InformationAddList_RL_ReconfReadyTDD768,
        UL_DPCH_InformationAddItem_RL_ReconfReadyTDD768_ExtIEs,
        __UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab,
        ___UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id,
        _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality,
        _UL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value,
        UL_DPCH_InformationModifyList_RL_ReconfReadyTDD,
        UL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD,
        _UL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD_val_Value_0,
        _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionPeriod,
        _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionLength,
        _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_tDD_DPCHOffset,
        _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_uL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
        ____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions,
        UL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD,
        UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _UL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1,
        _UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD__item_,
        UL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD,
        _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_timeSlotLCR,
        _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftLCR,
        _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence,
        _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_uL_Code_LCR_Information,
        ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD,
        _TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD__item_,
        TDD_UL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD,
        _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID,
        _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCodeLCR,
        ____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD,
        TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _TDD_UL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        UL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD__item_,
        UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_timeSlot,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftAndBurstType,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_uL_Code_Information,
        ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD,
        UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD__item_,
        TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD,
        _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID,
        _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCode,
        ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD,
        TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768__item_,
        UL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_timeSlot,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_midambleShiftAndBurstType768,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_tFCI_Presence,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_uL_Code_Information768,
        ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id,
        ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_,
        _UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions,
        UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768,
        UL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs,
        _TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768__item_,
        TDD_UL_Code_InformationModifyList_RL_ReconfReadyTDD768,
        _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_dPCH_ID,
        _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_tDD_ChannelisationCode768,
        ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id,
        ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality,
        ____TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_,
        _TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions,
        TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768,
        TDD_UL_Code_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs,
        __UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab,
        ___UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id,
        _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality,
        _UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value,
        UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD,
        UL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD,
        _UL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD_val_Value_0,
        _UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD__item_,
        UL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD,
        _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_dPCH_ID,
        ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions,
        UL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD,
        UL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_ExtIEs,
        __DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab,
        ___DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_id,
        _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_criticality,
        _DL_CCTrCH_InformationList_RL_ReconfReadyTDD_value,
        DL_CCTrCH_InformationList_RL_ReconfReadyTDD,
        DL_CCTrCHInformationListIEs_RL_ReconfReadyTDD,
        _DL_CCTrCHInformationListIEs_RL_ReconfReadyTDD_val_Value_0,
        _DL_CCTrCHInformationListIE_RL_ReconfReadyTDD__item_,
        DL_CCTrCHInformationListIE_RL_ReconfReadyTDD,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_AddInformation,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_ModifyInformation,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_dl_DPCH_DeleteInformation,
        ____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_4,
        ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_RL_ReconfReadyTDD,
        DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_2,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_3,
        _DL_CCTrCH_InformationItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_4,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionPeriod,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_repetitionLength,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_tDD_DPCHOffset,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_dL_TimeslotLCR_Info,
        ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD_iE_Extensions,
        DL_DPCH_LCR_InformationAddList_RL_ReconfReadyTDD,
        DL_DPCH_LCR_InformationAddItem_RL_ReconfReadyTDD_ExtIEs,
        __DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab,
        ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_id,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_criticality,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD_value,
        DL_DPCH_InformationAddList_RL_ReconfReadyTDD,
        DL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD,
        _DL_DPCH_InformationAddListIEs_RL_ReconfReadyTDD_val_Value_0,
        _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionPeriod,
        _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_repetitionLength,
        _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_tDD_DPCHOffset,
        _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_dL_Timeslot_Information,
        ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD_iE_Extensions,
        DL_DPCH_InformationAddListIE_RL_ReconfReadyTDD,
        DL_DPCH_InformationAddItem_RL_ReconfReadyTDD_ExtIEs,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionPeriod,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_repetitionLength,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_tDD_DPCHOffset,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_dL_Timeslot_Information768,
        ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__id,
        ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions__item_,
        _DL_DPCH_InformationAddList_RL_ReconfReadyTDD768_iE_Extensions,
        DL_DPCH_InformationAddList_RL_ReconfReadyTDD768,
        DL_DPCH_InformationAddItem_RL_ReconfReadyTDD768_ExtIEs,
        __DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab,
        ___DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_id,
        _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_criticality,
        _DL_DPCH_InformationModifyList_RL_ReconfReadyTDD_value,
        DL_DPCH_InformationModifyList_RL_ReconfReadyTDD,
        DL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD,
        _DL_DPCH_InformationModifyListIEs_RL_ReconfReadyTDD_val_Value_0,
        _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionPeriod,
        _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_repetitionLength,
        _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_tDD_DPCHOffset,
        _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_dL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
        ____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD_iE_Extensions,
        DL_DPCH_InformationModifyListIE_RL_ReconfReadyTDD,
        DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _DL_DPCH_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1,
        _DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD__item_,
        DL_TimeslotLCR_InformationModifyList_RL_ReconfReadyTDD,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_timeSlotLCR,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftLCR,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_dL_Code_LCR_Information,
        ____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD,
        _TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD__item_,
        TDD_DL_Code_LCR_InformationModifyList_RL_ReconfReadyTDD,
        _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID,
        _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCodeLCR,
        ____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD,
        TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _TDD_DL_Code_LCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _DL_TimeslotLCR_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_1,
        _DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD__item_,
        DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_timeSlot,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_midambleShiftAndBurstType,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_tFCI_Presence,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_dL_Code_Information,
        ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD,
        DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD__item_,
        TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_dPCH_ID,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_tDD_ChannelisationCode,
        ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        _____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_iE_Extensions,
        TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD,
        TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD_ExtIEs_val_Extension_0,
        _DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768__item_,
        DL_Timeslot_InformationModifyList_RL_ReconfReadyTDD768,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_timeSlot,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_midambleShiftAndBurstType768,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_tFCI_Presence,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_dL_Code_Information768,
        ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id,
        ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_,
        _DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions,
        DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768,
        DL_Timeslot_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs,
        _TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768__item_,
        TDD_DL_Code_InformationModifyList_RL_ReconfReadyTDD768,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_dPCH_ID768,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_tDD_ChannelisationCode768,
        ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id_tab,
        ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__id,
        ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality_tab,
        ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__criticality,
        ____TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue_tab,
        ___TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item__extensionValue,
        __TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions__item_,
        _TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_iE_Extensions,
        TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768,
        TDD_DL_Code_InformationModifyItem_RL_ReconfReadyTDD768_ExtIEs,
        __DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab,
        ___DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_id,
        _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_criticality,
        _DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_value,
        DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD,
        DL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD,
        _DL_DPCH_InformationDeleteListIEs_RL_ReconfReadyTDD_val_Value_0,
        _DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD__item_,
        DL_DPCH_InformationDeleteListIE_RL_ReconfReadyTDD,
        _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_dPCH_ID,
        ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD_iE_Extensions,
        DL_DPCH_InformationDeleteItem_RL_ReconfReadyTDD,
        DL_DPCH_InformationDeleteList_RL_ReconfReadyTDD_ExtIEs,
        _DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD__item_,
        DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD,
        _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_dPCH_ID768,
        ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD_iE_Extensions,
        DL_DPCH_InformationDeleteItem768_RL_ReconfReadyTDD,
        DL_DPCH_InformationDeleteList768_RL_ReconfReadyTDD_ExtIEs,
        __DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab,
        ___DCH_InformationResponseList_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_ReconfReadyTDD_id,
        _DCH_InformationResponseList_RL_ReconfReadyTDD_criticality,
        _DCH_InformationResponseList_RL_ReconfReadyTDD_value,
        DCH_InformationResponseList_RL_ReconfReadyTDD,
        DCH_InformationResponseListIEs_RL_ReconfReadyTDD,
        _DCH_InformationResponseListIEs_RL_ReconfReadyTDD_val_Value_0,
        __DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab,
        ___DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_id,
        _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality,
        _DSCHToBeAddedOrModified_RL_ReconfReadyTDD_value,
        DSCHToBeAddedOrModified_RL_ReconfReadyTDD,
        DSCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD,
        _DSCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD_val_Value_0,
        _DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD__item_,
        DSCHToBeAddedOrModifiedList_RL_ReconfReadyTDD,
        _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_dsch_ID,
        _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportFormatManagement,
        _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_dSCH_FlowControlInformation,
        _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_bindingID,
        _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportLayerAddress,
        ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions,
        DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD,
        DSCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_ExtIEs,
        __USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab,
        ___USCHToBeAddedOrModified_RL_ReconfReadyTDD_id_tab_val_Value_0,
        _USCHToBeAddedOrModified_RL_ReconfReadyTDD_id,
        _USCHToBeAddedOrModified_RL_ReconfReadyTDD_criticality,
        _USCHToBeAddedOrModified_RL_ReconfReadyTDD_value,
        USCHToBeAddedOrModified_RL_ReconfReadyTDD,
        USCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD,
        _USCHToBeAddedOrModifiedIEs_RL_ReconfReadyTDD_val_Value_0,
        _USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD__item_,
        USCHToBeAddedOrModifiedList_RL_ReconfReadyTDD,
        _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_uSCH_ID,
        _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportFormatManagement,
        _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_bindingID,
        _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_transportLayerAddress,
        ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id_tab,
        ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__id,
        ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality_tab,
        ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__criticality,
        ____USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue_tab,
        ___USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item__extensionValue,
        __USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions__item_,
        _USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_iE_Extensions,
        USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD,
        USCHToBeAddedOrModifiedItem_RL_ReconfReadyTDD_ExtIEs,
        RadioLinkReconfigurationReadyTDD_Extensions,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationReadyTDD_Extensions_val_Extension_19,
        _Multiple_RL_InformationResponse_RL_ReconfReadyTDD__item_,
        Multiple_RL_InformationResponse_RL_ReconfReadyTDD,
        ____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationCommit_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkReconfigurationCommit_protocolIEs__item__id,
        ___RadioLinkReconfigurationCommit_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationCommit_protocolIEs__item__value,
        __RadioLinkReconfigurationCommit_protocolIEs__item_,
        _RadioLinkReconfigurationCommit_protocolIEs,
        ____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationCommit_protocolExtensions__item__id_tab_val_Extension_1,
        ___RadioLinkReconfigurationCommit_protocolExtensions__item__id,
        ___RadioLinkReconfigurationCommit_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationCommit_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationCommit_protocolExtensions__item_,
        _RadioLinkReconfigurationCommit_protocolExtensions,
        RadioLinkReconfigurationCommit,
        RadioLinkReconfigurationCommit_IEs,
        _RadioLinkReconfigurationCommit_IEs_val_Value_0,
        _RadioLinkReconfigurationCommit_IEs_val_Value_1,
        RadioLinkReconfigurationCommit_Extensions,
        _RadioLinkReconfigurationCommit_Extensions_val_Extension_0,
        _RadioLinkReconfigurationCommit_Extensions_val_Extension_1,
        ____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkReconfigurationFailure_protocolIEs__item__id,
        ___RadioLinkReconfigurationFailure_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationFailure_protocolIEs__item__value,
        __RadioLinkReconfigurationFailure_protocolIEs__item_,
        _RadioLinkReconfigurationFailure_protocolIEs,
        ____RadioLinkReconfigurationFailure_protocolExtensions__item__id_tab,
        ___RadioLinkReconfigurationFailure_protocolExtensions__item__id,
        ____RadioLinkReconfigurationFailure_protocolExtensions__item__criticality_tab,
        ___RadioLinkReconfigurationFailure_protocolExtensions__item__criticality,
        ____RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkReconfigurationFailure_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationFailure_protocolExtensions__item_,
        _RadioLinkReconfigurationFailure_protocolExtensions,
        RadioLinkReconfigurationFailure,
        RadioLinkReconfigurationFailure_IEs,
        _RadioLinkReconfigurationFailure_IEs_val_Value_0,
        _RadioLinkReconfigurationFailure_IEs_val_Value_1,
        _CauseLevel_RL_ReconfFailure_generalCause,
        _CauseLevel_RL_ReconfFailure_rLSpecificCause,
        CauseLevel_RL_ReconfFailure,
        _GeneralCauseList_RL_ReconfFailure_cause,
        ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab,
        ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__id,
        ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab,
        ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__criticality,
        ____GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab,
        ___GeneralCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue,
        __GeneralCauseList_RL_ReconfFailure_iE_Extensions__item_,
        _GeneralCauseList_RL_ReconfFailure_iE_Extensions,
        GeneralCauseList_RL_ReconfFailure,
        GeneralCauseItem_RL_ReconfFailure_ExtIEs,
        _RLSpecificCauseList_RL_ReconfFailure_rL_ReconfigurationFailureList_RL_ReconfFailure,
        ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id_tab,
        ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__id,
        ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality_tab,
        ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__criticality,
        ____RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue_tab,
        ___RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item__extensionValue,
        __RLSpecificCauseList_RL_ReconfFailure_iE_Extensions__item_,
        _RLSpecificCauseList_RL_ReconfFailure_iE_Extensions,
        RLSpecificCauseList_RL_ReconfFailure,
        RLSpecificCauseItem_RL_ReconfFailure_ExtIEs,
        ___RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab,
        ____RL_ReconfigurationFailureList_RL_ReconfFailure__item__id_tab_val_Value_0,
        __RL_ReconfigurationFailureList_RL_ReconfFailure__item__id,
        __RL_ReconfigurationFailureList_RL_ReconfFailure__item__criticality,
        __RL_ReconfigurationFailureList_RL_ReconfFailure__item__value,
        _RL_ReconfigurationFailureList_RL_ReconfFailure__item_,
        RL_ReconfigurationFailureList_RL_ReconfFailure,
        RL_ReconfigurationFailure_RL_ReconfFailure_IEs,
        _RL_ReconfigurationFailure_RL_ReconfFailure_IEs_val_Value_0,
        _RL_ReconfigurationFailure_RL_ReconfFail_rL_ID,
        _RL_ReconfigurationFailure_RL_ReconfFail_cause,
        ____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab,
        _____RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id_tab_val_Extension_0,
        ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__id,
        ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__criticality,
        ___RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item__extensionValue,
        __RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions__item_,
        _RL_ReconfigurationFailure_RL_ReconfFail_iE_Extensions,
        RL_ReconfigurationFailure_RL_ReconfFail,
        RL_ReconfigurationFailure_RL_ReconfFailure_ExtIEs,
        _RL_ReconfigurationFailure_RL_ReconfFailure_ExtIEs_val_Extension_0,
        RadioLinkReconfigurationFailure_Extensions,
        ____RadioLinkReconfigurationCancel_protocolIEs__item__id_tab,
        ___RadioLinkReconfigurationCancel_protocolIEs__item__id,
        ____RadioLinkReconfigurationCancel_protocolIEs__item__criticality_tab,
        ___RadioLinkReconfigurationCancel_protocolIEs__item__criticality,
        ____RadioLinkReconfigurationCancel_protocolIEs__item__value_tab,
        ___RadioLinkReconfigurationCancel_protocolIEs__item__value,
        __RadioLinkReconfigurationCancel_protocolIEs__item_,
        _RadioLinkReconfigurationCancel_protocolIEs,
        ____RadioLinkReconfigurationCancel_protocolExtensions__item__id_tab,
        ___RadioLinkReconfigurationCancel_protocolExtensions__item__id,
        ____RadioLinkReconfigurationCancel_protocolExtensions__item__criticality_tab,
        ___RadioLinkReconfigurationCancel_protocolExtensions__item__criticality,
        ____RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkReconfigurationCancel_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationCancel_protocolExtensions__item_,
        _RadioLinkReconfigurationCancel_protocolExtensions,
        RadioLinkReconfigurationCancel,
        RadioLinkReconfigurationCancel_IEs,
        RadioLinkReconfigurationCancel_Extensions,
        ____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_6,
        ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationRequestFDD_protocolIEs__item__value,
        __RadioLinkReconfigurationRequestFDD_protocolIEs__item_,
        _RadioLinkReconfigurationRequestFDD_protocolIEs,
        ____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_18,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_19,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_20,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_21,
        _____RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id_tab_val_Extension_22,
        ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationRequestFDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationRequestFDD_protocolExtensions__item_,
        _RadioLinkReconfigurationRequestFDD_protocolExtensions,
        RadioLinkReconfigurationRequestFDD,
        RadioLinkReconfigurationRequestFDD_IEs,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_0,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_1,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_2,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_3,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_4,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_5,
        _RadioLinkReconfigurationRequestFDD_IEs_val_Value_6,
        _UL_DPCH_Information_RL_ReconfRqstFDD_tFCS,
        ____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ___UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_,
        _UL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions,
        UL_DPCH_Information_RL_ReconfRqstFDD,
        UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs,
        _UL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs_val_Extension_0,
        _DL_DPCH_Information_RL_ReconfRqstFDD_tFCS,
        _DL_DPCH_Information_RL_ReconfRqstFDD_tFCI_SignallingMode,
        _DL_DPCH_Information_RL_ReconfRqstFDD_limitedPowerIncrease,
        ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions__item_,
        _DL_DPCH_Information_RL_ReconfRqstFDD_iE_Extensions,
        DL_DPCH_Information_RL_ReconfRqstFDD,
        DL_DPCH_Information_RL_ReconfRqstFDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfRqstFDD__item_,
        DCH_DeleteList_RL_ReconfRqstFDD,
        _DCH_DeleteItem_RL_ReconfRqstFDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfRqstFDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfRqstFDD,
        DCH_DeleteItem_RL_ReconfRqstFDD_ExtIEs,
        RadioLinkReconfigurationRequestFDD_Extensions,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_18,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_19,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_20,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_21,
        _RadioLinkReconfigurationRequestFDD_Extensions_val_Extension_22,
        _Additional_HS_Cell_Information_RL_Reconf_Req__item_,
        Additional_HS_Cell_Information_RL_Reconf_Req,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_c_ID,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Information_To_Modify_Unsynchronised,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_hS_DSCH_Secondary_Serving_Remove,
        ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Reconf_Req_ItemIEs,
        Additional_HS_Cell_Information_RL_Reconf_Req_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Reconf_Req_setup_Or_ConfigurationChange_Or_Removal_Of_EDCH_On_secondary_UL_Frequency,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Reconf_Req_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Reconf_Req,
        Additional_EDCH_Cell_Information_RL_Reconf_Req_ExtIEs,
        ___RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab,
        ____RL_ReconfigurationRequestFDD_RL_InformationList__item__id_tab_val_Value_0,
        __RL_ReconfigurationRequestFDD_RL_InformationList__item__id,
        __RL_ReconfigurationRequestFDD_RL_InformationList__item__criticality,
        __RL_ReconfigurationRequestFDD_RL_InformationList__item__value,
        _RL_ReconfigurationRequestFDD_RL_InformationList__item_,
        RL_ReconfigurationRequestFDD_RL_InformationList,
        RL_ReconfigurationRequestFDD_RL_Information_ListItem,
        _RL_ReconfigurationRequestFDD_RL_Information_ListItem_val_Value_0,
        _RL_ReconfigurationRequestFDD_RL_Information_IEs_rL_ID,
        _RL_ReconfigurationRequestFDD_RL_Information_IEs_rL_Specific_DCH_Info,
        ____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id_tab_val_Extension_6,
        ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__id,
        ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__criticality,
        ___RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item__extensionValue,
        __RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions__item_,
        _RL_ReconfigurationRequestFDD_RL_Information_IEs_iE_Extensions,
        RL_ReconfigurationRequestFDD_RL_Information_IEs,
        RL_ReconfigurationRequestFDD_RL_Information_ExtIEs,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_0,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_1,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_2,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_3,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_4,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_5,
        _RL_ReconfigurationRequestFDD_RL_Information_ExtIEs_val_Extension_6,
        ____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_1,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_2,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_3,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_4,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_5,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_6,
        _____RadioLinkReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_7,
        ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationRequestTDD_protocolIEs__item__value,
        __RadioLinkReconfigurationRequestTDD_protocolIEs__item_,
        _RadioLinkReconfigurationRequestTDD_protocolIEs,
        ____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id_tab_val_Extension_15,
        ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationRequestTDD_protocolExtensions__item_,
        _RadioLinkReconfigurationRequestTDD_protocolExtensions,
        RadioLinkReconfigurationRequestTDD,
        RadioLinkReconfigurationRequestTDD_IEs,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_0,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_1,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_2,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_3,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_4,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_5,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_6,
        _RadioLinkReconfigurationRequestTDD_IEs_val_Value_7,
        ___UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id,
        __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality,
        __UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value,
        _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_,
        UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs,
        _UL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs_val_Value_0,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS,
        ____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        _____UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ___UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs,
        _UL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs_val_Extension_0,
        ___UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab,
        ____UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality,
        __UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value,
        _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_,
        UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs,
        _UL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs_val_Value_0,
        _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        UL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs,
        ___DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__id,
        __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__criticality,
        __DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item__value,
        _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD__item_,
        DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs,
        _DL_CCTrCH_InformationModifyList_RL_ReconfRqstTDD_IEs_val_Value_0,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_tFCS,
        ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationModifyItem_RL_ReconfRqstTDD_ExtIEs,
        ___DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab,
        ____DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id_tab_val_Value_0,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__id,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__criticality,
        __DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item__value,
        _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD__item_,
        DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs,
        _DL_CCTrCH_InformationDeleteList_RL_ReconfRqstTDD_IEs_val_Value_0,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_cCTrCH_ID,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD,
        DL_CCTrCH_InformationDeleteItem_RL_ReconfRqstTDD_ExtIEs,
        _DCH_DeleteList_RL_ReconfRqstTDD__item_,
        DCH_DeleteList_RL_ReconfRqstTDD,
        _DCH_DeleteItem_RL_ReconfRqstTDD_dCH_ID,
        ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__id,
        ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__criticality,
        ____DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions__item_,
        _DCH_DeleteItem_RL_ReconfRqstTDD_iE_Extensions,
        DCH_DeleteItem_RL_ReconfRqstTDD,
        DCH_DeleteItem_RL_ReconfRqstTDD_ExtIEs,
        RadioLinkReconfigurationRequestTDD_Extensions,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationRequestTDD_Extensions_val_Extension_15,
        _Multiple_RL_ReconfigurationRequestTDD_RL_Information__item_,
        Multiple_RL_ReconfigurationRequestTDD_RL_Information,
        _RL_ReconfigurationRequestTDD_RL_Information_rL_ID,
        _RL_ReconfigurationRequestTDD_RL_Information_rL_Specific_DCH_Info,
        ____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab,
        _____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__id,
        ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__criticality,
        ___RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item__extensionValue,
        __RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions__item_,
        _RL_ReconfigurationRequestTDD_RL_Information_iE_Extensions,
        RL_ReconfigurationRequestTDD_RL_Information,
        RL_ReconfigurationRequestTDD_RL_Information_ExtIEs,
        _RL_ReconfigurationRequestTDD_RL_Information_ExtIEs_val_Extension_0,
        _RL_ReconfigurationRequestTDD_RL_Information_ExtIEs_val_Extension_1,
        ____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationResponseFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationResponseFDD_protocolIEs__item__value,
        __RadioLinkReconfigurationResponseFDD_protocolIEs__item_,
        _RadioLinkReconfigurationResponseFDD_protocolIEs,
        ____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id_tab_val_Extension_5,
        ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationResponseFDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationResponseFDD_protocolExtensions__item_,
        _RadioLinkReconfigurationResponseFDD_protocolExtensions,
        RadioLinkReconfigurationResponseFDD,
        RadioLinkReconfigurationResponseFDD_IEs,
        _RadioLinkReconfigurationResponseFDD_IEs_val_Value_0,
        _RadioLinkReconfigurationResponseFDD_IEs_val_Value_1,
        ___RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab,
        ____RL_InformationResponseList_RL_ReconfRspFDD__item__id_tab_val_Value_0,
        __RL_InformationResponseList_RL_ReconfRspFDD__item__id,
        __RL_InformationResponseList_RL_ReconfRspFDD__item__criticality,
        __RL_InformationResponseList_RL_ReconfRspFDD__item__value,
        _RL_InformationResponseList_RL_ReconfRspFDD__item_,
        RL_InformationResponseList_RL_ReconfRspFDD,
        RL_InformationResponse_RL_ReconfRspFDD_IEs,
        _RL_InformationResponse_RL_ReconfRspFDD_IEs_val_Value_0,
        _RL_InformationResponseItem_RL_ReconfRspFDD_rL_ID,
        _RL_InformationResponseItem_RL_ReconfRspFDD_max_UL_SIR,
        _RL_InformationResponseItem_RL_ReconfRspFDD_min_UL_SIR,
        _RL_InformationResponseItem_RL_ReconfRspFDD_maximumDLTxPower,
        _RL_InformationResponseItem_RL_ReconfRspFDD_minimumDLTxPower,
        _RL_InformationResponseItem_RL_ReconfRspFDD_not_Used_secondary_CCPCH_Info,
        _RL_InformationResponseItem_RL_ReconfRspFDD_dCHsInformationResponseList,
        _RL_InformationResponseItem_RL_ReconfRspFDD_dL_CodeInformationList_RL_ReconfResp,
        ____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_6,
        _____RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id_tab_val_Extension_7,
        ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__id,
        ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__criticality,
        ___RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions__item_,
        _RL_InformationResponseItem_RL_ReconfRspFDD_iE_Extensions,
        RL_InformationResponseItem_RL_ReconfRspFDD,
        RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_0,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_1,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_2,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_3,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_4,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_5,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_6,
        _RL_InformationResponseItem_RL_ReconfRspFDD_ExtIEs_val_Extension_7,
        __DCH_InformationResponseList_RL_ReconfRspFDD_id_tab,
        ___DCH_InformationResponseList_RL_ReconfRspFDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_ReconfRspFDD_id,
        _DCH_InformationResponseList_RL_ReconfRspFDD_criticality,
        _DCH_InformationResponseList_RL_ReconfRspFDD_value,
        DCH_InformationResponseList_RL_ReconfRspFDD,
        DCH_InformationResponseListIEs_RL_ReconfRspFDD,
        _DCH_InformationResponseListIEs_RL_ReconfRspFDD_val_Value_0,
        __DL_CodeInformationList_RL_ReconfRspFDD_id_tab,
        ___DL_CodeInformationList_RL_ReconfRspFDD_id_tab_val_Value_0,
        _DL_CodeInformationList_RL_ReconfRspFDD_id,
        _DL_CodeInformationList_RL_ReconfRspFDD_criticality,
        _DL_CodeInformationList_RL_ReconfRspFDD_value,
        DL_CodeInformationList_RL_ReconfRspFDD,
        DL_CodeInformationListIEs_RL_ReconfRspFDD,
        _DL_CodeInformationListIEs_RL_ReconfRspFDD_val_Value_0,
        RadioLinkReconfigurationResponseFDD_Extensions,
        _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationResponseFDD_Extensions_val_Extension_5,
        ____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab,
        _____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkReconfigurationResponseTDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__id,
        ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__criticality,
        ___RadioLinkReconfigurationResponseTDD_protocolIEs__item__value,
        __RadioLinkReconfigurationResponseTDD_protocolIEs__item_,
        _RadioLinkReconfigurationResponseTDD_protocolIEs,
        ____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_16,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_17,
        _____RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id_tab_val_Extension_18,
        ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__id,
        ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__criticality,
        ___RadioLinkReconfigurationResponseTDD_protocolExtensions__item__extensionValue,
        __RadioLinkReconfigurationResponseTDD_protocolExtensions__item_,
        _RadioLinkReconfigurationResponseTDD_protocolExtensions,
        RadioLinkReconfigurationResponseTDD,
        RadioLinkReconfigurationResponseTDD_IEs,
        _RadioLinkReconfigurationResponseTDD_IEs_val_Value_0,
        _RadioLinkReconfigurationResponseTDD_IEs_val_Value_1,
        _RL_InformationResponse_RL_ReconfRspTDD_rL_ID,
        _RL_InformationResponse_RL_ReconfRspTDD_max_UL_SIR,
        _RL_InformationResponse_RL_ReconfRspTDD_min_UL_SIR,
        _RL_InformationResponse_RL_ReconfRspTDD_maximumDLTxPower,
        _RL_InformationResponse_RL_ReconfRspTDD_minimumDLTxPower,
        _RL_InformationResponse_RL_ReconfRspTDD_dCHsInformationResponseList,
        ____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab,
        _____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__id,
        ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__criticality,
        ___RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item__extensionValue,
        __RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions__item_,
        _RL_InformationResponse_RL_ReconfRspTDD_iE_Extensions,
        RL_InformationResponse_RL_ReconfRspTDD,
        RL_InformationResponse_RL_ReconfRspTDD_ExtIEs,
        _RL_InformationResponse_RL_ReconfRspTDD_ExtIEs_val_Extension_0,
        _RL_InformationResponse_RL_ReconfRspTDD_ExtIEs_val_Extension_1,
        _DL_CCTrCH_InformationList_RL_ReconfRspTDD__item_,
        DL_CCTrCH_InformationList_RL_ReconfRspTDD,
        _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_dl_DPCH_ModifyInformation_LCR,
        _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_Maximum_DL_Power,
        _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_cCTrCH_Minimum_DL_Power,
        ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_RL_ReconfRspTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_RL_ReconfRspTDD,
        DL_CCTrCH_InformationItem_RL_ReconfRspTDD_ExtIEs,
        __DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab,
        ___DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_id,
        _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_criticality,
        _DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD_value,
        DL_DPCH_InformationModifyList_LCR_RL_ReconfRspTDD,
        DL_DPCH_InformationModifyListIEs_LCR_RL_ReconfRspTDD,
        _DL_DPCH_InformationModifyListIEs_LCR_RL_ReconfRspTDD_val_Value_0,
        _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_dL_Timeslot_LCR_InformationModifyList_RL_ReconfRqstTDD,
        ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id_tab,
        ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__id,
        ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__criticality,
        ____DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions__item_,
        _DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_iE_Extensions,
        DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD,
        DL_DPCH_InformationModifyItem_LCR_RL_ReconfRspTDD_ExtIEs,
        _DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD__item_,
        DL_Timeslot_LCR_InformationModifyList_RL_ReconfRspTDD,
        _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_timeSlotLCR,
        _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_maxPowerLCR,
        _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_minPowerLCR,
        ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id_tab,
        ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__id,
        ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__criticality,
        ____DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions__item_,
        _DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_iE_Extensions,
        DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD,
        DL_Timeslot_LCR_InformationModifyItem_RL_ReconfRspTDD_ExtIEs,
        __DCH_InformationResponseList_RL_ReconfRspTDD_id_tab,
        ___DCH_InformationResponseList_RL_ReconfRspTDD_id_tab_val_Value_0,
        _DCH_InformationResponseList_RL_ReconfRspTDD_id,
        _DCH_InformationResponseList_RL_ReconfRspTDD_criticality,
        _DCH_InformationResponseList_RL_ReconfRspTDD_value,
        DCH_InformationResponseList_RL_ReconfRspTDD,
        DCH_InformationResponseListIEs_RL_ReconfRspTDD,
        _DCH_InformationResponseListIEs_RL_ReconfRspTDD_val_Value_0,
        RadioLinkReconfigurationResponseTDD_Extensions,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_0,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_1,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_2,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_3,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_4,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_5,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_6,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_7,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_8,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_9,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_10,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_11,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_12,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_13,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_14,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_15,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_16,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_17,
        _RadioLinkReconfigurationResponseTDD_Extensions_val_Extension_18,
        _Multiple_RL_InformationResponse_RL_ReconfRspTDD__item_,
        Multiple_RL_InformationResponse_RL_ReconfRspTDD,
        ____RadioLinkFailureIndication_protocolIEs__item__id_tab,
        _____RadioLinkFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkFailureIndication_protocolIEs__item__id,
        ___RadioLinkFailureIndication_protocolIEs__item__criticality,
        ___RadioLinkFailureIndication_protocolIEs__item__value,
        __RadioLinkFailureIndication_protocolIEs__item_,
        _RadioLinkFailureIndication_protocolIEs,
        ____RadioLinkFailureIndication_protocolExtensions__item__id_tab,
        ___RadioLinkFailureIndication_protocolExtensions__item__id,
        ____RadioLinkFailureIndication_protocolExtensions__item__criticality_tab,
        ___RadioLinkFailureIndication_protocolExtensions__item__criticality,
        ____RadioLinkFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkFailureIndication_protocolExtensions__item__extensionValue,
        __RadioLinkFailureIndication_protocolExtensions__item_,
        _RadioLinkFailureIndication_protocolExtensions,
        RadioLinkFailureIndication,
        RadioLinkFailureIndication_IEs,
        _RadioLinkFailureIndication_IEs_val_Value_0,
        _Reporting_Object_RL_FailureInd_rL,
        _Reporting_Object_RL_FailureInd_rL_Set,
        _Reporting_Object_RL_FailureInd_cCTrCH,
        Reporting_Object_RL_FailureInd,
        _RL_RL_FailureInd_rL_InformationList_RL_FailureInd,
        ____RL_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_RL_FailureInd_iE_Extensions__item__id,
        ____RL_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_RL_FailureInd_iE_Extensions__item_,
        _RL_RL_FailureInd_iE_Extensions,
        RL_RL_FailureInd,
        RLItem_RL_FailureInd_ExtIEs,
        ___RL_InformationList_RL_FailureInd__item__id_tab,
        ____RL_InformationList_RL_FailureInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_FailureInd__item__id,
        __RL_InformationList_RL_FailureInd__item__criticality,
        __RL_InformationList_RL_FailureInd__item__value,
        _RL_InformationList_RL_FailureInd__item_,
        RL_InformationList_RL_FailureInd,
        RL_Information_RL_FailureInd_IEs,
        _RL_Information_RL_FailureInd_IEs_val_Value_0,
        _RL_Information_RL_FailureInd_rL_ID,
        _RL_Information_RL_FailureInd_cause,
        ____RL_Information_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_Information_RL_FailureInd_iE_Extensions__item__id,
        ____RL_Information_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_Information_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Information_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_Information_RL_FailureInd_iE_Extensions__item_,
        _RL_Information_RL_FailureInd_iE_Extensions,
        RL_Information_RL_FailureInd,
        RL_Information_RL_FailureInd_ExtIEs,
        _RL_Set_RL_FailureInd_rL_Set_InformationList_RL_FailureInd,
        ____RL_Set_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_Set_RL_FailureInd_iE_Extensions__item__id,
        ____RL_Set_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_Set_RL_FailureInd_iE_Extensions__item_,
        _RL_Set_RL_FailureInd_iE_Extensions,
        RL_Set_RL_FailureInd,
        RL_SetItem_RL_FailureInd_ExtIEs,
        ___RL_Set_InformationList_RL_FailureInd__item__id_tab,
        ____RL_Set_InformationList_RL_FailureInd__item__id_tab_val_Value_0,
        __RL_Set_InformationList_RL_FailureInd__item__id,
        __RL_Set_InformationList_RL_FailureInd__item__criticality,
        __RL_Set_InformationList_RL_FailureInd__item__value,
        _RL_Set_InformationList_RL_FailureInd__item_,
        RL_Set_InformationList_RL_FailureInd,
        RL_Set_Information_RL_FailureInd_IEs,
        _RL_Set_Information_RL_FailureInd_IEs_val_Value_0,
        _RL_Set_Information_RL_FailureInd_rL_Set_ID,
        _RL_Set_Information_RL_FailureInd_cause,
        ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__id_tab,
        ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__id,
        ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__criticality,
        ____RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_Information_RL_FailureInd_iE_Extensions__item__extensionValue,
        __RL_Set_Information_RL_FailureInd_iE_Extensions__item_,
        _RL_Set_Information_RL_FailureInd_iE_Extensions,
        RL_Set_Information_RL_FailureInd,
        RL_Set_Information_RL_FailureInd_ExtIEs,
        RadioLinkFailureIndication_Extensions,
        _CCTrCH_RL_FailureInd_rL_ID,
        _CCTrCH_RL_FailureInd_cCTrCH_InformationList_RL_FailureInd,
        ____CCTrCH_RL_FailureInd_iE_Extensions__item__id_tab,
        ___CCTrCH_RL_FailureInd_iE_Extensions__item__id,
        ____CCTrCH_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_RL_FailureInd_iE_Extensions__item__criticality,
        ____CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_RL_FailureInd_iE_Extensions__item__extensionValue,
        __CCTrCH_RL_FailureInd_iE_Extensions__item_,
        _CCTrCH_RL_FailureInd_iE_Extensions,
        CCTrCH_RL_FailureInd,
        CCTrCHItem_RL_FailureInd_ExtIEs,
        ___CCTrCH_InformationList_RL_FailureInd__item__id_tab,
        ____CCTrCH_InformationList_RL_FailureInd__item__id_tab_val_Value_0,
        __CCTrCH_InformationList_RL_FailureInd__item__id,
        __CCTrCH_InformationList_RL_FailureInd__item__criticality,
        __CCTrCH_InformationList_RL_FailureInd__item__value,
        _CCTrCH_InformationList_RL_FailureInd__item_,
        CCTrCH_InformationList_RL_FailureInd,
        CCTrCH_InformationItemIE_RL_FailureInd,
        _CCTrCH_InformationItemIE_RL_FailureInd_val_Value_0,
        _CCTrCH_InformationItem_RL_FailureInd_cCTrCH_ID,
        _CCTrCH_InformationItem_RL_FailureInd_cause,
        ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id_tab,
        ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__id,
        ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__criticality,
        ____CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item__extensionValue,
        __CCTrCH_InformationItem_RL_FailureInd_iE_Extensions__item_,
        _CCTrCH_InformationItem_RL_FailureInd_iE_Extensions,
        CCTrCH_InformationItem_RL_FailureInd,
        CCTrCH_InformationItem_RL_FailureInd_ExtIEs,
        ____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab,
        _____RadioLinkPreemptionRequiredIndication_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__id,
        ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__criticality,
        ___RadioLinkPreemptionRequiredIndication_protocolIEs__item__value,
        __RadioLinkPreemptionRequiredIndication_protocolIEs__item_,
        _RadioLinkPreemptionRequiredIndication_protocolIEs,
        ____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab,
        _____RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id_tab_val_Extension_0,
        ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__id,
        ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__criticality,
        ___RadioLinkPreemptionRequiredIndication_protocolExtensions__item__extensionValue,
        __RadioLinkPreemptionRequiredIndication_protocolExtensions__item_,
        _RadioLinkPreemptionRequiredIndication_protocolExtensions,
        RadioLinkPreemptionRequiredIndication,
        RadioLinkPreemptionRequiredIndication_IEs,
        _RadioLinkPreemptionRequiredIndication_IEs_val_Value_0,
        ___RL_InformationList_RL_PreemptRequiredInd__item__id_tab,
        ____RL_InformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_PreemptRequiredInd__item__id,
        __RL_InformationList_RL_PreemptRequiredInd__item__criticality,
        __RL_InformationList_RL_PreemptRequiredInd__item__value,
        _RL_InformationList_RL_PreemptRequiredInd__item_,
        RL_InformationList_RL_PreemptRequiredInd,
        RL_InformationItemIEs_RL_PreemptRequiredInd,
        _RL_InformationItemIEs_RL_PreemptRequiredInd_val_Value_0,
        _RL_InformationItem_RL_PreemptRequiredInd_rL_ID,
        ____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab_val_Extension_0,
        ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id,
        ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions__item_,
        _RL_InformationItem_RL_PreemptRequiredInd_iE_Extensions,
        RL_InformationItem_RL_PreemptRequiredInd,
        RL_Information_RL_PreemptRequiredInd_ExtIEs,
        _RL_Information_RL_PreemptRequiredInd_ExtIEs_val_Extension_0,
        RadioLinkPreemptionRequiredIndication_Extensions,
        _RadioLinkPreemptionRequiredIndication_Extensions_val_Extension_0,
        ___HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab,
        ____HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0,
        __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id,
        __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality,
        __HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value,
        _HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_,
        HSDSCHMacdFlowSpecificInformationList_RL_PreemptRequiredInd,
        HSDSCHMacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd,
        _HSDSCHMacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd_val_Value_0,
        _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_hSDSCH_MACdFlow_ID,
        ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab,
        ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id,
        ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab,
        ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality,
        ____HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab,
        ___HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue,
        __HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_,
        _HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions,
        HSDSCHMacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
        HSDSCHMacdFlowSpecificInformation_RL_PreemptRequiredInd_ExtIEs,
        ___EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab,
        ____EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id_tab_val_Value_0,
        __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__id,
        __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__criticality,
        __EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item__value,
        _EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd__item_,
        EDCH_MacdFlowSpecificInformationList_RL_PreemptRequiredInd,
        EDCH_MacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd,
        _EDCH_MacdFlowSpecificInformationItemIEs_RL_PreemptRequiredInd_val_Value_0,
        _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_eDCH_MACdFlow_ID,
        ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id_tab,
        ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__id,
        ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality_tab,
        ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__criticality,
        ____EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue_tab,
        ___EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item__extensionValue,
        __EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions__item_,
        _EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd_iE_Extensions,
        EDCH_MacdFlowSpecificInformationItem_RL_PreemptRequiredInd,
        EDCH_MacdFlowSpecificInformation_RL_PreemptRequiredInd_ExtIEs,
        ____RadioLinkRestoreIndication_protocolIEs__item__id_tab,
        _____RadioLinkRestoreIndication_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkRestoreIndication_protocolIEs__item__id,
        ___RadioLinkRestoreIndication_protocolIEs__item__criticality,
        ___RadioLinkRestoreIndication_protocolIEs__item__value,
        __RadioLinkRestoreIndication_protocolIEs__item_,
        _RadioLinkRestoreIndication_protocolIEs,
        ____RadioLinkRestoreIndication_protocolExtensions__item__id_tab,
        ___RadioLinkRestoreIndication_protocolExtensions__item__id,
        ____RadioLinkRestoreIndication_protocolExtensions__item__criticality_tab,
        ___RadioLinkRestoreIndication_protocolExtensions__item__criticality,
        ____RadioLinkRestoreIndication_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkRestoreIndication_protocolExtensions__item__extensionValue,
        __RadioLinkRestoreIndication_protocolExtensions__item_,
        _RadioLinkRestoreIndication_protocolExtensions,
        RadioLinkRestoreIndication,
        RadioLinkRestoreIndication_IEs,
        _RadioLinkRestoreIndication_IEs_val_Value_0,
        _Reporting_Object_RL_RestoreInd_rL,
        _Reporting_Object_RL_RestoreInd_rL_Set,
        _Reporting_Object_RL_RestoreInd_cCTrCH,
        Reporting_Object_RL_RestoreInd,
        _RL_RL_RestoreInd_rL_InformationList_RL_RestoreInd,
        ____RL_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_RL_RestoreInd_iE_Extensions__item_,
        _RL_RL_RestoreInd_iE_Extensions,
        RL_RL_RestoreInd,
        RLItem_RL_RestoreInd_ExtIEs,
        ___RL_InformationList_RL_RestoreInd__item__id_tab,
        ____RL_InformationList_RL_RestoreInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_RestoreInd__item__id,
        __RL_InformationList_RL_RestoreInd__item__criticality,
        __RL_InformationList_RL_RestoreInd__item__value,
        _RL_InformationList_RL_RestoreInd__item_,
        RL_InformationList_RL_RestoreInd,
        RL_Information_RL_RestoreInd_IEs,
        _RL_Information_RL_RestoreInd_IEs_val_Value_0,
        _RL_Information_RL_RestoreInd_rL_ID,
        ____RL_Information_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_Information_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_Information_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Information_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_Information_RL_RestoreInd_iE_Extensions__item_,
        _RL_Information_RL_RestoreInd_iE_Extensions,
        RL_Information_RL_RestoreInd,
        RL_Information_RL_RestoreInd_ExtIEs,
        _RL_Set_RL_RestoreInd_rL_Set_InformationList_RL_RestoreInd,
        ____RL_Set_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_Set_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_Set_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_Set_RL_RestoreInd_iE_Extensions__item_,
        _RL_Set_RL_RestoreInd_iE_Extensions,
        RL_Set_RL_RestoreInd,
        RL_SetItem_RL_RestoreInd_ExtIEs,
        ___RL_Set_InformationList_RL_RestoreInd__item__id_tab,
        ____RL_Set_InformationList_RL_RestoreInd__item__id_tab_val_Value_0,
        __RL_Set_InformationList_RL_RestoreInd__item__id,
        __RL_Set_InformationList_RL_RestoreInd__item__criticality,
        __RL_Set_InformationList_RL_RestoreInd__item__value,
        _RL_Set_InformationList_RL_RestoreInd__item_,
        RL_Set_InformationList_RL_RestoreInd,
        RL_Set_Information_RL_RestoreInd_IEs,
        _RL_Set_Information_RL_RestoreInd_IEs_val_Value_0,
        _RL_Set_Information_RL_RestoreInd_rL_Set_ID,
        ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__id,
        ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__criticality,
        ____RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_Information_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __RL_Set_Information_RL_RestoreInd_iE_Extensions__item_,
        _RL_Set_Information_RL_RestoreInd_iE_Extensions,
        RL_Set_Information_RL_RestoreInd,
        RL_Set_Information_RL_RestoreInd_ExtIEs,
        RadioLinkRestoreIndication_Extensions,
        _CCTrCH_RL_RestoreInd_rL_ID,
        _CCTrCH_RL_RestoreInd_cCTrCH_InformationList_RL_RestoreInd,
        ____CCTrCH_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___CCTrCH_RL_RestoreInd_iE_Extensions__item__id,
        ____CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_RL_RestoreInd_iE_Extensions__item__criticality,
        ____CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __CCTrCH_RL_RestoreInd_iE_Extensions__item_,
        _CCTrCH_RL_RestoreInd_iE_Extensions,
        CCTrCH_RL_RestoreInd,
        CCTrCHItem_RL_RestoreInd_ExtIEs,
        ___CCTrCH_InformationList_RL_RestoreInd__item__id_tab,
        ____CCTrCH_InformationList_RL_RestoreInd__item__id_tab_val_Value_0,
        __CCTrCH_InformationList_RL_RestoreInd__item__id,
        __CCTrCH_InformationList_RL_RestoreInd__item__criticality,
        __CCTrCH_InformationList_RL_RestoreInd__item__value,
        _CCTrCH_InformationList_RL_RestoreInd__item_,
        CCTrCH_InformationList_RL_RestoreInd,
        CCTrCH_InformationItemIE_RL_RestoreInd,
        _CCTrCH_InformationItemIE_RL_RestoreInd_val_Value_0,
        _CCTrCH_InformationItem_RL_RestoreInd_cCTrCH_ID,
        ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id_tab,
        ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__id,
        ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality_tab,
        ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__criticality,
        ____CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue_tab,
        ___CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item__extensionValue,
        __CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions__item_,
        _CCTrCH_InformationItem_RL_RestoreInd_iE_Extensions,
        CCTrCH_InformationItem_RL_RestoreInd,
        CCTrCH_InformationItem_RL_RestoreInd_ExtIEs,
        ____DL_PowerControlRequest_protocolIEs__item__id_tab,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_1,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_2,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_3,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_4,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_5,
        _____DL_PowerControlRequest_protocolIEs__item__id_tab_val_Value_6,
        ___DL_PowerControlRequest_protocolIEs__item__id,
        ___DL_PowerControlRequest_protocolIEs__item__criticality,
        ___DL_PowerControlRequest_protocolIEs__item__value,
        __DL_PowerControlRequest_protocolIEs__item_,
        _DL_PowerControlRequest_protocolIEs,
        ____DL_PowerControlRequest_protocolExtensions__item__id_tab,
        ___DL_PowerControlRequest_protocolExtensions__item__id,
        ____DL_PowerControlRequest_protocolExtensions__item__criticality_tab,
        ___DL_PowerControlRequest_protocolExtensions__item__criticality,
        ____DL_PowerControlRequest_protocolExtensions__item__extensionValue_tab,
        ___DL_PowerControlRequest_protocolExtensions__item__extensionValue,
        __DL_PowerControlRequest_protocolExtensions__item_,
        _DL_PowerControlRequest_protocolExtensions,
        DL_PowerControlRequest,
        DL_PowerControlRequest_IEs,
        _DL_PowerControlRequest_IEs_val_Value_0,
        _DL_PowerControlRequest_IEs_val_Value_1,
        _DL_PowerControlRequest_IEs_val_Value_2,
        _DL_PowerControlRequest_IEs_val_Value_3,
        _DL_PowerControlRequest_IEs_val_Value_4,
        _DL_PowerControlRequest_IEs_val_Value_5,
        _DL_PowerControlRequest_IEs_val_Value_6,
        ___DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab,
        ____DL_ReferencePowerInformationList_DL_PC_Rqst__item__id_tab_val_Value_0,
        __DL_ReferencePowerInformationList_DL_PC_Rqst__item__id,
        __DL_ReferencePowerInformationList_DL_PC_Rqst__item__criticality,
        __DL_ReferencePowerInformationList_DL_PC_Rqst__item__value,
        _DL_ReferencePowerInformationList_DL_PC_Rqst__item_,
        DL_ReferencePowerInformationList_DL_PC_Rqst,
        DL_ReferencePowerInformation_DL_PC_Rqst_IEs,
        _DL_ReferencePowerInformation_DL_PC_Rqst_IEs_val_Value_0,
        _DL_ReferencePowerInformation_DL_PC_Rqst_rL_ID,
        _DL_ReferencePowerInformation_DL_PC_Rqst_dl_Reference_Power,
        ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id_tab,
        ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__id,
        ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality_tab,
        ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__criticality,
        ____DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue_tab,
        ___DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item__extensionValue,
        __DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions__item_,
        _DL_ReferencePowerInformation_DL_PC_Rqst_iE_Extensions,
        DL_ReferencePowerInformation_DL_PC_Rqst,
        DL_ReferencePowerInformation_DL_PC_Rqst_ExtIEs,
        DL_PowerControlRequest_Extensions,
        ____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab,
        _____DL_PowerTimeslotControlRequest_protocolIEs__item__id_tab_val_Value_0,
        ___DL_PowerTimeslotControlRequest_protocolIEs__item__id,
        ___DL_PowerTimeslotControlRequest_protocolIEs__item__criticality,
        ___DL_PowerTimeslotControlRequest_protocolIEs__item__value,
        __DL_PowerTimeslotControlRequest_protocolIEs__item_,
        _DL_PowerTimeslotControlRequest_protocolIEs,
        ____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab,
        _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____DL_PowerTimeslotControlRequest_protocolExtensions__item__id_tab_val_Extension_2,
        ___DL_PowerTimeslotControlRequest_protocolExtensions__item__id,
        ___DL_PowerTimeslotControlRequest_protocolExtensions__item__criticality,
        ___DL_PowerTimeslotControlRequest_protocolExtensions__item__extensionValue,
        __DL_PowerTimeslotControlRequest_protocolExtensions__item_,
        _DL_PowerTimeslotControlRequest_protocolExtensions,
        DL_PowerTimeslotControlRequest,
        DL_PowerTimeslotControlRequest_IEs,
        _DL_PowerTimeslotControlRequest_IEs_val_Value_0,
        DL_PowerTimeslotControlRequest_Extensions,
        _DL_PowerTimeslotControlRequest_Extensions_val_Extension_0,
        _DL_PowerTimeslotControlRequest_Extensions_val_Extension_1,
        _DL_PowerTimeslotControlRequest_Extensions_val_Extension_2,
        ____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab,
        _____PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id_tab_val_Value_0,
        ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__id,
        ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__criticality,
        ___PhysicalChannelReconfigurationRequestFDD_protocolIEs__item__value,
        __PhysicalChannelReconfigurationRequestFDD_protocolIEs__item_,
        _PhysicalChannelReconfigurationRequestFDD_protocolIEs,
        ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id_tab,
        ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__id,
        ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality_tab,
        ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__criticality,
        ____PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue_tab,
        ___PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item__extensionValue,
        __PhysicalChannelReconfigurationRequestFDD_protocolExtensions__item_,
        _PhysicalChannelReconfigurationRequestFDD_protocolExtensions,
        PhysicalChannelReconfigurationRequestFDD,
        PhysicalChannelReconfigurationRequestFDD_IEs,
        _PhysicalChannelReconfigurationRequestFDD_IEs_val_Value_0,
        _RL_Information_PhyChReconfRqstFDD_rL_ID,
        _RL_Information_PhyChReconfRqstFDD_dl_CodeInformation,
        ____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab,
        _____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__id,
        ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__criticality,
        ___RL_Information_PhyChReconfRqstFDD_iE_Extensions__item__extensionValue,
        __RL_Information_PhyChReconfRqstFDD_iE_Extensions__item_,
        _RL_Information_PhyChReconfRqstFDD_iE_Extensions,
        RL_Information_PhyChReconfRqstFDD,
        RL_Information_PhyChReconfRqstFDD_ExtIEs,
        _RL_Information_PhyChReconfRqstFDD_ExtIEs_val_Extension_0,
        _RL_Information_PhyChReconfRqstFDD_ExtIEs_val_Extension_1,
        __DL_CodeInformationList_PhyChReconfRqstFDD_id_tab,
        ___DL_CodeInformationList_PhyChReconfRqstFDD_id_tab_val_Value_0,
        _DL_CodeInformationList_PhyChReconfRqstFDD_id,
        _DL_CodeInformationList_PhyChReconfRqstFDD_criticality,
        _DL_CodeInformationList_PhyChReconfRqstFDD_value,
        DL_CodeInformationList_PhyChReconfRqstFDD,
        DL_CodeInformationListIEs_PhyChReconfRqstFDD,
        _DL_CodeInformationListIEs_PhyChReconfRqstFDD_val_Value_0,
        PhysicalChannelReconfigurationRequestFDD_Extensions,
        ____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab,
        _____PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id_tab_val_Value_0,
        ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__id,
        ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__criticality,
        ___PhysicalChannelReconfigurationRequestTDD_protocolIEs__item__value,
        __PhysicalChannelReconfigurationRequestTDD_protocolIEs__item_,
        _PhysicalChannelReconfigurationRequestTDD_protocolIEs,
        ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id_tab,
        ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__id,
        ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality_tab,
        ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__criticality,
        ____PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue_tab,
        ___PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item__extensionValue,
        __PhysicalChannelReconfigurationRequestTDD_protocolExtensions__item_,
        _PhysicalChannelReconfigurationRequestTDD_protocolExtensions,
        PhysicalChannelReconfigurationRequestTDD,
        PhysicalChannelReconfigurationRequestTDD_IEs,
        _PhysicalChannelReconfigurationRequestTDD_IEs_val_Value_0,
        _RL_Information_PhyChReconfRqstTDD_rL_ID,
        _RL_Information_PhyChReconfRqstTDD_ul_CCTrCH_Information,
        _RL_Information_PhyChReconfRqstTDD_dl_CCTrCH_Information,
        ____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_3,
        ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ___RL_Information_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __RL_Information_PhyChReconfRqstTDD_iE_Extensions__item_,
        _RL_Information_PhyChReconfRqstTDD_iE_Extensions,
        RL_Information_PhyChReconfRqstTDD,
        RL_Information_PhyChReconfRqstTDD_ExtIEs,
        _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_0,
        _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_1,
        _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_2,
        _RL_Information_PhyChReconfRqstTDD_ExtIEs_val_Extension_3,
        __UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab,
        ___UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0,
        _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_id,
        _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality,
        _UL_CCTrCH_InformationList_PhyChReconfRqstTDD_value,
        UL_CCTrCH_InformationList_PhyChReconfRqstTDD,
        UL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD,
        _UL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0,
        _UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD__item_,
        UL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
        _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_cCTrCH_ID,
        _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ul_DPCH_Information,
        ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        UL_CCTrCH_InformationItem_PhyChReconfRqstTDD,
        UL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        __UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab,
        ___UL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0,
        _UL_DPCH_InformationList_PhyChReconfRqstTDD_id,
        _UL_DPCH_InformationList_PhyChReconfRqstTDD_criticality,
        _UL_DPCH_InformationList_PhyChReconfRqstTDD_value,
        UL_DPCH_InformationList_PhyChReconfRqstTDD,
        UL_DPCH_InformationListIEs_PhyChReconfRqstTDD,
        _UL_DPCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionPeriod,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionLength,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_tDD_DPCHOffset,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_uL_Timeslot_InformationList_PhyChReconfRqstTDD,
        ____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        _____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ___UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        UL_DPCH_InformationItem_PhyChReconfRqstTDD,
        UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0,
        _UL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_1,
        _UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD__item_,
        UL_TimeslotLCR_InformationList_PhyChReconfRqstTDD,
        _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_timeSlotLCR,
        _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_midambleShiftLCR,
        _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_tFCI_Presence,
        _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_uL_Code_LCR_Information,
        ____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        _____UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ___UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD,
        UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _UL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0,
        _UL_Timeslot_InformationList_PhyChReconfRqstTDD__item_,
        UL_Timeslot_InformationList_PhyChReconfRqstTDD,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_timeSlot,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_tFCI_Presence,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_uL_Code_Information,
        ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        UL_Timeslot_InformationItem_PhyChReconfRqstTDD,
        UL_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _UL_Timeslot_InformationList_PhyChReconfRqstTDD768__item_,
        UL_Timeslot_InformationList_PhyChReconfRqstTDD768,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeSlot,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_tFCI_Presence,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_uL_Code_Information768,
        ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id,
        ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_,
        _UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions,
        UL_Timeslot_InformationItem_PhyChReconfRqstTDD768,
        UL_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs,
        __DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab,
        ___DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0,
        _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_id,
        _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_criticality,
        _DL_CCTrCH_InformationList_PhyChReconfRqstTDD_value,
        DL_CCTrCH_InformationList_PhyChReconfRqstTDD,
        DL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD,
        _DL_CCTrCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0,
        _DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD__item_,
        DL_CCTrCH_InformationListIE_PhyChReconfRqstTDD,
        _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_cCTrCH_ID,
        _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_dl_DPCH_Information,
        ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        DL_CCTrCH_InformationItem_PhyChReconfRqstTDD,
        DL_CCTrCH_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        __DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab,
        ___DL_DPCH_InformationList_PhyChReconfRqstTDD_id_tab_val_Value_0,
        _DL_DPCH_InformationList_PhyChReconfRqstTDD_id,
        _DL_DPCH_InformationList_PhyChReconfRqstTDD_criticality,
        _DL_DPCH_InformationList_PhyChReconfRqstTDD_value,
        DL_DPCH_InformationList_PhyChReconfRqstTDD,
        DL_DPCH_InformationListIEs_PhyChReconfRqstTDD,
        _DL_DPCH_InformationListIEs_PhyChReconfRqstTDD_val_Value_0,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionPeriod,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_repetitionLength,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_tDD_DPCHOffset,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_dL_Timeslot_InformationList_PhyChReconfRqstTDD,
        ____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        _____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_0,
        _____DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab_val_Extension_1,
        ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ___DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        DL_DPCH_InformationItem_PhyChReconfRqstTDD,
        DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_0,
        _DL_DPCH_InformationItem_PhyChReconfRqstTDD_ExtIEs_val_Extension_1,
        _DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD__item_,
        DL_TimeslotLCR_InformationList_PhyChReconfRqstTDD,
        _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_timeSlotLCR,
        _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_midambleShiftLCR,
        _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_tFCI_Presence,
        _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_dL_Code_LCR_Information,
        ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD,
        DL_TimeslotLCR_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _DL_Timeslot_InformationList_PhyChReconfRqstTDD__item_,
        DL_Timeslot_InformationList_PhyChReconfRqstTDD,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_timeSlot,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_tFCI_Presence,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_dL_Code_Information,
        ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        DL_Timeslot_InformationItem_PhyChReconfRqstTDD,
        DL_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _DL_Timeslot_InformationList_PhyChReconfRqstTDD768__item_,
        DL_Timeslot_InformationList_PhyChReconfRqstTDD768,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeSlot,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_tFCI_Presence,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_dL_Code_Information768,
        ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab,
        ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id,
        ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab,
        ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality,
        ____DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab,
        ___DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue,
        __DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_,
        _DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions,
        DL_Timeslot_InformationItem_PhyChReconfRqstTDD768,
        DL_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs,
        _HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD__item_,
        HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD,
        _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_timeslot,
        _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_midambleShiftAndBurstType,
        ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions__item_,
        _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_iE_Extensions,
        HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD,
        HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD_ExtIEs,
        _HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD__item_,
        HSPDSCH_Timeslot_InformationListLCR_PhyChReconfRqstTDD,
        _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_timeslotLCR,
        _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_midambleShiftLCR,
        ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id_tab,
        ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__id,
        ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality_tab,
        ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__criticality,
        ____HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue_tab,
        ___HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item__extensionValue,
        __HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions__item_,
        _HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_iE_Extensions,
        HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD,
        HSPDSCH_Timeslot_InformationItemLCR_PhyChReconfRqstTDD_ExtIEs,
        _HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768__item_,
        HSPDSCH_Timeslot_InformationList_PhyChReconfRqstTDD768,
        _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_timeslot,
        _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_midambleShiftAndBurstType768,
        ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id_tab,
        ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__id,
        ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality_tab,
        ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__criticality,
        ____HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue_tab,
        ___HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item__extensionValue,
        __HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions__item_,
        _HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_iE_Extensions,
        HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768,
        HSPDSCH_Timeslot_InformationItem_PhyChReconfRqstTDD768_ExtIEs,
        PhysicalChannelReconfigurationRequestTDD_Extensions,
        ____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab,
        _____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____PhysicalChannelReconfigurationCommand_protocolIEs__item__id_tab_val_Value_1,
        ___PhysicalChannelReconfigurationCommand_protocolIEs__item__id,
        ___PhysicalChannelReconfigurationCommand_protocolIEs__item__criticality,
        ___PhysicalChannelReconfigurationCommand_protocolIEs__item__value,
        __PhysicalChannelReconfigurationCommand_protocolIEs__item_,
        _PhysicalChannelReconfigurationCommand_protocolIEs,
        ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__id_tab,
        ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__id,
        ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality_tab,
        ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__criticality,
        ____PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue_tab,
        ___PhysicalChannelReconfigurationCommand_protocolExtensions__item__extensionValue,
        __PhysicalChannelReconfigurationCommand_protocolExtensions__item_,
        _PhysicalChannelReconfigurationCommand_protocolExtensions,
        PhysicalChannelReconfigurationCommand,
        PhysicalChannelReconfigurationCommand_IEs,
        _PhysicalChannelReconfigurationCommand_IEs_val_Value_0,
        _PhysicalChannelReconfigurationCommand_IEs_val_Value_1,
        PhysicalChannelReconfigurationCommand_Extensions,
        ____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab,
        _____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PhysicalChannelReconfigurationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PhysicalChannelReconfigurationFailure_protocolIEs__item__id,
        ___PhysicalChannelReconfigurationFailure_protocolIEs__item__criticality,
        ___PhysicalChannelReconfigurationFailure_protocolIEs__item__value,
        __PhysicalChannelReconfigurationFailure_protocolIEs__item_,
        _PhysicalChannelReconfigurationFailure_protocolIEs,
        ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__id_tab,
        ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__id,
        ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality_tab,
        ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__criticality,
        ____PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue_tab,
        ___PhysicalChannelReconfigurationFailure_protocolExtensions__item__extensionValue,
        __PhysicalChannelReconfigurationFailure_protocolExtensions__item_,
        _PhysicalChannelReconfigurationFailure_protocolExtensions,
        PhysicalChannelReconfigurationFailure,
        PhysicalChannelReconfigurationFailure_IEs,
        _PhysicalChannelReconfigurationFailure_IEs_val_Value_0,
        _PhysicalChannelReconfigurationFailure_IEs_val_Value_1,
        PhysicalChannelReconfigurationFailure_Extensions,
        ____RadioLinkCongestionIndication_protocolIEs__item__id_tab,
        _____RadioLinkCongestionIndication_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkCongestionIndication_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkCongestionIndication_protocolIEs__item__id,
        ___RadioLinkCongestionIndication_protocolIEs__item__criticality,
        ___RadioLinkCongestionIndication_protocolIEs__item__value,
        __RadioLinkCongestionIndication_protocolIEs__item_,
        _RadioLinkCongestionIndication_protocolIEs,
        ____RadioLinkCongestionIndication_protocolExtensions__item__id_tab,
        ___RadioLinkCongestionIndication_protocolExtensions__item__id,
        ____RadioLinkCongestionIndication_protocolExtensions__item__criticality_tab,
        ___RadioLinkCongestionIndication_protocolExtensions__item__criticality,
        ____RadioLinkCongestionIndication_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkCongestionIndication_protocolExtensions__item__extensionValue,
        __RadioLinkCongestionIndication_protocolExtensions__item_,
        _RadioLinkCongestionIndication_protocolExtensions,
        RadioLinkCongestionIndication,
        RadioLinkCongestionIndication_IEs,
        _RadioLinkCongestionIndication_IEs_val_Value_0,
        _RadioLinkCongestionIndication_IEs_val_Value_1,
        ___RL_InformationList_RL_CongestInd__item__id_tab,
        ____RL_InformationList_RL_CongestInd__item__id_tab_val_Value_0,
        __RL_InformationList_RL_CongestInd__item__id,
        __RL_InformationList_RL_CongestInd__item__criticality,
        __RL_InformationList_RL_CongestInd__item__value,
        _RL_InformationList_RL_CongestInd__item_,
        RL_InformationList_RL_CongestInd,
        RL_InformationItemIEs_RL_CongestInd,
        _RL_InformationItemIEs_RL_CongestInd_val_Value_0,
        _RL_InformationItem_RL_CongestInd_rL_ID,
        _RL_InformationItem_RL_CongestInd_dCH_Rate_Information,
        ____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab,
        _____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__id,
        ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__criticality,
        ___RL_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue,
        __RL_InformationItem_RL_CongestInd_iE_Extensions__item_,
        _RL_InformationItem_RL_CongestInd_iE_Extensions,
        RL_InformationItem_RL_CongestInd,
        ___DCH_Rate_Information_RL_CongestInd__item__id_tab,
        ____DCH_Rate_Information_RL_CongestInd__item__id_tab_val_Value_0,
        __DCH_Rate_Information_RL_CongestInd__item__id,
        __DCH_Rate_Information_RL_CongestInd__item__criticality,
        __DCH_Rate_Information_RL_CongestInd__item__value,
        _DCH_Rate_Information_RL_CongestInd__item_,
        DCH_Rate_Information_RL_CongestInd,
        DCH_Rate_InformationItemIEs_RL_CongestInd,
        _DCH_Rate_InformationItemIEs_RL_CongestInd_val_Value_0,
        _DCH_Rate_InformationItem_RL_CongestInd_dCH_ID,
        _DCH_Rate_InformationItem_RL_CongestInd_allowed_Rate_Information,
        ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id_tab,
        ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__id,
        ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab,
        ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__criticality,
        ____DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab,
        ___DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item__extensionValue,
        __DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions__item_,
        _DCH_Rate_InformationItem_RL_CongestInd_iE_Extensions,
        DCH_Rate_InformationItem_RL_CongestInd,
        DCH_Rate_InformationItem_RL_CongestInd_ExtIEs,
        RL_Information_RL_CongestInd_ExtIEs,
        _RL_Information_RL_CongestInd_ExtIEs_val_Extension_0,
        _RL_Information_RL_CongestInd_ExtIEs_val_Extension_1,
        RadioLinkCongestionIndication_Extensions,
        ___EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab,
        ____EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id_tab_val_Value_0,
        __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__id,
        __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__criticality,
        __EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item__value,
        _EDCH_MacdFlowSpecificInformationList_RL_CongestInd__item_,
        EDCH_MacdFlowSpecificInformationList_RL_CongestInd,
        EDCH_MacdFlowSpecificInformationItemIEs_RL_CongestInd,
        _EDCH_MacdFlowSpecificInformationItemIEs_RL_CongestInd_val_Value_0,
        _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_eDCH_MACdFlow_ID,
        ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id_tab,
        ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__id,
        ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality_tab,
        ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__criticality,
        ____EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue_tab,
        ___EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item__extensionValue,
        __EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions__item_,
        _EDCH_MacdFlowSpecificInformationItem_RL_CongestInd_iE_Extensions,
        EDCH_MacdFlowSpecificInformationItem_RL_CongestInd,
        EDCH_MacdFlowSpecificInformation_RL_CongestInd_ExtIEs,
        ____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_6,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_7,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_8,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_9,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_10,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_11,
        _____UplinkSignallingTransferIndicationFDD_protocolIEs__item__id_tab_val_Value_12,
        ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__id,
        ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__criticality,
        ___UplinkSignallingTransferIndicationFDD_protocolIEs__item__value,
        __UplinkSignallingTransferIndicationFDD_protocolIEs__item_,
        _UplinkSignallingTransferIndicationFDD_protocolIEs,
        ____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_14,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_15,
        _____UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id_tab_val_Extension_16,
        ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__id,
        ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__criticality,
        ___UplinkSignallingTransferIndicationFDD_protocolExtensions__item__extensionValue,
        __UplinkSignallingTransferIndicationFDD_protocolExtensions__item_,
        _UplinkSignallingTransferIndicationFDD_protocolExtensions,
        UplinkSignallingTransferIndicationFDD,
        UplinkSignallingTransferIndicationFDD_IEs,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_0,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_1,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_2,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_3,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_4,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_5,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_6,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_7,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_8,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_9,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_10,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_11,
        _UplinkSignallingTransferIndicationFDD_IEs_val_Value_12,
        UplinkSignallingTransferIndicationFDD_Extensions,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_0,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_1,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_2,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_3,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_4,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_5,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_6,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_7,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_8,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_9,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_10,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_11,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_12,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_13,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_14,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_15,
        _UplinkSignallingTransferIndicationFDD_Extensions_val_Extension_16,
        ____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_5,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_6,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_7,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_8,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_9,
        _____UplinkSignallingTransferIndicationTDD_protocolIEs__item__id_tab_val_Value_10,
        ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__id,
        ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__criticality,
        ___UplinkSignallingTransferIndicationTDD_protocolIEs__item__value,
        __UplinkSignallingTransferIndicationTDD_protocolIEs__item_,
        _UplinkSignallingTransferIndicationTDD_protocolIEs,
        ____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_6,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_7,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_8,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_9,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_10,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_11,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_12,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_13,
        _____UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id_tab_val_Extension_14,
        ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__id,
        ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__criticality,
        ___UplinkSignallingTransferIndicationTDD_protocolExtensions__item__extensionValue,
        __UplinkSignallingTransferIndicationTDD_protocolExtensions__item_,
        _UplinkSignallingTransferIndicationTDD_protocolExtensions,
        UplinkSignallingTransferIndicationTDD,
        UplinkSignallingTransferIndicationTDD_IEs,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_0,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_1,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_2,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_3,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_4,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_5,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_6,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_7,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_8,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_9,
        _UplinkSignallingTransferIndicationTDD_IEs_val_Value_10,
        UplinkSignallingTransferIndicationTDD_Extensions,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_0,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_1,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_2,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_3,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_4,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_5,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_6,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_7,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_8,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_9,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_10,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_11,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_12,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_13,
        _UplinkSignallingTransferIndicationTDD_Extensions_val_Extension_14,
        ____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab,
        _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_1,
        _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_2,
        _____DownlinkSignallingTransferRequest_protocolIEs__item__id_tab_val_Value_3,
        ___DownlinkSignallingTransferRequest_protocolIEs__item__id,
        ___DownlinkSignallingTransferRequest_protocolIEs__item__criticality,
        ___DownlinkSignallingTransferRequest_protocolIEs__item__value,
        __DownlinkSignallingTransferRequest_protocolIEs__item_,
        _DownlinkSignallingTransferRequest_protocolIEs,
        ____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab,
        _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____DownlinkSignallingTransferRequest_protocolExtensions__item__id_tab_val_Extension_5,
        ___DownlinkSignallingTransferRequest_protocolExtensions__item__id,
        ___DownlinkSignallingTransferRequest_protocolExtensions__item__criticality,
        ___DownlinkSignallingTransferRequest_protocolExtensions__item__extensionValue,
        __DownlinkSignallingTransferRequest_protocolExtensions__item_,
        _DownlinkSignallingTransferRequest_protocolExtensions,
        DownlinkSignallingTransferRequest,
        DownlinkSignallingTransferRequest_IEs,
        _DownlinkSignallingTransferRequest_IEs_val_Value_0,
        _DownlinkSignallingTransferRequest_IEs_val_Value_1,
        _DownlinkSignallingTransferRequest_IEs_val_Value_2,
        _DownlinkSignallingTransferRequest_IEs_val_Value_3,
        DownlinkSignallingTransferRequest_Extensions,
        _DownlinkSignallingTransferRequest_Extensions_val_Extension_0,
        _DownlinkSignallingTransferRequest_Extensions_val_Extension_1,
        _DownlinkSignallingTransferRequest_Extensions_val_Extension_2,
        _DownlinkSignallingTransferRequest_Extensions_val_Extension_3,
        _DownlinkSignallingTransferRequest_Extensions_val_Extension_4,
        _DownlinkSignallingTransferRequest_Extensions_val_Extension_5,
        ____RelocationCommit_protocolIEs__item__id_tab,
        _____RelocationCommit_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationCommit_protocolIEs__item__id_tab_val_Value_1,
        ___RelocationCommit_protocolIEs__item__id,
        ___RelocationCommit_protocolIEs__item__criticality,
        ___RelocationCommit_protocolIEs__item__value,
        __RelocationCommit_protocolIEs__item_,
        _RelocationCommit_protocolIEs,
        ____RelocationCommit_protocolExtensions__item__id_tab,
        ___RelocationCommit_protocolExtensions__item__id,
        ____RelocationCommit_protocolExtensions__item__criticality_tab,
        ___RelocationCommit_protocolExtensions__item__criticality,
        ____RelocationCommit_protocolExtensions__item__extensionValue_tab,
        ___RelocationCommit_protocolExtensions__item__extensionValue,
        __RelocationCommit_protocolExtensions__item_,
        _RelocationCommit_protocolExtensions,
        RelocationCommit,
        RelocationCommit_IEs,
        _RelocationCommit_IEs_val_Value_0,
        _RelocationCommit_IEs_val_Value_1,
        RelocationCommit_Extensions,
        ____PagingRequest_protocolIEs__item__id_tab,
        _____PagingRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PagingRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PagingRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PagingRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PagingRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PagingRequest_protocolIEs__item__id_tab_val_Value_5,
        ___PagingRequest_protocolIEs__item__id,
        ___PagingRequest_protocolIEs__item__criticality,
        ___PagingRequest_protocolIEs__item__value,
        __PagingRequest_protocolIEs__item_,
        _PagingRequest_protocolIEs,
        ____PagingRequest_protocolExtensions__item__id_tab,
        _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____PagingRequest_protocolExtensions__item__id_tab_val_Extension_2,
        ___PagingRequest_protocolExtensions__item__id,
        ___PagingRequest_protocolExtensions__item__criticality,
        ___PagingRequest_protocolExtensions__item__extensionValue,
        __PagingRequest_protocolExtensions__item_,
        _PagingRequest_protocolExtensions,
        PagingRequest,
        PagingRequest_IEs,
        _PagingRequest_IEs_val_Value_0,
        _PagingRequest_IEs_val_Value_1,
        _PagingRequest_IEs_val_Value_2,
        _PagingRequest_IEs_val_Value_3,
        _PagingRequest_IEs_val_Value_4,
        _PagingRequest_IEs_val_Value_5,
        _PagingArea_PagingRqst_uRA,
        _PagingArea_PagingRqst_cell,
        PagingArea_PagingRqst,
        _URA_PagingRqst_uRA_ID,
        ____URA_PagingRqst_iE_Extensions__item__id_tab,
        ___URA_PagingRqst_iE_Extensions__item__id,
        ____URA_PagingRqst_iE_Extensions__item__criticality_tab,
        ___URA_PagingRqst_iE_Extensions__item__criticality,
        ____URA_PagingRqst_iE_Extensions__item__extensionValue_tab,
        ___URA_PagingRqst_iE_Extensions__item__extensionValue,
        __URA_PagingRqst_iE_Extensions__item_,
        _URA_PagingRqst_iE_Extensions,
        URA_PagingRqst,
        URAItem_PagingRqst_ExtIEs,
        _Cell_PagingRqst_c_ID,
        ____Cell_PagingRqst_iE_Extensions__item__id_tab,
        ___Cell_PagingRqst_iE_Extensions__item__id,
        ____Cell_PagingRqst_iE_Extensions__item__criticality_tab,
        ___Cell_PagingRqst_iE_Extensions__item__criticality,
        ____Cell_PagingRqst_iE_Extensions__item__extensionValue_tab,
        ___Cell_PagingRqst_iE_Extensions__item__extensionValue,
        __Cell_PagingRqst_iE_Extensions__item_,
        _Cell_PagingRqst_iE_Extensions,
        Cell_PagingRqst,
        CellItem_PagingRqst_ExtIEs,
        _CNOriginatedPage_PagingRqst_pagingCause,
        _CNOriginatedPage_PagingRqst_cNDomainType,
        _CNOriginatedPage_PagingRqst_pagingRecordType,
        ____CNOriginatedPage_PagingRqst_iE_Extensions__item__id_tab,
        ___CNOriginatedPage_PagingRqst_iE_Extensions__item__id,
        ____CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality_tab,
        ___CNOriginatedPage_PagingRqst_iE_Extensions__item__criticality,
        ____CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue_tab,
        ___CNOriginatedPage_PagingRqst_iE_Extensions__item__extensionValue,
        __CNOriginatedPage_PagingRqst_iE_Extensions__item_,
        _CNOriginatedPage_PagingRqst_iE_Extensions,
        CNOriginatedPage_PagingRqst,
        CNOriginatedPage_PagingRqst_ExtIEs,
        PagingRequest_Extensions,
        _PagingRequest_Extensions_val_Extension_0,
        _PagingRequest_Extensions_val_Extension_1,
        _PagingRequest_Extensions_val_Extension_2,
        ____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____DedicatedMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___DedicatedMeasurementInitiationRequest_protocolIEs__item__id,
        ___DedicatedMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___DedicatedMeasurementInitiationRequest_protocolIEs__item__value,
        __DedicatedMeasurementInitiationRequest_protocolIEs__item_,
        _DedicatedMeasurementInitiationRequest_protocolIEs,
        ____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____DedicatedMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__id,
        ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__criticality,
        ___DedicatedMeasurementInitiationRequest_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementInitiationRequest_protocolExtensions__item_,
        _DedicatedMeasurementInitiationRequest_protocolExtensions,
        DedicatedMeasurementInitiationRequest,
        DedicatedMeasurementInitiationRequest_IEs,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_0,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_1,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_2,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_3,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_4,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_5,
        _DedicatedMeasurementInitiationRequest_IEs_val_Value_6,
        _DedicatedMeasurementObjectType_DM_Rqst_rL,
        _DedicatedMeasurementObjectType_DM_Rqst_rLS,
        _DedicatedMeasurementObjectType_DM_Rqst_allRL,
        _DedicatedMeasurementObjectType_DM_Rqst_allRLS,
        DedicatedMeasurementObjectType_DM_Rqst,
        _RL_DM_Rqst_rL_InformationList_DM_Rqst,
        ____RL_DM_Rqst_iE_Extensions__item__id_tab,
        ___RL_DM_Rqst_iE_Extensions__item__id,
        ____RL_DM_Rqst_iE_Extensions__item__criticality_tab,
        ___RL_DM_Rqst_iE_Extensions__item__criticality,
        ____RL_DM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_DM_Rqst_iE_Extensions__item_,
        _RL_DM_Rqst_iE_Extensions,
        RL_DM_Rqst,
        RLItem_DM_Rqst_ExtIEs,
        ___RL_InformationList_DM_Rqst__item__id_tab,
        ____RL_InformationList_DM_Rqst__item__id_tab_val_Value_0,
        __RL_InformationList_DM_Rqst__item__id,
        __RL_InformationList_DM_Rqst__item__criticality,
        __RL_InformationList_DM_Rqst__item__value,
        _RL_InformationList_DM_Rqst__item_,
        RL_InformationList_DM_Rqst,
        RL_Information_DM_Rqst_IEs,
        _RL_Information_DM_Rqst_IEs_val_Value_0,
        _RL_InformationItem_DM_Rqst_rL_ID,
        _RL_InformationItem_DM_Rqst_dPCH_ID,
        ____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_DM_Rqst_iE_Extensions__item__id_tab_val_Extension_2,
        ___RL_InformationItem_DM_Rqst_iE_Extensions__item__id,
        ___RL_InformationItem_DM_Rqst_iE_Extensions__item__criticality,
        ___RL_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_InformationItem_DM_Rqst_iE_Extensions__item_,
        _RL_InformationItem_DM_Rqst_iE_Extensions,
        RL_InformationItem_DM_Rqst,
        RL_InformationItem_DM_Rqst_ExtIEs,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_0,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_1,
        _RL_InformationItem_DM_Rqst_ExtIEs_val_Extension_2,
        _HSSICH_Info_DM_Rqst__item_,
        HSSICH_Info_DM_Rqst,
        _HSSICH_Info_DM_Rqst_Extension__item_,
        HSSICH_Info_DM_Rqst_Extension,
        _RL_Set_DM_Rqst_rL_Set_InformationList_DM_Rqst,
        ____RL_Set_DM_Rqst_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Rqst_iE_Extensions__item__id,
        ____RL_Set_DM_Rqst_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Rqst_iE_Extensions__item__criticality,
        ____RL_Set_DM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Rqst_iE_Extensions__item_,
        _RL_Set_DM_Rqst_iE_Extensions,
        RL_Set_DM_Rqst,
        RL_SetItem_DM_Rqst_ExtIEs,
        ___RL_Set_InformationList_DM_Rqst__item__id_tab,
        ____RL_Set_InformationList_DM_Rqst__item__id_tab_val_Value_0,
        __RL_Set_InformationList_DM_Rqst__item__id,
        __RL_Set_InformationList_DM_Rqst__item__criticality,
        __RL_Set_InformationList_DM_Rqst__item__value,
        _RL_Set_InformationList_DM_Rqst__item_,
        RL_Set_InformationList_DM_Rqst,
        RL_Set_Information_DM_Rqst_IEs,
        _RL_Set_Information_DM_Rqst_IEs_val_Value_0,
        _RL_Set_InformationItem_DM_Rqst_rL_Set_ID,
        ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__id,
        ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_DM_Rqst_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_DM_Rqst_iE_Extensions__item_,
        _RL_Set_InformationItem_DM_Rqst_iE_Extensions,
        RL_Set_InformationItem_DM_Rqst,
        RL_Set_InformationItem_DM_Rqst_ExtIEs,
        All_RL_DM_Rqst,
        All_RL_Set_DM_Rqst,
        DedicatedMeasurementInitiationRequest_Extensions,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_0,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_1,
        _DedicatedMeasurementInitiationRequest_Extensions_val_Extension_2,
        ____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___DedicatedMeasurementInitiationResponse_protocolIEs__item__id,
        ___DedicatedMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___DedicatedMeasurementInitiationResponse_protocolIEs__item__value,
        __DedicatedMeasurementInitiationResponse_protocolIEs__item_,
        _DedicatedMeasurementInitiationResponse_protocolIEs,
        ____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__id,
        ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__criticality,
        ___DedicatedMeasurementInitiationResponse_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementInitiationResponse_protocolExtensions__item_,
        _DedicatedMeasurementInitiationResponse_protocolExtensions,
        DedicatedMeasurementInitiationResponse,
        DedicatedMeasurementInitiationResponse_IEs,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_0,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_1,
        _DedicatedMeasurementInitiationResponse_IEs_val_Value_2,
        _DedicatedMeasurementObjectType_DM_Rsp_rLs,
        _DedicatedMeasurementObjectType_DM_Rsp_rLS,
        _DedicatedMeasurementObjectType_DM_Rsp_allRL,
        _DedicatedMeasurementObjectType_DM_Rsp_allRLS,
        DedicatedMeasurementObjectType_DM_Rsp,
        _RL_DM_Rsp_rL_InformationList_DM_Rsp,
        ____RL_DM_Rsp_iE_Extensions__item__id_tab,
        ___RL_DM_Rsp_iE_Extensions__item__id,
        ____RL_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___RL_DM_Rsp_iE_Extensions__item__criticality,
        ____RL_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_DM_Rsp_iE_Extensions__item_,
        _RL_DM_Rsp_iE_Extensions,
        RL_DM_Rsp,
        RLItem_DM_Rsp_ExtIEs,
        _RL_Set_DM_Rsp_rL_Set_InformationList_DM_Rsp,
        ____RL_Set_DM_Rsp_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Rsp_iE_Extensions__item__id,
        ____RL_Set_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Rsp_iE_Extensions__item__criticality,
        ____RL_Set_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Rsp_iE_Extensions__item_,
        _RL_Set_DM_Rsp_iE_Extensions,
        RL_Set_DM_Rsp,
        RL_SetItem_DM_Rsp_ExtIEs,
        ___RL_InformationList_DM_Rsp__item__id_tab,
        ____RL_InformationList_DM_Rsp__item__id_tab_val_Value_0,
        __RL_InformationList_DM_Rsp__item__id,
        __RL_InformationList_DM_Rsp__item__criticality,
        __RL_InformationList_DM_Rsp__item__value,
        _RL_InformationList_DM_Rsp__item_,
        RL_InformationList_DM_Rsp,
        RL_Information_DM_Rsp_IEs,
        _RL_Information_DM_Rsp_IEs_val_Value_0,
        _RL_InformationItem_DM_Rsp_rL_ID,
        _RL_InformationItem_DM_Rsp_dPCH_ID,
        _RL_InformationItem_DM_Rsp_dedicatedMeasurementValue,
        _RL_InformationItem_DM_Rsp_cFN,
        ____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_2,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_3,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_4,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_5,
        _____RL_InformationItem_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_6,
        ___RL_InformationItem_DM_Rsp_iE_Extensions__item__id,
        ___RL_InformationItem_DM_Rsp_iE_Extensions__item__criticality,
        ___RL_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_InformationItem_DM_Rsp_iE_Extensions__item_,
        _RL_InformationItem_DM_Rsp_iE_Extensions,
        RL_InformationItem_DM_Rsp,
        RL_InformationItem_DM_Rsp_ExtIEs,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_0,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_1,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_2,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_3,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_4,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_5,
        _RL_InformationItem_DM_Rsp_ExtIEs_val_Extension_6,
        ___RL_Set_InformationList_DM_Rsp__item__id_tab,
        ____RL_Set_InformationList_DM_Rsp__item__id_tab_val_Value_0,
        __RL_Set_InformationList_DM_Rsp__item__id,
        __RL_Set_InformationList_DM_Rsp__item__criticality,
        __RL_Set_InformationList_DM_Rsp__item__value,
        _RL_Set_InformationList_DM_Rsp__item_,
        RL_Set_InformationList_DM_Rsp,
        RL_Set_Information_DM_Rsp_IEs,
        _RL_Set_Information_DM_Rsp_IEs_val_Value_0,
        _RL_Set_InformationItem_DM_Rsp_rL_Set_ID,
        _RL_Set_InformationItem_DM_Rsp_dedicatedMeasurementValue,
        _RL_Set_InformationItem_DM_Rsp_cFN,
        ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__id,
        ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_DM_Rsp_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_DM_Rsp_iE_Extensions__item_,
        _RL_Set_InformationItem_DM_Rsp_iE_Extensions,
        RL_Set_InformationItem_DM_Rsp,
        RL_Set_InformationItem_DM_Rspns_ExtIEs,
        DedicatedMeasurementInitiationResponse_Extensions,
        _DedicatedMeasurementInitiationResponse_Extensions_val_Extension_0,
        _Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp__item_,
        Multiple_DedicatedMeasurementValueList_TDD_DM_Rsp,
        _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dPCH_ID,
        _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_iE_Extensions,
        Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp,
        Multiple_DedicatedMeasurementValueItem_TDD_DM_Rsp_ExtIEs,
        _Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp__item_,
        Multiple_DedicatedMeasurementValueList_LCR_TDD_DM_Rsp,
        _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dPCH_ID,
        _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_iE_Extensions,
        Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp,
        Multiple_DedicatedMeasurementValueItem_LCR_TDD_DM_Rsp_ExtIEs,
        _Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp__item_,
        Multiple_HSSICHMeasurementValueList_TDD_DM_Rsp,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_hsSICH_ID,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab,
        _____Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id_tab_val_Extension_0,
        ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__id,
        ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__criticality,
        ___Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions__item_,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_iE_Extensions,
        Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp,
        Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs,
        _Multiple_HSSICHMeasurementValueItem_TDD_DM_Rsp_ExtIEs_val_Extension_0,
        _Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp__item_,
        Multiple_DedicatedMeasurementValueList_TDD768_DM_Rsp,
        _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_dPCH_ID768,
        _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_dedicatedMeasurementValue,
        ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__id,
        ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__criticality,
        ____Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item__extensionValue,
        __Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions__item_,
        _Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_iE_Extensions,
        Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp,
        Multiple_DedicatedMeasurementValueItem_TDD768_DM_Rsp_ExtIEs,
        ____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____DedicatedMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___DedicatedMeasurementInitiationFailure_protocolIEs__item__id,
        ___DedicatedMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___DedicatedMeasurementInitiationFailure_protocolIEs__item__value,
        __DedicatedMeasurementInitiationFailure_protocolIEs__item_,
        _DedicatedMeasurementInitiationFailure_protocolIEs,
        ____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementInitiationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__id,
        ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__criticality,
        ___DedicatedMeasurementInitiationFailure_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementInitiationFailure_protocolExtensions__item_,
        _DedicatedMeasurementInitiationFailure_protocolExtensions,
        DedicatedMeasurementInitiationFailure,
        DedicatedMeasurementInitiationFailure_IEs,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_0,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_1,
        _DedicatedMeasurementInitiationFailure_IEs_val_Value_2,
        DedicatedMeasurementInitiationFailure_Extensions,
        _DedicatedMeasurementInitiationFailure_Extensions_val_Extension_0,
        _DedicatedMeasurementObjectType_DM_Fail_rL,
        _DedicatedMeasurementObjectType_DM_Fail_rLS,
        _DedicatedMeasurementObjectType_DM_Fail_allRL,
        _DedicatedMeasurementObjectType_DM_Fail_allRLS,
        DedicatedMeasurementObjectType_DM_Fail,
        _RL_DM_Fail_rL_unsuccessful_InformationRespList_DM_Fail,
        _RL_DM_Fail_rL_successful_InformationRespList_DM_Fail,
        ____RL_DM_Fail_iE_Extensions__item__id_tab,
        ___RL_DM_Fail_iE_Extensions__item__id,
        ____RL_DM_Fail_iE_Extensions__item__criticality_tab,
        ___RL_DM_Fail_iE_Extensions__item__criticality,
        ____RL_DM_Fail_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Fail_iE_Extensions__item__extensionValue,
        __RL_DM_Fail_iE_Extensions__item_,
        _RL_DM_Fail_iE_Extensions,
        RL_DM_Fail,
        RLItem_DM_Fail_ExtIEs,
        _RL_Set_DM_Fail_rL_Set_unsuccessful_InformationRespList_DM_Fail,
        _RL_Set_DM_Fail_rL_Set_successful_InformationRespList_DM_Fail,
        ____RL_Set_DM_Fail_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Fail_iE_Extensions__item__id,
        ____RL_Set_DM_Fail_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Fail_iE_Extensions__item__criticality,
        ____RL_Set_DM_Fail_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Fail_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Fail_iE_Extensions__item_,
        _RL_Set_DM_Fail_iE_Extensions,
        RL_Set_DM_Fail,
        RL_SetItem_DM_Fail_ExtIEs,
        ___RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab,
        ____RL_Unsuccessful_InformationRespList_DM_Fail__item__id_tab_val_Value_0,
        __RL_Unsuccessful_InformationRespList_DM_Fail__item__id,
        __RL_Unsuccessful_InformationRespList_DM_Fail__item__criticality,
        __RL_Unsuccessful_InformationRespList_DM_Fail__item__value,
        _RL_Unsuccessful_InformationRespList_DM_Fail__item_,
        RL_Unsuccessful_InformationRespList_DM_Fail,
        RL_Unsuccessful_InformationResp_DM_Fail_IEs,
        _RL_Unsuccessful_InformationResp_DM_Fail_IEs_val_Value_0,
        _RL_Unsuccessful_InformationItem_DM_Fail_rL_ID,
        _RL_Unsuccessful_InformationItem_DM_Fail_individualcause,
        ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab,
        ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id,
        ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab,
        ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality,
        ____RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab,
        ___RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue,
        __RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_,
        _RL_Unsuccessful_InformationItem_DM_Fail_iE_Extensions,
        RL_Unsuccessful_InformationItem_DM_Fail,
        RL_Unsuccessful_InformationItem_DM_Fail_ExtIEs,
        ___RL_Successful_InformationRespList_DM_Fail__item__id_tab,
        ____RL_Successful_InformationRespList_DM_Fail__item__id_tab_val_Value_0,
        __RL_Successful_InformationRespList_DM_Fail__item__id,
        __RL_Successful_InformationRespList_DM_Fail__item__criticality,
        __RL_Successful_InformationRespList_DM_Fail__item__value,
        _RL_Successful_InformationRespList_DM_Fail__item_,
        RL_Successful_InformationRespList_DM_Fail,
        RL_Successful_InformationResp_DM_Fail_IEs,
        _RL_Successful_InformationResp_DM_Fail_IEs_val_Value_0,
        _RL_Successful_InformationItem_DM_Fail_rL_ID,
        _RL_Successful_InformationItem_DM_Fail_dPCH_ID,
        _RL_Successful_InformationItem_DM_Fail_dedicatedMeasurementValue,
        _RL_Successful_InformationItem_DM_Fail_cFN,
        ____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab,
        _____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab_val_Extension_1,
        ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__id,
        ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality,
        ___RL_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue,
        __RL_Successful_InformationItem_DM_Fail_iE_Extensions__item_,
        _RL_Successful_InformationItem_DM_Fail_iE_Extensions,
        RL_Successful_InformationItem_DM_Fail,
        RL_Successful_InformationItem_DM_Fail_ExtIEs,
        _RL_Successful_InformationItem_DM_Fail_ExtIEs_val_Extension_0,
        _RL_Successful_InformationItem_DM_Fail_ExtIEs_val_Extension_1,
        ___RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab,
        ____RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id_tab_val_Value_0,
        __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__id,
        __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__criticality,
        __RL_Set_Unsuccessful_InformationRespList_DM_Fail__item__value,
        _RL_Set_Unsuccessful_InformationRespList_DM_Fail__item_,
        RL_Set_Unsuccessful_InformationRespList_DM_Fail,
        RL_Set_Unsuccessful_InformationResp_DM_Fail_IEs,
        _RL_Set_Unsuccessful_InformationResp_DM_Fail_IEs_val_Value_0,
        _RL_Set_Unsuccessful_InformationItem_DM_Fail_rL_Set_ID,
        _RL_Set_Unsuccessful_InformationItem_DM_Fail_individualcause,
        ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id_tab,
        ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__id,
        ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab,
        ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__criticality,
        ____RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue,
        __RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions__item_,
        _RL_Set_Unsuccessful_InformationItem_DM_Fail_iE_Extensions,
        RL_Set_Unsuccessful_InformationItem_DM_Fail,
        RL_Set_Unsuccessful_InformationItem_DM_Failns_ExtIEs,
        ___RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab,
        ____RL_Set_Successful_InformationRespList_DM_Fail__item__id_tab_val_Value_0,
        __RL_Set_Successful_InformationRespList_DM_Fail__item__id,
        __RL_Set_Successful_InformationRespList_DM_Fail__item__criticality,
        __RL_Set_Successful_InformationRespList_DM_Fail__item__value,
        _RL_Set_Successful_InformationRespList_DM_Fail__item_,
        RL_Set_Successful_InformationRespList_DM_Fail,
        RL_Set_Successful_InformationResp_DM_Fail_IEs,
        _RL_Set_Successful_InformationResp_DM_Fail_IEs_val_Value_0,
        _RL_Set_Successful_InformationItem_DM_Fail_rL_Set_ID,
        _RL_Set_Successful_InformationItem_DM_Fail_dedicatedMeasurementValue,
        _RL_Set_Successful_InformationItem_DM_Fail_cFN,
        ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id_tab,
        ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__id,
        ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality_tab,
        ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__criticality,
        ____RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item__extensionValue,
        __RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions__item_,
        _RL_Set_Successful_InformationItem_DM_Fail_iE_Extensions,
        RL_Set_Successful_InformationItem_DM_Fail,
        RL_Set_Successful_InformationItem_DM_Failns_ExtIEs,
        ____DedicatedMeasurementReport_protocolIEs__item__id_tab,
        _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        ___DedicatedMeasurementReport_protocolIEs__item__id,
        ___DedicatedMeasurementReport_protocolIEs__item__criticality,
        ___DedicatedMeasurementReport_protocolIEs__item__value,
        __DedicatedMeasurementReport_protocolIEs__item_,
        _DedicatedMeasurementReport_protocolIEs,
        ____DedicatedMeasurementReport_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0,
        ___DedicatedMeasurementReport_protocolExtensions__item__id,
        ___DedicatedMeasurementReport_protocolExtensions__item__criticality,
        ___DedicatedMeasurementReport_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementReport_protocolExtensions__item_,
        _DedicatedMeasurementReport_protocolExtensions,
        DedicatedMeasurementReport,
        DedicatedMeasurementReport_IEs,
        _DedicatedMeasurementReport_IEs_val_Value_0,
        _DedicatedMeasurementReport_IEs_val_Value_1,
        _DedicatedMeasurementObjectType_DM_Rprt_rLs,
        _DedicatedMeasurementObjectType_DM_Rprt_rLS,
        _DedicatedMeasurementObjectType_DM_Rprt_allRL,
        _DedicatedMeasurementObjectType_DM_Rprt_allRLS,
        DedicatedMeasurementObjectType_DM_Rprt,
        _RL_DM_Rprt_rL_InformationList_DM_Rprt,
        ____RL_DM_Rprt_iE_Extensions__item__id_tab,
        ___RL_DM_Rprt_iE_Extensions__item__id,
        ____RL_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___RL_DM_Rprt_iE_Extensions__item__criticality,
        ____RL_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_DM_Rprt_iE_Extensions__item_,
        _RL_DM_Rprt_iE_Extensions,
        RL_DM_Rprt,
        RLItem_DM_Rprt_ExtIEs,
        _RL_Set_DM_Rprt_rL_Set_InformationList_DM_Rprt,
        ____RL_Set_DM_Rprt_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Rprt_iE_Extensions__item__id,
        ____RL_Set_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Rprt_iE_Extensions__item__criticality,
        ____RL_Set_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Rprt_iE_Extensions__item_,
        _RL_Set_DM_Rprt_iE_Extensions,
        RL_Set_DM_Rprt,
        RL_SetItem_DM_Rprt_ExtIEs,
        ___RL_InformationList_DM_Rprt__item__id_tab,
        ____RL_InformationList_DM_Rprt__item__id_tab_val_Value_0,
        __RL_InformationList_DM_Rprt__item__id,
        __RL_InformationList_DM_Rprt__item__criticality,
        __RL_InformationList_DM_Rprt__item__value,
        _RL_InformationList_DM_Rprt__item_,
        RL_InformationList_DM_Rprt,
        RL_Information_DM_Rprt_IEs,
        _RL_Information_DM_Rprt_IEs_val_Value_0,
        _RL_InformationItem_DM_Rprt_rL_ID,
        _RL_InformationItem_DM_Rprt_dPCH_ID,
        _RL_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation,
        ____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_0,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_1,
        _____RL_InformationItem_DM_Rprt_iE_Extensions__item__id_tab_val_Extension_2,
        ___RL_InformationItem_DM_Rprt_iE_Extensions__item__id,
        ___RL_InformationItem_DM_Rprt_iE_Extensions__item__criticality,
        ___RL_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_InformationItem_DM_Rprt_iE_Extensions__item_,
        _RL_InformationItem_DM_Rprt_iE_Extensions,
        RL_InformationItem_DM_Rprt,
        RL_InformationItem_DM_Rprt_ExtIEs,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_0,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_1,
        _RL_InformationItem_DM_Rprt_ExtIEs_val_Extension_2,
        ___RL_Set_InformationList_DM_Rprt__item__id_tab,
        ____RL_Set_InformationList_DM_Rprt__item__id_tab_val_Value_0,
        __RL_Set_InformationList_DM_Rprt__item__id,
        __RL_Set_InformationList_DM_Rprt__item__criticality,
        __RL_Set_InformationList_DM_Rprt__item__value,
        _RL_Set_InformationList_DM_Rprt__item_,
        RL_Set_InformationList_DM_Rprt,
        RL_Set_Information_DM_Rprt_IEs,
        _RL_Set_Information_DM_Rprt_IEs_val_Value_0,
        _RL_Set_InformationItem_DM_Rprt_rL_Set_ID,
        _RL_Set_InformationItem_DM_Rprt_dedicatedMeasurementValueInformation,
        ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id_tab,
        ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__id,
        ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality_tab,
        ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__criticality,
        ____RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_InformationItem_DM_Rprt_iE_Extensions__item__extensionValue,
        __RL_Set_InformationItem_DM_Rprt_iE_Extensions__item_,
        _RL_Set_InformationItem_DM_Rprt_iE_Extensions,
        RL_Set_InformationItem_DM_Rprt,
        RL_Set_InformationItem_DM_Rprt_ExtIEs,
        DedicatedMeasurementReport_Extensions,
        _DedicatedMeasurementReport_Extensions_val_Extension_0,
        ____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab,
        _____DedicatedMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___DedicatedMeasurementTerminationRequest_protocolIEs__item__id,
        ___DedicatedMeasurementTerminationRequest_protocolIEs__item__criticality,
        ___DedicatedMeasurementTerminationRequest_protocolIEs__item__value,
        __DedicatedMeasurementTerminationRequest_protocolIEs__item_,
        _DedicatedMeasurementTerminationRequest_protocolIEs,
        ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__id_tab,
        ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__id,
        ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality_tab,
        ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__criticality,
        ____DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___DedicatedMeasurementTerminationRequest_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementTerminationRequest_protocolExtensions__item_,
        _DedicatedMeasurementTerminationRequest_protocolExtensions,
        DedicatedMeasurementTerminationRequest,
        DedicatedMeasurementTerminationRequest_IEs,
        _DedicatedMeasurementTerminationRequest_IEs_val_Value_0,
        DedicatedMeasurementTerminationRequest_Extensions,
        ____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____DedicatedMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___DedicatedMeasurementFailureIndication_protocolIEs__item__id,
        ___DedicatedMeasurementFailureIndication_protocolIEs__item__criticality,
        ___DedicatedMeasurementFailureIndication_protocolIEs__item__value,
        __DedicatedMeasurementFailureIndication_protocolIEs__item_,
        _DedicatedMeasurementFailureIndication_protocolIEs,
        ____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab,
        _____DedicatedMeasurementFailureIndication_protocolExtensions__item__id_tab_val_Extension_0,
        ___DedicatedMeasurementFailureIndication_protocolExtensions__item__id,
        ___DedicatedMeasurementFailureIndication_protocolExtensions__item__criticality,
        ___DedicatedMeasurementFailureIndication_protocolExtensions__item__extensionValue,
        __DedicatedMeasurementFailureIndication_protocolExtensions__item_,
        _DedicatedMeasurementFailureIndication_protocolExtensions,
        DedicatedMeasurementFailureIndication,
        DedicatedMeasurementFailureIndication_IEs,
        _DedicatedMeasurementFailureIndication_IEs_val_Value_0,
        _DedicatedMeasurementFailureIndication_IEs_val_Value_1,
        DedicatedMeasurementFailureIndication_Extensions,
        _DedicatedMeasurementFailureIndication_Extensions_val_Extension_0,
        _DedicatedMeasurementObjectType_DM_Fail_Ind_rL,
        _DedicatedMeasurementObjectType_DM_Fail_Ind_rLS,
        _DedicatedMeasurementObjectType_DM_Fail_Ind_allRL,
        _DedicatedMeasurementObjectType_DM_Fail_Ind_allRLS,
        DedicatedMeasurementObjectType_DM_Fail_Ind,
        _RL_DM_Fail_Ind_rL_unsuccessful_InformationRespList_DM_Fail_Ind,
        ____RL_DM_Fail_Ind_iE_Extensions__item__id_tab,
        ___RL_DM_Fail_Ind_iE_Extensions__item__id,
        ____RL_DM_Fail_Ind_iE_Extensions__item__criticality_tab,
        ___RL_DM_Fail_Ind_iE_Extensions__item__criticality,
        ____RL_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab,
        ___RL_DM_Fail_Ind_iE_Extensions__item__extensionValue,
        __RL_DM_Fail_Ind_iE_Extensions__item_,
        _RL_DM_Fail_Ind_iE_Extensions,
        RL_DM_Fail_Ind,
        RLItem_DM_Fail_Ind_ExtIEs,
        _RL_Set_DM_Fail_Ind_rL_Set_unsuccessful_InformationRespList_DM_Fail_Ind,
        ____RL_Set_DM_Fail_Ind_iE_Extensions__item__id_tab,
        ___RL_Set_DM_Fail_Ind_iE_Extensions__item__id,
        ____RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality_tab,
        ___RL_Set_DM_Fail_Ind_iE_Extensions__item__criticality,
        ____RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_DM_Fail_Ind_iE_Extensions__item__extensionValue,
        __RL_Set_DM_Fail_Ind_iE_Extensions__item_,
        _RL_Set_DM_Fail_Ind_iE_Extensions,
        RL_Set_DM_Fail_Ind,
        RL_SetItem_DM_Fail_Ind_ExtIEs,
        ___RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab,
        ____RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab_val_Value_0,
        __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id,
        __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality,
        __RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value,
        _RL_Unsuccessful_InformationRespList_DM_Fail_Ind__item_,
        RL_Unsuccessful_InformationRespList_DM_Fail_Ind,
        RL_Unsuccessful_InformationResp_DM_Fail_Ind_IEs,
        _RL_Unsuccessful_InformationResp_DM_Fail_Ind_IEs_val_Value_0,
        _RL_Unsuccessful_InformationItem_DM_Fail_Ind_rL_ID,
        _RL_Unsuccessful_InformationItem_DM_Fail_Ind_individualcause,
        ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab,
        ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id,
        ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab,
        ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality,
        ____RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab,
        ___RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue,
        __RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_,
        _RL_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions,
        RL_Unsuccessful_InformationItem_DM_Fail_Ind,
        RL_Unsuccessful_InformationItem_DM_Fail_Ind_ExtIEs,
        ___RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab,
        ____RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id_tab_val_Value_0,
        __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__id,
        __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__criticality,
        __RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item__value,
        _RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind__item_,
        RL_Set_Unsuccessful_InformationRespList_DM_Fail_Ind,
        RL_Set_Unsuccessful_InformationResp_DM_Fail_Ind_IEs,
        _RL_Set_Unsuccessful_InformationResp_DM_Fail_Ind_IEs_val_Value_0,
        _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_rL_Set_ID,
        _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_individualcause,
        ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id_tab,
        ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__id,
        ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality_tab,
        ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__criticality,
        ____RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue_tab,
        ___RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item__extensionValue,
        __RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions__item_,
        _RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind_iE_Extensions,
        RL_Set_Unsuccessful_InformationItem_DM_Fail_Ind,
        RL_Set_Unsuccessful_InformationItem_DM_Fail_Indns_ExtIEs,
        ____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab,
        _____CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__id,
        ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__criticality,
        ___CommonTransportChannelResourcesReleaseRequest_protocolIEs__item__value,
        __CommonTransportChannelResourcesReleaseRequest_protocolIEs__item_,
        _CommonTransportChannelResourcesReleaseRequest_protocolIEs,
        ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id_tab,
        ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__id,
        ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality_tab,
        ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__criticality,
        ____CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item__extensionValue,
        __CommonTransportChannelResourcesReleaseRequest_protocolExtensions__item_,
        _CommonTransportChannelResourcesReleaseRequest_protocolExtensions,
        CommonTransportChannelResourcesReleaseRequest,
        CommonTransportChannelResourcesReleaseRequest_IEs,
        _CommonTransportChannelResourcesReleaseRequest_IEs_val_Value_0,
        CommonTransportChannelResourcesReleaseRequest_Extensions,
        ____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab,
        _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_2,
        _____CommonTransportChannelResourcesRequest_protocolIEs__item__id_tab_val_Value_3,
        ___CommonTransportChannelResourcesRequest_protocolIEs__item__id,
        ___CommonTransportChannelResourcesRequest_protocolIEs__item__criticality,
        ___CommonTransportChannelResourcesRequest_protocolIEs__item__value,
        __CommonTransportChannelResourcesRequest_protocolIEs__item_,
        _CommonTransportChannelResourcesRequest_protocolIEs,
        ____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_6,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_7,
        _____CommonTransportChannelResourcesRequest_protocolExtensions__item__id_tab_val_Extension_8,
        ___CommonTransportChannelResourcesRequest_protocolExtensions__item__id,
        ___CommonTransportChannelResourcesRequest_protocolExtensions__item__criticality,
        ___CommonTransportChannelResourcesRequest_protocolExtensions__item__extensionValue,
        __CommonTransportChannelResourcesRequest_protocolExtensions__item_,
        _CommonTransportChannelResourcesRequest_protocolExtensions,
        CommonTransportChannelResourcesRequest,
        CommonTransportChannelResourcesRequest_IEs,
        _CommonTransportChannelResourcesRequest_IEs_val_Value_0,
        _CommonTransportChannelResourcesRequest_IEs_val_Value_1,
        _CommonTransportChannelResourcesRequest_IEs_val_Value_2,
        _CommonTransportChannelResourcesRequest_IEs_val_Value_3,
        CommonTransportChannelResourcesRequest_Extensions,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_0,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_1,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_2,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_3,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_4,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_5,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_6,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_7,
        _CommonTransportChannelResourcesRequest_Extensions_val_Extension_8,
        ____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab,
        _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_2,
        _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_3,
        _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_4,
        _____CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id_tab_val_Value_5,
        ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__id,
        ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__criticality,
        ___CommonTransportChannelResourcesResponseFDD_protocolIEs__item__value,
        __CommonTransportChannelResourcesResponseFDD_protocolIEs__item_,
        _CommonTransportChannelResourcesResponseFDD_protocolIEs,
        ____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab,
        _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id_tab_val_Extension_5,
        ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__id,
        ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__criticality,
        ___CommonTransportChannelResourcesResponseFDD_protocolExtensions__item__extensionValue,
        __CommonTransportChannelResourcesResponseFDD_protocolExtensions__item_,
        _CommonTransportChannelResourcesResponseFDD_protocolExtensions,
        CommonTransportChannelResourcesResponseFDD,
        CommonTransportChannelResourcesResponseFDD_IEs,
        _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_0,
        _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_1,
        _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_2,
        _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_3,
        _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_4,
        _CommonTransportChannelResourcesResponseFDD_IEs_val_Value_5,
        _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_fACH_FlowControlInformation,
        ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id_tab,
        ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__id,
        ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality_tab,
        ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__criticality,
        ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue_tab,
        ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item__extensionValue,
        __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions__item_,
        _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_iE_Extensions,
        FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD,
        FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspFDD_ExtIEs,
        __FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab,
        ___FACH_FlowControlInformation_CTCH_ResourceRspFDD_id_tab_val_Value_0,
        _FACH_FlowControlInformation_CTCH_ResourceRspFDD_id,
        _FACH_FlowControlInformation_CTCH_ResourceRspFDD_criticality,
        _FACH_FlowControlInformation_CTCH_ResourceRspFDD_value,
        FACH_FlowControlInformation_CTCH_ResourceRspFDD,
        FACH_FlowControlInformationIEs_CTCH_ResourceRspFDD,
        _FACH_FlowControlInformationIEs_CTCH_ResourceRspFDD_val_Value_0,
        CommonTransportChannelResourcesResponseFDD_Extensions,
        _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_0,
        _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_1,
        _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_2,
        _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_3,
        _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_4,
        _CommonTransportChannelResourcesResponseFDD_Extensions_val_Extension_5,
        ____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab,
        _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_2,
        _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_3,
        _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_4,
        _____CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id_tab_val_Value_5,
        ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__id,
        ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__criticality,
        ___CommonTransportChannelResourcesResponseTDD_protocolIEs__item__value,
        __CommonTransportChannelResourcesResponseTDD_protocolIEs__item_,
        _CommonTransportChannelResourcesResponseTDD_protocolIEs,
        ____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab,
        _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id_tab_val_Extension_4,
        ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__id,
        ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__criticality,
        ___CommonTransportChannelResourcesResponseTDD_protocolExtensions__item__extensionValue,
        __CommonTransportChannelResourcesResponseTDD_protocolExtensions__item_,
        _CommonTransportChannelResourcesResponseTDD_protocolExtensions,
        CommonTransportChannelResourcesResponseTDD,
        CommonTransportChannelResourcesResponseTDD_IEs,
        _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_0,
        _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_1,
        _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_2,
        _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_3,
        _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_4,
        _CommonTransportChannelResourcesResponseTDD_IEs_val_Value_5,
        _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_fACH_FlowControlInformation,
        ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id_tab,
        ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__id,
        ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality_tab,
        ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__criticality,
        ____FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue_tab,
        ___FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item__extensionValue,
        __FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions__item_,
        _FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_iE_Extensions,
        FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD,
        FACH_InfoForUESelectedS_CCPCH_CTCH_ResourceRspTDD_ExtIEs,
        __FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab,
        ___FACH_FlowControlInformation_CTCH_ResourceRspTDD_id_tab_val_Value_0,
        _FACH_FlowControlInformation_CTCH_ResourceRspTDD_id,
        _FACH_FlowControlInformation_CTCH_ResourceRspTDD_criticality,
        _FACH_FlowControlInformation_CTCH_ResourceRspTDD_value,
        FACH_FlowControlInformation_CTCH_ResourceRspTDD,
        FACH_FlowControlInformationIEs_CTCH_ResourceRspTDD,
        _FACH_FlowControlInformationIEs_CTCH_ResourceRspTDD_val_Value_0,
        CommonTransportChannelResourcesResponseTDD_Extensions,
        _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_0,
        _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_1,
        _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_2,
        _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_3,
        _CommonTransportChannelResourcesResponseTDD_Extensions_val_Extension_4,
        ____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab,
        _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_1,
        _____CommonTransportChannelResourcesFailure_protocolIEs__item__id_tab_val_Value_2,
        ___CommonTransportChannelResourcesFailure_protocolIEs__item__id,
        ___CommonTransportChannelResourcesFailure_protocolIEs__item__criticality,
        ___CommonTransportChannelResourcesFailure_protocolIEs__item__value,
        __CommonTransportChannelResourcesFailure_protocolIEs__item_,
        _CommonTransportChannelResourcesFailure_protocolIEs,
        ____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab,
        _____CommonTransportChannelResourcesFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___CommonTransportChannelResourcesFailure_protocolExtensions__item__id,
        ___CommonTransportChannelResourcesFailure_protocolExtensions__item__criticality,
        ___CommonTransportChannelResourcesFailure_protocolExtensions__item__extensionValue,
        __CommonTransportChannelResourcesFailure_protocolExtensions__item_,
        _CommonTransportChannelResourcesFailure_protocolExtensions,
        CommonTransportChannelResourcesFailure,
        CommonTransportChannelResourcesFailure_IEs,
        _CommonTransportChannelResourcesFailure_IEs_val_Value_0,
        _CommonTransportChannelResourcesFailure_IEs_val_Value_1,
        _CommonTransportChannelResourcesFailure_IEs_val_Value_2,
        CommonTransportChannelResourcesFailure_Extensions,
        _CommonTransportChannelResourcesFailure_Extensions_val_Extension_0,
        ____CompressedModeCommand_protocolIEs__item__id_tab,
        _____CompressedModeCommand_protocolIEs__item__id_tab_val_Value_0,
        ___CompressedModeCommand_protocolIEs__item__id,
        ___CompressedModeCommand_protocolIEs__item__criticality,
        ___CompressedModeCommand_protocolIEs__item__value,
        __CompressedModeCommand_protocolIEs__item_,
        _CompressedModeCommand_protocolIEs,
        ____CompressedModeCommand_protocolExtensions__item__id_tab,
        ___CompressedModeCommand_protocolExtensions__item__id,
        ____CompressedModeCommand_protocolExtensions__item__criticality_tab,
        ___CompressedModeCommand_protocolExtensions__item__criticality,
        ____CompressedModeCommand_protocolExtensions__item__extensionValue_tab,
        ___CompressedModeCommand_protocolExtensions__item__extensionValue,
        __CompressedModeCommand_protocolExtensions__item_,
        _CompressedModeCommand_protocolExtensions,
        CompressedModeCommand,
        CompressedModeCommand_IEs,
        _CompressedModeCommand_IEs_val_Value_0,
        CompressedModeCommand_Extensions,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_2,
        ___ErrorIndication_protocolExtensions__item__id,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndication_IEs,
        _ErrorIndication_IEs_val_Value_0,
        _ErrorIndication_IEs_val_Value_1,
        ErrorIndication_Extensions,
        _ErrorIndication_Extensions_val_Extension_0,
        _ErrorIndication_Extensions_val_Extension_1,
        _ErrorIndication_Extensions_val_Extension_2,
        ____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____CommonMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7,
        ___CommonMeasurementInitiationRequest_protocolIEs__item__id,
        ___CommonMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___CommonMeasurementInitiationRequest_protocolIEs__item__value,
        __CommonMeasurementInitiationRequest_protocolIEs__item_,
        _CommonMeasurementInitiationRequest_protocolIEs,
        ____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        ___CommonMeasurementInitiationRequest_protocolExtensions__item__id,
        ___CommonMeasurementInitiationRequest_protocolExtensions__item__criticality,
        ___CommonMeasurementInitiationRequest_protocolExtensions__item__extensionValue,
        __CommonMeasurementInitiationRequest_protocolExtensions__item_,
        _CommonMeasurementInitiationRequest_protocolExtensions,
        CommonMeasurementInitiationRequest,
        CommonMeasurementInitiationRequest_IEs,
        _CommonMeasurementInitiationRequest_IEs_val_Value_0,
        _CommonMeasurementInitiationRequest_IEs_val_Value_1,
        _CommonMeasurementInitiationRequest_IEs_val_Value_2,
        _CommonMeasurementInitiationRequest_IEs_val_Value_3,
        _CommonMeasurementInitiationRequest_IEs_val_Value_4,
        _CommonMeasurementInitiationRequest_IEs_val_Value_5,
        _CommonMeasurementInitiationRequest_IEs_val_Value_6,
        _CommonMeasurementInitiationRequest_IEs_val_Value_7,
        CommonMeasurementInitiationRequest_Extensions,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_0,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_1,
        _CommonMeasurementInitiationRequest_Extensions_val_Extension_2,
        _CommonMeasurementObjectType_CM_Rqst_cell,
        _CommonMeasurementObjectType_CM_Rqst_additional_CommonMeasurementObjectType_CM_Rqst,
        CommonMeasurementObjectType_CM_Rqst,
        _Cell_CM_Rqst_uC_ID,
        _Cell_CM_Rqst_timeSlot,
        _Cell_CM_Rqst_timeSlotLCR,
        _Cell_CM_Rqst_neighbouringCellMeasurementInformation,
        ____Cell_CM_Rqst_iE_Extensions__item__id_tab,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_0,
        _____Cell_CM_Rqst_iE_Extensions__item__id_tab_val_Extension_1,
        ___Cell_CM_Rqst_iE_Extensions__item__id,
        ___Cell_CM_Rqst_iE_Extensions__item__criticality,
        ___Cell_CM_Rqst_iE_Extensions__item__extensionValue,
        __Cell_CM_Rqst_iE_Extensions__item_,
        _Cell_CM_Rqst_iE_Extensions,
        Cell_CM_Rqst,
        __NeighbouringCellMeasurementInfo__item__neighbouringFDDCellMeasurementInformation,
        __NeighbouringCellMeasurementInfo__item__neighbouringTDDCellMeasurementInformation,
        __NeighbouringCellMeasurementInfo__item__extension_neighbouringCellMeasurementInformation,
        __NeighbouringCellMeasurementInfo__item__extension_neighbouringCellMeasurementInformation768,
        _NeighbouringCellMeasurementInfo__item_,
        NeighbouringCellMeasurementInfo,
        __Extension_neighbouringCellMeasurementInformation_id_tab,
        ___Extension_neighbouringCellMeasurementInformation_id_tab_val_Value_0,
        _Extension_neighbouringCellMeasurementInformation_id,
        _Extension_neighbouringCellMeasurementInformation_criticality,
        _Extension_neighbouringCellMeasurementInformation_value,
        Extension_neighbouringCellMeasurementInformation,
        Extension_neighbouringCellMeasurementInformationIE,
        _Extension_neighbouringCellMeasurementInformationIE_val_Value_0,
        __Extension_neighbouringCellMeasurementInformation768_id_tab,
        ___Extension_neighbouringCellMeasurementInformation768_id_tab_val_Value_0,
        _Extension_neighbouringCellMeasurementInformation768_id,
        _Extension_neighbouringCellMeasurementInformation768_criticality,
        _Extension_neighbouringCellMeasurementInformation768_value,
        Extension_neighbouringCellMeasurementInformation768,
        Extension_neighbouringCellMeasurementInformation768IE,
        _Extension_neighbouringCellMeasurementInformation768IE_val_Value_0,
        CellItem_CM_Rqst_ExtIEs,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_0,
        _CellItem_CM_Rqst_ExtIEs_val_Extension_1,
        __Additional_CommonMeasurementObjectType_CM_Rqst_id_tab,
        ___Additional_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0,
        _Additional_CommonMeasurementObjectType_CM_Rqst_id,
        _Additional_CommonMeasurementObjectType_CM_Rqst_criticality,
        _Additional_CommonMeasurementObjectType_CM_Rqst_value,
        Additional_CommonMeasurementObjectType_CM_Rqst,
        Additional_CommonMeasurementObjectType_CM_RqstIE,
        _Additional_CommonMeasurementObjectType_CM_RqstIE_val_Value_0,
        _GSM_Cell_CM_Rqst_cGI,
        ____GSM_Cell_CM_Rqst_iE_Extensions__item__id_tab,
        ___GSM_Cell_CM_Rqst_iE_Extensions__item__id,
        ____GSM_Cell_CM_Rqst_iE_Extensions__item__criticality_tab,
        ___GSM_Cell_CM_Rqst_iE_Extensions__item__criticality,
        ____GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___GSM_Cell_CM_Rqst_iE_Extensions__item__extensionValue,
        __GSM_Cell_CM_Rqst_iE_Extensions__item_,
        _GSM_Cell_CM_Rqst_iE_Extensions,
        GSM_Cell_CM_Rqst,
        GSMCell_CM_Rqst_ExtIEs,
        __Extension_CommonMeasurementObjectType_CM_Rqst_id_tab,
        ___Extension_CommonMeasurementObjectType_CM_Rqst_id_tab_val_Value_0,
        _Extension_CommonMeasurementObjectType_CM_Rqst_id,
        _Extension_CommonMeasurementObjectType_CM_Rqst_criticality,
        _Extension_CommonMeasurementObjectType_CM_Rqst_value,
        Extension_CommonMeasurementObjectType_CM_Rqst,
        Extension_CommonMeasurementObjectType_CM_RqstIE,
        _Extension_CommonMeasurementObjectType_CM_RqstIE_val_Value_0,
        _GsmCellList_CM_Rqst__item_,
        GsmCellList_CM_Rqst,
        _GsmCellItem_CM_Rqst_measurementID,
        _GsmCellItem_CM_Rqst_gsmCell,
        ____GsmCellItem_CM_Rqst_iE_Extensions__item__id_tab,
        ___GsmCellItem_CM_Rqst_iE_Extensions__item__id,
        ____GsmCellItem_CM_Rqst_iE_Extensions__item__criticality_tab,
        ___GsmCellItem_CM_Rqst_iE_Extensions__item__criticality,
        ____GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue_tab,
        ___GsmCellItem_CM_Rqst_iE_Extensions__item__extensionValue,
        __GsmCellItem_CM_Rqst_iE_Extensions__item_,
        _GsmCellItem_CM_Rqst_iE_Extensions,
        GsmCellItem_CM_Rqst,
        GsmCellItem_CM_Rqst_ExtIEs,
        ____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____CommonMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___CommonMeasurementInitiationResponse_protocolIEs__item__id,
        ___CommonMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___CommonMeasurementInitiationResponse_protocolIEs__item__value,
        __CommonMeasurementInitiationResponse_protocolIEs__item_,
        _CommonMeasurementInitiationResponse_protocolIEs,
        ____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab,
        _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonMeasurementInitiationResponse_protocolExtensions__item__id_tab_val_Extension_1,
        ___CommonMeasurementInitiationResponse_protocolExtensions__item__id,
        ___CommonMeasurementInitiationResponse_protocolExtensions__item__criticality,
        ___CommonMeasurementInitiationResponse_protocolExtensions__item__extensionValue,
        __CommonMeasurementInitiationResponse_protocolExtensions__item_,
        _CommonMeasurementInitiationResponse_protocolExtensions,
        CommonMeasurementInitiationResponse,
        CommonMeasurementInitiationResponse_IEs,
        _CommonMeasurementInitiationResponse_IEs_val_Value_0,
        _CommonMeasurementInitiationResponse_IEs_val_Value_1,
        _CommonMeasurementInitiationResponse_IEs_val_Value_2,
        _CommonMeasurementInitiationResponse_IEs_val_Value_3,
        _CommonMeasurementInitiationResponse_IEs_val_Value_4,
        CommonMeasurementInitiationResponse_Extensions,
        _CommonMeasurementInitiationResponse_Extensions_val_Extension_0,
        _CommonMeasurementInitiationResponse_Extensions_val_Extension_1,
        _CommonMeasurementObjectType_CM_Rsp_cell,
        CommonMeasurementObjectType_CM_Rsp,
        _Cell_CM_Rsp_commonMeasurementValue,
        ____Cell_CM_Rsp_iE_Extensions__item__id_tab,
        ___Cell_CM_Rsp_iE_Extensions__item__id,
        ____Cell_CM_Rsp_iE_Extensions__item__criticality_tab,
        ___Cell_CM_Rsp_iE_Extensions__item__criticality,
        ____Cell_CM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Cell_CM_Rsp_iE_Extensions__item__extensionValue,
        __Cell_CM_Rsp_iE_Extensions__item_,
        _Cell_CM_Rsp_iE_Extensions,
        Cell_CM_Rsp,
        CellItem_CM_Rsp_ExtIEs,
        __Extension_CommonMeasurementObjectType_CM_Rsp_id_tab,
        ___Extension_CommonMeasurementObjectType_CM_Rsp_id_tab_val_Value_0,
        _Extension_CommonMeasurementObjectType_CM_Rsp_id,
        _Extension_CommonMeasurementObjectType_CM_Rsp_criticality,
        _Extension_CommonMeasurementObjectType_CM_Rsp_value,
        Extension_CommonMeasurementObjectType_CM_Rsp,
        Extension_CommonMeasurementObjectType_CM_RspIE,
        _Extension_CommonMeasurementObjectType_CM_RspIE_val_Value_0,
        _GsmCellList_CM_Rsp__item_,
        GsmCellList_CM_Rsp,
        _GsmCellItem_CM_Rsp_measurementID,
        _GsmCellItem_CM_Rsp_commonMeasurementValue,
        ____GsmCellItem_CM_Rsp_iE_Extensions__item__id_tab,
        ___GsmCellItem_CM_Rsp_iE_Extensions__item__id,
        ____GsmCellItem_CM_Rsp_iE_Extensions__item__criticality_tab,
        ___GsmCellItem_CM_Rsp_iE_Extensions__item__criticality,
        ____GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue_tab,
        ___GsmCellItem_CM_Rsp_iE_Extensions__item__extensionValue,
        __GsmCellItem_CM_Rsp_iE_Extensions__item_,
        _GsmCellItem_CM_Rsp_iE_Extensions,
        GsmCellItem_CM_Rsp,
        GsmCellItem_CM_Rsp_ExtIEs,
        ____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___CommonMeasurementInitiationFailure_protocolIEs__item__id,
        ___CommonMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___CommonMeasurementInitiationFailure_protocolIEs__item__value,
        __CommonMeasurementInitiationFailure_protocolIEs__item_,
        _CommonMeasurementInitiationFailure_protocolIEs,
        ____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab,
        _____CommonMeasurementInitiationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___CommonMeasurementInitiationFailure_protocolExtensions__item__id,
        ___CommonMeasurementInitiationFailure_protocolExtensions__item__criticality,
        ___CommonMeasurementInitiationFailure_protocolExtensions__item__extensionValue,
        __CommonMeasurementInitiationFailure_protocolExtensions__item_,
        _CommonMeasurementInitiationFailure_protocolExtensions,
        CommonMeasurementInitiationFailure,
        CommonMeasurementInitiationFailure_IEs,
        _CommonMeasurementInitiationFailure_IEs_val_Value_0,
        _CommonMeasurementInitiationFailure_IEs_val_Value_1,
        _CommonMeasurementInitiationFailure_IEs_val_Value_2,
        CommonMeasurementInitiationFailure_Extensions,
        _CommonMeasurementInitiationFailure_Extensions_val_Extension_0,
        _Extension_FailureMeasurementList__item_,
        Extension_FailureMeasurementList,
        _Extension_FailureMeasurementItem_measurementID,
        _Extension_FailureMeasurementItem_cause,
        ____Extension_FailureMeasurementItem_iE_Extensions__item__id_tab,
        ___Extension_FailureMeasurementItem_iE_Extensions__item__id,
        ____Extension_FailureMeasurementItem_iE_Extensions__item__criticality_tab,
        ___Extension_FailureMeasurementItem_iE_Extensions__item__criticality,
        ____Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue_tab,
        ___Extension_FailureMeasurementItem_iE_Extensions__item__extensionValue,
        __Extension_FailureMeasurementItem_iE_Extensions__item_,
        _Extension_FailureMeasurementItem_iE_Extensions,
        Extension_FailureMeasurementItem,
        Extension_FailureMeasurementItem_ExtIEs,
        ____CommonMeasurementReport_protocolIEs__item__id_tab,
        _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        _____CommonMeasurementReport_protocolIEs__item__id_tab_val_Value_2,
        ___CommonMeasurementReport_protocolIEs__item__id,
        ___CommonMeasurementReport_protocolIEs__item__criticality,
        ___CommonMeasurementReport_protocolIEs__item__value,
        __CommonMeasurementReport_protocolIEs__item_,
        _CommonMeasurementReport_protocolIEs,
        ____CommonMeasurementReport_protocolExtensions__item__id_tab,
        _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonMeasurementReport_protocolExtensions__item__id_tab_val_Extension_1,
        ___CommonMeasurementReport_protocolExtensions__item__id,
        ___CommonMeasurementReport_protocolExtensions__item__criticality,
        ___CommonMeasurementReport_protocolExtensions__item__extensionValue,
        __CommonMeasurementReport_protocolExtensions__item_,
        _CommonMeasurementReport_protocolExtensions,
        CommonMeasurementReport,
        CommonMeasurementReport_IEs,
        _CommonMeasurementReport_IEs_val_Value_0,
        _CommonMeasurementReport_IEs_val_Value_1,
        _CommonMeasurementReport_IEs_val_Value_2,
        CommonMeasurementReport_Extensions,
        _CommonMeasurementReport_Extensions_val_Extension_0,
        _CommonMeasurementReport_Extensions_val_Extension_1,
        _CommonMeasurementObjectType_CM_Rprt_cell,
        CommonMeasurementObjectType_CM_Rprt,
        _Cell_CM_Rprt_commonMeasurementValueInformation,
        ____Cell_CM_Rprt_iE_Extensions__item__id_tab,
        ___Cell_CM_Rprt_iE_Extensions__item__id,
        ____Cell_CM_Rprt_iE_Extensions__item__criticality_tab,
        ___Cell_CM_Rprt_iE_Extensions__item__criticality,
        ____Cell_CM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___Cell_CM_Rprt_iE_Extensions__item__extensionValue,
        __Cell_CM_Rprt_iE_Extensions__item_,
        _Cell_CM_Rprt_iE_Extensions,
        Cell_CM_Rprt,
        CellItem_CM_Rprt_ExtIEs,
        __Extension_CommonMeasurementObjectType_CM_Rprt_id_tab,
        ___Extension_CommonMeasurementObjectType_CM_Rprt_id_tab_val_Value_0,
        _Extension_CommonMeasurementObjectType_CM_Rprt_id,
        _Extension_CommonMeasurementObjectType_CM_Rprt_criticality,
        _Extension_CommonMeasurementObjectType_CM_Rprt_value,
        Extension_CommonMeasurementObjectType_CM_Rprt,
        Extension_CommonMeasurementObjectType_CM_RprtIE,
        _Extension_CommonMeasurementObjectType_CM_RprtIE_val_Value_0,
        _GsmCellList_CM_Rprt__item_,
        GsmCellList_CM_Rprt,
        _GsmCellItem_CM_Rprt_measurementID,
        _GsmCellItem_CM_Rprt_commonMeasurementValueInformation,
        ____GsmCellItem_CM_Rprt_iE_Extensions__item__id_tab,
        ___GsmCellItem_CM_Rprt_iE_Extensions__item__id,
        ____GsmCellItem_CM_Rprt_iE_Extensions__item__criticality_tab,
        ___GsmCellItem_CM_Rprt_iE_Extensions__item__criticality,
        ____GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue_tab,
        ___GsmCellItem_CM_Rprt_iE_Extensions__item__extensionValue,
        __GsmCellItem_CM_Rprt_iE_Extensions__item_,
        _GsmCellItem_CM_Rprt_iE_Extensions,
        GsmCellItem_CM_Rprt,
        GsmCellItem_CM_Rprt_ExtIEs,
        ____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab,
        _____CommonMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___CommonMeasurementTerminationRequest_protocolIEs__item__id,
        ___CommonMeasurementTerminationRequest_protocolIEs__item__criticality,
        ___CommonMeasurementTerminationRequest_protocolIEs__item__value,
        __CommonMeasurementTerminationRequest_protocolIEs__item_,
        _CommonMeasurementTerminationRequest_protocolIEs,
        ____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab,
        _____CommonMeasurementTerminationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___CommonMeasurementTerminationRequest_protocolExtensions__item__id,
        ___CommonMeasurementTerminationRequest_protocolExtensions__item__criticality,
        ___CommonMeasurementTerminationRequest_protocolExtensions__item__extensionValue,
        __CommonMeasurementTerminationRequest_protocolExtensions__item_,
        _CommonMeasurementTerminationRequest_protocolExtensions,
        CommonMeasurementTerminationRequest,
        CommonMeasurementTerminationRequest_IEs,
        _CommonMeasurementTerminationRequest_IEs_val_Value_0,
        CommonMeasurementTerminationRequest_Extensions,
        _CommonMeasurementTerminationRequest_Extensions_val_Extension_0,
        _Extension_TerminationMeasurementList__item_,
        Extension_TerminationMeasurementList,
        _Extension_TerminationMeasurementItem_measurementID,
        ____Extension_TerminationMeasurementItem_iE_Extensions__item__id_tab,
        ___Extension_TerminationMeasurementItem_iE_Extensions__item__id,
        ____Extension_TerminationMeasurementItem_iE_Extensions__item__criticality_tab,
        ___Extension_TerminationMeasurementItem_iE_Extensions__item__criticality,
        ____Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue_tab,
        ___Extension_TerminationMeasurementItem_iE_Extensions__item__extensionValue,
        __Extension_TerminationMeasurementItem_iE_Extensions__item_,
        _Extension_TerminationMeasurementItem_iE_Extensions,
        Extension_TerminationMeasurementItem,
        Extension_TerminationMeasurementItem_ExtIEs,
        ____CommonMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____CommonMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___CommonMeasurementFailureIndication_protocolIEs__item__id,
        ___CommonMeasurementFailureIndication_protocolIEs__item__criticality,
        ___CommonMeasurementFailureIndication_protocolIEs__item__value,
        __CommonMeasurementFailureIndication_protocolIEs__item_,
        _CommonMeasurementFailureIndication_protocolIEs,
        ____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab,
        _____CommonMeasurementFailureIndication_protocolExtensions__item__id_tab_val_Extension_0,
        ___CommonMeasurementFailureIndication_protocolExtensions__item__id,
        ___CommonMeasurementFailureIndication_protocolExtensions__item__criticality,
        ___CommonMeasurementFailureIndication_protocolExtensions__item__extensionValue,
        __CommonMeasurementFailureIndication_protocolExtensions__item_,
        _CommonMeasurementFailureIndication_protocolExtensions,
        CommonMeasurementFailureIndication,
        CommonMeasurementFailureIndication_IEs,
        _CommonMeasurementFailureIndication_IEs_val_Value_0,
        _CommonMeasurementFailureIndication_IEs_val_Value_1,
        CommonMeasurementFailureIndication_Extensions,
        _CommonMeasurementFailureIndication_Extensions_val_Extension_0,
        _Extension_FailureIndicationMeasurementList__item_,
        Extension_FailureIndicationMeasurementList,
        _Extension_FailureIndicationMeasurementItem_measurementID,
        _Extension_FailureIndicationMeasurementItem_cause,
        ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id_tab,
        ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__id,
        ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality_tab,
        ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__criticality,
        ____Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue_tab,
        ___Extension_FailureIndicationMeasurementItem_iE_Extensions__item__extensionValue,
        __Extension_FailureIndicationMeasurementItem_iE_Extensions__item_,
        _Extension_FailureIndicationMeasurementItem_iE_Extensions,
        Extension_FailureIndicationMeasurementItem,
        Extension_FailureIndicationMeasurementItem_ExtIEs,
        ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        ___InformationExchangeInitiationRequest_protocolIEs__item__id,
        ___InformationExchangeInitiationRequest_protocolIEs__item__criticality,
        ___InformationExchangeInitiationRequest_protocolIEs__item__value,
        __InformationExchangeInitiationRequest_protocolIEs__item_,
        _InformationExchangeInitiationRequest_protocolIEs,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__id,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationRequest_protocolExtensions__item_,
        _InformationExchangeInitiationRequest_protocolExtensions,
        InformationExchangeInitiationRequest,
        InformationExchangeInitiationRequest_IEs,
        _InformationExchangeInitiationRequest_IEs_val_Value_0,
        _InformationExchangeInitiationRequest_IEs_val_Value_1,
        _InformationExchangeInitiationRequest_IEs_val_Value_2,
        _InformationExchangeInitiationRequest_IEs_val_Value_3,
        InformationExchangeInitiationRequest_Extensions,
        _InformationExchangeObjectType_InfEx_Rqst_cell,
        _InformationExchangeObjectType_InfEx_Rqst_extension_InformationExchangeObjectType_InfEx_Rqst,
        InformationExchangeObjectType_InfEx_Rqst,
        _Cell_InfEx_Rqst_c_ID,
        ____Cell_InfEx_Rqst_iE_Extensions__item__id_tab,
        ___Cell_InfEx_Rqst_iE_Extensions__item__id,
        ____Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab,
        ___Cell_InfEx_Rqst_iE_Extensions__item__criticality,
        ____Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab,
        ___Cell_InfEx_Rqst_iE_Extensions__item__extensionValue,
        __Cell_InfEx_Rqst_iE_Extensions__item_,
        _Cell_InfEx_Rqst_iE_Extensions,
        Cell_InfEx_Rqst,
        CellItem_InfEx_Rqst_ExtIEs,
        __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_0,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_1,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_2,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_3,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_4,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_5,
        _Extension_InformationExchangeObjectType_InfEx_Rqst_id,
        _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality,
        _Extension_InformationExchangeObjectType_InfEx_Rqst_value,
        Extension_InformationExchangeObjectType_InfEx_Rqst,
        Extension_InformationExchangeObjectType_InfEx_RqstIE,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_0,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_1,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_2,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_3,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_4,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_5,
        _GSM_Cell_InfEx_Rqst_cGI,
        ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__id_tab,
        ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__id,
        ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality_tab,
        ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__criticality,
        ____GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue_tab,
        ___GSM_Cell_InfEx_Rqst_iE_Extensions__item__extensionValue,
        __GSM_Cell_InfEx_Rqst_iE_Extensions__item_,
        _GSM_Cell_InfEx_Rqst_iE_Extensions,
        GSM_Cell_InfEx_Rqst,
        GSMCellItem_InfEx_Rqst_ExtIEs,
        _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst__item_,
        MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rqst,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_c_ID,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_mBMS_Bearer_Service_List_InfEx_Rqst,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__id,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__criticality,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions__item_,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_iE_Extensions,
        MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst,
        MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rqst_ExtIEs,
        _MBMS_Bearer_Service_List_InfEx_Rqst__item_,
        MBMS_Bearer_Service_List_InfEx_Rqst,
        _MBMS_Cell_InfEx_Rqst__item_,
        MBMS_Cell_InfEx_Rqst,
        _ANR_Cell_InfEx_Rqst__item_,
        ANR_Cell_InfEx_Rqst,
        _Common_E_RGCH_Cell_InfEx_Rqst__item_,
        Common_E_RGCH_Cell_InfEx_Rqst,
        ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___InformationExchangeInitiationResponse_protocolIEs__item__id,
        ___InformationExchangeInitiationResponse_protocolIEs__item__criticality,
        ___InformationExchangeInitiationResponse_protocolIEs__item__value,
        __InformationExchangeInitiationResponse_protocolIEs__item_,
        _InformationExchangeInitiationResponse_protocolIEs,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__id,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationResponse_protocolExtensions__item_,
        _InformationExchangeInitiationResponse_protocolExtensions,
        InformationExchangeInitiationResponse,
        InformationExchangeInitiationResponse_IEs,
        _InformationExchangeInitiationResponse_IEs_val_Value_0,
        _InformationExchangeInitiationResponse_IEs_val_Value_1,
        _InformationExchangeInitiationResponse_IEs_val_Value_2,
        InformationExchangeInitiationResponse_Extensions,
        _InformationExchangeObjectType_InfEx_Rsp_cell,
        _InformationExchangeObjectType_InfEx_Rsp_extension_InformationExchangeObjectType_InfEx_Rsp,
        InformationExchangeObjectType_InfEx_Rsp,
        _Cell_InfEx_Rsp_requestedDataValue,
        ____Cell_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___Cell_InfEx_Rsp_iE_Extensions__item__id,
        ____Cell_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___Cell_InfEx_Rsp_iE_Extensions__item__criticality,
        ____Cell_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Cell_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __Cell_InfEx_Rsp_iE_Extensions__item_,
        _Cell_InfEx_Rsp_iE_Extensions,
        Cell_InfEx_Rsp,
        CellItem_InfEx_Rsp_ExtIEs,
        __Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab,
        ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_0,
        ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_1,
        ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_2,
        ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_3,
        ___Extension_InformationExchangeObjectType_InfEx_Rsp_id_tab_val_Value_4,
        _Extension_InformationExchangeObjectType_InfEx_Rsp_id,
        _Extension_InformationExchangeObjectType_InfEx_Rsp_criticality,
        _Extension_InformationExchangeObjectType_InfEx_Rsp_value,
        Extension_InformationExchangeObjectType_InfEx_Rsp,
        Extension_InformationExchangeObjectType_InfEx_RspIE,
        _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_0,
        _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_1,
        _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_2,
        _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_3,
        _Extension_InformationExchangeObjectType_InfEx_RspIE_val_Value_4,
        _MBMS_Bearer_Service_List_InfEx_Rsp__item_,
        MBMS_Bearer_Service_List_InfEx_Rsp,
        _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_tmgi,
        _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_requestedDataValue,
        ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__id,
        ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__criticality,
        ____MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions__item_,
        _MBMS_Bearer_ServiceItemIEs_InfEx_Rsp_iE_Extensions,
        MBMS_Bearer_ServiceItemIEs_InfEx_Rsp,
        MBMS_Bearer_ServiceItem_InfEx_Rsp_ExtIEs,
        _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp__item_,
        MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rsp,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_c_ID,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_mBMS_Bearer_Service_List_InfEx_Rsp,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_iE_Extensions,
        MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp,
        MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rsp_ExtIEs,
        _MBMS_Cell_InfEx_Rsp__item_,
        MBMS_Cell_InfEx_Rsp,
        _MBMS_Cell_Item_InfEx_Rsp_c_ID,
        _MBMS_Cell_Item_InfEx_Rsp_requestedDataValue,
        ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__id,
        ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__criticality,
        ____MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __MBMS_Cell_Item_InfEx_Rsp_iE_Extensions__item_,
        _MBMS_Cell_Item_InfEx_Rsp_iE_Extensions,
        MBMS_Cell_Item_InfEx_Rsp,
        MBMS_Cell_Item_InfEx_Rsp_ExtIEs,
        _ANR_Cell_InfEx_Rsp__item_,
        ANR_Cell_InfEx_Rsp,
        _ANR_Cell_ItemIEs_InfEx_Rsp_c_ID,
        _ANR_Cell_ItemIEs_InfEx_Rsp_requestedDataValue,
        ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id,
        ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality,
        ____ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_,
        _ANR_Cell_ItemIEs_InfEx_Rsp_iE_Extensions,
        ANR_Cell_ItemIEs_InfEx_Rsp,
        ANR_Cell_ItemIEs_InfEx_Rsp_ExtIEs,
        _Common_E_RGCH_Cell_InfEx_Rsp__item_,
        Common_E_RGCH_Cell_InfEx_Rsp,
        _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_c_ID,
        _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_requestedDataValue,
        ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__id,
        ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__criticality,
        ____Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions__item_,
        _Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_iE_Extensions,
        Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp,
        Common_E_RGCH_Cell_ItemIEs_InfEx_Rsp_ExtIEs,
        ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___InformationExchangeInitiationFailure_protocolIEs__item__id,
        ___InformationExchangeInitiationFailure_protocolIEs__item__criticality,
        ___InformationExchangeInitiationFailure_protocolIEs__item__value,
        __InformationExchangeInitiationFailure_protocolIEs__item_,
        _InformationExchangeInitiationFailure_protocolIEs,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__id,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationFailure_protocolExtensions__item_,
        _InformationExchangeInitiationFailure_protocolExtensions,
        InformationExchangeInitiationFailure,
        InformationExchangeInitiationFailure_IEs,
        _InformationExchangeInitiationFailure_IEs_val_Value_0,
        _InformationExchangeInitiationFailure_IEs_val_Value_1,
        _InformationExchangeInitiationFailure_IEs_val_Value_2,
        InformationExchangeInitiationFailure_Extensions,
        ____InformationReport_protocolIEs__item__id_tab,
        _____InformationReport_protocolIEs__item__id_tab_val_Value_0,
        _____InformationReport_protocolIEs__item__id_tab_val_Value_1,
        ___InformationReport_protocolIEs__item__id,
        ___InformationReport_protocolIEs__item__criticality,
        ___InformationReport_protocolIEs__item__value,
        __InformationReport_protocolIEs__item_,
        _InformationReport_protocolIEs,
        ____InformationReport_protocolExtensions__item__id_tab,
        ___InformationReport_protocolExtensions__item__id,
        ____InformationReport_protocolExtensions__item__criticality_tab,
        ___InformationReport_protocolExtensions__item__criticality,
        ____InformationReport_protocolExtensions__item__extensionValue_tab,
        ___InformationReport_protocolExtensions__item__extensionValue,
        __InformationReport_protocolExtensions__item_,
        _InformationReport_protocolExtensions,
        InformationReport,
        InformationReport_IEs,
        _InformationReport_IEs_val_Value_0,
        _InformationReport_IEs_val_Value_1,
        InformationReport_Extensions,
        _InformationExchangeObjectType_InfEx_Rprt_cell,
        _InformationExchangeObjectType_InfEx_Rprt_extension_InformationExchangeObjectType_InfEx_Rprt,
        InformationExchangeObjectType_InfEx_Rprt,
        __Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab,
        ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_0,
        ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_1,
        ___Extension_InformationExchangeObjectType_InfEx_Rprt_id_tab_val_Value_2,
        _Extension_InformationExchangeObjectType_InfEx_Rprt_id,
        _Extension_InformationExchangeObjectType_InfEx_Rprt_criticality,
        _Extension_InformationExchangeObjectType_InfEx_Rprt_value,
        Extension_InformationExchangeObjectType_InfEx_Rprt,
        Extension_InformationExchangeObjectType_InfEx_RprtIE,
        _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_0,
        _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_1,
        _Extension_InformationExchangeObjectType_InfEx_RprtIE_val_Value_2,
        _Cell_InfEx_Rprt_requestedDataValueInformation,
        ____Cell_InfEx_Rprt_iE_Extensions__item__id_tab,
        ___Cell_InfEx_Rprt_iE_Extensions__item__id,
        ____Cell_InfEx_Rprt_iE_Extensions__item__criticality_tab,
        ___Cell_InfEx_Rprt_iE_Extensions__item__criticality,
        ____Cell_InfEx_Rprt_iE_Extensions__item__extensionValue_tab,
        ___Cell_InfEx_Rprt_iE_Extensions__item__extensionValue,
        __Cell_InfEx_Rprt_iE_Extensions__item_,
        _Cell_InfEx_Rprt_iE_Extensions,
        Cell_InfEx_Rprt,
        CellItem_InfEx_Rprt_ExtIEs,
        _MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt__item_,
        MBMS_Bearer_Service_in_MBMS_Cell_InfEx_Rprt,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_c_ID,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_mBMS_Bearer_Service_List_InfEx_Rprt,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality,
        ____MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_,
        _MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_iE_Extensions,
        MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt,
        MBMS_Bearer_Service_in_MBMS_Cell_Item_InfEx_Rprt_ExtIEs,
        _MBMS_Bearer_Service_List_InfEx_Rprt__item_,
        MBMS_Bearer_Service_List_InfEx_Rprt,
        _MBMS_Bearer_Service_List_Item_InfEx_Rprt_tmgi,
        _MBMS_Bearer_Service_List_Item_InfEx_Rprt_requestedDataValueInformation,
        ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id_tab,
        ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__id,
        ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab,
        ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__criticality,
        ____MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item__extensionValue,
        __MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions__item_,
        _MBMS_Bearer_Service_List_Item_InfEx_Rprt_iE_Extensions,
        MBMS_Bearer_Service_List_Item_InfEx_Rprt,
        MBMS_Bearer_Service_List_Item_InfEx_Rprt_ExtIEs,
        _MBMS_Cell_InfEx_Rprt__item_,
        MBMS_Cell_InfEx_Rprt,
        _MBMS_Cell_Item_InfEx_Rprt_c_ID,
        _MBMS_Cell_Item_InfEx_Rprt_requestedDataValueInformation,
        ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab,
        ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__id,
        ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab,
        ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality,
        ____MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab,
        ___MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue,
        __MBMS_Cell_Item_InfEx_Rprt_iE_Extensions__item_,
        _MBMS_Cell_Item_InfEx_Rprt_iE_Extensions,
        MBMS_Cell_Item_InfEx_Rprt,
        MBMS_Cell_Item_InfEx_Rprt_ExtIEs,
        _Common_E_RGCH_Cell_InfEx_Rprt__item_,
        Common_E_RGCH_Cell_InfEx_Rprt,
        _Common_E_RGCH_Cell_Item_InfEx_Rprt_c_ID,
        _Common_E_RGCH_Cell_Item_InfEx_Rprt_requestedDataValueInformation,
        ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id_tab,
        ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__id,
        ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality_tab,
        ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__criticality,
        ____Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue_tab,
        ___Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item__extensionValue,
        __Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions__item_,
        _Common_E_RGCH_Cell_Item_InfEx_Rprt_iE_Extensions,
        Common_E_RGCH_Cell_Item_InfEx_Rprt,
        Common_E_RGCH_Cell_Item_InfEx_Rprt_ExtIEs,
        ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab,
        _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___InformationExchangeTerminationRequest_protocolIEs__item__id,
        ___InformationExchangeTerminationRequest_protocolIEs__item__criticality,
        ___InformationExchangeTerminationRequest_protocolIEs__item__value,
        __InformationExchangeTerminationRequest_protocolIEs__item_,
        _InformationExchangeTerminationRequest_protocolIEs,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__id,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue,
        __InformationExchangeTerminationRequest_protocolExtensions__item_,
        _InformationExchangeTerminationRequest_protocolExtensions,
        InformationExchangeTerminationRequest,
        InformationExchangeTerminationRequest_IEs,
        _InformationExchangeTerminationRequest_IEs_val_Value_0,
        InformationExchangeTerminationRequest_Extensions,
        ____InformationExchangeFailureIndication_protocolIEs__item__id_tab,
        _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___InformationExchangeFailureIndication_protocolIEs__item__id,
        ___InformationExchangeFailureIndication_protocolIEs__item__criticality,
        ___InformationExchangeFailureIndication_protocolIEs__item__value,
        __InformationExchangeFailureIndication_protocolIEs__item_,
        _InformationExchangeFailureIndication_protocolIEs,
        ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__id,
        ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__criticality,
        ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue,
        __InformationExchangeFailureIndication_protocolExtensions__item_,
        _InformationExchangeFailureIndication_protocolExtensions,
        InformationExchangeFailureIndication,
        InformationExchangeFailureIndication_IEs,
        _InformationExchangeFailureIndication_IEs_val_Value_0,
        _InformationExchangeFailureIndication_IEs_val_Value_1,
        InformationExchangeFailureIndication_Extensions,
        ____ResetRequest_protocolIEs__item__id_tab,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_0,
        _____ResetRequest_protocolIEs__item__id_tab_val_Value_1,
        ___ResetRequest_protocolIEs__item__id,
        ___ResetRequest_protocolIEs__item__criticality,
        ___ResetRequest_protocolIEs__item__value,
        __ResetRequest_protocolIEs__item_,
        _ResetRequest_protocolIEs,
        ____ResetRequest_protocolExtensions__item__id_tab,
        _____ResetRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___ResetRequest_protocolExtensions__item__id,
        ___ResetRequest_protocolExtensions__item__criticality,
        ___ResetRequest_protocolExtensions__item__extensionValue,
        __ResetRequest_protocolExtensions__item_,
        _ResetRequest_protocolExtensions,
        ResetRequest,
        ResetRequest_IEs,
        _ResetRequest_IEs_val_Value_0,
        _ResetRequest_IEs_val_Value_1,
        ResetRequest_Extensions,
        _ResetRequest_Extensions_val_Extension_0,
        _ResetIndicator_context,
        _ResetIndicator_all_contexts,
        _ResetIndicator_contextGroup,
        ResetIndicator,
        _ContextList_Reset_contextInfoList_Reset,
        ____ContextList_Reset_iE_Extensions__item__id_tab,
        ___ContextList_Reset_iE_Extensions__item__id,
        ____ContextList_Reset_iE_Extensions__item__criticality_tab,
        ___ContextList_Reset_iE_Extensions__item__criticality,
        ____ContextList_Reset_iE_Extensions__item__extensionValue_tab,
        ___ContextList_Reset_iE_Extensions__item__extensionValue,
        __ContextList_Reset_iE_Extensions__item_,
        _ContextList_Reset_iE_Extensions,
        ContextList_Reset,
        ContextItem_Reset_ExtIEs,
        ___ContextInfoList_Reset__item__id_tab,
        ____ContextInfoList_Reset__item__id_tab_val_Value_0,
        __ContextInfoList_Reset__item__id,
        __ContextInfoList_Reset__item__criticality,
        __ContextInfoList_Reset__item__value,
        _ContextInfoList_Reset__item_,
        ContextInfoList_Reset,
        ContextInfoItemIE_Reset,
        _ContextInfoItemIE_Reset_val_Value_0,
        _ContextInfoItem_Reset_contextType_Reset,
        ____ContextInfoItem_Reset_iE_Extensions__item__id_tab,
        ___ContextInfoItem_Reset_iE_Extensions__item__id,
        ____ContextInfoItem_Reset_iE_Extensions__item__criticality_tab,
        ___ContextInfoItem_Reset_iE_Extensions__item__criticality,
        ____ContextInfoItem_Reset_iE_Extensions__item__extensionValue_tab,
        ___ContextInfoItem_Reset_iE_Extensions__item__extensionValue,
        __ContextInfoItem_Reset_iE_Extensions__item_,
        _ContextInfoItem_Reset_iE_Extensions,
        ContextInfoItem_Reset,
        ContextInfoItem_Reset_ExtIEs,
        _ContextType_Reset_sRNTI,
        _ContextType_Reset_dRNTI,
        _ContextType_Reset_extension_ContextType_Reset,
        ContextType_Reset,
        __Extension_ContextType_Reset_id_tab,
        ___Extension_ContextType_Reset_id_tab_val_Value_0,
        _Extension_ContextType_Reset_id,
        _Extension_ContextType_Reset_criticality,
        _Extension_ContextType_Reset_value,
        Extension_ContextType_Reset,
        Extension_ContextType_ResetIE,
        _Extension_ContextType_ResetIE_val_Value_0,
        _ContextGroupList_Reset_contextGroupInfoList_Reset,
        ____ContextGroupList_Reset_iE_Extensions__item__id_tab,
        ___ContextGroupList_Reset_iE_Extensions__item__id,
        ____ContextGroupList_Reset_iE_Extensions__item__criticality_tab,
        ___ContextGroupList_Reset_iE_Extensions__item__criticality,
        ____ContextGroupList_Reset_iE_Extensions__item__extensionValue_tab,
        ___ContextGroupList_Reset_iE_Extensions__item__extensionValue,
        __ContextGroupList_Reset_iE_Extensions__item_,
        _ContextGroupList_Reset_iE_Extensions,
        ContextGroupList_Reset,
        ContextGroupItem_Reset_ExtIEs,
        ___ContextGroupInfoList_Reset__item__id_tab,
        ____ContextGroupInfoList_Reset__item__id_tab_val_Value_0,
        __ContextGroupInfoList_Reset__item__id,
        __ContextGroupInfoList_Reset__item__criticality,
        __ContextGroupInfoList_Reset__item__value,
        _ContextGroupInfoList_Reset__item_,
        ContextGroupInfoList_Reset,
        ContextGroupInfoItemIE_Reset,
        _ContextGroupInfoItemIE_Reset_val_Value_0,
        _ContextGroupInfoItem_Reset_s_RNTI_Group,
        ____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab,
        _____ContextGroupInfoItem_Reset_iE_Extensions__item__id_tab_val_Extension_0,
        ___ContextGroupInfoItem_Reset_iE_Extensions__item__id,
        ___ContextGroupInfoItem_Reset_iE_Extensions__item__criticality,
        ___ContextGroupInfoItem_Reset_iE_Extensions__item__extensionValue,
        __ContextGroupInfoItem_Reset_iE_Extensions__item_,
        _ContextGroupInfoItem_Reset_iE_Extensions,
        ContextGroupInfoItem_Reset,
        ContextGroupInfoItem_Reset_ExtIEs,
        _ContextGroupInfoItem_Reset_ExtIEs_val_Extension_0,
        ____ResetResponse_protocolIEs__item__id_tab,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResponse_protocolIEs__item__id_tab_val_Value_1,
        ___ResetResponse_protocolIEs__item__id,
        ___ResetResponse_protocolIEs__item__criticality,
        ___ResetResponse_protocolIEs__item__value,
        __ResetResponse_protocolIEs__item_,
        _ResetResponse_protocolIEs,
        ____ResetResponse_protocolExtensions__item__id_tab,
        _____ResetResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___ResetResponse_protocolExtensions__item__id,
        ___ResetResponse_protocolExtensions__item__criticality,
        ___ResetResponse_protocolExtensions__item__extensionValue,
        __ResetResponse_protocolExtensions__item_,
        _ResetResponse_protocolExtensions,
        ResetResponse,
        ResetResponse_IEs,
        _ResetResponse_IEs_val_Value_0,
        _ResetResponse_IEs_val_Value_1,
        ResetResponse_Extensions,
        _ResetResponse_Extensions_val_Extension_0,
        ____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab,
        _____RadioLinkActivationCommandFDD_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkActivationCommandFDD_protocolIEs__item__id,
        ___RadioLinkActivationCommandFDD_protocolIEs__item__criticality,
        ___RadioLinkActivationCommandFDD_protocolIEs__item__value,
        __RadioLinkActivationCommandFDD_protocolIEs__item_,
        _RadioLinkActivationCommandFDD_protocolIEs,
        ____RadioLinkActivationCommandFDD_protocolExtensions__item__id_tab,
        ___RadioLinkActivationCommandFDD_protocolExtensions__item__id,
        ____RadioLinkActivationCommandFDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkActivationCommandFDD_protocolExtensions__item__criticality,
        ____RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkActivationCommandFDD_protocolExtensions__item__extensionValue,
        __RadioLinkActivationCommandFDD_protocolExtensions__item_,
        _RadioLinkActivationCommandFDD_protocolExtensions,
        RadioLinkActivationCommandFDD,
        RadioLinkActivationCommandFDD_IEs,
        _RadioLinkActivationCommandFDD_IEs_val_Value_0,
        RadioLinkActivationCommandFDD_Extensions,
        ___DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab,
        ____DelayedActivationInformationList_RL_ActivationCmdFDD__item__id_tab_val_Value_0,
        __DelayedActivationInformationList_RL_ActivationCmdFDD__item__id,
        __DelayedActivationInformationList_RL_ActivationCmdFDD__item__criticality,
        __DelayedActivationInformationList_RL_ActivationCmdFDD__item__value,
        _DelayedActivationInformationList_RL_ActivationCmdFDD__item_,
        DelayedActivationInformationList_RL_ActivationCmdFDD,
        DelayedActivationInformation_RL_ActivationCmdFDD_IEs,
        _DelayedActivationInformation_RL_ActivationCmdFDD_IEs_val_Value_0,
        _DelayedActivationInformation_RL_ActivationCmdFDD_rL_ID,
        _DelayedActivationInformation_RL_ActivationCmdFDD_delayed_activation_update,
        ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id_tab,
        ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__id,
        ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality_tab,
        ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__criticality,
        ____DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue_tab,
        ___DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item__extensionValue,
        __DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions__item_,
        _DelayedActivationInformation_RL_ActivationCmdFDD_iE_Extensions,
        DelayedActivationInformation_RL_ActivationCmdFDD,
        DelayedActivationInformation_RL_ActivationCmdFDD_ExtIEs,
        ____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab,
        _____RadioLinkActivationCommandTDD_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkActivationCommandTDD_protocolIEs__item__id,
        ___RadioLinkActivationCommandTDD_protocolIEs__item__criticality,
        ___RadioLinkActivationCommandTDD_protocolIEs__item__value,
        __RadioLinkActivationCommandTDD_protocolIEs__item_,
        _RadioLinkActivationCommandTDD_protocolIEs,
        ____RadioLinkActivationCommandTDD_protocolExtensions__item__id_tab,
        ___RadioLinkActivationCommandTDD_protocolExtensions__item__id,
        ____RadioLinkActivationCommandTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkActivationCommandTDD_protocolExtensions__item__criticality,
        ____RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkActivationCommandTDD_protocolExtensions__item__extensionValue,
        __RadioLinkActivationCommandTDD_protocolExtensions__item_,
        _RadioLinkActivationCommandTDD_protocolExtensions,
        RadioLinkActivationCommandTDD,
        RadioLinkActivationCommandTDD_IEs,
        _RadioLinkActivationCommandTDD_IEs_val_Value_0,
        RadioLinkActivationCommandTDD_Extensions,
        ___DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab,
        ____DelayedActivationInformationList_RL_ActivationCmdTDD__item__id_tab_val_Value_0,
        __DelayedActivationInformationList_RL_ActivationCmdTDD__item__id,
        __DelayedActivationInformationList_RL_ActivationCmdTDD__item__criticality,
        __DelayedActivationInformationList_RL_ActivationCmdTDD__item__value,
        _DelayedActivationInformationList_RL_ActivationCmdTDD__item_,
        DelayedActivationInformationList_RL_ActivationCmdTDD,
        DelayedActivationInformation_RL_ActivationCmdTDD_IEs,
        _DelayedActivationInformation_RL_ActivationCmdTDD_IEs_val_Value_0,
        _DelayedActivationInformation_RL_ActivationCmdTDD_rL_ID,
        _DelayedActivationInformation_RL_ActivationCmdTDD_delayed_activation_update,
        ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id_tab,
        ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__id,
        ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality_tab,
        ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__criticality,
        ____DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue_tab,
        ___DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item__extensionValue,
        __DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions__item_,
        _DelayedActivationInformation_RL_ActivationCmdTDD_iE_Extensions,
        DelayedActivationInformation_RL_ActivationCmdTDD,
        DelayedActivationInformation_RL_ActivationCmdTDD_ExtIEs,
        ____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_0,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_1,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_2,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_3,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_4,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_5,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_6,
        _____GERANUplinkSignallingTransferIndication_protocolIEs__item__id_tab_val_Value_7,
        ___GERANUplinkSignallingTransferIndication_protocolIEs__item__id,
        ___GERANUplinkSignallingTransferIndication_protocolIEs__item__criticality,
        ___GERANUplinkSignallingTransferIndication_protocolIEs__item__value,
        __GERANUplinkSignallingTransferIndication_protocolIEs__item_,
        _GERANUplinkSignallingTransferIndication_protocolIEs,
        ____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab,
        _____GERANUplinkSignallingTransferIndication_protocolExtensions__item__id_tab_val_Extension_0,
        ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__id,
        ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__criticality,
        ___GERANUplinkSignallingTransferIndication_protocolExtensions__item__extensionValue,
        __GERANUplinkSignallingTransferIndication_protocolExtensions__item_,
        _GERANUplinkSignallingTransferIndication_protocolExtensions,
        GERANUplinkSignallingTransferIndication,
        GERANUplinkSignallingTransferIndication_IEs,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_0,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_1,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_2,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_3,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_4,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_5,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_6,
        _GERANUplinkSignallingTransferIndication_IEs_val_Value_7,
        GERANUplinkSignallingTransferIndication_Extensions,
        _GERANUplinkSignallingTransferIndication_Extensions_val_Extension_0,
        ____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab,
        _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_0,
        _____RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id_tab_val_Value_1,
        ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__id,
        ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__criticality,
        ___RadioLinkParameterUpdateIndicationFDD_protocolIEs__item__value,
        __RadioLinkParameterUpdateIndicationFDD_protocolIEs__item_,
        _RadioLinkParameterUpdateIndicationFDD_protocolIEs,
        ____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_0,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_1,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_2,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_3,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_4,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_5,
        _____RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id_tab_val_Extension_6,
        ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__id,
        ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__criticality,
        ___RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item__extensionValue,
        __RadioLinkParameterUpdateIndicationFDD_protocolExtensions__item_,
        _RadioLinkParameterUpdateIndicationFDD_protocolExtensions,
        RadioLinkParameterUpdateIndicationFDD,
        RadioLinkParameterUpdateIndicationFDD_IEs,
        _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_0,
        _RadioLinkParameterUpdateIndicationFDD_IEs_val_Value_1,
        ___RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab,
        ____RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id_tab_val_Value_0,
        __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__id,
        __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__criticality,
        __RL_ParameterUpdateIndicationFDD_RL_InformationList__item__value,
        _RL_ParameterUpdateIndicationFDD_RL_InformationList__item_,
        RL_ParameterUpdateIndicationFDD_RL_InformationList,
        RL_ParameterUpdateIndicationFDD_RL_InformationList_IEs,
        _RL_ParameterUpdateIndicationFDD_RL_InformationList_IEs_val_Value_0,
        _RL_ParameterUpdateIndicationFDD_RL_Information_Item_rL_ID,
        _RL_ParameterUpdateIndicationFDD_RL_Information_Item_phase_Reference_Update_Indicator,
        ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id_tab,
        ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__id,
        ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality_tab,
        ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__criticality,
        ____RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item__extensionValue,
        __RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions__item_,
        _RL_ParameterUpdateIndicationFDD_RL_Information_Item_iE_Extensions,
        RL_ParameterUpdateIndicationFDD_RL_Information_Item,
        RL_ParameterUpdateIndicationFDD_RL_Information_ExtIEs,
        RadioLinkParameterUpdateIndicationFDD_Extensions,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_0,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_1,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_2,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_3,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_4,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_5,
        _RadioLinkParameterUpdateIndicationFDD_Extensions_val_Extension_6,
        _UE_Measurement_Forwarding_measurementID,
        _UE_Measurement_Forwarding_uE_Measurement_Value,
        ____UE_Measurement_Forwarding_iE_Extensions__item__id_tab,
        ___UE_Measurement_Forwarding_iE_Extensions__item__id,
        ____UE_Measurement_Forwarding_iE_Extensions__item__criticality_tab,
        ___UE_Measurement_Forwarding_iE_Extensions__item__criticality,
        ____UE_Measurement_Forwarding_iE_Extensions__item__extensionValue_tab,
        ___UE_Measurement_Forwarding_iE_Extensions__item__extensionValue,
        __UE_Measurement_Forwarding_iE_Extensions__item_,
        _UE_Measurement_Forwarding_iE_Extensions,
        UE_Measurement_Forwarding,
        UE_Measurement_Forwarding_ExtIEs,
        _Additional_HS_Cell_Information_RL_Param_Upd__item_,
        Additional_HS_Cell_Information_RL_Param_Upd,
        _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hSPDSCH_RL_ID,
        _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_hS_DSCH_FDD_Secondary_Serving_Update_Information,
        ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id,
        ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_,
        _Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions,
        Additional_HS_Cell_Information_RL_Param_Upd_ItemIEs,
        Additional_HS_Cell_Information_RL_Setup_ExtIEs,
        _Additional_EDCH_Cell_Information_RL_Param_Upd__item_,
        Additional_EDCH_Cell_Information_RL_Param_Upd,
        _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_additional_EDCH_FDD_Update_Information,
        ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id_tab,
        ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__id,
        ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality_tab,
        ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__criticality,
        ____Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue_tab,
        ___Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item__extensionValue,
        __Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions__item_,
        _Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs_iE_Extensions,
        Additional_EDCH_Cell_Information_RL_Param_Upd_ItemIEs,
        Additional_EDCH_FDD_Update_Information_ExtIEs,
        ____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab,
        _____RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id_tab_val_Value_0,
        ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__id,
        ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__criticality,
        ___RadioLinkParameterUpdateIndicationTDD_protocolIEs__item__value,
        __RadioLinkParameterUpdateIndicationTDD_protocolIEs__item_,
        _RadioLinkParameterUpdateIndicationTDD_protocolIEs,
        ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id_tab,
        ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__id,
        ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality_tab,
        ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__criticality,
        ____RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue_tab,
        ___RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item__extensionValue,
        __RadioLinkParameterUpdateIndicationTDD_protocolExtensions__item_,
        _RadioLinkParameterUpdateIndicationTDD_protocolExtensions,
        RadioLinkParameterUpdateIndicationTDD,
        RadioLinkParameterUpdateIndicationTDD_IEs,
        _RadioLinkParameterUpdateIndicationTDD_IEs_val_Value_0,
        RadioLinkParameterUpdateIndicationTDD_Extensions,
        ____UEMeasurementInitiationRequest_protocolIEs__item__id_tab,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____UEMeasurementInitiationRequest_protocolIEs__item__id_tab_val_Value_7,
        ___UEMeasurementInitiationRequest_protocolIEs__item__id,
        ___UEMeasurementInitiationRequest_protocolIEs__item__criticality,
        ___UEMeasurementInitiationRequest_protocolIEs__item__value,
        __UEMeasurementInitiationRequest_protocolIEs__item_,
        _UEMeasurementInitiationRequest_protocolIEs,
        ____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab,
        _____UEMeasurementInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___UEMeasurementInitiationRequest_protocolExtensions__item__id,
        ___UEMeasurementInitiationRequest_protocolExtensions__item__criticality,
        ___UEMeasurementInitiationRequest_protocolExtensions__item__extensionValue,
        __UEMeasurementInitiationRequest_protocolExtensions__item_,
        _UEMeasurementInitiationRequest_protocolExtensions,
        UEMeasurementInitiationRequest,
        UEMeasurementInitiationRequest_IEs,
        _UEMeasurementInitiationRequest_IEs_val_Value_0,
        _UEMeasurementInitiationRequest_IEs_val_Value_1,
        _UEMeasurementInitiationRequest_IEs_val_Value_2,
        _UEMeasurementInitiationRequest_IEs_val_Value_3,
        _UEMeasurementInitiationRequest_IEs_val_Value_4,
        _UEMeasurementInitiationRequest_IEs_val_Value_5,
        _UEMeasurementInitiationRequest_IEs_val_Value_6,
        _UEMeasurementInitiationRequest_IEs_val_Value_7,
        UEMeasurementInitiationRequest_Extensions,
        _UEMeasurementInitiationRequest_Extensions_val_Extension_0,
        ____UEMeasurementInitiationResponse_protocolIEs__item__id_tab,
        _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UEMeasurementInitiationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___UEMeasurementInitiationResponse_protocolIEs__item__id,
        ___UEMeasurementInitiationResponse_protocolIEs__item__criticality,
        ___UEMeasurementInitiationResponse_protocolIEs__item__value,
        __UEMeasurementInitiationResponse_protocolIEs__item_,
        _UEMeasurementInitiationResponse_protocolIEs,
        ____UEMeasurementInitiationResponse_protocolExtensions__item__id_tab,
        ___UEMeasurementInitiationResponse_protocolExtensions__item__id,
        ____UEMeasurementInitiationResponse_protocolExtensions__item__criticality_tab,
        ___UEMeasurementInitiationResponse_protocolExtensions__item__criticality,
        ____UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue_tab,
        ___UEMeasurementInitiationResponse_protocolExtensions__item__extensionValue,
        __UEMeasurementInitiationResponse_protocolExtensions__item_,
        _UEMeasurementInitiationResponse_protocolExtensions,
        UEMeasurementInitiationResponse,
        UEMeasurementInitiationResponse_IEs,
        _UEMeasurementInitiationResponse_IEs_val_Value_0,
        _UEMeasurementInitiationResponse_IEs_val_Value_1,
        _UEMeasurementInitiationResponse_IEs_val_Value_2,
        _UEMeasurementInitiationResponse_IEs_val_Value_3,
        UEMeasurementInitiationResponse_Extensions,
        ____UEMeasurementInitiationFailure_protocolIEs__item__id_tab,
        _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UEMeasurementInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___UEMeasurementInitiationFailure_protocolIEs__item__id,
        ___UEMeasurementInitiationFailure_protocolIEs__item__criticality,
        ___UEMeasurementInitiationFailure_protocolIEs__item__value,
        __UEMeasurementInitiationFailure_protocolIEs__item_,
        _UEMeasurementInitiationFailure_protocolIEs,
        ____UEMeasurementInitiationFailure_protocolExtensions__item__id_tab,
        ___UEMeasurementInitiationFailure_protocolExtensions__item__id,
        ____UEMeasurementInitiationFailure_protocolExtensions__item__criticality_tab,
        ___UEMeasurementInitiationFailure_protocolExtensions__item__criticality,
        ____UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___UEMeasurementInitiationFailure_protocolExtensions__item__extensionValue,
        __UEMeasurementInitiationFailure_protocolExtensions__item_,
        _UEMeasurementInitiationFailure_protocolExtensions,
        UEMeasurementInitiationFailure,
        UEMeasurementInitiationFailure_IEs,
        _UEMeasurementInitiationFailure_IEs_val_Value_0,
        _UEMeasurementInitiationFailure_IEs_val_Value_1,
        _UEMeasurementInitiationFailure_IEs_val_Value_2,
        UEMeasurementInitiationFailure_Extensions,
        ____UEMeasurementReport_protocolIEs__item__id_tab,
        _____UEMeasurementReport_protocolIEs__item__id_tab_val_Value_0,
        _____UEMeasurementReport_protocolIEs__item__id_tab_val_Value_1,
        ___UEMeasurementReport_protocolIEs__item__id,
        ___UEMeasurementReport_protocolIEs__item__criticality,
        ___UEMeasurementReport_protocolIEs__item__value,
        __UEMeasurementReport_protocolIEs__item_,
        _UEMeasurementReport_protocolIEs,
        ____UEMeasurementReport_protocolExtensions__item__id_tab,
        ___UEMeasurementReport_protocolExtensions__item__id,
        ____UEMeasurementReport_protocolExtensions__item__criticality_tab,
        ___UEMeasurementReport_protocolExtensions__item__criticality,
        ____UEMeasurementReport_protocolExtensions__item__extensionValue_tab,
        ___UEMeasurementReport_protocolExtensions__item__extensionValue,
        __UEMeasurementReport_protocolExtensions__item_,
        _UEMeasurementReport_protocolExtensions,
        UEMeasurementReport,
        UEMeasurementReport_IEs,
        _UEMeasurementReport_IEs_val_Value_0,
        _UEMeasurementReport_IEs_val_Value_1,
        UEMeasurementReport_Extensions,
        ____UEMeasurementTerminationRequest_protocolIEs__item__id_tab,
        _____UEMeasurementTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___UEMeasurementTerminationRequest_protocolIEs__item__id,
        ___UEMeasurementTerminationRequest_protocolIEs__item__criticality,
        ___UEMeasurementTerminationRequest_protocolIEs__item__value,
        __UEMeasurementTerminationRequest_protocolIEs__item_,
        _UEMeasurementTerminationRequest_protocolIEs,
        ____UEMeasurementTerminationRequest_protocolExtensions__item__id_tab,
        ___UEMeasurementTerminationRequest_protocolExtensions__item__id,
        ____UEMeasurementTerminationRequest_protocolExtensions__item__criticality_tab,
        ___UEMeasurementTerminationRequest_protocolExtensions__item__criticality,
        ____UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___UEMeasurementTerminationRequest_protocolExtensions__item__extensionValue,
        __UEMeasurementTerminationRequest_protocolExtensions__item_,
        _UEMeasurementTerminationRequest_protocolExtensions,
        UEMeasurementTerminationRequest,
        UEMeasurementTerminationRequest_IEs,
        _UEMeasurementTerminationRequest_IEs_val_Value_0,
        UEMeasurementTerminationRequest_Extensions,
        ____UEMeasurementFailureIndication_protocolIEs__item__id_tab,
        _____UEMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____UEMeasurementFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___UEMeasurementFailureIndication_protocolIEs__item__id,
        ___UEMeasurementFailureIndication_protocolIEs__item__criticality,
        ___UEMeasurementFailureIndication_protocolIEs__item__value,
        __UEMeasurementFailureIndication_protocolIEs__item_,
        _UEMeasurementFailureIndication_protocolIEs,
        ____UEMeasurementFailureIndication_protocolExtensions__item__id_tab,
        ___UEMeasurementFailureIndication_protocolExtensions__item__id,
        ____UEMeasurementFailureIndication_protocolExtensions__item__criticality_tab,
        ___UEMeasurementFailureIndication_protocolExtensions__item__criticality,
        ____UEMeasurementFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___UEMeasurementFailureIndication_protocolExtensions__item__extensionValue,
        __UEMeasurementFailureIndication_protocolExtensions__item_,
        _UEMeasurementFailureIndication_protocolExtensions,
        UEMeasurementFailureIndication,
        UEMeasurementFailureIndication_IEs,
        _UEMeasurementFailureIndication_IEs_val_Value_0,
        _UEMeasurementFailureIndication_IEs_val_Value_1,
        UEMeasurementFailureIndication_Extensions,
        ____IurInvokeTrace_protocolIEs__item__id_tab,
        _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_0,
        _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_1,
        _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_2,
        _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_3,
        _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_4,
        _____IurInvokeTrace_protocolIEs__item__id_tab_val_Value_5,
        ___IurInvokeTrace_protocolIEs__item__id,
        ___IurInvokeTrace_protocolIEs__item__criticality,
        ___IurInvokeTrace_protocolIEs__item__value,
        __IurInvokeTrace_protocolIEs__item_,
        _IurInvokeTrace_protocolIEs,
        ____IurInvokeTrace_protocolExtensions__item__id_tab,
        _____IurInvokeTrace_protocolExtensions__item__id_tab_val_Extension_0,
        _____IurInvokeTrace_protocolExtensions__item__id_tab_val_Extension_1,
        ___IurInvokeTrace_protocolExtensions__item__id,
        ___IurInvokeTrace_protocolExtensions__item__criticality,
        ___IurInvokeTrace_protocolExtensions__item__extensionValue,
        __IurInvokeTrace_protocolExtensions__item_,
        _IurInvokeTrace_protocolExtensions,
        IurInvokeTrace,
        IurInvokeTrace_IEs,
        _IurInvokeTrace_IEs_val_Value_0,
        _IurInvokeTrace_IEs_val_Value_1,
        _IurInvokeTrace_IEs_val_Value_2,
        _IurInvokeTrace_IEs_val_Value_3,
        _IurInvokeTrace_IEs_val_Value_4,
        _IurInvokeTrace_IEs_val_Value_5,
        ___ListOfInterfacesToTrace__item__id_tab,
        ____ListOfInterfacesToTrace__item__id_tab_val_Value_0,
        __ListOfInterfacesToTrace__item__id,
        __ListOfInterfacesToTrace__item__criticality,
        __ListOfInterfacesToTrace__item__value,
        _ListOfInterfacesToTrace__item_,
        ListOfInterfacesToTrace,
        InterfacesToBeTracedItemIE,
        _InterfacesToBeTracedItemIE_val_Value_0,
        _InterfacesToTraceItem_interface,
        ____InterfacesToTraceItem_iE_Extensions__item__id_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__id,
        ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__criticality,
        ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__extensionValue,
        __InterfacesToTraceItem_iE_Extensions__item_,
        _InterfacesToTraceItem_iE_Extensions,
        InterfacesToTraceItem,
        InterfacesToTraceItem_ExtIEs,
        IurInvokeTrace_Extensions,
        _IurInvokeTrace_Extensions_val_Extension_0,
        _IurInvokeTrace_Extensions_val_Extension_1,
        ____IurDeactivateTrace_protocolIEs__item__id_tab,
        _____IurDeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____IurDeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        ___IurDeactivateTrace_protocolIEs__item__id,
        ___IurDeactivateTrace_protocolIEs__item__criticality,
        ___IurDeactivateTrace_protocolIEs__item__value,
        __IurDeactivateTrace_protocolIEs__item_,
        _IurDeactivateTrace_protocolIEs,
        ____IurDeactivateTrace_protocolExtensions__item__id_tab,
        ___IurDeactivateTrace_protocolExtensions__item__id,
        ____IurDeactivateTrace_protocolExtensions__item__criticality_tab,
        ___IurDeactivateTrace_protocolExtensions__item__criticality,
        ____IurDeactivateTrace_protocolExtensions__item__extensionValue_tab,
        ___IurDeactivateTrace_protocolExtensions__item__extensionValue,
        __IurDeactivateTrace_protocolExtensions__item_,
        _IurDeactivateTrace_protocolExtensions,
        IurDeactivateTrace,
        IurDeactivateTrace_IEs,
        _IurDeactivateTrace_IEs_val_Value_0,
        _IurDeactivateTrace_IEs_val_Value_1,
        IurDeactivateTrace_Extensions,
        ____MBMSAttachCommand_protocolIEs__item__id_tab,
        _____MBMSAttachCommand_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSAttachCommand_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSAttachCommand_protocolIEs__item__id,
        ___MBMSAttachCommand_protocolIEs__item__criticality,
        ___MBMSAttachCommand_protocolIEs__item__value,
        __MBMSAttachCommand_protocolIEs__item_,
        _MBMSAttachCommand_protocolIEs,
        ____MBMSAttachCommand_protocolExtensions__item__id_tab,
        ___MBMSAttachCommand_protocolExtensions__item__id,
        ____MBMSAttachCommand_protocolExtensions__item__criticality_tab,
        ___MBMSAttachCommand_protocolExtensions__item__criticality,
        ____MBMSAttachCommand_protocolExtensions__item__extensionValue_tab,
        ___MBMSAttachCommand_protocolExtensions__item__extensionValue,
        __MBMSAttachCommand_protocolExtensions__item_,
        _MBMSAttachCommand_protocolExtensions,
        MBMSAttachCommand,
        MBMSAttachCommand_IEs,
        _MBMSAttachCommand_IEs_val_Value_0,
        _MBMSAttachCommand_IEs_val_Value_1,
        MBMSAttachCommand_Extensions,
        ____MBMSDetachCommand_protocolIEs__item__id_tab,
        _____MBMSDetachCommand_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSDetachCommand_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSDetachCommand_protocolIEs__item__id,
        ___MBMSDetachCommand_protocolIEs__item__criticality,
        ___MBMSDetachCommand_protocolIEs__item__value,
        __MBMSDetachCommand_protocolIEs__item_,
        _MBMSDetachCommand_protocolIEs,
        ____MBMSDetachCommand_protocolExtensions__item__id_tab,
        ___MBMSDetachCommand_protocolExtensions__item__id,
        ____MBMSDetachCommand_protocolExtensions__item__criticality_tab,
        ___MBMSDetachCommand_protocolExtensions__item__criticality,
        ____MBMSDetachCommand_protocolExtensions__item__extensionValue_tab,
        ___MBMSDetachCommand_protocolExtensions__item__extensionValue,
        __MBMSDetachCommand_protocolExtensions__item_,
        _MBMSDetachCommand_protocolExtensions,
        MBMSDetachCommand,
        MBMSDetachCommand_IEs,
        _MBMSDetachCommand_IEs_val_Value_0,
        _MBMSDetachCommand_IEs_val_Value_1,
        MBMSDetachCommand_Extensions,
        ____DirectInformationTransfer_protocolIEs__item__id_tab,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        ___DirectInformationTransfer_protocolIEs__item__id,
        ___DirectInformationTransfer_protocolIEs__item__criticality,
        ___DirectInformationTransfer_protocolIEs__item__value,
        __DirectInformationTransfer_protocolIEs__item_,
        _DirectInformationTransfer_protocolIEs,
        ____DirectInformationTransfer_protocolExtensions__item__id_tab,
        _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0,
        ___DirectInformationTransfer_protocolExtensions__item__id,
        ___DirectInformationTransfer_protocolExtensions__item__criticality,
        ___DirectInformationTransfer_protocolExtensions__item__extensionValue,
        __DirectInformationTransfer_protocolExtensions__item_,
        _DirectInformationTransfer_protocolExtensions,
        DirectInformationTransfer,
        DirectInformationTransfer_IEs,
        _DirectInformationTransfer_IEs_val_Value_0,
        _DirectInformationTransfer_IEs_val_Value_1,
        DirectInformationTransfer_Extensions,
        _DirectInformationTransfer_Extensions_val_Extension_0,
        ____EnhancedRelocationRequest_protocolIEs__item__id_tab,
        _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____EnhancedRelocationRequest_protocolIEs__item__id_tab_val_Value_5,
        ___EnhancedRelocationRequest_protocolIEs__item__id,
        ___EnhancedRelocationRequest_protocolIEs__item__criticality,
        ___EnhancedRelocationRequest_protocolIEs__item__value,
        __EnhancedRelocationRequest_protocolIEs__item_,
        _EnhancedRelocationRequest_protocolIEs,
        ____EnhancedRelocationRequest_protocolExtensions__item__id_tab,
        _____EnhancedRelocationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___EnhancedRelocationRequest_protocolExtensions__item__id,
        ___EnhancedRelocationRequest_protocolExtensions__item__criticality,
        ___EnhancedRelocationRequest_protocolExtensions__item__extensionValue,
        __EnhancedRelocationRequest_protocolExtensions__item_,
        _EnhancedRelocationRequest_protocolExtensions,
        EnhancedRelocationRequest,
        EnhancedRelocationRequest_IEs,
        _EnhancedRelocationRequest_IEs_val_Value_0,
        _EnhancedRelocationRequest_IEs_val_Value_1,
        _EnhancedRelocationRequest_IEs_val_Value_2,
        _EnhancedRelocationRequest_IEs_val_Value_3,
        _EnhancedRelocationRequest_IEs_val_Value_4,
        _EnhancedRelocationRequest_IEs_val_Value_5,
        EnhancedRelocationRequest_Extensions,
        _EnhancedRelocationRequest_Extensions_val_Extension_0,
        ____EnhancedRelocationResponse_protocolIEs__item__id_tab,
        _____EnhancedRelocationResponse_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationResponse_protocolIEs__item__id,
        ___EnhancedRelocationResponse_protocolIEs__item__criticality,
        ___EnhancedRelocationResponse_protocolIEs__item__value,
        __EnhancedRelocationResponse_protocolIEs__item_,
        _EnhancedRelocationResponse_protocolIEs,
        ____EnhancedRelocationResponse_protocolExtensions__item__id_tab,
        ___EnhancedRelocationResponse_protocolExtensions__item__id,
        ____EnhancedRelocationResponse_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationResponse_protocolExtensions__item__criticality,
        ____EnhancedRelocationResponse_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationResponse_protocolExtensions__item__extensionValue,
        __EnhancedRelocationResponse_protocolExtensions__item_,
        _EnhancedRelocationResponse_protocolExtensions,
        EnhancedRelocationResponse,
        EnhancedRelocationResponse_IEs,
        _EnhancedRelocationResponse_IEs_val_Value_0,
        EnhancedRelocationResponse_Extensions,
        ____EnhancedRelocationFailure_protocolIEs__item__id_tab,
        _____EnhancedRelocationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___EnhancedRelocationFailure_protocolIEs__item__id,
        ___EnhancedRelocationFailure_protocolIEs__item__criticality,
        ___EnhancedRelocationFailure_protocolIEs__item__value,
        __EnhancedRelocationFailure_protocolIEs__item_,
        _EnhancedRelocationFailure_protocolIEs,
        ____EnhancedRelocationFailure_protocolExtensions__item__id_tab,
        ___EnhancedRelocationFailure_protocolExtensions__item__id,
        ____EnhancedRelocationFailure_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationFailure_protocolExtensions__item__criticality,
        ____EnhancedRelocationFailure_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationFailure_protocolExtensions__item__extensionValue,
        __EnhancedRelocationFailure_protocolExtensions__item_,
        _EnhancedRelocationFailure_protocolExtensions,
        EnhancedRelocationFailure,
        EnhancedRelocationFailure_IEs,
        _EnhancedRelocationFailure_IEs_val_Value_0,
        _EnhancedRelocationFailure_IEs_val_Value_1,
        EnhancedRelocationFailure_Extensions,
        ____EnhancedRelocationCancel_protocolIEs__item__id_tab,
        _____EnhancedRelocationCancel_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationCancel_protocolIEs__item__id,
        ___EnhancedRelocationCancel_protocolIEs__item__criticality,
        ___EnhancedRelocationCancel_protocolIEs__item__value,
        __EnhancedRelocationCancel_protocolIEs__item_,
        _EnhancedRelocationCancel_protocolIEs,
        ____EnhancedRelocationCancel_protocolExtensions__item__id_tab,
        ___EnhancedRelocationCancel_protocolExtensions__item__id,
        ____EnhancedRelocationCancel_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationCancel_protocolExtensions__item__criticality,
        ____EnhancedRelocationCancel_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationCancel_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCancel_protocolExtensions__item_,
        _EnhancedRelocationCancel_protocolExtensions,
        EnhancedRelocationCancel,
        EnhancedRelocationCancel_IEs,
        _EnhancedRelocationCancel_IEs_val_Value_0,
        EnhancedRelocationCancel_Extensions,
        ____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab,
        _____EnhancedRelocationSignallingTransfer_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationSignallingTransfer_protocolIEs__item__id,
        ___EnhancedRelocationSignallingTransfer_protocolIEs__item__criticality,
        ___EnhancedRelocationSignallingTransfer_protocolIEs__item__value,
        __EnhancedRelocationSignallingTransfer_protocolIEs__item_,
        _EnhancedRelocationSignallingTransfer_protocolIEs,
        ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__id_tab,
        ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__id,
        ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__criticality,
        ____EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationSignallingTransfer_protocolExtensions__item__extensionValue,
        __EnhancedRelocationSignallingTransfer_protocolExtensions__item_,
        _EnhancedRelocationSignallingTransfer_protocolExtensions,
        EnhancedRelocationSignallingTransfer,
        EnhancedRelocationSignallingTransfer_IEs,
        _EnhancedRelocationSignallingTransfer_IEs_val_Value_0,
        EnhancedRelocationSignallingTransfer_Extensions,
        ____EnhancedRelocationRelease_protocolIEs__item__id_tab,
        _____EnhancedRelocationRelease_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationRelease_protocolIEs__item__id,
        ___EnhancedRelocationRelease_protocolIEs__item__criticality,
        ___EnhancedRelocationRelease_protocolIEs__item__value,
        __EnhancedRelocationRelease_protocolIEs__item_,
        _EnhancedRelocationRelease_protocolIEs,
        ____EnhancedRelocationRelease_protocolExtensions__item__id_tab,
        ___EnhancedRelocationRelease_protocolExtensions__item__id,
        ____EnhancedRelocationRelease_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationRelease_protocolExtensions__item__criticality,
        ____EnhancedRelocationRelease_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationRelease_protocolExtensions__item__extensionValue,
        __EnhancedRelocationRelease_protocolExtensions__item_,
        _EnhancedRelocationRelease_protocolExtensions,
        EnhancedRelocationRelease,
        EnhancedRelocationRelease_IEs,
        _EnhancedRelocationRelease_IEs_val_Value_0,
        EnhancedRelocationRelease_Extensions,
        ____MBSFNMCCHInformation_protocolIEs__item__id_tab,
        _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_0,
        _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_1,
        _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_2,
        _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_3,
        _____MBSFNMCCHInformation_protocolIEs__item__id_tab_val_Value_4,
        ___MBSFNMCCHInformation_protocolIEs__item__id,
        ___MBSFNMCCHInformation_protocolIEs__item__criticality,
        ___MBSFNMCCHInformation_protocolIEs__item__value,
        __MBSFNMCCHInformation_protocolIEs__item_,
        _MBSFNMCCHInformation_protocolIEs,
        ____MBSFNMCCHInformation_protocolExtensions__item__id_tab,
        ___MBSFNMCCHInformation_protocolExtensions__item__id,
        ____MBSFNMCCHInformation_protocolExtensions__item__criticality_tab,
        ___MBSFNMCCHInformation_protocolExtensions__item__criticality,
        ____MBSFNMCCHInformation_protocolExtensions__item__extensionValue_tab,
        ___MBSFNMCCHInformation_protocolExtensions__item__extensionValue,
        __MBSFNMCCHInformation_protocolExtensions__item_,
        _MBSFNMCCHInformation_protocolExtensions,
        MBSFNMCCHInformation,
        MBSFNMCCHInformation_IEs,
        _MBSFNMCCHInformation_IEs_val_Value_0,
        _MBSFNMCCHInformation_IEs_val_Value_1,
        _MBSFNMCCHInformation_IEs_val_Value_2,
        _MBSFNMCCHInformation_IEs_val_Value_3,
        _MBSFNMCCHInformation_IEs_val_Value_4,
        MBSFNMCCHInformation_Extensions,
        ____SecondaryULFrequencyReport_protocolIEs__item__id_tab,
        _____SecondaryULFrequencyReport_protocolIEs__item__id_tab_val_Value_0,
        ___SecondaryULFrequencyReport_protocolIEs__item__id,
        ___SecondaryULFrequencyReport_protocolIEs__item__criticality,
        ___SecondaryULFrequencyReport_protocolIEs__item__value,
        __SecondaryULFrequencyReport_protocolIEs__item_,
        _SecondaryULFrequencyReport_protocolIEs,
        ____SecondaryULFrequencyReport_protocolExtensions__item__id_tab,
        ___SecondaryULFrequencyReport_protocolExtensions__item__id,
        ____SecondaryULFrequencyReport_protocolExtensions__item__criticality_tab,
        ___SecondaryULFrequencyReport_protocolExtensions__item__criticality,
        ____SecondaryULFrequencyReport_protocolExtensions__item__extensionValue_tab,
        ___SecondaryULFrequencyReport_protocolExtensions__item__extensionValue,
        __SecondaryULFrequencyReport_protocolExtensions__item_,
        _SecondaryULFrequencyReport_protocolExtensions,
        SecondaryULFrequencyReport,
        SecondaryULFrequencyReport_IEs,
        _SecondaryULFrequencyReport_IEs_val_Value_0,
        SecondaryULFrequencyReport_Extensions,
        ____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab,
        _____SecondaryULFrequencyUpdateIndication_protocolIEs__item__id_tab_val_Value_0,
        ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__id,
        ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__criticality,
        ___SecondaryULFrequencyUpdateIndication_protocolIEs__item__value,
        __SecondaryULFrequencyUpdateIndication_protocolIEs__item_,
        _SecondaryULFrequencyUpdateIndication_protocolIEs,
        ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id_tab,
        ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__id,
        ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality_tab,
        ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__criticality,
        ____SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue_tab,
        ___SecondaryULFrequencyUpdateIndication_protocolExtensions__item__extensionValue,
        __SecondaryULFrequencyUpdateIndication_protocolExtensions__item_,
        _SecondaryULFrequencyUpdateIndication_protocolExtensions,
        SecondaryULFrequencyUpdateIndication,
        SecondaryULFrequencyUpdateIndication_IEs,
        _SecondaryULFrequencyUpdateIndication_IEs_val_Value_0,
        SecondaryULFrequencyUpdateIndication_Extensions,
        ____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab,
        _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_2,
        _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_3,
        _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_4,
        _____EnhancedRelocationResourceRequest_protocolIEs__item__id_tab_val_Value_5,
        ___EnhancedRelocationResourceRequest_protocolIEs__item__id,
        ___EnhancedRelocationResourceRequest_protocolIEs__item__criticality,
        ___EnhancedRelocationResourceRequest_protocolIEs__item__value,
        __EnhancedRelocationResourceRequest_protocolIEs__item_,
        _EnhancedRelocationResourceRequest_protocolIEs,
        ____EnhancedRelocationResourceRequest_protocolExtensions__item__id_tab,
        ___EnhancedRelocationResourceRequest_protocolExtensions__item__id,
        ____EnhancedRelocationResourceRequest_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationResourceRequest_protocolExtensions__item__criticality,
        ____EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationResourceRequest_protocolExtensions__item__extensionValue,
        __EnhancedRelocationResourceRequest_protocolExtensions__item_,
        _EnhancedRelocationResourceRequest_protocolExtensions,
        EnhancedRelocationResourceRequest,
        EnhancedRelocationResourceRequest_IEs,
        _EnhancedRelocationResourceRequest_IEs_val_Value_0,
        _EnhancedRelocationResourceRequest_IEs_val_Value_1,
        _EnhancedRelocationResourceRequest_IEs_val_Value_2,
        _EnhancedRelocationResourceRequest_IEs_val_Value_3,
        _EnhancedRelocationResourceRequest_IEs_val_Value_4,
        _EnhancedRelocationResourceRequest_IEs_val_Value_5,
        EnhancedRelocationResourceRequest_Extensions,
        ____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab,
        _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_2,
        _____EnhancedRelocationResourceResponse_protocolIEs__item__id_tab_val_Value_3,
        ___EnhancedRelocationResourceResponse_protocolIEs__item__id,
        ___EnhancedRelocationResourceResponse_protocolIEs__item__criticality,
        ___EnhancedRelocationResourceResponse_protocolIEs__item__value,
        __EnhancedRelocationResourceResponse_protocolIEs__item_,
        _EnhancedRelocationResourceResponse_protocolIEs,
        ____EnhancedRelocationResourceResponse_protocolExtensions__item__id_tab,
        ___EnhancedRelocationResourceResponse_protocolExtensions__item__id,
        ____EnhancedRelocationResourceResponse_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationResourceResponse_protocolExtensions__item__criticality,
        ____EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationResourceResponse_protocolExtensions__item__extensionValue,
        __EnhancedRelocationResourceResponse_protocolExtensions__item_,
        _EnhancedRelocationResourceResponse_protocolExtensions,
        EnhancedRelocationResourceResponse,
        EnhancedRelocationResourceResponse_IEs,
        _EnhancedRelocationResourceResponse_IEs_val_Value_0,
        _EnhancedRelocationResourceResponse_IEs_val_Value_1,
        _EnhancedRelocationResourceResponse_IEs_val_Value_2,
        _EnhancedRelocationResourceResponse_IEs_val_Value_3,
        EnhancedRelocationResourceResponse_Extensions,
        ____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab,
        _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationResourceFailure_protocolIEs__item__id_tab_val_Value_2,
        ___EnhancedRelocationResourceFailure_protocolIEs__item__id,
        ___EnhancedRelocationResourceFailure_protocolIEs__item__criticality,
        ___EnhancedRelocationResourceFailure_protocolIEs__item__value,
        __EnhancedRelocationResourceFailure_protocolIEs__item_,
        _EnhancedRelocationResourceFailure_protocolIEs,
        ____EnhancedRelocationResourceFailure_protocolExtensions__item__id_tab,
        ___EnhancedRelocationResourceFailure_protocolExtensions__item__id,
        ____EnhancedRelocationResourceFailure_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationResourceFailure_protocolExtensions__item__criticality,
        ____EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationResourceFailure_protocolExtensions__item__extensionValue,
        __EnhancedRelocationResourceFailure_protocolExtensions__item_,
        _EnhancedRelocationResourceFailure_protocolExtensions,
        EnhancedRelocationResourceFailure,
        EnhancedRelocationResourceFailure_IEs,
        _EnhancedRelocationResourceFailure_IEs_val_Value_0,
        _EnhancedRelocationResourceFailure_IEs_val_Value_1,
        _EnhancedRelocationResourceFailure_IEs_val_Value_2,
        EnhancedRelocationResourceFailure_Extensions,
        ____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab,
        _____EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__id,
        ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__criticality,
        ___EnhancedRelocationResourceReleaseCommand_protocolIEs__item__value,
        __EnhancedRelocationResourceReleaseCommand_protocolIEs__item_,
        _EnhancedRelocationResourceReleaseCommand_protocolIEs,
        ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id_tab,
        ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__id,
        ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__criticality,
        ____EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationResourceReleaseCommand_protocolExtensions__item__extensionValue,
        __EnhancedRelocationResourceReleaseCommand_protocolExtensions__item_,
        _EnhancedRelocationResourceReleaseCommand_protocolExtensions,
        EnhancedRelocationResourceReleaseCommand,
        EnhancedRelocationResourceReleaseCommand_IEs,
        _EnhancedRelocationResourceReleaseCommand_IEs_val_Value_0,
        EnhancedRelocationResourceReleaseCommand_Extensions,
        ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id_tab,
        ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__id,
        ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality_tab,
        ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__criticality,
        ____EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value_tab,
        ___EnhancedRelocationResourceReleaseComplete_protocolIEs__item__value,
        __EnhancedRelocationResourceReleaseComplete_protocolIEs__item_,
        _EnhancedRelocationResourceReleaseComplete_protocolIEs,
        ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id_tab,
        ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__id,
        ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__criticality,
        ____EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationResourceReleaseComplete_protocolExtensions__item__extensionValue,
        __EnhancedRelocationResourceReleaseComplete_protocolExtensions__item_,
        _EnhancedRelocationResourceReleaseComplete_protocolExtensions,
        EnhancedRelocationResourceReleaseComplete,
        EnhancedRelocationResourceReleaseComplete_IEs,
        EnhancedRelocationResourceReleaseComplete_Extensions,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____InformationTransferControlRequest_protocolIEs__item__id_tab,
        _____InformationTransferControlRequest_protocolIEs__item__id_tab_val_Value_0,
        ___InformationTransferControlRequest_protocolIEs__item__id,
        ___InformationTransferControlRequest_protocolIEs__item__criticality,
        ___InformationTransferControlRequest_protocolIEs__item__value,
        __InformationTransferControlRequest_protocolIEs__item_,
        _InformationTransferControlRequest_protocolIEs,
        ____InformationTransferControlRequest_protocolExtensions__item__id_tab,
        ___InformationTransferControlRequest_protocolExtensions__item__id,
        ____InformationTransferControlRequest_protocolExtensions__item__criticality_tab,
        ___InformationTransferControlRequest_protocolExtensions__item__criticality,
        ____InformationTransferControlRequest_protocolExtensions__item__extensionValue_tab,
        ___InformationTransferControlRequest_protocolExtensions__item__extensionValue,
        __InformationTransferControlRequest_protocolExtensions__item_,
        _InformationTransferControlRequest_protocolExtensions,
        InformationTransferControlRequest,
        InformationTransferControlRequest_IEs,
        _InformationTransferControlRequest_IEs_val_Value_0,
        InformationTransferControlRequest_Extensions,
        _Control_Type_InformationTransferControlReq_suspension,
        _Control_Type_InformationTransferControlReq_resume,
        Control_Type_InformationTransferControlReq,
        _Suspension_Control_Type_controlled_Object_Scope,
        ____Suspension_Control_Type_iE_Extensions__item__id_tab,
        ___Suspension_Control_Type_iE_Extensions__item__id,
        ____Suspension_Control_Type_iE_Extensions__item__criticality_tab,
        ___Suspension_Control_Type_iE_Extensions__item__criticality,
        ____Suspension_Control_Type_iE_Extensions__item__extensionValue_tab,
        ___Suspension_Control_Type_iE_Extensions__item__extensionValue,
        __Suspension_Control_Type_iE_Extensions__item_,
        _Suspension_Control_Type_iE_Extensions,
        Suspension_Control_Type,
        Suspension_Control_Type_ExtIEs,
        _Resume_Control_Type_controlled_Object_Scope,
        ____Resume_Control_Type_iE_Extensions__item__id_tab,
        ___Resume_Control_Type_iE_Extensions__item__id,
        ____Resume_Control_Type_iE_Extensions__item__criticality_tab,
        ___Resume_Control_Type_iE_Extensions__item__criticality,
        ____Resume_Control_Type_iE_Extensions__item__extensionValue_tab,
        ___Resume_Control_Type_iE_Extensions__item__extensionValue,
        __Resume_Control_Type_iE_Extensions__item_,
        _Resume_Control_Type_iE_Extensions,
        Resume_Control_Type,
        Resume_Control_Type_ExtIEs,
    ]

class RNSAP_PDU_Descriptions:

    _name_  = u'RNSAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 1, 1, 0]
    
    _obj_ = [
        u'RNSAP-ELEMENTARY-PROCEDURE',
        u'RNSAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'Outcome',
        u'RNSAP-ELEMENTARY-PROCEDURES',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-3',
        u'radioLinkSetupFDD',
        u'radioLinkSetupTDD',
        u'radioLinkAdditionFDD',
        u'radioLinkAdditionTDD',
        u'radioLinkDeletion',
        u'synchronisedRadioLinkReconfigurationPreparationFDD',
        u'synchronisedRadioLinkReconfigurationPreparationTDD',
        u'unSynchronisedRadioLinkReconfigurationFDD',
        u'unSynchronisedRadioLinkReconfigurationTDD',
        u'physicalChannelReconfigurationFDD',
        u'physicalChannelReconfigurationTDD',
        u'dedicatedMeasurementInitiation',
        u'commonTransportChannelResourcesInitialisationFDD',
        u'commonTransportChannelResourcesInitialisationTDD',
        u'uplinkSignallingTransferFDD',
        u'uplinkSignallingTransferTDD',
        u'downlinkSignallingTransfer',
        u'relocationCommit',
        u'paging',
        u'synchronisedRadioLinkReconfigurationCommit',
        u'synchronisedRadioLinkReconfigurationCancellation',
        u'radioLinkFailure',
        u'radioLinkPreemption',
        u'radioLinkRestoration',
        u'dedicatedMeasurementReporting',
        u'dedicatedMeasurementTermination',
        u'dedicatedMeasurementFailure',
        u'radioLinkCongestion',
        u'downlinkPowerControlFDD',
        u'downlinkPowerTimeslotControl',
        u'compressedModeCommandFDD',
        u'commonTransportChannelResourcesRelease',
        u'errorIndication',
        u'commonMeasurementInitiation',
        u'commonMeasurementReporting',
        u'commonMeasurementTermination',
        u'commonMeasurementFailure',
        u'informationExchangeInitiation',
        u'informationReporting',
        u'informationExchangeTermination',
        u'informationExchangeFailure',
        u'privateMessage',
        u'reset',
        u'radioLinkActivationFDD',
        u'radioLinkActivationTDD',
        u'gERANuplinkSignallingTransfer',
        u'radioLinkParameterUpdateFDD',
        u'radioLinkParameterUpdateTDD',
        u'uEMeasurementInitiation',
        u'uEMeasurementReporting',
        u'uEMeasurementTermination',
        u'uEMeasurementFailure',
        u'iurInvokeTrace',
        u'iurDeactivateTrace',
        u'mBMSAttach',
        u'mBMSDetach',
        u'directInformationTransfer',
        u'enhancedRelocation',
        u'enhancedRelocationCancel',
        u'enhancedRelocationSignallingTransfer',
        u'enhancedRelocationRelease',
        u'mBSFNMCCHInformation',
        u'secondaryULFrequencyReportingFDD',
        u'secondaryULFrequencyUpdateFDD',
        u'enhancedRelocationResourceAllocation',
        u'enhancedRelocationResourceRelease',
        u'informationTransferControl',
        ]
    _type_ = [
        u'RNSAP-ELEMENTARY-PROCEDURE',
        u'RNSAP-PDU',
        u'InitiatingMessage',
        u'SuccessfulOutcome',
        u'UnsuccessfulOutcome',
        u'Outcome',
        ]
    _set_ = [
        u'RNSAP-ELEMENTARY-PROCEDURES',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-3',
        ]
    _val_ = [
        u'radioLinkSetupFDD',
        u'radioLinkSetupTDD',
        u'radioLinkAdditionFDD',
        u'radioLinkAdditionTDD',
        u'radioLinkDeletion',
        u'synchronisedRadioLinkReconfigurationPreparationFDD',
        u'synchronisedRadioLinkReconfigurationPreparationTDD',
        u'unSynchronisedRadioLinkReconfigurationFDD',
        u'unSynchronisedRadioLinkReconfigurationTDD',
        u'physicalChannelReconfigurationFDD',
        u'physicalChannelReconfigurationTDD',
        u'dedicatedMeasurementInitiation',
        u'commonTransportChannelResourcesInitialisationFDD',
        u'commonTransportChannelResourcesInitialisationTDD',
        u'uplinkSignallingTransferFDD',
        u'uplinkSignallingTransferTDD',
        u'downlinkSignallingTransfer',
        u'relocationCommit',
        u'paging',
        u'synchronisedRadioLinkReconfigurationCommit',
        u'synchronisedRadioLinkReconfigurationCancellation',
        u'radioLinkFailure',
        u'radioLinkPreemption',
        u'radioLinkRestoration',
        u'dedicatedMeasurementReporting',
        u'dedicatedMeasurementTermination',
        u'dedicatedMeasurementFailure',
        u'radioLinkCongestion',
        u'downlinkPowerControlFDD',
        u'downlinkPowerTimeslotControl',
        u'compressedModeCommandFDD',
        u'commonTransportChannelResourcesRelease',
        u'errorIndication',
        u'commonMeasurementInitiation',
        u'commonMeasurementReporting',
        u'commonMeasurementTermination',
        u'commonMeasurementFailure',
        u'informationExchangeInitiation',
        u'informationReporting',
        u'informationExchangeTermination',
        u'informationExchangeFailure',
        u'privateMessage',
        u'reset',
        u'radioLinkActivationFDD',
        u'radioLinkActivationTDD',
        u'gERANuplinkSignallingTransfer',
        u'radioLinkParameterUpdateFDD',
        u'radioLinkParameterUpdateTDD',
        u'uEMeasurementInitiation',
        u'uEMeasurementReporting',
        u'uEMeasurementTermination',
        u'uEMeasurementFailure',
        u'iurInvokeTrace',
        u'iurDeactivateTrace',
        u'mBMSAttach',
        u'mBMSDetach',
        u'directInformationTransfer',
        u'enhancedRelocation',
        u'enhancedRelocationCancel',
        u'enhancedRelocationSignallingTransfer',
        u'enhancedRelocationRelease',
        u'mBSFNMCCHInformation',
        u'secondaryULFrequencyReportingFDD',
        u'secondaryULFrequencyUpdateFDD',
        u'enhancedRelocationResourceAllocation',
        u'enhancedRelocationResourceRelease',
        u'informationTransferControl',
        ]
    _class_ = [
        u'RNSAP-ELEMENTARY-PROCEDURE',
        u'RNSAP-ELEMENTARY-PROCEDURES',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-1',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-2',
        u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-3',
        u'radioLinkSetupFDD',
        u'radioLinkSetupTDD',
        u'radioLinkAdditionFDD',
        u'radioLinkAdditionTDD',
        u'radioLinkDeletion',
        u'synchronisedRadioLinkReconfigurationPreparationFDD',
        u'synchronisedRadioLinkReconfigurationPreparationTDD',
        u'unSynchronisedRadioLinkReconfigurationFDD',
        u'unSynchronisedRadioLinkReconfigurationTDD',
        u'physicalChannelReconfigurationFDD',
        u'physicalChannelReconfigurationTDD',
        u'dedicatedMeasurementInitiation',
        u'commonTransportChannelResourcesInitialisationFDD',
        u'commonTransportChannelResourcesInitialisationTDD',
        u'uplinkSignallingTransferFDD',
        u'uplinkSignallingTransferTDD',
        u'downlinkSignallingTransfer',
        u'relocationCommit',
        u'paging',
        u'synchronisedRadioLinkReconfigurationCommit',
        u'synchronisedRadioLinkReconfigurationCancellation',
        u'radioLinkFailure',
        u'radioLinkPreemption',
        u'radioLinkRestoration',
        u'dedicatedMeasurementReporting',
        u'dedicatedMeasurementTermination',
        u'dedicatedMeasurementFailure',
        u'radioLinkCongestion',
        u'downlinkPowerControlFDD',
        u'downlinkPowerTimeslotControl',
        u'compressedModeCommandFDD',
        u'commonTransportChannelResourcesRelease',
        u'errorIndication',
        u'commonMeasurementInitiation',
        u'commonMeasurementReporting',
        u'commonMeasurementTermination',
        u'commonMeasurementFailure',
        u'informationExchangeInitiation',
        u'informationReporting',
        u'informationExchangeTermination',
        u'informationExchangeFailure',
        u'privateMessage',
        u'reset',
        u'radioLinkActivationFDD',
        u'radioLinkActivationTDD',
        u'gERANuplinkSignallingTransfer',
        u'radioLinkParameterUpdateFDD',
        u'radioLinkParameterUpdateTDD',
        u'uEMeasurementInitiation',
        u'uEMeasurementReporting',
        u'uEMeasurementTermination',
        u'uEMeasurementFailure',
        u'iurInvokeTrace',
        u'iurDeactivateTrace',
        u'mBMSAttach',
        u'mBMSDetach',
        u'directInformationTransfer',
        u'enhancedRelocation',
        u'enhancedRelocationCancel',
        u'enhancedRelocationSignallingTransfer',
        u'enhancedRelocationRelease',
        u'mBSFNMCCHInformation',
        u'secondaryULFrequencyReportingFDD',
        u'secondaryULFrequencyUpdateFDD',
        u'enhancedRelocationResourceAllocation',
        u'enhancedRelocationResourceRelease',
        u'informationTransferControl',
        ]
    _param_ = [
        ]
    
    #-----< RNSAP-ELEMENTARY-PROCEDURE >-----#
    RNSAP_ELEMENTARY_PROCEDURE = CLASS(name=u'RNSAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _RNSAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name=u'InitiatingMessage', mode=MODE_TYPE)
    _RNSAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name=u'SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RNSAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RNSAP_ELEMENTARY_PROCEDURE_Outcome = OPEN(name=u'Outcome', mode=MODE_TYPE, opt=True)
    _RNSAP_ELEMENTARY_PROCEDURE_procedureID = SEQ(name=u'procedureID', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'ProcedureID')), uniq=True)
    _RNSAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'Criticality')), default=u'ignore')
    RNSAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        (u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        (u'Outcome', _RNSAP_ELEMENTARY_PROCEDURE_Outcome),
        (u'procedureID', _RNSAP_ELEMENTARY_PROCEDURE_procedureID),
        (u'criticality', _RNSAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< RNSAP-PDU >-----#
    RNSAP_PDU = CHOICE(name=u'RNSAP-PDU', mode=MODE_TYPE)
    _RNSAP_PDU_initiatingMessage = SEQ(name=u'initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'InitiatingMessage')))
    _RNSAP_PDU_successfulOutcome = SEQ(name=u'successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _RNSAP_PDU_unsuccessfulOutcome = SEQ(name=u'unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _RNSAP_PDU_outcome = SEQ(name=u'outcome', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'Outcome')))
    RNSAP_PDU._cont = ASN1Dict([
        (u'initiatingMessage', _RNSAP_PDU_initiatingMessage),
        (u'successfulOutcome', _RNSAP_PDU_successfulOutcome),
        (u'unsuccessfulOutcome', _RNSAP_PDU_unsuccessfulOutcome),
        (u'outcome', _RNSAP_PDU_outcome),
        ])
    RNSAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureID = SEQ(name=u'procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'procedureID']))
    __InitiatingMessage_procedureID_tab = CLASS(name='_tab_RNSAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_33 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_34 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_34 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_36 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    __InitiatingMessage_procedureID_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_0), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_1), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_2), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_3), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_4), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_5), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_6), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_7), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_8), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_9), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_10), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_11), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_12), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_13), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_14), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_15), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_16), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_17), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_18), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_19), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_20), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_21), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_22), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_23), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_24), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_25), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_26), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_27), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_28), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_29), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_30), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_31), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_32), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_33), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_33), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_34), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_34), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_34), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_35), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_36), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_36), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_37), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_38), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_39), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_40), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_41), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_42), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_43), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_44), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_45), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_46), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_47), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_48), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_49), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_50), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_51), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_52), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_53), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_54), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_55), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_56), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_57), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_58), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_59), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_60), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_61), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_62), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_63), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_64), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_65), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_66), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], er=[])
    _InitiatingMessage_procedureID._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_procedureID._const_tab_at = None
    _InitiatingMessage_procedureID._const_tab_id = u'procedureID'
    _InitiatingMessage_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', u'procedureID')
    _InitiatingMessage_criticality._const_tab_id = u'criticality'
    _InitiatingMessage_transactionID = CHOICE(name=u'transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'TransactionID')))
    _InitiatingMessage_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureID_tab
    _InitiatingMessage_value._const_tab_at = ('..', u'procedureID')
    _InitiatingMessage_value._const_tab_id = u'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        (u'procedureID', _InitiatingMessage_procedureID),
        (u'criticality', _InitiatingMessage_criticality),
        (u'transactionID', _InitiatingMessage_transactionID),
        (u'value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureID = SEQ(name=u'procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'procedureID']))
    __SuccessfulOutcome_procedureID_tab = CLASS(name='_tab_RNSAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_33 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_34 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_34 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_36 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    __SuccessfulOutcome_procedureID_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_9), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_33), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_33), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_34), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_34), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_35), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_36), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_36), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_37), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_38), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_39), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], er=[])
    _SuccessfulOutcome_procedureID._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_procedureID._const_tab_at = None
    _SuccessfulOutcome_procedureID._const_tab_id = u'procedureID'
    _SuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureID')
    _SuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _SuccessfulOutcome_transactionID = CHOICE(name=u'transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'TransactionID')))
    _SuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureID_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', u'procedureID')
    _SuccessfulOutcome_value._const_tab_id = u'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        (u'procedureID', _SuccessfulOutcome_procedureID),
        (u'criticality', _SuccessfulOutcome_criticality),
        (u'transactionID', _SuccessfulOutcome_transactionID),
        (u'value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureID = SEQ(name=u'procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'procedureID']))
    __UnsuccessfulOutcome_procedureID_tab = CLASS(name='_tab_RNSAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_33 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_34 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_34 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_36 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    __UnsuccessfulOutcome_procedureID_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_9), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_33), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_33), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_34), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_34), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_35), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_36), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_36), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_37), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_38), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_39), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], er=[])
    _UnsuccessfulOutcome_procedureID._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_procedureID._const_tab_at = None
    _UnsuccessfulOutcome_procedureID._const_tab_id = u'procedureID'
    _UnsuccessfulOutcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', u'procedureID')
    _UnsuccessfulOutcome_criticality._const_tab_id = u'criticality'
    _UnsuccessfulOutcome_transactionID = CHOICE(name=u'transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'TransactionID')))
    _UnsuccessfulOutcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureID_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', u'procedureID')
    _UnsuccessfulOutcome_value._const_tab_id = u'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        (u'procedureID', _UnsuccessfulOutcome_procedureID),
        (u'criticality', _UnsuccessfulOutcome_criticality),
        (u'transactionID', _UnsuccessfulOutcome_transactionID),
        (u'value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< Outcome >-----#
    Outcome = SEQ(name=u'Outcome', mode=MODE_TYPE)
    _Outcome_procedureID = SEQ(name=u'procedureID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'procedureID']))
    __Outcome_procedureID_tab = CLASS(name='_tab_RNSAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_33 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_34 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_34 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_36 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    ___Outcome_procedureID_tab_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    ___Outcome_procedureID_tab_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    __Outcome_procedureID_tab._val = ASN1Set(rv=[dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_0), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_0), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_1), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_1), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_2), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_2), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_3), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_3), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_4), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_4), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_5), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_5), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_6), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_6), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_7), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_7), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_8), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_8), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_9), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_9), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_10), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_10), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_11), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_11), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_12), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_12), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_13), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_13), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_14), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_15), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_16), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_17), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_18), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_19), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_20), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_21), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_22), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_23), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_24), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_25), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_26), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_27), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_28), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_29), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_30), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_31), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_32), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_33), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_33), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_33), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_34), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_34), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_34), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_35), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_35), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_36), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_36), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_36), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_37), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_37), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_38), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_38), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_39), (u'SuccessfulOutcome', ___Outcome_procedureID_tab_val_SuccessfulOutcome_39), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_40), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_41), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_42), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_43), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_44), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_45), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_46), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_47), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_48), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_49), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_50), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_51), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_52), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_53), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_54), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_55), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_56), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_57), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_58), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_59), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_60), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_61), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_62), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_63), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_64), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_65), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', ___Outcome_procedureID_tab_val_InitiatingMessage_66), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], er=[])
    _Outcome_procedureID._const_tab = __Outcome_procedureID_tab
    _Outcome_procedureID._const_tab_at = None
    _Outcome_procedureID._const_tab_id = u'procedureID'
    _Outcome_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'criticality']))
    _Outcome_criticality._const_tab = __Outcome_procedureID_tab
    _Outcome_criticality._const_tab_at = ('..', u'procedureID')
    _Outcome_criticality._const_tab_id = u'criticality'
    _Outcome_transactionID = CHOICE(name=u'transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RNSAP-CommonDataTypes', 'TransactionID')))
    _Outcome_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE'), [u'Outcome']))
    _Outcome_value._const_tab = __Outcome_procedureID_tab
    _Outcome_value._const_tab_at = ('..', u'procedureID')
    _Outcome_value._const_tab_id = u'Outcome'
    Outcome._cont = ASN1Dict([
        (u'procedureID', _Outcome_procedureID),
        (u'criticality', _Outcome_criticality),
        (u'transactionID', _Outcome_transactionID),
        (u'value', _Outcome_value),
        ])
    Outcome._ext = None
    
    #-----< RNSAP-ELEMENTARY-PROCEDURES >-----#
    RNSAP_ELEMENTARY_PROCEDURES = CLASS(name=u'RNSAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_33 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_34 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_34 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_36 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    RNSAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_33), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_34), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_34), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_36), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], er=[])
    
    #-----< RNSAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    RNSAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name=u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19 = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    RNSAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])], rr=[], ev=[dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), (u'UnsuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), (u'SuccessfulOutcome', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])], er=[])
    
    #-----< RNSAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    RNSAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name=u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_45 = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    RNSAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], rr=[], ev=[dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')]), dict([(u'InitiatingMessage', _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_45), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])], er=[])
    
    #-----< RNSAP-ELEMENTARY-PROCEDURES-CLASS-3 >-----#
    RNSAP_ELEMENTARY_PROCEDURES_CLASS_3 = CLASS(name=u'RNSAP-ELEMENTARY-PROCEDURES-CLASS-3', mode=MODE_SET, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    RNSAP_ELEMENTARY_PROCEDURES_CLASS_3._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< radioLinkSetupFDD >-----#
    radioLinkSetupFDD = CLASS(name=u'radioLinkSetupFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkSetupFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestFDD')))
    _radioLinkSetupFDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseFDD')))
    _radioLinkSetupFDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureFDD')))
    radioLinkSetupFDD._val = dict([(u'InitiatingMessage', _radioLinkSetupFDD_val_InitiatingMessage), (u'SuccessfulOutcome', _radioLinkSetupFDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _radioLinkSetupFDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'fdd')])), (u'criticality', u'reject')])
    
    #-----< radioLinkSetupTDD >-----#
    radioLinkSetupTDD = CLASS(name=u'radioLinkSetupTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkSetupTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupRequestTDD')))
    _radioLinkSetupTDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupResponseTDD')))
    _radioLinkSetupTDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkSetupFailureTDD')))
    radioLinkSetupTDD._val = dict([(u'InitiatingMessage', _radioLinkSetupTDD_val_InitiatingMessage), (u'SuccessfulOutcome', _radioLinkSetupTDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _radioLinkSetupTDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 19), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< radioLinkAdditionFDD >-----#
    radioLinkAdditionFDD = CLASS(name=u'radioLinkAdditionFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkAdditionFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestFDD')))
    _radioLinkAdditionFDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseFDD')))
    _radioLinkAdditionFDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureFDD')))
    radioLinkAdditionFDD._val = dict([(u'InitiatingMessage', _radioLinkAdditionFDD_val_InitiatingMessage), (u'SuccessfulOutcome', _radioLinkAdditionFDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _radioLinkAdditionFDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'fdd')])), (u'criticality', u'reject')])
    
    #-----< radioLinkAdditionTDD >-----#
    radioLinkAdditionTDD = CLASS(name=u'radioLinkAdditionTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkAdditionTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionRequestTDD')))
    _radioLinkAdditionTDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionResponseTDD')))
    _radioLinkAdditionTDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkAdditionFailureTDD')))
    radioLinkAdditionTDD._val = dict([(u'InitiatingMessage', _radioLinkAdditionTDD_val_InitiatingMessage), (u'SuccessfulOutcome', _radioLinkAdditionTDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _radioLinkAdditionTDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 14), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< radioLinkDeletion >-----#
    radioLinkDeletion = CLASS(name=u'radioLinkDeletion', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkDeletion_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionRequest')))
    _radioLinkDeletion_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkDeletionResponse')))
    radioLinkDeletion._val = dict([(u'InitiatingMessage', _radioLinkDeletion_val_InitiatingMessage), (u'SuccessfulOutcome', _radioLinkDeletion_val_SuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 15), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< synchronisedRadioLinkReconfigurationPreparationFDD >-----#
    synchronisedRadioLinkReconfigurationPreparationFDD = CLASS(name=u'synchronisedRadioLinkReconfigurationPreparationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationPreparationFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareFDD')))
    _synchronisedRadioLinkReconfigurationPreparationFDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyFDD')))
    _synchronisedRadioLinkReconfigurationPreparationFDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    synchronisedRadioLinkReconfigurationPreparationFDD._val = dict([(u'InitiatingMessage', _synchronisedRadioLinkReconfigurationPreparationFDD_val_InitiatingMessage), (u'SuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationFDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationFDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'fdd')])), (u'criticality', u'reject')])
    
    #-----< synchronisedRadioLinkReconfigurationPreparationTDD >-----#
    synchronisedRadioLinkReconfigurationPreparationTDD = CLASS(name=u'synchronisedRadioLinkReconfigurationPreparationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationPreparationTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationPrepareTDD')))
    _synchronisedRadioLinkReconfigurationPreparationTDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationReadyTDD')))
    _synchronisedRadioLinkReconfigurationPreparationTDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    synchronisedRadioLinkReconfigurationPreparationTDD._val = dict([(u'InitiatingMessage', _synchronisedRadioLinkReconfigurationPreparationTDD_val_InitiatingMessage), (u'SuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationTDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _synchronisedRadioLinkReconfigurationPreparationTDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 23), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< unSynchronisedRadioLinkReconfigurationFDD >-----#
    unSynchronisedRadioLinkReconfigurationFDD = CLASS(name=u'unSynchronisedRadioLinkReconfigurationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _unSynchronisedRadioLinkReconfigurationFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestFDD')))
    _unSynchronisedRadioLinkReconfigurationFDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseFDD')))
    _unSynchronisedRadioLinkReconfigurationFDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    unSynchronisedRadioLinkReconfigurationFDD._val = dict([(u'InitiatingMessage', _unSynchronisedRadioLinkReconfigurationFDD_val_InitiatingMessage), (u'SuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationFDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationFDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'fdd')])), (u'criticality', u'reject')])
    
    #-----< unSynchronisedRadioLinkReconfigurationTDD >-----#
    unSynchronisedRadioLinkReconfigurationTDD = CLASS(name=u'unSynchronisedRadioLinkReconfigurationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _unSynchronisedRadioLinkReconfigurationTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationRequestTDD')))
    _unSynchronisedRadioLinkReconfigurationTDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationResponseTDD')))
    _unSynchronisedRadioLinkReconfigurationTDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationFailure')))
    unSynchronisedRadioLinkReconfigurationTDD._val = dict([(u'InitiatingMessage', _unSynchronisedRadioLinkReconfigurationTDD_val_InitiatingMessage), (u'SuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationTDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _unSynchronisedRadioLinkReconfigurationTDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 24), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< physicalChannelReconfigurationFDD >-----#
    physicalChannelReconfigurationFDD = CLASS(name=u'physicalChannelReconfigurationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _physicalChannelReconfigurationFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestFDD')))
    _physicalChannelReconfigurationFDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    _physicalChannelReconfigurationFDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    physicalChannelReconfigurationFDD._val = dict([(u'InitiatingMessage', _physicalChannelReconfigurationFDD_val_InitiatingMessage), (u'SuccessfulOutcome', _physicalChannelReconfigurationFDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _physicalChannelReconfigurationFDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'fdd')])), (u'criticality', u'reject')])
    
    #-----< physicalChannelReconfigurationTDD >-----#
    physicalChannelReconfigurationTDD = CLASS(name=u'physicalChannelReconfigurationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _physicalChannelReconfigurationTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationRequestTDD')))
    _physicalChannelReconfigurationTDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationCommand')))
    _physicalChannelReconfigurationTDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PhysicalChannelReconfigurationFailure')))
    physicalChannelReconfigurationTDD._val = dict([(u'InitiatingMessage', _physicalChannelReconfigurationTDD_val_InitiatingMessage), (u'SuccessfulOutcome', _physicalChannelReconfigurationTDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _physicalChannelReconfigurationTDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 12), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< dedicatedMeasurementInitiation >-----#
    dedicatedMeasurementInitiation = CLASS(name=u'dedicatedMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationRequest')))
    _dedicatedMeasurementInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationResponse')))
    _dedicatedMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementInitiationFailure')))
    dedicatedMeasurementInitiation._val = dict([(u'InitiatingMessage', _dedicatedMeasurementInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _dedicatedMeasurementInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _dedicatedMeasurementInitiation_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 8), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< commonTransportChannelResourcesInitialisationFDD >-----#
    commonTransportChannelResourcesInitialisationFDD = CLASS(name=u'commonTransportChannelResourcesInitialisationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelResourcesInitialisationFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    _commonTransportChannelResourcesInitialisationFDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseFDD')))
    _commonTransportChannelResourcesInitialisationFDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    commonTransportChannelResourcesInitialisationFDD._val = dict([(u'InitiatingMessage', _commonTransportChannelResourcesInitialisationFDD_val_InitiatingMessage), (u'SuccessfulOutcome', _commonTransportChannelResourcesInitialisationFDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _commonTransportChannelResourcesInitialisationFDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'fdd')])), (u'criticality', u'reject')])
    
    #-----< commonTransportChannelResourcesInitialisationTDD >-----#
    commonTransportChannelResourcesInitialisationTDD = CLASS(name=u'commonTransportChannelResourcesInitialisationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelResourcesInitialisationTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesRequest')))
    _commonTransportChannelResourcesInitialisationTDD_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesResponseTDD')))
    _commonTransportChannelResourcesInitialisationTDD_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesFailure')))
    commonTransportChannelResourcesInitialisationTDD._val = dict([(u'InitiatingMessage', _commonTransportChannelResourcesInitialisationTDD_val_InitiatingMessage), (u'SuccessfulOutcome', _commonTransportChannelResourcesInitialisationTDD_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _commonTransportChannelResourcesInitialisationTDD_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 0), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< uplinkSignallingTransferFDD >-----#
    uplinkSignallingTransferFDD = CLASS(name=u'uplinkSignallingTransferFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _uplinkSignallingTransferFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationFDD')))
    uplinkSignallingTransferFDD._val = dict([(u'InitiatingMessage', _uplinkSignallingTransferFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< uplinkSignallingTransferTDD >-----#
    uplinkSignallingTransferTDD = CLASS(name=u'uplinkSignallingTransferTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _uplinkSignallingTransferTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UplinkSignallingTransferIndicationTDD')))
    uplinkSignallingTransferTDD._val = dict([(u'InitiatingMessage', _uplinkSignallingTransferTDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 25), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< downlinkSignallingTransfer >-----#
    downlinkSignallingTransfer = CLASS(name=u'downlinkSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _downlinkSignallingTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DownlinkSignallingTransferRequest')))
    downlinkSignallingTransfer._val = dict([(u'InitiatingMessage', _downlinkSignallingTransfer_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 5), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< relocationCommit >-----#
    relocationCommit = CLASS(name=u'relocationCommit', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _relocationCommit_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RelocationCommit')))
    relocationCommit._val = dict([(u'InitiatingMessage', _relocationCommit_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 20), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name=u'paging', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PagingRequest')))
    paging._val = dict([(u'InitiatingMessage', _paging_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 11), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< synchronisedRadioLinkReconfigurationCommit >-----#
    synchronisedRadioLinkReconfigurationCommit = CLASS(name=u'synchronisedRadioLinkReconfigurationCommit', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationCommit_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCommit')))
    synchronisedRadioLinkReconfigurationCommit._val = dict([(u'InitiatingMessage', _synchronisedRadioLinkReconfigurationCommit_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 22), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< synchronisedRadioLinkReconfigurationCancellation >-----#
    synchronisedRadioLinkReconfigurationCancellation = CLASS(name=u'synchronisedRadioLinkReconfigurationCancellation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _synchronisedRadioLinkReconfigurationCancellation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkReconfigurationCancel')))
    synchronisedRadioLinkReconfigurationCancellation._val = dict([(u'InitiatingMessage', _synchronisedRadioLinkReconfigurationCancellation_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 21), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkFailure >-----#
    radioLinkFailure = CLASS(name=u'radioLinkFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkFailure_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkFailureIndication')))
    radioLinkFailure._val = dict([(u'InitiatingMessage', _radioLinkFailure_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 16), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkPreemption >-----#
    radioLinkPreemption = CLASS(name=u'radioLinkPreemption', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkPreemption_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkPreemptionRequiredIndication')))
    radioLinkPreemption._val = dict([(u'InitiatingMessage', _radioLinkPreemption_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 17), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkRestoration >-----#
    radioLinkRestoration = CLASS(name=u'radioLinkRestoration', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkRestoration_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkRestoreIndication')))
    radioLinkRestoration._val = dict([(u'InitiatingMessage', _radioLinkRestoration_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 18), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< dedicatedMeasurementReporting >-----#
    dedicatedMeasurementReporting = CLASS(name=u'dedicatedMeasurementReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementReport')))
    dedicatedMeasurementReporting._val = dict([(u'InitiatingMessage', _dedicatedMeasurementReporting_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 9), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< dedicatedMeasurementTermination >-----#
    dedicatedMeasurementTermination = CLASS(name=u'dedicatedMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementTermination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementTerminationRequest')))
    dedicatedMeasurementTermination._val = dict([(u'InitiatingMessage', _dedicatedMeasurementTermination_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 10), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< dedicatedMeasurementFailure >-----#
    dedicatedMeasurementFailure = CLASS(name=u'dedicatedMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _dedicatedMeasurementFailure_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DedicatedMeasurementFailureIndication')))
    dedicatedMeasurementFailure._val = dict([(u'InitiatingMessage', _dedicatedMeasurementFailure_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 7), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkCongestion >-----#
    radioLinkCongestion = CLASS(name=u'radioLinkCongestion', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkCongestion_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkCongestionIndication')))
    radioLinkCongestion._val = dict([(u'InitiatingMessage', _radioLinkCongestion_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 34), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< downlinkPowerControlFDD >-----#
    downlinkPowerControlFDD = CLASS(name=u'downlinkPowerControlFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _downlinkPowerControlFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerControlRequest')))
    downlinkPowerControlFDD._val = dict([(u'InitiatingMessage', _downlinkPowerControlFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 3), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< downlinkPowerTimeslotControl >-----#
    downlinkPowerTimeslotControl = CLASS(name=u'downlinkPowerTimeslotControl', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _downlinkPowerTimeslotControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DL-PowerTimeslotControlRequest')))
    downlinkPowerTimeslotControl._val = dict([(u'InitiatingMessage', _downlinkPowerTimeslotControl_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 4), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< compressedModeCommandFDD >-----#
    compressedModeCommandFDD = CLASS(name=u'compressedModeCommandFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _compressedModeCommandFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CompressedModeCommand')))
    compressedModeCommandFDD._val = dict([(u'InitiatingMessage', _compressedModeCommandFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 2), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< commonTransportChannelResourcesRelease >-----#
    commonTransportChannelResourcesRelease = CLASS(name=u'commonTransportChannelResourcesRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonTransportChannelResourcesRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonTransportChannelResourcesReleaseRequest')))
    commonTransportChannelResourcesRelease._val = dict([(u'InitiatingMessage', _commonTransportChannelResourcesRelease_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 1), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name=u'errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([(u'InitiatingMessage', _errorIndication_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 6), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< commonMeasurementInitiation >-----#
    commonMeasurementInitiation = CLASS(name=u'commonMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationRequest')))
    _commonMeasurementInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationResponse')))
    _commonMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementInitiationFailure')))
    commonMeasurementInitiation._val = dict([(u'InitiatingMessage', _commonMeasurementInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _commonMeasurementInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _commonMeasurementInitiation_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 27), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< commonMeasurementReporting >-----#
    commonMeasurementReporting = CLASS(name=u'commonMeasurementReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementReport')))
    commonMeasurementReporting._val = dict([(u'InitiatingMessage', _commonMeasurementReporting_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 28), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< commonMeasurementTermination >-----#
    commonMeasurementTermination = CLASS(name=u'commonMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementTermination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementTerminationRequest')))
    commonMeasurementTermination._val = dict([(u'InitiatingMessage', _commonMeasurementTermination_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 29), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< commonMeasurementFailure >-----#
    commonMeasurementFailure = CLASS(name=u'commonMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _commonMeasurementFailure_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'CommonMeasurementFailureIndication')))
    commonMeasurementFailure._val = dict([(u'InitiatingMessage', _commonMeasurementFailure_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 26), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< informationExchangeInitiation >-----#
    informationExchangeInitiation = CLASS(name=u'informationExchangeInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _informationExchangeInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _informationExchangeInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    informationExchangeInitiation._val = dict([(u'InitiatingMessage', _informationExchangeInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _informationExchangeInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _informationExchangeInitiation_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 31), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< informationReporting >-----#
    informationReporting = CLASS(name=u'informationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _informationReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationReport')))
    informationReporting._val = dict([(u'InitiatingMessage', _informationReporting_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 32), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< informationExchangeTermination >-----#
    informationExchangeTermination = CLASS(name=u'informationExchangeTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeTermination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    informationExchangeTermination._val = dict([(u'InitiatingMessage', _informationExchangeTermination_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 33), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< informationExchangeFailure >-----#
    informationExchangeFailure = CLASS(name=u'informationExchangeFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeFailure_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    informationExchangeFailure._val = dict([(u'InitiatingMessage', _informationExchangeFailure_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 30), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name=u'privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([(u'InitiatingMessage', _privateMessage_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 13), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< reset >-----#
    reset = CLASS(name=u'reset', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetRequest')))
    _reset_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'ResetResponse')))
    reset._val = dict([(u'InitiatingMessage', _reset_val_InitiatingMessage), (u'SuccessfulOutcome', _reset_val_SuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 35), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< radioLinkActivationFDD >-----#
    radioLinkActivationFDD = CLASS(name=u'radioLinkActivationFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkActivationFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandFDD')))
    radioLinkActivationFDD._val = dict([(u'InitiatingMessage', _radioLinkActivationFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkActivationTDD >-----#
    radioLinkActivationTDD = CLASS(name=u'radioLinkActivationTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkActivationTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkActivationCommandTDD')))
    radioLinkActivationTDD._val = dict([(u'InitiatingMessage', _radioLinkActivationTDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 36), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< gERANuplinkSignallingTransfer >-----#
    gERANuplinkSignallingTransfer = CLASS(name=u'gERANuplinkSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _gERANuplinkSignallingTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'GERANUplinkSignallingTransferIndication')))
    gERANuplinkSignallingTransfer._val = dict([(u'InitiatingMessage', _gERANuplinkSignallingTransfer_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 37), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkParameterUpdateFDD >-----#
    radioLinkParameterUpdateFDD = CLASS(name=u'radioLinkParameterUpdateFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkParameterUpdateFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationFDD')))
    radioLinkParameterUpdateFDD._val = dict([(u'InitiatingMessage', _radioLinkParameterUpdateFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< radioLinkParameterUpdateTDD >-----#
    radioLinkParameterUpdateTDD = CLASS(name=u'radioLinkParameterUpdateTDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _radioLinkParameterUpdateTDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'RadioLinkParameterUpdateIndicationTDD')))
    radioLinkParameterUpdateTDD._val = dict([(u'InitiatingMessage', _radioLinkParameterUpdateTDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 38), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< uEMeasurementInitiation >-----#
    uEMeasurementInitiation = CLASS(name=u'uEMeasurementInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _uEMeasurementInitiation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationRequest')))
    _uEMeasurementInitiation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationResponse')))
    _uEMeasurementInitiation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementInitiationFailure')))
    uEMeasurementInitiation._val = dict([(u'InitiatingMessage', _uEMeasurementInitiation_val_InitiatingMessage), (u'SuccessfulOutcome', _uEMeasurementInitiation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _uEMeasurementInitiation_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 40), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< uEMeasurementReporting >-----#
    uEMeasurementReporting = CLASS(name=u'uEMeasurementReporting', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _uEMeasurementReporting_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementReport')))
    uEMeasurementReporting._val = dict([(u'InitiatingMessage', _uEMeasurementReporting_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 41), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< uEMeasurementTermination >-----#
    uEMeasurementTermination = CLASS(name=u'uEMeasurementTermination', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _uEMeasurementTermination_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementTerminationRequest')))
    uEMeasurementTermination._val = dict([(u'InitiatingMessage', _uEMeasurementTermination_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 42), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< uEMeasurementFailure >-----#
    uEMeasurementFailure = CLASS(name=u'uEMeasurementFailure', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _uEMeasurementFailure_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'UEMeasurementFailureIndication')))
    uEMeasurementFailure._val = dict([(u'InitiatingMessage', _uEMeasurementFailure_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 39), (u'ddMode', u'tdd')])), (u'criticality', u'ignore')])
    
    #-----< iurInvokeTrace >-----#
    iurInvokeTrace = CLASS(name=u'iurInvokeTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _iurInvokeTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurInvokeTrace')))
    iurInvokeTrace._val = dict([(u'InitiatingMessage', _iurInvokeTrace_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 44), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< iurDeactivateTrace >-----#
    iurDeactivateTrace = CLASS(name=u'iurDeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _iurDeactivateTrace_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'IurDeactivateTrace')))
    iurDeactivateTrace._val = dict([(u'InitiatingMessage', _iurDeactivateTrace_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 43), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< mBMSAttach >-----#
    mBMSAttach = CLASS(name=u'mBMSAttach', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _mBMSAttach_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSAttachCommand')))
    mBMSAttach._val = dict([(u'InitiatingMessage', _mBMSAttach_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 45), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< mBMSDetach >-----#
    mBMSDetach = CLASS(name=u'mBMSDetach', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _mBMSDetach_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBMSDetachCommand')))
    mBMSDetach._val = dict([(u'InitiatingMessage', _mBMSDetach_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 46), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< directInformationTransfer >-----#
    directInformationTransfer = CLASS(name=u'directInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _directInformationTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'DirectInformationTransfer')))
    directInformationTransfer._val = dict([(u'InitiatingMessage', _directInformationTransfer_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 48), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< enhancedRelocation >-----#
    enhancedRelocation = CLASS(name=u'enhancedRelocation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRequest')))
    _enhancedRelocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResponse')))
    _enhancedRelocation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationFailure')))
    enhancedRelocation._val = dict([(u'InitiatingMessage', _enhancedRelocation_val_InitiatingMessage), (u'SuccessfulOutcome', _enhancedRelocation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _enhancedRelocation_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 49), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< enhancedRelocationCancel >-----#
    enhancedRelocationCancel = CLASS(name=u'enhancedRelocationCancel', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationCancel_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationCancel')))
    enhancedRelocationCancel._val = dict([(u'InitiatingMessage', _enhancedRelocationCancel_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 50), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< enhancedRelocationSignallingTransfer >-----#
    enhancedRelocationSignallingTransfer = CLASS(name=u'enhancedRelocationSignallingTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationSignallingTransfer_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationSignallingTransfer')))
    enhancedRelocationSignallingTransfer._val = dict([(u'InitiatingMessage', _enhancedRelocationSignallingTransfer_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 51), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< enhancedRelocationRelease >-----#
    enhancedRelocationRelease = CLASS(name=u'enhancedRelocationRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationRelease')))
    enhancedRelocationRelease._val = dict([(u'InitiatingMessage', _enhancedRelocationRelease_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 52), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    #-----< mBSFNMCCHInformation >-----#
    mBSFNMCCHInformation = CLASS(name=u'mBSFNMCCHInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _mBSFNMCCHInformation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'MBSFNMCCHInformation')))
    mBSFNMCCHInformation._val = dict([(u'InitiatingMessage', _mBSFNMCCHInformation_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 53), (u'ddMode', u'common')])), (u'criticality', u'reject')])
    
    #-----< secondaryULFrequencyReportingFDD >-----#
    secondaryULFrequencyReportingFDD = CLASS(name=u'secondaryULFrequencyReportingFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _secondaryULFrequencyReportingFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyReport')))
    secondaryULFrequencyReportingFDD._val = dict([(u'InitiatingMessage', _secondaryULFrequencyReportingFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 54), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< secondaryULFrequencyUpdateFDD >-----#
    secondaryULFrequencyUpdateFDD = CLASS(name=u'secondaryULFrequencyUpdateFDD', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _secondaryULFrequencyUpdateFDD_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'SecondaryULFrequencyUpdateIndication')))
    secondaryULFrequencyUpdateFDD._val = dict([(u'InitiatingMessage', _secondaryULFrequencyUpdateFDD_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 55), (u'ddMode', u'fdd')])), (u'criticality', u'ignore')])
    
    #-----< enhancedRelocationResourceAllocation >-----#
    enhancedRelocationResourceAllocation = CLASS(name=u'enhancedRelocationResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationResourceAllocation_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceRequest')))
    _enhancedRelocationResourceAllocation_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceResponse')))
    _enhancedRelocationResourceAllocation_val_UnsuccessfulOutcome = SEQ(name=u'UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceFailure')))
    enhancedRelocationResourceAllocation._val = dict([(u'InitiatingMessage', _enhancedRelocationResourceAllocation_val_InitiatingMessage), (u'SuccessfulOutcome', _enhancedRelocationResourceAllocation_val_SuccessfulOutcome), (u'UnsuccessfulOutcome', _enhancedRelocationResourceAllocation_val_UnsuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 60), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< enhancedRelocationResourceRelease >-----#
    enhancedRelocationResourceRelease = CLASS(name=u'enhancedRelocationResourceRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationResourceRelease_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseCommand')))
    _enhancedRelocationResourceRelease_val_SuccessfulOutcome = SEQ(name=u'SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'EnhancedRelocationResourceReleaseComplete')))
    enhancedRelocationResourceRelease._val = dict([(u'InitiatingMessage', _enhancedRelocationResourceRelease_val_InitiatingMessage), (u'SuccessfulOutcome', _enhancedRelocationResourceRelease_val_SuccessfulOutcome), (u'procedureID', dict([(u'procedureCode', 61), (u'ddMode', u'tdd')])), (u'criticality', u'reject')])
    
    #-----< informationTransferControl >-----#
    informationTransferControl = CLASS(name=u'informationTransferControl', mode=MODE_VALUE, typeref=ASN1RefType(('RNSAP-PDU-Descriptions', 'RNSAP-ELEMENTARY-PROCEDURE')))
    _informationTransferControl_val_InitiatingMessage = SEQ(name=u'InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RNSAP-PDU-Contents', 'InformationTransferControlRequest')))
    informationTransferControl._val = dict([(u'InitiatingMessage', _informationTransferControl_val_InitiatingMessage), (u'procedureID', dict([(u'procedureCode', 56), (u'ddMode', u'common')])), (u'criticality', u'ignore')])
    
    _all_ = [
        _RNSAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _RNSAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _RNSAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _RNSAP_ELEMENTARY_PROCEDURE_Outcome,
        _RNSAP_ELEMENTARY_PROCEDURE_procedureID,
        _RNSAP_ELEMENTARY_PROCEDURE_criticality,
        RNSAP_ELEMENTARY_PROCEDURE,
        _RNSAP_PDU_initiatingMessage,
        _RNSAP_PDU_successfulOutcome,
        _RNSAP_PDU_unsuccessfulOutcome,
        _RNSAP_PDU_outcome,
        RNSAP_PDU,
        __InitiatingMessage_procedureID_tab,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_9,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_9,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_10,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_11,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_12,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_13,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_33,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_33,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_34,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_34,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_35,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_36,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_36,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_37,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_37,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_38,
        ___InitiatingMessage_procedureID_tab_val_UnsuccessfulOutcome_38,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureID_tab_val_SuccessfulOutcome_39,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_48,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_49,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_50,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_51,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_52,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_53,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_54,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_55,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_56,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_57,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_58,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_59,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_60,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_61,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_62,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_63,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_64,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_65,
        ___InitiatingMessage_procedureID_tab_val_InitiatingMessage_66,
        _InitiatingMessage_procedureID,
        _InitiatingMessage_criticality,
        _InitiatingMessage_transactionID,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureID_tab,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_9,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_33,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_33,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_34,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_34,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_35,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_36,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_36,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_37,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_37,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_38,
        ___SuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_38,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_39,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65,
        ___SuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66,
        _SuccessfulOutcome_procedureID,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_transactionID,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureID_tab,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_9,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_33,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_33,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_34,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_34,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_35,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_36,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_36,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_37,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_37,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_38,
        ___UnsuccessfulOutcome_procedureID_tab_val_UnsuccessfulOutcome_38,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureID_tab_val_SuccessfulOutcome_39,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_48,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_49,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_50,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_51,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_52,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_53,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_54,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_55,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_56,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_57,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_58,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_59,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_60,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_61,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_62,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_63,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_64,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_65,
        ___UnsuccessfulOutcome_procedureID_tab_val_InitiatingMessage_66,
        _UnsuccessfulOutcome_procedureID,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_transactionID,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        __Outcome_procedureID_tab,
        ___Outcome_procedureID_tab_val_InitiatingMessage_0,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_0,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_0,
        ___Outcome_procedureID_tab_val_InitiatingMessage_1,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_1,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_1,
        ___Outcome_procedureID_tab_val_InitiatingMessage_2,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_2,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_2,
        ___Outcome_procedureID_tab_val_InitiatingMessage_3,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_3,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_3,
        ___Outcome_procedureID_tab_val_InitiatingMessage_4,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_4,
        ___Outcome_procedureID_tab_val_InitiatingMessage_5,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_5,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_5,
        ___Outcome_procedureID_tab_val_InitiatingMessage_6,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_6,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_6,
        ___Outcome_procedureID_tab_val_InitiatingMessage_7,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_7,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_7,
        ___Outcome_procedureID_tab_val_InitiatingMessage_8,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_8,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_8,
        ___Outcome_procedureID_tab_val_InitiatingMessage_9,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_9,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_9,
        ___Outcome_procedureID_tab_val_InitiatingMessage_10,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_10,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_10,
        ___Outcome_procedureID_tab_val_InitiatingMessage_11,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_11,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_11,
        ___Outcome_procedureID_tab_val_InitiatingMessage_12,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_12,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_12,
        ___Outcome_procedureID_tab_val_InitiatingMessage_13,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_13,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_13,
        ___Outcome_procedureID_tab_val_InitiatingMessage_14,
        ___Outcome_procedureID_tab_val_InitiatingMessage_15,
        ___Outcome_procedureID_tab_val_InitiatingMessage_16,
        ___Outcome_procedureID_tab_val_InitiatingMessage_17,
        ___Outcome_procedureID_tab_val_InitiatingMessage_18,
        ___Outcome_procedureID_tab_val_InitiatingMessage_19,
        ___Outcome_procedureID_tab_val_InitiatingMessage_20,
        ___Outcome_procedureID_tab_val_InitiatingMessage_21,
        ___Outcome_procedureID_tab_val_InitiatingMessage_22,
        ___Outcome_procedureID_tab_val_InitiatingMessage_23,
        ___Outcome_procedureID_tab_val_InitiatingMessage_24,
        ___Outcome_procedureID_tab_val_InitiatingMessage_25,
        ___Outcome_procedureID_tab_val_InitiatingMessage_26,
        ___Outcome_procedureID_tab_val_InitiatingMessage_27,
        ___Outcome_procedureID_tab_val_InitiatingMessage_28,
        ___Outcome_procedureID_tab_val_InitiatingMessage_29,
        ___Outcome_procedureID_tab_val_InitiatingMessage_30,
        ___Outcome_procedureID_tab_val_InitiatingMessage_31,
        ___Outcome_procedureID_tab_val_InitiatingMessage_32,
        ___Outcome_procedureID_tab_val_InitiatingMessage_33,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_33,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_33,
        ___Outcome_procedureID_tab_val_InitiatingMessage_34,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_34,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_34,
        ___Outcome_procedureID_tab_val_InitiatingMessage_35,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_35,
        ___Outcome_procedureID_tab_val_InitiatingMessage_36,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_36,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_36,
        ___Outcome_procedureID_tab_val_InitiatingMessage_37,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_37,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_37,
        ___Outcome_procedureID_tab_val_InitiatingMessage_38,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_38,
        ___Outcome_procedureID_tab_val_UnsuccessfulOutcome_38,
        ___Outcome_procedureID_tab_val_InitiatingMessage_39,
        ___Outcome_procedureID_tab_val_SuccessfulOutcome_39,
        ___Outcome_procedureID_tab_val_InitiatingMessage_40,
        ___Outcome_procedureID_tab_val_InitiatingMessage_41,
        ___Outcome_procedureID_tab_val_InitiatingMessage_42,
        ___Outcome_procedureID_tab_val_InitiatingMessage_43,
        ___Outcome_procedureID_tab_val_InitiatingMessage_44,
        ___Outcome_procedureID_tab_val_InitiatingMessage_45,
        ___Outcome_procedureID_tab_val_InitiatingMessage_46,
        ___Outcome_procedureID_tab_val_InitiatingMessage_47,
        ___Outcome_procedureID_tab_val_InitiatingMessage_48,
        ___Outcome_procedureID_tab_val_InitiatingMessage_49,
        ___Outcome_procedureID_tab_val_InitiatingMessage_50,
        ___Outcome_procedureID_tab_val_InitiatingMessage_51,
        ___Outcome_procedureID_tab_val_InitiatingMessage_52,
        ___Outcome_procedureID_tab_val_InitiatingMessage_53,
        ___Outcome_procedureID_tab_val_InitiatingMessage_54,
        ___Outcome_procedureID_tab_val_InitiatingMessage_55,
        ___Outcome_procedureID_tab_val_InitiatingMessage_56,
        ___Outcome_procedureID_tab_val_InitiatingMessage_57,
        ___Outcome_procedureID_tab_val_InitiatingMessage_58,
        ___Outcome_procedureID_tab_val_InitiatingMessage_59,
        ___Outcome_procedureID_tab_val_InitiatingMessage_60,
        ___Outcome_procedureID_tab_val_InitiatingMessage_61,
        ___Outcome_procedureID_tab_val_InitiatingMessage_62,
        ___Outcome_procedureID_tab_val_InitiatingMessage_63,
        ___Outcome_procedureID_tab_val_InitiatingMessage_64,
        ___Outcome_procedureID_tab_val_InitiatingMessage_65,
        ___Outcome_procedureID_tab_val_InitiatingMessage_66,
        _Outcome_procedureID,
        _Outcome_criticality,
        _Outcome_transactionID,
        _Outcome_value,
        Outcome,
        RNSAP_ELEMENTARY_PROCEDURES,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_3,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_6,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_9,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_9,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_10,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_10,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_11,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_11,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_12,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_12,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_13,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_13,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_33,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_34,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_34,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_36,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38,
        _RNSAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _RNSAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_49,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_50,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_51,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_52,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_53,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_54,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_55,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_56,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_57,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_58,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_59,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_60,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_61,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_62,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_63,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_64,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_65,
        _RNSAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_66,
        RNSAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_6,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_7,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_8,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_14,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_15,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_15,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_17,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        RNSAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_24,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_25,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_26,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_27,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_28,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_29,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_30,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_31,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_32,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_33,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_34,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_35,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_36,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_37,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_38,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_39,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_40,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_41,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_42,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_43,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_44,
        _RNSAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_45,
        RNSAP_ELEMENTARY_PROCEDURES_CLASS_3,
        radioLinkSetupFDD,
        _radioLinkSetupFDD_val_InitiatingMessage,
        _radioLinkSetupFDD_val_SuccessfulOutcome,
        _radioLinkSetupFDD_val_UnsuccessfulOutcome,
        radioLinkSetupTDD,
        _radioLinkSetupTDD_val_InitiatingMessage,
        _radioLinkSetupTDD_val_SuccessfulOutcome,
        _radioLinkSetupTDD_val_UnsuccessfulOutcome,
        radioLinkAdditionFDD,
        _radioLinkAdditionFDD_val_InitiatingMessage,
        _radioLinkAdditionFDD_val_SuccessfulOutcome,
        _radioLinkAdditionFDD_val_UnsuccessfulOutcome,
        radioLinkAdditionTDD,
        _radioLinkAdditionTDD_val_InitiatingMessage,
        _radioLinkAdditionTDD_val_SuccessfulOutcome,
        _radioLinkAdditionTDD_val_UnsuccessfulOutcome,
        radioLinkDeletion,
        _radioLinkDeletion_val_InitiatingMessage,
        _radioLinkDeletion_val_SuccessfulOutcome,
        synchronisedRadioLinkReconfigurationPreparationFDD,
        _synchronisedRadioLinkReconfigurationPreparationFDD_val_InitiatingMessage,
        _synchronisedRadioLinkReconfigurationPreparationFDD_val_SuccessfulOutcome,
        _synchronisedRadioLinkReconfigurationPreparationFDD_val_UnsuccessfulOutcome,
        synchronisedRadioLinkReconfigurationPreparationTDD,
        _synchronisedRadioLinkReconfigurationPreparationTDD_val_InitiatingMessage,
        _synchronisedRadioLinkReconfigurationPreparationTDD_val_SuccessfulOutcome,
        _synchronisedRadioLinkReconfigurationPreparationTDD_val_UnsuccessfulOutcome,
        unSynchronisedRadioLinkReconfigurationFDD,
        _unSynchronisedRadioLinkReconfigurationFDD_val_InitiatingMessage,
        _unSynchronisedRadioLinkReconfigurationFDD_val_SuccessfulOutcome,
        _unSynchronisedRadioLinkReconfigurationFDD_val_UnsuccessfulOutcome,
        unSynchronisedRadioLinkReconfigurationTDD,
        _unSynchronisedRadioLinkReconfigurationTDD_val_InitiatingMessage,
        _unSynchronisedRadioLinkReconfigurationTDD_val_SuccessfulOutcome,
        _unSynchronisedRadioLinkReconfigurationTDD_val_UnsuccessfulOutcome,
        physicalChannelReconfigurationFDD,
        _physicalChannelReconfigurationFDD_val_InitiatingMessage,
        _physicalChannelReconfigurationFDD_val_SuccessfulOutcome,
        _physicalChannelReconfigurationFDD_val_UnsuccessfulOutcome,
        physicalChannelReconfigurationTDD,
        _physicalChannelReconfigurationTDD_val_InitiatingMessage,
        _physicalChannelReconfigurationTDD_val_SuccessfulOutcome,
        _physicalChannelReconfigurationTDD_val_UnsuccessfulOutcome,
        dedicatedMeasurementInitiation,
        _dedicatedMeasurementInitiation_val_InitiatingMessage,
        _dedicatedMeasurementInitiation_val_SuccessfulOutcome,
        _dedicatedMeasurementInitiation_val_UnsuccessfulOutcome,
        commonTransportChannelResourcesInitialisationFDD,
        _commonTransportChannelResourcesInitialisationFDD_val_InitiatingMessage,
        _commonTransportChannelResourcesInitialisationFDD_val_SuccessfulOutcome,
        _commonTransportChannelResourcesInitialisationFDD_val_UnsuccessfulOutcome,
        commonTransportChannelResourcesInitialisationTDD,
        _commonTransportChannelResourcesInitialisationTDD_val_InitiatingMessage,
        _commonTransportChannelResourcesInitialisationTDD_val_SuccessfulOutcome,
        _commonTransportChannelResourcesInitialisationTDD_val_UnsuccessfulOutcome,
        uplinkSignallingTransferFDD,
        _uplinkSignallingTransferFDD_val_InitiatingMessage,
        uplinkSignallingTransferTDD,
        _uplinkSignallingTransferTDD_val_InitiatingMessage,
        downlinkSignallingTransfer,
        _downlinkSignallingTransfer_val_InitiatingMessage,
        relocationCommit,
        _relocationCommit_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        synchronisedRadioLinkReconfigurationCommit,
        _synchronisedRadioLinkReconfigurationCommit_val_InitiatingMessage,
        synchronisedRadioLinkReconfigurationCancellation,
        _synchronisedRadioLinkReconfigurationCancellation_val_InitiatingMessage,
        radioLinkFailure,
        _radioLinkFailure_val_InitiatingMessage,
        radioLinkPreemption,
        _radioLinkPreemption_val_InitiatingMessage,
        radioLinkRestoration,
        _radioLinkRestoration_val_InitiatingMessage,
        dedicatedMeasurementReporting,
        _dedicatedMeasurementReporting_val_InitiatingMessage,
        dedicatedMeasurementTermination,
        _dedicatedMeasurementTermination_val_InitiatingMessage,
        dedicatedMeasurementFailure,
        _dedicatedMeasurementFailure_val_InitiatingMessage,
        radioLinkCongestion,
        _radioLinkCongestion_val_InitiatingMessage,
        downlinkPowerControlFDD,
        _downlinkPowerControlFDD_val_InitiatingMessage,
        downlinkPowerTimeslotControl,
        _downlinkPowerTimeslotControl_val_InitiatingMessage,
        compressedModeCommandFDD,
        _compressedModeCommandFDD_val_InitiatingMessage,
        commonTransportChannelResourcesRelease,
        _commonTransportChannelResourcesRelease_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        commonMeasurementInitiation,
        _commonMeasurementInitiation_val_InitiatingMessage,
        _commonMeasurementInitiation_val_SuccessfulOutcome,
        _commonMeasurementInitiation_val_UnsuccessfulOutcome,
        commonMeasurementReporting,
        _commonMeasurementReporting_val_InitiatingMessage,
        commonMeasurementTermination,
        _commonMeasurementTermination_val_InitiatingMessage,
        commonMeasurementFailure,
        _commonMeasurementFailure_val_InitiatingMessage,
        informationExchangeInitiation,
        _informationExchangeInitiation_val_InitiatingMessage,
        _informationExchangeInitiation_val_SuccessfulOutcome,
        _informationExchangeInitiation_val_UnsuccessfulOutcome,
        informationReporting,
        _informationReporting_val_InitiatingMessage,
        informationExchangeTermination,
        _informationExchangeTermination_val_InitiatingMessage,
        informationExchangeFailure,
        _informationExchangeFailure_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        radioLinkActivationFDD,
        _radioLinkActivationFDD_val_InitiatingMessage,
        radioLinkActivationTDD,
        _radioLinkActivationTDD_val_InitiatingMessage,
        gERANuplinkSignallingTransfer,
        _gERANuplinkSignallingTransfer_val_InitiatingMessage,
        radioLinkParameterUpdateFDD,
        _radioLinkParameterUpdateFDD_val_InitiatingMessage,
        radioLinkParameterUpdateTDD,
        _radioLinkParameterUpdateTDD_val_InitiatingMessage,
        uEMeasurementInitiation,
        _uEMeasurementInitiation_val_InitiatingMessage,
        _uEMeasurementInitiation_val_SuccessfulOutcome,
        _uEMeasurementInitiation_val_UnsuccessfulOutcome,
        uEMeasurementReporting,
        _uEMeasurementReporting_val_InitiatingMessage,
        uEMeasurementTermination,
        _uEMeasurementTermination_val_InitiatingMessage,
        uEMeasurementFailure,
        _uEMeasurementFailure_val_InitiatingMessage,
        iurInvokeTrace,
        _iurInvokeTrace_val_InitiatingMessage,
        iurDeactivateTrace,
        _iurDeactivateTrace_val_InitiatingMessage,
        mBMSAttach,
        _mBMSAttach_val_InitiatingMessage,
        mBMSDetach,
        _mBMSDetach_val_InitiatingMessage,
        directInformationTransfer,
        _directInformationTransfer_val_InitiatingMessage,
        enhancedRelocation,
        _enhancedRelocation_val_InitiatingMessage,
        _enhancedRelocation_val_SuccessfulOutcome,
        _enhancedRelocation_val_UnsuccessfulOutcome,
        enhancedRelocationCancel,
        _enhancedRelocationCancel_val_InitiatingMessage,
        enhancedRelocationSignallingTransfer,
        _enhancedRelocationSignallingTransfer_val_InitiatingMessage,
        enhancedRelocationRelease,
        _enhancedRelocationRelease_val_InitiatingMessage,
        mBSFNMCCHInformation,
        _mBSFNMCCHInformation_val_InitiatingMessage,
        secondaryULFrequencyReportingFDD,
        _secondaryULFrequencyReportingFDD_val_InitiatingMessage,
        secondaryULFrequencyUpdateFDD,
        _secondaryULFrequencyUpdateFDD_val_InitiatingMessage,
        enhancedRelocationResourceAllocation,
        _enhancedRelocationResourceAllocation_val_InitiatingMessage,
        _enhancedRelocationResourceAllocation_val_SuccessfulOutcome,
        _enhancedRelocationResourceAllocation_val_UnsuccessfulOutcome,
        enhancedRelocationResourceRelease,
        _enhancedRelocationResourceRelease_val_InitiatingMessage,
        _enhancedRelocationResourceRelease_val_SuccessfulOutcome,
        informationTransferControl,
        _informationTransferControl_val_InitiatingMessage,
    ]

init_modules(RNSAP_CommonDataTypes, RNSAP_Constants, RNSAP_Containers, RNSAP_IEs, RNSAP_PDU_Contents, RNSAP_PDU_Descriptions)
